--
VUHDO_DEBUFF_TYPE_NONE = 0;
VUHDO_DEBUFF_TYPE_POISON = 1;
VUHDO_DEBUFF_TYPE_DISEASE = 2;
VUHDO_DEBUFF_TYPE_MAGIC = 3;
VUHDO_DEBUFF_TYPE_CURSE = 4;
VUHDO_DEBUFF_TYPE_CUSTOM = 6;
VUHDO_DEBUFF_TYPE_MISSING_BUFF = 7;



--
VUHDO_INIT_DEBUFF_ABILITIES = {
	["WARRIOR"] = {
	},
	["ROGUE"] = {
	},
	["HUNTER"] = {
	},
	["MAGE"] = {
		[VUHDO_DEBUFF_TYPE_CURSE] = VUHDO_SPELL_ID_REMOVE_CURSE,
	},
	["DRUID"] = {
		[VUHDO_DEBUFF_TYPE_POISON] = VUHDO_SPELL_ID_ABOLISH_POISON,
		[VUHDO_DEBUFF_TYPE_CURSE] = VUHDO_SPELL_ID_REMOVE_CURSE,
	},
	["PALADIN"] = {
		[VUHDO_DEBUFF_TYPE_POISON] = VUHDO_SPELL_ID_PURIFY,
		[VUHDO_DEBUFF_TYPE_DISEASE] = VUHDO_SPELL_ID_PURIFY,
		[VUHDO_DEBUFF_TYPE_MAGIC] = VUHDO_SPELL_ID_PALA_CLEANSE,
	},
	["PRIEST"] = {
		[VUHDO_DEBUFF_TYPE_DISEASE] = VUHDO_SPELL_ID_CURE_DISEASE,
		[VUHDO_DEBUFF_TYPE_MAGIC] = VUHDO_SPELL_ID_DISPEL_MAGIC,
	},
	["SHAMAN"] = {
		[VUHDO_DEBUFF_TYPE_POISON] = VUHDO_SPELL_ID_CURE_TOXINS,
		[VUHDO_DEBUFF_TYPE_DISEASE] = VUHDO_SPELL_ID_CURE_TOXINS,
		[VUHDO_DEBUFF_TYPE_CURSE] = VUHDO_SPELL_ID_CLEANSE_SPIRIT,
	},
	["WARLOCK"] = {
	},
	["DEATHKNIGHT"] = {
	},
};



VUHDO_INIT_IGNORE_DEBUFFS_BY_CLASS = {
	["WARRIOR"] = {
		[VUHDO_SPELL_ID_DEBUFF_ANCIENT_HYSTERIA] = true,
    [VUHDO_SPELL_ID_DEBUFF_IGNITE_MANA] = true,
    [VUHDO_SPELL_ID_DEBUFF_TAINTED_MIND] = true,
    [VUHDO_SPELL_ID_DEBUFF_VIPER_STING] = true,
    [VUHDO_SPELL_ID_DEBUFF_IMPOTENCE] = true,
    [VUHDO_SPELL_ID_DEBUFF_DECAYED_INT] = true,
    [VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
  ["ROGUE"] = {
    [VUHDO_SPELL_ID_DEBUFF_SILENCE] = true,
    [VUHDO_SPELL_ID_DEBUFF_ANCIENT_HYSTERIA] = true,
    [VUHDO_SPELL_ID_DEBUFF_IGNITE_MANA] = true,
    [VUHDO_SPELL_ID_DEBUFF_TAINTED_MIND] = true,
    [VUHDO_SPELL_ID_DEBUFF_VIPER_STING] = true,
    [VUHDO_SPELL_ID_DEBUFF_IMPOTENCE] = true,
    [VUHDO_SPELL_ID_DEBUFF_DECAYED_INT] = true,
    [VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
  ["HUNTER"] = {
    [VUHDO_SPELL_ID_DEBUFF_MAGMA_SHACKLES] = true,
    [VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
  ["MAGE"] = {
  	[VUHDO_SPELL_ID_DEBUFF_MAGMA_SHACKLES] = true,
    [VUHDO_SPELL_ID_DEBUFF_DECAYED_STR] = true,
    [VUHDO_SPELL_ID_DEBUFF_CRIPPLE] = true,
    [VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
  ["DRUID"] = {
  	[VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
  ["PALADIN"] = {
    [VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
  ["PRIEST"] = {
  	[VUHDO_SPELL_ID_DEBUFF_DECAYED_STR] = true,
    [VUHDO_SPELL_ID_DEBUFF_CRIPPLE] = true,
    [VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
  ["SHAMAN"] = {
    [VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
  ["WARLOCK"] = {
  	[VUHDO_SPELL_ID_DEBUFF_DECAYED_STR] = true,
    [VUHDO_SPELL_ID_DEBUFF_CRIPPLE] = true,
    [VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
  ["DEATHKNIGHT"] = {
    [VUHDO_SPELL_ID_DEBUFF_UNSTABLE_AFFL] = true,
  },
};



VUHDO_INIT_IGNORE_DEBUFFS_MOVEMENT = {
	[VUHDO_SPELL_ID_DEBUFF_FROSTBOLT] = true,
	[VUHDO_SPELL_ID_DEBUFF_MAGMA_SHACKLES] = true,
	[VUHDO_SPELL_ID_DEBUFF_SLOW] = true,
	[VUHDO_SPELL_ID_DEBUFF_CHILLED] = true,
	[VUHDO_SPELL_ID_DEBUFF_CONEOFCOLD] = true,
	[VUHDO_SPELL_ID_DEBUFF_CONCUSSIVESHOT] = true,
	[VUHDO_SPELL_ID_DEBUFF_THUNDERCLAP] = true,
	[VUHDO_SPELL_ID_DEBUFF_DAZED] = true,
	[VUHDO_SPELL_ID_DEBUFF_FROST_SHOCK] = true,
};



VUHDO_INIT_IGNORE_DEBUFFS_DURATION = {
	[VUHDO_SPELL_ID_DEBUFF_PSYCHIC_HORROR] = true,
  [VUHDO_SPELL_ID_DEBUFF_CHILLED] = true,
  [VUHDO_SPELL_ID_DEBUFF_CONEOFCOLD] = true,
  [VUHDO_SPELL_ID_DEBUFF_CONCUSSIVESHOT] = true,
  [VUHDO_SPELL_ID_DEBUFF_FALTER] = true,
};



VUHDO_INIT_IGNORE_DEBUFFS_NO_HARM = {
  [VUHDO_SPELL_ID_DEBUFF_HUNTERS_MARK] = true,
  [VUHDO_SPELL_ID_DEBUFF_ARCANE_BLAST] = true,
  [VUHDO_SPELL_ID_DEBUFF_MAJOR_DREAMLESS] = true,
  [VUHDO_SPELL_ID_DEBUFF_GREATER_DREAMLESS] = true,
  [VUHDO_SPELL_ID_DEBUFF_DREAMLESS_SLEEP] = true,
  [VUHDO_SPELL_ID_MISDIRECTION] = true,
  [VUHDO_SPELL_ID_DEBUFF_DELUSIONS_OF_JINDO] = true,
  [VUHDO_SPELL_ID_DEBUFF_MIND_VISION] = true,
  [VUHDO_SPELL_ID_DEBUFF_MUTATING_INJECTION] = true,
  [VUHDO_SPELL_ID_DEBUFF_BANISH] = true,
  [VUHDO_SPELL_ID_DEBUFF_PHASE_SHIFT] = true
};
