--[[
	Informant - An addon for World of Warcraft that shows pertinent information about
	an item in a tooltip when you hover over the item in the game.
	Version: 5.7.4504 (KillerKoala)
	Revision: $Id: InfData.lua 4717 2010-04-19 04:31:36Z Nechckn $
	URL: http://auctioneeraddon.com/dl/Informant/

	Informant ItemData

	License:
		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.

		You should have received a copy of the GNU General Public License
		along with this program(see GPL.txt); if not, write to the Free Software
		Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

	Note:
		This AddOn's source code is specifically designed to work with
		World of Warcraft's interpreted AddOn system.
		You have an implicit licence to use this AddOn with these facilities
		since that is its designated purpose as per:
		http://www.fsf.org/licensing/licenses/gpl-faq.html#InterpreterIncompat
		Many thanks to the folks at http://www.wowhead.com for providing this data.
--]]
-- Numeric Codes and the Skills associated with them.
Informant.SetSkills({
	[171]="Alchemy",
	[164]="Blacksmithing",
	[185]="Cooking",
	[333]="Enchanting",
	[202]="Engineering",
	[129]="FirstAid",
	[356]="Fishing",
	[182]="Herbalism",
	[773]="Inscription",
	[755]="Jewelcrafting",
	[165]="Leatherworking",
	[186]="Mining",
	[762]="Riding",
	[197]="Tailoring",
	[-11]="Druid",
	[-8]="Mage",
	[237]="Mage",
	[-2]="Paladin",
	[-5]="Priest",
	[40]="Rogue",
	[-4]="Rogue",
	[-7]="Shaman",
	[354]="Warlock",
	[-9]="Warlock",
	[-6]="DeathKnight",
})

-- A list of recipes mapped to items that they produce
Informant.SetCrafted({
	[728]=733, -- Recipe: Westfall Stew
	[2406]=2307, -- Pattern: Fine Leather Boots
	[2407]=2311, -- Pattern: White Leather Jerkin
	[2408]=2312, -- Pattern: Fine Leather Gloves
	[2409]=2317, -- Pattern: Dark Leather Tunic
	[2553]=2457, -- Recipe: Elixir of Minor Agility
	[2555]=2459, -- Recipe: Swiftness Potion
	[2598]=2572, -- Pattern: Red Linen Robe
	[2601]=2585, -- Pattern: Gray Woolen Robe
	[2697]=724, -- Recipe: Goretusk Liver Pie
	[2698]=2682, -- Recipe: Cooked Crab Claw
	[2699]=1082, -- Recipe: Redridge Goulash
	[2700]=2685, -- Recipe: Succulent Pork Ribs
	[2701]=1017, -- Recipe: Seasoned Wolf Kabob
	[2881]=2864, -- Plans: Runed Copper Breastplate
	[2882]=3481, -- Plans: Silvered Bronze Shoulders
	[2883]=3490, -- Plans: Deadly Bronze Poniard
	[2889]=2888, -- Recipe: Beer Basted Boar Ribs
	[3393]=3384, -- Recipe: Minor Magic Resistance Potion
	[3394]=3386, -- Recipe: Potion of Curing
	[3395]=3387, -- Recipe: Limited Invulnerability Potion
	[3396]=3390, -- Recipe: Elixir of Lesser Agility
	[3608]=3492, -- Plans: Mighty Iron Hammer
	[3609]=3471, -- Plans: Copper Chain Vest
	[3610]=3474, -- Plans: Gemmed Copper Gauntlets
	[3611]=3484, -- Plans: Green Iron Boots
	[3612]=3485, -- Plans: Green Iron Gauntlets
	[3678]=3662, -- Recipe: Crocolisk Steak
	[3679]=3220, -- Recipe: Blood Sausage
	[3680]=3663, -- Recipe: Murloc Fin Soup
	[3681]=3664, -- Recipe: Crocolisk Gumbo
	[3682]=3665, -- Recipe: Curiously Tasty Omelet
	[3683]=3666, -- Recipe: Gooey Spider Cake
	[3734]=3726, -- Recipe: Big Bear Steak
	[3735]=3727, -- Recipe: Hot Lion Chops
	[3736]=3728, -- Recipe: Tasty Lion Steak
	[3737]=3729, -- Recipe: Soothing Turtle Bisque
	[3830]=3825, -- Recipe: Elixir of Fortitude
	[3831]=3826, -- Recipe: Major Troll's Blood Elixir
	[3832]=3828, -- Recipe: Elixir of Detect Lesser Invisibility
	[3866]=3850, -- Plans: Jade Serpentblade
	[3867]=3852, -- Plans: Golden Iron Destroyer
	[3868]=3854, -- Plans: Frost Tiger Blade
	[3869]=3856, -- Plans: Shadow Crescent Axe
	[3870]=3840, -- Plans: Green Iron Shoulders
	[3871]=3841, -- Plans: Golden Scale Shoulders
	[3872]=3843, -- Plans: Golden Scale Leggings
	[3873]=3845, -- Plans: Golden Scale Cuirass
	[3874]=3846, -- Plans: Polished Steel Boots
	[3875]=3847, -- Plans: Golden Scale Boots
	[4292]=4241, -- Pattern: Green Woolen Bag
	[4293]=4244, -- Pattern: Hillman's Leather Vest
	[4294]=4250, -- Pattern: Hillman's Belt
	[4296]=4252, -- Pattern: Dark Leather Shoulders
	[4297]=4254, -- Pattern: Barbaric Gloves
	[4298]=4258, -- Pattern: Guardian Belt
	[4299]=4256, -- Pattern: Guardian Armor
	[4300]=4260, -- Pattern: Guardian Leather Bracers
	[4301]=4264, -- Pattern: Barbaric Belt
	[4345]=4313, -- Pattern: Red Woolen Boots
	[4346]=4311, -- Pattern: Heavy Woolen Cloak
	[4347]=4315, -- Pattern: Reinforced Woolen Shoulders
	[4348]=4331, -- Pattern: Phoenix Gloves
	[4349]=4317, -- Pattern: Phoenix Pants
	[4350]=4321, -- Pattern: Spider Silk Slippers
	[4351]=4323, -- Pattern: Shadow Hood
	[4352]=4325, -- Pattern: Boots of the Enchanter
	[4353]=4328, -- Pattern: Spider Belt
	[4354]=4335, -- Pattern: Rich Purple Silk Shirt
	[4355]=4327, -- Pattern: Icy Cloak
	[4356]=4329, -- Pattern: Star Belt
	[4408]=4401, -- Schematic: Mechanical Squirrel Box
	[4409]=4367, -- Schematic: Small Seaforium Charge
	[4410]=4373, -- Schematic: Shadow Goggles
	[4411]=4376, -- Schematic: Flame Deflector
	[4412]=4383, -- Schematic: Moonsight Rifle
	[4413]=4388, -- Schematic: Discombobulator Ray
	[4414]=4403, -- Schematic: Portable Bronze Mortar
	[4415]=4393, -- Schematic: Craftsman's Monocle
	[4416]=4395, -- Schematic: Goblin Land Mine
	[4417]=4398, -- Schematic: Large Seaforium Charge
	[4597]=4596, -- Recipe: Discolored Healing Potion
	[4609]=4457, -- Recipe: Barbecued Buzzard Wing
	[4624]=4623, -- Recipe: Lesser Stoneshield Potion
	[5083]=5081, -- Pattern: Kodo Hide Bag
	[5482]=5472, -- Recipe: Kaldorei Spider Kabob
	[5483]=5473, -- Recipe: Scorpid Surprise
	[5484]=5474, -- Recipe: Roasted Kodo Meat
	[5485]=5476, -- Recipe: Fillet of Frenzy
	[5486]=5477, -- Recipe: Strider Stew
	[5487]=5478, -- Recipe: Dig Rat Stew
	[5488]=5479, -- Recipe: Crispy Lizard Tail
	[5489]=5480, -- Recipe: Lean Venison
	[5528]=5526, -- Recipe: Clam Chowder
	[5543]=5541, -- Plans: Iridescent Hammer
	[5578]=2869, -- Plans: Silvered Bronze Breastplate
	[5640]=5631, -- Recipe: Rage Potion
	[5642]=5634, -- Recipe: Free Action Potion
	[5643]=5633, -- Recipe: Great Rage Potion
	[5771]=5762, -- Pattern: Red Linen Bag
	[5772]=5763, -- Pattern: Red Woolen Bag
	[5773]=5770, -- Pattern: Robes of Arcana
	[5774]=5764, -- Pattern: Green Silk Pack
	[5775]=5765, -- Pattern: Black Silk Pack
	[5786]=5780, -- Pattern: Murloc Scale Belt
	[5787]=5781, -- Pattern: Murloc Scale Breastplate
	[5788]=5782, -- Pattern: Thick Murloc Armor
	[5789]=5783, -- Pattern: Murloc Scale Bracers
	[5972]=5958, -- Pattern: Fine Leather Pants
	[5973]=5963, -- Pattern: Barbaric Leggings
	[5974]=5965, -- Pattern: Guardian Cloak
	[6039]=6038, -- Recipe: Giant Clam Scorcho
	[6044]=6042, -- Plans: Iron Shield Spike
	[6045]=6043, -- Plans: Iron Counterweight
	[6046]=6041, -- Plans: Steel Weapon Chain
	[6047]=3837, -- Plans: Golden Scale Coif
	[6053]=6051, -- Recipe: Holy Protection Potion
	[6054]=6048, -- Recipe: Shadow Protection Potion
	[6055]=6049, -- Recipe: Fire Protection Potion
	[6056]=6050, -- Recipe: Frost Protection Potion
	[6057]=6052, -- Recipe: Nature Protection Potion
	[6068]=3824, -- Recipe: Shadow Oil
	[6211]=3391, -- Recipe: Elixir of Ogre's Strength
	[6270]=6240, -- Pattern: Blue Linen Vest
	[6271]=6239, -- Pattern: Red Linen Vest
	[6272]=6242, -- Pattern: Blue Linen Robe
	[6274]=6263, -- Pattern: Blue Overalls
	[6275]=6264, -- Pattern: Greater Adept's Robe
	[6325]=6290, -- Recipe: Brilliant Smallfish
	[6326]=787, -- Recipe: Slitherskin Mackerel
	[6328]=4592, -- Recipe: Longjaw Mud Snapper
	[6329]=6316, -- Recipe: Loch Frenzy Delight
	[6330]=4593, -- Recipe: Bristle Whisker Catfish
	[6368]=5095, -- Recipe: Rainbow Fin Albacore
	[6369]=4594, -- Recipe: Rockscale Cod
	[6390]=6384, -- Pattern: Stylish Blue Shirt
	[6391]=6385, -- Pattern: Stylish Green Shirt
	[6401]=4333, -- Pattern: Dark Silk Shirt
	[6474]=6466, -- Pattern: Deviate Scale Cloak
	[6475]=6467, -- Pattern: Deviate Scale Gloves
	[6476]=6468, -- Pattern: Deviate Scale Belt
	[6661]=6657, -- Recipe: Savory Deviate Delight
	[6663]=6662, -- Recipe: Elixir of Giant Growth
	[6672]=4852, -- Schematic: Flash Bomb
	[6710]=6709, -- Pattern: Moonglow Vest
	[6716]=6714, -- Schematic: EZ-Thro Dynamite
	[6735]=6731, -- Plans: Ironforge Breastplate
	[6892]=6890, -- Recipe: Smoked Bear Meat
	[7084]=7059, -- Pattern: Crimson Silk Shoulders
	[7085]=7060, -- Pattern: Azure Shoulders
	[7086]=7061, -- Pattern: Earthen Silk Belt
	[7087]=7056, -- Pattern: Crimson Silk Cloak
	[7088]=7063, -- Pattern: Crimson Silk Robe
	[7089]=7053, -- Pattern: Azure Silk Cloak
	[7090]=7065, -- Pattern: Green Silk Armor
	[7091]=7049, -- Pattern: Truefaith Gloves
	[7092]=7047, -- Pattern: Hands of Darkness
	[7114]=4319, -- Pattern: Azure Silk Gloves
	[7288]=7280, -- Pattern: Rugged Leather Pants
	[7289]=7283, -- Pattern: Black Whelp Cloak
	[7290]=7284, -- Pattern: Red Whelp Gloves
	[7360]=4248, -- Pattern: Dark Leather Gloves
	[7361]=7349, -- Pattern: Herbalist's Gloves
	[7362]=7352, -- Pattern: Earthen Leather Shoulders
	[7363]=7358, -- Pattern: Pilferer's Gloves
	[7364]=7359, -- Pattern: Heavy Earthen Gloves
	[7449]=7373, -- Pattern: Dusky Leather Leggings
	[7450]=7375, -- Pattern: Green Whelp Armor
	[7451]=7386, -- Pattern: Green Whelp Bracers
	[7452]=7390, -- Pattern: Dusky Boots
	[7453]=7391, -- Pattern: Swift Boots
	[7560]=7506, -- Schematic: Gnomish Universal Remote
	[7561]=7148, -- Schematic: Goblin Jumper Cables
	[7613]=4255, -- Pattern: Green Leather Armor
	[7678]=7676, -- Recipe: Thistle Tea
	[7742]=4397, -- Schematic: Gnomish Cloaking Device
	[7975]=7921, -- Plans: Heavy Mithril Pants
	[7976]=7967, -- Plans: Mithril Shield Spike
	[7978]=7913, -- Plans: Barbaric Iron Shoulders
	[7979]=7914, -- Plans: Barbaric Iron Breastplate
	[7980]=7915, -- Plans: Barbaric Iron Helm
	[7981]=7916, -- Plans: Barbaric Iron Boots
	[7982]=7917, -- Plans: Barbaric Iron Gloves
	[7983]=7926, -- Plans: Ornate Mithril Pants
	[7984]=7927, -- Plans: Ornate Mithril Gloves
	[7985]=7928, -- Plans: Ornate Mithril Shoulder
	[7989]=7969, -- Plans: Mithril Spurs
	[7990]=7934, -- Plans: Heavy Mithril Helm
	[7991]=7932, -- Plans: Mithril Scale Shoulders
	[7992]=7942, -- Plans: Blue Glittering Axe
	[7993]=7944, -- Plans: Dazzling Mithril Rapier
	[7995]=7924, -- Plans: Mithril Scale Bracers
	[8028]=7946, -- Plans: Runed Mithril Hammer
	[8029]=7943, -- Plans: Wicked Mithril Blade
	[8030]=7947, -- Plans: Ebon Shiv
	[8384]=8174, -- Pattern: Comfortable Leather Hat
	[8385]=8187, -- Pattern: Turtle Scale Gloves
	[8386]=8200, -- Pattern: Big Voodoo Robe
	[8387]=8201, -- Pattern: Big Voodoo Mask
	[8389]=8202, -- Pattern: Big Voodoo Pants
	[8390]=8216, -- Pattern: Big Voodoo Cloak
	[8395]=8203, -- Pattern: Tough Scorpid Breastplate
	[8397]=8205, -- Pattern: Tough Scorpid Bracers
	[8398]=8204, -- Pattern: Tough Scorpid Gloves
	[8399]=8209, -- Pattern: Tough Scorpid Boots
	[8400]=8207, -- Pattern: Tough Scorpid Shoulders
	[8401]=8206, -- Pattern: Tough Scorpid Leggings
	[8402]=8208, -- Pattern: Tough Scorpid Helm
	[8403]=8210, -- Pattern: Wild Leather Shoulders
	[8404]=8211, -- Pattern: Wild Leather Vest
	[8405]=8214, -- Pattern: Wild Leather Helmet
	[8406]=8213, -- Pattern: Wild Leather Boots
	[8407]=8212, -- Pattern: Wild Leather Leggings
	[8408]=8215, -- Pattern: Wild Leather Cloak
	[8409]=8192, -- Pattern: Nightscape Shoulders
	[9293]=9036, -- Recipe: Magic Resistance Potion
	[9294]=9144, -- Recipe: Wildvine Potion
	[9295]=9172, -- Recipe: Invisibility Potion
	[9296]=9088, -- Recipe: Gift of Arthas
	[9297]=9197, -- Recipe: Elixir of Dream Vision
	[9298]=9206, -- Recipe: Elixir of Giants
	[9300]=9224, -- Recipe: Elixir of Demonslaying
	[9301]=9264, -- Recipe: Elixir of Shadow Power
	[9302]=9210, -- Recipe: Ghost Dye
	[9303]=9149, -- Recipe: Philosopher's Stone
	[9367]=9366, -- Plans: Golden Scale Gauntlets
	[10300]=10007, -- Pattern: Red Mageweave Vest
	[10301]=10008, -- Pattern: White Bandit Mask
	[10302]=10009, -- Pattern: Red Mageweave Pants
	[10311]=10052, -- Pattern: Orange Martial Shirt
	[10312]=10018, -- Pattern: Red Mageweave Gloves
	[10314]=10054, -- Pattern: Lavender Mageweave Shirt
	[10315]=10029, -- Pattern: Red Mageweave Shoulders
	[10316]=10048, -- Pattern: Colorful Kilt
	[10317]=10055, -- Pattern: Pink Mageweave Shirt
	[10318]=10030, -- Pattern: Admiral's Hat
	[10320]=10033, -- Pattern: Red Mageweave Headband
	[10321]=10034, -- Pattern: Tuxedo Shirt
	[10323]=10035, -- Pattern: Tuxedo Pants
	[10325]=10040, -- Pattern: White Wedding Dress
	[10326]=10036, -- Pattern: Tuxedo Jacket
	[10424]=10423, -- Plans: Silvered Bronze Leggings
	[10463]=10025, -- Pattern: Shadoweave Mask
	[10601]=10499, -- Schematic: Bright-Eye Goggles
	[10602]=10546, -- Schematic: Deadly Scope
	[10603]=10501, -- Schematic: Catseye Ultra Goggles
	[10604]=10510, -- Schematic: Mithril Heavy-bore Rifle
	[10605]=10502, -- Schematic: Spellpower Goggles Xtreme
	[10606]=10518, -- Schematic: Parachute Cloak
	[10607]=10506, -- Schematic: Deepdive Helmet
	[10608]=10548, -- Schematic: Sniper Scope
	[10609]=10576, -- Schematic: Mithril Mechanical Dragonling
	[10644]=9061, -- Recipe: Goblin Rocket Fuel
	[10713]=9060, -- Plans: Inlaid Mithril Cylinder
	[10728]=4336, -- Pattern: Black Swashbuckler's Shirt
	[10858]=3851, -- Plans: Solid Iron Maul
	[11610]=11608, -- Plans: Dark Iron Pulverizer
	[11611]=11607, -- Plans: Dark Iron Sunderer
	[11612]=11604, -- Plans: Dark Iron Plate
	[11614]=11606, -- Plans: Dark Iron Mail
	[11615]=11605, -- Plans: Dark Iron Shoulders
	[11827]=11826, -- Schematic: Lil' Smoky
	[11828]=11825, -- Schematic: Pet Bombling
	[12162]=3849, -- Plans: Hardened Iron Shortsword
	[12163]=3853, -- Plans: Moonsteel Broadsword
	[12164]=3855, -- Plans: Massive Iron Axe
	[12226]=12224, -- Recipe: Crispy Bat Wing
	[12227]=12209, -- Recipe: Lean Wolf Steak
	[12228]=12210, -- Recipe: Roast Raptor
	[12229]=13851, -- Recipe: Hot Wolf Ribs
	[12231]=12212, -- Recipe: Jungle Stew
	[12232]=12213, -- Recipe: Carrion Surprise
	[12233]=12214, -- Recipe: Mystery Stew
	[12239]=12217, -- Recipe: Dragonbreath Chili
	[12240]=12215, -- Recipe: Heavy Kodo Stew
	[12261]=12260, -- Plans: Searing Golden Blade
	[12682]=12405, -- Plans: Thorium Armor
	[12683]=12406, -- Plans: Thorium Belt
	[12684]=12408, -- Plans: Thorium Bracers
	[12685]=12416, -- Plans: Radiant Belt
	[12687]=12428, -- Plans: Imperial Plate Shoulders
	[12688]=12424, -- Plans: Imperial Plate Belt
	[12689]=12415, -- Plans: Radiant Breastplate
	[12690]=12425, -- Plans: Imperial Plate Bracers
	[12691]=12624, -- Plans: Wildthorn Mail
	[12692]=12645, -- Plans: Thorium Shield Spike
	[12693]=12409, -- Plans: Thorium Boots
	[12694]=12410, -- Plans: Thorium Helm
	[12695]=12418, -- Plans: Radiant Gloves
	[12696]=12628, -- Plans: Demon Forged Breastplate
	[12697]=12419, -- Plans: Radiant Boots
	[12698]=12625, -- Plans: Dawnbringer Shoulders
	[12699]=12631, -- Plans: Fiery Plate Gauntlets
	[12700]=12426, -- Plans: Imperial Plate Boots
	[12701]=12427, -- Plans: Imperial Plate Helm
	[12702]=12417, -- Plans: Radiant Circlet
	[12703]=12632, -- Plans: Storm Gauntlets
	[12704]=12414, -- Plans: Thorium Leggings
	[12705]=12422, -- Plans: Imperial Plate Chest
	[12706]=12610, -- Plans: Runic Plate Shoulders
	[12707]=12611, -- Plans: Runic Plate Boots
	[12711]=12633, -- Plans: Whitesoul Helm
	[12713]=12420, -- Plans: Radiant Leggings
	[12714]=12612, -- Plans: Runic Plate Helm
	[12715]=12429, -- Plans: Imperial Plate Leggings
	[12716]=12636, -- Plans: Helm of the Great Chief
	[12717]=12640, -- Plans: Lionheart Helm
	[12718]=12613, -- Plans: Runic Breastplate
	[12719]=12614, -- Plans: Runic Plate Leggings
	[12720]=12639, -- Plans: Stronghold Gauntlets
	[12725]=12620, -- Plans: Enchanted Thorium Helm
	[12726]=12619, -- Plans: Enchanted Thorium Leggings
	[12727]=12618, -- Plans: Enchanted Thorium Breastplate
	[12728]=12641, -- Plans: Invulnerable Mail
	[12819]=12773, -- Plans: Ornate Thorium Handaxe
	[12821]=12774, -- Plans: Dawn's Edge
	[12823]=12775, -- Plans: Huge Thorium Battleaxe
	[12824]=12776, -- Plans: Enchanted Battlehammer
	[12825]=12777, -- Plans: Blazing Rapier
	[12827]=12781, -- Plans: Serenity
	[12828]=12792, -- Plans: Volcanic Hammer
	[12830]=12782, -- Plans: Corruption
	[12833]=12796, -- Plans: Hammer of the Titans
	[12834]=12790, -- Plans: Arcanite Champion
	[12835]=12798, -- Plans: Annihilator
	[12836]=12797, -- Plans: Frostguard
	[12837]=12794, -- Plans: Masterwork Stormhammer
	[12838]=12784, -- Plans: Arcanite Reaper
	[12839]=12783, -- Plans: Heartseeker
	[13287]=4455, -- Pattern: Raptor Hide Harness
	[13288]=4456, -- Pattern: Raptor Hide Belt
	[13308]=4386, -- Schematic: Ice Deflector
	[13309]=4372, -- Schematic: Lovingly Crafted Boomstick
	[13310]=4407, -- Schematic: Accurate Scope
	[13311]=4396, -- Schematic: Mechanical Dragonling
	[13476]=13442, -- Recipe: Mighty Rage Potion
	[13477]=13443, -- Recipe: Superior Mana Potion
	[13478]=13445, -- Recipe: Elixir of Superior Defense
	[13479]=13447, -- Recipe: Elixir of the Sages
	[13480]=13446, -- Recipe: Major Healing Potion
	[13481]=13453, -- Recipe: Elixir of Brute Force
	[13490]=13455, -- Recipe: Greater Stoneshield Potion
	[13491]=13452, -- Recipe: Elixir of the Mongoose
	[13492]=13462, -- Recipe: Purification Potion
	[13493]=13454, -- Recipe: Greater Arcane Elixir
	[13494]=13457, -- Recipe: Greater Fire Protection Potion
	[13495]=13456, -- Recipe: Greater Frost Protection Potion
	[13496]=13458, -- Recipe: Greater Nature Protection Potion
	[13497]=13461, -- Recipe: Greater Arcane Protection Potion
	[13499]=13459, -- Recipe: Greater Shadow Protection Potion
	[13501]=13444, -- Recipe: Major Mana Potion
	[13517]=13503, -- Recipe: Alchemist's Stone
	[13518]=13506, -- Recipe: Potion of Petrification
	[13519]=13510, -- Recipe: Flask of the Titans
	[13520]=13511, -- Recipe: Flask of Distilled Wisdom
	[13521]=13512, -- Recipe: Flask of Supreme Power
	[13522]=13513, -- Recipe: Flask of Chromatic Resistance
	[13939]=6887, -- Recipe: Spotted Yellowtail
	[13940]=13927, -- Recipe: Cooked Glossy Mightfish
	[13941]=13930, -- Recipe: Filet of Redgill
	[13942]=13928, -- Recipe: Grilled Squid
	[13943]=13929, -- Recipe: Hot Smoked Bass
	[13945]=13931, -- Recipe: Nightfin Soup
	[13946]=13932, -- Recipe: Poached Sunscale Salmon
	[13947]=13933, -- Recipe: Lobster Stew
	[13948]=13934, -- Recipe: Mightfish Steak
	[13949]=13935, -- Recipe: Baked Salmon
	[14466]=13869, -- Pattern: Frostweave Tunic
	[14467]=13868, -- Pattern: Frostweave Robe
	[14468]=14046, -- Pattern: Runecloth Bag
	[14469]=13858, -- Pattern: Runecloth Robe
	[14470]=13857, -- Pattern: Runecloth Tunic
	[14471]=14042, -- Pattern: Cindercloth Vest
	[14472]=13860, -- Pattern: Runecloth Cloak
	[14473]=14143, -- Pattern: Ghostweave Belt
	[14474]=13870, -- Pattern: Frostweave Gloves
	[14476]=14043, -- Pattern: Cindercloth Gloves
	[14477]=14142, -- Pattern: Ghostweave Gloves
	[14478]=14100, -- Pattern: Brightcloth Robe
	[14479]=14101, -- Pattern: Brightcloth Gloves
	[14480]=14141, -- Pattern: Ghostweave Vest
	[14481]=13863, -- Pattern: Runecloth Gloves
	[14482]=14044, -- Pattern: Cindercloth Cloak
	[14483]=14107, -- Pattern: Felcloth Pants
	[14484]=14103, -- Pattern: Brightcloth Cloak
	[14485]=14132, -- Pattern: Wizardweave Leggings
	[14486]=14134, -- Pattern: Cloak of Fire
	[14488]=13864, -- Pattern: Runecloth Boots
	[14489]=13871, -- Pattern: Frostweave Pants
	[14490]=14045, -- Pattern: Cindercloth Pants
	[14491]=13865, -- Pattern: Runecloth Pants
	[14492]=14108, -- Pattern: Felcloth Boots
	[14493]=14136, -- Pattern: Robe of Winter Night
	[14494]=14104, -- Pattern: Brightcloth Pants
	[14495]=14144, -- Pattern: Ghostweave Pants
	[14496]=14111, -- Pattern: Felcloth Hood
	[14497]=14137, -- Pattern: Mooncloth Leggings
	[14498]=13866, -- Pattern: Runecloth Headband
	[14499]=14155, -- Pattern: Mooncloth Bag
	[14500]=14128, -- Pattern: Wizardweave Robe
	[14501]=14138, -- Pattern: Mooncloth Vest
	[14504]=13867, -- Pattern: Runecloth Shoulders
	[14505]=14130, -- Pattern: Wizardweave Turban
	[14506]=14106, -- Pattern: Felcloth Robe
	[14507]=14139, -- Pattern: Mooncloth Shoulders
	[14508]=14112, -- Pattern: Felcloth Shoulders
	[14509]=14140, -- Pattern: Mooncloth Circlet
	[14510]=14156, -- Pattern: Bottomless Bag
	[14511]=14146, -- Pattern: Gloves of Spell Mastery
	[14512]=14154, -- Pattern: Truefaith Vestments
	[14513]=14152, -- Pattern: Robe of the Archmage
	[14514]=14153, -- Pattern: Robe of the Void
	[14526]=14342, -- Pattern: Mooncloth
	[14627]=4332, -- Pattern: Bright Yellow Shirt
	[14630]=4322, -- Pattern: Enchanter's Cowl
	[14634]=3829, -- Recipe: Frost Oil
	[14635]=4262, -- Pattern: Gem-studded Leather Belt
	[14639]=4381, -- Schematic: Minor Recombobulator
	[15724]=15077, -- Pattern: Heavy Scorpid Bracers
	[15725]=15083, -- Pattern: Wicked Leather Gauntlets
	[15726]=15045, -- Pattern: Green Dragonscale Breastplate
	[15727]=15076, -- Pattern: Heavy Scorpid Vest
	[15728]=15084, -- Pattern: Wicked Leather Bracers
	[15729]=15074, -- Pattern: Chimeric Gloves
	[15730]=15047, -- Pattern: Red Dragonscale Breastplate
	[15731]=15091, -- Pattern: Runic Leather Gauntlets
	[15732]=15054, -- Pattern: Volcanic Leggings
	[15733]=15046, -- Pattern: Green Dragonscale Leggings
	[15734]=15061, -- Pattern: Living Shoulders
	[15735]=15067, -- Pattern: Ironfeather Shoulders
	[15737]=15073, -- Pattern: Chimeric Boots
	[15738]=15078, -- Pattern: Heavy Scorpid Gauntlets
	[15739]=15092, -- Pattern: Runic Leather Bracers
	[15740]=15071, -- Pattern: Frostsaber Boots
	[15741]=15057, -- Pattern: Stormshroud Pants
	[15742]=15064, -- Pattern: Warbear Harness
	[15743]=15082, -- Pattern: Heavy Scorpid Belt
	[15744]=15086, -- Pattern: Wicked Leather Headband
	[15745]=15093, -- Pattern: Runic Leather Belt
	[15746]=15072, -- Pattern: Chimeric Leggings
	[15747]=15069, -- Pattern: Frostsaber Leggings
	[15748]=15079, -- Pattern: Heavy Scorpid Leggings
	[15749]=15053, -- Pattern: Volcanic Breastplate
	[15751]=15048, -- Pattern: Blue Dragonscale Breastplate
	[15752]=15060, -- Pattern: Living Leggings
	[15753]=15056, -- Pattern: Stormshroud Armor
	[15754]=15065, -- Pattern: Warbear Woolies
	[15755]=15075, -- Pattern: Chimeric Vest
	[15756]=15094, -- Pattern: Runic Leather Headband
	[15757]=15087, -- Pattern: Wicked Leather Pants
	[15758]=15063, -- Pattern: Devilsaur Gauntlets
	[15759]=15050, -- Pattern: Black Dragonscale Breastplate
	[15760]=15066, -- Pattern: Ironfeather Breastplate
	[15761]=15070, -- Pattern: Frostsaber Gloves
	[15762]=15080, -- Pattern: Heavy Scorpid Helm
	[15763]=15049, -- Pattern: Blue Dragonscale Shoulders
	[15764]=15058, -- Pattern: Stormshroud Shoulders
	[15765]=15095, -- Pattern: Runic Leather Pants
	[15768]=15088, -- Pattern: Wicked Leather Belt
	[15770]=15051, -- Pattern: Black Dragonscale Shoulders
	[15771]=15059, -- Pattern: Living Breastplate
	[15772]=15062, -- Pattern: Devilsaur Leggings
	[15773]=15085, -- Pattern: Wicked Leather Armor
	[15774]=15081, -- Pattern: Heavy Scorpid Shoulders
	[15775]=15055, -- Pattern: Volcanic Shoulders
	[15776]=15090, -- Pattern: Runic Leather Armor
	[15777]=15096, -- Pattern: Runic Leather Shoulders
	[15779]=15068, -- Pattern: Frostsaber Tunic
	[15781]=15052, -- Pattern: Black Dragonscale Leggings
	[16041]=15993, -- Schematic: Thorium Grenade
	[16042]=15994, -- Schematic: Thorium Widget
	[16043]=15995, -- Schematic: Thorium Rifle
	[16044]=15996, -- Schematic: Lifelike Mechanical Toad
	[16045]=15999, -- Schematic: Spellpower Goggles Xtreme Plus
	[16046]=16023, -- Schematic: Masterwork Target Dummy
	[16047]=16000, -- Schematic: Thorium Tube
	[16048]=16004, -- Schematic: Dark Iron Rifle
	[16049]=16005, -- Schematic: Dark Iron Bomb
	[16050]=16006, -- Schematic: Delicate Arcanite Converter
	[16051]=15997, -- Schematic: Thorium Shells
	[16052]=16009, -- Schematic: Voice Amplification Modulator
	[16053]=16008, -- Schematic: Master Engineer's Goggles
	[16054]=16022, -- Schematic: Arcanite Dragonling
	[16055]=16040, -- Schematic: Arcane Bomb
	[16056]=16007, -- Schematic: Flawless Arcanite Rifle
	[16110]=12218, -- Recipe: Monster Omelet
	[16111]=12216, -- Recipe: Spiced Chili Crab
	[16767]=16766, -- Recipe: Undermine Clam Chowder
	[17017]=16980, -- Pattern: Flarecore Mantle
	[17018]=16979, -- Pattern: Flarecore Gloves
	[17022]=16982, -- Pattern: Corehound Boots
	[17023]=16983, -- Pattern: Molten Helm
	[17025]=16984, -- Pattern: Black Dragonscale Boots
	[17049]=16989, -- Plans: Fiery Chain Girdle
	[17051]=17014, -- Plans: Dark Iron Bracers
	[17052]=17013, -- Plans: Dark Iron Leggings
	[17053]=16988, -- Plans: Fiery Chain Shoulders
	[17059]=17015, -- Plans: Dark Iron Reaver
	[17060]=17016, -- Plans: Dark Iron Destroyer
	[17062]=8364, -- Recipe: Mithril Head Trout
	[17200]=17197, -- Recipe: Gingerbread Cookie
	[17201]=17198, -- Recipe: Egg Nog
	[17706]=17704, -- Plans: Edge of Winter
	[17709]=17708, -- Recipe: Elixir of Frost Power
	[17720]=17716, -- Schematic: Snowmaster 9000
	[17722]=17721, -- Pattern: Gloves of the Greatfather
	[17724]=17723, -- Pattern: Green Holiday Shirt
	[18046]=18045, -- Recipe: Tender Wolf Steak
	[18160]=7676, -- Recipe: Thistle Tea
	[18239]=18238, -- Pattern: Shadowskin Gloves
	[18252]=18251, -- Pattern: Core Armor Kit
	[18257]=18253, -- Recipe: Major Rejuvenation Potion
	[18264]=18262, -- Plans: Elemental Sharpening Stone
	[18265]=18263, -- Pattern: Flarecore Wraps
	[18267]=18254, -- Recipe: Runn Tum Tuber Surprise
	[18290]=18283, -- Schematic: Biznicks 247x128 Accurascope
	[18291]=18168, -- Schematic: Force Reactive Disk
	[18292]=18282, -- Schematic: Core Marksman Rifle
	[18414]=18405, -- Pattern: Belt of the Archmage
	[18415]=18407, -- Pattern: Felcloth Gloves
	[18416]=18408, -- Pattern: Inferno Gloves
	[18417]=18409, -- Pattern: Mooncloth Gloves
	[18418]=18413, -- Pattern: Cloak of Warding
	[18487]=18486, -- Pattern: Mooncloth Robe
	[18514]=18504, -- Pattern: Girdle of Insight
	[18515]=18506, -- Pattern: Mongoose Boots
	[18516]=18508, -- Pattern: Swift Flight Bracers
	[18517]=18509, -- Pattern: Chromatic Cloak
	[18518]=18510, -- Pattern: Hide of the Wild
	[18519]=18511, -- Pattern: Shifting Cloak
	[18592]=17193, -- Plans: Sulfuron Hammer
	[18647]=9318, -- Schematic: Red Firework
	[18648]=9313, -- Schematic: Green Firework
	[18649]=9312, -- Schematic: Blue Firework
	[18650]=18588, -- Schematic: EZ-Thro Dynamite II
	[18651]=18631, -- Schematic: Truesilver Transformer
	[18652]=18634, -- Schematic: Gyrofreeze Ice Reflector
	[18653]=18587, -- Schematic: Goblin Jumper Cables XL
	[18654]=18645, -- Schematic: Gnomish Alarm-o-Bot
	[18655]=18637, -- Schematic: Major Recombobulator
	[18656]=18594, -- Schematic: Powerful Seaforium Charge
	[18657]=18638, -- Schematic: Hyper-Radiant Flame Reflector
	[18658]=18639, -- Schematic: Ultra-Flash Shadow Reflector
	[18661]=18660, -- Schematic: World Enlarger
	[18731]=18662, -- Pattern: Heavy Leather Ball
	[18949]=18948, -- Pattern: Barbaric Bracers
	[19027]=19026, -- Schematic: Snake Burst Firework
	[19202]=19043, -- Plans: Heavy Timbermaw Belt
	[19203]=19051, -- Plans: Girdle of the Dawn
	[19204]=19048, -- Plans: Heavy Timbermaw Boots
	[19205]=19057, -- Plans: Gloves of the Dawn
	[19206]=19148, -- Plans: Dark Iron Helm
	[19207]=19164, -- Plans: Dark Iron Gauntlets
	[19208]=19166, -- Plans: Black Amnesty
	[19209]=19167, -- Plans: Blackfury
	[19210]=19170, -- Plans: Ebon Hand
	[19211]=19168, -- Plans: Blackguard
	[19212]=19169, -- Plans: Nightfall
	[19215]=19047, -- Pattern: Wisdom of the Timbermaw
	[19216]=19056, -- Pattern: Argent Boots
	[19217]=19059, -- Pattern: Argent Shoulders
	[19218]=19050, -- Pattern: Mantle of the Timbermaw
	[19219]=19156, -- Pattern: Flarecore Robe
	[19220]=19165, -- Pattern: Flarecore Leggings
	[19326]=19044, -- Pattern: Might of the Timbermaw
	[19327]=19049, -- Pattern: Timbermaw Brawlers
	[19328]=19052, -- Pattern: Dawn Treaders
	[19329]=19058, -- Pattern: Golden Mantle of the Dawn
	[19330]=19149, -- Pattern: Lava Belt
	[19331]=19157, -- Pattern: Chromatic Gauntlets
	[19332]=19162, -- Pattern: Corehound Belt
	[19333]=19163, -- Pattern: Molten Belt
	[19764]=19682, -- Pattern: Bloodvine Vest
	[19765]=19683, -- Pattern: Bloodvine Leggings
	[19766]=19684, -- Pattern: Bloodvine Boots
	[19769]=19685, -- Pattern: Primal Batskin Jerkin
	[19770]=19686, -- Pattern: Primal Batskin Gloves
	[19771]=19687, -- Pattern: Primal Batskin Bracers
	[19772]=19688, -- Pattern: Blood Tiger Breastplate
	[19773]=19689, -- Pattern: Blood Tiger Shoulders
	[19776]=19690, -- Plans: Bloodsoul Breastplate
	[19777]=19691, -- Plans: Bloodsoul Shoulders
	[19778]=19692, -- Plans: Bloodsoul Gauntlets
	[19779]=19693, -- Plans: Darksoul Breastplate
	[19780]=19694, -- Plans: Darksoul Leggings
	[19781]=19695, -- Plans: Darksoul Shoulders
	[20000]=19999, -- Schematic: Bloodvine Goggles
	[20001]=19998, -- Schematic: Bloodvine Lens
	[20011]=20007, -- Recipe: Mageblood Elixir
	[20012]=20002, -- Recipe: Greater Dreamless Sleep Potion
	[20013]=20008, -- Recipe: Living Action Potion
	[20014]=20004, -- Recipe: Mighty Troll's Blood Elixir
	[20040]=20039, -- Plans: Dark Iron Boots
	[20075]=20074, -- Recipe: Heavy Crocolisk Stew
	[20253]=15064, -- Pattern: Warbear Harness
	[20254]=15065, -- Pattern: Warbear Woolies
	[20382]=20380, -- Pattern: Dreamscale Breastplate
	[20506]=20481, -- Pattern: Spitfire Bracers
	[20507]=20480, -- Pattern: Spitfire Gauntlets
	[20508]=20479, -- Pattern: Spitfire Breastplate
	[20509]=20476, -- Pattern: Sandstalker Bracers
	[20510]=20477, -- Pattern: Sandstalker Gauntlets
	[20511]=20478, -- Pattern: Sandstalker Breastplate
	[20546]=20538, -- Pattern: Runed Stygian Leggings
	[20547]=20537, -- Pattern: Runed Stygian Boots
	[20548]=20539, -- Pattern: Runed Stygian Belt
	[20553]=20549, -- Plans: Darkrune Gauntlets
	[20554]=20550, -- Plans: Darkrune Breastplate
	[20555]=20551, -- Plans: Darkrune Helm
	[20576]=20575, -- Pattern: Black Whelp Tunic
	[20854]=20830, -- Design: Amulet of the Moon
	[20855]=20833, -- Design: Wicked Moonstone Ring
	[20856]=20831, -- Design: Heavy Golden Necklace of Battle
	[20970]=20950, -- Design: Pendant of the Agate Shield
	[20971]=20954, -- Design: Heavy Iron Knuckles
	[20973]=20958, -- Design: Blazing Citrine Ring
	[20974]=20966, -- Design: Jade Pendant of Blasting
	[20975]=20959, -- Design: The Jade Eye
	[20976]=20967, -- Design: Citrine Pendant of Golden Healing
	[21025]=21023, -- Recipe: Dirge's Kickin' Chimaerok Chops
	[21099]=21072, -- Recipe: Smoked Sagefish
	[21219]=21217, -- Recipe: Sagefish Delight
	[21358]=21340, -- Pattern: Soul Pouch
	[21371]=21342, -- Pattern: Core Felcloth Bag
	[21547]=21546, -- Recipe: Elixir of Greater Firepower
	[21548]=21278, -- Pattern: Stormshroud Gloves
	[21722]=21154, -- Pattern: Festival Dress
	[21723]=21542, -- Pattern: Festival Suit
	[21724]=21558, -- Schematic: Small Blue Rocket
	[21725]=21559, -- Schematic: Small Green Rocket
	[21726]=21557, -- Schematic: Small Red Rocket
	[21727]=21589, -- Schematic: Large Blue Rocket
	[21728]=21590, -- Schematic: Large Green Rocket
	[21729]=21592, -- Schematic: Large Red Rocket
	[21730]=21571, -- Schematic: Blue Rocket Cluster
	[21731]=21574, -- Schematic: Green Rocket Cluster
	[21732]=21576, -- Schematic: Red Rocket Cluster
	[21733]=21714, -- Schematic: Large Blue Rocket Cluster
	[21734]=21716, -- Schematic: Large Green Rocket Cluster
	[21735]=21718, -- Schematic: Large Red Rocket Cluster
	[21737]=21570, -- Schematic: Cluster Launcher
	[21738]=21569, -- Schematic: Firework Launcher
	[21892]=21842, -- Pattern: Bolt of Imbued Netherweave
	[21893]=21843, -- Pattern: Imbued Netherweave Bag
	[21894]=21844, -- Pattern: Bolt of Soulcloth
	[21895]=21845, -- Pattern: Primal Mooncloth
	[21896]=21854, -- Pattern: Netherweave Robe
	[21897]=21855, -- Pattern: Netherweave Tunic
	[21898]=21859, -- Pattern: Imbued Netherweave Pants
	[21899]=21860, -- Pattern: Imbued Netherweave Boots
	[21900]=21861, -- Pattern: Imbued Netherweave Robe
	[21901]=21862, -- Pattern: Imbued Netherweave Tunic
	[21902]=21863, -- Pattern: Soulcloth Gloves
	[21903]=21864, -- Pattern: Soulcloth Shoulders
	[21904]=21865, -- Pattern: Soulcloth Vest
	[21905]=21866, -- Pattern: Arcanoweave Bracers
	[21906]=21867, -- Pattern: Arcanoweave Boots
	[21907]=21868, -- Pattern: Arcanoweave Robe
	[21908]=21846, -- Pattern: Spellfire Belt
	[21909]=21847, -- Pattern: Spellfire Gloves
	[21910]=21848, -- Pattern: Spellfire Robe
	[21911]=21858, -- Pattern: Spellfire Bag
	[21912]=21869, -- Pattern: Frozen Shadoweave Shoulders
	[21913]=21871, -- Pattern: Frozen Shadoweave Robe
	[21914]=21870, -- Pattern: Frozen Shadoweave Boots
	[21915]=21872, -- Pattern: Ebon Shadowbag
	[21916]=21873, -- Pattern: Primal Mooncloth Belt
	[21917]=21875, -- Pattern: Primal Mooncloth Robe
	[21918]=21874, -- Pattern: Primal Mooncloth Shoulders
	[21919]=21876, -- Pattern: Primal Mooncloth Bag
	[21940]=21756, -- Design: Golden Hare
	[21941]=21758, -- Design: Black Pearl Panther
	[21942]=20969, -- Design: Ruby Crown of Restoration
	[21943]=21760, -- Design: Truesilver Crab
	[21944]=21763, -- Design: Truesilver Boar
	[21945]=21754, -- Design: The Aquamarine Ward
	[21947]=21753, -- Design: Gem Studded Band
	[21948]=21766, -- Design: Opal Necklace of Impact
	[21949]=21769, -- Design: Ruby Serpent
	[21952]=21774, -- Design: Emerald Crown of Destruction
	[21953]=21777, -- Design: Emerald Owl
	[21954]=21778, -- Design: Ring of Bitter Shadows
	[21955]=21784, -- Design: Black Diamond Crab
	[21956]=21789, -- Design: Dark Iron Scorpid
	[21957]=21792, -- Design: Necklace of the Diamond Tower
	[22209]=22197, -- Plans: Heavy Obsidian Belt
	[22214]=22195, -- Plans: Light Obsidian Belt
	[22219]=22198, -- Plans: Jagged Obsidian Shield
	[22220]=22194, -- Plans: Black Grasp of the Destroyer
	[22221]=22191, -- Plans: Obsidian Mail Tunic
	[22222]=22196, -- Plans: Thick Obsidian Breastplate
	[22307]=22246, -- Pattern: Enchanted Mageweave Pouch
	[22308]=22248, -- Pattern: Enchanted Runecloth Bag
	[22309]=22249, -- Pattern: Big Bag of Enchantment
	[22310]=22251, -- Pattern: Cenarion Herb Bag
	[22312]=22252, -- Pattern: Satchel of Cenarius
	[22388]=22385, -- Plans: Titanic Leggings
	[22389]=22383, -- Plans: Sageblade
	[22390]=22384, -- Plans: Persuader
	[22647]=22645, -- Recipe: Crunchy Spider Surprise
	[22683]=22660, -- Pattern: Gaea's Embrace
	[22729]=22728, -- Schematic: Steam Tonk Controller
	[22766]=22762, -- Plans: Ironvine Breastplate
	[22767]=22763, -- Plans: Ironvine Gloves
	[22768]=22764, -- Plans: Ironvine Belt
	[22769]=22761, -- Pattern: Bramblewood Belt
	[22770]=22760, -- Pattern: Bramblewood Boots
	[22771]=22759, -- Pattern: Bramblewood Helm
	[22772]=22758, -- Pattern: Sylvan Shoulders
	[22773]=22757, -- Pattern: Sylvan Crown
	[22774]=22756, -- Pattern: Sylvan Vest
	[22900]=22823, -- Recipe: Elixir of Camouflage
	[22901]=22826, -- Recipe: Sneaking Potion
	[22902]=22827, -- Recipe: Elixir of Major Frost Power
	[22903]=22828, -- Recipe: Insane Strength Potion
	[22904]=22830, -- Recipe: Elixir of the Searching Eye
	[22905]=22831, -- Recipe: Elixir of Major Agility
	[22906]=22871, -- Recipe: Shrouding Potion
	[22907]=22832, -- Recipe: Super Mana Potion
	[22908]=22833, -- Recipe: Elixir of Major Firepower
	[22909]=22834, -- Recipe: Elixir of Major Defense
	[22910]=22835, -- Recipe: Elixir of Major Shadow Power
	[22911]=22836, -- Recipe: Major Dreamless Sleep Potion
	[22912]=22837, -- Recipe: Heroic Potion
	[22913]=22838, -- Recipe: Haste Potion
	[22914]=22839, -- Recipe: Destruction Potion
	[22919]=22840, -- Recipe: Elixir of Major Mageblood
	[22920]=22841, -- Recipe: Major Fire Protection Potion
	[22921]=22842, -- Recipe: Major Frost Protection Potion
	[22922]=22844, -- Recipe: Major Nature Protection Potion
	[22923]=22845, -- Recipe: Major Arcane Protection Potion
	[22924]=22846, -- Recipe: Major Shadow Protection Potion
	[22925]=22847, -- Recipe: Major Holy Protection Potion
	[22926]=22848, -- Recipe: Elixir of Empowerment
	[22927]=22849, -- Recipe: Ironshield Potion
	[23130]=23094, -- Design: Teardrop Blood Garnet
	[23131]=23095, -- Design: Bold Blood Garnet
	[23133]=23096, -- Design: Runed Blood Garnet
	[23134]=23097, -- Design: Delicate Blood Garnet
	[23135]=23098, -- Design: Inscribed Flame Spessarite
	[23136]=23099, -- Design: Luminous Flame Spessarite
	[23137]=23100, -- Design: Glinting Flame Spessarite
	[23138]=23101, -- Design: Potent Flame Spessarite
	[23140]=23103, -- Design: Radiant Deep Peridot
	[23141]=23104, -- Design: Jagged Deep Peridot
	[23142]=23105, -- Design: Enduring Deep Peridot
	[23143]=23106, -- Design: Dazzling Deep Peridot
	[23144]=23108, -- Design: Glowing Shadow Draenite
	[23145]=23109, -- Design: Royal Shadow Draenite
	[23146]=23110, -- Design: Shifting Shadow Draenite
	[23147]=23111, -- Design: Sovereign Shadow Draenite
	[23148]=23113, -- Design: Brilliant Golden Draenite
	[23149]=23114, -- Design: Gleaming Golden Draenite
	[23150]=23115, -- Design: Thick Golden Draenite
	[23151]=23116, -- Design: Rigid Golden Draenite
	[23152]=23118, -- Design: Solid Azure Moonstone
	[23153]=23119, -- Design: Sparkling Azure Moonstone
	[23154]=23120, -- Design: Stormy Azure Moonstone
	[23155]=23121, -- Design: Lustrous Azure Moonstone
	[23590]=23502, -- Plans: Adamantite Maul
	[23591]=23503, -- Plans: Adamantite Cleaver
	[23592]=23504, -- Plans: Adamantite Dagger
	[23593]=23505, -- Plans: Adamantite Rapier
	[23594]=23506, -- Plans: Adamantite Plate Bracers
	[23595]=23508, -- Plans: Adamantite Plate Gloves
	[23596]=23507, -- Plans: Adamantite Breastplate
	[23597]=23510, -- Plans: Enchanted Adamantite Belt
	[23598]=23511, -- Plans: Enchanted Adamantite Boots
	[23599]=23509, -- Plans: Enchanted Adamantite Breastplate
	[23600]=23512, -- Plans: Enchanted Adamantite Leggings
	[23601]=23515, -- Plans: Flamebane Bracers
	[23602]=23516, -- Plans: Flamebane Helm
	[23603]=23514, -- Plans: Flamebane Gloves
	[23604]=23513, -- Plans: Flamebane Breastplate
	[23605]=23517, -- Plans: Felsteel Gloves
	[23606]=23518, -- Plans: Felsteel Leggings
	[23607]=23519, -- Plans: Felsteel Helm
	[23608]=23524, -- Plans: Khorium Belt
	[23609]=23523, -- Plans: Khorium Pants
	[23610]=23525, -- Plans: Khorium Boots
	[23611]=23520, -- Plans: Ragesteel Gloves
	[23612]=23521, -- Plans: Ragesteel Helm
	[23613]=23522, -- Plans: Ragesteel Breastplate
	[23615]=23526, -- Plans: Swiftsteel Gloves
	[23617]=23527, -- Plans: Earthpeace Breastplate
	[23618]=23529, -- Plans: Adamantite Sharpening Stone
	[23619]=23530, -- Plans: Felsteel Shield Spike
	[23620]=23531, -- Plans: Felfury Gauntlets
	[23621]=23532, -- Plans: Gauntlets of the Iron Tower
	[23622]=23533, -- Plans: Steelgrip Gauntlets
	[23623]=23534, -- Plans: Storm Helm
	[23624]=23535, -- Plans: Helm of the Stalwart Defender
	[23625]=23536, -- Plans: Oathkeeper's Helm
	[23626]=23537, -- Plans: Black Felsteel Bracers
	[23627]=23538, -- Plans: Bracers of the Green Fortress
	[23628]=23539, -- Plans: Blessed Bracers
	[23629]=23540, -- Plans: Felsteel Longblade
	[23630]=23541, -- Plans: Khorium Champion
	[23631]=23542, -- Plans: Fel Edged Battleaxe
	[23632]=23543, -- Plans: Felsteel Reaper
	[23633]=23544, -- Plans: Runic Hammer
	[23634]=23546, -- Plans: Fel Hardened Maul
	[23635]=23554, -- Plans: Eternium Runed Blade
	[23636]=23555, -- Plans: Dirge
	[23637]=23556, -- Plans: Hand of Eternity
	[23638]=23575, -- Plans: Lesser Ward of Shielding
	[23639]=23576, -- Plans: Greater Ward of Shielding
	[23799]=23746, -- Schematic: Adamantite Rifle
	[23800]=23747, -- Schematic: Felsteel Boomstick
	[23802]=23748, -- Schematic: Ornate Khorium Rifle
	[23803]=23758, -- Schematic: Cogspinner Goggles
	[23804]=23761, -- Schematic: Power Amplification Goggles
	[23805]=23762, -- Schematic: Ultra-Spectropic Detection Goggles
	[23806]=23763, -- Schematic: Hyper-Vision Goggles
	[23807]=23764, -- Schematic: Adamantite Scope
	[23808]=23765, -- Schematic: Khorium Scope
	[23809]=23766, -- Schematic: Stabilized Eternium Scope
	[23810]=23767, -- Schematic: Crashin' Thrashin' Robot
	[23811]=23768, -- Schematic: White Smoke Flare
	[23814]=23771, -- Schematic: Green Smoke Flare
	[23815]=34504, -- Schematic: Adamantite Shell Machine
	[23816]=23774, -- Schematic: Fel Iron Toolbox
	[23817]=23775, -- Schematic: Titanium Toolbox
	[23874]=23819, -- Schematic: Elemental Seaforium Charge
	[23883]=33092, -- Schematic: Healing Potion Injector
	[23884]=33093, -- Schematic: Mana Potion Injector
	[23885]=23840, -- Schematic: Remote Mail Terminal
	[23887]=23824, -- Schematic: Rocket Boots Xtreme
	[23888]=23821, -- Schematic: Zapthrottle Mote Extractor
	[24001]=22831, -- Recipe: Elixir of Major Agility
	[24002]=23530, -- Plans: Felsteel Shield Spike
	[24158]=24079, -- Design: Khorium Band of Shadows
	[24159]=24080, -- Design: Khorium Band of Frost
	[24160]=24082, -- Design: Khorium Inferno Band
	[24161]=24085, -- Design: Khorium Band of Leaves
	[24162]=24086, -- Design: Arcane Khorium Band
	[24163]=24087, -- Design: Heavy Felsteel Ring
	[24164]=24088, -- Design: Delicate Eternium Ring
	[24165]=24089, -- Design: Blazing Eternium Band
	[24166]=24106, -- Design: Thick Felsteel Necklace
	[24167]=24110, -- Design: Living Ruby Pendant
	[24168]=24114, -- Design: Braided Eternium Chain
	[24169]=24116, -- Design: Eye of the Night
	[24170]=24117, -- Design: Embrace of the Dawn
	[24171]=24121, -- Design: Chain of the Twilight Owl
	[24172]=24122, -- Design: Coronet of Verdant Flame
	[24173]=24123, -- Design: Circlet of Arcane Might
	[24174]=24092, -- Design: Pendant of Frozen Flame
	[24175]=24093, -- Design: Pendant of Thawing
	[24176]=24095, -- Design: Pendant of Withering
	[24177]=24097, -- Design: Pendant of Shadow's End
	[24178]=24098, -- Design: Pendant of the Null Rune
	[24179]=24124, -- Design: Felsteel Boar
	[24180]=24125, -- Design: Dawnstone Crab
	[24181]=24126, -- Design: Living Ruby Serpent
	[24182]=24127, -- Design: Talasite Owl
	[24183]=24128, -- Design: Nightseye Panther
	[24192]=24031, -- Design: Bright Living Ruby
	[24193]=24027, -- Design: Bold Living Ruby
	[24194]=24028, -- Design: Delicate Living Ruby
	[24195]=24029, -- Design: Teardrop Living Ruby
	[24196]=24030, -- Design: Runed Living Ruby
	[24197]=24032, -- Design: Subtle Living Ruby
	[24198]=24036, -- Design: Flashing Living Ruby
	[24199]=24033, -- Design: Solid Star of Elune
	[24200]=24035, -- Design: Sparkling Star of Elune
	[24201]=24037, -- Design: Lustrous Star of Elune
	[24202]=24039, -- Design: Stormy Star of Elune
	[24203]=24047, -- Design: Brilliant Dawnstone
	[24204]=24048, -- Design: Smooth Dawnstone
	[24205]=24051, -- Design: Rigid Dawnstone
	[24206]=24050, -- Design: Gleaming Dawnstone
	[24207]=24052, -- Design: Thick Dawnstone
	[24208]=24053, -- Design: Mystic Dawnstone
	[24209]=24054, -- Design: Sovereign Nightseye
	[24210]=24055, -- Design: Shifting Nightseye
	[24211]=24056, -- Design: Glowing Nightseye
	[24212]=24057, -- Design: Royal Nightseye
	[24213]=24058, -- Design: Inscribed Noble Topaz
	[24214]=24059, -- Design: Potent Noble Topaz
	[24215]=24060, -- Design: Luminous Noble Topaz
	[24216]=24061, -- Design: Glinting Noble Topaz
	[24217]=24062, -- Design: Enduring Talasite
	[24218]=24066, -- Design: Radiant Talasite
	[24219]=24065, -- Design: Dazzling Talasite
	[24220]=24067, -- Design: Jagged Talasite
	[24292]=24273, -- Pattern: Mystic Spellthread
	[24293]=24275, -- Pattern: Silver Spellthread
	[24294]=24274, -- Pattern: Runic Spellthread
	[24295]=24276, -- Pattern: Golden Spellthread
	[24296]=24249, -- Pattern: Unyielding Bracers
	[24297]=24250, -- Pattern: Bracers of Havok
	[24298]=24251, -- Pattern: Blackstrike Bracers
	[24299]=24252, -- Pattern: Cloak of the Black Void
	[24300]=24253, -- Pattern: Cloak of Eternity
	[24301]=24254, -- Pattern: White Remedy Cape
	[24302]=24255, -- Pattern: Unyielding Girdle
	[24303]=24256, -- Pattern: Girdle of Ruination
	[24304]=24257, -- Pattern: Black Belt of Knowledge
	[24305]=24258, -- Pattern: Resolute Cape
	[24306]=24259, -- Pattern: Vengeance Wrap
	[24307]=24260, -- Pattern: Manaweave Cloak
	[24308]=24261, -- Pattern: Whitemend Pants
	[24309]=24262, -- Pattern: Spellstrike Pants
	[24310]=24263, -- Pattern: Battlecast Pants
	[24311]=24264, -- Pattern: Whitemend Hood
	[24312]=24266, -- Pattern: Spellstrike Hood
	[24313]=24267, -- Pattern: Battlecast Hood
	[24314]=24270, -- Pattern: Bag of Jewels
	[24316]=24271, -- Pattern: Spellcloth
	[25526]=25521, -- Plans: Greater Rune of Warding
	[25720]=23793, -- Pattern: Heavy Knothide Leather
	[25721]=25651, -- Pattern: Vindicator's Armor Kit
	[25722]=25652, -- Pattern: Magister's Armor Kit
	[25725]=25653, -- Pattern: Riding Crop
	[25726]=25679, -- Pattern: Comfortable Insoles
	[25728]=25680, -- Pattern: Stylin' Purple Hat
	[25729]=25681, -- Pattern: Stylin' Adventure Hat
	[25730]=25682, -- Pattern: Stylin' Jungle Hat
	[25731]=25683, -- Pattern: Stylin' Crimson Hat
	[25732]=25685, -- Pattern: Fel Leather Gloves
	[25733]=25686, -- Pattern: Fel Leather Boots
	[25734]=25687, -- Pattern: Fel Leather Leggings
	[25735]=25689, -- Pattern: Heavy Clefthoof Vest
	[25736]=25690, -- Pattern: Heavy Clefthoof Leggings
	[25737]=25691, -- Pattern: Heavy Clefthoof Boots
	[25738]=25695, -- Pattern: Felstalker Belt
	[25739]=25697, -- Pattern: Felstalker Bracers
	[25740]=25696, -- Pattern: Felstalker Breastplate
	[25741]=25694, -- Pattern: Netherfury Belt
	[25742]=25692, -- Pattern: Netherfury Leggings
	[25743]=25693, -- Pattern: Netherfury Boots
	[25846]=25844, -- Plans: Adamantite Rod
	[25847]=25845, -- Plans: Eternium Rod
	[25887]=25886, -- Schematic: Purple Smoke Flare
	[25902]=25896, -- Design: Powerful Earthstorm Diamond
	[25903]=25897, -- Design: Bracing Earthstorm Diamond
	[25904]=25901, -- Design: Insightful Earthstorm Diamond
	[25905]=25898, -- Design: Tenacious Earthstorm Diamond
	[25906]=25899, -- Design: Brutal Earthstorm Diamond
	[25907]=25890, -- Design: Destructive Skyfire Diamond
	[25908]=25894, -- Design: Swift Skyfire Diamond
	[25909]=25893, -- Design: Mystical Skyfire Diamond
	[25910]=25895, -- Design: Enigmatic Skyfire Diamond
	[27684]=27651, -- Recipe: Buzzard Bites
	[27685]=27635, -- Recipe: Lynx Steak
	[27686]=24105, -- Recipe: Roasted Moongraze Tenderloin
	[27687]=27636, -- Recipe: Bat Bites
	[27688]=27655, -- Recipe: Ravager Dog
	[27689]=27656, -- Recipe: Sporeling Snack
	[27690]=27657, -- Recipe: Blackened Basilisk
	[27691]=27658, -- Recipe: Roasted Clefthoof
	[27692]=27659, -- Recipe: Warp Burger
	[27693]=27660, -- Recipe: Talbuk Steak
	[27694]=27661, -- Recipe: Blackened Trout
	[27695]=27662, -- Recipe: Feltail Delight
	[27696]=27663, -- Recipe: Blackened Sporefish
	[27697]=27664, -- Recipe: Grilled Mudfish
	[27698]=27665, -- Recipe: Poached Bluefish
	[27699]=27666, -- Recipe: Golden Fish Sticks
	[27700]=27667, -- Recipe: Spicy Crawdad
	[28291]=28290, -- Design: Smooth Golden Draenite
	[28596]=28595, -- Design: Bright Blood Garnet
	[28632]=28421, -- Plans: Adamantite Weightstone
	[29213]=25695, -- Pattern: Felstalker Belt
	[29214]=25697, -- Pattern: Felstalker Bracers
	[29215]=25696, -- Pattern: Felstalker Breastplate
	[29217]=25694, -- Pattern: Netherfury Belt
	[29218]=25693, -- Pattern: Netherfury Boots
	[29219]=25692, -- Pattern: Netherfury Leggings
	[29664]=29540, -- Pattern: Reinforced Mining Bag
	[29669]=29483, -- Pattern: Shadow Armor Kit
	[29672]=29485, -- Pattern: Flame Armor Kit
	[29673]=29486, -- Pattern: Frost Armor Kit
	[29674]=29487, -- Pattern: Nature Armor Kit
	[29675]=29488, -- Pattern: Arcane Armor Kit
	[29677]=29489, -- Pattern: Enchanted Felscale Leggings
	[29682]=29490, -- Pattern: Enchanted Felscale Gloves
	[29684]=29491, -- Pattern: Enchanted Felscale Boots
	[29689]=29492, -- Pattern: Flamescale Leggings
	[29691]=29493, -- Pattern: Flamescale Boots
	[29693]=29494, -- Pattern: Flamescale Belt
	[29698]=29495, -- Pattern: Enchanted Clefthoof Leggings
	[29700]=29496, -- Pattern: Enchanted Clefthoof Gloves
	[29701]=29497, -- Pattern: Enchanted Clefthoof Boots
	[29702]=29498, -- Pattern: Blastguard Pants
	[29703]=29499, -- Pattern: Blastguard Boots
	[29704]=29500, -- Pattern: Blastguard Belt
	[29713]=29532, -- Pattern: Drums of Panic
	[29714]=29531, -- Pattern: Drums of Restoration
	[29717]=29529, -- Pattern: Drums of Battle
	[29718]=29530, -- Pattern: Drums of Speed
	[29719]=29533, -- Pattern: Cobrahide Leg Armor
	[29720]=29534, -- Pattern: Clefthide Leg Armor
	[29721]=29536, -- Pattern: Nethercleft Leg Armor
	[29722]=29535, -- Pattern: Nethercobra Leg Armor
	[29723]=29502, -- Pattern: Cobrascale Hood
	[29724]=29503, -- Pattern: Cobrascale Gloves
	[29725]=29504, -- Pattern: Windscale Hood
	[29726]=29505, -- Pattern: Hood of Primal Life
	[29727]=29506, -- Pattern: Gloves of the Living Touch
	[29728]=29507, -- Pattern: Windslayer Wraps
	[29729]=29508, -- Pattern: Living Dragonscale Helm
	[29730]=29512, -- Pattern: Earthen Netherscale Boots
	[29731]=29509, -- Pattern: Windstrike Gloves
	[29732]=29510, -- Pattern: Netherdrake Helm
	[29733]=29511, -- Pattern: Netherdrake Gloves
	[29734]=29514, -- Pattern: Thick Netherscale Breastplate
	[30156]=30155, -- Recipe: Clam Bar
	[30280]=30038, -- Pattern: Belt of Blasting
	[30281]=30036, -- Pattern: Belt of the Long Road
	[30282]=30037, -- Pattern: Boots of Blasting
	[30283]=30035, -- Pattern: Boots of the Long Road
	[30301]=30042, -- Pattern: Belt of Natural Power
	[30302]=30040, -- Pattern: Belt of Deep Shadow
	[30303]=30046, -- Pattern: Belt of the Black Eagle
	[30304]=30044, -- Pattern: Monsoon Belt
	[30305]=30041, -- Pattern: Boots of Natural Grace
	[30306]=30039, -- Pattern: Boots of Utter Darkness
	[30307]=30045, -- Pattern: Boots of the Crimson Hawk
	[30308]=30043, -- Pattern: Hurricane Boots
	[30321]=30034, -- Plans: Belt of the Guardian
	[30322]=30032, -- Plans: Red Belt of Battle
	[30323]=30033, -- Plans: Boots of the Protector
	[30324]=30031, -- Plans: Red Havoc Boots
	[30444]=29540, -- Pattern: Reinforced Mining Bag
	[30483]=24272, -- Pattern: Shadowcloth
	[30826]=30825, -- Design: Ring of Arcane Shielding
	[30833]=30831, -- Pattern: Cloak of Arcane Evasion
	[30842]=30837, -- Pattern: Flameheart Bracers
	[30843]=30838, -- Pattern: Flameheart Gloves
	[30844]=30839, -- Pattern: Flameheart Vest
	[31354]=13510, -- Recipe: Flask of the Titans
	[31355]=13512, -- Recipe: Flask of Supreme Power
	[31356]=13511, -- Recipe: Flask of Distilled Wisdom
	[31357]=13513, -- Recipe: Flask of Chromatic Resistance
	[31358]=24125, -- Design: Dawnstone Crab
	[31359]=23105, -- Design: Enduring Deep Peridot
	[31361]=29533, -- Pattern: Cobrahide Leg Armor
	[31362]=29535, -- Pattern: Nethercobra Leg Armor
	[31390]=31364, -- Plans: Wildguard Breastplate
	[31391]=31367, -- Plans: Wildguard Leggings
	[31392]=31368, -- Plans: Wildguard Helm
	[31393]=31369, -- Plans: Iceguard Breastplate
	[31394]=31370, -- Plans: Iceguard Leggings
	[31395]=31371, -- Plans: Iceguard Helm
	[31401]=31398, -- Design: The Frozen Eye
	[31402]=31399, -- Design: The Natural Ward
	[31674]=31673, -- Recipe: Crunchy Serpent
	[31675]=31672, -- Recipe: Mok'Nathal Shortribs
	[31680]=31679, -- Recipe: Fel Strength Elixir
	[31681]=31676, -- Recipe: Fel Regeneration Potion
	[31682]=31677, -- Recipe: Fel Mana Potion
	[31870]=31860, -- Design: Great Golden Draenite
	[31871]=31862, -- Design: Balanced Shadow Draenite
	[31872]=31864, -- Design: Infused Shadow Draenite
	[31873]=31866, -- Design: Veiled Flame Spessarite
	[31874]=31869, -- Design: Wicked Flame Spessarite
	[31875]=31861, -- Design: Great Dawnstone
	[31876]=31863, -- Design: Balanced Nightseye
	[31877]=31865, -- Design: Infused Nightseye
	[31878]=31867, -- Design: Veiled Noble Topaz
	[31879]=31868, -- Design: Wicked Noble Topaz
	[32070]=32063, -- Recipe: Earthen Elixir
	[32071]=32068, -- Recipe: Elixir of Ironskin
	[32274]=32193, -- Design: Bold Crimson Spinel
	[32277]=32194, -- Design: Delicate Crimson Spinel
	[32281]=32195, -- Design: Teardrop Crimson Spinel
	[32282]=32196, -- Design: Runed Crimson Spinel
	[32283]=32197, -- Design: Bright Crimson Spinel
	[32284]=32198, -- Design: Subtle Crimson Spinel
	[32285]=32199, -- Design: Flashing Crimson Spinel
	[32286]=32200, -- Design: Solid Empyrean Sapphire
	[32287]=32201, -- Design: Sparkling Empyrean Sapphire
	[32288]=32202, -- Design: Lustrous Empyrean Sapphire
	[32289]=32203, -- Design: Stormy Empyrean Sapphire
	[32290]=32204, -- Design: Brilliant Lionseye
	[32291]=32205, -- Design: Smooth Lionseye
	[32292]=32206, -- Design: Rigid Lionseye
	[32293]=32207, -- Design: Gleaming Lionseye
	[32294]=32208, -- Design: Thick Lionseye
	[32295]=32209, -- Design: Mystic Lionseye
	[32296]=32210, -- Design: Great Lionseye
	[32297]=32211, -- Design: Sovereign Shadowsong Amethyst
	[32298]=32212, -- Design: Shifting Shadowsong Amethyst
	[32299]=32213, -- Design: Balanced Shadowsong Amethyst
	[32300]=32214, -- Design: Infused Shadowsong Amethyst
	[32301]=32215, -- Design: Glowing Shadowsong Amethyst
	[32302]=32216, -- Design: Royal Shadowsong Amethyst
	[32303]=32217, -- Design: Inscribed Pyrestone
	[32304]=32218, -- Design: Potent Pyrestone
	[32305]=32219, -- Design: Luminous Pyrestone
	[32306]=32220, -- Design: Glinting Pyrestone
	[32307]=32221, -- Design: Veiled Pyrestone
	[32308]=32222, -- Design: Wicked Pyrestone
	[32309]=32223, -- Design: Enduring Seaspray Emerald
	[32310]=32224, -- Design: Radiant Seaspray Emerald
	[32311]=32225, -- Design: Dazzling Seaspray Emerald
	[32312]=32226, -- Design: Jagged Seaspray Emerald
	[32381]=7191, -- Schematic: Fused Wiring
	[32411]=32410, -- Design: Thundering Skyfire Diamond
	[32412]=32409, -- Design: Relentless Earthstorm Diamond
	[32429]=32398, -- Pattern: Boots of Shackled Souls
	[32430]=32399, -- Pattern: Bracers of Shackled Souls
	[32431]=32400, -- Pattern: Greaves of Shackled Souls
	[32432]=32397, -- Pattern: Waistguard of Shackled Souls
	[32433]=32394, -- Pattern: Redeemed Soul Moccasins
	[32434]=32395, -- Pattern: Redeemed Soul Wristguards
	[32435]=32396, -- Pattern: Redeemed Soul Legguards
	[32436]=32393, -- Pattern: Redeemed Soul Cinch
	[32437]=32391, -- Pattern: Soulguard Slippers
	[32438]=32392, -- Pattern: Soulguard Bracers
	[32439]=32389, -- Pattern: Soulguard Leggings
	[32440]=32390, -- Pattern: Soulguard Girdle
	[32441]=32402, -- Plans: Shadesteel Sabots
	[32442]=32403, -- Plans: Shadesteel Bracers
	[32443]=32404, -- Plans: Shadesteel Greaves
	[32444]=32401, -- Plans: Shadesteel Girdle
	[32447]=32420, -- Pattern: Night's End
	[32736]=32568, -- Plans: Swiftsteel Bracers
	[32737]=32570, -- Plans: Swiftsteel Shoulders
	[32738]=32571, -- Plans: Dawnsteel Bracers
	[32739]=32573, -- Plans: Dawnsteel Shoulders
	[32744]=32582, -- Pattern: Bracers of Renewed Life
	[32745]=32583, -- Pattern: Shoulderpads of Renewed Life
	[32746]=32580, -- Pattern: Swiftstrike Bracers
	[32747]=32581, -- Pattern: Swiftstrike Shoulders
	[32748]=32574, -- Pattern: Bindings of Lightning Reflexes
	[32749]=32575, -- Pattern: Shoulders of Lightning Reflexes
	[32750]=32577, -- Pattern: Living Earth Bindings
	[32751]=32579, -- Pattern: Living Earth Shoulders
	[32752]=32584, -- Pattern: Swiftheal Wraps
	[32753]=32585, -- Pattern: Swiftheal Mantle
	[32754]=32586, -- Pattern: Bracers of Nimble Thought
	[32755]=32587, -- Pattern: Mantle of Nimble Thought
	[33124]=33122, -- Pattern: Cloak of Darkness
	[33155]=33134, -- Design: Kailee's Rose
	[33156]=33131, -- Design: Crimson Sun
	[33157]=33135, -- Design: Falling Star
	[33158]=33143, -- Design: Stone of Blades
	[33159]=33140, -- Design: Blood of Amber
	[33160]=33144, -- Design: Facet of Eternity
	[33174]=33173, -- Plans: Ragesteel Shoulders
	[33186]=33185, -- Plans: Adamantite Weapon Chain
	[33205]=33204, -- Pattern: Shadowprowler's Chestguard
	[33209]=33208, -- Recipe: Flask of Chromatic Wonder
	[33305]=33133, -- Design: Don Julio's Heart
	[33622]=32409, -- Design: Relentless Earthstorm Diamond
	[33783]=33782, -- Design: Steady Talasite
	[33792]=33791, -- Plans: Heavy Copper Longsword
	[33804]=20475, -- Schematic: Adamantite Arrow Maker
	[33869]=33867, -- Recipe: Broiled Bloodfin
	[33870]=33825, -- Recipe: Skullfish Soup
	[33871]=33866, -- Recipe: Stormchops
	[33873]=33872, -- Recipe: Spicy Hot Talbuk
	[33875]=33874, -- Recipe: Kibler's Bits
	[33925]=33924, -- Recipe: Delicious Chocolate Cake
	[33954]=32854, -- Plans: Hammer of Righteous Might
	[34114]=34113, -- Schematic: Field Repair Bot 110G
	[34126]=34125, -- Recipe: Shoveltusk Soup
	[34172]=29530, -- Pattern: Drums of Speed
	[34173]=29530, -- Pattern: Drums of Speed
	[34174]=29531, -- Pattern: Drums of Restoration
	[34175]=29531, -- Pattern: Drums of Restoration
	[34200]=34105, -- Pattern: Quiver of a Thousand Feathers
	[34201]=34106, -- Pattern: Netherscale Ammo Pouch
	[34218]=34106, -- Pattern: Netherscale Ammo Pouch
	[34221]=34220, -- Design: Chaotic Skyfire Diamond
	[34261]=34087, -- Pattern: Green Winter Clothes
	[34262]=34086, -- Pattern: Winter Boots
	[34319]=34085, -- Pattern: Red Winter Clothes
	[34413]=34411, -- Recipe: Hot Apple Cider
	[34491]=34490, -- Pattern: Bag of Many Hides
	[34689]=34220, -- Design: Chaotic Skyfire Diamond
	[34834]=34832, -- Recipe: Captain Rumsey's Lager
	[35186]=34847, -- Schematic: Annihilator Holo-Gogs
	[35187]=35185, -- Schematic: Justicebringer 3000 Specs
	[35189]=35181, -- Schematic: Powerheal 9000 Lens
	[35190]=35182, -- Schematic: Hyper-Magnified Moon Specs
	[35191]=35183, -- Schematic: Wonderheal XT68 Shades
	[35192]=35184, -- Schematic: Primal-Attuned Goggles
	[35193]=34355, -- Schematic: Lightning Etched Specs
	[35194]=34356, -- Schematic: Surestrike Goggles v3.0
	[35195]=34354, -- Schematic: Mayhem Projection Goggles
	[35196]=34357, -- Schematic: Hard Khorium Goggles
	[35197]=34353, -- Schematic: Quad Deathblow X44 Goggles
	[35198]=34362, -- Design: Loop of Forged Power
	[35199]=34363, -- Design: Ring of Flowing Life
	[35200]=34361, -- Design: Hard Khorium Band
	[35201]=34359, -- Design: Pendant of Sunfire
	[35202]=34360, -- Design: Amulet of Flowing Life
	[35203]=34358, -- Design: Hard Khorium Choker
	[35204]=34366, -- Pattern: Sunfire Handwraps
	[35205]=34367, -- Pattern: Hands of Eternal Light
	[35206]=34364, -- Pattern: Sunfire Robe
	[35207]=34365, -- Pattern: Robe of Eternal Light
	[35208]=34380, -- Plans: Sunblessed Gauntlets
	[35209]=34378, -- Plans: Hard Khorium Battlefists
	[35210]=34379, -- Plans: Sunblessed Breastplate
	[35211]=34377, -- Plans: Hard Khorium Battleplate
	[35212]=34372, -- Pattern: Leather Gauntlets of the Sun
	[35213]=34374, -- Pattern: Fletcher's Gloves of the Phoenix
	[35214]=34370, -- Pattern: Gloves of Immortal Dusk
	[35215]=34376, -- Pattern: Sun-Drenched Scale Gloves
	[35216]=34371, -- Pattern: Leather Chestguard of the Sun
	[35217]=34373, -- Pattern: Embrace of the Phoenix
	[35218]=34369, -- Pattern: Carapace of Sun and Shadow
	[35219]=34375, -- Pattern: Sun-Drenched Scale Chestguard
	[35238]=32213, -- Design: Balanced Shadowsong Amethyst
	[35239]=32215, -- Design: Glowing Shadowsong Amethyst
	[35240]=32214, -- Design: Infused Shadowsong Amethyst
	[35241]=32216, -- Design: Royal Shadowsong Amethyst
	[35242]=32212, -- Design: Shifting Shadowsong Amethyst
	[35243]=32211, -- Design: Sovereign Shadowsong Amethyst
	[35244]=32193, -- Design: Bold Crimson Spinel
	[35245]=32197, -- Design: Bright Crimson Spinel
	[35246]=32194, -- Design: Delicate Crimson Spinel
	[35247]=32199, -- Design: Flashing Crimson Spinel
	[35248]=32196, -- Design: Runed Crimson Spinel
	[35249]=32198, -- Design: Subtle Crimson Spinel
	[35250]=32195, -- Design: Teardrop Crimson Spinel
	[35251]=32225, -- Design: Dazzling Seaspray Emerald
	[35252]=32223, -- Design: Enduring Seaspray Emerald
	[35253]=32226, -- Design: Jagged Seaspray Emerald
	[35254]=32224, -- Design: Radiant Seaspray Emerald
	[35255]=32204, -- Design: Brilliant Lionseye
	[35256]=32207, -- Design: Gleaming Lionseye
	[35257]=32210, -- Design: Great Lionseye
	[35258]=32209, -- Design: Mystic Lionseye
	[35259]=32206, -- Design: Rigid Lionseye
	[35260]=32205, -- Design: Smooth Lionseye
	[35261]=32208, -- Design: Thick Lionseye
	[35262]=32202, -- Design: Lustrous Empyrean Sapphire
	[35263]=32200, -- Design: Solid Empyrean Sapphire
	[35264]=32201, -- Design: Sparkling Empyrean Sapphire
	[35265]=32203, -- Design: Stormy Empyrean Sapphire
	[35266]=32220, -- Design: Glinting Pyrestone
	[35267]=32217, -- Design: Inscribed Pyrestone
	[35268]=32219, -- Design: Luminous Pyrestone
	[35269]=32218, -- Design: Potent Pyrestone
	[35270]=32221, -- Design: Veiled Pyrestone
	[35271]=32222, -- Design: Wicked Pyrestone
	[35294]=22848, -- Recipe: Elixir of Empowerment
	[35295]=22838, -- Recipe: Haste Potion
	[35296]=33185, -- Plans: Adamantite Weapon Chain
	[35300]=29509, -- Pattern: Windstrike Gloves
	[35301]=29511, -- Pattern: Netherdrake Gloves
	[35302]=29503, -- Pattern: Cobrascale Gloves
	[35303]=29506, -- Pattern: Gloves of the Living Touch
	[35304]=24033, -- Design: Solid Star of Elune
	[35305]=24030, -- Design: Runed Living Ruby
	[35306]=24031, -- Design: Bright Living Ruby
	[35307]=24051, -- Design: Rigid Dawnstone
	[35308]=24249, -- Pattern: Unyielding Bracers
	[35309]=24255, -- Pattern: Unyielding Girdle
	[35310]=33092, -- Schematic: Healing Potion Injector
	[35311]=33093, -- Schematic: Mana Potion Injector
	[35322]=35315, -- Design: Quick Dawnstone
	[35323]=35316, -- Design: Reckless Noble Topaz
	[35325]=35318, -- Design: Forceful Talasite
	[35502]=35501, -- Design: Eternal Earthstorm Diamond
	[35505]=35503, -- Design: Ember Skyfire Diamond
	[35564]=35563, -- Recipe: Charred Bear Kabobs
	[35566]=35565, -- Recipe: Juicy Bear Burger
	[35582]=35581, -- Schematic: Rocket Boots Xtreme Lite
	[35695]=35693, -- Design: Figurine - Empyrean Tortoise
	[35696]=35694, -- Design: Figurine - Khorium Boar
	[35697]=35700, -- Design: Figurine - Crimson Serpent
	[35698]=35702, -- Design: Figurine - Shadowsong Panther
	[35699]=35703, -- Design: Figurine - Seaspray Albatross
	[35708]=35707, -- Design: Regal Nightseye
	[35752]=35748, -- Recipe: Guardian's Alchemist Stone
	[35753]=35749, -- Recipe: Sorcerer's Alchemist Stone
	[35754]=35750, -- Recipe: Redeemer's Alchemist Stone
	[35755]=35751, -- Recipe: Assassin's Alchemist Stone
	[35762]=35760, -- Design: Reckless Pyrestone
	[35763]=35761, -- Design: Quick Lionseye
	[35764]=35758, -- Design: Steady Seaspray Emerald
	[35765]=35759, -- Design: Forceful Seaspray Emerald
	[35766]=35758, -- Design: Steady Seaspray Emerald
	[35767]=35760, -- Design: Reckless Pyrestone
	[35768]=35761, -- Design: Quick Lionseye
	[35769]=35759, -- Design: Forceful Seaspray Emerald
	[37504]=37503, -- Design: Purified Shadowsong Amethyst
	[37915]=6836, -- Pattern: Dress Shoes
	[38229]=38225, -- Pattern: Mycah's Botanical Bag
	[38327]=38277, -- Pattern: Haliscan Jacket
	[38328]=38278, -- Pattern: Haliscan Pantaloons
	[39644]=39520, -- Recipe: Kungaloosh
	[39692]=39691, -- Recipe: Succulent Orca Stew
	[41120]=40958, -- Plans: Reinforced Cobalt Legplates
	[41122]=40959, -- Plans: Reinforced Cobalt Chestpiece
	[41123]=40957, -- Plans: Reinforced Cobalt Helm
	[41124]=40956, -- Plans: Reinforced Cobalt Shoulders
	[41559]=39917, -- Design: Mystic Sun Crystal
	[41560]=39932, -- Design: Stormy Chalcedony
	[41561]=39959, -- Design: Reckless Huge Citrine
	[41562]=39952, -- Design: Deadly Huge Citrine
	[41563]=39958, -- Design: Durable Huge Citrine
	[41564]=39962, -- Design: Empowered Huge Citrine
	[41565]=39954, -- Design: Lucent Huge Citrine
	[41566]=39950, -- Design: Resplendent Huge Citrine
	[41567]=39975, -- Design: Vivid Dark Jade
	[41568]=39979, -- Design: Seer's Dark Jade
	[41569]=39992, -- Design: Shattered Dark Jade
	[41570]=39991, -- Design: Tense Dark Jade
	[41571]=39982, -- Design: Turbid Dark Jade
	[41572]=39977, -- Design: Steady Dark Jade
	[41573]=39988, -- Design: Opaque Dark Jade
	[41574]=39939, -- Design: Defender's Shadow Crystal
	[41575]=39945, -- Design: Mysterious Shadow Crystal
	[41576]=39996, -- Design: Bold Scarlet Ruby
	[41577]=39997, -- Design: Delicate Scarlet Ruby
	[41578]=40001, -- Design: Flashing Scarlet Ruby
	[41579]=40017, -- Design: Quick Autumn's Glow
	[41580]=40014, -- Design: Rigid Autumn's Glow
	[41581]=40010, -- Design: Lustrous Sky Sapphire
	[41582]=40044, -- Design: Glinting Monarch Topaz
	[41686]=40048, -- Design: Potent Monarch Topaz
	[41687]=40055, -- Design: Stark Monarch Topaz
	[41688]=40049, -- Design: Veiled Monarch Topaz
	[41689]=40047, -- Design: Luminous Monarch Topaz
	[41690]=40051, -- Design: Reckless Monarch Topaz
	[41692]=40105, -- Design: Energized Forest Emerald
	[41693]=40091, -- Design: Forceful Forest Emerald
	[41694]=40104, -- Design: Intricate Forest Emerald
	[41696]=40100, -- Design: Lambent Forest Emerald
	[41697]=40089, -- Design: Enduring Forest Emerald
	[41698]=40088, -- Design: Vivid Forest Emerald
	[41699]=40092, -- Design: Seer's Forest Emerald
	[41701]=40027, -- Design: Royal Twilight Opal
	[41702]=40033, -- Design: Puissant Twilight Opal
	[41703]=40031, -- Design: Regal Twilight Opal
	[41704]=41285, -- Design: Chaotic Skyflare Diamond
	[41705]=41377, -- Design: Effulgent Skyflare Diamond
	[41706]=41333, -- Design: Ember Skyflare Diamond
	[41707]=41376, -- Design: Revitalizing Skyflare Diamond
	[41708]=41401, -- Design: Insightful Earthsiege Diamond
	[41709]=41385, -- Design: Invigorating Earthsiege Diamond
	[41710]=41398, -- Design: Relentless Earthsiege Diamond
	[41711]=41382, -- Design: Trenchant Earthsiege Diamond
	[41718]=39998, -- Design: Runed Scarlet Ruby
	[41719]=40000, -- Design: Subtle Scarlet Ruby
	[41720]=40013, -- Design: Smooth Autumn's Glow
	[41721]=40052, -- Design: Wicked Monarch Topaz
	[41722]=40057, -- Design: Glimmering Monarch Topaz
	[41723]=40086, -- Design: Jagged Forest Emerald
	[41724]=40096, -- Design: Sundered Forest Emerald
	[41725]=40025, -- Design: Glowing Twilight Opal
	[41726]=40034, -- Design: Guardian's Twilight Opal
	[41727]=40016, -- Design: Mystic Autumn's Glow
	[41728]=40011, -- Design: Stormy Sky Sapphire
	[41730]=40050, -- Design: Durable Monarch Topaz
	[41732]=40054, -- Design: Empowered Monarch Topaz
	[41733]=40045, -- Design: Lucent Monarch Topaz
	[41734]=40040, -- Design: Resplendent Monarch Topaz
	[41735]=40106, -- Design: Shattered Forest Emerald
	[41736]=40101, -- Design: Tense Forest Emerald
	[41737]=40102, -- Design: Turbid Forest Emerald
	[41738]=40090, -- Design: Steady Forest Emerald
	[41739]=40103, -- Design: Opaque Forest Emerald
	[41740]=40028, -- Design: Mysterious Twilight Opal
	[41742]=41335, -- Design: Enigmatic Skyflare Diamond
	[41743]=41378, -- Design: Forlorn Skyflare Diamond
	[41744]=41379, -- Design: Impassive Skyflare Diamond
	[41747]=40023, -- Design: Shifting Twilight Opal
	[41777]=40038, -- Design: Etched Monarch Topaz
	[41778]=40059, -- Design: Resolute Monarch Topaz
	[41779]=40056, -- Design: Stalwart Monarch Topaz
	[41780]=40039, -- Design: Champion's Monarch Topaz
	[41781]=40095, -- Design: Misty Forest Emerald
	[41782]=40099, -- Design: Shining Forest Emerald
	[41783]=40026, -- Design: Purified Twilight Opal
	[41784]=40022, -- Design: Sovereign Twilight Opal
	[41785]=40024, -- Design: Tenuous Twilight Opal
	[41786]=41307, -- Design: Destructive Skyflare Diamond
	[41787]=41400, -- Design: Thundering Skyflare Diamond
	[41788]=41389, -- Design: Beaming Earthsiege Diamond
	[41789]=40037, -- Design: Inscribed Monarch Topaz
	[41790]=40003, -- Design: Precise Scarlet Ruby
	[41791]=40015, -- Design: Thick Autumn's Glow
	[41792]=40046, -- Design: Deft Monarch Topaz
	[41793]=40041, -- Design: Fierce Monarch Topaz
	[41794]=40043, -- Design: Deadly Monarch Topaz
	[41795]=40085, -- Design: Timeless Forest Emerald
	[41796]=40030, -- Design: Infused Twilight Opal
	[41797]=41380, -- Design: Austere Earthsiege Diamond
	[41798]=41395, -- Design: Bracing Earthsiege Diamond
	[41799]=41396, -- Design: Eternal Earthsiege Diamond
	[41817]=40002, -- Design: Fractured Scarlet Ruby
	[41818]=40058, -- Design: Accurate Monarch Topaz
	[41819]=40098, -- Design: Radiant Forest Emerald
	[41820]=40032, -- Design: Defender's Twilight Opal
	[42138]=40008, -- Design: Solid Sky Sapphire
	[42172]=41248, -- Pattern: Red Lumberjack Shirt
	[42173]=41249, -- Pattern: Blue Lumberjack Shirt
	[42175]=41250, -- Pattern: Green Lumberjack Shirt
	[42176]=41253, -- Pattern: Blue Workman's Shirt
	[42177]=41252, -- Pattern: Red Workman's Shirt
	[42178]=41254, -- Pattern: Rustic Workman's Shirt
	[42183]=41597, -- Pattern: Abyssal Bag
	[42184]=41600, -- Pattern: Glacial Bag
	[42185]=41598, -- Pattern: Mysterious Bag
	[42187]=41602, -- Pattern: Brilliant Spellthread
	[42188]=41604, -- Pattern: Sapphire Spellthread
	[42298]=42142, -- Design: Bold Dragon's Eye
	[42299]=36766, -- Design: Bright Dragon's Eye
	[42300]=42148, -- Design: Brilliant Dragon's Eye
	[42301]=42143, -- Design: Delicate Dragon's Eye
	[42302]=42152, -- Design: Flashing Dragon's Eye
	[42303]=42153, -- Design: Fractured Dragon's Eye
	[42304]=42146, -- Design: Lustrous Dragon's Eye
	[42305]=42158, -- Design: Mystic Dragon's Eye
	[42306]=42154, -- Design: Precise Dragon's Eye
	[42307]=42150, -- Design: Quick Dragon's Eye
	[42308]=42156, -- Design: Rigid Dragon's Eye
	[42309]=42144, -- Design: Runed Dragon's Eye
	[42310]=42149, -- Design: Smooth Dragon's Eye
	[42311]=36767, -- Design: Solid Dragon's Eye
	[42312]=42145, -- Design: Sparkling Dragon's Eye
	[42313]=42155, -- Design: Stormy Dragon's Eye
	[42314]=42151, -- Design: Subtle Dragon's Eye
	[42315]=42157, -- Design: Thick Dragon's Eye
	[42648]=42642, -- Design: Titanium Impact Band
	[42649]=42643, -- Design: Titanium Earthguard Ring
	[42650]=42644, -- Design: Titanium Spellshock Ring
	[42651]=42645, -- Design: Titanium Impact Choker
	[42652]=42646, -- Design: Titanium Earthguard Chain
	[42653]=42647, -- Design: Titanium Spellshock Necklace
	[43017]=43015, -- Recipe: Fish Feast
	[43018]=34754, -- Recipe: Mega Mammoth Meal
	[43019]=34755, -- Recipe: Tender Shoveltusk Steak
	[43020]=34756, -- Recipe: Spiced Worm Burger
	[43021]=34757, -- Recipe: Very Burnt Worg
	[43022]=34758, -- Recipe: Mighty Rhino Dogs
	[43023]=34766, -- Recipe: Poached Northern Sculpin
	[43024]=34767, -- Recipe: Firecracker Salmon
	[43025]=34768, -- Recipe: Spicy Blue Nettlefish
	[43026]=34769, -- Recipe: Imperial Manta Steak
	[43027]=42993, -- Recipe: Spicy Fried Herring
	[43028]=42994, -- Recipe: Rhinolicious Wormsteak
	[43029]=43004, -- Recipe: Critter Bites
	[43030]=42995, -- Recipe: Hearty Rhino
	[43031]=42996, -- Recipe: Snapper Extreme
	[43032]=42997, -- Recipe: Blackened Worg Steak
	[43033]=42998, -- Recipe: Cuttlesteak
	[43034]=43005, -- Recipe: Spiced Mammoth Treats
	[43035]=42999, -- Recipe: Blackened Dragonfin
	[43036]=43000, -- Recipe: Dragonfin Filet
	[43037]=43001, -- Recipe: Tracker Snacks
	[43317]=43250, -- Design: Ring of Earthen Might
	[43318]=43251, -- Design: Ring of Scarlet Shadows
	[43319]=43252, -- Design: Windfire Band
	[43320]=43253, -- Design: Ring of Northern Tears
	[43485]=43482, -- Design: Savage Titanium Ring
	[43497]=43498, -- Design: Savage Titanium Band
	[43505]=43478, -- Recipe: Gigantic Feast
	[43506]=43480, -- Recipe: Small Feast
	[43507]=43490, -- Recipe: Tasty Cupcake
	[43508]=43488, -- Recipe: Last Week's Mammoth
	[43509]=43491, -- Recipe: Bad Clams
	[43510]=43492, -- Recipe: Haunted Herring
	[43597]=43582, -- Design: Titanium Frostguard Ring
	[44502]=41508, -- Schematic: Mechano-hog
	[44503]=44413, -- Schematic: Mekgineer's Chopper
	[44509]=38399, -- Pattern: Trapper's Traveling Pack
	[44510]=38347, -- Pattern: Mammoth Mining Bag
	[44511]=44447, -- Pattern: Dragonscale Ammo Pouch
	[44512]=44448, -- Pattern: Nerubian Reinforced Quiver
	[44513]=43260, -- Pattern: Eviscerator's Facemask
	[44514]=43433, -- Pattern: Eviscerator's Shoulderpads
	[44515]=43434, -- Pattern: Eviscerator's Chestguard
	[44516]=43435, -- Pattern: Eviscerator's Bindings
	[44517]=43436, -- Pattern: Eviscerator's Gauntlets
	[44518]=43437, -- Pattern: Eviscerator's Waistguard
	[44519]=43438, -- Pattern: Eviscerator's Legguards
	[44520]=43439, -- Pattern: Eviscerator's Treads
	[44521]=43261, -- Pattern: Overcast Headguard
	[44522]=43262, -- Pattern: Overcast Spaulders
	[44523]=43263, -- Pattern: Overcast Chestguard
	[44524]=43264, -- Pattern: Overcast Bracers
	[44525]=43265, -- Pattern: Overcast Handwraps
	[44526]=43266, -- Pattern: Overcast Belt
	[44527]=43271, -- Pattern: Overcast Leggings
	[44528]=43273, -- Pattern: Overcast Boots
	[44530]=43447, -- Pattern: Swiftarrow Helm
	[44531]=43449, -- Pattern: Swiftarrow Shoulderguards
	[44532]=43445, -- Pattern: Swiftarrow Hauberk
	[44533]=43444, -- Pattern: Swiftarrow Bracers
	[44534]=43446, -- Pattern: Swiftarrow Gauntlets
	[44535]=43442, -- Pattern: Swiftarrow Belt
	[44536]=43448, -- Pattern: Swiftarrow Leggings
	[44537]=43443, -- Pattern: Swiftarrow Boots
	[44538]=43455, -- Pattern: Stormhide Crown
	[44539]=43457, -- Pattern: Stormhide Shoulders
	[44540]=43453, -- Pattern: Stormhide Hauberk
	[44541]=43452, -- Pattern: Stormhide Wristguards
	[44542]=43454, -- Pattern: Stormhide Grips
	[44543]=43450, -- Pattern: Stormhide Belt
	[44544]=43456, -- Pattern: Stormhide Legguards
	[44545]=43451, -- Pattern: Stormhide Stompers
	[44546]=43458, -- Pattern: Giantmaim Legguards
	[44547]=43459, -- Pattern: Giantmaim Bracers
	[44548]=43461, -- Pattern: Revenant's Breastplate
	[44549]=43469, -- Pattern: Revenant's Treads
	[44550]=43481, -- Pattern: Trollwoven Spaulders
	[44551]=43484, -- Pattern: Trollwoven Girdle
	[44552]=43495, -- Pattern: Earthgiving Legguards
	[44553]=43502, -- Pattern: Earthgiving Boots
	[44564]=40213, -- Recipe: Mighty Arcane Protection Potion
	[44565]=40214, -- Recipe: Mighty Fire Protection Potion
	[44566]=40215, -- Recipe: Mighty Frost Protection Potion
	[44567]=40216, -- Recipe: Mighty Nature Protection Potion
	[44568]=40217, -- Recipe: Mighty Shadow Protection Potion
	[44584]=43590, -- Pattern: Polar Vest
	[44585]=43591, -- Pattern: Polar Cord
	[44586]=43592, -- Pattern: Polar Boots
	[44587]=43593, -- Pattern: Icy Scale Chestguard
	[44588]=43594, -- Pattern: Icy Scale Belt
	[44589]=43595, -- Pattern: Icy Scale Boots
	[44858]=44840, -- Recipe: Cranberry Chutney
	[44859]=44839, -- Recipe: Candied Sweet Potato
	[44860]=44837, -- Recipe: Spice Bread Stuffing
	[44861]=44838, -- Recipe: Slow-Roasted Turkey
	[44862]=44836, -- Recipe: Pumpkin Pie
	[44916]=21154, -- Pattern: Festival Dress
	[44917]=21542, -- Pattern: Festival Suit
	[44918]=21570, -- Schematic: Cluster Launcher
	[44919]=21569, -- Schematic: Firework Launcher
	[44932]=44930, -- Pattern: Windripper Boots
	[44933]=44931, -- Pattern: Windripper Leggings
	[44937]=44936, -- Plans: Titanium Plating
	[44938]=44936, -- Plans: Titanium Plating
	[44954]=44953, -- Recipe: Worg Tartare
	[44977]=5478, -- Recipe: Dig Rat Stew
	[45088]=45550, -- Plans: Belt of the Titans
	[45089]=45559, -- Plans: Battlelord's Plate Boots
	[45090]=45552, -- Plans: Plate Girdle of Righteousness
	[45091]=45561, -- Plans: Treads of Destiny
	[45092]=45551, -- Plans: Indestructible Plate Girdle
	[45093]=45560, -- Plans: Spiked Deathdealers
	[45094]=45553, -- Pattern: Belt of Dragons
	[45095]=45562, -- Pattern: Boots of Living Scale
	[45096]=45554, -- Pattern: Blue Belt of Chaos
	[45097]=45563, -- Pattern: Lightning Grounded Boots
	[45098]=45555, -- Pattern: Death-warmed Belt
	[45099]=45564, -- Pattern: Footpads of Silence
	[45100]=45556, -- Pattern: Belt of Arctic Life
	[45101]=45565, -- Pattern: Boots of Wintry Endurance
	[45102]=45557, -- Pattern: Sash of Ancient Power
	[45103]=45566, -- Pattern: Spellslinger's Slippers
	[45104]=45558, -- Pattern: Cord of the White Dawn
	[45105]=45567, -- Pattern: Savior's Slippers
	[45774]=45773, -- Pattern: Emerald Bag
	[46710]=46691, -- Recipe: Bread of the Dead
	[46803]=44837, -- Recipe: Spice Bread Stuffing
	[46804]=44836, -- Recipe: Pumpkin Pie
	[46805]=44840, -- Recipe: Cranberry Chutney
	[46806]=44839, -- Recipe: Candied Sweet Potato
	[46807]=44838, -- Recipe: Slow-Roasted Turkey
	[46897]=40167, -- Design: Enduring Eye of Zul
	[46898]=40168, -- Design: Steady Eye of Zul
	[46899]=40166, -- Design: Vivid Eye of Zul
	[46900]=40175, -- Design: Dazzling Eye of Zul
	[46901]=40165, -- Design: Jagged Eye of Zul
	[46902]=40164, -- Design: Timeless Eye of Zul
	[46903]=40170, -- Design: Seer's Eye of Zul
	[46904]=40169, -- Design: Forceful Eye of Zul
	[46905]=40171, -- Design: Misty Eye of Zul
	[46906]=40176, -- Design: Sundered Eye of Zul
	[46907]=40172, -- Design: Shining Eye of Zul
	[46908]=40181, -- Design: Tense Eye of Zul
	[46909]=40177, -- Design: Lambent Eye of Zul
	[46910]=40174, -- Design: Intricate Eye of Zul
	[46911]=40180, -- Design: Radiant Eye of Zul
	[46912]=40179, -- Design: Energized Eye of Zul
	[46913]=40182, -- Design: Shattered Eye of Zul
	[46914]=40178, -- Design: Opaque Eye of Zul
	[46915]=40173, -- Design: Turbid Eye of Zul
	[46916]=40113, -- Design: Runed Cardinal Ruby
	[46917]=40111, -- Design: Bold Cardinal Ruby
	[46918]=40112, -- Design: Delicate Cardinal Ruby
	[46919]=40114, -- Design: Bright Cardinal Ruby
	[46920]=40118, -- Design: Precise Cardinal Ruby
	[46921]=40117, -- Design: Fractured Cardinal Ruby
	[46922]=40115, -- Design: Subtle Cardinal Ruby
	[46923]=40116, -- Design: Flashing Cardinal Ruby
	[46924]=40119, -- Design: Solid Majestic Zircon
	[46925]=40120, -- Design: Sparkling Majestic Zircon
	[46926]=40122, -- Design: Stormy Majestic Zircon
	[46927]=40121, -- Design: Lustrous Majestic Zircon
	[46928]=40125, -- Design: Rigid King's Amber
	[46929]=40124, -- Design: Smooth King's Amber
	[46930]=40123, -- Design: Brilliant King's Amber
	[46931]=40126, -- Design: Thick King's Amber
	[46932]=40127, -- Design: Mystic King's Amber
	[46933]=40128, -- Design: Quick King's Amber
	[46934]=40136, -- Design: Balanced Dreadstone
	[46935]=40129, -- Design: Sovereign Dreadstone
	[46936]=40132, -- Design: Glowing Dreadstone
	[46937]=40133, -- Design: Purified Dreadstone
	[46938]=40130, -- Design: Shifting Dreadstone
	[46939]=40134, -- Design: Royal Dreadstone
	[46940]=40138, -- Design: Regal Dreadstone
	[46941]=40139, -- Design: Defender's Dreadstone
	[46942]=40141, -- Design: Guardian's Dreadstone
	[46943]=40135, -- Design: Mysterious Dreadstone
	[46944]=40140, -- Design: Puissant Dreadstone
	[46945]=40137, -- Design: Infused Dreadstone
	[46946]=40131, -- Design: Tenuous Dreadstone
	[46947]=40151, -- Design: Luminous Ametrine
	[46948]=40142, -- Design: Inscribed Ametrine
	[46949]=40147, -- Design: Deadly Ametrine
	[46950]=40152, -- Design: Potent Ametrine
	[46951]=40153, -- Design: Veiled Ametrine
	[46952]=40154, -- Design: Durable Ametrine
	[46953]=40143, -- Design: Etched Ametrine
	[46956]=40157, -- Design: Pristine Ametrine
	[47007]=40155, -- Design: Reckless Ametrine
	[47008]=40148, -- Design: Glinting Ametrine
	[47010]=40162, -- Design: Accurate Ametrine
	[47011]=40156, -- Design: Wicked Ametrine
	[47012]=40161, -- Design: Glimmering Ametrine
	[47015]=40144, -- Design: Champion's Ametrine
	[47016]=40158, -- Design: Empowered Ametrine
	[47017]=40160, -- Design: Stalwart Ametrine
	[47018]=40145, -- Design: Resplendent Ametrine
	[47019]=40146, -- Design: Fierce Ametrine
	[47020]=40150, -- Design: Deft Ametrine
	[47021]=40149, -- Design: Lucent Ametrine
	[47022]=40163, -- Design: Resolute Ametrine
	[47023]=40159, -- Design: Stark Ametrine
	[47622]=47592, -- Plans: Breastplate of the White Knight
	[47623]=47571, -- Plans: Saronite Swordbreakers
	[47624]=47590, -- Plans: Titanium Razorplate
	[47625]=47573, -- Plans: Titanium Spikeguards
	[47626]=47594, -- Plans: Sunforged Breastplate
	[47627]=47575, -- Plans: Sunforged Bracers
	[47628]=47598, -- Pattern: Ensorcelled Nerubian Breastplate
	[47629]=47580, -- Pattern: Black Chitin Bracers
	[47630]=47596, -- Pattern: Crusader's Dragonscale Breastplate
	[47631]=47577, -- Pattern: Crusader's Dragonscale Bracers
	[47632]=47602, -- Pattern: Lunar Eclipse Robes
	[47633]=47584, -- Pattern: Moonshadow Armguards
	[47634]=47600, -- Pattern: Knightbane Carapace
	[47635]=47582, -- Pattern: Bracers of Swift Death
	[47636]=47606, -- Pattern: Royal Moonshroud Robe
	[47637]=47588, -- Pattern: Royal Moonshroud Bracers
	[47638]=47604, -- Pattern: Merlin's Robe
	[47639]=47586, -- Pattern: Bejeweled Wizard's Bracers
	[47640]=47592, -- Plans: Breastplate of the White Knight
	[47641]=47571, -- Plans: Saronite Swordbreakers
	[47642]=47575, -- Plans: Sunforged Bracers
	[47643]=47594, -- Plans: Sunforged Breastplate
	[47644]=47590, -- Plans: Titanium Razorplate
	[47645]=47573, -- Plans: Titanium Spikeguards
	[47646]=47580, -- Pattern: Black Chitin Bracers
	[47647]=47582, -- Pattern: Bracers of Swift Death
	[47648]=47577, -- Pattern: Crusader's Dragonscale Bracers
	[47649]=47596, -- Pattern: Crusader's Dragonscale Breastplate
	[47650]=47598, -- Pattern: Ensorcelled Nerubian Breastplate
	[47651]=47600, -- Pattern: Knightbane Carapace
	[47652]=47602, -- Pattern: Lunar Eclipse Robes
	[47653]=47584, -- Pattern: Moonshadow Armguards
	[47654]=47586, -- Pattern: Bejeweled Wizard's Bracers
	[47655]=47604, -- Pattern: Merlin's Robe
	[47656]=47588, -- Pattern: Royal Moonshroud Bracers
	[47657]=47606, -- Pattern: Royal Moonshroud Robe
	[49050]=49040, -- Schematic: Jeeves
	[49112]=49110, -- Design: Nightmare Tear
	[49953]=49891, -- Pattern: Leggings of Woven Death
	[49954]=49890, -- Pattern: Deathfrost Boots
	[49955]=49892, -- Pattern: Lightweave Leggings
	[49956]=49893, -- Pattern: Sandals of Consecration
	[49957]=49898, -- Pattern: Legwraps of Unleashed Nature
	[49958]=49894, -- Pattern: Blessed Cenarion Boots
	[49959]=49899, -- Pattern: Bladeborn Leggings
	[49961]=49895, -- Pattern: Footpads of Impending Death
	[49962]=49900, -- Pattern: Lightning-Infused Leggings
	[49963]=49896, -- Pattern: Earthsoul Boots
	[49965]=49901, -- Pattern: Draconic Bonesplinter Legguards
	[49966]=49897, -- Pattern: Rock-Steady Treads
	[49969]=49902, -- Plans: Puresteel Legplates
	[49970]=49905, -- Plans: Protectors of Life
	[49971]=49903, -- Plans: Legplates of Painful Death
	[49972]=49906, -- Plans: Hellfrozen Bonegrinders
	[49973]=49904, -- Plans: Pillars of Might
	[49974]=49907, -- Plans: Boots of Kingly Upheaval
	[52022]=52020, -- Plans: Shatter Rounds
	[52023]=52021, -- Plans: Iceblade Arrow
})

-- how many items are crafted at a time (on average) by a recipe
Informant.SetCraftCount({
	[728]=5, -- Recipe: Westfall Stew
	[2701]=3, -- Recipe: Seasoned Wolf Kabob
	[3679]=2, -- Recipe: Blood Sausage
	[5484]=2, -- Recipe: Roasted Kodo Meat
	[5485]=2, -- Recipe: Fillet of Frenzy
	[5486]=2, -- Recipe: Strider Stew
	[5487]=2, -- Recipe: Dig Rat Stew
	[5488]=2, -- Recipe: Crispy Lizard Tail
	[5489]=2, -- Recipe: Lean Venison
	[6716]=2, -- Schematic: EZ-Thro Dynamite
	[12231]=2, -- Recipe: Jungle Stew
	[12240]=2, -- Recipe: Heavy Kodo Stew
	[13518]=2, -- Recipe: Potion of Petrification
	[13519]=2, -- Recipe: Flask of the Titans
	[13520]=2, -- Recipe: Flask of Distilled Wisdom
	[13521]=2, -- Recipe: Flask of Supreme Power
	[13522]=2, -- Recipe: Flask of Chromatic Resistance
	[16041]=3, -- Schematic: Thorium Grenade
	[16049]=3, -- Schematic: Dark Iron Bomb
	[16051]=200, -- Schematic: Thorium Shells
	[16055]=3, -- Schematic: Arcane Bomb
	[16767]=2, -- Recipe: Undermine Clam Chowder
	[18647]=3, -- Schematic: Red Firework
	[18648]=3, -- Schematic: Green Firework
	[18649]=3, -- Schematic: Blue Firework
	[18654]=2, -- Schematic: Gnomish Alarm-o-Bot
	[19027]=4, -- Schematic: Snake Burst Firework
	[21025]=5, -- Recipe: Dirge's Kickin' Chimaerok Chops
	[21724]=3, -- Schematic: Small Blue Rocket
	[21725]=3, -- Schematic: Small Green Rocket
	[21726]=3, -- Schematic: Small Red Rocket
	[21727]=3, -- Schematic: Large Blue Rocket
	[21728]=3, -- Schematic: Large Green Rocket
	[21729]=3, -- Schematic: Large Red Rocket
	[21730]=3, -- Schematic: Blue Rocket Cluster
	[21731]=3, -- Schematic: Green Rocket Cluster
	[21732]=3, -- Schematic: Red Rocket Cluster
	[21733]=3, -- Schematic: Large Blue Rocket Cluster
	[21734]=3, -- Schematic: Large Green Rocket Cluster
	[21735]=3, -- Schematic: Large Red Rocket Cluster
	[21737]=2, -- Schematic: Cluster Launcher
	[22920]=5, -- Recipe: Major Fire Protection Potion
	[22921]=5, -- Recipe: Major Frost Protection Potion
	[22922]=5, -- Recipe: Major Nature Protection Potion
	[22923]=5, -- Recipe: Major Arcane Protection Potion
	[22924]=5, -- Recipe: Major Shadow Protection Potion
	[22925]=5, -- Recipe: Major Holy Protection Potion
	[23811]=3, -- Schematic: White Smoke Flare
	[23814]=3, -- Schematic: Green Smoke Flare
	[23874]=2, -- Schematic: Elemental Seaforium Charge
	[23883]=20, -- Schematic: Healing Potion Injector
	[23884]=20, -- Schematic: Mana Potion Injector
	[25887]=3, -- Schematic: Purple Smoke Flare
	[31354]=2, -- Recipe: Flask of the Titans
	[31355]=2, -- Recipe: Flask of Supreme Power
	[31356]=2, -- Recipe: Flask of Distilled Wisdom
	[31357]=2, -- Recipe: Flask of Chromatic Resistance
	[32381]=5, -- Schematic: Fused Wiring
	[33209]=2, -- Recipe: Flask of Chromatic Wonder
	[34114]=5, -- Schematic: Field Repair Bot 110G
	[34413]=2, -- Recipe: Hot Apple Cider
	[34834]=5, -- Recipe: Captain Rumsey's Lager
	[35310]=20, -- Schematic: Healing Potion Injector
	[35311]=20, -- Schematic: Mana Potion Injector
	[39644]=5, -- Recipe: Kungaloosh
	[43029]=4, -- Recipe: Critter Bites
	[43507]=5, -- Recipe: Tasty Cupcake
	[43508]=5, -- Recipe: Last Week's Mammoth
	[43509]=5, -- Recipe: Bad Clams
	[43510]=5, -- Recipe: Haunted Herring
	[44918]=2, -- Schematic: Cluster Launcher
	[44977]=2, -- Recipe: Dig Rat Stew
	[52022]=1000, -- Plans: Shatter Rounds
	[52023]=1000, -- Plans: Iceblade Arrow
})

-- A list of items with skill or other requirements
Informant.SetRequirements({
	[118]="171:1",
	[724]="185:50",
	[733]="185:50",
	[787]="185:1",
	[858]="171:55",
	[929]="171:110",
	[954]="773:15",
	[955]="773:1",
	[1017]="185:100",
	[1082]="185:100",
	[1113]="237:0",
	[1114]="237:0",
	[1180]="773:1",
	[1181]="773:1",
	[1251]="129:1",
	[1477]="773:85",
	[1487]="237:0",
	[1710]="171:155",
	[1711]="773:75",
	[1712]="773:75",
	[2136]="237:0",
	[2288]="237:0",
	[2289]="773:80",
	[2290]="773:75",
	[2300]="165:40",
	[2302]="165:1",
	[2303]="165:15",
	[2304]="165:1",
	[2307]="165:90",
	[2308]="165:85",
	[2309]="165:55",
	[2310]="165:60",
	[2311]="165:60",
	[2312]="165:75",
	[2313]="165:100",
	[2314]="165:120",
	[2315]="165:100",
	[2316]="165:110",
	[2317]="165:100",
	[2318]="165:1",
	[2319]="165:100",
	[2454]="171:1",
	[2455]="171:25",
	[2456]="171:40",
	[2457]="171:50",
	[2458]="171:50",
	[2459]="171:60",
	[2568]="197:10",
	[2569]="197:65",
	[2570]="197:1",
	[2572]="197:40",
	[2575]="197:40",
	[2576]="197:1",
	[2577]="197:40",
	[2578]="197:70",
	[2579]="197:70",
	[2580]="197:60",
	[2581]="129:40",
	[2582]="197:85",
	[2583]="197:95",
	[2584]="197:75",
	[2585]="197:105",
	[2587]="197:100",
	[2679]="185:1",
	[2680]="185:10",
	[2681]="185:1",
	[2682]="185:85",
	[2683]="185:75",
	[2684]="185:50",
	[2685]="185:110",
	[2687]="185:80",
	[2840]="186:1",
	[2841]="186:65",
	[2842]="186:75",
	[2844]="164:15",
	[2845]="164:20",
	[2847]="164:25",
	[2848]="164:110",
	[2849]="164:115",
	[2850]="164:120",
	[2851]="164:35",
	[2852]="164:1",
	[2853]="164:1",
	[2854]="164:90",
	[2857]="164:70",
	[2862]="164:1",
	[2863]="164:65",
	[2864]="164:80",
	[2865]="164:105",
	[2866]="164:105",
	[2868]="164:120",
	[2869]="164:130",
	[2870]="164:145",
	[2871]="164:125",
	[2888]="185:10",
	[2996]="197:1",
	[2997]="197:75",
	[3012]="773:15",
	[3220]="185:60",
	[3239]="164:1",
	[3240]="164:65",
	[3241]="164:125",
	[3382]="171:15",
	[3383]="171:90",
	[3384]="171:110",
	[3385]="171:120",
	[3386]="171:120",
	[3387]="171:250",
	[3388]="171:125",
	[3389]="171:130",
	[3390]="171:140",
	[3391]="171:150",
	[3469]="164:20",
	[3470]="164:25",
	[3471]="164:35",
	[3472]="164:40",
	[3473]="164:45",
	[3474]="164:60",
	[3478]="164:75",
	[3480]="164:110",
	[3481]="164:125",
	[3482]="164:130",
	[3483]="164:135",
	[3484]="164:145",
	[3485]="164:150",
	[3486]="164:125",
	[3487]="164:95",
	[3488]="164:35",
	[3489]="164:70",
	[3490]="164:125",
	[3491]="164:130",
	[3492]="164:145",
	[3530]="129:80",
	[3531]="129:115",
	[3575]="186:125",
	[3576]="186:65",
	[3577]="186:155",
	[3662]="185:80",
	[3663]="185:90",
	[3664]="185:120",
	[3665]="185:130",
	[3666]="185:110",
	[3719]="165:150",
	[3726]="185:110",
	[3727]="185:125",
	[3728]="185:150",
	[3729]="185:175",
	[3772]="237:0",
	[3823]="171:165",
	[3824]="171:165",
	[3825]="171:175",
	[3826]="171:180",
	[3827]="171:160",
	[3828]="171:195",
	[3829]="171:200",
	[3835]="164:165",
	[3836]="164:170",
	[3837]="164:190",
	[3840]="164:160",
	[3841]="164:175",
	[3842]="164:155",
	[3843]="164:170",
	[3844]="164:180",
	[3845]="164:195",
	[3846]="164:185",
	[3847]="164:200",
	[3848]="164:105",
	[3849]="164:160",
	[3850]="164:175",
	[3851]="164:155",
	[3852]="164:170",
	[3853]="164:180",
	[3854]="164:200",
	[3855]="164:185",
	[3856]="164:200",
	[3859]="186:165",
	[3860]="186:175",
	[3928]="171:215",
	[4231]="165:35",
	[4233]="165:100",
	[4234]="165:150",
	[4236]="165:150",
	[4237]="165:25",
	[4238]="197:45",
	[4239]="165:55",
	[4240]="197:80",
	[4241]="197:95",
	[4242]="165:75",
	[4243]="165:85",
	[4244]="165:100",
	[4245]="197:150",
	[4246]="165:80",
	[4247]="165:145",
	[4248]="165:120",
	[4249]="165:125",
	[4250]="165:120",
	[4251]="165:130",
	[4252]="165:140",
	[4253]="165:135",
	[4254]="165:150",
	[4255]="165:155",
	[4256]="165:175",
	[4257]="165:160",
	[4258]="165:170",
	[4259]="165:180",
	[4260]="165:195",
	[4262]="165:185",
	[4264]="165:200",
	[4265]="165:150",
	[4304]="165:200",
	[4305]="197:125",
	[4307]="197:35",
	[4308]="197:60",
	[4309]="197:70",
	[4310]="197:85",
	[4311]="197:100",
	[4312]="197:80",
	[4313]="197:95",
	[4314]="197:110",
	[4315]="197:120",
	[4316]="197:110",
	[4317]="197:125",
	[4318]="197:130",
	[4319]="197:145",
	[4320]="197:125",
	[4321]="197:140",
	[4322]="197:165",
	[4323]="197:170",
	[4324]="197:150",
	[4325]="197:175",
	[4326]="197:185",
	[4327]="197:200",
	[4328]="197:180",
	[4329]="197:200",
	[4330]="197:110",
	[4331]="197:125",
	[4332]="197:135",
	[4333]="197:155",
	[4334]="197:170",
	[4335]="197:185",
	[4336]="197:200",
	[4339]="197:175",
	[4343]="197:30",
	[4344]="197:1",
	[4357]="202:1",
	[4358]="202:1",
	[4359]="202:30",
	[4360]="202:30",
	[4361]="202:50",
	[4362]="202:50",
	[4363]="202:65",
	[4364]="202:75",
	[4365]="202:75",
	[4366]="202:85",
	[4367]="202:100",
	[4368]="202:100",
	[4369]="202:105",
	[4370]="202:105",
	[4371]="202:105",
	[4372]="202:120",
	[4373]="202:120",
	[4374]="202:120",
	[4375]="202:125",
	[4376]="202:125",
	[4377]="202:125",
	[4378]="202:125",
	[4379]="202:130",
	[4380]="202:140",
	[4381]="202:140",
	[4382]="202:145",
	[4383]="202:145",
	[4384]="202:150",
	[4385]="202:150",
	[4386]="202:155",
	[4387]="202:160",
	[4388]="202:160",
	[4389]="202:170",
	[4390]="202:175",
	[4391]="202:175",
	[4392]="202:185",
	[4393]="202:185",
	[4394]="202:190",
	[4395]="202:195",
	[4396]="202:200",
	[4397]="202:200",
	[4398]="202:200",
	[4401]="202:75",
	[4403]="202:165",
	[4404]="202:90",
	[4405]="202:60",
	[4406]="202:110",
	[4407]="202:180",
	[4419]="773:165",
	[4422]="773:155",
	[4424]="773:160",
	[4425]="773:175",
	[4426]="773:170",
	[4455]="165:165",
	[4456]="165:165",
	[4457]="185:175",
	[4592]="185:50",
	[4593]="185:100",
	[4594]="185:175",
	[4596]="171:50",
	[4623]="171:215",
	[4852]="202:185",
	[5081]="165:40",
	[5095]="185:50",
	[5232]="354:0",
	[5349]="237:0",
	[5350]="237:0",
	[5472]="185:10",
	[5473]="185:20",
	[5474]="185:35",
	[5476]="185:50",
	[5477]="185:50",
	[5478]="185:90",
	[5479]="185:100",
	[5480]="185:110",
	[5507]="202:135",
	[5513]="237:0",
	[5514]="237:0",
	[5525]="185:50",
	[5526]="185:90",
	[5527]="185:125",
	[5540]="164:110",
	[5541]="164:140",
	[5542]="197:90",
	[5631]="171:60",
	[5633]="171:175",
	[5634]="171:150",
	[5739]="165:190",
	[5762]="197:70",
	[5763]="197:115",
	[5764]="197:175",
	[5765]="197:185",
	[5766]="197:135",
	[5770]="197:150",
	[5780]="165:90",
	[5781]="165:95",
	[5782]="165:170",
	[5783]="165:190",
	[5957]="165:1",
	[5958]="165:105",
	[5961]="165:115",
	[5962]="165:160",
	[5963]="165:170",
	[5964]="165:175",
	[5965]="165:185",
	[5966]="165:190",
	[5996]="171:90",
	[5997]="171:1",
	[6037]="171:225",
	[6038]="185:175",
	[6040]="164:185",
	[6041]="164:190",
	[6042]="164:150",
	[6043]="164:165",
	[6048]="171:135",
	[6049]="171:165",
	[6050]="171:190",
	[6051]="171:100",
	[6052]="171:190",
	[6149]="171:205",
	[6214]="164:65",
	[6218]="333:1",
	[6219]="202:50",
	[6238]="197:30",
	[6239]="197:55",
	[6240]="197:55",
	[6241]="197:30",
	[6242]="197:70",
	[6263]="197:100",
	[6264]="197:115",
	[6290]="185:1",
	[6316]="185:50",
	[6338]="164:100",
	[6339]="333:100",
	[6350]="164:95",
	[6370]="171:80",
	[6371]="171:130",
	[6372]="171:100",
	[6373]="171:140",
	[6384]="197:120",
	[6385]="197:120",
	[6450]="129:150",
	[6451]="129:180",
	[6452]="129:80",
	[6453]="129:130",
	[6466]="165:90",
	[6467]="165:105",
	[6468]="165:115",
	[6533]="202:150",
	[6657]="185:85",
	[6662]="171:90",
	[6709]="165:90",
	[6712]="202:100",
	[6714]="202:100",
	[6731]="164:100",
	[6786]="197:40",
	[6787]="197:110",
	[6795]="197:160",
	[6796]="197:175",
	[6836]="197:250",
	[6887]="185:225",
	[6888]="185:1",
	[6890]="185:40",
	[7026]="197:15",
	[7046]="197:140",
	[7047]="197:145",
	[7048]="197:145",
	[7049]="197:150",
	[7050]="197:160",
	[7051]="197:170",
	[7052]="197:175",
	[7053]="197:175",
	[7054]="197:190",
	[7055]="197:175",
	[7056]="197:180",
	[7057]="197:180",
	[7058]="197:185",
	[7059]="197:190",
	[7060]="197:190",
	[7061]="197:195",
	[7062]="197:195",
	[7063]="197:205",
	[7064]="197:210",
	[7065]="197:165",
	[7068]="171:300",
	[7071]="164:150",
	[7076]="171:275",
	[7078]="171:275",
	[7080]="171:275",
	[7082]="171:275",
	[7148]="202:165",
	[7166]="164:30",
	[7189]="202:225",
	[7191]="202:275",
	[7276]="165:1",
	[7277]="165:1",
	[7278]="165:30",
	[7279]="165:30",
	[7280]="165:35",
	[7281]="165:70",
	[7282]="165:95",
	[7283]="165:100",
	[7284]="165:120",
	[7285]="165:120",
	[7348]="165:125",
	[7349]="165:135",
	[7352]="165:135",
	[7358]="165:140",
	[7359]="165:145",
	[7371]="165:150",
	[7372]="165:150",
	[7373]="165:165",
	[7374]="165:175",
	[7375]="165:175",
	[7377]="165:180",
	[7378]="165:185",
	[7386]="165:190",
	[7387]="165:195",
	[7390]="165:200",
	[7391]="165:200",
	[7506]="202:125",
	[7676]="185:60",
	[7913]="164:160",
	[7914]="164:160",
	[7915]="164:175",
	[7916]="164:180",
	[7917]="164:185",
	[7918]="164:205",
	[7919]="164:205",
	[7920]="164:210",
	[7921]="164:210",
	[7922]="164:215",
	[7924]="164:215",
	[7926]="164:220",
	[7927]="164:220",
	[7928]="164:225",
	[7929]="164:0",
	[7930]="164:230",
	[7931]="164:230",
	[7932]="164:235",
	[7933]="164:235",
	[7934]="164:245",
	[7935]="164:0",
	[7936]="164:0",
	[7937]="164:0",
	[7938]="164:0",
	[7939]="164:0",
	[7941]="164:210",
	[7942]="164:220",
	[7943]="164:225",
	[7944]="164:240",
	[7945]="164:230",
	[7946]="164:245",
	[7947]="164:255",
	[7954]="164:0",
	[7955]="164:30",
	[7956]="164:125",
	[7957]="164:130",
	[7958]="164:135",
	[7959]="164:0",
	[7960]="164:0",
	[7961]="164:0",
	[7963]="164:200",
	[7964]="164:200",
	[7965]="164:200",
	[7966]="164:200",
	[7967]="164:215",
	[7969]="164:235",
	[8007]="237:0",
	[8008]="237:0",
	[8067]="202:1",
	[8068]="202:75",
	[8069]="202:125",
	[8075]="237:0",
	[8076]="237:0",
	[8077]="237:0",
	[8078]="237:0",
	[8079]="237:0",
	[8170]="165:250",
	[8172]="165:200",
	[8173]="165:200",
	[8174]="165:200",
	[8175]="165:205",
	[8176]="165:205",
	[8185]="165:235",
	[8187]="165:205",
	[8189]="165:210",
	[8191]="165:230",
	[8192]="165:210",
	[8193]="165:230",
	[8197]="165:235",
	[8198]="165:210",
	[8200]="165:215",
	[8201]="165:220",
	[8202]="165:240",
	[8203]="165:220",
	[8204]="165:225",
	[8205]="165:220",
	[8206]="165:245",
	[8207]="165:240",
	[8208]="165:250",
	[8209]="165:235",
	[8210]="165:220",
	[8211]="165:225",
	[8212]="165:250",
	[8213]="165:245",
	[8214]="165:225",
	[8215]="165:250",
	[8216]="165:240",
	[8217]="165:225",
	[8218]="165:225",
	[8345]="165:0",
	[8346]="165:0",
	[8347]="165:0",
	[8348]="165:0",
	[8349]="165:0",
	[8364]="185:175",
	[8367]="165:0",
	[8544]="129:210",
	[8545]="129:240",
	[8827]="171:400",
	[8949]="171:185",
	[8951]="171:195",
	[8956]="171:205",
	[9030]="171:210",
	[9036]="171:210",
	[9060]="164:200",
	[9061]="171:210",
	[9088]="171:240",
	[9144]="171:225",
	[9149]="171:225",
	[9154]="171:230",
	[9155]="171:235",
	[9172]="171:235",
	[9179]="171:235",
	[9187]="171:240",
	[9197]="171:240",
	[9206]="171:245",
	[9210]="171:245",
	[9224]="171:250",
	[9233]="171:250",
	[9264]="171:250",
	[9312]="202:150",
	[9313]="202:150",
	[9318]="202:150",
	[9366]="164:205",
	[9998]="197:205",
	[9999]="197:205",
	[10001]="197:210",
	[10002]="197:210",
	[10003]="197:215",
	[10004]="197:215",
	[10007]="197:215",
	[10008]="197:215",
	[10009]="197:215",
	[10018]="197:225",
	[10019]="197:225",
	[10021]="197:225",
	[10023]="197:225",
	[10024]="197:230",
	[10025]="197:245",
	[10026]="197:230",
	[10027]="197:230",
	[10028]="197:235",
	[10029]="197:235",
	[10030]="197:240",
	[10031]="197:240",
	[10033]="197:240",
	[10034]="197:240",
	[10035]="197:245",
	[10036]="197:250",
	[10040]="197:250",
	[10041]="197:250",
	[10042]="197:225",
	[10044]="197:245",
	[10045]="197:1",
	[10046]="197:20",
	[10047]="197:75",
	[10048]="197:120",
	[10050]="197:225",
	[10051]="197:235",
	[10052]="197:220",
	[10053]="197:235",
	[10054]="197:230",
	[10055]="197:235",
	[10056]="197:215",
	[10306]="773:210",
	[10307]="773:205",
	[10308]="773:215",
	[10309]="773:225",
	[10310]="773:220",
	[10421]="164:1",
	[10423]="164:155",
	[10498]="202:175",
	[10499]="202:175",
	[10500]="202:205",
	[10501]="202:220",
	[10502]="202:225",
	[10503]="202:230",
	[10504]="202:245",
	[10505]="202:175",
	[10506]="202:230",
	[10507]="202:175",
	[10508]="202:205",
	[10510]="202:220",
	[10512]="202:210",
	[10513]="202:245",
	[10514]="202:215",
	[10518]="202:225",
	[10542]="202:205",
	[10543]="202:205",
	[10545]="202:210",
	[10546]="202:210",
	[10548]="202:240",
	[10558]="202:150",
	[10559]="202:195",
	[10560]="202:200",
	[10561]="202:215",
	[10562]="202:235",
	[10576]="202:250",
	[10577]="202:205",
	[10586]="202:235",
	[10587]="202:230",
	[10588]="202:245",
	[10592]="171:200",
	[10644]="202:205",
	[10645]="202:240",
	[10646]="202:205",
	[10713]="202:205",
	[10716]="202:205",
	[10720]="202:210",
	[10721]="202:215",
	[10724]="202:225",
	[10725]="202:230",
	[10726]="202:235",
	[10727]="202:240",
	[10841]="185:175",
	[11128]="164:150",
	[11130]="333:150",
	[11144]="164:200",
	[11145]="333:200",
	[11287]="333:10",
	[11288]="333:70",
	[11289]="333:155",
	[11290]="333:175",
	[11371]="186:230",
	[11590]="202:200",
	[11604]="164:285",
	[11605]="164:280",
	[11606]="164:270",
	[11607]="164:275",
	[11608]="164:265",
	[11811]="333:265",
	[11825]="202:205",
	[11826]="202:205",
	[12190]="171:230",
	[12209]="185:125",
	[12210]="185:175",
	[12212]="185:175",
	[12213]="185:175",
	[12214]="185:175",
	[12215]="185:200",
	[12216]="185:225",
	[12217]="185:200",
	[12218]="185:225",
	[12224]="185:1",
	[12259]="164:180",
	[12260]="164:190",
	[12359]="186:230",
	[12360]="171:275",
	[12404]="164:250",
	[12405]="164:250",
	[12406]="164:250",
	[12408]="164:255",
	[12409]="164:280",
	[12410]="164:280",
	[12414]="164:300",
	[12415]="164:270",
	[12416]="164:260",
	[12417]="164:295",
	[12418]="164:285",
	[12419]="164:290",
	[12420]="164:300",
	[12422]="164:300",
	[12424]="164:265",
	[12425]="164:270",
	[12426]="164:295",
	[12427]="164:295",
	[12428]="164:265",
	[12429]="164:300",
	[12610]="164:300",
	[12611]="164:300",
	[12612]="164:300",
	[12613]="164:300",
	[12614]="164:300",
	[12618]="164:300",
	[12619]="164:300",
	[12620]="164:300",
	[12624]="164:270",
	[12625]="164:290",
	[12628]="164:285",
	[12631]="164:290",
	[12632]="164:295",
	[12633]="164:300",
	[12636]="164:300",
	[12639]="164:300",
	[12640]="164:300",
	[12641]="164:300",
	[12643]="164:250",
	[12644]="164:250",
	[12645]="164:275",
	[12655]="333:250",
	[12773]="164:275",
	[12774]="164:275",
	[12775]="164:280",
	[12776]="164:280",
	[12777]="164:280",
	[12781]="164:285",
	[12782]="164:290",
	[12783]="164:300",
	[12784]="164:300",
	[12790]="164:300",
	[12792]="164:290",
	[12794]="164:300",
	[12796]="164:300",
	[12797]="164:300",
	[12798]="164:300",
	[12803]="171:275",
	[12808]="171:275",
	[12810]="333:250",
	[13423]="171:250",
	[13442]="171:255",
	[13443]="171:260",
	[13444]="171:295",
	[13445]="171:265",
	[13446]="171:275",
	[13447]="171:270",
	[13452]="171:280",
	[13453]="171:275",
	[13454]="171:285",
	[13455]="171:280",
	[13456]="171:290",
	[13457]="171:290",
	[13458]="171:290",
	[13459]="171:290",
	[13461]="171:290",
	[13462]="171:285",
	[13503]="171:350",
	[13506]="171:300",
	[13510]="171:300",
	[13511]="171:300",
	[13512]="171:300",
	[13513]="171:300",
	[13851]="185:175",
	[13856]="197:255",
	[13857]="197:260",
	[13858]="197:260",
	[13860]="197:265",
	[13863]="197:275",
	[13864]="197:280",
	[13865]="197:285",
	[13866]="197:295",
	[13867]="197:300",
	[13868]="197:255",
	[13869]="197:255",
	[13870]="197:265",
	[13871]="197:280",
	[13927]="185:225",
	[13928]="185:240",
	[13929]="185:240",
	[13930]="185:225",
	[13931]="185:250",
	[13932]="185:250",
	[13933]="185:275",
	[13934]="185:275",
	[13935]="185:275",
	[14042]="197:260",
	[14043]="197:270",
	[14044]="197:275",
	[14045]="197:280",
	[14046]="197:260",
	[14048]="197:250",
	[14100]="197:270",
	[14101]="197:270",
	[14103]="197:275",
	[14104]="197:290",
	[14106]="197:300",
	[14107]="197:275",
	[14108]="197:285",
	[14111]="197:290",
	[14112]="197:300",
	[14128]="197:300",
	[14130]="197:300",
	[14132]="197:275",
	[14134]="197:275",
	[14136]="197:285",
	[14137]="197:290",
	[14138]="197:300",
	[14139]="197:300",
	[14140]="197:300",
	[14141]="197:275",
	[14142]="197:270",
	[14143]="197:265",
	[14144]="197:290",
	[14146]="197:300",
	[14152]="197:300",
	[14153]="197:300",
	[14154]="197:300",
	[14155]="197:300",
	[14156]="197:300",
	[14342]="197:250",
	[14529]="129:260",
	[14530]="129:290",
	[15045]="165:260",
	[15046]="165:270",
	[15047]="165:300",
	[15048]="165:285",
	[15049]="165:295",
	[15050]="165:290",
	[15051]="165:300",
	[15052]="165:300",
	[15053]="165:285",
	[15054]="165:270",
	[15055]="165:300",
	[15056]="165:285",
	[15057]="165:275",
	[15058]="165:295",
	[15059]="165:300",
	[15060]="165:285",
	[15061]="165:270",
	[15062]="165:300",
	[15063]="165:290",
	[15064]="165:275",
	[15065]="165:285",
	[15066]="165:290",
	[15067]="165:270",
	[15068]="165:300",
	[15069]="165:285",
	[15070]="165:295",
	[15071]="165:275",
	[15072]="165:280",
	[15073]="165:275",
	[15074]="165:265",
	[15075]="165:290",
	[15076]="165:265",
	[15077]="165:255",
	[15078]="165:275",
	[15079]="165:285",
	[15080]="165:295",
	[15081]="165:300",
	[15082]="165:280",
	[15083]="165:260",
	[15084]="165:265",
	[15085]="165:300",
	[15086]="165:280",
	[15087]="165:290",
	[15088]="165:300",
	[15090]="165:300",
	[15091]="165:270",
	[15092]="165:275",
	[15093]="165:280",
	[15094]="165:290",
	[15095]="165:300",
	[15096]="165:300",
	[15138]="165:300",
	[15407]="165:250",
	[15564]="165:250",
	[15802]="197:290",
	[15846]="202:250",
	[15869]="164:100",
	[15870]="164:150",
	[15871]="164:200",
	[15872]="164:275",
	[15992]="202:250",
	[15993]="202:260",
	[15994]="202:260",
	[15995]="202:260",
	[15996]="202:265",
	[15997]="202:285",
	[15999]="202:270",
	[16000]="202:275",
	[16004]="202:275",
	[16005]="202:285",
	[16006]="202:285",
	[16007]="202:300",
	[16008]="202:290",
	[16009]="202:290",
	[16022]="202:300",
	[16023]="202:275",
	[16040]="202:300",
	[16206]="164:275",
	[16207]="333:290",
	[16766]="185:225",
	[16892]="354:0",
	[16893]="354:0",
	[16895]="354:0",
	[16896]="354:0",
	[16979]="197:300",
	[16980]="197:300",
	[16982]="165:295",
	[16983]="165:300",
	[16984]="165:300",
	[16988]="164:300",
	[16989]="164:295",
	[17013]="164:300",
	[17014]="164:295",
	[17015]="164:300",
	[17016]="164:300",
	[17193]="164:300",
	[17197]="185:1",
	[17198]="185:35",
	[17222]="185:200",
	[17704]="164:190",
	[17708]="171:190",
	[17716]="202:190",
	[17721]="165:190",
	[17723]="197:190",
	[17771]="186:300",
	[18045]="185:225",
	[18168]="202:300",
	[18232]="202:300",
	[18238]="165:200",
	[18251]="165:300",
	[18253]="171:300",
	[18254]="185:275",
	[18258]="197:275",
	[18262]="164:300",
	[18263]="197:300",
	[18282]="202:300",
	[18283]="202:300",
	[18294]="171:215",
	[18405]="197:300",
	[18407]="197:300",
	[18408]="197:300",
	[18409]="197:300",
	[18413]="197:300",
	[18486]="197:300",
	[18504]="165:300",
	[18506]="165:300",
	[18508]="165:300",
	[18509]="165:300",
	[18510]="165:300",
	[18511]="165:300",
	[18587]="202:265",
	[18588]="202:200",
	[18594]="202:275",
	[18631]="202:260",
	[18634]="202:260",
	[18637]="202:275",
	[18638]="202:290",
	[18639]="202:300",
	[18641]="202:250",
	[18645]="202:265",
	[18660]="202:260",
	[18662]="165:150",
	[18948]="165:155",
	[18984]="202:260",
	[18986]="202:260",
	[19026]="202:250",
	[19043]="164:290",
	[19044]="165:290",
	[19047]="197:290",
	[19048]="164:300",
	[19049]="165:300",
	[19050]="197:300",
	[19051]="164:290",
	[19052]="165:290",
	[19056]="197:290",
	[19057]="164:300",
	[19058]="165:300",
	[19059]="197:300",
	[19148]="164:300",
	[19149]="165:300",
	[19156]="197:300",
	[19157]="165:300",
	[19162]="165:300",
	[19163]="165:300",
	[19164]="164:300",
	[19165]="197:300",
	[19166]="164:300",
	[19167]="164:300",
	[19168]="164:300",
	[19169]="164:300",
	[19170]="164:300",
	[19440]="129:300",
	[19682]="197:300",
	[19683]="197:300",
	[19684]="197:300",
	[19685]="165:300",
	[19686]="165:300",
	[19687]="165:300",
	[19688]="165:300",
	[19689]="165:300",
	[19690]="164:300",
	[19691]="164:300",
	[19692]="164:300",
	[19693]="164:300",
	[19694]="164:300",
	[19695]="164:300",
	[19931]="171:300",
	[19998]="202:300",
	[19999]="202:300",
	[20002]="171:275",
	[20004]="171:290",
	[20007]="171:275",
	[20008]="171:285",
	[20039]="164:300",
	[20074]="185:150",
	[20295]="165:0",
	[20296]="165:0",
	[20380]="165:300",
	[20452]="185:285",
	[20475]="202:335",
	[20476]="165:300",
	[20477]="165:300",
	[20478]="165:300",
	[20479]="165:300",
	[20480]="165:300",
	[20481]="165:300",
	[20537]="197:300",
	[20538]="197:300",
	[20539]="197:300",
	[20549]="164:300",
	[20550]="164:300",
	[20551]="164:300",
	[20575]="165:100",
	[20744]="333:45",
	[20745]="333:150",
	[20746]="333:200",
	[20747]="333:250",
	[20748]="333:300",
	[20749]="333:300",
	[20750]="333:275",
	[20816]="755:1",
	[20817]="755:50",
	[20818]="755:50",
	[20820]="755:60",
	[20821]="755:30",
	[20823]="755:70",
	[20826]="755:90",
	[20827]="755:80",
	[20828]="755:100",
	[20830]="755:110",
	[20831]="755:150",
	[20832]="755:120",
	[20833]="755:125",
	[20906]="755:1",
	[20907]="755:50",
	[20909]="755:110",
	[20950]="755:120",
	[20954]="755:125",
	[20955]="755:135",
	[20958]="755:150",
	[20959]="755:170",
	[20960]="755:170",
	[20961]="755:180",
	[20963]="755:150",
	[20964]="755:210",
	[20966]="755:160",
	[20967]="755:190",
	[20969]="755:225",
	[21023]="185:300",
	[21072]="185:80",
	[21154]="197:250",
	[21217]="185:175",
	[21277]="202:250",
	[21278]="165:300",
	[21340]="197:260",
	[21341]="197:280",
	[21342]="197:300",
	[21542]="197:250",
	[21546]="171:250",
	[21557]="202:125",
	[21558]="202:125",
	[21559]="202:125",
	[21569]="202:225",
	[21570]="202:275",
	[21571]="202:225",
	[21574]="202:225",
	[21576]="202:225",
	[21589]="202:175",
	[21590]="202:175",
	[21592]="202:175",
	[21714]="202:275",
	[21716]="202:275",
	[21718]="202:275",
	[21748]="755:200",
	[21752]="755:225",
	[21753]="755:250",
	[21754]="755:245",
	[21755]="755:220",
	[21756]="755:200",
	[21758]="755:215",
	[21760]="755:225",
	[21763]="755:235",
	[21764]="755:235",
	[21765]="755:240",
	[21766]="755:250",
	[21767]="755:260",
	[21768]="755:275",
	[21769]="755:260",
	[21774]="755:275",
	[21775]="755:280",
	[21777]="755:285",
	[21778]="755:285",
	[21779]="755:310",
	[21780]="755:0",
	[21784]="755:300",
	[21789]="755:300",
	[21790]="755:280",
	[21791]="755:290",
	[21792]="755:305",
	[21793]="755:0",
	[21840]="197:300",
	[21841]="197:315",
	[21842]="197:325",
	[21843]="197:340",
	[21844]="197:345",
	[21845]="197:350",
	[21846]="197:355",
	[21847]="197:365",
	[21848]="197:375",
	[21849]="197:310",
	[21850]="197:310",
	[21851]="197:320",
	[21852]="197:325",
	[21853]="197:335",
	[21854]="197:340",
	[21855]="197:345",
	[21858]="197:375",
	[21859]="197:340",
	[21860]="197:350",
	[21861]="197:360",
	[21862]="197:360",
	[21863]="197:355",
	[21864]="197:365",
	[21865]="197:375",
	[21866]="197:350",
	[21867]="197:360",
	[21868]="197:370",
	[21869]="197:355",
	[21870]="197:365",
	[21871]="197:375",
	[21872]="197:375",
	[21873]="197:355",
	[21874]="197:365",
	[21875]="197:375",
	[21876]="197:375",
	[21884]="171:300",
	[21885]="171:300",
	[21886]="171:300",
	[21887]="165:300",
	[21931]="755:1",
	[21932]="755:5",
	[21933]="755:50",
	[21934]="755:30",
	[21990]="129:330",
	[21991]="129:360",
	[22018]="237:0",
	[22019]="237:0",
	[22044]="237:0",
	[22116]="354:0",
	[22191]="164:300",
	[22194]="164:300",
	[22195]="164:300",
	[22196]="164:300",
	[22197]="164:300",
	[22198]="164:300",
	[22246]="197:225",
	[22248]="197:275",
	[22249]="197:300",
	[22251]="197:275",
	[22252]="197:300",
	[22383]="164:300",
	[22384]="164:300",
	[22385]="164:300",
	[22448]="333:300",
	[22449]="333:335",
	[22451]="171:350",
	[22452]="171:300",
	[22456]="171:300",
	[22457]="171:300",
	[22459]="333:350",
	[22460]="333:325",
	[22461]="333:300",
	[22462]="333:350",
	[22463]="333:375",
	[22521]="333:310",
	[22522]="333:340",
	[22573]="186:300",
	[22574]="186:300",
	[22645]="185:60",
	[22652]="197:300",
	[22654]="197:300",
	[22655]="197:300",
	[22658]="197:300",
	[22660]="197:300",
	[22661]="165:300",
	[22662]="165:300",
	[22663]="165:300",
	[22664]="165:300",
	[22665]="165:300",
	[22666]="165:300",
	[22669]="164:300",
	[22670]="164:300",
	[22671]="164:300",
	[22728]="202:275",
	[22756]="197:300",
	[22757]="197:300",
	[22758]="197:300",
	[22759]="165:300",
	[22760]="165:300",
	[22761]="165:300",
	[22762]="164:300",
	[22763]="164:300",
	[22764]="164:300",
	[22823]="171:305",
	[22824]="171:305",
	[22825]="171:310",
	[22826]="171:315",
	[22827]="171:320",
	[22828]="171:320",
	[22829]="171:325",
	[22830]="171:325",
	[22831]="171:330",
	[22832]="171:340",
	[22833]="171:345",
	[22834]="171:345",
	[22835]="171:350",
	[22836]="171:350",
	[22837]="171:350",
	[22838]="171:350",
	[22839]="171:350",
	[22840]="171:355",
	[22841]="171:360",
	[22842]="171:360",
	[22844]="171:360",
	[22845]="171:360",
	[22846]="171:360",
	[22847]="171:360",
	[22848]="171:365",
	[22849]="171:365",
	[22850]="171:300",
	[22851]="171:300",
	[22853]="171:300",
	[22854]="171:300",
	[22861]="171:300",
	[22866]="171:300",
	[22871]="171:335",
	[22895]="237:0",
	[23094]="755:300",
	[23095]="755:305",
	[23096]="755:315",
	[23097]="755:325",
	[23098]="755:300",
	[23099]="755:305",
	[23100]="755:315",
	[23101]="755:325",
	[23103]="755:300",
	[23104]="755:305",
	[23105]="755:315",
	[23106]="755:325",
	[23108]="755:300",
	[23109]="755:305",
	[23110]="755:315",
	[23111]="755:325",
	[23113]="755:300",
	[23114]="755:305",
	[23115]="755:315",
	[23116]="755:325",
	[23118]="755:300",
	[23119]="755:305",
	[23120]="755:315",
	[23121]="755:325",
	[23445]="186:275",
	[23446]="186:325",
	[23447]="186:350",
	[23448]="186:350",
	[23449]="186:375",
	[23482]="164:300",
	[23484]="164:305",
	[23487]="164:315",
	[23488]="164:315",
	[23489]="164:325",
	[23490]="164:320",
	[23491]="164:310",
	[23493]="164:300",
	[23494]="164:315",
	[23497]="164:310",
	[23498]="164:315",
	[23499]="164:320",
	[23502]="164:325",
	[23503]="164:330",
	[23504]="164:330",
	[23505]="164:335",
	[23506]="164:335",
	[23507]="164:340",
	[23508]="164:335",
	[23509]="164:360",
	[23510]="164:355",
	[23511]="164:355",
	[23512]="164:365",
	[23513]="164:365",
	[23514]="164:360",
	[23515]="164:350",
	[23516]="164:355",
	[23517]="164:360",
	[23518]="164:360",
	[23519]="164:365",
	[23520]="164:365",
	[23521]="164:365",
	[23522]="164:370",
	[23523]="164:360",
	[23524]="164:360",
	[23525]="164:365",
	[23526]="164:370",
	[23527]="164:370",
	[23528]="164:300",
	[23529]="164:350",
	[23530]="164:360",
	[23531]="164:365",
	[23532]="164:365",
	[23533]="164:365",
	[23534]="164:365",
	[23535]="164:365",
	[23536]="164:365",
	[23537]="164:365",
	[23538]="164:365",
	[23539]="164:365",
	[23540]="164:365",
	[23541]="164:365",
	[23542]="164:365",
	[23543]="164:365",
	[23544]="164:365",
	[23546]="164:365",
	[23554]="164:365",
	[23555]="164:365",
	[23556]="164:365",
	[23559]="164:325",
	[23563]="164:350",
	[23564]="164:375",
	[23565]="164:375",
	[23571]="171:350",
	[23573]="186:375",
	[23575]="164:340",
	[23576]="164:375",
	[23736]="202:300",
	[23737]="202:325",
	[23742]="202:320",
	[23746]="202:350",
	[23747]="202:360",
	[23748]="202:375",
	[23758]="202:340",
	[23761]="202:340",
	[23762]="202:350",
	[23763]="202:360",
	[23764]="202:335",
	[23765]="202:360",
	[23766]="202:375",
	[23767]="202:325",
	[23768]="202:335",
	[23771]="202:335",
	[23772]="202:310",
	[23774]="202:325",
	[23775]="202:405",
	[23781]="202:300",
	[23782]="202:300",
	[23783]="202:300",
	[23784]="202:325",
	[23785]="202:340",
	[23786]="202:340",
	[23787]="202:340",
	[23793]="165:325",
	[23819]="202:350",
	[23821]="202:305",
	[23824]="202:355",
	[23825]="202:350",
	[23826]="202:325",
	[23827]="202:340",
	[23828]="202:375",
	[23829]="202:375",
	[23835]="202:340",
	[23836]="202:350",
	[23838]="202:375",
	[23839]="202:375",
	[23841]="202:325",
	[24027]="755:350",
	[24028]="755:350",
	[24029]="755:350",
	[24030]="755:350",
	[24031]="755:350",
	[24032]="755:350",
	[24033]="755:350",
	[24035]="755:350",
	[24036]="755:350",
	[24037]="755:350",
	[24039]="755:350",
	[24047]="755:350",
	[24048]="755:350",
	[24050]="755:350",
	[24051]="755:350",
	[24052]="755:350",
	[24053]="755:350",
	[24054]="755:350",
	[24055]="755:350",
	[24056]="755:350",
	[24057]="755:350",
	[24058]="755:350",
	[24059]="755:350",
	[24060]="755:350",
	[24061]="755:350",
	[24062]="755:350",
	[24065]="755:350",
	[24066]="755:350",
	[24067]="755:350",
	[24074]="755:310",
	[24075]="755:310",
	[24076]="755:320",
	[24077]="755:335",
	[24078]="755:335",
	[24079]="755:350",
	[24080]="755:355",
	[24082]="755:355",
	[24085]="755:360",
	[24086]="755:365",
	[24087]="755:345",
	[24088]="755:355",
	[24089]="755:365",
	[24092]="755:360",
	[24093]="755:360",
	[24095]="755:360",
	[24097]="755:360",
	[24098]="755:360",
	[24105]="185:1",
	[24106]="755:355",
	[24110]="755:355",
	[24114]="755:360",
	[24116]="755:360",
	[24117]="755:365",
	[24121]="755:365",
	[24122]="755:370",
	[24123]="755:370",
	[24124]="755:370",
	[24125]="755:370",
	[24126]="755:370",
	[24127]="755:370",
	[24128]="755:370",
	[24249]="197:350",
	[24250]="197:350",
	[24251]="197:350",
	[24252]="197:350",
	[24253]="197:350",
	[24254]="197:350",
	[24255]="197:365",
	[24256]="197:365",
	[24257]="197:365",
	[24258]="197:365",
	[24259]="197:365",
	[24260]="197:365",
	[24261]="197:375",
	[24262]="197:375",
	[24263]="197:375",
	[24264]="197:375",
	[24266]="197:375",
	[24267]="197:375",
	[24268]="197:300",
	[24270]="197:340",
	[24271]="197:350",
	[24272]="197:350",
	[24273]="197:335",
	[24274]="197:375",
	[24275]="197:335",
	[24276]="197:375",
	[25438]="755:20",
	[25439]="755:20",
	[25498]="755:1",
	[25521]="164:350",
	[25650]="165:300",
	[25651]="165:325",
	[25652]="165:325",
	[25653]="165:350",
	[25654]="165:300",
	[25655]="165:310",
	[25656]="165:320",
	[25657]="165:335",
	[25659]="165:335",
	[25660]="165:325",
	[25661]="165:310",
	[25662]="165:300",
	[25668]="165:320",
	[25669]="165:300",
	[25670]="165:315",
	[25671]="165:330",
	[25673]="165:300",
	[25674]="165:310",
	[25675]="165:320",
	[25676]="165:330",
	[25679]="165:300",
	[25680]="165:350",
	[25681]="165:350",
	[25682]="165:350",
	[25683]="165:350",
	[25685]="165:340",
	[25686]="165:350",
	[25687]="165:350",
	[25689]="165:360",
	[25690]="165:355",
	[25691]="165:355",
	[25692]="165:340",
	[25693]="165:350",
	[25694]="165:340",
	[25695]="165:350",
	[25696]="165:360",
	[25697]="165:360",
	[25843]="164:300",
	[25844]="164:350",
	[25845]="164:360",
	[25867]="171:350",
	[25868]="171:350",
	[25880]="755:50",
	[25881]="755:110",
	[25882]="755:175",
	[25883]="755:225",
	[25886]="202:335",
	[25890]="755:365",
	[25893]="755:365",
	[25894]="755:365",
	[25895]="755:365",
	[25896]="755:365",
	[25897]="755:365",
	[25898]="755:365",
	[25899]="755:365",
	[25901]="755:365",
	[27498]="773:270",
	[27499]="773:260",
	[27501]="773:255",
	[27502]="773:250",
	[27503]="773:265",
	[27635]="185:1",
	[27636]="185:50",
	[27651]="185:300",
	[27655]="185:300",
	[27656]="185:310",
	[27657]="185:315",
	[27658]="185:325",
	[27659]="185:325",
	[27660]="185:325",
	[27661]="185:300",
	[27662]="185:300",
	[27663]="185:310",
	[27664]="185:320",
	[27665]="185:320",
	[27666]="185:325",
	[27667]="185:350",
	[28100]="171:300",
	[28101]="171:310",
	[28102]="171:300",
	[28103]="171:300",
	[28104]="171:315",
	[28290]="755:325",
	[28420]="164:300",
	[28421]="164:350",
	[28425]="164:350",
	[28426]="164:375",
	[28427]="164:375",
	[28428]="164:350",
	[28429]="164:375",
	[28430]="164:375",
	[28431]="164:350",
	[28432]="164:375",
	[28433]="164:375",
	[28434]="164:350",
	[28435]="164:375",
	[28436]="164:375",
	[28437]="164:350",
	[28438]="164:375",
	[28439]="164:375",
	[28440]="164:350",
	[28441]="164:375",
	[28442]="164:375",
	[28483]="164:350",
	[28484]="164:375",
	[28485]="164:375",
	[28595]="755:305",
	[29157]="755:180",
	[29158]="755:200",
	[29159]="755:280",
	[29160]="755:290",
	[29201]="164:100",
	[29202]="164:200",
	[29203]="164:300",
	[29204]="164:350",
	[29483]="165:340",
	[29485]="165:340",
	[29486]="165:340",
	[29487]="165:340",
	[29488]="165:340",
	[29489]="165:350",
	[29490]="165:350",
	[29491]="165:350",
	[29492]="165:350",
	[29493]="165:350",
	[29494]="165:350",
	[29495]="165:350",
	[29496]="165:350",
	[29497]="165:350",
	[29498]="165:350",
	[29499]="165:350",
	[29500]="165:350",
	[29502]="165:365",
	[29503]="165:365",
	[29504]="165:365",
	[29505]="165:365",
	[29506]="165:365",
	[29507]="165:365",
	[29508]="165:365",
	[29509]="165:365",
	[29510]="165:365",
	[29511]="165:365",
	[29512]="165:365",
	[29514]="165:365",
	[29515]="165:375",
	[29516]="165:375",
	[29517]="165:375",
	[29519]="165:375",
	[29520]="165:375",
	[29521]="165:375",
	[29522]="165:375",
	[29523]="165:375",
	[29524]="165:375",
	[29525]="165:375",
	[29526]="165:375",
	[29527]="165:375",
	[29528]="165:340",
	[29529]="165:365",
	[29530]="165:345",
	[29531]="165:350",
	[29532]="165:370",
	[29533]="165:335",
	[29534]="165:335",
	[29535]="165:365",
	[29536]="165:365",
	[29540]="165:325",
	[29964]="165:260",
	[29970]="165:260",
	[29971]="165:260",
	[29973]="165:330",
	[29974]="165:330",
	[29975]="165:330",
	[30031]="164:375",
	[30032]="164:375",
	[30033]="164:375",
	[30034]="164:375",
	[30035]="197:375",
	[30036]="197:375",
	[30037]="197:375",
	[30038]="197:375",
	[30039]="165:375",
	[30040]="165:375",
	[30041]="165:375",
	[30042]="165:375",
	[30043]="165:375",
	[30044]="165:375",
	[30045]="165:375",
	[30046]="165:375",
	[30069]="164:260",
	[30070]="164:260",
	[30071]="164:260",
	[30072]="164:260",
	[30073]="164:260",
	[30074]="164:330",
	[30076]="164:330",
	[30077]="164:330",
	[30086]="164:330",
	[30087]="164:330",
	[30088]="164:330",
	[30089]="164:330",
	[30093]="164:330",
	[30155]="185:300",
	[30419]="755:75",
	[30420]="755:105",
	[30421]="755:230",
	[30422]="755:265",
	[30459]="197:0",
	[30460]="197:0",
	[30461]="197:0",
	[30542]="202:350",
	[30544]="202:350",
	[30703]="237:0",
	[30804]="755:65",
	[30816]="185:1",
	[30825]="755:360",
	[30831]="197:350",
	[30837]="197:350",
	[30838]="197:360",
	[30839]="197:370",
	[31079]="755:325",
	[31080]="171:325",
	[31154]="755:80",
	[31364]="164:375",
	[31367]="164:375",
	[31368]="164:375",
	[31369]="164:375",
	[31370]="164:375",
	[31371]="164:375",
	[31398]="755:375",
	[31399]="755:375",
	[31672]="185:335",
	[31673]="185:335",
	[31676]="171:345",
	[31677]="171:360",
	[31679]="171:335",
	[31860]="755:325",
	[31861]="755:350",
	[31862]="755:325",
	[31863]="755:350",
	[31864]="755:325",
	[31865]="755:350",
	[31866]="755:325",
	[31867]="755:350",
	[31868]="755:350",
	[31869]="755:325",
	[32062]="171:310",
	[32063]="171:320",
	[32067]="171:320",
	[32068]="171:330",
	[32193]="755:375",
	[32194]="755:375",
	[32195]="755:375",
	[32196]="755:375",
	[32197]="755:375",
	[32198]="755:375",
	[32199]="755:375",
	[32200]="755:375",
	[32201]="755:375",
	[32202]="755:375",
	[32203]="755:375",
	[32204]="755:375",
	[32205]="755:375",
	[32206]="755:375",
	[32207]="755:375",
	[32208]="755:375",
	[32209]="755:375",
	[32210]="755:375",
	[32211]="755:375",
	[32212]="755:375",
	[32213]="755:375",
	[32214]="755:375",
	[32215]="755:375",
	[32216]="755:375",
	[32217]="755:375",
	[32218]="755:375",
	[32219]="755:375",
	[32220]="755:375",
	[32221]="755:375",
	[32222]="755:375",
	[32223]="755:375",
	[32224]="755:375",
	[32225]="755:375",
	[32226]="755:375",
	[32389]="197:375",
	[32390]="197:375",
	[32391]="197:375",
	[32392]="197:375",
	[32393]="165:375",
	[32394]="165:375",
	[32395]="165:375",
	[32396]="165:375",
	[32397]="165:375",
	[32398]="165:375",
	[32399]="165:375",
	[32400]="165:375",
	[32401]="164:375",
	[32402]="164:375",
	[32403]="164:375",
	[32404]="164:375",
	[32409]="755:365",
	[32410]="755:365",
	[32413]="202:335",
	[32420]="197:375",
	[32423]="202:335",
	[32461]="202:350",
	[32472]="202:350",
	[32473]="202:350",
	[32474]="202:350",
	[32475]="202:350",
	[32476]="202:350",
	[32478]="202:350",
	[32479]="202:350",
	[32480]="202:350",
	[32494]="202:350",
	[32495]="202:350",
	[32508]="755:340",
	[32568]="164:375",
	[32570]="164:375",
	[32571]="164:375",
	[32573]="164:375",
	[32574]="165:375",
	[32575]="165:375",
	[32577]="165:375",
	[32579]="165:375",
	[32580]="165:375",
	[32581]="165:375",
	[32582]="165:375",
	[32583]="165:375",
	[32584]="197:375",
	[32585]="197:375",
	[32586]="197:375",
	[32587]="197:375",
	[32756]="202:375",
	[32772]="755:325",
	[32774]="755:330",
	[32776]="755:365",
	[32833]="755:325",
	[32836]="755:350",
	[32839]="171:300",
	[32849]="171:300",
	[32850]="171:300",
	[32851]="171:300",
	[32852]="171:300",
	[32854]="164:365",
	[33004]="185:0",
	[33048]="185:320",
	[33052]="185:350",
	[33053]="185:350",
	[33092]="202:330",
	[33093]="202:345",
	[33122]="165:360",
	[33131]="755:360",
	[33133]="755:360",
	[33134]="755:360",
	[33135]="755:360",
	[33140]="755:360",
	[33143]="755:360",
	[33144]="755:360",
	[33173]="164:365",
	[33185]="164:335",
	[33204]="165:365",
	[33208]="171:375",
	[33312]="237:0",
	[33447]="171:405",
	[33448]="171:410",
	[33457]="773:310",
	[33458]="773:310",
	[33460]="773:295",
	[33461]="773:290",
	[33462]="773:305",
	[33568]="165:350",
	[33782]="755:350",
	[33791]="164:35",
	[33825]="185:325",
	[33866]="185:300",
	[33867]="185:300",
	[33872]="185:325",
	[33874]="185:300",
	[33924]="185:1",
	[34060]="202:0",
	[34061]="202:0",
	[34085]="197:250",
	[34086]="165:285",
	[34087]="197:250",
	[34099]="165:315",
	[34100]="165:315",
	[34105]="165:350",
	[34106]="165:350",
	[34113]="202:360",
	[34207]="165:350",
	[34220]="755:365",
	[34330]="165:350",
	[34353]="202:375",
	[34354]="202:375",
	[34355]="202:375",
	[34356]="202:375",
	[34357]="202:375",
	[34358]="755:365",
	[34359]="755:365",
	[34360]="755:365",
	[34361]="755:365",
	[34362]="755:365",
	[34363]="755:365",
	[34364]="197:365",
	[34365]="197:365",
	[34366]="197:365",
	[34367]="197:365",
	[34369]="165:365",
	[34370]="165:365",
	[34371]="165:365",
	[34372]="165:365",
	[34373]="165:365",
	[34374]="165:365",
	[34375]="165:365",
	[34376]="165:365",
	[34377]="164:365",
	[34378]="164:365",
	[34379]="164:365",
	[34380]="164:365",
	[34411]="185:325",
	[34440]="171:325",
	[34482]="165:300",
	[34490]="165:360",
	[34504]="202:335",
	[34721]="129:350",
	[34722]="129:400",
	[34747]="185:0",
	[34748]="185:350",
	[34749]="185:350",
	[34750]="185:350",
	[34751]="185:350",
	[34752]="185:350",
	[34753]="185:375",
	[34754]="185:400",
	[34755]="185:400",
	[34756]="185:400",
	[34757]="185:400",
	[34758]="185:400",
	[34759]="185:350",
	[34760]="185:350",
	[34761]="185:350",
	[34762]="185:350",
	[34763]="185:350",
	[34764]="185:350",
	[34765]="185:350",
	[34766]="185:400",
	[34767]="185:400",
	[34768]="185:400",
	[34769]="185:400",
	[34832]="185:100",
	[34847]="202:375",
	[35128]="186:375",
	[35181]="202:375",
	[35182]="202:375",
	[35183]="202:375",
	[35184]="202:375",
	[35185]="202:375",
	[35315]="755:350",
	[35316]="755:350",
	[35318]="755:350",
	[35501]="755:370",
	[35503]="755:370",
	[35563]="185:250",
	[35565]="185:250",
	[35581]="202:355",
	[35622]="171:300",
	[35623]="171:300",
	[35624]="171:300",
	[35625]="171:300",
	[35627]="171:300",
	[35693]="755:375",
	[35694]="755:375",
	[35700]="755:375",
	[35702]="755:375",
	[35703]="755:375",
	[35707]="755:350",
	[35748]="171:375",
	[35749]="171:375",
	[35750]="171:375",
	[35751]="171:375",
	[35758]="755:375",
	[35759]="755:375",
	[35760]="755:375",
	[35761]="755:375",
	[35945]="755:350",
	[36766]="755:370",
	[36767]="755:370",
	[36860]="171:300",
	[36895]="354:0",
	[36913]="186:400",
	[36916]="186:350",
	[36919]="171:300",
	[36922]="171:450",
	[36925]="171:450",
	[36928]="171:450",
	[36931]="171:450",
	[36934]="171:450",
	[37091]="773:360",
	[37092]="773:410",
	[37093]="773:350",
	[37094]="773:400",
	[37097]="773:355",
	[37098]="773:405",
	[37101]="773:1",
	[37118]="773:35",
	[37168]="773:110",
	[37503]="755:375",
	[37567]="202:410",
	[37602]="773:200",
	[37663]="186:450",
	[38225]="197:375",
	[38277]="197:250",
	[38278]="197:245",
	[38322]="773:400",
	[38347]="165:415",
	[38371]="165:405",
	[38372]="165:400",
	[38373]="165:425",
	[38374]="165:425",
	[38375]="165:350",
	[38376]="165:395",
	[38399]="165:415",
	[38400]="165:370",
	[38401]="165:375",
	[38402]="165:380",
	[38403]="165:375",
	[38404]="165:370",
	[38405]="165:380",
	[38406]="165:380",
	[38407]="165:375",
	[38408]="165:375",
	[38409]="165:370",
	[38410]="165:370",
	[38411]="165:380",
	[38412]="165:370",
	[38413]="165:380",
	[38414]="165:375",
	[38415]="165:380",
	[38416]="165:370",
	[38417]="165:380",
	[38418]="165:375",
	[38419]="165:380",
	[38420]="165:375",
	[38421]="165:370",
	[38422]="165:370",
	[38424]="165:375",
	[38425]="165:390",
	[38433]="165:385",
	[38434]="165:385",
	[38435]="165:385",
	[38436]="165:385",
	[38437]="165:385",
	[38438]="165:385",
	[38439]="165:385",
	[38440]="165:385",
	[38441]="165:380",
	[38590]="165:400",
	[38591]="165:395",
	[38592]="165:395",
	[38682]="773:35",
	[39083]="164:360",
	[39084]="164:370",
	[39085]="164:375",
	[39086]="164:370",
	[39087]="164:350",
	[39088]="164:350",
	[39349]="773:75",
	[39350]="773:235",
	[39469]="773:35",
	[39520]="185:375",
	[39666]="171:395",
	[39671]="171:350",
	[39681]="202:350",
	[39682]="202:375",
	[39683]="202:390",
	[39688]="202:400",
	[39690]="202:350",
	[39774]="773:75",
	[39900]="755:350",
	[39905]="755:350",
	[39906]="755:350",
	[39907]="755:360",
	[39908]="755:350",
	[39909]="755:350",
	[39910]="755:350",
	[39911]="755:350",
	[39912]="755:350",
	[39914]="755:350",
	[39915]="755:350",
	[39916]="755:350",
	[39917]="755:350",
	[39918]="755:350",
	[39919]="755:350",
	[39920]="755:350",
	[39927]="755:350",
	[39932]="755:350",
	[39933]="755:350",
	[39934]="755:350",
	[39935]="755:350",
	[39936]="755:350",
	[39937]="755:350",
	[39938]="755:360",
	[39939]="755:350",
	[39940]="755:350",
	[39941]="755:350",
	[39942]="755:350",
	[39943]="755:350",
	[39944]="755:350",
	[39945]="755:350",
	[39946]="755:350",
	[39947]="755:350",
	[39948]="755:350",
	[39949]="755:350",
	[39950]="755:350",
	[39951]="755:350",
	[39952]="755:350",
	[39953]="755:350",
	[39954]="755:350",
	[39955]="755:350",
	[39956]="755:350",
	[39957]="755:350",
	[39958]="755:350",
	[39959]="755:350",
	[39960]="755:350",
	[39961]="755:350",
	[39962]="755:350",
	[39963]="755:350",
	[39964]="755:350",
	[39965]="755:360",
	[39966]="755:350",
	[39967]="755:350",
	[39968]="755:350",
	[39974]="755:350",
	[39975]="755:350",
	[39976]="755:350",
	[39977]="755:350",
	[39978]="755:350",
	[39979]="755:350",
	[39980]="755:350",
	[39981]="755:350",
	[39982]="755:350",
	[39983]="755:350",
	[39984]="755:350",
	[39985]="755:350",
	[39986]="755:350",
	[39988]="755:350",
	[39989]="755:350",
	[39990]="755:350",
	[39991]="755:350",
	[39992]="755:350",
	[39996]="755:390",
	[39997]="755:390",
	[39998]="755:390",
	[39999]="755:390",
	[40000]="755:390",
	[40001]="755:390",
	[40002]="755:390",
	[40003]="755:390",
	[40008]="755:390",
	[40009]="755:390",
	[40010]="755:390",
	[40011]="755:390",
	[40012]="755:390",
	[40013]="755:390",
	[40014]="755:390",
	[40015]="755:390",
	[40016]="755:390",
	[40017]="755:390",
	[40022]="755:390",
	[40023]="755:390",
	[40024]="755:390",
	[40025]="755:390",
	[40026]="755:390",
	[40027]="755:390",
	[40028]="755:390",
	[40029]="755:390",
	[40030]="755:390",
	[40031]="755:390",
	[40032]="755:390",
	[40033]="755:390",
	[40034]="755:390",
	[40037]="755:390",
	[40038]="755:390",
	[40039]="755:390",
	[40040]="755:390",
	[40041]="755:390",
	[40043]="755:390",
	[40044]="755:390",
	[40045]="755:390",
	[40046]="755:390",
	[40047]="755:390",
	[40048]="755:390",
	[40049]="755:390",
	[40050]="755:390",
	[40051]="755:390",
	[40052]="755:390",
	[40053]="755:390",
	[40054]="755:390",
	[40055]="755:390",
	[40056]="755:390",
	[40057]="755:390",
	[40058]="755:390",
	[40059]="755:390",
	[40067]="171:360",
	[40068]="171:355",
	[40070]="171:365",
	[40072]="171:385",
	[40073]="171:385",
	[40076]="171:375",
	[40077]="171:400",
	[40078]="171:390",
	[40079]="171:375",
	[40081]="171:380",
	[40085]="755:390",
	[40086]="755:390",
	[40087]="171:400",
	[40088]="755:390",
	[40089]="755:390",
	[40090]="755:390",
	[40091]="755:390",
	[40092]="755:390",
	[40093]="171:395",
	[40094]="755:390",
	[40095]="755:390",
	[40096]="755:390",
	[40097]="171:400",
	[40098]="755:390",
	[40099]="755:390",
	[40100]="755:390",
	[40101]="755:390",
	[40102]="755:390",
	[40103]="755:390",
	[40104]="755:390",
	[40105]="755:390",
	[40106]="755:390",
	[40109]="171:400",
	[40111]="755:450",
	[40112]="755:450",
	[40113]="755:450",
	[40114]="755:450",
	[40115]="755:450",
	[40116]="755:450",
	[40117]="755:450",
	[40118]="755:450",
	[40119]="755:450",
	[40120]="755:450",
	[40121]="755:450",
	[40122]="755:450",
	[40123]="755:450",
	[40124]="755:450",
	[40125]="755:450",
	[40126]="755:450",
	[40127]="755:450",
	[40128]="755:450",
	[40129]="755:450",
	[40130]="755:450",
	[40131]="755:450",
	[40132]="755:450",
	[40133]="755:450",
	[40134]="755:450",
	[40135]="755:450",
	[40136]="755:450",
	[40137]="755:450",
	[40138]="755:450",
	[40139]="755:450",
	[40140]="755:450",
	[40141]="755:450",
	[40142]="755:450",
	[40143]="755:450",
	[40144]="755:450",
	[40145]="755:450",
	[40146]="755:450",
	[40147]="755:450",
	[40148]="755:450",
	[40149]="755:450",
	[40150]="755:450",
	[40151]="755:450",
	[40152]="755:450",
	[40153]="755:450",
	[40154]="755:450",
	[40155]="755:450",
	[40156]="755:450",
	[40157]="755:450",
	[40158]="755:450",
	[40159]="755:450",
	[40160]="755:450",
	[40161]="755:450",
	[40162]="755:450",
	[40163]="755:450",
	[40164]="755:450",
	[40165]="755:450",
	[40166]="755:450",
	[40167]="755:450",
	[40168]="755:450",
	[40169]="755:450",
	[40170]="755:450",
	[40171]="755:450",
	[40172]="755:450",
	[40173]="755:450",
	[40174]="755:450",
	[40175]="755:450",
	[40176]="755:450",
	[40177]="755:450",
	[40178]="755:450",
	[40179]="755:450",
	[40180]="755:450",
	[40181]="755:450",
	[40182]="755:450",
	[40195]="171:375",
	[40211]="171:400",
	[40212]="171:400",
	[40213]="171:400",
	[40214]="171:400",
	[40215]="171:400",
	[40216]="171:400",
	[40217]="171:400",
	[40536]="202:375",
	[40668]="164:360",
	[40669]="164:395",
	[40670]="164:390",
	[40671]="164:400",
	[40672]="164:400",
	[40673]="164:405",
	[40674]="164:395",
	[40675]="164:405",
	[40767]="202:420",
	[40768]="202:425",
	[40769]="202:0",
	[40771]="202:350",
	[40772]="202:435",
	[40773]="354:0",
	[40865]="202:420",
	[40892]="202:375",
	[40893]="202:375",
	[40895]="202:425",
	[40896]="773:350",
	[40897]="773:90",
	[40899]="773:385",
	[40900]="773:385",
	[40901]="773:260",
	[40902]="773:200",
	[40903]="773:310",
	[40906]="773:385",
	[40908]="773:385",
	[40909]="773:170",
	[40912]="773:385",
	[40913]="773:80",
	[40914]="773:115",
	[40915]="773:385",
	[40916]="773:220",
	[40919]="773:150",
	[40920]="773:385",
	[40921]="773:385",
	[40922]="773:85",
	[40923]="773:130",
	[40924]="773:100",
	[40942]="164:375",
	[40943]="164:395",
	[40949]="164:380",
	[40950]="164:385",
	[40951]="164:385",
	[40952]="164:390",
	[40953]="164:395",
	[40954]="164:400",
	[40955]="164:400",
	[40956]="164:375",
	[40957]="164:375",
	[40958]="164:375",
	[40959]="164:375",
	[41092]="773:120",
	[41094]="773:335",
	[41095]="773:90",
	[41096]="773:80",
	[41097]="773:385",
	[41098]="773:230",
	[41099]="773:205",
	[41100]="773:155",
	[41101]="773:385",
	[41102]="773:375",
	[41103]="773:265",
	[41104]="773:180",
	[41105]="773:300",
	[41106]="773:105",
	[41107]="773:385",
	[41108]="773:135",
	[41109]="773:385",
	[41110]="773:385",
	[41112]="202:420",
	[41113]="164:410",
	[41114]="164:415",
	[41116]="164:410",
	[41117]="164:390",
	[41121]="202:425",
	[41126]="164:395",
	[41127]="164:400",
	[41128]="164:405",
	[41129]="164:415",
	[41146]="202:425",
	[41163]="171:395",
	[41164]="202:410",
	[41165]="202:415",
	[41167]="202:430",
	[41168]="202:450",
	[41169]="354:0",
	[41170]="354:0",
	[41171]="354:0",
	[41172]="354:0",
	[41173]="354:0",
	[41174]="354:0",
	[41181]="164:390",
	[41182]="164:395",
	[41183]="164:400",
	[41184]="164:405",
	[41185]="164:410",
	[41186]="164:415",
	[41187]="164:415",
	[41188]="164:415",
	[41189]="164:415",
	[41190]="164:415",
	[41191]="354:0",
	[41192]="354:0",
	[41193]="354:0",
	[41194]="354:0",
	[41195]="354:0",
	[41196]="354:0",
	[41238]="165:395",
	[41239]="164:380",
	[41240]="164:380",
	[41241]="164:385",
	[41242]="164:385",
	[41243]="164:390",
	[41245]="164:405",
	[41248]="197:400",
	[41249]="197:400",
	[41250]="197:400",
	[41251]="197:400",
	[41252]="197:400",
	[41253]="197:400",
	[41254]="197:400",
	[41255]="197:400",
	[41257]="164:440",
	[41264]="165:0",
	[41266]="171:430",
	[41285]="755:420",
	[41307]="755:420",
	[41333]="755:420",
	[41334]="171:425",
	[41335]="755:420",
	[41339]="755:420",
	[41344]="164:425",
	[41345]="164:425",
	[41346]="164:425",
	[41347]="164:425",
	[41348]="164:420",
	[41349]="164:420",
	[41350]="164:425",
	[41351]="164:420",
	[41352]="164:420",
	[41353]="164:425",
	[41354]="164:420",
	[41355]="164:420",
	[41356]="164:420",
	[41357]="164:420",
	[41367]="755:350",
	[41375]="755:420",
	[41376]="755:420",
	[41377]="755:420",
	[41378]="755:420",
	[41379]="755:420",
	[41380]="755:420",
	[41381]="755:420",
	[41382]="755:420",
	[41383]="164:440",
	[41384]="164:440",
	[41385]="755:420",
	[41386]="164:440",
	[41387]="164:440",
	[41388]="164:440",
	[41389]="755:420",
	[41391]="164:440",
	[41392]="164:440",
	[41394]="164:440",
	[41395]="755:420",
	[41396]="755:420",
	[41397]="755:420",
	[41398]="755:420",
	[41400]="755:420",
	[41401]="755:420",
	[41508]="202:450",
	[41509]="197:360",
	[41510]="197:350",
	[41511]="197:400",
	[41512]="197:350",
	[41513]="197:350",
	[41515]="197:360",
	[41516]="197:420",
	[41517]="773:385",
	[41518]="773:385",
	[41519]="197:380",
	[41520]="197:375",
	[41521]="197:380",
	[41522]="197:370",
	[41523]="197:385",
	[41524]="773:385",
	[41525]="197:390",
	[41526]="773:385",
	[41527]="773:300",
	[41528]="197:385",
	[41529]="773:385",
	[41530]="773:110",
	[41531]="773:85",
	[41532]="773:125",
	[41533]="773:215",
	[41534]="773:385",
	[41535]="773:235",
	[41536]="773:140",
	[41537]="773:95",
	[41538]="773:385",
	[41539]="773:375",
	[41540]="773:165",
	[41541]="773:275",
	[41542]="773:330",
	[41543]="197:395",
	[41544]="197:410",
	[41545]="197:405",
	[41546]="197:395",
	[41547]="773:185",
	[41548]="197:395",
	[41549]="197:405",
	[41550]="197:410",
	[41551]="197:400",
	[41552]="773:385",
	[41553]="197:415",
	[41554]="197:420",
	[41555]="197:415",
	[41593]="197:415",
	[41594]="197:415",
	[41595]="197:415",
	[41597]="197:435",
	[41598]="197:440",
	[41599]="197:410",
	[41600]="197:445",
	[41601]="197:400",
	[41602]="197:430",
	[41603]="197:400",
	[41604]="197:430",
	[41607]="197:390",
	[41608]="197:395",
	[41609]="197:0",
	[41610]="197:0",
	[41611]="164:415",
	[41745]="164:420",
	[41974]="164:360",
	[41975]="164:370",
	[41976]="164:420",
	[41984]="197:425",
	[41985]="197:420",
	[41986]="197:420",
	[42093]="197:425",
	[42095]="197:420",
	[42096]="197:420",
	[42100]="197:440",
	[42101]="197:440",
	[42102]="197:440",
	[42103]="197:435",
	[42111]="197:435",
	[42113]="197:435",
	[42142]="755:370",
	[42143]="755:370",
	[42144]="755:370",
	[42145]="755:370",
	[42146]="755:370",
	[42148]="755:370",
	[42149]="755:370",
	[42150]="755:370",
	[42151]="755:370",
	[42152]="755:370",
	[42153]="755:370",
	[42154]="755:370",
	[42155]="755:370",
	[42156]="755:370",
	[42157]="755:370",
	[42158]="755:370",
	[42336]="755:350",
	[42337]="755:350",
	[42338]="755:380",
	[42339]="755:380",
	[42340]="755:420",
	[42341]="755:400",
	[42395]="755:400",
	[42396]="773:385",
	[42397]="773:230",
	[42398]="773:105",
	[42399]="773:270",
	[42400]="773:120",
	[42401]="773:315",
	[42402]="773:135",
	[42403]="773:385",
	[42404]="773:385",
	[42405]="773:385",
	[42406]="773:350",
	[42407]="773:385",
	[42408]="773:80",
	[42409]="773:385",
	[42410]="773:95",
	[42411]="773:160",
	[42412]="773:375",
	[42413]="755:400",
	[42414]="773:385",
	[42415]="773:180",
	[42416]="773:210",
	[42417]="773:385",
	[42418]="755:400",
	[42420]="755:360",
	[42421]="755:370",
	[42435]="164:440",
	[42443]="164:410",
	[42453]="773:350",
	[42454]="773:385",
	[42455]="773:85",
	[42456]="773:385",
	[42457]="773:385",
	[42458]="773:125",
	[42459]="773:385",
	[42460]="773:385",
	[42461]="773:110",
	[42462]="773:95",
	[42463]="773:385",
	[42464]="773:385",
	[42465]="773:140",
	[42466]="773:215",
	[42467]="773:165",
	[42468]="773:275",
	[42469]="773:385",
	[42470]="773:240",
	[42471]="773:325",
	[42472]="773:385",
	[42473]="773:190",
	[42500]="164:420",
	[42508]="164:440",
	[42546]="202:415",
	[42549]="202:440",
	[42550]="202:440",
	[42551]="202:440",
	[42552]="202:440",
	[42553]="202:440",
	[42554]="202:440",
	[42555]="202:440",
	[42641]="202:425",
	[42642]="755:430",
	[42643]="755:430",
	[42644]="755:430",
	[42645]="755:440",
	[42646]="755:440",
	[42647]="755:440",
	[42701]="755:360",
	[42702]="755:390",
	[42723]="164:420",
	[42724]="164:420",
	[42725]="164:425",
	[42726]="164:425",
	[42727]="164:420",
	[42728]="164:425",
	[42729]="164:420",
	[42730]="164:420",
	[42731]="165:425",
	[42734]="773:100",
	[42735]="773:115",
	[42736]="773:335",
	[42737]="773:130",
	[42738]="773:155",
	[42739]="773:385",
	[42740]="773:385",
	[42741]="773:80",
	[42742]="773:385",
	[42743]="773:90",
	[42744]="773:225",
	[42745]="773:375",
	[42746]="773:175",
	[42747]="773:205",
	[42748]="773:385",
	[42749]="773:325",
	[42750]="773:280",
	[42751]="773:385",
	[42752]="773:400",
	[42753]="773:385",
	[42754]="773:385",
	[42897]="773:175",
	[42898]="773:100",
	[42899]="773:385",
	[42900]="773:115",
	[42901]="773:385",
	[42902]="773:385",
	[42903]="773:200",
	[42904]="773:225",
	[42905]="773:260",
	[42906]="773:350",
	[42907]="773:80",
	[42908]="773:130",
	[42909]="773:375",
	[42910]="773:150",
	[42911]="773:315",
	[42912]="773:90",
	[42913]="773:385",
	[42914]="773:385",
	[42915]="773:385",
	[42916]="773:385",
	[42917]="773:385",
	[42942]="185:350",
	[42954]="773:385",
	[42955]="773:340",
	[42956]="773:80",
	[42957]="773:385",
	[42958]="773:385",
	[42959]="773:385",
	[42960]="773:95",
	[42961]="773:105",
	[42962]="773:120",
	[42963]="773:305",
	[42964]="773:135",
	[42965]="773:385",
	[42966]="773:160",
	[42967]="773:385",
	[42968]="773:385",
	[42969]="773:385",
	[42970]="773:185",
	[42971]="773:385",
	[42972]="773:210",
	[42973]="773:235",
	[42974]="773:285",
	[42993]="185:400",
	[42994]="185:400",
	[42995]="185:400",
	[42996]="185:400",
	[42997]="185:400",
	[42998]="185:400",
	[42999]="185:400",
	[43000]="185:400",
	[43001]="185:400",
	[43004]="185:400",
	[43005]="185:400",
	[43015]="185:450",
	[43115]="773:85",
	[43116]="773:100",
	[43117]="773:125",
	[43118]="773:150",
	[43119]="773:175",
	[43120]="773:200",
	[43121]="773:225",
	[43122]="773:250",
	[43123]="773:275",
	[43124]="773:290",
	[43125]="773:325",
	[43126]="773:350",
	[43127]="773:375",
	[43129]="165:425",
	[43130]="165:420",
	[43131]="165:420",
	[43132]="165:425",
	[43133]="165:420",
	[43145]="773:350",
	[43146]="773:400",
	[43244]="755:350",
	[43245]="755:350",
	[43246]="755:370",
	[43247]="755:370",
	[43248]="755:390",
	[43249]="755:390",
	[43250]="755:420",
	[43251]="755:420",
	[43252]="755:420",
	[43253]="755:420",
	[43255]="165:420",
	[43256]="165:420",
	[43257]="165:425",
	[43258]="165:420",
	[43260]="165:420",
	[43261]="165:420",
	[43262]="165:420",
	[43263]="165:420",
	[43264]="165:420",
	[43265]="165:425",
	[43266]="165:425",
	[43268]="185:350",
	[43271]="165:425",
	[43273]="165:425",
	[43316]="773:75",
	[43331]="773:75",
	[43332]="773:75",
	[43334]="773:75",
	[43335]="773:75",
	[43338]="773:75",
	[43339]="773:75",
	[43340]="773:75",
	[43342]="773:75",
	[43343]="773:75",
	[43344]="773:75",
	[43350]="773:75",
	[43351]="773:75",
	[43354]="773:75",
	[43355]="773:75",
	[43356]="773:75",
	[43357]="773:75",
	[43359]="773:75",
	[43360]="773:75",
	[43361]="773:75",
	[43364]="773:75",
	[43365]="773:75",
	[43366]="773:75",
	[43367]="773:75",
	[43368]="773:75",
	[43369]="773:75",
	[43370]="773:75",
	[43371]="773:75",
	[43372]="773:75",
	[43373]="773:75",
	[43374]="773:75",
	[43376]="773:75",
	[43377]="773:75",
	[43378]="773:75",
	[43379]="773:75",
	[43380]="773:75",
	[43381]="773:75",
	[43385]="773:75",
	[43386]="773:75",
	[43388]="773:75",
	[43389]="773:75",
	[43390]="773:75",
	[43391]="773:75",
	[43392]="773:75",
	[43393]="773:75",
	[43394]="773:75",
	[43395]="773:75",
	[43396]="773:75",
	[43397]="773:75",
	[43398]="773:75",
	[43399]="773:75",
	[43400]="773:75",
	[43412]="773:385",
	[43413]="773:85",
	[43414]="773:240",
	[43415]="773:385",
	[43416]="773:285",
	[43417]="773:125",
	[43418]="773:95",
	[43419]="773:385",
	[43420]="773:220",
	[43421]="773:385",
	[43422]="773:170",
	[43423]="773:110",
	[43424]="773:190",
	[43425]="773:385",
	[43426]="773:385",
	[43427]="773:140",
	[43428]="773:320",
	[43429]="773:385",
	[43430]="773:385",
	[43431]="773:385",
	[43432]="773:345",
	[43433]="165:420",
	[43434]="165:420",
	[43435]="165:420",
	[43436]="165:425",
	[43437]="165:425",
	[43438]="165:425",
	[43439]="165:425",
	[43442]="165:425",
	[43443]="165:425",
	[43444]="165:420",
	[43445]="165:420",
	[43446]="165:425",
	[43447]="165:420",
	[43448]="165:425",
	[43449]="165:420",
	[43450]="165:425",
	[43451]="165:425",
	[43452]="165:420",
	[43453]="165:420",
	[43454]="165:425",
	[43455]="165:420",
	[43456]="165:425",
	[43457]="165:420",
	[43458]="165:440",
	[43459]="165:440",
	[43461]="165:440",
	[43463]="773:370",
	[43464]="773:420",
	[43465]="773:365",
	[43466]="773:415",
	[43469]="165:440",
	[43478]="185:425",
	[43480]="185:425",
	[43481]="165:440",
	[43482]="755:420",
	[43484]="165:440",
	[43488]="185:350",
	[43490]="185:350",
	[43491]="185:350",
	[43492]="185:350",
	[43495]="165:440",
	[43498]="755:420",
	[43502]="165:440",
	[43515]="773:110",
	[43518]="237:0",
	[43523]="237:0",
	[43533]="773:385",
	[43534]="773:385",
	[43535]="773:75",
	[43536]="773:265",
	[43537]="773:385",
	[43538]="773:385",
	[43539]="773:75",
	[43541]="773:285",
	[43542]="773:385",
	[43543]="773:270",
	[43544]="773:75",
	[43545]="773:385",
	[43546]="773:280",
	[43547]="773:385",
	[43548]="773:300",
	[43549]="773:350",
	[43550]="773:385",
	[43551]="773:330",
	[43552]="773:375",
	[43553]="773:305",
	[43554]="773:345",
	[43565]="165:440",
	[43566]="165:440",
	[43569]="171:410",
	[43570]="171:410",
	[43582]="755:420",
	[43583]="197:425",
	[43584]="197:420",
	[43585]="197:420",
	[43586]="164:425",
	[43587]="164:420",
	[43588]="164:420",
	[43590]="165:425",
	[43591]="165:420",
	[43592]="165:420",
	[43593]="165:425",
	[43594]="165:420",
	[43595]="165:420",
	[43654]="773:125",
	[43655]="773:125",
	[43656]="773:175",
	[43657]="773:175",
	[43660]="773:225",
	[43661]="773:225",
	[43663]="773:275",
	[43664]="773:275",
	[43666]="773:325",
	[43667]="773:325",
	[43671]="773:75",
	[43672]="773:75",
	[43673]="773:75",
	[43674]="773:75",
	[43725]="773:75",
	[43825]="773:310",
	[43826]="773:320",
	[43827]="773:340",
	[43850]="773:200",
	[43853]="164:430",
	[43854]="164:350",
	[43860]="164:395",
	[43864]="164:400",
	[43865]="164:405",
	[43867]="773:385",
	[43868]="773:385",
	[43869]="773:385",
	[43870]="164:415",
	[43871]="164:410",
	[43969]="197:415",
	[43970]="197:420",
	[43971]="197:420",
	[43972]="197:420",
	[43973]="197:420",
	[43974]="197:415",
	[43975]="197:420",
	[44063]="755:400",
	[44142]="773:125",
	[44161]="773:175",
	[44163]="773:225",
	[44210]="773:400",
	[44211]="197:360",
	[44314]="773:200",
	[44315]="773:350",
	[44316]="773:275",
	[44317]="773:325",
	[44318]="773:400",
	[44322]="171:400",
	[44323]="171:400",
	[44324]="171:400",
	[44325]="171:400",
	[44327]="171:400",
	[44328]="171:400",
	[44329]="171:400",
	[44330]="171:400",
	[44331]="171:400",
	[44332]="171:395",
	[44413]="202:450",
	[44436]="165:395",
	[44437]="165:395",
	[44438]="165:400",
	[44440]="165:395",
	[44441]="165:395",
	[44442]="165:400",
	[44443]="165:395",
	[44444]="165:395",
	[44445]="165:400",
	[44446]="165:415",
	[44447]="165:415",
	[44448]="165:415",
	[44452]="333:425",
	[44504]="202:450",
	[44554]="197:0",
	[44558]="197:0",
	[44684]="773:385",
	[44739]="202:390",
	[44740]="202:420",
	[44741]="202:420",
	[44742]="202:420",
	[44836]="185:100",
	[44837]="185:1",
	[44838]="185:280",
	[44839]="185:220",
	[44840]="185:160",
	[44920]="773:75",
	[44922]="773:75",
	[44923]="773:75",
	[44928]="773:375",
	[44930]="165:440",
	[44931]="165:440",
	[44936]="164:450",
	[44939]="171:385",
	[44943]="755:425",
	[44949]="202:440",
	[44951]="202:405",
	[44953]="185:400",
	[44955]="773:75",
	[44958]="171:375",
	[44963]="165:425",
	[45054]="755:300",
	[45085]="164:440",
	[45550]="164:450",
	[45551]="164:450",
	[45552]="164:450",
	[45553]="165:450",
	[45554]="165:450",
	[45555]="165:450",
	[45556]="165:450",
	[45557]="197:450",
	[45558]="197:450",
	[45559]="164:450",
	[45560]="164:450",
	[45561]="164:450",
	[45562]="165:450",
	[45563]="165:450",
	[45564]="165:450",
	[45565]="165:450",
	[45566]="197:450",
	[45567]="197:450",
	[45601]="773:425",
	[45602]="773:0",
	[45603]="773:0",
	[45604]="773:0",
	[45621]="171:135",
	[45622]="773:250",
	[45623]="773:425",
	[45625]="773:0",
	[45626]="197:125",
	[45627]="755:200",
	[45631]="202:250",
	[45731]="773:0",
	[45732]="773:0",
	[45733]="773:0",
	[45734]="773:0",
	[45735]="773:0",
	[45736]="773:0",
	[45737]="773:0",
	[45738]="773:0",
	[45739]="773:0",
	[45740]="773:0",
	[45741]="773:0",
	[45742]="773:0",
	[45743]="773:0",
	[45744]="773:0",
	[45745]="773:0",
	[45746]="773:0",
	[45747]="773:0",
	[45753]="773:0",
	[45755]="773:0",
	[45756]="773:0",
	[45757]="773:0",
	[45758]="773:0",
	[45760]="773:255",
	[45761]="773:0",
	[45762]="773:0",
	[45764]="773:0",
	[45766]="773:0",
	[45767]="773:0",
	[45768]="773:255",
	[45769]="773:0",
	[45770]="773:0",
	[45771]="773:0",
	[45772]="773:0",
	[45773]="197:435",
	[45775]="773:250",
	[45776]="773:255",
	[45777]="773:0",
	[45778]="773:0",
	[45779]="773:0",
	[45780]="773:0",
	[45781]="773:0",
	[45782]="773:0",
	[45783]="773:0",
	[45785]="773:0",
	[45789]="773:0",
	[45790]="773:0",
	[45792]="773:0",
	[45793]="773:0",
	[45794]="773:0",
	[45795]="773:0",
	[45797]="773:0",
	[45799]="773:0",
	[45800]="773:0",
	[45803]="773:0",
	[45804]="773:275",
	[45805]="773:280",
	[45806]="773:0",
	[45808]="755:420",
	[45809]="755:420",
	[45810]="197:405",
	[45811]="197:400",
	[45812]="755:420",
	[45813]="755:420",
	[45849]="773:350",
	[45854]="773:350",
	[45932]="185:400",
	[46372]="773:0",
	[46376]="171:435",
	[46377]="171:435",
	[46378]="171:435",
	[46379]="171:435",
	[46691]="185:1",
	[47499]="171:425",
	[47570]="164:450",
	[47571]="164:450",
	[47572]="164:450",
	[47573]="164:450",
	[47574]="164:450",
	[47575]="164:450",
	[47576]="165:450",
	[47577]="165:450",
	[47579]="165:450",
	[47580]="165:450",
	[47581]="165:450",
	[47582]="165:450",
	[47583]="165:450",
	[47584]="165:450",
	[47585]="197:450",
	[47586]="197:450",
	[47587]="197:450",
	[47588]="197:450",
	[47589]="164:450",
	[47590]="164:450",
	[47591]="164:450",
	[47592]="164:450",
	[47593]="164:450",
	[47594]="164:450",
	[47595]="165:450",
	[47596]="165:450",
	[47597]="165:450",
	[47598]="165:450",
	[47599]="165:450",
	[47600]="165:450",
	[47601]="165:450",
	[47602]="165:450",
	[47603]="197:450",
	[47604]="197:450",
	[47605]="197:450",
	[47606]="197:450",
	[47828]="202:410",
	[48720]="773:100",
	[48933]="202:435",
	[49040]="202:450",
	[49084]="773:75",
	[49110]="755:450",
	[49632]="773:440",
	[49633]="165:450",
	[49634]="165:450",
	[49890]="197:450",
	[49891]="197:450",
	[49892]="197:450",
	[49893]="197:450",
	[49894]="165:450",
	[49895]="165:450",
	[49896]="165:450",
	[49897]="165:450",
	[49898]="165:450",
	[49899]="165:450",
	[49900]="165:450",
	[49901]="165:450",
	[49902]="164:450",
	[49903]="164:450",
	[49904]="164:450",
	[49905]="164:450",
	[49906]="164:450",
	[49907]="164:450",
	[50045]="773:250",
	[50077]="773:375",
	[50125]="773:375",
	[52020]="202:450",
	[52021]="202:450",
})

-- The base item data
Informant.SetDatabase({
	[7]="0:7:2:200:::1:0:", -- 1000G
	[17]="0:4:6:1:Shirt::1:0:", -- Martin Fury
	[25]="0:2:1:1:OneHandSword::1:0:", -- Worn Shortsword
	[35]="0:2:1:1:Stave::1:0:", -- Bent Staff
	[36]="0:2:1:1:OneHandMace::1:0:", -- Worn Mace
	[37]="0:2:1:1:OneHandAxe::1:0:", -- Worn Axe
	[38]="1:4:1:1:Shirt::1:0:18672", -- Recruit's Shirt
	[39]="5:4:0:1:Cloth::1:0:18672", -- Recruit's Pants
	[40]="5:4:1:1:Miscellaneous::1:0:18672", -- Recruit's Boots
	[43]="5:4:1:1:Miscellaneous::1:0:18672", -- Squire's Boots
	[44]="4:4:0:1:Cloth::1:0:18672", -- Squire's Pants
	[45]="1:4:1:1:Shirt::1:0:18672", -- Squire's Shirt
	[47]="0:4:1:1:Miscellaneous::1:0:", -- Footpad's Shoes
	[48]="0:4:0:1:Cloth::1:0:", -- Footpad's Pants
	[49]="0:4:1:1:Shirt::1:0:", -- Footpad's Shirt
	[51]="5:4:1:1:Miscellaneous::1:0:18672", -- Neophyte's Boots
	[52]="5:4:0:1:Cloth::1:0:18672", -- Neophyte's Pants
	[53]="1:4:1:1:Shirt::1:0:18672", -- Neophyte's Shirt
	[55]="5:4:1:1:Miscellaneous::1:0:18672", -- Apprentice's Boots
	[56]="5:4:0:1:Cloth::1:0:18672", -- Apprentice's Robe
	[57]="5:4:0:1:Cloth::1:0:18672", -- Acolyte's Robe
	[59]="5:4:1:1:Miscellaneous::1:0:18672", -- Acolyte's Shoes
	[60]="0:4:1:1:Leather::1:0:", -- Layered Tunic
	[61]="0:4:1:1:Leather::1:0:", -- Dwarven Leather Pants
	[79]="0:4:1:1:Cloth::1:0:", -- Dwarven Cloth Britches
	[80]="0:4:1:1:Cloth::1:0:", -- Soft Fur-lined Shoes
	[85]="63:4:1:1:Leather::1:0:2113,3074,3160,4558", -- Dirty Leather Vest
	[117]="25:0:1:20:FoodDrink::5:0:982,1464,2365,2388,2814,3025,3089,3312,3368,3411,3489,3621,3705,3881,3882,3933,3935,3960,4084,4169,4782,4875,4879,4891,4894,4954,5111,5124,5611,5620,5870,6928,6929,7485,7731,7733,8125,9356,11118,11187,12196,12959,14624,15174,15397,16443,16618,16739,17553,17630,17656,19182,23263,23481,23605,24208,24343", -- Tough Jerky
	[118]="0:0:1:20:Potion:171:1:0:", -- Minor Healing Potion
	[120]="0:4:0:1:Cloth::1:0:", -- Thug Pants
	[121]="0:4:1:1:Miscellaneous::1:0:", -- Thug Boots
	[127]="0:4:1:1:Shirt::1:0:", -- Trapper's Shirt
	[129]="0:4:1:1:Miscellaneous::1:0:", -- Rugged Trapper's Boots
	[139]="0:4:0:1:Cloth::1:0:", -- Brawler's Pants
	[140]="0:4:1:1:Miscellaneous::1:0:", -- Brawler's Boots
	[147]="0:4:0:1:Cloth::1:0:", -- Rugged Trapper's Pants
	[148]="0:4:1:1:Shirt::1:0:", -- Rugged Trapper's Shirt
	[153]="0:4:0:1:Leather::1:0:", -- Primitive Kilt
	[154]="0:4:1:1:Shirt::1:0:", -- Primitive Mantle
	[159]="25:0:1:20:FoodDrink:185,202:5:0:151,152,227,258,274,295,465,491,734,791,829,955,982,1149,1237,1247,1250,1285,1328,1448,1452,1464,1682,1685,1691,1697,2084,2115,2134,2140,2303,2352,2364,2366,2381,2388,2397,2401,2664,2803,2806,2808,2820,2832,2908,3027,3072,3076,3085,3086,3158,3164,3186,3298,3313,3350,3400,3411,3481,3498,3541,3546,3577,3587,3608,3621,3625,3689,3708,3881,3882,3883,3884,3934,3937,3959,3961,3962,4082,4084,4167,4169,4170,4181,4182,4190,4191,4192,4195,4223,4241,4265,4266,4553,4554,4555,4571,4782,4875,4876,4879,4893,4896,4981,5101,5111,5112,5134,5140,5160,5483,5611,5620,5688,5814,5871,6091,6272,6495,6727,6734,6735,6736,6737,6738,6739,6740,6741,6746,6747,6790,6791,6807,6928,6929,6930,7485,7714,7731,7733,7736,7737,7744,7941,7942,7943,8125,8137,8139,8143,8150,8152,8307,8362,8931,9356,9501,11038,11103,11106,11116,11118,11187,11287,11555,12019,12021,12026,12027,12033,12196,12246,12959,12960,14371,14624,14731,14738,15174,15287,15397,15433,16187,16191,16253,16256,16259,16260,16443,16444,16458,16542,16553,16618,16677,16718,16732,16739,16920,17246,17421,17446,17489,17553,17630,17656,18810,18811,18987,18988,18993,19182,19195,19371,19617,20028,20096,20097,21145,23573,23995,24208,24834,24934,24993,25012,25020,25052,25089,26868,28811,29291,31031,31032,33595,34645,34681,34682,34683,34684,34685,34783,34787,35337,35338,35340,35341,35342,35343", -- Refreshing Spring Water
	[182]="0:12:1:1:::1:0:", -- Garrick's Head
	[192]="0:2:0:1:Miscellaneous::1:0:", -- Martin's Broken Staff
	[193]="49:4:1:1:Cloth::1:0:2113,3160,4558", -- Tattered Cloth Vest
	[194]="49:4:1:1:Cloth::1:0:2113,3160,4558", -- Tattered Cloth Pants
	[195]="37:4:1:1:Cloth::1:0:2113,3160,4558", -- Tattered Cloth Boots
	[200]="2270:4:1:1:Cloth::1:0:1291,2849,3092,3317,3492,3952,4175,4188,5155,5821,8358,16623,16716", -- Thick Cloth Vest
	[201]="2278:4:1:1:Cloth::1:0:1291,2849,3092,3317,3492,3952,4175,4188,5155,5821,8358,16623,16716", -- Thick Cloth Pants
	[202]="1715:4:1:1:Cloth::1:0:1291,2849,3092,3317,3492,3952,4175,4188,5155,5821,8358,16623,16716", -- Thick Cloth Shoes
	[203]="1147:4:1:1:Cloth::1:0:1291,2849,3092,3317,3492,3952,4175,4188,5155,5821,8358,16623,16716", -- Thick Cloth Gloves
	[209]="61:4:1:1:Leather::1:0:2113,3074,3160,4558", -- Dirty Leather Pants
	[210]="45:4:1:1:Leather::1:0:2113,3074,3160,4558", -- Dirty Leather Boots
	[236]="2795:4:1:1:Leather::1:0:1295,1695,3093,3097,3321,3492,3536,3953,4236,5783,5820,8359,16691,16747", -- Cured Leather Armor
	[237]="2806:4:1:1:Leather::1:0:1295,1695,3093,3097,3321,3492,3536,3953,4236,5783,5820,8359,16691,16747", -- Cured Leather Pants
	[238]="2112:4:1:1:Leather::1:0:1295,1695,3093,3097,3321,3492,3536,3953,4236,5783,5820,8359,16691,16747", -- Cured Leather Boots
	[239]="1413:4:1:1:Leather::1:0:1295,1695,3093,3097,3321,3492,3536,3953,4236,5783,5820,8359,16691,16747", -- Cured Leather Gloves
	[285]="3555:4:1:1:Mail::1:0:956,1294,1341,3319,3493,3543,3682,4177,5125,5812,5819,8360,16625,16750", -- Scalemail Vest
	[286]="3229:4:1:1:Mail::1:0:956,1294,1341,3319,3493,3543,3682,4177,5125,5812,5819,8360,16625,16750", -- Scalemail Pants
	[287]="2442:4:1:1:Mail::1:0:956,1294,1341,3319,3493,3543,3682,4177,5125,5812,5819,8360,16625,16750", -- Scalemail Boots
	[414]="125:0:1:20:FoodDrink::5:0:295,465,483,1237,2352,2364,3298,3546,4782,4891,4894,4981,5620,6746,6790,6930,9501,11106,11116,16553,17630,18929,23521,23604,24934,29714", -- Dalaran Sharp
	[422]="500:0:1:20:FoodDrink::5:0:295,465,483,1237,2352,2364,3298,3546,4782,4891,4894,4981,5620,6746,6790,6930,9501,11106,11116,16553,17630,18929,23521,23604,24934", -- Dwarven Mild
	[537]="0:15:0:5:Junk::1:0:", -- Dull Frenzy Scale
	[555]="0:15:0:10:Junk::1:0:", -- Rough Vulture Feathers
	[556]="0:15:0:5:Junk::1:0:", -- Buzzard Beak
	[647]="0:2:4:1:TwoHandSword::1:0:", -- Destiny
	[710]="0:4:1:1:Cloth::1:0:", -- Bracers of the People's Militia
	[711]="26:4:1:1:Cloth::1:0:2113,3160,4558", -- Tattered Cloth Gloves
	[714]="32:4:1:1:Leather::1:0:2113,3074,3160,4558", -- Dirty Leather Gloves
	[718]="1614:4:1:1:Mail::1:0:956,1294,1341,3319,3493,3543,3682,4177,5125,5812,5819,8360,16625,16750", -- Scalemail Gloves
	[719]="0:4:1:1:Cloth::1:0:", -- Rabbit Handler Gloves
	[720]="0:4:3:1:Leather::1:0:", -- Brawler Gloves
	[723]="0:7:1:20:Meat:185:1:0:", -- Goretusk Liver
	[724]="0:0:1:20:FoodDrink::1:0:", -- Goretusk Liver Pie
	[725]="0:12:1:20:::1:0:", -- Gnoll Paw
	[727]="0:2:2:1:OneHandSword::1:0:", -- Notched Shortsword
	[728]="200:9:1:1:Cooking::1:0:340", -- Recipe: Westfall Stew
	[729]="0:7:1:20:Meat:185:1:0:", -- Stringy Vulture Meat
	[730]="0:7:1:20:Meat:185:1:0:", -- Murloc Eye
	[731]="0:7:1:20:Meat:185:1:0:", -- Goretusk Snout
	[732]="0:12:1:10:::1:0:", -- Okra
	[733]="0:0:1:20:FoodDrink::1:0:", -- Westfall Stew
	[735]="0:12:1:1:::1:0:", -- Rolf and Malakai's Medallions
	[737]="0:12:1:1:::1:0:", -- Holy Spring Water
	[738]="0:12:1:20:::1:0:", -- Sack of Barley
	[739]="0:12:1:20:::1:0:", -- Sack of Corn
	[740]="0:12:1:20:::1:0:", -- Sack of Rye
	[742]="0:12:1:1:::1:0:", -- A Sycamore Branch
	[743]="0:12:1:1:::1:0:", -- Bundle of Charred Oak
	[744]="0:4:2:1:Trinket::1:0:", -- Thunderbrew's Boot Flask
	[745]="0:12:1:1:::1:0:", -- Marshal McBride's Documents
	[748]="0:12:1:1:::1:0:", -- Stormwind Armor Marker
	[750]="0:12:1:20:::1:0:", -- Tough Wolf Meat
	[752]="0:12:1:20:::1:0:", -- Red Burlap Bandana
	[753]="0:2:2:1:OneHandSword::1:0:", -- Dragonmaw Shortsword
	[754]="0:2:3:1:OneHandSword::1:0:", -- Shortsword of Vengeance
	[755]="0:15:0:5:Junk::1:0:", -- Melted Candle
	[756]="0:2:2:1:TwoHandAxe::1:0:", -- Tunnel Pick
	[763]="0:4:1:1:Leather::1:0:", -- Ice-covered Bracers
	[765]="40:7:1:20:Herb:171:1:1:1313,3490,3548,16224,16641,16705", -- Silverleaf
	[766]="0:2:1:1:OneHandMace::1:0:", -- Flanged Mace
	[767]="0:2:1:1:Stave::1:0:", -- Long Bo Staff
	[768]="0:2:1:1:OneHandAxe::1:0:", -- Lumberjack Axe
	[769]="0:7:1:20:Meat:185:1:0:", -- Chunk of Boar Meat
	[770]="0:15:0:10:Junk::1:0:", -- Pointy Crocolisk Tooth
	[771]="0:15:0:5:Junk::1:0:", -- Chipped Boar Tusk
	[772]="0:12:1:20:::1:0:", -- Large Candle
	[773]="0:12:1:20:::1:0:", -- Gold Dust
	[774]="0:3:2:20:GemSimple:164,202,755:1:0:", -- Malachite
	[776]="0:2:3:1:Dagger::1:0:", -- Vendetta
	[777]="0:15:0:10:Junk::1:0:", -- Prowler Teeth
	[778]="0:2:1:1:OneHandAxe::1:0:", -- Kobold Excavation Pick
	[779]="0:15:0:5:Junk::1:0:", -- Shiny Seashell
	[780]="0:12:1:20:::1:0:", -- Torn Murloc Fin
	[781]="0:2:1:1:OneHandMace::1:0:", -- Stone Gnoll Hammer
	[782]="0:12:1:20:::1:0:", -- Painted Gnoll Armband
	[783]="0:7:1:10:Leather:165:1:0:", -- Light Hide
	[785]="80:7:1:20:Herb:171,185:1:1:844,1302,1313,3490,3548,4083,4878,8305,14846,16224,16641,16705", -- Mageroyal
	[787]="25:0:1:20:FoodDrink::5:0:1678,1684,2842,3086,3178,3497,3540,4200,4221,4305,4307,5814,6727,6738,6791,6807,7943,8137,8931,11187,12962,14731,16618,16739,17553,17656,19045,23896,24834,24993,25012,25020,25052,25089,29291", -- Slitherskin Mackerel
	[789]="0:2:2:1:OneHandMace::1:0:", -- Stout Battlehammer
	[790]="0:2:2:1:OneHandAxe::1:0:", -- Forester's Axe
	[791]="0:2:3:1:Stave::1:0:", -- Gnarled Ash Staff
	[792]="208:4:1:1:Cloth::1:0:74,959,1238,1291,2264,3092,3530,3531,3611,3952,4164,4175,5821,16716,17929", -- Knitted Sandals
	[793]="139:4:1:1:Cloth::1:0:74,959,1238,1291,2264,3092,3530,3531,3611,3952,4164,4175,5821,16716,17929", -- Knitted Gloves
	[794]="280:4:1:1:Cloth::1:0:74,959,1238,1291,2264,3092,3530,3531,3611,3952,4164,4175,5821,16716,17929", -- Knitted Pants
	[795]="281:4:1:1:Cloth::1:0:74,959,1238,1291,2264,3092,3530,3531,3611,3952,4164,4175,5821,16716,17929", -- Knitted Tunic
	[796]="264:4:1:1:Leather::1:0:74,896,1238,1295,3162,3532,3612,3953,4164,4236,5820,16747,17929", -- Rough Leather Boots
	[797]="177:4:1:1:Leather::1:0:74,896,1238,1295,3162,3532,3612,3953,4164,4236,5820,16747,17929", -- Rough Leather Gloves
	[798]="355:4:1:1:Leather::1:0:74,896,1238,1295,3162,3532,3612,3953,4164,4236,5820,16747,17929", -- Rough Leather Pants
	[799]="356:4:1:1:Leather::1:0:74,896,1238,1295,3162,3532,3612,3953,4164,4236,5820,16747,17929", -- Rough Leather Vest
	[804]="0:1:1:1:Bag::1:0:", -- Large Blue Sack
	[805]="0:1:1:1:Bag::1:0:", -- Small Red Pouch
	[809]="0:2:4:1:OneHandSword::1:0:", -- Bloodrazor
	[810]="0:2:4:1:OneHandMace::1:0:", -- Hammer of the Northern Wind
	[811]="0:2:4:1:OneHandAxe::1:0:", -- Axe of the Deep Woods
	[812]="0:2:4:1:Stave::1:0:", -- Glowing Brightwood Staff
	[814]="0:7:1:20:Part:202:1:0:", -- Flask of Oil
	[816]="0:2:2:1:Dagger::1:0:", -- Small Hand Blade
	[818]="0:3:2:20:GemSimple:164,202,755:1:0:", -- Tigerseye
	[820]="0:2:2:1:Dagger::1:0:", -- Slicer Blade
	[821]="0:4:2:1:Leather::1:0:", -- Riverpaw Leather Vest
	[826]="0:2:2:1:OneHandAxe::1:0:", -- Brutish Riverpaw Axe
	[827]="0:2:2:1:OneHandMace::1:0:", -- Wicked Blackjack
	[828]="0:1:1:1:Bag::1:0:", -- Small Blue Pouch
	[829]="0:12:1:20:::1:0:", -- Red Leather Bandana
	[832]="0:4:2:1:Mail::1:0:", -- Silver Defias Belt
	[833]="0:4:4:1:Trinket::1:0:", -- Lifestone
	[835]="0:0:1:1:Consumable::1:0:", -- Large Rope Net
	[837]="1125:4:1:1:Cloth::1:0:1214,1291,3092,3317,3486,3554,3683,3952,4164,4175,4185,4558,5108,5821,8358,16623,16631,16716", -- Heavy Weave Armor
	[838]="1129:4:1:1:Cloth::1:0:1214,1291,3092,3317,3486,3554,3683,3952,4164,4175,4185,4558,5108,5821,8358,16623,16631,16716", -- Heavy Weave Pants
	[839]="566:4:1:1:Cloth::1:0:1214,1291,3092,3317,3486,3554,3683,3952,4164,4175,4185,4558,5108,5821,8358,16623,16631,16716", -- Heavy Weave Gloves
	[840]="853:4:1:1:Cloth::1:0:1214,1291,3092,3317,3486,3554,3683,3952,4164,4175,4185,4558,5108,5821,8358,16623,16631,16716", -- Heavy Weave Shoes
	[841]="0:12:1:1:::1:0:", -- Furlbrow's Pocket Watch
	[843]="1077:4:1:1:Leather::1:0:896,954,1295,1669,3093,3321,3483,3552,3684,3953,4164,4186,4236,4558,5108,5820,8359,10380,16691,16747", -- Tanned Leather Boots
	[844]="721:4:1:1:Leather::1:0:896,954,1295,1669,3093,3321,3483,3552,3684,3953,4164,4186,4236,4558,5108,5820,8359,10380,16691,16747", -- Tanned Leather Gloves
	[845]="1447:4:1:1:Leather::1:0:896,954,1295,1669,3093,3321,3483,3552,3684,3953,4164,4186,4236,4558,5108,5820,8359,10380,16691,16747", -- Tanned Leather Pants
	[846]="1452:4:1:1:Leather::1:0:896,954,1295,1669,3093,3321,3483,3552,3684,3953,4164,4186,4236,4558,5108,5820,8359,10380,16691,16747", -- Tanned Leather Jerkin
	[847]="1749:4:1:1:Mail::1:0:167,1294,1362,3319,3483,3528,3529,3553,4164,4177,4187,4560,5107,5812,5819,8360,11703,16625,16750", -- Chainmail Armor
	[848]="1755:4:1:1:Mail::1:0:167,1294,1362,3319,3483,3528,3529,3553,4164,4177,4187,4560,5107,5812,5819,8360,11703,16625,16750", -- Chainmail Pants
	[849]="1327:4:1:1:Mail::1:0:167,1294,1362,3319,3483,3528,3529,3553,4164,4177,4187,4560,5107,5812,5819,8360,11703,16625,16750", -- Chainmail Boots
	[850]="883:4:1:1:Mail::1:0:167,1294,1362,3319,3483,3528,3529,3553,4164,4177,4187,4560,5107,5812,5819,8360,11703,16625,16750", -- Chainmail Gloves
	[851]="2023:2:1:1:OneHandSword::1:0:1287,1289,2997,3021,3314,3331,3361,3479,3534,3658,4171,4183,4203,4231,4557,4569,5103,5120,16714", -- Cutlass
	[852]="1739:2:1:1:OneHandMace::1:0:222,1287,1289,1348,2840,2997,3020,3314,3360,3479,3534,3658,4183,4203,4231,4233,4557,4602,5103,5121,16765,17412", -- Mace
	[853]="2409:2:1:1:OneHandAxe::1:0:1287,1289,2997,3019,3314,3409,3479,3534,3658,4183,4203,4231,4232,4557,4601,5103,5119,16714", -- Hatchet
	[854]="3023:2:1:1:Stave::1:0:1287,1289,1348,2997,3020,3314,3360,3409,3479,3534,3658,4183,4203,4231,4233,4557,4602,5103,5121,16765,17412,19238", -- Quarter Staff
	[856]="0:1:1:1:Bag::1:0:", -- Blue Leather Bag
	[857]="0:1:1:1:Bag::1:0:", -- Large Red Sack
	[858]="100:0:1:20:Potion::1:1:844,958,1257,2140,3548,3658,14847", -- Lesser Healing Potion
	[859]="0:4:1:1:Shirt::1:0:", -- Fine Cloth Shirt
	[860]="0:4:1:1:Cloth::1:0:", -- Cavalier's Boots
	[862]="0:4:3:1:Ring::1:0:", -- Runed Ring
	[863]="0:2:2:1:OneHandAxe::1:0:", -- Gloom Reaper
	[864]="0:2:2:1:OneHandSword::1:0:", -- Knightly Longsword
	[865]="0:2:2:1:OneHandMace::1:0:", -- Leaden Mace
	[866]="0:2:2:1:Stave::1:0:", -- Monk's Staff
	[867]="0:4:4:1:Leather::1:0:", -- Gloves of Holy Might
	[868]="0:2:4:1:OneHandMace::1:0:", -- Ardent Custodian
	[869]="0:2:4:1:OneHandSword::1:0:", -- Dazzling Longsword
	[870]="0:2:4:1:TwoHandAxe::1:0:", -- Fiery War Axe
	[871]="0:2:4:1:OneHandAxe::1:0:", -- Flurry Axe
	[872]="0:2:3:1:TwoHandAxe::1:0:", -- Rockslicer
	[873]="0:2:4:1:Stave::1:0:", -- Staff of Jordan
	[878]="0:7:0:10:Other::1:0:", -- Fist-sized Spinneret
	[880]="0:2:2:1:Stave::1:0:", -- Staff of Horrors
	[884]="0:12:1:20:::1:0:", -- Ghoul Rib
	[885]="0:2:2:1:OneHandAxe::1:0:", -- Black Metal Axe
	[886]="0:2:2:1:OneHandSword::1:0:", -- Black Metal Shortsword
	[887]="0:15:0:5:Junk::1:0:", -- Pound of Flesh
	[888]="0:4:3:1:Leather::1:0:", -- Naga Battle Gloves
	[889]="0:12:1:1:::1:0:", -- A Dusty Unsent Letter
	[890]="0:2:3:1:Stave::1:0:", -- Twisted Chanter's Staff
	[892]="0:4:2:1:Cloth::1:0:", -- Gnoll Casting Gloves
	[893]="0:15:0:10:Junk::1:0:", -- Dire Wolf Fang
	[895]="0:12:1:20:::1:0:", -- Worgen Skull
	[896]="0:12:1:20:::1:0:", -- Worgen Fang
	[897]="0:4:2:1:Leather::1:0:", -- Madwolf Bracers
	[899]="0:2:2:1:Dagger::1:0:", -- Venom Web Fang
	[910]="0:12:1:1:::1:0:", -- An Undelivered Letter
	[911]="0:2:2:1:TwoHandMace::1:0:", -- Ironwood Treebranch
	[914]="0:4:2:1:Mail::1:0:", -- Large Ogre Chain Armor
	[915]="0:12:1:20:::1:0:", -- Red Silk Bandana
	[916]="0:12:1:1:::1:0:", -- A Torn Journal Page
	[918]="0:1:1:1:Bag::1:0:", -- Deviate Hide Pack
	[920]="0:2:2:1:OneHandMace::1:0:", -- Wicked Spiked Mace
	[921]="0:12:1:1:::1:0:", -- A Faded Journal Page
	[922]="12039:2:1:1:TwoHandSword::1:0:225,1287,1289,1441,3021,3331,3361,3539,4086,4171,4203,4569,5120,11137,16714", -- Dacian Falx
	[923]="8744:2:1:1:OneHandSword::1:0:225,1287,1289,1441,3021,3331,3361,3539,4086,4171,4203,4569,5120,11137,16714", -- Longsword
	[924]="10973:2:1:1:TwoHandMace::1:0:225,1287,1289,1348,1441,3020,3360,3539,4086,4203,4233,4602,5121,11137,16765,17412", -- Maul
	[925]="7797:2:1:1:OneHandMace::1:0:225,1287,1289,1348,1441,3020,3360,3539,4086,4203,4233,4602,5121,11137,16765,17412", -- Flail
	[926]="9785:2:1:1:TwoHandAxe::1:0:225,1287,1289,1441,3019,3409,3539,4086,4203,4232,4601,5119,11137,16714", -- Battle Axe
	[927]="6954:2:1:1:OneHandAxe::1:0:225,1287,1289,1441,3019,3409,3539,4086,4203,4232,4601,5119,11137,16714", -- Double Axe
	[928]="9860:2:1:1:Stave::1:0:225,1287,1289,1348,1441,3020,3360,3409,3539,4086,4203,4233,4602,5121,11137,16765,17412,19238", -- Long Staff
	[929]="300:0:1:20:Potion:197:1:1:1307,1453,1457,2481,2805,3134,3534,3956,4083,4878,8305,13476,18810", -- Healing Potion
	[932]="0:1:1:1:Bag::1:0:", -- Fel Steed Saddlebags
	[933]="0:1:1:1:Bag::1:0:", -- Large Rucksack
	[934]="0:2:3:1:OneHandAxe::1:0:", -- Stalvan's Reaper
	[935]="0:2:3:1:OneHandSword::1:0:", -- Night Watch Shortsword
	[936]="0:2:3:1:OneHandMace::1:0:", -- Midnight Mace
	[937]="0:2:3:1:Stave::1:0:", -- Black Duskwood Staff
	[938]="0:12:1:1:::1:0:", -- Muddy Journal Pages
	[939]="0:12:1:1:::1:0:", -- A Bloodstained Journal Page
	[940]="0:4:4:1:Cloth::1:0:", -- Robes of Insight
	[942]="0:4:4:1:Ring::1:0:", -- Freezing Band
	[943]="0:2:4:1:Stave::1:0:", -- Warden Staff
	[944]="0:2:4:1:Stave::1:0:", -- Elemental Mage Staff
	[954]="200:0:1:20:Scroll::1:1:958,1316,2805,4581,4878,13476,14847,16224", -- Scroll of Strength
	[955]="150:0:1:20:Scroll::1:1:958,1316,4581,14847,16224", -- Scroll of Intellect
	[957]="0:12:1:1:::1:0:", -- William's Shipment
	[961]="0:0:1:10:FoodDrink::1:0:", -- Healing Herb
	[962]="0:12:1:1:::1:0:", -- Pork Belly Pie
	[981]="0:12:1:1:::1:0:", -- Bernice's Necklace
	[983]="0:4:1:1:Cloth::1:0:", -- Red Linen Sash
	[1006]="0:12:1:1:::1:0:", -- Brass Collar
	[1008]="0:2:1:1:OneHandSword::1:0:", -- Well-used Sword
	[1009]="0:2:2:1:OneHandMace::1:0:", -- Compact Hammer
	[1010]="0:2:1:1:Stave::1:0:", -- Gnarled Short Staff
	[1011]="0:2:1:1:OneHandAxe::1:0:", -- Sharp Axe
	[1013]="0:12:1:20:::1:0:", -- Iron Rivet
	[1015]="0:7:1:20:Meat:185:1:0:", -- Lean Wolf Flank
	[1017]="0:0:1:20:FoodDrink::1:0:", -- Seasoned Wolf Kabob
	[1019]="0:12:1:20:::1:0:", -- Red Linen Bandana
	[1074]="0:15:0:5:Junk::1:0:", -- Hard Spider Leg Tip
	[1075]="0:12:1:20:::1:0:", -- Shadowhide Pendant
	[1076]="0:4:2:1:Ring::1:0:", -- Defias Renegade Ring
	[1077]="0:4:2:1:Ring::1:0:", -- Defias Mage Ring
	[1080]="0:7:1:20:Meat:185:1:0:", -- Tough Condor Meat
	[1081]="0:7:1:20:Meat:185:1:0:", -- Crisp Spider Meat
	[1082]="0:0:1:20:FoodDrink::1:0:", -- Redridge Goulash
	[1083]="0:12:1:20:::1:0:", -- Glyph of Azora
	[1113]="0:0:1:20:FoodDrink::1:0:", -- Conjured Bread
	[1114]="0:0:1:20:FoodDrink::1:0:", -- Conjured Rye
	[1116]="0:4:2:1:Ring::1:0:", -- Ring of Pure Silver
	[1121]="0:4:3:1:Leather::1:0:", -- Feet of the Lynx
	[1127]="0:0:1:10:Consumable::1:0:", -- Flash Bundle
	[1129]="0:12:1:20:::1:0:", -- Ghoul Fang
	[1130]="0:12:1:20:::1:0:", -- Vial of Spider Venom
	[1131]="0:4:2:1:OffHandFrill::1:0:", -- Totem of Infliction
	[1132]="10000:15:3:1:Mount::1:0:3362", -- Horn of the Timber Wolf
	[1154]="0:4:1:1:Mail::1:0:", -- Belt of the People's Militia
	[1155]="0:2:3:1:Stave::1:0:", -- Rod of the Sleepwalker
	[1156]="0:4:3:1:Ring::1:0:", -- Lavishly Jeweled Ring
	[1158]="0:2:1:1:OneHandMace::1:0:", -- Solid Metal Club
	[1159]="0:2:1:1:Stave::1:0:", -- Militia Quarterstaff
	[1161]="0:2:1:1:OneHandSword::1:0:", -- Militia Shortsword
	[1166]="0:4:1:1:Shield::1:0:", -- Dented Buckler
	[1167]="0:4:1:1:Shield::1:0:", -- Small Targe
	[1168]="0:4:4:1:Shield::1:0:", -- Skullflame Shield
	[1169]="0:4:4:1:Shield::1:0:", -- Blackskull Shield
	[1171]="0:4:1:1:Cloth::1:0:", -- Well-stitched Robe
	[1172]="0:4:2:1:OffHandFrill::1:0:", -- Grayson's Torch
	[1173]="0:4:1:1:Leather::1:0:", -- Weather-worn Boots
	[1175]="0:15:0:1:Junk::1:0:", -- A Gold Tooth
	[1177]="0:0:1:10:Other::1:0:", -- Oil of Olaf
	[1178]="0:0:1:20:Other::1:0:", -- Explosive Rocket
	[1179]="125:0:1:20:FoodDrink:185:5:0:227,258,274,295,465,491,734,791,955,982,1237,1247,1285,1328,1448,1452,1464,1682,1685,1697,2140,2303,2352,2364,2366,2388,2401,2803,2806,2832,3086,3298,3313,3411,3481,3498,3541,3546,3577,3621,3689,3708,3881,3882,3883,3884,3934,3937,3959,3961,3962,4082,4084,4167,4169,4181,4182,4190,4191,4192,4195,4266,4554,4555,4571,4782,4875,4876,4879,4893,4981,5111,5112,5140,5611,5620,5688,5814,5871,6091,6272,6495,6727,6734,6735,6736,6737,6738,6739,6740,6741,6746,6747,6790,6791,6807,6928,6929,6930,7485,7714,7731,7733,7736,7737,7744,7941,7942,7943,8125,8137,8139,8143,8150,8152,8362,8931,9356,9501,11038,11103,11106,11116,11118,11187,11287,12019,12021,12026,12027,12196,12959,12960,14371,14624,14731,15174,15397,15433,16187,16191,16256,16443,16444,16458,16542,16553,16618,16732,16739,17421,17489,17553,17630,17656,18810,18811,19182,19617,21145,23573,23995,24208,24834,24934,24993,25012,25020,25052,25089,29291", -- Ice Cold Milk
	[1180]="150:0:1:20:Scroll::1:1:958,1316,4581,14847,16224", -- Scroll of Stamina
	[1181]="100:0:1:20:Scroll::1:1:958,1316,4581,14847,16224", -- Scroll of Spirit
	[1182]="0:4:1:1:Mail::1:0:", -- Brass-studded Bracers
	[1183]="0:4:1:1:Cloth::1:0:", -- Elastic Wristguards
	[1187]="0:15:2:1:CombatPet::1:0:", -- Spiked Collar
	[1189]="0:4:2:1:Ring::1:0:", -- Overseer's Ring
	[1190]="0:4:2:1:Cloak::1:0:", -- Overseer's Cloak
	[1191]="0:0:1:1:Consumable::1:0:", -- Bag of Marbles
	[1193]="0:4:1:1:Shield::1:0:", -- Banded Buckler
	[1194]="104:2:1:1:TwoHandSword::1:0:78,945,2117,2997,3073,3159,3314,3588,4231,4556,5102,16919", -- Bastard Sword
	[1195]="0:2:1:1:TwoHandMace::1:0:", -- Kobold Mining Shovel
	[1196]="2214:2:1:1:TwoHandAxe::1:0:1287,1289,2997,3019,3314,3409,3479,3534,3658,4183,4203,4231,4232,4557,4601,5103,5119,16714", -- Tabar
	[1197]="2667:2:1:1:TwoHandMace::1:0:222,1287,1289,1348,2840,2997,3020,3314,3360,3479,3534,3658,4183,4203,4231,4233,4557,4602,5103,5121,16765,17412", -- Giant Mace
	[1198]="2677:2:1:1:TwoHandSword::1:0:1287,1289,2997,3021,3314,3331,3361,3479,3534,3658,4171,4183,4203,4231,4557,4569,5103,5120,16714", -- Claymore
	[1200]="82:4:1:1:Shield::1:0:2116,3075,3161,4559,16693", -- Large Wooden Shield
	[1201]="473:4:1:1:Shield::1:0:1249,2046,3613,4240,5106,16762,17930", -- Dull Heater Shield
	[1202]="1839:4:1:1:Shield::1:0:3319,3528,3529,4187,4559,4560,5107,8360,16693,16762", -- Wall Shield
	[1203]="0:4:3:1:Shield::1:0:", -- Aegis of Stormwind
	[1204]="0:4:4:1:Shield::1:0:", -- The Green Tower
	[1205]="500:0:1:20:FoodDrink::5:0:227,258,274,295,465,734,791,955,982,1149,1237,1247,1285,1328,1448,1452,1464,1697,2084,2303,2352,2364,2366,2388,2401,2803,2806,2808,2820,2832,2908,3086,3298,3313,3350,3411,3498,3541,3546,3577,3621,3625,3689,3708,3881,3882,3883,3884,3934,3937,3959,3961,3962,4082,4084,4167,4169,4170,4181,4190,4191,4192,4195,4241,4266,4554,4555,4571,4782,4875,4876,4879,4893,4896,4981,5101,5111,5112,5134,5140,5611,5620,5688,5814,5871,6091,6272,6495,6727,6734,6735,6736,6737,6738,6739,6740,6741,6746,6747,6790,6791,6807,6928,6929,6930,7485,7714,7731,7733,7736,7737,7744,7941,7942,7943,8125,8137,8139,8143,8150,8152,8362,8931,9356,9501,11038,11103,11106,11116,11118,11187,11287,11555,12019,12021,12026,12027,12196,12246,12959,12960,14371,14624,14731,14963,14964,15124,15125,15174,15397,15433,16191,16256,16443,16458,16542,16553,16618,16732,16739,17489,17553,17630,17656,18811,19182,19617,21145,23573,23995,24208,24834,24934,24993,25012,25020,25052,25089,29291", -- Melon Juice
	[1206]="0:3:2:20:GemSimple:164,202,755,165:1:0:", -- Moss Agate
	[1207]="0:2:2:1:OneHandMace::1:0:", -- Murphstar
	[1208]="0:12:1:1:::1:0:", -- Maybell's Love Letter
	[1210]="0:3:2:20:GemSimple:164,202,755:1:0:", -- Shadowgem
	[1211]="0:4:2:1:Leather::1:0:", -- Gnoll War Harness
	[1212]="0:15:0:5:Junk::1:0:", -- Gnoll Spittle
	[1213]="0:4:1:1:Leather::1:0:", -- Gnoll Kindred Bracers
	[1214]="0:2:2:1:OneHandMace::1:0:", -- Gnoll Punisher
	[1215]="0:4:2:1:Leather::1:0:", -- Support Girdle
	[1218]="0:2:2:1:TwoHandMace::1:0:", -- Heavy Gnoll War Club
	[1219]="0:2:2:1:OneHandSword::1:0:", -- Redridge Machete
	[1220]="0:2:2:1:TwoHandAxe::1:0:", -- Lupine Axe
	[1221]="0:12:1:20:::1:0:", -- Underbelly Whelp Scale
	[1251]="0:0:1:20:Bandage::1:0:", -- Linen Bandage
	[1252]="0:12:1:1:::1:0:", -- Gramma Stonefield's Note
	[1256]="0:12:1:20:::1:0:", -- Crystal Kelp Frond
	[1257]="0:12:1:1:::1:0:", -- Invisibility Liquor
	[1260]="0:12:1:1:::1:0:", -- Tharil'zun's Head
	[1261]="0:12:1:20:::1:0:", -- Midnight Orb
	[1262]="0:0:1:1:Consumable::1:0:", -- Keg of Thunderbrew Lager
	[1263]="0:2:4:1:TwoHandAxe::1:0:", -- Brain Hacker
	[1264]="0:2:2:1:TwoHandMace::1:0:", -- Headbasher
	[1265]="0:2:3:1:OneHandSword::1:0:", -- Scorpion Sting
	[1270]="0:4:2:1:Cloak::1:0:", -- Finely Woven Cloak
	[1273]="0:4:2:1:Mail::1:0:", -- Forest Chain
	[1274]="0:12:1:20:::1:0:", -- Hops
	[1275]="0:4:2:1:Mail::1:0:", -- Deputy Chain Coat
	[1276]="0:4:2:1:Shield::1:0:", -- Fire Hardened Buckler
	[1280]="0:4:2:1:Leather::1:0:", -- Cloaked Hood
	[1282]="0:4:2:1:Mail::1:0:", -- Sparkmetal Coif
	[1283]="0:12:1:1:::1:0:", -- Verner's Note
	[1284]="0:12:1:1:::1:0:", -- Crate of Horseshoes
	[1287]="0:2:2:1:Dagger::1:0:", -- Giant Tarantula Fang
	[1288]="0:7:1:5:Other:171,129:1:0:", -- Large Venom Sac
	[1292]="0:2:3:1:OneHandAxe::1:0:", -- Butcher's Cleaver
	[1293]="0:12:1:1:::1:0:", -- The State of Lakeshire
	[1294]="0:12:1:1:::1:0:", -- The General's Response
	[1296]="0:2:2:1:OneHandMace::1:0:", -- Blackrock Mace
	[1297]="0:4:2:1:Cloth::1:0:", -- Robes of the Shadowcaster
	[1299]="0:4:2:1:Cloth::1:0:", -- Lesser Belt of the Spire
	[1300]="0:2:2:1:Stave::1:0:", -- Lesser Staff of the Spire
	[1302]="0:4:2:1:Leather::1:0:", -- Black Whelp Gloves
	[1303]="0:4:2:1:Mail::1:0:", -- Bridgeworker's Gloves
	[1304]="0:4:2:1:Cloth::1:0:", -- Riding Gloves
	[1306]="0:4:2:1:Leather::1:0:", -- Wolfmane Wristguards
	[1307]="0:12:1:1:::1:0:", -- Gold Pickup Schedule
	[1309]="0:12:1:1:::1:0:", -- Oslow's Toolbox
	[1310]="0:4:2:1:Leather::1:0:", -- Smith's Trousers
	[1314]="0:4:2:1:Leather::1:0:", -- Ghoul Fingers
	[1315]="0:4:4:1:Amulet::1:0:", -- Lei of Lilies
	[1317]="0:2:2:1:Stave::1:0:", -- Hardened Root Staff
	[1318]="0:2:3:1:TwoHandAxe::1:0:", -- Night Reaver
	[1319]="0:4:2:1:Ring::1:0:", -- Ring of Iron Will
	[1322]="0:0:1:10:Consumable::1:0:", -- Fishliver Oil
	[1325]="0:12:1:1:::1:0:", -- Daffodil Bouquet
	[1326]="0:0:1:20:FoodDrink::1:0:", -- Sauteed Sunfish
	[1327]="0:12:1:1:::1:0:", -- Wiley's Note
	[1349]="0:12:1:1:::1:0:", -- Abercrombie's Crate
	[1351]="0:4:2:1:Cloth::1:0:", -- Fingerbone Bracers
	[1353]="0:12:1:1:::1:0:", -- Shaw's Report
	[1355]="0:4:2:1:Cloak::1:0:", -- Buckskin Cape
	[1357]="0:12:1:1:::1:0:", -- Captain Sanders' Treasure Map
	[1358]="0:12:1:1:::1:0:", -- A Clue to Sanders' Treasure
	[1359]="0:4:1:1:Leather::1:0:", -- Lion-stamped Gloves
	[1360]="0:4:1:1:Mail::1:0:", -- Stormwind Chain Gloves
	[1361]="0:12:1:1:::1:0:", -- Another Clue to Sanders' Treasure
	[1362]="0:12:1:1:::1:0:", -- Final Clue to Sanders' Treasure
	[1364]="0:4:0:1:Leather::1:0:", -- Ragged Leather Vest
	[1366]="0:4:0:1:Leather::1:0:", -- Ragged Leather Pants
	[1367]="0:4:0:1:Leather::1:0:", -- Ragged Leather Boots
	[1368]="0:4:0:1:Leather::1:0:", -- Ragged Leather Gloves
	[1369]="0:4:0:1:Leather::1:0:", -- Ragged Leather Belt
	[1370]="0:4:0:1:Leather::1:0:", -- Ragged Leather Bracers
	[1372]="0:4:0:1:Cloak::1:0:", -- Ragged Cloak
	[1374]="0:4:0:1:Cloth::1:0:", -- Frayed Shoes
	[1376]="0:4:0:1:Cloak::1:0:", -- Frayed Cloak
	[1377]="0:4:0:1:Cloth::1:0:", -- Frayed Gloves
	[1378]="0:4:0:1:Cloth::1:0:", -- Frayed Pants
	[1380]="0:4:0:1:Cloth::1:0:", -- Frayed Robe
	[1381]="0:12:1:1:::1:0:", -- A Mysterious Message
	[1382]="0:2:1:1:OneHandMace::1:0:", -- Rock Mace
	[1383]="0:2:1:1:OneHandAxe::1:0:", -- Stone Tomahawk
	[1384]="0:2:1:1:OneHandSword::1:0:", -- Dull Blade
	[1387]="0:2:2:1:TwoHandSword::1:0:", -- Ghoulfang
	[1388]="0:2:1:1:Stave::1:0:", -- Crooked Staff
	[1389]="0:2:1:1:OneHandMace::1:0:", -- Kobold Mining Mallet
	[1391]="0:2:2:1:Stave::1:0:", -- Riverpaw Mystic Staff
	[1394]="0:2:2:1:OneHandMace::1:0:", -- Driftwood Club
	[1395]="5:4:0:1:Cloth::1:0:18672", -- Apprentice's Pants
	[1396]="4:4:0:1:Cloth::1:0:18672", -- Acolyte's Pants
	[1399]="0:0:1:20:Other::1:0:", -- Magic Candle
	[1401]="0:0:1:20:FoodDrink::1:0:", -- Green Tea Leaf
	[1404]="0:4:2:1:Trinket::1:0:", -- Tidal Charm
	[1405]="0:2:2:1:Stave::1:0:", -- Foamspittle Staff
	[1406]="0:2:2:1:Polearm::1:0:", -- Pearl-encrusted Spear
	[1407]="0:12:1:1:::1:0:", -- Solomon's Plea to Westfall
	[1408]="0:12:1:1:::1:0:", -- Stoutmantle's Response to Solomon
	[1409]="0:12:1:1:::1:0:", -- Solomon's Plea to Darkshire
	[1410]="0:12:1:1:::1:0:", -- Ebonlocke's Response to Solomon
	[1411]="0:2:0:1:Stave::1:0:", -- Withered Staff
	[1412]="0:2:0:1:TwoHandSword::1:0:", -- Crude Bastard Sword
	[1413]="0:2:0:1:OneHandSword::1:0:", -- Feeble Sword
	[1414]="0:2:0:1:TwoHandMace::1:0:", -- Cracked Sledge
	[1415]="0:2:0:1:OneHandMace::1:0:", -- Carpenter's Mallet
	[1416]="0:2:0:1:OneHandAxe::1:0:", -- Rusty Hatchet
	[1417]="0:2:0:1:TwoHandAxe::1:0:", -- Beaten Battle Axe
	[1418]="0:4:0:1:Leather::1:0:", -- Worn Leather Belt
	[1419]="0:4:0:1:Leather::1:0:", -- Worn Leather Boots
	[1420]="0:4:0:1:Leather::1:0:", -- Worn Leather Bracers
	[1421]="0:4:0:1:Cloak::1:0:", -- Worn Hide Cloak
	[1422]="0:4:0:1:Leather::1:0:", -- Worn Leather Gloves
	[1423]="0:4:0:1:Leather::1:0:", -- Worn Leather Pants
	[1425]="0:4:0:1:Leather::1:0:", -- Worn Leather Vest
	[1427]="0:4:0:1:Cloth::1:0:", -- Patchwork Shoes
	[1429]="0:4:0:1:Cloak::1:0:", -- Patchwork Cloak
	[1430]="0:4:0:1:Cloth::1:0:", -- Patchwork Gloves
	[1431]="0:4:0:1:Cloth::1:0:", -- Patchwork Pants
	[1433]="0:4:0:1:Cloth::1:0:", -- Patchwork Armor
	[1434]="0:0:1:20:Consumable::1:0:", -- Glowing Wax Stick
	[1436]="0:4:2:1:Leather::1:0:", -- Frontier Britches
	[1438]="0:4:1:1:Shield::1:0:", -- Warrior's Shield
	[1440]="0:2:2:1:OneHandMace::1:0:", -- Gnoll Skull Basher
	[1443]="0:4:4:1:Amulet::1:0:", -- Jeweled Amulet of Cainwyn
	[1445]="0:4:1:1:Mail::1:0:", -- Blackrock Pauldrons
	[1446]="0:4:2:1:Mail::1:0:", -- Blackrock Boots
	[1447]="0:4:4:1:Ring::1:0:", -- Ring of Saviors
	[1448]="0:4:2:1:Mail::1:0:", -- Blackrock Gauntlets
	[1449]="0:4:2:1:Ring::1:0:", -- Minor Channeling Ring
	[1451]="0:12:1:1:::1:0:", -- Bottle of Zombie Juice
	[1453]="0:12:1:1:::1:0:", -- Spectral Comb
	[1454]="0:2:3:1:OneHandAxe::1:0:", -- Axe of the Enforcer
	[1455]="0:2:2:1:TwoHandAxe::1:0:", -- Blackrock Champion's Axe
	[1457]="0:2:2:1:OneHandMace::1:0:", -- Shadowhide Mace
	[1458]="0:2:2:1:TwoHandMace::1:0:", -- Shadowhide Maul
	[1459]="0:2:2:1:OneHandAxe::1:0:", -- Shadowhide Scalper
	[1460]="0:2:2:1:TwoHandSword::1:0:", -- Shadowhide Two-handed Sword
	[1461]="0:2:2:1:TwoHandAxe::1:0:", -- Slayer's Battle Axe
	[1462]="0:4:2:1:Ring::1:0:", -- Ring of the Shadow
	[1464]="0:15:0:5:Junk::1:0:", -- Buzzard Talon
	[1465]="0:2:2:1:Dagger::1:0:", -- Tigerbane
	[1467]="0:12:1:20:::1:0:", -- Spotted Sunfish
	[1468]="0:7:1:20:Meat:185:1:0:", -- Murloc Fin
	[1469]="0:2:2:1:OneHandSword::1:0:", -- Scimitar of Atun
	[1470]="0:1:1:1:Bag::1:0:", -- Murloc Skin Bag
	[1473]="0:2:2:1:Stave::1:0:", -- Riverside Staff
	[1475]="0:7:1:5:Other:129:1:0:", -- Small Venom Sac
	[1476]="0:15:0:5:Junk::1:0:", -- Snapped Spider Limb
	[1477]="350:0:1:20:Scroll::1:1:12246,14847", -- Scroll of Agility II
	[1478]="250:0:1:20:Scroll::1:1:1316,2805,4581,4878,13476", -- Scroll of Protection II
	[1479]="0:4:1:1:Cloth::1:0:", -- Salma's Oven Mitts
	[1480]="0:2:2:1:OneHandMace::1:0:", -- Fist of the People's Militia
	[1481]="0:2:3:1:OneHandAxe::1:0:", -- Grimclaw
	[1482]="0:2:3:1:OneHandSword::1:0:", -- Shadowfang
	[1483]="0:2:3:1:OneHandMace::1:0:", -- Face Smasher
	[1484]="0:2:3:1:Stave::1:0:", -- Witching Stave
	[1485]="0:2:0:1:Polearm::1:0:", -- Pitchfork
	[1486]="0:4:3:1:Cloth::1:0:", -- Tree Bark Jacket
	[1487]="0:0:1:20:FoodDrink::1:0:", -- Conjured Pumpernickel
	[1488]="0:4:3:1:Mail::1:0:", -- Avenger's Armor
	[1489]="0:4:3:1:Leather::1:0:", -- Gloomshroud Armor
	[1490]="0:4:2:1:Trinket::1:0:", -- Guardian Talisman
	[1491]="0:4:3:1:Ring::1:0:", -- Ring of Precision
	[1493]="0:2:3:1:OneHandSword::1:0:", -- Heavy Marauder Scimitar
	[1495]="0:4:0:1:Cloth::1:0:", -- Calico Shoes
	[1497]="0:4:0:1:Cloak::1:0:", -- Calico Cloak
	[1498]="0:4:0:1:Cloth::1:0:", -- Calico Gloves
	[1499]="0:4:0:1:Cloth::1:0:", -- Calico Pants
	[1501]="0:4:0:1:Cloth::1:0:", -- Calico Tunic
	[1502]="0:4:0:1:Leather::1:0:", -- Warped Leather Belt
	[1503]="0:4:0:1:Leather::1:0:", -- Warped Leather Boots
	[1504]="0:4:0:1:Leather::1:0:", -- Warped Leather Bracers
	[1505]="0:4:0:1:Cloak::1:0:", -- Warped Cloak
	[1506]="0:4:0:1:Leather::1:0:", -- Warped Leather Gloves
	[1507]="0:4:0:1:Leather::1:0:", -- Warped Leather Pants
	[1509]="0:4:0:1:Leather::1:0:", -- Warped Leather Vest
	[1510]="0:2:0:1:OneHandMace::1:0:", -- Heavy Hammer
	[1511]="0:2:0:1:OneHandSword::1:0:", -- Commoner's Sword
	[1512]="0:2:0:1:TwoHandAxe::1:0:", -- Crude Battle Axe
	[1513]="0:2:0:1:TwoHandSword::1:0:", -- Old Greatsword
	[1514]="0:2:0:1:TwoHandMace::1:0:", -- Rusty Warhammer
	[1515]="0:2:0:1:Stave::1:0:", -- Rough Wooden Staff
	[1516]="0:2:0:1:OneHandAxe::1:0:", -- Worn Hatchet
	[1518]="0:12:1:1:::1:0:", -- Ghost Hair Comb
	[1519]="0:12:1:20:::1:0:", -- Bloodscalp Ear
	[1520]="0:15:0:5:Junk::1:0:", -- Troll Sweat
	[1521]="0:2:2:1:TwoHandAxe::1:0:", -- Lumbering Ogre Axe
	[1522]="0:2:2:1:Polearm::1:0:", -- Headhunting Spear
	[1523]="0:2:2:1:TwoHandMace::1:0:", -- Huge Stone Club
	[1524]="0:12:1:20:::1:0:", -- Skullsplitter Tusk
	[1528]="0:12:1:20:::1:0:", -- Handful of Oats
	[1529]="0:3:2:20:GemSimple:164,202,755,165,197:1:0:", -- Jade
	[1532]="0:12:1:20:::1:0:", -- Shrunken Head
	[1537]="0:1:1:1:Bag::1:0:", -- Old Blanchy's Feed Pouch
	[1539]="0:2:2:1:Stave::1:0:", -- Gnarled Hermit's Staff
	[1547]="0:4:2:1:Shield::1:0:", -- Shield of the Faith
	[1557]="0:4:2:1:Shield::1:0:", -- Buckler of the Seas
	[1560]="0:4:2:1:Cloth::1:0:", -- Bluegill Sandals
	[1561]="0:4:2:1:Cloth::1:0:", -- Harvester's Robe
	[1566]="0:2:2:1:TwoHandSword::1:0:", -- Edge of the People's Militia
	[1596]="0:12:1:1:::1:0:", -- Ghost Hair Thread
	[1598]="0:12:1:20:::1:0:", -- Rot Blossom
	[1602]="0:2:3:1:OneHandAxe::1:0:", -- Sickle Axe
	[1604]="0:2:2:1:TwoHandSword::1:0:", -- Chromatic Sword
	[1607]="0:2:3:1:Stave::1:0:", -- Soulkeeper
	[1608]="0:2:2:1:OneHandMace::1:0:", -- Skullcrusher Mace
	[1613]="0:2:2:1:Stave::1:0:", -- Spiritchaser Staff
	[1624]="0:4:2:1:Mail::1:0:", -- Skullsplitter Helm
	[1625]="0:2:2:1:TwoHandSword::1:0:", -- Exquisite Flamberge
	[1630]="0:15:0:5:Junk::1:0:", -- Broken Electro-lantern
	[1637]="0:12:1:1:::1:0:", -- Letter to Ello
	[1639]="0:2:2:1:TwoHandAxe::1:0:", -- Grinning Axe
	[1640]="0:2:2:1:TwoHandAxe::1:0:", -- Monstrous War Axe
	[1645]="2000:0:1:20:FoodDrink::5:0:258,274,295,465,734,955,982,1149,1237,1247,1285,1328,1464,1697,2084,2303,2352,2364,2366,2388,2401,2803,2806,2808,2820,2832,2908,3086,3298,3313,3350,3411,3541,3546,3577,3621,3625,3689,3708,3881,3882,3883,3884,3934,3937,3959,3961,4167,4169,4170,4181,4190,4191,4192,4195,4241,4266,4554,4555,4571,4782,4875,4879,4893,4896,4981,5101,5111,5112,5134,5140,5611,5620,5688,5814,5871,6091,6272,6495,6727,6734,6735,6736,6737,6738,6739,6740,6741,6746,6747,6790,6791,6807,6928,6929,6930,7485,7714,7731,7733,7736,7737,7744,7941,7942,7943,8125,8137,8139,8143,8150,8152,8362,8931,9356,9501,11038,11103,11106,11116,11118,11187,11287,11555,12019,12021,12026,12027,12196,12246,12959,12960,14371,14624,14731,14963,14964,15124,15125,15174,15397,15433,16191,16256,16443,16458,16542,16553,16618,16732,16739,17553,17630,17656,19182,19617,21145,23573,23995,24208,24834,24934,24993,25012,25020,25052,25089,29291", -- Moonberry Juice
	[1652]="0:1:1:1:Bag::1:0:", -- Sturdy Lunchbox
	[1656]="0:12:1:1:::1:0:", -- Translated Letter
	[1659]="0:4:2:1:Cloth::1:0:", -- Engineering Gloves
	[1664]="0:2:2:1:Stave::1:0:", -- Spellforce Rod
	[1677]="0:4:2:1:Mail::1:0:", -- Drake-scale Vest
	[1678]="0:4:3:1:Mail::1:0:", -- Black Ogre Kickers
	[1679]="0:2:2:1:TwoHandMace::1:0:", -- Korg Bat
	[1680]="0:2:2:1:TwoHandAxe::1:0:", -- Headchopper
	[1685]="0:1:1:1:Bag::1:0:", -- Troll-hide Bag
	[1686]="0:15:0:10:Junk::1:0:", -- Bristly Whisker
	[1687]="0:15:0:5:Junk::1:0:", -- Retractable Claw
	[1688]="0:15:0:5:Junk::1:0:", -- Long Soft Tail
	[1696]="0:15:0:5:Junk::1:0:", -- Curved Raptor Talon
	[1697]="0:15:0:10:Junk::1:0:", -- Keen Raptor Tooth
	[1701]="0:15:0:5:Junk::1:0:", -- Curved Basilisk Claw
	[1702]="0:15:0:5:Junk::1:0:", -- Intact Basilisk Spine
	[1703]="0:0:1:10:Other::1:0:", -- Crystal Basilisk Spine
	[1705]="0:3:2:20:GemSimple:164,202,755:1:0:", -- Lesser Moonstone
	[1706]="0:15:0:10:Junk::1:0:", -- Azuredeep Shards
	[1707]="1000:0:1:20:FoodDrink::5:0:295,465,483,1237,2352,2364,3298,3546,4782,4891,4894,4981,5620,6746,6790,6930,9501,11106,11116,16553,17630,18929,23521,23604,24934", -- Stormwind Brie
	[1708]="1000:0:1:20:FoodDrink::5:0:258,274,295,465,734,955,982,1149,1237,1247,1285,1328,1464,1697,2084,2303,2352,2364,2366,2388,2401,2803,2806,2808,2820,2832,2908,3086,3298,3313,3350,3411,3541,3546,3577,3621,3625,3689,3708,3881,3882,3883,3884,3934,3937,3959,3961,4167,4169,4170,4181,4190,4191,4192,4195,4241,4266,4554,4555,4571,4782,4875,4879,4893,4896,4981,5101,5111,5112,5134,5140,5611,5620,5688,5814,5871,6091,6272,6495,6727,6734,6735,6736,6737,6738,6739,6740,6741,6746,6747,6790,6791,6807,6928,6929,6930,7485,7714,7731,7733,7736,7737,7744,7941,7942,7943,8125,8137,8139,8143,8150,8152,8362,8931,9356,9501,11038,11103,11106,11116,11118,11187,11287,11555,12019,12021,12026,12027,12196,12246,12959,12960,14371,14624,14731,14963,14964,15124,15125,15174,15397,15433,16191,16256,16443,16458,16542,16553,16618,16732,16739,17553,17630,17656,19182,19617,21145,23573,23995,24208,24834,24934,24993,25012,25020,25052,25089,29291", -- Sweet Nectar
	[1710]="500:0:1:20:Potion::1:1:2380,2480,2812,2848,4899,12245", -- Greater Healing Potion
	[1711]="300:0:1:20:Scroll::1:1:1316,2805,4581,4878,12246,13476,14847", -- Scroll of Stamina II
	[1712]="250:0:1:20:Scroll::1:1:1316,2805,4581,4878,13476", -- Scroll of Spirit II
	[1713]="0:4:3:1:Trinket::1:0:", -- Ankh of Life
	[1714]="0:4:3:1:Amulet::1:0:", -- Necklace of Calisea
	[1715]="0:4:3:1:Mail::1:0:", -- Polished Jazeraint Armor
	[1716]="0:4:3:1:Cloth::1:0:", -- Robe of the Magi
	[1717]="0:4:3:1:Mail::1:0:", -- Double Link Tunic
	[1718]="0:4:3:1:Leather::1:0:", -- Basilisk Hide Pants
	[1720]="0:2:3:1:Stave::1:0:", -- Tanglewood Staff
	[1721]="0:2:3:1:OneHandMace::1:0:", -- Viking Warhammer
	[1722]="0:2:3:1:TwoHandMace::1:0:", -- Thornstone Sledgehammer
	[1725]="0:1:1:1:Bag::1:0:", -- Large Knapsack
	[1726]="0:2:3:1:Polearm::1:0:", -- Poison-tipped Bone Spear
	[1727]="0:2:3:1:OneHandSword::1:0:", -- Sword of Decay
	[1728]="0:2:4:1:OneHandSword::1:0:", -- Teebu's Blazing Longsword
	[1729]="0:1:1:1:Bag::1:0:", -- Gunnysack of the Night Watch
	[1730]="0:4:0:1:Mail::1:0:", -- Worn Mail Belt
	[1731]="0:4:0:1:Mail::1:0:", -- Worn Mail Boots
	[1732]="0:4:0:1:Mail::1:0:", -- Worn Mail Bracers
	[1733]="0:4:0:1:Cloak::1:0:", -- Worn Cloak
	[1734]="0:4:0:1:Mail::1:0:", -- Worn Mail Gloves
	[1735]="0:4:0:1:Mail::1:0:", -- Worn Mail Pants
	[1737]="0:4:0:1:Mail::1:0:", -- Worn Mail Vest
	[1738]="0:4:0:1:Mail::1:0:", -- Laced Mail Belt
	[1739]="0:4:0:1:Mail::1:0:", -- Laced Mail Boots
	[1740]="0:4:0:1:Mail::1:0:", -- Laced Mail Bracers
	[1741]="0:4:0:1:Cloak::1:0:", -- Laced Cloak
	[1742]="0:4:0:1:Mail::1:0:", -- Laced Mail Gloves
	[1743]="0:4:0:1:Mail::1:0:", -- Laced Mail Pants
	[1744]="0:4:0:1:Mail::1:0:", -- Laced Mail Shoulderpads
	[1745]="0:4:0:1:Mail::1:0:", -- Laced Mail Vest
	[1746]="0:4:0:1:Mail::1:0:", -- Linked Chain Belt
	[1747]="0:4:0:1:Mail::1:0:", -- Linked Chain Boots
	[1748]="0:4:0:1:Mail::1:0:", -- Linked Chain Bracers
	[1749]="0:4:0:1:Cloak::1:0:", -- Linked Chain Cloak
	[1750]="0:4:0:1:Mail::1:0:", -- Linked Chain Gloves
	[1751]="0:4:0:1:Mail::1:0:", -- Linked Chain Pants
	[1752]="0:4:0:1:Mail::1:0:", -- Linked Chain Shoulderpads
	[1753]="0:4:0:1:Mail::1:0:", -- Linked Chain Vest
	[1754]="0:4:0:1:Mail::1:0:", -- Reinforced Chain Belt
	[1755]="0:4:0:1:Mail::1:0:", -- Reinforced Chain Boots
	[1756]="0:4:0:1:Mail::1:0:", -- Reinforced Chain Bracers
	[1757]="0:4:0:1:Cloak::1:0:", -- Reinforced Chain Cloak
	[1758]="0:4:0:1:Mail::1:0:", -- Reinforced Chain Gloves
	[1759]="0:4:0:1:Mail::1:0:", -- Reinforced Chain Pants
	[1760]="0:4:0:1:Mail::1:0:", -- Reinforced Chain Shoulderpads
	[1761]="0:4:0:1:Mail::1:0:", -- Reinforced Chain Vest
	[1764]="0:4:0:1:Cloth::1:0:", -- Canvas Shoes
	[1766]="0:4:0:1:Cloak::1:0:", -- Canvas Cloak
	[1767]="0:4:0:1:Cloth::1:0:", -- Canvas Gloves
	[1768]="0:4:0:1:Cloth::1:0:", -- Canvas Pants
	[1769]="0:4:0:1:Cloth::1:0:", -- Canvas Shoulderpads
	[1770]="0:4:0:1:Cloth::1:0:", -- Canvas Vest
	[1772]="0:4:0:1:Cloth::1:0:", -- Brocade Shoes
	[1774]="0:4:0:1:Cloak::1:0:", -- Brocade Cloak
	[1775]="0:4:0:1:Cloth::1:0:", -- Brocade Gloves
	[1776]="0:4:0:1:Cloth::1:0:", -- Brocade Pants
	[1777]="0:4:0:1:Cloth::1:0:", -- Brocade Shoulderpads
	[1778]="0:4:0:1:Cloth::1:0:", -- Brocade Vest
	[1780]="0:4:0:1:Cloth::1:0:", -- Cross-stitched Sandals
	[1782]="0:4:0:1:Cloak::1:0:", -- Cross-stitched Cloak
	[1783]="0:4:0:1:Cloth::1:0:", -- Cross-stitched Gloves
	[1784]="0:4:0:1:Cloth::1:0:", -- Cross-stitched Pants
	[1785]="0:4:0:1:Cloth::1:0:", -- Cross-stitched Shoulderpads
	[1786]="0:4:0:1:Cloth::1:0:", -- Cross-stitched Vest
	[1787]="0:4:0:1:Leather::1:0:", -- Patched Leather Belt
	[1788]="0:4:0:1:Leather::1:0:", -- Patched Leather Boots
	[1789]="0:4:0:1:Leather::1:0:", -- Patched Leather Bracers
	[1790]="0:4:0:1:Cloak::1:0:", -- Patched Cloak
	[1791]="0:4:0:1:Leather::1:0:", -- Patched Leather Gloves
	[1792]="0:4:0:1:Leather::1:0:", -- Patched Leather Pants
	[1793]="0:4:0:1:Leather::1:0:", -- Patched Leather Shoulderpads
	[1794]="0:4:0:1:Leather::1:0:", -- Patched Leather Jerkin
	[1795]="0:4:0:1:Leather::1:0:", -- Rawhide Belt
	[1796]="0:4:0:1:Leather::1:0:", -- Rawhide Boots
	[1797]="0:4:0:1:Leather::1:0:", -- Rawhide Bracers
	[1798]="0:4:0:1:Cloak::1:0:", -- Rawhide Cloak
	[1799]="0:4:0:1:Leather::1:0:", -- Rawhide Gloves
	[1800]="0:4:0:1:Leather::1:0:", -- Rawhide Pants
	[1801]="0:4:0:1:Leather::1:0:", -- Rawhide Shoulderpads
	[1802]="0:4:0:1:Leather::1:0:", -- Rawhide Tunic
	[1803]="0:4:0:1:Leather::1:0:", -- Tough Leather Belt
	[1804]="0:4:0:1:Leather::1:0:", -- Tough Leather Boots
	[1805]="0:4:0:1:Leather::1:0:", -- Tough Leather Bracers
	[1806]="0:4:0:1:Cloak::1:0:", -- Tough Cloak
	[1807]="0:4:0:1:Leather::1:0:", -- Tough Leather Gloves
	[1808]="0:4:0:1:Leather::1:0:", -- Tough Leather Pants
	[1809]="0:4:0:1:Leather::1:0:", -- Tough Leather Shoulderpads
	[1810]="0:4:0:1:Leather::1:0:", -- Tough Leather Armor
	[1811]="0:2:0:1:TwoHandSword::1:0:", -- Blunt Claymore
	[1812]="0:2:0:1:TwoHandAxe::1:0:", -- Short-handled Battle Axe
	[1813]="0:2:0:1:Stave::1:0:", -- Chipped Quarterstaff
	[1814]="0:2:0:1:TwoHandMace::1:0:", -- Battered Mallet
	[1815]="0:2:0:1:OneHandMace::1:0:", -- Ornamental Mace
	[1816]="0:2:0:1:OneHandAxe::1:0:", -- Unbalanced Axe
	[1817]="0:2:0:1:OneHandSword::1:0:", -- Stock Shortsword
	[1818]="0:2:0:1:TwoHandSword::1:0:", -- Standard Claymore
	[1819]="0:2:0:1:OneHandAxe::1:0:", -- Gouging Pick
	[1820]="0:2:0:1:TwoHandMace::1:0:", -- Wooden Maul
	[1821]="0:2:0:1:OneHandSword::1:0:", -- Warped Blade
	[1822]="0:2:0:1:Stave::1:0:", -- Cedar Walking Stick
	[1823]="0:2:0:1:OneHandMace::1:0:", -- Bludgeoning Cudgel
	[1824]="0:2:0:1:TwoHandAxe::1:0:", -- Shiny War Axe
	[1825]="0:2:0:1:OneHandMace::1:0:", -- Bulky Bludgeon
	[1826]="0:2:0:1:TwoHandMace::1:0:", -- Rock Maul
	[1827]="0:2:0:1:OneHandAxe::1:0:", -- Meat Cleaver
	[1828]="0:2:0:1:TwoHandAxe::1:0:", -- Stone War Axe
	[1829]="0:2:0:1:OneHandSword::1:0:", -- Short Cutlass
	[1830]="0:2:0:1:TwoHandSword::1:0:", -- Long Bastard Sword
	[1831]="0:2:0:1:Stave::1:0:", -- Oaken War Staff
	[1832]="0:4:2:1:Cloth::1:0:", -- Lucky Trousers
	[1835]="31:4:1:1:Leather::1:0:2113,3074,3160,4558", -- Dirty Leather Belt
	[1836]="31:4:1:1:Leather::1:0:2113,3074,3160,4558", -- Dirty Leather Bracers
	[1839]="185:4:1:1:Leather::1:0:74,896,1238,1295,3162,3532,3612,3953,4164,4236,5820,16747,17929", -- Rough Leather Belt
	[1840]="185:4:1:1:Leather::1:0:74,896,1238,1295,3162,3532,3612,3953,4164,4236,5820,16747,17929", -- Rough Leather Bracers
	[1843]="726:4:1:1:Leather::1:0:896,954,1295,1669,3093,3321,3483,3552,3684,3953,4164,4186,4236,4558,5108,5820,8359,10380,16691,16747", -- Tanned Leather Belt
	[1844]="728:4:1:1:Leather::1:0:896,954,1295,1669,3093,3321,3483,3552,3684,3953,4164,4186,4236,4558,5108,5820,8359,10380,16691,16747", -- Tanned Leather Bracers
	[1845]="877:4:1:1:Mail::1:0:167,1294,1362,3319,3483,3528,3529,3553,4164,4177,4187,4560,5107,5812,5819,8360,11703,16625,16750", -- Chainmail Belt
	[1846]="881:4:1:1:Mail::1:0:167,1294,1362,3319,3483,3528,3529,3553,4164,4177,4187,4560,5107,5812,5819,8360,11703,16625,16750", -- Chainmail Bracers
	[1849]="1388:4:1:1:Leather::1:0:1295,1695,3093,3097,3321,3492,3536,3953,4236,5783,5820,8359,16691,16747", -- Cured Leather Belt
	[1850]="1393:4:1:1:Leather::1:0:1295,1695,3093,3097,3321,3492,3536,3953,4236,5783,5820,8359,16691,16747", -- Cured Leather Bracers
	[1852]="1684:4:1:1:Mail::1:0:956,1294,1341,3319,3493,3543,3682,4177,5125,5812,5819,8360,16625,16750", -- Scalemail Bracers
	[1853]="1690:4:1:1:Mail::1:0:956,1294,1341,3319,3493,3543,3682,4177,5125,5812,5819,8360,16625,16750", -- Scalemail Belt
	[1875]="0:12:1:1:::1:0:", -- Thistlenettle's Badge
	[1893]="0:2:2:1:TwoHandAxe::1:0:", -- Miner's Revenge
	[1894]="0:12:1:20:::1:0:", -- Miners' Union Card
	[1913]="0:2:1:1:OneHandMace::1:0:", -- Studded Blackjack
	[1917]="0:2:2:1:Dagger::1:0:", -- Jeweled Dagger
	[1922]="0:12:1:1:::1:0:", -- Supplies for Sven
	[1923]="0:12:1:1:::1:0:", -- Ambassador's Satchel
	[1925]="0:2:2:1:OneHandSword::1:0:", -- Defias Rapier
	[1926]="0:2:2:1:OneHandMace::1:0:", -- Weighted Sap
	[1927]="0:2:2:1:OneHandAxe::1:0:", -- Deadmines Cleaver
	[1928]="0:2:2:1:Stave::1:0:", -- Defias Mage Staff
	[1929]="0:4:2:1:Cloth::1:0:", -- Silk-threaded Trousers
	[1930]="0:4:2:1:Cloak::1:0:", -- Stonemason Cloak
	[1931]="0:12:1:1:::1:0:", -- Huge Gnoll Claw
	[1933]="0:2:2:1:Stave::1:0:", -- Staff of Conjuring
	[1934]="0:4:2:1:Leather::1:0:", -- Stonemason Trousers
	[1935]="0:2:3:1:Dagger::1:0:", -- Assassin's Blade
	[1936]="0:2:2:1:Dagger::1:0:", -- Goblin Screwdriver
	[1937]="0:2:3:1:OneHandSword::1:0:", -- Buzz Saw
	[1938]="0:2:2:1:OneHandMace::1:0:", -- Block Mallet
	[1939]="675:12:1:1:::1:0:465", -- Skin of Sweet Rum
	[1941]="815:12:1:1:::1:0:277", -- Cask of Merlot
	[1942]="1265:12:1:1:::1:0:274", -- Bottle of Moonshine
	[1943]="0:4:2:1:Mail::1:0:", -- Goblin Mail Leggings
	[1944]="0:4:2:1:Leather::1:0:", -- Metalworking Gloves
	[1945]="0:4:2:1:Leather::1:0:", -- Woodworking Gloves
	[1946]="0:12:1:1:::1:0:", -- Mary's Looking Glass
	[1951]="0:2:2:1:OneHandSword::1:0:", -- Blackwater Cutlass
	[1955]="0:4:2:1:Mail::1:0:", -- Dragonmaw Chain Boots
	[1956]="0:12:1:1:::1:0:", -- Faded Shadowhide Pendant
	[1958]="0:2:2:1:OneHandMace::1:0:", -- Petrified Shinbone
	[1959]="0:2:2:1:TwoHandAxe::1:0:", -- Cold Iron Pick
	[1962]="0:12:1:1:::1:0:", -- Glowing Shadowhide Pendant
	[1965]="0:4:1:1:Leather::1:0:", -- White Wolf Gloves
	[1968]="0:12:1:1:::1:0:", -- Ogre's Monocle
	[1970]="0:0:1:10:Consumable::1:0:", -- Restoring Balm
	[1971]="0:12:1:1:::1:0:", -- Furlbrow's Deed
	[1972]="0:12:1:1:::1:0:", -- Westfall Deed
	[1973]="0:4:3:1:Trinket::1:0:", -- Orb of Deception
	[1974]="0:4:3:1:Cloth::1:0:", -- Mindthrust Bracers
	[1975]="0:2:3:1:TwoHandSword::1:0:", -- Pysan's Old Greatsword
	[1976]="0:2:3:1:TwoHandMace::1:0:", -- Slaghammer
	[1978]="0:4:3:1:Leather::1:0:", -- Wolfclaw Gloves
	[1979]="0:4:4:1:Shield::1:0:", -- Wall of the Dead
	[1980]="0:4:4:1:Ring::1:0:", -- Underworld Band
	[1981]="0:4:4:1:Mail::1:0:", -- Icemail Jerkin
	[1982]="0:2:4:1:TwoHandSword::1:0:", -- Nightblade
	[1986]="0:2:2:1:TwoHandSword::1:0:", -- Gutrender
	[1987]="0:12:1:1:::1:0:", -- Krazek's Fixed Pot
	[1988]="0:4:2:1:Mail::1:0:", -- Chief Brigadier Gauntlets
	[1990]="0:2:2:1:TwoHandMace::1:0:", -- Ballast Maul
	[1991]="0:2:2:1:TwoHandMace::1:0:", -- Goblin Power Shovel
	[1992]="0:4:3:1:OffHandFrill::1:0:", -- Swampchill Fetish
	[1993]="0:4:2:1:Ring::1:0:", -- Ogremind Ring
	[1994]="0:2:2:1:OneHandAxe::1:0:", -- Ebonclaw Reaver
	[1996]="0:4:2:1:Ring::1:0:", -- Voodoo Band
	[1997]="0:4:2:1:Cloth::1:0:", -- Pressed Felt Robe
	[1998]="0:2:2:1:Stave::1:0:", -- Bloodscalp Channeling Staff
	[2000]="0:2:2:1:TwoHandSword::1:0:", -- Archeus
	[2004]="0:12:1:1:::1:0:", -- Grelin Whitebeard's Journal
	[2005]="0:12:1:1:::1:0:", -- The First Troll Legend
	[2006]="0:12:1:1:::1:0:", -- The Second Troll Legend
	[2007]="0:12:1:1:::1:0:", -- The Third Troll Legend
	[2008]="0:12:1:1:::1:0:", -- The Fourth Troll Legend
	[2011]="0:2:3:1:OneHandSword::1:0:", -- Twisted Sabre
	[2013]="0:2:2:1:Stave::1:0:", -- Cryptbone Staff
	[2014]="0:2:2:1:TwoHandSword::1:0:", -- Black Metal Greatsword
	[2015]="0:2:2:1:TwoHandAxe::1:0:", -- Black Metal War Axe
	[2017]="0:4:2:1:Leather::1:0:", -- Glowing Leather Bracers
	[2018]="0:2:2:1:OneHandSword::1:0:", -- Skeletal Longsword
	[2020]="0:2:2:1:Dagger::1:0:", -- Hollowfang Blade
	[2021]="0:4:2:1:Shield::1:0:", -- Green Carapace Shield
	[2024]="6079:2:1:1:TwoHandSword::1:0:225,1287,1289,2997,3021,3331,3361,3491,4171,4203,4231,4557,4569,5103,5120,16714", -- Espadon
	[2025]="5305:2:1:1:TwoHandAxe::1:0:225,1287,1289,2997,3019,3409,3491,4203,4231,4232,4557,4601,5103,5119,16714", -- Bearded Axe
	[2026]="6286:2:1:1:TwoHandMace::1:0:225,1287,1289,1348,2997,3020,3360,3491,4203,4231,4233,4557,4602,5103,5121,16765,17412", -- Rock Hammer
	[2027]="3816:2:1:1:OneHandSword::1:0:225,1287,1289,2997,3021,3331,3361,3491,4171,4203,4231,4557,4569,5103,5120,16714", -- Scimitar
	[2028]="5065:2:1:1:OneHandMace::1:0:225,1287,1289,1348,2997,3020,3360,3491,4203,4231,4233,4557,4602,5103,5121,16765,17412", -- Hammer
	[2029]="4420:2:1:1:OneHandAxe::1:0:225,1287,1289,2997,3019,3409,3491,4203,4231,4232,4557,4601,5103,5119,16714", -- Cleaver
	[2030]="5545:2:1:1:Stave::1:0:225,1287,1289,1348,2997,3020,3360,3409,3491,4203,4231,4233,4557,4602,5103,5121,16765,17412,19238", -- Gnarled Staff
	[2032]="0:4:2:1:Cloth::1:0:", -- Gallan Cuffs
	[2033]="0:4:2:1:Leather::1:0:", -- Ambassador's Boots
	[2034]="0:4:2:1:Cloth::1:0:", -- Scholarly Robes
	[2035]="0:2:2:1:OneHandSword::1:0:", -- Sword of the Night Sky
	[2036]="0:4:2:1:Leather::1:0:", -- Dusty Mining Gloves
	[2037]="0:4:2:1:Mail::1:0:", -- Tunneler's Boots
	[2039]="0:4:3:1:Ring::1:0:", -- Plains Ring
	[2040]="0:4:3:1:Shield::1:0:", -- Troll Protector
	[2041]="0:4:3:1:Leather::1:0:", -- Tunic of Westfall
	[2042]="0:2:3:1:Stave::1:0:", -- Staff of Westfall
	[2043]="0:4:3:1:Ring::1:0:", -- Ring of Forlorn Spirits
	[2044]="0:2:3:1:OneHandAxe::1:0:", -- Crescent of Forlorn Spirits
	[2046]="0:2:2:1:OneHandSword::1:0:", -- Bluegill Kukri
	[2047]="0:2:1:1:OneHandAxe::1:0:", -- Anvilmar Hand Axe
	[2048]="0:2:1:1:OneHandMace::1:0:", -- Anvilmar Hammer
	[2054]="0:2:1:1:OneHandAxe::1:0:", -- Trogg Hand Axe
	[2055]="0:2:1:1:OneHandMace::1:0:", -- Small Wooden Hammer
	[2057]="0:2:1:1:OneHandSword::1:0:", -- Pitted Defias Shortsword
	[2058]="0:2:2:1:TwoHandMace::1:0:", -- Kazon's Maul
	[2059]="0:4:3:1:Cloak::1:0:", -- Sentry Cloak
	[2064]="0:2:1:1:OneHandMace::1:0:", -- Trogg Club
	[2065]="0:2:1:1:OneHandSword::1:0:", -- Rockjaw Blade
	[2066]="0:2:1:1:OneHandAxe::1:0:", -- Skull Hatchet
	[2067]="0:2:1:1:Stave::1:0:", -- Frostbit Staff
	[2069]="0:4:1:1:Leather::1:0:", -- Black Bear Hide Vest
	[2070]="25:0:1:20:FoodDrink::5:0:295,465,483,1237,2352,2364,3298,3546,4782,4891,4894,4981,5620,6746,6790,6930,9501,11106,11116,16553,17630,18929,23521,23604,24934", -- Darnassian Bleu
	[2072]="0:2:2:1:Stave::1:0:", -- Dwarven Magestaff
	[2073]="0:2:2:1:OneHandAxe::1:0:", -- Dwarven Hatchet
	[2074]="0:2:2:1:OneHandSword::1:0:", -- Solid Shortblade
	[2075]="0:2:2:1:OneHandMace::1:0:", -- Priest's Mace
	[2077]="0:2:2:1:Stave::1:0:", -- Magician Staff
	[2078]="0:2:2:1:OneHandSword::1:0:", -- Northern Shortsword
	[2079]="0:2:2:1:OneHandMace::1:0:", -- Sergeant's Warhammer
	[2080]="0:2:2:1:OneHandAxe::1:0:", -- Hillborne Axe
	[2082]="0:1:1:1:Bag::1:0:", -- Wizbang's Gunnysack
	[2084]="0:2:2:1:TwoHandSword::1:0:", -- Darksteel Bastard Sword
	[2085]="0:15:0:5:Junk::1:0:", -- Chunk of Flesh
	[2087]="0:4:2:1:Leather::1:0:", -- Hard Crawler Carapace
	[2088]="0:2:2:1:Dagger::1:0:", -- Long Crawler Limb
	[2089]="0:2:2:1:Dagger::1:0:", -- Scrimshaw Dagger
	[2091]="0:0:1:10:Other::1:0:", -- Magic Dust
	[2092]="0:2:1:1:Dagger::1:0:", -- Worn Dagger
	[2098]="0:2:3:1:Gun::1:0:", -- Double-barreled Shotgun
	[2099]="0:2:4:1:Gun::1:0:", -- Dwarven Hand Cannon
	[2100]="0:2:4:1:Gun::1:0:", -- Precisely Calibrated Boomstick
	[2101]="4:11:1:1:Quiver::1:0:1287,4602,7976,16715,16919,17667", -- Light Quiver
	[2102]="4:11:1:1:AmmoPouch::1:0:2685,6028", -- Small Ammo Pouch
	[2105]="0:4:1:1:Shirt::1:0:", -- Thug Shirt
	[2108]="0:4:1:1:Leather::1:0:", -- Frostmane Leather Vest
	[2109]="0:4:1:1:Mail::1:0:", -- Frostmane Chain Vest
	[2110]="0:4:1:1:Cloth::1:0:", -- Light Magesmith Robe
	[2112]="0:4:1:1:Leather::1:0:", -- Lumberjack Jerkin
	[2113]="0:12:1:1:::1:0:", -- Calor's Note
	[2114]="0:4:1:1:Cloth::1:0:", -- Snowy Robe
	[2117]="37:4:1:1:Cloth::1:0:190,836,1238,3590,4175,16918", -- Thin Cloth Shoes
	[2119]="25:4:1:1:Cloth::1:0:190,836,1238,3590,4175,16918", -- Thin Cloth Gloves
	[2120]="50:4:1:1:Cloth::1:0:190,836,1238,3590,4175,16918", -- Thin Cloth Pants
	[2121]="50:4:1:1:Cloth::1:0:190,836,1238,3590,4175,16918", -- Thin Cloth Armor
	[2122]="32:4:1:1:Leather::1:0:190,836,1238,3591,4236,16918", -- Cracked Leather Belt
	[2123]="49:4:1:1:Leather::1:0:190,836,1238,3591,4236,16918", -- Cracked Leather Boots
	[2124]="33:4:1:1:Leather::1:0:190,836,1238,3591,4236,16918", -- Cracked Leather Bracers
	[2125]="33:4:1:1:Leather::1:0:190,836,1238,3591,4236,16918", -- Cracked Leather Gloves
	[2126]="60:4:1:1:Leather::1:0:190,836,1238,3591,4236,16918", -- Cracked Leather Pants
	[2127]="60:4:1:1:Leather::1:0:190,836,1238,3591,4236,16918", -- Cracked Leather Vest
	[2129]="77:4:1:1:Shield::1:0:1104,1213,3592,4240,16762,16917", -- Large Round Shield
	[2130]="54:2:1:1:OneHandMace::1:0:78,945,2117,2997,3073,3159,3314,3588,4231,4556,5102,16919", -- Club
	[2131]="54:2:1:1:OneHandSword::1:0:78,945,2117,2997,3073,3159,3314,3588,4231,4556,5102,16919", -- Shortsword
	[2132]="102:2:1:1:Stave::1:0:78,945,2117,2997,3073,3159,3314,3588,4231,4556,5102,16919", -- Short Staff
	[2133]="0:4:1:1:Shield::1:0:", -- Small Shield
	[2134]="82:2:1:1:OneHandAxe::1:0:78,945,2117,2997,3073,3159,3314,3588,4231,4556,5102,16919", -- Hand Axe
	[2136]="0:0:1:20:FoodDrink::1:0:", -- Conjured Purified Water
	[2137]="0:2:1:1:Dagger::1:0:", -- Whittling Knife
	[2138]="0:2:0:1:Dagger::1:0:", -- Sharpened Letter Opener
	[2139]="57:2:1:1:Dagger::1:0:78,945,2117,2997,3073,3159,3314,3588,4231,4556,5102,16919", -- Dirk
	[2140]="0:2:2:1:Dagger::1:0:", -- Carving Knife
	[2141]="5224:4:1:1:Leather::1:0:1314,1695,3315,3316,3953,4236,5820", -- Cuirboulli Vest
	[2142]="2621:4:1:1:Leather::1:0:1314,1695,3315,3316,3953,4236,5820", -- Cuirboulli Belt
	[2143]="3945:4:1:1:Leather::1:0:1314,1695,3315,3316,3953,4236,5820", -- Cuirboulli Boots
	[2144]="2639:4:1:1:Leather::1:0:1314,1695,3315,3316,3953,4236,5820", -- Cuirboulli Bracers
	[2145]="2649:4:1:1:Leather::1:0:1314,1695,3315,3316,3953,4236,5820", -- Cuirboulli Gloves
	[2146]="4809:4:1:1:Leather::1:0:1314,1695,3315,3316,3953,4236,5820", -- Cuirboulli Pants
	[2148]="2908:4:1:1:Mail::1:0:226,1323,1341,1349,1450,3095,4085,4177,4883,4886,5125,5812,5819,6028", -- Polished Scale Belt
	[2149]="4398:4:1:1:Mail::1:0:226,1323,1341,1349,1450,3095,4085,4177,4883,4886,5125,5812,5819,6028", -- Polished Scale Boots
	[2150]="2930:4:1:1:Mail::1:0:226,1323,1341,1349,1450,3095,4085,4177,4883,4886,5125,5812,5819,6028", -- Polished Scale Bracers
	[2151]="2941:4:1:1:Mail::1:0:226,1323,1341,1349,1450,3095,4085,4177,4883,4886,5125,5812,5819,6028", -- Polished Scale Gloves
	[2152]="5906:4:1:1:Mail::1:0:226,1323,1341,1349,1450,3095,4085,4177,4883,4886,5125,5812,5819,6028", -- Polished Scale Leggings
	[2153]="5928:4:1:1:Mail::1:0:226,1323,1341,1349,1450,3095,4085,4177,4883,4886,5125,5812,5819,6028", -- Polished Scale Vest
	[2154]="0:15:0:1:Junk::1:0:", -- The Story of Morgan Ladimore
	[2156]="3078:4:1:1:Cloth::1:0:1314,2849,3092,3315,3316,3952,4175,4188,5821", -- Padded Boots
	[2158]="2066:4:1:1:Cloth::1:0:1314,2849,3092,3315,3316,3952,4175,4188,5821", -- Padded Gloves
	[2159]="4148:4:1:1:Cloth::1:0:1314,2849,3092,3315,3316,3952,4175,4188,5821", -- Padded Pants
	[2160]="4163:4:1:1:Cloth::1:0:1314,2849,3092,3315,3316,3952,4175,4188,5821", -- Padded Armor
	[2161]="0:12:1:1:::1:0:", -- Book from Sven's Farm
	[2162]="0:12:1:1:::1:0:", -- Sarah's Ring
	[2163]="0:2:4:1:Dagger::1:0:", -- Shadowblade
	[2164]="0:2:4:1:Dagger::1:0:", -- Gut Ripper
	[2165]="0:4:1:1:Cloak::1:0:", -- Old Blanchy's Blanket
	[2166]="0:4:2:1:Mail::1:0:", -- Foreman's Leggings
	[2167]="0:4:2:1:Leather::1:0:", -- Foreman's Gloves
	[2168]="0:4:2:1:Cloth::1:0:", -- Foreman's Boots
	[2169]="0:2:3:1:Dagger::1:0:", -- Buzzer Blade
	[2172]="0:4:1:1:Mail::1:0:", -- Rustic Belt
	[2173]="0:4:1:1:Leather::1:0:", -- Old Leather Belt
	[2175]="0:2:2:1:TwoHandAxe::1:0:", -- Shadowhide Battle Axe
	[2186]="0:4:1:1:Leather::1:0:", -- Outfitter Belt
	[2187]="0:12:1:1:::1:0:", -- A Stack of Letters
	[2188]="0:12:1:1:::1:0:", -- A Letter to Grelin Whitebeard
	[2194]="0:2:3:1:OneHandMace::1:0:", -- Diamond Hammer
	[2195]="0:2:1:1:Dagger::1:0:", -- Anvilmar Knife
	[2203]="0:2:2:1:TwoHandAxe::1:0:", -- Brashclaw's Chopper
	[2204]="0:2:2:1:TwoHandSword::1:0:", -- Brashclaw's Skewer
	[2205]="0:2:3:1:TwoHandSword::1:0:", -- Duskbringer
	[2207]="2391:2:1:1:Dagger::1:0:1287,1289,2997,3021,3314,3331,3361,3479,3534,3658,4171,4183,4203,4231,4557,4569,5103,5120,16714", -- Jambiya
	[2208]="3651:2:1:1:Dagger::1:0:225,1287,1289,2997,3021,3331,3361,3491,4171,4203,4231,4557,4569,5103,5120,16714", -- Poniard
	[2209]="7116:2:1:1:Dagger::1:0:225,1287,1289,1441,3021,3331,3361,3539,4086,4171,4203,4569,5120,11137,16714", -- Kris
	[2210]="0:4:0:1:Shield::1:0:", -- Battered Buckler
	[2211]="0:4:0:1:Shield::1:0:", -- Bent Large Shield
	[2212]="0:4:0:1:Shield::1:0:", -- Cracked Buckler
	[2213]="0:4:0:1:Shield::1:0:", -- Worn Large Shield
	[2214]="0:4:0:1:Shield::1:0:", -- Wooden Buckler
	[2215]="0:4:0:1:Shield::1:0:", -- Wooden Shield
	[2216]="0:4:0:1:Shield::1:0:", -- Simple Buckler
	[2217]="0:4:0:1:Shield::1:0:", -- Rectangular Shield
	[2218]="0:2:2:1:Dagger::1:0:", -- Craftsman's Dagger
	[2219]="0:4:0:1:Shield::1:0:", -- Small Round Shield
	[2220]="0:4:0:1:Shield::1:0:", -- Box Shield
	[2221]="0:4:0:1:Shield::1:0:", -- Targe Shield
	[2222]="0:4:0:1:Shield::1:0:", -- Tower Shield
	[2223]="0:12:1:1:::1:0:", -- The Collector's Schedule
	[2224]="0:2:1:1:Dagger::1:0:", -- Militia Dagger
	[2225]="0:2:1:1:Dagger::1:0:", -- Sharp Kitchen Knife
	[2226]="0:2:2:1:Stave::1:0:", -- Ogremage Staff
	[2227]="0:2:2:1:TwoHandAxe::1:0:", -- Heavy Ogre War Axe
	[2230]="0:4:2:1:Mail::1:0:", -- Gloves of Brawn
	[2231]="0:4:2:1:Cloth::1:0:", -- Inferno Robe
	[2232]="0:4:2:1:Cloth::1:0:", -- Dark Runner Boots
	[2233]="0:4:2:1:Leather::1:0:", -- Shadow Weaver Leggings
	[2234]="0:4:2:1:Cloth::1:0:", -- Nightwalker Armor
	[2235]="0:2:2:1:Dagger::1:0:", -- Brackclaw
	[2236]="0:2:3:1:Dagger::1:0:", -- Blackfang
	[2237]="0:4:1:1:Leather::1:0:", -- Patched Pants
	[2238]="0:4:1:1:Cloth::1:0:", -- Urchin's Pants
	[2239]="0:12:1:1:::1:0:", -- The Collector's Ring
	[2240]="0:4:1:1:Cloak::1:0:", -- Rugged Cape
	[2241]="0:4:2:1:Cloak::1:0:", -- Desperado Cape
	[2243]="0:2:4:1:OneHandMace::1:0:", -- Hand of Edward the Odd
	[2244]="0:2:4:1:OneHandSword::1:0:", -- Krol Blade
	[2245]="0:4:4:1:Mail::1:0:", -- Helm of Narv
	[2246]="0:4:4:1:Ring::1:0:", -- Myrmidon's Signet
	[2249]="0:4:1:1:Shield::1:0:", -- Militia Buckler
	[2250]="0:12:1:1:::1:0:", -- Dusky Crab Cakes
	[2251]="0:7:1:20:Meat:185:1:0:", -- Gooey Spider Leg
	[2252]="0:12:1:1:::1:0:", -- Miscellaneous Goblin Supplies
	[2254]="0:2:2:1:TwoHandMace::1:0:", -- Icepane Warhammer
	[2256]="0:2:3:1:OneHandMace::1:0:", -- Skeletal Club
	[2257]="0:2:1:1:Stave::1:0:", -- Frostmane Staff
	[2258]="0:2:1:1:OneHandSword::1:0:", -- Frostmane Shortsword
	[2259]="0:2:1:1:OneHandMace::1:0:", -- Frostmane Club
	[2260]="0:2:1:1:OneHandAxe::1:0:", -- Frostmane Hand Axe
	[2262]="0:4:3:1:Ring::1:0:", -- Mark of Kern
	[2263]="0:2:2:1:OneHandSword::1:0:", -- Phytoblade
	[2264]="0:4:3:1:Leather::1:0:", -- Mantle of Thieves
	[2265]="0:2:2:1:OneHandAxe::1:0:", -- Stonesplinter Axe
	[2266]="0:2:2:1:Dagger::1:0:", -- Stonesplinter Dagger
	[2267]="0:2:2:1:OneHandMace::1:0:", -- Stonesplinter Mace
	[2268]="0:2:1:1:OneHandSword::1:0:", -- Stonesplinter Blade
	[2271]="0:2:3:1:Stave::1:0:", -- Staff of the Blessed Seer
	[2274]="0:4:2:1:Mail::1:0:", -- Sapper's Gloves
	[2276]="0:4:3:1:Leather::1:0:", -- Swampwalker Boots
	[2277]="0:4:3:1:Cloth::1:0:", -- Necromancer Leggings
	[2278]="0:4:3:1:Leather::1:0:", -- Forest Tracker Epaulets
	[2280]="0:2:3:1:Stave::1:0:", -- Kam's Walking Stick
	[2281]="0:2:2:1:OneHandAxe::1:0:", -- Rodentia Flint Axe
	[2282]="0:2:1:1:OneHandSword::1:0:", -- Rodentia Shortsword
	[2283]="0:4:2:1:Cloth::1:0:", -- Rat Cloth Belt
	[2284]="0:4:2:1:Cloak::1:0:", -- Rat Cloth Cloak
	[2287]="125:0:1:20:FoodDrink::5:0:982,1464,2365,2388,2814,3025,3089,3312,3368,3411,3489,3621,3705,3881,3882,3933,3935,3960,4084,4169,4782,4875,4879,4891,4894,4954,5111,5124,5611,5620,5870,6928,6929,7485,7731,7733,8125,9356,11118,11187,12196,12959,14624,15174,15397,16443,16618,16739,17553,17630,17656,19182,23263,23481,23605,24208,24291,24343", -- Haunch of Meat
	[2288]="0:0:1:20:FoodDrink::1:0:", -- Conjured Fresh Water
	[2289]="350:0:1:20:Scroll::1:1:12246,14847", -- Scroll of Strength II
	[2290]="300:0:1:20:Scroll::1:1:1316,2805,4581,4878,12246,13476,14847", -- Scroll of Intellect II
	[2291]="0:2:4:1:TwoHandAxe::1:0:", -- Kang the Decapitator
	[2292]="0:4:3:1:Cloth::1:0:", -- Necrology Robes
	[2295]="0:15:0:5:Junk::1:0:", -- Large Boar Tusk
	[2296]="0:7:1:20:Meat::1:0:", -- Great Goretusk Snout
	[2299]="0:2:3:1:TwoHandAxe::1:0:", -- Burning War Axe
	[2300]="0:4:2:1:Leather::1:0:", -- Embossed Leather Vest
	[2302]="0:4:1:1:Leather::1:0:", -- Handstitched Leather Boots
	[2303]="0:4:1:1:Leather::1:0:", -- Handstitched Leather Pants
	[2304]="0:0:1:10:EnhPerm::1:0:", -- Light Armor Kit
	[2307]="0:4:2:1:Leather::1:0:", -- Fine Leather Boots
	[2308]="0:4:2:1:Cloak::1:0:", -- Fine Leather Cloak
	[2309]="0:4:2:1:Leather::1:0:", -- Embossed Leather Boots
	[2310]="0:4:2:1:Cloak::1:0:", -- Embossed Leather Cloak
	[2311]="0:4:2:1:Leather::1:0:", -- White Leather Jerkin
	[2312]="0:4:2:1:Leather::1:0:", -- Fine Leather Gloves
	[2313]="0:0:1:10:EnhPerm::1:0:", -- Medium Armor Kit
	[2314]="0:4:3:1:Leather::1:0:", -- Toughened Leather Armor
	[2315]="0:4:2:1:Leather::1:0:", -- Dark Leather Boots
	[2316]="0:4:2:1:Cloak::1:0:", -- Dark Leather Cloak
	[2317]="0:4:2:1:Leather::1:0:", -- Dark Leather Tunic
	[2318]="0:7:1:20:Leather:164,202,165,197:1:0:", -- Light Leather
	[2319]="200:7:1:20:Leather:164,202,165,197:1:1:14846", -- Medium Leather
	[2320]="10:7:1:20:Cloth:165,197:1:0:66,777,843,960,989,1148,1250,1286,1347,1454,1456,1465,1474,1672,1692,2118,2225,2381,2393,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3081,3091,3096,3168,3187,3364,3366,3367,3482,3485,3499,3556,3614,3779,3954,3955,3958,4168,4189,4194,4225,4229,4561,4577,4589,4775,4877,4897,5100,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,9636,11189,11557,11874,12022,12028,12043,12245,12941,12942,12943,12956,12957,12958,15165,15179,16224,16261,16262,16366,16613,16638,16689,16748,16767,16768,17486,17490,18009,18277,18426,18427,18749,18754,18771,18772,19196,19213,19244,19372,19450,19521,19532,19722,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,28692,28718,28726,28798,28810,28831,28872,29288,30311,33596,33601,33635,33636,33681,33684", -- Coarse Thread
	[2321]="100:7:1:20:Cloth:164,165,197:1:0:777,843,960,989,1148,1286,1347,1454,1456,1465,1474,1672,2225,2381,2393,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3091,3096,3364,3366,3367,3482,3485,3499,3556,3779,3954,3955,3958,4168,4189,4194,4225,4229,4561,4577,4589,4775,4877,4897,5100,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,9636,11189,11557,11874,12022,12028,12043,12245,12941,12942,12943,12956,12957,12958,15165,15179,16224,16366,16613,16638,16689,16748,16767,16768,17486,17490,18009,18277,18426,18427,18749,18754,18771,18772,19196,19213,19244,19372,19450,19521,19532,19722,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,28692,28718,28726,28798,28810,28831,28872,29288,30311,33596,33601,33635,33636,33681,33684", -- Fine Thread
	[2324]="25:7:1:10:Other:165,197:1:0:66,777,843,960,1250,1347,1454,1456,1465,1474,1672,1692,2118,2225,2381,2393,2394,2668,2669,2670,2672,3005,3081,3091,3096,3168,3187,3364,3482,3485,3499,3556,3614,4168,4189,4194,4577,4877,5100,5135,5154,5817,5944,6301,6567,6568,6574,6576,7940,7947,8145,8681,8934,9636,11557,12022,12028,12043,15165,16224,16261,16262,16366,16638,16767,17490,18426,18427,18749,18772,19213,19521,19722,24843,24935,24995,25010,25019,25051,25082,28726,28810,29288,33596,33636,33684", -- Bleach
	[2325]="1000:7:1:10:Other:165,197:1:0:989,1148,1286,1347,1454,1474,1672,2225,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3091,3096,3364,3366,3367,3485,3779,3954,3955,3958,4168,4189,4225,4229,4561,4577,4589,4775,4897,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,11189,11557,11874,12022,12028,12245,12941,12942,12943,12956,12957,12958,15165,15179,16366,16613,16638,16689,16748,16767,16768,17486,18009,18277,18749,18754,18771,18772,19196,19213,19244,19372,19450,19521,19532,19722,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,28692,28718,28726,28798,28810,28831,28872,29288,30311,33596,33601,33635,33636,33681,33684", -- Black Dye
	[2326]="0:4:1:1:Cloth::1:0:", -- Ivy-weave Bracers
	[2327]="0:4:1:1:Leather::1:0:", -- Sturdy Leather Bracers
	[2361]="0:2:1:1:TwoHandMace::1:0:", -- Battleworn Hammer
	[2362]="0:4:0:1:Shield::1:0:", -- Worn Wooden Shield
	[2364]="296:4:1:1:Cloth::1:0:3166,3317,3522,4558,16186,16623", -- Woven Vest
	[2366]="298:4:1:1:Cloth::1:0:3166,3317,3522,4558,16186,16623", -- Woven Pants
	[2367]="224:4:1:1:Cloth::1:0:3166,3317,3522,4558,16186,16623", -- Woven Boots
	[2369]="150:4:1:1:Cloth::1:0:3166,3317,3522,4558,16186,16623", -- Woven Gloves
	[2370]="378:4:1:1:Leather::1:0:2137,3079,3093,3166,3321,4558,16186,16691", -- Battered Leather Harness
	[2371]="189:4:1:1:Leather::1:0:2137,3079,3093,3166,3321,4558,16186,16691", -- Battered Leather Belt
	[2372]="344:4:1:1:Leather::1:0:2137,3079,3093,3166,3321,4558,16186,16691", -- Battered Leather Pants
	[2373]="259:4:1:1:Leather::1:0:2137,3079,3093,3166,3321,4558,16186,16691", -- Battered Leather Boots
	[2374]="173:4:1:1:Leather::1:0:2137,3079,3093,3166,3321,4558,16186,16691", -- Battered Leather Bracers
	[2375]="174:4:1:1:Leather::1:0:2137,3079,3093,3166,3321,4558,16186,16691", -- Battered Leather Gloves
	[2376]="448:4:1:1:Shield::1:0:2135,3080,3167,3319,4559,16258,16693", -- Worn Heater Shield
	[2377]="0:4:1:1:Shield::1:0:", -- Round Buckler
	[2378]="0:12:1:20:::1:0:", -- Skeleton Finger
	[2379]="76:4:1:1:Mail::1:0:1104,1213,3592,4177,16917", -- Tarnished Chain Vest
	[2380]="38:4:1:1:Mail::1:0:1104,1213,3592,4177,16917", -- Tarnished Chain Belt
	[2381]="76:4:1:1:Mail::1:0:1104,1213,3592,4177,16917", -- Tarnished Chain Leggings
	[2382]="0:12:1:1:::1:0:", -- The Embalmer's Heart
	[2383]="58:4:1:1:Mail::1:0:1104,1213,3592,4177,16917", -- Tarnished Chain Boots
	[2384]="38:4:1:1:Mail::1:0:1104,1213,3592,4177,16917", -- Tarnished Chain Bracers
	[2385]="38:4:1:1:Mail::1:0:1104,1213,3592,4177,16917", -- Tarnished Chain Gloves
	[2386]="78:4:1:1:Mail::1:0:2116,3075,3161,4559", -- Rusted Chain Vest
	[2387]="39:4:1:1:Mail::1:0:2116,3075,3161,4559", -- Rusted Chain Belt
	[2388]="78:4:1:1:Mail::1:0:2116,3075,3161,4559", -- Rusted Chain Leggings
	[2389]="59:4:1:1:Mail::1:0:2116,3075,3161,4559", -- Rusted Chain Boots
	[2390]="39:4:1:1:Mail::1:0:2116,3075,3161,4559", -- Rusted Chain Bracers
	[2391]="39:4:1:1:Mail::1:0:2116,3075,3161,4559", -- Rusted Chain Gloves
	[2392]="413:4:1:1:Mail::1:0:1240,1249,1294,2046,3613,4164,4177,5106,5812,5819,16750,17930", -- Light Mail Armor
	[2393]="207:4:1:1:Mail::1:0:1240,1249,1294,2046,3613,4164,4177,5106,5812,5819,16750,17930", -- Light Mail Belt
	[2394]="416:4:1:1:Mail::1:0:1240,1249,1294,2046,3613,4164,4177,5106,5812,5819,16750,17930", -- Light Mail Leggings
	[2395]="323:4:1:1:Mail::1:0:1240,1249,1294,2046,3613,4164,4177,5106,5812,5819,16750,17930", -- Light Mail Boots
	[2396]="215:4:1:1:Mail::1:0:1240,1249,1294,2046,3613,4164,4177,5106,5812,5819,16750,17930", -- Light Mail Bracers
	[2397]="216:4:1:1:Mail::1:0:1240,1249,1294,2046,3613,4164,4177,5106,5812,5819,16750,17930", -- Light Mail Gloves
	[2398]="434:4:1:1:Mail::1:0:2135,3080,3167,3319,4559,16258,16625,16693", -- Light Chain Armor
	[2399]="218:4:1:1:Mail::1:0:2135,3080,3167,3319,4559,16258,16625,16693", -- Light Chain Belt
	[2400]="437:4:1:1:Mail::1:0:2135,3080,3167,3319,4559,16258,16625,16693", -- Light Chain Leggings
	[2401]="331:4:1:1:Mail::1:0:2135,3080,3167,3319,4559,16258,16625,16693", -- Light Chain Boots
	[2402]="220:4:1:1:Mail::1:0:2135,3080,3167,3319,4559,16258,16625,16693", -- Light Chain Bracers
	[2403]="221:4:1:1:Mail::1:0:2135,3080,3167,3319,4559,16258,16625,16693", -- Light Chain Gloves
	[2406]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Fine Leather Boots
	[2407]="0:9:2:1:Leatherworking::1:0:", -- Pattern: White Leather Jerkin
	[2408]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Fine Leather Gloves
	[2409]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Dark Leather Tunic
	[2411]="10000:15:3:1:Mount::1:0:1460", -- Black Stallion Bridle
	[2414]="10000:15:3:1:Mount::1:0:384,1460,2357,4885", -- Pinto Bridle
	[2417]="15673:4:1:1:Mail::1:0:1322,1323,1349,1381,2845,3095,4177,5125,5812,5819,8129", -- Augmented Chain Vest
	[2418]="15732:4:1:1:Mail::1:0:1322,1323,1349,1381,2845,3095,4177,5125,5812,5819,8129", -- Augmented Chain Leggings
	[2419]="7895:4:1:1:Mail::1:0:1322,1323,1349,1381,2845,3095,4177,5125,5812,5819,8129", -- Augmented Chain Belt
	[2420]="11938:4:1:1:Mail::1:0:1322,1323,1339,1349,1381,2845,3095,4177,4890,5125,5812,5819,8129,23571", -- Augmented Chain Boots
	[2421]="7952:4:1:1:Mail::1:0:1322,1323,1349,1381,2845,3095,4177,5125,5812,5819,8129", -- Augmented Chain Bracers
	[2422]="7981:4:1:1:Mail::1:0:1322,1323,1349,1381,2845,3095,4177,5125,5812,5819,8129", -- Augmented Chain Gloves
	[2423]="42770:4:1:1:Mail::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Brigandine Vest
	[2424]="21461:4:1:1:Mail::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Brigandine Belt
	[2425]="43077:4:1:1:Mail::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Brigandine Leggings
	[2426]="32569:4:1:1:Mail::1:0:980,1323,1339,1349,3095,4177,4890,5126,5508,5812,5819,8129,11182,16626,16753,23571,25274,27067", -- Brigandine Boots
	[2427]="20146:4:1:1:Mail::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Brigandine Bracers
	[2428]="20222:4:1:1:Mail::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Brigandine Gloves
	[2429]="10139:4:1:1:Cloth::1:0:1147,1314,1407,2849,3092,3315,3316,4175,5155,5821,8159,10293", -- Russet Vest
	[2431]="10215:4:1:1:Cloth::1:0:1147,1314,1407,2849,3092,3315,3316,4175,5155,5821,8159,10293", -- Russet Pants
	[2432]="7691:4:1:1:Cloth::1:0:1147,1314,1339,1407,2849,3092,3315,3316,4175,4890,5155,5821,8159,10293,23571", -- Russet Boots
	[2434]="5166:4:1:1:Cloth::1:0:1147,1314,1407,2849,3092,3315,3316,4175,5155,5821,8159,10293", -- Russet Gloves
	[2435]="27683:4:1:1:Cloth::1:0:984,1314,2849,3092,3315,3316,4175,5129,5155,5821,10293,11183,12023,26707", -- Embroidered Armor
	[2437]="27891:4:1:1:Cloth::1:0:984,1314,2849,3092,3315,3316,4175,5129,5155,5821,10293,11183,12023,26707", -- Embroidered Pants
	[2438]="20996:4:1:1:Cloth::1:0:984,1314,1339,2849,3092,3315,3316,4175,4890,5129,5155,5821,10293,11183,12023,23571,26707", -- Embroidered Boots
	[2440]="14099:4:1:1:Cloth::1:0:984,1314,2849,3092,3315,3316,4175,5129,5155,5821,10293,11183,12023,26707", -- Embroidered Gloves
	[2445]="3433:4:1:1:Shield::1:0:793,1319,3319,3493,4240,5126,8360,16693,16762", -- Large Metal Shield
	[2446]="6182:4:1:1:Shield::1:0:226,1319,1323,1349,1450,3095,4240,4886,5126,5812,5819,6028,16693,16762,31027", -- Kite Shield
	[2447]="40:7:1:20:Herb:171:1:1:1313,3490,3548,16224,16641,16705", -- Peacebloom
	[2448]="16159:4:1:1:Shield::1:0:1319,1322,1323,1349,1381,2845,3095,4177,4240,5125,5126,5812,5819,8129", -- Heavy Pavise
	[2449]="80:7:1:20:Herb:171:1:1:844,1302,1313,3490,3548,4083,4878,8305,14846,16224,16641,16705", -- Earthroot
	[2450]="0:7:1:20:Herb:171:1:0:", -- Briarthorn
	[2451]="43629:4:1:1:Shield::1:0:980,1319,1323,1349,3095,4177,4240,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Crested Heater Shield
	[2452]="0:7:1:20:Herb:171,185:1:0:", -- Swiftthistle
	[2453]="100:7:1:20:Herb:171:1:1:844,1302,1313,3490,3548,4083,4878,8305,14846,16224,16641,16705", -- Bruiseweed
	[2454]="0:0:1:20:Elixir::1:0:", -- Elixir of Lion's Strength
	[2455]="40:0:1:20:Potion::1:1:958,3658,16612,16706", -- Minor Mana Potion
	[2456]="0:0:1:20:Potion::1:0:", -- Minor Rejuvenation Potion
	[2457]="0:0:1:20:Elixir:165:1:0:", -- Elixir of Minor Agility
	[2458]="0:0:1:20:Elixir::1:0:", -- Elixir of Minor Fortitude
	[2459]="0:0:1:20:Potion:164,165:1:0:", -- Swiftness Potion
	[2463]="13695:4:1:1:Leather::1:0:1147,1314,1320,1407,3315,3316,4236,5129,5820,8159", -- Studded Doublet
	[2464]="6872:4:1:1:Leather::1:0:1147,1314,1320,1407,3315,3316,4236,5129,5820,8159", -- Studded Belt
	[2465]="12477:4:1:1:Leather::1:0:1147,1314,1320,1407,3315,3316,4236,5129,5820,8159", -- Studded Pants
	[2466]="0:12:1:20:::1:0:", -- Skullsplitter Fetish
	[2467]="9430:4:1:1:Leather::1:0:1147,1314,1320,1339,1407,3315,3316,4236,4890,5129,5820,8159,23571", -- Studded Boots
	[2468]="6311:4:1:1:Leather::1:0:1147,1314,1320,1407,3315,3316,4236,5129,5820,8159", -- Studded Bracers
	[2469]="6335:4:1:1:Leather::1:0:1147,1314,1320,1407,3315,3316,4236,5129,5820,8159", -- Studded Gloves
	[2470]="33952:4:1:1:Leather::1:0:984,1314,1320,3315,3316,4236,5129,5820,11183,12023,26707,27037", -- Reinforced Leather Vest
	[2471]="17041:4:1:1:Leather::1:0:984,1314,1320,3315,3316,4236,5129,5820,11183,12023,26707,27037", -- Reinforced Leather Belt
	[2472]="34212:4:1:1:Leather::1:0:984,1314,1320,3315,3316,4236,5129,5820,11183,12023,26707,27037", -- Reinforced Leather Pants
	[2473]="25753:4:1:1:Leather::1:0:984,1314,1320,1339,3315,3316,4236,4890,5129,5820,11183,12023,23571,26707,27037", -- Reinforced Leather Boots
	[2474]="17233:4:1:1:Leather::1:0:984,1314,1320,3315,3316,4236,5129,5820,11183,12023,26707,27037", -- Reinforced Leather Bracers
	[2475]="17298:4:1:1:Leather::1:0:984,1314,1320,3315,3316,4236,5129,5820,11183,12023,26707,27037", -- Reinforced Leather Gloves
	[2476]="0:12:1:20:::1:0:", -- Chilled Basilisk Haunch
	[2477]="0:12:1:20:::1:0:", -- Ravager's Skull
	[2479]="108:2:1:1:TwoHandAxe::1:0:78,945,2117,2997,3073,3159,3314,3588,4231,4556,5102,16919", -- Broad Axe
	[2480]="72:2:1:1:TwoHandMace::1:0:78,945,2117,2997,3073,3159,3314,3588,4231,4556,5102,16919", -- Large Club
	[2488]="536:2:1:1:OneHandSword::1:0:54,1273,1698,2136,2265,2997,3077,3163,3314,3609,4231,4556,5102,10369,16257,17930,18926", -- Gladius
	[2489]="343:2:1:1:TwoHandSword::1:0:54,1273,1698,2136,2265,2997,3077,3163,3314,3609,4231,4556,5102,10369,16257,17930,18926", -- Two-handed Sword
	[2490]="540:2:1:1:OneHandAxe::1:0:54,1273,1698,2136,2265,2997,3077,3163,3177,3314,3609,4231,4556,5102,10369,16257,17930,18926", -- Tomahawk
	[2491]="484:2:1:1:TwoHandAxe::1:0:54,1273,1698,2136,2265,2997,3077,3163,3177,3314,3609,4231,4556,5102,10369,16257,17930,18926", -- Large Axe
	[2492]="285:2:1:1:OneHandMace::1:0:54,222,1273,1348,1698,2136,2265,2997,3077,3163,3177,3314,3609,4231,4556,5102,10369,16257,17930,18926", -- Cudgel
	[2493]="701:2:1:1:TwoHandMace::1:0:54,222,1273,1348,1698,2136,2265,2997,3077,3163,3177,3314,3609,4231,4556,5102,10369,16257,17930,18926", -- Wooden Mallet
	[2494]="402:2:1:1:Dagger::1:0:54,1273,1698,2136,2265,2997,3077,3163,3314,3609,4231,4556,5102,10369,16257,17930,18926", -- Stiletto
	[2495]="505:2:1:1:Stave::1:0:54,1273,1698,2136,2265,2997,3077,3163,3314,3409,3609,4231,4556,5102,10369,16257,17930,18926,19238", -- Walking Stick
	[2499]="0:2:1:1:TwoHandAxe::1:0:", -- Double-bladed Axe
	[2504]="29:2:1:1:Bow::1:0:1297,12029,16263,16274,16619,16715,17667", -- Worn Shortbow
	[2505]="60:2:1:1:Bow::1:0:1297,12029,16263,16274,16619,16715,17667", -- Polished Shortbow
	[2506]="285:2:1:1:Bow::1:0:1198,1297,3165,3589,3610,10369,12029,16263,16274,16619,16715,17667", -- Hornwood Recurve Bow
	[2507]="1752:2:1:1:Bow::1:0:1198,1297,1459,1668,1687,3165,3409,3488,3589,3610,3951,4203,9549,9553,10369,12029,16263,16274,16619,16715,17667", -- Laminated Recurve Bow
	[2508]="27:2:1:1:Gun::1:0:5510", -- Old Blunderbuss
	[2509]="414:2:1:1:Gun::1:0:1243,1297,1469,2997,3018,3078,3322,3488,4603,5123,5510,7976,9551,16274,16620,16735", -- Ornate Blunderbuss
	[2510]="41:2:1:1:Gun::1:0:1243,3018,3078,4603,5123,5510", -- Solid Blunderbuss
	[2511]="1324:2:1:1:Gun::1:0:1297,1469,1686,2997,3018,3088,3322,3488,7976,9551,16274,16620,16735", -- Hunter's Boomstick
	[2512]="10:6:1:1000:Arrow::200:0:151,152,228,491,789,791,829,1198,1250,1285,1287,1297,1298,1459,1462,1668,1682,1685,1687,1691,2115,2134,2140,2839,3015,3072,3076,3158,3164,3165,3186,3313,3409,3410,3481,3488,3498,3587,3589,3608,3610,3951,4082,4084,4170,4173,4182,4203,4241,4555,4602,4604,4892,5122,6028,7942,7976,8362,9548,9549,9551,9552,9553,9555,10369,12027,12029,12960,14301,15287,16187,16191,16259,16260,16263,16274,16444,16619,16715,16732,16919,16920,17421,17446,17489,17598,17667,18810,18811,19020,19561,27055", -- Rough Arrow
	[2515]="50:6:1:1000:Arrow::200:0:227,228,491,734,789,791,1149,1198,1285,1287,1297,1298,1448,1452,1459,1462,1668,1682,1685,1687,2084,2140,2401,2803,2806,2808,2820,2839,2908,3015,3165,3313,3350,3409,3410,3481,3488,3498,3541,3589,3610,3625,3951,3962,4082,4084,4170,4173,4182,4203,4241,4555,4602,4604,4876,4892,4896,5101,5122,5134,6028,7942,7976,8139,8362,9548,9549,9551,9552,9553,9555,10369,11038,11555,12021,12027,12029,12246,12959,12960,14301,14624,15174,15397,16187,16191,16263,16274,16444,16619,16715,16732,16919,17421,17489,17598,17667,18810,18811,19020,19561,27055", -- Sharp Arrow
	[2516]="10:6:1:1000:Bullet::200:0:151,152,491,791,829,1243,1250,1285,1297,1461,1469,1682,1685,1686,1691,2115,2134,2140,2685,2997,3018,3053,3072,3076,3078,3088,3158,3164,3186,3313,3322,3481,3488,3498,3587,3608,4082,4084,4170,4182,4241,4555,4603,4889,5123,5510,6028,7942,7976,8131,8362,9548,9551,11184,12027,12960,16187,16191,16259,16260,16274,16444,16620,16732,16735,17421,17446,17489,18810,18811", -- Light Shot
	[2519]="50:6:1:1000:Bullet::200:0:227,491,734,791,1149,1243,1285,1297,1448,1452,1461,1469,1682,1685,1686,2084,2140,2401,2685,2803,2806,2808,2820,2908,2997,3018,3053,3078,3088,3313,3322,3350,3481,3488,3498,3541,3625,3962,4082,4084,4170,4182,4241,4555,4603,4876,4889,4896,5101,5123,5134,5510,6028,7942,7976,8131,8139,8362,9548,9551,11038,11184,11555,12021,12027,12246,12959,12960,14624,15174,15397,16187,16191,16274,16444,16620,16732,16735,17421,17489,18810,18811", -- Heavy Shot
	[2520]="24629:2:1:1:OneHandSword::1:0:1146,1324,1645,2482,2843,3000,3021,3331,3361,4171,4600,4884,4888,5120,5170,11137,15315,16678,16714,19047,19240,21086,21474,28871", -- Broadsword
	[2521]="30896:2:1:1:TwoHandSword::1:0:1146,1333,1645,2482,2843,3000,4043,4180,4600,4884,4888,5120,5170,8398,11137,15315,16678,19047,19240,21086,21474,28871", -- Flamberge
	[2522]="22548:2:1:1:OneHandAxe::1:0:1146,1645,2482,2483,3000,3019,4232,4884,4888,5119,5509,10379,11137,12045,15315,16666,19479,21086,23571", -- Crescent Axe
	[2523]="28286:2:1:1:TwoHandAxe::1:0:1146,1333,1645,2482,2483,3000,3019,4043,4180,4232,4600,4884,4888,5119,5509,8398,10379,11137,12045,15315,16666,19479,21086,23571", -- Bullova
	[2524]="19192:2:1:1:OneHandMace::1:0:1146,1471,1645,2482,3000,4884,4888,5121,5152,8878,10379,11137,16637,16765,19370,21086,25314,28855,31027", -- Truncheon
	[2525]="26490:2:1:1:TwoHandMace::1:0:1146,1333,1471,1645,2482,3000,4043,4180,4600,4884,4888,5121,5152,8398,8878,10379,11137,16637,16765,19370,21086,25314,28855,31027", -- War Hammer
	[2526]="19336:2:1:1:Dagger::1:0:1146,1324,1645,2482,2843,3000,3021,3331,3361,4171,4600,4884,4888,5120,5170,11137,15315,16678,16714,19047,19239,19240,21086,21474,28871", -- Main Gauche
	[2527]="29356:2:1:1:Stave::1:0:1146,1315,1471,1645,2482,3000,3022,3330,3349,4234,4570,4884,4888,5121,5152,8878,10379,11137,16637,16765,19043,19238,19370,21086,25314,28855,31027", -- Battle Staff
	[2528]="51836:2:1:1:OneHandSword::1:0:981,1296,1324,1407,2843,3000,3021,3331,3361,4171,4600,5120,5170,10361,11184,12024,15315,16388,16678,16714,19047,19240,21474,23897,28871", -- Falchion
	[2529]="65032:2:1:1:TwoHandSword::1:0:981,1296,1333,1407,2843,3000,4043,4180,4600,5120,5170,8398,10361,11184,12024,15315,16388,16678,19047,19240,21474,23897,28871", -- Zweihander
	[2530]="52220:2:1:1:OneHandAxe::1:0:981,1296,1407,2483,3000,3019,4232,5119,5509,10361,10379,11184,12024,12045,15315,16388,16666,19479,23571,23897", -- Francisca
	[2531]="56170:2:1:1:TwoHandAxe::1:0:981,1296,1333,1407,2483,3000,3019,4043,4180,4232,4600,5119,5509,8398,10361,10379,11184,12024,12045,15315,16388,16666,19479,23571,23897", -- Great Axe
	[2532]="52608:2:1:1:OneHandMace::1:0:981,1296,1407,1471,3000,5121,5152,8878,10361,10379,11184,12024,16388,16637,16765,19370,21086,23897,25314,28855,31027", -- Morning Star
	[2533]="61108:2:1:1:TwoHandMace::1:0:981,1296,1333,1407,1471,3000,4043,4180,4600,5121,5152,8398,8878,10361,10379,11184,12024,16388,16637,16765,19370,21086,23897,25314,28855,31027", -- War Maul
	[2534]="45431:2:1:1:Dagger::1:0:981,1296,1324,1407,2843,3000,3021,3331,3361,4171,4600,5120,5170,10361,11184,12024,15315,16388,16678,16714,19047,19239,19240,21474,23897,28871", -- Rondel
	[2535]="61557:2:1:1:Stave::1:0:981,1296,1315,1407,1471,3000,3022,3330,3349,4234,4570,5121,5152,8878,10361,10379,11184,12024,16388,16637,16765,19043,19238,19370,21086,23897,25314,28855,31027", -- War Staff
	[2536]="0:12:1:20:::1:0:", -- Trogg Stone Tooth
	[2545]="0:4:2:1:Mail::1:0:", -- Malleable Chain Leggings
	[2546]="0:4:1:1:Mail::1:0:", -- Royal Frostmane Girdle
	[2547]="0:4:1:1:Mail::1:0:", -- Boar Handler Gloves
	[2548]="0:12:1:1:::1:0:", -- Barrel of Barleybrew Scalder
	[2549]="0:2:3:1:Stave::1:0:", -- Staff of the Shade
	[2553]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Minor Agility
	[2555]="0:9:2:1:Alchemy::1:0:", -- Recipe: Swiftness Potion
	[2560]="0:12:1:1:::1:0:", -- Jitters' Completed Journal
	[2561]="0:12:1:1:::1:0:", -- Chok'sul's Head
	[2562]="0:4:1:1:OffHandFrill::1:0:", -- Bouquet of Scarlet Begonias
	[2563]="0:12:1:1:::1:0:", -- Strange Smelling Powder
	[2564]="0:4:3:1:Leather::1:0:", -- Elven Spirit Claws
	[2565]="0:4:3:1:OffHandFrill::1:0:", -- Rod of Molten Fire
	[2566]="0:4:2:1:Cloth::1:0:", -- Sacrificial Robes
	[2567]="0:2:3:1:Dagger::1:0:", -- Evocator's Blade
	[2568]="0:4:1:1:Cloth::1:0:", -- Brown Linen Vest
	[2569]="0:4:2:1:Cloth::1:0:", -- Linen Boots
	[2570]="0:4:1:1:Cloak::1:0:", -- Linen Cloak
	[2571]="0:4:1:1:Cloth::1:0:", -- Viny Wrappings
	[2572]="0:4:2:1:Cloth::1:0:", -- Red Linen Robe
	[2575]="0:4:1:1:Shirt::1:0:", -- Red Linen Shirt
	[2576]="0:4:1:1:Shirt::1:0:", -- White Linen Shirt
	[2577]="0:4:1:1:Shirt::1:0:", -- Blue Linen Shirt
	[2578]="0:4:2:1:Cloth::1:0:", -- Barbaric Linen Vest
	[2579]="0:4:1:1:Shirt::1:0:", -- Green Linen Shirt
	[2580]="0:4:2:1:Cloak::1:0:", -- Reinforced Linen Cape
	[2581]="0:0:1:20:Bandage::1:0:", -- Heavy Linen Bandage
	[2582]="0:4:2:1:Cloth::1:0:", -- Green Woolen Vest
	[2583]="0:4:2:1:Cloth::1:0:", -- Woolen Boots
	[2584]="0:4:1:1:Cloak::1:0:", -- Woolen Cape
	[2585]="0:4:2:1:Cloth::1:0:", -- Gray Woolen Robe
	[2586]="0:4:1:1:Cloth::1:0:", -- Gamemaster's Robe
	[2587]="0:4:1:1:Shirt::1:0:", -- Gray Woolen Shirt
	[2589]="55:7:1:20:Cloth:164,202,129,197:1:1:16631", -- Linen Cloth
	[2590]="0:15:0:5:Junk::1:0:", -- Forest Spider Webbing
	[2591]="0:15:0:5:Junk::1:0:", -- Dirty Trogg Cloth
	[2592]="135:7:1:20:Cloth:164,202,129,197:1:1:16631", -- Wool Cloth
	[2593]="150:0:1:20:FoodDrink:185:1:0:258,277,465,955,1301,1305,1311,1328,1697,2832,5111,5112,5140,5570,5611,5848,16442,17553,18542,18954,19186,19245,19617,23525,23606,24333,31017,33026", -- Flask of Port
	[2594]="1500:0:1:20:FoodDrink:185:1:0:258,277,465,955,1301,1305,1311,1328,1464,1697,2832,5111,5112,5140,5570,5611,5848,16442,17553,18542,18954,19186,19245,19617,20377,23525,23606,24333,31017,33026", -- Flagon of Mead
	[2595]="2000:0:1:20:FoodDrink::1:0:258,277,465,955,1301,1305,1311,1328,1697,2832,5111,5112,5140,5570,5611,5848,16442,17553,18542,18954,19186,19245,19617,23525,23606,24333,31017,33026", -- Jug of Bourbon
	[2596]="120:0:1:20:FoodDrink:185:1:0:258,277,465,955,1301,1305,1311,1328,1697,2832,5111,5112,5140,5570,5611,5848,16442,17553,18542,18954,19186,19245,19617,23525,23606,24333,31017,33026", -- Skin of Dwarven Stout
	[2598]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Linen Robe
	[2601]="0:9:2:1:Tailoring::1:0:", -- Pattern: Gray Woolen Robe
	[2604]="50:7:1:10:Other:165,197:1:0:66,843,989,1148,1250,1286,1347,1454,1465,1474,1672,1692,2118,2225,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3081,3091,3096,3168,3187,3364,3366,3367,3482,3485,3614,3779,3954,3955,3958,4168,4189,4194,4225,4229,4561,4577,4589,4775,4897,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,11189,11557,11874,12022,12028,12245,12941,12942,12943,12956,12957,12958,15165,15179,16224,16261,16262,16366,16613,16638,16689,16748,16767,16768,17486,17490,18009,18277,18426,18427,18749,18754,18771,18772,19196,19213,19244,19372,19450,19521,19532,19722,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,28692,28718,28726,28798,28810,28831,28872,29288,30311,33596,33601,33635,33636,33681,33684", -- Red Dye
	[2605]="100:7:1:10:Other:164,202,165,197:1:0:843,1347,1454,1465,1474,1672,2225,2394,2668,2669,2670,2672,2697,2698,2699,2816,2819,2846,3005,3091,3096,3364,3366,3482,3485,3958,4168,4189,4194,4225,4577,4589,5128,5135,5154,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,8160,8681,8934,11557,11874,12942,12943,12956,15165,16224,16366,16638,16689,16748,16767,17490,18277,18426,18427,18749,18754,18771,18772,19196,19213,19521,19532,19722,21085,28718,28726,28798,28810,33596,33601,33635,33636,33681,33684", -- Green Dye
	[2606]="0:12:1:1:::1:0:", -- Lurker Venom
	[2607]="0:12:1:1:::1:0:", -- Mo'grosh Crystal
	[2608]="0:15:0:5:Junk::1:0:", -- Threshadon Ambergris
	[2609]="0:12:1:1:::1:0:", -- Disarming Colloid
	[2610]="0:12:1:1:::1:0:", -- Disarming Mixture
	[2611]="0:12:1:20:::1:0:", -- Crude Flint
	[2612]="163:4:1:1:Cloth::1:0:1309,1350,3092,3315,4172,4580,5156", -- Plain Robe
	[2613]="608:4:1:1:Cloth::1:0:1309,1350,3092,3315,4172,4580,5156", -- Double-stitched Robes
	[2614]="1162:4:1:1:Cloth::1:0:1309,1350,3092,3315,4172,4580,5156", -- Robe of Apprenticeship
	[2615]="5092:4:1:1:Cloth::1:0:1309,1350,3092,3315,4172,4580,5156", -- Chromatic Robe
	[2616]="2660:4:1:1:Cloth::1:0:1309,1350,3092,3315,4172,4580,5156", -- Shimmering Silk Robes
	[2617]="10992:4:1:1:Cloth::1:0:1309,1350,3092,3315,4172,4580,5156", -- Burning Robes
	[2618]="26640:4:1:1:Cloth::1:0:1309,1350,3092,3315,4172,4580,5156", -- Silver Dress Robes
	[2619]="0:12:1:1:::1:0:", -- Grelin's Report
	[2620]="0:4:2:1:Cloth::1:0:", -- Augural Shroud
	[2621]="0:4:2:1:Cloth::1:0:", -- Cowl of Necromancy
	[2622]="0:4:2:1:Cloth::1:0:", -- Nimar's Tribal Headdress
	[2623]="0:4:2:1:Cloth::1:0:", -- Holy Diadem
	[2624]="0:4:2:1:Cloth::1:0:", -- Thinking Cap
	[2625]="0:12:1:1:::1:0:", -- Menethil Statuette
	[2628]="0:12:1:1:::1:0:", -- Senir's Report
	[2629]="0:13:1:1:::1:0:", -- Intrepid Strongbox Key
	[2632]="0:2:2:1:Dagger::1:0:", -- Curved Dagger
	[2633]="0:0:1:20:Potion::1:0:", -- Jungle Remedy
	[2634]="0:12:1:1:::1:0:", -- Venom Fern Extract
	[2635]="0:4:0:1:Mail::1:0:", -- Loose Chain Belt
	[2636]="0:12:1:20:::1:0:", -- Carved Stone Idol
	[2637]="0:12:1:1:::1:0:", -- Ironband's Progress Report
	[2639]="0:12:1:1:::1:0:", -- Merrin's Letter
	[2640]="0:12:1:20:::1:0:", -- Miners' Gear
	[2642]="0:4:0:1:Mail::1:0:", -- Loose Chain Boots
	[2643]="0:4:0:1:Mail::1:0:", -- Loose Chain Bracers
	[2644]="0:4:0:1:Cloak::1:0:", -- Loose Chain Cloak
	[2645]="0:4:0:1:Mail::1:0:", -- Loose Chain Gloves
	[2646]="0:4:0:1:Mail::1:0:", -- Loose Chain Pants
	[2648]="0:4:0:1:Mail::1:0:", -- Loose Chain Vest
	[2649]="0:4:0:1:Mail::1:0:", -- Flimsy Chain Belt
	[2650]="0:4:0:1:Mail::1:0:", -- Flimsy Chain Boots
	[2651]="0:4:0:1:Mail::1:0:", -- Flimsy Chain Bracers
	[2652]="0:4:0:1:Cloak::1:0:", -- Flimsy Chain Cloak
	[2653]="0:4:0:1:Mail::1:0:", -- Flimsy Chain Gloves
	[2654]="0:4:0:1:Mail::1:0:", -- Flimsy Chain Pants
	[2656]="0:4:0:1:Mail::1:0:", -- Flimsy Chain Vest
	[2657]="0:1:1:1:Bag::1:0:", -- Red Leather Bag
	[2658]="0:12:1:1:::1:0:", -- Ados Fragment
	[2659]="0:12:1:1:::1:0:", -- Modr Fragment
	[2660]="0:12:1:1:::1:0:", -- Golm Fragment
	[2661]="0:12:1:1:::1:0:", -- Neru Fragment
	[2662]="0:11:2:1:Quiver::1:0:", -- Ribbly's Quiver
	[2663]="0:11:2:1:AmmoPouch::1:0:", -- Ribbly's Bandolier
	[2665]="20:7:1:20:Meat::1:0:1303", -- Stormwind Seasoning Herbs
	[2666]="0:12:1:1:::1:0:", -- Barrel of Thunder Ale
	[2667]="0:12:1:1:::1:0:", -- MacGrann's Dried Meats
	[2671]="0:12:1:20:::1:0:", -- Wendigo Mane
	[2672]="0:7:1:20:Meat:185:1:0:", -- Stringy Wolf Meat
	[2673]="0:7:1:20:Meat:185:1:0:", -- Coyote Meat
	[2674]="0:7:1:20:Meat:185:1:0:", -- Crawler Meat
	[2675]="0:7:1:20:Meat:185:1:0:", -- Crawler Claw
	[2676]="0:12:1:20:::1:0:", -- Shimmerweed
	[2677]="0:7:1:20:Meat:185:1:0:", -- Boar Ribs
	[2678]="10:7:1:20:Other:185:5:0:66,777,843,960,989,1148,1250,1286,1456,1465,1692,2118,2225,2381,2393,2397,2664,2810,2821,3027,3081,3085,3168,3187,3367,3400,3482,3499,3556,3614,3779,3954,3955,4194,4223,4229,4265,4553,4561,4775,4877,4897,5100,5135,5160,5163,5483,5817,6301,7947,8145,8307,8363,8934,9636,11189,12022,12028,12033,12043,12245,12941,12957,12958,14738,15179,16224,16253,16261,16262,16613,16677,16718,16768,17246,17486,17490,18009,18426,18427,18987,18988,18993,19195,19244,19371,19372,19450,20028,20096,20097,24834,24843,24935,24993,24995,25010,25012,25019,25020,25051,25052,25082,25089,26868,27021,27026,27043,27057,28692,28811,28831,28872,29288,29291,30311,31031,31032,33595,34645,34681,34682,34683,34684,34685,34783,34787,35337,35338,35340,35341,35342,35343", -- Mild Spices
	[2679]="0:0:1:20:FoodDrink::1:0:", -- Charred Wolf Meat
	[2680]="0:0:1:20:FoodDrink::1:0:", -- Spiced Wolf Meat
	[2681]="0:0:1:20:FoodDrink::1:0:", -- Roasted Boar Meat
	[2682]="0:0:1:20:FoodDrink::1:0:", -- Cooked Crab Claw
	[2683]="0:0:1:20:FoodDrink::1:0:", -- Crab Cake
	[2684]="0:0:1:20:FoodDrink::1:0:", -- Coyote Steak
	[2685]="0:0:1:20:FoodDrink::1:0:", -- Succulent Pork Ribs
	[2686]="50:0:1:10:FoodDrink::1:0:1247,1682,7744", -- Thunder Ale
	[2687]="0:0:1:20:FoodDrink::1:0:", -- Dry Pork Ribs
	[2690]="0:4:1:1:Mail::1:0:", -- Latched Belt
	[2691]="0:4:1:1:Mail::1:0:", -- Outfitter Boots
	[2692]="0:7:1:20:Other::1:0:", -- Hot Spices
	[2694]="0:4:2:1:Mail::1:0:", -- Settler's Leggings
	[2696]="0:12:1:1:::1:0:", -- Cask of Evershine
	[2697]="400:9:1:1:Cooking::1:0:340", -- Recipe: Goretusk Liver Pie
	[2698]="400:9:1:1:Cooking::1:0:340", -- Recipe: Cooked Crab Claw
	[2699]="800:9:1:1:Cooking::1:0:340", -- Recipe: Redridge Goulash
	[2700]="400:9:1:1:Cooking::1:0:340", -- Recipe: Succulent Pork Ribs
	[2701]="1600:9:1:1:Cooking::1:0:340", -- Recipe: Seasoned Wolf Kabob
	[2702]="0:12:1:20:::1:0:", -- Lightforge Ingot
	[2712]="0:12:1:1:::1:0:", -- Crate of Lightforge Ingots
	[2713]="0:12:1:1:::1:0:", -- Ol' Sooty's Head
	[2719]="0:13:1:1:::1:0:", -- Small Brass Key
	[2720]="0:12:1:1:::1:0:", -- Muddy Note
	[2721]="0:4:3:1:Cloth::1:0:", -- Holy Shroud
	[2722]="0:12:1:1:::1:0:", -- Wine Ticket
	[2723]="50:0:1:20:FoodDrink::1:0:258,277,465,955,1301,1305,1311,1328,1697,2832,5111,5112,5140,5570,5611,5848,16442,17553,18542,18954,19186,19245,19617,23525,23606,24333,31017,33026", -- Bottle of Pinot Noir
	[2724]="0:12:1:1:::1:0:", -- Cloth Request
	[2725]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 1
	[2728]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 4
	[2730]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 6
	[2732]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 8
	[2734]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 10
	[2735]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 11
	[2738]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 14
	[2740]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 16
	[2742]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 18
	[2744]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 20
	[2745]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 21
	[2748]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 24
	[2749]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 25
	[2750]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 26
	[2751]="0:12:1:10:::1:0:", -- Green Hills of Stranglethorn - Page 27
	[2754]="0:2:1:1:TwoHandSword::1:0:", -- Tarnished Bastard Sword
	[2756]="0:12:1:1:::1:0:", -- Green Hills of Stranglethorn - Chapter I
	[2757]="0:12:1:1:::1:0:", -- Green Hills of Stranglethorn - Chapter II
	[2758]="0:12:1:1:::1:0:", -- Green Hills of Stranglethorn - Chapter III
	[2759]="0:12:1:1:::1:0:", -- Green Hills of Stranglethorn - Chapter IV
	[2760]="0:12:1:1:::1:0:", -- Thurman's Sewing Kit
	[2763]="0:2:0:1:Dagger::1:0:", -- Fisherman Knife
	[2764]="0:2:0:1:Dagger::1:0:", -- Small Dagger
	[2765]="0:2:0:1:Dagger::1:0:", -- Hunting Knife
	[2766]="0:2:0:1:Dagger::1:0:", -- Deft Stiletto
	[2770]="20:7:1:20:MetalStone:186:1:1:16224", -- Copper Ore
	[2771]="100:7:1:20:MetalStone:186:1:1:16224", -- Tin Ore
	[2772]="0:7:1:20:MetalStone:333,186:1:0:", -- Iron Ore
	[2773]="0:2:0:1:Bow::1:0:", -- Cracked Shortbow
	[2774]="0:2:0:1:Gun::1:0:", -- Rust-covered Blunderbuss
	[2775]="300:7:2:20:MetalStone:186:1:1:16224", -- Silver Ore
	[2776]="0:7:2:20:MetalStone:186:1:0:", -- Gold Ore
	[2777]="0:2:0:1:Bow::1:0:", -- Feeble Shortbow
	[2778]="0:2:0:1:Gun::1:0:", -- Cheap Blunderbuss
	[2779]="0:12:1:1:::1:0:", -- Tear of Tilloa
	[2780]="0:2:0:1:Bow::1:0:", -- Light Hunting Bow
	[2781]="0:2:0:1:Gun::1:0:", -- Dirty Blunderbuss
	[2782]="0:2:0:1:Bow::1:0:", -- Mishandled Recurve Bow
	[2783]="0:2:0:1:Gun::1:0:", -- Shoddy Blunderbuss
	[2784]="0:12:1:1:::1:0:", -- Musquash Root
	[2785]="0:2:0:1:Bow::1:0:", -- Stiff Recurve Bow
	[2786]="0:2:0:1:Gun::1:0:", -- Oiled Blunderbuss
	[2787]="0:2:1:1:Dagger::1:0:", -- Trogg Dagger
	[2788]="0:12:1:1:::1:0:", -- Black Claw Stout
	[2794]="0:12:1:1:::1:0:", -- An Old History Book
	[2795]="0:12:1:1:::1:0:", -- Book: Stresses of Iron
	[2797]="0:12:1:1:::1:0:", -- Heart of Mokk
	[2798]="0:12:1:20:::1:0:", -- Rethban Ore
	[2799]="0:12:1:20:::1:0:", -- Gorilla Fang
	[2800]="0:4:3:1:Cloth::1:0:", -- Black Velvet Robes
	[2801]="0:2:4:1:TwoHandSword::1:0:", -- Blade of Hanna
	[2802]="0:4:3:1:Trinket::1:0:", -- Blazing Emblem
	[2805]="0:4:2:1:Cloak::1:0:", -- Yeti Fur Cloak
	[2806]="0:12:1:1:::1:0:", -- Package for Stormpike
	[2807]="0:2:3:1:OneHandAxe::1:0:", -- Guillotine Axe
	[2815]="0:2:3:1:OneHandAxe::1:0:", -- Curve-bladed Ripper
	[2816]="0:2:3:1:OneHandMace::1:0:", -- Death Speaker Scepter
	[2817]="0:4:2:1:Leather::1:0:", -- Soft Leather Tunic
	[2818]="0:4:2:1:Leather::1:0:", -- Stretched Leather Trousers
	[2819]="0:2:2:1:Dagger::1:0:", -- Cross Dagger
	[2820]="0:4:2:1:Trinket::1:0:", -- Nifty Stopwatch
	[2821]="0:2:2:1:OneHandMace::1:0:", -- Mo'grosh Masher
	[2822]="0:2:2:1:TwoHandSword::1:0:", -- Mo'grosh Toothpick
	[2823]="0:2:2:1:TwoHandAxe::1:0:", -- Mo'grosh Can Opener
	[2824]="0:2:4:1:Bow::1:0:", -- Hurricane
	[2825]="0:2:4:1:Bow::1:0:", -- Bow of Searing Arrows
	[2828]="0:12:1:1:::1:0:", -- Nissa's Remains
	[2829]="0:12:1:1:::1:0:", -- Gregor's Remains
	[2830]="0:12:1:1:::1:0:", -- Thurman's Remains
	[2831]="0:12:1:1:::1:0:", -- Devlin's Remains
	[2832]="0:12:1:1:::1:0:", -- Verna's Westfall Stew Recipe
	[2833]="0:12:1:1:::1:0:", -- The Lich's Spellbook
	[2834]="0:12:1:20:::1:0:", -- Embalming Ichor
	[2835]="0:7:1:20:MetalStone:164,202,755:1:0:", -- Rough Stone
	[2836]="0:7:1:20:MetalStone:164,202,755:1:0:", -- Coarse Stone
	[2837]="0:12:1:1:::1:0:", -- Thurman's Letter
	[2838]="0:7:1:20:MetalStone:164,202,755:1:0:", -- Heavy Stone
	[2839]="0:12:1:1:::1:0:", -- A Letter to Yvette
	[2840]="0:7:1:20:MetalStone:164,202,755,165,186:1:0:", -- Copper Bar
	[2841]="0:7:1:20:MetalStone:164,202,755:1:0:", -- Bronze Bar
	[2842]="0:7:2:20:MetalStone:164,202,755:1:0:", -- Silver Bar
	[2843]="0:12:1:20:::1:0:", -- Dirty Knucklebones
	[2844]="0:2:1:1:OneHandMace::1:0:", -- Copper Mace
	[2845]="0:2:1:1:OneHandAxe::1:0:", -- Copper Axe
	[2846]="0:12:1:20:::1:0:", -- Tirisfal Pumpkin
	[2847]="0:2:1:1:OneHandSword::1:0:", -- Copper Shortsword
	[2848]="0:2:2:1:OneHandMace::1:0:", -- Bronze Mace
	[2849]="0:2:2:1:OneHandAxe::1:0:", -- Bronze Axe
	[2850]="0:2:2:1:OneHandSword::1:0:", -- Bronze Shortsword
	[2851]="0:4:1:1:Mail::1:0:", -- Copper Chain Belt
	[2852]="0:4:1:1:Mail::1:0:", -- Copper Chain Pants
	[2853]="0:4:1:1:Mail::1:0:", -- Copper Bracers
	[2854]="0:4:2:1:Mail::1:0:", -- Runed Copper Bracers
	[2855]="0:12:1:20:::1:0:", -- Putrid Claw
	[2856]="0:12:1:20:::1:0:", -- Iron Pike
	[2857]="0:4:2:1:Mail::1:0:", -- Runed Copper Belt
	[2858]="0:12:1:20:::1:0:", -- Darkhound Blood
	[2859]="0:12:1:20:::1:0:", -- Vile Fin Scale
	[2862]="0:0:1:20:EnhTemp::1:0:", -- Rough Sharpening Stone
	[2863]="0:0:1:20:EnhTemp::1:0:", -- Coarse Sharpening Stone
	[2864]="0:4:2:1:Mail::1:0:", -- Runed Copper Breastplate
	[2865]="0:4:2:1:Mail::1:0:", -- Rough Bronze Leggings
	[2866]="0:4:2:1:Mail::1:0:", -- Rough Bronze Cuirass
	[2867]="0:4:2:1:Mail::1:0:", -- Rough Bronze Bracers
	[2868]="0:4:2:1:Mail::1:0:", -- Patterned Bronze Bracers
	[2869]="0:4:2:1:Mail::1:0:", -- Silvered Bronze Breastplate
	[2870]="0:4:3:1:Mail::1:0:", -- Shining Silver Breastplate
	[2871]="0:0:1:20:EnhTemp::1:0:", -- Heavy Sharpening Stone
	[2872]="0:12:1:20:::1:0:", -- Vicious Night Web Spider Venom
	[2874]="0:12:1:1:::1:0:", -- An Unsent Letter
	[2875]="0:12:1:20:::1:0:", -- Scarlet Insignia Ring
	[2876]="0:12:1:20:::1:0:", -- Duskbat Pelt
	[2877]="0:2:3:1:TwoHandSword::1:0:", -- Combatant Claymore
	[2878]="0:2:3:1:OneHandAxe::1:0:", -- Bearded Boneaxe
	[2879]="0:4:3:1:OffHandFrill::1:0:", -- Antipodean Rod
	[2880]="100:7:1:20:Other:164,202:1:0:66,372,777,790,843,960,989,1148,1250,1286,1448,1456,1465,1690,1692,1694,2118,2225,2381,2393,2682,2683,2684,2685,2687,2688,2810,2821,2844,2847,2999,3002,3081,3133,3167,3168,3187,3343,3356,3358,3367,3392,3413,3477,3482,3495,3499,3556,3578,3614,3779,3954,3955,4194,4229,4256,4257,4259,4453,4561,4587,4597,4599,4775,4877,4897,5100,5135,5163,5175,5411,5512,5514,5519,5817,6298,6300,6301,6730,6777,7947,8145,8161,8176,8363,8678,8679,8934,9179,9544,9636,9676,11185,11186,11189,12022,12028,12043,12245,12941,12957,12958,14337,14624,14637,14737,15176,15179,15400,16224,16261,16262,16376,16583,16613,16657,16664,16670,16713,16751,16768,16782,16823,17222,17245,17421,17486,17490,17655,18009,18278,18426,18427,18484,18752,18775,19011,19012,19056,19244,19342,19372,19383,19450,19520,19530,19662,19879,20082,20463,20890,20981,22264,22476,23144,23724,23908,24052,24843,24935,24995,25010,25019,25051,25082,26081,26599,26600,26898,26934,27019,27021,27026,27043,27045,27057,27062,27134,27267,27711,28344,28692,28716,28722,28728,28796,28797,28831,28872,29252,29253,29288,29688,29907,29923,29964,29969,30241,30253,30311,30336,30345,30434,30436,30825,31024,31776,31781,32594,33594,33599,33631,33634,33640,33669,33675,33677,33682,37904,37935", -- Weak Flux
	[2881]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Runed Copper Breastplate
	[2882]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Silvered Bronze Shoulders
	[2883]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Deadly Bronze Poniard
	[2885]="0:12:1:1:::1:0:", -- Scarlet Crusade Documents
	[2886]="0:7:1:20:Meat:185:1:0:", -- Crag Boar Rib
	[2888]="0:0:1:20:FoodDrink::1:0:", -- Beer Basted Boar Ribs
	[2889]="240:9:1:1:Cooking::1:0:340", -- Recipe: Beer Basted Boar Ribs
	[2892]="100:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Deadly Poison
	[2893]="150:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Deadly Poison II
	[2894]="50:0:1:10:FoodDrink::1:0:1247,1682,7744", -- Rhapsody Malt
	[2898]="0:4:1:1:Mail::1:0:", -- Mountaineer Chestpiece
	[2899]="0:4:2:1:Leather::1:0:", -- Wendigo Collar
	[2900]="0:4:1:1:Shield::1:0:", -- Stone Buckler
	[2901]="81:2:1:1:Miscellaneous:202:1:0:66,372,777,790,843,960,989,1148,1250,1286,1448,1456,1465,1690,1692,1694,2118,2225,2381,2393,2682,2683,2684,2685,2687,2688,2810,2821,2844,2847,2999,3002,3081,3133,3167,3168,3187,3343,3356,3358,3367,3392,3413,3477,3482,3495,3499,3556,3578,3614,3779,3954,3955,4194,4229,4256,4257,4259,4453,4561,4587,4597,4599,4775,4877,4897,5100,5135,5163,5175,5411,5512,5514,5519,5817,6298,6300,6301,6730,6777,7947,8145,8161,8176,8363,8678,8679,8934,9179,9544,9636,9676,11185,11186,11189,12022,12028,12043,12245,12941,12957,12958,14337,14624,14637,14737,15176,15179,15400,16224,16261,16262,16376,16583,16613,16657,16664,16670,16713,16751,16768,16782,16823,17222,17245,17421,17486,17490,17655,18009,18278,18426,18427,18484,18752,18775,19011,19012,19056,19244,19342,19372,19383,19450,19520,19530,19575,19661,19662,19879,20082,20463,20890,20981,21112,22264,22476,23144,23724,23908,24052,24843,24935,24995,25010,25019,25051,25082,26081,26599,26600,26898,26934,27019,27021,27026,27043,27045,27057,27062,27134,27267,27711,28344,28692,28716,28722,28728,28796,28797,28831,28872,29252,29253,29288,29688,29907,29923,29964,29969,30241,30253,30311,30336,30345,30434,30436,30825,31024,31776,31781,32594,33594,33599,33631,33634,33640,33669,33675,33677,33682,37904,37935", -- Mining Pick
	[2902]="0:4:2:1:Cloak::1:0:", -- Cloak of the Faith
	[2903]="0:2:2:1:Bow::1:0:", -- Daryl's Hunting Bow
	[2904]="0:2:2:1:Gun::1:0:", -- Daryl's Hunting Rifle
	[2905]="0:4:1:1:Cloak::1:0:", -- Goat Fur Cloak
	[2906]="0:4:2:1:Mail::1:0:", -- Darkshire Mail Leggings
	[2907]="0:2:2:1:TwoHandAxe::1:0:", -- Dwarven Tree Chopper
	[2908]="0:2:2:1:Dagger::1:0:", -- Thornblade
	[2909]="0:12:1:20:::1:0:", -- Red Wool Bandana
	[2910]="0:4:2:1:Mail::1:0:", -- Gold Militia Boots
	[2911]="0:4:3:1:Cloth::1:0:", -- Keller's Girdle
	[2912]="0:2:3:1:Dagger::1:0:", -- Claw of the Shadowmancer
	[2913]="0:4:2:1:Cloth::1:0:", -- Silk Mantle of Gamn
	[2915]="0:2:4:1:TwoHandMace::1:0:", -- Taran Icebreaker
	[2916]="0:4:2:1:Shield::1:0:", -- Gold Lion Shield
	[2917]="0:4:2:1:Ring::1:0:", -- Tranquil Ring
	[2924]="0:7:1:20:Meat:185:1:0:", -- Crocolisk Meat
	[2925]="0:12:1:20:::1:0:", -- Crocolisk Skin
	[2926]="0:12:1:1:::1:0:", -- Head of Bazil Thredd
	[2928]="0:15:0:20:Junk::1:0:", -- Dust of Decay
	[2930]="0:15:0:20:Junk::1:0:", -- Essence of Pain
	[2931]="0:15:0:20:Junk::1:0:", -- Maiden's Anguish
	[2933]="0:4:3:1:Ring::1:0:", -- Seal of Wrynn
	[2934]="0:7:1:20:Leather:165:1:0:", -- Ruined Leather Scraps
	[2939]="0:12:1:1:::1:0:", -- Crocolisk Tear
	[2940]="0:15:0:5:Junk::1:0:", -- Bloody Bear Paw
	[2941]="0:2:3:1:Dagger::1:0:", -- Prison Shank
	[2942]="0:2:3:1:FistWeapon::1:0:", -- Iron Knuckles
	[2943]="0:4:2:1:OffHandFrill::1:0:", -- Eye of Paleth
	[2944]="0:4:2:1:OffHandFrill::1:0:", -- Cursed Eye of Paleth
	[2946]="0:15:1:200:Junk::1:0:", -- Broken Balanced Throwing Dagger
	[2947]="0:15:1:200:Junk::1:0:", -- Broken Small Throwing Knife
	[2949]="0:4:2:1:Leather::1:0:", -- Mariner Boots
	[2950]="0:2:2:1:Stave::1:0:", -- Icicle Rod
	[2951]="0:4:3:1:Ring::1:0:", -- Ring of the Underwood
	[2953]="0:4:2:1:Cloak::1:0:", -- Watch Master's Cloak
	[2954]="0:4:2:1:Cloth::1:0:", -- Night Watch Pantaloons
	[2955]="0:4:2:1:Cloth::1:0:", -- First Mate Hat
	[2956]="0:12:1:1:::1:0:", -- Report on the Defias Brotherhood
	[2957]="0:4:2:1:Cloth::1:0:", -- Journeyman's Vest
	[2958]="0:4:2:1:Cloth::1:0:", -- Journeyman's Pants
	[2959]="0:4:1:1:Cloth::1:0:", -- Journeyman's Boots
	[2960]="0:4:1:1:Cloth::1:0:", -- Journeyman's Gloves
	[2961]="0:4:2:1:Leather::1:0:", -- Burnt Leather Vest
	[2962]="0:4:2:1:Leather::1:0:", -- Burnt Leather Breeches
	[2963]="0:4:1:1:Leather::1:0:", -- Burnt Leather Boots
	[2964]="0:4:1:1:Leather::1:0:", -- Burnt Leather Gloves
	[2965]="0:4:2:1:Mail::1:0:", -- Warrior's Tunic
	[2966]="0:4:2:1:Mail::1:0:", -- Warrior's Pants
	[2967]="0:4:1:1:Mail::1:0:", -- Warrior's Boots
	[2968]="0:4:1:1:Mail::1:0:", -- Warrior's Gloves
	[2969]="0:4:2:1:Cloth::1:0:", -- Spellbinder Vest
	[2970]="0:4:2:1:Cloth::1:0:", -- Spellbinder Pants
	[2971]="0:4:1:1:Cloth::1:0:", -- Spellbinder Boots
	[2972]="0:4:1:1:Cloth::1:0:", -- Spellbinder Gloves
	[2973]="0:4:2:1:Leather::1:0:", -- Hunting Tunic
	[2974]="0:4:2:1:Leather::1:0:", -- Hunting Pants
	[2975]="0:4:1:1:Leather::1:0:", -- Hunting Boots
	[2976]="0:4:2:1:Leather::1:0:", -- Hunting Gloves
	[2977]="0:4:2:1:Mail::1:0:", -- Veteran Armor
	[2978]="0:4:2:1:Mail::1:0:", -- Veteran Leggings
	[2979]="0:4:1:1:Mail::1:0:", -- Veteran Boots
	[2980]="0:4:2:1:Mail::1:0:", -- Veteran Gloves
	[2981]="0:4:2:1:Cloth::1:0:", -- Seer's Robe
	[2982]="0:4:2:1:Cloth::1:0:", -- Seer's Pants
	[2983]="0:4:2:1:Cloth::1:0:", -- Seer's Boots
	[2984]="0:4:2:1:Cloth::1:0:", -- Seer's Gloves
	[2985]="0:4:2:1:Leather::1:0:", -- Inscribed Leather Breastplate
	[2986]="0:4:2:1:Leather::1:0:", -- Inscribed Leather Pants
	[2987]="0:4:2:1:Leather::1:0:", -- Inscribed Leather Boots
	[2988]="0:4:2:1:Leather::1:0:", -- Inscribed Leather Gloves
	[2989]="0:4:2:1:Mail::1:0:", -- Burnished Tunic
	[2990]="0:4:2:1:Mail::1:0:", -- Burnished Leggings
	[2991]="0:4:2:1:Mail::1:0:", -- Burnished Boots
	[2992]="0:4:2:1:Mail::1:0:", -- Burnished Gloves
	[2996]="160:7:1:20:Cloth:197:1:1:16631", -- Bolt of Linen Cloth
	[2997]="400:7:1:20:Cloth:165,197:1:1:16631", -- Bolt of Woolen Cloth
	[2998]="0:12:1:1:::1:0:", -- A Simple Compass
	[2999]="0:12:1:1:::1:0:", -- Steelgrill's Tools
	[3000]="0:4:2:1:Leather::1:0:", -- Brood Mother Carapace
	[3008]="0:4:1:1:Cloak::1:0:", -- Wendigo Fur Cloak
	[3010]="0:15:0:5:Junk::1:0:", -- Fine Sand
	[3011]="0:4:2:1:Leather::1:0:", -- Feathered Headdress
	[3012]="200:0:1:20:Scroll::1:1:958,1316,2805,4581,4878,13476,14847,16224", -- Scroll of Agility
	[3013]="100:0:1:20:Scroll::1:1:958,1316,4581,14847,16224", -- Scroll of Protection
	[3014]="0:12:1:20:::1:0:", -- Battleworn Axe
	[3016]="0:12:1:1:::1:0:", -- Gunther's Spellbook
	[3017]="0:12:1:1:::1:0:", -- Sevren's Orders
	[3018]="0:4:2:1:Cloak::1:0:", -- Hide of Lupos
	[3019]="0:4:2:1:Cloth::1:0:", -- Noble's Robe
	[3020]="0:4:3:1:Leather::1:0:", -- Enduring Cap
	[3021]="0:2:3:1:Bow::1:0:", -- Ranger Bow
	[3022]="0:4:2:1:Leather::1:0:", -- Bluegill Breeches
	[3023]="3772:2:1:1:Gun::1:0:1297,1461,1686,3018,3053,3088,3322,4603,4889,5123,8131,9548,9551,11184,16274,16620,16735", -- Large Bore Blunderbuss
	[3024]="7098:2:1:1:Gun::1:0:1297,1461,3018,3053,3322,4603,4889,5123,8131,9548,9551,11184,16620,16735", -- BKP 2700 "Enforcer"
	[3025]="18479:2:1:1:Gun::1:0:3322,8131,9548,11184,19836,22491,29945", -- BKP 42 "Ultra"
	[3026]="3812:2:1:1:Bow::1:0:228,1297,1298,1459,1668,1687,2839,3015,3409,3410,3488,3951,4173,4203,4604,4892,5122,9548,9549,9551,9552,9553,9555,12029,14301,16263,16274,16619,16715,17667,19020,19561,27055", -- Reinforced Bow
	[3027]="6349:2:1:1:Bow::1:0:228,1297,1298,2839,3015,3410,4173,4604,4892,5122,9548,9551,9552,9555,12029,14301,16263,16274,16619,16715,17667,19020,19561,27055", -- Heavy Recurve Bow
	[3030]="300:6:1:1000:Arrow::200:0:227,228,734,789,1149,1285,1287,1297,1298,1448,1452,1462,2084,2401,2803,2806,2808,2820,2839,2908,3015,3313,3350,3410,3541,3625,3962,4170,4173,4241,4555,4602,4604,4876,4892,4896,5101,5122,5134,6028,7942,7976,8139,8362,9548,9551,9552,9555,11038,11555,12021,12027,12029,12246,12959,12960,14301,14624,15174,15397,16191,16263,16274,16619,16715,16732,16919,17489,17598,17667,19020,19561,27055", -- Razor Arrow
	[3033]="300:6:1:1000:Bullet::200:0:227,734,1149,1285,1297,1448,1452,1461,1686,2084,2401,2685,2803,2806,2808,2820,2908,3018,3053,3088,3313,3322,3350,3541,3625,3962,4170,4241,4555,4603,4876,4889,4896,5101,5123,5134,6028,7942,8131,8139,8362,9548,9551,11038,11184,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16274,16620,16732,16735,17489", -- Solid Shot
	[3035]="0:12:1:1:::1:0:", -- Laced Pumpkin
	[3036]="0:2:2:1:Bow::1:0:", -- Heavy Shortbow
	[3037]="0:2:2:1:Bow::1:0:", -- Whipwood Recurve Bow
	[3039]="0:2:2:1:Bow::1:0:", -- Short Ash Bow
	[3040]="0:2:2:1:Gun::1:0:", -- Hunter's Muzzle Loader
	[3041]="0:2:2:1:Gun::1:0:", -- "Mage-Eye" Blunderbuss
	[3042]="0:2:2:1:Gun::1:0:", -- BKP "Sparrow" Smallbore
	[3045]="0:4:2:1:Mail::1:0:", -- Lambent Scale Boots
	[3047]="0:4:2:1:Mail::1:0:", -- Lambent Scale Gloves
	[3048]="0:4:2:1:Mail::1:0:", -- Lambent Scale Legguards
	[3049]="0:4:2:1:Mail::1:0:", -- Lambent Scale Breastplate
	[3053]="0:4:2:1:Mail::1:0:", -- Humbert's Chestpiece
	[3055]="0:4:2:1:Leather::1:0:", -- Forest Leather Chestpiece
	[3056]="0:4:2:1:Leather::1:0:", -- Forest Leather Pants
	[3057]="0:4:2:1:Leather::1:0:", -- Forest Leather Boots
	[3058]="0:4:2:1:Leather::1:0:", -- Forest Leather Gloves
	[3065]="0:4:2:1:Cloth::1:0:", -- Bright Boots
	[3066]="0:4:2:1:Cloth::1:0:", -- Bright Gloves
	[3067]="0:4:2:1:Cloth::1:0:", -- Bright Pants
	[3069]="0:4:2:1:Cloth::1:0:", -- Bright Robe
	[3070]="0:4:1:1:Cloak::1:0:", -- Ensign Cloak
	[3071]="0:2:1:1:OneHandAxe::1:0:", -- Striking Hatchet
	[3072]="0:4:2:1:Cloth::1:0:", -- Smoldering Robe
	[3073]="0:4:2:1:Cloth::1:0:", -- Smoldering Pants
	[3074]="0:4:2:1:Cloth::1:0:", -- Smoldering Gloves
	[3075]="0:4:4:1:Cloth::1:0:", -- Eye of Flame
	[3076]="0:4:2:1:Cloth::1:0:", -- Smoldering Boots
	[3078]="0:2:3:1:Bow::1:0:", -- Naga Heartpiercer
	[3079]="0:2:2:1:Gun::1:0:", -- Skorn's Rifle
	[3080]="0:12:1:1:::1:0:", -- Candle of Beckoning
	[3081]="0:12:1:1:::1:0:", -- Nether Gem
	[3082]="0:12:1:1:::1:0:", -- Dargol's Skull
	[3083]="0:12:1:20:::1:0:", -- Restabilization Cog
	[3084]="0:12:1:20:::1:0:", -- Gyromechanic Gear
	[3085]="0:12:1:1:::1:0:", -- Barrel of Shimmer Stout
	[3086]="0:12:1:1:::1:0:", -- Cask of Shimmer Stout
	[3087]="0:0:1:20:Potion::1:0:", -- Mug of Shimmer Stout
	[3103]="0:2:2:1:TwoHandMace::1:0:", -- Coldridge Hammer
	[3107]="0:15:1:200:Junk::1:0:", -- Broken Keen Throwing Knife
	[3108]="0:15:1:200:Junk::1:0:", -- Broken Heavy Throwing Dagger
	[3110]="0:12:1:20:::1:0:", -- Tunnel Rat Ear
	[3111]="0:15:1:200:Junk::1:0:", -- Broken Crude Throwing Axe
	[3117]="0:12:1:1:::1:0:", -- Hildelve's Journal
	[3131]="0:15:1:200:Junk::1:0:", -- Broken Weighted Throwing Axe
	[3135]="0:15:1:200:Junk::1:0:", -- Broken Sharp Throwing Axe
	[3137]="0:15:1:200:Junk::1:0:", -- Broken Deadly Throwing Axe
	[3151]="0:4:1:1:Mail::1:0:", -- Siege Brigade Vest
	[3152]="0:4:1:1:Leather::1:0:", -- Driving Gloves
	[3153]="0:4:1:1:Cloak::1:0:", -- Oil-stained Cloak
	[3154]="0:2:2:1:OneHandAxe::1:0:", -- Thelsamar Axe
	[3155]="0:12:1:1:::1:0:", -- Remedy of Arugal
	[3156]="0:12:1:20:::1:0:", -- Glutton Shackle
	[3157]="0:12:1:20:::1:0:", -- Darksoul Shackle
	[3158]="0:4:1:1:Leather::1:0:", -- Burnt Hide Bracers
	[3160]="0:4:2:1:Shield::1:0:", -- Ironplate Buckler
	[3161]="0:4:2:1:Cloth::1:0:", -- Robe of the Keeper
	[3162]="0:12:1:20:::1:0:", -- Notched Rib
	[3163]="0:12:1:20:::1:0:", -- Blackened Skull
	[3164]="0:7:1:10:Other:171:1:0:", -- Discolored Worg Heart
	[3165]="0:12:1:1:::1:0:", -- Quinn's Potion
	[3166]="0:4:2:1:Mail::1:0:", -- Ironheart Chain
	[3167]="0:15:0:10:Junk::1:0:", -- Thick Spider Hair
	[3169]="0:15:0:10:Junk::1:0:", -- Chipped Bear Tooth
	[3170]="0:15:0:10:Junk::1:0:", -- Large Bear Tooth
	[3171]="0:15:0:5:Junk::1:0:", -- Broken Boar Tusk
	[3172]="0:7:1:20:Meat:185:1:0:", -- Boar Intestines
	[3173]="0:7:1:20:Meat:185:1:0:", -- Bear Meat
	[3174]="0:7:1:20:Meat:185:1:0:", -- Spider Ichor
	[3175]="0:15:0:10:Junk::1:0:", -- Ruined Dragonhide
	[3176]="0:15:0:10:Junk::1:0:", -- Small Claw
	[3177]="0:15:0:10:Junk::1:0:", -- Tiny Fang
	[3179]="0:15:0:10:Junk::1:0:", -- Cracked Dragon Molting
	[3180]="0:15:0:5:Junk::1:0:", -- Flecked Raptor Scale
	[3181]="0:15:0:5:Junk::1:0:", -- Partially Digested Meat
	[3182]="0:7:1:10:Cloth:165,197:1:0:", -- Spider's Silk
	[3183]="0:12:1:1:::1:0:", -- Mangy Claw
	[3184]="0:2:2:1:Dagger::1:0:", -- Hook Dagger
	[3185]="0:2:2:1:Stave::1:0:", -- Acrobatic Staff
	[3186]="0:2:2:1:OneHandSword::1:0:", -- Viking Sword
	[3187]="0:2:2:1:Dagger::1:0:", -- Sacrificial Kris
	[3188]="0:2:2:1:TwoHandSword::1:0:", -- Coral Claymore
	[3189]="0:2:1:1:TwoHandAxe::1:0:", -- Wood Chopper
	[3190]="0:2:1:1:TwoHandMace::1:0:", -- Beatstick
	[3191]="0:2:3:1:TwoHandAxe::1:0:", -- Arced War Axe
	[3192]="0:2:2:1:TwoHandSword::1:0:", -- Short Bastard Sword
	[3193]="0:2:2:1:TwoHandMace::1:0:", -- Oak Mallet
	[3194]="0:2:3:1:TwoHandMace::1:0:", -- Black Malice
	[3195]="0:2:2:1:TwoHandAxe::1:0:", -- Barbaric Battle Axe
	[3196]="0:2:2:1:TwoHandSword::1:0:", -- Edged Bastard Sword
	[3197]="0:2:2:1:TwoHandSword::1:0:", -- Stonecutter Claymore
	[3198]="0:2:2:1:TwoHandMace::1:0:", -- Battering Hammer
	[3199]="0:2:2:1:TwoHandAxe::1:0:", -- Battle Slayer
	[3200]="0:4:1:1:Leather::1:0:", -- Burnt Leather Bracers
	[3201]="0:2:2:1:TwoHandAxe::1:0:", -- Barbarian War Axe
	[3202]="0:4:2:1:Leather::1:0:", -- Forest Leather Bracers
	[3203]="0:2:3:1:TwoHandMace::1:0:", -- Dense Triangle Mace
	[3204]="0:4:2:1:Leather::1:0:", -- Deepwood Bracers
	[3205]="0:4:2:1:Leather::1:0:", -- Inscribed Leather Bracers
	[3206]="0:2:2:1:TwoHandSword::1:0:", -- Cavalier Two-hander
	[3207]="0:4:1:1:Leather::1:0:", -- Hunting Bracers
	[3208]="0:2:2:1:TwoHandMace::1:0:", -- Conk Hammer
	[3209]="0:2:2:1:TwoHandSword::1:0:", -- Ancient War Sword
	[3210]="0:2:2:1:TwoHandAxe::1:0:", -- Brutal War Axe
	[3211]="0:4:2:1:Mail::1:0:", -- Burnished Bracers
	[3212]="0:4:2:1:Mail::1:0:", -- Lambent Scale Bracers
	[3213]="0:4:1:1:Mail::1:0:", -- Veteran Bracers
	[3214]="0:4:1:1:Mail::1:0:", -- Warrior's Bracers
	[3216]="0:4:1:1:Cloth::1:0:", -- Warm Winter Robe
	[3217]="0:4:2:1:Cloth::1:0:", -- Foreman Belt
	[3218]="0:12:1:20:::1:0:", -- Pyrewood Shackle
	[3220]="0:0:1:20:FoodDrink::1:0:", -- Blood Sausage
	[3223]="0:2:2:1:OneHandMace::1:0:", -- Frostmane Scepter
	[3224]="0:4:1:1:Cloth::1:0:", -- Silver-lined Bracers
	[3225]="0:2:1:1:Dagger::1:0:", -- Bloodstained Knife
	[3227]="0:2:2:1:Stave::1:0:", -- Nightbane Staff
	[3228]="0:4:3:1:Mail::1:0:", -- Jimmied Handcuffs
	[3229]="0:4:2:1:Cloth::1:0:", -- Tarantula Silk Sash
	[3230]="0:4:3:1:Leather::1:0:", -- Black Wolf Bracers
	[3231]="0:4:2:1:Mail::1:0:", -- Cutthroat Pauldrons
	[3233]="0:1:1:1:Bag::1:0:", -- Gnoll Hide Sack
	[3234]="0:12:1:1:::1:0:", -- Deliah's Ring
	[3235]="0:4:2:1:Ring::1:0:", -- Ring of Scorn
	[3236]="0:12:1:20:::1:0:", -- Rot Hide Ichor
	[3237]="0:12:1:1:::1:0:", -- Sample Ichor
	[3238]="0:12:1:1:::1:0:", -- Johaan's Findings
	[3239]="0:0:1:20:EnhTemp::1:0:", -- Rough Weightstone
	[3240]="0:0:1:20:EnhTemp::1:0:", -- Coarse Weightstone
	[3241]="0:0:1:20:EnhTemp::1:0:", -- Heavy Weightstone
	[3248]="0:12:1:1:::1:0:", -- Translated Letter from The Embalmer
	[3250]="0:12:1:1:::1:0:", -- Bethor's Scroll
	[3251]="0:12:1:1:::1:0:", -- Bethor's Potion
	[3252]="0:12:1:1:::1:0:", -- Deathstalker Report
	[3253]="0:12:1:20:::1:0:", -- Grizzled Bear Heart
	[3254]="0:12:1:20:::1:0:", -- Skittering Blood
	[3255]="0:12:1:1:::1:0:", -- Berard's Journal
	[3256]="0:12:1:20:::1:0:", -- Lake Skulker Moss
	[3257]="0:12:1:20:::1:0:", -- Lake Creeper Moss
	[3258]="0:12:1:1:::1:0:", -- Hardened Tumor
	[3260]="0:4:1:1:Cloth::1:0:", -- Scarlet Initiate Robes
	[3261]="0:4:1:1:Cloak::1:0:", -- Webbed Cloak
	[3262]="0:2:1:1:OneHandMace::1:0:", -- Putrid Wooden Hammer
	[3263]="0:4:1:1:Cloth::1:0:", -- Webbed Pants
	[3264]="0:12:1:20:::1:0:", -- Duskbat Wing
	[3265]="0:12:1:20:::1:0:", -- Scavenger Paw
	[3266]="0:12:1:20:::1:0:", -- Scarlet Armband
	[3267]="0:2:1:1:OneHandSword::1:0:", -- Forsaken Shortsword
	[3268]="0:2:1:1:Dagger::1:0:", -- Forsaken Dagger
	[3269]="0:2:1:1:OneHandMace::1:0:", -- Forsaken Maul
	[3270]="0:4:1:1:Cloth::1:0:", -- Flax Vest
	[3272]="0:4:1:1:Leather::1:0:", -- Zombie Skin Leggings
	[3273]="0:4:1:1:Mail::1:0:", -- Rugged Mail Vest
	[3274]="0:4:1:1:Cloth::1:0:", -- Flax Boots
	[3275]="0:4:1:1:Cloth::1:0:", -- Flax Gloves
	[3276]="0:4:1:1:Shield::1:0:", -- Deathguard Buckler
	[3277]="0:2:1:1:Stave::1:0:", -- Executor Staff
	[3279]="0:4:1:1:Mail::1:0:", -- Battle Chain Boots
	[3280]="0:4:1:1:Mail::1:0:", -- Battle Chain Bracers
	[3281]="0:4:1:1:Mail::1:0:", -- Battle Chain Gloves
	[3282]="0:4:2:1:Mail::1:0:", -- Battle Chain Pants
	[3283]="0:4:2:1:Mail::1:0:", -- Battle Chain Tunic
	[3284]="0:4:1:1:Leather::1:0:", -- Tribal Boots
	[3285]="0:4:1:1:Leather::1:0:", -- Tribal Bracers
	[3286]="0:4:1:1:Leather::1:0:", -- Tribal Gloves
	[3287]="0:4:2:1:Leather::1:0:", -- Tribal Pants
	[3288]="0:4:2:1:Leather::1:0:", -- Tribal Vest
	[3289]="0:4:1:1:Cloth::1:0:", -- Ancestral Boots
	[3290]="0:4:1:1:Cloth::1:0:", -- Ancestral Gloves
	[3291]="0:4:2:1:Cloth::1:0:", -- Ancestral Woollies
	[3292]="0:4:2:1:Cloth::1:0:", -- Ancestral Tunic
	[3293]="0:2:1:1:OneHandAxe::1:0:", -- Deadman Cleaver
	[3294]="0:2:1:1:OneHandMace::1:0:", -- Deadman Club
	[3295]="0:2:1:1:OneHandSword::1:0:", -- Deadman Blade
	[3296]="0:2:1:1:Dagger::1:0:", -- Deadman Dagger
	[3297]="0:12:1:20:::1:0:", -- Fel Moss
	[3299]="0:15:0:10:Junk::1:0:", -- Fractured Canine
	[3300]="0:15:0:5:Junk::1:0:", -- Rabbit's Foot
	[3301]="0:15:0:10:Junk::1:0:", -- Sharp Canine
	[3302]="0:4:2:1:Mail::1:0:", -- Brackwater Boots
	[3303]="0:4:1:1:Mail::1:0:", -- Brackwater Bracers
	[3304]="0:4:1:1:Mail::1:0:", -- Brackwater Gauntlets
	[3305]="0:4:2:1:Mail::1:0:", -- Brackwater Leggings
	[3306]="0:4:2:1:Mail::1:0:", -- Brackwater Vest
	[3307]="0:4:2:1:Cloth::1:0:", -- Barbaric Cloth Boots
	[3308]="0:4:2:1:Cloth::1:0:", -- Barbaric Cloth Gloves
	[3309]="0:4:2:1:Cloth::1:0:", -- Barbaric Loincloth
	[3310]="0:4:2:1:Cloth::1:0:", -- Barbaric Cloth Vest
	[3311]="0:4:1:1:Leather::1:0:", -- Ceremonial Leather Ankleguards
	[3312]="0:4:1:1:Leather::1:0:", -- Ceremonial Leather Bracers
	[3313]="0:4:2:1:Leather::1:0:", -- Ceremonial Leather Harness
	[3314]="0:4:2:1:Leather::1:0:", -- Ceremonial Leather Gloves
	[3315]="0:4:2:1:Leather::1:0:", -- Ceremonial Leather Loincloth
	[3317]="0:12:1:1:::1:0:", -- A Talking Head
	[3318]="0:12:1:1:::1:0:", -- Alaric's Remains
	[3319]="0:2:1:1:OneHandSword::1:0:", -- Short Sabre
	[3321]="0:4:1:1:Leather::1:0:", -- Gray Fur Booties
	[3322]="0:4:1:1:Cloak::1:0:", -- Wispy Cloak
	[3323]="0:4:1:1:Cloth::1:0:", -- Ghostly Bracers
	[3324]="0:4:2:1:Cloth::1:0:", -- Ghostly Mantle
	[3325]="0:2:1:1:TwoHandAxe::1:0:", -- Vile Fin Battle Axe
	[3327]="0:2:1:1:Stave::1:0:", -- Vile Fin Oracle Staff
	[3328]="0:4:1:1:Cloth::1:0:", -- Spider Web Robe
	[3329]="0:2:1:1:OneHandMace::1:0:", -- Spiked Wooden Plank
	[3330]="0:4:2:1:Mail::1:0:", -- Dargol's Hauberk
	[3331]="0:4:1:1:Cloak::1:0:", -- Melrache's Cape
	[3332]="0:4:1:1:Mail::1:0:", -- Perrine's Boots
	[3334]="0:2:1:1:TwoHandMace::1:0:", -- Farmer's Shovel
	[3335]="0:2:1:1:Stave::1:0:", -- Farmer's Broom
	[3336]="0:2:2:1:Dagger::1:0:", -- Flesh Piercer
	[3337]="0:12:1:20:::1:0:", -- Dragonmaw War Banner
	[3339]="0:12:1:1:::1:0:", -- Dwarven Tinder
	[3340]="0:12:1:10:::1:0:", -- Incendicite Ore
	[3341]="0:4:2:1:Mail::1:0:", -- Gauntlets of Ogre Strength
	[3342]="0:4:1:1:Shirt::1:0:", -- Captain Sanders' Shirt
	[3343]="0:1:1:1:Bag::1:0:", -- Captain Sanders' Booty Bag
	[3344]="0:4:2:1:Cloth::1:0:", -- Captain Sanders' Sash
	[3345]="0:4:2:1:Cloth::1:0:", -- Silk Wizard Hat
	[3347]="0:12:1:1:::1:0:", -- Bundle of Crocolisk Skins
	[3348]="0:12:1:20:::1:0:", -- Giant Crocolisk Skin
	[3349]="0:12:1:1:::1:0:", -- Sida's Bag
	[3352]="0:1:1:1:Bag::1:0:", -- Ooze-covered Bag
	[3353]="0:12:1:1:::1:0:", -- Rune-inscribed Pendant
	[3354]="0:12:1:20:::1:0:", -- Dalaran Pendant
	[3355]="200:7:1:20:Herb:171:1:1:844,1302,1313,4083,4878,8305,14846,16641,16705", -- Wild Steelbloom
	[3356]="120:7:1:20:Herb:171,333,165:1:1:844,1302,1313,4083,4878,8305,14846,16641,16705", -- Kingsblood
	[3357]="300:7:1:20:Herb:171:1:1:844,1302,1313,4083,4878,8305,14846,16641,16705", -- Liferoot
	[3358]="700:7:1:20:Herb:171:1:1:14846", -- Khadgar's Whisker
	[3360]="0:4:1:1:OffHandFrill::1:0:", -- Stitches' Femur
	[3363]="0:4:0:1:Cloth::1:0:", -- Frayed Belt
	[3365]="0:4:0:1:Cloth::1:0:", -- Frayed Bracers
	[3369]="0:7:1:20:Herb:171:1:0:", -- Grave Moss
	[3370]="0:4:0:1:Cloth::1:0:", -- Patchwork Belt
	[3371]="20:7:1:20:Other:171,333:5:0:66,777,843,844,958,960,983,989,1148,1250,1257,1286,1313,1453,1456,1465,1692,2118,2225,2380,2381,2393,2480,2481,2810,2812,2821,2848,3010,3014,3081,3168,3187,3348,3367,3405,3482,3499,3548,3556,3614,3779,3954,3955,3956,4194,4216,4226,4229,4561,4610,4615,4775,4877,4897,4899,5100,5135,5138,5163,5178,5503,5594,5817,6301,7947,8145,8157,8158,8177,8178,8305,8363,8934,9636,11188,11189,12022,12028,12043,12245,12941,12957,12958,15179,16224,16261,16262,16367,16612,16613,16641,16705,16706,16768,16829,17486,17490,18005,18009,18426,18427,19074,19244,19372,19450,19837,20989,24843,24935,24975,24995,25010,25019,25051,25082,26568,27021,27026,27031,27038,27043,27053,27057,27140,27141,28692,28725,28727,28828,28829,28831,28866,28868,28872,29288,29535,29909,30311,33600,33630,33639,33674,33678", -- Empty Vial
	[3372]="200:7:1:20:Other:171,333:5:0:777,844,958,960,983,989,1148,1257,1286,1313,1453,1456,2225,2380,2381,2393,2480,2481,2810,2812,2821,2848,3010,3014,3348,3367,3405,3499,3548,3556,3779,3954,3955,3956,4216,4226,4229,4561,4610,4615,4775,4877,4897,4899,5100,5135,5138,5163,5178,5503,5594,5817,6301,7947,8145,8157,8158,8177,8178,8305,8363,8934,9636,11188,11189,12022,12028,12043,12245,12941,12957,12958,15179,16367,16612,16613,16641,16705,16706,16768,16829,17486,18005,18009,19074,19244,19372,19450,19837,20989,24843,24935,24975,24995,25010,25019,25051,25082,26568,27021,27026,27031,27038,27043,27053,27057,27140,27141,28692,28725,28727,28828,28829,28831,28866,28868,28872,29288,29535,29909,30311,33600,33630,33639,33674,33678", -- Leaded Vial
	[3373]="0:4:0:1:Cloth::1:0:", -- Patchwork Bracers
	[3374]="0:4:0:1:Cloth::1:0:", -- Calico Belt
	[3375]="0:4:0:1:Cloth::1:0:", -- Calico Bracers
	[3376]="0:4:0:1:Cloth::1:0:", -- Canvas Belt
	[3377]="0:4:0:1:Cloth::1:0:", -- Canvas Bracers
	[3378]="0:4:0:1:Cloth::1:0:", -- Brocade Belt
	[3379]="0:4:0:1:Cloth::1:0:", -- Brocade Bracers
	[3380]="0:4:0:1:Cloth::1:0:", -- Cross-stitched Belt
	[3381]="0:4:0:1:Cloth::1:0:", -- Cross-stitched Bracers
	[3382]="0:0:1:20:Elixir::1:0:", -- Weak Troll's Blood Elixir
	[3383]="0:0:1:20:Elixir:165,197:1:0:", -- Elixir of Wisdom
	[3384]="0:0:1:20:Potion::1:0:", -- Minor Magic Resistance Potion
	[3385]="120:0:1:20:Potion::1:1:1307,2481,2805,3134,3956,4083,13476,14847", -- Lesser Mana Potion
	[3386]="0:0:1:20:Potion::1:0:", -- Potion of Curing
	[3387]="0:0:1:20:Potion::1:0:", -- Limited Invulnerability Potion
	[3388]="0:0:1:20:Elixir::1:0:", -- Strong Troll's Blood Elixir
	[3389]="0:0:1:20:Elixir:165:1:0:", -- Elixir of Defense
	[3390]="0:0:1:20:Elixir:165:1:0:", -- Elixir of Lesser Agility
	[3391]="0:0:1:20:Elixir:164,755:1:0:", -- Elixir of Ogre's Strength
	[3392]="0:4:2:1:Leather::1:0:", -- Ringed Helm
	[3393]="0:9:1:1:Alchemy::1:0:", -- Recipe: Minor Magic Resistance Potion
	[3394]="0:9:1:1:Alchemy::1:0:", -- Recipe: Potion of Curing
	[3395]="0:9:2:1:Alchemy::1:0:", -- Recipe: Limited Invulnerability Potion
	[3396]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Lesser Agility
	[3397]="0:12:1:20:::1:0:", -- Young Crocolisk Skin
	[3399]="0:15:0:5:Junk::1:0:", -- Vulture Talon
	[3400]="0:2:2:1:OneHandSword::1:0:", -- Lucine Longsword
	[3401]="0:15:0:5:Junk::1:0:", -- Rough Crocolisk Scale
	[3402]="0:15:0:5:Junk::1:0:", -- Soft Patch of Fur
	[3403]="0:15:0:5:Junk::1:0:", -- Ivory Boar Tusk
	[3404]="0:7:1:20:Meat:185:1:0:", -- Buzzard Wing
	[3405]="0:12:1:1:::1:0:", -- Raven Claw Talisman
	[3406]="0:12:1:1:::1:0:", -- Black Feather Quill
	[3407]="0:12:1:1:::1:0:", -- Sapphire of Sky
	[3408]="0:12:1:1:::1:0:", -- Rune of Nesting
	[3409]="0:12:1:20:::1:0:", -- Nightsaber Fang
	[3411]="0:12:1:20:::1:0:", -- Strigid Owl Feather
	[3412]="0:12:1:20:::1:0:", -- Webwood Spider Silk
	[3413]="0:2:3:1:Dagger::1:0:", -- Doomspike
	[3414]="0:2:3:1:OneHandMace::1:0:", -- Crested Scepter
	[3415]="0:2:3:1:Stave::1:0:", -- Staff of the Friar
	[3416]="0:4:3:1:Mail::1:0:", -- Martyr's Chain
	[3417]="0:2:3:1:TwoHandSword::1:0:", -- Onyx Claymore
	[3418]="0:12:1:20:::1:0:", -- Fel Cone
	[3419]="500:4:1:1:OffHandFrill::1:0:1302,1303,3014,23731,28993,31021,37936", -- Red Rose
	[3420]="5000:4:1:1:OffHandFrill::1:0:1302,1303,3014,23731,28993,31021,37936", -- Black Rose
	[3421]="200:4:1:1:OffHandFrill::1:0:1302,1303,3014,23731,28993,31021,37936", -- Simple Wildflowers
	[3422]="2000:4:1:1:OffHandFrill::1:0:1302,1303,3014,23731,28993,31021,37936", -- Beautiful Wildflowers
	[3423]="20000:4:1:1:OffHandFrill::1:0:1302,1303,3014,23731,28993,31021,37936", -- Bouquet of White Roses
	[3424]="500000:4:1:1:OffHandFrill::1:0:1302,1303,3014,23731,28993,31021,37936", -- Bouquet of Black Roses
	[3425]="0:12:1:1:::1:0:", -- Woven Wand
	[3426]="4000:4:1:1:Shirt::1:0:1299", -- Bold Yellow Shirt
	[3427]="6000:4:1:1:Shirt::1:0:1299", -- Stylish Black Shirt
	[3428]="400:4:1:1:Shirt::1:0:1214,1291,1299,3317,3486,3554,3683,4185,4558,5108,8358,16623,16631,16716", -- Common Gray Shirt
	[3429]="0:4:2:1:Leather::1:0:", -- Guardsman Belt
	[3430]="0:2:2:1:Gun::1:0:", -- Sniper Rifle
	[3431]="0:4:2:1:Leather::1:0:", -- Bone-studded Leather
	[3434]="0:0:1:10:Consumable::1:0:", -- Slumber Sand
	[3435]="0:4:1:1:Leather::1:0:", -- Zombie Skin Bracers
	[3437]="0:4:1:1:Mail::1:0:", -- Clasped Belt
	[3439]="0:4:1:1:Leather::1:0:", -- Zombie Skin Boots
	[3440]="0:2:2:1:TwoHandMace::1:0:", -- Bonecracker
	[3442]="0:4:1:1:Cloth::1:0:", -- Apprentice Sash
	[3443]="0:2:1:1:OneHandAxe::1:0:", -- Ceremonial Tomahawk
	[3444]="0:4:1:1:Leather::1:0:", -- Tiller's Vest
	[3445]="0:2:1:1:Dagger::1:0:", -- Ceremonial Knife
	[3446]="0:2:2:1:Stave::1:0:", -- Darkwood Staff
	[3447]="0:4:1:1:Mail::1:0:", -- Cryptwalker Boots
	[3448]="0:0:1:20:FoodDrink::1:0:", -- Senggin Root
	[3449]="0:4:2:1:Cloak::1:0:", -- Mystic Shawl
	[3450]="0:4:2:1:Shield::1:0:", -- Faerleia's Shield
	[3451]="0:4:2:1:OffHandFrill::1:0:", -- Nightglow Concoction
	[3452]="0:2:2:1:Stave::1:0:", -- Ceranium Rod
	[3453]="0:4:1:1:Cloth::1:0:", -- Quilted Bracers
	[3454]="0:4:1:1:Cloth::1:0:", -- Reconnaissance Boots
	[3455]="0:2:1:1:OneHandSword::1:0:", -- Deathstalker Shortsword
	[3456]="0:15:3:1:CombatPet::1:0:", -- Dog Whistle
	[3457]="0:4:2:1:Cloth::1:0:", -- Stamped Trousers
	[3458]="0:4:2:1:Mail::1:0:", -- Rugged Mail Gloves
	[3460]="0:12:1:1:::1:0:", -- Johaan's Special Drink
	[3461]="0:4:2:1:Cloth::1:0:", -- High Robe of the Adjudicator
	[3462]="0:2:2:1:OneHandSword::1:0:", -- Talonstrike
	[3463]="0:15:2:200:Junk::1:0:", -- Broken Silver Star
	[3464]="0:6:2:1000:Arrow::1:0:", -- Feathered Arrow
	[3465]="0:6:2:1000:Bullet::1:0:", -- Exploding Shot
	[3466]="2000:7:1:20:Other:164:1:0:372,790,960,989,1148,1286,1448,1456,1690,1694,2225,2381,2393,2682,2683,2684,2685,2687,2688,2810,2821,2844,2847,2999,3002,3133,3167,3343,3356,3358,3367,3392,3413,3477,3495,3578,3779,3954,3955,4229,4256,4257,4259,4453,4561,4587,4597,4599,4775,4877,4897,5100,5135,5163,5175,5411,5512,5514,5519,5817,6298,6300,6301,6730,6777,7947,8145,8161,8176,8363,8678,8679,8934,9179,9544,9636,9676,11185,11186,11189,12022,12028,12245,12941,12957,12958,14337,14624,14637,14737,15176,15179,15400,16376,16583,16613,16657,16664,16670,16713,16751,16768,16782,16823,17222,17245,17421,17486,17655,18009,18278,18484,18752,18775,19011,19012,19056,19244,19342,19372,19383,19450,19520,19530,19662,19879,20082,20463,20890,20981,22264,22476,23144,23724,23908,24052,24843,24935,24995,25010,25019,25051,25082,26081,26599,26600,26898,26934,27019,27021,27026,27043,27045,27057,27062,27134,27267,27711,28344,28692,28716,28722,28728,28796,28797,28831,28872,29252,29253,29288,29688,29907,29923,29964,29969,30241,30253,30311,30336,30345,30434,30436,30825,31024,31776,31781,32594,33594,33599,33631,33634,33640,33669,33675,33677,33682,37904,37935", -- Strong Flux
	[3467]="0:13:1:1:::1:0:", -- Dull Iron Key
	[3468]="0:12:1:1:::1:0:", -- Renferrel's Findings
	[3469]="0:4:1:1:Mail::1:0:", -- Copper Chain Boots
	[3470]="0:7:1:20:MetalStone:164:1:0:", -- Rough Grinding Stone
	[3471]="0:4:2:1:Mail::1:0:", -- Copper Chain Vest
	[3472]="0:4:2:1:Mail::1:0:", -- Runed Copper Gauntlets
	[3473]="0:4:2:1:Mail::1:0:", -- Runed Copper Pants
	[3474]="0:4:2:1:Mail::1:0:", -- Gemmed Copper Gauntlets
	[3475]="0:4:4:1:Cloak::1:0:", -- Cloak of Flames
	[3476]="0:12:1:20:::1:0:", -- Gray Bear Tongue
	[3477]="0:12:1:1:::1:0:", -- Creeper Ichor
	[3478]="0:7:1:20:MetalStone:164:1:0:", -- Coarse Grinding Stone
	[3480]="0:4:2:1:Mail::1:0:", -- Rough Bronze Shoulders
	[3481]="0:4:2:1:Mail::1:0:", -- Silvered Bronze Shoulders
	[3482]="0:4:2:1:Mail::1:0:", -- Silvered Bronze Boots
	[3483]="0:4:2:1:Mail::1:0:", -- Silvered Bronze Gauntlets
	[3484]="0:4:2:1:Mail::1:0:", -- Green Iron Boots
	[3485]="0:4:2:1:Mail::1:0:", -- Green Iron Gauntlets
	[3486]="0:7:1:20:MetalStone:164:1:0:", -- Heavy Grinding Stone
	[3487]="0:2:2:1:TwoHandSword::1:0:", -- Heavy Copper Broadsword
	[3488]="0:2:2:1:TwoHandAxe::1:0:", -- Copper Battle Axe
	[3489]="0:2:2:1:OneHandAxe::1:0:", -- Thick War Axe
	[3490]="0:2:2:1:Dagger::1:0:", -- Deadly Bronze Poniard
	[3491]="0:2:2:1:OneHandMace::1:0:", -- Heavy Bronze Mace
	[3492]="0:2:2:1:OneHandMace::1:0:", -- Mighty Iron Hammer
	[3493]="0:2:2:1:Bow::1:0:", -- Raptor's End
	[3495]="0:12:1:1:::1:0:", -- Elixir of Suffering
	[3496]="0:12:1:20:::1:0:", -- Mountain Lion Blood
	[3497]="0:12:1:1:::1:0:", -- Elixir of Pain
	[3498]="0:12:1:1:::1:0:", -- Taretha's Necklace
	[3499]="0:13:1:1:::1:0:", -- Burnished Gold Key
	[3502]="0:12:1:20:::1:0:", -- Mudsnout Blossoms
	[3505]="0:12:1:20:::1:0:", -- Alterac Signet Ring
	[3506]="0:12:1:1:::1:0:", -- Mudsnout Composite
	[3508]="0:12:1:1:::1:0:", -- Mudsnout Mixture
	[3509]="0:12:1:20:::1:0:", -- Daggerspine Scale
	[3510]="0:12:1:20:::1:0:", -- Torn Fin Eye
	[3511]="0:4:2:1:Cloak::1:0:", -- Cloak of the People's Militia
	[3514]="0:12:1:1:::1:0:", -- Mor'Ladim's Skull
	[3515]="0:12:1:1:::1:0:", -- Ataeric's Staff
	[3516]="0:12:1:1:::1:0:", -- Lescovar's Head
	[3517]="0:12:1:1:::1:0:", -- Keg of Shindigger Stout
	[3518]="0:12:1:1:::1:0:", -- Decrypted Letter
	[3520]="0:12:1:1:::1:0:", -- Tainted Keg
	[3521]="0:12:1:1:::1:0:", -- Cleverly Encrypted Letter
	[3530]="0:0:1:20:Bandage::1:0:", -- Wool Bandage
	[3531]="0:0:1:20:Bandage::1:0:", -- Heavy Wool Bandage
	[3550]="0:12:1:1:::1:0:", -- Targ's Head
	[3551]="0:12:1:1:::1:0:", -- Muckrake's Head
	[3552]="0:12:1:1:::1:0:", -- Glommus's Head
	[3553]="0:12:1:1:::1:0:", -- Mug'thol's Head
	[3554]="0:12:1:1:::1:0:", -- Crown of Will
	[3555]="0:4:2:1:Cloth::1:0:", -- Robe of Solomon
	[3556]="0:4:2:1:Cloth::1:0:", -- Dread Mage Hat
	[3558]="0:4:2:1:Cloth::1:0:", -- Fen Keeper Robe
	[3559]="0:4:2:1:Mail::1:0:", -- Night Watch Gauntlets
	[3560]="0:4:2:1:Cloth::1:0:", -- Mantle of Honor
	[3561]="0:4:2:1:Cloak::1:0:", -- Resilient Poncho
	[3562]="0:4:2:1:Leather::1:0:", -- Belt of Vindication
	[3563]="0:4:2:1:Cloth::1:0:", -- Seafarer's Pantaloons
	[3564]="0:12:1:1:::1:0:", -- Shipment of Iron
	[3565]="0:4:2:1:Cloth::1:0:", -- Beerstained Gloves
	[3566]="0:4:2:1:Leather::1:0:", -- Raptorbane Armor
	[3567]="0:2:2:1:Gun::1:0:", -- Dwarven Fishing Pole
	[3569]="0:4:2:1:Cloth::1:0:", -- Vicar's Robe
	[3570]="0:2:2:1:OneHandMace::1:0:", -- Bonegrinding Pestle
	[3571]="0:2:2:1:TwoHandMace::1:0:", -- Trogg Beater
	[3572]="0:2:2:1:OneHandSword::1:0:", -- Daryl's Shortsword
	[3573]="0:11:1:1:Quiver::1:0:", -- Hunting Quiver
	[3574]="0:11:1:1:AmmoPouch::1:0:", -- Hunting Ammo Sack
	[3575]="0:7:1:20:MetalStone:171,164,202,755,186:1:0:", -- Iron Bar
	[3576]="0:7:1:20:MetalStone:186:1:0:", -- Tin Bar
	[3577]="0:7:2:20:MetalStone:164,202,755,197:1:0:", -- Gold Bar
	[3578]="0:4:2:1:Leather::1:0:", -- Harvester's Pants
	[3581]="0:2:2:1:Dagger::1:0:", -- Serrated Knife
	[3582]="0:4:2:1:Cloak::1:0:", -- Acidproof Cloak
	[3583]="0:4:1:1:Leather::1:0:", -- Weathered Belt
	[3585]="0:4:2:1:Leather::1:0:", -- Camouflaged Tunic
	[3586]="0:2:2:1:TwoHandAxe::1:0:", -- Logsplitter
	[3587]="14314:4:1:1:Cloth::1:0:984,1314,2849,3092,3315,3316,4175,5129,5155,5821,10293,11183,12023,26707", -- Embroidered Belt
	[3588]="14366:4:1:1:Cloth::1:0:984,1314,2849,3092,3315,3316,4175,5129,5155,5821,10293,11183,12023,26707", -- Embroidered Bracers
	[3589]="577:4:1:1:Cloth::1:0:1214,1291,3092,3317,3486,3554,3683,3952,4164,4175,4185,4558,5108,5821,8358,16623,16631,16716", -- Heavy Weave Belt
	[3590]="579:4:1:1:Cloth::1:0:1214,1291,3092,3317,3486,3554,3683,3952,4164,4175,4185,4558,5108,5821,8358,16623,16631,16716", -- Heavy Weave Bracers
	[3591]="2097:4:1:1:Cloth::1:0:1314,2849,3092,3315,3316,3952,4175,4188,5821", -- Padded Belt
	[3592]="2104:4:1:1:Cloth::1:0:1314,2849,3092,3315,3316,3952,4175,4188,5821", -- Padded Bracers
	[3593]="5478:4:1:1:Cloth::1:0:1147,1314,1407,2849,3092,3315,3316,4175,5155,5821,8159,10293", -- Russet Belt
	[3594]="5497:4:1:1:Cloth::1:0:1147,1314,1407,2849,3092,3315,3316,4175,5155,5821,8159,10293", -- Russet Bracers
	[3595]="24:4:1:1:Cloth::1:0:2113,3160,4558", -- Tattered Cloth Belt
	[3596]="24:4:1:1:Cloth::1:0:2113,3160,4558", -- Tattered Cloth Bracers
	[3597]="1081:4:1:1:Cloth::1:0:1291,2849,3092,3317,3492,3952,4175,4188,5155,5821,8358,16623,16716", -- Thick Cloth Belt
	[3598]="1085:4:1:1:Cloth::1:0:1291,2849,3092,3317,3492,3952,4175,4188,5155,5821,8358,16623,16716", -- Thick Cloth Bracers
	[3599]="24:4:1:1:Cloth::1:0:190,836,1238,3590,4175,16918", -- Thin Cloth Belt
	[3600]="24:4:1:1:Cloth::1:0:190,836,1238,3590,4175,16918", -- Thin Cloth Bracers
	[3601]="0:12:1:1:::1:0:", -- Syndicate Missive
	[3602]="145:4:1:1:Cloth::1:0:74,959,1238,1291,2264,3092,3530,3531,3611,3952,4164,4175,5821,16716,17929", -- Knitted Belt
	[3603]="146:4:1:1:Cloth::1:0:74,959,1238,1291,2264,3092,3530,3531,3611,3952,4164,4175,5821,16716,17929", -- Knitted Bracers
	[3604]="0:11:2:1:AmmoPouch::1:0:", -- Bandolier of the Night Watch
	[3605]="0:11:2:1:Quiver::1:0:", -- Quiver of the Night Watch
	[3606]="147:4:1:1:Cloth::1:0:3166,3317,3522,4558,16186,16623", -- Woven Belt
	[3607]="148:4:1:1:Cloth::1:0:3166,3317,3522,4558,16186,16623", -- Woven Bracers
	[3608]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Mighty Iron Hammer
	[3609]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Copper Chain Vest
	[3610]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Gemmed Copper Gauntlets
	[3611]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Green Iron Boots
	[3612]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Green Iron Gauntlets
	[3613]="0:12:1:1:::1:0:", -- Valdred's Hands
	[3614]="0:12:1:1:::1:0:", -- Yowler's Paw
	[3615]="0:12:1:1:::1:0:", -- Kurzen's Head
	[3616]="0:12:1:1:::1:0:", -- Mind's Eye
	[3617]="0:12:1:1:::1:0:", -- Pendant of Shadow
	[3618]="0:12:1:1:::1:0:", -- Gobbler's Head
	[3619]="0:12:1:1:::1:0:", -- Snellig's Snuffbox
	[3621]="0:12:1:1:::1:0:", -- Ivar's Head
	[3622]="0:12:1:1:::1:0:", -- Essence of Nightlash
	[3623]="0:12:1:1:::1:0:", -- Thule's Head
	[3625]="0:12:1:1:::1:0:", -- Nek'rosh's Head
	[3626]="0:12:1:1:::1:0:", -- Head of Baron Vardus
	[3627]="0:12:1:1:::1:0:", -- Fang of Vagash
	[3628]="0:12:1:1:::1:0:", -- Hand of Dextren Ward
	[3629]="0:12:1:1:::1:0:", -- Mistmantle Family Ring
	[3630]="0:12:1:1:::1:0:", -- Head of Targorr
	[3631]="0:12:1:1:::1:0:", -- Bellygrub's Tusk
	[3632]="0:12:1:1:::1:0:", -- Fangore's Paw
	[3633]="0:12:1:1:::1:0:", -- Head of Gath'Ilzogg
	[3634]="0:12:1:1:::1:0:", -- Head of Grimson
	[3635]="0:12:1:1:::1:0:", -- Maggot Eye's Paw
	[3636]="0:12:1:1:::1:0:", -- Scale of Old Murk-Eye
	[3637]="0:12:1:1:::1:0:", -- Head of VanCleef
	[3638]="0:12:1:1:::1:0:", -- Sarltooth's Talon
	[3639]="0:12:1:1:::1:0:", -- Ear of Balgaras
	[3640]="0:12:1:1:::1:0:", -- Head of Deepfury
	[3641]="0:4:1:1:Cloth::1:0:", -- Journeyman's Bracers
	[3642]="0:4:1:1:Cloth::1:0:", -- Ancestral Bracers
	[3643]="0:4:1:1:Cloth::1:0:", -- Spellbinder Bracers
	[3644]="0:4:1:1:Cloth::1:0:", -- Barbaric Cloth Bracers
	[3645]="0:4:2:1:Cloth::1:0:", -- Seer's Cuffs
	[3647]="0:4:2:1:Cloth::1:0:", -- Bright Bracers
	[3649]="0:4:1:1:Shield::1:0:", -- Tribal Buckler
	[3650]="0:4:1:1:Shield::1:0:", -- Battle Shield
	[3651]="0:4:2:1:Shield::1:0:", -- Veteran Shield
	[3652]="0:4:2:1:Shield::1:0:", -- Hunting Buckler
	[3653]="0:4:2:1:Shield::1:0:", -- Ceremonial Buckler
	[3654]="0:4:2:1:Shield::1:0:", -- Brackwater Shield
	[3655]="0:4:2:1:Shield::1:0:", -- Burnished Shield
	[3656]="0:4:2:1:Shield::1:0:", -- Lambent Scale Shield
	[3657]="0:12:1:1:::1:0:", -- Hillsbrad Town Registry
	[3658]="0:12:1:10:::1:0:", -- Recovered Tome
	[3659]="0:12:1:1:::1:0:", -- Worn Leather Book
	[3660]="0:12:1:1:::1:0:", -- Tomes of Alterac
	[3661]="0:2:1:1:Stave::1:0:", -- Handcrafted Staff
	[3662]="0:0:1:20:FoodDrink::1:0:", -- Crocolisk Steak
	[3663]="0:0:1:20:FoodDrink::1:0:", -- Murloc Fin Soup
	[3664]="0:0:1:20:FoodDrink::1:0:", -- Crocolisk Gumbo
	[3665]="0:0:1:20:FoodDrink::1:0:", -- Curiously Tasty Omelet
	[3666]="0:0:1:20:FoodDrink::1:0:", -- Gooey Spider Cake
	[3667]="0:7:1:20:Meat:185:1:0:", -- Tender Crocolisk Meat
	[3668]="0:12:1:1:::1:0:", -- Assassin's Contract
	[3669]="0:15:0:5:Junk::1:0:", -- Gelatinous Goo
	[3670]="0:15:0:5:Junk::1:0:", -- Large Slimy Bone
	[3671]="0:15:0:5:Junk::1:0:", -- Lifeless Skull
	[3672]="0:12:1:1:::1:0:", -- Head of Nagaz
	[3673]="0:15:0:100:Junk::1:0:", -- Broken Arrow
	[3674]="0:15:0:5:Junk::1:0:", -- Decomposed Boot
	[3676]="0:15:0:10:Junk::1:0:", -- Slimy Ichor
	[3678]="400:9:1:1:Cooking::1:0:340", -- Recipe: Crocolisk Steak
	[3679]="400:9:1:1:Cooking::1:0:340", -- Recipe: Blood Sausage
	[3680]="1600:9:1:1:Cooking::1:0:340", -- Recipe: Murloc Fin Soup
	[3681]="1600:9:1:1:Cooking::1:0:340", -- Recipe: Crocolisk Gumbo
	[3682]="1600:9:1:1:Cooking::1:0:340,1148,2821", -- Recipe: Curiously Tasty Omelet
	[3683]="1600:9:1:1:Cooking::1:0:340", -- Recipe: Gooey Spider Cake
	[3684]="0:12:1:1:::1:0:", -- Perenolde Tiara
	[3685]="0:7:1:20:Meat:185:1:0:", -- Raptor Egg
	[3688]="0:12:1:1:::1:0:", -- Bloodstone Oval
	[3689]="0:12:1:1:::1:0:", -- Bloodstone Marble
	[3690]="0:12:1:1:::1:0:", -- Bloodstone Shard
	[3691]="0:12:1:1:::1:0:", -- Bloodstone Wedge
	[3692]="0:12:1:30:::1:0:", -- Hillsbrad Human Skull
	[3693]="0:12:1:1:::1:0:", -- Humbert's Sword
	[3701]="0:12:1:1:::1:0:", -- Darthalia's Sealed Commendation
	[3702]="0:15:0:10:Junk::1:0:", -- Bear Gall Bladder
	[3703]="145:0:1:10:FoodDrink::1:0:2388,20377", -- Southshore Stout
	[3704]="0:13:1:1:::1:0:", -- Rusted Iron Key
	[3706]="0:12:1:1:::1:0:", -- Ensorcelled Parchment
	[3708]="0:12:1:1:::1:0:", -- Helcular's Rod
	[3710]="0:12:1:1:::1:0:", -- Rod of Helcular
	[3711]="0:15:0:1:Junk::1:0:", -- Belamoore's Research Journal
	[3712]="0:7:1:20:Meat:185:1:0:", -- Turtle Meat
	[3713]="0:7:1:20:Other::1:0:", -- Soothing Spices
	[3714]="0:12:1:20:::1:0:", -- Worn Stone Token
	[3715]="0:12:1:20:::1:0:", -- Bracers of Earth Binding
	[3716]="0:12:1:20:::1:0:", -- Murloc Head
	[3717]="0:12:1:1:::1:0:", -- Sack of Murloc Heads
	[3718]="0:12:1:1:::1:0:", -- Foreboding Plans
	[3719]="0:4:2:1:Cloak::1:0:", -- Hillman's Cloak
	[3720]="0:12:1:20:::1:0:", -- Yeti Fur
	[3721]="0:12:1:1:::1:0:", -- Farren's Report
	[3722]="0:15:0:5:Junk::1:0:", -- Familiar Hide
	[3723]="0:15:0:5:Junk::1:0:", -- Familiar Fang
	[3724]="0:15:0:5:Junk::1:0:", -- Familiar Claw
	[3725]="0:15:0:5:Junk::1:0:", -- Familiar Horn
	[3726]="0:0:1:20:FoodDrink::1:0:", -- Big Bear Steak
	[3727]="0:0:1:20:FoodDrink::1:0:", -- Hot Lion Chops
	[3728]="0:0:1:20:FoodDrink::1:0:", -- Tasty Lion Steak
	[3729]="0:0:1:20:FoodDrink::1:0:", -- Soothing Turtle Bisque
	[3730]="0:7:1:20:Meat:185:1:0:", -- Big Bear Meat
	[3731]="0:7:1:20:Meat:185:1:0:", -- Lion Meat
	[3732]="0:4:1:1:Cloth::1:0:", -- Hooded Cowl
	[3733]="0:4:2:1:Mail::1:0:", -- Orcish War Chain
	[3734]="1600:9:1:1:Cooking::1:0:3960,12246", -- Recipe: Big Bear Steak
	[3735]="1800:9:1:1:Cooking::1:0:3489,12245", -- Recipe: Hot Lion Chops
	[3736]="0:9:1:1:Cooking::1:0:", -- Recipe: Tasty Lion Steak
	[3737]="0:9:1:1:Cooking::1:0:", -- Recipe: Soothing Turtle Bisque
	[3739]="0:4:2:1:Ring::1:0:", -- Skull Ring
	[3740]="0:2:2:1:OneHandSword::1:0:", -- Decapitating Sword
	[3741]="0:4:2:1:Leather::1:0:", -- Stomping Boots
	[3742]="0:2:2:1:Bow::1:0:", -- Bow of Plunder
	[3743]="0:4:2:1:Shield::1:0:", -- Sentry Buckler
	[3745]="0:12:1:20:::1:0:", -- Rune of Opening
	[3747]="0:4:2:1:Leather::1:0:", -- Meditative Sash
	[3748]="0:4:3:1:Cloth::1:0:", -- Feline Mantle
	[3749]="0:4:2:1:Cloak::1:0:", -- High Apothecary Cloak
	[3750]="0:4:2:1:Leather::1:0:", -- Ribbed Breastplate
	[3751]="0:4:2:1:Mail::1:0:", -- Mercenary Leggings
	[3752]="0:4:2:1:Cloth::1:0:", -- Grunt Vest
	[3753]="0:4:2:1:Leather::1:0:", -- Shepherd's Girdle
	[3754]="0:4:2:1:Leather::1:0:", -- Shepherd's Gloves
	[3755]="0:2:2:1:OneHandAxe::1:0:", -- Fish Gutter
	[3758]="0:4:2:1:Mail::1:0:", -- Crusader Belt
	[3759]="0:4:2:1:Cloth::1:0:", -- Insulated Sage Gloves
	[3760]="0:4:2:1:Ring::1:0:", -- Band of the Undercity
	[3761]="0:4:2:1:Shield::1:0:", -- Deadskull Shield
	[3763]="0:4:2:1:Shield::1:0:", -- Lunar Buckler
	[3764]="0:4:2:1:Cloth::1:0:", -- Mantis Boots
	[3765]="0:4:2:1:Mail::1:0:", -- Brigand's Pauldrons
	[3766]="0:15:0:10:Junk::1:0:", -- Gryphon Feather Quill
	[3767]="0:15:0:5:Junk::1:0:", -- Fine Parchment
	[3769]="0:15:0:5:Junk::1:0:", -- Broken Wand
	[3770]="500:0:1:20:FoodDrink::5:0:982,1464,2365,2388,2814,3025,3089,3312,3368,3411,3489,3621,3705,3881,3882,3933,3935,3960,4084,4169,4782,4875,4879,4891,4894,4954,5111,5124,5611,5620,5870,6928,6929,7485,7731,7733,8125,9356,11118,11187,12196,12959,14624,14963,14964,15124,15125,15174,15397,16443,16618,16739,17553,17630,17656,19182,23263,23481,23605,24208,24343", -- Mutton Chop
	[3771]="1000:0:1:20:FoodDrink::5:0:982,1464,2365,2388,2814,3025,3089,3312,3368,3411,3489,3621,3705,3881,3882,3933,3935,3960,4084,4169,4782,4875,4879,4891,4894,4954,5111,5124,5611,5620,5870,6928,6929,7485,7731,7733,8125,9356,11118,11187,12196,12959,14624,14963,14964,15124,15125,15174,15397,16443,16618,16739,17553,17630,17656,19182,23263,23481,23605,24208,24343", -- Wild Hog Shank
	[3772]="0:0:1:20:FoodDrink::1:0:", -- Conjured Spring Water
	[3775]="70:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,23732,24148,24313,24349,24357,24780,25043,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29561,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,33630,33674,35642,37904,37935", -- Crippling Poison
	[3776]="0:15:0:20:Junk::1:0:", -- Crippling Poison II
	[3777]="0:15:0:20:Junk::1:0:", -- Lethargy Root
	[3778]="0:2:0:1:Bow::1:0:", -- Taut Compound Bow
	[3779]="0:2:0:1:TwoHandAxe::1:0:", -- Hefty War Axe
	[3780]="0:2:0:1:Gun::1:0:", -- Long-barreled Musket
	[3781]="0:2:0:1:TwoHandSword::1:0:", -- Broad Claymore
	[3782]="0:2:0:1:TwoHandMace::1:0:", -- Large War Club
	[3783]="0:2:0:1:OneHandSword::1:0:", -- Light Scimitar
	[3784]="0:2:0:1:Stave::1:0:", -- Metal Stave
	[3785]="0:2:0:1:OneHandAxe::1:0:", -- Keen Axe
	[3786]="0:2:0:1:Dagger::1:0:", -- Shiny Dirk
	[3787]="0:2:0:1:OneHandMace::1:0:", -- Stone Club
	[3792]="0:4:0:1:Cloth::1:0:", -- Interlaced Belt
	[3793]="0:4:0:1:Cloth::1:0:", -- Interlaced Boots
	[3794]="0:4:0:1:Cloth::1:0:", -- Interlaced Bracers
	[3795]="0:4:0:1:Cloak::1:0:", -- Interlaced Cloak
	[3796]="0:4:0:1:Cloth::1:0:", -- Interlaced Gloves
	[3797]="0:4:0:1:Cloth::1:0:", -- Interlaced Pants
	[3798]="0:4:0:1:Cloth::1:0:", -- Interlaced Shoulderpads
	[3799]="0:4:0:1:Cloth::1:0:", -- Interlaced Vest
	[3800]="0:4:0:1:Leather::1:0:", -- Hardened Leather Belt
	[3801]="0:4:0:1:Leather::1:0:", -- Hardened Leather Boots
	[3802]="0:4:0:1:Leather::1:0:", -- Hardened Leather Bracers
	[3803]="0:4:0:1:Cloak::1:0:", -- Hardened Cloak
	[3804]="0:4:0:1:Leather::1:0:", -- Hardened Leather Gloves
	[3805]="0:4:0:1:Leather::1:0:", -- Hardened Leather Pants
	[3806]="0:4:0:1:Leather::1:0:", -- Hardened Leather Shoulderpads
	[3807]="0:4:0:1:Leather::1:0:", -- Hardened Leather Tunic
	[3808]="0:4:0:1:Mail::1:0:", -- Double Mail Belt
	[3809]="0:4:0:1:Mail::1:0:", -- Double Mail Boots
	[3810]="0:4:0:1:Mail::1:0:", -- Double Mail Bracers
	[3811]="0:4:0:1:Cloak::1:0:", -- Double-stitched Cloak
	[3812]="0:4:0:1:Mail::1:0:", -- Double Mail Gloves
	[3813]="0:4:0:1:Mail::1:0:", -- Double Mail Pants
	[3814]="0:4:0:1:Mail::1:0:", -- Double Mail Shoulderpads
	[3815]="0:4:0:1:Mail::1:0:", -- Double Mail Vest
	[3816]="0:4:0:1:Shield::1:0:", -- Reflective Heater
	[3817]="0:4:0:1:Shield::1:0:", -- Reinforced Buckler
	[3818]="0:7:1:20:Herb:171:1:0:", -- Fadeleaf
	[3819]="0:7:1:20:Herb:171,333:1:0:", -- Wintersbite
	[3820]="0:7:1:20:Herb:171:1:0:", -- Stranglekelp
	[3821]="0:7:1:20:Herb:171,185:1:0:", -- Goldthorn
	[3822]="0:2:2:1:TwoHandSword::1:0:", -- Runic Darkblade
	[3823]="0:0:1:20:Potion:164:1:0:", -- Lesser Invisibility Potion
	[3824]="0:0:1:5:EnhTemp:171,164,755,165,197:1:0:", -- Shadow Oil
	[3825]="0:0:1:20:Elixir::1:0:", -- Elixir of Fortitude
	[3826]="0:0:1:20:Elixir::1:0:", -- Major Troll's Blood Elixir
	[3827]="480:0:1:20:Potion:755,197:1:1:2380,2480,2812,2848,4899,12245", -- Mana Potion
	[3828]="0:0:1:20:Elixir::1:0:", -- Elixir of Detect Lesser Invisibility
	[3829]="0:0:1:5:EnhTemp:164,333,202,197:1:0:", -- Frost Oil
	[3830]="0:9:1:1:Alchemy::1:0:", -- Recipe: Elixir of Fortitude
	[3831]="0:9:2:1:Alchemy::1:0:", -- Recipe: Major Troll's Blood Elixir
	[3832]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Detect Lesser Invisibility
	[3833]="0:4:1:1:Cloak::1:0:", -- Adept's Cloak
	[3834]="0:4:1:1:Cloth::1:0:", -- Sturdy Cloth Trousers
	[3835]="0:4:2:1:Mail::1:0:", -- Green Iron Bracers
	[3836]="0:4:2:1:Mail::1:0:", -- Green Iron Helm
	[3837]="0:4:2:1:Mail::1:0:", -- Golden Scale Coif
	[3838]="0:12:1:20:::1:0:", -- Shadowmaw Claw
	[3839]="0:12:1:1:::1:0:", -- Pristine Tigress Fang
	[3840]="0:4:2:1:Mail::1:0:", -- Green Iron Shoulders
	[3841]="0:4:2:1:Mail::1:0:", -- Golden Scale Shoulders
	[3842]="0:4:2:1:Mail::1:0:", -- Green Iron Leggings
	[3843]="0:4:2:1:Mail::1:0:", -- Golden Scale Leggings
	[3844]="0:4:3:1:Mail::1:0:", -- Green Iron Hauberk
	[3845]="0:4:2:1:Mail::1:0:", -- Golden Scale Cuirass
	[3846]="0:4:2:1:Mail::1:0:", -- Polished Steel Boots
	[3847]="0:4:2:1:Mail::1:0:", -- Golden Scale Boots
	[3848]="0:2:2:1:Dagger::1:0:", -- Big Bronze Knife
	[3849]="0:2:2:1:OneHandSword::1:0:", -- Hardened Iron Shortsword
	[3850]="0:2:2:1:OneHandSword::1:0:", -- Jade Serpentblade
	[3851]="0:2:2:1:TwoHandMace::1:0:", -- Solid Iron Maul
	[3852]="0:2:2:1:TwoHandMace::1:0:", -- Golden Iron Destroyer
	[3853]="0:2:2:1:TwoHandSword::1:0:", -- Moonsteel Broadsword
	[3854]="0:2:2:1:TwoHandSword::1:0:", -- Frost Tiger Blade
	[3855]="0:2:2:1:TwoHandAxe::1:0:", -- Massive Iron Axe
	[3856]="0:2:2:1:TwoHandAxe::1:0:", -- Shadow Crescent Axe
	[3857]="500:7:1:20:MetalStone:186:1:0:372,790,960,989,1148,1286,1456,1690,2225,2381,2393,2810,2821,2844,2847,2999,3002,3133,3167,3343,3356,3358,3367,3392,3477,3578,3779,3954,3955,4229,4256,4257,4259,4561,4597,4599,4775,4877,4897,5100,5135,5163,5411,5512,5514,5817,6298,6300,6301,7947,8145,8161,8176,8363,8934,9179,9636,11186,11189,12022,12028,12245,12941,12957,12958,14624,14737,15176,15179,15400,16376,16583,16613,16664,16670,16713,16751,16768,16823,17245,17486,17655,18009,19011,19012,19056,19244,19342,19372,19450,19520,19530,19662,19879,20082,20463,20981,22264,22476,23144,23724,23908,24052,24843,24935,24995,25010,25019,25051,25082,26081,26599,26934,27019,27021,27026,27043,27045,27057,27062,27134,27267,28344,28692,28716,28728,28796,28831,28872,29252,29253,29288,29907,29923,29964,29969,30241,30253,30311,30336,30436,31024,32594,33599,33631,33640,33675,33682", -- Coal
	[3858]="0:7:1:20:MetalStone:171,186:1:0:", -- Mithril Ore
	[3859]="0:7:1:20:MetalStone:164,202:1:0:", -- Steel Bar
	[3860]="0:7:1:20:MetalStone:171,164,202,755:1:0:", -- Mithril Bar
	[3862]="0:12:1:1:::1:0:", -- Aged Gorilla Sinew
	[3863]="0:12:1:20:::1:0:", -- Jungle Stalker Feather
	[3864]="0:3:2:20:GemSimple:164,202,755,165,197:1:0:", -- Citrine
	[3866]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Jade Serpentblade
	[3867]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Golden Iron Destroyer
	[3868]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Frost Tiger Blade
	[3869]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Shadow Crescent Axe
	[3870]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Green Iron Shoulders
	[3871]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Golden Scale Shoulders
	[3872]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Golden Scale Leggings
	[3873]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Golden Scale Cuirass
	[3874]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Polished Steel Boots
	[3875]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Golden Scale Boots
	[3876]="0:12:1:1:::1:0:", -- Fang of Bhag'thera
	[3877]="0:12:1:1:::1:0:", -- Talon of Tethis
	[3879]="0:12:1:1:::1:0:", -- Paw of Sin'Dall
	[3880]="0:12:1:1:::1:0:", -- Head of Bangalash
	[3882]="0:15:0:10:Junk::1:0:", -- Buzzard Feather
	[3889]="7923:4:1:1:Cloth::1:0:1147,1310,1314,1407,2849,3092,3315,3316,4175,5155,5821,8159,10293", -- Russet Hat
	[3890]="10201:4:1:1:Leather::1:0:1147,1310,1314,1320,1407,3315,3316,4236,5129,5820,8159", -- Studded Hat
	[3891]="12285:4:1:1:Mail::1:0:1310,1322,1323,1349,1381,2845,3095,4177,5125,5812,5819,8129", -- Augmented Chain Helm
	[3892]="21940:4:1:1:Cloth::1:0:984,1310,1314,2849,3092,3315,3316,4175,5129,5155,5821,10293,11183,12023,26707", -- Embroidered Hat
	[3893]="27523:4:1:1:Leather::1:0:984,1310,1314,1320,3315,3316,4236,5129,5820,11183,12023,26707,27037", -- Reinforced Leather Cap
	[3894]="29986:4:1:1:Mail::1:0:980,1310,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Brigandine Helm
	[3897]="0:12:1:1:::1:0:", -- Dizzy's Eye
	[3898]="0:12:1:1:::1:0:", -- Library Scrip
	[3899]="25:15:0:1:Junk::1:0:", -- Legends of the Gurubashi, Volume 3
	[3900]="0:12:1:20:::1:0:", -- Pupellyverbos Port
	[3901]="0:12:1:20:::1:0:", -- Bloodscalp Tusk
	[3902]="0:2:2:1:Stave::1:0:", -- Staff of Nobles
	[3904]="0:12:1:1:::1:0:", -- Gan'zulah's Head
	[3905]="0:12:1:1:::1:0:", -- Nezzliok's Head
	[3906]="0:12:1:20:::1:0:", -- Balia'mah Trophy
	[3907]="0:12:1:20:::1:0:", -- Ziata'jai Trophy
	[3908]="0:12:1:20:::1:0:", -- Zul'Mamwe Trophy
	[3909]="0:12:1:1:::1:0:", -- Broken Armor of Ana'thek
	[3910]="0:12:1:20:::1:0:", -- Snuff
	[3911]="0:12:1:20:::1:0:", -- Pulsing Blue Shard
	[3912]="0:12:1:1:::1:0:", -- Soul Gem
	[3913]="0:12:1:1:::1:0:", -- Filled Soul Gem
	[3914]="0:1:1:1:Bag::1:0:", -- Journeyman's Backpack
	[3915]="0:12:1:25:::1:0:", -- Bloody Bone Necklace
	[3916]="0:12:1:25:::1:0:", -- Split Bone Necklace
	[3917]="0:12:1:20:::1:0:", -- Singing Blue Crystal
	[3918]="0:12:1:20:::1:0:", -- Singing Crystal Shard
	[3919]="0:12:1:20:::1:0:", -- Mistvale Giblets
	[3920]="0:12:1:1:::1:0:", -- Bloodsail Charts
	[3921]="0:12:1:1:::1:0:", -- Bloodsail Orders
	[3922]="0:12:1:1:::1:0:", -- Shaky's Payment
	[3923]="0:12:1:20:::1:0:", -- Water Elemental Bracers
	[3924]="0:12:1:1:::1:0:", -- Maury's Clubbed Foot
	[3925]="0:12:1:1:::1:0:", -- Jon-Jon's Golden Spyglass
	[3926]="0:12:1:1:::1:0:", -- Chucky's Huge Ring
	[3927]="2000:0:1:20:FoodDrink::5:0:295,465,483,1237,2352,2364,3298,3546,4782,4891,4894,4981,5620,6746,6790,6930,9501,11106,11116,16553,17630,18929,23521,23604,24934", -- Fine Aged Cheddar
	[3928]="1000:0:1:20:Potion::1:1:983,8157,8158,8177,8178,11188,14847,18905,18908", -- Superior Healing Potion
	[3930]="0:13:1:1:::1:0:", -- Maury's Key
	[3931]="0:15:0:5:Junk::1:0:", -- Poisoned Spider Fang
	[3932]="0:12:1:1:::1:0:", -- Smotts' Chest
	[3935]="0:2:1:1:OneHandSword::1:0:", -- Smotts' Cutlass
	[3936]="0:4:0:1:Cloth::1:0:", -- Crochet Belt
	[3937]="0:4:0:1:Cloth::1:0:", -- Crochet Boots
	[3938]="0:4:0:1:Cloth::1:0:", -- Crochet Bracers
	[3939]="0:4:0:1:Cloak::1:0:", -- Crochet Cloak
	[3940]="0:4:0:1:Cloth::1:0:", -- Crochet Gloves
	[3941]="0:4:0:1:Cloth::1:0:", -- Crochet Pants
	[3942]="0:4:0:1:Cloth::1:0:", -- Crochet Shoulderpads
	[3943]="0:4:0:1:Cloth::1:0:", -- Crochet Vest
	[3944]="0:4:0:1:Cloth::1:0:", -- Twill Belt
	[3945]="0:4:0:1:Cloth::1:0:", -- Twill Boots
	[3946]="0:4:0:1:Cloth::1:0:", -- Twill Bracers
	[3947]="0:4:0:1:Cloak::1:0:", -- Twill Cloak
	[3948]="0:4:0:1:Cloth::1:0:", -- Twill Gloves
	[3949]="0:4:0:1:Cloth::1:0:", -- Twill Pants
	[3950]="0:4:0:1:Cloth::1:0:", -- Twill Shoulderpads
	[3951]="0:4:0:1:Cloth::1:0:", -- Twill Vest
	[3960]="0:12:1:1:::1:0:", -- Bag of Water Elemental Bracers
	[3961]="0:4:0:1:Leather::1:0:", -- Thick Leather Belt
	[3962]="0:4:0:1:Leather::1:0:", -- Thick Leather Boots
	[3963]="0:4:0:1:Leather::1:0:", -- Thick Leather Bracers
	[3964]="0:4:0:1:Cloak::1:0:", -- Thick Cloak
	[3965]="0:4:0:1:Leather::1:0:", -- Thick Leather Gloves
	[3966]="0:4:0:1:Leather::1:0:", -- Thick Leather Pants
	[3967]="0:4:0:1:Leather::1:0:", -- Thick Leather Shoulderpads
	[3968]="0:4:0:1:Leather::1:0:", -- Thick Leather Tunic
	[3969]="0:4:0:1:Leather::1:0:", -- Smooth Leather Belt
	[3970]="0:4:0:1:Leather::1:0:", -- Smooth Leather Boots
	[3971]="0:4:0:1:Leather::1:0:", -- Smooth Leather Bracers
	[3972]="0:4:0:1:Cloak::1:0:", -- Smooth Cloak
	[3973]="0:4:0:1:Leather::1:0:", -- Smooth Leather Gloves
	[3974]="0:4:0:1:Leather::1:0:", -- Smooth Leather Pants
	[3975]="0:4:0:1:Leather::1:0:", -- Smooth Leather Shoulderpads
	[3976]="0:4:0:1:Leather::1:0:", -- Smooth Leather Armor
	[3985]="0:4:2:1:Cloth::1:0:", -- Monogrammed Sash
	[3986]="0:4:0:1:Shield::1:0:", -- Protective Pavise
	[3987]="0:4:0:1:Shield::1:0:", -- Deflecting Tower
	[3989]="0:4:0:1:Shield::1:0:", -- Blocking Targe
	[3990]="0:4:0:1:Shield::1:0:", -- Crested Buckler
	[3992]="0:4:0:1:Mail::1:0:", -- Laminated Scale Belt
	[3993]="0:4:0:1:Mail::1:0:", -- Laminated Scale Boots
	[3994]="0:4:0:1:Mail::1:0:", -- Laminated Scale Bracers
	[3995]="0:4:0:1:Cloak::1:0:", -- Laminated Scale Cloak
	[3996]="0:4:0:1:Mail::1:0:", -- Laminated Scale Gloves
	[3997]="0:4:0:1:Mail::1:0:", -- Laminated Scale Pants
	[3998]="0:4:0:1:Mail::1:0:", -- Laminated Scale Shoulderpads
	[3999]="0:4:0:1:Mail::1:0:", -- Laminated Scale Armor
	[4000]="0:4:0:1:Mail::1:0:", -- Overlinked Chain Belt
	[4001]="0:4:0:1:Mail::1:0:", -- Overlinked Chain Boots
	[4002]="0:4:0:1:Mail::1:0:", -- Overlinked Chain Bracers
	[4003]="0:4:0:1:Cloak::1:0:", -- Overlinked Chain Cloak
	[4004]="0:4:0:1:Mail::1:0:", -- Overlinked Chain Gloves
	[4005]="0:4:0:1:Mail::1:0:", -- Overlinked Chain Pants
	[4006]="0:4:0:1:Mail::1:0:", -- Overlinked Chain Shoulderpads
	[4007]="0:4:0:1:Mail::1:0:", -- Overlinked Chain Armor
	[4016]="0:12:1:20:::1:0:", -- Zanzil's Mixture
	[4017]="0:2:0:1:OneHandSword::1:0:", -- Sharp Shortsword
	[4018]="0:2:0:1:TwoHandSword::1:0:", -- Whetted Claymore
	[4019]="0:2:0:1:OneHandAxe::1:0:", -- Heavy Flint Axe
	[4020]="0:2:0:1:TwoHandAxe::1:0:", -- Splintering Battle Axe
	[4021]="0:2:0:1:OneHandMace::1:0:", -- Blunting Mace
	[4022]="0:2:0:1:TwoHandMace::1:0:", -- Crushing Maul
	[4023]="0:2:0:1:Dagger::1:0:", -- Fine Pointed Dagger
	[4024]="0:2:0:1:Stave::1:0:", -- Heavy War Staff
	[4025]="0:2:0:1:Bow::1:0:", -- Balanced Long Bow
	[4026]="0:2:0:1:Gun::1:0:", -- Sentinel Musket
	[4027]="0:12:1:1:::1:0:", -- Catelyn's Blade
	[4028]="0:12:1:1:::1:0:", -- Bundle of Akiris Reeds
	[4029]="0:12:1:20:::1:0:", -- Akiris Reed
	[4034]="0:12:1:1:::1:0:", -- Stone of the Tides
	[4035]="0:4:2:1:Cloth::1:0:", -- Silver-thread Robe
	[4036]="0:4:2:1:Cloth::1:0:", -- Silver-thread Cuffs
	[4037]="0:4:2:1:Cloth::1:0:", -- Silver-thread Pants
	[4038]="0:4:2:1:Cloth::1:0:", -- Nightsky Robe
	[4039]="0:4:2:1:Cloth::1:0:", -- Nightsky Cowl
	[4040]="0:4:2:1:Cloth::1:0:", -- Nightsky Gloves
	[4041]="0:4:2:1:Cloth::1:0:", -- Aurora Cowl
	[4042]="0:4:2:1:Cloth::1:0:", -- Aurora Gloves
	[4043]="0:4:2:1:Cloth::1:0:", -- Aurora Bracers
	[4044]="0:4:2:1:Cloth::1:0:", -- Aurora Pants
	[4045]="0:4:2:1:Cloth::1:0:", -- Mistscape Bracers
	[4046]="0:4:2:1:Cloth::1:0:", -- Mistscape Pants
	[4047]="0:4:2:1:Cloth::1:0:", -- Mistscape Boots
	[4048]="0:4:2:1:Leather::1:0:", -- Emblazoned Hat
	[4049]="0:4:2:1:Leather::1:0:", -- Emblazoned Bracers
	[4050]="0:4:2:1:Leather::1:0:", -- Emblazoned Leggings
	[4051]="0:4:2:1:Leather::1:0:", -- Emblazoned Boots
	[4052]="0:4:2:1:Leather::1:0:", -- Insignia Cap
	[4053]="0:12:1:20:::1:0:", -- Large River Crocolisk Skin
	[4054]="0:4:2:1:Leather::1:0:", -- Insignia Leggings
	[4055]="0:4:2:1:Leather::1:0:", -- Insignia Boots
	[4056]="0:12:1:1:::1:0:", -- Cortello's Riddle
	[4057]="0:4:2:1:Leather::1:0:", -- Insignia Chestguard
	[4058]="0:4:2:1:Leather::1:0:", -- Glyphed Breastplate
	[4059]="0:4:2:1:Leather::1:0:", -- Glyphed Bracers
	[4060]="0:4:2:1:Leather::1:0:", -- Glyphed Leggings
	[4061]="0:4:2:1:Leather::1:0:", -- Imperial Leather Bracers
	[4062]="0:4:2:1:Leather::1:0:", -- Imperial Leather Pants
	[4063]="0:4:2:1:Leather::1:0:", -- Imperial Leather Gloves
	[4064]="0:4:2:1:Shield::1:0:", -- Emblazoned Buckler
	[4065]="0:4:2:1:Shield::1:0:", -- Combat Shield
	[4066]="0:4:2:1:Shield::1:0:", -- Insignia Buckler
	[4067]="0:4:2:1:Shield::1:0:", -- Glyphed Buckler
	[4068]="0:4:2:1:Shield::1:0:", -- Chief Brigadier Shield
	[4069]="0:4:2:1:Shield::1:0:", -- Blackforge Buckler
	[4070]="0:4:2:1:Shield::1:0:", -- Jouster's Crest
	[4071]="0:4:2:1:Mail::1:0:", -- Glimmering Mail Breastplate
	[4072]="0:4:2:1:Mail::1:0:", -- Glimmering Mail Gauntlets
	[4073]="0:4:2:1:Mail::1:0:", -- Glimmering Mail Greaves
	[4074]="0:4:2:1:Mail::1:0:", -- Mail Combat Armor
	[4075]="0:4:2:1:Mail::1:0:", -- Mail Combat Gauntlets
	[4076]="0:4:2:1:Mail::1:0:", -- Mail Combat Boots
	[4077]="0:4:2:1:Mail::1:0:", -- Mail Combat Headguard
	[4078]="0:4:2:1:Mail::1:0:", -- Chief Brigadier Coif
	[4079]="0:4:2:1:Mail::1:0:", -- Chief Brigadier Leggings
	[4080]="0:4:2:1:Mail::1:0:", -- Blackforge Cowl
	[4082]="0:4:2:1:Mail::1:0:", -- Blackforge Breastplate
	[4083]="0:4:2:1:Mail::1:0:", -- Blackforge Gauntlets
	[4084]="0:4:2:1:Mail::1:0:", -- Blackforge Leggings
	[4085]="0:12:1:1:::1:0:", -- Krazek's Crock Pot
	[4086]="0:2:2:1:Gun::1:0:", -- Flash Rifle
	[4087]="0:2:2:1:Bow::1:0:", -- Trueshot Bow
	[4088]="0:2:2:1:Dagger::1:0:", -- Dreadblade
	[4089]="0:2:2:1:Gun::1:0:", -- Ricochet Blunderbuss
	[4090]="0:2:3:1:OneHandMace::1:0:", -- Mug O' Hurt
	[4091]="0:2:3:1:Dagger::1:0:", -- Widowmaker
	[4092]="0:15:0:5:Junk::1:0:", -- Prismatic Basilisk Scale
	[4093]="0:15:0:5:Junk::1:0:", -- Large Basilisk Tail
	[4094]="0:12:1:1:::1:0:", -- Tablet Shard
	[4096]="0:15:1:10:Junk:165:1:0:", -- Coarse Gorilla Hair
	[4097]="0:15:0:10:Junk::1:0:", -- Chipped Gorilla Tooth
	[4098]="0:12:1:1:::1:0:", -- Carefully Folded Note
	[4099]="0:15:0:5:Junk::1:0:", -- Tuft of Gorilla Hair
	[4100]="0:15:0:10:Junk::1:0:", -- Crumpled Note
	[4101]="0:15:0:10:Junk::1:0:", -- Ripped Note
	[4102]="0:15:0:10:Junk::1:0:", -- Torn Note
	[4103]="0:13:1:1:::1:0:", -- Shackle Key
	[4104]="0:12:1:20:::1:0:", -- Snapjaw Crocolisk Skin
	[4105]="0:12:1:20:::1:0:", -- Elder Crocolisk Skin
	[4106]="0:12:1:20:::1:0:", -- Tumbled Crystal
	[4107]="0:4:2:1:Leather::1:0:", -- Tiger Hunter Gloves
	[4108]="0:4:2:1:Leather::1:0:", -- Panther Hunter Leggings
	[4109]="0:4:2:1:Leather::1:0:", -- Excelsior Boots
	[4110]="0:2:2:1:Bow::1:0:", -- Master Hunter's Bow
	[4111]="0:2:2:1:Gun::1:0:", -- Master Hunter's Rifle
	[4112]="0:4:2:1:Amulet::1:0:", -- Choker of the High Shaman
	[4113]="0:4:2:1:Cloak::1:0:", -- Medicine Blanket
	[4114]="0:4:2:1:Cloak::1:0:", -- Darktide Cape
	[4115]="0:4:2:1:Shield::1:0:", -- Grom'gol Buckler
	[4116]="0:2:2:1:OneHandSword::1:0:", -- Olmann Sewar
	[4117]="0:4:2:1:Cloth::1:0:", -- Scorching Sash
	[4118]="0:4:2:1:Mail::1:0:", -- Poobah's Nose Ring
	[4119]="0:4:2:1:Leather::1:0:", -- Raptor Hunter Tunic
	[4120]="0:4:3:1:Cloth::1:0:", -- Robe of Crystal Waters
	[4121]="0:4:2:1:Cloth::1:0:", -- Gemmed Gloves
	[4122]="0:2:2:1:OneHandMace::1:0:", -- Bookmaker's Scepter
	[4123]="0:4:2:1:Mail::1:0:", -- Frost Metal Pauldrons
	[4124]="0:4:2:1:Leather::1:0:", -- Cap of Harmony
	[4125]="0:4:2:1:OffHandFrill::1:0:", -- Tranquil Orb
	[4126]="0:2:2:1:OneHandAxe::1:0:", -- Guerrilla Cleaver
	[4127]="0:2:2:1:Gun::1:0:", -- Shrapnel Blaster
	[4128]="0:2:2:1:TwoHandMace::1:0:", -- Silver Spade
	[4129]="0:4:2:1:Shield::1:0:", -- Collection Plate
	[4130]="0:4:2:1:Trinket::1:0:", -- Smotts' Compass
	[4131]="0:4:2:1:Leather::1:0:", -- Belt of Corruption
	[4132]="0:4:2:1:Mail::1:0:", -- Darkspear Armsplints
	[4133]="0:4:2:1:Cloth::1:0:", -- Darkspear Cuffs
	[4134]="0:2:3:1:Stave::1:0:", -- Nimboya's Mystical Staff
	[4135]="0:4:2:1:Ring::1:0:", -- Bloodbone Band
	[4136]="0:4:2:1:Mail::1:0:", -- Darkspear Boots
	[4137]="0:4:2:1:Cloth::1:0:", -- Darkspear Shoes
	[4138]="0:4:2:1:Mail::1:0:", -- Blackwater Tunic
	[4139]="0:4:2:1:Cloth::1:0:", -- Junglewalker Sandals
	[4140]="0:4:2:1:Cloth::1:0:", -- Palm Frond Mantle
	[4197]="0:4:3:1:Cloth::1:0:", -- Berylline Pads
	[4213]="0:9:2:1:Book::1:0:", -- Grimoire of Doom
	[4231]="0:7:1:20:Leather:165:1:0:", -- Cured Light Hide
	[4232]="0:7:1:10:Leather:165:1:0:", -- Medium Hide
	[4233]="0:7:1:20:Leather:165:1:0:", -- Cured Medium Hide
	[4234]="600:7:1:20:Leather:164,202,165,197:1:1:14846", -- Heavy Leather
	[4235]="0:7:1:10:Leather:165:1:0:", -- Heavy Hide
	[4236]="0:7:1:20:Leather:165:1:0:", -- Cured Heavy Hide
	[4237]="0:4:1:1:Leather::1:0:", -- Handstitched Leather Belt
	[4238]="0:1:1:1:Bag::1:0:", -- Linen Bag
	[4239]="0:4:2:1:Leather::1:0:", -- Embossed Leather Gloves
	[4240]="0:1:1:1:Bag::1:0:", -- Woolen Bag
	[4241]="0:1:1:1:Bag::1:0:", -- Green Woolen Bag
	[4242]="0:4:2:1:Leather::1:0:", -- Embossed Leather Pants
	[4243]="0:4:2:1:Leather:165:1:0:", -- Fine Leather Tunic
	[4244]="0:4:2:1:Leather::1:0:", -- Hillman's Leather Vest
	[4245]="0:1:1:1:Bag::1:0:", -- Small Silk Pack
	[4246]="0:4:2:1:Leather:165:1:0:", -- Fine Leather Belt
	[4247]="0:4:2:1:Leather::1:0:", -- Hillman's Leather Gloves
	[4248]="0:4:2:1:Leather::1:0:", -- Dark Leather Gloves
	[4249]="0:4:2:1:Leather::1:0:", -- Dark Leather Belt
	[4250]="0:4:2:1:Leather::1:0:", -- Hillman's Belt
	[4251]="0:4:2:1:Leather::1:0:", -- Hillman's Shoulders
	[4252]="0:4:2:1:Leather::1:0:", -- Dark Leather Shoulders
	[4253]="0:4:3:1:Leather::1:0:", -- Toughened Leather Gloves
	[4254]="0:4:2:1:Leather::1:0:", -- Barbaric Gloves
	[4255]="0:4:2:1:Leather:164:1:0:", -- Green Leather Armor
	[4256]="0:4:2:1:Leather::1:0:", -- Guardian Armor
	[4257]="0:4:2:1:Leather::1:0:", -- Green Leather Belt
	[4258]="0:4:2:1:Leather::1:0:", -- Guardian Belt
	[4259]="0:4:2:1:Leather::1:0:", -- Green Leather Bracers
	[4260]="0:4:2:1:Leather::1:0:", -- Guardian Leather Bracers
	[4261]="0:4:1:1:Cloth::1:0:", -- Solliden's Trousers
	[4262]="0:4:3:1:Leather::1:0:", -- Gem-studded Leather Belt
	[4263]="0:4:1:1:Shield::1:0:", -- Standard Issue Shield
	[4264]="0:4:2:1:Leather::1:0:", -- Barbaric Belt
	[4265]="0:0:1:10:EnhPerm::1:0:", -- Heavy Armor Kit
	[4278]="0:12:1:20:::1:0:", -- Lesser Bloodstone Ore
	[4289]="50:7:1:20:Leather:165:1:0:66,777,843,960,989,1148,1250,1286,1456,1465,1692,2118,2225,2381,2393,2697,2698,2699,2810,2816,2819,2821,2846,3005,3081,3168,3187,3366,3367,3482,3499,3556,3614,3779,3954,3955,3958,4194,4225,4229,4561,4589,4775,4877,4897,5100,5128,5135,5163,5565,5783,5817,5944,6301,6731,7852,7854,7947,8145,8160,8363,8934,9636,11189,11874,12022,12028,12043,12245,12941,12942,12943,12956,12957,12958,15179,16224,16261,16262,16613,16689,16748,16768,17486,17490,18009,18277,18426,18427,18754,18771,19196,19244,19372,19450,19532,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27037,27043,27057,28692,28718,28798,28831,28872,29288,30311,33601,33635,33641,33681,33683", -- Salt
	[4290]="0:4:2:1:Shield::1:0:", -- Dust Bowl
	[4291]="500:7:1:20:Cloth:165,197:1:0:960,989,1148,1286,1347,1454,1456,1474,1672,2225,2381,2393,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3091,3096,3364,3366,3367,3485,3779,3954,3955,3958,4168,4189,4225,4229,4561,4577,4589,4775,4877,4897,5100,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,9636,11189,11557,11874,12022,12028,12245,12941,12942,12943,12956,12957,12958,15165,15179,16366,16613,16638,16689,16748,16767,16768,17486,18009,18277,18749,18754,18771,18772,19196,19213,19244,19372,19450,19521,19532,19722,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,28692,28718,28726,28798,28810,28831,28872,29288,30311,33596,33601,33635,33636,33681,33684", -- Silken Thread
	[4292]="0:9:2:1:Tailoring::1:0:", -- Pattern: Green Woolen Bag
	[4293]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Hillman's Leather Vest
	[4294]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Hillman's Belt
	[4296]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Dark Leather Shoulders
	[4297]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Barbaric Gloves
	[4298]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Guardian Belt
	[4299]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Guardian Armor
	[4300]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Guardian Leather Bracers
	[4301]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Barbaric Belt
	[4302]="0:2:1:1:Dagger::1:0:", -- Small Green Dagger
	[4303]="0:2:2:1:OneHandMace::1:0:", -- Cranial Thumper
	[4304]="1200:7:1:20:Leather:164,202,165,197:1:1:14846", -- Thick Leather
	[4305]="2400:7:1:20:Cloth:165,197:1:1:16631", -- Bolt of Silk Cloth
	[4306]="600:7:1:20:Cloth:164,202,129,197:1:1:16631", -- Silk Cloth
	[4307]="0:4:2:1:Cloth::1:0:", -- Heavy Linen Gloves
	[4308]="0:4:2:1:Cloth::1:0:", -- Green Linen Bracers
	[4309]="0:4:2:1:Cloth::1:0:", -- Handstitched Linen Britches
	[4310]="0:4:2:1:Cloth::1:0:", -- Heavy Woolen Gloves
	[4311]="0:4:2:1:Cloak::1:0:", -- Heavy Woolen Cloak
	[4312]="0:4:2:1:Cloth::1:0:", -- Soft-soled Linen Boots
	[4313]="0:4:2:1:Cloth::1:0:", -- Red Woolen Boots
	[4314]="0:4:2:1:Cloth::1:0:", -- Double-stitched Woolen Shoulders
	[4315]="0:4:2:1:Cloth::1:0:", -- Reinforced Woolen Shoulders
	[4316]="0:4:2:1:Cloth::1:0:", -- Heavy Woolen Pants
	[4317]="0:4:2:1:Cloth::1:0:", -- Phoenix Pants
	[4318]="0:4:2:1:Cloth::1:0:", -- Gloves of Meditation
	[4319]="0:4:2:1:Cloth::1:0:", -- Azure Silk Gloves
	[4320]="0:4:3:1:Cloth::1:0:", -- Spidersilk Boots
	[4321]="0:4:2:1:Cloth::1:0:", -- Spider Silk Slippers
	[4322]="0:4:2:1:Cloth::1:0:", -- Enchanter's Cowl
	[4323]="0:4:2:1:Cloth::1:0:", -- Shadow Hood
	[4324]="0:4:2:1:Cloth::1:0:", -- Azure Silk Vest
	[4325]="0:4:2:1:Cloth::1:0:", -- Boots of the Enchanter
	[4326]="0:4:2:1:Cloak::1:0:", -- Long Silken Cloak
	[4327]="0:4:3:1:Cloak::1:0:", -- Icy Cloak
	[4328]="0:4:2:1:Cloth::1:0:", -- Spider Belt
	[4329]="0:4:2:1:Cloth::1:0:", -- Star Belt
	[4330]="0:4:1:1:Shirt::1:0:", -- Stylish Red Shirt
	[4331]="0:4:2:1:Cloth::1:0:", -- Phoenix Gloves
	[4332]="0:4:1:1:Shirt::1:0:", -- Bright Yellow Shirt
	[4333]="0:4:1:1:Shirt::1:0:", -- Dark Silk Shirt
	[4334]="0:4:1:1:Shirt::1:0:", -- Formal White Shirt
	[4335]="0:4:1:1:Shirt::1:0:", -- Rich Purple Silk Shirt
	[4336]="0:4:1:1:Shirt::1:0:", -- Black Swashbuckler's Shirt
	[4337]="0:7:1:10:Cloth:202,165,197:1:0:", -- Thick Spider's Silk
	[4338]="1000:7:1:20:Cloth:164,202,129,165,197:1:1:16631", -- Mageweave Cloth
	[4339]="0:7:1:20:Cloth:202,197:1:0:", -- Bolt of Mageweave
	[4340]="350:7:1:10:Other:165,197:1:0:989,1148,1286,1347,1454,1474,1672,2225,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3091,3096,3364,3366,3367,3485,3779,3954,3955,3958,4168,4189,4225,4229,4561,4577,4589,4775,4897,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,11189,11557,11874,12022,12028,12245,12941,12942,12943,12956,12957,12958,15165,15179,16366,16613,16638,16689,16748,16767,16768,17486,18009,18277,18749,18754,18771,18772,19196,19213,19244,19372,19450,19521,19532,19722,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,28692,28718,28726,28798,28810,28831,28872,29288,30311,33596,33601,33635,33636,33681,33684", -- Gray Dye
	[4341]="500:7:1:10:Other:197:1:0:989,1148,1286,1347,1454,1474,1672,2225,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3091,3096,3364,3366,3367,3485,3779,3954,3955,3958,4168,4189,4225,4229,4561,4577,4589,4775,4897,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,11189,11557,11874,12022,12028,12245,12941,12942,12943,12956,12957,12958,15165,15179,16366,16613,16638,16689,16748,16767,16768,17486,18009,18277,18749,18754,18771,18772,19196,19213,19244,19372,19450,19521,19532,19722,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,28692,28718,28726,28798,28810,28831,28872,29288,30311,33596,33601,33635,33636,33681,33684", -- Yellow Dye
	[4342]="2500:7:1:10:Other:171,202,165,197:1:0:989,1148,1286,1347,1454,1474,1672,2225,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3091,3096,3364,3366,3367,3485,3779,3954,3955,3958,4168,4189,4225,4229,4561,4577,4589,4775,4897,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,11189,11557,11874,12022,12028,12245,12941,12942,12943,12956,12957,12958,15165,15179,16366,16613,16638,16689,16748,16767,16768,17486,18009,18277,18749,18754,18771,18772,19196,19213,19244,19372,19450,19521,19532,19722,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,28692,28718,28726,28798,28810,28831,28872,29288,30311,33596,33601,33635,33636,33681,33684", -- Purple Dye
	[4343]="0:4:2:1:Cloth::1:0:", -- Brown Linen Pants
	[4344]="0:4:1:1:Shirt::1:0:", -- Brown Linen Shirt
	[4345]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Woolen Boots
	[4346]="0:9:2:1:Tailoring::1:0:", -- Pattern: Heavy Woolen Cloak
	[4347]="0:9:2:1:Tailoring::1:0:", -- Pattern: Reinforced Woolen Shoulders
	[4348]="0:9:2:1:Tailoring::1:0:", -- Pattern: Phoenix Gloves
	[4349]="0:9:2:1:Tailoring::1:0:", -- Pattern: Phoenix Pants
	[4350]="0:9:2:1:Tailoring::1:0:", -- Pattern: Spider Silk Slippers
	[4351]="0:9:2:1:Tailoring::1:0:", -- Pattern: Shadow Hood
	[4352]="0:9:2:1:Tailoring::1:0:", -- Pattern: Boots of the Enchanter
	[4353]="0:9:2:1:Tailoring::1:0:", -- Pattern: Spider Belt
	[4354]="0:9:3:1:Tailoring::1:0:", -- Pattern: Rich Purple Silk Shirt
	[4355]="1500:9:1:1:Tailoring::1:1:2381,6567", -- Pattern: Icy Cloak
	[4356]="0:9:2:1:Tailoring::1:0:", -- Pattern: Star Belt
	[4357]="16:7:1:20:Part:202:1:1:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14337,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Rough Blasting Powder
	[4358]="0:7:1:20:Explosive::1:0:", -- Rough Dynamite
	[4359]="0:7:1:20:Part:202:1:0:", -- Handful of Copper Bolts
	[4360]="0:7:1:20:Explosive::1:0:", -- Rough Copper Bomb
	[4361]="480:7:1:20:Part:202:1:1:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33669,33677,37904,37935", -- Copper Tube
	[4362]="0:2:2:1:Gun::1:0:", -- Rough Boomstick
	[4363]="200:7:1:20:Part:202:1:1:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Copper Modulator
	[4364]="48:7:1:20:Part:202:1:1:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14337,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Coarse Blasting Powder
	[4365]="0:7:1:20:Explosive::1:0:", -- Coarse Dynamite
	[4366]="0:15:1:10:CombatPet::1:0:", -- Target Dummy
	[4367]="0:7:1:10:Explosive::1:0:", -- Small Seaforium Charge
	[4368]="0:4:2:1:Cloth:202:1:0:", -- Flying Tiger Goggles
	[4369]="0:2:2:1:Gun::1:0:", -- Deadly Blunderbuss
	[4370]="0:7:1:20:Explosive::1:0:", -- Large Copper Bomb
	[4371]="800:7:1:20:Part:202:1:1:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Bronze Tube
	[4372]="0:2:2:1:Gun::1:0:", -- Lovingly Crafted Boomstick
	[4373]="0:4:2:1:Cloth::1:0:", -- Shadow Goggles
	[4374]="0:7:1:20:Explosive::1:0:", -- Small Bronze Bomb
	[4375]="0:7:1:10:Part:202:1:0:", -- Whirring Bronze Gizmo
	[4376]="0:7:1:1:Device::1:0:", -- Flame Deflector
	[4377]="0:7:1:20:Part:202:1:0:", -- Heavy Blasting Powder
	[4378]="1400:7:1:20:Explosive::1:1:3180", -- Heavy Dynamite
	[4379]="0:2:2:1:Gun::1:0:", -- Silver-plated Shotgun
	[4380]="0:7:1:20:Explosive::1:0:", -- Big Bronze Bomb
	[4381]="0:4:2:1:Trinket::1:0:", -- Minor Recombobulator
	[4382]="2400:7:1:10:Part:202:1:1:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Bronze Framework
	[4383]="0:2:2:1:Gun::1:0:", -- Moonsight Rifle
	[4384]="0:15:1:20:CombatPet::1:0:", -- Explosive Sheep
	[4385]="0:4:2:1:Cloth:202:1:0:", -- Green Tinted Goggles
	[4386]="0:7:1:1:Device::1:0:", -- Ice Deflector
	[4387]="0:7:1:10:Part:202:1:0:", -- Iron Strut
	[4388]="0:7:1:1:Device::1:0:", -- Discombobulator Ray
	[4389]="3000:7:1:10:Part:202:1:1:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33669,37904,37935", -- Gyrochronatom
	[4390]="0:7:1:20:Explosive::1:0:", -- Iron Grenade
	[4391]="0:15:1:5:CombatPet::1:0:", -- Compact Harvest Reaper Kit
	[4392]="0:15:1:10:CombatPet::1:0:", -- Advanced Target Dummy
	[4393]="0:4:2:1:Cloth::1:0:", -- Craftsman's Monocle
	[4394]="0:7:1:20:Explosive:202:1:0:", -- Big Iron Bomb
	[4395]="0:15:1:20:CombatPet::1:0:", -- Goblin Land Mine
	[4396]="0:4:2:1:Trinket::1:0:", -- Mechanical Dragonling
	[4397]="0:4:1:1:Trinket::1:0:", -- Gnomish Cloaking Device
	[4398]="0:7:1:20:Explosive::1:0:", -- Large Seaforium Charge
	[4399]="200:7:1:10:Part:202:1:0:960,989,1148,1286,1448,1456,1694,2225,2381,2393,2682,2683,2684,2685,2687,2688,2810,2821,3133,3367,3413,3495,3779,3954,3955,4229,4453,4561,4587,4775,4877,4897,5100,5135,5163,5175,5519,5817,6301,6730,6777,7947,8145,8363,8678,8679,8934,9544,9636,9676,11185,11189,12022,12028,12245,12941,12957,12958,14337,14637,15179,16613,16657,16768,16782,17222,17421,17486,18009,18278,18484,18752,18775,19244,19372,19383,19450,20890,24843,24935,24995,25010,25019,25051,25082,26600,26898,27021,27026,27043,27057,27711,28692,28722,28797,28831,28872,29288,29688,29907,30311,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Wooden Stock
	[4400]="2000:7:1:10:Part:202:1:0:960,989,1148,1286,1448,1456,1694,2225,2381,2393,2682,2683,2684,2685,2687,2688,2810,2821,3133,3367,3413,3495,3779,3954,3955,4229,4453,4561,4587,4775,4877,4897,5100,5135,5163,5175,5519,5817,6301,6730,6777,7947,8145,8363,8678,8679,8934,9544,9636,9676,11185,11189,12022,12028,12245,12941,12957,12958,14337,14637,15179,16613,16657,16768,16782,17222,17421,17486,18009,18278,18484,18752,18775,19244,19372,19383,19450,20890,24843,24935,24995,25010,25019,25051,25082,26600,26898,27021,27026,27043,27057,27711,28692,28722,28797,28831,28872,29288,29688,29907,30311,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Heavy Stock
	[4401]="0:15:1:1:Companion::1:0:", -- Mechanical Squirrel Box
	[4402]="0:7:1:5:Other:171,185,202:1:0:", -- Small Flame Sac
	[4403]="0:7:1:1:Device::1:0:", -- Portable Bronze Mortar
	[4404]="100:7:1:20:Part:202:1:1:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33669,33677,37904,37935", -- Silver Contact
	[4405]="0:0:1:5:EnhPerm::1:0:", -- Crude Scope
	[4406]="0:0:1:5:EnhPerm::1:0:", -- Standard Scope
	[4407]="0:0:2:5:EnhPerm:202:1:0:", -- Accurate Scope
	[4408]="0:9:2:1:Engineering::1:0:", -- Schematic: Mechanical Squirrel Box
	[4409]="0:9:2:1:Engineering::1:0:", -- Schematic: Small Seaforium Charge
	[4410]="0:9:2:1:Engineering::1:0:", -- Schematic: Shadow Goggles
	[4411]="0:9:2:1:Engineering::1:0:", -- Schematic: Flame Deflector
	[4412]="0:9:2:1:Engineering::1:0:", -- Schematic: Moonsight Rifle
	[4413]="0:9:2:1:Engineering::1:0:", -- Schematic: Discombobulator Ray
	[4414]="0:9:2:1:Engineering::1:0:", -- Schematic: Portable Bronze Mortar
	[4415]="0:9:3:1:Engineering::1:0:", -- Schematic: Craftsman's Monocle
	[4416]="0:9:2:1:Engineering::1:0:", -- Schematic: Goblin Land Mine
	[4417]="0:9:2:1:Engineering::1:0:", -- Schematic: Large Seaforium Charge
	[4419]="450:0:1:20:Scroll::1:1:14847", -- Scroll of Intellect III
	[4421]="400:0:1:20:Scroll::1:1:12246,14847", -- Scroll of Protection III
	[4422]="450:0:1:20:Scroll::1:1:14847", -- Scroll of Stamina III
	[4424]="400:0:1:20:Scroll::1:1:12246,14847", -- Scroll of Spirit III
	[4425]="500:0:1:20:Scroll::1:1:14847,20092", -- Scroll of Agility III
	[4426]="500:0:1:20:Scroll::1:1:14847,20092", -- Scroll of Strength III
	[4428]="0:15:0:5:Junk::1:0:", -- Spider Palp
	[4429]="0:12:1:1:::1:0:", -- Deepfury's Orders
	[4430]="0:4:2:1:Amulet::1:0:", -- Ethereal Talisman
	[4432]="0:12:1:1:::1:0:", -- Sully Balloo's Letter
	[4433]="0:12:1:1:::1:0:", -- Waterlogged Envelope
	[4434]="0:4:2:1:Cloth::1:0:", -- Scarecrow Trousers
	[4435]="0:12:1:20:::1:0:", -- Mote of Myzrael
	[4436]="0:4:2:1:Cloth::1:0:", -- Jewel-encrusted Sash
	[4437]="0:2:2:1:Stave::1:0:", -- Channeler's Staff
	[4438]="0:4:3:1:Mail::1:0:", -- Pugilist Bracers
	[4439]="0:2:2:1:OneHandMace::1:0:", -- Bruiser Club
	[4440]="0:12:1:1:::1:0:", -- Sigil of Strom
	[4441]="0:12:1:1:::1:0:", -- MacKreel's Moonshine
	[4443]="0:4:2:1:Mail::1:0:", -- Grim Pauldrons
	[4444]="0:4:2:1:Shield::1:0:", -- Black Husk Shield
	[4445]="0:2:2:1:OneHandAxe::1:0:", -- Flesh Carver
	[4446]="0:2:3:1:Dagger::1:0:", -- Blackvenom Blade
	[4447]="0:4:2:1:Cloak::1:0:", -- Cloak of Night
	[4448]="0:4:2:1:Mail::1:0:", -- Husk of Naraxis
	[4449]="0:2:2:1:Dagger::1:0:", -- Naraxis' Fang
	[4450]="0:12:1:20:::1:0:", -- Sigil Fragment
	[4453]="0:12:1:1:::1:0:", -- Sigil of Thoradin
	[4454]="0:2:3:1:Dagger::1:0:", -- Talon of Vultros
	[4455]="0:4:2:1:Leather::1:0:", -- Raptor Hide Harness
	[4456]="0:4:2:1:Leather::1:0:", -- Raptor Hide Belt
	[4457]="0:0:1:20:FoodDrink::1:0:", -- Barbecued Buzzard Wing
	[4458]="0:12:1:1:::1:0:", -- Sigil of Arathor
	[4459]="0:15:0:10:Junk::1:0:", -- Brittle Dragon Bone
	[4460]="0:15:0:10:Junk::1:0:", -- Ripped Wing Webbing
	[4461]="0:7:1:10:Leather:165:1:0:", -- Raptor Hide
	[4462]="0:4:2:1:Cloak::1:0:", -- Cloak of Rot
	[4463]="0:4:2:1:Cloth::1:0:", -- Beaded Raptor Collar
	[4464]="0:4:2:1:Mail::1:0:", -- Trouncing Boots
	[4465]="0:4:2:1:Mail::1:0:", -- Felstrom's Gauntlets
	[4466]="0:12:1:1:::1:0:", -- Sigil of Trollbane
	[4467]="0:12:1:1:::1:0:", -- Sigil of Ignaeus
	[4468]="0:12:1:1:::1:0:", -- Sheathed Trol'kalar
	[4469]="0:12:1:1:::1:0:", -- Rod of Order
	[4470]="38:7:1:20:Other:333,202:1:0:151,227,491,734,791,1149,1250,1285,1318,1448,1452,1650,1682,1685,1691,2084,2134,2140,2401,2803,2806,2808,2820,2908,3012,3076,3164,3186,3313,3346,3350,3481,3498,3541,3608,3625,3962,4082,4084,4170,4182,4228,4241,4555,4617,4876,4896,5101,5134,5158,5757,5758,7942,8139,8362,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,15419,16187,16191,16259,16260,16444,16635,16722,16732,17421,17446,17489,18753,18773,18810,18811,18951,19234,19537,19540,19663,26569,27030,27039,27054,27147,28714,28715,29537,33597,33633,33676", -- Simple Wood
	[4471]="0:7:0:1:Other::1:0:", -- Flint and Tinder
	[4472]="0:12:1:1:::1:0:", -- Scroll of Myzrael
	[4473]="0:12:1:1:::1:0:", -- Eldritch Shackles
	[4474]="0:2:2:1:Bow::1:0:", -- Ravenwood Bow
	[4476]="0:4:2:1:Cloth::1:0:", -- Beastwalker Robe
	[4477]="0:4:2:1:Shield::1:0:", -- Nefarious Buckler
	[4478]="0:4:2:1:Mail::1:0:", -- Iridescent Scale Leggings
	[4479]="0:0:1:10:Other::1:0:", -- Burning Charm
	[4480]="0:0:1:10:Other::1:0:", -- Thundering Charm
	[4481]="0:0:1:10:Other::1:0:", -- Cresting Charm
	[4482]="0:12:1:1:::1:0:", -- Sealed Folder
	[4483]="0:13:1:1:::1:0:", -- Burning Key
	[4484]="0:13:1:1:::1:0:", -- Cresting Key
	[4485]="0:13:1:1:::1:0:", -- Thundering Key
	[4487]="0:12:1:1:::1:0:", -- Maiden's Folly Charts
	[4488]="0:12:1:1:::1:0:", -- Spirit of Silverpine Charts
	[4489]="0:12:1:1:::1:0:", -- Maiden's Folly Log
	[4490]="0:12:1:1:::1:0:", -- Spirit of Silverpine Log
	[4491]="0:12:1:1:::1:0:", -- Goggles of Gem Hunting
	[4492]="0:12:1:20:::1:0:", -- Elven Gem
	[4493]="0:12:1:1:::1:0:", -- Elven Gems
	[4494]="0:12:1:1:::1:0:", -- Seahorn's Sealed Letter
	[4495]="0:12:1:20:::1:0:", -- Bloodstone Amulet
	[4496]="500:1:1:1:Bag::1:0:151,491,791,1250,1285,1321,1682,1685,1691,2134,2140,3016,3076,3164,3186,3313,3369,3481,3487,3498,3608,4082,4084,4170,4182,4230,4241,4555,4590,5132,7942,8362,8364,12027,12960,16187,16191,16259,16260,16444,16690,16709,16732,17421,17446,17489,18810,18811,18947,19197,19560", -- Small Brown Pouch
	[4497]="20000:1:1:1:Bag::1:0:227,734,1149,1285,1321,1448,1452,2084,2401,2803,2806,2808,2820,2908,3016,3313,3350,3369,3487,3541,3625,3962,4170,4230,4241,4555,4590,4876,4896,5101,5132,5134,7942,8139,8362,8364,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16690,16709,16732,17489,18947,19197,19560", -- Heavy Brown Bag
	[4498]="2500:1:1:1:Bag::1:0:151,227,491,734,791,1149,1250,1285,1321,1448,1452,1682,1685,1691,2084,2134,2140,2401,2803,2806,2808,2820,2908,3016,3076,3164,3186,3313,3350,3369,3481,3487,3498,3541,3608,3625,3962,4082,4084,4170,4182,4230,4241,4555,4590,4876,4896,5101,5132,5134,7942,8139,8362,8364,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,16187,16191,16259,16260,16444,16690,16709,16732,17421,17446,17489,18810,18811,18947,19197,19560", -- Brown Leather Satchel
	[4499]="100000:1:1:1:Bag::1:0:1321,3369,4230,4590,5132,8364,16690,16709,19197", -- Huge Brown Sack
	[4500]="0:1:2:1:Bag::1:0:", -- Traveler's Backpack
	[4502]="0:12:1:1:::1:0:", -- Sample Elven Gem
	[4503]="0:12:1:20:::1:0:", -- Witherbark Tusk
	[4504]="0:4:2:1:Cloak::1:0:", -- Dwarven Guard Cloak
	[4505]="0:4:2:1:Cloth::1:0:", -- Swampland Trousers
	[4506]="0:12:1:20:::1:0:", -- Stromgarde Badge
	[4507]="0:4:3:1:Shield::1:0:", -- Pit Fighter's Shield
	[4508]="0:4:3:1:Mail::1:0:", -- Blood-tinged Armor
	[4509]="0:4:2:1:Leather::1:0:", -- Seawolf Gloves
	[4510]="0:12:1:1:::1:0:", -- Befouled Bloodstone Orb
	[4511]="0:2:2:1:OneHandMace::1:0:", -- Black Water Hammer
	[4512]="0:12:1:20:::1:0:", -- Highland Raptor Eye
	[4513]="0:12:1:20:::1:0:", -- Raptor Heart
	[4514]="0:12:1:1:::1:0:", -- Sara Balloo's Plea
	[4515]="0:12:1:1:::1:0:", -- Marez's Head
	[4516]="0:12:1:1:::1:0:", -- Otto's Head
	[4517]="0:12:1:1:::1:0:", -- Falconcrest's Head
	[4518]="0:12:1:1:::1:0:", -- Torn Scroll Fragment
	[4519]="0:12:1:1:::1:0:", -- Crumpled Scroll Fragment
	[4520]="0:12:1:1:::1:0:", -- Singed Scroll Fragment
	[4521]="0:12:1:20:::1:0:", -- Alterac Granite
	[4522]="0:12:1:20:::1:0:", -- Witherbark Medicine Pouch
	[4525]="0:12:1:1:::1:0:", -- Trelane's Wand of Invocation
	[4526]="0:12:1:1:::1:0:", -- Raptor Talon Amulet
	[4527]="0:12:1:1:::1:0:", -- Azure Agate
	[4528]="0:12:1:1:::1:0:", -- Tor'gan's Orb
	[4529]="0:12:1:1:::1:0:", -- Enchanted Agate
	[4530]="0:12:1:1:::1:0:", -- Trelane's Phylactery
	[4531]="0:12:1:1:::1:0:", -- Trelane's Orb
	[4532]="0:12:1:1:::1:0:", -- Trelane's Ember Agate
	[4533]="0:12:1:1:::1:0:", -- Sealed Letter to Archmage Malin
	[4534]="0:4:2:1:Mail::1:0:", -- Steel-clasped Bracers
	[4535]="0:4:2:1:Ring::1:0:", -- Ironforge Memorial Ring
	[4536]="25:0:1:20:FoodDrink::5:0:734,894,1671,3017,3342,3934,3961,4191,4891,5814,6735,6740,7714,7736,7978,16443,16542,17630,19223,21145,23573,24934,29547", -- Shiny Red Apple
	[4537]="125:0:1:20:FoodDrink::5:0:734,894,1671,3017,3342,3934,3961,4191,4891,5814,6735,6740,7714,7736,7978,16443,16542,17630,21145,23573,24934,29547", -- Tel'Abim Banana
	[4538]="500:0:1:20:FoodDrink::5:0:734,894,1671,3017,3342,3934,3961,4191,4891,5814,6735,6740,7714,7736,7978,14963,14964,15124,15125,16443,16542,17630,21145,23573,24934,29547", -- Snapvine Watermelon
	[4539]="1000:0:1:20:FoodDrink::5:0:734,894,1671,3017,3342,3934,3961,4191,4891,5814,6735,6740,7714,7736,7978,14963,14964,15124,15125,16443,16542,17630,19223,21145,23573,24934,29547", -- Goldenbark Apple
	[4540]="25:0:1:20:FoodDrink::5:0:152,233,829,1237,1247,1285,1670,2115,2352,2364,2832,3003,3072,3086,3158,3291,3313,3480,3518,3546,3587,3689,3708,3883,3884,3937,3948,3959,4190,4266,4891,4894,5109,5620,6272,6734,6736,6737,6740,6747,7485,7737,7744,7941,8143,8307,8362,11103,11287,15433,16191,16256,16458,16739,17630,23522,23603,24834,24934,24993,25012,25020,25052,25089,29291,33996", -- Tough Hunk of Bread
	[4541]="125:0:1:20:FoodDrink::5:0:233,1237,1247,1670,2352,2364,2832,3003,3086,3291,3480,3518,3546,3689,3708,3883,3884,3937,3948,3959,4190,4266,4891,4894,5109,5620,6272,6734,6736,6737,6740,6747,7485,7737,7744,7941,8143,8307,11103,11287,15433,16256,16458,16739,17630,23522,23603,24834,24934,24993,25012,25020,25052,25089,29291,33996", -- Freshly Baked Bread
	[4542]="500:0:1:20:FoodDrink::5:0:233,1237,1247,1670,2352,2364,2832,3003,3086,3291,3480,3518,3546,3689,3708,3883,3884,3937,3948,3959,4190,4266,4891,4894,5109,5620,6272,6734,6736,6737,6740,6747,7485,7737,7744,7941,8143,8307,11103,11287,15433,16256,16458,16739,17630,23522,23603,24834,24934,24993,25012,25020,25052,25089,29291,33996", -- Moist Cornbread
	[4543]="0:4:2:1:Leather::1:0:", -- White Drakeskin Cap
	[4544]="1000:0:1:20:FoodDrink::5:0:233,1237,1247,1670,2352,2364,2832,3003,3086,3291,3480,3518,3546,3689,3708,3883,3884,3937,3948,3959,4190,4266,4891,4894,5109,5620,6272,6734,6736,6737,6740,6747,7485,7737,7744,7941,8143,8307,11103,11287,15433,16256,16458,16739,17630,23522,23603,24834,24934,24993,25012,25020,25052,25089,29291,33996", -- Mulgore Spice Bread
	[4545]="0:4:2:1:Cloth::1:0:", -- Radiant Silver Bracers
	[4546]="0:0:1:1:Consumable::1:0:", -- Call of the Raptor
	[4547]="0:2:2:1:Wand::1:0:", -- Gnomish Zapper
	[4548]="0:2:2:1:TwoHandMace::1:0:", -- Servomechanic Sledgehammer
	[4549]="0:4:2:1:Ring::1:0:", -- Seafire Band
	[4550]="0:4:2:1:Ring::1:0:", -- Coldwater Ring
	[4551]="0:12:1:1:::1:0:", -- Or'Kalar's Head
	[4552]="0:15:0:10:Junk::1:0:", -- Smooth Stone Chip
	[4553]="0:15:0:5:Junk::1:0:", -- Jagged Piece of Stone
	[4554]="0:15:0:5:Junk::1:0:", -- Shiny Polished Stone
	[4555]="0:15:0:5:Junk::1:0:", -- Thick Scaly Tail
	[4556]="0:15:0:5:Junk::1:0:", -- Speckled Shell Fragment
	[4557]="0:15:0:10:Junk::1:0:", -- Fiery Gland
	[4558]="0:15:0:1:Junk::1:0:", -- Empty Barrel
	[4560]="0:2:1:1:OneHandSword::1:0:", -- Fine Scimitar
	[4561]="0:2:2:1:OneHandAxe::1:0:", -- Scalping Tomahawk
	[4562]="0:2:2:1:TwoHandAxe::1:0:", -- Severing Axe
	[4563]="0:2:1:1:OneHandMace::1:0:", -- Billy Club
	[4564]="0:2:2:1:TwoHandMace::1:0:", -- Spiked Club
	[4565]="0:2:1:1:Dagger::1:0:", -- Simple Dagger
	[4566]="0:2:2:1:Stave::1:0:", -- Sturdy Quarterstaff
	[4567]="0:2:2:1:TwoHandSword::1:0:", -- Merc Sword
	[4568]="0:2:2:1:OneHandAxe::1:0:", -- Grunt Axe
	[4569]="0:2:2:1:OneHandMace::1:0:", -- Staunch Hammer
	[4570]="0:2:2:1:TwoHandMace::1:0:", -- Birchwood Maul
	[4571]="0:2:2:1:Dagger::1:0:", -- War Knife
	[4575]="0:2:2:1:Stave::1:0:", -- Medicine Staff
	[4576]="0:2:2:1:Bow::1:0:", -- Light Bow
	[4577]="0:2:2:1:Gun::1:0:", -- Compact Shotgun
	[4580]="0:15:0:10:Junk::1:0:", -- Sabertooth Fang
	[4581]="0:15:0:5:Junk::1:0:", -- Patch of Fine Fur
	[4582]="0:12:1:5:::1:0:", -- Soft Bushy Tail
	[4583]="0:15:0:5:Junk::1:0:", -- Thick Furry Mane
	[4584]="0:15:0:5:Junk::1:0:", -- Large Trophy Paw
	[4585]="0:15:0:5:Junk::1:0:", -- Dripping Spider Mandible
	[4586]="0:15:0:5:Junk::1:0:", -- Smooth Raptor Skin
	[4587]="0:15:0:10:Junk::1:0:", -- Tribal Raptor Feathers
	[4588]="0:15:0:5:Junk::1:0:", -- Pristine Raptor Skull
	[4589]="0:7:1:10:Other:197:1:0:", -- Long Elegant Feather
	[4590]="0:15:0:5:Junk::1:0:", -- Curved Yellow Bill
	[4591]="0:15:0:5:Junk::1:0:", -- Eagle Eye
	[4592]="20:0:1:20:FoodDrink::5:0:1678,1684,2842,3086,3178,3497,3540,4200,4221,4305,4307,5814,6727,6738,6791,6807,7943,8137,8931,11187,12962,14731,16618,16739,17553,17656,19045,23896,24834,24993,25012,25020,25052,25089,29291", -- Longjaw Mud Snapper
	[4593]="500:0:1:20:FoodDrink::5:0:1678,1684,2842,3086,3178,3497,3540,4200,4221,4305,4307,5814,6727,6738,6791,6807,7943,8137,8931,11187,12962,14731,16618,16739,17553,17656,19045,23896,24834,24993,25012,25020,25052,25089,29291", -- Bristle Whisker Catfish
	[4594]="1000:0:1:20:FoodDrink::5:0:1678,1684,2842,3086,3178,3497,3540,4200,4221,4305,4307,5814,6727,6738,6791,6807,7943,8137,8931,11187,12962,14731,16618,16739,17553,17656,19045,23896,24834,24993,25012,25020,25052,25089,29291", -- Rockscale Cod
	[4595]="300:0:1:10:FoodDrink::1:0:2832", -- Junglevine Wine
	[4596]="0:0:1:20:Potion::1:0:", -- Discolored Healing Potion
	[4597]="0:9:2:1:Alchemy::1:0:", -- Recipe: Discolored Healing Potion
	[4598]="0:0:1:10:Consumable::1:0:", -- Goblin Fishing Pole
	[4599]="2000:0:1:20:FoodDrink::5:0:982,1464,2365,2388,2814,3025,3089,3312,3368,3411,3489,3621,3705,3881,3882,3933,3935,3960,4084,4169,4782,4875,4879,4891,4894,4954,5111,5124,5611,5620,5870,6928,6929,7485,7731,7733,8125,9356,11118,11187,12196,12959,14624,14963,14964,15124,15125,15174,15397,16443,16618,16739,17553,17630,17656,19182,23263,23481,23605,24208,24291,24343", -- Cured Ham Steak
	[4600]="340:0:1:20:FoodDrink::1:0:2832,4782,5570,19617,20377,24333,24834,24993,25012,25020,25052,25089,29291", -- Cherry Grog
	[4601]="2000:0:1:20:FoodDrink::5:0:233,1237,1247,1670,2352,2364,2832,3003,3086,3291,3480,3518,3546,3689,3708,3883,3884,3937,3948,3959,4190,4266,4891,4894,5109,5620,6272,6734,6736,6737,6740,6747,7485,7737,7744,7941,8143,8307,11103,11287,15433,16256,16458,16739,17630,23522,23603,24834,24934,24993,25012,25020,25052,25089,29291,33996", -- Soft Banana Bread
	[4602]="2000:0:1:20:FoodDrink::5:0:734,894,1671,3017,3342,3934,3961,4191,4891,5814,6735,6740,7714,7736,7978,14963,14964,15124,15125,16443,16542,17630,21145,23573,24934,29547", -- Moon Harvest Pumpkin
	[4603]="0:7:1:20:Meat:185:1:0:", -- Raw Spotted Yellowtail
	[4604]="25:0:1:20:FoodDrink::5:0:2803,2806,3138,3329,3544,3547,4554,4571,5688,5886,6739,6741,8150,8152,11038,12384,17656", -- Forest Mushroom Cap
	[4605]="125:0:1:20:FoodDrink::5:0:2803,2806,3138,3329,3544,3547,4554,4571,5688,5886,6739,6741,8150,8152,11038,12384,17656", -- Red-speckled Mushroom
	[4606]="500:0:1:20:FoodDrink::5:0:2803,2806,3138,3329,3544,3547,4554,4571,5688,5886,6739,6741,8150,8152,11038,12384,14963,14964,15124,15125,17656", -- Spongy Morel
	[4607]="1000:0:1:20:FoodDrink::5:0:2803,2806,3138,3329,3544,3547,4554,4571,5688,5886,6739,6741,8150,8152,11038,12384,14963,14964,15124,15125,17656", -- Delicious Cave Mold
	[4608]="2000:0:1:20:FoodDrink::5:0:2803,2806,3138,3329,3544,3547,4554,4571,5688,5886,6739,6741,8150,8152,11038,12384,14963,14964,15124,15125,17656", -- Raw Black Truffle
	[4609]="1000:9:1:1:Cooking::1:0:2814,12246", -- Recipe: Barbecued Buzzard Wing
	[4610]="0:12:1:20:::1:0:", -- Carved Stone Urn
	[4611]="0:7:1:20:Other:202:1:0:", -- Blue Pearl
	[4612]="0:12:1:20:::1:0:", -- Black Drake's Heart
	[4613]="0:12:1:1:::1:0:", -- Corroded Black Box
	[4614]="0:4:2:1:Amulet::1:0:", -- Pendant of Myzrael
	[4615]="0:12:1:1:::1:0:", -- Blacklash's Bindings
	[4616]="0:2:1:1:Miscellaneous::1:0:", -- Ryedol's Lucky Pick
	[4621]="0:12:1:1:::1:0:", -- Ambassador Infernus' Bracer
	[4622]="0:12:1:1:::1:0:", -- Sealed Note to Advisor Belgrum
	[4623]="0:0:1:20:Potion::1:0:", -- Lesser Stoneshield Potion
	[4624]="0:9:1:1:Alchemy::1:0:", -- Recipe: Lesser Stoneshield Potion
	[4625]="0:7:1:20:Herb:171,333,197:1:0:", -- Firebloom
	[4626]="0:12:1:20:::1:0:", -- Small Stone Shard
	[4627]="0:12:1:5:::1:0:", -- Large Stone Slab
	[4628]="0:12:1:20:::1:0:", -- Bracers of Rock Binding
	[4629]="0:12:1:20:::1:0:", -- Supply Crate
	[4630]="0:12:1:20:::1:0:", -- Scrap Metal
	[4631]="0:12:1:1:::1:0:", -- Tablet of Ryun'eh
	[4632]="0:15:2:1:Junk::1:0:", -- Ornate Bronze Lockbox
	[4633]="0:15:2:1:Junk::1:0:", -- Heavy Bronze Lockbox
	[4634]="0:15:2:1:Junk::1:0:", -- Iron Lockbox
	[4635]="0:12:1:1:::1:0:", -- Hammertoe's Amulet
	[4636]="0:15:2:1:Junk::1:0:", -- Strong Iron Lockbox
	[4637]="0:15:2:1:Junk::1:0:", -- Steel Lockbox
	[4638]="0:15:2:1:Junk::1:0:", -- Reinforced Steel Lockbox
	[4639]="0:12:1:1:::1:0:", -- Enchanted Sea Kelp
	[4640]="0:12:1:1:::1:0:", -- Sign of the Earth
	[4641]="0:12:1:1:::1:0:", -- Hand of Dagun
	[4643]="0:4:2:1:Cloak::1:0:", -- Grimsteel Cape
	[4644]="0:12:1:1:::1:0:", -- The Legacy Heart
	[4645]="0:12:1:1:::1:0:", -- Chains of Hematus
	[4646]="0:12:1:1:::1:0:", -- Star of Xil'yeh
	[4647]="0:12:1:1:::1:0:", -- Yagyin's Digest
	[4648]="0:12:1:1:::1:0:", -- Sigil of the Hammer
	[4649]="0:12:1:1:::1:0:", -- Bonegrip's Note
	[4650]="0:12:1:1:::1:0:", -- Bel'dugur's Note
	[4652]="0:4:2:1:Shield::1:0:", -- Salbac Shield
	[4653]="0:4:2:1:Mail::1:0:", -- Ironheel Boots
	[4654]="0:12:1:1:::1:0:", -- Mysterious Fossil
	[4655]="0:7:1:20:Meat:185:1:0:", -- Giant Clam Meat
	[4656]="0:0:1:20:FoodDrink::1:0:", -- Small Pumpkin
	[4658]="0:4:1:1:Cloak::1:0:", -- Warrior's Cloak
	[4659]="0:4:1:1:Mail::1:0:", -- Warrior's Girdle
	[4660]="0:4:2:1:Cloth::1:0:", -- Walking Boots
	[4661]="0:4:2:1:Cloth::1:0:", -- Bright Mantle
	[4662]="0:4:1:1:Cloak::1:0:", -- Journeyman's Cloak
	[4663]="0:4:1:1:Cloth::1:0:", -- Journeyman's Belt
	[4665]="0:4:1:1:Cloak::1:0:", -- Burnt Cloak
	[4666]="0:4:1:1:Leather::1:0:", -- Burnt Leather Belt
	[4668]="0:4:1:1:Cloak::1:0:", -- Battle Chain Cloak
	[4669]="0:4:1:1:Mail::1:0:", -- Battle Chain Girdle
	[4671]="0:4:1:1:Cloak::1:0:", -- Ancestral Cloak
	[4672]="0:4:1:1:Cloth::1:0:", -- Ancestral Belt
	[4674]="0:4:1:1:Cloak::1:0:", -- Tribal Cloak
	[4675]="0:4:1:1:Leather::1:0:", -- Tribal Belt
	[4676]="0:4:2:1:Mail::1:0:", -- Skeletal Gauntlets
	[4677]="0:4:1:1:Cloak::1:0:", -- Veteran Cloak
	[4678]="0:4:1:1:Mail::1:0:", -- Veteran Girdle
	[4680]="0:4:1:1:Cloak::1:0:", -- Brackwater Cloak
	[4681]="0:4:1:1:Mail::1:0:", -- Brackwater Girdle
	[4683]="0:4:1:1:Cloak::1:0:", -- Spellbinder Cloak
	[4684]="0:4:1:1:Cloth::1:0:", -- Spellbinder Belt
	[4686]="0:4:1:1:Cloak::1:0:", -- Barbaric Cloth Cloak
	[4687]="0:4:1:1:Cloth::1:0:", -- Barbaric Cloth Belt
	[4689]="0:4:1:1:Cloak::1:0:", -- Hunting Cloak
	[4690]="0:4:1:1:Leather::1:0:", -- Hunting Belt
	[4692]="0:4:1:1:Cloak::1:0:", -- Ceremonial Cloak
	[4693]="0:4:1:1:Leather::1:0:", -- Ceremonial Leather Belt
	[4694]="0:4:1:1:Mail::1:0:", -- Burnished Pauldrons
	[4695]="0:4:2:1:Cloak::1:0:", -- Burnished Cloak
	[4696]="0:4:3:1:OffHandFrill::1:0:", -- Lapidis Tankard of Tidesippe
	[4697]="0:4:2:1:Mail::1:0:", -- Burnished Girdle
	[4698]="0:4:1:1:Cloth::1:0:", -- Seer's Mantle
	[4699]="0:4:2:1:Cloth::1:0:", -- Seer's Belt
	[4700]="0:4:1:1:Leather::1:0:", -- Inscribed Leather Spaulders
	[4701]="0:4:2:1:Cloak::1:0:", -- Inscribed Cloak
	[4702]="0:12:1:20:::1:0:", -- Prospector's Pick
	[4703]="0:12:1:20:::1:0:", -- Broken Tools
	[4705]="0:4:2:1:Mail::1:0:", -- Lambent Scale Pauldrons
	[4706]="0:4:2:1:Cloak::1:0:", -- Lambent Scale Cloak
	[4707]="0:4:2:1:Mail::1:0:", -- Lambent Scale Girdle
	[4708]="0:4:2:1:Cloth::1:0:", -- Bright Belt
	[4709]="0:4:2:1:Leather::1:0:", -- Forest Leather Mantle
	[4710]="0:4:2:1:Cloak::1:0:", -- Forest Cloak
	[4711]="0:4:2:1:Cloak::1:0:", -- Glimmering Cloak
	[4712]="0:4:2:1:Mail::1:0:", -- Glimmering Mail Girdle
	[4713]="0:4:2:1:Cloak::1:0:", -- Silver-thread Cloak
	[4714]="0:4:2:1:Cloth::1:0:", -- Silver-thread Sash
	[4715]="0:4:2:1:Cloak::1:0:", -- Emblazoned Cloak
	[4716]="0:4:2:1:Cloak::1:0:", -- Combat Cloak
	[4717]="0:4:2:1:Mail::1:0:", -- Mail Combat Belt
	[4718]="0:4:2:1:Cloth::1:0:", -- Nightsky Mantle
	[4719]="0:4:2:1:Cloak::1:0:", -- Nightsky Cloak
	[4720]="0:4:2:1:Cloth::1:0:", -- Nightsky Sash
	[4721]="0:4:2:1:Leather::1:0:", -- Insignia Mantle
	[4722]="0:4:2:1:Cloak::1:0:", -- Insignia Cloak
	[4723]="0:4:2:1:Cloth::1:0:", -- Humbert's Pants
	[4724]="0:4:2:1:Leather::1:0:", -- Humbert's Helm
	[4725]="0:4:2:1:Mail::1:0:", -- Chief Brigadier Pauldrons
	[4726]="0:4:2:1:Cloak::1:0:", -- Chief Brigadier Cloak
	[4727]="0:4:2:1:Mail::1:0:", -- Chief Brigadier Girdle
	[4729]="0:4:2:1:Cloth::1:0:", -- Aurora Mantle
	[4731]="0:4:2:1:Leather::1:0:", -- Glyphed Epaulets
	[4732]="0:4:2:1:Cloak::1:0:", -- Glyphed Cloak
	[4733]="0:4:2:1:Mail::1:0:", -- Blackforge Pauldrons
	[4734]="0:4:2:1:Cloth::1:0:", -- Mistscape Mantle
	[4735]="0:4:2:1:Cloak::1:0:", -- Mistscape Cloak
	[4736]="0:4:2:1:Cloth::1:0:", -- Mistscape Sash
	[4737]="0:4:2:1:Leather::1:0:", -- Imperial Leather Spaulders
	[4738]="0:4:2:1:Leather::1:0:", -- Imperial Leather Belt
	[4739]="0:12:1:20:::1:0:", -- Plainstrider Meat
	[4740]="0:12:1:20:::1:0:", -- Plainstrider Feather
	[4741]="0:4:2:1:Mail::1:0:", -- Stromgarde Cavalry Leggings
	[4742]="0:12:1:20:::1:0:", -- Mountain Cougar Pelt
	[4743]="0:4:3:1:Amulet::1:0:", -- Pulsating Crystalline Shard
	[4744]="0:4:2:1:Cloth::1:0:", -- Arcane Runed Bracers
	[4745]="0:4:2:1:Mail::1:0:", -- War Rider Bracers
	[4746]="0:4:2:1:Cloth::1:0:", -- Doomsayer's Robe
	[4751]="0:12:1:20:::1:0:", -- Windfury Talon
	[4752]="0:12:1:20:::1:0:", -- Azure Feather
	[4753]="0:12:1:20:::1:0:", -- Bronze Feather
	[4755]="0:12:1:1:::1:0:", -- Water Pitcher
	[4757]="0:15:0:5:Junk::1:0:", -- Cracked Egg Shells
	[4758]="0:12:1:20:::1:0:", -- Prairie Wolf Paw
	[4759]="0:12:1:20:::1:0:", -- Plainstrider Talon
	[4765]="2878:2:2:1:OneHandSword::1:1:167,3479,3658,3682", -- Enamelled Broadsword
	[4766]="2407:2:2:1:OneHandSword::1:1:167,3479,3658,3682", -- Feral Blade
	[4767]="0:4:2:1:Cloth::1:0:", -- Coppercloth Gloves
	[4768]="0:4:2:1:Cloth::1:0:", -- Adept's Gloves
	[4769]="0:12:1:20:::1:0:", -- Trophy Swoop Quill
	[4770]="0:12:1:20:::1:0:", -- Bristleback Belt
	[4771]="0:4:2:1:Cloak::1:0:", -- Harvest Cloak
	[4772]="0:4:1:1:Cloak::1:0:", -- Warm Cloak
	[4775]="0:15:0:5:Junk::1:0:", -- Cracked Bill
	[4776]="0:15:0:10:Junk::1:0:", -- Ruffled Feather
	[4777]="7040:2:2:1:TwoHandMace::1:1:222,844,2840,3534,3658,3682", -- Ironwood Maul
	[4778]="7351:2:2:1:TwoHandMace::1:1:222,844,2840,3534,3658,3682", -- Heavy Spiked Mace
	[4779]="0:15:0:10:Junk::1:0:", -- Dull Kodo Tooth
	[4780]="0:15:0:5:Junk::1:0:", -- Kodo Horn Fragment
	[4781]="2736:4:2:1:Cloth::1:1:1214,3091,3486,3554,3683", -- Whispering Vest
	[4782]="2077:4:2:1:Cloth::1:1:1214,3091,3486,3554,3683", -- Solstice Robe
	[4783]="0:12:1:1:::1:0:", -- Totem of Hawkwind
	[4784]="0:15:0:5:Junk::1:0:", -- Lifeless Stone
	[4785]="0:4:2:1:Cloth::1:0:", -- Brimstone Belt
	[4786]="1394:4:2:1:Cloth::1:1:1214,3091,3486,3554,3683", -- Wise Man's Belt
	[4787]="0:15:0:5:Junk::1:0:", -- Burning Pitch
	[4788]="2634:4:2:1:Leather::1:1:954,1669,3552,3684", -- Agile Boots
	[4789]="1999:4:2:1:Leather::1:1:954,1669,3552,3684", -- Stable Boots
	[4790]="4159:4:2:1:Cloak::1:1:1454,3096,3486", -- Inferno Cloak
	[4791]="0:0:1:20:FoodDrink::1:0:", -- Enchanted Water
	[4792]="3280:4:2:1:Cloak::1:1:1454,3096,3486", -- Spirit Cloak
	[4793]="3720:4:2:1:Cloak::1:1:1454,3096,3486", -- Sylvan Cloak
	[4794]="3515:4:2:1:Leather::1:1:844,3097,3492,3536", -- Wolf Bracers
	[4795]="3528:4:2:1:Leather::1:1:844,3097,3492,3536", -- Bear Bracers
	[4796]="3540:4:2:1:Leather::1:1:844,3097,3492,3536", -- Owl Bracers
	[4797]="4263:4:2:1:Cloak::1:1:226,3493,3543,3682", -- Fiery Cloak
	[4798]="3871:4:2:1:Cloak::1:1:226,3493,3543,3682", -- Heavy Runed Cloak
	[4799]="3043:4:2:1:Cloak::1:1:226,3493,3543,3682", -- Antiquated Cloak
	[4800]="6110:4:2:1:Mail::1:1:226,3493,3543,3682", -- Mighty Chain Pants
	[4801]="0:12:1:20:::1:0:", -- Stalker Claws
	[4802]="0:12:1:20:::1:0:", -- Cougar Claws
	[4803]="0:12:1:20:::1:0:", -- Prairie Alpha Tooth
	[4804]="0:12:1:1:::1:0:", -- Prairie Wolf Heart
	[4805]="0:12:1:1:::1:0:", -- Flatland Cougar Femur
	[4806]="0:12:1:1:::1:0:", -- Plainstrider Scale
	[4807]="0:12:1:1:::1:0:", -- Swoop Gizzard
	[4808]="0:12:1:20:::1:0:", -- Well Stone
	[4809]="0:12:1:20:::1:0:", -- Ambercorn
	[4810]="0:4:2:1:Leather::1:0:", -- Boulder Pads
	[4813]="0:15:0:10:Junk::1:0:", -- Small Leather Collar
	[4814]="0:15:0:5:Junk::1:0:", -- Discolored Fang
	[4816]="7519:4:2:1:Mail::1:1:226,3493,3543,3682", -- Legionnaire's Leggings
	[4817]="12311:2:2:1:TwoHandSword::1:1:844,1441,3534,3539,4086,4890", -- Blessed Claymore
	[4818]="14273:2:2:1:TwoHandSword::1:1:844,1441,3534,3539,4086,4890", -- Executioner's Sword
	[4819]="0:12:1:1:::1:0:", -- Fizsprocket's Clipboard
	[4820]="8321:4:2:1:Shield::1:1:793,3493", -- Guardian Buckler
	[4821]="6541:4:2:1:Shield::1:1:793,3493", -- Bear Buckler
	[4822]="6746:4:2:1:Shield::1:1:793,3493", -- Owl's Disk
	[4823]="0:12:1:1:::1:0:", -- Water of the Seers
	[4824]="16856:2:2:1:OneHandAxe::1:1:1307,3180,3539,4890", -- Blurred Axe
	[4825]="20472:2:2:1:OneHandAxe::1:1:1307,3180,3539,4890", -- Callous Axe
	[4826]="15436:2:2:1:OneHandAxe::1:1:1307,3180,3539,4890", -- Marauder Axe
	[4827]="3749:4:2:1:Cloth::1:1:1307,1454,2679,3134,3537,4085", -- Wizard's Belt
	[4828]="3420:4:2:1:Cloth::1:1:1307,1454,2679,3134,3537,4085", -- Nightwind Belt
	[4829]="4154:4:2:1:Cloth::1:1:1307,1454,2679,3134,3537,4085", -- Dreamer's Belt
	[4830]="9475:4:2:1:Leather::1:1:2679,3180,3536,4085,4890", -- Saber Leggings
	[4831]="7859:4:2:1:Leather::1:1:2679,3180,3536,4085,4890", -- Stalking Pants
	[4832]="10498:4:2:1:Leather::1:1:2679,3180,3536,4085,4890", -- Mystic Sarong
	[4833]="8658:4:2:1:Mail::1:1:2679,3180,3543,4085", -- Glorious Shoulders
	[4834]="0:12:1:1:::1:0:", -- Venture Co. Documents
	[4835]="10551:4:2:1:Mail::1:1:2679,3180,3543,4085", -- Elite Shoulders
	[4836]="8002:4:2:1:OffHandFrill::1:1:3134,3537,4086", -- Fireproof Orb
	[4837]="8002:4:2:1:OffHandFrill::1:1:3134,3537,4086", -- Strength of Will
	[4838]="8002:4:2:1:OffHandFrill::1:1:3134,3537,4086", -- Orb of Power
	[4840]="0:2:1:1:Dagger::1:0:", -- Long Bayonet
	[4841]="0:12:1:1:::1:0:", -- Horn of Arra'chea
	[4843]="0:12:1:1:::1:0:", -- Amethyst Runestone
	[4844]="0:12:1:1:::1:0:", -- Opal Runestone
	[4845]="0:12:1:1:::1:0:", -- Diamond Runestone
	[4846]="0:12:1:1:::1:0:", -- Cog #5
	[4847]="0:12:1:1:::1:0:", -- Lotwil's Shackles of Elemental Binding
	[4848]="0:12:1:20:::1:0:", -- Battleboar Snout
	[4849]="0:12:1:20:::1:0:", -- Battleboar Flank
	[4850]="0:12:1:1:::1:0:", -- Bristleback Attack Plans
	[4851]="0:12:1:1:::1:0:", -- Dirt-stained Map
	[4852]="0:7:1:20:Explosive::1:0:", -- Flash Bomb
	[4854]="0:4:1:1:Cloak::1:0:", -- Demon Scarred Cloak
	[4859]="0:12:1:1:::1:0:", -- Burning Blade Medallion
	[4860]="0:15:0:5:Junk::1:0:", -- Glistening Frenzy Scale
	[4861]="0:4:2:1:Leather::1:0:", -- Sleek Feathered Tunic
	[4862]="0:12:1:20:::1:0:", -- Scorpid Worker Tail
	[4863]="0:12:1:20:::1:0:", -- Gnomish Tools
	[4864]="0:12:1:10:::1:0:", -- Minshina's Skull
	[4865]="0:15:0:5:Junk::1:0:", -- Ruined Pelt
	[4866]="0:12:1:1:::1:0:", -- Zalazane's Head
	[4867]="0:15:0:5:Junk::1:0:", -- Broken Scorpid Leg
	[4869]="0:12:1:1:::1:0:", -- Fizzle's Claw
	[4870]="0:12:1:20:::1:0:", -- Canvas Scraps
	[4871]="0:12:1:20:::1:0:", -- Searing Collar
	[4872]="0:15:0:5:Junk::1:0:", -- Dry Scorpid Eye
	[4873]="0:15:0:5:Junk::1:0:", -- Dry Hardened Barnacle
	[4874]="0:15:0:5:Junk::1:0:", -- Clean Fishbones
	[4875]="0:15:0:5:Junk::1:0:", -- Slimy Bone
	[4876]="0:15:0:5:Junk::1:0:", -- Bloody Leather Boot
	[4877]="0:15:0:5:Junk::1:0:", -- Stone Arrowhead
	[4878]="0:15:0:1:Junk::1:0:", -- Broken Bloodstained Bow
	[4879]="0:15:0:5:Junk::1:0:", -- Squashed Rabbit Carcass
	[4880]="0:15:0:5:Junk::1:0:", -- Broken Spear
	[4881]="0:12:1:1:::1:0:", -- Aged Envelope
	[4882]="0:13:1:1:::1:0:", -- Benedict's Key
	[4883]="0:12:1:1:::1:0:", -- Admiral Proudmoore's Orders
	[4886]="0:12:1:20:::1:0:", -- Venomtail Poison Sac
	[4887]="0:12:1:20:::1:0:", -- Intact Makrura Eye
	[4888]="0:12:1:20:::1:0:", -- Crawler Mucus
	[4890]="0:12:1:20:::1:0:", -- Taillasher Egg
	[4891]="0:12:1:1:::1:0:", -- Kron's Amulet
	[4892]="0:12:1:20:::1:0:", -- Durotar Tiger Fur
	[4893]="0:12:1:20:::1:0:", -- Savannah Lion Tusk
	[4894]="0:12:1:20:::1:0:", -- Plainstrider Kidney
	[4895]="0:12:1:1:::1:0:", -- Thunder Lizard Horn
	[4896]="0:12:1:20:::1:0:", -- Kodo Liver
	[4897]="0:12:1:20:::1:0:", -- Thunderhawk Saliva Gland
	[4898]="0:12:1:20:::1:0:", -- Lightning Gland
	[4903]="0:12:1:1:::1:0:", -- Eye of Burning Shadow
	[4904]="0:12:1:20:::1:0:", -- Venomtail Antidote
	[4905]="0:12:1:1:::1:0:", -- Sarkoth's Mangled Claw
	[4906]="0:4:1:1:Leather::1:0:", -- Rainwalker Boots
	[4907]="0:4:1:1:Leather::1:0:", -- Woodland Tunic
	[4908]="0:4:1:1:Leather::1:0:", -- Nomadic Bracers
	[4909]="0:4:2:1:Leather::1:0:", -- Kodo Hunter's Leggings
	[4910]="0:4:1:1:Mail::1:0:", -- Painted Chain Gloves
	[4911]="0:4:1:1:Shield::1:0:", -- Thick Bark Buckler
	[4913]="0:4:1:1:Mail::1:0:", -- Painted Chain Belt
	[4914]="0:4:1:1:Leather::1:0:", -- Battleworn Leather Gloves
	[4915]="0:4:1:1:Cloth::1:0:", -- Soft Wool Boots
	[4916]="0:4:1:1:Cloth::1:0:", -- Soft Wool Vest
	[4917]="0:4:1:1:Mail::1:0:", -- Battleworn Chain Leggings
	[4918]="0:12:1:20:::1:0:", -- Sack of Supplies
	[4919]="0:4:1:1:Cloth::1:0:", -- Soft Wool Belt
	[4920]="0:4:1:1:Cloak::1:0:", -- Battleworn Cape
	[4921]="0:4:1:1:Leather::1:0:", -- Dust-covered Leggings
	[4922]="0:4:1:1:Mail::1:0:", -- Jagged Chain Vest
	[4923]="0:2:1:1:OneHandAxe::1:0:", -- Primitive Hatchet
	[4924]="0:2:1:1:OneHandMace::1:0:", -- Primitive Club
	[4925]="0:2:1:1:Dagger::1:0:", -- Primitive Hand Blade
	[4926]="0:12:1:1:::1:0:", -- Chen's Empty Keg
	[4928]="0:4:1:1:Leather::1:0:", -- Sandrunner Wristguards
	[4929]="0:4:1:1:Leather::1:0:", -- Light Scorpid Armor
	[4931]="0:2:1:1:Bow::1:0:", -- Hickory Shortbow
	[4932]="0:2:1:1:OneHandSword::1:0:", -- Harpy Wing Clipper
	[4933]="0:4:1:1:Cloak::1:0:", -- Seasoned Fighter's Cloak
	[4935]="0:4:1:1:Mail::1:0:", -- Wide Metal Girdle
	[4936]="0:4:1:1:Cloth::1:0:", -- Dirt-trodden Boots
	[4937]="0:4:1:1:Shield::1:0:", -- Charging Buckler
	[4938]="0:2:1:1:Stave::1:0:", -- Blemished Wooden Staff
	[4939]="0:2:2:1:TwoHandSword::1:0:", -- Steady Bastard Sword
	[4940]="0:4:1:1:Leather::1:0:", -- Veiled Grips
	[4941]="0:0:1:20:Consumable::1:0:", -- Really Sticky Glue
	[4942]="0:4:1:1:Leather::1:0:", -- Tiger Hide Boots
	[4944]="0:4:1:1:Cloak::1:0:", -- Handsewn Cloak
	[4945]="0:0:1:1:Consumable::1:0:", -- Faintly Glowing Skull
	[4946]="0:4:1:1:Mail::1:0:", -- Lightweight Boots
	[4947]="0:2:2:1:Dagger::1:0:", -- Jagged Dagger
	[4948]="0:2:2:1:OneHandMace::1:0:", -- Stinging Mace
	[4949]="0:2:2:1:OneHandAxe::1:0:", -- Orcish Cleaver
	[4951]="0:4:1:1:Leather::1:0:", -- Squealer's Belt
	[4952]="0:0:1:10:Consumable::1:0:", -- Stormstout
	[4953]="0:0:1:10:Consumable::1:0:", -- Trogg Ale
	[4954]="0:4:1:1:Leather::1:0:", -- Nomadic Belt
	[4957]="0:1:1:1:Bag::1:0:", -- Old Moneybag
	[4958]="0:4:1:1:Cloak::1:0:", -- Sun-beaten Cloak
	[4960]="0:6:1:1000:Bullet::1:0:", -- Flash Pellet
	[4961]="0:2:1:1:Stave::1:0:", -- Dreamwatcher Staff
	[4962]="0:4:1:1:Leather::1:0:", -- Double-layered Gloves
	[4963]="0:4:1:1:Cloak::1:0:", -- Thunderhorn Cloak
	[4964]="0:2:2:1:TwoHandMace::1:0:", -- Goblin Smasher
	[4967]="0:4:1:1:Shield::1:0:", -- Tribal Warrior's Shield
	[4968]="0:4:1:1:Leather::1:0:", -- Bound Harness
	[4969]="0:4:1:1:Mail::1:0:", -- Fortified Bindings
	[4970]="0:4:1:1:Leather::1:0:", -- Rough-hewn Kodo Leggings
	[4971]="0:2:2:1:OneHandMace::1:0:", -- Skorn's Hammer
	[4972]="0:4:1:1:Mail::1:0:", -- Cliff Runner Boots
	[4973]="0:4:1:1:Leather::1:0:", -- Plains Hunter Wristguards
	[4974]="0:2:2:1:Dagger::1:0:", -- Compact Fighting Knife
	[4975]="0:4:3:1:Shield::1:0:", -- Vigilant Buckler
	[4976]="0:4:2:1:Leather::1:0:", -- Mistspray Kilt
	[4977]="0:2:2:1:OneHandSword::1:0:", -- Sword of Hammerfall
	[4978]="0:2:2:1:OneHandMace::1:0:", -- Ryedol's Hammer
	[4979]="0:4:2:1:Cloth::1:0:", -- Enchanted Stonecloth Bracers
	[4980]="0:4:2:1:Leather::1:0:", -- Prospector Gloves
	[4982]="0:4:0:1:Leather::1:0:", -- Ripped Prospector Belt
	[4983]="0:2:2:1:TwoHandMace::1:0:", -- Rock Pulverizer
	[4984]="0:4:2:1:OffHandFrill::1:0:", -- Skull of Impending Doom
	[4986]="0:12:1:1:::1:0:", -- Flawed Power Stone
	[4987]="0:2:2:1:OneHandSword::1:0:", -- Dwarf Captain's Sword
	[4992]="0:12:1:1:::1:0:", -- Recruitment Letter
	[4995]="0:12:1:1:::1:0:", -- Signed Recruitment Letter
	[4998]="0:4:2:1:Ring::1:0:", -- Blood Ring
	[4999]="0:4:2:1:Ring::1:0:", -- Azora's Will
	[5001]="0:4:2:1:Ring::1:0:", -- Heart Ring
	[5002]="0:4:2:1:Amulet::1:0:", -- Glowing Green Talisman
	[5003]="0:4:2:1:Amulet::1:0:", -- Crystal Starfire Medallion
	[5005]="0:4:2:1:Amulet::1:0:", -- Emberspark Pendant
	[5006]="0:12:1:1:::1:0:", -- Khazgorm's Journal
	[5007]="0:4:2:1:Ring::1:0:", -- Band of Thorns
	[5009]="0:4:2:1:Ring::1:0:", -- Mindbender Loop
	[5011]="0:4:2:1:Ring::1:0:", -- Welken Ring
	[5012]="0:12:1:20:::1:0:", -- Fungal Spores
	[5016]="0:4:2:1:Cloth::1:0:", -- Artisan's Trousers
	[5017]="0:12:1:20:::1:0:", -- Nitroglycerin
	[5018]="0:12:1:20:::1:0:", -- Wood Pulp
	[5019]="0:12:1:20:::1:0:", -- Sodium Nitrate
	[5020]="0:13:1:1:::1:0:", -- Kolkar Booty Key
	[5021]="0:12:1:1:::1:0:", -- Explosive Stick of Gann
	[5022]="0:12:1:1:::1:0:", -- Barak's Head
	[5023]="0:12:1:1:::1:0:", -- Verog's Head
	[5025]="0:12:1:1:::1:0:", -- Hezrul's Head
	[5026]="0:12:1:1:::1:0:", -- Fire Tar
	[5027]="0:12:1:1:::1:0:", -- Rendered Spores
	[5028]="0:4:2:1:OffHandFrill::1:0:", -- Lord Sakrasis' Scepter
	[5029]="0:4:2:1:Amulet::1:0:", -- Talisman of the Naga Lord
	[5030]="0:12:1:20:::1:0:", -- Centaur Bracers
	[5038]="0:12:1:1:::1:0:", -- Tear of the Moons
	[5040]="0:2:1:1:Dagger::1:0:", -- Shadow Hunter Knife
	[5042]="50:0:1:10:Other::1:0:151,491,1250,1285,1682,1685,1691,2134,2140,3076,3164,3186,3313,3481,3608,4170,4182,4241,8362,16187,16191,16259,16260,16444,16732,17421,17446,17489,18810,19197", -- Red Ribboned Wrapping Paper
	[5043]="0:0:1:1:Other::1:0:", -- Red Ribboned Gift
	[5044]="0:0:1:1:Other::1:0:", -- Blue Ribboned Gift
	[5048]="50:0:1:10:Other::1:0:791,1285,3313,3498,4082,4084,4555,7942,8362,12027,12960,16191,16732,17489,18811,19197", -- Blue Ribboned Wrapping Paper
	[5050]="0:13:1:1:::1:0:", -- Ignition Key
	[5051]="1:12:1:20::185:1:1:3443", -- Dig Rat
	[5052]="0:15:1:1:CombatPet::1:0:", -- Unconscious Dig Rat
	[5054]="0:12:1:1:::1:0:", -- Samophlange
	[5055]="0:12:1:20:::1:0:", -- Intact Raptor Horn
	[5056]="0:12:1:20:::1:0:", -- Root Sample
	[5057]="0:0:1:20:FoodDrink::1:0:", -- Ripe Watermelon
	[5058]="0:12:1:20:::1:0:", -- Silithid Egg
	[5059]="0:15:1:1:CombatPet::1:0:", -- Digging Claw
	[5060]="0:15:1:1:Reagent::1:0:", -- Thieves' Tools
	[5061]="0:12:1:20:::1:0:", -- Stolen Silver
	[5062]="0:12:1:20:::1:0:", -- Raptor Head
	[5063]="0:12:1:1:::1:0:", -- Kreenig Snarlsnout's Tusk
	[5064]="0:12:1:20:::1:0:", -- Witchwing Talon
	[5065]="0:12:1:20:::1:0:", -- Harpy Lieutenant Ring
	[5066]="0:0:1:10:FoodDrink::1:0:", -- Fissure Plant
	[5067]="0:12:1:1:::1:0:", -- Serena's Head
	[5068]="0:12:1:1:::1:0:", -- Dried Seeds
	[5069]="0:2:2:1:Wand::1:0:", -- Fire Wand
	[5071]="0:2:2:1:Wand::1:0:", -- Shadow Wand
	[5072]="0:12:1:1:::1:0:", -- Lok's Skull
	[5073]="0:12:1:1:::1:0:", -- Nak's Skull
	[5074]="0:12:1:1:::1:0:", -- Kuz's Skull
	[5075]="0:12:1:10:::1:0:", -- Blood Shard
	[5076]="0:12:1:20:::1:0:", -- Shipment of Boots
	[5077]="0:12:1:20:::1:0:", -- Telescopic Lens
	[5078]="0:12:1:20:::1:0:", -- Theramore Medal
	[5079]="0:4:2:1:Trinket::1:0:", -- Cold Basilisk Eye
	[5080]="0:12:1:10:::1:0:", -- Gazlowe's Ledger
	[5081]="0:1:1:1:Bag::1:0:", -- Kodo Hide Bag
	[5082]="0:7:1:10:Leather:165:1:0:", -- Thin Kodo Leather
	[5083]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Kodo Hide Bag
	[5084]="0:12:1:1:::1:0:", -- Baron Longshore's Head
	[5085]="0:12:1:60:::1:0:", -- Bristleback Quilboar Tusk
	[5086]="0:12:1:20:::1:0:", -- Zhevra Hooves
	[5087]="0:12:1:20:::1:0:", -- Plainstrider Beak
	[5088]="0:12:1:1:::1:0:", -- Control Console Operating Manual
	[5089]="0:13:1:1:::1:0:", -- Console Key
	[5092]="0:2:1:1:Wand::1:0:", -- Charred Razormane Wand
	[5093]="0:2:1:1:Dagger::1:0:", -- Razormane Backstabber
	[5094]="0:4:1:1:Shield::1:0:", -- Razormane War Shield
	[5095]="0:0:1:20:FoodDrink::1:0:", -- Rainbow Fin Albacore
	[5096]="0:12:1:20:::1:0:", -- Prowler Claws
	[5097]="0:12:1:1:::1:0:", -- Cats Eye Emerald
	[5098]="0:12:1:20:::1:0:", -- Altered Snapjaw Shell
	[5099]="0:12:1:1:::1:0:", -- Hoof of Lakota'mani
	[5100]="0:12:1:1:::1:0:", -- Echeyakee's Hide
	[5101]="0:12:1:1:::1:0:", -- Ishamuhale's Fang
	[5102]="0:12:1:1:::1:0:", -- Owatanka's Tailspike
	[5103]="0:12:1:1:::1:0:", -- Washte Pawne's Feather
	[5104]="0:12:1:1:::1:0:", -- Heart of Isha Awak
	[5105]="0:15:1:20:Junk::1:0:", -- Explosive Shell
	[5107]="0:4:1:1:Shirt::1:0:", -- Deckhand's Shirt
	[5109]="0:4:1:1:Cloth::1:0:", -- Stonesplinter Rags
	[5110]="0:4:1:1:Cloth::1:0:", -- Dalaran Wizard's Robe
	[5111]="0:4:2:1:Cloak::1:0:", -- Rathorian's Cape
	[5112]="0:2:2:1:Dagger::1:0:", -- Ritual Blade
	[5113]="0:15:0:5:Junk::1:0:", -- Mark of the Syndicate
	[5114]="0:15:0:5:Junk::1:0:", -- Severed Talon
	[5115]="0:15:0:5:Junk::1:0:", -- Broken Wishbone
	[5116]="0:7:0:10:Leather::1:0:", -- Long Tail Feather
	[5117]="0:12:1:10:::1:0:", -- Vibrant Plume
	[5118]="0:15:0:10:Junk::1:0:", -- Large Flat Tooth
	[5119]="0:15:0:10:Junk::1:0:", -- Fine Loose Hair
	[5120]="0:15:0:5:Junk::1:0:", -- Long Tail Hair
	[5121]="0:15:0:5:Junk::1:0:", -- Dirty Kodo Scale
	[5122]="0:15:0:10:Junk::1:0:", -- Thick Kodo Hair
	[5123]="0:15:0:5:Junk::1:0:", -- Steel Arrowhead
	[5124]="0:15:0:10:Junk::1:0:", -- Small Raptor Tooth
	[5125]="0:15:0:5:Junk::1:0:", -- Charged Scale
	[5128]="0:15:0:5:Junk::1:0:", -- Shed Lizard Skin
	[5133]="0:15:0:5:Junk::1:0:", -- Seeping Gizzard
	[5134]="0:12:1:5:::1:0:", -- Small Furry Paw
	[5135]="0:15:0:5:Junk::1:0:", -- Thin Black Claw
	[5136]="0:15:0:5:Junk::1:0:", -- Torn Furry Ear
	[5137]="0:15:0:5:Junk::1:0:", -- Bright Eyeball
	[5138]="0:12:1:1:::1:0:", -- Harvester's Head
	[5140]="0:15:0:20:Reagent::1:0:", -- Flash Powder
	[5143]="0:12:1:20:::1:0:", -- Thunder Lizard Blood
	[5164]="0:12:1:1:::1:0:", -- Thunderhawk Wings
	[5165]="0:12:1:20:::1:0:", -- Sunscale Feather
	[5166]="0:12:1:20:::1:0:", -- Webwood Venom Sac
	[5167]="0:12:1:20:::1:0:", -- Webwood Egg
	[5168]="0:12:1:20:::1:0:", -- Timberling Seed
	[5169]="0:12:1:20:::1:0:", -- Timberling Sprout
	[5170]="0:12:1:20:::1:0:", -- Mossy Tumor
	[5173]="0:15:0:20:Junk::1:0:", -- Deathweed
	[5175]="0:15:1:1:Reagent::1:0:", -- Earth Totem
	[5176]="0:15:1:1:Reagent::1:0:", -- Fire Totem
	[5177]="0:15:1:1:Reagent::1:0:", -- Water Totem
	[5178]="0:15:1:1:Reagent::1:0:", -- Air Totem
	[5179]="0:12:1:1:::1:0:", -- Moss-twined Heart
	[5180]="0:4:2:1:Amulet::1:0:", -- Necklace of Harmony
	[5181]="0:4:2:1:Cloak::1:0:", -- Vibrant Silk Cape
	[5182]="0:2:2:1:TwoHandSword::1:0:", -- Shiver Blade
	[5183]="0:4:3:1:OffHandFrill::1:0:", -- Pulsating Hydra Heart
	[5184]="0:12:1:1:::1:0:", -- Filled Crystal Phial
	[5185]="0:12:1:1:::1:0:", -- Crystal Phial
	[5186]="0:12:1:1:::1:0:", -- Partially Filled Vessel
	[5187]="0:2:3:1:TwoHandMace::1:0:", -- Rhahk'Zor's Hammer
	[5188]="0:12:1:1:::1:0:", -- Filled Vessel
	[5189]="0:12:1:1:::1:0:", -- Glowing Fruit
	[5190]="0:12:1:1:::1:0:", -- Shimmering Frond
	[5191]="0:2:3:1:OneHandSword::1:0:", -- Cruel Barb
	[5192]="0:2:3:1:OneHandSword::1:0:", -- Thief's Blade
	[5193]="0:4:3:1:Cloak::1:0:", -- Cape of the Brotherhood
	[5194]="0:2:3:1:TwoHandAxe::1:0:", -- Taskmaster Axe
	[5195]="0:4:3:1:Cloth::1:0:", -- Gold-flecked Gloves
	[5196]="0:2:3:1:OneHandAxe::1:0:", -- Smite's Reaver
	[5197]="0:2:3:1:OneHandMace::1:0:", -- Cookie's Tenderizer
	[5198]="0:2:3:1:Wand::1:0:", -- Cookie's Stirring Rod
	[5199]="0:4:3:1:Leather::1:0:", -- Smelting Pants
	[5200]="0:2:3:1:Polearm::1:0:", -- Impaling Harpoon
	[5201]="0:2:3:1:Stave::1:0:", -- Emberstone Staff
	[5202]="0:4:3:1:Cloth::1:0:", -- Corsair's Overshirt
	[5203]="0:12:1:20:::1:0:", -- Flatland Prowler Claw
	[5204]="0:12:1:20:::1:0:", -- Bloodfeather Belt
	[5205]="0:0:1:10:Other::1:0:", -- Sprouted Frond
	[5206]="0:0:1:10:Other::1:0:", -- Bogling Root
	[5207]="0:2:2:1:Wand::1:0:", -- Opaque Wand
	[5208]="3340:2:1:1:Wand::1:0:1312,5133,5754,5816,16632,16636,19236,27943", -- Smoldering Wand
	[5209]="3855:2:1:1:Wand::1:0:1312,5133,5754,5816,16632,16636,19236,27943", -- Gloom Wand
	[5210]="5808:2:1:1:Wand::1:0:1312,5133,5754,5816,16632,16636,19236,27943", -- Burning Wand
	[5211]="5830:2:1:1:Wand::1:0:1312,5133,5754,5816,16632,16636,19236,27943", -- Dusk Wand
	[5212]="0:2:2:1:Wand::1:0:", -- Blazing Wand
	[5213]="0:2:2:1:Wand::1:0:", -- Scorching Wand
	[5214]="0:2:2:1:Wand::1:0:", -- Wand of Eventide
	[5215]="0:2:2:1:Wand::1:0:", -- Ember Wand
	[5216]="0:2:2:1:Wand::1:0:", -- Umbral Wand
	[5217]="0:12:1:1:::1:0:", -- Tainted Heart
	[5218]="0:12:1:1:::1:0:", -- Cleansed Timberling Heart
	[5219]="0:12:1:1:::1:0:", -- Inscribed Bark
	[5220]="0:12:1:20:::1:0:", -- Gnarlpine Fang
	[5221]="0:12:1:1:::1:0:", -- Melenas' Head
	[5232]="0:0:1:1:Consumable::1:0:", -- Minor Soulstone
	[5233]="0:12:1:1:::1:0:", -- Stone of Relu
	[5234]="0:12:1:1:::1:0:", -- Flagongut's Fossil
	[5236]="14394:2:1:1:Wand::1:0:1312,5133,5754,5816,16632,16636,19236,27943", -- Combustible Wand
	[5237]="40:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,23732,24148,24313,24349,24357,24780,25043,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,33630,33674,37904,37935", -- Mind-numbing Poison
	[5238]="35727:2:1:1:Wand::1:0:1312,5133,5754,5816,16632,16636,19236,27943", -- Pitchwood Wand
	[5239]="38731:2:1:1:Wand::1:0:1312,5133,5754,5816,16632,16636,19236,27943", -- Blackbone Wand
	[5240]="0:2:2:1:Wand::1:0:", -- Torchlight Wand
	[5241]="0:2:2:1:Wand::1:0:", -- Dwarven Flamestick
	[5242]="0:2:2:1:Wand::1:0:", -- Cinder Wand
	[5243]="0:2:3:1:Wand::1:0:", -- Firebelcher
	[5244]="0:2:2:1:Wand::1:0:", -- Consecrated Wand
	[5245]="0:2:2:1:Wand::1:0:", -- Summoner's Wand
	[5246]="0:2:2:1:Wand::1:0:", -- Excavation Rod
	[5247]="0:2:2:1:Wand::1:0:", -- Rod of Sorrow
	[5248]="0:2:2:1:Wand::1:0:", -- Flash Wand
	[5249]="0:2:2:1:Wand::1:0:", -- Burning Sliver
	[5250]="0:2:2:1:Wand::1:0:", -- Charred Wand
	[5251]="0:12:1:1:::1:0:", -- Phial of Scrying
	[5252]="0:2:2:1:Wand::1:0:", -- Wand of Decay
	[5253]="0:2:2:1:Wand::1:0:", -- Goblin Igniter
	[5254]="0:4:3:1:Leather::1:0:", -- Rugged Spaulders
	[5256]="0:2:2:1:OneHandMace::1:0:", -- Kovork's Rattle
	[5257]="0:4:3:1:Cloak::1:0:", -- Dark Hooded Cape
	[5263]="0:15:0:10:Junk::1:0:", -- Pocket Lint
	[5266]="0:4:3:1:Ring::1:0:", -- Eye of Adaegus
	[5267]="0:2:3:1:Dagger::1:0:", -- Scarlet Kris
	[5268]="0:15:0:5:Junk::1:0:", -- Cracked Silithid Shell
	[5269]="0:15:0:5:Junk::1:0:", -- Silithid Ichor
	[5270]="0:12:1:20:::1:0:", -- Death Cap
	[5271]="0:12:1:20:::1:0:", -- Scaber Stalk
	[5272]="0:12:1:1:::1:0:", -- Insane Scribbles
	[5273]="0:12:1:20:::1:0:", -- Mathystra Relic
	[5274]="0:4:2:1:Cloth::1:0:", -- Rose Mantle
	[5275]="0:4:2:1:Leather::1:0:", -- Binding Girdle
	[5279]="0:2:2:1:Dagger::1:0:", -- Harpy Skinner
	[5299]="0:4:2:1:Leather::1:0:", -- Gloves of the Moon
	[5302]="0:4:2:1:Shield::1:0:", -- Cobalt Buckler
	[5306]="0:2:2:1:Stave::1:0:", -- Wind Rider Staff
	[5309]="0:2:2:1:Gun::1:0:", -- Privateer Musket
	[5310]="0:4:2:1:Cloth::1:0:", -- Sea Dog Britches
	[5311]="0:4:2:1:Leather::1:0:", -- Buckled Boots
	[5312]="0:4:2:1:Mail::1:0:", -- Riveted Gauntlets
	[5313]="0:4:2:1:Ring::1:0:", -- Totemic Clan Ring
	[5314]="0:4:2:1:Cloak::1:0:", -- Boar Hunter's Cape
	[5315]="0:4:2:1:Cloth::1:0:", -- Timberland Armguards
	[5316]="0:4:2:1:Leather::1:0:", -- Barkshell Tunic
	[5317]="0:4:2:1:Leather::1:0:", -- Dry Moss Tunic
	[5318]="0:2:2:1:TwoHandAxe::1:0:", -- Zhovur Axe
	[5319]="0:4:1:1:Leather::1:0:", -- Bashing Pauldrons
	[5320]="0:4:2:1:Mail::1:0:", -- Padded Lamellar Boots
	[5321]="0:2:2:1:OneHandSword::1:0:", -- Elegant Shortsword
	[5322]="0:2:2:1:TwoHandMace::1:0:", -- Demolition Hammer
	[5323]="0:4:2:1:OffHandFrill::1:0:", -- Everglow Lantern
	[5324]="0:2:2:1:OneHandMace::1:0:", -- Engineer's Hammer
	[5325]="0:4:2:1:Shield::1:0:", -- Welding Shield
	[5326]="0:2:2:1:Wand::1:0:", -- Flaring Baton
	[5327]="0:4:2:1:Leather::1:0:", -- Greasy Tinker's Pants
	[5328]="0:4:2:1:Mail::1:0:", -- Cinched Belt
	[5329]="0:15:0:20:Junk::1:0:", -- Cat Figurine
	[5332]="0:15:1:1:CombatPet::1:0:", -- Glowing Cat Figurine
	[5334]="0:12:1:1:::1:0:", -- 99-Year-Old Port
	[5335]="0:15:1:1:Junk::1:0:", -- A Sack of Coins
	[5336]="0:12:1:20:::1:0:", -- Grell Earring
	[5337]="0:4:2:1:Cloth::1:0:", -- Wayfaring Gloves
	[5338]="0:12:1:1:::1:0:", -- Ancient Moonstone Seal
	[5339]="0:12:1:20:::1:0:", -- Serpentbloom
	[5340]="0:2:2:1:Stave::1:0:", -- Cauldron Stirrer
	[5341]="0:4:2:1:Leather::1:0:", -- Spore-covered Tunic
	[5342]="0:0:1:10:FoodDrink::1:0:", -- Raptor Punch
	[5343]="0:4:2:1:Cloak::1:0:", -- Barkeeper's Cloak
	[5344]="0:2:2:1:OneHandAxe::1:0:", -- Pointed Axe
	[5345]="0:2:2:1:TwoHandMace::1:0:", -- Stonewood Hammer
	[5346]="0:2:2:1:Bow::1:0:", -- Orcish Battle Bow
	[5347]="15713:2:1:1:Wand::1:0:1312,5133,5754,5816,16632,16636,19236,27943", -- Pestilent Wand
	[5348]="0:12:1:20:::1:0:", -- Worn Parchment
	[5349]="0:0:1:20:FoodDrink::1:0:", -- Conjured Muffin
	[5350]="0:0:1:20:FoodDrink::1:0:", -- Conjured Water
	[5351]="0:4:2:1:Ring::1:0:", -- Bounty Hunter's Ring
	[5352]="0:12:1:1:::1:0:", -- Book: The Powers Below
	[5354]="0:12:1:1:::1:0:", -- Letter to Delgren
	[5355]="0:4:2:1:Leather::1:0:", -- Beastmaster's Girdle
	[5356]="0:2:2:1:Wand::1:0:", -- Branding Rod
	[5357]="0:4:2:1:Shield::1:0:", -- Ward of the Vale
	[5359]="0:12:1:1:::1:0:", -- Lorgalis Manuscript
	[5360]="0:12:1:20:::1:0:", -- Highborne Relic
	[5361]="0:15:0:10:Junk::1:0:", -- Fishbone Toothpick
	[5362]="0:15:0:5:Junk::1:0:", -- Chew Toy
	[5363]="0:15:0:5:Junk::1:0:", -- Folded Handkerchief
	[5364]="0:15:0:5:Junk::1:0:", -- Dry Salt Lick
	[5366]="0:12:1:1:::1:0:", -- Glowing Soul Gem
	[5367]="0:15:0:5:Junk::1:0:", -- Primitive Rock Tool
	[5368]="0:15:0:5:Junk::1:0:", -- Empty Wallet
	[5369]="0:15:0:5:Junk::1:0:", -- Gnawed Bone
	[5370]="0:15:0:5:Junk::1:0:", -- Bent Spoon
	[5371]="0:15:0:5:Junk::1:0:", -- Piece of Coral
	[5373]="0:15:1:5:Junk:165:1:0:", -- Lucky Charm
	[5374]="0:15:0:5:Junk::1:0:", -- Small Pocket Watch
	[5375]="0:15:0:5:Junk::1:0:", -- Scratching Stick
	[5376]="0:15:0:5:Junk::1:0:", -- Broken Mirror
	[5377]="0:15:0:5:Junk::1:0:", -- Scallop Shell
	[5379]="0:15:0:200:Junk::1:0:", -- Broken Boot Knife
	[5382]="0:12:1:1:::1:0:", -- Anaya's Pendant
	[5383]="0:12:1:1:::1:0:", -- Athrikus Narassin's Head
	[5385]="0:12:1:20:::1:0:", -- Crawler Leg
	[5386]="0:12:1:20:::1:0:", -- Fine Moonstalker Pelt
	[5387]="0:4:2:1:Cloak::1:0:", -- Enchanted Moonstalker Cloak
	[5388]="0:12:1:1:::1:0:", -- Ran Bloodtooth's Skull
	[5389]="0:12:1:1:::1:0:", -- Corrupted Furbolg Totem
	[5390]="0:12:1:1:::1:0:", -- Fandral's Message
	[5391]="0:12:1:1:::1:0:", -- Rare Earth
	[5392]="0:2:1:1:Dagger::1:0:", -- Thistlewood Dagger
	[5393]="0:2:1:1:Stave::1:0:", -- Thistlewood Staff
	[5394]="0:4:1:1:Leather::1:0:", -- Archery Training Gloves
	[5395]="0:4:1:1:Shield::1:0:", -- Woodland Shield
	[5396]="0:13:1:1:::1:0:", -- Key to Searing Gorge
	[5397]="0:15:1:1:Junk::1:0:", -- Defias Gunpowder
	[5398]="0:4:1:1:Leather::1:0:", -- Canopy Leggings
	[5399]="0:4:1:1:Mail::1:0:", -- Tracking Boots
	[5404]="0:4:3:1:Leather::1:0:", -- Serpent's Shoulders
	[5405]="0:4:1:1:Cloak::1:0:", -- Draped Cloak
	[5411]="0:4:1:1:Miscellaneous::1:0:", -- Winterhoof Cleansing Totem
	[5412]="0:12:1:20:::1:0:", -- Thresher Eye
	[5413]="0:12:1:20:::1:0:", -- Moonstalker Fang
	[5414]="0:12:1:20:::1:0:", -- Grizzled Scalp
	[5415]="0:12:1:1:::1:0:", -- Thunderhorn Cleansing Totem
	[5416]="0:12:1:1:::1:0:", -- Wildmane Cleansing Totem
	[5419]="0:4:1:1:Leather::1:0:", -- Feral Bracers
	[5420]="0:4:2:1:Cloth::1:0:", -- Banshee Armor
	[5421]="0:0:1:1:EnhPerm::1:0:", -- Fiery Blaze Enchantment
	[5422]="0:4:2:1:Leather::1:0:", -- Brambleweed Leggings
	[5423]="0:2:3:1:TwoHandAxe::1:0:", -- Boahn's Fang
	[5424]="0:12:1:1:::1:0:", -- Ancient Statuette
	[5425]="0:4:3:1:Mail::1:0:", -- Runescale Girdle
	[5426]="0:2:3:1:OneHandAxe::1:0:", -- Serpent's Kiss
	[5427]="0:15:0:5:Junk::1:0:", -- Crude Pocket Watch
	[5428]="0:15:0:5:Junk::1:0:", -- An Exotic Cookbook
	[5429]="0:15:0:5:Junk::1:0:", -- A Pretty Rock
	[5430]="0:15:0:5:Junk::1:0:", -- Intricate Bauble
	[5431]="0:15:0:5:Junk::1:0:", -- Empty Hip Flask
	[5432]="0:15:0:5:Junk::1:0:", -- Hickory Pipe
	[5433]="0:15:0:5:Junk::1:0:", -- Rag Doll
	[5435]="0:15:0:5:Junk::1:0:", -- Shiny Dinglehopper
	[5437]="0:12:1:20:::1:0:", -- Bathran's Hair
	[5439]="100:11:1:1:Quiver::1:0:228,789,1198,1297,1298,1459,1462,1668,1687,2839,3015,3165,3409,3410,3488,3589,3610,3951,4173,4203,4604,4892,5122,6028,9548,9549,9551,9552,9553,9555,10369,12029,14301,16263,16274,16619,16715,16919,17598,17667,19020,19561,27055", -- Small Quiver
	[5440]="0:12:1:1:::1:0:", -- Bottle of Disease
	[5441]="1000:11:1:1:AmmoPouch::1:0:1243,1297,1469,1686,2997,3018,3078,3088,3322,3488,4603,5123,5510,7976,9551,16274,16620,16735", -- Small Shot Pouch
	[5442]="0:12:1:1:::1:0:", -- Head of Arugal
	[5443]="0:4:3:1:Shield::1:0:", -- Gold-plated Buckler
	[5444]="0:4:3:1:Cloak::1:0:", -- Miner's Cape
	[5445]="0:12:1:1:::1:0:", -- Ring of Zoram
	[5446]="0:15:0:20:Junk::1:0:", -- Broken Elemental Bracer
	[5447]="0:15:0:20:Junk::1:0:", -- Damaged Elemental Bracer
	[5448]="0:15:0:20:Junk::1:0:", -- Fractured Elemental Bracer
	[5451]="0:15:0:20:Junk::1:0:", -- Crushed Elemental Bracer
	[5455]="0:12:1:1:::1:0:", -- Divined Scroll
	[5456]="0:12:1:1:::1:0:", -- Divining Scroll
	[5457]="0:0:1:10:Consumable::1:0:", -- Severed Voodoo Claw
	[5458]="0:4:1:1:Cloth::1:0:", -- Dirtwood Belt
	[5459]="0:2:2:1:OneHandAxe::1:0:", -- Defender Axe
	[5460]="0:12:1:1:::1:0:", -- Orendil's Cure
	[5461]="0:12:1:1:::1:0:", -- Branch of Cenarius
	[5462]="0:12:1:1:::1:0:", -- Dartol's Rod of Transformation
	[5463]="0:12:1:1:::1:0:", -- Glowing Gem
	[5464]="0:12:1:1:::1:0:", -- Iron Shaft
	[5465]="0:7:1:20:Meat:185:1:0:", -- Small Spider Leg
	[5466]="0:7:1:20:Meat:185:1:0:", -- Scorpid Stinger
	[5467]="0:7:1:20:Meat:185:1:0:", -- Kodo Meat
	[5468]="0:7:1:20:Meat:185:1:0:", -- Soft Frenzy Flesh
	[5469]="0:7:1:20:Meat:185:1:0:", -- Strider Meat
	[5470]="0:7:1:20:Meat:185:1:0:", -- Thunder Lizard Tail
	[5471]="0:7:1:20:Meat:185:1:0:", -- Stag Meat
	[5472]="0:0:1:20:FoodDrink::1:0:", -- Kaldorei Spider Kabob
	[5473]="0:0:1:20:FoodDrink::1:0:", -- Scorpid Surprise
	[5474]="0:0:1:20:FoodDrink::1:0:", -- Roasted Kodo Meat
	[5475]="0:13:1:1:::1:0:", -- Wooden Key
	[5476]="0:0:1:20:FoodDrink::1:0:", -- Fillet of Frenzy
	[5477]="0:0:1:20:FoodDrink::1:0:", -- Strider Stew
	[5478]="0:0:1:20:FoodDrink::1:0:", -- Dig Rat Stew
	[5479]="0:0:1:20:FoodDrink::1:0:", -- Crispy Lizard Tail
	[5480]="0:0:1:20:FoodDrink::1:0:", -- Lean Venison
	[5481]="0:12:1:20:::1:0:", -- Satyr Horns
	[5482]="0:9:1:1:Cooking::1:0:", -- Recipe: Kaldorei Spider Kabob
	[5483]="140:9:1:1:Cooking::1:0:3881", -- Recipe: Scorpid Surprise
	[5484]="240:9:1:1:Cooking::1:0:3081", -- Recipe: Roasted Kodo Meat
	[5485]="400:9:1:1:Cooking::1:0:4200", -- Recipe: Fillet of Frenzy
	[5486]="440:9:1:1:Cooking::1:0:3482", -- Recipe: Strider Stew
	[5487]="0:9:1:1:Cooking::1:0:", -- Recipe: Dig Rat Stew
	[5488]="400:9:1:1:Cooking::1:0:3482", -- Recipe: Crispy Lizard Tail
	[5489]="1200:9:1:1:Cooking::1:0:3960,12245", -- Recipe: Lean Venison
	[5490]="0:12:1:20:::1:0:", -- Wrathtail Head
	[5493]="0:12:1:1:::1:0:", -- Elune's Tear
	[5494]="0:12:1:20:::1:0:", -- Handful of Stardust
	[5498]="0:3:2:20:GemSimple:164,755,165,197:1:0:", -- Small Lustrous Pearl
	[5500]="0:3:2:20:GemSimple:164,333,165,197:1:0:", -- Iridescent Pearl
	[5503]="0:7:1:20:Meat:185:1:0:", -- Clam Meat
	[5504]="0:7:1:20:Meat:185:1:0:", -- Tangy Clam Meat
	[5505]="0:12:1:1:::1:0:", -- Teronis' Journal
	[5506]="0:15:0:5:Junk::1:0:", -- Beady Eye Stalk
	[5507]="0:7:1:1:Device::1:0:", -- Ornate Spyglass
	[5508]="0:12:1:1:::1:0:", -- Fallen Moonstone
	[5509]="0:0:1:1:Other::1:0:", -- Healthstone
	[5510]="0:0:1:1:Other::1:0:", -- Greater Healthstone
	[5511]="0:0:1:1:Other::1:0:", -- Lesser Healthstone
	[5512]="0:0:1:1:Other::1:0:", -- Minor Healthstone
	[5513]="0:0:1:1:Consumable::1:0:", -- Mana Jade
	[5514]="0:4:1:1:Miscellaneous::1:0:", -- Mana Agate
	[5516]="0:2:0:1:Dagger::1:0:", -- Threshadon Fang
	[5517]="0:15:1:10:Reagent::1:0:", -- Tiny Bronze Key
	[5518]="0:15:1:10:Reagent::1:0:", -- Tiny Iron Key
	[5519]="0:12:1:1:::1:0:", -- Iron Pommel
	[5520]="0:12:1:1:::1:0:", -- Velinde's Journal
	[5521]="0:13:1:1:::1:0:", -- Velinde's Key
	[5523]="0:7:1:20:Other::1:0:", -- Small Barnacled Clam
	[5524]="0:7:1:20:Other::1:0:", -- Thick-shelled Clam
	[5525]="0:0:1:20:FoodDrink::1:0:", -- Boiled Clams
	[5526]="0:0:1:20:FoodDrink::1:0:", -- Clam Chowder
	[5527]="0:0:1:20:FoodDrink::1:0:", -- Goblin Deviled Clams
	[5528]="800:9:1:1:Cooking::1:0:4305,4307", -- Recipe: Clam Chowder
	[5529]="0:15:0:20:Junk::1:0:", -- Tomb Dust
	[5533]="0:12:1:1:::1:0:", -- Ilkrud Magthrull's Tome
	[5534]="0:12:1:1:::1:0:", -- Parker's Lunch
	[5535]="0:12:1:1:::1:0:", -- Compendium of the Fallen
	[5536]="0:12:1:1:::1:0:", -- Mythology of the Titans
	[5537]="0:12:1:1:::1:0:", -- Sarilus Foulborne's Head
	[5538]="0:12:1:1:::1:0:", -- Vorrel's Wedding Ring
	[5539]="0:12:1:1:::1:0:", -- Letter of Commendation
	[5540]="0:2:2:1:Dagger::1:0:", -- Pearl-handled Dagger
	[5541]="0:2:2:1:OneHandMace::1:0:", -- Iridescent Hammer
	[5542]="0:4:2:1:Cloak::1:0:", -- Pearl-clasped Cloak
	[5543]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Iridescent Hammer
	[5544]="0:12:1:1:::1:0:", -- Dal Bloodclaw's Skull
	[5547]="0:12:1:1:::1:0:", -- Reconstructed Rod
	[5565]="5000:15:1:5:Reagent:-9:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,35642,37904,37935", -- Infernal Stone
	[5566]="0:15:0:5:Junk::1:0:", -- Broken Antler
	[5567]="0:15:0:5:Junk::1:0:", -- Silver Hook
	[5568]="0:6:1:1000:Bullet::1:0:", -- Smooth Pebble
	[5569]="0:15:0:5:Junk::1:0:", -- Seaweed
	[5570]="0:12:1:20:::1:0:", -- Deepmoss Egg
	[5571]="0:1:1:1:Bag::1:0:", -- Small Black Pouch
	[5572]="0:1:1:1:Bag::1:0:", -- Small Green Pouch
	[5573]="0:1:1:1:Bag::1:0:", -- Green Leather Bag
	[5574]="0:1:1:1:Bag::1:0:", -- White Leather Bag
	[5575]="0:1:1:1:Bag::1:0:", -- Large Green Sack
	[5576]="0:1:1:1:Bag::1:0:", -- Large Brown Sack
	[5578]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Silvered Bronze Breastplate
	[5579]="0:2:1:1:TwoHandMace::1:0:", -- Militia Warhammer
	[5580]="0:2:1:1:OneHandMace::1:0:", -- Militia Hammer
	[5581]="0:2:1:1:Stave::1:0:", -- Smooth Walking Staff
	[5582]="0:12:1:20:::1:0:", -- Stonetalon Sap
	[5583]="0:12:1:20:::1:0:", -- Fey Dragon Scale
	[5584]="0:12:1:20:::1:0:", -- Twilight Whisker
	[5585]="0:12:1:20:::1:0:", -- Courser Eye
	[5586]="0:2:1:1:OneHandSword::1:0:", -- Thistlewood Blade
	[5587]="0:2:2:1:OneHandMace::1:0:", -- Thornroot Club
	[5588]="0:12:1:1:::1:0:", -- Lydon's Toxin
	[5589]="0:4:1:1:Mail::1:0:", -- Moss-covered Gauntlets
	[5590]="0:4:1:1:Cloth::1:0:", -- Cord Bracers
	[5591]="0:4:1:1:Cloak::1:0:", -- Rain-spotted Cape
	[5592]="0:4:1:1:Mail::1:0:", -- Shackled Girdle
	[5593]="0:4:1:1:Shield::1:0:", -- Crag Buckler
	[5594]="0:12:1:1:::1:0:", -- Letter to Jin'Zil
	[5595]="0:2:1:1:TwoHandMace::1:0:", -- Thicket Hammer
	[5596]="0:2:1:1:Bow::1:0:", -- Ashwood Bow
	[5601]="0:15:0:10:Junk::1:0:", -- Hatched Egg Sac
	[5602]="0:15:0:10:Junk::1:0:", -- Sticky Spider Webbing
	[5604]="0:2:2:1:Wand::1:0:", -- Elven Wand
	[5605]="0:2:1:1:Dagger::1:0:", -- Pruning Knife
	[5606]="0:4:1:1:Cloth::1:0:", -- Gardening Gloves
	[5608]="0:4:2:1:Cloth::1:0:", -- Living Cowl
	[5609]="0:4:2:1:Leather::1:0:", -- Steadfast Cinch
	[5610]="0:4:2:1:Cloak::1:0:", -- Gustweald Cloak
	[5611]="0:4:2:1:OffHandFrill::1:0:", -- Tear of Grief
	[5612]="0:4:1:1:Leather::1:0:", -- Ivy Cuffs
	[5613]="0:2:2:1:Stave::1:0:", -- Staff of the Purifier
	[5614]="0:2:2:1:TwoHandSword::1:0:", -- Seraph's Strike
	[5615]="0:2:2:1:TwoHandSword::1:0:", -- Woodsman Sword
	[5616]="0:2:3:1:Dagger::1:0:", -- Gutwrencher
	[5617]="0:4:2:1:Leather::1:0:", -- Vagabond Leggings
	[5618]="0:4:1:1:Cloak::1:0:", -- Scout's Cloak
	[5619]="0:12:1:1:::1:0:", -- Jade Phial
	[5620]="0:12:1:20:::1:0:", -- Vial of Innocent Blood
	[5621]="0:12:1:1:::1:0:", -- Tourmaline Phial
	[5622]="0:4:2:1:Ring::1:0:", -- Clergy Ring
	[5623]="0:12:1:1:::1:0:", -- Amethyst Phial
	[5624]="0:4:2:1:Cloth::1:0:", -- Circlet of the Order
	[5626]="0:2:2:1:TwoHandAxe::1:0:", -- Skullchipper
	[5627]="0:2:2:1:Dagger::1:0:", -- Relic Blade
	[5628]="0:12:1:1:::1:0:", -- Zamah's Note
	[5629]="0:4:2:1:Leather::1:0:", -- Hammerfist Gloves
	[5630]="0:4:2:1:Leather::1:0:", -- Windfelt Gloves
	[5631]="0:0:1:20:Potion::1:0:", -- Rage Potion
	[5632]="0:0:1:5:Potion::1:0:", -- Cowardly Flight Potion
	[5633]="0:0:1:20:Potion:165:1:0:", -- Great Rage Potion
	[5634]="0:0:1:20:Potion::1:0:", -- Free Action Potion
	[5635]="0:7:1:5:Other:171,164:1:0:", -- Sharp Claw
	[5636]="0:15:0:10:Junk::1:0:", -- Delicate Feather
	[5637]="0:7:1:5:Other:171,164,333,755,165:1:0:", -- Large Fang
	[5638]="0:12:1:1:::1:0:", -- Toxic Fogger
	[5639]="0:12:1:1:::1:0:", -- Filled Jade Phial
	[5640]="100:9:1:1:Alchemy::1:1:1669,1685,3335,3499", -- Recipe: Rage Potion
	[5642]="1800:9:1:1:Alchemy::1:1:3348,4226,5178", -- Recipe: Free Action Potion
	[5643]="2000:9:1:1:Alchemy::1:1:3335,4226", -- Recipe: Great Rage Potion
	[5645]="0:12:1:1:::1:0:", -- Filled Tourmaline Phial
	[5646]="0:12:1:1:::1:0:", -- Vial of Blessed Water
	[5655]="10000:15:3:1:Mount::1:0:384,1460,2357,4885", -- Chestnut Mare Bridle
	[5656]="10000:15:3:1:Mount::1:0:384,1460,2357,4885", -- Brown Horse Bridle
	[5659]="0:12:1:20:::1:0:", -- Smoldering Embers
	[5664]="0:12:1:20:::1:0:", -- Corroded Shrapnel
	[5665]="10000:15:3:1:Mount::1:0:3362", -- Horn of the Dire Wolf
	[5668]="10000:15:3:1:Mount::1:0:3362", -- Horn of the Brown Wolf
	[5669]="0:12:1:1:::1:0:", -- Dust Devil Debris
	[5675]="0:12:1:20:::1:0:", -- Crystalized Scales
	[5681]="0:12:1:1:::1:0:", -- Corrosive Sap
	[5686]="0:12:1:1:::1:0:", -- Ordanus' Head
	[5687]="0:13:1:1:::1:0:", -- Gatekeeper's Key
	[5689]="0:13:1:1:::1:0:", -- Sleepers' Key
	[5690]="0:13:1:1:::1:0:", -- Claw Key
	[5691]="0:13:1:1:::1:0:", -- Barrow Key
	[5692]="0:12:1:1:::1:0:", -- Remote Detonator (Red)
	[5693]="0:12:1:1:::1:0:", -- Remote Detonator (Blue)
	[5694]="0:12:1:1:::1:0:", -- NG-5 Explosives (Red)
	[5695]="0:12:1:1:::1:0:", -- NG-5 Explosives (Blue)
	[5717]="0:12:1:1:::1:0:", -- Venture Co. Letters
	[5718]="0:12:1:1:::1:0:", -- Venture Co. Engineering Plans
	[5731]="0:12:1:1:::1:0:", -- Scroll of Messaging
	[5732]="0:12:1:1:::1:0:", -- NG-5
	[5733]="0:12:1:1:::1:0:", -- Unidentified Ore
	[5734]="0:12:1:1:::1:0:", -- Super Reaper 6000 Blueprints
	[5735]="0:12:1:1:::1:0:", -- Sealed Envelope
	[5736]="0:12:1:1:::1:0:", -- Gerenzo's Mechanical Arm
	[5737]="0:12:1:1:::1:0:", -- Covert Ops Plans: Alpha & Beta
	[5738]="0:15:1:1:Junk::1:0:", -- Covert Ops Pack
	[5739]="0:4:2:1:Leather::1:0:", -- Barbaric Harness
	[5740]="100:0:1:5:Other::1:0:1304,2838,3180,5569,8117,8118,16650,23208", -- Red Fireworks Rocket
	[5741]="0:15:0:20:Junk::1:0:", -- Rock Chip
	[5742]="0:2:2:1:Dagger::1:0:", -- Gemstone Dagger
	[5743]="0:4:2:1:Ring::1:0:", -- Prismstone Ring
	[5744]="0:2:2:1:OneHandSword::1:0:", -- Pale Skinner
	[5749]="0:2:2:1:TwoHandAxe::1:0:", -- Scythe Axe
	[5750]="0:4:2:1:Mail::1:0:", -- Warchief's Girdle
	[5751]="0:4:2:1:Cloak::1:0:", -- Webwing Cloak
	[5752]="0:2:2:1:Dagger::1:0:", -- Wyvern Tailspike
	[5753]="0:4:2:1:Leather::1:0:", -- Ruffled Chaplet
	[5754]="0:4:2:1:Amulet::1:0:", -- Wolfpack Medallion
	[5755]="0:4:2:1:Mail::1:0:", -- Onyx Shredder Plate
	[5756]="0:2:3:1:Dagger::1:0:", -- Sliverblade
	[5757]="0:2:2:1:OneHandMace::1:0:", -- Hardwood Cudgel
	[5758]="0:15:2:1:Junk::1:0:", -- Mithril Lockbox
	[5759]="0:15:2:1:Junk::1:0:", -- Thorium Lockbox
	[5760]="0:15:2:1:Junk::1:0:", -- Eternium Lockbox
	[5761]="0:2:1:1:TwoHandMace::1:0:", -- Anvilmar Sledge
	[5762]="0:1:1:1:Bag::1:0:", -- Red Linen Bag
	[5763]="0:1:1:1:Bag::1:0:", -- Red Woolen Bag
	[5764]="0:1:1:1:Bag::1:0:", -- Green Silk Pack
	[5765]="0:1:1:1:Bag::1:0:", -- Black Silk Pack
	[5766]="0:4:2:1:Cloth::1:0:", -- Lesser Wizard's Robe
	[5767]="0:4:1:1:Cloth::1:0:", -- Violet Robes
	[5770]="0:4:2:1:Cloth::1:0:", -- Robes of Arcana
	[5771]="200:9:1:1:Tailoring::1:1:843,3005,3556,4189,16224", -- Pattern: Red Linen Bag
	[5772]="500:9:1:1:Tailoring::1:1:777,1454,1474,3005,3364,3485,3537,3683,4189,4577,5944", -- Pattern: Red Woolen Bag
	[5773]="0:9:2:1:Tailoring::1:0:", -- Pattern: Robes of Arcana
	[5774]="0:9:2:1:Tailoring::1:0:", -- Pattern: Green Silk Pack
	[5775]="0:9:2:1:Tailoring::1:0:", -- Pattern: Black Silk Pack
	[5776]="0:2:1:1:Stave::1:0:", -- Elder's Cane
	[5777]="0:2:1:1:TwoHandAxe::1:0:", -- Brave's Axe
	[5778]="0:2:1:1:Stave::1:0:", -- Primitive Walking Stick
	[5779]="0:2:1:1:TwoHandSword::1:0:", -- Forsaken Bastard Sword
	[5780]="0:4:2:1:Leather::1:0:", -- Murloc Scale Belt
	[5781]="0:4:2:1:Leather::1:0:", -- Murloc Scale Breastplate
	[5782]="0:4:2:1:Leather::1:0:", -- Thick Murloc Armor
	[5783]="0:4:2:1:Leather::1:0:", -- Murloc Scale Bracers
	[5784]="0:7:1:10:Leather:165:1:0:", -- Slimy Murloc Scale
	[5785]="0:7:1:10:Leather:165:1:0:", -- Thick Murloc Scale
	[5786]="550:9:1:1:Leatherworking::1:1:843,3556,4186", -- Pattern: Murloc Scale Belt
	[5787]="600:9:1:1:Leatherworking::1:1:843,3556,4186", -- Pattern: Murloc Scale Breastplate
	[5788]="650:9:2:1:Leatherworking::1:1:2381,2393,2846", -- Pattern: Thick Murloc Armor
	[5789]="2800:9:2:1:Leatherworking::1:1:2846,4897", -- Pattern: Murloc Scale Bracers
	[5790]="0:12:1:1:::1:0:", -- Lonebrow's Journal
	[5791]="0:12:1:1:::1:0:", -- Henrig Lonebrow's Journal
	[5792]="0:12:1:1:::1:0:", -- Razorflank's Medallion
	[5793]="0:12:1:1:::1:0:", -- Razorflank's Heart
	[5794]="0:12:1:20:::1:0:", -- Salty Scorpid Venom
	[5795]="0:12:1:20:::1:0:", -- Hardened Tortoise Shell
	[5796]="0:12:1:20:::1:0:", -- Encrusted Tail Fin
	[5797]="0:12:1:20:::1:0:", -- Indurium Flake
	[5798]="0:12:1:30:::1:0:", -- Rocket Car Parts
	[5799]="0:12:1:1:::1:0:", -- Kravel's Parts Order
	[5800]="0:12:1:1:::1:0:", -- Kravel's Parts
	[5801]="0:12:1:20:::1:0:", -- Kraul Guano
	[5802]="0:12:1:1:::1:0:", -- Delicate Car Parts
	[5803]="0:12:1:20:::1:0:", -- Speck of Dream Dust
	[5804]="0:12:1:1:::1:0:", -- Goblin Rumors
	[5805]="0:12:1:20:::1:0:", -- Heart of Zeal
	[5806]="0:12:1:1:::1:0:", -- Fool's Stout
	[5807]="0:12:1:1:::1:0:", -- Fool's Stout Report
	[5808]="0:12:1:20:::1:0:", -- Pridewing Venom Sac
	[5809]="0:12:1:20:::1:0:", -- Highperch Venom Sac
	[5810]="0:12:1:1:::1:0:", -- Fresh Carcass
	[5811]="0:12:1:1:::1:0:", -- Frostmaw's Mane
	[5812]="0:4:2:1:Cloth::1:0:", -- Robes of Antiquity
	[5813]="0:2:2:1:TwoHandSword::1:0:", -- Emil's Brand
	[5814]="0:4:2:1:Leather::1:0:", -- Snapbrook Armor
	[5815]="0:2:2:1:TwoHandMace::1:0:", -- Glacial Stone
	[5816]="0:0:1:1:Potion::1:0:", -- Light of Elune
	[5817]="0:2:2:1:Bow::1:0:", -- Lunaris Bow
	[5818]="0:2:2:1:Wand::1:0:", -- Moonbeam Wand
	[5819]="0:4:3:1:Mail::1:0:", -- Sunblaze Coif
	[5820]="0:4:2:1:Cloth::1:0:", -- Faerie Mantle
	[5824]="0:12:1:1:::1:0:", -- Tablet of Will
	[5825]="0:12:1:1:::1:0:", -- Treshala's Pendant
	[5826]="0:12:1:1:::1:0:", -- Kravel's Scheme
	[5827]="0:12:1:1:::1:0:", -- Fizzle Brassbolts' Letter
	[5829]="0:15:0:5:Junk::1:0:", -- Razor-sharp Beak
	[5830]="0:12:1:1:::1:0:", -- Kenata's Head
	[5831]="0:12:1:1:::1:0:", -- Fardel's Head
	[5832]="0:12:1:1:::1:0:", -- Marcel's Head
	[5833]="0:12:1:20:::1:0:", -- Indurium Ore
	[5834]="0:12:1:1:::1:0:", -- Mok'Morokk's Snuff
	[5835]="0:12:1:1:::1:0:", -- Mok'Morokk's Grog
	[5836]="0:12:1:1:::1:0:", -- Mok'Morokk's Strongbox
	[5837]="0:12:1:1:::1:0:", -- Steelsnap's Rib
	[5838]="0:12:1:1:::1:0:", -- Kodo Skin Scroll
	[5839]="0:15:0:1:Junk::1:0:", -- Journal Page
	[5840]="0:12:1:20:::1:0:", -- Searing Tongue
	[5841]="0:12:1:20:::1:0:", -- Searing Heart
	[5842]="0:12:1:1:::1:0:", -- Unrefined Ore Sample
	[5843]="0:12:1:1:::1:0:", -- Grenka's Claw
	[5844]="0:12:1:1:::1:0:", -- Fragments of Rok'Alim
	[5846]="0:12:1:1:::1:0:", -- Korran's Sealed Note
	[5847]="0:12:1:20:::1:0:", -- Mirefin Head
	[5848]="0:12:1:20:::1:0:", -- Hollow Vulture Bone
	[5849]="0:12:1:1:::1:0:", -- Crate of Crash Helmets
	[5850]="0:12:1:1:::1:0:", -- Belgrom's Sealed Note
	[5851]="0:13:1:1:::1:0:", -- Cozzle's Key
	[5852]="0:12:1:1:::1:0:", -- Fuel Regulator Blueprints
	[5853]="0:12:1:20:::1:0:", -- Intact Silithid Carapace
	[5854]="0:12:1:20:::1:0:", -- Silithid Talon
	[5855]="0:12:1:20:::1:0:", -- Silithid Heart
	[5860]="0:12:1:1:::1:0:", -- Legacy of the Aspects
	[5861]="0:12:1:1:::1:0:", -- Beginnings of the Undead Threat
	[5862]="0:12:1:1:::1:0:", -- Seaforium Booster
	[5863]="0:15:1:1:Junk::1:0:", -- Guild Charter
	[5864]="10000:15:3:1:Mount::1:0:1261", -- Gray Ram
	[5865]="0:12:1:1:::1:0:", -- Modified Seaforium Booster
	[5866]="0:12:1:1:::1:0:", -- Sample of Indurium Ore
	[5867]="0:12:1:1:::1:0:", -- Etched Phial
	[5868]="0:12:1:1:::1:0:", -- Filled Etched Phial
	[5869]="0:12:1:1:::1:0:", -- Cloven Hoof
	[5871]="0:15:0:5:Junk::1:0:", -- Large Hoof
	[5872]="10000:15:3:1:Mount::1:0:1261", -- Brown Ram
	[5873]="10000:15:3:1:Mount::1:0:1261", -- White Ram
	[5876]="0:12:1:20:::1:0:", -- Blueleaf Tuber
	[5877]="0:12:1:1:::1:0:", -- Cracked Silithid Carapace
	[5879]="0:12:1:20:::1:0:", -- Twilight Pendant
	[5880]="0:0:1:1:Consumable::1:0:", -- Crate With Holes
	[5881]="0:12:1:1:::1:0:", -- Head of Kelris
	[5882]="0:12:1:1:::1:0:", -- Captain's Documents
	[5883]="0:12:1:20:::1:0:", -- Forked Mudrock Tongue
	[5884]="0:12:1:20:::1:0:", -- Unpopped Darkmist Eye
	[5897]="0:12:1:1:::1:0:", -- Snufflenose Owner's Manual
	[5917]="0:12:1:1:::1:0:", -- Spy's Report
	[5918]="0:12:1:1:::1:0:", -- Defiant Orc Head
	[5919]="0:12:1:1:::1:0:", -- Blackened Iron Shield
	[5936]="0:4:1:1:Leather::1:0:", -- Animal Skin Belt
	[5938]="0:12:1:20:::1:0:", -- Pristine Crawler Leg
	[5939]="0:4:1:1:Leather::1:0:", -- Sewing Gloves
	[5940]="0:4:1:1:Shield::1:0:", -- Bone Buckler
	[5941]="0:4:1:1:Mail::1:0:", -- Brass Scale Pants
	[5942]="0:12:1:1:::1:0:", -- Jeweled Pendant
	[5943]="0:4:3:1:Mail::1:0:", -- Rift Bracers
	[5944]="0:4:2:1:Mail::1:0:", -- Greaves of the People's Militia
	[5945]="0:12:1:1:::1:0:", -- Deadmire's Tooth
	[5946]="0:12:1:1:::1:0:", -- Sealed Note to Elling
	[5947]="0:12:1:1:::1:0:", -- Defias Docket
	[5948]="0:12:1:1:::1:0:", -- Letter to Jorgen
	[5950]="0:12:1:1:::1:0:", -- Reethe's Badge
	[5951]="0:0:1:10:Consumable::1:0:", -- Moist Towelette
	[5952]="0:12:1:20:::1:0:", -- Corrupted Brain Stem
	[5956]="18:2:1:1:Miscellaneous:202:1:0:66,777,790,843,960,989,1148,1250,1286,1448,1456,1465,1690,1692,1694,2118,2225,2381,2393,2682,2683,2684,2685,2687,2688,2810,2821,2844,2847,2999,3081,3133,3168,3187,3343,3356,3367,3413,3477,3482,3495,3499,3556,3614,3779,3954,3955,4194,4229,4257,4259,4453,4561,4587,4597,4775,4877,4897,5100,5135,5163,5175,5411,5512,5519,5817,6300,6301,6730,6777,7947,8145,8161,8176,8363,8678,8679,8934,9179,9544,9636,9676,11185,11189,12022,12028,12043,12245,12941,12957,12958,14337,14624,14637,14737,15176,15179,15400,16224,16261,16262,16376,16583,16613,16657,16670,16713,16768,16782,16823,17222,17245,17421,17486,17490,17655,18009,18278,18426,18427,18484,18752,18775,19011,19012,19056,19244,19342,19372,19383,19450,19520,19530,19575,19661,19662,19879,20082,20463,20890,21112,22264,22476,23144,23724,23908,24052,24843,24935,24995,25010,25019,25051,25082,26081,26599,26600,26898,26934,27019,27021,27026,27043,27045,27057,27062,27134,27267,27711,28344,28692,28716,28722,28796,28797,28831,28872,29252,29253,29288,29688,29907,29923,29964,29969,30241,30253,30311,30336,30345,30434,30436,30825,31024,31776,31781,32594,33594,33599,33631,33634,33669,33675,33677,37904,37935", -- Blacksmith Hammer
	[5957]="0:4:1:1:Leather::1:0:", -- Handstitched Leather Vest
	[5958]="0:4:2:1:Leather::1:0:", -- Fine Leather Pants
	[5959]="0:12:1:20:::1:0:", -- Acidic Venom Sac
	[5960]="0:12:1:1:::1:0:", -- Sealed Note to Watcher Backus
	[5961]="0:4:2:1:Leather::1:0:", -- Dark Leather Pants
	[5962]="0:4:2:1:Leather::1:0:", -- Guardian Pants
	[5963]="0:4:2:1:Leather::1:0:", -- Barbaric Leggings
	[5964]="0:4:2:1:Leather::1:0:", -- Barbaric Shoulders
	[5965]="0:4:2:1:Cloak::1:0:", -- Guardian Cloak
	[5966]="0:4:2:1:Leather:164:1:0:", -- Guardian Gloves
	[5967]="0:4:2:1:Cloth::1:0:", -- Girdle of Nobility
	[5969]="0:4:2:1:Cloak::1:0:", -- Regent's Cloak
	[5970]="0:4:3:1:Cloth::1:0:", -- Serpent Gloves
	[5971]="0:4:2:1:Cloak::1:0:", -- Feathered Cape
	[5972]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Fine Leather Pants
	[5973]="650:9:1:1:Leatherworking::1:1:2810,2821,3958,4877", -- Pattern: Barbaric Leggings
	[5974]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Guardian Cloak
	[5975]="0:4:2:1:Leather::1:0:", -- Ruffian Belt
	[5976]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,28776", -- Guild Tabard
	[5996]="0:0:1:20:Elixir::1:0:", -- Elixir of Water Breathing
	[5997]="0:0:1:20:Elixir::1:0:", -- Elixir of Minor Defense
	[5998]="0:12:1:1:::1:0:", -- Stormpike's Request
	[6016]="0:12:1:1:::1:0:", -- Wolf Heart Sample
	[6037]="0:7:2:20:MetalStone:164,333,202,755,197:1:0:", -- Truesilver Bar
	[6038]="0:0:1:20:FoodDrink::1:0:", -- Giant Clam Scorcho
	[6039]="5000:9:1:1:Cooking::1:0:2664", -- Recipe: Giant Clam Scorcho
	[6040]="0:4:2:1:Mail::1:0:", -- Golden Scale Bracers
	[6041]="0:0:1:5:EnhPerm::1:0:", -- Steel Weapon Chain
	[6042]="0:0:1:5:EnhPerm::1:0:", -- Iron Shield Spike
	[6043]="0:0:1:5:EnhPerm::1:0:", -- Iron Counterweight
	[6044]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Iron Shield Spike
	[6045]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Iron Counterweight
	[6046]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Steel Weapon Chain
	[6047]="4400:9:1:1:Blacksmithing::1:1:5411", -- Plans: Golden Scale Coif
	[6048]="0:0:1:20:Potion:333,197:1:0:", -- Shadow Protection Potion
	[6049]="0:0:1:20:Potion::1:0:", -- Fire Protection Potion
	[6050]="0:0:1:20:Potion::1:0:", -- Frost Protection Potion
	[6051]="0:0:1:20:Potion::1:0:", -- Holy Protection Potion
	[6052]="0:0:1:20:Potion::1:0:", -- Nature Protection Potion
	[6053]="800:9:1:1:Alchemy::1:1:1685,3134,3490", -- Recipe: Holy Protection Potion
	[6054]="900:9:1:1:Alchemy::1:1:2393,3956", -- Recipe: Shadow Protection Potion
	[6055]="1500:9:1:1:Alchemy::1:1:2380,4083", -- Recipe: Fire Protection Potion
	[6056]="2000:9:1:1:Alchemy::1:1:2812,2848", -- Recipe: Frost Protection Potion
	[6057]="2000:9:1:1:Alchemy::1:1:2848,5594,8157,8158", -- Recipe: Nature Protection Potion
	[6058]="0:4:1:1:Leather::1:0:", -- Blackened Leather Belt
	[6059]="0:4:1:1:Leather::1:0:", -- Nomadic Vest
	[6060]="0:4:1:1:Cloth::1:0:", -- Flax Bracers
	[6061]="0:4:1:1:Mail::1:0:", -- Graystone Bracers
	[6062]="0:4:1:1:Cloth::1:0:", -- Heavy Cord Bracers
	[6063]="0:4:1:1:Mail::1:0:", -- Cold Steel Gauntlets
	[6064]="0:12:1:1:::1:0:", -- Miniature Platinum Discs
	[6065]="0:12:1:1:::1:0:", -- Khadgar's Essays on Dimensional Convergence
	[6066]="0:12:1:1:::1:0:", -- Khan Dez'hepah's Head
	[6067]="0:12:1:20:::1:0:", -- Centaur Ear
	[6068]="1500:9:1:1:Alchemy::1:1:2481,4878", -- Recipe: Shadow Oil
	[6069]="0:12:1:20:::1:0:", -- Crudely Dried Meat
	[6070]="0:4:1:1:Leather::1:0:", -- Wolfskin Bracers
	[6071]="0:12:1:20:::1:0:", -- Draenethyst Crystal
	[6072]="0:12:1:1:::1:0:", -- Khan Jehn's Head
	[6073]="0:12:1:1:::1:0:", -- Khan Shaka's Head
	[6074]="0:0:1:1:Consumable::1:0:", -- War Horn Mouthpiece
	[6076]="0:4:1:1:Cloth::1:0:", -- Tapered Pants
	[6077]="0:12:1:1:::1:0:", -- Maraudine Key Fragment
	[6078]="0:4:1:1:Shield::1:0:", -- Pikeman Shield
	[6079]="0:12:1:20:::1:0:", -- Crude Charm
	[6080]="0:12:1:20:::1:0:", -- Shadow Panther Heart
	[6081]="0:12:1:1:::1:0:", -- Mire Lord Fungus
	[6082]="0:12:1:1:::1:0:", -- Green Whelp Blood
	[6083]="0:12:1:20:::1:0:", -- Broken Tears
	[6084]="0:4:2:1:Mail::1:0:", -- Stormwind Guard Leggings
	[6085]="0:4:2:1:Leather::1:0:", -- Footman Tunic
	[6086]="0:12:1:1:::1:0:", -- Faustin's Truth Serum
	[6087]="0:4:3:1:Mail::1:0:", -- Chausses of Westfall
	[6089]="0:12:1:1:::1:0:", -- Zraedus's Brew
	[6091]="0:12:1:1:::1:0:", -- Crate of Power Stones
	[6092]="0:4:2:1:Leather::1:0:", -- Black Whelp Boots
	[6093]="0:2:2:1:TwoHandMace::1:0:", -- Orc Crusher
	[6094]="0:2:2:1:TwoHandAxe::1:0:", -- Piercing Axe
	[6095]="0:4:2:1:Cloth::1:0:", -- Wandering Boots
	[6096]="1:4:1:1:Shirt::1:0:18672", -- Apprentice's Shirt
	[6097]="1:4:1:1:Shirt::1:0:18672,24539", -- Acolyte's Shirt
	[6098]="4:4:0:1:Cloth::1:0:18672", -- Neophyte's Robe
	[6117]="0:4:1:1:Shirt::1:0:", -- Squire's Shirt
	[6118]="0:4:0:1:Cloth::1:0:", -- Squire's Pants
	[6119]="0:4:0:1:Cloth::1:0:", -- Neophyte's Robe
	[6120]="0:4:1:1:Shirt::1:0:", -- Recruit's Shirt
	[6121]="0:4:0:1:Cloth::1:0:", -- Recruit's Pants
	[6122]="0:4:1:1:Miscellaneous::1:0:", -- Recruit's Boots
	[6123]="0:4:0:1:Cloth::1:0:", -- Novice's Robe
	[6124]="0:4:0:1:Cloth::1:0:", -- Novice's Pants
	[6125]="0:4:1:1:Shirt::1:0:", -- Brawler's Harness
	[6126]="0:4:0:1:Cloth::1:0:", -- Trapper's Pants
	[6127]="0:4:1:1:Miscellaneous::1:0:", -- Trapper's Boots
	[6129]="0:4:0:1:Cloth::1:0:", -- Acolyte's Robe
	[6134]="0:4:1:1:Shirt::1:0:", -- Primitive Mantle
	[6135]="0:4:0:1:Leather::1:0:", -- Primitive Kilt
	[6136]="0:4:1:1:Shirt::1:0:", -- Thug Shirt
	[6137]="0:4:0:1:Cloth::1:0:", -- Thug Pants
	[6138]="0:4:1:1:Miscellaneous::1:0:", -- Thug Boots
	[6139]="0:4:0:1:Cloth::1:0:", -- Novice's Robe
	[6140]="0:4:0:1:Cloth::1:0:", -- Apprentice's Robe
	[6144]="0:4:0:1:Cloth::1:0:", -- Neophyte's Robe
	[6145]="0:12:1:1:::1:0:", -- Clarice's Pendant
	[6146]="0:12:1:20:::1:0:", -- Sundried Driftwood
	[6147]="0:4:1:1:Leather::1:0:", -- Ratty Old Belt
	[6148]="0:4:1:1:Cloth::1:0:", -- Web-covered Boots
	[6149]="1200:0:1:20:Potion:755:1:1:983,8157,8158,8177,8178,11188,18810,18905,18906,18908", -- Greater Mana Potion
	[6150]="0:15:0:20:Junk::1:0:", -- A Frayed Knot
	[6166]="0:12:1:20:::1:0:", -- Coyote Jawbone
	[6167]="0:12:1:1:::1:0:", -- Neeka's Report
	[6168]="0:12:1:20:::1:0:", -- Sawtooth Snapper Claw
	[6169]="0:12:1:20:::1:0:", -- Unprepared Sawtooth Flank
	[6170]="0:12:1:1:::1:0:", -- Wizards' Reagents
	[6171]="0:4:1:1:Leather::1:0:", -- Wolf Handler Gloves
	[6172]="0:12:1:1:::1:0:", -- Lost Supplies
	[6173]="0:4:1:1:Cloth::1:0:", -- Snow Boots
	[6175]="0:12:1:20:::1:0:", -- Atal'ai Artifact
	[6176]="0:4:1:1:Shield::1:0:", -- Dwarven Kite Shield
	[6177]="0:4:1:1:Mail::1:0:", -- Ironwrought Bracers
	[6178]="0:12:1:1:::1:0:", -- Shipment to Nethergarde
	[6179]="0:4:2:1:Cloak::1:0:", -- Privateer's Cape
	[6180]="0:4:2:1:Mail::1:0:", -- Slarkskin
	[6181]="0:12:1:20:::1:0:", -- Fetish of Hakkar
	[6182]="0:4:1:1:OffHandFrill::1:0:", -- Dim Torch
	[6184]="0:12:1:20:::1:0:", -- Monstrous Crawler Leg
	[6185]="0:4:1:1:Cloak::1:0:", -- Bear Shawl
	[6186]="0:2:2:1:TwoHandSword::1:0:", -- Trogg Slicer
	[6187]="0:4:2:1:Shield::1:0:", -- Dwarven Defender
	[6188]="0:4:2:1:Mail::1:0:", -- Mud Stompers
	[6189]="0:4:1:1:Mail::1:0:", -- Durable Chain Shoulders
	[6190]="0:12:1:1:::1:0:", -- Draenethyst Shard
	[6191]="0:4:2:1:Cloth::1:0:", -- Kimbra Boots
	[6193]="0:12:1:1:::1:0:", -- Bundle of Atal'ai Artifacts
	[6194]="0:2:2:1:OneHandAxe::1:0:", -- Barreling Reaper
	[6195]="0:4:2:1:Mail::1:0:", -- Wax-polished Armor
	[6196]="0:2:0:1:OneHandMace::1:0:", -- Noboru's Cudgel
	[6197]="0:4:2:1:Leather::1:0:", -- Loch Croc Hide Vest
	[6198]="0:4:2:1:Leather::1:0:", -- Jurassic Wristguards
	[6199]="0:4:2:1:Ring::1:0:", -- Black Widow Band
	[6200]="0:4:2:1:Mail::1:0:", -- Garneg's War Belt
	[6201]="0:4:1:1:Leather::1:0:", -- Lithe Boots
	[6202]="0:4:1:1:Cloth::1:0:", -- Fingerless Gloves
	[6203]="0:4:1:1:Shield::1:0:", -- Thuggish Shield
	[6204]="0:4:2:1:Leather::1:0:", -- Tribal Worg Helm
	[6205]="0:2:2:1:TwoHandMace::1:0:", -- Burrowing Shovel
	[6206]="0:2:1:1:TwoHandAxe::1:0:", -- Rock Chipper
	[6211]="0:9:1:1:Alchemy::1:0:", -- Recipe: Elixir of Ogre's Strength
	[6212]="0:12:1:1:::1:0:", -- Head of Jammal'an
	[6214]="0:2:2:1:TwoHandMace::1:0:", -- Heavy Copper Maul
	[6215]="0:2:2:1:Stave::1:0:", -- Balanced Fighting Stick
	[6217]="124:7:1:1:Enchanting:333:1:0:66,777,843,960,989,1148,1250,1286,1318,1456,1465,1692,2118,2225,2381,2393,2810,2821,3012,3081,3168,3187,3346,3367,3482,3499,3556,3614,3779,3954,3955,4194,4228,4229,4561,4617,4775,4877,4897,5100,5135,5158,5163,5757,5758,5817,6301,7947,8145,8363,8934,9636,11189,12022,12028,12043,12245,12941,12957,12958,15179,15419,16224,16261,16262,16613,16635,16722,16768,17486,17490,18009,18426,18427,18753,18773,18951,19234,19244,19372,19450,19537,19540,19663,24843,24935,24995,25010,25019,25051,25082,26569,27021,27026,27030,27039,27043,27054,27057,27147,28692,28714,28715,28831,28872,29288,29537,30311,33597,33633,33676", -- Copper Rod
	[6218]="0:7:1:1:Enchanting:333:1:0:", -- Runed Copper Rod
	[6219]="0:2:1:1:Miscellaneous::1:0:", -- Arclight Spanner
	[6220]="0:2:3:1:Dagger::1:0:", -- Meteor Shard
	[6223]="0:4:2:1:Shield::1:0:", -- Crest of Darkshire
	[6226]="0:4:3:1:Cloth::1:0:", -- Bloody Apron
	[6238]="0:4:2:1:Cloth::1:0:", -- Brown Linen Robe
	[6239]="0:4:2:1:Cloth::1:0:", -- Red Linen Vest
	[6240]="0:4:2:1:Cloth::1:0:", -- Blue Linen Vest
	[6241]="0:4:2:1:Cloth::1:0:", -- White Linen Robe
	[6242]="0:4:2:1:Cloth::1:0:", -- Blue Linen Robe
	[6243]="0:4:2:1:Cloth::1:0:", -- Green Woolen Robe
	[6245]="0:12:1:1:::1:0:", -- Karnitol's Satchel
	[6246]="0:12:1:20:::1:0:", -- Hatefury Claw
	[6247]="0:12:1:20:::1:0:", -- Hatefury Horn
	[6248]="0:12:1:20:::1:0:", -- Scorpashi Venom
	[6249]="0:12:1:20:::1:0:", -- Aged Kodo Hide
	[6250]="0:12:1:20:::1:0:", -- Felhound Brain
	[6251]="0:12:1:20:::1:0:", -- Nether Wing
	[6252]="0:12:1:20:::1:0:", -- Doomwarder Blood
	[6253]="0:12:1:1:::1:0:", -- Leftwitch's Package
	[6256]="23:2:1:1:FishingPole::1:0:66,777,843,989,1148,1250,1286,1465,1678,1684,1692,2118,2225,2383,2626,2810,2821,3029,3081,3168,3178,3187,3333,3367,3482,3497,3499,3550,3556,3572,3614,3779,3954,3955,4194,4222,4229,4561,4574,4775,4897,5135,5162,5163,5494,5817,5940,5942,6301,7945,7947,8145,8363,8508,8934,10118,10216,11189,12022,12028,12031,12043,12245,12941,12957,12958,12962,14740,15179,16224,16261,16262,16613,16708,16768,17101,17486,17490,18009,18018,18347,18426,18427,18911,19244,19372,19450,19472,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,27144,27181,27190,28692,28707,28742,28812,28831,28872,29288,30311,31804,31805", -- Fishing Pole
	[6257]="0:12:1:20:::1:0:", -- Roc Gizzard
	[6258]="0:12:1:20:::1:0:", -- Ironfur Liver
	[6259]="0:12:1:20:::1:0:", -- Groddoc Liver
	[6260]="50:7:1:10:Other:197:1:0:66,843,1250,1347,1454,1465,1474,1672,1692,2118,2225,2394,2668,2669,2670,2672,2697,2698,2699,2816,2819,2846,3005,3081,3091,3096,3168,3187,3364,3366,3482,3485,3614,3958,4168,4189,4194,4225,4577,4589,5128,5135,5154,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,8160,8681,8934,11557,11874,12942,12943,12956,15165,16224,16261,16262,16366,16638,16689,16748,16767,17490,18277,18426,18427,18749,18754,18771,18772,19196,19213,19521,19532,19722,21085,28718,28726,28798,28810,33596,33601,33635,33636,33681,33684", -- Blue Dye
	[6261]="1000:7:1:10:Other:197:1:0:1347,1454,1474,1672,2394,2668,2669,2670,2672,2697,2698,2699,2816,2819,2846,3005,3091,3096,3364,3366,3485,3958,4168,4189,4225,4577,4589,5128,5154,5565,5783,5944,6567,6568,6574,6576,6731,7852,7854,7940,8160,8681,11557,11874,12942,12943,12956,15165,16366,16638,16689,16748,16767,18277,18749,18754,18771,18772,19196,19213,19521,19532,19722,21085,28718,28726,28798,28810,33596,33601,33635,33636,33681,33684", -- Orange Dye
	[6263]="0:4:2:1:Cloth::1:0:", -- Blue Overalls
	[6264]="0:4:2:1:Cloth::1:0:", -- Greater Adept's Robe
	[6265]="0:15:1:1:Reagent:-9:1:0:", -- Soul Shard
	[6266]="0:4:2:1:Cloth::1:0:", -- Disciple's Vest
	[6267]="0:4:2:1:Cloth::1:0:", -- Disciple's Pants
	[6268]="0:4:2:1:Leather::1:0:", -- Pioneer Tunic
	[6269]="0:4:2:1:Leather::1:0:", -- Pioneer Trousers
	[6270]="200:9:1:1:Tailoring::1:1:66,3364,3485,3522,4189", -- Pattern: Blue Linen Vest
	[6271]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Linen Vest
	[6272]="300:9:1:1:Tailoring::1:1:1250,3485,3499,3556,4168", -- Pattern: Blue Linen Robe
	[6274]="400:9:1:1:Tailoring::1:1:843,1347,2394,3364,5944", -- Pattern: Blue Overalls
	[6275]="800:9:1:1:Tailoring::1:1:1454,1474,2669,3499,4168,4577", -- Pattern: Greater Adept's Robe
	[6281]="0:12:1:20:::1:0:", -- Rattlecage Skull
	[6282]="0:4:2:1:Cloth::1:0:", -- Sacred Burial Trousers
	[6283]="0:12:1:1:::1:0:", -- The Book of Ur
	[6284]="0:12:1:1:::1:0:", -- Runes of Summoning
	[6285]="0:12:1:1:::1:0:", -- Egalin's Grimoire
	[6286]="0:12:1:1:::1:0:", -- Pure Hearts
	[6287]="0:12:1:1:::1:0:", -- Atal'ai Tablet Fragment
	[6288]="0:12:1:20:::1:0:", -- Atal'ai Tablet
	[6289]="0:7:1:20:Meat:185:1:0:", -- Raw Longjaw Mud Snapper
	[6290]="0:0:1:20:FoodDrink::1:0:", -- Brilliant Smallfish
	[6291]="0:7:1:20:Meat:185:1:0:", -- Raw Brilliant Smallfish
	[6292]="0:4:1:1:OffHandFrill::1:0:", -- 10 Pound Mud Snapper
	[6293]="0:15:0:10:Junk::1:0:", -- Dried Bat Blood
	[6294]="0:4:1:1:OffHandFrill::1:0:", -- 12 Pound Mud Snapper
	[6295]="0:4:1:1:OffHandFrill::1:0:", -- 15 Pound Mud Snapper
	[6296]="0:15:0:10:Junk::1:0:", -- Patch of Bat Hair
	[6297]="0:15:0:10:Junk::1:0:", -- Old Skull
	[6298]="0:15:0:20:Junk::1:0:", -- Bloody Bat Fang
	[6299]="0:0:1:20:FoodDrink::1:0:", -- Sickly Looking Fish
	[6300]="0:15:0:10:Junk::1:0:", -- Husk Fragment
	[6301]="0:15:0:1:Junk::1:0:", -- Old Teamster's Skull
	[6302]="0:15:0:5:Junk::1:0:", -- Delicate Insect Wing
	[6303]="0:7:1:20:Meat:185:1:0:", -- Raw Slitherskin Mackerel
	[6304]="0:15:0:1:Junk::1:0:", -- Damp Diary Page (Day 4)
	[6305]="0:15:0:1:Junk::1:0:", -- Damp Diary Page (Day 87)
	[6306]="0:15:0:1:Junk::1:0:", -- Damp Diary Page (Day 512)
	[6307]="0:15:1:1:Junk::1:0:", -- Message in a Bottle
	[6308]="0:7:1:20:Meat:185:1:0:", -- Raw Bristle Whisker Catfish
	[6309]="0:4:1:1:OffHandFrill::1:0:", -- 17 Pound Catfish
	[6310]="0:4:1:1:OffHandFrill::1:0:", -- 19 Pound Catfish
	[6311]="0:4:1:1:OffHandFrill::1:0:", -- 22 Pound Catfish
	[6312]="0:12:1:1:::1:0:", -- Dalin's Heart
	[6313]="0:12:1:1:::1:0:", -- Comar's Heart
	[6314]="0:4:3:1:Cloak::1:0:", -- Wolfmaster Cape
	[6315]="0:2:2:1:Crossbow::1:0:", -- Steelarrow Crossbow
	[6316]="0:0:1:20:FoodDrink::1:0:", -- Loch Frenzy Delight
	[6317]="0:7:1:20:Meat:185:1:0:", -- Raw Loch Frenzy
	[6318]="0:2:3:1:Stave::1:0:", -- Odo's Ley Staff
	[6319]="0:4:3:1:Leather::1:0:", -- Girdle of the Blindwatcher
	[6320]="0:4:3:1:Shield::1:0:", -- Commander's Crest
	[6321]="0:4:3:1:Ring::1:0:", -- Silverlaine's Family Seal
	[6323]="0:2:3:1:OneHandMace::1:0:", -- Baron's Scepter
	[6324]="0:4:3:1:Cloth::1:0:", -- Robes of Arugal
	[6325]="40:9:1:1:Cooking::1:0:66,1684,3029,3550,4265,4574,5494,5940,8508", -- Recipe: Brilliant Smallfish
	[6326]="40:9:1:1:Cooking::1:0:3550,4305,5162,5942,10118", -- Recipe: Slitherskin Mackerel
	[6327]="0:2:3:1:TwoHandMace::1:0:", -- The Pacifier
	[6328]="400:9:1:1:Cooking::1:0:66,1684,3027,4265,4574,5162,5748,5940", -- Recipe: Longjaw Mud Snapper
	[6329]="400:9:1:1:Cooking::1:0:1684", -- Recipe: Loch Frenzy Delight
	[6330]="1200:9:1:1:Cooking::1:0:2383,2397,3027,3029,3497,4553,5494", -- Recipe: Bristle Whisker Catfish
	[6331]="0:2:3:1:Dagger::1:0:", -- Howling Blade
	[6332]="0:4:3:1:Ring::1:0:", -- Black Pearl Ring
	[6333]="0:2:2:1:Dagger::1:0:", -- Spikelash Dagger
	[6335]="0:4:2:1:Leather::1:0:", -- Grizzled Boots
	[6336]="0:4:2:1:Mail::1:0:", -- Infantry Tunic
	[6337]="0:4:2:1:Mail::1:0:", -- Infantry Leggings
	[6338]="0:7:1:1:Enchanting:333:1:0:", -- Silver Rod
	[6339]="0:7:1:1:Enchanting:333:1:0:", -- Runed Silver Rod
	[6340]="0:4:3:1:Cloak::1:0:", -- Fenrus' Hide
	[6341]="0:4:3:1:OffHandFrill::1:0:", -- Eerie Stable Lantern
	[6342]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Chest - Minor Mana
	[6344]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Minor Spirit
	[6346]="400:9:2:1:Enchanting::1:1:3346,5757", -- Formula: Enchant Chest - Lesser Mana
	[6347]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Minor Strength
	[6348]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Minor Beastslayer
	[6349]="500:9:1:1:Enchanting::1:1:3012,3346,5158,5758", -- Formula: Enchant 2H Weapon - Lesser Intellect
	[6350]="0:4:2:1:Mail::1:0:", -- Rough Bronze Boots
	[6351]="0:15:1:1:Other::1:0:", -- Dented Crate
	[6352]="0:15:1:1:Other::1:0:", -- Waterlogged Crate
	[6353]="0:15:1:1:Junk::1:0:", -- Small Chest
	[6354]="0:15:1:1:Junk::1:0:", -- Small Locked Chest
	[6355]="0:15:1:1:Junk::1:0:", -- Sturdy Locked Chest
	[6356]="0:15:1:1:Junk::1:0:", -- Battered Chest
	[6357]="0:15:1:1:Other::1:0:", -- Sealed Crate
	[6358]="0:7:1:20:Other:171:1:0:", -- Oily Blackmouth
	[6359]="0:7:1:20:Other:171:1:0:", -- Firefin Snapper
	[6360]="0:2:2:1:OneHandMace::1:0:", -- Steelscale Crushfish
	[6361]="0:7:1:20:Meat:185:1:0:", -- Raw Rainbow Fin Albacore
	[6362]="0:7:1:20:Meat:185:1:0:", -- Raw Rockscale Cod
	[6363]="0:4:1:1:OffHandFrill::1:0:", -- 26 Pound Catfish
	[6364]="0:4:1:1:OffHandFrill::1:0:", -- 32 Pound Catfish
	[6365]="902:2:1:1:FishingPole::1:1:1678,1684,2383,2626,3029,3178,3333,3497,3550,3572,4222,4574,5162,5494,5940,5942,7945,8508,10118,12031,12962,14740,16708,17101,18018,18347,18911,19472,27144,27181,27190,28707,28742,28812,31804,31805", -- Strong Fishing Pole
	[6366]="0:2:1:1:FishingPole::1:0:", -- Darkwood Fishing Pole
	[6367]="0:2:1:1:FishingPole::1:0:", -- Big Iron Fishing Pole
	[6368]="400:9:1:1:Cooking::1:0:3178,3333,3497,4305,4307,4553,5494,5748,5942,10118", -- Recipe: Rainbow Fin Albacore
	[6369]="2200:9:1:1:Cooking::1:0:2383,2664,3178,3333,4307,4574,5162,12033,12962", -- Recipe: Rockscale Cod
	[6370]="0:7:1:20:Other:171,333:1:0:", -- Blackmouth Oil
	[6371]="0:7:1:20:Other:171,333,197:1:0:", -- Fire Oil
	[6372]="0:0:1:20:Potion::1:0:", -- Swim Speed Potion
	[6373]="0:0:1:20:Elixir::1:0:", -- Elixir of Firepower
	[6375]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Lesser Spirit
	[6377]="1000:9:2:1:Enchanting::1:1:3012,3537", -- Formula: Enchant Boots - Minor Agility
	[6378]="0:4:2:1:Cloak::1:0:", -- Seer's Cape
	[6379]="0:4:2:1:Leather::1:0:", -- Inscribed Leather Belt
	[6380]="0:4:2:1:Shield::1:0:", -- Inscribed Buckler
	[6381]="0:4:2:1:Cloak::1:0:", -- Bright Cloak
	[6382]="0:4:2:1:Leather::1:0:", -- Forest Leather Belt
	[6383]="0:4:2:1:Shield::1:0:", -- Forest Buckler
	[6384]="0:4:1:1:Shirt::1:0:", -- Stylish Blue Shirt
	[6385]="0:4:1:1:Shirt::1:0:", -- Stylish Green Shirt
	[6386]="0:4:2:1:Mail::1:0:", -- Glimmering Mail Legguards
	[6387]="0:4:2:1:Mail::1:0:", -- Glimmering Mail Bracers
	[6388]="0:4:2:1:Mail::1:0:", -- Glimmering Mail Pauldrons
	[6389]="0:4:2:1:Mail::1:0:", -- Glimmering Mail Coif
	[6390]="0:9:2:1:Tailoring::1:0:", -- Pattern: Stylish Blue Shirt
	[6391]="0:9:2:1:Tailoring::1:0:", -- Pattern: Stylish Green Shirt
	[6392]="0:4:3:1:Cloth::1:0:", -- Belt of Arugal
	[6393]="0:4:2:1:Cloth::1:0:", -- Silver-thread Gloves
	[6394]="0:4:2:1:Cloth::1:0:", -- Silver-thread Boots
	[6395]="0:4:2:1:Cloth::1:0:", -- Silver-thread Amice
	[6396]="0:4:2:1:Leather::1:0:", -- Emblazoned Chestpiece
	[6397]="0:4:2:1:Leather::1:0:", -- Emblazoned Gloves
	[6398]="0:4:2:1:Leather::1:0:", -- Emblazoned Belt
	[6399]="0:4:2:1:Leather::1:0:", -- Emblazoned Shoulders
	[6400]="0:4:2:1:Shield::1:0:", -- Glimmering Shield
	[6401]="1100:9:1:1:Tailoring::1:1:2394,2669", -- Pattern: Dark Silk Shirt
	[6402]="0:4:2:1:Mail::1:0:", -- Mail Combat Leggings
	[6403]="0:4:2:1:Mail::1:0:", -- Mail Combat Armguards
	[6404]="0:4:2:1:Mail::1:0:", -- Mail Combat Spaulders
	[6405]="0:4:2:1:Cloth::1:0:", -- Nightsky Trousers
	[6406]="0:4:2:1:Cloth::1:0:", -- Nightsky Boots
	[6407]="0:4:2:1:Cloth::1:0:", -- Nightsky Wristbands
	[6408]="0:4:2:1:Leather::1:0:", -- Insignia Gloves
	[6409]="0:4:2:1:Leather::1:0:", -- Insignia Belt
	[6410]="0:4:2:1:Leather::1:0:", -- Insignia Bracers
	[6411]="0:4:2:1:Mail::1:0:", -- Chief Brigadier Armor
	[6412]="0:4:2:1:Mail::1:0:", -- Chief Brigadier Boots
	[6413]="0:4:2:1:Mail::1:0:", -- Chief Brigadier Bracers
	[6414]="0:4:3:1:Ring::1:0:", -- Seal of Sylvanas
	[6415]="0:4:2:1:Cloth::1:0:", -- Aurora Robe
	[6416]="0:4:2:1:Cloth::1:0:", -- Aurora Boots
	[6417]="0:4:2:1:Cloak::1:0:", -- Aurora Cloak
	[6418]="0:4:2:1:Cloth::1:0:", -- Aurora Sash
	[6419]="0:4:2:1:Leather::1:0:", -- Glyphed Mitts
	[6420]="0:4:2:1:Leather::1:0:", -- Glyphed Boots
	[6421]="0:4:2:1:Leather::1:0:", -- Glyphed Belt
	[6422]="0:4:2:1:Leather::1:0:", -- Glyphed Helm
	[6423]="0:4:2:1:Mail::1:0:", -- Blackforge Greaves
	[6424]="0:4:2:1:Cloak::1:0:", -- Blackforge Cape
	[6425]="0:4:2:1:Mail::1:0:", -- Blackforge Girdle
	[6426]="0:4:2:1:Mail::1:0:", -- Blackforge Bracers
	[6427]="0:4:2:1:Cloth::1:0:", -- Mistscape Robe
	[6428]="0:4:2:1:Cloth::1:0:", -- Mistscape Gloves
	[6429]="0:4:2:1:Cloth::1:0:", -- Mistscape Wizard Hat
	[6430]="0:4:2:1:Leather::1:0:", -- Imperial Leather Breastplate
	[6431]="0:4:2:1:Leather::1:0:", -- Imperial Leather Boots
	[6432]="0:4:2:1:Cloak::1:0:", -- Imperial Cloak
	[6433]="0:4:2:1:Leather::1:0:", -- Imperial Leather Helm
	[6435]="0:12:1:20:::1:0:", -- Infused Burning Gem
	[6436]="0:12:1:1:::1:0:", -- Burning Gem
	[6438]="0:15:0:5:Junk::1:0:", -- Dull Elemental Bracer
	[6439]="0:15:0:5:Junk::1:0:", -- Broken Binding Bracer
	[6440]="0:4:3:1:Ring::1:0:", -- Brainlash
	[6441]="0:12:1:1:::1:0:", -- Shadowstalker Scalp
	[6442]="0:12:1:1:::1:0:", -- Oracle Crystal
	[6443]="0:12:1:20:::1:0:", -- Deviate Hide
	[6444]="0:15:0:5:Junk::1:0:", -- Forked Tongue
	[6445]="0:15:0:5:Junk::1:0:", -- Brittle Molting
	[6446]="0:1:3:1:Bag::1:0:", -- Snakeskin Bag
	[6447]="0:4:3:1:Shield::1:0:", -- Worn Turtle Shell Shield
	[6448]="0:2:3:1:Dagger::1:0:", -- Tail Spike
	[6449]="0:4:3:1:Cloak::1:0:", -- Glowing Lizardscale Cloak
	[6450]="0:0:1:20:Bandage::1:0:", -- Silk Bandage
	[6451]="0:0:1:20:Bandage::1:0:", -- Heavy Silk Bandage
	[6452]="0:0:1:20:Other::1:0:", -- Anti-Venom
	[6453]="0:0:1:20:Other::1:0:", -- Strong Anti-Venom
	[6454]="0:9:2:1:FirstAid::1:0:", -- Manual: Strong Anti-Venom
	[6455]="0:15:0:5:Junk::1:0:", -- Old Wagonwheel
	[6456]="0:15:0:10:Junk::1:0:", -- Acidic Slime
	[6457]="0:15:0:5:Junk::1:0:", -- Rusted Engineering Parts
	[6458]="0:0:1:20:Other::1:0:", -- Oil Covered Fish
	[6459]="0:4:3:1:Mail::1:0:", -- Savage Trodders
	[6460]="0:4:3:1:Mail::1:0:", -- Cobrahn's Grasp
	[6461]="0:4:3:1:Cloth::1:0:", -- Slime-encrusted Pads
	[6462]="0:12:1:1:::1:0:", -- Secure Crate
	[6463]="0:4:3:1:Ring::1:0:", -- Deep Fathom Ring
	[6464]="0:0:1:20:Consumable::1:0:", -- Wailing Essence
	[6465]="0:4:3:1:Cloth::1:0:", -- Robe of the Moccasin
	[6466]="0:4:2:1:Cloak::1:0:", -- Deviate Scale Cloak
	[6467]="0:4:2:1:Leather::1:0:", -- Deviate Scale Gloves
	[6468]="0:4:3:1:Leather::1:0:", -- Deviate Scale Belt
	[6469]="0:2:3:1:Bow::1:0:", -- Venomstrike
	[6470]="0:7:1:20:Leather:165:1:0:", -- Deviate Scale
	[6471]="0:7:1:20:Leather:165:1:0:", -- Perfect Deviate Scale
	[6472]="0:2:3:1:OneHandMace::1:0:", -- Stinging Viper
	[6473]="0:4:3:1:Leather::1:0:", -- Armor of the Fang
	[6474]="550:9:1:1:Leatherworking::1:1:5783", -- Pattern: Deviate Scale Cloak
	[6475]="1500:9:1:1:Leatherworking::1:1:5783", -- Pattern: Deviate Scale Gloves
	[6476]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Deviate Scale Belt
	[6477]="0:4:2:1:Cloth::1:0:", -- Grassland Sash
	[6479]="0:12:1:1:::1:0:", -- Malem Pendant
	[6480]="0:4:2:1:Leather::1:0:", -- Slick Deviate Leggings
	[6481]="0:4:2:1:Mail::1:0:", -- Dagmire Gauntlets
	[6482]="0:4:2:1:Cloth::1:0:", -- Firewalker Boots
	[6486]="0:0:1:20:Consumable::1:0:", -- Singed Scale
	[6487]="0:12:1:20:::1:0:", -- Vile Familiar Head
	[6488]="0:12:1:1:::1:0:", -- Simple Tablet
	[6502]="0:4:2:1:Mail::1:0:", -- Violet Scale Armor
	[6503]="0:4:2:1:Cloth::1:0:", -- Harlequin Robes
	[6504]="0:2:3:1:OneHandSword::1:0:", -- Wingblade
	[6505]="0:2:3:1:Stave::1:0:", -- Crescent Staff
	[6506]="0:4:1:1:Mail::1:0:", -- Infantry Boots
	[6507]="0:4:1:1:Mail::1:0:", -- Infantry Bracers
	[6508]="0:4:1:1:Cloak::1:0:", -- Infantry Cloak
	[6509]="0:4:1:1:Mail::1:0:", -- Infantry Belt
	[6510]="0:4:1:1:Mail::1:0:", -- Infantry Gauntlets
	[6511]="0:4:2:1:Cloth::1:0:", -- Journeyman's Robe
	[6512]="0:4:2:1:Cloth::1:0:", -- Disciple's Robe
	[6513]="0:4:1:1:Cloth::1:0:", -- Disciple's Sash
	[6514]="0:4:1:1:Cloak::1:0:", -- Disciple's Cloak
	[6515]="0:4:1:1:Cloth::1:0:", -- Disciple's Gloves
	[6517]="0:4:1:1:Leather::1:0:", -- Pioneer Belt
	[6518]="0:4:1:1:Leather::1:0:", -- Pioneer Boots
	[6519]="0:4:1:1:Leather::1:0:", -- Pioneer Bracers
	[6520]="0:4:1:1:Cloak::1:0:", -- Pioneer Cloak
	[6521]="0:4:1:1:Leather::1:0:", -- Pioneer Gloves
	[6522]="0:0:1:20:FoodDrink:171,185:1:0:", -- Deviate Fish
	[6523]="1422:4:1:1:Leather::1:0:3023,3359", -- Buckled Harness
	[6524]="2871:4:1:1:Leather::1:0:3023,3359", -- Studded Leather Harness
	[6525]="5168:4:1:1:Leather::1:0:3023,3359", -- Grunt's Harness
	[6526]="12487:4:1:1:Leather::1:0:3023,3359", -- Battle Harness
	[6527]="0:4:2:1:Cloth::1:0:", -- Ancestral Robe
	[6528]="0:4:2:1:Cloth::1:0:", -- Spellbinder Robe
	[6529]="50:0:1:20:EnhTemp::1:0:66,777,843,1250,1465,1678,1684,1692,2118,2225,2383,2626,3029,3081,3168,3178,3187,3333,3482,3497,3499,3550,3556,3572,3614,4194,4222,4574,5135,5162,5494,5817,5940,5942,6301,7945,8508,8934,10118,10216,12028,12031,12043,12962,14740,16224,16261,16262,16708,17101,17490,18018,18347,18426,18427,18911,19472,27144,27181,27190,28707,28742,28812,31804,31805", -- Shiny Bauble
	[6530]="100:0:1:20:EnhTemp:202:1:0:777,843,960,989,1148,1286,1456,1465,1678,1684,2225,2381,2383,2393,2626,2810,2821,3029,3178,3333,3367,3482,3497,3499,3550,3556,3572,3779,3954,3955,4194,4222,4229,4561,4574,4775,4877,4897,5100,5135,5162,5163,5494,5817,5940,5942,6301,7945,7947,8145,8363,8508,8934,9636,10118,11189,12022,12028,12031,12043,12245,12941,12957,12958,12962,14740,15179,16224,16613,16708,16768,17101,17486,17490,18009,18018,18347,18426,18427,18911,19244,19372,19450,19472,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,27144,27181,27190,28692,28707,28742,28812,28831,28872,29288,30311,31804,31805", -- Nightcrawlers
	[6531]="0:4:2:1:Cloth::1:0:", -- Barbaric Cloth Robe
	[6532]="250:0:1:20:EnhTemp::1:0:960,989,1148,1286,1456,1678,1684,2225,2381,2383,2393,2626,2810,2821,3029,3178,3333,3367,3497,3550,3572,3779,3954,3955,4222,4229,4561,4574,4775,4877,4897,5100,5135,5162,5163,5494,5817,5940,5942,6301,7945,7947,8145,8363,8508,8934,9636,10118,11189,12022,12028,12031,12245,12941,12957,12958,12962,14740,15179,16602,16613,16708,16768,16826,17101,17486,18009,18015,18018,18347,18907,18911,18960,19015,19017,19042,19194,19197,19244,19345,19372,19450,19472,19497,19533,19562,19573,20081,20092,20194,20250,20891,21083,21113,22099,22271,23802,24054,24147,24188,24341,24356,24843,24935,24995,25010,25019,25034,25051,25082,26374,26474,26720,26939,26941,27012,27021,27026,27043,27057,27063,27070,27132,27144,27146,27181,27184,27190,27195,27938,28692,28707,28742,28794,28806,28812,28831,28872,29208,29270,29277,29288,30311,30345,30438,30825,31115,31804,31805,32477,32639,32641,33669,37904,37935", -- Bright Baubles
	[6533]="250:0:1:20:EnhTemp::1:1:1678,1684,2383,2626,3029,3178,3333,3497,3550,3572,4222,4574,5162,5494,5940,5942,7945,8508,10118,12031,12962,14740,16708,17101,18018,18347,18911,19472,27144,27181,27190,28707,28742,28812,31804,31805", -- Aquadynamic Fish Attractor
	[6534]="0:12:1:1:::1:0:", -- Forged Steel Bars
	[6535]="0:12:1:1:::1:0:", -- Tablet of Verga
	[6536]="0:4:2:1:Cloth::1:0:", -- Willow Vest
	[6537]="0:4:2:1:Cloth::1:0:", -- Willow Boots
	[6538]="0:4:2:1:Cloth::1:0:", -- Willow Robe
	[6539]="0:4:2:1:Cloth::1:0:", -- Willow Belt
	[6540]="0:4:2:1:Cloth::1:0:", -- Willow Pants
	[6541]="0:4:2:1:Cloth::1:0:", -- Willow Gloves
	[6542]="0:4:2:1:Cloak::1:0:", -- Willow Cape
	[6543]="0:4:2:1:Cloth::1:0:", -- Willow Bracers
	[6545]="0:4:2:1:Mail::1:0:", -- Soldier's Armor
	[6546]="0:4:2:1:Mail::1:0:", -- Soldier's Leggings
	[6547]="0:4:2:1:Mail::1:0:", -- Soldier's Gauntlets
	[6548]="0:4:2:1:Mail::1:0:", -- Soldier's Girdle
	[6549]="0:4:1:1:Cloak::1:0:", -- Soldier's Cloak
	[6550]="0:4:2:1:Mail::1:0:", -- Soldier's Wristguards
	[6551]="0:4:2:1:Mail::1:0:", -- Soldier's Boots
	[6552]="0:4:2:1:Leather::1:0:", -- Bard's Tunic
	[6553]="0:4:2:1:Leather::1:0:", -- Bard's Trousers
	[6554]="0:4:2:1:Leather::1:0:", -- Bard's Gloves
	[6555]="0:4:1:1:Cloak::1:0:", -- Bard's Cloak
	[6556]="0:4:2:1:Leather::1:0:", -- Bard's Bracers
	[6557]="0:4:2:1:Leather::1:0:", -- Bard's Boots
	[6558]="0:4:2:1:Leather::1:0:", -- Bard's Belt
	[6559]="0:4:2:1:Shield::1:0:", -- Bard's Buckler
	[6560]="0:4:2:1:Shield::1:0:", -- Soldier's Shield
	[6561]="0:4:2:1:Cloth::1:0:", -- Seer's Padded Armor
	[6562]="0:4:2:1:Cloth::1:0:", -- Shimmering Boots
	[6563]="0:4:2:1:Cloth::1:0:", -- Shimmering Bracers
	[6564]="0:4:2:1:Cloak::1:0:", -- Shimmering Cloak
	[6565]="0:4:2:1:Cloth::1:0:", -- Shimmering Gloves
	[6566]="0:4:1:1:Cloth::1:0:", -- Shimmering Amice
	[6567]="0:4:2:1:Cloth::1:0:", -- Shimmering Armor
	[6568]="0:4:2:1:Cloth::1:0:", -- Shimmering Trousers
	[6569]="0:4:2:1:Cloth::1:0:", -- Shimmering Robe
	[6570]="0:4:2:1:Cloth::1:0:", -- Shimmering Sash
	[6571]="0:4:2:1:Shield::1:0:", -- Scouting Buckler
	[6572]="0:4:2:1:Shield::1:0:", -- Defender Shield
	[6573]="0:4:2:1:Mail::1:0:", -- Defender Boots
	[6574]="0:4:2:1:Mail::1:0:", -- Defender Bracers
	[6575]="0:4:2:1:Cloak::1:0:", -- Defender Cloak
	[6576]="0:4:2:1:Mail::1:0:", -- Defender Girdle
	[6577]="0:4:2:1:Mail::1:0:", -- Defender Gauntlets
	[6578]="0:4:2:1:Mail::1:0:", -- Defender Leggings
	[6579]="0:4:1:1:Mail::1:0:", -- Defender Spaulders
	[6580]="0:4:2:1:Mail::1:0:", -- Defender Tunic
	[6581]="0:4:2:1:Leather::1:0:", -- Scouting Belt
	[6582]="0:4:2:1:Leather::1:0:", -- Scouting Boots
	[6583]="0:4:2:1:Leather::1:0:", -- Scouting Bracers
	[6584]="0:4:2:1:Leather::1:0:", -- Scouting Tunic
	[6585]="0:4:2:1:Cloak::1:0:", -- Scouting Cloak
	[6586]="0:4:2:1:Leather::1:0:", -- Scouting Gloves
	[6587]="0:4:2:1:Leather::1:0:", -- Scouting Trousers
	[6588]="0:4:1:1:Leather::1:0:", -- Scouting Spaulders
	[6590]="0:4:2:1:Mail::1:0:", -- Battleforge Boots
	[6591]="0:4:2:1:Mail::1:0:", -- Battleforge Wristguards
	[6592]="0:4:2:1:Mail::1:0:", -- Battleforge Armor
	[6593]="0:4:2:1:Cloak::1:0:", -- Battleforge Cloak
	[6594]="0:4:2:1:Mail::1:0:", -- Battleforge Girdle
	[6595]="0:4:2:1:Mail::1:0:", -- Battleforge Gauntlets
	[6596]="0:4:2:1:Mail::1:0:", -- Battleforge Legguards
	[6597]="0:4:2:1:Mail::1:0:", -- Battleforge Shoulderguards
	[6598]="0:4:2:1:Shield::1:0:", -- Dervish Buckler
	[6599]="0:4:2:1:Shield::1:0:", -- Battleforge Shield
	[6600]="0:4:2:1:Leather::1:0:", -- Dervish Belt
	[6601]="0:4:2:1:Leather::1:0:", -- Dervish Boots
	[6602]="0:4:2:1:Leather::1:0:", -- Dervish Bracers
	[6603]="0:4:2:1:Leather::1:0:", -- Dervish Tunic
	[6604]="0:4:2:1:Cloak::1:0:", -- Dervish Cape
	[6605]="0:4:2:1:Leather::1:0:", -- Dervish Gloves
	[6607]="0:4:2:1:Leather::1:0:", -- Dervish Leggings
	[6608]="0:4:2:1:Cloth::1:0:", -- Bright Armor
	[6609]="0:4:2:1:Cloth::1:0:", -- Sage's Cloth
	[6610]="0:4:2:1:Cloth::1:0:", -- Sage's Robe
	[6611]="0:4:2:1:Cloth::1:0:", -- Sage's Sash
	[6612]="0:4:2:1:Cloth::1:0:", -- Sage's Boots
	[6613]="0:4:2:1:Cloth::1:0:", -- Sage's Bracers
	[6614]="0:4:2:1:Cloak::1:0:", -- Sage's Cloak
	[6615]="0:4:2:1:Cloth::1:0:", -- Sage's Gloves
	[6616]="0:4:2:1:Cloth::1:0:", -- Sage's Pants
	[6617]="0:4:2:1:Cloth::1:0:", -- Sage's Mantle
	[6622]="0:2:3:1:OneHandSword::1:0:", -- Sword of Zeal
	[6624]="0:12:1:1:::1:0:", -- Ken'zigla's Draught
	[6625]="0:12:1:1:::1:0:", -- Dirt-caked Pendant
	[6626]="0:12:1:1:::1:0:", -- Dogran's Pendant
	[6627]="0:4:3:1:Mail::1:0:", -- Mutant Scale Breastplate
	[6628]="0:4:2:1:Cloth::1:0:", -- Raven's Claws
	[6629]="0:4:3:1:Cloak::1:0:", -- Sporid Cape
	[6630]="0:4:3:1:Shield::1:0:", -- Seedcloud Buckler
	[6631]="0:2:3:1:Stave::1:0:", -- Living Root
	[6632]="0:4:3:1:Cloak::1:0:", -- Feyscale Cloak
	[6633]="0:2:3:1:OneHandSword::1:0:", -- Butcher's Slicer
	[6634]="0:12:1:20:::1:0:", -- Ritual Salve
	[6635]="0:0:1:1:Consumable::1:0:", -- Earth Sapta
	[6636]="0:0:1:1:Consumable::1:0:", -- Fire Sapta
	[6637]="0:0:1:1:Consumable::1:0:", -- Water Sapta
	[6640]="0:12:1:20:::1:0:", -- Felstalker Hoof
	[6641]="0:2:3:1:TwoHandSword::1:0:", -- Haunting Blade
	[6642]="0:4:3:1:Mail::1:0:", -- Phantom Armor
	[6643]="0:15:1:1:Other::1:0:", -- Bloated Smallfish
	[6645]="0:15:1:1:Other::1:0:", -- Bloated Mud Snapper
	[6647]="0:15:1:1:Other::1:0:", -- Bloated Catfish
	[6651]="0:2:1:1:OneHandMace::1:0:", -- Broken Wine Bottle
	[6652]="0:12:1:1:::1:0:", -- Reagent Pouch
	[6653]="0:4:1:1:OffHandFrill::1:0:", -- Torch of the Dormant Flame
	[6654]="0:4:1:1:OffHandFrill::1:0:", -- Torch of the Eternal Flame
	[6655]="0:12:1:1:::1:0:", -- Glowing Ember
	[6656]="0:12:1:1:::1:0:", -- Rough Quartz
	[6657]="0:0:1:20:FoodDrink::1:0:", -- Savory Deviate Delight
	[6658]="0:12:1:1:::1:0:", -- Example Collar
	[6659]="0:4:2:1:Cloth::1:0:", -- Scarab Trousers
	[6660]="0:2:3:1:Dagger::1:0:", -- Julie's Dagger
	[6661]="0:9:2:1:Cooking::1:0:", -- Recipe: Savory Deviate Delight
	[6662]="0:0:1:20:Elixir::1:0:", -- Elixir of Giant Growth
	[6663]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Giant Growth
	[6664]="0:4:2:1:Cloth::1:0:", -- Voodoo Mantle
	[6665]="0:4:2:1:Mail::1:0:", -- Hexed Bracers
	[6666]="0:4:2:1:Mail::1:0:", -- Dredge Boots
	[6667]="0:4:2:1:Cloak::1:0:", -- Engineer's Cloak
	[6668]="0:4:2:1:Leather::1:0:", -- Draftsman Boots
	[6669]="0:4:2:1:Ring::1:0:", -- Sacred Band
	[6670]="0:4:2:1:Leather::1:0:", -- Panther Armor
	[6671]="0:4:2:1:Mail::1:0:", -- Juggernaut Leggings
	[6672]="0:9:2:1:Engineering::1:0:", -- Schematic: Flash Bomb
	[6675]="0:4:2:1:Mail::1:0:", -- Tempered Bracers
	[6676]="0:4:2:1:Shield::1:0:", -- Constable Buckler
	[6677]="0:2:2:1:Wand::1:0:", -- Spellcrafter Wand
	[6678]="0:4:2:1:Ring::1:0:", -- Band of Elven Grace
	[6679]="0:2:3:1:Polearm::1:0:", -- Armor Piercer
	[6681]="0:2:3:1:Dagger::1:0:", -- Thornspike
	[6682]="0:4:3:1:Cloth::1:0:", -- Death Speaker Robes
	[6684]="0:12:1:1:::1:0:", -- Snufflenose Command Stick
	[6685]="0:4:3:1:Cloth::1:0:", -- Death Speaker Mantle
	[6686]="0:4:3:1:Mail::1:0:", -- Tusken Helm
	[6687]="0:2:3:1:TwoHandAxe::1:0:", -- Corpsemaker
	[6688]="0:4:3:1:Leather::1:0:", -- Whisperwind Headdress
	[6689]="0:2:3:1:Stave::1:0:", -- Wind Spirit Staff
	[6690]="0:4:3:1:Leather::1:0:", -- Ferine Leggings
	[6691]="0:2:3:1:Dagger::1:0:", -- Swinetusk Shank
	[6692]="0:2:3:1:OneHandAxe::1:0:", -- Pronged Reaver
	[6693]="0:4:3:1:Ring::1:0:", -- Agamaggan's Clutch
	[6694]="0:4:3:1:Shield::1:0:", -- Heart of Agamaggan
	[6695]="0:4:3:1:Amulet::1:0:", -- Stygian Bone Amulet
	[6696]="0:2:3:1:Bow::1:0:", -- Nightstalker Bow
	[6697]="0:4:3:1:Cloth::1:0:", -- Batwing Mantle
	[6709]="0:4:2:1:Leather::1:0:", -- Moonglow Vest
	[6710]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Moonglow Vest
	[6712]="0:15:1:1:Junk::1:0:", -- Practice Lock
	[6713]="0:4:1:1:Cloth::1:0:", -- Ripped Pants
	[6714]="0:7:1:20:Explosive::1:0:", -- Ez-Thro Dynamite
	[6715]="0:7:1:1:Device::1:0:", -- Ruined Jumper Cables
	[6716]="0:9:2:1:Engineering::1:0:", -- Schematic: EZ-Thro Dynamite
	[6717]="0:12:1:20:::1:0:", -- Gaffer Jack
	[6718]="0:12:1:20:::1:0:", -- Electropeller
	[6719]="0:4:2:1:Leather::1:0:", -- Windborne Belt
	[6720]="0:4:2:1:Leather::1:0:", -- Spirit Hunter Headdress
	[6721]="0:4:2:1:Mail::1:0:", -- Chestplate of Kor
	[6722]="0:4:2:1:Mail::1:0:", -- Beastial Manacles
	[6723]="0:4:3:1:Amulet::1:0:", -- Medal of Courage
	[6725]="0:4:3:1:Shield::1:0:", -- Marbled Buckler
	[6726]="0:4:2:1:Cloth::1:0:", -- Razzeric's Customized Seatbelt
	[6727]="0:4:2:1:Leather::1:0:", -- Razzeric's Racing Grips
	[6729]="0:2:2:1:Wand::1:0:", -- Fizzle's Zippy Lighter
	[6730]="0:4:2:1:Mail::1:0:", -- Ironforge Chain
	[6731]="0:4:2:1:Mail::1:0:", -- Ironforge Breastplate
	[6732]="0:4:2:1:Leather::1:0:", -- Gnomish Mechanic's Gloves
	[6733]="0:4:2:1:Mail::1:0:", -- Ironforge Gauntlets
	[6735]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Ironforge Breastplate
	[6737]="0:4:2:1:Cloth::1:0:", -- Dryleaf Pants
	[6738]="0:2:2:1:OneHandAxe::1:0:", -- Bleeding Crescent
	[6739]="0:2:2:1:Bow::1:0:", -- Cliffrunner's Aim
	[6740]="0:4:2:1:Leather::1:0:", -- Azure Sash
	[6741]="0:2:1:1:TwoHandSword::1:0:", -- Orcish War Sword
	[6742]="0:4:3:1:Mail::1:0:", -- Stonefist Girdle
	[6743]="0:4:2:1:Ring::1:0:", -- Sustaining Ring
	[6744]="0:4:2:1:Cloth::1:0:", -- Gloves of Kapelan
	[6745]="0:4:2:1:Cloak::1:0:", -- Swiftrunner Cape
	[6746]="0:4:2:1:Shield::1:0:", -- Basalt Buckler
	[6747]="0:4:2:1:Mail::1:0:", -- Enforcer Pauldrons
	[6748]="0:4:2:1:Ring::1:0:", -- Monkey Ring
	[6749]="0:4:2:1:Ring::1:0:", -- Tiger Band
	[6750]="0:4:2:1:Ring::1:0:", -- Snake Hoop
	[6751]="0:4:2:1:Cloak::1:0:", -- Mourning Shawl
	[6752]="0:4:2:1:Leather::1:0:", -- Lancer Boots
	[6753]="0:12:1:20:::1:0:", -- Feather Charm
	[6755]="0:15:1:1:Junk::1:0:", -- A Small Container of Gems
	[6756]="0:1:1:1:Bag::1:0:", -- Jewelry Box
	[6757]="0:4:2:1:Ring::1:0:", -- Jaina's Signet Ring
	[6767]="0:12:1:1:::1:0:", -- Tyranis' Pendant
	[6773]="0:4:2:1:Mail::1:0:", -- Gelkis Marauder Chain
	[6774]="0:4:2:1:OffHandFrill::1:0:", -- Uthek's Finger
	[6776]="0:12:1:1:::1:0:", -- Tome of Valor
	[6780]="0:4:2:1:Cloth::1:0:", -- Lilac Sash
	[6781]="0:0:1:1:Consumable::1:0:", -- Bartleby's Mug
	[6782]="0:0:1:1:Consumable::1:0:", -- Marshal Haggard's Badge
	[6783]="0:13:1:1:::1:0:", -- Dead-tooth's Key
	[6784]="0:4:2:1:Leather::1:0:", -- Braced Handguards
	[6785]="0:12:1:1:::1:0:", -- Powers of the Void
	[6786]="0:4:1:1:Miscellaneous::1:0:", -- Simple Dress
	[6787]="0:4:1:1:Miscellaneous::1:0:", -- White Woolen Dress
	[6788]="0:4:2:1:Leather::1:0:", -- Magram Hunter's Belt
	[6789]="0:4:2:1:Cloak::1:0:", -- Ceremonial Centaur Blanket
	[6790]="0:4:2:1:Ring::1:0:", -- Ring of Calm
	[6791]="0:4:2:1:Cloth::1:0:", -- Hellion Boots
	[6792]="0:4:2:1:Mail::1:0:", -- Sanguine Pauldrons
	[6793]="0:4:2:1:Mail::1:0:", -- Auric Bracers
	[6794]="0:4:2:1:Leather::1:0:", -- Stormfire Gauntlets
	[6795]="0:4:1:1:Shirt::1:0:", -- White Swashbuckler's Shirt
	[6796]="0:4:1:1:Shirt::1:0:", -- Red Swashbuckler's Shirt
	[6797]="0:2:2:1:Wand::1:0:", -- Eyepoker
	[6798]="0:2:2:1:Gun::1:0:", -- Blasting Hackbut
	[6799]="0:12:1:1:::1:0:", -- Vejrek's Head
	[6800]="0:12:1:20:::1:0:", -- Umbral Ore
	[6801]="0:4:2:1:Cloth::1:0:", -- Baroque Apron
	[6802]="0:2:3:1:OneHandSword::1:0:", -- Sword of Omen
	[6803]="0:4:3:1:OffHandFrill::1:0:", -- Prophetic Cane
	[6804]="0:2:3:1:OneHandMace::1:0:", -- Windstorm Hammer
	[6805]="0:12:1:1:::1:0:", -- Horn of Vorlus
	[6806]="0:2:3:1:Wand::1:0:", -- Dancing Flame
	[6807]="0:0:1:20:FoodDrink::1:0:", -- Frog Leg Stew
	[6808]="0:12:1:20:::1:0:", -- Elunite Ore
	[6809]="0:12:1:1:::1:0:", -- Elura's Medallion
	[6810]="0:12:1:1:::1:0:", -- Surena's Choker
	[6811]="0:0:1:20:EnhTemp::1:0:", -- Aquadynamic Fish Lens
	[6812]="0:0:1:1:Consumable::1:0:", -- Case of Elunite
	[6826]="0:15:0:10:Junk::1:0:", -- Brilliant Scale
	[6827]="0:15:1:1:Junk::1:0:", -- Box of Supplies
	[6828]="0:4:2:1:Shield::1:0:", -- Visionary Buckler
	[6829]="0:2:3:1:OneHandSword::1:0:", -- Sword of Serenity
	[6830]="0:2:3:1:TwoHandAxe::1:0:", -- Bonebiter
	[6831]="0:2:3:1:Dagger::1:0:", -- Black Menace
	[6832]="0:4:2:1:Cloak::1:0:", -- Cloak of Blight
	[6833]="0:4:1:1:Shirt::1:0:32836,32837", -- White Tuxedo Shirt
	[6835]="0:4:1:1:Cloth::1:0:32836,32837", -- Black Tuxedo Pants
	[6836]="0:4:1:1:Cloth::1:0:", -- Dress Shoes
	[6838]="0:12:1:20:::1:0:", -- Scorched Spider Fang
	[6839]="0:12:1:20:::1:0:", -- Charred Horn
	[6840]="0:12:1:20:::1:0:", -- Galvanized Horn
	[6841]="0:0:1:1:Consumable::1:0:", -- Vial of Phlogiston
	[6842]="0:0:1:1:Consumable::1:0:", -- Furen's Instructions
	[6843]="0:12:1:1:::1:0:", -- Cask of Scalder
	[6844]="0:12:1:20:::1:0:", -- Burning Blood
	[6845]="0:12:1:20:::1:0:", -- Burning Rock
	[6846]="0:12:1:1:::1:0:", -- Defias Script
	[6847]="0:12:1:1:::1:0:", -- Dark Iron Script
	[6848]="0:12:1:20:::1:0:", -- Searing Coral
	[6849]="0:12:1:20:::1:0:", -- Sunscorched Shell
	[6851]="0:0:1:1:Consumable::1:0:", -- Essence of the Exile
	[6866]="0:12:1:1:::1:0:", -- Symbol of Life
	[6887]="0:0:1:20:FoodDrink::1:0:", -- Spotted Yellowtail
	[6888]="0:0:1:20:FoodDrink::1:0:", -- Herb Baked Egg
	[6889]="0:7:1:20:Meat:185:1:0:", -- Small Egg
	[6890]="0:0:1:20:FoodDrink::1:0:", -- Smoked Bear Meat
	[6892]="250:9:1:1:Cooking::1:0:1465,3556", -- Recipe: Smoked Bear Meat
	[6893]="0:13:1:1:::1:0:", -- Workshop Key
	[6894]="0:12:1:1:::1:0:", -- Whirlwind Heart
	[6895]="0:12:1:1:::1:0:", -- Jordan's Smithing Hammer
	[6898]="0:4:2:1:OffHandFrill::1:0:", -- Orb of Soran'ruk
	[6900]="0:4:3:1:Cloth::1:0:", -- Enchanted Gold Bloodrobe
	[6901]="0:4:3:1:Cloak::1:0:", -- Glowing Thresher Cape
	[6902]="0:4:3:1:Leather::1:0:", -- Bands of Serra'kis
	[6903]="0:4:3:1:Cloth::1:0:", -- Gaze Dreamer Pants
	[6904]="0:2:3:1:Dagger::1:0:", -- Bite of Serra'kis
	[6905]="0:2:3:1:TwoHandAxe::1:0:", -- Reef Axe
	[6906]="0:4:3:1:Mail::1:0:", -- Algae Fists
	[6907]="0:4:3:1:Mail::1:0:", -- Tortoise Armor
	[6908]="0:4:3:1:Cloth::1:0:", -- Ghamoo-ra's Bind
	[6909]="0:2:3:1:TwoHandSword::1:0:", -- Strike of the Hydra
	[6910]="0:4:3:1:Cloth::1:0:", -- Leech Pants
	[6911]="0:4:3:1:Leather::1:0:", -- Moss Cinch
	[6912]="0:12:1:1:::1:0:", -- Heartswood
	[6913]="0:12:1:1:::1:0:", -- Heartswood Core
	[6914]="0:12:1:20:::1:0:", -- Soran'ruk Fragment
	[6915]="0:12:1:1:::1:0:", -- Large Soran'ruk Fragment
	[6926]="0:0:1:1:Consumable::1:0:", -- Furen's Notes
	[6927]="0:0:1:1:Consumable::1:0:", -- Big Will's Ear
	[6928]="0:12:1:1:::1:0:", -- Bloodstone Choker
	[6929]="0:0:1:1:Consumable::1:0:", -- Bath'rah's Parchment
	[6930]="0:12:1:20:::1:0:", -- Rod of Channeling
	[6931]="0:12:1:1:::1:0:", -- Moldy Tome
	[6947]="25:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Instant Poison
	[6948]="0:15:1:1:Junk::1:0:", -- Hearthstone
	[6949]="50:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Instant Poison II
	[6950]="150:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Instant Poison III
	[6951]="0:15:0:20:Junk::1:0:", -- Mind-numbing Poison II
	[6952]="0:12:1:20:::1:0:", -- Thick Bear Fur
	[6953]="0:2:3:1:TwoHandMace::1:0:", -- Verigan's Fist
	[6966]="0:2:2:1:OneHandAxe::1:0:", -- Elunite Axe
	[6967]="0:2:2:1:OneHandSword::1:0:", -- Elunite Sword
	[6968]="0:2:2:1:OneHandMace::1:0:", -- Elunite Hammer
	[6969]="0:2:2:1:Dagger::1:0:", -- Elunite Dagger
	[6970]="0:4:2:1:Shield::1:0:", -- Furen's Favor
	[6971]="0:4:2:1:Mail::1:0:", -- Fire Hardened Coif
	[6972]="0:4:3:1:Mail::1:0:", -- Fire Hardened Hauberk
	[6973]="0:4:2:1:Mail::1:0:", -- Fire Hardened Leggings
	[6974]="0:4:2:1:Mail::1:0:", -- Fire Hardened Gauntlets
	[6975]="0:2:3:1:TwoHandAxe::1:0:", -- Whirlwind Axe
	[6976]="0:2:3:1:TwoHandMace::1:0:", -- Whirlwind Warhammer
	[6977]="0:2:3:1:TwoHandSword::1:0:", -- Whirlwind Sword
	[6978]="0:2:2:1:OneHandAxe::1:0:", -- Umbral Axe
	[6979]="0:2:2:1:OneHandAxe::1:0:", -- Haggard's Axe
	[6980]="0:2:2:1:Dagger::1:0:", -- Haggard's Dagger
	[6981]="0:2:2:1:Dagger::1:0:", -- Umbral Dagger
	[6982]="0:2:2:1:OneHandMace::1:0:", -- Umbral Mace
	[6983]="0:2:2:1:OneHandMace::1:0:", -- Haggard's Hammer
	[6984]="0:2:2:1:OneHandSword::1:0:", -- Umbral Sword
	[6985]="0:2:2:1:OneHandSword::1:0:", -- Haggard's Sword
	[6986]="0:15:0:10:Junk::1:0:", -- Crimson Lotus
	[6989]="0:12:1:20:::1:0:", -- Vial of Hatefury Blood
	[6990]="0:12:1:1:::1:0:", -- Lesser Infernal Stone
	[6991]="0:12:1:20:::1:0:", -- Smoldering Coal
	[6992]="0:12:1:1:::1:0:", -- Jordan's Ore Shipment
	[6993]="0:12:1:1:::1:0:", -- Jordan's Refined Ore Shipment
	[6994]="0:12:1:1:::1:0:", -- Whitestone Oak Lumber
	[6995]="0:12:1:1:::1:0:", -- Corrupted Kor Gem
	[6996]="0:12:1:1:::1:0:", -- Jordan's Weapon Notes
	[6997]="0:12:1:1:::1:0:", -- Tattered Manuscript
	[6998]="0:4:2:1:Cloth::1:0:", -- Nimbus Boots
	[6999]="0:12:1:1:::1:0:", -- Tome of the Cabal
	[7000]="0:4:2:1:Leather::1:0:", -- Heartwood Girdle
	[7001]="0:2:3:1:Wand::1:0:", -- Gravestone Scepter
	[7002]="0:4:3:1:Shield::1:0:", -- Arctic Buckler
	[7003]="0:4:2:1:Mail::1:0:", -- Beetle Clasps
	[7004]="0:4:2:1:Cloak::1:0:", -- Prelacy Cape
	[7005]="82:2:1:1:Miscellaneous:202:1:0:66,777,843,989,1148,1250,1286,1465,1692,2118,2225,2697,2698,2699,2810,2816,2819,2821,2846,3005,3081,3168,3187,3366,3367,3482,3499,3556,3614,3779,3954,3955,3958,4194,4225,4229,4561,4589,4775,4897,5128,5135,5163,5565,5783,5817,5944,6301,6731,7852,7854,7947,8145,8160,8363,8934,11189,11874,12022,12028,12043,12245,12941,12942,12943,12956,12957,12958,15179,16224,16261,16262,16613,16689,16748,16768,17486,17490,18009,18277,18426,18427,18754,18771,19196,19244,19372,19450,19532,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27037,27043,27057,28692,28718,28798,28831,28872,29288,30311,33601,33635,33641,33681,33683", -- Skinning Knife
	[7006]="0:12:1:1:::1:0:", -- Reconstructed Tome
	[7026]="0:4:1:1:Cloth::1:0:", -- Linen Belt
	[7027]="0:4:2:1:Cloth::1:0:", -- Boots of Darkness
	[7046]="0:4:2:1:Cloth::1:0:", -- Azure Silk Pants
	[7047]="0:4:2:1:Cloth::1:0:", -- Hands of Darkness
	[7048]="0:4:2:1:Cloth::1:0:", -- Azure Silk Hood
	[7049]="0:4:2:1:Cloth::1:0:", -- Truefaith Gloves
	[7050]="0:4:2:1:Cloth::1:0:", -- Silk Headband
	[7051]="0:4:2:1:Cloth::1:0:", -- Earthen Vest
	[7052]="0:4:2:1:Cloth::1:0:", -- Azure Silk Belt
	[7053]="0:4:2:1:Cloak::1:0:", -- Azure Silk Cloak
	[7054]="0:4:3:1:Cloth::1:0:", -- Robe of Power
	[7055]="0:4:2:1:Cloth::1:0:", -- Crimson Silk Belt
	[7056]="0:4:2:1:Cloak::1:0:", -- Crimson Silk Cloak
	[7057]="0:4:2:1:Cloth::1:0:", -- Green Silken Shoulders
	[7058]="0:4:2:1:Cloth::1:0:", -- Crimson Silk Vest
	[7059]="0:4:2:1:Cloth::1:0:", -- Crimson Silk Shoulders
	[7060]="0:4:2:1:Cloth::1:0:", -- Azure Shoulders
	[7061]="0:4:2:1:Cloth::1:0:", -- Earthen Silk Belt
	[7062]="0:4:2:1:Cloth::1:0:", -- Crimson Silk Pantaloons
	[7063]="0:4:2:1:Cloth::1:0:", -- Crimson Silk Robe
	[7064]="0:4:2:1:Cloth::1:0:", -- Crimson Silk Gloves
	[7065]="0:4:2:1:Cloth::1:0:", -- Green Silk Armor
	[7067]="0:7:1:10:Elemental:171,164,333,202,755,165,197:1:0:", -- Elemental Earth
	[7068]="0:7:1:10:Elemental:171,164,333,202,197:1:0:", -- Elemental Fire
	[7069]="0:7:1:10:Elemental:164,202,197:1:0:", -- Elemental Air
	[7070]="0:7:1:10:Elemental:171,164,755,165,197:1:0:", -- Elemental Water
	[7071]="0:7:1:5:Part:165,197:1:0:", -- Iron Buckle
	[7072]="0:7:1:10:Other:197:1:0:", -- Naga Scale
	[7073]="0:15:0:5:Junk::1:0:", -- Broken Fang
	[7074]="0:15:0:5:Junk::1:0:", -- Chipped Claw
	[7075]="0:7:1:10:Elemental:164,333,202,755,165:1:0:", -- Core of Earth
	[7076]="0:7:2:10:Elemental:171,164,333,202,755,165,197:1:0:", -- Essence of Earth
	[7077]="0:7:1:10:Elemental:171,164,333,202,755,165,197:1:0:", -- Heart of Fire
	[7078]="0:7:2:10:Elemental:171,164,333,202,755,165,197:1:0:", -- Essence of Fire
	[7079]="0:7:1:10:Elemental:333,202,755,165,197:1:0:", -- Globe of Water
	[7080]="0:7:2:10:Elemental:171,164,333,202,165,197:1:0:", -- Essence of Water
	[7081]="0:7:1:10:Elemental:164,333,755,165:1:0:", -- Breath of Wind
	[7082]="0:7:2:10:Elemental:171,333,202,755,165,197:1:0:", -- Essence of Air
	[7083]="0:12:1:1:::1:0:", -- Purified Kor Gem
	[7084]="0:9:2:1:Tailoring::1:0:", -- Pattern: Crimson Silk Shoulders
	[7085]="0:9:2:1:Tailoring::1:0:", -- Pattern: Azure Shoulders
	[7086]="0:9:2:1:Tailoring::1:0:", -- Pattern: Earthen Silk Belt
	[7087]="1200:9:1:1:Tailoring::1:1:2670", -- Pattern: Crimson Silk Cloak
	[7088]="5000:9:1:1:Tailoring::1:1:6568", -- Pattern: Crimson Silk Robe
	[7089]="1500:9:1:1:Tailoring::1:1:6574,6576", -- Pattern: Azure Silk Cloak
	[7090]="0:9:2:1:Tailoring::1:0:", -- Pattern: Green Silk Armor
	[7091]="0:9:2:1:Tailoring::1:0:", -- Pattern: Truefaith Gloves
	[7092]="0:9:2:1:Tailoring::1:0:", -- Pattern: Hands of Darkness
	[7094]="0:2:1:1:Stave::1:0:", -- Driftwood Branch
	[7095]="0:4:1:1:Cloth::1:0:", -- Bog Boots
	[7096]="0:15:0:5:Junk::1:0:", -- Plucked Feather
	[7097]="0:0:1:20:FoodDrink::1:0:", -- Leg Meat
	[7098]="0:15:0:5:Junk::1:0:", -- Splintered Tusk
	[7099]="0:15:0:5:Junk::1:0:", -- Severed Pincer
	[7100]="0:15:0:5:Junk::1:0:", -- Sticky Ichor
	[7101]="0:15:0:5:Junk::1:0:", -- Bug Eye
	[7106]="0:4:2:1:Cloth::1:0:", -- Zodiac Gloves
	[7107]="0:4:2:1:Mail::1:0:", -- Belt of the Stars
	[7108]="0:4:2:1:Shield::1:0:", -- Infantry Shield
	[7109]="0:4:1:1:Shield::1:0:", -- Pioneer Buckler
	[7110]="0:4:2:1:Cloth::1:0:", -- Silver-thread Armor
	[7111]="0:4:2:1:Cloth::1:0:", -- Nightsky Armor
	[7112]="0:4:2:1:Cloth::1:0:", -- Aurora Armor
	[7113]="0:4:2:1:Cloth::1:0:", -- Mistscape Armor
	[7114]="1000:9:1:1:Tailoring::1:1:2679,9636", -- Pattern: Azure Silk Gloves
	[7115]="0:2:2:1:OneHandAxe::1:0:", -- Heirloom Axe
	[7116]="0:2:2:1:Dagger::1:0:", -- Heirloom Dagger
	[7117]="0:2:2:1:OneHandMace::1:0:", -- Heirloom Hammer
	[7118]="0:2:2:1:OneHandSword::1:0:", -- Heirloom Sword
	[7119]="0:12:1:1:::1:0:", -- Twitching Antenna
	[7120]="0:4:2:1:Shield::1:0:", -- Ruga's Bulwark
	[7126]="0:12:1:20:::1:0:", -- Smoky Iron Ingot
	[7127]="0:0:1:20:Consumable::1:0:", -- Powdered Azurite
	[7128]="0:12:1:20:::1:0:", -- Uncloven Satyr Hoof
	[7129]="0:4:2:1:Mail::1:0:", -- Brutal Gauntlets
	[7130]="0:4:2:1:Mail::1:0:", -- Brutal Helm
	[7131]="0:12:1:20:::1:0:", -- Dragonmaw Shinbone
	[7132]="0:4:2:1:Mail::1:0:", -- Brutal Legguards
	[7133]="0:4:3:1:Mail::1:0:", -- Brutal Hauberk
	[7134]="0:12:1:20:::1:0:", -- Sturdy Dragonmaw Shinbone
	[7135]="0:12:0:20:::1:0:", -- Broken Dragonmaw Shinbone
	[7146]="0:13:2:1:::1:0:", -- The Scarlet Key
	[7148]="0:7:1:1:Device::1:0:", -- Goblin Jumper Cables
	[7166]="0:2:1:1:Dagger::1:0:", -- Copper Dagger
	[7189]="0:4:2:1:Cloth::1:0:", -- Goblin Rocket Boots
	[7190]="0:15:0:1:Junk::1:0:", -- Scorched Rocket Boots
	[7191]="0:7:1:5:Part:202:1:0:", -- Fused Wiring
	[7206]="0:12:1:1:::1:0:", -- Mirror Lake Water Sample
	[7207]="0:12:1:1:::1:0:", -- Jennea's Flask
	[7208]="0:13:1:1:::1:0:", -- Tazan's Key
	[7209]="0:15:1:1:Junk::1:0:", -- Tazan's Satchel
	[7226]="0:12:1:1:::1:0:", -- Mage-tastic Gizmonitor
	[7227]="0:0:1:1:Consumable::1:0:", -- Balnir Snapdragons
	[7228]="500:0:1:20:FoodDrink::5:0:6496,14480,14481,15353,15354,18913,18914,24934", -- Tigule and Foror's Strawberry Ice Cream
	[7229]="0:4:2:1:Mail::1:0:", -- Explorer's Vest
	[7230]="0:2:3:1:TwoHandMace::1:0:", -- Smite's Mighty Hammer
	[7231]="0:12:1:1:::1:0:", -- Astor's Letter of Introduction
	[7247]="0:15:1:1:Junk::1:0:", -- Chest of Containment Coffers
	[7249]="0:12:1:20:::1:0:", -- Charged Rift Gem
	[7266]="0:0:1:1:Consumable::1:0:", -- Ur's Treatise on Shadow Magic
	[7267]="0:12:1:20:::1:0:", -- Pristine Spider Silk
	[7268]="0:12:1:1:::1:0:", -- Xavian Water Sample
	[7269]="0:12:1:1:::1:0:", -- Deino's Flask
	[7270]="0:12:1:20:::1:0:", -- Laughing Sister's Hair
	[7271]="0:12:1:20:::1:0:", -- Flawless Ivory Tusk
	[7272]="0:12:1:1:::1:0:", -- Bolt Charged Bramble
	[7273]="0:12:1:20:::1:0:", -- Witherbark Totem Stick
	[7274]="0:12:1:1:::1:0:", -- Rituals of Power
	[7276]="0:4:1:1:Cloak::1:0:", -- Handstitched Leather Cloak
	[7277]="0:4:1:1:Leather::1:0:", -- Handstitched Leather Bracers
	[7278]="0:11:1:1:Quiver::1:0:", -- Light Leather Quiver
	[7279]="0:11:1:1:AmmoPouch::1:0:", -- Small Leather Ammo Pouch
	[7280]="0:4:2:1:Leather::1:0:", -- Rugged Leather Pants
	[7281]="0:4:2:1:Leather::1:0:", -- Light Leather Bracers
	[7282]="0:4:2:1:Leather::1:0:", -- Light Leather Pants
	[7283]="0:4:2:1:Cloak::1:0:", -- Black Whelp Cloak
	[7284]="0:4:2:1:Leather::1:0:", -- Red Whelp Gloves
	[7285]="0:4:2:1:Leather::1:0:", -- Nimble Leather Gloves
	[7286]="0:7:1:10:Leather:165:1:0:", -- Black Whelp Scale
	[7287]="0:15:1:5:Junk:165:1:0:", -- Red Whelp Scale
	[7288]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Rugged Leather Pants
	[7289]="650:9:1:1:Leatherworking::1:1:2697", -- Pattern: Black Whelp Cloak
	[7290]="1600:9:1:1:Leatherworking::1:1:2679", -- Pattern: Red Whelp Gloves
	[7291]="0:12:1:1:::1:0:", -- Infernal Orb
	[7292]="0:12:1:20:::1:0:", -- Filled Containment Coffer
	[7293]="0:12:1:20:::1:0:", -- Dalaran Mana Gem
	[7294]="0:12:1:1:::1:0:", -- Andron's Ledger
	[7295]="0:12:1:1:::1:0:", -- Tazan's Logbook
	[7296]="0:15:0:5:Junk::1:0:", -- Extinguished Torch
	[7297]="0:4:1:1:OffHandFrill::1:0:", -- Morbent's Bane
	[7298]="0:2:2:1:Dagger::1:0:", -- Blade of Cunning
	[7306]="0:12:1:1:::1:0:", -- Fenwick's Head
	[7307]="0:0:1:20:EnhTemp::1:0:", -- Flesh Eating Worm
	[7308]="0:12:1:1:::1:0:", -- Cantation of Manifestation
	[7309]="0:12:1:1:::1:0:", -- Dalaran Status Report
	[7326]="0:2:2:1:OneHandAxe::1:0:", -- Thun'grim's Axe
	[7327]="0:2:2:1:Dagger::1:0:", -- Thun'grim's Dagger
	[7328]="0:2:2:1:OneHandMace::1:0:", -- Thun'grim's Mace
	[7329]="0:2:2:1:OneHandSword::1:0:", -- Thun'grim's Sword
	[7330]="0:4:2:1:Shield::1:0:", -- Infiltrator Buckler
	[7331]="0:4:2:1:Shield::1:0:", -- Phalanx Shield
	[7332]="0:4:2:1:Cloth::1:0:", -- Regal Armor
	[7333]="0:12:1:1:::1:0:", -- Overseer's Whistle
	[7334]="0:4:2:1:Cloth::1:0:", -- Efflorescent Robe
	[7335]="0:4:2:1:Leather::1:0:", -- Grizzly Tunic
	[7336]="0:4:2:1:Mail::1:0:", -- Wildwood Chain
	[7337]="1000000:4:1:1:Ring::1:0:2849,16624,17512", -- The Rock
	[7338]="10000:4:1:1:Ring::1:0:2849,16624,17512", -- Mood Ring
	[7339]="250000:4:1:1:Ring::1:0:2849,16624,17512", -- Miniscule Diamond Ring
	[7340]="500000:4:1:1:Ring::1:0:2849,16624,17512", -- Flawless Diamond Solitaire
	[7341]="50000:4:1:1:Ring::1:0:2849,16624,17512", -- Cubic Zirconia Ring
	[7342]="100000:4:1:1:Ring::1:0:2849,16624,17512", -- Silver Piffeny Band
	[7343]="0:12:1:1:::1:0:", -- Bingles' Wrench
	[7344]="0:4:2:1:OffHandFrill::1:0:", -- Torch of Holy Flame
	[7345]="0:12:1:1:::1:0:", -- Bingles' Screwdriver
	[7346]="0:12:1:1:::1:0:", -- Bingles' Hammer
	[7348]="0:4:3:1:Leather::1:0:", -- Fletcher's Gloves
	[7349]="0:4:2:1:Leather::1:0:", -- Herbalist's Gloves
	[7350]="0:4:1:1:Cloth::1:0:", -- Disciple's Bracers
	[7351]="0:4:1:1:Cloth::1:0:", -- Disciple's Boots
	[7352]="0:4:2:1:Leather::1:0:", -- Earthen Leather Shoulders
	[7353]="0:4:2:1:Cloth::1:0:", -- Elder's Padded Armor
	[7354]="0:4:2:1:Cloth::1:0:", -- Elder's Boots
	[7355]="0:4:2:1:Cloth::1:0:", -- Elder's Bracers
	[7356]="0:4:2:1:Cloak::1:0:", -- Elder's Cloak
	[7357]="0:4:2:1:Cloth::1:0:", -- Elder's Hat
	[7358]="0:4:2:1:Leather::1:0:", -- Pilferer's Gloves
	[7359]="0:4:2:1:Leather::1:0:", -- Heavy Earthen Gloves
	[7360]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Dark Leather Gloves
	[7361]="1800:9:2:1:Leatherworking::1:1:6731", -- Pattern: Herbalist's Gloves
	[7362]="2000:9:1:1:Leatherworking::1:1:3537", -- Pattern: Earthen Leather Shoulders
	[7363]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Pilferer's Gloves
	[7364]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Heavy Earthen Gloves
	[7365]="0:12:1:1:::1:0:", -- Gnoam Sprecklesprocket
	[7366]="0:4:2:1:Cloth::1:0:", -- Elder's Gloves
	[7367]="0:4:2:1:Cloth::1:0:", -- Elder's Mantle
	[7368]="0:4:2:1:Cloth::1:0:", -- Elder's Pants
	[7369]="0:4:2:1:Cloth::1:0:", -- Elder's Robe
	[7370]="0:4:2:1:Cloth::1:0:", -- Elder's Sash
	[7371]="2000:11:2:1:Quiver::1:0:1287,4602,7976,16715,16919,17667", -- Heavy Quiver
	[7372]="0:11:2:1:AmmoPouch::1:0:", -- Heavy Leather Ammo Pouch
	[7373]="0:4:2:1:Leather::1:0:", -- Dusky Leather Leggings
	[7374]="0:4:2:1:Leather::1:0:", -- Dusky Leather Armor
	[7375]="0:4:2:1:Leather::1:0:", -- Green Whelp Armor
	[7376]="0:12:1:1:::1:0:", -- Bingles' Blastencapper
	[7377]="0:4:2:1:Cloak::1:0:", -- Frost Leather Cloak
	[7378]="0:4:2:1:Leather::1:0:", -- Dusky Bracers
	[7386]="0:4:2:1:Leather::1:0:", -- Green Whelp Bracers
	[7387]="0:4:2:1:Leather:202:1:0:", -- Dusky Belt
	[7389]="0:12:1:1:::1:0:", -- Venture Co. Ledger
	[7390]="0:4:2:1:Leather::1:0:", -- Dusky Boots
	[7391]="0:4:2:1:Leather::1:0:", -- Swift Boots
	[7392]="0:7:1:5:Leather:333,165:1:0:", -- Green Whelp Scale
	[7406]="0:4:2:1:Leather::1:0:", -- Infiltrator Cord
	[7407]="0:4:2:1:Leather::1:0:", -- Infiltrator Armor
	[7408]="0:4:2:1:Leather::1:0:", -- Infiltrator Shoulders
	[7409]="0:4:2:1:Leather::1:0:", -- Infiltrator Boots
	[7410]="0:4:2:1:Leather::1:0:", -- Infiltrator Bracers
	[7411]="0:4:2:1:Cloak::1:0:", -- Infiltrator Cloak
	[7412]="0:4:2:1:Leather::1:0:", -- Infiltrator Gloves
	[7413]="0:4:2:1:Leather::1:0:", -- Infiltrator Cap
	[7414]="0:4:2:1:Leather::1:0:", -- Infiltrator Pants
	[7415]="0:4:2:1:Leather::1:0:", -- Dervish Spaulders
	[7416]="0:4:2:1:Mail::1:0:", -- Phalanx Bracers
	[7417]="0:4:2:1:Mail::1:0:", -- Phalanx Boots
	[7418]="0:4:2:1:Mail::1:0:", -- Phalanx Breastplate
	[7419]="0:4:2:1:Cloak::1:0:", -- Phalanx Cloak
	[7420]="0:4:2:1:Mail::1:0:", -- Phalanx Headguard
	[7421]="0:4:2:1:Mail::1:0:", -- Phalanx Gauntlets
	[7422]="0:4:2:1:Mail::1:0:", -- Phalanx Girdle
	[7423]="0:4:2:1:Mail::1:0:", -- Phalanx Leggings
	[7424]="0:4:2:1:Mail::1:0:", -- Phalanx Spaulders
	[7428]="0:15:0:10:Junk::1:0:", -- Shadowcat Hide
	[7429]="0:4:2:1:Cloth::1:0:", -- Twilight Armor
	[7430]="0:4:2:1:Cloth::1:0:", -- Twilight Robe
	[7431]="0:4:2:1:Cloth::1:0:", -- Twilight Pants
	[7432]="0:4:2:1:Cloth::1:0:", -- Twilight Cowl
	[7433]="0:4:2:1:Cloth::1:0:", -- Twilight Gloves
	[7434]="0:4:2:1:Cloth::1:0:", -- Twilight Boots
	[7435]="0:4:2:1:Cloth::1:0:", -- Twilight Mantle
	[7436]="0:4:2:1:Cloak::1:0:", -- Twilight Cape
	[7437]="0:4:2:1:Cloth::1:0:", -- Twilight Cuffs
	[7438]="0:4:2:1:Cloth::1:0:", -- Twilight Belt
	[7439]="0:4:2:1:Leather::1:0:", -- Sentinel Breastplate
	[7440]="0:4:2:1:Leather::1:0:", -- Sentinel Trousers
	[7441]="0:4:2:1:Leather::1:0:", -- Sentinel Cap
	[7442]="0:12:1:1:::1:0:", -- Gyromast's Key
	[7443]="0:4:2:1:Leather::1:0:", -- Sentinel Gloves
	[7444]="0:4:2:1:Leather::1:0:", -- Sentinel Boots
	[7445]="0:4:2:1:Leather::1:0:", -- Sentinel Shoulders
	[7446]="0:4:2:1:Cloak::1:0:", -- Sentinel Cloak
	[7447]="0:4:2:1:Leather::1:0:", -- Sentinel Bracers
	[7448]="0:4:2:1:Leather::1:0:", -- Sentinel Girdle
	[7449]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Dusky Leather Leggings
	[7450]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Green Whelp Armor
	[7451]="2800:9:2:1:Leatherworking::1:1:4225,4589,7852,7854", -- Pattern: Green Whelp Bracers
	[7452]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Dusky Boots
	[7453]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Swift Boots
	[7454]="0:4:2:1:Mail::1:0:", -- Knight's Breastplate
	[7455]="0:4:2:1:Mail::1:0:", -- Knight's Legguards
	[7456]="0:4:2:1:Mail::1:0:", -- Knight's Headguard
	[7457]="0:4:2:1:Mail::1:0:", -- Knight's Gauntlets
	[7458]="0:4:2:1:Mail::1:0:", -- Knight's Boots
	[7459]="0:4:2:1:Mail::1:0:", -- Knight's Pauldrons
	[7460]="0:4:2:1:Cloak::1:0:", -- Knight's Cloak
	[7461]="0:4:2:1:Mail::1:0:", -- Knight's Bracers
	[7462]="0:4:2:1:Mail::1:0:", -- Knight's Girdle
	[7463]="0:4:2:1:Shield::1:0:", -- Sentinel Buckler
	[7464]="0:12:1:1:::1:0:", -- Glyphs of Summoning
	[7465]="0:4:2:1:Shield::1:0:", -- Knight's Crest
	[7468]="0:4:2:1:Cloth::1:0:", -- Regal Robe
	[7469]="0:4:2:1:Cloth::1:0:", -- Regal Leggings
	[7470]="0:4:2:1:Cloth::1:0:", -- Regal Wizard Hat
	[7471]="0:4:2:1:Cloth::1:0:", -- Regal Gloves
	[7472]="0:4:2:1:Cloth::1:0:", -- Regal Boots
	[7473]="0:4:2:1:Cloth::1:0:", -- Regal Mantle
	[7474]="0:4:2:1:Cloak::1:0:", -- Regal Cloak
	[7475]="0:4:2:1:Cloth::1:0:", -- Regal Cuffs
	[7476]="0:4:2:1:Cloth::1:0:", -- Regal Sash
	[7477]="0:4:2:1:Leather::1:0:", -- Ranger Tunic
	[7478]="0:4:2:1:Leather::1:0:", -- Ranger Leggings
	[7479]="0:4:2:1:Leather::1:0:", -- Ranger Helm
	[7480]="0:4:2:1:Leather::1:0:", -- Ranger Gloves
	[7481]="0:4:2:1:Leather::1:0:", -- Ranger Boots
	[7482]="0:4:2:1:Leather::1:0:", -- Ranger Shoulders
	[7483]="0:4:2:1:Cloak::1:0:", -- Ranger Cloak
	[7484]="0:4:2:1:Leather::1:0:", -- Ranger Wristguards
	[7485]="0:4:2:1:Leather::1:0:", -- Ranger Cord
	[7486]="0:4:2:1:Mail::1:0:", -- Captain's Breastplate
	[7487]="0:4:2:1:Mail::1:0:", -- Captain's Leggings
	[7488]="0:4:2:1:Mail::1:0:", -- Captain's Circlet
	[7489]="0:4:2:1:Mail::1:0:", -- Captain's Gauntlets
	[7490]="0:4:2:1:Mail::1:0:", -- Captain's Boots
	[7491]="0:4:2:1:Mail::1:0:", -- Captain's Shoulderguards
	[7492]="0:4:2:1:Cloak::1:0:", -- Captain's Cloak
	[7493]="0:4:2:1:Mail::1:0:", -- Captain's Bracers
	[7494]="0:4:2:1:Mail::1:0:", -- Captain's Waistguard
	[7495]="0:4:2:1:Shield::1:0:", -- Captain's Buckler
	[7496]="0:4:2:1:Shield::1:0:", -- Field Plate Shield
	[7498]="0:12:1:1:::1:0:", -- Top of Gelkak's Key
	[7499]="0:12:1:1:::1:0:", -- Middle of Gelkak's Key
	[7500]="0:12:1:1:::1:0:", -- Bottom of Gelkak's Key
	[7506]="0:4:2:1:Trinket::1:0:", -- Gnomish Universal Remote
	[7507]="0:4:2:1:OffHandFrill::1:0:", -- Arcane Orb
	[7508]="0:4:2:1:OffHandFrill::1:0:", -- Ley Orb
	[7509]="0:4:2:1:Cloth::1:0:", -- Manaweave Robe
	[7510]="0:4:2:1:Cloth::1:0:", -- Lesser Spellfire Robes
	[7511]="0:4:2:1:Cloth::1:0:", -- Astral Knot Robe
	[7512]="0:4:2:1:Cloth::1:0:", -- Nether-lace Robe
	[7513]="0:2:3:1:Wand::1:0:", -- Ragefire Wand
	[7514]="0:2:3:1:Wand::1:0:", -- Icefury Wand
	[7515]="0:4:3:1:OffHandFrill::1:0:", -- Celestial Orb
	[7516]="0:0:1:1:Consumable::1:0:", -- Tabetha's Instructions
	[7517]="0:4:2:1:Cloth::1:0:", -- Gossamer Tunic
	[7518]="0:4:2:1:Cloth::1:0:", -- Gossamer Robe
	[7519]="0:4:2:1:Cloth::1:0:", -- Gossamer Pants
	[7520]="0:4:2:1:Cloth::1:0:", -- Gossamer Headpiece
	[7521]="0:4:2:1:Cloth::1:0:", -- Gossamer Gloves
	[7522]="0:4:2:1:Cloth::1:0:", -- Gossamer Boots
	[7523]="0:4:2:1:Cloth::1:0:", -- Gossamer Shoulderpads
	[7524]="0:4:2:1:Cloak::1:0:", -- Gossamer Cape
	[7525]="0:4:2:1:Cloth::1:0:", -- Gossamer Bracers
	[7526]="0:4:2:1:Cloth::1:0:", -- Gossamer Belt
	[7527]="0:4:2:1:Leather::1:0:", -- Cabalist Chestpiece
	[7528]="0:4:2:1:Leather::1:0:", -- Cabalist Leggings
	[7529]="0:4:2:1:Leather::1:0:", -- Cabalist Helm
	[7530]="0:4:2:1:Leather::1:0:", -- Cabalist Gloves
	[7531]="0:4:2:1:Leather::1:0:", -- Cabalist Boots
	[7532]="0:4:2:1:Leather::1:0:", -- Cabalist Spaulders
	[7533]="0:4:2:1:Cloak::1:0:", -- Cabalist Cloak
	[7534]="0:4:2:1:Leather::1:0:", -- Cabalist Bracers
	[7535]="0:4:2:1:Leather::1:0:", -- Cabalist Belt
	[7536]="0:4:2:1:Shield::1:0:", -- Champion's Wall Shield
	[7537]="0:4:2:1:Shield::1:0:", -- Gothic Shield
	[7538]="0:4:2:1:Mail::1:0:", -- Champion's Armor
	[7539]="0:4:2:1:Mail::1:0:", -- Champion's Leggings
	[7540]="0:4:2:1:Mail::1:0:", -- Champion's Helmet
	[7541]="0:4:2:1:Mail::1:0:", -- Champion's Gauntlets
	[7542]="0:4:2:1:Mail::1:0:", -- Champion's Greaves
	[7543]="0:4:2:1:Mail::1:0:", -- Champion's Pauldrons
	[7544]="0:4:2:1:Cloak::1:0:", -- Champion's Cape
	[7545]="0:4:2:1:Mail::1:0:", -- Champion's Bracers
	[7546]="0:4:2:1:Mail::1:0:", -- Champion's Girdle
	[7549]="0:4:2:1:Amulet::1:0:", -- Fairy's Embrace
	[7551]="0:4:2:1:Amulet::1:0:", -- Entwined Opaline Talisman
	[7552]="0:4:2:1:Ring::1:0:", -- Falcon's Hook
	[7553]="0:4:2:1:Ring::1:0:", -- Band of the Unicorn
	[7554]="0:4:2:1:OffHandFrill::1:0:", -- Willow Branch
	[7555]="0:4:2:1:OffHandFrill::1:0:", -- Regal Star
	[7556]="0:4:2:1:OffHandFrill::1:0:", -- Twilight Orb
	[7557]="0:4:2:1:OffHandFrill::1:0:", -- Gossamer Rod
	[7558]="0:4:2:1:OffHandFrill::1:0:", -- Shimmering Stave
	[7559]="0:4:2:1:OffHandFrill::1:0:", -- Runic Cane
	[7560]="1200:9:1:1:Engineering::1:1:5175,6730", -- Schematic: Gnomish Universal Remote
	[7561]="2000:9:1:1:Engineering::1:1:3134,3537,4086", -- Schematic: Goblin Jumper Cables
	[7566]="0:12:1:1:::1:0:", -- Agamand Family Sword
	[7567]="0:12:1:1:::1:0:", -- Agamand Family Axe
	[7568]="0:12:1:1:::1:0:", -- Agamand Family Dagger
	[7569]="0:12:1:1:::1:0:", -- Agamand Family Mace
	[7586]="0:12:1:1:::1:0:", -- Tharnariun's Hope
	[7587]="0:12:1:1:::1:0:", -- Thun'grim's Instructions
	[7606]="0:4:2:1:Mail::1:0:", -- Polar Gauntlets
	[7607]="0:2:2:1:Wand::1:0:", -- Sable Wand
	[7608]="0:4:2:1:OffHandFrill::1:0:", -- Seer's Fine Stein
	[7609]="0:4:2:1:OffHandFrill::1:0:", -- Elder's Amber Stave
	[7610]="0:4:2:1:OffHandFrill::1:0:", -- Aurora Sphere
	[7611]="0:4:2:1:OffHandFrill::1:0:", -- Mistscape Stave
	[7613]="2000:9:1:1:Leatherworking::1:1:2679,2698", -- Pattern: Green Leather Armor
	[7626]="0:12:1:1:::1:0:", -- Bundle of Furs
	[7627]="0:0:1:1:Consumable::1:0:", -- Dolanaar Delivery
	[7628]="0:12:1:1:::1:0:", -- Nondescript Letter
	[7629]="0:0:1:1:Consumable::1:0:", -- Ukor's Burden
	[7646]="0:12:1:1:::1:0:", -- Crate of Inn Supplies
	[7666]="0:12:2:1:::1:0:", -- Shattered Necklace
	[7667]="0:12:1:1:::1:0:", -- Talvash's Phial of Scrying
	[7668]="0:15:1:1:Junk::1:0:", -- Bloodstained Journal
	[7669]="0:12:1:1:::1:0:", -- Shattered Necklace Ruby
	[7670]="0:12:1:1:::1:0:", -- Shattered Necklace Sapphire
	[7671]="0:12:1:1:::1:0:", -- Shattered Necklace Topaz
	[7672]="0:12:1:1:::1:0:", -- Shattered Necklace Power Source
	[7673]="0:4:3:1:Amulet::1:0:", -- Talvash's Enhancing Necklace
	[7674]="0:12:1:1:::1:0:", -- Delivery to Mathias
	[7675]="0:12:1:1:::1:0:", -- Defias Shipping Schedule
	[7676]="0:0:1:10:FoodDrink::1:0:", -- Thistle Tea
	[7678]="0:9:1:1:Cooking::1:0:", -- Recipe: Thistle Tea
	[7679]="0:12:1:20:::1:0:", -- Shrike Bat Fang
	[7680]="0:12:1:20:::1:0:", -- Jadespine Basilisk Scale
	[7682]="0:2:3:1:Dagger::1:0:", -- Torturing Poker
	[7683]="0:2:3:1:FistWeapon::1:0:", -- Bloody Brass Knuckles
	[7684]="0:4:3:1:Cloth::1:0:", -- Bloodmage Mantle
	[7685]="0:4:3:1:OffHandFrill::1:0:", -- Orb of the Forgotten Seer
	[7686]="0:4:3:1:Ring::1:0:", -- Ironspine's Eye
	[7687]="0:2:3:1:OneHandMace::1:0:", -- Ironspine's Fist
	[7688]="0:4:3:1:Mail::1:0:", -- Ironspine's Ribcage
	[7689]="0:2:3:1:TwoHandSword::1:0:", -- Morbid Dawn
	[7690]="0:4:3:1:Leather::1:0:", -- Ebon Vise
	[7691]="0:4:3:1:Cloth::1:0:", -- Embalmed Shroud
	[7708]="0:2:3:1:Wand::1:0:", -- Necrotic Wand
	[7709]="0:4:3:1:Cloth::1:0:", -- Blighted Leggings
	[7710]="0:2:3:1:Stave::1:0:", -- Loksey's Training Stick
	[7711]="0:4:3:1:Cloth::1:0:", -- Robe of Doan
	[7712]="0:4:3:1:Cloth::1:0:", -- Mantle of Doan
	[7713]="0:2:3:1:Stave::1:0:", -- Illusionary Rod
	[7714]="0:2:3:1:Dagger::1:0:", -- Hypnotic Blade
	[7715]="0:12:1:1:::1:0:", -- Onin's Report
	[7717]="0:2:3:1:TwoHandAxe::1:0:", -- Ravager
	[7718]="0:4:3:1:Mail::1:0:", -- Herod's Shoulder
	[7719]="0:4:3:1:Mail::1:0:", -- Raging Berserker's Helm
	[7720]="0:4:3:1:Cloth::1:0:", -- Whitemane's Chapeau
	[7721]="0:2:3:1:OneHandMace::1:0:", -- Hand of Righteousness
	[7722]="0:4:3:1:Amulet::1:0:", -- Triune Amulet
	[7723]="0:2:3:1:TwoHandMace::1:0:", -- Mograine's Might
	[7724]="0:4:3:1:Mail::1:0:", -- Gauntlets of Divinity
	[7726]="0:4:3:1:Shield::1:0:", -- Aegis of the Scarlet Commander
	[7727]="0:4:3:1:Leather::1:0:", -- Watchman Pauldrons
	[7728]="0:4:3:1:Cloth::1:0:", -- Beguiler Robes
	[7729]="0:2:3:1:Gun::1:0:", -- Chesterfall Musket
	[7730]="0:2:3:1:TwoHandMace::1:0:", -- Cobalt Crusher
	[7731]="0:4:3:1:Amulet::1:0:", -- Ghostshard Talisman
	[7733]="0:12:1:1:::1:0:", -- Staff of Prehistoria
	[7734]="0:4:3:1:Trinket::1:0:", -- Six Demon Bag
	[7735]="0:12:1:1:::1:0:", -- Jannok's Rose
	[7736]="0:2:3:1:OneHandMace::1:0:", -- Fight Club
	[7737]="0:12:1:1:::1:0:", -- Sethir's Journal
	[7738]="0:4:2:1:Cloth::1:0:", -- Evergreen Gloves
	[7739]="0:4:2:1:Cloak::1:0:", -- Timberland Cape
	[7740]="0:12:3:1:::1:0:", -- Gni'kiv Medallion
	[7741]="0:12:3:1:::1:0:", -- The Shaft of Tsol
	[7742]="2400:9:1:1:Engineering::1:1:6777", -- Schematic: Gnomish Cloaking Device
	[7746]="0:4:2:1:Amulet::1:0:", -- Explorers' League Commendation
	[7747]="0:4:2:1:Shield::1:0:", -- Vile Protector
	[7749]="0:4:2:1:OffHandFrill::1:0:", -- Omega Orb
	[7750]="0:4:2:1:Cloth::1:0:", -- Mantle of Woe
	[7751]="0:4:2:1:Leather::1:0:", -- Vorrel's Boots
	[7752]="0:2:3:1:OneHandMace::1:0:", -- Dreamslayer
	[7753]="0:2:3:1:TwoHandAxe::1:0:", -- Bloodspiller
	[7754]="0:4:3:1:Leather::1:0:", -- Harbinger Boots
	[7755]="0:4:3:1:Leather::1:0:", -- Flintrock Shoulders
	[7756]="0:4:3:1:Leather::1:0:", -- Dog Training Gloves
	[7757]="0:2:3:1:Stave::1:0:", -- Windweaver Staff
	[7758]="0:2:3:1:Polearm::1:0:", -- Ruthless Shiv
	[7759]="0:4:3:1:Mail::1:0:", -- Archon Chestpiece
	[7760]="0:4:3:1:Leather::1:0:", -- Warchief Kilt
	[7761]="0:2:3:1:OneHandAxe::1:0:", -- Steelclaw Reaver
	[7766]="0:12:1:1:::1:0:", -- Empty Brown Waterskin
	[7767]="0:12:1:1:::1:0:", -- Empty Blue Waterskin
	[7768]="0:12:1:1:::1:0:", -- Empty Red Waterskin
	[7769]="0:12:1:1:::1:0:", -- Filled Brown Waterskin
	[7770]="0:12:1:1:::1:0:", -- Filled Blue Waterskin
	[7771]="0:12:1:1:::1:0:", -- Filled Red Waterskin
	[7786]="0:2:3:1:OneHandAxe::1:0:", -- Headsplitter
	[7787]="0:4:3:1:Shield::1:0:", -- Resplendent Guardian
	[7806]="0:0:1:20:FoodDrink::1:0:", -- Lollipop
	[7807]="0:0:1:20:FoodDrink::1:0:", -- Candy Bar
	[7808]="0:0:1:20:FoodDrink::1:0:", -- Chocolate Square
	[7809]="0:4:1:1:Miscellaneous::1:0:", -- Easter Dress
	[7810]="0:12:1:1:::1:0:", -- Vial of Purest Water
	[7811]="0:12:1:1:::1:0:", -- Remaining Drops of Purest Water
	[7812]="0:12:1:1:::1:0:", -- Corrupt Manifestation's Bracers
	[7813]="0:12:1:1:::1:0:", -- Shard of Water
	[7846]="0:12:1:20:::1:0:", -- Crag Coyote Fang
	[7847]="0:12:1:20:::1:0:", -- Buzzard Gizzard
	[7848]="0:12:1:20:::1:0:", -- Rock Elemental Shard
	[7866]="0:12:1:1:::1:0:", -- Empty Thaumaturgy Vessel
	[7867]="0:12:1:20:::1:0:", -- Vessel of Dragon's Blood
	[7870]="0:12:1:1:::1:0:", -- Thaumaturgy Vessel Lockbox
	[7871]="0:12:1:1:::1:0:", -- Token of Thievery
	[7886]="0:12:1:1:::1:0:", -- Untranslated Journal
	[7887]="0:12:1:1:::1:0:", -- Necklace and Gem Salvage
	[7888]="0:4:3:1:Amulet::1:0:", -- Jarkal's Enhancing Necklace
	[7906]="0:12:1:1:::1:0:", -- Horns of Nez'ra
	[7907]="0:15:1:1:Junk::1:0:", -- Certificate of Thievery
	[7908]="0:12:1:1:::1:0:", -- Klaven Mortwake's Journal
	[7909]="0:3:2:20:GemSimple:164,333,202,755:1:0:", -- Aquamarine
	[7910]="0:3:2:20:GemSimple:164,202,755,197:1:0:", -- Star Ruby
	[7911]="0:7:2:20:MetalStone:186:1:0:", -- Truesilver Ore
	[7912]="0:7:1:20:MetalStone:164,202,755:1:0:", -- Solid Stone
	[7913]="0:4:2:1:Mail::1:0:", -- Barbaric Iron Shoulders
	[7914]="0:4:2:1:Mail::1:0:", -- Barbaric Iron Breastplate
	[7915]="0:4:2:1:Mail::1:0:", -- Barbaric Iron Helm
	[7916]="0:4:2:1:Mail::1:0:", -- Barbaric Iron Boots
	[7917]="0:4:2:1:Mail::1:0:", -- Barbaric Iron Gloves
	[7918]="0:4:2:1:Plate::1:0:", -- Heavy Mithril Shoulder
	[7919]="0:4:2:1:Plate::1:0:", -- Heavy Mithril Gauntlet
	[7920]="0:4:2:1:Mail::1:0:", -- Mithril Scale Pants
	[7921]="0:4:2:1:Plate::1:0:", -- Heavy Mithril Pants
	[7922]="0:4:3:1:Plate::1:0:", -- Steel Plate Helm
	[7923]="0:13:1:1:::1:0:", -- Defias Tower Key
	[7924]="0:4:2:1:Mail::1:0:", -- Mithril Scale Bracers
	[7925]="0:4:2:1:Mail::1:0:", -- Mithril Scale Gloves
	[7926]="0:4:2:1:Plate::1:0:", -- Ornate Mithril Pants
	[7927]="0:4:2:1:Plate::1:0:", -- Ornate Mithril Gloves
	[7928]="0:4:2:1:Plate::1:0:", -- Ornate Mithril Shoulder
	[7929]="0:4:2:1:Mail::1:0:", -- Orcish War Leggings
	[7930]="0:4:2:1:Plate::1:0:", -- Heavy Mithril Breastplate
	[7931]="0:4:2:1:Mail::1:0:", -- Mithril Coif
	[7932]="0:4:2:1:Mail::1:0:", -- Mithril Scale Shoulders
	[7933]="0:4:2:1:Plate::1:0:", -- Heavy Mithril Boots
	[7934]="0:4:2:1:Plate::1:0:", -- Heavy Mithril Helm
	[7935]="0:4:2:1:Plate::1:0:", -- Ornate Mithril Breastplate
	[7936]="0:4:2:1:Plate::1:0:", -- Ornate Mithril Boots
	[7937]="0:4:2:1:Plate::1:0:", -- Ornate Mithril Helm
	[7938]="0:4:3:1:Plate::1:0:", -- Truesilver Gauntlets
	[7939]="0:4:3:1:Plate::1:0:", -- Truesilver Breastplate
	[7941]="0:2:2:1:OneHandAxe::1:0:", -- Heavy Mithril Axe
	[7942]="0:2:2:1:OneHandAxe::1:0:", -- Blue Glittering Axe
	[7943]="0:2:2:1:OneHandSword::1:0:", -- Wicked Mithril Blade
	[7944]="0:2:2:1:OneHandSword::1:0:", -- Dazzling Mithril Rapier
	[7945]="0:2:2:1:OneHandMace::1:0:", -- Big Black Mace
	[7946]="0:2:2:1:OneHandMace::1:0:", -- Runed Mithril Hammer
	[7947]="0:2:2:1:Dagger::1:0:", -- Ebon Shiv
	[7954]="0:2:3:1:OneHandMace::1:0:", -- The Shatterer
	[7955]="0:2:1:1:TwoHandSword::1:0:", -- Copper Claymore
	[7956]="0:2:2:1:TwoHandMace::1:0:", -- Bronze Warhammer
	[7957]="0:2:2:1:TwoHandSword::1:0:", -- Bronze Greatsword
	[7958]="0:2:2:1:TwoHandAxe::1:0:", -- Bronze Battle Axe
	[7959]="0:2:3:1:Polearm::1:0:", -- Blight
	[7960]="0:2:3:1:TwoHandSword::1:0:", -- Truesilver Champion
	[7961]="0:2:3:1:OneHandSword::1:0:", -- Phantom Blade
	[7963]="0:4:2:1:Mail::1:0:", -- Steel Breastplate
	[7964]="0:0:1:20:EnhTemp::1:0:", -- Solid Sharpening Stone
	[7965]="0:0:1:20:EnhTemp::1:0:", -- Solid Weightstone
	[7966]="0:7:1:20:MetalStone:164:1:0:", -- Solid Grinding Stone
	[7967]="0:0:2:5:EnhPerm::1:0:", -- Mithril Shield Spike
	[7968]="0:12:1:1:::1:0:", -- Southsea Treasure
	[7969]="0:0:2:1:EnhPerm::1:0:", -- Mithril Spurs
	[7970]="0:0:1:1:Consumable::1:0:", -- E.C.A.C.
	[7971]="0:3:2:20:GemSimple:164,333,755,165,197:1:0:", -- Black Pearl
	[7972]="0:7:1:10:Elemental:171,164,333,202,197:1:0:", -- Ichor of Undeath
	[7973]="0:7:1:20:Other::1:0:", -- Big-mouth Clam
	[7974]="0:7:1:20:Meat:185:1:0:", -- Zesty Clam Meat
	[7975]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Heavy Mithril Pants
	[7976]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Mithril Shield Spike
	[7978]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Barbaric Iron Shoulders
	[7979]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Barbaric Iron Breastplate
	[7980]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Barbaric Iron Helm
	[7981]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Barbaric Iron Boots
	[7982]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Barbaric Iron Gloves
	[7983]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Ornate Mithril Pants
	[7984]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Ornate Mithril Gloves
	[7985]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Ornate Mithril Shoulder
	[7989]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Mithril Spurs
	[7990]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Heavy Mithril Helm
	[7991]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Mithril Scale Shoulders
	[7992]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Blue Glittering Axe
	[7993]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Dazzling Mithril Rapier
	[7995]="6000:9:1:1:Blacksmithing::1:1:8161,8176", -- Plans: Mithril Scale Bracers
	[7997]="0:4:0:1:Miscellaneous::1:0:", -- Red Defias Mask
	[8006]="0:2:3:1:Dagger::1:0:", -- The Ziggler
	[8007]="0:0:1:1:Consumable::1:0:", -- Mana Citrine
	[8008]="0:0:1:1:Consumable::1:0:", -- Mana Ruby
	[8009]="0:12:1:20:::1:0:", -- Dentrium Power Stone
	[8026]="0:12:1:1:::1:0:", -- Garrett Family Treasure
	[8027]="0:12:1:1:::1:0:", -- Krom Stoutarm's Treasure
	[8028]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Runed Mithril Hammer
	[8029]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Wicked Mithril Blade
	[8030]="10000:9:1:1:Blacksmithing::1:0:11278", -- Plans: Ebon Shiv
	[8046]="0:9:1:1:Book::1:0:", -- Kearnen's Journal
	[8047]="0:12:1:20:::1:0:", -- Magenta Fungus Cap
	[8048]="0:0:1:1:Consumable::1:0:", -- Emerald Dreamcatcher
	[8049]="0:12:1:1:::1:0:", -- Gnarlpine Necklace
	[8050]="0:12:1:1:::1:0:", -- Tallonkai's Jewel
	[8051]="0:12:1:1:::1:0:", -- Flare Gun
	[8052]="0:12:1:20:::1:0:", -- An'Alleum Power Stone
	[8053]="0:12:1:1:::1:0:", -- Obsidian Power Source
	[8066]="0:12:1:1:::1:0:", -- Fizzule's Whistle
	[8067]="0:6:1:1000:Bullet::1:0:", -- Crafted Light Shot
	[8068]="0:6:1:1000:Bullet::1:0:", -- Crafted Heavy Shot
	[8069]="0:6:1:1000:Bullet::1:0:", -- Crafted Solid Shot
	[8070]="0:12:1:1:::1:0:", -- Reward Voucher
	[8071]="0:2:2:1:Wand::1:0:", -- Sizzle Stick
	[8072]="0:13:1:1:::1:0:", -- Silixiz's Tower Key
	[8073]="0:12:1:1:::1:0:", -- Cache of Zanzil's Altered Mixture
	[8074]="0:12:1:1:::1:0:", -- Gallywix's Head
	[8075]="0:0:1:20:FoodDrink::1:0:", -- Conjured Sourdough
	[8076]="0:0:1:20:FoodDrink::1:0:", -- Conjured Sweet Roll
	[8077]="0:0:1:20:FoodDrink::1:0:", -- Conjured Mineral Water
	[8078]="0:0:1:20:FoodDrink::1:0:", -- Conjured Sparkling Water
	[8079]="0:0:1:20:FoodDrink::1:0:", -- Conjured Crystal Water
	[8080]="0:4:0:1:Plate::1:0:", -- Light Plate Chestpiece
	[8081]="0:4:0:1:Plate::1:0:", -- Light Plate Belt
	[8082]="0:4:0:1:Plate::1:0:", -- Light Plate Boots
	[8083]="0:4:0:1:Plate::1:0:", -- Light Plate Bracers
	[8084]="0:4:0:1:Plate::1:0:", -- Light Plate Gloves
	[8085]="0:4:0:1:Plate::1:0:", -- Light Plate Pants
	[8086]="0:4:0:1:Plate::1:0:", -- Light Plate Shoulderpads
	[8087]="0:15:1:1:Junk::1:0:", -- Sample of Zanzil's Altered Mixture
	[8088]="23470:4:1:1:Plate::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Platemail Belt
	[8089]="35075:4:1:1:Plate::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Platemail Boots
	[8090]="23653:4:1:1:Plate::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Platemail Bracers
	[8091]="23742:4:1:1:Plate::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Platemail Gloves
	[8092]="35479:4:1:1:Plate::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Platemail Helm
	[8093]="47577:4:1:1:Plate::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Platemail Leggings
	[8094]="47759:4:1:1:Plate::1:0:980,1323,1349,3095,4177,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Platemail Armor
	[8095]="0:0:1:1:Consumable::1:0:", -- Hinott's Oil
	[8106]="0:4:2:1:Cloth::1:0:", -- Hibernal Armor
	[8107]="0:4:2:1:Cloth::1:0:", -- Hibernal Boots
	[8108]="0:4:2:1:Cloth::1:0:", -- Hibernal Bracers
	[8109]="0:4:2:1:Cloak::1:0:", -- Hibernal Cloak
	[8110]="0:4:2:1:Cloth::1:0:", -- Hibernal Gloves
	[8111]="0:4:2:1:Cloth::1:0:", -- Hibernal Mantle
	[8112]="0:4:2:1:Cloth::1:0:", -- Hibernal Pants
	[8113]="0:4:2:1:Cloth::1:0:", -- Hibernal Robe
	[8114]="0:4:2:1:Cloth::1:0:", -- Hibernal Sash
	[8115]="0:4:2:1:Cloth::1:0:", -- Hibernal Cowl
	[8116]="0:4:2:1:Leather::1:0:", -- Heraldic Belt
	[8117]="0:4:2:1:Leather::1:0:", -- Heraldic Boots
	[8118]="0:4:2:1:Leather::1:0:", -- Heraldic Bracers
	[8119]="0:4:2:1:Leather::1:0:", -- Heraldic Breastplate
	[8120]="0:4:2:1:Cloak::1:0:", -- Heraldic Cloak
	[8121]="0:4:2:1:Leather::1:0:", -- Heraldic Gloves
	[8122]="0:4:2:1:Leather::1:0:", -- Heraldic Headpiece
	[8123]="0:4:2:1:Leather::1:0:", -- Heraldic Leggings
	[8124]="0:4:2:1:Leather::1:0:", -- Heraldic Spaulders
	[8125]="0:4:2:1:Mail::1:0:", -- Myrmidon's Bracers
	[8126]="0:4:2:1:Mail::1:0:", -- Myrmidon's Breastplate
	[8127]="0:4:2:1:Cloak::1:0:", -- Myrmidon's Cape
	[8128]="0:4:2:1:Mail::1:0:", -- Myrmidon's Gauntlets
	[8129]="0:4:2:1:Mail::1:0:", -- Myrmidon's Girdle
	[8130]="0:4:2:1:Mail::1:0:", -- Myrmidon's Greaves
	[8131]="0:4:2:1:Mail::1:0:", -- Myrmidon's Helm
	[8132]="0:4:2:1:Mail::1:0:", -- Myrmidon's Leggings
	[8133]="0:4:2:1:Mail::1:0:", -- Myrmidon's Pauldrons
	[8134]="0:4:2:1:Shield::1:0:", -- Myrmidon's Defender
	[8135]="0:4:2:1:Shield::1:0:", -- Chromite Shield
	[8136]="0:12:1:1:::1:0:", -- Gargantuan Tumor
	[8137]="0:4:2:1:Plate::1:0:", -- Chromite Bracers
	[8138]="0:4:2:1:Plate::1:0:", -- Chromite Chestplate
	[8139]="0:4:2:1:Plate::1:0:", -- Chromite Gauntlets
	[8140]="0:4:2:1:Plate::1:0:", -- Chromite Girdle
	[8141]="0:4:2:1:Plate::1:0:", -- Chromite Greaves
	[8142]="0:4:2:1:Plate::1:0:", -- Chromite Barbute
	[8143]="0:4:2:1:Plate::1:0:", -- Chromite Legplates
	[8144]="0:4:2:1:Plate::1:0:", -- Chromite Pauldrons
	[8146]="0:15:0:5:Junk::1:0:", -- Wicked Claw
	[8149]="0:12:1:1:::1:0:", -- Voodoo Charm
	[8150]="0:7:1:20:Leather:185,202,165:1:0:", -- Deeprock Salt
	[8151]="0:7:1:20:Other:202,755,165:1:0:", -- Flask of Mojo
	[8152]="0:7:1:20:Other:755,165:1:0:", -- Flask of Big Mojo
	[8153]="0:7:2:20:Herb:171,164,333,202,165,197:1:0:", -- Wildvine
	[8154]="0:7:1:20:Leather:165:1:0:", -- Scorpid Scale
	[8155]="0:12:1:1:::1:0:", -- Sathrah's Sacrifice
	[8156]="0:4:2:1:Plate::1:0:", -- Jouster's Wristguards
	[8157]="0:4:2:1:Plate::1:0:", -- Jouster's Chestplate
	[8158]="0:4:2:1:Plate::1:0:", -- Jouster's Gauntlets
	[8159]="0:4:2:1:Plate::1:0:", -- Jouster's Girdle
	[8160]="0:4:2:1:Plate::1:0:", -- Jouster's Greaves
	[8161]="0:4:2:1:Plate::1:0:", -- Jouster's Visor
	[8162]="0:4:2:1:Plate::1:0:", -- Jouster's Legplates
	[8163]="0:4:2:1:Plate::1:0:", -- Jouster's Pauldrons
	[8165]="0:7:1:20:Leather:165:1:0:", -- Worn Dragonscale
	[8167]="0:7:1:20:Leather:165:1:0:", -- Turtle Scale
	[8168]="0:7:0:20:Leather::1:0:", -- Jet Black Feather
	[8169]="0:7:1:10:Leather:165:1:0:", -- Thick Hide
	[8170]="2000:7:1:20:Leather:164,333,202,165,197:1:1:14846", -- Rugged Leather
	[8171]="0:7:1:10:Leather:165:1:0:", -- Rugged Hide
	[8172]="0:7:1:20:Leather:165:1:0:", -- Cured Thick Hide
	[8173]="0:0:1:10:EnhPerm::1:0:", -- Thick Armor Kit
	[8174]="0:4:3:1:Leather::1:0:", -- Comfortable Leather Hat
	[8175]="0:4:2:1:Leather::1:0:", -- Nightscape Tunic
	[8176]="0:4:2:1:Leather::1:0:", -- Nightscape Headband
	[8177]="0:2:1:1:TwoHandSword::1:0:", -- Practice Sword
	[8178]="0:2:2:1:TwoHandSword::1:0:", -- Training Sword
	[8179]="0:2:1:1:Bow::1:0:", -- Cadet's Bow
	[8180]="0:2:2:1:Bow::1:0:", -- Hunting Bow
	[8181]="0:2:1:1:Gun::1:0:", -- Hunting Rifle
	[8182]="0:2:1:1:Gun::1:0:", -- Pellet Rifle
	[8183]="0:2:2:1:Bow::1:0:", -- Precision Bow
	[8184]="0:2:2:1:Wand::1:0:", -- Firestarter
	[8185]="0:4:2:1:Mail::1:0:", -- Turtle Scale Leggings
	[8186]="0:2:2:1:Wand::1:0:", -- Dire Wand
	[8187]="0:4:2:1:Mail::1:0:", -- Turtle Scale Gloves
	[8188]="0:2:2:1:Gun::1:0:", -- Explosive Shotgun
	[8189]="0:4:2:1:Mail::1:0:", -- Turtle Scale Breastplate
	[8190]="0:2:3:1:OneHandSword::1:0:", -- Hanzo Sword
	[8191]="0:4:2:1:Mail::1:0:", -- Turtle Scale Helm
	[8192]="0:4:2:1:Leather::1:0:", -- Nightscape Shoulders
	[8193]="0:4:2:1:Leather::1:0:", -- Nightscape Pants
	[8194]="0:2:2:1:OneHandMace::1:0:", -- Goblin Nutcracker
	[8195]="0:4:2:1:Cloak::1:0:", -- Nightscape Cloak
	[8196]="0:2:2:1:OneHandSword::1:0:", -- Ebon Scimitar
	[8197]="0:4:2:1:Leather::1:0:", -- Nightscape Boots
	[8198]="0:4:2:1:Mail::1:0:", -- Turtle Scale Bracers
	[8199]="0:2:2:1:TwoHandSword::1:0:", -- Battlefield Destroyer
	[8200]="0:4:2:1:Leather::1:0:", -- Big Voodoo Robe
	[8201]="0:4:2:1:Leather::1:0:", -- Big Voodoo Mask
	[8202]="0:4:2:1:Leather::1:0:", -- Big Voodoo Pants
	[8203]="0:4:2:1:Mail::1:0:", -- Tough Scorpid Breastplate
	[8204]="0:4:2:1:Mail::1:0:", -- Tough Scorpid Gloves
	[8205]="0:4:2:1:Mail::1:0:", -- Tough Scorpid Bracers
	[8206]="0:4:2:1:Mail::1:0:", -- Tough Scorpid Leggings
	[8207]="0:4:2:1:Mail::1:0:", -- Tough Scorpid Shoulders
	[8208]="0:4:2:1:Mail::1:0:", -- Tough Scorpid Helm
	[8209]="0:4:2:1:Mail::1:0:", -- Tough Scorpid Boots
	[8210]="0:4:2:1:Leather::1:0:", -- Wild Leather Shoulders
	[8211]="0:4:2:1:Leather::1:0:", -- Wild Leather Vest
	[8212]="0:4:2:1:Leather::1:0:", -- Wild Leather Leggings
	[8213]="0:4:2:1:Leather::1:0:", -- Wild Leather Boots
	[8214]="0:4:2:1:Leather::1:0:", -- Wild Leather Helmet
	[8215]="0:4:2:1:Cloak::1:0:", -- Wild Leather Cloak
	[8216]="0:4:2:1:Cloak::1:0:", -- Big Voodoo Cloak
	[8217]="0:11:2:1:Quiver::1:0:", -- Quickdraw Quiver
	[8218]="0:11:2:1:AmmoPouch::1:0:", -- Thick Leather Ammo Pouch
	[8223]="0:2:3:1:OneHandSword::1:0:", -- Blade of the Basilisk
	[8224]="0:2:2:1:OneHandSword::1:0:", -- Silithid Ripper
	[8225]="0:2:3:1:OneHandSword::1:0:", -- Tainted Pierce
	[8226]="0:2:3:1:OneHandSword::1:0:", -- The Butcher
	[8244]="0:12:3:20:::1:0:", -- Flawless Draenethyst Sphere
	[8245]="0:4:2:1:Cloth::1:0:", -- Imperial Red Tunic
	[8246]="0:4:2:1:Cloth::1:0:", -- Imperial Red Boots
	[8247]="0:4:2:1:Cloth::1:0:", -- Imperial Red Bracers
	[8248]="0:4:2:1:Cloak::1:0:", -- Imperial Red Cloak
	[8249]="0:4:2:1:Cloth::1:0:", -- Imperial Red Gloves
	[8250]="0:4:2:1:Cloth::1:0:", -- Imperial Red Mantle
	[8251]="0:4:2:1:Cloth::1:0:", -- Imperial Red Pants
	[8252]="0:4:2:1:Cloth::1:0:", -- Imperial Red Robe
	[8253]="0:4:2:1:Cloth::1:0:", -- Imperial Red Sash
	[8254]="0:4:2:1:Cloth::1:0:", -- Imperial Red Circlet
	[8255]="0:4:2:1:Leather::1:0:", -- Serpentskin Girdle
	[8256]="0:4:2:1:Leather::1:0:", -- Serpentskin Boots
	[8257]="0:4:2:1:Leather::1:0:", -- Serpentskin Bracers
	[8258]="0:4:2:1:Leather::1:0:", -- Serpentskin Armor
	[8259]="0:4:2:1:Cloak::1:0:", -- Serpentskin Cloak
	[8260]="0:4:2:1:Leather::1:0:", -- Serpentskin Gloves
	[8261]="0:4:2:1:Leather::1:0:", -- Serpentskin Helm
	[8262]="0:4:2:1:Leather::1:0:", -- Serpentskin Leggings
	[8263]="0:4:2:1:Leather::1:0:", -- Serpentskin Spaulders
	[8264]="0:4:2:1:Mail::1:0:", -- Ebonhold Wristguards
	[8265]="0:4:2:1:Mail::1:0:", -- Ebonhold Armor
	[8266]="0:4:2:1:Cloak::1:0:", -- Ebonhold Cloak
	[8267]="0:4:2:1:Mail::1:0:", -- Ebonhold Gauntlets
	[8268]="0:4:2:1:Mail::1:0:", -- Ebonhold Girdle
	[8269]="0:4:2:1:Mail::1:0:", -- Ebonhold Boots
	[8270]="0:4:2:1:Mail::1:0:", -- Ebonhold Helmet
	[8271]="0:4:2:1:Mail::1:0:", -- Ebonhold Leggings
	[8272]="0:4:2:1:Mail::1:0:", -- Ebonhold Shoulderpads
	[8273]="0:4:2:1:Plate::1:0:", -- Valorous Wristguards
	[8274]="0:4:2:1:Plate::1:0:", -- Valorous Chestguard
	[8275]="0:4:2:1:Shield::1:0:", -- Ebonhold Buckler
	[8276]="0:4:2:1:Plate::1:0:", -- Valorous Gauntlets
	[8277]="0:4:2:1:Plate::1:0:", -- Valorous Girdle
	[8278]="0:4:2:1:Plate::1:0:", -- Valorous Greaves
	[8279]="0:4:2:1:Plate::1:0:", -- Valorous Helm
	[8280]="0:4:2:1:Plate::1:0:", -- Valorous Legguards
	[8281]="0:4:2:1:Plate::1:0:", -- Valorous Pauldrons
	[8282]="0:4:2:1:Shield::1:0:", -- Valorous Shield
	[8283]="0:4:2:1:Cloth::1:0:", -- Arcane Armor
	[8284]="0:4:2:1:Cloth::1:0:", -- Arcane Boots
	[8285]="0:4:2:1:Cloth::1:0:", -- Arcane Bands
	[8286]="0:4:2:1:Cloak::1:0:", -- Arcane Cloak
	[8287]="0:4:2:1:Cloth::1:0:", -- Arcane Gloves
	[8288]="0:4:2:1:Cloth::1:0:", -- Arcane Pads
	[8289]="0:4:2:1:Cloth::1:0:", -- Arcane Leggings
	[8290]="0:4:2:1:Cloth::1:0:", -- Arcane Robe
	[8291]="0:4:2:1:Cloth::1:0:", -- Arcane Sash
	[8292]="0:4:2:1:Cloth::1:0:", -- Arcane Cover
	[8293]="0:4:2:1:Leather::1:0:", -- Traveler's Belt
	[8294]="0:4:2:1:Leather::1:0:", -- Traveler's Boots
	[8295]="0:4:2:1:Leather::1:0:", -- Traveler's Bracers
	[8296]="0:4:2:1:Leather::1:0:", -- Traveler's Jerkin
	[8297]="0:4:2:1:Cloak::1:0:", -- Traveler's Cloak
	[8298]="0:4:2:1:Leather::1:0:", -- Traveler's Gloves
	[8299]="0:4:2:1:Leather::1:0:", -- Traveler's Helm
	[8300]="0:4:2:1:Leather::1:0:", -- Traveler's Leggings
	[8301]="0:4:2:1:Leather::1:0:", -- Traveler's Spaulders
	[8302]="0:4:2:1:Mail::1:0:", -- Hero's Bracers
	[8303]="0:4:2:1:Mail::1:0:", -- Hero's Breastplate
	[8304]="0:4:2:1:Cloak::1:0:", -- Hero's Cape
	[8305]="0:4:2:1:Mail::1:0:", -- Hero's Gauntlets
	[8306]="0:4:2:1:Mail::1:0:", -- Hero's Belt
	[8307]="0:4:2:1:Mail::1:0:", -- Hero's Boots
	[8308]="0:4:2:1:Mail::1:0:", -- Hero's Band
	[8309]="0:4:2:1:Mail::1:0:", -- Hero's Leggings
	[8310]="0:4:2:1:Mail::1:0:", -- Hero's Pauldrons
	[8311]="0:4:2:1:Plate::1:0:", -- Alabaster Plate Vambraces
	[8312]="0:4:2:1:Plate::1:0:", -- Alabaster Breastplate
	[8313]="0:4:2:1:Shield::1:0:", -- Hero's Buckler
	[8314]="0:4:2:1:Plate::1:0:", -- Alabaster Plate Gauntlets
	[8315]="0:4:2:1:Plate::1:0:", -- Alabaster Plate Girdle
	[8316]="0:4:2:1:Plate::1:0:", -- Alabaster Plate Greaves
	[8317]="0:4:2:1:Plate::1:0:", -- Alabaster Plate Helmet
	[8318]="0:4:2:1:Plate::1:0:", -- Alabaster Plate Leggings
	[8319]="0:4:2:1:Plate::1:0:", -- Alabaster Plate Pauldrons
	[8320]="0:4:2:1:Shield::1:0:", -- Alabaster Shield
	[8343]="2000:7:1:20:Cloth:165,197:1:0:989,1148,1286,1347,1454,1474,1672,2225,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3091,3096,3364,3366,3367,3485,3779,3954,3955,3958,4168,4189,4225,4229,4561,4577,4589,4775,4897,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,11189,11557,11874,12022,12028,12245,12941,12942,12943,12956,12957,12958,15165,15179,16366,16613,16638,16689,16748,16767,16768,17486,18009,18277,18749,18754,18771,18772,19196,19213,19244,19372,19450,19521,19532,19722,21085,24843,24935,24995,25010,25019,25051,25082,27021,27026,27043,27057,28692,28718,28726,28798,28810,28831,28872,29288,30311,33596,33601,33635,33636,33681,33684", -- Heavy Silken Thread
	[8344]="0:12:1:1:::1:0:", -- Silvery Spinnerets
	[8345]="0:4:3:1:Leather::1:0:", -- Wolfshead Helm
	[8346]="0:4:3:1:Leather::1:0:", -- Gauntlets of the Sea
	[8347]="0:4:3:1:Mail::1:0:", -- Dragonscale Gauntlets
	[8348]="0:4:3:1:Leather::1:0:", -- Helm of Fire
	[8349]="0:4:3:1:Leather::1:0:", -- Feathered Breastplate
	[8350]="0:4:2:1:Ring::1:0:", -- The 1 Ring
	[8363]="0:12:1:1:::1:0:", -- Shaman Voodoo Charm
	[8364]="0:0:1:20:FoodDrink::1:0:", -- Mithril Head Trout
	[8365]="0:7:1:20:Meat:185:1:0:", -- Raw Mithril Head Trout
	[8366]="0:15:1:1:Other::1:0:", -- Bloated Trout
	[8367]="0:4:3:1:Mail::1:0:", -- Dragonscale Breastplate
	[8368]="0:15:0:10:Junk::1:0:", -- Thick Wolfhide
	[8383]="0:15:1:1:Junk::1:0:", -- Plain Letter
	[8384]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Comfortable Leather Hat
	[8385]="3500:9:1:1:Leatherworking::1:1:7852,7854", -- Pattern: Turtle Scale Gloves
	[8386]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Big Voodoo Robe
	[8387]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Big Voodoo Mask
	[8389]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Big Voodoo Pants
	[8390]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Big Voodoo Cloak
	[8391]="0:12:1:20:::1:0:", -- Snickerfang Jowl
	[8392]="0:12:1:20:::1:0:", -- Blasted Boar Lung
	[8393]="0:12:1:20:::1:0:", -- Scorpok Pincer
	[8394]="0:12:1:20:::1:0:", -- Basilisk Brain
	[8395]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Tough Scorpid Breastplate
	[8396]="0:12:1:20:::1:0:", -- Vulture Gizzard
	[8397]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Tough Scorpid Bracers
	[8398]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Tough Scorpid Gloves
	[8399]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Tough Scorpid Boots
	[8400]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Tough Scorpid Shoulders
	[8401]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Tough Scorpid Leggings
	[8402]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Tough Scorpid Helm
	[8403]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wild Leather Shoulders
	[8404]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wild Leather Vest
	[8405]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wild Leather Helmet
	[8406]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wild Leather Boots
	[8407]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wild Leather Leggings
	[8408]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wild Leather Cloak
	[8409]="4000:9:2:1:Leatherworking::1:1:7854,8160", -- Pattern: Nightscape Shoulders
	[8410]="0:0:1:1:Elixir::1:0:", -- R.O.I.D.S.
	[8411]="0:0:1:1:Elixir::1:0:", -- Lung Juice Cocktail
	[8412]="0:0:1:1:Elixir::1:0:", -- Ground Scorpok Assay
	[8423]="0:0:1:1:Elixir::1:0:", -- Cerebral Cortex Compound
	[8424]="0:0:1:1:Elixir::1:0:", -- Gizzard Gum
	[8425]="0:15:0:20:Junk::1:0:", -- Parrot Droppings
	[8426]="0:15:0:20:Junk::1:0:", -- Large Ruffled Feather
	[8427]="0:15:0:20:Junk::1:0:", -- Mutilated Rat Carcass
	[8428]="0:12:1:1:::1:0:", -- Laden Dew Gland
	[8429]="0:15:0:10:Junk::1:0:", -- Punctured Dew Gland
	[8430]="0:15:0:10:Junk::1:0:", -- Empty Dew Gland
	[8431]="0:12:1:1:::1:0:", -- Spool of Light Chartreuse Silk Thread
	[8432]="0:0:1:1:Consumable::1:0:", -- Eau de Mixilpixil
	[8443]="0:12:1:20:::1:0:", -- Gahz'ridian Ornament
	[8444]="0:13:1:1:::1:0:", -- Executioner's Key
	[8463]="0:12:1:1:::1:0:", -- Warchief's Orders
	[8483]="0:12:1:20:::1:0:", -- Wastewander Water Pouch
	[8484]="0:15:1:1:Junk::1:0:", -- Gadgetzan Water Co. Care Package
	[8485]="4000:15:1:1:Companion::1:0:6367", -- Cat Carrier (Bombay)
	[8486]="4000:15:1:1:Companion::1:0:6367", -- Cat Carrier (Cornish Rex)
	[8487]="4000:15:1:1:Companion::1:0:6367", -- Cat Carrier (Orange Tabby)
	[8488]="4000:15:1:1:Companion::1:0:6367", -- Cat Carrier (Silver Tabby)
	[8489]="6000:15:1:1:Companion::1:1:8666", -- Cat Carrier (White Kitten)
	[8490]="6000:15:1:1:Companion::1:0:20980", -- Cat Carrier (Siamese)
	[8491]="0:15:1:1:Companion::1:0:", -- Cat Carrier (Black Tabby)
	[8492]="0:15:1:1:Companion::1:0:", -- Parrot Cage (Green Wing Macaw)
	[8494]="0:15:4:1:Companion::1:0:", -- Parrot Cage (Hyacinth Macaw)
	[8495]="4000:15:1:1:Companion::1:0:2663,20980", -- Parrot Cage (Senegal)
	[8496]="4000:15:1:1:Companion::1:0:2663", -- Parrot Cage (Cockatiel)
	[8497]="2000:15:1:1:Companion::1:0:1263", -- Rabbit Crate (Snowshoe)
	[8498]="0:15:1:1:Companion::1:0:", -- Tiny Emerald Whelpling
	[8499]="0:15:1:1:Companion::1:0:", -- Tiny Crimson Whelpling
	[8500]="5000:15:1:1:Companion::1:0:8665", -- Great Horned Owl
	[8501]="5000:15:1:1:Companion::1:0:8665", -- Hawk Owl
	[8508]="0:15:0:5:Junk::1:0:", -- Large Fin
	[8523]="1000:12:1:1:::1:0:7683", -- Field Testing Kit
	[8524]="0:12:2:1:::1:0:", -- Model 4711-FTZ Power Source
	[8525]="0:12:1:1:::1:0:", -- Zinge's Purchase Order
	[8526]="0:12:1:1:::1:0:", -- Violet Tragan
	[8527]="0:12:1:1:::1:0:", -- Sealed Field Testing Kit
	[8528]="0:12:1:1:::1:0:", -- Violet Powder
	[8529]="3500:0:1:20:Elixir::5:0:7564", -- Noggenfogger Elixir
	[8544]="0:0:1:20:Bandage::1:0:", -- Mageweave Bandage
	[8545]="0:0:1:20:Bandage::1:0:", -- Heavy Mageweave Bandage
	[8546]="0:0:1:1:Other::1:0:", -- Powerful Smelling Salts
	[8548]="0:0:1:1:Consumable::1:0:", -- Divino-matic Rod
	[8563]="10000:15:3:1:Mount::1:0:7955", -- Red Mechanostrider
	[8564]="0:12:1:1:::1:0:", -- Hippogryph Egg
	[8584]="0:12:1:1:::1:0:", -- Untapped Dowsing Widget
	[8585]="0:12:1:1:::1:0:", -- Tapped Dowsing Widget
	[8586]="0:15:4:1:Mount::1:0:", -- Whistle of the Mottled Red Raptor
	[8587]="0:12:1:20:::1:0:", -- Centipaar Insect Parts
	[8588]="10000:15:3:1:Mount::1:0:7952", -- Whistle of the Emerald Raptor
	[8591]="10000:15:3:1:Mount::1:0:7952", -- Whistle of the Turquoise Raptor
	[8592]="10000:15:3:1:Mount::1:0:7952", -- Whistle of the Violet Raptor
	[8593]="0:12:1:1:::1:0:", -- Scrimshank's Surveying Gear
	[8594]="0:12:1:1:::1:0:", -- Insect Analysis Report
	[8595]="10000:15:3:1:Mount::1:0:7955", -- Blue Mechanostrider
	[8603]="0:12:1:1:::1:0:", -- Thistleshrub Dew
	[8623]="0:12:2:1:::1:0:", -- OOX-17/TN Distress Beacon
	[8624]="1000:4:1:1:OffHandFrill::1:0:8117,8118", -- Red Sparkler
	[8625]="1000:4:1:1:OffHandFrill::1:0:8117,8118", -- White Sparkler
	[8626]="1000:4:1:1:OffHandFrill::1:0:8117,8118", -- Blue Sparkler
	[8628]="0:15:1:1:Mount::1:0:", -- Reins of the Spotted Nightsaber
	[8629]="10000:15:3:1:Mount::1:0:4730", -- Reins of the Striped Nightsaber
	[8631]="10000:15:3:1:Mount::1:0:4730", -- Reins of the Striped Frostsaber
	[8632]="10000:15:3:1:Mount::1:0:4730", -- Reins of the Spotted Frostsaber
	[8643]="0:12:1:1:::1:0:", -- Extraordinary Egg
	[8644]="0:12:1:1:::1:0:", -- Fine Egg
	[8645]="0:12:1:1:::1:0:", -- Ordinary Egg
	[8646]="0:12:1:1:::1:0:", -- Bad Egg
	[8647]="0:12:1:1:::1:0:", -- Egg Crate
	[8663]="0:4:2:1:Trinket::1:0:", -- Mithril Insignia
	[8683]="0:12:1:20:::1:0:", -- Clara's Fresh Apple
	[8684]="0:12:1:20:::1:0:", -- Hinterlands Honey Ripple
	[8685]="0:12:1:1:::1:0:", -- Dran's Ripple Delivery
	[8686]="0:12:1:1:::1:0:", -- Mithril Pendant
	[8687]="0:12:1:1:::1:0:", -- Sealed Description of Thredd's Visitor
	[8703]="0:4:2:1:Trinket::1:0:", -- Signet of Expertise
	[8704]="0:12:2:1:::1:0:", -- OOX-09/HL Distress Beacon
	[8705]="0:12:2:1:::1:0:", -- OOX-22/FE Distress Beacon
	[8707]="0:12:1:1:::1:0:", -- Gahz'rilla's Electrified Scale
	[8708]="0:2:4:1:OneHandMace::1:0:", -- Hammer of Expertise
	[8723]="0:12:1:1:::1:0:", -- Caliph Scorpidsting's Head
	[8724]="0:12:1:1:::1:0:", -- Rin'ji's Secret
	[8746]="0:4:0:1:Cloth::1:0:", -- Interlaced Cowl
	[8747]="0:4:0:1:Leather::1:0:", -- Hardened Leather Helm
	[8748]="0:4:0:1:Mail::1:0:", -- Double Mail Coif
	[8749]="0:4:0:1:Cloth::1:0:", -- Crochet Hat
	[8750]="0:4:0:1:Leather::1:0:", -- Thick Leather Hat
	[8751]="0:4:0:1:Mail::1:0:", -- Overlinked Coif
	[8752]="0:4:0:1:Mail::1:0:", -- Laminated Scale Circlet
	[8753]="0:4:0:1:Leather::1:0:", -- Smooth Leather Helmet
	[8754]="0:4:0:1:Cloth::1:0:", -- Twill Cover
	[8755]="0:4:0:1:Plate::1:0:", -- Light Plate Helmet
	[8766]="4000:0:1:20:FoodDrink::5:0:258,274,295,465,734,955,982,1237,1247,1328,1464,1697,2303,2352,2364,2366,2388,2803,2806,2832,3086,3298,3411,3546,3577,3621,3689,3708,3881,3882,3883,3884,3934,3937,3959,3961,4167,4169,4181,4190,4191,4192,4195,4255,4266,4554,4555,4571,4782,4875,4879,4893,4981,5111,5112,5140,5611,5620,5688,5814,5871,6091,6272,6495,6727,6734,6735,6736,6737,6738,6739,6740,6741,6746,6747,6790,6791,6807,6928,6929,6930,7485,7714,7731,7733,7736,7737,7744,7941,7943,8125,8137,8143,8150,8152,8931,9356,9501,10367,11038,11103,11106,11116,11118,11187,11287,12019,12026,12096,12097,12196,12959,14371,14624,14731,14961,14962,14963,14964,15124,15125,15174,15397,15433,16256,16443,16458,16542,16553,16585,16602,16618,16739,16798,16826,17277,17553,17630,17656,18245,18251,18905,18906,18907,18908,18913,18914,18957,19050,19182,19232,19245,19296,19314,19315,19348,19352,19435,19451,19470,19495,19518,19528,19559,19572,19617,19679,19718,20080,20231,20893,20916,21084,21110,21145,21183,21484,21487,21744,21746,23110,23143,23573,23748,23995,24033,24057,24149,24208,24333,24342,24834,24934,24993,25012,25020,25036,25052,25089,26375,26680,29205,29291,33018", -- Morning Glory Dew
	[8827]="0:0:1:20:Elixir::1:0:", -- Elixir of Water Walking
	[8831]="0:7:1:20:Herb:171,333,197:1:0:", -- Purple Lotus
	[8836]="0:7:1:20:Herb:171:1:0:", -- Arthas' Tears
	[8838]="0:7:1:20:Herb:171,333:1:0:", -- Sungrass
	[8839]="0:7:1:20:Herb:171:1:0:", -- Blindweed
	[8845]="1500:7:1:20:Herb:171:1:1:14846", -- Ghost Mushroom
	[8846]="1000:7:1:20:Herb:171:1:1:16015", -- Gromsblood
	[8923]="0:15:0:20:Junk::1:0:", -- Essence of Agony
	[8924]="0:15:0:20:Junk::1:0:", -- Dust of Deterioration
	[8925]="2500:7:1:20:Other:171,333:5:0:844,958,983,989,1148,1257,1286,1313,1453,2225,2380,2480,2481,2810,2812,2821,2848,3010,3014,3348,3367,3405,3548,3779,3954,3955,3956,4216,4226,4229,4561,4610,4615,4775,4897,4899,5135,5138,5163,5178,5503,5594,5817,6301,7947,8145,8157,8158,8177,8178,8305,8363,8934,11188,11189,12022,12028,12245,12941,12957,12958,15179,16367,16612,16613,16641,16705,16706,16768,16829,17486,18005,18009,19074,19244,19372,19450,19837,20989,24843,24935,24975,24995,25010,25019,25051,25082,26568,27021,27026,27031,27038,27043,27053,27057,27140,27141,28692,28725,28727,28828,28829,28831,28866,28868,28872,29288,29535,29909,30311,33600,33630,33639,33674,33678", -- Crystal Vial
	[8926]="500:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Instant Poison IV
	[8927]="700:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,24148,24313,24780,25043,26382,26568,27031,27038,27053,27089,28347,29535,30239,30244,30306,30438,31115,32639,32641,33630,33674", -- Instant Poison V
	[8928]="800:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,23732,24148,24313,24349,24357,24780,25043,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,33630,33674,37904,37935", -- Instant Poison VI
	[8932]="4000:0:1:20:FoodDrink::5:0:295,465,483,1237,2352,2364,3298,3546,4255,4782,4891,4894,4981,5620,6746,6790,6930,9501,10367,11106,11116,16553,17630,18929,19232,19296,19718,20080,20916,21110,21744,21746,22266,23521,23604,24342,24934", -- Alterac Swiss
	[8948]="4000:0:1:20:FoodDrink::5:0:2803,2806,3138,3329,3544,3547,4554,4571,5688,5886,6739,6741,8150,8152,10367,11038,12096,12097,12384,14961,14962,14963,14964,15124,15125,17656,19471,22266,23748,24149,24342,24396,24408,27032,29205,33018", -- Dried King Bolete
	[8949]="0:0:1:20:Elixir:165:1:0:", -- Elixir of Agility
	[8950]="4000:0:1:20:FoodDrink::5:0:233,1237,1247,1670,2352,2364,2832,3003,3086,3291,3480,3518,3546,3689,3708,3883,3884,3937,3948,3959,4190,4255,4266,4891,4894,5109,5620,6272,6734,6736,6737,6740,6747,7485,7737,7744,7941,8143,8307,9099,10367,11103,11287,15433,16256,16458,16739,17630,18245,18251,18907,19038,19232,19348,19352,19451,19495,19518,19664,20893,21744,21746,23522,23603,23937,24033,24057,24834,24934,24993,25012,25020,25052,25089,29291,33996", -- Homemade Cherry Pie
	[8951]="0:0:1:20:Elixir:165:1:0:", -- Elixir of Greater Defense
	[8952]="4000:0:1:20:FoodDrink::5:0:982,1464,2365,2388,2814,3025,3089,3312,3368,3411,3489,3621,3705,3881,3882,3933,3935,3960,4084,4169,4255,4782,4875,4879,4891,4894,4954,5111,5124,5611,5620,5870,6928,6929,7485,7731,7733,8125,9356,10367,11118,11187,12096,12097,12196,12959,14624,14961,14962,14963,14964,15124,15125,15174,15397,16443,16585,16602,16618,16739,16798,16826,17277,17553,17630,17656,18905,18906,18908,18913,18914,18957,19038,19182,19314,19315,19348,19352,19435,19470,19528,19559,19572,19679,19718,20097,20231,20378,20893,21084,22266,23143,23263,23481,23605,23748,24208,24343,25036,26375,28760,28943,29205", -- Roasted Quail
	[8953]="4000:0:1:20:FoodDrink::5:0:734,894,1671,3017,3342,3934,3961,4191,4255,4891,5814,6735,6740,7714,7736,7978,12096,12097,14961,14962,14963,14964,15124,15125,16443,16542,16798,17277,17630,18957,19050,19223,19232,19471,19572,19718,21145,21484,21487,21744,21746,22266,23573,24934,25036,26375,26680,29547", -- Deep Fried Plantains
	[8956]="0:0:1:5:Other::1:0:", -- Oil of Immolation
	[8957]="4000:0:1:20:FoodDrink::5:0:1678,1684,2842,3086,3178,3497,3540,4200,4221,4255,4305,4307,5814,6727,6738,6791,6807,7943,8137,8931,10367,11187,12962,14731,16618,16739,17553,17656,19045,19296,19472,22266,23748,23896,24033,24057,24834,24993,25012,25020,25036,25052,25089,29291", -- Spinefin Halibut
	[8959]="0:7:1:20:Meat::1:0:", -- Raw Spinefin Halibut
	[8973]="0:12:1:20:::1:0:", -- Thick Yeti Hide
	[8984]="200:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Deadly Poison III
	[8985]="250:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,24148,24313,24780,25043,26382,26568,27031,27038,27053,27089,28347,29535,30239,30244,30306,30438,31115,32639,32641,33630,33674", -- Deadly Poison IV
	[9030]="0:0:1:20:Potion::1:0:", -- Restorative Potion
	[9036]="0:0:1:20:Potion::1:0:", -- Magic Resistance Potion
	[9060]="0:7:1:20:Part:202:1:0:", -- Inlaid Mithril Cylinder
	[9061]="0:7:1:20:Part:185,202:1:0:", -- Goblin Rocket Fuel
	[9088]="0:0:1:20:Elixir::1:0:", -- Gift of Arthas
	[9144]="0:0:1:20:Potion::1:0:", -- Wildvine Potion
	[9149]="0:4:2:1:Trinket:171:1:0:", -- Philosopher's Stone
	[9153]="0:12:1:1:::1:0:", -- Rig Blueprints
	[9154]="0:0:1:20:Elixir::1:0:", -- Elixir of Detect Undead
	[9155]="0:0:1:20:Elixir::1:0:", -- Arcane Elixir
	[9172]="0:0:1:20:Potion::1:0:", -- Invisibility Potion
	[9173]="0:12:1:1:::1:0:", -- Goblin Transponder
	[9179]="0:0:1:20:Elixir::1:0:", -- Elixir of Greater Intellect
	[9186]="0:15:0:20:Junk::1:0:", -- Mind-numbing Poison III
	[9187]="0:0:1:20:Elixir::1:0:", -- Elixir of Greater Agility
	[9189]="0:12:1:1:::1:0:", -- Shay's Bell
	[9197]="0:0:1:20:Elixir::1:0:", -- Elixir of Dream Vision
	[9206]="0:0:1:20:Elixir::1:0:", -- Elixir of Giants
	[9210]="0:7:1:10:Other:197:1:0:", -- Ghost Dye
	[9214]="0:15:2:1:CombatPet::1:0:", -- Grimoire of Inferno
	[9224]="0:0:1:20:Elixir:333:1:0:", -- Elixir of Demonslaying
	[9233]="0:0:1:20:Elixir::1:0:", -- Elixir of Detect Demon
	[9234]="0:12:1:1:::1:0:", -- Tiara of the Deep
	[9235]="0:12:1:1:::1:0:", -- Pratt's Letter
	[9236]="0:12:1:1:::1:0:", -- Jangdor's Letter
	[9237]="0:12:1:20:::1:0:", -- Woodpaw Gnoll Mane
	[9238]="0:12:1:20:::1:0:", -- Uncracked Scarab Shell
	[9240]="0:2:3:1:OneHandMace::1:0:", -- Mallet of Zul'Farrak
	[9241]="0:12:1:1:::1:0:", -- Sacred Mallet
	[9242]="0:15:0:1:Junk::1:0:", -- Ancient Tablet
	[9243]="0:4:2:1:Amulet::1:0:", -- Shriveled Heart
	[9244]="0:12:1:1:::1:0:", -- Stoley's Shipment
	[9245]="0:12:1:1:::1:0:", -- Stoley's Bottle
	[9246]="0:12:1:1:::1:0:", -- Firebeard's Head
	[9247]="0:12:1:20:::1:0:", -- Hatecrest Naga Scale
	[9248]="0:12:1:1:::1:0:", -- Mysterious Relic
	[9249]="0:13:2:1:::1:0:", -- Captain's Key
	[9250]="0:12:1:1:::1:0:", -- Ship Schedule
	[9251]="0:12:1:1:::1:0:", -- Upper Map Fragment
	[9252]="0:12:1:1:::1:0:", -- Lower Map Fragment
	[9253]="0:12:1:1:::1:0:", -- Middle Map Fragment
	[9254]="0:12:1:1:::1:0:", -- Cuergo's Treasure Map
	[9255]="0:12:1:1:::1:0:", -- Lahassa Essence
	[9256]="0:12:1:1:::1:0:", -- Imbel Essence
	[9257]="0:12:1:1:::1:0:", -- Samha Essence
	[9258]="0:12:1:1:::1:0:", -- Byltan Essence
	[9259]="0:15:1:20:Junk::1:0:", -- Troll Tribal Necklace
	[9260]="1600:0:1:10:FoodDrink:171:1:1:14322,37903", -- Volatile Rum
	[9261]="0:15:0:10:Junk::1:0:", -- Lead Ore
	[9262]="0:7:1:20:Other:171:1:0:", -- Black Vitriol
	[9263]="0:12:1:1:::1:0:", -- Troyas' Stave
	[9264]="0:0:1:20:Elixir::1:0:", -- Elixir of Shadow Power
	[9265]="0:12:2:1:::1:0:", -- Cuergo's Hidden Treasure
	[9266]="0:12:1:1:::1:0:", -- Woodpaw Battle Plans
	[9275]="0:13:1:1:::1:0:", -- Cuergo's Key
	[9276]="0:15:1:1:Junk::1:0:", -- Pirate's Footlocker
	[9277]="0:12:1:1:::1:0:", -- Techbot's Memory Core
	[9278]="0:12:1:20:::1:0:", -- Essential Artificial
	[9279]="0:12:1:1:::1:0:", -- White Punch Card
	[9280]="0:12:1:1:::1:0:", -- Yellow Punch Card
	[9281]="0:12:1:1:::1:0:", -- Red Punch Card
	[9282]="0:12:1:1:::1:0:", -- Blue Punch Card
	[9283]="0:12:1:1:::1:0:", -- Empty Leaden Collection Phial
	[9284]="0:12:1:1:::1:0:", -- Full Leaden Collection Phial
	[9285]="0:4:2:1:Plate::1:0:", -- Field Plate Vambraces
	[9286]="0:4:2:1:Plate::1:0:", -- Field Plate Armor
	[9287]="0:4:2:1:Plate::1:0:", -- Field Plate Gauntlets
	[9288]="0:4:2:1:Plate::1:0:", -- Field Plate Girdle
	[9289]="0:4:2:1:Plate::1:0:", -- Field Plate Boots
	[9290]="0:4:2:1:Plate::1:0:", -- Field Plate Helmet
	[9291]="0:4:2:1:Plate::1:0:", -- Field Plate Leggings
	[9292]="0:4:2:1:Plate::1:0:", -- Field Plate Pauldrons
	[9293]="0:9:2:1:Alchemy::1:0:", -- Recipe: Magic Resistance Potion
	[9294]="0:9:2:1:Alchemy::1:0:", -- Recipe: Wildvine Potion
	[9295]="0:9:2:1:Alchemy::1:0:", -- Recipe: Invisibility Potion
	[9296]="0:9:2:1:Alchemy::1:0:", -- Recipe: Gift of Arthas
	[9297]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Dream Vision
	[9298]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Giants
	[9299]="0:15:1:1:Junk::1:0:", -- Thermaplugg's Safe Combination
	[9300]="10000:9:1:1:Alchemy::1:1:8177,8178", -- Recipe: Elixir of Demonslaying
	[9301]="10000:9:2:1:Alchemy::1:1:1313,4610", -- Recipe: Elixir of Shadow Power
	[9302]="9000:9:1:1:Alchemy::1:1:8157,8158", -- Recipe: Ghost Dye
	[9303]="8000:9:1:1:Alchemy::1:0:5594", -- Recipe: Philosopher's Stone
	[9304]="8000:9:1:1:Alchemy::1:0:5594", -- Recipe: Transmute Iron to Gold
	[9305]="8000:9:1:1:Alchemy::1:1:5594", -- Recipe: Transmute Mithril to Truesilver
	[9306]="0:12:1:1:::1:0:", -- Stave of Equinex
	[9307]="0:12:1:1:::1:0:", -- A Sparkling Stone
	[9308]="0:12:1:20:::1:0:", -- Grime-Encrusted Object
	[9309]="0:12:1:20:::1:0:", -- Robo-mechanical Guts
	[9311]="0:0:1:1:Other::1:0:", -- Default Stationery
	[9312]="20:0:1:5:Other::1:0:8117,8118,15011,15012", -- Blue Firework
	[9313]="20:0:1:5:Other::1:0:8117,8118,15011,15012", -- Green Firework
	[9314]="50:0:1:5:Other::1:0:8117,8118,15011,15012,23208", -- Red Streaks Firework
	[9315]="40:0:1:5:Other::1:0:8117,8118,15011,15012", -- Yellow Rose Firework
	[9316]="0:12:1:1:::1:0:", -- Prismatic Punch Card
	[9317]="25:0:1:5:Other::1:0:8117,8118", -- Red, White and Blue Firework
	[9318]="20:0:1:5:Other::1:0:8117,8118,15011,15012", -- Red Firework
	[9319]="0:0:1:1:Consumable::1:0:", -- Nimboya's Laden Pike
	[9320]="0:12:1:20:::1:0:", -- Witherbark Skull
	[9321]="0:12:1:1:::1:0:", -- Venom Bottle
	[9322]="0:12:1:20:::1:0:", -- Undamaged Venom Sac
	[9323]="0:12:1:1:::1:0:", -- Gadrin's Parchment
	[9324]="0:12:1:1:::1:0:", -- Shadra's Venom
	[9326]="0:12:1:1:::1:0:", -- Grime-Encrusted Ring
	[9327]="0:12:2:1:::1:0:", -- Security DELTA Data Access Card
	[9328]="0:12:1:1:::1:0:", -- Super Snapper FX
	[9329]="0:12:1:1:::1:0:", -- A Short Note
	[9330]="0:12:1:1:::1:0:", -- Snapshot of Gammerita
	[9331]="0:12:1:1:::1:0:", -- Feralas: A History
	[9332]="0:15:0:20:Junk::1:0:", -- Crusted Bandages
	[9333]="0:4:0:20:Amulet::1:0:", -- Tarnished Silver Necklace
	[9334]="0:15:0:10:Junk::1:0:", -- Cracked Pottery
	[9335]="0:15:0:5:Junk::1:0:", -- Broken Obsidian Club
	[9336]="0:15:0:5:Junk::1:0:", -- Gold-capped Troll Tusk
	[9355]="0:15:0:20:Junk::1:0:", -- Hoop Earring
	[9356]="0:15:0:5:Junk::1:0:", -- A Wooden Leg
	[9357]="0:15:0:10:Junk::1:0:", -- A Parrot Skeleton
	[9358]="0:15:0:20:Junk::1:0:", -- A Head Rag
	[9359]="0:2:3:1:OneHandMace::1:0:", -- Wirt's Third Leg
	[9360]="0:0:1:1:FoodDrink::1:0:", -- Cuergo's Gold
	[9361]="0:0:1:1:FoodDrink::1:0:", -- Cuergo's Gold with Worm
	[9362]="0:4:2:1:Ring::1:0:", -- Brilliant Gold Ring
	[9363]="0:15:1:1:Junk::1:0:", -- Sparklematic-Wrapped Box
	[9364]="0:12:1:1:::1:0:", -- Heavy Leaden Collection Phial
	[9365]="0:12:1:1:::1:0:", -- High Potency Radioactive Fallout
	[9366]="0:4:2:1:Mail::1:0:", -- Golden Scale Gauntlets
	[9367]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Golden Scale Gauntlets
	[9368]="0:12:1:1:::1:0:", -- Jer'kai's Signet Ring
	[9369]="0:12:1:20:::1:0:", -- Iridescent Sprite Darter Wing
	[9370]="0:12:1:1:::1:0:", -- Gordunni Scroll
	[9371]="0:12:1:1:::1:0:", -- Gordunni Orb
	[9372]="0:2:4:1:TwoHandSword::1:0:", -- Sul'thraze the Lasher
	[9375]="0:4:3:1:Leather::1:0:", -- Expert Goldminer's Helmet
	[9378]="0:2:3:1:OneHandAxe::1:0:", -- Shovelphlange's Mining Axe
	[9379]="0:2:3:1:OneHandSword::1:0:", -- Sang'thraze the Deflector
	[9381]="0:2:3:1:Wand::1:0:", -- Earthen Rod
	[9382]="0:4:2:1:Leather::1:0:", -- Tromping Miner's Boots
	[9383]="0:2:3:1:TwoHandAxe::1:0:", -- Obsidian Cleaver
	[9384]="0:2:3:1:Dagger::1:0:", -- Stonevault Shiv
	[9385]="0:2:3:1:TwoHandSword::1:0:", -- Archaic Defender
	[9386]="0:2:3:1:OneHandMace::1:0:", -- Excavator's Brand
	[9387]="0:4:3:1:Plate::1:0:", -- Revelosh's Boots
	[9388]="0:4:3:1:Mail::1:0:", -- Revelosh's Armguards
	[9389]="0:4:3:1:Leather::1:0:", -- Revelosh's Spaulders
	[9390]="0:4:3:1:Cloth::1:0:", -- Revelosh's Gloves
	[9391]="0:2:3:1:TwoHandMace::1:0:", -- The Shoveler
	[9392]="0:2:3:1:OneHandSword::1:0:", -- Annealed Blade
	[9393]="0:4:3:1:OffHandFrill::1:0:", -- Beacon of Hope
	[9394]="0:4:3:1:Plate::1:0:", -- Horned Viking Helmet
	[9395]="0:4:3:1:Cloth::1:0:", -- Gloves of Old
	[9396]="0:4:3:1:Mail::1:0:", -- Legguards of the Vault
	[9397]="0:4:3:1:Cloak::1:0:", -- Energy Cloak
	[9398]="0:4:3:1:Leather::1:0:", -- Worn Running Boots
	[9399]="0:6:2:1000:Arrow::1:0:", -- Precision Arrow
	[9400]="0:2:3:1:Bow::1:0:", -- Baelog's Shortbow
	[9401]="0:2:3:1:OneHandSword::1:0:", -- Nordic Longshank
	[9402]="0:4:3:1:Leather::1:0:", -- Earthborn Kilt
	[9403]="0:4:3:1:Shield::1:0:", -- Battered Viking Shield
	[9404]="0:4:3:1:Shield::1:0:", -- Olaf's All Purpose Shield
	[9405]="0:4:3:1:Mail::1:0:", -- Girdle of Golem Strength
	[9406]="0:4:3:1:Leather::1:0:", -- Spirewind Fetter
	[9407]="0:4:3:1:Cloth::1:0:", -- Stoneweaver Leggings
	[9408]="0:2:3:1:Stave::1:0:", -- Ironshod Bludgeon
	[9409]="0:4:3:1:Mail::1:0:", -- Ironaya's Bracers
	[9410]="0:4:3:1:Plate::1:0:", -- Cragfists
	[9411]="0:4:3:1:Mail::1:0:", -- Rockshard Pauldrons
	[9412]="0:2:3:1:Gun::1:0:", -- Galgann's Fireblaster
	[9413]="0:2:3:1:TwoHandMace::1:0:", -- The Rockpounder
	[9414]="0:4:3:1:Leather::1:0:", -- Oilskin Leggings
	[9415]="0:4:3:1:Cloth::1:0:", -- Grimlok's Tribal Vestments
	[9416]="0:2:3:1:Polearm::1:0:", -- Grimlok's Charge
	[9418]="0:2:3:1:TwoHandSword::1:0:", -- Stoneslayer
	[9419]="0:2:3:1:OneHandMace::1:0:", -- Galgann's Firehammer
	[9420]="0:4:3:1:Leather::1:0:", -- Adventurer's Pith Helmet
	[9421]="0:0:1:1:Other::1:0:", -- Major Healthstone
	[9422]="0:2:3:1:Gun::1:0:", -- Shadowforge Bushmaster
	[9423]="0:2:3:1:TwoHandMace::1:0:", -- The Jackhammer
	[9424]="0:2:3:1:OneHandSword::1:0:", -- Ginn-su Sword
	[9425]="0:2:3:1:TwoHandAxe::1:0:", -- Pendulum of Doom
	[9426]="0:2:3:1:Bow::1:0:", -- Monolithic Bow
	[9427]="0:2:3:1:OneHandMace::1:0:", -- Stonevault Bonebreaker
	[9428]="0:4:3:1:Leather::1:0:", -- Unearthed Bands
	[9429]="0:4:3:1:Cloth::1:0:", -- Miner's Hat of the Deep
	[9430]="0:4:3:1:Mail::1:0:", -- Spaulders of a Lost Age
	[9431]="0:4:3:1:Cloth::1:0:", -- Papal Fez
	[9432]="0:4:3:1:Plate::1:0:", -- Skullplate Bracers
	[9433]="0:4:3:1:Cloth::1:0:", -- Forgotten Wraps
	[9434]="0:4:3:1:Cloth::1:0:", -- Elemental Raiment
	[9435]="0:4:3:1:Mail::1:0:", -- Reticulated Bone Gauntlets
	[9436]="0:12:1:1:::1:0:", -- Faranell's Parcel
	[9437]="0:12:1:20:::1:0:", -- Untested Basilisk Sample
	[9438]="0:12:1:20:::1:0:", -- Acceptable Scorpid Sample
	[9439]="0:12:1:20:::1:0:", -- Untested Hyena Sample
	[9440]="0:12:1:20:::1:0:", -- Acceptable Basilisk Sample
	[9441]="0:12:1:20:::1:0:", -- Acceptable Hyena Sample
	[9442]="0:12:1:20:::1:0:", -- Untested Scorpid Sample
	[9444]="0:4:1:1:Shield::1:0:", -- Techbot CPU Shell
	[9445]="0:4:3:1:Mail::1:0:", -- Grubbis Paws
	[9446]="0:2:3:1:OneHandSword::1:0:", -- Electrocutioner Leg
	[9447]="0:4:3:1:Ring::1:0:", -- Electrocutioner Lagnut
	[9448]="0:4:3:1:Cloth::1:0:", -- Spidertank Oilrag
	[9449]="0:2:3:1:TwoHandMace::1:0:", -- Manual Crowd Pummeler
	[9450]="0:4:3:1:Leather::1:0:", -- Gnomebot Operating Boots
	[9451]="0:0:1:20:FoodDrink::1:0:", -- Bubbling Water
	[9452]="0:2:3:1:Stave::1:0:", -- Hydrocane
	[9453]="0:2:3:1:Dagger::1:0:", -- Toxic Revenger
	[9454]="0:4:3:1:Cloth::1:0:", -- Acidic Walkers
	[9455]="0:4:3:1:Leather::1:0:", -- Emissary Cuffs
	[9456]="0:2:3:1:Gun::1:0:", -- Glass Shooter
	[9457]="0:2:3:1:OneHandMace::1:0:", -- Royal Diplomatic Scepter
	[9458]="0:4:3:1:Shield::1:0:", -- Thermaplugg's Central Core
	[9459]="0:2:3:1:TwoHandAxe::1:0:", -- Thermaplugg's Left Arm
	[9460]="0:12:1:20:::1:0:", -- Grimtotem Horn
	[9461]="0:4:3:1:Ring::1:0:", -- Charged Gear
	[9462]="0:12:1:1:::1:0:", -- Crate of Grimtotem Horns
	[9463]="0:12:1:20:::1:0:", -- Gordunni Cobalt
	[9465]="0:2:3:1:OneHandAxe::1:0:", -- Digmaster 5000
	[9466]="0:12:1:1:::1:0:", -- Orwin's Shovel
	[9467]="0:2:3:1:Dagger::1:0:", -- Gahz'rilla Fang
	[9468]="0:12:1:1:::1:0:", -- Sharpbeak's Feather
	[9469]="0:4:3:1:Mail::1:0:", -- Gahz'rilla Scale Armor
	[9470]="0:4:3:1:Cloth::1:0:", -- Bad Mojo Mask
	[9471]="0:12:1:1:::1:0:", -- Nekrum's Medallion
	[9472]="0:13:1:1:::1:0:", -- Hexx's Key
	[9473]="0:4:3:1:Leather::1:0:", -- Jinxed Hoodoo Skin
	[9474]="0:4:3:1:Leather::1:0:", -- Jinxed Hoodoo Kilt
	[9475]="0:2:3:1:Polearm::1:0:", -- Diabolic Skiver
	[9476]="0:4:3:1:Plate::1:0:", -- Big Bad Pauldrons
	[9477]="0:2:3:1:Stave::1:0:", -- The Chief's Enforcer
	[9478]="0:2:3:1:OneHandAxe::1:0:", -- Ripsaw
	[9479]="0:4:3:1:Leather::1:0:", -- Embrace of the Lycan
	[9480]="0:2:3:1:Polearm::1:0:", -- Eyegouger
	[9481]="0:2:3:1:TwoHandAxe::1:0:", -- The Minotaur
	[9482]="0:2:3:1:Stave::1:0:", -- Witch Doctor's Cane
	[9483]="0:2:3:1:Wand::1:0:", -- Flaming Incinerator
	[9484]="0:4:3:1:Cloth::1:0:", -- Spellshock Leggings
	[9485]="0:2:3:1:OneHandAxe::1:0:", -- Vibroblade
	[9486]="0:2:3:1:TwoHandAxe::1:0:", -- Supercharger Battle Axe
	[9487]="0:2:3:1:Gun::1:0:", -- Hi-tech Supergun
	[9488]="0:2:3:1:OneHandMace::1:0:", -- Oscillating Power Hammer
	[9489]="0:2:2:1:Wand::1:0:", -- Gyromatic Icemaker
	[9490]="0:2:3:1:TwoHandSword::1:0:", -- Gizmotron Megachopper
	[9491]="0:4:3:1:Cloth::1:0:", -- Hotshot Pilot's Gloves
	[9492]="0:4:3:1:Cloth::1:0:", -- Electromagnetic Gigaflux Reactivator
	[9507]="0:12:1:1:::1:0:", -- A Carefully-packed Crate
	[9508]="0:4:3:1:Cloth::1:0:", -- Mechbuilder's Overalls
	[9509]="0:4:3:1:Leather::1:0:", -- Petrolspill Leggings
	[9510]="0:4:3:1:Mail::1:0:", -- Caverndeep Trudgers
	[9511]="0:2:3:1:OneHandSword::1:0:", -- Bloodletter Scalpel
	[9512]="0:4:3:1:Cloak::1:0:", -- Blackmetal Cape
	[9513]="0:2:2:1:Stave::1:0:", -- Ley Staff
	[9514]="0:2:2:1:Stave::1:0:", -- Arcane Staff
	[9515]="0:4:2:1:Cloth::1:0:", -- Nether-lace Tunic
	[9516]="0:4:2:1:Cloth::1:0:", -- Astral Knot Blouse
	[9517]="0:2:3:1:Stave::1:0:", -- Celestial Stave
	[9518]="0:4:2:1:Leather::1:0:", -- Mud's Crushers
	[9519]="0:4:2:1:Cloth::1:0:", -- Durtfeet Stompers
	[9520]="0:2:2:1:Dagger::1:0:", -- Silent Hunter
	[9521]="0:2:2:1:TwoHandAxe::1:0:", -- Skullsplitter
	[9522]="0:4:2:1:Shield::1:0:", -- Energized Stone Circle
	[9523]="0:12:1:20:::1:0:", -- Troll Temper
	[9527]="0:2:2:1:Stave::1:0:", -- Spellshifter Rod
	[9528]="0:12:1:1:::1:0:", -- Edana's Dark Heart
	[9530]="0:12:1:1:::1:0:", -- Horn of Hatetalon
	[9531]="0:4:2:1:Plate::1:0:", -- Gemshale Pauldrons
	[9533]="0:4:3:1:Ring::1:0:", -- Masons Fraternity Ring
	[9534]="0:4:3:1:Leather::1:0:", -- Engineer's Guild Headpiece
	[9535]="0:4:2:1:Mail::1:0:", -- Fire-welded Bracers
	[9536]="0:4:2:1:Cloth::1:0:", -- Fairywing Mantle
	[9538]="0:4:3:1:Ring::1:0:", -- Talvash's Gold Ring
	[9539]="0:15:1:1:Junk::1:0:", -- Box of Rations
	[9540]="0:15:1:1:Junk::1:0:", -- Box of Spells
	[9541]="0:15:1:1:Junk::1:0:", -- Box of Goodies
	[9542]="0:12:1:1:::1:0:", -- Simple Letter
	[9543]="0:12:1:1:::1:0:", -- Simple Rune
	[9544]="0:12:1:1:::1:0:", -- Simple Memorandum
	[9545]="0:12:1:1:::1:0:", -- Simple Sigil
	[9546]="0:0:1:1:Consumable::1:0:", -- Simple Scroll
	[9547]="0:12:1:1:::1:0:", -- Simple Note
	[9548]="0:12:1:1:::1:0:", -- Hallowed Letter
	[9550]="0:12:1:1:::1:0:", -- Encrypted Rune
	[9551]="0:12:1:1:::1:0:", -- Encrypted Sigil
	[9552]="0:12:1:1:::1:0:", -- Rune-Inscribed Note
	[9553]="0:12:1:1:::1:0:", -- Etched Parchment
	[9554]="0:12:1:1:::1:0:", -- Encrypted Tablet
	[9555]="0:12:1:1:::1:0:", -- Encrypted Letter
	[9556]="0:12:1:1:::1:0:", -- Hallowed Rune
	[9557]="0:12:1:1:::1:0:", -- Hallowed Sigil
	[9558]="0:12:1:1:::1:0:", -- Encrypted Memorandum
	[9559]="0:12:1:1:::1:0:", -- Encrypted Scroll
	[9560]="0:12:1:1:::1:0:", -- Encrypted Parchment
	[9561]="0:12:1:1:::1:0:", -- Hallowed Tablet
	[9562]="0:12:1:1:::1:0:", -- Rune-Inscribed Tablet
	[9563]="0:12:1:1:::1:0:", -- Consecrated Rune
	[9564]="0:12:1:1:::1:0:", -- Etched Tablet
	[9565]="0:12:1:1:::1:0:", -- Etched Note
	[9566]="0:12:1:1:::1:0:", -- Etched Rune
	[9567]="0:12:1:1:::1:0:", -- Etched Sigil
	[9568]="0:12:1:1:::1:0:", -- Rune-Inscribed Parchment
	[9569]="0:0:1:1:Consumable::1:0:", -- Hallowed Scroll
	[9570]="0:12:1:1:::1:0:", -- Consecrated Letter
	[9571]="0:12:1:1:::1:0:", -- Glyphic Letter
	[9573]="0:12:1:1:::1:0:", -- Glyphic Memorandum
	[9574]="0:12:1:1:::1:0:", -- Glyphic Scroll
	[9575]="0:12:1:1:::1:0:", -- Glyphic Tablet
	[9576]="0:12:1:1:::1:0:", -- Tainted Letter
	[9577]="0:12:1:1:::1:0:", -- Tainted Memorandum
	[9578]="0:12:1:1:::1:0:", -- Tainted Scroll
	[9579]="0:12:1:1:::1:0:", -- Tainted Parchment
	[9580]="0:12:1:1:::1:0:", -- Verdant Sigil
	[9581]="0:12:1:1:::1:0:", -- Verdant Note
	[9587]="0:1:1:1:Bag::1:0:", -- Thawpelt Sack
	[9588]="0:4:3:1:Ring::1:0:", -- Nogg's Gold Ring
	[9589]="0:12:1:20:::1:0:", -- Encrusted Minerals
	[9590]="0:12:1:2:::1:0:", -- Splintered Log
	[9591]="0:12:1:20:::1:0:", -- Resilient Sinew
	[9592]="0:12:1:40:::1:0:", -- Metallic Fragments
	[9593]="0:12:1:20:::1:0:", -- Treant Muisek
	[9594]="0:12:1:20:::1:0:", -- Beast Muisek
	[9595]="0:12:1:20:::1:0:", -- Hippogryph Muisek
	[9596]="0:12:1:20:::1:0:", -- Faerie Dragon Muisek
	[9597]="0:12:1:20:::1:0:", -- Mountain Giant Muisek
	[9598]="0:4:2:1:Cloth::1:0:", -- Sleeping Robes
	[9599]="0:4:2:1:Mail::1:0:", -- Barkmail Leggings
	[9600]="0:4:1:1:Cloth::1:0:", -- Lace Pants
	[9601]="0:4:1:1:Leather::1:0:", -- Cushioned Boots
	[9602]="0:2:2:1:TwoHandSword::1:0:", -- Brushwood Blade
	[9603]="0:2:2:1:Stave::1:0:", -- Gritroot Staff
	[9604]="0:2:2:1:TwoHandMace::1:0:", -- Mechanic's Pipehammer
	[9605]="0:4:2:1:Cloak::1:0:", -- Repairman's Cape
	[9606]="0:12:1:1:::1:0:", -- Treant Muisek Vessel
	[9607]="0:4:2:1:Shield::1:0:", -- Bastion of Stormwind
	[9608]="0:2:2:1:OneHandAxe::1:0:", -- Shoni's Disarming Tool
	[9609]="0:4:2:1:Cloth::1:0:", -- Shilly Mitts
	[9618]="0:12:1:1:::1:0:", -- Beast Muisek Vessel
	[9619]="0:12:1:1:::1:0:", -- Hippogryph Muisek Vessel
	[9620]="0:12:1:1:::1:0:", -- Faerie Dragon Muisek Vessel
	[9621]="0:12:1:1:::1:0:", -- Mountain Giant Muisek Vessel
	[9622]="0:4:2:1:Ring::1:0:", -- Reedknot Ring
	[9623]="0:4:3:1:Cloth::1:0:", -- Civinad Robes
	[9624]="0:4:3:1:Leather::1:0:", -- Triprunner Dungarees
	[9625]="0:4:3:1:Mail::1:0:", -- Dual Reinforced Leggings
	[9626]="0:2:2:1:TwoHandAxe::1:0:", -- Dwarven Charge
	[9627]="0:4:2:1:OffHandFrill::1:0:", -- Explorers' League Lodestar
	[9628]="0:12:1:1:::1:0:", -- Xerash's Herb Pouch
	[9629]="0:12:1:1:::1:0:", -- A Shrunken Head
	[9630]="0:4:2:1:Leather::1:0:", -- Pratt's Handcrafted Boots
	[9631]="0:4:2:1:Leather::1:0:", -- Pratt's Handcrafted Gloves
	[9632]="0:4:2:1:Leather::1:0:", -- Jangdor's Handcrafted Gloves
	[9633]="0:4:2:1:Leather::1:0:", -- Jangdor's Handcrafted Boots
	[9634]="0:4:2:1:Cloth::1:0:", -- Skilled Handling Gloves
	[9635]="0:4:2:1:Cloak::1:0:", -- Master Apothecary Cape
	[9636]="0:4:2:1:Cloth::1:0:", -- Swashbuckler Sash
	[9637]="0:4:2:1:Plate::1:0:", -- Shinkicker Boots
	[9638]="0:4:2:1:Mail::1:0:", -- Chelonian Cuffs
	[9639]="0:2:3:1:OneHandMace::1:0:", -- The Hand of Antu'sul
	[9640]="0:4:3:1:Plate::1:0:", -- Vice Grips
	[9641]="0:4:3:1:Amulet::1:0:", -- Lifeblood Amulet
	[9642]="0:4:2:1:Ring::1:0:", -- Band of the Great Tortoise
	[9643]="0:4:2:1:Shield::1:0:", -- Optomatic Deflector
	[9644]="0:4:2:1:OffHandFrill::1:0:", -- Thermotastic Egg Timer
	[9645]="0:4:2:1:Cloth::1:0:", -- Gnomish Inventor Boots
	[9646]="0:4:2:1:Plate::1:0:", -- Gnomish Water Sinking Device
	[9647]="0:4:2:1:Leather::1:0:", -- Failed Flying Experiment
	[9648]="0:4:2:1:Cloak::1:0:", -- Chainlink Towel
	[9649]="0:4:3:1:Cloth::1:0:", -- Royal Highmark Vestments
	[9650]="0:4:3:1:Mail::1:0:", -- Honorguard Chestpiece
	[9651]="0:2:3:1:OneHandMace::1:0:", -- Gryphon Rider's Stormhammer
	[9652]="0:4:3:1:Leather::1:0:", -- Gryphon Rider's Leggings
	[9653]="0:4:2:1:Cloth::1:0:", -- Speedy Racer Goggles
	[9654]="0:2:2:1:Wand::1:0:", -- Cairnstone Sliver
	[9655]="0:4:2:1:Ring::1:0:", -- Seedtime Hoop
	[9656]="0:4:2:1:Plate::1:0:", -- Granite Grips
	[9657]="0:4:2:1:Leather::1:0:", -- Vinehedge Cinch
	[9658]="0:4:2:1:Cloth::1:0:", -- Boots of the Maharishi
	[9660]="0:4:2:1:Cloak::1:0:", -- Stargazer Cloak
	[9661]="0:4:2:1:Shield::1:0:", -- Earthclasp Barrier
	[9662]="0:4:2:1:Plate::1:0:", -- Rushridge Boots
	[9663]="0:4:2:1:Mail::1:0:", -- Dawnrider's Chestpiece
	[9664]="0:4:2:1:Plate::1:0:", -- Sentinel's Guard
	[9665]="0:4:2:1:Cloth::1:0:", -- Wingcrest Gloves
	[9666]="0:4:2:1:Mail::1:0:", -- Stronghorn Girdle
	[9678]="0:2:2:1:TwoHandMace::1:0:", -- Tok'kar's Murloc Basher
	[9679]="0:2:2:1:TwoHandAxe::1:0:", -- Tok'kar's Murloc Chopper
	[9680]="0:2:2:1:Dagger::1:0:", -- Tok'kar's Murloc Shanker
	[9681]="0:0:1:20:FoodDrink::1:0:", -- Grilled King Crawler Legs
	[9682]="0:4:2:1:Leather::1:0:", -- Leather Chef's Belt
	[9683]="0:2:3:1:Stave::1:0:", -- Strength of the Treant
	[9684]="0:2:3:1:OneHandAxe::1:0:", -- Force of the Hippogryph
	[9686]="0:2:3:1:OneHandMace::1:0:", -- Spirit of the Faerie Dragon
	[9687]="0:4:2:1:Leather::1:0:", -- Grappler's Belt
	[9698]="0:4:2:1:Leather::1:0:", -- Gloves of Insight
	[9699]="0:4:2:1:Cloak::1:0:", -- Garrison Cloak
	[9703]="0:4:2:1:Cloak::1:0:", -- Scorched Cape
	[9704]="0:4:2:1:Leather::1:0:", -- Rustler Gloves
	[9705]="0:4:2:1:Leather::1:0:", -- Tharg's Shoelace
	[9706]="0:4:2:1:Shield::1:0:", -- Tharg's Disk
	[9718]="0:2:3:1:OneHandSword::1:0:", -- Reforged Blade of Heroes
	[9719]="0:7:3:1:Other::1:0:", -- Broken Blade of Heroes
	[9738]="0:12:1:20:::1:0:", -- Gem of Cobrahn
	[9739]="0:12:1:20:::1:0:", -- Gem of Anacondra
	[9740]="0:12:1:20:::1:0:", -- Gem of Pythas
	[9741]="0:12:1:20:::1:0:", -- Gem of Serpentis
	[9742]="0:4:1:1:Cloth::1:0:", -- Simple Cord
	[9743]="0:4:1:1:Cloth::1:0:", -- Simple Shoes
	[9744]="0:4:1:1:Cloth::1:0:", -- Simple Bands
	[9745]="0:4:1:1:Cloak::1:0:", -- Simple Cape
	[9746]="0:4:1:1:Cloth::1:0:", -- Simple Gloves
	[9747]="0:4:2:1:Cloth::1:0:", -- Simple Britches
	[9748]="0:4:2:1:Cloth::1:0:", -- Simple Robe
	[9749]="0:4:2:1:Cloth::1:0:", -- Simple Blouse
	[9750]="0:4:1:1:Leather::1:0:", -- Gypsy Sash
	[9751]="0:4:1:1:Leather::1:0:", -- Gypsy Sandals
	[9752]="0:4:1:1:Leather::1:0:", -- Gypsy Bands
	[9753]="0:4:2:1:Shield::1:0:", -- Gypsy Buckler
	[9754]="0:4:1:1:Cloak::1:0:", -- Gypsy Cloak
	[9755]="0:4:1:1:Leather::1:0:", -- Gypsy Gloves
	[9756]="0:4:2:1:Leather::1:0:", -- Gypsy Trousers
	[9757]="0:4:2:1:Leather::1:0:", -- Gypsy Tunic
	[9758]="0:4:1:1:Mail::1:0:", -- Cadet Belt
	[9759]="0:4:1:1:Mail::1:0:", -- Cadet Boots
	[9760]="0:4:1:1:Mail::1:0:", -- Cadet Bracers
	[9761]="0:4:1:1:Cloak::1:0:", -- Cadet Cloak
	[9762]="0:4:1:1:Mail::1:0:", -- Cadet Gauntlets
	[9763]="0:4:2:1:Mail::1:0:", -- Cadet Leggings
	[9764]="0:4:2:1:Shield::1:0:", -- Cadet Shield
	[9765]="0:4:2:1:Mail::1:0:", -- Cadet Vest
	[9766]="0:4:2:1:Cloth::1:0:", -- Greenweave Sash
	[9767]="0:4:2:1:Cloth::1:0:", -- Greenweave Sandals
	[9768]="0:4:2:1:Cloth::1:0:", -- Greenweave Bracers
	[9769]="0:4:2:1:OffHandFrill::1:0:", -- Greenweave Branch
	[9770]="0:4:2:1:Cloak::1:0:", -- Greenweave Cloak
	[9771]="0:4:2:1:Cloth::1:0:", -- Greenweave Gloves
	[9772]="0:4:2:1:Cloth::1:0:", -- Greenweave Leggings
	[9773]="0:4:2:1:Cloth::1:0:", -- Greenweave Robe
	[9774]="0:4:2:1:Cloth::1:0:", -- Greenweave Vest
	[9775]="0:4:2:1:Leather::1:0:", -- Bandit Cinch
	[9776]="0:4:2:1:Leather::1:0:", -- Bandit Boots
	[9777]="0:4:2:1:Leather::1:0:", -- Bandit Bracers
	[9778]="0:4:2:1:Shield::1:0:", -- Bandit Buckler
	[9779]="0:4:2:1:Cloak::1:0:", -- Bandit Cloak
	[9780]="0:4:2:1:Leather::1:0:", -- Bandit Gloves
	[9781]="0:4:2:1:Leather::1:0:", -- Bandit Pants
	[9782]="0:4:2:1:Leather::1:0:", -- Bandit Jerkin
	[9783]="0:4:2:1:Mail::1:0:", -- Raider's Chestpiece
	[9784]="0:4:2:1:Mail::1:0:", -- Raider's Boots
	[9785]="0:4:2:1:Mail::1:0:", -- Raider's Bracers
	[9786]="0:4:2:1:Cloak::1:0:", -- Raider's Cloak
	[9787]="0:4:2:1:Mail::1:0:", -- Raider's Gauntlets
	[9788]="0:4:2:1:Mail::1:0:", -- Raider's Belt
	[9789]="0:4:2:1:Mail::1:0:", -- Raider's Legguards
	[9790]="0:4:2:1:Shield::1:0:", -- Raider's Shield
	[9791]="0:4:2:1:Cloth::1:0:", -- Ivycloth Tunic
	[9792]="0:4:2:1:Cloth::1:0:", -- Ivycloth Boots
	[9793]="0:4:2:1:Cloth::1:0:", -- Ivycloth Bracelets
	[9794]="0:4:2:1:Cloak::1:0:", -- Ivycloth Cloak
	[9795]="0:4:2:1:Cloth::1:0:", -- Ivycloth Gloves
	[9796]="0:4:2:1:Cloth::1:0:", -- Ivycloth Mantle
	[9797]="0:4:2:1:Cloth::1:0:", -- Ivycloth Pants
	[9798]="0:4:2:1:Cloth::1:0:", -- Ivycloth Robe
	[9799]="0:4:2:1:Cloth::1:0:", -- Ivycloth Sash
	[9800]="0:4:2:1:OffHandFrill::1:0:", -- Ivy Orb
	[9801]="0:4:2:1:Leather::1:0:", -- Superior Belt
	[9802]="0:4:2:1:Leather::1:0:", -- Superior Boots
	[9803]="0:4:2:1:Leather::1:0:", -- Superior Bracers
	[9804]="0:4:2:1:Shield::1:0:", -- Superior Buckler
	[9805]="0:4:2:1:Cloak::1:0:", -- Superior Cloak
	[9806]="0:4:2:1:Leather::1:0:", -- Superior Gloves
	[9807]="0:4:2:1:Leather::1:0:", -- Superior Shoulders
	[9808]="0:4:2:1:Leather::1:0:", -- Superior Leggings
	[9809]="0:4:2:1:Leather::1:0:", -- Superior Tunic
	[9810]="0:4:2:1:Mail::1:0:", -- Fortified Boots
	[9811]="0:4:2:1:Mail::1:0:", -- Fortified Bracers
	[9812]="0:4:2:1:Cloak::1:0:", -- Fortified Cloak
	[9813]="0:4:2:1:Mail::1:0:", -- Fortified Gauntlets
	[9814]="0:4:2:1:Mail::1:0:", -- Fortified Belt
	[9815]="0:4:2:1:Mail::1:0:", -- Fortified Leggings
	[9816]="0:4:2:1:Shield::1:0:", -- Fortified Shield
	[9817]="0:4:2:1:Mail::1:0:", -- Fortified Spaulders
	[9818]="0:4:2:1:Mail::1:0:", -- Fortified Chain
	[9819]="0:4:2:1:Cloth::1:0:", -- Durable Tunic
	[9820]="0:4:2:1:Cloth::1:0:", -- Durable Boots
	[9821]="0:4:2:1:Cloth::1:0:", -- Durable Bracers
	[9822]="0:4:2:1:Cloak::1:0:", -- Durable Cape
	[9823]="0:4:2:1:Cloth::1:0:", -- Durable Gloves
	[9824]="0:4:2:1:Cloth::1:0:", -- Durable Shoulders
	[9825]="0:4:2:1:Cloth::1:0:", -- Durable Pants
	[9826]="0:4:2:1:Cloth::1:0:", -- Durable Robe
	[9827]="0:4:2:1:Leather::1:0:", -- Scaled Leather Belt
	[9828]="0:4:2:1:Leather::1:0:", -- Scaled Leather Boots
	[9829]="0:4:2:1:Leather::1:0:", -- Scaled Leather Bracers
	[9830]="0:4:2:1:Shield::1:0:", -- Scaled Shield
	[9831]="0:4:2:1:Cloak::1:0:", -- Scaled Cloak
	[9832]="0:4:2:1:Leather::1:0:", -- Scaled Leather Gloves
	[9833]="0:4:2:1:Leather::1:0:", -- Scaled Leather Leggings
	[9834]="0:4:2:1:Leather::1:0:", -- Scaled Leather Shoulders
	[9835]="0:4:2:1:Leather::1:0:", -- Scaled Leather Tunic
	[9836]="0:4:2:1:Mail::1:0:", -- Banded Armor
	[9837]="0:4:2:1:Mail::1:0:", -- Banded Bracers
	[9838]="0:4:2:1:Cloak::1:0:", -- Banded Cloak
	[9839]="0:4:2:1:Mail::1:0:", -- Banded Gauntlets
	[9840]="0:4:2:1:Mail::1:0:", -- Banded Girdle
	[9841]="0:4:2:1:Mail::1:0:", -- Banded Leggings
	[9842]="0:4:2:1:Mail::1:0:", -- Banded Pauldrons
	[9843]="0:4:2:1:Shield::1:0:", -- Banded Shield
	[9844]="0:4:2:1:Cloth::1:0:", -- Conjurer's Vest
	[9845]="0:4:2:1:Cloth::1:0:", -- Conjurer's Shoes
	[9846]="0:4:2:1:Cloth::1:0:", -- Conjurer's Bracers
	[9847]="0:4:2:1:Cloak::1:0:", -- Conjurer's Cloak
	[9848]="0:4:2:1:Cloth::1:0:", -- Conjurer's Gloves
	[9849]="0:4:2:1:Cloth::1:0:", -- Conjurer's Hood
	[9850]="0:4:2:1:Cloth::1:0:", -- Conjurer's Mantle
	[9851]="0:4:2:1:Cloth::1:0:", -- Conjurer's Breeches
	[9852]="0:4:2:1:Cloth::1:0:", -- Conjurer's Robe
	[9853]="0:4:2:1:Cloth::1:0:", -- Conjurer's Cinch
	[9854]="0:4:2:1:Leather::1:0:", -- Archer's Jerkin
	[9855]="0:4:2:1:Leather::1:0:", -- Archer's Belt
	[9856]="0:4:2:1:Leather::1:0:", -- Archer's Boots
	[9857]="0:4:2:1:Leather::1:0:", -- Archer's Bracers
	[9858]="0:4:2:1:Shield::1:0:", -- Archer's Buckler
	[9859]="0:4:2:1:Leather::1:0:", -- Archer's Cap
	[9860]="0:4:2:1:Cloak::1:0:", -- Archer's Cloak
	[9861]="0:4:2:1:Leather::1:0:", -- Archer's Gloves
	[9862]="0:4:2:1:Leather::1:0:", -- Archer's Trousers
	[9863]="0:4:2:1:Leather::1:0:", -- Archer's Shoulderpads
	[9864]="0:4:2:1:Mail::1:0:", -- Renegade Boots
	[9865]="0:4:2:1:Mail::1:0:", -- Renegade Bracers
	[9866]="0:4:2:1:Mail::1:0:", -- Renegade Chestguard
	[9867]="0:4:2:1:Cloak::1:0:", -- Renegade Cloak
	[9868]="0:4:2:1:Mail::1:0:", -- Renegade Gauntlets
	[9869]="0:4:2:1:Mail::1:0:", -- Renegade Belt
	[9870]="0:4:2:1:Mail::1:0:", -- Renegade Circlet
	[9871]="0:4:2:1:Mail::1:0:", -- Renegade Leggings
	[9872]="0:4:2:1:Mail::1:0:", -- Renegade Pauldrons
	[9873]="0:4:2:1:Shield::1:0:", -- Renegade Shield
	[9874]="0:4:2:1:Cloth::1:0:", -- Sorcerer Drape
	[9875]="0:4:2:1:Cloth::1:0:", -- Sorcerer Sash
	[9876]="0:4:2:1:Cloth::1:0:", -- Sorcerer Slippers
	[9877]="0:4:2:1:Cloak::1:0:", -- Sorcerer Cloak
	[9878]="0:4:2:1:Cloth::1:0:", -- Sorcerer Hat
	[9879]="0:4:2:1:Cloth::1:0:", -- Sorcerer Bracelets
	[9880]="0:4:2:1:Cloth::1:0:", -- Sorcerer Gloves
	[9881]="0:4:2:1:Cloth::1:0:", -- Sorcerer Mantle
	[9882]="0:4:2:1:OffHandFrill::1:0:", -- Sorcerer Sphere
	[9883]="0:4:2:1:Cloth::1:0:", -- Sorcerer Pants
	[9884]="0:4:2:1:Cloth::1:0:", -- Sorcerer Robe
	[9885]="0:4:2:1:Leather::1:0:", -- Huntsman's Boots
	[9886]="0:4:2:1:Leather::1:0:", -- Huntsman's Bands
	[9887]="0:4:2:1:Leather::1:0:", -- Huntsman's Armor
	[9889]="0:4:2:1:Leather::1:0:", -- Huntsman's Cap
	[9890]="0:4:2:1:Cloak::1:0:", -- Huntsman's Cape
	[9891]="0:4:2:1:Leather::1:0:", -- Huntsman's Belt
	[9892]="0:4:2:1:Leather::1:0:", -- Huntsman's Gloves
	[9893]="0:4:2:1:Leather::1:0:", -- Huntsman's Leggings
	[9894]="0:4:2:1:Leather::1:0:", -- Huntsman's Shoulders
	[9895]="0:4:2:1:Mail::1:0:", -- Jazeraint Boots
	[9896]="0:4:2:1:Mail::1:0:", -- Jazeraint Bracers
	[9897]="0:4:2:1:Mail::1:0:", -- Jazeraint Chestguard
	[9898]="0:4:2:1:Cloak::1:0:", -- Jazeraint Cloak
	[9899]="0:4:2:1:Shield::1:0:", -- Jazeraint Shield
	[9900]="0:4:2:1:Mail::1:0:", -- Jazeraint Gauntlets
	[9901]="0:4:2:1:Mail::1:0:", -- Jazeraint Belt
	[9902]="0:4:2:1:Mail::1:0:", -- Jazeraint Helm
	[9903]="0:4:2:1:Mail::1:0:", -- Jazeraint Leggings
	[9904]="0:4:2:1:Mail::1:0:", -- Jazeraint Pauldrons
	[9905]="0:4:2:1:Cloth::1:0:", -- Royal Blouse
	[9906]="0:4:2:1:Cloth::1:0:", -- Royal Sash
	[9907]="0:4:2:1:Cloth::1:0:", -- Royal Boots
	[9908]="0:4:2:1:Cloak::1:0:", -- Royal Cape
	[9909]="0:4:2:1:Cloth::1:0:", -- Royal Bands
	[9910]="0:4:2:1:Cloth::1:0:", -- Royal Gloves
	[9911]="0:4:2:1:Cloth::1:0:", -- Royal Trousers
	[9912]="0:4:2:1:Cloth::1:0:", -- Royal Amice
	[9913]="0:4:2:1:Cloth::1:0:", -- Royal Gown
	[9914]="0:4:2:1:OffHandFrill::1:0:", -- Royal Scepter
	[9915]="0:4:2:1:Cloth::1:0:", -- Royal Headband
	[9916]="0:4:2:1:Leather::1:0:", -- Tracker's Belt
	[9917]="0:4:2:1:Leather::1:0:", -- Tracker's Boots
	[9918]="0:4:2:1:Shield::1:0:", -- Brigade Defender
	[9919]="0:4:2:1:Cloak::1:0:", -- Tracker's Cloak
	[9920]="0:4:2:1:Leather::1:0:", -- Tracker's Gloves
	[9921]="0:4:2:1:Leather::1:0:", -- Tracker's Headband
	[9922]="0:4:2:1:Leather::1:0:", -- Tracker's Leggings
	[9923]="0:4:2:1:Leather::1:0:", -- Tracker's Shoulderpads
	[9924]="0:4:2:1:Leather::1:0:", -- Tracker's Tunic
	[9925]="0:4:2:1:Leather::1:0:", -- Tracker's Wristguards
	[9926]="0:4:2:1:Mail::1:0:", -- Brigade Boots
	[9927]="0:4:2:1:Mail::1:0:", -- Brigade Bracers
	[9928]="0:4:2:1:Mail::1:0:", -- Brigade Breastplate
	[9929]="0:4:2:1:Cloak::1:0:", -- Brigade Cloak
	[9930]="0:4:2:1:Mail::1:0:", -- Brigade Gauntlets
	[9931]="0:4:2:1:Mail::1:0:", -- Brigade Girdle
	[9932]="0:4:2:1:Mail::1:0:", -- Brigade Circlet
	[9933]="0:4:2:1:Mail::1:0:", -- Brigade Leggings
	[9934]="0:4:2:1:Mail::1:0:", -- Brigade Pauldrons
	[9935]="0:4:2:1:Shield::1:0:", -- Embossed Plate Shield
	[9936]="0:4:2:1:Cloth::1:0:", -- Abjurer's Boots
	[9937]="0:4:2:1:Cloth::1:0:", -- Abjurer's Bands
	[9938]="0:4:2:1:Cloak::1:0:", -- Abjurer's Cloak
	[9939]="0:4:2:1:Cloth::1:0:", -- Abjurer's Gloves
	[9940]="0:4:2:1:Cloth::1:0:", -- Abjurer's Hood
	[9941]="0:4:2:1:Cloth::1:0:", -- Abjurer's Mantle
	[9942]="0:4:2:1:Cloth::1:0:", -- Abjurer's Pants
	[9943]="0:4:2:1:Cloth::1:0:", -- Abjurer's Robe
	[9944]="0:4:2:1:OffHandFrill::1:0:", -- Abjurer's Crystal
	[9945]="0:4:2:1:Cloth::1:0:", -- Abjurer's Sash
	[9946]="0:4:2:1:Cloth::1:0:", -- Abjurer's Tunic
	[9947]="0:4:2:1:Leather::1:0:", -- Chieftain's Belt
	[9948]="0:4:2:1:Leather::1:0:", -- Chieftain's Boots
	[9949]="0:4:2:1:Leather::1:0:", -- Chieftain's Bracers
	[9950]="0:4:2:1:Leather::1:0:", -- Chieftain's Breastplate
	[9951]="0:4:2:1:Cloak::1:0:", -- Chieftain's Cloak
	[9952]="0:4:2:1:Leather::1:0:", -- Chieftain's Gloves
	[9953]="0:4:2:1:Leather::1:0:", -- Chieftain's Headdress
	[9954]="0:4:2:1:Leather::1:0:", -- Chieftain's Leggings
	[9955]="0:4:2:1:Leather::1:0:", -- Chieftain's Shoulders
	[9956]="0:4:2:1:Mail::1:0:", -- Warmonger's Bracers
	[9957]="0:4:2:1:Mail::1:0:", -- Warmonger's Chestpiece
	[9958]="0:4:2:1:Shield::1:0:", -- Warmonger's Buckler
	[9959]="0:4:2:1:Cloak::1:0:", -- Warmonger's Cloak
	[9960]="0:4:2:1:Mail::1:0:", -- Warmonger's Gauntlets
	[9961]="0:4:2:1:Mail::1:0:", -- Warmonger's Belt
	[9962]="0:4:2:1:Mail::1:0:", -- Warmonger's Greaves
	[9963]="0:4:2:1:Mail::1:0:", -- Warmonger's Circlet
	[9964]="0:4:2:1:Mail::1:0:", -- Warmonger's Leggings
	[9965]="0:4:2:1:Mail::1:0:", -- Warmonger's Pauldrons
	[9966]="0:4:2:1:Plate::1:0:", -- Embossed Plate Armor
	[9967]="0:4:2:1:Plate::1:0:", -- Embossed Plate Gauntlets
	[9968]="0:4:2:1:Plate::1:0:", -- Embossed Plate Girdle
	[9969]="0:4:2:1:Plate::1:0:", -- Embossed Plate Helmet
	[9970]="0:4:2:1:Plate::1:0:", -- Embossed Plate Leggings
	[9971]="0:4:2:1:Plate::1:0:", -- Embossed Plate Pauldrons
	[9972]="0:4:2:1:Plate::1:0:", -- Embossed Plate Bracers
	[9973]="0:4:2:1:Plate::1:0:", -- Embossed Plate Boots
	[9974]="0:4:2:1:Shield::1:0:", -- Overlord's Shield
	[9978]="0:12:1:1:::1:0:", -- Gahz'ridian Detector
	[9998]="0:4:2:1:Cloth::1:0:", -- Black Mageweave Vest
	[9999]="0:4:2:1:Cloth::1:0:", -- Black Mageweave Leggings
	[10000]="0:12:1:1:::1:0:", -- Margol's Horn
	[10001]="0:4:2:1:Cloth::1:0:", -- Black Mageweave Robe
	[10002]="0:4:2:1:Cloth::1:0:", -- Shadoweave Pants
	[10003]="0:4:2:1:Cloth::1:0:", -- Black Mageweave Gloves
	[10004]="0:4:2:1:Cloth::1:0:", -- Shadoweave Robe
	[10005]="0:12:1:1:::1:0:", -- Margol's Gigantic Horn
	[10007]="0:4:2:1:Cloth::1:0:", -- Red Mageweave Vest
	[10008]="0:4:2:1:Cloth::1:0:", -- White Bandit Mask
	[10009]="0:4:2:1:Cloth::1:0:", -- Red Mageweave Pants
	[10010]="0:4:2:1:Cloth::1:0:", -- Stormcloth Pants
	[10011]="0:4:2:1:Cloth::1:0:", -- Stormcloth Gloves
	[10018]="0:4:2:1:Cloth::1:0:", -- Red Mageweave Gloves
	[10019]="0:4:3:1:Cloth::1:0:", -- Dreamweave Gloves
	[10020]="0:4:2:1:Cloth::1:0:", -- Stormcloth Vest
	[10021]="0:4:3:1:Cloth::1:0:", -- Dreamweave Vest
	[10022]="0:12:1:1:::1:0:", -- Proof of Deed
	[10023]="0:4:2:1:Cloth::1:0:", -- Shadoweave Gloves
	[10024]="0:4:2:1:Cloth::1:0:", -- Black Mageweave Headband
	[10025]="0:4:2:1:Cloth::1:0:", -- Shadoweave Mask
	[10026]="0:4:2:1:Cloth:202:1:0:", -- Black Mageweave Boots
	[10027]="0:4:2:1:Cloth::1:0:", -- Black Mageweave Shoulders
	[10028]="0:4:2:1:Cloth::1:0:", -- Shadoweave Shoulders
	[10029]="0:4:2:1:Cloth::1:0:", -- Red Mageweave Shoulders
	[10030]="0:4:2:1:Cloth::1:0:", -- Admiral's Hat
	[10031]="0:4:2:1:Cloth::1:0:", -- Shadoweave Boots
	[10032]="0:4:2:1:Cloth::1:0:", -- Stormcloth Headband
	[10033]="0:4:2:1:Cloth::1:0:", -- Red Mageweave Headband
	[10034]="0:4:1:1:Shirt::1:0:", -- Tuxedo Shirt
	[10035]="0:4:1:1:Cloth::1:0:", -- Tuxedo Pants
	[10036]="0:4:1:1:Cloth::1:0:", -- Tuxedo Jacket
	[10038]="0:4:2:1:Cloth::1:0:", -- Stormcloth Shoulders
	[10039]="0:4:2:1:Cloth::1:0:", -- Stormcloth Boots
	[10040]="0:4:1:1:Cloth::1:0:", -- White Wedding Dress
	[10041]="0:4:3:1:Cloth::1:0:", -- Dreamweave Circlet
	[10042]="0:4:2:1:Cloth::1:0:", -- Cindercloth Robe
	[10043]="0:4:2:1:Cloth::1:0:", -- Pious Legwraps
	[10044]="0:4:2:1:Cloth::1:0:", -- Cindercloth Boots
	[10045]="0:4:1:1:Cloth::1:0:", -- Simple Linen Pants
	[10046]="0:4:1:1:Cloth::1:0:", -- Simple Linen Boots
	[10047]="0:4:2:1:Cloth::1:0:", -- Simple Kilt
	[10048]="0:4:2:1:Cloth::1:0:", -- Colorful Kilt
	[10050]="0:1:1:1:Bag::1:0:", -- Mageweave Bag
	[10051]="0:1:1:1:Bag::1:0:", -- Red Mageweave Bag
	[10052]="0:4:1:1:Shirt::1:0:", -- Orange Martial Shirt
	[10053]="0:4:1:1:Miscellaneous::1:0:", -- Simple Black Dress
	[10054]="0:4:1:1:Shirt::1:0:", -- Lavender Mageweave Shirt
	[10055]="0:4:1:1:Shirt::1:0:", -- Pink Mageweave Shirt
	[10056]="0:4:1:1:Shirt::1:0:", -- Orange Mageweave Shirt
	[10057]="0:4:2:1:Cloth::1:0:", -- Duskwoven Tunic
	[10058]="0:4:2:1:Cloth::1:0:", -- Duskwoven Sandals
	[10059]="0:4:2:1:Cloth::1:0:", -- Duskwoven Bracers
	[10060]="0:4:2:1:Cloak::1:0:", -- Duskwoven Cape
	[10061]="0:4:2:1:Cloth::1:0:", -- Duskwoven Turban
	[10062]="0:4:2:1:Cloth::1:0:", -- Duskwoven Gloves
	[10063]="0:4:2:1:Cloth::1:0:", -- Duskwoven Amice
	[10064]="0:4:2:1:Cloth::1:0:", -- Duskwoven Pants
	[10065]="0:4:2:1:Cloth::1:0:", -- Duskwoven Robe
	[10066]="0:4:2:1:Cloth::1:0:", -- Duskwoven Sash
	[10067]="0:4:2:1:Leather::1:0:", -- Righteous Waistguard
	[10068]="0:4:2:1:Leather::1:0:", -- Righteous Boots
	[10069]="0:4:2:1:Leather::1:0:", -- Righteous Bracers
	[10070]="0:4:2:1:Leather::1:0:", -- Righteous Armor
	[10071]="0:4:2:1:Cloak::1:0:", -- Righteous Cloak
	[10072]="0:4:2:1:Leather::1:0:", -- Righteous Gloves
	[10073]="0:4:2:1:Leather::1:0:", -- Righteous Helmet
	[10074]="0:4:2:1:Leather::1:0:", -- Righteous Leggings
	[10075]="0:4:2:1:Leather::1:0:", -- Righteous Spaulders
	[10076]="0:4:2:1:Mail::1:0:", -- Lord's Armguards
	[10077]="0:4:2:1:Mail::1:0:", -- Lord's Breastplate
	[10078]="0:4:2:1:Shield::1:0:", -- Lord's Crest
	[10079]="0:4:2:1:Cloak::1:0:", -- Lord's Cape
	[10080]="0:4:2:1:Mail::1:0:", -- Lord's Gauntlets
	[10081]="0:4:2:1:Mail::1:0:", -- Lord's Girdle
	[10082]="0:4:2:1:Mail::1:0:", -- Lord's Boots
	[10083]="0:4:2:1:Mail::1:0:", -- Lord's Crown
	[10084]="0:4:2:1:Mail::1:0:", -- Lord's Legguards
	[10085]="0:4:2:1:Mail::1:0:", -- Lord's Pauldrons
	[10086]="0:4:2:1:Plate::1:0:", -- Gothic Plate Armor
	[10087]="0:4:2:1:Plate::1:0:", -- Gothic Plate Gauntlets
	[10088]="0:4:2:1:Plate::1:0:", -- Gothic Plate Girdle
	[10089]="0:4:2:1:Plate::1:0:", -- Gothic Sabatons
	[10090]="0:4:2:1:Plate::1:0:", -- Gothic Plate Helmet
	[10091]="0:4:2:1:Plate::1:0:", -- Gothic Plate Leggings
	[10092]="0:4:2:1:Plate::1:0:", -- Gothic Plate Spaulders
	[10093]="0:4:2:1:Shield::1:0:", -- Revenant Deflector
	[10094]="0:4:2:1:Plate::1:0:", -- Gothic Plate Vambraces
	[10095]="0:4:2:1:Cloth::1:0:", -- Councillor's Boots
	[10096]="0:4:2:1:Cloth::1:0:", -- Councillor's Cuffs
	[10097]="0:4:2:1:Cloth::1:0:", -- Councillor's Circlet
	[10098]="0:4:2:1:Cloak::1:0:", -- Councillor's Cloak
	[10099]="0:4:2:1:Cloth::1:0:", -- Councillor's Gloves
	[10100]="0:4:2:1:Cloth::1:0:", -- Councillor's Shoulders
	[10101]="0:4:2:1:Cloth::1:0:", -- Councillor's Pants
	[10102]="0:4:2:1:Cloth::1:0:", -- Councillor's Robes
	[10103]="0:4:2:1:Cloth::1:0:", -- Councillor's Sash
	[10104]="0:4:2:1:Cloth::1:0:", -- Councillor's Tunic
	[10105]="0:4:2:1:Leather::1:0:", -- Wanderer's Armor
	[10106]="0:4:2:1:Leather::1:0:", -- Wanderer's Boots
	[10107]="0:4:2:1:Leather::1:0:", -- Wanderer's Bracers
	[10108]="0:4:2:1:Cloak::1:0:", -- Wanderer's Cloak
	[10109]="0:4:2:1:Leather::1:0:", -- Wanderer's Belt
	[10110]="0:4:2:1:Leather::1:0:", -- Wanderer's Gloves
	[10111]="0:4:2:1:Leather::1:0:", -- Wanderer's Hat
	[10112]="0:4:2:1:Leather::1:0:", -- Wanderer's Leggings
	[10113]="0:4:2:1:Leather::1:0:", -- Wanderer's Shoulders
	[10118]="0:4:2:1:Mail::1:0:", -- Ornate Breastplate
	[10119]="0:4:2:1:Mail::1:0:", -- Ornate Greaves
	[10120]="0:4:2:1:Cloak::1:0:", -- Ornate Cloak
	[10121]="0:4:2:1:Mail::1:0:", -- Ornate Gauntlets
	[10122]="0:4:2:1:Mail::1:0:", -- Ornate Girdle
	[10123]="0:4:2:1:Mail::1:0:", -- Ornate Circlet
	[10124]="0:4:2:1:Mail::1:0:", -- Ornate Legguards
	[10125]="0:4:2:1:Mail::1:0:", -- Ornate Pauldrons
	[10126]="0:4:2:1:Mail::1:0:", -- Ornate Bracers
	[10127]="0:4:2:1:Plate::1:0:", -- Revenant Bracers
	[10128]="0:4:2:1:Plate::1:0:", -- Revenant Chestplate
	[10129]="0:4:2:1:Plate::1:0:", -- Revenant Gauntlets
	[10130]="0:4:2:1:Plate::1:0:", -- Revenant Girdle
	[10131]="0:4:2:1:Plate::1:0:", -- Revenant Boots
	[10132]="0:4:2:1:Plate::1:0:", -- Revenant Helmet
	[10133]="0:4:2:1:Plate::1:0:", -- Revenant Leggings
	[10134]="0:4:2:1:Plate::1:0:", -- Revenant Shoulders
	[10135]="0:4:2:1:Cloth::1:0:", -- High Councillor's Tunic
	[10136]="0:4:2:1:Cloth::1:0:", -- High Councillor's Bracers
	[10137]="0:4:2:1:Cloth::1:0:", -- High Councillor's Boots
	[10138]="0:4:2:1:Cloak::1:0:", -- High Councillor's Cloak
	[10139]="0:4:2:1:Cloth::1:0:", -- High Councillor's Circlet
	[10140]="0:4:2:1:Cloth::1:0:", -- High Councillor's Gloves
	[10141]="0:4:2:1:Cloth::1:0:", -- High Councillor's Pants
	[10142]="0:4:2:1:Cloth::1:0:", -- High Councillor's Mantle
	[10143]="0:4:2:1:Cloth::1:0:", -- High Councillor's Robe
	[10144]="0:4:2:1:Cloth::1:0:", -- High Councillor's Sash
	[10145]="0:4:2:1:Leather::1:0:", -- Mighty Girdle
	[10146]="0:4:2:1:Leather::1:0:", -- Mighty Boots
	[10147]="0:4:2:1:Leather::1:0:", -- Mighty Armsplints
	[10148]="0:4:2:1:Cloak::1:0:", -- Mighty Cloak
	[10149]="0:4:2:1:Leather::1:0:", -- Mighty Gauntlets
	[10150]="0:4:2:1:Leather::1:0:", -- Mighty Helmet
	[10151]="0:4:2:1:Leather::1:0:", -- Mighty Tunic
	[10152]="0:4:2:1:Leather::1:0:", -- Mighty Leggings
	[10153]="0:4:2:1:Leather::1:0:", -- Mighty Spaulders
	[10154]="0:4:2:1:Mail::1:0:", -- Mercurial Girdle
	[10155]="0:4:2:1:Mail::1:0:", -- Mercurial Greaves
	[10156]="0:4:2:1:Mail::1:0:", -- Mercurial Bracers
	[10157]="0:4:2:1:Mail::1:0:", -- Mercurial Breastplate
	[10158]="0:4:2:1:Shield::1:0:", -- Mercurial Guard
	[10159]="0:4:2:1:Cloak::1:0:", -- Mercurial Cloak
	[10160]="0:4:2:1:Mail::1:0:", -- Mercurial Circlet
	[10161]="0:4:2:1:Mail::1:0:", -- Mercurial Gauntlets
	[10162]="0:4:2:1:Mail::1:0:", -- Mercurial Legguards
	[10163]="0:4:2:1:Mail::1:0:", -- Mercurial Pauldrons
	[10164]="0:4:2:1:Plate::1:0:", -- Templar Chestplate
	[10165]="0:4:2:1:Plate::1:0:", -- Templar Gauntlets
	[10166]="0:4:2:1:Plate::1:0:", -- Templar Girdle
	[10167]="0:4:2:1:Plate::1:0:", -- Templar Boots
	[10168]="0:4:2:1:Plate::1:0:", -- Templar Crown
	[10169]="0:4:2:1:Plate::1:0:", -- Templar Legplates
	[10170]="0:4:2:1:Plate::1:0:", -- Templar Pauldrons
	[10171]="0:4:2:1:Plate::1:0:", -- Templar Bracers
	[10172]="0:4:2:1:Cloth::1:0:", -- Mystical Mantle
	[10173]="0:4:2:1:Cloth::1:0:", -- Mystical Bracers
	[10174]="0:4:2:1:Cloak::1:0:", -- Mystical Cape
	[10175]="0:4:2:1:Cloth::1:0:", -- Mystical Headwrap
	[10176]="0:4:2:1:Cloth::1:0:", -- Mystical Gloves
	[10177]="0:4:2:1:Cloth::1:0:", -- Mystical Leggings
	[10178]="0:4:2:1:Cloth::1:0:", -- Mystical Robe
	[10179]="0:4:2:1:Cloth::1:0:", -- Mystical Boots
	[10180]="0:4:2:1:Cloth::1:0:", -- Mystical Belt
	[10181]="0:4:2:1:Cloth::1:0:", -- Mystical Armor
	[10182]="0:4:2:1:Leather::1:0:", -- Swashbuckler's Breastplate
	[10183]="0:4:2:1:Leather::1:0:", -- Swashbuckler's Boots
	[10184]="0:4:2:1:Leather::1:0:", -- Swashbuckler's Bracers
	[10185]="0:4:2:1:Cloak::1:0:", -- Swashbuckler's Cape
	[10186]="0:4:2:1:Leather::1:0:", -- Swashbuckler's Gloves
	[10187]="0:4:2:1:Leather::1:0:", -- Swashbuckler's Eyepatch
	[10188]="0:4:2:1:Leather::1:0:", -- Swashbuckler's Leggings
	[10189]="0:4:2:1:Leather::1:0:", -- Swashbuckler's Shoulderpads
	[10190]="0:4:2:1:Leather::1:0:", -- Swashbuckler's Belt
	[10191]="0:4:2:1:Mail::1:0:", -- Crusader's Armguards
	[10192]="0:4:2:1:Mail::1:0:", -- Crusader's Boots
	[10193]="0:4:2:1:Mail::1:0:", -- Crusader's Armor
	[10194]="0:4:2:1:Cloak::1:0:", -- Crusader's Cloak
	[10195]="0:4:2:1:Shield::1:0:", -- Crusader's Shield
	[10196]="0:4:2:1:Mail::1:0:", -- Crusader's Gauntlets
	[10197]="0:4:2:1:Mail::1:0:", -- Crusader's Belt
	[10198]="0:4:2:1:Mail::1:0:", -- Crusader's Helm
	[10199]="0:4:2:1:Mail::1:0:", -- Crusader's Leggings
	[10200]="0:4:2:1:Mail::1:0:", -- Crusader's Pauldrons
	[10201]="0:4:2:1:Plate::1:0:", -- Overlord's Greaves
	[10202]="0:4:2:1:Plate::1:0:", -- Overlord's Vambraces
	[10203]="0:4:2:1:Plate::1:0:", -- Overlord's Chestplate
	[10204]="0:4:2:1:Shield::1:0:", -- Heavy Lamellar Shield
	[10205]="0:4:2:1:Plate::1:0:", -- Overlord's Gauntlets
	[10206]="0:4:2:1:Plate::1:0:", -- Overlord's Girdle
	[10207]="0:4:2:1:Plate::1:0:", -- Overlord's Crown
	[10208]="0:4:2:1:Plate::1:0:", -- Overlord's Legplates
	[10209]="0:4:2:1:Plate::1:0:", -- Overlord's Spaulders
	[10210]="0:4:2:1:Cloth::1:0:", -- Elegant Mantle
	[10211]="0:4:2:1:Cloth::1:0:", -- Elegant Boots
	[10212]="0:4:2:1:Cloak::1:0:", -- Elegant Cloak
	[10213]="0:4:2:1:Cloth::1:0:", -- Elegant Bracers
	[10214]="0:4:2:1:Cloth::1:0:", -- Elegant Gloves
	[10215]="0:4:2:1:Cloth::1:0:", -- Elegant Robes
	[10216]="0:4:2:1:Cloth::1:0:", -- Elegant Belt
	[10217]="0:4:2:1:Cloth::1:0:", -- Elegant Leggings
	[10218]="0:4:2:1:Cloth::1:0:", -- Elegant Tunic
	[10219]="0:4:2:1:Cloth::1:0:", -- Elegant Circlet
	[10220]="0:4:2:1:Leather::1:0:", -- Nightshade Tunic
	[10221]="0:4:2:1:Leather::1:0:", -- Nightshade Girdle
	[10222]="0:4:2:1:Leather::1:0:", -- Nightshade Boots
	[10223]="0:4:2:1:Leather::1:0:", -- Nightshade Armguards
	[10224]="0:4:2:1:Cloak::1:0:", -- Nightshade Cloak
	[10225]="0:4:2:1:Leather::1:0:", -- Nightshade Gloves
	[10226]="0:4:2:1:Leather::1:0:", -- Nightshade Helmet
	[10227]="0:4:2:1:Leather::1:0:", -- Nightshade Leggings
	[10228]="0:4:2:1:Leather::1:0:", -- Nightshade Spaulders
	[10229]="0:4:2:1:Mail::1:0:", -- Engraved Bracers
	[10230]="0:4:2:1:Mail::1:0:", -- Engraved Breastplate
	[10231]="0:4:2:1:Cloak::1:0:", -- Engraved Cape
	[10232]="0:4:2:1:Mail::1:0:", -- Engraved Gauntlets
	[10233]="0:4:2:1:Mail::1:0:", -- Engraved Girdle
	[10234]="0:4:2:1:Mail::1:0:", -- Engraved Boots
	[10235]="0:4:2:1:Mail::1:0:", -- Engraved Helm
	[10236]="0:4:2:1:Mail::1:0:", -- Engraved Leggings
	[10237]="0:4:2:1:Mail::1:0:", -- Engraved Pauldrons
	[10238]="0:4:2:1:Plate::1:0:", -- Heavy Lamellar Boots
	[10239]="0:4:2:1:Plate::1:0:", -- Heavy Lamellar Vambraces
	[10240]="0:4:2:1:Plate::1:0:", -- Heavy Lamellar Chestpiece
	[10241]="0:4:2:1:Plate::1:0:", -- Heavy Lamellar Helm
	[10242]="0:4:2:1:Plate::1:0:", -- Heavy Lamellar Gauntlets
	[10243]="0:4:2:1:Plate::1:0:", -- Heavy Lamellar Girdle
	[10244]="0:4:2:1:Plate::1:0:", -- Heavy Lamellar Leggings
	[10245]="0:4:2:1:Plate::1:0:", -- Heavy Lamellar Pauldrons
	[10246]="0:4:2:1:Cloth::1:0:", -- Master's Vest
	[10247]="0:4:2:1:Cloth::1:0:", -- Master's Boots
	[10248]="0:4:2:1:Cloth::1:0:", -- Master's Bracers
	[10249]="0:4:2:1:Cloak::1:0:", -- Master's Cloak
	[10250]="0:4:2:1:Cloth::1:0:", -- Master's Hat
	[10251]="0:4:2:1:Cloth::1:0:", -- Master's Gloves
	[10252]="0:4:2:1:Cloth::1:0:", -- Master's Leggings
	[10253]="0:4:2:1:Cloth::1:0:", -- Master's Mantle
	[10254]="0:4:2:1:Cloth::1:0:", -- Master's Robe
	[10255]="0:4:2:1:Cloth::1:0:", -- Master's Belt
	[10256]="0:4:2:1:Leather::1:0:", -- Adventurer's Bracers
	[10257]="0:4:2:1:Leather::1:0:", -- Adventurer's Boots
	[10258]="0:4:2:1:Cloak::1:0:", -- Adventurer's Cape
	[10259]="0:4:2:1:Leather::1:0:", -- Adventurer's Belt
	[10260]="0:4:2:1:Leather::1:0:", -- Adventurer's Gloves
	[10261]="0:4:2:1:Leather::1:0:", -- Adventurer's Bandana
	[10262]="0:4:2:1:Leather::1:0:", -- Adventurer's Legguards
	[10263]="0:4:2:1:Leather::1:0:", -- Adventurer's Shoulders
	[10264]="0:4:2:1:Leather::1:0:", -- Adventurer's Tunic
	[10265]="0:4:2:1:Mail::1:0:", -- Masterwork Bracers
	[10266]="0:4:2:1:Mail::1:0:", -- Masterwork Breastplate
	[10267]="0:4:2:1:Cloak::1:0:", -- Masterwork Cape
	[10268]="0:4:2:1:Mail::1:0:", -- Masterwork Gauntlets
	[10269]="0:4:2:1:Mail::1:0:", -- Masterwork Girdle
	[10270]="0:4:2:1:Mail::1:0:", -- Masterwork Boots
	[10271]="0:4:2:1:Shield::1:0:", -- Masterwork Shield
	[10272]="0:4:2:1:Mail::1:0:", -- Masterwork Circlet
	[10273]="0:4:2:1:Mail::1:0:", -- Masterwork Legplates
	[10274]="0:4:2:1:Mail::1:0:", -- Masterwork Pauldrons
	[10275]="0:4:2:1:Plate::1:0:", -- Emerald Breastplate
	[10276]="0:4:2:1:Plate::1:0:", -- Emerald Sabatons
	[10277]="0:4:2:1:Plate::1:0:", -- Emerald Gauntlets
	[10278]="0:4:2:1:Plate::1:0:", -- Emerald Girdle
	[10279]="0:4:2:1:Plate::1:0:", -- Emerald Helm
	[10280]="0:4:2:1:Plate::1:0:", -- Emerald Legplates
	[10281]="0:4:2:1:Plate::1:0:", -- Emerald Pauldrons
	[10282]="0:4:2:1:Plate::1:0:", -- Emerald Vambraces
	[10283]="0:12:1:1:::1:0:", -- Wolf Heart Samples
	[10285]="0:7:1:10:Cloth:202,165,197:1:0:", -- Shadow Silk
	[10286]="0:7:1:10:Elemental:171,202,755,197:1:0:", -- Heart of the Wild
	[10287]="0:4:2:1:Cloth::1:0:", -- Greenweave Mantle
	[10288]="0:4:2:1:Cloth::1:0:", -- Sage's Circlet
	[10289]="0:4:2:1:Cloth::1:0:", -- Durable Hat
	[10290]="2500:7:1:10:Other:197:1:0:1347,1454,1474,1672,2394,2668,2669,2670,2672,2697,2698,2699,2816,2819,2846,3005,3091,3096,3364,3366,3485,3958,4168,4189,4225,4577,4589,5128,5154,5565,5783,5944,6567,6568,6574,6576,6731,7852,7854,7940,8160,8681,11557,11874,12942,12943,12956,15165,16366,16638,16689,16748,16767,18277,18749,18754,18771,18772,19196,19213,19521,19532,19722,21085,28718,28726,28798,28810,33596,33601,33635,33636,33681,33684", -- Pink Dye
	[10298]="0:4:2:1:Ring::1:0:", -- Gnomeregan Band
	[10299]="0:4:2:1:Amulet::1:0:", -- Gnomeregan Amulet
	[10300]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Mageweave Vest
	[10301]="0:9:2:1:Tailoring::1:0:", -- Pattern: White Bandit Mask
	[10302]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Mageweave Pants
	[10305]="550:0:1:20:Scroll::1:1:14847", -- Scroll of Protection IV
	[10306]="550:0:1:20:Scroll::1:1:14847,20092", -- Scroll of Spirit IV
	[10307]="600:0:1:20:Scroll::1:1:14847,20092", -- Scroll of Stamina IV
	[10308]="600:0:1:20:Scroll::1:1:14847,20092", -- Scroll of Intellect IV
	[10309]="650:0:1:20:Scroll::1:1:14847", -- Scroll of Agility IV
	[10310]="650:0:1:20:Scroll::1:1:14847", -- Scroll of Strength IV
	[10311]="3000:9:1:1:Tailoring::1:1:3005,4168", -- Pattern: Orange Martial Shirt
	[10312]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Mageweave Gloves
	[10314]="4000:9:1:1:Tailoring::1:1:3364,8681", -- Pattern: Lavender Mageweave Shirt
	[10315]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Mageweave Shoulders
	[10316]="0:9:2:1:Tailoring::1:0:", -- Pattern: Colorful Kilt
	[10317]="4000:9:1:1:Tailoring::1:1:3364,8681", -- Pattern: Pink Mageweave Shirt
	[10318]="7000:9:1:1:Tailoring::1:1:2672", -- Pattern: Admiral's Hat
	[10320]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Mageweave Headband
	[10321]="4500:9:1:1:Tailoring::1:1:4577,8681", -- Pattern: Tuxedo Shirt
	[10323]="4500:9:1:1:Tailoring::1:1:4577,8681", -- Pattern: Tuxedo Pants
	[10325]="10000:9:1:1:Tailoring::1:1:1347,3005", -- Pattern: White Wedding Dress
	[10326]="5000:9:1:1:Tailoring::1:1:4577,8681", -- Pattern: Tuxedo Jacket
	[10327]="0:12:1:1:::1:0:", -- Horn of Echeyakee
	[10328]="0:4:3:1:Mail::1:0:", -- Scarlet Chestpiece
	[10329]="0:4:2:1:Mail::1:0:", -- Scarlet Belt
	[10330]="0:4:3:1:Mail::1:0:", -- Scarlet Leggings
	[10331]="0:4:2:1:Mail::1:0:", -- Scarlet Gauntlets
	[10332]="0:4:3:1:Mail::1:0:", -- Scarlet Boots
	[10333]="0:4:2:1:Mail::1:0:", -- Scarlet Wristguards
	[10338]="0:12:1:1:::1:0:", -- Fresh Zhevra Carcass
	[10358]="0:4:2:1:Mail::1:0:", -- Duracin Bracers
	[10359]="0:4:2:1:Cloth::1:0:", -- Everlast Boots
	[10360]="5000:15:1:1:Companion::1:0:8404", -- Black Kingsnake
	[10361]="5000:15:1:1:Companion::1:0:8404", -- Brown Snake
	[10362]="0:4:2:1:Shield::1:0:", -- Ornate Shield
	[10363]="0:4:2:1:Shield::1:0:", -- Engraved Wall
	[10364]="0:4:2:1:Shield::1:0:", -- Templar Shield
	[10365]="0:4:2:1:Shield::1:0:", -- Emerald Shield
	[10366]="0:4:2:1:Shield::1:0:", -- Demon Guard
	[10367]="0:4:2:1:Shield::1:0:", -- Hyperion Shield
	[10368]="0:4:2:1:Plate::1:0:", -- Imbued Plate Armor
	[10369]="0:4:2:1:Plate::1:0:", -- Imbued Plate Gauntlets
	[10370]="0:4:2:1:Plate::1:0:", -- Imbued Plate Girdle
	[10371]="0:4:2:1:Plate::1:0:", -- Imbued Plate Greaves
	[10372]="0:4:2:1:Plate::1:0:", -- Imbued Plate Helmet
	[10373]="0:4:2:1:Plate::1:0:", -- Imbued Plate Leggings
	[10374]="0:4:2:1:Plate::1:0:", -- Imbued Plate Pauldrons
	[10375]="0:4:2:1:Plate::1:0:", -- Imbued Plate Vambraces
	[10376]="0:4:2:1:Plate::1:0:", -- Commander's Boots
	[10377]="0:4:2:1:Plate::1:0:", -- Commander's Vambraces
	[10378]="0:4:2:1:Plate::1:0:", -- Commander's Armor
	[10379]="0:4:2:1:Plate::1:0:", -- Commander's Helm
	[10380]="0:4:2:1:Plate::1:0:", -- Commander's Gauntlets
	[10381]="0:4:2:1:Plate::1:0:", -- Commander's Girdle
	[10382]="0:4:2:1:Plate::1:0:", -- Commander's Leggings
	[10383]="0:4:2:1:Plate::1:0:", -- Commander's Pauldrons
	[10384]="0:4:2:1:Plate::1:0:", -- Hyperion Armor
	[10385]="0:4:2:1:Plate::1:0:", -- Hyperion Greaves
	[10386]="0:4:2:1:Plate::1:0:", -- Hyperion Gauntlets
	[10387]="0:4:2:1:Plate::1:0:", -- Hyperion Girdle
	[10388]="0:4:2:1:Plate::1:0:", -- Hyperion Helm
	[10389]="0:4:2:1:Plate::1:0:", -- Hyperion Legplates
	[10390]="0:4:2:1:Plate::1:0:", -- Hyperion Pauldrons
	[10391]="0:4:2:1:Plate::1:0:", -- Hyperion Vambraces
	[10392]="5000:15:1:1:Companion::1:0:8404,20980", -- Crimson Snake
	[10393]="5000:15:1:1:Companion::1:0:8403,20980", -- Cockroach
	[10394]="5000:15:1:1:Companion::1:0:8401", -- Prairie Dog Whistle
	[10398]="0:15:1:1:Companion::1:0:", -- Mechanical Chicken
	[10399]="0:4:3:1:Leather::1:0:", -- Blackened Defias Armor
	[10400]="0:4:2:1:Leather::1:0:", -- Blackened Defias Leggings
	[10401]="0:4:2:1:Leather::1:0:", -- Blackened Defias Gloves
	[10402]="0:4:2:1:Leather::1:0:", -- Blackened Defias Boots
	[10403]="0:4:3:1:Leather::1:0:", -- Blackened Defias Belt
	[10404]="0:4:2:1:Cloth::1:0:", -- Durable Belt
	[10405]="0:4:1:1:Leather::1:0:", -- Bandit Shoulders
	[10406]="0:4:2:1:Leather::1:0:", -- Scaled Leather Headband
	[10407]="0:4:1:1:Mail::1:0:", -- Raider's Shoulderpads
	[10408]="0:4:2:1:Mail::1:0:", -- Banded Helm
	[10409]="0:4:2:1:Mail::1:0:", -- Banded Boots
	[10410]="0:4:3:1:Leather::1:0:", -- Leggings of the Fang
	[10411]="0:4:3:1:Leather::1:0:", -- Footpads of the Fang
	[10412]="0:4:3:1:Leather::1:0:", -- Belt of the Fang
	[10413]="0:4:3:1:Leather::1:0:", -- Gloves of the Fang
	[10414]="0:12:1:1:::1:0:", -- Sample Snapjaw Shell
	[10418]="0:4:2:1:Trinket::1:0:", -- Glimmering Mithril Insignia
	[10420]="0:12:1:1:::1:0:", -- Skull of the Coldbringer
	[10421]="0:4:1:1:Mail::1:0:", -- Rough Copper Vest
	[10423]="0:4:2:1:Mail::1:0:", -- Silvered Bronze Leggings
	[10424]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Silvered Bronze Leggings
	[10438]="0:12:1:1:::1:0:", -- Felix's Box
	[10439]="0:12:1:1:::1:0:", -- Durnan's Scalding Mornbrew
	[10440]="0:12:1:1:::1:0:", -- Nori's Mug
	[10441]="0:12:1:1:::1:0:", -- Glowing Shard
	[10442]="0:12:1:1:::1:0:", -- Mysterious Artifact
	[10443]="0:12:1:1:::1:0:", -- Singed Letter
	[10444]="0:12:1:1:::1:0:", -- Standard Issue Flare Gun
	[10445]="0:12:1:1:::1:0:", -- Drawing Kit
	[10446]="0:12:1:1:::1:0:", -- Heart of Obsidion
	[10447]="0:12:1:1:::1:0:", -- Head of Lathoric the Black
	[10450]="0:12:0:20:::1:0:", -- Undamaged Hippogryph Feather
	[10454]="0:12:2:1:::1:0:", -- Essence of Eranikus
	[10455]="0:4:2:1:Trinket::1:0:", -- Chained Essence of Eranikus
	[10456]="0:15:1:1:Junk::1:0:", -- A Bulging Coin Purse
	[10457]="0:15:0:5:Junk::1:0:", -- Empty Sea Snail Shell
	[10458]="0:12:1:1:::1:0:", -- Prayer to Elune
	[10459]="0:12:1:1:::1:0:", -- Chief Sharptusk Thornmantle's Head
	[10460]="0:15:1:1:Junk::1:0:", -- Hakkari Blood
	[10461]="0:4:2:1:Cloth::1:0:", -- Shadowy Bracers
	[10462]="0:4:2:1:Cloth::1:0:", -- Shadowy Belt
	[10463]="0:9:2:1:Tailoring::1:0:", -- Pattern: Shadoweave Mask
	[10464]="0:12:1:1:::1:0:", -- Staff of Command
	[10465]="0:12:1:1:::1:0:", -- Egg of Hakkar
	[10466]="0:12:1:1:::1:0:", -- Atal'ai Stone Circle
	[10467]="0:15:1:1:Junk::1:0:", -- Trader's Satchel
	[10479]="0:15:2:1:Junk::1:0:", -- Kovic's Trading Satchel
	[10498]="0:7:1:1:Part::1:0:", -- Gyromatic Micro-Adjustor
	[10499]="0:4:2:1:Cloth::1:0:", -- Bright-Eye Goggles
	[10500]="0:4:2:1:Cloth:202:1:0:", -- Fire Goggles
	[10501]="0:4:2:1:Cloth::1:0:", -- Catseye Ultra Goggles
	[10502]="0:4:2:1:Cloth:202:1:0:", -- Spellpower Goggles Xtreme
	[10503]="0:4:2:1:Cloth::1:0:", -- Rose Colored Goggles
	[10504]="0:4:3:1:Cloth::1:0:", -- Green Lens
	[10505]="0:7:1:20:Part:202:1:0:", -- Solid Blasting Powder
	[10506]="0:4:2:1:Cloth::1:0:", -- Deepdive Helmet
	[10507]="0:7:1:20:Explosive:202:1:0:", -- Solid Dynamite
	[10508]="0:2:2:1:Gun::1:0:", -- Mithril Blunderbuss
	[10509]="0:12:1:4:::1:0:", -- Heart of Flame
	[10510]="0:2:2:1:Gun::1:0:", -- Mithril Heavy-bore Rifle
	[10511]="0:12:1:4:::1:0:", -- Golem Oil
	[10512]="0:6:2:1000:Bullet::1:0:", -- Hi-Impact Mithril Slugs
	[10513]="0:6:2:1000:Bullet::1:0:", -- Mithril Gyro-Shot
	[10514]="0:7:1:20:Explosive::1:0:", -- Mithril Frag Bomb
	[10515]="0:4:1:1:Miscellaneous::1:0:", -- Torch of Retribution
	[10518]="0:4:2:1:Cloak::1:0:", -- Parachute Cloak
	[10538]="0:12:1:1:::1:0:", -- Tablet of Beth'Amara
	[10539]="0:12:1:1:::1:0:", -- Tablet of Jin'yael
	[10540]="0:12:1:1:::1:0:", -- Tablet of Markri
	[10541]="0:12:1:1:::1:0:", -- Tablet of Sael'hai
	[10542]="0:4:2:1:Mail::1:0:", -- Goblin Mining Helmet
	[10543]="0:4:2:1:Cloth:202:1:0:", -- Goblin Construction Helmet
	[10544]="0:2:1:1:OneHandMace::1:0:", -- Thistlewood Maul
	[10545]="0:4:2:1:Cloth::1:0:", -- Gnomish Goggles
	[10546]="0:0:1:5:EnhPerm:202:1:0:", -- Deadly Scope
	[10547]="0:2:1:1:Dagger::1:0:", -- Camping Knife
	[10548]="0:0:1:5:EnhPerm::1:0:", -- Sniper Scope
	[10549]="0:4:2:1:Cloth::1:0:", -- Rancher's Trousers
	[10550]="0:4:1:1:Cloth::1:0:", -- Wooly Mittens
	[10551]="0:12:1:10:::1:0:", -- Thorium Plated Dagger
	[10552]="0:12:1:1:::1:0:", -- Symbol of Ragnaros
	[10553]="0:4:2:1:Cloth::1:0:", -- Foreman Vest
	[10554]="0:4:2:1:Cloth::1:0:", -- Foreman Pants
	[10556]="0:12:1:1:::1:0:", -- Stone Circle
	[10558]="0:7:1:20:Part:202:1:0:", -- Gold Power Core
	[10559]="0:7:1:20:Part:202:1:0:", -- Mithril Tube
	[10560]="0:7:1:10:Part:202:1:0:", -- Unstable Trigger
	[10561]="0:7:1:10:Part:202:1:0:", -- Mithril Casing
	[10562]="0:7:1:20:Explosive::1:0:", -- Hi-Explosive Bomb
	[10563]="0:12:1:1:::1:0:", -- Rubbing: Rune of Beth'Amara
	[10564]="0:12:1:1:::1:0:", -- Rubbing: Rune of Jin'yael
	[10565]="0:12:1:1:::1:0:", -- Rubbing: Rune of Markri
	[10566]="0:12:1:1:::1:0:", -- Rubbing: Rune of Sael'hai
	[10567]="0:2:3:1:Bow::1:0:", -- Quillshooter
	[10569]="0:15:1:1:Junk::1:0:", -- Hoard of the Black Dragonflight
	[10570]="0:2:3:1:TwoHandAxe::1:0:", -- Manslayer
	[10571]="0:2:3:1:OneHandMace::1:0:", -- Ebony Boneclub
	[10572]="0:2:3:1:Wand::1:0:", -- Freezing Shard
	[10573]="0:2:3:1:TwoHandSword::1:0:", -- Boneslasher
	[10574]="0:4:3:1:Cloth::1:0:", -- Corpseshroud
	[10575]="0:15:1:10:Junk::1:0:", -- Black Dragonflight Molt
	[10576]="0:4:2:1:Trinket:202:1:0:", -- Mithril Mechanical Dragonling
	[10577]="0:4:1:1:Trinket:202:1:0:", -- Goblin Mortar
	[10578]="0:4:3:1:Cloth::1:0:", -- Thoughtcast Boots
	[10579]="0:6:3:200:Arrow::1:0:", -- Explosive Arrow
	[10580]="0:7:1:10:Explosive::1:0:", -- Goblin "Boom" Box
	[10581]="0:4:3:1:Cloth::1:0:", -- Death's Head Vestment
	[10582]="0:4:3:1:Leather::1:0:", -- Briar Tredders
	[10583]="0:4:3:1:Leather::1:0:", -- Quillward Harness
	[10584]="0:4:3:1:Mail::1:0:", -- Stormgale Fists
	[10585]="0:4:1:10:Trinket::1:0:", -- Goblin Radio
	[10586]="0:7:1:20:Explosive:202:1:0:", -- The Big One
	[10587]="0:4:1:1:Trinket::1:0:", -- Goblin Bomb Dispenser
	[10588]="0:4:2:1:Cloth::1:0:", -- Goblin Rocket Helmet
	[10589]="0:12:1:1:::1:0:", -- Oathstone of Ysera's Dragonflight
	[10590]="0:12:1:1:::1:0:", -- Pocked Black Box
	[10592]="0:0:1:20:Elixir:202:1:0:", -- Catseye Elixir
	[10593]="0:12:2:20:::1:0:", -- Imperfect Draenethyst Fragment
	[10597]="0:12:1:1:::1:0:", -- Head of Magus Rimtori
	[10598]="0:12:1:1:::1:0:", -- Hetaera's Bloodied Head
	[10599]="0:12:1:1:::1:0:", -- Hetaera's Beaten Head
	[10600]="0:12:1:1:::1:0:", -- Hetaera's Bruised Head
	[10601]="0:9:2:1:Engineering::1:0:", -- Schematic: Bright-Eye Goggles
	[10602]="3000:9:1:1:Engineering::1:1:8679,9544", -- Schematic: Deadly Scope
	[10603]="0:9:2:1:Engineering::1:0:", -- Schematic: Catseye Ultra Goggles
	[10604]="0:9:2:1:Engineering::1:0:", -- Schematic: Mithril Heavy-bore Rifle
	[10605]="0:9:3:1:Engineering::1:0:", -- Schematic: Spellpower Goggles Xtreme
	[10606]="0:9:2:1:Engineering::1:0:", -- Schematic: Parachute Cloak
	[10607]="3600:9:1:1:Engineering::1:1:8678", -- Schematic: Deepdive Helmet
	[10608]="0:9:3:1:Engineering::1:0:", -- Schematic: Sniper Scope
	[10609]="4000:9:1:1:Engineering::1:1:2688,35826", -- Schematic: Mithril Mechanical Dragonling
	[10610]="0:12:1:1:::1:0:", -- Hetaera's Blood
	[10620]="0:7:1:20:MetalStone:171,186:1:0:", -- Thorium Ore
	[10621]="0:0:1:1:Consumable::1:0:", -- Runed Scroll
	[10622]="0:12:1:1:::1:0:", -- Kadrak's Flag
	[10623]="0:2:3:1:OneHandAxe::1:0:", -- Winter's Bite
	[10624]="0:2:3:1:Bow::1:0:", -- Stinging Bow
	[10625]="0:2:3:1:Dagger::1:0:", -- Stealthblade
	[10626]="0:2:3:1:TwoHandMace::1:0:", -- Ragehammer
	[10627]="0:2:3:1:Stave::1:0:", -- Bludgeon of the Grinning Dog
	[10628]="0:2:3:1:TwoHandSword::1:0:", -- Deathblow
	[10629]="0:4:3:1:Cloth::1:0:", -- Mistwalker Boots
	[10630]="0:4:3:1:Cloth::1:0:", -- Soulcatcher Halo
	[10631]="0:4:3:1:Mail::1:0:", -- Murkwater Gauntlets
	[10632]="0:4:3:1:Mail::1:0:", -- Slimescale Bracers
	[10633]="0:4:3:1:Plate::1:0:", -- Silvershell Leggings
	[10634]="0:4:3:1:Ring::1:0:", -- Mindseye Circle
	[10635]="0:4:1:1:Mail::1:0:", -- Painted Chain Leggings
	[10636]="0:4:1:1:Leather::1:0:", -- Nomadic Gloves
	[10637]="0:4:2:1:Cloth::1:0:", -- Brewer's Gloves
	[10638]="0:4:2:1:Cloak::1:0:", -- Long Draping Cape
	[10639]="0:12:1:20:::1:0:", -- Hyacinth Mushroom
	[10640]="0:12:1:20:::1:0:", -- Webwood Ichor
	[10641]="0:12:1:20:::1:0:", -- Moonpetal Lily
	[10642]="0:12:1:1:::1:0:", -- Iverron's Antidote
	[10643]="0:12:1:1:::1:0:", -- Sealed Letter to Ag'tor
	[10644]="0:9:1:1:Alchemy::1:0:", -- Recipe: Goblin Rocket Fuel
	[10645]="0:4:1:1:Trinket::1:0:", -- Gnomish Death Ray
	[10646]="0:7:1:20:Explosive::1:0:", -- Goblin Sapper Charge
	[10647]="2000:7:1:10:Part:202:1:0:1316,1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4581,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14337,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,19575,19661,20890,21112,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Engineer's Ink
	[10648]="125:7:1:20:Other:202,773:1:0:66,1250,1316,1448,1692,1694,2118,2682,2683,2684,2685,2687,2688,3081,3133,3168,3187,3413,3495,3614,4453,4581,4587,5175,5519,5817,6730,6777,8678,8679,8934,9544,9676,11185,14337,14637,16261,16262,16602,16657,16782,16826,17222,17421,17490,18015,18278,18484,18752,18775,18907,18960,19015,19017,19042,19194,19197,19345,19372,19383,19450,19497,19533,19562,19573,19575,19661,20081,20092,20194,20250,20890,20891,21083,21112,21113,22099,22271,23363,23802,24054,24147,24188,24341,24356,25034,26374,26474,26600,26720,26898,26916,26939,26941,26959,26977,26995,27012,27021,27026,27043,27057,27063,27070,27132,27143,27146,27184,27195,27711,27938,28692,28722,28723,28794,28797,28806,28831,28872,29208,29270,29277,29688,29907,30311,30345,30434,30438,30723,30724,30727,30729,30730,30731,30732,30733,30734,30735,30825,31115,31776,31781,32477,32639,32641,33594,33598,33634,33638,33669,33677,33679,37904,37935", -- Common Parchment
	[10649]="0:12:1:1:::1:0:", -- Nightmare Shard
	[10652]="0:2:3:1:TwoHandAxe::1:0:", -- Will of the Mountain Giant
	[10653]="0:4:2:1:Leather::1:0:", -- Trailblazer Boots
	[10654]="0:4:2:1:Cloth::1:0:", -- Jutebraid Gloves
	[10655]="0:4:1:1:Cloth::1:0:", -- Sedgeweed Britches
	[10656]="0:4:1:1:Mail::1:0:", -- Barkmail Vest
	[10657]="0:4:2:1:Cloth::1:0:", -- Talbar Mantle
	[10658]="0:4:2:1:Mail::1:0:", -- Quagmire Galoshes
	[10659]="0:4:2:1:Trinket::1:0:", -- Shard of Afrasa
	[10660]="0:12:1:1:::1:0:", -- First Mosh'aru Tablet
	[10661]="0:12:1:1:::1:0:", -- Second Mosh'aru Tablet
	[10662]="0:12:1:1:::1:0:", -- Filled Egg of Hakkar
	[10663]="0:0:1:1:Consumable::1:0:", -- Essence of Hakkar
	[10664]="0:12:1:1:::1:0:", -- A Note to Magus Rimtori
	[10678]="0:12:1:1:::1:0:", -- Magatha's Note
	[10679]="0:12:1:1:::1:0:", -- Andron's Note
	[10680]="0:12:1:1:::1:0:", -- Jes'rimon's Note
	[10681]="0:12:1:1:::1:0:", -- Xylem's Note
	[10682]="0:12:1:1:::1:0:", -- Belnistrasz's Oathstone
	[10684]="2000:0:1:1:Consumable::1:0:7772", -- Colossal Parachute
	[10686]="0:4:3:1:Shield::1:0:", -- Aegis of Battle
	[10687]="0:0:1:1:Consumable::1:0:", -- Empty Vial Labeled #1
	[10688]="0:0:1:1:Consumable::1:0:", -- Empty Vial Labeled #2
	[10689]="0:0:1:1:Consumable::1:0:", -- Empty Vial Labeled #3
	[10690]="0:0:1:1:Consumable::1:0:", -- Empty Vial Labeled #4
	[10691]="0:12:1:1:::1:0:", -- Filled Vial Labeled #1
	[10692]="0:12:1:1:::1:0:", -- Filled Vial Labeled #2
	[10693]="0:12:1:1:::1:0:", -- Filled Vial Labeled #3
	[10694]="0:12:1:1:::1:0:", -- Filled Vial Labeled #4
	[10695]="0:15:1:1:Junk::1:0:", -- Box of Empty Vials
	[10696]="0:2:2:1:OneHandSword::1:0:", -- Enchanted Azsharite Felbane Sword
	[10697]="0:2:2:1:Dagger::1:0:", -- Enchanted Azsharite Felbane Dagger
	[10698]="0:2:2:1:Stave::1:0:", -- Enchanted Azsharite Felbane Staff
	[10699]="0:12:1:1:::1:0:", -- Yeh'kinya's Bramble
	[10700]="0:4:2:1:Cloth::1:0:", -- Encarmine Boots
	[10701]="0:4:2:1:Mail::1:0:", -- Boots of Zua'tec
	[10702]="0:4:2:1:Leather::1:0:", -- Enormous Ogre Boots
	[10703]="0:2:2:1:Dagger::1:0:", -- Fiendish Skiv
	[10704]="0:2:2:1:Wand::1:0:", -- Chillnail Splinter
	[10705]="0:4:2:1:Cloth::1:0:", -- Firwillow Wristbands
	[10706]="0:4:2:1:Mail::1:0:", -- Nightscale Girdle
	[10707]="0:4:2:1:Plate::1:0:", -- Steelsmith Greaves
	[10708]="0:4:2:1:OffHandFrill::1:0:", -- Skullspell Orb
	[10709]="0:4:2:1:OffHandFrill::1:0:", -- Pyrestone Orb
	[10710]="0:4:3:1:Ring::1:0:", -- Dragonclaw Ring
	[10711]="0:4:3:1:Amulet::1:0:", -- Dragon's Blood Necklace
	[10712]="0:12:1:1:::1:0:", -- Cuely's Elixir
	[10713]="0:9:1:1:Blacksmithing::1:0:", -- Plans: Inlaid Mithril Cylinder
	[10714]="0:12:1:20:::1:0:", -- Crystallized Azsharite
	[10715]="0:12:1:1:::1:0:", -- Kim'Jael's Scope
	[10716]="0:4:2:1:Trinket::1:0:", -- Gnomish Shrink Ray
	[10717]="0:12:1:1:::1:0:", -- Kim'Jael's Compass
	[10718]="0:12:1:1:::1:0:", -- Kim'Jael's Wizzlegoober
	[10720]="0:4:2:1:Trinket::1:0:", -- Gnomish Net-o-Matic Projector
	[10721]="0:4:2:1:Leather::1:0:", -- Gnomish Harm Prevention Belt
	[10722]="0:12:1:1:::1:0:", -- Kim'Jael's Stuffed Chicken
	[10723]="0:4:1:10:Trinket::1:0:", -- Gnomish Ham Radio
	[10724]="0:4:2:1:Cloth::1:0:", -- Gnomish Rocket Boots
	[10725]="0:4:1:1:Trinket::1:0:", -- Gnomish Battle Chicken
	[10726]="0:4:2:1:Cloth::1:0:", -- Gnomish Mind Control Cap
	[10727]="0:4:1:1:Trinket::1:0:", -- Goblin Dragon Gun
	[10728]="1500:9:1:1:Tailoring::1:1:2663", -- Pattern: Black Swashbuckler's Shirt
	[10738]="0:12:1:1:::1:0:", -- Shipment to Galvan
	[10739]="0:4:2:1:Ring::1:0:", -- Ring of Fortitude
	[10740]="0:4:2:1:Plate::1:0:", -- Centurion Legplates
	[10741]="0:4:2:1:Leather::1:0:", -- Lordrec Helmet
	[10742]="0:4:2:1:Cloth::1:0:", -- Dragonflight Leggings
	[10743]="0:4:2:1:Mail::1:0:", -- Drakefire Headguard
	[10744]="0:2:2:1:OneHandAxe::1:0:", -- Axe of the Ebon Drake
	[10745]="0:4:2:1:Leather::1:0:", -- Kaylari Shoulders
	[10746]="0:4:2:1:Plate::1:0:", -- Runesteel Vambraces
	[10747]="0:4:2:1:Cloth::1:0:", -- Teacher's Sash
	[10748]="0:4:2:1:Leather::1:0:", -- Wanderlust Boots
	[10749]="0:4:3:1:Plate::1:0:", -- Avenguard Helm
	[10750]="0:2:3:1:Dagger::1:0:", -- Lifeforce Dirk
	[10751]="0:4:3:1:Cloth::1:0:", -- Gemburst Circlet
	[10752]="0:15:2:1:Junk::1:0:", -- Emerald Encrusted Chest
	[10753]="0:12:1:1:::1:0:", -- Amulet of Grol
	[10754]="0:12:1:1:::1:0:", -- Amulet of Sevine
	[10755]="0:12:1:1:::1:0:", -- Amulet of Allistarj
	[10757]="0:15:1:1:Junk::1:0:", -- Ward of the Defiler
	[10758]="0:2:3:1:TwoHandSword::1:0:", -- X'caliboar
	[10759]="0:12:1:1:::1:0:", -- Severed Horn of the Defiler
	[10760]="0:4:3:1:Leather::1:0:", -- Swine Fists
	[10761]="0:2:3:1:Dagger::1:0:", -- Coldrage Dagger
	[10762]="0:4:3:1:Cloth::1:0:", -- Robes of the Lich
	[10763]="0:4:3:1:Plate::1:0:", -- Icemetal Barbute
	[10764]="0:4:3:1:Mail::1:0:", -- Deathchill Armor
	[10765]="0:4:3:1:Leather::1:0:", -- Bonefingers
	[10766]="0:2:3:1:Wand::1:0:", -- Plaguerot Sprig
	[10767]="0:4:3:1:Shield::1:0:", -- Savage Boar's Guard
	[10768]="0:4:3:1:Mail::1:0:", -- Boar Champion's Belt
	[10769]="0:4:3:1:Amulet::1:0:", -- Glowing Eye of Mordresh
	[10770]="0:4:3:1:OffHandFrill::1:0:", -- Mordresh's Lifeless Skull
	[10771]="0:4:3:1:Cloth::1:0:", -- Deathmage Sash
	[10772]="0:2:3:1:OneHandAxe::1:0:", -- Glutton's Cleaver
	[10773]="0:15:2:1:Junk::1:0:", -- Hakkari Urn
	[10774]="0:4:3:1:Leather::1:0:", -- Fleshhide Shoulders
	[10775]="0:4:3:1:Plate::1:0:", -- Carapace of Tuten'kash
	[10776]="0:4:3:1:Cloak::1:0:", -- Silky Spider Cape
	[10777]="0:4:3:1:Leather::1:0:", -- Arachnid Gloves
	[10778]="0:4:2:1:Amulet::1:0:", -- Necklace of Sanctuary
	[10779]="0:4:2:1:Trinket::1:0:", -- Demon's Blood
	[10780]="0:4:2:1:Ring::1:0:", -- Mark of Hakkar
	[10781]="0:4:2:1:Leather::1:0:", -- Hakkari Breastplate
	[10782]="0:4:2:1:Cloth::1:0:", -- Hakkari Shroud
	[10783]="0:4:3:1:Leather::1:0:", -- Atal'ai Spaulders
	[10784]="0:4:3:1:Mail::1:0:", -- Atal'ai Breastplate
	[10785]="0:4:3:1:Leather::1:0:", -- Atal'ai Leggings
	[10786]="0:4:3:1:Mail::1:0:", -- Atal'ai Boots
	[10787]="0:4:3:1:Cloth::1:0:", -- Atal'ai Gloves
	[10788]="0:4:3:1:Plate::1:0:", -- Atal'ai Girdle
	[10789]="0:12:1:1:::1:0:", -- Manual of Engineering Disciplines
	[10790]="0:12:1:1:::1:0:", -- Gnome Engineer Membership Card
	[10791]="0:12:1:1:::1:0:", -- Goblin Engineer Membership Card
	[10792]="0:12:1:1:::1:0:", -- Nixx's Pledge of Secrecy
	[10793]="0:12:1:1:::1:0:", -- Overspark's Pledge of Secrecy
	[10794]="0:12:1:1:::1:0:", -- Oglethorpe's Pledge of Secrecy
	[10795]="0:4:3:1:Ring::1:0:", -- Drakeclaw Band
	[10796]="0:4:3:1:OffHandFrill::1:0:", -- Drakestone
	[10797]="0:2:3:1:OneHandSword::1:0:", -- Firebreather
	[10798]="0:4:3:1:Plate::1:0:", -- Atal'alarion's Tusk Ring
	[10799]="0:2:3:1:Polearm::1:0:", -- Headspike
	[10800]="0:4:3:1:Leather::1:0:", -- Darkwater Bracers
	[10801]="0:4:3:1:Leather::1:0:", -- Slitherscale Boots
	[10802]="0:4:3:1:Cloak::1:0:", -- Wingveil Cloak
	[10803]="0:2:3:1:OneHandSword::1:0:", -- Blade of the Wretched
	[10804]="0:2:3:1:OneHandMace::1:0:", -- Fist of the Damned
	[10805]="0:2:3:1:OneHandAxe::1:0:", -- Eater of the Dead
	[10806]="0:4:3:1:Cloth::1:0:", -- Vestments of the Atal'ai Prophet
	[10807]="0:4:3:1:Cloth::1:0:", -- Kilt of the Atal'ai Prophet
	[10808]="0:4:3:1:Cloth::1:0:", -- Gloves of the Atal'ai Prophet
	[10818]="0:12:1:1:::1:0:", -- Yeh'kinya's Scroll
	[10819]="0:12:1:20:::1:0:", -- Wildkin Feather
	[10820]="0:4:2:1:Cloth::1:0:", -- Jackseed Belt
	[10821]="0:4:2:1:Cloak::1:0:", -- Sower's Cloak
	[10822]="0:15:1:1:Companion::1:0:", -- Dark Whelpling
	[10823]="0:2:3:1:OneHandSword::1:0:", -- Vanquisher's Sword
	[10824]="0:4:3:1:Amulet::1:0:", -- Amberglow Talisman
	[10826]="0:2:2:1:Stave::1:0:", -- Staff of Lore
	[10827]="0:4:2:1:Leather::1:0:", -- Surveyor's Tunic
	[10828]="0:2:3:1:Dagger::1:0:", -- Dire Nail
	[10829]="0:4:3:1:Amulet::1:0:", -- The Dragon's Eye
	[10830]="0:0:1:10:Consumable::1:0:", -- M73 Frag Grenade
	[10831]="0:15:1:1:CombatPet::1:0:", -- Fel Orb
	[10832]="0:12:1:1:::1:0:", -- Fel Tracker Owner's Manual
	[10833]="0:4:3:1:Mail::1:0:", -- Horns of Eranikus
	[10834]="0:15:1:1:Junk::1:0:", -- Felhound Tracker Kit
	[10835]="0:4:3:1:Shield::1:0:", -- Crest of Supremacy
	[10836]="0:2:3:1:Wand::1:0:", -- Rod of Corrosion
	[10837]="0:2:3:1:OneHandAxe::1:0:", -- Tooth of Eranikus
	[10838]="0:2:3:1:OneHandMace::1:0:", -- Might of Hakkar
	[10839]="0:15:0:1:Junk::1:0:", -- Crystallized Note
	[10840]="0:15:0:1:Junk::1:0:", -- Crystallized Note
	[10841]="0:0:1:20:FoodDrink::1:0:", -- Goldthorn Tea
	[10842]="0:4:3:1:Leather::1:0:", -- Windscale Sarong
	[10843]="0:4:3:1:Cloak::1:0:", -- Featherskin Cape
	[10844]="0:2:3:1:Stave::1:0:", -- Spire of Hakkar
	[10845]="0:4:3:1:Plate::1:0:", -- Warrior's Embrace
	[10846]="0:4:3:1:Mail::1:0:", -- Bloodshot Greaves
	[10847]="0:2:4:1:OneHandSword::1:0:", -- Dragon's Call
	[10858]="3000:9:1:1:Blacksmithing::1:1:1471,8878,9179,26081", -- Plans: Solid Iron Maul
	[10918]="50:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Wound Poison
	[10919]="0:4:2:1:Cloth::1:0:", -- Apothecary Gloves
	[10920]="150:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Wound Poison II
	[10921]="250:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,26568,27031,27038,27053,28347,29535,30239,30244,30306,32639,32641", -- Wound Poison III
	[10922]="800:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,24148,24313,24780,25043,26382,26568,27031,27038,27053,27089,28347,29535,30239,30244,30306,30438,31115,32639,32641,33630,33674", -- Wound Poison IV
	[10938]="800:7:2:10:Enchanting:333:1:1:1318,3012,3346,4228,4617,5158,5757,5758,15419,16635,16722,18753,18773,18951,19234,19537,19540,19663,26569,27030,27039,27054,27147,28714,28715,29537,33597,33633,33676", -- Lesser Magic Essence
	[10939]="0:7:2:10:Enchanting:333:1:0:", -- Greater Magic Essence
	[10940]="800:7:1:20:Enchanting:333:1:1:1318,3012,3346,4228,4617,5158,5757,5758,15419,16635,16722,18753,18773,18951,19234,19537,19540,19663,26569,27030,27039,27054,27147,28714,28715,29537,33597,33633,33676", -- Strange Dust
	[10958]="0:12:1:1:::1:0:", -- Hilary's Necklace
	[10959]="0:1:2:1:Bag::1:0:", -- Demon Hide Sack
	[10978]="0:7:3:20:Enchanting:333:1:0:", -- Small Glimmering Shard
	[10998]="0:7:2:10:Enchanting:333:1:0:", -- Lesser Astral Essence
	[10999]="0:12:1:1:::1:0:", -- Ironfel
	[11000]="0:13:1:1:::1:0:", -- Shadowforge Key
	[11018]="0:12:1:100:::1:0:", -- Un'Goro Soil
	[11020]="10000:12:1:1:::1:0:4217,7879,9087", -- Evergreen Pouch
	[11022]="1000:12:1:20:::1:0:4217,7879,9087", -- Packet of Tharlendris Seeds
	[11023]="10000:15:1:1:Companion::1:0:6548", -- Ancona Chicken
	[11024]="0:12:1:1:::1:0:", -- Evergreen Herb Casing
	[11026]="10000:15:1:1:Companion::1:0:14860", -- Tree Frog Box
	[11027]="10000:15:1:1:Companion::1:1:14860", -- Wood Frog Box
	[11038]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant 2H Weapon - Lesser Spirit
	[11039]="800:9:2:1:Enchanting::1:1:3954,12043", -- Formula: Enchant Cloak - Minor Agility
	[11040]="0:12:1:20::197:1:0:", -- Morrowgrain
	[11058]="0:12:1:1:::1:0:", -- Sha'ni's Nose-Ring
	[11078]="0:13:1:20:::1:0:", -- Relic Coffer Key
	[11079]="0:15:1:1:Junk::1:0:", -- Gor'tesh's Lopped Off Head
	[11080]="0:12:1:1:::1:0:", -- Gor'tesh's Lopped Off Head
	[11081]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Shield - Lesser Protection
	[11082]="0:7:2:10:Enchanting:333:1:0:", -- Greater Astral Essence
	[11083]="0:7:1:20:Enchanting:333,755:1:0:", -- Soul Dust
	[11084]="0:7:3:20:Enchanting:333:1:0:", -- Large Glimmering Shard
	[11086]="0:2:3:1:OneHandSword::1:0:", -- Jang'thraze the Protector
	[11098]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Lesser Shadow Resistance
	[11101]="2500:9:2:1:Enchanting::1:1:3954,12043", -- Formula: Enchant Bracer - Lesser Strength
	[11102]="0:12:1:1:::1:0:", -- Unhatched Sprite Darter Egg
	[11103]="0:12:1:1:::1:0:", -- Seed Voucher
	[11104]="0:12:1:1:::1:0:", -- Large Compass
	[11105]="0:12:1:1:::1:0:", -- Curled Map Parchment
	[11106]="0:13:1:1:::1:0:", -- Lion-headed Key
	[11107]="0:12:1:1:::1:0:", -- A Small Pack
	[11108]="0:12:1:1:::1:0:", -- Faded Photograph
	[11109]="25:0:1:1:FoodDrink::1:0:233,33996", -- Special Chicken Feed
	[11110]="0:15:1:1:Companion::1:0:", -- Chicken Egg
	[11112]="0:12:1:1:::1:0:", -- Research Equipment
	[11113]="0:12:1:1:::1:0:", -- Crate of Foodstuffs
	[11114]="0:12:1:20:::1:0:", -- Dinosaur Bone
	[11116]="0:15:2:1:Junk::1:0:", -- A Mangled Journal
	[11118]="0:4:3:1:Ring::1:0:", -- Archaedic Stone
	[11119]="0:12:1:20:::1:0:", -- Milly's Harvest
	[11120]="0:2:2:1:OneHandMace::1:0:", -- Belgrom's Hammer
	[11121]="0:2:3:1:OneHandSword::1:0:", -- Darkwater Talwar
	[11122]="0:4:2:1:Trinket::1:0:", -- Carrot on a Stick
	[11123]="0:4:3:1:Cloth::1:0:", -- Rainstrider Leggings
	[11124]="0:4:3:1:Mail::1:0:", -- Helm of Exile
	[11125]="0:12:1:1:::1:0:", -- Grape Manifest
	[11126]="0:12:1:1:::1:0:", -- Tablet of Kurniya
	[11127]="0:12:1:20:::1:0:", -- Scavenged Goods
	[11128]="0:7:1:1:Enchanting:333:1:0:", -- Golden Rod
	[11129]="0:12:1:20:::1:0:", -- Essence of the Elements
	[11130]="0:7:1:1:Enchanting:333:1:0:", -- Runed Golden Rod
	[11131]="0:12:1:1:::1:0:", -- Hive Wall Sample
	[11132]="0:12:1:1:::1:0:", -- Unused Scraping Vial
	[11133]="0:12:1:1:::1:0:", -- Linken's Training Sword
	[11134]="0:7:2:10:Enchanting:333:1:0:", -- Lesser Mystic Essence
	[11135]="0:7:2:10:Enchanting:333:1:0:", -- Greater Mystic Essence
	[11136]="0:12:1:1:::1:0:", -- Linken's Tempered Sword
	[11137]="0:7:1:20:Enchanting:333,755,197:1:0:", -- Vision Dust
	[11138]="0:7:3:20:Enchanting:333:1:0:", -- Small Glowing Shard
	[11139]="0:7:3:20:Enchanting:333:1:0:", -- Large Glowing Shard
	[11140]="0:13:1:1:::1:0:", -- Prison Cell Key
	[11141]="2000:12:1:1:::1:0:7775", -- Bait
	[11142]="0:12:1:1:::1:0:", -- Broken Samophlange
	[11143]="0:12:1:20:::1:0:", -- Nugget Slug
	[11144]="0:7:1:1:Enchanting:333:1:0:", -- Truesilver Rod
	[11145]="0:7:1:1:Enchanting:333:1:0:", -- Runed Truesilver Rod
	[11146]="0:12:1:1:::1:0:", -- Broken and Battered Samophlange
	[11147]="0:12:1:1:::1:0:", -- Samophlange Manual Cover
	[11148]="0:0:1:20:Consumable::1:0:", -- Samophlange Manual Page
	[11149]="0:12:1:1:::1:0:", -- Samophlange Manual
	[11150]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Mining
	[11151]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Herbalism
	[11152]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Fishing
	[11162]="0:12:1:1:::1:0:", -- Linken's Superior Sword
	[11163]="3000:9:2:1:Enchanting::1:1:2381,2821", -- Formula: Enchant Bracer - Lesser Deflection
	[11164]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Lesser Beastslayer
	[11165]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Lesser Elemental Slayer
	[11166]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Skinning
	[11167]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Boots - Lesser Spirit
	[11168]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Shield - Lesser Block
	[11169]="0:12:1:1:::1:0:", -- Book of Aquor
	[11172]="0:12:1:20:::1:0:", -- Silvery Claws
	[11173]="0:12:1:1:::1:0:", -- Irontree Heart
	[11174]="0:7:2:10:Enchanting:333:1:0:", -- Lesser Nether Essence
	[11175]="0:7:2:10:Enchanting:333:1:0:", -- Greater Nether Essence
	[11176]="0:7:1:20:Enchanting:171,333,186,197:1:0:", -- Dream Dust
	[11177]="0:7:3:20:Enchanting:333:1:0:", -- Small Radiant Shard
	[11178]="0:7:3:20:Enchanting:333,755:1:0:", -- Large Radiant Shard
	[11179]="0:12:1:1:::1:0:", -- Golden Flame
	[11184]="0:12:1:100:::1:0:", -- Blue Power Crystal
	[11185]="0:12:1:100:::1:0:", -- Green Power Crystal
	[11186]="0:12:1:100:::1:0:", -- Red Power Crystal
	[11187]="0:4:1:1:Cloth::1:0:", -- Stemleaf Bracers
	[11188]="0:12:1:100:::1:0:", -- Yellow Power Crystal
	[11189]="0:4:1:1:Cloth::1:0:", -- Woodland Robes
	[11190]="0:4:1:1:Cloth::1:0:", -- Viny Gloves
	[11191]="0:4:1:1:Cloth::1:0:", -- Farmer's Boots
	[11192]="0:4:1:1:Cloth::1:0:", -- Outfitter Gloves
	[11193]="0:4:2:1:Leather::1:0:", -- Blazewind Breastplate
	[11194]="0:4:2:1:Mail::1:0:", -- Prismscale Hauberk
	[11195]="0:4:2:1:Plate::1:0:", -- Warforged Chestplate
	[11196]="0:4:2:1:Amulet::1:0:", -- Mindburst Medallion
	[11197]="0:13:1:1:::1:0:", -- Dark Keeper Key
	[11202]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Shield - Stamina
	[11203]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Advanced Mining
	[11204]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Greater Spirit
	[11205]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Advanced Herbalism
	[11206]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Lesser Agility
	[11207]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Fiery Weapon
	[11208]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Demonslaying
	[11222]="0:12:1:1:::1:0:", -- Head of Krom'zar
	[11223]="5800:9:2:1:Enchanting::1:1:989,4229", -- Formula: Enchant Bracer - Deflection
	[11224]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Shield - Frost Resistance
	[11225]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Greater Stamina
	[11226]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Riding Skill
	[11227]="0:12:1:1:::1:0:", -- Piece of Krom'zar's Banner
	[11229]="0:4:2:1:Mail::1:0:", -- Brightscale Girdle
	[11230]="0:12:1:1:::1:0:", -- Encased Fiery Essence
	[11231]="0:12:1:10:::1:0:", -- Altered Black Dragonflight Molt
	[11242]="0:12:1:1:::1:0:", -- Evoroot
	[11243]="0:12:1:20:::1:0:", -- Videre Elixir
	[11262]="0:4:3:1:OffHandFrill::1:0:", -- Orb of Lorica
	[11263]="0:2:3:1:Wand::1:0:", -- Nether Force Wand
	[11265]="0:2:2:1:TwoHandMace::1:0:", -- Cragwood Maul
	[11266]="0:12:1:20:::1:0:", -- Fractured Elemental Shard
	[11267]="0:12:1:1:::1:0:", -- Elemental Shard Sample
	[11268]="0:12:1:1:::1:0:", -- Head of Argelmach
	[11269]="0:12:1:10:::1:0:", -- Intact Elemental Core
	[11270]="0:12:1:1:::1:0:", -- Nixx's Signed Pledge
	[11282]="0:12:1:1:::1:0:", -- Oglethorpe's Signed Pledge
	[11283]="0:12:1:1:::1:0:", -- Overspark's Signed Pledge
	[11284]="1000:6:1:1000:Bullet::200:0:734,1149,1285,1297,1461,2084,2401,2685,2803,2806,2808,2820,2908,3018,3053,3313,3322,3350,3541,3625,4170,4241,4555,4603,4889,4896,5101,5123,5134,6028,7942,8131,8139,8362,9548,9551,11038,11184,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16602,16620,16732,16735,16826,18011,18907,18959,19020,19021,19053,19197,19243,19314,19315,19339,19343,19351,19374,19436,19452,19473,19474,19498,19534,19560,19574,19625,19649,19679,19694,19718,20080,20092,20194,20231,20249,20892,21082,21111,21172,21183,21483,21488,22099,22270,23143,23373,24053,24141,24348,25035,26718,27071,28792,28807,29207", -- Accurate Slugs
	[11285]="1000:6:1:1000:Arrow::200:0:228,734,789,1149,1285,1298,1462,2084,2401,2803,2806,2808,2820,2839,2908,3015,3313,3350,3410,3541,3625,4170,4173,4241,4555,4604,4892,4896,5101,5122,5134,6028,7942,8139,8362,9548,9551,9552,9555,11038,11555,12021,12027,12246,12959,12960,14301,14624,15174,15397,16191,16602,16732,16826,16919,17598,18011,18907,18959,19020,19021,19053,19197,19243,19314,19315,19339,19343,19351,19374,19436,19452,19473,19474,19498,19534,19560,19561,19574,19625,19649,19679,19694,19718,20080,20092,20194,20231,20249,20892,21082,21111,21172,21183,21483,21488,22099,22270,23143,23373,24053,24141,24348,25035,26718,27055,27071,28792,28807,29207", -- Jagged Arrow
	[11286]="0:12:1:1:::1:0:", -- Thorium Shackles
	[11287]="0:2:2:1:Wand::1:0:", -- Lesser Magic Wand
	[11288]="0:2:2:1:Wand::1:0:", -- Greater Magic Wand
	[11289]="0:2:2:1:Wand::1:0:", -- Lesser Mystic Wand
	[11290]="0:2:2:1:Wand::1:0:", -- Greater Mystic Wand
	[11291]="4500:7:1:20:Other:333,202:1:0:1318,3012,3346,4228,4617,5158,5757,5758,15419,16635,16722,18753,18773,18951,19234,19537,19540,19663,26569,27030,27039,27054,27147,28714,28715,29537,33597,33633,33676", -- Star Wood
	[11302]="0:4:3:1:Trinket::1:0:", -- Uther's Strength
	[11303]="3185:2:2:1:Bow::1:1:1198,1298,3015,3410,4173,4604,5122", -- Fine Shortbow
	[11304]="4862:2:2:1:Bow::1:1:228,1459,1668,1687,3488,3534,9549,9551,9553", -- Fine Longbow
	[11305]="25814:2:2:1:Bow::1:1:2839,3951,4892,9551,9552,9555,14301", -- Dense Shortbow
	[11306]="19468:2:2:1:Bow::1:1:1298,3015,3410,4173,4604,5122", -- Sturdy Recurve
	[11307]="67952:2:2:1:Bow::1:1:1298,3015,3410,4604,5122,24028", -- Massive Longbow
	[11308]="78829:2:2:1:Bow::1:1:4173,9548,12029,19499,24028", -- Sylvan Shortbow
	[11309]="0:12:1:1:::1:0:", -- The Heart of the Mountain
	[11310]="0:4:3:1:Cloth::1:0:", -- Flameseer Mantle
	[11311]="0:4:3:1:Cloak::1:0:", -- Emberscale Cape
	[11312]="0:12:1:1:::1:0:", -- Lost Thunderbrew Recipe
	[11313]="0:12:1:1:::1:0:", -- Ribbly's Head
	[11315]="0:12:1:100:::1:0:", -- Bloodpetal Sprout
	[11316]="0:12:1:20:::1:0:", -- Bloodpetal
	[11318]="0:12:1:20:::1:0:", -- Atal'ai Haze
	[11319]="0:12:1:1:::1:0:", -- Unloaded Zapper
	[11320]="0:12:1:1:::1:0:", -- Bloodpetal Zapper
	[11324]="0:1:1:1:Bag::1:0:", -- Explorer's Knapsack
	[11325]="600:0:1:20:Other::1:1:9499", -- Dark Iron Ale Mug
	[11362]="1000:11:1:1:Quiver::1:0:228,789,1198,1287,1297,1298,1459,1462,1668,1687,2839,3015,3165,3409,3410,3488,3589,3610,3951,4173,4203,4602,4604,4892,5122,6028,7976,9548,9549,9551,9552,9553,9555,10369,12029,14301,16263,16274,16619,16715,16919,17598,17667,19020,19561,27055", -- Medium Quiver
	[11363]="1000:11:1:1:AmmoPouch::1:0:2685,6028", -- Medium Shot Pouch
	[11364]="0:4:1:1:Tabard::1:0:", -- Tabard of Stormwind
	[11366]="0:12:1:1:::1:0:", -- Helendis Riverhorn's Letter
	[11367]="0:12:1:1:::1:0:", -- Solomon's Plea to Bolvar
	[11368]="0:12:1:1:::1:0:", -- Wrynn's Decree
	[11370]="0:7:1:20:MetalStone:186:1:0:", -- Dark Iron Ore
	[11371]="0:7:1:20:MetalStone:164,202,755:1:0:", -- Dark Iron Bar
	[11382]="0:3:2:20:GemSimple:164,755:1:0:", -- Blood of the Mountain
	[11384]="0:15:0:20:Junk::1:0:", -- Broken Basilisk Teeth
	[11385]="0:15:0:20:Junk::1:0:", -- Basilisk Scale
	[11386]="0:15:0:10:Junk::1:0:", -- Squishy Basilisk Eye
	[11387]="0:15:0:5:Junk::1:0:", -- Basilisk Heart
	[11388]="0:15:0:5:Junk::1:0:", -- Basilisk Venom
	[11389]="0:15:0:5:Junk::1:0:", -- Shimmering Basilisk Skin
	[11390]="0:15:0:20:Junk::1:0:", -- Broken Bat Fang
	[11391]="0:15:0:10:Junk::1:0:", -- Spined Bat Wing
	[11392]="0:15:0:5:Junk::1:0:", -- Severed Bat Claw
	[11393]="0:15:0:10:Junk::1:0:", -- Small Bat Skull
	[11394]="0:15:0:10:Junk::1:0:", -- Bat Heart
	[11395]="0:15:0:10:Junk::1:0:", -- Bat Ear
	[11402]="0:15:0:10:Junk::1:0:", -- Sleek Bat Pelt
	[11403]="0:15:0:10:Junk::1:0:", -- Large Bat Fang
	[11404]="0:12:1:10:::1:0:", -- Evil Bat Eye
	[11405]="0:0:1:20:Consumable::1:0:", -- Giant Silver Vein
	[11406]="0:15:0:5:Junk::1:0:", -- Rotting Bear Carcass
	[11407]="0:12:1:10:::1:0:", -- Torn Bear Pelt
	[11408]="0:15:0:10:Junk::1:0:", -- Bear Jaw
	[11409]="0:15:0:10:Junk::1:0:", -- Bear Organ
	[11410]="0:15:0:10:Junk::1:0:", -- Savage Bear Claw
	[11411]="0:2:0:1:OneHandMace::1:0:", -- Large Bear Bone
	[11412]="0:12:1:1:::1:0:", -- Nagmara's Vial
	[11413]="0:0:1:1:Consumable::1:0:", -- Nagmara's Filled Vial
	[11414]="0:15:0:10:Junk::1:0:", -- Grizzled Mane
	[11415]="0:0:1:20:FoodDrink::1:0:", -- Mixed Berries
	[11416]="0:15:0:10:Junk::1:0:", -- Delicate Ribcage
	[11417]="0:15:0:5:Junk::1:0:", -- Feathery Wing
	[11418]="0:15:0:5:Junk::1:0:", -- Hollow Wing Bone
	[11419]="0:15:0:10:Junk::1:0:", -- Mysterious Unhatched Egg
	[11420]="0:15:0:10:Junk::1:0:", -- Elegant Writing Tool
	[11422]="0:15:1:1:Junk::1:0:", -- Goblin Engineer's Renewal Gift
	[11423]="0:15:1:1:Junk::1:0:", -- Gnome Engineer's Renewal Gift
	[11444]="4000:0:1:20:FoodDrink::5:0:9499", -- Grim Guzzler Boar
	[11445]="0:12:1:1:::1:0:", -- Flute of the Ancients
	[11446]="0:12:1:1:::1:0:", -- A Crumpled Up Note
	[11462]="0:12:1:1:::1:0:", -- Discarded Knife
	[11463]="0:12:2:1:::1:0:", -- Undelivered Parcel
	[11464]="0:12:1:1:::1:0:", -- Marshal Windsor's Lost Information
	[11465]="0:12:1:1:::1:0:", -- Marshal Windsor's Lost Information
	[11466]="0:12:1:1:::1:0:", -- Raschal's Report
	[11467]="0:12:1:50:::1:0:", -- Blackrock Medallion
	[11468]="0:12:1:20:::1:0:", -- Dark Iron Fanny Pack
	[11469]="0:4:2:1:Cloth::1:0:", -- Bloodband Bracers
	[11470]="0:12:1:1:::1:0:", -- Tablet Transcript
	[11471]="0:12:1:1:::1:0:", -- Fragile Sprite Darter Egg
	[11472]="0:12:1:10:::1:0:", -- Silvermane Stalker Flank
	[11474]="0:15:1:1:Companion::1:0:", -- Sprite Darter Egg
	[11475]="0:4:1:1:Cloak::1:0:", -- Wine-stained Cloak
	[11476]="0:12:1:1:::1:0:", -- U'cha's Pelt
	[11477]="0:12:1:10:::1:0:", -- White Ravasaur Claw
	[11478]="0:12:1:10:::1:0:", -- Un'Goro Gorilla Pelt
	[11479]="0:12:1:10:::1:0:", -- Un'Goro Stomper Pelt
	[11480]="0:12:1:10:::1:0:", -- Un'Goro Thunderer Pelt
	[11482]="0:15:0:1:Junk::1:0:", -- Crystal Pylon User's Manual
	[11502]="0:4:2:1:Leather::1:0:", -- Loreskin Shoulders
	[11503]="0:12:1:20:::1:0:", -- Blood Amber
	[11504]="0:12:1:1:::1:0:", -- Piece of Threshadon Carcass
	[11507]="0:12:1:20:::1:0:", -- Spotted Hyena Pelt
	[11508]="0:4:1:1:Cloth::1:0:", -- Gamemaster's Slippers
	[11509]="0:12:1:5:::1:0:", -- Ravasaur Pheromone Gland
	[11510]="0:12:1:1:::1:0:", -- Lar'korwi's Head
	[11511]="0:12:1:1:::1:0:", -- Cenarion Beacon
	[11512]="0:12:1:20:::1:0:", -- Patch of Tainted Skin
	[11513]="0:12:1:20:::1:0:", -- Tainted Vitriol
	[11514]="0:12:1:20:::1:0:", -- Fel Creep
	[11515]="0:12:1:20:::1:0:", -- Corrupted Soul Shard
	[11516]="0:12:1:100:::1:0:", -- Cenarion Plant Salve
	[11522]="0:4:1:1:OffHandFrill::1:0:", -- Silver Totem of Aquementas
	[11562]="0:12:1:20:::1:0:", -- Crystal Restore
	[11563]="0:12:1:20:::1:0:", -- Crystal Force
	[11564]="0:12:1:20:::1:0:", -- Crystal Ward
	[11565]="0:12:1:20:::1:0:", -- Crystal Yield
	[11566]="0:12:1:20:::1:0:", -- Crystal Charge
	[11567]="0:12:1:20:::1:0:", -- Crystal Spire
	[11568]="0:15:1:1:Junk::1:0:", -- Torwa's Pouch
	[11569]="0:12:1:1:::1:0:", -- Preserved Threshadon Meat
	[11570]="0:12:1:1:::1:0:", -- Preserved Pheromone Mixture
	[11582]="0:15:1:1:Junk::1:0:", -- Fel Salve
	[11583]="0:12:1:10:::1:0:", -- Cactus Apple
	[11584]="0:0:1:20:FoodDrink::1:0:", -- Cactus Apple Surprise
	[11590]="0:7:1:5:Device::1:0:", -- Mechanical Repair Kit
	[11602]="0:13:1:1:::1:0:", -- Grim Guzzler Key
	[11603]="0:2:3:1:FistWeapon::1:0:", -- Vilerend Slicer
	[11604]="0:4:3:1:Plate::1:0:", -- Dark Iron Plate
	[11605]="0:4:2:1:Plate::1:0:", -- Dark Iron Shoulders
	[11606]="0:4:2:1:Mail::1:0:", -- Dark Iron Mail
	[11607]="0:2:3:1:TwoHandAxe::1:0:", -- Dark Iron Sunderer
	[11608]="0:2:3:1:TwoHandMace::1:0:", -- Dark Iron Pulverizer
	[11610]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Dark Iron Pulverizer
	[11611]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Dark Iron Sunderer
	[11612]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Dark Iron Plate
	[11614]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Dark Iron Mail
	[11615]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Dark Iron Shoulders
	[11617]="0:12:1:1:::1:0:", -- Eridan's Supplies
	[11622]="0:0:2:1:EnhPerm::1:0:", -- Lesser Arcanum of Rumination
	[11623]="0:4:3:1:Cloak::1:0:", -- Spritecaster Cape
	[11624]="0:4:3:1:Cloth::1:0:", -- Kentic Amice
	[11625]="0:4:3:1:OffHandFrill::1:0:", -- Enthralled Sphere
	[11626]="0:4:3:1:Cloak::1:0:", -- Blackveil Cape
	[11627]="0:4:3:1:Mail::1:0:", -- Fleetfoot Greaves
	[11628]="0:2:3:1:Bow::1:0:", -- Houndmaster's Bow
	[11629]="0:2:3:1:Gun::1:0:", -- Houndmaster's Rifle
	[11630]="0:6:3:1000:Bullet::1:0:", -- Rockshard Pellets
	[11631]="0:4:3:1:Shield::1:0:", -- Stoneshell Guard
	[11632]="0:4:3:1:Plate::1:0:", -- Earthslag Shoulders
	[11633]="0:4:3:1:Plate::1:0:", -- Spiderfang Carapace
	[11634]="0:4:3:1:Cloth::1:0:", -- Silkweb Gloves
	[11635]="0:2:3:1:Dagger::1:0:", -- Hookfang Shanker
	[11642]="0:0:2:1:EnhPerm::1:0:", -- Lesser Arcanum of Constitution
	[11643]="0:0:2:1:EnhPerm::1:0:", -- Lesser Arcanum of Tenacity
	[11644]="0:0:2:1:EnhPerm::1:0:", -- Lesser Arcanum of Resilience
	[11645]="0:0:2:1:EnhPerm::1:0:", -- Lesser Arcanum of Voracity
	[11646]="0:0:2:1:EnhPerm::1:0:", -- Lesser Arcanum of Voracity
	[11647]="0:0:2:1:EnhPerm::1:0:", -- Lesser Arcanum of Voracity
	[11648]="0:0:2:1:EnhPerm::1:0:", -- Lesser Arcanum of Voracity
	[11649]="0:0:2:1:EnhPerm::1:0:", -- Lesser Arcanum of Voracity
	[11662]="0:4:3:1:Cloth::1:0:", -- Ban'thok Sash
	[11665]="0:4:3:1:Leather::1:0:", -- Ogreseer Fists
	[11668]="0:12:1:1:::1:0:", -- Flute of Xavaric
	[11669]="0:4:3:1:Ring::1:0:", -- Naglering
	[11674]="0:12:1:20:::1:0:", -- Jadefire Felbind
	[11675]="0:4:3:1:Leather::1:0:", -- Shadefiend Boots
	[11677]="0:4:3:1:Cloak::1:0:", -- Graverot Cape
	[11678]="0:4:3:1:Plate::1:0:", -- Carapace of Anub'shiah
	[11679]="0:4:3:1:Mail::1:0:", -- Rubicund Armguards
	[11682]="0:12:1:1:::1:0:", -- Eridan's Vial
	[11684]="0:2:4:1:OneHandMace::1:0:", -- Ironfoe
	[11685]="0:4:3:1:Leather::1:0:", -- Splinthide Shoulders
	[11686]="0:4:3:1:Leather::1:0:", -- Girdle of Beastial Fury
	[11702]="0:2:3:1:OneHandAxe::1:0:", -- Grizzle's Skinner
	[11703]="0:4:3:1:Plate::1:0:", -- Stonewall Girdle
	[11722]="0:4:3:1:Mail::1:0:", -- Dregmetal Spaulders
	[11723]="0:12:1:1:::1:0:", -- Goodsteel's Balanced Flameberge
	[11724]="0:12:1:1:::1:0:", -- Overdue Package
	[11725]="0:12:1:20:::1:0:", -- Solid Crystal Leg Shaft
	[11726]="0:4:4:1:Mail::1:0:", -- Savage Gladiator Chain
	[11727]="0:12:1:1:::1:0:", -- Goodsteel Ledger
	[11728]="0:4:3:1:Mail::1:0:", -- Savage Gladiator Leggings
	[11729]="0:4:3:1:Mail::1:0:", -- Savage Gladiator Helm
	[11730]="0:4:3:1:Mail::1:0:", -- Savage Gladiator Grips
	[11731]="0:4:3:1:Mail::1:0:", -- Savage Gladiator Greaves
	[11732]="0:9:2:1:Book::1:0:", -- Libram of Rumination
	[11733]="0:9:2:1:Book::1:0:", -- Libram of Constitution
	[11734]="0:9:2:1:Book::1:0:", -- Libram of Tenacity
	[11735]="0:4:3:1:Leather::1:0:", -- Ragefury Eyepatch
	[11736]="0:9:2:1:Book::1:0:", -- Libram of Resilience
	[11737]="0:9:2:1:Book::1:0:", -- Libram of Voracity
	[11742]="0:1:2:1:Bag::1:0:", -- Wayfarer's Knapsack
	[11743]="0:2:3:1:FistWeapon::1:0:", -- Rockfist
	[11744]="0:2:3:1:FistWeapon::1:0:", -- Bloodfist
	[11745]="0:4:3:1:Plate::1:0:", -- Fists of Phalanx
	[11746]="0:4:3:1:Plate::1:0:", -- Golem Skull Helm
	[11747]="0:4:3:1:Leather::1:0:", -- Flamestrider Robes
	[11748]="0:2:3:1:Wand::1:0:", -- Pyric Caduceus
	[11749]="0:4:3:1:Mail::1:0:", -- Searingscale Leggings
	[11750]="0:2:3:1:Stave::1:0:", -- Kindling Stave
	[11751]="0:12:1:5:::1:0:", -- Burning Essence
	[11752]="0:12:1:5:::1:0:", -- Black Blood of the Tormented
	[11753]="0:12:1:1:::1:0:", -- Eye of Kajal
	[11754]="0:12:2:20::164,755,165:1:0:", -- Black Diamond
	[11755]="0:4:3:1:Amulet::1:0:", -- Verek's Collar
	[11764]="0:4:3:1:Leather::1:0:", -- Cinderhide Armsplints
	[11765]="0:4:3:1:Mail::1:0:", -- Pyremail Wristguards
	[11766]="0:4:3:1:Cloth::1:0:", -- Flameweave Cuffs
	[11767]="0:4:3:1:Plate::1:0:", -- Emberplate Armguards
	[11768]="0:4:3:1:Cloth::1:0:", -- Incendic Bracers
	[11782]="0:4:3:1:Cloth::1:0:", -- Boreal Mantle
	[11783]="0:4:3:1:Mail::1:0:", -- Chillsteel Girdle
	[11784]="0:2:3:1:OneHandSword::1:0:", -- Arbiter's Blade
	[11785]="0:4:3:1:Shield::1:0:", -- Rock Golem Bulwark
	[11786]="0:2:3:1:TwoHandSword::1:0:", -- Stone of the Earth
	[11787]="0:4:3:1:Plate::1:0:", -- Shalehusk Boots
	[11802]="0:4:3:1:Plate::1:0:", -- Lavacrest Leggings
	[11803]="0:2:3:1:TwoHandMace::1:0:", -- Force of Magma
	[11804]="0:12:1:1:::1:0:", -- Spraggle's Canteen
	[11805]="0:2:3:1:OneHandMace::1:0:", -- Rubidium Hammer
	[11807]="0:4:3:1:Cloth::1:0:", -- Sash of the Burning Heart
	[11808]="0:4:4:1:Cloth::1:0:", -- Circle of Flame
	[11809]="0:2:3:1:Polearm::1:0:", -- Flame Wrath
	[11810]="0:4:3:1:Trinket::1:0:", -- Force of Will
	[11811]="0:4:3:1:Trinket::1:0:", -- Smoking Heart of the Mountain
	[11812]="0:4:3:1:Cloak::1:0:", -- Cape of the Fire Salamander
	[11813]="0:9:2:1:Enchanting::1:0:", -- Formula: Smoking Heart of the Mountain
	[11814]="0:4:3:1:Mail::1:0:", -- Molten Fists
	[11815]="0:4:3:1:Trinket::1:0:", -- Hand of Justice
	[11816]="0:2:3:1:TwoHandAxe::1:0:", -- Angerforge's Battle Axe
	[11817]="0:2:3:1:OneHandSword::1:0:", -- Lord General's Sword
	[11818]="0:12:1:1:::1:0:", -- Grimesilt Outhouse Key
	[11819]="0:4:3:1:Trinket::1:0:", -- Second Wind
	[11820]="0:4:3:1:Mail::1:0:", -- Royal Decorated Armor
	[11821]="0:4:3:1:Leather::1:0:", -- Warstrife Leggings
	[11822]="0:4:3:1:Cloth::1:0:", -- Omnicast Boots
	[11823]="0:4:3:1:Leather::1:0:", -- Luminary Kilt
	[11824]="0:4:3:1:Ring::1:0:", -- Cyclopean Band
	[11825]="0:15:1:1:Companion::1:0:", -- Pet Bombling
	[11826]="0:15:1:1:Companion::1:0:", -- Lil' Smoky
	[11827]="0:9:2:1:Engineering::1:0:", -- Schematic: Lil' Smoky
	[11828]="0:9:2:1:Engineering::1:0:", -- Schematic: Pet Bombling
	[11829]="0:12:1:20:::1:0:", -- Un'Goro Ash
	[11830]="0:12:1:20:::1:0:", -- Webbed Diemetradon Scale
	[11831]="0:12:1:20:::1:0:", -- Webbed Pterrordax Scale
	[11832]="0:4:3:1:Trinket::1:0:", -- Burst of Knowledge
	[11833]="0:12:1:1:::1:0:", -- Gorishi Queen Lure
	[11834]="0:12:1:20:::1:0:", -- Super Sticky Tar
	[11835]="0:12:1:1:::1:0:", -- Gorishi Queen Brain
	[11837]="0:12:1:1:::1:0:", -- Gorishi Scent Gland
	[11839]="0:4:3:1:Cloth::1:0:", -- Chief Architect's Monocle
	[11840]="0:4:1:1:Shirt::1:0:", -- Master Builder's Shirt
	[11841]="0:4:3:1:Cloth::1:0:", -- Senior Designer's Pantaloons
	[11842]="0:4:3:1:Mail::1:0:", -- Lead Surveyor's Mantle
	[11843]="0:12:1:1:::1:0:", -- Bank Voucher
	[11844]="0:12:1:1:::1:0:", -- Pestlezugg's Un'Goro Report
	[11845]="0:1:1:1:Bag::1:0:", -- Handmade Leather Bag
	[11846]="0:0:1:20:FoodDrink::1:0:", -- Wizbang's Special Brew
	[11847]="0:4:1:1:Cloak::1:0:", -- Battered Cloak
	[11848]="0:4:1:1:Cloth::1:0:", -- Flax Belt
	[11849]="0:4:1:1:Mail::1:0:", -- Rustmetal Bracers
	[11850]="0:4:1:1:Cloak::1:0:", -- Short Duskbat Cape
	[11851]="0:4:1:1:Leather::1:0:", -- Scavenger Tunic
	[11852]="0:4:1:1:Mail::1:0:", -- Roamer's Leggings
	[11853]="0:4:2:1:Leather::1:0:", -- Rambling Boots
	[11854]="0:2:2:1:TwoHandSword::1:0:", -- Samophlange Screwdriver
	[11855]="0:4:2:1:OffHandFrill::1:0:", -- Tork Wrench
	[11856]="0:2:2:1:Dagger::1:0:", -- Ceremonial Elven Blade
	[11857]="0:2:2:1:Stave::1:0:", -- Sanctimonial Rod
	[11858]="0:4:2:1:Cloak::1:0:", -- Battlehard Cape
	[11859]="0:4:2:1:OffHandFrill::1:0:", -- Jademoon Orb
	[11860]="0:2:2:1:Wand::1:0:", -- Charged Lightning Rod
	[11861]="0:4:2:1:Mail::1:0:", -- Girdle of Reprisal
	[11862]="0:4:2:1:Ring::1:0:", -- White Bone Band
	[11863]="0:2:2:1:FistWeapon::1:0:", -- White Bone Shredder
	[11864]="0:2:2:1:Polearm::1:0:", -- White Bone Spear
	[11865]="0:4:2:1:Cloth::1:0:", -- Rancor Boots
	[11866]="0:4:3:1:Leather::1:0:", -- Nagmara's Whipping Belt
	[11867]="0:4:2:1:Mail::1:0:", -- Maddening Gauntlets
	[11868]="0:4:2:1:Ring::1:0:", -- Choking Band
	[11869]="0:4:2:1:Ring::1:0:", -- Sha'ni's Ring
	[11870]="0:4:2:1:OffHandFrill::1:0:", -- Oblivion Orb
	[11871]="0:4:2:1:Leather::1:0:", -- Snarkshaw Spaulders
	[11872]="0:4:2:1:Plate::1:0:", -- Eschewal Greaves
	[11873]="0:4:2:1:Cloak::1:0:", -- Ethereal Mist Cape
	[11874]="0:4:2:1:Leather::1:0:", -- Clouddrift Mantle
	[11875]="0:4:2:1:Cloth::1:0:", -- Breezecloud Bracers
	[11876]="0:4:2:1:Leather::1:0:", -- Plainstalker Tunic
	[11882]="0:4:2:1:Mail::1:0:", -- Outrider Leggings
	[11883]="0:15:1:1:Junk::1:0:", -- A Dingy Fanny Pack
	[11884]="0:4:2:1:Cloth::1:0:", -- Moonlit Amice
	[11885]="0:12:1:1:::1:0:", -- Shadowforge Torch
	[11886]="0:12:1:1:::1:0:", -- Urgent Message
	[11887]="0:15:1:1:Junk::1:0:", -- Cenarion Circle Cache
	[11888]="0:4:2:1:Cloth::1:0:", -- Quintis' Research Gloves
	[11889]="0:4:2:1:Plate::1:0:", -- Bark Iron Pauldrons
	[11902]="0:2:2:1:OneHandSword::1:0:", -- Linken's Sword of Mastery
	[11904]="0:4:2:1:OffHandFrill::1:0:", -- Spirit of Aquementas
	[11905]="0:4:2:1:Trinket::1:0:", -- Linken's Boomerang
	[11906]="0:2:2:1:OneHandMace::1:0:", -- Beastsmasher
	[11907]="0:2:2:1:TwoHandAxe::1:0:", -- Beastslayer
	[11908]="0:4:2:1:Cloth::1:0:", -- Archaeologist's Quarry Boots
	[11909]="0:4:2:1:Leather::1:0:", -- Excavator's Utility Belt
	[11910]="0:4:2:1:Plate::1:0:", -- Bejeweled Legguards
	[11911]="0:4:2:1:Cloth::1:0:", -- Treetop Leggings
	[11912]="0:15:1:1:Junk::1:0:", -- Package of Empty Ooze Containers
	[11913]="0:4:2:1:Mail::1:0:", -- Clayridge Helm
	[11914]="0:0:1:20:Consumable::1:0:", -- Empty Cursed Ooze Jar
	[11915]="0:4:2:1:Shield::1:0:", -- Shizzle's Drizzle Blocker
	[11916]="0:4:2:1:Leather::1:0:", -- Shizzle's Muzzle
	[11917]="0:4:2:1:Cloth::1:0:", -- Shizzle's Nozzle Wiper
	[11918]="0:4:2:1:Mail::1:0:", -- Grotslab Gloves
	[11919]="0:4:2:1:Plate::1:0:", -- Cragplate Greaves
	[11920]="0:2:3:1:OneHandAxe::1:0:", -- Wraith Scythe
	[11921]="0:2:3:1:TwoHandMace::1:0:", -- Impervious Giant
	[11922]="0:2:3:1:Dagger::1:0:", -- Blood-etched Blade
	[11923]="0:2:3:1:OneHandMace::1:0:", -- The Hammer of Grace
	[11924]="0:4:3:1:Cloth::1:0:", -- Robes of the Royal Crown
	[11925]="0:4:3:1:Leather::1:0:", -- Ghostshroud
	[11926]="0:4:3:1:Mail::1:0:", -- Deathdealer Breastplate
	[11927]="0:4:3:1:Plate::1:0:", -- Legplates of the Eternal Guardian
	[11928]="0:4:3:1:OffHandFrill::1:0:", -- Thaurissan's Royal Scepter
	[11929]="0:4:3:1:Cloth::1:0:", -- Haunting Specter Leggings
	[11930]="0:4:3:1:Cloak::1:0:", -- The Emperor's New Cape
	[11931]="0:2:3:1:TwoHandAxe::1:0:", -- Dreadforge Retaliator
	[11932]="0:2:3:1:Stave::1:0:", -- Guiding Stave of Wisdom
	[11933]="0:4:3:1:Amulet::1:0:", -- Imperial Jewel
	[11934]="0:4:3:1:Ring::1:0:", -- Emperor's Seal
	[11935]="0:4:3:1:OffHandFrill::1:0:", -- Magmus Stone
	[11936]="0:4:2:1:Cloth::1:0:", -- Relic Hunter Belt
	[11937]="0:15:1:1:Junk::1:0:", -- Fat Sack of Coins
	[11938]="0:15:1:1:Junk::1:0:", -- Sack of Gems
	[11939]="0:15:0:20:Junk::1:0:", -- Shiny Bracelet
	[11940]="0:15:0:20:Junk::1:0:", -- Sparkly Necklace
	[11941]="0:15:0:10:Junk::1:0:", -- False Documents
	[11942]="0:15:0:10:Junk::1:0:", -- Legal Documents
	[11943]="0:15:0:1:Junk::1:0:", -- Deed to Thandol Span
	[11944]="0:15:0:1:Junk::1:0:", -- Dark Iron Baby Booties
	[11945]="0:4:3:1:Ring::1:0:", -- Dark Iron Ring
	[11946]="0:4:3:1:Amulet::1:0:", -- Fire Opal Necklace
	[11947]="0:12:1:20:::1:0:", -- Filled Cursed Ooze Jar
	[11948]="0:0:1:20:Consumable::1:0:", -- Empty Tainted Ooze Jar
	[11949]="0:12:1:20:::1:0:", -- Filled Tainted Ooze Jar
	[11950]="0:0:1:20:Other::1:0:", -- Windblossom Berries
	[11951]="0:0:1:20:FoodDrink::1:0:", -- Whipper Root Tuber
	[11952]="0:0:1:20:Other::1:0:", -- Night Dragon's Breath
	[11953]="0:0:1:20:Consumable::1:0:", -- Empty Pure Sample Jar
	[11954]="0:12:1:20:::1:0:", -- Filled Pure Sample Jar
	[11955]="0:15:1:1:Junk::1:0:", -- Bag of Empty Ooze Containers
	[11962]="0:4:3:1:Cloth::1:0:", -- Manacle Cuffs
	[11963]="0:4:2:1:Leather::1:0:", -- Penance Spaulders
	[11964]="0:2:2:1:OneHandMace::1:0:", -- Swiftstrike Cudgel
	[11965]="0:4:2:1:Ring::1:0:", -- Quartz Ring
	[11966]="0:15:1:1:Junk::1:0:", -- Small Sack of Coins
	[11967]="0:4:2:1:Ring::1:0:", -- Zircon Band
	[11968]="0:4:2:1:Ring::1:0:", -- Amber Hoop
	[11969]="0:4:2:1:Ring::1:0:", -- Jacinth Circle
	[11970]="0:4:2:1:Ring::1:0:", -- Spinel Ring
	[11971]="0:4:2:1:Ring::1:0:", -- Amethyst Band
	[11972]="0:4:2:1:Ring::1:0:", -- Carnelian Loop
	[11973]="0:4:2:1:Ring::1:0:", -- Hematite Link
	[11974]="0:4:2:1:Ring::1:0:", -- Aquamarine Ring
	[11975]="0:4:2:1:Ring::1:0:", -- Topaz Ring
	[11976]="0:4:2:1:Ring::1:0:", -- Sardonyx Knuckle
	[11977]="0:4:2:1:Ring::1:0:", -- Serpentine Loop
	[11978]="0:4:2:1:Ring::1:0:", -- Jasper Link
	[11979]="0:4:2:1:Ring::1:0:", -- Peridot Circle
	[11980]="0:4:2:1:Ring::1:0:", -- Opal Ring
	[11981]="0:4:2:1:Ring::1:0:", -- Lead Band
	[11982]="0:4:2:1:Ring::1:0:", -- Viridian Band
	[11983]="0:4:2:1:Ring::1:0:", -- Chrome Ring
	[11984]="0:4:2:1:Ring::1:0:", -- Cobalt Ring
	[11985]="0:4:2:1:Ring::1:0:", -- Cerulean Ring
	[11986]="0:4:2:1:Ring::1:0:", -- Thallium Hoop
	[11987]="0:4:2:1:Ring::1:0:", -- Iridium Circle
	[11988]="0:4:2:1:Ring::1:0:", -- Tellurium Band
	[11989]="0:4:2:1:Ring::1:0:", -- Vanadium Loop
	[11990]="0:4:2:1:Ring::1:0:", -- Selenium Loop
	[11991]="0:4:2:1:Ring::1:0:", -- Quicksilver Ring
	[11992]="0:4:2:1:Ring::1:0:", -- Vermilion Band
	[11993]="0:4:2:1:Ring::1:0:", -- Clay Ring
	[11994]="0:4:2:1:Ring::1:0:", -- Coral Band
	[11995]="0:4:2:1:Ring::1:0:", -- Ivory Band
	[11996]="0:4:2:1:Ring::1:0:", -- Basalt Ring
	[11997]="0:4:2:1:Ring::1:0:", -- Greenstone Circle
	[11998]="0:4:2:1:Ring::1:0:", -- Jet Loop
	[11999]="0:4:2:1:Ring::1:0:", -- Lodestone Hoop
	[12000]="0:2:2:1:TwoHandAxe::1:0:", -- Limb Cleaver
	[12001]="0:4:2:1:Ring::1:0:", -- Onyx Ring
	[12002]="0:4:2:1:Ring::1:0:", -- Marble Circle
	[12003]="0:0:1:20:FoodDrink::1:0:", -- Dark Dwarven Lager
	[12004]="0:4:2:1:Ring::1:0:", -- Obsidian Band
	[12005]="0:4:2:1:Ring::1:0:", -- Granite Ring
	[12006]="0:4:2:1:Ring::1:0:", -- Meadow Ring
	[12007]="0:4:2:1:Ring::1:0:", -- Prairie Ring
	[12008]="0:4:2:1:Ring::1:0:", -- Savannah Ring
	[12009]="0:4:2:1:Ring::1:0:", -- Tundra Ring
	[12010]="0:4:2:1:Ring::1:0:", -- Fen Ring
	[12011]="0:4:2:1:Ring::1:0:", -- Forest Hoop
	[12012]="0:4:2:1:Ring::1:0:", -- Marsh Ring
	[12013]="0:4:2:1:Ring::1:0:", -- Desert Ring
	[12014]="0:4:2:1:Ring::1:0:", -- Arctic Ring
	[12015]="0:4:2:1:Ring::1:0:", -- Swamp Ring
	[12016]="0:4:2:1:Ring::1:0:", -- Jungle Ring
	[12017]="0:4:2:1:Ring::1:0:", -- Prismatic Band
	[12018]="0:4:2:1:Mail::1:0:", -- Conservator Helm
	[12019]="0:4:2:1:Amulet::1:0:", -- Cerulean Talisman
	[12020]="0:4:2:1:Amulet::1:0:", -- Thallium Choker
	[12021]="0:4:2:1:Plate::1:0:", -- Shieldplate Sabatons
	[12022]="0:4:2:1:Amulet::1:0:", -- Iridium Chain
	[12023]="0:4:2:1:Amulet::1:0:", -- Tellurium Necklace
	[12024]="0:4:2:1:Amulet::1:0:", -- Vanadium Talisman
	[12025]="0:4:2:1:Amulet::1:0:", -- Selenium Chain
	[12026]="0:4:2:1:Amulet::1:0:", -- Quicksilver Pendant
	[12027]="0:4:2:1:Amulet::1:0:", -- Vermilion Necklace
	[12028]="0:4:2:1:Amulet::1:0:", -- Basalt Necklace
	[12029]="0:4:2:1:Amulet::1:0:", -- Greenstone Talisman
	[12030]="0:4:2:1:Amulet::1:0:", -- Jet Chain
	[12031]="0:4:2:1:Amulet::1:0:", -- Lodestone Necklace
	[12032]="0:4:2:1:Amulet::1:0:", -- Onyx Choker
	[12033]="0:15:1:1:Junk::1:0:", -- Thaurissan Family Jewels
	[12034]="0:4:2:1:Amulet::1:0:", -- Marble Necklace
	[12035]="0:4:2:1:Amulet::1:0:", -- Obsidian Pendant
	[12036]="0:4:2:1:Amulet::1:0:", -- Granite Necklace
	[12037]="350:7:1:20:Meat:185:1:0:24291", -- Mystery Meat
	[12038]="0:4:2:1:Ring::1:0:", -- Lagrave's Seal
	[12039]="0:4:2:1:Amulet::1:0:", -- Tundra Necklace
	[12040]="0:4:2:1:Amulet::1:0:", -- Forest Pendant
	[12041]="0:4:2:1:Leather::1:0:", -- Windshear Leggings
	[12042]="0:4:2:1:Amulet::1:0:", -- Marsh Chain
	[12043]="0:4:2:1:Amulet::1:0:", -- Desert Choker
	[12044]="0:4:2:1:Amulet::1:0:", -- Arctic Pendant
	[12045]="0:4:2:1:Amulet::1:0:", -- Swamp Pendant
	[12046]="0:4:2:1:Amulet::1:0:", -- Jungle Necklace
	[12047]="0:4:2:1:Amulet::1:0:", -- Spectral Necklace
	[12048]="0:4:2:1:Amulet::1:0:", -- Prismatic Pendant
	[12049]="0:4:2:1:Mail::1:0:", -- Splintsteel Armor
	[12050]="0:4:2:1:Cloth::1:0:", -- Hazecover Boots
	[12051]="0:4:2:1:Mail::1:0:", -- Brazen Gauntlets
	[12052]="0:4:2:1:Ring::1:0:", -- Ring of the Moon
	[12053]="0:4:2:1:Ring::1:0:", -- Volcanic Rock Ring
	[12054]="0:4:2:1:Ring::1:0:", -- Demon Band
	[12055]="0:4:2:1:Ring::1:0:", -- Stardust Band
	[12056]="0:4:2:1:Ring::1:0:", -- Ring of the Heavens
	[12057]="0:4:2:1:Ring::1:0:", -- Dragonscale Band
	[12058]="0:4:2:1:Ring::1:0:", -- Demonic Bone Ring
	[12059]="0:4:3:1:Amulet::1:0:", -- Conqueror's Medallion
	[12060]="0:12:1:1:::1:0:", -- Shindrell's Note
	[12061]="0:2:2:1:OneHandSword::1:0:", -- Blade of Reckoning
	[12062]="0:2:2:1:Dagger::1:0:", -- Skilled Fighting Blade
	[12064]="0:4:1:1:Cloth::1:0:", -- Gamemaster Hood
	[12065]="0:4:2:1:Trinket::1:0:", -- Ward of the Elements
	[12066]="0:4:2:1:Cloak::1:0:", -- Shaleskin Cape
	[12082]="0:4:2:1:Leather::1:0:", -- Wyrmhide Spaulders
	[12083]="0:4:2:1:Cloth::1:0:", -- Valconian Sash
	[12102]="0:4:2:1:Ring::1:0:", -- Ring of the Aristocrat
	[12103]="0:4:3:1:Amulet::1:0:", -- Star of Mystaria
	[12108]="0:4:2:1:Mail::1:0:", -- Basaltscale Armor
	[12109]="0:4:2:1:Cloth::1:0:", -- Azure Moon Amice
	[12110]="0:4:2:1:Cloak::1:0:", -- Raincaster Drape
	[12111]="0:4:2:1:Plate::1:0:", -- Lavaplate Gauntlets
	[12112]="0:4:2:1:Mail::1:0:", -- Crypt Demon Bracers
	[12113]="0:4:2:1:Cloak::1:0:", -- Sunborne Cape
	[12114]="0:4:2:1:Leather::1:0:", -- Nightfall Gloves
	[12115]="0:4:2:1:Plate::1:0:", -- Stalwart Clutch
	[12122]="0:15:2:1:Junk::1:0:", -- Kum'isha's Junk
	[12144]="0:15:1:1:Junk::1:0:", -- Eggscilloscope
	[12162]="3000:9:1:1:Blacksmithing::1:1:2843,3356,5512", -- Plans: Hardened Iron Shortsword
	[12163]="4400:9:1:1:Blacksmithing::1:1:2482", -- Plans: Moonsteel Broadsword
	[12164]="4400:9:1:1:Blacksmithing::1:1:1146,2483", -- Plans: Massive Iron Axe
	[12184]="0:7:1:20:Meat:185:1:0:", -- Raptor Flesh
	[12185]="0:4:2:1:Cloth::1:0:", -- Bloodsail Admiral's Hat
	[12190]="0:0:1:20:Potion::1:0:", -- Dreamless Sleep Potion
	[12191]="0:12:1:1:::1:0:", -- Silver Dawning's Lockbox
	[12192]="0:12:1:1:::1:0:", -- Mist Veil's Lockbox
	[12202]="0:7:1:20:Meat:185:1:0:", -- Tiger Meat
	[12203]="0:7:1:20:Meat:185:1:0:", -- Red Wolf Meat
	[12204]="0:7:1:20:Meat:185:1:0:", -- Heavy Kodo Meat
	[12205]="0:7:1:20:Meat:185:1:0:", -- White Spider Meat
	[12206]="0:7:1:20:Meat:185:1:0:", -- Tender Crab Meat
	[12207]="0:7:1:20:Meat:185:1:0:", -- Giant Egg
	[12208]="0:7:1:20:Meat:185:1:0:", -- Tender Wolf Meat
	[12209]="0:0:1:20:FoodDrink::1:0:", -- Lean Wolf Steak
	[12210]="0:0:1:20:FoodDrink::1:0:", -- Roast Raptor
	[12212]="0:0:1:20:FoodDrink::1:0:", -- Jungle Stew
	[12213]="0:0:1:20:FoodDrink::1:0:", -- Carrion Surprise
	[12214]="0:0:1:20:FoodDrink::1:0:", -- Mystery Stew
	[12215]="0:0:1:20:FoodDrink::1:0:", -- Heavy Kodo Stew
	[12216]="0:0:1:20:FoodDrink::1:0:", -- Spiced Chili Crab
	[12217]="0:0:1:20:FoodDrink::1:0:", -- Dragonbreath Chili
	[12218]="0:0:1:20:FoodDrink::1:0:", -- Monster Omelet
	[12219]="0:12:1:1:::1:0:", -- Unadorned Seal of Ascension
	[12220]="0:12:1:20:::1:0:", -- Intact Elemental Bracer
	[12223]="0:7:1:20:Meat:185:1:0:", -- Meaty Bat Wing
	[12224]="0:0:1:20:FoodDrink::1:0:", -- Crispy Bat Wing
	[12225]="0:2:1:1:FishingPole::1:0:", -- Blump Family Fishing Pole
	[12226]="25:9:1:1:Cooking::1:0:2118", -- Recipe: Crispy Bat Wing
	[12227]="1600:9:1:1:Cooking::1:1:12246", -- Recipe: Lean Wolf Steak
	[12228]="5000:9:1:1:Cooking::1:0:734,1148,2810,2821,4879,4897,12245", -- Recipe: Roast Raptor
	[12229]="5000:9:1:1:Cooking::1:0:7947,8145,12246", -- Recipe: Hot Wolf Ribs
	[12230]="0:12:1:20:::1:0:", -- Felwood Slime Sample
	[12231]="3000:9:1:1:Cooking::1:0:734,1148,12245", -- Recipe: Jungle Stew
	[12232]="5000:9:1:1:Cooking::1:0:989,4879,9636,12245", -- Recipe: Carrion Surprise
	[12233]="3000:9:1:1:Cooking::1:0:4897,8150,12246", -- Recipe: Mystery Stew
	[12234]="0:12:1:20:::1:0:", -- Corrupted Felwood Sample
	[12235]="0:12:1:20:::1:0:", -- Un'Goro Slime Sample
	[12236]="0:12:1:20:::1:0:", -- Pure Un'Goro Sample
	[12237]="0:12:1:20:::1:0:", -- Fine Crab Chunks
	[12238]="0:0:1:20:FoodDrink::1:0:", -- Darkshore Grouper
	[12239]="7000:9:1:1:Cooking::1:0:4879,4897,12246", -- Recipe: Dragonbreath Chili
	[12240]="7000:9:1:1:Cooking::1:0:8150,9636,12245", -- Recipe: Heavy Kodo Stew
	[12241]="0:12:1:20:::1:0:", -- Collected Dragon Egg
	[12242]="0:12:1:1:::1:0:", -- Sea Creature Bones
	[12243]="0:2:3:1:Polearm::1:0:", -- Smoldering Claw
	[12247]="28373:2:2:1:Dagger::1:1:225,3539,4235", -- Broad Bladed Knife
	[12248]="32030:2:2:1:Dagger::1:1:1146,2843,4888", -- Daring Dirk
	[12249]="30195:2:2:1:TwoHandAxe::1:1:225,3019,3539,4232,12045", -- Merciless Axe
	[12250]="40342:2:2:1:TwoHandAxe::1:1:1146,2483,4884,4888,12045", -- Midnight Axe
	[12251]="53897:2:2:1:Stave::1:1:2482,4884,19043", -- Big Stick
	[12252]="63095:2:2:1:Stave::1:1:2482,19238", -- Staff of Protection
	[12253]="17728:4:2:1:Cloak::1:1:8159,11874", -- Brilliant Red Cloak
	[12254]="22416:4:2:1:Cloak::1:1:8159,11874,12023", -- Well Oiled Cloak
	[12255]="34988:4:2:1:Cloth::1:1:984,3315", -- Pale Leggings
	[12256]="43828:4:2:1:Cloth::1:1:984,3316,4175", -- Cindercloth Leggings
	[12257]="19430:4:2:1:Mail::1:1:2845", -- Heavy Notched Belt
	[12259]="0:2:2:1:Dagger::1:0:", -- Glinting Steel Dagger
	[12260]="0:2:2:1:Dagger::1:0:", -- Searing Golden Blade
	[12261]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Searing Golden Blade
	[12262]="0:12:1:1:::1:0:", -- Empty Worg Pup Cage
	[12263]="0:12:1:1:::1:0:", -- Caged Worg Pup
	[12264]="0:15:1:1:Companion::1:0:", -- Worg Carrier
	[12282]="0:2:1:1:TwoHandAxe::1:0:", -- Worn Battleaxe
	[12283]="0:12:1:20:::1:0:", -- Broodling Essence
	[12284]="0:12:1:1:::1:0:", -- Draco-Incarcinatrix 900
	[12286]="0:12:1:1:::1:0:", -- Eggscilloscope Prototype
	[12287]="0:12:1:1:::1:0:", -- Collectronic Module
	[12288]="0:12:1:1:::1:0:", -- Encased Corrupt Ooze
	[12289]="0:12:1:1:::1:0:", -- Sea Turtle Remains
	[12291]="0:12:1:1:::1:0:", -- Merged Ooze Sample
	[12292]="0:12:1:1:::1:0:", -- Strangely Marked Box
	[12293]="0:12:1:1:::1:0:", -- Fine Gold Thread
	[12295]="0:4:2:1:Cloth::1:0:", -- Leggings of the People's Militia
	[12296]="0:2:2:1:Wand::1:0:", -- Spark of the People's Militia
	[12299]="0:4:1:1:Cloth::1:0:", -- Netted Gloves
	[12300]="0:12:1:1:::1:0:", -- Orb of Draconic Energy
	[12301]="0:13:1:1:::1:0:", -- Bamboo Cage Key
	[12302]="0:15:4:1:Mount::1:0:", -- Reins of the Ancient Frostsaber
	[12303]="0:15:4:1:Mount::1:0:", -- Reins of the Nightsaber
	[12323]="0:12:1:1:::1:0:", -- Unforged Seal of Ascension
	[12324]="0:12:1:1:::1:0:", -- Forged Seal of Ascension
	[12330]="0:15:4:1:Mount::1:0:", -- Horn of the Red Wolf
	[12334]="0:12:1:20:::1:0:", -- Frostmaul Shards
	[12335]="0:12:2:1:::1:0:", -- Gemstone of Smolderthorn
	[12336]="0:12:2:1:::1:0:", -- Gemstone of Spirestone
	[12337]="0:12:2:1:::1:0:", -- Gemstone of Bloodaxe
	[12339]="0:12:1:1:::1:0:", -- Vaelan's Gift
	[12341]="0:12:1:1:::1:0:", -- Blackwood Fruit Sample
	[12342]="0:12:1:1:::1:0:", -- Blackwood Grain Sample
	[12343]="0:12:1:1:::1:0:", -- Blackwood Nut Sample
	[12344]="0:4:3:1:Ring::1:0:", -- Seal of Ascension
	[12345]="0:12:1:1:::1:0:", -- Bijou's Belongings
	[12346]="0:12:1:1:::1:0:", -- Empty Cleansing Bowl
	[12347]="0:12:1:1:::1:0:", -- Filled Cleansing Bowl
	[12349]="0:12:1:1:::1:0:", -- Cliffspring River Sample
	[12350]="0:12:1:1:::1:0:", -- Empty Sampling Tube
	[12351]="0:15:4:1:Mount::1:0:", -- Horn of the Arctic Wolf
	[12352]="0:12:1:1:::1:0:", -- Doomrigger's Clasp
	[12353]="0:15:4:1:Mount::1:0:", -- White Stallion Bridle
	[12354]="0:15:4:1:Mount::1:0:", -- Palomino Bridle
	[12355]="0:12:1:1:::1:0:", -- Talisman of Corruption
	[12356]="0:12:1:20:::1:0:", -- Highperch Wyvern Egg
	[12358]="0:12:1:1:::1:0:", -- Darkstone Tablet
	[12359]="0:7:1:20:MetalStone:171,164,333,202,755,186:1:0:", -- Thorium Bar
	[12360]="0:7:2:20:MetalStone:164,202,755,186,197:1:0:", -- Arcanite Bar
	[12361]="0:3:2:20:GemSimple:164,202,755:1:0:", -- Blue Sapphire
	[12363]="0:3:2:20:GemSimple:171,755:1:0:", -- Arcane Crystal
	[12364]="0:3:2:20:GemSimple:164,202,755,197:1:0:", -- Huge Emerald
	[12365]="0:7:1:20:MetalStone:164,202,755:1:0:", -- Dense Stone
	[12366]="0:12:1:20:::1:0:", -- Thick Yeti Fur
	[12367]="0:12:1:20:::1:0:", -- Pristine Yeti Horn
	[12368]="0:12:1:1:::1:0:", -- Dawn's Gambit
	[12382]="0:13:2:1:::1:0:", -- Key to the City
	[12383]="0:12:1:20:::1:0:", -- Moontouched Feather
	[12384]="0:12:1:1:::1:0:", -- Cache of Mau'ari
	[12402]="0:12:1:1:::1:0:", -- Ancient Egg
	[12404]="0:0:1:20:EnhTemp::1:0:", -- Dense Sharpening Stone
	[12405]="0:4:2:1:Plate::1:0:", -- Thorium Armor
	[12406]="0:4:2:1:Plate::1:0:", -- Thorium Belt
	[12408]="0:4:2:1:Plate::1:0:", -- Thorium Bracers
	[12409]="0:4:2:1:Plate::1:0:", -- Thorium Boots
	[12410]="0:4:2:1:Plate::1:0:", -- Thorium Helm
	[12411]="0:12:1:1:::1:0:", -- Third Mosh'aru Tablet
	[12412]="0:12:1:1:::1:0:", -- Fourth Mosh'aru Tablet
	[12414]="0:4:2:1:Plate::1:0:", -- Thorium Leggings
	[12415]="0:4:2:1:Mail::1:0:", -- Radiant Breastplate
	[12416]="0:4:2:1:Mail::1:0:", -- Radiant Belt
	[12417]="0:4:2:1:Mail::1:0:", -- Radiant Circlet
	[12418]="0:4:2:1:Mail::1:0:", -- Radiant Gloves
	[12419]="0:4:2:1:Mail::1:0:", -- Radiant Boots
	[12420]="0:4:2:1:Mail::1:0:", -- Radiant Leggings
	[12422]="0:4:2:1:Plate::1:0:", -- Imperial Plate Chest
	[12424]="0:4:2:1:Plate::1:0:", -- Imperial Plate Belt
	[12425]="0:4:2:1:Plate::1:0:", -- Imperial Plate Bracers
	[12426]="0:4:2:1:Plate::1:0:", -- Imperial Plate Boots
	[12427]="0:4:2:1:Plate::1:0:", -- Imperial Plate Helm
	[12428]="0:4:2:1:Plate::1:0:", -- Imperial Plate Shoulders
	[12429]="0:4:2:1:Plate::1:0:", -- Imperial Plate Leggings
	[12430]="0:12:1:20:::1:0:", -- Frostsaber E'ko
	[12431]="0:12:1:20:::1:0:", -- Winterfall E'ko
	[12432]="0:12:1:20:::1:0:", -- Shardtooth E'ko
	[12433]="0:12:1:20:::1:0:", -- Wildkin E'ko
	[12434]="0:12:1:20:::1:0:", -- Chillwind E'ko
	[12435]="0:12:1:20:::1:0:", -- Ice Thistle E'ko
	[12436]="0:12:1:20:::1:0:", -- Frostmaul E'ko
	[12437]="0:12:1:1:::1:0:", -- Ridgewell's Crate
	[12438]="0:12:1:1:::1:0:", -- Tinkee's Letter
	[12444]="0:12:1:20:::1:0:", -- Uncracked Chillwind Horn
	[12445]="0:12:1:1:::1:0:", -- Felnok's Package
	[12446]="0:2:1:1:Gun::1:0:", -- Anvilmar Musket
	[12447]="0:2:1:1:Bow::1:0:", -- Thistlewood Bow
	[12448]="0:2:1:1:Gun::1:0:", -- Light Hunting Rifle
	[12449]="0:2:1:1:Bow::1:0:", -- Primitive Bow
	[12450]="0:12:1:20:::1:0:", -- Juju Flurry
	[12451]="0:12:1:20:::1:0:", -- Juju Power
	[12455]="0:12:1:20:::1:0:", -- Juju Ember
	[12457]="0:12:1:20:::1:0:", -- Juju Chill
	[12458]="0:12:1:20:::1:0:", -- Juju Guile
	[12459]="0:12:1:20:::1:0:", -- Juju Escape
	[12460]="0:12:1:20:::1:0:", -- Juju Might
	[12462]="0:4:4:1:Cloth::1:0:", -- Embrace of the Wind Serpent
	[12463]="0:2:3:1:TwoHandSword::1:0:", -- Drakefang Butcher
	[12464]="0:4:3:1:Leather::1:0:", -- Bloodfire Talons
	[12465]="0:4:3:1:Cloak::1:0:", -- Nightfall Drape
	[12466]="0:4:3:1:Cloth::1:0:", -- Dawnspire Cord
	[12467]="0:12:1:1:::1:0:", -- Alien Egg
	[12470]="0:4:3:1:Leather::1:0:", -- Sandstalker Ankleguards
	[12471]="0:4:3:1:OffHandFrill::1:0:", -- Desertwalker Cane
	[12472]="0:12:1:1:::1:0:", -- Krakle's Thermometer
	[12522]="0:4:2:1:Leather::1:0:", -- Bingles' Flying Gloves
	[12524]="0:12:1:1:::1:0:", -- Blue-feathered Amulet
	[12525]="0:12:1:1:::1:0:", -- Jaron's Supplies
	[12527]="0:2:3:1:OneHandAxe::1:0:", -- Ribsplitter
	[12528]="0:2:3:1:TwoHandMace::1:0:", -- The Judge's Gavel
	[12529]="0:15:1:1:Companion::1:0:", -- Smolderweb Carrier
	[12530]="0:12:1:20:::1:0:", -- Spire Spider Egg
	[12531]="0:2:3:1:Dagger::1:0:", -- Searing Needle
	[12532]="0:2:3:1:Stave::1:0:", -- Spire of the Stoneshaper
	[12533]="0:0:1:1:Consumable::1:0:", -- Roughshod Pike
	[12534]="0:12:1:1:::1:0:", -- Omokk's Head
	[12535]="0:2:3:1:OneHandSword::1:0:", -- Doomforged Straightedge
	[12542]="0:4:3:1:Cloth::1:0:", -- Funeral Pyre Vestment
	[12543]="0:4:3:1:Ring::1:0:", -- Songstone of Ironforge
	[12544]="0:4:3:1:Ring::1:0:", -- Thrall's Resolve
	[12545]="0:4:3:1:Ring::1:0:", -- Eye of Orgrimmar
	[12546]="0:4:3:1:Cloth::1:0:", -- Aristocratic Cuffs
	[12547]="0:4:3:1:Leather::1:0:", -- Mar Alom's Grip
	[12548]="0:4:3:1:Ring::1:0:", -- Magni's Will
	[12549]="0:4:3:1:Mail::1:0:", -- Braincage
	[12550]="0:4:3:1:Plate::1:0:", -- Runed Golem Shackles
	[12551]="0:4:3:1:Cloak::1:0:", -- Stoneshield Cloak
	[12552]="0:4:3:1:Cloak::1:0:", -- Blisterbane Wrap
	[12553]="0:4:3:1:Leather::1:0:", -- Swiftwalker Boots
	[12554]="0:4:3:1:Cloth::1:0:", -- Hands of the Exalted Herald
	[12555]="0:4:3:1:Plate::1:0:", -- Battlechaser's Greaves
	[12556]="0:4:3:1:Cloth::1:0:", -- High Priestess Boots
	[12557]="0:4:3:1:Plate::1:0:", -- Ebonsteel Spaulders
	[12558]="0:12:1:1:::1:0:", -- Blue-feathered Necklace
	[12562]="0:12:1:1:::1:0:", -- Important Blackrock Documents
	[12563]="0:12:1:1:::1:0:", -- Warlord Goretooth's Command
	[12564]="0:12:1:1:::1:0:", -- Assassination Note
	[12565]="0:15:1:1:Junk::1:0:", -- Winna's Kitten Carrier
	[12566]="0:12:1:1:::1:0:", -- Hardened Flasket
	[12567]="0:12:1:1:::1:0:", -- Filled Flasket
	[12582]="0:2:3:1:Dagger::1:0:", -- Keris of Zul'Serak
	[12583]="0:2:3:1:Polearm::1:0:", -- Blackhand Doomsaw
	[12584]="0:2:4:1:OneHandSword::1:0:", -- Grand Marshal's Longsword
	[12586]="0:0:1:50:Other::1:0:", -- Immature Venom Sac
	[12587]="0:4:3:1:Leather::1:0:", -- Eye of Rend
	[12588]="0:4:3:1:Mail::1:0:", -- Bonespike Shoulder
	[12589]="0:4:3:1:Cloth::1:0:", -- Dustfeather Sash
	[12590]="0:2:4:1:Dagger::1:0:", -- Felstriker
	[12592]="0:2:4:1:TwoHandSword::1:0:", -- Blackblade of Shahram
	[12602]="0:4:3:1:Shield::1:0:", -- Draconian Deflector
	[12603]="0:4:3:1:Leather::1:0:", -- Nightbrace Tunic
	[12604]="0:4:3:1:Cloth::1:0:", -- Starfire Tiara
	[12605]="0:2:3:1:Wand::1:0:", -- Serpentine Skuller
	[12606]="0:4:3:1:Leather::1:0:", -- Crystallized Girdle
	[12607]="0:12:3:20::165:1:0:", -- Brilliant Chromatic Scale
	[12608]="0:4:3:1:Cloak::1:0:", -- Butcher's Apron
	[12609]="0:4:3:1:Cloth::1:0:", -- Polychromatic Visionwrap
	[12610]="0:4:2:1:Plate::1:0:", -- Runic Plate Shoulders
	[12611]="0:4:2:1:Plate::1:0:", -- Runic Plate Boots
	[12612]="0:4:2:1:Plate::1:0:", -- Runic Plate Helm
	[12613]="0:4:2:1:Plate::1:0:", -- Runic Breastplate
	[12614]="0:4:2:1:Plate::1:0:", -- Runic Plate Leggings
	[12618]="0:4:3:1:Plate::1:0:", -- Enchanted Thorium Breastplate
	[12619]="0:4:3:1:Plate::1:0:", -- Enchanted Thorium Leggings
	[12620]="0:4:3:1:Plate::1:0:", -- Enchanted Thorium Helm
	[12621]="0:2:3:1:OneHandAxe::1:0:", -- Demonfork
	[12622]="0:12:1:10:::1:0:", -- Shardtooth Meat
	[12623]="0:12:1:10:::1:0:", -- Chillwind Meat
	[12624]="0:4:3:1:Mail::1:0:", -- Wildthorn Mail
	[12625]="0:4:3:1:Plate::1:0:", -- Dawnbringer Shoulders
	[12626]="0:4:3:1:Cloth::1:0:", -- Funeral Cuffs
	[12627]="0:12:1:1:::1:0:", -- Temporal Displacer
	[12628]="0:4:3:1:Plate::1:0:", -- Demon Forged Breastplate
	[12630]="0:12:1:1:::1:0:", -- Head of Rend Blackhand
	[12631]="0:4:3:1:Plate::1:0:", -- Fiery Plate Gauntlets
	[12632]="0:4:3:1:Mail::1:0:", -- Storm Gauntlets
	[12633]="0:4:3:1:Plate::1:0:", -- Whitesoul Helm
	[12634]="0:4:3:1:Mail::1:0:", -- Chiselbrand Girdle
	[12635]="0:12:1:1:::1:0:", -- Simple Parchment
	[12636]="0:4:3:1:Mail::1:0:", -- Helm of the Great Chief
	[12637]="0:4:3:1:Plate::1:0:", -- Backusarian Gauntlets
	[12638]="0:12:1:20:::1:0:", -- Andorhal Watch
	[12639]="0:4:4:1:Plate::1:0:", -- Stronghold Gauntlets
	[12640]="0:4:4:1:Plate::1:0:", -- Lionheart Helm
	[12641]="0:4:4:1:Mail::1:0:", -- Invulnerable Mail
	[12642]="0:12:1:1:::1:0:", -- Cleansed Infernal Orb
	[12643]="0:0:1:20:EnhTemp::1:0:", -- Dense Weightstone
	[12644]="0:7:1:20:MetalStone:164:1:0:", -- Dense Grinding Stone
	[12645]="0:0:2:5:EnhPerm::1:0:", -- Thorium Shield Spike
	[12646]="0:12:1:1:::1:0:", -- Infus Emerald
	[12647]="0:12:1:1:::1:0:", -- Felhas Ruby
	[12648]="0:12:1:1:::1:0:", -- Imprisoned Felhound Spirit
	[12649]="0:12:1:1:::1:0:", -- Imprisoned Infernal Spirit
	[12650]="0:0:1:1:Consumable::1:0:", -- Attuned Dampener
	[12651]="0:2:3:1:Crossbow::1:0:", -- Blackcrow
	[12652]="0:12:1:1:::1:0:", -- Bijou's Reconnaissance Report
	[12653]="0:2:3:1:Bow::1:0:", -- Riphook
	[12654]="0:6:3:1000:Arrow::1:0:", -- Doomshot
	[12655]="0:7:1:20:MetalStone:164:1:0:", -- Enchanted Thorium Bar
	[12662]="0:7:2:20:Other:164,755,197:1:0:", -- Demonic Rune
	[12663]="0:12:1:1:::1:0:", -- Glyphed Oaken Branch
	[12682]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Thorium Armor
	[12683]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Thorium Belt
	[12684]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Thorium Bracers
	[12685]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Radiant Belt
	[12687]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Imperial Plate Shoulders
	[12688]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Imperial Plate Belt
	[12689]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Radiant Breastplate
	[12690]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Imperial Plate Bracers
	[12691]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Wildthorn Mail
	[12692]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Thorium Shield Spike
	[12693]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Thorium Boots
	[12694]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Thorium Helm
	[12695]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Radiant Gloves
	[12696]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Demon Forged Breastplate
	[12697]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Radiant Boots
	[12698]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Dawnbringer Shoulders
	[12699]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Fiery Plate Gauntlets
	[12700]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Imperial Plate Boots
	[12701]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Imperial Plate Helm
	[12702]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Radiant Circlet
	[12703]="40000:9:3:1:Blacksmithing::1:0:11278", -- Plans: Storm Gauntlets
	[12704]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Thorium Leggings
	[12705]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Imperial Plate Chest
	[12706]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Runic Plate Shoulders
	[12707]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Runic Plate Boots
	[12708]="0:12:1:1:::1:0:", -- Crossroads' Supply Crates
	[12709]="0:2:3:1:Dagger::1:0:", -- Finkle's Skinner
	[12710]="0:12:1:1:::1:0:", -- Glowing Hunk of the Beast's Flesh
	[12711]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Whitesoul Helm
	[12712]="0:0:1:1:Consumable::1:0:", -- Warosh's Mojo
	[12713]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Radiant Leggings
	[12714]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Runic Plate Helm
	[12715]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Imperial Plate Leggings
	[12716]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Helm of the Great Chief
	[12717]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Lionheart Helm
	[12718]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Runic Breastplate
	[12719]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Runic Plate Leggings
	[12720]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Stronghold Gauntlets
	[12721]="0:12:1:1:::1:0:", -- Good Luck Half-Charm
	[12722]="0:12:1:1:::1:0:", -- Good Luck Other-Half-Charm
	[12723]="0:12:1:1:::1:0:", -- Good Luck Charm
	[12724]="0:12:1:1:::1:0:", -- Janice's Parcel
	[12725]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Enchanted Thorium Helm
	[12726]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Enchanted Thorium Leggings
	[12727]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Enchanted Thorium Breastplate
	[12728]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Invulnerable Mail
	[12730]="0:12:1:1:::1:0:", -- Warosh's Scroll
	[12731]="0:12:4:1:::1:0:", -- Pristine Hide of the Beast
	[12732]="0:12:1:20:::1:0:", -- Incendia Agave
	[12733]="0:12:1:1:::1:0:", -- Sacred Frostsaber Meat
	[12734]="0:12:1:10:::1:0:", -- Enchanted Scarlet Thread
	[12735]="0:12:2:20:::1:0:", -- Frayed Abomination Stitching
	[12736]="0:12:1:10:::1:0:", -- Frostwhisper's Embalming Fluid
	[12737]="0:12:1:20:::1:0:", -- Gloom Weed
	[12738]="0:13:1:1:::1:0:", -- Dalson Outhouse Key
	[12739]="0:13:1:1:::1:0:", -- Dalson Cabinet Key
	[12740]="0:12:1:1:::1:0:", -- Fifth Mosh'aru Tablet
	[12741]="0:12:1:1:::1:0:", -- Sixth Mosh'aru Tablet
	[12752]="0:4:4:1:Cloth::1:0:", -- Cap of the Scarlet Savant
	[12753]="0:12:2:10::164,165:1:0:", -- Skin of Shadow
	[12756]="0:4:4:1:Leather::1:0:", -- Leggings of Arcana
	[12757]="0:4:4:1:Leather::1:0:", -- Breastplate of Bloodthirst
	[12764]="0:2:2:1:TwoHandSword::1:0:", -- Thorium Greatsword
	[12765]="0:12:1:1:::1:0:", -- Secret Note #1
	[12766]="0:12:1:1:::1:0:", -- Secret Note #2
	[12768]="0:12:1:1:::1:0:", -- Secret Note #3
	[12769]="0:2:3:1:TwoHandAxe::1:0:", -- Bleakwood Hew
	[12770]="0:12:1:1:::1:0:", -- Bijou's Information
	[12771]="0:12:1:1:::1:0:", -- Empty Firewater Flask
	[12772]="0:2:2:1:TwoHandMace::1:0:", -- Inlaid Thorium Hammer
	[12773]="0:2:2:1:OneHandAxe::1:0:", -- Ornate Thorium Handaxe
	[12774]="0:2:3:1:OneHandAxe::1:0:", -- Dawn's Edge
	[12775]="0:2:2:1:TwoHandAxe::1:0:", -- Huge Thorium Battleaxe
	[12776]="0:2:3:1:TwoHandMace::1:0:", -- Enchanted Battlehammer
	[12777]="0:2:3:1:OneHandSword::1:0:", -- Blazing Rapier
	[12779]="0:2:2:1:OneHandAxe::1:0:", -- Rune Edge
	[12780]="0:12:1:1:::1:0:", -- General Drakkisath's Command
	[12781]="0:2:3:1:OneHandMace::1:0:", -- Serenity
	[12782]="0:2:3:1:TwoHandSword::1:0:", -- Corruption
	[12783]="0:2:3:1:Dagger::1:0:", -- Heartseeker
	[12784]="0:2:3:1:TwoHandAxe::1:0:", -- Arcanite Reaper
	[12785]="0:12:1:1:::1:0:", -- Incendia Powder
	[12790]="0:2:3:1:TwoHandSword::1:0:", -- Arcanite Champion
	[12791]="0:2:3:1:Dagger::1:0:", -- Barman Shanker
	[12792]="0:2:2:1:OneHandMace::1:0:", -- Volcanic Hammer
	[12793]="0:4:3:1:Leather::1:0:", -- Mixologist's Tunic
	[12794]="0:2:3:1:OneHandMace::1:0:", -- Masterwork Stormhammer
	[12795]="0:2:3:1:FistWeapon::1:0:", -- Blood Talon
	[12796]="0:2:3:1:TwoHandMace::1:0:", -- Hammer of the Titans
	[12797]="0:2:3:1:OneHandSword::1:0:", -- Frostguard
	[12798]="0:2:3:1:OneHandAxe::1:0:", -- Annihilator
	[12799]="0:3:2:20:GemSimple:164,202,755:1:0:", -- Large Opal
	[12800]="0:3:2:20:GemSimple:164,202,755,197:1:0:", -- Azerothian Diamond
	[12802]="0:2:3:1:Polearm::1:0:", -- Darkspear
	[12803]="0:7:2:10:Elemental:171,164,333,202,755,165,197:1:0:", -- Living Essence
	[12804]="0:7:1:20:Other:171,164,202,755,165,197:1:0:", -- Powerful Mojo
	[12806]="0:12:3:1:::1:0:", -- Unforged Rune Covered Breastplate
	[12807]="0:12:1:1:::1:0:", -- Scourge Banner
	[12808]="0:7:2:10:Elemental:171,164,185,333,202,755,197:1:0:", -- Essence of Undeath
	[12809]="0:7:2:20:MetalStone:164,165,197:1:0:", -- Guardian Stone
	[12810]="2000:7:1:20:Leather:164,202,165,197:1:1:14846", -- Enchanted Leather
	[12811]="0:7:2:20:Other:164,333,197:1:0:", -- Righteous Orb
	[12812]="0:12:3:1:::1:0:", -- Unfired Plate Gauntlets
	[12813]="0:12:1:1:::1:0:", -- Flask of Mystery Goo
	[12814]="0:12:1:1:::1:0:", -- Flame in a Bottle
	[12815]="0:12:1:1:::1:0:", -- Beacon Torch
	[12819]="16000:9:2:1:Blacksmithing::1:0:11278", -- Plans: Ornate Thorium Handaxe
	[12820]="0:0:1:10:Elixir::1:0:", -- Winterfall Firewater
	[12821]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Dawn's Edge
	[12822]="0:12:1:20:::1:0:", -- Toxic Horror Droplet
	[12823]="20000:9:1:1:Blacksmithing::1:0:11278", -- Plans: Huge Thorium Battleaxe
	[12824]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Enchanted Battlehammer
	[12825]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Blazing Rapier
	[12827]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Serenity
	[12828]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Volcanic Hammer
	[12829]="0:12:1:1:::1:0:", -- Winterfall Crate
	[12830]="0:9:1:1:Blacksmithing::1:0:", -- Plans: Corruption
	[12833]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Hammer of the Titans
	[12834]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Arcanite Champion
	[12835]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Annihilator
	[12836]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Frostguard
	[12837]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Masterwork Stormhammer
	[12838]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Arcanite Reaper
	[12839]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Heartseeker
	[12840]="0:12:1:250:::1:0:", -- Minion's Scourgestone
	[12841]="0:12:1:250:::1:0:", -- Invader's Scourgestone
	[12842]="0:12:1:1:::1:0:", -- Crudely-written Log
	[12843]="0:12:2:250:::1:0:", -- Corruptor's Scourgestone
	[12844]="0:12:2:250:::1:0:", -- Argent Dawn Valor Token
	[12845]="0:12:1:1:::1:0:", -- Medallion of Faith
	[12846]="0:4:1:1:Trinket::1:0:", -- Argent Dawn Commission
	[12847]="0:12:1:1:::1:0:", -- Soul Stained Pike
	[12848]="0:12:1:1:::1:0:", -- Blood Stained Pike
	[12849]="0:12:2:1:::1:0:", -- Demon Kissed Sack
	[12871]="0:15:4:1:Junk::1:0:", -- Chromatic Carapace
	[12884]="0:0:1:1:Consumable::1:0:", -- Arnak's Hoof
	[12885]="0:0:1:1:Consumable::1:0:", -- Pamela's Doll
	[12886]="0:0:1:1:Consumable::1:0:", -- Pamela's Doll's Head
	[12887]="0:12:1:1:::1:0:", -- Pamela's Doll's Left Side
	[12888]="0:12:1:1:::1:0:", -- Pamela's Doll's Right Side
	[12891]="0:12:1:1:::1:0:", -- Jaron's Pick
	[12894]="0:0:1:1:Consumable::1:0:", -- Joseph's Wedding Ring
	[12895]="0:4:4:1:Plate::1:0:", -- Breastplate of the Chromatic Flight
	[12896]="0:12:1:1:::1:0:", -- First Relic Fragment
	[12897]="0:12:1:1:::1:0:", -- Second Relic Fragment
	[12898]="0:12:1:1:::1:0:", -- Third Relic Fragment
	[12899]="0:12:1:1:::1:0:", -- Fourth Relic Fragment
	[12900]="0:12:1:1:::1:0:", -- Annals of Darrowshire
	[12903]="0:4:4:1:Mail::1:0:", -- Legguards of the Chromatic Defier
	[12905]="0:4:3:1:Cloak::1:0:", -- Wildfire Cape
	[12906]="0:12:1:1:::1:0:", -- Purified Moonwell Water
	[12907]="0:12:1:1:::1:0:", -- Corrupt Moonwell Water
	[12922]="0:0:1:1:Consumable::1:0:", -- Empty Canteen
	[12923]="0:12:1:1:::1:0:", -- Awbee's Scale
	[12924]="0:0:1:5:Consumable::1:0:", -- Ritual Candle
	[12925]="0:12:1:1:::1:0:", -- Arikara Serpent Skin
	[12926]="0:4:3:1:Ring::1:0:", -- Flaming Band
	[12927]="0:4:3:1:Leather::1:0:", -- Truestrike Shoulders
	[12928]="0:12:1:1:::1:0:", -- Umi's Mechanical Yeti
	[12929]="0:4:3:1:Amulet::1:0:", -- Emberfury Talisman
	[12930]="0:4:3:1:Trinket::1:0:", -- Briarwood Reed
	[12935]="0:4:3:1:Plate::1:0:", -- Warmaster Legguards
	[12936]="0:4:3:1:Plate::1:0:", -- Battleborn Armbraces
	[12938]="0:12:1:20::171,755:1:0:", -- Blood of Heroes
	[12939]="0:2:3:1:OneHandSword::1:0:", -- Dal'Rend's Tribal Guardian
	[12940]="0:2:3:1:OneHandSword::1:0:", -- Dal'Rend's Sacred Charge
	[12942]="0:13:1:1:::1:0:", -- Panther Cage Key
	[12945]="0:4:4:1:Mail::1:0:", -- Legplates of the Chromatic Defier
	[12946]="0:12:1:1:::1:0:", -- Hypercapacitor Gizmo
	[12947]="0:4:6:1:Ring::1:0:", -- Alex's Ring of Audacity
	[12952]="0:4:3:1:Plate::1:0:", -- Gyth's Skull
	[12953]="0:4:3:1:Mail::1:0:", -- Dragoneye Coif
	[12954]="0:12:1:1:::1:0:", -- Davil's Libram
	[12955]="0:12:1:1:::1:0:", -- Redpath's Shield
	[12956]="0:12:1:1:::1:0:", -- Skull of Horgus
	[12957]="0:12:1:1:::1:0:", -- Shattered Sword of Marduk
	[12958]="50000:9:1:1:Alchemy::1:0:5594", -- Recipe: Transmute Arcanite
	[12960]="0:4:3:1:Leather::1:0:", -- Tribal War Feathers
	[12963]="0:4:3:1:Leather::1:0:", -- Blademaster Leggings
	[12964]="0:4:3:1:Mail::1:0:", -- Tristam Legguards
	[12965]="0:4:3:1:Cloth::1:0:", -- Spiritshroud Leggings
	[12966]="0:4:3:1:Leather::1:0:", -- Blackmist Armguards
	[12967]="0:4:3:1:Cloak::1:0:", -- Bloodmoon Cloak
	[12968]="0:4:3:1:Cloak::1:0:", -- Frostweaver Cape
	[12969]="0:2:3:1:TwoHandMace::1:0:", -- Seeping Willow
	[12973]="0:15:1:1:Junk::1:0:", -- Scarlet Cannonball
	[12974]="0:2:3:1:OneHandSword::1:0:", -- The Black Knight
	[12975]="0:2:3:1:TwoHandAxe::1:0:", -- Prospector Axe
	[12976]="0:2:3:1:OneHandSword::1:0:", -- Ironpatch Blade
	[12977]="0:4:3:1:Cloth::1:0:", -- Magefist Gloves
	[12978]="0:4:3:1:Mail::1:0:", -- Stormbringer Belt
	[12979]="0:4:3:1:Cloak::1:0:", -- Firebane Cloak
	[12982]="0:4:3:1:Mail::1:0:", -- Silver-linked Footguards
	[12983]="0:2:3:1:TwoHandMace::1:0:", -- Rakzur Club
	[12984]="0:2:3:1:Wand::1:0:", -- Skycaller
	[12985]="0:4:3:1:Ring::1:0:", -- Ring of Defense
	[12987]="0:4:3:1:Cloth::1:0:", -- Darkweave Breeches
	[12988]="0:4:3:1:Leather::1:0:", -- Starsight Tunic
	[12989]="0:2:3:1:Polearm::1:0:", -- Gargoyle's Bite
	[12990]="0:2:3:1:OneHandAxe::1:0:", -- Razor's Edge
	[12992]="0:2:3:1:TwoHandSword::1:0:", -- Searing Blade
	[12994]="0:4:3:1:Mail::1:0:", -- Thorbia's Gauntlets
	[12996]="0:4:3:1:Ring::1:0:", -- Band of Purification
	[12997]="0:4:3:1:Shield::1:0:", -- Redbeard Crest
	[12998]="0:4:3:1:Cloth::1:0:", -- Magician's Mantle
	[12999]="0:4:3:1:Leather::1:0:", -- Drakewing Bands
	[13000]="0:2:3:1:Stave::1:0:", -- Staff of Hale Magefire
	[13001]="0:4:3:1:Ring::1:0:", -- Maiden's Circle
	[13002]="0:4:3:1:Amulet::1:0:", -- Lady Alizabeth's Pendant
	[13003]="0:2:3:1:TwoHandAxe::1:0:", -- Lord Alexander's Battle Axe
	[13004]="0:2:3:1:Wand::1:0:", -- Torch of Austen
	[13005]="0:4:3:1:Cloak::1:0:", -- Amy's Blanket
	[13006]="0:2:3:1:OneHandMace::1:0:", -- Mass of McGowan
	[13007]="0:4:3:1:Cloak::1:0:", -- Mageflame Cloak
	[13008]="0:4:3:1:Cloth::1:0:", -- Dalewind Trousers
	[13009]="0:4:3:1:Leather::1:0:", -- Cow King's Hide
	[13010]="0:4:3:1:Mail::1:0:", -- Dreamsinger Legguards
	[13011]="0:4:3:1:Leather::1:0:", -- Silver-lined Belt
	[13012]="0:4:3:1:Mail::1:0:", -- Yorgen Bracers
	[13013]="0:4:3:1:Cloth::1:0:", -- Elder Wizard's Mantle
	[13014]="0:2:3:1:OneHandAxe::1:0:", -- Axe of Rin'ji
	[13015]="0:2:3:1:OneHandAxe::1:0:", -- Serathil
	[13016]="0:2:3:1:TwoHandAxe::1:0:", -- Killmaim
	[13017]="0:2:3:1:TwoHandAxe::1:0:", -- Hellslayer Battle Axe
	[13018]="0:2:3:1:TwoHandAxe::1:0:", -- Executioner's Cleaver
	[13019]="0:2:3:1:Bow::1:0:", -- Harpyclaw Short Bow
	[13020]="0:2:3:1:Bow::1:0:", -- Skystriker Bow
	[13021]="0:2:3:1:Bow::1:0:", -- Needle Threader
	[13022]="0:2:3:1:Bow::1:0:", -- Gryphonwing Long Bow
	[13023]="0:2:3:1:Bow::1:0:", -- Eaglehorn Long Bow
	[13024]="0:2:3:1:OneHandMace::1:0:", -- Beazel's Basher
	[13025]="0:2:3:1:OneHandMace::1:0:", -- Deadwood Sledge
	[13026]="0:2:3:1:OneHandMace::1:0:", -- Heaven's Light
	[13027]="0:2:3:1:OneHandMace::1:0:", -- Bonesnapper
	[13028]="0:2:3:1:OneHandMace::1:0:", -- Bludstone Hammer
	[13029]="0:4:3:1:OffHandFrill::1:0:", -- Umbral Crystal
	[13030]="0:4:3:1:OffHandFrill::1:0:", -- Basilisk Bone
	[13031]="0:4:3:1:OffHandFrill::1:0:", -- Orb of Mistmantle
	[13032]="0:2:3:1:OneHandSword::1:0:", -- Sword of Corruption
	[13033]="0:2:3:1:OneHandSword::1:0:", -- Zealot Blade
	[13034]="0:2:3:1:OneHandSword::1:0:", -- Speedsteel Rapier
	[13035]="0:2:3:1:OneHandSword::1:0:", -- Serpent Slicer
	[13036]="0:2:3:1:OneHandSword::1:0:", -- Assassination Blade
	[13037]="0:2:3:1:Crossbow::1:0:", -- Crystalpine Stinger
	[13038]="0:2:3:1:Crossbow::1:0:", -- Swiftwind
	[13039]="0:2:3:1:Crossbow::1:0:", -- Skull Splitting Crossbow
	[13040]="0:2:3:1:Crossbow::1:0:", -- Heartseeking Crossbow
	[13041]="0:2:3:1:TwoHandSword::1:0:", -- Guardian Blade
	[13042]="0:2:3:1:TwoHandSword::1:0:", -- Sword of the Magistrate
	[13043]="0:2:3:1:TwoHandSword::1:0:", -- Blade of the Titans
	[13044]="0:2:3:1:TwoHandSword::1:0:", -- Demonslayer
	[13045]="0:2:3:1:TwoHandMace::1:0:", -- Viscous Hammer
	[13046]="0:2:3:1:TwoHandMace::1:0:", -- Blanchard's Stout
	[13047]="0:2:3:1:TwoHandMace::1:0:", -- Twig of the World Tree
	[13048]="0:2:3:1:OneHandMace::1:0:", -- Looming Gavel
	[13049]="0:2:3:1:TwoHandSword::1:0:", -- Deanship Claymore
	[13051]="0:2:3:1:TwoHandSword::1:0:", -- Witchfury
	[13052]="0:2:3:1:TwoHandSword::1:0:", -- Warmonger
	[13053]="0:2:3:1:TwoHandSword::1:0:", -- Doombringer
	[13054]="0:2:3:1:Polearm::1:0:", -- Grim Reaper
	[13055]="0:2:3:1:Polearm::1:0:", -- Bonechewer
	[13056]="0:2:3:1:Polearm::1:0:", -- Frenzied Striker
	[13057]="0:2:3:1:Polearm::1:0:", -- Bloodpike
	[13058]="0:2:3:1:Polearm::1:0:", -- Khoo's Point
	[13059]="0:2:3:1:Polearm::1:0:", -- Stoneraven
	[13060]="0:2:3:1:Polearm::1:0:", -- The Needler
	[13062]="0:2:3:1:Wand::1:0:", -- Thunderwood
	[13063]="0:2:3:1:Wand::1:0:", -- Starfaller
	[13064]="0:2:3:1:Wand::1:0:", -- Jaina's Firestarter
	[13065]="0:2:3:1:Wand::1:0:", -- Wand of Allistarj
	[13066]="0:4:3:1:Plate::1:0:", -- Wyrmslayer Spaulders
	[13067]="0:4:3:1:Plate::1:0:", -- Hydralick Armor
	[13068]="0:4:3:1:Plate::1:0:", -- Obsidian Greaves
	[13070]="0:4:3:1:Plate::1:0:", -- Sapphiron's Scale Boots
	[13071]="0:4:3:1:Plate::1:0:", -- Plated Fist of Hakoo
	[13072]="0:4:3:1:Plate::1:0:", -- Stonegrip Gauntlets
	[13073]="0:4:3:1:Plate::1:0:", -- Mugthol's Helm
	[13074]="0:4:3:1:Plate::1:0:", -- Golem Shard Leggings
	[13075]="0:4:3:1:Plate::1:0:", -- Direwing Legguards
	[13076]="0:4:3:1:Plate::1:0:", -- Giantslayer Bracers
	[13077]="0:4:3:1:Plate::1:0:", -- Girdle of Uther
	[13079]="0:4:3:1:Shield::1:0:", -- Shield of Thorsen
	[13081]="0:4:3:1:Shield::1:0:", -- Skullance Shield
	[13082]="0:4:3:1:Shield::1:0:", -- Mountainside Buckler
	[13083]="0:4:3:1:Shield::1:0:", -- Garrett Family Crest
	[13084]="0:4:3:1:Amulet::1:0:", -- Kaleidoscope Chain
	[13085]="0:4:3:1:Amulet::1:0:", -- Horizon Choker
	[13086]="1000000:15:4:1:Mount::1:0:10618", -- Reins of the Winterspring Frostsaber
	[13087]="0:4:3:1:Amulet::1:0:", -- River Pride Choker
	[13088]="0:4:3:1:Amulet::1:0:", -- Gazlowe's Charm
	[13089]="0:4:3:1:Amulet::1:0:", -- Skibi's Pendant
	[13091]="0:4:3:1:Amulet::1:0:", -- Medallion of Grand Marshal Morris
	[13093]="0:4:3:1:Ring::1:0:", -- Blush Ember Ring
	[13094]="0:4:3:1:Ring::1:0:", -- The Queen's Jewel
	[13095]="0:4:3:1:Ring::1:0:", -- Assault Band
	[13096]="0:4:3:1:Ring::1:0:", -- Band of the Hierophant
	[13097]="0:4:3:1:Ring::1:0:", -- Thunderbrow Ring
	[13098]="0:4:3:1:Ring::1:0:", -- Painweaver Band
	[13099]="0:4:3:1:Cloth::1:0:", -- Moccasins of the White Hare
	[13100]="0:4:3:1:Cloth::1:0:", -- Furen's Boots
	[13101]="0:4:3:1:Cloth::1:0:", -- Wolfrunner Shoes
	[13102]="0:4:3:1:Cloth::1:0:", -- Cassandra's Grace
	[13103]="0:4:3:1:Cloth::1:0:", -- Pads of the Venom Spider
	[13105]="0:4:3:1:Cloth::1:0:", -- Sutarn's Ring
	[13106]="0:4:3:1:Cloth::1:0:", -- Glowing Magical Bracelets
	[13107]="0:4:3:1:Cloth::1:0:", -- Magiskull Cuffs
	[13108]="0:4:3:1:Cloak::1:0:", -- Tigerstrike Mantle
	[13109]="0:4:3:1:Cloak::1:0:", -- Blackflame Cape
	[13110]="0:4:3:1:Leather::1:0:", -- Wolffear Harness
	[13111]="0:4:3:1:Leather::1:0:", -- Sandals of the Insurgent
	[13112]="0:4:3:1:Leather::1:0:", -- Winged Helm
	[13113]="0:4:3:1:Leather::1:0:", -- Feathermoon Headdress
	[13114]="0:4:3:1:Leather::1:0:", -- Troll's Bane Leggings
	[13115]="0:4:3:1:Leather::1:0:", -- Sheepshear Mantle
	[13116]="0:4:3:1:Leather::1:0:", -- Spaulders of the Unseen
	[13117]="0:4:3:1:Leather::1:0:", -- Ogron's Sash
	[13118]="0:4:3:1:Leather::1:0:", -- Serpentine Sash
	[13119]="0:4:3:1:Leather::1:0:", -- Enchanted Kodo Bracers
	[13120]="0:4:3:1:Leather::1:0:", -- Deepfury Bracers
	[13121]="0:4:3:1:Cloak::1:0:", -- Wing of the Whelpling
	[13122]="0:4:3:1:Cloak::1:0:", -- Dark Phantom Cape
	[13123]="0:4:3:1:Mail::1:0:", -- Dreamwalker Armor
	[13124]="0:4:3:1:Mail::1:0:", -- Ravasaur Scale Boots
	[13125]="0:4:3:1:Mail::1:0:", -- Elven Chain Boots
	[13126]="0:4:3:1:Mail::1:0:", -- Battlecaller Gauntlets
	[13127]="0:4:3:1:Mail::1:0:", -- Frostreaver Crown
	[13128]="0:4:3:1:Mail::1:0:", -- High Bergg Helm
	[13129]="0:4:3:1:Mail::1:0:", -- Firemane Leggings
	[13130]="0:4:3:1:Mail::1:0:", -- Windrunner Legguards
	[13131]="0:4:3:1:Mail::1:0:", -- Sparkleshell Mantle
	[13132]="0:4:3:1:Mail::1:0:", -- Skeletal Shoulders
	[13133]="0:4:3:1:Mail::1:0:", -- Drakesfire Epaulets
	[13134]="0:4:3:1:Mail::1:0:", -- Belt of the Gladiator
	[13135]="0:4:3:1:Mail::1:0:", -- Lordly Armguards
	[13136]="0:2:3:1:Gun::1:0:", -- Lil Timmy's Peashooter
	[13137]="0:2:3:1:Gun::1:0:", -- Ironweaver
	[13138]="0:2:3:1:Gun::1:0:", -- The Silencer
	[13139]="0:2:3:1:Gun::1:0:", -- Guttbuster
	[13140]="0:13:1:1:::1:0:", -- Blood Red Key
	[13141]="0:4:3:1:Amulet::1:0:", -- Tooth of Gnarr
	[13142]="0:4:3:1:Plate::1:0:", -- Brigam Girdle
	[13143]="0:4:4:1:Ring::1:0:", -- Mark of the Dragon Lord
	[13144]="0:4:3:1:Cloth::1:0:", -- Serenity Belt
	[13145]="0:4:3:1:Plate::1:0:", -- Enormous Ogre Belt
	[13146]="0:2:3:1:Gun::1:0:", -- Shell Launcher Shotgun
	[13148]="0:2:3:1:Polearm::1:0:", -- Chillpike
	[13155]="0:0:1:20:Consumable::1:0:", -- Resonating Skull
	[13156]="0:0:1:1:Consumable::1:0:", -- Mystic Crystal
	[13157]="0:12:1:20:::1:0:", -- Fetid Skull
	[13158]="0:12:1:1:::1:0:", -- Words of the High Chief
	[13159]="0:12:1:20:::1:0:", -- Bone Dust
	[13161]="0:2:3:1:Stave::1:0:", -- Trindlehaven Staff
	[13162]="0:4:3:1:Plate::1:0:", -- Reiver Claws
	[13163]="0:2:3:1:TwoHandSword::1:0:", -- Relentless Scythe
	[13164]="0:4:3:1:Trinket::1:0:", -- Heart of the Scale
	[13166]="0:4:3:1:Plate::1:0:", -- Slamshot Shoulders
	[13167]="0:2:3:1:TwoHandMace::1:0:", -- Fist of Omokk
	[13168]="0:4:3:1:Plate::1:0:", -- Plate of the Shaman King
	[13169]="0:4:3:1:Leather::1:0:", -- Tressermane Leggings
	[13170]="0:4:3:1:Cloth::1:0:", -- Skyshroud Leggings
	[13171]="0:4:2:1:Trinket::1:0:", -- Smokey's Lighter
	[13172]="0:12:1:1:::1:0:", -- Siabi's Premium Tobacco
	[13173]="0:15:3:200:Junk::1:0:", -- Broken Flightblade Throwing Axe
	[13174]="0:12:1:30:::1:0:", -- Plagued Flesh Sample
	[13175]="0:2:2:1:Bow::1:0:", -- Voone's Twitchbow
	[13176]="0:12:1:1:::1:0:", -- Scourge Data
	[13177]="0:4:3:1:Amulet::1:0:", -- Talisman of Evasion
	[13178]="0:4:3:1:Ring::1:0:", -- Rosewine Circle
	[13179]="0:4:3:1:Mail::1:0:", -- Brazecore Armguards
	[13180]="0:12:1:50:::1:0:", -- Stratholme Holy Water
	[13181]="0:4:3:1:Cloth::1:0:", -- Demonskin Gloves
	[13182]="0:2:3:1:OneHandSword::1:0:", -- Phase Blade
	[13183]="0:2:3:1:OneHandMace::1:0:", -- Venomspitter
	[13184]="0:4:3:1:Leather::1:0:", -- Fallbrush Handgrips
	[13185]="0:4:3:1:Cloth::1:0:", -- Sunderseer Mantle
	[13186]="0:12:1:1:::1:0:", -- Empty Felstone Field Bottle
	[13187]="0:12:1:1:::1:0:", -- Empty Dalson's Tears Bottle
	[13188]="0:12:1:1:::1:0:", -- Empty Writhing Haunt Bottle
	[13189]="0:12:1:1:::1:0:", -- Empty Gahrron's Withering Bottle
	[13190]="0:12:1:1:::1:0:", -- Filled Felstone Field Bottle
	[13191]="0:12:1:1:::1:0:", -- Filled Dalson's Tears Bottle
	[13192]="0:12:1:1:::1:0:", -- Filled Writhing Haunt Bottle
	[13193]="0:12:1:1:::1:0:", -- Filled Gahrron's Withering Bottle
	[13194]="0:13:1:1:::1:0:", -- Felstone Field Cauldron Key
	[13195]="0:13:1:1:::1:0:", -- Dalson's Tears Cauldron Key
	[13196]="0:13:1:1:::1:0:", -- Gahrron's Withering Cauldron Key
	[13197]="0:13:1:1:::1:0:", -- Writhing Haunt Cauldron Key
	[13198]="0:2:3:1:FistWeapon::1:0:", -- Hurd Smasher
	[13199]="0:4:3:1:Mail::1:0:", -- Crushridge Bindings
	[13202]="0:12:1:1:::1:0:", -- Extended Annals of Darrowshire
	[13203]="0:4:3:1:Cloak::1:0:", -- Armswake Cloak
	[13204]="0:2:3:1:OneHandMace::1:0:", -- Bashguuder
	[13205]="0:4:3:1:Shield::1:0:", -- Rhombeard Protector
	[13206]="0:4:3:1:Cloth::1:0:", -- Wolfshear Leggings
	[13207]="0:12:1:1:::1:0:", -- Shadow Lord Fel'dan's Head
	[13208]="0:4:3:1:Leather::1:0:", -- Bleak Howler Armguards
	[13209]="0:4:3:1:Trinket::1:0:", -- Seal of the Dawn
	[13210]="0:4:3:1:Leather::1:0:", -- Pads of the Dread Wolf
	[13211]="0:4:3:1:Mail::1:0:", -- Slashclaw Bracers
	[13212]="0:4:3:1:Amulet::1:0:", -- Halycon's Spiked Collar
	[13213]="0:4:3:1:Trinket::1:0:", -- Smolderweb's Eye
	[13216]="0:4:2:1:Cloth::1:0:", -- Crown of the Penitent
	[13217]="0:4:2:1:Ring::1:0:", -- Band of the Penitent
	[13218]="0:2:3:1:Dagger::1:0:", -- Fang of the Crystal Spider
	[13243]="0:4:3:1:Shield::1:0:", -- Argent Defender
	[13244]="0:4:3:1:Mail::1:0:", -- Gilded Gauntlets
	[13245]="0:4:3:1:Shield::1:0:", -- Kresh's Back
	[13246]="0:2:3:1:OneHandSword::1:0:", -- Argent Avenger
	[13248]="0:2:3:1:Gun::1:0:", -- Burstshot Harquebus
	[13249]="0:2:3:1:Stave::1:0:", -- Argent Crusader
	[13250]="0:12:1:1:::1:0:", -- Head of Balnazzar
	[13251]="0:12:1:1:::1:0:", -- Head of Baron Rivendare
	[13252]="0:4:3:1:Leather::1:0:", -- Cloudrunner Girdle
	[13253]="0:4:3:1:Cloth::1:0:", -- Hands of Power
	[13254]="0:4:3:1:Shield::1:0:", -- Astral Guard
	[13255]="0:4:3:1:Mail::1:0:", -- Trueaim Gauntlets
	[13257]="0:4:3:1:Leather::1:0:", -- Demonic Runed Spaulders
	[13258]="0:4:3:1:Leather::1:0:", -- Slaghide Gauntlets
	[13259]="0:4:3:1:Plate::1:0:", -- Ribsteel Footguards
	[13260]="0:4:3:1:Mail::1:0:", -- Wind Dancer Boots
	[13261]="0:4:3:1:OffHandFrill::1:0:", -- Globe of D'sak
	[13262]="0:2:5:1:TwoHandSword::1:0:", -- Ashbringer
	[13282]="0:4:3:1:Cloth::1:0:", -- Ogreseer Tower Boots
	[13283]="0:4:3:1:Ring::1:0:", -- Magus Ring
	[13284]="0:4:3:1:Mail::1:0:", -- Swiftdart Battleboots
	[13285]="0:2:3:1:TwoHandAxe::1:0:", -- The Blackrock Slicer
	[13286]="0:2:3:1:OneHandAxe::1:0:", -- Rivenspike
	[13287]="2500:9:2:1:Leatherworking::1:1:2819", -- Pattern: Raptor Hide Harness
	[13288]="2500:9:2:1:Leatherworking::1:1:2816", -- Pattern: Raptor Hide Belt
	[13289]="0:12:1:1:::1:0:", -- Egan's Blaster
	[13302]="0:13:1:20:::1:0:", -- Market Row Postbox Key
	[13303]="0:13:1:20:::1:0:", -- Crusaders' Square Postbox Key
	[13304]="0:13:1:20:::1:0:", -- Festival Lane Postbox Key
	[13305]="0:13:1:20:::1:0:", -- Elders' Square Postbox Key
	[13306]="0:13:1:20:::1:0:", -- King's Square Postbox Key
	[13307]="0:13:1:20:::1:0:", -- Fras Siabi's Postbox Key
	[13308]="1800:9:1:1:Engineering::1:1:2684", -- Schematic: Ice Deflector
	[13309]="1000:9:1:1:Engineering::1:1:2682,6730", -- Schematic: Lovingly Crafted Boomstick
	[13310]="2000:9:1:1:Engineering::1:1:2685", -- Schematic: Accurate Scope
	[13311]="10000:9:1:1:Engineering::1:1:2687,35826", -- Schematic: Mechanical Dragonling
	[13313]="0:12:1:1:::1:0:", -- Sacred Highborne Writings
	[13314]="0:4:4:1:Cloth::1:0:", -- Alanna's Embrace
	[13315]="0:4:2:1:OffHandFrill::1:0:", -- Testament of Hope
	[13317]="0:15:4:1:Mount::1:0:", -- Whistle of the Ivory Raptor
	[13320]="5000:12:1:1:::1:0:11056,11057", -- Arcane Quickener
	[13321]="10000:15:3:1:Mount::1:0:7955", -- Green Mechanostrider
	[13322]="10000:15:3:1:Mount::1:0:7955", -- Unpainted Mechanostrider
	[13326]="0:15:4:1:Mount::1:0:", -- White Mechanostrider Mod B
	[13327]="0:15:4:1:Mount::1:0:", -- Icy Blue Mechanostrider Mod A
	[13328]="0:15:4:1:Mount::1:0:", -- Black Ram
	[13329]="0:15:4:1:Mount::1:0:", -- Frost Ram
	[13331]="10000:15:3:1:Mount::1:0:4731", -- Red Skeletal Horse
	[13332]="10000:15:3:1:Mount::1:0:4731", -- Blue Skeletal Horse
	[13333]="10000:15:3:1:Mount::1:0:4731", -- Brown Skeletal Horse
	[13334]="100000:15:4:1:Mount::1:0:4731", -- Green Skeletal Warhorse
	[13335]="0:15:4:1:Mount::1:0:", -- Deathcharger's Reins
	[13340]="0:4:3:1:Cloak::1:0:", -- Cape of the Black Baron
	[13344]="0:4:3:1:Mail::1:0:", -- Dracorian Gauntlets
	[13345]="0:4:3:1:Ring::1:0:", -- Seal of Rivendare
	[13346]="0:4:3:1:Cloth::1:0:", -- Robes of the Exalted
	[13347]="0:12:1:1:::1:0:", -- Crystal of Zin-Malor
	[13348]="0:2:3:1:TwoHandSword::1:0:", -- Demonshear
	[13349]="0:2:3:1:OneHandMace::1:0:", -- Scepter of the Unholy
	[13350]="0:12:1:1:::1:0:", -- Insignia of the Black Guard
	[13351]="0:12:1:1:::1:0:", -- Crimson Hammersmith's Apron
	[13352]="0:12:1:1:::1:0:", -- Vosh'gajin's Snakestone
	[13353]="0:4:4:1:OffHandFrill::1:0:", -- Book of the Dead
	[13354]="0:12:1:200:::1:0:", -- Ectoplasmic Resonator
	[13356]="0:12:1:200:::1:0:", -- Somatic Intensifier
	[13357]="0:12:1:200:::1:0:", -- Osseous Agitator
	[13358]="0:4:3:1:Leather::1:0:", -- Wyrmtongue Shoulders
	[13359]="0:4:3:1:Mail::1:0:", -- Crown of Tyranny
	[13360]="0:2:3:1:Dagger::1:0:", -- Gift of the Elven Magi
	[13361]="0:2:3:1:OneHandSword::1:0:", -- Skullforge Reaver
	[13362]="0:15:0:20:Junk::1:0:", -- Letter from the Front
	[13363]="0:15:0:20:Junk::1:0:", -- Municipal Proclamation
	[13364]="0:15:0:20:Junk::1:0:", -- Fras Siabi's Advertisement
	[13365]="0:15:0:20:Junk::1:0:", -- Town Meeting Notice
	[13366]="0:15:0:20:Junk::1:0:", -- Ingenious Toy
	[13367]="0:0:0:1:Other::1:0:", -- Wrapped Gift
	[13368]="0:2:3:1:Dagger::1:0:", -- Bonescraper
	[13369]="0:4:3:1:Cloth::1:0:", -- Fire Striders
	[13370]="0:12:1:1:::1:0:", -- Vitreous Focuser
	[13371]="0:4:2:1:OffHandFrill::1:0:", -- Father Flame
	[13372]="0:2:3:1:Stave::1:0:", -- Slavedriver's Cane
	[13373]="0:4:3:1:Ring::1:0:", -- Band of Flesh
	[13374]="0:4:3:1:Cloth::1:0:", -- Soulstealer Mantle
	[13375]="0:4:3:1:Shield::1:0:", -- Crest of Retribution
	[13376]="0:4:3:1:Cloak::1:0:", -- Royal Tribunal Cloak
	[13377]="0:6:3:1000:Bullet::1:0:", -- Miniature Cannon Balls
	[13378]="0:4:3:1:Leather::1:0:", -- Songbird Blouse
	[13379]="0:4:3:1:Trinket::1:0:", -- Piccolo of the Flaming Fire
	[13380]="0:2:3:1:Gun::1:0:", -- Willey's Portable Howitzer
	[13381]="0:4:3:1:Plate::1:0:", -- Master Cannoneer Boots
	[13382]="0:4:3:1:Trinket::1:0:", -- Cannonball Runner
	[13383]="0:4:3:1:Mail::1:0:", -- Woollies of the Prancing Minstrel
	[13384]="0:4:3:1:Plate::1:0:", -- Rainbow Girdle
	[13385]="0:4:3:1:OffHandFrill::1:0:", -- Tome of Knowledge
	[13386]="0:4:3:1:Cloak::1:0:", -- Archivist Cape
	[13387]="0:4:3:1:Mail::1:0:", -- Foresight Girdle
	[13388]="0:4:3:1:Cloth::1:0:", -- The Postmaster's Tunic
	[13389]="0:4:3:1:Cloth::1:0:", -- The Postmaster's Trousers
	[13390]="0:4:3:1:Cloth::1:0:", -- The Postmaster's Band
	[13391]="0:4:3:1:Cloth::1:0:", -- The Postmaster's Treads
	[13392]="0:4:3:1:Ring::1:0:", -- The Postmaster's Seal
	[13393]="0:2:3:1:TwoHandMace::1:0:", -- Malown's Slam
	[13394]="0:4:3:1:Plate::1:0:", -- Skul's Cold Embrace
	[13395]="0:4:3:1:Leather::1:0:", -- Skul's Fingerbone Claws
	[13396]="0:2:3:1:Wand::1:0:", -- Skul's Ghastly Touch
	[13397]="0:4:3:1:Cloak::1:0:", -- Stoneskin Gargoyle Cape
	[13398]="0:4:3:1:Leather::1:0:", -- Boots of the Shrieker
	[13399]="0:2:3:1:FistWeapon::1:0:", -- Gargoyle Shredder Talons
	[13400]="0:4:3:1:Plate::1:0:", -- Vambraces of the Sadist
	[13401]="0:2:3:1:OneHandMace::1:0:", -- The Cruel Hand of Timmy
	[13402]="0:4:3:1:Mail::1:0:", -- Timmy's Galoshes
	[13403]="0:4:3:1:Cloth::1:0:", -- Grimgore Noose
	[13404]="0:4:3:1:Leather::1:0:", -- Mask of the Unforgiven
	[13405]="0:4:3:1:Plate::1:0:", -- Wailing Nightbane Pauldrons
	[13408]="0:2:3:1:OneHandAxe::1:0:", -- Soul Breaker
	[13409]="0:4:3:1:Cloth::1:0:", -- Tearfall Bracers
	[13422]="0:7:1:20:Other:171:1:0:", -- Stonescale Eel
	[13423]="0:7:1:20:Other:171:1:0:", -- Stonescale Oil
	[13442]="0:0:1:20:Potion::1:0:", -- Mighty Rage Potion
	[13443]="1600:0:1:20:Potion::1:1:14847,28715,29537", -- Superior Mana Potion
	[13444]="6000:0:1:20:Potion:333:1:1:15471,19837,20092,20989", -- Major Mana Potion
	[13445]="0:0:1:20:Elixir::1:0:", -- Elixir of Superior Defense
	[13446]="4000:0:1:20:Potion:333:1:1:15471,19837,20092,20989,29628", -- Major Healing Potion
	[13447]="0:0:1:20:Elixir::1:0:", -- Elixir of the Sages
	[13448]="0:12:1:1:::1:0:", -- The Deed to Caer Darrow
	[13450]="0:12:1:1:::1:0:", -- The Deed to Southshore
	[13451]="0:12:1:1:::1:0:", -- The Deed to Tarren Mill
	[13452]="0:0:1:20:Elixir::1:0:", -- Elixir of the Mongoose
	[13453]="0:0:1:20:Elixir::1:0:", -- Elixir of Brute Force
	[13454]="0:0:1:20:Elixir::1:0:", -- Greater Arcane Elixir
	[13455]="0:0:1:20:Potion::1:0:", -- Greater Stoneshield Potion
	[13456]="0:0:1:20:Potion::1:0:", -- Greater Frost Protection Potion
	[13457]="0:0:1:20:Potion::1:0:", -- Greater Fire Protection Potion
	[13458]="0:0:1:20:Potion::1:0:", -- Greater Nature Protection Potion
	[13459]="0:0:1:20:Potion::1:0:", -- Greater Shadow Protection Potion
	[13460]="0:0:1:20:Potion::1:0:", -- Greater Holy Protection Potion
	[13461]="0:0:1:20:Potion::1:0:", -- Greater Arcane Protection Potion
	[13462]="0:0:1:20:Potion::1:0:", -- Purification Potion
	[13463]="400:7:1:20:Herb:171:1:1:14846", -- Dreamfoil
	[13464]="400:7:1:20:Herb:171:1:1:14846", -- Golden Sansam
	[13465]="600:7:1:20:Herb:171:1:1:14846", -- Mountain Silversage
	[13466]="0:7:1:20:Herb:171:1:0:", -- Plaguebloom
	[13467]="1000:7:1:20:Herb:171,333,202:1:1:20989,24975", -- Icecap
	[13468]="4000:7:2:20:Herb:171,197:1:1:14846", -- Black Lotus
	[13469]="0:12:1:1:::1:0:", -- Head of Weldon Barov
	[13470]="0:12:1:1:::1:0:", -- Head of Alexi Barov
	[13471]="0:12:1:1:::1:0:", -- The Deed to Brill
	[13473]="0:4:2:1:Amulet::1:0:", -- Felstone Good Luck Charm
	[13474]="0:2:2:1:Gun::1:0:", -- Farmer Dalson's Shotgun
	[13475]="0:4:2:1:Ring::1:0:", -- Dalson Family Wedding Ring
	[13476]="0:9:2:1:Alchemy::1:0:", -- Recipe: Mighty Rage Potion
	[13477]="0:9:1:1:Alchemy::1:0:", -- Recipe: Superior Mana Potion
	[13478]="13000:9:1:1:Alchemy::1:1:3348,5178", -- Recipe: Elixir of Superior Defense
	[13479]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of the Sages
	[13480]="0:9:1:1:Alchemy::1:0:", -- Recipe: Major Healing Potion
	[13481]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Brute Force
	[13482]="15000:9:2:1:Alchemy::1:0:10856,10857,11536", -- Recipe: Transmute Air to Fire
	[13483]="15000:9:2:1:Alchemy::1:0:9499", -- Recipe: Transmute Fire to Earth
	[13484]="15000:9:2:1:Alchemy::1:0:11557", -- Recipe: Transmute Earth to Water
	[13485]="15000:9:2:1:Alchemy::1:0:11278", -- Recipe: Transmute Water to Air
	[13486]="0:9:2:1:Alchemy::1:0:", -- Recipe: Transmute Undeath to Water
	[13487]="0:9:2:1:Alchemy::1:0:", -- Recipe: Transmute Water to Undeath
	[13488]="0:9:2:1:Alchemy::1:0:", -- Recipe: Transmute Life to Earth
	[13489]="0:9:2:1:Alchemy::1:0:", -- Recipe: Transmute Earth to Life
	[13490]="0:9:2:1:Alchemy::1:0:", -- Recipe: Greater Stoneshield Potion
	[13491]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of the Mongoose
	[13492]="0:9:2:1:Alchemy::1:0:", -- Recipe: Purification Potion
	[13493]="0:9:2:1:Alchemy::1:0:", -- Recipe: Greater Arcane Elixir
	[13494]="0:9:2:1:Alchemy::1:0:", -- Recipe: Greater Fire Protection Potion
	[13495]="0:9:2:1:Alchemy::1:0:", -- Recipe: Greater Frost Protection Potion
	[13496]="0:9:2:1:Alchemy::1:0:", -- Recipe: Greater Nature Protection Potion
	[13497]="0:9:2:1:Alchemy::1:0:", -- Recipe: Greater Arcane Protection Potion
	[13498]="0:4:3:1:Plate::1:0:", -- Handcrafted Mastersmith Leggings
	[13499]="0:9:2:1:Alchemy::1:0:", -- Recipe: Greater Shadow Protection Potion
	[13501]="30000:9:2:1:Alchemy::1:0:11278", -- Recipe: Major Mana Potion
	[13502]="0:4:3:1:Plate::1:0:", -- Handcrafted Mastersmith Girdle
	[13503]="0:4:4:1:Trinket:171:1:0:", -- Alchemist's Stone
	[13505]="0:2:4:1:TwoHandSword::1:0:", -- Runeblade of Baron Rivendare
	[13506]="0:0:1:20:Potion::1:0:", -- Potion of Petrification
	[13507]="0:12:1:1:::1:0:", -- Cliffwatcher Longhorn Report
	[13508]="0:15:2:1:CombatPet::1:0:", -- Eye of Arachnida
	[13509]="0:0:2:1:Consumable::1:0:", -- Clutch of Foresight
	[13510]="0:0:1:20:Flask:164:1:0:", -- Flask of the Titans
	[13511]="0:0:1:20:Flask::1:0:", -- Flask of Distilled Wisdom
	[13512]="0:0:1:20:Flask:164:1:0:", -- Flask of Supreme Power
	[13513]="0:0:1:20:Flask::1:0:", -- Flask of Chromatic Resistance
	[13514]="0:0:2:1:Consumable::1:0:", -- Wail of the Banshee
	[13515]="0:4:3:1:Trinket::1:0:", -- Ramstein's Lightning Bolts
	[13517]="80000:9:1:1:Alchemy::1:0:21432", -- Recipe: Alchemist's Stone
	[13518]="0:9:2:1:Alchemy::1:0:", -- Recipe: Potion of Petrification
	[13519]="0:9:2:1:Alchemy::1:0:", -- Recipe: Flask of the Titans
	[13520]="0:9:2:1:Alchemy::1:0:", -- Recipe: Flask of Distilled Wisdom
	[13521]="0:9:2:1:Alchemy::1:0:", -- Recipe: Flask of Supreme Power
	[13522]="0:9:2:1:Alchemy::1:0:", -- Recipe: Flask of Chromatic Resistance
	[13523]="0:12:1:1:::1:0:", -- Blood of Innocents
	[13524]="0:4:3:1:OffHandFrill::1:0:", -- Skull of Burning Shadows
	[13525]="0:4:2:1:Cloth::1:0:", -- Darkbind Fingers
	[13526]="0:4:2:1:Leather::1:0:", -- Flamescarred Girdle
	[13527]="0:4:2:1:Plate::1:0:", -- Lavawalker Greaves
	[13528]="0:4:2:1:Mail::1:0:", -- Twilight Void Bracers
	[13529]="0:4:3:1:Shield::1:0:", -- Husk of Nerub'enkan
	[13530]="0:4:2:1:Cloth::1:0:", -- Fangdrip Runners
	[13531]="0:4:2:1:Leather::1:0:", -- Crypt Stalker Leggings
	[13532]="0:4:2:1:Mail::1:0:", -- Darkspinner Claws
	[13533]="0:4:2:1:Plate::1:0:", -- Acid-etched Pauldrons
	[13534]="0:2:3:1:Wand::1:0:", -- Banshee Finger
	[13535]="0:4:2:1:Cloth::1:0:", -- Coldtouch Phantom Wraps
	[13536]="0:12:1:1:::1:0:", -- Horn of Awakening
	[13537]="0:4:2:1:Leather::1:0:", -- Chillhide Bracers
	[13538]="0:4:2:1:Mail::1:0:", -- Windshrieker Pauldrons
	[13539]="0:4:2:1:Plate::1:0:", -- Banshee's Touch
	[13542]="0:12:1:1:::1:0:", -- Demon Box
	[13544]="0:4:2:1:Trinket::1:0:", -- Spectral Essence
	[13545]="0:12:1:20:::1:0:", -- Shellfish
	[13546]="0:0:1:20:FoodDrink::1:0:", -- Bloodbelly Fish
	[13562]="0:0:1:1:Consumable::1:0:", -- Remains of Trey Lightforge
	[13582]="0:15:3:1:Companion::1:0:", -- Zergling Leash
	[13583]="0:15:3:1:Companion::1:0:", -- Panda Collar
	[13584]="0:15:3:1:Companion::1:0:", -- Diablo Stone
	[13585]="0:12:1:1:::1:0:", -- Keepsake of Remembrance
	[13624]="0:12:1:1:::1:0:", -- Soulbound Keepsake
	[13626]="0:12:1:1:::1:0:", -- Human Head of Ras Frostwhisper
	[13702]="0:12:1:20:::1:0:", -- Doom Weed
	[13703]="0:0:1:20:Consumable::1:0:", -- Kodo Bone
	[13704]="0:13:1:1:::1:0:", -- Skeleton Key
	[13724]="6000:0:1:20:FoodDrink::5:0:10856,10857,11536", -- Enriched Manna Biscuit
	[13725]="0:12:1:1:::1:0:", -- Krastinov's Bag of Horrors
	[13752]="0:12:1:1:::1:0:", -- Soulbound Keepsake
	[13754]="0:7:1:20:Meat:185:1:0:", -- Raw Glossy Mightfish
	[13755]="0:0:1:20:FoodDrink:185:1:0:", -- Winter Squid
	[13756]="0:7:1:20:Meat:185:1:0:", -- Raw Summer Bass
	[13757]="0:7:1:20:Other:185:1:0:", -- Lightning Eel
	[13758]="0:7:1:20:Meat:185:1:0:", -- Raw Redgill
	[13759]="0:7:1:20:Meat:185:1:0:", -- Raw Nightfin Snapper
	[13760]="0:7:1:20:Meat:185:1:0:", -- Raw Sunscale Salmon
	[13761]="0:0:1:1:Consumable::1:0:", -- Frozen Eggs
	[13810]="6000:0:1:20:FoodDrink::5:0:10856,10857,11536", -- Blessed Sunfruit
	[13813]="6000:0:1:20:Consumable::5:0:10856,10857,11536", -- Blessed Sunfruit Juice
	[13815]="0:12:1:1:::1:0:", -- Some Rune
	[13816]="0:2:0:1:OneHandSword::1:0:", -- Fine Longsword
	[13817]="0:2:0:1:TwoHandSword::1:0:", -- Tapered Greatsword
	[13818]="0:2:0:1:OneHandAxe::1:0:", -- Jagged Axe
	[13819]="0:2:0:1:TwoHandAxe::1:0:", -- Balanced War Axe
	[13820]="0:2:0:1:OneHandMace::1:0:", -- Clout Mace
	[13821]="0:2:0:1:TwoHandMace::1:0:", -- Bulky Maul
	[13822]="0:2:0:1:Dagger::1:0:", -- Spiked Dagger
	[13823]="0:2:0:1:Stave::1:0:", -- Stout War Staff
	[13824]="0:2:0:1:Bow::1:0:", -- Recurve Long Bow
	[13825]="0:2:0:1:Gun::1:0:", -- Primed Musket
	[13850]="0:12:1:1:::1:0:", -- Rumbleshot's Ammo
	[13851]="0:0:1:20:FoodDrink::1:0:", -- Hot Wolf Ribs
	[13852]="0:12:1:1:::1:0:", -- The Grand Crusader's Command
	[13853]="0:12:1:10:::1:0:", -- Slab of Carrion Worm Meat
	[13856]="0:4:2:1:Cloth::1:0:", -- Runecloth Belt
	[13857]="0:4:2:1:Cloth::1:0:", -- Runecloth Tunic
	[13858]="0:4:2:1:Cloth::1:0:", -- Runecloth Robe
	[13860]="0:4:2:1:Cloak::1:0:", -- Runecloth Cloak
	[13863]="0:4:2:1:Cloth::1:0:", -- Runecloth Gloves
	[13864]="0:4:2:1:Cloth::1:0:", -- Runecloth Boots
	[13865]="0:4:2:1:Cloth::1:0:", -- Runecloth Pants
	[13866]="0:4:2:1:Cloth::1:0:", -- Runecloth Headband
	[13867]="0:4:2:1:Cloth::1:0:", -- Runecloth Shoulders
	[13868]="0:4:2:1:Cloth::1:0:", -- Frostweave Robe
	[13869]="0:4:2:1:Cloth::1:0:", -- Frostweave Tunic
	[13870]="0:4:2:1:Cloth::1:0:", -- Frostweave Gloves
	[13871]="0:4:2:1:Cloth::1:0:", -- Frostweave Pants
	[13872]="0:12:1:20:::1:0:", -- Bundle of Wood
	[13873]="0:13:1:1:::1:0:", -- Viewing Room Key
	[13874]="0:15:1:1:Other::1:0:", -- Heavy Crate
	[13875]="0:15:1:1:Junk::1:0:", -- Ironbound Locked Chest
	[13876]="0:15:1:1:Junk::1:0:", -- 40 Pound Grouper
	[13877]="0:15:1:1:Junk::1:0:", -- 47 Pound Grouper
	[13878]="0:15:1:1:Junk::1:0:", -- 53 Pound Grouper
	[13879]="0:15:1:1:Junk::1:0:", -- 59 Pound Grouper
	[13880]="0:15:1:1:Junk::1:0:", -- 68 Pound Grouper
	[13881]="0:15:1:1:Other::1:0:", -- Bloated Redgill
	[13882]="0:4:1:1:OffHandFrill::1:0:", -- 42 Pound Redgill
	[13883]="0:4:1:1:OffHandFrill::1:0:", -- 45 Pound Redgill
	[13884]="0:4:1:1:OffHandFrill::1:0:", -- 49 Pound Redgill
	[13885]="0:4:1:1:OffHandFrill::1:0:", -- 34 Pound Redgill
	[13886]="0:4:1:1:OffHandFrill::1:0:", -- 37 Pound Redgill
	[13887]="0:4:1:1:OffHandFrill::1:0:", -- 52 Pound Redgill
	[13888]="0:7:1:20:Meat:185:1:0:", -- Darkclaw Lobster
	[13889]="0:7:1:20:Meat:185:1:0:", -- Raw Whitescale Salmon
	[13890]="0:7:1:20:Meat::1:0:", -- Plated Armorfish
	[13891]="0:15:1:1:Other::1:0:", -- Bloated Salmon
	[13892]="0:12:1:1:::1:0:", -- Kodo Kombobulator
	[13893]="0:0:1:20:FoodDrink:185:1:0:", -- Large Raw Mightfish
	[13895]="506622:4:1:1:Miscellaneous::1:1:4184", -- Formal Dangui
	[13896]="55103:4:1:1:Miscellaneous::1:0:1299,4184,5821", -- Dark Green Wedding Hanbok
	[13897]="2977:4:1:1:Miscellaneous::1:0:1299,4184,5821", -- White Traditional Hanbok
	[13898]="288699:4:1:1:Miscellaneous::1:0:1299,4184,5821", -- Royal Dangui
	[13899]="17641:4:1:1:Miscellaneous::1:1:4184", -- Red Traditional Hanbok
	[13900]="137214:4:1:1:Miscellaneous::1:1:4184", -- Green Wedding Hanbok
	[13901]="0:4:1:1:OffHandFrill::1:0:", -- 15 Pound Salmon
	[13902]="0:4:1:1:OffHandFrill::1:0:", -- 18 Pound Salmon
	[13903]="0:4:1:1:OffHandFrill::1:0:", -- 22 Pound Salmon
	[13904]="0:4:1:1:OffHandFrill::1:0:", -- 25 Pound Salmon
	[13905]="0:4:1:1:OffHandFrill::1:0:", -- 29 Pound Salmon
	[13907]="0:15:1:1:Junk::1:0:", -- 7 Pound Lobster
	[13908]="0:15:1:1:Junk::1:0:", -- 9 Pound Lobster
	[13909]="0:15:1:1:Junk::1:0:", -- 12 Pound Lobster
	[13910]="0:15:1:1:Junk::1:0:", -- 15 Pound Lobster
	[13911]="0:15:1:1:Junk::1:0:", -- 19 Pound Lobster
	[13912]="0:15:1:1:Junk::1:0:", -- 21 Pound Lobster
	[13913]="0:15:1:1:Junk::1:0:", -- 22 Pound Lobster
	[13914]="0:4:1:1:OffHandFrill::1:0:", -- 70 Pound Mightfish
	[13915]="0:4:1:1:OffHandFrill::1:0:", -- 85 Pound Mightfish
	[13916]="0:4:1:1:OffHandFrill::1:0:", -- 92 Pound Mightfish
	[13917]="0:4:1:1:OffHandFrill::1:0:", -- 103 Pound Mightfish
	[13918]="0:15:1:1:Junk::1:0:", -- Reinforced Locked Chest
	[13920]="0:12:1:1:::1:0:", -- Healthy Dragon Scale
	[13926]="0:3:2:20:GemSimple:333,197:1:0:", -- Golden Pearl
	[13927]="0:0:1:20:FoodDrink::1:0:", -- Cooked Glossy Mightfish
	[13928]="0:0:1:20:FoodDrink::1:0:", -- Grilled Squid
	[13929]="0:0:1:20:FoodDrink::1:0:", -- Hot Smoked Bass
	[13930]="0:0:1:20:FoodDrink::1:0:", -- Filet of Redgill
	[13931]="0:0:1:20:FoodDrink::1:0:", -- Nightfin Soup
	[13932]="0:0:1:20:FoodDrink::1:0:", -- Poached Sunscale Salmon
	[13933]="0:0:1:20:FoodDrink::1:0:", -- Lobster Stew
	[13934]="0:0:1:20:FoodDrink::1:0:", -- Mightfish Steak
	[13935]="0:0:1:20:FoodDrink::1:0:", -- Baked Salmon
	[13937]="0:2:4:1:Stave::1:0:", -- Headmaster's Charge
	[13938]="0:2:3:1:Wand::1:0:", -- Bonecreeper Stylus
	[13939]="16000:9:1:1:Cooking::1:0:8137", -- Recipe: Spotted Yellowtail
	[13940]="16000:9:1:1:Cooking::1:0:2664", -- Recipe: Cooked Glossy Mightfish
	[13941]="16000:9:1:1:Cooking::1:0:2664", -- Recipe: Filet of Redgill
	[13942]="16000:9:1:1:Cooking::1:0:8137", -- Recipe: Grilled Squid
	[13943]="16000:9:1:1:Cooking::1:0:2664", -- Recipe: Hot Smoked Bass
	[13944]="0:4:3:1:Leather::1:0:", -- Tombstone Breastplate
	[13945]="20000:9:1:1:Cooking::1:0:8137", -- Recipe: Nightfin Soup
	[13946]="20000:9:1:1:Cooking::1:0:8137", -- Recipe: Poached Sunscale Salmon
	[13947]="20000:9:1:1:Cooking::1:0:7947,8145", -- Recipe: Lobster Stew
	[13948]="20000:9:1:1:Cooking::1:0:7947,8145", -- Recipe: Mightfish Steak
	[13949]="20000:9:1:1:Cooking::1:0:7947,8145", -- Recipe: Baked Salmon
	[13950]="0:4:3:1:Mail::1:0:", -- Detention Strap
	[13951]="0:4:3:1:Plate::1:0:", -- Vigorsteel Vambraces
	[13952]="0:2:3:1:OneHandAxe::1:0:", -- Iceblade Hacker
	[13953]="0:2:3:1:OneHandSword::1:0:", -- Silent Fang
	[13954]="0:4:3:1:Leather::1:0:", -- Verdant Footpads
	[13955]="0:4:3:1:Plate::1:0:", -- Stoneform Shoulders
	[13956]="0:4:3:1:Cloth::1:0:", -- Clutch of Andros
	[13957]="0:4:3:1:Leather::1:0:", -- Gargoyle Slashers
	[13958]="0:4:3:1:Cloth::1:0:", -- Wyrmthalak's Shackles
	[13959]="0:4:3:1:Plate::1:0:", -- Omokk's Girth Restrainer
	[13960]="0:4:3:1:Amulet::1:0:", -- Heart of the Fiend
	[13961]="0:4:3:1:Leather::1:0:", -- Halycon's Muzzle
	[13962]="0:4:3:1:Leather::1:0:", -- Vosh'gajin's Strand
	[13963]="0:4:3:1:Mail::1:0:", -- Voone's Vice Grips
	[13964]="0:2:3:1:Dagger::1:0:", -- Witchblade
	[13965]="0:4:3:1:Trinket::1:0:", -- Blackhand's Breadth
	[13966]="0:4:3:1:Trinket::1:0:", -- Mark of Tyranny
	[13967]="0:4:3:1:Mail::1:0:", -- Windreaver Greaves
	[13968]="0:4:3:1:Trinket::1:0:", -- Eye of the Beast
	[13969]="0:4:3:1:Mail::1:0:", -- Loomguard Armbraces
	[13982]="0:2:3:1:TwoHandSword::1:0:", -- Warblade of Caer Darrow
	[13983]="0:2:3:1:TwoHandAxe::1:0:", -- Gravestone War Axe
	[13984]="0:2:3:1:Dagger::1:0:", -- Darrowspike
	[13986]="0:4:3:1:Cloth::1:0:", -- Crown of Caer Darrow
	[14002]="0:4:3:1:Shield::1:0:", -- Darrowshire Strongguard
	[14022]="0:4:3:1:Trinket::1:0:", -- Barov Peasant Caller
	[14023]="0:4:3:1:Trinket::1:0:", -- Barov Peasant Caller
	[14024]="0:2:3:1:Dagger::1:0:", -- Frightalon
	[14025]="0:4:2:1:Cloth::1:0:", -- Mystic's Belt
	[14042]="0:4:2:1:Cloth::1:0:", -- Cindercloth Vest
	[14043]="0:4:2:1:Cloth::1:0:", -- Cindercloth Gloves
	[14044]="0:4:2:1:Cloak:165:1:0:", -- Cindercloth Cloak
	[14045]="0:4:2:1:Cloth::1:0:", -- Cindercloth Pants
	[14046]="0:1:1:1:Bag::1:0:", -- Runecloth Bag
	[14047]="0:7:1:20:Cloth:164,202,129,165,197:1:0:", -- Runecloth
	[14048]="0:7:1:20:Cloth:165,197:1:0:", -- Bolt of Runecloth
	[14086]="0:4:1:1:Cloth::1:0:", -- Beaded Sandals
	[14087]="0:4:1:1:Cloth::1:0:", -- Beaded Cuffs
	[14088]="0:4:1:1:Cloak::1:0:", -- Beaded Cloak
	[14089]="0:4:1:1:Cloth::1:0:", -- Beaded Gloves
	[14090]="0:4:2:1:Cloth::1:0:", -- Beaded Britches
	[14091]="0:4:2:1:Cloth::1:0:", -- Beaded Robe
	[14093]="0:4:1:1:Cloth::1:0:", -- Beaded Cord
	[14094]="0:4:2:1:Cloth::1:0:", -- Beaded Wraps
	[14095]="0:4:1:1:Cloth::1:0:", -- Native Bands
	[14096]="0:4:2:1:Cloth::1:0:", -- Native Vest
	[14097]="0:4:2:1:Cloth::1:0:", -- Native Pants
	[14098]="0:4:1:1:Cloak::1:0:", -- Native Cloak
	[14099]="0:4:1:1:Cloth::1:0:", -- Native Sash
	[14100]="0:4:2:1:Cloth::1:0:", -- Brightcloth Robe
	[14101]="0:4:2:1:Cloth::1:0:", -- Brightcloth Gloves
	[14102]="0:4:1:1:Cloth::1:0:", -- Native Handwraps
	[14103]="0:4:2:1:Cloak::1:0:", -- Brightcloth Cloak
	[14104]="0:4:2:1:Cloth::1:0:", -- Brightcloth Pants
	[14106]="0:4:2:1:Cloth::1:0:", -- Felcloth Robe
	[14107]="0:4:2:1:Cloth::1:0:", -- Felcloth Pants
	[14108]="0:4:2:1:Cloth::1:0:", -- Felcloth Boots
	[14109]="0:4:2:1:Cloth::1:0:", -- Native Robe
	[14110]="0:4:1:1:Cloth::1:0:", -- Native Sandals
	[14111]="0:4:2:1:Cloth::1:0:", -- Felcloth Hood
	[14112]="0:4:2:1:Cloth::1:0:", -- Felcloth Shoulders
	[14113]="0:4:2:1:Cloth::1:0:", -- Aboriginal Sash
	[14114]="0:4:2:1:Cloth::1:0:", -- Aboriginal Footwraps
	[14115]="0:4:1:1:Cloth::1:0:", -- Aboriginal Bands
	[14116]="0:4:1:1:Cloak::1:0:", -- Aboriginal Cape
	[14117]="0:4:2:1:Cloth::1:0:", -- Aboriginal Gloves
	[14119]="0:4:2:1:Cloth::1:0:", -- Aboriginal Loincloth
	[14120]="0:4:2:1:Cloth::1:0:", -- Aboriginal Robe
	[14121]="0:4:2:1:Cloth::1:0:", -- Aboriginal Vest
	[14122]="0:4:2:1:Cloth::1:0:", -- Ritual Bands
	[14123]="0:4:2:1:Cloak::1:0:", -- Ritual Cape
	[14124]="0:4:2:1:Cloth::1:0:", -- Ritual Gloves
	[14125]="0:4:2:1:Cloth::1:0:", -- Ritual Leggings
	[14126]="0:4:1:1:Cloth::1:0:", -- Ritual Amice
	[14127]="0:4:2:1:Cloth::1:0:", -- Ritual Shroud
	[14128]="0:4:2:1:Cloth::1:0:", -- Wizardweave Robe
	[14129]="0:4:2:1:Cloth::1:0:", -- Ritual Sandals
	[14130]="0:4:2:1:Cloth::1:0:", -- Wizardweave Turban
	[14131]="0:4:2:1:Cloth::1:0:", -- Ritual Belt
	[14132]="0:4:2:1:Cloth::1:0:", -- Wizardweave Leggings
	[14133]="0:4:2:1:Cloth::1:0:", -- Ritual Tunic
	[14134]="0:4:3:1:Cloak::1:0:", -- Cloak of Fire
	[14136]="0:4:3:1:Cloth::1:0:", -- Robe of Winter Night
	[14137]="0:4:3:1:Cloth::1:0:", -- Mooncloth Leggings
	[14138]="0:4:3:1:Cloth::1:0:", -- Mooncloth Vest
	[14139]="0:4:3:1:Cloth::1:0:", -- Mooncloth Shoulders
	[14140]="0:4:3:1:Cloth::1:0:", -- Mooncloth Circlet
	[14141]="0:4:2:1:Cloth::1:0:", -- Ghostweave Vest
	[14142]="0:4:2:1:Cloth::1:0:", -- Ghostweave Gloves
	[14143]="0:4:2:1:Cloth::1:0:", -- Ghostweave Belt
	[14144]="0:4:2:1:Cloth::1:0:", -- Ghostweave Pants
	[14145]="0:2:3:1:OneHandSword::1:0:", -- Cursed Felblade
	[14146]="0:4:4:1:Cloth::1:0:", -- Gloves of Spell Mastery
	[14147]="0:4:3:1:Mail::1:0:", -- Cavedweller Bracers
	[14148]="0:4:3:1:Cloth::1:0:", -- Crystalline Cuffs
	[14149]="0:4:3:1:Cloak::1:0:", -- Subterranean Cape
	[14150]="0:4:3:1:Cloth::1:0:", -- Robe of Evocation
	[14151]="0:2:3:1:Dagger::1:0:", -- Chanting Blade
	[14152]="0:4:4:1:Cloth::1:0:", -- Robe of the Archmage
	[14153]="0:4:4:1:Cloth::1:0:", -- Robe of the Void
	[14154]="0:4:4:1:Cloth::1:0:", -- Truefaith Vestments
	[14155]="0:1:2:1:Bag::1:0:", -- Mooncloth Bag
	[14156]="0:1:3:1:Bag::1:0:", -- Bottomless Bag
	[14157]="0:4:1:1:Cloth::1:0:", -- Pagan Mantle
	[14158]="0:4:2:1:Cloth::1:0:", -- Pagan Vest
	[14159]="0:4:2:1:Cloth::1:0:", -- Pagan Shoes
	[14160]="0:4:2:1:Cloth::1:0:", -- Pagan Bands
	[14161]="0:4:2:1:Cloak::1:0:", -- Pagan Cape
	[14162]="0:4:2:1:Cloth::1:0:", -- Pagan Mitts
	[14163]="0:4:2:1:Cloth::1:0:", -- Pagan Wraps
	[14164]="0:4:2:1:Cloth::1:0:", -- Pagan Belt
	[14165]="0:4:2:1:Cloth::1:0:", -- Pagan Britches
	[14166]="0:4:2:1:Cloth::1:0:", -- Buccaneer's Bracers
	[14167]="0:4:2:1:Cloak::1:0:", -- Buccaneer's Cape
	[14168]="0:4:2:1:Cloth::1:0:", -- Buccaneer's Gloves
	[14169]="0:4:1:1:Cloth::1:0:", -- Aboriginal Shoulder Pads
	[14170]="0:4:1:1:Cloth::1:0:", -- Buccaneer's Mantle
	[14171]="0:4:2:1:Cloth::1:0:", -- Buccaneer's Pants
	[14172]="0:4:2:1:Cloth::1:0:", -- Buccaneer's Robes
	[14173]="0:4:2:1:Cloth::1:0:", -- Buccaneer's Cord
	[14174]="0:4:2:1:Cloth::1:0:", -- Buccaneer's Boots
	[14175]="0:4:2:1:Cloth::1:0:", -- Buccaneer's Vest
	[14176]="0:4:2:1:Cloth::1:0:", -- Watcher's Boots
	[14177]="0:4:2:1:Cloth::1:0:", -- Watcher's Cuffs
	[14178]="0:4:2:1:Cloth::1:0:", -- Watcher's Cap
	[14179]="0:4:2:1:Cloak::1:0:", -- Watcher's Cape
	[14180]="0:4:2:1:Cloth::1:0:", -- Watcher's Jerkin
	[14181]="0:4:2:1:Cloth::1:0:", -- Watcher's Handwraps
	[14182]="0:4:2:1:Cloth::1:0:", -- Watcher's Mantle
	[14183]="0:4:2:1:Cloth::1:0:", -- Watcher's Leggings
	[14184]="0:4:2:1:Cloth::1:0:", -- Watcher's Robes
	[14185]="0:4:2:1:Cloth::1:0:", -- Watcher's Cinch
	[14186]="0:4:2:1:Cloth::1:0:", -- Raincaller Mantle
	[14187]="0:4:2:1:Cloth::1:0:", -- Raincaller Cuffs
	[14188]="0:4:2:1:Cloak::1:0:", -- Raincaller Cloak
	[14189]="0:4:2:1:Cloth::1:0:", -- Raincaller Cap
	[14190]="0:4:2:1:Cloth::1:0:", -- Raincaller Vest
	[14191]="0:4:2:1:Cloth::1:0:", -- Raincaller Mitts
	[14192]="0:4:2:1:Cloth::1:0:", -- Raincaller Robes
	[14193]="0:4:2:1:Cloth::1:0:", -- Raincaller Pants
	[14194]="0:4:2:1:Cloth::1:0:", -- Raincaller Cord
	[14195]="0:4:2:1:Cloth::1:0:", -- Raincaller Boots
	[14196]="0:4:2:1:Cloth::1:0:", -- Thistlefur Sandals
	[14197]="0:4:2:1:Cloth::1:0:", -- Thistlefur Bands
	[14198]="0:4:2:1:Cloak::1:0:", -- Thistlefur Cloak
	[14199]="0:4:2:1:Cloth::1:0:", -- Thistlefur Gloves
	[14200]="0:4:2:1:Cloth::1:0:", -- Thistlefur Cap
	[14201]="0:4:2:1:Cloth::1:0:", -- Thistlefur Mantle
	[14202]="0:4:2:1:Cloth::1:0:", -- Thistlefur Jerkin
	[14203]="0:4:2:1:Cloth::1:0:", -- Thistlefur Pants
	[14204]="0:4:2:1:Cloth::1:0:", -- Thistlefur Robe
	[14205]="0:4:2:1:Cloth::1:0:", -- Thistlefur Belt
	[14206]="0:4:2:1:Cloth::1:0:", -- Vital Bracelets
	[14207]="0:4:2:1:Cloth::1:0:", -- Vital Leggings
	[14208]="0:4:2:1:Cloth::1:0:", -- Vital Headband
	[14209]="0:4:2:1:Cloth::1:0:", -- Vital Sash
	[14210]="0:4:2:1:Cloak::1:0:", -- Vital Cape
	[14211]="0:4:2:1:Cloth::1:0:", -- Vital Handwraps
	[14212]="0:4:2:1:Cloth::1:0:", -- Vital Shoulders
	[14213]="0:4:2:1:Cloth::1:0:", -- Vital Raiment
	[14214]="0:4:2:1:Cloth::1:0:", -- Vital Boots
	[14215]="0:4:2:1:Cloth::1:0:", -- Vital Tunic
	[14216]="0:4:2:1:Cloth::1:0:", -- Geomancer's Jerkin
	[14217]="0:4:2:1:Cloth::1:0:", -- Geomancer's Cord
	[14218]="0:4:2:1:Cloth::1:0:", -- Geomancer's Boots
	[14219]="0:4:2:1:Cloak::1:0:", -- Geomancer's Cloak
	[14220]="0:4:2:1:Cloth::1:0:", -- Geomancer's Cap
	[14221]="0:4:2:1:Cloth::1:0:", -- Geomancer's Bracers
	[14222]="0:4:2:1:Cloth::1:0:", -- Geomancer's Gloves
	[14223]="0:4:2:1:Cloth::1:0:", -- Geomancer's Spaulders
	[14224]="0:4:2:1:Cloth::1:0:", -- Geomancer's Trousers
	[14225]="0:4:2:1:Cloth::1:0:", -- Geomancer's Wraps
	[14226]="0:4:2:1:Cloth::1:0:", -- Embersilk Bracelets
	[14227]="0:7:1:10:Cloth:202,165,197:1:0:", -- Ironweb Spider Silk
	[14228]="0:4:2:1:Cloth::1:0:", -- Embersilk Coronet
	[14229]="0:4:2:1:Cloak::1:0:", -- Embersilk Cloak
	[14230]="0:4:2:1:Cloth::1:0:", -- Embersilk Tunic
	[14231]="0:4:2:1:Cloth::1:0:", -- Embersilk Mitts
	[14232]="0:4:2:1:Cloth::1:0:", -- Embersilk Mantle
	[14233]="0:4:2:1:Cloth::1:0:", -- Embersilk Leggings
	[14234]="0:4:2:1:Cloth::1:0:", -- Embersilk Robes
	[14235]="0:4:2:1:Cloth::1:0:", -- Embersilk Cord
	[14236]="0:4:2:1:Cloth::1:0:", -- Embersilk Boots
	[14237]="0:4:2:1:Cloth::1:0:", -- Darkmist Armor
	[14238]="0:4:2:1:Cloth::1:0:", -- Darkmist Boots
	[14239]="0:4:2:1:Cloak::1:0:", -- Darkmist Cape
	[14240]="0:4:2:1:Cloth::1:0:", -- Darkmist Bands
	[14241]="0:4:2:1:Cloth::1:0:", -- Darkmist Handguards
	[14242]="0:4:2:1:Cloth::1:0:", -- Darkmist Pants
	[14243]="0:4:2:1:Cloth::1:0:", -- Darkmist Mantle
	[14244]="0:4:2:1:Cloth::1:0:", -- Darkmist Wraps
	[14245]="0:4:2:1:Cloth::1:0:", -- Darkmist Girdle
	[14246]="0:4:2:1:Cloth::1:0:", -- Darkmist Wizard Hat
	[14247]="0:4:2:1:Cloth::1:0:", -- Lunar Mantle
	[14248]="0:4:2:1:Cloth::1:0:", -- Lunar Bindings
	[14249]="0:4:2:1:Cloth::1:0:", -- Lunar Vest
	[14250]="0:4:2:1:Cloth::1:0:", -- Lunar Slippers
	[14251]="0:4:2:1:Cloak::1:0:", -- Lunar Cloak
	[14252]="0:4:2:1:Cloth::1:0:", -- Lunar Coronet
	[14253]="0:4:2:1:Cloth::1:0:", -- Lunar Handwraps
	[14254]="0:4:2:1:Cloth::1:0:", -- Lunar Raiment
	[14255]="0:4:2:1:Cloth::1:0:", -- Lunar Belt
	[14256]="8000:7:1:20:Cloth:165,197:1:1:16015", -- Felcloth
	[14257]="0:4:2:1:Cloth::1:0:", -- Lunar Leggings
	[14258]="0:4:2:1:Cloth::1:0:", -- Bloodwoven Cord
	[14259]="0:4:2:1:Cloth::1:0:", -- Bloodwoven Boots
	[14260]="0:4:2:1:Cloth::1:0:", -- Bloodwoven Bracers
	[14261]="0:4:2:1:Cloak::1:0:", -- Bloodwoven Cloak
	[14262]="0:4:2:1:Cloth::1:0:", -- Bloodwoven Mitts
	[14263]="0:4:2:1:Cloth::1:0:", -- Bloodwoven Mask
	[14264]="0:4:2:1:Cloth::1:0:", -- Bloodwoven Pants
	[14265]="0:4:2:1:Cloth::1:0:", -- Bloodwoven Wraps
	[14266]="0:4:2:1:Cloth::1:0:", -- Bloodwoven Pads
	[14267]="0:4:2:1:Cloth::1:0:", -- Bloodwoven Jerkin
	[14268]="0:4:2:1:Cloth::1:0:", -- Gaea's Cuffs
	[14269]="0:4:2:1:Cloth::1:0:", -- Gaea's Slippers
	[14270]="0:4:2:1:Cloak::1:0:", -- Gaea's Cloak
	[14271]="0:4:2:1:Cloth::1:0:", -- Gaea's Circlet
	[14272]="0:4:2:1:Cloth::1:0:", -- Gaea's Handwraps
	[14273]="0:4:2:1:Cloth::1:0:", -- Gaea's Amice
	[14274]="0:4:2:1:Cloth::1:0:", -- Gaea's Leggings
	[14275]="0:4:2:1:Cloth::1:0:", -- Gaea's Raiment
	[14276]="0:4:2:1:Cloth::1:0:", -- Gaea's Belt
	[14277]="0:4:2:1:Cloth::1:0:", -- Gaea's Tunic
	[14278]="0:4:2:1:Cloth::1:0:", -- Opulent Mantle
	[14279]="0:4:2:1:Cloth::1:0:", -- Opulent Bracers
	[14280]="0:4:2:1:Cloak::1:0:", -- Opulent Cape
	[14281]="0:4:2:1:Cloth::1:0:", -- Opulent Crown
	[14282]="0:4:2:1:Cloth::1:0:", -- Opulent Gloves
	[14283]="0:4:2:1:Cloth::1:0:", -- Opulent Leggings
	[14284]="0:4:2:1:Cloth::1:0:", -- Opulent Robes
	[14285]="0:4:2:1:Cloth::1:0:", -- Opulent Boots
	[14286]="0:4:2:1:Cloth::1:0:", -- Opulent Belt
	[14287]="0:4:2:1:Cloth::1:0:", -- Opulent Tunic
	[14288]="0:4:2:1:Cloth::1:0:", -- Arachnidian Armor
	[14289]="0:4:2:1:Cloth::1:0:", -- Arachnidian Girdle
	[14290]="0:4:2:1:Cloth::1:0:", -- Arachnidian Footpads
	[14291]="0:4:2:1:Cloth::1:0:", -- Arachnidian Bracelets
	[14292]="0:4:2:1:Cloak::1:0:", -- Arachnidian Cape
	[14293]="0:4:2:1:Cloth::1:0:", -- Arachnidian Circlet
	[14294]="0:4:2:1:Cloth::1:0:", -- Arachnidian Gloves
	[14295]="0:4:2:1:Cloth::1:0:", -- Arachnidian Legguards
	[14296]="0:4:2:1:Cloth::1:0:", -- Arachnidian Pauldrons
	[14297]="0:4:2:1:Cloth::1:0:", -- Arachnidian Robes
	[14298]="0:4:2:1:Cloth::1:0:", -- Bonecaster's Spaulders
	[14299]="0:4:2:1:Cloth::1:0:", -- Bonecaster's Boots
	[14300]="0:4:2:1:Cloak::1:0:", -- Bonecaster's Cape
	[14301]="0:4:2:1:Cloth::1:0:", -- Bonecaster's Bindings
	[14302]="0:4:2:1:Cloth::1:0:", -- Bonecaster's Gloves
	[14303]="0:4:2:1:Cloth::1:0:", -- Bonecaster's Shroud
	[14304]="0:4:2:1:Cloth::1:0:", -- Bonecaster's Belt
	[14305]="0:4:2:1:Cloth::1:0:", -- Bonecaster's Sarong
	[14306]="0:4:2:1:Cloth::1:0:", -- Bonecaster's Vest
	[14307]="0:4:2:1:Cloth::1:0:", -- Bonecaster's Crown
	[14308]="0:4:2:1:Cloth::1:0:", -- Celestial Tunic
	[14309]="0:4:2:1:Cloth::1:0:", -- Celestial Belt
	[14310]="0:4:2:1:Cloth::1:0:", -- Celestial Slippers
	[14311]="0:4:2:1:Cloth::1:0:", -- Celestial Bindings
	[14312]="0:4:2:1:Cloth::1:0:", -- Celestial Crown
	[14313]="0:4:2:1:Cloak::1:0:", -- Celestial Cape
	[14314]="0:4:2:1:Cloth::1:0:", -- Celestial Handwraps
	[14315]="0:4:2:1:Cloth::1:0:", -- Celestial Kilt
	[14316]="0:4:2:1:Cloth::1:0:", -- Celestial Pauldrons
	[14317]="0:4:2:1:Cloth::1:0:", -- Celestial Silk Robes
	[14318]="0:4:2:1:Cloth::1:0:", -- Resplendent Tunic
	[14319]="0:4:2:1:Cloth::1:0:", -- Resplendent Boots
	[14320]="0:4:2:1:Cloth::1:0:", -- Resplendent Bracelets
	[14321]="0:4:2:1:Cloak::1:0:", -- Resplendent Cloak
	[14322]="0:4:2:1:Cloth::1:0:", -- Resplendent Circlet
	[14323]="0:4:2:1:Cloth::1:0:", -- Resplendent Gauntlets
	[14324]="0:4:2:1:Cloth::1:0:", -- Resplendent Sarong
	[14325]="0:4:2:1:Cloth::1:0:", -- Resplendent Epaulets
	[14326]="0:4:2:1:Cloth::1:0:", -- Resplendent Robes
	[14327]="0:4:2:1:Cloth::1:0:", -- Resplendent Belt
	[14328]="0:4:2:1:Cloth::1:0:", -- Eternal Chestguard
	[14329]="0:4:2:1:Cloth::1:0:", -- Eternal Boots
	[14330]="0:4:2:1:Cloth::1:0:", -- Eternal Bindings
	[14331]="0:4:2:1:Cloak::1:0:", -- Eternal Cloak
	[14332]="0:4:2:1:Cloth::1:0:", -- Eternal Crown
	[14333]="0:4:2:1:Cloth::1:0:", -- Eternal Gloves
	[14334]="0:4:2:1:Cloth::1:0:", -- Eternal Sarong
	[14335]="0:4:2:1:Cloth::1:0:", -- Eternal Spaulders
	[14336]="0:4:2:1:Cloth::1:0:", -- Eternal Wraps
	[14337]="0:4:2:1:Cloth::1:0:", -- Eternal Cord
	[14338]="0:12:1:1:::1:0:", -- Empty Water Tube
	[14339]="0:12:1:1:::1:0:", -- Moonwell Water Tube
	[14340]="0:4:3:1:Cloth::1:0:", -- Freezing Lich Robes
	[14341]="5000:7:1:20:Cloth:165,197:1:0:989,1148,1286,1347,1454,1474,1672,2225,2394,2668,2669,2670,2672,2697,2698,2699,2810,2816,2819,2821,2846,3005,3091,3096,3364,3366,3367,3485,3779,3954,3955,3958,4168,4189,4225,4229,4561,4577,4589,4775,4897,5128,5135,5154,5163,5565,5783,5817,5944,6301,6567,6568,6574,6576,6731,7852,7854,7940,7947,8145,8160,8363,8681,8934,11189,11557,11874,12022,12028,12245,12941,12942,12943,12956,12957,12958,15165,15179,16366,16602,16613,16638,16689,16748,16767,16768,16826,17486,18009,18015,18277,18749,18754,18771,18772,18907,18960,19015,19017,19042,19194,19196,19197,19213,19244,19345,19372,19450,19497,19521,19532,19533,19562,19573,19722,20081,20092,20194,20250,20891,21083,21085,21113,22099,22271,23802,24054,24147,24188,24341,24356,24843,24935,24995,25010,25019,25034,25051,25082,26374,26474,26720,26939,26941,27012,27021,27026,27043,27057,27063,27070,27132,27146,27184,27195,27938,28692,28718,28726,28794,28798,28806,28810,28831,28872,29208,29270,29277,29288,30311,30345,30438,30825,31115,32477,32639,32641,33596,33601,33635,33636,33669,33681,33684,37904,37935", -- Rune Thread
	[14342]="0:7:1:20:Cloth:165,197:1:0:", -- Mooncloth
	[14343]="0:7:3:20:Enchanting:333:1:0:", -- Small Brilliant Shard
	[14344]="0:7:3:20:Enchanting:333,197:1:0:", -- Large Brilliant Shard
	[14364]="0:4:2:1:Cloth::1:0:", -- Mystic's Slippers
	[14365]="0:4:2:1:Cloak::1:0:", -- Mystic's Cape
	[14366]="0:4:2:1:Cloth::1:0:", -- Mystic's Bracelets
	[14367]="0:4:2:1:Cloth::1:0:", -- Mystic's Gloves
	[14368]="0:4:1:1:Cloth::1:0:", -- Mystic's Shoulder Pads
	[14369]="0:4:2:1:Cloth::1:0:", -- Mystic's Wrap
	[14370]="0:4:2:1:Cloth::1:0:", -- Mystic's Woolies
	[14371]="0:4:2:1:Cloth::1:0:", -- Mystic's Robe
	[14372]="0:4:2:1:Cloth::1:0:", -- Sanguine Armor
	[14373]="0:4:2:1:Cloth::1:0:", -- Sanguine Belt
	[14374]="0:4:2:1:Cloth::1:0:", -- Sanguine Sandals
	[14375]="0:4:2:1:Cloth::1:0:", -- Sanguine Cuffs
	[14376]="0:4:2:1:Cloak::1:0:", -- Sanguine Cape
	[14377]="0:4:2:1:Cloth::1:0:", -- Sanguine Handwraps
	[14378]="0:4:2:1:Cloth::1:0:", -- Sanguine Mantle
	[14379]="0:4:2:1:Cloth::1:0:", -- Sanguine Trousers
	[14380]="0:4:2:1:Cloth::1:0:", -- Sanguine Robe
	[14381]="0:12:1:1:::1:0:", -- Grimtotem Satchel
	[14395]="0:12:1:1:::1:0:", -- Spells of Shadow
	[14396]="0:12:1:1:::1:0:", -- Incantations from the Nether
	[14397]="0:4:2:1:Cloth::1:0:", -- Resilient Mantle
	[14398]="0:4:2:1:Cloth::1:0:", -- Resilient Tunic
	[14399]="0:4:2:1:Cloth::1:0:", -- Resilient Boots
	[14400]="0:4:2:1:Cloak::1:0:", -- Resilient Cape
	[14401]="0:4:2:1:Cloth::1:0:", -- Resilient Cap
	[14402]="0:4:2:1:Cloth::1:0:", -- Resilient Bands
	[14403]="0:4:2:1:Cloth::1:0:", -- Resilient Handgrips
	[14404]="0:4:2:1:Cloth::1:0:", -- Resilient Leggings
	[14405]="0:4:2:1:Cloth::1:0:", -- Resilient Robe
	[14406]="0:4:2:1:Cloth::1:0:", -- Resilient Cord
	[14407]="0:4:2:1:Cloth::1:0:", -- Stonecloth Vest
	[14408]="0:4:2:1:Cloth::1:0:", -- Stonecloth Boots
	[14409]="0:4:2:1:Cloak::1:0:", -- Stonecloth Cape
	[14410]="0:4:2:1:Cloth::1:0:", -- Stonecloth Circlet
	[14411]="0:4:2:1:Cloth::1:0:", -- Stonecloth Gloves
	[14412]="0:4:2:1:Cloth::1:0:", -- Stonecloth Epaulets
	[14413]="0:4:2:1:Cloth::1:0:", -- Stonecloth Robe
	[14414]="0:4:2:1:Cloth::1:0:", -- Stonecloth Belt
	[14415]="0:4:2:1:Cloth::1:0:", -- Stonecloth Britches
	[14416]="0:4:2:1:Cloth::1:0:", -- Stonecloth Bindings
	[14417]="0:4:2:1:Cloth::1:0:", -- Silksand Tunic
	[14418]="0:4:2:1:Cloth::1:0:", -- Silksand Boots
	[14419]="0:4:2:1:Cloth::1:0:", -- Silksand Bracers
	[14420]="0:4:2:1:Cloak::1:0:", -- Silksand Cape
	[14421]="0:4:2:1:Cloth::1:0:", -- Silksand Circlet
	[14422]="0:4:2:1:Cloth::1:0:", -- Silksand Gloves
	[14423]="0:4:2:1:Cloth::1:0:", -- Silksand Shoulder Pads
	[14424]="0:4:2:1:Cloth::1:0:", -- Silksand Legwraps
	[14425]="0:4:2:1:Cloth::1:0:", -- Silksand Wraps
	[14426]="0:4:2:1:Cloth::1:0:", -- Silksand Girdle
	[14427]="0:4:2:1:Cloth::1:0:", -- Windchaser Wraps
	[14428]="0:4:2:1:Cloth::1:0:", -- Windchaser Footpads
	[14429]="0:4:2:1:Cloth::1:0:", -- Windchaser Cuffs
	[14430]="0:4:2:1:Cloak::1:0:", -- Windchaser Cloak
	[14431]="0:4:2:1:Cloth::1:0:", -- Windchaser Handguards
	[14432]="0:4:2:1:Cloth::1:0:", -- Windchaser Amice
	[14433]="0:4:2:1:Cloth::1:0:", -- Windchaser Woolies
	[14434]="0:4:2:1:Cloth::1:0:", -- Windchaser Robes
	[14435]="0:4:2:1:Cloth::1:0:", -- Windchaser Cinch
	[14436]="0:4:2:1:Cloth::1:0:", -- Windchaser Coronet
	[14437]="0:4:2:1:Cloth::1:0:", -- Venomshroud Vest
	[14438]="0:4:2:1:Cloth::1:0:", -- Venomshroud Boots
	[14439]="0:4:2:1:Cloth::1:0:", -- Venomshroud Armguards
	[14440]="0:4:2:1:Cloak::1:0:", -- Venomshroud Cape
	[14441]="0:4:2:1:Cloth::1:0:", -- Venomshroud Mask
	[14442]="0:4:2:1:Cloth::1:0:", -- Venomshroud Mitts
	[14443]="0:4:2:1:Cloth::1:0:", -- Venomshroud Mantle
	[14444]="0:4:2:1:Cloth::1:0:", -- Venomshroud Leggings
	[14445]="0:4:2:1:Cloth::1:0:", -- Venomshroud Silk Robes
	[14446]="0:4:2:1:Cloth::1:0:", -- Venomshroud Belt
	[14447]="0:4:2:1:Cloth::1:0:", -- Highborne Footpads
	[14448]="0:4:2:1:Cloth::1:0:", -- Highborne Bracelets
	[14449]="0:4:2:1:Cloth::1:0:", -- Highborne Crown
	[14450]="0:4:2:1:Cloak::1:0:", -- Highborne Cloak
	[14451]="0:4:2:1:Cloth::1:0:", -- Highborne Gloves
	[14452]="0:4:2:1:Cloth::1:0:", -- Highborne Pauldrons
	[14453]="0:4:2:1:Cloth::1:0:", -- Highborne Robes
	[14454]="0:4:2:1:Cloth::1:0:", -- Highborne Cord
	[14455]="0:4:2:1:Cloth::1:0:", -- Highborne Padded Armor
	[14456]="0:4:2:1:Cloth::1:0:", -- Elunarian Vest
	[14457]="0:4:2:1:Cloth::1:0:", -- Elunarian Cuffs
	[14458]="0:4:2:1:Cloth::1:0:", -- Elunarian Boots
	[14459]="0:4:2:1:Cloak::1:0:", -- Elunarian Cloak
	[14460]="0:4:2:1:Cloth::1:0:", -- Elunarian Diadem
	[14461]="0:4:2:1:Cloth::1:0:", -- Elunarian Handgrips
	[14462]="0:4:2:1:Cloth::1:0:", -- Elunarian Sarong
	[14463]="0:4:2:1:Cloth::1:0:", -- Elunarian Spaulders
	[14464]="0:4:2:1:Cloth::1:0:", -- Elunarian Silk Robes
	[14465]="0:4:2:1:Cloth::1:0:", -- Elunarian Belt
	[14466]="0:9:2:1:Tailoring::1:0:", -- Pattern: Frostweave Tunic
	[14467]="0:9:2:1:Tailoring::1:0:", -- Pattern: Frostweave Robe
	[14468]="12000:9:1:1:Tailoring::1:1:11189", -- Pattern: Runecloth Bag
	[14469]="12000:9:1:1:Tailoring::1:1:7940", -- Pattern: Runecloth Robe
	[14470]="0:9:2:1:Tailoring::1:0:", -- Pattern: Runecloth Tunic
	[14471]="0:9:2:1:Tailoring::1:0:", -- Pattern: Cindercloth Vest
	[14472]="12000:9:1:1:Tailoring::1:1:7940", -- Pattern: Runecloth Cloak
	[14473]="0:9:2:1:Tailoring::1:0:", -- Pattern: Ghostweave Belt
	[14474]="0:9:2:1:Tailoring::1:0:", -- Pattern: Frostweave Gloves
	[14476]="0:9:2:1:Tailoring::1:0:", -- Pattern: Cindercloth Gloves
	[14477]="0:9:2:1:Tailoring::1:0:", -- Pattern: Ghostweave Gloves
	[14478]="0:9:2:1:Tailoring::1:0:", -- Pattern: Brightcloth Robe
	[14479]="0:9:2:1:Tailoring::1:0:", -- Pattern: Brightcloth Gloves
	[14480]="0:9:2:1:Tailoring::1:0:", -- Pattern: Ghostweave Vest
	[14481]="0:9:1:1:Tailoring::1:0:", -- Pattern: Runecloth Gloves
	[14482]="0:9:2:1:Tailoring::1:0:", -- Pattern: Cindercloth Cloak
	[14483]="16000:9:1:1:Tailoring::1:1:12022", -- Pattern: Felcloth Pants
	[14484]="0:9:2:1:Tailoring::1:0:", -- Pattern: Brightcloth Cloak
	[14485]="0:9:2:1:Tailoring::1:0:", -- Pattern: Wizardweave Leggings
	[14486]="0:9:3:1:Tailoring::1:0:", -- Pattern: Cloak of Fire
	[14487]="0:2:3:1:OneHandMace::1:0:", -- Bonechill Hammer
	[14488]="0:9:1:1:Tailoring::1:0:", -- Pattern: Runecloth Boots
	[14489]="0:9:2:1:Tailoring::1:0:", -- Pattern: Frostweave Pants
	[14490]="0:9:2:1:Tailoring::1:0:", -- Pattern: Cindercloth Pants
	[14491]="0:9:2:1:Tailoring::1:0:", -- Pattern: Runecloth Pants
	[14492]="0:9:2:1:Tailoring::1:0:", -- Pattern: Felcloth Boots
	[14493]="0:9:3:1:Tailoring::1:0:", -- Pattern: Robe of Winter Night
	[14494]="0:9:2:1:Tailoring::1:0:", -- Pattern: Brightcloth Pants
	[14495]="0:9:2:1:Tailoring::1:0:", -- Pattern: Ghostweave Pants
	[14496]="0:9:2:1:Tailoring::1:0:", -- Pattern: Felcloth Hood
	[14497]="0:9:3:1:Tailoring::1:0:", -- Pattern: Mooncloth Leggings
	[14498]="0:9:2:1:Tailoring::1:0:", -- Pattern: Runecloth Headband
	[14499]="0:9:2:1:Tailoring::1:0:", -- Pattern: Mooncloth Bag
	[14500]="0:9:2:1:Tailoring::1:0:", -- Pattern: Wizardweave Robe
	[14501]="0:9:3:1:Tailoring::1:0:", -- Pattern: Mooncloth Vest
	[14502]="0:4:3:1:Leather::1:0:", -- Frostbite Girdle
	[14503]="0:4:3:1:Leather::1:0:", -- Death's Clutch
	[14504]="0:9:2:1:Tailoring::1:0:", -- Pattern: Runecloth Shoulders
	[14505]="0:9:2:1:Tailoring::1:0:", -- Pattern: Wizardweave Turban
	[14506]="0:9:2:1:Tailoring::1:0:", -- Pattern: Felcloth Robe
	[14507]="0:9:3:1:Tailoring::1:0:", -- Pattern: Mooncloth Shoulders
	[14508]="0:9:2:1:Tailoring::1:0:", -- Pattern: Felcloth Shoulders
	[14509]="0:9:3:1:Tailoring::1:0:", -- Pattern: Mooncloth Circlet
	[14510]="0:9:3:1:Tailoring::1:0:", -- Pattern: Bottomless Bag
	[14511]="0:9:4:1:Tailoring::1:0:", -- Pattern: Gloves of Spell Mastery
	[14512]="0:9:4:1:Tailoring::1:0:", -- Pattern: Truefaith Vestments
	[14513]="0:9:4:1:Tailoring::1:0:", -- Pattern: Robe of the Archmage
	[14514]="0:9:4:1:Tailoring::1:0:", -- Pattern: Robe of the Void
	[14522]="0:4:3:1:Mail::1:0:", -- Maelstrom Leggings
	[14523]="0:12:1:1:::1:0:", -- Demon Pick
	[14525]="0:4:3:1:Plate::1:0:", -- Boneclenched Gauntlets
	[14526]="20000:9:1:1:Tailoring::1:0:11189", -- Pattern: Mooncloth
	[14528]="0:4:3:1:Shield::1:0:", -- Rattlecage Buckler
	[14529]="0:0:1:20:Bandage::1:0:", -- Runecloth Bandage
	[14530]="4000:0:1:20:Bandage::1:1:15471", -- Heavy Runecloth Bandage
	[14531]="0:2:3:1:TwoHandMace::1:0:", -- Frightskull Shaft
	[14536]="0:4:3:1:Mail::1:0:", -- Bonebrace Hauberk
	[14537]="0:4:3:1:Plate::1:0:", -- Corpselight Greaves
	[14538]="0:4:3:1:Cloth::1:0:", -- Deadwalker Mantle
	[14539]="0:4:3:1:Leather::1:0:", -- Bone Ring Helm
	[14540]="0:12:1:1:::1:0:", -- Taragaman the Hungerer's Heart
	[14541]="0:2:3:1:TwoHandSword::1:0:", -- Barovian Family Sword
	[14542]="0:0:1:1:Consumable::1:0:", -- Kravel's Crate
	[14543]="0:4:3:1:Cloth::1:0:", -- Darkshade Gloves
	[14544]="0:12:1:1:::1:0:", -- Lieutenant's Insignia
	[14545]="0:4:3:1:Leather::1:0:", -- Ghostloom Leggings
	[14546]="0:12:1:1:::1:0:", -- Roon's Kodo Horn
	[14547]="0:12:1:1:::1:0:", -- Hand of Iruxos
	[14548]="0:4:3:1:Mail::1:0:", -- Royal Cap Spaulders
	[14549]="0:4:4:1:Plate::1:0:", -- Boots of Avoidance
	[14551]="0:4:4:1:Mail::1:0:", -- Edgemaster's Handguards
	[14552]="0:4:4:1:Plate::1:0:", -- Stockade Pauldrons
	[14553]="0:4:4:1:Leather::1:0:", -- Sash of Mercy
	[14554]="0:4:4:1:Plate::1:0:", -- Cloudkeeper Legplates
	[14555]="0:2:4:1:Dagger::1:0:", -- Alcor's Sunrazor
	[14557]="0:4:4:1:Trinket::1:0:", -- The Lion Horn of Stormwind
	[14558]="0:4:4:1:Amulet::1:0:", -- Lady Maye's Pendant
	[14559]="0:4:2:1:Leather::1:0:", -- Prospector's Sash
	[14560]="0:4:2:1:Leather::1:0:", -- Prospector's Boots
	[14561]="0:4:2:1:Leather::1:0:", -- Prospector's Cuffs
	[14562]="0:4:2:1:Leather::1:0:", -- Prospector's Chestpiece
	[14563]="0:4:2:1:Cloak::1:0:", -- Prospector's Cloak
	[14564]="0:4:2:1:Leather::1:0:", -- Prospector's Mitts
	[14565]="0:4:2:1:Leather::1:0:", -- Prospector's Woolies
	[14566]="0:4:2:1:Leather::1:0:", -- Prospector's Pads
	[14567]="0:4:2:1:Leather::1:0:", -- Bristlebark Belt
	[14568]="0:4:2:1:Leather::1:0:", -- Bristlebark Boots
	[14569]="0:4:2:1:Leather::1:0:", -- Bristlebark Bindings
	[14570]="0:4:2:1:Leather::1:0:", -- Bristlebark Blouse
	[14571]="0:4:2:1:Cloak::1:0:", -- Bristlebark Cape
	[14572]="0:4:2:1:Leather::1:0:", -- Bristlebark Gloves
	[14573]="0:4:2:1:Leather::1:0:", -- Bristlebark Amice
	[14574]="0:4:2:1:Leather::1:0:", -- Bristlebark Britches
	[14576]="0:2:3:1:OneHandSword::1:0:", -- Ebon Hilt of Marduk
	[14577]="0:4:3:1:Cloth::1:0:", -- Skullsmoke Pants
	[14578]="0:4:2:1:Leather::1:0:", -- Dokebi Cord
	[14579]="0:4:2:1:Leather::1:0:", -- Dokebi Boots
	[14580]="0:4:2:1:Leather::1:0:", -- Dokebi Bracers
	[14581]="0:4:2:1:Leather::1:0:", -- Dokebi Chestguard
	[14582]="0:4:2:1:Cloak::1:0:", -- Dokebi Cape
	[14583]="0:4:2:1:Leather::1:0:", -- Dokebi Gloves
	[14584]="0:4:2:1:Leather::1:0:", -- Dokebi Hat
	[14585]="0:4:2:1:Leather::1:0:", -- Dokebi Leggings
	[14587]="0:4:2:1:Leather::1:0:", -- Dokebi Mantle
	[14588]="0:4:2:1:Leather::1:0:", -- Hawkeye's Cord
	[14589]="0:4:2:1:Leather::1:0:", -- Hawkeye's Shoes
	[14590]="0:4:2:1:Leather::1:0:", -- Hawkeye's Bracers
	[14591]="0:4:2:1:Leather::1:0:", -- Hawkeye's Helm
	[14592]="0:4:2:1:Leather::1:0:", -- Hawkeye's Tunic
	[14593]="0:4:2:1:Cloak::1:0:", -- Hawkeye's Cloak
	[14594]="0:4:2:1:Leather::1:0:", -- Hawkeye's Gloves
	[14595]="0:4:2:1:Leather::1:0:", -- Hawkeye's Breeches
	[14596]="0:4:2:1:Leather::1:0:", -- Hawkeye's Epaulets
	[14598]="0:4:2:1:Leather::1:0:", -- Warden's Waistband
	[14599]="0:4:2:1:Leather::1:0:", -- Warden's Footpads
	[14600]="0:4:2:1:Leather::1:0:", -- Warden's Wristbands
	[14601]="0:4:2:1:Leather::1:0:", -- Warden's Wraps
	[14602]="0:4:2:1:Cloak::1:0:", -- Warden's Cloak
	[14603]="0:4:2:1:Leather::1:0:", -- Warden's Mantle
	[14604]="0:4:2:1:Leather::1:0:", -- Warden's Wizard Hat
	[14605]="0:4:2:1:Leather::1:0:", -- Warden's Woolies
	[14606]="0:4:2:1:Leather::1:0:", -- Warden's Gloves
	[14607]="0:4:2:1:Shield::1:0:", -- Hawkeye's Buckler
	[14608]="0:4:2:1:Shield::1:0:", -- Dokebi Buckler
	[14610]="0:12:1:1:::1:0:", -- Araj's Scarab
	[14611]="0:4:3:1:Mail::1:0:", -- Bloodmail Hauberk
	[14612]="0:4:3:1:Mail::1:0:", -- Bloodmail Legguards
	[14613]="0:12:1:1:::1:0:", -- Taelan's Hammer
	[14614]="0:4:3:1:Mail::1:0:", -- Bloodmail Belt
	[14615]="0:4:3:1:Mail::1:0:", -- Bloodmail Gauntlets
	[14616]="0:4:3:1:Mail::1:0:", -- Bloodmail Boots
	[14617]="0:4:1:1:Shirt::1:0:", -- Sawbones Shirt
	[14619]="0:12:1:20:::1:0:", -- Skeletal Fragments
	[14620]="0:4:3:1:Plate::1:0:", -- Deathbone Girdle
	[14621]="0:4:3:1:Plate::1:0:", -- Deathbone Sabatons
	[14622]="0:4:3:1:Plate::1:0:", -- Deathbone Gauntlets
	[14623]="0:4:3:1:Plate::1:0:", -- Deathbone Legguards
	[14624]="0:4:3:1:Plate::1:0:", -- Deathbone Chestplate
	[14625]="0:12:1:1:::1:0:", -- Symbol of Lost Honor
	[14626]="0:4:3:1:Cloth::1:0:", -- Necropile Robe
	[14627]="800:9:1:1:Tailoring::1:1:2668", -- Pattern: Bright Yellow Shirt
	[14628]="0:12:1:1:::1:0:", -- Imbued Skeletal Fragments
	[14629]="0:4:3:1:Cloth::1:0:", -- Necropile Cuffs
	[14630]="1000:9:1:1:Tailoring::1:1:2670", -- Pattern: Enchanter's Cowl
	[14631]="0:4:3:1:Cloth::1:0:", -- Necropile Boots
	[14632]="0:4:3:1:Cloth::1:0:", -- Necropile Leggings
	[14633]="0:4:3:1:Cloth::1:0:", -- Necropile Mantle
	[14634]="2500:9:2:1:Alchemy::1:1:2480", -- Recipe: Frost Oil
	[14635]="3000:9:1:1:Leatherworking::1:1:2699", -- Pattern: Gem-studded Leather Belt
	[14636]="0:4:3:1:Leather::1:0:", -- Cadaverous Belt
	[14637]="0:4:3:1:Leather::1:0:", -- Cadaverous Armor
	[14638]="0:4:3:1:Leather::1:0:", -- Cadaverous Leggings
	[14639]="1500:9:1:1:Engineering::1:1:2682,2683,3495", -- Schematic: Minor Recombobulator
	[14640]="0:4:3:1:Leather::1:0:", -- Cadaverous Gloves
	[14641]="0:4:3:1:Leather::1:0:", -- Cadaverous Walkers
	[14644]="0:12:1:1:::1:0:", -- Skeleton Key Mold
	[14645]="0:12:1:1:::1:0:", -- Unfinished Skeleton Key
	[14646]="0:12:1:1:::1:0:", -- Goldshire Gift Voucher
	[14647]="0:12:1:1:::1:0:", -- Kharanos Gift Voucher
	[14648]="0:12:1:1:::1:0:", -- Dolanaar Gift Voucher
	[14649]="0:12:1:1:::1:0:", -- Razor Hill Gift Voucher
	[14650]="0:12:1:1:::1:0:", -- Bloodhoof Village Gift Voucher
	[14651]="0:12:1:1:::1:0:", -- Brill Gift Voucher
	[14652]="0:4:2:1:Leather::1:0:", -- Scorpashi Sash
	[14653]="0:4:2:1:Leather::1:0:", -- Scorpashi Slippers
	[14654]="0:4:2:1:Leather::1:0:", -- Scorpashi Wristbands
	[14655]="0:4:2:1:Leather::1:0:", -- Scorpashi Breastplate
	[14656]="0:4:2:1:Cloak::1:0:", -- Scorpashi Cape
	[14657]="0:4:2:1:Leather::1:0:", -- Scorpashi Gloves
	[14658]="0:4:2:1:Leather::1:0:", -- Scorpashi Skullcap
	[14659]="0:4:2:1:Leather::1:0:", -- Scorpashi Leggings
	[14660]="0:4:2:1:Leather::1:0:", -- Scorpashi Shoulder Pads
	[14661]="0:4:2:1:Leather::1:0:", -- Keeper's Cord
	[14662]="0:4:2:1:Leather::1:0:", -- Keeper's Hooves
	[14663]="0:4:2:1:Leather::1:0:", -- Keeper's Bindings
	[14664]="0:4:2:1:Leather::1:0:", -- Keeper's Armor
	[14665]="0:4:2:1:Cloak::1:0:", -- Keeper's Cloak
	[14666]="0:4:2:1:Leather::1:0:", -- Keeper's Gloves
	[14667]="0:4:2:1:Leather::1:0:", -- Keeper's Wreath
	[14668]="0:4:2:1:Leather::1:0:", -- Keeper's Woolies
	[14669]="0:4:2:1:Leather::1:0:", -- Keeper's Mantle
	[14670]="0:4:2:1:Leather::1:0:", -- Pridelord Armor
	[14671]="0:4:2:1:Leather::1:0:", -- Pridelord Boots
	[14672]="0:4:2:1:Leather::1:0:", -- Pridelord Bands
	[14673]="0:4:2:1:Cloak::1:0:", -- Pridelord Cape
	[14674]="0:4:2:1:Leather::1:0:", -- Pridelord Girdle
	[14675]="0:4:2:1:Leather::1:0:", -- Pridelord Gloves
	[14676]="0:4:2:1:Leather::1:0:", -- Pridelord Halo
	[14677]="0:4:2:1:Leather::1:0:", -- Pridelord Pants
	[14678]="0:4:2:1:Leather::1:0:", -- Pridelord Pauldrons
	[14679]="0:12:1:1:::1:0:", -- Of Love and Family
	[14680]="0:4:2:1:Leather::1:0:", -- Indomitable Vest
	[14681]="0:4:2:1:Leather::1:0:", -- Indomitable Boots
	[14682]="0:4:2:1:Leather::1:0:", -- Indomitable Armguards
	[14683]="0:4:2:1:Cloak::1:0:", -- Indomitable Cloak
	[14684]="0:4:2:1:Leather::1:0:", -- Indomitable Belt
	[14685]="0:4:2:1:Leather::1:0:", -- Indomitable Gauntlets
	[14686]="0:4:2:1:Leather::1:0:", -- Indomitable Headdress
	[14687]="0:4:2:1:Leather::1:0:", -- Indomitable Leggings
	[14688]="0:4:2:1:Leather::1:0:", -- Indomitable Epaulets
	[14722]="0:4:2:1:Mail::1:0:", -- War Paint Anklewraps
	[14723]="0:4:2:1:Mail::1:0:", -- War Paint Bindings
	[14724]="0:4:2:1:Cloak::1:0:", -- War Paint Cloak
	[14725]="0:4:2:1:Mail::1:0:", -- War Paint Waistband
	[14726]="0:4:2:1:Mail::1:0:", -- War Paint Gloves
	[14727]="0:4:2:1:Mail::1:0:", -- War Paint Legguards
	[14728]="0:4:1:1:Mail::1:0:", -- War Paint Shoulder Pads
	[14729]="0:4:2:1:Shield::1:0:", -- War Paint Shield
	[14730]="0:4:2:1:Mail::1:0:", -- War Paint Chestpiece
	[14742]="0:4:2:1:Mail::1:0:", -- Hulking Boots
	[14743]="0:4:2:1:Mail::1:0:", -- Hulking Bands
	[14744]="0:4:2:1:Mail::1:0:", -- Hulking Chestguard
	[14745]="0:4:2:1:Cloak::1:0:", -- Hulking Cloak
	[14746]="0:4:2:1:Mail::1:0:", -- Hulking Belt
	[14747]="0:4:2:1:Mail::1:0:", -- Hulking Gauntlets
	[14748]="0:4:2:1:Mail::1:0:", -- Hulking Leggings
	[14749]="0:4:2:1:Mail::1:0:", -- Hulking Spaulders
	[14750]="0:4:2:1:Mail::1:0:", -- Slayer's Cuffs
	[14751]="0:4:2:1:Mail::1:0:", -- Slayer's Surcoat
	[14752]="0:4:2:1:Cloak::1:0:", -- Slayer's Cape
	[14753]="0:4:2:1:Mail::1:0:", -- Slayer's Skullcap
	[14754]="0:4:2:1:Mail::1:0:", -- Slayer's Gloves
	[14755]="0:4:2:1:Mail::1:0:", -- Slayer's Sash
	[14756]="0:4:2:1:Mail::1:0:", -- Slayer's Slippers
	[14757]="0:4:2:1:Mail::1:0:", -- Slayer's Pants
	[14758]="0:4:2:1:Mail::1:0:", -- Slayer's Shoulderguards
	[14759]="0:4:2:1:Mail::1:0:", -- Enduring Bracers
	[14760]="0:4:2:1:Mail::1:0:", -- Enduring Breastplate
	[14761]="0:4:2:1:Mail::1:0:", -- Enduring Belt
	[14762]="0:4:2:1:Mail::1:0:", -- Enduring Boots
	[14763]="0:4:2:1:Cloak::1:0:", -- Enduring Cape
	[14764]="0:4:2:1:Mail::1:0:", -- Enduring Gauntlets
	[14765]="0:4:2:1:Mail::1:0:", -- Enduring Circlet
	[14766]="0:4:2:1:Mail::1:0:", -- Enduring Breeches
	[14767]="0:4:2:1:Mail::1:0:", -- Enduring Pauldrons
	[14768]="0:4:2:1:Mail::1:0:", -- Ravager's Armor
	[14769]="0:4:2:1:Mail::1:0:", -- Ravager's Sandals
	[14770]="0:4:2:1:Mail::1:0:", -- Ravager's Armguards
	[14771]="0:4:2:1:Cloak::1:0:", -- Ravager's Cloak
	[14772]="0:4:2:1:Mail::1:0:", -- Ravager's Handwraps
	[14773]="0:4:2:1:Mail::1:0:", -- Ravager's Cord
	[14774]="0:4:2:1:Mail::1:0:", -- Ravager's Crown
	[14775]="0:4:2:1:Mail::1:0:", -- Ravager's Woolies
	[14776]="0:4:2:1:Mail::1:0:", -- Ravager's Mantle
	[14777]="0:4:2:1:Shield::1:0:", -- Ravager's Shield
	[14778]="0:4:2:1:Mail::1:0:", -- Khan's Bindings
	[14779]="0:4:2:1:Mail::1:0:", -- Khan's Chestpiece
	[14780]="0:4:2:1:Shield::1:0:", -- Khan's Buckler
	[14781]="0:4:2:1:Cloak::1:0:", -- Khan's Cloak
	[14782]="0:4:2:1:Mail::1:0:", -- Khan's Gloves
	[14783]="0:4:2:1:Mail::1:0:", -- Khan's Belt
	[14784]="0:4:2:1:Mail::1:0:", -- Khan's Greaves
	[14785]="0:4:2:1:Mail::1:0:", -- Khan's Helmet
	[14786]="0:4:2:1:Mail::1:0:", -- Khan's Legguards
	[14787]="0:4:2:1:Mail::1:0:", -- Khan's Mantle
	[14788]="0:4:2:1:Mail::1:0:", -- Protector Armguards
	[14789]="0:4:2:1:Mail::1:0:", -- Protector Breastplate
	[14790]="0:4:2:1:Shield::1:0:", -- Protector Buckler
	[14791]="0:4:2:1:Cloak::1:0:", -- Protector Cape
	[14792]="0:4:2:1:Mail::1:0:", -- Protector Gauntlets
	[14793]="0:4:2:1:Mail::1:0:", -- Protector Waistband
	[14794]="0:4:2:1:Mail::1:0:", -- Protector Ankleguards
	[14795]="0:4:2:1:Mail::1:0:", -- Protector Helm
	[14796]="0:4:2:1:Mail::1:0:", -- Protector Legguards
	[14797]="0:4:2:1:Mail::1:0:", -- Protector Pads
	[14798]="0:4:2:1:Mail::1:0:", -- Bloodlust Breastplate
	[14799]="0:4:2:1:Mail::1:0:", -- Bloodlust Boots
	[14800]="0:4:2:1:Shield::1:0:", -- Bloodlust Buckler
	[14801]="0:4:2:1:Cloak::1:0:", -- Bloodlust Cape
	[14802]="0:4:2:1:Mail::1:0:", -- Bloodlust Gauntlets
	[14803]="0:4:2:1:Mail::1:0:", -- Bloodlust Belt
	[14804]="0:4:2:1:Mail::1:0:", -- Bloodlust Helm
	[14805]="0:4:2:1:Mail::1:0:", -- Bloodlust Britches
	[14806]="0:4:2:1:Mail::1:0:", -- Bloodlust Epaulets
	[14807]="0:4:2:1:Mail::1:0:", -- Bloodlust Bracelets
	[14808]="0:4:2:1:Mail::1:0:", -- Warstrike Belt
	[14809]="0:4:2:1:Mail::1:0:", -- Warstrike Sabatons
	[14810]="0:4:2:1:Mail::1:0:", -- Warstrike Armsplints
	[14811]="0:4:2:1:Mail::1:0:", -- Warstrike Chestguard
	[14812]="0:4:2:1:Shield::1:0:", -- Warstrike Buckler
	[14813]="0:4:2:1:Cloak::1:0:", -- Warstrike Cape
	[14814]="0:4:2:1:Mail::1:0:", -- Warstrike Helmet
	[14815]="0:4:2:1:Mail::1:0:", -- Warstrike Gauntlets
	[14816]="0:4:2:1:Mail::1:0:", -- Warstrike Legguards
	[14817]="0:4:2:1:Mail::1:0:", -- Warstrike Shoulder Pads
	[14821]="0:4:2:1:Plate::1:0:", -- Symbolic Breastplate
	[14825]="0:4:2:1:Shield::1:0:", -- Symbolic Crest
	[14826]="0:4:2:1:Plate::1:0:", -- Symbolic Gauntlets
	[14827]="0:4:2:1:Plate::1:0:", -- Symbolic Belt
	[14828]="0:4:2:1:Plate::1:0:", -- Symbolic Greaves
	[14829]="0:4:2:1:Plate::1:0:", -- Symbolic Legplates
	[14830]="0:4:2:1:Plate::1:0:", -- Symbolic Pauldrons
	[14831]="0:4:2:1:Plate::1:0:", -- Symbolic Crown
	[14832]="0:4:2:1:Plate::1:0:", -- Symbolic Vambraces
	[14833]="0:4:2:1:Plate::1:0:", -- Tyrant's Gauntlets
	[14834]="0:4:2:1:Plate::1:0:", -- Tyrant's Armguards
	[14835]="0:4:2:1:Plate::1:0:", -- Tyrant's Chestpiece
	[14838]="0:4:2:1:Plate::1:0:", -- Tyrant's Belt
	[14839]="0:4:2:1:Plate::1:0:", -- Tyrant's Greaves
	[14840]="0:4:2:1:Plate::1:0:", -- Tyrant's Legplates
	[14841]="0:4:2:1:Plate::1:0:", -- Tyrant's Epaulets
	[14842]="0:4:2:1:Shield::1:0:", -- Tyrant's Shield
	[14843]="0:4:2:1:Plate::1:0:", -- Tyrant's Helm
	[14844]="0:4:2:1:Plate::1:0:", -- Sunscale Chestguard
	[14846]="0:4:2:1:Plate::1:0:", -- Sunscale Gauntlets
	[14847]="0:4:2:1:Plate::1:0:", -- Sunscale Belt
	[14848]="0:4:2:1:Plate::1:0:", -- Sunscale Sabatons
	[14849]="0:4:2:1:Plate::1:0:", -- Sunscale Helmet
	[14850]="0:4:2:1:Plate::1:0:", -- Sunscale Legplates
	[14851]="0:4:2:1:Plate::1:0:", -- Sunscale Spaulders
	[14852]="0:4:2:1:Shield::1:0:", -- Sunscale Shield
	[14853]="0:4:2:1:Plate::1:0:", -- Sunscale Wristguards
	[14854]="0:4:2:1:Plate::1:0:", -- Vanguard Breastplate
	[14855]="0:4:2:1:Plate::1:0:", -- Vanguard Gauntlets
	[14856]="0:4:2:1:Plate::1:0:", -- Vanguard Girdle
	[14857]="0:4:2:1:Plate::1:0:", -- Vanguard Sabatons
	[14858]="0:4:2:1:Plate::1:0:", -- Vanguard Headdress
	[14859]="0:4:2:1:Plate::1:0:", -- Vanguard Legplates
	[14860]="0:4:2:1:Plate::1:0:", -- Vanguard Pauldrons
	[14861]="0:4:2:1:Plate::1:0:", -- Vanguard Vambraces
	[14862]="0:4:2:1:Plate::1:0:", -- Warleader's Breastplate
	[14863]="0:4:2:1:Plate::1:0:", -- Warleader's Gauntlets
	[14864]="0:4:2:1:Plate::1:0:", -- Warleader's Belt
	[14865]="0:4:2:1:Plate::1:0:", -- Warleader's Greaves
	[14866]="0:4:2:1:Plate::1:0:", -- Warleader's Crown
	[14867]="0:4:2:1:Plate::1:0:", -- Warleader's Leggings
	[14868]="0:4:2:1:Plate::1:0:", -- Warleader's Shoulders
	[14869]="0:4:2:1:Plate::1:0:", -- Warleader's Bracers
	[14872]="0:12:1:1:::1:0:", -- Tirion's Gift
	[14894]="0:0:1:1:Consumable::1:0:", -- Lily Root
	[14895]="0:4:2:1:Plate::1:0:", -- Saltstone Surcoat
	[14896]="0:4:2:1:Plate::1:0:", -- Saltstone Sabatons
	[14897]="0:4:2:1:Plate::1:0:", -- Saltstone Gauntlets
	[14898]="0:4:2:1:Plate::1:0:", -- Saltstone Girdle
	[14899]="0:4:2:1:Plate::1:0:", -- Saltstone Helm
	[14900]="0:4:2:1:Plate::1:0:", -- Saltstone Legplates
	[14901]="0:4:2:1:Plate::1:0:", -- Saltstone Shoulder Pads
	[14902]="0:4:2:1:Shield::1:0:", -- Saltstone Shield
	[14903]="0:4:2:1:Plate::1:0:", -- Saltstone Armsplints
	[14904]="0:4:2:1:Plate::1:0:", -- Brutish Breastplate
	[14905]="0:4:2:1:Plate::1:0:", -- Brutish Gauntlets
	[14906]="0:4:2:1:Plate::1:0:", -- Brutish Belt
	[14907]="0:4:2:1:Plate::1:0:", -- Brutish Helmet
	[14908]="0:4:2:1:Plate::1:0:", -- Brutish Legguards
	[14909]="0:4:2:1:Plate::1:0:", -- Brutish Shoulders
	[14910]="0:4:2:1:Plate::1:0:", -- Brutish Armguards
	[14911]="0:4:2:1:Plate::1:0:", -- Brutish Boots
	[14912]="0:4:2:1:Shield::1:0:", -- Brutish Shield
	[14913]="0:4:2:1:Plate::1:0:", -- Jade Greaves
	[14914]="0:4:2:1:Plate::1:0:", -- Jade Bracers
	[14915]="0:4:2:1:Plate::1:0:", -- Jade Breastplate
	[14916]="0:4:2:1:Shield::1:0:", -- Jade Deflector
	[14917]="0:4:2:1:Plate::1:0:", -- Jade Gauntlets
	[14918]="0:4:2:1:Plate::1:0:", -- Jade Belt
	[14919]="0:4:2:1:Plate::1:0:", -- Jade Circlet
	[14920]="0:4:2:1:Plate::1:0:", -- Jade Legplates
	[14921]="0:4:2:1:Plate::1:0:", -- Jade Epaulets
	[14922]="0:4:2:1:Plate::1:0:", -- Lofty Sabatons
	[14923]="0:4:2:1:Plate::1:0:", -- Lofty Armguards
	[14924]="0:4:2:1:Plate::1:0:", -- Lofty Breastplate
	[14925]="0:4:2:1:Plate::1:0:", -- Lofty Helm
	[14926]="0:4:2:1:Plate::1:0:", -- Lofty Gauntlets
	[14927]="0:4:2:1:Plate::1:0:", -- Lofty Belt
	[14928]="0:4:2:1:Plate::1:0:", -- Lofty Legguards
	[14929]="0:4:2:1:Plate::1:0:", -- Lofty Shoulder Pads
	[14930]="0:4:2:1:Shield::1:0:", -- Lofty Shield
	[14931]="0:4:2:1:Plate::1:0:", -- Heroic Armor
	[14932]="0:4:2:1:Plate::1:0:", -- Heroic Greaves
	[14933]="0:4:2:1:Plate::1:0:", -- Heroic Gauntlets
	[14934]="0:4:2:1:Plate::1:0:", -- Heroic Girdle
	[14935]="0:4:2:1:Plate::1:0:", -- Heroic Skullcap
	[14936]="0:4:2:1:Plate::1:0:", -- Heroic Legplates
	[14937]="0:4:2:1:Plate::1:0:", -- Heroic Pauldrons
	[14938]="0:4:2:1:Plate::1:0:", -- Heroic Bracers
	[14939]="0:4:2:1:Plate::1:0:", -- Warbringer's Chestguard
	[14940]="0:4:2:1:Plate::1:0:", -- Warbringer's Sabatons 
	[14941]="0:4:2:1:Plate::1:0:", -- Warbringer's Armsplints
	[14942]="0:4:2:1:Plate::1:0:", -- Warbringer's Gauntlets
	[14943]="0:4:2:1:Plate::1:0:", -- Warbringer's Belt
	[14944]="0:4:2:1:Plate::1:0:", -- Warbringer's Crown
	[14945]="0:4:2:1:Plate::1:0:", -- Warbringer's Legguards
	[14946]="0:4:2:1:Plate::1:0:", -- Warbringer's Spaulders
	[14947]="0:4:2:1:Shield::1:0:", -- Warbringer's Shield
	[14948]="0:4:2:1:Plate::1:0:", -- Bloodforged Chestpiece
	[14949]="0:4:2:1:Plate::1:0:", -- Bloodforged Gauntlets
	[14950]="0:4:2:1:Plate::1:0:", -- Bloodforged Belt
	[14951]="0:4:2:1:Plate::1:0:", -- Bloodforged Sabatons
	[14952]="0:4:2:1:Plate::1:0:", -- Bloodforged Helmet
	[14953]="0:4:2:1:Plate::1:0:", -- Bloodforged Legplates
	[14954]="0:4:2:1:Shield::1:0:", -- Bloodforged Shield
	[14955]="0:4:2:1:Plate::1:0:", -- Bloodforged Shoulder Pads
	[14956]="0:4:2:1:Plate::1:0:", -- Bloodforged Bindings
	[14957]="0:4:2:1:Plate::1:0:", -- High Chief's Sabatons
	[14958]="0:4:2:1:Plate::1:0:", -- High Chief's Armor
	[14959]="0:4:2:1:Plate::1:0:", -- High Chief's Gauntlets
	[14960]="0:4:2:1:Plate::1:0:", -- High Chief's Belt
	[14961]="0:4:2:1:Plate::1:0:", -- High Chief's Crown
	[14962]="0:4:2:1:Plate::1:0:", -- High Chief's Legguards
	[14963]="0:4:2:1:Plate::1:0:", -- High Chief's Pauldrons
	[14964]="0:4:2:1:Shield::1:0:", -- High Chief's Shield
	[14965]="0:4:2:1:Plate::1:0:", -- High Chief's Bindings
	[14966]="0:4:2:1:Plate::1:0:", -- Glorious Breastplate
	[14967]="0:4:2:1:Plate::1:0:", -- Glorious Gauntlets
	[14968]="0:4:2:1:Plate::1:0:", -- Glorious Belt
	[14969]="0:4:2:1:Plate::1:0:", -- Glorious Headdress
	[14970]="0:4:2:1:Plate::1:0:", -- Glorious Legplates
	[14971]="0:4:2:1:Plate::1:0:", -- Glorious Shoulder Pads
	[14972]="0:4:2:1:Plate::1:0:", -- Glorious Sabatons
	[14973]="0:4:2:1:Shield::1:0:", -- Glorious Shield
	[14974]="0:4:2:1:Plate::1:0:", -- Glorious Bindings
	[14975]="0:4:2:1:Plate::1:0:", -- Exalted Harness
	[14976]="0:4:2:1:Plate::1:0:", -- Exalted Gauntlets
	[14977]="0:4:2:1:Plate::1:0:", -- Exalted Girdle
	[14978]="0:4:2:1:Plate::1:0:", -- Exalted Sabatons
	[14979]="0:4:2:1:Plate::1:0:", -- Exalted Helmet
	[14980]="0:4:2:1:Plate::1:0:", -- Exalted Legplates
	[14981]="0:4:2:1:Plate::1:0:", -- Exalted Epaulets
	[14982]="0:4:2:1:Shield::1:0:", -- Exalted Shield
	[14983]="0:4:2:1:Plate::1:0:", -- Exalted Armsplints
	[15002]="0:12:1:1:::1:0:", -- Nimboya's Pike
	[15003]="0:4:1:1:Leather::1:0:", -- Primal Belt
	[15004]="0:4:1:1:Leather::1:0:", -- Primal Boots
	[15005]="0:4:1:1:Leather::1:0:", -- Primal Bands
	[15006]="0:4:1:1:Shield::1:0:", -- Primal Buckler
	[15007]="0:4:1:1:Cloak::1:0:", -- Primal Cape
	[15008]="0:4:1:1:Leather::1:0:", -- Primal Mitts
	[15009]="0:4:2:1:Leather::1:0:", -- Primal Leggings
	[15010]="0:4:2:1:Leather::1:0:", -- Primal Wraps
	[15011]="0:4:2:1:Leather::1:0:", -- Lupine Cord
	[15012]="0:4:2:1:Leather::1:0:", -- Lupine Slippers
	[15013]="0:4:1:1:Leather::1:0:", -- Lupine Cuffs
	[15014]="0:4:2:1:Shield::1:0:", -- Lupine Buckler
	[15015]="0:4:1:1:Cloak::1:0:", -- Lupine Cloak
	[15016]="0:4:2:1:Leather::1:0:", -- Lupine Handwraps
	[15017]="0:4:2:1:Leather::1:0:", -- Lupine Leggings
	[15018]="0:4:2:1:Leather::1:0:", -- Lupine Vest
	[15019]="0:4:1:1:Leather::1:0:", -- Lupine Mantle
	[15042]="0:12:1:1:::1:0:", -- Empty Termite Jar
	[15043]="0:12:1:100:::1:0:", -- Plagueland Termites
	[15044]="0:12:1:1:::1:0:", -- Barrel of Plagueland Termites
	[15045]="0:4:3:1:Mail::1:0:", -- Green Dragonscale Breastplate
	[15046]="0:4:3:1:Mail::1:0:", -- Green Dragonscale Leggings
	[15047]="0:4:3:1:Mail::1:0:", -- Red Dragonscale Breastplate
	[15048]="0:4:3:1:Mail::1:0:", -- Blue Dragonscale Breastplate
	[15049]="0:4:3:1:Mail::1:0:", -- Blue Dragonscale Shoulders
	[15050]="0:4:3:1:Mail::1:0:", -- Black Dragonscale Breastplate
	[15051]="0:4:3:1:Mail::1:0:", -- Black Dragonscale Shoulders
	[15052]="0:4:3:1:Mail::1:0:", -- Black Dragonscale Leggings
	[15053]="0:4:2:1:Leather::1:0:", -- Volcanic Breastplate
	[15054]="0:4:2:1:Leather::1:0:", -- Volcanic Leggings
	[15055]="0:4:2:1:Leather::1:0:", -- Volcanic Shoulders
	[15056]="0:4:3:1:Leather::1:0:", -- Stormshroud Armor
	[15057]="0:4:3:1:Leather::1:0:", -- Stormshroud Pants
	[15058]="0:4:3:1:Leather::1:0:", -- Stormshroud Shoulders
	[15059]="0:4:3:1:Leather::1:0:", -- Living Breastplate
	[15060]="0:4:3:1:Leather::1:0:", -- Living Leggings
	[15061]="0:4:3:1:Leather::1:0:", -- Living Shoulders
	[15062]="0:4:3:1:Leather::1:0:", -- Devilsaur Leggings
	[15063]="0:4:3:1:Leather::1:0:", -- Devilsaur Gauntlets
	[15064]="0:4:3:1:Leather::1:0:", -- Warbear Harness
	[15065]="0:4:3:1:Leather::1:0:", -- Warbear Woolies
	[15066]="0:4:3:1:Leather::1:0:", -- Ironfeather Breastplate
	[15067]="0:4:3:1:Leather::1:0:", -- Ironfeather Shoulders
	[15068]="0:4:2:1:Leather::1:0:", -- Frostsaber Tunic
	[15069]="0:4:2:1:Leather::1:0:", -- Frostsaber Leggings
	[15070]="0:4:2:1:Leather::1:0:", -- Frostsaber Gloves
	[15071]="0:4:2:1:Leather::1:0:", -- Frostsaber Boots
	[15072]="0:4:2:1:Leather::1:0:", -- Chimeric Leggings
	[15073]="0:4:2:1:Leather::1:0:", -- Chimeric Boots
	[15074]="0:4:2:1:Leather::1:0:", -- Chimeric Gloves
	[15075]="0:4:2:1:Leather::1:0:", -- Chimeric Vest
	[15076]="0:4:2:1:Mail::1:0:", -- Heavy Scorpid Vest
	[15077]="0:4:2:1:Mail::1:0:", -- Heavy Scorpid Bracers
	[15078]="0:4:2:1:Mail::1:0:", -- Heavy Scorpid Gauntlets
	[15079]="0:4:2:1:Mail::1:0:", -- Heavy Scorpid Leggings
	[15080]="0:4:2:1:Mail::1:0:", -- Heavy Scorpid Helm
	[15081]="0:4:2:1:Mail::1:0:", -- Heavy Scorpid Shoulders
	[15082]="0:4:2:1:Mail::1:0:", -- Heavy Scorpid Belt
	[15083]="0:4:2:1:Leather::1:0:", -- Wicked Leather Gauntlets
	[15084]="0:4:2:1:Leather::1:0:", -- Wicked Leather Bracers
	[15085]="0:4:2:1:Leather::1:0:", -- Wicked Leather Armor
	[15086]="0:4:2:1:Leather::1:0:", -- Wicked Leather Headband
	[15087]="0:4:2:1:Leather::1:0:", -- Wicked Leather Pants
	[15088]="0:4:2:1:Leather::1:0:", -- Wicked Leather Belt
	[15090]="0:4:2:1:Leather::1:0:", -- Runic Leather Armor
	[15091]="0:4:2:1:Leather::1:0:", -- Runic Leather Gauntlets
	[15092]="0:4:2:1:Leather::1:0:", -- Runic Leather Bracers
	[15093]="0:4:2:1:Leather::1:0:", -- Runic Leather Belt
	[15094]="0:4:2:1:Leather::1:0:", -- Runic Leather Headband
	[15095]="0:4:2:1:Leather::1:0:", -- Runic Leather Pants
	[15096]="0:4:2:1:Leather::1:0:", -- Runic Leather Shoulders
	[15102]="0:15:1:1:Junk::1:0:", -- Un'Goro Tested Sample
	[15103]="0:15:1:1:Junk::1:0:", -- Corrupt Tested Sample
	[15104]="0:4:3:1:Cloth::1:0:", -- Wingborne Boots
	[15105]="0:2:2:1:Stave::1:0:", -- Staff of Noh'Orahil
	[15106]="0:2:2:1:Stave::1:0:", -- Staff of Dar'Orahil
	[15107]="0:4:3:1:OffHandFrill::1:0:", -- Orb of Noh'Orahil
	[15108]="0:4:3:1:OffHandFrill::1:0:", -- Orb of Dar'Orahil
	[15109]="0:2:2:1:Stave::1:0:", -- Staff of Soran'ruk
	[15110]="0:4:2:1:Leather::1:0:", -- Rigid Belt
	[15111]="0:4:2:1:Leather::1:0:", -- Rigid Moccasins
	[15112]="0:4:2:1:Leather::1:0:", -- Rigid Bracelets
	[15113]="0:4:2:1:Shield::1:0:", -- Rigid Buckler
	[15114]="0:4:2:1:Cloak::1:0:", -- Rigid Cape
	[15115]="0:4:2:1:Leather::1:0:", -- Rigid Gloves
	[15116]="0:4:2:1:Leather::1:0:", -- Rigid Shoulders
	[15117]="0:4:2:1:Leather::1:0:", -- Rigid Leggings
	[15118]="0:4:2:1:Leather::1:0:", -- Rigid Tunic
	[15119]="0:4:2:1:Cloth::1:0:", -- Highborne Pants
	[15120]="0:4:2:1:Leather::1:0:", -- Robust Girdle
	[15121]="0:4:2:1:Leather::1:0:", -- Robust Boots
	[15122]="0:4:2:1:Leather::1:0:", -- Robust Bracers
	[15123]="0:4:2:1:Shield::1:0:", -- Robust Buckler
	[15124]="0:4:2:1:Cloak::1:0:", -- Robust Cloak
	[15125]="0:4:2:1:Leather::1:0:", -- Robust Gloves
	[15126]="0:4:2:1:Leather::1:0:", -- Robust Leggings
	[15127]="0:4:2:1:Leather::1:0:", -- Robust Shoulders
	[15128]="0:4:2:1:Leather::1:0:", -- Robust Tunic
	[15129]="0:4:2:1:Leather::1:0:", -- Robust Helm
	[15130]="0:4:2:1:Leather::1:0:", -- Cutthroat's Vest
	[15131]="0:4:2:1:Leather::1:0:", -- Cutthroat's Boots
	[15132]="0:4:2:1:Leather::1:0:", -- Cutthroat's Armguards
	[15133]="0:4:2:1:Shield::1:0:", -- Cutthroat's Buckler
	[15134]="0:4:2:1:Leather::1:0:", -- Cutthroat's Hat
	[15135]="0:4:2:1:Cloak::1:0:", -- Cutthroat's Cape
	[15136]="0:4:2:1:Leather::1:0:", -- Cutthroat's Belt
	[15137]="0:4:2:1:Leather::1:0:", -- Cutthroat's Mitts
	[15138]="0:4:3:1:Cloak::1:0:", -- Onyxia Scale Cloak
	[15139]="0:4:2:1:Leather::1:0:", -- Cutthroat's Pants
	[15140]="0:4:2:1:Leather::1:0:", -- Cutthroat's Mantle
	[15141]="0:4:4:1:Mail::1:0:", -- Onyxia Scale Breastplate
	[15142]="0:4:2:1:Leather::1:0:", -- Ghostwalker Boots
	[15143]="0:4:2:1:Leather::1:0:", -- Ghostwalker Bindings
	[15144]="0:4:2:1:Leather::1:0:", -- Ghostwalker Rags
	[15145]="0:4:2:1:Shield::1:0:", -- Ghostwalker Buckler
	[15146]="0:4:2:1:Leather::1:0:", -- Ghostwalker Crown
	[15147]="0:4:2:1:Cloak::1:0:", -- Ghostwalker Cloak
	[15148]="0:4:2:1:Leather::1:0:", -- Ghostwalker Belt
	[15149]="0:4:2:1:Leather::1:0:", -- Ghostwalker Gloves
	[15150]="0:4:2:1:Leather::1:0:", -- Ghostwalker Pads
	[15151]="0:4:2:1:Leather::1:0:", -- Ghostwalker Legguards
	[15152]="0:4:2:1:Leather::1:0:", -- Nocturnal Shoes
	[15153]="0:4:2:1:Cloak::1:0:", -- Nocturnal Cloak
	[15154]="0:4:2:1:Leather::1:0:", -- Nocturnal Sash
	[15155]="0:4:2:1:Leather::1:0:", -- Nocturnal Gloves
	[15156]="0:4:2:1:Leather::1:0:", -- Nocturnal Cap
	[15157]="0:4:2:1:Leather::1:0:", -- Nocturnal Leggings
	[15158]="0:4:2:1:Leather::1:0:", -- Nocturnal Shoulder Pads
	[15159]="0:4:2:1:Leather::1:0:", -- Nocturnal Tunic
	[15160]="0:4:2:1:Leather::1:0:", -- Nocturnal Wristbands
	[15161]="0:4:2:1:Leather::1:0:", -- Imposing Belt
	[15162]="0:4:2:1:Leather::1:0:", -- Imposing Boots
	[15163]="0:4:2:1:Leather::1:0:", -- Imposing Bracers
	[15164]="0:4:2:1:Leather::1:0:", -- Imposing Vest
	[15165]="0:4:2:1:Cloak::1:0:", -- Imposing Cape
	[15166]="0:4:2:1:Leather::1:0:", -- Imposing Gloves
	[15167]="0:4:2:1:Leather::1:0:", -- Imposing Bandana
	[15168]="0:4:2:1:Leather::1:0:", -- Imposing Pants
	[15169]="0:4:2:1:Leather::1:0:", -- Imposing Shoulders
	[15170]="0:4:2:1:Leather::1:0:", -- Potent Armor
	[15171]="0:4:2:1:Leather::1:0:", -- Potent Boots
	[15172]="0:4:2:1:Leather::1:0:", -- Potent Bands
	[15173]="0:4:2:1:Cloak::1:0:", -- Potent Cape
	[15174]="0:4:2:1:Leather::1:0:", -- Potent Gloves
	[15175]="0:4:2:1:Leather::1:0:", -- Potent Helmet
	[15176]="0:4:2:1:Leather::1:0:", -- Potent Pants
	[15177]="0:4:2:1:Leather::1:0:", -- Potent Shoulders
	[15178]="0:4:2:1:Leather::1:0:", -- Potent Belt
	[15179]="0:4:2:1:Leather::1:0:", -- Praetorian Padded Armor
	[15180]="0:4:2:1:Leather::1:0:", -- Praetorian Girdle
	[15181]="0:4:2:1:Leather::1:0:", -- Praetorian Boots
	[15182]="0:4:2:1:Leather::1:0:", -- Praetorian Wristbands
	[15183]="0:4:2:1:Cloak::1:0:", -- Praetorian Cloak
	[15184]="0:4:2:1:Leather::1:0:", -- Praetorian Gloves
	[15185]="0:4:2:1:Leather::1:0:", -- Praetorian Coif
	[15186]="0:4:2:1:Leather::1:0:", -- Praetorian Leggings
	[15187]="0:4:2:1:Leather::1:0:", -- Praetorian Pauldrons
	[15188]="0:4:2:1:Leather::1:0:", -- Grand Armguards
	[15189]="0:4:2:1:Leather::1:0:", -- Grand Boots
	[15190]="0:4:2:1:Cloak::1:0:", -- Grand Cloak
	[15191]="0:4:2:1:Leather::1:0:", -- Grand Belt
	[15192]="0:4:2:1:Leather::1:0:", -- Grand Gauntlets
	[15193]="0:4:2:1:Leather::1:0:", -- Grand Crown
	[15194]="0:4:2:1:Leather::1:0:", -- Grand Legguards
	[15195]="0:4:2:1:Leather::1:0:", -- Grand Breastplate
	[15196]="0:4:1:1:Tabard::1:0:5049,5191,5193,12781,16766", -- Private's Tabard
	[15197]="0:4:1:1:Tabard::1:0:5188,5189,5190,12793,12799,16610", -- Scout's Tabard
	[15198]="0:4:1:1:Tabard::1:0:", -- Knight's Colors
	[15199]="0:4:1:1:Tabard::1:0:", -- Stone Guard's Herald
	[15200]="0:4:3:1:Amulet::1:0:12799", -- Senior Sergeant's Insignia
	[15202]="0:4:2:1:Leather::1:0:", -- Wildkeeper Leggings
	[15203]="0:4:2:1:Mail::1:0:", -- Guststorm Legguards
	[15204]="0:2:2:1:Wand::1:0:", -- Moonstone Wand
	[15205]="0:2:2:1:Gun::1:0:", -- Owlsight Rifle
	[15206]="0:4:2:1:OffHandFrill::1:0:", -- Jadefinger Baton
	[15207]="0:4:2:1:Shield::1:0:", -- Steelcap Shield
	[15208]="0:12:1:1:::1:0:", -- Cenarion Moondust
	[15209]="0:12:1:1:::1:0:", -- Relic Bundle
	[15210]="0:2:2:1:OneHandSword::1:0:", -- Raider Shortsword
	[15211]="0:2:2:1:OneHandSword::1:0:", -- Militant Shortsword
	[15212]="0:2:2:1:OneHandSword::1:0:", -- Fighter Broadsword
	[15213]="0:2:2:1:OneHandSword::1:0:", -- Mercenary Blade
	[15214]="0:2:2:1:OneHandSword::1:0:", -- Nobles Brand
	[15215]="0:2:2:1:OneHandSword::1:0:", -- Furious Falchion
	[15216]="0:2:2:1:OneHandSword::1:0:", -- Rune Sword
	[15217]="0:2:2:1:OneHandSword::1:0:", -- Widow Blade
	[15218]="0:2:2:1:OneHandSword::1:0:", -- Crystal Sword
	[15219]="0:2:2:1:OneHandSword::1:0:", -- Dimensional Blade
	[15220]="0:2:2:1:OneHandSword::1:0:", -- Battlefell Sabre
	[15221]="0:2:2:1:OneHandSword::1:0:", -- Holy War Sword
	[15222]="0:2:2:1:OneHandMace::1:0:", -- Barbed Club
	[15223]="0:2:2:1:OneHandMace::1:0:", -- Jagged Star
	[15224]="0:2:2:1:OneHandMace::1:0:", -- Battlesmasher
	[15225]="0:2:2:1:OneHandMace::1:0:", -- Sequoia Hammer
	[15226]="0:2:2:1:OneHandMace::1:0:", -- Giant Club
	[15227]="0:2:2:1:OneHandMace::1:0:", -- Diamond-Tip Bludgeon
	[15228]="0:2:2:1:OneHandMace::1:0:", -- Smashing Star
	[15229]="0:2:2:1:OneHandMace::1:0:", -- Blesswind Hammer
	[15230]="0:2:2:1:OneHandAxe::1:0:", -- Ridge Cleaver
	[15231]="0:2:2:1:OneHandAxe::1:0:", -- Splitting Hatchet
	[15232]="0:2:2:1:OneHandAxe::1:0:", -- Hacking Cleaver
	[15233]="0:2:2:1:OneHandAxe::1:0:", -- Savage Axe
	[15234]="0:2:2:1:OneHandAxe::1:0:", -- Greater Scythe
	[15235]="0:2:2:1:OneHandAxe::1:0:", -- Crescent Edge
	[15236]="0:2:2:1:OneHandAxe::1:0:", -- Moon Cleaver
	[15237]="0:2:2:1:OneHandAxe::1:0:", -- Corpse Harvester
	[15238]="0:2:2:1:OneHandAxe::1:0:", -- Warlord's Axe
	[15239]="0:2:2:1:OneHandAxe::1:0:", -- Felstone Reaver
	[15240]="0:2:2:1:OneHandAxe::1:0:", -- Demon's Claw
	[15241]="0:2:2:1:Dagger::1:0:", -- Battle Knife
	[15242]="0:2:2:1:Dagger::1:0:", -- Honed Stiletto
	[15243]="0:2:2:1:Dagger::1:0:", -- Deadly Kris
	[15244]="0:2:2:1:Dagger::1:0:", -- Razor Blade
	[15245]="0:2:2:1:Dagger::1:0:", -- Vorpal Dagger
	[15246]="0:2:2:1:Dagger::1:0:", -- Demon Blade
	[15247]="0:2:2:1:Dagger::1:0:", -- Bloodstrike Dagger
	[15248]="0:2:2:1:TwoHandSword::1:0:", -- Gleaming Claymore
	[15249]="0:2:2:1:TwoHandSword::1:0:", -- Polished Zweihander
	[15250]="0:2:2:1:TwoHandSword::1:0:", -- Glimmering Flamberge
	[15251]="0:2:2:1:TwoHandSword::1:0:", -- Headstriker Sword
	[15252]="0:2:2:1:TwoHandSword::1:0:", -- Tusker Sword
	[15253]="0:2:2:1:TwoHandSword::1:0:", -- Beheading Blade
	[15254]="0:2:2:1:TwoHandSword::1:0:", -- Dark Espadon
	[15255]="0:2:2:1:TwoHandSword::1:0:", -- Gallant Flamberge
	[15256]="0:2:2:1:TwoHandSword::1:0:", -- Massacre Sword
	[15257]="0:2:2:1:TwoHandSword::1:0:", -- Shin Blade
	[15258]="0:2:2:1:TwoHandSword::1:0:", -- Divine Warblade
	[15259]="0:2:2:1:TwoHandMace::1:0:", -- Hefty Battlehammer
	[15260]="0:2:2:1:TwoHandMace::1:0:", -- Stone Hammer
	[15261]="0:2:2:1:TwoHandMace::1:0:", -- Sequoia Branch
	[15262]="0:2:2:1:TwoHandMace::1:0:", -- Greater Maul
	[15263]="0:2:2:1:TwoHandMace::1:0:", -- Royal Mallet
	[15264]="0:2:2:1:TwoHandMace::1:0:", -- Backbreaker
	[15265]="0:2:2:1:TwoHandMace::1:0:", -- Painbringer
	[15266]="0:2:2:1:TwoHandMace::1:0:", -- Fierce Mauler
	[15267]="0:2:2:1:TwoHandMace::1:0:", -- Brutehammer
	[15268]="0:2:2:1:TwoHandAxe::1:0:", -- Twin-bladed Axe
	[15269]="0:2:2:1:TwoHandAxe::1:0:", -- Massive Battle Axe
	[15270]="0:2:2:1:TwoHandAxe::1:0:", -- Gigantic War Axe
	[15271]="0:2:2:1:TwoHandAxe::1:0:", -- Colossal Great Axe
	[15272]="0:2:2:1:TwoHandAxe::1:0:", -- Razor Axe
	[15273]="0:2:2:1:TwoHandAxe::1:0:", -- Death Striker
	[15274]="0:2:2:1:Stave::1:0:", -- Diviner Long Staff
	[15275]="0:2:2:1:Stave::1:0:", -- Thaumaturgist Staff
	[15276]="0:2:2:1:Stave::1:0:", -- Magus Long Staff
	[15277]="10000:15:3:1:Mount::1:0:3685", -- Gray Kodo
	[15278]="0:2:2:1:Stave::1:0:", -- Solstice Staff
	[15279]="0:2:2:1:Wand::1:0:", -- Ivory Wand
	[15280]="0:2:2:1:Wand::1:0:", -- Wizard's Hand
	[15281]="0:2:2:1:Wand::1:0:", -- Glowstar Rod
	[15282]="0:2:2:1:Wand::1:0:", -- Dragon Finger
	[15283]="0:2:2:1:Wand::1:0:", -- Lunar Wand
	[15284]="0:2:2:1:Bow::1:0:", -- Long Battle Bow
	[15285]="0:2:2:1:Bow::1:0:", -- Archer's Longbow
	[15286]="0:2:2:1:Bow::1:0:", -- Long Redwood Bow
	[15287]="0:2:2:1:Bow::1:0:", -- Crusader Bow
	[15288]="0:2:2:1:Bow::1:0:", -- Blasthorn Bow
	[15289]="0:2:2:1:Bow::1:0:", -- Archstrike Bow
	[15290]="10000:15:3:1:Mount::1:0:3685", -- Brown Kodo
	[15291]="0:2:2:1:Bow::1:0:", -- Harpy Needler
	[15292]="0:15:4:1:Mount::1:0:", -- Green Kodo
	[15293]="0:15:4:1:Mount::1:0:", -- Teal Kodo
	[15294]="0:2:2:1:Bow::1:0:", -- Siege Bow
	[15295]="0:2:2:1:Bow::1:0:", -- Quillfire Bow
	[15296]="0:2:2:1:Bow::1:0:", -- Hawkeye Bow
	[15297]="0:4:1:1:Leather::1:0:", -- Grizzly Bracers
	[15298]="0:4:2:1:Shield::1:0:", -- Grizzly Buckler
	[15299]="0:4:1:1:Cloak::1:0:", -- Grizzly Cape
	[15300]="0:4:1:1:Leather::1:0:", -- Grizzly Gloves
	[15301]="0:4:1:1:Leather::1:0:", -- Grizzly Slippers
	[15302]="0:4:1:1:Leather::1:0:", -- Grizzly Belt
	[15303]="0:4:2:1:Leather::1:0:", -- Grizzly Pants
	[15304]="0:4:2:1:Leather::1:0:", -- Grizzly Jerkin
	[15305]="0:4:2:1:Leather::1:0:", -- Feral Shoes
	[15306]="0:4:2:1:Leather::1:0:", -- Feral Bindings
	[15307]="0:4:2:1:Shield::1:0:", -- Feral Buckler
	[15308]="0:4:2:1:Leather::1:0:", -- Feral Cord
	[15309]="0:4:2:1:Cloak::1:0:", -- Feral Cloak
	[15310]="0:4:2:1:Leather::1:0:", -- Feral Gloves
	[15311]="0:4:2:1:Leather::1:0:", -- Feral Harness
	[15312]="0:4:2:1:Leather::1:0:", -- Feral Leggings
	[15313]="0:4:1:1:Leather::1:0:", -- Feral Shoulder Pads
	[15314]="0:0:1:1:Consumable::1:0:", -- Bundle of Relics
	[15322]="0:2:2:1:Gun::1:0:", -- Smoothbore Gun
	[15323]="0:2:2:1:Gun::1:0:", -- Percussion Shotgun
	[15324]="0:2:2:1:Gun::1:0:", -- Burnside Rifle
	[15325]="0:2:2:1:Gun::1:0:", -- Sharpshooter Harquebus
	[15326]="0:15:1:200:Junk::1:0:", -- Broken Gleaming Throwing Axe
	[15327]="0:15:1:200:Junk::1:0:", -- Broken Wicked Throwing Dagger
	[15328]="0:13:1:1:::1:0:", -- Joseph's Key
	[15329]="0:4:2:1:Leather::1:0:", -- Wrangler's Belt
	[15330]="0:4:2:1:Leather::1:0:", -- Wrangler's Boots
	[15331]="0:4:2:1:Leather::1:0:", -- Wrangler's Wristbands
	[15332]="0:4:2:1:Shield::1:0:", -- Wrangler's Buckler
	[15333]="0:4:2:1:Cloak::1:0:", -- Wrangler's Cloak
	[15334]="0:4:2:1:Leather::1:0:", -- Wrangler's Gloves
	[15335]="0:2:2:1:OneHandSword::1:0:", -- Briarsteel Shortsword
	[15336]="0:4:2:1:Leather::1:0:", -- Wrangler's Leggings
	[15337]="0:4:2:1:Leather::1:0:", -- Wrangler's Wraps
	[15338]="0:4:2:1:Leather::1:0:", -- Wrangler's Mantle
	[15339]="0:4:2:1:Leather::1:0:", -- Pathfinder Hat
	[15340]="0:4:2:1:Cloak::1:0:", -- Pathfinder Cloak
	[15341]="0:4:2:1:Leather::1:0:", -- Pathfinder Footpads
	[15342]="0:4:2:1:Shield::1:0:", -- Pathfinder Guard
	[15343]="0:4:2:1:Leather::1:0:", -- Pathfinder Gloves
	[15344]="0:4:2:1:Leather::1:0:", -- Pathfinder Pants
	[15345]="0:4:2:1:Leather::1:0:", -- Pathfinder Shoulder Pads
	[15346]="0:4:2:1:Leather::1:0:", -- Pathfinder Vest
	[15347]="0:4:2:1:Leather::1:0:", -- Pathfinder Belt
	[15348]="0:4:2:1:Leather::1:0:", -- Pathfinder Bracers
	[15349]="0:4:2:1:Leather::1:0:", -- Headhunter's Belt
	[15350]="0:4:2:1:Leather::1:0:", -- Headhunter's Slippers
	[15351]="0:4:2:1:Leather::1:0:", -- Headhunter's Bands
	[15352]="0:4:2:1:Shield::1:0:", -- Headhunter's Buckler
	[15353]="0:4:2:1:Leather::1:0:", -- Headhunter's Headdress
	[15354]="0:4:2:1:Cloak::1:0:", -- Headhunter's Cloak
	[15355]="0:4:2:1:Leather::1:0:", -- Headhunter's Mitts
	[15356]="0:4:2:1:Leather::1:0:", -- Headhunter's Armor
	[15357]="0:4:2:1:Leather::1:0:", -- Headhunter's Spaulders
	[15358]="0:4:2:1:Leather::1:0:", -- Headhunter's Woolies
	[15359]="0:4:2:1:Leather::1:0:", -- Trickster's Vest
	[15360]="0:4:2:1:Leather::1:0:", -- Trickster's Bindings
	[15361]="0:4:2:1:Leather::1:0:", -- Trickster's Sash
	[15362]="0:4:2:1:Leather::1:0:", -- Trickster's Boots
	[15363]="0:4:2:1:Leather::1:0:", -- Trickster's Headdress
	[15364]="0:4:2:1:Cloak::1:0:", -- Trickster's Cloak
	[15365]="0:4:2:1:Leather::1:0:", -- Trickster's Handwraps
	[15366]="0:4:2:1:Leather::1:0:", -- Trickster's Leggings
	[15367]="0:4:2:1:Shield::1:0:", -- Trickster's Protector
	[15368]="0:4:2:1:Leather::1:0:", -- Trickster's Pauldrons
	[15369]="0:4:2:1:Leather::1:0:", -- Wolf Rider's Belt
	[15370]="0:4:2:1:Leather::1:0:", -- Wolf Rider's Boots
	[15371]="0:4:2:1:Cloak::1:0:", -- Wolf Rider's Cloak
	[15372]="0:4:2:1:Leather::1:0:", -- Wolf Rider's Gloves
	[15373]="0:4:2:1:Leather::1:0:", -- Wolf Rider's Headgear
	[15374]="0:4:2:1:Leather::1:0:", -- Wolf Rider's Leggings
	[15375]="0:4:2:1:Leather::1:0:", -- Wolf Rider's Shoulder Pads
	[15376]="0:4:2:1:Leather::1:0:", -- Wolf Rider's Padded Armor
	[15377]="0:4:2:1:Leather::1:0:", -- Wolf Rider's Wristbands
	[15378]="0:4:2:1:Leather::1:0:", -- Rageclaw Belt
	[15379]="0:4:2:1:Leather::1:0:", -- Rageclaw Boots
	[15380]="0:4:2:1:Leather::1:0:", -- Rageclaw Bracers
	[15381]="0:4:2:1:Leather::1:0:", -- Rageclaw Chestguard
	[15382]="0:4:2:1:Cloak::1:0:", -- Rageclaw Cloak
	[15383]="0:4:2:1:Leather::1:0:", -- Rageclaw Gloves
	[15384]="0:4:2:1:Leather::1:0:", -- Rageclaw Helm
	[15385]="0:4:2:1:Leather::1:0:", -- Rageclaw Leggings
	[15386]="0:4:2:1:Leather::1:0:", -- Rageclaw Shoulder Pads
	[15387]="0:4:2:1:Leather::1:0:", -- Jadefire Bracelets
	[15388]="0:4:2:1:Leather::1:0:", -- Jadefire Belt
	[15389]="0:4:2:1:Leather::1:0:", -- Jadefire Sabatons
	[15390]="0:4:2:1:Leather::1:0:", -- Jadefire Chestguard
	[15391]="0:4:2:1:Leather::1:0:", -- Jadefire Cap
	[15392]="0:4:2:1:Cloak::1:0:", -- Jadefire Cloak
	[15393]="0:4:2:1:Leather::1:0:", -- Jadefire Gloves
	[15394]="0:4:2:1:Leather::1:0:", -- Jadefire Pants
	[15395]="0:4:2:1:Leather::1:0:", -- Jadefire Epaulets
	[15396]="0:2:2:1:Dagger::1:0:", -- Curvewood Dagger
	[15397]="0:2:2:1:Stave::1:0:", -- Oakthrush Staff
	[15398]="0:4:1:1:Cloth::1:0:", -- Sandcomber Boots
	[15399]="0:4:2:1:Leather::1:0:", -- Dryweed Belt
	[15400]="0:4:1:1:Mail::1:0:", -- Clamshell Bracers
	[15401]="0:4:1:1:Cloth::1:0:", -- Welldrip Gloves
	[15402]="0:4:1:1:Mail::1:0:", -- Noosegrip Gauntlets
	[15403]="0:4:2:1:Leather::1:0:", -- Ridgeback Bracers
	[15404]="0:4:2:1:Mail::1:0:", -- Breakwater Girdle
	[15405]="0:4:2:1:Leather::1:0:", -- Shucking Gloves
	[15406]="0:4:2:1:Mail::1:0:", -- Crustacean Boots
	[15407]="0:7:1:20:Leather:202,165:1:0:", -- Cured Rugged Hide
	[15408]="0:7:1:20:Leather:165:1:0:", -- Heavy Scorpid Scale
	[15409]="0:7:1:20:Leather:165:1:0:", -- Refined Deeprock Salt
	[15410]="0:7:3:20:Leather:165:1:0:", -- Scale of Onyxia
	[15411]="0:4:3:1:Amulet::1:0:", -- Mark of Fordring
	[15412]="0:7:1:20:Leather:165:1:0:", -- Green Dragonscale
	[15413]="0:4:3:1:Plate::1:0:", -- Ornate Adamantium Breastplate
	[15414]="0:7:1:20:Leather:165:1:0:", -- Red Dragonscale
	[15415]="0:7:1:20:Leather:165:1:0:", -- Blue Dragonscale
	[15416]="0:7:1:20:Leather:165:1:0:", -- Black Dragonscale
	[15417]="0:7:1:20:Leather:164,165:1:0:", -- Devilsaur Leather
	[15418]="0:2:3:1:TwoHandMace::1:0:", -- Shimmering Platinum Warhammer
	[15419]="0:7:1:20:Leather:165:1:0:", -- Warbear Leather
	[15420]="0:15:0:50:Junk::1:0:", -- Ironfeather
	[15421]="0:4:3:1:Cloak::1:0:", -- Shroud of the Exile
	[15422]="0:15:0:20:Junk::1:0:", -- Frostsaber Leather
	[15423]="0:15:0:20:Junk::1:0:", -- Chimera Leather
	[15424]="0:2:2:1:TwoHandAxe::1:0:", -- Axe of Orgrimmar
	[15425]="0:4:2:1:Leather::1:0:", -- Peerless Bracers
	[15426]="0:4:2:1:Leather::1:0:", -- Peerless Boots
	[15427]="0:4:2:1:Cloak::1:0:", -- Peerless Cloak
	[15428]="0:4:2:1:Leather::1:0:", -- Peerless Belt
	[15429]="0:4:2:1:Leather::1:0:", -- Peerless Gloves
	[15430]="0:4:2:1:Leather::1:0:", -- Peerless Headband
	[15431]="0:4:2:1:Leather::1:0:", -- Peerless Leggings
	[15432]="0:4:2:1:Leather::1:0:", -- Peerless Shoulders
	[15433]="0:4:2:1:Leather::1:0:", -- Peerless Armor
	[15434]="0:4:2:1:Leather::1:0:", -- Supreme Sash
	[15435]="0:4:2:1:Leather::1:0:", -- Supreme Shoes
	[15436]="0:4:2:1:Leather::1:0:", -- Supreme Bracers
	[15437]="0:4:2:1:Cloak::1:0:", -- Supreme Cape
	[15438]="0:4:2:1:Leather::1:0:", -- Supreme Gloves
	[15439]="0:4:2:1:Leather::1:0:", -- Supreme Crown
	[15440]="0:4:2:1:Leather::1:0:", -- Supreme Leggings
	[15441]="0:4:2:1:Leather::1:0:", -- Supreme Shoulders
	[15442]="0:4:2:1:Leather::1:0:", -- Supreme Breastplate
	[15443]="0:2:2:1:Dagger::1:0:", -- Kris of Orgrimmar
	[15444]="0:2:2:1:Stave::1:0:", -- Staff of Orgrimmar
	[15445]="0:2:2:1:OneHandMace::1:0:", -- Hammer of Orgrimmar
	[15447]="0:12:1:1:::1:0:", -- Living Rot
	[15448]="0:12:1:1:::1:0:", -- Coagulated Rot
	[15449]="0:4:2:1:Cloth::1:0:", -- Ghastly Trousers
	[15450]="0:4:2:1:Leather::1:0:", -- Dredgemire Leggings
	[15451]="0:4:2:1:Mail::1:0:", -- Gargoyle Leggings
	[15452]="0:4:2:1:Cloth::1:0:", -- Featherbead Bracers
	[15453]="0:4:2:1:Leather::1:0:", -- Savannah Bracers
	[15454]="0:12:1:1:::1:0:", -- Mortar and Pestle
	[15455]="0:4:2:1:Cloth::1:0:", -- Dustfall Robes
	[15456]="0:4:2:1:Leather::1:0:", -- Lightstep Leggings
	[15457]="0:4:2:1:Cloth::1:0:", -- Desert Shoulders
	[15458]="0:4:2:1:Leather::1:0:", -- Tundra Boots
	[15459]="0:4:2:1:Mail::1:0:", -- Grimtoll Wristguards
	[15461]="0:4:2:1:Cloth::1:0:", -- Lightheel Boots
	[15462]="0:4:2:1:Leather::1:0:", -- Loamflake Bracers
	[15463]="0:4:2:1:Mail::1:0:", -- Palestrider Gloves
	[15464]="0:2:2:1:TwoHandMace::1:0:", -- Brute Hammer
	[15465]="0:2:2:1:Wand::1:0:", -- Stingshot Wand
	[15466]="0:4:2:1:Shield::1:0:", -- Clink Shield
	[15467]="0:4:2:1:Ring::1:0:", -- Inventor's League Ring
	[15468]="0:4:2:1:Cloak::1:0:", -- Windsong Drape
	[15469]="0:4:2:1:Leather::1:0:", -- Windsong Cinch
	[15470]="0:4:2:1:Mail::1:0:", -- Plainsguard Leggings
	[15471]="0:4:2:1:Leather::1:0:", -- Brawnhide Armor
	[15472]="0:4:1:1:Mail::1:0:", -- Charger's Belt
	[15473]="0:4:1:1:Mail::1:0:", -- Charger's Boots
	[15474]="0:4:1:1:Mail::1:0:", -- Charger's Bindings
	[15475]="0:4:1:1:Cloak::1:0:", -- Charger's Cloak
	[15476]="0:4:1:1:Mail::1:0:", -- Charger's Handwraps
	[15477]="0:4:2:1:Mail::1:0:", -- Charger's Pants
	[15478]="0:4:1:1:Shield::1:0:", -- Charger's Shield
	[15479]="0:4:2:1:Mail::1:0:", -- Charger's Armor
	[15480]="0:4:1:1:Mail::1:0:", -- War Torn Girdle
	[15481]="0:4:1:1:Mail::1:0:", -- War Torn Greaves
	[15482]="0:4:1:1:Mail::1:0:", -- War Torn Bands
	[15483]="0:4:1:1:Cloak::1:0:", -- War Torn Cape
	[15484]="0:4:1:1:Mail::1:0:", -- War Torn Handgrips
	[15485]="0:4:2:1:Mail::1:0:", -- War Torn Pants
	[15486]="0:4:2:1:Shield::1:0:", -- War Torn Shield
	[15487]="0:4:2:1:Mail::1:0:", -- War Torn Tunic
	[15488]="0:4:2:1:Mail::1:0:", -- Bloodspattered Surcoat
	[15489]="0:4:2:1:Mail::1:0:", -- Bloodspattered Sabatons
	[15490]="0:4:1:1:Cloak::1:0:", -- Bloodspattered Cloak
	[15491]="0:4:2:1:Mail::1:0:", -- Bloodspattered Gloves
	[15492]="0:4:2:1:Mail::1:0:", -- Bloodspattered Sash
	[15493]="0:4:2:1:Mail::1:0:", -- Bloodspattered Loincloth
	[15494]="0:4:2:1:Shield::1:0:", -- Bloodspattered Shield
	[15495]="0:4:2:1:Mail::1:0:", -- Bloodspattered Wristbands
	[15496]="0:4:1:1:Mail::1:0:", -- Bloodspattered Shoulder Pads
	[15497]="0:4:2:1:Mail::1:0:", -- Outrunner's Cord
	[15498]="0:4:2:1:Mail::1:0:", -- Outrunner's Slippers
	[15499]="0:4:2:1:Mail::1:0:", -- Outrunner's Cuffs
	[15500]="0:4:2:1:Mail::1:0:", -- Outrunner's Chestguard
	[15501]="0:4:2:1:Cloak::1:0:", -- Outrunner's Cloak
	[15502]="0:4:2:1:Mail::1:0:", -- Outrunner's Gloves
	[15503]="0:4:2:1:Mail::1:0:", -- Outrunner's Legguards
	[15504]="0:4:2:1:Shield::1:0:", -- Outrunner's Shield
	[15505]="0:4:1:1:Mail::1:0:", -- Outrunner's Pauldrons
	[15506]="0:4:2:1:Mail::1:0:", -- Grunt's AnkleWraps
	[15507]="0:4:2:1:Mail::1:0:", -- Grunt's Bracers
	[15508]="0:4:2:1:Cloak::1:0:", -- Grunt's Cape
	[15509]="0:4:2:1:Mail::1:0:", -- Grunt's Handwraps
	[15510]="0:4:2:1:Mail::1:0:", -- Grunt's Belt
	[15511]="0:4:2:1:Mail::1:0:", -- Grunt's Legguards
	[15512]="0:4:2:1:Shield::1:0:", -- Grunt's Shield
	[15513]="0:4:2:1:Mail::1:0:", -- Grunt's Pauldrons
	[15514]="0:4:2:1:Mail::1:0:", -- Grunt's Chestpiece
	[15515]="0:4:2:1:Mail::1:0:", -- Spiked Chain Belt
	[15516]="0:4:2:1:Mail::1:0:", -- Spiked Chain Slippers
	[15517]="0:4:2:1:Mail::1:0:", -- Spiked Chain Wristbands
	[15518]="0:4:2:1:Mail::1:0:", -- Spiked Chain Breastplate
	[15519]="0:4:2:1:Cloak::1:0:", -- Spiked Chain Cloak
	[15520]="0:4:2:1:Mail::1:0:", -- Spiked Chain Gauntlets
	[15521]="0:4:2:1:Mail::1:0:", -- Spiked Chain Leggings
	[15522]="0:4:2:1:Shield::1:0:", -- Spiked Chain Shield
	[15523]="0:4:2:1:Mail::1:0:", -- Spiked Chain Shoulder Pads
	[15524]="0:4:2:1:Mail::1:0:", -- Sentry's Surcoat
	[15525]="0:4:2:1:Mail::1:0:", -- Sentry's Slippers
	[15526]="0:4:2:1:Cloak::1:0:", -- Sentry's Cape
	[15527]="0:4:2:1:Mail::1:0:", -- Sentry's Gloves
	[15528]="0:4:2:1:Mail::1:0:", -- Sentry's Sash
	[15529]="0:4:2:1:Mail::1:0:", -- Sentry's Leggings
	[15530]="0:4:2:1:Shield::1:0:", -- Sentry's Shield
	[15531]="0:4:2:1:Mail::1:0:", -- Sentry's Shoulderguards
	[15532]="0:4:2:1:Mail::1:0:", -- Sentry's Armsplints
	[15533]="0:4:2:1:Mail::1:0:", -- Sentry's Headdress
	[15534]="0:4:2:1:Mail::1:0:", -- Wicked Chain Boots
	[15535]="0:4:2:1:Mail::1:0:", -- Wicked Chain Bracers
	[15536]="0:4:2:1:Mail::1:0:", -- Wicked Chain Chestpiece
	[15537]="0:4:2:1:Cloak::1:0:", -- Wicked Chain Cloak
	[15538]="0:4:2:1:Mail::1:0:", -- Wicked Chain Gauntlets
	[15539]="0:4:2:1:Mail::1:0:", -- Wicked Chain Waistband
	[15540]="0:4:2:1:Mail::1:0:", -- Wicked Chain Helmet
	[15541]="0:4:2:1:Mail::1:0:", -- Wicked Chain Legguards
	[15542]="0:4:2:1:Mail::1:0:", -- Wicked Chain Shoulder Pads
	[15543]="0:4:2:1:Shield::1:0:", -- Wicked Chain Shield
	[15544]="0:4:2:1:Mail::1:0:", -- Thick Scale Sabatons
	[15545]="0:4:2:1:Mail::1:0:", -- Thick Scale Bracelets
	[15546]="0:4:2:1:Mail::1:0:", -- Thick Scale Breastplate
	[15547]="0:4:2:1:Cloak::1:0:", -- Thick Scale Cloak
	[15548]="0:4:2:1:Mail::1:0:", -- Thick Scale Gauntlets
	[15549]="0:4:2:1:Mail::1:0:", -- Thick Scale Belt
	[15550]="0:4:2:1:Mail::1:0:", -- Thick Scale Crown
	[15551]="0:4:2:1:Mail::1:0:", -- Thick Scale Legguards
	[15552]="0:4:2:1:Shield::1:0:", -- Thick Scale Shield
	[15553]="0:4:2:1:Mail::1:0:", -- Thick Scale Shoulder Pads
	[15554]="0:4:2:1:Mail::1:0:", -- Pillager's Girdle
	[15555]="0:4:2:1:Mail::1:0:", -- Pillager's Boots
	[15556]="0:4:2:1:Mail::1:0:", -- Pillager's Bracers
	[15557]="0:4:2:1:Mail::1:0:", -- Pillager's Chestguard
	[15558]="0:4:2:1:Mail::1:0:", -- Pillager's Crown
	[15559]="0:4:2:1:Cloak::1:0:", -- Pillager's Cloak
	[15560]="0:4:2:1:Mail::1:0:", -- Pillager's Gloves
	[15561]="0:4:2:1:Mail::1:0:", -- Pillager's Leggings
	[15562]="0:4:2:1:Mail::1:0:", -- Pillager's Pauldrons
	[15563]="0:4:2:1:Shield::1:0:", -- Pillager's Shield
	[15564]="0:0:1:10:EnhPerm::1:0:", -- Rugged Armor Kit
	[15565]="0:4:2:1:Mail::1:0:", -- Marauder's Boots
	[15566]="0:4:2:1:Mail::1:0:", -- Marauder's Bracers
	[15567]="0:4:2:1:Mail::1:0:", -- Marauder's Tunic
	[15568]="0:4:2:1:Cloak::1:0:", -- Marauder's Cloak
	[15569]="0:4:2:1:Shield::1:0:", -- Marauder's Crest
	[15570]="0:4:2:1:Mail::1:0:", -- Marauder's Gauntlets
	[15571]="0:4:2:1:Mail::1:0:", -- Marauder's Belt
	[15572]="0:4:2:1:Mail::1:0:", -- Marauder's Circlet
	[15573]="0:4:2:1:Mail::1:0:", -- Marauder's Leggings
	[15574]="0:4:2:1:Mail::1:0:", -- Marauder's Shoulder Pads
	[15575]="0:4:2:1:Mail::1:0:", -- Sparkleshell Belt
	[15576]="0:4:2:1:Mail::1:0:", -- Sparkleshell Sabatons
	[15577]="0:4:2:1:Mail::1:0:", -- Sparkleshell Bracers
	[15578]="0:4:2:1:Mail::1:0:", -- Sparkleshell Breastplate
	[15579]="0:4:2:1:Cloak::1:0:", -- Sparkleshell Cloak
	[15580]="0:4:2:1:Mail::1:0:", -- Sparkleshell Headwrap
	[15581]="0:4:2:1:Mail::1:0:", -- Sparkleshell Gauntlets
	[15582]="0:4:2:1:Mail::1:0:", -- Sparkleshell Legguards
	[15583]="0:4:2:1:Mail::1:0:", -- Sparkleshell Shoulder Pads
	[15584]="0:4:2:1:Shield::1:0:", -- Sparkleshell Shield
	[15585]="0:4:2:1:Cloth::1:0:", -- Pardoc Grips
	[15587]="0:4:2:1:Leather::1:0:", -- Ringtail Girdle
	[15588]="0:4:2:1:Mail::1:0:", -- Bracesteel Belt
	[15589]="0:4:2:1:Mail::1:0:", -- Steadfast Stompers
	[15590]="0:4:2:1:Mail::1:0:", -- Steadfast Bracelets
	[15591]="0:4:2:1:Mail::1:0:", -- Steadfast Breastplate
	[15592]="0:4:2:1:Shield::1:0:", -- Steadfast Buckler
	[15593]="0:4:2:1:Mail::1:0:", -- Steadfast Coronet
	[15594]="0:4:2:1:Cloak::1:0:", -- Steadfast Cloak
	[15595]="0:4:2:1:Mail::1:0:", -- Steadfast Gloves
	[15596]="0:4:2:1:Mail::1:0:", -- Steadfast Legplates
	[15597]="0:4:2:1:Mail::1:0:", -- Steadfast Shoulders
	[15598]="0:4:2:1:Mail::1:0:", -- Steadfast Girdle
	[15599]="0:4:2:1:Mail::1:0:", -- Ancient Greaves
	[15600]="0:4:2:1:Mail::1:0:", -- Ancient Vambraces
	[15601]="0:4:2:1:Mail::1:0:", -- Ancient Chestpiece
	[15602]="0:4:2:1:Mail::1:0:", -- Ancient Crown
	[15603]="0:4:2:1:Cloak::1:0:", -- Ancient Cloak
	[15604]="0:4:2:1:Shield::1:0:", -- Ancient Defender
	[15605]="0:4:2:1:Mail::1:0:", -- Ancient Gauntlets
	[15606]="0:4:2:1:Mail::1:0:", -- Ancient Belt
	[15607]="0:4:2:1:Mail::1:0:", -- Ancient Legguards
	[15608]="0:4:2:1:Mail::1:0:", -- Ancient Pauldrons
	[15609]="0:4:2:1:Mail::1:0:", -- Bonelink Armor
	[15610]="0:4:2:1:Mail::1:0:", -- Bonelink Bracers
	[15611]="0:4:2:1:Cloak::1:0:", -- Bonelink Cape
	[15612]="0:4:2:1:Mail::1:0:", -- Bonelink Gauntlets
	[15613]="0:4:2:1:Mail::1:0:", -- Bonelink Belt
	[15614]="0:4:2:1:Mail::1:0:", -- Bonelink Sabatons
	[15615]="0:4:2:1:Mail::1:0:", -- Bonelink Helmet
	[15616]="0:4:2:1:Mail::1:0:", -- Bonelink Legplates
	[15617]="0:4:2:1:Mail::1:0:", -- Bonelink Epaulets
	[15618]="0:4:2:1:Shield::1:0:", -- Bonelink Wall Shield
	[15619]="0:4:2:1:Mail::1:0:", -- Gryphon Mail Belt
	[15620]="0:4:2:1:Mail::1:0:", -- Gryphon Mail Bracelets
	[15621]="0:4:2:1:Shield::1:0:", -- Gryphon Mail Buckler
	[15622]="0:4:2:1:Mail::1:0:", -- Gryphon Mail Breastplate
	[15623]="0:4:2:1:Mail::1:0:", -- Gryphon Mail Crown
	[15624]="0:4:2:1:Cloak::1:0:", -- Gryphon Cloak
	[15625]="0:4:2:1:Mail::1:0:", -- Gryphon Mail Gauntlets
	[15626]="0:4:2:1:Mail::1:0:", -- Gryphon Mail Greaves
	[15627]="0:4:2:1:Mail::1:0:", -- Gryphon Mail Legguards
	[15628]="0:4:2:1:Mail::1:0:", -- Gryphon Mail Pauldrons
	[15629]="0:4:2:1:Mail::1:0:", -- Formidable Bracers
	[15630]="0:4:2:1:Mail::1:0:", -- Formidable Sabatons
	[15631]="0:4:2:1:Mail::1:0:", -- Formidable Chestpiece
	[15632]="0:4:2:1:Cloak::1:0:", -- Formidable Cape
	[15633]="0:4:2:1:Shield::1:0:", -- Formidable Crest
	[15634]="0:4:2:1:Mail::1:0:", -- Formidable Circlet
	[15635]="0:4:2:1:Mail::1:0:", -- Formidable Gauntlets
	[15636]="0:4:2:1:Mail::1:0:", -- Formidable Belt
	[15637]="0:4:2:1:Mail::1:0:", -- Formidable Legguards
	[15638]="0:4:2:1:Mail::1:0:", -- Formidable Shoulder Pads
	[15639]="0:4:2:1:Mail::1:0:", -- Ironhide Bracers
	[15640]="0:4:2:1:Mail::1:0:", -- Ironhide Breastplate
	[15641]="0:4:2:1:Mail::1:0:", -- Ironhide Belt
	[15642]="0:4:2:1:Mail::1:0:", -- Ironhide Greaves
	[15643]="0:4:2:1:Cloak::1:0:", -- Ironhide Cloak
	[15644]="0:4:2:1:Mail::1:0:", -- Ironhide Gauntlets
	[15645]="0:4:2:1:Mail::1:0:", -- Ironhide Helmet
	[15646]="0:4:2:1:Mail::1:0:", -- Ironhide Legguards
	[15647]="0:4:2:1:Mail::1:0:", -- Ironhide Pauldrons
	[15648]="0:4:2:1:Shield::1:0:", -- Ironhide Shield
	[15649]="0:4:2:1:Mail::1:0:", -- Merciless Bracers
	[15650]="0:4:2:1:Mail::1:0:", -- Merciless Surcoat
	[15651]="0:4:2:1:Mail::1:0:", -- Merciless Crown
	[15652]="0:4:2:1:Cloak::1:0:", -- Merciless Cloak
	[15653]="0:4:2:1:Mail::1:0:", -- Merciless Gauntlets
	[15654]="0:4:2:1:Mail::1:0:", -- Merciless Belt
	[15655]="0:4:2:1:Mail::1:0:", -- Merciless Legguards
	[15656]="0:4:2:1:Mail::1:0:", -- Merciless Epaulets
	[15657]="0:4:2:1:Shield::1:0:", -- Merciless Shield
	[15658]="0:4:2:1:Mail::1:0:", -- Impenetrable Sabatons
	[15659]="0:4:2:1:Mail::1:0:", -- Impenetrable Bindings
	[15660]="0:4:2:1:Mail::1:0:", -- Impenetrable Breastplate
	[15661]="0:4:2:1:Cloak::1:0:", -- Impenetrable Cloak
	[15662]="0:4:2:1:Mail::1:0:", -- Impenetrable Gauntlets
	[15663]="0:4:2:1:Mail::1:0:", -- Impenetrable Belt
	[15664]="0:4:2:1:Mail::1:0:", -- Impenetrable Helmet
	[15665]="0:4:2:1:Mail::1:0:", -- Impenetrable Legguards
	[15666]="0:4:2:1:Mail::1:0:", -- Impenetrable Pauldrons
	[15667]="0:4:2:1:Shield::1:0:", -- Impenetrable Wall
	[15668]="0:4:2:1:Mail::1:0:", -- Magnificent Bracers
	[15669]="0:4:2:1:Mail::1:0:", -- Magnificent Breastplate
	[15670]="0:4:2:1:Mail::1:0:", -- Magnificent Helmet
	[15671]="0:4:2:1:Cloak::1:0:", -- Magnificent Cloak
	[15672]="0:4:2:1:Mail::1:0:", -- Magnificent Gauntlets
	[15673]="0:4:2:1:Mail::1:0:", -- Magnificent Belt
	[15674]="0:4:2:1:Mail::1:0:", -- Magnificent Greaves
	[15675]="0:4:2:1:Shield::1:0:", -- Magnificent Guard
	[15676]="0:4:2:1:Mail::1:0:", -- Magnificent Leggings
	[15677]="0:4:2:1:Mail::1:0:", -- Magnificent Shoulders
	[15678]="0:4:2:1:Mail::1:0:", -- Triumphant Sabatons
	[15679]="0:4:2:1:Mail::1:0:", -- Triumphant Bracers
	[15680]="0:4:2:1:Mail::1:0:", -- Triumphant Chestpiece
	[15681]="0:4:2:1:Cloak::1:0:", -- Triumphant Cloak
	[15682]="0:4:2:1:Mail::1:0:", -- Triumphant Gauntlets
	[15683]="0:4:2:1:Mail::1:0:", -- Triumphant Girdle
	[15684]="0:4:2:1:Mail::1:0:", -- Triumphant Skullcap
	[15685]="0:4:2:1:Mail::1:0:", -- Triumphant Legplates
	[15686]="0:4:2:1:Mail::1:0:", -- Triumphant Shoulder Pads
	[15687]="0:4:2:1:Shield::1:0:", -- Triumphant Shield
	[15689]="0:4:2:1:Ring::1:0:", -- Trader's Ring
	[15690]="0:4:2:1:Amulet::1:0:", -- Kodobone Necklace
	[15691]="0:2:2:1:Gun::1:0:", -- Sidegunner Shottie
	[15692]="0:2:2:1:Wand::1:0:", -- Kodo Brander
	[15693]="0:4:2:1:Leather::1:0:", -- Grand Shoulders
	[15694]="0:4:2:1:Mail::1:0:", -- Merciless Greaves
	[15695]="0:4:2:1:Shield::1:0:", -- Studded Ring Shield
	[15696]="0:12:1:1:::1:0:", -- Ruined Tome
	[15697]="0:4:2:1:Cloth::1:0:", -- Kodo Rustler Boots
	[15698]="0:4:2:1:Mail::1:0:", -- Wrangling Spaulders
	[15699]="0:15:1:1:Junk::1:0:", -- Small Brown-wrapped Package
	[15702]="0:4:2:1:Ring::1:0:", -- Chemist's Ring
	[15703]="0:4:2:1:Cloak::1:0:", -- Chemist's Smock
	[15704]="0:4:2:1:Amulet::1:0:", -- Hunter's Insignia Medal
	[15705]="0:2:2:1:OneHandSword::1:0:", -- Tidecrest Blade
	[15706]="0:2:2:1:Dagger::1:0:", -- Hunt Tracker Blade
	[15707]="0:4:2:1:Cloth::1:0:", -- Brantwood Sash
	[15708]="0:4:2:1:Leather::1:0:", -- Blight Leather Gloves
	[15709]="0:4:2:1:Plate::1:0:", -- Gearforge Girdle
	[15710]="0:12:1:1:::1:0:", -- Cenarion Lunardust
	[15722]="0:12:1:1:::1:0:", -- Spraggle's Canteen
	[15723]="0:0:2:1:Consumable::1:0:", -- Tea with Sugar
	[15724]="12000:9:1:1:Leatherworking::1:1:12956", -- Pattern: Heavy Scorpid Bracers
	[15725]="12000:9:1:1:Leatherworking::1:1:12942,12943", -- Pattern: Wicked Leather Gauntlets
	[15726]="12000:9:1:1:Leatherworking::1:1:11874", -- Pattern: Green Dragonscale Breastplate
	[15727]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Heavy Scorpid Vest
	[15728]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wicked Leather Bracers
	[15729]="12000:9:1:1:Leatherworking::1:1:12957", -- Pattern: Chimeric Gloves
	[15730]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Red Dragonscale Breastplate
	[15731]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Runic Leather Gauntlets
	[15732]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Volcanic Leggings
	[15733]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Green Dragonscale Leggings
	[15734]="14000:9:1:1:Leatherworking::1:1:7852,7854", -- Pattern: Living Shoulders
	[15735]="14000:9:1:1:Leatherworking::1:1:12958", -- Pattern: Ironfeather Shoulders
	[15736]="0:12:1:1:::1:0:", -- Smokey's Special Compound
	[15737]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Chimeric Boots
	[15738]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Heavy Scorpid Gauntlets
	[15739]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Runic Leather Bracers
	[15740]="16000:9:1:1:Leatherworking::1:1:11189", -- Pattern: Frostsaber Boots
	[15741]="16000:9:1:1:Leatherworking::1:1:12942,12943", -- Pattern: Stormshroud Pants
	[15742]="0:9:1:1:Leatherworking::1:0:", -- Pattern: Warbear Harness
	[15743]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Heavy Scorpid Belt
	[15744]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wicked Leather Headband
	[15745]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Runic Leather Belt
	[15746]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Chimeric Leggings
	[15747]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Frostsaber Leggings
	[15748]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Heavy Scorpid Leggings
	[15749]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Volcanic Breastplate
	[15750]="0:12:1:1:::1:0:", -- Sceptre of Light
	[15751]="20000:9:1:1:Leatherworking::1:1:12957", -- Pattern: Blue Dragonscale Breastplate
	[15752]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Living Leggings
	[15753]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Stormshroud Armor
	[15754]="0:9:1:1:Leatherworking::1:0:", -- Pattern: Warbear Woolies
	[15755]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Chimeric Vest
	[15756]="0:9:1:1:Leatherworking::1:0:", -- Pattern: Runic Leather Headband
	[15757]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wicked Leather Pants
	[15758]="22000:9:1:1:Leatherworking::1:1:12959", -- Pattern: Devilsaur Gauntlets
	[15759]="22000:9:1:1:Leatherworking::1:1:9499", -- Pattern: Black Dragonscale Breastplate
	[15760]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Ironfeather Breastplate
	[15761]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Frostsaber Gloves
	[15762]="25000:9:1:1:Leatherworking::1:1:12956", -- Pattern: Heavy Scorpid Helm
	[15763]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Blue Dragonscale Shoulders
	[15764]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Stormshroud Shoulders
	[15765]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Runic Leather Pants
	[15766]="0:12:1:1:::1:0:", -- Gem of the Serpent
	[15767]="0:13:1:1:::1:0:", -- Hameya's Key
	[15768]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wicked Leather Belt
	[15770]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Black Dragonscale Shoulders
	[15771]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Living Breastplate
	[15772]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Devilsaur Leggings
	[15773]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Wicked Leather Armor
	[15774]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Heavy Scorpid Shoulders
	[15775]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Volcanic Shoulders
	[15776]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Runic Leather Armor
	[15777]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Runic Leather Shoulders
	[15778]="0:15:2:1:CombatPet::1:0:", -- Mechanical Yeti
	[15779]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Frostsaber Tunic
	[15781]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Black Dragonscale Leggings
	[15782]="0:2:2:1:OneHandSword::1:0:", -- Beaststalker Blade
	[15783]="0:2:2:1:Dagger::1:0:", -- Beasthunter Dagger
	[15784]="0:4:2:1:Cloth::1:0:", -- Crystal Breeze Mantle
	[15785]="0:12:1:1:::1:0:", -- Zaeldarr's Head
	[15786]="0:4:2:1:Leather::1:0:", -- Fernpulse Jerkin
	[15787]="0:4:2:1:Mail::1:0:", -- Willow Band Hauberk
	[15788]="0:12:1:1:::1:0:", -- Everlook Report
	[15789]="0:4:2:1:Cloak::1:0:", -- Deep River Cloak
	[15790]="0:12:1:1:::1:0:", -- Studies in Spirit Speaking
	[15791]="0:4:2:1:Cloth::1:0:", -- Turquoise Sash
	[15792]="0:4:2:1:Leather::1:0:", -- Plow Wood Spaulders
	[15793]="0:15:0:20:Junk::1:0:", -- A Chewed Bone
	[15794]="0:4:0:1:Cloth::1:0:", -- Ripped Ogre Loincloth
	[15795]="0:4:2:1:Plate::1:0:", -- Emerald Mist Gauntlets
	[15796]="0:4:2:1:Mail::1:0:", -- Seaspray Bracers
	[15797]="0:4:2:1:Plate::1:0:", -- Shining Armplates
	[15798]="0:15:0:20:Junk::1:0:", -- Chipped Ogre Teeth
	[15799]="0:4:3:1:Amulet::1:0:", -- Heroic Commendation Medal
	[15800]="0:2:3:1:OneHandSword::1:0:", -- Intrepid Shortsword
	[15801]="0:2:3:1:OneHandSword::1:0:", -- Valiant Shortsword
	[15802]="0:4:3:1:Cloth::1:0:", -- Mooncloth Boots
	[15803]="0:12:1:1:::1:0:", -- Book of the Ancients
	[15804]="0:4:2:1:Cloak::1:0:", -- Cerise Drape
	[15805]="0:4:3:1:OffHandFrill::1:0:", -- Penelope's Rose
	[15806]="0:2:3:1:OneHandSword::1:0:", -- Mirah's Song
	[15807]="294:2:1:1:Crossbow::1:0:1287,4602,7976,16715,16919,17667", -- Light Crossbow
	[15808]="3641:2:1:1:Crossbow::1:0:1287,4602,7976,16715,16919,17667", -- Fine Light Crossbow
	[15809]="14691:2:1:1:Crossbow::1:0:1287,4602,7976,16715,16919,17667", -- Heavy Crossbow
	[15810]="10145:2:1:1:Polearm::1:0:1289,4601", -- Short Spear
	[15811]="27133:2:1:1:Polearm::1:0:1289,4601", -- Heavy Spear
	[15812]="0:4:2:1:Cloth::1:0:", -- Orchid Amice
	[15813]="0:4:2:1:Mail::1:0:", -- Gold Link Belt
	[15814]="0:2:2:1:OneHandSword::1:0:", -- Hameya's Slayer
	[15815]="0:4:2:1:Cloak::1:0:", -- Hameya's Cloak
	[15822]="0:4:2:1:Leather::1:0:", -- Shadowskin Spaulders
	[15823]="0:4:2:1:Mail::1:0:", -- Bricksteel Gauntlets
	[15824]="0:4:2:1:Cloth::1:0:", -- Astoria Robes
	[15825]="0:4:2:1:Leather::1:0:", -- Traphook Jerkin
	[15826]="0:12:1:1:::1:0:", -- Curative Animal Salve
	[15827]="0:4:2:1:Mail::1:0:", -- Jadescale Breastplate
	[15842]="0:12:1:1:::1:0:", -- Empty Dreadmist Peak Sampler
	[15843]="0:12:1:1:::1:0:", -- Filled Dreadmist Peak Sampler
	[15844]="0:12:1:1:::1:0:", -- Empty Cliffspring Falls Sampler
	[15845]="0:12:1:1:::1:0:", -- Filled Cliffspring Falls Sampler
	[15846]="0:7:1:1:Device::1:0:", -- Salt Shaker
	[15847]="0:12:1:1:::1:0:", -- Quel'Thalas Registry
	[15848]="0:12:1:1:::1:0:", -- Crate of Ghost Magnets
	[15849]="0:12:1:20:::1:0:", -- Ghost-o-plasm
	[15850]="0:12:1:1:::1:0:", -- Patch of Duskwing's Fur
	[15851]="0:12:1:20:::1:0:", -- Lunar Fungus
	[15852]="0:12:1:20:::1:0:", -- Kodo Horn
	[15853]="0:2:3:1:OneHandAxe::1:0:", -- Windreaper
	[15854]="0:2:3:1:Stave::1:0:", -- Dancing Sliver
	[15855]="0:4:3:1:Ring::1:0:", -- Ring of Protection
	[15856]="0:4:3:1:Amulet::1:0:", -- Archlight Talisman
	[15857]="0:4:3:1:OffHandFrill::1:0:", -- Magebane Scion
	[15858]="0:4:2:1:Cloth::1:0:", -- Freewind Gloves
	[15859]="0:4:2:1:Mail::1:0:", -- Seapost Girdle
	[15860]="0:4:2:1:Plate::1:0:", -- Blinkstrike Armguards
	[15861]="0:4:2:1:Leather::1:0:", -- Swiftfoot Treads
	[15862]="0:2:2:1:OneHandAxe::1:0:", -- Blitzcleaver
	[15863]="0:2:2:1:OneHandMace::1:0:", -- Grave Scepter
	[15864]="0:4:2:1:Cloth::1:0:", -- Condor Bracers
	[15865]="0:4:2:1:Shield::1:0:", -- Anchorhold Buckler
	[15866]="0:4:2:1:OffHandFrill::1:0:", -- Veildust Medicine Bag
	[15867]="0:4:2:1:Trinket::1:0:", -- Prismcharm
	[15868]="0:12:1:1:::1:0:", -- The Grand Crusader's Command
	[15869]="0:13:2:20:::1:0:", -- Silver Skeleton Key
	[15870]="0:13:2:20:::1:0:", -- Golden Skeleton Key
	[15871]="0:13:2:20:::1:0:", -- Truesilver Skeleton Key
	[15872]="0:13:2:20:::1:0:", -- Arcanite Skeleton Key
	[15873]="0:4:3:1:Trinket::1:0:", -- Ragged John's Neverending Cup
	[15874]="0:7:1:20:Other::1:0:", -- Soft-shelled Clam
	[15875]="0:12:1:1:::1:0:", -- Rotten Apple
	[15876]="0:12:1:1:::1:0:", -- Nathanos' Chest
	[15877]="0:12:1:1:::1:0:", -- Shrine Bauble
	[15878]="0:13:1:1:::1:0:", -- Rackmore's Silver Key
	[15879]="0:12:1:1:::1:0:", -- Overlord Ror's Claw
	[15880]="0:12:1:1:::1:0:", -- Head of Ramstein the Gorger
	[15881]="0:13:1:1:::1:0:", -- Rackmore's Golden Key
	[15882]="0:12:1:1:::1:0:", -- Half Pendant of Aquatic Endurance
	[15883]="0:12:1:1:::1:0:", -- Half Pendant of Aquatic Agility
	[15884]="0:12:1:1:::1:0:", -- Augustus' Receipt Book
	[15885]="0:12:1:1:::1:0:", -- Pendant of the Sea Lion
	[15886]="0:12:1:1:::1:0:", -- Timolain's Phylactery
	[15887]="0:4:2:1:Shield::1:0:", -- Heroic Guard
	[15890]="0:4:2:1:Shield::1:0:", -- Vanguard Shield
	[15891]="0:4:2:1:Shield::1:0:", -- Hulking Shield
	[15892]="0:4:2:1:Shield::1:0:", -- Slayer's Shield
	[15893]="0:4:2:1:Shield::1:0:", -- Prospector's Buckler
	[15894]="0:4:2:1:Shield::1:0:", -- Bristlebark Buckler
	[15895]="0:4:1:1:Shield::1:0:", -- Burnt Buckler
	[15902]="80000:15:1:1:Junk::1:1:12384", -- A Crazy Grab Bag
	[15903]="8118:2:1:1:FistWeapon::1:0:3361,4203,7976,19047", -- Right-Handed Claw
	[15904]="21708:2:1:1:FistWeapon::1:0:3361,4203,7976,19047", -- Right-Handed Blades
	[15905]="2130:2:1:1:FistWeapon::1:0:3361,4203,7976,19047", -- Right-Handed Brass Knuckles
	[15906]="2138:2:1:1:FistWeapon::1:0:3361,4203,7976,19047", -- Left-Handed Brass Knuckles
	[15907]="8237:2:1:1:FistWeapon::1:0:3361,4203,7976,19047", -- Left-Handed Claw
	[15908]="0:12:1:1:::1:0:", -- Taming Rod
	[15909]="22107:2:1:1:FistWeapon::1:0:3361,4203,7976,19047", -- Left-Handed Blades
	[15911]="0:12:1:1:::1:0:", -- Taming Rod
	[15912]="0:4:2:1:OffHandFrill::1:0:", -- Buccaneer's Orb
	[15913]="0:12:1:1:::1:0:", -- Taming Rod
	[15914]="0:12:1:1:::1:0:", -- Taming Rod
	[15915]="0:12:1:1:::1:0:", -- Taming Rod
	[15916]="0:12:1:1:::1:0:", -- Taming Rod
	[15917]="0:12:1:1:::1:0:", -- Taming Rod
	[15918]="0:4:2:1:OffHandFrill::1:0:", -- Conjurer's Sphere
	[15919]="0:12:1:1:::1:0:", -- Taming Rod
	[15920]="0:12:1:1:::1:0:", -- Taming Rod
	[15921]="0:12:1:1:::1:0:", -- Taming Rod
	[15922]="0:12:1:1:::1:0:", -- Taming Rod
	[15923]="0:12:1:1:::1:0:", -- Taming Rod
	[15924]="0:12:1:10:::1:0:", -- Soft-shelled Clam Meat
	[15925]="0:4:2:1:OffHandFrill::1:0:", -- Journeyman's Stave
	[15926]="0:4:2:1:OffHandFrill::1:0:", -- Spellbinder Orb
	[15927]="0:4:2:1:OffHandFrill::1:0:", -- Bright Sphere
	[15928]="0:4:2:1:OffHandFrill::1:0:", -- Silver-thread Rod
	[15929]="0:4:2:1:OffHandFrill::1:0:", -- Nightsky Orb
	[15930]="0:4:2:1:OffHandFrill::1:0:", -- Imperial Red Scepter
	[15931]="0:4:2:1:OffHandFrill::1:0:", -- Arcane Star
	[15932]="0:4:2:1:OffHandFrill::1:0:", -- Disciple's Stein
	[15933]="0:4:2:1:OffHandFrill::1:0:", -- Simple Branch
	[15934]="0:4:2:1:OffHandFrill::1:0:", -- Sage's Stave
	[15935]="0:4:2:1:OffHandFrill::1:0:", -- Durable Rod
	[15936]="0:4:2:1:OffHandFrill::1:0:", -- Duskwoven Branch
	[15937]="0:4:2:1:OffHandFrill::1:0:", -- Hibernal Sphere
	[15938]="0:4:2:1:OffHandFrill::1:0:", -- Mystical Orb
	[15939]="0:4:2:1:OffHandFrill::1:0:", -- Councillor's Scepter
	[15940]="0:4:2:1:OffHandFrill::1:0:", -- Elegant Scepter
	[15941]="0:4:2:1:OffHandFrill::1:0:", -- High Councillor's Scepter
	[15942]="0:4:2:1:OffHandFrill::1:0:", -- Master's Rod
	[15943]="0:4:2:1:Shield::1:0:", -- Imbued Shield
	[15944]="0:4:2:1:OffHandFrill::1:0:", -- Ancestral Orb
	[15945]="0:4:2:1:OffHandFrill::1:0:", -- Runic Stave
	[15946]="0:4:2:1:OffHandFrill::1:0:", -- Mystic's Sphere
	[15947]="0:4:2:1:OffHandFrill::1:0:", -- Sanguine Star
	[15962]="0:4:2:1:OffHandFrill::1:0:", -- Satyr's Rod
	[15963]="0:4:2:1:OffHandFrill::1:0:", -- Stonecloth Branch
	[15964]="0:4:2:1:OffHandFrill::1:0:", -- Silksand Star
	[15965]="0:4:2:1:OffHandFrill::1:0:", -- Windchaser Orb
	[15966]="0:4:2:1:OffHandFrill::1:0:", -- Venomshroud Orb
	[15967]="0:4:2:1:OffHandFrill::1:0:", -- Highborne Star
	[15968]="0:4:2:1:OffHandFrill::1:0:", -- Elunarian Sphere
	[15969]="0:4:2:1:OffHandFrill::1:0:", -- Beaded Orb
	[15970]="0:4:2:1:OffHandFrill::1:0:", -- Native Branch
	[15971]="0:4:2:1:OffHandFrill::1:0:", -- Aboriginal Rod
	[15972]="0:4:2:1:OffHandFrill::1:0:", -- Ritual Stein
	[15973]="0:4:2:1:OffHandFrill::1:0:", -- Watcher's Star
	[15974]="0:4:2:1:OffHandFrill::1:0:", -- Pagan Rod
	[15975]="0:4:2:1:OffHandFrill::1:0:", -- Raincaller Scepter
	[15976]="0:4:2:1:OffHandFrill::1:0:", -- Thistlefur Branch
	[15977]="0:4:2:1:OffHandFrill::1:0:", -- Vital Orb
	[15978]="0:4:2:1:OffHandFrill::1:0:", -- Geomancer's Rod
	[15979]="0:4:2:1:OffHandFrill::1:0:", -- Embersilk Stave
	[15980]="0:4:2:1:OffHandFrill::1:0:", -- Darkmist Orb
	[15981]="0:4:2:1:OffHandFrill::1:0:", -- Lunar Sphere
	[15982]="0:4:2:1:OffHandFrill::1:0:", -- Bloodwoven Rod
	[15983]="0:4:2:1:OffHandFrill::1:0:", -- Gaea's Scepter
	[15984]="0:4:2:1:OffHandFrill::1:0:", -- Opulent Scepter
	[15985]="0:4:2:1:OffHandFrill::1:0:", -- Arachnidian Branch
	[15986]="0:4:2:1:OffHandFrill::1:0:", -- Bonecaster's Star
	[15987]="0:4:2:1:OffHandFrill::1:0:", -- Astral Orb
	[15988]="0:4:2:1:OffHandFrill::1:0:", -- Resplendent Orb
	[15989]="0:4:2:1:OffHandFrill::1:0:", -- Eternal Rod
	[15990]="0:4:2:1:Shield::1:0:", -- Enduring Shield
	[15991]="0:4:2:1:Shield::1:0:", -- Warleader's Shield
	[15992]="0:7:1:20:Part:202:1:0:", -- Dense Blasting Powder
	[15993]="0:7:1:20:Explosive::1:0:", -- Thorium Grenade
	[15994]="0:7:1:10:Part:202:1:0:", -- Thorium Widget
	[15995]="0:2:2:1:Gun::1:0:", -- Thorium Rifle
	[15996]="0:15:1:1:Companion::1:0:", -- Lifelike Mechanical Toad
	[15997]="0:6:2:1000:Bullet::1:0:", -- Thorium Shells
	[15998]="0:12:1:1:::1:0:", -- Lewis' Note
	[15999]="0:4:2:1:Cloth::1:0:", -- Spellpower Goggles Xtreme Plus
	[16000]="0:7:1:20:Part:202:1:0:", -- Thorium Tube
	[16001]="0:12:1:1:::1:0:", -- SI:7 Insignia (Fredo)
	[16002]="0:12:1:1:::1:0:", -- SI:7 Insignia (Turyen)
	[16003]="0:12:1:1:::1:0:", -- SI:7 Insignia (Rutger)
	[16004]="0:2:3:1:Gun::1:0:", -- Dark Iron Rifle
	[16005]="0:7:1:20:Explosive::1:0:", -- Dark Iron Bomb
	[16006]="0:7:1:10:Part:202:1:0:", -- Delicate Arcanite Converter
	[16007]="0:2:3:1:Gun::1:0:", -- Flawless Arcanite Rifle
	[16008]="0:4:2:1:Cloth::1:0:", -- Master Engineer's Goggles
	[16009]="0:4:2:1:Amulet::1:0:", -- Voice Amplification Modulator
	[16022]="0:4:3:1:Trinket::1:0:", -- Arcanite Dragonling
	[16023]="0:15:1:10:CombatPet::1:0:", -- Masterwork Target Dummy
	[16039]="0:2:3:1:TwoHandSword::1:0:", -- Ta'Kierthan Songblade
	[16040]="0:7:1:20:Explosive::1:0:", -- Arcane Bomb
	[16041]="0:9:1:1:Engineering::1:0:", -- Schematic: Thorium Grenade
	[16042]="0:9:1:1:Engineering::1:0:", -- Schematic: Thorium Widget
	[16043]="0:9:2:1:Engineering::1:0:", -- Schematic: Thorium Rifle
	[16044]="0:9:2:1:Engineering::1:0:", -- Schematic: Lifelike Mechanical Toad
	[16045]="0:9:2:1:Engineering::1:0:", -- Schematic: Spellpower Goggles Xtreme Plus
	[16046]="16000:9:1:1:Engineering::1:1:11185", -- Schematic: Masterwork Target Dummy
	[16047]="0:9:1:1:Engineering::1:0:", -- Schematic: Thorium Tube
	[16048]="0:9:2:1:Engineering::1:0:", -- Schematic: Dark Iron Rifle
	[16049]="0:9:2:1:Engineering::1:0:", -- Schematic: Dark Iron Bomb
	[16050]="20000:9:1:1:Engineering::1:1:11185", -- Schematic: Delicate Arcanite Converter
	[16051]="0:9:2:1:Engineering::1:0:", -- Schematic: Thorium Shells
	[16052]="0:9:2:1:Engineering::1:0:", -- Schematic: Voice Amplification Modulator
	[16053]="0:9:2:1:Engineering::1:0:", -- Schematic: Master Engineer's Goggles
	[16054]="24000:9:2:1:Engineering::1:1:35826", -- Schematic: Arcanite Dragonling
	[16055]="0:9:2:1:Engineering::1:0:", -- Schematic: Arcane Bomb
	[16056]="0:9:2:1:Engineering::1:0:", -- Schematic: Flawless Arcanite Rifle
	[16058]="0:4:3:1:Ring::1:0:", -- Fordring's Seal
	[16059]="400:4:1:1:Shirt::1:0:1214,1291,3317,3486,3554,3683,4185,4558,5108,8358,16623,16631,16716", -- Common Brown Shirt
	[16060]="400:4:1:1:Shirt::1:0:1214,1291,3317,3486,3554,3683,4185,4558,5108,8358,16623,16631,16716", -- Common White Shirt
	[16072]="0:9:1:1:Cooking::1:0:", -- Expert Cookbook
	[16083]="0:9:1:1:Fishing::1:0:", -- Expert Fishing - The Bass and You
	[16084]="0:9:1:1:FirstAid::1:0:", -- Expert First Aid - Under Wraps
	[16085]="0:9:1:1:FirstAid::1:0:", -- Artisan First Aid - Heal Thyself
	[16110]="12000:9:1:1:Cooking::1:0:2803,2806,11187", -- Recipe: Monster Omelet
	[16111]="12000:9:1:1:Cooking::1:0:989,1149,4305", -- Recipe: Spiced Chili Crab
	[16112]="0:9:1:1:FirstAid::1:0:", -- Manual: Heavy Silk Bandage
	[16113]="0:9:1:1:FirstAid::1:0:", -- Manual: Mageweave Bandage
	[16114]="0:12:1:1:::1:0:", -- Foreman's Blackjack
	[16115]="0:12:1:1:::1:0:", -- Osric's Crate
	[16166]="25:0:1:20:FoodDrink::5:0:2303,3961,4167,4181,4191,4195,4266,6091,7941,12019,12026", -- Bean Soup
	[16167]="125:0:1:20:FoodDrink::5:0:2303,3961,4167,4181,4191,4195,4266,6091,7941,12019,12026", -- Versicolor Treat
	[16168]="2000:0:1:20:FoodDrink::5:0:2303,3961,4167,4181,4191,4195,4266,6091,7941,12019,12026", -- Heaven Peach
	[16169]="1000:0:1:20:FoodDrink::5:0:2303,3961,4167,4181,4191,4195,4266,6091,7941,12019,12026", -- Wild Ricecake
	[16170]="500:0:1:20:FoodDrink::5:0:2303,3961,4167,4181,4191,4195,4266,6091,7941,12019,12026", -- Steamed Mandu
	[16171]="0:0:1:20:FoodDrink::1:0:", -- Shinsollo
	[16189]="0:12:1:1:::1:0:", -- Maggran's Reserve Letter
	[16190]="0:12:1:1:::1:0:", -- Bloodfury Ripper's Remains
	[16192]="0:12:1:1:::1:0:", -- Besseleth's Fang
	[16202]="0:7:2:10:Enchanting:333:1:0:", -- Lesser Eternal Essence
	[16203]="0:7:2:10:Enchanting:333,197:1:0:", -- Greater Eternal Essence
	[16204]="0:7:1:20:Enchanting:333:1:0:", -- Illusion Dust
	[16205]="0:12:1:10:::1:0:", -- Gaea Seed
	[16206]="0:7:1:1:Enchanting:333:1:0:", -- Arcanite Rod
	[16207]="0:7:1:1:Enchanting:333:1:0:", -- Runed Arcanite Rod
	[16208]="0:12:1:1:::1:0:", -- Enchanted Gaea Seeds
	[16209]="0:12:1:1:::1:0:", -- Podrig's Order
	[16210]="0:12:1:1:::1:0:", -- Gordon's Crate
	[16214]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Greater Intellect
	[16215]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Boots - Greater Stamina
	[16216]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Greater Resistance
	[16217]="12000:9:1:1:Enchanting::1:1:4229,4561", -- Formula: Enchant Shield - Greater Stamina
	[16218]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Superior Spirit
	[16219]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Greater Agility
	[16220]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Boots - Spirit
	[16221]="16000:9:1:1:Enchanting::1:1:11189", -- Formula: Enchant Chest - Major Health
	[16222]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Shield - Superior Spirit
	[16223]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Icy Chill
	[16224]="20000:9:1:1:Enchanting::1:1:12022", -- Formula: Enchant Cloak - Superior Defense
	[16242]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Chest - Major Mana
	[16243]="22000:9:1:1:Enchanting::1:1:12022", -- Formula: Runed Arcanite Rod
	[16244]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Greater Strength
	[16245]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Boots - Greater Agility
	[16246]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Superior Strength
	[16247]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant 2H Weapon - Superior Impact
	[16248]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Unholy
	[16249]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant 2H Weapon - Major Intellect
	[16250]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Superior Striking
	[16251]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Superior Stamina
	[16252]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Crusader
	[16253]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Chest - Greater Stats
	[16254]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Lifestealing
	[16255]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant 2H Weapon - Major Spirit
	[16262]="0:12:1:1:::1:0:", -- Nessa's Collection
	[16263]="0:12:1:1:::1:0:", -- Laird's Response
	[16282]="0:0:1:1:Consumable::1:0:", -- Bundle of Hides
	[16283]="0:12:1:1:::1:0:", -- Ahanu's Leather Goods
	[16302]="100:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Firebolt (Rank 2)
	[16303]="0:12:2:1:::1:0:", -- Ursangous's Paw
	[16304]="0:12:2:1:::1:0:", -- Shadumbra's Head
	[16305]="0:12:2:1:::1:0:", -- Sharptalon's Claw
	[16306]="0:12:1:1:::1:0:", -- Zargh's Meats
	[16307]="0:12:1:1:::1:0:", -- Gryshka's Letter
	[16309]="0:4:3:1:Amulet::1:0:", -- Drakefire Amulet
	[16310]="0:12:1:1:::1:0:", -- Brock's List
	[16311]="0:12:1:1:::1:0:", -- Honorary Picks
	[16312]="0:12:1:10:::1:0:", -- Incendrites
	[16313]="0:12:1:1:::1:0:", -- Felix's Chest
	[16314]="0:12:1:1:::1:0:", -- Felix's Bucket of Bolts
	[16316]="1500:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Firebolt (Rank 3)
	[16317]="5000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Firebolt (Rank 4)
	[16318]="10000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Firebolt (Rank 5)
	[16319]="14000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Firebolt (Rank 6)
	[16320]="24000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Firebolt (Rank 7)
	[16321]="100:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Blood Pact (Rank 1)
	[16322]="900:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Blood Pact (Rank 2)
	[16323]="4000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Blood Pact (Rank 3)
	[16324]="10000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Blood Pact (Rank 4)
	[16325]="15000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Blood Pact (Rank 5)
	[16326]="900:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Fire Shield (Rank 1)
	[16327]="3000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Fire Shield (Rank 2)
	[16328]="8000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Fire Shield (Rank 3)
	[16329]="12000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Fire Shield (Rank 4)
	[16330]="20000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Fire Shield (Rank 5)
	[16331]="600:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Phase Shift
	[16332]="0:12:1:1:::1:0:", -- Thazz'ril's Pick
	[16333]="0:12:1:1:::1:0:", -- Samuel's Remains
	[16335]="0:4:3:1:Amulet::1:0:12799", -- Senior Sergeant's Insignia
	[16339]="0:15:1:1:Mount::1:0:", -- Commander's Steed
	[16341]="0:4:3:1:Cloak::1:0:12799", -- Sergeant's Cloak
	[16342]="0:4:3:1:Cloak::1:0:", -- Sergeant's Cape
	[16345]="0:2:4:1:OneHandSword::1:0:", -- High Warlord's Blade
	[16346]="2000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Torment (Rank 2)
	[16347]="6000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Torment (Rank 3)
	[16348]="11000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Torment (Rank 4)
	[16349]="15000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Torment (Rank 5)
	[16350]="26000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Torment (Rank 6)
	[16351]="1200:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Sacrifice (Rank 1)
	[16352]="3000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Sacrifice (Rank 2)
	[16353]="7000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Sacrifice (Rank 3)
	[16354]="11000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Sacrifice (Rank 4)
	[16355]="14000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Sacrifice (Rank 5)
	[16356]="22000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Sacrifice (Rank 6)
	[16357]="1500:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Consume Shadows (Rank 1)
	[16358]="4000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Consume Shadows (Rank 2)
	[16359]="8000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Consume Shadows (Rank 3)
	[16360]="11000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Consume Shadows (Rank 4)
	[16361]="15000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Consume Shadows (Rank 5)
	[16362]="24000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Consume Shadows (Rank 6)
	[16363]="3000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Suffering (Rank 1)
	[16364]="9000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Suffering (Rank 2)
	[16365]="14000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Suffering (Rank 3)
	[16366]="26000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Suffering (Rank 4)
	[16368]="5000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Lash of Pain (Rank 2)
	[16369]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Silk Boots
	[16371]="9000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Lash of Pain (Rank 3)
	[16372]="12000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Lash of Pain (Rank 4)
	[16373]="18000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Lash of Pain (Rank 5)
	[16374]="26000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Lash of Pain (Rank 6)
	[16375]="2500:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Soothing Kiss (Rank 1)
	[16376]="8000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Soothing Kiss (Rank 2)
	[16377]="13000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Soothing Kiss (Rank 3)
	[16378]="24000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Soothing Kiss (Rank 4)
	[16379]="4000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Seduction
	[16380]="7000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Lesser Invisibility
	[16381]="10000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Devour Magic (Rank 2)
	[16382]="13000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Devour Magic (Rank 3)
	[16383]="20000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Devour Magic (Rank 4)
	[16384]="7000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Tainted Blood (Rank 1)
	[16385]="11000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Tainted Blood (Rank 2)
	[16386]="14000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Tainted Blood (Rank 3)
	[16387]="22000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Tainted Blood (Rank 4)
	[16388]="9000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Spell Lock (Rank 1)
	[16389]="18000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Spell Lock (Rank 2)
	[16390]="11000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Paranoia
	[16391]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Silk Gloves
	[16392]="0:4:3:1:Leather::1:0:", -- Knight-Lieutenant's Leather Boots
	[16393]="0:4:3:1:Leather::1:0:", -- Knight-Lieutenant's Dragonhide Footwraps
	[16396]="0:4:3:1:Leather::1:0:", -- Knight-Lieutenant's Leather Gauntlets
	[16397]="0:4:3:1:Leather::1:0:", -- Knight-Lieutenant's Dragonhide Gloves
	[16401]="0:4:3:1:Mail::1:0:", -- Knight-Lieutenant's Chain Boots
	[16403]="0:4:3:1:Mail::1:0:", -- Knight-Lieutenant's Chain Gauntlets
	[16405]="0:4:3:1:Plate::1:0:", -- Knight-Lieutenant's Plate Boots
	[16406]="0:4:3:1:Plate::1:0:", -- Knight-Lieutenant's Plate Gauntlets
	[16408]="0:12:2:1:::1:0:", -- Befouled Water Globe
	[16409]="0:4:3:1:Plate::1:0:", -- Knight-Lieutenant's Lamellar Sabatons
	[16410]="0:4:3:1:Plate::1:0:", -- Knight-Lieutenant's Lamellar Gauntlets
	[16413]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Silk Raiment
	[16414]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Silk Leggings
	[16415]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Silk Spaulders
	[16416]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Crown
	[16417]="0:4:3:1:Leather::1:0:", -- Knight-Captain's Leather Armor
	[16418]="0:4:3:1:Leather::1:0:", -- Lieutenant Commander's Leather Veil
	[16419]="0:4:3:1:Leather::1:0:", -- Knight-Captain's Leather Legguards
	[16420]="0:4:3:1:Leather::1:0:", -- Lieutenant Commander's Leather Spaulders
	[16421]="0:4:3:1:Leather::1:0:", -- Knight-Captain's Dragonhide Tunic
	[16422]="0:4:3:1:Leather::1:0:", -- Knight-Captain's Dragonhide Leggings
	[16423]="0:4:3:1:Leather::1:0:", -- Lieutenant Commander's Dragonhide Epaulets
	[16424]="0:4:3:1:Leather::1:0:", -- Lieutenant Commander's Dragonhide Shroud
	[16425]="0:4:3:1:Mail::1:0:", -- Knight-Captain's Chain Hauberk
	[16426]="0:4:3:1:Mail::1:0:", -- Knight-Captain's Chain Leggings
	[16427]="0:4:3:1:Mail::1:0:", -- Lieutenant Commander's Chain Pauldrons
	[16428]="0:4:3:1:Mail::1:0:", -- Lieutenant Commander's Chain Helmet
	[16429]="0:4:3:1:Plate::1:0:", -- Lieutenant Commander's Plate Helm
	[16430]="0:4:3:1:Plate::1:0:", -- Knight-Captain's Plate Chestguard
	[16431]="0:4:3:1:Plate::1:0:", -- Knight-Captain's Plate Leggings
	[16432]="0:4:3:1:Plate::1:0:", -- Lieutenant Commander's Plate Pauldrons
	[16433]="0:4:3:1:Plate::1:0:", -- Knight-Captain's Lamellar Breastplate
	[16434]="0:4:3:1:Plate::1:0:", -- Lieutenant Commander's Lamellar Headguard
	[16435]="0:4:3:1:Plate::1:0:", -- Knight-Captain's Lamellar Leggings
	[16436]="0:4:3:1:Plate::1:0:", -- Lieutenant Commander's Lamellar Shoulders
	[16437]="0:4:4:1:Cloth::1:0:", -- Marshal's Silk Footwraps
	[16440]="0:4:4:1:Cloth::1:0:", -- Marshal's Silk Gloves
	[16441]="0:4:4:1:Cloth::1:0:", -- Field Marshal's Coronet
	[16442]="0:4:4:1:Cloth::1:0:", -- Marshal's Silk Leggings
	[16443]="0:4:4:1:Cloth::1:0:", -- Field Marshal's Silk Vestments
	[16444]="0:4:4:1:Cloth::1:0:", -- Field Marshal's Silk Spaulders
	[16446]="0:4:4:1:Leather::1:0:", -- Marshal's Leather Footguards
	[16448]="0:4:4:1:Leather::1:0:", -- Marshal's Dragonhide Gauntlets
	[16449]="0:4:4:1:Leather::1:0:", -- Field Marshal's Dragonhide Spaulders
	[16450]="0:4:4:1:Leather::1:0:", -- Marshal's Dragonhide Legguards
	[16451]="0:4:4:1:Leather::1:0:", -- Field Marshal's Dragonhide Helmet
	[16452]="0:4:4:1:Leather::1:0:", -- Field Marshal's Dragonhide Breastplate
	[16453]="0:4:4:1:Leather::1:0:", -- Field Marshal's Leather Chestpiece
	[16454]="0:4:4:1:Leather::1:0:", -- Marshal's Leather Handgrips
	[16455]="0:4:4:1:Leather::1:0:", -- Field Marshal's Leather Mask
	[16456]="0:4:4:1:Leather::1:0:", -- Marshal's Leather Leggings
	[16457]="0:4:4:1:Leather::1:0:", -- Field Marshal's Leather Epaulets
	[16459]="0:4:4:1:Leather::1:0:", -- Marshal's Dragonhide Boots
	[16462]="0:4:4:1:Mail::1:0:", -- Marshal's Chain Boots
	[16463]="0:4:4:1:Mail::1:0:", -- Marshal's Chain Grips
	[16465]="0:4:4:1:Mail::1:0:", -- Field Marshal's Chain Helm
	[16466]="0:4:4:1:Mail::1:0:", -- Field Marshal's Chain Breastplate
	[16467]="0:4:4:1:Mail::1:0:", -- Marshal's Chain Legguards
	[16468]="0:4:4:1:Mail::1:0:", -- Field Marshal's Chain Spaulders
	[16471]="0:4:4:1:Plate::1:0:", -- Marshal's Lamellar Gloves
	[16472]="0:4:4:1:Plate::1:0:", -- Marshal's Lamellar Boots
	[16473]="0:4:4:1:Plate::1:0:", -- Field Marshal's Lamellar Chestplate
	[16474]="0:4:4:1:Plate::1:0:", -- Field Marshal's Lamellar Faceguard
	[16475]="0:4:4:1:Plate::1:0:", -- Marshal's Lamellar Legplates
	[16476]="0:4:4:1:Plate::1:0:", -- Field Marshal's Lamellar Pauldrons
	[16477]="0:4:4:1:Plate::1:0:", -- Field Marshal's Plate Armor
	[16478]="0:4:4:1:Plate::1:0:", -- Field Marshal's Plate Helm
	[16479]="0:4:4:1:Plate::1:0:", -- Marshal's Plate Legguards
	[16480]="0:4:4:1:Plate::1:0:", -- Field Marshal's Plate Shoulderguards
	[16483]="0:4:4:1:Plate::1:0:", -- Marshal's Plate Boots
	[16484]="0:4:4:1:Plate::1:0:", -- Marshal's Plate Gauntlets
	[16485]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Silk Footwraps
	[16486]="0:4:3:1:Cloth::1:0:12799", -- First Sergeant's Silk Cuffs
	[16487]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Silk Gloves
	[16489]="0:4:3:1:Cloth::1:0:", -- Champion's Silk Hood
	[16490]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Silk Pants
	[16491]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Silk Robes
	[16492]="0:4:3:1:Cloth::1:0:", -- Champion's Silk Shoulderpads
	[16494]="0:4:3:1:Leather::1:0:", -- Blood Guard's Dragonhide Boots
	[16496]="0:4:3:1:Leather::1:0:", -- Blood Guard's Dragonhide Gauntlets
	[16497]="0:4:3:1:Leather::1:0:12799", -- First Sergeant's Leather Armguards
	[16498]="0:4:3:1:Leather::1:0:", -- Blood Guard's Leather Treads
	[16499]="0:4:3:1:Leather::1:0:", -- Blood Guard's Leather Vices
	[16501]="0:4:3:1:Leather::1:0:", -- Champion's Dragonhide Spaulders
	[16502]="0:4:3:1:Leather::1:0:", -- Legionnaire's Dragonhide Trousers
	[16503]="0:4:3:1:Leather::1:0:", -- Champion's Dragonhide Helm
	[16504]="0:4:3:1:Leather::1:0:", -- Legionnaire's Dragonhide Breastplate
	[16505]="0:4:3:1:Leather::1:0:", -- Legionnaire's Leather Hauberk
	[16506]="0:4:3:1:Leather::1:0:", -- Champion's Leather Headguard
	[16507]="0:4:3:1:Leather::1:0:", -- Champion's Leather Mantle
	[16508]="0:4:3:1:Leather::1:0:", -- Legionnaire's Leather Leggings
	[16509]="0:4:3:1:Plate::1:0:", -- Blood Guard's Plate Boots
	[16510]="0:4:3:1:Plate::1:0:", -- Blood Guard's Plate Gloves
	[16513]="0:4:3:1:Plate::1:0:", -- Legionnaire's Plate Armor
	[16514]="0:4:3:1:Plate::1:0:", -- Champion's Plate Headguard
	[16515]="0:4:3:1:Plate::1:0:", -- Legionnaire's Plate Legguards
	[16516]="0:4:3:1:Plate::1:0:", -- Champion's Plate Pauldrons
	[16518]="0:4:3:1:Mail::1:0:", -- Blood Guard's Mail Walkers
	[16519]="0:4:3:1:Mail::1:0:", -- Blood Guard's Mail Grips
	[16521]="0:4:3:1:Mail::1:0:", -- Champion's Mail Helm
	[16522]="0:4:3:1:Mail::1:0:", -- Legionnaire's Mail Chestpiece
	[16523]="0:4:3:1:Mail::1:0:", -- Legionnaire's Mail Leggings
	[16524]="0:4:3:1:Mail::1:0:", -- Champion's Mail Shoulders
	[16525]="0:4:3:1:Mail::1:0:", -- Legionnaire's Chain Breastplate
	[16526]="0:4:3:1:Mail::1:0:", -- Champion's Chain Headguard
	[16527]="0:4:3:1:Mail::1:0:", -- Legionnaire's Chain Leggings
	[16528]="0:4:3:1:Mail::1:0:", -- Champion's Chain Pauldrons
	[16530]="0:4:3:1:Mail::1:0:", -- Blood Guard's Chain Gauntlets
	[16531]="0:4:3:1:Mail::1:0:", -- Blood Guard's Chain Boots
	[16532]="0:4:3:1:Mail::1:0:12799", -- First Sergeant's Mail Wristguards
	[16533]="0:4:4:1:Cloth::1:0:", -- Warlord's Silk Cowl
	[16534]="0:4:4:1:Cloth::1:0:", -- General's Silk Trousers
	[16535]="0:4:4:1:Cloth::1:0:", -- Warlord's Silk Raiment
	[16536]="0:4:4:1:Cloth::1:0:", -- Warlord's Silk Amice
	[16539]="0:4:4:1:Cloth::1:0:", -- General's Silk Boots
	[16540]="0:4:4:1:Cloth::1:0:", -- General's Silk Handguards
	[16541]="0:4:4:1:Plate::1:0:", -- Warlord's Plate Armor
	[16542]="0:4:4:1:Plate::1:0:", -- Warlord's Plate Headpiece
	[16543]="0:4:4:1:Plate::1:0:", -- General's Plate Leggings
	[16544]="0:4:4:1:Plate::1:0:", -- Warlord's Plate Shoulders
	[16545]="0:4:4:1:Plate::1:0:", -- General's Plate Boots
	[16548]="0:4:4:1:Plate::1:0:", -- General's Plate Gauntlets
	[16549]="0:4:4:1:Leather::1:0:", -- Warlord's Dragonhide Hauberk
	[16550]="0:4:4:1:Leather::1:0:", -- Warlord's Dragonhide Helmet
	[16551]="0:4:4:1:Leather::1:0:", -- Warlord's Dragonhide Epaulets
	[16552]="0:4:4:1:Leather::1:0:", -- General's Dragonhide Leggings
	[16554]="0:4:4:1:Leather::1:0:", -- General's Dragonhide Boots
	[16555]="0:4:4:1:Leather::1:0:", -- General's Dragonhide Gloves
	[16558]="0:4:4:1:Leather::1:0:", -- General's Leather Treads
	[16560]="0:4:4:1:Leather::1:0:", -- General's Leather Mitts
	[16561]="0:4:4:1:Leather::1:0:", -- Warlord's Leather Helm
	[16562]="0:4:4:1:Leather::1:0:", -- Warlord's Leather Spaulders
	[16563]="0:4:4:1:Leather::1:0:", -- Warlord's Leather Breastplate
	[16564]="0:4:4:1:Leather::1:0:", -- General's Leather Legguards
	[16565]="0:4:4:1:Mail::1:0:", -- Warlord's Chain Chestpiece
	[16566]="0:4:4:1:Mail::1:0:", -- Warlord's Chain Helmet
	[16567]="0:4:4:1:Mail::1:0:", -- General's Chain Legguards
	[16568]="0:4:4:1:Mail::1:0:", -- Warlord's Chain Shoulders
	[16569]="0:4:4:1:Mail::1:0:", -- General's Chain Boots
	[16571]="0:4:4:1:Mail::1:0:", -- General's Chain Gloves
	[16573]="0:4:4:1:Mail::1:0:", -- General's Mail Boots
	[16574]="0:4:4:1:Mail::1:0:", -- General's Mail Gauntlets
	[16577]="0:4:4:1:Mail::1:0:", -- Warlord's Mail Armor
	[16578]="0:4:4:1:Mail::1:0:", -- Warlord's Mail Helm
	[16579]="0:4:4:1:Mail::1:0:", -- General's Mail Leggings
	[16580]="0:4:4:1:Mail::1:0:", -- Warlord's Mail Spaulders
	[16581]="0:12:1:20:::1:0:", -- Resonite Crystal
	[16583]="10000:15:1:5:Reagent::1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24396,24409,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,35642,37904,37935", -- Demonic Figurine
	[16602]="0:12:1:20:::1:0:", -- Troll Charm
	[16603]="0:12:1:1:::1:0:", -- Enchanted Resonite Crystal
	[16604]="0:4:2:1:Cloth::1:0:", -- Moon Robes of Elune
	[16605]="0:4:2:1:Cloth::1:0:", -- Friar's Robes of the Light
	[16606]="0:4:2:1:Cloth::1:0:", -- Juju Hex Robes
	[16607]="0:4:2:1:Cloth::1:0:", -- Acolyte's Sacrificial Robes
	[16608]="0:4:3:1:Leather::1:0:", -- Aquarius Belt
	[16622]="0:2:2:1:Bow::1:0:", -- Thornflinger
	[16623]="0:4:2:1:Amulet::1:0:", -- Opaline Medallion
	[16642]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Chapter 1
	[16643]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Chapter 2
	[16644]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Chapter 3
	[16645]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 1
	[16646]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 2
	[16647]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 3
	[16648]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 4
	[16649]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 5
	[16650]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 6
	[16651]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 7
	[16652]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 8
	[16653]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 9
	[16654]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 10
	[16655]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 11
	[16656]="0:12:1:1:::1:0:", -- Shredder Operating Manual - Page 12
	[16658]="0:4:2:1:Cloak::1:0:", -- Wildhunter Cloak
	[16659]="0:4:2:1:Leather::1:0:", -- Deftkin Belt
	[16660]="0:4:2:1:Shield::1:0:", -- Driftmire Shield
	[16661]="0:4:2:1:Cloak::1:0:", -- Soft Willow Cape
	[16662]="0:12:1:1:::1:0:", -- Fragment of the Dragon's Eye
	[16663]="0:12:1:1:::1:0:", -- Blood of the Black Dragon Champion
	[16665]="0:9:2:1:Book::1:0:", -- Tome of Tranquilizing Shot
	[16666]="0:4:3:1:Mail::1:0:", -- Vest of Elements
	[16667]="0:4:3:1:Mail::1:0:", -- Coif of Elements
	[16668]="0:4:3:1:Mail::1:0:", -- Kilt of Elements
	[16669]="0:4:3:1:Mail::1:0:", -- Pauldrons of Elements
	[16670]="0:4:3:1:Mail::1:0:", -- Boots of Elements
	[16671]="0:4:3:1:Mail::1:0:", -- Bindings of Elements
	[16672]="0:4:3:1:Mail::1:0:", -- Gauntlets of Elements
	[16673]="0:4:3:1:Mail::1:0:", -- Cord of Elements
	[16674]="0:4:3:1:Mail::1:0:", -- Beaststalker's Tunic
	[16675]="0:4:3:1:Mail::1:0:", -- Beaststalker's Boots
	[16676]="0:4:3:1:Mail::1:0:", -- Beaststalker's Gloves
	[16677]="0:4:3:1:Mail::1:0:", -- Beaststalker's Cap
	[16678]="0:4:3:1:Mail::1:0:", -- Beaststalker's Pants
	[16679]="0:4:3:1:Mail::1:0:", -- Beaststalker's Mantle
	[16680]="0:4:3:1:Mail::1:0:", -- Beaststalker's Belt
	[16681]="0:4:3:1:Mail::1:0:", -- Beaststalker's Bindings
	[16682]="0:4:3:1:Cloth::1:0:", -- Magister's Boots
	[16683]="0:4:3:1:Cloth::1:0:", -- Magister's Bindings
	[16684]="0:4:3:1:Cloth::1:0:", -- Magister's Gloves
	[16685]="0:4:3:1:Cloth::1:0:", -- Magister's Belt
	[16686]="0:4:3:1:Cloth::1:0:", -- Magister's Crown
	[16687]="0:4:3:1:Cloth::1:0:", -- Magister's Leggings
	[16688]="0:4:3:1:Cloth::1:0:", -- Magister's Robes
	[16689]="0:4:3:1:Cloth::1:0:", -- Magister's Mantle
	[16690]="0:4:3:1:Cloth::1:0:", -- Devout Robe
	[16691]="0:4:3:1:Cloth::1:0:", -- Devout Sandals
	[16692]="0:4:3:1:Cloth::1:0:", -- Devout Gloves
	[16693]="0:4:3:1:Cloth::1:0:", -- Devout Crown
	[16694]="0:4:3:1:Cloth::1:0:", -- Devout Skirt
	[16695]="0:4:3:1:Cloth::1:0:", -- Devout Mantle
	[16696]="0:4:3:1:Cloth::1:0:", -- Devout Belt
	[16697]="0:4:3:1:Cloth::1:0:", -- Devout Bracers
	[16698]="0:4:3:1:Cloth::1:0:", -- Dreadmist Mask
	[16699]="0:4:3:1:Cloth::1:0:", -- Dreadmist Leggings
	[16700]="0:4:3:1:Cloth::1:0:", -- Dreadmist Robe
	[16701]="0:4:3:1:Cloth::1:0:", -- Dreadmist Mantle
	[16702]="0:4:3:1:Cloth::1:0:", -- Dreadmist Belt
	[16703]="0:4:3:1:Cloth::1:0:", -- Dreadmist Bracers
	[16704]="0:4:3:1:Cloth::1:0:", -- Dreadmist Sandals
	[16705]="0:4:3:1:Cloth::1:0:", -- Dreadmist Wraps
	[16706]="0:4:3:1:Leather::1:0:", -- Wildheart Vest
	[16707]="0:4:3:1:Leather::1:0:", -- Shadowcraft Cap
	[16708]="0:4:3:1:Leather::1:0:", -- Shadowcraft Spaulders
	[16709]="0:4:3:1:Leather::1:0:", -- Shadowcraft Pants
	[16710]="0:4:3:1:Leather::1:0:", -- Shadowcraft Bracers
	[16711]="0:4:3:1:Leather::1:0:", -- Shadowcraft Boots
	[16712]="0:4:3:1:Leather::1:0:", -- Shadowcraft Gloves
	[16713]="0:4:3:1:Leather::1:0:", -- Shadowcraft Belt
	[16714]="0:4:3:1:Leather::1:0:", -- Wildheart Bracers
	[16715]="0:4:3:1:Leather::1:0:", -- Wildheart Boots
	[16716]="0:4:3:1:Leather::1:0:", -- Wildheart Belt
	[16717]="0:4:3:1:Leather::1:0:", -- Wildheart Gloves
	[16718]="0:4:3:1:Leather::1:0:", -- Wildheart Spaulders
	[16719]="0:4:3:1:Leather::1:0:", -- Wildheart Kilt
	[16720]="0:4:3:1:Leather::1:0:", -- Wildheart Cowl
	[16721]="0:4:3:1:Leather::1:0:", -- Shadowcraft Tunic
	[16722]="0:4:3:1:Plate::1:0:", -- Lightforge Bracers
	[16723]="0:4:3:1:Plate::1:0:", -- Lightforge Belt
	[16724]="0:4:3:1:Plate::1:0:", -- Lightforge Gauntlets
	[16725]="0:4:3:1:Plate::1:0:", -- Lightforge Boots
	[16726]="0:4:3:1:Plate::1:0:", -- Lightforge Breastplate
	[16727]="0:4:3:1:Plate::1:0:", -- Lightforge Helm
	[16728]="0:4:3:1:Plate::1:0:", -- Lightforge Legplates
	[16729]="0:4:3:1:Plate::1:0:", -- Lightforge Spaulders
	[16730]="0:4:3:1:Plate::1:0:", -- Breastplate of Valor
	[16731]="0:4:3:1:Plate::1:0:", -- Helm of Valor
	[16732]="0:4:3:1:Plate::1:0:", -- Legplates of Valor
	[16733]="0:4:3:1:Plate::1:0:", -- Spaulders of Valor
	[16734]="0:4:3:1:Plate::1:0:", -- Boots of Valor
	[16735]="0:4:3:1:Plate::1:0:", -- Bracers of Valor
	[16736]="0:4:3:1:Plate::1:0:", -- Belt of Valor
	[16737]="0:4:3:1:Plate::1:0:", -- Gauntlets of Valor
	[16738]="0:4:2:1:Cloth::1:0:", -- Witherseed Gloves
	[16739]="0:4:2:1:Leather::1:0:", -- Rugwood Mantle
	[16740]="0:4:2:1:Cloth::1:0:", -- Shredder Operating Gloves
	[16741]="0:4:2:1:Leather::1:0:", -- Oilrag Handwraps
	[16742]="0:12:1:1:::1:0:", -- Warsong Saw Blades
	[16743]="0:12:1:20:::1:0:", -- Logging Rope
	[16744]="0:12:1:20:::1:0:", -- Warsong Oil
	[16745]="0:12:1:1:::1:0:", -- Warsong Axe Shipment
	[16746]="0:12:1:20:::1:0:", -- Warsong Report
	[16747]="0:15:0:20:Junk::1:0:", -- Broken Lock
	[16748]="0:15:0:20:Junk::1:0:", -- Padded Lining
	[16762]="0:12:1:1:::1:0:", -- Fathom Core
	[16763]="0:12:1:1:::1:0:", -- Warsong Runner Update
	[16764]="0:12:1:1:::1:0:", -- Warsong Scout Update
	[16765]="0:12:1:1:::1:0:", -- Warsong Outrider Update
	[16766]="0:0:1:20:FoodDrink::1:0:", -- Undermine Clam Chowder
	[16767]="3000:9:1:1:Cooking::1:1:8139", -- Recipe: Undermine Clam Chowder
	[16768]="150000:4:2:1:OffHandFrill::1:0:11555", -- Furbolg Medicine Pouch
	[16769]="133081:2:2:1:OneHandMace::1:0:11555", -- Furbolg Medicine Totem
	[16782]="0:12:2:1:::1:0:", -- Strange Water Globe
	[16783]="0:12:1:20:::1:0:", -- Bundle of Reports
	[16784]="0:12:1:20:::1:0:", -- Sapphire of Aku'Mai
	[16785]="0:12:1:1:::1:0:", -- Rokaro's Letter
	[16786]="0:12:1:20:::1:0:", -- Black Dragonspawn Eye
	[16787]="0:4:1:1:Amulet::1:0:", -- Amulet of Draconic Subversion
	[16788]="0:4:2:1:Shield::1:0:", -- Captain Rackmore's Wheel
	[16789]="0:2:2:1:Wand::1:0:", -- Captain Rackmore's Tiller
	[16790]="0:15:1:1:Junk::1:0:", -- Damp Note
	[16791]="0:4:2:1:Cloth::1:0:", -- Silkstream Cuffs
	[16793]="0:4:2:1:Mail::1:0:", -- Arcmetal Shoulders
	[16794]="0:4:2:1:Mail::1:0:", -- Gripsteel Wristguards
	[16795]="0:4:4:1:Cloth::1:0:", -- Arcanist Crown
	[16796]="0:4:4:1:Cloth::1:0:", -- Arcanist Leggings
	[16797]="0:4:4:1:Cloth::1:0:", -- Arcanist Mantle
	[16798]="0:4:4:1:Cloth::1:0:", -- Arcanist Robes
	[16799]="0:4:4:1:Cloth::1:0:", -- Arcanist Bindings
	[16800]="0:4:4:1:Cloth::1:0:", -- Arcanist Boots
	[16801]="0:4:4:1:Cloth::1:0:", -- Arcanist Gloves
	[16802]="0:4:4:1:Cloth::1:0:", -- Arcanist Belt
	[16803]="0:4:4:1:Cloth::1:0:", -- Felheart Slippers
	[16804]="0:4:4:1:Cloth::1:0:", -- Felheart Bracers
	[16805]="0:4:4:1:Cloth::1:0:", -- Felheart Gloves
	[16806]="0:4:4:1:Cloth::1:0:", -- Felheart Belt
	[16807]="0:4:4:1:Cloth::1:0:", -- Felheart Shoulder Pads
	[16808]="0:4:4:1:Cloth::1:0:", -- Felheart Horns
	[16809]="0:4:4:1:Cloth::1:0:", -- Felheart Robes
	[16810]="0:4:4:1:Cloth::1:0:", -- Felheart Pants
	[16811]="0:4:4:1:Cloth::1:0:", -- Boots of Prophecy
	[16812]="0:4:4:1:Cloth::1:0:", -- Gloves of Prophecy
	[16813]="0:4:4:1:Cloth::1:0:", -- Circlet of Prophecy
	[16814]="0:4:4:1:Cloth::1:0:", -- Pants of Prophecy
	[16815]="0:4:4:1:Cloth::1:0:", -- Robes of Prophecy
	[16816]="0:4:4:1:Cloth::1:0:", -- Mantle of Prophecy
	[16817]="0:4:4:1:Cloth::1:0:", -- Girdle of Prophecy
	[16818]="0:4:4:1:Cloth::1:0:", -- Netherwind Belt
	[16819]="0:4:4:1:Cloth::1:0:", -- Vambraces of Prophecy
	[16820]="0:4:4:1:Leather::1:0:", -- Nightslayer Chestpiece
	[16821]="0:4:4:1:Leather::1:0:", -- Nightslayer Cover
	[16822]="0:4:4:1:Leather::1:0:", -- Nightslayer Pants
	[16823]="0:4:4:1:Leather::1:0:", -- Nightslayer Shoulder Pads
	[16824]="0:4:4:1:Leather::1:0:", -- Nightslayer Boots
	[16825]="0:4:4:1:Leather::1:0:", -- Nightslayer Bracelets
	[16826]="0:4:4:1:Leather::1:0:", -- Nightslayer Gloves
	[16827]="0:4:4:1:Leather::1:0:", -- Nightslayer Belt
	[16828]="0:4:4:1:Leather::1:0:", -- Cenarion Belt
	[16829]="0:4:4:1:Leather::1:0:", -- Cenarion Boots
	[16830]="0:4:4:1:Leather::1:0:", -- Cenarion Bracers
	[16831]="0:4:4:1:Leather::1:0:", -- Cenarion Gloves
	[16832]="0:4:4:1:Leather::1:0:", -- Bloodfang Spaulders
	[16833]="0:4:4:1:Leather::1:0:", -- Cenarion Vestments
	[16834]="0:4:4:1:Leather::1:0:", -- Cenarion Helm
	[16835]="0:4:4:1:Leather::1:0:", -- Cenarion Leggings
	[16836]="0:4:4:1:Leather::1:0:", -- Cenarion Spaulders
	[16837]="0:4:4:1:Mail::1:0:", -- Earthfury Boots
	[16838]="0:4:4:1:Mail::1:0:", -- Earthfury Belt
	[16839]="0:4:4:1:Mail::1:0:", -- Earthfury Gauntlets
	[16840]="0:4:4:1:Mail::1:0:", -- Earthfury Bracers
	[16841]="0:4:4:1:Mail::1:0:", -- Earthfury Vestments
	[16842]="0:4:4:1:Mail::1:0:", -- Earthfury Helmet
	[16843]="0:4:4:1:Mail::1:0:", -- Earthfury Legguards
	[16844]="0:4:4:1:Mail::1:0:", -- Earthfury Epaulets
	[16845]="0:4:4:1:Mail::1:0:", -- Giantstalker's Breastplate
	[16846]="0:4:4:1:Mail::1:0:", -- Giantstalker's Helmet
	[16847]="0:4:4:1:Mail::1:0:", -- Giantstalker's Leggings
	[16848]="0:4:4:1:Mail::1:0:", -- Giantstalker's Epaulets
	[16849]="0:4:4:1:Mail::1:0:", -- Giantstalker's Boots
	[16850]="0:4:4:1:Mail::1:0:", -- Giantstalker's Bracers
	[16851]="0:4:4:1:Mail::1:0:", -- Giantstalker's Belt
	[16852]="0:4:4:1:Mail::1:0:", -- Giantstalker's Gloves
	[16853]="0:4:4:1:Plate::1:0:", -- Lawbringer Chestguard
	[16854]="0:4:4:1:Plate::1:0:", -- Lawbringer Helm
	[16855]="0:4:4:1:Plate::1:0:", -- Lawbringer Legplates
	[16856]="0:4:4:1:Plate::1:0:", -- Lawbringer Spaulders
	[16857]="0:4:4:1:Plate::1:0:", -- Lawbringer Bracers
	[16858]="0:4:4:1:Plate::1:0:", -- Lawbringer Belt
	[16859]="0:4:4:1:Plate::1:0:", -- Lawbringer Boots
	[16860]="0:4:4:1:Plate::1:0:", -- Lawbringer Gauntlets
	[16861]="0:4:4:1:Plate::1:0:", -- Bracers of Might
	[16862]="0:4:4:1:Plate::1:0:", -- Sabatons of Might
	[16863]="0:4:4:1:Plate::1:0:", -- Gauntlets of Might
	[16864]="0:4:4:1:Plate::1:0:", -- Belt of Might
	[16865]="0:4:4:1:Plate::1:0:", -- Breastplate of Might
	[16866]="0:4:4:1:Plate::1:0:", -- Helm of Might
	[16867]="0:4:4:1:Plate::1:0:", -- Legplates of Might
	[16868]="0:4:4:1:Plate::1:0:", -- Pauldrons of Might
	[16869]="0:12:1:1:::1:0:", -- The Skull of Scryer
	[16870]="0:12:1:1:::1:0:", -- The Skull of Somnus
	[16871]="0:12:1:1:::1:0:", -- The Skull of Chronalis
	[16872]="0:12:1:1:::1:0:", -- The Skull of Axtroz
	[16873]="0:4:2:1:Leather::1:0:", -- Braidfur Gloves
	[16882]="0:15:1:1:Junk::1:0:", -- Battered Junkbox
	[16883]="0:15:1:1:Junk::1:0:", -- Worn Junkbox
	[16884]="0:15:1:1:Junk::1:0:", -- Sturdy Junkbox
	[16885]="0:15:1:1:Junk::1:0:", -- Heavy Junkbox
	[16886]="0:2:3:1:OneHandSword::1:0:", -- Outlaw Sabre
	[16887]="0:4:3:1:OffHandFrill::1:0:", -- Witch's Finger
	[16888]="0:12:1:1:::1:0:", -- Dull Drakefire Amulet
	[16889]="0:2:2:1:Stave::1:0:", -- Polished Walking Staff
	[16890]="0:2:2:1:OneHandSword::1:0:", -- Slatemetal Cutlass
	[16891]="0:2:2:1:OneHandSword::1:0:", -- Claystone Shortsword
	[16892]="0:0:1:1:Consumable::1:0:", -- Lesser Soulstone
	[16893]="0:0:1:1:Consumable::1:0:", -- Soulstone
	[16894]="0:2:2:1:Stave::1:0:", -- Clear Crystal Rod
	[16895]="0:0:1:1:Consumable::1:0:", -- Greater Soulstone
	[16896]="0:0:1:1:Consumable::1:0:", -- Major Soulstone
	[16897]="0:4:4:1:Leather::1:0:", -- Stormrage Chestguard
	[16898]="0:4:4:1:Leather::1:0:", -- Stormrage Boots
	[16899]="0:4:4:1:Leather::1:0:", -- Stormrage Handguards
	[16900]="0:4:4:1:Leather::1:0:", -- Stormrage Cover
	[16901]="0:4:4:1:Leather::1:0:", -- Stormrage Legguards
	[16902]="0:4:4:1:Leather::1:0:", -- Stormrage Pauldrons
	[16903]="0:4:4:1:Leather::1:0:", -- Stormrage Belt
	[16904]="0:4:4:1:Leather::1:0:", -- Stormrage Bracers
	[16905]="0:4:4:1:Leather::1:0:", -- Bloodfang Chestpiece
	[16906]="0:4:4:1:Leather::1:0:", -- Bloodfang Boots
	[16907]="0:4:4:1:Leather::1:0:", -- Bloodfang Gloves
	[16908]="0:4:4:1:Leather::1:0:", -- Bloodfang Hood
	[16909]="0:4:4:1:Leather::1:0:", -- Bloodfang Pants
	[16910]="0:4:4:1:Leather::1:0:", -- Bloodfang Belt
	[16911]="0:4:4:1:Leather::1:0:", -- Bloodfang Bracers
	[16912]="0:4:4:1:Cloth::1:0:", -- Netherwind Boots
	[16913]="0:4:4:1:Cloth::1:0:", -- Netherwind Gloves
	[16914]="0:4:4:1:Cloth::1:0:", -- Netherwind Crown
	[16915]="0:4:4:1:Cloth::1:0:", -- Netherwind Pants
	[16916]="0:4:4:1:Cloth::1:0:", -- Netherwind Robes
	[16917]="0:4:4:1:Cloth::1:0:", -- Netherwind Mantle
	[16918]="0:4:4:1:Cloth::1:0:", -- Netherwind Bindings
	[16919]="0:4:4:1:Cloth::1:0:", -- Boots of Transcendence
	[16920]="0:4:4:1:Cloth::1:0:", -- Handguards of Transcendence
	[16921]="0:4:4:1:Cloth::1:0:", -- Halo of Transcendence
	[16922]="0:4:4:1:Cloth::1:0:", -- Leggings of Transcendence
	[16923]="0:4:4:1:Cloth::1:0:", -- Robes of Transcendence
	[16924]="0:4:4:1:Cloth::1:0:", -- Pauldrons of Transcendence
	[16925]="0:4:4:1:Cloth::1:0:", -- Belt of Transcendence
	[16926]="0:4:4:1:Cloth::1:0:", -- Bindings of Transcendence
	[16927]="0:4:4:1:Cloth::1:0:", -- Nemesis Boots
	[16928]="0:4:4:1:Cloth::1:0:", -- Nemesis Gloves
	[16929]="0:4:4:1:Cloth::1:0:", -- Nemesis Skullcap
	[16930]="0:4:4:1:Cloth::1:0:", -- Nemesis Leggings
	[16931]="0:4:4:1:Cloth::1:0:", -- Nemesis Robes
	[16932]="0:4:4:1:Cloth::1:0:", -- Nemesis Spaulders
	[16933]="0:4:4:1:Cloth::1:0:", -- Nemesis Belt
	[16934]="0:4:4:1:Cloth::1:0:", -- Nemesis Bracers
	[16935]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Bracers
	[16936]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Belt
	[16937]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Spaulders
	[16938]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Legguards
	[16939]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Helm
	[16940]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Gauntlets
	[16941]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Greaves
	[16942]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Breastplate
	[16943]="0:4:4:1:Mail::1:0:", -- Bracers of Ten Storms
	[16944]="0:4:4:1:Mail::1:0:", -- Belt of Ten Storms
	[16945]="0:4:4:1:Mail::1:0:", -- Epaulets of Ten Storms
	[16946]="0:4:4:1:Mail::1:0:", -- Legplates of Ten Storms
	[16947]="0:4:4:1:Mail::1:0:", -- Helmet of Ten Storms
	[16948]="0:4:4:1:Mail::1:0:", -- Gauntlets of Ten Storms
	[16949]="0:4:4:1:Mail::1:0:", -- Greaves of Ten Storms
	[16950]="0:4:4:1:Mail::1:0:", -- Breastplate of Ten Storms
	[16951]="0:4:4:1:Plate::1:0:", -- Judgement Bindings
	[16952]="0:4:4:1:Plate::1:0:", -- Judgement Belt
	[16953]="0:4:4:1:Plate::1:0:", -- Judgement Spaulders
	[16954]="0:4:4:1:Plate::1:0:", -- Judgement Legplates
	[16955]="0:4:4:1:Plate::1:0:", -- Judgement Crown
	[16956]="0:4:4:1:Plate::1:0:", -- Judgement Gauntlets
	[16957]="0:4:4:1:Plate::1:0:", -- Judgement Sabatons
	[16958]="0:4:4:1:Plate::1:0:", -- Judgement Breastplate
	[16959]="0:4:4:1:Plate::1:0:", -- Bracelets of Wrath
	[16960]="0:4:4:1:Plate::1:0:", -- Waistband of Wrath
	[16961]="0:4:4:1:Plate::1:0:", -- Pauldrons of Wrath
	[16962]="0:4:4:1:Plate::1:0:", -- Legplates of Wrath
	[16963]="0:4:4:1:Plate::1:0:", -- Helm of Wrath
	[16964]="0:4:4:1:Plate::1:0:", -- Gauntlets of Wrath
	[16965]="0:4:4:1:Plate::1:0:", -- Sabatons of Wrath
	[16966]="0:4:4:1:Plate::1:0:", -- Breastplate of Wrath
	[16967]="0:4:1:1:OffHandFrill::1:0:", -- Feralas Ahi
	[16968]="0:12:1:1:::1:0:", -- Sar'theris Striker
	[16969]="0:12:1:1:::1:0:", -- Savage Coast Blue Sailfin
	[16970]="0:12:1:1:::1:0:", -- Misty Reed Mahi Mahi
	[16971]="0:0:1:20:FoodDrink::1:0:", -- Clamlette Surprise
	[16972]="0:12:1:1:::1:0:", -- Karang's Banner
	[16973]="0:12:1:1:::1:0:", -- Vial of Dire Water
	[16974]="0:12:1:1:::1:0:", -- Empty Water Vial
	[16975]="0:4:3:1:Cloth::1:0:", -- Warsong Sash
	[16976]="0:12:1:1:::1:0:", -- Murgut's Totem
	[16977]="0:4:3:1:Leather::1:0:", -- Warsong Boots
	[16978]="0:4:3:1:Mail::1:0:", -- Warsong Gauntlets
	[16979]="0:4:4:1:Cloth::1:0:", -- Flarecore Gloves
	[16980]="0:4:4:1:Cloth::1:0:", -- Flarecore Mantle
	[16981]="0:4:2:1:Cloth::1:0:", -- Owlbeard Bracers
	[16982]="0:4:4:1:Leather::1:0:", -- Corehound Boots
	[16983]="0:4:4:1:Leather::1:0:", -- Molten Helm
	[16984]="0:4:4:1:Mail::1:0:", -- Black Dragonscale Boots
	[16985]="0:4:2:1:Cloth::1:0:", -- Windseeker Boots
	[16986]="0:4:2:1:Mail::1:0:", -- Sandspire Gloves
	[16987]="0:4:2:1:Leather::1:0:", -- Screecher Belt
	[16988]="0:4:4:1:Mail::1:0:", -- Fiery Chain Shoulders
	[16989]="0:4:4:1:Mail::1:0:", -- Fiery Chain Girdle
	[16990]="0:4:2:1:Cloak::1:0:", -- Spritekin Cloak
	[16991]="0:12:1:1:::1:0:", -- Triage Bandage
	[16992]="0:2:2:1:Gun::1:0:", -- Smokey's Explosive Launcher
	[16993]="0:2:2:1:Wand::1:0:", -- Smokey's Fireshooter
	[16994]="0:4:2:1:Leather::1:0:", -- Duskwing Gloves
	[16995]="0:4:2:1:Leather::1:0:", -- Duskwing Mantle
	[16996]="0:2:3:1:Bow::1:0:", -- Gorewood Bow
	[16997]="0:2:3:1:Wand::1:0:", -- Stormrager
	[16998]="0:4:3:1:Shield::1:0:", -- Sacred Protector
	[17001]="0:4:2:1:Ring::1:0:", -- Elemental Circle
	[17002]="0:2:2:1:OneHandAxe::1:0:", -- Ichor Spitter
	[17003]="0:2:2:1:OneHandMace::1:0:", -- Skullstone Hammer
	[17004]="0:2:2:1:Stave::1:0:", -- Sarah's Guide
	[17005]="0:4:2:1:Leather::1:0:", -- Boorguard Tunic
	[17006]="0:4:2:1:Mail::1:0:", -- Cobalt Legguards
	[17007]="0:4:4:1:Mail::1:0:", -- Stonerender Gauntlets
	[17008]="0:15:1:1:Junk::1:0:", -- Small Scroll
	[17009]="0:12:1:1:::1:0:", -- Ambassador Malcin's Head
	[17010]="0:7:3:10:Other:164,202,165,186,197:1:0:", -- Fiery Core
	[17011]="0:7:3:10:Other:164,202,165,197:1:0:", -- Lava Core
	[17012]="0:7:1:20:Leather:164,165,197:1:0:", -- Core Leather
	[17013]="0:4:4:1:Plate::1:0:", -- Dark Iron Leggings
	[17014]="0:4:4:1:Plate::1:0:", -- Dark Iron Bracers
	[17015]="0:2:3:1:OneHandSword::1:0:", -- Dark Iron Reaver
	[17016]="0:2:3:1:OneHandAxe::1:0:", -- Dark Iron Destroyer
	[17017]="180000:9:1:1:Tailoring::1:1:12944", -- Pattern: Flarecore Mantle
	[17018]="80000:9:1:1:Tailoring::1:1:12944", -- Pattern: Flarecore Gloves
	[17020]="1000:15:1:100:Reagent:202,-8:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,35642,37904,37935", -- Arcane Powder
	[17021]="700:15:1:20:Reagent:-11:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,37904,37935", -- Wild Berries
	[17022]="150000:9:1:1:Leatherworking::1:1:12944", -- Pattern: Corehound Boots
	[17023]="160000:9:1:1:Leatherworking::1:1:12944", -- Pattern: Molten Helm
	[17025]="160000:9:1:1:Leatherworking::1:1:12944", -- Pattern: Black Dragonscale Boots
	[17026]="1000:15:1:20:Reagent:-11:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,37904,37935", -- Wild Thornroot
	[17028]="700:15:1:20:Reagent:-5:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,37904,37935", -- Holy Candle
	[17029]="1000:15:1:20:Reagent:-5:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24396,24409,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,37904,37935", -- Sacred Candle
	[17030]="2000:15:1:10:Reagent:-7:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24396,24409,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,35642,37904,37935", -- Ankh
	[17031]="1000:15:1:20:Reagent:-8:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,35642,37904,37935", -- Rune of Teleportation
	[17032]="2000:15:1:20:Reagent:-8:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,35642,37904,37935", -- Rune of Portals
	[17033]="2000:15:1:5:Reagent:-2:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24396,24409,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,35642,37904,37935", -- Symbol of Divinity
	[17034]="200:15:1:20:Reagent:333,-11:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16611,16612,16706,16757,16829,18006,18019,18243,19004,19678,19718,20081,22479,23112,23560,24843,24935,24995,25010,25019,25051,25082,26474,26569,26598,26900,26908,26984,27030,27039,27054,27088,29288,29537,29636,30239,30244,30307,30438,31115,32639,32641,33630,33633,33674,33676,33871", -- Maple Seed
	[17035]="400:15:1:20:Reagent:333,-11:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16611,16612,16706,16757,16829,18006,18019,18243,19004,19678,19718,20081,22479,23112,23560,24843,24935,24995,25010,25019,25051,25082,26474,26569,26598,26900,26908,26984,27030,27039,27054,27088,29288,29537,29636,30239,30244,30307,30438,31115,32639,32641,33630,33633,33674,33676,33871", -- Stranglethorn Seed
	[17036]="800:15:1:20:Reagent:-11:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16611,16612,16706,16757,16829,18006,18019,18243,19004,19678,19718,20081,22479,23112,23560,24843,24935,24995,25010,25019,25051,25082,26474,26569,26598,26900,26908,26984,27030,27039,27054,27088,29288,29537,29636,30239,30244,30307,30438,31115,32639,32641,33630,33633,33674,33676,33871", -- Ashwood Seed
	[17037]="1400:15:1:20:Reagent:-11:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,37904,37935", -- Hornbeam Seed
	[17038]="2000:15:1:20:Reagent:-11:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,37904,37935", -- Ironwood Seed
	[17039]="0:2:2:1:OneHandMace::1:0:", -- Skullbreaker
	[17042]="0:2:2:1:Gun::1:0:", -- Nail Spitter
	[17043]="0:4:2:1:Cloth::1:0:", -- Zealot's Robe
	[17044]="0:4:3:1:Amulet::1:0:", -- Will of the Martyr
	[17045]="0:4:3:1:Ring::1:0:", -- Blood of the Martyr
	[17046]="0:2:2:1:OneHandAxe::1:0:", -- Gutterblade
	[17047]="0:4:2:1:Cloth::1:0:", -- Luminescent Amice
	[17048]="0:0:1:10:Consumable::1:0:", -- Rumsey Rum
	[17049]="90000:9:3:1:Blacksmithing::1:1:12944", -- Plans: Fiery Chain Girdle
	[17050]="0:4:3:1:Cloth::1:0:", -- Chan's Imperial Robes
	[17051]="70000:9:3:1:Blacksmithing::1:1:12944", -- Plans: Dark Iron Bracers
	[17052]="180000:9:3:1:Blacksmithing::1:0:12944", -- Plans: Dark Iron Leggings
	[17053]="200000:9:3:1:Blacksmithing::1:0:12944", -- Plans: Fiery Chain Shoulders
	[17054]="0:2:3:1:OneHandSword::1:0:", -- Joonho's Mercy
	[17055]="0:2:3:1:OneHandMace::1:0:", -- Changuk Smasher
	[17056]="0:15:1:20:Reagent:165,-8,-5:1:0:", -- Light Feather
	[17057]="0:15:1:20:Reagent:-7:1:0:", -- Shiny Fish Scales
	[17058]="0:15:1:20:Reagent:-7:1:0:", -- Fish Oil
	[17059]="220000:9:3:1:Blacksmithing::1:1:12944", -- Plans: Dark Iron Reaver
	[17060]="220000:9:3:1:Blacksmithing::1:1:12944", -- Plans: Dark Iron Destroyer
	[17061]="0:4:3:1:Cloak::1:0:", -- Juno's Shadow
	[17062]="2200:9:1:1:Cooking::1:0:2383,2664,3178,3333,4307,4574,5162,12033,12962", -- Recipe: Mithril Head Trout
	[17063]="0:4:4:1:Ring::1:0:", -- Band of Accuria
	[17064]="0:4:4:1:Trinket::1:0:", -- Shard of the Scale
	[17065]="0:4:4:1:Amulet::1:0:", -- Medallion of Steadfast Might
	[17066]="0:4:4:1:Shield::1:0:", -- Drillborer Disk
	[17067]="0:4:4:1:OffHandFrill::1:0:", -- Ancient Cornerstone Grimoire
	[17068]="0:2:4:1:OneHandAxe::1:0:", -- Deathbringer
	[17069]="0:2:4:1:Bow::1:0:", -- Striker's Mark
	[17070]="0:2:4:1:Dagger::1:0:", -- Fang of the Mystics
	[17071]="0:2:4:1:Dagger::1:0:", -- Gutgore Ripper
	[17072]="0:2:4:1:Gun::1:0:", -- Blastershot Launcher
	[17073]="0:2:4:1:TwoHandMace::1:0:", -- Earthshaker
	[17074]="0:2:4:1:Polearm::1:0:", -- Shadowstrike
	[17075]="0:2:4:1:OneHandSword::1:0:", -- Vis'kag the Bloodletter
	[17076]="0:2:4:1:TwoHandSword::1:0:", -- Bonereaver's Edge
	[17077]="0:2:4:1:Wand::1:0:", -- Crimson Shocker
	[17078]="0:4:4:1:Cloak::1:0:", -- Sapphiron Drape
	[17082]="0:4:4:1:Trinket::1:0:", -- Shard of the Flame
	[17102]="0:4:4:1:Cloak::1:0:", -- Cloak of the Shrouded Mists
	[17103]="0:2:4:1:OneHandSword::1:0:", -- Azuresong Mageblade
	[17104]="0:2:4:1:TwoHandAxe::1:0:", -- Spinal Reaper
	[17105]="0:2:4:1:OneHandMace::1:0:", -- Aurastone Hammer
	[17106]="0:4:4:1:Shield::1:0:", -- Malistar's Defender
	[17107]="0:4:4:1:Cloak::1:0:", -- Dragon's Blood Cape
	[17109]="0:4:4:1:Amulet::1:0:", -- Choker of Enlightenment
	[17110]="0:4:4:1:Ring::1:0:", -- Seal of the Archmagus
	[17111]="0:4:4:1:Amulet::1:0:", -- Blazefury Medallion
	[17112]="0:2:4:1:OneHandMace::1:0:", -- Empyrean Demolisher
	[17113]="0:2:4:1:Stave::1:0:", -- Amberseal Keeper
	[17114]="0:12:1:1:::1:0:", -- Araj's Phylactery Shard
	[17117]="0:12:1:1:::1:0:", -- Rat Catcher's Flute
	[17118]="0:12:1:1:::1:0:", -- Carton of Mystery Meat
	[17119]="125:0:1:20:FoodDrink::5:0:13018", -- Deeprun Rat Kabob
	[17124]="0:12:1:100:::1:0:", -- Syndicate Emblem
	[17125]="0:12:1:1:::1:0:", -- Seal of Ravenholdt
	[17126]="0:12:1:1:::1:0:", -- Elegant Letter
	[17182]="160402:2:5:1:TwoHandMace::1:0:", -- Sulfuras, Hand of Ragnaros
	[17183]="36:4:1:1:Shield::1:0:2116,3075,3161,4559,16693", -- Dented Buckler
	[17184]="36:4:1:1:Shield::1:0:1104,1213,3592,4240,16762,16917", -- Small Shield
	[17185]="260:4:1:1:Shield::1:0:2135,3080,3167,3319,4559,16258,16693", -- Round Buckler
	[17186]="260:4:1:1:Shield::1:0:1249,2046,3613,4240,5106,16762,17930", -- Small Targe
	[17187]="1161:4:1:1:Shield::1:0:3319,3528,3529,4187,4559,4560,5107,8360,16693,16762", -- Banded Buckler
	[17188]="2447:4:1:1:Shield::1:0:793,1319,3319,3493,4240,5126,8360,16693,16762", -- Ringed Buckler
	[17189]="13054:4:1:1:Shield::1:0:1319,1322,1323,1349,1381,2845,3095,4177,4240,5125,5126,5812,5819,8129", -- Metal Buckler
	[17190]="37647:4:1:1:Shield::1:0:980,1319,1323,1349,3095,4177,4240,5126,5508,5812,5819,8129,11182,16626,16753,25274,27067", -- Ornate Buckler
	[17191]="0:2:3:1:Stave::1:0:", -- Scepter of Celebras
	[17192]="4820:4:1:1:Shield::1:0:226,1319,1323,1349,1450,3095,4240,4886,5126,5812,5819,6028,16693,16762,31027", -- Reinforced Targe
	[17193]="0:2:4:1:TwoHandMace::1:0:", -- Sulfuron Hammer
	[17194]="10:15:1:20:Holiday:185:5:0:13420,13429,13432,13433,13435,23010,23012,23064", -- Holiday Spices
	[17195]="0:15:1:20:Junk::1:0:", -- Fake Mistletoe
	[17196]="50:0:1:20:FoodDrink:185:1:0:13420,13429,13432,13433,13435,23010,23012,23064", -- Holiday Spirits
	[17197]="0:0:1:20:FoodDrink::1:0:", -- Gingerbread Cookie
	[17198]="0:0:1:20:FoodDrink::1:0:", -- Egg Nog
	[17200]="25:9:1:1:Cooking::1:0:13420,13429,13432,13433,13435,23010,23012,23064", -- Recipe: Gingerbread Cookie
	[17201]="240:9:1:1:Cooking::1:0:13420,13429,13432,13433,13435,23010,23012,23064", -- Recipe: Egg Nog
	[17202]="10:15:1:20:Holiday:202:5:0:13420,13429,13432,13433,13435,23010,23012,23064", -- Snowball
	[17203]="0:7:4:20:MetalStone:164:1:0:", -- Sulfuron Ingot
	[17204]="0:7:5:1:Other::1:0:", -- Eye of Sulfuras
	[17222]="0:0:1:20:FoodDrink::1:0:", -- Spider Sausage
	[17223]="0:2:4:1:Polearm::1:0:", -- Thunderstrike
	[17224]="0:12:2:1:::1:0:", -- Scrying Scope
	[17242]="0:13:1:1:::1:0:", -- Key to Salem's Chest
	[17262]="0:13:1:1:::1:0:", -- James' Key
	[17302]="0:0:1:1:Other::1:0:", -- Blue Ribboned Holiday Gift
	[17303]="10:0:1:10:Other::1:0:13420,13429,13432,13433,13435,23010,23012,23064", -- Blue Ribboned Wrapping Paper
	[17304]="10:0:1:10:Other::1:0:13420,13429,13432,13433,13435,23010,23012,23064", -- Green Ribboned Wrapping Paper
	[17305]="0:0:1:1:Other::1:0:", -- Green Ribboned Holiday Gift
	[17306]="0:12:1:100:::1:0:", -- Stormpike Soldier's Blood
	[17307]="10:0:1:10:Other::1:0:13420,13429,13432,13433,13435,23010,23012,23064", -- Purple Ribboned Wrapping Paper
	[17308]="0:0:1:1:Other::1:0:", -- Purple Ribboned Holiday Gift
	[17309]="0:12:1:20:::1:0:", -- Discordant Bracers
	[17310]="0:12:1:1:::1:0:", -- Aspect of Neptulon
	[17322]="0:12:1:1:::1:0:", -- Eye of the Emberseer
	[17326]="0:12:1:100:::1:0:", -- Stormpike Soldier's Flesh
	[17327]="0:12:1:100:::1:0:", -- Stormpike Lieutenant's Flesh
	[17328]="0:12:1:100:::1:0:", -- Stormpike Commander's Flesh
	[17329]="0:12:1:1:::1:0:", -- Hand of Lucifron
	[17330]="0:12:1:1:::1:0:", -- Hand of Sulfuron
	[17331]="0:12:1:1:::1:0:", -- Hand of Gehennas
	[17332]="0:12:1:1:::1:0:", -- Hand of Shazzrah
	[17333]="0:12:1:1:::1:0:", -- Aqual Quintessence
	[17344]="25:0:1:20:FoodDrink::5:0:13420,13429,13432,13433,13435,23010,23012,23064", -- Candy Cane
	[17345]="0:12:1:20:::1:0:", -- Silithid Goo
	[17346]="0:12:1:1:::1:0:", -- Encrusted Silithid Object
	[17348]="1000:0:1:20:Potion::1:0:13216,13217,13218,13219,14753,14754", -- Major Healing Draught
	[17349]="500:0:1:20:Potion::1:0:13216,13217,13218,13219,14753,14754,15126,15127", -- Superior Healing Draught
	[17351]="1000:0:1:20:Potion::1:0:13216,13217,13218,13219,14753,14754", -- Major Mana Draught
	[17352]="500:0:1:20:Potion::1:0:13216,13217,13218,13219,14753,14754,15126,15127", -- Superior Mana Draught
	[17355]="0:12:1:1:::1:0:", -- Rabine's Letter
	[17364]="0:12:2:1:::1:0:", -- Scrying Scope
	[17384]="0:12:3:1:::1:0:", -- Zinfizzlex's Portable Shredder Unit
	[17402]="2000:0:1:20:FoodDrink::1:0:13418,13430,13431,13434,13436,23009,23011,23065", -- Greatfather's Winter Ale
	[17403]="150:0:1:20:FoodDrink::1:0:13418,13430,13431,13434,13436,23009,23011,23065", -- Steamwheedle Fizzy Spirits
	[17404]="125:0:1:20:FoodDrink::5:0:13418,13430,13431,13434,13436,23009,23011,23065", -- Blended Bean Brew
	[17405]="1000:15:1:20:Holiday::5:0:13418,13430,13431,13434,13436,23009,23011,23065", -- Green Garden Tea
	[17406]="125:0:1:20:FoodDrink::5:0:13418,13430,13431,13434,13436,23009,23011,23065", -- Holiday Cheesewheel
	[17407]="1000:0:1:20:FoodDrink::5:0:13418,13430,13431,13434,13436,23009,23011,23065", -- Graccu's Homemade Meat Pie
	[17408]="2000:0:1:20:FoodDrink::5:0:13418,13430,13431,13434,13436,23009,23011,23065", -- Spicy Beefstick
	[17410]="0:15:3:1:CombatPet::1:0:", -- Zinfizzlex's Portable Shredder Unit
	[17411]="0:12:1:1:::1:0:", -- Steamsaw
	[17413]="0:9:3:1:Book::1:0:", -- Codex: Prayer of Fortitude
	[17414]="0:9:3:1:Book::1:0:", -- Codex: Prayer of Fortitude II
	[17422]="0:12:1:100:::1:0:", -- Armor Scraps
	[17423]="0:12:1:100:::1:0:", -- Storm Crystal
	[17442]="0:12:1:1:::1:0:", -- Frostwolf Assault Orders
	[17502]="0:12:1:100:::1:0:", -- Frostwolf Soldier's Medal
	[17503]="0:12:1:100:::1:0:", -- Frostwolf Lieutenant's Medal
	[17504]="0:12:1:100:::1:0:", -- Frostwolf Commander's Medal
	[17508]="0:4:2:1:Shield::1:0:", -- Forcestone Buckler
	[17522]="0:12:1:20:::1:0:", -- Irondeep Supplies
	[17523]="0:4:2:1:Cloak::1:0:", -- Smokey's Drape
	[17542]="0:12:1:20:::1:0:", -- Coldtooth Supplies
	[17562]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Dreadweave Boots
	[17564]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Dreadweave Gloves
	[17566]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Headguard
	[17567]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Dreadweave Leggings
	[17568]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Dreadweave Robe
	[17569]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Dreadweave Mantle
	[17570]="0:4:3:1:Cloth::1:0:", -- Champion's Dreadweave Hood
	[17571]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Dreadweave Leggings
	[17572]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Dreadweave Robe
	[17573]="0:4:3:1:Cloth::1:0:", -- Champion's Dreadweave Shoulders
	[17576]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Dreadweave Boots
	[17577]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Dreadweave Gloves
	[17578]="0:4:4:1:Cloth::1:0:", -- Field Marshal's Coronal
	[17579]="0:4:4:1:Cloth::1:0:", -- Marshal's Dreadweave Leggings
	[17580]="0:4:4:1:Cloth::1:0:", -- Field Marshal's Dreadweave Shoulders
	[17581]="0:4:4:1:Cloth::1:0:", -- Field Marshal's Dreadweave Robe
	[17583]="0:4:4:1:Cloth::1:0:", -- Marshal's Dreadweave Boots
	[17584]="0:4:4:1:Cloth::1:0:", -- Marshal's Dreadweave Gloves
	[17586]="0:4:4:1:Cloth::1:0:", -- General's Dreadweave Boots
	[17588]="0:4:4:1:Cloth::1:0:", -- General's Dreadweave Gloves
	[17590]="0:4:4:1:Cloth::1:0:", -- Warlord's Dreadweave Mantle
	[17591]="0:4:4:1:Cloth::1:0:", -- Warlord's Dreadweave Hood
	[17592]="0:4:4:1:Cloth::1:0:", -- Warlord's Dreadweave Robe
	[17593]="0:4:4:1:Cloth::1:0:", -- General's Dreadweave Pants
	[17594]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Satin Boots
	[17596]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Satin Gloves
	[17598]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Diadem
	[17599]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Satin Leggings
	[17600]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Satin Robes
	[17601]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Satin Amice
	[17602]="0:4:4:1:Cloth::1:0:", -- Field Marshal's Headdress
	[17603]="0:4:4:1:Cloth::1:0:", -- Marshal's Satin Pants
	[17604]="0:4:4:1:Cloth::1:0:", -- Field Marshal's Satin Mantle
	[17605]="0:4:4:1:Cloth::1:0:", -- Field Marshal's Satin Vestments
	[17607]="0:4:4:1:Cloth::1:0:", -- Marshal's Satin Sandals
	[17608]="0:4:4:1:Cloth::1:0:", -- Marshal's Satin Gloves
	[17610]="0:4:3:1:Cloth::1:0:", -- Champion's Satin Cowl
	[17611]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Satin Trousers
	[17612]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Satin Vestments
	[17613]="0:4:3:1:Cloth::1:0:", -- Champion's Satin Shoulderpads
	[17616]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Satin Boots
	[17617]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Satin Gloves
	[17618]="0:4:4:1:Cloth::1:0:", -- General's Satin Boots
	[17620]="0:4:4:1:Cloth::1:0:", -- General's Satin Gloves
	[17622]="0:4:4:1:Cloth::1:0:", -- Warlord's Satin Mantle
	[17623]="0:4:4:1:Cloth::1:0:", -- Warlord's Satin Cowl
	[17624]="0:4:4:1:Cloth::1:0:", -- Warlord's Satin Robes
	[17625]="0:4:4:1:Cloth::1:0:", -- General's Satin Leggings
	[17626]="0:12:1:1:::1:0:", -- Frostwolf Muzzle
	[17642]="0:12:1:100:::1:0:", -- Alterac Ram Hide
	[17643]="0:12:1:100:::1:0:", -- Frostwolf Hide
	[17662]="0:12:1:1:::1:0:", -- Stolen Treats
	[17682]="0:9:3:1:Book::1:0:", -- Book: Gift of the Wild
	[17683]="0:9:3:1:Book::1:0:", -- Book: Gift of the Wild II
	[17684]="0:12:1:30:::1:0:", -- Theradric Crystal Carving
	[17685]="0:15:1:1:Junk::1:0:", -- Smokywood Pastures Sampler
	[17686]="0:2:2:1:Bow::1:0:", -- Master Hunter's Bow
	[17687]="0:2:2:1:Gun::1:0:", -- Master Hunter's Rifle
	[17688]="0:4:2:1:Plate::1:0:", -- Jungle Boots
	[17689]="0:12:1:1:::1:0:", -- Stormpike Training Collar
	[17690]="0:4:2:1:Trinket::1:0:", -- Frostwolf Insignia Rank 1
	[17691]="0:4:2:1:Trinket::1:0:", -- Stormpike Insignia Rank 1
	[17692]="0:4:2:1:Ring::1:0:", -- Horn Ring
	[17693]="0:12:1:1:::1:0:", -- Coated Cerulean Vial
	[17694]="0:4:2:1:Ring::1:0:", -- Band of the Fist
	[17695]="0:4:2:1:Cloth::1:0:", -- Chestnut Mantle
	[17696]="0:12:1:1:::1:0:", -- Filled Cerulean Vial
	[17702]="0:12:1:1:::1:0:", -- Celebrian Rod
	[17703]="0:12:1:1:::1:0:", -- Celebrian Diamond
	[17704]="0:2:2:1:OneHandAxe::1:0:", -- Edge of Winter
	[17705]="0:2:3:1:OneHandSword::1:0:", -- Thrash Blade
	[17706]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Edge of Winter
	[17707]="0:4:3:1:Amulet::1:0:", -- Gemshard Heart
	[17708]="0:0:1:20:Elixir::1:0:", -- Elixir of Frost Power
	[17709]="0:9:1:1:Alchemy::1:0:", -- Recipe: Elixir of Frost Power
	[17710]="0:2:3:1:Dagger::1:0:", -- Charstone Dirk
	[17711]="0:4:3:1:Plate::1:0:", -- Elemental Rockridge Leggings
	[17712]="0:15:1:1:Junk::1:0:", -- Winter Veil Disguise Kit
	[17713]="0:4:3:1:Ring::1:0:", -- Blackstone Ring
	[17714]="0:4:3:1:Mail::1:0:", -- Bracers of the Stone Princess
	[17715]="0:4:3:1:Cloth::1:0:", -- Eye of Theradras
	[17716]="0:7:1:1:Device::1:0:", -- Snowmaster 9000
	[17717]="0:2:3:1:Gun::1:0:", -- Megashot Rifle
	[17718]="0:4:3:1:Shield::1:0:", -- Gizlock's Hypertech Buckler
	[17719]="0:2:3:1:OneHandSword::1:0:", -- Inventor's Focal Sword
	[17720]="0:9:2:1:Engineering::1:0:", -- Schematic: Snowmaster 9000
	[17721]="0:4:2:1:Leather::1:0:", -- Gloves of the Greatfather
	[17722]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Gloves of the Greatfather
	[17723]="0:4:1:1:Shirt::1:0:", -- Green Holiday Shirt
	[17724]="0:9:1:1:Tailoring::1:0:", -- Pattern: Green Holiday Shirt
	[17725]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Winter's Might
	[17726]="0:15:1:1:Junk::1:0:", -- Smokywood Pastures Special Gift
	[17727]="0:15:1:1:Junk::1:0:", -- Smokywood Pastures Gift Pack
	[17728]="0:4:3:1:Leather::1:0:", -- Albino Crocscale Boots
	[17730]="0:2:3:1:TwoHandAxe::1:0:", -- Gatorbite Axe
	[17732]="0:4:3:1:Cloth::1:0:", -- Rotgrip Mantle
	[17733]="0:2:3:1:OneHandMace::1:0:", -- Fist of Stone
	[17734]="0:4:3:1:Plate::1:0:", -- Helm of the Mountain
	[17735]="0:15:1:1:Junk::1:0:", -- The Feast of Winter Veil
	[17736]="0:4:3:1:Mail::1:0:", -- Rockgrip Gauntlets
	[17737]="0:4:3:1:OffHandFrill::1:0:", -- Cloud Stone
	[17738]="0:2:3:1:FistWeapon::1:0:", -- Claw of Celebras
	[17739]="0:4:3:1:Cloak::1:0:", -- Grovekeeper's Drape
	[17740]="0:4:3:1:Leather::1:0:", -- Soothsayer's Headdress
	[17741]="0:4:3:1:Cloth::1:0:", -- Nature's Embrace
	[17742]="0:4:3:1:Leather::1:0:", -- Fungus Shroud Armor
	[17743]="0:2:3:1:Stave::1:0:", -- Resurgence Rod
	[17744]="0:4:3:1:Trinket::1:0:", -- Heart of Noxxion
	[17745]="0:2:3:1:Wand::1:0:", -- Noxious Shooter
	[17746]="0:4:3:1:Plate::1:0:", -- Noxxion's Shackles
	[17747]="0:0:1:5:Other::1:0:", -- Razorlash Root
	[17748]="0:4:3:1:Cloth::1:0:", -- Vinerot Sandals
	[17749]="0:4:3:1:Leather::1:0:", -- Phytoskin Spaulders
	[17750]="0:4:3:1:Cloth::1:0:", -- Chloromesh Girdle
	[17751]="0:4:3:1:Leather::1:0:", -- Brusslehide Leggings
	[17752]="0:2:3:1:Dagger::1:0:", -- Satyr's Lash
	[17753]="0:2:3:1:Bow::1:0:", -- Verdant Keeper's Aim
	[17754]="0:4:3:1:Mail::1:0:", -- Infernal Trickster Leggings
	[17755]="0:4:3:1:Cloth::1:0:", -- Satyrmane Sash
	[17756]="0:12:1:20:::1:0:", -- Shadowshard Fragment
	[17757]="0:12:1:1:::1:0:", -- Amulet of Spirits
	[17758]="0:12:1:1:::1:0:", -- Amulet of Union
	[17759]="0:4:3:1:Trinket::1:0:", -- Mark of Resolution
	[17760]="0:12:1:1:::1:0:", -- Seed of Life
	[17761]="0:12:1:1:::1:0:", -- Gem of the First Khan
	[17762]="0:12:1:1:::1:0:", -- Gem of the Second Khan
	[17763]="0:12:1:1:::1:0:", -- Gem of the Third Khan
	[17764]="0:12:1:1:::1:0:", -- Gem of the Fourth Khan
	[17765]="0:12:1:1:::1:0:", -- Gem of the Fifth Khan
	[17766]="0:2:3:1:TwoHandMace::1:0:", -- Princess Theradras' Scepter
	[17767]="0:4:3:1:Mail::1:0:", -- Bloomsprout Headpiece
	[17768]="0:4:2:1:Ring::1:0:", -- Woodseed Hoop
	[17770]="0:4:2:1:Plate::1:0:", -- Branchclaw Gauntlets
	[17771]="0:7:5:20:MetalStone::1:0:", -- Elementium Bar
	[17772]="0:4:2:1:Amulet::1:0:", -- Zealous Shadowshard Pendant
	[17773]="0:4:2:1:Amulet::1:0:", -- Prodigious Shadowshard Pendant
	[17774]="0:4:2:1:Trinket::1:0:", -- Mark of the Chosen
	[17775]="0:4:2:1:Cloth::1:0:", -- Acumen Robes
	[17776]="0:4:2:1:Leather::1:0:", -- Sprightring Helm
	[17777]="0:4:2:1:Mail::1:0:", -- Relentless Chain
	[17778]="0:4:2:1:Leather::1:0:", -- Sagebrush Girdle
	[17779]="0:4:2:1:Plate::1:0:", -- Hulkstone Pauldrons
	[17780]="0:2:4:1:Dagger::1:0:", -- Blade of Eternal Darkness
	[17781]="0:12:1:1:::1:0:", -- The Pariah's Instructions
	[17782]="0:4:5:1:Amulet::1:0:", -- Talisman of Binding Shard
	[17822]="0:12:1:1:::1:0:", -- Frostwolf Maps
	[17823]="0:12:1:1:::1:0:", -- Stormpike Battle Plans
	[17849]="0:12:1:1:::1:0:", -- Stormpike Banner
	[17850]="0:12:1:1:::1:0:", -- Frostwolf Banner
	[17900]="0:4:2:1:Trinket::1:0:", -- Stormpike Insignia Rank 2
	[17901]="0:4:2:1:Trinket::1:0:", -- Stormpike Insignia Rank 3
	[17902]="0:4:3:1:Trinket::1:0:", -- Stormpike Insignia Rank 4
	[17903]="0:4:3:1:Trinket::1:0:", -- Stormpike Insignia Rank 5
	[17904]="0:4:4:1:Trinket::1:0:", -- Stormpike Insignia Rank 6
	[17905]="0:4:2:1:Trinket::1:0:", -- Frostwolf Insignia Rank 2
	[17906]="0:4:2:1:Trinket::1:0:", -- Frostwolf Insignia Rank 3
	[17907]="0:4:3:1:Trinket::1:0:", -- Frostwolf Insignia Rank 4
	[17908]="0:4:3:1:Trinket::1:0:", -- Frostwolf Insignia Rank 5
	[17909]="0:4:4:1:Trinket::1:0:", -- Frostwolf Insignia Rank 6
	[17922]="0:4:2:1:Leather::1:0:", -- Lionfur Armor
	[17943]="0:2:3:1:OneHandMace::1:0:", -- Fist of Stone
	[17962]="0:15:4:1:Junk::1:0:", -- Blue Sack of Gems
	[17963]="0:15:2:1:Junk::1:0:", -- Green Sack of Gems
	[17964]="0:15:2:1:Junk::1:0:", -- Gray Sack of Gems
	[17965]="0:15:2:1:Junk::1:0:", -- Yellow Sack of Gems
	[17966]="0:1:2:1:Bag::1:0:", -- Onyxia Hide Backpack
	[17967]="0:7:3:20:Leather::1:0:", -- Refined Scale of Onyxia
	[17968]="0:7:3:20:Other::1:0:", -- Charged Scale of Onyxia
	[17969]="0:15:2:1:Junk::1:0:", -- Red Sack of Gems
	[17982]="0:4:3:1:Ring::1:0:", -- Ragnaros Core
	[18022]="0:4:3:1:Ring::1:0:", -- Royal Seal of Alexis
	[18042]="0:6:2:1000:Arrow::1:0:", -- Thorium Headed Arrow
	[18043]="0:4:3:1:Leather::1:0:", -- Coal Miner Boots
	[18044]="0:2:3:1:OneHandMace::1:0:", -- Hurley's Tankard
	[18045]="0:0:1:20:FoodDrink::1:0:", -- Tender Wolf Steak
	[18046]="12000:9:1:1:Cooking::1:0:4782,7733,8125", -- Recipe: Tender Wolf Steak
	[18047]="0:4:3:1:Mail::1:0:", -- Flame Walkers
	[18048]="0:2:3:1:OneHandMace::1:0:", -- Mastersmith's Hammer
	[18082]="0:2:3:1:Stave::1:0:", -- Zum'rah's Vexing Cane
	[18083]="0:4:3:1:Cloth::1:0:", -- Jumanza Grips
	[18102]="0:4:3:1:Cloth::1:0:", -- Dragonrider Boots
	[18103]="0:4:3:1:Ring::1:0:", -- Band of Rumination
	[18104]="0:4:3:1:Mail::1:0:", -- Feralsurge Girdle
	[18142]="0:12:1:100:::1:0:", -- Severed Night Elf Head
	[18143]="0:12:1:100:::1:0:", -- Tuft of Gnome Hair
	[18144]="0:12:1:100:::1:0:", -- Human Bone Chip
	[18145]="0:12:1:100:::1:0:", -- Tauren Hoof
	[18146]="0:12:1:100:::1:0:", -- Darkspear Troll Mojo
	[18147]="0:12:1:100:::1:0:", -- Forsaken Heart
	[18148]="0:12:1:1:::1:0:", -- Skull of Korrak
	[18149]="0:12:2:1:::1:0:", -- Rune of Recall
	[18150]="0:12:2:1:::1:0:", -- Rune of Recall
	[18151]="0:12:1:1:::1:0:", -- Filled Amethyst Phial
	[18152]="0:12:1:1:::1:0:", -- Amethyst Phial
	[18154]="0:0:1:1:Other::1:0:", -- Blizzard Stationery
	[18160]="200:9:2:1:Cooking::1:0:6779", -- Recipe: Thistle Tea
	[18168]="0:4:4:1:Shield::1:0:", -- Force Reactive Disk
	[18169]="100000:0:2:1:EnhPerm::1:0:10856,10857,11536", -- Flame Mantle of the Dawn
	[18170]="100000:0:2:1:EnhPerm::1:0:10856,10857,11536", -- Frost Mantle of the Dawn
	[18171]="100000:0:2:1:EnhPerm::1:0:10856,10857,11536", -- Arcane Mantle of the Dawn
	[18172]="100000:0:2:1:EnhPerm::1:0:10856,10857,11536", -- Nature Mantle of the Dawn
	[18173]="100000:0:2:1:EnhPerm::1:0:10856,10857,11536", -- Shadow Mantle of the Dawn
	[18182]="400000:0:2:1:EnhPerm::1:0:10856,10857,11536", -- Chromatic Mantle of the Dawn
	[18202]="0:2:4:1:FistWeapon::1:0:", -- Eskhandar's Left Claw
	[18203]="0:2:4:1:FistWeapon::1:0:", -- Eskhandar's Right Claw
	[18204]="0:4:4:1:Cloak::1:0:", -- Eskhandar's Pelt
	[18205]="0:4:4:1:Amulet::1:0:", -- Eskhandar's Collar
	[18206]="0:12:1:100:::1:0:", -- Dwarf Spine
	[18207]="0:12:1:100:::1:0:", -- Orc Tooth
	[18208]="0:4:4:1:Cloak::1:0:", -- Drape of Benediction
	[18222]="0:15:0:20:Junk::1:0:", -- Thorny Vine
	[18223]="0:15:0:20:Junk::1:0:", -- Serrated Petal
	[18224]="0:15:0:40:Junk::1:0:", -- Lasher Root
	[18225]="0:15:0:5:Junk::1:0:", -- Worn Running Shoes
	[18226]="0:15:0:5:Junk::1:0:", -- A Sealed Pact
	[18227]="0:15:0:5:Junk::1:0:", -- Nubless Pacifier
	[18228]="0:15:0:1:Junk::1:0:", -- Autographed Picture of Foror & Tigule
	[18229]="0:15:0:1:Junk::1:0:", -- Nat Pagle's Guide to Extreme Anglin'
	[18230]="0:15:0:5:Junk::1:0:", -- Broken I.W.I.N. Button
	[18231]="0:4:0:1:Shirt::1:0:", -- Sleeveless T-Shirt
	[18232]="0:15:1:5:CombatPet:202:1:0:", -- Field Repair Bot 74A
	[18233]="0:15:0:5:Junk::1:0:", -- Tear Stained Handkerchief
	[18234]="0:15:0:5:Junk::1:0:", -- Document from Boomstick Imports
	[18236]="0:15:0:20:Junk::1:0:", -- Gordok Chew Toy
	[18237]="0:15:0:20:Junk::1:0:", -- Mastiff Jawbone
	[18238]="0:4:3:1:Leather::1:0:", -- Shadowskin Gloves
	[18239]="3500:9:1:1:Leatherworking::1:1:2699", -- Pattern: Shadowskin Gloves
	[18240]="0:7:2:20:Other:165,197:1:0:", -- Ogre Tannin
	[18249]="0:13:1:1:::1:0:", -- Crescent Key
	[18250]="0:13:2:1:::1:0:", -- Gordok Shackle Key
	[18251]="0:0:3:10:EnhPerm::1:0:", -- Core Armor Kit
	[18252]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Core Armor Kit
	[18253]="0:0:1:20:Potion::1:0:", -- Major Rejuvenation Potion
	[18254]="0:0:1:20:FoodDrink::1:0:", -- Runn Tum Tuber Surprise
	[18255]="0:0:1:20:FoodDrink:185:1:0:", -- Runn Tum Tuber
	[18256]="20000:7:1:20:Other:171,333:5:0:844,958,983,989,1148,1257,1286,1313,1453,2225,2380,2480,2481,2810,2812,2821,2848,3010,3014,3348,3367,3405,3548,3779,3954,3955,3956,4216,4226,4229,4561,4610,4615,4775,4897,4899,5135,5138,5163,5178,5503,5594,5817,6301,7947,8145,8157,8158,8177,8178,8305,8363,8934,11188,11189,12022,12028,12245,12941,12957,12958,15179,16367,16588,16602,16612,16613,16641,16705,16706,16768,16826,16829,17486,18005,18009,18015,18802,18907,18960,19015,19017,19042,19074,19194,19197,19244,19345,19372,19450,19497,19533,19562,19573,19837,20081,20092,20194,20250,20891,20989,21083,21113,22099,22271,23802,24054,24147,24188,24341,24356,24780,24975,25034,26374,26474,26568,26720,26939,26941,27012,27021,27026,27031,27038,27043,27053,27057,27063,27070,27132,27140,27141,27146,27184,27195,27938,28692,28725,28727,28794,28806,28828,28829,28831,28866,28868,28872,29208,29270,29277,29535,29909,30311,30345,30438,30825,31115,32477,32639,32641,33600,33630,33639,33669,33674,33678,37904,37935", -- Imbued Vial
	[18257]="0:9:3:1:Alchemy::1:0:", -- Recipe: Major Rejuvenation Potion
	[18258]="0:12:2:1:::1:0:", -- Gordok Ogre Suit
	[18259]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Spellpower
	[18260]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Healing Power
	[18261]="0:12:1:1:::1:0:", -- Book of Incantations
	[18262]="0:0:2:20:EnhTemp::1:0:", -- Elemental Sharpening Stone
	[18263]="0:4:4:1:Cloth::1:0:", -- Flarecore Wraps
	[18264]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Elemental Sharpening Stone
	[18265]="0:9:3:1:Tailoring::1:0:", -- Pattern: Flarecore Wraps
	[18266]="0:13:1:1:::1:0:", -- Gordok Courtyard Key
	[18267]="0:9:2:1:Cooking::1:0:", -- Recipe: Runn Tum Tuber Surprise
	[18268]="0:13:1:1:::1:0:", -- Gordok Inner Door Key
	[18269]="1500:0:2:10:Consumable::1:0:14322", -- Gordok Green Grog
	[18282]="0:2:4:1:Gun::1:0:", -- Core Marksman Rifle
	[18283]="0:0:3:5:EnhPerm::1:0:", -- Biznicks 247x128 Accurascope
	[18284]="1500:0:2:10:Consumable::1:0:14322", -- Kreeg's Stout Beatdown
	[18285]="0:15:0:20:Junk::1:0:", -- Crystallized Mana Shard
	[18286]="0:15:0:20:Junk::1:0:", -- Condensed Mana Fragment
	[18287]="200:0:1:20:FoodDrink::1:0:14322", -- Evermurky
	[18288]="1000:0:1:20:FoodDrink::1:0:14322", -- Molasses Firewater
	[18289]="0:4:3:1:Amulet::1:0:", -- Barbed Thorn Necklace
	[18290]="0:9:3:1:Engineering::1:0:", -- Schematic: Biznicks 247x128 Accurascope
	[18291]="0:9:3:1:Engineering::1:0:", -- Schematic: Force Reactive Disk
	[18292]="0:9:3:1:Engineering::1:0:", -- Schematic: Core Marksman Rifle
	[18294]="0:0:1:20:Elixir::1:0:", -- Elixir of Greater Water Breathing
	[18295]="0:4:3:1:Cloth::1:0:", -- Phasing Boots
	[18296]="0:4:3:1:Mail::1:0:", -- Marksman Bands
	[18297]="0:15:1:5:CombatPet::1:0:", -- Thornling Seed
	[18298]="0:4:3:1:Leather::1:0:", -- Unbridled Leggings
	[18299]="0:12:1:1:::1:0:", -- Hydrospawn Essence
	[18300]="0:0:1:20:FoodDrink::1:0:", -- Hyjal Nectar
	[18301]="0:2:2:1:Wand::1:0:", -- Lethtendris's Wand
	[18302]="0:4:2:1:Ring::1:0:", -- Band of Vigor
	[18305]="0:4:2:1:Plate::1:0:", -- Breakwater Legguards
	[18306]="0:4:2:1:Cloth::1:0:", -- Gloves of Shadowy Mist
	[18307]="0:4:2:1:Cloth::1:0:", -- Riptide Shoes
	[18308]="0:4:2:1:Leather::1:0:", -- Clever Hat
	[18309]="0:4:3:1:Leather::1:0:", -- Gloves of Restoration
	[18310]="0:2:3:1:OneHandSword::1:0:", -- Fiendish Machete
	[18311]="0:2:3:1:Stave::1:0:", -- Quel'dorei Channeling Rod
	[18312]="0:4:3:1:Plate::1:0:", -- Energized Chestplate
	[18313]="0:4:3:1:Plate::1:0:", -- Helm of Awareness
	[18314]="0:4:3:1:Ring::1:0:", -- Ring of Demonic Guile
	[18315]="0:4:3:1:Ring::1:0:", -- Ring of Demonic Potency
	[18317]="0:4:3:1:Amulet::1:0:", -- Tempest Talisman
	[18318]="0:4:3:1:Mail::1:0:", -- Merciful Greaves
	[18319]="0:4:3:1:Mail::1:0:", -- Fervent Helm
	[18321]="0:2:3:1:OneHandMace::1:0:", -- Energetic Rod
	[18322]="0:4:3:1:Leather::1:0:", -- Waterspout Boots
	[18323]="0:2:3:1:Bow::1:0:", -- Satyr's Bow
	[18324]="0:2:3:1:TwoHandAxe::1:0:", -- Waveslicer
	[18325]="0:4:3:1:Leather::1:0:", -- Felhide Cap
	[18326]="0:4:3:1:Plate::1:0:", -- Razor Gauntlets
	[18327]="0:4:3:1:Cloth::1:0:", -- Whipvine Cord
	[18328]="0:4:3:1:Cloak::1:0:", -- Shadewood Cloak
	[18329]="0:0:2:1:EnhPerm::1:0:", -- Arcanum of Rapidity
	[18330]="0:0:2:1:EnhPerm::1:0:", -- Arcanum of Focus
	[18331]="0:0:2:1:EnhPerm::1:0:", -- Arcanum of Protection
	[18332]="0:9:2:1:Book::1:0:", -- Libram of Rapidity
	[18333]="0:9:2:1:Book::1:0:", -- Libram of Focus
	[18334]="0:9:2:1:Book::1:0:", -- Libram of Protection
	[18335]="0:12:3:20::755:1:0:", -- Pristine Black Diamond
	[18336]="0:12:1:1:::1:0:", -- Gauntlet of Gordok Might
	[18337]="0:4:2:1:Cloth::1:0:", -- Orphic Bracers
	[18338]="0:2:3:1:Wand::1:0:", -- Wand of Arcane Potency
	[18339]="0:4:2:1:Cloak::1:0:", -- Eidolon Cloak
	[18340]="0:4:3:1:Amulet::1:0:", -- Eidolon Talisman
	[18343]="0:4:2:1:Ring::1:0:", -- Petrified Band
	[18344]="0:4:3:1:Leather::1:0:", -- Stonebark Gauntlets
	[18345]="0:4:2:1:Ring::1:0:", -- Murmuring Ring
	[18346]="0:4:2:1:Cloth::1:0:", -- Threadbare Trousers
	[18347]="0:2:2:1:OneHandAxe::1:0:", -- Well Balanced Axe
	[18348]="0:2:4:1:OneHandSword::1:0:", -- Quel'Serrar
	[18349]="0:4:2:1:Mail::1:0:", -- Gauntlets of Accuracy
	[18350]="0:4:2:1:Cloak::1:0:", -- Amplifying Cloak
	[18351]="0:4:2:1:Plate::1:0:", -- Magically Sealed Bracers
	[18352]="0:4:2:1:Shield::1:0:", -- Petrified Bark Shield
	[18353]="0:2:2:1:Stave::1:0:", -- Stoneflower Staff
	[18354]="0:4:3:1:Trinket::1:0:", -- Pimgib's Collar
	[18356]="0:12:3:1:::1:0:", -- Garona: A Study on Stealth and Treachery
	[18357]="0:12:3:1:::1:0:", -- Codex of Defense
	[18358]="0:12:3:1:::1:0:", -- The Arcanist's Cookbook
	[18359]="0:12:3:1:::1:0:", -- The Light and How to Swing It
	[18360]="0:12:3:1:::1:0:", -- Harnessing Shadows
	[18361]="0:12:3:1:::1:0:", -- The Greatest Race of Hunters
	[18362]="0:12:3:1:::1:0:", -- Holy Bologna: What the Light Won't Tell You
	[18363]="0:12:3:1:::1:0:", -- Frost Shock and You
	[18364]="0:12:3:1:::1:0:", -- The Emerald Dream
	[18365]="0:15:0:1:Junk::1:0:", -- A Thoroughly Read Copy of "Nat Pagle's Extreme' Anglin."
	[18366]="0:4:3:1:Plate::1:0:", -- Gordok's Handguards
	[18367]="0:4:3:1:Mail::1:0:", -- Gordok's Gauntlets
	[18368]="0:4:3:1:Leather::1:0:", -- Gordok's Gloves
	[18369]="0:4:3:1:Cloth::1:0:", -- Gordok's Handwraps
	[18370]="0:4:3:1:Trinket::1:0:", -- Vigilance Charm
	[18371]="0:4:3:1:Trinket::1:0:", -- Mindtap Talisman
	[18372]="0:2:3:1:Dagger::1:0:", -- Blade of the New Moon
	[18373]="0:4:3:1:Leather::1:0:", -- Chestplate of Tranquility
	[18374]="0:4:3:1:Leather::1:0:", -- Flamescarred Shoulders
	[18375]="0:4:3:1:Leather::1:0:", -- Bracers of the Eclipse
	[18376]="0:2:3:1:OneHandMace::1:0:", -- Timeworn Mace
	[18377]="0:4:3:1:Leather::1:0:", -- Quickdraw Gloves
	[18378]="0:4:3:1:Mail::1:0:", -- Silvermoon Leggings
	[18379]="0:4:3:1:Mail::1:0:", -- Odious Greaves
	[18380]="0:4:3:1:Plate::1:0:", -- Eldritch Reinforced Legplates
	[18381]="0:4:3:1:Amulet::1:0:", -- Evil Eye Pendant
	[18382]="0:4:3:1:Cloak::1:0:", -- Fluctuating Cloak
	[18383]="0:4:3:1:Plate::1:0:", -- Force Imbued Gauntlets
	[18384]="0:4:3:1:Plate::1:0:", -- Bile-etched Spaulders
	[18385]="0:4:3:1:Cloth::1:0:", -- Robe of Everlasting Night
	[18386]="0:4:3:1:Cloth::1:0:", -- Padre's Trousers
	[18387]="0:4:3:1:Cloth::1:0:", -- Brightspark Gloves
	[18388]="0:2:3:1:Crossbow::1:0:", -- Stoneshatter
	[18389]="0:4:3:1:Cloak::1:0:", -- Cloak of the Cosmos
	[18390]="0:4:3:1:Leather::1:0:", -- Tanglemoss Leggings
	[18391]="0:4:3:1:Leather::1:0:", -- Eyestalk Cord
	[18392]="0:2:3:1:Dagger::1:0:", -- Distracting Dagger
	[18393]="0:4:3:1:Mail::1:0:", -- Warpwood Binding
	[18394]="0:4:3:1:Mail::1:0:", -- Demon Howl Wristguards
	[18395]="0:4:3:1:Ring::1:0:", -- Emerald Flame Ring
	[18396]="0:2:3:1:OneHandSword::1:0:", -- Mind Carver
	[18397]="0:4:3:1:Amulet::1:0:", -- Elder Magus Pendant
	[18398]="0:4:3:1:Ring::1:0:", -- Tidal Loop
	[18399]="0:4:3:1:Ring::1:0:", -- Ocean's Breeze
	[18400]="0:4:2:1:Ring::1:0:", -- Ring of Living Stone
	[18401]="0:12:4:1:::1:0:", -- Foror's Compendium of Dragon Slaying
	[18402]="0:4:2:1:Ring::1:0:", -- Glowing Crystal Ring
	[18403]="0:4:4:1:Ring::1:0:", -- Dragonslayer's Signet
	[18404]="0:4:4:1:Amulet::1:0:", -- Onyxia Tooth Pendant
	[18405]="0:4:4:1:Cloth::1:0:", -- Belt of the Archmage
	[18406]="0:4:4:1:Trinket::1:0:", -- Onyxia Blood Talisman
	[18407]="0:4:3:1:Cloth::1:0:", -- Felcloth Gloves
	[18408]="0:4:3:1:Cloth::1:0:", -- Inferno Gloves
	[18409]="0:4:3:1:Cloth::1:0:", -- Mooncloth Gloves
	[18410]="0:2:2:1:TwoHandSword::1:0:", -- Sprinter's Sword
	[18411]="0:4:2:1:Leather::1:0:", -- Spry Boots
	[18412]="0:12:1:1:::1:0:", -- Core Fragment
	[18413]="0:4:3:1:Cloak::1:0:", -- Cloak of Warding
	[18414]="0:9:4:1:Tailoring::1:0:", -- Pattern: Belt of the Archmage
	[18415]="0:9:3:1:Tailoring::1:0:", -- Pattern: Felcloth Gloves
	[18416]="0:9:3:1:Tailoring::1:0:", -- Pattern: Inferno Gloves
	[18417]="0:9:3:1:Tailoring::1:0:", -- Pattern: Mooncloth Gloves
	[18418]="0:9:3:1:Tailoring::1:0:", -- Pattern: Cloak of Warding
	[18420]="0:2:3:1:TwoHandMace::1:0:", -- Bonecrusher
	[18421]="0:4:3:1:Mail::1:0:", -- Backwood Helm
	[18422]="0:12:4:1:::1:0:", -- Head of Onyxia
	[18423]="0:12:4:1:::1:0:", -- Head of Onyxia
	[18424]="0:4:3:1:Leather::1:0:", -- Sedge Boots
	[18425]="0:4:2:1:OffHandFrill::1:0:", -- Kreeg's Mug
	[18426]="0:12:1:1:::1:0:", -- Lethtendris's Web
	[18427]="0:4:3:1:Cloak::1:0:12799", -- Sergeant's Cloak
	[18428]="0:4:3:1:Amulet::1:0:12799", -- Senior Sergeant's Insignia
	[18429]="0:4:3:1:Plate::1:0:12799", -- First Sergeant's Plate Bracers
	[18430]="0:4:3:1:Plate::1:0:12799", -- First Sergeant's Plate Bracers
	[18432]="0:4:3:1:Mail::1:0:12799", -- First Sergeant's Mail Wristguards
	[18434]="0:4:3:1:Leather::1:0:12799", -- First Sergeant's Dragonhide Armguards
	[18435]="0:4:3:1:Leather::1:0:12799", -- First Sergeant's Leather Armguards
	[18436]="0:4:3:1:Leather::1:0:12799", -- First Sergeant's Dragonhide Armguards
	[18437]="0:4:3:1:Cloth::1:0:12799", -- First Sergeant's Silk Cuffs
	[18440]="0:4:3:1:Cloak::1:0:", -- Sergeant's Cape
	[18441]="0:4:3:1:Cloak::1:0:", -- Sergeant's Cape
	[18442]="0:4:3:1:Amulet::1:0:", -- Master Sergeant's Insignia
	[18443]="0:4:3:1:Amulet::1:0:", -- Master Sergeant's Insignia
	[18444]="0:4:3:1:Amulet::1:0:", -- Master Sergeant's Insignia
	[18445]="0:4:3:1:Plate::1:0:", -- Sergeant Major's Plate Wristguards
	[18447]="0:4:3:1:Plate::1:0:", -- Sergeant Major's Plate Wristguards
	[18448]="0:4:3:1:Mail::1:0:", -- Sergeant Major's Chain Armguards
	[18449]="0:4:3:1:Mail::1:0:", -- Sergeant Major's Chain Armguards
	[18450]="0:4:2:1:Cloth::1:0:", -- Robe of Combustion
	[18451]="0:4:2:1:Leather::1:0:", -- Hyena Hide Belt
	[18452]="0:4:3:1:Leather::1:0:", -- Sergeant Major's Leather Armsplints
	[18453]="0:4:3:1:Leather::1:0:", -- Sergeant Major's Leather Armsplints
	[18454]="0:4:3:1:Leather::1:0:", -- Sergeant Major's Dragonhide Armsplints
	[18455]="0:4:3:1:Leather::1:0:", -- Sergeant Major's Dragonhide Armsplints
	[18456]="0:4:3:1:Cloth::1:0:", -- Sergeant Major's Silk Cuffs
	[18457]="0:4:3:1:Cloth::1:0:", -- Sergeant Major's Silk Cuffs
	[18458]="0:4:2:1:Mail::1:0:", -- Modest Armguards
	[18459]="0:4:2:1:Plate::1:0:", -- Gallant's Wristguards
	[18460]="0:2:2:1:Gun::1:0:", -- Unsophisticated Hand Cannon
	[18461]="0:4:3:1:Cloak::1:0:12799", -- Sergeant's Cloak
	[18462]="0:2:2:1:FistWeapon::1:0:", -- Jagged Bone Fist
	[18463]="0:2:2:1:OneHandSword::1:0:", -- Ogre Pocket Knife
	[18464]="0:4:2:1:Ring::1:0:", -- Gordok Nose Ring
	[18465]="0:4:3:1:Trinket::1:0:", -- Royal Seal of Eldre'Thalas
	[18466]="0:4:3:1:Trinket::1:0:", -- Royal Seal of Eldre'Thalas
	[18467]="0:4:3:1:Trinket::1:0:", -- Royal Seal of Eldre'Thalas
	[18468]="0:4:3:1:Trinket::1:0:", -- Royal Seal of Eldre'Thalas
	[18469]="0:4:3:1:Trinket::1:0:", -- Royal Seal of Eldre'Thalas
	[18470]="0:4:3:1:Trinket::1:0:", -- Royal Seal of Eldre'Thalas
	[18471]="0:4:3:1:Trinket::1:0:", -- Royal Seal of Eldre'Thalas
	[18472]="0:4:3:1:Trinket::1:0:", -- Royal Seal of Eldre'Thalas
	[18473]="0:4:3:1:Trinket::1:0:", -- Royal Seal of Eldre'Thalas
	[18475]="0:4:2:1:Cloth::1:0:", -- Oddly Magical Belt
	[18476]="0:4:2:1:Leather::1:0:", -- Mud Stained Boots
	[18477]="0:4:2:1:Leather::1:0:", -- Shaggy Leggings
	[18478]="0:4:2:1:Leather::1:0:", -- Hyena Hide Jerkin
	[18479]="0:4:2:1:Mail::1:0:", -- Carrion Scorpid Helm
	[18480]="0:4:2:1:Plate::1:0:", -- Scarab Plate Helm
	[18481]="0:2:2:1:TwoHandMace::1:0:", -- Skullcracking Mace
	[18482]="0:2:2:1:Bow::1:0:", -- Ogre Toothpick Shooter
	[18483]="0:2:3:1:Wand::1:0:", -- Mana Channeling Wand
	[18484]="0:2:3:1:OneHandSword::1:0:", -- Cho'Rush's Blade
	[18485]="0:4:3:1:Shield::1:0:", -- Observer's Shield
	[18486]="0:4:3:1:Cloth::1:0:", -- Mooncloth Robe
	[18487]="40000:9:1:1:Tailoring::1:1:14371", -- Pattern: Mooncloth Robe
	[18488]="0:12:1:1:::1:0:", -- Heated Ancient Blade
	[18489]="0:12:4:1:::1:0:", -- Unfired Ancient Blade
	[18490]="0:4:3:1:Leather::1:0:", -- Insightful Hood
	[18491]="0:2:3:1:Dagger::1:0:", -- Lorespinner
	[18492]="0:12:1:1:::1:0:", -- Treated Ancient Blade
	[18493]="0:4:3:1:Plate::1:0:", -- Bulky Iron Spaulders
	[18494]="0:4:3:1:Mail::1:0:", -- Denwatcher's Shoulders
	[18495]="0:4:3:1:Cloak::1:0:", -- Redoubt Cloak
	[18496]="0:4:3:1:Cloak::1:0:", -- Heliotrope Cloak
	[18497]="0:4:3:1:Cloth::1:0:", -- Sublime Wristguards
	[18498]="0:2:3:1:OneHandAxe::1:0:", -- Hedgecutter
	[18499]="0:4:3:1:Shield::1:0:", -- Barrier Shield
	[18500]="0:4:3:1:Ring::1:0:", -- Tarnished Elven Ring
	[18501]="0:12:1:1:::1:0:", -- Felvine Shard
	[18502]="0:2:3:1:Polearm::1:0:", -- Monstrous Glaive
	[18503]="0:4:3:1:Plate::1:0:", -- Kromcrush's Chestplate
	[18504]="0:4:3:1:Leather::1:0:", -- Girdle of Insight
	[18505]="0:4:3:1:Leather::1:0:", -- Mugger's Belt
	[18506]="0:4:3:1:Leather::1:0:", -- Mongoose Boots
	[18507]="0:4:3:1:Cloth::1:0:", -- Boots of the Full Moon
	[18508]="0:4:3:1:Mail::1:0:", -- Swift Flight Bracers
	[18509]="0:4:4:1:Cloak::1:0:", -- Chromatic Cloak
	[18510]="0:4:4:1:Cloak::1:0:", -- Hide of the Wild
	[18511]="0:4:4:1:Cloak::1:0:", -- Shifting Cloak
	[18512]="0:7:1:5:Other:165:1:0:", -- Larval Acid
	[18513]="0:12:4:1:::1:0:", -- A Dull and Flat Elven Blade
	[18514]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Girdle of Insight
	[18515]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Mongoose Boots
	[18516]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Swift Flight Bracers
	[18517]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Chromatic Cloak
	[18518]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Hide of the Wild
	[18519]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Shifting Cloak
	[18520]="0:2:3:1:TwoHandSword::1:0:", -- Barbarous Blade
	[18521]="0:4:3:1:Plate::1:0:", -- Grimy Metal Boots
	[18522]="0:4:3:1:Ring::1:0:", -- Band of the Ogre King
	[18523]="0:4:3:1:OffHandFrill::1:0:", -- Brightly Glowing Stone
	[18524]="0:4:3:1:Mail::1:0:", -- Leggings of Destruction
	[18525]="0:4:3:1:Leather::1:0:", -- Bracers of Prosperity
	[18526]="0:4:3:1:Cloth::1:0:", -- Crown of the Ogre King
	[18527]="0:4:3:1:Mail::1:0:", -- Harmonious Gauntlets
	[18528]="0:4:3:1:Leather::1:0:", -- Cyclone Spaulders
	[18529]="0:4:3:1:Plate::1:0:", -- Elemental Plate Girdle
	[18530]="0:4:3:1:Mail::1:0:", -- Ogre Forged Hauberk
	[18531]="0:2:3:1:TwoHandMace::1:0:", -- Unyielding Maul
	[18532]="0:4:3:1:Cloth::1:0:", -- Mindsurge Robe
	[18533]="0:4:3:1:Plate::1:0:", -- Gordok Bracers of Power
	[18534]="0:2:3:1:Stave::1:0:", -- Rod of the Ogre Magi
	[18535]="0:4:3:1:Shield::1:0:", -- Milli's Shield
	[18536]="0:4:3:1:OffHandFrill::1:0:", -- Milli's Lexicon
	[18537]="0:4:3:1:Trinket::1:0:", -- Counterattack Lodestone
	[18538]="0:2:4:1:TwoHandAxe::1:0:", -- Treant's Bane
	[18539]="0:12:1:1:::1:0:", -- Reliquary of Purity
	[18540]="0:12:1:1:::1:0:", -- Sealed Reliquary of Purity
	[18541]="0:4:4:1:Cloak::1:0:", -- Puissant Cape
	[18542]="0:2:4:1:TwoHandSword::1:0:", -- Typhoon
	[18543]="0:4:4:1:Ring::1:0:", -- Ring of Entropy
	[18544]="0:4:4:1:Leather::1:0:", -- Doomhide Gauntlets
	[18545]="0:4:4:1:Cloth::1:0:", -- Leggings of Arcane Supremacy
	[18546]="0:4:4:1:Mail::1:0:", -- Infernal Headcage
	[18547]="0:4:4:1:Plate::1:0:", -- Unmelting Ice Girdle
	[18562]="0:7:4:20:MetalStone:186:1:0:", -- Elementium Ore
	[18563]="0:12:5:1:::1:0:", -- Bindings of the Windseeker
	[18564]="0:12:5:1:::1:0:", -- Bindings of the Windseeker
	[18567]="150000:7:1:20:MetalStone:186:1:0:790,1690,2844,2847,2999,3343,3356,3477,4257,4259,4597,5411,5512,6300,8161,8176,9179,14624,14737,15176,15400,16376,16583,16670,16713,16823,17245,17655,19011,19012,19056,19342,19520,19530,19662,19879,20082,20463,22264,22476,23144,23724,23908,24052,26081,26599,26934,27019,27045,27062,27134,27267,28344,28716,28796,29252,29253,29907,29923,29964,29969,30241,30253,30336,30436,31024,32594,33599,33631,33675", -- Elemental Flux
	[18582]="0:2:6:1:OneHandSword::1:0:", -- The Twin Blades of Azzinoth
	[18583]="0:2:6:1:OneHandSword::1:0:", -- Warglaive of Azzinoth (Right)
	[18584]="0:2:6:1:OneHandSword::1:0:", -- Warglaive of Azzinoth (Left)
	[18585]="0:4:3:1:Ring::1:0:", -- Band of Allegiance
	[18586]="0:4:3:1:Ring::1:0:", -- Lonetree's Circle
	[18587]="0:7:1:1:Device::1:0:", -- Goblin Jumper Cables XL
	[18588]="0:7:1:20:Explosive::1:0:", -- Ez-Thro Dynamite II
	[18590]="0:12:1:30:::1:0:", -- Raging Beast's Blood
	[18591]="0:12:1:1:::1:0:", -- Case of Blood
	[18592]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Sulfuron Hammer
	[18594]="0:7:1:20:Explosive::1:0:", -- Powerful Seaforium Charge
	[18597]="0:15:1:1:CombatPet::1:0:", -- Orcish Orphan Whistle
	[18598]="0:15:1:1:CombatPet::1:0:", -- Human Orphan Whistle
	[18600]="0:9:3:1:Book::1:0:", -- Tome of Arcane Brilliance
	[18601]="0:12:1:1:::1:0:", -- Glowing Crystal Prison
	[18602]="0:4:3:1:OffHandFrill::1:0:", -- Tome of Sacrifice
	[18603]="0:12:1:15:::1:0:", -- Satyr Blood
	[18604]="0:12:1:5:::1:0:", -- Tears of the Hederine
	[18605]="0:12:1:1:::1:0:", -- Imprisoned Doomguard
	[18606]="0:0:1:1:Consumable::1:0:12781", -- Alliance Battle Standard
	[18607]="0:0:1:1:Consumable::1:0:12793", -- Horde Battle Standard
	[18608]="0:2:4:1:Stave::1:0:", -- Benediction
	[18609]="0:2:4:1:Stave::1:0:", -- Anathema
	[18610]="0:2:1:1:OneHandSword::1:0:", -- Keen Machete
	[18611]="0:4:1:1:Leather::1:0:", -- Gnarlpine Leggings
	[18612]="0:4:1:1:Mail::1:0:", -- Bloody Chain Boots
	[18622]="0:12:1:1:::1:0:", -- Flawless Fel Essence (Jaedenar)
	[18623]="0:12:1:1:::1:0:", -- Flawless Fel Essence (Dark Portal)
	[18624]="0:12:1:1:::1:0:", -- Flawless Fel Essence (Azshara)
	[18625]="0:12:1:1:::1:0:", -- Kroshius' Infernal Core
	[18626]="0:12:1:1:::1:0:", -- Fel Fire
	[18628]="0:12:4:1:::1:0:", -- Thorium Brotherhood Contract
	[18629]="500000:12:1:1:::1:0:14437", -- Black Lodestone
	[18631]="0:7:1:10:Part:202:1:0:", -- Truesilver Transformer
	[18632]="1000:0:1:20:FoodDrink::5:0:14480,14481,15353,15354", -- Moonbrook Riot Taffy
	[18633]="125:0:1:20:FoodDrink::5:0:14480,14481,15353,15354", -- Styleen's Sour Suckerpop
	[18634]="0:4:3:1:Trinket::1:0:", -- Gyrofreeze Ice Reflector
	[18635]="2000:0:1:20:FoodDrink::5:0:14480,14481,15353,15354", -- Bellara's Nutterbar
	[18636]="0:7:1:1:Device::1:0:", -- Ruined Jumper Cables XL
	[18637]="0:4:2:1:Trinket::1:0:", -- Major Recombobulator
	[18638]="0:4:3:1:Trinket::1:0:", -- Hyper-Radiant Flame Reflector
	[18639]="0:4:3:1:Trinket::1:0:", -- Ultra-Flash Shadow Reflector
	[18640]="0:0:1:4:Other::1:0:", -- Happy Fun Rock
	[18641]="0:7:1:20:Explosive::1:0:", -- Dense Dynamite
	[18642]="0:12:1:1:::1:0:", -- Jaina's Autograph
	[18643]="0:12:1:1:::1:0:", -- Cairne's Hoofprint
	[18645]="0:7:2:20:Device::1:0:", -- Gnomish Alarm-o-Bot
	[18646]="0:4:4:1:Trinket::1:0:", -- The Eye of Divinity
	[18647]="1800:9:1:1:Engineering::1:1:3413", -- Schematic: Red Firework
	[18648]="1800:9:1:1:Engineering::1:1:2838,3495", -- Schematic: Green Firework
	[18649]="1800:9:1:1:Engineering::1:1:1304,5175", -- Schematic: Blue Firework
	[18650]="5000:9:1:1:Engineering::1:1:8131", -- Schematic: EZ-Thro Dynamite II
	[18651]="0:9:1:1:Engineering::1:0:", -- Schematic: Truesilver Transformer
	[18652]="12000:9:1:1:Engineering::1:1:11185", -- Schematic: Gyrofreeze Ice Reflector
	[18653]="0:9:2:1:Engineering::1:0:", -- Schematic: Goblin Jumper Cables XL
	[18654]="0:9:2:1:Engineering::1:0:", -- Schematic: Gnomish Alarm-o-Bot
	[18655]="0:9:2:1:Engineering::1:0:", -- Schematic: Major Recombobulator
	[18656]="16000:9:1:1:Engineering::1:1:11185", -- Schematic: Powerful Seaforium Charge
	[18657]="0:9:2:1:Engineering::1:0:", -- Schematic: Hyper-Radiant Flame Reflector
	[18658]="0:9:2:1:Engineering::1:0:", -- Schematic: Ultra-Flash Shadow Reflector
	[18659]="0:12:4:1:::1:0:", -- Splinter of Nordrassil
	[18660]="0:7:2:1:Device::1:0:", -- World Enlarger
	[18661]="0:9:2:1:Engineering::1:0:", -- Schematic: World Enlarger
	[18662]="20:0:1:5:Other::1:0:14860", -- Heavy Leather Ball
	[18663]="1500000:12:1:1:::1:0:14437", -- J'eevee's Jar
	[18664]="0:15:1:1:Junk::1:0:", -- A Treatise on Military Ranks
	[18665]="0:4:4:1:Trinket::1:0:", -- The Eye of Shadow
	[18670]="500000:12:1:1:::1:0:14437", -- Xorothian Glyphs
	[18671]="0:2:3:1:OneHandMace::1:0:", -- Baron Charr's Sceptre
	[18672]="0:4:2:1:OffHandFrill::1:0:", -- Elemental Ember
	[18673]="0:4:3:1:Shield::1:0:", -- Avalanchion's Stony Hide
	[18674]="0:4:2:1:Ring::1:0:", -- Hardened Stone Band
	[18675]="100:15:1:1:Junk::1:0:12799", -- Military Ranks of the Horde & Alliance
	[18676]="0:4:3:1:Mail::1:0:", -- Sash of the Windreaver
	[18677]="0:4:2:1:Cloak::1:0:", -- Zephyr Cloak
	[18678]="0:4:3:1:Amulet::1:0:", -- Tempestria's Frozen Necklace
	[18679]="0:4:2:1:Ring::1:0:", -- Frigid Ring
	[18680]="0:2:3:1:Bow::1:0:", -- Ancient Bone Bow
	[18681]="0:4:3:1:Cloth::1:0:", -- Burial Shawl
	[18682]="0:4:3:1:Leather::1:0:", -- Ghoul Skin Leggings
	[18683]="0:2:3:1:OneHandMace::1:0:", -- Hammer of the Vesper
	[18684]="0:4:3:1:Ring::1:0:", -- Dimly Opalescent Ring
	[18686]="0:4:3:1:Mail::1:0:", -- Bone Golem Shoulders
	[18687]="1500000:12:1:1:::1:0:14522", -- Xorothian Stardust
	[18688]="0:12:1:1:::1:0:", -- Imp in a Jar
	[18689]="0:4:3:1:Cloak::1:0:", -- Phantasmal Cloak
	[18690]="0:4:3:1:Plate::1:0:", -- Wraithplate Leggings
	[18691]="0:4:3:1:Amulet::1:0:", -- Dark Advisor's Pendant
	[18692]="0:4:3:1:Plate::1:0:", -- Death Knight Sabatons
	[18693]="0:4:3:1:Cloth::1:0:", -- Shivery Handwraps
	[18694]="0:4:3:1:Mail::1:0:", -- Shadowy Mail Greaves
	[18695]="0:4:3:1:OffHandFrill::1:0:", -- Spellbound Tome
	[18696]="0:4:3:1:Shield::1:0:", -- Intricately Runed Shield
	[18697]="0:4:3:1:Cloth::1:0:", -- Coldstone Slippers
	[18698]="0:4:3:1:Leather::1:0:", -- Tattered Leather Hood
	[18699]="0:4:3:1:Leather::1:0:", -- Icy Tomb Spaulders
	[18700]="0:4:3:1:Leather::1:0:", -- Malefic Bracers
	[18701]="0:4:3:1:Ring::1:0:", -- Innervating Band
	[18702]="0:4:3:1:Plate::1:0:", -- Belt of the Ordained
	[18703]="0:12:4:1:::1:0:", -- Ancient Petrified Leaf
	[18704]="0:12:4:1:::1:0:", -- Mature Blue Dragon Sinew
	[18705]="0:12:4:1:::1:0:", -- Mature Black Dragon Sinew
	[18706]="0:4:2:1:Trinket::1:0:", -- Arena Master
	[18707]="0:12:4:1:::1:0:", -- Ancient Rune Etched Stave
	[18708]="0:12:1:1:::1:0:", -- Petrified Bark
	[18709]="0:4:3:1:Cloth::1:0:", -- Arena Wristguards
	[18710]="0:4:3:1:Leather::1:0:", -- Arena Bracers
	[18711]="0:4:3:1:Mail::1:0:", -- Arena Bands
	[18712]="0:4:3:1:Plate::1:0:", -- Arena Vambraces
	[18713]="0:2:4:1:Bow::1:0:", -- Rhok'delar, Longbow of the Ancient Keepers
	[18714]="0:11:4:1:Quiver::1:0:", -- Ancient Sinew Wrapped Lamina
	[18715]="0:2:4:1:Stave::1:0:", -- Lok'delar, Stave of the Ancient Keepers
	[18716]="0:4:3:1:Leather::1:0:", -- Ash Covered Boots
	[18717]="0:2:3:1:TwoHandMace::1:0:", -- Hammer of the Grand Crusader
	[18718]="0:4:3:1:Plate::1:0:", -- Grand Crusader's Helm
	[18719]="0:12:1:1:::1:0:", -- The Traitor's Heart
	[18720]="0:4:3:1:Cloth::1:0:", -- Shroud of the Nathrezim
	[18721]="0:4:3:1:Mail::1:0:", -- Barrage Girdle
	[18722]="0:4:3:1:Plate::1:0:", -- Death Grips
	[18723]="0:4:3:1:Amulet::1:0:", -- Animated Chain Necklace
	[18724]="0:12:4:1:::1:0:", -- Enchanted Black Dragon Sinew
	[18725]="0:2:3:1:Polearm::1:0:", -- Peacemaker
	[18726]="0:4:3:1:Leather::1:0:", -- Magistrate's Cuffs
	[18727]="0:4:3:1:Cloth::1:0:", -- Crimson Felt Hat
	[18728]="0:4:3:1:Amulet::1:0:", -- Anastari Heirloom
	[18729]="0:2:3:1:Bow::1:0:", -- Screeching Bow
	[18730]="0:4:3:1:Cloth::1:0:", -- Shadowy Laced Handwraps
	[18731]="2000:9:1:1:Leatherworking::1:1:3366,5128", -- Pattern: Heavy Leather Ball
	[18734]="0:4:3:1:Cloak::1:0:", -- Pale Moon Cloak
	[18735]="0:4:3:1:Cloth::1:0:", -- Maleki's Footwraps
	[18736]="0:4:3:1:Leather::1:0:", -- Plaguehound Leggings
	[18737]="0:2:3:1:OneHandAxe::1:0:", -- Bone Slicing Hatchet
	[18738]="0:2:3:1:Crossbow::1:0:", -- Carapace Spine Crossbow
	[18739]="0:4:3:1:Plate::1:0:", -- Chitinous Plate Legguards
	[18740]="0:4:3:1:Cloth::1:0:", -- Thuzadin Sash
	[18741]="0:4:3:1:Plate::1:0:", -- Morlune's Bracer
	[18742]="0:4:3:1:Mail::1:0:", -- Stratholme Militia Shoulderguard
	[18743]="0:4:3:1:Cloak::1:0:", -- Gracious Cape
	[18744]="0:4:3:1:Leather::1:0:", -- Plaguebat Fur Gloves
	[18745]="0:4:3:1:Cloth::1:0:", -- Sacred Cloth Leggings
	[18746]="0:12:1:1:::1:0:", -- Divination Scryer
	[18749]="0:12:1:1:::1:0:", -- Charger's Lost Soul
	[18752]="0:12:1:1:::1:0:", -- Exorcism Censer
	[18753]="0:12:1:1:::1:0:", -- Arcanite Barding
	[18754]="0:4:3:1:Plate::1:0:", -- Fel Hardened Bracers
	[18755]="0:2:3:1:Gun::1:0:", -- Xorothian Firestick
	[18756]="0:4:3:1:Shield::1:0:", -- Dreadguard's Protector
	[18757]="0:4:3:1:Cloth::1:0:", -- Diabolic Mantle
	[18758]="0:2:3:1:Dagger::1:0:", -- Specter's Blade
	[18759]="0:2:3:1:TwoHandAxe::1:0:", -- Malicious Axe
	[18760]="0:4:3:1:Ring::1:0:", -- Necromantic Band
	[18761]="0:2:3:1:Wand::1:0:", -- Oblivion's Touch
	[18762]="0:4:3:1:OffHandFrill::1:0:", -- Shard of the Green Flame
	[18766]="100000:15:4:1:Mount::1:0:4730", -- Reins of the Swift Frostsaber
	[18767]="100000:15:4:1:Mount::1:0:4730", -- Reins of the Swift Mistsaber
	[18769]="0:12:3:1:::1:0:", -- Enchanted Thorium Platemail
	[18770]="0:12:3:1:::1:0:", -- Enchanted Thorium Platemail
	[18771]="0:12:3:1:::1:0:", -- Enchanted Thorium Platemail
	[18772]="100000:15:4:1:Mount::1:0:7955", -- Swift Green Mechanostrider
	[18773]="100000:15:4:1:Mount::1:0:7955", -- Swift White Mechanostrider
	[18774]="100000:15:4:1:Mount::1:0:7955", -- Swift Yellow Mechanostrider
	[18775]="0:12:1:1:::1:0:", -- Manna-Enriched Horse Feed
	[18776]="100000:15:4:1:Mount::1:0:384,2357,4885", -- Swift Palomino
	[18777]="100000:15:4:1:Mount::1:0:384,2357,4885", -- Swift Brown Steed
	[18778]="100000:15:4:1:Mount::1:0:384,2357,4885", -- Swift White Steed
	[18779]="0:12:3:1:::1:0:", -- Bottom Half of Advanced Armorsmithing: Volume I
	[18780]="0:12:3:1:::1:0:", -- Top Half of Advanced Armorsmithing: Volume I
	[18781]="0:12:3:1:::1:0:", -- Bottom Half of Advanced Armorsmithing: Volume II
	[18782]="0:12:3:1:::1:0:", -- Top Half of Advanced Armorsmithing: Volume II
	[18783]="0:12:3:1:::1:0:", -- Bottom Half of Advanced Armorsmithing: Volume III
	[18784]="0:12:3:1:::1:0:", -- Top Half of Advanced Armorsmithing: Volume III
	[18785]="100000:15:4:1:Mount::1:0:1261", -- Swift White Ram
	[18786]="100000:15:4:1:Mount::1:0:1261", -- Swift Brown Ram
	[18787]="100000:15:4:1:Mount::1:0:1261", -- Swift Gray Ram
	[18788]="100000:15:4:1:Mount::1:0:7952", -- Swift Blue Raptor
	[18789]="100000:15:4:1:Mount::1:0:7952", -- Swift Olive Raptor
	[18790]="100000:15:4:1:Mount::1:0:7952", -- Swift Orange Raptor
	[18791]="100000:15:4:1:Mount::1:0:4731", -- Purple Skeletal Warhorse
	[18792]="0:12:1:1:::1:0:", -- Blessed Arcanite Barding
	[18793]="100000:15:4:1:Mount::1:0:3685", -- Great White Kodo
	[18794]="100000:15:4:1:Mount::1:0:3685", -- Great Brown Kodo
	[18795]="100000:15:4:1:Mount::1:0:3685", -- Great Gray Kodo
	[18796]="100000:15:4:1:Mount::1:0:3362", -- Horn of the Swift Brown Wolf
	[18797]="100000:15:4:1:Mount::1:0:3362", -- Horn of the Swift Timber Wolf
	[18798]="100000:15:4:1:Mount::1:0:3362", -- Horn of the Swift Gray Wolf
	[18799]="0:12:1:1:::1:0:", -- Charger's Redeemed Soul
	[18802]="60000:12:1:5:::3:0:14437", -- Shadowy Potion
	[18803]="0:2:4:1:TwoHandMace::1:0:", -- Finkle's Lava Dredger
	[18804]="0:12:1:1:::1:0:", -- Lord Grayson's Satchel
	[18805]="0:2:4:1:Dagger::1:0:", -- Core Hound Tooth
	[18806]="0:4:4:1:Plate::1:0:", -- Core Forged Greaves
	[18807]="0:4:3:1:Mail::1:0:", -- Helm of Latent Power
	[18808]="0:4:4:1:Cloth::1:0:", -- Gloves of the Hypnotic Flame
	[18809]="0:4:4:1:Cloth::1:0:", -- Sash of Whispered Secrets
	[18810]="0:4:4:1:Leather::1:0:", -- Wild Growth Spaulders
	[18811]="0:4:4:1:Cloak::1:0:", -- Fireproof Cloak
	[18812]="0:4:4:1:Mail::1:0:", -- Wristguards of True Flight
	[18813]="0:4:4:1:Ring::1:0:", -- Ring of Binding
	[18814]="0:4:4:1:Amulet::1:0:", -- Choker of the Fire Lord
	[18815]="0:4:4:1:Trinket::1:0:", -- Essence of the Pure Flame
	[18816]="0:2:4:1:Dagger::1:0:", -- Perdition's Blade
	[18817]="0:4:4:1:Mail::1:0:", -- Crown of Destruction
	[18818]="0:12:1:1:::1:0:", -- Mor'zul's Instructions
	[18819]="0:12:1:1:::1:0:", -- Rohan's Exorcism Censer
	[18820]="0:4:4:1:Trinket::1:0:", -- Talisman of Ephemeral Power
	[18821]="0:4:4:1:Ring::1:0:", -- Quick Strike Ring
	[18822]="0:2:4:1:TwoHandSword::1:0:", -- Obsidian Edged Blade
	[18823]="0:4:4:1:Leather::1:0:", -- Aged Core Leather Gloves
	[18824]="0:4:4:1:Plate::1:0:", -- Magma Tempered Boots
	[18825]="0:4:4:1:Shield::1:0:", -- Grand Marshal's Aegis
	[18826]="0:4:4:1:Shield::1:0:", -- High Warlord's Shield Wall
	[18827]="0:2:4:1:OneHandAxe::1:0:", -- Grand Marshal's Handaxe
	[18828]="0:2:4:1:OneHandAxe::1:0:", -- High Warlord's Cleaver
	[18829]="0:4:4:1:Mail::1:0:", -- Deep Earth Spaulders
	[18830]="0:2:4:1:TwoHandAxe::1:0:", -- Grand Marshal's Sunderer
	[18831]="0:2:4:1:TwoHandAxe::1:0:", -- High Warlord's Battle Axe
	[18832]="0:2:4:1:OneHandSword::1:0:", -- Brutality Blade
	[18833]="0:2:4:1:Bow::1:0:", -- Grand Marshal's Bullseye
	[18834]="0:4:3:1:Trinket::1:0:12795,12799", -- Insignia of the Horde
	[18835]="0:2:4:1:Bow::1:0:", -- High Warlord's Recurve
	[18836]="0:2:4:1:Crossbow::1:0:", -- Grand Marshal's Repeater
	[18837]="0:2:4:1:Crossbow::1:0:", -- High Warlord's Crossbow
	[18838]="0:2:4:1:Dagger::1:0:", -- Grand Marshal's Dirk
	[18839]="1000:0:1:20:Potion::1:0:12781,12793", -- Combat Healing Potion
	[18840]="0:2:4:1:Dagger::1:0:", -- High Warlord's Razor
	[18841]="1000:0:1:20:Potion::1:0:12781,12793", -- Combat Mana Potion
	[18842]="0:2:4:1:Stave::1:0:", -- Staff of Dominance
	[18843]="0:2:4:1:FistWeapon::1:0:", -- Grand Marshal's Right Hand Blade
	[18844]="0:2:4:1:FistWeapon::1:0:", -- High Warlord's Right Claw
	[18845]="0:4:3:1:Trinket::1:0:12795,12799", -- Insignia of the Horde
	[18846]="0:4:3:1:Trinket::1:0:12795,12799", -- Insignia of the Horde
	[18847]="0:2:4:1:FistWeapon::1:0:", -- Grand Marshal's Left Hand Blade
	[18848]="0:2:4:1:FistWeapon::1:0:", -- High Warlord's Left Claw
	[18849]="0:4:3:1:Trinket::1:0:12795,12799", -- Insignia of the Horde
	[18850]="0:4:3:1:Trinket::1:0:12795,12799", -- Insignia of the Horde
	[18851]="0:4:3:1:Trinket::1:0:12795,12799", -- Insignia of the Horde
	[18852]="0:4:3:1:Trinket::1:0:12795,12799", -- Insignia of the Horde
	[18853]="0:4:3:1:Trinket::1:0:12795,12799", -- Insignia of the Horde
	[18854]="0:4:3:1:Trinket::1:0:12785", -- Insignia of the Alliance
	[18855]="0:2:4:1:Gun::1:0:", -- Grand Marshal's Hand Cannon
	[18856]="0:4:3:1:Trinket::1:0:12785", -- Insignia of the Alliance
	[18857]="0:4:3:1:Trinket::1:0:12785", -- Insignia of the Alliance
	[18858]="0:4:3:1:Trinket::1:0:12785", -- Insignia of the Alliance
	[18859]="0:4:3:1:Trinket::1:0:12785", -- Insignia of the Alliance
	[18860]="0:2:4:1:Gun::1:0:", -- High Warlord's Street Sweeper
	[18861]="0:4:4:1:Plate::1:0:", -- Flamewaker Legplates
	[18862]="0:4:3:1:Trinket::1:0:12785", -- Insignia of the Alliance
	[18863]="0:4:3:1:Trinket::1:0:12785", -- Insignia of the Alliance
	[18864]="0:4:3:1:Trinket::1:0:12785", -- Insignia of the Alliance
	[18865]="0:2:4:1:OneHandMace::1:0:", -- Grand Marshal's Punisher
	[18866]="0:2:4:1:OneHandMace::1:0:", -- High Warlord's Bludgeon
	[18867]="0:2:4:1:TwoHandMace::1:0:", -- Grand Marshal's Battle Hammer
	[18868]="0:2:4:1:TwoHandMace::1:0:", -- High Warlord's Pulverizer
	[18869]="0:2:4:1:Polearm::1:0:", -- Grand Marshal's Glaive
	[18870]="0:4:4:1:Mail::1:0:", -- Helm of the Lifegiver
	[18871]="0:2:4:1:Polearm::1:0:", -- High Warlord's Pig Sticker
	[18872]="0:4:4:1:Cloth::1:0:", -- Manastorm Leggings
	[18873]="0:2:4:1:Stave::1:0:", -- Grand Marshal's Stave
	[18874]="0:2:4:1:Stave::1:0:", -- High Warlord's War Staff
	[18875]="0:4:4:1:Leather::1:0:", -- Salamander Scale Pants
	[18876]="0:2:4:1:TwoHandSword::1:0:", -- Grand Marshal's Claymore
	[18877]="0:2:4:1:TwoHandSword::1:0:", -- High Warlord's Greatsword
	[18878]="0:2:4:1:Dagger::1:0:", -- Sorcerous Dagger
	[18879]="0:4:4:1:Ring::1:0:", -- Heavy Dark Iron Ring
	[18880]="0:12:1:1:::1:0:", -- Darkreaver's Head
	[18902]="100000:15:4:1:Mount::1:0:4730", -- Reins of the Swift Stormsaber
	[18904]="0:12:1:1:::1:0:", -- Zorbin's Ultra-Shrinker
	[18922]="0:12:1:1:::1:0:", -- Secret Plans: Fiery Flux
	[18943]="0:12:1:20:::1:0:", -- Dark Iron Pillow
	[18944]="0:12:1:100:::1:0:", -- Incendosaur Scale
	[18945]="0:12:1:100:::1:0:", -- Dark Iron Residue
	[18946]="0:12:1:1:::1:0:", -- Head of Overseer Maltorius
	[18947]="0:12:1:20:::1:0:", -- Rage Scar Yeti Hide
	[18948]="0:4:3:1:Leather::1:0:", -- Barbaric Bracers
	[18949]="2000:9:1:1:Leatherworking::1:1:4225,4589", -- Pattern: Barbaric Bracers
	[18950]="0:12:1:1:::1:0:", -- Chambermaid Pillaclencher's Pillow
	[18951]="0:4:2:1:Trinket::1:0:", -- Evonice's Landin' Pilla
	[18952]="0:12:1:1:::1:0:", -- Simone's Head
	[18953]="0:12:1:1:::1:0:", -- Klinfran's Head
	[18954]="0:12:1:1:::1:0:", -- Solenor's Head
	[18955]="0:12:1:1:::1:0:", -- Artorius's Head
	[18956]="0:12:1:20:::1:0:", -- Miniaturization Residue
	[18957]="0:2:2:1:OneHandSword::1:0:", -- Brushwood Blade
	[18958]="0:12:1:20:::1:0:", -- Water Elemental Core
	[18959]="0:12:1:1:::1:0:", -- Smithing Tuyere
	[18960]="0:12:1:1:::1:0:", -- Lookout's Spyglass
	[18961]="0:12:1:20:::1:0:", -- Zukk'ash Carapace
	[18962]="0:12:1:1:::1:0:", -- Stinglasher's Glands
	[18964]="0:15:1:1:Companion::1:0:", -- Turtle Egg (Loggerhead)
	[18969]="0:12:1:1:::1:0:", -- Pristine Yeti Hide
	[18972]="0:12:1:1:::1:0:", -- Perfect Yeti Hide
	[18984]="0:4:2:1:Miscellaneous::1:0:", -- Dimensional Ripper - Everlook
	[18986]="0:4:2:1:Miscellaneous::1:0:", -- Ultrasafe Transporter: Gadgetzan
	[18987]="0:12:1:1:::1:0:", -- Blackhand's Command
	[19002]="0:12:4:1:::1:0:", -- Head of Nefarian
	[19003]="0:12:4:1:::1:0:", -- Head of Nefarian
	[19004]="0:0:1:1:Other::1:0:", -- Minor Healthstone
	[19005]="0:0:1:1:Other::1:0:", -- Minor Healthstone
	[19006]="0:0:1:1:Other::1:0:", -- Lesser Healthstone
	[19007]="0:0:1:1:Other::1:0:", -- Lesser Healthstone
	[19008]="0:0:1:1:Other::1:0:", -- Healthstone
	[19009]="0:0:1:1:Other::1:0:", -- Healthstone
	[19010]="0:0:1:1:Other::1:0:", -- Greater Healthstone
	[19011]="0:0:1:1:Other::1:0:", -- Greater Healthstone
	[19012]="0:0:1:1:Other::1:0:", -- Major Healthstone
	[19013]="0:0:1:1:Other::1:0:", -- Major Healthstone
	[19016]="0:12:5:1:::1:0:", -- Vessel of Rebirth
	[19017]="0:12:1:1:::1:0:", -- Essence of the Firelord
	[19018]="0:12:5:1:::1:0:", -- Dormant Wind Kissed Blade
	[19019]="123140:2:5:1:OneHandSword::1:0:", -- Thunderfury, Blessed Blade of the Windseeker
	[19020]="0:12:1:1:::1:0:", -- Camp Mojache Zukk'ash Report
	[19022]="0:2:2:1:FishingPole::1:0:", -- Nat Pagle's Extreme Angler FC-5000
	[19023]="0:12:1:1:::1:0:", -- Katoom's Best Lure
	[19024]="0:4:3:1:Trinket::1:0:", -- Arena Grand Master
	[19025]="0:12:1:1:::1:0:", -- Skylord Plume
	[19026]="0:0:1:10:Other::1:0:", -- Snake Burst Firework
	[19027]="5000:9:1:1:Engineering::1:0:14637", -- Schematic: Snake Burst Firework
	[19028]="0:4:1:1:Miscellaneous::1:0:32836,32837", -- Elegant Dress
	[19029]="0:15:4:1:Mount::1:0:", -- Horn of the Frostwolf Howler
	[19030]="0:15:4:1:Mount::1:0:", -- Stormpike Battle Charger
	[19031]="0:4:1:1:Tabard::1:0:", -- Frostwolf Battle Tabard
	[19032]="0:4:1:1:Tabard::1:0:", -- Stormpike Battle Tabard
	[19033]="0:12:1:1:::1:0:", -- Slagtree's Lost Tools
	[19034]="0:12:1:1:::1:0:", -- Lard's Lunch
	[19035]="0:15:2:1:Junk::1:0:", -- Lard's Special Picnic Basket
	[19036]="0:12:1:1:::1:0:", -- Final Message to the Wildhammer
	[19037]="0:4:2:1:Plate::1:0:", -- Emerald Peak Spaulders
	[19038]="0:4:2:1:Ring::1:0:", -- Ring of Subtlety
	[19039]="0:4:2:1:Leather::1:0:", -- Zorbin's Water Resistant Hat
	[19040]="0:2:2:1:OneHandSword::1:0:", -- Zorbin's Mega-Slicer
	[19041]="0:4:2:1:Leather::1:0:", -- Pratt's Handcrafted Tunic
	[19042]="0:4:2:1:Leather::1:0:", -- Jangdor's Handcrafted Tunic
	[19043]="0:4:3:1:Mail::1:0:", -- Heavy Timbermaw Belt
	[19044]="0:4:3:1:Leather::1:0:", -- Might of the Timbermaw
	[19045]="0:0:3:1:Consumable::1:0:", -- Stormpike Battle Standard
	[19046]="0:0:3:1:Consumable::1:0:", -- Frostwolf Battle Standard
	[19047]="0:4:3:1:Cloth::1:0:", -- Wisdom of the Timbermaw
	[19048]="0:4:3:1:Mail::1:0:", -- Heavy Timbermaw Boots
	[19049]="0:4:3:1:Leather::1:0:", -- Timbermaw Brawlers
	[19050]="0:4:3:1:Cloth::1:0:", -- Mantle of the Timbermaw
	[19051]="0:4:3:1:Plate::1:0:", -- Girdle of the Dawn
	[19052]="0:4:3:1:Leather::1:0:", -- Dawn Treaders
	[19054]="0:15:1:1:Companion::1:0:", -- Red Dragon Orb
	[19055]="0:15:1:1:Companion::1:0:", -- Green Dragon Orb
	[19056]="0:4:3:1:Cloth::1:0:", -- Argent Boots
	[19057]="0:4:3:1:Plate::1:0:", -- Gloves of the Dawn
	[19058]="0:4:3:1:Leather::1:0:", -- Golden Mantle of the Dawn
	[19059]="0:4:3:1:Cloth::1:0:", -- Argent Shoulders
	[19060]="2000:0:1:20:Consumable::5:0:14753,14754", -- Warsong Gulch Enriched Ration
	[19061]="1500:0:1:20:Consumable::5:0:14753,14754", -- Warsong Gulch Iron Ration
	[19062]="1000:0:1:20:Consumable::5:0:14753,14754", -- Warsong Gulch Field Ration
	[19064]="0:13:1:1:::1:0:", -- Shackle Key
	[19066]="2000:0:1:20:Bandage::5:0:14753,14754", -- Warsong Gulch Runecloth Bandage
	[19067]="1500:0:1:20:Bandage::5:0:14753,14754", -- Warsong Gulch Mageweave Bandage
	[19068]="1000:0:1:20:Bandage::5:0:14753,14754", -- Warsong Gulch Silk Bandage
	[19069]="0:12:1:1:::1:0:", -- Huntsman Malkhor's Skull
	[19070]="0:12:1:1:::1:0:", -- Huntsman Malkhor's Bones
	[19071]="0:12:1:10:::1:0:", -- Vessel of Tainted Blood
	[19083]="0:4:3:1:Cloak::1:0:", -- Frostwolf Legionnaire's Cloak
	[19084]="0:4:3:1:Cloak::1:0:", -- Stormpike Soldier's Cloak
	[19085]="0:4:3:1:Cloak::1:0:", -- Frostwolf Advisor's Cloak
	[19086]="0:4:3:1:Cloak::1:0:", -- Stormpike Sage's Cloak
	[19087]="0:4:3:1:Plate::1:0:", -- Frostwolf Plate Belt
	[19088]="0:4:3:1:Mail::1:0:", -- Frostwolf Mail Belt
	[19089]="0:4:3:1:Leather::1:0:", -- Frostwolf Leather Belt
	[19090]="0:4:3:1:Cloth::1:0:", -- Frostwolf Cloth Belt
	[19091]="0:4:3:1:Plate::1:0:", -- Stormpike Plate Girdle
	[19092]="0:4:3:1:Mail::1:0:", -- Stormpike Mail Girdle
	[19093]="0:4:3:1:Leather::1:0:", -- Stormpike Leather Girdle
	[19094]="0:4:3:1:Cloth::1:0:", -- Stormpike Cloth Girdle
	[19095]="0:4:3:1:Amulet::1:0:", -- Frostwolf Legionnaire's Pendant
	[19096]="0:4:3:1:Amulet::1:0:", -- Frostwolf Advisor's Pendant
	[19097]="0:4:3:1:Amulet::1:0:", -- Stormpike Soldier's Pendant
	[19098]="0:4:3:1:Amulet::1:0:", -- Stormpike Sage's Pendant
	[19099]="0:2:3:1:Dagger::1:0:", -- Glacial Blade
	[19100]="0:2:3:1:Dagger::1:0:13217", -- Electrified Dagger
	[19101]="0:2:3:1:Stave::1:0:", -- Whiteout Staff
	[19102]="0:2:3:1:Stave::1:0:", -- Crackling Staff
	[19103]="0:2:3:1:OneHandAxe::1:0:", -- Frostbite
	[19104]="0:2:3:1:OneHandMace::1:0:13217", -- Stormstrike Hammer
	[19105]="0:4:3:1:Cloth::1:0:", -- Frost Runed Headdress
	[19106]="0:2:3:1:Polearm::1:0:", -- Ice Barbed Spear
	[19107]="0:2:3:1:Crossbow::1:0:", -- Bloodseeker
	[19108]="0:2:3:1:Wand::1:0:", -- Wand of Biting Cold
	[19109]="0:4:3:1:Ring::1:0:", -- Deep Rooted Ring
	[19110]="0:2:3:1:OneHandSword::1:0:", -- Cold Forged Blade
	[19111]="0:4:3:1:Mail::1:0:", -- Winteraxe Epaulets
	[19112]="0:4:3:1:Plate::1:0:", -- Frozen Steel Vambraces
	[19113]="0:4:3:1:Leather::1:0:", -- Yeti Hide Bracers
	[19114]="0:2:2:1:Bow::1:0:", -- Highland Bow
	[19115]="0:4:2:1:OffHandFrill::1:0:", -- Flask of Forest Mojo
	[19116]="0:4:2:1:Cloth::1:0:", -- Greenleaf Handwraps
	[19117]="0:4:2:1:Plate::1:0:", -- Laquered Wooden Plate Legguards
	[19118]="0:2:2:1:Wand::1:0:", -- Nature's Breath
	[19119]="0:4:2:1:Leather::1:0:", -- Owlbeast Hide Gloves
	[19120]="0:4:2:1:Trinket::1:0:", -- Rune of the Guard Captain
	[19121]="0:4:3:1:Cloak::1:0:", -- Deep Woodlands Cloak
	[19123]="0:4:2:1:Cloth::1:0:", -- Everwarm Handwraps
	[19124]="0:4:2:1:Plate::1:0:", -- Slagplate Leggings
	[19125]="0:4:2:1:Mail::1:0:", -- Seared Mail Girdle
	[19126]="0:4:2:1:Plate::1:0:", -- Slagplate Gauntlets
	[19127]="0:4:2:1:Leather::1:0:", -- Charred Leather Tunic
	[19128]="0:4:2:1:Mail::1:0:", -- Seared Mail Vest
	[19129]="0:4:2:1:Cloth::1:0:", -- Everglowing Robe
	[19130]="0:2:4:1:Wand::1:0:", -- Cold Snap
	[19131]="0:4:4:1:Cloth::1:0:", -- Snowblind Shoes
	[19132]="0:4:4:1:Cloth::1:0:", -- Crystal Adorned Crown
	[19133]="0:4:4:1:Cloth::1:0:", -- Fel Infused Leggings
	[19134]="0:4:4:1:Leather::1:0:", -- Flayed Doomguard Belt
	[19135]="0:4:4:1:Cloth::1:0:", -- Blacklight Bracer
	[19136]="0:4:4:1:Cloth::1:0:", -- Mana Igniting Cord
	[19137]="0:4:4:1:Plate::1:0:", -- Onslaught Girdle
	[19138]="0:4:4:1:Ring::1:0:", -- Band of Sulfuras
	[19139]="0:4:4:1:Leather::1:0:", -- Fireguard Shoulders
	[19140]="0:4:4:1:Ring::1:0:", -- Cauterizing Band
	[19141]="0:4:2:1:Trinket::1:0:", -- Luffa
	[19142]="0:4:4:1:OffHandFrill::1:0:", -- Fire Runed Grimoire
	[19143]="0:4:4:1:Plate::1:0:", -- Flameguard Gauntlets
	[19144]="0:4:4:1:Mail::1:0:", -- Sabatons of the Flamewalker
	[19145]="0:4:4:1:Cloth::1:0:", -- Robe of Volatile Power
	[19146]="0:4:4:1:Leather::1:0:", -- Wristguards of Stability
	[19147]="0:4:4:1:Ring::1:0:", -- Ring of Spell Power
	[19148]="0:4:4:1:Plate::1:0:", -- Dark Iron Helm
	[19149]="0:4:4:1:Leather::1:0:", -- Lava Belt
	[19150]="0:0:1:1:Consumable::1:0:", -- Sentinel Basic Care Package
	[19151]="0:0:1:1:Consumable::1:0:", -- Sentinel Standard Care Package
	[19152]="0:0:1:1:Consumable::1:0:", -- Sentinel Advanced Care Package
	[19153]="0:0:1:1:Consumable::1:0:", -- Outrider Advanced Care Package
	[19154]="0:0:1:1:Consumable::1:0:", -- Outrider Basic Care Package
	[19155]="0:0:1:1:Consumable::1:0:", -- Outrider Standard Care Package
	[19156]="0:4:4:1:Cloth::1:0:", -- Flarecore Robe
	[19157]="0:4:4:1:Mail::1:0:", -- Chromatic Gauntlets
	[19159]="0:4:3:1:Amulet::1:0:", -- Woven Ivy Necklace
	[19160]="0:4:1:1:Tabard::1:0:", -- Contest Winner's Tabard
	[19162]="0:4:4:1:Leather::1:0:", -- Corehound Belt
	[19163]="0:4:4:1:Leather::1:0:", -- Molten Belt
	[19164]="0:4:4:1:Plate::1:0:", -- Dark Iron Gauntlets
	[19165]="0:4:4:1:Cloth::1:0:", -- Flarecore Leggings
	[19166]="0:2:4:1:Dagger::1:0:", -- Black Amnesty
	[19167]="0:2:4:1:Polearm::1:0:", -- Blackfury
	[19168]="0:2:4:1:OneHandSword::1:0:", -- Blackguard
	[19169]="0:2:4:1:TwoHandAxe::1:0:", -- Nightfall
	[19170]="0:2:4:1:OneHandMace::1:0:", -- Ebon Hand
	[19182]="0:0:1:200:Consumable::1:0:", -- Darkmoon Faire Prize Ticket
	[19183]="0:0:1:200:Other::1:0:", -- Hourglass Sand
	[19202]="22000:9:1:1:Blacksmithing::1:0:11557", -- Plans: Heavy Timbermaw Belt
	[19203]="22000:9:1:1:Blacksmithing::1:0:10856,10857,11536", -- Plans: Girdle of the Dawn
	[19204]="40000:9:1:1:Blacksmithing::1:0:11557", -- Plans: Heavy Timbermaw Boots
	[19205]="40000:9:1:1:Blacksmithing::1:0:10856,10857,11536", -- Plans: Gloves of the Dawn
	[19206]="60000:9:1:1:Blacksmithing::1:1:12944", -- Plans: Dark Iron Helm
	[19207]="80000:9:1:1:Blacksmithing::1:0:12944", -- Plans: Dark Iron Gauntlets
	[19208]="70000:9:1:1:Blacksmithing::1:0:12944", -- Plans: Black Amnesty
	[19209]="70000:9:1:1:Blacksmithing::1:0:12944", -- Plans: Blackfury
	[19210]="120000:9:1:1:Blacksmithing::1:0:12944", -- Plans: Ebon Hand
	[19211]="120000:9:1:1:Blacksmithing::1:0:12944", -- Plans: Blackguard
	[19212]="120000:9:1:1:Blacksmithing::1:0:12944", -- Plans: Nightfall
	[19213]="0:12:2:250:::1:0:", -- Silverwing Talisman of Merit
	[19215]="22000:9:1:1:Tailoring::1:0:11557", -- Pattern: Wisdom of the Timbermaw
	[19216]="22000:9:1:1:Tailoring::1:0:10856,10857,11536", -- Pattern: Argent Boots
	[19217]="40000:9:1:1:Tailoring::1:0:10856,10857,11536", -- Pattern: Argent Shoulders
	[19218]="40000:9:1:1:Tailoring::1:0:11557", -- Pattern: Mantle of the Timbermaw
	[19219]="60000:9:1:1:Tailoring::1:1:12944", -- Pattern: Flarecore Robe
	[19220]="90000:9:1:1:Tailoring::1:0:12944", -- Pattern: Flarecore Leggings
	[19221]="50:0:1:10:FoodDrink::1:0:14844", -- Darkmoon Special Reserve
	[19222]="10:0:1:10:FoodDrink::1:0:14844,20377", -- Cheap Beer
	[19223]="25:0:1:20:FoodDrink::5:0:14845", -- Darkmoon Dog
	[19224]="1000:0:1:20:FoodDrink::5:0:14845", -- Red Hot Wings
	[19225]="4000:0:1:20:FoodDrink::5:0:14845", -- Deep Fried Candybar
	[19227]="0:12:3:20:::1:0:", -- Ace of Beasts
	[19228]="0:12:4:1:::1:0:", -- Beasts Deck
	[19229]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #1
	[19230]="0:12:3:20:::1:0:", -- Two of Beasts
	[19231]="0:12:3:20:::1:0:", -- Three of Beasts
	[19232]="0:12:3:20:::1:0:", -- Four of Beasts
	[19233]="0:12:3:20:::1:0:", -- Five of Beasts
	[19234]="0:12:3:20:::1:0:", -- Six of Beasts
	[19235]="0:12:3:20:::1:0:", -- Seven of Beasts
	[19236]="0:12:3:20:::1:0:", -- Eight of Beasts
	[19237]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #19
	[19238]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #3
	[19239]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #4
	[19240]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #5
	[19241]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #6
	[19242]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #7
	[19243]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #8
	[19244]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #9
	[19245]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #10
	[19246]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #11
	[19247]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #12
	[19248]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #13
	[19249]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #14
	[19250]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #15
	[19251]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #16
	[19252]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #18
	[19253]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #17
	[19254]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #21
	[19255]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #22
	[19256]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #2
	[19257]="0:12:4:1:::1:0:", -- Warlords Deck
	[19258]="0:12:3:20:::1:0:", -- Ace of Warlords
	[19259]="0:12:3:20:::1:0:", -- Two of Warlords
	[19260]="0:12:3:20:::1:0:", -- Three of Warlords
	[19261]="0:12:3:20:::1:0:", -- Four of Warlords
	[19262]="0:12:3:20:::1:0:", -- Five of Warlords
	[19263]="0:12:3:20:::1:0:", -- Six of Warlords
	[19264]="0:12:3:20:::1:0:", -- Seven of Warlords
	[19265]="0:12:3:20:::1:0:", -- Eight of Warlords
	[19266]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #20
	[19267]="0:12:4:1:::1:0:", -- Elementals Deck
	[19268]="0:12:3:20:::1:0:", -- Ace of Elementals
	[19269]="0:12:3:20:::1:0:", -- Two of Elementals
	[19270]="0:12:3:20:::1:0:", -- Three of Elementals
	[19271]="0:12:3:20:::1:0:", -- Four of Elementals
	[19272]="0:12:3:20:::1:0:", -- Five of Elementals
	[19273]="0:12:3:20:::1:0:", -- Six of Elementals
	[19274]="0:12:3:20:::1:0:", -- Seven of Elementals
	[19275]="0:12:3:20:::1:0:", -- Eight of Elementals
	[19276]="0:12:3:20:::1:0:", -- Ace of Portals
	[19277]="0:12:4:1:::1:0:", -- Portals Deck
	[19278]="0:12:3:20:::1:0:", -- Two of Portals
	[19279]="0:12:3:20:::1:0:", -- Three of Portals
	[19280]="0:12:3:20:::1:0:", -- Four of Portals
	[19281]="0:12:3:20:::1:0:", -- Five of Portals
	[19282]="0:12:3:20:::1:0:", -- Six of Portals
	[19283]="0:12:3:20:::1:0:", -- Seven of Portals
	[19284]="0:12:3:20:::1:0:", -- Eight of Portals
	[19287]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Heroism
	[19288]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Blue Dragon
	[19289]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Maelstrom
	[19290]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Twisting Nether
	[19291]="0:1:1:1:Bag::1:0:", -- Darkmoon Storage Box
	[19292]="0:2:1:1:OneHandMace::1:0:", -- Last Month's Mutton
	[19293]="0:2:1:1:OneHandMace::1:0:", -- Last Year's Mutton
	[19295]="0:4:1:1:OffHandFrill::1:0:", -- Darkmoon Flower
	[19296]="0:0:2:1:Other::1:0:", -- Greater Darkmoon Prize
	[19297]="0:0:2:1:Other::1:0:", -- Lesser Darkmoon Prize
	[19298]="0:0:2:1:Other::1:0:", -- Minor Darkmoon Prize
	[19299]="500:0:1:20:FoodDrink::5:0:14844", -- Fizzy Faire Drink
	[19300]="2000:0:1:20:FoodDrink::5:0:14844", -- Bottled Winterspring Water
	[19301]="7000:0:1:20:FoodDrink::5:0:13216,13217,13218,13219", -- Alterac Manna Biscuit
	[19302]="50000:4:3:1:Ring::1:1:14846", -- Darkmoon Ring
	[19303]="50000:4:2:1:Amulet::1:1:14846", -- Darkmoon Necklace
	[19304]="125:0:1:20:FoodDrink::5:0:14845", -- Spiced Beef Jerky
	[19305]="500:0:1:20:FoodDrink::5:0:14845", -- Pickled Kodo Foot
	[19306]="2000:0:1:20:FoodDrink::5:0:14845", -- Crunchy Frog
	[19307]="8000:0:1:100:Bandage::20:0:13216,13217,13218,13219", -- Alterac Heavy Runecloth Bandage
	[19308]="0:4:4:1:OffHandFrill::1:0:", -- Tome of Arcane Domination
	[19309]="0:4:4:1:OffHandFrill::1:0:", -- Tome of Shadow Force
	[19310]="0:4:4:1:OffHandFrill::1:0:", -- Tome of the Ice Lord
	[19311]="0:4:4:1:OffHandFrill::1:0:", -- Tome of Fiery Arcana
	[19312]="0:4:4:1:OffHandFrill::1:0:", -- Lei of the Lifegiver
	[19315]="0:4:4:1:OffHandFrill::1:0:", -- Therazane's Touch
	[19316]="6000:6:2:1000:Arrow::200:0:13216,13217,13218,13219", -- Ice Threaded Arrow
	[19317]="6000:6:2:1000:Bullet::200:0:13216,13217,13218,13219", -- Ice Threaded Bullet
	[19318]="5000:0:1:20:Consumable::5:0:13216,13217,13218,13219", -- Bottled Alterac Spring Water
	[19319]="0:11:3:1:Quiver::1:0:", -- Harpy Hide Quiver
	[19320]="0:11:3:1:AmmoPouch::1:0:", -- Gnoll Skin Bandolier
	[19321]="0:4:4:1:Shield::1:0:", -- The Immovable Object
	[19323]="0:2:4:1:TwoHandMace::1:0:", -- The Unstoppable Force
	[19324]="0:2:4:1:Dagger::1:0:", -- The Lobotomizer
	[19325]="0:4:4:1:Ring::1:0:", -- Don Julio's Band
	[19326]="22000:9:1:1:Leatherworking::1:0:11557", -- Pattern: Might of the Timbermaw
	[19327]="40000:9:1:1:Leatherworking::1:0:11557", -- Pattern: Timbermaw Brawlers
	[19328]="22000:9:1:1:Leatherworking::1:0:10856,10857,11536", -- Pattern: Dawn Treaders
	[19329]="40000:9:1:1:Leatherworking::1:0:10856,10857,11536", -- Pattern: Golden Mantle of the Dawn
	[19330]="60000:9:1:1:Leatherworking::1:1:12944", -- Pattern: Lava Belt
	[19331]="90000:9:1:1:Leatherworking::1:0:12944", -- Pattern: Chromatic Gauntlets
	[19332]="90000:9:1:1:Leatherworking::1:0:12944", -- Pattern: Corehound Belt
	[19333]="90000:9:1:1:Leatherworking::1:0:12944", -- Pattern: Molten Belt
	[19334]="0:2:4:1:TwoHandSword::1:0:", -- The Untamed Blade
	[19335]="0:2:4:1:OneHandMace::1:0:", -- Spineshatter
	[19336]="0:4:4:1:Trinket::1:0:", -- Arcane Infused Gem
	[19337]="0:4:4:1:Trinket::1:0:", -- The Black Book
	[19338]="0:12:1:1:::1:0:", -- Free Ticket Voucher
	[19339]="0:4:4:1:Trinket::1:0:", -- Mind Quickening Gem
	[19340]="0:4:4:1:Trinket::1:0:", -- Rune of Metamorphosis
	[19341]="0:4:4:1:Trinket::1:0:", -- Lifegiving Gem
	[19342]="0:4:4:1:Trinket::1:0:", -- Venomous Totem
	[19343]="0:4:4:1:Trinket::1:0:", -- Scrolls of Blinding Light
	[19344]="0:4:4:1:Trinket::1:0:", -- Natural Alignment Crystal
	[19345]="0:4:4:1:Trinket::1:0:", -- Aegis of Preservation
	[19346]="0:2:4:1:Dagger::1:0:", -- Dragonfang Blade
	[19347]="0:2:4:1:Dagger::1:0:", -- Claw of Chromaggus
	[19348]="0:4:4:1:Shield::1:0:", -- Red Dragonscale Protector
	[19349]="0:4:4:1:Shield::1:0:", -- Elementium Reinforced Bulwark
	[19350]="0:2:4:1:Bow::1:0:", -- Heartstriker
	[19351]="81453:2:4:1:OneHandSword::1:0:", -- Maladath, Runed Blade of the Black Flight
	[19352]="0:2:4:1:OneHandSword::1:0:", -- Chromatically Tempered Sword
	[19353]="0:2:4:1:TwoHandAxe::1:0:", -- Drake Talon Cleaver
	[19354]="0:2:4:1:TwoHandAxe::1:0:", -- Draconic Avenger
	[19355]="0:2:4:1:Stave::1:0:", -- Shadow Wing Focus Staff
	[19356]="0:2:4:1:Stave::1:0:", -- Staff of the Shadow Flame
	[19357]="0:2:4:1:TwoHandMace::1:0:", -- Herald of Woe
	[19358]="0:2:4:1:TwoHandMace::1:0:", -- Draconic Maul
	[19360]="0:2:4:1:OneHandMace::1:0:", -- Lok'amir il Romathis
	[19361]="60230:2:4:1:Crossbow::1:0:", -- Ashjre'thul, Crossbow of Smiting
	[19362]="0:2:4:1:OneHandAxe::1:0:", -- Doom's Edge
	[19363]="84569:2:4:1:OneHandAxe::1:0:", -- Crul'shorukh, Edge of Chaos
	[19364]="106097:2:4:1:TwoHandSword::1:0:", -- Ashkandi, Greatsword of the Brotherhood
	[19365]="0:2:4:1:FistWeapon::1:0:", -- Claw of the Black Drake
	[19366]="0:4:4:1:OffHandFrill::1:0:", -- Master Dragonslayer's Orb
	[19367]="0:2:4:1:Wand::1:0:", -- Dragon's Touch
	[19368]="0:2:4:1:Gun::1:0:", -- Dragonbreath Hand Cannon
	[19369]="0:4:4:1:Cloth::1:0:", -- Gloves of Rapid Evolution
	[19370]="0:4:4:1:Cloth::1:0:", -- Mantle of the Blackwing Cabal
	[19371]="0:4:4:1:Amulet::1:0:", -- Pendant of the Fallen Dragon
	[19372]="0:4:4:1:Plate::1:0:", -- Helm of Endless Rage
	[19373]="0:4:4:1:Mail::1:0:", -- Black Brood Pauldrons
	[19374]="0:4:4:1:Cloth::1:0:", -- Bracers of Arcane Accuracy
	[19375]="25143:4:4:1:Cloth::1:0:", -- Mish'undare, Circlet of the Mind Flayer
	[19376]="0:4:4:1:Ring::1:0:", -- Archimtiros' Ring of Reckoning
	[19377]="0:4:4:1:Amulet::1:0:", -- Prestor's Talisman of Connivery
	[19378]="0:4:4:1:Cloak::1:0:", -- Cloak of the Brood Lord
	[19379]="0:4:4:1:Trinket::1:0:", -- Neltharion's Tear
	[19380]="0:4:4:1:Mail::1:0:", -- Therazane's Link
	[19381]="0:4:4:1:Leather::1:0:", -- Boots of the Shadow Flame
	[19382]="0:4:4:1:Ring::1:0:", -- Pure Elementium Band
	[19383]="0:4:4:1:Amulet::1:0:", -- Master Dragonslayer's Medallion
	[19384]="0:4:4:1:Ring::1:0:", -- Master Dragonslayer's Ring
	[19385]="0:4:4:1:Cloth::1:0:", -- Empowered Leggings
	[19386]="0:4:4:1:Cloak::1:0:", -- Elementium Threaded Cloak
	[19387]="0:4:4:1:Plate::1:0:", -- Chromatic Boots
	[19388]="0:4:4:1:Cloth::1:0:", -- Angelista's Grasp
	[19389]="0:4:4:1:Leather::1:0:", -- Taut Dragonhide Shoulderpads
	[19390]="0:4:4:1:Leather::1:0:", -- Taut Dragonhide Gloves
	[19391]="0:4:4:1:Cloth::1:0:", -- Shimmering Geta
	[19392]="0:4:4:1:Plate::1:0:", -- Girdle of the Fallen Crusader
	[19393]="0:4:4:1:Mail::1:0:", -- Primalist's Linked Waistguard
	[19394]="0:4:4:1:Plate::1:0:", -- Drake Talon Pauldrons
	[19395]="0:4:4:1:Trinket::1:0:", -- Rejuvenating Gem
	[19396]="0:4:4:1:Leather::1:0:", -- Taut Dragonhide Belt
	[19397]="0:4:4:1:Ring::1:0:", -- Ring of Blackrock
	[19398]="0:4:4:1:Cloak::1:0:", -- Cloak of Firemaw
	[19399]="0:4:4:1:Cloth::1:0:", -- Black Ash Robe
	[19400]="0:4:4:1:Cloth::1:0:", -- Firemaw's Clutch
	[19401]="0:4:4:1:Mail::1:0:", -- Primalist's Linked Legguards
	[19402]="0:4:4:1:Plate::1:0:", -- Legguards of the Fallen Crusader
	[19403]="0:4:4:1:Ring::1:0:", -- Band of Forced Concentration
	[19405]="0:4:4:1:Leather::1:0:", -- Malfurion's Blessed Bulwark
	[19406]="0:4:4:1:Trinket::1:0:", -- Drake Fang Talisman
	[19407]="0:4:4:1:Cloth::1:0:", -- Ebony Flame Gloves
	[19422]="0:12:1:1:::1:0:", -- Darkmoon Faire Fortune
	[19423]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #23
	[19424]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #24
	[19425]="0:0:2:1:Consumable::1:0:", -- Mysterious Lockbox
	[19426]="0:4:4:1:Amulet::1:0:", -- Orb of the Darkmoon
	[19430]="0:4:4:1:Cloak::1:0:", -- Shroud of Pure Thought
	[19431]="0:4:4:1:Trinket::1:0:", -- Styleen's Impeding Scarab
	[19432]="0:4:4:1:Ring::1:0:", -- Circle of Applied Force
	[19433]="0:4:4:1:Mail::1:0:", -- Emberweave Leggings
	[19434]="0:4:4:1:Ring::1:0:", -- Band of Dark Dominion
	[19435]="0:2:4:1:Wand::1:0:", -- Essence Gatherer
	[19436]="0:4:4:1:Cloak::1:0:", -- Cloak of Draconic Might
	[19437]="0:4:4:1:Cloth::1:0:", -- Boots of Pure Thought
	[19438]="0:4:4:1:Cloth::1:0:", -- Ringo's Blizzard Boots
	[19439]="0:4:4:1:Leather::1:0:", -- Interlaced Shadow Jerkin
	[19440]="0:0:1:10:Other::1:0:", -- Powerful Anti-Venom
	[19441]="0:7:1:5:Other:129:1:0:", -- Huge Venom Sac
	[19442]="100000:9:1:1:FirstAid::1:0:10856,10857,11536", -- Formula: Powerful Anti-Venom
	[19443]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #25
	[19444]="30000:9:1:1:Enchanting::1:1:12944", -- Formula: Enchant Weapon - Strength
	[19445]="30000:9:1:1:Enchanting::1:0:11557", -- Formula: Enchant Weapon - Agility
	[19446]="30000:9:1:1:Enchanting::1:0:10856,10857,11536", -- Formula: Enchant Bracer - Mana Regeneration
	[19447]="60000:9:1:1:Enchanting::1:0:10856,10857,11536", -- Formula: Enchant Bracer - Healing Power
	[19448]="80000:9:1:1:Enchanting::1:1:12944", -- Formula: Enchant Weapon - Mighty Spirit
	[19449]="100000:9:1:1:Enchanting::1:1:12944", -- Formula: Enchant Weapon - Mighty Intellect
	[19450]="0:15:1:1:Companion::1:0:", -- A Jubling's Tiny Home
	[19451]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #26
	[19452]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #27
	[19453]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #28
	[19454]="0:15:1:1:Junk::1:0:", -- Sayge's Fortune #29
	[19462]="0:15:1:1:Companion::1:0:", -- Unhatched Jubling Egg
	[19483]="0:15:1:1:Junk::1:0:", -- Peeling the Onion
	[19484]="0:15:1:1:Junk::1:0:", -- The Frostwolf Artichoke
	[19491]="0:4:4:1:Amulet::1:0:", -- Amulet of the Darkmoon
	[19505]="0:4:1:1:Tabard::1:0:5188,5189,5190,14754,16610", -- Warsong Battle Tabard
	[19506]="0:4:1:1:Tabard::1:0:5049,5191,5193,14753,16766", -- Silverwing Battle Tabard
	[19507]="0:4:3:1:Cloth::1:0:", -- Inquisitor's Shawl
	[19508]="0:4:3:1:Leather::1:0:", -- Branded Leather Bracers
	[19509]="0:4:3:1:Mail::1:0:", -- Dusty Mail Boots
	[19510]="0:4:3:1:Ring::1:0:", -- Legionnaire's Band
	[19511]="0:4:3:1:Ring::1:0:", -- Legionnaire's Band
	[19512]="0:4:3:1:Ring::1:0:", -- Legionnaire's Band
	[19513]="0:4:3:1:Ring::1:0:", -- Legionnaire's Band
	[19514]="0:4:3:1:Ring::1:0:", -- Protector's Band
	[19515]="0:4:3:1:Ring::1:0:", -- Protector's Band
	[19516]="0:4:3:1:Ring::1:0:", -- Protector's Band
	[19517]="0:4:3:1:Ring::1:0:", -- Protector's Band
	[19518]="0:4:3:1:Ring::1:0:", -- Advisor's Ring
	[19519]="0:4:3:1:Ring::1:0:", -- Advisor's Ring
	[19520]="0:4:3:1:Ring::1:0:", -- Advisor's Ring
	[19521]="0:4:3:1:Ring::1:0:", -- Advisor's Ring
	[19522]="0:4:3:1:Ring::1:0:", -- Lorekeeper's Ring
	[19523]="0:4:3:1:Ring::1:0:", -- Lorekeeper's Ring
	[19524]="0:4:3:1:Ring::1:0:", -- Lorekeeper's Ring
	[19525]="0:4:3:1:Ring::1:0:", -- Lorekeeper's Ring
	[19526]="0:4:3:1:Cloak::1:0:", -- Battle Healer's Cloak
	[19527]="0:4:3:1:Cloak::1:0:", -- Battle Healer's Cloak
	[19528]="0:4:3:1:Cloak::1:0:", -- Battle Healer's Cloak
	[19529]="0:4:3:1:Cloak::1:0:", -- Battle Healer's Cloak
	[19530]="0:4:3:1:Cloak::1:0:", -- Caretaker's Cape
	[19531]="0:4:3:1:Cloak::1:0:", -- Caretaker's Cape
	[19532]="0:4:3:1:Cloak::1:0:", -- Caretaker's Cape
	[19533]="0:4:3:1:Cloak::1:0:", -- Caretaker's Cape
	[19534]="0:4:3:1:Amulet::1:0:", -- Scout's Medallion
	[19535]="0:4:3:1:Amulet::1:0:", -- Scout's Medallion
	[19536]="0:4:3:1:Amulet::1:0:", -- Scout's Medallion
	[19537]="0:4:3:1:Amulet::1:0:", -- Scout's Medallion
	[19538]="0:4:3:1:Amulet::1:0:", -- Sentinel's Medallion
	[19539]="0:4:3:1:Amulet::1:0:", -- Sentinel's Medallion
	[19540]="0:4:3:1:Amulet::1:0:", -- Sentinel's Medallion
	[19541]="0:4:3:1:Amulet::1:0:", -- Sentinel's Medallion
	[19542]="0:2:3:1:Dagger::1:0:", -- Scout's Blade
	[19543]="0:2:3:1:Dagger::1:0:", -- Scout's Blade
	[19544]="0:2:3:1:Dagger::1:0:", -- Scout's Blade
	[19545]="0:2:3:1:Dagger::1:0:", -- Scout's Blade
	[19546]="0:2:3:1:Dagger::1:0:", -- Sentinel's Blade
	[19547]="0:2:3:1:Dagger::1:0:", -- Sentinel's Blade
	[19548]="0:2:3:1:Dagger::1:0:", -- Sentinel's Blade
	[19549]="0:2:3:1:Dagger::1:0:", -- Sentinel's Blade
	[19550]="0:2:3:1:OneHandSword::1:0:", -- Legionnaire's Sword
	[19551]="0:2:3:1:OneHandSword::1:0:", -- Legionnaire's Sword
	[19552]="0:2:3:1:OneHandSword::1:0:", -- Legionnaire's Sword
	[19553]="0:2:3:1:OneHandSword::1:0:", -- Legionnaire's Sword
	[19554]="0:2:3:1:OneHandSword::1:0:", -- Protector's Sword
	[19555]="0:2:3:1:OneHandSword::1:0:", -- Protector's Sword
	[19556]="0:2:3:1:OneHandSword::1:0:", -- Protector's Sword
	[19557]="0:2:3:1:OneHandSword::1:0:", -- Protector's Sword
	[19558]="0:2:3:1:Bow::1:0:", -- Outrider's Bow
	[19559]="0:2:3:1:Bow::1:0:", -- Outrider's Bow
	[19560]="0:2:3:1:Bow::1:0:", -- Outrider's Bow
	[19561]="0:2:3:1:Bow::1:0:", -- Outrider's Bow
	[19562]="0:2:3:1:Bow::1:0:", -- Outrunner's Bow
	[19563]="0:2:3:1:Bow::1:0:", -- Outrunner's Bow
	[19564]="0:2:3:1:Bow::1:0:", -- Outrunner's Bow
	[19565]="0:2:3:1:Bow::1:0:", -- Outrunner's Bow
	[19566]="0:2:3:1:Stave::1:0:", -- Advisor's Gnarled Staff
	[19567]="0:2:3:1:Stave::1:0:", -- Advisor's Gnarled Staff
	[19568]="0:2:3:1:Stave::1:0:", -- Advisor's Gnarled Staff
	[19569]="0:2:3:1:Stave::1:0:", -- Advisor's Gnarled Staff
	[19570]="0:2:3:1:Stave::1:0:", -- Lorekeeper's Staff
	[19571]="0:2:3:1:Stave::1:0:", -- Lorekeeper's Staff
	[19572]="0:2:3:1:Stave::1:0:", -- Lorekeeper's Staff
	[19573]="0:2:3:1:Stave::1:0:", -- Lorekeeper's Staff
	[19574]="0:4:2:1:Amulet::1:0:", -- Strength of Mugamba
	[19575]="0:4:3:1:Amulet::1:0:", -- Strength of Mugamba
	[19576]="0:4:3:1:Amulet::1:0:", -- Strength of Mugamba
	[19577]="0:4:4:1:Amulet::1:0:", -- Rage of Mugamba
	[19578]="0:4:4:1:Plate::1:0:", -- Berserker Bracers
	[19579]="0:4:2:1:Amulet::1:0:", -- Heathen's Brand
	[19580]="0:4:4:1:Plate::1:0:", -- Berserker Bracers
	[19581]="0:4:4:1:Plate::1:0:", -- Berserker Bracers
	[19582]="0:4:4:1:Mail::1:0:", -- Windtalker's Wristguards
	[19583]="0:4:4:1:Mail::1:0:", -- Windtalker's Wristguards
	[19584]="0:4:4:1:Mail::1:0:", -- Windtalker's Wristguards
	[19585]="0:4:3:1:Amulet::1:0:", -- Heathen's Brand
	[19586]="0:4:3:1:Amulet::1:0:", -- Heathen's Brand
	[19587]="0:4:4:1:Leather::1:0:", -- Forest Stalker's Bracers
	[19588]="0:4:4:1:Amulet::1:0:", -- Hero's Brand
	[19589]="0:4:4:1:Leather::1:0:", -- Forest Stalker's Bracers
	[19590]="0:4:4:1:Leather::1:0:", -- Forest Stalker's Bracers
	[19591]="0:4:2:1:Amulet::1:0:", -- The Eye of Zuldazar
	[19592]="0:4:3:1:Amulet::1:0:", -- The Eye of Zuldazar
	[19593]="0:4:3:1:Amulet::1:0:", -- The Eye of Zuldazar
	[19594]="0:4:4:1:Amulet::1:0:", -- The All-Seeing Eye of Zuldazar
	[19595]="0:4:4:1:Cloth::1:0:", -- Dryad's Wrist Bindings
	[19596]="0:4:4:1:Cloth::1:0:", -- Dryad's Wrist Bindings
	[19597]="0:4:4:1:Cloth::1:0:", -- Dryad's Wrist Bindings
	[19598]="0:4:2:1:Amulet::1:0:", -- Pebble of Kajaro
	[19599]="0:4:3:1:Amulet::1:0:", -- Pebble of Kajaro
	[19600]="0:4:3:1:Amulet::1:0:", -- Pebble of Kajaro
	[19601]="0:4:4:1:Amulet::1:0:", -- Jewel of Kajaro
	[19602]="0:4:2:1:Amulet::1:0:", -- Kezan's Taint
	[19603]="0:4:3:1:Amulet::1:0:", -- Kezan's Taint
	[19604]="0:4:3:1:Amulet::1:0:", -- Kezan's Taint
	[19605]="0:4:4:1:Amulet::1:0:", -- Kezan's Unstoppable Taint
	[19606]="0:4:2:1:Amulet::1:0:", -- Vision of Voodress
	[19607]="0:4:3:1:Amulet::1:0:", -- Vision of Voodress
	[19608]="0:4:3:1:Amulet::1:0:", -- Vision of Voodress
	[19609]="0:4:4:1:Amulet::1:0:", -- Unmarred Vision of Voodress
	[19610]="0:4:2:1:Amulet::1:0:", -- Enchanted South Seas Kelp
	[19611]="0:4:3:1:Amulet::1:0:", -- Enchanted South Seas Kelp
	[19612]="0:4:3:1:Amulet::1:0:", -- Enchanted South Seas Kelp
	[19613]="0:4:4:1:Amulet::1:0:", -- Pristine Enchanted South Seas Kelp
	[19614]="0:4:2:1:Amulet::1:0:", -- Zandalarian Shadow Talisman
	[19615]="0:4:3:1:Amulet::1:0:", -- Zandalarian Shadow Talisman
	[19616]="0:4:3:1:Amulet::1:0:", -- Zandalarian Shadow Talisman
	[19617]="0:4:4:1:Amulet::1:0:", -- Zandalarian Shadow Mastery Talisman
	[19618]="0:4:2:1:Amulet::1:0:", -- Maelstrom's Tendril
	[19619]="0:4:3:1:Amulet::1:0:", -- Maelstrom's Tendril
	[19620]="0:4:3:1:Amulet::1:0:", -- Maelstrom's Tendril
	[19621]="0:4:4:1:Amulet::1:0:", -- Maelstrom's Wrath
	[19682]="0:4:3:1:Cloth::1:0:", -- Bloodvine Vest
	[19683]="0:4:3:1:Cloth::1:0:", -- Bloodvine Leggings
	[19684]="0:4:3:1:Cloth::1:0:", -- Bloodvine Boots
	[19685]="0:4:3:1:Leather::1:0:", -- Primal Batskin Jerkin
	[19686]="0:4:3:1:Leather::1:0:", -- Primal Batskin Gloves
	[19687]="0:4:3:1:Leather::1:0:", -- Primal Batskin Bracers
	[19688]="0:4:3:1:Leather::1:0:", -- Blood Tiger Breastplate
	[19689]="0:4:3:1:Leather::1:0:", -- Blood Tiger Shoulders
	[19690]="0:4:3:1:Mail::1:0:", -- Bloodsoul Breastplate
	[19691]="0:4:3:1:Mail::1:0:", -- Bloodsoul Shoulders
	[19692]="0:4:3:1:Mail::1:0:", -- Bloodsoul Gauntlets
	[19693]="0:4:3:1:Plate::1:0:", -- Darksoul Breastplate
	[19694]="0:4:3:1:Plate::1:0:", -- Darksoul Leggings
	[19695]="0:4:3:1:Plate::1:0:", -- Darksoul Shoulders
	[19696]="0:0:1:20:FoodDrink::1:0:", -- Harvest Bread
	[19697]="0:4:1:1:Miscellaneous::1:0:", -- Bounty of the Harvest
	[19698]="0:12:2:250:::1:0:", -- Zulian Coin
	[19699]="0:12:2:250:::1:0:", -- Razzashi Coin
	[19700]="0:12:2:250:::1:0:", -- Hakkari Coin
	[19701]="0:12:2:250:::1:0:", -- Gurubashi Coin
	[19702]="0:12:2:250:::1:0:", -- Vilebranch Coin
	[19703]="0:12:2:250:::1:0:", -- Witherbark Coin
	[19704]="0:12:2:250:::1:0:", -- Sandfury Coin
	[19705]="0:12:2:250:::1:0:", -- Skullsplitter Coin
	[19706]="0:12:2:250:::1:0:", -- Bloodscalp Coin
	[19707]="0:12:3:250:::1:0:", -- Red Hakkari Bijou
	[19708]="0:12:3:250:::1:0:", -- Blue Hakkari Bijou
	[19709]="0:12:3:250:::1:0:", -- Yellow Hakkari Bijou
	[19710]="0:12:3:250:::1:0:", -- Orange Hakkari Bijou
	[19711]="0:12:3:250:::1:0:", -- Green Hakkari Bijou
	[19712]="0:12:3:250:::1:0:", -- Purple Hakkari Bijou
	[19713]="0:12:3:250:::1:0:", -- Bronze Hakkari Bijou
	[19714]="0:12:3:250:::1:0:", -- Silver Hakkari Bijou
	[19715]="0:12:3:250:::1:0:", -- Gold Hakkari Bijou
	[19716]="0:12:4:250:::1:0:", -- Primal Hakkari Bindings
	[19717]="0:12:4:250:::1:0:", -- Primal Hakkari Armsplint
	[19718]="0:12:4:250:::1:0:", -- Primal Hakkari Stanchion
	[19719]="0:12:4:250:::1:0:", -- Primal Hakkari Girdle
	[19720]="0:12:4:250:::1:0:", -- Primal Hakkari Sash
	[19721]="0:12:4:250:::1:0:", -- Primal Hakkari Shawl
	[19722]="0:12:4:250:::1:0:", -- Primal Hakkari Tabard
	[19723]="0:12:4:250:::1:0:", -- Primal Hakkari Kossack
	[19724]="0:12:4:250:::1:0:", -- Primal Hakkari Aegis
	[19725]="0:12:1:20:::1:0:", -- Arathi Resource Crate
	[19726]="0:7:2:20:Herb:164,202,165,197:1:0:", -- Bloodvine
	[19727]="0:7:3:1:Herb::1:0:", -- Blood Scythe
	[19764]="50000:9:1:1:Tailoring::1:0:14921", -- Pattern: Bloodvine Vest
	[19765]="50000:9:1:1:Tailoring::1:0:14921", -- Pattern: Bloodvine Leggings
	[19766]="50000:9:1:1:Tailoring::1:0:14921", -- Pattern: Bloodvine Boots
	[19767]="0:7:1:20:Leather:165:1:0:", -- Primal Bat Leather
	[19768]="0:7:1:20:Leather:165:1:0:", -- Primal Tiger Leather
	[19769]="50000:9:1:1:Leatherworking::1:0:14921", -- Pattern: Primal Batskin Jerkin
	[19770]="50000:9:1:1:Leatherworking::1:0:14921", -- Pattern: Primal Batskin Gloves
	[19771]="50000:9:1:1:Leatherworking::1:0:14921", -- Pattern: Primal Batskin Bracers
	[19772]="50000:9:1:1:Leatherworking::1:0:14921", -- Pattern: Blood Tiger Breastplate
	[19773]="50000:9:1:1:Leatherworking::1:0:14921", -- Pattern: Blood Tiger Shoulders
	[19774]="0:3:2:20:GemSimple:164:1:0:", -- Souldarite
	[19775]="0:15:1:1:Junk::1:0:", -- Sealed Azure Bag
	[19776]="50000:9:1:1:Blacksmithing::1:0:14921", -- Plans: Bloodsoul Breastplate
	[19777]="50000:9:1:1:Blacksmithing::1:0:14921", -- Plans: Bloodsoul Shoulders
	[19778]="50000:9:1:1:Blacksmithing::1:0:14921", -- Plans: Bloodsoul Gauntlets
	[19779]="50000:9:1:1:Blacksmithing::1:0:14921", -- Plans: Darksoul Breastplate
	[19780]="50000:9:1:1:Blacksmithing::1:0:14921", -- Plans: Darksoul Leggings
	[19781]="50000:9:1:1:Blacksmithing::1:0:14921", -- Plans: Darksoul Shoulders
	[19782]="0:0:3:1:EnhPerm::1:0:", -- Presence of Might
	[19783]="0:0:3:1:EnhPerm::1:0:", -- Syncretist's Sigil
	[19784]="0:0:3:1:EnhPerm::1:0:", -- Death's Embrace
	[19785]="0:0:3:1:EnhPerm::1:0:", -- Falcon's Call
	[19786]="0:0:3:1:EnhPerm::1:0:", -- Vodouisant's Vigilant Embrace
	[19787]="0:0:3:1:EnhPerm::1:0:", -- Presence of Sight
	[19788]="0:0:3:1:EnhPerm::1:0:", -- Hoodoo Hex
	[19789]="0:0:3:1:EnhPerm::1:0:", -- Prophetic Aura
	[19790]="0:0:3:1:EnhPerm::1:0:", -- Animist's Caress
	[19802]="0:12:4:1:::1:0:", -- Heart of Hakkar
	[19803]="0:15:2:20:Junk::1:0:", -- Brownell's Blue Striped Racer
	[19805]="0:15:2:20:Junk::1:0:", -- Keefer's Angelfish
	[19806]="0:15:2:20:Junk::1:0:", -- Dezian Queenfish
	[19807]="0:12:1:20:::1:0:", -- Speckled Tastyfish
	[19808]="0:2:2:1:OneHandMace::1:0:", -- Rockhide Strongfish
	[19812]="0:4:3:1:Trinket::1:0:", -- Rune of the Dawn
	[19813]="0:12:2:1:::1:0:", -- Punctured Voodoo Doll
	[19814]="0:12:2:1:::1:0:", -- Punctured Voodoo Doll
	[19815]="0:12:2:1:::1:0:", -- Punctured Voodoo Doll
	[19816]="0:12:2:1:::1:0:", -- Punctured Voodoo Doll
	[19817]="0:12:2:1:::1:0:", -- Punctured Voodoo Doll
	[19818]="0:12:2:1:::1:0:", -- Punctured Voodoo Doll
	[19819]="0:12:2:1:::1:0:", -- Punctured Voodoo Doll
	[19820]="0:12:2:1:::1:0:", -- Punctured Voodoo Doll
	[19821]="0:12:2:1:::1:0:", -- Punctured Voodoo Doll
	[19822]="0:4:4:1:Plate::1:0:", -- Zandalar Vindicator's Breastplate
	[19823]="0:4:4:1:Plate::1:0:", -- Zandalar Vindicator's Belt
	[19824]="0:4:4:1:Plate::1:0:", -- Zandalar Vindicator's Armguards
	[19825]="0:4:4:1:Plate::1:0:", -- Zandalar Freethinker's Breastplate
	[19826]="0:4:4:1:Plate::1:0:", -- Zandalar Freethinker's Belt
	[19827]="0:4:4:1:Plate::1:0:", -- Zandalar Freethinker's Armguards
	[19828]="0:4:4:1:Mail::1:0:", -- Zandalar Augur's Hauberk
	[19829]="0:4:4:1:Mail::1:0:", -- Zandalar Augur's Belt
	[19830]="0:4:4:1:Mail::1:0:", -- Zandalar Augur's Bracers
	[19831]="0:4:4:1:Mail::1:0:", -- Zandalar Predator's Mantle
	[19832]="0:4:4:1:Mail::1:0:", -- Zandalar Predator's Belt
	[19833]="0:4:4:1:Mail::1:0:", -- Zandalar Predator's Bracers
	[19834]="0:4:4:1:Leather::1:0:", -- Zandalar Madcap's Tunic
	[19835]="0:4:4:1:Leather::1:0:", -- Zandalar Madcap's Mantle
	[19836]="0:4:4:1:Leather::1:0:", -- Zandalar Madcap's Bracers
	[19838]="0:4:4:1:Leather::1:0:", -- Zandalar Haruspex's Tunic
	[19839]="0:4:4:1:Leather::1:0:", -- Zandalar Haruspex's Belt
	[19840]="0:4:4:1:Leather::1:0:", -- Zandalar Haruspex's Bracers
	[19841]="0:4:4:1:Cloth::1:0:", -- Zandalar Confessor's Mantle
	[19842]="0:4:4:1:Cloth::1:0:", -- Zandalar Confessor's Bindings
	[19843]="0:4:4:1:Cloth::1:0:", -- Zandalar Confessor's Wraps
	[19845]="0:4:4:1:Cloth::1:0:", -- Zandalar Illusionist's Mantle
	[19846]="0:4:4:1:Cloth::1:0:", -- Zandalar Illusionist's Wraps
	[19848]="0:4:4:1:Cloth::1:0:", -- Zandalar Demoniac's Wraps
	[19849]="0:4:4:1:Cloth::1:0:", -- Zandalar Demoniac's Mantle
	[19850]="0:12:1:1:::1:0:", -- Uther's Tribute
	[19851]="0:12:1:1:::1:0:", -- Grom's Tribute
	[19852]="0:2:4:1:OneHandAxe::1:0:", -- Ancient Hakkari Manslayer
	[19853]="0:2:4:1:Gun::1:0:", -- Gurubashi Dwarf Destroyer
	[19854]="92937:2:4:1:TwoHandSword::1:0:", -- Zin'rokh, Destroyer of Worlds
	[19855]="0:4:4:1:Plate::1:0:", -- Bloodsoaked Legplates
	[19856]="0:4:4:1:Amulet::1:0:", -- The Eye of Hakkar
	[19857]="0:4:4:1:Cloak::1:0:", -- Cloak of Consumption
	[19858]="0:12:2:250:::1:0:", -- Zandalar Honor Token
	[19859]="0:2:4:1:Dagger::1:0:", -- Fang of the Faceless
	[19861]="0:2:4:1:Wand::1:0:", -- Touch of Chaos
	[19862]="0:4:4:1:Shield::1:0:", -- Aegis of the Blood God
	[19863]="0:4:3:1:Ring::1:0:", -- Primalist's Seal
	[19864]="0:2:4:1:OneHandSword::1:0:", -- Bloodcaller
	[19865]="0:2:4:1:OneHandSword::1:0:", -- Warblade of the Hakkari
	[19866]="0:2:4:1:OneHandSword::1:0:", -- Warblade of the Hakkari
	[19867]="0:2:4:1:OneHandSword::1:0:", -- Bloodlord's Defender
	[19869]="0:4:3:1:Leather::1:0:", -- Blooddrenched Grips
	[19870]="0:4:3:1:Cloak::1:0:", -- Hakkari Loa Cloak
	[19871]="0:4:3:1:Amulet::1:0:", -- Talisman of Protection
	[19872]="0:15:4:1:Mount::1:0:", -- Swift Razzashi Raptor
	[19873]="0:4:3:1:Ring::1:0:", -- Overlord's Crimson Band
	[19874]="0:2:4:1:Polearm::1:0:", -- Halberd of Smiting
	[19875]="0:4:3:1:Mail::1:0:", -- Bloodstained Coif
	[19876]="0:4:4:1:Amulet::1:0:", -- Soul Corrupter's Necklace
	[19877]="0:4:3:1:Leather::1:0:", -- Animist's Leggings
	[19878]="0:4:3:1:Plate::1:0:", -- Bloodsoaked Pauldrons
	[19880]="0:12:1:1:::1:0:", -- Gurubashi Head Collection
	[19881]="0:12:1:20:::1:0:", -- Channeler's Head
	[19882]="0:12:1:20:::1:0:", -- The Hexxer's Head
	[19883]="0:12:1:1:::1:0:", -- Sacred Cord
	[19884]="0:2:4:1:Stave::1:0:", -- Jin'do's Judgement
	[19885]="0:4:4:1:Amulet::1:0:", -- Jin'do's Evil Eye
	[19886]="0:4:3:1:Cloth::1:0:", -- The Hexxer's Cover
	[19887]="0:4:3:1:Mail::1:0:", -- Bloodstained Legplates
	[19888]="0:4:3:1:Cloak::1:0:", -- Overlord's Embrace
	[19889]="0:4:3:1:Leather::1:0:", -- Blooddrenched Leggings
	[19890]="0:2:4:1:OneHandMace::1:0:", -- Jin'do's Hexxer
	[19891]="0:4:4:1:OffHandFrill::1:0:", -- Jin'do's Bag of Whammies
	[19892]="0:4:3:1:Leather::1:0:", -- Animist's Boots
	[19893]="0:4:3:1:Ring::1:0:", -- Zanzil's Seal
	[19894]="0:4:3:1:Plate::1:0:", -- Bloodsoaked Gauntlets
	[19895]="0:4:3:1:Cloth::1:0:", -- Bloodtinged Kilt
	[19896]="0:2:4:1:FistWeapon::1:0:", -- Thekal's Grasp
	[19897]="0:4:4:1:Cloth::1:0:", -- Betrayer's Boots
	[19898]="0:4:3:1:Ring::1:0:", -- Seal of Jin
	[19899]="0:4:3:1:Cloth::1:0:", -- Ritualistic Legguards
	[19900]="0:2:3:1:TwoHandAxe::1:0:", -- Zulian Stone Axe
	[19901]="0:2:3:1:OneHandSword::1:0:", -- Zulian Slicer
	[19902]="0:15:4:1:Mount::1:0:", -- Swift Zulian Tiger
	[19903]="0:2:4:1:Dagger::1:0:", -- Fang of Venoxis
	[19904]="0:4:4:1:Mail::1:0:", -- Runed Bloodstained Hauberk
	[19905]="0:4:3:1:Ring::1:0:", -- Zanzil's Band
	[19906]="0:4:3:1:Leather::1:0:", -- Blooddrenched Footpads
	[19907]="0:4:3:1:Cloak::1:0:", -- Zulian Tigerhide Cloak
	[19908]="0:2:3:1:OneHandMace::1:0:", -- Sceptre of Smiting
	[19909]="0:2:4:1:Stave::1:0:", -- Will of Arlokk
	[19910]="0:2:4:1:FistWeapon::1:0:", -- Arlokk's Grasp
	[19911]="0:15:1:5:Junk::1:0:", -- Whipweed Heart
	[19912]="0:4:3:1:Ring::1:0:", -- Overlord's Onyx Band
	[19913]="0:4:3:1:Plate::1:0:", -- Bloodsoaked Greaves
	[19914]="0:1:3:1:Bag::1:0:", -- Panther Hide Sack
	[19915]="0:4:3:1:Shield::1:0:", -- Zulian Defender
	[19918]="0:2:4:1:TwoHandMace::1:0:", -- Jeklik's Crusher
	[19919]="0:4:3:1:Mail::1:0:", -- Bloodstained Greaves
	[19920]="0:4:3:1:Ring::1:0:", -- Primalist's Band
	[19921]="0:2:3:1:OneHandAxe::1:0:", -- Zulian Hacker
	[19922]="0:4:3:1:OffHandFrill::1:0:", -- Arlokk's Hoodoo Stick
	[19923]="0:4:3:1:Amulet::1:0:", -- Jeklik's Opaline Talisman
	[19925]="0:4:3:1:Ring::1:0:", -- Band of Jin
	[19927]="0:2:4:1:Wand::1:0:", -- Mar'li's Touch
	[19928]="0:4:3:1:Leather::1:0:", -- Animist's Spaulders
	[19929]="0:4:3:1:Cloth::1:0:", -- Bloodtinged Gloves
	[19930]="0:4:3:1:Trinket::1:0:", -- Mar'li's Eye
	[19931]="0:12:3:20:::1:0:", -- Gurubashi Mojo Madness
	[19933]="0:15:1:10:Junk::1:0:", -- Glowing Scorpid Blood
	[19934]="0:15:0:10:Junk::1:0:", -- Large Scorpid Claw
	[19935]="0:15:0:10:Junk::1:0:", -- Empty Venom Sac
	[19936]="0:15:0:10:Junk::1:0:", -- Dried Scorpid Carapace
	[19937]="0:15:0:10:Junk::1:0:", -- Small Scorpid Claw
	[19938]="0:15:0:10:Junk::1:0:", -- Heavy Scorpid Leg
	[19939]="0:12:2:1:::1:0:", -- Gri'lek's Blood
	[19940]="0:12:2:1:::1:0:", -- Renataki's Tooth
	[19941]="0:12:2:1:::1:0:", -- Wushoolay's Mane
	[19942]="0:12:2:1:::1:0:", -- Hazza'rah's Dream Thread
	[19943]="0:7:1:20:Other:171:1:0:", -- Massive Mojo
	[19944]="0:2:4:1:Stave::1:0:", -- Nat Pagle's Fish Terminator
	[19945]="0:4:4:1:Leather::1:0:", -- Foror's Eyepatch
	[19946]="0:2:3:1:Polearm::1:0:", -- Tigule's Harpoon
	[19947]="0:4:3:1:Trinket::1:0:", -- Nat Pagle's Broken Reel
	[19948]="0:4:4:1:Trinket::1:0:", -- Zandalarian Hero Badge
	[19949]="0:4:4:1:Trinket::1:0:", -- Zandalarian Hero Medallion
	[19950]="0:4:4:1:Trinket::1:0:", -- Zandalarian Hero Charm
	[19951]="0:4:4:1:Trinket::1:0:", -- Gri'lek's Charm of Might
	[19952]="0:4:4:1:Trinket::1:0:", -- Gri'lek's Charm of Valor
	[19953]="0:4:4:1:Trinket::1:0:", -- Renataki's Charm of Beasts
	[19954]="0:4:4:1:Trinket::1:0:", -- Renataki's Charm of Trickery
	[19955]="0:4:4:1:Trinket::1:0:", -- Wushoolay's Charm of Nature
	[19956]="0:4:4:1:Trinket::1:0:", -- Wushoolay's Charm of Spirits
	[19957]="0:4:4:1:Trinket::1:0:", -- Hazza'rah's Charm of Destruction
	[19958]="0:4:4:1:Trinket::1:0:", -- Hazza'rah's Charm of Healing
	[19959]="0:4:4:1:Trinket::1:0:", -- Hazza'rah's Charm of Magic
	[19960]="0:12:1:1:::1:0:", -- Crystalized Honey
	[19961]="0:2:3:1:OneHandMace::1:0:", -- Gri'lek's Grinder
	[19962]="0:2:3:1:TwoHandAxe::1:0:", -- Gri'lek's Carver
	[19963]="0:2:3:1:Polearm::1:0:", -- Pitchfork of Madness
	[19964]="0:2:3:1:OneHandSword::1:0:", -- Renataki's Soul Conduit
	[19965]="0:2:3:1:Dagger::1:0:", -- Wushoolay's Poker
	[19967]="0:2:3:1:Wand::1:0:", -- Thoughtblighter
	[19968]="0:2:3:1:OneHandSword::1:0:", -- Fiery Retributer
	[19969]="0:4:2:1:Cloth::1:0:", -- Nat Pagle's Extreme Anglin' Boots
	[19970]="0:2:3:1:FishingPole::1:0:", -- Arcanite Fishing Pole
	[19971]="0:0:2:5:EnhPerm::1:0:", -- High Test Eternium Fishing Line
	[19972]="0:4:2:1:Cloth::1:0:", -- Lucky Fishing Hat
	[19973]="0:12:1:1:::1:0:", -- Nat's Measuring Tape
	[19974]="10000:12:1:20:::1:0:12919", -- Mudskunk Lure
	[19975]="0:12:1:20:::1:0:", -- Zulian Mudskunk
	[19978]="0:15:1:1:Junk::1:0:", -- Fishing Tournament!
	[19979]="0:4:3:1:Trinket::1:0:", -- Hook of the Master Angler
	[19982]="0:4:3:1:Cloak::1:0:", -- Duskbat Drape
	[19984]="0:4:3:1:Leather::1:0:", -- Ebon Mask
	[19990]="0:4:3:1:Trinket::1:0:", -- Blessed Prayer Beads
	[19991]="0:4:3:1:Trinket::1:0:", -- Devilsaur Eye
	[19992]="0:4:3:1:Trinket::1:0:", -- Devilsaur Tooth
	[19993]="0:2:3:1:Bow::1:0:", -- Hoodoo Hunting Bow
	[19994]="0:0:1:20:FoodDrink::1:0:", -- Harvest Fruit
	[19995]="0:0:1:20:FoodDrink::1:0:", -- Harvest Boar
	[19996]="0:0:1:20:FoodDrink::1:0:", -- Harvest Fish
	[19997]="0:0:1:20:Consumable::1:0:", -- Harvest Nectar
	[19998]="0:4:3:1:Leather::1:0:", -- Bloodvine Lens
	[19999]="0:4:3:1:Cloth::1:0:", -- Bloodvine Goggles
	[20000]="120000:9:1:1:Engineering::1:0:14921", -- Schematic: Bloodvine Goggles
	[20001]="50000:9:1:1:Engineering::1:0:14921", -- Schematic: Bloodvine Lens
	[20002]="0:0:1:20:Potion::1:0:", -- Greater Dreamless Sleep Potion
	[20004]="0:0:1:20:Elixir::1:0:", -- Mighty Troll's Blood Elixir
	[20006]="0:4:3:1:Ring::1:0:", -- Circle of Hope
	[20007]="0:0:1:20:Elixir::1:0:", -- Mageblood Elixir
	[20008]="0:0:1:20:Potion::1:0:", -- Living Action Potion
	[20009]="0:12:1:1:::1:0:", -- For the Light!
	[20010]="0:12:1:1:::1:0:", -- The Horde's Hellscream
	[20011]="50000:9:1:1:Alchemy::1:0:14921", -- Recipe: Mageblood Elixir
	[20012]="50000:9:1:1:Alchemy::1:0:14921", -- Recipe: Greater Dreamless Sleep Potion
	[20013]="50000:9:1:1:Alchemy::1:0:14921", -- Recipe: Living Action Potion
	[20014]="50000:9:1:1:Alchemy::1:0:14921", -- Recipe: Mighty Troll's Blood Elixir
	[20015]="0:15:0:10:Junk::1:0:", -- Elder Raptor Feathers
	[20016]="0:15:0:1:Junk::1:0:", -- Trophy Raptor Skull
	[20017]="0:15:1:5:Junk::1:0:", -- Perfect Courser Antler
	[20018]="0:12:1:20:::1:0:", -- Angerclaw Grizzly Hide
	[20019]="0:15:1:1:Junk::1:0:", -- Tooth of Morphaz
	[20021]="0:12:1:40:::1:0:", -- Gold Pirate Earring
	[20022]="0:13:1:1:::1:0:", -- Azure Key
	[20023]="0:12:1:20:::1:0:", -- Encoded Fragment
	[20025]="0:12:1:1:::1:0:", -- Blood of Morphaz
	[20027]="0:12:1:10:::1:0:", -- Healthy Courser Gland
	[20028]="0:12:1:20:::1:0:", -- Glittering Dust
	[20029]="0:12:1:20:::1:0:", -- Enchanted Coral
	[20030]="0:15:0:1:Junk::1:0:", -- Pet Rock
	[20031]="0:0:1:20:FoodDrink::1:0:", -- Essence Mango
	[20032]="0:4:4:1:Cloth::1:0:", -- Flowing Ritual Robes
	[20033]="0:4:4:1:Cloth::1:0:", -- Zandalar Demoniac's Robe
	[20034]="0:4:4:1:Cloth::1:0:", -- Zandalar Illusionist's Robe
	[20035]="0:2:3:1:Dagger::1:0:", -- Glacial Spike
	[20036]="0:4:3:1:Trinket::1:0:", -- Fire Ruby
	[20037]="0:4:3:1:Amulet::1:0:", -- Arcane Crystal Pendant
	[20038]="0:2:4:1:Bow::1:0:", -- Mandokir's Sting
	[20039]="0:4:4:1:Plate::1:0:", -- Dark Iron Boots
	[20040]="80000:9:1:1:Blacksmithing::1:0:12944", -- Plans: Dark Iron Boots
	[20041]="0:4:3:1:Plate::1:0:", -- Highlander's Plate Girdle
	[20042]="0:4:3:1:Plate::1:0:", -- Highlander's Lamellar Girdle
	[20043]="0:4:3:1:Mail::1:0:", -- Highlander's Chain Girdle
	[20044]="0:4:3:1:Mail::1:0:", -- Highlander's Mail Girdle
	[20045]="0:4:3:1:Leather::1:0:", -- Highlander's Leather Girdle
	[20046]="0:4:3:1:Leather::1:0:", -- Highlander's Lizardhide Girdle
	[20047]="0:4:3:1:Cloth::1:0:", -- Highlander's Cloth Girdle
	[20048]="0:4:3:1:Plate::1:0:", -- Highlander's Plate Greaves
	[20049]="0:4:3:1:Plate::1:0:", -- Highlander's Lamellar Greaves
	[20050]="0:4:3:1:Mail::1:0:", -- Highlander's Chain Greaves
	[20051]="0:4:3:1:Mail::1:0:", -- Highlander's Mail Greaves
	[20052]="0:4:3:1:Leather::1:0:", -- Highlander's Leather Boots
	[20053]="0:4:3:1:Leather::1:0:", -- Highlander's Lizardhide Boots
	[20054]="0:4:3:1:Cloth::1:0:", -- Highlander's Cloth Boots
	[20055]="0:4:4:1:Mail::1:0:", -- Highlander's Chain Pauldrons
	[20056]="0:4:4:1:Mail::1:0:", -- Highlander's Mail Pauldrons
	[20057]="0:4:4:1:Plate::1:0:", -- Highlander's Plate Spaulders
	[20058]="0:4:4:1:Plate::1:0:", -- Highlander's Lamellar Spaulders
	[20059]="0:4:4:1:Leather::1:0:", -- Highlander's Leather Shoulders
	[20060]="0:4:4:1:Leather::1:0:", -- Highlander's Lizardhide Shoulders
	[20061]="0:4:4:1:Cloth::1:0:", -- Highlander's Epaulets
	[20062]="0:0:1:20:Consumable::1:0:", -- Arathi Basin Enriched Ration
	[20063]="0:0:1:20:Consumable::1:0:", -- Arathi Basin Field Ration
	[20064]="0:0:1:20:Consumable::1:0:", -- Arathi Basin Iron Ration
	[20065]="0:0:1:20:Bandage::1:0:", -- Arathi Basin Mageweave Bandage
	[20066]="0:0:1:20:Bandage::1:0:", -- Arathi Basin Runecloth Bandage
	[20067]="0:0:1:20:Bandage::1:0:", -- Arathi Basin Silk Bandage
	[20068]="0:4:4:1:Cloak::1:0:", -- Deathguard's Cloak
	[20069]="0:2:4:1:Stave::1:0:", -- Ironbark Staff
	[20070]="0:2:4:1:Dagger::1:0:", -- Sageclaw
	[20071]="0:4:3:1:Trinket::1:0:", -- Talisman of Arathor
	[20072]="0:4:3:1:Trinket::1:0:", -- Defiler's Talisman
	[20073]="0:4:4:1:Cloak::1:0:", -- Cloak of the Honor Guard
	[20074]="0:0:1:20:FoodDrink::1:0:", -- Heavy Crocolisk Stew
	[20075]="2000:9:1:1:Cooking::1:0:4879", -- Recipe: Heavy Crocolisk Stew
	[20076]="0:0:3:1:EnhPerm::1:0:", -- Zandalar Signet of Mojo
	[20077]="0:0:3:1:EnhPerm::1:0:", -- Zandalar Signet of Might
	[20078]="0:0:3:1:EnhPerm::1:0:", -- Zandalar Signet of Serenity
	[20079]="0:0:2:1:Elixir::1:0:", -- Spirit of Zanza
	[20080]="0:0:2:1:Elixir::1:0:", -- Sheen of Zanza
	[20081]="0:0:2:1:Elixir::1:0:", -- Swiftness of Zanza
	[20082]="0:2:3:1:Wand::1:0:", -- Woestave
	[20083]="0:2:3:1:Polearm::1:0:", -- Hunting Spear
	[20085]="0:15:1:1:Junk::1:0:", -- Arcane Shard
	[20086]="0:15:2:200:Junk::1:0:", -- Broken Dusksteel Throwing Knife
	[20087]="0:15:1:20:Junk::1:0:", -- Wavethrasher Scales
	[20088]="0:4:3:1:Mail::1:0:", -- Highlander's Chain Girdle
	[20089]="0:4:3:1:Mail::1:0:", -- Highlander's Chain Girdle
	[20090]="0:4:3:1:Leather::1:0:", -- Highlander's Padded Girdle
	[20091]="0:4:3:1:Mail::1:0:", -- Highlander's Chain Greaves
	[20092]="0:4:3:1:Mail::1:0:", -- Highlander's Chain Greaves
	[20093]="0:4:3:1:Leather::1:0:", -- Highlander's Padded Greaves
	[20094]="0:4:3:1:Cloth::1:0:", -- Highlander's Cloth Boots
	[20095]="0:4:3:1:Cloth::1:0:", -- Highlander's Cloth Boots
	[20096]="0:4:3:1:Cloth::1:0:", -- Highlander's Cloth Boots
	[20097]="0:4:3:1:Cloth::1:0:", -- Highlander's Cloth Girdle
	[20098]="0:4:3:1:Cloth::1:0:", -- Highlander's Cloth Girdle
	[20099]="0:4:3:1:Cloth::1:0:", -- Highlander's Cloth Girdle
	[20100]="0:4:3:1:Leather::1:0:", -- Highlander's Lizardhide Boots
	[20101]="0:4:3:1:Leather::1:0:", -- Highlander's Lizardhide Boots
	[20102]="0:4:3:1:Leather::1:0:", -- Highlander's Lizardhide Boots
	[20103]="0:4:3:1:Leather::1:0:", -- Highlander's Lizardhide Girdle
	[20104]="0:4:3:1:Leather::1:0:", -- Highlander's Lizardhide Girdle
	[20105]="0:4:3:1:Leather::1:0:", -- Highlander's Lizardhide Girdle
	[20106]="0:4:3:1:Plate::1:0:", -- Highlander's Lamellar Girdle
	[20107]="0:4:3:1:Plate::1:0:", -- Highlander's Lamellar Girdle
	[20108]="0:4:3:1:Mail::1:0:", -- Highlander's Lamellar Girdle
	[20109]="0:4:3:1:Plate::1:0:", -- Highlander's Lamellar Greaves
	[20110]="0:4:3:1:Plate::1:0:", -- Highlander's Lamellar Greaves
	[20111]="0:4:3:1:Mail::1:0:", -- Highlander's Lamellar Greaves
	[20112]="0:4:3:1:Leather::1:0:", -- Highlander's Leather Boots
	[20113]="0:4:3:1:Leather::1:0:", -- Highlander's Leather Boots
	[20114]="0:4:3:1:Leather::1:0:", -- Highlander's Leather Boots
	[20115]="0:4:3:1:Leather::1:0:", -- Highlander's Leather Girdle
	[20116]="0:4:3:1:Leather::1:0:", -- Highlander's Leather Girdle
	[20117]="0:4:3:1:Leather::1:0:", -- Highlander's Leather Girdle
	[20118]="0:4:3:1:Mail::1:0:", -- Highlander's Mail Girdle
	[20119]="0:4:3:1:Mail::1:0:", -- Highlander's Mail Girdle
	[20120]="0:4:3:1:Leather::1:0:", -- Highlander's Mail Girdle
	[20121]="0:4:3:1:Mail::1:0:", -- Highlander's Mail Greaves
	[20122]="0:4:3:1:Mail::1:0:", -- Highlander's Mail Greaves
	[20123]="0:4:3:1:Leather::1:0:", -- Highlander's Mail Greaves
	[20124]="0:4:3:1:Plate::1:0:", -- Highlander's Plate Girdle
	[20125]="0:4:3:1:Plate::1:0:", -- Highlander's Plate Girdle
	[20126]="0:4:3:1:Mail::1:0:", -- Highlander's Mail Girdle
	[20127]="0:4:3:1:Plate::1:0:", -- Highlander's Plate Greaves
	[20128]="0:4:3:1:Plate::1:0:", -- Highlander's Plate Greaves
	[20129]="0:4:3:1:Mail::1:0:", -- Highlander's Mail Greaves
	[20130]="0:4:3:1:Trinket::1:0:", -- Diamond Flask
	[20131]="0:4:1:1:Tabard::1:0:", -- Battle Tabard of the Defilers
	[20132]="0:4:1:1:Tabard::1:0:", -- Arathor Battle Tabard
	[20134]="0:4:4:1:Mail::1:0:", -- Skyfury Helm
	[20150]="0:4:3:1:Mail::1:0:", -- Defiler's Chain Girdle
	[20151]="0:4:3:1:Mail::1:0:", -- Defiler's Chain Girdle
	[20152]="0:4:3:1:Leather::1:0:", -- Defiler's Chain Girdle
	[20153]="0:4:3:1:Mail::1:0:", -- Defiler's Chain Girdle
	[20154]="0:4:3:1:Mail::1:0:", -- Defiler's Chain Greaves
	[20155]="0:4:3:1:Mail::1:0:", -- Defiler's Chain Greaves
	[20156]="0:4:3:1:Mail::1:0:", -- Defiler's Chain Greaves
	[20157]="0:4:3:1:Leather::1:0:", -- Defiler's Chain Greaves
	[20158]="0:4:4:1:Mail::1:0:", -- Defiler's Chain Pauldrons
	[20159]="0:4:3:1:Cloth::1:0:", -- Defiler's Cloth Boots
	[20160]="0:4:3:1:Cloth::1:0:", -- Defiler's Cloth Boots
	[20161]="0:4:3:1:Cloth::1:0:", -- Defiler's Cloth Boots
	[20162]="0:4:3:1:Cloth::1:0:", -- Defiler's Cloth Boots
	[20163]="0:4:3:1:Cloth::1:0:", -- Defiler's Cloth Girdle
	[20164]="0:4:3:1:Cloth::1:0:", -- Defiler's Cloth Girdle
	[20165]="0:4:3:1:Cloth::1:0:", -- Defiler's Cloth Girdle
	[20166]="0:4:3:1:Cloth::1:0:", -- Defiler's Cloth Girdle
	[20167]="0:4:3:1:Leather::1:0:", -- Defiler's Lizardhide Boots
	[20168]="0:4:3:1:Leather::1:0:", -- Defiler's Lizardhide Boots
	[20169]="0:4:3:1:Leather::1:0:", -- Defiler's Lizardhide Boots
	[20170]="0:4:3:1:Leather::1:0:", -- Defiler's Lizardhide Boots
	[20171]="0:4:3:1:Leather::1:0:", -- Defiler's Lizardhide Girdle
	[20172]="0:4:3:1:Leather::1:0:", -- Defiler's Lizardhide Girdle
	[20173]="0:4:3:1:Leather::1:0:", -- Defiler's Lizardhide Girdle
	[20174]="0:4:3:1:Leather::1:0:", -- Defiler's Lizardhide Girdle
	[20175]="0:4:4:1:Leather::1:0:", -- Defiler's Lizardhide Shoulders
	[20176]="0:4:4:1:Cloth::1:0:", -- Defiler's Epaulets
	[20177]="0:4:3:1:Plate::1:0:", -- Defiler's Lamellar Girdle
	[20178]="0:4:3:1:Mail::1:0:", -- Defiler's Lamellar Girdle
	[20179]="0:4:3:1:Plate::1:0:", -- Defiler's Lamellar Girdle
	[20180]="0:4:3:1:Plate::1:0:", -- Defiler's Lamellar Girdle
	[20181]="0:4:3:1:Plate::1:0:", -- Defiler's Lamellar Greaves
	[20182]="0:4:3:1:Mail::1:0:", -- Defiler's Lamellar Greaves
	[20183]="0:4:3:1:Plate::1:0:", -- Defiler's Lamellar Greaves
	[20184]="0:4:4:1:Plate::1:0:", -- Defiler's Lamellar Spaulders
	[20185]="0:4:3:1:Plate::1:0:", -- Defiler's Lamellar Greaves
	[20186]="0:4:3:1:Leather::1:0:", -- Defiler's Leather Boots
	[20187]="0:4:3:1:Leather::1:0:", -- Defiler's Leather Boots
	[20188]="0:4:3:1:Leather::1:0:", -- Defiler's Leather Boots
	[20189]="0:4:3:1:Leather::1:0:", -- Defiler's Leather Boots
	[20190]="0:4:3:1:Leather::1:0:", -- Defiler's Leather Girdle
	[20191]="0:4:3:1:Leather::1:0:", -- Defiler's Leather Girdle
	[20192]="0:4:3:1:Leather::1:0:", -- Defiler's Leather Girdle
	[20193]="0:4:3:1:Leather::1:0:", -- Defiler's Leather Girdle
	[20194]="0:4:4:1:Leather::1:0:", -- Defiler's Leather Shoulders
	[20195]="0:4:3:1:Mail::1:0:", -- Defiler's Mail Girdle
	[20196]="0:4:3:1:Mail::1:0:", -- Defiler's Mail Girdle
	[20197]="0:4:3:1:Leather::1:0:", -- Defiler's Padded Girdle
	[20198]="0:4:3:1:Mail::1:0:", -- Defiler's Mail Girdle
	[20199]="0:4:3:1:Mail::1:0:", -- Defiler's Mail Greaves
	[20200]="0:4:3:1:Mail::1:0:", -- Defiler's Mail Greaves
	[20201]="0:4:3:1:Leather::1:0:", -- Defiler's Mail Greaves
	[20202]="0:4:3:1:Mail::1:0:", -- Defiler's Mail Greaves
	[20203]="0:4:4:1:Mail::1:0:", -- Defiler's Mail Pauldrons
	[20204]="0:4:3:1:Plate::1:0:", -- Defiler's Plate Girdle
	[20205]="0:4:3:1:Plate::1:0:", -- Defiler's Plate Girdle
	[20206]="0:4:3:1:Plate::1:0:", -- Defiler's Plate Girdle
	[20207]="0:4:3:1:Mail::1:0:", -- Defiler's Mail Girdle
	[20208]="0:4:3:1:Plate::1:0:", -- Defiler's Plate Greaves
	[20209]="0:4:3:1:Plate::1:0:", -- Defiler's Plate Greaves
	[20210]="0:4:3:1:Mail::1:0:", -- Defiler's Mail Greaves
	[20211]="0:4:3:1:Plate::1:0:", -- Defiler's Plate Greaves
	[20212]="0:4:4:1:Plate::1:0:", -- Defiler's Plate Spaulders
	[20213]="0:4:3:1:Plate::1:0:", -- Belt of Shrunken Heads
	[20214]="0:2:4:1:Dagger::1:0:", -- Mindfang
	[20215]="0:4:3:1:Mail::1:0:", -- Belt of Shriveled Heads
	[20216]="0:4:3:1:Leather::1:0:", -- Belt of Preserved Heads
	[20217]="0:4:3:1:Cloth::1:0:", -- Belt of Tiny Heads
	[20218]="0:4:3:1:Cloak::1:0:", -- Faded Hakkari Cloak
	[20219]="0:4:3:1:Cloak::1:0:", -- Tattered Hakkari Cape
	[20220]="0:2:4:1:Stave::1:0:", -- Ironbark Staff
	[20222]="2000:0:1:20:Consumable::5:0:15126", -- Defiler's Enriched Ration
	[20223]="1000:0:1:20:Consumable::5:0:15126", -- Defiler's Field Ration
	[20224]="1500:0:1:20:Consumable::5:0:15126", -- Defiler's Iron Ration
	[20225]="2000:0:1:20:Consumable::5:0:15127", -- Highlander's Enriched Ration
	[20226]="1000:0:1:20:Consumable::5:0:15127", -- Highlander's Field Ration
	[20227]="1500:0:1:20:Consumable::5:0:15127", -- Highlander's Iron Ration
	[20228]="0:0:1:1:Consumable::1:0:", -- Defiler's Advanced Care Package
	[20229]="0:0:1:1:Consumable::1:0:", -- Defiler's Basic Care Package
	[20230]="0:0:1:1:Consumable::1:0:", -- Defiler's Standard Care Package
	[20231]="0:0:1:1:Consumable::1:0:", -- Arathor Advanced Care Package
	[20232]="1500:0:1:20:Bandage::5:0:15126", -- Defiler's Mageweave Bandage
	[20233]="0:0:1:1:Consumable::1:0:", -- Arathor Basic Care Package
	[20234]="2000:0:1:20:Bandage::5:0:15126", -- Defiler's Runecloth Bandage
	[20235]="1000:0:1:20:Bandage::5:0:15126", -- Defiler's Silk Bandage
	[20236]="0:0:1:1:Consumable::1:0:", -- Arathor Standard Care Package
	[20237]="1500:0:1:20:Bandage::5:0:15127", -- Highlander's Mageweave Bandage
	[20243]="2000:0:1:20:Bandage::5:0:15127", -- Highlander's Runecloth Bandage
	[20244]="1000:0:1:20:Bandage::5:0:15127", -- Highlander's Silk Bandage
	[20253]="16000:9:1:1:Leatherworking::1:0:11557", -- Pattern: Warbear Harness
	[20254]="20000:9:1:1:Leatherworking::1:0:11557", -- Pattern: Warbear Woolies
	[20255]="0:4:3:1:Leather::1:0:", -- Whisperwalk Boots
	[20256]="0:12:2:250:::1:0:", -- Warsong Gulch Ribbon of Sacrifice
	[20257]="0:4:4:1:Mail::1:0:", -- Seafury Gauntlets
	[20258]="0:2:3:1:Stave::1:0:", -- Zulian Ceremonial Staff
	[20259]="0:4:3:1:Leather::1:0:", -- Shadow Panther Hide Gloves
	[20260]="0:4:3:1:Mail::1:0:", -- Seafury Leggings
	[20261]="0:4:3:1:Leather::1:0:", -- Shadow Panther Hide Belt
	[20262]="0:4:3:1:Mail::1:0:", -- Seafury Boots
	[20263]="0:4:3:1:Plate::1:0:", -- Gurubashi Helm
	[20264]="0:4:4:1:Plate::1:0:", -- Peacekeeper Gauntlets
	[20265]="0:4:3:1:Plate::1:0:", -- Peacekeeper Boots
	[20266]="0:4:3:1:Plate::1:0:", -- Peacekeeper Leggings
	[20295]="0:4:3:1:Mail::1:0:", -- Blue Dragonscale Leggings
	[20296]="0:4:3:1:Mail::1:0:", -- Green Dragonscale Gauntlets
	[20310]="0:12:1:1:::1:0:", -- Flayed Demon Skin
	[20369]="0:4:3:1:Mail::1:0:", -- Azurite Fists
	[20371]="0:15:3:1:Companion::1:0:", -- Blue Murloc Egg
	[20373]="0:12:1:20:::1:0:", -- Stonelash Scorpid Stinger
	[20374]="0:12:1:20:::1:0:", -- Stonelash Pincer Stinger
	[20375]="0:12:1:20:::1:0:", -- Stonelash Flayer Stinger
	[20376]="0:12:1:20:::1:0:", -- Sand Skitterer Fang
	[20377]="0:12:1:20:::1:0:", -- Rock Stalker Fang
	[20378]="0:12:1:20:::1:0:", -- Twilight Tablet Fragment
	[20379]="0:12:1:1:::1:0:", -- Noggle's Satchel
	[20380]="0:4:4:1:Mail::1:0:", -- Dreamscale Breastplate
	[20381]="0:7:2:20:Leather:165:1:0:", -- Dreamscale
	[20382]="60000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Dreamscale Breastplate
	[20383]="0:12:1:1:::1:0:", -- Head of the Broodlord Lashlayer
	[20384]="0:12:1:200:::1:0:", -- Silithid Carapace Fragment
	[20385]="0:12:1:1:::1:0:", -- Deathclasp's Pincer
	[20387]="1000:12:1:1:::1:0:15197", -- Forsaken Stink Bomb Cluster
	[20388]="0:0:1:20:Consumable::1:0:", -- Lollipop
	[20389]="0:0:1:20:Consumable::1:0:", -- Candy Corn
	[20390]="0:0:1:20:Consumable::1:0:", -- Candy Bar
	[20391]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Gnome Mask
	[20392]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Gnome Mask
	[20393]="0:15:1:1:Junk::1:0:", -- Treat Bag
	[20394]="0:12:1:1:::1:0:", -- Twilight Lexicon - Chapter 1
	[20395]="0:12:1:1:::1:0:", -- Twilight Lexicon - Chapter 2
	[20396]="0:12:1:1:::1:0:", -- Twilight Lexicon - Chapter 3
	[20397]="0:0:1:1:Consumable::1:0:", -- Hallowed Wand - Pirate
	[20398]="0:0:1:1:Consumable::1:0:", -- Hallowed Wand - Ninja
	[20399]="0:0:1:1:Consumable::1:0:", -- Hallowed Wand - Leper Gnome
	[20400]="0:1:2:1:Bag::1:0:", -- Pumpkin Bag
	[20401]="0:12:1:1:::1:0:", -- Restored Twilight Tablet
	[20402]="0:15:2:1:Junk::1:0:", -- Agent of Nozdormu
	[20403]="0:15:2:1:Junk::1:0:", -- Proxy of Nozdormu
	[20404]="0:12:1:250:::1:0:", -- Encrypted Twilight Text
	[20405]="0:12:1:1:::1:0:", -- Decoded Tablet Transcription
	[20406]="0:4:2:1:Cloth::1:0:", -- Twilight Cultist Mantle
	[20407]="0:4:2:1:Cloth::1:0:", -- Twilight Cultist Robe
	[20408]="0:4:2:1:Cloth::1:0:", -- Twilight Cultist Cowl
	[20409]="0:0:1:1:Consumable::1:0:", -- Hallowed Wand - Ghost
	[20410]="0:0:1:1:Consumable::1:0:", -- Hallowed Wand - Bat
	[20411]="0:0:1:1:Consumable::1:0:", -- Hallowed Wand - Skeleton
	[20413]="0:0:1:1:Consumable::1:0:", -- Hallowed Wand - Random
	[20414]="0:0:1:1:Consumable::1:0:", -- Hallowed Wand - Wisp
	[20415]="0:15:1:1:Junk::1:0:", -- The War of the Shifting Sands
	[20416]="0:12:1:20:::1:0:", -- Crest of Beckoning: Fire
	[20418]="0:12:1:20:::1:0:", -- Crest of Beckoning: Thunder
	[20419]="0:12:1:20:::1:0:", -- Crest of Beckoning: Earth
	[20420]="0:12:1:20:::1:0:", -- Crest of Beckoning: Water
	[20422]="0:4:1:1:Amulet::1:0:", -- Twilight Cultist Medallion of Station
	[20424]="0:7:1:20:Meat:185:1:0:", -- Sandworm Meat
	[20425]="0:2:3:1:Stave::1:0:", -- Advisor's Gnarled Staff
	[20426]="0:4:3:1:Ring::1:0:", -- Advisor's Ring
	[20427]="0:4:3:1:Cloak::1:0:", -- Battle Healer's Cloak
	[20428]="0:4:3:1:Cloak::1:0:", -- Caretaker's Cape
	[20429]="0:4:3:1:Ring::1:0:", -- Legionnaire's Band
	[20430]="0:2:3:1:OneHandSword::1:0:", -- Legionnaire's Sword
	[20431]="0:4:3:1:Ring::1:0:", -- Lorekeeper's Ring
	[20432]="0:12:1:20:::1:0:", -- Signet of Beckoning: Fire
	[20433]="0:12:1:20:::1:0:", -- Signet of Beckoning: Thunder
	[20434]="0:2:3:1:Stave::1:0:", -- Lorekeeper's Staff
	[20435]="0:12:1:20:::1:0:", -- Signet of Beckoning: Stone
	[20436]="0:12:1:20:::1:0:", -- Signet of Beckoning: Water
	[20437]="0:2:3:1:Bow::1:0:", -- Outrider's Bow
	[20438]="0:2:3:1:Bow::1:0:", -- Outrunner's Bow
	[20439]="0:4:3:1:Ring::1:0:", -- Protector's Band
	[20440]="0:2:3:1:OneHandSword::1:0:", -- Protector's Sword
	[20441]="0:2:3:1:Dagger::1:0:", -- Scout's Blade
	[20442]="0:4:3:1:Amulet::1:0:", -- Scout's Medallion
	[20443]="0:2:3:1:Dagger::1:0:", -- Sentinel's Blade
	[20444]="0:4:3:1:Amulet::1:0:", -- Sentinel's Medallion
	[20447]="0:12:1:20:::1:0:", -- Scepter of Beckoning: Fire
	[20448]="0:12:1:20:::1:0:", -- Scepter of Beckoning: Thunder
	[20449]="0:12:1:20:::1:0:", -- Scepter of Beckoning: Stone
	[20450]="0:12:1:20:::1:0:", -- Scepter of Beckoning: Water
	[20451]="0:4:1:1:Ring::1:0:", -- Twilight Cultist Ring of Lordship
	[20452]="0:0:1:20:FoodDrink::1:0:", -- Smoked Desert Dumplings
	[20453]="0:12:1:1:::1:0:", -- Geologist's Transcription Kit
	[20454]="0:12:1:1:::1:0:", -- Hive'Zora Rubbing
	[20455]="0:12:1:1:::1:0:", -- Hive'Ashi Rubbing
	[20456]="0:12:1:1:::1:0:", -- Hive'Regal Rubbing
	[20457]="0:12:1:1:::1:0:", -- Hive'Ashi Silithid Brain
	[20458]="0:12:1:1:::1:0:", -- Hive'Zora Silithid Brain
	[20459]="0:12:1:1:::1:0:", -- Hive'Regal Silithid Brain
	[20461]="0:15:1:1:Junk::1:0:", -- Brann Bronzebeard's Lost Letter
	[20463]="0:12:1:1:::1:0:", -- Glyphed Crystal Prism
	[20464]="0:15:1:1:Junk::1:0:", -- Glyphs of Calling
	[20465]="0:12:1:1:::1:0:", -- Crystal Unlocking Mechanism
	[20466]="0:12:1:1:::1:0:", -- Vyral's Signet Ring
	[20467]="0:12:1:1:::1:0:", -- Torn Recipe Page
	[20469]="0:15:1:1:Junk::1:0:", -- Decoded True Believer Clippings
	[20470]="0:0:1:1:Consumable::1:0:", -- Solanian's Scrying Orb
	[20471]="0:0:1:1:Consumable::1:0:", -- Scroll of Scourge Magic
	[20472]="0:0:1:1:Consumable::1:0:", -- Solanian's Journal
	[20474]="0:1:1:1:Bag::1:0:", -- Sunstrider Book Satchel
	[20475]="0:0:1:1:Other::1:0:", -- Adamantite Arrow Maker
	[20476]="0:4:3:1:Mail::1:0:", -- Sandstalker Bracers
	[20477]="0:4:3:1:Mail::1:0:", -- Sandstalker Gauntlets
	[20478]="0:4:3:1:Mail::1:0:", -- Sandstalker Breastplate
	[20479]="0:4:3:1:Mail::1:0:", -- Spitfire Breastplate
	[20480]="0:4:3:1:Mail::1:0:", -- Spitfire Gauntlets
	[20481]="0:4:3:1:Mail::1:0:", -- Spitfire Bracers
	[20482]="0:12:1:20:::1:0:", -- Arcane Sliver
	[20483]="0:15:1:1:Junk::1:0:", -- Tainted Arcane Sliver
	[20490]="0:12:1:1:::1:0:", -- Ironforge Mint
	[20491]="0:12:1:1:::1:0:", -- Undercity Mint
	[20492]="0:12:1:1:::1:0:", -- Stormwind Nougat
	[20493]="0:12:1:1:::1:0:", -- Orgrimmar Nougat
	[20494]="0:12:1:1:::1:0:", -- Gnomeregan Gumdrop
	[20495]="0:12:1:1:::1:0:", -- Darkspear Gumdrop
	[20496]="0:12:1:1:::1:0:", -- Darnassus Marzipan
	[20497]="0:12:1:1:::1:0:", -- Thunder Bluff Marzipan
	[20498]="0:7:1:20:Leather:165:1:0:", -- Silithid Chitin
	[20499]="0:15:0:20:Junk::1:0:", -- Broken Silithid Chitin
	[20500]="0:7:1:20:Leather:165:1:0:", -- Light Silithid Carapace
	[20501]="0:7:1:20:Leather:165:1:0:", -- Heavy Silithid Carapace
	[20503]="0:4:3:1:Trinket::1:0:", -- Enamored Water Spirit
	[20504]="0:2:3:1:TwoHandSword::1:0:", -- Lightforged Blade
	[20505]="0:4:3:1:Ring::1:0:", -- Chivalrous Signet
	[20506]="40000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Spitfire Bracers
	[20507]="40000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Spitfire Gauntlets
	[20508]="40000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Spitfire Breastplate
	[20509]="40000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Sandstalker Bracers
	[20510]="40000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Sandstalker Gauntlets
	[20511]="40000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Sandstalker Breastplate
	[20512]="0:4:3:1:Trinket::1:0:", -- Sanctified Orb
	[20513]="0:12:2:20:::1:0:", -- Abyssal Crest
	[20514]="0:12:3:20:::1:0:", -- Abyssal Signet
	[20515]="0:12:4:20:::1:0:", -- Abyssal Scepter
	[20516]="0:0:1:5:FoodDrink::1:0:", -- Bobbing Apple
	[20517]="0:4:3:1:Plate::1:0:", -- Razorsteel Shoulders
	[20518]="0:12:1:20:::1:0:", -- Scroll: Create Crest of Beckoning
	[20519]="0:12:1:20:::1:0:", -- Southsea Pirate Hat
	[20520]="0:7:2:20:Other:164,197:1:0:", -- Dark Rune
	[20521]="0:4:3:1:Plate::1:0:", -- Fury Visor
	[20526]="0:12:1:20:::1:0:", -- Scroll: Create Crest of Beckoning
	[20527]="0:12:1:20:::1:0:", -- Scroll: Create Crest of Beckoning
	[20528]="0:12:1:20:::1:0:", -- Scroll: Create Crest of Beckoning
	[20530]="0:4:3:1:Cloth::1:0:", -- Robes of Servitude
	[20531]="0:12:1:20:::1:0:", -- Scroll: Create Signet of Beckoning
	[20532]="0:12:1:20:::1:0:", -- Scroll: Create Signet of Beckoning
	[20533]="0:12:1:20:::1:0:", -- Scroll: Create Signet of Beckoning
	[20534]="0:4:3:1:Trinket::1:0:", -- Abyss Shard
	[20535]="0:12:1:20:::1:0:", -- Scroll: Create Signet of Beckoning
	[20536]="0:2:3:1:Stave::1:0:", -- Soul Harvester
	[20537]="0:4:3:1:Cloth::1:0:", -- Runed Stygian Boots
	[20538]="0:4:3:1:Cloth::1:0:", -- Runed Stygian Leggings
	[20539]="0:4:3:1:Cloth::1:0:", -- Runed Stygian Belt
	[20540]="0:12:1:20:::1:0:", -- Scroll: Create Scepter of Beckoning
	[20541]="0:12:1:20:::1:0:", -- Decoded Twilight Text
	[20542]="0:12:1:20:::1:0:", -- Scroll: Create Scepter of Beckoning
	[20543]="0:12:1:20:::1:0:", -- Scroll: Create Scepter of Beckoning
	[20544]="0:12:1:20:::1:0:", -- Scroll: Create Scepter of Beckoning
	[20545]="0:12:1:20:::1:0:", -- Decoded Twilight Text
	[20546]="0:9:3:1:Tailoring::1:0:", -- Pattern: Runed Stygian Leggings
	[20547]="0:9:3:1:Tailoring::1:0:", -- Pattern: Runed Stygian Boots
	[20548]="0:9:3:1:Tailoring::1:0:", -- Pattern: Runed Stygian Belt
	[20549]="0:4:3:1:Plate::1:0:", -- Darkrune Gauntlets
	[20550]="0:4:3:1:Plate::1:0:", -- Darkrune Breastplate
	[20551]="0:4:3:1:Plate::1:0:", -- Darkrune Helm
	[20552]="0:12:1:20:::1:0:", -- Decoded Twilight Text
	[20553]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Darkrune Gauntlets
	[20554]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Darkrune Breastplate
	[20555]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Darkrune Helm
	[20556]="0:2:3:1:Stave::1:0:", -- Wildstaff
	[20557]="3500:0:1:100:Consumable::5:0:15353,15354", -- Hallow's End Pumpkin Treat
	[20558]="0:10:2::Currency::1:0:", -- Warsong Gulch Mark of Honor
	[20559]="0:10:2::Currency::1:0:", -- Arathi Basin Mark of Honor
	[20560]="0:10:2::Currency::1:0:", -- Alterac Valley Mark of Honor
	[20561]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Dwarf Mask
	[20562]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Dwarf Mask
	[20563]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Night Elf Mask
	[20564]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Night Elf Mask
	[20565]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Human Mask
	[20566]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Human Mask
	[20567]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Troll Mask
	[20568]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Troll Mask
	[20569]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Orc Mask
	[20570]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Orc Mask
	[20571]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Tauren Mask
	[20572]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Tauren Mask
	[20573]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Undead Mask
	[20574]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Undead Mask
	[20575]="0:4:2:1:Leather::1:0:", -- Black Whelp Tunic
	[20576]="1400:9:1:1:Leatherworking::1:1:777", -- Pattern: Black Whelp Tunic
	[20577]="0:2:4:1:OneHandSword::1:0:", -- Nightmare Blade
	[20578]="0:2:4:1:Dagger::1:0:", -- Emerald Dragonfang
	[20579]="0:4:4:1:Cloak::1:0:", -- Green Dragonskin Cloak
	[20580]="0:2:4:1:OneHandMace::1:0:", -- Hammer of Bestial Fury
	[20581]="0:2:4:1:Stave::1:0:", -- Staff of Rampant Growth
	[20582]="0:4:4:1:OffHandFrill::1:0:", -- Trance Stone
	[20599]="0:2:4:1:Crossbow::1:0:", -- Polished Ironwood Crossbow
	[20600]="0:4:4:1:Ring::1:0:", -- Malfurion's Signet Ring
	[20601]="0:15:1:1:Junk::1:0:", -- Sack of Spoils
	[20602]="0:15:1:1:Junk::1:0:", -- Chest of Spoils
	[20603]="0:15:1:1:Junk::1:0:", -- Bag of Spoils
	[20604]="500:12:1:1:::1:0:15199", -- Stink Bomb Cleaner
	[20605]="0:12:1:1:::1:0:", -- Rotten Eggs
	[20606]="0:15:1:10:Junk::1:0:", -- Amber Voodoo Feather
	[20607]="0:15:1:10:Junk::1:0:", -- Blue Voodoo Feather
	[20608]="0:15:1:10:Junk::1:0:", -- Green Voodoo Feather
	[20610]="0:15:1:20:Junk::1:0:", -- Bloodshot Spider Eye
	[20611]="0:15:1:20:Junk::1:0:", -- Thick Black Claw
	[20612]="0:15:1:10:Junk::1:0:", -- Inert Scourgestone
	[20613]="0:15:1:20:Junk::1:0:", -- Rotting Wood
	[20614]="0:15:1:20:Junk::1:0:", -- Bloodvenom Essence
	[20615]="0:4:4:1:Leather::1:0:", -- Dragonspur Wraps
	[20616]="0:4:4:1:Plate::1:0:", -- Dragonbone Wristguards
	[20617]="0:4:4:1:Mail::1:0:", -- Ancient Corroded Leggings
	[20618]="0:4:4:1:Cloth::1:0:", -- Gloves of Delusional Power
	[20619]="0:4:4:1:Plate::1:0:", -- Acid Inscribed Greaves
	[20620]="0:15:1:5:Junk::1:0:", -- Holy Mightstone
	[20621]="0:4:4:1:Mail::1:0:", -- Boots of the Endless Moor
	[20622]="0:4:4:1:Amulet::1:0:", -- Dragonheart Necklace
	[20623]="0:4:4:1:Leather::1:0:", -- Circlet of Restless Dreams
	[20624]="0:4:4:1:Ring::1:0:", -- Ring of the Unliving
	[20625]="0:4:4:1:Cloth::1:0:", -- Belt of the Dark Bog
	[20626]="0:4:4:1:Cloth::1:0:", -- Black Bark Wristbands
	[20627]="0:4:4:1:Leather::1:0:", -- Dark Heart Pants
	[20628]="0:4:4:1:Leather::1:0:", -- Deviate Growth Cap
	[20629]="0:4:4:1:Mail::1:0:", -- Malignant Footguards
	[20630]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Shining Light
	[20631]="0:4:4:1:Cloth::1:0:", -- Mendicant's Slippers
	[20632]="0:4:4:1:Ring::1:0:", -- Mindtear Band
	[20633]="0:4:4:1:Leather::1:0:", -- Unnatural Leather Spaulders
	[20634]="0:4:4:1:Leather::1:0:", -- Boots of Fright
	[20635]="0:4:4:1:Cloth::1:0:", -- Jade Inlaid Vestments
	[20636]="0:4:4:1:Trinket::1:0:", -- Hibernation Crystal
	[20637]="0:4:4:1:Plate::1:0:", -- Acid Inscribed Pauldrons
	[20638]="0:4:4:1:Mail::1:0:", -- Leggings of the Demented Mind
	[20639]="0:4:4:1:Plate::1:0:", -- Strangely Glyphed Legplates
	[20640]="0:4:2:1:Plate::1:0:", -- Southsea Head Bucket
	[20641]="0:4:2:1:Cloth::1:0:", -- Southsea Mojo Boots
	[20642]="0:4:2:1:Cloth::1:0:", -- Antiquated Nobleman's Tunic
	[20643]="0:4:2:1:Leather::1:0:", -- Undercity Reservist's Cap
	[20644]="0:12:4:1:::1:0:", -- Nightmare Engulfed Object
	[20645]="0:4:2:1:Amulet::1:0:", -- Nature's Whisper
	[20646]="0:2:3:1:Bow::1:0:", -- Sandstrider's Mark
	[20647]="0:2:3:1:Dagger::1:0:", -- Black Crystal Dagger
	[20648]="0:2:3:1:OneHandMace::1:0:", -- Cold Forged Hammer
	[20649]="0:4:2:1:Amulet::1:0:", -- Sunprism Pendant
	[20650]="0:4:2:1:Plate::1:0:", -- Desert Wind Gauntlets
	[20652]="0:4:2:1:Cloth::1:0:", -- Abyssal Cloth Slippers
	[20653]="0:4:2:1:Plate::1:0:", -- Abyssal Plate Gauntlets
	[20654]="0:2:3:1:Stave::1:0:", -- Amethyst War Staff
	[20655]="0:4:2:1:Cloth::1:0:", -- Abyssal Cloth Handwraps
	[20656]="0:4:2:1:Mail::1:0:", -- Abyssal Mail Sabatons
	[20657]="0:2:3:1:Dagger::1:0:", -- Crystal Tipped Stiletto
	[20658]="0:4:2:1:Leather::1:0:", -- Abyssal Leather Boots
	[20659]="0:4:2:1:Mail::1:0:", -- Abyssal Mail Handguards
	[20660]="0:2:3:1:Polearm::1:0:", -- Stonecutting Glaive
	[20661]="0:4:2:1:Leather::1:0:", -- Abyssal Leather Gloves
	[20662]="0:4:2:1:Plate::1:0:", -- Abyssal Plate Greaves
	[20663]="0:2:3:1:Bow::1:0:", -- Deep Strike Bow
	[20664]="0:4:2:1:Cloth::1:0:", -- Abyssal Cloth Sash
	[20665]="0:4:3:1:Leather::1:0:", -- Abyssal Leather Leggings
	[20666]="0:2:3:1:OneHandMace::1:0:", -- Hardened Steel Warhammer
	[20667]="0:4:2:1:Leather::1:0:", -- Abyssal Leather Belt
	[20668]="0:4:3:1:Mail::1:0:", -- Abyssal Mail Legguards
	[20669]="0:2:3:1:TwoHandSword::1:0:", -- Darkstone Claymore
	[20670]="0:4:2:1:Mail::1:0:", -- Abyssal Mail Clutch
	[20671]="0:4:3:1:Plate::1:0:", -- Abyssal Plate Legguards
	[20672]="0:2:3:1:Wand::1:0:", -- Sparkling Crystal Wand
	[20673]="0:4:2:1:Plate::1:0:", -- Abyssal Plate Girdle
	[20674]="0:4:3:1:Cloth::1:0:", -- Abyssal Cloth Pants
	[20675]="0:2:3:1:OneHandAxe::1:0:", -- Soulrender
	[20676]="0:12:1:20:::1:0:", -- Decoded Twilight Text
	[20677]="0:12:1:20:::1:0:", -- Decoded Twilight Text
	[20678]="0:12:1:20:::1:0:", -- Decoded Twilight Text
	[20679]="0:12:1:20:::1:0:", -- Decoded Twilight Text
	[20680]="0:4:3:1:Mail::1:0:", -- Abyssal Mail Pauldrons
	[20681]="0:4:3:1:Leather::1:0:", -- Abyssal Leather Bracers
	[20682]="0:4:4:1:Ring::1:0:", -- Elemental Focus Band
	[20683]="0:4:3:1:Plate::1:0:", -- Abyssal Plate Epaulets
	[20684]="0:4:3:1:Mail::1:0:", -- Abyssal Mail Armguards
	[20685]="0:4:4:1:Amulet::1:0:", -- Wavefront Necklace
	[20686]="0:4:3:1:Cloth::1:0:", -- Abyssal Cloth Amice
	[20687]="0:4:3:1:Plate::1:0:", -- Abyssal Plate Vambraces
	[20688]="0:4:4:1:Shield::1:0:", -- Earthen Guard
	[20689]="0:4:3:1:Leather::1:0:", -- Abyssal Leather Shoulders
	[20690]="0:4:3:1:Cloth::1:0:", -- Abyssal Cloth Wristbands
	[20691]="0:4:4:1:Cloak::1:0:", -- Windshear Cape
	[20692]="0:4:2:1:Ring::1:0:", -- Multicolored Band
	[20693]="0:4:2:1:Cloak::1:0:", -- Weighted Cloak
	[20694]="0:4:2:1:OffHandFrill::1:0:", -- Glowing Black Orb
	[20695]="0:4:3:1:Amulet::1:0:", -- Abyssal War Beads
	[20696]="0:2:3:1:TwoHandMace::1:0:", -- Crystal Spiked Maul
	[20697]="0:4:3:1:Cloak::1:0:", -- Crystalline Threaded Cape
	[20698]="0:2:4:1:OneHandSword::1:0:", -- Elemental Attuned Blade
	[20699]="0:4:3:1:Plate::1:0:", -- Cenarion Reservist's Legplates
	[20700]="0:4:3:1:Plate::1:0:", -- Cenarion Reservist's Legplates
	[20701]="0:4:3:1:Mail::1:0:", -- Cenarion Reservist's Legguards
	[20702]="0:4:3:1:Mail::1:0:", -- Cenarion Reservist's Legguards
	[20703]="0:4:3:1:Leather::1:0:", -- Cenarion Reservist's Leggings
	[20704]="0:4:3:1:Leather::1:0:", -- Cenarion Reservist's Leggings
	[20705]="0:4:3:1:Cloth::1:0:", -- Cenarion Reservist's Pants
	[20706]="0:4:3:1:Cloth::1:0:", -- Cenarion Reservist's Pants
	[20707]="0:4:3:1:Cloth::1:0:", -- Cenarion Reservist's Pants
	[20708]="0:15:1:1:Junk::1:0:", -- Tightly Sealed Trunk
	[20709]="0:0:1:10:FoodDrink::1:0:", -- Rumsey Rum Light
	[20710]="0:4:3:1:Plate::1:0:", -- Crystal Encrusted Greaves
	[20711]="0:4:3:1:Plate::1:0:", -- Crystal Lined Greaves
	[20712]="0:4:3:1:Mail::1:0:", -- Wastewalker's Gauntlets
	[20713]="0:4:3:1:Mail::1:0:", -- Desertstalkers's Gauntlets
	[20714]="0:4:3:1:Leather::1:0:", -- Sandstorm Boots
	[20715]="0:4:3:1:Leather::1:0:", -- Dunestalker's Boots
	[20716]="0:4:3:1:Cloth::1:0:", -- Sandworm Skin Gloves
	[20717]="0:4:3:1:Cloth::1:0:", -- Desert Bloom Gloves
	[20720]="0:2:3:1:Dagger::1:0:", -- Dark Whisper Blade
	[20721]="0:4:3:1:Ring::1:0:", -- Band of the Cultist
	[20722]="0:2:3:1:Gun::1:0:", -- Crystal Slugthrower
	[20723]="0:2:2:1:OneHandAxe::1:0:", -- Brann's Trusty Pick
	[20724]="0:2:2:1:Stave::1:0:", -- Corrupted Blackwood Staff
	[20725]="0:7:4:20:Enchanting:164,333:1:0:", -- Nexus Crystal
	[20726]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Threat
	[20727]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Shadow Power
	[20728]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Frost Power
	[20729]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Fire Power
	[20730]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Healing Power
	[20731]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Superior Agility
	[20732]="100000:9:1:1:Enchanting::1:0:15419", -- Formula: Enchant Cloak - Greater Fire Resistance
	[20733]="100000:9:1:1:Enchanting::1:0:15419", -- Formula: Enchant Cloak - Greater Nature Resistance
	[20734]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Stealth
	[20735]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Subtlety
	[20736]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Dodge
	[20741]="0:15:1:1:Junk::1:0:", -- Deadwood Ritual Totem
	[20742]="0:15:1:1:Junk::1:0:", -- Winterfall Ritual Totem
	[20743]="0:12:1:10:::1:0:", -- Unstable Mana Crystal
	[20744]="0:0:1:1:EnhTemp::1:0:", -- Minor Wizard Oil
	[20745]="0:0:1:1:EnhTemp::1:0:", -- Minor Mana Oil
	[20746]="0:0:1:1:EnhTemp::1:0:", -- Lesser Wizard Oil
	[20747]="0:0:1:1:EnhTemp::1:0:", -- Lesser Mana Oil
	[20748]="0:0:1:1:EnhTemp::1:0:", -- Brilliant Mana Oil
	[20749]="0:0:1:1:EnhTemp::1:0:", -- Brilliant Wizard Oil
	[20750]="0:0:1:1:EnhTemp::1:0:", -- Wizard Oil
	[20752]="3000:9:1:1:Enchanting::1:0:1318,3012,3346,4228,4617,5158,5757,5758,15419,16635,16722,18753,18773,18951,19234,19537,19540,19663,26569,27030,27054,27147,28714,33633,33676", -- Formula: Minor Mana Oil
	[20753]="4000:9:1:1:Enchanting::1:0:1318,3012,3346,4228,4617,5158,5757,5758,15419,16635,16722,18753,18773,18951,19234,19537,19540,19663,26569,27030,27054,27147,28714,33633,33676", -- Formula: Lesser Wizard Oil
	[20754]="10000:9:1:1:Enchanting::1:0:15419", -- Formula: Lesser Mana Oil
	[20755]="20000:9:1:1:Enchanting::1:0:15419", -- Formula: Wizard Oil
	[20756]="40000:9:1:1:Enchanting::1:0:14921", -- Formula: Brilliant Wizard Oil
	[20757]="40000:9:1:1:Enchanting::1:0:14921", -- Formula: Brilliant Mana Oil
	[20758]="500:9:1:1:Enchanting::1:0:1318,3012,3346,4228,4617,5158,5757,5758,15419,16635,16722,18753,18773,18951,19234,19537,19540,19663,26569,27030,27054,27147,28714,33633,33676", -- Formula: Minor Wizard Oil
	[20759]="0:12:1:1:::1:0:", -- Otembe's Hammer
	[20760]="0:12:1:1:::1:0:", -- Chieftain Zul'Marosh's Head
	[20761]="120000:9:1:1:Alchemy::1:1:12944", -- Recipe: Transmute Elemental Fire
	[20763]="0:15:0:5:Junk::1:0:", -- Broken Weapon
	[20764]="0:12:1:1:::1:0:", -- Prospector Anvilward's Head
	[20765]="0:12:1:1:::1:0:", -- Incriminating Documents
	[20766]="0:15:1:1:Junk::1:0:", -- Slimy Bag
	[20767]="0:15:1:1:Junk::1:0:", -- Scum Covered Bag
	[20768]="0:15:1:1:Junk::1:0:", -- Oozing Bag
	[20769]="0:15:1:1:Companion::1:0:", -- Disgusting Oozeling
	[20770]="0:15:0:10:Junk::1:0:", -- Bubbling Green Ichor
	[20771]="0:12:1:20:::1:0:", -- Tainted Soil Sample
	[20772]="0:12:1:20:::1:0:", -- Springpaw Pelt
	[20797]="0:12:1:20:::1:0:", -- Lynx Collar
	[20799]="0:12:1:1:::1:0:", -- Felendren's Head
	[20800]="0:12:2:20:::1:0:", -- Cenarion Logistics Badge
	[20801]="0:12:2:20:::1:0:", -- Cenarion Tactical Badge
	[20802]="0:12:2:20:::1:0:", -- Cenarion Combat Badge
	[20803]="0:12:1:1:::1:0:", -- Twilight Battle Orders
	[20804]="0:12:1:1:::1:0:", -- Erona's Package
	[20805]="0:15:1:1:Junk::1:0:", -- Followup Logistics Assignment
	[20806]="0:12:2:1:::1:0:", -- Logistics Task Briefing X
	[20807]="0:12:2:1:::1:0:", -- Logistics Task Briefing I
	[20808]="0:15:1:1:Junk::1:0:", -- Combat Assignment
	[20809]="0:15:1:1:Junk::1:0:", -- Tactical Assignment
	[20810]="0:12:1:1:::1:0:", -- Signed Field Duty Papers
	[20812]="0:15:0:10:Junk::1:0:", -- Tattered Pelt
	[20813]="0:15:0:10:Junk::1:0:", -- Lynx Tooth
	[20815]="800:7:1:1:Other::1:0:372,790,3002,3133,3167,3358,3392,3578,4256,4599,5514,6298,11186,16224,16262,16613,16624,16664,16751,16768,17486,17512,18427,18751,18774,19065,19538,19539,20981,27142,28721,28728,28799,33602,33637,33640,33680,33682", -- Jeweler's Kit
	[20816]="0:7:1:20:Jewelcrafting:202,755:1:0:", -- Delicate Copper Wire
	[20817]="0:7:1:20:Jewelcrafting:755:1:0:", -- Bronze Setting
	[20818]="0:4:2:1:Ring::1:0:", -- Elegant Silver Ring
	[20820]="0:4:2:1:Ring::1:0:", -- Simple Pearl Ring
	[20821]="0:4:2:1:Ring::1:0:", -- Inlaid Malachite Ring
	[20823]="0:4:2:1:Ring::1:0:", -- Gloom Band
	[20824]="25000:7:1:1:Jewelcrafting::1:0:372,790,3002,3133,3167,3358,3392,3578,4256,4599,5514,6298,11186,16224,16262,16613,16624,16664,16751,16768,17486,17512,18427,18751,18774,19065,19538,19539,20981,27142,28721,28728,28799,33602,33637,33640,33680,33682", -- Simple Grinder
	[20826]="0:4:3:1:Ring::1:0:", -- Heavy Silver Ring
	[20827]="0:4:2:1:Ring::1:0:", -- Ring of Silver Might
	[20828]="0:4:2:1:Ring::1:0:", -- Ring of Twilight Shadows
	[20830]="0:4:2:1:Amulet::1:0:", -- Amulet of the Moon
	[20831]="0:4:2:1:Amulet::1:0:", -- Heavy Golden Necklace of Battle
	[20832]="0:4:3:1:Cloth::1:0:", -- Moonsoul Crown
	[20833]="0:4:2:1:Ring::1:0:", -- Wicked Moonstone Ring
	[20835]="0:2:1:1:OneHandSword::1:0:", -- Sunstrider Sword
	[20836]="0:2:1:1:Dagger::1:0:", -- Sunstrider Dagger
	[20837]="0:2:1:1:OneHandAxe::1:0:", -- Sunstrider Axe
	[20838]="0:2:1:1:Bow::1:0:", -- Sunstrider Bow
	[20839]="0:2:1:1:Stave::1:0:", -- Sunstrider Staff
	[20840]="0:2:1:1:OneHandMace::1:0:", -- Sunstrider Mace
	[20841]="0:4:1:1:Shield::1:0:", -- Sunstrider Shield
	[20842]="0:15:0:10:Junk::1:0:", -- Frayed Tender Vine
	[20843]="0:15:0:10:Junk::1:0:", -- Smashed Petal
	[20844]="300:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,24148,24313,24780,25043,26382,26568,27031,27038,27053,27089,28347,29535,30239,30244,30306,30438,31115,32639,32641,33630,33674", -- Deadly Poison V
	[20845]="0:15:0:10:Junk::1:0:", -- Torn Wyrm Scale
	[20846]="0:15:0:10:Junk::1:0:", -- Faintly Glowing Eye
	[20847]="0:15:0:10:Junk::1:0:", -- Wraith Fragment
	[20848]="0:15:0:10:Junk::1:0:", -- Sparkling Dust
	[20849]="84:2:1:1:OneHandSword::1:0:15289", -- Arcane Forged Shortsword
	[20850]="84:2:1:1:OneHandAxe::1:0:15289", -- Arcane Forged Axe
	[20851]="85:2:1:1:OneHandMace::1:0:15289", -- Arcane Forged Mace
	[20852]="85:2:1:1:Dagger::1:0:15289", -- Arcane Forged Dirk
	[20853]="107:2:1:1:Stave::1:0:15289", -- Mana Gathering Staff
	[20854]="1800:9:1:1:Jewelcrafting::1:1:4229,4561,16624,17512", -- Design: Amulet of the Moon
	[20855]="1500:9:1:1:Jewelcrafting::1:1:3499,3954", -- Design: Wicked Moonstone Ring
	[20856]="1500:9:1:1:Jewelcrafting::1:1:1286,3367,16624,17512", -- Design: Heavy Golden Necklace of Battle
	[20857]="25:0:1:20:FoodDrink::5:0:15287,16920", -- Honey Bread
	[20858]="0:12:2:250:::1:0:", -- Stone Scarab
	[20859]="0:12:2:250:::1:0:", -- Gold Scarab
	[20860]="0:12:2:250:::1:0:", -- Silver Scarab
	[20861]="0:12:2:250:::1:0:", -- Bronze Scarab
	[20862]="0:12:2:250:::1:0:", -- Crystal Scarab
	[20863]="0:12:2:250:::1:0:", -- Clay Scarab
	[20864]="0:12:2:250:::1:0:", -- Bone Scarab
	[20865]="0:12:2:250:::1:0:", -- Ivory Scarab
	[20866]="0:12:3:250:::1:0:", -- Azure Idol
	[20867]="0:12:3:250:::1:0:", -- Onyx Idol
	[20868]="0:12:3:250:::1:0:", -- Lambent Idol
	[20869]="0:12:3:250:::1:0:", -- Amber Idol
	[20870]="0:12:3:250:::1:0:", -- Jasper Idol
	[20871]="0:12:3:250:::1:0:", -- Obsidian Idol
	[20872]="0:12:3:250:::1:0:", -- Vermillion Idol
	[20873]="0:12:3:250:::1:0:", -- Alabaster Idol
	[20874]="0:12:3:250:::1:0:", -- Idol of the Sun
	[20875]="0:12:3:250:::1:0:", -- Idol of Night
	[20876]="0:12:3:250:::1:0:", -- Idol of Death
	[20877]="0:12:3:250:::1:0:", -- Idol of the Sage
	[20878]="0:12:3:250:::1:0:", -- Idol of Rebirth
	[20879]="0:12:3:250:::1:0:", -- Idol of Life
	[20881]="0:12:3:250:::1:0:", -- Idol of Strife
	[20882]="0:12:3:250:::1:0:", -- Idol of War
	[20884]="0:12:3:250:::1:0:", -- Qiraji Magisterial Ring
	[20885]="0:12:3:250:::1:0:", -- Qiraji Martial Drape
	[20886]="0:12:4:250:::1:0:", -- Qiraji Spiked Hilt
	[20888]="0:12:3:250:::1:0:", -- Qiraji Ceremonial Ring
	[20889]="0:12:3:250:::1:0:", -- Qiraji Regal Drape
	[20890]="0:12:4:250:::1:0:", -- Qiraji Ornate Hilt
	[20891]="0:4:0:1:Cloth::1:0:", -- Neophyte's Robe
	[20892]="0:4:0:1:Cloth::1:0:", -- Acolyte's Robe
	[20893]="0:4:0:1:Cloth::1:0:", -- Apprentice's Robe
	[20894]="0:4:0:1:Cloth::1:0:", -- Apprentice's Pants
	[20895]="0:4:1:1:Miscellaneous::1:0:", -- Apprentice's Boots
	[20896]="0:4:0:1:Cloth::1:0:", -- Lookout's Pants
	[20897]="0:4:0:1:Shirt::1:0:", -- Lookout's Tunic
	[20898]="0:4:0:1:Cloth::1:0:", -- Lookout's Shoes
	[20899]="0:4:0:1:Cloth::1:0:", -- Warder's Pants
	[20900]="0:4:0:1:Cloth::1:0:", -- Warder's Boots
	[20901]="0:4:0:1:Shirt::1:0:", -- Warder's Shirt
	[20906]="0:4:2:1:Ring::1:0:", -- Braided Copper Ring
	[20907]="0:4:2:1:Ring::1:0:", -- Solid Bronze Ring
	[20909]="0:4:2:1:Amulet::1:0:", -- Barbaric Iron Collar
	[20910]="63:2:1:1:Bow::1:0:15289", -- Stiff Shortbow
	[20911]="37:4:1:1:Shield::1:0:15292", -- Light Guard
	[20912]="84:4:1:1:Shield::1:0:15292", -- Large Shield
	[20914]="39:4:1:1:Mail::1:0:15292", -- Unadorned Chain Belt
	[20915]="60:4:1:1:Mail::1:0:15292", -- Unadorned Chain Boots
	[20916]="36:4:1:1:Mail::1:0:15292", -- Unadorned Chain Bracers
	[20917]="36:4:1:1:Mail::1:0:15292", -- Unadorned Chain Gloves
	[20918]="72:4:1:1:Mail::1:0:15292,24539", -- Unadorned Chain Leggings
	[20919]="73:4:1:1:Mail::1:0:15292", -- Unadorned Chain Vest
	[20920]="30:4:1:1:Leather::1:0:15291", -- Sun Cured Belt
	[20921]="46:4:1:1:Leather::1:0:15291", -- Sun Cured Boots
	[20922]="30:4:1:1:Leather::1:0:15291", -- Sun Cured Bracers
	[20923]="30:4:1:1:Leather::1:0:15291", -- Sun Cured Gloves
	[20924]="62:4:1:1:Leather::1:0:15291", -- Sun Cured Pants
	[20925]="62:4:1:1:Leather::1:0:15291", -- Sun Cured Vest
	[20926]="0:12:4:250:::1:0:", -- Vek'nilash's Circlet
	[20927]="0:12:4:250:::1:0:", -- Ouro's Intact Hide
	[20928]="0:15:4:250:Junk::1:0:", -- Qiraji Bindings of Command
	[20929]="0:15:4:250:Junk::1:0:", -- Carapace of the Old God
	[20930]="0:15:4:250:Junk::1:0:", -- Vek'lor's Diadem
	[20931]="0:12:4:250:::1:0:", -- Skin of the Great Sandworm
	[20932]="0:15:4:250:Junk::1:0:", -- Qiraji Bindings of Dominance
	[20933]="0:15:4:250:Junk::1:0:", -- Husk of the Old God
	[20934]="0:12:1:20:::1:0:", -- Wraith Essence
	[20935]="0:12:1:1:::1:0:", -- Tainted Wraith Essence
	[20938]="0:12:1:1:::1:0:", -- Falconwing Square Gift Voucher
	[20939]="0:12:2:1:::1:0:", -- Logistics Task Briefing II
	[20940]="0:12:2:1:::1:0:", -- Logistics Task Briefing III
	[20941]="0:12:2:1:::1:0:", -- Combat Task Briefing XII
	[20942]="0:12:2:1:::1:0:", -- Combat Task Briefing III
	[20943]="0:12:2:1:::1:0:", -- Tactical Task Briefing X
	[20944]="0:12:2:1:::1:0:", -- Tactical Task Briefing IX
	[20945]="0:12:2:1:::1:0:", -- Tactical Task Briefing II
	[20947]="0:12:2:1:::1:0:", -- Tactical Task Briefing IV
	[20948]="0:12:2:1:::1:0:", -- Tactical Task Briefing V
	[20949]="0:12:1:1:::1:0:", -- Magical Ledger
	[20950]="0:4:2:1:Amulet::1:0:", -- Pendant of the Agate Shield
	[20951]="0:12:1:1:::1:0:", -- Narain's Scrying Goggles
	[20954]="0:2:2:1:FistWeapon::1:0:", -- Heavy Iron Knuckles
	[20955]="0:4:2:1:Ring::1:0:", -- Golden Dragon Ring
	[20956]="0:4:2:1:Amulet::1:0:", -- Silver Rose Pendant
	[20958]="0:4:2:1:Ring::1:0:", -- Blazing Citrine Ring
	[20959]="0:4:2:1:Ring::1:0:", -- The Jade Eye
	[20960]="0:4:2:1:Ring::1:0:", -- Engraved Truesilver Ring
	[20961]="0:4:2:1:Ring::1:0:", -- Citrine Ring of Rapid Healing
	[20963]="0:7:1:20:Jewelcrafting:755:1:0:", -- Mithril Filigree
	[20964]="0:4:3:1:Ring::1:0:", -- Aquamarine Signet
	[20966]="0:4:2:1:Amulet::1:0:", -- Jade Pendant of Blasting
	[20967]="0:4:2:1:Amulet::1:0:", -- Citrine Pendant of Golden Healing
	[20969]="0:4:3:1:Cloth::1:0:", -- Ruby Crown of Restoration
	[20970]="1500:9:1:1:Jewelcrafting::1:1:1448,4877", -- Design: Pendant of the Agate Shield
	[20971]="1500:9:1:1:Jewelcrafting::1:1:2381,2393", -- Design: Heavy Iron Knuckles
	[20973]="2000:9:1:1:Jewelcrafting::1:1:2381,9636", -- Design: Blazing Citrine Ring
	[20974]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Jade Pendant of Blasting
	[20975]="2500:9:1:1:Jewelcrafting::1:1:4775,5163,16624,17512", -- Design: The Jade Eye
	[20976]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Citrine Pendant of Golden Healing
	[20978]="46:2:1:1:Stave::1:0:24539", -- Apprentice's Staff
	[20980]="0:2:1:1:Bow::1:0:", -- Warder's Shortbow
	[20981]="0:2:1:1:OneHandMace::1:0:", -- Neophyte's Mace
	[20982]="0:2:1:1:Dagger::1:0:", -- Sharp Dagger
	[20983]="37:2:1:1:Dagger::1:0:24539", -- Acolyte's Dagger
	[20985]="38:4:1:1:Cloth::1:0:15291", -- Light Cloth Shoes
	[20986]="51:4:1:1:Cloth::1:0:15291,24539", -- Light Cloth Pants
	[20987]="25:4:1:1:Cloth::1:0:15291", -- Light Cloth Gloves
	[20988]="25:4:1:1:Cloth::1:0:15291", -- Light Cloth Bracers
	[20989]="25:4:1:1:Cloth::1:0:15291", -- Light Cloth Belt
	[20990]="52:4:1:1:Cloth::1:0:15291", -- Light Cloth Armor
	[20991]="0:4:1:1:Cloak::1:0:", -- Daylight Cloak
	[20992]="0:4:1:1:Cloth::1:0:", -- Sunrise Bracers
	[20993]="0:4:1:1:Leather::1:0:", -- Lynxskin Gloves
	[20994]="0:4:1:1:Mail::1:0:", -- Green Chain Vest
	[20995]="0:4:1:1:Cloth::1:0:", -- Well Watcher Gloves
	[20996]="0:4:1:1:Leather::1:0:", -- Sunspire Cord
	[20997]="0:4:1:1:Mail::1:0:", -- Green Chain Boots
	[20998]="0:4:1:1:Cloth::1:0:", -- Wyrm Sash
	[20999]="0:4:1:1:Mail::1:0:", -- Green Chain Gauntlets
	[21000]="0:4:1:1:Leather::1:0:", -- Vigorous Bracers
	[21001]="0:4:1:1:Cloth::1:0:", -- Striding Pants
	[21002]="0:4:0:1:Cloth::1:0:", -- Unkempt Belt
	[21003]="0:4:0:1:Cloth::1:0:", -- Unkempt Bracers
	[21004]="0:4:0:1:Cloak::1:0:", -- Unkempt Cloak
	[21005]="0:4:0:1:Cloth::1:0:", -- Unkempt Gloves
	[21006]="0:4:0:1:Cloth::1:0:", -- Unkempt Pants
	[21007]="0:4:0:1:Cloth::1:0:", -- Unkempt Robe
	[21008]="0:4:0:1:Cloth::1:0:", -- Unkempt Shoes
	[21009]="0:4:0:1:Leather::1:0:", -- Scraggy Leather Belt
	[21010]="0:4:0:1:Leather::1:0:", -- Scraggy Leather Boots
	[21011]="0:4:0:1:Leather::1:0:", -- Scraggy Leather Bracers
	[21012]="0:4:0:1:Leather::1:0:", -- Scraggy Leather Gloves
	[21013]="0:4:0:1:Leather::1:0:", -- Scraggy Leather Pants
	[21014]="0:4:0:1:Leather::1:0:", -- Scraggy Leather Vest
	[21015]="0:4:0:1:Mail::1:0:", -- Shoddy Chain Belt
	[21016]="0:4:0:1:Mail::1:0:", -- Shoddy Chain Vest
	[21017]="0:4:0:1:Mail::1:0:", -- Shoddy Chain Pants
	[21018]="0:4:0:1:Mail::1:0:", -- Shoddy Chain Gloves
	[21019]="0:4:0:1:Mail::1:0:", -- Shoddy Chain Bracers
	[21020]="0:4:0:1:Mail::1:0:", -- Shoddy Chain Boots
	[21021]="0:4:0:1:Shield::1:0:", -- Battered Shield
	[21022]="0:4:0:1:Shield::1:0:", -- Weather Beaten Buckler
	[21023]="0:0:1:20:FoodDrink::1:0:", -- Dirge's Kickin' Chimaerok Chops
	[21024]="0:7:1:20:Meat:185:1:0:", -- Chimaerok Tenderloin
	[21025]="0:9:4:1:Cooking::1:0:", -- Recipe: Dirge's Kickin' Chimaerok Chops
	[21027]="0:12:1:1:::1:0:", -- Lakmaeran's Carcass
	[21028]="0:12:1:1:::1:0:", -- 500 Pound Chicken
	[21029]="0:12:1:1:::1:0:", -- Ransom Letter
	[21030]="2000:0:1:20:FoodDrink::5:0:2303,3961,4167,4181,4191,4195,4266,6091,7941,12019,12026", -- Darnassus Kimchi Pie
	[21031]="4000:0:1:20:FoodDrink::5:0:2303,3961,4167,4181,4191,4195,4266,6091,7941,12019,12026", -- Cabbage Kimchi
	[21032]="0:12:1:1:::1:0:", -- Meridith's Love Letter
	[21033]="4000:0:1:20:FoodDrink::5:0:2303,3961,4167,4181,4191,4195,4266,6091,7941,12019,12026", -- Radish Kimchi
	[21037]="0:15:1:1:Junk::1:0:", -- Crude Map
	[21038]="0:0:1:20:Other::1:0:", -- Hardpacked Snowball
	[21039]="0:4:1:1:Miscellaneous::1:0:", -- Narain's Turban
	[21040]="0:4:1:1:Miscellaneous::1:0:", -- Narain's Robe
	[21041]="0:12:1:1:::1:0:", -- Bag of Gold
	[21042]="0:15:1:1:Junk::1:0:", -- Narain's Special Kit
	[21071]="0:7:1:20:Meat:185:1:0:", -- Raw Sagefish
	[21072]="0:0:1:20:FoodDrink::1:0:", -- Smoked Sagefish
	[21099]="500:9:1:1:Cooking::1:0:2381,2397,2664,3027,3085,3400,4223,4265,4553,5160,5483,8307,12033,14738,16253,16677,16718,17246,19195,26868", -- Recipe: Smoked Sagefish
	[21100]="0:12:1:100:::1:0:", -- Coin of Ancestry
	[21103]="0:15:1:1:Junk::1:0:", -- Draconic for Dummies
	[21104]="0:15:1:1:Junk::1:0:", -- Draconic for Dummies
	[21105]="0:15:1:1:Junk::1:0:", -- Draconic for Dummies
	[21106]="0:15:1:1:Junk::1:0:", -- Draconic for Dummies
	[21107]="0:15:1:1:Junk::1:0:", -- Draconic for Dummies
	[21108]="0:15:1:1:Junk::1:0:", -- Draconic for Dummies
	[21109]="0:15:1:1:Junk::1:0:", -- Draconic for Dummies
	[21110]="0:15:1:1:Junk::1:0:", -- Draconic for Dummies
	[21111]="0:12:1:1:::1:0:", -- Draconic For Dummies: Volume II
	[21112]="0:12:1:1:::1:0:", -- Magical Book Binding
	[21113]="0:15:1:1:Junk::1:0:", -- Watertight Trunk
	[21114]="0:0:1:10:FoodDrink::1:0:", -- Rumsey Rum Dark
	[21115]="0:4:3:1:Trinket::1:0:", -- Defiler's Talisman
	[21116]="0:4:3:1:Trinket::1:0:", -- Defiler's Talisman
	[21117]="0:4:3:1:Trinket::1:0:", -- Talisman of Arathor
	[21118]="0:4:3:1:Trinket::1:0:", -- Talisman of Arathor
	[21119]="0:4:3:1:Trinket::1:0:", -- Talisman of Arathor
	[21120]="0:4:3:1:Trinket::1:0:", -- Defiler's Talisman
	[21126]="0:2:4:1:Dagger::1:0:", -- Death's Sting
	[21128]="0:2:4:1:Stave::1:0:", -- Staff of the Qiraji Prophets
	[21130]="0:15:1:1:Junk::1:0:", -- Diary of Weavil
	[21131]="0:15:1:1:Junk::1:0:", -- Followup Combat Assignment
	[21132]="0:15:1:1:Junk::1:0:", -- Logistics Assignment
	[21133]="0:15:1:1:Junk::1:0:", -- Followup Tactical Assignment
	[21134]="0:2:4:1:TwoHandAxe::1:0:", -- Dark Edge of Insanity
	[21136]="0:12:1:1:::1:0:", -- Arcanite Buoy
	[21137]="0:12:1:1:::1:0:", -- Blue Scepter Shard
	[21138]="0:12:1:1:::1:0:", -- Red Scepter Shard
	[21139]="0:12:1:1:::1:0:", -- Green Scepter Shard
	[21140]="0:0:1:1:Other::1:0:", -- Auction Stationery
	[21142]="0:15:1:1:Junk::1:0:", -- From the Desk of Lord Victor Nefarius
	[21143]="0:12:1:1:::1:0:", -- Unsigned Field Duty Papers
	[21144]="0:12:1:1:::1:0:", -- Demon Summoning Torch
	[21145]="0:12:1:1:::1:0:", -- Essence of Xandivious
	[21146]="0:12:1:1:::1:0:", -- Fragment of the Nightmare's Corruption
	[21147]="0:12:1:1:::1:0:", -- Fragment of the Nightmare's Corruption
	[21148]="0:12:1:1:::1:0:", -- Fragment of the Nightmare's Corruption
	[21149]="0:12:1:1:::1:0:", -- Fragment of the Nightmare's Corruption
	[21150]="0:15:1:1:Junk::1:0:", -- Iron Bound Trunk
	[21151]="200:0:1:10:FoodDrink::1:0:20377", -- Rumsey Rum Black Label
	[21153]="0:7:1:20:Meat:185:1:0:", -- Raw Greater Sagefish
	[21154]="0:4:1:1:Cloth::1:0:", -- Festival Dress
	[21155]="0:12:1:1:::1:0:", -- Timbermaw Offering of Peace
	[21156]="0:15:1:1:Junk::1:0:", -- Scarab Bag
	[21157]="0:4:1:1:Miscellaneous::1:0:15864", -- Festive Green Dress
	[21158]="0:12:1:1:::1:0:", -- Hive'Zora Scout Report
	[21160]="0:12:1:1:::1:0:", -- Hive'Regal Scout Report
	[21161]="0:12:1:1:::1:0:", -- Hive'Ashi Scout Report
	[21162]="0:0:1:1:Consumable::1:0:", -- Bloated Oily Blackmouth
	[21164]="0:15:1:1:Other::1:0:", -- Bloated Rockscale Cod
	[21165]="0:12:2:1:::1:0:", -- Tactical Task Briefing VI
	[21166]="0:12:2:1:::1:0:", -- Tactical Task Briefing VII
	[21167]="0:12:2:1:::1:0:", -- Tactical Task Briefing VIII
	[21168]="0:15:1:1:Companion::1:0:", -- Baby Shark
	[21171]="0:15:1:1:Junk::1:0:", -- Filled Festive Mug
	[21174]="0:15:1:1:Junk::1:0:", -- Empty Festive Mug
	[21175]="0:15:1:1:Junk::1:0:", -- The Scepter of the Shifting Sands
	[21176]="0:15:5:1:Mount::1:0:", -- Black Qiraji Resonating Crystal
	[21177]="3000:15:1:100:Reagent:-2:20:1:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24396,24409,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,35642,37904,37935", -- Symbol of Kings
	[21178]="0:4:3:1:Leather::1:0:", -- Gloves of Earthen Power
	[21179]="0:4:3:1:Ring::1:0:", -- Band of Earthen Wrath
	[21180]="0:4:4:1:Trinket::1:0:", -- Earthstrike
	[21181]="0:4:3:1:Trinket::1:0:", -- Grace of Earth
	[21182]="0:4:3:1:Ring::1:0:", -- Band of Earthen Might
	[21183]="0:4:3:1:Cloth::1:0:", -- Earthpower Vest
	[21184]="0:4:4:1:Plate::1:0:", -- Deeprock Bracers
	[21185]="0:4:4:1:OffHandFrill::1:0:", -- Earthcalm Orb
	[21186]="0:4:4:1:Cloth::1:0:", -- Rockfury Bracers
	[21187]="0:4:3:1:Cloak::1:0:", -- Earthweave Cloak
	[21188]="0:2:4:1:TwoHandMace::1:0:", -- Fist of Cenarius
	[21189]="0:4:4:1:Ring::1:0:", -- Might of Cenarius
	[21190]="0:4:4:1:Ring::1:0:", -- Wrath of Cenarius
	[21191]="0:15:1:1:Junk::1:0:", -- Carefully Wrapped Present
	[21196]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21197]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21198]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21199]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21200]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21201]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21202]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21203]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21204]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21205]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21206]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21207]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21208]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21209]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21210]="0:4:4:1:Ring::1:0:", -- Signet Ring of the Bronze Dragonflight
	[21211]="0:12:1:1:::1:0:", -- Pouch of Reindeer Dust
	[21212]="0:0:1:20:Consumable::1:0:", -- Fresh Holly
	[21213]="0:15:2:20:Holiday::1:0:", -- Preserved Holly
	[21214]="0:9:3:1:Book::1:0:", -- Tome of Frostbolt XI
	[21215]="0:0:1:20:FoodDrink::1:0:", -- Graccu's Mince Meat Fruitcake
	[21216]="0:15:1:1:Junk::1:0:", -- Smokywood Pastures Extra-Special Gift
	[21217]="0:0:1:20:FoodDrink::1:0:", -- Sagefish Delight
	[21218]="0:15:3:1:Mount::1:0:", -- Blue Qiraji Resonating Crystal
	[21219]="5000:9:1:1:Cooking::1:0:2381,2397,2664,3027,3085,3400,4223,4265,4553,5160,5483,8307,12033,14738,16253,16677,16718,17246,19195,26868", -- Recipe: Sagefish Delight
	[21220]="0:12:4:1:::1:0:", -- Head of Ossirian the Unscarred
	[21221]="0:12:4:1:::1:0:", -- Eye of C'Thun
	[21222]="0:15:0:10:Junk::1:0:", -- Armored Chitin
	[21223]="0:15:0:10:Junk::1:0:", -- Black Stone
	[21224]="0:15:0:10:Junk::1:0:", -- Ancient Armor Fragment
	[21225]="0:15:0:10:Junk::1:0:", -- Heavy Silithid Husk
	[21226]="0:15:0:10:Junk::1:0:", -- Runic Stone
	[21227]="0:15:0:10:Junk::1:0:", -- Ancient Hero's Skull
	[21228]="0:15:1:1:Junk::1:0:", -- Mithril Bound Trunk
	[21229]="0:15:1:50:Junk::1:0:", -- Qiraji Lord's Insignia
	[21230]="0:15:1:1:Junk::1:0:", -- Ancient Qiraji Artifact
	[21232]="0:15:4:1:Junk::1:0:", -- Imperial Qiraji Armaments
	[21235]="0:0:1:20:FoodDrink::1:0:", -- Winter Veil Roast
	[21237]="0:15:4:1:Junk::1:0:", -- Imperial Qiraji Regalia
	[21241]="0:0:1:20:Consumable::1:0:", -- Winter Veil Eggnog
	[21242]="0:2:4:1:OneHandAxe::1:0:", -- Blessed Qiraji War Axe
	[21244]="0:2:4:1:Dagger::1:0:", -- Blessed Qiraji Pugio
	[21245]="0:12:2:1:::1:0:", -- Tactical Task Briefing I
	[21248]="0:12:2:1:::1:0:", -- Combat Task Briefing IV
	[21249]="0:12:2:1:::1:0:", -- Combat Task Briefing V
	[21250]="0:12:2:1:::1:0:", -- Combat Task Briefing VI
	[21251]="0:12:2:1:::1:0:", -- Combat Task Briefing VII
	[21252]="0:12:2:1:::1:0:", -- Combat Task Briefing VIII
	[21253]="0:12:2:1:::1:0:", -- Combat Task Briefing IX
	[21254]="0:0:1:5:FoodDrink::1:0:", -- Winter Veil Cookie
	[21255]="0:12:2:1:::1:0:", -- Combat Task Briefing X
	[21256]="0:12:2:1:::1:0:", -- Combat Task Briefing XI
	[21257]="0:12:2:1:::1:0:", -- Logistics Task Briefing IV
	[21258]="0:12:2:1:::1:0:", -- Logistics Task Briefing IV
	[21259]="0:12:2:1:::1:0:", -- Logistics Task Briefing V
	[21260]="0:12:2:1:::1:0:", -- Logistics Task Briefing VI
	[21261]="0:12:2:1:::1:0:", -- Logistics Task Briefing VI
	[21262]="0:12:2:1:::1:0:", -- Logistics Task Briefing VIII
	[21263]="0:12:2:1:::1:0:", -- Logistics Task Briefing VII
	[21264]="0:12:2:1:::1:0:", -- Logistics Task Briefing VII
	[21265]="0:12:2:1:::1:0:", -- Logistics Task Briefing IX
	[21266]="0:15:1:1:Junk::1:0:", -- Logistics Assignment
	[21267]="0:15:1:1:Holiday::1:0:", -- Toasting Goblet
	[21268]="0:2:4:1:OneHandMace::1:0:", -- Blessed Qiraji War Hammer
	[21269]="0:4:4:1:Shield::1:0:", -- Blessed Qiraji Bulwark
	[21270]="0:15:1:1:Junk::1:0:", -- Gently Shaken Gift
	[21271]="0:15:1:1:Junk::1:0:", -- Gently Shaken Gift
	[21272]="0:2:4:1:Gun::1:0:", -- Blessed Qiraji Musket
	[21273]="0:2:4:1:Stave::1:0:", -- Blessed Qiraji Acolyte Staff
	[21275]="0:2:4:1:Stave::1:0:", -- Blessed Qiraji Augur Staff
	[21277]="0:15:1:1:Companion::1:0:", -- Tranquil Mechanical Yeti
	[21278]="0:4:3:1:Leather::1:0:", -- Stormshroud Gloves
	[21279]="0:9:3:1:Book::1:0:", -- Tome of Fireball XII
	[21280]="0:9:3:1:Book::1:0:", -- Tome of Arcane Missiles VIII
	[21281]="0:9:3:1:Book::1:0:", -- Grimoire of Shadow Bolt X
	[21282]="0:9:3:1:Book::1:0:", -- Grimoire of Immolate VIII
	[21283]="0:9:3:1:Book::1:0:", -- Grimoire of Corruption VII
	[21284]="0:9:3:1:Book::1:0:", -- Codex of Greater Heal V
	[21285]="0:9:3:1:Book::1:0:", -- Codex of Renew X
	[21287]="0:9:3:1:Book::1:0:", -- Codex of Prayer of Healing V
	[21288]="0:9:3:1:Book::1:0:", -- Libram: Blessing of Wisdom VI
	[21289]="0:9:3:1:Book::1:0:", -- Libram: Blessing of Might VII
	[21290]="0:9:3:1:Book::1:0:", -- Libram: Holy Light IX
	[21291]="0:9:3:1:Book::1:0:", -- Tablet of Healing Wave X
	[21292]="0:15:3:1:CombatPet::1:0:", -- Tablet of Strength of Earth Totem V
	[21293]="0:9:3:1:Book::1:0:", -- Tablet of Grace of Air Totem III
	[21294]="0:9:3:1:Book::1:0:", -- Book of Healing Touch XI
	[21295]="0:9:3:1:Book::1:0:", -- Book of Starfire VII
	[21296]="0:9:3:1:Book::1:0:", -- Book of Rejuvenation XI
	[21297]="0:9:3:1:Book::1:0:", -- Manual of Heroic Strike IX
	[21298]="0:9:3:1:Book::1:0:", -- Manual of Battle Shout VII
	[21299]="0:9:3:1:Book::1:0:", -- Manual of Revenge VI
	[21300]="0:9:3:1:Book::1:0:", -- Handbook of Backstab IX
	[21301]="0:15:1:1:Companion::1:0:", -- Green Helper Box
	[21302]="0:9:3:1:Book::1:0:", -- Handbook of Deadly Poison V
	[21303]="0:9:3:1:Book::1:0:", -- Handbook of Feint V
	[21304]="0:9:3:1:Book::1:0:", -- Guide: Multi-Shot V
	[21305]="0:15:1:1:Companion::1:0:", -- Red Helper Box
	[21306]="0:9:3:1:Book::1:0:", -- Guide: Serpent Sting IX
	[21307]="0:9:3:1:Book::1:0:", -- Guide: Aspect of the Hawk VII
	[21308]="0:15:1:1:Companion::1:0:", -- Jingling Bell
	[21309]="0:15:1:1:Companion::1:0:", -- Snowman Kit
	[21310]="0:15:1:1:Junk::1:0:", -- Gaily Wrapped Present
	[21311]="0:4:2:1:Cloth::1:0:", -- Earth Warder's Vest
	[21312]="0:4:2:1:Mail::1:0:", -- Belt of the Den Watcher
	[21314]="0:15:1:1:Junk::1:0:", -- Metzen's Letters and Notes
	[21315]="0:15:1:1:Junk::1:0:", -- Smokywood Satchel
	[21316]="0:4:2:1:Plate::1:0:", -- Leggings of the Ursa
	[21317]="0:4:2:1:Leather::1:0:", -- Helm of the Pathfinder
	[21318]="0:4:2:1:Cloth::1:0:", -- Earth Warder's Gloves
	[21319]="0:4:2:1:Leather::1:0:", -- Gloves of the Pathfinder
	[21320]="0:4:2:1:Mail::1:0:", -- Vest of the Den Watcher
	[21321]="0:15:3:1:Mount::1:0:", -- Red Qiraji Resonating Crystal
	[21322]="0:4:2:1:Plate::1:0:", -- Ursa's Embrace
	[21323]="0:15:3:1:Mount::1:0:", -- Green Qiraji Resonating Crystal
	[21324]="0:15:3:1:Mount::1:0:", -- Yellow Qiraji Resonating Crystal
	[21325]="0:15:2:1:CombatPet::1:0:", -- Mechanical Greench
	[21326]="0:4:4:1:Trinket::1:0:", -- Defender of the Timbermaw
	[21327]="0:15:1:1:Junk::1:0:", -- Ticking Present
	[21328]="0:15:1:1:Junk::1:0:", -- Wand of Holiday Cheer
	[21329]="0:4:4:1:Plate::1:0:", -- Conqueror's Crown
	[21330]="0:4:4:1:Plate::1:0:", -- Conqueror's Spaulders
	[21331]="0:4:4:1:Plate::1:0:", -- Conqueror's Breastplate
	[21332]="0:4:4:1:Plate::1:0:", -- Conqueror's Legguards
	[21333]="0:4:4:1:Plate::1:0:", -- Conqueror's Greaves
	[21334]="0:4:4:1:Cloth::1:0:", -- Doomcaller's Robes
	[21335]="0:4:4:1:Cloth::1:0:", -- Doomcaller's Mantle
	[21336]="0:4:4:1:Cloth::1:0:", -- Doomcaller's Trousers
	[21337]="0:4:4:1:Cloth::1:0:", -- Doomcaller's Circlet
	[21338]="0:4:4:1:Cloth::1:0:", -- Doomcaller's Footwraps
	[21340]="0:1:2:1:SoulBag::1:0:", -- Soul Pouch
	[21341]="0:1:3:1:SoulBag::1:0:", -- Felcloth Bag
	[21342]="0:1:4:1:SoulBag::1:0:", -- Core Felcloth Bag
	[21343]="0:4:4:1:Cloth::1:0:", -- Enigma Robes
	[21344]="0:4:4:1:Cloth::1:0:", -- Enigma Boots
	[21345]="0:4:4:1:Cloth::1:0:", -- Enigma Shoulderpads
	[21346]="0:4:4:1:Cloth::1:0:", -- Enigma Leggings
	[21347]="0:4:4:1:Cloth::1:0:", -- Enigma Circlet
	[21348]="0:4:4:1:Cloth::1:0:", -- Tiara of the Oracle
	[21349]="0:4:4:1:Cloth::1:0:", -- Footwraps of the Oracle
	[21350]="0:4:4:1:Cloth::1:0:", -- Mantle of the Oracle
	[21351]="0:4:4:1:Cloth::1:0:", -- Vestments of the Oracle
	[21352]="0:4:4:1:Cloth::1:0:", -- Trousers of the Oracle
	[21353]="0:4:4:1:Leather::1:0:", -- Genesis Helm
	[21354]="0:4:4:1:Leather::1:0:", -- Genesis Shoulderpads
	[21355]="0:4:4:1:Leather::1:0:", -- Genesis Boots
	[21356]="0:4:4:1:Leather::1:0:", -- Genesis Trousers
	[21357]="0:4:4:1:Leather::1:0:", -- Genesis Vest
	[21358]="12000:9:1:1:Tailoring::1:0:6568", -- Pattern: Soul Pouch
	[21359]="0:4:4:1:Leather::1:0:", -- Deathdealer's Boots
	[21360]="0:4:4:1:Leather::1:0:", -- Deathdealer's Helm
	[21361]="0:4:4:1:Leather::1:0:", -- Deathdealer's Spaulders
	[21362]="0:4:4:1:Leather::1:0:", -- Deathdealer's Leggings
	[21363]="0:15:1:1:Junk::1:0:", -- Festive Gift
	[21364]="0:4:4:1:Leather::1:0:", -- Deathdealer's Vest
	[21365]="0:4:4:1:Mail::1:0:", -- Striker's Footguards
	[21366]="0:4:4:1:Mail::1:0:", -- Striker's Diadem
	[21367]="0:4:4:1:Mail::1:0:", -- Striker's Pauldrons
	[21368]="0:4:4:1:Mail::1:0:", -- Striker's Leggings
	[21370]="0:4:4:1:Mail::1:0:", -- Striker's Hauberk
	[21371]="0:9:3:1:Tailoring::1:0:", -- Pattern: Core Felcloth Bag
	[21372]="0:4:4:1:Mail::1:0:", -- Stormcaller's Diadem
	[21373]="0:4:4:1:Mail::1:0:", -- Stormcaller's Footguards
	[21374]="0:4:4:1:Mail::1:0:", -- Stormcaller's Hauberk
	[21375]="0:4:4:1:Mail::1:0:", -- Stormcaller's Leggings
	[21376]="0:4:4:1:Mail::1:0:", -- Stormcaller's Pauldrons
	[21377]="0:12:1:250:::1:0:", -- Deadwood Headdress Feather
	[21378]="0:12:2:1:::1:0:", -- Logistics Task Briefing I
	[21379]="0:12:2:1:::1:0:", -- Logistics Task Briefing II
	[21380]="0:12:2:1:::1:0:", -- Logistics Task Briefing III
	[21381]="0:12:2:1:::1:0:", -- Logistics Task Briefing IX
	[21382]="0:12:2:1:::1:0:", -- Logistics Task Briefing V
	[21383]="0:12:1:250:::1:0:", -- Winterfall Spirit Beads
	[21384]="0:12:2:1:::1:0:", -- Logistics Task Briefing VIII
	[21385]="0:12:2:1:::1:0:", -- Logistics Task Briefing X
	[21386]="0:15:1:1:Junk::1:0:", -- Followup Logistics Assignment
	[21387]="0:4:4:1:Plate::1:0:", -- Avenger's Crown
	[21388]="0:4:4:1:Plate::1:0:", -- Avenger's Greaves
	[21389]="0:4:4:1:Plate::1:0:", -- Avenger's Breastplate
	[21390]="0:4:4:1:Plate::1:0:", -- Avenger's Legguards
	[21391]="0:4:4:1:Plate::1:0:", -- Avenger's Pauldrons
	[21392]="0:2:4:1:OneHandAxe::1:0:", -- Sickle of Unyielding Strength
	[21393]="0:4:4:1:Ring::1:0:", -- Signet of Unyielding Strength
	[21394]="0:4:4:1:Cloak::1:0:", -- Drape of Unyielding Strength
	[21395]="0:2:4:1:OneHandSword::1:0:", -- Blade of Eternal Justice
	[21396]="0:4:4:1:Ring::1:0:", -- Ring of Eternal Justice
	[21397]="0:4:4:1:Cloak::1:0:", -- Cape of Eternal Justice
	[21398]="0:2:4:1:OneHandMace::1:0:", -- Hammer of the Gathering Storm
	[21399]="0:4:4:1:Ring::1:0:", -- Ring of the Gathering Storm
	[21400]="0:4:4:1:Cloak::1:0:", -- Cloak of the Gathering Storm
	[21401]="0:2:4:1:OneHandAxe::1:0:", -- Scythe of the Unseen Path
	[21402]="0:4:4:1:Ring::1:0:", -- Signet of the Unseen Path
	[21403]="0:4:4:1:Cloak::1:0:", -- Cloak of the Unseen Path
	[21404]="0:2:4:1:Dagger::1:0:", -- Dagger of Veiled Shadows
	[21405]="0:4:4:1:Ring::1:0:", -- Band of Veiled Shadows
	[21406]="0:4:4:1:Cloak::1:0:", -- Cloak of Veiled Shadows
	[21407]="0:2:4:1:TwoHandMace::1:0:", -- Mace of Unending Life
	[21408]="0:4:4:1:Ring::1:0:", -- Band of Unending Life
	[21409]="0:4:4:1:Cloak::1:0:", -- Cloak of Unending Life
	[21410]="0:2:4:1:OneHandMace::1:0:", -- Gavel of Infinite Wisdom
	[21411]="0:4:4:1:Ring::1:0:", -- Ring of Infinite Wisdom
	[21412]="0:4:4:1:Cloak::1:0:", -- Shroud of Infinite Wisdom
	[21413]="0:2:4:1:OneHandSword::1:0:", -- Blade of Vaulted Secrets
	[21414]="0:4:4:1:Ring::1:0:", -- Band of Vaulted Secrets
	[21415]="0:4:4:1:Cloak::1:0:", -- Drape of Vaulted Secrets
	[21416]="0:2:4:1:Dagger::1:0:", -- Kris of Unspoken Names
	[21417]="0:4:4:1:Ring::1:0:", -- Ring of Unspoken Names
	[21418]="0:4:4:1:Cloak::1:0:", -- Shroud of Unspoken Names
	[21436]="0:15:1:100:Junk::1:0:", -- Alliance Commendation Signet
	[21438]="0:15:1:100:Junk::1:0:", -- Horde Commendation Signet
	[21452]="0:2:4:1:Stave::1:0:", -- Staff of the Ruins
	[21453]="0:4:4:1:Plate::1:0:", -- Mantle of the Horusath
	[21454]="0:4:4:1:Mail::1:0:", -- Runic Stone Shoulders
	[21455]="0:4:3:1:Leather::1:0:", -- Southwind Helm
	[21456]="0:4:4:1:Cloak::1:0:", -- Sandstorm Cloak
	[21457]="0:4:4:1:Plate::1:0:", -- Bracers of Brutality
	[21458]="0:4:4:1:Leather::1:0:", -- Gauntlets of New Life
	[21459]="0:2:4:1:Crossbow::1:0:", -- Crossbow of Imminent Doom
	[21460]="0:4:4:1:Plate::1:0:", -- Helm of Domination
	[21461]="0:4:4:1:Cloth::1:0:", -- Leggings of the Black Blizzard
	[21462]="0:4:4:1:Cloth::1:0:", -- Gloves of Dark Wisdom
	[21463]="0:4:4:1:Mail::1:0:", -- Ossirian's Binding
	[21464]="0:4:4:1:Cloth::1:0:", -- Shackles of the Unscarred
	[21466]="0:2:4:1:OneHandMace::1:0:", -- Stinger of Ayamiss
	[21467]="0:4:4:1:Leather::1:0:", -- Thick Silithid Chestguard
	[21468]="0:4:3:1:Cloth::1:0:", -- Mantle of Maz'Nadir
	[21469]="0:4:3:1:Leather::1:0:", -- Gauntlets of Southwind
	[21470]="0:4:3:1:Cloak::1:0:", -- Cloak of the Savior
	[21471]="0:4:4:1:OffHandFrill::1:0:", -- Talon of Furious Concentration
	[21472]="0:4:4:1:Cloth::1:0:", -- Dustwind Turban
	[21473]="0:4:3:1:Trinket::1:0:", -- Eye of Moam
	[21474]="0:4:3:1:Leather::1:0:", -- Chitinous Shoulderguards
	[21475]="0:4:3:1:Plate::1:0:", -- Legplates of the Destroyer
	[21476]="0:4:3:1:Mail::1:0:", -- Obsidian Scaled Leggings
	[21477]="0:4:3:1:Ring::1:0:", -- Ring of Fury
	[21478]="0:2:4:1:Bow::1:0:", -- Bow of Taut Sinew
	[21479]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Immovable
	[21480]="0:4:3:1:Mail::1:0:", -- Scaled Silithid Gauntlets
	[21481]="0:4:3:1:Plate::1:0:", -- Boots of the Desert Protector
	[21482]="0:4:3:1:Mail::1:0:", -- Boots of the Fiery Sands
	[21483]="0:4:3:1:Ring::1:0:", -- Ring of the Desert Winds
	[21484]="0:4:3:1:Leather::1:0:", -- Helm of Regrowth
	[21485]="0:4:4:1:Shield::1:0:", -- Buru's Skull Fragment
	[21486]="0:4:4:1:Plate::1:0:", -- Gloves of the Swarm
	[21487]="0:4:4:1:Mail::1:0:", -- Slimy Scaled Gauntlets
	[21488]="0:4:3:1:Trinket::1:0:", -- Fetish of Chitinous Spikes
	[21489]="0:4:3:1:Cloth::1:0:", -- Quicksand Waders
	[21490]="0:4:3:1:Plate::1:0:", -- Slime Kickers
	[21491]="0:4:3:1:Leather::1:0:", -- Scaled Bracers of the Gorger
	[21492]="0:2:4:1:TwoHandSword::1:0:", -- Manslayer of the Qiraji
	[21493]="0:4:4:1:Leather::1:0:", -- Boots of the Vanguard
	[21494]="0:4:3:1:Leather::1:0:", -- Southwind's Grasp
	[21495]="0:4:3:1:Plate::1:0:", -- Legplates of the Qiraji Command
	[21496]="0:4:3:1:Cloth::1:0:", -- Bracers of Qiraji Command
	[21497]="0:4:3:1:Mail::1:0:", -- Boots of the Qiraji General
	[21498]="0:2:4:1:Dagger::1:0:", -- Qiraji Sacrificial Dagger
	[21499]="0:4:4:1:Cloth::1:0:", -- Vestments of the Shifting Sands
	[21500]="0:4:3:1:Cloth::1:0:", -- Belt of the Inquisition
	[21501]="0:4:3:1:Leather::1:0:", -- Toughened Silithid Hide Gloves
	[21502]="0:4:3:1:Mail::1:0:", -- Sand Reaver Wristguards
	[21503]="0:4:3:1:Plate::1:0:", -- Belt of the Sand Reaver
	[21504]="0:4:4:1:Amulet::1:0:", -- Charm of the Shifting Sands
	[21505]="0:4:4:1:Amulet::1:0:", -- Choker of the Shifting Sands
	[21506]="0:4:4:1:Amulet::1:0:", -- Pendant of the Shifting Sands
	[21507]="0:4:4:1:Amulet::1:0:", -- Amulet of the Shifting Sands
	[21508]="0:12:2:20:::1:0:", -- Mark of Cenarius
	[21509]="0:15:1:1:Junk::1:0:", -- Ahn'Qiraj War Effort Supplies
	[21510]="0:15:1:1:Junk::1:0:", -- Ahn'Qiraj War Effort Supplies
	[21511]="0:15:1:1:Junk::1:0:", -- Ahn'Qiraj War Effort Supplies
	[21512]="0:15:1:1:Junk::1:0:", -- Ahn'Qiraj War Effort Supplies
	[21513]="0:15:1:1:Junk::1:0:", -- Ahn'Qiraj War Effort Supplies
	[21514]="0:12:2:1:::1:0:", -- Logistics Task Briefing XI
	[21515]="0:12:2:20:::1:0:", -- Mark of Remulos
	[21517]="0:4:4:1:Cloth::1:0:", -- Gnomish Turban of Psychic Might
	[21519]="0:15:1:20:Junk::1:0:", -- Mistletoe
	[21520]="0:2:4:1:OneHandSword::1:0:", -- Ravencrest's Legacy
	[21521]="0:2:4:1:OneHandSword::1:0:", -- Runesword of the Red
	[21522]="0:2:4:1:Dagger::1:0:", -- Shadowsong's Sorrow
	[21523]="0:2:4:1:Dagger::1:0:", -- Fang of Korialstrasz
	[21524]="0:4:2:1:Cloth::1:0:", -- Red Winter Hat
	[21525]="0:4:2:1:Cloth::1:0:", -- Green Winter Hat
	[21526]="0:4:4:1:Ring::1:0:", -- Band of Icy Depths
	[21527]="0:4:4:1:Cloth::1:0:", -- Darkwater Robes
	[21528]="0:15:2:1:Junk::1:0:", -- Colossal Bag of Loot
	[21529]="0:4:4:1:Amulet::1:0:", -- Amulet of Shadow Shielding
	[21530]="0:4:4:1:Mail::1:0:", -- Onyx Embedded Leggings
	[21531]="0:4:4:1:Amulet::1:0:", -- Drake Tooth Necklace
	[21532]="0:4:4:1:Leather::1:0:", -- Drudge Boots
	[21533]="0:12:1:1:::1:0:", -- Colossus of Zora's Husk
	[21534]="0:12:1:1:::1:0:", -- Colossus of Ashi's Husk
	[21535]="0:12:1:1:::1:0:", -- Colossus of Regal's Husk
	[21536]="0:15:1:20:Holiday::1:0:", -- Elune Stone
	[21537]="0:0:1:20:Consumable::8:0:15864", -- Festival Dumplings
	[21538]="0:4:1:1:Miscellaneous::1:0:15864", -- Festive Pink Dress
	[21539]="0:4:1:1:Miscellaneous::1:0:15864", -- Festive Purple Dress
	[21540]="0:15:2:1:Junk::1:0:", -- Elune's Lantern
	[21541]="0:4:1:1:Miscellaneous::1:0:15864", -- Festive Black Pant Suit
	[21542]="0:4:1:1:Miscellaneous::1:0:", -- Festival Suit
	[21543]="0:4:1:1:Miscellaneous::1:0:15864", -- Festive Teal Pant Suit
	[21544]="0:4:1:1:Miscellaneous::1:0:15864", -- Festive Blue Pant Suit
	[21545]="0:12:1:1:::1:0:", -- Smokywood Supplies
	[21546]="0:0:1:20:Elixir::1:0:", -- Elixir of Greater Firepower
	[21547]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Greater Firepower
	[21548]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Stormshroud Gloves
	[21552]="2000:0:1:20:FoodDrink::5:0:1678,1684,2842,3086,3178,3497,3540,4200,4221,4305,4307,5814,6727,6738,6791,6807,7943,8137,8931,11187,12962,14731,16618,16739,17553,17656,19045,23896,24834,24993,25012,25020,25052,25089,29291", -- Striped Yellowtail
	[21557]="25:15:1:20:Holiday::1:0:15898", -- Small Red Rocket
	[21558]="25:15:1:20:Holiday::1:0:15898", -- Small Blue Rocket
	[21559]="25:15:1:20:Holiday::1:0:15898", -- Small Green Rocket
	[21561]="0:15:1:20:Holiday::1:0:", -- Small White Rocket
	[21562]="0:15:1:20:Holiday::1:0:", -- Small Yellow Rocket
	[21563]="0:4:4:1:Ring::1:0:", -- Don Rodrigo's Band
	[21565]="0:4:3:1:Trinket::1:0:", -- Rune of Perfection
	[21566]="0:4:3:1:Trinket::1:0:", -- Rune of Perfection
	[21567]="0:4:3:1:Trinket::1:0:", -- Rune of Duty
	[21568]="0:4:3:1:Trinket::1:0:", -- Rune of Duty
	[21569]="0:15:1:1:Holiday::1:0:", -- Firework Launcher
	[21570]="0:15:1:20:Holiday::1:0:", -- Cluster Launcher
	[21571]="100:15:1:20:Holiday::1:0:15898", -- Blue Rocket Cluster
	[21574]="100:15:1:20:Holiday::1:0:15898", -- Green Rocket Cluster
	[21576]="100:15:1:20:Holiday::1:0:15898", -- Red Rocket Cluster
	[21579]="0:4:4:1:Trinket::1:0:", -- Vanquished Tentacle of C'Thun
	[21581]="0:4:4:1:Plate::1:0:", -- Gauntlets of Annihilation
	[21582]="0:4:4:1:Cloth::1:0:", -- Grasp of the Old God
	[21583]="0:4:4:1:Cloak::1:0:", -- Cloak of Clarity
	[21585]="0:4:4:1:Cloth::1:0:", -- Dark Storm Gauntlets
	[21586]="0:4:4:1:Leather::1:0:", -- Belt of Never-ending Agony
	[21588]="0:4:4:1:Mail::1:0:", -- Wristguards of Elemental Fury
	[21589]="0:15:1:20:Holiday::1:0:", -- Large Blue Rocket
	[21590]="0:15:1:20:Holiday::1:0:", -- Large Green Rocket
	[21592]="0:15:1:20:Holiday::1:0:", -- Large Red Rocket
	[21593]="0:15:1:20:Holiday::1:0:", -- Large White Rocket
	[21595]="0:15:1:20:Holiday::1:0:", -- Large Yellow Rocket
	[21596]="0:4:4:1:Ring::1:0:", -- Ring of the Godslayer
	[21597]="0:4:4:1:OffHandFrill::1:0:", -- Royal Scepter of Vek'lor
	[21598]="0:4:4:1:Plate::1:0:", -- Royal Qiraji Belt
	[21599]="0:4:4:1:Mail::1:0:", -- Vek'lor's Gloves of Devastation
	[21600]="0:4:4:1:Cloth::1:0:", -- Boots of Epiphany
	[21601]="0:4:4:1:Ring::1:0:", -- Ring of Emperor Vek'lor
	[21602]="0:4:4:1:Leather::1:0:", -- Qiraji Execution Bracers
	[21603]="0:2:4:1:Wand::1:0:", -- Wand of Qiraji Nobility
	[21604]="0:4:4:1:Cloth::1:0:", -- Bracelets of Royal Redemption
	[21605]="0:4:4:1:Leather::1:0:", -- Gloves of the Hidden Temple
	[21606]="0:4:4:1:Plate::1:0:", -- Belt of the Fallen Emperor
	[21607]="0:4:4:1:Mail::1:0:", -- Grasp of the Fallen Emperor
	[21608]="0:4:4:1:Amulet::1:0:", -- Amulet of Vek'nilash
	[21609]="0:4:4:1:Leather::1:0:", -- Regenerating Belt of Vek'nilash
	[21610]="0:4:4:1:Shield::1:0:", -- Wormscale Blocker
	[21611]="0:4:4:1:Cloth::1:0:", -- Burrower Bracers
	[21615]="0:4:4:1:Cloth::1:0:", -- Don Rigoberto's Lost Hat
	[21616]="0:2:4:1:Bow::1:0:", -- Huhuran's Stinger
	[21617]="0:4:4:1:Leather::1:0:", -- Wasphide Gauntlets
	[21618]="0:4:4:1:Plate::1:0:", -- Hive Defiler Wristguards
	[21619]="0:4:4:1:Cloth::1:0:", -- Gloves of the Messiah
	[21620]="0:4:4:1:Ring::1:0:", -- Ring of the Martyr
	[21621]="0:4:4:1:Cloak::1:0:", -- Cloak of the Golden Hive
	[21622]="0:2:4:1:OneHandSword::1:0:", -- Sharpened Silithid Femur
	[21623]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Righteous Champion
	[21624]="0:4:4:1:Mail::1:0:", -- Gauntlets of Kalimdor
	[21625]="0:4:4:1:Trinket::1:0:", -- Scarab Brooch
	[21626]="0:4:4:1:Mail::1:0:", -- Slime-coated Leggings
	[21627]="0:4:4:1:Cloak::1:0:", -- Cloak of Untold Secrets
	[21635]="0:2:4:1:Polearm::1:0:", -- Barb of the Sand Reaver
	[21639]="0:4:4:1:Plate::1:0:", -- Pauldrons of the Unrelenting
	[21640]="0:15:1:1:Junk::1:0:15864", -- Lunar Festival Fireworks Pack
	[21645]="0:4:4:1:Leather::1:0:", -- Hive Tunneler's Boots
	[21647]="0:4:4:1:Trinket::1:0:", -- Fetish of the Sand Reaver
	[21648]="0:4:4:1:Cloth::1:0:", -- Recomposed Boots
	[21650]="0:2:4:1:OneHandSword::1:0:", -- Ancient Qiraji Ripper
	[21651]="0:4:4:1:Mail::1:0:", -- Scaled Sand Reaver Leggings
	[21652]="0:4:4:1:Plate::1:0:", -- Silithid Carapace Chestguard
	[21663]="0:4:4:1:Cloth::1:0:", -- Robes of the Guardian Saint
	[21664]="0:4:4:1:Amulet::1:0:", -- Barbed Choker
	[21665]="0:4:4:1:Leather::1:0:", -- Mantle of Wicked Revenge
	[21666]="0:4:4:1:OffHandFrill::1:0:", -- Sartura's Might
	[21667]="0:4:4:1:Plate::1:0:", -- Legplates of Blazing Light
	[21668]="0:4:4:1:Mail::1:0:", -- Scaled Leggings of Qiraji Fury
	[21669]="0:4:4:1:Leather::1:0:", -- Creeping Vine Helm
	[21670]="0:4:4:1:Trinket::1:0:", -- Badge of the Swarmguard
	[21671]="0:4:4:1:Cloth::1:0:", -- Robes of the Battleguard
	[21672]="0:4:4:1:Leather::1:0:", -- Gloves of Enforcement
	[21673]="0:2:4:1:FistWeapon::1:0:", -- Silithid Claw
	[21674]="0:4:4:1:Plate::1:0:", -- Gauntlets of Steadfast Determination
	[21675]="0:4:4:1:Leather::1:0:", -- Thick Qirajihide Belt
	[21676]="0:4:4:1:Cloth::1:0:", -- Leggings of the Festering Swarm
	[21677]="0:4:4:1:Ring::1:0:", -- Ring of the Qiraji Fury
	[21678]="0:4:4:1:Amulet::1:0:", -- Necklace of Purity
	[21679]="0:2:4:1:TwoHandSword::1:0:", -- Kalimdor's Revenge
	[21680]="0:4:4:1:Leather::1:0:", -- Vest of Swift Execution
	[21681]="0:4:4:1:Ring::1:0:", -- Ring of the Devoured
	[21682]="0:4:4:1:Leather::1:0:", -- Bile-Covered Gauntlets
	[21683]="0:4:4:1:Plate::1:0:", -- Mantle of the Desert Crusade
	[21684]="0:4:4:1:Mail::1:0:", -- Mantle of the Desert's Fury
	[21685]="0:4:4:1:Trinket::1:0:", -- Petrified Scarab
	[21686]="0:4:4:1:Cloth::1:0:", -- Mantle of Phrenic Power
	[21687]="0:4:4:1:Ring::1:0:", -- Ukko's Ring of Darkness
	[21688]="0:4:4:1:Plate::1:0:", -- Boots of the Fallen Hero
	[21689]="0:4:4:1:Leather::1:0:", -- Gloves of Ebru
	[21690]="0:4:4:1:Amulet::1:0:", -- Angelista's Charm
	[21691]="0:4:4:1:Plate::1:0:", -- Ooze-ridden Gauntlets
	[21692]="0:4:4:1:Plate::1:0:", -- Triad Girdle
	[21693]="0:4:4:1:Leather::1:0:", -- Guise of the Devourer
	[21694]="0:4:4:1:Cloth::1:0:", -- Ternary Mantle
	[21695]="0:4:4:1:Ring::1:0:", -- Angelista's Touch
	[21696]="0:4:4:1:Cloth::1:0:", -- Robes of the Triumvirate
	[21697]="0:4:4:1:Cloak::1:0:", -- Cape of the Trinity
	[21698]="0:4:4:1:Leather::1:0:", -- Leggings of Immersion
	[21699]="0:4:4:1:Mail::1:0:", -- Barrage Shoulders
	[21700]="0:4:4:1:Amulet::1:0:", -- Pendant of the Qiraji Guardian
	[21701]="0:4:4:1:Cloak::1:0:", -- Cloak of Concentrated Hatred
	[21702]="0:4:4:1:Amulet::1:0:", -- Amulet of Foul Warding
	[21703]="0:2:4:1:TwoHandMace::1:0:", -- Hammer of Ji'zhi
	[21704]="0:4:4:1:Plate::1:0:", -- Boots of the Redeemed Prophecy
	[21705]="0:4:4:1:Mail::1:0:", -- Boots of the Fallen Prophet
	[21706]="0:4:4:1:Plate::1:0:", -- Boots of the Unwavering Will
	[21707]="0:4:4:1:Ring::1:0:", -- Ring of Swarming Thought
	[21708]="0:4:4:1:Leather::1:0:", -- Beetle Scaled Wristguards
	[21709]="0:4:4:1:Ring::1:0:", -- Ring of the Fallen God
	[21710]="0:4:4:1:Cloak::1:0:", -- Cloak of the Fallen God
	[21711]="0:0:1:1:Consumable::1:0:", -- Lunar Festival Invitation
	[21712]="0:4:4:1:Amulet::1:0:", -- Amulet of the Fallen God
	[21713]="1000:2:1:1:Miscellaneous::1:0:15864", -- Elune's Candle
	[21714]="0:15:1:20:Holiday::1:0:", -- Large Blue Rocket Cluster
	[21715]="0:2:4:1:OneHandMace::1:0:", -- Sand Polished Hammer
	[21716]="0:15:1:20:Holiday::1:0:", -- Large Green Rocket Cluster
	[21718]="0:15:1:20:Holiday::1:0:", -- Large Red Rocket Cluster
	[21721]="15:0:1:10:FoodDrink::1:0:15898", -- Moonglow
	[21722]="0:9:2:1:Tailoring::1:0:", -- Pattern: Festival Dress
	[21723]="0:9:2:1:Tailoring::1:0:", -- Pattern: Festival Suit
	[21724]="0:9:2:1:Engineering::1:0:", -- Schematic: Small Blue Rocket
	[21725]="0:9:2:1:Engineering::1:0:", -- Schematic: Small Green Rocket
	[21726]="0:9:2:1:Engineering::1:0:", -- Schematic: Small Red Rocket
	[21727]="0:9:2:1:Engineering::1:0:", -- Schematic: Large Blue Rocket
	[21728]="0:9:2:1:Engineering::1:0:", -- Schematic: Large Green Rocket
	[21729]="0:9:2:1:Engineering::1:0:", -- Schematic: Large Red Rocket
	[21730]="0:9:2:1:Engineering::1:0:", -- Schematic: Blue Rocket Cluster
	[21731]="0:9:2:1:Engineering::1:0:", -- Schematic: Green Rocket Cluster
	[21732]="0:9:2:1:Engineering::1:0:", -- Schematic: Red Rocket Cluster
	[21733]="0:9:2:1:Engineering::1:0:", -- Schematic: Large Blue Rocket Cluster
	[21734]="0:9:2:1:Engineering::1:0:", -- Schematic: Large Green Rocket Cluster
	[21735]="0:9:2:1:Engineering::1:0:", -- Schematic: Large Red Rocket Cluster
	[21737]="0:9:2:1:Engineering::1:0:", -- Schematic: Cluster Launcher
	[21738]="0:9:2:1:Engineering::1:0:", -- Schematic: Firework Launcher
	[21740]="0:0:1:1:Consumable::1:0:15909", -- Small Rocket Recipes
	[21741]="0:0:1:1:Consumable::1:0:15909", -- Cluster Rocket Recipes
	[21742]="0:0:1:1:Consumable::1:0:15909", -- Large Rocket Recipes
	[21743]="0:0:1:1:Consumable::1:0:15909", -- Large Cluster Rocket Recipes
	[21744]="0:0:1:20:Consumable::1:0:", -- Lucky Rocket Cluster
	[21745]="0:0:1:20:Consumable::1:0:", -- Elder's Moonstone
	[21746]="0:0:1:1:Consumable::1:0:", -- Lucky Red Envelope
	[21747]="300:15:1:20:Holiday::1:0:15898", -- Festival Firecracker
	[21748]="0:4:2:1:Trinket::1:0:", -- Figurine - Jade Owl
	[21749]="0:12:2:1:::1:0:", -- Combat Task Briefing I
	[21750]="0:12:2:1:::1:0:", -- Combat Task Briefing II
	[21751]="0:12:2:1:::1:0:", -- Tactical Task Briefing III
	[21752]="0:7:1:20:Jewelcrafting:755:1:0:", -- Thorium Setting
	[21753]="0:4:3:1:Ring::1:0:", -- Gem Studded Band
	[21754]="0:4:2:1:Ring::1:0:", -- The Aquamarine Ward
	[21755]="0:4:2:1:Amulet::1:0:", -- Aquamarine Pendant of the Warrior
	[21756]="0:4:2:1:Trinket::1:0:", -- Figurine - Golden Hare
	[21757]="0:12:1:10:::1:0:", -- Grimscale Murloc Head
	[21758]="0:4:2:1:Trinket::1:0:", -- Figurine - Black Pearl Panther
	[21760]="0:4:2:1:Trinket::1:0:", -- Figurine - Truesilver Crab
	[21761]="0:13:1:20:::1:0:", -- Scarab Coffer Key
	[21762]="0:13:1:20:::1:0:", -- Greater Scarab Coffer Key
	[21763]="0:4:2:1:Trinket::1:0:", -- Figurine - Truesilver Boar
	[21764]="0:4:2:1:Amulet::1:0:", -- Ruby Pendant of Fire
	[21765]="0:4:2:1:Ring::1:0:", -- Truesilver Healing Ring
	[21766]="0:4:3:1:Amulet::1:0:", -- Opal Necklace of Impact
	[21767]="0:4:2:1:Ring::1:0:", -- Simple Opal Ring
	[21768]="0:4:3:1:Ring::1:0:", -- Sapphire Signet
	[21769]="0:4:2:1:Trinket::1:0:", -- Figurine - Ruby Serpent
	[21770]="0:12:1:1:::1:0:", -- Ring of Mmmrrrggglll
	[21771]="0:12:1:10:::1:0:", -- Captain Kelisendra's Cargo
	[21774]="0:4:3:1:Cloth::1:0:", -- Emerald Crown of Destruction
	[21775]="0:4:2:1:Ring::1:0:", -- Onslaught Ring
	[21776]="0:12:1:1:::1:0:", -- Captain Kelisendra's Lost Rutters
	[21777]="0:4:2:1:Trinket::1:0:", -- Figurine - Emerald Owl
	[21778]="0:4:2:1:Ring::1:0:", -- Ring of Bitter Shadows
	[21779]="0:4:3:1:Ring::1:0:", -- Band of Natural Fire
	[21780]="0:4:3:1:Cloth::1:0:", -- Blood Crown
	[21781]="0:12:1:1:::1:0:", -- Thaelis's Head
	[21783]="0:12:1:1:::1:0:", -- Magister Duskwither's Journal
	[21784]="0:4:3:1:Trinket::1:0:", -- Figurine - Black Diamond Crab
	[21789]="0:4:3:1:Trinket::1:0:", -- Figurine - Dark Iron Scorpid
	[21790]="0:4:2:1:Amulet::1:0:", -- Sapphire Pendant of Winter Night
	[21791]="0:4:3:1:Amulet::1:0:", -- Living Emerald Pendant
	[21792]="0:4:3:1:Amulet::1:0:", -- Necklace of the Diamond Tower
	[21793]="0:4:3:1:Amulet::1:0:", -- Arcanite Sword Pendant
	[21800]="0:2:3:1:Gun::1:0:", -- Silithid Husked Launcher
	[21801]="0:2:3:1:Wand::1:0:", -- Antenna of Invigoration
	[21802]="0:2:3:1:Dagger::1:0:", -- The Lost Kris of Zedd
	[21803]="0:4:3:1:Plate::1:0:", -- Helm of the Holy Avenger
	[21804]="0:4:3:1:Mail::1:0:", -- Coif of Elemental Fury
	[21805]="0:4:3:1:Plate::1:0:", -- Polished Obsidian Pauldrons
	[21806]="0:2:3:1:TwoHandMace::1:0:", -- Gavel of Qiraji Authority
	[21807]="0:12:1:1:::1:0:", -- Unmarked Letter
	[21808]="0:12:1:10:::1:0:", -- Arcane Core
	[21809]="0:4:3:1:Amulet::1:0:", -- Fury of the Forgotten Swarm
	[21810]="0:4:3:1:Cloth::1:0:", -- Treads of the Wandering Nomad
	[21812]="0:15:1:1:Junk::1:0:", -- Box of Chocolates
	[21813]="0:15:1:1:Junk::1:0:37674", -- Bag of Heart Candies
	[21814]="0:4:4:1:Plate::1:0:", -- Breastplate of Annihilation
	[21816]="0:15:1:200:Holiday::1:0:", -- Heart Candy
	[21817]="0:15:1:200:Holiday::1:0:", -- Heart Candy
	[21818]="0:15:1:200:Holiday::1:0:", -- Heart Candy
	[21819]="0:15:1:200:Holiday::1:0:", -- Heart Candy
	[21820]="0:15:1:200:Holiday::1:0:", -- Heart Candy
	[21821]="0:15:1:200:Holiday::1:0:", -- Heart Candy
	[21822]="0:15:1:200:Holiday::1:0:", -- Heart Candy
	[21823]="0:15:1:200:Holiday::1:0:", -- Heart Candy
	[21829]="100:15:1:1:Holiday::1:0:6737", -- Perfume Bottle
	[21830]="0:15:1:10:Holiday::1:0:", -- Empty Wrapper
	[21831]="0:15:1:1:Holiday::1:0:", -- Wrappered Gift
	[21833]="100:15:1:1:Holiday::1:0:6737", -- Cologne Bottle
	[21835]="1500:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,23732,24148,24313,24349,24357,24780,25043,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,33630,33674,37904,37935", -- Anesthetic Poison
	[21836]="0:4:4:1:Ring::1:0:", -- Ritssyn's Ring of Chaos
	[21837]="0:2:4:1:OneHandMace::1:0:", -- Anubisath Warhammer
	[21838]="0:4:4:1:Cloth::1:0:", -- Garb of Royal Ascension
	[21839]="0:2:4:1:OneHandMace::1:0:", -- Scepter of the False Prophet
	[21840]="0:7:1:20:Cloth:202,197:1:0:", -- Bolt of Netherweave
	[21841]="0:1:2:1:Bag::1:0:", -- Netherweave Bag
	[21842]="0:7:2:20:Cloth:197:1:0:", -- Bolt of Imbued Netherweave
	[21843]="0:1:2:1:Bag::1:0:", -- Imbued Netherweave Bag
	[21844]="0:7:1:20:Cloth:165,197:1:0:", -- Bolt of Soulcloth
	[21845]="0:7:3:20:Cloth:197:1:0:", -- Primal Mooncloth
	[21846]="0:4:4:1:Cloth::1:0:", -- Spellfire Belt
	[21847]="0:4:4:1:Cloth::1:0:", -- Spellfire Gloves
	[21848]="0:4:4:1:Cloth::1:0:", -- Spellfire Robe
	[21849]="0:4:2:1:Cloth::1:0:", -- Netherweave Bracers
	[21850]="0:4:2:1:Cloth::1:0:", -- Netherweave Belt
	[21851]="0:4:2:1:Cloth::1:0:", -- Netherweave Gloves
	[21852]="0:4:2:1:Cloth::1:0:", -- Netherweave Pants
	[21853]="0:4:2:1:Cloth::1:0:", -- Netherweave Boots
	[21854]="0:4:2:1:Cloth::1:0:", -- Netherweave Robe
	[21855]="0:4:2:1:Cloth::1:0:", -- Netherweave Tunic
	[21856]="99282:2:4:1:TwoHandAxe::1:0:", -- Neretzek, The Blood Drinker
	[21858]="0:1:3:1:EnchantingBag::1:0:", -- Spellfire Bag
	[21859]="0:4:3:1:Cloth::1:0:", -- Imbued Netherweave Pants
	[21860]="0:4:3:1:Cloth::1:0:", -- Imbued Netherweave Boots
	[21861]="0:4:3:1:Cloth::1:0:", -- Imbued Netherweave Robe
	[21862]="0:4:3:1:Cloth::1:0:", -- Imbued Netherweave Tunic
	[21863]="0:4:4:1:Cloth::1:0:", -- Soulcloth Gloves
	[21864]="0:4:4:1:Cloth::1:0:", -- Soulcloth Shoulders
	[21865]="0:4:4:1:Cloth::1:0:", -- Soulcloth Vest
	[21866]="0:4:3:1:Cloth::1:0:", -- Arcanoweave Bracers
	[21867]="0:4:3:1:Cloth::1:0:", -- Arcanoweave Boots
	[21868]="0:4:3:1:Cloth::1:0:", -- Arcanoweave Robe
	[21869]="0:4:4:1:Cloth::1:0:", -- Frozen Shadoweave Shoulders
	[21870]="0:4:4:1:Cloth::1:0:", -- Frozen Shadoweave Boots
	[21871]="0:4:4:1:Cloth::1:0:", -- Frozen Shadoweave Robe
	[21872]="0:1:3:1:SoulBag::1:0:", -- Ebon Shadowbag
	[21873]="0:4:4:1:Cloth::1:0:", -- Primal Mooncloth Belt
	[21874]="0:4:4:1:Cloth::1:0:", -- Primal Mooncloth Shoulders
	[21875]="0:4:4:1:Cloth::1:0:", -- Primal Mooncloth Robe
	[21876]="0:1:3:1:Bag::1:0:", -- Primal Mooncloth Bag
	[21877]="0:7:1:20:Cloth:164,202,129,197:1:0:", -- Netherweave Cloth
	[21881]="0:7:1:10:Cloth:197:1:0:", -- Netherweb Spider Silk
	[21882]="0:7:1:20:Other:197:1:0:", -- Soul Essence
	[21884]="0:7:2:20:Elemental:171,164,333,202,755,165,186,197:1:0:", -- Primal Fire
	[21885]="0:7:2:20:Elemental:171,164,333,202,755,165,197:1:0:", -- Primal Water
	[21886]="0:7:2:20:Elemental:171,164,333,202,755,165,197,773:1:0:", -- Primal Life
	[21887]="5000:7:1:20:Leather:164,202,165,197:1:1:14846", -- Knothide Leather
	[21888]="0:4:4:1:Cloth::1:0:", -- Gloves of the Immortal
	[21889]="0:4:4:1:Plate::1:0:", -- Gloves of the Redeemed Prophecy
	[21890]="0:4:4:1:Mail::1:0:", -- Gloves of the Fallen Prophet
	[21891]="0:4:4:1:Trinket::1:0:", -- Shard of the Fallen Star
	[21892]="40000:9:1:1:Tailoring::1:0:16638,16767,19213", -- Pattern: Bolt of Imbued Netherweave
	[21893]="40000:9:1:1:Tailoring::1:0:19015,19213", -- Pattern: Imbued Netherweave Bag
	[21894]="40000:9:1:1:Tailoring::1:1:16638,16767,19015,19017", -- Pattern: Bolt of Soulcloth
	[21895]="40000:9:1:1:Tailoring::1:0:22208,29512", -- Pattern: Primal Mooncloth
	[21896]="40000:9:1:1:Tailoring::1:0:16638,16767,19213", -- Pattern: Netherweave Robe
	[21897]="40000:9:1:1:Tailoring::1:0:16638,16767,19213", -- Pattern: Netherweave Tunic
	[21898]="60000:9:1:1:Tailoring::1:1:18011,19722", -- Pattern: Imbued Netherweave Pants
	[21899]="60000:9:1:1:Tailoring::1:1:18011,19722", -- Pattern: Imbued Netherweave Boots
	[21900]="60000:9:1:1:Tailoring::1:1:19521", -- Pattern: Imbued Netherweave Robe
	[21901]="60000:9:1:1:Tailoring::1:1:19521", -- Pattern: Imbued Netherweave Tunic
	[21902]="80000:9:1:1:Tailoring::1:1:19015,19017", -- Pattern: Soulcloth Gloves
	[21903]="0:9:4:1:Tailoring::1:0:", -- Pattern: Soulcloth Shoulders
	[21904]="0:9:4:1:Tailoring::1:0:", -- Pattern: Soulcloth Vest
	[21905]="0:9:2:1:Tailoring::1:0:", -- Pattern: Arcanoweave Bracers
	[21906]="0:9:2:1:Tailoring::1:0:", -- Pattern: Arcanoweave Boots
	[21907]="0:9:2:1:Tailoring::1:0:", -- Pattern: Arcanoweave Robe
	[21908]="60000:9:1:1:Tailoring::1:0:22213,29511", -- Pattern: Spellfire Belt
	[21909]="60000:9:1:1:Tailoring::1:0:22213,29511", -- Pattern: Spellfire Gloves
	[21910]="60000:9:1:1:Tailoring::1:0:22213,29511", -- Pattern: Spellfire Robe
	[21911]="60000:9:3:1:Tailoring::1:0:22213,29511", -- Pattern: Spellfire Bag
	[21912]="60000:9:1:1:Tailoring::1:0:22212,29510", -- Pattern: Frozen Shadoweave Shoulders
	[21913]="60000:9:1:1:Tailoring::1:0:22212,29510", -- Pattern: Frozen Shadoweave Robe
	[21914]="60000:9:1:1:Tailoring::1:0:22212,29510", -- Pattern: Frozen Shadoweave Boots
	[21915]="60000:9:3:1:Tailoring::1:0:22212,29510", -- Pattern: Ebon Shadowbag
	[21916]="60000:9:1:1:Tailoring::1:0:22208,29512", -- Pattern: Primal Mooncloth Belt
	[21917]="60000:9:1:1:Tailoring::1:0:22208,29512", -- Pattern: Primal Mooncloth Robe
	[21918]="60000:9:1:1:Tailoring::1:0:22208,29512", -- Pattern: Primal Mooncloth Shoulders
	[21919]="60000:9:3:1:Tailoring::1:0:22208,29512", -- Pattern: Primal Mooncloth Bag
	[21920]="0:15:1:1:Junk::1:0:", -- Creased Letter
	[21921]="0:15:1:1:Junk::1:0:", -- Carefully Penned Note
	[21925]="0:15:1:1:Junk::1:0:", -- Immaculate Letter
	[21926]="0:15:1:1:Junk::1:0:", -- Slightly Creased Note
	[21927]="1500:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,23732,24148,24313,24349,24357,24780,25043,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,33630,33674,37904,37935", -- Instant Poison VII
	[21928]="0:12:1:20:::1:0:", -- Winterspring Blood Sample
	[21929]="0:3:2:20:GemOrange:171,202,755:1:0:", -- Flame Spessarite
	[21931]="0:4:2:1:Ring::1:0:", -- Woven Copper Ring
	[21932]="0:4:2:1:Ring::1:0:", -- Heavy Copper Ring
	[21933]="0:4:2:1:Amulet::1:0:", -- Thick Bronze Necklace
	[21934]="0:4:2:1:Amulet::1:0:", -- Ornate Tigerseye Necklace
	[21935]="0:12:1:20:::1:0:", -- Stable Ectoplasm
	[21936]="0:12:1:20:::1:0:", -- Frozen Ectoplasm
	[21937]="0:12:1:20:::1:0:", -- Scorched Ectoplasm
	[21938]="0:12:1:1:::1:0:", -- Magma Core
	[21939]="400000:12:1:1:::1:0:16015", -- Fel Elemental Rod
	[21940]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Golden Hare
	[21941]="5000:9:1:1:Jewelcrafting::1:1:989,4897", -- Design: Black Pearl Panther
	[21942]="6000:9:1:1:Jewelcrafting::1:1:2810,2821", -- Design: Ruby Crown of Restoration
	[21943]="6000:9:1:1:Jewelcrafting::1:1:1148,4897", -- Design: Truesilver Crab
	[21944]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Truesilver Boar
	[21945]="0:9:2:1:Jewelcrafting::1:0:", -- Design: The Aquamarine Ward
	[21946]="0:12:1:1:::1:0:", -- Ectoplasmic Distiller
	[21947]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Gem Studded Band
	[21948]="7500:9:1:1:Jewelcrafting::1:1:5163,8363,16624,17512", -- Design: Opal Necklace of Impact
	[21949]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Ruby Serpent
	[21952]="10000:9:1:1:Jewelcrafting::1:1:15179", -- Design: Emerald Crown of Destruction
	[21953]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Emerald Owl
	[21954]="10000:9:1:1:Jewelcrafting::1:1:12941", -- Design: Ring of Bitter Shadows
	[21955]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Black Diamond Crab
	[21956]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Dark Iron Scorpid
	[21957]="13500:9:1:1:Jewelcrafting::1:1:11189", -- Design: Necklace of the Diamond Tower
	[21960]="0:15:1:20:Holiday::1:0:", -- Handmade Woodcraft
	[21975]="0:15:1:1:Holiday::1:0:", -- Pledge of Adoration: Stormwind
	[21979]="0:15:1:1:Holiday::1:0:", -- Gift of Adoration: Darnassus
	[21980]="0:15:1:1:Holiday::1:0:", -- Gift of Adoration: Ironforge
	[21981]="0:15:1:1:Holiday::1:0:", -- Gift of Adoration: Stormwind
	[21982]="0:12:1:25:::1:0:", -- Ogre Warbeads
	[21983]="0:12:1:1:::1:0:", -- Incomplete Banner of Provocation
	[21984]="0:12:1:1:::1:0:", -- Left Piece of Lord Valthalak's Amulet
	[21985]="0:12:1:1:::1:0:", -- Sealed Blood Container
	[21986]="0:12:1:1:::1:0:", -- Banner of Provocation
	[21987]="0:12:1:1:::1:0:", -- Incendicite of Incendius
	[21988]="0:12:1:1:::1:0:", -- Ember of Emberseer
	[21989]="0:12:1:1:::1:0:", -- Cinder of Cynders
	[21990]="0:0:1:20:Bandage::1:0:", -- Netherweave Bandage
	[21991]="0:0:1:20:Bandage::1:0:", -- Heavy Netherweave Bandage
	[21992]="20000:9:1:1:FirstAid::1:0:18990,18991,26947", -- Manual: Netherweave Bandage
	[21993]="40000:9:1:1:FirstAid::1:0:18990,18991,26947", -- Manual: Heavy Netherweave Bandage
	[21994]="0:4:3:1:Plate::1:0:", -- Belt of Heroism
	[21995]="0:4:4:1:Plate::1:0:", -- Boots of Heroism
	[21996]="0:4:3:1:Plate::1:0:", -- Bracers of Heroism
	[21997]="0:4:4:1:Plate::1:0:", -- Breastplate of Heroism
	[21998]="0:4:4:1:Plate::1:0:", -- Gauntlets of Heroism
	[21999]="0:4:4:1:Plate::1:0:", -- Helm of Heroism
	[22000]="0:4:3:1:Plate::1:0:", -- Legplates of Heroism
	[22001]="0:4:3:1:Plate::1:0:", -- Spaulders of Heroism
	[22002]="0:4:3:1:Leather::1:0:", -- Darkmantle Belt
	[22003]="0:4:4:1:Leather::1:0:", -- Darkmantle Boots
	[22004]="0:4:3:1:Leather::1:0:", -- Darkmantle Bracers
	[22005]="0:4:4:1:Leather::1:0:", -- Darkmantle Cap
	[22006]="0:4:4:1:Leather::1:0:", -- Darkmantle Gloves
	[22007]="0:4:3:1:Leather::1:0:", -- Darkmantle Pants
	[22008]="0:4:3:1:Leather::1:0:", -- Darkmantle Spaulders
	[22009]="0:4:4:1:Leather::1:0:", -- Darkmantle Tunic
	[22010]="0:4:3:1:Mail::1:0:", -- Beastmaster's Belt
	[22011]="0:4:3:1:Mail::1:0:", -- Beastmaster's Bindings
	[22012]="50000:9:1:1:FirstAid::1:0:18990,18991,26947", -- Master First Aid - Doctor in the House
	[22013]="0:4:4:1:Mail::1:0:", -- Beastmaster's Cap
	[22014]="1333333:12:1:1:::1:0:10856,10857,11536", -- Hallowed Brazier
	[22015]="0:4:4:1:Mail::1:0:", -- Beastmaster's Gloves
	[22016]="0:4:3:1:Mail::1:0:", -- Beastmaster's Mantle
	[22017]="0:4:3:1:Mail::1:0:", -- Beastmaster's Pants
	[22018]="0:0:1:20:FoodDrink::1:0:", -- Conjured Glacier Water
	[22019]="0:0:1:20:FoodDrink::1:0:", -- Conjured Croissant
	[22044]="0:0:1:1:Consumable::1:0:", -- Mana Emerald
	[22046]="0:12:1:1:::1:0:", -- Right Piece of Lord Valthalak's Amulet
	[22047]="0:12:1:1:::1:0:", -- Top Piece of Lord Valthalak's Amulet
	[22048]="0:12:1:1:::1:0:", -- Lord Valthalak's Amulet
	[22049]="0:12:1:1:::1:0:", -- Brazier of Beckoning
	[22050]="0:12:1:1:::1:0:", -- Brazier of Beckoning
	[22051]="0:12:1:1:::1:0:", -- Brazier of Beckoning
	[22052]="0:12:1:1:::1:0:", -- Brazier of Beckoning
	[22053]="1000:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,23732,24148,24313,24349,24357,24780,25043,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,33630,33674,37904,37935", -- Deadly Poison VI
	[22054]="1500:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,23732,24148,24313,24349,24357,24780,25043,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,33630,33674,37904,37935", -- Deadly Poison VII
	[22055]="900:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,12096,12097,15175,16268,16588,16683,16829,18006,18019,18802,19013,19014,19049,19239,19679,20081,20121,20194,20915,20986,22479,23145,23373,23732,24148,24313,24349,24357,24780,25043,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,33630,33674,37904,37935", -- Wound Poison V
	[22056]="0:12:1:1:::1:0:", -- Brazier of Beckoning
	[22057]="0:12:1:1:::1:0:", -- Brazier of Invocation
	[22058]="0:15:1:1:Holiday::1:0:", -- Valentine's Day Stationery
	[22059]="0:15:1:1:Junk::1:0:", -- Valentine's Day Card
	[22060]="0:4:4:1:Mail::1:0:", -- Beastmaster's Tunic
	[22061]="0:4:4:1:Mail::1:0:", -- Beastmaster's Boots
	[22062]="0:4:3:1:Cloth::1:0:", -- Sorcerer's Belt
	[22063]="0:4:3:1:Cloth::1:0:", -- Sorcerer's Bindings
	[22064]="0:4:4:1:Cloth::1:0:", -- Sorcerer's Boots
	[22065]="0:4:4:1:Cloth::1:0:", -- Sorcerer's Crown
	[22066]="0:4:4:1:Cloth::1:0:", -- Sorcerer's Gloves
	[22067]="0:4:3:1:Cloth::1:0:", -- Sorcerer's Leggings
	[22068]="0:4:3:1:Cloth::1:0:", -- Sorcerer's Mantle
	[22069]="0:4:4:1:Cloth::1:0:", -- Sorcerer's Robes
	[22070]="0:4:3:1:Cloth::1:0:", -- Deathmist Belt
	[22071]="0:4:3:1:Cloth::1:0:", -- Deathmist Bracers
	[22072]="0:4:3:1:Cloth::1:0:", -- Deathmist Leggings
	[22073]="0:4:3:1:Cloth::1:0:", -- Deathmist Mantle
	[22074]="0:4:4:1:Cloth::1:0:", -- Deathmist Mask
	[22075]="0:4:4:1:Cloth::1:0:", -- Deathmist Robe
	[22076]="0:4:4:1:Cloth::1:0:", -- Deathmist Sandals
	[22077]="0:4:4:1:Cloth::1:0:", -- Deathmist Wraps
	[22078]="0:4:3:1:Cloth::1:0:", -- Virtuous Belt
	[22079]="0:4:3:1:Cloth::1:0:", -- Virtuous Bracers
	[22080]="0:4:4:1:Cloth::1:0:", -- Virtuous Crown
	[22081]="0:4:4:1:Cloth::1:0:", -- Virtuous Gloves
	[22082]="0:4:3:1:Cloth::1:0:", -- Virtuous Mantle
	[22083]="0:4:4:1:Cloth::1:0:", -- Virtuous Robe
	[22084]="0:4:4:1:Cloth::1:0:", -- Virtuous Sandals
	[22085]="0:4:3:1:Cloth::1:0:", -- Virtuous Skirt
	[22086]="0:4:3:1:Plate::1:0:", -- Soulforge Belt
	[22087]="0:4:4:1:Plate::1:0:", -- Soulforge Boots
	[22088]="0:4:3:1:Plate::1:0:", -- Soulforge Bracers
	[22089]="0:4:4:1:Plate::1:0:", -- Soulforge Breastplate
	[22090]="0:4:4:1:Plate::1:0:", -- Soulforge Gauntlets
	[22091]="0:4:4:1:Plate::1:0:", -- Soulforge Helm
	[22092]="0:4:3:1:Plate::1:0:", -- Soulforge Legplates
	[22093]="0:4:3:1:Plate::1:0:", -- Soulforge Spaulders
	[22094]="0:12:1:25:::1:0:", -- Bloodkelp
	[22095]="0:4:3:1:Mail::1:0:", -- Bindings of The Five Thunders
	[22096]="0:4:4:1:Mail::1:0:", -- Boots of The Five Thunders
	[22097]="0:4:4:1:Mail::1:0:", -- Coif of The Five Thunders
	[22098]="0:4:3:1:Mail::1:0:", -- Cord of The Five Thunders
	[22099]="0:4:4:1:Mail::1:0:", -- Gauntlets of The Five Thunders
	[22100]="0:4:3:1:Mail::1:0:", -- Kilt of The Five Thunders
	[22101]="0:4:3:1:Mail::1:0:", -- Pauldrons of The Five Thunders
	[22102]="0:4:4:1:Mail::1:0:", -- Vest of The Five Thunders
	[22103]="0:0:1:1:Other::1:0:", -- Master Healthstone
	[22104]="0:0:1:1:Other::1:0:", -- Master Healthstone
	[22105]="0:0:1:1:Other::1:0:", -- Master Healthstone
	[22106]="0:4:3:1:Leather::1:0:", -- Feralheart Belt
	[22107]="0:4:4:1:Leather::1:0:", -- Feralheart Boots
	[22108]="0:4:3:1:Leather::1:0:", -- Feralheart Bracers
	[22109]="0:4:4:1:Leather::1:0:", -- Feralheart Cowl
	[22110]="0:4:4:1:Leather::1:0:", -- Feralheart Gloves
	[22111]="0:4:3:1:Leather::1:0:", -- Feralheart Kilt
	[22112]="0:4:3:1:Leather::1:0:", -- Feralheart Spaulders
	[22113]="0:4:4:1:Leather::1:0:", -- Feralheart Vest
	[22114]="0:15:3:1:Companion::1:0:", -- Pink Murloc Egg
	[22115]="0:12:1:1:::1:0:", -- Extra-Dimensional Ghost Revealer
	[22116]="0:0:1:1:Consumable::1:0:", -- Master Soulstone
	[22117]="0:15:1:20:Holiday::1:0:", -- Pledge of Loyalty: Stormwind
	[22119]="0:15:1:20:Holiday::1:0:", -- Pledge of Loyalty: Ironforge
	[22120]="0:15:1:20:Holiday::1:0:", -- Pledge of Loyalty: Darnassus
	[22121]="0:15:1:20:Holiday::1:0:", -- Pledge of Loyalty: Undercity
	[22122]="0:15:1:20:Holiday::1:0:", -- Pledge of Loyalty: Thunder Bluff
	[22123]="0:15:1:20:Holiday::1:0:", -- Pledge of Loyalty: Orgrimmar
	[22131]="0:15:1:1:Holiday::1:0:", -- Stormwind Gift Collection
	[22132]="0:15:1:1:Holiday::1:0:", -- Ironforge Gift Collection
	[22133]="0:15:1:1:Holiday::1:0:", -- Darnassus Gift Collection
	[22134]="0:15:1:1:Holiday::1:0:", -- Undercity Gift Collection
	[22135]="0:15:1:1:Holiday::1:0:", -- Thunder Bluff Gift Collection
	[22136]="0:15:1:1:Holiday::1:0:", -- Orgrimmar Gift Collection
	[22137]="0:15:1:1:Junk::1:0:", -- Ysida's Satchel
	[22138]="0:12:1:50:::1:0:", -- Blackrock Bracer
	[22139]="0:12:1:1:::1:0:", -- Ysida's Locket
	[22140]="0:15:1:20:Holiday::1:0:", -- Sentinel's Card
	[22141]="0:15:1:20:Holiday::1:0:", -- Ironforge Guard's Card
	[22142]="0:15:1:20:Holiday::1:0:", -- Grunt's Card
	[22143]="0:15:1:20:Holiday::1:0:", -- Stormwind Guard's Card
	[22144]="0:15:1:20:Holiday::1:0:", -- Bluffwatcher's Card
	[22145]="0:15:1:20:Holiday::1:0:", -- Guardian's Moldy Card
	[22146]="0:9:3:1:Book::1:0:", -- Book: Gift of the Wild III
	[22147]="5000:15:1:20:Reagent:-11:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24396,24409,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,37904,37935", -- Flintweed Seed
	[22148]="1500:15:1:20:Reagent:-11:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24396,24409,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29288,29537,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,37904,37935", -- Wild Quillvine
	[22149]="0:4:3:1:Amulet::1:0:", -- Beads of Ogre Mojo
	[22150]="0:4:3:1:Amulet::1:0:", -- Beads of Ogre Might
	[22153]="0:9:3:1:Book::1:0:", -- Tome of Arcane Brilliance 2
	[22154]="0:15:1:1:Holiday::1:0:", -- Pledge of Adoration: Ironforge
	[22155]="0:15:1:1:Holiday::1:0:", -- Pledge of Adoration: Darnassus
	[22156]="0:15:1:1:Holiday::1:0:", -- Pledge of Adoration: Orgrimmar
	[22157]="0:15:1:1:Holiday::1:0:", -- Pledge of Adoration: Undercity
	[22158]="0:15:1:1:Holiday::1:0:", -- Pledge of Adoration: Thunder Bluff
	[22159]="0:15:1:1:Holiday::1:0:", -- Pledge of Friendship: Darnassus
	[22160]="0:15:1:1:Holiday::1:0:", -- Pledge of Friendship: Ironforge
	[22161]="0:15:1:1:Holiday::1:0:", -- Pledge of Friendship: Orgrimmar
	[22162]="0:15:1:1:Holiday::1:0:", -- Pledge of Friendship: Thunder Bluff
	[22163]="0:15:1:1:Holiday::1:0:", -- Pledge of Friendship: Undercity
	[22164]="0:15:1:1:Holiday::1:0:", -- Gift of Adoration: Orgrimmar
	[22165]="0:15:1:1:Holiday::1:0:", -- Gift of Adoration: Thunder Bluff
	[22166]="0:15:1:1:Holiday::1:0:", -- Gift of Adoration: Undercity
	[22167]="0:15:1:1:Holiday::1:0:", -- Gift of Friendship: Darnassus
	[22168]="0:15:1:1:Holiday::1:0:", -- Gift of Friendship: Ironforge
	[22169]="0:15:1:1:Holiday::1:0:", -- Gift of Friendship: Orgrimmar
	[22170]="0:15:1:1:Holiday::1:0:", -- Gift of Friendship: Stormwind
	[22171]="0:15:1:1:Holiday::1:0:", -- Gift of Friendship: Thunder Bluff
	[22172]="0:15:1:1:Holiday::1:0:", -- Gift of Friendship: Undercity
	[22173]="0:15:1:20:Holiday::1:0:", -- Dwarven Homebrew
	[22174]="0:15:1:20:Holiday::1:0:", -- Romantic Poem
	[22175]="0:15:1:20:Holiday::1:0:", -- Freshly Baked Pie
	[22176]="0:15:1:20:Holiday::1:0:", -- Homemade Bread
	[22177]="0:15:1:20:Holiday::1:0:", -- Freshly Picked Flowers
	[22178]="0:15:1:1:Holiday::1:0:", -- Pledge of Friendship: Stormwind
	[22179]="54000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Firebolt (Rank 8)
	[22180]="26000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Blood Pact (Rank 6)
	[22181]="36000:9:1:1:Book::1:0:5520,5749,5750,5753,5815,6027,6328,6373,6374,6376,6382,12776,12807,15494,16267,16649,23535", -- Grimoire of Fire Shield (Rank 6)
	[22182]="67000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Torment (Rank 7)
	[22183]="32000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Suffering (Rank 5)
	[22184]="44000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Consume Shadows (Rank 7)
	[22185]="36000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Sacrifice (Rank 7)
	[22186]="54000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Lash of Pain (Rank 7)
	[22187]="67000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Soothing Kiss (Rank 5)
	[22188]="29000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Devour Magic (Rank 5)
	[22189]="67000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Devour Magic (Rank 6)
	[22190]="36000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Tainted Blood (Rank 5)
	[22191]="0:4:4:1:Mail::1:0:", -- Obsidian Mail Tunic
	[22192]="0:0:1:20:Consumable::1:0:", -- Bloodkelp Elixir of Dodging
	[22193]="0:0:1:20:Consumable::1:0:", -- Bloodkelp Elixir of Resistance
	[22194]="0:4:4:1:Mail::1:0:", -- Black Grasp of the Destroyer
	[22195]="0:4:3:1:Mail::1:0:", -- Light Obsidian Belt
	[22196]="0:4:4:1:Plate::1:0:", -- Thick Obsidian Breastplate
	[22197]="0:4:3:1:Plate::1:0:", -- Heavy Obsidian Belt
	[22198]="0:4:4:1:Shield::1:0:", -- Jagged Obsidian Shield
	[22200]="0:15:1:20:Companion::5:0:37674", -- Silver Shafted Arrow
	[22201]="0:12:1:1:::1:0:", -- Reliquary of Purity
	[22202]="0:7:1:10:MetalStone:164:1:0:", -- Small Obsidian Shard
	[22203]="0:7:1:10:MetalStone:164:1:0:", -- Large Obsidian Shard
	[22204]="0:4:3:1:Leather::1:0:", -- Wristguards of Renown
	[22205]="0:4:3:1:Plate::1:0:", -- Black Steel Bindings
	[22206]="0:4:2:1:OffHandFrill::1:0:", -- Bouquet of Red Roses
	[22207]="0:4:3:1:Mail::1:0:", -- Sash of the Grand Hunt
	[22208]="0:2:3:1:TwoHandMace::1:0:", -- Lavastone Hammer
	[22209]="50000:9:1:1:Blacksmithing::1:0:15176", -- Plans: Heavy Obsidian Belt
	[22212]="0:4:3:1:Mail::1:0:", -- Golem Fitted Pauldrons
	[22214]="50000:9:1:1:Blacksmithing::1:0:15176", -- Plans: Light Obsidian Belt
	[22216]="0:12:1:1:::1:0:", -- Venoxis's Venom Sac
	[22217]="0:12:1:1:::1:0:", -- Kurinnaxx's Venom Sac
	[22218]="0:15:1:20:Holiday::5:0:37674", -- Handful of Rose Petals
	[22219]="50000:9:1:1:Blacksmithing::1:1:15471", -- Plans: Jagged Obsidian Shield
	[22220]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Black Grasp of the Destroyer
	[22221]="80000:9:1:1:Blacksmithing::1:1:15471", -- Plans: Obsidian Mail Tunic
	[22222]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Thick Obsidian Breastplate
	[22223]="0:4:3:1:Plate::1:0:", -- Foreman's Head Protector
	[22224]="0:12:1:1:::1:0:", -- Jeering Spectre's Essence
	[22225]="0:4:3:1:Cloth::1:0:", -- Dragonskin Cowl
	[22226]="0:12:1:1:::1:0:", -- Druidical Remains
	[22227]="0:12:1:1:::1:0:", -- Starbreeze Village Relic
	[22228]="0:12:1:1:::1:0:", -- Brilliant Sword of Zealotry
	[22229]="0:12:1:1:::1:0:", -- Soul Ashes of the Banished
	[22231]="0:4:3:1:Cloth::1:0:", -- Kayser's Boots of Precision
	[22232]="0:4:3:1:Mail::1:0:", -- Marksman's Girdle
	[22234]="0:4:3:1:Cloth::1:0:", -- Mantle of Lost Hope
	[22235]="0:15:1:1:Companion::1:0:37674", -- Truesilver Shafted Arrow
	[22236]="0:0:1:20:Consumable::1:0:", -- Buttermilk Delight
	[22237]="0:0:1:20:Consumable::1:0:", -- Dark Desire
	[22238]="0:0:1:20:Consumable::1:0:", -- Very Berry Cream
	[22239]="0:0:1:20:Consumable::1:0:", -- Sweet Surprise
	[22240]="0:4:3:1:Mail::1:0:", -- Greaves of Withering Despair
	[22241]="0:4:3:1:Leather::1:0:", -- Dark Warder's Pauldrons
	[22242]="0:4:3:1:Mail::1:0:", -- Verek's Leash
	[22243]="0:1:2:1:SoulBag::1:0:", -- Small Soul Pouch
	[22244]="0:1:2:1:SoulBag::1:0:", -- Box of Souls
	[22245]="0:4:3:1:Cloth::1:0:", -- Soot Encrusted Footwear
	[22246]="0:1:2:1:EnchantingBag::1:0:", -- Enchanted Mageweave Pouch
	[22247]="0:4:3:1:Cloth::1:0:", -- Faith Healer's Boots
	[22248]="0:1:2:1:EnchantingBag::1:0:", -- Enchanted Runecloth Bag
	[22249]="0:1:2:1:EnchantingBag::1:0:", -- Big Bag of Enchantment
	[22250]="1000:1:2:1:HerbBag::1:0:3405,3548,4216,4615,4899,5138,5503,16367,26568,27053,27141,28727,28828,28868,33639,33678", -- Herb Pouch
	[22251]="0:1:2:1:HerbBag::1:0:", -- Cenarion Herb Bag
	[22252]="0:1:2:1:HerbBag::1:0:", -- Satchel of Cenarius
	[22253]="0:4:3:1:OffHandFrill::1:0:", -- Tome of the Lost
	[22254]="0:2:3:1:Wand::1:0:", -- Wand of Eternal Light
	[22255]="0:4:3:1:Ring::1:0:", -- Magma Forged Band
	[22256]="0:4:3:1:Cloth::1:0:", -- Mana Shaping Handwraps
	[22257]="0:4:3:1:Ring::1:0:", -- Bloodclot Band
	[22259]="0:0:1:20:Consumable::1:0:", -- Unbestowed Friendship Bracelet
	[22260]="0:0:1:100:Consumable::1:0:", -- Friendship Bracelet
	[22261]="0:15:1:10:CombatPet::1:0:37674", -- Love Fool
	[22262]="0:15:1:1:Holiday::1:0:", -- Alliance Gift Collection
	[22263]="0:15:1:1:Holiday::1:0:", -- Horde Gift Collection
	[22264]="0:15:1:1:Junk::1:0:", -- Carefully Written Letter
	[22265]="0:15:1:1:Junk::1:0:", -- Lovingly Composed Letter
	[22266]="0:2:3:1:Dagger::1:0:", -- Flarethorn
	[22267]="0:4:3:1:Cloth::1:0:", -- Spellweaver's Turban
	[22268]="0:4:3:1:Trinket::1:0:", -- Draconic Infused Emblem
	[22269]="0:4:3:1:Cloak::1:0:", -- Shadow Prowler's Cloak
	[22270]="0:4:3:1:Plate::1:0:", -- Entrenching Boots
	[22271]="0:4:3:1:Leather::1:0:", -- Leggings of Frenzied Magic
	[22272]="0:4:3:1:Leather::1:0:", -- Forest's Embrace
	[22274]="0:4:3:1:Leather::1:0:", -- Grizzled Pelt
	[22275]="0:4:3:1:Leather::1:0:", -- Firemoss Boots
	[22276]="0:4:1:1:Miscellaneous::1:0:", -- Lovely Red Dress
	[22277]="0:4:1:1:Miscellaneous::1:0:", -- Red Dinner Suit
	[22278]="0:4:1:1:Miscellaneous::1:0:", -- Lovely Blue Dress
	[22279]="0:4:1:1:Miscellaneous::1:0:", -- Lovely Black Dress
	[22280]="0:4:1:1:Miscellaneous::1:0:", -- Lovely Purple Dress
	[22281]="0:4:1:1:Miscellaneous::1:0:", -- Blue Dinner Suit
	[22282]="0:4:1:1:Miscellaneous::1:0:", -- Purple Dinner Suit
	[22283]="0:15:1:1:Holiday::1:0:", -- Sack of Homemade Bread
	[22284]="0:15:1:1:Holiday::1:0:", -- Bundle of Cards
	[22285]="0:15:1:1:Holiday::1:0:", -- Stormwind Pledge Collection
	[22286]="0:15:1:1:Holiday::1:0:", -- Ironforge Pledge Collection
	[22287]="0:15:1:1:Holiday::1:0:", -- Parcel of Cards
	[22288]="0:15:1:1:Holiday::1:0:", -- Case of Homebrew
	[22289]="0:15:1:1:Holiday::1:0:", -- Stack of Cards
	[22290]="0:15:1:1:Holiday::1:0:", -- Darnassus Pledge Collection
	[22291]="0:15:1:1:Holiday::1:0:", -- Box of Woodcrafts
	[22292]="0:15:1:1:Holiday::1:0:", -- Box of Fresh Pies
	[22293]="0:15:1:1:Holiday::1:0:", -- Package of Cards
	[22294]="0:15:1:1:Holiday::1:0:", -- Orgrimmar Pledge Collection
	[22295]="0:15:1:1:Holiday::1:0:", -- Satchel of Cards
	[22296]="0:15:1:1:Holiday::1:0:", -- Basket of Flowers
	[22297]="0:15:1:1:Holiday::1:0:", -- Thunder Bluff Pledge Collection
	[22298]="0:15:1:1:Holiday::1:0:", -- Book of Romantic Poems
	[22299]="0:15:1:1:Holiday::1:0:", -- Sheaf of Cards
	[22300]="0:15:1:1:Holiday::1:0:", -- Undercity Pledge Collection
	[22301]="0:4:3:1:Cloth::1:0:", -- Ironweave Robe
	[22302]="0:4:3:1:Cloth::1:0:", -- Ironweave Cowl
	[22303]="0:4:3:1:Cloth::1:0:", -- Ironweave Pants
	[22304]="0:4:3:1:Cloth::1:0:", -- Ironweave Gloves
	[22305]="0:4:3:1:Cloth::1:0:", -- Ironweave Mantle
	[22306]="0:4:3:1:Cloth::1:0:", -- Ironweave Belt
	[22307]="6000:9:1:1:Tailoring::1:0:1318,3012,3346,4228,4617,5158,5757,5758,15419,16635,16722,18753,18773,18951,19234,19537,19540,19663,26569,27030,27054,27147,28714,33633,33676", -- Pattern: Enchanted Mageweave Pouch
	[22308]="20000:9:1:1:Tailoring::1:0:15419", -- Pattern: Enchanted Runecloth Bag
	[22309]="0:9:2:1:Tailoring::1:0:", -- Pattern: Big Bag of Enchantment
	[22310]="20000:9:1:1:Tailoring::1:0:15179", -- Pattern: Cenarion Herb Bag
	[22311]="0:4:3:1:Cloth::1:0:", -- Ironweave Boots
	[22312]="50000:9:1:1:Tailoring::1:0:15179", -- Pattern: Satchel of Cenarius
	[22313]="0:4:3:1:Cloth::1:0:", -- Ironweave Bracers
	[22314]="0:2:3:1:Polearm::1:0:", -- Huntsman's Harpoon
	[22315]="0:2:3:1:OneHandMace::1:0:", -- Hammer of Revitalization
	[22317]="0:2:3:1:FistWeapon::1:0:", -- Lefty's Brass Knuckle
	[22318]="0:2:3:1:Bow::1:0:", -- Malgen's Long Bow
	[22319]="0:4:3:1:OffHandFrill::1:0:", -- Tome of Divine Right
	[22320]="0:15:1:1:Junk::1:0:", -- Mux's Quality Goods
	[22321]="0:4:3:1:Trinket::1:0:", -- Heart of Wyrmthalak
	[22322]="0:2:3:1:OneHandMace::1:0:", -- The Jaw Breaker
	[22324]="4000:0:1:20:FoodDrink::5:0:11118", -- Winter Kimchi
	[22325]="0:4:3:1:Leather::1:0:", -- Belt of the Trickster
	[22326]="0:4:3:1:Ring::1:0:", -- Amalgam's Band
	[22327]="0:4:3:1:Amulet::1:0:", -- Amulet of the Redeemed
	[22328]="0:4:3:1:Plate::1:0:", -- Legplates of Vigilance
	[22329]="0:4:3:1:OffHandFrill::1:0:", -- Scepter of Interminable Focus
	[22330]="0:4:3:1:Cloak::1:0:", -- Shroud of Arcane Mastery
	[22331]="0:4:3:1:Ring::1:0:", -- Band of the Steadfast Hero
	[22332]="0:2:3:1:OneHandSword::1:0:", -- Blade of Necromancy
	[22333]="0:2:3:1:TwoHandMace::1:0:", -- Hammer of Divine Might
	[22334]="0:4:3:1:Ring::1:0:", -- Band of Mending
	[22335]="0:2:3:1:Stave::1:0:", -- Lord Valthalak's Staff of Command
	[22336]="0:4:3:1:Shield::1:0:", -- Draconian Aegis of the Legion
	[22337]="0:4:3:1:Cloak::1:0:", -- Shroud of Domination
	[22338]="0:12:1:30:::1:0:", -- Volcanic Ash
	[22339]="0:4:3:1:Ring::1:0:", -- Rune Band of Wizardry
	[22340]="0:4:3:1:Amulet::1:0:", -- Pendant of Celerity
	[22342]="0:4:3:1:Cloth::1:0:", -- Leggings of Torment
	[22343]="0:4:3:1:Mail::1:0:", -- Handguards of Savagery
	[22344]="0:15:1:1:Junk::1:0:", -- Brazier of Invocation: User's Manual
	[22345]="0:4:3:1:Totem::1:0:", -- Totem of Rebirth
	[22347]="0:2:3:1:Crossbow::1:0:", -- Fahrad's Reloading Repeater
	[22348]="0:2:3:1:TwoHandMace::1:0:", -- Doomulus Prime
	[22349]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Breastplate
	[22350]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Tunic
	[22351]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Robe
	[22352]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Legplates
	[22353]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Helmet
	[22354]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Pauldrons
	[22355]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Bracers
	[22356]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Waistguard
	[22357]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Gauntlets
	[22358]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Sabatons
	[22359]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Legguards
	[22360]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Headpiece
	[22361]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Spaulders
	[22362]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Wristguards
	[22363]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Girdle
	[22364]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Handguards
	[22365]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Boots
	[22366]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Leggings
	[22367]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Circlet
	[22368]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Shoulderpads
	[22369]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Bindings
	[22370]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Belt
	[22371]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Gloves
	[22372]="0:15:4:1:ArmorToken::1:0:", -- Desecrated Sandals
	[22373]="0:12:3:200:::1:0:", -- Wartorn Leather Scrap
	[22374]="0:12:3:200:::1:0:", -- Wartorn Chain Scrap
	[22375]="0:12:3:200:::1:0:", -- Wartorn Plate Scrap
	[22376]="0:12:3:200:::1:0:", -- Wartorn Cloth Scrap
	[22377]="0:2:3:1:Dagger::1:0:", -- The Thunderwood Poker
	[22378]="0:2:3:1:OneHandSword::1:0:", -- Ravenholdt Slicer
	[22379]="0:2:3:1:Dagger::1:0:", -- Shivsprocket's Shiv
	[22380]="0:2:3:1:OneHandMace::1:0:", -- Simone's Cultivating Hammer
	[22381]="0:12:1:20:::1:0:", -- Silithus Venom Sample
	[22382]="0:12:1:1:::1:0:", -- Sealed Venom Container
	[22383]="0:2:4:1:OneHandSword::1:0:", -- Sageblade
	[22384]="0:2:4:1:OneHandMace::1:0:", -- Persuader
	[22385]="0:4:4:1:Plate::1:0:", -- Titanic Leggings
	[22388]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Titanic Leggings
	[22389]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Sageblade
	[22390]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Persuader
	[22392]="25000:9:1:1:Enchanting::1:0:11557", -- Formula: Enchant 2H Weapon - Agility
	[22393]="0:9:3:1:Book::1:0:", -- Codex: Prayer of Shadow Protection
	[22394]="0:2:3:1:Stave::1:0:", -- Staff of Metanoia
	[22395]="0:4:3:1:Totem::1:0:", -- Totem of Rage
	[22396]="0:4:4:1:Totem::1:0:", -- Totem of Life
	[22397]="0:4:3:1:Idol::1:0:", -- Idol of Ferocity
	[22398]="0:4:3:1:Idol::1:0:", -- Idol of Rejuvenation
	[22399]="0:4:4:1:Idol::1:0:", -- Idol of Health
	[22400]="0:4:3:1:Libram::1:0:", -- Libram of Truth
	[22401]="0:4:3:1:Libram::1:0:", -- Libram of Hope
	[22402]="0:4:4:1:Libram::1:0:", -- Libram of Grace
	[22403]="0:4:3:1:Amulet::1:0:", -- Diana's Pearl Necklace
	[22404]="0:2:3:1:FistWeapon::1:0:", -- Willey's Back Scratcher
	[22405]="0:4:3:1:Cloth::1:0:", -- Mantle of the Scarlet Crusade
	[22406]="0:2:3:1:Stave::1:0:", -- Redemption
	[22407]="0:4:3:1:Leather::1:0:", -- Helm of the New Moon
	[22408]="0:2:3:1:Wand::1:0:", -- Ritssyn's Wand of Bad Mojo
	[22409]="0:4:3:1:Leather::1:0:", -- Tunic of the Crescent Moon
	[22410]="0:4:3:1:Mail::1:0:", -- Gauntlets of Deftness
	[22411]="0:4:3:1:Plate::1:0:", -- Helm of the Executioner
	[22412]="0:4:3:1:Cloth::1:0:", -- Thuzadin Mantle
	[22413]="0:12:1:20:::1:0:", -- Sin'dorei Armaments
	[22414]="0:12:1:1:::1:0:", -- Antheol's Elemental Grimoire
	[22416]="0:4:4:1:Plate::1:0:", -- Dreadnaught Breastplate
	[22417]="0:4:4:1:Plate::1:0:", -- Dreadnaught Legplates
	[22418]="0:4:4:1:Plate::1:0:", -- Dreadnaught Helmet
	[22419]="0:4:4:1:Plate::1:0:", -- Dreadnaught Pauldrons
	[22420]="0:4:4:1:Plate::1:0:", -- Dreadnaught Sabatons
	[22421]="0:4:4:1:Plate::1:0:", -- Dreadnaught Gauntlets
	[22422]="0:4:4:1:Plate::1:0:", -- Dreadnaught Waistguard
	[22423]="0:4:4:1:Plate::1:0:", -- Dreadnaught Bracers
	[22424]="0:4:4:1:Plate::1:0:", -- Redemption Wristguards
	[22425]="0:4:4:1:Plate::1:0:", -- Redemption Tunic
	[22426]="0:4:4:1:Plate::1:0:", -- Redemption Handguards
	[22427]="0:4:4:1:Plate::1:0:", -- Redemption Legguards
	[22428]="0:4:4:1:Plate::1:0:", -- Redemption Headpiece
	[22429]="0:4:4:1:Plate::1:0:", -- Redemption Spaulders
	[22430]="0:4:4:1:Plate::1:0:", -- Redemption Boots
	[22431]="0:4:4:1:Plate::1:0:", -- Redemption Girdle
	[22432]="0:12:1:20:::1:0:", -- Devilsaur Barb
	[22433]="0:4:3:1:Ring::1:0:", -- Don Mauricio's Band of Domination
	[22434]="0:15:1:10:Junk::1:0:", -- Bloodcap
	[22435]="0:15:1:10:Junk::1:0:", -- Gorishi Sting
	[22436]="0:4:4:1:Mail::1:0:", -- Cryptstalker Tunic
	[22437]="0:4:4:1:Mail::1:0:", -- Cryptstalker Legguards
	[22438]="0:4:4:1:Mail::1:0:", -- Cryptstalker Headpiece
	[22439]="0:4:4:1:Mail::1:0:", -- Cryptstalker Spaulders
	[22440]="0:4:4:1:Mail::1:0:", -- Cryptstalker Boots
	[22441]="0:4:4:1:Mail::1:0:", -- Cryptstalker Handguards
	[22442]="0:4:4:1:Mail::1:0:", -- Cryptstalker Girdle
	[22443]="0:4:4:1:Mail::1:0:", -- Cryptstalker Wristguards
	[22444]="0:15:1:10:Junk::1:0:", -- Putrid Vine
	[22445]="0:7:1:20:Enchanting:164,333,202,165,197:1:0:", -- Arcane Dust
	[22446]="0:7:2:10:Enchanting:333,197:1:0:", -- Greater Planar Essence
	[22447]="0:7:2:10:Enchanting:333:1:0:", -- Lesser Planar Essence
	[22448]="0:7:3:20:Enchanting:333,202,165:1:0:", -- Small Prismatic Shard
	[22449]="0:7:3:20:Enchanting:164,333,202:1:0:", -- Large Prismatic Shard
	[22450]="0:7:4:20:Enchanting:164,333,165,197:1:0:", -- Void Crystal
	[22451]="0:7:2:20:Elemental:171,164,333,202,755,165,197:1:0:", -- Primal Air
	[22452]="0:7:2:20:Elemental:171,164,333,202,755,165,186,197:1:0:", -- Primal Earth
	[22456]="0:7:2:20:Elemental:171,164,333,202,755,165,197:1:0:", -- Primal Shadow
	[22457]="0:7:2:20:Elemental:171,164,333,202,755,165,197:1:0:", -- Primal Mana
	[22458]="0:2:3:1:Stave::1:0:", -- Moonshadow Stave
	[22459]="0:3:4:1:GemPrismatic::1:0:", -- Void Sphere
	[22460]="0:3:3:1:GemPrismatic::1:0:", -- Prismatic Sphere
	[22461]="0:7:1:1:Enchanting:333:1:0:", -- Runed Fel Iron Rod
	[22462]="0:7:2:1:Enchanting:333:1:0:", -- Runed Adamantite Rod
	[22463]="0:7:3:1:Enchanting:333:1:0:", -- Runed Eternium Rod
	[22464]="0:4:4:1:Mail::1:0:", -- Earthshatter Tunic
	[22465]="0:4:4:1:Mail::1:0:", -- Earthshatter Legguards
	[22466]="0:4:4:1:Mail::1:0:", -- Earthshatter Headpiece
	[22467]="0:4:4:1:Mail::1:0:", -- Earthshatter Spaulders
	[22468]="0:4:4:1:Mail::1:0:", -- Earthshatter Boots
	[22469]="0:4:4:1:Mail::1:0:", -- Earthshatter Handguards
	[22470]="0:4:4:1:Mail::1:0:", -- Earthshatter Girdle
	[22471]="0:4:4:1:Mail::1:0:", -- Earthshatter Wristguards
	[22472]="0:4:3:1:Leather::1:0:", -- Boots of Ferocity
	[22473]="0:12:1:1:::1:0:", -- Antheol's Disciplinary Rod
	[22476]="0:4:4:1:Leather::1:0:", -- Bonescythe Breastplate
	[22477]="0:4:4:1:Leather::1:0:", -- Bonescythe Legplates
	[22478]="0:4:4:1:Leather::1:0:", -- Bonescythe Helmet
	[22479]="0:4:4:1:Leather::1:0:", -- Bonescythe Pauldrons
	[22480]="0:4:4:1:Leather::1:0:", -- Bonescythe Sabatons
	[22481]="0:4:4:1:Leather::1:0:", -- Bonescythe Gauntlets
	[22482]="0:4:4:1:Leather::1:0:", -- Bonescythe Waistguard
	[22483]="0:4:4:1:Leather::1:0:", -- Bonescythe Bracers
	[22484]="0:15:2:250:Junk::1:0:", -- Necrotic Rune
	[22487]="0:12:1:1:::1:0:", -- Aldaron's Head
	[22488]="0:4:4:1:Leather::1:0:", -- Dreamwalker Tunic
	[22489]="0:4:4:1:Leather::1:0:", -- Dreamwalker Legguards
	[22490]="0:4:4:1:Leather::1:0:", -- Dreamwalker Headpiece
	[22491]="0:4:4:1:Leather::1:0:", -- Dreamwalker Spaulders
	[22492]="0:4:4:1:Leather::1:0:", -- Dreamwalker Boots
	[22493]="0:4:4:1:Leather::1:0:", -- Dreamwalker Handguards
	[22494]="0:4:4:1:Leather::1:0:", -- Dreamwalker Girdle
	[22495]="0:4:4:1:Leather::1:0:", -- Dreamwalker Wristguards
	[22496]="0:4:4:1:Cloth::1:0:", -- Frostfire Robe
	[22497]="0:4:4:1:Cloth::1:0:", -- Frostfire Leggings
	[22498]="0:4:4:1:Cloth::1:0:", -- Frostfire Circlet
	[22499]="0:4:4:1:Cloth::1:0:", -- Frostfire Shoulderpads
	[22500]="0:4:4:1:Cloth::1:0:", -- Frostfire Sandals
	[22501]="0:4:4:1:Cloth::1:0:", -- Frostfire Gloves
	[22502]="0:4:4:1:Cloth::1:0:", -- Frostfire Belt
	[22503]="0:4:4:1:Cloth::1:0:", -- Frostfire Bindings
	[22504]="0:4:4:1:Cloth::1:0:", -- Plagueheart Robe
	[22505]="0:4:4:1:Cloth::1:0:", -- Plagueheart Leggings
	[22506]="0:4:4:1:Cloth::1:0:", -- Plagueheart Circlet
	[22507]="0:4:4:1:Cloth::1:0:", -- Plagueheart Shoulderpads
	[22508]="0:4:4:1:Cloth::1:0:", -- Plagueheart Sandals
	[22509]="0:4:4:1:Cloth::1:0:", -- Plagueheart Gloves
	[22510]="0:4:4:1:Cloth::1:0:", -- Plagueheart Belt
	[22511]="0:4:4:1:Cloth::1:0:", -- Plagueheart Bindings
	[22512]="0:4:4:1:Cloth::1:0:", -- Robe of Faith
	[22513]="0:4:4:1:Cloth::1:0:", -- Leggings of Faith
	[22514]="0:4:4:1:Cloth::1:0:", -- Circlet of Faith
	[22515]="0:4:4:1:Cloth::1:0:", -- Shoulderpads of Faith
	[22516]="0:4:4:1:Cloth::1:0:", -- Sandals of Faith
	[22517]="0:4:4:1:Cloth::1:0:", -- Gloves of Faith
	[22518]="0:4:4:1:Cloth::1:0:", -- Belt of Faith
	[22519]="0:4:4:1:Cloth::1:0:", -- Bindings of Faith
	[22520]="0:12:4:1:::1:0:", -- The Phylactery of Kel'Thuzad
	[22521]="0:0:1:1:EnhTemp::1:0:", -- Superior Mana Oil
	[22522]="0:0:1:1:EnhTemp::1:0:", -- Superior Wizard Oil
	[22523]="0:15:2:250:Junk::1:0:", -- Insignia of the Dawn
	[22524]="0:15:2:250:Junk::1:0:", -- Insignia of the Crusade
	[22525]="0:12:1:250:::1:0:", -- Crypt Fiend Parts
	[22526]="0:12:1:250:::1:0:", -- Bone Fragments
	[22527]="0:12:1:250:::1:0:", -- Core of Elements
	[22528]="0:12:1:250:::1:0:", -- Dark Iron Scraps
	[22529]="0:12:1:250:::1:0:", -- Savage Frond
	[22530]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Major Defense
	[22531]="60000:9:1:1:Enchanting::1:0:17657", -- Formula: Enchant Bracer - Superior Healing
	[22532]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Restore Mana Prime
	[22533]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Fortitude
	[22534]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Bracer - Spellpower
	[22535]="100000:9:1:1:Enchanting::1:0:17518", -- Formula: Enchant Ring - Striking
	[22536]="100000:9:1:1:Enchanting::1:0:21643", -- Formula: Enchant Ring - Spellpower
	[22537]="100000:9:1:1:Enchanting::1:0:21432", -- Formula: Enchant Ring - Healing Power
	[22538]="200000:9:1:1:Enchanting::1:0:21655", -- Formula: Enchant Ring - Stats
	[22539]="60000:9:1:1:Enchanting::1:1:18664", -- Formula: Enchant Shield - Intellect
	[22540]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Shield - Shield Block
	[22541]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Shield - Resistance
	[22542]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Boots - Vitality
	[22543]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Boots - Fortitude
	[22544]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Boots - Dexterity
	[22545]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Boots - Surefooted
	[22547]="60000:9:1:1:Enchanting::1:0:17657", -- Formula: Enchant Chest - Exceptional Stats
	[22548]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Major Resistance
	[22549]="0:12:1:1:::1:0:", -- Quartermaster Lymel's Bill of Lading
	[22550]="0:12:1:1:::1:0:", -- Quartermaster Lymel's Goods
	[22551]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Major Intellect
	[22552]="60000:9:1:1:Enchanting::1:0:20242,23007", -- Formula: Enchant Weapon - Major Striking
	[22553]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Potency
	[22554]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant 2H Weapon - Savagery
	[22555]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Major Spellpower
	[22556]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant 2H Weapon - Major Agility
	[22557]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Battlemaster
	[22558]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Spellsurge
	[22559]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Mongoose
	[22560]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Sunfire
	[22561]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Soulfrost
	[22562]="50000:9:1:1:Enchanting::1:1:16635,16722,19663", -- Formula: Superior Mana Oil
	[22563]="70000:9:1:1:Enchanting::1:1:16635,16722,19663", -- Formula: Superior Wizard Oil
	[22565]="60000:9:1:1:Enchanting::1:1:16635,16722,19663", -- Formula: Large Prismatic Shard
	[22566]="0:12:1:20:::1:0:", -- Phantasmal Substance
	[22567]="0:12:1:20:::1:0:", -- Gargoyle Fragment
	[22568]="0:15:1:1:Junk::1:0:", -- Sealed Craftsman's Writ
	[22570]="0:12:1:20:::1:0:", -- Plagued Blood Sample
	[22571]="0:1:1:1:Bag::1:0:", -- Courier's Bag
	[22572]="1600:7:1:10:Elemental:333:1:1:14846,20981,20986", -- Mote of Air
	[22573]="1600:7:1:10:Elemental:171,164,333,202:1:1:14846,20981,20986", -- Mote of Earth
	[22574]="1600:7:1:10:Elemental:171,333,202:1:1:14846,20981,20986", -- Mote of Fire
	[22575]="1600:7:1:10:Elemental::1:1:14846,20981,20986", -- Mote of Life
	[22576]="1600:7:1:10:Elemental::1:1:14846,20981,20986", -- Mote of Mana
	[22577]="1600:7:1:10:Elemental:185:1:1:14846,20981,20986", -- Mote of Shadow
	[22578]="1600:7:1:10:Elemental:171,333,755:1:1:14846,20981,20986", -- Mote of Water
	[22579]="0:12:1:10:::1:0:", -- Plagued Murloc Spine
	[22580]="0:12:1:20:::1:0:", -- Crystallized Mana Essence
	[22583]="0:12:1:1:::1:0:", -- Rathis Tomber's Supplies
	[22589]="184558:2:5:1:Stave::1:0:", -- Atiesh, Greatstaff of the Guardian
	[22590]="0:12:1:1:::1:0:", -- Night Elf Plans: An'daroth
	[22591]="0:12:1:1:::1:0:", -- Night Elf Plans: An'owyn
	[22592]="0:12:1:1:::1:0:", -- Night Elf Plans: Scrying on the Sin'dorei
	[22593]="0:15:1:1:Junk::1:0:", -- Writ of Safe Passage
	[22594]="0:12:1:1:::1:0:", -- Night Elf Plans
	[22595]="0:15:1:1:Junk::1:0:", -- Call to Arms Announcement
	[22597]="0:12:1:1:::1:0:", -- The Lady's Necklace
	[22598]="0:12:1:20:::1:0:", -- Stone of Light
	[22599]="0:12:1:20:::1:0:", -- Stone of Flame
	[22600]="0:12:1:1:::1:0:", -- Craftsman's Writ - Dense Weightstone
	[22601]="0:12:1:1:::1:0:", -- Craftsman's Writ - Imperial Plate Chest
	[22602]="0:12:1:1:::1:0:", -- Craftsman's Writ - Volcanic Hammer
	[22603]="0:12:1:1:::1:0:", -- Craftsman's Writ - Huge Thorium Battleaxe
	[22604]="0:12:1:1:::1:0:", -- Craftsman's Writ - Radiant Circlet
	[22605]="0:12:1:1:::1:0:", -- Craftsman's Writ - Wicked Leather Headband
	[22606]="0:12:1:1:::1:0:", -- Craftsman's Writ - Rugged Armor Kit
	[22607]="0:12:1:1:::1:0:", -- Craftsman's Writ - Wicked Leather Belt
	[22608]="0:12:1:1:::1:0:", -- Craftsman's Writ - Runic Leather Pants
	[22609]="0:12:1:1:::1:0:", -- Craftsman's Writ - Brightcloth Pants
	[22610]="0:12:1:1:::1:0:", -- Craftsman's Writ - Runecloth Boots
	[22611]="0:12:1:1:::1:0:", -- Craftsman's Writ - Runecloth Bag
	[22612]="0:12:1:1:::1:0:", -- Craftsman's Writ - Runecloth Robe
	[22613]="0:12:1:1:::1:0:", -- Craftsman's Writ - Goblin Sapper Charge
	[22614]="0:12:1:1:::1:0:", -- Craftsman's Writ - Thorium Grenade
	[22615]="0:12:1:1:::1:0:", -- Craftsman's Writ - Gnomish Battle Chicken
	[22616]="0:12:1:1:::1:0:", -- Craftsman's Writ - Thorium Tube
	[22617]="0:12:1:1:::1:0:", -- Craftsman's Writ - Major Mana Potion
	[22618]="0:12:1:1:::1:0:", -- Craftsman's Writ - Major Healing Potion
	[22620]="0:12:1:1:::1:0:", -- Craftsman's Writ - Greater Arcane Protection Potion
	[22621]="0:12:1:1:::1:0:", -- Craftsman's Writ - Potion of Petrification
	[22622]="0:12:1:1:::1:0:", -- Craftsman's Writ - Stonescale Eel
	[22623]="0:12:1:1:::1:0:", -- Craftsman's Writ - Plated Armorfish
	[22624]="0:12:1:1:::1:0:", -- Craftsman's Writ - Lightning Eel
	[22627]="0:12:1:1:::1:0:", -- The Lady's Necklace
	[22628]="0:12:1:1:::1:0:", -- Renzithen's Restorative Draught
	[22629]="0:12:1:1:::1:0:", -- Sealed Sin'dorei Orders
	[22630]="185158:2:5:1:Stave::1:0:", -- Atiesh, Greatstaff of the Guardian
	[22631]="172821:2:5:1:Stave::1:0:", -- Atiesh, Greatstaff of the Guardian
	[22632]="173474:2:5:1:Stave::1:0:", -- Atiesh, Greatstaff of the Guardian
	[22633]="0:12:1:20:::1:0:", -- Troll Juju
	[22634]="0:12:1:20:::1:0:", -- Underlight Ore
	[22635]="0:0:3:1:EnhPerm::1:0:", -- Savage Guard
	[22636]="0:0:3:1:EnhPerm::1:0:", -- Ice Guard
	[22637]="0:15:3:1:Junk::1:0:", -- Primal Hakkari Idol
	[22638]="0:0:3:1:EnhPerm::1:0:", -- Shadow Guard
	[22639]="0:12:1:10:::1:0:", -- Zeb'Sora Troll Ear
	[22640]="0:12:1:1:::1:0:", -- Head of Kel'gash the Wicked
	[22641]="0:12:1:10:::1:0:", -- Rotting Heart
	[22642]="0:12:1:10:::1:0:", -- Spinal Dust
	[22644]="0:7:1:20:Meat:185:1:0:", -- Crunchy Spider Leg
	[22645]="0:0:1:20:FoodDrink::1:0:", -- Crunchy Spider Surprise
	[22647]="400:9:1:1:Cooking::1:0:16253,18427", -- Recipe: Crunchy Spider Surprise
	[22648]="0:15:1:1:Junk::1:0:", -- Hive'Ashi Dossier
	[22649]="0:15:1:1:Junk::1:0:", -- Hive'Regal Dossier
	[22650]="0:15:1:1:Junk::1:0:", -- Hive'Zora Dossier
	[22651]="0:4:4:1:Plate::1:0:", -- Outrider's Plate Legguards
	[22652]="0:4:4:1:Cloth::1:0:", -- Glacial Vest
	[22653]="0:12:1:1:::1:0:", -- Dar'Khan's Head
	[22654]="0:4:4:1:Cloth::1:0:", -- Glacial Gloves
	[22655]="0:4:4:1:Cloth::1:0:", -- Glacial Wrists
	[22656]="0:2:4:1:Gun::1:0:", -- The Purifier
	[22657]="0:4:4:1:Amulet::1:0:", -- Amulet of the Dawn
	[22658]="0:4:4:1:Cloak::1:0:", -- Glacial Cloak
	[22659]="0:4:4:1:Amulet::1:0:", -- Medallion of the Dawn
	[22660]="0:4:3:1:Cloak::1:0:", -- Gaea's Embrace
	[22661]="0:4:4:1:Leather::1:0:", -- Polar Tunic
	[22662]="0:4:4:1:Leather::1:0:", -- Polar Gloves
	[22663]="0:4:4:1:Leather::1:0:", -- Polar Bracers
	[22664]="0:4:4:1:Mail::1:0:", -- Icy Scale Breastplate
	[22665]="0:4:4:1:Mail::1:0:", -- Icy Scale Bracers
	[22666]="0:4:4:1:Mail::1:0:", -- Icy Scale Gauntlets
	[22667]="0:4:4:1:Cloth::1:0:", -- Bracers of Hope
	[22668]="0:4:4:1:Leather::1:0:", -- Bracers of Subterfuge
	[22669]="0:4:4:1:Plate::1:0:", -- Icebane Breastplate
	[22670]="0:4:4:1:Plate::1:0:", -- Icebane Gauntlets
	[22671]="0:4:4:1:Plate::1:0:", -- Icebane Bracers
	[22672]="0:4:4:1:Plate::1:0:", -- Sentinel's Plate Legguards
	[22673]="0:4:4:1:Mail::1:0:", -- Outrider's Chain Leggings
	[22674]="0:12:1:8:::1:0:", -- Wavefront Medallion
	[22675]="0:12:1:1:::1:0:", -- Bundle of Medallions
	[22676]="0:4:4:1:Mail::1:0:", -- Outrider's Mail Leggings
	[22677]="0:12:1:5:::1:0:", -- Catlord Claws
	[22678]="0:4:4:1:Trinket::1:0:", -- Talisman of Ascendance
	[22679]="0:1:3:1:Bag::1:0:", -- Supply Bag
	[22680]="0:4:3:1:Ring::1:0:", -- Band of Resolution
	[22681]="0:4:3:1:Ring::1:0:", -- Band of Piety
	[22682]="0:7:3:20:Other:164,165,197:1:0:", -- Frozen Rune
	[22683]="90000:9:1:1:Tailoring::1:0:15179", -- Pattern: Gaea's Embrace
	[22688]="0:2:3:1:Dagger::1:0:", -- Verimonde's Last Resort
	[22689]="0:4:3:1:Leather::1:0:", -- Sanctified Leather Helm
	[22690]="0:4:3:1:Mail::1:0:", -- Leggings of the Plague Hunter
	[22691]="0:2:4:1:TwoHandSword::1:0:", -- Corrupted Ashbringer
	[22693]="0:12:1:1:::1:0:", -- Infused Crystal
	[22699]="0:4:4:1:Plate::1:0:", -- Icebane Leggings
	[22700]="0:4:4:1:Cloth::1:0:", -- Glacial Leggings
	[22701]="0:4:4:1:Leather::1:0:", -- Polar Leggings
	[22702]="0:4:4:1:Mail::1:0:", -- Icy Scale Leggings
	[22706]="0:12:1:1:::1:0:", -- Dar'Khan's Journal
	[22707]="0:4:4:1:Ring::1:0:", -- Ramaladni's Icy Grasp
	[22708]="0:12:1:1:::1:0:", -- Fate of Ramaladni
	[22710]="0:7:1:20:Herb::1:0:", -- Bloodthistle
	[22711]="0:4:3:1:Cloak::1:0:", -- Cloak of the Hakkari Worshippers
	[22712]="0:4:3:1:Cloak::1:0:", -- Might of the Tribe
	[22713]="0:2:3:1:OneHandMace::1:0:", -- Zulian Scepter of Rites
	[22714]="0:4:3:1:Plate::1:0:", -- Sacrificial Gauntlets
	[22715]="0:4:3:1:Mail::1:0:", -- Gloves of the Tormented
	[22716]="0:4:3:1:Cloth::1:0:", -- Belt of Untapped Power
	[22717]="0:12:1:1:::1:0:", -- Letter from Silvermoon
	[22718]="0:4:3:1:Leather::1:0:", -- Blooddrenched Mask
	[22719]="0:15:1:1:Junk::1:0:", -- Omarion's Handbook
	[22720]="0:4:3:1:Cloth::1:0:", -- Zulian Headdress
	[22721]="0:4:4:1:Ring::1:0:", -- Band of Servitude
	[22722]="0:4:4:1:Ring::1:0:", -- Seal of the Gurubashi Berserker
	[22723]="0:12:1:1:::1:0:", -- A Letter from the Keeper of the Rolls
	[22725]="0:4:3:1:Ring::1:0:", -- Band of Cenarius
	[22726]="0:12:5:40:::1:0:", -- Splinter of Atiesh
	[22727]="0:12:5:1:::1:0:", -- Frame of Atiesh
	[22728]="0:15:1:1:CombatPet::1:0:", -- Steam Tonk Controller
	[22729]="8000:9:1:1:Engineering::1:1:3413,5175", -- Schematic: Steam Tonk Controller
	[22730]="0:4:4:1:Cloth::1:0:", -- Eyestalk Waist Cord
	[22731]="0:4:4:1:Cloak::1:0:", -- Cloak of the Devoured
	[22732]="0:4:4:1:Amulet::1:0:", -- Mark of C'Thun
	[22733]="0:12:1:1:::1:0:", -- Staff Head of Atiesh
	[22734]="0:12:1:1:::1:0:", -- Base of Atiesh
	[22735]="0:12:1:1:::1:0:", -- Research Notes
	[22736]="0:2:5:1:OneHandSword::1:0:", -- Andonisus, Reaper of Souls
	[22737]="0:12:5:1:::1:0:", -- Atiesh, Greatstaff of the Guardian
	[22739]="0:9:3:1:Book::1:0:", -- Tome of Polymorph: Turtle
	[22740]="0:4:4:1:Leather::1:0:", -- Outrider's Leather Pants
	[22741]="0:4:4:1:Leather::1:0:", -- Outrider's Lizardhide Pants
	[22742]="0:4:1:1:Cloth::1:0:", -- Bloodsail Shirt
	[22743]="0:0:1:1:Consumable::1:0:", -- Bloodsail Sash
	[22744]="0:4:1:1:Cloth::1:0:", -- Bloodsail Boots
	[22745]="0:4:1:1:Cloth::1:0:", -- Bloodsail Pants
	[22746]="0:15:1:1:Junk::1:0:", -- Buccaneer's Uniform
	[22747]="0:4:4:1:Cloth::1:0:", -- Outrider's Silk Leggings
	[22748]="0:4:4:1:Mail::1:0:", -- Sentinel's Chain Leggings
	[22749]="0:4:4:1:Leather::1:0:", -- Sentinel's Leather Pants
	[22750]="0:4:4:1:Leather::1:0:", -- Sentinel's Lizardhide Pants
	[22752]="0:4:4:1:Cloth::1:0:", -- Sentinel's Silk Leggings
	[22753]="0:4:4:1:Plate::1:0:", -- Sentinel's Lamellar Legguards
	[22754]="0:12:1:1:::1:0:", -- Eternal Quintessence
	[22755]="0:12:1:1:::1:0:", -- Blazing Torch
	[22756]="0:4:3:1:Cloth::1:0:", -- Sylvan Vest
	[22757]="0:4:3:1:Cloth::1:0:", -- Sylvan Crown
	[22758]="0:4:3:1:Cloth::1:0:", -- Sylvan Shoulders
	[22759]="0:4:3:1:Leather::1:0:", -- Bramblewood Helm
	[22760]="0:4:3:1:Leather::1:0:", -- Bramblewood Boots
	[22761]="0:4:3:1:Leather::1:0:", -- Bramblewood Belt
	[22762]="0:4:3:1:Plate::1:0:", -- Ironvine Breastplate
	[22763]="0:4:3:1:Plate::1:0:", -- Ironvine Gloves
	[22764]="0:4:3:1:Plate::1:0:", -- Ironvine Belt
	[22766]="50000:9:1:1:Blacksmithing::1:0:15176", -- Plans: Ironvine Breastplate
	[22767]="50000:9:1:1:Blacksmithing::1:0:15176", -- Plans: Ironvine Gloves
	[22768]="50000:9:1:1:Blacksmithing::1:0:15176", -- Plans: Ironvine Belt
	[22769]="50000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Bramblewood Belt
	[22770]="50000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Bramblewood Boots
	[22771]="50000:9:1:1:Leatherworking::1:0:15293", -- Pattern: Bramblewood Helm
	[22772]="50000:9:1:1:Tailoring::1:0:15179", -- Pattern: Sylvan Shoulders
	[22773]="50000:9:1:1:Tailoring::1:0:15179", -- Pattern: Sylvan Crown
	[22774]="50000:9:1:1:Tailoring::1:0:15179", -- Pattern: Sylvan Vest
	[22775]="300:12:1:1:::1:0:16442", -- Suntouched Special Reserve
	[22776]="100:12:1:1:::1:0:16443", -- Springpaw Appetizers
	[22777]="150:12:1:1:::1:0:16444", -- Bundle of Fireworks
	[22778]="0:0:1:5:Consumable::1:0:", -- Scourgebane Infusion
	[22779]="0:0:1:5:Consumable::1:0:", -- Scourgebane Draught
	[22781]="0:15:1:1:Companion::1:0:", -- Polar Bear Collar
	[22783]="0:2:2:1:OneHandSword::1:0:", -- Sunwell Blade
	[22784]="0:4:2:1:OffHandFrill::1:0:", -- Sunwell Orb
	[22785]="2000:7:1:20:Herb:171:1:1:20989,24975", -- Felweed
	[22786]="2000:7:1:20:Herb:171:1:1:20989,24975", -- Dreaming Glory
	[22787]="2400:7:1:20:Herb:171:1:1:14846", -- Ragveil
	[22788]="0:7:1:20:Herb::1:0:", -- Flame Cap
	[22789]="2000:7:1:20:Herb:171:1:1:14846", -- Terocone
	[22790]="3000:7:1:20:Herb:171:1:1:14846", -- Ancient Lichen
	[22791]="4000:7:1:20:Herb:171,333:1:1:14846,20989,24975", -- Netherbloom
	[22792]="5000:7:1:20:Herb:171,333:1:1:14846", -- Nightmare Vine
	[22793]="6000:7:1:20:Herb:171:1:1:14846,20989,24975", -- Mana Thistle
	[22794]="30000:7:2:20:Herb:171,333,197:1:1:14846", -- Fel Lotus
	[22795]="0:0:1:20:Consumable::1:0:", -- Fel Blossom
	[22796]="0:12:1:1:::1:0:", -- Apothecary's Poison
	[22797]="0:7:1:20:Herb::1:0:", -- Nightmare Seed
	[22798]="0:2:4:1:TwoHandMace::1:0:", -- Might of Menethil
	[22799]="0:2:4:1:Stave::1:0:", -- Soulseeker
	[22800]="0:2:4:1:Stave::1:0:", -- Brimstone Staff
	[22801]="0:2:4:1:Stave::1:0:", -- Spire of Twilight
	[22802]="0:2:4:1:Dagger::1:0:", -- Kingsfall
	[22803]="0:2:4:1:Dagger::1:0:", -- Midnight Haze
	[22804]="0:2:4:1:Dagger::1:0:", -- Maexxna's Fang
	[22806]="0:2:4:1:OneHandSword::1:0:", -- Widow's Remorse
	[22807]="0:2:4:1:OneHandSword::1:0:", -- Wraith Blade
	[22808]="0:2:4:1:OneHandMace::1:0:", -- The Castigator
	[22809]="0:2:4:1:TwoHandMace::1:0:", -- Maul of the Redeemed Crusader
	[22810]="0:2:4:1:Gun::1:0:", -- Toxin Injector
	[22811]="0:2:4:1:Bow::1:0:", -- Soulstring
	[22812]="0:2:4:1:Crossbow::1:0:", -- Nerubian Slavemaker
	[22813]="0:2:4:1:TwoHandSword::1:0:", -- Claymore of Unholy Might
	[22815]="0:2:4:1:TwoHandAxe::1:0:", -- Severance
	[22816]="0:2:4:1:OneHandAxe::1:0:", -- Hatchet of Sundered Bone
	[22818]="0:4:4:1:Shield::1:0:", -- The Plague Bearer
	[22819]="0:4:4:1:Shield::1:0:", -- Shield of Condemnation
	[22820]="0:2:4:1:Wand::1:0:", -- Wand of Fates
	[22821]="0:2:4:1:Wand::1:0:", -- Doomfinger
	[22823]="0:0:1:20:Elixir::1:0:", -- Elixir of Camouflage
	[22824]="0:0:1:20:Elixir:164,333:1:0:", -- Elixir of Major Strength
	[22825]="0:0:1:20:Elixir::1:0:", -- Elixir of Healing Power
	[22826]="0:0:1:20:Potion::1:0:", -- Sneaking Potion
	[22827]="0:0:1:20:Elixir::1:0:", -- Elixir of Major Frost Power
	[22828]="0:0:1:20:Potion::1:0:", -- Insane Strength Potion
	[22829]="20000:0:1:20:Potion:202:1:1:14847,20989,24396,29628", -- Super Healing Potion
	[22830]="0:0:1:20:Elixir::1:0:", -- Elixir of the Searching Eye
	[22831]="0:0:1:20:Elixir:164:1:0:", -- Elixir of Major Agility
	[22832]="20000:0:1:20:Potion:202:1:1:14847,20989,24396,28715,29537", -- Super Mana Potion
	[22833]="0:0:1:20:Elixir::1:0:", -- Elixir of Major Firepower
	[22834]="0:0:1:20:Elixir::1:0:", -- Elixir of Major Defense
	[22835]="0:0:1:20:Elixir::1:0:", -- Elixir of Major Shadow Power
	[22836]="0:0:1:20:Potion::1:0:", -- Major Dreamless Sleep Potion
	[22837]="0:0:1:20:Potion::1:0:", -- Heroic Potion
	[22838]="0:0:1:20:Potion::1:0:", -- Haste Potion
	[22839]="0:0:1:20:Potion::1:0:", -- Destruction Potion
	[22840]="0:0:1:20:Elixir::1:0:", -- Elixir of Major Mageblood
	[22841]="0:0:1:20:Potion::1:0:", -- Major Fire Protection Potion
	[22842]="0:0:1:20:Potion::1:0:", -- Major Frost Protection Potion
	[22843]="0:4:3:1:Mail::1:0:", -- Blood Guard's Chain Greaves
	[22844]="0:0:1:20:Potion::1:0:", -- Major Nature Protection Potion
	[22845]="20000:0:1:20:Potion::1:1:20989", -- Major Arcane Protection Potion
	[22846]="20000:0:1:20:Potion::1:1:20989", -- Major Shadow Protection Potion
	[22847]="0:0:1:20:Potion::1:0:", -- Major Holy Protection Potion
	[22848]="0:0:1:20:Elixir::1:0:", -- Elixir of Empowerment
	[22849]="0:0:1:20:Potion::1:0:", -- Ironshield Potion
	[22850]="0:0:1:20:Potion::1:0:", -- Super Rejuvenation Potion
	[22851]="0:0:1:20:Flask::1:0:", -- Flask of Fortification
	[22852]="0:4:3:1:Leather::1:0:", -- Blood Guard's Dragonhide Treads
	[22853]="0:0:1:20:Flask::1:0:", -- Flask of Mighty Restoration
	[22854]="0:0:1:20:Flask::1:0:", -- Flask of Relentless Assault
	[22855]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Dreadweave Walkers
	[22856]="0:4:3:1:Leather::1:0:", -- Blood Guard's Leather Walkers
	[22857]="0:4:3:1:Mail::1:0:", -- Blood Guard's Mail Greaves
	[22858]="0:4:3:1:Plate::1:0:", -- Blood Guard's Plate Greaves
	[22859]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Satin Walkers
	[22860]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Silk Walkers
	[22861]="0:0:1:20:Flask::1:0:", -- Flask of Blinding Light
	[22862]="0:4:3:1:Mail::1:0:", -- Blood Guard's Chain Vices
	[22863]="0:4:3:1:Leather::1:0:", -- Blood Guard's Dragonhide Grips
	[22864]="0:4:3:1:Leather::1:0:", -- Blood Guard's Leather Grips
	[22865]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Dreadweave Handwraps
	[22866]="0:0:1:20:Flask::1:0:", -- Flask of Pure Death
	[22867]="0:4:3:1:Mail::1:0:", -- Blood Guard's Mail Vices
	[22868]="0:4:3:1:Plate::1:0:", -- Blood Guard's Plate Gauntlets
	[22869]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Satin Handwraps
	[22870]="0:4:3:1:Cloth::1:0:", -- Blood Guard's Silk Handwraps
	[22871]="0:0:1:20:Potion::1:0:", -- Shrouding Potion
	[22872]="0:4:3:1:Plate::1:0:", -- Legionnaire's Plate Hauberk
	[22873]="0:4:3:1:Plate::1:0:", -- Legionnaire's Plate Leggings
	[22874]="0:4:3:1:Mail::1:0:", -- Legionnaire's Chain Hauberk
	[22875]="0:4:3:1:Mail::1:0:", -- Legionnaire's Chain Legguards
	[22876]="0:4:3:1:Mail::1:0:", -- Legionnaire's Mail Hauberk
	[22877]="0:4:3:1:Leather::1:0:", -- Legionnaire's Dragonhide Chestpiece
	[22878]="0:4:3:1:Leather::1:0:", -- Legionnaire's Dragonhide Leggings
	[22879]="0:4:3:1:Leather::1:0:", -- Legionnaire's Leather Chestpiece
	[22880]="0:4:3:1:Leather::1:0:", -- Legionnaire's Leather Legguards
	[22881]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Dreadweave Legguards
	[22882]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Satin Legguards
	[22883]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Silk Legguards
	[22884]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Dreadweave Tunic
	[22885]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Satin Tunic
	[22886]="0:4:3:1:Cloth::1:0:", -- Legionnaire's Silk Tunic
	[22887]="0:4:3:1:Mail::1:0:", -- Legionnaire's Mail Legguards
	[22888]="0:12:1:1:::1:0:", -- Azure Watch Gift Voucher
	[22889]="0:12:1:10:::1:0:", -- Vial of Moth Blood
	[22890]="0:9:3:1:Book::1:0:", -- Tome of Frost Ward V
	[22891]="0:9:3:1:Book::1:0:", -- Grimoire of Shadow Ward IV
	[22892]="0:12:1:10:::1:0:", -- Dim Necrotic Stone
	[22893]="0:12:1:1:::1:0:", -- Luzran's Head
	[22894]="0:12:1:1:::1:0:", -- Knucklerot's Head
	[22895]="0:0:1:20:FoodDrink::1:0:", -- Conjured Cinnamon Roll
	[22897]="0:9:3:1:Book::1:0:", -- Tome of Conjure Food VII
	[22900]="30000:9:1:1:Alchemy::1:1:16588,16641,16705,18802", -- Recipe: Elixir of Camouflage
	[22901]="30000:9:1:1:Alchemy::1:1:18017,19042", -- Recipe: Sneaking Potion
	[22902]="40000:9:1:1:Alchemy::1:1:18005,18017", -- Recipe: Elixir of Major Frost Power
	[22903]="0:9:2:1:Alchemy::1:0:", -- Recipe: Insane Strength Potion
	[22904]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of the Searching Eye
	[22905]="50000:9:1:1:Alchemy::1:0:17657", -- Recipe: Elixir of Major Agility
	[22906]="0:9:2:1:Alchemy::1:0:18382", -- Recipe: Shrouding Potion
	[22907]="50000:9:1:1:Alchemy::1:1:18005,19837", -- Recipe: Super Mana Potion
	[22908]="60000:9:2:1:Alchemy::1:0:19331", -- Recipe: Elixir of Major Firepower
	[22909]="50000:9:1:1:Alchemy::1:1:18005,19837", -- Recipe: Elixir of Major Defense
	[22910]="80000:9:2:1:Alchemy::1:0:21655", -- Recipe: Elixir of Major Shadow Power
	[22911]="50000:9:1:1:Alchemy::1:1:19042,19837", -- Recipe: Major Dreamless Sleep Potion
	[22912]="0:9:2:1:Alchemy::1:0:", -- Recipe: Heroic Potion
	[22913]="0:9:2:1:Alchemy::1:0:", -- Recipe: Haste Potion
	[22914]="0:9:2:1:Alchemy::1:0:", -- Recipe: Destruction Potion
	[22915]="80000:9:2:1:Alchemy::1:0:21432", -- Recipe: Transmute Primal Air to Fire
	[22916]="0:9:2:1:Alchemy::1:0:18382", -- Recipe: Transmute Primal Earth to Water
	[22917]="80000:9:2:1:Alchemy::1:0:20241", -- Recipe: Transmute Primal Fire to Earth
	[22918]="80000:9:2:1:Alchemy::1:0:17904", -- Recipe: Transmute Primal Water to Air
	[22919]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Major Mageblood
	[22920]="0:9:2:1:Alchemy::1:0:", -- Recipe: Major Fire Protection Potion
	[22921]="0:9:2:1:Alchemy::1:0:", -- Recipe: Major Frost Protection Potion
	[22922]="100000:9:1:1:Alchemy::1:0:17904", -- Recipe: Major Nature Protection Potion
	[22923]="0:9:2:1:Alchemy::1:0:", -- Recipe: Major Arcane Protection Potion
	[22924]="0:9:2:1:Alchemy::1:0:", -- Recipe: Major Shadow Protection Potion
	[22925]="0:9:2:1:Alchemy::1:0:", -- Recipe: Major Holy Protection Potion
	[22926]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Empowerment
	[22927]="0:9:2:1:Alchemy::1:0:", -- Recipe: Ironshield Potion
	[22930]="0:12:1:1:::1:0:", -- A Bloodstained Envelope
	[22932]="0:12:1:1:::1:0:", -- A Torn Letter
	[22934]="0:12:1:10:::1:0:", -- Lasher Sample
	[22935]="0:4:4:1:Amulet::1:0:", -- Touch of Frost
	[22936]="0:4:4:1:Plate::1:0:", -- Wristguards of Vengeance
	[22937]="0:4:4:1:OffHandFrill::1:0:", -- Gem of Nerubis
	[22938]="0:4:4:1:Cloak::1:0:", -- Cryptfiend Silk Cloak
	[22939]="0:4:4:1:Ring::1:0:", -- Band of Unanswered Prayers
	[22940]="0:4:4:1:Plate::1:0:", -- Icebane Pauldrons
	[22941]="0:4:4:1:Leather::1:0:", -- Polar Shoulder Pads
	[22942]="0:2:4:1:OneHandMace::1:0:", -- The Widow's Embrace
	[22943]="0:4:4:1:Amulet::1:0:", -- Malice Stone Pendant
	[22944]="0:12:1:1:::1:0:", -- A Crumpled Missive
	[22945]="0:12:1:1:::1:0:", -- A Careworn Note
	[22946]="0:12:1:1:::1:0:", -- A Ragged Page
	[22947]="0:4:4:1:Amulet::1:0:", -- Pendant of Forgotten Names
	[22948]="0:12:1:1:::1:0:", -- A Smudged Document
	[22949]="0:12:1:1:::1:0:", -- Cracked Necrotic Crystal
	[22950]="0:12:1:1:::1:0:", -- Faint Necrotic Crystal
	[22951]="0:4:1:1:Leather::1:0:", -- Springpaw Hide Leggings
	[22952]="0:4:1:1:Cloak::1:0:", -- Springpaw Hide Cloak
	[22953]="0:4:1:1:Mail::1:0:", -- Fur Lined Chain Shirt
	[22954]="0:4:4:1:Trinket::1:0:", -- Kiss of the Spider
	[22955]="0:12:1:1:::1:0:", -- Neutralizing Agent
	[22956]="0:2:1:1:OneHandMace::1:0:", -- Rusty Mace
	[22957]="0:2:1:1:OneHandSword::1:0:", -- Rusty Sin'dorei Sword
	[22958]="0:2:1:1:TwoHandSword::1:0:", -- Farstrider Sword
	[22959]="0:2:1:1:Stave::1:0:", -- Smooth Metal Staff
	[22960]="0:4:4:1:Cloak::1:0:", -- Cloak of Suturing
	[22961]="0:4:4:1:Ring::1:0:", -- Band of Reanimation
	[22962]="0:12:1:1:::1:0:", -- Inoculating Crystal
	[22963]="0:2:1:1:Dagger::1:0:", -- Ranger's Pocketknife
	[22964]="0:4:1:1:Mail::1:0:", -- Sunsail Bracers
	[22965]="0:4:1:1:Leather::1:0:", -- Longshoreman's Bindings
	[22966]="0:4:1:1:Cloth::1:0:", -- Silk Wristbands
	[22967]="0:4:4:1:Mail::1:0:", -- Icy Scale Spaulders
	[22968]="0:4:4:1:Cloth::1:0:", -- Glacial Mantle
	[22969]="0:2:2:1:Bow::1:0:", -- Ven'jashi's Bow
	[22970]="0:12:1:1:::1:0:", -- A Bloodstained Envelope
	[22971]="0:2:2:1:Wand::1:0:", -- Hoodoo Wand
	[22972]="0:12:1:1:::1:0:", -- A Careworn Note
	[22973]="0:12:1:1:::1:0:", -- A Crumpled Missive
	[22974]="0:12:1:1:::1:0:", -- A Ragged Page
	[22975]="0:12:1:1:::1:0:", -- A Smudged Document
	[22976]="0:1:1:1:Bag::1:0:", -- Magister's Pouch
	[22977]="0:12:1:1:::1:0:", -- A Torn Letter
	[22978]="0:12:1:10:::1:0:", -- Emitter Spare Part
	[22979]="0:4:2:1:Ring::1:0:", -- Slayer's Band
	[22980]="0:2:3:1:Stave::1:0:", -- Staff of the Sun
	[22981]="0:4:4:1:Amulet::1:0:", -- Gluth's Missing Collar
	[22982]="0:2:3:1:Bow::1:0:", -- Farstrider's Longbow
	[22983]="0:4:4:1:Cloth::1:0:", -- Rime Covered Mantle
	[22984]="0:2:3:1:Dagger::1:0:", -- Dawnblade
	[22985]="2038:4:2:1:Mail::1:0:16528", -- Suncrown Hauberk
	[22986]="1364:4:2:1:Cloth::1:0:16528", -- Apothecary's Robe
	[22987]="1712:4:2:1:Leather::1:0:16528", -- Deathstalker's Vest
	[22988]="0:2:4:1:OneHandMace::1:0:", -- The End of Dreams
	[22990]="2883:4:3:1:Cloak::1:0:16528", -- Tranquillien Champion's Cloak
	[22991]="1042:4:2:1:Cloth::1:0:16528", -- Apprentice Boots
	[22992]="1308:4:2:1:Leather::1:0:16528", -- Bogwalker Boots
	[22993]="1582:4:2:1:Mail::1:0:16528", -- Volunteer's Greaves
	[22994]="0:4:4:1:OffHandFrill::1:0:", -- Digested Hand of Power
	[22995]="0:2:3:1:TwoHandSword::1:0:", -- Sin'dorei Warblade
	[22996]="0:4:2:1:Shield::1:0:", -- Reforged Quel'dorei Crest
	[22997]="0:2:2:1:Wand::1:0:", -- Ley-Keeper's Wand
	[22998]="0:4:2:1:Leather::1:0:", -- Ghostclaw Leggings
	[22999]="0:4:1:1:Tabard::1:0:16786", -- Tabard of the Argent Dawn
	[23000]="0:4:4:1:Plate::1:0:", -- Plated Abomination Ribcage
	[23001]="0:4:4:1:Trinket::1:0:", -- Eye of Diminution
	[23002]="0:15:1:1:Companion::1:0:", -- Turtle Box
	[23003]="0:12:1:1:::1:0:", -- Blood Elf Plans
	[23004]="0:4:4:1:Idol::1:0:", -- Idol of Longevity
	[23005]="0:4:4:1:Totem::1:0:", -- Totem of Flowing Water
	[23006]="0:4:4:1:Libram::1:0:", -- Libram of Light
	[23007]="0:15:1:1:Companion::1:0:", -- Piglet's Collar
	[23008]="0:12:1:1:::1:0:", -- Sealed Research Report
	[23009]="0:2:4:1:Wand::1:0:", -- Wand of the Whispering Dead
	[23010]="0:12:1:1:::1:0:", -- Sealed Research Report
	[23011]="0:12:1:1:::1:0:", -- Sealed Research Report
	[23012]="0:12:1:1:::1:0:", -- Sealed Research Report
	[23013]="0:12:1:1:::1:0:", -- Sealed Research Report
	[23014]="85238:2:4:1:OneHandSword::1:0:", -- Iblis, Blade of the Fallen Seraph
	[23015]="0:15:1:1:Companion::1:0:", -- Rat Cage
	[23016]="0:12:1:1:::1:0:", -- Sealed Research Report
	[23017]="0:4:4:1:Cloak::1:0:", -- Veil of Eclipse
	[23018]="0:4:4:1:Ring::1:0:", -- Signet of the Fallen Defender
	[23019]="0:4:4:1:Plate::1:0:", -- Icebane Helmet
	[23020]="0:4:4:1:Leather::1:0:", -- Polar Helmet
	[23021]="0:4:4:1:Cloth::1:0:", -- The Soul Harvester's Bindings
	[23022]="0:15:1:1:Junk::1:0:", -- Curmudgeon's Payoff
	[23023]="0:4:4:1:Amulet::1:0:", -- Sadist's Collar
	[23024]="0:12:1:1:::1:0:", -- Prepared Field Duty Papers
	[23025]="0:4:4:1:Ring::1:0:", -- Seal of the Damned
	[23027]="0:4:4:1:Trinket::1:0:", -- Warmth of Forgiveness
	[23028]="0:4:4:1:Ring::1:0:", -- Hailstone Band
	[23029]="0:4:4:1:OffHandFrill::1:0:", -- Noth's Frigid Heart
	[23030]="0:4:4:1:Cloak::1:0:", -- Cloak of the Scourge
	[23031]="0:4:4:1:Ring::1:0:", -- Band of the Inevitable
	[23032]="0:4:4:1:Cloth::1:0:", -- Glacial Headdress
	[23033]="0:4:4:1:Mail::1:0:", -- Icy Scale Coif
	[23035]="0:4:4:1:Cloth::1:0:", -- Preceptor's Hat
	[23036]="0:4:4:1:Amulet::1:0:", -- Necklace of Necropsy
	[23037]="0:4:4:1:Ring::1:0:", -- Ring of Spiritual Fervor
	[23038]="0:4:4:1:Ring::1:0:", -- Band of Unnatural Forces
	[23039]="0:2:4:1:Polearm::1:0:", -- The Eye of Nerub
	[23040]="0:4:4:1:Trinket::1:0:", -- Glyph of Deflection
	[23041]="0:4:4:1:Trinket::1:0:", -- Slayer's Crest
	[23042]="0:4:4:1:Trinket::1:0:", -- Loatheb's Reflection
	[23043]="0:4:4:1:Shield::1:0:", -- The Face of Death
	[23044]="0:2:4:1:Dagger::1:0:", -- Harbinger of Doom
	[23045]="0:4:4:1:Cloak::1:0:", -- Shroud of Dominion
	[23046]="0:4:4:1:Trinket::1:0:", -- The Restrained Essence of Sapphiron
	[23047]="0:4:4:1:Trinket::1:0:", -- Eye of the Dead
	[23048]="0:4:4:1:OffHandFrill::1:0:", -- Sapphiron's Right Eye
	[23049]="0:4:4:1:OffHandFrill::1:0:", -- Sapphiron's Left Eye
	[23050]="0:4:4:1:Cloak::1:0:", -- Cloak of the Necropolis
	[23053]="0:4:4:1:Amulet::1:0:", -- Stormrage's Talisman of Seething
	[23054]="95047:2:4:1:OneHandSword::1:0:", -- Gressil, Dawn of Ruin
	[23055]="0:7:1:10:Other::1:0:", -- Word of Thawing
	[23056]="0:2:4:1:OneHandMace::1:0:", -- Hammer of the Twisting Nether
	[23057]="0:4:4:1:Amulet::1:0:", -- Gem of Trapped Innocents
	[23059]="0:4:4:1:Ring::1:0:", -- Ring of the Dreadnaught
	[23060]="0:4:4:1:Ring::1:0:", -- Bonescythe Ring
	[23061]="0:4:4:1:Ring::1:0:", -- Ring of Faith
	[23062]="0:4:4:1:Ring::1:0:", -- Frostfire Ring
	[23063]="0:4:4:1:Ring::1:0:", -- Plagueheart Ring
	[23064]="0:4:4:1:Ring::1:0:", -- Ring of the Dreamwalker
	[23065]="0:4:4:1:Ring::1:0:", -- Ring of the Earthshatterer
	[23066]="0:4:4:1:Ring::1:0:", -- Ring of Redemption
	[23067]="0:4:4:1:Ring::1:0:", -- Ring of the Cryptstalker
	[23068]="0:4:4:1:Plate::1:0:", -- Legplates of Carnage
	[23069]="0:4:4:1:Cloth::1:0:", -- Necro-Knight's Garb
	[23070]="0:4:4:1:Cloth::1:0:", -- Leggings of Polarity
	[23071]="0:4:4:1:Leather::1:0:", -- Leggings of Apocalypse
	[23072]="0:4:4:1:Plate::1:0:", -- Fists of the Unrelenting
	[23073]="0:4:4:1:Leather::1:0:", -- Boots of Displacement
	[23075]="0:4:4:1:Shield::1:0:", -- Death's Bargain
	[23077]="0:3:2:20:GemRed:171,202,755:1:0:", -- Blood Garnet
	[23078]="0:4:3:1:Plate::1:0:", -- Gauntlets of Undead Slaying
	[23079]="0:3:2:20:GemGreen:171,202,755:1:0:", -- Deep Peridot
	[23081]="0:4:3:1:Leather::1:0:", -- Handwraps of Undead Slaying
	[23082]="0:4:3:1:Mail::1:0:", -- Handguards of Undead Slaying
	[23083]="0:15:3:1:Companion::1:0:26123,26124", -- Captured Flame
	[23084]="0:4:3:1:Cloth::1:0:", -- Gloves of Undead Cleansing
	[23085]="0:4:3:1:Cloth::1:0:", -- Robe of Undead Cleansing
	[23087]="0:4:3:1:Plate::1:0:", -- Breastplate of Undead Slaying
	[23088]="0:4:3:1:Mail::1:0:", -- Chestguard of Undead Slaying
	[23089]="0:4:3:1:Leather::1:0:", -- Tunic of Undead Slaying
	[23090]="0:4:3:1:Plate::1:0:", -- Bracers of Undead Slaying
	[23091]="0:4:3:1:Cloth::1:0:", -- Bracers of Undead Cleansing
	[23092]="0:4:3:1:Mail::1:0:", -- Wristguards of Undead Slaying
	[23093]="0:4:3:1:Leather::1:0:", -- Wristwraps of Undead Slaying
	[23094]="0:3:2:1:GemRed::1:0:", -- Teardrop Blood Garnet
	[23095]="10000:3:2:1:GemRed::1:1:19538", -- Bold Blood Garnet
	[23096]="10000:3:2:1:GemRed::1:1:19538", -- Runed Blood Garnet
	[23097]="10000:3:2:1:GemRed::1:1:19538", -- Delicate Blood Garnet
	[23098]="10000:3:2:1:GemOrange::1:1:19538", -- Inscribed Flame Spessarite
	[23099]="10000:3:2:1:GemOrange::1:1:19538", -- Luminous Flame Spessarite
	[23100]="0:3:2:1:GemOrange::1:0:", -- Glinting Flame Spessarite
	[23101]="0:3:2:1:GemOrange::1:0:", -- Potent Flame Spessarite
	[23103]="10000:3:2:1:GemGreen::1:1:19538", -- Radiant Deep Peridot
	[23104]="10000:3:2:1:GemGreen::1:1:19538", -- Jagged Deep Peridot
	[23105]="10000:3:2:1:GemGreen::1:1:19538", -- Enduring Deep Peridot
	[23106]="10000:3:2:1:GemGreen::1:1:19538", -- Dazzling Deep Peridot
	[23107]="0:3:2:20:GemPurple:171,755:1:0:", -- Shadow Draenite
	[23108]="10000:3:2:1:GemPurple::1:1:19538", -- Glowing Shadow Draenite
	[23109]="10000:3:2:1:GemPurple::1:1:19538", -- Royal Shadow Draenite
	[23110]="10000:3:2:1:GemPurple::1:1:19538", -- Shifting Shadow Draenite
	[23111]="10000:3:2:1:GemPurple::1:1:19538", -- Sovereign Shadow Draenite
	[23112]="0:3:2:20:GemYellow:171,202,755,197:1:0:", -- Golden Draenite
	[23113]="10000:3:2:1:GemYellow::1:1:19538", -- Brilliant Golden Draenite
	[23114]="10000:3:2:1:GemYellow::1:1:19538", -- Gleaming Golden Draenite
	[23115]="10000:3:2:1:GemYellow::1:1:19538", -- Thick Golden Draenite
	[23116]="10000:3:2:1:GemYellow::1:1:19538", -- Rigid Golden Draenite
	[23117]="0:3:2:20:GemBlue:171,755:1:0:", -- Azure Moonstone
	[23118]="10000:3:2:1:GemBlue::1:1:19538", -- Solid Azure Moonstone
	[23119]="0:3:2:1:GemBlue::1:0:", -- Sparkling Azure Moonstone
	[23120]="10000:3:2:1:GemBlue::1:1:19538", -- Stormy Azure Moonstone
	[23121]="0:3:2:1:GemBlue::1:0:", -- Lustrous Azure Moonstone
	[23122]="0:0:2:20:EnhTemp::1:0:16786", -- Consecrated Sharpening Stone
	[23123]="0:0:2:20:EnhTemp::1:0:16786", -- Blessed Wizard Oil
	[23124]="0:2:3:1:Stave::1:0:", -- Staff of Balzaphon
	[23125]="0:4:3:1:Amulet::1:0:", -- Chains of the Lich
	[23126]="0:4:3:1:Cloth::1:0:", -- Waistband of Balzaphon
	[23127]="0:4:3:1:Cloak::1:0:", -- Cloak of Revanchion
	[23128]="0:4:3:1:Cloth::1:0:", -- The Shadow's Grasp
	[23129]="0:4:3:1:Cloth::1:0:", -- Bracers of Mending
	[23130]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Teardrop Blood Garnet
	[23131]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Bold Blood Garnet
	[23132]="0:2:3:1:OneHandSword::1:0:", -- Lord Blackwood's Blade
	[23133]="60000:9:2:1:Jewelcrafting::1:0:19331", -- Design: Runed Blood Garnet
	[23134]="60000:9:2:1:Jewelcrafting::1:0:20242,23007", -- Design: Delicate Blood Garnet
	[23135]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Inscribed Flame Spessarite
	[23136]="50000:9:2:1:Jewelcrafting::1:0:20242,23007", -- Design: Luminous Flame Spessarite
	[23137]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Glinting Flame Spessarite
	[23138]="60000:9:2:1:Jewelcrafting::1:0:21655", -- Design: Potent Flame Spessarite
	[23139]="0:4:3:1:Shield::1:0:", -- Lord Blackwood's Buckler
	[23140]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Radiant Deep Peridot
	[23141]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Jagged Deep Peridot
	[23142]="60000:9:2:1:Jewelcrafting::1:0:17657", -- Design: Enduring Deep Peridot
	[23143]="60000:9:2:1:Jewelcrafting::1:0:19331", -- Design: Dazzling Deep Peridot
	[23144]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Glowing Shadow Draenite
	[23145]="50000:9:2:1:Jewelcrafting::1:0:19321", -- Design: Royal Shadow Draenite
	[23146]="60000:9:2:1:Jewelcrafting::1:0:20242,23007", -- Design: Shifting Shadow Draenite
	[23147]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Sovereign Shadow Draenite
	[23148]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Brilliant Golden Draenite
	[23149]="50000:9:2:1:Jewelcrafting::1:0:19321", -- Design: Gleaming Golden Draenite
	[23150]="60000:9:2:1:Jewelcrafting::1:0:20242,23007", -- Design: Thick Golden Draenite
	[23151]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Rigid Golden Draenite
	[23152]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Solid Azure Moonstone
	[23153]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Sparkling Azure Moonstone
	[23154]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Stormy Azure Moonstone
	[23155]="60000:9:2:1:Jewelcrafting::1:0:20242,23007", -- Design: Lustrous Azure Moonstone
	[23156]="0:4:3:1:OffHandFrill::1:0:", -- Blackwood's Thigh
	[23160]="4000:0:1:20:FoodDrink::5:0:2482,3044,4165,5173,5698,11038,14450,15006,16543", -- Friendship Bread
	[23161]="4000:0:1:20:Consumable::5:0:2482,3044,4165,5173,5698,11038,14450,15006,16543", -- Freshly-Squeezed Lemonade
	[23162]="0:1:1:1:Bag::1:0:", -- Foror's Crate of Endless Resist Gear Storage
	[23165]="0:12:1:5:::1:0:", -- Headhunter Axe
	[23166]="0:12:1:5:::1:0:", -- Hexxer Stave
	[23167]="0:12:1:5:::1:0:", -- Shadowcaster Mace
	[23168]="0:2:3:1:Dagger::1:0:", -- Scorn's Focal Dagger
	[23169]="0:4:3:1:Amulet::1:0:", -- Scorn's Icy Choker
	[23170]="0:4:3:1:Mail::1:0:", -- The Frozen Clutch
	[23171]="0:2:3:1:TwoHandAxe::1:0:", -- The Axe of Severing
	[23173]="0:4:3:1:Cloth::1:0:", -- Abomination Skin Leggings
	[23177]="0:2:3:1:Wand::1:0:", -- Lady Falther'ess' Finger
	[23178]="0:4:3:1:Cloak::1:0:", -- Mantle of Lady Falther'ess
	[23179]="0:12:1:1:::1:0:", -- Flame of Orgrimmar
	[23180]="0:12:1:1:::1:0:", -- Flame of Thunder Bluff
	[23181]="0:12:1:1:::1:0:", -- Flame of the Undercity
	[23182]="0:12:1:1:::1:0:", -- Flame of Stormwind
	[23183]="0:12:1:1:::1:0:", -- Flame of Ironforge
	[23184]="0:12:1:1:::1:0:", -- Flame of Darnassus
	[23191]="0:12:1:1:::1:0:", -- Crystal Controlling Orb
	[23192]="0:4:2:1:Tabard::1:0:", -- Tabard of the Scarlet Crusade
	[23194]="0:0:1:3:Consumable::1:0:", -- Lesser Mark of the Dawn
	[23195]="0:0:1:3:Consumable::1:0:", -- Mark of the Dawn
	[23196]="0:0:1:3:Consumable::1:0:", -- Greater Mark of the Dawn
	[23197]="0:4:3:1:Idol::1:0:", -- Idol of the Moon
	[23198]="0:4:3:1:Idol::1:0:", -- Idol of Brutality
	[23199]="0:4:3:1:Totem::1:0:", -- Totem of the Storm
	[23200]="0:4:3:1:Totem::1:0:", -- Totem of Sustaining
	[23201]="0:4:3:1:Libram::1:0:", -- Libram of Divinity
	[23203]="0:4:3:1:Libram::1:0:", -- Libram of Fervor
	[23205]="0:12:1:10:::1:0:", -- Hellfire Spineleaf
	[23206]="0:4:4:1:Trinket::1:0:", -- Mark of the Champion
	[23207]="0:4:4:1:Trinket::1:0:", -- Mark of the Champion
	[23211]="0:0:1:20:Consumable::5:0:26123,26124", -- Toasted Smorc
	[23214]="0:12:1:10:::1:0:", -- Plump Helboar Carcass
	[23215]="0:0:1:5:Consumable::1:0:26123,26124", -- Bag of Smorc Ingredients
	[23217]="0:12:1:50:::1:0:", -- Ravager Egg
	[23218]="0:12:1:10:::1:0:", -- Condensed Voidwalker Essence
	[23219]="0:4:4:1:Plate::1:0:", -- Girdle of the Mentor
	[23220]="0:4:4:1:Cloth::1:0:", -- Crystal Webbed Robe
	[23221]="0:2:4:1:OneHandMace::1:0:", -- Misplaced Servo Arm
	[23226]="0:4:4:1:Leather::1:0:", -- Ghoul Skin Tunic
	[23228]="0:12:1:1:::1:0:", -- Old Whitebark's Pendant
	[23237]="0:4:4:1:Ring::1:0:", -- Ring of the Eternal Flame
	[23238]="0:4:4:1:Shield::1:0:", -- Stygian Buckler
	[23239]="0:12:1:20:::1:0:", -- Plump Buzzard Wing
	[23242]="0:2:4:1:FistWeapon::1:0:", -- Claw of the Frost Wyrm
	[23243]="0:4:3:1:Plate::1:0:", -- Champion's Plate Shoulders
	[23244]="0:4:3:1:Plate::1:0:", -- Champion's Plate Helm
	[23246]="0:0:1:20:Consumable::5:0:26123,26124", -- Fiery Festival Brew
	[23247]="0:15:1:250:Junk::1:0:", -- Burning Blossom
	[23248]="0:12:1:10:::1:0:", -- Purified Helboar Meat
	[23249]="0:12:1:1:::1:0:", -- Amani Invasion Plans
	[23250]="0:15:1:1:Junk::1:0:", -- Prismatic Shell
	[23251]="0:4:3:1:Mail::1:0:", -- Champion's Chain Helm
	[23252]="0:4:3:1:Mail::1:0:", -- Champion's Chain Shoulders
	[23253]="0:4:3:1:Leather::1:0:", -- Champion's Dragonhide Headguard
	[23254]="0:4:3:1:Leather::1:0:", -- Champion's Dragonhide Shoulders
	[23255]="0:4:3:1:Cloth::1:0:", -- Champion's Dreadweave Cowl
	[23256]="0:4:3:1:Cloth::1:0:", -- Champion's Dreadweave Spaulders
	[23257]="0:4:3:1:Leather::1:0:", -- Champion's Leather Helm
	[23258]="0:4:3:1:Leather::1:0:", -- Champion's Leather Shoulders
	[23259]="0:4:3:1:Mail::1:0:", -- Champion's Mail Headguard
	[23260]="0:4:3:1:Mail::1:0:", -- Champion's Mail Pauldrons
	[23261]="0:4:3:1:Cloth::1:0:", -- Champion's Satin Hood
	[23262]="0:4:3:1:Cloth::1:0:", -- Champion's Satin Mantle
	[23263]="0:4:3:1:Cloth::1:0:", -- Champion's Silk Cowl
	[23264]="0:4:3:1:Cloth::1:0:", -- Champion's Silk Mantle
	[23265]="0:4:1:1:Mail::1:0:", -- Blackened Chain Girdle
	[23266]="0:4:1:1:Leather::1:0:", -- Ranger's Vest
	[23267]="0:4:1:1:Cloth::1:0:", -- Satin Lined Boots
	[23268]="0:12:1:1:::1:0:", -- Purification Mixture
	[23269]="0:12:1:20:::1:0:", -- Felblood Sample
	[23270]="0:12:1:10:::1:0:", -- Tainted Helboar Meat
	[23272]="0:4:3:1:Plate::1:0:", -- Knight-Captain's Lamellar Breastplate
	[23273]="0:4:3:1:Plate::1:0:", -- Knight-Captain's Lamellar Leggings
	[23274]="0:4:3:1:Plate::1:0:", -- Knight-Lieutenant's Lamellar Gauntlets
	[23275]="0:4:3:1:Plate::1:0:", -- Knight-Lieutenant's Lamellar Sabatons
	[23276]="0:4:3:1:Plate::1:0:", -- Lieutenant Commander's Lamellar Headguard
	[23277]="0:4:3:1:Plate::1:0:", -- Lieutenant Commander's Lamellar Shoulders
	[23278]="0:4:3:1:Mail::1:0:", -- Knight-Lieutenant's Chain Greaves
	[23279]="0:4:3:1:Mail::1:0:", -- Knight-Lieutenant's Chain Vices
	[23280]="0:4:3:1:Leather::1:0:", -- Knight-Lieutenant's Dragonhide Grips
	[23281]="0:4:3:1:Leather::1:0:", -- Knight-Lieutenant's Dragonhide Treads
	[23282]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Dreadweave Handwraps
	[23283]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Dreadweave Walkers
	[23284]="0:4:3:1:Leather::1:0:", -- Knight-Lieutenant's Leather Grips
	[23285]="0:4:3:1:Leather::1:0:", -- Knight-Lieutenant's Leather Walkers
	[23286]="0:4:3:1:Plate::1:0:", -- Knight-Lieutenant's Plate Gauntlets
	[23287]="0:4:3:1:Plate::1:0:", -- Knight-Lieutenant's Plate Greaves
	[23288]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Satin Handwraps
	[23289]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Satin Walkers
	[23290]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Silk Handwraps
	[23291]="0:4:3:1:Cloth::1:0:", -- Knight-Lieutenant's Silk Walkers
	[23292]="0:4:3:1:Mail::1:0:", -- Knight-Captain's Chain Hauberk
	[23293]="0:4:3:1:Mail::1:0:", -- Knight-Captain's Chain Legguards
	[23294]="0:4:3:1:Leather::1:0:", -- Knight-Captain's Dragonhide Chestpiece
	[23295]="0:4:3:1:Leather::1:0:", -- Knight-Captain's Dragonhide Leggings
	[23296]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Dreadweave Legguards
	[23297]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Dreadweave Tunic
	[23298]="0:4:3:1:Leather::1:0:", -- Knight-Captain's Leather Chestpiece
	[23299]="0:4:3:1:Leather::1:0:", -- Knight-Captain's Leather Legguards
	[23300]="0:4:3:1:Plate::1:0:", -- Knight-Captain's Plate Hauberk
	[23301]="0:4:3:1:Plate::1:0:", -- Knight-Captain's Plate Leggings
	[23302]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Satin Legguards
	[23303]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Satin Tunic
	[23304]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Silk Legguards
	[23305]="0:4:3:1:Cloth::1:0:", -- Knight-Captain's Silk Tunic
	[23306]="0:4:3:1:Mail::1:0:", -- Lieutenant Commander's Chain Helm
	[23307]="0:4:3:1:Mail::1:0:", -- Lieutenant Commander's Chain Shoulders
	[23308]="0:4:3:1:Leather::1:0:", -- Lieutenant Commander's Dragonhide Headguard
	[23309]="0:4:3:1:Leather::1:0:", -- Lieutenant Commander's Dragonhide Shoulders
	[23310]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Dreadweave Cowl
	[23311]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Dreadweave Spaulders
	[23312]="0:4:3:1:Leather::1:0:", -- Lieutenant Commander's Leather Helm
	[23313]="0:4:3:1:Leather::1:0:", -- Lieutenant Commander's Leather Shoulders
	[23314]="0:4:3:1:Plate::1:0:", -- Lieutenant Commander's Plate Helmet
	[23315]="0:4:3:1:Plate::1:0:", -- Lieutenant Commander's Plate Shoulders
	[23316]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Satin Hood
	[23317]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Satin Mantle
	[23318]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Silk Cowl
	[23319]="0:4:3:1:Cloth::1:0:", -- Lieutenant Commander's Silk Mantle
	[23320]="0:9:3:1:Book::1:0:", -- Tablet of Flame Shock VI
	[23321]="5:4:0:1:Cloth::1:0:18672", -- Recruit's Robe
	[23322]="0:4:0:1:Cloth::1:0:", -- Acolyte's Robe
	[23323]="0:4:1:1:Cloth::1:0:", -- Crown of the Fire Festival
	[23324]="0:4:1:1:Miscellaneous::1:0:26123,26124", -- Mantle of the Fire Festival
	[23326]="0:0:1:20:Consumable::5:0:26123,26124", -- Midsummer Sausage
	[23327]="0:0:1:20:Consumable::5:0:26123,26124", -- Fire-toasted Bun
	[23329]="0:0:1:5:Other::1:0:", -- Enriched Lasher Root
	[23331]="0:15:0:20:Junk::1:0:", -- Broken Vine
	[23332]="0:15:0:40:Junk::1:0:", -- Withered Lasher Root
	[23333]="0:15:0:20:Junk::1:0:", -- Shattered Power Core
	[23334]="0:0:1:5:Other::1:0:", -- Cracked Power Core
	[23336]="0:12:1:6:::1:0:", -- Helboar Blood Sample
	[23337]="0:12:1:1:::1:0:", -- Cenarion Antidote
	[23338]="0:12:1:1:::1:0:", -- Eroded Leather Case
	[23339]="0:12:1:1:::1:0:", -- Arelion's Journal
	[23340]="0:12:1:1:::1:0:", -- Arelion's Journal Page 2
	[23341]="0:12:1:1:::1:0:", -- Arelion's Journal Page 3
	[23342]="0:12:1:1:::1:0:", -- Arelion's Journal Page 4
	[23343]="0:12:1:1:::1:0:", -- Torn Pilgrim's Pack
	[23344]="0:4:0:1:Cloth::1:0:", -- Scout's Pants
	[23345]="0:4:1:1:Shirt::1:0:", -- Scout's Shirt
	[23346]="0:2:1:1:TwoHandSword::1:0:", -- Battleworn Claymore
	[23347]="0:2:1:1:Crossbow::1:0:", -- Weathered Crossbow
	[23348]="0:4:1:1:Miscellaneous::1:0:", -- Scout's Boots
	[23352]="0:12:1:1:::1:0:", -- Potent Voidwalker Essence
	[23353]="0:15:0:20:Junk::1:0:", -- Mana Residue
	[23354]="0:0:1:5:Other::1:0:", -- Crystalized Mana Residue
	[23355]="0:12:0:10:::1:0:", -- Toxic Helboar Meat
	[23358]="0:12:1:1:::1:0:", -- Signaling Gem
	[23361]="0:0:1:1:Consumable::1:0:", -- Cleansing Vial
	[23367]="0:4:1:1:Cloth::1:0:", -- Light Silk Robe
	[23370]="0:2:1:1:OneHandSword::1:0:", -- Ley-Keeper's Blade
	[23371]="0:2:1:1:Stave::1:0:", -- Velania's Walking Stick
	[23372]="0:2:1:1:TwoHandSword::1:0:", -- Bloodhawk Claymore
	[23373]="0:2:1:1:OneHandSword::1:0:", -- Long Knife
	[23375]="0:4:1:1:Leather::1:0:", -- Black Leather Vest
	[23376]="0:4:1:1:Mail::1:0:", -- Gatewatcher's Chain Gloves
	[23377]="0:4:1:1:Cloth::1:0:", -- Guard's Leggings
	[23379]="0:15:2:1:CombatPet::1:0:", -- Cinder Bracers
	[23380]="0:15:0:20:Junk::1:0:", -- Broken Power Core
	[23381]="0:0:1:5:Other::1:0:", -- Chipped Power Core
	[23383]="0:15:0:10:Junk::1:0:", -- Ripped Wyrm Scale
	[23384]="0:15:0:10:Junk::1:0:", -- Dimly Glowing Eye
	[23385]="0:15:0:20:Junk::1:0:", -- Dormant Mana Powder
	[23386]="0:0:1:5:Other::1:0:", -- Condensed Mana Powder
	[23387]="0:12:1:10:::1:0:", -- Bonestripper Tail Feather
	[23389]="0:1:1:1:Bag::1:0:", -- Empty Draenei Supply Pouch
	[23390]="0:2:1:1:TwoHandSword::1:0:", -- Exodar Bastard Sword
	[23391]="0:2:1:1:Dagger::1:0:", -- Exodar Dagger
	[23392]="0:2:1:1:OneHandMace::1:0:", -- Exodar Maul
	[23393]="0:2:1:1:OneHandSword::1:0:", -- Exodar Shortsword
	[23394]="0:12:1:1:::1:0:", -- Healing Salve
	[23395]="0:4:1:1:Shield::1:0:", -- Farstrider's Buckler
	[23396]="0:2:1:1:OneHandSword::1:0:", -- Slightly Used Ranger's Blade
	[23397]="0:4:1:1:Cloth::1:0:", -- Satin Lined Gloves
	[23398]="0:2:1:1:Bow::1:0:", -- Worn Ranger's Bow
	[23399]="0:4:2:1:Cloth::1:0:", -- Fallen Apprentice's Robe
	[23400]="0:4:2:1:Cloak::1:0:", -- Sylastor's Cloak
	[23401]="0:4:2:1:OffHandFrill::1:0:", -- Divining Crystal
	[23402]="0:2:2:1:Dagger::1:0:", -- Arcanist's Dagger
	[23403]="0:4:2:1:Mail::1:0:", -- Salvaged Mail Leggings
	[23404]="0:4:2:1:Leather::1:0:", -- Padded Running Shoes
	[23405]="0:4:2:1:Leather::1:0:", -- Farstrider's Tunic
	[23406]="0:4:2:1:Mail::1:0:", -- Sentry Bracers
	[23407]="0:4:2:1:Cloth::1:0:", -- Supple Cotton Bracer
	[23408]="0:4:2:1:Leather::1:0:", -- Farstrider's Bracers
	[23409]="0:2:2:1:Bow::1:0:", -- Well Crafted Long Bow
	[23410]="0:2:2:1:OneHandSword::1:0:", -- Well Crafted Sword
	[23411]="0:2:2:1:Stave::1:0:", -- Well Crafted Staff
	[23412]="0:4:2:1:Mail::1:0:", -- Troll Kickers
	[23413]="0:4:2:1:Cloth::1:0:", -- Troll Kickers
	[23414]="0:4:2:1:Leather::1:0:", -- Troll Kickers
	[23415]="0:2:2:1:Dagger::1:0:", -- Survival Knife
	[23417]="0:0:1:1:Consumable::1:0:", -- Sanctified Crystal
	[23423]="0:2:2:1:TwoHandSword::1:0:", -- Mercenary Greatsword
	[23424]="0:7:1:20:MetalStone:186:1:0:", -- Fel Iron Ore
	[23425]="0:7:1:20:MetalStone:186:1:0:", -- Adamantite Ore
	[23426]="0:7:2:20:MetalStone:186:1:0:", -- Khorium Ore
	[23427]="0:7:2:20:MetalStone:333,186:1:0:", -- Eternium Ore
	[23429]="0:2:2:1:TwoHandMace::1:0:", -- Mercenary Clout
	[23430]="0:2:2:1:OneHandSword::1:0:", -- Mercenary Sword
	[23431]="0:2:2:1:Dagger::1:0:", -- Mercenary Stiletto
	[23435]="0:0:1:20:Consumable::5:0:26123,26124", -- Elderberry Pie
	[23436]="120000:3:3:20:GemRed:202,755:1:1:14846", -- Living Ruby
	[23437]="120000:3:3:20:GemGreen:202,755:1:1:14846", -- Talasite
	[23438]="120000:3:3:20:GemBlue:202,755:1:1:14846", -- Star of Elune
	[23439]="120000:3:3:20:GemOrange:202,755:1:1:14846", -- Noble Topaz
	[23440]="120000:3:3:20:GemYellow:202,755:1:1:14846", -- Dawnstone
	[23441]="120000:3:3:20:GemPurple:202,755:1:1:14846", -- Nightseye
	[23442]="0:12:1:1:::1:0:", -- Glowing Sanctified Crystal
	[23444]="0:0:1:5:Elixir::1:0:", -- Goldenmist Special Brew
	[23445]="0:7:1:20:MetalStone:164,202,755,186:1:0:", -- Fel Iron Bar
	[23446]="0:7:1:20:MetalStone:164,202,755,186:1:0:", -- Adamantite Bar
	[23447]="0:7:2:20:MetalStone:164,755,186:1:0:", -- Eternium Bar
	[23448]="0:7:2:20:MetalStone:164,202,755:1:0:", -- Felsteel Bar
	[23449]="0:7:2:20:MetalStone:164,202,755,186:1:0:", -- Khorium Bar
	[23451]="0:2:4:1:Dagger::1:0:", -- Grand Marshal's Mageblade
	[23452]="0:4:4:1:OffHandFrill::1:0:", -- Grand Marshal's Tome of Power
	[23453]="0:4:4:1:OffHandFrill::1:0:", -- Grand Marshal's Tome of Restoration
	[23454]="0:2:4:1:OneHandMace::1:0:", -- Grand Marshal's Warhammer
	[23455]="0:2:4:1:TwoHandMace::1:0:", -- Grand Marshal's Demolisher
	[23456]="0:2:4:1:OneHandSword::1:0:", -- Grand Marshal's Swiftblade
	[23460]="0:12:1:20:::1:0:", -- Broken Blood Sample
	[23464]="0:2:4:1:OneHandMace::1:0:", -- High Warlord's Battle Mace
	[23465]="0:2:4:1:TwoHandMace::1:0:", -- High Warlord's Destroyer
	[23466]="0:2:4:1:Dagger::1:0:", -- High Warlord's Spellblade
	[23467]="0:2:4:1:OneHandSword::1:0:", -- High Warlord's Quickblade
	[23468]="0:4:4:1:OffHandFrill::1:0:", -- High Warlord's Tome of Destruction
	[23469]="0:4:4:1:OffHandFrill::1:0:", -- High Warlord's Tome of Mending
	[23473]="0:4:1:1:Shirt::1:0:", -- Recruit's Shirt
	[23474]="0:4:0:1:Cloth::1:0:", -- Recruit's Pants
	[23475]="0:4:1:1:Miscellaneous::1:0:", -- Recruit's Boots
	[23476]="0:4:1:1:Shirt::1:0:", -- Squire's Shirt
	[23477]="0:4:0:1:Cloth::1:0:", -- Squire's Pants
	[23478]="0:4:0:1:Cloth::1:0:", -- Recruit's Pants
	[23479]="0:4:0:1:Cloth::1:0:", -- Recruit's Robe
	[23480]="0:12:1:1:::1:0:", -- Lit Torch
	[23482]="0:4:2:1:Plate::1:0:", -- Fel Iron Plate Gloves
	[23483]="0:12:1:20:::1:0:", -- Haal'eshi Scroll
	[23484]="0:4:2:1:Plate::1:0:", -- Fel Iron Plate Belt
	[23485]="0:12:1:1:::1:0:", -- Empty Birdcage
	[23486]="0:12:1:1:::1:0:", -- Caged Female Kaliri Hatchling
	[23487]="0:4:2:1:Plate::1:0:", -- Fel Iron Plate Boots
	[23488]="0:4:2:1:Plate::1:0:", -- Fel Iron Plate Pants
	[23489]="0:4:2:1:Plate::1:0:", -- Fel Iron Breastplate
	[23490]="0:4:2:1:Mail::1:0:", -- Fel Iron Chain Tunic
	[23491]="0:4:2:1:Mail::1:0:", -- Fel Iron Chain Gloves
	[23492]="0:0:1:20:Consumable::1:0:", -- Suntouched Special Reserve
	[23493]="0:4:2:1:Mail::1:0:", -- Fel Iron Chain Coif
	[23494]="0:4:2:1:Mail::1:0:", -- Fel Iron Chain Bracers
	[23495]="0:0:1:20:FoodDrink::1:0:", -- Springpaw Appetizer
	[23497]="0:2:2:1:OneHandAxe::1:0:", -- Fel Iron Hatchet
	[23498]="0:2:2:1:OneHandMace::1:0:", -- Fel Iron Hammer
	[23499]="0:2:2:1:TwoHandSword::1:0:", -- Fel Iron Greatsword
	[23500]="0:15:1:1:Junk::1:0:", -- Saltheril's Haven Party Invitation
	[23501]="0:15:1:5:Junk::1:0:", -- Bloodthistle Petal
	[23502]="0:2:2:1:TwoHandMace::1:0:", -- Adamantite Maul
	[23503]="0:2:2:1:TwoHandAxe::1:0:", -- Adamantite Cleaver
	[23504]="0:2:2:1:Dagger::1:0:", -- Adamantite Dagger
	[23505]="0:2:2:1:OneHandSword::1:0:", -- Adamantite Rapier
	[23506]="0:4:3:1:Plate::1:0:", -- Adamantite Plate Bracers
	[23507]="0:4:3:1:Plate::1:0:", -- Adamantite Breastplate
	[23508]="0:4:3:1:Plate::1:0:", -- Adamantite Plate Gloves
	[23509]="0:4:3:1:Plate::1:0:", -- Enchanted Adamantite Breastplate
	[23510]="0:4:3:1:Plate::1:0:", -- Enchanted Adamantite Belt
	[23511]="0:4:3:1:Plate::1:0:", -- Enchanted Adamantite Boots
	[23512]="0:4:3:1:Plate::1:0:", -- Enchanted Adamantite Leggings
	[23513]="0:4:3:1:Plate::1:0:", -- Flamebane Breastplate
	[23514]="0:4:3:1:Plate::1:0:", -- Flamebane Gloves
	[23515]="0:4:3:1:Plate::1:0:", -- Flamebane Bracers
	[23516]="0:4:3:1:Plate::1:0:", -- Flamebane Helm
	[23517]="0:4:3:1:Plate::1:0:", -- Felsteel Gloves
	[23518]="0:4:3:1:Plate::1:0:", -- Felsteel Leggings
	[23519]="0:4:3:1:Plate::1:0:", -- Felsteel Helm
	[23520]="0:4:3:1:Plate::1:0:", -- Ragesteel Gloves
	[23521]="0:4:3:1:Plate::1:0:", -- Ragesteel Helm
	[23522]="0:4:3:1:Plate::1:0:", -- Ragesteel Breastplate
	[23523]="0:4:3:1:Plate::1:0:", -- Khorium Pants
	[23524]="0:4:3:1:Plate::1:0:", -- Khorium Belt
	[23525]="0:4:3:1:Plate::1:0:", -- Khorium Boots
	[23526]="0:4:3:1:Mail::1:0:", -- Swiftsteel Gloves
	[23527]="0:4:3:1:Mail::1:0:", -- Earthpeace Breastplate
	[23528]="0:0:1:20:EnhTemp::1:0:", -- Fel Sharpening Stone
	[23529]="0:0:2:20:EnhTemp::1:0:", -- Adamantite Sharpening Stone
	[23530]="0:0:2:5:EnhPerm::1:0:", -- Felsteel Shield Spike
	[23531]="0:4:4:1:Mail::1:0:", -- Felfury Gauntlets
	[23532]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Iron Tower
	[23533]="0:4:4:1:Plate::1:0:", -- Steelgrip Gauntlets
	[23534]="0:4:4:1:Mail::1:0:", -- Storm Helm
	[23535]="0:4:4:1:Plate::1:0:", -- Helm of the Stalwart Defender
	[23536]="0:4:4:1:Plate::1:0:", -- Oathkeeper's Helm
	[23537]="0:4:4:1:Plate::1:0:", -- Black Felsteel Bracers
	[23538]="0:4:4:1:Plate::1:0:", -- Bracers of the Green Fortress
	[23539]="0:4:4:1:Plate::1:0:", -- Blessed Bracers
	[23540]="0:2:4:1:OneHandSword::1:0:", -- Felsteel Longblade
	[23541]="0:2:4:1:TwoHandSword::1:0:", -- Khorium Champion
	[23542]="0:2:4:1:OneHandAxe::1:0:", -- Fel Edged Battleaxe
	[23543]="0:2:4:1:TwoHandAxe::1:0:", -- Felsteel Reaper
	[23544]="0:2:4:1:OneHandMace::1:0:", -- Runic Hammer
	[23545]="0:0:4:1:EnhPerm::1:0:", -- Power of the Scourge
	[23546]="0:2:4:1:TwoHandMace::1:0:", -- Fel Hardened Maul
	[23547]="0:0:4:1:EnhPerm::1:0:", -- Resilience of the Scourge
	[23548]="0:0:4:1:EnhPerm::1:0:", -- Might of the Scourge
	[23549]="0:0:4:1:EnhPerm::1:0:", -- Fortitude of the Scourge
	[23550]="0:12:1:1:::1:0:", -- Heavy Stone Axe
	[23551]="0:12:1:20:::1:0:", -- Azure Phial
	[23552]="0:12:1:20:::1:0:", -- Filled Azure Phial
	[23553]="0:2:1:1:Stave::1:0:", -- Living Branch
	[23554]="0:2:4:1:Dagger::1:0:", -- Eternium Runed Blade
	[23555]="0:2:4:1:Dagger::1:0:", -- Dirge
	[23556]="0:2:4:1:OneHandMace::1:0:", -- Hand of Eternity
	[23557]="0:2:4:1:Gun::1:0:", -- Larvae of the Great Worm
	[23558]="0:4:4:1:Trinket::1:0:", -- The Burrower's Shell
	[23559]="0:0:1:20:EnhTemp::1:0:", -- Lesser Rune of Warding
	[23560]="0:15:1:1:Junk::1:0:", -- Arena Team Charter (2v2)
	[23561]="0:15:1:1:Junk::1:0:", -- Arena Team Charter (3v3)
	[23562]="0:15:1:1:Junk::1:0:", -- Arena Team Charter (5v5)
	[23563]="0:4:4:1:Mail:164:1:0:", -- Nether Chain Shirt
	[23564]="0:4:4:1:Mail:164:1:0:", -- Twisting Nether Chain Shirt
	[23565]="0:4:4:1:Mail::1:0:", -- Embrace of the Twisting Nether
	[23566]="0:12:1:1:::1:0:", -- Azure Phial
	[23568]="0:12:1:1:::1:0:", -- Bundle of Vials
	[23569]="0:12:1:1:::1:0:", -- Letter from the Mag'har
	[23570]="0:4:4:1:Trinket::1:0:", -- Jom Gabbar
	[23571]="0:7:3:20:Elemental:171,164,333,202,755,165,197:1:0:", -- Primal Might
	[23572]="0:7:3:20:Material:164,202,755,165,197:1:0:18525", -- Primal Nether
	[23573]="0:7:1:20:MetalStone:164,202,755,186:1:0:", -- Hardened Adamantite Bar
	[23574]="80000:9:2:1:Alchemy::1:1:16641,16705,19074", -- Recipe: Transmute Primal Might
	[23575]="0:0:1:5:EnhTemp::1:0:", -- Lesser Ward of Shielding
	[23576]="0:0:1:5:EnhTemp::1:0:", -- Greater Ward of Shielding
	[23577]="0:2:4:1:OneHandSword::1:0:", -- The Hungering Cold
	[23580]="0:12:1:1:::1:0:", -- Avruu's Orb
	[23584]="0:0:1:10:Consumable::1:0:", -- Loch Modan Lager
	[23585]="4000:0:1:20:Consumable::5:0:20377", -- Stouthammer Lite
	[23586]="0:0:1:20:Consumable::1:0:", -- Aerie Peak Pale Ale
	[23587]="0:4:2:1:Cloth::1:0:", -- Mirren's Drinking Hat
	[23588]="0:12:1:20:::1:0:", -- Kaliri Feather
	[23589]="0:12:1:10:::1:0:", -- Mag'har Ancestral Beads
	[23590]="40000:9:1:1:Blacksmithing::1:1:16670,16713,19662", -- Plans: Adamantite Maul
	[23591]="40000:9:1:1:Blacksmithing::1:1:16670,16713,19662", -- Plans: Adamantite Cleaver
	[23592]="40000:9:1:1:Blacksmithing::1:1:16670,16713,19662", -- Plans: Adamantite Dagger
	[23593]="40000:9:1:1:Blacksmithing::1:1:16670,16713,19662", -- Plans: Adamantite Rapier
	[23594]="60000:9:1:1:Blacksmithing::1:1:19342,19694", -- Plans: Adamantite Plate Bracers
	[23595]="60000:9:1:1:Blacksmithing::1:1:19342,19694", -- Plans: Adamantite Plate Gloves
	[23596]="60000:9:1:1:Blacksmithing::1:1:19342,19694", -- Plans: Adamantite Breastplate
	[23597]="60000:9:1:1:Blacksmithing::1:0:19331", -- Plans: Enchanted Adamantite Belt
	[23598]="60000:9:1:1:Blacksmithing::1:0:19331", -- Plans: Enchanted Adamantite Boots
	[23599]="60000:9:1:1:Blacksmithing::1:0:19331", -- Plans: Enchanted Adamantite Breastplate
	[23600]="80000:9:1:1:Blacksmithing::1:0:19331", -- Plans: Enchanted Adamantite Leggings
	[23601]="60000:9:1:1:Blacksmithing::1:0:19321", -- Plans: Flamebane Bracers
	[23602]="60000:9:1:1:Blacksmithing::1:0:19321", -- Plans: Flamebane Helm
	[23603]="60000:9:1:1:Blacksmithing::1:0:19321", -- Plans: Flamebane Gloves
	[23604]="80000:9:1:1:Blacksmithing::1:0:19321", -- Plans: Flamebane Breastplate
	[23605]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Felsteel Gloves
	[23606]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Felsteel Leggings
	[23607]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Felsteel Helm
	[23608]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Khorium Belt
	[23609]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Khorium Pants
	[23610]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Khorium Boots
	[23611]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Ragesteel Gloves
	[23612]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Ragesteel Helm
	[23613]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Ragesteel Breastplate
	[23614]="0:12:1:20:::1:0:", -- Red Snapper
	[23615]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Swiftsteel Gloves
	[23617]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Earthpeace Breastplate
	[23618]="60000:9:1:1:Blacksmithing::1:0:17904", -- Plans: Adamantite Sharpening Stone
	[23619]="60000:9:1:1:Blacksmithing::1:0:17657", -- Plans: Felsteel Shield Spike
	[23620]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Felfury Gauntlets
	[23621]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Gauntlets of the Iron Tower
	[23622]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Steelgrip Gauntlets
	[23623]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Storm Helm
	[23624]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Helm of the Stalwart Defender
	[23625]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Oathkeeper's Helm
	[23626]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Black Felsteel Bracers
	[23627]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Bracers of the Green Fortress
	[23628]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Blessed Bracers
	[23629]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Felsteel Longblade
	[23630]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Khorium Champion
	[23631]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Fel Edged Battleaxe
	[23632]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Felsteel Reaper
	[23633]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Runic Hammer
	[23634]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Fel Hardened Maul
	[23635]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Eternium Runed Blade
	[23636]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Dirge
	[23637]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Hand of Eternity
	[23638]="60000:9:1:1:Blacksmithing::1:1:16583,19373", -- Plans: Lesser Ward of Shielding
	[23639]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Greater Ward of Shielding
	[23642]="0:12:1:10:::1:0:", -- Sha'naar Relic
	[23643]="0:12:1:4:::1:0:", -- Purifying Earth
	[23644]="0:12:1:1:::1:0:", -- Crate of Reagents
	[23645]="0:0:1:1:Consumable::1:0:", -- Seer's Relic
	[23646]="0:12:1:1:::1:0:", -- Shipment of Rare Crystals
	[23654]="0:12:1:1:::1:0:", -- Draenei Fishing Net
	[23657]="0:12:1:1:::1:0:", -- Dawn Runner Cargo
	[23658]="0:12:1:1:::1:0:", -- Advisor's Pack
	[23659]="0:12:1:1:::1:0:", -- Fel-Tainted Morsels
	[23660]="0:12:1:1:::1:0:", -- Advisor's Rapier
	[23661]="0:12:1:1:::1:0:", -- Mark of the Lightbringer
	[23662]="0:12:1:1:::1:0:", -- Letter from Nazgrel
	[23663]="0:4:4:1:Mail::1:0:", -- Girdle of Elemental Fury
	[23664]="0:4:4:1:Mail::1:0:", -- Pauldrons of Elemental Fury
	[23665]="0:4:4:1:Mail::1:0:", -- Leggings of Elemental Fury
	[23666]="0:4:4:1:Plate::1:0:", -- Belt of the Grand Crusader
	[23667]="0:4:4:1:Plate::1:0:", -- Spaulders of the Grand Crusader
	[23668]="0:4:4:1:Plate::1:0:", -- Leggings of the Grand Crusader
	[23669]="0:12:1:1:::1:0:", -- Ancestral Spirit Wolf Totem
	[23670]="0:12:1:1:::1:0:", -- Thalanaar Moonwell Water
	[23671]="0:12:1:1:::1:0:", -- Earth Crystal
	[23672]="0:12:1:1:::1:0:", -- Crate of Red Snapper
	[23675]="0:12:1:1:::1:0:", -- Robotron Control Unit
	[23676]="0:7:1:50:Meat:185:1:0:", -- Moongraze Stag Tenderloin
	[23677]="0:12:1:6:::1:0:", -- Moongraze Buck Hide
	[23678]="0:12:1:1:::1:0:", -- Faintly Glowing Crystal
	[23679]="0:12:1:1:::1:0:", -- Bloodscalp Totem
	[23680]="0:12:1:1:::1:0:", -- Gift of Naias
	[23681]="0:12:1:1:::1:0:", -- Heart of Naias
	[23682]="0:12:1:1:::1:0:", -- Ritual Torch
	[23684]="0:0:1:20:Bandage::1:0:", -- Crystal Infused Bandage
	[23685]="0:12:1:8:::1:0:", -- Root Trapper Vine
	[23686]="0:12:1:1:::1:0:", -- Lacy Handkerchief
	[23687]="0:12:1:1:::1:0:", -- Blacktalon's Claws
	[23688]="0:12:1:1:::1:0:", -- Hauteur's Ashes
	[23691]="0:4:1:1:OffHandFrill::1:0:", -- Corrupted Mark of the Lightbringer
	[23692]="0:12:1:5:::1:0:", -- Azure Snapdragon Bulb
	[23693]="0:12:1:1:::1:0:", -- Carinda's Scroll of Retribution
	[23694]="0:12:1:5:::1:0:", -- Gryphon Egg
	[23695]="0:15:0:1:Junk::1:0:", -- Featherbeard's Map
	[23697]="0:12:1:1:::1:0:", -- Taming Rod
	[23702]="0:12:1:1:::1:0:", -- Taming Rod
	[23703]="0:12:1:1:::1:0:", -- Taming Rod
	[23705]="0:4:4:1:Tabard::1:0:", -- Tabard of Flame
	[23706]="0:12:1:20:::1:0:", -- Arcane Fragment
	[23707]="0:12:1:1:::1:0:", -- Spindleweb Silk Gland
	[23709]="0:4:4:1:Tabard::1:0:", -- Tabard of Frost
	[23711]="18000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Intercept (Rank 1)
	[23713]="0:15:4:1:Companion::1:0:", -- Hippogryph Hatchling
	[23717]="0:4:1:1:Ring::1:0:", -- Pitted Gold Band
	[23720]="0:15:4:1:Mount::1:0:", -- Riding Turtle
	[23723]="0:12:1:1:::1:0:", -- Warchief Kargath's Fist
	[23726]="0:12:1:1:::1:0:", -- Fel Ember
	[23729]="0:12:1:1:::1:0:", -- Fel Horde Banner
	[23730]="26000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Intercept (Rank 2)
	[23731]="60000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Intercept (Rank 3)
	[23732]="0:12:1:1:::1:0:", -- Voidstone
	[23733]="0:12:1:1:::1:0:", -- Ritual Torch
	[23734]="15000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Cleave (Rank 1)
	[23735]="0:12:1:1:::1:0:", -- Grand Warlock's Amulet
	[23736]="10000:7:1:20:Explosive::1:1:19575,19661,21112", -- Fel Iron Bomb
	[23737]="10000:7:1:20:Explosive::1:1:19575", -- Adamantite Grenade
	[23738]="0:12:1:1:::1:0:", -- Nautical Compass
	[23739]="0:12:1:1:::1:0:", -- Nautical Map
	[23742]="0:2:2:1:Gun::1:0:", -- Fel Iron Musket
	[23744]="0:12:1:10:::1:0:", -- Foul Essence
	[23745]="15000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Cleave (Rank 2)
	[23746]="0:2:2:1:Gun::1:0:", -- Adamantite Rifle
	[23747]="0:2:3:1:Gun::1:0:", -- Felsteel Boomstick
	[23748]="0:2:3:1:Gun::1:0:", -- Ornate Khorium Rifle
	[23749]="0:12:1:1:::1:0:", -- Empty Bota Bag
	[23750]="0:12:1:1:::1:0:", -- Filled Bota Bag
	[23751]="0:12:1:1:::1:0:", -- Skin of Purest Water
	[23752]="0:12:1:1:::1:0:", -- Flask of Purest Water
	[23753]="0:12:1:20:::1:0:", -- Drycap Mushroom
	[23755]="60000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Cleave (Rank 3)
	[23756]="0:0:1:20:FoodDrink::1:0:", -- Cookie's Jumbo Gumbo
	[23757]="0:12:1:10:::1:0:", -- Skittering Crawler Meat
	[23758]="0:4:3:1:Leather::1:0:", -- Cogspinner Goggles
	[23759]="0:12:1:1:::1:0:", -- Rune Covered Tablet
	[23760]="0:12:1:1:::1:0:", -- Chalice of Elune
	[23761]="0:4:3:1:Cloth::1:0:", -- Power Amplification Goggles
	[23762]="0:4:3:1:Cloth::1:0:", -- Ultra-Spectropic Detection Goggles
	[23763]="0:4:3:1:Leather::1:0:", -- Hyper-Vision Goggles
	[23764]="0:0:2:5:EnhPerm::1:0:", -- Adamantite Scope
	[23765]="0:0:3:5:EnhPerm::1:0:", -- Khorium Scope
	[23766]="0:0:3:5:EnhPerm::1:0:", -- Stabilized Eternium Scope
	[23767]="0:15:2:1:CombatPet::1:0:", -- Crashin' Thrashin' Robot
	[23768]="1000:0:1:20:Other::1:1:19575,19661,21112,23208", -- White Smoke Flare
	[23769]="1000:0:1:20:Other::1:1:23208", -- Red Smoke Flare
	[23770]="0:0:1:20:Other::1:0:", -- Blue Smoke Flare
	[23771]="1000:0:1:20:Other::1:1:19575", -- Green Smoke Flare
	[23772]="0:6:2:1000:Bullet::1:0:", -- Fel Iron Shells
	[23773]="0:6:3:1000:Bullet::1:0:", -- Adamantite Shells
	[23774]="0:1:2:1:EngineeringBag::1:0:", -- Fel Iron Toolbox
	[23775]="0:1:3:1:EngineeringBag::1:0:", -- Titanium Toolbox
	[23776]="0:12:1:15:::1:0:", -- Warsong Lumber
	[23777]="0:12:1:1:::1:0:", -- Diabolical Plans
	[23778]="0:12:1:1:::1:0:", -- Sentinel Luciel's Report
	[23779]="0:12:1:8:::1:0:", -- Ancient Relic
	[23780]="0:12:1:1:::1:0:", -- Diabolical Plans
	[23781]="2000:7:1:20:Part:202:1:1:19575,19661,20981,21112", -- Elemental Blasting Powder
	[23782]="32000:7:1:10:Part:171,202:1:1:19575", -- Fel Iron Casing
	[23783]="6000:7:1:20:Part:202:1:1:19575,19661,20981,21112", -- Handful of Fel Iron Bolts
	[23784]="40000:7:1:10:Part:202:1:1:19575,20981", -- Adamantite Frame
	[23785]="120000:7:1:20:Part:202:1:1:20981", -- Hardened Adamantite Tube
	[23786]="48000:7:1:20:Part:202:1:1:19575", -- Khorium Power Core
	[23787]="48000:7:1:20:Part:202:1:1:19575", -- Felsteel Stabilizer
	[23788]="0:12:1:1:::1:0:", -- Tree Seedlings
	[23789]="0:12:1:1:::1:0:", -- Remains of Cowlen's Family
	[23790]="0:12:1:1:::1:0:", -- Hollowed Out Tree
	[23791]="0:12:1:10:::1:0:", -- Pile of Leaves
	[23792]="0:15:1:1:Junk::1:0:", -- Tree Disguise Kit
	[23793]="25000:7:1:20:Leather:164,202,165:1:1:14846", -- Heavy Knothide Leather
	[23797]="0:12:1:1:::1:0:", -- Diabolical Plans
	[23798]="0:12:1:1:::1:0:", -- Diabolical Plans
	[23799]="80000:9:1:1:Engineering::1:1:16657,16782,19661", -- Schematic: Adamantite Rifle
	[23800]="0:9:3:1:Engineering::1:0:", -- Schematic: Felsteel Boomstick
	[23801]="0:13:1:10:::1:0:", -- Bristlelimb Key
	[23802]="0:9:3:1:Engineering::1:0:", -- Schematic: Ornate Khorium Rifle
	[23803]="60000:9:1:1:Engineering::1:1:18775,19836", -- Schematic: Cogspinner Goggles
	[23804]="0:9:3:1:Engineering::1:0:", -- Schematic: Power Amplification Goggles
	[23805]="80000:9:1:1:Engineering::1:1:18775,19383", -- Schematic: Ultra-Spectropic Detection Goggles
	[23806]="0:9:3:1:Engineering::1:0:", -- Schematic: Hyper-Vision Goggles
	[23807]="60000:9:1:1:Engineering::1:1:19351,19836", -- Schematic: Adamantite Scope
	[23808]="0:9:3:1:Engineering::1:0:", -- Schematic: Khorium Scope
	[23809]="0:9:3:1:Engineering::1:0:", -- Schematic: Stabilized Eternium Scope
	[23810]="0:9:2:1:Engineering::1:0:", -- Schematic: Crashin' Thrashin' Robot
	[23811]="60000:9:1:1:Engineering::1:1:16657,16782,18484,19383", -- Schematic: White Smoke Flare
	[23814]="60000:9:1:1:Engineering::1:0:17904", -- Schematic: Green Smoke Flare
	[23815]="60000:9:1:1:Engineering::1:1:16657,16782,18484", -- Schematic: Adamantite Shell Machine
	[23816]="40000:9:1:1:Engineering::1:1:16657,16782,18484", -- Schematic: Fel Iron Toolbox
	[23817]="80000:9:1:1:Engineering::1:1:28722,33594", -- Schematic: Titanium Toolbox
	[23818]="0:15:1:1:Junk::1:0:", -- Stillpine Furbolg Language Primer
	[23819]="0:7:1:10:Explosive::1:0:", -- Elemental Seaforium Charge
	[23820]="0:7:2:1:Device::1:0:", -- Critter Enlarger
	[23821]="0:7:1:1:Device::1:0:", -- Zapthrottle Mote Extractor
	[23822]="0:0:1:1:Potion::1:0:", -- Healing Potion Injector
	[23823]="0:0:1:1:Potion::1:0:", -- Mana Potion Injector
	[23824]="0:4:3:1:Leather::1:0:", -- Rocket Boots Xtreme
	[23825]="0:4:3:1:Cloth::1:0:", -- Nigh Invulnerability Belt
	[23826]="0:7:1:20:Explosive:202:1:0:", -- The Bigger One
	[23827]="0:7:1:20:Explosive::1:0:", -- Super Sapper Charge
	[23828]="0:4:4:1:Cloth::1:0:", -- Gnomish Power Goggles
	[23829]="0:4:4:1:Leather::1:0:", -- Gnomish Battle Goggles
	[23830]="0:12:1:1:::1:0:", -- Clopper's Equipment
	[23831]="0:7:1:1:Device::1:0:", -- Goblin Tonk Controller
	[23832]="0:7:1:1:Device::1:0:", -- Gnomish Tonk Controller
	[23833]="0:12:1:6:::1:0:", -- Crude Murloc Knife
	[23834]="0:12:1:5:::1:0:", -- Crude Murloc Idol
	[23835]="0:4:3:1:Trinket::1:0:", -- Gnomish Poultryizer
	[23836]="0:4:3:1:Trinket::1:0:", -- Goblin Rocket Launcher
	[23837]="0:12:1:1:::1:0:", -- Weathered Treasure Map
	[23838]="0:4:4:1:Cloth::1:0:", -- Foreman's Enchanted Helmet
	[23839]="0:4:4:1:Mail::1:0:", -- Foreman's Reinforced Helmet
	[23840]="0:7:1:1:Device::1:0:", -- Remote Mail Terminal
	[23841]="0:7:1:10:Explosive::1:0:", -- Gnomish Flame Turret
	[23843]="0:12:1:1:::1:0:", -- Whorl of Air
	[23844]="0:4:2:1:OffHandFrill::1:0:", -- Nolkai's Lantern
	[23845]="0:12:1:8:::1:0:", -- Ravager Hide
	[23846]="0:15:1:1:Junk::1:0:", -- Nolkai's Box
	[23847]="0:15:0:1:Junk::1:0:", -- Nolkai's Band
	[23848]="2000:0:1:10:FoodDrink::1:0:3546", -- Nethergarde Bitter
	[23849]="0:12:1:5:::1:0:", -- Stillpine Grain
	[23850]="0:12:1:1:::1:0:", -- Gurf's Dignity
	[23851]="0:12:1:1:::1:0:", -- Battered Journal
	[23852]="0:1:2:1:Bag::1:0:", -- Nolkai's Bag
	[23857]="0:0:1:1:Other::1:0:", -- Legacy of the Mountain King
	[23858]="0:15:1:1:Junk::1:0:", -- Singed Page
	[23859]="0:12:1:1:::1:0:", -- Nazzivus Monument Glyph
	[23860]="0:12:1:1:::1:0:", -- The Kurken's Hide
	[23862]="0:0:1:1:Other::1:0:", -- Redemption of the Fallen
	[23863]="0:12:1:5:::1:0:", -- Corrupted Crystal
	[23864]="0:0:1:1:Other::1:0:", -- Torment of the Worgen
	[23865]="0:0:1:1:Other::1:0:", -- Wrath of the Titans
	[23866]="0:15:1:1:Junk::1:0:", -- Singed Page
	[23867]="0:15:1:1:Junk::1:0:", -- Singed Page
	[23868]="0:15:1:1:Junk::1:0:", -- Singed Page
	[23869]="0:12:1:10:::1:0:", -- Crystallized Bark
	[23870]="0:12:1:1:::1:0:", -- Red Crystal Pendant
	[23871]="0:0:1:3:Elixir::1:0:", -- Potion of Water Breathing
	[23873]="0:12:1:1:::1:0:", -- Galaen's Amulet
	[23874]="80000:9:1:1:Engineering::1:0:20242,23007", -- Schematic: Elemental Seaforium Charge
	[23875]="0:12:1:1:::1:0:", -- Crystal Mining Pick
	[23876]="0:12:1:1:::1:0:", -- Crystal Mining Pick
	[23877]="0:12:1:1:::1:0:", -- Crystal Mining Pick
	[23878]="0:12:1:1:::1:0:", -- Impact Site Crystal Sample
	[23879]="0:12:1:1:::1:0:", -- Altered Crystal Sample
	[23880]="0:12:1:1:::1:0:", -- Axxarien Crystal Sample
	[23881]="0:12:1:1:::1:0:", -- Gargolmar's Hand
	[23883]="0:9:3:1:Engineering::1:0:", -- Schematic: Healing Potion Injector
	[23884]="0:9:3:1:Engineering::1:0:", -- Schematic: Mana Potion Injector
	[23885]="0:9:3:1:Engineering::1:0:", -- Schematic: Remote Mail Terminal
	[23886]="0:12:1:1:::1:0:", -- Omor's Hoof
	[23887]="0:9:3:1:Engineering::1:0:", -- Schematic: Rocket Boots Xtreme
	[23888]="0:9:1:1:Engineering::1:0:", -- Schematic: Zapthrottle Mote Extractor
	[23890]="0:12:1:1:::1:0:", -- Ominous Letter
	[23891]="0:12:1:1:::1:0:", -- Ominous Letter
	[23892]="0:12:1:1:::1:0:", -- Ominous Letter
	[23893]="0:12:1:1:::1:0:", -- Ominous Letter
	[23894]="0:12:1:10:::1:0:", -- Fel Orc Blood Vial
	[23896]="0:12:1:1:::1:0:", -- Taming Totem
	[23897]="0:12:1:1:::1:0:", -- Taming Totem
	[23898]="0:12:1:1:::1:0:", -- Taming Totem
	[23899]="0:12:1:1:::1:0:", -- Traitor's Communication
	[23900]="0:12:1:1:::1:0:", -- Tzerak's Armor Plate
	[23901]="0:12:1:1:::1:0:", -- Nazan's Head
	[23902]="0:12:1:1:::1:0:", -- Topher's List
	[23903]="0:12:1:1:::1:0:", -- Nurguni's Supplies
	[23909]="0:4:1:1:Miscellaneous::1:0:", -- Blood Elf Bandit Mask
	[23910]="0:15:1:1:Junk::1:0:", -- Blood Elf Communication
	[23919]="0:12:1:1:::1:0:", -- Stack of Reports
	[23920]="0:15:0:5:Junk::1:0:", -- Tattered Handkerchief
	[23921]="0:15:1:1:Junk::1:0:", -- Bulging Sack of Silver
	[23922]="0:15:0:10:Junk::1:0:", -- Rat Skeleton
	[23923]="0:2:1:1:Dagger::1:0:", -- Amani Sacrificial Dagger
	[23924]="0:4:2:1:Cloth::1:0:", -- Robes of Silvermoon
	[23925]="0:13:1:1:::1:0:", -- Ravager Cage Key
	[23926]="0:12:1:1:::1:0:", -- Tome of Divinity
	[23927]="0:12:1:10:::1:0:", -- Sand Pear
	[23928]="0:12:1:1:::1:0:", -- The Exarch's Orders
	[23929]="0:12:1:1:::1:0:", -- Letter from Lor'themar Theron
	[23930]="0:12:1:1:::1:0:", -- Letter Sealed by Sylvanas
	[23931]="0:4:2:1:Cloth::1:0:", -- Azure Watch Robes
	[23932]="0:12:1:1:::1:0:", -- Survey Data Crystal
	[23933]="0:12:1:1:::1:0:", -- Medivh's Journal
	[23934]="0:12:1:1:::1:0:", -- Medivh's Journal
	[23937]="0:12:1:1:::1:0:", -- Letter of Introduction
	[23938]="0:15:0:10:Junk::1:0:", -- Pristine Ravager Carapace
	[23939]="0:15:0:10:Junk::1:0:", -- Pristine Ravager Claw
	[23944]="0:15:0:10:Junk::1:0:", -- Broken Ravager Carapace
	[23945]="0:15:0:5:Junk::1:0:", -- Broken Ravager Fang
	[23946]="0:15:0:10:Junk::1:0:", -- Broken Ravager Claw
	[23947]="0:15:0:10:Junk::1:0:", -- Cracked Ravager Carapace
	[23948]="0:15:0:5:Junk::1:0:", -- Cracked Ravager Fang
	[23949]="0:15:0:10:Junk::1:0:", -- Cracked Ravager Claw
	[23965]="0:15:0:10:Junk::1:0:", -- Chipped Ravager Claw
	[23976]="0:15:0:10:Junk::1:0:", -- Gnarled Ravager Carapace
	[23977]="0:15:0:5:Junk::1:0:", -- Gnarled Ravager Fang
	[23978]="0:15:0:10:Junk::1:0:", -- Gnarled Ravager Claw
	[23979]="0:15:0:10:Junk::1:0:", -- Chipped Ravager Carapace
	[23981]="0:12:1:20:::1:0:", -- Steam Pump Part
	[23984]="0:12:1:100:::1:0:", -- Irradiated Crystal Shard
	[23985]="0:0:1:10:Consumable::1:0:", -- Crystal of Vitality
	[23986]="0:0:1:10:Consumable::1:0:", -- Crystal of Insight
	[23987]="0:15:0:20:Junk::1:0:", -- Mutated Petal
	[23988]="0:15:0:20:Junk::1:0:", -- Mutated Vine
	[23989]="0:0:1:10:Consumable::1:0:", -- Crystal of Ferocity
	[23994]="0:12:1:6:::1:0:", -- Thorny Constrictor Vine
	[23995]="0:12:1:1:::1:0:", -- Murloc Tagger
	[23997]="0:12:1:1:::1:0:", -- Head of Tel'athion
	[23999]="10000:4:1:1:Tabard::1:0:5049,5191,5193,16766,17657", -- Honor Hold Tabard
	[24000]="60000:9:1:1:Enchanting::1:0:17585", -- Formula: Enchant Bracer - Superior Healing
	[24001]="50000:9:1:1:Alchemy::1:0:17585", -- Recipe: Elixir of Major Agility
	[24002]="60000:9:1:1:Blacksmithing::1:0:17585", -- Plans: Felsteel Shield Spike
	[24003]="60000:9:1:1:Enchanting::1:0:17585", -- Formula: Enchant Chest - Exceptional Stats
	[24004]="10000:4:1:1:Tabard::1:0:5188,5189,5190,16610,17585", -- Thrallmar Tabard
	[24006]="2000:0:1:20:Consumable::5:0:17585", -- Grunt's Waterskin
	[24007]="2000:0:1:20:Consumable::5:0:17657", -- Footman's Waterskin
	[24008]="4500:0:1:20:FoodDrink::5:0:17657", -- Dried Mushroom Rations
	[24009]="4500:0:1:20:FoodDrink::5:0:17585", -- Dried Fruit Rations
	[24020]="0:2:3:1:OneHandSword::1:0:", -- Shadowrend Longblade
	[24021]="0:4:3:1:Plate::1:0:", -- Light-Touched Breastplate
	[24022]="0:4:3:1:Mail::1:0:", -- Scale Leggings of the Skirmisher
	[24023]="0:4:3:1:Leather::1:0:", -- Bracers of Finesse
	[24024]="0:4:3:1:Cloth::1:0:", -- Pauldrons of Arcane Rage
	[24025]="0:12:1:1:::1:0:", -- Deathclaw's Paw
	[24026]="0:12:1:8:::1:0:", -- Elder Brown Bear Flank
	[24027]="0:3:3:1:GemRed::1:0:", -- Bold Living Ruby
	[24028]="0:3:3:1:GemRed::1:0:", -- Delicate Living Ruby
	[24029]="0:3:3:1:GemRed::1:0:", -- Teardrop Living Ruby
	[24030]="0:3:3:1:GemRed::1:0:", -- Runed Living Ruby
	[24031]="0:3:3:1:GemRed::1:0:", -- Bright Living Ruby
	[24032]="0:3:3:1:GemRed::1:0:", -- Subtle Living Ruby
	[24033]="0:3:3:1:GemBlue::1:0:", -- Solid Star of Elune
	[24035]="0:3:3:1:GemBlue::1:0:", -- Sparkling Star of Elune
	[24036]="0:3:3:1:GemRed::1:0:", -- Flashing Living Ruby
	[24037]="0:3:3:1:GemBlue::1:0:", -- Lustrous Star of Elune
	[24039]="0:3:3:1:GemBlue::1:0:", -- Stormy Star of Elune
	[24040]="0:12:1:1:::1:0:", -- Blood Mushroom
	[24041]="0:12:1:1:::1:0:", -- Aquatic Stinkhorn
	[24042]="0:12:1:1:::1:0:", -- Ruinous Polyspore
	[24043]="0:12:1:1:::1:0:", -- Fel Cone Fungus
	[24044]="0:2:3:1:Polearm::1:0:", -- Hellreaver
	[24045]="0:4:3:1:Ring::1:0:", -- Band of Renewal
	[24046]="0:4:3:1:Mail::1:0:", -- Kilt of Rolling Thunders
	[24047]="0:3:3:1:GemYellow::1:0:", -- Brilliant Dawnstone
	[24048]="0:3:3:1:GemYellow::1:0:", -- Smooth Dawnstone
	[24049]="0:12:1:2:::1:0:", -- Ysera's Tear
	[24050]="0:3:3:1:GemYellow::1:0:", -- Gleaming Dawnstone
	[24051]="0:3:3:1:GemYellow::1:0:", -- Rigid Dawnstone
	[24052]="0:3:3:1:GemYellow::1:0:", -- Thick Dawnstone
	[24053]="0:3:3:1:GemYellow::1:0:", -- Mystic Dawnstone
	[24054]="0:3:3:1:GemPurple::1:0:", -- Sovereign Nightseye
	[24055]="0:3:3:1:GemPurple::1:0:", -- Shifting Nightseye
	[24056]="0:3:3:1:GemPurple::1:0:", -- Glowing Nightseye
	[24057]="0:3:3:1:GemPurple::1:0:", -- Royal Nightseye
	[24058]="0:3:3:1:GemOrange::1:0:", -- Inscribed Noble Topaz
	[24059]="0:3:3:1:GemOrange::1:0:", -- Potent Noble Topaz
	[24060]="0:3:3:1:GemOrange::1:0:", -- Luminous Noble Topaz
	[24061]="0:3:3:1:GemOrange::1:0:", -- Glinting Noble Topaz
	[24062]="0:3:3:1:GemGreen::1:0:", -- Enduring Talasite
	[24063]="0:4:3:1:Leather::1:0:", -- Shifting Sash of Midnight
	[24064]="0:4:3:1:Plate::1:0:", -- Ironsole Clompers
	[24065]="0:3:3:1:GemGreen::1:0:", -- Dazzling Talasite
	[24066]="0:3:3:1:GemGreen::1:0:", -- Radiant Talasite
	[24067]="0:3:3:1:GemGreen::1:0:", -- Jagged Talasite
	[24069]="0:2:3:1:Stave::1:0:", -- Crystalfire Staff
	[24072]="0:0:1:20:FoodDrink::1:0:", -- Sand Pear Pie
	[24073]="0:4:3:1:Amulet::1:0:", -- Garrote-String Necklace
	[24074]="0:4:2:1:Ring::1:0:", -- Fel Iron Blood Ring
	[24075]="0:4:2:1:Ring::1:0:", -- Golden Draenite Ring
	[24076]="0:4:2:1:Ring::1:0:", -- Azure Moonstone Ring
	[24077]="0:4:2:1:Amulet::1:0:", -- Thick Adamantite Necklace
	[24078]="0:4:2:1:Ring::1:0:", -- Heavy Adamantite Ring
	[24079]="0:4:3:1:Ring::1:0:", -- Khorium Band of Shadows
	[24080]="0:4:3:1:Ring::1:0:", -- Khorium Band of Frost
	[24081]="0:12:1:5:::1:0:", -- Satyrnaar Fel Wood
	[24082]="0:4:3:1:Ring::1:0:", -- Khorium Inferno Band
	[24083]="0:4:3:1:Cloth::1:0:", -- Lifegiver Britches
	[24084]="0:15:1:1:Junk::1:0:", -- Draenei Banner
	[24085]="0:4:3:1:Ring::1:0:", -- Khorium Band of Leaves
	[24086]="0:4:3:1:Ring::1:0:", -- Arcane Khorium Band
	[24087]="0:4:3:1:Ring::1:0:", -- Heavy Felsteel Ring
	[24088]="0:4:3:1:Ring::1:0:", -- Delicate Eternium Ring
	[24089]="0:4:3:1:Ring::1:0:", -- Blazing Eternium Band
	[24090]="0:4:3:1:Mail::1:0:", -- Bloodstained Ravager Gauntlets
	[24091]="0:4:3:1:Plate::1:0:", -- Tenacious Defender
	[24092]="0:4:3:1:Amulet::1:0:", -- Pendant of Frozen Flame
	[24093]="0:4:3:1:Amulet::1:0:", -- Pendant of Thawing
	[24094]="0:2:3:1:TwoHandMace::1:0:", -- Heart Fire Warhammer
	[24095]="0:4:3:1:Amulet::1:0:", -- Pendant of Withering
	[24096]="0:4:3:1:Amulet::1:0:", -- Heartblood Prayer Beads
	[24097]="0:4:3:1:Amulet::1:0:", -- Pendant of Shadow's End
	[24098]="0:4:3:1:Amulet::1:0:", -- Pendant of the Null Rune
	[24099]="0:13:1:1:::1:0:", -- The High Chief's Key
	[24101]="0:9:3:1:Book::1:0:", -- Book of Ferocious Bite V
	[24102]="0:9:3:1:Book::1:0:", -- Manual of Eviscerate IX
	[24103]="0:4:1:1:Leather::1:0:", -- Moongraze Hide Boots
	[24104]="0:4:1:1:Cloak::1:0:", -- Moongraze Fur Cloak
	[24105]="0:0:1:20:FoodDrink::1:0:", -- Roasted Moongraze Tenderloin
	[24106]="0:4:3:1:Amulet::1:0:", -- Thick Felsteel Necklace
	[24107]="0:4:2:1:Mail::1:0:", -- Ravager Chitin Tunic
	[24108]="0:4:2:1:Leather::1:0:", -- Ravager Hide Leggings
	[24109]="0:4:2:1:Cloth::1:0:", -- Thick Ravager Belt
	[24110]="0:4:3:1:Amulet::1:0:", -- Living Ruby Pendant
	[24111]="0:4:2:1:Leather::1:0:", -- Kurken Hide Jerkin
	[24112]="0:4:2:1:Cloth::1:0:", -- Kurkenstoks
	[24113]="0:4:2:1:Cloth::1:0:", -- Cowlen's Bracers of Kinship
	[24114]="0:4:3:1:Amulet::1:0:", -- Braided Eternium Chain
	[24116]="0:4:3:1:Amulet::1:0:", -- Eye of the Night
	[24117]="0:4:3:1:Amulet::1:0:", -- Embrace of the Dawn
	[24118]="0:4:2:1:Ring::1:0:", -- Signet of Argas
	[24119]="0:4:2:1:Ring::1:0:", -- Band of Argas
	[24120]="0:4:2:1:Ring::1:0:", -- Seal of Argas
	[24121]="0:4:3:1:Amulet::1:0:", -- Chain of the Twilight Owl
	[24122]="0:4:4:1:Cloth::1:0:", -- Coronet of Verdant Flame
	[24123]="0:4:4:1:Cloth::1:0:", -- Circlet of Arcane Might
	[24124]="0:4:3:1:Trinket::1:0:", -- Figurine - Felsteel Boar
	[24125]="0:4:3:1:Trinket::1:0:", -- Figurine - Dawnstone Crab
	[24126]="0:4:3:1:Trinket::1:0:", -- Figurine - Living Ruby Serpent
	[24127]="0:4:3:1:Trinket::1:0:", -- Figurine - Talasite Owl
	[24128]="0:4:3:1:Trinket::1:0:", -- Figurine - Nightseye Panther
	[24129]="0:4:1:1:Leather::1:0:", -- Salvaged Leather Belt
	[24130]="0:4:1:1:Cloth::1:0:", -- Worn Slippers
	[24131]="0:4:1:1:Mail::1:0:", -- Slightly Rusted Bracers
	[24132]="0:12:1:1:::1:0:", -- A Letter from the Admiral
	[24133]="0:4:1:1:Mail::1:0:", -- Weathered Mail Tunic
	[24134]="0:4:1:1:Leather::1:0:", -- Weathered Leather Vest
	[24135]="0:4:1:1:Cloth::1:0:", -- Weathered Cloth Armor
	[24136]="0:2:2:1:Bow::1:0:", -- Farstrider's Bow
	[24138]="0:2:2:1:Crossbow::1:0:", -- Silver Crossbow
	[24139]="0:12:1:1:::1:0:", -- Faint Arcane Essence
	[24140]="0:0:0:1:Consumable::1:0:", -- Blackened Urn
	[24141]="0:4:1:1:Mail::1:0:", -- Battle Worn Gauntlets
	[24142]="0:4:1:1:Leather::1:0:", -- Battle Worn Gloves
	[24143]="0:4:0:1:Shirt::1:0:", -- Initiate's Shirt
	[24144]="0:4:1:1:Cloth::1:0:", -- Battle Worn Handguards
	[24145]="0:4:0:1:Cloth::1:0:", -- Initiate's Pants
	[24146]="0:4:0:1:Cloth::1:0:", -- Initiate's Boots
	[24150]="0:4:3:1:Cloak::1:0:", -- Mok'Nathal Wildercloak
	[24151]="0:4:3:1:Ring::1:0:", -- Mok'Nathal Clan Ring
	[24152]="0:12:1:10:::1:0:", -- Charred Bone Fragment
	[24153]="0:12:1:4:::1:0:", -- Bloodcursed Soul
	[24154]="0:4:3:1:Ring::1:0:", -- Witching Band
	[24155]="0:2:3:1:Stave::1:0:", -- Ursol's Claw
	[24156]="0:12:1:1:::1:0:", -- Filled Shimmering Vessel
	[24157]="0:12:1:1:::1:0:", -- Shimmering Vessel
	[24158]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Khorium Band of Shadows
	[24159]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Khorium Band of Frost
	[24160]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Khorium Inferno Band
	[24161]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Khorium Band of Leaves
	[24162]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Arcane Khorium Band
	[24163]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Heavy Felsteel Ring
	[24164]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Delicate Eternium Ring
	[24165]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Blazing Eternium Band
	[24166]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Thick Felsteel Necklace
	[24167]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Living Ruby Pendant
	[24168]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Braided Eternium Chain
	[24169]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Eye of the Night
	[24170]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Embrace of the Dawn
	[24171]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Chain of the Twilight Owl
	[24172]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Coronet of Verdant Flame
	[24173]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Circlet of Arcane Might
	[24174]="120000:9:3:1:Jewelcrafting::1:0:21643", -- Design: Pendant of Frozen Flame
	[24175]="120000:9:3:1:Jewelcrafting::1:0:21655", -- Design: Pendant of Thawing
	[24176]="120000:9:3:1:Jewelcrafting::1:0:19331", -- Design: Pendant of Withering
	[24177]="120000:9:3:1:Jewelcrafting::1:0:19321", -- Design: Pendant of Shadow's End
	[24178]="120000:9:3:1:Jewelcrafting::1:0:20242,23007", -- Design: Pendant of the Null Rune
	[24179]="120000:9:3:1:Jewelcrafting::1:0:21655", -- Design: Felsteel Boar
	[24180]="120000:9:3:1:Jewelcrafting::1:0:17657", -- Design: Dawnstone Crab
	[24181]="120000:9:3:1:Jewelcrafting::1:0:21643", -- Design: Living Ruby Serpent
	[24182]="120000:9:3:1:Jewelcrafting::1:0:21432", -- Design: Talasite Owl
	[24183]="120000:9:3:1:Jewelcrafting::1:0:17904", -- Design: Nightseye Panther
	[24184]="0:12:1:1:::1:0:", -- Filled Shimmering Vessel
	[24185]="0:12:1:10:::1:0:", -- Dragon Bone
	[24186]="0:15:0:20:Junk::1:0:", -- Copper Powder
	[24188]="0:15:0:20:Junk::1:0:", -- Tin Powder
	[24189]="0:15:0:20:Junk::1:0:", -- Crystalline Fragments
	[24190]="0:15:0:20:Junk::1:0:", -- Iron Powder
	[24192]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Bright Living Ruby
	[24193]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Bold Living Ruby
	[24194]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Delicate Living Ruby
	[24195]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Teardrop Living Ruby
	[24196]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Runed Living Ruby
	[24197]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Subtle Living Ruby
	[24198]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Flashing Living Ruby
	[24199]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Solid Star of Elune
	[24200]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Sparkling Star of Elune
	[24201]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Lustrous Star of Elune
	[24202]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Stormy Star of Elune
	[24203]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Brilliant Dawnstone
	[24204]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Smooth Dawnstone
	[24205]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Rigid Dawnstone
	[24206]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Gleaming Dawnstone
	[24207]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Thick Dawnstone
	[24208]="120000:9:3:1:Jewelcrafting::1:1:21474,21485", -- Design: Mystic Dawnstone
	[24209]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Sovereign Nightseye
	[24210]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Shifting Nightseye
	[24211]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Glowing Nightseye
	[24212]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Royal Nightseye
	[24213]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Inscribed Noble Topaz
	[24214]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Potent Noble Topaz
	[24215]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Luminous Noble Topaz
	[24216]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Glinting Noble Topaz
	[24217]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Enduring Talasite
	[24218]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Radiant Talasite
	[24219]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Dazzling Talasite
	[24220]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Jagged Talasite
	[24221]="0:12:1:1:::1:0:", -- Bundle of Dragon Bones
	[24222]="0:2:3:1:Dagger::1:0:", -- The Shadowfoot Stabber
	[24223]="0:15:0:1:Junk::1:0:", -- Bloodvalor's Notes
	[24224]="0:12:1:1:::1:0:", -- Crate of Bloodforged Ingots
	[24225]="0:12:1:1:::1:0:", -- Blood of the Wrathful
	[24226]="0:12:1:1:::1:0:", -- Blood Knight Insignia
	[24230]="0:12:1:1:::1:0:", -- Velen's Orders
	[24231]="0:15:0:20:Junk::1:0:", -- Coarse Snuff
	[24232]="0:15:0:20:Junk::1:0:", -- Shabby Knot
	[24233]="0:12:1:20:::1:0:", -- Discarded Nutriment
	[24234]="0:15:0:20:Junk::1:0:", -- Mithril Powder
	[24235]="0:15:0:20:Junk::1:0:", -- Thorium Powder
	[24236]="0:12:1:12:::1:0:", -- Medical Supplies
	[24237]="0:12:1:1:::1:0:", -- Galaen's Journal
	[24238]="0:12:1:20:::1:0:", -- Mushroom Sample
	[24239]="0:12:1:1:::1:0:", -- Crate of Materials
	[24240]="0:12:1:10:::1:0:", -- Box of Mushrooms
	[24241]="0:4:1:1:Mail::1:0:", -- Green Chain Belt
	[24242]="0:15:0:20:Junk::1:0:", -- Fel Iron Powder
	[24243]="0:7:1:20:Jewelcrafting:755:1:0:", -- Adamantite Powder
	[24245]="0:12:1:100:::1:0:", -- Glowcap
	[24246]="0:12:1:200:::1:0:", -- Sanguine Hibiscus
	[24247]="0:12:1:1:::1:0:", -- Underspore Frond
	[24248]="0:12:1:1:::1:0:", -- Brain of the Black Stalker
	[24249]="0:4:3:1:Cloth::1:0:", -- Unyielding Bracers
	[24250]="0:4:3:1:Cloth::1:0:", -- Bracers of Havok
	[24251]="0:4:3:1:Cloth::1:0:", -- Blackstrike Bracers
	[24252]="0:4:3:1:Cloak::1:0:", -- Cloak of the Black Void
	[24253]="0:4:3:1:Cloak::1:0:", -- Cloak of Eternity
	[24254]="0:4:3:1:Cloak::1:0:", -- White Remedy Cape
	[24255]="0:4:4:1:Cloth::1:0:", -- Unyielding Girdle
	[24256]="0:4:4:1:Cloth::1:0:", -- Girdle of Ruination
	[24257]="0:4:4:1:Cloth::1:0:", -- Black Belt of Knowledge
	[24258]="0:4:4:1:Cloak::1:0:", -- Resolute Cape
	[24259]="0:4:4:1:Cloak::1:0:", -- Vengeance Wrap
	[24260]="0:4:4:1:Cloak::1:0:", -- Manaweave Cloak
	[24261]="0:4:4:1:Cloth::1:0:", -- Whitemend Pants
	[24262]="0:4:4:1:Cloth::1:0:", -- Spellstrike Pants
	[24263]="0:4:4:1:Cloth::1:0:", -- Battlecast Pants
	[24264]="0:4:4:1:Cloth::1:0:", -- Whitemend Hood
	[24266]="0:4:4:1:Cloth::1:0:", -- Spellstrike Hood
	[24267]="0:4:4:1:Cloth::1:0:", -- Battlecast Hood
	[24268]="0:0:1:20:Other::1:0:", -- Netherweave Net
	[24270]="0:1:2:1:GemBag::1:0:", -- Bag of Jewels
	[24271]="0:7:3:20:Cloth:202,197:1:0:", -- Spellcloth
	[24272]="0:7:3:20:Cloth:202,197:1:0:", -- Shadowcloth
	[24273]="0:0:3:20:EnhPerm::1:0:", -- Mystic Spellthread
	[24274]="0:0:4:20:EnhPerm::1:0:", -- Runic Spellthread
	[24275]="0:0:3:20:EnhPerm::1:0:", -- Silver Spellthread
	[24276]="0:0:4:20:EnhPerm::1:0:", -- Golden Spellthread
	[24277]="0:15:0:1:Junk::1:0:", -- Items for Magister Astalor Bloodsworn
	[24278]="0:15:1:1:CombatPet::1:0:", -- Flare Gun
	[24279]="0:12:1:10:::1:0:", -- Vicious Teromoth Sample
	[24280]="0:12:1:200:::1:0:", -- Naga Claws
	[24281]="0:15:0:5:Junk::1:0:", -- Carved Ivory Bone
	[24282]="0:15:0:5:Junk::1:0:", -- Rogue's Diary
	[24283]="0:15:0:1:Junk::1:0:", -- An Antique Gun
	[24284]="0:12:1:1:::1:0:", -- Tyr's Hand Holy Water
	[24285]="1500000:12:1:1:::1:0:16683", -- Crepuscular Powder
	[24286]="500000:12:1:1:::1:0:16611", -- Arcane Catalyst
	[24287]="0:15:1:1:Junk::1:0:", -- Extinguishing Mixture
	[24289]="0:15:1:1:CombatPet::1:0:", -- Chrono-beacon
	[24290]="0:12:1:200:::1:0:", -- Mature Spore Sac
	[24291]="0:12:1:200:::1:0:", -- Bog Lord Tendril
	[24292]="60000:9:1:1:Tailoring::1:0:19331", -- Pattern: Mystic Spellthread
	[24293]="60000:9:1:1:Tailoring::1:0:19321", -- Pattern: Silver Spellthread
	[24294]="360000:9:1:1:Tailoring::1:0:19331", -- Pattern: Runic Spellthread
	[24295]="360000:9:1:1:Tailoring::1:0:19321", -- Pattern: Golden Spellthread
	[24296]="0:9:3:1:Tailoring::1:0:", -- Pattern: Unyielding Bracers
	[24297]="0:9:3:1:Tailoring::1:0:", -- Pattern: Bracers of Havok
	[24298]="0:9:3:1:Tailoring::1:0:", -- Pattern: Blackstrike Bracers
	[24299]="0:9:3:1:Tailoring::1:0:", -- Pattern: Cloak of the Black Void
	[24300]="0:9:3:1:Tailoring::1:0:", -- Pattern: Cloak of Eternity
	[24301]="0:9:3:1:Tailoring::1:0:", -- Pattern: White Remedy Cape
	[24302]="0:9:4:1:Tailoring::1:0:", -- Pattern: Unyielding Girdle
	[24303]="0:9:4:1:Tailoring::1:0:", -- Pattern: Girdle of Ruination
	[24304]="0:9:4:1:Tailoring::1:0:", -- Pattern: Black Belt of Knowledge
	[24305]="0:9:4:1:Tailoring::1:0:", -- Pattern: Resolute Cape
	[24306]="0:9:4:1:Tailoring::1:0:", -- Pattern: Vengeance Wrap
	[24307]="0:9:4:1:Tailoring::1:0:", -- Pattern: Manaweave Cloak
	[24308]="0:9:4:1:Tailoring::1:0:", -- Pattern: Whitemend Pants
	[24309]="0:9:4:1:Tailoring::1:0:", -- Pattern: Spellstrike Pants
	[24310]="0:9:4:1:Tailoring::1:0:", -- Pattern: Battlecast Pants
	[24311]="0:9:4:1:Tailoring::1:0:", -- Pattern: Whitemend Hood
	[24312]="0:9:4:1:Tailoring::1:0:", -- Pattern: Spellstrike Hood
	[24313]="0:9:4:1:Tailoring::1:0:", -- Pattern: Battlecast Hood
	[24314]="40000:9:1:1:Tailoring::1:0:20242,23007", -- Pattern: Bag of Jewels
	[24316]="40000:9:1:1:Tailoring::1:0:22213,29511", -- Pattern: Spellcloth
	[24317]="0:12:1:1:::1:0:", -- Bloodmyst Water Sample
	[24318]="0:12:1:1:::1:0:", -- Water Sample Flask
	[24323]="0:12:1:1:::1:0:", -- Translated Sunhawk Missive
	[24330]="0:0:1:1:Consumable::1:0:", -- Drain Schematics
	[24334]="0:4:2:1:Shield::1:0:", -- Wheel of the Lost Hope
	[24335]="0:15:1:1:Junk::1:0:", -- Orb of Returning
	[24336]="0:15:1:1:Junk::1:0:", -- Fireproof Satchel
	[24337]="0:12:1:1:::1:0:", -- Deactivating Jewel
	[24338]="0:0:1:20:FoodDrink::1:0:", -- Hellfire Spineleaf
	[24339]="0:2:2:1:OneHandSword::1:0:", -- Stung
	[24340]="0:4:2:1:Cloth::1:0:", -- Vandril's Hand Me Down Pants
	[24341]="0:4:2:1:Mail::1:0:", -- Fortified Oven Mitts
	[24342]="0:2:2:1:Wand::1:0:", -- Stillpine Shocker
	[24343]="0:2:2:1:OneHandMace::1:0:", -- The Thumper
	[24344]="0:4:1:1:Tabard::1:0:", -- Tabard of the Hand
	[24345]="0:9:3:1:Book::1:0:", -- Book of Cower IV
	[24346]="0:4:2:1:Cloth::1:0:", -- Robe of the Dragon Slayer
	[24347]="0:4:2:1:Leather::1:0:", -- Vest of the Dragon Slayer
	[24348]="0:4:2:1:Mail::1:0:", -- Tunic of the Dragon Slayer
	[24349]="0:4:2:1:Ring::1:0:", -- Signet Ring of the Hand
	[24350]="0:4:2:1:Ring::1:0:", -- Signet Ring of the Hand
	[24351]="0:2:2:1:OneHandMace::1:0:", -- Mace of the Hand
	[24352]="0:2:2:1:TwoHandSword::1:0:", -- Blade of the Hand
	[24353]="0:2:2:1:Crossbow::1:0:", -- Crossbow of the Hand
	[24354]="0:2:2:1:Stave::1:0:", -- Staff of the Hand
	[24355]="0:0:1:1:Consumable::1:0:", -- Ironvine Seeds
	[24356]="0:2:3:1:Dagger::1:0:", -- Wastewalker Shiv
	[24357]="0:4:3:1:Mail::1:0:", -- Vest of Living Lightning
	[24359]="0:4:3:1:Cloth::1:0:", -- Princely Reign Leggings
	[24360]="0:4:3:1:Mail::1:0:", -- Tracker's Belt
	[24361]="0:2:3:1:OneHandSword::1:0:", -- Spellfire Longsword
	[24362]="0:4:3:1:Cloak::1:0:", -- Spore-Soaked Vaneer
	[24363]="0:4:3:1:Plate::1:0:", -- Unscarred Breastplate
	[24364]="0:4:3:1:Plate::1:0:", -- Azureplate Greaves
	[24365]="0:4:3:1:Leather::1:0:", -- Deft Handguards
	[24366]="0:4:3:1:Mail::1:0:", -- Scorpid-Sting Mantle
	[24367]="0:12:1:1:::1:0:", -- Orders from Lady Vashj
	[24368]="0:12:1:200:::1:0:", -- Coilfang Armaments
	[24372]="0:12:1:10:::1:0:", -- Diaphanous Wing
	[24373]="0:12:1:1:::1:0:", -- Scout Jyoba's Report
	[24374]="0:12:1:10:::1:0:", -- Eel Filet
	[24375]="0:12:1:20:::1:0:", -- Thick Hydra Scale
	[24376]="0:4:3:1:Trinket::1:0:", -- Runed Fungalcap
	[24378]="0:2:3:1:OneHandMace::1:0:", -- Coilfang Hammer of Renewal
	[24379]="0:4:3:1:Cloak::1:0:", -- Bogstrok Scale Cloak
	[24380]="0:2:3:1:Wand::1:0:", -- Calming Spore Reed
	[24381]="0:2:3:1:Crossbow::1:0:", -- Coilfang Needler
	[24382]="0:12:1:1:::1:0:", -- Zurai's Report
	[24383]="0:12:1:10:::1:0:", -- Fulgor Spore
	[24384]="0:2:3:1:OneHandMace::1:0:", -- Diamond-Core Sledgemace
	[24385]="0:4:3:1:Amulet::1:0:", -- Pendant of Battle-Lust
	[24386]="0:4:3:1:Libram::1:0:", -- Libram of Saints Departed
	[24387]="0:4:3:1:Plate::1:0:", -- Ironblade Gauntlets
	[24388]="0:4:3:1:Mail::1:0:", -- Girdle of the Gale Storm
	[24389]="0:2:3:1:Gun::1:0:", -- Legion Blunderbuss
	[24390]="0:4:3:1:Trinket::1:0:", -- Auslese's Light Channeler
	[24391]="0:4:3:1:Leather::1:0:", -- Kilt of the Night Strider
	[24392]="0:4:3:1:Cloth::1:0:", -- Arcing Bracers
	[24393]="0:4:3:1:Cloth::1:0:", -- Bloody Surgeon's Mitts
	[24394]="0:2:3:1:TwoHandAxe::1:0:", -- Warsong Howling Axe
	[24395]="0:4:3:1:Cloth::1:0:", -- Mindfire Waistband
	[24396]="0:4:3:1:Leather::1:0:", -- Vest of Vengeance
	[24397]="0:4:3:1:Cloth::1:0:", -- Raiments of Divine Authority
	[24398]="0:4:3:1:Leather::1:0:", -- Mantle of the Dusk-Dweller
	[24399]="0:15:1:1:Junk::1:0:", -- Sunhawk Missive
	[24400]="0:12:1:1:::1:0:", -- Dead Mire Soil Sample
	[24401]="0:12:1:200:::1:0:", -- Unidentified Plant Parts
	[24402]="0:15:1:1:Junk::1:0:", -- Package of Identified Plants
	[24403]="0:12:0:100:::1:0:", -- Common Fern
	[24404]="0:15:0:100:Junk::1:0:", -- Ruined Specimen
	[24405]="0:12:0:100:::1:0:", -- Common Azerothian Species
	[24406]="0:12:0:100:::1:0:", -- Common Flower
	[24407]="0:0:1:1:Consumable::1:0:", -- Uncatalogued Species
	[24408]="0:0:1:20:Consumable::1:0:", -- Edible Stalks
	[24411]="0:12:1:1:::1:0:", -- Ikeyen's Belongings
	[24413]="0:4:3:1:Totem::1:0:", -- Totem of the Thunderhead
	[24414]="0:12:1:1:::1:0:", -- Blood Elf Plans
	[24415]="0:12:1:1:::1:0:", -- Vindicator Idaar's Letter
	[24416]="0:12:1:10:::1:0:", -- Corrupted Flower
	[24417]="2000:6:2:1000:Arrow::200:0:17904", -- Scout's Arrow
	[24419]="0:12:1:15:::1:0:", -- Digested Caracoli
	[24421]="0:0:1:20:Consumable::1:0:", -- Nagrand Cherry
	[24422]="0:12:1:10:::1:0:", -- Feralfen Idol
	[24423]="0:4:1:1:Mail::1:0:", -- Beaten Chain Leggings
	[24424]="0:4:1:1:Leather::1:0:", -- Rough Leather Leggings
	[24425]="0:4:1:1:Cloth::1:0:", -- Hand Sewn Pants
	[24426]="0:12:1:4:::1:0:", -- Sporebat Eye
	[24427]="0:12:1:4:::1:0:", -- Fen Strider Tentacle
	[24428]="0:12:1:1:::1:0:", -- Ahuurn's Elixir
	[24429]="8000:0:1:1:Consumable::1:0:17904", -- Expedition Flare
	[24430]="0:2:1:1:TwoHandSword::1:0:", -- Seafarer's Blade
	[24431]="0:2:1:1:OneHandMace::1:0:", -- McWeaksauce's Meat Tenderizer
	[24432]="0:2:1:1:TwoHandMace::1:0:", -- The Shell Cracker
	[24433]="0:2:1:1:Crossbow::1:0:", -- Crossbow of the Albatross
	[24434]="0:2:1:1:Stave::1:0:", -- The Discipline Stick
	[24435]="0:4:1:1:Mail::1:0:", -- Reinforced Mail Boots
	[24436]="0:4:1:1:Leather::1:0:", -- Huntsman's Bracers
	[24437]="0:4:1:1:Cloth::1:0:", -- Slightly Worn Bracer
	[24438]="0:4:2:1:Cloth::1:0:", -- Fur Covered Robe
	[24439]="0:4:2:1:Leather::1:0:", -- Savage Leggings
	[24440]="0:4:2:1:Mail::1:0:", -- Heavy Chain Leggings
	[24441]="0:2:1:1:Crossbow::1:0:", -- Exodar Crossbow
	[24445]="0:4:1:1:Mail::1:0:", -- Fortified Wristguards
	[24446]="0:4:1:1:Leather::1:0:", -- Sturdy Leather Belt
	[24447]="0:4:1:1:Mail::1:0:", -- Naga Scale Boots
	[24448]="0:2:1:1:OneHandSword::1:0:", -- Battle Tested Blade
	[24449]="0:12:1:200:::1:0:", -- Fertile Spores
	[24450]="0:4:3:1:Cloth::1:0:", -- Manaspark Gloves
	[24451]="0:4:3:1:Mail::1:0:", -- Lykul Bloodbands
	[24452]="0:4:3:1:Leather::1:0:", -- Starlight Gauntlets
	[24453]="0:2:3:1:Dagger::1:0:", -- Zangartooth Shortblade
	[24454]="0:4:3:1:Cloak::1:0:", -- Cloak of Enduring Swiftness
	[24455]="0:4:3:1:Leather::1:0:", -- Tunic of the Nightwatcher
	[24456]="0:4:3:1:Plate::1:0:", -- Greaves of the Iron Guardian
	[24457]="0:4:3:1:Plate::1:0:", -- Truth Bearer Shoulderguards
	[24458]="0:4:3:1:Plate::1:0:", -- Studded Girdle of Virtue
	[24459]="0:4:3:1:Cloak::1:0:", -- Cloak of Healing Rays
	[24460]="0:4:3:1:Amulet::1:0:", -- Talisman of Tenacity
	[24461]="0:2:3:1:TwoHandMace::1:0:", -- Hatebringer
	[24462]="0:4:3:1:Amulet::1:0:", -- Luminous Pearls of Insight
	[24463]="0:4:3:1:Plate::1:0:", -- Pauldrons of Brute Force
	[24464]="0:2:3:1:Dagger::1:0:", -- The Stalker's Fangs
	[24465]="0:4:3:1:Mail::1:0:", -- Shamblehide Chestguard
	[24466]="0:4:3:1:Leather::1:0:", -- Skulldugger's Leggings
	[24467]="0:15:1:1:Junk::1:0:", -- Living Fire
	[24468]="0:12:1:8:::1:0:", -- Burstcap Mushroom
	[24469]="0:12:1:10:::1:0:", -- Muck-ridden Core
	[24470]="0:12:1:1:::1:0:", -- Murloc Cage
	[24471]="0:12:1:1:::1:0:", -- Ango'rosh Attack Plans
	[24472]="0:12:1:1:::1:0:", -- Boss Grog'ak's Head
	[24473]="0:12:1:15:::1:0:", -- Enraged Crusher Core
	[24474]="0:0:1:1:Consumable::1:0:", -- Violet Scrying Crystal
	[24475]="0:15:0:1:Junk::1:0:", -- Gordawg's Imprint
	[24476]="0:7:1:20:Other::1:0:", -- Jaggal Clam
	[24477]="0:7:1:20:Meat:185:1:0:", -- Jaggal Clam Meat
	[24478]="0:3:2:20:GemSimple:755:1:0:", -- Jaggal Pearl
	[24479]="0:3:2:20:GemSimple:755:1:0:", -- Shadow Pearl
	[24480]="0:12:1:20:::1:0:", -- Ghostly Essence
	[24481]="0:4:3:1:Cloth::1:0:", -- Robes of the Augurer
	[24482]="0:12:1:1:::1:0:", -- Alturus's Report
	[24483]="0:12:1:1:::1:0:", -- Withered Basidium
	[24484]="0:12:1:1:::1:0:", -- Withered Basidium
	[24485]="0:12:1:6:::1:0:", -- Marshlight Bleeder Venom
	[24486]="0:12:1:10:::1:0:", -- Fenclaw Hide
	[24487]="0:12:1:1:::1:0:", -- Second Key Fragment
	[24488]="0:12:1:1:::1:0:", -- Third Key Fragment
	[24489]="0:13:1:1:::1:0:", -- Restored Apprentice's Key
	[24490]="0:13:1:1:::1:0:", -- The Master's Key
	[24492]="0:12:1:1:::1:0:", -- Keanna's Log
	[24493]="0:12:1:10:::1:0:", -- Marshfang Slicer Blade
	[24494]="0:0:1:1:Consumable::1:0:", -- Tears of the Goddess
	[24496]="0:12:1:1:::1:0:", -- Horn of Banthar
	[24497]="0:12:1:5:::1:0:", -- Feralfen Protection Totem
	[24498]="0:12:1:1:::1:0:", -- Feralfen Totem
	[24499]="0:12:1:1:::1:0:", -- Daggerfen Poison Manual
	[24500]="0:12:1:1:::1:0:", -- Daggerfen Poison Vial
	[24501]="0:15:1:1:Junk::1:0:", -- Gordawg's Boulder
	[24502]="0:15:1:7:Junk::1:0:", -- Warmaul Skull
	[24503]="0:12:1:1:::1:0:", -- Gurok's Earthen Head
	[24504]="0:15:1:1:Junk::1:0:", -- Howling Wind
	[24505]="0:12:1:1:::1:0:", -- Heart of Tusker
	[24507]="0:15:0:20:Junk::1:0:", -- Elemental Shard
	[24508]="0:15:0:20:Junk::1:0:", -- Elemental Fragment
	[24510]="0:15:0:20:Junk::1:0:", -- Primordial Core
	[24511]="0:15:0:20:Junk::1:0:", -- Primordial Essence
	[24513]="0:12:1:1:::1:0:", -- Eye of Gutripper
	[24514]="0:12:1:1:::1:0:", -- First Key Fragment
	[24516]="0:15:0:10:Junk::1:0:", -- Damaged Rock Flayer Talon
	[24517]="0:15:0:10:Junk::1:0:", -- Blood Soaked Tail
	[24519]="0:15:0:10:Junk::1:0:", -- Twisted Rock Flayer Talon
	[24520]="0:0:1:20:Consumable::1:0:18266", -- Honor Hold Favor
	[24521]="0:15:0:10:Junk::1:0:", -- Mangled Tail
	[24522]="0:0:1:20:Consumable::1:0:18267", -- Thrallmar Favor
	[24523]="0:12:1:1:::1:0:", -- Hoof of Bach'lor
	[24538]="0:0:1:10:Other::1:0:", -- Fire Bomb
	[24539]="0:0:1:20:FoodDrink::5:0:18382", -- Marsh Lichen
	[24540]="0:0:1:20:Consumable::1:0:", -- Edible Fern
	[24542]="0:12:1:20:::1:0:", -- Murkblood Idol
	[24543]="0:12:1:1:::1:0:", -- Head of Ortor of Murkblood
	[24544]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Plate Chestpiece
	[24545]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Plate Helm
	[24546]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Plate Shoulders
	[24547]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Plate Legguards
	[24549]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Plate Gauntlets
	[24550]="0:2:4:1:TwoHandSword::1:0:", -- Gladiator's Greatsword
	[24551]="0:4:4:1:Trinket::1:0:", -- Talisman of the Horde
	[24552]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Dreadweave Robe
	[24553]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Dreadweave Hood
	[24554]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Dreadweave Mantle
	[24555]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Dreadweave Leggings
	[24556]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Dreadweave Gloves
	[24557]="0:2:4:1:Stave::1:0:", -- Gladiator's War Staff
	[24558]="0:15:1:1:Junk::1:0:", -- Murkblood Invasion Plans
	[24559]="0:15:1:1:Junk::1:0:", -- Murkblood Invasion Plans
	[24560]="0:12:1:1:::1:0:", -- Torch of Liquid Fire
	[24573]="0:12:1:1:::1:0:", -- Elder Kuruti's Response
	[24575]="0:4:2:1:Cloth::1:0:", -- Outlander's Girdle
	[24576]="0:4:0:1:Cloth::1:0:", -- Loosely Threaded Belt
	[24577]="0:4:0:1:Cloth::1:0:", -- Loosely Threaded Boots
	[24578]="0:4:0:1:Cloth::1:0:", -- Loosely Threaded Bracers
	[24579]="0:0:1:250:Consumable::1:0:", -- Mark of Honor Hold
	[24580]="0:4:0:1:Cloth::1:0:", -- Loosely Threaded Hat
	[24581]="0:0:1:250:Consumable::1:0:", -- Mark of Thrallmar
	[24582]="0:4:2:1:Cloth::1:0:", -- Outlander's Boots
	[24583]="0:4:2:1:Cloth::1:0:", -- Outlander's Tunic
	[24584]="0:4:2:1:Cloth::1:0:", -- Outlander's Gloves
	[24585]="0:4:2:1:Cloth::1:0:", -- Outlander's Facewrap
	[24586]="0:4:2:1:Cloth::1:0:", -- Outlander's Leggings
	[24587]="0:4:2:1:Cloth::1:0:", -- Outlander's Pauldrons
	[24588]="0:4:2:1:Cloth::1:0:", -- Outlander's Bracers
	[24589]="0:4:2:1:Cloth::1:0:", -- Fireheart Girdle
	[24590]="0:4:2:1:Cloth::1:0:", -- Fireheart Boots
	[24591]="0:4:2:1:Cloth::1:0:", -- Fireheart Chestpiece
	[24592]="0:4:2:1:Cloth::1:0:", -- Fireheart Gloves
	[24593]="0:4:2:1:Cloth::1:0:", -- Fireheart Skullcap
	[24594]="0:4:2:1:Cloth::1:0:", -- Fireheart Leggings
	[24595]="0:4:2:1:Cloth::1:0:", -- Fireheart Shoulderpads
	[24596]="0:4:2:1:Cloth::1:0:", -- Fireheart Bracers
	[24597]="0:4:2:1:Cloth::1:0:", -- Starfire Sash
	[24598]="0:4:2:1:Cloth::1:0:", -- Starfire Sandals
	[24599]="0:4:2:1:Cloth::1:0:", -- Starfire Vest
	[24600]="0:4:2:1:Cloth::1:0:", -- Starfire Gloves
	[24601]="0:4:2:1:Cloth::1:0:", -- Starfire Circlet
	[24602]="0:4:2:1:Cloth::1:0:", -- Starfire Trousers
	[24603]="0:4:2:1:Cloth::1:0:", -- Starfire Mantle
	[24604]="0:4:2:1:Cloth::1:0:", -- Starfire Wristwraps
	[24605]="0:4:2:1:Cloth::1:0:", -- Laughing Skull Waistguard
	[24606]="0:4:2:1:Cloth::1:0:", -- Laughing Skull Boot
	[24607]="0:4:2:1:Cloth::1:0:", -- Laughing Skull Tunic
	[24608]="0:4:2:1:Cloth::1:0:", -- Laughing Skull Gloves
	[24609]="0:4:2:1:Cloth::1:0:", -- Laughing Skull Cap
	[24610]="0:4:2:1:Cloth::1:0:", -- Laughing Skull Pants
	[24611]="0:4:2:1:Cloth::1:0:", -- Laughing Skull Shoulderpads
	[24612]="0:4:2:1:Cloth::1:0:", -- Laughing Skull Bracelets
	[24613]="0:4:2:1:Cloth::1:0:", -- Vindicator Belt
	[24614]="0:4:2:1:Cloth::1:0:", -- Vindicator Boots
	[24615]="0:4:2:1:Cloth::1:0:", -- Vindicator Tunic
	[24616]="0:4:2:1:Cloth::1:0:", -- Vindicator Gloves
	[24617]="0:4:2:1:Cloth::1:0:", -- Vindicator Cap
	[24618]="0:4:2:1:Cloth::1:0:", -- Vindicator Pants
	[24619]="0:4:2:1:Cloth::1:0:", -- Vindicator Shoulderpads
	[24620]="0:4:2:1:Cloth::1:0:", -- Vindicator Bracers
	[24621]="0:4:2:1:Cloth::1:0:", -- Slavehandler Belt
	[24622]="0:4:2:1:Cloth::1:0:", -- Slavehandler Footpads
	[24623]="0:4:2:1:Cloth::1:0:", -- Slavehandler Jerkin
	[24624]="0:4:2:1:Cloth::1:0:", -- Slavehandler Handwraps
	[24625]="0:4:2:1:Cloth::1:0:", -- Slavehandler Cap
	[24626]="0:4:2:1:Cloth::1:0:", -- Slavehandler Pants
	[24627]="0:4:2:1:Cloth::1:0:", -- Slavehandler Amice
	[24628]="0:4:2:1:Cloth::1:0:", -- Slavehandler Wristguards
	[24629]="0:4:2:1:Cloth::1:0:", -- Feralfen Sash
	[24630]="0:4:2:1:Cloth::1:0:", -- Feralfen Sandals
	[24631]="0:4:2:1:Cloth::1:0:", -- Feralfen Jerkin
	[24632]="0:4:2:1:Cloth::1:0:", -- Feralfen Hand
	[24633]="0:4:2:1:Cloth::1:0:", -- Feralfen Hood
	[24634]="0:4:2:1:Cloth::1:0:", -- Feralfen Pants
	[24635]="0:4:2:1:Cloth::1:0:", -- Feralfen Amice
	[24636]="0:4:2:1:Cloth::1:0:", -- Feralfen Cuffs
	[24637]="0:4:2:1:Cloth::1:0:", -- Mistyreed Belt
	[24638]="0:4:2:1:Cloth::1:0:", -- Mistyreed Boots
	[24639]="0:4:2:1:Cloth::1:0:", -- Mistyreed Tunic
	[24640]="0:4:2:1:Cloth::1:0:", -- Mistyreed Gloves
	[24641]="0:4:2:1:Cloth::1:0:", -- Mistyreed Hood
	[24642]="0:4:2:1:Cloth::1:0:", -- Mistyreed Pants
	[24643]="0:4:2:1:Cloth::1:0:", -- Mistyreed Shoulderpads
	[24644]="0:4:2:1:Cloth::1:0:", -- Mistyreed Bracers
	[24645]="0:4:2:1:Cloth::1:0:", -- Astralaan Belt
	[24646]="0:4:2:1:Cloth::1:0:", -- Astralaan Boots
	[24647]="0:4:2:1:Cloth::1:0:", -- Astralaan Robe
	[24648]="0:4:2:1:Cloth::1:0:", -- Astralaan Gloves
	[24649]="0:4:2:1:Cloth::1:0:", -- Astralaan Headdress
	[24650]="0:4:2:1:Cloth::1:0:", -- Astralaan Pants
	[24651]="0:4:2:1:Cloth::1:0:", -- Astralaan Shoulderpads
	[24652]="0:4:2:1:Cloth::1:0:", -- Astralaan Bracer
	[24653]="0:4:2:1:Cloth::1:0:", -- Consortium Sash
	[24654]="0:4:2:1:Cloth::1:0:", -- Consortium Boot
	[24655]="0:4:2:1:Cloth::1:0:", -- Consortium Robe
	[24656]="0:4:2:1:Cloth::1:0:", -- Consortium Gloves
	[24657]="0:4:2:1:Cloth::1:0:", -- Consortium Hood
	[24658]="0:4:2:1:Cloth::1:0:", -- Consortium Pants
	[24659]="0:4:2:1:Cloth::1:0:", -- Consortium Mantle
	[24660]="0:4:2:1:Cloth::1:0:", -- Consortium Bracer
	[24661]="0:4:2:1:Cloth::1:0:", -- Shadow Council Chain
	[24662]="0:4:2:1:Cloth::1:0:", -- Shadow Council Boots
	[24663]="0:4:2:1:Cloth::1:0:", -- Shadow Council Tunic
	[24664]="0:4:2:1:Cloth::1:0:", -- Shadow Council Gloves
	[24665]="0:4:2:1:Cloth::1:0:", -- Shadow Council Cowl
	[24666]="0:4:2:1:Cloth::1:0:", -- Shadow Council Pants
	[24667]="0:4:2:1:Cloth::1:0:", -- Shadow Council Mantle
	[24668]="0:4:2:1:Cloth::1:0:", -- Shadow Council Bracer
	[24669]="0:4:2:1:Cloth::1:0:", -- Eldr'naan Belt
	[24670]="0:4:2:1:Cloth::1:0:", -- Eldr'naan Boots
	[24671]="0:4:2:1:Cloth::1:0:", -- Eldr'naan Jerkin
	[24672]="0:4:2:1:Cloth::1:0:", -- Eldr'naan Gloves
	[24673]="0:4:2:1:Cloth::1:0:", -- Eldr'naan Hood
	[24674]="0:4:2:1:Cloth::1:0:", -- Eldr'naan Pants
	[24675]="0:4:2:1:Cloth::1:0:", -- Eldr'naan Shoulderpads
	[24676]="0:4:2:1:Cloth::1:0:", -- Eldr'naan Bracelets
	[24677]="0:4:2:1:Cloth::1:0:", -- Archmage Belt
	[24678]="0:4:2:1:Cloth::1:0:", -- Archmage Slippers
	[24679]="0:4:2:1:Cloth::1:0:", -- Archmage Robe
	[24680]="0:4:2:1:Cloth::1:0:", -- Archmage Gloves
	[24681]="0:4:2:1:Cloth::1:0:", -- Archmage Headpiece
	[24682]="0:4:2:1:Cloth::1:0:", -- Archmage Pants
	[24683]="0:4:2:1:Cloth::1:0:", -- Archmage Mantle
	[24684]="0:4:2:1:Cloth::1:0:", -- Archmage Bracelets
	[24685]="0:4:2:1:Cloth::1:0:", -- Elementalist Belt
	[24686]="0:4:2:1:Cloth::1:0:", -- Elementalist Boots
	[24687]="0:4:2:1:Cloth::1:0:", -- Elementalist Tunic
	[24688]="0:4:2:1:Cloth::1:0:", -- Elementalist Gloves
	[24689]="0:4:2:1:Cloth::1:0:", -- Elementalist Skullcap
	[24690]="0:4:2:1:Cloth::1:0:", -- Elementalist Leggings
	[24691]="0:4:2:1:Cloth::1:0:", -- Elementalist Mantle
	[24692]="0:4:2:1:Cloth::1:0:", -- Elementalist Bracelets
	[24693]="0:4:2:1:Leather::1:0:", -- Bonechewer Pelt-Girdle
	[24694]="0:4:2:1:Leather::1:0:", -- Bonechewer Shredboots
	[24695]="0:4:2:1:Leather::1:0:", -- Bonechewer Chestpiece
	[24696]="0:4:2:1:Leather::1:0:", -- Bonechewer Spikegloves
	[24697]="0:4:2:1:Leather::1:0:", -- Bonechewer Skincloak
	[24698]="0:4:2:1:Leather::1:0:", -- Bonechewer Ripleggings
	[24699]="0:4:2:1:Leather::1:0:", -- Bonechewer Shoulderguards
	[24700]="0:4:2:1:Leather::1:0:", -- Bonechewer Bands
	[24701]="0:4:2:1:Leather::1:0:", -- Haal'eshi Cord
	[24702]="0:4:2:1:Leather::1:0:", -- Haal'eshi Boots
	[24703]="0:4:2:1:Leather::1:0:", -- Haal'eshi Jerkin
	[24704]="0:4:2:1:Leather::1:0:", -- Haal'eshi Gloves
	[24705]="0:4:2:1:Leather::1:0:", -- Haal'eshi Hat
	[24706]="0:4:2:1:Leather::1:0:", -- Haal'eshi Leggings
	[24707]="0:4:2:1:Leather::1:0:", -- Haal'eshi Pauldrons
	[24708]="0:4:2:1:Leather::1:0:", -- Haal'eshi Bindings
	[24709]="0:4:2:1:Leather::1:0:", -- Vengeance Belt
	[24710]="0:4:2:1:Leather::1:0:", -- Vengeance Boots
	[24711]="0:4:2:1:Leather::1:0:", -- Vengeance Chestpiece
	[24712]="0:4:2:1:Leather::1:0:", -- Vengeance Gloves
	[24713]="0:4:2:1:Leather::1:0:", -- Vengeance Helm
	[24714]="0:4:2:1:Leather::1:0:", -- Vengeance Legguards
	[24715]="0:4:2:1:Leather::1:0:", -- Vengeance Pauldrons
	[24716]="0:4:2:1:Leather::1:0:", -- Vengeance Bands
	[24717]="0:4:2:1:Leather::1:0:", -- Dreghood Belt
	[24718]="0:4:2:1:Leather::1:0:", -- Dreghood Boots
	[24719]="0:4:2:1:Leather::1:0:", -- Dreghood Chestpiece
	[24720]="0:4:2:1:Leather::1:0:", -- Dreghood Gloves
	[24721]="0:4:2:1:Leather::1:0:", -- Dreghood Cowl
	[24722]="0:4:2:1:Leather::1:0:", -- Dreghood Trousers
	[24723]="0:4:2:1:Leather::1:0:", -- Dreghood Pauldrons
	[24724]="0:4:2:1:Leather::1:0:", -- Dreghood Bands
	[24725]="0:4:2:1:Leather::1:0:", -- Dementia Cord
	[24726]="0:4:2:1:Leather::1:0:", -- Dementia Boots
	[24727]="0:4:2:1:Leather::1:0:", -- Dementia Vest
	[24728]="0:4:2:1:Leather::1:0:", -- Dementia Gloves
	[24729]="0:4:2:1:Leather::1:0:", -- Dementia Hood
	[24730]="0:4:2:1:Leather::1:0:", -- Dementia Trousers
	[24731]="0:4:2:1:Leather::1:0:", -- Dementia Shoulderguards
	[24732]="0:4:2:1:Leather::1:0:", -- Dementia Armguards
	[24733]="0:4:2:1:Leather::1:0:", -- Sunroc Waistband
	[24734]="0:4:2:1:Leather::1:0:", -- Sunroc Boots
	[24735]="0:4:2:1:Leather::1:0:", -- Sunroc Chestpiece
	[24736]="0:4:2:1:Leather::1:0:", -- Sunroc Gloves
	[24737]="0:4:2:1:Leather::1:0:", -- Sunroc Mask
	[24738]="0:4:2:1:Leather::1:0:", -- Sunroc Pants
	[24739]="0:4:2:1:Leather::1:0:", -- Sunroc Shoulderguards
	[24740]="0:4:2:1:Leather::1:0:", -- Sunroc Armguards
	[24741]="0:4:2:1:Leather::1:0:", -- Ranger Belt
	[24742]="0:4:2:1:Leather::1:0:", -- Ranger Boots
	[24743]="0:4:2:1:Leather::1:0:", -- Ranger Jerkin
	[24744]="0:4:2:1:Leather::1:0:", -- Ranger Gloves
	[24745]="0:4:2:1:Leather::1:0:", -- Ranger Hat
	[24746]="0:4:2:1:Leather::1:0:", -- Ranger Pants
	[24747]="0:4:2:1:Leather::1:0:", -- Ranger Pauldrons
	[24748]="0:4:2:1:Leather::1:0:", -- Ranger Armguards
	[24749]="0:4:2:1:Leather::1:0:", -- Daggerfen Belt
	[24750]="0:4:2:1:Leather::1:0:", -- Daggerfen Boots
	[24751]="0:4:2:1:Leather::1:0:", -- Daggerfen Battlevest
	[24752]="0:4:2:1:Leather::1:0:", -- Daggerfen Gloves
	[24753]="0:4:2:1:Leather::1:0:", -- Daggerfen Cowl
	[24754]="0:4:2:1:Leather::1:0:", -- Daggerfen Stitchpants
	[24755]="0:4:2:1:Leather::1:0:", -- Daggerfen Pauldrons
	[24756]="0:4:2:1:Leather::1:0:", -- Daggerfen Bindings
	[24757]="0:4:2:1:Leather::1:0:", -- Umbrafen Waistband
	[24758]="0:4:2:1:Leather::1:0:", -- Umbrafen Boots
	[24759]="0:4:2:1:Leather::1:0:", -- Umbrafen Tunic
	[24760]="0:4:2:1:Leather::1:0:", -- Umbrafen Gloves
	[24761]="0:4:2:1:Leather::1:0:", -- Umbrafen Cap
	[24762]="0:4:2:1:Leather::1:0:", -- Umbrafen Britches
	[24763]="0:4:2:1:Leather::1:0:", -- Umbrafen Shoulderguards
	[24764]="0:4:2:1:Leather::1:0:", -- Umbrafen Bindings
	[24765]="0:4:2:1:Leather::1:0:", -- Clefthoof Belt
	[24766]="0:4:2:1:Leather::1:0:", -- Clefthoof Wanderboots
	[24767]="0:4:2:1:Leather::1:0:", -- Clefthoof Hidemantle
	[24768]="0:4:2:1:Leather::1:0:", -- Clefthoof Gloves
	[24769]="0:4:2:1:Leather::1:0:", -- Clefthoof Cover
	[24770]="0:4:2:1:Leather::1:0:", -- Clefthoof Britches
	[24771]="0:4:2:1:Leather::1:0:", -- Clefthoof Shoulderguards
	[24772]="0:4:2:1:Leather::1:0:", -- Clefthoof Bracers
	[24773]="0:4:2:1:Leather::1:0:", -- Boneshredder Belt
	[24774]="0:4:2:1:Leather::1:0:", -- Boneshredder Boots
	[24775]="0:4:2:1:Leather::1:0:", -- Boneshredder Jerkin
	[24776]="0:4:2:1:Leather::1:0:", -- Boneshredder Gloves
	[24777]="0:4:2:1:Leather::1:0:", -- Boneshredder Skullcap
	[24778]="0:4:2:1:Leather::1:0:", -- Boneshredder Britches
	[24779]="0:4:2:1:Leather::1:0:", -- Boneshredder Shoulderguards
	[24780]="0:4:2:1:Leather::1:0:", -- Boneshredder Wristguards
	[24781]="0:4:2:1:Leather::1:0:", -- Murkblood Belt
	[24782]="0:4:0:1:Cloth::1:0:", -- Loosely Threaded Gloves
	[24783]="0:4:2:1:Leather::1:0:", -- Murkblood Boots
	[24784]="0:4:2:1:Leather::1:0:", -- Murkblood Chestpiece
	[24785]="0:4:2:1:Leather::1:0:", -- Murkblood Gloves
	[24786]="0:4:2:1:Leather::1:0:", -- Murkblood Cover
	[24787]="0:4:2:1:Leather::1:0:", -- Murkblood Pants
	[24788]="0:4:2:1:Leather::1:0:", -- Murkblood Shoulderguards
	[24789]="0:4:2:1:Leather::1:0:", -- Murkblood Bracers
	[24790]="0:4:2:1:Leather::1:0:", -- Expedition Girdle
	[24791]="0:4:2:1:Leather::1:0:", -- Expedition Boots
	[24792]="0:4:2:1:Leather::1:0:", -- Expedition Tunic
	[24793]="0:4:2:1:Leather::1:0:", -- Expedition Gloves
	[24794]="0:4:2:1:Leather::1:0:", -- Expedition Hood
	[24795]="0:4:2:1:Leather::1:0:", -- Expedition Pants
	[24796]="0:4:2:1:Leather::1:0:", -- Expedition Shoulderguards
	[24797]="0:4:2:1:Leather::1:0:", -- Expedition Bracers
	[24798]="0:4:2:1:Leather::1:0:", -- Dragonhawk Belt
	[24799]="0:4:2:1:Leather::1:0:", -- Dragonhawk Boots
	[24800]="0:4:2:1:Leather::1:0:", -- Dragonhawk Tunic
	[24801]="0:4:2:1:Leather::1:0:", -- Dragonhawk Gloves
	[24802]="0:4:2:1:Leather::1:0:", -- Dragonhawk Hat
	[24803]="0:4:2:1:Leather::1:0:", -- Dragonhawk Pants
	[24804]="0:4:2:1:Leather::1:0:", -- Dragonhawk Shoulderguards
	[24805]="0:4:2:1:Leather::1:0:", -- Dragonhawk Bands
	[24806]="0:4:2:1:Mail::1:0:", -- Unyielding Waistband
	[24807]="0:4:2:1:Mail::1:0:", -- Unyielding Footwraps
	[24808]="0:4:2:1:Mail::1:0:", -- Unyielding Chain Vest
	[24809]="0:4:2:1:Mail::1:0:", -- Unyielding Fists
	[24810]="0:4:2:1:Mail::1:0:", -- Unyielding Helm
	[24811]="0:4:2:1:Mail::1:0:", -- Unyielding Leggings
	[24812]="0:4:2:1:Mail::1:0:", -- Unyielding Spaulders
	[24813]="0:4:2:1:Mail::1:0:", -- Unyielding Bindings
	[24814]="0:4:2:1:Mail::1:0:", -- Felstone Waistband
	[24815]="0:4:2:1:Mail::1:0:", -- Felstone Greaves
	[24816]="0:4:2:1:Mail::1:0:", -- Felstone Chain Vest
	[24817]="0:4:2:1:Mail::1:0:", -- Felstone Gauntlets
	[24818]="0:4:2:1:Mail::1:0:", -- Felstone Helm
	[24819]="0:4:2:1:Mail::1:0:", -- Felstone Leggings
	[24820]="0:4:2:1:Mail::1:0:", -- Felstone Spaulders
	[24821]="0:4:2:1:Mail::1:0:", -- Felstone Bindings
	[24822]="0:4:2:1:Mail::1:0:", -- Netherstalker Belt
	[24823]="0:4:2:1:Mail::1:0:", -- Netherstalker Greaves
	[24824]="0:4:2:1:Mail::1:0:", -- Netherstalker Armor
	[24825]="0:4:2:1:Mail::1:0:", -- Netherstalker Gloves
	[24826]="0:4:2:1:Mail::1:0:", -- Netherstalker Helmet
	[24827]="0:4:2:1:Mail::1:0:", -- Netherstalker Legguards
	[24828]="0:4:2:1:Mail::1:0:", -- Netherstalker Mantle
	[24829]="0:4:2:1:Mail::1:0:", -- Netherstalker Bracer
	[24830]="0:4:2:1:Mail::1:0:", -- Nexus-Strider Belt
	[24831]="0:4:2:1:Mail::1:0:", -- Nexus-Strider Greaves
	[24832]="0:4:2:1:Mail::1:0:", -- Nexus-Strider Breastplate
	[24833]="0:4:2:1:Mail::1:0:", -- Nexus-Strider Gloves
	[24834]="0:4:2:1:Mail::1:0:", -- Nexus-Strider Helmet
	[24835]="0:4:2:1:Mail::1:0:", -- Nexus-Strider Legwraps
	[24836]="0:4:2:1:Mail::1:0:", -- Nexus-Strider Mantle
	[24837]="0:4:2:1:Mail::1:0:", -- Nexus-Strider Bracer
	[24838]="0:4:2:1:Mail::1:0:", -- Wrathfin Waistband
	[24839]="0:4:2:1:Mail::1:0:", -- Wrathfin Greaves
	[24840]="0:4:2:1:Mail::1:0:", -- Wrathfin Armor
	[24841]="0:4:2:1:Mail::1:0:", -- Wrathfin Gloves
	[24842]="0:4:2:1:Mail::1:0:", -- Wrathfin Helmet
	[24843]="0:4:2:1:Mail::1:0:", -- Wrathfin Legguards
	[24844]="0:4:2:1:Mail::1:0:", -- Wrathfin Mantle
	[24845]="0:4:2:1:Mail::1:0:", -- Wrathfin Bindings
	[24846]="0:4:2:1:Mail::1:0:", -- Fenclaw Waistband
	[24847]="0:4:2:1:Mail::1:0:", -- Fenclaw Footwraps
	[24848]="0:4:2:1:Mail::1:0:", -- Fenclaw Armor
	[24849]="0:4:2:1:Mail::1:0:", -- Fenclaw Fists
	[24850]="0:4:2:1:Mail::1:0:", -- Fenclaw Helm
	[24851]="0:4:2:1:Mail::1:0:", -- Fenclaw Legguards
	[24852]="0:4:2:1:Mail::1:0:", -- Fenclaw Mantle
	[24853]="0:4:2:1:Mail::1:0:", -- Fenclaw Bindings
	[24854]="0:4:2:1:Mail::1:0:", -- Marshcreeper Belt
	[24855]="0:4:2:1:Mail::1:0:", -- Marshcreeper Sludgeboots
	[24856]="0:4:2:1:Mail::1:0:", -- Marshcreeper Fen-Vest
	[24857]="0:4:2:1:Mail::1:0:", -- Marshcreeper Gloves
	[24858]="0:4:2:1:Mail::1:0:", -- Marshcreeper Helm
	[24859]="0:4:2:1:Mail::1:0:", -- Marshcreeper Leggings
	[24860]="0:4:2:1:Mail::1:0:", -- Marshcreeper Mantle
	[24861]="0:4:2:1:Mail::1:0:", -- Marshcreeper Bracelets
	[24862]="0:4:2:1:Mail::1:0:", -- Blood Knight Girdle
	[24863]="0:4:2:1:Mail::1:0:", -- Blood Knight Boots
	[24864]="0:4:2:1:Mail::1:0:", -- Blood Knight Breastplate
	[24865]="0:4:2:1:Mail::1:0:", -- Blood Knight Gauntlets
	[24866]="0:4:2:1:Mail::1:0:", -- Blood Knight Helm
	[24867]="0:4:2:1:Mail::1:0:", -- Blood Knight Greaves
	[24868]="0:4:2:1:Mail::1:0:", -- Blood Knight Pauldrons
	[24869]="0:4:2:1:Mail::1:0:", -- Blood Knight Bracers
	[24870]="0:4:2:1:Mail::1:0:", -- Ironspine Belt
	[24871]="0:4:2:1:Mail::1:0:", -- Ironspine Greaves
	[24872]="0:4:2:1:Mail::1:0:", -- Ironspine Chain Vest
	[24873]="0:4:2:1:Mail::1:0:", -- Ironspine Gloves
	[24874]="0:4:2:1:Mail::1:0:", -- Ironspine Helm
	[24875]="0:4:2:1:Mail::1:0:", -- Ironspine Legguards
	[24876]="0:4:2:1:Mail::1:0:", -- Ironspine Shoulderguards
	[24877]="0:4:2:1:Mail::1:0:", -- Ironspine Bracelets
	[24878]="0:4:2:1:Mail::1:0:", -- Der'izu Belt
	[24879]="0:4:2:1:Mail::1:0:", -- Der'izu Greaves
	[24880]="0:4:2:1:Mail::1:0:", -- Der'izu Chestpiece
	[24881]="0:4:2:1:Mail::1:0:", -- Der'izu Fists
	[24882]="0:4:2:1:Mail::1:0:", -- Der'izu Helm
	[24883]="0:4:2:1:Mail::1:0:", -- Der'izu Legguards
	[24884]="0:4:2:1:Mail::1:0:", -- Der'izu Spaulders
	[24885]="0:4:2:1:Mail::1:0:", -- Der'izu Bracer
	[24886]="0:4:2:1:Mail::1:0:", -- Skettis Belt
	[24887]="0:4:2:1:Mail::1:0:", -- Skettis Footwraps
	[24888]="0:4:2:1:Mail::1:0:", -- Skettis Chestpiece
	[24889]="0:4:2:1:Mail::1:0:", -- Skettis Gauntlets
	[24890]="0:4:2:1:Mail::1:0:", -- Skettis Helmet
	[24891]="0:4:2:1:Mail::1:0:", -- Skettis Legguards
	[24892]="0:4:2:1:Mail::1:0:", -- Skettis Spaulders
	[24893]="0:4:2:1:Mail::1:0:", -- Skettis Bracer
	[24894]="0:4:2:1:Mail::1:0:", -- Sundered Waistband
	[24895]="0:4:2:1:Mail::1:0:", -- Sundered Footwraps
	[24896]="0:4:2:1:Mail::1:0:", -- Sundered Chestpiece
	[24897]="0:4:2:1:Mail::1:0:", -- Sundered Gauntlets
	[24898]="0:4:2:1:Mail::1:0:", -- Sundered Helmet
	[24899]="0:4:2:1:Mail::1:0:", -- Sundered Legguards
	[24900]="0:4:2:1:Mail::1:0:", -- Sundered Spaulders
	[24901]="0:4:2:1:Mail::1:0:", -- Tortured Bracer
	[24902]="0:4:2:1:Mail::1:0:", -- Talhide Stitched-Belt
	[24903]="0:4:2:1:Mail::1:0:", -- Talhide Lined-Boots
	[24904]="0:4:2:1:Mail::1:0:", -- Talhide Chestpiece
	[24905]="0:4:2:1:Mail::1:0:", -- Talhide Lined-Gloves
	[24906]="0:4:2:1:Mail::1:0:", -- Talhide Helmet
	[24907]="0:4:2:1:Mail::1:0:", -- Talhide Lined-Leggings
	[24908]="0:4:2:1:Mail::1:0:", -- Talhide Shoulderguards
	[24909]="0:4:2:1:Mail::1:0:", -- Talhide Lined-Bracers
	[24910]="0:4:2:1:Mail::1:0:", -- Netherstorm Belt
	[24911]="0:4:2:1:Mail::1:0:", -- Netherstorm Greaves
	[24912]="0:4:2:1:Mail::1:0:", -- Netherstorm Chestpiece
	[24913]="0:4:2:1:Mail::1:0:", -- Netherstorm Gauntlets
	[24914]="0:4:2:1:Mail::1:0:", -- Netherstorm Helm
	[24915]="0:4:2:1:Mail::1:0:", -- Netherstorm Legguards
	[24916]="0:4:2:1:Mail::1:0:", -- Netherstorm Shoulderguards
	[24917]="0:4:2:1:Mail::1:0:", -- Netherstorm Bracer
	[24918]="0:4:2:1:Plate::1:0:", -- Grimscale Belt
	[24919]="0:4:2:1:Plate::1:0:", -- Grimscale Sabatons
	[24920]="0:4:2:1:Plate::1:0:", -- Grimscale Armor
	[24921]="0:4:2:1:Plate::1:0:", -- Grimscale Gauntlets
	[24922]="0:4:2:1:Plate::1:0:", -- Grimscale Helm
	[24923]="0:4:2:1:Plate::1:0:", -- Grimscale Legguards
	[24924]="0:4:2:1:Plate::1:0:", -- Grimscale Pauldrons
	[24925]="0:4:2:1:Plate::1:0:", -- Grimscale Vambraces
	[24926]="0:4:2:1:Plate::1:0:", -- Ango'rosh Belt
	[24927]="0:4:2:1:Plate::1:0:", -- Ango'rosh Sabatons
	[24928]="0:4:2:1:Plate::1:0:", -- Ango'rosh Breastplate
	[24929]="0:4:2:1:Plate::1:0:", -- Ango'rosh Gauntlets
	[24930]="0:4:2:1:Plate::1:0:", -- Ango'rosh Helm
	[24931]="0:4:2:1:Plate::1:0:", -- Ango'rosh Legguards
	[24932]="0:4:2:1:Plate::1:0:", -- Ango'rosh Pauldrons
	[24933]="0:4:2:1:Plate::1:0:", -- Ango'rosh Vambraces
	[24934]="0:4:2:1:Plate::1:0:", -- Darkcrest Belt
	[24935]="0:4:2:1:Plate::1:0:", -- Darkcrest Sabatons
	[24936]="0:4:2:1:Plate::1:0:", -- Darkcrest Breastplate
	[24937]="0:4:2:1:Plate::1:0:", -- Darkcrest Gauntlets
	[24938]="0:4:2:1:Plate::1:0:", -- Darkcrest Helm
	[24939]="0:4:2:1:Plate::1:0:", -- Darkcrest Legguards
	[24940]="0:4:2:1:Plate::1:0:", -- Darkcrest Pauldrons
	[24941]="0:4:2:1:Plate::1:0:", -- Darkcrest Bracers
	[24942]="0:4:2:1:Plate::1:0:", -- Bloodscale Belt
	[24943]="0:4:2:1:Plate::1:0:", -- Bloodscale Sabatons
	[24944]="0:4:2:1:Plate::1:0:", -- Bloodscale Breastplate
	[24945]="0:4:2:1:Plate::1:0:", -- Bloodscale Gauntlets
	[24946]="0:4:2:1:Plate::1:0:", -- Bloodscale Helm
	[24947]="0:4:2:1:Plate::1:0:", -- Bloodscale Legguards
	[24948]="0:4:2:1:Plate::1:0:", -- Bloodscale Pauldrons
	[24949]="0:4:2:1:Plate::1:0:", -- Bloodscale Bracers
	[24950]="0:4:2:1:Plate::1:0:", -- Bogslayer Belt
	[24951]="0:4:2:1:Plate::1:0:", -- Bogslayer Sabatons
	[24952]="0:4:2:1:Plate::1:0:", -- Bogslayer Breastplate
	[24953]="0:4:2:1:Plate::1:0:", -- Bogslayer Gauntlets
	[24954]="0:4:2:1:Plate::1:0:", -- Bogslayer Helm
	[24955]="0:4:2:1:Plate::1:0:", -- Bogslayer Legplates
	[24956]="0:4:2:1:Plate::1:0:", -- Bogslayer Pauldrons
	[24957]="0:4:2:1:Plate::1:0:", -- Bogslayer Bracers
	[24958]="0:4:2:1:Plate::1:0:", -- Khan'aish Girdle
	[24959]="0:4:2:1:Plate::1:0:", -- Khan'aish Greaves
	[24960]="0:4:2:1:Plate::1:0:", -- Khan'aish Breastplate
	[24961]="0:4:2:1:Plate::1:0:", -- Khan'aish Gloves
	[24962]="0:4:2:1:Plate::1:0:", -- Khan'aish Helmet
	[24963]="0:4:2:1:Plate::1:0:", -- Khan'aish Legplates
	[24964]="0:4:2:1:Plate::1:0:", -- Khan'aish Epaulets
	[24965]="0:4:2:1:Plate::1:0:", -- Khan'aish Bracers
	[24966]="0:4:2:1:Plate::1:0:", -- Talonguard Girdle
	[24967]="0:4:2:1:Plate::1:0:", -- Talonguard Greaves
	[24968]="0:4:2:1:Plate::1:0:", -- Talonguard Armor
	[24969]="0:4:2:1:Plate::1:0:", -- Talonguard Gloves
	[24970]="0:4:2:1:Plate::1:0:", -- Talonguard Helmet
	[24971]="0:4:2:1:Plate::1:0:", -- Talonguard Legplates
	[24972]="0:4:2:1:Plate::1:0:", -- Talonguard Epaulets
	[24973]="0:4:2:1:Plate::1:0:", -- Talonguard Bracers
	[24974]="0:4:2:1:Plate::1:0:", -- Reaver Girdle
	[24975]="0:4:2:1:Plate::1:0:", -- Reaver Greaves
	[24976]="0:4:2:1:Plate::1:0:", -- Reaver Armor
	[24977]="0:4:2:1:Plate::1:0:", -- Reaver Gloves
	[24978]="0:4:2:1:Plate::1:0:", -- Reaver Helmet
	[24979]="0:4:2:1:Plate::1:0:", -- Reaver Legplates
	[24980]="0:4:2:1:Plate::1:0:", -- Reaver Epaulets
	[24981]="0:4:2:1:Plate::1:0:", -- Reaver Bracers
	[24982]="0:4:2:1:Plate::1:0:", -- Boulderfist Belt
	[24983]="0:4:2:1:Plate::1:0:", -- Boulderfist Greaves
	[24984]="0:4:2:1:Plate::1:0:", -- Boulderfist Armor
	[24985]="0:4:2:1:Plate::1:0:", -- Boulderfist Gloves
	[24986]="0:4:2:1:Plate::1:0:", -- Boulderfist Helm
	[24987]="0:4:2:1:Plate::1:0:", -- Boulderfist Legplates
	[24988]="0:4:2:1:Plate::1:0:", -- Boulderfist Epaulets
	[24989]="0:4:2:1:Plate::1:0:", -- Boulderfist Bracers
	[24990]="0:4:2:1:Plate::1:0:", -- Warmaul Belt
	[24991]="0:4:2:1:Plate::1:0:", -- Warmaul Greaves
	[24992]="0:4:2:1:Plate::1:0:", -- Warmaul Breastplate
	[24993]="0:4:2:1:Plate::1:0:", -- Warmaul Gloves
	[24994]="0:4:2:1:Plate::1:0:", -- Warmaul Helmet
	[24995]="0:4:2:1:Plate::1:0:", -- Warmaul Legplates
	[24996]="0:4:2:1:Plate::1:0:", -- Warmaul Epaulets
	[24997]="0:4:2:1:Plate::1:0:", -- Warmaul Vambraces
	[24998]="0:4:2:1:Plate::1:0:", -- Bloodfist Girdle
	[24999]="0:4:2:1:Plate::1:0:", -- Bloodfist Greaves
	[25000]="0:4:2:1:Plate::1:0:", -- Bloodfist Breastplate
	[25001]="0:4:2:1:Plate::1:0:", -- Bloodfist Gloves
	[25002]="0:4:2:1:Plate::1:0:", -- Bloodfist Helmet
	[25003]="0:4:2:1:Plate::1:0:", -- Bloodfist Legplates
	[25004]="0:4:2:1:Plate::1:0:", -- Bloodfist Epaulets
	[25005]="0:4:2:1:Plate::1:0:", -- Bloodfist Vambraces
	[25006]="0:4:2:1:Plate::1:0:", -- Conqueror's Girdle
	[25007]="0:4:2:1:Plate::1:0:", -- Conqueror's Greaves
	[25008]="0:4:2:1:Plate::1:0:", -- Conqueror's Breastplate
	[25009]="0:4:2:1:Plate::1:0:", -- Conqueror's Gauntlets
	[25010]="0:4:2:1:Plate::1:0:", -- Conqueror's Helmet
	[25011]="0:4:2:1:Plate::1:0:", -- Conqueror's Legplates
	[25012]="0:4:2:1:Plate::1:0:", -- Conqueror's Epaulets
	[25013]="0:4:2:1:Plate::1:0:", -- Conqueror's Vambraces
	[25014]="0:4:2:1:Plate::1:0:", -- Shattered Hand Belt
	[25015]="0:4:2:1:Plate::1:0:", -- Shattered Hand Sabatons
	[25016]="0:4:2:1:Plate::1:0:", -- Shattered Hand Breastplate
	[25017]="0:4:2:1:Plate::1:0:", -- Shattered Hand Gauntlets
	[25018]="0:4:2:1:Plate::1:0:", -- Shattered Hand Helmet
	[25019]="0:4:2:1:Plate::1:0:", -- Shattered Hand Legplates
	[25020]="0:4:2:1:Plate::1:0:", -- Shattered Hand Epaulets
	[25021]="0:4:2:1:Plate::1:0:", -- Shattered Hand Vambraces
	[25022]="0:4:2:1:Plate::1:0:", -- Warlord's Iron-Girdle
	[25023]="0:4:2:1:Plate::1:0:", -- Warlord's Sabatons
	[25024]="0:4:2:1:Plate::1:0:", -- Warlord's Iron-Breastplate
	[25025]="0:4:2:1:Plate::1:0:", -- Warlord's Iron-Gauntlets
	[25026]="0:4:2:1:Plate::1:0:", -- Warlord's Iron-Helm
	[25027]="0:4:2:1:Plate::1:0:", -- Warlord's Iron-Legplates
	[25028]="0:4:2:1:Plate::1:0:", -- Warlord's Iron-Epaulets
	[25029]="0:4:2:1:Plate::1:0:", -- Warlord's Iron-Vambraces
	[25030]="0:4:2:1:Cloak::1:0:", -- Silky Velvet Cloak
	[25031]="0:4:2:1:Cloak::1:0:", -- Silvermoon Royal Cloak
	[25032]="0:4:2:1:Cloak::1:0:", -- Hellfire Cloak
	[25033]="0:4:2:1:Cloak::1:0:", -- Scavenger's Cloak
	[25034]="0:4:2:1:Cloak::1:0:", -- Elementalist Cloak
	[25035]="0:4:2:1:Cloak::1:0:", -- Silver-Lined Cloak
	[25036]="0:4:2:1:Cloak::1:0:", -- Boulderfist Cloak
	[25037]="0:4:2:1:Cloak::1:0:", -- Patched Cape
	[25038]="0:4:2:1:Cloak::1:0:", -- Forest Shroud
	[25039]="0:4:2:1:Cloak::1:0:", -- Farseer Cloak
	[25040]="0:4:2:1:Cloak::1:0:", -- Murkblood Cape
	[25041]="0:4:2:1:Cloak::1:0:", -- Ambusher's Cloak
	[25042]="0:4:2:1:Cloak::1:0:", -- Nether Cloak
	[25043]="0:4:2:1:Cloak::1:0:", -- Amber Cape
	[25044]="0:4:2:1:Ring::1:0:", -- Rubellite Ring
	[25045]="0:4:2:1:Ring::1:0:", -- Azurite Ring
	[25046]="0:4:2:1:Ring::1:0:", -- Spined Ring
	[25047]="0:4:2:1:Ring::1:0:", -- Tourmaline Loop
	[25048]="0:4:2:1:Ring::1:0:", -- Smoky Quartz Ring
	[25049]="0:4:2:1:Ring::1:0:", -- Scheelite Ring
	[25050]="0:4:2:1:Ring::1:0:", -- Moldavite Ring
	[25051]="0:4:2:1:Ring::1:0:", -- Blue Topaz Band
	[25052]="0:4:2:1:Ring::1:0:", -- Hauyne Ring
	[25053]="0:4:2:1:Ring::1:0:", -- Lazuli Ring
	[25054]="0:4:2:1:Ring::1:0:", -- Sodalite Band
	[25055]="0:4:2:1:Ring::1:0:", -- Alexandrite Ring
	[25056]="0:4:2:1:Ring::1:0:", -- Almandine Ring
	[25057]="0:4:2:1:Ring::1:0:", -- Amber Band
	[25058]="0:4:2:1:Amulet::1:0:", -- Anglesite Choker
	[25059]="0:4:2:1:Amulet::1:0:", -- Fire Opal Collar
	[25060]="0:4:2:1:Amulet::1:0:", -- Sunstone Necklace
	[25061]="0:4:2:1:Amulet::1:0:", -- Hiddenite Necklace
	[25062]="0:4:2:1:Amulet::1:0:", -- Zircon Amulet
	[25063]="0:4:2:1:Amulet::1:0:", -- Multi-Colored Beads
	[25064]="0:4:2:1:Amulet::1:0:", -- Amethyst Pendant
	[25065]="0:4:2:1:Amulet::1:0:", -- Turquoise Brooch
	[25066]="0:4:2:1:Amulet::1:0:", -- Pink Sapphire Necklace
	[25067]="0:4:2:1:Amulet::1:0:", -- Diopside Beads
	[25068]="0:4:2:1:Amulet::1:0:", -- Kunzite Necklace
	[25069]="0:4:2:1:Amulet::1:0:", -- Epidote Stone Necklace
	[25070]="0:4:2:1:Amulet::1:0:", -- Coral Beads
	[25071]="0:4:2:1:Amulet::1:0:", -- Tanzanite Pendant
	[25072]="0:4:2:1:Shield::1:0:", -- Northman's Shield
	[25073]="0:4:2:1:Shield::1:0:", -- Emperor Shield
	[25074]="0:4:2:1:Shield::1:0:", -- Telaari Shield
	[25075]="0:4:2:1:Shield::1:0:", -- Hardened Steel Shield
	[25076]="0:4:2:1:Shield::1:0:", -- Screaming Shield
	[25077]="0:4:2:1:Shield::1:0:", -- Modani War-Shield
	[25078]="0:4:2:1:Shield::1:0:", -- Zangari Shield
	[25079]="0:4:2:1:Shield::1:0:", -- Outland Shield
	[25080]="0:4:2:1:Shield::1:0:", -- Spell-Breaker Shield
	[25081]="0:4:2:1:Shield::1:0:", -- Bayeaux Shield
	[25082]="0:4:2:1:Shield::1:0:", -- Fel-Iron Shield
	[25083]="0:4:2:1:Shield::1:0:", -- Smouldering Shield
	[25084]="0:4:2:1:Shield::1:0:", -- Zeth'Gor Shield
	[25085]="0:4:2:1:Shield::1:0:", -- Dragonscale Shield
	[25086]="0:4:2:1:OffHandFrill::1:0:", -- Dreamseeker Dandelion
	[25087]="0:4:2:1:OffHandFrill::1:0:", -- Bleeding Eye
	[25088]="0:4:2:1:OffHandFrill::1:0:", -- Laughing Skull Orb
	[25089]="0:4:2:1:OffHandFrill::1:0:", -- Supplicant's Rod
	[25090]="0:4:2:1:OffHandFrill::1:0:", -- Slavehandler Rod
	[25091]="0:4:2:1:OffHandFrill::1:0:", -- Mistyreed Torch
	[25092]="0:4:2:1:OffHandFrill::1:0:", -- Consortium Crystal
	[25093]="0:4:2:1:OffHandFrill::1:0:", -- Shadow Council Orb
	[25094]="0:4:2:1:OffHandFrill::1:0:", -- Eldr'naan Scepter
	[25095]="0:4:2:1:OffHandFrill::1:0:", -- Archmage Orb
	[25096]="0:4:2:1:OffHandFrill::1:0:", -- Elementalist Star
	[25097]="0:4:2:1:OffHandFrill::1:0:", -- Astralaan Orb
	[25098]="0:4:2:1:OffHandFrill::1:0:", -- Tuurik Torch
	[25099]="0:4:2:1:OffHandFrill::1:0:", -- Draenei Crystal Rod
	[25100]="0:2:2:1:Dagger::1:0:", -- Liege Blade
	[25101]="0:2:2:1:Dagger::1:0:", -- Cross Pommel Dagger
	[25102]="0:2:2:1:Dagger::1:0:", -- Jaedenis Dagger
	[25103]="0:2:2:1:Dagger::1:0:", -- Nightstalker Dagger
	[25104]="0:2:2:1:Dagger::1:0:", -- Anzac Dagger
	[25105]="0:2:2:1:Dagger::1:0:", -- Arachnid Dagger
	[25106]="0:2:2:1:Dagger::1:0:", -- Cobra Shortblade
	[25107]="0:2:2:1:Dagger::1:0:", -- Draconic Dagger
	[25108]="0:2:2:1:Dagger::1:0:", -- Grave Keeper Knife
	[25109]="0:2:2:1:Dagger::1:0:", -- Moon Blade
	[25110]="0:2:2:1:Dagger::1:0:", -- Sharp Bowie Knife
	[25111]="0:2:2:1:Dagger::1:0:", -- Lionhead Dagger
	[25112]="0:2:2:1:Dagger::1:0:", -- Fel Ripper
	[25113]="0:2:2:1:Dagger::1:0:", -- Phantom Dagger
	[25114]="0:2:2:1:OneHandMace::1:0:", -- Doomsayer's Mace
	[25115]="0:2:2:1:OneHandMace::1:0:", -- Riversong Mace
	[25116]="0:2:2:1:OneHandMace::1:0:", -- Pneumatic War Hammer
	[25117]="0:2:2:1:OneHandMace::1:0:", -- Flanged Battle Mace
	[25118]="0:2:2:1:OneHandMace::1:0:", -- Battle Star
	[25119]="0:2:2:1:OneHandMace::1:0:", -- Silvermoon War-Mace
	[25120]="0:2:2:1:OneHandMace::1:0:", -- Rockshard Club
	[25121]="0:2:2:1:OneHandMace::1:0:", -- Dreaded Mace
	[25122]="0:2:2:1:OneHandMace::1:0:", -- Khorium Plated Bludgeon
	[25123]="0:2:2:1:OneHandMace::1:0:", -- Boneshredder Mace
	[25124]="0:2:2:1:OneHandMace::1:0:", -- Footman Mace
	[25125]="0:2:2:1:OneHandMace::1:0:", -- Retro-Spike Club
	[25126]="0:2:2:1:OneHandMace::1:0:", -- Anvilmar Hammer
	[25127]="0:2:2:1:OneHandMace::1:0:", -- Knight's War Hammer
	[25128]="0:2:2:1:TwoHandMace::1:0:", -- Shining Mace
	[25129]="0:2:2:1:TwoHandMace::1:0:", -- Giant's Leg Bone
	[25130]="0:2:2:1:TwoHandMace::1:0:", -- Gronn-Bone Club
	[25131]="0:2:2:1:TwoHandMace::1:0:", -- Hateful Bludgeon
	[25132]="0:2:2:1:TwoHandMace::1:0:", -- Thrallmar War Hammer
	[25133]="0:2:2:1:TwoHandMace::1:0:", -- Stormwind Maul
	[25134]="0:2:2:1:TwoHandMace::1:0:", -- Highmountain Hammer
	[25135]="0:2:2:1:TwoHandMace::1:0:", -- Clefthoof Mace
	[25136]="0:2:2:1:TwoHandMace::1:0:", -- Blood Stained Hammer
	[25137]="0:2:2:1:TwoHandMace::1:0:", -- Draenethyst Mallet
	[25138]="0:2:2:1:TwoHandMace::1:0:", -- Blood Knight Maul
	[25139]="0:2:2:1:TwoHandMace::1:0:", -- Algaz Battle Hammer
	[25140]="0:2:2:1:TwoHandMace::1:0:", -- Commanding Mallet
	[25141]="0:2:2:1:TwoHandMace::1:0:", -- Halaani Hammer
	[25142]="0:2:2:1:OneHandSword::1:0:", -- Telaari Longblade
	[25143]="0:2:2:1:OneHandSword::1:0:", -- Silver Hand Blade
	[25144]="0:2:2:1:OneHandSword::1:0:", -- Skettis Curved Blade
	[25146]="0:2:2:1:OneHandSword::1:0:", -- Light-Etched Longsword
	[25147]="0:2:2:1:OneHandSword::1:0:", -- Skystrider Katana
	[25148]="0:2:2:1:OneHandSword::1:0:", -- Bone Collector Sword
	[25149]="0:2:2:1:OneHandSword::1:0:", -- Baron's Broadsword
	[25150]="0:2:2:1:OneHandSword::1:0:", -- Honor Hold Saber
	[25151]="0:2:2:1:OneHandSword::1:0:", -- Assassins' Short Blade
	[25152]="0:2:2:1:OneHandSword::1:0:", -- Howling Sword
	[25153]="0:2:2:1:OneHandSword::1:0:", -- Gladiator Greatblade
	[25154]="0:2:2:1:OneHandSword::1:0:", -- Blood Groove Blade
	[25155]="0:2:2:1:OneHandSword::1:0:", -- Iron Skull Sword
	[25156]="0:2:2:1:TwoHandSword::1:0:", -- Royal Crusader Sword
	[25157]="0:2:2:1:TwoHandSword::1:0:", -- Serpentlord Claymore
	[25158]="0:2:2:1:TwoHandSword::1:0:", -- Skeletal Broadsword
	[25160]="0:2:2:1:TwoHandSword::1:0:", -- Vengeance Blade
	[25161]="0:2:2:1:TwoHandSword::1:0:", -- Dragon Wing Blade
	[25162]="0:2:2:1:TwoHandSword::1:0:", -- Darkened Broadsword
	[25163]="0:2:2:1:TwoHandSword::1:0:", -- Elexorien Blade
	[25164]="0:2:2:1:TwoHandSword::1:0:", -- Crude Umbrafen Blade
	[25165]="0:2:2:1:TwoHandSword::1:0:", -- Boulderfist Claymore
	[25166]="0:2:2:1:TwoHandSword::1:0:", -- Mok'Nathal Warblade
	[25167]="0:2:2:1:TwoHandSword::1:0:", -- Nethersteel Claymore
	[25168]="0:2:2:1:TwoHandSword::1:0:", -- Sha'tari Longsword
	[25169]="0:2:2:1:TwoHandSword::1:0:", -- Fel Orc Brute Sword
	[25170]="0:2:2:1:Stave::1:0:", -- Rattan Bo Staff
	[25171]="0:2:2:1:Stave::1:0:", -- Straight Hardwood Staff
	[25172]="0:2:2:1:Stave::1:0:", -- Jinbali Warp-Staff
	[25174]="0:2:2:1:Stave::1:0:", -- Hanbo Staff
	[25175]="0:2:2:1:Stave::1:0:", -- Demoniac Longstaff
	[25176]="0:2:2:1:Stave::1:0:", -- Taiji Quarterstaff
	[25177]="0:2:2:1:Stave::1:0:", -- Tanjo Staff
	[25178]="0:2:2:1:Stave::1:0:", -- Bata Staff
	[25179]="0:2:2:1:Stave::1:0:", -- Nguni Stick
	[25180]="0:2:2:1:Stave::1:0:", -- Calenda Fighting Stick
	[25181]="0:2:2:1:Stave::1:0:", -- Tapered Staff
	[25182]="0:2:2:1:Stave::1:0:", -- Crystal-Etched Warstaff
	[25183]="0:2:2:1:Stave::1:0:", -- Voodoo Hex-Staff
	[25184]="0:2:2:1:FistWeapon::1:0:", -- Ravager Claws
	[25185]="0:2:2:1:FistWeapon::1:0:", -- Thrasher Blades
	[25186]="0:2:2:1:FistWeapon::1:0:", -- Vampiric Handscythes
	[25187]="0:2:2:1:FistWeapon::1:0:", -- Shekketh Talons
	[25188]="0:2:2:1:FistWeapon::1:0:", -- Spleenripper Claws
	[25189]="0:2:2:1:FistWeapon::1:0:", -- Ironspine Point
	[25190]="0:2:2:1:FistWeapon::1:0:", -- Wight's Claws
	[25191]="0:2:2:1:FistWeapon::1:0:", -- Dread Fangs
	[25192]="0:2:2:1:FistWeapon::1:0:", -- Gutrippers
	[25193]="0:2:2:1:FistWeapon::1:0:", -- Deathclaw Talons
	[25194]="0:2:2:1:FistWeapon::1:0:", -- Serpent's Fangs
	[25195]="0:2:2:1:FistWeapon::1:0:", -- Diamond Tipped Claws
	[25196]="0:2:2:1:FistWeapon::1:0:", -- Boneshredder Claws
	[25197]="0:2:2:1:FistWeapon::1:0:", -- Razor Scythes
	[25198]="0:2:2:1:OneHandAxe::1:0:", -- Karaborian Battle Axe
	[25199]="0:2:2:1:OneHandAxe::1:0:", -- Knight's War Axe
	[25200]="0:2:2:1:OneHandAxe::1:0:", -- Jagged Broadaxe
	[25201]="0:2:2:1:OneHandAxe::1:0:", -- Reaver's Sickle
	[25202]="0:2:2:1:OneHandAxe::1:0:", -- Kingly Axe
	[25203]="0:2:2:1:OneHandAxe::1:0:", -- Chipped Woodchopper
	[25204]="0:2:2:1:OneHandAxe::1:0:", -- Colossal War Axe
	[25205]="0:2:2:1:OneHandAxe::1:0:", -- Silvermoon Crescent Axe
	[25206]="0:2:2:1:OneHandAxe::1:0:", -- Berserker Axe
	[25207]="0:2:2:1:OneHandAxe::1:0:", -- Shadowmoon Cleaver
	[25208]="0:2:2:1:OneHandAxe::1:0:", -- Bladespire Broadaxe
	[25209]="0:2:2:1:OneHandAxe::1:0:", -- Amani Tomahawk
	[25210]="0:2:2:1:OneHandAxe::1:0:", -- Double-Bladed Axe
	[25211]="0:2:2:1:OneHandAxe::1:0:", -- Rockbiter Cutter
	[25212]="0:2:2:1:TwoHandAxe::1:0:", -- Lucky Strike Axe
	[25213]="0:2:2:1:TwoHandAxe::1:0:", -- Fel-Touched Axe
	[25214]="0:2:2:1:TwoHandAxe::1:0:", -- Mok'Nathal Battleaxe
	[25215]="0:2:2:1:TwoHandAxe::1:0:", -- Spiked Battle Axe
	[25216]="0:2:2:1:TwoHandAxe::1:0:", -- Ogre Splitting Axe
	[25217]="0:2:2:1:TwoHandAxe::1:0:", -- Sundering Axe
	[25218]="0:2:2:1:TwoHandAxe::1:0:", -- Silver-Edged Axe
	[25219]="0:2:2:1:TwoHandAxe::1:0:", -- Rending Claw
	[25220]="0:2:2:1:TwoHandAxe::1:0:", -- Glorious War-Axe
	[25221]="0:2:2:1:TwoHandAxe::1:0:", -- Ghostly Battle Axe
	[25222]="0:2:2:1:TwoHandAxe::1:0:", -- Ceremonial Slayer's Axe
	[25223]="0:2:2:1:TwoHandAxe::1:0:", -- Windcaller Hatchet
	[25224]="0:2:2:1:TwoHandAxe::1:0:", -- Slavemaster Axe
	[25225]="0:2:2:1:TwoHandAxe::1:0:", -- Deepforge Broadaxe
	[25226]="0:2:2:1:Polearm::1:0:", -- War Scythe
	[25227]="0:2:2:1:Polearm::1:0:", -- Sha'tari Longspear
	[25228]="0:2:2:1:Polearm::1:0:", -- Halberd Polearm
	[25229]="0:2:2:1:Polearm::1:0:", -- Partisan Polearm
	[25230]="0:2:2:1:Polearm::1:0:", -- Voulge Blade
	[25231]="0:2:2:1:Polearm::1:0:", -- Fel-Wrought Halberd
	[25232]="0:2:2:1:Polearm::1:0:", -- War Glaive
	[25233]="0:2:2:1:Polearm::1:0:", -- Battle Scythe
	[25234]="0:2:2:1:Polearm::1:0:", -- Telaari Polearm
	[25235]="0:2:2:1:Polearm::1:0:", -- Ethereal-Etched Glaive
	[25236]="0:2:2:1:Polearm::1:0:", -- Grim Scythe
	[25237]="0:2:2:1:Polearm::1:0:", -- Nether Trident
	[25238]="0:2:2:1:Polearm::1:0:", -- Hellfire War Spear
	[25239]="0:2:2:1:Polearm::1:0:", -- Legend's Glaive
	[25240]="0:2:2:1:Bow::1:0:", -- Azerothian Longbow
	[25241]="0:2:2:1:Bow::1:0:", -- Ashenvale Longbow
	[25242]="0:2:2:1:Bow::1:0:", -- Telaari Longbow
	[25243]="0:2:2:1:Bow::1:0:", -- Windtalker Bow
	[25244]="0:2:2:1:Bow::1:0:", -- Viper Bow
	[25245]="0:2:2:1:Bow::1:0:", -- Razorsong Bow
	[25246]="0:2:2:1:Bow::1:0:", -- Thalassian Compound Bow
	[25247]="0:2:2:1:Bow::1:0:", -- Expert's Bow
	[25248]="0:2:2:1:Bow::1:0:", -- Talbuk Hunting Bow
	[25249]="0:2:2:1:Bow::1:0:", -- Ranger's Recurved Bow
	[25250]="0:2:2:1:Bow::1:0:", -- Rocslayer Longbow
	[25251]="0:2:2:1:Bow::1:0:", -- Orc Flatbow
	[25252]="0:2:2:1:Bow::1:0:", -- Dream Catcher Bow
	[25253]="0:2:2:1:Bow::1:0:", -- Windspear Longbow
	[25254]="0:2:2:1:Crossbow::1:0:", -- Tower Crossbow
	[25255]="0:2:2:1:Crossbow::1:0:", -- Ram's Head Crossbow
	[25256]="0:2:2:1:Crossbow::1:0:", -- Stronghold Crossbow
	[25257]="0:2:2:1:Crossbow::1:0:", -- Citadel Crossbow
	[25258]="0:2:2:1:Crossbow::1:0:", -- Repeater Crossbow
	[25259]="0:2:2:1:Crossbow::1:0:", -- Collapsible Crossbow
	[25260]="0:2:2:1:Crossbow::1:0:", -- Archer's Crossbow
	[25261]="0:2:2:1:Crossbow::1:0:", -- Mighty Crossbow
	[25262]="0:2:2:1:Crossbow::1:0:", -- Battle Damaged Crossbow
	[25263]="0:2:2:1:Crossbow::1:0:", -- Assassins' Silent Crossbow
	[25264]="0:2:2:1:Crossbow::1:0:", -- Pocket Ballista
	[25265]="0:2:2:1:Crossbow::1:0:", -- Barreled Crossbow
	[25266]="0:2:2:1:Crossbow::1:0:", -- Well-Balanced Crossbow
	[25267]="0:2:2:1:Crossbow::1:0:", -- Rampant Crossbow
	[25268]="0:2:2:1:Gun::1:0:", -- Lead-Slug Shotgun
	[25269]="0:2:2:1:Gun::1:0:", -- Longbeard Rifle
	[25270]="0:2:2:1:Gun::1:0:", -- Gnomish Assault Rifle
	[25271]="0:2:2:1:Gun::1:0:", -- Croc-Hunter's Rifle
	[25272]="0:2:2:1:Gun::1:0:", -- PC-54 Shotgun
	[25273]="0:2:2:1:Gun::1:0:", -- Sawed-Off Shotgun
	[25274]="0:2:2:1:Gun::1:0:", -- Cliffjumper Shotgun
	[25275]="0:2:2:1:Gun::1:0:", -- Dragonbreath Musket
	[25276]="0:2:2:1:Gun::1:0:", -- Tauren Runed Musket
	[25277]="0:2:2:1:Gun::1:0:", -- Sporting Rifle
	[25278]="0:2:2:1:Gun::1:0:", -- Nesingwary Longrifle
	[25279]="0:2:2:1:Gun::1:0:", -- Sen'jin Longrifle
	[25280]="0:2:2:1:Gun::1:0:", -- Game Hunter Musket
	[25281]="0:2:2:1:Gun::1:0:", -- Big-Boar Battle Rifle
	[25282]="0:2:2:1:Wand::1:0:", -- Mahogany Wand
	[25283]="0:2:2:1:Wand::1:0:", -- Crystallized Ebony Wand
	[25284]="0:2:2:1:Wand::1:0:", -- Purpleheart Wand
	[25286]="0:2:2:1:Wand::1:0:", -- Yew Wand
	[25287]="0:2:2:1:Wand::1:0:", -- Magician's Wand
	[25288]="0:2:2:1:Wand::1:0:", -- Conjurer's Wand
	[25289]="0:2:2:1:Wand::1:0:", -- Majestic Wand
	[25290]="0:2:2:1:Wand::1:0:", -- Solitaire Wand
	[25291]="0:2:2:1:Wand::1:0:", -- Nobility Torch
	[25292]="0:2:2:1:Wand::1:0:", -- Mechano-Wand
	[25293]="0:2:2:1:Wand::1:0:", -- Draenethyst Wand
	[25294]="0:2:2:1:Wand::1:0:", -- Dragonscale Wand
	[25295]="0:2:2:1:Wand::1:0:", -- Flawless Wand
	[25296]="0:2:2:1:Dagger::1:0:", -- Absorption Dagger
	[25297]="0:2:2:1:Dagger::1:0:", -- Tuning Knife
	[25298]="0:2:2:1:Dagger::1:0:", -- Combustion Dagger
	[25299]="0:2:2:1:Dagger::1:0:", -- Siphoning Dagger
	[25300]="0:2:2:1:Dagger::1:0:", -- Lightning Dagger
	[25301]="0:2:2:1:Dagger::1:0:", -- Shattering Dagger
	[25302]="0:2:2:1:Dagger::1:0:", -- Soul-Drain Dagger
	[25303]="0:2:2:1:Dagger::1:0:", -- Amplifying Blade
	[25304]="0:2:2:1:Dagger::1:0:", -- Destructo-Blade
	[25305]="0:2:2:1:Dagger::1:0:", -- Elemental Dagger
	[25306]="0:2:2:1:Dagger::1:0:", -- Permafrost Dagger
	[25307]="0:2:2:1:Dagger::1:0:", -- Shadow Dagger
	[25308]="0:2:2:1:Dagger::1:0:", -- Thunder Spike
	[25309]="0:2:2:1:Dagger::1:0:", -- Warpdagger
	[25310]="0:2:2:1:OneHandMace::1:0:", -- Naaru Lightmace
	[25311]="0:2:2:1:OneHandMace::1:0:", -- Revitalizing Hammer
	[25312]="0:2:2:1:OneHandMace::1:0:", -- Glorious Scepter
	[25313]="0:2:2:1:OneHandMace::1:0:", -- Cold-Iron Scepter
	[25314]="0:2:2:1:OneHandMace::1:0:", -- Ceremonial Hammer
	[25315]="0:2:2:1:OneHandMace::1:0:", -- Restorative Mace
	[25316]="0:2:2:1:OneHandMace::1:0:", -- Spirit-Clad Mace
	[25317]="0:2:2:1:OneHandMace::1:0:", -- Lesser Sledgemace
	[25318]="0:2:2:1:OneHandMace::1:0:", -- Ancestral Hammer
	[25319]="0:2:2:1:OneHandMace::1:0:", -- Tranquility Mace
	[25320]="0:2:2:1:OneHandMace::1:0:", -- Queen's Insignia
	[25321]="0:2:2:1:OneHandMace::1:0:", -- Divine Hammer
	[25322]="0:2:2:1:OneHandMace::1:0:", -- Lordly Scepter
	[25323]="0:2:2:1:OneHandMace::1:0:", -- Ascendant's Scepter
	[25324]="0:2:2:1:Stave::1:0:", -- Angerstaff
	[25325]="0:2:2:1:Stave::1:0:", -- Brutal Scar-Limb
	[25326]="0:2:2:1:Stave::1:0:", -- Primal Lore-Staff
	[25327]="0:2:2:1:Stave::1:0:", -- Frenzied Staff
	[25328]="0:2:2:1:Stave::1:0:", -- Faerie-Kind Staff
	[25329]="0:2:2:1:Stave::1:0:", -- Tranquility Staff
	[25330]="0:2:2:1:Stave::1:0:", -- Starshine Staff
	[25331]="0:2:2:1:Stave::1:0:", -- Vengeance Staff
	[25332]="0:2:2:1:Stave::1:0:", -- Reflective Staff
	[25333]="0:2:2:1:Stave::1:0:", -- Purification Staff
	[25334]="0:2:2:1:Stave::1:0:", -- Intimidating Greatstaff
	[25335]="0:2:2:1:Stave::1:0:", -- Feral Warp-Staff
	[25336]="0:2:2:1:Stave::1:0:", -- Splintering Greatstaff
	[25337]="0:2:2:1:Stave::1:0:", -- Swarming Sting-Staff
	[25338]="0:4:0:1:Cloth::1:0:", -- Loosely Threaded Pants
	[25339]="0:4:0:1:Cloth::1:0:", -- Loosely Threaded Shoulderpads
	[25340]="0:4:0:1:Cloth::1:0:", -- Loosely Threaded Vest
	[25341]="0:4:0:1:Cloth::1:0:", -- Dilapidated Cloth Belt
	[25342]="0:4:0:1:Cloth::1:0:", -- Dilapidated Cloth Boots
	[25343]="0:4:0:1:Cloth::1:0:", -- Dilapidated Cloth Bracers
	[25344]="0:4:0:1:Cloth::1:0:", -- Dilapidated Cloth Gloves
	[25345]="0:4:0:1:Cloth::1:0:", -- Dilapidated Cloth Hat
	[25346]="0:4:0:1:Cloth::1:0:", -- Dilapidated Cloth Pants
	[25347]="0:4:0:1:Cloth::1:0:", -- Dilapidated Cloth Shoulderpads
	[25348]="0:4:0:1:Cloth::1:0:", -- Dilapidated Cloth Vest
	[25349]="0:4:0:1:Leather::1:0:", -- Moldy Leather Armor
	[25350]="0:4:0:1:Leather::1:0:", -- Moldy Leather Belt
	[25351]="0:4:0:1:Leather::1:0:", -- Moldy Leather Boots
	[25352]="0:4:0:1:Leather::1:0:", -- Moldy Leather Bracers
	[25353]="0:4:0:1:Leather::1:0:", -- Moldy Leather Gloves
	[25354]="0:4:0:1:Leather::1:0:", -- Moldy Leather Helmet
	[25355]="0:4:0:1:Leather::1:0:", -- Moldy Leather Pants
	[25356]="0:4:0:1:Leather::1:0:", -- Moldy Leather Shoulderpads
	[25357]="0:4:0:1:Leather::1:0:", -- Decaying Leather Armor
	[25358]="0:4:0:1:Leather::1:0:", -- Decaying Leather Belt
	[25359]="0:4:0:1:Leather::1:0:", -- Decaying Leather Boots
	[25360]="0:4:0:1:Leather::1:0:", -- Decaying Leather Bracers
	[25361]="0:4:0:1:Leather::1:0:", -- Decaying Leather Gloves
	[25362]="0:4:0:1:Leather::1:0:", -- Decaying Leather Helmet
	[25363]="0:4:0:1:Leather::1:0:", -- Decaying Leather Pants
	[25364]="0:4:0:1:Leather::1:0:", -- Decaying Leather Shoulderpads
	[25365]="0:4:0:1:Mail::1:0:", -- Eroded Mail Armor
	[25366]="0:4:0:1:Mail::1:0:", -- Eroded Mail Belt
	[25367]="0:4:0:1:Mail::1:0:", -- Eroded Mail Boots
	[25368]="0:4:0:1:Mail::1:0:", -- Eroded Mail Bracers
	[25369]="0:4:0:1:Mail::1:0:", -- Eroded Mail Circlet
	[25370]="0:4:0:1:Mail::1:0:", -- Eroded Mail Gloves
	[25371]="0:4:0:1:Mail::1:0:", -- Eroded Mail Pants
	[25372]="0:4:0:1:Mail::1:0:", -- Eroded Mail Shoulderpads
	[25373]="0:4:0:1:Mail::1:0:", -- Corroded Mail Armor
	[25374]="0:4:0:1:Mail::1:0:", -- Corroded Mail Belt
	[25375]="0:4:0:1:Mail::1:0:", -- Corroded Mail Boots
	[25376]="0:4:0:1:Mail::1:0:", -- Corroded Mail Bracers
	[25377]="0:4:0:1:Mail::1:0:", -- Corroded Mail Circlet
	[25378]="0:4:0:1:Mail::1:0:", -- Corroded Mail Gloves
	[25379]="0:4:0:1:Mail::1:0:", -- Corroded Mail Pants
	[25380]="0:4:0:1:Mail::1:0:", -- Corroded Mail Shoulderpads
	[25381]="0:4:0:1:Plate::1:0:", -- Tarnished Plate Belt
	[25382]="0:4:0:1:Plate::1:0:", -- Tarnished Plate Boots
	[25383]="0:4:0:1:Plate::1:0:", -- Tarnished Plate Bracers
	[25384]="0:4:0:1:Plate::1:0:", -- Tarnished Plate Chestpiece
	[25385]="0:4:0:1:Plate::1:0:", -- Tarnished Plate Gloves
	[25386]="0:4:0:1:Plate::1:0:", -- Tarnished Plate Helmet
	[25387]="0:4:0:1:Plate::1:0:", -- Tarnished Plate Pants
	[25388]="0:4:0:1:Plate::1:0:", -- Tarnished Plate Shoulderpads
	[25389]="0:4:0:1:Plate::1:0:", -- Deteriorating Plate Belt
	[25390]="0:4:0:1:Plate::1:0:", -- Deteriorating Plate Boots
	[25391]="0:4:0:1:Plate::1:0:", -- Deteriorating Plate Bracers
	[25392]="0:4:0:1:Plate::1:0:", -- Deteriorating Plate Chestpiece
	[25393]="0:4:0:1:Plate::1:0:", -- Deteriorating Plate Gloves
	[25394]="0:4:0:1:Plate::1:0:", -- Deteriorating Plate Helmet
	[25395]="0:4:0:1:Plate::1:0:", -- Deteriorating Plate Pants
	[25396]="0:4:0:1:Plate::1:0:", -- Deteriorating Plate Shoulderpads
	[25397]="0:2:0:1:OneHandAxe::1:0:", -- Eroded Axe
	[25398]="0:2:0:1:TwoHandAxe::1:0:", -- Stone Reaper
	[25399]="0:2:0:1:OneHandSword::1:0:", -- Deteriorating Blade
	[25400]="0:2:0:1:TwoHandSword::1:0:", -- Tarnished Claymore
	[25401]="0:2:0:1:OneHandMace::1:0:", -- Corroded Mace
	[25402]="0:2:0:1:TwoHandMace::1:0:", -- The Stoppable Force
	[25403]="0:2:0:1:Dagger::1:0:", -- Sharpened Stilleto
	[25404]="0:2:0:1:Stave::1:0:", -- Dense War Staff
	[25405]="0:2:0:1:Gun::1:0:", -- Rusted Musket
	[25406]="0:2:0:1:Bow::1:0:", -- Broken Longbow
	[25408]="0:15:0:20:Junk::1:0:", -- Shiny Tail Hair
	[25409]="0:15:0:20:Junk::1:0:", -- Resilient Tail Hair
	[25410]="0:15:0:20:Junk::1:0:", -- Damaged Hoof
	[25411]="0:15:0:20:Junk::1:0:", -- Worn Hoof
	[25412]="0:15:0:20:Junk::1:0:", -- Dirt-covered Fur
	[25413]="0:15:0:20:Junk::1:0:", -- Smooth Fur
	[25414]="0:15:0:20:Junk::1:0:", -- Brittle Horn
	[25415]="0:15:0:20:Junk::1:0:", -- Aged Horn
	[25416]="0:12:1:200:::1:0:", -- Oshu'gun Crystal Fragment
	[25417]="0:15:0:20:Junk::1:0:", -- Bloody Fang
	[25418]="0:15:0:20:Junk::1:0:", -- Razor Sharp Fang
	[25419]="0:15:1:1:Junk::1:0:", -- Unmarked Bag of Gems
	[25420]="0:15:0:20:Junk::1:0:", -- Severed Claw
	[25421]="0:15:0:20:Junk::1:0:", -- Gnarled Claw
	[25422]="0:15:1:1:Junk::1:0:", -- Bulging Sack of Gems
	[25423]="0:15:1:1:Junk::1:0:", -- Bag of Premium Gems
	[25424]="0:15:1:1:Junk::1:0:", -- Gem-Stuffed Envelope
	[25425]="0:15:0:20:Junk::1:0:", -- Molted Feather
	[25426]="0:15:0:20:Junk::1:0:", -- Brilliant Feather
	[25427]="0:15:0:20:Junk::1:0:", -- Beaten Talon
	[25428]="0:15:0:20:Junk::1:0:", -- Savage Talon
	[25429]="0:15:0:20:Junk::1:0:", -- Grime-encrusted Scale
	[25430]="0:15:0:20:Junk::1:0:", -- Glimmering Scale
	[25431]="0:15:0:20:Junk::1:0:", -- Ripped Fin
	[25432]="0:15:0:20:Junk::1:0:", -- Pristine Fin
	[25433]="0:12:1:200:::1:0:", -- Obsidian Warbeads
	[25434]="0:15:0:20:Junk::1:0:", -- Fractured Carapace
	[25435]="0:15:0:20:Junk::1:0:", -- Hardened Carapace
	[25436]="0:15:0:20:Junk::1:0:", -- Twitching Leg
	[25437]="0:15:0:20:Junk::1:0:", -- Barbed Leg
	[25438]="0:4:2:1:Amulet::1:0:", -- Malachite Pendant
	[25439]="0:4:2:1:Ring::1:0:", -- Tigerseye Band
	[25440]="0:15:0:20:Junk::1:0:", -- Cracked Boar Tusk
	[25441]="0:15:0:20:Junk::1:0:", -- Gnarled Boar Tusk
	[25442]="0:15:0:20:Junk::1:0:", -- Mangled Snout
	[25443]="0:15:0:20:Junk::1:0:", -- Bloody Snout
	[25444]="0:15:0:20:Junk::1:0:", -- Corrosive Ichor
	[25445]="0:15:0:20:Junk::1:0:", -- Wretched Ichor
	[25446]="0:15:0:20:Junk::1:0:", -- Brittle Skull
	[25447]="0:15:0:20:Junk::1:0:", -- Broken Skull
	[25448]="0:12:1:1:::1:0:", -- Blacksting's Stinger
	[25449]="0:12:1:10:::1:0:", -- Bundle of Skins
	[25450]="0:15:0:20:Junk::1:0:", -- Creeping Moss
	[25451]="0:15:0:20:Junk::1:0:", -- Swamp Moss
	[25452]="0:15:0:20:Junk::1:0:", -- Blighted Fungus
	[25453]="0:15:0:20:Junk::1:0:", -- Death Cap Fungus
	[25454]="0:15:0:20:Junk::1:0:", -- Luminescent Globe
	[25455]="0:15:0:20:Junk::1:0:", -- Phosphorescent Globe
	[25456]="0:15:0:20:Junk::1:0:", -- Glowing Spores
	[25457]="0:15:0:20:Junk::1:0:", -- Incandescent Spores
	[25458]="0:15:1:1:Junk::1:0:", -- Mag'har Battle Standard
	[25459]="0:12:1:1:::1:0:", -- "Count" Ungula's Mandible
	[25460]="0:12:1:20:::1:0:", -- Bleeding Hollow Supply Crate
	[25461]="0:12:1:1:::1:0:", -- Book of Forgotten Names
	[25462]="0:12:1:1:::1:0:", -- Tome of Dusk
	[25463]="0:12:1:200:::1:0:", -- Pair of Ivory Tusks
	[25464]="0:2:3:1:Polearm::1:0:", -- Blood-Tempered Ranseur
	[25465]="0:0:1:1:Consumable::1:0:", -- Stormcrow Amulet
	[25466]="0:15:0:20:Junk::1:0:", -- Broken Antenna
	[25467]="0:15:0:20:Junk::1:0:", -- Torn Moth Wing
	[25468]="0:15:1:1:Junk::1:0:", -- Boulderfist Plans
	[25469]="26000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Avoidance
	[25470]="500000:15:3:1:FlyingMount::1:0:20510,32216,35101,35131", -- Golden Gryphon
	[25471]="500000:15:3:1:FlyingMount::1:0:20510,32216,35101,35131", -- Ebon Gryphon
	[25472]="500000:15:3:1:FlyingMount::1:0:20510,32216,35101,35131", -- Snowy Gryphon
	[25473]="1000000:15:4:1:FlyingMount::1:0:20510,32216,35101,35131", -- Swift Blue Gryphon
	[25474]="500000:15:3:1:FlyingMount::1:0:20494,32216,35099,35132", -- Tawny Wind Rider
	[25475]="500000:15:3:1:FlyingMount::1:0:20494,32216,35099,35132", -- Blue Wind Rider
	[25476]="500000:15:3:1:FlyingMount::1:0:20494,32216,35099,35132", -- Green Wind Rider
	[25477]="1000000:15:4:1:FlyingMount::1:0:20494,32216,35099,35132", -- Swift Red Wind Rider
	[25478]="0:4:2:1:Plate::1:0:", -- Defender's Gauntlets
	[25479]="0:4:2:1:Mail::1:0:", -- Boots of the Earthcaller
	[25480]="0:4:2:1:Cloth::1:0:", -- Wastewalker's Sash
	[25481]="0:4:2:1:Plate::1:0:", -- Sunstrider's Gauntlets
	[25482]="0:4:2:1:Mail::1:0:", -- Venn'ren's Boots
	[25483]="0:4:2:1:Cloth::1:0:", -- Fine Sash
	[25484]="0:4:2:1:Amulet::1:0:", -- Telhamat Pendant
	[25485]="0:4:2:1:Ring::1:0:", -- Amaan's Signet
	[25486]="0:4:2:1:Leather::1:0:", -- Demonslayer's Wristguards
	[25487]="0:4:2:1:Amulet::1:0:", -- Wind Dancer's Pendant
	[25488]="0:4:2:1:Ring::1:0:", -- Signet of Aeranas
	[25489]="0:4:2:1:Cloak::1:0:", -- Windtalker's Cloak
	[25490]="0:13:1:1:::1:0:", -- Boulderfist Key
	[25491]="0:12:1:1:::1:0:", -- Salvaged Spore Sacs
	[25492]="0:2:2:1:OneHandMace::1:0:", -- Earthcaller's Mace
	[25494]="0:2:2:1:Stave::1:0:", -- Totemic Staff
	[25495]="0:2:2:1:Dagger::1:0:", -- Wolfrider's Dagger
	[25496]="0:2:2:1:Bow::1:0:", -- Mag'har Bow
	[25498]="0:15:1:5:CombatPet::1:0:", -- Rough Stone Statue
	[25499]="0:4:2:1:Ring::1:0:", -- Felblood Band
	[25500]="0:4:2:1:Amulet::1:0:", -- Felforce Medallion
	[25501]="0:4:2:1:Cloak::1:0:", -- Lost Anchorite's Cloak
	[25502]="0:4:2:1:Plate::1:0:", -- Lightbearer's Gauntlets
	[25503]="0:4:2:1:Cloth::1:0:", -- Flamehandler's Gloves
	[25504]="0:4:2:1:Leather::1:0:", -- Pilgrim's Belt
	[25505]="0:4:2:1:Ring::1:0:", -- Carinda's Wedding Band
	[25506]="0:4:2:1:Mail::1:0:", -- Vindicator's Chain Helm
	[25507]="0:4:2:1:Leather::1:0:", -- Leggings of Telhamat
	[25508]="0:4:2:1:Leather::1:0:", -- Omenai Vest
	[25509]="0:13:1:1:::1:0:", -- Northwind Cleft Key
	[25510]="0:4:2:1:Cloth::1:0:", -- Ceremonial Robes
	[25511]="0:4:2:1:Plate::1:0:", -- Thunderforge Leggings
	[25512]="0:4:2:1:Mail::1:0:", -- Tribal Hauberk
	[25513]="0:4:2:1:Leather::1:0:", -- Clefthoof Hide Mask
	[25514]="0:4:2:1:Mail::1:0:", -- Ikeyen's Pauldrons
	[25515]="0:4:2:1:Leather::1:0:", -- Mud Encrusted Boots
	[25516]="0:4:2:1:Cloth::1:0:", -- Ikeyen's Boots
	[25517]="0:4:2:1:Amulet::1:0:", -- Preserver's Medallion
	[25518]="0:4:2:1:Leather::1:0:", -- Explorer's Leggings
	[25519]="0:2:2:1:OneHandMace::1:0:", -- Warden's Hammer
	[25521]="0:0:1:20:EnhTemp::1:0:", -- Greater Rune of Warding
	[25522]="0:4:2:1:Plate::1:0:", -- Marshstrider's Spaulders
	[25523]="0:4:2:1:Mail::1:0:", -- Windcaller's Gauntlets
	[25524]="0:4:2:1:Leather::1:0:", -- Cenarion Expedition Boots
	[25525]="0:4:2:1:Cloth::1:0:", -- Zangar Epaulets
	[25526]="60000:9:1:1:Blacksmithing::1:0:17904", -- Plans: Greater Rune of Warding
	[25527]="1000000:15:4:1:FlyingMount::1:0:20510,32216,35101,35131", -- Swift Red Gryphon
	[25528]="1000000:15:4:1:FlyingMount::1:0:20510,32216,35101,35131", -- Swift Green Gryphon
	[25529]="1000000:15:4:1:FlyingMount::1:0:20510,32216,35101,35131", -- Swift Purple Gryphon
	[25530]="0:4:2:1:Plate::1:0:", -- Helm of Natural Purity
	[25531]="1000000:15:4:1:FlyingMount::1:0:20494,32216,35099,35132", -- Swift Green Wind Rider
	[25532]="1000000:15:4:1:FlyingMount::1:0:20494,32216,35099,35132", -- Swift Yellow Wind Rider
	[25533]="1000000:15:4:1:FlyingMount::1:0:20494,32216,35099,35132", -- Swift Purple Wind Rider
	[25534]="0:4:2:1:Mail::1:0:", -- Marsh Survivalist's Belt
	[25535]="0:15:3:1:Companion::1:0:", -- Netherwhelp's Collar
	[25536]="0:2:3:1:OneHandMace::1:0:", -- Sporeggar Smasher
	[25537]="0:2:3:1:TwoHandAxe::1:0:", -- Hewing Axe of the Marsh
	[25538]="0:2:3:1:FistWeapon::1:0:", -- Sporeling Claw
	[25539]="0:0:1:1:Elixir::1:0:", -- Potion of Water Breathing
	[25540]="0:4:3:1:Cloak::1:0:", -- Dark Cloak of the Marsh
	[25541]="0:4:3:1:Ring::1:0:", -- Cenarion Ring of Casting
	[25542]="0:4:2:1:Ring::1:0:", -- Lucky Circle of the Fool
	[25543]="0:2:2:1:Dagger::1:0:", -- Talbuk Sticker
	[25544]="0:2:2:1:Gun::1:0:", -- Zerid's Vintage Musket
	[25545]="0:2:2:1:Dagger::1:0:", -- Talbuk Dirk
	[25548]="0:0:1:5:Other::1:0:18382", -- Tallstalk Mushroom
	[25549]="0:4:1:1:Tabard::1:0:", -- Blood Knight Tabard
	[25550]="0:0:1:5:Other::1:0:18382", -- Redcap Toadstool
	[25552]="0:15:1:1:Junk::1:0:", -- Warmaul Ogre Banner
	[25553]="0:2:1:1:Stave::1:0:", -- Exodar Staff
	[25554]="0:12:1:20:::1:0:", -- Kil'sorrow Armaments
	[25555]="0:15:1:1:Junk::1:0:", -- Kil'sorrow Banner
	[25556]="0:4:2:1:Mail::1:0:", -- Oversized Ogre Hauberk
	[25557]="0:4:2:1:Plate::1:0:", -- Salvaged Ango'rosh Pauldrons
	[25558]="0:4:2:1:Cloth::1:0:", -- Ango'rosh Souleater's Cowl
	[25559]="0:4:2:1:Leather::1:0:", -- Lo'ap's Tunic of Muck Diving
	[25560]="0:4:2:1:Mail::1:0:", -- Lo'ap's Muck Diving Pads
	[25561]="0:4:2:1:Plate::1:0:", -- Muck-ridden Galoshes
	[25562]="0:4:3:1:Amulet::1:0:", -- Earthen Mark of Razing
	[25563]="0:4:3:1:Amulet::1:0:", -- Earthen Mark of Power
	[25564]="0:4:3:1:Amulet::1:0:", -- Earthen Mark of Health
	[25565]="0:4:2:1:Leather::1:0:", -- Spaulders of the Ring
	[25566]="0:4:2:1:Plate::1:0:", -- Judicator's Gauntlets
	[25567]="0:4:2:1:Mail::1:0:", -- Cord of the Ring
	[25568]="0:4:2:1:Mail::1:0:", -- Warcaster's Scaled Leggings
	[25569]="0:4:2:1:Plate::1:0:", -- Murkblood Avenger's Chestplate
	[25570]="0:4:2:1:Leather::1:0:", -- Melia's Lustrous Crown
	[25574]="0:4:2:1:Cloth::1:0:", -- Greenkeeper's Pantaloons
	[25575]="0:4:2:1:Mail::1:0:", -- Thunderbringer's Guard
	[25576]="0:4:2:1:Leather::1:0:", -- Smuggler's Mitts
	[25577]="0:4:2:1:Cloth::1:0:", -- Greenblood Pantaloons
	[25578]="0:4:2:1:Leather::1:0:", -- Caustic Feelers
	[25579]="0:4:2:1:Mail::1:0:", -- Dark Shaman's Cover
	[25583]="0:4:2:1:Leather::1:0:", -- Eighty Silver Links
	[25584]="0:4:2:1:Mail::1:0:", -- Murkblood Oven Mitts
	[25585]="0:4:2:1:Plate::1:0:", -- Murkblood Avenger's Legplates
	[25586]="0:12:1:1:::1:0:", -- Burning Blade Peace Offering
	[25589]="0:4:2:1:Plate::1:0:", -- Clefthoof Helm
	[25590]="0:12:1:1:::1:0:", -- Head of Cho'war
	[25591]="0:4:2:1:Leather::1:0:", -- Clefthoof Gloves
	[25592]="0:4:2:1:Mail::1:0:", -- Clefthoof Wristguards
	[25593]="0:4:2:1:Plate::1:0:", -- Windroc Greaves
	[25594]="0:4:2:1:Mail::1:0:", -- Windroc Boots
	[25595]="0:4:2:1:Cloth::1:0:", -- Windroc Shroud
	[25596]="0:15:5:1:FlyingMount::1:0:", -- Peep's Whistle
	[25597]="0:4:2:1:Plate::1:0:", -- Vindicator's Cinch
	[25598]="0:4:2:1:Mail::1:0:", -- Fen Strider's Bracer
	[25599]="0:4:2:1:Leather::1:0:", -- Explorer's Bands
	[25600]="0:4:2:1:Leather::1:0:", -- Bog Walker's Bands
	[25601]="0:4:2:1:Mail::1:0:", -- Murk-Darkened Bracers
	[25602]="0:4:2:1:Plate::1:0:", -- Bog Walker's Belt
	[25603]="0:2:3:1:Polearm::1:0:", -- Lantresor's Warblade
	[25604]="0:13:1:20:::1:0:", -- Warmaul Prison Key
	[25605]="0:4:3:1:Leather::1:0:", -- Burning Blade Devotee's Cinch
	[25606]="0:4:3:1:Ring::1:0:", -- Burning Blade Cultist Band
	[25607]="0:4:3:1:Ring::1:0:", -- Burning Blade Cultist Band
	[25608]="0:2:3:1:Polearm::1:0:", -- Lantresor's Warblade
	[25609]="0:4:3:1:Leather::1:0:", -- Burning Blade Devotee's Cinch
	[25610]="0:4:2:1:Plate::1:0:", -- Fen Strider's Footguards
	[25611]="0:4:2:1:Cloth::1:0:", -- The Witch Doctor's Wraps
	[25612]="0:4:2:1:Mail::1:0:", -- Daggerfen Mail
	[25613]="0:4:2:1:Cloth::1:0:", -- Feralfen Mystic's Handwraps
	[25614]="0:4:2:1:Mail::1:0:", -- Feralfen Beastmaster's Hauberk
	[25615]="0:4:2:1:Plate::1:0:", -- Feralfen Champion's Boots
	[25616]="0:4:2:1:Leather::1:0:", -- Tim's Trusty Helmet
	[25617]="0:4:2:1:Leather::1:0:", -- Captain Krosh's Crash Helmet
	[25618]="0:4:2:1:Cloak::1:0:", -- Telaar Courier's Cloak
	[25619]="0:4:2:1:Trinket::1:0:", -- Glowing Crystal Insignia
	[25620]="0:4:2:1:Trinket::1:0:", -- Ancient Crystal Talisman
	[25621]="0:4:2:1:Cloak::1:0:", -- Serpent Spirit's Drape
	[25622]="0:2:2:1:Stave::1:0:", -- Staff of the Four Golden Coins
	[25623]="0:4:2:1:Plate::1:0:", -- Bracers of the Battle Cleric
	[25624]="0:4:2:1:Shield::1:0:", -- King's Bulwark
	[25628]="0:4:2:1:Trinket::1:0:", -- Ogre Mauler's Badge
	[25629]="0:2:2:1:Wand::1:0:", -- Ogre Handler's Shooter
	[25630]="0:4:2:1:Cloth::1:0:", -- Ogre Basher's Slippers
	[25631]="0:4:2:1:Cloth::1:0:", -- Boots of the Specialist
	[25632]="0:2:2:1:Wand::1:0:", -- Wand of Happiness
	[25633]="0:4:2:1:Trinket::1:0:", -- Uniting Charm
	[25634]="0:4:2:1:Trinket::1:0:", -- Oshu'gun Relic
	[25636]="0:4:2:1:Cloak::1:0:", -- Talbuk Cape
	[25637]="0:4:2:1:Cloth::1:0:", -- Ethereal Sash
	[25638]="0:12:1:1:::1:0:", -- Eye of Veil Reskk
	[25639]="0:2:3:1:Gun::1:0:", -- Hemet's Elekk Gun
	[25640]="0:2:3:1:Wand::1:0:", -- Nesingwary Safari Stick
	[25642]="0:12:1:1:::1:0:", -- Eye of Veil Shienor
	[25643]="0:4:3:1:Idol::1:0:", -- Harold's Rejuvenating Broach
	[25644]="0:4:3:1:Libram::1:0:", -- Blessed Book of Nagrand
	[25645]="0:4:3:1:Totem::1:0:", -- Totem of the Plains
	[25647]="0:12:1:20:::1:0:", -- Telaar Supply Crate
	[25648]="0:13:1:1:::1:0:", -- Cho'war's Key
	[25649]="0:7:1:20:Leather:165:1:0:", -- Knothide Leather Scraps
	[25650]="0:0:1:10:EnhPerm::1:0:", -- Knothide Armor Kit
	[25651]="0:0:1:10:EnhPerm::1:0:", -- Vindicator's Armor Kit
	[25652]="0:0:1:10:EnhPerm::1:0:", -- Magister's Armor Kit
	[25653]="0:4:3:1:Trinket::1:0:", -- Riding Crop
	[25654]="0:4:2:1:Mail::1:0:", -- Felscale Gloves
	[25655]="0:4:2:1:Mail::1:0:", -- Felscale Boots
	[25656]="0:4:2:1:Mail::1:0:", -- Felscale Pants
	[25657]="0:4:2:1:Mail::1:0:", -- Felscale Breastplate
	[25658]="0:15:1:1:Junk::1:0:", -- Damp Woolen Blanket
	[25659]="0:4:2:1:Mail::1:0:", -- Scaled Draenic Boots
	[25660]="0:4:2:1:Mail::1:0:", -- Scaled Draenic Vest
	[25661]="0:4:2:1:Mail::1:0:", -- Scaled Draenic Gloves
	[25662]="0:4:2:1:Mail::1:0:", -- Scaled Draenic Pants
	[25668]="0:4:2:1:Leather::1:0:", -- Thick Draenic Boots
	[25669]="0:4:2:1:Leather::1:0:", -- Thick Draenic Gloves
	[25670]="0:4:2:1:Leather::1:0:", -- Thick Draenic Pants
	[25671]="0:4:2:1:Leather::1:0:", -- Thick Draenic Vest
	[25672]="0:12:1:10:::1:0:", -- Teromoth Sample
	[25673]="0:4:2:1:Leather::1:0:", -- Wild Draenish Boots
	[25674]="0:4:2:1:Leather::1:0:", -- Wild Draenish Gloves
	[25675]="0:4:2:1:Leather::1:0:", -- Wild Draenish Leggings
	[25676]="0:4:2:1:Leather::1:0:", -- Wild Draenish Vest
	[25679]="0:0:1:10:EnhTemp::1:0:", -- Comfortable Insoles
	[25680]="0:4:3:1:Leather::1:0:", -- Stylin' Purple Hat
	[25681]="0:4:3:1:Mail::1:0:", -- Stylin' Adventure Hat
	[25682]="0:4:3:1:Leather::1:0:", -- Stylin' Jungle Hat
	[25683]="0:4:3:1:Mail::1:0:", -- Stylin' Crimson Hat
	[25685]="0:4:3:1:Leather::1:0:", -- Fel Leather Gloves
	[25686]="0:4:3:1:Leather::1:0:", -- Fel Leather Boots
	[25687]="0:4:3:1:Leather::1:0:", -- Fel Leather Leggings
	[25689]="0:4:3:1:Leather::1:0:", -- Heavy Clefthoof Vest
	[25690]="0:4:3:1:Leather::1:0:", -- Heavy Clefthoof Leggings
	[25691]="0:4:3:1:Leather::1:0:", -- Heavy Clefthoof Boots
	[25692]="0:4:3:1:Mail::1:0:", -- Netherfury Leggings
	[25693]="0:4:3:1:Mail::1:0:", -- Netherfury Boots
	[25694]="0:4:3:1:Mail::1:0:", -- Netherfury Belt
	[25695]="0:4:3:1:Mail::1:0:", -- Felstalker Belt
	[25696]="0:4:3:1:Mail::1:0:", -- Felstalker Breastplate
	[25697]="0:4:3:1:Mail::1:0:", -- Felstalker Bracers
	[25699]="0:7:1:20:Leather:165:1:0:", -- Crystal Infused Leather
	[25700]="0:7:1:20:Leather:165:1:0:", -- Fel Scales
	[25701]="0:4:3:1:Plate::1:0:", -- Breastplate of Retribution
	[25702]="0:4:3:1:Mail::1:0:", -- Scaled Legs of Ruination
	[25703]="0:15:0:20:Junk::1:0:", -- Zhevra Leather
	[25707]="5000:7:1:20:Leather:165:1:1:14846", -- Fel Hide
	[25708]="3000:7:1:20:Leather:165:1:1:14846", -- Thick Clefthoof Leather
	[25710]="0:4:3:1:Leather::1:0:", -- Moonkin Headdress
	[25711]="0:4:3:1:Cloth::1:0:", -- Deadly Borer Leggings
	[25712]="0:4:3:1:Cloak::1:0:", -- Perfectly Balanced Cape
	[25713]="0:4:3:1:Ring::1:0:", -- Holy Healing Band
	[25714]="0:4:3:1:Amulet::1:0:", -- Crimson Pendant of Clarity
	[25715]="0:4:3:1:Plate::1:0:", -- Jade Warrior Pauldrons
	[25716]="0:4:3:1:Mail::1:0:", -- Handguards of Precision
	[25717]="0:4:3:1:Leather::1:0:", -- Sure-Step Boots
	[25718]="0:4:3:1:Cloth::1:0:", -- Mantle of Magical Might
	[25719]="0:12:1:250::165:1:0:", -- Arakkoa Feather
	[25720]="0:9:1:1:Leatherworking::1:0:", -- Pattern: Heavy Knothide Leather
	[25721]="50000:9:1:1:Leatherworking::1:0:19321", -- Pattern: Vindicator's Armor Kit
	[25722]="50000:9:1:1:Leatherworking::1:0:19331", -- Pattern: Magister's Armor Kit
	[25723]="0:15:0:20:Junk::1:0:", -- Bent Antenna
	[25724]="0:15:0:20:Junk::1:0:", -- Ripped Moth Wing
	[25725]="50000:9:1:1:Leatherworking::1:0:18672", -- Pattern: Riding Crop
	[25726]="10000:9:1:1:Leatherworking::1:1:16689,16748", -- Pattern: Comfortable Insoles
	[25727]="0:12:1:1:::1:0:", -- Sealed Box
	[25728]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Stylin' Purple Hat
	[25729]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Stylin' Adventure Hat
	[25730]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Stylin' Jungle Hat
	[25731]="0:9:3:1:Leatherworking::1:0:", -- Pattern: Stylin' Crimson Hat
	[25732]="120000:9:3:1:Leatherworking::1:0:20242,23007", -- Pattern: Fel Leather Gloves
	[25733]="140000:9:3:1:Leatherworking::1:0:20242,23007", -- Pattern: Fel Leather Boots
	[25734]="140000:9:3:1:Leatherworking::1:0:20242,23007", -- Pattern: Fel Leather Leggings
	[25735]="160000:9:3:1:Leatherworking::1:0:17904", -- Pattern: Heavy Clefthoof Vest
	[25736]="140000:9:3:1:Leatherworking::1:0:17904", -- Pattern: Heavy Clefthoof Leggings
	[25737]="140000:9:3:1:Leatherworking::1:0:17904", -- Pattern: Heavy Clefthoof Boots
	[25738]="120000:9:3:1:Leatherworking::1:0:17585", -- Pattern: Felstalker Belt
	[25739]="160000:9:3:1:Leatherworking::1:0:17585", -- Pattern: Felstalker Bracers
	[25740]="160000:9:3:1:Leatherworking::1:0:17585", -- Pattern: Felstalker Breastplate
	[25741]="120000:9:3:1:Leatherworking::1:0:20241", -- Pattern: Netherfury Belt
	[25742]="120000:9:3:1:Leatherworking::1:0:20241", -- Pattern: Netherfury Leggings
	[25743]="120000:9:3:1:Leatherworking::1:0:20241", -- Pattern: Netherfury Boots
	[25744]="0:12:1:200:::1:0:", -- Dampscale Basilisk Eye
	[25745]="0:12:1:30:::1:0:", -- Olemba Seed
	[25746]="0:12:1:1:::1:0:", -- Box of Parts
	[25751]="0:12:1:1:::1:0:", -- The Master Planner's Blueprints
	[25759]="0:2:3:1:OneHandMace::1:0:", -- Mogor's Anointing Club
	[25760]="0:2:3:1:Stave::1:0:", -- Battle Mage's Baton
	[25761]="0:2:3:1:Stave::1:0:", -- Staff of Beasts
	[25762]="0:2:3:1:TwoHandAxe::1:0:", -- Honed Voidaxe
	[25763]="0:2:3:1:Dagger::1:0:", -- Ceremonial Warmaul Blood-blade
	[25764]="0:2:3:1:FistWeapon::1:0:", -- Mag'hari Fury Brand
	[25765]="0:12:1:1:::1:0:", -- Fel Orc Plans
	[25766]="0:15:0:1:Junk::1:0:", -- "Creatures That Owe Sal'salabim Golds"
	[25767]="0:12:1:1:::1:0:", -- Raliq's Debt
	[25768]="0:12:1:1:::1:0:", -- Coosh'coosh's Debt
	[25769]="0:12:1:1:::1:0:", -- Floon's Debt
	[25770]="0:12:1:1:::1:0:", -- Fel Cannon Activator
	[25771]="0:12:1:1:::1:0:", -- Fel Cannon Activator
	[25772]="0:2:3:1:OneHandSword::1:0:", -- Crystalline Kopesh
	[25773]="0:2:3:1:OneHandMace::1:0:", -- Hungering Bone Cudgel
	[25774]="0:2:3:1:Dagger::1:0:", -- Azure Lightblade
	[25775]="0:4:3:1:Ring::1:0:", -- Ogre Slayer's Band
	[25776]="0:4:3:1:Amulet::1:0:", -- Ogre Slayer's Pendant
	[25777]="0:4:3:1:Cloak::1:0:", -- Ogre Slayer's Cover
	[25778]="0:4:2:1:Cloth::1:0:", -- Manacles of Remembrance
	[25779]="0:4:2:1:Ring::1:0:", -- Warmaul Slayer's Band
	[25780]="0:4:2:1:Cloak::1:0:", -- Warmaul Defender's Cloak
	[25781]="0:4:2:1:Plate::1:0:", -- Segmented Breastplate
	[25782]="0:4:2:1:Mail::1:0:", -- Sunstrider Legguards
	[25783]="0:4:2:1:Cloth::1:0:", -- Pilgrim's Cover
	[25784]="0:4:2:1:Amulet::1:0:", -- Imbued Chain
	[25785]="0:4:2:1:Ring::1:0:", -- Adept's Band
	[25786]="0:4:2:1:Trinket::1:0:", -- Hypnotist's Watch
	[25787]="0:4:2:1:Trinket::1:0:", -- Charm of Alacrity
	[25788]="0:4:3:1:Plate::1:0:", -- Dauntless Handguards
	[25789]="0:4:3:1:Mail::1:0:", -- Rune-Engraved Belt
	[25790]="0:4:3:1:Leather::1:0:", -- Expedition Scout's Epaulets
	[25791]="0:4:3:1:Leather::1:0:", -- Gloves of Preservation
	[25792]="0:4:3:1:Cloth::1:0:", -- Curate's Boots
	[25802]="0:12:1:200:::1:0:", -- Dreadfang Venom Sac
	[25803]="0:4:3:1:Amulet::1:0:", -- Medallion of the Valiant Guardian
	[25804]="0:4:3:1:Ring::1:0:", -- Naliko's Revenge
	[25805]="0:4:3:1:Cloak::1:0:", -- Mantle of Vivification
	[25806]="0:2:3:1:Wand::1:0:", -- Nethekurse's Rod of Torment
	[25807]="0:12:1:12:::1:0:", -- Timber Worg Tail
	[25808]="0:2:3:1:Wand::1:0:", -- Rod of Dire Shadows
	[25809]="0:4:3:1:Amulet::1:0:", -- Maimfist's Choker
	[25810]="0:4:3:1:Cloak::1:0:", -- Vicar's Cloak
	[25811]="0:4:3:1:Ring::1:0:", -- Conqueror's Band
	[25812]="0:12:1:12:::1:0:", -- Timber Worg Pelt
	[25813]="0:15:0:20:Junk::1:0:", -- Small Mushroom
	[25814]="0:12:1:1:::1:0:", -- Deathskitter's Fang
	[25815]="0:12:1:1:::1:0:", -- Stonegazer's Blood
	[25817]="0:12:1:1:::1:0:", -- Blessed Vial
	[25819]="0:4:3:1:Plate::1:0:", -- Breastplate of the Warbringer
	[25820]="0:4:3:1:Mail::1:0:", -- Metallic Headband of Simm'onz
	[25821]="0:4:3:1:Leather::1:0:", -- Leggings of Unending Assault
	[25822]="0:4:3:1:Cloth::1:0:", -- Watcher's Tunic
	[25823]="347318:2:3:1:OneHandAxe::1:0:17585", -- Grunt's Waraxe
	[25824]="114780:4:3:1:Ring::1:0:17585", -- Farseer's Band
	[25825]="349801:2:3:1:OneHandSword::1:0:17657", -- Footman's Longsword
	[25826]="114780:4:3:1:Ring::1:0:17657", -- Sage's Band
	[25827]="0:4:3:1:Cloak::1:0:18382", -- Muck-Covered Drape
	[25828]="0:4:3:1:Shield::1:0:18382", -- Petrified Lichen Guard
	[25829]="0:4:4:1:Trinket::1:0:", -- Talisman of the Alliance
	[25830]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Leather Helm
	[25831]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Leather Tunic
	[25832]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Leather Spaulders
	[25833]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Leather Legguards
	[25834]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Leather Gloves
	[25835]="447982:2:3:1:Stave::1:0:17904", -- Explorer's Walking Stick
	[25836]="359704:2:3:1:OneHandMace::1:0:17904", -- Preserver's Cudgel
	[25837]="0:12:1:1:::1:0:", -- Ironjaw's Pelt
	[25838]="181153:4:3:1:Leather::1:0:17904", -- Warden's Hauberk
	[25841]="0:12:1:10:::1:0:", -- Draenei Vessel
	[25842]="0:12:1:20:::1:0:", -- Restless Bones
	[25843]="0:7:1:1:Enchanting:333:1:0:", -- Fel Iron Rod
	[25844]="0:7:1:1:Enchanting:333:1:0:", -- Adamantite Rod
	[25845]="0:7:1:1:Enchanting:333:1:0:", -- Eternium Rod
	[25846]="40000:9:1:1:Blacksmithing::1:1:19662", -- Plans: Adamantite Rod
	[25847]="120000:9:1:1:Blacksmithing::1:1:16583,19373", -- Plans: Eternium Rod
	[25848]="100000:9:1:1:Enchanting::1:0:18960,19004", -- Formula: Runed Adamantite Rod
	[25849]="120000:9:1:1:Enchanting::1:1:19663", -- Formula: Runed Eternium Rod
	[25850]="0:12:1:6:::1:0:", -- Tuurem Artifact
	[25852]="0:12:1:1:::1:0:", -- Tail Feather of Torgos
	[25853]="0:15:1:1:Junk::1:0:", -- Pack of Incendiary Bombs
	[25854]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Silk Amice
	[25855]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Silk Cowl
	[25856]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Silk Raiment
	[25857]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Silk Handguards
	[25858]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Silk Trousers
	[25861]="15:2:1:1:Thrown::1:0:151,152,491,829,1250,1285,1682,1685,1691,2115,2134,2140,3072,3076,3158,3164,3186,3313,3409,3481,3587,3608,4170,4182,4203,4235,4241,4592,5120,8362,15287,16187,16191,16259,16260,16444,16732,16920,17421,17446,17489,18810,32253", -- Crude Throwing Axe
	[25862]="0:12:1:1:::1:0:", -- Marshberry
	[25863]="0:12:1:1:::1:0:", -- Olemba Root
	[25864]="0:12:1:1:::1:0:", -- Telaari Frond
	[25865]="0:12:1:1:::1:0:", -- Dragonspine
	[25866]="0:15:1:1:Junk::1:0:", -- Greatmother's List of Herbs
	[25867]="0:3:3:20:GemMeta:171,755:1:0:", -- Earthstorm Diamond
	[25868]="0:3:3:20:GemMeta:171,755:1:0:", -- Skyfire Diamond
	[25869]="80000:9:1:1:Alchemy::1:0:17904", -- Recipe: Transmute Earthstorm Diamond
	[25870]="80000:9:1:1:Alchemy::1:0:17657", -- Recipe: Transmute Skyfire Diamond
	[25872]="30:2:1:1:Thrown::1:0:151,491,791,1250,1285,1682,1685,1691,2134,2140,3076,3164,3186,3313,3409,3481,3498,3608,4082,4084,4170,4182,4203,4235,4241,4555,4592,5120,7942,8362,12027,12960,16187,16191,16259,16260,16444,16732,17421,17446,17489,18810,18811", -- Balanced Throwing Dagger
	[25873]="75:2:1:1:Thrown::1:0:227,734,791,1149,1285,1448,1452,2084,2401,2803,2806,2808,2820,2908,3313,3350,3409,3498,3541,3625,3962,4082,4084,4170,4203,4235,4241,4555,4592,4876,4896,5101,5120,5134,7942,8139,8362,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16732,17489,18811", -- Keen Throwing Knife
	[25874]="0:2:1:1:Thrown::1:0:", -- Large Throwing Knife
	[25875]="200:2:1:1:Thrown::1:0:227,734,1149,1285,1448,1452,2084,2401,2803,2806,2808,2820,2908,3313,3350,3409,3541,3625,3962,4170,4203,4235,4241,4555,4592,4876,4896,5101,5120,5134,7942,8139,8362,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16732,17489,32253", -- Deadly Throwing Axe
	[25876]="800:2:1:1:Thrown::1:0:734,1149,1285,2084,2401,2803,2806,2808,2820,2908,3313,3350,3409,3541,3625,4170,4203,4235,4241,4555,4592,4896,5101,5120,5134,7942,8139,8362,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16732,32253", -- Gleaming Throwing Axe
	[25878]="0:2:2:1:Thrown::1:0:", -- Dusksteel Throwing Knife
	[25880]="0:15:1:5:CombatPet::1:0:", -- Coarse Stone Statue
	[25881]="0:15:1:5:CombatPet::1:0:", -- Heavy Stone Statue
	[25882]="0:15:1:5:CombatPet::1:0:", -- Solid Stone Statue
	[25883]="0:15:1:5:CombatPet::1:0:", -- Dense Stone Statue
	[25886]="0:0:1:20:Other::1:0:", -- Purple Smoke Flare
	[25887]="0:9:2:1:Engineering::1:0:", -- Schematic: Purple Smoke Flare
	[25889]="0:12:1:1:::1:0:", -- Draenei Holy Water
	[25890]="0:3:3:1:GemMeta::1:0:", -- Destructive Skyfire Diamond
	[25891]="0:12:1:10:::1:0:", -- Pristine Shimmerscale Eel
	[25893]="0:3:3:1:GemMeta::1:0:", -- Mystical Skyfire Diamond
	[25894]="0:3:3:1:GemMeta::1:0:", -- Swift Skyfire Diamond
	[25895]="0:3:3:1:GemMeta::1:0:", -- Enigmatic Skyfire Diamond
	[25896]="0:3:3:1:GemMeta::1:0:", -- Powerful Earthstorm Diamond
	[25897]="0:3:3:1:GemMeta::1:0:", -- Bracing Earthstorm Diamond
	[25898]="0:3:3:1:GemMeta::1:0:", -- Tenacious Earthstorm Diamond
	[25899]="0:3:3:1:GemMeta::1:0:", -- Brutal Earthstorm Diamond
	[25900]="22000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Demonic Frenzy
	[25901]="0:3:3:1:GemMeta::1:0:", -- Insightful Earthstorm Diamond
	[25902]="120000:9:1:1:Jewelcrafting::1:0:17518", -- Design: Powerful Earthstorm Diamond
	[25903]="120000:9:1:1:Jewelcrafting::1:0:17518", -- Design: Bracing Earthstorm Diamond
	[25904]="120000:9:1:1:Jewelcrafting::1:0:21432", -- Design: Insightful Earthstorm Diamond
	[25905]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Tenacious Earthstorm Diamond
	[25906]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Brutal Earthstorm Diamond
	[25907]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Destructive Skyfire Diamond
	[25908]="120000:9:1:1:Jewelcrafting::1:0:20242,23007", -- Design: Swift Skyfire Diamond
	[25909]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Mystical Skyfire Diamond
	[25910]="120000:9:1:1:Jewelcrafting::1:0:21643", -- Design: Enigmatic Skyfire Diamond
	[25911]="0:12:1:10:::1:0:", -- Salvaged Wood
	[25912]="0:12:1:10:::1:0:", -- Salvaged Metal
	[25913]="0:4:2:1:Ring::1:0:", -- Ring of the Slain Anchorite
	[25914]="0:4:2:1:Amulet::1:0:", -- Broken Choker
	[25915]="0:2:2:1:OneHandSword::1:0:", -- Fallen Vindicator's Blade
	[25916]="0:2:2:1:OneHandAxe::1:0:", -- Terokkar Axe
	[25917]="0:2:2:1:Stave::1:0:", -- Healer's Staff of the Forest
	[25918]="0:2:2:1:Dagger::1:0:", -- Blood-Guided Knife
	[25919]="0:4:2:1:Amulet::1:0:", -- Sedai's Necklace
	[25920]="0:2:2:1:OneHandSword::1:0:", -- Sedai's Blade
	[25921]="0:4:2:1:Ring::1:0:", -- Sedai's Ring
	[25922]="0:4:2:1:Plate::1:0:", -- Fearless Girdle
	[25923]="0:4:2:1:Mail::1:0:", -- Fierce Mantle
	[25924]="0:4:2:1:Leather::1:0:", -- Swamprunner's Boots
	[25925]="0:4:2:1:Cloth::1:0:", -- Terrorcloth Mantle
	[25926]="0:4:2:1:Ring::1:0:", -- Nexus-Stalker's Band
	[25927]="0:4:2:1:Cloak::1:0:", -- Consortium Cloak of the Quick
	[25928]="0:4:2:1:Amulet::1:0:", -- Ethereal Healing Pendant
	[25929]="0:4:2:1:Plate::1:0:", -- Cenarion Thicket Legplates
	[25930]="0:4:2:1:Mail::1:0:", -- Cenarion Thicket Helm
	[25931]="0:4:2:1:Cloth::1:0:", -- Cenarion Thicket Circlet
	[25932]="0:4:2:1:Leather::1:0:", -- Cenarion Thicket Jerkin
	[25933]="0:2:2:1:OneHandSword::1:0:", -- Extra Sharp Blade
	[25934]="0:2:2:1:TwoHandMace::1:0:", -- Spiked Destroyer
	[25935]="0:2:2:1:Stave::1:0:", -- Invincible Stave
	[25936]="0:4:2:1:Trinket::1:0:", -- Terokkar Tablet of Vim
	[25937]="0:4:2:1:Trinket::1:0:", -- Terokkar Tablet of Precision
	[25938]="0:12:1:1:::1:0:", -- Mysteries of the Light
	[25939]="0:2:3:1:Wand::1:0:", -- Voidfire Wand
	[25940]="0:4:3:1:Idol::1:0:", -- Idol of the Claw
	[25941]="0:4:3:1:Mail::1:0:", -- Boots of the Outlander
	[25942]="0:4:3:1:Plate::1:0:", -- Faith Bearer's Gauntlets
	[25943]="0:2:3:1:FistWeapon::1:0:", -- Creepjacker
	[25944]="0:2:3:1:TwoHandSword::1:0:", -- Shaarde the Greater
	[25945]="0:4:3:1:Cloak::1:0:", -- Cloak of Revival
	[25946]="0:4:3:1:Leather::1:0:", -- Nethershade Boots
	[25947]="0:4:3:1:Mail::1:0:", -- Lightning-Rod Pauldrons
	[25948]="0:4:2:1:Plate::1:0:", -- Girdle of the Penitent
	[25949]="0:4:2:1:Leather::1:0:", -- Gloves of the Afterlife
	[25950]="0:2:3:1:Stave::1:0:", -- Staff of Polarities
	[25951]="0:4:2:1:Mail::1:0:", -- Fleet Refugee's Boots
	[25952]="0:2:3:1:OneHandSword::1:0:", -- Scimitar of the Nexus-Stalkers
	[25953]="0:2:3:1:Bow::1:0:", -- Ethereal Warp-Bow
	[25954]="0:4:3:1:Amulet::1:0:", -- Sigil of Shaffar
	[25955]="0:4:3:1:Mail::1:0:", -- Mask of the Howling Storm
	[25956]="0:4:3:1:Plate::1:0:", -- Nexus-Bracers of Vigor
	[25957]="0:4:3:1:Cloth::1:0:", -- Ethereal Boots of the Skystrider
	[25958]="0:4:2:1:Plate::1:0:", -- Eagle Engraved Bracers
	[25959]="0:4:2:1:Mail::1:0:", -- Feathered Armbands
	[25960]="0:4:2:1:Leather::1:0:", -- Talonstalker Bracers
	[25961]="0:4:2:1:Cloth::1:0:", -- Feathered Wrist Cuffs
	[25962]="0:4:3:1:Ring::1:0:", -- Longstrider's Loop
	[25963]="0:4:2:1:Ring::1:0:", -- Kokorek's Signet
	[25964]="0:2:3:1:OneHandSword::1:0:", -- Shaarde the Lesser
	[25965]="0:4:2:1:Cloak::1:0:", -- Cloak of Grasping Talons
	[25966]="0:4:2:1:Cloak::1:0:", -- Arakkoa Sage's Shawl
	[25971]="0:2:2:1:Bow::1:0:", -- Stout Oak Longbow
	[25972]="0:2:2:1:Gun::1:0:", -- Deadeye's Piece
	[25973]="0:2:2:1:Wand::1:0:", -- Dark Augur's Wand
	[25974]="0:4:2:1:Cloth::1:0:", -- Helm of Lupine Cunning
	[25975]="0:4:2:1:Leather::1:0:", -- Wolf Hunter's Guise
	[25976]="0:4:2:1:Mail::1:0:", -- Helm of Lupine Grace
	[25977]="0:4:2:1:Plate::1:0:", -- Helm of Lupine Ferocity
	[25978]="0:2:2:1:FishingPole::1:0:", -- Seth's Graphite Fishing Pole
	[25979]="0:4:2:1:Plate::1:0:", -- Flintlocke's Piloting Pants
	[25980]="0:4:2:1:Mail::1:0:", -- Aerodynamic Scaled Vest
	[25981]="0:4:2:1:Leather::1:0:", -- Dirigible Crash Helmet
	[25982]="0:4:2:1:Cloth::1:0:", -- Foreman's Sash
	[25983]="0:4:2:1:Mail::1:0:", -- Heavy Miner's Belt
	[25984]="0:4:2:1:Leather::1:0:", -- Miner's Brace
	[25985]="0:2:2:1:Stave::1:0:", -- Cenarion Naturalist's Staff
	[25986]="0:2:2:1:TwoHandMace::1:0:", -- Dreadtusk's Fury
	[25987]="0:2:2:1:TwoHandSword::1:0:", -- Helboar Carving Blade
	[25989]="0:4:2:1:Amulet::1:0:", -- Draenethyst Chaplet
	[25992]="0:4:2:1:Amulet::1:0:", -- Enforcer's Chain
	[25993]="0:4:2:1:Amulet::1:0:", -- Finely Wrought Chain
	[25997]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Linked Armor
	[25998]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Linked Helm
	[25999]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Linked Spaulders
	[26000]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Linked Gauntlets
	[26001]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Linked Leggings
	[26002]="0:12:1:1:::1:0:", -- Flaming Torch
	[26004]="0:4:2:1:Cloth::1:0:", -- Farmhand's Vest
	[26005]="0:4:2:1:Cloth::1:0:", -- Jessera's Fungus Lined Tunic
	[26006]="0:4:2:1:Cloth::1:0:", -- Crystal-Flecked Pants
	[26007]="0:4:2:1:Cloth::1:0:", -- Vindicator's Woolies
	[26008]="0:4:2:1:Cloth::1:0:", -- Scholar's Gloves
	[26009]="0:4:2:1:Cloth::1:0:", -- Flutterer Silk Handwraps
	[26010]="0:4:2:1:Cloth::1:0:", -- Vindicator's Soft Sole Slippers
	[26011]="0:4:2:1:Cloth::1:0:", -- Cryo-Core Attendant's Boots
	[26012]="0:4:2:1:Cloth::1:0:", -- Kessel's Cinch Wrap
	[26013]="0:4:2:1:Cloth::1:0:", -- Cincture of Woven Reeds
	[26014]="0:4:2:1:Cloth::1:0:", -- Jessera's Fungus Lined Cuffs
	[26016]="0:4:2:1:Cloak::1:0:", -- Surveyor's Mantle
	[26017]="0:4:2:1:Cloak::1:0:", -- Venomous Silk Cover
	[26018]="0:4:2:1:Leather::1:0:", -- Elekk Handler's Leathers
	[26019]="0:4:2:1:Leather::1:0:", -- Jessera's Fungus Lined Vest
	[26020]="0:4:2:1:Leather::1:0:", -- Shard-Covered Leggings
	[26021]="0:4:2:1:Leather::1:0:", -- Vindicator's Leather Chaps
	[26022]="0:4:2:1:Leather::1:0:", -- Researcher's Gloves
	[26023]="0:4:2:1:Leather::1:0:", -- Ravager Hide Gloves
	[26024]="0:4:2:1:Leather::1:0:", -- Vindicator's Leather Moccasins
	[26025]="0:4:2:1:Leather::1:0:", -- Technician's Boots
	[26026]="0:4:2:1:Leather::1:0:", -- Ornately Tooled Belt
	[26027]="0:4:2:1:Leather::1:0:", -- Kessel's Sweat Stained Elekk Leash
	[26028]="0:4:2:1:Leather::1:0:", -- Jessera's Fungus Lined Bands
	[26030]="0:4:2:1:Mail::1:0:", -- Jessera's Fungus Lined Hauberk
	[26031]="0:4:2:1:Mail::1:0:", -- Elekk Rider's Mail
	[26032]="0:4:2:1:Mail::1:0:", -- Crystal-Studded Legguards
	[26033]="0:4:2:1:Mail::1:0:", -- Vindicator's Iron Legguards
	[26034]="0:4:2:1:Mail::1:0:", -- Protective Field Gloves
	[26035]="0:4:2:1:Mail::1:0:", -- Corin's Handguards
	[26036]="0:4:2:1:Mail::1:0:", -- Vindicator's Stompers
	[26037]="0:4:2:1:Mail::1:0:", -- Lightweight Mesh Boots
	[26038]="0:4:2:1:Mail::1:0:", -- Segmented Girdle
	[26039]="0:4:2:1:Mail::1:0:", -- Kessel's Sturdy Riding Handle
	[26040]="0:4:2:1:Mail::1:0:", -- Jessera's Fungus Lined Bracers
	[26042]="0:15:1:100:Junk::1:0:", -- Oshu'gun Crystal Powder Sample
	[26043]="0:15:1:100:Junk::1:0:", -- Oshu'gun Crystal Powder Sample
	[26044]="0:15:2:100:Junk::1:0:", -- Halaa Research Token
	[26045]="0:15:2:100:Junk::1:0:", -- Halaa Battle Token
	[26048]="0:12:1:1:::1:0:", -- Letter to Kialon
	[26049]="0:2:2:1:OneHandMace::1:0:", -- Old Elekk Prod
	[26050]="0:2:2:1:OneHandMace::1:0:", -- Fist of Argus
	[26051]="0:2:2:1:TwoHandMace::1:0:", -- 2 Stone Sledgehammer
	[26052]="0:2:2:1:TwoHandMace::1:0:", -- Vindicator's Smasher
	[26053]="0:2:2:1:OneHandSword::1:0:", -- Elekk Handler's Blade
	[26054]="0:2:2:1:OneHandSword::1:0:", -- Blade of Argus
	[26055]="0:4:3:1:Trinket::1:0:", -- Oculus of the Hidden Eye
	[27317]="0:0:1:1:Consumable::1:0:", -- Elemental Sapta
	[27388]="0:0:3:1:Consumable::1:0:", -- Mr. Pinchy
	[27389]="0:2:2:1:TwoHandSword::1:0:", -- Surplus Bastard Sword
	[27390]="0:2:2:1:TwoHandSword::1:0:", -- Vindicator's Letter Opener
	[27398]="0:4:2:1:OffHandFrill::1:0:", -- Carved Crystalline Orb
	[27399]="0:4:2:1:Shield::1:0:", -- Stillpine Defender
	[27400]="0:4:2:1:Shield::1:0:", -- Peacekeeper's Buckler
	[27401]="0:2:2:1:Crossbow::1:0:", -- Arugoo's Crossbow of Destruction
	[27402]="0:2:2:1:Crossbow::1:0:", -- Huntsman's Crossbow
	[27403]="0:2:2:1:Wand::1:0:", -- Stillpine Stinger
	[27404]="0:2:2:1:Wand::1:0:", -- Lightspark
	[27408]="0:4:3:1:Plate::1:0:", -- Hope Bearer Helm
	[27409]="0:4:3:1:Leather::1:0:", -- Raven-Heart Headdress
	[27410]="0:4:3:1:Cloth::1:0:", -- Collar of Command
	[27411]="0:4:3:1:Cloth::1:0:", -- Slippers of Serenity
	[27412]="0:2:3:1:Stave::1:0:", -- Ironstaff of Regeneration
	[27413]="0:4:3:1:Ring::1:0:", -- Ring of the Exarchs
	[27414]="0:4:3:1:Mail::1:0:", -- Mok'Nathal Beast-Mask
	[27415]="0:4:3:1:Leather::1:0:", -- Darkguard Face Mask
	[27416]="0:4:3:1:Trinket::1:0:", -- Fetish of the Fallen
	[27417]="0:4:3:1:Leather::1:0:", -- Ravenwing Pauldrons
	[27418]="0:4:3:1:Cloth::1:0:", -- Stormreaver Shadow-Kilt
	[27420]="0:4:3:1:Plate::1:0:", -- Uther's Ceremonial Warboots
	[27422]="0:7:1:20:Meat:185:1:0:", -- Barbed Gill Trout
	[27423]="0:4:3:1:Cloak::1:0:", -- Cloak of Impulsiveness
	[27424]="0:2:3:1:OneHandAxe::1:0:", -- Amani Venom-Axe
	[27425]="0:7:1:20:Meat:185:1:0:", -- Spotted Feltail
	[27426]="0:2:3:1:OneHandMace::1:0:", -- Northshire Battlemace
	[27427]="0:4:3:1:Plate::1:0:", -- Durotan's Battle Harness
	[27428]="0:4:3:1:Mail::1:0:", -- Stormfront Gauntlets
	[27429]="0:7:1:20:Meat:185:1:0:", -- Zangarian Sporefish
	[27430]="0:4:3:1:Mail::1:0:", -- Scaled Greaves of Patience
	[27431]="0:2:3:1:Dagger::1:0:", -- Time-Shifted Dagger
	[27432]="0:4:3:1:Ring::1:0:", -- Broxigar's Ring of Valor
	[27433]="0:4:3:1:Cloth::1:0:", -- Pauldrons of Sufferance
	[27434]="0:4:3:1:Leather::1:0:", -- Mantle of Perenolde
	[27435]="0:7:1:20:Meat:185:1:0:", -- Figluster's Mudfish
	[27436]="0:4:3:1:Ring::1:0:", -- Iron Band of the Unbreakable
	[27437]="0:7:1:20:Meat:185:1:0:", -- Icefin Bluefish
	[27438]="0:7:1:20:Meat:185:1:0:", -- Golden Darter
	[27439]="0:7:1:20:Meat:185:1:0:", -- Furious Crawdad
	[27440]="0:4:3:1:Amulet::1:0:", -- Diamond Prism of Recurrence
	[27441]="0:15:0:20:Junk::1:0:", -- Felblood Snapper
	[27442]="0:15:0:20:Junk::1:0:", -- Goldenscale Vendorfish
	[27443]="0:15:0:20:Junk::1:0:", -- Steam Pump Debris
	[27445]="0:15:1:1:Companion::1:0:", -- Magical Crawdad Box
	[27446]="0:15:3:1:Junk::1:0:", -- Mr. Pinchy's Gift
	[27447]="0:4:3:1:Plate::1:0:", -- Bracers of Just Rewards
	[27448]="0:4:3:1:Cloak::1:0:", -- Cloak of the Everliving
	[27449]="0:4:3:1:Shield::1:0:", -- Blood Knight Defender
	[27450]="0:4:3:1:Mail::1:0:", -- Wild Stalker Boots
	[27451]="0:4:3:1:Cloth::1:0:", -- Boots of the Darkwalker
	[27452]="0:4:3:1:Cloth::1:0:", -- Light Scribe Bands
	[27453]="0:4:3:1:Ring::1:0:", -- Averinn's Ring of Slaying
	[27454]="0:4:3:1:Mail::1:0:", -- Volcanic Pauldrons
	[27455]="0:4:3:1:Plate::1:0:", -- Irondrake Faceguard
	[27456]="0:4:3:1:Leather::1:0:", -- Raiments of Nature's Breath
	[27457]="0:4:3:1:Plate::1:0:", -- Life Bearer's Gauntlets
	[27458]="0:4:3:1:Mail::1:0:", -- Oceansong Kilt
	[27459]="0:4:3:1:Plate::1:0:", -- Vambraces of Daring
	[27460]="0:4:3:1:Ring::1:0:", -- Reavers' Ring
	[27461]="0:4:3:1:Leather::1:0:", -- Chestguard of the Prowler
	[27462]="0:4:3:1:Cloth::1:0:", -- Crimson Bracers of Gloom
	[27463]="0:2:3:1:Dagger::1:0:", -- Terror Flame Dagger
	[27464]="0:4:3:1:Amulet::1:0:", -- Omor's Unyielding Will
	[27465]="0:4:3:1:Cloth::1:0:", -- Mana-Etched Gloves
	[27466]="0:4:3:1:Cloth::1:0:", -- Headdress of Alacrity
	[27467]="0:4:3:1:Leather::1:0:", -- Silent-Strider Kneeboots
	[27468]="0:4:3:1:Leather::1:0:", -- Moonglade Handwraps
	[27469]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Mail Armor
	[27470]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Mail Gauntlets
	[27471]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Mail Helm
	[27472]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Mail Leggings
	[27473]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Mail Spaulders
	[27474]="0:4:3:1:Mail::1:0:", -- Beast Lord Handguards
	[27475]="0:4:3:1:Plate::1:0:", -- Gauntlets of the Bold
	[27476]="0:2:3:1:OneHandMace::1:0:", -- Truncheon of Five Hells
	[27477]="0:4:3:1:OffHandFrill::1:0:", -- Faol's Signet of Cleansing
	[27478]="0:4:3:1:Mail::1:0:", -- Girdle of the Blasted Reaches
	[27479]="0:12:1:1:::1:0:", -- Flaming Torch
	[27480]="0:12:1:20:::1:0:", -- Soul Device
	[27481]="0:15:1:1:Other::1:0:", -- Heavy Supply Crate
	[27483]="0:4:3:1:Leather::1:0:", -- Moon-Touched Bands
	[27484]="0:4:3:1:Libram::1:0:", -- Libram of Avengement
	[27485]="0:4:3:1:Cloak::1:0:", -- Embroidered Cape of Mysteries
	[27487]="0:4:3:1:Plate::1:0:", -- Bloodlord Legplates
	[27488]="0:4:3:1:Cloth::1:0:", -- Mage-Collar of the Firestorm
	[27489]="0:4:3:1:Plate::1:0:", -- Virtue Bearer's Vambraces
	[27490]="0:2:3:1:OneHandAxe::1:0:", -- Firebrand Battleaxe
	[27491]="0:4:3:1:Ring::1:0:", -- Signet of Repose
	[27492]="0:4:3:1:Leather::1:0:", -- Moonchild Leggings
	[27493]="0:4:3:1:Cloth::1:0:", -- Gloves of the Deadwatcher
	[27494]="0:4:3:1:Mail::1:0:", -- Emerald Eye Bracer
	[27495]="0:4:3:1:Amulet::1:0:", -- Soldier's Dog Tags
	[27497]="0:4:3:1:Plate::1:0:", -- Doomplate Gauntlets
	[27498]="500:0:1:20:Scroll::1:1:14847,23363", -- Scroll of Agility V
	[27499]="600:0:1:20:Scroll::1:1:14847", -- Scroll of Intellect V
	[27500]="550:0:1:20:Scroll::1:1:14847", -- Scroll of Protection V
	[27501]="550:0:1:20:Scroll::1:1:14847,23363", -- Scroll of Spirit V
	[27502]="600:0:1:20:Scroll::1:1:14847,23363", -- Scroll of Stamina V
	[27503]="500:0:1:20:Scroll:164:1:1:14847,23363", -- Scroll of Strength V
	[27505]="0:4:3:1:Plate::1:0:", -- Ruby Helm of the Just
	[27506]="0:4:3:1:Cloth::1:0:", -- Robe of Effervescent Light
	[27507]="0:2:3:1:Crossbow::1:0:", -- Adamantine Repeater
	[27508]="0:4:3:1:Cloth::1:0:", -- Incanter's Gloves
	[27509]="0:4:3:1:Leather::1:0:", -- Handgrips of Assassination
	[27510]="0:4:3:1:Mail::1:0:", -- Tidefury Gauntlets
	[27511]="0:7:1:1:Other::1:0:", -- Inscribed Scrollcase
	[27512]="0:2:3:1:OneHandSword::1:0:", -- The Willbreaker
	[27513]="0:7:1:1:Other::1:0:", -- Curious Crate
	[27514]="0:4:3:1:Leather::1:0:", -- Leggings of the Unrepentant
	[27515]="0:4:1:5:OffHandFrill:185:1:0:", -- Huge Spotted Feltail
	[27516]="0:4:1:5:OffHandFrill:185:1:0:", -- Enormous Barbed Gill Trout
	[27517]="0:4:3:1:Cloth::1:0:", -- Bands of Nethekurse
	[27518]="0:4:3:1:Idol::1:0:", -- Ivory Idol of the Moongoddess
	[27519]="0:4:3:1:Cloak::1:0:", -- Cloak of Malice
	[27520]="0:4:3:1:Plate::1:0:", -- Greathelm of the Unbreakable
	[27521]="0:4:3:1:Mail::1:0:", -- Telaari Hunting Girdle
	[27522]="0:4:3:1:Mail::1:0:", -- World's End Bracers
	[27523]="0:4:3:1:Ring::1:0:", -- Exarch's Diamond Band
	[27524]="0:2:3:1:TwoHandMace::1:0:", -- Firemaul of Destruction
	[27525]="0:4:3:1:Cloth::1:0:", -- Jeweled Boots of Sanctification
	[27526]="0:2:3:1:Bow::1:0:", -- Skyfire Hawk-Bow
	[27527]="0:4:3:1:Plate::1:0:", -- Greaves of the Shatterer
	[27528]="0:4:3:1:Mail::1:0:", -- Gauntlets of Desolation
	[27529]="0:4:3:1:Trinket::1:0:", -- Figurine of the Colossus
	[27531]="0:4:3:1:Leather::1:0:", -- Wastewalker Gloves
	[27532]="50000:9:1:1:Fishing::1:0:26947", -- Master Fishing - The Art of Angling
	[27533]="0:2:3:1:FistWeapon::1:0:", -- Demonblood Eviscerator
	[27534]="0:4:3:1:OffHandFrill::1:0:", -- Hortus' Seal of Brilliance
	[27535]="0:4:3:1:Plate::1:0:", -- Gauntlets of the Righteous
	[27536]="0:4:3:1:Cloth::1:0:", -- Hallowed Handwraps
	[27537]="0:4:3:1:Cloth::1:0:", -- Gloves of Oblivion
	[27538]="0:2:3:1:OneHandMace::1:0:", -- Lightsworn Hammer
	[27539]="0:4:3:1:Plate::1:0:", -- Justice Bearer's Pauldrons
	[27540]="0:2:3:1:Wand::1:0:", -- Nexus Torch
	[27541]="0:4:3:1:Mail::1:0:", -- Archery Belt of the Broken
	[27542]="0:4:3:1:Cloth::1:0:", -- Cord of Belief
	[27543]="0:2:3:1:Dagger::1:0:", -- Starlight Dagger
	[27544]="0:4:3:1:Totem::1:0:", -- Totem of Spontaneous Regrowth
	[27545]="0:4:3:1:Leather::1:0:", -- Mennu's Scaled Leggings
	[27546]="0:4:3:1:Amulet::1:0:", -- Traitor's Noose
	[27547]="0:4:3:1:Cloth::1:0:", -- Coldwhisper Cord
	[27548]="0:4:3:1:Plate::1:0:", -- Girdle of Many Blessings
	[27549]="0:4:3:1:Mail::1:0:", -- Wavefury Boots
	[27550]="0:4:3:1:Cloak::1:0:", -- Ironscale War Cloak
	[27551]="0:4:3:1:Amulet::1:0:", -- Skeletal Necklace of Battlerage
	[27552]="0:4:1:1:Leather::1:0:", -- Soft Leather Vest
	[27553]="0:0:1:10:Consumable::1:0:", -- Crimson Steer Energy Drink
	[27631]="0:2:3:1:Thrown::1:0:", -- Needle Shrike
	[27632]="0:12:1:1:::1:0:", -- Terokk's Quill
	[27633]="0:12:1:1:::1:0:", -- Terokk's Mask
	[27634]="0:12:1:1:::1:0:", -- The Saga of Terokk
	[27635]="0:0:1:20:FoodDrink::1:0:", -- Lynx Steak
	[27636]="0:0:1:20:FoodDrink::1:0:", -- Bat Bites
	[27637]="0:4:3:1:Leather::1:0:18821,18822", -- Shadowstalker's Sash
	[27638]="0:4:3:1:Cloth::1:0:18821,18822", -- Hierophant's Sash
	[27639]="0:4:3:1:Plate::1:0:18821,18822", -- Slayer's Waistguard
	[27640]="0:2:2:1:Crossbow::1:0:", -- Hand of Argus Crossfire
	[27641]="0:2:2:1:Stave::1:0:", -- Vindicator's Walking Stick
	[27643]="0:4:3:1:Mail::1:0:18821,18822", -- Stormbreaker's Girdle
	[27644]="0:4:3:1:Plate::1:0:18821,18822", -- Avenger's Waistguard
	[27645]="0:4:3:1:Leather::1:0:18821,18822", -- Dreamstalker Sash
	[27646]="0:4:3:1:Mail::1:0:18821,18822", -- Marksman's Belt
	[27647]="0:4:3:1:Mail::1:0:18821,18822", -- Marksman's Legguards
	[27648]="0:4:3:1:Leather::1:0:18821,18822", -- Dreamstalker Leggings
	[27649]="0:4:3:1:Cloth::1:0:18821,18822", -- Hierophant's Leggings
	[27650]="0:4:3:1:Leather::1:0:18821,18822", -- Shadowstalker's Leggings
	[27651]="0:0:1:20:FoodDrink::1:0:", -- Buzzard Bites
	[27652]="0:4:3:1:Mail::1:0:18821,18822", -- Stormbreaker's Leggings
	[27653]="0:4:3:1:Plate::1:0:18821,18822", -- Slayer's Leggings
	[27654]="0:4:3:1:Plate::1:0:18821,18822", -- Avenger's Legplates
	[27655]="0:0:1:20:FoodDrink::1:0:", -- Ravager Dog
	[27656]="0:0:1:20:FoodDrink::1:0:", -- Sporeling Snack
	[27657]="600:0:1:20:FoodDrink::1:1:24396", -- Blackened Basilisk
	[27658]="0:0:1:20:FoodDrink::1:0:", -- Roasted Clefthoof
	[27659]="0:0:1:20:FoodDrink::1:0:", -- Warp Burger
	[27660]="0:0:1:20:FoodDrink::1:0:", -- Talbuk Steak
	[27661]="0:0:1:20:FoodDrink::1:0:", -- Blackened Trout
	[27662]="0:0:1:20:FoodDrink::1:0:", -- Feltail Delight
	[27663]="0:0:1:20:FoodDrink::1:0:", -- Blackened Sporefish
	[27664]="0:0:1:20:FoodDrink::1:0:", -- Grilled Mudfish
	[27665]="0:0:1:20:FoodDrink::1:0:", -- Poached Bluefish
	[27666]="600:0:1:20:FoodDrink::1:1:24396", -- Golden Fish Sticks
	[27667]="600:0:1:20:FoodDrink::1:1:24396", -- Spicy Crawdad
	[27668]="0:7:1:20:Meat:185:1:0:", -- Lynx Meat
	[27669]="0:7:1:20:Meat:185:1:0:", -- Bat Flesh
	[27671]="0:7:1:20:Meat:185:1:0:", -- Buzzard Meat
	[27672]="0:4:3:1:Plate::1:0:", -- Girdle of the Immovable
	[27673]="0:2:3:1:OneHandSword::1:0:", -- Phosphorescent Blade
	[27674]="0:7:1:20:Meat:185:1:0:", -- Ravager Flesh
	[27676]="0:7:1:20:Meat:185:1:0:", -- Strange Spores
	[27677]="0:7:1:20:Meat:185:1:0:", -- Chunk o' Basilisk
	[27678]="0:7:1:20:Meat:185:1:0:", -- Clefthoof Meat
	[27679]="0:3:4:1:GemYellow::1:0:18821,18822", -- Sublime Mystic Dawnstone
	[27680]="0:1:3:1:Bag::1:0:18821,18822", -- Halaani Bag
	[27681]="0:7:1:20:Meat:185:1:0:", -- Warped Flesh
	[27682]="0:7:1:20:Meat:185:1:0:", -- Talbuk Venison
	[27683]="0:4:3:1:Trinket::1:0:", -- Quagmirran's Eye
	[27684]="0:9:1:1:Cooking::1:0:", -- Recipe: Buzzard Bites
	[27685]="40:9:1:1:Cooking::1:0:16262", -- Recipe: Lynx Steak
	[27686]="0:9:1:1:Cooking::1:0:", -- Recipe: Roasted Moongraze Tenderloin
	[27687]="400:9:1:1:Cooking::1:0:16253", -- Recipe: Bat Bites
	[27688]="20000:9:1:1:Cooking::1:0:16585,16826", -- Recipe: Ravager Dog
	[27689]="0:9:1:1:Cooking::1:0:18382", -- Recipe: Sporeling Snack
	[27690]="30000:9:1:1:Cooking::1:0:18957,19038", -- Recipe: Blackened Basilisk
	[27691]="30000:9:1:1:Cooking::1:0:20096,20097", -- Recipe: Roasted Clefthoof
	[27692]="30000:9:1:1:Cooking::1:0:18957,19038", -- Recipe: Warp Burger
	[27693]="30000:9:1:1:Cooking::1:0:20096,20097", -- Recipe: Talbuk Steak
	[27694]="20000:9:1:1:Cooking::1:0:18015,20028", -- Recipe: Blackened Trout
	[27695]="20000:9:1:1:Cooking::1:0:18011,20028", -- Recipe: Feltail Delight
	[27696]="20000:9:1:1:Cooking::1:0:18911", -- Recipe: Blackened Sporefish
	[27697]="30000:9:1:1:Cooking::1:0:20096,20097", -- Recipe: Grilled Mudfish
	[27698]="30000:9:1:1:Cooking::1:0:20096,20097", -- Recipe: Poached Bluefish
	[27699]="30000:9:1:1:Cooking::1:0:18960,19296", -- Recipe: Golden Fish Sticks
	[27700]="30000:9:1:1:Cooking::1:0:18960,19296", -- Recipe: Spicy Crawdad
	[27702]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Lamellar Chestpiece
	[27703]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Lamellar Gauntlets
	[27704]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Lamellar Helm
	[27705]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Lamellar Legguards
	[27706]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Lamellar Shoulders
	[27707]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Satin Gloves
	[27708]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Satin Hood
	[27709]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Satin Leggings
	[27710]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Satin Mantle
	[27711]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Satin Robe
	[27712]="0:4:3:1:Leather::1:0:", -- Shackles of Quagmirran
	[27713]="0:4:3:1:Mail::1:0:", -- Pauldrons of Desolation
	[27714]="0:4:3:1:OffHandFrill::1:0:", -- Swamplight Lantern
	[27715]="0:4:2:1:Plate::1:0:", -- Circle's Stalwart Helmet
	[27716]="0:4:2:1:Plate::1:0:", -- Refuge Armor
	[27717]="0:4:2:1:Mail::1:0:", -- Expedition Forager Leggings
	[27721]="0:4:2:1:Plate::1:0:", -- Expedition Footgear
	[27722]="0:4:2:1:Mail::1:0:", -- Gloves of Marshmanship
	[27723]="0:4:2:1:Leather::1:0:", -- Belt of the Moonkin
	[27724]="0:4:2:1:Leather::1:0:", -- Wild Shoulderpads
	[27725]="0:4:2:1:Plate::1:0:", -- Expedition Mantle
	[27726]="0:4:2:1:Mail::1:0:", -- Hearty Cenarion Cincture
	[27727]="0:4:2:1:Leather::1:0:", -- Swift Cenarion Footwear
	[27728]="0:4:2:1:Cloth::1:0:", -- Cushy Cenarion Walkers
	[27729]="0:15:0:10:Junk::1:0:", -- Humanoid Skull
	[27730]="0:4:2:1:Cloak::1:0:", -- Watcher's Cloak of Vigilance
	[27731]="0:4:2:1:Cloak::1:0:", -- Vindicator's Cloak
	[27732]="0:4:2:1:Cloak::1:0:", -- Infiltrator's Cloak
	[27733]="0:4:2:1:Ring::1:0:", -- Warden's Ring of Precision
	[27734]="0:4:2:1:Ring::1:0:", -- Expedition Caster's Band
	[27735]="0:4:2:1:Amulet::1:0:", -- Pendant of the Marsh
	[27736]="0:9:1:1:Cooking::1:0:", -- Master Cookbook
	[27737]="0:4:3:1:Leather::1:0:", -- Moonglade Shoulders
	[27738]="0:4:3:1:Cloth::1:0:", -- Incanter's Pauldrons
	[27739]="0:4:3:1:Plate::1:0:", -- Spaulders of the Righteous
	[27740]="0:4:3:1:Ring::1:0:", -- Band of Ursol
	[27741]="0:2:3:1:OneHandMace::1:0:", -- Bleeding Hollow Warhammer
	[27742]="0:4:3:1:Cloth::1:0:", -- Mage-Fury Girdle
	[27743]="0:4:3:1:Mail::1:0:", -- Girdle of Living Flame
	[27744]="0:4:3:1:Idol::1:0:", -- Idol of Ursoc
	[27745]="0:4:3:1:Mail::1:0:", -- Hungarhide Gauntlets
	[27746]="0:4:3:1:Cloth::1:0:", -- Arcanium Signet Bands
	[27747]="0:2:3:1:FistWeapon::1:0:", -- Boggspine Knuckles
	[27748]="0:4:3:1:Plate::1:0:", -- Cassock of the Loyal
	[27749]="0:2:2:1:Stave::1:0:", -- Staff of the Wild
	[27750]="0:2:2:1:TwoHandMace::1:0:", -- Hammer of the Sporelings
	[27751]="0:2:2:1:Polearm::1:0:", -- Survivalist's Pike
	[27752]="0:2:2:1:TwoHandSword::1:0:", -- Zangarmarsh Claymore
	[27753]="0:2:2:1:Dagger::1:0:", -- Ensorcelled Marshfang Blade
	[27754]="0:2:2:1:OneHandSword::1:0:", -- Keen Marshfang Slicer
	[27755]="0:4:3:1:Plate::1:0:", -- Girdle of Gallantry
	[27756]="0:2:2:1:OneHandAxe::1:0:", -- Marshfang Blade Axe
	[27757]="0:2:3:1:Stave::1:0:", -- Greatstaff of the Leviathan
	[27758]="0:4:3:1:Amulet::1:0:", -- Hydra-fang Necklace
	[27759]="0:4:3:1:Mail::1:0:", -- Headdress of the Tides
	[27760]="0:4:3:1:Leather::1:0:", -- Dunewind Sash
	[27761]="0:4:3:1:Ring::1:0:", -- Ring of the Shadow Deeps
	[27762]="0:4:3:1:Ring::1:0:", -- Weathered Band of the Swamplord
	[27763]="0:4:3:1:Leather::1:0:", -- Crown of the Forest Lord
	[27764]="0:4:3:1:Cloth::1:0:", -- Hands of the Sun
	[27765]="0:4:3:1:Leather::1:0:", -- Armwraps of Disdain
	[27766]="0:4:3:1:Amulet::1:0:", -- Swampstone Necklace
	[27767]="0:2:3:1:OneHandAxe::1:0:", -- Bogreaver
	[27768]="0:4:3:1:Cloth::1:0:", -- Oracle Belt of Timeless Mystery
	[27769]="0:2:3:1:TwoHandSword::1:0:", -- Endbringer
	[27770]="0:4:3:1:Trinket::1:0:", -- Argussian Compass
	[27771]="0:4:3:1:Plate::1:0:", -- Doomplate Shoulderguards
	[27772]="0:4:3:1:Shield::1:0:", -- Stormshield of Renewal
	[27773]="0:4:3:1:Mail::1:0:", -- Barbaric Legstraps
	[27775]="0:4:3:1:Cloth::1:0:", -- Hallowed Pauldrons
	[27776]="0:4:3:1:Leather::1:0:", -- Shoulderpads of Assassination
	[27777]="0:3:3:1:GemRed::1:0:18267", -- Stark Blood Garnet
	[27778]="0:4:3:1:Cloth::1:0:", -- Spaulders of Oblivion
	[27779]="0:4:3:1:Amulet::1:0:", -- Bone Chain Necklace
	[27780]="0:4:3:1:Ring::1:0:", -- Ring of Fabled Hope
	[27781]="0:4:3:1:Cloth::1:0:", -- Demonfang Ritual Helm
	[27783]="0:4:3:1:Leather::1:0:", -- Moonrage Girdle
	[27784]="0:4:3:1:Ring::1:0:", -- Scintillating Coral Band
	[27785]="0:3:3:1:GemGreen::1:0:18267", -- Notched Deep Peridot
	[27786]="0:3:3:1:GemGreen::1:0:18267", -- Barbed Deep Peridot
	[27787]="0:4:3:1:Leather::1:0:", -- Chestguard of No Remorse
	[27788]="0:4:3:1:Plate::1:0:", -- Bloodsworn Warboots
	[27789]="0:4:3:1:Cloak::1:0:", -- Cloak of Whispering Shells
	[27790]="0:4:3:1:Plate::1:0:", -- Mask of Penance
	[27791]="0:2:3:1:Stave::1:0:", -- Serpentcrest Life-Staff
	[27792]="0:4:3:1:Amulet::1:0:", -- Steam-Hinge Chain of Valor
	[27793]="0:4:3:1:Mail::1:0:", -- Earth Mantle Handwraps
	[27794]="0:2:3:1:Gun::1:0:", -- Recoilless Rocket Ripper X-54
	[27795]="0:4:3:1:Cloth::1:0:", -- Sash of Serpentra
	[27796]="0:4:3:1:Cloth::1:0:", -- Mana-Etched Spaulders
	[27797]="0:4:3:1:Leather::1:0:", -- Wastewalker Shoulderpads
	[27798]="0:4:3:1:Plate::1:0:", -- Gauntlets of Vindication
	[27799]="0:4:3:1:Cloth::1:0:", -- Vermillion Robes of the Dominant
	[27800]="0:4:3:1:Leather::1:0:", -- Earthsoul Britches
	[27801]="0:4:3:1:Mail::1:0:", -- Beast Lord Mantle
	[27802]="0:4:3:1:Mail::1:0:", -- Tidefury Shoulderguards
	[27803]="0:4:3:1:Plate::1:0:", -- Shoulderguards of the Bold
	[27804]="0:4:3:1:Cloak::1:0:", -- Devilshark Cape
	[27805]="0:4:3:1:Ring::1:0:", -- Ring of the Silver Hand
	[27806]="0:4:3:1:Mail::1:0:", -- Fathomheart Gauntlets
	[27807]="0:12:1:3:::1:0:", -- Air Elemental Gas
	[27808]="0:13:2:1:::1:0:", -- Jump-a-tron 4000 Key
	[27809]="0:3:3:1:GemGreen::1:0:18266", -- Barbed Deep Peridot
	[27812]="0:3:3:1:GemRed::1:0:18266", -- Stark Blood Garnet
	[27813]="0:4:3:1:Plate::1:0:", -- Boots of the Colossus
	[27814]="0:2:3:1:Dagger::1:0:", -- Twinblade of Mastery
	[27815]="0:4:3:1:Totem::1:0:", -- Totem of the Astral Winds
	[27816]="0:4:3:1:Cloth::1:0:", -- Mindrage Pauldrons
	[27817]="0:2:3:1:Bow::1:0:", -- Starbolt Longbow
	[27818]="0:4:3:1:Leather::1:0:", -- Starry Robes of the Crescent
	[27820]="0:3:3:1:GemGreen::1:0:18266", -- Notched Deep Peridot
	[27821]="0:4:3:1:Cloth::1:0:", -- Extravagant Boots of Malice
	[27822]="0:4:3:1:Ring::1:0:", -- Crystal Band of Valor
	[27823]="0:4:3:1:Mail::1:0:", -- Shard Encrusted Breastplate
	[27824]="0:4:3:1:Cloth::1:0:", -- Robe of the Great Dark Beyond
	[27825]="0:4:3:1:Leather::1:0:", -- Predatory Gloves
	[27826]="0:4:3:1:Mail::1:0:", -- Mantle of the Sea Wolf
	[27827]="0:4:3:1:Leather::1:0:", -- Lucid Dream Bracers
	[27828]="0:4:3:1:Trinket::1:0:", -- Warp-Scarab Brooch
	[27829]="0:2:3:1:TwoHandAxe::1:0:", -- Axe of the Nexus-Kings
	[27830]="0:4:3:1:Ring::1:0:18267", -- Circlet of the Victor
	[27831]="0:4:3:1:Leather::1:0:", -- Mantle of the Unforgiven
	[27832]="0:4:3:1:Ring::1:0:18267", -- Band of the Victor
	[27833]="0:4:3:1:Ring::1:0:18266", -- Band of the Victor
	[27834]="0:4:3:1:Ring::1:0:18266", -- Circlet of the Victor
	[27835]="0:4:3:1:Mail::1:0:", -- Stillwater Girdle
	[27837]="0:4:3:1:Leather::1:0:", -- Wastewalker Leggings
	[27838]="0:4:3:1:Cloth::1:0:", -- Incanter's Trousers
	[27839]="0:4:3:1:Plate::1:0:", -- Legplates of the Righteous
	[27840]="0:2:3:1:TwoHandMace::1:0:", -- Scepter of Sha'tar
	[27841]="0:12:1:1:::1:0:", -- Severed Talon of the Matriarch
	[27842]="0:2:3:1:Stave::1:0:", -- Grand Scepter of the Nexus-Kings
	[27843]="0:4:3:1:Cloth::1:0:", -- Glyph-Lined Sash
	[27844]="0:4:3:1:Plate::1:0:", -- Pauldrons of Swift Retribution
	[27845]="0:4:3:1:Mail::1:0:", -- Magma Plume Boots
	[27846]="0:2:3:1:FistWeapon::1:0:", -- Claw of the Watcher
	[27847]="0:4:3:1:Plate::1:0:", -- Fanblade Pauldrons
	[27848]="0:4:3:1:Cloth::1:0:", -- Embroidered Spellpyre Boots
	[27854]="5600:0:1:20:FoodDrink::5:0:3025,3312,3368,4169,4255,5111,5124,6929,10367,12096,12097,16585,16602,16618,16739,16798,16826,17277,17630,18905,18906,18908,18913,18914,18957,19038,19182,19314,19315,19348,19352,19435,19470,19528,19559,19572,19679,19718,20097,20231,20893,21084,22266,23143,23263,23481,23605,23748,24343,25036,26375,28760,28943,29205", -- Smoked Talbuk Venison
	[27855]="5600:0:1:20:FoodDrink::5:0:3003,3518,4255,5109,6740,10367,16739,17630,18245,18251,18907,19038,19232,19348,19352,19451,19495,19518,19664,20893,21744,21746,23522,23603,24033,24057", -- Mag'har Grainbread
	[27856]="5600:0:1:20:FoodDrink::5:0:3017,3342,4255,6735,6740,7978,12096,12097,16798,17277,17630,18957,19050,19223,19232,19471,19572,19718,21484,21487,21744,21746,22266,25036,26375,26680,29547", -- Skethyl Berries
	[27857]="5600:0:1:20:FoodDrink::5:0:483,4255,4981,6746,10367,17630,19232,19296,19718,20080,20916,21110,21744,21746,22266,23521,23604,24342", -- Garadar Sharp
	[27858]="5600:0:1:20:FoodDrink::5:0:4221,4255,10367,16618,16739,19045,19296,19472,22266,23748,24033,24057,25036", -- Sunspring Carp
	[27859]="5600:0:1:20:FoodDrink::5:0:3329,4554,4571,6741,10367,12096,12097,19471,22266,23748,24149,24342,24396,24408,27032,29205,33018", -- Zangar Caps
	[27860]="6400:0:1:20:FoodDrink:755:5:0:4255,10367,12096,12097,16585,16602,16798,16826,17277,18245,18251,18905,18906,18907,18908,18913,18914,18957,19050,19182,19232,19245,19296,19314,19315,19348,19352,19435,19451,19470,19495,19518,19528,19559,19572,19617,19679,19718,20080,20231,20893,20916,21084,21110,21183,21484,21487,21744,21746,23110,23143,23748,24033,24057,24149,24333,24342,25036,26375,26680,29205,33018", -- Purified Draenic Water
	[27861]="0:12:1:20:::1:0:", -- Lathrai's Stolen Goods
	[27865]="0:4:3:1:Mail::1:0:", -- Bracers of Shirrak
	[27866]="0:4:3:1:Cloth::1:0:", -- Scintillating Headdress of Second Sight
	[27867]="0:4:3:1:Leather::1:0:", -- Boots of the Unjust
	[27868]="0:2:3:1:Dagger::1:0:", -- Runesong Dagger
	[27869]="0:4:3:1:Ring::1:0:", -- Soulpriest's Ring of Resolve
	[27870]="0:4:3:1:Plate::1:0:", -- Doomplate Legguards
	[27871]="0:4:3:1:Amulet::1:0:", -- Maladaar's Blessed Chaplet
	[27872]="0:2:3:1:OneHandAxe::1:0:", -- The Harvester of Souls
	[27873]="0:4:3:1:Leather::1:0:", -- Moonglade Pants
	[27874]="0:4:3:1:Mail::1:0:", -- Beast Lord Leggings
	[27875]="0:4:3:1:Cloth::1:0:", -- Hallowed Trousers
	[27876]="0:2:3:1:OneHandMace::1:0:", -- Will of the Fallen Exarch
	[27877]="0:2:3:1:Stave::1:0:", -- Draenic Wildstaff
	[27878]="0:4:3:1:Cloak::1:0:", -- Auchenai Death Shroud
	[27879]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Scaled Chestpiece
	[27880]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Scaled Gauntlets
	[27881]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Scaled Helm
	[27882]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Scaled Legguards
	[27883]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Scaled Shoulders
	[27884]="0:4:3:1:Plate::1:0:", -- Ornate Boots of the Sanctified
	[27885]="0:2:3:1:Wand::1:0:", -- Soul-Wand of the Aldor
	[27886]="0:4:3:1:Idol::1:0:", -- Idol of the Emerald Queen
	[27887]="0:4:3:1:Shield::1:0:", -- Platinum Shield of the Valorous
	[27888]="0:4:3:1:Mail::1:0:", -- Dream-Wing Helm
	[27889]="0:4:3:1:Cloth::1:0:", -- Jaedenfire Gloves of Annihilation
	[27890]="0:2:3:1:Wand::1:0:", -- Wand of the Netherwing
	[27891]="0:4:3:1:Trinket::1:0:", -- Adamantine Figurine
	[27892]="0:4:3:1:Cloak::1:0:", -- Cloak of the Inciter
	[27893]="0:4:3:1:Plate::1:0:", -- Ornate Leggings of the Venerated
	[27895]="0:4:3:1:Ring::1:0:", -- Band of Many Prisms
	[27896]="0:4:3:1:Trinket::1:0:", -- Alembic of Infernal Power
	[27897]="0:4:3:1:Plate::1:0:", -- Breastplate of Many Graces
	[27898]="0:2:3:1:Gun::1:0:", -- Wrathfire Hand-Cannon
	[27899]="0:2:3:1:OneHandSword::1:0:", -- Mana Wrath
	[27900]="0:4:3:1:Trinket::1:0:", -- Jewel of Charismatic Mystique
	[27901]="0:2:3:1:OneHandMace::1:0:", -- Blackout Truncheon
	[27902]="0:4:3:1:Cloth::1:0:", -- Silent Slippers of Meditation
	[27903]="0:2:3:1:Polearm::1:0:", -- Sonic Spear
	[27904]="0:4:3:1:Ring::1:0:", -- Resounding Ring of Glory
	[27905]="0:2:3:1:OneHandSword::1:0:", -- Greatsword of Horrid Dreams
	[27906]="0:4:3:1:Plate::1:0:", -- Crimsonforge Breastplate
	[27907]="0:4:3:1:Cloth::1:0:", -- Mana-Etched Pantaloons
	[27908]="0:4:3:1:Leather::1:0:", -- Leggings of Assassination
	[27909]="0:4:3:1:Mail::1:0:", -- Tidefury Kilt
	[27910]="0:4:3:1:Shield::1:0:", -- Silvermoon Crest Shield
	[27911]="0:4:3:1:Leather::1:0:", -- Epoch's Whispering Cinch
	[27912]="0:4:3:1:Mail::1:0:", -- Harness of the Deep Currents
	[27913]="0:2:3:1:Dagger::1:0:", -- Whispering Blade of Slaying
	[27914]="0:4:3:1:Leather::1:0:", -- Moonstrider Boots
	[27915]="0:4:3:1:Mail::1:0:", -- Sky-Hunter Swift Boots
	[27916]="0:2:3:1:Thrown::1:0:", -- Sethekk Feather-Darts
	[27917]="0:4:3:1:Libram::1:0:", -- Libram of the Eternal Rest
	[27918]="0:4:3:1:Plate::1:0:", -- Bands of Syth
	[27919]="0:4:3:1:Cloth::1:0:", -- Light-Woven Slippers
	[27920]="0:4:3:1:Trinket::1:0:18564", -- Mark of Conquest
	[27921]="0:4:3:1:Trinket::1:0:18581", -- Mark of Conquest
	[27922]="0:4:3:1:Trinket::1:0:18581", -- Mark of Defiance
	[27924]="0:4:3:1:Trinket::1:0:18564", -- Mark of Defiance
	[27925]="0:4:3:1:Ring::1:0:", -- Ravenclaw Band
	[27926]="0:4:3:1:Trinket::1:0:18564", -- Mark of Vindication
	[27927]="0:4:3:1:Trinket::1:0:18581", -- Mark of Vindication
	[27928]="0:2:3:1:Thrown::1:0:18564", -- Terminal Edge
	[27929]="0:2:3:1:Thrown::1:0:18581", -- Terminal Edge
	[27930]="0:2:3:1:Bow::1:0:18564", -- Splintermark
	[27931]="0:2:3:1:Bow::1:0:18581", -- Splintermark
	[27932]="0:15:0:20:Junk::1:0:", -- Razor Claw
	[27933]="0:15:0:5:Junk::1:0:", -- Serrated Tooth
	[27934]="0:15:0:20:Junk::1:0:", -- Vorpal Claw
	[27935]="0:15:0:5:Junk::1:0:", -- Needle Fang
	[27936]="0:4:3:1:Mail::1:0:", -- Greaves of Desolation
	[27937]="0:2:3:1:OneHandMace::1:0:", -- Sky Breaker
	[27938]="0:4:3:1:Leather::1:0:", -- Savage Mask of the Lynx Lord
	[27939]="0:2:3:1:Wand::1:0:18564", -- Incendic Rod
	[27940]="400000:4:1:1:Amulet::1:0:19227", -- Marvelous Madstone of Immortality
	[27941]="200000:4:1:1:Amulet::1:0:19227", -- Compassionate Critter's Friend
	[27942]="0:2:3:1:Wand::1:0:18581", -- Incendic Rod
	[27943]="0:12:1:1:::1:0:", -- Chieftain Mummaki's Totem
	[27944]="350000:4:1:1:Amulet::1:0:19227", -- Talisman of True Treasure Tracking
	[27945]="150000:4:1:1:Amulet::1:0:19227", -- Shark's Tooth of Bona Fide Fluidic Mobility
	[27946]="0:4:3:1:Cloak::1:0:", -- Avian Cloak of Feathers
	[27947]="0:4:3:1:Totem::1:0:18564", -- Totem of Impact
	[27948]="0:4:3:1:Cloth::1:0:", -- Trousers of Oblivion
	[27949]="0:4:3:1:Libram::1:0:18564", -- Libram of Zeal
	[27976]="250000:4:1:1:Amulet::1:0:19227", -- Polished Pendant of Edible Energy
	[27977]="0:4:3:1:Plate::1:0:", -- Legplates of the Bold
	[27978]="10000:4:1:1:Amulet::1:0:19227", -- Soap on a Rope
	[27979]="100000:4:1:1:Amulet::1:0:19227", -- Stone of Stupendous Springing Strides
	[27980]="0:2:3:1:OneHandMace::1:0:", -- Terokk's Nightmace
	[27981]="0:4:3:1:Cloak::1:0:", -- Sethekk Oracle Cloak
	[27982]="300000:4:1:1:Amulet::1:0:19227", -- Charm of Potent and Powerful Passions
	[27983]="0:4:3:1:Libram::1:0:18581", -- Libram of Zeal
	[27984]="0:4:3:1:Totem::1:0:18581", -- Totem of Impact
	[27985]="0:4:3:1:Plate::1:0:", -- Deathforge Girdle
	[27986]="0:2:3:1:TwoHandAxe::1:0:", -- Crow Wing Reaper
	[27987]="0:2:3:1:Bow::1:0:", -- Melmorta's Twilight Longbow
	[27988]="0:4:3:1:Cloak::1:0:", -- Burnoose of Shifting Ages
	[27989]="0:4:3:1:Idol::1:0:18564", -- Idol of Savagery
	[27990]="0:4:3:1:Idol::1:0:18581", -- Idol of Savagery
	[27991]="0:13:1:1:::1:0:", -- Shadow Labyrinth Key
	[27992]="50000:4:1:1:Amulet::1:0:19227", -- Infallible Tikbalang Ward
	[27993]="0:4:3:1:Mail::1:0:", -- Mask of Inner Fire
	[27994]="0:4:3:1:Cloth::1:0:", -- Mantle of Three Terrors
	[27995]="0:4:3:1:Leather::1:0:", -- Sun-Gilded Shouldercaps
	[27996]="0:4:3:1:Ring::1:0:", -- Ring of Spiritual Precision
	[28024]="0:12:1:1:::1:0:", -- Orion's Report
	[28026]="0:4:2:1:Cloak::1:0:", -- Crazy Cenarion Cloak
	[28027]="0:4:2:1:Amulet::1:0:", -- Lunatic's Choker
	[28028]="0:4:2:1:Leather::1:0:", -- Moonstruck Bands
	[28029]="0:4:3:1:Cloth::1:0:", -- Goldenvine Wraps
	[28030]="0:4:3:1:Cloak::1:0:", -- Spell-slinger's Protector
	[28031]="0:4:3:1:Cloak::1:0:", -- Nomad's Woven Cloak
	[28032]="0:4:3:1:Cloak::1:0:", -- Delicate Green Poncho
	[28033]="0:2:3:1:Stave::1:0:", -- Epoch-Mender
	[28034]="0:4:3:1:Trinket::1:0:", -- Hourglass of the Unraveller
	[28038]="0:0:1:1:Consumable::1:0:", -- Seaforium PU-36 Explosive Nether Modulator
	[28039]="0:12:1:1:::1:0:", -- Crude Explosives
	[28040]="0:4:3:1:Trinket::1:0:", -- Vengeance of the Illidari
	[28041]="0:4:3:1:Trinket::1:0:", -- Bladefist's Breadth
	[28042]="0:4:3:1:Trinket::1:0:", -- Regal Protectorate
	[28050]="0:4:3:1:Leather::1:0:", -- Sacred Feather Vest
	[28051]="0:4:3:1:Leather::1:0:", -- Jerkin of the Untamed Spirit
	[28052]="0:4:3:1:Cloth::1:0:", -- Goldweave Tunic
	[28053]="1600:6:1:1000:Arrow::200:0:228,734,789,1149,1285,1298,1462,2084,2401,2803,2806,2808,2820,2839,2908,3015,3313,3350,3410,3541,3625,4170,4173,4241,4555,4604,4892,4896,5101,5122,5134,6028,7942,8139,8362,9548,9551,9552,9555,11038,11555,12021,12027,12246,12959,12960,14301,14624,15174,15397,16191,16602,16732,16826,16919,17598,18011,18907,18959,19020,19021,19053,19197,19243,19314,19315,19339,19343,19351,19374,19436,19452,19473,19474,19498,19534,19560,19561,19574,19625,19649,19679,19694,19718,20080,20092,20194,20231,20249,20892,21082,21111,21172,21183,21483,21488,22099,22270,23143,23373,23862,24028,24053,24141,24348,25035,26718,26901,27055,27071,28040,28792,28800,28807,28813,29014,29207,29493,30572,31025", -- Wicked Arrow
	[28055]="0:4:3:1:Plate::1:0:", -- Gilded Crimson Chestplate
	[28056]="3000:6:1:1000:Arrow::200:0:3625,5134,16602,16826,18011,18907,18959,19020,19021,19053,19197,19243,19314,19315,19339,19343,19351,19374,19436,19452,19473,19474,19498,19534,19560,19574,19625,19649,19679,19694,19718,20080,20092,20194,20231,20249,20892,21082,21111,21172,21183,21483,21488,22099,22270,23143,23373,23802,23862,24028,24053,24141,24188,24348,24780,25035,25195,25196,26388,26718,26901,26934,26936,26938,27011,27022,27025,27041,27051,27055,27058,27071,27145,27182,27193,27940,28040,28691,28792,28800,28807,28813,28830,28867,29014,29035,29207,29493,29908,29925,29944,29962,29970,30011,30070,30256,30257,30310,30437,30572,31022,31025,32477,32638,32642,33872", -- Blackflight Arrow
	[28057]="0:4:3:1:Mail::1:0:", -- Bonechewer Berserker's Vest
	[28058]="0:15:0:20:Junk::1:0:", -- Shredded Wyrm Wing
	[28059]="0:15:0:20:Junk::1:0:", -- Iridescent Eye
	[28060]="1600:6:1:1000:Bullet::200:0:734,1149,1285,2084,2401,2685,2803,2806,2808,2820,2908,3313,3322,3350,3541,3625,4170,4241,4555,4896,5101,5134,6028,7942,8131,8139,8362,9548,11038,11184,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16602,16732,16826,18011,18907,18959,19020,19021,19053,19197,19243,19314,19315,19339,19343,19351,19374,19436,19452,19473,19474,19498,19534,19560,19574,19625,19649,19679,19694,19718,19836,20080,20092,20194,20231,20249,20892,21082,21111,21172,21183,21483,21488,22099,22270,22491,23143,23373,23862,24028,24053,24141,24348,25035,26718,26901,27055,27071,28040,28792,28800,28807,28813,29014,29207,29493,29945,30572,31025", -- Impact Shot
	[28061]="3000:6:1:1000:Bullet::200:0:3625,5134,16602,16826,18011,18907,18959,19020,19021,19053,19197,19243,19314,19315,19339,19343,19351,19374,19436,19452,19473,19474,19498,19534,19560,19574,19625,19649,19679,19694,19718,19836,20080,20092,20194,20231,20249,20892,21082,21111,21172,21183,21483,21488,22099,22270,22491,23143,23373,23802,23862,24028,24053,24141,24188,24348,24780,25035,25195,25196,26388,26718,26901,26934,26936,26938,27011,27022,27025,27041,27051,27055,27058,27071,27145,27182,27193,27940,28040,28691,28792,28800,28807,28813,28830,28867,29014,29035,29207,29493,29908,29925,29944,29945,29962,29970,30011,30070,30256,30257,30310,30437,30572,31022,31025,32477,32638,32642,33872", -- Ironbite Shell
	[28062]="0:2:2:1:Crossbow::1:0:", -- Expedition Repeater
	[28063]="0:2:2:1:Wand::1:0:", -- Survivalist's Wand
	[28064]="0:4:2:1:Idol::1:0:", -- Idol of the Wild
	[28065]="0:4:2:1:Libram::1:0:", -- Libram of Wracking
	[28066]="0:4:2:1:Totem::1:0:", -- Totem of Lightning
	[28068]="60000:9:1:1:Book::1:0:5520,5750,5753,5815,6027,6328,6374,6382,12807,16267,16649,23535", -- Grimoire of Suffering (Rank 6)
	[28069]="0:4:3:1:Plate::1:0:", -- Golden Cenarion Greaves
	[28070]="0:4:3:1:Mail::1:0:", -- Verdant Handwraps
	[28071]="15000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Anguish (Rank 1)
	[28072]="26000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Anguish (Rank 2)
	[28073]="67000:9:1:1:Book::1:0:5520,5753,5815,6382,12807,16267,16649,23535", -- Grimoire of Anguish (Rank 3)
	[28074]="0:4:3:1:Leather::1:0:", -- Studded Green Anklewraps
	[28075]="0:4:3:1:Cloth::1:0:", -- Destroyers' Mantle
	[28099]="0:12:1:1:::1:0:", -- Drillmaster Zurok's Orders
	[28100]="4000:0:1:20:Potion::1:1:22099,24780", -- Volatile Healing Potion
	[28101]="6000:0:1:20:Potion::1:1:22099,24780", -- Unstable Mana Potion
	[28102]="0:0:1:20:Elixir::1:0:", -- Onslaught Elixir
	[28103]="0:0:1:20:Elixir::1:0:", -- Adept's Elixir
	[28104]="0:0:1:20:Elixir::1:0:", -- Elixir of Mastery
	[28105]="0:12:1:1:::1:0:", -- Duron's Report
	[28106]="0:15:1:1:Junk::1:0:", -- Kingston's Primers
	[28108]="0:4:3:1:Trinket::1:0:", -- Power Infused Mushroom
	[28109]="0:4:3:1:Trinket::1:0:", -- Essence Infused Mushroom
	[28111]="0:4:3:1:Miscellaneous::1:0:", -- Everlasting Underspore Frond
	[28112]="0:0:1:20:FoodDrink::1:0:", -- Underspore Pod
	[28116]="0:12:1:30:::1:0:", -- Zeppelin Debris
	[28118]="0:3:4:1:GemRed::1:0:34040,34043,34080,34081", -- Runed Ornate Ruby
	[28119]="0:3:4:1:GemYellow::1:0:34040,34043,34080,34081", -- Smooth Ornate Dawnstone
	[28120]="0:3:4:1:GemYellow::1:0:34040,34043,34080,34081", -- Gleaming Ornate Dawnstone
	[28121]="0:4:3:1:Trinket::1:0:", -- Icon of Unyielding Courage
	[28123]="0:3:4:1:GemOrange::1:0:34040,34043,34080,34081", -- Potent Ornate Topaz
	[28124]="0:4:3:1:Leather::1:0:", -- Liar's Cord
	[28126]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Dragonhide Gloves
	[28127]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Dragonhide Helm
	[28128]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Dragonhide Legguards
	[28129]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Dragonhide Spaulders
	[28130]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Dragonhide Tunic
	[28132]="0:0:1:1:Consumable::1:0:", -- Area 52 Special
	[28134]="0:4:3:1:Amulet::1:0:", -- Brooch of Heightened Potential
	[28136]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Wyrmhide Gloves
	[28137]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Wyrmhide Helm
	[28138]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Wyrmhide Legguards
	[28139]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Wyrmhide Spaulders
	[28140]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Wyrmhide Tunic
	[28141]="0:4:2:1:Cloth::1:0:", -- Ranger's Sash
	[28142]="0:4:2:1:Leather::1:0:", -- Farstrider's Belt
	[28143]="0:4:2:1:Mail::1:0:", -- Rusted Chain Girdle
	[28144]="0:4:2:1:Cloth::1:0:", -- Troll Handler Gloves
	[28146]="0:4:2:1:Cloth::1:0:", -- Courier's Wraps
	[28147]="0:4:2:1:Leather::1:0:", -- Tranquillien Scout's Bracers
	[28148]="0:4:2:1:Mail::1:0:", -- Bronze Mail Bracers
	[28149]="0:4:2:1:Leather::1:0:", -- Tranquillien Breeches
	[28150]="0:4:2:1:Cloak::1:0:", -- Renzithen's Dusty Cloak
	[28151]="0:2:2:1:Wand::1:0:", -- Arcanist's Wand
	[28152]="0:2:2:1:Bow::1:0:", -- Quel'Thalas Recurve
	[28153]="0:4:2:1:Shield::1:0:", -- Farstrider's Shield
	[28154]="0:4:2:1:Cloth::1:0:", -- Red Silk Trousers
	[28155]="965:4:2:1:Cloth::1:0:16528", -- Apothecary's Waistband
	[28156]="0:4:2:1:Cloth::1:0:", -- Rotting Handwraps
	[28157]="0:4:2:1:Leather::1:0:", -- Black Leather Jerkin
	[28158]="1219:4:2:1:Leather::1:0:16528", -- Batskin Belt
	[28159]="0:4:2:1:Leather::1:0:", -- Undertaker's Gloves
	[28160]="0:4:2:1:Mail::1:0:", -- An'telas Scale Shirt
	[28161]="0:4:2:1:Mail::1:0:", -- Tranquillien Scale Leggings
	[28162]="1380:4:2:1:Mail::1:0:16528", -- Tranquillien Defender's Girdle
	[28163]="0:4:2:1:Mail::1:0:", -- Maltendis's Handguards
	[28164]="4381:2:2:1:TwoHandSword::1:0:16528", -- Tranquillien Flamberge
	[28166]="0:4:3:1:Shield::1:0:", -- Shield of the Void
	[28167]="0:4:3:1:Plate::1:0:", -- Sha'tari Wrought Armguards
	[28168]="0:4:3:1:Amulet::1:0:", -- Insignia of the Mag'hari Hero
	[28169]="0:4:3:1:Cloth::1:0:", -- Mag'hari Ritualist's Horns
	[28170]="0:4:3:1:Mail::1:0:", -- Auchenai Bracers
	[28171]="0:4:3:1:Leather::1:0:", -- Spymistress's Wristguards
	[28172]="0:4:3:1:Leather::1:0:", -- Mag'hari Scout's Tunic
	[28173]="0:4:3:1:Mail::1:0:", -- Mag'hari Huntsman's Leggings
	[28174]="0:4:3:1:Cloth::1:0:", -- Shattrath Wraps
	[28175]="0:4:3:1:Plate::1:0:", -- Mag'hari Warlord's Legplates
	[28176]="0:4:3:1:Plate::1:0:", -- Sha'tari Wrought Greaves
	[28177]="0:4:3:1:Mail::1:0:", -- Auchenai Boots
	[28178]="0:4:3:1:Leather::1:0:", -- Spymistress's Boots
	[28179]="0:4:3:1:Cloth::1:0:", -- Shattrath Jumpers
	[28180]="0:4:3:1:Plate::1:0:", -- Myrmidon's Headdress
	[28181]="0:4:3:1:Mail::1:0:", -- Earthwarden's Coif
	[28182]="0:4:3:1:Leather::1:0:", -- Helm of the Claw
	[28183]="0:4:3:1:Cloth::1:0:", -- Hydromancer's Headwrap
	[28184]="0:2:3:1:OneHandSword::1:0:", -- Millennium Blade
	[28185]="0:4:3:1:Cloth::1:0:", -- Khadgar's Kilt of Abjuration
	[28186]="0:4:3:1:Mail::1:0:", -- Laughing Skull Battle-Harness
	[28187]="0:4:3:1:OffHandFrill::1:0:", -- Star-Heart Lamp
	[28188]="0:2:3:1:Stave::1:0:", -- Bloodfire Greatstaff
	[28189]="0:2:3:1:OneHandSword::1:0:", -- Latro's Shifting Sword
	[28190]="0:4:3:1:Trinket::1:0:", -- Scarab of the Infinite Cycle
	[28191]="0:4:3:1:Cloth::1:0:", -- Mana-Etched Vestments
	[28192]="0:4:3:1:Mail::1:0:", -- Helm of Desolation
	[28193]="0:4:3:1:Cloth::1:0:", -- Mana-Etched Crown
	[28194]="0:4:3:1:Mail::1:0:", -- Primal Surge Bracers
	[28202]="0:4:3:1:Leather::1:0:", -- Moonglade Robe
	[28203]="0:4:3:1:Plate::1:0:", -- Breastplate of the Righteous
	[28204]="0:4:3:1:Leather::1:0:", -- Tunic of Assassination
	[28205]="0:4:3:1:Plate::1:0:", -- Breastplate of the Bold
	[28206]="0:4:3:1:Leather::1:0:", -- Cowl of the Guiltless
	[28207]="0:4:3:1:Plate::1:0:", -- Pauldrons of the Crimson Flight
	[28209]="0:12:1:1:::1:0:", -- Old Whitebark's Pendant
	[28210]="0:2:3:1:OneHandMace::1:0:", -- Bloodskull Destroyer
	[28211]="0:4:3:1:Ring::1:0:", -- Lieutenant's Signet of Lordaeron
	[28212]="0:4:3:1:Cloth::1:0:", -- Aran's Sorcerous Slacks
	[28213]="0:4:3:1:OffHandFrill::1:0:", -- Lordaeron Medical Guide
	[28214]="0:4:3:1:Leather::1:0:", -- Grips of the Lunar Eclipse
	[28215]="0:4:3:1:Mail::1:0:", -- Mok'Nathal Mask of Battle
	[28216]="0:2:3:1:OneHandMace::1:0:", -- Dathrohan's Ceremonial Hammer
	[28217]="0:4:3:1:Amulet::1:0:", -- Tarren Mill Vitality Locket
	[28218]="0:4:3:1:Cloth::1:0:", -- Pontiff's Pantaloons of Prophecy
	[28219]="0:4:3:1:Mail::1:0:", -- Emerald-Scale Greaves
	[28220]="0:4:3:1:Leather::1:0:", -- Moon-Crown Antlers
	[28221]="0:4:3:1:Plate::1:0:", -- Boots of the Watchful Heart
	[28222]="0:2:3:1:TwoHandAxe::1:0:", -- Reaver of the Infinites
	[28223]="0:4:3:1:Trinket::1:0:", -- Arcanist's Stone
	[28224]="0:4:3:1:Leather::1:0:", -- Wastewalker Helm
	[28225]="0:4:3:1:Plate::1:0:", -- Doomplate Warhelm
	[28226]="0:2:3:1:Dagger::1:0:", -- Timeslicer
	[28227]="0:4:3:1:Ring::1:0:", -- Sparking Arcanite Ring
	[28228]="0:4:3:1:Mail::1:0:", -- Beast Lord Cuirass
	[28229]="0:4:3:1:Cloth::1:0:", -- Incanter's Robe
	[28230]="0:4:3:1:Cloth::1:0:", -- Hallowed Garments
	[28231]="0:4:3:1:Mail::1:0:", -- Tidefury Chestpiece
	[28232]="0:4:3:1:Cloth::1:0:", -- Robe of Oblivion
	[28233]="0:4:3:1:Amulet::1:0:", -- Necklace of Resplendent Hope
	[28234]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[28235]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[28236]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[28237]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[28238]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[28239]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[28240]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[28241]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[28242]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[28243]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[28244]="0:4:4:1:Amulet::1:0:", -- Pendant of Triumph
	[28245]="0:4:4:1:Amulet::1:0:", -- Pendant of Dominance
	[28246]="0:4:3:1:Ring::1:0:", -- Band of Triumph
	[28247]="0:4:3:1:Ring::1:0:", -- Band of Dominance
	[28248]="0:4:3:1:Totem::1:0:", -- Totem of the Void
	[28249]="0:4:3:1:Cloak::1:0:", -- Capacitus' Cloak of Calibration
	[28250]="0:4:3:1:Cloth::1:0:", -- Vestia's Pauldrons of Inner Grace
	[28251]="0:4:3:1:Leather::1:0:", -- Boots of the Glade-Keeper
	[28252]="0:4:3:1:Cloth::1:0:", -- Bloodfyre Robes of Annihilation
	[28253]="0:2:3:1:Polearm::1:0:", -- Plasma Rat's Hyper-Scythe
	[28254]="0:4:3:1:Amulet::1:0:", -- Warp Engineer's Prismatic Chain
	[28255]="0:4:3:1:Leather::1:0:", -- Lunar-Claw Pauldrons
	[28256]="0:4:3:1:Cloak::1:0:", -- Thoriumweave Cloak
	[28257]="0:2:3:1:OneHandMace::1:0:", -- Hammer of the Penitent
	[28258]="0:2:3:1:Thrown::1:0:", -- Nethershrike
	[28259]="0:4:3:1:Ring::1:0:", -- Cosmic Lifeband
	[28260]="0:4:3:1:OffHandFrill::1:0:", -- Manual of the Nethermancer
	[28262]="0:4:3:1:Plate::1:0:", -- Jade-Skull Breastplate
	[28263]="0:2:3:1:OneHandAxe::1:0:", -- Stellaris
	[28264]="0:4:3:1:Leather::1:0:", -- Wastewalker Tunic
	[28265]="0:4:3:1:Ring::1:0:", -- Dath'Remar's Ring of Defense
	[28266]="0:4:3:1:Mail::1:0:", -- Molten Earth Kilt
	[28267]="0:2:3:1:OneHandSword::1:0:", -- Edge of the Cosmos
	[28268]="0:4:3:1:Leather::1:0:", -- Natural Mender's Wraps
	[28269]="0:4:3:1:Cloak::1:0:", -- Baba's Cloak of Arcanistry
	[28270]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Chest - Major Resilience
	[28271]="80000:9:2:1:Enchanting::1:0:17904", -- Formula: Enchant Gloves - Precise Strikes
	[28272]="80000:9:2:1:Enchanting::1:0:21643", -- Formula: Enchant Gloves - Major Spellpower
	[28273]="60000:9:2:1:Enchanting::1:0:21432", -- Formula: Enchant Gloves - Major Healing
	[28274]="40000:9:2:1:Enchanting::1:0:20242,23007", -- Formula: Enchant Cloak - Spell Penetration
	[28275]="0:4:3:1:Mail::1:0:", -- Beast Lord Helm
	[28276]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Greater Arcane Resistance
	[28277]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Greater Shadow Resistance
	[28278]="0:4:3:1:Cloth::1:0:", -- Incanter's Cowl
	[28279]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Boots - Cat's Swiftness
	[28280]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Boots - Boar's Speed
	[28281]="60000:9:2:1:Enchanting::1:0:21432", -- Formula: Enchant Weapon - Major Healing
	[28282]="40000:9:1:1:Enchanting::1:1:19663", -- Formula: Enchant Shield - Major Stamina
	[28283]="0:12:1:1:::1:0:", -- Soul Mirror
	[28284]="300:0:1:10:FoodDrink::1:0:19617,24333", -- Don Carlos Tequila
	[28285]="0:4:3:1:Plate::1:0:", -- Helm of the Righteous
	[28286]="0:2:3:1:Gun::1:0:", -- Telescopic Sharprifle
	[28287]="0:12:1:10:::1:0:", -- Vial of Sedative Serum
	[28288]="0:4:3:1:Trinket::1:0:", -- Abacus of Violent Odds
	[28290]="10000:3:2:1:GemYellow::1:1:19538", -- Smooth Golden Draenite
	[28291]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Smooth Golden Draenite
	[28292]="0:12:1:1:::1:0:", -- Archmage Vargoth's Staff
	[28293]="0:2:3:1:TwoHandSword::1:0:", -- High Warlord's Claymore
	[28294]="0:2:4:1:Crossbow::1:0:", -- Gladiator's Heavy Crossbow
	[28295]="0:2:4:1:OneHandSword::1:0:", -- Gladiator's Slicer
	[28296]="0:4:3:1:Libram::1:0:", -- Libram of the Lightbringer
	[28297]="0:2:4:1:Dagger::1:0:", -- Gladiator's Spellblade
	[28298]="0:2:4:1:TwoHandAxe::1:0:", -- Gladiator's Decapitator
	[28299]="0:2:4:1:TwoHandMace::1:0:", -- Gladiator's Bonegrinder
	[28300]="0:2:4:1:Polearm::1:0:", -- Gladiator's Painsaw
	[28301]="0:4:3:1:Cloak::1:0:", -- Syrannis' Mystic Sheen
	[28302]="0:2:4:1:OneHandMace::1:0:", -- Gladiator's Bonecracker
	[28303]="0:4:2:1:Ring::1:0:", -- Invoker's Signet
	[28304]="0:4:3:1:Cloth::1:0:", -- Prismatic Mittens of Mending
	[28305]="0:2:4:1:OneHandMace::1:0:", -- Gladiator's Pummeler
	[28306]="0:4:3:1:Mail::1:0:", -- Towering Mantle of the Hunt
	[28307]="0:2:4:1:OneHandSword::1:0:", -- Gladiator's Quickblade
	[28308]="0:2:4:1:OneHandAxe::1:0:", -- Gladiator's Cleaver
	[28309]="0:2:4:1:OneHandAxe::1:0:", -- Gladiator's Hacker
	[28310]="0:2:4:1:Dagger::1:0:", -- Gladiator's Shiv
	[28311]="0:2:3:1:OneHandSword::1:0:", -- Revenger
	[28312]="0:2:4:1:Dagger::1:0:", -- Gladiator's Shanker
	[28313]="0:2:4:1:FistWeapon::1:0:", -- Gladiator's Right Ripper
	[28314]="0:2:4:1:FistWeapon::1:0:", -- Gladiator's Left Ripper
	[28315]="0:2:3:1:FistWeapon::1:0:", -- Stormreaver Warblades
	[28316]="0:4:3:1:Shield::1:0:", -- Aegis of the Sunbird
	[28317]="0:4:3:1:Cloth::1:0:", -- Energis Armwraps
	[28318]="0:4:3:1:Plate::1:0:", -- Obsidian Clodstompers
	[28319]="0:2:4:1:Thrown::1:0:", -- Gladiator's War Edge
	[28320]="0:2:4:1:Wand::1:0:", -- Gladiator's Touch of Defeat
	[28321]="0:4:3:1:Amulet::1:0:", -- Enchanted Thorium Torque
	[28322]="0:2:3:1:Dagger::1:0:", -- Runed Dagger of Solace
	[28323]="0:4:3:1:Ring::1:0:", -- Ring of Umbral Doom
	[28324]="0:4:3:1:Plate::1:0:", -- Gauntlets of Cruel Intention
	[28325]="0:2:3:1:Stave::1:0:", -- Dreamer's Dragonstaff
	[28327]="0:4:3:1:Ring::1:0:", -- Arcane Netherband
	[28328]="0:4:3:1:Cloak::1:0:", -- Mithril-Bark Cloak
	[28331]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Chain Helm
	[28332]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Chain Leggings
	[28333]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Chain Spaulders
	[28334]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Chain Armor
	[28335]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Chain Gauntlets
	[28336]="0:12:1:1:::1:0:", -- Belmara's Tome
	[28337]="0:4:3:1:Plate::1:0:", -- Breastplate of Righteous Fury
	[28338]="0:4:3:1:Cloth::1:0:", -- Devil-Stitched Leggings
	[28339]="0:4:3:1:Leather::1:0:", -- Boots of the Shifting Sands
	[28340]="0:4:3:1:Leather::1:0:", -- Mantle of Autumn
	[28341]="0:2:3:1:Stave::1:0:", -- Warpstaff of Arcanum
	[28342]="0:4:3:1:Cloth::1:0:", -- Warp Infused Drape
	[28343]="0:4:3:1:Amulet::1:0:", -- Jagged Bark Pendant
	[28344]="0:4:3:1:Mail::1:0:", -- Wyrmfury Pauldrons
	[28345]="0:2:3:1:Dagger::1:0:", -- Warp Splinter's Thorn
	[28346]="0:4:4:1:OffHandFrill::1:0:", -- Gladiator's Endgame
	[28347]="0:4:3:1:Leather::1:0:", -- Warpscale Leggings
	[28348]="0:4:3:1:Leather::1:0:", -- Moonglade Cowl
	[28349]="0:4:3:1:Mail::1:0:", -- Tidefury Helm
	[28350]="0:4:3:1:Plate::1:0:", -- Warhelm of the Bold
	[28351]="0:12:1:1:::1:0:", -- Dathric's Blade
	[28352]="0:12:1:1:::1:0:", -- Luminrath's Mantle
	[28353]="0:12:1:1:::1:0:", -- Cohlien's Cap
	[28355]="0:4:4:1:Idol::1:0:", -- Gladiator's Idol of Tenacity
	[28356]="0:4:4:1:Libram::1:0:", -- Gladiator's Libram of Justice
	[28357]="0:4:4:1:Totem::1:0:", -- Gladiator's Totem of the Third Wind
	[28358]="0:4:4:1:Shield::1:0:", -- Gladiator's Shield Wall
	[28359]="0:12:1:1:::1:0:", -- Netherologist's Notes
	[28360]="0:3:3:1:GemRed::1:0:18267", -- Mighty Blood Garnet
	[28361]="0:3:3:1:GemRed::1:0:18266", -- Mighty Blood Garnet
	[28362]="0:3:4:1:GemRed::1:0:34040,34043,34080,34081", -- Bold Ornate Ruby
	[28363]="0:3:4:1:GemOrange::1:0:34040,34043,34080,34081", -- Inscribed Ornate Topaz
	[28364]="0:12:1:20:::1:0:", -- Etherlithium Matrix Crystal
	[28367]="0:2:3:1:TwoHandSword::1:0:", -- Greatsword of Forlorn Visions
	[28368]="0:12:1:1:::1:0:", -- Sigil of Krasus
	[28369]="0:12:1:1:::1:0:", -- Battery Recharging Blaster
	[28370]="0:4:3:1:Trinket::1:0:", -- Bangle of Endless Blessings
	[28371]="0:4:3:1:Cloak::1:0:", -- Netherfury Cape
	[28372]="0:4:3:1:Idol::1:0:", -- Idol of Feral Shadows
	[28373]="0:4:3:1:Cloak::1:0:", -- Cloak of Scintillating Auras
	[28374]="0:4:3:1:Cloth::1:0:", -- Mana-Sphere Shoulderguards
	[28375]="0:4:3:1:Plate::1:0:", -- Rubium War-Girdle
	[28376]="0:12:1:1:::1:0:", -- B'naar Personnel Roster
	[28377]="0:4:4:1:Cloak::1:0:", -- Sergeant's Heavy Cloak
	[28378]="0:4:4:1:Cloak::1:0:", -- Sergeant's Heavy Cape
	[28379]="0:4:4:1:Cloak::1:0:", -- Sergeant's Heavy Cape
	[28380]="0:4:4:1:Cloak::1:0:", -- Sergeant's Heavy Cloak
	[28381]="0:4:4:1:Plate::1:0:", -- General's Plate Bracers
	[28383]="0:4:4:1:Plate::1:0:", -- General's Plate Greaves
	[28384]="0:4:3:1:Mail::1:0:", -- Outland Striders
	[28385]="0:4:4:1:Plate::1:0:", -- General's Plate Belt
	[28386]="0:2:3:1:Wand::1:0:", -- Nether Core's Control Rod
	[28387]="0:4:3:1:OffHandFrill::1:0:", -- Lamp of Peaceful Repose
	[28390]="0:4:3:1:Plate::1:0:", -- Thatia's Self-Correcting Gauntlets
	[28391]="0:4:3:1:Mail::1:0:", -- Worldfire Chestguard
	[28392]="0:2:3:1:FistWeapon::1:0:", -- Reflex Blades
	[28393]="0:2:3:1:TwoHandMace::1:0:", -- Warmaul of Infused Light
	[28394]="0:4:3:1:Ring::1:0:", -- Ryngo's Band of Ingenuity
	[28395]="0:13:1:1:::1:0:", -- Shattered Halls Key
	[28396]="0:4:3:1:Leather::1:0:", -- Gloves of the Unbound
	[28397]="0:2:3:1:Crossbow::1:0:", -- Emberhawk Crossbow
	[28398]="0:4:3:1:Leather::1:0:", -- The Sleeper's Cord
	[28399]="5600:0:1:20:FoodDrink::5:0:4169,4255,4554,4571,4981,5111,6735,6740,6741,6746,6929,10367,12096,12097,16585,16602,16618,16739,16798,16826,17277,17630,18245,18251,18905,18906,18907,18908,18913,18914,18957,19050,19182,19232,19245,19296,19314,19315,19348,19352,19435,19451,19470,19495,19518,19528,19559,19572,19617,19679,19718,20080,20231,20893,20916,21084,21110,21183,21484,21487,21744,21746,23110,23143,23748,24033,24057,24149,24333,24342,25036,26375,26680,29205,33018", -- Filtered Draenic Water
	[28400]="0:2:3:1:OneHandSword::1:0:", -- Warp-Storm Warblade
	[28401]="0:4:3:1:Mail::1:0:", -- Hauberk of Desolation
	[28402]="0:4:4:1:Cloth::1:0:", -- General's Dreadweave Stalkers
	[28403]="0:4:3:1:Plate::1:0:", -- Doomplate Chestguard
	[28404]="0:4:4:1:Cloth::1:0:", -- General's Dreadweave Belt
	[28405]="0:4:4:1:Cloth::1:0:", -- General's Dreadweave Cuffs
	[28406]="0:4:3:1:Cloth::1:0:", -- Sigil-Laced Boots
	[28407]="0:4:3:1:Ring::1:0:", -- Elementium Band of the Sentry
	[28408]="0:2:2:1:Thrown::1:0:", -- Broken Silver Star
	[28409]="0:4:4:1:Cloth::1:0:", -- General's Silk Belt
	[28410]="0:4:4:1:Cloth::1:0:", -- General's Silk Footguards
	[28411]="0:4:4:1:Cloth::1:0:", -- General's Silk Cuffs
	[28412]="0:4:3:1:OffHandFrill::1:0:", -- Lamp of Peaceful Radiance
	[28413]="0:4:3:1:Cloth::1:0:", -- Hallowed Crown
	[28414]="0:4:3:1:Leather::1:0:", -- Helm of Assassination
	[28415]="0:4:3:1:Cloth::1:0:", -- Hood of Oblivion
	[28416]="0:2:3:1:Dagger::1:0:", -- Hungering Spineripper
	[28417]="0:12:1:20:::1:0:", -- Nether Ray Stinger
	[28418]="0:4:3:1:Trinket::1:0:", -- Shiffar's Nexus-Horn
	[28419]="0:4:3:1:Amulet::1:0:", -- Choker of Fluid Thought
	[28420]="0:0:1:20:EnhTemp::1:0:", -- Fel Weightstone
	[28421]="0:0:2:20:EnhTemp::1:0:", -- Adamantite Weightstone
	[28422]="0:4:4:1:Leather::1:0:", -- General's Leather Boots
	[28423]="0:4:4:1:Leather::1:0:", -- General's Leather Belt
	[28424]="0:4:4:1:Leather::1:0:", -- General's Leather Bracers
	[28425]="0:2:4:1:OneHandSword:164:1:0:", -- Fireguard
	[28426]="0:2:4:1:OneHandSword:164:1:0:", -- Blazeguard
	[28427]="0:2:4:1:OneHandSword::1:0:", -- Blazefury
	[28428]="0:2:4:1:TwoHandSword:164:1:0:", -- Lionheart Blade
	[28429]="0:2:4:1:TwoHandSword:164:1:0:", -- Lionheart Champion
	[28430]="0:2:4:1:TwoHandSword::1:0:", -- Lionheart Executioner
	[28431]="0:2:4:1:OneHandAxe:164:1:0:", -- The Planar Edge
	[28432]="0:2:4:1:OneHandAxe:164:1:0:", -- Black Planar Edge
	[28433]="0:2:4:1:OneHandAxe::1:0:", -- Wicked Edge of the Planes
	[28434]="0:2:4:1:TwoHandAxe:164:1:0:", -- Lunar Crescent
	[28435]="0:2:4:1:TwoHandAxe:164:1:0:", -- Mooncleaver
	[28436]="0:2:4:1:TwoHandAxe::1:0:", -- Bloodmoon
	[28437]="0:2:4:1:OneHandMace:164:1:0:", -- Drakefist Hammer
	[28438]="0:2:4:1:OneHandMace:164:1:0:", -- Dragonmaw
	[28439]="0:2:4:1:OneHandMace::1:0:", -- Dragonstrike
	[28440]="0:2:4:1:TwoHandMace:164:1:0:", -- Thunder
	[28441]="0:2:4:1:TwoHandMace:164:1:0:", -- Deep Thunder
	[28442]="0:2:4:1:TwoHandMace::1:0:", -- Stormherald
	[28443]="0:4:4:1:Leather::1:0:", -- General's Dragonhide Belt
	[28444]="0:4:4:1:Leather::1:0:", -- General's Dragonhide Boots
	[28445]="0:4:4:1:Leather::1:0:", -- General's Dragonhide Bracers
	[28446]="0:4:4:1:Leather::1:0:", -- General's Wyrmhide Belt
	[28447]="0:4:4:1:Leather::1:0:", -- General's Wyrmhide Boots
	[28448]="0:4:4:1:Leather::1:0:", -- General's Wyrmhide Bracers
	[28449]="0:4:4:1:Mail::1:0:", -- General's Chain Sabatons
	[28450]="0:4:4:1:Mail::1:0:", -- General's Chain Girdle
	[28451]="0:4:4:1:Mail::1:0:", -- General's Chain Bracers
	[28452]="0:12:1:20:::1:0:", -- Bloodgem Shard
	[28453]="0:4:4:1:Leather::1:0:", -- Bracers of the White Stag
	[28454]="0:4:4:1:Mail::1:0:", -- Stalker's War Bands
	[28455]="0:12:1:1:::1:0:", -- Archmage Vargoth's Staff
	[28457]="0:12:1:20:::1:0:", -- Ethereal Technology
	[28458]="20000:3:1:1:GemRed::1:0:19330,19538,22225,22227", -- Bold Tourmaline
	[28459]="20000:3:1:1:GemRed::1:0:19330,19538,22225,22227", -- Delicate Tourmaline
	[28460]="20000:3:1:1:GemRed::1:0:19330,19538,22225,22227", -- Teardrop Tourmaline
	[28461]="20000:3:1:1:GemRed::1:0:19330,19538,22225,22227", -- Runed Tourmaline
	[28462]="20000:3:1:1:GemRed::1:0:19330,19538,22225,22227", -- Bright Tourmaline
	[28463]="20000:3:1:1:GemBlue::1:0:19330,19538,22225,22227", -- Solid Zircon
	[28464]="20000:3:1:1:GemBlue::1:0:19330,19538,22225,22227", -- Sparkling Zircon
	[28465]="20000:3:1:1:GemBlue::1:0:19330,19538,22225,22227", -- Lustrous Zircon
	[28466]="20000:3:1:1:GemYellow::1:0:19330,19538,22225,22227", -- Brilliant Amber
	[28467]="20000:3:1:1:GemYellow::1:0:19330,19538,22225,22227", -- Smooth Amber
	[28468]="20000:3:1:1:GemYellow::1:0:19330,19538,22225,22227", -- Rigid Amber
	[28469]="20000:3:1:1:GemYellow::1:0:19330,19538,22225,22227", -- Gleaming Amber
	[28470]="20000:3:1:1:GemYellow::1:0:19330,19538,22225,22227", -- Thick Amber
	[28472]="0:12:1:1:::1:0:", -- Krasus's Compendium - Chapter 1
	[28473]="0:12:1:1:::1:0:", -- Krasus's Compendium - Chapter 2
	[28474]="0:12:1:1:::1:0:", -- Krasus's Compendium - Chapter 3
	[28475]="0:12:1:1:::1:0:", -- Heliotrope Oculus
	[28476]="0:2:4:1:TwoHandMace::1:0:", -- Gladiator's Maul
	[28477]="0:4:4:1:Cloth::1:0:", -- Harbinger Bands
	[28478]="0:15:1:1:Junk::1:0:", -- To'arch's Primers
	[28479]="0:12:1:1:::1:0:", -- Stone of Glacius
	[28481]="10000:15:3:1:Mount::1:0:17584", -- Brown Elekk
	[28483]="0:4:4:1:Plate:164:1:0:", -- Breastplate of Kings
	[28484]="0:4:4:1:Plate:164:1:0:", -- Bulwark of Kings
	[28485]="0:4:4:1:Plate::1:0:", -- Bulwark of the Ancient Kings
	[28486]="5600:0:1:20:FoodDrink::5:0:19664", -- Moser's Magnificent Muffin
	[28490]="0:12:1:1:::1:0:", -- Shaffar's Wrappings
	[28491]="0:4:3:1:Cloth::1:0:", -- Windwalker's Footwraps
	[28492]="0:4:3:1:Leather::1:0:", -- Talonite's Boots
	[28493]="0:4:3:1:Mail::1:0:", -- Dreadhawk's Schynbald
	[28494]="0:4:3:1:Plate::1:0:", -- Ravenguard's Greaves
	[28495]="0:4:2:1:Cloth::1:0:", -- Windwalker's Sash
	[28496]="0:4:2:1:Leather::1:0:", -- Talonite's Belt
	[28497]="0:4:2:1:Mail::1:0:", -- Dreadhawk's Girdle
	[28498]="0:4:2:1:Plate::1:0:", -- Ravenguard's Baldric
	[28500]="0:12:1:1:::1:0:", -- Fossil Oil
	[28501]="0:0:1:20:FoodDrink::1:0:", -- Ravager Egg Omelet
	[28502]="0:4:4:1:Plate::1:0:", -- Vambraces of Courage
	[28503]="0:4:4:1:Mail::1:0:", -- Whirlwind Bracers
	[28504]="0:2:4:1:Crossbow::1:0:", -- Steelhawk Crossbow
	[28505]="0:4:4:1:Plate::1:0:", -- Gauntlets of Renewed Hope
	[28506]="0:4:4:1:Leather::1:0:", -- Gloves of Dexterous Manipulation
	[28507]="0:4:4:1:Cloth::1:0:", -- Handwraps of Flowing Thought
	[28508]="0:4:4:1:Cloth::1:0:", -- Gloves of Saintly Blessings
	[28509]="0:4:4:1:Amulet::1:0:", -- Worgen Claw Necklace
	[28510]="0:4:4:1:Ring::1:0:", -- Spectral Band of Innervation
	[28511]="0:4:4:1:Cloth::1:0:", -- Bands of Indwelling
	[28512]="0:4:4:1:Plate::1:0:", -- Bracers of Justice
	[28513]="0:0:1:20:Consumable::1:0:", -- Demonic Rune Stone
	[28514]="0:4:4:1:Leather::1:0:", -- Bracers of Maliciousness
	[28515]="0:4:4:1:Cloth::1:0:", -- Bands of Nefarious Deeds
	[28516]="0:4:4:1:Amulet::1:0:", -- Barbed Choker of Discipline
	[28517]="0:4:4:1:Cloth::1:0:", -- Boots of Foretelling
	[28518]="0:4:4:1:Plate::1:0:", -- Iron Gauntlets of the Maiden
	[28519]="0:4:4:1:Mail::1:0:", -- Gloves of Quickening
	[28520]="0:4:4:1:Mail::1:0:", -- Gloves of Centering
	[28521]="0:4:4:1:Leather::1:0:", -- Mitts of the Treemender
	[28522]="0:2:4:1:OneHandMace::1:0:", -- Shard of the Virtuous
	[28523]="0:4:4:1:Totem::1:0:", -- Totem of Healing Rains
	[28524]="0:2:4:1:Dagger::1:0:", -- Emerald Ripper
	[28525]="0:4:4:1:OffHandFrill::1:0:", -- Signet of Unshakable Faith
	[28526]="0:12:1:1:::1:0:", -- Etherlithium Matrix Crystals
	[28527]="0:12:1:20:::1:0:", -- Mana Wraith Essence
	[28528]="0:4:4:1:Trinket::1:0:", -- Moroes' Lucky Pocket Watch
	[28529]="0:4:4:1:Cloak::1:0:", -- Royal Cloak of Arathi Kings
	[28530]="0:4:4:1:Amulet::1:0:", -- Brooch of Unquenchable Fury
	[28531]="0:2:2:1:Thrown::1:0:", -- Barbed Shrike
	[28532]="0:2:2:1:Thrown::1:0:", -- Silver Throwing Knives
	[28533]="0:2:2:1:Thrown::1:0:", -- Wooden Boomerang
	[28534]="0:2:2:1:Thrown::1:0:", -- Fel Tipped Dart
	[28535]="0:2:2:1:Thrown::1:0:", -- Amani Throwing Axe
	[28536]="0:2:2:1:Thrown::1:0:", -- Jagged Guillotine
	[28537]="0:2:2:1:Thrown::1:0:", -- Wildhammer Throwing Axe
	[28538]="0:2:2:1:Thrown::1:0:", -- Forked Shuriken
	[28539]="0:2:2:1:Thrown::1:0:", -- Razor-Edged Boomerang
	[28540]="0:2:2:1:Thrown::1:0:", -- Arakkoa Talon-Axe
	[28541]="0:2:2:1:Thrown::1:0:", -- Sawshrike
	[28542]="0:2:2:1:Thrown::1:0:", -- Heartseeker Knives
	[28543]="0:2:2:1:Thrown::1:0:", -- Dreghood Throwing Axe
	[28544]="0:2:2:1:Thrown::1:0:", -- Assassin's Shuriken
	[28545]="0:4:4:1:Leather::1:0:", -- Edgewalker Longboots
	[28547]="0:12:1:1:::1:0:", -- Elemental Power Extractor
	[28548]="0:12:1:20:::1:0:", -- Elemental Power
	[28550]="0:12:1:1:::1:0:", -- Flaming Torch
	[28551]="0:12:1:20:::1:0:", -- Fel Reaver Part
	[28552]="0:12:1:1:::1:0:", -- A Mysterious Tome
	[28553]="0:4:4:1:Ring::1:0:19772,19773", -- Band of the Exorcist
	[28554]="0:0:1:20:Consumable::1:0:", -- Shredder Spare Parts
	[28555]="0:4:4:1:Ring::1:0:19772,19773", -- Seal of the Exorcist
	[28556]="0:3:3:1:GemMeta::1:0:19772,19773", -- Swift Windfire Diamond
	[28557]="0:3:3:1:GemMeta::1:0:19772,19773", -- Swift Starfire Diamond
	[28558]="0:12:1:200:::1:0:", -- Spirit Shard
	[28559]="0:4:3:1:Plate::1:0:19772,19773", -- Exorcist's Plate Helm
	[28560]="0:4:3:1:Plate::1:0:19772,19773", -- Exorcist's Lamellar Helm
	[28561]="0:4:3:1:Leather::1:0:19772,19773", -- Exorcist's Leather Helm
	[28562]="0:12:1:1:::1:0:", -- Unyielding Battle Horn
	[28563]="0:12:1:1:::1:0:", -- Doomclaw's Hand
	[28564]="0:12:1:20:::1:0:", -- Energy Isolation Cube
	[28565]="0:4:4:1:Cloth::1:0:", -- Nethershard Girdle
	[28566]="0:4:4:1:Plate::1:0:", -- Crimson Girdle of the Indomitable
	[28567]="0:4:4:1:Mail::1:0:", -- Belt of Gale Force
	[28568]="0:4:4:1:Idol::1:0:", -- Idol of the Avian Heart
	[28569]="0:4:4:1:Plate::1:0:", -- Boots of Valiance
	[28570]="0:4:4:1:Cloak::1:0:", -- Shadow-Cloak of Dalaran
	[28571]="0:0:1:1:Consumable::1:0:", -- Blank Scroll
	[28572]="0:2:4:1:Dagger::1:0:", -- Blade of the Unrequited
	[28573]="0:2:4:1:TwoHandSword::1:0:", -- Despair
	[28574]="0:4:3:1:Leather::1:0:19772,19773", -- Exorcist's Dragonhide Helm
	[28575]="0:4:3:1:Leather::1:0:19772,19773", -- Exorcist's Wyrmhide Helm
	[28576]="0:4:3:1:Mail::1:0:19772,19773", -- Exorcist's Chain Helm
	[28577]="0:4:3:1:Mail::1:0:19772,19773", -- Exorcist's Linked Helm
	[28578]="0:4:4:1:Cloth::1:0:", -- Masquerade Gown
	[28579]="0:4:4:1:Trinket::1:0:", -- Romulo's Poison Vial
	[28580]="0:0:1:1:Consumable::1:0:", -- B'naar Console Transcription
	[28581]="0:2:4:1:Gun::1:0:", -- Wolfslayer Sniper Rifle
	[28582]="0:4:4:1:Cloak::1:0:", -- Red Riding Hood's Cloak
	[28583]="0:4:4:1:Mail::1:0:", -- Big Bad Wolf's Head
	[28584]="0:2:4:1:FistWeapon::1:0:", -- Big Bad Wolf's Paw
	[28585]="0:4:4:1:Cloth::1:0:", -- Ruby Slippers
	[28586]="0:4:4:1:Cloth::1:0:", -- Wicked Witch's Hat
	[28587]="0:2:4:1:TwoHandAxe::1:0:", -- Legacy
	[28588]="0:2:4:1:Wand::1:0:", -- Blue Diamond Witchwand
	[28589]="0:4:4:1:Mail::1:0:", -- Beastmaw Pauldrons
	[28590]="0:4:4:1:Trinket::1:0:", -- Ribbon of Sacrifice
	[28591]="0:4:4:1:Leather::1:0:", -- Earthsoul Leggings
	[28592]="0:4:4:1:Libram::1:0:", -- Libram of Souls Redeemed
	[28593]="0:4:4:1:Plate::1:0:", -- Eternium Greathelm
	[28594]="0:4:4:1:Cloth::1:0:", -- Trial-Fire Trousers
	[28595]="10000:3:2:1:GemRed::1:1:19538", -- Bright Blood Garnet
	[28596]="0:9:1:1:Jewelcrafting::1:0:", -- Design: Bright Blood Garnet
	[28597]="0:4:4:1:Plate::1:0:", -- Panzar'Thar Breastplate
	[28599]="0:4:4:1:Mail::1:0:", -- Scaled Breastplate of Carnage
	[28600]="0:4:4:1:Leather::1:0:", -- Stonebough Jerkin
	[28601]="0:4:4:1:Leather::1:0:", -- Chestguard of the Conniver
	[28602]="0:4:4:1:Cloth::1:0:", -- Robe of the Elder Scribes
	[28603]="0:4:4:1:OffHandFrill::1:0:", -- Talisman of Nightbane
	[28604]="0:2:4:1:Stave::1:0:", -- Nightstaff of the Everliving
	[28605]="0:4:4:1:Mail::1:0:", -- General's Linked Bracers
	[28606]="0:4:4:1:Shield::1:0:", -- Shield of Impenetrable Darkness
	[28607]="0:0:1:1:Consumable::1:0:", -- Sunfury Disguise
	[28608]="0:4:4:1:Plate::1:0:", -- Ironstriders of Urgency
	[28609]="0:4:4:1:Amulet::1:0:", -- Emberspur Talisman
	[28610]="0:4:4:1:Mail::1:0:", -- Ferocious Swift-Kickers
	[28611]="0:4:4:1:Shield::1:0:", -- Dragonheart Flameshield
	[28612]="0:4:4:1:Cloth::1:0:", -- Pauldrons of the Solace-Giver
	[28613]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Chain Armor
	[28614]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Chain Gauntlets
	[28615]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Chain Helm
	[28616]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Chain Leggings
	[28617]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Chain Spaulders
	[28618]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Dragonhide Gloves
	[28619]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Dragonhide Helm
	[28620]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Dragonhide Legguards
	[28621]="0:4:4:1:Plate::1:0:", -- Wrynn Dynasty Greaves
	[28622]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Dragonhide Spaulders
	[28623]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Dragonhide Tunic
	[28624]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Dreadweave Gloves
	[28625]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Dreadweave Hood
	[28626]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Dreadweave Leggings
	[28627]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Dreadweave Mantle
	[28628]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Dreadweave Robe
	[28629]="0:4:4:1:Mail::1:0:", -- General's Linked Girdle
	[28630]="0:4:4:1:Mail::1:0:", -- General's Linked Sabatons
	[28631]="0:4:4:1:Mail::1:0:", -- Dragon-Quake Shoulderguards
	[28632]="60000:9:1:1:Blacksmithing::1:0:17904", -- Plans: Adamantite Weightstone
	[28633]="0:2:4:1:Stave::1:0:", -- Staff of Infinite Mysteries
	[28634]="0:12:1:1:::1:0:", -- Scrap Reaver X6000 Controller
	[28635]="0:0:1:1:Consumable::1:0:", -- Sunfury Arcanist Robes
	[28636]="0:0:1:1:Consumable::1:0:", -- Sunfury Researcher Gloves
	[28637]="0:0:1:1:Consumable::1:0:", -- Sunfury Guardsman Medallion
	[28638]="0:4:4:1:Mail::1:0:", -- General's Mail Bracers
	[28639]="0:4:4:1:Mail::1:0:", -- General's Mail Girdle
	[28640]="0:4:4:1:Mail::1:0:", -- General's Mail Sabatons
	[28641]="0:4:4:1:Plate::1:0:", -- General's Lamellar Belt
	[28642]="0:4:4:1:Plate::1:0:", -- General's Lamellar Greaves
	[28643]="0:4:4:1:Plate::1:0:", -- General's Lamellar Bracers
	[28644]="0:4:4:1:Plate::1:0:", -- General's Scaled Belt
	[28645]="0:4:4:1:Plate::1:0:", -- General's Scaled Greaves
	[28646]="0:4:4:1:Plate::1:0:", -- General's Scaled Bracers
	[28647]="0:4:4:1:Leather::1:0:", -- Forest Wind Shoulderpads
	[28649]="0:4:4:1:Ring::1:0:", -- Garona's Signet Ring
	[28651]="0:12:1:1:::1:0:", -- Unyielding Battle Horn
	[28652]="0:4:4:1:Cloth::1:0:", -- Cincture of Will
	[28653]="0:4:4:1:Cloak::1:0:", -- Shadowvine Cloak of Infusion
	[28654]="0:4:4:1:Cloth::1:0:", -- Malefic Girdle
	[28655]="0:4:4:1:Leather::1:0:", -- Cord of Nature's Sustenance
	[28656]="0:4:4:1:Mail::1:0:", -- Girdle of the Prowler
	[28657]="0:2:4:1:OneHandMace::1:0:", -- Fool's Bane
	[28658]="0:2:4:1:Stave::1:0:", -- Terestian's Stranglestaff
	[28659]="0:2:4:1:Thrown::1:0:", -- Xavian Stiletto
	[28660]="0:4:4:1:Cloak::1:0:", -- Gilded Thorium Cloak
	[28661]="0:4:4:1:Ring::1:0:", -- Mender's Heart-Ring
	[28662]="0:4:4:1:Plate::1:0:", -- Breastplate of the Lightbinder
	[28663]="0:4:4:1:Cloth::1:0:", -- Boots of the Incorrupt
	[28664]="0:15:0:1:Junk::1:0:", -- Nitrin's Instructions
	[28665]="0:12:1:1:::1:0:", -- Mountain Gronn Eyeball
	[28666]="0:4:4:1:Plate::1:0:", -- Pauldrons of the Justice-Seeker
	[28667]="0:12:1:1:::1:0:", -- Flawless Greater Windroc Beak
	[28668]="0:12:1:1:::1:0:", -- Aged Clefthoof Blubber
	[28669]="0:4:4:1:Leather::1:0:", -- Rapscallion Boots
	[28670]="0:4:4:1:Cloth::1:0:", -- Boots of the Infernal Coven
	[28671]="0:4:4:1:Mail::1:0:", -- Steelspine Faceguard
	[28672]="0:4:4:1:Cloak::1:0:", -- Drape of the Dark Reavers
	[28673]="0:2:4:1:Wand::1:0:", -- Tirisfal Wand of Ascendancy
	[28674]="0:4:4:1:Amulet::1:0:", -- Saberclaw Talisman
	[28675]="0:4:4:1:Ring::1:0:", -- Shermanar Great-Ring
	[28677]="0:15:1:1:Junk::1:0:", -- The Book of the Dead
	[28679]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Lamellar Chestpiece
	[28680]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Lamellar Gauntlets
	[28681]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Lamellar Helm
	[28683]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Lamellar Shoulders
	[28684]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Leather Gloves
	[28685]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Leather Helm
	[28686]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Leather Legguards
	[28687]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Leather Spaulders
	[28688]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Leather Tunic
	[28689]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Linked Armor
	[28690]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Linked Gauntlets
	[28691]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Linked Helm
	[28692]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Linked Leggings
	[28693]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Linked Spaulders
	[28694]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Mail Armor
	[28695]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Mail Gauntlets
	[28696]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Mail Helm
	[28697]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Mail Leggings
	[28698]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Mail Spaulders
	[28699]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Plate Chestpiece
	[28700]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Plate Gauntlets
	[28701]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Plate Helm
	[28702]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Plate Legguards
	[28703]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Plate Shoulders
	[28704]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Satin Gloves
	[28705]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Satin Hood
	[28706]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Satin Leggings
	[28707]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Satin Mantle
	[28708]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Satin Robe
	[28709]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Scaled Chestpiece
	[28710]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Scaled Gauntlets
	[28711]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Scaled Helm
	[28712]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Scaled Legguards
	[28713]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Scaled Shoulders
	[28714]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Silk Amice
	[28715]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Silk Cowl
	[28716]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Silk Handguards
	[28717]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Silk Raiment
	[28718]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Silk Trousers
	[28719]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Wyrmhide Gloves
	[28720]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Wyrmhide Helm
	[28721]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Wyrmhide Legguards
	[28722]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Wyrmhide Spaulders
	[28723]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Wyrmhide Tunic
	[28724]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Lamellar Legguards
	[28725]="0:12:1:1:::1:0:", -- Rune Activation Device
	[28726]="0:4:4:1:Cloth::1:0:", -- Mantle of the Mind Flayer
	[28727]="0:4:4:1:Trinket::1:0:", -- Pendant of the Violet Eye
	[28728]="0:4:4:1:OffHandFrill::1:0:", -- Aran's Soothing Sapphire
	[28729]="0:2:4:1:OneHandSword::1:0:", -- Spiteblade
	[28730]="0:4:4:1:Ring::1:0:", -- Mithril Band of the Unscarred
	[28731]="0:4:4:1:Amulet::1:0:", -- Shining Chain of the Afterworld
	[28732]="0:4:4:1:Leather::1:0:", -- Cowl of Defiance
	[28733]="0:4:4:1:Plate::1:0:", -- Girdle of Truth
	[28734]="0:4:4:1:OffHandFrill::1:0:", -- Jewel of Infinite Possibilities
	[28735]="0:4:4:1:Mail::1:0:", -- Earthblood Chestguard
	[28740]="0:4:4:1:Mail::1:0:", -- Rip-Flayer Leggings
	[28741]="0:4:4:1:Leather::1:0:", -- Skulker's Greaves
	[28742]="0:4:4:1:Cloth::1:0:", -- Pantaloons of Repentance
	[28743]="0:4:4:1:Plate::1:0:", -- Mantle of Abrahmis
	[28744]="0:4:4:1:Cloth::1:0:", -- Uni-Mind Headdress
	[28745]="0:4:4:1:Amulet::1:0:", -- Mithril Chain of Heroism
	[28746]="0:4:4:1:Mail::1:0:", -- Fiend Slayer Boots
	[28747]="0:4:4:1:Plate::1:0:", -- Battlescar Boots
	[28748]="0:4:4:1:Plate::1:0:", -- Legplates of the Innocent
	[28749]="0:2:4:1:OneHandSword::1:0:", -- King's Defender
	[28750]="0:4:4:1:Leather::1:0:", -- Girdle of Treachery
	[28751]="0:4:4:1:Mail::1:0:", -- Heart-Flame Leggings
	[28752]="0:4:4:1:Leather::1:0:", -- Forestlord Striders
	[28753]="0:4:4:1:Ring::1:0:", -- Ring of Recurrence
	[28754]="0:4:4:1:Shield::1:0:", -- Triptych Shield of the Ancients
	[28755]="0:4:4:1:Leather::1:0:", -- Bladed Shoulderpads of the Merciless
	[28756]="0:4:4:1:Cloth::1:0:", -- Headdress of the High Potentate
	[28757]="0:4:4:1:Ring::1:0:", -- Ring of a Thousand Marks
	[28758]="0:4:3:1:Mail::1:0:19772,19773", -- Exorcist's Mail Helm
	[28759]="0:4:3:1:Cloth::1:0:19772,19773", -- Exorcist's Dreadweave Hood
	[28760]="0:4:3:1:Cloth::1:0:19772,19773", -- Exorcist's Silk Hood
	[28761]="0:4:3:1:Plate::1:0:19772,19773", -- Exorcist's Scaled Helm
	[28762]="0:4:4:1:Amulet::1:0:", -- Adornment of Stolen Souls
	[28763]="0:4:4:1:Ring::1:0:", -- Jade Ring of the Everliving
	[28764]="0:4:4:1:Cloak::1:0:", -- Farstrider Wildercloak
	[28765]="0:4:4:1:Cloak::1:0:", -- Stainless Cloak of the Pure Hearted
	[28766]="0:4:4:1:Cloak::1:0:", -- Ruby Drape of the Mysticant
	[28767]="0:2:4:1:OneHandAxe::1:0:", -- The Decapitator
	[28768]="0:2:4:1:Dagger::1:0:", -- Malchazeen
	[28769]="0:12:1:1:::1:0:", -- The Keystone
	[28770]="0:2:4:1:Dagger::1:0:", -- Nathrezim Mindblade
	[28771]="0:2:4:1:OneHandMace::1:0:", -- Light's Justice
	[28772]="0:2:4:1:Bow::1:0:", -- Sunfury Bow of the Phoenix
	[28773]="0:2:4:1:TwoHandAxe::1:0:", -- Gorehowl
	[28774]="0:2:4:1:Polearm::1:0:", -- Glaive of the Pit
	[28775]="0:4:4:1:Plate::1:0:", -- Thundering Greathelm
	[28776]="0:4:4:1:Leather::1:0:", -- Liar's Tongue Gloves
	[28777]="0:4:4:1:Cloak::1:0:", -- Cloak of the Pit Stalker
	[28778]="0:4:4:1:Mail::1:0:", -- Terror Pit Girdle
	[28779]="0:4:4:1:Plate::1:0:", -- Girdle of the Endless Pit
	[28780]="0:4:4:1:Cloth::1:0:", -- Soul-Eater's Handwraps
	[28781]="0:4:4:1:OffHandFrill::1:0:", -- Karaborian Talisman
	[28782]="0:2:4:1:Stave::1:0:", -- Crystalheart Pulse-Staff
	[28783]="0:2:4:1:Wand::1:0:", -- Eredar Wand of Obliteration
	[28784]="0:0:1:1:Consumable::1:0:", -- Unyielding Banner Scrap
	[28785]="0:4:4:1:Trinket::1:0:", -- The Lightning Capacitor
	[28786]="0:12:1:1:::1:0:", -- Apex's Crystal Focus
	[28787]="0:12:1:1:::1:0:", -- Annihilator Servo
	[28788]="0:4:1:1:Tabard::1:0:", -- Tabard of the Protector
	[28789]="0:4:4:1:Trinket::1:0:", -- Eye of Magtheridon
	[28790]="0:4:4:1:Ring::1:0:", -- Naaru Lightwarden's Band
	[28791]="0:4:4:1:Ring::1:0:", -- Ring of the Recalcitrant
	[28792]="0:4:4:1:Ring::1:0:", -- A'dal's Signet of Defense
	[28793]="0:4:4:1:Ring::1:0:", -- Band of Crimson Fury
	[28794]="0:2:4:1:TwoHandAxe::1:0:", -- Axe of the Gronn Lords
	[28795]="0:4:4:1:Plate::1:0:", -- Bladespire Warbands
	[28796]="0:4:4:1:Leather::1:0:", -- Malefic Mask of the Shadows
	[28797]="0:4:4:1:Cloak::1:0:", -- Brute Cloak of the Ogre-Magi
	[28799]="0:4:4:1:Cloth::1:0:", -- Belt of Divine Inspiration
	[28800]="0:2:4:1:TwoHandMace::1:0:", -- Hammer of the Naaru
	[28801]="0:4:4:1:Mail::1:0:", -- Maulgar's Warhelm
	[28802]="0:2:4:1:OneHandSword::1:0:", -- Bloodmaw Magus-Blade
	[28803]="0:4:4:1:Leather::1:0:", -- Cowl of Nature's Breath
	[28804]="0:4:4:1:Cloth::1:0:", -- Collar of Cho'gall
	[28805]="0:4:3:1:Mail::1:0:", -- High Warlord's Chain Armor
	[28806]="0:4:3:1:Mail::1:0:", -- High Warlord's Chain Gauntlets
	[28807]="0:4:3:1:Mail::1:0:", -- High Warlord's Chain Helm
	[28808]="0:4:3:1:Mail::1:0:", -- High Warlord's Chain Leggings
	[28809]="0:4:3:1:Mail::1:0:", -- High Warlord's Chain Spaulders
	[28810]="0:4:4:1:Mail::1:0:", -- Windshear Boots
	[28811]="0:4:3:1:Leather::1:0:", -- High Warlord's Dragonhide Gloves
	[28812]="0:4:3:1:Leather::1:0:", -- High Warlord's Dragonhide Helm
	[28813]="0:4:3:1:Leather::1:0:", -- High Warlord's Dragonhide Legguards
	[28814]="0:4:3:1:Leather::1:0:", -- High Warlord's Dragonhide Spaulders
	[28815]="0:4:3:1:Leather::1:0:", -- High Warlord's Dragonhide Tunic
	[28817]="0:4:3:1:Cloth::1:0:", -- High Warlord's Dreadweave Gloves
	[28818]="0:4:3:1:Cloth::1:0:", -- High Warlord's Dreadweave Hood
	[28819]="0:4:3:1:Cloth::1:0:", -- High Warlord's Dreadweave Leggings
	[28820]="0:4:3:1:Cloth::1:0:", -- High Warlord's Dreadweave Mantle
	[28821]="0:4:3:1:Cloth::1:0:", -- High Warlord's Dreadweave Robe
	[28822]="0:4:4:1:Amulet::1:0:", -- Teeth of Gruul
	[28823]="0:4:4:1:Trinket::1:0:", -- Eye of Gruul
	[28824]="0:4:4:1:Plate::1:0:", -- Gauntlets of Martial Perfection
	[28825]="0:4:4:1:Shield::1:0:", -- Aldori Legacy Defender
	[28826]="0:2:4:1:Thrown::1:0:", -- Shuriken of Negation
	[28827]="0:4:4:1:Mail::1:0:", -- Gauntlets of the Dragonslayer
	[28828]="0:4:4:1:Leather::1:0:", -- Gronn-Stitched Girdle
	[28829]="0:12:1:1:::1:0:", -- Arklon Crystal Artifact
	[28830]="0:4:4:1:Trinket::1:0:", -- Dragonspine Trophy
	[28831]="0:4:3:1:Plate::1:0:", -- High Warlord's Lamellar Chestpiece
	[28832]="0:4:3:1:Plate::1:0:", -- High Warlord's Lamellar Gauntlets
	[28833]="0:4:3:1:Plate::1:0:", -- High Warlord's Lamellar Helm
	[28834]="0:4:3:1:Plate::1:0:", -- High Warlord's Lamellar Legguards
	[28835]="0:4:3:1:Plate::1:0:", -- High Warlord's Lamellar Shoulders
	[28836]="0:4:3:1:Leather::1:0:", -- High Warlord's Leather Gloves
	[28837]="0:4:3:1:Leather::1:0:", -- High Warlord's Leather Helm
	[28838]="0:4:3:1:Leather::1:0:", -- High Warlord's Leather Legguards
	[28839]="0:4:3:1:Leather::1:0:", -- High Warlord's Leather Spaulders
	[28840]="0:4:3:1:Leather::1:0:", -- High Warlord's Leather Tunic
	[28841]="0:4:3:1:Mail::1:0:", -- High Warlord's Linked Armor
	[28842]="0:4:3:1:Mail::1:0:", -- High Warlord's Linked Gauntlets
	[28843]="0:4:3:1:Mail::1:0:", -- High Warlord's Linked Helm
	[28844]="0:4:3:1:Mail::1:0:", -- High Warlord's Linked Leggings
	[28845]="0:4:3:1:Mail::1:0:", -- High Warlord's Linked Spaulders
	[28846]="0:4:3:1:Mail::1:0:", -- High Warlord's Mail Armor
	[28847]="0:4:3:1:Mail::1:0:", -- High Warlord's Mail Gauntlets
	[28848]="0:4:3:1:Mail::1:0:", -- High Warlord's Mail Helm
	[28849]="0:4:3:1:Mail::1:0:", -- High Warlord's Mail Leggings
	[28850]="0:4:3:1:Mail::1:0:", -- High Warlord's Mail Spaulders
	[28851]="0:4:3:1:Plate::1:0:", -- High Warlord's Plate Chestpiece
	[28852]="0:4:3:1:Plate::1:0:", -- High Warlord's Plate Gauntlets
	[28853]="0:4:3:1:Plate::1:0:", -- High Warlord's Plate Helm
	[28854]="0:4:3:1:Plate::1:0:", -- High Warlord's Plate Legguards
	[28855]="0:4:3:1:Plate::1:0:", -- High Warlord's Plate Shoulders
	[28856]="0:4:3:1:Cloth::1:0:", -- High Warlord's Satin Gloves
	[28857]="0:4:3:1:Cloth::1:0:", -- High Warlord's Satin Hood
	[28858]="0:4:3:1:Cloth::1:0:", -- High Warlord's Satin Leggings
	[28859]="0:4:3:1:Cloth::1:0:", -- High Warlord's Satin Mantle
	[28860]="0:4:3:1:Cloth::1:0:", -- High Warlord's Satin Robe
	[28861]="0:4:3:1:Plate::1:0:", -- High Warlord's Scaled Chestpiece
	[28862]="0:4:3:1:Plate::1:0:", -- High Warlord's Scaled Gauntlets
	[28863]="0:4:3:1:Plate::1:0:", -- High Warlord's Scaled Helm
	[28864]="0:4:3:1:Plate::1:0:", -- High Warlord's Scaled Legguards
	[28865]="0:4:3:1:Plate::1:0:", -- High Warlord's Scaled Shoulders
	[28866]="0:4:3:1:Cloth::1:0:", -- High Warlord's Silk Amice
	[28867]="0:4:3:1:Cloth::1:0:", -- High Warlord's Silk Cowl
	[28868]="0:4:3:1:Cloth::1:0:", -- High Warlord's Silk Handguards
	[28869]="0:4:3:1:Cloth::1:0:", -- High Warlord's Silk Raiment
	[28870]="0:4:3:1:Cloth::1:0:", -- High Warlord's Silk Trousers
	[28871]="0:4:3:1:Leather::1:0:", -- High Warlord's Wyrmhide Gloves
	[28872]="0:4:3:1:Leather::1:0:", -- High Warlord's Wyrmhide Helm
	[28873]="0:4:3:1:Leather::1:0:", -- High Warlord's Wyrmhide Legguards
	[28874]="0:4:3:1:Leather::1:0:", -- High Warlord's Wyrmhide Spaulders
	[28875]="0:4:3:1:Leather::1:0:", -- High Warlord's Wyrmhide Tunic
	[28878]="0:0:2:1:EnhPerm::1:0:20807", -- Inscription of Faith
	[28881]="0:0:2:1:EnhPerm::1:0:20807", -- Inscription of Discipline
	[28882]="0:0:2:1:EnhPerm::1:0:20807", -- Inscription of Warding
	[28885]="0:0:2:1:EnhPerm::1:0:20807", -- Inscription of Vengeance
	[28886]="0:0:3:1:EnhPerm::1:0:20807", -- Greater Inscription of Discipline
	[28887]="0:0:3:1:EnhPerm::1:0:20807", -- Greater Inscription of Faith
	[28888]="0:0:3:1:EnhPerm::1:0:20807", -- Greater Inscription of Vengeance
	[28889]="0:0:3:1:EnhPerm::1:0:20807", -- Greater Inscription of Warding
	[28903]="0:0:2:1:EnhPerm::1:0:20808", -- Inscription of the Orb
	[28904]="0:0:2:1:EnhPerm::1:0:20808", -- Inscription of the Oracle
	[28907]="0:0:2:1:EnhPerm::1:0:20808", -- Inscription of the Blade
	[28908]="0:0:2:1:EnhPerm::1:0:20808", -- Inscription of the Knight
	[28909]="0:0:3:1:EnhPerm::1:0:20808", -- Greater Inscription of the Orb
	[28910]="0:0:3:1:EnhPerm::1:0:20808", -- Greater Inscription of the Blade
	[28911]="0:0:3:1:EnhPerm::1:0:20808", -- Greater Inscription of the Knight
	[28912]="0:0:3:1:EnhPerm::1:0:20808", -- Greater Inscription of the Oracle
	[28913]="0:12:1:20:::1:0:", -- Box of Surveying Equipment
	[28915]="0:15:4:1:Mount::1:0:21474,21485", -- Reins of the Dark Riding Talbuk
	[28917]="0:2:3:1:TwoHandMace::1:0:", -- High Warlord's Bonegrinder
	[28918]="0:2:3:1:TwoHandAxe::1:0:", -- High Warlord's Decapitator
	[28919]="0:2:3:1:TwoHandMace::1:0:", -- High Warlord's Maul
	[28920]="0:2:3:1:OneHandAxe::1:0:", -- High Warlord's Cleaver
	[28921]="0:2:3:1:OneHandAxe::1:0:", -- High Warlord's Hacker
	[28922]="0:2:3:1:FistWeapon::1:0:", -- High Warlord's Left Ripper
	[28923]="0:2:3:1:Polearm::1:0:", -- High Warlord's Painsaw
	[28924]="0:2:3:1:OneHandMace::1:0:", -- High Warlord's Bonecracker
	[28925]="0:2:3:1:OneHandMace::1:0:", -- High Warlord's Pummeler
	[28926]="0:2:3:1:OneHandSword::1:0:", -- High Warlord's Quickblade
	[28927]="10000:15:3:1:Mount::1:0:16264", -- Red Hawkstrider
	[28928]="0:2:3:1:FistWeapon::1:0:", -- High Warlord's Right Ripper
	[28929]="0:2:3:1:Dagger::1:0:", -- High Warlord's Shanker
	[28930]="0:2:3:1:Dagger::1:0:", -- High Warlord's Shiv
	[28931]="0:2:3:1:Dagger::1:0:", -- High Warlord's Spellblade
	[28933]="0:2:3:1:Crossbow::1:0:", -- High Warlord's Heavy Crossbow
	[28934]="0:12:1:1:::1:0:", -- Surveying Equipment
	[28935]="0:2:3:1:Stave::1:0:", -- High Warlord's War Staff
	[28936]="100000:15:4:1:Mount::1:0:16264", -- Swift Pink Hawkstrider
	[28937]="0:2:3:1:OneHandSword::1:0:", -- High Warlord's Slicer
	[28938]="0:4:3:1:OffHandFrill::1:0:", -- High Warlord's Battletome
	[28939]="0:4:3:1:Shield::1:0:", -- High Warlord's Barricade
	[28940]="0:4:3:1:Shield::1:0:", -- Grand Marshal's Barricade
	[28941]="0:4:3:1:OffHandFrill::1:0:", -- Grand Marshal's Battletome
	[28942]="0:2:3:1:TwoHandMace::1:0:", -- Grand Marshal's Bonegrinder
	[28943]="0:2:3:1:TwoHandSword::1:0:", -- Grand Marshal's Warblade
	[28944]="0:2:3:1:OneHandAxe::1:0:", -- Grand Marshal's Cleaver
	[28945]="0:2:3:1:TwoHandAxe::1:0:", -- Grand Marshal's Decapitator
	[28946]="0:2:3:1:OneHandAxe::1:0:", -- Grand Marshal's Hacker
	[28947]="0:2:3:1:FistWeapon::1:0:", -- Grand Marshal's Left Ripper
	[28948]="0:2:3:1:TwoHandMace::1:0:", -- Grand Marshal's Maul
	[28949]="0:2:3:1:Polearm::1:0:", -- Grand Marshal's Painsaw
	[28950]="0:2:3:1:OneHandMace::1:0:", -- Grand Marshal's Bonecracker
	[28951]="0:2:3:1:OneHandMace::1:0:", -- Grand Marshal's Pummeler
	[28952]="0:2:3:1:OneHandSword::1:0:", -- Grand Marshal's Quickblade
	[28953]="0:2:3:1:FistWeapon::1:0:", -- Grand Marshal's Right Ripper
	[28954]="0:2:3:1:Dagger::1:0:", -- Grand Marshal's Shanker
	[28955]="0:2:3:1:Dagger::1:0:", -- Grand Marshal's Shiv
	[28956]="0:2:3:1:OneHandSword::1:0:", -- Grand Marshal's Slicer
	[28957]="0:2:3:1:Dagger::1:0:", -- Grand Marshal's Spellblade
	[28959]="0:2:3:1:Stave::1:0:", -- Grand Marshal's War Staff
	[28960]="0:2:3:1:Crossbow::1:0:", -- Grand Marshal's Heavy Crossbow
	[28962]="0:12:1:1:::1:0:", -- Triangulation Device
	[28963]="0:4:4:1:Cloth::1:0:20613,20616", -- Voidheart Crown
	[28964]="0:4:4:1:Cloth::1:0:20613,20616", -- Voidheart Robe
	[28966]="0:4:4:1:Cloth::1:0:20613,20616", -- Voidheart Leggings
	[28967]="0:4:4:1:Cloth::1:0:20613,20616", -- Voidheart Mantle
	[28968]="0:4:4:1:Cloth::1:0:20613,20616", -- Voidheart Gloves
	[28969]="0:12:1:1:::1:0:", -- Teleporter Power Pack
	[28970]="0:12:1:15:::1:0:", -- Nether Dragon Essence
	[28971]="0:12:1:20:::1:0:", -- Nether Dragonkin Egg
	[28972]="0:2:3:1:Thrown::1:0:", -- Flightblade Throwing Axe
	[28973]="0:4:4:1:Mail::1:0:", -- Marshal's Chain Bracers
	[28974]="0:4:4:1:Mail::1:0:", -- Marshal's Chain Girdle
	[28975]="0:4:4:1:Mail::1:0:", -- Marshal's Chain Sabatons
	[28976]="0:4:4:1:Leather::1:0:", -- Marshal's Dragonhide Belt
	[28977]="0:4:4:1:Leather::1:0:", -- Marshal's Dragonhide Boots
	[28978]="0:4:4:1:Leather::1:0:", -- Marshal's Dragonhide Bracers
	[28979]="15:2:1:1:Thrown::1:0:151,152,491,829,1250,1285,1682,1685,1691,2115,2134,2140,3072,3076,3158,3164,3186,3313,3481,3587,3608,4170,4182,4241,8362,16187,16191,16259,16260,16444,16732,17421,17446,17489,18810", -- Light Throwing Knife
	[28980]="0:4:4:1:Cloth::1:0:", -- Marshal's Dreadweave Belt
	[28981]="0:4:4:1:Cloth::1:0:", -- Marshal's Dreadweave Cuffs
	[28982]="0:4:4:1:Cloth::1:0:", -- Marshal's Dreadweave Stalkers
	[28983]="0:4:4:1:Plate::1:0:", -- Marshal's Lamellar Belt
	[28984]="0:4:4:1:Plate::1:0:", -- Marshal's Lamellar Bracers
	[28985]="0:4:4:1:Plate::1:0:", -- Marshal's Lamellar Greaves
	[28986]="0:4:4:1:Leather::1:0:", -- Marshal's Leather Belt
	[28987]="0:4:4:1:Leather::1:0:", -- Marshal's Leather Boots
	[28988]="0:4:4:1:Leather::1:0:", -- Marshal's Leather Bracers
	[28989]="0:4:4:1:Mail::1:0:", -- Marshal's Linked Bracers
	[28990]="0:4:4:1:Mail::1:0:", -- Marshal's Linked Girdle
	[28991]="0:4:4:1:Mail::1:0:", -- Marshal's Linked Sabatons
	[28992]="0:4:4:1:Mail::1:0:", -- Marshal's Mail Bracers
	[28993]="0:4:4:1:Mail::1:0:", -- Marshal's Mail Girdle
	[28994]="0:4:4:1:Mail::1:0:", -- Marshal's Mail Sabatons
	[28995]="0:4:4:1:Plate::1:0:", -- Marshal's Plate Belt
	[28996]="0:4:4:1:Plate::1:0:", -- Marshal's Plate Bracers
	[28997]="0:4:4:1:Plate::1:0:", -- Marshal's Plate Greaves
	[28998]="0:4:4:1:Plate::1:0:", -- Marshal's Scaled Belt
	[28999]="0:4:4:1:Plate::1:0:", -- Marshal's Scaled Bracers
	[29000]="0:4:4:1:Plate::1:0:", -- Marshal's Scaled Greaves
	[29001]="0:4:4:1:Cloth::1:0:", -- Marshal's Silk Belt
	[29002]="0:4:4:1:Cloth::1:0:", -- Marshal's Silk Cuffs
	[29003]="0:4:4:1:Cloth::1:0:", -- Marshal's Silk Footguards
	[29004]="0:4:4:1:Leather::1:0:", -- Marshal's Wyrmhide Belt
	[29005]="0:4:4:1:Leather::1:0:", -- Marshal's Wyrmhide Boots
	[29006]="0:4:4:1:Leather::1:0:", -- Marshal's Wyrmhide Bracers
	[29007]="30:2:1:1:Thrown::1:0:151,491,791,1250,1285,1682,1685,1691,2134,2140,3076,3164,3186,3313,3481,3498,3608,4082,4084,4170,4182,4241,4555,7942,8362,12027,12960,16187,16191,16259,16260,16444,16732,17421,17446,17489,18810,18811,32253", -- Weighted Throwing Axe
	[29008]="75:2:1:1:Thrown::1:0:227,791,1285,1448,1452,2401,2803,2806,3313,3498,3541,3962,4082,4084,4555,4876,7942,8139,8362,12021,12027,12960,16191,16732,17489,18811,32253", -- Sharp Throwing Axe
	[29009]="200:2:1:1:Thrown::1:0:227,734,1149,1285,1448,1452,2084,2401,2803,2806,2808,2820,2908,3313,3350,3541,3625,3962,4170,4241,4555,4876,4896,5101,5134,7942,8139,8362,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16732,17489", -- Heavy Throwing Dagger
	[29010]="800:2:1:1:Thrown::1:0:734,1149,1285,2084,2401,2803,2806,2808,2820,2908,3313,3350,3541,3625,4170,4241,4555,4896,5101,5134,7942,8139,8362,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16732", -- Wicked Throwing Dagger
	[29011]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Greathelm
	[29012]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Chestguard
	[29013]="800:2:1:1:Thrown::1:0:734,1149,1285,2084,2401,2803,2806,2808,2820,2908,3313,3350,3541,3625,4170,4241,4555,4896,5101,5134,7942,8139,8362,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16732,16826,18011,18907,18959,19020,19021,19053,19197,19243,19314,19315,19343,19374,19436,19452,19473,19474,19498,19534,19560,19574,19625,19649,19679,20080,20092,20194,20231,20249,20892,21082,21111,21172,21183,22099,22270,23143,23802,24053,24141,24188,24348,25035,26388,26718,26934,26936,26938,27011,27022,27025,27041,27051,27058,27071,27145,27182,27193,27940,28691,28792,28807,28830,28867,29035,29207,29908,29925,29944,29962,29970,30011,30070,30256,30257,30310,30437,31022,32253,32477,32638,32642,33872", -- Jagged Throwing Axe
	[29014]="800:2:1:1:Thrown::1:0:734,1149,1285,2084,2401,2803,2806,2808,2820,2908,3313,3350,3541,3625,4170,4241,4555,4896,5101,5134,7942,8139,8362,11038,11555,12021,12027,12246,12959,12960,14624,15174,15397,16191,16732,16826,18011,18907,18959,19020,19021,19053,19197,19243,19314,19315,19343,19374,19436,19452,19473,19474,19498,19534,19560,19574,19625,19649,19679,20080,20092,20194,20231,20249,20892,21082,21111,21172,21183,22099,22270,23143,23802,24053,24141,24188,24348,25035,26388,26718,26934,26936,26938,27011,27022,27025,27041,27051,27058,27071,27145,27182,27193,27940,28691,28792,28807,28830,28867,29035,29207,29908,29925,29944,29962,29970,30011,30070,30256,30257,30310,30437,31022,32477,32638,32642,33872", -- Blacksteel Throwing Dagger
	[29015]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Legguards
	[29016]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Shoulderguards
	[29017]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Handguards
	[29018]="0:12:1:1:::1:0:", -- Triangulation Device
	[29019]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Breastplate
	[29020]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Gauntlets
	[29021]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Battle-Helm
	[29022]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Greaves
	[29023]="0:4:4:1:Plate::1:0:20613,20616", -- Warbringer Shoulderplates
	[29024]="0:10:2::Currency::1:0:", -- Eye of the Storm Mark of Honor
	[29026]="0:12:1:1:::1:0:", -- Ata'mal Crystal
	[29027]="0:12:1:1:::1:0:", -- Unstable Warp Rift Generator
	[29028]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Headdress
	[29029]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Hauberk
	[29030]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Kilt
	[29031]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Shoulderpads
	[29032]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Gloves
	[29033]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Chestguard
	[29034]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Handguards
	[29035]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Faceguard
	[29036]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Legguards
	[29037]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Shoulderguards
	[29038]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Breastplate
	[29039]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Gauntlets
	[29040]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Helm
	[29042]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone War-Kilt
	[29043]="0:4:4:1:Mail::1:0:20613,20616", -- Cyclone Shoulderplates
	[29044]="0:4:4:1:Leather::1:0:20613,20616", -- Netherblade Facemask
	[29045]="0:4:4:1:Leather::1:0:20613,20616", -- Netherblade Chestpiece
	[29046]="0:4:4:1:Leather::1:0:20613,20616", -- Netherblade Breeches
	[29047]="0:4:4:1:Leather::1:0:20613,20616", -- Netherblade Shoulderpads
	[29048]="0:4:4:1:Leather::1:0:20613,20616", -- Netherblade Gloves
	[29049]="0:4:4:1:Cloth::1:0:20613,20616", -- Light-Collar of the Incarnate
	[29050]="0:4:4:1:Cloth::1:0:20613,20616", -- Robes of the Incarnate
	[29051]="0:12:1:5:::1:0:", -- Warp Nether
	[29053]="0:4:4:1:Cloth::1:0:20613,20616", -- Trousers of the Incarnate
	[29054]="0:4:4:1:Cloth::1:0:20613,20616", -- Light-Mantle of the Incarnate
	[29055]="0:4:4:1:Cloth::1:0:20613,20616", -- Handwraps of the Incarnate
	[29056]="0:4:4:1:Cloth::1:0:20613,20616", -- Shroud of the Incarnate
	[29057]="0:4:4:1:Cloth::1:0:20613,20616", -- Gloves of the Incarnate
	[29058]="0:4:4:1:Cloth::1:0:20613,20616", -- Soul-Collar of the Incarnate
	[29059]="0:4:4:1:Cloth::1:0:20613,20616", -- Leggings of the Incarnate
	[29060]="0:4:4:1:Cloth::1:0:20613,20616", -- Soul-Mantle of the Incarnate
	[29061]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Diadem
	[29062]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Chestpiece
	[29063]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Leggings
	[29064]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Pauldrons
	[29065]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Gloves
	[29066]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Chestguard
	[29067]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Handguards
	[29068]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Faceguard
	[29069]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Legguards
	[29070]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Shoulderguards
	[29071]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Breastplate
	[29072]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Gauntlets
	[29073]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Crown
	[29074]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Greaves
	[29075]="0:4:4:1:Plate::1:0:20613,20616", -- Justicar Shoulderplates
	[29076]="0:4:4:1:Cloth::1:0:20613,20616", -- Collar of the Aldor
	[29077]="0:4:4:1:Cloth::1:0:20613,20616", -- Vestments of the Aldor
	[29078]="0:4:4:1:Cloth::1:0:20613,20616", -- Legwraps of the Aldor
	[29079]="0:4:4:1:Cloth::1:0:20613,20616", -- Pauldrons of the Aldor
	[29080]="0:4:4:1:Cloth::1:0:20613,20616", -- Gloves of the Aldor
	[29081]="0:4:4:1:Mail::1:0:20613,20616", -- Demon Stalker Greathelm
	[29082]="0:4:4:1:Mail::1:0:20613,20616", -- Demon Stalker Harness
	[29083]="0:4:4:1:Mail::1:0:20613,20616", -- Demon Stalker Greaves
	[29084]="0:4:4:1:Mail::1:0:20613,20616", -- Demon Stalker Shoulderguards
	[29085]="0:4:4:1:Mail::1:0:20613,20616", -- Demon Stalker Gauntlets
	[29086]="0:4:4:1:Leather::1:0:20613,20616", -- Crown of Malorne
	[29087]="0:4:4:1:Leather::1:0:20613,20616", -- Chestguard of Malorne
	[29088]="0:4:4:1:Leather::1:0:20613,20616", -- Legguards of Malorne
	[29089]="0:4:4:1:Leather::1:0:20613,20616", -- Shoulderguards of Malorne
	[29090]="0:4:4:1:Leather::1:0:20613,20616", -- Handguards of Malorne
	[29091]="0:4:4:1:Leather::1:0:20613,20616", -- Chestpiece of Malorne
	[29092]="0:4:4:1:Leather::1:0:20613,20616", -- Gloves of Malorne
	[29093]="0:4:4:1:Leather::1:0:20613,20616", -- Antlers of Malorne
	[29094]="0:4:4:1:Leather::1:0:20613,20616", -- Britches of Malorne
	[29095]="0:4:4:1:Leather::1:0:20613,20616", -- Pauldrons of Malorne
	[29096]="0:4:4:1:Leather::1:0:20613,20616", -- Breastplate of Malorne
	[29097]="0:4:4:1:Leather::1:0:20613,20616", -- Gauntlets of Malorne
	[29098]="0:4:4:1:Leather::1:0:20613,20616", -- Stag-Helm of Malorne
	[29099]="0:4:4:1:Leather::1:0:20613,20616", -- Greaves of Malorne
	[29100]="0:4:4:1:Leather::1:0:20613,20616", -- Mantle of Malorne
	[29101]="0:12:1:1:::1:0:", -- Challenge of the Blue Flight
	[29102]="1000000:15:4:1:Mount::1:0:20241", -- Reins of the Cobalt War Talbuk
	[29103]="1000000:15:4:1:Mount::1:0:20241", -- Reins of the White War Talbuk
	[29104]="1000000:15:4:1:Mount::1:0:20241", -- Reins of the Silver War Talbuk
	[29105]="1000000:15:4:1:Mount::1:0:20241", -- Reins of the Tan War Talbuk
	[29106]="0:12:1:1:::1:0:", -- Ata'mal Crystal
	[29108]="0:2:2:1:OneHandSword::1:0:", -- Blade of the Unyielding
	[29109]="0:2:2:1:Stave::1:0:", -- Rod of the Unyielding
	[29110]="0:15:0:1:Junk::1:0:", -- Ruined Scented Candle
	[29111]="0:15:0:1:Junk::1:0:", -- Box of Stale Candy
	[29112]="300:0:1:10:FoodDrink::1:0:18907", -- Cenarion Spirits
	[29113]="0:12:1:20:::1:0:", -- Demonic Essence
	[29115]="344063:2:3:1:Gun::1:0:20242,23007", -- Consortium Blaster
	[29116]="230189:4:3:1:Leather::1:0:20242,23007", -- Nomad's Leggings
	[29117]="167172:4:3:1:Cloth::1:0:20242,23007", -- Stormspire Vest
	[29118]="100000:11:3:1:AmmoPouch::1:0:20242,23007", -- Smuggler's Ammo Pouch
	[29119]="790112:4:4:1:Amulet::1:0:20242,23007", -- Haramad's Bargain
	[29121]="1995172:2:4:1:Dagger::1:0:20242,23007", -- Guile of Khoraazi
	[29122]="627777:4:4:1:Cloth::1:0:20242,23007", -- Nether Runner's Cowl
	[29123]="790112:4:4:1:Amulet::1:0:19321", -- Medallion of the Lightbearer
	[29124]="2072720:2:4:1:OneHandSword::1:0:19321", -- Vindicator's Brand
	[29125]="2080372:2:4:1:Dagger::1:0:19331", -- Retainer's Blade
	[29126]="790112:4:4:1:Ring::1:0:19331", -- Seer's Signet
	[29127]="312042:4:3:1:Plate::1:0:19321", -- Vindicator's Hauberk
	[29128]="28410:4:3:1:Ring::1:0:19321", -- Lightwarden's Band
	[29129]="179594:4:3:1:Cloth::1:0:19321", -- Anchorite's Robes
	[29130]="563267:2:3:1:Stave::1:0:19321", -- Auchenai Staff
	[29131]="226120:4:3:1:Leather::1:0:19331", -- Retainer's Leggings
	[29132]="175952:4:3:1:Trinket::1:0:19331", -- Scryer's Bloodgem
	[29133]="569315:2:3:1:Stave::1:0:19331", -- Seer's Cane
	[29134]="160892:4:3:1:Plate::1:0:19331", -- Gauntlets of the Chosen
	[29135]="206398:4:3:1:Mail::1:0:20241", -- Earthcaller's Headdress
	[29136]="207131:4:3:1:Mail::1:0:20240", -- Far Seer's Helm
	[29137]="522358:2:3:1:TwoHandAxe::1:0:20241", -- Hellscream's Will
	[29138]="524392:2:3:1:TwoHandMace::1:0:20240", -- Arechron's Gift
	[29139]="126329:4:3:1:Cloak::1:0:20241", -- Ceremonial Cover
	[29140]="130314:4:3:1:Cloak::1:0:20240", -- Cloak of the Ancient Spirits
	[29141]="218004:4:3:1:Leather::1:0:20241", -- Tempest Leggings
	[29142]="218818:4:3:1:Leather::1:0:20240", -- Kurenai Kilt
	[29143]="100000:11:3:1:Quiver::1:0:20241", -- Clefthoof Hide Quiver
	[29144]="100000:11:3:1:Quiver::1:0:20240", -- Worg Hide Quiver
	[29145]="175952:4:3:1:Ring::1:0:20241", -- Band of Ancestral Spirits
	[29146]="175952:4:3:1:Ring::1:0:20240", -- Band of Elemental Spirits
	[29147]="167132:4:3:1:Leather::1:0:20241", -- Talbuk Hide Spaulders
	[29148]="167743:4:3:1:Leather::1:0:20240", -- Blackened Leather Spaulders
	[29149]="0:2:3:1:Wand::1:0:18382", -- Sporeling's Firestick
	[29150]="0:2:3:1:Dagger::1:0:18382", -- Hardened Stone Shard
	[29151]="1594245:2:4:1:Gun::1:0:17657", -- Veteran's Musket
	[29152]="1599984:2:4:1:Bow::1:0:17585", -- Marksman's Bow
	[29153]="2140963:2:4:1:OneHandSword::1:0:17657", -- Blade of the Archmage
	[29154]="0:12:1:10:::1:0:", -- Legion Cannon
	[29155]="2156059:2:4:1:OneHandSword::1:0:17585", -- Stormcaller
	[29156]="2011508:2:4:1:OneHandSword::1:0:17657", -- Honor's Call
	[29157]="0:4:3:1:Ring::1:0:", -- Golden Ring of Power
	[29158]="0:4:3:1:Ring::1:0:", -- Truesilver Commander's Ring
	[29159]="0:4:2:1:Ring::1:0:", -- Glowing Thorium Band
	[29160]="0:4:2:1:Ring::1:0:", -- Emerald Lion Ring
	[29161]="0:12:1:20:::1:0:", -- Void Ridge Soul Shard
	[29162]="0:0:1:1:Consumable::1:0:", -- Galaxis Soul Shard
	[29163]="0:12:1:20:::1:0:", -- Raw Farahlite
	[29164]="0:12:1:1:::1:0:", -- Farahlite Core
	[29165]="2079958:2:4:1:OneHandAxe::1:0:17585", -- Warbringer
	[29166]="555019:2:3:1:Polearm::1:0:17657", -- Hellforged Halberd
	[29167]="557054:2:3:1:Polearm::1:0:17585", -- Blackened Spear
	[29168]="175952:4:3:1:Ring::1:0:17585", -- Ancestral Band
	[29169]="175952:4:3:1:Ring::1:0:17657", -- Ring of Convalescence
	[29170]="790112:4:4:1:OffHandFrill::1:0:17904", -- Windcaller's Orb
	[29171]="2656817:2:4:1:TwoHandMace::1:0:17904", -- Earthwarden
	[29172]="790112:4:4:1:Ring::1:0:17904", -- Ashyen's Gift
	[29173]="175952:4:3:1:Amulet::1:0:17904", -- Strength of the Untamed
	[29174]="127371:4:3:1:Cloth::1:0:17904", -- Watcher's Cowl
	[29175]="2003650:2:4:1:OneHandMace::1:0:21432", -- Gavel of Pure Light
	[29176]="1344928:4:4:1:Shield::1:0:21432", -- Crest of the Sha'tar
	[29177]="790112:4:4:1:Ring::1:0:21432", -- A'dal's Command
	[29179]="175952:4:3:1:Trinket::1:0:21432", -- Xi'ri's Gift
	[29180]="130288:4:3:1:Mail::1:0:21432", -- Blessed Scale Girdle
	[29181]="790112:4:4:1:Trinket::1:0:21643", -- Timelapse Shard
	[29182]="2056797:2:4:1:Dagger::1:0:21643", -- Riftmaker
	[29183]="431396:4:4:1:Cloth::1:0:21643", -- Bindings of the Timewalker
	[29184]="308501:4:3:1:Plate::1:0:21643", -- Timewarden's Leggings
	[29185]="442344:2:3:1:OneHandSword::1:0:21643", -- Continuum Blade
	[29186]="1000000:0:2:1:EnhPerm::1:0:21643", -- Arcanum of the Defender
	[29187]="300000:0:2:1:EnhPerm::1:0:18255", -- Inscription of Endurance
	[29189]="1000000:0:2:1:EnhPerm::1:0:17657", -- Arcanum of Renewal
	[29190]="1000000:0:2:1:EnhPerm::1:0:17585", -- Arcanum of Renewal
	[29191]="1000000:0:2:1:EnhPerm::1:0:21432", -- Arcanum of Power
	[29192]="1000000:0:2:1:EnhPerm::1:0:17904", -- Arcanum of Ferocity
	[29193]="1000000:0:2:1:EnhPerm::1:0:25032", -- Arcanum of the Gladiator
	[29194]="1000000:0:2:1:EnhPerm::1:0:17904", -- Arcanum of Nature Warding
	[29195]="1000000:0:2:1:EnhPerm::1:0:21432", -- Arcanum of Arcane Warding
	[29196]="1000000:0:2:1:EnhPerm::1:0:17657", -- Arcanum of Fire Warding
	[29197]="1000000:0:2:1:EnhPerm::1:0:17585", -- Arcanum of Fire Warding
	[29198]="1000000:0:2:1:EnhPerm::1:0:21643", -- Arcanum of Frost Warding
	[29199]="1000000:0:2:1:EnhPerm::1:0:21655", -- Arcanum of Shadow Warding
	[29200]="0:2:2:1:Gun::1:0:", -- Falfindel's Blaster
	[29201]="0:2:2:1:Thrown::1:0:", -- Thick Bronze Darts
	[29202]="0:2:2:1:Thrown::1:0:", -- Whirling Steel Axes
	[29203]="0:2:2:1:Thrown::1:0:", -- Enchanted Thorium Blades
	[29204]="0:2:3:1:Thrown::1:0:", -- Felsteel Whisper Knives
	[29207]="0:12:1:1:::1:0:", -- Conjuring Powder
	[29209]="0:12:1:200:::1:0:", -- Zaxxis Insignia
	[29211]="0:2:3:1:Thrown::1:0:", -- Fitz's Throwing Axe
	[29212]="0:2:2:1:Thrown::1:0:", -- Balanced Stone Dirk
	[29213]="120000:9:3:1:Leatherworking::1:0:17657", -- Pattern: Felstalker Belt
	[29214]="160000:9:3:1:Leatherworking::1:0:17657", -- Pattern: Felstalker Bracers
	[29215]="160000:9:3:1:Leatherworking::1:0:17657", -- Pattern: Felstalker Breastplate
	[29216]="0:12:1:10:::1:0:", -- Flawless Crystal Shard
	[29217]="120000:9:3:1:Leatherworking::1:0:20240", -- Pattern: Netherfury Belt
	[29218]="120000:9:3:1:Leatherworking::1:0:20240", -- Pattern: Netherfury Boots
	[29219]="120000:9:3:1:Leatherworking::1:0:20240", -- Pattern: Netherfury Leggings
	[29220]="10000:15:3:1:Mount::1:0:16264", -- Blue Hawkstrider
	[29221]="10000:15:3:1:Mount::1:0:16264", -- Black Hawkstrider
	[29222]="10000:15:3:1:Mount::1:0:16264", -- Purple Hawkstrider
	[29223]="100000:15:4:1:Mount::1:0:16264", -- Swift Green Hawkstrider
	[29224]="100000:15:4:1:Mount::1:0:16264", -- Swift Purple Hawkstrider
	[29226]="0:12:1:1:::1:0:", -- Warp Rift Generator
	[29227]="1000000:15:4:1:Mount::1:0:20240", -- Reins of the Cobalt War Talbuk
	[29228]="0:15:4:1:Mount::1:0:21474,21485", -- Reins of the Dark War Talbuk
	[29229]="1000000:15:4:1:Mount::1:0:20240", -- Reins of the Silver War Talbuk
	[29230]="1000000:15:4:1:Mount::1:0:20240", -- Reins of the Tan War Talbuk
	[29231]="1000000:15:4:1:Mount::1:0:20240", -- Reins of the White War Talbuk
	[29232]="80000:9:1:1:Alchemy::1:0:17585", -- Recipe: Transmute Skyfire Diamond
	[29233]="0:12:1:1:::1:0:", -- Dathric's Blade
	[29234]="0:12:1:1:::1:0:", -- Belmara's Tome
	[29235]="0:12:1:1:::1:0:", -- Luminrath's Mantle
	[29236]="0:12:1:1:::1:0:", -- Cohlien's Cap
	[29237]="0:4:4:1:Plate::1:0:", -- Warpath Bracers
	[29238]="0:4:4:1:Plate::1:0:", -- Lion's Heart Girdle
	[29239]="0:4:4:1:Plate::1:0:", -- Eaglecrest Warboots
	[29240]="0:4:4:1:Cloth::1:0:", -- Bands of Negation
	[29241]="0:4:4:1:Cloth::1:0:", -- Belt of Depravity
	[29242]="0:4:4:1:Cloth::1:0:", -- Boots of Blasphemy
	[29243]="0:4:4:1:Mail::1:0:", -- Wave-Fury Vambraces
	[29244]="0:4:4:1:Mail::1:0:", -- Wave-Song Girdle
	[29245]="0:4:4:1:Mail::1:0:", -- Wave-Crest Striders
	[29246]="0:4:4:1:Leather::1:0:", -- Nightfall Wristguards
	[29247]="0:4:4:1:Leather::1:0:", -- Girdle of the Deathdealer
	[29248]="0:4:4:1:Leather::1:0:", -- Shadowstep Striders
	[29249]="0:4:4:1:Cloth::1:0:", -- Bands of the Benevolent
	[29250]="0:4:4:1:Cloth::1:0:", -- Cord of Sanctification
	[29251]="0:4:4:1:Cloth::1:0:", -- Boots of the Pious
	[29252]="0:4:4:1:Plate::1:0:", -- Bracers of Dignity
	[29253]="0:4:4:1:Plate::1:0:", -- Girdle of Valorous Deeds
	[29254]="0:4:4:1:Plate::1:0:", -- Boots of the Righteous Path
	[29255]="0:4:4:1:Cloth::1:0:", -- Bands of Rarefied Magic
	[29257]="0:4:4:1:Cloth::1:0:", -- Sash of Arcane Visions
	[29258]="0:4:4:1:Cloth::1:0:", -- Boots of Ethereal Manipulation
	[29259]="0:4:4:1:Mail::1:0:", -- Bracers of the Hunt
	[29260]="0:12:1:1:::1:0:", -- Heart of the Fel Reaver
	[29261]="0:4:4:1:Mail::1:0:", -- Girdle of Ferocity
	[29262]="0:4:4:1:Mail::1:0:", -- Boots of the Endless Hunt
	[29263]="0:4:4:1:Leather::1:0:", -- Forestheart Bracers
	[29264]="0:4:4:1:Leather::1:0:", -- Tree-Mender's Belt
	[29265]="0:4:4:1:Leather::1:0:", -- Barkchip Boots
	[29266]="0:4:4:1:Shield::1:0:18525", -- Azure-Shield of Coldarra
	[29267]="0:4:4:1:Shield::1:0:18525", -- Light-Bearer's Faith Shield
	[29268]="0:4:4:1:Shield::1:0:18525", -- Mazthoril Honor Shield
	[29269]="0:4:4:1:OffHandFrill::1:0:18525", -- Sapphiron's Wing Bone
	[29270]="0:4:4:1:OffHandFrill::1:0:18525", -- Flametongue Seal
	[29271]="0:4:4:1:OffHandFrill::1:0:18525", -- Talisman of Kalecgos
	[29272]="0:4:4:1:OffHandFrill::1:0:18525", -- Orb of the Soul-Eater
	[29273]="0:4:4:1:OffHandFrill::1:0:18525", -- Khadgar's Knapsack
	[29274]="0:4:4:1:OffHandFrill::1:0:18525", -- Tears of Heaven
	[29275]="0:2:4:1:Dagger::1:0:18525", -- Searing Sunblade
	[29276]="0:4:3:1:Ring::1:0:", -- Violet Signet
	[29277]="0:4:4:1:Ring::1:0:", -- Violet Signet
	[29278]="0:4:4:1:Ring::1:0:", -- Violet Signet
	[29279]="0:4:4:1:Ring::1:0:", -- Violet Signet of the Great Protector
	[29280]="0:4:3:1:Ring::1:0:", -- Violet Signet
	[29281]="0:4:4:1:Ring::1:0:", -- Violet Signet
	[29282]="0:4:4:1:Ring::1:0:", -- Violet Signet
	[29283]="0:4:4:1:Ring::1:0:", -- Violet Signet of the Master Assassin
	[29284]="0:4:3:1:Ring::1:0:", -- Violet Signet
	[29285]="0:4:4:1:Ring::1:0:", -- Violet Signet
	[29286]="0:4:4:1:Ring::1:0:", -- Violet Signet
	[29287]="0:4:4:1:Ring::1:0:", -- Violet Signet of the Archmage
	[29288]="0:4:3:1:Ring::1:0:", -- Violet Signet
	[29289]="0:4:4:1:Ring::1:0:", -- Violet Signet
	[29290]="0:4:4:1:Ring::1:0:", -- Violet Signet of the Grand Restorer
	[29291]="0:4:4:1:Ring::1:0:", -- Violet Signet
	[29292]="0:0:1:20:FoodDrink::1:0:", -- Helboar Bacon
	[29294]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29295]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29296]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29297]="0:4:4:1:Ring::1:0:", -- Band of the Eternal Defender
	[29298]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29299]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29300]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29301]="0:4:4:1:Ring::1:0:", -- Band of the Eternal Champion
	[29302]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29303]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29304]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29305]="0:4:4:1:Ring::1:0:", -- Band of the Eternal Sage
	[29306]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29307]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29308]="0:4:4:1:Ring::1:0:", -- Band of Eternity
	[29309]="0:4:4:1:Ring::1:0:", -- Band of the Eternal Restorer
	[29312]="0:4:3:1:Plate::1:0:", -- Cover of Righteous Fury
	[29313]="0:4:3:1:Mail::1:0:", -- Earthbreaker's Greaves
	[29314]="0:4:3:1:Leather::1:0:", -- Leggings of the Third Coin
	[29315]="0:4:3:1:Cloth::1:0:", -- Gloves of Penitence
	[29316]="0:4:3:1:Plate::1:0:", -- Warchief's Mantle
	[29317]="0:4:3:1:Cloth::1:0:", -- Tempest's Touch
	[29318]="0:4:3:1:Leather::1:0:", -- Southshore Sneakers
	[29319]="0:4:3:1:Mail::1:0:", -- Tarren Mill Defender's Cinch
	[29320]="0:4:3:1:Ring::1:0:", -- Band of the Guardian
	[29321]="0:4:3:1:Ring::1:0:", -- Time-bending Gem
	[29322]="0:4:3:1:Ring::1:0:", -- Keeper's Ring of Piety
	[29323]="0:4:3:1:Ring::1:0:", -- Andormu's Tear
	[29324]="0:0:1:1:Consumable::1:0:", -- Warp-Attuned Orb
	[29325]="0:4:3:1:Plate::1:0:", -- Flesh Beast's Metal Greaves
	[29326]="0:4:3:1:Mail::1:0:", -- Consortium Mantle of Phasing
	[29327]="0:4:3:1:Leather::1:0:", -- Cryo-mitts
	[29328]="0:4:3:1:Cloth::1:0:", -- Consortium Prince's Wrap
	[29329]="0:2:3:1:Polearm::1:0:", -- Terokk's Quill
	[29330]="0:4:3:1:OffHandFrill::1:0:", -- The Saga of Terokk
	[29331]="0:12:1:1:::1:0:", -- Annals of Kirin'Var
	[29332]="0:4:3:1:Leather::1:0:", -- Terokk's Mask
	[29333]="0:4:3:1:Amulet::1:0:", -- Torc of the Sethekk Prophet
	[29334]="0:4:3:1:Amulet::1:0:", -- Sethekk Oracle's Focus
	[29335]="0:4:3:1:Amulet::1:0:", -- Talon Lord's Collar
	[29336]="0:4:3:1:Amulet::1:0:", -- Mark of the Ravenguard
	[29337]="0:4:3:1:Plate::1:0:", -- The Exarch's Protector
	[29338]="0:12:1:10:::1:0:", -- Loathsome Remnant
	[29339]="0:4:3:1:Mail::1:0:", -- Auchenai Tracker's Hauberk
	[29340]="0:4:3:1:Leather::1:0:", -- Auchenai Monk's Tunic
	[29341]="0:4:3:1:Cloth::1:0:", -- Auchenai Anchorite's Robe
	[29342]="0:4:3:1:Plate::1:0:", -- Consortium Plated Legguards
	[29343]="0:4:3:1:Leather::1:0:", -- Haramad's Leggings of the Third Coin
	[29344]="0:4:3:1:Mail::1:0:", -- Haramad's Linked Chain Pantaloons
	[29345]="0:4:3:1:Cloth::1:0:", -- Haramad's Leg Wraps
	[29346]="0:2:4:1:Dagger::1:0:", -- Feltooth Eviscerator
	[29347]="0:4:4:1:Amulet::1:0:", -- Talisman of the Breaker
	[29348]="0:2:4:1:FistWeapon::1:0:", -- The Bladefist
	[29349]="0:4:4:1:Amulet::1:0:", -- Adamantine Chain of the Unbroken
	[29350]="0:2:4:1:Wand::1:0:", -- The Black Stalk
	[29351]="0:2:4:1:Bow::1:0:", -- Wrathtide Longbow
	[29352]="0:4:4:1:Ring::1:0:", -- Cobalt Band of Tyrigosa
	[29353]="0:2:4:1:OneHandMace::1:0:", -- Shockwave Truncheon
	[29354]="0:4:4:1:Cloak::1:0:", -- Light-Touched Stole of Altruism
	[29355]="0:2:4:1:Stave::1:0:", -- Terokk's Shadowstaff
	[29356]="0:2:4:1:TwoHandSword::1:0:", -- Quantum Blade
	[29357]="0:4:4:1:Leather::1:0:", -- Master Thief's Gloves
	[29359]="0:2:4:1:Stave::1:0:", -- Feral Staff of Lashing
	[29360]="0:2:4:1:Dagger::1:0:", -- Vileblade of the Betrayer
	[29361]="0:12:1:1:::1:0:", -- Naberius's Phylactery
	[29362]="0:2:4:1:OneHandSword::1:0:", -- The Sun Eater
	[29363]="400000:15:1:1:Companion::1:0:20980", -- Mana Wyrmling
	[29364]="100000:15:1:1:Companion::1:0:20980", -- Brown Rabbit Crate
	[29365]="0:12:1:20:::1:0:", -- Smithing Hammer
	[29366]="0:12:1:1:::1:0:", -- B'naar Access Crystal
	[29367]="0:4:4:1:Ring::1:0:18525", -- Ring of Cryptic Dreams
	[29368]="0:4:4:1:Amulet::1:0:18525", -- Manasurge Pendant
	[29369]="0:4:4:1:Cloak::1:0:18525", -- Shawl of Shifting Probabilities
	[29370]="0:4:4:1:Trinket::1:0:18525", -- Icon of the Silver Crescent
	[29371]="348334:2:2:1:FistWeapon::1:1:19536", -- Nexus-Claw
	[29372]="349616:2:2:1:FistWeapon::1:1:19536", -- Void-Talon
	[29373]="0:4:4:1:Ring::1:0:18525", -- Band of Halos
	[29374]="0:4:4:1:Amulet::1:0:18525", -- Necklace of Eternal Hope
	[29375]="0:4:4:1:Cloak::1:0:18525", -- Bishop's Cloak
	[29376]="0:4:4:1:Trinket::1:0:18525", -- Essence of the Martyr
	[29377]="444941:2:2:1:Polearm::1:1:19536", -- Ethereum Phase-Spear
	[29378]="267925:2:2:1:Wand::1:1:19536", -- Starheart Baton
	[29379]="0:4:4:1:Ring::1:0:18525", -- Ring of Arathi Warlords
	[29380]="359762:2:2:1:OneHandSword::1:1:19536", -- Ethereum Phase Blade
	[29381]="0:4:4:1:Amulet::1:0:18525", -- Choker of Vile Intent
	[29382]="0:4:4:1:Cloak::1:0:18525", -- Blood Knight War Cloak
	[29383]="0:4:4:1:Trinket::1:0:18525", -- Bloodlust Brooch
	[29384]="0:4:4:1:Ring::1:0:18525", -- Ring of Unyielding Force
	[29385]="0:4:4:1:Cloak::1:0:18525", -- Farstrider Defender's Cloak
	[29386]="0:4:4:1:Amulet::1:0:18525", -- Necklace of the Juggernaut
	[29387]="0:4:4:1:Trinket::1:0:18525", -- Gnomeregan Auto-Blocker 600
	[29388]="0:4:4:1:Libram::1:0:18525", -- Libram of Repentance
	[29389]="0:4:4:1:Totem::1:0:18525", -- Totem of the Pulsing Earth
	[29390]="0:4:4:1:Idol::1:0:18525", -- Everbloom Idol
	[29391]="348265:2:2:1:Dagger::1:1:19536", -- Pulse Dagger
	[29393]="5600:0:1:20:FoodDrink::5:0:19531,20986", -- Diamond Berries
	[29394]="8000:0:1:20:FoodDrink::5:0:19531,20986", -- Lyribread
	[29395]="6400:0:1:20:FoodDrink::5:0:19531,20986", -- Ethermead
	[29396]="0:12:1:1:::1:0:", -- Coruu Access Crystal
	[29397]="0:12:1:1:::1:0:", -- Duro Access Crystal
	[29398]="0:4:2:1:Ring::1:0:", -- Circle of Banishing
	[29399]="0:2:2:1:Stave::1:0:", -- Rod of the Void Caller
	[29400]="0:4:2:1:Cloak::1:0:", -- Abyssal Shroud
	[29401]="6400:0:1:20:FoodDrink::5:0:20377", -- Sparkling Southshore Cider
	[29411]="0:12:1:1:::1:0:", -- Ara Access Crystal
	[29412]="5600:0:1:20:FoodDrink::5:0:20378", -- Jessen's Special Slop
	[29425]="0:12:1:250:::1:0:", -- Mark of Kil'jaeden
	[29426]="0:12:1:250:::1:0:", -- Firewing Signet
	[29428]="0:12:1:1:::1:0:", -- Bessy's Bell
	[29429]="0:12:1:1:::1:0:", -- Boom's Doom
	[29434]="0:10:4::Currency::1:0:", -- Badge of Justice
	[29443]="0:0:1:20:Consumable::1:0:", -- Bloodmaul Brutebane Brew
	[29445]="0:12:1:1:::1:0:", -- Surveying Markers
	[29447]="0:12:1:1:::1:0:", -- Fel Zapper
	[29448]="8000:0:1:20:FoodDrink::5:0:4255,10367,19232,19296,19718,20080,20916,21110,21744,21746,22266,23521,24342", -- Mag'har Mild Cheese
	[29449]="8000:0:1:20:FoodDrink::5:0:4255,10367,18245,18251,18907,19038,19232,19348,19352,19451,19495,19518,19664,20893,21744,21746,24033,24057", -- Bladespire Bagel
	[29450]="8000:0:1:20:FoodDrink::5:0:4255,12096,12097,16798,17277,18957,19050,19223,19232,19471,19572,19718,21484,21487,21744,21746,22266,25036,26375,26680,29547", -- Telaari Grapes
	[29451]="8000:0:1:20:FoodDrink::5:0:4255,10367,12096,12097,16585,16602,16798,16826,17277,18905,18906,18908,18913,18914,18957,19038,19182,19314,19315,19348,19352,19435,19470,19528,19559,19572,19679,19718,20097,20231,20893,21084,22266,23143,23263,23481,23748,24343,25036,26375,28760,28943,29205", -- Clefthoof Ribs
	[29452]="8000:0:1:20:FoodDrink::5:0:4255,10367,19045,19296,19472,22266,23748,24033,24057,25036", -- Zangar Trout
	[29453]="8000:0:1:20:FoodDrink::5:0:10367,12096,12097,19471,22266,23748,24149,24342,24396,24408,27032,29205,33018", -- Sporeggar Mushroom
	[29454]="5600:0:1:20:FoodDrink::5:0:19531,20986", -- Silverwine
	[29456]="348580:2:3:1:OneHandSword::1:0:20242,23007", -- Gift of the Ethereal
	[29457]="349938:2:3:1:Dagger::1:0:20242,23007", -- Nethershard
	[29458]="0:4:4:1:Shield::1:0:", -- Aegis of the Vindicator
	[29459]="0:12:1:15:::1:0:", -- Ethereum Relay Data
	[29460]="0:13:2:50:::1:0:", -- Ethereum Prison Key
	[29461]="0:12:1:1:::1:0:", -- Mana Bomb Fragment
	[29463]="0:4:4:1:Plate::1:0:", -- Amber Bands of the Aggressor
	[29464]="0:12:1:20:::1:0:", -- Shaleskin Shale
	[29465]="0:15:4:1:Mount::1:0:12783", -- Black Battlestrider
	[29466]="0:15:4:1:Mount::1:0:12796", -- Black War Kodo
	[29467]="0:15:4:1:Mount::1:0:12783", -- Black War Ram
	[29468]="0:15:4:1:Mount::1:0:12783", -- Black War Steed Bridle
	[29469]="0:15:4:1:Mount::1:0:12796", -- Horn of the Black War Wolf
	[29470]="0:15:4:1:Mount::1:0:12796", -- Red Skeletal Warhorse
	[29471]="0:15:4:1:Mount::1:0:12783", -- Reins of the Black War Tiger
	[29472]="0:15:4:1:Mount::1:0:12796", -- Whistle of the Black War Raptor
	[29473]="0:15:1:1:Junk::1:0:", -- Protectorate Igniter
	[29474]="0:12:1:20:::1:0:", -- Ivory Bell
	[29475]="0:12:1:20:::1:0:", -- Pacifying Dust
	[29476]="0:12:1:1:::1:0:", -- Crimson Crystal Shard
	[29477]="0:12:1:1:::1:0:", -- Crimson Crystal Shard
	[29478]="0:12:1:1:::1:0:", -- Seed of Revitalization
	[29480]="0:12:1:10:::1:0:", -- Parched Hydra Sample
	[29481]="0:12:1:10:::1:0:", -- Withered Bog Lord Sample
	[29482]="0:0:1:20:Consumable::1:0:", -- Ethereum Essence
	[29483]="0:0:2:10:EnhPerm::1:0:", -- Shadow Armor Kit
	[29485]="0:0:2:10:EnhPerm::1:0:", -- Flame Armor Kit
	[29486]="0:0:2:10:EnhPerm::1:0:", -- Frost Armor Kit
	[29487]="0:0:2:10:EnhPerm::1:0:", -- Nature Armor Kit
	[29488]="0:0:2:10:EnhPerm::1:0:", -- Arcane Armor Kit
	[29489]="0:4:3:1:Mail::1:0:", -- Enchanted Felscale Leggings
	[29490]="0:4:3:1:Mail::1:0:", -- Enchanted Felscale Gloves
	[29491]="0:4:3:1:Mail::1:0:", -- Enchanted Felscale Boots
	[29492]="0:4:3:1:Mail::1:0:", -- Flamescale Leggings
	[29493]="0:4:3:1:Mail::1:0:", -- Flamescale Boots
	[29494]="0:4:3:1:Mail::1:0:", -- Flamescale Belt
	[29495]="0:4:3:1:Leather::1:0:", -- Enchanted Clefthoof Leggings
	[29496]="0:4:3:1:Leather::1:0:", -- Enchanted Clefthoof Gloves
	[29497]="0:4:3:1:Leather::1:0:", -- Enchanted Clefthoof Boots
	[29498]="0:4:3:1:Leather::1:0:", -- Blastguard Pants
	[29499]="0:4:3:1:Leather::1:0:", -- Blastguard Boots
	[29500]="0:4:3:1:Leather::1:0:", -- Blastguard Belt
	[29501]="0:13:1:1:::1:0:", -- Sha'naar Key
	[29502]="0:4:4:1:Leather::1:0:", -- Cobrascale Hood
	[29503]="0:4:4:1:Leather::1:0:", -- Cobrascale Gloves
	[29504]="0:4:4:1:Leather::1:0:", -- Windscale Hood
	[29505]="0:4:4:1:Leather::1:0:", -- Hood of Primal Life
	[29506]="0:4:4:1:Leather::1:0:", -- Gloves of the Living Touch
	[29507]="0:4:4:1:Leather::1:0:", -- Windslayer Wraps
	[29508]="0:4:4:1:Mail::1:0:", -- Living Dragonscale Helm
	[29509]="0:4:4:1:Mail::1:0:", -- Windstrike Gloves
	[29510]="0:4:4:1:Mail::1:0:", -- Netherdrake Helm
	[29511]="0:4:4:1:Mail::1:0:", -- Netherdrake Gloves
	[29512]="0:4:4:1:Mail::1:0:", -- Earthen Netherscale Boots
	[29513]="0:12:1:1:::1:0:", -- Staff of the Dreghood Elders
	[29514]="0:4:4:1:Mail::1:0:", -- Thick Netherscale Breastplate
	[29515]="0:4:4:1:Mail::1:0:", -- Ebon Netherscale Breastplate
	[29516]="0:4:4:1:Mail::1:0:", -- Ebon Netherscale Belt
	[29517]="0:4:4:1:Mail::1:0:", -- Ebon Netherscale Bracers
	[29518]="0:2:1:1:OneHandSword::1:0:", -- Amani Scimitar
	[29519]="0:4:4:1:Mail::1:0:", -- Netherstrike Breastplate
	[29520]="0:4:4:1:Mail::1:0:", -- Netherstrike Belt
	[29521]="0:4:4:1:Mail::1:0:", -- Netherstrike Bracers
	[29522]="0:4:4:1:Leather::1:0:", -- Windhawk Hauberk
	[29523]="0:4:4:1:Leather::1:0:", -- Windhawk Bracers
	[29524]="0:4:4:1:Leather::1:0:", -- Windhawk Belt
	[29525]="0:4:4:1:Leather::1:0:", -- Primalstrike Vest
	[29526]="0:4:4:1:Leather::1:0:", -- Primalstrike Belt
	[29527]="0:4:4:1:Leather::1:0:", -- Primalstrike Bracers
	[29528]="0:0:2:1:Other::1:0:", -- Drums of War
	[29529]="0:0:2:1:Other::1:0:", -- Drums of Battle
	[29530]="0:0:2:1:Other::1:0:", -- Drums of Speed
	[29531]="0:0:2:1:Other::1:0:", -- Drums of Restoration
	[29532]="0:0:2:1:Other::1:0:", -- Drums of Panic
	[29533]="0:0:3:20:EnhPerm::1:0:", -- Cobrahide Leg Armor
	[29534]="0:0:3:20:EnhPerm::1:0:", -- Clefthide Leg Armor
	[29535]="0:0:4:20:EnhPerm::1:0:", -- Nethercobra Leg Armor
	[29536]="0:0:4:20:EnhPerm::1:0:", -- Nethercleft Leg Armor
	[29539]="0:7:1:20:Leather:165:1:0:", -- Cobra Scales
	[29540]="0:1:2:1:MiningBag::1:0:", -- Reinforced Mining Bag
	[29545]="0:12:1:1:::1:0:", -- Sunfury Military Briefing
	[29546]="0:12:1:1:::1:0:", -- Sunfury Arcane Briefing
	[29547]="0:7:1:20:Leather:165:1:0:", -- Wind Scales
	[29548]="0:7:1:20:Leather:165:1:0:", -- Nether Dragonscales
	[29549]="0:9:3:1:Book::1:0:", -- Codex: Prayer of Fortitude III
	[29550]="0:9:3:1:Book::1:0:", -- Tome of Conjure Water IX
	[29553]="0:15:0:20:Junk::1:0:", -- Basilisk Liver
	[29554]="0:15:0:5:Junk::1:0:", -- Encrusted Basilisk Skin
	[29555]="0:15:0:5:Junk::1:0:", -- Glimmering Basilisk Skin
	[29556]="0:15:0:5:Junk::1:0:", -- Basilisk Venom Sac
	[29559]="0:15:0:5:Junk::1:0:", -- Vibrant Feather
	[29560]="0:15:0:5:Junk::1:0:", -- Electrified Scale
	[29561]="0:15:0:10:Junk::1:0:", -- Dragon Femur
	[29562]="0:15:0:10:Junk::1:0:", -- Dragon's Tooth
	[29563]="0:15:0:10:Junk::1:0:", -- Dragon's Claw
	[29564]="0:15:0:10:Junk::1:0:", -- Dragon's Fang
	[29567]="0:15:0:10:Junk::1:0:", -- Raptor Talon
	[29568]="0:15:0:10:Junk::1:0:", -- Raptor War Feather
	[29569]="0:15:1:1:Junk::1:0:", -- Strong Junkbox
	[29570]="0:15:0:5:Junk::1:0:", -- A Gnome Effigy
	[29571]="0:15:0:5:Junk::1:0:", -- A Steamy Romance Novel
	[29572]="0:15:0:5:Junk::1:0:", -- Aboriginal Carvings
	[29573]="0:15:0:5:Junk::1:0:", -- Embalming Fluid
	[29574]="0:15:0:5:Junk::1:0:", -- Mummified Parts
	[29575]="0:15:0:5:Junk::1:0:", -- A Jack-o'-Lantern
	[29576]="0:15:0:5:Junk::1:0:", -- Shark Bait
	[29577]="0:15:0:5:Junk::1:0:", -- Troll Keepsake
	[29578]="0:15:0:10:Junk::1:0:", -- Crystalized Stone
	[29579]="0:15:0:10:Junk::1:0:", -- Crystalized Stone Chips
	[29580]="0:15:0:10:Junk::1:0:", -- Crystal Fragments
	[29581]="0:15:0:10:Junk::1:0:", -- Strange Crystal
	[29582]="0:12:1:1:::1:0:", -- Ethereum Data Cell
	[29583]="7313:2:2:1:OneHandSword::1:1:16268", -- Sinister Scimitar
	[29584]="600:2:2:1:Thrown::1:1:16268", -- Throat Piercers
	[29586]="0:12:1:1:::1:0:", -- Head of Forgefiend Razorsaw
	[29588]="0:15:1:1:Junk::1:0:", -- Burning Legion Missive
	[29589]="0:12:1:1:::1:0:", -- Burning Legion Missive
	[29590]="0:15:1:1:Junk::1:0:", -- Burning Legion Missive
	[29591]="0:12:1:1:::1:0:", -- Prepared Ethereum Wrapping
	[29592]="0:4:3:1:Trinket::1:0:12795", -- Insignia of the Horde
	[29593]="0:4:3:1:Trinket::1:0:12785", -- Insignia of the Alliance
	[29594]="0:4:3:1:Mail::1:0:", -- Knight-Lieutenant's Mail Greaves
	[29595]="0:4:3:1:Mail::1:0:", -- Knight-Lieutenant's Mail Vices
	[29596]="0:4:3:1:Mail::1:0:", -- Knight-Captain's Mail Hauberk
	[29597]="0:4:3:1:Mail::1:0:", -- Knight-Captain's Mail Legguards
	[29598]="0:4:3:1:Mail::1:0:", -- Lieutenant Commander's Mail Headguard
	[29599]="0:4:3:1:Mail::1:0:", -- Lieutenant Commander's Mail Pauldrons
	[29600]="0:4:3:1:Plate::1:0:", -- Blood Guard's Lamellar Gauntlets
	[29601]="0:4:3:1:Plate::1:0:", -- Blood Guard's Lamellar Sabatons
	[29602]="0:4:3:1:Plate::1:0:", -- Legionnaire's Lamellar Breastplate
	[29603]="0:4:3:1:Plate::1:0:", -- Legionnaire's Lamellar Leggings
	[29604]="0:4:3:1:Plate::1:0:", -- Champion's Lamellar Headguard
	[29605]="0:4:3:1:Plate::1:0:", -- Champion's Lamellar Shoulders
	[29606]="0:4:4:1:Mail::1:0:", -- Marshal's Mail Boots
	[29607]="0:4:4:1:Mail::1:0:", -- Marshal's Mail Gauntlets
	[29608]="0:4:4:1:Mail::1:0:", -- Marshal's Mail Leggings
	[29609]="0:4:4:1:Mail::1:0:", -- Field Marshal's Mail Armor
	[29610]="0:4:4:1:Mail::1:0:", -- Field Marshal's Mail Helm
	[29611]="0:4:4:1:Mail::1:0:", -- Field Marshal's Mail Spaulders
	[29612]="0:4:4:1:Plate::1:0:", -- General's Lamellar Boots
	[29613]="0:4:4:1:Plate::1:0:", -- General's Lamellar Gloves
	[29614]="0:4:4:1:Plate::1:0:", -- General's Lamellar Legplates
	[29615]="0:4:4:1:Plate::1:0:", -- Warlord's Lamellar Chestplate
	[29616]="0:4:4:1:Plate::1:0:", -- Warlord's Lamellar Faceguard
	[29617]="0:4:4:1:Plate::1:0:", -- Warlord's Lamellar Pauldrons
	[29618]="0:12:1:1:::1:0:", -- Protectorate Disruptor
	[29624]="0:0:1:1:Consumable::1:0:", -- First Half of Socrethar's Stone
	[29625]="0:0:1:1:Consumable::1:0:", -- Second Half of Socrethar's Stone
	[29664]="50000:9:1:1:Leatherworking::1:0:20241", -- Pattern: Reinforced Mining Bag
	[29669]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Shadow Armor Kit
	[29672]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Flame Armor Kit
	[29673]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Frost Armor Kit
	[29674]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Nature Armor Kit
	[29675]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Arcane Armor Kit
	[29677]="80000:9:1:1:Leatherworking::1:0:19331", -- Pattern: Enchanted Felscale Leggings
	[29682]="80000:9:1:1:Leatherworking::1:0:19331", -- Pattern: Enchanted Felscale Gloves
	[29684]="80000:9:1:1:Leatherworking::1:0:19331", -- Pattern: Enchanted Felscale Boots
	[29689]="80000:9:1:1:Leatherworking::1:0:19321", -- Pattern: Flamescale Leggings
	[29691]="80000:9:1:1:Leatherworking::1:0:19321", -- Pattern: Flamescale Boots
	[29693]="80000:9:1:1:Leatherworking::1:0:19321", -- Pattern: Flamescale Belt
	[29698]="80000:9:1:1:Leatherworking::1:0:19331", -- Pattern: Enchanted Clefthoof Leggings
	[29699]="0:0:1:1:Consumable::1:0:", -- Socrethar's Teleportation Stone
	[29700]="80000:9:1:1:Leatherworking::1:0:19331", -- Pattern: Enchanted Clefthoof Gloves
	[29701]="80000:9:1:1:Leatherworking::1:0:19331", -- Pattern: Enchanted Clefthoof Boots
	[29702]="80000:9:1:1:Leatherworking::1:0:19321", -- Pattern: Blastguard Pants
	[29703]="80000:9:1:1:Leatherworking::1:0:19321", -- Pattern: Blastguard Boots
	[29704]="80000:9:1:1:Leatherworking::1:0:19321", -- Pattern: Blastguard Belt
	[29713]="120000:9:1:1:Leatherworking::1:0:21643", -- Pattern: Drums of Panic
	[29714]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Drums of Restoration
	[29717]="120000:9:1:1:Leatherworking::1:0:21432", -- Pattern: Drums of Battle
	[29718]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Drums of Speed
	[29719]="60000:9:1:1:Leatherworking::1:0:17657", -- Pattern: Cobrahide Leg Armor
	[29720]="60000:9:1:1:Leatherworking::1:0:17904", -- Pattern: Clefthide Leg Armor
	[29721]="120000:9:1:1:Leatherworking::1:0:17904", -- Pattern: Nethercleft Leg Armor
	[29722]="120000:9:1:1:Leatherworking::1:0:17657", -- Pattern: Nethercobra Leg Armor
	[29723]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Cobrascale Hood
	[29724]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Cobrascale Gloves
	[29725]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Windscale Hood
	[29726]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Hood of Primal Life
	[29727]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Gloves of the Living Touch
	[29728]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Windslayer Wraps
	[29729]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Living Dragonscale Helm
	[29730]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Earthen Netherscale Boots
	[29731]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Windstrike Gloves
	[29732]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Netherdrake Helm
	[29733]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Netherdrake Gloves
	[29734]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Thick Netherscale Breastplate
	[29735]="0:0:1:250:Consumable::1:0:", -- Holy Dust
	[29736]="0:0:1:250:Consumable::1:0:", -- Arcane Rune
	[29737]="0:12:1:1:::1:0:", -- Navuud's Concoction
	[29738]="0:12:1:1:::1:0:", -- Vial of Void Horror Ooze
	[29739]="0:12:2:250:::1:0:", -- Arcane Tome
	[29740]="0:12:2:250:::1:0:", -- Fel Armament
	[29741]="0:12:1:1:::1:0:", -- Diagnostic Results
	[29742]="0:13:1:10:::1:0:", -- The Warden's Key
	[29743]="10000:15:3:1:Mount::1:0:17584", -- Purple Elekk
	[29744]="10000:15:3:1:Mount::1:0:17584", -- Gray Elekk
	[29745]="100000:15:4:1:Mount::1:0:17584", -- Great Blue Elekk
	[29746]="100000:15:4:1:Mount::1:0:17584", -- Great Green Elekk
	[29747]="100000:15:4:1:Mount::1:0:17584", -- Great Purple Elekk
	[29749]="0:12:1:20:::1:0:", -- Farahlon Lasher Cutting
	[29750]="0:13:2:50:::1:0:", -- Ethereum Stasis Chamber Key
	[29751]="0:12:1:20:::1:0:", -- Talbuk Horn Sample
	[29753]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Fallen Defender
	[29754]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Fallen Champion
	[29755]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Fallen Hero
	[29756]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Fallen Hero
	[29757]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Fallen Champion
	[29758]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Fallen Defender
	[29759]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Fallen Hero
	[29760]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Fallen Champion
	[29761]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Fallen Defender
	[29762]="0:15:4:1:ArmorToken::1:0:", -- Pauldrons of the Fallen Hero
	[29763]="0:15:4:1:ArmorToken::1:0:", -- Pauldrons of the Fallen Champion
	[29764]="0:15:4:1:ArmorToken::1:0:", -- Pauldrons of the Fallen Defender
	[29765]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Fallen Hero
	[29766]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Fallen Champion
	[29767]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Fallen Defender
	[29768]="0:12:1:1:::1:0:", -- Hulking Hydra Heart
	[29769]="0:12:1:1:::1:0:", -- Diagnostic Results
	[29770]="0:12:1:1:::1:0:", -- Experimental Repair Apparatus
	[29771]="0:4:2:1:Cloth::1:0:", -- Kirin'Var Journeyman's Belt
	[29772]="0:4:2:1:Leather::1:0:", -- Kirin'Var Scout's Belt
	[29773]="0:4:2:1:Mail::1:0:", -- Battle-Mage's Helmet
	[29774]="0:4:2:1:Plate::1:0:", -- Kirin'Var Defender's Chausses
	[29775]="0:4:2:1:Amulet::1:0:", -- Pendant of the Battle-Mage
	[29776]="0:4:2:1:Trinket::1:0:", -- Core of Ar'kelos
	[29777]="0:4:2:1:Cloak::1:0:", -- Cloak of the Valiant Defender
	[29778]="0:0:1:1:Consumable::1:0:", -- Phase Disruptor
	[29779]="0:2:2:1:Wand::1:0:", -- Rejuvenating Scepter
	[29780]="0:4:3:1:Cloth::1:0:", -- Kirin Tor Apprentice's Robes
	[29781]="0:4:3:1:Leather::1:0:", -- Lifewarden's Breastplate
	[29782]="0:4:3:1:Mail::1:0:", -- Coif of the Wicked
	[29783]="0:4:3:1:Plate::1:0:", -- Legguards of the Resolute Defender
	[29784]="0:4:2:1:Leather::1:0:", -- Harmony's Touch
	[29785]="0:4:2:1:Mail::1:0:", -- Crimson Mail Bracers
	[29786]="0:4:2:1:Plate::1:0:", -- Kirin'Var Defender's Greaves
	[29787]="0:2:2:1:OneHandMace::1:0:", -- Master Smith's Hammer
	[29788]="0:4:2:1:Mail::1:0:", -- Finely Wrought Scale Leggings
	[29789]="0:4:2:1:Plate::1:0:", -- Andrethan's Masterwork
	[29791]="0:4:2:1:Plate::1:0:", -- Reinforced Heaume
	[29792]="0:4:2:1:Cloak::1:0:", -- Dawnstrike's Cloak
	[29793]="0:4:2:1:Ring::1:0:", -- Signet of the Violet Tower
	[29794]="0:4:2:1:Amulet::1:0:", -- Strength of the Violet Tower
	[29795]="0:12:1:1:::1:0:", -- Burning Legion Gate Key
	[29796]="0:0:1:1:Consumable::1:0:", -- Socrethar's Teleportation Stone
	[29797]="0:12:1:10:::1:0:", -- Orders From Kael'thas
	[29798]="0:12:1:20:::1:0:", -- Dome Generator Segment
	[29799]="0:15:0:20:Junk::1:0:", -- Lifeless Tendril
	[29800]="0:15:0:20:Junk::1:0:", -- Evil Eye
	[29801]="0:12:1:10:::1:0:", -- Ripfang Lynx Pelt
	[29803]="0:12:1:1:::1:0:", -- Diagnostic Device
	[29804]="0:4:2:1:Leather::1:0:", -- Wrangler's Boots
	[29805]="0:0:1:1:Consumable::1:0:", -- Socrethar's Head
	[29806]="0:4:2:1:Mail::1:0:", -- Cowpoke's Riding Gloves
	[29807]="0:4:2:1:Plate::1:0:", -- Engraved Cattleman's Buckle
	[29808]="0:4:2:1:Cloth::1:0:", -- Shimmering Azure Boots
	[29810]="0:4:2:1:Leather::1:0:", -- Dragon Crested Epaulets
	[29811]="0:4:2:1:Mail::1:0:", -- Goldenlink Bracers
	[29812]="0:4:2:1:Plate::1:0:", -- Blued Steel Gauntlets
	[29813]="0:4:3:1:Cloak::1:0:", -- Cloak of Woven Energy
	[29814]="0:4:3:1:Ring::1:0:", -- Celestial Jewel Ring
	[29815]="0:4:3:1:Amulet::1:0:", -- Chain of Glowing Tendrils
	[29817]="0:12:1:1:::1:0:", -- Talbuk Tagger
	[29818]="0:12:1:1:::1:0:", -- Energy Field Modulator
	[29822]="0:12:1:8:::1:0:", -- Fragment of Dimensius
	[29901]="5000:15:1:1:Companion::1:0:21019", -- Blue Moth Egg
	[29902]="100000:15:1:1:Companion::1:0:20980", -- Red Moth Egg
	[29903]="5000:15:1:1:Companion::1:0:21019", -- Yellow Moth Egg
	[29904]="5000:15:1:1:Companion::1:0:21019", -- White Moth Egg
	[29905]="0:0:1:1:Consumable::1:0:", -- Kael's Vial Remnant
	[29906]="0:0:1:1:Consumable::1:0:", -- Vashj's Vial Remnant
	[29908]="0:2:2:1:TwoHandAxe::1:0:", -- Rage Reaver
	[29909]="0:2:2:1:Dagger::1:0:", -- Screaming Dagger
	[29910]="0:2:2:1:Stave::1:0:", -- The Staff of Twin Worlds
	[29911]="0:2:2:1:Stave::1:0:", -- Agamaggan's Quill
	[29912]="0:12:1:1:::1:0:", -- The Final Code
	[29913]="0:2:2:1:OneHandSword::1:0:", -- Foe Reaver
	[29914]="0:2:2:1:Dagger::1:0:", -- Hellfire Skiver
	[29915]="0:2:2:1:Wand::1:0:", -- Desolation Rod
	[29916]="0:2:2:1:Crossbow::1:0:", -- Ironstar Repeater
	[29917]="0:4:2:1:Shield::1:0:", -- Landslide Buckler
	[29918]="0:4:4:1:Cloth::1:0:", -- Mindstorm Wristbands
	[29919]="0:4:2:1:Shield::1:0:", -- Adamantine Kite Shield
	[29920]="0:4:4:1:Ring::1:0:", -- Phoenix-Ring of Rebirth
	[29921]="0:4:4:1:Mail::1:0:", -- Fire Crest Breastplate
	[29922]="0:4:4:1:Ring::1:0:", -- Band of Al'ar
	[29923]="0:4:4:1:OffHandFrill::1:0:", -- Talisman of the Sun King
	[29924]="0:2:4:1:OneHandAxe::1:0:", -- Netherbane
	[29925]="0:4:4:1:Cloak::1:0:", -- Phoenix-Wing Cloak
	[29926]="0:4:2:1:Cloth::1:0:", -- Whispering Tunic
	[29927]="0:4:2:1:Cloth::1:0:", -- Shadowbrim Travel Hat
	[29928]="0:4:2:1:Cloth::1:0:", -- Wanderer's Stitched Trousers
	[29929]="0:4:2:1:Leather::1:0:", -- Raging Spirit Harness
	[29930]="0:4:2:1:Leather::1:0:", -- Nature-Stitched Kilt
	[29931]="0:4:2:1:Leather::1:0:", -- Phantasmal Headdress
	[29932]="0:4:2:1:Mail::1:0:", -- Arcane Ringed Tunic
	[29933]="0:4:2:1:Mail::1:0:", -- Arcane Ringed Greaves
	[29934]="0:4:2:1:Mail::1:0:", -- Helm of Affinity
	[29935]="0:4:2:1:Plate::1:0:", -- Fire Scarred Breastplate
	[29936]="0:4:2:1:Plate::1:0:", -- Skyfire Greaves
	[29937]="0:4:2:1:Plate::1:0:", -- Helm of Infinite Visions
	[29938]="0:4:2:1:Leather::1:0:", -- Battle Seeker Chestguard
	[29939]="0:4:2:1:Leather::1:0:", -- Flayer-Hide Leggings
	[29940]="0:4:2:1:Leather::1:0:", -- Veteran's Skullcap
	[29941]="0:4:2:1:Mail::1:0:", -- Scale Brand Breastplate
	[29942]="0:4:2:1:Mail::1:0:", -- Battle Scarred Leggings
	[29943]="0:4:2:1:Mail::1:0:", -- Legionnaire's Studded Helm
	[29944]="0:4:2:1:Plate::1:0:", -- Protectorate Breastplate
	[29945]="0:4:2:1:Plate::1:0:", -- Magistrate's Greaves
	[29946]="0:4:2:1:Plate::1:0:", -- Invader's Greathelm
	[29947]="0:4:4:1:Leather::1:0:", -- Gloves of the Searing Grip
	[29948]="0:2:4:1:FistWeapon::1:0:", -- Claw of the Phoenix
	[29949]="0:2:4:1:Gun::1:0:", -- Arcanite Steam-Pistol
	[29950]="0:4:4:1:Plate::1:0:", -- Greaves of the Bloodwarder
	[29951]="0:4:4:1:Mail::1:0:", -- Star-Strider Boots
	[29952]="0:12:1:1:::1:0:", -- Rina's Bough
	[29953]="5000:15:1:1:Companion::1:0:16860", -- Golden Dragonhawk Hatchling
	[29954]="0:4:2:1:Cloth::1:0:", -- Spiritbinder's Mantle
	[29955]="0:4:2:1:Leather::1:0:", -- Mana Infused Wristguards
	[29956]="5000:15:1:1:Companion::1:0:16860", -- Red Dragonhawk Hatchling
	[29957]="5000:15:1:1:Companion::1:0:16860", -- Silver Dragonhawk Hatchling
	[29958]="100000:15:1:1:Companion::1:0:20980", -- Blue Dragonhawk Hatchling
	[29959]="0:4:2:1:Plate::1:0:", -- Spiritualist's Gauntlets
	[29960]="0:15:1:1:Companion::1:0:", -- Captured Firefly
	[29961]="0:12:1:10:::1:0:", -- Enraged Earthen Soul
	[29962]="0:2:4:1:Dagger::1:0:", -- Heartrazor
	[29963]="0:12:1:10:::1:0:", -- Enraged Fiery Soul
	[29964]="0:4:3:1:Leather::1:0:", -- Blackstorm Leggings
	[29965]="0:4:4:1:Plate::1:0:", -- Girdle of the Righteous Path
	[29966]="0:4:4:1:Leather::1:0:", -- Vambraces of Ending
	[29967]="0:4:2:1:Leather::1:0:", -- Nether Vest
	[29968]="0:4:2:1:Mail::1:0:", -- Nether Leggings
	[29969]="0:4:2:1:Plate::1:0:", -- Sparky's Discarded Helmet
	[29970]="0:4:3:1:Leather::1:0:", -- Wildfeather Leggings
	[29971]="0:4:3:1:Mail::1:0:", -- Dragonstrike Leggings
	[29972]="0:4:4:1:Cloth::1:0:", -- Trousers of the Astromancer
	[29973]="0:4:3:1:Leather::1:0:", -- Primalstorm Breastplate
	[29974]="0:4:3:1:Leather::1:0:", -- Living Crystal Breastplate
	[29975]="0:4:3:1:Mail::1:0:", -- Golden Dragonstrike Breastplate
	[29976]="0:4:4:1:Mail::1:0:", -- Worldstorm Gauntlets
	[29977]="0:4:4:1:Cloth::1:0:", -- Star-Soul Breeches
	[29978]="0:4:2:1:Cloth::1:0:", -- Consortium Combatant's Robes
	[29979]="0:4:2:1:Leather::1:0:", -- Netherstorm Eyepatch
	[29980]="0:4:2:1:Plate::1:0:", -- Midrealm Leggings
	[29981]="0:2:4:1:Stave::1:0:", -- Ethereum Life-Staff
	[29982]="0:2:4:1:Wand::1:0:", -- Wand of the Forgotten Star
	[29983]="0:4:4:1:Plate::1:0:", -- Fel-Steel Warhelm
	[29984]="0:4:4:1:Leather::1:0:", -- Girdle of Zaetar
	[29985]="0:4:4:1:Mail::1:0:", -- Void Reaver Greaves
	[29986]="0:4:4:1:Cloth::1:0:", -- Cowl of the Grand Engineer
	[29987]="0:4:4:1:Cloth::1:0:", -- Gauntlets of the Sun King
	[29988]="0:2:4:1:Stave::1:0:", -- The Nexus Key
	[29989]="0:4:4:1:Cloak::1:0:", -- Sunshower Light Cloak
	[29990]="0:4:4:1:Cloth::1:0:", -- Crown of the Sun
	[29991]="0:4:4:1:Mail::1:0:", -- Sunhawk Leggings
	[29992]="0:4:4:1:Cloak::1:0:", -- Royal Cloak of the Sunstriders
	[29993]="0:2:4:1:TwoHandSword::1:0:", -- Twinblade of the Phoenix
	[29994]="0:4:4:1:Cloak::1:0:", -- Thalassian Wildercloak
	[29995]="0:4:4:1:Leather::1:0:", -- Leggings of Murderous Intent
	[29996]="0:2:4:1:OneHandMace::1:0:", -- Rod of the Sun King
	[29997]="0:4:4:1:Ring::1:0:", -- Band of the Ranger-General
	[29998]="0:4:4:1:Plate::1:0:", -- Royal Gauntlets of Silvermoon
	[29999]="0:4:2:1:Leather::1:0:", -- After Hours Pauldrons
	[30000]="0:4:2:1:Cloth::1:0:", -- Mixologist's Gloves
	[30001]="0:4:2:1:Mail::1:0:", -- Doc's Belt
	[30002]="0:4:2:1:Plate::1:0:", -- Boot's Boots
	[30003]="0:4:2:1:Leather::1:0:", -- Gloves of the Nether-Stalker
	[30004]="0:4:2:1:Mail::1:0:", -- Landing Boots
	[30005]="0:4:2:1:Plate::1:0:", -- Overmaster's Shoulders
	[30006]="0:4:2:1:Ring::1:0:", -- Wind Trader's Band
	[30007]="0:4:4:1:Amulet::1:0:", -- The Darkener's Grasp
	[30008]="0:4:4:1:Amulet::1:0:", -- Pendant of the Lost Ages
	[30009]="0:2:3:1:TwoHandAxe::1:0:", -- The Burning Crusader
	[30010]="0:2:3:1:Stave::1:0:", -- Fleshling Simulation Staff
	[30011]="0:2:3:1:Stave::1:0:", -- Ameer's Impulse Taser
	[30012]="0:2:3:1:Stave::1:0:", -- Ameer's Judgement
	[30013]="0:2:3:1:Dagger::1:0:", -- Twin-Bladed Ripper
	[30014]="0:4:3:1:Leather::1:0:", -- X-52 Pilot's Leggings
	[30015]="0:4:4:1:Amulet::1:0:", -- The Sun King's Talisman
	[30016]="0:4:3:1:Plate::1:0:", -- X-52 Technician's Helm
	[30017]="0:4:4:1:Amulet::1:0:", -- Telonicus's Pendant of Mayhem
	[30018]="0:4:4:1:Amulet::1:0:", -- Lord Sanguinar's Claim
	[30019]="0:4:3:1:Mail::1:0:", -- Area 52 Defender's Pants
	[30020]="0:4:4:1:Cloth::1:0:", -- Fire-Cord of the Magus
	[30021]="0:2:4:1:Stave::1:0:", -- Wildfury Greatstaff
	[30022]="0:4:4:1:Amulet::1:0:", -- Pendant of the Perilous
	[30023]="0:4:4:1:Totem::1:0:", -- Totem of the Maelstrom
	[30024]="0:4:4:1:Cloth::1:0:", -- Mantle of the Elven Kings
	[30025]="0:2:4:1:Thrown::1:0:", -- Serpentshrine Shuriken
	[30026]="0:4:4:1:Mail::1:0:", -- Bands of the Celestial Archer
	[30027]="0:4:4:1:Plate::1:0:", -- Boots of Courage Unending
	[30028]="0:4:4:1:Ring::1:0:", -- Seventh Ring of the Tirisfalen
	[30029]="0:4:4:1:Leather::1:0:", -- Bark-Gloves of Ancient Wisdom
	[30030]="0:4:4:1:Mail::1:0:", -- Girdle of Fallen Stars
	[30031]="0:4:4:1:Plate::1:0:", -- Red Havoc Boots
	[30032]="0:4:4:1:Plate::1:0:", -- Red Belt of Battle
	[30033]="0:4:4:1:Plate::1:0:", -- Boots of the Protector
	[30034]="0:4:4:1:Plate::1:0:", -- Belt of the Guardian
	[30035]="0:4:4:1:Cloth::1:0:", -- Boots of the Long Road
	[30036]="0:4:4:1:Cloth::1:0:", -- Belt of the Long Road
	[30037]="0:4:4:1:Cloth::1:0:", -- Boots of Blasting
	[30038]="0:4:4:1:Cloth::1:0:", -- Belt of Blasting
	[30039]="0:4:4:1:Leather::1:0:", -- Boots of Utter Darkness
	[30040]="0:4:4:1:Leather::1:0:", -- Belt of Deep Shadow
	[30041]="0:4:4:1:Leather::1:0:", -- Boots of Natural Grace
	[30042]="0:4:4:1:Leather::1:0:", -- Belt of Natural Power
	[30043]="0:4:4:1:Mail::1:0:", -- Hurricane Boots
	[30044]="0:4:4:1:Mail::1:0:", -- Monsoon Belt
	[30045]="0:4:4:1:Mail::1:0:", -- Boots of the Crimson Hawk
	[30046]="0:4:4:1:Mail::1:0:", -- Belt of the Black Eagle
	[30047]="0:4:4:1:Mail::1:0:", -- Blackfathom Warbands
	[30048]="0:4:4:1:Plate::1:0:", -- Brighthelm of Justice
	[30049]="0:4:4:1:OffHandFrill::1:0:", -- Fathomstone
	[30050]="0:4:4:1:Cloth::1:0:", -- Boots of the Shifting Nightmare
	[30051]="0:4:4:1:Idol::1:0:", -- Idol of the Crescent Goddess
	[30052]="0:4:4:1:Ring::1:0:", -- Ring of Lethality
	[30053]="0:4:4:1:Plate::1:0:", -- Pauldrons of the Wardancer
	[30054]="0:4:4:1:Mail::1:0:", -- Ranger-General's Chestguard
	[30055]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Stranger
	[30056]="0:4:4:1:Cloth::1:0:", -- Robe of Hateful Echoes
	[30057]="0:4:4:1:Plate::1:0:", -- Bracers of Eradication
	[30058]="0:2:4:1:OneHandMace::1:0:", -- Mallet of the Tides
	[30059]="0:4:4:1:Amulet::1:0:", -- Choker of Animalistic Fury
	[30060]="0:4:4:1:Leather::1:0:", -- Boots of Effortless Striking
	[30061]="0:4:4:1:Ring::1:0:", -- Ancestral Ring of Conquest
	[30062]="0:4:4:1:Leather::1:0:", -- Grove-Bands of Remulos
	[30063]="0:4:4:1:Libram::1:0:", -- Libram of Absolute Truth
	[30064]="0:4:4:1:Cloth::1:0:", -- Cord of Screaming Terrors
	[30065]="0:4:4:1:Plate::1:0:", -- Glowing Breastplate of Truth
	[30066]="0:4:4:1:Mail::1:0:", -- Tempest-Strider Boots
	[30067]="0:4:4:1:Cloth::1:0:", -- Velvet Boots of the Guardian
	[30068]="0:4:4:1:Mail::1:0:", -- Girdle of the Tidal Call
	[30069]="0:4:3:1:Plate::1:0:", -- Earthforged Leggings
	[30070]="0:4:3:1:Mail::1:0:", -- Windforged Leggings
	[30071]="0:2:3:1:OneHandSword::1:0:", -- Light Earthforged Blade
	[30072]="0:2:3:1:OneHandAxe::1:0:", -- Light Skyforged Axe
	[30073]="0:2:3:1:OneHandMace::1:0:", -- Light Emberforged Hammer
	[30074]="0:4:3:1:Plate::1:0:", -- Heavy Earthforged Breastplate
	[30075]="0:4:4:1:Leather::1:0:", -- Gnarled Chestpiece of the Ancients
	[30076]="0:4:3:1:Mail::1:0:", -- Stormforged Hauberk
	[30077]="0:2:3:1:OneHandSword::1:0:", -- Windforged Rapier
	[30079]="0:4:4:1:Cloth::1:0:", -- Illidari Shoulderpads
	[30080]="0:2:4:1:Wand::1:0:", -- Luminescent Rod of the Naaru
	[30081]="0:4:4:1:Plate::1:0:", -- Warboots of Obliteration
	[30082]="0:2:4:1:OneHandSword::1:0:", -- Talon of Azshara
	[30083]="0:4:4:1:Ring::1:0:", -- Ring of Sundered Souls
	[30084]="0:4:4:1:Plate::1:0:", -- Pauldrons of the Argent Sentinel
	[30085]="0:4:4:1:Mail::1:0:", -- Mantle of the Tireless Tracker
	[30086]="0:2:3:1:TwoHandSword::1:0:", -- Stoneforged Claymore
	[30087]="0:2:3:1:OneHandAxe::1:0:", -- Stormforged Axe
	[30088]="0:2:3:1:TwoHandAxe::1:0:", -- Skyforged Great Axe
	[30089]="0:2:3:1:OneHandMace::1:0:", -- Lavaforged Warhammer
	[30090]="0:2:4:1:TwoHandMace::1:0:", -- World Breaker
	[30091]="0:4:4:1:Mail::1:0:", -- True-Aim Stalker Bands
	[30092]="0:4:4:1:Leather::1:0:", -- Orca-Hide Boots
	[30093]="0:2:3:1:TwoHandMace::1:0:", -- Great Earthforged Hammer
	[30094]="0:12:1:1:::1:0:", -- Totem of Spirits
	[30095]="0:2:4:1:OneHandSword::1:0:", -- Fang of the Leviathan
	[30096]="0:4:4:1:Plate::1:0:", -- Girdle of the Invulnerable
	[30097]="0:4:4:1:Mail::1:0:", -- Coral-Barbed Shoulderpads
	[30098]="0:4:4:1:Cloak::1:0:", -- Razor-Scale Battlecloak
	[30099]="0:4:4:1:Amulet::1:0:", -- Frayed Tether of the Drowned
	[30100]="0:4:4:1:Cloth::1:0:", -- Soul-Strider Boots
	[30101]="0:4:4:1:Leather::1:0:", -- Bloodsea Brigand's Vest
	[30102]="0:4:4:1:Plate::1:0:", -- Krakken-Heart Breastplate
	[30103]="0:2:4:1:Dagger::1:0:", -- Fang of Vashj
	[30104]="0:4:4:1:Mail::1:0:", -- Cobra-Lash Boots
	[30105]="0:2:4:1:Bow::1:0:", -- Serpent Spine Longbow
	[30106]="0:4:4:1:Leather::1:0:", -- Belt of One-Hundred Deaths
	[30107]="0:4:4:1:Cloth::1:0:", -- Vestments of the Sea-Witch
	[30108]="0:2:4:1:OneHandMace::1:0:", -- Lightfathom Scepter
	[30109]="0:4:4:1:Ring::1:0:", -- Ring of Endless Coils
	[30110]="0:4:4:1:Ring::1:0:", -- Coral Band of the Revived
	[30111]="0:4:4:1:Leather::1:0:", -- Runetotem's Mantle
	[30112]="0:4:4:1:Plate::1:0:", -- Glorious Gauntlets of Crestfall
	[30113]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Chestguard
	[30114]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Handguards
	[30115]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Greathelm
	[30116]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Legguards
	[30117]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Shoulderguards
	[30118]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Breastplate
	[30119]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Gauntlets
	[30120]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Battle-Helm
	[30121]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Greaves
	[30122]="0:4:4:1:Plate::1:0:21905,21906", -- Destroyer Shoulderblades
	[30123]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Chestguard
	[30124]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Handguards
	[30125]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Faceguard
	[30126]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Legguards
	[30127]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Shoulderguards
	[30129]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Breastplate
	[30130]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Gauntlets
	[30131]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge War-Helm
	[30132]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Greaves
	[30133]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Shoulderbraces
	[30134]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Chestpiece
	[30135]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Gloves
	[30136]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Greathelm
	[30137]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Leggings
	[30138]="0:4:4:1:Plate::1:0:21905,21906", -- Crystalforge Pauldrons
	[30139]="0:4:4:1:Mail::1:0:21905,21906", -- Rift Stalker Hauberk
	[30140]="0:4:4:1:Mail::1:0:21905,21906", -- Rift Stalker Gauntlets
	[30141]="0:4:4:1:Mail::1:0:21905,21906", -- Rift Stalker Helm
	[30142]="0:4:4:1:Mail::1:0:21905,21906", -- Rift Stalker Leggings
	[30143]="0:4:4:1:Mail::1:0:21905,21906", -- Rift Stalker Mantle
	[30144]="0:4:4:1:Leather::1:0:21905,21906", -- Deathmantle Chestguard
	[30145]="0:4:4:1:Leather::1:0:21905,21906", -- Deathmantle Handguards
	[30146]="0:4:4:1:Leather::1:0:21905,21906", -- Deathmantle Helm
	[30148]="0:4:4:1:Leather::1:0:21905,21906", -- Deathmantle Legguards
	[30149]="0:4:4:1:Leather::1:0:21905,21906", -- Deathmantle Shoulderpads
	[30150]="0:4:4:1:Cloth::1:0:21905,21906", -- Vestments of the Avatar
	[30151]="0:4:4:1:Cloth::1:0:21905,21906", -- Gloves of the Avatar
	[30152]="0:4:4:1:Cloth::1:0:21905,21906", -- Cowl of the Avatar
	[30153]="0:4:4:1:Cloth::1:0:21905,21906", -- Breeches of the Avatar
	[30154]="0:4:4:1:Cloth::1:0:21905,21906", -- Mantle of the Avatar
	[30155]="0:0:1:20:FoodDrink::1:0:", -- Clam Bar
	[30156]="0:9:1:1:Cooking::1:0:18382", -- Recipe: Clam Bar
	[30157]="0:12:1:20:::1:0:", -- Cursed Talisman
	[30158]="0:12:1:1:::1:0:", -- Morkh's Shattered Armor
	[30159]="0:4:4:1:Cloth::1:0:21905,21906", -- Shroud of the Avatar
	[30160]="0:4:4:1:Cloth::1:0:21905,21906", -- Handguards of the Avatar
	[30161]="0:4:4:1:Cloth::1:0:21905,21906", -- Hood of the Avatar
	[30162]="0:4:4:1:Cloth::1:0:21905,21906", -- Leggings of the Avatar
	[30163]="0:4:4:1:Cloth::1:0:21905,21906", -- Wings of the Avatar
	[30164]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Chestguard
	[30165]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Gloves
	[30166]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Headguard
	[30167]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Legguards
	[30168]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Shoulderguards
	[30169]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Chestpiece
	[30170]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Handgrips
	[30171]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Headpiece
	[30172]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Leggings
	[30173]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Shoulderpads
	[30174]="0:12:1:20:::1:0:", -- Dust of the Fey Drake
	[30175]="0:12:1:1:::1:0:", -- Gor'drek's Ointment
	[30177]="0:12:1:1:::1:0:", -- Stronglimb Deeproot's Trunk
	[30183]="0:7:4:20:Material:171,164,165,197:1:0:18525", -- Nether Vortex
	[30184]="0:12:1:20:::1:0:", -- Thunderlord Dire Wolf Tail
	[30185]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Chestplate
	[30186]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Felweave Amice
	[30187]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Felweave Cowl
	[30188]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Felweave Handguards
	[30189]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Gauntlets
	[30190]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Helm
	[30192]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Legplates
	[30194]="0:4:4:1:Mail::1:0:21905,21906", -- Cataclysm Shoulderplates
	[30196]="0:4:4:1:Cloth::1:0:21905,21906", -- Robes of Tirisfal
	[30200]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Felweave Raiment
	[30201]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Felweave Trousers
	[30205]="0:4:4:1:Cloth::1:0:21905,21906", -- Gloves of Tirisfal
	[30206]="0:4:4:1:Cloth::1:0:21905,21906", -- Cowl of Tirisfal
	[30207]="0:4:4:1:Cloth::1:0:21905,21906", -- Leggings of Tirisfal
	[30210]="0:4:4:1:Cloth::1:0:21905,21906", -- Mantle of Tirisfal
	[30211]="0:4:4:1:Cloth::1:0:21905,21906", -- Gloves of the Corruptor
	[30212]="0:4:4:1:Cloth::1:0:21905,21906", -- Hood of the Corruptor
	[30213]="0:4:4:1:Cloth::1:0:21905,21906", -- Leggings of the Corruptor
	[30214]="0:4:4:1:Cloth::1:0:21905,21906", -- Robe of the Corruptor
	[30215]="0:4:4:1:Cloth::1:0:21905,21906", -- Mantle of the Corruptor
	[30216]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Chestguard
	[30217]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Gloves
	[30218]="0:4:2:1:Leather::1:0:", -- Junior Technician 3rd Grade Shoulders
	[30219]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Headguard
	[30220]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Life-Kilt
	[30221]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Life-Mantle
	[30222]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Chestplate
	[30223]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Handgrips
	[30224]="0:4:2:1:Mail::1:0:", -- Junior Technician 3rd Grade Gloves
	[30225]="0:4:2:1:Plate::1:0:", -- Junior Technician 3rd Grade Bracers
	[30226]="0:2:2:1:Bow::1:0:", -- Alley's Recurve
	[30227]="0:2:2:1:Thrown::1:0:", -- Mark V's Throwing Star
	[30228]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Headdress
	[30229]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Feral-Kilt
	[30230]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Feral-Mantle
	[30231]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Chestpiece
	[30232]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Gauntlets
	[30233]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Headpiece
	[30234]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Wrath-Kilt
	[30235]="0:4:4:1:Leather::1:0:21905,21906", -- Nordrassil Wrath-Mantle
	[30236]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Vanquished Champion
	[30237]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Vanquished Defender
	[30238]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Vanquished Hero
	[30239]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Vanquished Champion
	[30240]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Vanquished Defender
	[30241]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Vanquished Hero
	[30242]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Vanquished Champion
	[30243]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Vanquished Defender
	[30244]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Vanquished Hero
	[30245]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Vanquished Champion
	[30246]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Vanquished Defender
	[30247]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Vanquished Hero
	[30248]="0:15:4:1:ArmorToken::1:0:", -- Pauldrons of the Vanquished Champion
	[30249]="0:15:4:1:ArmorToken::1:0:", -- Pauldrons of the Vanquished Defender
	[30250]="0:15:4:1:ArmorToken::1:0:", -- Pauldrons of the Vanquished Hero
	[30251]="0:12:1:1:::1:0:", -- Rina's Diminution Powder
	[30252]="0:2:2:1:Wand::1:0:", -- Unearthed Enkaat Wand
	[30253]="0:4:2:1:Cloth::1:0:", -- Ethereal Gloves
	[30254]="0:4:2:1:Plate::1:0:", -- Zephyrion's Belt
	[30255]="0:4:2:1:Mail::1:0:", -- Chestguard of the Stormspire
	[30256]="0:4:3:1:Cloth::1:0:", -- Pants of the Naaru
	[30257]="0:4:3:1:Leather::1:0:", -- Shattrath Leggings
	[30258]="0:4:3:1:Plate::1:0:", -- Chestplate of A'dal
	[30259]="0:15:1:1:Junk::1:0:", -- Voren'thal's Presence
	[30260]="0:0:1:1:Consumable::1:0:", -- Voren'thal's Package
	[30262]="0:4:2:1:Leather::1:0:", -- Trep's Shoulderguards
	[30263]="0:4:2:1:Mail::1:0:", -- Heavy-Duty Engineering Boots
	[30264]="0:4:2:1:Plate::1:0:", -- Area 52 Engineering Gloves
	[30265]="0:4:2:1:Cloth::1:0:", -- Zaxxis Bracers
	[30266]="0:4:2:1:Leather::1:0:", -- Zaxxis Boots
	[30267]="0:4:2:1:Plate::1:0:", -- Zaxxis Gloves
	[30268]="0:4:2:1:Cloth::1:0:", -- Heap Leggings
	[30269]="0:4:2:1:Leather::1:0:", -- Warp-Raider's Eyepatch
	[30270]="0:4:2:1:Plate::1:0:", -- Scavenged Breastplate
	[30271]="0:4:2:1:Cloth::1:0:", -- Midrealm Hat
	[30272]="0:4:2:1:Leather::1:0:", -- Eco-Dome Leggings
	[30273]="0:4:2:1:Mail::1:0:", -- Duro Footgear
	[30274]="0:4:2:1:Mail::1:0:", -- Papa's Armbands
	[30275]="0:4:2:1:Plate::1:0:", -- Mech Tech Shoulders
	[30276]="0:4:2:1:Amulet::1:0:", -- Wheeler Family Heirloom
	[30277]="0:2:2:1:FistWeapon::1:0:", -- Ripfang Paw
	[30278]="0:2:2:1:OneHandSword::1:0:", -- Pilfered Ethereal Blade
	[30279]="0:2:2:1:Gun::1:0:", -- Mama's Insurance
	[30280]="0:9:4:1:Tailoring::1:0:", -- Pattern: Belt of Blasting
	[30281]="0:9:4:1:Tailoring::1:0:", -- Pattern: Belt of the Long Road
	[30282]="0:9:4:1:Tailoring::1:0:", -- Pattern: Boots of Blasting
	[30283]="0:9:4:1:Tailoring::1:0:", -- Pattern: Boots of the Long Road
	[30284]="0:4:2:1:Cloth::1:0:", -- Audi's Embroidered Boots
	[30285]="0:4:2:1:Leather::1:0:", -- B.O.O.M. Operative's Belt
	[30286]="0:4:2:1:Mail::1:0:", -- Otherworldly Pauldrons
	[30290]="0:4:2:1:Leather::1:0:", -- Leggings of Concentrated Power
	[30291]="0:4:2:1:Plate::1:0:", -- Nexus-Guard's Pauldrons
	[30293]="0:4:2:1:Trinket::1:0:", -- Heavenly Inspiration
	[30294]="0:4:2:1:Cloth::1:0:", -- Red Pointy Hat
	[30295]="0:4:2:1:Mail::1:0:", -- Exotic Spiked Shoulders
	[30296]="0:4:2:1:Plate::1:0:", -- Lost Chestplate of the Reverent
	[30297]="0:4:3:1:Leather::1:0:", -- Circlet of the Starcaller
	[30298]="0:4:3:1:Mail::1:0:", -- Void Slayer's Tunic
	[30299]="0:4:3:1:Plate::1:0:", -- Starcaller's Plated Legguards
	[30300]="0:4:3:1:Trinket::1:0:", -- Dabiri's Enigma
	[30301]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Belt of Natural Power
	[30302]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Belt of Deep Shadow
	[30303]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Belt of the Black Eagle
	[30304]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Monsoon Belt
	[30305]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Boots of Natural Grace
	[30306]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Boots of Utter Darkness
	[30307]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Boots of the Crimson Hawk
	[30308]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Hurricane Boots
	[30309]="0:0:1:5:Consumable::1:0:", -- Stonebreaker Brew
	[30311]="0:2:5:1:OneHandSword::1:0:", -- Warp Slicer
	[30312]="0:2:5:1:Dagger::1:0:", -- Infinity Blade
	[30313]="0:2:5:1:Stave::1:0:", -- Staff of Disintegration
	[30314]="0:4:5:1:Shield::1:0:", -- Phaseshift Bulwark
	[30315]="0:12:1:20:::1:0:", -- Draenethyst Mine Crystal
	[30316]="0:2:5:1:TwoHandAxe::1:0:", -- Devastation
	[30317]="0:2:5:1:OneHandMace::1:0:", -- Cosmic Infuser
	[30318]="0:2:5:1:Bow::1:0:", -- Netherstrand Longbow
	[30319]="0:6:5:1000:Arrow::1:0:", -- Nether Spike
	[30320]="0:15:5:1:Junk::1:0:", -- Bundle of Nether Spikes
	[30321]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Belt of the Guardian
	[30322]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Red Belt of Battle
	[30323]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Boots of the Protector
	[30324]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Red Havoc Boots
	[30326]="0:12:1:1:::1:0:", -- Bonechewer Blood Samples
	[30327]="0:12:1:20:::1:0:", -- Bonechewer Blood
	[30328]="0:4:2:1:Leather::1:0:", -- Protectorate Assassin's Tunic
	[30329]="0:4:2:1:Mail::1:0:", -- Flesh Handler's Headpiece
	[30330]="0:4:2:1:Plate::1:0:", -- Starcaller's Plated Belt
	[30331]="0:4:2:1:Cloth::1:0:", -- Diviner's Cinch
	[30332]="0:4:2:1:Leather::1:0:", -- Ferocious Bands
	[30333]="0:4:2:1:Mail::1:0:", -- Spaulders of the Protectorate
	[30334]="0:4:2:1:Plate::1:0:", -- Starcaller's Plated Stompers
	[30335]="0:4:2:1:Leather::1:0:", -- Druidic Force Boots
	[30336]="0:4:2:1:Mail::1:0:", -- Surger's Hand Wraps
	[30337]="0:4:2:1:Plate::1:0:", -- Protectorate Headplate
	[30338]="0:4:2:1:Cloak::1:0:", -- Diviner's Cloak
	[30339]="0:4:2:1:Ring::1:0:", -- Protectorate Assassin's Ring
	[30340]="0:4:2:1:Trinket::1:0:", -- Starkiller's Bauble
	[30341]="0:4:2:1:Leather::1:0:", -- Flesh Handler's Gauntlets
	[30342]="0:4:2:1:Mail::1:0:", -- Protectorate Waistband
	[30343]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[30344]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[30345]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[30346]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[30348]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[30349]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[30350]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[30351]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[30352]="0:4:2:1:Plate::1:0:", -- Demolisher's Bracers
	[30353]="0:12:1:1:::1:0:", -- Bloodmaul Brutebane Keg
	[30354]="0:12:1:1:::1:0:", -- Ultra Deconsolodation Zapper
	[30355]="8000:0:1:20:FoodDrink::5:0:21183", -- Grilled Shadowmoon Tuber
	[30356]="0:12:1:10:::1:0:", -- Shadowmoon Tuber
	[30357]="0:0:1:20:FoodDrink::1:0:", -- Oronok's Tuber of Healing
	[30358]="0:0:1:20:FoodDrink::1:0:", -- Oronok's Tuber of Agility
	[30359]="0:0:1:20:FoodDrink::1:0:", -- Oronok's Tuber of Strength
	[30360]="0:15:3:1:Companion::1:0:", -- Lurky's Egg
	[30361]="0:0:1:20:FoodDrink::1:0:", -- Oronok's Tuber of Spell Power
	[30362]="0:4:2:1:Leather::1:0:", -- Energized Helm
	[30363]="0:4:2:1:Mail::1:0:", -- Warp-Shielded Hauberk
	[30364]="0:2:2:1:OneHandAxe::1:0:", -- Resonating Axe
	[30365]="0:4:3:1:Ring::1:0:", -- Overseer's Signet
	[30366]="0:4:3:1:Ring::1:0:", -- Manastorm Band
	[30368]="0:4:3:1:Cloth::1:0:", -- Slippers of the High Priestess
	[30369]="0:4:3:1:Leather::1:0:", -- Cleansed Fel Pauldrons
	[30370]="0:4:3:1:Mail::1:0:", -- Gauntlets of the Redeemed Vindicator
	[30371]="0:4:3:1:Plate::1:0:", -- Lightwarden's Girdle
	[30372]="0:4:3:1:Leather::1:0:", -- Socrethar's Girdle
	[30373]="0:4:3:1:Leather::1:0:", -- Netherfused Pauldrons
	[30374]="0:4:3:1:Mail::1:0:", -- Greaves of Spellpower
	[30375]="0:4:3:1:Plate::1:0:", -- Gauntlets of the Vanquisher
	[30377]="0:4:3:1:Amulet::1:0:", -- Karja's Medallion
	[30378]="0:4:3:1:Amulet::1:0:", -- Thalodien's Charm
	[30379]="0:4:2:1:Leather::1:0:", -- Vindicator's Light Vest
	[30380]="0:4:2:1:Plate::1:0:", -- Girdle of the Lost Vindicator
	[30381]="0:4:2:1:Plate::1:0:", -- Kaylaan's Spaulders
	[30382]="0:4:2:1:Cloth::1:0:", -- Aldor Ceremonial Wraps
	[30383]="0:4:2:1:Cloth::1:0:", -- Belt of the Sage
	[30384]="0:4:2:1:Leather::1:0:", -- Brightdawn Bracers
	[30386]="0:4:2:1:Plate::1:0:", -- Bloodguard's Greaves
	[30394]="0:2:2:1:TwoHandSword::1:0:", -- Sunfury Blade
	[30395]="0:2:2:1:TwoHandMace::1:0:", -- Warp-Master's Maul
	[30396]="0:2:2:1:Polearm::1:0:", -- Jeweled Halberd
	[30397]="0:2:2:1:Crossbow::1:0:", -- Spymaster's Crossbow
	[30398]="0:4:2:1:Cloth::1:0:", -- Boots of the Beneficent
	[30399]="0:4:2:1:Leather::1:0:", -- Nightstalker's Wristguards
	[30400]="0:4:2:1:Plate::1:0:", -- Thadell's Bracers
	[30401]="0:4:2:1:Leather::1:0:", -- Farahlite Studded Boots
	[30402]="0:4:2:1:Plate::1:0:", -- Field Agent's Bracers
	[30404]="0:12:1:1:::1:0:", -- Bleeding Hollow Blood Sample
	[30413]="0:12:1:1:::1:0:", -- Vindicator Vuuleen's Blade
	[30415]="0:12:1:1:::1:0:", -- Vindicator Vuuleen's Shield
	[30416]="0:12:1:1:::1:0:", -- Bladespire Clan Banner
	[30417]="0:12:1:1:::1:0:", -- Helm of Gurn Grubnosh
	[30419]="0:4:2:1:Amulet::1:0:", -- Brilliant Necklace
	[30420]="0:4:2:1:Ring::1:0:", -- Heavy Jade Ring
	[30421]="0:4:2:1:Ring::1:0:", -- Red Ring of Destruction
	[30422]="0:4:2:1:Ring::1:0:", -- Diamond Focus Ring
	[30425]="0:12:1:20:::1:0:", -- Bleeding Hollow Blood
	[30426]="0:13:1:50:::1:0:", -- Coilskar Chest Key
	[30428]="0:12:1:1:::1:0:", -- First Fragment of the Cipher of Damnation
	[30429]="0:12:1:1:::1:0:", -- Grom'tor's Lockbox
	[30430]="0:12:1:20:::1:0:", -- Boiled Blood
	[30431]="0:12:1:1:::1:0:", -- Thunderlord Clan Artifact
	[30432]="0:12:1:1:::1:0:", -- Thunderlord Clan Drum
	[30433]="0:12:1:1:::1:0:", -- Thunderlord Clan Arrow
	[30434]="0:12:1:1:::1:0:", -- Thunderlord Clan Tablet
	[30435]="0:12:1:1:::1:0:", -- The Thunderspike
	[30436]="0:15:1:1:Junk::1:0:", -- Jagged Blue Crystal
	[30437]="0:15:1:1:Junk::1:0:", -- Jagged Red Crystal
	[30438]="0:13:1:1:::1:0:", -- Cache of the Legion Key
	[30442]="0:13:1:1:::1:0:", -- Crystalline Key
	[30443]="80000:9:2:1:Alchemy::1:0:20240", -- Recipe: Transmute Primal Fire to Earth
	[30444]="50000:9:1:1:Leatherworking::1:0:20240", -- Pattern: Reinforced Mining Bag
	[30446]="0:4:4:1:Trinket::1:0:", -- Solarian's Sapphire
	[30447]="0:4:4:1:Trinket::1:0:", -- Tome of Fiery Redemption
	[30448]="0:4:4:1:Trinket::1:0:", -- Talon of Al'ar
	[30449]="0:4:4:1:Trinket::1:0:", -- Void Star Talisman
	[30450]="0:4:4:1:Trinket::1:0:", -- Warp-Spring Coil
	[30451]="0:12:1:1:::1:0:", -- Lohn'goron, Bow of the Torn-heart
	[30453]="0:12:1:1:::1:0:", -- Second Fragment of the Cipher of Damnation
	[30454]="0:12:1:1:::1:0:", -- Ar'tor's Lockbox
	[30457]="0:0:1:20:FoodDrink::1:0:", -- Gilneas Sparkling Water
	[30458]="0:0:1:20:FoodDrink::1:0:", -- Stromgarde Muenster
	[30459]="0:4:3:1:Cloth::1:0:", -- Netherflame Robe
	[30460]="0:4:3:1:Cloth::1:0:", -- Netherflame Belt
	[30461]="0:4:3:1:Cloth::1:0:", -- Netherflame Boots
	[30462]="0:12:1:1:::1:0:", -- Oronok's Boar Whistle
	[30463]="0:4:3:1:Cloth::1:0:", -- Lifeblood Belt
	[30464]="0:4:3:1:Cloth::1:0:", -- Lifeblood Bracers
	[30465]="0:4:3:1:Cloth::1:0:", -- Lifeblood Leggings
	[30466]="0:15:0:10:Junk::1:0:", -- Crocolisk Tooth
	[30467]="0:15:0:10:Junk::1:0:", -- Crocolisk Tail
	[30468]="0:12:1:1:::1:0:", -- T'chali's Hookah
	[30475]="0:15:0:20:Junk::1:0:", -- Razor Thorn
	[30476]="0:15:0:20:Junk::1:0:", -- Hypnotic Flower
	[30477]="0:15:0:20:Junk::1:0:", -- Connective Tissue
	[30478]="0:15:0:20:Junk::1:0:", -- Stringy Ectoplasm
	[30479]="0:12:1:1:::1:0:", -- Wicked Strong Fetish
	[30480]="0:15:4:1:Mount::1:0:", -- Fiery Warhorse's Reins
	[30481]="0:12:1:1:::1:0:", -- Fiery Soul Fragment
	[30483]="40000:9:1:1:Tailoring::1:0:22212,29510", -- Pattern: Shadowcloth
	[30486]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Plate Chestpiece
	[30487]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Plate Gauntlets
	[30488]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Plate Helm
	[30489]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Plate Legguards
	[30490]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Plate Shoulders
	[30497]="0:4:4:1:Mail::1:0:", -- Sentinel's Mail Leggings
	[30498]="0:4:4:1:Plate::1:0:", -- Outrider's Lamellar Legguards
	[30499]="0:0:1:5:Consumable::1:0:", -- Brightsong Wine
	[30500]="0:12:1:1:::1:0:", -- Rotten Arakkoa Egg
	[30501]="0:12:1:1:::1:0:", -- Bundle of Bloodthistle
	[30503]="0:12:1:1:::1:0:", -- Archeologist's Shrunken Head
	[30504]="0:2:2:1:Dagger::1:0:", -- Leafblade Dagger
	[30505]="0:4:2:1:Leather::1:0:", -- Ghostclaw Tunic
	[30506]="0:15:0:5:Junk::1:0:", -- Snipe Egg
	[30507]="0:15:0:5:Junk::1:0:", -- Lucky Rock
	[30508]="0:15:0:5:Junk::1:0:", -- Pickled Murloc Head
	[30509]="0:15:0:5:Junk::1:0:", -- Armor Fragment
	[30510]="0:15:0:10:Junk::1:0:", -- Imbued Leaf
	[30511]="0:15:0:10:Junk::1:0:", -- Stonewood
	[30512]="0:15:0:5:Junk::1:0:", -- Giant Spinneret
	[30513]="0:15:0:20:Junk::1:0:", -- Bloody Spider Fang
	[30514]="0:4:2:1:Cloth::1:0:", -- Nether Guards
	[30515]="0:4:2:1:Cloth::1:0:", -- Junior Technician 3rd Grade Goggles
	[30516]="0:4:2:1:Cloth::1:0:", -- Chief Engineer's Belt
	[30517]="0:4:2:1:Cloth::1:0:", -- Netherfarer's Leggings
	[30518]="0:4:2:1:Cloth::1:0:", -- Warpthread Vest
	[30519]="0:4:2:1:Cloth::1:0:", -- Boots of the Nexus Warden
	[30520]="0:4:2:1:Cloth::1:0:", -- Gold-Trimmed Cuffs
	[30521]="0:4:2:1:Cloth::1:0:", -- Warpweaver's Gloves
	[30522]="0:2:2:1:Stave::1:0:", -- Conjurer's Staff
	[30523]="0:2:2:1:Wand::1:0:", -- Hotshot Cattle Prod
	[30524]="0:12:1:1:::1:0:", -- Ancient Draenei Manuscript, Chapter 1
	[30525]="0:12:1:1:::1:0:", -- Ancient Draenei Manuscript, Chapter 2
	[30526]="0:12:1:1:::1:0:", -- Ancient Draenei Manuscript, Chapter 3
	[30527]="0:12:1:1:::1:0:", -- Draenei Tomb Relic
	[30529]="0:12:1:20:::1:0:", -- Plucked Lashh'an Feather
	[30530]="0:12:1:1:::1:0:", -- Fistful of Feathers
	[30531]="0:4:4:1:Cloth::1:0:", -- Breeches of the Occultist
	[30532]="0:4:4:1:Cloth::1:0:", -- Kirin Tor Master's Trousers
	[30533]="0:4:4:1:Plate::1:0:", -- Vanquisher's Legplates
	[30534]="0:4:4:1:Mail::1:0:", -- Wyrmscale Greaves
	[30535]="0:4:4:1:Leather::1:0:", -- Forestwalker Kilt
	[30536]="0:4:4:1:Plate::1:0:", -- Greaves of the Martyr
	[30538]="0:4:4:1:Leather::1:0:", -- Midnight Legguards
	[30539]="0:12:1:1:::1:0:", -- Tally's Waiver (Signed)
	[30540]="0:0:1:1:Consumable::1:0:", -- Tally's Waiver (Unsigned)
	[30541]="0:4:4:1:Mail::1:0:", -- Stormsong Kilt
	[30542]="0:4:2:1:Miscellaneous::1:0:", -- Dimensional Ripper - Area 52
	[30543]="0:4:4:1:Cloth::1:0:", -- Pontifex Kilt
	[30544]="0:4:2:1:Miscellaneous::1:0:", -- Ultrasafe Transporter: Toshley's Station
	[30546]="0:3:4:1:GemPurple::1:0:", -- Sovereign Tanzanite
	[30547]="0:3:4:1:GemOrange::1:0:", -- Luminous Fire Opal
	[30548]="0:3:4:1:GemGreen::1:0:", -- Polished Chrysoprase
	[30549]="0:3:4:1:GemPurple::1:0:", -- Shifting Tanzanite
	[30550]="0:3:4:1:GemGreen::1:0:", -- Sundered Chrysoprase
	[30551]="0:3:4:1:GemOrange::1:0:", -- Infused Fire Opal
	[30552]="0:3:4:1:GemPurple::1:0:", -- Blessed Tanzanite
	[30553]="0:3:4:1:GemOrange::1:0:", -- Pristine Fire Opal
	[30554]="0:3:4:1:GemOrange::1:0:", -- Stalwart Fire Opal
	[30555]="0:3:4:1:GemPurple::1:0:", -- Glowing Tanzanite
	[30556]="0:3:4:1:GemOrange::1:0:", -- Glinting Fire Opal
	[30558]="0:3:4:1:GemOrange::1:0:", -- Glimmering Fire Opal
	[30559]="0:3:4:1:GemOrange::1:0:", -- Etched Fire Opal
	[30560]="0:3:4:1:GemGreen::1:0:", -- Rune Covered Chrysoprase
	[30561]="0:12:1:1:::1:0:", -- Vekh'nir Crystal
	[30563]="0:3:4:1:GemPurple::1:0:", -- Regal Tanzanite
	[30564]="0:3:4:1:GemOrange::1:0:", -- Shining Fire Opal
	[30565]="0:3:4:1:GemOrange::1:0:", -- Assassin's Fire Opal
	[30566]="0:3:4:1:GemPurple::1:0:", -- Defender's Tanzanite
	[30567]="0:12:1:1:::1:0:", -- Charged Vekh'nir Crystal
	[30568]="22142:2:2:1:Thrown::1:1:21474", -- The Sharp Cookie
	[30569]="18166:2:0:1:OneHandSword::1:0:21474,21485", -- Proximo's Rudius
	[30570]="87726:2:2:1:TwoHandSword::1:1:21474", -- Arkadian Claymore
	[30571]="140972:3:3:1:GemRed::1:1:21474", -- Don Rodrigo's Heart
	[30572]="0:3:4:1:GemPurple::1:0:", -- Imperial Tanzanite
	[30573]="0:3:4:1:GemOrange::1:0:", -- Mysterious Fire Opal
	[30574]="0:3:4:1:GemPurple::1:0:", -- Brutal Tanzanite
	[30575]="0:3:4:1:GemOrange::1:0:", -- Nimble Fire Opal
	[30579]="0:12:1:1:::1:0:", -- Illidari-Bane Shard
	[30581]="0:3:4:1:GemOrange::1:0:", -- Durable Fire Opal
	[30582]="0:3:4:1:GemOrange::1:0:", -- Deadly Fire Opal
	[30583]="0:3:4:1:GemGreen::1:0:", -- Timeless Chrysoprase
	[30584]="0:3:4:1:GemOrange::1:0:", -- Enscribed Fire Opal
	[30585]="0:3:4:1:GemOrange::1:0:", -- Glistening Fire Opal
	[30586]="0:3:4:1:GemGreen::1:0:", -- Seer's Chrysoprase
	[30587]="0:3:4:1:GemOrange::1:0:", -- Champion's Fire Opal
	[30588]="0:3:4:1:GemOrange::1:0:", -- Potent Fire Opal
	[30589]="0:3:4:1:GemGreen::1:0:", -- Dazzling Chrysoprase
	[30590]="0:3:4:1:GemGreen::1:0:", -- Enduring Chrysoprase
	[30591]="0:3:4:1:GemOrange::1:0:", -- Empowered Fire Opal
	[30592]="0:3:4:1:GemGreen::1:0:", -- Steady Chrysoprase
	[30593]="0:3:4:1:GemOrange::1:0:", -- Iridescent Fire Opal
	[30594]="0:3:4:1:GemGreen::1:0:", -- Effulgent Chrysoprase
	[30596]="0:12:1:20:::1:0:", -- Baa'ri Tablet Fragment
	[30597]="92463:2:2:1:TwoHandSword::1:1:21485", -- Halaani Claymore
	[30598]="140972:3:3:1:GemRed::1:1:21485", -- Don Amancio's Heart
	[30599]="22142:2:2:1:Thrown::1:1:21485", -- Avenging Blades
	[30600]="0:3:4:1:GemPurple::1:0:", -- Fluorescent Tanzanite
	[30601]="0:3:4:1:GemOrange::1:0:", -- Beaming Fire Opal
	[30602]="0:3:4:1:GemGreen::1:0:", -- Jagged Chrysoprase
	[30603]="0:3:4:1:GemPurple::1:0:", -- Royal Tanzanite
	[30604]="0:3:4:1:GemOrange::1:0:", -- Resplendent Fire Opal
	[30605]="0:3:4:1:GemGreen::1:0:", -- Vivid Chrysoprase
	[30606]="0:3:4:1:GemGreen::1:0:", -- Lambent Chrysoprase
	[30607]="0:3:4:1:GemOrange::1:0:", -- Splendid Fire Opal
	[30608]="0:3:4:1:GemGreen::1:0:", -- Radiant Chrysoprase
	[30609]="0:15:4:1:FlyingMount::1:0:", -- Swift Nether Drake
	[30610]="0:0:1:20:FoodDrink::1:0:", -- Smoked Black Bear Meat
	[30611]="5000:6:3:1000:Arrow::200:0:21483,21488", -- Halaani Razorshaft
	[30612]="5000:6:3:1000:Bullet::200:0:21483,21488", -- Halaani Grimshot
	[30613]="0:12:1:10:::1:0:", -- Felfire Diemetradon Eye
	[30614]="0:12:1:1:::1:0:", -- Fel Bomb
	[30615]="16000:0:1:3:Consumable::3:0:21484,21487", -- Halaani Whiskey
	[30616]="0:12:1:1:::1:0:", -- Bundle of Bloodthistle
	[30617]="0:12:1:1:::1:0:", -- Stormrage Missive
	[30618]="0:12:1:1:::1:0:", -- Trachela's Carcass
	[30619]="0:4:4:1:Trinket::1:0:", -- Fel Reaver's Piston
	[30620]="0:4:4:1:Trinket::1:0:", -- Spyglass of the Hidden Fleet
	[30621]="0:4:4:1:Trinket::1:0:", -- Prism of Inner Calm
	[30622]="100000:13:1:1:::1:0:17657", -- Flamewrought Key
	[30623]="100000:13:1:1:::1:0:17904", -- Reservoir Key
	[30626]="0:4:4:1:Trinket::1:0:", -- Sextant of Unstable Currents
	[30627]="0:4:4:1:Trinket::1:0:", -- Tsunami Talisman
	[30628]="0:12:1:1:::1:0:", -- Fel Reaver Power Core
	[30629]="0:4:4:1:Trinket::1:0:", -- Scarab of Displacement
	[30631]="0:12:1:1:::1:0:", -- Fel Reaver Armor Plate
	[30632]="0:15:1:1:Junk::1:0:", -- Lament of the Highborne
	[30633]="100000:13:1:1:::1:0:21655", -- Auchenai Key
	[30634]="100000:13:1:1:::1:0:21432", -- Warpforged Key
	[30635]="100000:13:1:1:::1:0:21643", -- Key of Time
	[30637]="100000:13:1:1:::1:0:17585", -- Flamewrought Key
	[30638]="0:12:1:1:::1:0:", -- Box o' Tricks
	[30639]="0:15:1:1:Junk::1:0:", -- Blood Elf Disguise
	[30640]="0:12:1:6:::1:0:", -- Eclipsion Armor
	[30641]="0:4:4:1:Plate::1:0:", -- Boots of Elusion
	[30642]="0:4:4:1:Cloak::1:0:", -- Drape of the Righteous
	[30643]="0:4:4:1:Mail::1:0:", -- Belt of the Tracker
	[30644]="0:4:4:1:Leather::1:0:", -- Grips of Deftness
	[30645]="0:12:1:1:::1:0:", -- Third Fragment of the Cipher of Damnation
	[30646]="0:12:1:1:::1:0:", -- Borak's Lockbox
	[30649]="0:12:1:10:::1:0:", -- Orders From Akama
	[30650]="0:12:1:1:::1:0:", -- Dertrok's Wand Case
	[30651]="0:12:1:1:::1:0:", -- Dertrok's First Wand
	[30652]="0:12:1:1:::1:0:", -- Dertrok's Second Wand
	[30653]="0:12:1:1:::1:0:", -- Dertrok's Third Wand
	[30654]="0:12:1:1:::1:0:", -- Dertrok's Fourth Wand
	[30655]="0:12:1:4:::1:0:", -- Infused Vekh'nir Crystal
	[30656]="0:12:1:1:::1:0:", -- Protovoltaic Magneto Collector
	[30657]="0:12:1:1:::1:0:", -- The Cipher of Damnation
	[30658]="0:12:1:1:::1:0:", -- Flanis's Pack
	[30659]="0:12:1:1:::1:0:", -- Kagrosh's Pack
	[30663]="0:4:4:1:Trinket::1:0:", -- Fathom-Brooch of the Tidewalker
	[30664]="0:4:4:1:Trinket::1:0:", -- Living Root of the Wildheart
	[30665]="0:4:4:1:Trinket::1:0:", -- Earring of Soulful Meditation
	[30666]="0:4:4:1:Amulet::1:0:", -- Ritssyn's Lost Pendant
	[30667]="0:4:4:1:Ring::1:0:", -- Ring of Unrelenting Storms
	[30668]="0:4:4:1:Cloth::1:0:", -- Grasp of the Dead
	[30672]="0:12:1:1:::1:0:", -- Elemental Displacer
	[30673]="0:4:4:1:Cloth::1:0:", -- Inferno Waist Cord
	[30674]="0:4:4:1:Leather::1:0:", -- Zierhut's Lost Treads
	[30675]="0:4:4:1:Cloth::1:0:", -- Lurker's Cord
	[30676]="0:4:4:1:Leather::1:0:", -- Lurker's Grasp
	[30677]="0:4:4:1:Mail::1:0:", -- Lurker's Belt
	[30678]="0:4:4:1:Plate::1:0:", -- Lurker's Girdle
	[30679]="0:12:1:20:::1:0:", -- Sunfury Glaive
	[30680]="0:4:4:1:Cloth::1:0:", -- Glider's Foot-Wraps
	[30681]="0:4:4:1:Leather::1:0:", -- Glider's Boots
	[30682]="0:4:4:1:Mail::1:0:", -- Glider's Sabatons
	[30683]="0:4:4:1:Plate::1:0:", -- Glider's Greaves
	[30684]="0:4:4:1:Cloth::1:0:", -- Ravager's Cuffs
	[30685]="0:4:4:1:Leather::1:0:", -- Ravager's Wrist-Wraps
	[30686]="0:4:4:1:Mail::1:0:", -- Ravager's Bands
	[30687]="0:4:4:1:Plate::1:0:", -- Ravager's Bracers
	[30688]="0:13:1:1:::1:0:", -- Deathforge Key
	[30689]="0:12:1:1:::1:0:", -- Razuun's Orders
	[30690]="0:0:1:1:Consumable::1:0:", -- Power Converter
	[30691]="0:12:1:10:::1:0:", -- Haalum's Medallion Fragment
	[30692]="0:12:1:10:::1:0:", -- Eykenen's Medallion Fragment
	[30693]="0:12:1:10:::1:0:", -- Lakaan's Medallion Fragment
	[30694]="0:12:1:10:::1:0:", -- Uylaru's Medallion Fragment
	[30695]="0:12:1:1:::1:0:", -- Legion Teleporter Control
	[30696]="0:4:3:1:Trinket::1:0:", -- Scourgebane
	[30700]="0:15:1:5:Junk::1:0:", -- Scourgestone Fragments
	[30701]="0:12:1:1:::1:0:", -- Oscillating Frequency Scanners
	[30703]="0:0:1:20:FoodDrink::1:0:", -- Conjured Mountain Spring Water
	[30704]="0:12:1:20:::1:0:", -- Ruuan'ok Claw
	[30705]="0:4:3:1:Plate::1:0:", -- Spaulders of Slaughter
	[30706]="0:12:1:1:::1:0:", -- Harbinger's Pendant
	[30707]="0:4:3:1:Leather::1:0:", -- Nimble-foot Treads
	[30708]="0:4:3:1:Mail::1:0:", -- Belt of Flowing Thought
	[30709]="0:4:3:1:Cloth::1:0:", -- Pantaloons of Flaming Wrath
	[30710]="0:4:3:1:Amulet::1:0:", -- Blood Guard's Necklace of Ferocity
	[30712]="0:13:1:1:::1:0:", -- The Doctor's Key
	[30713]="0:12:1:1:::1:0:", -- The Art of Fel Reaver Maintenance
	[30716]="0:12:1:15:::1:0:", -- Ever-burning Ash
	[30719]="0:4:1:1:Miscellaneous::1:0:", -- Spectrecles
	[30720]="0:4:4:1:Trinket::1:0:", -- Serpent-Coil Braid
	[30721]="0:4:1:1:Miscellaneous::1:0:", -- Spectrecles
	[30722]="0:2:4:1:TwoHandAxe::1:0:", -- Ethereum Nexus-Reaver
	[30723]="0:2:4:1:Dagger::1:0:", -- Talon of the Tempest
	[30724]="0:2:4:1:Gun::1:0:", -- Barrel-Blade Longrifle
	[30725]="0:4:4:1:Cloth::1:0:", -- Anger-Spark Gloves
	[30726]="0:4:4:1:Amulet::1:0:", -- Archaic Charm of Presence
	[30727]="0:4:4:1:Cloth::1:0:", -- Gilded Trousers of Benediction
	[30728]="0:4:4:1:Mail::1:0:", -- Fathom-Helm of the Deeps
	[30729]="0:4:4:1:Cloak::1:0:", -- Black-Iron Battlecloak
	[30730]="0:4:4:1:Leather::1:0:", -- Terrorweave Tunic
	[30731]="0:4:4:1:Plate::1:0:", -- Faceguard of the Endless Watch
	[30732]="0:2:4:1:Stave::1:0:", -- Exodar Life-Staff
	[30733]="0:2:4:1:OneHandSword::1:0:", -- Hope Ender
	[30734]="0:4:4:1:Cloth::1:0:", -- Leggings of the Seventh Circle
	[30735]="0:4:4:1:Cloak::1:0:", -- Ancient Spellcloak of the Highborne
	[30736]="0:4:4:1:Ring::1:0:", -- Ring of Flowing Light
	[30737]="0:4:4:1:Leather::1:0:", -- Gold-Leaf Wildboots
	[30738]="0:4:4:1:Ring::1:0:", -- Ring of Reciprocity
	[30739]="0:4:4:1:Mail::1:0:", -- Scaled Greaves of the Marksman
	[30740]="0:4:4:1:Plate::1:0:", -- Ripfiend Shoulderplates
	[30741]="0:4:4:1:Plate::1:0:", -- Topaz-Studded Battlegrips
	[30742]="0:12:1:1:::1:0:", -- Temporal Phase Modulator
	[30743]="0:12:1:20:::1:0:", -- Proto-Nether Drake Essence
	[30744]="120000:1:2:1:Bag::1:0:16602,18906,19053", -- Draenic Leather Pack
	[30745]="140000:1:2:1:EngineeringBag::1:1:16602,18906,19053", -- Heavy Toolbox
	[30746]="100000:1:2:1:MiningBag::1:1:16602,18906,19053", -- Mining Sack
	[30747]="120000:1:2:1:GemBag::1:1:16602,18906,19053", -- Gem Pouch
	[30748]="140000:1:2:1:EnchantingBag::1:1:16602,18906,19053", -- Enchanter's Satchel
	[30749]="145540:2:1:1:OneHandSword::1:0:18997,19001,19333,19499,19526,20112,20917,21485,26229,37903,37936", -- Draenic Sparring Blade
	[30750]="189372:2:1:1:TwoHandSword::1:0:18997,19001,19333,19499,19526,20112,20917,21485,26229,37903,37936", -- Draenic Warblade
	[30751]="148381:2:1:1:OneHandAxe::1:0:18997,19001,19333,19499,19526,20112,20917", -- Mag'hari Light Axe
	[30752]="168397:2:1:1:TwoHandAxe::1:0:18997,19001,19333,19499,19526,20112,20917", -- Mag'hari Battleaxe
	[30753]="326668:2:2:1:Polearm::1:1:18997,19001,19333,19499,19526,20112,20917", -- Warphorn Spear
	[30754]="137417:2:1:1:OneHandMace::1:0:18997,19001,19333,19499,19526,20112,20917", -- Ancient Bone Mace
	[30755]="254979:2:2:1:FistWeapon::1:1:18997,19001,19333,19499,19526,20112,20917", -- Mag'hari Fighting Claw
	[30756]="0:12:1:1:::1:0:", -- Illidari-Bane Shard
	[30757]="104257:2:1:1:Crossbow::1:0:18962,19021,19339,19499", -- Draenic Light Crossbow
	[30758]="103377:2:1:1:Gun::1:0:18962,19021,19339,19351,19499,26229,28040", -- Aldor Guardian Rifle
	[30759]="102498:2:1:1:Bow::1:0:18962,19021,19339,19499", -- Mag'hari Light Recurve
	[30761]="0:4:4:1:Cloth::1:0:18525", -- Infernoweave Leggings
	[30762]="0:4:4:1:Cloth::1:0:18525", -- Infernoweave Robe
	[30763]="0:4:4:1:Cloth::1:0:18525", -- Infernoweave Boots
	[30764]="0:4:4:1:Cloth::1:0:18525", -- Infernoweave Gloves
	[30765]="126608:4:1:1:Plate::1:0:18010,19011,19012,19373,19517,19694,23735,24347", -- Heavy Draenic Breastplate
	[30766]="0:4:4:1:Plate::1:0:18525", -- Inferno Tempered Leggings
	[30767]="0:4:4:1:Plate::1:0:18525", -- Inferno Tempered Gauntlets
	[30768]="0:4:4:1:Plate::1:0:18525", -- Inferno Tempered Boots
	[30769]="0:4:4:1:Plate::1:0:18525", -- Inferno Tempered Chestguard
	[30770]="0:4:4:1:Mail::1:0:18525", -- Inferno Forged Boots
	[30771]="65032:4:1:1:Plate::1:0:18010,19011,19012,19373,19517,19694,23735,24347", -- Heavy Draenic Bracers
	[30772]="0:4:4:1:Mail::1:0:18525", -- Inferno Forged Leggings
	[30773]="0:4:4:1:Mail::1:0:18525", -- Inferno Forged Hauberk
	[30774]="0:4:4:1:Mail::1:0:18525", -- Inferno Forged Gloves
	[30775]="108595:4:1:1:Shield::1:0:18010,19011,19012,19373,19517,19694,23735,24347", -- Layered Bone Shield
	[30776]="0:4:4:1:Leather::1:0:18525", -- Inferno Hardened Chestguard
	[30777]="59255:4:1:1:Plate::1:0:18010,19011,19012,19373,19517,19694,23735,24347", -- Aldor Heavy Belt
	[30778]="0:4:4:1:Leather::1:0:18525", -- Inferno Hardened Leggings
	[30779]="0:4:4:1:Leather::1:0:18525", -- Inferno Hardened Boots
	[30780]="0:4:4:1:Leather::1:0:18525", -- Inferno Hardened Gloves
	[30781]="101003:4:1:1:Mail::1:0:18010,19011,19012,19373,19517,19694,23735,24347", -- Mag'hari Chain Vest
	[30782]="0:12:1:20:::1:0:", -- Adolescent Nether Drake Essence
	[30783]="0:12:1:20:::1:0:", -- Mature Nether Drake Essence
	[30784]="50501:4:1:1:Mail::1:0:18010,19011,19012,19373,19517,19694,23735,24347", -- Worn Mag'hari Gauntlets
	[30785]="0:12:1:1:::1:0:", -- Morgroron's Glaive
	[30786]="0:12:1:1:::1:0:", -- Makazradon's Glaive
	[30787]="0:2:3:1:Dagger::1:0:", -- Illidari-Bane Mageblade
	[30788]="0:2:3:1:OneHandSword::1:0:", -- Illidari-Bane Broadsword
	[30789]="0:2:3:1:TwoHandSword::1:0:", -- Illidari-Bane Claymore
	[30791]="0:12:1:10:::1:0:", -- Silkwing Cocoon
	[30792]="0:12:1:20:::1:0:", -- Iridescent Wing
	[30794]="0:13:1:1:::1:0:", -- Shredder Keys
	[30797]="0:12:1:1:::1:0:", -- Gorefiend's Armor
	[30798]="0:12:1:20:::1:0:", -- Extra Sharp Daggermaw Tooth
	[30799]="0:12:1:1:::1:0:", -- Gorefiend's Cloak
	[30800]="0:12:1:1:::1:0:", -- Gorefiend's Truncheon
	[30803]="0:12:1:1:::1:0:", -- Felhound Whistle
	[30804]="0:4:3:1:Ring::1:0:", -- Bronze Band of Force
	[30805]="0:12:1:1:::1:0:", -- Thick Stain Resistant Gloves
	[30807]="0:12:1:1:::1:0:", -- Uvuros's Fiery Mane
	[30808]="0:12:1:10:::1:0:", -- Book of Fel Names
	[30809]="0:12:1:250:::1:0:", -- Mark of Sargeras
	[30810]="0:12:1:250:::1:0:", -- Sunfury Signet
	[30811]="0:0:1:20:Consumable::1:0:", -- Scroll of Demonic Unbanishing
	[30812]="0:15:0:20:Junk::1:0:", -- Iridescent Scale
	[30813]="0:15:0:5:Junk::1:0:", -- Envenomed Fang
	[30814]="0:15:0:20:Junk::1:0:", -- Enormous Molar
	[30815]="0:15:0:20:Junk::1:0:", -- Giant Scale
	[30816]="0:0:1:20:FoodDrink:185:1:0:", -- Spice Bread
	[30817]="25:7:1:20:Other:185:5:0:66,1250,1692,2118,2381,2397,2664,3027,3081,3085,3168,3187,3400,3614,4223,4265,4553,5160,5483,5817,8307,8934,12033,14738,16253,16261,16262,16677,16718,17246,17490,18987,18988,18993,19195,19371,20028,20096,20097,24834,24993,25012,25020,25052,25089,26868,28811,29291,31031,31032,33595,34645,34681,34682,34683,34684,34685,34783,34787,35337,35338,35340,35341,35342,35343", -- Simple Flour
	[30818]="0:12:1:1:::1:0:", -- Repolarized Magneto Sphere
	[30819]="0:12:1:8:::1:0:", -- Felfire Spleen
	[30820]="0:15:0:10:Junk::1:0:", -- Vicious Scorpid Claw
	[30821]="0:15:0:10:Junk::1:0:", -- Envenomed Scorpid Stinger
	[30822]="0:12:1:1:::1:0:", -- Box of Ingots
	[30823]="300000:12:1:1:::1:0:19678", -- Demon Warding Totem
	[30824]="0:12:1:1:::1:0:", -- Overcharged Manacell
	[30825]="0:4:3:1:Ring::1:0:", -- Ring of Arcane Shielding
	[30826]="120000:9:3:1:Jewelcrafting::1:0:21432", -- Design: Ring of Arcane Shielding
	[30827]="0:12:1:1:::1:0:", -- Lexicon Demonica
	[30828]="0:12:1:1:::1:0:", -- Vial of Underworld Loam
	[30829]="0:12:1:1:::1:0:", -- Tear of the Earthmother
	[30830]="2505080:2:4:1:Polearm::1:0:21655", -- Trident of the Outcast Tribe
	[30831]="0:4:3:1:Cloak::1:0:", -- Cloak of Arcane Evasion
	[30832]="504841:2:4:1:OneHandMace::1:0:21655", -- Gavel of Unearthed Secrets
	[30833]="60000:9:1:1:Tailoring::1:0:21655", -- Pattern: Cloak of Arcane Evasion
	[30834]="197528:4:4:1:Ring::1:0:21655", -- Shapeshifter's Signet
	[30835]="260629:4:3:1:Mail::1:0:21655", -- Salvager's Hauberk
	[30836]="174403:4:3:1:Cloth::1:0:21655", -- Leggings of the Skettis Exile
	[30837]="0:4:3:1:Cloth::1:0:", -- Flameheart Bracers
	[30838]="0:4:3:1:Cloth::1:0:", -- Flameheart Gloves
	[30839]="0:4:3:1:Cloth::1:0:", -- Flameheart Vest
	[30840]="0:12:1:20:::1:0:", -- Ether-Energized Flesh
	[30841]="175952:4:3:1:Trinket::1:0:21655", -- Lower City Prayerbook
	[30842]="60000:9:1:1:Tailoring::1:0:19321", -- Pattern: Flameheart Bracers
	[30843]="80000:9:1:1:Tailoring::1:0:19321", -- Pattern: Flameheart Gloves
	[30844]="100000:9:1:1:Tailoring::1:0:19321", -- Pattern: Flameheart Vest
	[30846]="1000000:0:2:1:EnhPerm::1:0:21655", -- Arcanum of the Outcast
	[30847]="0:4:2:1:Cloth::1:0:", -- X-52 Rocket Helmet
	[30849]="0:12:1:20:::1:0:", -- Scalewing Lightning Gland
	[30850]="0:12:1:1:::1:0:", -- Freshly Drawn Blood
	[30851]="0:12:1:1:::1:0:", -- Felspine's Hide
	[30852]="0:12:1:1:::1:0:", -- Multi-Spectrum Light Trap
	[30853]="0:12:1:1:::1:0:", -- Imbued Silver Spear
	[30854]="0:12:1:1:::1:0:", -- Book of Fel Names
	[30855]="0:2:2:1:OneHandAxe::1:0:", -- Shatterstone Pick
	[30856]="0:4:2:1:Plate::1:0:", -- Underworld Helm
	[30857]="0:4:2:1:OffHandFrill::1:0:", -- Deep Core Lantern
	[30858]="0:0:1:20:Consumable::1:0:", -- Peon Sleep Potion
	[30859]="0:2:3:1:Wand::1:0:", -- Wand of the Seer
	[30860]="0:4:3:1:Ring::1:0:", -- Kaylaan's Signet
	[30861]="0:4:4:1:Plate::1:0:", -- Furious Shackles
	[30862]="0:4:4:1:Plate::1:0:", -- Blessed Adamantite Bracers
	[30863]="0:4:4:1:Leather::1:0:", -- Deadly Cuffs
	[30864]="0:4:4:1:Mail::1:0:", -- Bracers of the Pathfinder
	[30865]="0:2:4:1:Dagger::1:0:", -- Tracker's Blade
	[30866]="0:4:4:1:Plate::1:0:", -- Blood-stained Pauldrons
	[30867]="0:12:1:1:::1:0:", -- Overdeveloped Felfire Gizzard
	[30868]="0:4:4:1:Leather::1:0:", -- Rejuvenating Bracers
	[30869]="0:4:4:1:Mail::1:0:", -- Howling Wind Bracers
	[30870]="0:4:4:1:Cloth::1:0:", -- Cuffs of Devastation
	[30871]="0:4:4:1:Cloth::1:0:", -- Bracers of Martyrdom
	[30872]="0:4:4:1:OffHandFrill::1:0:", -- Chronicle of Dark Secrets
	[30873]="0:4:4:1:Mail::1:0:", -- Stillwater Boots
	[30874]="0:2:4:1:OneHandSword::1:0:", -- The Unbreakable Will
	[30875]="0:12:1:1:::1:0:", -- Forged Illidari-Bane Blade
	[30876]="0:12:1:1:::1:0:", -- Quenched Illidari-Bane Blade
	[30878]="0:4:4:1:Plate::1:0:", -- Glimmering Steel Mantle
	[30879]="0:4:4:1:Leather::1:0:", -- Don Alejandro's Money Belt
	[30880]="0:4:4:1:Mail::1:0:", -- Quickstrider Moccasins
	[30881]="0:2:4:1:OneHandSword::1:0:", -- Blade of Infamy
	[30882]="0:4:4:1:Shield::1:0:", -- Bastion of Light
	[30883]="0:2:4:1:Stave::1:0:", -- Pillar of Ferocity
	[30884]="0:4:4:1:Cloth::1:0:", -- Hatefury Mantle
	[30885]="0:4:4:1:Cloth::1:0:", -- Archbishop's Slippers
	[30886]="0:4:4:1:Leather::1:0:", -- Enchanted Leather Sandals
	[30887]="0:4:4:1:Mail::1:0:", -- Golden Links of Restoration
	[30888]="0:4:4:1:Cloth::1:0:", -- Anetheron's Noose
	[30889]="0:4:4:1:Shield::1:0:", -- Kaz'rogal's Hardened Heart
	[30890]="0:12:1:1:::1:0:", -- Collection of Souls
	[30891]="0:4:4:1:Leather::1:0:", -- Black Featherlight Boots
	[30892]="0:4:4:1:Mail::1:0:", -- Beast-tamer's Shoulders
	[30893]="0:4:4:1:Mail::1:0:", -- Sun-touched Chain Leggings
	[30894]="0:4:4:1:Cloth::1:0:", -- Blue Suede Shoes
	[30895]="0:4:4:1:Cloth::1:0:", -- Angelista's Sash
	[30896]="0:4:4:1:Plate::1:0:", -- Glory of the Defender
	[30897]="0:4:4:1:Plate::1:0:", -- Girdle of Hope
	[30898]="0:4:4:1:Leather::1:0:", -- Shady Dealer's Pantaloons
	[30899]="0:4:4:1:Leather::1:0:", -- Don Rodrigo's Poncho
	[30900]="0:4:4:1:Mail::1:0:", -- Bow-stitched Leggings
	[30901]="0:2:4:1:Dagger::1:0:", -- Boundless Agony
	[30902]="0:2:4:1:TwoHandSword::1:0:", -- Cataclysm's Edge
	[30903]="0:4:4:1:Plate::1:0:", -- Legguards of Endless Rage
	[30904]="0:4:4:1:Plate::1:0:", -- Savior's Grasp
	[30905]="0:4:4:1:Leather::1:0:", -- Midnight Chestguard
	[30906]="0:2:4:1:Bow::1:0:", -- Bristleblitz Striker
	[30907]="0:4:4:1:Mail::1:0:", -- Mail of Fevered Pursuit
	[30908]="0:2:4:1:Stave::1:0:", -- Apostle of Argus
	[30909]="0:4:4:1:Shield::1:0:", -- Antonidas's Aegis of Rapt Concentration
	[30910]="0:2:4:1:OneHandSword::1:0:", -- Tempest of Chaos
	[30911]="0:4:4:1:OffHandFrill::1:0:", -- Scepter of Purification
	[30912]="0:4:4:1:Cloth::1:0:", -- Leggings of Eternity
	[30913]="0:4:4:1:Cloth::1:0:", -- Robes of Rhonin
	[30914]="0:4:4:1:Leather::1:0:", -- Belt of the Crescent Moon
	[30915]="0:4:4:1:Plate::1:0:", -- Belt of Seething Fury
	[30916]="0:4:4:1:Cloth::1:0:", -- Leggings of Channeled Elements
	[30917]="0:4:4:1:Leather::1:0:", -- Razorfury Mantle
	[30918]="0:2:4:1:OneHandMace::1:0:", -- Hammer of Atonement
	[30919]="0:4:4:1:Mail::1:0:", -- Valestalker Girdle
	[30922]="0:4:2:1:Cloth::1:0:", -- Ata'mal Crown
	[30923]="0:4:2:1:Cloth::1:0:", -- Grom'tor's Bloodied Bandage
	[30924]="0:4:3:1:Cloth::1:0:", -- Gloves of the High Magus
	[30925]="0:4:3:1:Cloth::1:0:", -- Spaulders of the Torn-heart
	[30926]="0:4:2:1:Cloth::1:0:", -- Ashwalker's Footwraps
	[30927]="0:4:2:1:Cloth::1:0:", -- Earthmender's Bracer of Shattering
	[30928]="0:4:2:1:Cloth::1:0:", -- Sketh'lon Survivor's Tunic
	[30929]="0:4:2:1:Cloth::1:0:", -- Soothsayer's Kilt
	[30930]="0:4:2:1:Cloth::1:0:", -- Grips of the Void
	[30931]="0:4:2:1:Cloth::1:0:", -- Ghostly Headwrap
	[30932]="0:4:3:1:Cloth::1:0:", -- Akama's Sash
	[30933]="0:4:3:1:Leather::1:0:", -- Hauberk of Karabor
	[30936]="0:4:2:1:Leather::1:0:", -- Eva's Strap
	[30937]="0:4:2:1:Leather::1:0:", -- Earthmender's Fists of Undoing
	[30938]="0:4:2:1:Leather::1:0:", -- Azurestrike Shoulders
	[30939]="0:4:3:1:Leather::1:0:", -- Felboar Hide Shoes
	[30940]="0:4:2:1:Leather::1:0:", -- Aged Leather Bindings
	[30941]="0:4:2:1:Leather::1:0:", -- Ash Tempered Legguards
	[30942]="0:4:2:1:Leather::1:0:", -- Manimal's Cinch
	[30943]="0:4:3:1:Leather::1:0:", -- Verdant Gloves
	[30944]="0:4:3:1:Leather::1:0:", -- Umberhowl's Collar
	[30945]="0:4:2:1:Leather::1:0:", -- Grom'tor's Friend's Cousin's Tunic
	[30946]="0:4:2:1:Leather::1:0:", -- Mooncrest Headdress
	[30947]="0:4:2:1:Mail::1:0:", -- Crimson Mail Hauberk
	[30948]="0:4:3:1:Mail::1:0:", -- Sunfury Legguards
	[30950]="0:4:2:1:Mail::1:0:", -- Darkhunter's Cinch
	[30951]="0:4:3:1:Mail::1:0:", -- Ar'tor's Mainstay
	[30952]="0:4:2:1:Mail::1:0:", -- Earthmender's Crimson Spaulders
	[30953]="0:4:2:1:Mail::1:0:", -- Boots of the Skybreaker
	[30955]="0:4:2:1:Mail::1:0:", -- Crown of Cinders
	[30956]="0:4:2:1:Mail::1:0:", -- Oronok's Old Bracers
	[30957]="0:4:2:1:Mail::1:0:", -- Oronok's Old Leggings
	[30958]="0:4:2:1:Mail::1:0:", -- Blackened Chain Greaves
	[30959]="0:4:2:1:Plate::1:0:", -- Torn-heart Family Tunic
	[30960]="0:4:2:1:Plate::1:0:", -- Runed Sketh'lon Legplates
	[30961]="0:4:2:1:Plate::1:0:", -- Ash-Covered Helm
	[30962]="0:4:3:1:Plate::1:0:", -- Borak's Belt of Bravery
	[30964]="0:4:2:1:Plate::1:0:", -- Skybreaker's Pauldrons
	[30966]="0:4:2:1:Plate::1:0:", -- Singed Vambraces
	[30967]="0:4:3:1:Plate::1:0:", -- The Hands of Fate
	[30968]="0:4:2:1:Plate::1:0:", -- Earthmender's Plated Boots
	[30969]="0:4:4:1:Plate::1:0:23381", -- Onslaught Gauntlets
	[30970]="0:4:4:1:Plate::1:0:23381", -- Onslaught Handguards
	[30971]="0:4:2:1:Cloak::1:0:", -- Torn-heart Cloak
	[30972]="0:4:4:1:Plate::1:0:23381", -- Onslaught Battle-Helm
	[30973]="0:4:3:1:Ring::1:0:", -- Band of Anguish
	[30974]="0:4:4:1:Plate::1:0:23381", -- Onslaught Greathelm
	[30975]="0:4:4:1:Plate::1:0:23381", -- Onslaught Breastplate
	[30976]="0:4:4:1:Plate::1:0:23381", -- Onslaught Chestguard
	[30977]="0:4:4:1:Plate::1:0:23381", -- Onslaught Greaves
	[30978]="0:4:4:1:Plate::1:0:23381", -- Onslaught Legguards
	[30979]="0:4:4:1:Plate::1:0:23381", -- Onslaught Shoulderblades
	[30980]="0:4:4:1:Plate::1:0:23381", -- Onslaught Shoulderguards
	[30981]="0:4:2:1:Amulet::1:0:", -- Grom'tor's Pendant of Conquest
	[30982]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Gauntlets
	[30983]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Gloves
	[30984]="0:4:3:1:Shield::1:0:", -- Spellbreaker's Buckler
	[30985]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Handguards
	[30986]="0:4:2:1:Shield::1:0:", -- Bloodforged Guard
	[30987]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Faceguard
	[30988]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Greathelm
	[30989]="0:4:4:1:Plate::1:0:23381", -- Lightbringer War-Helm
	[30990]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Breastplate
	[30991]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Chestguard
	[30992]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Chestpiece
	[30993]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Greaves
	[30994]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Leggings
	[30995]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Legguards
	[30996]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Pauldrons
	[30997]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Shoulderbraces
	[30998]="0:4:4:1:Plate::1:0:23381", -- Lightbringer Shoulderguards
	[30999]="0:2:3:1:Dagger::1:0:", -- Ashtongue Blade
	[31000]="0:2:3:1:Gun::1:0:", -- Bloodwarder's Rifle
	[31001]="0:4:4:1:Mail::1:0:23381", -- Gronnstalker's Gloves
	[31002]="0:2:3:1:OneHandSword::1:0:", -- Summoner's Blade
	[31003]="0:4:4:1:Mail::1:0:23381", -- Gronnstalker's Helmet
	[31004]="0:4:4:1:Mail::1:0:23381", -- Gronnstalker's Chestguard
	[31005]="0:4:4:1:Mail::1:0:23381", -- Gronnstalker's Leggings
	[31006]="0:4:4:1:Mail::1:0:23381", -- Gronnstalker's Spaulders
	[31007]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Gloves
	[31008]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Gauntlets
	[31009]="0:2:3:1:Stave::1:0:", -- Wildcaller
	[31010]="0:2:3:1:TwoHandAxe::1:0:", -- Slayer's Axe
	[31011]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Grips
	[31012]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Helmet
	[31013]="0:2:3:1:Dagger::1:0:", -- Ceremonial Kris
	[31014]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Headguard
	[31015]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Cover
	[31016]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Chestguard
	[31017]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Breastplate
	[31018]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Tunic
	[31019]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Leggings
	[31020]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Legguards
	[31021]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Pants
	[31022]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Shoulderpads
	[31023]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Mantle
	[31024]="0:4:4:1:Mail::1:0:23381", -- Skyshatter Pauldrons
	[31025]="0:4:3:1:Idol::1:0:", -- Idol of the Avenger
	[31026]="0:4:4:1:Leather::1:0:23381", -- Slayer's Handguards
	[31027]="0:4:4:1:Leather::1:0:23381", -- Slayer's Helm
	[31028]="0:4:4:1:Leather::1:0:23381", -- Slayer's Chestguard
	[31029]="0:4:4:1:Leather::1:0:23381", -- Slayer's Legguards
	[31030]="0:4:4:1:Leather::1:0:23381", -- Slayer's Shoulderpads
	[31031]="0:4:3:1:Totem::1:0:", -- Stormfury Totem
	[31032]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Gloves
	[31033]="0:4:3:1:Libram::1:0:", -- Libram of Righteous Power
	[31034]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Gauntlets
	[31035]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Handguards
	[31036]="0:2:3:1:Stave::1:0:", -- Oronok's Ancient Scepter
	[31037]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Helmet
	[31038]="0:2:3:1:Stave::1:0:", -- Staff of the Redeemer
	[31039]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Cover
	[31040]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Headguard
	[31041]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Tunic
	[31042]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Chestguard
	[31043]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Vest
	[31044]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Leggings
	[31045]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Legguards
	[31046]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Pants
	[31047]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Spaulders
	[31048]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Pauldrons
	[31049]="0:4:4:1:Leather::1:0:23381", -- Thunderheart Shoulderpads
	[31050]="0:4:4:1:Cloth::1:0:23381", -- Gloves of the Malefic
	[31051]="0:4:4:1:Cloth::1:0:23381", -- Hood of the Malefic
	[31052]="0:4:4:1:Cloth::1:0:23381", -- Robe of the Malefic
	[31053]="0:4:4:1:Cloth::1:0:23381", -- Leggings of the Malefic
	[31054]="0:4:4:1:Cloth::1:0:23381", -- Mantle of the Malefic
	[31055]="0:4:4:1:Cloth::1:0:23381", -- Gloves of the Tempest
	[31056]="0:4:4:1:Cloth::1:0:23381", -- Cowl of the Tempest
	[31057]="0:4:4:1:Cloth::1:0:23381", -- Robes of the Tempest
	[31058]="0:4:4:1:Cloth::1:0:23381", -- Leggings of the Tempest
	[31059]="0:4:4:1:Cloth::1:0:23381", -- Mantle of the Tempest
	[31060]="0:4:4:1:Cloth::1:0:23381", -- Gloves of Absolution
	[31061]="0:4:4:1:Cloth::1:0:23381", -- Handguards of Absolution
	[31062]="0:2:3:1:TwoHandAxe::1:0:", -- Torn-heart Axe of Battle
	[31063]="0:4:4:1:Cloth::1:0:23381", -- Cowl of Absolution
	[31064]="0:4:4:1:Cloth::1:0:23381", -- Hood of Absolution
	[31065]="0:4:4:1:Cloth::1:0:23381", -- Shroud of Absolution
	[31066]="0:4:4:1:Cloth::1:0:23381", -- Vestments of Absolution
	[31067]="0:4:4:1:Cloth::1:0:23381", -- Leggings of Absolution
	[31068]="0:4:4:1:Cloth::1:0:23381", -- Breeches of Absolution
	[31069]="0:4:4:1:Cloth::1:0:23381", -- Mantle of Absolution
	[31070]="0:4:4:1:Cloth::1:0:23381", -- Shoulderpads of Absolution
	[31071]="0:2:3:1:OneHandAxe::1:0:", -- Grom'tor's Charge
	[31072]="59981:2:3:1:Bow::1:0:", -- Lohn'goron, Bow of the Torn-heart
	[31073]="0:2:3:1:Dagger::1:0:", -- Borak's Reminder
	[31074]="0:4:3:1:Amulet::1:0:", -- Amulet of the Torn-heart
	[31075]="0:4:3:1:Ring::1:0:", -- Evoker's Mark of the Redemption
	[31076]="0:4:3:1:Ring::1:0:", -- Spellsword's Mark of the Redemption
	[31077]="0:4:3:1:Ring::1:0:", -- Slayer's Mark of the Redemption
	[31078]="0:4:3:1:Ring::1:0:", -- Protector's Mark of the Redemption
	[31079]="0:7:3:20:Jewelcrafting:755:1:0:", -- Mercurial Adamantite
	[31080]="0:4:2:1:Trinket::1:0:", -- Mercurial Stone
	[31084]="0:13:1:1:::1:0:", -- Key to the Arcatraz
	[31085]="0:12:1:1:::1:0:", -- Top Shard of the Arcatraz Key
	[31086]="0:12:1:1:::1:0:", -- Bottom Shard of the Arcatraz Key
	[31088]="0:15:1:1:Junk::1:0:", -- Tainted Core
	[31089]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Forgotten Conqueror
	[31090]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Forgotten Vanquisher
	[31091]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Forgotten Protector
	[31092]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Forgotten Conqueror
	[31093]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Forgotten Vanquisher
	[31094]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Forgotten Protector
	[31095]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Forgotten Protector
	[31096]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Forgotten Vanquisher
	[31097]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Forgotten Conqueror
	[31098]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Forgotten Conqueror
	[31099]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Forgotten Vanquisher
	[31100]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Forgotten Protector
	[31101]="0:15:4:1:ArmorToken::1:0:", -- Pauldrons of the Forgotten Conqueror
	[31102]="0:15:4:1:ArmorToken::1:0:", -- Pauldrons of the Forgotten Vanquisher
	[31103]="0:15:4:1:ArmorToken::1:0:", -- Pauldrons of the Forgotten Protector
	[31104]="0:4:3:1:Cloth::1:0:", -- Evoker's Helmet of Second Sight
	[31105]="0:4:3:1:Plate::1:0:", -- Overlord's Helmet of Second Sight
	[31106]="0:4:3:1:Mail::1:0:", -- Stalker's Helmet of Second Sight
	[31107]="0:4:3:1:Mail::1:0:", -- Shamanistic Helmet of Second Sight
	[31108]="0:15:1:1:CombatPet::1:0:", -- Kor'kron Flare Gun
	[31109]="0:4:3:1:Leather::1:0:", -- Stealther's Helmet of Second Sight
	[31110]="0:4:3:1:Leather::1:0:", -- Druidic Helmet of Second Sight
	[31111]="0:4:2:1:Cloth::1:0:", -- Uvuros Hide Gloves
	[31112]="0:4:2:1:Leather::1:0:", -- Uvuros Hide Boots
	[31113]="0:4:4:1:Trinket::1:0:", -- Violet Badge
	[31114]="0:4:2:1:Mail::1:0:", -- Uvuros Hide Cinch
	[31115]="0:4:2:1:Plate::1:0:", -- Uvuros Plated Spaulders
	[31116]="0:3:4:1:GemPurple::1:0:", -- Infused Amethyst
	[31117]="0:3:4:1:GemPurple::1:0:", -- Soothing Amethyst
	[31118]="0:3:4:1:GemPurple::1:0:", -- Pulsing Amethyst
	[31119]="0:12:1:20:::1:0:", -- Wyrmcult Net
	[31120]="0:12:1:1:::1:0:", -- Meeting Note
	[31121]="0:0:1:20:Consumable::1:0:", -- Costume Scraps
	[31122]="0:0:1:5:Consumable::1:0:", -- Overseer Disguise
	[31123]="0:12:1:1:::1:0:", -- Spinning Nether-weather Vane
	[31124]="0:12:1:1:::1:0:", -- Nether-weather Vane
	[31125]="0:4:3:1:Plate::1:0:", -- Boots of the Decimator
	[31126]="0:4:3:1:Leather::1:0:", -- Gloves of Ferocity
	[31127]="0:4:3:1:Mail::1:0:", -- Hauberk of Totemic Rage
	[31128]="0:12:1:1:::1:0:", -- Rexxar's Whistle
	[31129]="0:12:1:1:::1:0:", -- Blackwhelp Net
	[31130]="0:12:1:10:::1:0:", -- Wyrmcult Blackwhelp
	[31131]="0:4:3:1:Leather::1:0:", -- Sash of Silent Blades
	[31132]="0:12:1:20:::1:0:", -- Crust Burster Venom Gland
	[31133]="0:4:3:1:Cloth::1:0:", -- Leggings of Concentrated Darkness
	[31134]="0:2:3:1:TwoHandSword::1:0:", -- Blade of Misfortune
	[31135]="0:12:1:1:::1:0:", -- Baron Sablemane's Poison
	[31136]="0:4:3:1:Plate::1:0:", -- Breastplate of Blade Turning
	[31137]="0:4:3:1:Plate::1:0:", -- Gauntlets of Purification
	[31138]="0:4:3:1:Mail::1:0:", -- Storm Lord's Girdle
	[31139]="0:2:3:1:OneHandMace::1:0:", -- Fist of Reckoning
	[31140]="0:4:3:1:Cloak::1:0:", -- Cloak of Entropy
	[31141]="0:12:1:1:::1:0:", -- Kodohide Drum
	[31142]="0:2:3:1:Dagger::1:0:", -- Blade of Trapped Knowledge
	[31143]="0:4:3:1:Cloak::1:0:", -- Shroud of Frenzy
	[31144]="0:12:1:1:::1:0:", -- Spirit's Whistle
	[31145]="0:4:3:1:Leather::1:0:", -- Headdress of the Sleeper
	[31146]="0:12:1:1:::1:0:", -- Rexxar's Battle Horn
	[31147]="0:4:3:1:Amulet::1:0:", -- Pendant of Cunning
	[31148]="0:4:3:1:Leather::1:0:", -- Demon Hide Spaulders
	[31149]="0:4:3:1:Cloth::1:0:", -- Gloves of Pandemonium
	[31150]="0:4:3:1:Cloth::1:0:", -- Gloves of Piety
	[31151]="0:4:3:1:Plate::1:0:", -- Girdle of Siege
	[31152]="0:4:3:1:Plate::1:0:", -- Chestguard of Illumination
	[31153]="0:2:3:1:OneHandAxe::1:0:", -- Axe of the Legion
	[31154]="0:4:2:1:Amulet::1:0:", -- Bronze Torc
	[31155]="0:4:3:1:Plate::1:0:", -- Drakescale Breastplate
	[31156]="0:4:3:1:Mail::1:0:", -- Drakescale Hauberk
	[31157]="0:4:3:1:Leather::1:0:", -- Drakehide Tunic
	[31158]="0:4:3:1:Cloth::1:0:", -- Drakeweave Raiment
	[31159]="0:4:3:1:Plate::1:0:", -- Felstone Pauldrons
	[31160]="0:4:3:1:Mail::1:0:", -- Felstone Epaulets
	[31161]="0:4:3:1:Leather::1:0:", -- Felstone Spaulders
	[31162]="0:4:3:1:Cloth::1:0:", -- Felstone Mantle
	[31163]="0:4:3:1:Plate::1:0:", -- Nethersteel Handguards
	[31164]="0:4:3:1:Mail::1:0:", -- Nethersteel Gauntlets
	[31165]="0:4:3:1:Leather::1:0:", -- Nethersteel-Reinforced Gloves
	[31166]="0:4:3:1:Cloth::1:0:", -- Nethersteel-Lined Handwraps
	[31168]="0:4:3:1:Plate::1:0:", -- Demon-Forged Chestguard
	[31169]="0:12:1:1:::1:0:", -- Sketh'lon War Totem
	[31170]="0:4:3:1:Mail::1:0:", -- Demon-Forged Hauberk
	[31172]="0:4:3:1:Leather::1:0:", -- Demon-Cured Tunic
	[31173]="0:4:3:1:Mail::1:0:", -- Boots of Savagery
	[31174]="0:4:3:1:Cloth::1:0:", -- Demonweave Raiment
	[31175]="0:4:3:1:Leather::1:0:", -- Blade Dancer's Wristguards
	[31176]="0:4:3:1:Plate::1:0:", -- Rockwurm Plate Handguards
	[31177]="0:4:3:1:Mail::1:0:", -- Rockwurm Scale Gauntlets
	[31178]="0:4:3:1:Amulet::1:0:", -- Amulet of Unstable Power
	[31179]="0:4:3:1:Leather::1:0:", -- Rockwurm Hide Gloves
	[31180]="0:4:3:1:Plate::1:0:", -- Gauntlets of the Skullsplitter
	[31181]="0:4:3:1:Cloth::1:0:", -- Rockwurm Hide Handwraps
	[31182]="0:4:3:1:Plate::1:0:", -- Legion Helm
	[31183]="0:4:3:1:Mail::1:0:", -- Legion Coif
	[31184]="0:4:3:1:Leather::1:0:", -- Legion Headguard
	[31185]="0:4:3:1:Cloth::1:0:", -- Legion Crown
	[31186]="0:2:3:1:Stave::1:0:", -- Braxxis' Staff of Slumber
	[31187]="0:4:3:1:Mail::1:0:", -- Boots of the Pathfinder
	[31188]="0:4:3:1:Plate::1:0:", -- Crocolisk Scale Vambraces
	[31189]="0:4:3:1:Mail::1:0:", -- Crocolisk Scale Wristguards
	[31190]="0:4:3:1:Leather::1:0:", -- The Dreamer's Shoulderpads
	[31191]="0:4:3:1:Leather::1:0:", -- Crocolisk Hide Bracers
	[31192]="0:4:3:1:Cloth::1:0:", -- Crocolisk Hide Bindings
	[31193]="0:2:3:1:Dagger::1:0:", -- Blade of Unquenched Thirst
	[31194]="0:4:3:1:Amulet::1:0:", -- Gronn-Blessed Warbeads
	[31195]="0:4:3:1:Plate::1:0:", -- Voidplate Girdle
	[31196]="0:4:3:1:Amulet::1:0:", -- Amulet of Sanctification
	[31197]="0:4:3:1:Mail::1:0:", -- Voidscale Belt
	[31198]="0:4:3:1:Leather::1:0:", -- Voidhide Cord
	[31199]="0:4:3:1:Cloth::1:0:", -- Voidweave Cilice
	[31200]="0:4:3:1:Shield::1:0:", -- Shield of the Wayward Footman
	[31201]="0:4:3:1:Cloak::1:0:", -- Illidari Cloak
	[31202]="0:4:3:1:Plate::1:0:", -- Girdle of Divine Blessing
	[31203]="0:4:3:1:Ring::1:0:", -- Arcane Loop
	[31204]="0:2:3:1:Gun::1:0:", -- The Gunblade
	[31209]="0:4:3:1:Plate::1:0:", -- Chimaerascale Legplates
	[31210]="0:4:3:1:Mail::1:0:", -- Chimaerascale Legguards
	[31211]="0:4:3:1:Leather::1:0:", -- Chimaerahide Pants
	[31212]="0:4:3:1:Cloth::1:0:", -- Chimaerahide Leggings
	[31213]="0:4:3:1:Plate::1:0:", -- Abyssal Plate Sabatons
	[31214]="0:4:3:1:Mail::1:0:", -- Abyssal Mail Greaves
	[31215]="0:4:3:1:Leather::1:0:", -- Abyssal Leather Treads
	[31216]="0:4:3:1:Cloth::1:0:", -- Abyssal Cloth Footwraps
	[31217]="0:4:3:1:Plate::1:0:", -- Crimson Beholder Eye
	[31218]="0:4:3:1:Mail::1:0:", -- Fiery Beholder Eye
	[31219]="0:4:3:1:Leather::1:0:", -- Emerald Beholder Eye
	[31220]="0:4:3:1:Cloth::1:0:", -- Amethyst Beholder Eye
	[31221]="0:4:3:1:Plate::1:0:", -- Illidari Vambraces
	[31222]="0:4:3:1:Mail::1:0:", -- Headdress of Inner Rage
	[31223]="0:4:3:1:Mail::1:0:", -- Illidari Wristguards
	[31224]="0:4:3:1:Leather::1:0:", -- Illidari Bracers
	[31225]="0:4:3:1:Cloth::1:0:", -- Illidari Bindings
	[31226]="0:4:3:1:Leather::1:0:", -- Leggings of the Sly
	[31227]="0:4:3:1:Plate::1:0:", -- Feathered Girdle
	[31228]="0:4:3:1:Mail::1:0:", -- Feathered Belt
	[31229]="0:4:3:1:Leather::1:0:", -- Feathered Waistband
	[31230]="0:4:3:1:Cloth::1:0:", -- Abyss Walker's Boots
	[31231]="0:4:3:1:Cloth::1:0:", -- Feathered Sash
	[31232]="0:4:3:1:Plate::1:0:", -- Grim Sabatons
	[31233]="0:4:3:1:Mail::1:0:", -- Grim Greaves
	[31234]="0:2:3:1:OneHandSword::1:0:", -- Crystalblade of the Draenei
	[31235]="0:4:3:1:Leather::1:0:", -- Grim Boots
	[31236]="0:4:3:1:Cloth::1:0:", -- Grim Slippers
	[31237]="0:4:3:1:Leather::1:0:", -- Elekk Hide Leggings
	[31238]="0:4:3:1:Ring::1:0:", -- Dragonbone Ring
	[31239]="0:12:1:1:::1:0:", -- Primed Key Mold
	[31240]="0:4:3:1:Mail::1:0:", -- Scales of the Beast
	[31241]="0:12:1:1:::1:0:", -- Primed Key Mold
	[31242]="0:4:3:1:Plate::1:0:", -- Nagascale Legplates
	[31243]="0:4:3:1:Mail::1:0:", -- Nagascale Legguards
	[31244]="0:4:3:1:Leather::1:0:", -- Nagahide Pants
	[31245]="0:12:1:1:::1:0:", -- Primed Key Mold
	[31246]="0:4:3:1:Cloth::1:0:", -- Nagahide Leggings
	[31247]="0:4:3:1:Plate::1:0:", -- Bog Pauldrons
	[31248]="0:4:3:1:Mail::1:0:", -- Bog Epaulets
	[31249]="0:4:3:1:Leather::1:0:", -- Bog Spaulders
	[31250]="0:4:3:1:Cloth::1:0:", -- Bog Mantle
	[31251]="0:12:1:1:::1:0:", -- Unfired Key Mold
	[31252]="0:12:1:1:::1:0:", -- Charred Key Mold
	[31254]="0:4:3:1:Cloak::1:0:", -- Striderhide Cloak
	[31255]="0:4:3:1:Cloak::1:0:", -- Cloak of the Craft
	[31256]="0:4:2:1:Mail::1:0:", -- Silvermoon Armor
	[31258]="0:4:3:1:Ring::1:0:", -- Band of Sorrow
	[31260]="0:12:1:1:::1:0:", -- Sketh'lon Commander's Journal - Page 1
	[31261]="0:12:1:1:::1:0:", -- Sketh'lon Commander's Journal - Page 2
	[31262]="0:12:1:1:::1:0:", -- Sketh'lon Commander's Journal - Page 3
	[31263]="0:4:2:1:Leather::1:0:", -- Silvermoon Tunic
	[31264]="0:4:2:1:Cloth::1:0:", -- Silvermoon Robes
	[31268]="0:2:2:1:OneHandAxe::1:0:", -- Abomination Cleaver
	[31269]="0:2:2:1:OneHandMace::1:0:", -- Ghoul Hammer
	[31270]="0:2:2:1:Wand::1:0:", -- Banshee Rod
	[31271]="0:12:1:1:::1:0:", -- Illidan's Command
	[31272]="0:4:3:1:Cloth::1:0:", -- Crown of Endless Knowledge
	[31275]="0:4:3:1:Amulet::1:0:", -- Necklace of Trophies
	[31276]="0:4:3:1:Plate::1:0:", -- Boots of Zealotry
	[31277]="0:4:3:1:Ring::1:0:", -- Pathfinder's Band
	[31278]="0:12:1:10:::1:0:", -- Illidari Tabard
	[31279]="0:4:1:1:Tabard::1:0:", -- Enchanted Illidari Tabard
	[31280]="0:4:3:1:Mail::1:0:", -- Thundercaller's Gauntlets
	[31281]="0:4:3:1:Leather::1:0:", -- Mask of Veiled Death
	[31282]="0:4:3:1:Cloth::1:0:", -- Shroud of Spiritual Purity
	[31283]="0:4:3:1:Cloth::1:0:", -- Sash of Sealed Fate
	[31284]="0:4:3:1:Plate::1:0:", -- Bracers of Recklessness
	[31285]="0:4:3:1:Leather::1:0:", -- Chestguard of the Talon
	[31286]="0:4:3:1:Mail::1:0:", -- Breastplate of Rapid Striking
	[31287]="0:4:3:1:Shield::1:0:", -- Draenei Honor Guard Shield
	[31288]="0:4:3:1:Leather::1:0:", -- The Master's Treads
	[31289]="0:2:3:1:Stave::1:0:", -- Staff of Divine Infusion
	[31290]="0:4:3:1:Ring::1:0:", -- Band of Dominion
	[31291]="0:2:3:1:TwoHandAxe::1:0:", -- Crystalforged War Axe
	[31292]="0:4:3:1:Shield::1:0:", -- Crystal Pulse Shield
	[31293]="0:4:3:1:Mail::1:0:", -- Girdle of Gale Force
	[31294]="0:4:3:1:Mail::1:0:", -- Pauldrons of Surging Mana
	[31295]="0:4:3:1:Leather::1:0:", -- Chestguard of the Dark Stalker
	[31297]="0:4:3:1:Cloth::1:0:", -- Robe of the Crimson Order
	[31298]="0:4:3:1:Plate::1:0:", -- Legguards of the Shattered Hand
	[31299]="0:2:3:1:TwoHandMace::1:0:", -- The Oathkeeper
	[31300]="0:12:1:1:::1:0:", -- Ironroot Seeds
	[31303]="0:2:3:1:Bow::1:0:", -- Valanos' Longbow
	[31304]="0:2:3:1:OneHandMace::1:0:", -- The Essence Focuser
	[31305]="0:2:3:1:Dagger::1:0:", -- Ced's Carver
	[31306]="0:4:3:1:Cloth::1:0:", -- Leggings of the Sacred Crest
	[31307]="0:12:1:1:::1:0:", -- Heart of Fury
	[31308]="0:2:3:1:Stave::1:0:", -- The Bringer of Death
	[31310]="0:15:1:1:CombatPet::1:0:", -- Wildhammer Flare Gun
	[31312]="0:4:2:1:Cloth::1:0:", -- Sinister Area 52 Boots
	[31313]="0:4:2:1:Leather::1:0:", -- Nether-Rocket Gloves
	[31314]="0:4:2:1:Mail::1:0:", -- Rocket-Chief Pauldrons
	[31315]="0:4:2:1:Plate::1:0:", -- Goblin Girdle
	[31316]="0:13:1:1:::1:0:", -- Lianthe's Key
	[31317]="0:12:1:1:::1:0:", -- Rod of Lianthe
	[31318]="0:2:4:1:TwoHandAxe::1:0:", -- Singing Crystal Axe
	[31319]="0:4:4:1:Ring::1:0:", -- Band of Impenetrable Defenses
	[31320]="0:4:4:1:Plate::1:0:", -- Chestguard of Exile
	[31321]="0:4:4:1:Amulet::1:0:", -- Choker of Repentance
	[31322]="0:2:4:1:TwoHandMace::1:0:", -- The Hammer of Destiny
	[31323]="0:2:4:1:Gun::1:0:", -- Don Santos' Famous Hunting Rifle
	[31324]="0:12:1:10:::1:0:", -- Sketh'lon Feather
	[31326]="0:4:4:1:Ring::1:0:", -- Truestrike Ring
	[31328]="0:4:4:1:Mail::1:0:", -- Leggings of Beast Mastery
	[31329]="0:4:4:1:Cloak::1:0:", -- Lifegiving Cloak
	[31330]="0:4:4:1:Mail::1:0:", -- Lightning Crown
	[31331]="0:2:4:1:Dagger::1:0:", -- The Night Blade
	[31332]="0:2:4:1:OneHandSword::1:0:", -- Blinkstrike
	[31333]="0:4:4:1:Leather::1:0:", -- The Night Watchman
	[31334]="0:2:4:1:Stave::1:0:", -- Staff of Natural Fury
	[31335]="0:4:4:1:Leather::1:0:", -- Pants of Living Growth
	[31336]="0:2:4:1:OneHandSword::1:0:", -- Blade of Wizardry
	[31337]="25000:0:1:1:Consumable::1:0:22099", -- Orb of the Blackwhelp
	[31338]="0:4:4:1:Amulet::1:0:", -- Charlotte's Ivy
	[31339]="0:4:4:1:Ring::1:0:", -- Lola's Eve
	[31340]="0:4:4:1:Cloth::1:0:", -- Will of Edward the Odd
	[31341]="100261:4:2:1:Cloak::1:0:22099", -- Wyrmcultist's Cloak
	[31342]="0:2:4:1:OneHandMace::1:0:", -- The Ancient Scepter of Sue-Min
	[31343]="0:4:4:1:Cloth::1:0:", -- Kamaei's Cerulean Skirt
	[31344]="0:12:1:1:::1:0:", -- Ceremonial Incense
	[31345]="0:12:1:1:::1:0:", -- The Journal of Val'zareq
	[31346]="0:12:1:1:::1:0:", -- Burning Bleeding Hollow Torch
	[31347]="0:12:1:20:::1:0:", -- Bleeding Hollow Torch
	[31349]="0:12:1:1:::1:0:", -- Grulloc's Sack
	[31350]="0:12:1:1:::1:0:", -- Huffer's Whistle
	[31351]="0:12:1:1:::1:0:", -- Dragonfire Trap
	[31354]="40000:9:2:1:Alchemy::1:0:21432", -- Recipe: Flask of the Titans
	[31355]="40000:9:2:1:Alchemy::1:0:21643", -- Recipe: Flask of Supreme Power
	[31356]="40000:9:2:1:Alchemy::1:0:17904", -- Recipe: Flask of Distilled Wisdom
	[31357]="40000:9:2:1:Alchemy::1:0:21655", -- Recipe: Flask of Chromatic Resistance
	[31358]="120000:9:3:1:Jewelcrafting::1:0:17585", -- Design: Dawnstone Crab
	[31359]="60000:9:2:1:Jewelcrafting::1:0:17585", -- Design: Enduring Deep Peridot
	[31360]="0:4:1:1:Trinket::1:0:", -- Unfinished Headpiece
	[31361]="60000:9:1:1:Leatherworking::1:0:17585", -- Pattern: Cobrahide Leg Armor
	[31362]="120000:9:1:1:Leatherworking::1:0:17585", -- Pattern: Nethercobra Leg Armor
	[31363]="0:12:1:1:::1:0:", -- Gorgrom's Favor
	[31364]="0:4:4:1:Plate::1:0:", -- Wildguard Breastplate
	[31365]="0:12:1:1:::1:0:", -- Energized Headpiece
	[31366]="0:12:1:1:::1:0:", -- Felsworn Gas Mask
	[31367]="0:4:4:1:Plate::1:0:", -- Wildguard Leggings
	[31368]="0:4:4:1:Plate::1:0:", -- Wildguard Helm
	[31369]="0:4:4:1:Plate::1:0:", -- Iceguard Breastplate
	[31370]="0:4:4:1:Plate::1:0:", -- Iceguard Leggings
	[31371]="0:4:4:1:Plate::1:0:", -- Iceguard Helm
	[31372]="0:12:1:8:::1:0:", -- Rocknail Flayer Carcass
	[31373]="0:12:1:5:::1:0:", -- Rocknail Flayer Giblets
	[31374]="0:12:1:1:::1:0:", -- Worg Master's Head
	[31375]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Kodohide Gloves
	[31376]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Kodohide Helm
	[31377]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Kodohide Legguards
	[31378]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Kodohide Spaulders
	[31379]="0:4:4:1:Leather::1:0:26090", -- Gladiator's Kodohide Tunic
	[31380]="0:4:3:1:Ring::1:0:", -- Acrobat's Mark of the Sha'tar
	[31381]="0:4:3:1:Ring::1:0:", -- Aggressor's Mark of the Sha'tar
	[31382]="0:4:3:1:Ring::1:0:", -- Mage's Mark of the Sha'tar
	[31383]="0:4:3:1:Ring::1:0:", -- Spiritualist's Mark of the Sha'tar
	[31384]="0:12:1:1:::1:0:", -- Damaged Mask
	[31386]="0:12:1:1:::1:0:", -- Staff of Parshah
	[31387]="0:12:1:1:::1:0:", -- Mystery Mask
	[31390]="240000:9:4:1:Blacksmithing::1:0:17904", -- Plans: Wildguard Breastplate
	[31391]="240000:9:4:1:Blacksmithing::1:0:17904", -- Plans: Wildguard Leggings
	[31392]="240000:9:4:1:Blacksmithing::1:0:17904", -- Plans: Wildguard Helm
	[31393]="240000:9:4:1:Blacksmithing::1:0:16388", -- Plans: Iceguard Breastplate
	[31394]="240000:9:4:1:Blacksmithing::1:0:16388", -- Plans: Iceguard Leggings
	[31395]="240000:9:4:1:Blacksmithing::1:0:16388", -- Plans: Iceguard Helm
	[31396]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Ringmail Armor
	[31397]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Ringmail Gauntlets
	[31398]="0:4:4:1:Ring::1:0:", -- The Frozen Eye
	[31399]="0:4:4:1:Ring::1:0:", -- The Natural Ward
	[31400]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Ringmail Helm
	[31401]="120000:9:4:1:Jewelcrafting::1:0:18255", -- Design: The Frozen Eye
	[31402]="120000:9:4:1:Jewelcrafting::1:0:17904", -- Design: The Natural Ward
	[31403]="0:12:1:1:::1:0:", -- Sablemane's Sleeping Powder
	[31404]="0:4:2:1:Tabard::1:0:", -- Green Trophy Tabard of the Illidari
	[31405]="0:4:2:1:Tabard::1:0:", -- Purple Trophy Tabard of the Illidari
	[31406]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Ringmail Leggings
	[31407]="0:4:4:1:Mail::1:0:26090", -- Gladiator's Ringmail Spaulders
	[31408]="0:15:1:1:Junk::1:0:", -- Offering of the Sha'tar
	[31409]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Mooncloth Gloves
	[31410]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Mooncloth Hood
	[31411]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Mooncloth Leggings
	[31412]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Mooncloth Mantle
	[31413]="0:4:4:1:Cloth::1:0:26090", -- Gladiator's Mooncloth Robe
	[31414]="0:2:2:1:Stave::1:0:", -- Wild Wood Staff
	[31415]="0:4:2:1:Shield::1:0:", -- Iron Oak Shield
	[31416]="0:2:2:1:Bow::1:0:", -- Scorch Wood Bow
	[31417]="0:2:3:1:Stave::1:0:", -- Staff of the Ashtongue Deathsworn
	[31418]="0:4:2:1:Cloth::1:0:", -- Sylvanaar Gloves
	[31419]="0:4:2:1:Leather::1:0:", -- Living Grove Shoulderpads
	[31420]="0:4:2:1:Mail::1:0:", -- Protector's Boots
	[31421]="0:4:2:1:Plate::1:0:", -- Sentinel Armbands
	[31422]="0:2:2:1:Dagger::1:0:", -- Heavy Elven Dirk
	[31423]="0:2:2:1:OneHandAxe::1:0:", -- Wolf Hewer's Axe
	[31424]="0:2:2:1:Wand::1:0:", -- Arcane Wand of Sylvanaar
	[31425]="0:4:2:1:Cloth::1:0:", -- Ogre Vanquisher's Belt
	[31426]="0:4:2:1:Leather::1:0:", -- Agile Mountain Bracers
	[31427]="0:4:2:1:Mail::1:0:", -- Sylvanaar Defender's Pauldrons
	[31428]="0:4:2:1:Plate::1:0:", -- Commander Skyshadow's Gloves
	[31429]="0:4:2:1:Cloth::1:0:", -- Spelunker's Mantle
	[31430]="0:4:2:1:Leather::1:0:", -- Miner's Gloves
	[31431]="0:4:2:1:Mail::1:0:", -- All-Weather Armguards
	[31432]="0:4:2:1:Plate::1:0:", -- Explorer's Boots
	[31433]="0:4:2:1:Cloth::1:0:", -- Sylvanaar Elite Caster's Armor
	[31434]="0:4:2:1:Leather::1:0:", -- Ogre Assassin's Britches
	[31435]="0:4:2:1:Mail::1:0:", -- Gurn's Horned Helmet
	[31436]="0:4:2:1:Plate::1:0:", -- Sylvanaar Champion's Shoulders
	[31437]="0:0:2:10:Other::1:0:", -- Medicinal Drake Essence
	[31438]="0:4:2:1:Cloth::1:0:", -- Fizit's Mantle of Drake Hunting
	[31439]="0:4:2:1:Leather::1:0:", -- Precise Gloves of Alacrity
	[31440]="0:4:2:1:Mail::1:0:", -- Devolved Drake Girdle
	[31441]="0:4:2:1:Plate::1:0:", -- Clocktock's Jumpers
	[31442]="0:4:2:1:Cloth::1:0:", -- Metro's Slimming Legs
	[31443]="0:4:2:1:Leather::1:0:", -- Nickwinkle's Harness Experiment
	[31444]="0:4:2:1:Mail::1:0:", -- Party Hat Mistake
	[31445]="0:4:2:1:Plate::1:0:", -- Last Year's "In" Belt
	[31446]="0:2:2:1:Dagger::1:0:", -- Vibro Shanker
	[31447]="0:2:2:1:Dagger::1:0:", -- Vibro Dagger
	[31448]="0:2:2:1:OneHandSword::1:0:", -- Vibro Sword
	[31449]="0:0:1:5:Consumable::1:0:", -- Distilled Stalker Sight
	[31450]="0:0:1:5:Consumable::1:0:", -- Stealth of the Stalker
	[31451]="0:0:1:5:Consumable::1:0:", -- Pure Energy
	[31452]="0:4:2:1:Cloth::1:0:", -- Energized Wristwraps
	[31453]="0:4:2:1:Leather::1:0:", -- Charged Footwear
	[31454]="0:4:2:1:Mail::1:0:", -- Scalewing Gloves
	[31455]="0:4:2:1:Plate::1:0:", -- Muscle Toning Belt
	[31456]="0:4:2:1:Cloth::1:0:", -- Gnomish Casting Boots
	[31457]="0:4:2:1:Leather::1:0:", -- Toshley's Station Hero's Hat
	[31458]="0:4:2:1:Mail::1:0:", -- Razaani-Buster Leggings
	[31459]="0:4:2:1:Plate::1:0:", -- Soul Saver's Chest Plate
	[31460]="0:4:3:1:Plate::1:0:", -- Sha'tari Vindicator's Waistguard
	[31461]="0:4:3:1:Cloth::1:0:", -- A'dal's Gift
	[31462]="0:4:3:1:Mail::1:0:", -- Shattrath's Champion Belt
	[31463]="0:12:1:1:::1:0:", -- Zezzak's Shard
	[31464]="0:4:3:1:Leather::1:0:", -- Naaru Belt of Precision
	[31465]="0:4:3:1:Cloak::1:0:", -- Sha'tari Anchorite's Cloak
	[31470]="0:4:2:1:Cloth::1:0:", -- Witch Doctor's Beads
	[31471]="0:4:2:1:Leather::1:0:", -- T'chali's Kilt
	[31472]="0:4:2:1:Mail::1:0:", -- Hexxer's Belt
	[31473]="0:4:2:1:Plate::1:0:", -- Ogre Defiler's Handguards
	[31474]="0:2:2:1:Wand::1:0:", -- Wand of the Ancestors
	[31475]="0:2:2:1:Dagger::1:0:", -- Thunderlord Scalpel
	[31476]="0:2:2:1:Dagger::1:0:", -- Slow Death Dirk
	[31477]="0:4:2:1:Cloth::1:0:", -- Red Hands of the Thunderlord
	[31478]="0:4:2:1:Leather::1:0:", -- Tor'chunk's Foot Covers
	[31479]="0:4:2:1:Mail::1:0:", -- Rugged Mountain Bracers
	[31480]="0:4:2:1:Plate::1:0:", -- Ogre Beater's Belt
	[31481]="0:4:2:1:Cloth::1:0:", -- Thunderlord Armbands
	[31482]="0:4:2:1:Leather::1:0:", -- Dire Wolf Handler Gloves
	[31483]="0:4:2:1:Plate::1:0:", -- Gor'drek's Pauldrons
	[31484]="0:4:2:1:Mail::1:0:", -- Wolf Chaps
	[31485]="0:4:2:1:Cloth::1:0:", -- Dark Deed Leggings
	[31486]="0:4:2:1:Leather::1:0:", -- Bear-Strength Harness
	[31487]="0:4:2:1:Mail::1:0:", -- Wild Horned Helm
	[31488]="0:4:2:1:Plate::1:0:", -- Boots of the Ancient-Killer
	[31489]="0:12:1:1:::1:0:", -- Orb of the Grishna
	[31490]="0:4:3:1:Shield::1:0:", -- Netherwing Protector's Shield
	[31491]="0:4:3:1:Shield::1:0:", -- Netherwing Defender's Shield
	[31492]="0:2:3:1:Dagger::1:0:", -- Claw of the Netherwing Flight
	[31493]="0:4:3:1:OffHandFrill::1:0:", -- Netherwing Spiritualist's Charm
	[31494]="0:4:3:1:OffHandFrill::1:0:", -- Netherwing Sorceror's Charm
	[31495]="0:0:1:5:Consumable::1:0:", -- Grishnath Orb
	[31501]="0:9:3:1:Book::1:0:", -- Tome of Conjure Food VIII
	[31504]="0:12:1:12:::1:0:", -- Nethervine Crystal
	[31508]="0:4:2:1:Cloth::1:0:", -- Coven Britches
	[31509]="0:4:2:1:Cloth::1:0:", -- Wyrmcultist's Hood
	[31510]="0:4:2:1:Cloth::1:0:", -- Hewing Gloves
	[31511]="0:4:2:1:Leather::1:0:", -- Chest of the Wyrmcult
	[31512]="0:4:2:1:Leather::1:0:", -- Tree Warden's Belt
	[31513]="0:4:2:1:Leather::1:0:", -- Blackwhelp Belt
	[31514]="0:4:2:1:Mail::1:0:", -- Dragonkin Shirt
	[31515]="0:4:2:1:Mail::1:0:", -- Whelpscale Gauntlets
	[31516]="0:4:2:1:Mail::1:0:", -- Bracers of the Weald
	[31517]="0:0:1:5:Consumable::1:0:", -- Dire Pinfeather
	[31518]="0:15:1:5:CombatPet::1:0:", -- Exorcism Feather
	[31519]="0:4:2:1:Plate::1:0:", -- Inkling's Leggings
	[31520]="0:4:2:1:Plate::1:0:", -- Blackwing Helm
	[31521]="0:4:2:1:Plate::1:0:", -- Expedition Defender's Shoulders
	[31522]="0:12:1:1:::1:0:", -- Primal Mooncloth Supplies
	[31523]="0:4:2:1:Ring::1:0:", -- Treebole's Hoop
	[31524]="0:12:1:1:::1:0:", -- Square of Imbued Netherweave
	[31525]="0:12:1:1:::1:0:", -- Vial of Primal Reagents
	[31526]="0:4:2:1:Ring::1:0:", -- Raven's Wood Exorciser's Band
	[31527]="0:4:2:1:Ring::1:0:", -- Leafbeard Ring
	[31528]="0:4:2:1:Ring::1:0:", -- Ring of the Stonebark
	[31529]="0:12:1:1:::1:0:", -- Grillok's Eyepatch
	[31530]="0:12:1:1:::1:0:", -- Sample of Primal Mooncloth
	[31531]="0:4:2:1:Cloth::1:0:", -- Wraithcloth Bindings
	[31532]="0:4:2:1:Leather::1:0:", -- Supple Leather Boots
	[31533]="0:4:2:1:Mail::1:0:", -- Diluvian Spaulders
	[31534]="0:4:2:1:Plate::1:0:", -- Whiteknuckle Gauntlets
	[31535]="0:0:1:5:EnhTemp::1:0:", -- Bloodboil Poison
	[31536]="0:13:1:5:::1:0:", -- Camp Anger Key
	[31537]="0:4:2:1:Cloth::1:0:", -- Darktread Boots
	[31538]="0:4:2:1:Leather::1:0:", -- Twin Moon Shoulderguards
	[31539]="0:4:2:1:Mail::1:0:", -- Chaintwine Cinch
	[31540]="0:4:2:1:Plate::1:0:", -- Fairweather's Wristguards
	[31541]="0:2:2:1:OneHandSword::1:0:", -- Whistling Sword
	[31542]="0:2:2:1:TwoHandAxe::1:0:", -- Fanged Axe
	[31543]="0:2:2:1:Stave::1:0:", -- Adjudicator's Staff
	[31544]="0:4:3:1:Leather::1:0:", -- Clefthoof Hide Leggings
	[31545]="0:4:3:1:Leather::1:0:", -- Oilcloth Breeches
	[31546]="0:4:3:1:Cloth::1:0:", -- Tourmaline Crown
	[31547]="0:4:3:1:Mail::1:0:", -- Malefactor's Eyepatch
	[31548]="0:4:3:1:Plate::1:0:", -- Blackened Chestplate
	[31549]="0:4:3:1:Plate::1:0:", -- Leonine Breastplate
	[31550]="0:12:1:1:::1:0:", -- Albreck's Findings
	[31552]="0:4:3:1:Cloth::1:0:", -- Windchanneller's Miter
	[31553]="0:4:3:1:Cloth::1:0:", -- Windchanneller's Mantle
	[31554]="0:4:3:1:Cloth::1:0:", -- Windchanneller's Tunic
	[31555]="0:4:3:1:Cloth::1:0:", -- Windchanneller's Ceinture
	[31556]="0:4:3:1:Cloth::1:0:", -- Windchanneller's Leggings
	[31557]="0:4:3:1:Cloth::1:0:", -- Windchanneller's Boots
	[31558]="0:4:3:1:Cloth::1:0:", -- Windchanneller's Bindings
	[31559]="0:4:3:1:Cloth::1:0:", -- Windchanneller's Gloves
	[31560]="0:4:3:1:Leather::1:0:", -- Skystalker's Shroud
	[31561]="0:4:3:1:Leather::1:0:", -- Skystalker's Shoulders
	[31562]="0:4:3:1:Leather::1:0:", -- Skystalker's Tunic
	[31563]="0:4:3:1:Leather::1:0:", -- Skystalker's Cord
	[31564]="0:4:3:1:Leather::1:0:", -- Skystalker's Leggings
	[31565]="0:4:3:1:Leather::1:0:", -- Skystalker's Boots
	[31566]="0:4:3:1:Leather::1:0:", -- Skystalker's Bracers
	[31567]="0:4:3:1:Leather::1:0:", -- Skystalker's Gloves
	[31568]="0:4:3:1:Mail::1:0:", -- Mistshroud Helm
	[31569]="0:4:3:1:Mail::1:0:", -- Mistshroud Shoulders
	[31570]="0:4:3:1:Mail::1:0:", -- Mistshroud Tunic
	[31571]="0:4:3:1:Mail::1:0:", -- Mistshroud Belt
	[31572]="0:4:3:1:Mail::1:0:", -- Mistshroud Pants
	[31573]="0:4:3:1:Mail::1:0:", -- Mistshroud Boots
	[31574]="0:4:3:1:Mail::1:0:", -- Mistshroud Bracers
	[31575]="0:4:3:1:Mail::1:0:", -- Mistshroud Gauntlets
	[31576]="0:4:3:1:Plate::1:0:", -- Slatesteel Helm
	[31577]="0:4:3:1:Plate::1:0:", -- Slatesteel Shoulders
	[31578]="0:4:3:1:Plate::1:0:", -- Slatesteel Breastplate
	[31579]="0:4:3:1:Plate::1:0:", -- Slatesteel Girdle
	[31580]="0:4:3:1:Plate::1:0:", -- Slatesteel Leggings
	[31581]="0:4:3:1:Plate::1:0:", -- Slatesteel Boots
	[31582]="0:4:3:1:Plate::1:0:", -- Slatesteel Bracers
	[31583]="0:4:3:1:Plate::1:0:", -- Slatesteel Gauntlets
	[31584]="0:4:3:1:Leather::1:0:", -- High Warlord's Kodohide Gloves
	[31585]="0:4:3:1:Leather::1:0:", -- High Warlord's Kodohide Helm
	[31586]="0:4:3:1:Leather::1:0:", -- High Warlord's Kodohide Legguards
	[31587]="0:4:3:1:Leather::1:0:", -- High Warlord's Kodohide Spaulders
	[31588]="0:4:3:1:Leather::1:0:", -- High Warlord's Kodohide Tunic
	[31589]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Kodohide Gloves
	[31590]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Kodohide Helm
	[31591]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Kodohide Legguards
	[31592]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Kodohide Spaulders
	[31593]="0:4:3:1:Leather::1:0:", -- Grand Marshal's Kodohide Tunic
	[31594]="0:4:4:1:Leather::1:0:", -- General's Kodohide Belt
	[31595]="0:4:4:1:Leather::1:0:", -- General's Kodohide Boots
	[31596]="0:4:4:1:Leather::1:0:", -- Marshal's Kodohide Belt
	[31597]="0:4:4:1:Leather::1:0:", -- Marshal's Kodohide Boots
	[31598]="0:4:4:1:Leather::1:0:", -- General's Kodohide Bracers
	[31599]="0:4:4:1:Leather::1:0:", -- Marshal's Kodohide Bracers
	[31606]="0:12:1:1:::1:0:", -- Demoniac Scryer
	[31607]="0:12:1:1:::1:0:", -- Demoniac Scryer Reading
	[31610]="0:12:1:1:::1:0:", -- Rod of Purification
	[31613]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Ornamented Chestguard
	[31614]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Ornamented Gloves
	[31615]="0:4:2:1:Trinket::1:0:", -- Ancient Draenei Arcane Relic
	[31616]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Ornamented Headcover
	[31617]="0:4:2:1:Trinket::1:0:", -- Ancient Draenei War Talisman
	[31618]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Ornamented Legplates
	[31619]="0:4:4:1:Plate::1:0:26090", -- Gladiator's Ornamented Spaulders
	[31620]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Mooncloth Mitts
	[31621]="0:4:3:1:Cloth::1:0:", -- High Warlord's Mooncloth Mitts
	[31622]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Mooncloth Cowl
	[31623]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Mooncloth Legguards
	[31624]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Mooncloth Shoulderpads
	[31625]="0:4:3:1:Cloth::1:0:", -- Grand Marshal's Mooncloth Vestments
	[31626]="0:4:3:1:Cloth::1:0:", -- High Warlord's Mooncloth Cowl
	[31627]="0:4:3:1:Cloth::1:0:", -- High Warlord's Mooncloth Legguards
	[31628]="0:4:3:1:Cloth::1:0:", -- High Warlord's Mooncloth Shoulderpads
	[31629]="0:4:3:1:Cloth::1:0:", -- High Warlord's Mooncloth Vestments
	[31630]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Ornamented Chestplate
	[31631]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Ornamented Gloves
	[31632]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Ornamented Headguard
	[31633]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Ornamented Leggings
	[31634]="0:4:3:1:Plate::1:0:", -- Grand Marshal's Ornamented Spaulders
	[31635]="0:4:3:1:Plate::1:0:", -- High Warlord's Ornamented Chestplate
	[31636]="0:4:3:1:Plate::1:0:", -- High Warlord's Ornamented Gloves
	[31637]="0:4:3:1:Plate::1:0:", -- High Warlord's Ornamented Headguard
	[31638]="0:4:3:1:Plate::1:0:", -- High Warlord's Ornamented Leggings
	[31639]="0:4:3:1:Plate::1:0:", -- High Warlord's Ornamented Spaulders
	[31640]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Ringmail Chestguard
	[31641]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Ringmail Gloves
	[31642]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Ringmail Headpiece
	[31643]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Ringmail Legguards
	[31644]="0:4:3:1:Mail::1:0:", -- Grand Marshal's Ringmail Shoulders
	[31646]="0:4:3:1:Mail::1:0:", -- High Warlord's Ringmail Chestguard
	[31647]="0:4:3:1:Mail::1:0:", -- High Warlord's Ringmail Gloves
	[31648]="0:4:3:1:Mail::1:0:", -- High Warlord's Ringmail Headpiece
	[31649]="0:4:3:1:Mail::1:0:", -- High Warlord's Ringmail Legguards
	[31650]="0:4:3:1:Mail::1:0:", -- High Warlord's Ringmail Shoulderpads
	[31651]="0:12:1:20:::1:0:", -- Bladespire Totem
	[31652]="0:12:1:1:::1:0:", -- Enchanted Nethervine Crystal
	[31653]="0:12:1:10:::1:0:", -- Condensed Nether Gas
	[31655]="0:13:1:10:::1:0:", -- Veil Skith Prison Key
	[31656]="0:12:1:20:::1:0:", -- Lesser Nether Drake Spirit
	[31657]="0:4:2:1:Cloth::1:0:", -- Chemise of Rebirth
	[31658]="0:4:2:1:Leather::1:0:", -- Scout's Hood
	[31659]="0:4:2:1:Cloth::1:0:", -- Researcher's Mantle
	[31660]="0:4:2:1:Leather::1:0:", -- Feralfen Skulker's Belt
	[31661]="0:4:2:1:Leather::1:0:", -- Leesa'oh's Wristbands
	[31662]="0:12:1:1:::1:0:", -- Rilak's Missive
	[31663]="0:12:1:1:::1:0:", -- Spirit Calling Totems
	[31664]="0:13:1:1:::1:0:", -- Zuluhed's Key
	[31666]="0:15:1:1:CombatPet::1:0:", -- Battered Steam Tonk Controller
	[31668]="0:12:1:1:::1:0:", -- Orb Collecting Totem
	[31670]="0:7:1:20:Meat:185:1:0:", -- Raptor Ribs
	[31671]="0:7:1:20:Meat:185:1:0:", -- Serpent Flesh
	[31672]="0:0:1:20:FoodDrink::1:0:", -- Mok'Nathal Shortribs
	[31673]="0:0:1:20:FoodDrink::1:0:", -- Crunchy Serpent
	[31674]="30000:9:1:1:Cooking::1:0:20916,21113", -- Recipe: Crunchy Serpent
	[31675]="30000:9:1:1:Cooking::1:0:20916,21113", -- Recipe: Mok'Nathal Shortribs
	[31676]="0:0:1:20:Potion::1:0:", -- Fel Regeneration Potion
	[31677]="0:0:1:20:Potion::1:0:", -- Fel Mana Potion
	[31678]="0:12:1:1:::1:0:", -- Mental Interference Rod
	[31679]="0:0:1:20:Elixir::1:0:", -- Fel Strength Elixir
	[31680]="0:9:3:1:Alchemy::1:0:", -- Recipe: Fel Strength Elixir
	[31681]="0:9:3:1:Alchemy::1:0:", -- Recipe: Fel Regeneration Potion
	[31682]="0:9:3:1:Alchemy::1:0:", -- Recipe: Fel Mana Potion
	[31683]="0:4:2:1:Cloth::1:0:", -- Dreadwing Skin Belt
	[31684]="0:4:2:1:Leather::1:0:", -- Netherhide Gloves
	[31685]="0:4:2:1:Mail::1:0:", -- Brood Mother Leggings
	[31686]="0:4:2:1:Plate::1:0:", -- Nether Protector's Chest
	[31687]="0:4:2:1:Cloth::1:0:", -- Mok'Nathal Mantle
	[31688]="0:4:2:1:Leather::1:0:", -- Spiritcaller's Mask
	[31689]="0:4:2:1:Mail::1:0:", -- Mok'Nathal Hero's Pantaloons
	[31690]="0:4:2:1:Plate::1:0:", -- Belt of the Soul Saver
	[31691]="0:4:3:1:Amulet::1:0:", -- Natasha's Guardian Cord
	[31692]="0:4:3:1:Amulet::1:0:", -- Natasha's Ember Necklace
	[31693]="0:4:3:1:Amulet::1:0:", -- Natasha's Arcane Filament
	[31694]="0:4:3:1:Amulet::1:0:", -- Natasha's Pack Collar
	[31695]="0:4:3:1:Amulet::1:0:", -- Natasha's Choker
	[31696]="0:4:3:1:Amulet::1:0:", -- Natasha's Battle Chain
	[31697]="0:12:1:1:::1:0:", -- Dread Relic
	[31698]="0:15:1:1:Junk::1:0:", -- Letter from Shattrath
	[31699]="0:4:2:1:OffHandFrill::1:0:", -- Imbued Draenethyst Crystal
	[31700]="0:2:2:1:Stave::1:0:", -- Runed Silver Staff
	[31701]="0:2:2:1:TwoHandAxe::1:0:", -- Saboteur's Axe
	[31702]="0:0:1:1:Consumable::1:0:", -- Challenge from the Horde
	[31703]="0:2:2:1:Dagger::1:0:", -- Nether-Stalker's Blade
	[31704]="0:13:1:1:::1:0:", -- The Tempest Key
	[31705]="0:13:1:1:::1:0:", -- Derelict Caravan Chest Key
	[31706]="0:12:1:1:::1:0:", -- The Head of the Hand of Kargath
	[31707]="0:12:1:1:::1:0:", -- Cabal Orders
	[31708]="0:12:1:10:::1:0:", -- Scroll of Atalor
	[31709]="0:12:1:10:::1:0:", -- Drape of Arunen
	[31710]="0:12:1:10:::1:0:", -- Gavel of K'alen
	[31711]="0:4:2:1:Cloth::1:0:", -- Nether-Empowered Footgear
	[31712]="0:4:2:1:Leather::1:0:", -- Mok'Nathal Champion's Shoulderguards
	[31713]="0:4:2:1:Mail::1:0:", -- Ritualist's Helm
	[31714]="0:4:2:1:Plate::1:0:", -- Nether Drake Wristguards
	[31715]="0:4:2:1:OffHandFrill::1:0:", -- Demoniac Soul Prison
	[31716]="0:12:1:1:::1:0:", -- Unused Axe of the Executioner
	[31717]="0:4:3:1:Cloth::1:0:", -- Shadowcast Tunic
	[31718]="0:4:3:1:Leather::1:0:", -- Darkstorm Tunic
	[31719]="0:4:3:1:Mail::1:0:", -- Stormstrike Vest
	[31720]="0:4:3:1:Plate::1:0:", -- Battlemaster's Breastplate
	[31721]="0:12:1:1:::1:0:", -- Kalithresh's Trident
	[31722]="0:12:1:1:::1:0:", -- Murmur's Essence
	[31723]="0:2:2:1:Dagger::1:0:", -- Madman's Blade
	[31724]="0:2:2:1:Wand::1:0:", -- Arakkoa Divining Rod
	[31725]="0:4:2:1:Cloth::1:0:", -- Cilice of Suffering
	[31726]="0:4:3:1:Amulet::1:0:", -- Necklace of Bloodied Feathers
	[31727]="0:4:3:1:Amulet::1:0:", -- Choker of Bloodied Feathers
	[31728]="0:4:2:1:Ring::1:0:", -- Heirloom Signet of Willpower
	[31729]="0:4:2:1:Ring::1:0:", -- Heirloom Signet of Valor
	[31730]="0:4:2:1:Ring::1:0:", -- Heirloom Signet of Convalescence
	[31731]="0:4:2:1:OffHandFrill::1:0:", -- Mekeda's Gift
	[31732]="0:4:2:1:OffHandFrill::1:0:", -- Unearthed Orb
	[31733]="0:2:2:1:Dagger::1:0:", -- Akuno's Blade
	[31734]="0:4:2:1:Shield::1:0:", -- Ancient Draenei Crest
	[31735]="20000:6:4:1000:Bullet::200:0:19932,20130,25195,25196,29493", -- Timeless Shell
	[31736]="0:12:1:1:::1:0:", -- Crystal of Deep Shadows
	[31737]="20000:6:4:1000:Arrow::200:0:19932,20130,25195,25196,29493", -- Timeless Arrow
	[31739]="0:12:1:1:::1:0:", -- Smoke Beacon
	[31740]="0:12:1:1:::1:0:", -- Meeting Note
	[31741]="0:12:1:1:::1:0:", -- Nether-wraith Essence
	[31742]="0:12:1:1:::1:0:", -- Nether-wraith Beacon
	[31744]="0:12:1:10:::1:0:", -- Botanist's Field Guide
	[31745]="0:2:3:1:Dagger::1:0:", -- Illidari-Bane Dagger
	[31746]="0:4:4:1:Ring::1:0:", -- Phoenix-fire Band
	[31747]="0:4:3:1:Amulet::1:0:", -- Potent Sha'tari Pendant
	[31748]="0:4:3:1:Amulet::1:0:", -- Shattrath Choker of Power
	[31749]="0:4:3:1:Amulet::1:0:", -- A'dal's Recovery Necklace
	[31750]="0:12:1:1:::1:0:", -- Earthen Signet
	[31751]="0:12:1:1:::1:0:", -- Blazing Signet
	[31752]="0:12:1:1:::1:0:", -- Sablemane's Trap
	[31753]="0:12:1:20:::1:0:", -- Essence of Infinity
	[31754]="0:12:1:5:::1:0:", -- Grisly Totem
	[31755]="0:13:1:1:::1:0:", -- Wyvern Cage Key
	[31756]="0:2:3:1:Dagger::1:0:", -- Dib'Muad's Crysknife
	[31757]="0:12:1:20:::1:0:", -- Fel Cannonball
	[31758]="0:2:3:1:Dagger::1:0:", -- Revered Mother's Crysknife
	[31759]="0:2:3:1:Dagger::1:0:", -- Shani's Crysknife
	[31760]="0:15:1:1:Companion::1:0:", -- Miniwing
	[31761]="0:2:2:1:Wand::1:0:", -- Talonbranch Wand
	[31762]="0:2:2:1:Bow::1:0:", -- Feather-Wrapped Bow
	[31763]="0:12:1:1:::1:0:", -- Druid Signal
	[31764]="0:4:2:1:Mail::1:0:", -- Stillfire Leggings
	[31765]="0:4:2:1:Plate::1:0:", -- Redeemer's Plate
	[31766]="0:4:2:1:Cloth::1:0:", -- Skywitch Hat
	[31768]="0:4:2:1:Cloak::1:0:", -- Deep Mire Cloak
	[31769]="0:12:1:1:::1:0:", -- Sha'tari Torch
	[31770]="0:4:2:1:Cloth::1:0:", -- Marsh Bracers
	[31772]="0:12:1:1:::1:0:", -- Anchorite Relic
	[31773]="10000:4:1:1:Tabard::1:0:5188,5189,5190,16610,20241", -- Mag'har Tabard
	[31774]="10000:4:1:1:Tabard::1:0:5049,5191,5193,16766,20240", -- Kurenai Tabard
	[31775]="0:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,18382,28776", -- Sporeggar Tabard
	[31776]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,20242,23007,28776", -- Consortium Tabard
	[31777]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,21643,28776", -- Keepers of Time Tabard
	[31778]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,21655,28776", -- Lower City Tabard
	[31779]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,19321,28776", -- Aldor Tabard
	[31780]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,19331,28776", -- Scryers Tabard
	[31781]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,21432,28776", -- Sha'tar Tabard
	[31782]="0:4:2:1:Mail::1:0:", -- Warpstalker Breastplate
	[31783]="0:4:2:1:Cloth::1:0:", -- Bloodfire Leggings
	[31784]="0:4:2:1:Leather::1:0:", -- Ancient Terokkar Hood
	[31785]="0:2:2:1:TwoHandAxe::1:0:", -- Edge of Inevitability
	[31786]="0:4:2:1:Mail::1:0:", -- Blacksting Shoulders
	[31787]="0:4:2:1:Plate::1:0:", -- Stalwart Girdle
	[31788]="0:4:2:1:Leather::1:0:", -- Blacksting Gloves
	[31789]="0:4:2:1:Cloth::1:0:", -- Marshfang Boots
	[31790]="0:4:2:1:Amulet::1:0:", -- Expedition Pendant
	[31791]="0:4:2:1:Ring::1:0:", -- Wildlord's Band
	[31792]="0:4:2:1:Cloak::1:0:", -- Evergrove Ranger's Cloak
	[31793]="0:4:2:1:Leather::1:0:", -- Ruuan Weald Wristguards
	[31794]="0:4:2:1:Plate::1:0:", -- Sha'tari Vindicator's Legplates
	[31795]="0:0:1:1:Consumable::1:0:", -- Draenei Prayer Beads
	[31796]="0:4:2:1:Mail::1:0:", -- Sha'tari Marksman's Gloves
	[31797]="0:4:2:1:Leather::1:0:", -- Elekk Hide Spaulders
	[31798]="0:4:2:1:Cloth::1:0:", -- Death-Speaker's Tunic
	[31799]="0:12:1:1:::1:0:18266", -- Fei Fei Doggy Treat
	[31800]="0:15:1:1:Junk::1:0:", -- Outcast's Cache
	[31804]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,17904,28776", -- Cenarion Expedition Tabard
	[31807]="0:12:1:1:::1:0:", -- Naturalized Ammunition
	[31808]="0:12:1:1:::1:0:", -- Sablemane's Signet
	[31809]="0:12:1:1:::1:0:", -- Evergrove Wand
	[31810]="0:12:1:1:::1:0:", -- Fumper
	[31811]="0:12:1:1:::1:0:", -- Dread Relic
	[31812]="0:12:1:20:::1:0:", -- Doom Skull
	[31813]="0:12:1:10:::1:0:", -- Warp Chaser Blood
	[31814]="0:12:1:8:::1:0:", -- Mature Bone Sifter Carcass
	[31815]="0:12:1:1:::1:0:", -- Zeppit's Crystal
	[31816]="0:2:2:1:TwoHandSword::1:0:", -- Dragonbone Greatsword
	[31817]="0:4:2:1:Mail::1:0:", -- Dragonbone Shoulders
	[31818]="0:4:2:1:Amulet::1:0:", -- Dragonbone Talisman
	[31819]="0:4:2:1:Plate::1:0:", -- Noble Plate Pauldrons
	[31820]="0:4:2:1:Ring::1:0:", -- Blessed Signet Ring
	[31821]="0:2:2:1:OneHandSword::1:0:", -- Blade of Retribution
	[31823]="0:4:2:1:OffHandFrill::1:0:", -- Book of Many Blessings
	[31825]="0:12:1:1:::1:0:", -- Fumper
	[31826]="0:12:1:1:::1:0:", -- Enormous Bone Worm Organs
	[31827]="0:12:1:1:::1:0:", -- Sablemane's Trap
	[31828]="0:12:1:1:::1:0:", -- Ritual Prayer Beads
	[31829]="700000:15:4:1:Mount::1:0:20241", -- Reins of the Cobalt Riding Talbuk
	[31830]="700000:15:4:1:Mount::1:0:20240", -- Reins of the Cobalt Riding Talbuk
	[31831]="700000:15:4:1:Mount::1:0:20241", -- Reins of the Silver Riding Talbuk
	[31832]="700000:15:4:1:Mount::1:0:20240", -- Reins of the Silver Riding Talbuk
	[31833]="700000:15:4:1:Mount::1:0:20241", -- Reins of the Tan Riding Talbuk
	[31834]="700000:15:4:1:Mount::1:0:20240", -- Reins of the Tan Riding Talbuk
	[31835]="700000:15:4:1:Mount::1:0:20241", -- Reins of the White Riding Talbuk
	[31836]="700000:15:4:1:Mount::1:0:20240", -- Reins of the White Riding Talbuk
	[31837]="0:9:3:1:Book::1:0:", -- Codex: Prayer of Shadow Protection II
	[31838]="0:0:1:20:Potion::1:0:12781,12793", -- Major Combat Healing Potion
	[31839]="0:0:1:20:Potion::1:0:12781,12793", -- Major Combat Healing Potion
	[31840]="0:0:1:20:Potion::1:0:12781,12793", -- Major Combat Mana Potion
	[31841]="0:0:1:20:Potion::1:0:12781,12793", -- Major Combat Mana Potion
	[31852]="0:0:1:20:Potion::1:0:12781,12793", -- Major Combat Healing Potion
	[31853]="0:0:1:20:Potion::1:0:12781,12793", -- Major Combat Healing Potion
	[31854]="0:0:1:20:Potion::1:0:12781,12793", -- Major Combat Mana Potion
	[31855]="0:0:1:20:Potion::1:0:12781,12793", -- Major Combat Mana Potion
	[31856]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Crusade
	[31857]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Wrath
	[31858]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Vengeance
	[31859]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Madness
	[31860]="0:3:2:1:GemYellow::1:0:", -- Great Golden Draenite
	[31861]="0:3:3:1:GemYellow::1:0:", -- Great Dawnstone
	[31862]="0:3:2:1:GemPurple::1:0:", -- Balanced Shadow Draenite
	[31863]="0:3:3:1:GemPurple::1:0:", -- Balanced Nightseye
	[31864]="0:3:2:1:GemPurple::1:0:", -- Infused Shadow Draenite
	[31865]="0:3:3:1:GemPurple::1:0:", -- Infused Nightseye
	[31866]="0:3:2:1:GemOrange::1:0:", -- Veiled Flame Spessarite
	[31867]="0:3:3:1:GemOrange::1:0:", -- Veiled Noble Topaz
	[31868]="0:3:3:1:GemOrange::1:0:", -- Wicked Noble Topaz
	[31869]="0:3:2:1:GemOrange::1:0:", -- Wicked Flame Spessarite
	[31870]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Great Golden Draenite
	[31871]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Balanced Shadow Draenite
	[31872]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Infused Shadow Draenite
	[31873]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Veiled Flame Spessarite
	[31874]="0:9:2:1:Jewelcrafting::1:0:", -- Design: Wicked Flame Spessarite
	[31875]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Great Dawnstone
	[31876]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Balanced Nightseye
	[31877]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Infused Nightseye
	[31878]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Veiled Noble Topaz
	[31879]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Wicked Noble Topaz
	[31880]="0:15:1:1:CombatPet::1:0:", -- Blood Elf Orphan Whistle
	[31881]="0:15:1:1:CombatPet::1:0:", -- Draenei Orphan Whistle
	[31882]="0:12:3:20:::1:0:", -- Ace of Blessings
	[31883]="0:12:3:20:::1:0:", -- Eight of Blessings
	[31884]="0:12:3:20:::1:0:", -- Five of Blessings
	[31885]="0:12:3:20:::1:0:", -- Four of Blessings
	[31886]="0:12:3:20:::1:0:", -- Seven of Blessings
	[31887]="0:12:3:20:::1:0:", -- Six of Blessings
	[31888]="0:12:3:20:::1:0:", -- Three of Blessings
	[31889]="0:12:3:20:::1:0:", -- Two of Blessings
	[31890]="0:12:4:1:::1:0:", -- Blessings Deck
	[31891]="0:12:4:1:::1:0:", -- Storms Deck
	[31892]="0:12:3:20:::1:0:", -- Ace of Storms
	[31893]="0:12:3:20:::1:0:", -- Eight of Storms
	[31894]="0:12:3:20:::1:0:", -- Five of Storms
	[31895]="0:12:3:20:::1:0:", -- Four of Storms
	[31896]="0:12:3:20:::1:0:", -- Seven of Storms
	[31898]="0:12:3:20:::1:0:", -- Six of Storms
	[31899]="0:12:3:20:::1:0:", -- Three of Storms
	[31900]="0:12:3:20:::1:0:", -- Two of Storms
	[31901]="0:12:3:20:::1:0:", -- Ace of Furies
	[31902]="0:12:3:20:::1:0:", -- Eight of Furies
	[31903]="0:12:3:20:::1:0:", -- Five of Furies
	[31904]="0:12:3:20:::1:0:", -- Four of Furies
	[31905]="0:12:3:20:::1:0:", -- Seven of Furies
	[31906]="0:12:3:20:::1:0:", -- Six of Furies
	[31907]="0:12:4:1:::1:0:", -- Furies Deck
	[31908]="0:12:3:20:::1:0:", -- Three of Furies
	[31909]="0:12:3:20:::1:0:", -- Two of Furies
	[31910]="0:12:3:20:::1:0:", -- Ace of Lunacy
	[31911]="0:12:3:20:::1:0:", -- Eight of Lunacy
	[31912]="0:12:3:20:::1:0:", -- Five of Lunacy
	[31913]="0:12:3:20:::1:0:", -- Four of Lunacy
	[31914]="0:12:4:1:::1:0:", -- Lunacy Deck
	[31915]="0:12:3:20:::1:0:", -- Seven of Lunacy
	[31916]="0:12:3:20:::1:0:", -- Six of Lunacy
	[31917]="0:12:3:20:::1:0:", -- Three of Lunacy
	[31918]="0:12:3:20:::1:0:", -- Two of Lunacy
	[31919]="0:4:4:1:Ring::1:0:", -- Nexus-Prince's Ring of Balance
	[31920]="0:4:4:1:Ring::1:0:", -- Shaffar's Band of Brutality
	[31921]="0:4:4:1:Ring::1:0:", -- Yor's Collapsing Band
	[31922]="0:4:4:1:Ring::1:0:", -- Ring of Conflict Survival
	[31923]="0:4:4:1:Ring::1:0:", -- Band of the Crystalline Void
	[31924]="0:4:4:1:Ring::1:0:", -- Yor's Revenge
	[31925]="0:4:3:1:Ring::1:0:", -- Fiery Band
	[31926]="0:4:3:1:Ring::1:0:", -- Frigid Band
	[31927]="0:4:3:1:Ring::1:0:", -- Living Band
	[31928]="0:4:3:1:Ring::1:0:", -- Dark Band
	[31929]="0:4:3:1:Ring::1:0:", -- Enigmatic Band
	[31935]="0:4:3:1:Cloak::1:0:", -- Frigid Cloak
	[31936]="0:4:3:1:Cloak::1:0:", -- Fiery Cloak
	[31937]="0:4:3:1:Cloak::1:0:", -- Living Cloak
	[31938]="0:4:3:1:Cloak::1:0:", -- Enigmatic Cloak
	[31939]="0:4:3:1:Cloak::1:0:", -- Dark Cloak
	[31940]="0:4:3:1:Amulet::1:0:", -- Ethereum Torque
	[31941]="0:12:2:50:::1:0:", -- Mark of the Nexus-King
	[31942]="0:4:3:1:Cloak::1:0:", -- Deathwing Brood Cloak
	[31943]="0:4:3:1:Ring::1:0:", -- Ethereum Band
	[31944]="0:15:0:20:Junk::1:0:", -- Demonic Capacitor
	[31945]="0:15:0:20:Junk::1:0:", -- Shadow Circuit
	[31946]="0:12:1:1:::1:0:", -- Ashtongue Cowl
	[31949]="5000:6:3:1000:Arrow::200:0:17904,25195,25196,29493", -- Warden's Arrow
	[31950]="0:12:1:15:::1:0:", -- Bogblossom
	[31951]="0:15:1:1:Junk::1:0:", -- Toy Dragon
	[31952]="0:15:2:1:Junk::1:0:", -- Khorium Lockbox
	[31953]="0:12:1:1:::1:0:", -- Ward of Waking
	[31955]="0:15:1:1:Junk::1:0:", -- Arelion's Knapsack
	[31956]="0:13:1:1:::1:0:", -- Salvaged Ethereum Prison Key
	[31957]="0:15:2:100:Junk::1:0:", -- Ethereum Prisoner I.D. Tag
	[31958]="0:2:4:1:OneHandMace::1:0:", -- Merciless Gladiator's Bonecracker
	[31959]="0:2:4:1:TwoHandMace::1:0:", -- Merciless Gladiator's Bonegrinder
	[31960]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Chain Armor
	[31961]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Chain Gauntlets
	[31962]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Chain Helm
	[31963]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Chain Leggings
	[31964]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Chain Spaulders
	[31965]="0:2:4:1:OneHandAxe::1:0:", -- Merciless Gladiator's Cleaver
	[31966]="0:2:4:1:TwoHandAxe::1:0:", -- Merciless Gladiator's Decapitator
	[31967]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Dragonhide Gloves
	[31968]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Dragonhide Helm
	[31969]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Dragonhide Legguards
	[31971]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Dragonhide Spaulders
	[31972]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Dragonhide Tunic
	[31973]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Dreadweave Gloves
	[31974]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Dreadweave Hood
	[31975]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Dreadweave Leggings
	[31976]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Dreadweave Mantle
	[31977]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Dreadweave Robe
	[31978]="0:4:4:1:OffHandFrill::1:0:", -- Merciless Gladiator's Endgame
	[31979]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Felweave Amice
	[31980]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Felweave Cowl
	[31981]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Felweave Handguards
	[31982]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Felweave Raiment
	[31983]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Felweave Trousers
	[31984]="0:2:4:1:TwoHandSword::1:0:", -- Merciless Gladiator's Greatsword
	[31985]="0:2:4:1:OneHandAxe::1:0:", -- Merciless Gladiator's Hacker
	[31986]="0:2:4:1:Crossbow::1:0:", -- Merciless Gladiator's Crossbow of the Phoenix
	[31987]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Kodohide Gloves
	[31988]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Kodohide Helm
	[31989]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Kodohide Legguards
	[31990]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Kodohide Spaulders
	[31991]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Kodohide Tunic
	[31992]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Lamellar Chestpiece
	[31993]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Lamellar Gauntlets
	[31994]="0:13:1:1:::1:0:", -- Ethereum Key Tablet - Alpha
	[31995]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Lamellar Legguards
	[31996]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Lamellar Shoulders
	[31997]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Lamellar Helm
	[31998]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Leather Gloves
	[31999]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Leather Helm
	[32000]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Leather Legguards
	[32001]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Leather Spaulders
	[32002]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Leather Tunic
	[32003]="0:2:4:1:FistWeapon::1:0:", -- Merciless Gladiator's Left Ripper
	[32004]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Linked Armor
	[32005]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Linked Gauntlets
	[32006]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Linked Helm
	[32007]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Linked Leggings
	[32008]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Linked Spaulders
	[32009]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Mail Armor
	[32010]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Mail Gauntlets
	[32011]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Mail Helm
	[32012]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Mail Leggings
	[32013]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Mail Spaulders
	[32014]="0:2:4:1:TwoHandMace::1:0:", -- Merciless Gladiator's Maul
	[32015]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Mooncloth Gloves
	[32016]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Mooncloth Hood
	[32017]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Mooncloth Leggings
	[32018]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Mooncloth Mantle
	[32019]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Mooncloth Robe
	[32020]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Ornamented Chestguard
	[32021]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Ornamented Gloves
	[32022]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Ornamented Headcover
	[32023]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Ornamented Legplates
	[32024]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Ornamented Spaulders
	[32025]="0:2:4:1:Polearm::1:0:", -- Merciless Gladiator's Painsaw
	[32026]="0:2:4:1:OneHandMace::1:0:", -- Merciless Gladiator's Pummeler
	[32027]="0:2:4:1:OneHandSword::1:0:", -- Merciless Gladiator's Quickblade
	[32028]="0:2:4:1:FistWeapon::1:0:", -- Merciless Gladiator's Right Ripper
	[32029]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Ringmail Armor
	[32030]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Ringmail Gauntlets
	[32031]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Ringmail Helm
	[32032]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Ringmail Leggings
	[32033]="0:4:4:1:Mail::1:0:26091,26092", -- Merciless Gladiator's Ringmail Spaulders
	[32034]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Satin Gloves
	[32035]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Satin Hood
	[32036]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Satin Leggings
	[32037]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Satin Mantle
	[32038]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Satin Robe
	[32039]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Scaled Chestpiece
	[32040]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Scaled Gauntlets
	[32041]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Scaled Helm
	[32042]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Scaled Legguards
	[32043]="0:4:4:1:Plate::1:0:26091,26092", -- Merciless Gladiator's Scaled Shoulders
	[32044]="0:2:4:1:Dagger::1:0:", -- Merciless Gladiator's Shanker
	[32045]="0:4:4:1:Shield::1:0:", -- Merciless Gladiator's Shield Wall
	[32046]="0:2:4:1:Dagger::1:0:", -- Merciless Gladiator's Shiv
	[32047]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Silk Amice
	[32048]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Silk Cowl
	[32049]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Silk Handguards
	[32050]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Silk Raiment
	[32051]="0:4:4:1:Cloth::1:0:26091,26092", -- Merciless Gladiator's Silk Trousers
	[32052]="0:2:4:1:OneHandSword::1:0:", -- Merciless Gladiator's Slicer
	[32053]="0:2:4:1:Dagger::1:0:", -- Merciless Gladiator's Spellblade
	[32054]="0:2:4:1:Thrown::1:0:", -- Merciless Gladiator's War Edge
	[32055]="0:2:4:1:Stave::1:0:", -- Merciless Gladiator's War Staff
	[32056]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Wyrmhide Gloves
	[32057]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Wyrmhide Helm
	[32058]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Wyrmhide Legguards
	[32059]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Wyrmhide Spaulders
	[32060]="0:4:4:1:Leather::1:0:26091,26092", -- Merciless Gladiator's Wyrmhide Tunic
	[32061]="0:12:1:1:::1:0:", -- Evidence from Alpha
	[32062]="0:0:1:20:Elixir::1:0:", -- Elixir of Major Fortitude
	[32063]="0:0:1:20:Elixir::1:0:", -- Earthen Elixir
	[32064]="0:15:2:1:Junk::1:0:", -- Protectorate Treasure Cache
	[32067]="0:0:1:20:Elixir::1:0:", -- Elixir of Draenic Wisdom
	[32068]="0:0:1:20:Elixir::1:0:", -- Elixir of Ironskin
	[32069]="0:13:1:1:::1:0:", -- Mana-Tombs Stasis Chamber Key
	[32070]="40000:9:1:1:Alchemy::1:0:17904", -- Recipe: Earthen Elixir
	[32071]="0:9:1:1:Alchemy::1:0:18821,18822", -- Recipe: Elixir of Ironskin
	[32072]="0:4:4:1:Plate::1:0:", -- Gauntlets of Dissension
	[32073]="0:4:4:1:Plate::1:0:", -- Spaulders of Dementia
	[32074]="0:12:1:1:::1:0:", -- Relics of Aviana
	[32076]="0:4:4:1:Mail::1:0:", -- Handguards of the Steady
	[32077]="0:4:4:1:Mail::1:0:", -- Wrath Infused Gauntlets
	[32078]="0:4:4:1:Mail::1:0:", -- Pauldrons of Wild Magic
	[32079]="0:13:2:50:::1:0:", -- Shaffar's Stasis Chamber Key
	[32080]="0:4:4:1:Leather::1:0:", -- Mantle of Shadowy Embrace
	[32081]="0:4:4:1:Ring::1:0:", -- Eye of the Stalker
	[32082]="0:4:4:1:Shield::1:0:", -- The Fel Barrier
	[32083]="0:4:4:1:Plate::1:0:18525", -- Faceguard of Determination
	[32084]="0:4:4:1:Plate::1:0:18525", -- Helmet of the Steadfast Champion
	[32085]="0:4:4:1:Mail::1:0:18525", -- Warpstalker Helm
	[32086]="0:4:4:1:Mail::1:0:18525", -- Storm Master's Helmet
	[32087]="0:4:4:1:Leather::1:0:18525", -- Mask of the Deceiver
	[32088]="0:4:4:1:Leather::1:0:18525", -- Cowl of Beastly Rage
	[32089]="0:4:4:1:Cloth::1:0:18525", -- Mana-Binders Cowl
	[32090]="0:4:4:1:Cloth::1:0:18525", -- Cowl of Naaru Blessings
	[32092]="0:13:3:1:::1:0:", -- The Eye of Haramad
	[32193]="0:3:4:1:GemRed::1:0:", -- Bold Crimson Spinel
	[32194]="0:3:4:1:GemRed::1:0:", -- Delicate Crimson Spinel
	[32195]="0:3:4:1:GemRed::1:0:", -- Teardrop Crimson Spinel
	[32196]="0:3:4:1:GemRed::1:0:", -- Runed Crimson Spinel
	[32197]="0:3:4:1:GemRed::1:0:", -- Bright Crimson Spinel
	[32198]="0:3:4:1:GemRed::1:0:", -- Subtle Crimson Spinel
	[32199]="0:3:4:1:GemRed::1:0:", -- Flashing Crimson Spinel
	[32200]="0:3:4:1:GemBlue::1:0:", -- Solid Empyrean Sapphire
	[32201]="0:3:4:1:GemBlue::1:0:", -- Sparkling Empyrean Sapphire
	[32202]="0:3:4:1:GemBlue::1:0:", -- Lustrous Empyrean Sapphire
	[32203]="0:3:4:1:GemBlue::1:0:", -- Stormy Empyrean Sapphire
	[32204]="0:3:4:1:GemYellow::1:0:", -- Brilliant Lionseye
	[32205]="0:3:4:1:GemYellow::1:0:", -- Smooth Lionseye
	[32206]="0:3:4:1:GemYellow::1:0:", -- Rigid Lionseye
	[32207]="0:3:4:1:GemYellow::1:0:", -- Gleaming Lionseye
	[32208]="0:3:4:1:GemYellow::1:0:", -- Thick Lionseye
	[32209]="0:3:4:1:GemYellow::1:0:", -- Mystic Lionseye
	[32210]="0:3:4:1:GemYellow::1:0:", -- Great Lionseye
	[32211]="0:3:4:1:GemPurple::1:0:", -- Sovereign Shadowsong Amethyst
	[32212]="0:3:4:1:GemPurple::1:0:", -- Shifting Shadowsong Amethyst
	[32213]="0:3:4:1:GemPurple::1:0:", -- Balanced Shadowsong Amethyst
	[32214]="0:3:4:1:GemPurple::1:0:", -- Infused Shadowsong Amethyst
	[32215]="0:3:4:1:GemPurple::1:0:", -- Glowing Shadowsong Amethyst
	[32216]="0:3:4:1:GemPurple::1:0:", -- Royal Shadowsong Amethyst
	[32217]="0:3:4:1:GemOrange::1:0:", -- Inscribed Pyrestone
	[32218]="0:3:4:1:GemOrange::1:0:", -- Potent Pyrestone
	[32219]="0:3:4:1:GemOrange::1:0:", -- Luminous Pyrestone
	[32220]="0:3:4:1:GemOrange::1:0:", -- Glinting Pyrestone
	[32221]="0:3:4:1:GemOrange::1:0:", -- Veiled Pyrestone
	[32222]="0:3:4:1:GemOrange::1:0:", -- Wicked Pyrestone
	[32223]="0:3:4:1:GemGreen::1:0:", -- Enduring Seaspray Emerald
	[32224]="0:3:4:1:GemGreen::1:0:", -- Radiant Seaspray Emerald
	[32225]="0:3:4:1:GemGreen::1:0:", -- Dazzling Seaspray Emerald
	[32226]="0:3:4:1:GemGreen::1:0:", -- Jagged Seaspray Emerald
	[32227]="0:3:4:20:GemRed:755:1:0:25950,27666", -- Crimson Spinel
	[32228]="0:3:4:20:GemBlue:755:1:0:25950,27666", -- Empyrean Sapphire
	[32229]="0:3:4:20:GemYellow:755:1:0:25950,27666", -- Lionseye
	[32230]="0:3:4:20:GemPurple:755:1:0:25950,27666", -- Shadowsong Amethyst
	[32231]="0:3:4:20:GemOrange:755:1:0:25950,27666", -- Pyrestone
	[32232]="0:4:4:1:Plate::1:0:", -- Eternium Shell Bracers
	[32233]="5000:15:3:1:Companion::1:0:23710,24495,27478,27489", -- Wolpertinger's Tankard
	[32234]="0:4:4:1:Mail::1:0:", -- Fists of Mukoa
	[32235]="0:4:4:1:Leather::1:0:", -- Cursed Vision of Sargeras
	[32236]="0:2:4:1:OneHandAxe::1:0:", -- Rising Tide
	[32237]="0:2:4:1:Dagger::1:0:", -- The Maelstrom's Fury
	[32238]="0:4:4:1:Ring::1:0:", -- Ring of Calming Waves
	[32239]="0:4:4:1:Cloth::1:0:", -- Slippers of the Seacaller
	[32240]="0:4:4:1:Leather::1:0:", -- Guise of the Tidal Lurker
	[32241]="0:4:4:1:Mail::1:0:", -- Helm of Soothing Currents
	[32242]="0:4:4:1:Mail::1:0:", -- Boots of Oceanic Fury
	[32243]="0:4:4:1:Plate::1:0:", -- Pearl Inlaid Boots
	[32244]="0:12:1:1:::1:0:", -- Seer's Stone
	[32245]="0:4:4:1:Plate::1:0:", -- Tide-stomper's Greaves
	[32247]="0:4:4:1:Ring::1:0:", -- Ring of Captured Storms
	[32248]="0:2:4:1:Polearm::1:0:", -- Halberd of Desolation
	[32249]="0:3:4:20:GemGreen:755:1:0:25950,27666", -- Seaspray Emerald
	[32250]="0:4:4:1:Plate::1:0:", -- Pauldrons of Abyssal Fury
	[32251]="0:4:4:1:Mail::1:0:", -- Wraps of Precise Flight
	[32252]="0:4:4:1:Leather::1:0:", -- Nether Shadow Tunic
	[32253]="0:2:4:1:Crossbow::1:0:", -- Legionkiller
	[32254]="0:2:4:1:OneHandAxe::1:0:", -- The Brutalizer
	[32255]="0:4:4:1:Shield::1:0:", -- Felstone Bulwark
	[32256]="0:4:4:1:Cloth::1:0:", -- Waistwrap of Infinity
	[32257]="0:4:4:1:Idol::1:0:", -- Idol of the White Stag
	[32258]="0:4:4:1:Mail::1:0:", -- Naturalist's Preserving Cinch
	[32259]="0:4:4:1:Mail::1:0:", -- Bands of the Coming Storm
	[32260]="0:4:4:1:Amulet::1:0:", -- Choker of Endless Nightmares
	[32261]="0:4:4:1:Ring::1:0:", -- Band of the Abyssal Lord
	[32262]="0:2:4:1:OneHandMace::1:0:", -- Syphon of the Nathrezim
	[32263]="0:4:4:1:Plate::1:0:", -- Praetorian's Legguards
	[32264]="0:4:4:1:Mail::1:0:", -- Shoulders of the Hidden Predator
	[32265]="0:4:4:1:Leather::1:0:", -- Shadow-walker's Cord
	[32266]="0:4:4:1:Ring::1:0:", -- Ring of Deceitful Intent
	[32267]="0:4:4:1:Plate::1:0:", -- Boots of the Resilient
	[32268]="0:4:4:1:Plate::1:0:", -- Myrmidon's Treads
	[32269]="0:2:4:1:Dagger::1:0:", -- Messenger of Fate
	[32270]="0:4:4:1:Cloth::1:0:", -- Focused Mana Bindings
	[32271]="0:4:4:1:Leather::1:0:", -- Kilt of Immortal Nature
	[32273]="0:4:4:1:Cloth::1:0:", -- Amice of Brilliant Light
	[32274]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Bold Crimson Spinel
	[32275]="0:4:4:1:Mail::1:0:", -- Spiritwalker Gauntlets
	[32276]="0:4:4:1:Mail::1:0:", -- Flashfire Girdle
	[32277]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Delicate Crimson Spinel
	[32278]="0:4:4:1:Plate::1:0:", -- Grips of Silent Justice
	[32279]="0:4:4:1:Plate::1:0:", -- The Seeker's Wristguards
	[32280]="0:4:4:1:Plate::1:0:", -- Gauntlets of Enforcement
	[32281]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Teardrop Crimson Spinel
	[32282]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Runed Crimson Spinel
	[32283]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Bright Crimson Spinel
	[32284]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Subtle Crimson Spinel
	[32285]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Flashing Crimson Spinel
	[32286]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Solid Empyrean Sapphire
	[32287]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Sparkling Empyrean Sapphire
	[32288]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Lustrous Empyrean Sapphire
	[32289]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Stormy Empyrean Sapphire
	[32290]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Brilliant Lionseye
	[32291]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Smooth Lionseye
	[32292]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Rigid Lionseye
	[32293]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Gleaming Lionseye
	[32294]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Thick Lionseye
	[32295]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Mystic Lionseye
	[32296]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Great Lionseye
	[32297]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Sovereign Shadowsong Amethyst
	[32298]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Shifting Shadowsong Amethyst
	[32299]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Balanced Shadowsong Amethyst
	[32300]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Infused Shadowsong Amethyst
	[32301]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Glowing Shadowsong Amethyst
	[32302]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Royal Shadowsong Amethyst
	[32303]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Inscribed Pyrestone
	[32304]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Potent Pyrestone
	[32305]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Luminous Pyrestone
	[32306]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Glinting Pyrestone
	[32307]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Veiled Pyrestone
	[32308]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Wicked Pyrestone
	[32309]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Enduring Seaspray Emerald
	[32310]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Radiant Seaspray Emerald
	[32311]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Dazzling Seaspray Emerald
	[32312]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Jagged Seaspray Emerald
	[32313]="0:12:1:10:::1:0:", -- Raven Stone
	[32314]="2000000:15:4:1:FlyingMount::1:0:23367", -- Green Riding Nether Ray
	[32315]="0:12:1:1:::1:0:", -- Cenarion Sparrowhawk Whistle
	[32316]="2000000:15:4:1:FlyingMount::1:0:23367", -- Purple Riding Nether Ray
	[32317]="2000000:15:4:1:FlyingMount::1:0:23367", -- Red Riding Nether Ray
	[32318]="2000000:15:4:1:FlyingMount::1:0:23367", -- Silver Riding Nether Ray
	[32319]="2000000:15:4:1:FlyingMount::1:0:23367", -- Blue Riding Nether Ray
	[32320]="0:12:1:1:::1:0:", -- Captive Sparrowhawk
	[32321]="0:12:1:1:::1:0:", -- Sparrowhawk Net
	[32323]="0:4:4:1:Cloak::1:0:", -- Shadowmoon Destroyer's Drape
	[32324]="0:4:4:1:Leather::1:0:", -- Insidious Bands
	[32325]="0:2:4:1:Gun::1:0:", -- Rifle of the Stoic Guardian
	[32326]="0:2:4:1:Thrown::1:0:", -- Twisted Blades of Zarak
	[32327]="0:4:4:1:Cloth::1:0:", -- Robe of the Shadow Council
	[32328]="0:4:4:1:Leather::1:0:", -- Botanist's Gloves of Growth
	[32329]="0:4:4:1:Cloth::1:0:", -- Cowl of Benevolence
	[32330]="0:4:4:1:Totem::1:0:", -- Totem of Ancestral Guidance
	[32331]="0:4:4:1:Cloak::1:0:", -- Cloak of the Illidari Council
	[32332]="0:2:4:1:TwoHandMace::1:0:", -- Torch of the Damned
	[32333]="0:4:4:1:Plate::1:0:", -- Girdle of Stability
	[32334]="0:4:4:1:Mail::1:0:", -- Vest of Mounting Assault
	[32335]="0:4:4:1:Ring::1:0:", -- Unstoppable Aggressor's Ring
	[32336]="0:2:4:1:Bow::1:0:", -- Black Bow of the Betrayer
	[32337]="0:4:4:1:Cloak::1:0:", -- Shroud of Forgiveness
	[32338]="0:4:4:1:Cloth::1:0:", -- Blood-cursed Shoulderpads
	[32339]="0:4:4:1:Leather::1:0:", -- Belt of Primal Majesty
	[32340]="0:4:4:1:Cloth::1:0:", -- Garments of Temperance
	[32341]="0:4:4:1:Plate::1:0:", -- Leggings of Divine Retribution
	[32342]="0:4:4:1:Plate::1:0:", -- Girdle of Mighty Resolve
	[32343]="0:2:4:1:Wand::1:0:", -- Wand of Prismatic Focus
	[32344]="0:2:4:1:Stave::1:0:", -- Staff of Immaculate Recovery
	[32345]="0:4:4:1:Plate::1:0:", -- Dreadboots of the Legion
	[32346]="0:4:4:1:Mail::1:0:", -- Boneweave Girdle
	[32347]="0:4:4:1:Leather::1:0:", -- Grips of Damnation
	[32348]="0:2:4:1:TwoHandAxe::1:0:", -- Soul Cleaver
	[32349]="0:4:4:1:Amulet::1:0:", -- Translucent Spellthread Necklace
	[32350]="0:4:4:1:OffHandFrill::1:0:", -- Touch of Inspiration
	[32351]="0:4:4:1:Leather::1:0:", -- Elunite Empowered Bracers
	[32352]="0:4:4:1:Leather::1:0:", -- Naturewarden's Treads
	[32353]="0:4:4:1:Cloth::1:0:", -- Gloves of Unfailing Faith
	[32354]="0:4:4:1:Plate::1:0:", -- Crown of Empowered Fate
	[32355]="0:12:1:1:::1:0:", -- Essence of the Eagle
	[32356]="0:12:1:1:::1:0:", -- Essence of the Hawk
	[32357]="0:12:1:1:::1:0:", -- Essence of the Falcon
	[32358]="0:12:1:1:::1:0:", -- Vim'gol's Vile Grimoire
	[32359]="0:12:1:1:::1:0:", -- Arthorn's Package
	[32361]="0:4:4:1:OffHandFrill::1:0:", -- Blind-Seers Icon
	[32362]="0:4:4:1:Amulet::1:0:", -- Pendant of Titans
	[32363]="0:2:4:1:Wand::1:0:", -- Naaru-Blessed Life Rod
	[32364]="0:12:1:1:::1:0:", -- Southfury Moonstone
	[32365]="0:4:4:1:Plate::1:0:", -- Heartshatter Breastplate
	[32366]="0:4:4:1:Leather::1:0:", -- Shadowmaster's Boots
	[32367]="0:4:4:1:Cloth::1:0:", -- Leggings of Devastation
	[32368]="0:4:4:1:Libram::1:0:", -- Tome of the Lightbringer
	[32369]="0:2:4:1:OneHandSword::1:0:", -- Blade of Savagery
	[32370]="0:4:4:1:Amulet::1:0:", -- Nadina's Pendant of Purity
	[32373]="0:4:4:1:Plate::1:0:", -- Helm of the Illidari Shatterer
	[32374]="183948:2:4:1:Stave::1:0:", -- Zhar'doom, Greatstaff of the Devourer
	[32375]="0:4:4:1:Shield::1:0:", -- Bulwark of Azzinoth
	[32376]="0:4:4:1:Mail::1:0:", -- Forest Prowler's Helm
	[32377]="0:4:4:1:Leather::1:0:", -- Mantle of Darkness
	[32378]="0:2:2:1:Thrown::1:0:", -- Silver Star
	[32379]="0:12:1:1:::1:0:", -- Grulloc's Dragon Skull
	[32380]="0:12:1:1:::1:0:", -- Maggoc's Treasure Chest
	[32381]="16000:9:1:1:Engineering::1:1:11185,19661", -- Schematic: Fused Wiring
	[32382]="0:12:1:1:::1:0:", -- Slaag's Standard
	[32383]="0:12:1:1:::1:0:", -- Skulloc's Soul
	[32385]="0:12:4:1:::1:0:", -- Magtheridon's Head
	[32386]="0:12:4:1:::1:0:", -- Magtheridon's Head
	[32387]="0:4:3:1:Idol::1:0:", -- Idol of the Raven Goddess
	[32388]="0:12:1:100:::1:0:", -- Shadow Dust
	[32389]="0:4:4:1:Cloth::1:0:", -- Soulguard Leggings
	[32390]="0:4:4:1:Cloth::1:0:", -- Soulguard Girdle
	[32391]="0:4:4:1:Cloth::1:0:", -- Soulguard Slippers
	[32392]="0:4:4:1:Cloth::1:0:", -- Soulguard Bracers
	[32393]="0:4:4:1:Leather::1:0:", -- Redeemed Soul Cinch
	[32394]="0:4:4:1:Leather::1:0:", -- Redeemed Soul Moccasins
	[32395]="0:4:4:1:Leather::1:0:", -- Redeemed Soul Wristguards
	[32396]="0:4:4:1:Leather::1:0:", -- Redeemed Soul Legguards
	[32397]="0:4:4:1:Mail::1:0:", -- Waistguard of Shackled Souls
	[32398]="0:4:4:1:Mail::1:0:", -- Boots of Shackled Souls
	[32399]="0:4:4:1:Mail::1:0:", -- Bracers of Shackled Souls
	[32400]="0:4:4:1:Mail::1:0:", -- Greaves of Shackled Souls
	[32401]="0:4:4:1:Plate::1:0:", -- Shadesteel Girdle
	[32402]="0:4:4:1:Plate::1:0:", -- Shadesteel Sabots
	[32403]="0:4:4:1:Plate::1:0:", -- Shadesteel Bracers
	[32404]="0:4:4:1:Plate::1:0:", -- Shadesteel Greaves
	[32405]="0:12:4:1:::1:0:", -- Verdant Sphere
	[32406]="0:0:1:1:Consumable::1:0:", -- Skyguard Blasting Charges
	[32408]="0:0:1:5:Consumable::1:0:", -- Naj'entus Spine
	[32409]="0:3:3:1:GemMeta::1:0:", -- Relentless Earthstorm Diamond
	[32410]="0:3:3:1:GemMeta::1:0:", -- Thundering Skyfire Diamond
	[32411]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Thundering Skyfire Diamond
	[32412]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Relentless Earthstorm Diamond
	[32413]="0:7:1:20:Explosive::1:0:", -- Frost Grenade
	[32420]="0:4:4:1:Cloak::1:0:", -- Night's End
	[32423]="0:7:1:20:Part:202:1:0:", -- Icy Blasting Primers
	[32427]="0:15:1:250:Junk::1:0:", -- Netherwing Crystal
	[32428]="0:7:3:20:Other:164,165,197:1:0:", -- Heart of Darkness
	[32429]="80000:9:1:1:Leatherworking::1:0:23159", -- Pattern: Boots of Shackled Souls
	[32430]="80000:9:1:1:Leatherworking::1:0:23159", -- Pattern: Bracers of Shackled Souls
	[32431]="80000:9:1:1:Leatherworking::1:0:23159", -- Pattern: Greaves of Shackled Souls
	[32432]="80000:9:1:1:Leatherworking::1:0:23159", -- Pattern: Waistguard of Shackled Souls
	[32433]="80000:9:1:1:Leatherworking::1:0:23159", -- Pattern: Redeemed Soul Moccasins
	[32434]="80000:9:1:1:Leatherworking::1:0:23159", -- Pattern: Redeemed Soul Wristguards
	[32435]="80000:9:1:1:Leatherworking::1:0:23159", -- Pattern: Redeemed Soul Legguards
	[32436]="80000:9:1:1:Leatherworking::1:0:23159", -- Pattern: Redeemed Soul Cinch
	[32437]="80000:9:1:1:Tailoring::1:0:23159", -- Pattern: Soulguard Slippers
	[32438]="80000:9:1:1:Tailoring::1:0:23159", -- Pattern: Soulguard Bracers
	[32439]="80000:9:1:1:Tailoring::1:0:23159", -- Pattern: Soulguard Leggings
	[32440]="80000:9:1:1:Tailoring::1:0:23159", -- Pattern: Soulguard Girdle
	[32441]="80000:9:1:1:Blacksmithing::1:0:23159", -- Plans: Shadesteel Sabots
	[32442]="80000:9:1:1:Blacksmithing::1:0:23159", -- Plans: Shadesteel Bracers
	[32443]="80000:9:1:1:Blacksmithing::1:0:23159", -- Plans: Shadesteel Greaves
	[32444]="80000:9:1:1:Blacksmithing::1:0:23159", -- Plans: Shadesteel Girdle
	[32445]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,23367,28776", -- Skyguard Tabard
	[32446]="0:12:1:20:::1:0:", -- Elixir of Shadows
	[32447]="80000:9:1:1:Tailoring::1:0:23159", -- Pattern: Night's End
	[32449]="0:13:1:1:::1:0:", -- Essence-Infused Moonstone
	[32450]="0:2:4:1:OneHandMace::1:0:", -- Gladiator's Gavel
	[32451]="0:2:4:1:OneHandMace::1:0:", -- Gladiator's Salvation
	[32452]="0:4:4:1:OffHandFrill::1:0:", -- Gladiator's Reprieve
	[32453]="10000:0:1:20:FoodDrink::20:0:12781,12793", -- Star's Tears
	[32454]="0:15:1:1:Junk::1:0:", -- Arthorn's Research
	[32455]="1200:0:1:20:FoodDrink::5:0:12781,12793", -- Star's Lament
	[32456]="0:12:1:1:::1:0:", -- Skyguard Bombs
	[32458]="0:15:4:1:FlyingMount::1:0:", -- Ashes of Al'ar
	[32459]="0:12:1:1:::1:0:", -- Time-Phased Phylactery
	[32461]="0:4:4:1:Plate:202:1:0:", -- Furious Gizmatic Goggles
	[32462]="0:15:1:1:Junk::1:0:", -- Morthis' Materials
	[32464]="0:12:1:20:::1:0:", -- Nethercite Ore
	[32467]="0:12:1:1:::1:0:", -- Vim'gol's Grimoire
	[32468]="0:12:1:20:::1:0:", -- Netherdust Pollen
	[32469]="0:12:1:1:::1:0:", -- Illidari Service Papers
	[32470]="0:12:1:20:::1:0:", -- Nethermine Flayer Hide
	[32471]="0:2:4:1:Dagger::1:0:", -- Shard of Azzinoth
	[32472]="0:4:4:1:Plate:202:1:0:", -- Justicebringer 2000 Specs
	[32473]="0:4:4:1:Plate:202:1:0:", -- Tankatronic Goggles
	[32474]="0:4:4:1:Mail:202:1:0:", -- Surestrike Goggles v2.0
	[32475]="0:4:4:1:Mail:202:1:0:", -- Living Replicator Specs
	[32476]="0:4:4:1:Mail:202:1:0:", -- Gadgetstorm Goggles
	[32478]="0:4:4:1:Leather:202:1:0:", -- Deathblow X11 Goggles
	[32479]="0:4:4:1:Leather:202:1:0:", -- Wonderheal XT40 Shades
	[32480]="0:4:4:1:Leather:202:1:0:", -- Magnified Moon Specs
	[32481]="0:4:3:1:Trinket::1:0:", -- Charm of Swift Flight
	[32483]="0:4:4:1:Trinket::1:0:", -- The Skull of Gul'dan
	[32485]="288156:4:4:1:Trinket::1:0:23159", -- Ashtongue Talisman of Valor
	[32486]="288156:4:4:1:Trinket::1:0:23159", -- Ashtongue Talisman of Equilibrium
	[32487]="288156:4:4:1:Trinket::1:0:23159", -- Ashtongue Talisman of Swiftness
	[32488]="288156:4:4:1:Trinket::1:0:23159", -- Ashtongue Talisman of Insight
	[32489]="288156:4:4:1:Trinket::1:0:23159", -- Ashtongue Talisman of Zeal
	[32490]="288156:4:4:1:Trinket::1:0:23159", -- Ashtongue Talisman of Acumen
	[32491]="288156:4:4:1:Trinket::1:0:23159", -- Ashtongue Talisman of Vision
	[32492]="288156:4:4:1:Trinket::1:0:23159", -- Ashtongue Talisman of Lethality
	[32493]="288156:4:4:1:Trinket::1:0:23159", -- Ashtongue Talisman of Shadows
	[32494]="0:4:4:1:Cloth:202:1:0:", -- Destruction Holo-gogs
	[32495]="0:4:4:1:Cloth:202:1:0:", -- Powerheal 4000 Lens
	[32496]="0:4:4:1:Trinket::1:0:", -- Memento of Tyrande
	[32497]="0:4:4:1:Ring::1:0:", -- Stormrage Signet Ring
	[32498]="0:15:3:0:Companion::1:0:", -- Fortune Coin
	[32500]="0:2:4:1:OneHandMace::1:0:", -- Crystal Spire of Karabor
	[32501]="0:4:4:1:Trinket::1:0:", -- Shadowmoon Insignia
	[32502]="0:12:1:12:::1:0:", -- Fel Gland
	[32503]="0:12:1:1:::1:0:", -- Yarzill's Mutton
	[32505]="0:4:4:1:Trinket::1:0:", -- Madness of the Betrayer
	[32506]="0:15:2:20:Junk::1:0:", -- Netherwing Egg
	[32508]="0:4:3:1:Amulet::1:0:", -- Necklace of the Deep
	[32509]="0:12:1:10:::1:0:", -- Netherwing Relic
	[32510]="0:4:4:1:Mail::1:0:", -- Softstep Boots of Tracking
	[32512]="0:4:4:1:Plate::1:0:", -- Girdle of Lordaeron's Fallen
	[32513]="0:4:4:1:Cloth::1:0:", -- Wristbands of Divine Influence
	[32514]="0:4:3:1:Ring::1:0:", -- Skettis Band
	[32515]="0:4:4:1:Plate::1:0:", -- Wristguards of Determination
	[32516]="0:4:4:1:Cloth::1:0:", -- Wraps of Purification
	[32517]="0:4:4:1:Mail::1:0:", -- The Wavemender's Mantle
	[32518]="0:4:4:1:Leather::1:0:", -- Veil of Turning Leaves
	[32519]="0:4:4:1:Cloth::1:0:", -- Belt of Divine Guidance
	[32520]="0:4:3:1:OffHandFrill::1:0:", -- Manaforged Sphere
	[32521]="0:4:4:1:Plate::1:0:", -- Faceplate of the Impenetrable
	[32522]="0:4:3:1:Shield::1:0:", -- Demonic Bulwark
	[32523]="0:12:1:1:::1:0:", -- Ishaal's Almanac
	[32524]="0:4:4:1:Cloak::1:0:", -- Shroud of the Highborne
	[32525]="0:4:4:1:Cloth::1:0:", -- Cowl of the Illidari High Lord
	[32526]="0:4:4:1:Ring::1:0:", -- Band of Devastation
	[32527]="0:4:4:1:Ring::1:0:", -- Ring of Ancient Knowledge
	[32528]="0:4:4:1:Ring::1:0:", -- Blessed Band of Karabor
	[32529]="0:4:3:1:Plate::1:0:", -- Heretic's Gauntlets
	[32531]="0:4:3:1:Amulet::1:0:", -- Gezzarak's Fang
	[32532]="0:4:3:1:Leather::1:0:", -- Windrager's Coils
	[32533]="0:4:3:1:OffHandFrill::1:0:", -- Karrog's Shard
	[32534]="0:4:3:1:Trinket::1:0:", -- Brooch of the Immortal King
	[32535]="0:4:3:1:Ring::1:0:", -- Gift of the Talonpriests
	[32536]="0:2:3:1:OneHandMace::1:0:", -- Terokk's Gavel
	[32537]="0:2:3:1:OneHandMace::1:0:", -- Terokk's Gavel
	[32538]="137691:4:3:1:Cloak::1:0:23367", -- Skywitch's Drape
	[32539]="138166:4:3:1:Cloak::1:0:23367", -- Skyguard's Drape
	[32540]="0:4:4:1:Cloak::1:0:", -- Terokk's Might
	[32541]="0:4:4:1:Cloak::1:0:", -- Terokk's Wisdom
	[32542]="0:0:3:1:Consumable::1:0:", -- Imp in a Ball
	[32563]="0:0:0:20:Consumable::1:0:", -- Grilled Picnic Treat
	[32564]="0:12:1:1:::1:0:", -- Ishaal's Almanac
	[32566]="0:15:3:1:Junk::1:0:", -- Picnic Basket
	[32567]="0:12:1:10:::1:0:", -- Aether Ray Eye
	[32568]="0:4:4:1:Plate::1:0:", -- Swiftsteel Bracers
	[32569]="0:15:1:250:Junk::1:0:", -- Apexis Shard
	[32570]="0:4:4:1:Plate::1:0:", -- Swiftsteel Shoulders
	[32571]="0:4:4:1:Plate::1:0:", -- Dawnsteel Bracers
	[32572]="0:15:3:250:Junk::1:0:", -- Apexis Crystal
	[32573]="0:4:4:1:Plate::1:0:", -- Dawnsteel Shoulders
	[32574]="0:4:4:1:Mail::1:0:", -- Bindings of Lightning Reflexes
	[32575]="0:4:4:1:Mail::1:0:", -- Shoulders of Lightning Reflexes
	[32576]="0:0:1:20:Other::1:0:", -- Depleted Crystal Focus
	[32577]="0:4:4:1:Mail::1:0:", -- Living Earth Bindings
	[32578]="0:15:1:20:Junk::1:0:", -- Charged Crystal Focus
	[32579]="0:4:4:1:Mail::1:0:", -- Living Earth Shoulders
	[32580]="0:4:4:1:Leather::1:0:", -- Swiftstrike Bracers
	[32581]="0:4:4:1:Leather::1:0:", -- Swiftstrike Shoulders
	[32582]="0:4:4:1:Leather::1:0:", -- Bracers of Renewed Life
	[32583]="0:4:4:1:Leather::1:0:", -- Shoulderpads of Renewed Life
	[32584]="0:4:4:1:Cloth::1:0:", -- Swiftheal Wraps
	[32585]="0:4:4:1:Cloth::1:0:", -- Swiftheal Mantle
	[32586]="0:4:4:1:Cloth::1:0:", -- Bracers of Nimble Thought
	[32587]="0:4:4:1:Cloth::1:0:", -- Mantle of Nimble Thought
	[32588]="0:15:3:1:Companion::1:0:", -- Banana Charm
	[32589]="0:4:4:1:Amulet::1:0:", -- Hellfire-Encased Pendant
	[32590]="0:4:4:1:Cloak::1:0:", -- Nethervoid Cloak
	[32591]="0:4:4:1:Amulet::1:0:", -- Choker of Serrated Blades
	[32592]="0:4:4:1:Mail::1:0:", -- Chestguard of Relentless Storms
	[32593]="0:4:4:1:Leather::1:0:", -- Treads of the Den Mother
	[32596]="0:0:1:20:Flask::1:0:23243", -- Unstable Flask of the Elder
	[32597]="0:0:1:20:Flask::1:0:23243", -- Unstable Flask of the Soldier
	[32598]="0:0:1:20:Flask::1:0:", -- Unstable Flask of the Beast
	[32599]="0:0:1:20:Flask::1:0:23243", -- Unstable Flask of the Bandit
	[32600]="0:0:1:20:Flask::1:0:23243", -- Unstable Flask of the Physician
	[32601]="0:0:1:20:Flask::1:0:", -- Unstable Flask of the Sorcerer
	[32602]="0:0:1:1:Consumable::1:0:", -- Crystalforged Darkrune
	[32606]="0:4:4:1:Plate::1:0:", -- Girdle of the Lightbearer
	[32608]="0:4:4:1:Plate::1:0:", -- Pillager's Gauntlets
	[32609]="0:4:4:1:Cloth::1:0:", -- Boots of the Divine Light
	[32616]="0:15:3:1:Companion::1:0:", -- Egbert's Egg
	[32617]="0:15:3:1:Companion::1:0:", -- Sleepy Willy
	[32619]="0:12:1:1:::1:0:", -- Preserved Fruit
	[32620]="0:12:1:250:::1:0:", -- Time-Lost Scroll
	[32621]="0:12:1:1:::1:0:", -- Partially Digested Hand
	[32622]="0:15:3:1:Companion::1:0:", -- Elekk Training Collar
	[32623]="0:12:1:1:::1:0:", -- Bossi's Spare Parts
	[32624]="0:15:1:1:Junk::1:0:23245", -- Large Iron Metamorphosis Geode 
	[32625]="0:15:1:1:Junk::1:0:23245", -- Small Iron Metamorphosis Geode
	[32626]="0:15:1:1:Junk::1:0:", -- Large Copper Metamorphosis Geode
	[32627]="0:15:1:1:Junk::1:0:", -- Small Copper Metamorphosis Geode
	[32628]="0:15:1:1:Junk::1:0:23245", -- Large Silver Metamorphosis Geode
	[32629]="0:15:1:1:Junk::1:0:23245", -- Large Gold Metamorphosis Geode
	[32630]="0:15:1:1:Junk::1:0:23245", -- Small Gold Metamorphosis Geode
	[32631]="0:15:1:1:Junk::1:0:23245", -- Small Silver Metamorphosis Geode
	[32634]="0:3:3:1:GemPurple::1:0:23244", -- Unstable Amethyst
	[32635]="0:3:3:1:GemGreen::1:0:23244", -- Unstable Peridot
	[32636]="0:3:3:1:GemPurple::1:0:23244", -- Unstable Sapphire
	[32637]="0:3:3:1:GemOrange::1:0:23244", -- Unstable Citrine
	[32638]="0:3:3:1:GemOrange::1:0:23244", -- Unstable Topaz
	[32639]="0:3:3:1:GemGreen::1:0:23244", -- Unstable Talasite
	[32640]="0:3:3:1:GemMeta::1:0:23245", -- Potent Unstable Diamond
	[32641]="0:3:3:1:GemMeta::1:0:23245", -- Imbued Unstable Diamond
	[32643]="0:15:1:1:Junk::1:0:", -- Darkrune
	[32645]="0:2:4:1:Crossbow::1:0:23428", -- Crystalline Crossbow
	[32646]="0:12:1:1:::1:0:", -- Medallion of Karabor
	[32647]="0:4:4:1:Leather::1:0:23428", -- Shard-bound Bracers
	[32648]="0:4:4:1:Plate::1:0:23428", -- Vortex Walking Boots
	[32649]="0:4:4:1:Amulet::1:0:", -- Medallion of Karabor
	[32650]="0:2:3:1:Wand::1:0:23428", -- Cerulean Crystal Rod
	[32651]="0:4:4:1:OffHandFrill::1:0:23428", -- Crystal Orb of Enlightenment
	[32652]="0:4:3:1:Shield::1:0:23428", -- Ogri'la Aegis
	[32653]="0:4:3:1:Cloak::1:0:23428", -- Apexis Cloak
	[32654]="0:4:3:1:Trinket::1:0:23428", -- Crystalforged Trinket
	[32655]="0:4:4:1:Cloth::1:0:", -- Crystalweave Bracers
	[32656]="0:4:4:1:Mail::1:0:", -- Crystalhide Handwraps
	[32657]="0:15:1:1:CombatPet::1:0:", -- Arthorn's Sparrowhawk Whistle
	[32658]="0:4:3:1:Trinket::1:0:", -- Badge of Tenacity
	[32659]="0:2:3:1:Dagger::1:0:", -- Crystal-Infused Shiv
	[32660]="0:2:3:1:OneHandSword::1:0:", -- Crystalforged Sword
	[32661]="0:2:3:1:OneHandMace::1:0:", -- Apexis Crystal Mace
	[32662]="0:2:3:1:Stave::1:0:", -- Flaming Quartz Staff
	[32663]="0:2:3:1:TwoHandAxe::1:0:", -- Apexis Cleaver
	[32664]="0:4:3:1:Ring::1:0:", -- Dreamcrystal Band
	[32665]="0:4:3:1:Cloak::1:0:", -- Crystalweave Cape
	[32666]="0:12:1:1:::1:0:", -- Hardened Hide of Tyrantus
	[32667]="340:0:1:20:FoodDrink::1:0:23110", -- Bash Ale
	[32668]="6400:0:1:20:FoodDrink::5:0:23110", -- Dos Ogris
	[32670]="0:15:3:1:Junk::1:0:", -- Depleted Two-Handed Axe
	[32671]="0:15:3:1:Junk::1:0:", -- Depleted Mace
	[32672]="0:15:3:1:Junk::1:0:", -- Depleted Badge
	[32673]="0:15:3:1:Junk::1:0:", -- Depleted Dagger
	[32674]="0:15:3:1:Junk::1:0:", -- Depleted Sword
	[32675]="0:15:4:1:Junk::1:0:", -- Depleted Mail Gauntlets
	[32676]="0:15:4:1:Junk::1:0:", -- Depleted Cloth Bracers
	[32677]="0:15:3:1:Junk::1:0:", -- Depleted Cloak
	[32678]="0:15:3:1:Junk::1:0:", -- Depleted Ring
	[32679]="0:15:3:1:Junk::1:0:", -- Depleted Staff
	[32680]="0:12:1:1:::1:0:", -- Booterang
	[32681]="0:15:3:5:Junk::1:0:", -- Onyx Scale of Rivendark
	[32682]="0:15:3:5:Junk::1:0:", -- Obsidia Scale
	[32683]="0:15:3:5:Junk::1:0:", -- Jet Scale of Furywing
	[32684]="0:15:3:5:Junk::1:0:", -- Insidion's Ebony Scale
	[32685]="8000:0:1:20:FoodDrink::5:0:22266", -- Ogri'la Chicken Fingers
	[32686]="8000:0:1:20:FoodDrink::5:0:22266", -- Mingo's Fortune Giblets
	[32687]="0:12:1:1:::1:0:", -- Hazzik's Package
	[32688]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32689]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32690]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32691]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32692]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32693]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32694]="0:4:2:1:Trinket::1:0:", -- Overseer's Badge
	[32695]="0:4:3:1:Trinket::1:0:", -- Captain's Badge
	[32696]="0:12:1:1:::1:0:", -- Banishing Crystal
	[32697]="0:12:1:1:::1:0:", -- Apexis Guardian's Head
	[32698]="0:12:1:1:::1:0:", -- Wrangling Rope
	[32700]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32701]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32702]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32703]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32704]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32705]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32706]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32707]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32708]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32709]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32710]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32711]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32712]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32713]="0:15:1:20:Junk::1:0:", -- Bloodstained Fortune
	[32714]="0:15:0:5:Junk::1:0:", -- Splintered Spider Fang
	[32715]="0:12:2:20:::1:0:", -- Akkarai's Talons
	[32716]="0:12:2:20:::1:0:", -- Gezzarak's Claws
	[32717]="0:12:2:20:::1:0:", -- Karrog's Spine
	[32718]="0:12:2:20:::1:0:", -- Vakkiz's Scale
	[32720]="0:12:1:20:::1:0:", -- Time-Lost Offering
	[32721]="4500:0:1:20:FoodDrink::5:0:23367", -- Skyguard Rations
	[32722]="4000:0:1:20:FoodDrink::5:0:23367", -- Enriched Terocone Juice
	[32723]="0:12:1:15:::1:0:", -- Nethermine Cargo
	[32724]="0:15:1:1:Junk::1:0:", -- Sludge-covered Object
	[32725]="0:15:0:5:Junk::1:0:", -- Murkblood Miner's Pick
	[32726]="0:15:1:1:Junk::1:0:", -- Murkblood Escape Plans
	[32727]="0:15:0:5:Junk::1:0:", -- Vial of Tears
	[32728]="0:15:0:100:Junk::1:0:", -- Sludge
	[32732]="0:12:1:1:::1:0:", -- Dragon Teeth
	[32733]="0:12:1:1:::1:0:", -- Fel Whip
	[32734]="0:12:1:1:::1:0:", -- Hand of the Overseer
	[32735]="0:3:4:1:GemGreen::1:0:", -- Radiant Spencerite
	[32736]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Swiftsteel Bracers
	[32737]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Swiftsteel Shoulders
	[32738]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Dawnsteel Bracers
	[32739]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Dawnsteel Shoulders
	[32741]="0:12:1:1:::1:0:", -- Shabby Arakkoa Disguise
	[32742]="30000:12:1:1:::1:0:23363", -- Adversarial Bloodlines
	[32744]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Bracers of Renewed Life
	[32745]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Shoulderpads of Renewed Life
	[32746]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Swiftstrike Bracers
	[32747]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Swiftstrike Shoulders
	[32748]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Bindings of Lightning Reflexes
	[32749]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Shoulders of Lightning Reflexes
	[32750]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Living Earth Bindings
	[32751]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Living Earth Shoulders
	[32752]="0:9:4:1:Tailoring::1:0:", -- Pattern: Swiftheal Wraps
	[32753]="0:9:4:1:Tailoring::1:0:", -- Pattern: Swiftheal Mantle
	[32754]="0:9:4:1:Tailoring::1:0:", -- Pattern: Bracers of Nimble Thought
	[32755]="0:9:4:1:Tailoring::1:0:", -- Pattern: Mantle of Nimble Thought
	[32756]="0:2:4:1:Gun::1:0:", -- Gyro-Balanced Khorium Destroyer
	[32757]="0:4:4:1:Amulet::1:0:", -- Blessed Medallion of Karabor
	[32758]="10000:12:1:10:::1:0:22270", -- Brute Cologne
	[32759]="0:15:1:1:Junk::1:0:23245", -- Accelerator Module
	[32760]="0:6:4:200:Arrow::1:0:", -- The Macho Gnome's Arrow
	[32761]="0:6:4:200:Bullet::1:0:", -- The Sarge's Bullet
	[32762]="0:0:1:5:Potion::1:0:", -- Rulkster's Brain Juice
	[32763]="0:0:1:5:Potion::1:0:", -- Rulkster's Secret Sauce
	[32764]="0:0:1:5:Flask::1:0:", -- Flaskataur's Celestial Brew
	[32765]="0:0:1:5:Consumable::1:0:", -- Flaskataur's Tears
	[32766]="0:0:1:5:Flask::1:0:", -- Flaskataur's Flask of Flaskocity
	[32767]="0:0:1:5:Flask::1:0:", -- Flaskataur's Flask of Pretty Good Power
	[32768]="0:15:4:1:Mount::1:0:", -- Reins of the Raven Lord
	[32769]="0:4:3:1:Leather::1:0:", -- Belt of the Raven Lord
	[32770]="41230:4:4:1:Trinket::1:0:23367", -- Skyguard Silver Cross
	[32771]="41230:4:4:1:Trinket::1:0:23367", -- Airman's Ribbon of Gallantry
	[32772]="0:4:3:1:Ring::1:0:", -- Brilliant Pearl Band
	[32773]="0:13:2:50:::1:0:", -- Bash'ir's Skeleton Key
	[32774]="0:4:3:1:Ring::1:0:", -- The Black Pearl
	[32776]="0:4:3:1:Cloth::1:0:", -- Crown of the Sea Witch
	[32777]="0:15:1:1:Junk::1:0:", -- Kronk's Grab Bag
	[32778]="0:4:3:1:Plate::1:0:", -- Boots of Righteous Fortitude
	[32779]="0:4:3:1:Ring::1:0:", -- Band of Frigid Elements
	[32780]="0:2:3:1:Gun::1:0:", -- The Boomstick
	[32781]="0:2:3:1:Dagger::1:0:", -- Talon of Anzu
	[32782]="0:4:3:1:Trinket::1:0:", -- Time-Lost Figurine
	[32783]="0:0:1:20:Potion::1:0:23428", -- Blue Ogre Brew
	[32784]="0:0:1:20:Potion::1:0:23428", -- Red Ogre Brew
	[32785]="0:4:4:1:Mail::1:0:26089", -- Veteran's Chain Sabatons
	[32786]="0:4:4:1:Leather::1:0:26089", -- Veteran's Dragonhide Boots
	[32787]="0:4:4:1:Cloth::1:0:26089", -- Veteran's Dreadweave Stalkers
	[32788]="0:4:4:1:Leather::1:0:26089", -- Veteran's Kodohide Boots
	[32789]="0:4:4:1:Plate::1:0:26089", -- Veteran's Lamellar Greaves
	[32790]="0:4:4:1:Leather::1:0:26089", -- Veteran's Leather Boots
	[32791]="0:4:4:1:Mail::1:0:26089", -- Veteran's Linked Sabatons
	[32792]="0:4:4:1:Mail::1:0:26089", -- Veteran's Mail Sabatons
	[32793]="0:4:4:1:Plate::1:0:26089", -- Veteran's Plate Greaves
	[32794]="0:4:4:1:Plate::1:0:26089", -- Veteran's Scaled Greaves
	[32795]="0:4:4:1:Cloth::1:0:26089", -- Veteran's Silk Footguards
	[32796]="0:4:4:1:Leather::1:0:26089", -- Veteran's Wyrmhide Boots
	[32797]="0:4:4:1:Mail::1:0:26089", -- Veteran's Chain Girdle
	[32798]="0:4:4:1:Leather::1:0:26089", -- Veteran's Dragonhide Belt
	[32799]="0:4:4:1:Cloth::1:0:26089", -- Veteran's Dreadweave Belt
	[32800]="0:4:4:1:Leather::1:0:26089", -- Veteran's Kodohide Belt
	[32801]="0:4:4:1:Plate::1:0:26089", -- Veteran's Lamellar Belt
	[32802]="0:4:4:1:Leather::1:0:26089", -- Veteran's Leather Belt
	[32803]="0:4:4:1:Mail::1:0:26089", -- Veteran's Linked Girdle
	[32804]="0:4:4:1:Mail::1:0:26089", -- Veteran's Mail Girdle
	[32805]="0:4:4:1:Plate::1:0:26089", -- Veteran's Plate Belt
	[32806]="0:4:4:1:Plate::1:0:26089", -- Veteran's Scaled Belt
	[32807]="0:4:4:1:Cloth::1:0:26089", -- Veteran's Silk Belt
	[32808]="0:4:4:1:Leather::1:0:26089", -- Veteran's Wyrmhide Belt
	[32809]="0:4:4:1:Mail::1:0:26089", -- Veteran's Chain Bracers
	[32810]="0:4:4:1:Leather::1:0:26089", -- Veteran's Dragonhide Bracers
	[32811]="0:4:4:1:Cloth::1:0:26089", -- Veteran's Dreadweave Cuffs
	[32812]="0:4:4:1:Leather::1:0:26089", -- Veteran's Kodohide Bracers
	[32813]="0:4:4:1:Plate::1:0:26089", -- Veteran's Lamellar Bracers
	[32814]="0:4:4:1:Leather::1:0:26089", -- Veteran's Leather Bracers
	[32816]="0:4:4:1:Mail::1:0:26089", -- Veteran's Linked Bracers
	[32817]="0:4:4:1:Mail::1:0:26089", -- Veteran's Mail Bracers
	[32818]="0:4:4:1:Plate::1:0:26089", -- Veteran's Plate Bracers
	[32819]="0:4:4:1:Plate::1:0:26089", -- Veteran's Scaled Bracers
	[32820]="0:4:4:1:Cloth::1:0:26089", -- Veteran's Silk Cuffs
	[32821]="0:4:4:1:Leather::1:0:26089", -- Veteran's Wyrmhide Bracers
	[32822]="0:12:1:1:::1:0:", -- Flawless Arcane Essence
	[32823]="0:15:0:1:Junk::1:0:", -- Illidari Lord Balthas' Instructions
	[32824]="0:2:6:1:TwoHandSword::1:0:", -- Tigole's Trashbringer
	[32825]="0:12:1:1:::1:0:", -- Soul Cannon
	[32828]="0:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,23428,28776", -- Ogri'la Tabard
	[32829]="0:2:3:1:Polearm::1:0:", -- Windcharger's Lance
	[32830]="0:2:3:1:Stave::1:0:", -- Severin's Cane
	[32831]="0:2:3:1:Wand::1:0:", -- Jeweled Rod
	[32832]="0:2:3:1:Thrown::1:0:", -- Scout's Throwing Knives
	[32833]="0:3:2:1:GemPurple::1:0:", -- Purified Jaggal Pearl
	[32834]="0:12:1:1:::1:0:", -- Nether Ray Cage
	[32835]="0:15:1:1:Junk::1:0:", -- Ogri'la Care Package
	[32836]="0:3:3:1:GemPurple::1:0:", -- Purified Shadow Pearl
	[32837]="0:2:5:1:OneHandSword::1:0:", -- Warglaive of Azzinoth
	[32838]="0:2:5:1:OneHandSword::1:0:", -- Warglaive of Azzinoth
	[32839]="0:0:1:5:Other::1:0:", -- Cauldron of Major Arcane Protection
	[32840]="0:0:1:20:Potion::1:0:", -- Major Arcane Protection Potion
	[32842]="0:12:1:1:::1:0:", -- Dragonmaw Flare Gun
	[32843]="0:12:1:1:::1:0:", -- Scryer Medals
	[32844]="0:0:1:20:Potion::1:0:", -- Major Nature Protection Potion
	[32845]="0:0:1:20:Potion::1:0:", -- Major Shadow Protection Potion
	[32846]="0:0:1:20:Potion::1:0:", -- Major Fire Protection Potion
	[32847]="0:0:1:20:Potion::1:0:", -- Major Frost Protection Potion
	[32848]="0:0:1:1:Consumable::1:0:", -- Explosives Package
	[32849]="0:0:1:5:Other::1:0:", -- Cauldron of Major Fire Protection
	[32850]="0:0:1:5:Other::1:0:", -- Cauldron of Major Frost Protection
	[32851]="0:0:1:5:Other::1:0:", -- Cauldron of Major Nature Protection
	[32852]="0:0:1:5:Other::1:0:", -- Cauldron of Major Shadow Protection
	[32853]="0:12:1:1:::1:0:", -- Aldor Medals
	[32854]="0:2:4:1:TwoHandMace::1:0:", -- Hammer of Righteous Might
	[32857]="2000000:15:4:1:FlyingMount::1:0:23489", -- Reins of the Onyx Netherwing Drake
	[32858]="2000000:15:4:1:FlyingMount::1:0:23489", -- Reins of the Azure Netherwing Drake
	[32859]="2000000:15:4:1:FlyingMount::1:0:23489", -- Reins of the Cobalt Netherwing Drake
	[32860]="2000000:15:4:1:FlyingMount::1:0:23489", -- Reins of the Purple Netherwing Drake
	[32861]="2000000:15:4:1:FlyingMount::1:0:23489", -- Reins of the Veridian Netherwing Drake
	[32862]="2000000:15:4:1:FlyingMount::1:0:23489", -- Reins of the Violet Netherwing Drake
	[32863]="0:4:3:1:Trinket::1:0:", -- Skybreaker Whip
	[32864]="0:4:3:1:Trinket::1:0:", -- Commander's Badge
	[32865]="0:4:2:1:Leather::1:0:", -- Drake Tamer's Gloves
	[32866]="0:4:2:1:Plate::1:0:", -- Ascendant's Boots
	[32867]="0:4:2:1:Cloth::1:0:", -- Dragonmaw Augur's Cinch
	[32868]="0:4:2:1:Mail::1:0:", -- Skybreaker's Mantle
	[32869]="0:4:2:1:Leather::1:0:", -- Illidari Lord's Tunic
	[32870]="0:4:2:1:Mail::1:0:", -- Legguards of Contemplation
	[32871]="0:4:2:1:Plate::1:0:", -- Horns of the Illidari
	[32872]="0:2:2:1:Wand::1:0:", -- Illidari Rod of Discipline
	[32882]="5000:6:3:1000:Bullet::200:0:17585,25195,25196,29493", -- Hellfire Shot
	[32883]="5000:6:3:1000:Bullet::200:0:17657,25195,25196,29493", -- Felbane Slugs
	[32888]="0:15:0:1:Junk::1:0:", -- The Relics of Terokk
	[32895]="0:15:4:1:Junk::1:0:", -- Scroll of the Maelstrom
	[32896]="0:15:4:1:Junk::1:0:", -- Scroll of the Sun
	[32897]="0:15:2:250:Other::1:0:", -- Mark of the Illidari
	[32898]="0:0:1:20:Flask::1:0:23483,23484", -- Shattrath Flask of Fortification
	[32899]="0:0:1:20:Flask::1:0:23483,23484", -- Shattrath Flask of Mighty Restoration
	[32900]="0:0:1:20:Flask::1:0:23483,23484", -- Shattrath Flask of Supreme Power
	[32901]="0:0:1:20:Flask::1:0:23483,23484", -- Shattrath Flask of Relentless Assault
	[32902]="0:0:1:20:Potion::1:0:", -- Bottled Nethergon Energy
	[32903]="0:0:1:20:Potion::3:0:23373", -- Cenarion Mana Salve
	[32904]="0:0:1:20:Potion::3:0:23373", -- Cenarion Healing Salve
	[32905]="0:0:1:20:Potion::1:0:", -- Bottled Nethergon Vapor
	[32906]="0:12:1:5:::1:0:", -- Stunned Wolpertinger
	[32907]="0:12:1:1:::1:0:", -- Wolpertinger Net
	[32909]="0:0:1:20:Potion::1:0:", -- Blue Ogre Brew Special
	[32910]="0:0:1:20:Potion::1:0:", -- Red Ogre Brew Special
	[32911]="0:15:1:1:Junk::1:0:", -- Empty Brewfest Stein
	[32912]="0:2:3:1:Miscellaneous::1:0:", -- Yellow Brewfest Stein
	[32915]="0:2:3:1:Miscellaneous::1:0:", -- Filled Yellow Brewfest Stein
	[32917]="0:2:3:1:Miscellaneous::1:0:", -- Filled Yellow Brewfest Stein
	[32918]="0:2:3:1:Miscellaneous::1:0:", -- Filled Yellow Brewfest Stein
	[32919]="0:2:3:1:Miscellaneous::1:0:", -- Filled Yellow Brewfest Stein
	[32920]="0:2:3:1:Miscellaneous::1:0:", -- Filled Yellow Brewfest Stein
	[32941]="0:4:4:1:Ring::1:0:", -- Corruptor's Signet
	[32942]="0:4:4:1:Ring::1:0:", -- Ring of the Overseer
	[32943]="0:2:4:1:OneHandMace::1:0:", -- Swiftsteel Bludgeon
	[32944]="0:2:4:1:FistWeapon::1:0:", -- Talon of the Phoenix
	[32945]="0:2:4:1:FistWeapon::1:0:", -- Fist of Molten Fury
	[32946]="0:2:4:1:FistWeapon::1:0:", -- Claw of Molten Fury
	[32947]="0:0:1:20:Potion::1:0:19772,19773", -- Auchenai Healing Potion
	[32948]="0:0:1:20:Potion::1:0:19772,19773", -- Auchenai Mana Potion
	[32960]="0:12:1:1:::1:0:", -- Elekk Dispersion Ray
	[32961]="0:4:4:1:OffHandFrill::1:0:", -- Merciless Gladiator's Reprieve
	[32962]="0:2:4:1:Wand::1:0:", -- Merciless Gladiator's Touch of Defeat
	[32963]="0:2:4:1:OneHandMace::1:0:", -- Merciless Gladiator's Gavel
	[32964]="0:2:4:1:OneHandMace::1:0:", -- Merciless Gladiator's Salvation
	[32971]="0:0:1:20:Consumable::1:0:", -- Water Bucket
	[32979]="0:4:4:1:Cloth::1:0:26089", -- Veteran's Mooncloth Belt
	[32980]="0:4:4:1:Cloth::1:0:26089", -- Veteran's Mooncloth Cuffs
	[32981]="0:4:4:1:Cloth::1:0:26089", -- Veteran's Mooncloth Slippers
	[32988]="0:4:4:1:Plate::1:0:26089", -- Veteran's Ornamented Belt
	[32989]="0:4:4:1:Plate::1:0:26089", -- Veteran's Ornamented Bracers
	[32990]="0:4:4:1:Plate::1:0:26089", -- Veteran's Ornamented Greaves
	[32997]="0:4:4:1:Mail::1:0:26089", -- Veteran's Ringmail Bracers
	[32998]="0:4:4:1:Mail::1:0:26089", -- Veteran's Ringmail Girdle
	[32999]="0:4:4:1:Mail::1:0:26089", -- Veteran's Ringmail Sabatons
	[33004]="0:0:1:20:FoodDrink::1:0:", -- Clamlette Magnifique
	[33006]="0:2:4:1:Crossbow::1:0:", -- Vengeful Gladiator's Heavy Crossbow
	[33007]="0:12:1:1:::1:0:", -- Grimbooze's Secret Recipe
	[33008]="0:12:1:1:::1:0:", -- Deserter Propaganda
	[33009]="0:12:1:1:::1:0:", -- Tender Strider Meat
	[33010]="0:12:1:1:::1:0:", -- Griftah's Note
	[33012]="0:4:1:1:OffHandFrill::1:0:", -- Terokkar Lilac
	[33013]="0:12:1:1:::1:0:", -- Budd's Map of Zul'Aman
	[33014]="0:4:1:1:OffHandFrill::1:0:", -- Fine Poking Stick
	[33015]="0:12:1:1:::1:0:", -- Altered Leaflets
	[33016]="0:2:3:1:Miscellaneous::1:0:", -- Blue Brewfest Stein
	[33017]="0:2:3:1:Miscellaneous::1:0:", -- Filled Blue Brewfest Stein
	[33018]="0:2:3:1:Miscellaneous::1:0:", -- Filled Blue Brewfest Stein
	[33019]="0:2:3:1:Miscellaneous::1:0:", -- Filled Blue Brewfest Stein
	[33020]="0:2:3:1:Miscellaneous::1:0:", -- Filled Blue Brewfest Stein
	[33021]="0:2:3:1:Miscellaneous::1:0:", -- Filled Blue Brewfest Stein
	[33023]="200:0:1:20:Consumable::1:0:23481,23605", -- Savory Sausage
	[33024]="400:0:1:20:Consumable::1:0:23481,23605", -- Pickled Sausage
	[33025]="500:0:1:20:Consumable::1:0:23481,23605", -- Spicy Smoked Sausage
	[33026]="800:0:1:20:Consumable::1:0:23481,23605", -- The Golden Link
	[33028]="15:0:1:20:Consumable::1:0:23482", -- Barleybrew Light
	[33029]="50:0:1:20:Consumable::1:0:23482", -- Barleybrew Dark
	[33030]="3:0:1:20:Consumable::1:0:23482", -- Barleybrew Clear
	[33031]="100:0:1:20:Consumable::1:0:23510,24545", -- Thunder 45
	[33032]="200:0:1:20:Consumable::1:0:23510,24545", -- Thunderbrew Ale
	[33033]="400:0:1:20:Consumable::1:0:23510,24545", -- Thunderbrew Stout
	[33034]="400:0:1:20:Consumable::1:0:23511", -- Gordok Grog
	[33035]="640:0:1:20:Consumable::1:0:23511", -- Ogre Mead
	[33036]="640:0:1:20:Consumable::1:0:23511", -- Mudder's Milk
	[33037]="0:12:1:1:::1:0:", -- Defias Orders
	[33038]="0:12:1:1:::1:0:", -- Damaged Diving Gear
	[33039]="0:12:1:1:::1:0:", -- Tool Kit
	[33040]="0:12:1:1:::1:0:", -- Repaired Diving Gear
	[33041]="0:12:1:10:::1:0:", -- Salvaged Strongbox
	[33042]="6400:0:1:20:FoodDrink::5:0:23699", -- Black Coffee
	[33043]="3:0:1:20:Consumable::1:0:23522,23603", -- The Essential Brewfest Pretzel
	[33044]="0:12:1:1:::1:0:", -- Salvage Kit
	[33045]="0:12:1:1:::1:0:", -- Renn's Supplies
	[33047]="0:4:1:1:Miscellaneous::1:0:23710,27478", -- Belbi's Eyesight Enhancing Romance Goggles
	[33048]="0:0:1:20:FoodDrink::1:0:", -- Stewed Trout
	[33050]="0:12:1:4:::1:0:", -- Grimtotem Note
	[33051]="0:12:1:1:::1:0:", -- Grimtotem Battle Plan
	[33052]="0:0:1:20:FoodDrink::1:0:", -- Fisherman's Feast
	[33053]="0:0:1:20:FoodDrink::1:0:", -- Hot Buttered Trout
	[33054]="0:4:4:1:Ring::1:0:", -- The Seal of Danzalar
	[33055]="0:4:4:1:Ring::1:0:", -- Band of Vile Aggression
	[33056]="0:4:4:1:Ring::1:0:", -- Veteran's Band of Dominance
	[33057]="0:4:4:1:Ring::1:0:", -- Veteran's Band of Triumph
	[33058]="0:4:4:1:Ring::1:0:", -- Band of the Vigilant
	[33061]="0:13:1:10:::1:0:", -- Grimtotem Key
	[33063]="0:0:1:1:Consumable::1:0:", -- Really Tough Brewfest Bread
	[33064]="0:4:4:1:Ring::1:0:", -- Veteran's Band of Salvation
	[33065]="0:4:4:1:Amulet::1:0:", -- Veteran's Pendant of Dominance
	[33066]="0:4:4:1:Amulet::1:0:", -- Veteran's Pendant of Triumph
	[33067]="0:4:4:1:Amulet::1:0:", -- Veteran's Pendant of Conquest
	[33068]="0:4:4:1:Amulet::1:0:", -- Veteran's Pendant of Salvation
	[33069]="0:12:1:1:::1:0:", -- Sturdy Rope
	[33070]="0:12:1:1:::1:0:", -- Raptor Bait
	[33071]="0:12:1:10:::1:0:", -- Blackhoof Armaments
	[33072]="0:12:1:1:::1:0:", -- Tabetha's Torch
	[33076]="0:4:4:1:Idol::1:0:", -- Merciless Gladiator's Idol of Tenacity
	[33077]="0:4:4:1:Libram::1:0:", -- Merciless Gladiator's Libram of Justice
	[33078]="0:4:4:1:Totem::1:0:", -- Merciless Gladiator's Totem of the Third Wind
	[33079]="0:0:3:1:Consumable::1:0:", -- Murloc Costume
	[33081]="0:0:1:5:Other::1:0:", -- Voodoo Skull
	[33082]="0:12:1:1:::1:0:", -- Wreath
	[33083]="0:0:1:20:Other::1:0:", -- Orcish Grog
	[33084]="0:12:1:20:::1:0:", -- Darkclaw Guano
	[33085]="0:12:1:5:::1:0:", -- Bloodfen Feather
	[33086]="0:12:1:1:::1:0:", -- Stonemaul Banner
	[33087]="0:12:1:10:::1:0:", -- Black Dragonkin Essence
	[33088]="0:12:1:1:::1:0:", -- Brogg's Totem
	[33091]="0:12:1:1:::1:0:", -- Energized Totem
	[33092]="0:0:1:20:Potion::1:0:", -- Healing Potion Injector
	[33093]="0:0:1:20:Potion::1:0:", -- Mana Potion Injector
	[33095]="0:12:1:1:::1:0:", -- Stonemaul Banner
	[33096]="0:15:1:1:Junk::1:0:", -- Complimentary Brewfest Sampler
	[33098]="0:12:1:1:::1:0:", -- Petrov's Cluster Bombs
	[33099]="0:0:1:20:Consumable::1:0:", -- Intact Plague Container
	[33101]="0:12:1:1:::1:0:", -- Captured Totem
	[33102]="0:12:4:1:::1:0:", -- Blood of Zul'jin
	[33103]="0:12:1:10:::1:0:", -- Marsh Venom
	[33105]="0:4:1:1:Miscellaneous::1:0:", -- Budd's Guise of Zul'aman
	[33106]="0:12:1:10:::1:0:", -- Forest Troll Tusk
	[33107]="0:12:2:1:::1:0:", -- Tattered Voodoo Doll
	[33108]="0:12:1:1:::1:0:", -- Ooze Buster
	[33109]="0:12:1:20:::1:0:", -- Steel Gate Artifact
	[33110]="0:12:1:1:::1:0:", -- Razorspine's Sword
	[33111]="0:12:1:20:::1:0:", -- Pristine Mistsaber Catgut
	[33112]="0:12:1:20:::1:0:", -- Witchbane
	[33113]="0:12:1:1:::1:0:", -- Witchbane Torch
	[33114]="0:12:1:1:::1:0:", -- Sealed Letter
	[33115]="0:12:1:1:::1:0:", -- Sealed Letter
	[33117]="0:1:3:1:Bag::1:0:", -- Jack-o'-Lantern
	[33119]="0:12:1:1:::1:0:", -- Malister's Frost Wand
	[33120]="0:12:1:20:::1:0:", -- Shoveltusk Meat
	[33122]="0:4:4:1:Cloak::1:0:", -- Cloak of Darkness
	[33123]="0:12:1:20:::1:0:", -- Westguard Cannonball
	[33124]="50000:9:3:1:Leatherworking::1:0:18255", -- Pattern: Cloak of Darkness
	[33126]="0:12:1:10:::1:0:", -- Thresher Oil
	[33127]="0:12:1:1:::1:0:", -- Dastardly Denizens of the Deep
	[33129]="0:12:1:1:::1:0:", -- Feknut's Firecrackers
	[33131]="0:3:4:1:GemRed::1:0:", -- Crimson Sun
	[33132]="0:3:4:1:GemRed::1:0:", -- Delicate Fire Ruby
	[33133]="0:3:4:1:GemRed::1:0:", -- Don Julio's Heart
	[33134]="0:3:4:1:GemRed::1:0:", -- Kailee's Rose
	[33135]="0:3:4:1:GemBlue::1:0:", -- Falling Star
	[33137]="0:3:4:1:GemBlue::1:0:", -- Sparkling Falling Star
	[33138]="0:3:4:1:GemYellow::1:0:", -- Mystic Bladestone
	[33139]="0:3:4:1:GemYellow::1:0:", -- Brilliant Bladestone
	[33140]="0:3:4:1:GemYellow::1:0:", -- Blood of Amber
	[33141]="0:3:4:1:GemYellow::1:0:", -- Great Bladestone
	[33142]="0:3:4:1:GemYellow::1:0:", -- Rigid Bladestone
	[33143]="0:3:4:1:GemYellow::1:0:", -- Stone of Blades
	[33144]="0:3:4:1:GemYellow::1:0:", -- Facet of Eternity
	[33148]="100000:9:3:1:Enchanting::1:0:21655", -- Formula: Enchant Cloak - Dodge
	[33149]="100000:9:3:1:Enchanting::1:0:17904", -- Formula: Enchant Cloak - Stealth
	[33150]="100000:9:3:1:Enchanting::1:0:17657", -- Formula: Enchant Cloak - Subtlety
	[33151]="100000:9:3:1:Enchanting::1:0:17585", -- Formula: Enchant Cloak - Subtlety
	[33152]="100000:9:3:1:Enchanting::1:0:21643", -- Formula: Enchant Gloves - Superior Agility
	[33153]="100000:9:3:1:Enchanting::1:0:21432", -- Formula: Enchant Gloves - Threat
	[33154]="0:15:3:1:Companion::1:0:", -- Sinister Squashling
	[33155]="120000:9:1:1:Jewelcrafting::1:0:21432", -- Design: Kailee's Rose
	[33156]="120000:9:1:1:Jewelcrafting::1:0:20242,23007", -- Design: Crimson Sun
	[33157]="120000:9:1:1:Jewelcrafting::1:0:21655", -- Design: Falling Star
	[33158]="120000:9:1:1:Jewelcrafting::1:0:21643", -- Design: Stone of Blades
	[33159]="120000:9:1:1:Jewelcrafting::1:0:21432", -- Design: Blood of Amber
	[33160]="120000:9:1:1:Jewelcrafting::1:0:21643", -- Design: Facet of Eternity
	[33163]="0:12:1:10:::1:0:", -- Zeppelin Cargo
	[33164]="0:12:1:1:::1:0:", -- Ever-burning Torches
	[33165]="30000:9:1:1:Enchanting::1:0:18255", -- Formula: Enchant Weapon - Greater Agility
	[33166]="0:12:1:1:::1:0:", -- Pagle's Fish Paste, Extra Strength
	[33173]="0:4:3:1:Plate::1:0:", -- Ragesteel Shoulders
	[33174]="0:9:3:1:Blacksmithing::1:0:", -- Plans: Ragesteel Shoulders
	[33175]="0:12:1:10:::1:0:", -- Wyrmtail
	[33176]="0:15:3:1:FlyingMount::1:0:", -- Flying Broom
	[33182]="0:15:4:1:FlyingMount::1:0:", -- Swift Flying Broom
	[33183]="0:15:3:1:Mount::1:0:", -- Old Magic Broom
	[33184]="0:15:4:1:Mount::1:0:", -- Swift Magic Broom
	[33185]="0:0:2:5:EnhPerm::1:0:", -- Adamantite Weapon Chain
	[33186]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Adamantite Weapon Chain
	[33187]="0:12:1:250:::1:0:", -- Whisper Gulch Gem
	[33188]="0:12:1:250:::1:0:", -- Whisper Gulch Ore Fragment
	[33189]="0:15:2:1:Mount::1:0:", -- Rickety Magic Broom
	[33190]="0:12:1:1:::1:0:", -- Steelring's Foolproof Dynamite
	[33191]="0:4:4:1:Plate::1:0:", -- Jungle Stompers
	[33192]="0:2:4:1:Wand::1:0:18525", -- Carved Witch Doctor's Stick
	[33202]="0:12:1:10:::1:0:", -- Marsh Frog Leg
	[33203]="0:4:4:1:Cloth::1:0:", -- Robes of Heavenly Purpose
	[33204]="0:4:4:1:Leather::1:0:", -- Shadowprowler's Chestguard
	[33205]="240000:9:4:1:Leatherworking::1:0:18255", -- Pattern: Shadowprowler's Chestguard
	[33206]="0:4:4:1:Mail::1:0:", -- Pauldrons of Primal Fury
	[33207]="0:4:4:1:Plate::1:0:18525", -- Implacable Guardian Sabatons
	[33208]="0:0:1:20:Flask::1:0:", -- Flask of Chromatic Wonder
	[33209]="40000:9:2:1:Alchemy::1:0:18255", -- Recipe: Flask of Chromatic Wonder
	[33211]="0:4:4:1:Leather::1:0:", -- Bladeangel's Money Belt
	[33214]="0:2:4:1:OneHandSword::1:0:", -- Akil'zon's Talonblade
	[33215]="0:4:4:1:Plate::1:0:", -- Bloodstained Elven Battlevest
	[33216]="0:4:4:1:Plate::1:0:", -- Chestguard of Hidden Purpose
	[33218]="0:0:1:20:Consumable::1:0:", -- Goblin Gumbo
	[33219]="0:0:3:1:Consumable::1:0:", -- Goblin Gumbo Kettle
	[33221]="0:12:1:1:::1:0:", -- Plaguehound Cage
	[33222]="0:4:4:1:Leather::1:0:18525", -- Nyn'jah's Tabi Boots
	[33223]="0:15:3:1:Junk::1:0:", -- Fishing Chair
	[33226]="0:0:1:20:Consumable::1:0:", -- Tricky Treat
	[33228]="0:4:2:1:Cloth::1:0:", -- Crimson Tunic
	[33229]="0:4:2:1:Cloth::1:0:", -- Mordant's Travel Tunic
	[33230]="0:4:2:1:Cloth::1:0:", -- Leggings of the Long Road
	[33231]="0:4:2:1:Cloth::1:0:", -- Oversized Stonemaul Hood
	[33232]="0:4:2:1:Cloth::1:0:", -- Journeyman's Cowl
	[33233]="0:4:2:1:Cloth::1:0:", -- Cobalt-threaded Gloves
	[33234]="4000:0:1:20:Consumable::5:0:14844", -- Iced Berry Slush
	[33235]="0:4:2:1:Cloth::1:0:", -- Journeyman's Epaulets
	[33236]="5600:0:1:20:Consumable::5:0:14844", -- Fizzy Faire Drink "Classic"
	[33237]="0:4:2:1:Leather::1:0:", -- Brogg's Battle Harness
	[33238]="0:12:1:5:::1:0:", -- Crow Meat
	[33239]="0:4:2:1:Leather::1:0:", -- Marshwarden's Tunic
	[33240]="0:4:2:1:Leather::1:0:", -- Grimtotem Earthbinder's Tunic
	[33241]="0:4:2:1:Leather::1:0:", -- Oiled Leather Leggings
	[33242]="0:4:2:1:Leather::1:0:", -- Raptorhide Legguards
	[33243]="0:4:2:1:Leather::1:0:", -- Skirmisher's Cover
	[33244]="0:4:2:1:Leather::1:0:", -- The Wanderer's Cover
	[33245]="0:4:2:1:Leather::1:0:", -- Grimsby's Gaudy Girdle
	[33246]="5600:0:1:20:Consumable::5:0:14845", -- Funnel Cake
	[33247]="0:4:2:1:Leather::1:0:", -- Swift Wind Spaulders
	[33248]="0:4:2:1:Leather::1:0:", -- Crested Shoulderpads
	[33249]="0:4:2:1:Leather::1:0:", -- Boots of the Skirmisher
	[33250]="0:4:2:1:Leather::1:0:", -- Archer's Wristguard
	[33251]="0:4:2:1:Mail::1:0:", -- Steel-banded Hauberk
	[33252]="0:4:2:1:Mail::1:0:", -- Gleaming Scale Breastplate
	[33253]="0:4:2:1:Mail::1:0:", -- Golden Helm
	[33254]="8000:0:1:20:Consumable::5:0:14845", -- Afrazi Forest Strider Drumstick
	[33255]="0:4:2:1:Plate::1:0:", -- Rustproof Waistguard
	[33256]="0:4:2:1:Plate::1:0:", -- Refitted Bruiser Gauntlets
	[33257]="0:4:2:1:Mail::1:0:", -- Scaled Marshwalkers
	[33258]="0:4:2:1:Plate::1:0:", -- Protective Engineer's Leggings
	[33259]="0:4:2:1:Mail::1:0:", -- Crimson Barbut
	[33260]="0:4:2:1:Cloak::1:0:", -- Spellbound Cloak
	[33261]="0:4:2:1:Cloak::1:0:", -- Destroyer's Cloak
	[33262]="0:4:2:1:Ring::1:0:", -- Morlann's Seal
	[33263]="0:4:2:1:Ring::1:0:", -- Raptor Eye Ring
	[33264]="0:4:2:1:Ring::1:0:", -- Glowing Tourmaline Ring
	[33265]="0:4:2:1:Amulet::1:0:", -- Pendant of Ferocity
	[33266]="0:4:2:1:OffHandFrill::1:0:", -- Book of the Adept
	[33267]="0:2:2:1:Dagger::1:0:", -- Fleshripper
	[33268]="0:2:2:1:Dagger::1:0:", -- Bone Dirk
	[33269]="0:2:2:1:Dagger::1:0:", -- Bejeweled Dagger
	[33270]="0:2:2:1:OneHandSword::1:0:", -- Mariner's Sword
	[33271]="0:2:2:1:OneHandSword::1:0:", -- Battlecaster's Edge
	[33272]="0:2:2:1:OneHandAxe::1:0:", -- Biting Axe
	[33273]="0:2:2:1:Bow::1:0:", -- Seasoned Marshwood Bow
	[33274]="0:2:2:1:Crossbow::1:0:", -- Mercenary's Crossbow
	[33277]="0:0:1:1:Consumable::1:0:", -- Tome of Thomas Thomson
	[33278]="0:12:1:1:::1:0:", -- Burning Torch
	[33279]="0:4:4:1:Plate::1:0:18525", -- Iron-tusk Girdle
	[33280]="0:4:4:1:Mail::1:0:18525", -- War-Feathered Loop
	[33281]="0:4:4:1:Amulet::1:0:", -- Brooch of Nature's Mercy
	[33282]="0:12:1:1:::1:0:", -- Wyrmcaller's Horn
	[33283]="0:2:4:1:OneHandMace::1:0:", -- Amani Punisher
	[33284]="0:13:1:20:::1:0:", -- Gjalerbron Cage Key
	[33285]="0:4:4:1:Cloth::1:0:", -- Fury of the Ursine
	[33286]="0:4:4:1:Mail::1:0:", -- Mojo-mender's Mask
	[33287]="0:4:4:1:Leather::1:0:18525", -- Gnarled Ironwood Pauldrons
	[33289]="0:12:1:1:::1:0:", -- Gjalerbron Attack Plans
	[33290]="0:13:1:20:::1:0:", -- Large Gjalerbron Cage Key
	[33291]="0:4:4:1:Cloth::1:0:18525", -- Voodoo-woven Belt
	[33292]="0:4:3:1:Cloth::1:0:", -- Hallowed Helm
	[33293]="0:4:4:1:Ring::1:0:", -- Signet of Ancient Magics
	[33296]="0:4:4:1:Amulet::1:0:18525", -- Brooch of Deftness
	[33297]="0:4:4:1:Amulet::1:0:", -- The Savage's Choker
	[33298]="0:2:4:1:Dagger::1:0:", -- Prowler's Strikeblade
	[33299]="0:4:4:1:Plate::1:0:", -- Spaulders of the Advocate
	[33300]="0:4:4:1:Leather::1:0:", -- Shoulderpads of Dancing Blades
	[33303]="0:4:4:1:Plate::1:0:", -- Skullshatter Warboots
	[33304]="0:4:4:1:Cloak::1:0:18525", -- Cloak of Subjugated Power
	[33305]="120000:9:1:1:Jewelcrafting::1:0:20242,23007", -- Design: Don Julio's Heart
	[33306]="0:12:1:1:::1:0:", -- Ram Racing Reins
	[33307]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Executioner
	[33308]="0:13:1:20:::1:0:", -- Dragonflayer Cage Key
	[33309]="0:4:4:1:Shield::1:0:", -- Merciless Gladiator's Redoubt
	[33310]="0:12:1:1:::1:0:", -- The Sergeant's Machete
	[33311]="0:12:1:1:::1:0:", -- Westguard Command Insignia
	[33312]="0:0:1:1:Consumable::1:0:", -- Mana Sapphire
	[33313]="0:4:4:1:Shield::1:0:", -- Merciless Gladiator's Barrier
	[33314]="0:12:1:1:::1:0:", -- Vrykul Scroll of Ascension
	[33317]="0:4:4:1:Cloth::1:0:", -- Robe of Departed Spirits
	[33321]="0:12:1:1:::1:0:", -- Sergeant's Torch
	[33322]="0:4:4:1:Leather::1:0:", -- Shimmer-pelt Vest
	[33323]="0:12:1:1:::1:0:", -- Sergeant's Flare
	[33324]="0:4:4:1:Mail::1:0:18525", -- Treads of the Life Path
	[33325]="0:4:4:1:OffHandFrill::1:0:18525", -- Voodoo Shaker
	[33326]="0:4:4:1:Shield::1:0:", -- Bulwark of the Amani Empire
	[33327]="0:4:4:1:Plate::1:0:", -- Mask of Introspection
	[33328]="0:4:4:1:Mail::1:0:", -- Arrow-fall Chestguard
	[33329]="0:4:4:1:Leather::1:0:", -- Shadowtooth Trollskin Cuirass
	[33330]="0:12:1:1:::1:0:", -- Ingvar's Head
	[33331]="0:4:4:1:Plate::1:0:18525", -- Chain of Unleashed Rage
	[33332]="0:4:4:1:Shield::1:0:", -- Enamelled Disc of Mojo
	[33333]="0:4:4:1:Cloak::1:0:18525", -- Kharmaa's Shroud of Hope
	[33334]="0:4:4:1:OffHandFrill::1:0:18525", -- Fetish of the Primal Gods
	[33335]="0:12:1:1:::1:0:", -- Cannoneer's Smoke Flare
	[33336]="0:12:1:1:::1:0:", -- Sergeant's Spyglass
	[33337]="0:12:1:5:::1:0:", -- Giant Toxin Gland
	[33339]="0:12:1:1:::1:0:", -- Vrykul Scroll of Ascension
	[33340]="0:12:1:1:::1:0:", -- Winterhoof Emblem
	[33341]="0:12:1:1:::1:0:", -- Brave's Spyglass
	[33342]="0:12:1:1:::1:0:", -- The Brave's Machete
	[33343]="0:12:1:1:::1:0:", -- Brave's Torch
	[33344]="0:12:1:1:::1:0:", -- Brave's Flare
	[33345]="0:12:1:1:::1:0:", -- Vrykul Scroll of Ascension
	[33346]="0:12:1:1:::1:0:", -- Vrykul Scroll of Ascension
	[33347]="0:12:1:1:::1:0:", -- Gjalerbron Attack Plans
	[33348]="0:12:1:20:::1:0:", -- Spotted Hippogryph Down
	[33349]="0:0:1:1:Consumable::1:0:", -- Plague Vials
	[33351]="0:12:1:10:::1:0:", -- Undamaged Ram Horn
	[33352]="0:12:1:10:::1:0:", -- Tough Ram Meat
	[33354]="0:2:4:1:Dagger::1:0:", -- Wub's Cursed Hexblade
	[33355]="0:12:1:10:::1:0:", -- Wyrmskull Tablet
	[33356]="0:4:4:1:Leather::1:0:", -- Helm of Natural Regeneration
	[33357]="0:4:4:1:Cloth::1:0:", -- Footpads of Madness
	[33358]="0:4:0:1:Cloth::1:0:", -- Thread-Bare Cloth Belt
	[33359]="0:4:0:1:Cloth::1:0:", -- Thread-Bare Cloth Boots
	[33360]="0:4:0:1:Cloth::1:0:", -- Thread-Bare Cloth Bracers
	[33361]="0:4:0:1:Cloth::1:0:", -- Thread-Bare Cloth Gloves
	[33362]="0:4:0:1:Cloth::1:0:", -- Thread-Bare Cloth Pants
	[33363]="0:4:0:1:Cloth::1:0:", -- Thread-Bare Cloth Shoulderpads
	[33364]="0:4:0:1:Cloth::1:0:", -- Thread-Bare Cloth Vest
	[33365]="0:4:0:1:Cloth::1:0:", -- Frost-Rimed Cloth Belt
	[33366]="0:4:0:1:Cloth::1:0:", -- Frost-Rimed Cloth Boots
	[33367]="0:4:0:1:Cloth::1:0:", -- Frost-Rimed Cloth Bracers
	[33368]="0:4:0:1:Cloth::1:0:", -- Frost-Rimed Cloth Gloves
	[33369]="0:4:0:1:Cloth::1:0:", -- Frost-Rimed Cloth Pants
	[33370]="0:4:0:1:Cloth::1:0:", -- Frost-Rimed Cloth Shoulderpads
	[33371]="0:4:0:1:Cloth::1:0:", -- Frost-Rimed Cloth Vest
	[33372]="0:4:0:1:Leather::1:0:", -- Fur-Lined Armor
	[33373]="0:4:0:1:Leather::1:0:", -- Fur-Lined Belt
	[33374]="0:4:0:1:Leather::1:0:", -- Fur-Lined Boots
	[33375]="0:4:0:1:Leather::1:0:", -- Fur-Lined Bracers
	[33376]="0:4:0:1:Leather::1:0:", -- Fur-Lined Gloves
	[33377]="0:4:0:1:Leather::1:0:", -- Fur-Lined Pants
	[33378]="0:4:0:1:Leather::1:0:", -- Fur-Lined Shoulderpads
	[33379]="0:4:0:1:Leather::1:0:", -- Frozen Armor
	[33380]="0:4:0:1:Leather::1:0:", -- Frozen Belt
	[33381]="0:4:0:1:Leather::1:0:", -- Frozen Boots
	[33382]="0:4:0:1:Leather::1:0:", -- Frozen Bracers
	[33383]="0:4:0:1:Leather::1:0:", -- Frozen Gloves
	[33384]="0:4:0:1:Leather::1:0:", -- Frozen Pants
	[33385]="0:4:0:1:Leather::1:0:", -- Frozen Shoulderpads
	[33386]="0:4:4:1:Mail::1:0:18525", -- Man'kin'do's Belt
	[33387]="0:12:1:1:::1:0:", -- Glorenfeld's Package
	[33388]="0:2:4:1:OneHandSword::1:0:", -- Heartless
	[33389]="0:2:4:1:Dagger::1:0:", -- Dagger of Bad Mojo
	[33390]="0:4:0:1:Mail::1:0:", -- Icy Mail Armor
	[33391]="0:4:0:1:Mail::1:0:", -- Icy Mail Belt
	[33392]="0:4:0:1:Mail::1:0:", -- Icy Mail Boots
	[33393]="0:4:0:1:Mail::1:0:", -- Icy Mail Bracers
	[33394]="0:4:0:1:Mail::1:0:", -- Icy Mail Gloves
	[33395]="0:4:0:1:Mail::1:0:", -- Icy Mail Pants
	[33396]="0:4:0:1:Mail::1:0:", -- Icy Mail Shoulderpads
	[33397]="0:4:0:1:Mail::1:0:", -- Frigid Mail Armor
	[33398]="0:4:0:1:Mail::1:0:", -- Frigid Mail Belt
	[33399]="0:4:0:1:Mail::1:0:", -- Frigid Mail Boots
	[33400]="0:4:0:1:Mail::1:0:", -- Frigid Mail Bracers
	[33401]="0:4:0:1:Mail::1:0:", -- Frigid Mail Gloves
	[33402]="0:4:0:1:Mail::1:0:", -- Frigid Mail Pants
	[33403]="0:4:0:1:Mail::1:0:", -- Frigid Mail Shoulderpads
	[33404]="0:4:0:1:Plate::1:0:", -- Ice-Bound Plate Belt
	[33405]="0:4:0:1:Plate::1:0:", -- Ice-Bound Plate Boots
	[33406]="0:4:0:1:Plate::1:0:", -- Ice-Bound Plate Bracers
	[33407]="0:4:0:1:Plate::1:0:", -- Ice-Bound Plate Chestpiece
	[33408]="0:4:0:1:Plate::1:0:", -- Ice-Bound Plate Gloves
	[33409]="0:4:0:1:Plate::1:0:", -- Ice-Bound Plate Pants
	[33410]="0:4:0:1:Plate::1:0:", -- Ice-Bound Plate Shoulderpads
	[33411]="0:12:1:1:::1:0:", -- Dragonskin Map
	[33412]="0:4:0:1:Plate::1:0:", -- Frost-Worn Plate Belt
	[33413]="0:4:0:1:Plate::1:0:", -- Frost-Worn Plate Boots
	[33414]="0:4:0:1:Plate::1:0:", -- Frost-Worn Plate Bracers
	[33415]="0:4:0:1:Plate::1:0:", -- Frost-Worn Plate Chestpiece
	[33416]="0:4:0:1:Plate::1:0:", -- Frost-Worn Plate Gloves
	[33417]="0:4:0:1:Plate::1:0:", -- Frost-Worn Plate Pants
	[33418]="0:12:1:1:::1:0:", -- Tillinghast's Plague Canister
	[33419]="0:4:0:1:Plate::1:0:", -- Frost-Worn Plate Shoulderpads
	[33420]="0:12:1:20:::1:0:", -- Plagued Proto-Whelp Specimen
	[33421]="0:4:4:1:Plate::1:0:", -- Battleworn Tuskguard
	[33422]="0:2:0:1:Bow::1:0:", -- Shattered Bow
	[33423]="0:2:0:1:OneHandMace::1:0:", -- Rime-Covered Mace
	[33424]="0:2:0:1:Stave::1:0:", -- Cracked Iron Staff
	[33425]="0:2:0:1:OneHandSword::1:0:", -- Ice-Pitted Blade
	[33426]="0:2:0:1:OneHandAxe::1:0:", -- Chipped Timber Axe
	[33427]="0:2:0:1:Gun::1:0:", -- Frost-Encrusted Rifle
	[33428]="0:2:0:1:Dagger::1:0:", -- Dulled Shiv
	[33429]="0:2:0:1:TwoHandAxe::1:0:", -- Ice Cleaver
	[33430]="0:2:0:1:TwoHandSword::1:0:", -- Abandoned Greatsword
	[33431]="0:2:0:1:TwoHandMace::1:0:", -- Icesmashing Mace
	[33432]="0:4:4:1:Mail::1:0:", -- Coif of the Jungle Stalker
	[33433]="0:4:0:1:Mail::1:0:", -- Frigid Mail Circlet
	[33434]="0:4:0:1:Leather::1:0:", -- Frozen Leather Helmet
	[33435]="0:4:0:1:Plate::1:0:", -- Frost-Worn Plate Helmet
	[33436]="0:4:0:1:Cloth::1:0:", -- Frost-Rimed Cloth Hat
	[33437]="0:4:0:1:Mail::1:0:", -- Icy Mail Circlet
	[33438]="0:4:0:1:Cloth::1:0:", -- Thread-Bare Hat
	[33439]="0:4:0:1:Leather::1:0:", -- Fur-Lined Leather Helmet
	[33440]="0:4:0:1:Plate::1:0:", -- Ice-Bound Plate Helmet
	[33441]="0:12:1:1:::1:0:", -- Tillinghast's Plagued Meat
	[33443]="8500:0:1:20:FoodDrink::5:0:483,4255,4981,6746,10367,17630,23604,23731,23937,24149,24342,25245,25278,26567,27027,27042,27052,27066,27950,28686,28687,29122,29532,29714,29715,30346,31557,32403,32412,32413,32421,32424,32426,32631,32638,32642,33018,33644,33865,33866", -- Sour Goat Cheese
	[33444]="8500:0:1:20:FoodDrink::5:0:4169,4255,4554,4571,4981,5111,6735,6740,6741,6746,6929,10367,12096,12097,16618,16739,17630,23731,23737,24033,24057,24149,24342,25245,25278,26375,26567,26596,26680,26709,27027,27042,27044,27052,27066,27069,27125,27137,27148,27174,27187,27950,28038,28682,28685,28686,28687,28791,28811,29049,29121,29122,29205,29532,29583,29904,29926,29944,29963,29971,30098,30254,30255,30309,30346,30827,31017,31557,32334,32403,32412,32413,32415,32416,32419,32420,32421,32424,32426,32478,32631,32638,32642,33018,33645,33867,33868,33869", -- Pungent Seal Whey
	[33445]="11000:0:1:20:FoodDrink::5:0:4169,4255,4554,4571,4981,5111,6735,6740,6741,6746,6929,10367,12096,12097,16618,16739,17630,23731,23737,24033,24057,24149,24342,25245,25278,26375,26567,26596,26680,26709,27027,27042,27044,27052,27066,27069,27125,27137,27148,27174,27187,27950,28038,28682,28685,28686,28687,28791,28811,29049,29121,29122,29205,29532,29583,29904,29926,29944,29963,29971,30098,30254,30255,30309,30346,30827,31017,31557,32334,32403,32412,32413,32415,32416,32419,32420,32421,32424,32426,32478,32631,32638,32642,33018,33645,33867,33868,33869", -- Honeymint Tea
	[33446]="0:4:4:1:Plate::1:0:", -- Girdle of Stromgarde's Hope
	[33447]="24000:0:1:20:Potion:171:1:1:14847,29628", -- Runic Healing Potion
	[33448]="24000:0:1:20:Potion:171:1:1:28715,29537", -- Runic Mana Potion
	[33449]="8500:0:1:20:FoodDrink::5:0:3003,3518,4255,5109,6740,10367,16739,17630,23522,23603,23937,24033,25245,26567,26709,27027,27042,27044,27052,27069,27125,27137,27148,27174,27187,27950,28682,28685,28686,28687,28791,29121,29532,29583,29714,29715,29904,29926,29944,29963,29971,30098,30254,30255,30309,30346,31557,32403,32412,32413,32419,32420,32421,32424,32426,32631,32638,32642,33644,33865,33866", -- Crusty Flatbread
	[33450]="0:12:1:1:::1:0:", -- Carved Horn
	[33451]="8500:0:1:20:FoodDrink::5:0:4221,4255,10367,16618,16739,24057,25248,26567,27044,27144,27148,27174,27181,27187,27190,28682,28742,28791,28812,29122,29583,30309,30827,31019,31804,31805,32631,32638,32642,33644,33865,33866", -- Fillet of Icefin
	[33452]="8500:0:1:20:FoodDrink::5:0:3329,4554,4571,6741,10367,12096,12097,24149,25278,27032,27069,27137,28685,29121,29205,32419,32420,32631,32638,32642,33018,33644,33865,33866", -- Honey-Spiced Lichen
	[33453]="0:4:4:1:Cloth::1:0:", -- Hood of Hexing
	[33454]="8500:0:1:20:FoodDrink::5:0:3025,3312,3368,4169,4255,5111,5124,6929,10367,12096,12097,16618,16739,17630,23605,23937,25248,26375,26567,26596,26709,26868,27027,27042,27044,27052,27125,27148,27174,27187,27950,28046,28686,28687,28811,29122,29205,29244,29532,29905,29944,30254,30255,30827,31557,32403,32412,32413,32421,32424,32426,32478,32631,32638,32642,33644,33865,33866", -- Salted Venison
	[33455]="0:12:2:200:::1:0:", -- Brewfest Prize Ticket
	[33457]="900:0:1:20:Scroll::1:1:14847", -- Scroll of Agility VI
	[33458]="1080:0:1:20:Scroll::1:1:14847", -- Scroll of Intellect VI
	[33459]="990:0:1:20:Scroll::1:1:14847", -- Scroll of Protection VI
	[33460]="990:0:1:20:Scroll::1:1:14847", -- Scroll of Spirit VI
	[33461]="1080:0:1:20:Scroll::1:1:14847", -- Scroll of Stamina VI
	[33462]="900:0:1:20:Scroll::1:1:14847", -- Scroll of Strength VI
	[33463]="0:4:4:1:Cloth::1:0:", -- Hood of the Third Eye
	[33464]="0:4:4:1:Mail::1:0:", -- Hex Lord's Voodoo Pauldrons
	[33465]="0:2:4:1:Stave::1:0:", -- Staff of Primal Fury
	[33466]="0:4:4:1:Amulet::1:0:", -- Loop of Cursed Bones
	[33467]="0:2:4:1:OneHandSword::1:0:", -- Blade of Twisted Visions
	[33468]="0:2:4:1:OneHandMace::1:0:", -- Dark Blessing
	[33469]="0:4:4:1:Mail::1:0:", -- Hauberk of the Empire's Champion
	[33470]="0:7:1:20:Cloth:202,129,197:1:0:", -- Frostweave Cloth
	[33471]="0:4:4:1:Cloth::1:0:", -- Two-toed Sandals
	[33472]="0:12:1:1:::1:0:", -- Gorth's Torch
	[33473]="0:4:4:1:Plate::1:0:", -- Chestguard of the Warlord
	[33474]="0:2:4:1:Bow::1:0:", -- Ancient Amani Longbow
	[33476]="0:2:4:1:OneHandAxe::1:0:", -- Cleaver of the Unforgiving
	[33477]="0:12:1:1:::1:0:", -- Giant Yeti Meal
	[33478]="178195:2:4:1:TwoHandSword::1:0:", -- Jin'rohk, The Great Apocalypse
	[33479]="0:4:4:1:Leather::1:0:", -- Grimgrin Faceguard
	[33480]="0:4:4:1:Cloth::1:0:", -- Cord of Braided Troll Hair
	[33481]="0:4:4:1:Plate::1:0:", -- Pauldrons of Stone Resolve
	[33483]="0:4:4:1:Leather::1:0:", -- Life-step Belt
	[33484]="0:4:4:1:Cloak::1:0:18525", -- Dory's Embrace
	[33485]="0:12:1:1:::1:0:", -- Sacred Artifact
	[33486]="0:12:1:1:::1:0:", -- Plaguehound Leash
	[33487]="0:12:1:10:::1:0:", -- Trapped Prey
	[33488]="0:12:1:1:::1:0:", -- Dragonflayer Battle Plans
	[33489]="0:4:4:1:Cloth::1:0:", -- Mantle of Ill Intent
	[33490]="0:2:4:1:Stave::1:0:", -- Staff of Dark Mending
	[33491]="0:2:4:1:Gun::1:0:", -- Tuskbreaker
	[33492]="0:2:4:1:TwoHandAxe::1:0:", -- Trollbane
	[33493]="0:2:4:1:Dagger::1:0:", -- Umbral Shiv
	[33494]="0:2:4:1:Stave::1:0:", -- Amani Divining Staff
	[33495]="0:2:4:1:FistWeapon::1:0:", -- Rage
	[33496]="0:4:4:1:Ring::1:0:", -- Signet of Primal Wrath
	[33497]="0:4:4:1:Ring::1:0:", -- Mana Attuned Band
	[33498]="0:4:4:1:Ring::1:0:", -- Signet of the Quiet Forest
	[33499]="0:4:4:1:Ring::1:0:", -- Signet of the Last Defender
	[33500]="0:4:4:1:Ring::1:0:", -- Signet of Eternal Life
	[33501]="0:4:4:1:Plate::1:0:18525", -- Bloodthirster's Wargreaves
	[33502]="0:4:4:1:Libram::1:0:18525", -- Libram of Mending
	[33503]="0:4:4:1:Libram::1:0:18525", -- Libram of Divine Judgement
	[33504]="0:4:4:1:Libram::1:0:18525", -- Libram of Divine Purpose
	[33505]="0:4:4:1:Totem::1:0:18525", -- Totem of Living Water
	[33506]="0:4:4:1:Totem::1:0:18525", -- Skycall Totem
	[33507]="0:4:4:1:Totem::1:0:18525", -- Stonebreaker's Totem
	[33508]="0:4:4:1:Idol::1:0:18525", -- Idol of Budding Life
	[33509]="0:4:4:1:Idol::1:0:18525", -- Idol of Terror
	[33510]="0:4:4:1:Idol::1:0:18525", -- Idol of the Unseen Moon
	[33512]="0:4:4:1:Plate::1:0:18525", -- Furious Deathgrips
	[33513]="0:4:4:1:Plate::1:0:18525", -- Eternium Rage-shackles
	[33514]="0:4:4:1:Plate::1:0:18525", -- Pauldrons of Gruesome Fate
	[33515]="0:4:4:1:Plate::1:0:18525", -- Unwavering Legguards
	[33516]="0:4:4:1:Plate::1:0:18525", -- Bracers of the Ancient Phalanx
	[33517]="0:4:4:1:Plate::1:0:18525", -- Bonefist Gauntlets
	[33518]="0:4:4:1:Plate::1:0:18525", -- High Justicar's Legplates
	[33519]="0:4:4:1:Plate::1:0:18525", -- Handguards of the Templar
	[33520]="0:4:4:1:Plate::1:0:18525", -- Vambraces of the Naaru
	[33522]="0:4:4:1:Plate::1:0:18525", -- Chestguard of the Stoic Guardian
	[33523]="0:4:4:1:Plate::1:0:18525", -- Sabatons of the Righteous Defender
	[33524]="0:4:4:1:Plate::1:0:18525", -- Girdle of the Protector
	[33527]="0:4:4:1:Mail::1:0:18525", -- Shifting Camouflage Pants
	[33528]="0:4:4:1:Mail::1:0:18525", -- Gauntlets of Sniping
	[33529]="0:4:4:1:Mail::1:0:18525", -- Steadying Bracers
	[33530]="0:4:4:1:Mail::1:0:18525", -- Natural Life Leggings
	[33531]="0:4:4:1:Mail::1:0:18525", -- Polished Waterscale Gloves
	[33532]="0:4:4:1:Mail::1:0:18525", -- Gleaming Earthen Bracers
	[33533]="0:4:4:1:Mail::1:0:", -- Avalanche Leggings
	[33534]="0:4:4:1:Mail::1:0:18525", -- Grips of Nature's Wrath
	[33535]="0:4:4:1:Mail::1:0:18525", -- Earthquake Bracers
	[33536]="0:4:4:1:Mail::1:0:18525", -- Stormwrap
	[33537]="0:4:4:1:Mail::1:0:18525", -- Treads of Booming Thunder
	[33538]="0:4:4:1:Leather::1:0:18525", -- Shallow-grave Trousers
	[33539]="0:4:4:1:Leather::1:0:18525", -- Trickster's Stickyfingers
	[33540]="0:4:4:1:Leather::1:0:18525", -- Master Assassin Wristwraps
	[33541]="0:12:1:10:::1:0:", -- Dwarven Keg
	[33545]="0:12:1:1:::1:0:", -- Ancient Cipher
	[33546]="0:15:0:20:Junk::1:0:", -- Vicious Fang
	[33547]="0:15:0:20:Junk::1:0:", -- Hardened Claw
	[33548]="0:15:0:20:Junk::1:0:", -- Icy Hoof
	[33549]="0:15:0:20:Junk::1:0:", -- Thick Tail Hair
	[33550]="0:15:0:20:Junk::1:0:", -- Thick Carapace
	[33551]="0:15:0:20:Junk::1:0:", -- Razor Pincer
	[33552]="0:4:4:1:Leather::1:0:18525", -- Pants of Splendid Recovery
	[33553]="0:15:0:20:Junk::1:0:", -- Serrated Pincer
	[33554]="0:12:1:1:::1:0:", -- Grick's Bonesaw
	[33555]="0:15:0:20:Junk::1:0:", -- Armored Carapace
	[33556]="0:15:0:20:Junk::1:0:", -- Pearly Seashell Fragment
	[33557]="0:4:4:1:Leather::1:0:18525", -- Gargon's Bracers of Peaceful Slumber
	[33558]="0:12:1:20:::1:0:", -- Deranged Explorer Brain
	[33559]="0:4:4:1:Leather::1:0:18525", -- Starfire Waistband
	[33560]="0:15:0:20:Junk::1:0:", -- Huge Jaws
	[33561]="0:15:0:20:Junk::1:0:", -- Hardened Flipper
	[33562]="0:15:0:20:Junk::1:0:", -- Enormous Jaws
	[33563]="0:12:1:1:::1:0:", -- Forsaken Banner
	[33566]="0:4:4:1:Leather::1:0:18525", -- Blessed Elunite Coverings
	[33567]="0:7:1:20:Leather:165:1:0:", -- Borean Leather Scraps
	[33568]="9000:7:1:20:Leather:202,165:1:1:14846", -- Borean Leather
	[33569]="0:15:0:20:Junk::1:0:", -- Barbed Fang
	[33571]="0:15:0:20:Junk::1:0:", -- Rending Talon
	[33575]="0:15:0:20:Junk::1:0:", -- Icicle Claw
	[33576]="0:15:0:20:Junk::1:0:", -- Gnarled Horn
	[33577]="0:4:4:1:Leather::1:0:18525", -- Moon-walkers
	[33578]="0:4:4:1:Leather::1:0:18525", -- Armwraps of the Kaldorei Protector
	[33579]="0:4:4:1:Leather::1:0:18525", -- Vestments of Hibernation
	[33580]="0:4:4:1:Leather::1:0:18525", -- Band of the Swift Paw
	[33581]="0:12:1:1:::1:0:", -- Vrykul Insult
	[33582]="0:4:4:1:Leather::1:0:18525", -- Footwraps of Wild Encroachment
	[33583]="0:4:4:1:Leather::1:0:18525", -- Waistguard of the Great Beast
	[33584]="0:4:4:1:Cloth::1:0:18525", -- Pantaloons of Arcane Annihilation
	[33585]="0:4:4:1:Cloth::1:0:18525", -- Achromic Trousers of the Naaru
	[33586]="0:4:4:1:Cloth::1:0:18525", -- Studious Wraps
	[33587]="0:4:4:1:Cloth::1:0:18525", -- Light-Blessed Bonds
	[33588]="0:4:4:1:Cloth::1:0:18525", -- Runed Spell-cuffs
	[33589]="0:4:4:1:Cloth::1:0:18525", -- Wristguards of Tranquil Thought
	[33590]="0:4:4:1:Cloak::1:0:", -- Cloak of Fiends
	[33591]="0:4:4:1:Cloak::1:0:", -- Shadowcaster's Drape
	[33592]="0:4:4:1:Cloak::1:0:", -- Cloak of Ancient Rituals
	[33593]="0:4:4:1:Cloak::1:0:18525", -- Slikk's Cloak of Placation
	[33605]="0:12:1:15:::1:0:", -- Icy Core
	[33606]="0:12:1:1:::1:0:", -- Lurielle's Pendant
	[33607]="0:12:1:1:::1:0:", -- Enchanted Ice Core
	[33611]="0:12:1:10:::1:0:", -- Shoveltusk Ligament
	[33612]="8500:12:1:5:::1:0:24291", -- Fresh Pound of Flesh
	[33613]="0:12:1:1:::1:0:", -- Abomination Assembly Kit
	[33614]="0:0:1:1:Consumable::1:0:", -- Empty Apothecary's Flask
	[33615]="0:0:1:1:Consumable::1:0:", -- Flask of Vrykul Blood
	[33616]="0:0:1:1:Consumable::1:0:", -- Unstable Mix
	[33617]="0:0:1:1:Consumable::1:0:", -- Balanced Concoction
	[33618]="0:12:1:1:::1:0:", -- Worg Disguise
	[33619]="0:0:1:1:Consumable::1:0:", -- Lysander's Strain
	[33620]="0:12:1:1:::1:0:", -- Apothecary's Package
	[33621]="0:0:1:1:Consumable::1:0:", -- Plague Spray
	[33622]="120000:9:3:1:Jewelcrafting::1:0:20242,23007", -- Design: Relentless Earthstorm Diamond
	[33627]="0:12:1:1:::1:0:", -- Peppy's Special Mix
	[33628]="0:12:1:10:::1:0:", -- Northern Barbfish
	[33629]="0:15:0:20:Junk::1:0:", -- Frosty Spinneret
	[33630]="0:15:0:20:Junk::1:0:", -- Icy Fang
	[33631]="0:15:0:20:Junk::1:0:", -- Frosted Claw
	[33632]="0:15:0:20:Junk::1:0:", -- Icicle Fang
	[33634]="0:15:1:10:Junk::1:0:", -- Orehammer's Precision Bombs
	[33635]="0:12:1:1:::1:0:", -- Reagent Pouch
	[33637]="0:12:1:1:::1:0:", -- Incense Burner
	[33638]="0:15:0:20:Junk::1:0:", -- Runic Crystal
	[33639]="0:15:0:20:Junk::1:0:", -- Glowing Runestone
	[33640]="0:2:4:1:FistWeapon::1:0:", -- Fury
	[33661]="0:4:4:1:Shield::1:0:", -- Vengeful Gladiator's Barrier
	[33662]="0:2:4:1:OneHandMace::1:0:", -- Vengeful Gladiator's Bonecracker
	[33663]="0:2:4:1:TwoHandMace::1:0:", -- Vengeful Gladiator's Bonegrinder
	[33664]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Chain Armor
	[33665]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Chain Gauntlets
	[33666]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Chain Helm
	[33667]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Chain Leggings
	[33668]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Chain Spaulders
	[33669]="0:2:4:1:OneHandAxe::1:0:", -- Vengeful Gladiator's Cleaver
	[33670]="0:2:4:1:TwoHandAxe::1:0:", -- Vengeful Gladiator's Decapitator
	[33671]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Dragonhide Gloves
	[33672]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Dragonhide Helm
	[33673]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Dragonhide Legguards
	[33674]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Dragonhide Spaulders
	[33675]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Dragonhide Tunic
	[33676]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Dreadweave Gloves
	[33677]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Dreadweave Hood
	[33678]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Dreadweave Leggings
	[33679]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Dreadweave Mantle
	[33680]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Dreadweave Robe
	[33681]="0:4:4:1:OffHandFrill::1:0:", -- Vengeful Gladiator's Endgame
	[33682]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Felweave Amice
	[33683]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Felweave Cowl
	[33684]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Felweave Handguards
	[33685]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Felweave Raiment
	[33686]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Felweave Trousers
	[33687]="0:2:4:1:OneHandMace::1:0:", -- Vengeful Gladiator's Gavel
	[33688]="0:2:4:1:TwoHandSword::1:0:", -- Vengeful Gladiator's Greatsword
	[33689]="0:2:4:1:OneHandAxe::1:0:", -- Vengeful Gladiator's Hacker
	[33690]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Kodohide Gloves
	[33691]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Kodohide Helm
	[33692]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Kodohide Legguards
	[33693]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Kodohide Spaulders
	[33694]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Kodohide Tunic
	[33695]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Lamellar Chestpiece
	[33696]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Lamellar Gauntlets
	[33697]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Lamellar Helm
	[33698]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Lamellar Legguards
	[33699]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Lamellar Shoulders
	[33700]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Leather Gloves
	[33701]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Leather Helm
	[33702]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Leather Legguards
	[33703]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Leather Spaulders
	[33704]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Leather Tunic
	[33705]="0:2:4:1:FistWeapon::1:0:", -- Vengeful Gladiator's Left Ripper
	[33706]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Linked Armor
	[33707]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Linked Gauntlets
	[33708]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Linked Helm
	[33709]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Linked Leggings
	[33710]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Linked Spaulders
	[33711]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Mail Armor
	[33712]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Mail Gauntlets
	[33713]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Mail Helm
	[33714]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Mail Leggings
	[33715]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Mail Spaulders
	[33716]="0:2:4:1:Stave::1:0:", -- Vengeful Gladiator's Staff
	[33717]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Mooncloth Gloves
	[33718]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Mooncloth Hood
	[33719]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Mooncloth Leggings
	[33720]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Mooncloth Mantle
	[33721]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Mooncloth Robe
	[33722]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Ornamented Chestguard
	[33723]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Ornamented Gloves
	[33724]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Ornamented Headcover
	[33725]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Ornamented Legplates
	[33726]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Ornamented Spaulders
	[33727]="0:2:4:1:Polearm::1:0:", -- Vengeful Gladiator's Painsaw
	[33728]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Plate Chestpiece
	[33729]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Plate Gauntlets
	[33730]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Plate Helm
	[33731]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Plate Legguards
	[33732]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Plate Shoulders
	[33733]="0:2:4:1:OneHandMace::1:0:", -- Vengeful Gladiator's Pummeler
	[33734]="0:2:4:1:OneHandSword::1:0:", -- Vengeful Gladiator's Quickblade
	[33735]="0:4:4:1:Shield::1:0:", -- Vengeful Gladiator's Redoubt
	[33736]="0:4:4:1:OffHandFrill::1:0:", -- Vengeful Gladiator's Reprieve
	[33737]="0:2:4:1:FistWeapon::1:0:", -- Vengeful Gladiator's Right Ripper
	[33738]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Ringmail Armor
	[33739]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Ringmail Gauntlets
	[33740]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Ringmail Helm
	[33741]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Ringmail Leggings
	[33742]="0:4:4:1:Mail::1:0:", -- Vengeful Gladiator's Ringmail Spaulders
	[33743]="0:2:4:1:OneHandMace::1:0:", -- Vengeful Gladiator's Salvation
	[33744]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Satin Gloves
	[33745]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Satin Hood
	[33746]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Satin Leggings
	[33747]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Satin Mantle
	[33748]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Satin Robe
	[33749]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Scaled Chestpiece
	[33750]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Scaled Gauntlets
	[33751]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Scaled Helm
	[33752]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Scaled Legguards
	[33753]="0:4:4:1:Plate::1:0:", -- Vengeful Gladiator's Scaled Shoulders
	[33754]="0:2:4:1:Dagger::1:0:", -- Vengeful Gladiator's Shanker
	[33755]="0:4:4:1:Shield::1:0:", -- Vengeful Gladiator's Shield Wall
	[33756]="0:2:4:1:Dagger::1:0:", -- Vengeful Gladiator's Shiv
	[33757]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Silk Amice
	[33758]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Silk Cowl
	[33759]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Silk Handguards
	[33760]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Silk Raiment
	[33761]="0:4:4:1:Cloth::1:0:", -- Vengeful Gladiator's Silk Trousers
	[33762]="0:2:4:1:OneHandSword::1:0:", -- Vengeful Gladiator's Slicer
	[33763]="0:2:4:1:Dagger::1:0:", -- Vengeful Gladiator's Spellblade
	[33764]="0:2:4:1:Wand::1:0:", -- Vengeful Gladiator's Touch of Defeat
	[33765]="0:2:4:1:Thrown::1:0:", -- Vengeful Gladiator's War Edge
	[33766]="0:2:4:1:Stave::1:0:", -- Vengeful Gladiator's War Staff
	[33767]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Wyrmhide Gloves
	[33768]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Wyrmhide Helm
	[33769]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Wyrmhide Legguards
	[33770]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Wyrmhide Spaulders
	[33771]="0:4:4:1:Leather::1:0:", -- Vengeful Gladiator's Wyrmhide Tunic
	[33774]="0:12:1:1:::1:0:", -- Incense Burner
	[33778]="0:12:1:1:::1:0:", -- Book of Runes - Chapter 1
	[33779]="0:12:1:1:::1:0:", -- Book of Runes - Chapter 2
	[33780]="0:12:1:1:::1:0:", -- Book of Runes - Chapter 3
	[33781]="0:12:1:1:::1:0:", -- The Book of Runes
	[33782]="0:3:3:1:GemGreen::1:0:", -- Steady Talasite
	[33783]="0:9:3:1:Jewelcrafting::1:0:18821,18822", -- Design: Steady Talasite
	[33784]="0:15:1:5:Junk::1:0:", -- Darkrune Fragment
	[33791]="0:2:2:1:OneHandSword::1:0:", -- Heavy Copper Longsword
	[33792]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Heavy Copper Longsword
	[33794]="0:12:1:1:::1:0:", -- Iron Rune Carving Tools
	[33796]="0:12:1:1:::1:0:", -- Rune of Command
	[33797]="0:0:1:1:Consumable::1:0:", -- Portable Brewfest Keg
	[33801]="0:2:4:1:Dagger::1:0:", -- Vengeful Gladiator's Mutilator
	[33803]="0:6:3:1000:Arrow::1:0:", -- Adamantite Stinger
	[33804]="0:9:2:1:Engineering::1:0:", -- Schematic: Adamantite Arrow Maker
	[33805]="0:4:4:1:Mail::1:0:", -- Shadowhunter's Treads
	[33806]="0:12:1:1:::1:0:", -- Runeseeking Pick
	[33808]="0:4:4:1:Plate::1:0:", -- The Horseman's Helm
	[33809]="0:15:4:1:Mount::1:0:", -- Amani War Bear
	[33810]="0:4:4:1:Plate::1:0:18525", -- Amani Mask of Death
	[33811]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Plate Belt
	[33812]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Plate Greaves
	[33813]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Plate Bracers
	[33814]="0:12:1:1:::1:0:", -- Keli'dan's Feathered Stave
	[33815]="0:12:1:1:::1:0:", -- Bladefist's Seal
	[33816]="0:15:3:1:Companion::1:0:", -- Toothy's Bucket
	[33818]="0:15:3:1:Companion::1:0:", -- Muckbreath's Bucket
	[33819]="0:12:1:1:::1:0:", -- Rune Sample
	[33820]="0:4:3:1:Cloth::1:0:", -- Weather-Beaten Fishing Hat
	[33821]="0:12:1:1:::1:0:", -- The Heart of Quagmirran
	[33823]="0:7:1:20:Meat:185:1:0:", -- Bloodfin Catfish
	[33824]="0:7:1:20:Meat:185:1:0:", -- Crescent-Tail Skullfish
	[33825]="0:0:1:20:FoodDrink::1:0:", -- Skullfish Soup
	[33826]="0:12:1:1:::1:0:", -- Black Stalker Egg
	[33827]="0:12:1:1:::1:0:", -- The Warlord's Treatise
	[33828]="0:4:4:1:Trinket::1:0:", -- Tome of Diabolic Remedy
	[33829]="0:4:4:1:Trinket::1:0:", -- Hex Shrunken Head
	[33830]="0:4:4:1:Trinket::1:0:", -- Ancient Aqir Artifact
	[33831]="0:4:4:1:Trinket::1:0:", -- Berserker's Call
	[33832]="0:4:4:1:Trinket::1:0:18525", -- Battlemaster's Determination
	[33833]="0:12:1:1:::1:0:", -- Nazan's Riding Crop
	[33834]="0:12:1:1:::1:0:", -- The Headfeathers of Ikiss
	[33835]="0:12:1:1:::1:0:", -- Shaffar's Wondrous Amulet
	[33836]="0:12:1:1:::1:0:", -- The Exarch's Soul Gem
	[33837]="0:12:1:1:::1:0:", -- Cooking Pot
	[33838]="0:12:1:20:::1:0:", -- Giant Kaliri Wing
	[33839]="0:12:1:1:::1:0:", -- Kaliri Stew
	[33840]="0:12:1:1:::1:0:", -- Murmur's Whisper
	[33841]="0:4:4:1:Idol::1:0:", -- Vengeful Gladiator's Idol of Tenacity
	[33842]="0:4:4:1:Libram::1:0:", -- Vengeful Gladiator's Libram of Justice
	[33843]="0:4:4:1:Totem::1:0:", -- Vengeful Gladiator's Totem of the Third Wind
	[33844]="0:15:1:1:Junk::1:0:", -- Barrel of Fish
	[33846]="0:15:0:5:Junk::1:0:", -- Ruined Fishing Net
	[33847]="0:12:1:1:::1:0:", -- Epoch Hunter's Head
	[33848]="0:12:1:1:::1:0:", -- Demon Broiled Surprise
	[33849]="0:12:1:20:::1:0:", -- Mana Berry
	[33850]="0:12:1:1:::1:0:", -- Spiritual Soup
	[33851]="0:12:1:1:::1:0:", -- Cooking Pot
	[33852]="0:12:1:1:::1:0:", -- Cooking Pot
	[33853]="0:4:4:1:Ring::1:0:", -- Vindicator's Band of Dominance
	[33854]="0:15:0:5:Junk::1:0:", -- Unidentified Eye
	[33855]="0:4:0:1:Ring::1:0:", -- Tarnished Silver Ring
	[33856]="0:15:0:10:Junk::1:0:", -- List of Goods
	[33857]="0:15:1:1:Junk::1:0:", -- Crate of Meat
	[33858]="0:12:1:1:::1:0:", -- Aeonus's Hourglass
	[33859]="0:12:1:1:::1:0:", -- Warp Splinter Clipping
	[33860]="0:12:1:1:::1:0:", -- Pathaleon's Projector
	[33861]="0:12:1:1:::1:0:", -- The Scroll of Skyriss
	[33862]="0:4:1:1:Miscellaneous::1:0:23710,24495,27478,27489", -- Brewfest Regalia
	[33863]="0:4:1:1:Miscellaneous::1:0:23710,24495,27478,27489", -- Brewfest Dress
	[33864]="0:4:1:1:Miscellaneous::1:0:23710,24495,27478,27489", -- Brown Brewfest Hat
	[33865]="0:0:2:1:Consumable::1:0:", -- Amani Hex Stick
	[33866]="0:0:1:20:FoodDrink::1:0:", -- Stormchops
	[33867]="0:0:1:20:FoodDrink::1:0:", -- Broiled Bloodfin
	[33868]="0:4:1:1:Miscellaneous::1:0:23710,24495,27478,27489", -- Brewfest Boots
	[33869]="0:9:2:1:Cooking::1:0:", -- Recipe: Broiled Bloodfin
	[33870]="0:9:2:1:Cooking::1:0:", -- Recipe: Skullfish Soup
	[33871]="0:9:3:1:Cooking::1:0:", -- Recipe: Stormchops
	[33872]="0:0:1:20:FoodDrink::1:0:", -- Spicy Hot Talbuk
	[33873]="0:9:2:1:Cooking::1:0:", -- Recipe: Spicy Hot Talbuk
	[33874]="0:0:1:20:FoodDrink::1:0:", -- Kibler's Bits
	[33875]="0:9:2:1:Cooking::1:0:", -- Recipe: Kibler's Bits
	[33876]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Chain Bracers
	[33877]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Chain Girdle
	[33878]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Chain Sabatons
	[33879]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Dragonhide Belt
	[33880]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Dragonhide Boots
	[33881]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Dragonhide Bracers
	[33882]="0:4:4:1:Cloth::1:0:26089", -- Vindicator's Dreadweave Belt
	[33883]="0:4:4:1:Cloth::1:0:26089", -- Vindicator's Dreadweave Cuffs
	[33884]="0:4:4:1:Cloth::1:0:26089", -- Vindicator's Dreadweave Stalkers
	[33885]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Kodohide Belt
	[33886]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Kodohide Boots
	[33887]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Kodohide Bracers
	[33888]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Lamellar Belt
	[33889]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Lamellar Bracers
	[33890]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Lamellar Greaves
	[33891]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Leather Belt
	[33892]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Leather Boots
	[33893]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Leather Bracers
	[33894]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Linked Bracers
	[33895]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Linked Girdle
	[33896]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Linked Sabatons
	[33897]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Mail Bracers
	[33898]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Mail Girdle
	[33899]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Mail Sabatons
	[33900]="0:4:4:1:Cloth::1:0:26089", -- Vindicator's Mooncloth Belt
	[33901]="0:4:4:1:Cloth::1:0:26089", -- Vindicator's Mooncloth Cuffs
	[33902]="0:4:4:1:Cloth::1:0:26089", -- Vindicator's Mooncloth Slippers
	[33903]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Ornamented Belt
	[33904]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Ornamented Bracers
	[33905]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Ornamented Greaves
	[33906]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Ringmail Bracers
	[33907]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Ringmail Girdle
	[33908]="0:4:4:1:Mail::1:0:26089", -- Vindicator's Ringmail Sabatons
	[33909]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Scaled Belt
	[33910]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Scaled Bracers
	[33911]="0:4:4:1:Plate::1:0:26089", -- Vindicator's Scaled Greaves
	[33912]="0:4:4:1:Cloth::1:0:26089", -- Vindicator's Silk Belt
	[33913]="0:4:4:1:Cloth::1:0:26089", -- Vindicator's Silk Cuffs
	[33914]="0:4:4:1:Cloth::1:0:26089", -- Vindicator's Silk Footguards
	[33915]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Wyrmhide Belt
	[33916]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Wyrmhide Boots
	[33917]="0:4:4:1:Leather::1:0:26089", -- Vindicator's Wyrmhide Bracers
	[33918]="0:4:4:1:Ring::1:0:", -- Vindicator's Band of Salvation
	[33919]="0:4:4:1:Ring::1:0:", -- Vindicator's Band of Triumph
	[33920]="0:4:4:1:Amulet::1:0:", -- Vindicator's Pendant of Conquest
	[33921]="0:4:4:1:Amulet::1:0:", -- Vindicator's Pendant of Dominance
	[33922]="0:4:4:1:Amulet::1:0:", -- Vindicator's Pendant of Salvation
	[33923]="0:4:4:1:Amulet::1:0:", -- Vindicator's Pendant of Triumph
	[33924]="0:0:1:1:FoodDrink::1:0:", -- Delicious Chocolate Cake
	[33925]="0:9:3:1:Cooking::1:0:", -- Recipe: Delicious Chocolate Cake
	[33926]="1000:0:3:1:Consumable::1:1:24396", -- Sealed Scroll Case
	[33927]="0:0:3:1:Consumable::1:0:23710,24495,27478,27489", -- Brewfest Pony Keg
	[33928]="1000:0:3:1:Consumable::1:1:24396", -- Hollowed Bone Decanter
	[33929]="0:0:1:1:Consumable::1:0:", -- Brewfest Brew
	[33930]="0:0:2:1:Other::1:0:", -- Amani Charm of the Bloodletter
	[33931]="0:0:2:1:Other::1:0:", -- Amani Charm of Mighty Mojo
	[33932]="0:0:2:1:Other::1:0:", -- Amani Charm of the Witch Doctor
	[33933]="0:0:2:1:Other::1:0:", -- Amani Charm of the Raging Defender
	[33934]="0:0:1:20:Potion::1:0:23428", -- Crystal Healing Potion
	[33935]="0:0:1:20:Potion::1:0:23428", -- Crystal Mana Potion
	[33936]="0:4:4:1:Libram::1:0:", -- Gladiator's Libram of Fortitude
	[33937]="0:4:4:1:Libram::1:0:", -- Merciless Gladiator's Libram of Fortitude
	[33938]="0:4:4:1:Libram::1:0:", -- Vengeful Gladiator's Libram of Fortitude
	[33939]="0:4:4:1:Totem::1:0:", -- Gladiator's Totem of Indomitability
	[33940]="0:4:4:1:Totem::1:0:", -- Merciless Gladiator's Totem of Indomitability
	[33941]="0:4:4:1:Totem::1:0:", -- Vengeful Gladiator's Totem of Indomitability
	[33942]="0:4:4:1:Idol::1:0:", -- Gladiator's Idol of Steadfastness
	[33943]="0:4:4:1:Idol::1:0:", -- Merciless Gladiator's Idol of Steadfastness
	[33944]="0:4:4:1:Idol::1:0:", -- Vengeful Gladiator's Idol of Steadfastness
	[33945]="0:4:4:1:Idol::1:0:", -- Gladiator's Idol of Resolve
	[33946]="0:4:4:1:Idol::1:0:", -- Merciless Gladiator's Idol of Resolve
	[33947]="0:4:4:1:Idol::1:0:", -- Vengeful Gladiator's Idol of Resolve
	[33948]="0:4:4:1:Libram::1:0:", -- Gladiator's Libram of Vengeance
	[33949]="0:4:4:1:Libram::1:0:", -- Merciless Gladiator's Libram of Vengeance
	[33950]="0:4:4:1:Libram::1:0:", -- Vengeful Gladiator's Libram of Vengeance
	[33951]="0:4:4:1:Totem::1:0:", -- Gladiator's Totem of Survival
	[33952]="0:4:4:1:Totem::1:0:", -- Merciless Gladiator's Totem of Survival
	[33953]="0:4:4:1:Totem::1:0:", -- Vengeful Gladiator's Totem of Survival
	[33954]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Hammer of Righteous Might
	[33955]="0:12:2:1:::1:0:", -- Brewfest Stein Voucher
	[33956]="0:0:1:6:Consumable::1:0:", -- Harkor's Home Brew
	[33960]="0:12:1:1:::1:0:", -- Scourging Crystal Controller
	[33961]="0:12:1:1:::1:0:", -- Scourge Device
	[33962]="0:12:1:1:::1:0:", -- Scourge Device
	[33965]="0:4:4:1:Mail::1:0:18525", -- Hauberk of the Furious Elements
	[33966]="0:4:1:1:Miscellaneous::1:0:23710,24495,27478,27489", -- Brewfest Slippers
	[33967]="0:4:1:1:Miscellaneous::1:0:23710,24495,27478,27489", -- Green Brewfest Hat
	[33968]="0:4:1:1:Miscellaneous::1:0:23710,24495,27478,27489", -- Blue Brewfest Hat
	[33969]="0:4:1:1:Miscellaneous::1:0:23710,24495,27478,27489", -- Purple Brewfest Hat
	[33970]="0:4:4:1:Mail::1:0:18525", -- Pauldrons of the Furious Elements
	[33971]="0:4:4:1:Leather::1:0:", -- Elunite Imbued Leggings
	[33972]="0:4:4:1:Leather::1:0:18525", -- Mask of Primal Power
	[33973]="0:4:4:1:Leather::1:0:18525", -- Pauldrons of Tribal Fury
	[33974]="0:4:4:1:Leather::1:0:18525", -- Grasp of the Moonkin
	[33976]="100000:15:3:1:Mount::1:0:24468,24510", -- Brewfest Ram
	[33977]="1000000:15:4:1:Mount::1:0:24468,24510", -- Swift Brewfest Ram
	[33978]="0:12:1:1:::1:0:", -- "Honorary Brewer" Hand Stamp
	[33985]="0:12:1:1:::1:0:", -- Dreary Candle
	[33993]="0:15:3:1:Companion::1:0:", -- Mojo
	[33999]="20000000:15:4:1:FlyingMount::1:0:17904", -- Cenarion War Hippogryph
	[34000]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Blood Elf Mask
	[34001]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Female Draenei Mask
	[34002]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Blood Elf Mask
	[34003]="0:4:1:1:Miscellaneous::1:0:", -- Flimsy Male Draenei Mask
	[34008]="0:4:1:1:Miscellaneous::1:0:24495,27489", -- Blix's Eyesight Enhancing Romance Goggles
	[34009]="0:2:4:1:OneHandMace::1:0:", -- Hammer of Judgement
	[34010]="0:4:4:1:Cloak::1:0:", -- Pepe's Shroud of Pacification
	[34011]="0:4:4:1:Shield::1:0:", -- Illidari Runeshield
	[34012]="0:4:4:1:Cloak::1:0:", -- Shroud of the Final Stand
	[34013]="0:12:1:1:::1:0:", -- Fresh Barbfish Bait
	[34014]="0:2:4:1:TwoHandAxe::1:0:", -- Vengeful Gladiator's Waraxe
	[34015]="0:2:4:1:OneHandAxe::1:0:", -- Vengeful Gladiator's Chopper
	[34016]="0:2:4:1:FistWeapon::1:0:", -- Vengeful Gladiator's Left Render
	[34017]="3:0:1:20:Consumable::1:0:24501", -- Small Step Brew
	[34018]="15:0:1:20:Consumable::1:0:24501", -- Long Stride Brew
	[34019]="50:0:1:20:Consumable::1:0:24501", -- Path of Brew
	[34020]="100:0:1:20:Consumable::1:0:23533", -- Jungle River Water
	[34021]="200:0:1:20:Consumable::1:0:23533", -- Brewdoo Magic
	[34022]="400:0:1:20:Consumable::1:0:23533", -- Stout Shrunken Head
	[34023]="0:0:1:1:Consumable::1:0:", -- Empty Apothecary's Flask
	[34024]="0:0:1:1:Consumable::1:0:", -- Flask of Vrykul Blood
	[34026]="0:12:1:1:::1:0:", -- Feathered Charm
	[34027]="0:12:1:1:::1:0:", -- Eyes of the Eagle
	[34028]="0:12:1:1:::1:0:", -- "Honorary Brewer" Hand Stamp
	[34029]="0:4:4:1:Trinket::1:0:", -- Tiny Voodoo Mask
	[34031]="0:12:1:1:::1:0:", -- Harpoon Operation Manual
	[34032]="0:12:1:1:::1:0:", -- Harpoon Control Mechanism
	[34033]="0:4:4:1:OffHandFrill::1:0:", -- Vengeful Gladiator's Grimoire
	[34035]="0:12:1:1:::1:0:", -- Rotgill's Trident
	[34040]="0:12:1:1:::1:0:", -- Saga of the Twins
	[34041]="0:12:1:1:::1:0:", -- Saga of the Winter Curse
	[34042]="0:12:1:1:::1:0:", -- Saga of the Val'kyr
	[34043]="0:12:1:20:::1:0:", -- Ancient Vrykul Bone
	[34049]="0:4:4:1:Trinket::1:0:18525", -- Battlemaster's Audacity
	[34050]="0:4:4:1:Trinket::1:0:18525", -- Battlemaster's Perseverance
	[34051]="0:12:1:1:::1:0:", -- Alliance Banner
	[34052]="0:7:3:20:Enchanting:333,202,755,197:1:0:", -- Dream Shard
	[34053]="0:7:3:20:Enchanting::1:0:", -- Small Dream Shard
	[34054]="0:7:1:20:Enchanting:164,333,755,197:1:0:", -- Infinite Dust
	[34055]="0:7:2:10:Elemental:333,165:1:0:", -- Greater Cosmic Essence
	[34056]="0:7:2:10:Enchanting:333:1:0:", -- Lesser Cosmic Essence
	[34057]="0:7:4:20:Enchanting:333,165:1:0:", -- Abyss Crystal
	[34059]="0:2:4:1:Wand::1:0:", -- Vengeful Gladiator's Baton of Light
	[34060]="0:15:3:1:FlyingMount::1:0:", -- Flying Machine Control
	[34061]="0:15:4:1:FlyingMount::1:0:", -- Turbo-Charged Flying Machine Control
	[34062]="0:0:1:20:FoodDrink::1:0:", -- Conjured Mana Biscuit
	[34063]="50:0:1:20:Consumable::1:0:23481,23605", -- Dried Sausage
	[34064]="100:0:1:20:Consumable::1:0:23481,23605", -- Succulent Sausage
	[34065]="15:0:1:20:Consumable::1:0:23521,23604", -- Spiced Onion Cheese
	[34066]="0:2:4:1:Wand::1:0:", -- Vengeful Gladiator's Piercing Touch
	[34067]="0:1:3:1:Bag::1:0:", -- Tattered Hexcloth Sack
	[34068]="0:0:1:20:Consumable::1:0:", -- Weighted Jack-o'-Lantern
	[34069]="0:12:1:1:::1:0:", -- Amani Vase
	[34070]="0:12:1:1:::1:0:", -- Eagle Figurine
	[34073]="0:4:4:1:Ring::1:0:", -- The Horseman's Signet Ring
	[34074]="0:4:4:1:Ring::1:0:", -- Witches Band
	[34075]="0:4:4:1:Ring::1:0:", -- Ring of Ghoulish Delight
	[34076]="0:0:1:1:Consumable::1:0:", -- Fish Bladder
	[34077]="0:0:1:1:Consumable::1:0:", -- Crudely Wrapped Gift
	[34078]="0:13:1:1:::1:0:", -- Icehammer's Harpoon Controller
	[34081]="0:12:1:10:::1:0:", -- Valgarde Supply Crate
	[34082]="0:12:1:1:::1:0:", -- Diving Helm
	[34083]="0:12:1:5:::1:0:", -- Awakening Rod
	[34084]="0:12:1:20:::1:0:", -- Bear Musk
	[34085]="0:4:1:1:Cloth::1:0:", -- Red Winter Clothes
	[34086]="0:4:1:1:Cloth::1:0:", -- Winter Boots
	[34087]="0:4:1:1:Cloth::1:0:", -- Green Winter Clothes
	[34088]="0:12:1:1:::1:0:", -- McSorf's Bundle
	[34089]="0:12:1:1:::1:0:", -- Alicia's Poem
	[34090]="0:12:1:1:::1:0:", -- Mezhen's Writings
	[34091]="0:12:1:1:::1:0:", -- Mezhen's Writings
	[34092]="0:15:4:1:FlyingMount::1:0:", -- Merciless Nether Drake
	[34099]="0:11:2:1:AmmoPouch::1:0:", -- Knothide Ammo Pouch
	[34100]="0:11:2:1:Quiver::1:0:", -- Knothide Quiver
	[34101]="0:12:1:10:::1:0:", -- Chimaera Horn
	[34102]="0:12:1:20:::1:0:", -- Fjord Grub
	[34105]="0:11:3:1:Quiver::1:0:", -- Quiver of a Thousand Feathers
	[34106]="0:11:3:1:AmmoPouch::1:0:", -- Netherscale Ammo Pouch
	[34109]="0:9:1:1:Book::1:0:", -- Weather-Beaten Journal
	[34111]="0:12:1:1:::1:0:", -- Trained Rock Falcon
	[34112]="0:12:1:5:::1:0:", -- Fjord Turkey
	[34113]="0:15:1:5:CombatPet:202:1:0:", -- Field Repair Bot 110G
	[34114]="0:9:2:1:Engineering::1:0:", -- Schematic: Field Repair Bot 110G
	[34115]="0:12:1:1:::1:0:", -- "Silvermoon" Harry's Debt
	[34116]="0:12:1:1:::1:0:", -- Jack Adams' Debt
	[34118]="0:12:1:1:::1:0:", -- Black Conrad's Treasure
	[34119]="0:15:1:1:Junk::1:0:", -- Black Conrad's Treasure
	[34120]="0:12:1:10:::1:0:", -- Fjord Hawk
	[34121]="0:12:1:1:::1:0:", -- Trained Rock Falcon
	[34122]="0:12:1:1:::1:0:", -- Big Roy's Blubber
	[34123]="0:12:1:8:::1:0:", -- Fjord Hawk Egg
	[34124]="0:12:1:1:::1:0:", -- Trained Rock Falcon
	[34125]="0:0:1:20:FoodDrink::1:0:", -- Shoveltusk Soup
	[34126]="0:9:1:1:Cooking::1:0:", -- Recipe: Shoveltusk Soup
	[34127]="0:12:1:20:::1:0:", -- Tasty Reef Fish
	[34128]="0:12:1:1:::1:0:", -- Jonah Sterling's Spyglass
	[34129]="0:15:4:1:Mount::1:0:12796", -- Swift Warstrider
	[34130]="0:0:1:1:Elixir::1:0:", -- Recovery Diver's Potion
	[34131]="0:12:1:1:::1:0:", -- Building Tools
	[34132]="0:12:1:1:::1:0:", -- Donny's Letter
	[34133]="0:12:1:1:::1:0:", -- Large Barrel
	[34134]="0:12:1:1:::1:0:", -- Industrial Strength Rope
	[34135]="0:12:1:1:::1:0:", -- Dark Iron Ingots
	[34136]="0:12:1:1:::1:0:", -- Pristine Shoveltusk Hide
	[34137]="0:12:1:1:::1:0:", -- Steel Ribbing
	[34138]="0:2:3:1:Wand::1:0:", -- Enchanted White Wand
	[34139]="0:2:3:1:Wand::1:0:", -- Enchanted Crimson Wand
	[34140]="0:4:3:1:OffHandFrill::1:0:", -- Dark Iron Tankard
	[34141]="0:12:1:1:::1:0:", -- Dark Iron Ale Keg
	[34142]="0:3:3:1:GemPrismatic::1:0:", -- Infinite Sphere
	[34143]="0:3:3:1:GemPrismatic::1:0:", -- Chromatic Sphere
	[34157]="0:12:1:1:::1:0:", -- Head of Kael'thas
	[34160]="0:12:1:1:::1:0:", -- The Signet Ring of Prince Kael'thas
	[34162]="0:4:4:1:Trinket::1:0:18525", -- Battlemaster's Depravity
	[34163]="0:4:4:1:Trinket::1:0:18525", -- Battlemaster's Cruelty
	[34164]="0:2:4:1:OneHandSword::1:0:", -- Dragonscale-Encrusted Longblade
	[34165]="0:2:4:1:Dagger::1:0:", -- Fang of Kalecgos
	[34166]="0:4:4:1:Ring::1:0:", -- Band of Lucent Beams
	[34167]="0:4:4:1:Plate::1:0:", -- Legplates of the Holy Juggernaut
	[34168]="0:4:4:1:Mail::1:0:", -- Starstalker Legguards
	[34169]="0:4:4:1:Leather::1:0:", -- Breeches of Natural Aggression
	[34170]="0:4:4:1:Cloth::1:0:", -- Pantaloons of Calming Strife
	[34171]="0:15:1:1:Holiday::1:0:", -- Winter Stationery
	[34172]="160000:9:1:1:Leatherworking::1:0:20241", -- Pattern: Drums of Speed
	[34173]="160000:9:1:1:Leatherworking::1:0:20240", -- Pattern: Drums of Speed
	[34174]="160000:9:1:1:Leatherworking::1:0:20241", -- Pattern: Drums of Restoration
	[34175]="160000:9:1:1:Leatherworking::1:0:20240", -- Pattern: Drums of Restoration
	[34176]="0:2:4:1:OneHandMace::1:0:", -- Reign of Misery
	[34177]="0:4:4:1:Amulet::1:0:", -- Clutch of Demise
	[34178]="0:4:4:1:Amulet::1:0:", -- Collar of the Pit Lord
	[34179]="0:4:4:1:OffHandFrill::1:0:", -- Heart of the Pit
	[34180]="0:4:4:1:Plate::1:0:", -- Felfury Legplates
	[34181]="0:4:4:1:Cloth::1:0:", -- Leggings of Calamity
	[34182]="0:2:4:1:Stave::1:0:", -- Grand Magister's Staff of Torrents
	[34183]="0:2:4:1:Polearm::1:0:", -- Shivering Felspine
	[34184]="0:4:4:1:Amulet::1:0:", -- Brooch of the Highborne
	[34185]="0:4:4:1:Shield::1:0:", -- Sword Breaker's Bulwark
	[34186]="0:4:4:1:Mail::1:0:", -- Chain Links of the Tumultuous Storm
	[34188]="0:4:4:1:Leather::1:0:", -- Leggings of the Immortal Night
	[34189]="0:4:4:1:Ring::1:0:", -- Band of Ruinous Delight
	[34190]="0:4:4:1:Cloak::1:0:", -- Crimson Paragon's Cover
	[34191]="0:15:1:20:Holiday::1:0:", -- Handful of Snowflakes
	[34192]="0:4:4:1:Plate::1:0:", -- Pauldrons of Perseverance
	[34193]="0:4:4:1:Plate::1:0:", -- Spaulders of the Thalassian Savior
	[34194]="0:4:4:1:Mail::1:0:", -- Mantle of the Golden Forest
	[34195]="0:4:4:1:Leather::1:0:", -- Shoulderpads of Vehemence
	[34196]="0:2:4:1:Bow::1:0:", -- Golden Bow of Quel'Thalas
	[34197]="0:2:4:1:Dagger::1:0:", -- Shiv of Exsanguination
	[34198]="0:2:4:1:Stave::1:0:", -- Stanchion of Primal Instinct
	[34199]="0:2:4:1:OneHandMace::1:0:", -- Archon's Gavel
	[34200]="160000:9:1:1:Leatherworking::1:0:21655", -- Pattern: Quiver of a Thousand Feathers
	[34201]="160000:9:1:1:Leatherworking::1:0:17585", -- Pattern: Netherscale Ammo Pouch
	[34202]="0:4:4:1:Cloth::1:0:", -- Shawl of Wonderment
	[34203]="0:2:4:1:FistWeapon::1:0:", -- Grip of Mannoroth
	[34204]="0:4:4:1:Amulet::1:0:", -- Amulet of Unfettered Magics
	[34205]="0:4:4:1:Cloak::1:0:", -- Shroud of Redeemed Souls
	[34206]="0:4:4:1:OffHandFrill::1:0:", -- Book of Highborne Hymns
	[34207]="0:0:2:10:EnhPerm::1:0:", -- Glove Reinforcements
	[34208]="0:4:4:1:Mail::1:0:", -- Equilibrium Epaulets
	[34209]="0:4:4:1:Leather::1:0:", -- Spaulders of Reclamation
	[34210]="0:4:4:1:Cloth::1:0:", -- Amice of the Convoker
	[34211]="0:4:4:1:Leather::1:0:", -- Harness of Carnal Instinct
	[34212]="0:4:4:1:Leather::1:0:", -- Sunglow Vest
	[34213]="0:4:4:1:Ring::1:0:", -- Ring of Hardened Resolve
	[34214]="0:2:4:1:OneHandSword::1:0:", -- Muramasa
	[34215]="0:4:4:1:Plate::1:0:", -- Warharness of Reckless Fury
	[34216]="0:4:4:1:Plate::1:0:", -- Heroic Judicator's Chestguard
	[34218]="160000:9:1:1:Leatherworking::1:0:17657", -- Pattern: Netherscale Ammo Pouch
	[34220]="0:3:3:1:GemMeta::1:0:", -- Chaotic Skyfire Diamond
	[34221]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Chaotic Skyfire Diamond
	[34222]="0:15:1:1:Junk::1:0:", -- Fengir's Clue
	[34223]="0:15:1:1:Junk::1:0:", -- Rodin's Clue
	[34224]="0:15:1:1:Junk::1:0:", -- Isuldof's Clue
	[34225]="0:15:1:1:Junk::1:0:", -- Windan's Clue
	[34226]="0:12:1:1:::1:0:", -- Orfus's Bundle
	[34227]="0:4:4:1:Ring::1:0:", -- Deadman's Hand
	[34228]="0:4:4:1:Mail::1:0:", -- Vicious Hawkstrider Hauberk
	[34229]="0:4:4:1:Mail::1:0:", -- Garments of Serene Shores
	[34230]="0:4:4:1:Ring::1:0:", -- Ring of Omnipotence
	[34231]="0:4:4:1:Shield::1:0:", -- Aegis of Angelic Fortune
	[34232]="0:4:4:1:Cloth::1:0:", -- Fel Conquerer Raiments
	[34233]="0:4:4:1:Cloth::1:0:", -- Robes of Faltered Light
	[34234]="0:4:4:1:Leather::1:0:", -- Shadowed Gauntlets of Paroxysm
	[34235]="0:12:1:1:::1:0:", -- Sin'dorei Scrying Crystal
	[34236]="0:12:1:1:::1:0:", -- The Staff of Storm's Fury
	[34237]="0:12:1:1:::1:0:", -- The Frozen Heart of Isuldof
	[34238]="0:12:1:1:::1:0:", -- The Shield of the Aesirites
	[34239]="0:12:1:1:::1:0:", -- The Ancient Armor of the Kvaldir
	[34240]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Soothed Soul
	[34241]="0:4:4:1:Cloak::1:0:", -- Cloak of Unforgivable Sin
	[34242]="0:4:4:1:Cloak::1:0:", -- Tattered Cape of Antonidas
	[34243]="0:4:4:1:Plate::1:0:", -- Helm of Burning Righteousness
	[34244]="0:4:4:1:Leather::1:0:", -- Duplicitous Guise
	[34245]="0:4:4:1:Leather::1:0:", -- Cover of Ursol the Wise
	[34246]="0:12:1:20:::1:0:", -- Smuggled Mana Cell
	[34247]="207710:2:4:1:TwoHandSword::1:0:", -- Apolyon, the Soul-Render
	[34248]="0:12:1:1:::1:0:", -- Bash'ir Phasing Device
	[34249]="1000000:4:1:1:Amulet:202:1:0:19227", -- Hula Girl Doll
	[34253]="0:12:1:1:::1:0:", -- Sizzling Embers
	[34254]="0:12:1:20:::1:0:", -- Razorthorn Root
	[34255]="0:12:1:5:::1:0:", -- Razorthorn Flayer Gland
	[34256]="0:3:4:1:GemBlue::1:0:", -- Charmed Amani Jewel
	[34257]="0:12:1:1:::1:0:", -- Fel Siphon
	[34258]="0:0:1:20:Other::5:0:37674", -- Love Rocket
	[34259]="0:12:1:20:::1:0:", -- Demonic Blood
	[34261]="5000:9:2:1:Tailoring::1:0:13420", -- Pattern: Green Winter Clothes
	[34262]="5000:9:2:1:Leatherworking::1:0:13420,13433", -- Pattern: Winter Boots
	[34319]="5000:9:2:1:Tailoring::1:0:13433", -- Pattern: Red Winter Clothes
	[34329]="0:2:4:1:Dagger::1:0:", -- Crux of the Apocalypse
	[34330]="0:0:1:10:EnhPerm::1:0:", -- Heavy Knothide Armor Kit
	[34331]="0:2:4:1:FistWeapon::1:0:", -- Hand of the Deceiver
	[34332]="0:4:4:1:Mail::1:0:", -- Cowl of Gul'dan
	[34333]="0:4:4:1:Mail::1:0:", -- Coif of Alleria
	[34334]="182930:2:5:1:Bow::1:0:", -- Thori'dal, the Stars' Fury
	[34335]="0:2:4:1:OneHandMace::1:0:", -- Hammer of Sanctification
	[34336]="0:2:4:1:Dagger::1:0:", -- Sunflare
	[34337]="0:2:4:1:Stave::1:0:", -- Golden Staff of the Sin'dorei
	[34338]="0:12:1:4:::1:0:", -- Mana Remnants
	[34339]="0:4:4:1:Cloth::1:0:", -- Cowl of Light's Purity
	[34340]="0:4:4:1:Cloth::1:0:", -- Dark Conjuror's Collar
	[34341]="0:4:4:1:Plate::1:0:", -- Borderland Paingrips
	[34342]="0:4:4:1:Cloth::1:0:", -- Handguards of the Dawn
	[34343]="0:4:4:1:Mail::1:0:", -- Thalassian Ranger Gauntlets
	[34344]="0:4:4:1:Cloth::1:0:", -- Handguards of Defiled Worlds
	[34345]="0:4:4:1:Plate::1:0:", -- Crown of Anasterian
	[34346]="0:2:4:1:FistWeapon::1:0:", -- Mounting Vengeance
	[34347]="0:2:4:1:Wand::1:0:", -- Wand of the Demonsoul
	[34348]="0:2:4:1:Wand::1:0:", -- Wand of Cleansing Light
	[34349]="0:2:4:1:Thrown::1:0:", -- Blade of Life's Inevitability
	[34350]="0:4:4:1:Mail::1:0:", -- Gauntlets of the Ancient Shadowmoon
	[34351]="0:4:4:1:Leather::1:0:", -- Tranquil Majesty Wraps
	[34352]="0:4:4:1:Plate::1:0:", -- Borderland Fortress Grips
	[34353]="0:4:4:1:Leather::1:0:", -- Quad Deathblow X44 Goggles
	[34354]="0:4:4:1:Plate::1:0:", -- Mayhem Projection Goggles
	[34355]="0:4:4:1:Mail::1:0:", -- Lightning Etched Specs
	[34356]="0:4:4:1:Mail::1:0:", -- Surestrike Goggles v3.0
	[34357]="0:4:4:1:Plate::1:0:", -- Hard Khorium Goggles
	[34358]="0:4:4:1:Amulet::1:0:", -- Hard Khorium Choker
	[34359]="0:4:4:1:Amulet::1:0:", -- Pendant of Sunfire
	[34360]="0:4:4:1:Amulet::1:0:", -- Amulet of Flowing Life
	[34361]="0:4:4:1:Ring::1:0:", -- Hard Khorium Band
	[34362]="0:4:4:1:Ring::1:0:", -- Loop of Forged Power
	[34363]="0:4:4:1:Ring::1:0:", -- Ring of Flowing Life
	[34364]="0:4:4:1:Cloth::1:0:", -- Sunfire Robe
	[34365]="0:4:4:1:Cloth::1:0:", -- Robe of Eternal Light
	[34366]="0:4:4:1:Cloth::1:0:", -- Sunfire Handwraps
	[34367]="0:4:4:1:Cloth::1:0:", -- Hands of Eternal Light
	[34368]="0:12:1:1:::1:0:", -- Attuned Crystal Cores
	[34369]="0:4:4:1:Leather::1:0:", -- Carapace of Sun and Shadow
	[34370]="0:4:4:1:Leather::1:0:", -- Gloves of Immortal Dusk
	[34371]="0:4:4:1:Leather::1:0:", -- Leather Chestguard of the Sun
	[34372]="0:4:4:1:Leather::1:0:", -- Leather Gauntlets of the Sun
	[34373]="0:4:4:1:Mail::1:0:", -- Embrace of the Phoenix
	[34374]="0:4:4:1:Mail::1:0:", -- Fletcher's Gloves of the Phoenix
	[34375]="0:4:4:1:Mail::1:0:", -- Sun-Drenched Scale Chestguard
	[34376]="0:4:4:1:Mail::1:0:", -- Sun-Drenched Scale Gloves
	[34377]="0:4:4:1:Plate::1:0:", -- Hard Khorium Battleplate
	[34378]="0:4:4:1:Plate::1:0:", -- Hard Khorium Battlefists
	[34379]="0:4:4:1:Plate::1:0:", -- Sunblessed Breastplate
	[34380]="0:4:4:1:Plate::1:0:", -- Sunblessed Gauntlets
	[34381]="0:4:4:1:Plate::1:0:25977", -- Felstrength Legplates
	[34382]="0:4:4:1:Plate::1:0:25977", -- Judicator's Legguards
	[34383]="0:4:4:1:Mail::1:0:25977", -- Kilt of Spiritual Reconstruction
	[34384]="0:4:4:1:Leather::1:0:25977", -- Breeches of Natural Splendor
	[34385]="0:4:4:1:Leather::1:0:25977", -- Leggings of the Immortal Beast
	[34386]="0:4:4:1:Cloth::1:0:25977", -- Pantaloons of Growing Strife
	[34387]="0:12:1:5:::1:0:", -- Barrel of Blasting Powder
	[34388]="0:4:4:1:Plate::1:0:25977", -- Pauldrons of Berserking
	[34389]="0:4:4:1:Plate::1:0:25977", -- Spaulders of the Thalassian Defender
	[34390]="0:4:4:1:Mail::1:0:25977", -- Erupting Epaulets
	[34391]="0:4:4:1:Leather::1:0:25977", -- Spaulders of Devastation
	[34392]="0:4:4:1:Leather::1:0:25977", -- Demontooth Shoulderpads
	[34393]="0:4:4:1:Cloth::1:0:25977", -- Shoulderpads of Knowledge's Pursuit
	[34394]="0:4:4:1:Plate::1:0:25977", -- Breastplate of Agony's Aversion
	[34395]="0:4:4:1:Plate::1:0:25977", -- Noble Judicator's Chestguard
	[34396]="0:4:4:1:Mail::1:0:25977", -- Garments of Crashing Shores
	[34397]="0:4:4:1:Leather::1:0:25977", -- Bladed Chaos Tunic
	[34398]="0:4:4:1:Leather::1:0:25977", -- Utopian Tunic of Elune
	[34399]="0:4:4:1:Cloth::1:0:25977", -- Robes of Ghostly Hatred
	[34400]="0:4:4:1:Plate::1:0:25977", -- Crown of Dath'Remar
	[34401]="0:4:4:1:Plate::1:0:25977", -- Helm of Uther's Resolve
	[34402]="0:4:4:1:Mail::1:0:25977", -- Shroud of Chieftain Ner'zhul
	[34403]="0:4:4:1:Leather::1:0:25977", -- Cover of Ursoc the Mighty
	[34404]="0:4:4:1:Leather::1:0:25977", -- Mask of the Fury Hunter
	[34405]="0:4:4:1:Cloth::1:0:25977", -- Helm of Arcane Purity
	[34406]="0:4:4:1:Cloth::1:0:25977", -- Gloves of Tyri's Power
	[34407]="0:4:4:1:Leather::1:0:25977", -- Tranquil Moonlight Wraps
	[34408]="0:4:4:1:Leather::1:0:25977", -- Gloves of the Forest Drifter
	[34409]="0:4:4:1:Mail::1:0:25977", -- Gauntlets of the Ancient Frostwolf
	[34410]="4000:0:1:20:Consumable::5:0:13418,13430,13431,13434,13436,23009,23011,23065", -- Honeyed Holiday Ham
	[34411]="0:0:1:20:FoodDrink::1:0:", -- Hot Apple Cider
	[34412]="1000:0:1:20:Consumable:185:5:0:13418,13430,13431,13434,13436,23009,23011,23065", -- Sparkling Apple Cider
	[34413]="10000:9:1:1:Cooking::1:0:13420,13433", -- Recipe: Hot Apple Cider
	[34414]="0:12:1:1:::1:0:", -- Shattered Sun Banner
	[34416]="0:4:3:1:Cloth::1:0:", -- Gloves of the Dune
	[34417]="0:4:3:1:Leather::1:0:", -- Marauder's Handwraps
	[34418]="0:2:3:1:Wand::1:0:", -- Scrying Wand
	[34419]="0:2:3:1:Thrown::1:0:", -- Thorium Flight Blade
	[34420]="0:12:1:1:::1:0:", -- Captured Legion Scroll
	[34421]="0:4:3:1:Mail::1:0:", -- Cave Crawler's Mail Treads
	[34422]="0:4:3:1:Plate::1:0:", -- Tempered Thorium Boots
	[34423]="0:4:3:1:Trinket::1:0:", -- Strength of the High Chief
	[34424]="0:4:3:1:Trinket::1:0:", -- Power of the High Chief
	[34425]="0:15:3:1:Companion::1:0:", -- Clockwork Rocket Bot
	[34426]="0:15:1:1:Junk::1:0:", -- Winter Veil Gift
	[34427]="0:4:4:1:Trinket::1:0:", -- Blackened Naaru Sliver
	[34428]="0:4:4:1:Trinket::1:0:", -- Steely Naaru Sliver
	[34429]="0:4:4:1:Trinket::1:0:", -- Shifting Naaru Sliver
	[34430]="0:4:4:1:Trinket::1:0:", -- Glimmering Naaru Sliver
	[34431]="0:4:4:1:Plate::1:0:25976", -- Lightbringer Bands
	[34432]="0:4:4:1:Plate::1:0:25976", -- Lightbringer Bracers
	[34433]="0:4:4:1:Plate::1:0:25976", -- Lightbringer Wristguards
	[34434]="0:4:4:1:Cloth::1:0:25976", -- Bracers of Absolution
	[34435]="0:4:4:1:Cloth::1:0:25976", -- Cuffs of Absolution
	[34436]="0:4:4:1:Cloth::1:0:25976", -- Bracers of the Malefic
	[34437]="0:4:4:1:Mail::1:0:25976", -- Skyshatter Bands
	[34438]="0:4:4:1:Mail::1:0:25976", -- Skyshatter Bracers
	[34439]="0:4:4:1:Mail::1:0:25976", -- Skyshatter Wristguards
	[34440]="0:0:1:20:Potion::1:0:", -- Mad Alchemist's Potion
	[34441]="0:4:4:1:Plate::1:0:25976", -- Onslaught Bracers
	[34442]="0:4:4:1:Plate::1:0:25976", -- Onslaught Wristguards
	[34443]="0:4:4:1:Mail::1:0:25976", -- Gronnstalker's Bracers
	[34444]="0:4:4:1:Leather::1:0:25976", -- Thunderheart Wristguards
	[34445]="0:4:4:1:Leather::1:0:25976", -- Thunderheart Bracers
	[34446]="0:4:4:1:Leather::1:0:25976", -- Thunderheart Bands
	[34447]="0:4:4:1:Cloth::1:0:25976", -- Bracers of the Tempest
	[34448]="0:4:4:1:Leather::1:0:25976", -- Slayer's Bracers
	[34468]="0:12:1:1:::1:0:", -- Sorlof's Booty
	[34469]="0:12:1:1:::1:0:", -- Strange Engine Part
	[34470]="0:4:4:1:Trinket::1:0:", -- Timbal's Focusing Crystal
	[34471]="0:4:4:1:Trinket::1:0:", -- Vial of the Sunwell
	[34472]="0:4:4:1:Trinket::1:0:", -- Shard of Contempt
	[34473]="0:4:4:1:Trinket::1:0:", -- Commendation of Kael'thas
	[34474]="0:12:1:1:::1:0:", -- Strange Engine Part
	[34475]="0:0:1:1:Consumable::1:0:", -- Arcane Charges
	[34476]="0:12:0:1:::1:0:", -- Broken Engine Part
	[34477]="0:13:1:10:::1:0:", -- Darkspine Chest Key
	[34478]="0:15:3:1:Companion::1:0:18382", -- Tiny Sporebat
	[34479]="0:12:1:10:::1:0:", -- Darkspine Iron Ore
	[34480]="0:15:3:1:Junk::1:0:37674", -- Romantic Picnic Basket
	[34482]="0:1:2:1:LeatherworkingBag::1:0:", -- Leatherworker's Satchel
	[34483]="0:12:1:10:::1:0:", -- Orb of Murloc Control
	[34484]="0:4:2:1:OffHandFrill::1:0:", -- Old Ironjaw
	[34485]="0:4:4:1:Plate::1:0:25976", -- Lightbringer Girdle
	[34486]="0:4:2:1:OffHandFrill::1:0:", -- Old Crafty
	[34487]="0:4:4:1:Plate::1:0:25976", -- Lightbringer Belt
	[34488]="0:4:4:1:Plate::1:0:25976", -- Lightbringer Waistguard
	[34489]="0:12:1:1:::1:0:", -- Flaming Oil
	[34490]="0:1:3:1:LeatherworkingBag::1:0:", -- Bag of Many Hides
	[34491]="0:9:2:1:Leatherworking::1:0:", -- Pattern: Bag of Many Hides
	[34492]="0:15:3:1:Companion::1:0:", -- Rocket Chicken
	[34493]="0:15:4:1:Companion::1:0:", -- Dragon Kite
	[34494]="0:15:1:1:Junk::1:0:", -- Paper Zeppelin
	[34497]="0:15:1:5:Junk::1:0:", -- Paper Flying Machine
	[34498]="50000:15:1:1:Junk::1:0:29478,29716", -- Paper Zeppelin Kit
	[34499]="0:15:3:1:Junk::1:0:", -- Paper Flying Machine Kit
	[34500]="0:12:1:5:::1:0:", -- Ata'mal Armament
	[34501]="0:12:1:5:::1:0:", -- Cleansed Ata'mal Metal
	[34502]="0:12:1:20:::1:0:", -- Bloodberry
	[34504]="0:0:1:1:Other::1:0:", -- Adamantite Shell Machine
	[34518]="0:15:3:1:Companion::1:0:", -- Golden Pig Coin
	[34519]="0:15:3:1:Companion::1:0:", -- Silver Pig Coin
	[34527]="0:4:4:1:Cloth::1:0:25976", -- Belt of Absolution
	[34528]="0:4:4:1:Cloth::1:0:25976", -- Cord of Absolution
	[34529]="0:2:4:1:Bow::1:0:", -- Vengeful Gladiator's Longbow
	[34530]="0:2:4:1:Gun::1:0:", -- Vengeful Gladiator's Rifle
	[34533]="0:12:1:1:::1:0:", -- Astromancer's Crystal
	[34535]="0:15:1:1:Companion::1:0:", -- Azure Whelpling
	[34537]="0:0:1:20:Elixir::1:0:", -- Bloodberry Elixir
	[34538]="0:0:1:1:EnhTemp::1:0:", -- Blessed Weapon Coating
	[34539]="0:0:1:1:EnhTemp::1:0:", -- Righteous Weapon Coating
	[34540]="0:2:4:1:Stave::1:0:", -- Vengeful Gladiator's Battle Staff
	[34541]="0:4:4:1:Cloth::1:0:25976", -- Belt of the Malefic
	[34542]="0:4:4:1:Mail::1:0:25976", -- Skyshatter Cord
	[34543]="0:4:4:1:Mail::1:0:25976", -- Skyshatter Belt
	[34545]="0:4:4:1:Mail::1:0:25976", -- Skyshatter Girdle
	[34546]="0:4:4:1:Plate::1:0:25976", -- Onslaught Belt
	[34547]="0:4:4:1:Plate::1:0:25976", -- Onslaught Waistguard
	[34549]="0:4:4:1:Mail::1:0:25976", -- Gronnstalker's Belt
	[34554]="0:4:4:1:Leather::1:0:25976", -- Thunderheart Belt
	[34555]="0:4:4:1:Leather::1:0:25976", -- Thunderheart Cord
	[34556]="0:4:4:1:Leather::1:0:25976", -- Thunderheart Waistguard
	[34557]="0:4:4:1:Cloth::1:0:25976", -- Belt of the Tempest
	[34558]="0:4:4:1:Leather::1:0:25976", -- Slayer's Belt
	[34559]="0:4:4:1:Plate::1:0:25976", -- Lightbringer Treads
	[34560]="0:4:4:1:Plate::1:0:25976", -- Lightbringer Stompers
	[34561]="0:4:4:1:Plate::1:0:25976", -- Lightbringer Boots
	[34562]="0:4:4:1:Cloth::1:0:25976", -- Boots of Absolution
	[34563]="0:4:4:1:Cloth::1:0:25976", -- Treads of Absolution
	[34564]="0:4:4:1:Cloth::1:0:25976", -- Boots of the Malefic
	[34565]="0:4:4:1:Mail::1:0:25976", -- Skyshatter Boots
	[34566]="0:4:4:1:Mail::1:0:25976", -- Skyshatter Treads
	[34567]="0:4:4:1:Mail::1:0:25976", -- Skyshatter Greaves
	[34568]="0:4:4:1:Plate::1:0:25976", -- Onslaught Boots
	[34569]="0:4:4:1:Plate::1:0:25976", -- Onslaught Treads
	[34570]="0:4:4:1:Mail::1:0:25976", -- Gronnstalker's Boots
	[34571]="0:4:4:1:Leather::1:0:25976", -- Thunderheart Boots
	[34572]="0:4:4:1:Leather::1:0:25976", -- Thunderheart Footwraps
	[34573]="0:4:4:1:Leather::1:0:25976", -- Thunderheart Treads
	[34574]="0:4:4:1:Cloth::1:0:25976", -- Boots of the Tempest
	[34575]="0:4:4:1:Leather::1:0:25976", -- Slayer's Boots
	[34576]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Cruelty
	[34577]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Depravity
	[34578]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Determination
	[34579]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Audacity
	[34580]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Perseverance
	[34581]="10000:6:4:1000:Arrow::200:0:18255,25195,25196,29493", -- Mysterious Arrow
	[34582]="10000:6:4:1000:Bullet::200:0:18255,25195,25196,29493", -- Mysterious Shell
	[34583]="0:0:1:1:Consumable::1:0:", -- Aldor Supplies Package
	[34584]="0:0:1:1:Consumable::1:0:", -- Scryer Supplies Package
	[34585]="0:0:1:1:Consumable::1:0:", -- Scryer Supplies Package
	[34587]="0:0:1:1:Consumable::1:0:", -- Aldor Supplies Package
	[34592]="0:0:1:1:Consumable::1:0:", -- Aldor Supplies Package
	[34593]="0:0:1:1:Consumable::1:0:", -- Scryer Supplies Package
	[34594]="0:0:1:1:Consumable::1:0:", -- Scryer Supplies Package
	[34595]="0:0:1:1:Consumable::1:0:", -- Aldor Supplies Package
	[34597]="0:15:1:100:Junk::1:0:", -- Winterfin Clam
	[34598]="0:12:1:1:::1:0:", -- The King's Empty Conch
	[34599]="0:0:1:40:Consumable::5:0:26123,26124", -- Juggling Torch
	[34600]="0:13:1:1:::1:0:", -- Urmgrgl's Key
	[34601]="0:4:4:1:Plate::1:0:", -- Shoulderplates of Everlasting Pain
	[34602]="0:4:4:1:Leather::1:0:", -- Eversong Cuffs
	[34603]="0:2:4:1:Thrown::1:0:", -- Distracting Blades
	[34604]="0:2:4:1:Dagger::1:0:", -- Jaded Crystal Dagger
	[34605]="0:4:4:1:Plate::1:0:", -- Breastplate of Fierce Survival
	[34606]="0:2:4:1:Dagger::1:0:", -- Edge of Oppression
	[34607]="0:4:4:1:Cloth::1:0:", -- Fel-tinged Mantle
	[34608]="0:2:4:1:Stave::1:0:", -- Rod of the Blazing Light
	[34609]="0:2:4:1:OneHandSword::1:0:", -- Quickening Blade of the Prince
	[34610]="0:4:4:1:Cloth::1:0:", -- Scarlet Sin'dorei Robes
	[34611]="0:2:4:1:OneHandMace::1:0:", -- Cudgel of Consecration
	[34612]="0:4:4:1:Plate::1:0:", -- Greaves of the Penitent Knight
	[34613]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Silvermoon Retainer
	[34614]="0:4:4:1:Mail::1:0:", -- Tunic of the Ranger Lord
	[34615]="0:4:4:1:Plate::1:0:", -- Netherforce Chestplate
	[34616]="0:2:4:1:OneHandAxe::1:0:", -- Breeching Comet
	[34617]="0:12:1:1:::1:0:", -- Glrggl's Head
	[34618]="0:12:1:10:::1:0:", -- Succulent Orca Blubber
	[34619]="0:12:1:1:::1:0:", -- King Mrgl-Mrgl's Spare Suit
	[34620]="0:12:1:1:::1:0:", -- King Mrgl-Mrgl's Spare Suit
	[34621]="0:12:1:1:::1:0:", -- Claw of Claximus
	[34622]="0:2:4:1:Thrown::1:0:", -- Spinesever
	[34623]="0:12:1:1:::1:0:", -- The King's Filled Conch
	[34624]="0:12:1:1:::1:0:", -- Bundle of Vrykul Artifacts
	[34625]="0:4:4:1:Ring::1:0:", -- Kharmaa's Ring of Fate
	[34627]="0:3:3:1:GemYellow::1:0:", -- Heavy Tonk Armor
	[34645]="0:7:1:10:Part::1:0:", -- Earthen Ink
	[34647]="0:7:1:20:Other::1:0:", -- Rough Parchment
	[34648]="0:4:2:1:Plate::1:0:", -- Acherus Knight's Greaves
	[34649]="0:4:2:1:Plate::1:0:", -- Acherus Knight's Gauntlets
	[34650]="0:4:2:1:Plate::1:0:", -- Acherus Knight's Tunic
	[34651]="0:4:2:1:Plate::1:0:", -- Acherus Knight's Girdle
	[34652]="0:4:2:1:Plate::1:0:", -- Acherus Knight's Hood
	[34653]="0:4:2:1:Plate::1:0:", -- Acherus Knight's Wristguard
	[34655]="0:4:2:1:Plate::1:0:", -- Acherus Knight's Pauldrons
	[34656]="0:4:2:1:Plate::1:0:", -- Acherus Knight's Legplates
	[34657]="0:4:2:1:Amulet::1:0:", -- Choker of Damnation
	[34658]="0:4:2:1:Ring::1:0:", -- Plague Band
	[34659]="0:4:2:1:Cloak::1:0:", -- Acherus Knight's Shroud
	[34663]="0:7:1:20:Other::1:0:", -- Silver Quill
	[34664]="0:7:3:20:Other:164,755,165,197:1:0:", -- Sunmote
	[34665]="459015:2:3:1:Dagger::1:0:25032", -- Bombardier's Blade
	[34666]="460643:2:3:1:OneHandSword::1:0:25032", -- The Sunbreaker
	[34667]="418194:2:3:1:OneHandSword::1:0:25032", -- Archmage's Guile
	[34669]="0:12:1:1:::1:0:", -- Arcanometer
	[34670]="434690:2:3:1:OneHandMace::1:0:25032", -- Seeker's Gavel
	[34671]="436317:2:3:1:OneHandMace::1:0:25032", -- K'iru's Presage
	[34672]="437945:2:3:1:OneHandSword::1:0:25032", -- Inuuro's Blade
	[34673]="549466:2:3:1:TwoHandAxe::1:0:25032", -- Legionfoe
	[34674]="330867:2:3:1:Crossbow::1:0:25032", -- Truestrike Crossbow
	[34675]="377842:4:4:1:Shield::1:0:25032", -- Sunward Crest
	[34676]="379231:4:4:1:Shield::1:0:25032", -- Dawnforged Defender
	[34677]="232752:4:4:1:Amulet::1:0:25032", -- Shattered Sun Pendant of Restoration
	[34678]="232752:4:4:1:Amulet::1:0:25032", -- Shattered Sun Pendant of Acumen
	[34679]="232752:4:4:1:Amulet::1:0:25032", -- Shattered Sun Pendant of Might
	[34680]="232752:4:4:1:Amulet::1:0:25032", -- Shattered Sun Pendant of Resolve
	[34683]="0:4:1:1:Miscellaneous::1:0:26123,26124", -- Sandals of Summer
	[34684]="0:15:1:20:Holiday::1:0:26123,26124", -- Handful of Summer Petals
	[34685]="0:4:1:1:Miscellaneous::1:0:26123,26124", -- Vestment of Summer
	[34686]="0:0:3:1:Consumable::1:0:26123,26124", -- Brazier of Dancing Flames
	[34688]="0:13:1:1:::1:0:", -- Beryl Prison Key
	[34689]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Chaotic Skyfire Diamond
	[34690]="0:12:1:1:::1:0:", -- Warsong Banner
	[34691]="0:12:1:1:::1:0:", -- Arcane Binder
	[34692]="0:12:1:1:::1:0:", -- Ragefist's Torch
	[34695]="0:12:1:1:::1:0:", -- Enlistment Card
	[34697]="0:4:3:1:Cloth::1:0:", -- Bindings of Raging Fire
	[34698]="0:4:3:1:Mail::1:0:", -- Bracers of the Forest Stalker
	[34699]="0:2:3:1:OneHandAxe::1:0:", -- Sun-forged Cleaver
	[34700]="0:4:3:1:Plate::1:0:", -- Gauntlets of Divine Blessings
	[34701]="0:4:3:1:Leather::1:0:", -- Leggings of the Betrayed
	[34702]="0:4:3:1:Cloak::1:0:", -- Cloak of Swift Mending
	[34703]="0:2:3:1:OneHandSword::1:0:", -- Latro's Dancing Blade
	[34704]="0:4:3:1:Ring::1:0:", -- Band of Arcane Alacrity
	[34705]="0:4:3:1:Cloth::1:0:", -- Bracers of Divine Infusion
	[34706]="0:4:3:1:Ring::1:0:", -- Band of Determination
	[34707]="0:4:3:1:Leather::1:0:", -- Boots of Resuscitation
	[34708]="0:4:3:1:Cloak::1:0:", -- Cloak of the Coming Night
	[34709]="0:12:1:15:::1:0:", -- Warsong Munitions
	[34710]="0:12:1:1:::1:0:", -- Seaforium Depth Charge Bundle
	[34711]="0:12:1:10:::1:0:", -- Core of Malice
	[34713]="0:12:1:10:::1:0:", -- Tuskarr Ritual Object
	[34714]="0:12:1:1:::1:0:", -- Kul Tiras Wine
	[34715]="0:12:1:1:::1:0:", -- Tuskarr Ritual Object
	[34719]="0:12:1:1:::1:0:", -- Luther's Journal
	[34720]="0:12:1:1:::1:0:", -- Barthus's Note
	[34721]="0:0:1:20:Bandage::1:0:", -- Frostweave Bandage
	[34722]="0:0:1:20:Bandage::1:0:", -- Heavy Frostweave Bandage
	[34736]="0:7:1:20:Meat:185:1:0:", -- Chunk o' Mammoth
	[34747]="0:0:1:20:FoodDrink::1:0:", -- Northern Stew
	[34748]="0:0:1:20:FoodDrink::1:0:", -- Mammoth Meal
	[34749]="0:0:1:20:FoodDrink::1:0:", -- Shoveltusk Steak
	[34750]="0:0:1:20:FoodDrink::1:0:", -- Worm Delight
	[34751]="0:0:1:20:FoodDrink::1:0:", -- Roasted Worg
	[34752]="0:0:1:20:FoodDrink::1:0:", -- Rhino Dogs
	[34753]="0:0:1:20:FoodDrink::1:0:", -- Great Feast
	[34754]="0:0:1:20:FoodDrink::1:0:", -- Mega Mammoth Meal
	[34755]="0:0:1:20:FoodDrink::1:0:", -- Tender Shoveltusk Steak
	[34756]="0:0:1:20:FoodDrink::1:0:", -- Spiced Worm Burger
	[34757]="0:0:1:20:FoodDrink::1:0:", -- Very Burnt Worg
	[34758]="0:0:1:20:FoodDrink::1:0:", -- Mighty Rhino Dogs
	[34759]="0:0:1:20:FoodDrink::1:0:", -- Smoked Rockfin
	[34760]="0:0:1:20:FoodDrink::1:0:", -- Grilled Bonescale
	[34761]="0:0:1:20:FoodDrink::1:0:", -- Sauteed Goby
	[34762]="0:0:1:20:FoodDrink::1:0:", -- Grilled Sculpin
	[34763]="0:0:1:20:FoodDrink::1:0:", -- Smoked Salmon
	[34764]="0:0:1:20:FoodDrink::1:0:", -- Poached Nettlefish
	[34765]="0:0:1:20:FoodDrink::1:0:", -- Pickled Fangtooth
	[34766]="0:0:1:20:FoodDrink::1:0:", -- Poached Northern Sculpin
	[34767]="0:0:1:20:FoodDrink::1:0:", -- Firecracker Salmon
	[34768]="0:0:1:20:FoodDrink::1:0:", -- Spicy Blue Nettlefish
	[34769]="0:0:1:20:FoodDrink::1:0:", -- Imperial Manta Steak
	[34772]="0:12:1:10:::1:0:", -- Gnomish Grenade
	[34773]="0:12:1:1:::1:0:", -- Farseer Grimwalker's Remains
	[34774]="0:12:1:10:::1:0:", -- Scourged Earth
	[34775]="0:12:1:10:::1:0:", -- Scourged Mammoth Pelt
	[34777]="0:12:1:1:::1:0:", -- Ith'rix's Hardened Carapace
	[34778]="0:12:1:1:::1:0:", -- Imperean's Primal
	[34779]="0:12:1:1:::1:0:", -- Imperean's Primal
	[34780]="5000:0:1:20:FoodDrink::5:0:25032", -- Naaru Ration
	[34781]="0:12:1:1:::1:0:", -- Kaganishu's Fetish
	[34782]="0:4:1:1:Cloak::1:0:", -- Imbued Scourge Shroud
	[34783]="0:2:3:1:Thrown::1:0:", -- Nightstrike
	[34785]="0:12:1:1:::1:0:", -- Pneumatic Tank Transjigamarig
	[34786]="0:12:1:10:::1:0:", -- Super Strong Metal Plate
	[34787]="0:12:1:20:::1:0:", -- Crafty's Stuff
	[34788]="0:4:3:1:Cloth::1:0:", -- Duskhallow Mantle
	[34789]="0:4:3:1:Plate::1:0:", -- Bracers of Slaughter
	[34790]="0:2:3:1:OneHandMace::1:0:", -- Battle-mace of the High Priestess
	[34791]="0:4:3:1:Mail::1:0:", -- Gauntlets of the Tranquil Waves
	[34792]="0:4:3:1:Cloak::1:0:", -- Cloak of the Betrayed
	[34793]="0:4:3:1:Cloth::1:0:", -- Cord of Reconstruction
	[34794]="0:2:3:1:TwoHandAxe::1:0:", -- Axe of Shattered Dreams
	[34795]="0:4:3:1:Plate::1:0:", -- Helm of Sanctification
	[34796]="0:4:3:1:Leather::1:0:", -- Robes of Summer Flame
	[34797]="0:2:3:1:Stave::1:0:", -- Sun-infused Focus Staff
	[34798]="0:4:3:1:Ring::1:0:", -- Band of Celerity
	[34799]="0:4:4:1:Mail::1:0:", -- Hauberk of the War Bringer
	[34800]="0:12:1:5:::1:0:", -- Tempest Mote
	[34801]="0:12:1:1:::1:0:", -- Crafty's Shopping List
	[34802]="0:12:1:1:::1:0:", -- Crafty's Tools
	[34804]="0:12:1:1:::1:0:", -- A Handful of Rocknar's Grit
	[34806]="0:12:1:1:::1:0:", -- Sage Aeire's Totem
	[34807]="0:4:4:1:Plate::1:0:", -- Sunstrider Warboots
	[34808]="0:4:4:1:Cloth::1:0:", -- Gloves of Arcane Acuity
	[34809]="0:4:4:1:Leather::1:0:", -- Sunrage Treads
	[34810]="0:4:4:1:Cloak::1:0:", -- Cloak of Blade Turning
	[34811]="0:12:1:1:::1:0:", -- Neural Needler
	[34812]="0:12:1:1:::1:0:", -- Crafty's Ultra-Advanced Proto-Typical Shortening Blaster
	[34813]="0:12:1:1:::1:0:", -- Horn of the Ancient Mariner
	[34814]="0:12:1:8:::1:0:", -- Tuskarr Relic
	[34815]="0:12:1:1:::1:0:", -- Vial of Fresh Blood
	[34822]="0:15:0:20:Junk::1:0:", -- Ancient Coin
	[34823]="0:15:0:20:Junk::1:0:", -- Beautiful Glass Eye
	[34824]="0:15:0:20:Junk::1:0:", -- Silver Statuette
	[34825]="0:15:0:20:Junk::1:0:", -- Mithril Shaving Razor
	[34826]="0:4:1:1:Ring::1:0:", -- Gold Wedding Band
	[34827]="0:4:1:1:Miscellaneous::1:0:", -- Noble's Monocle
	[34828]="0:4:1:1:Miscellaneous::1:0:", -- Antique Silver Cufflinks
	[34829]="0:4:1:1:OffHandFrill::1:0:", -- Ornate Drinking Stein
	[34830]="0:12:1:1:::1:0:", -- Tuskarr Torch
	[34831]="0:3:3:1:GemBlue::1:0:", -- Eye of the Sea
	[34832]="0:0:1:20:FoodDrink::1:0:", -- Captain Rumsey's Lager
	[34833]="0:12:1:1:::1:0:", -- Unlit Torches
	[34834]="0:9:2:1:Cooking::1:0:", -- Recipe: Captain Rumsey's Lager
	[34836]="0:0:2:5:EnhPerm::1:0:", -- Spun Truesilver Fishing Line
	[34837]="0:4:4:1:Ring::1:0:", -- The 2 Ring
	[34838]="0:15:0:1:Junk::1:0:", -- Mariner's Log
	[34839]="0:15:0:10:Junk::1:0:", -- Piece of Polished Driftwood
	[34840]="0:15:0:1:Junk::1:0:", -- Broken Spyglass
	[34841]="16000:15:0:5:Junk::1:0:29561", -- Salvaged Scrap Metal
	[34842]="0:12:1:10:::1:0:", -- Warsong Outfit
	[34843]="0:15:0:10:Junk::1:0:", -- Giant Shark Tooth
	[34844]="0:12:1:1:::1:0:", -- Horn of the Ancient Mariner
	[34845]="0:1:4:1:Bag::1:0:", -- Pit Lord's Satchel
	[34846]="0:15:2:1:Junk::1:0:", -- Black Sack of Gems
	[34847]="0:4:4:1:Cloth::1:0:", -- Annihilator Holo-Gogs
	[34848]="0:15:4:1:ArmorToken::1:0:", -- Bracers of the Forgotten Conqueror
	[34850]="100:0:1:5:Consumable::1:0:8117,8118,15011,15012", -- Midsummer Ground Flower
	[34851]="0:15:4:1:ArmorToken::1:0:", -- Bracers of the Forgotten Protector
	[34852]="0:15:4:1:ArmorToken::1:0:", -- Bracers of the Forgotten Vanquisher
	[34853]="0:15:4:1:ArmorToken::1:0:", -- Belt of the Forgotten Conqueror
	[34854]="0:15:4:1:ArmorToken::1:0:", -- Belt of the Forgotten Protector
	[34855]="0:15:4:1:ArmorToken::1:0:", -- Belt of the Forgotten Vanquisher
	[34856]="0:15:4:1:ArmorToken::1:0:", -- Boots of the Forgotten Conqueror
	[34857]="0:15:4:1:ArmorToken::1:0:", -- Boots of the Forgotten Protector
	[34858]="0:15:4:1:ArmorToken::1:0:", -- Boots of the Forgotten Vanquisher
	[34859]="0:2:1:1:Dagger::1:0:", -- Razor Sharp Fillet Knife
	[34860]="0:15:0:5:Junk::1:0:", -- Rusted Lock
	[34861]="0:0:1:20:EnhTemp::1:0:", -- Sharpened Fish Hook
	[34862]="0:12:1:1:::1:0:", -- Practice Torches
	[34863]="0:15:1:1:Junk::1:0:", -- Bag of Fishing Treasures
	[34864]="0:12:1:1:::1:0:", -- Baby Crocolisk
	[34865]="0:12:1:1:::1:0:", -- Blackfin Darter
	[34866]="0:12:1:20:::1:0:", -- Giant Freshwater Shrimp
	[34867]="0:12:1:1:::1:0:", -- Monstrous Felblood Snapper
	[34868]="0:12:1:1:::1:0:", -- World's Largest Mudfish
	[34869]="0:12:1:1:::1:0:", -- Warsong Banner
	[34870]="0:12:1:1:::1:0:", -- Warsong Orc Disguise
	[34871]="0:15:1:1:Junk::1:0:", -- Crafty's Sack
	[34872]="150000:9:1:1:Enchanting::1:0:25032", -- Formula: Void Shatter
	[34887]="0:4:4:1:Ring::1:0:25046,27667", -- Angelista's Revenge
	[34888]="0:4:4:1:Ring::1:0:25046,27667", -- Ring of the Stalwart Protector
	[34889]="0:4:4:1:Ring::1:0:25046,27667", -- Fused Nethergon Band
	[34890]="0:4:4:1:Ring::1:0:25046,27667", -- Anveena's Touch
	[34891]="0:2:4:1:TwoHandAxe::1:0:25046,27667", -- The Blade of Harbingers
	[34892]="0:2:4:1:Crossbow::1:0:25046,27667", -- Crossbow of Relentless Strikes
	[34893]="0:2:4:1:FistWeapon::1:0:25046,27667", -- Vanir's Right Fist of Brutality
	[34894]="0:2:4:1:Dagger::1:0:25046,27667", -- Blade of Serration
	[34895]="0:2:4:1:Dagger::1:0:25046,27667", -- Scryer's Blade of Focus
	[34896]="0:2:4:1:OneHandMace::1:0:25046,27667", -- Gavel of Naaru Blessings
	[34897]="0:12:1:1:::1:0:", -- Beryl Shield Detonator
	[34898]="0:2:4:1:Stave::1:0:25046,27667", -- Staff of the Forest Lord
	[34900]="0:4:4:1:Leather::1:0:25046,27667", -- Shroud of Nature's Harmony
	[34901]="0:4:4:1:Leather::1:0:25046,27667", -- Grovewalker's Leggings
	[34902]="0:4:4:1:Leather::1:0:25046,27667", -- Oakleaf-Spun Handguards
	[34903]="0:4:4:1:Leather::1:0:25046,27667", -- Embrace of Starlight
	[34904]="0:4:4:1:Leather::1:0:25046,27667", -- Barbed Gloves of the Sage
	[34905]="0:4:4:1:Leather::1:0:25046,27667", -- Crystalwind Leggings
	[34906]="0:4:4:1:Leather::1:0:25046,27667", -- Embrace of Everlasting Prowess
	[34907]="0:15:0:20:Junk::1:0:", -- Shattered Gem Fragments
	[34908]="0:13:1:5:::1:0:", -- Scourge Cage Key
	[34909]="0:12:1:1:::1:0:", -- Salrand's Broken Key
	[34910]="0:4:4:1:Leather::1:0:25046,27667", -- Tameless Breeches
	[34911]="0:4:4:1:Leather::1:0:25046,27667", -- Handwraps of the Aggressor
	[34912]="0:4:4:1:Mail::1:0:25046,27667", -- Scaled Drakeskin Chestguard
	[34913]="0:12:1:1:::1:0:", -- Highmesa's Cleansing Seeds
	[34914]="0:4:4:1:Mail::1:0:25046,27667", -- Leggings of the Pursuit
	[34915]="0:12:1:1:::1:0:", -- Bixie's Inhibiting Powder
	[34916]="0:4:4:1:Mail::1:0:25046,27667", -- Gauntlets of Rapidity
	[34917]="0:4:4:1:Cloth::1:0:25046,27667", -- Shroud of the Lore`nial
	[34918]="0:4:4:1:Cloth::1:0:25046,27667", -- Legwraps of Sweltering Flame
	[34919]="0:4:4:1:Cloth::1:0:25046,27667", -- Boots of Incantations
	[34920]="0:12:1:1:::1:0:", -- Map of the Geyser Fields
	[34921]="0:4:4:1:Plate::1:0:25046,27667", -- Ecclesiastical Cuirass
	[34922]="0:4:4:1:Plate::1:0:25046,27667", -- Greaves of Pacification
	[34923]="0:4:4:1:Plate::1:0:25046,27667", -- Waistguard of Reparation
	[34924]="0:4:4:1:Cloth::1:0:25046,27667", -- Gown of Spiritual Wonder
	[34925]="0:4:4:1:Cloth::1:0:25046,27667", -- Adorned Supernal Legwraps
	[34926]="0:4:4:1:Cloth::1:0:25046,27667", -- Slippers of Dutiful Mending
	[34927]="0:4:4:1:Leather::1:0:25046,27667", -- Tunic of the Dark Hour
	[34928]="0:4:4:1:Leather::1:0:25046,27667", -- Trousers of the Scryers' Retainer
	[34929]="0:4:4:1:Leather::1:0:25046,27667", -- Belt of the Silent Path
	[34930]="0:4:4:1:Mail::1:0:25046,27667", -- Wave of Life Chestguard
	[34931]="0:4:4:1:Mail::1:0:25046,27667", -- Runed Scales of Antiquity
	[34932]="0:4:4:1:Mail::1:0:25046,27667", -- Clutch of the Soothing Breeze
	[34933]="0:4:4:1:Mail::1:0:25046,27667", -- Hauberk of Whirling Fury
	[34934]="0:4:4:1:Mail::1:0:25046,27667", -- Rushing Storm Kilt
	[34935]="0:4:4:1:Mail::1:0:25046,27667", -- Aftershock Waistguard
	[34936]="0:4:4:1:Cloth::1:0:25046,27667", -- Tormented Demonsoul Robes
	[34937]="0:4:4:1:Cloth::1:0:25046,27667", -- Corrupted Soulcloth Pantaloons
	[34938]="0:4:4:1:Cloth::1:0:25046,27667", -- Enslaved Doomguard Soulgrips
	[34939]="0:4:4:1:Plate::1:0:25046,27667", -- Chestplate of Stoicism
	[34940]="0:4:4:1:Plate::1:0:25046,27667", -- Sunguard Legplates
	[34941]="0:4:4:1:Plate::1:0:25046,27667", -- Girdle of the Fearless
	[34942]="0:4:4:1:Plate::1:0:25046,27667", -- Breastplate of Ire
	[34943]="0:4:4:1:Plate::1:0:25046,27667", -- Legplates of Unending Fury
	[34944]="0:4:4:1:Plate::1:0:25046,27667", -- Girdle of Seething Rage
	[34945]="0:4:4:1:Plate::1:0:25046,27667", -- Shattrath Protectorate's Breastplate
	[34946]="0:4:4:1:Plate::1:0:25046,27667", -- Inscribed Legplates of the Aldor
	[34947]="0:4:4:1:Plate::1:0:25046,27667", -- Blue's Greaves of the Righteous Guardian
	[34948]="0:13:1:1:::1:0:", -- Salrand's Key
	[34949]="0:2:4:1:Dagger::1:0:25046,27667", -- Swift Blade of Uncertainty
	[34950]="0:2:4:1:FistWeapon::1:0:25046,27667", -- Vanir's Left Fist of Savagery
	[34951]="0:2:4:1:FistWeapon::1:0:25046,27667", -- Vanir's Left Fist of Brutality
	[34952]="0:2:4:1:Dagger::1:0:25046,27667", -- The Mutilator
	[34953]="0:12:1:1:::1:0:", -- Earthen Ring Magma Totem
	[34954]="0:12:1:1:::1:0:", -- Torp's Kodo Snaffle
	[34955]="0:15:3:1:Companion::1:0:", -- Scorched Stone
	[34956]="0:12:1:10:::1:0:", -- Elemental Heart
	[34957]="0:12:1:1:::1:0:", -- Engine-Core Crystal
	[34958]="0:12:1:1:::1:0:", -- Magical Gyroscope
	[34959]="0:12:1:1:::1:0:", -- Piloting Scourgestone
	[34960]="0:12:1:1:::1:0:", -- The Legend of the Horn
	[34961]="0:13:1:1:::1:0:", -- Burblegobble's Key
	[34962]="0:13:1:1:::1:0:", -- Gurgleboggle's Key
	[34963]="0:12:1:1:::1:0:", -- Lower Horn Half
	[34964]="0:12:1:1:::1:0:", -- Upper Horn Half
	[34968]="0:12:1:1:::1:0:", -- The Horn of Elemental Fury
	[34971]="0:12:1:1:::1:0:", -- Warsong Flare Gun
	[34972]="0:12:1:20:::1:0:", -- Fizzcrank Spare Parts
	[34973]="0:12:1:1:::1:0:", -- Re-Cursive Transmatter Injection
	[34974]="0:12:1:10:::1:0:", -- Bloodspore Carpel
	[34975]="0:12:1:1:::1:0:", -- Portable Oil Collector
	[34976]="0:12:1:5:::1:0:", -- Bloodspore Moth Pollen
	[34977]="0:12:1:10:::1:0:", -- Thick Mammoth Hide
	[34978]="0:12:1:1:::1:0:", -- Pollinated Bloodspore Flower
	[34979]="0:12:1:1:::1:0:", -- Pouch of Crushed Bloodspore
	[34980]="0:12:1:1:::1:0:", -- Head of Gammothra
	[34981]="0:12:1:1:::1:0:", -- Shake-n-Quake 5000 Control Unit
	[34982]="0:12:1:1:::1:0:", -- Massive Glowing Egg
	[34983]="0:12:1:10:::1:0:", -- Gorloc Spice Pouch
	[34984]="0:12:1:1:::1:0:", -- The Ultrasonic Screwdriver
	[34985]="0:2:4:1:Wand::1:0:20278,23396", -- Brutal Gladiator's Baton of Light
	[34986]="0:4:4:1:Shield::1:0:20278,23396", -- Brutal Gladiator's Barrier
	[34987]="0:2:4:1:Stave::1:0:20278,23396", -- Brutal Gladiator's Battle Staff
	[34988]="0:2:4:1:OneHandMace::1:0:20278,23396", -- Brutal Gladiator's Bonecracker
	[34989]="0:2:4:1:TwoHandMace::1:0:20278,23396", -- Brutal Gladiator's Bonegrinder
	[34990]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Chain Armor
	[34991]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Chain Gauntlets
	[34992]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Chain Helm
	[34993]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Chain Leggings
	[34994]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Chain Spaulders
	[34995]="0:2:4:1:OneHandAxe::1:0:20278,23396", -- Brutal Gladiator's Chopper
	[34996]="0:2:4:1:OneHandAxe::1:0:20278,23396", -- Brutal Gladiator's Cleaver
	[34997]="0:2:4:1:TwoHandAxe::1:0:20278,23396", -- Brutal Gladiator's Decapitator
	[34998]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Dragonhide Gloves
	[34999]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Dragonhide Helm
	[35000]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Dragonhide Legguards
	[35001]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Dragonhide Spaulders
	[35002]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Dragonhide Tunic
	[35003]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Dreadweave Gloves
	[35004]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Dreadweave Hood
	[35005]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Dreadweave Leggings
	[35006]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Dreadweave Mantle
	[35007]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Dreadweave Robe
	[35008]="0:4:4:1:OffHandFrill::1:0:20278,23396", -- Brutal Gladiator's Endgame
	[35009]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Felweave Amice
	[35010]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Felweave Cowl
	[35011]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Felweave Handguards
	[35012]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Felweave Raiment
	[35013]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Felweave Trousers
	[35014]="0:2:4:1:OneHandMace::1:0:20278,23396", -- Brutal Gladiator's Gavel
	[35015]="0:2:4:1:TwoHandSword::1:0:20278,23396", -- Brutal Gladiator's Greatsword
	[35016]="0:4:4:1:OffHandFrill::1:0:20278,23396", -- Brutal Gladiator's Grimoire
	[35017]="0:2:4:1:OneHandAxe::1:0:20278,23396", -- Brutal Gladiator's Hacker
	[35018]="0:2:4:1:Crossbow::1:0:20278,23396", -- Brutal Gladiator's Heavy Crossbow
	[35019]="0:4:4:1:Idol::1:0:20278,23396", -- Brutal Gladiator's Idol of Resolve
	[35020]="0:4:4:1:Idol::1:0:20278,23396", -- Brutal Gladiator's Idol of Steadfastness
	[35021]="0:4:4:1:Idol::1:0:20278,23396", -- Brutal Gladiator's Idol of Tenacity
	[35022]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Kodohide Gloves
	[35023]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Kodohide Helm
	[35024]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Kodohide Legguards
	[35025]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Kodohide Spaulders
	[35026]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Kodohide Tunic
	[35027]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Lamellar Chestpiece
	[35028]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Lamellar Gauntlets
	[35029]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Lamellar Helm
	[35030]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Lamellar Legguards
	[35031]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Lamellar Shoulders
	[35032]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Leather Gloves
	[35033]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Leather Helm
	[35034]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Leather Legguards
	[35035]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Leather Spaulders
	[35036]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Leather Tunic
	[35037]="0:2:4:1:FistWeapon::1:0:20278,23396", -- Brutal Gladiator's Left Render
	[35038]="0:2:4:1:FistWeapon::1:0:20278,23396", -- Brutal Gladiator's Left Ripper
	[35039]="0:4:4:1:Libram::1:0:20278,23396", -- Brutal Gladiator's Libram of Fortitude
	[35040]="0:4:4:1:Libram::1:0:20278,23396", -- Brutal Gladiator's Libram of Justice
	[35041]="0:4:4:1:Libram::1:0:20278,23396", -- Brutal Gladiator's Libram of Vengeance
	[35042]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Linked Armor
	[35043]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Linked Gauntlets
	[35044]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Linked Helm
	[35045]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Linked Leggings
	[35046]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Linked Spaulders
	[35047]="0:2:4:1:Bow::1:0:20278,23396", -- Brutal Gladiator's Longbow
	[35048]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Mail Armor
	[35049]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Mail Gauntlets
	[35050]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Mail Helm
	[35051]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Mail Leggings
	[35052]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Mail Spaulders
	[35053]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Mooncloth Gloves
	[35054]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Mooncloth Hood
	[35055]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Mooncloth Leggings
	[35056]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Mooncloth Mantle
	[35057]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Mooncloth Robe
	[35058]="0:2:4:1:Dagger::1:0:20278,23396", -- Brutal Gladiator's Mutilator
	[35059]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Ornamented Chestguard
	[35060]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Ornamented Gloves
	[35061]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Ornamented Headcover
	[35062]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Ornamented Legplates
	[35063]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Ornamented Spaulders
	[35064]="0:2:4:1:Polearm::1:0:20278,23396", -- Brutal Gladiator's Painsaw
	[35065]="0:2:4:1:Wand::1:0:20278,23396", -- Brutal Gladiator's Piercing Touch
	[35066]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Plate Chestpiece
	[35067]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Plate Gauntlets
	[35068]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Plate Helm
	[35069]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Plate Legguards
	[35070]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Plate Shoulders
	[35071]="0:2:4:1:OneHandMace::1:0:20278,23396", -- Brutal Gladiator's Pummeler
	[35072]="0:2:4:1:OneHandSword::1:0:20278,23396", -- Brutal Gladiator's Quickblade
	[35073]="0:4:4:1:Shield::1:0:20278,23396", -- Brutal Gladiator's Redoubt
	[35074]="0:4:4:1:OffHandFrill::1:0:20278,23396", -- Brutal Gladiator's Reprieve
	[35075]="0:2:4:1:Gun::1:0:20278,23396", -- Brutal Gladiator's Rifle
	[35076]="0:2:4:1:FistWeapon::1:0:20278,23396", -- Brutal Gladiator's Right Ripper
	[35077]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Ringmail Armor
	[35078]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Ringmail Gauntlets
	[35079]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Ringmail Helm
	[35080]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Ringmail Leggings
	[35081]="0:4:4:1:Mail::1:0:20278,23396", -- Brutal Gladiator's Ringmail Spaulders
	[35082]="0:2:4:1:OneHandMace::1:0:20278,23396", -- Brutal Gladiator's Salvation
	[35083]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Satin Gloves
	[35084]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Satin Hood
	[35085]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Satin Leggings
	[35086]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Satin Mantle
	[35087]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Satin Robe
	[35088]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Scaled Chestpiece
	[35089]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Scaled Gauntlets
	[35090]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Scaled Helm
	[35091]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Scaled Legguards
	[35092]="0:4:4:1:Plate::1:0:20278,23396", -- Brutal Gladiator's Scaled Shoulders
	[35093]="0:2:4:1:Dagger::1:0:20278,23396", -- Brutal Gladiator's Shanker
	[35094]="0:4:4:1:Shield::1:0:20278,23396", -- Brutal Gladiator's Shield Wall
	[35095]="0:2:4:1:Dagger::1:0:20278,23396", -- Brutal Gladiator's Shiv
	[35096]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Silk Amice
	[35097]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Silk Cowl
	[35098]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Silk Handguards
	[35099]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Silk Raiment
	[35100]="0:4:4:1:Cloth::1:0:20278,23396", -- Brutal Gladiator's Silk Trousers
	[35101]="0:2:4:1:OneHandSword::1:0:20278,23396", -- Brutal Gladiator's Slicer
	[35102]="0:2:4:1:Dagger::1:0:20278,23396", -- Brutal Gladiator's Spellblade
	[35103]="0:2:4:1:Stave::1:0:20278,23396", -- Brutal Gladiator's Staff
	[35104]="0:4:4:1:Totem::1:0:20278,23396", -- Brutal Gladiator's Totem of Indomitability
	[35105]="0:4:4:1:Totem::1:0:20278,23396", -- Brutal Gladiator's Totem of Survival
	[35106]="0:4:4:1:Totem::1:0:20278,23396", -- Brutal Gladiator's Totem of the Third Wind
	[35107]="0:2:4:1:Wand::1:0:20278,23396", -- Brutal Gladiator's Touch of Defeat
	[35108]="0:2:4:1:Thrown::1:0:20278,23396", -- Brutal Gladiator's War Edge
	[35109]="0:2:4:1:Stave::1:0:20278,23396", -- Brutal Gladiator's War Staff
	[35110]="0:2:4:1:OneHandAxe::1:0:20278,23396", -- Brutal Gladiator's Waraxe
	[35111]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Wyrmhide Gloves
	[35112]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Wyrmhide Helm
	[35113]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Wyrmhide Legguards
	[35114]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Wyrmhide Spaulders
	[35115]="0:4:4:1:Leather::1:0:20278,23396", -- Brutal Gladiator's Wyrmhide Tunic
	[35116]="0:12:1:1:::1:0:", -- The Ultrasonic Screwdriver
	[35119]="0:12:1:1:::1:0:", -- Hawthorn's Anti-Venom
	[35121]="0:12:1:1:::1:0:", -- Wolf Bait
	[35122]="0:12:1:1:::1:0:", -- Cultist Communique
	[35123]="0:12:1:10:::1:0:", -- Microfilm
	[35125]="0:12:1:1:::1:0:", -- Oculus of the Exorcist
	[35126]="0:12:1:10:::1:0:", -- Fizzcrank Pilot's Insignia
	[35127]="0:12:1:1:::1:0:", -- Pile of Fake Furs
	[35128]="0:7:2:20:MetalStone:164,202,755:1:0:", -- Hardened Khorium
	[35129]="0:4:4:1:Ring::1:0:", -- Guardian's Band of Dominance
	[35130]="0:4:4:1:Ring::1:0:", -- Guardian's Band of Salvation
	[35131]="0:4:4:1:Ring::1:0:", -- Guardian's Band of Triumph
	[35132]="0:4:4:1:Amulet::1:0:", -- Guardian's Pendant of Conquest
	[35133]="0:4:4:1:Amulet::1:0:", -- Guardian's Pendant of Dominance
	[35134]="0:4:4:1:Amulet::1:0:", -- Guardian's Pendant of Salvation
	[35135]="0:4:4:1:Amulet::1:0:", -- Guardian's Pendant of Triumph
	[35136]="0:4:4:1:Mail::1:0:", -- Guardian's Chain Sabatons
	[35137]="0:4:4:1:Leather::1:0:", -- Guardian's Dragonhide Boots
	[35138]="0:4:4:1:Cloth::1:0:", -- Guardian's Dreadweave Stalkers
	[35139]="0:4:4:1:Leather::1:0:", -- Guardian's Kodohide Boots
	[35140]="0:4:4:1:Plate::1:0:", -- Guardian's Lamellar Greaves
	[35141]="0:4:4:1:Leather::1:0:", -- Guardian's Leather Boots
	[35142]="0:4:4:1:Mail::1:0:", -- Guardian's Linked Sabatons
	[35143]="0:4:4:1:Mail::1:0:", -- Guardian's Mail Sabatons
	[35144]="0:4:4:1:Cloth::1:0:", -- Guardian's Mooncloth Slippers
	[35145]="0:4:4:1:Plate::1:0:", -- Guardian's Ornamented Greaves
	[35146]="0:4:4:1:Plate::1:0:", -- Guardian's Plate Greaves
	[35147]="0:4:4:1:Mail::1:0:", -- Guardian's Ringmail Sabatons
	[35148]="0:4:4:1:Plate::1:0:", -- Guardian's Scaled Greaves
	[35149]="0:4:4:1:Cloth::1:0:", -- Guardian's Silk Footguards
	[35150]="0:4:4:1:Leather::1:0:", -- Guardian's Wyrmhide Boots
	[35151]="0:4:4:1:Mail::1:0:", -- Guardian's Chain Girdle
	[35152]="0:4:4:1:Leather::1:0:", -- Guardian's Dragonhide Belt
	[35153]="0:4:4:1:Cloth::1:0:", -- Guardian's Dreadweave Belt
	[35154]="0:4:4:1:Leather::1:0:", -- Guardian's Kodohide Belt
	[35155]="0:4:4:1:Plate::1:0:", -- Guardian's Lamellar Belt
	[35156]="0:4:4:1:Leather::1:0:", -- Guardian's Leather Belt
	[35157]="0:4:4:1:Mail::1:0:", -- Guardian's Linked Girdle
	[35158]="0:4:4:1:Mail::1:0:", -- Guardian's Mail Girdle
	[35159]="0:4:4:1:Cloth::1:0:", -- Guardian's Mooncloth Belt
	[35160]="0:4:4:1:Plate::1:0:", -- Guardian's Ornamented Belt
	[35161]="0:4:4:1:Plate::1:0:", -- Guardian's Plate Belt
	[35162]="0:4:4:1:Mail::1:0:", -- Guardian's Ringmail Girdle
	[35163]="0:4:4:1:Plate::1:0:", -- Guardian's Scaled Belt
	[35164]="0:4:4:1:Cloth::1:0:", -- Guardian's Silk Belt
	[35165]="0:4:4:1:Leather::1:0:", -- Guardian's Wyrmhide Belt
	[35166]="0:4:4:1:Mail::1:0:", -- Guardian's Chain Bracers
	[35167]="0:4:4:1:Leather::1:0:", -- Guardian's Dragonhide Bracers
	[35168]="0:4:4:1:Cloth::1:0:", -- Guardian's Dreadweave Cuffs
	[35169]="0:4:4:1:Leather::1:0:", -- Guardian's Kodohide Bracers
	[35170]="0:4:4:1:Plate::1:0:", -- Guardian's Lamellar Bracers
	[35171]="0:4:4:1:Leather::1:0:", -- Guardian's Leather Bracers
	[35172]="0:4:4:1:Mail::1:0:", -- Guardian's Linked Bracers
	[35173]="0:4:4:1:Mail::1:0:", -- Guardian's Mail Bracers
	[35174]="0:4:4:1:Cloth::1:0:", -- Guardian's Mooncloth Cuffs
	[35175]="0:4:4:1:Plate::1:0:", -- Guardian's Ornamented Bracers
	[35176]="0:4:4:1:Plate::1:0:", -- Guardian's Plate Bracers
	[35177]="0:4:4:1:Mail::1:0:", -- Guardian's Ringmail Bracers
	[35178]="0:4:4:1:Plate::1:0:", -- Guardian's Scaled Bracers
	[35179]="0:4:4:1:Cloth::1:0:", -- Guardian's Silk Cuffs
	[35180]="0:4:4:1:Leather::1:0:", -- Guardian's Wyrmhide Bracers
	[35181]="0:4:4:1:Cloth::1:0:", -- Powerheal 9000 Lens
	[35182]="0:4:4:1:Leather::1:0:", -- Hyper-Magnified Moon Specs
	[35183]="0:4:4:1:Leather::1:0:", -- Wonderheal XT68 Shades
	[35184]="0:4:4:1:Mail::1:0:", -- Primal-Attuned Goggles
	[35185]="0:4:4:1:Plate::1:0:", -- Justicebringer 3000 Specs
	[35186]="0:9:4:1:Engineering::1:0:", -- Schematic: Annihilator Holo-Gogs
	[35187]="0:9:4:1:Engineering::1:0:", -- Schematic: Justicebringer 3000 Specs
	[35188]="0:12:1:50:::1:0:", -- Nesingwary Lackey Ear
	[35189]="0:9:4:1:Engineering::1:0:", -- Schematic: Powerheal 9000 Lens
	[35190]="0:9:4:1:Engineering::1:0:", -- Schematic: Hyper-Magnified Moon Specs
	[35191]="0:9:4:1:Engineering::1:0:", -- Schematic: Wonderheal XT68 Shades
	[35192]="0:9:4:1:Engineering::1:0:", -- Schematic: Primal-Attuned Goggles
	[35193]="0:9:4:1:Engineering::1:0:", -- Schematic: Lightning Etched Specs
	[35194]="0:9:4:1:Engineering::1:0:", -- Schematic: Surestrike Goggles v3.0
	[35195]="0:9:4:1:Engineering::1:0:", -- Schematic: Mayhem Projection Goggles
	[35196]="0:9:4:1:Engineering::1:0:", -- Schematic: Hard Khorium Goggles
	[35197]="0:9:4:1:Engineering::1:0:", -- Schematic: Quad Deathblow X44 Goggles
	[35198]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Loop of Forged Power
	[35199]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Ring of Flowing Life
	[35200]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Hard Khorium Band
	[35201]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Pendant of Sunfire
	[35202]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Amulet of Flowing Life
	[35203]="0:9:4:1:Jewelcrafting::1:0:", -- Design: Hard Khorium Choker
	[35204]="0:9:4:1:Tailoring::1:0:", -- Pattern: Sunfire Handwraps
	[35205]="0:9:4:1:Tailoring::1:0:", -- Pattern: Hands of Eternal Light
	[35206]="0:9:4:1:Tailoring::1:0:", -- Pattern: Sunfire Robe
	[35207]="0:9:4:1:Tailoring::1:0:", -- Pattern: Robe of Eternal Light
	[35208]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Sunblessed Gauntlets
	[35209]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Hard Khorium Battlefists
	[35210]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Sunblessed Breastplate
	[35211]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Hard Khorium Battleplate
	[35212]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Leather Gauntlets of the Sun
	[35213]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Fletcher's Gloves of the Phoenix
	[35214]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Gloves of Immortal Dusk
	[35215]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Sun-Drenched Scale Gloves
	[35216]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Leather Chestguard of the Sun
	[35217]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Embrace of the Phoenix
	[35218]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Carapace of Sun and Shadow
	[35219]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Sun-Drenched Scale Chestguard
	[35221]="10000:4:1:1:Tabard::1:0:5049,5188,5189,5190,5191,5193,16610,16766,25032,28776", -- Tabard of the Shattered Sun
	[35222]="0:12:1:12:::1:0:", -- Shipment of Animal Parts
	[35223]="0:0:3:250:Consumable::1:0:", -- Papa Hummel's Old-Fashioned Pet Biscuit
	[35224]="0:12:1:1:::1:0:", -- Emergency Torch
	[35227]="0:15:4:1:Companion::1:0:", -- Goblin Weather Machine - Prototype 01-B
	[35228]="0:12:1:1:::1:0:", -- D.E.H.T.A. Trap Smasher
	[35229]="0:12:1:10:::1:0:", -- Nether Residue
	[35230]="0:12:1:200:::1:0:", -- Darnarian's Scroll of Teleportation
	[35231]="0:12:1:1:::1:0:", -- Sunfury Attack Plans
	[35232]="0:0:1:1:Consumable::1:0:", -- Shattered Sun Supplies
	[35233]="0:12:1:1:::1:0:", -- Multiphase Spectrographic Goggles
	[35234]="0:12:1:1:::1:0:", -- Kaw's War Halberd
	[35237]="0:12:1:1:::1:0:", -- Orb of the Crawler
	[35238]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Balanced Shadowsong Amethyst
	[35239]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Glowing Shadowsong Amethyst
	[35240]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Infused Shadowsong Amethyst
	[35241]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Royal Shadowsong Amethyst
	[35242]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Shifting Shadowsong Amethyst
	[35243]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Sovereign Shadowsong Amethyst
	[35244]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Bold Crimson Spinel
	[35245]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Bright Crimson Spinel
	[35246]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Delicate Crimson Spinel
	[35247]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Flashing Crimson Spinel
	[35248]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Runed Crimson Spinel
	[35249]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Subtle Crimson Spinel
	[35250]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Teardrop Crimson Spinel
	[35251]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Dazzling Seaspray Emerald
	[35252]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Enduring Seaspray Emerald
	[35253]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Jagged Seaspray Emerald
	[35254]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Radiant Seaspray Emerald
	[35255]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Brilliant Lionseye
	[35256]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Gleaming Lionseye
	[35257]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Great Lionseye
	[35258]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Mystic Lionseye
	[35259]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Rigid Lionseye
	[35260]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Smooth Lionseye
	[35261]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Thick Lionseye
	[35262]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Lustrous Empyrean Sapphire
	[35263]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Solid Empyrean Sapphire
	[35264]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Sparkling Empyrean Sapphire
	[35265]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Stormy Empyrean Sapphire
	[35266]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Glinting Pyrestone
	[35267]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Inscribed Pyrestone
	[35268]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Luminous Pyrestone
	[35269]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Potent Pyrestone
	[35270]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Veiled Pyrestone
	[35271]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Wicked Pyrestone
	[35272]="0:12:1:1:::1:0:", -- Jenny's Whistle
	[35273]="0:9:3:1:Book::1:0:", -- Study of Advanced Smelting
	[35275]="0:4:3:1:Miscellaneous::1:0:", -- Orb of the Sin'dorei
	[35276]="0:12:1:10:::1:0:", -- Gnomish Emergency Toolkit
	[35277]="0:12:1:1:::1:0:", -- Twilight Correspondence
	[35278]="0:12:1:1:::1:0:", -- Reinforced Net
	[35279]="0:4:3:1:Tabard::1:0:", -- Tabard of Summer Skies
	[35280]="0:4:3:1:Tabard::1:0:", -- Tabard of Summer Flames
	[35281]="0:12:1:1:::1:0:", -- Windsoul Totem
	[35282]="0:4:4:1:Ring::1:0:", -- Sin'dorei Band of Dominance
	[35283]="0:4:4:1:Ring::1:0:", -- Sin'dorei Band of Salvation
	[35284]="0:4:4:1:Ring::1:0:", -- Sin'dorei Band of Triumph
	[35285]="0:7:1:20:Meat::1:0:", -- Giant Sunfish
	[35286]="0:15:1:1:Other::1:0:", -- Bloated Giant Sunfish
	[35287]="0:0:1:20:Other::1:0:", -- Luminous Bluetail
	[35288]="0:12:1:100:::1:0:", -- Uncured Caribou Hide
	[35289]="0:12:1:10:::1:0:", -- Steam Cured Hide
	[35290]="0:4:4:1:Amulet::1:0:", -- Sin'dorei Pendant of Conquest
	[35291]="0:4:4:1:Amulet::1:0:", -- Sin'dorei Pendant of Salvation
	[35292]="0:4:4:1:Amulet::1:0:", -- Sin'dorei Pendant of Triumph
	[35293]="0:12:1:1:::1:0:", -- Cenarion Horn
	[35294]="0:9:2:1:Alchemy::1:0:", -- Recipe: Elixir of Empowerment
	[35295]="0:9:2:1:Alchemy::1:0:", -- Recipe: Haste Potion
	[35296]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Adamantite Weapon Chain
	[35297]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Boots - Boar's Speed
	[35298]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Boots - Vitality
	[35299]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Boots - Cat's Swiftness
	[35300]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Windstrike Gloves
	[35301]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Netherdrake Gloves
	[35302]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Cobrascale Gloves
	[35303]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Gloves of the Living Touch
	[35304]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Solid Star of Elune
	[35305]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Runed Living Ruby
	[35306]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Bright Living Ruby
	[35307]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Rigid Dawnstone
	[35308]="0:9:3:1:Tailoring::1:0:", -- Pattern: Unyielding Bracers
	[35309]="0:9:4:1:Tailoring::1:0:", -- Pattern: Unyielding Girdle
	[35310]="0:9:3:1:Engineering::1:0:", -- Schematic: Healing Potion Injector
	[35311]="0:9:3:1:Engineering::1:0:", -- Schematic: Mana Potion Injector
	[35313]="0:12:1:1:::1:0:", -- Bloated Barbed Gill Trout
	[35314]="0:15:0:5:Junk::1:0:", -- Partially Digested Weeds
	[35315]="0:3:3:1:GemYellow::1:0:", -- Quick Dawnstone
	[35316]="0:3:3:1:GemOrange::1:0:", -- Reckless Noble Topaz
	[35317]="0:4:4:1:Amulet::1:0:", -- Vindicator's Pendant of Reprieve
	[35318]="0:3:3:1:GemGreen::1:0:", -- Forceful Talasite
	[35319]="0:4:4:1:Amulet::1:0:", -- Vindicator's Pendant of Subjugation
	[35320]="0:4:4:1:Ring::1:0:", -- Vindicator's Band of Subjugation
	[35321]="0:4:4:1:Cloak::1:0:18525", -- Cloak of Arcane Alacrity
	[35322]="120000:9:3:1:Jewelcrafting::1:0:25950,27666", -- Design: Quick Dawnstone
	[35323]="120000:9:3:1:Jewelcrafting::1:0:25950,27666", -- Design: Reckless Noble Topaz
	[35324]="0:4:4:1:Cloak::1:0:18525", -- Cloak of Swift Reprieve
	[35325]="120000:9:3:1:Jewelcrafting::1:0:25950,27666", -- Design: Forceful Talasite
	[35326]="0:4:4:1:Trinket::1:0:18525", -- Battlemaster's Alacrity
	[35327]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Alacrity
	[35328]="86955:4:3:1:Cloth::1:0:21643", -- Dreadweave Gloves
	[35329]="130908:4:3:1:Cloth::1:0:17904", -- Dreadweave Hood
	[35330]="175195:4:3:1:Cloth::1:0:21432", -- Dreadweave Leggings
	[35331]="131885:4:3:1:Cloth::1:0:21655", -- Dreadweave Mantle
	[35332]="176497:4:3:1:Cloth::1:0:17585", -- Dreadweave Robe
	[35333]="132848:4:3:1:Cloth::1:0:21432", -- Mooncloth Cowl
	[35334]="177782:4:3:1:Cloth::1:0:21643", -- Mooncloth Legguards
	[35335]="89216:4:3:1:Cloth::1:0:21655", -- Mooncloth Mitts
	[35336]="134313:4:3:1:Cloth::1:0:17904", -- Mooncloth Shoulderpads
	[35337]="179717:4:3:1:Cloth::1:0:17585", -- Mooncloth Vestments
	[35338]="90184:4:3:1:Cloth::1:0:21643", -- Satin Gloves
	[35339]="135764:4:3:1:Cloth::1:0:17585", -- Satin Hood
	[35340]="181670:4:3:1:Cloth::1:0:21655", -- Satin Leggings
	[35341]="136728:4:3:1:Cloth::1:0:21432", -- Satin Mantle
	[35342]="182955:4:3:1:Cloth::1:0:17904", -- Satin Robe
	[35343]="137704:4:3:1:Cloth::1:0:17585", -- Evoker's Silk Amice
	[35344]="128467:4:3:1:Cloth::1:0:21655", -- Evoker's Silk Cowl
	[35345]="85970:4:3:1:Cloth::1:0:21432", -- Evoker's Silk Handguards
	[35346]="172591:4:3:1:Cloth::1:0:21643", -- Evoker's Silk Raiment
	[35347]="173242:4:3:1:Cloth::1:0:17904", -- Evoker's Silk Trousers
	[35348]="0:15:1:1:Junk::1:0:", -- Bag of Fishing Treasures
	[35349]="0:15:3:1:Companion::1:0:", -- Snarly's Bucket
	[35350]="0:15:3:1:Companion::1:0:", -- Chuck's Bucket
	[35352]="0:12:1:1:::1:0:", -- Sage's Lightning Rod
	[35353]="0:12:1:1:::1:0:", -- High Priest Naferset's Scroll
	[35354]="0:12:1:1:::1:0:", -- High Priest Talet-Kha's Scroll
	[35355]="0:12:1:1:::1:0:", -- High Priest Andorath's Scroll
	[35356]="111905:4:3:1:Leather::1:0:21643", -- Dragonhide Gloves
	[35357]="168468:4:3:1:Leather::1:0:21655", -- Dragonhide Helm
	[35358]="225438:4:3:1:Leather::1:0:17904", -- Dragonhide Legguards
	[35359]="169689:4:3:1:Leather::1:0:21432", -- Dragonhide Spaulders
	[35360]="210856:4:3:1:Leather::1:0:17585", -- Dragonhide Robe
	[35361]="105835:4:3:1:Leather::1:0:21655", -- Kodohide Gloves
	[35362]="159363:4:3:1:Leather::1:0:21432", -- Kodohide Helm
	[35363]="213276:4:3:1:Leather::1:0:21643", -- Kodohide Legguards
	[35364]="160567:4:3:1:Leather::1:0:17585", -- Kodohide Spaulders
	[35365]="214903:4:3:1:Leather::1:0:17904", -- Kodohide Robe
	[35366]="107858:4:3:1:Leather::1:0:17585", -- Opportunist's Leather Gloves
	[35367]="162381:4:3:1:Leather::1:0:17904", -- Opportunist's Leather Helm
	[35368]="217323:4:3:1:Leather::1:0:21432", -- Opportunist's Leather Legguards
	[35369]="163602:4:3:1:Leather::1:0:21643", -- Opportunist's Leather Spaulders
	[35370]="218950:4:3:1:Leather::1:0:21655", -- Opportunist's Leather Tunic
	[35371]="109871:4:3:1:Leather::1:0:17585", -- Wyrmhide Gloves
	[35372]="165417:4:3:1:Leather::1:0:21643", -- Wyrmhide Helm
	[35373]="221369:4:3:1:Leather::1:0:21655", -- Wyrmhide Legguards
	[35374]="166637:4:3:1:Leather::1:0:17904", -- Wyrmhide Spaulders
	[35375]="222975:4:3:1:Leather::1:0:21432", -- Wyrmhide Robe
	[35376]="268547:4:3:1:Mail::1:0:21643", -- Stalker's Chain Armor
	[35377]="138258:4:3:1:Mail::1:0:17585", -- Stalker's Chain Gauntlets
	[35378]="188286:4:3:1:Mail::1:0:21655", -- Stalker's Chain Helm
	[35379]="252025:4:3:1:Mail::1:0:17904", -- Stalker's Chain Leggings
	[35380]="190594:4:3:1:Mail::1:0:21432", -- Stalker's Chain Spaulders
	[35381]="253978:4:3:1:Mail::1:0:21432", -- Seer's Linked Armor
	[35382]="127464:4:3:1:Mail::1:0:21655", -- Seer's Linked Gauntlets
	[35383]="191928:4:3:1:Mail::1:0:17585", -- Seer's Linked Helm
	[35384]="256881:4:3:1:Mail::1:0:21643", -- Seer's Linked Leggings
	[35385]="194253:4:3:1:Mail::1:0:17904", -- Seer's Linked Spaulders
	[35386]="258808:4:3:1:Mail::1:0:17585", -- Seer's Mail Armor
	[35387]="129892:4:3:1:Mail::1:0:17904", -- Seer's Mail Gauntlets
	[35388]="195570:4:3:1:Mail::1:0:21432", -- Seer's Mail Helm
	[35389]="261737:4:3:1:Mail::1:0:21655", -- Seer's Mail Leggings
	[35390]="197891:4:3:1:Mail::1:0:21643", -- Seer's Mail Spaulders
	[35391]="263664:4:3:1:Mail::1:0:21655", -- Seer's Ringmail Chestguard
	[35392]="132320:4:3:1:Mail::1:0:17585", -- Seer's Ringmail Gloves
	[35393]="204438:4:3:1:Mail::1:0:21643", -- Seer's Ringmail Headpiece
	[35394]="273561:4:3:1:Mail::1:0:17904", -- Seer's Ringmail Legguards
	[35395]="206818:4:3:1:Mail::1:0:21432", -- Seer's Ringmail Shoulderpads
	[35401]="0:12:1:1:::1:0:", -- The Greatmother's Soulcatcher
	[35402]="297385:4:3:1:Plate::1:0:21643", -- Crusader's Ornamented Chestplate
	[35403]="150115:4:3:1:Plate::1:0:17904", -- Crusader's Ornamented Gloves
	[35404]="224320:4:3:1:Plate::1:0:21432", -- Crusader's Ornamented Headguard
	[35405]="300772:4:3:1:Plate::1:0:21655", -- Crusader's Ornamented Leggings
	[35406]="226002:4:3:1:Plate::1:0:17585", -- Crusader's Ornamented Spaulders
	[35407]="303051:4:3:1:Plate::1:0:21432", -- Savage Plate Chestpiece
	[35408]="152949:4:3:1:Plate::1:0:17904", -- Savage Plate Gauntlets
	[35409]="234646:4:3:1:Plate::1:0:17585", -- Savage Plate Helm
	[35410]="314598:4:3:1:Plate::1:0:21643", -- Savage Plate Legguards
	[35411]="236352:4:3:1:Plate::1:0:21655", -- Savage Plate Shoulders
	[35412]="316846:4:3:1:Plate::1:0:21655", -- Crusader's Scaled Chestpiece
	[35413]="159901:4:3:1:Plate::1:0:17585", -- Crusader's Scaled Gauntlets
	[35414]="238887:4:3:1:Plate::1:0:21643", -- Crusader's Scaled Helm
	[35415]="320263:4:3:1:Plate::1:0:17904", -- Crusader's Scaled Legguards
	[35416]="240570:4:3:1:Plate::1:0:21432", -- Crusader's Scaled Shoulders
	[35464]="175829:4:3:1:Cloth::1:0:17657", -- Dreadweave Robe
	[35465]="132346:4:3:1:Cloth::1:0:17657", -- Evoker's Silk Amice
	[35466]="132835:4:3:1:Cloth::1:0:17657", -- Satin Hood
	[35467]="177764:4:3:1:Cloth::1:0:17657", -- Mooncloth Vestments
	[35468]="111509:4:3:1:Leather::1:0:17657", -- Opportunist's Leather Gloves
	[35469]="223811:4:3:1:Leather::1:0:17657", -- Dragonhide Robe
	[35470]="168468:4:3:1:Leather::1:0:17657", -- Kodohide Spaulders
	[35471]="112719:4:3:1:Leather::1:0:17657", -- Wyrmhide Gloves
	[35472]="271476:4:3:1:Mail::1:0:17657", -- Seer's Mail Armor
	[35473]="126514:4:3:1:Mail::1:0:17657", -- Seer's Ringmail Gloves
	[35474]="190503:4:3:1:Mail::1:0:17657", -- Seer's Linked Helm
	[35475]="127490:4:3:1:Mail::1:0:17657", -- Stalker's Chain Gauntlets
	[35476]="223513:4:3:1:Plate::1:0:17657", -- Crusader's Ornamented Spaulders
	[35477]="150719:4:3:1:Plate::1:0:17657", -- Crusader's Scaled Gauntlets
	[35478]="225219:4:3:1:Plate::1:0:17657", -- Savage Plate Helm
	[35479]="0:12:1:1:::1:0:", -- Interdimensional Refabricator
	[35481]="0:12:1:1:::1:0:", -- Fields, Factories and Workshops
	[35483]="0:12:1:5:::1:0:", -- Glacial Splinter
	[35484]="0:12:1:5:::1:0:", -- Magic-Bound Splinter
	[35486]="0:12:1:1:::1:0:", -- Mechazod's Head
	[35487]="0:3:4:1:GemRed::1:0:", -- Bright Crimson Spinel
	[35488]="0:3:4:1:GemRed::1:0:", -- Runed Crimson Spinel
	[35489]="0:3:4:1:GemRed::1:0:", -- Teardrop Crimson Spinel
	[35490]="0:12:1:5:::1:0:", -- Arcane Splinter
	[35491]="0:12:1:1:::1:0:", -- Wendy's Torch
	[35492]="0:12:1:10:::1:0:", -- Frostberry
	[35493]="0:12:1:10:::1:0:", -- Nexus Mana Essence
	[35494]="0:4:4:1:Cloak::1:0:", -- Shroud of Winter's Chill
	[35495]="0:4:4:1:Cloak::1:0:", -- The Frost Lord's War Cloak
	[35496]="0:4:4:1:Cloak::1:0:", -- Icebound Cloak
	[35497]="0:4:4:1:Cloak::1:0:", -- Cloak of the Frigid Winds
	[35498]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Deathfrost
	[35500]="150000:9:1:1:Enchanting::1:0:25032", -- Formula: Enchant Chest - Defense
	[35501]="0:3:3:1:GemMeta::1:0:", -- Eternal Earthstorm Diamond
	[35502]="150000:9:1:1:Jewelcrafting::1:0:25032", -- Design: Eternal Earthstorm Diamond
	[35503]="0:3:3:1:GemMeta::1:0:", -- Ember Skyfire Diamond
	[35504]="0:15:3:1:Companion::1:0:", -- Phoenix Hatchling
	[35505]="150000:9:1:1:Jewelcrafting::1:0:25032", -- Design: Ember Skyfire Diamond
	[35506]="0:12:1:1:::1:0:", -- Raelorasz's Spear
	[35507]="0:4:4:1:Amulet::1:0:", -- Amulet of Bitter Hatred
	[35508]="0:4:4:1:Amulet::1:0:", -- Choker of the Arctic Flow
	[35509]="0:4:4:1:Amulet::1:0:", -- Amulet of Glacial Tranquility
	[35511]="0:4:4:1:Amulet::1:0:", -- Hailstone Pendant
	[35512]="0:0:1:1:Consumable::1:0:", -- Pocket Full of Snow
	[35513]="0:15:4:1:Mount::1:0:", -- Swift White Hawkstrider
	[35514]="0:2:4:1:Stave::1:0:", -- Frostscythe of Lord Ahune
	[35516]="0:1:3:1:Bag::1:0:", -- Sun Touched Satchel
	[35557]="0:15:1:10:Holiday::1:0:", -- Huge Snowball
	[35562]="0:7:1:20:Meat:185:1:0:", -- Bear Flank
	[35563]="0:0:1:20:FoodDrink::1:0:", -- Charred Bear Kabobs
	[35564]="18000:9:1:1:Cooking::1:0:2803,2806", -- Recipe: Charred Bear Kabobs
	[35565]="0:0:1:20:FoodDrink::1:0:", -- Juicy Bear Burger
	[35566]="18000:9:1:1:Cooking::1:0:2803,2806", -- Recipe: Juicy Bear Burger
	[35568]="0:12:1:1:::1:0:", -- Flame of Silvermoon
	[35569]="0:12:1:1:::1:0:", -- Flame of the Exodar
	[35570]="0:2:3:1:Dagger::1:0:", -- Keleseth's Blade of Evocation
	[35571]="0:4:3:1:Mail::1:0:", -- Dragon Stabler's Gauntlets
	[35572]="0:4:3:1:Cloth::1:0:", -- Reinforced Velvet Helm
	[35573]="0:2:3:1:FistWeapon::1:0:", -- Arm Blade of Augelmir
	[35574]="0:4:3:1:Plate::1:0:", -- Chestplate of the Northern Lights
	[35575]="0:4:3:1:Leather::1:0:", -- Skarvald's Dragonskin Habergeon
	[35576]="0:2:3:1:TwoHandAxe::1:0:", -- Ingvar's Monolithic Cleaver
	[35577]="0:4:3:1:Leather::1:0:", -- Holistic Patchwork Breeches
	[35578]="0:4:3:1:Mail::1:0:", -- Overlaid Chain Spaulders
	[35579]="0:4:3:1:Leather::1:0:", -- Vrykul Shackles
	[35580]="0:4:3:1:Cloth::1:0:", -- Skein Woven Mantle
	[35581]="0:4:3:1:Cloth::1:0:", -- Rocket Boots Xtreme Lite
	[35582]="0:9:3:1:Engineering::1:0:", -- Schematic: Rocket Boots Xtreme Lite
	[35583]="0:2:3:1:Stave::1:0:", -- Witch Doctor's Wildstaff
	[35584]="0:4:3:1:Cloth::1:0:", -- Embroidered Gown of Zul'Drak
	[35585]="0:4:3:1:Mail::1:0:", -- Cannibal's Legguards
	[35586]="0:15:1:5:Junk::1:0:", -- Frozen Axe
	[35587]="0:2:3:1:OneHandMace::1:0:", -- Frozen Scepter of Necromancy
	[35588]="0:4:3:1:Plate::1:0:", -- Forlorn Breastplate of War
	[35589]="0:4:3:1:Ring::1:0:", -- Arcane Focal Signet
	[35590]="0:2:3:1:Bow::1:0:", -- Drakkari Hunting Bow
	[35591]="0:4:3:1:Leather::1:0:", -- Shoulderguards of the Ice Troll
	[35592]="0:4:3:1:Mail::1:0:", -- Hauberk of Totemic Mastery
	[35593]="0:4:3:1:Plate::1:0:", -- Steel Bear Trap Bracers
	[35594]="0:4:3:1:Cloth::1:0:", -- Snowmelt Silken Cinch
	[35595]="0:2:3:1:Dagger::1:0:", -- Glacier Sharpened Vileblade
	[35596]="0:4:3:1:Cloth::1:0:", -- Attuned Crystalline Boots
	[35597]="0:4:3:1:Ring::1:0:", -- Band of Glittering Permafrost
	[35598]="0:4:3:1:OffHandFrill::1:0:", -- Tome of the Lore Keepers
	[35599]="0:4:3:1:Mail::1:0:", -- Gauntlets of Serpent Scales
	[35600]="0:4:3:1:Mail::1:0:", -- Cleated Ice Boots
	[35601]="0:2:3:1:FistWeapon::1:0:", -- Drakonid Arm Blade
	[35602]="0:4:3:1:Plate::1:0:", -- Chiseled Stalagmite Pauldrons
	[35603]="0:4:3:1:Plate::1:0:", -- Greaves of the Blue Flight
	[35604]="0:4:3:1:Plate::1:0:", -- Insulating Bindings
	[35605]="0:4:3:1:Leather::1:0:", -- Belt of Draconic Runes
	[35606]="0:2:3:1:Dagger::1:0:", -- Blade of Nadox
	[35607]="0:4:3:1:Leather::1:0:", -- Ahn'kahar Handwraps
	[35608]="0:4:3:1:Plate::1:0:", -- Crawler-Emblem Belt
	[35609]="0:4:3:1:OffHandFrill::1:0:", -- Talisman of Scourge Command
	[35610]="0:4:3:1:Amulet::1:0:", -- Slasher's Amulet
	[35611]="0:4:3:1:Cloth::1:0:", -- Gloves of the Blood Prince
	[35612]="0:4:3:1:Cloth::1:0:", -- Mantle of Echoing Bats
	[35613]="0:4:3:1:Leather::1:0:", -- Pyramid Embossed Belt
	[35614]="0:4:3:1:Plate::1:0:", -- Volazj's Sabatons
	[35615]="0:4:3:1:Mail::1:0:", -- Glowworm Cavern Bindings
	[35616]="0:4:3:1:Mail::1:0:", -- Spored Tendrils Spaulders
	[35617]="0:2:3:1:Wand::1:0:", -- Wand of Shimmering Scales
	[35618]="0:2:3:1:TwoHandSword::1:0:", -- Troll Butcherer
	[35619]="0:4:3:1:Mail::1:0:", -- Infection Resistant Legguards
	[35620]="0:4:3:1:Leather::1:0:", -- Berserker's Horns
	[35622]="0:7:2:20:Elemental:171,164,333,202,755,165,197:1:0:", -- Eternal Water
	[35623]="0:7:2:20:Elemental:171,164,333,202,755,165:1:0:", -- Eternal Air
	[35624]="0:7:2:20:Elemental:171,164,333,202,755,165,186,197:1:0:", -- Eternal Earth
	[35625]="0:7:2:20:Elemental:171,164,333,202,755,165,197,773:1:0:", -- Eternal Life
	[35627]="0:7:2:20:Elemental:171,164,333,202,755,165,186,197,773:1:0:", -- Eternal Shadow
	[35628]="0:12:1:1:::1:0:", -- Azure Codex
	[35629]="0:12:1:3:::1:0:", -- Shimmering Rune
	[35630]="0:2:3:1:OneHandMace::1:0:", -- Summoner's Stone Gavel
	[35631]="0:4:3:1:Amulet::1:0:", -- Crystal Pendant of Warding
	[35632]="0:4:3:1:Cloth::1:0:", -- Robes of Novos
	[35633]="0:2:3:1:Stave::1:0:", -- Staff of the Great Reptile
	[35634]="0:4:3:1:Leather::1:0:", -- Scabrous-Hide Helm
	[35635]="0:4:3:1:Cloth::1:0:", -- Stable Master's Breeches
	[35636]="0:4:3:1:Shield::1:0:", -- Tharon'ja's Aegis
	[35637]="0:4:3:1:Plate::1:0:", -- Muradin's Lost Greaves
	[35638]="0:4:3:1:Mail::1:0:", -- Helmet of Living Flesh
	[35639]="0:4:3:1:Plate::1:0:", -- Brighthelm of Guarding
	[35640]="0:4:3:1:Mail::1:0:", -- Darkweb Bindings
	[35641]="0:4:3:1:Leather::1:0:", -- Scytheclaw Boots
	[35642]="0:4:3:1:Shield::1:0:", -- Riot Shield
	[35643]="0:4:3:1:Plate::1:0:", -- Spaulders of Ichoron
	[35644]="0:4:3:1:Mail::1:0:", -- Xevozz's Belt
	[35645]="0:2:3:1:Gun::1:0:", -- Prison Warden's Shotgun
	[35646]="0:4:3:1:Cloth::1:0:", -- Lava Burn Gloves
	[35647]="0:4:3:1:Leather::1:0:", -- Handguards of Rapid Pursuit
	[35648]="0:12:1:1:::1:0:", -- Scintillating Fragment
	[35649]="0:2:3:1:Stave::1:0:", -- Jailer's Baton
	[35650]="0:4:3:1:Mail::1:0:", -- Boots of the Portal Guardian
	[35651]="0:4:3:1:Plate::1:0:", -- Plate Claws of the Dragon
	[35652]="0:2:3:1:Wand::1:0:", -- Incessant Torch
	[35653]="0:4:3:1:Plate::1:0:", -- Girdle of the Mystical Prison
	[35654]="0:4:3:1:Cloth::1:0:", -- Bindings of the Bastille
	[35655]="0:2:3:1:Dagger::1:0:", -- Cobweb Machete
	[35656]="0:4:3:1:Plate::1:0:", -- Aura Focused Gauntlets
	[35657]="0:4:3:1:Cloth::1:0:", -- Exquisite Spider-Silk Footwraps
	[35658]="0:2:3:1:Stave::1:0:", -- Life-Staff of the Web Lair
	[35659]="0:4:3:1:Leather::1:0:", -- Treads of Aspiring Heights
	[35660]="0:4:3:1:Leather::1:0:", -- Spinneret Epaulets
	[35661]="0:4:3:1:Ring::1:0:", -- Signet of Arachnathid Command
	[35662]="0:4:3:1:Mail::1:0:", -- Wing Cover Girdle
	[35663]="0:4:3:1:Cloth::1:0:", -- Charmed Silken Cord
	[35664]="0:2:3:1:OneHandMace::1:0:", -- Unknown Archaeologist's Hammer
	[35665]="0:4:3:1:Leather::1:0:", -- Soothing Lichen Wraps
	[35666]="0:4:3:1:Amulet::1:0:", -- Mark of the Spider
	[35668]="0:12:1:1:::1:0:", -- Prison Casing
	[35669]="0:12:1:1:::1:0:", -- Energy Core
	[35670]="0:4:3:1:Plate::1:0:", -- Brann's Lost Mining Helmet
	[35671]="0:15:1:1:CombatPet::1:0:", -- Augmented Arcane Prison
	[35672]="0:4:3:1:Mail::1:0:", -- Hollow Geode Helm
	[35673]="0:4:3:1:Cloth::1:0:", -- Leggings of Burning Gleam
	[35675]="0:4:3:1:Mail::1:0:", -- Linked Armor of the Sphere
	[35676]="0:4:3:1:Leather::1:0:", -- Constellation Leggings
	[35677]="0:4:3:1:Leather::1:0:", -- Cosmos Vestments
	[35678]="0:4:3:1:Plate::1:0:", -- Ironshaper's Legplates
	[35679]="0:4:3:1:Cloth::1:0:", -- Static Cowl
	[35680]="0:4:3:1:Amulet::1:0:", -- Amulet of Wills
	[35681]="0:2:3:1:Dagger::1:0:", -- Unrelenting Blade
	[35682]="0:4:3:1:Cloth::1:0:", -- Rune Giant Bindings
	[35683]="0:4:3:1:Ring::1:0:", -- Palladium Ring
	[35685]="0:12:1:10:::1:0:", -- Crystallized Mana Shard
	[35686]="0:12:1:20:::1:0:", -- Stolen Moa'ki Goods
	[35687]="0:12:1:1:::1:0:", -- Tanathal's Phylactery
	[35688]="0:12:1:1:::1:0:", -- Blood of Loguhn
	[35690]="0:12:1:1:::1:0:", -- Arcane Power Focus
	[35691]="950:15:0:10:Junk::1:0:29561", -- Ruined Metal Parts
	[35692]="0:12:1:12:::1:0:", -- Snowfall Glade Pup
	[35693]="0:4:4:1:Trinket::1:0:", -- Figurine - Empyrean Tortoise
	[35694]="0:4:4:1:Trinket::1:0:", -- Figurine - Khorium Boar
	[35695]="250000:9:1:1:Jewelcrafting::1:0:25032", -- Design: Figurine - Empyrean Tortoise
	[35696]="250000:9:1:1:Jewelcrafting::1:0:25032", -- Design: Figurine - Khorium Boar
	[35697]="250000:9:1:1:Jewelcrafting::1:0:25032", -- Design: Figurine - Crimson Serpent
	[35698]="250000:9:1:1:Jewelcrafting::1:0:25032", -- Design: Figurine - Shadowsong Panther
	[35699]="250000:9:1:1:Jewelcrafting::1:0:25032", -- Design: Figurine - Seaspray Albatross
	[35700]="0:4:4:1:Trinket::1:0:", -- Figurine - Crimson Serpent
	[35701]="0:12:1:1:::1:0:", -- Issliruk's Totem
	[35702]="0:4:4:1:Trinket::1:0:", -- Figurine - Shadowsong Panther
	[35703]="0:4:4:1:Trinket::1:0:", -- Figurine - Seaspray Albatross
	[35704]="0:0:1:1:Consumable::1:0:", -- Incendiary Explosives
	[35705]="0:13:1:1:::1:0:", -- Cart Release Key
	[35706]="0:12:1:1:::1:0:", -- Crate of Farshire Ore
	[35707]="0:3:3:1:GemPurple::1:0:", -- Regal Nightseye
	[35708]="120000:9:1:1:Jewelcrafting::1:0:25032", -- Design: Regal Nightseye
	[35709]="0:12:1:10:::1:0:", -- Saragosa's Corpse
	[35711]="0:12:1:20:::1:0:", -- Kaskala Supplies
	[35716]="0:0:1:20:Flask::1:0:23483,23484", -- Shattrath Flask of Pure Death
	[35717]="0:0:1:20:Flask::1:0:23483,23484", -- Shattrath Flask of Blinding Light
	[35718]="0:12:1:1:::1:0:", -- Raelorasz' Flare
	[35720]="0:0:1:20:FoodDrink::1:0:", -- Lord of Frost's Private Label
	[35722]="0:15:1:1:Junk::1:0:", -- Foror's Wipe Neutralizer
	[35723]="0:12:1:1:::1:0:", -- Shards of Ahune
	[35725]="0:12:1:1:::1:0:", -- Summer Incense
	[35726]="0:12:1:10:::1:0:", -- Horde Armaments
	[35733]="0:4:4:1:Ring::1:0:", -- Ring of Harmonic Beauty
	[35734]="0:12:1:5:::1:0:", -- Boulder
	[35736]="0:12:1:1:::1:0:", -- Bounty Hunter's Cage
	[35737]="0:12:1:10:::1:0:", -- Missing Journal Page
	[35738]="0:12:1:1:::1:0:", -- Brann Bronzebeard's Journal
	[35739]="0:12:1:1:::1:0:", -- Incomplete Journal
	[35746]="0:12:1:1:::1:0:", -- Runic Keystone
	[35747]="0:12:1:10:::1:0:", -- Runic Keystone Fragment
	[35748]="0:4:4:1:Trinket::1:0:", -- Guardian's Alchemist Stone
	[35749]="0:4:4:1:Trinket::1:0:", -- Sorcerer's Alchemist Stone
	[35750]="0:4:4:1:Trinket::1:0:", -- Redeemer's Alchemist Stone
	[35751]="0:4:4:1:Trinket::1:0:", -- Assassin's Alchemist Stone
	[35752]="250000:9:1:1:Alchemy::1:0:25032", -- Recipe: Guardian's Alchemist Stone
	[35753]="250000:9:1:1:Alchemy::1:0:25032", -- Recipe: Sorcerer's Alchemist Stone
	[35754]="250000:9:1:1:Alchemy::1:0:25032", -- Recipe: Redeemer's Alchemist Stone
	[35755]="250000:9:1:1:Alchemy::1:0:25032", -- Recipe: Assassin's Alchemist Stone
	[35756]="0:9:3:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Steelweave
	[35758]="0:3:4:1:GemGreen::1:0:", -- Steady Seaspray Emerald
	[35759]="0:3:4:1:GemGreen::1:0:", -- Forceful Seaspray Emerald
	[35760]="0:3:4:1:GemOrange::1:0:", -- Reckless Pyrestone
	[35761]="0:3:4:1:GemYellow::1:0:", -- Quick Lionseye
	[35762]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Reckless Pyrestone
	[35763]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Quick Lionseye
	[35764]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Steady Seaspray Emerald
	[35765]="60000:9:4:1:Jewelcrafting::1:0:23437", -- Design: Forceful Seaspray Emerald
	[35766]="500000:9:4:1:Jewelcrafting::1:0:25032,25950,27666", -- Design: Steady Seaspray Emerald
	[35767]="500000:9:4:1:Jewelcrafting::1:0:25032,25950,27666", -- Design: Reckless Pyrestone
	[35768]="500000:9:4:1:Jewelcrafting::1:0:25032,25950,27666", -- Design: Quick Lionseye
	[35769]="500000:9:4:1:Jewelcrafting::1:0:25032,25950,27666", -- Design: Forceful Seaspray Emerald
	[35774]="0:12:1:1:::1:0:", -- Trident of Naz'jan
	[35782]="0:12:1:10:::1:0:", -- Shimmering Snowcap
	[35783]="0:15:1:1:Junk::1:0:", -- Moonrest Gardens Plans
	[35784]="0:12:1:1:::1:0:", -- Blood Oath of the Horde
	[35788]="0:15:0:10:Junk::1:0:", -- Destroyed Magic Item
	[35790]="0:15:0:10:Junk::1:0:", -- Torn Robes
	[35791]="0:15:0:10:Junk::1:0:", -- Spoiled Reagents
	[35792]="0:15:1:1:Junk::1:0:", -- Mage Hunter Personal Effects
	[35794]="8000:7:1:20:Meat::5:0:26484", -- Silvercoat Stag Meat
	[35795]="0:12:1:1:::1:0:", -- Waterweed Frond
	[35796]="10000:12:1:1:::1:0:26484", -- Howlin' Good Moonshine
	[35797]="0:12:1:1:::1:0:", -- Drakuru's Elixir
	[35798]="0:12:1:10:::1:0:", -- Ice Serpent Eye
	[35799]="0:12:1:10:::1:0:", -- Frozen Mojo
	[35800]="0:12:1:1:::1:0:", -- Wind Trader Mu'fah's Remains
	[35801]="0:12:1:1:::1:0:", -- The Scales of Goramosh
	[35802]="0:12:1:20:::1:0:", -- Tua'kea Crab Trap
	[35803]="0:12:1:1:::1:0:", -- Scalawag Frog
	[35806]="0:12:1:1:::1:0:", -- Eye of the Prophets
	[35807]="0:2:2:1:Stave::1:0:", -- Bramblethorn Greatstaff
	[35808]="0:2:2:1:OneHandSword::1:0:", -- Coldstone Cutlass
	[35809]="0:2:2:1:Dagger::1:0:", -- Earthspike
	[35810]="0:2:2:1:OneHandMace::1:0:", -- Pacifying Pummeler
	[35811]="0:2:2:1:Crossbow::1:0:", -- Elekk-Horn Crossbow
	[35812]="0:2:2:1:TwoHandMace::1:0:", -- Cragthumper
	[35813]="8000:12:1:1:::1:0:24539", -- Shiny Knife
	[35814]="0:4:2:1:Cloth::1:0:", -- Benevolent Hood
	[35815]="0:4:2:1:Leather::1:0:", -- Bone-Threaded Harness
	[35816]="0:4:2:1:Mail::1:0:", -- Blood-Stained Chain Leggings
	[35817]="0:4:2:1:Shield::1:0:", -- Nerubian Inner Husk
	[35818]="0:4:2:1:Cloth::1:0:", -- Stretch-Hide Spaulders
	[35819]="0:12:1:1:::1:0:", -- Thor Modan Stability Profile
	[35820]="0:4:2:1:Leather::1:0:", -- Deacon's Wraps
	[35821]="0:4:2:1:Mail::1:0:", -- Streamlined Stompers
	[35822]="0:4:2:1:Plate::1:0:", -- Scavenged Tirasian Plate
	[35823]="0:2:2:1:Dagger::1:0:", -- Ice-Rimed Dagger
	[35824]="0:2:2:1:OneHandSword::1:0:", -- Stoneblade Slicer
	[35826]="0:2:2:1:Wand::1:0:", -- Whelpling-Skull Zapper
	[35827]="0:2:2:1:Wand::1:0:", -- Regal Sceptre
	[35828]="0:12:1:1:::1:0:", -- Totemic Beacon
	[35829]="0:2:2:1:Bow::1:0:", -- Coldspike Longbow
	[35830]="0:2:2:1:FistWeapon::1:0:", -- Worn Vrykul Smasher
	[35831]="0:12:1:1:::1:0:", -- The Flesh of "Two Huge Pincers"
	[35832]="0:4:2:1:Cloth::1:0:", -- Blauvelt's Special Occasion Gloves
	[35833]="0:4:2:1:Leather::1:0:", -- Imperious Worghide Cap
	[35834]="0:4:2:1:Mail::1:0:", -- Nimblefinger Scaled Gloves
	[35835]="0:4:2:1:Plate::1:0:", -- Antique Reinforced Legguards
	[35836]="0:12:1:10:::1:0:", -- Zim'bo's Mojo
	[35837]="0:12:1:1:::1:0:", -- Portable Seismograph
	[35838]="0:12:1:1:::1:0:", -- Tu'u'gwar's Bait
	[35839]="0:4:2:1:Amulet::1:0:", -- Runed Clamshell Choker
	[35841]="0:4:2:1:Leather::1:0:", -- Frost-Trimmed Gauntlets
	[35842]="0:4:2:1:Mail::1:0:", -- Azure Chain Hauberk
	[35843]="0:4:2:1:Plate::1:0:", -- Ramshorn-Inlaid Shoulders
	[35844]="0:4:2:1:Cloth::1:0:", -- Shock-Resistant Hood
	[35845]="0:2:2:1:Thrown::1:0:", -- Crystalline Star
	[35846]="0:4:2:1:Mail::1:0:", -- Banded Chain Gloves
	[35848]="0:4:2:1:Plate::1:0:", -- Munificent Legguards
	[35849]="0:2:2:1:TwoHandSword::1:0:", -- Featherweight Claymore
	[35850]="0:12:1:1:::1:0:", -- Trident of Naz'jan
	[35851]="0:2:2:1:FistWeapon::1:0:", -- Acid-Etched Knuckles
	[35852]="0:2:2:1:Dagger::1:0:", -- Fullered Coldsteel Dagger
	[35856]="0:2:2:1:Gun::1:0:", -- Hair-Trigger Blunderbuss
	[35857]="0:4:2:1:Shield::1:0:", -- Munificent Bulwark
	[35858]="0:4:2:1:OffHandFrill::1:0:", -- Tome of Alacrity
	[35859]="0:4:2:1:Cloth::1:0:", -- Fire-Purifying Tunic
	[35860]="0:4:2:1:Leather::1:0:", -- Flexible Leather Footwraps
	[35861]="0:4:2:1:Mail::1:0:", -- Inescapable Girdle
	[35862]="0:4:2:1:Plate::1:0:", -- Light-Bound Chestguard
	[35863]="0:4:2:1:Cloth::1:0:", -- Earth-Infused Leggings
	[35864]="0:4:2:1:Leather::1:0:", -- Fizznik's Patented Earwarmer
	[35865]="0:4:2:1:Shield::1:0:", -- Arcanum Shield
	[35866]="0:4:2:1:Plate::1:0:", -- Master Artilleryman Boots
	[35867]="0:4:2:1:Ring::1:0:", -- Nimblefinger Band
	[35868]="0:4:2:1:Leather::1:0:", -- Grounded Pants
	[35869]="0:4:2:1:Mail::1:0:", -- Hex-Linked Stronghelm
	[35870]="0:2:2:1:TwoHandAxe::1:0:", -- Stoneground Cleaver
	[35871]="0:4:2:1:Cloth::1:0:", -- Indigo Robe of Replenishment
	[35872]="0:4:2:1:Leather::1:0:", -- Iron-Studded Leggings
	[35873]="0:4:2:1:Mail::1:0:", -- Interlinked Chain Girdle
	[35875]="0:4:2:1:Plate::1:0:", -- Beneficent Skullcap
	[35877]="0:4:2:1:Leather::1:0:", -- Worgskin Shoulders
	[35878]="0:4:2:1:Mail::1:0:", -- Dusk-Linked Leggings
	[35879]="0:4:2:1:Plate::1:0:", -- Gold-Plated Coldsteel Girdle
	[35880]="0:4:2:1:Cloth::1:0:", -- Earthwell Footwraps
	[35881]="0:4:2:1:Ring::1:0:", -- Lost Vrykul Signet
	[35882]="0:4:2:1:Mail::1:0:", -- Magispike Helm
	[35883]="0:4:2:1:Plate::1:0:", -- Silversteel Gauntlets
	[35884]="0:4:2:1:Cloth::1:0:", -- Regal Pantaloons
	[35885]="0:4:2:1:Leather::1:0:", -- Tribal Chestguard
	[35886]="0:4:2:1:Amulet::1:0:", -- Worgtooth Pendant
	[35887]="0:4:2:1:Plate::1:0:", -- Loam-Stained Greaves
	[35888]="0:4:2:1:Cloth::1:0:", -- Embossed Ermine Girdle
	[35889]="0:4:2:1:Leather::1:0:", -- Bone-Inlaid Bracers
	[35890]="0:4:2:1:Mail::1:0:", -- Magdun Spaulders
	[35891]="0:4:2:1:Plate::1:0:", -- Runeplate Helm
	[35892]="0:4:2:1:Cloth::1:0:", -- Flamebinder Handwraps
	[35893]="0:4:2:1:Leather::1:0:", -- Coldstone-Inlaid Waistguard
	[35894]="0:4:2:1:Mail::1:0:", -- Purestrike Bracers
	[35895]="0:4:2:1:Plate::1:0:", -- Emeraldscale Pauldrons
	[35896]="0:4:2:1:Cloth::1:0:", -- Icestriker Bands
	[35897]="0:4:2:1:Cloak::1:0:", -- Ice-Crusted Cape
	[35898]="0:4:2:1:Mail::1:0:", -- Reinforced Tuskhide Hauberk
	[35899]="0:4:2:1:Plate::1:0:", -- Bloodbinder's Girdle
	[35900]="0:4:2:1:Cloth::1:0:", -- Supple Doeskin Moccasins
	[35901]="0:4:2:1:Leather::1:0:", -- Rejuvenating Cord
	[35902]="0:4:2:1:Mail::1:0:", -- Shock-Bound Spaulders
	[35903]="0:4:2:1:Plate::1:0:", -- Onyx Grips
	[35904]="0:4:2:1:Amulet::1:0:", -- Puissance-Infused Pendant
	[35905]="0:4:2:1:Leather::1:0:", -- Vinewoven Tunic
	[35906]="0:15:4:1:Mount::1:0:12783", -- Reins of the Black War Elekk
	[35907]="0:12:1:1:::1:0:", -- Toalu'u's Spiritual Incense
	[35908]="0:12:1:1:::1:0:", -- Mack's Dark Grog
	[35909]="0:4:2:1:Mail::1:0:", -- Sun-fired Striders
	[35910]="0:4:2:1:Plate::1:0:", -- Shaleground Bracers
	[35911]="0:4:2:1:Ring::1:0:", -- Unsparing Band
	[35912]="0:4:2:1:Cloak::1:0:", -- Crackling Cloak
	[35913]="0:4:2:1:Cloth::1:0:", -- Gholamweave Leggings
	[35914]="0:4:2:1:Leather::1:0:", -- Proto-Drake Tooth Spaulders
	[35915]="0:4:2:1:Mail::1:0:", -- Darksteel Ringmail Greaves
	[35916]="0:4:2:1:Plate::1:0:", -- Worgblood Berserker's Hauberk
	[35917]="0:4:2:1:Cloth::1:0:", -- Wrathwrought Shoulderpads
	[35918]="0:4:2:1:Leather::1:0:", -- Spiked Skullguard
	[35919]="0:4:2:1:Mail::1:0:", -- Whispersteel Handguards
	[35920]="0:4:2:1:Plate::1:0:", -- Feather-Lined Shoulderpads
	[35921]="0:4:2:1:Cloth::1:0:", -- Flint-Reinforced Spaulders
	[35922]="0:4:2:1:Ring::1:0:", -- Dark Iron Signet
	[35923]="0:4:2:1:Mail::1:0:", -- Cold-Iron Armbands
	[35924]="0:4:2:1:Plate::1:0:", -- Arcanum-Bound Bracers
	[35925]="0:4:2:1:Ring::1:0:", -- Shimmering Cold-Iron Band
	[35926]="0:4:2:1:Leather::1:0:", -- Artfully Tooled Leggings
	[35927]="0:4:2:1:Mail::1:0:", -- Songscale Breastplate
	[35928]="0:4:2:1:Plate::1:0:", -- Cold-Forged Bronze Legplates
	[35929]="0:4:2:1:Cloth::1:0:", -- Gholamcloth Wrap
	[35930]="0:4:2:1:Leather::1:0:", -- Inscribed Worghide Treads
	[35931]="0:4:2:1:Mail::1:0:", -- Appointed Scalemail Leggings
	[35932]="0:4:2:1:Ring::1:0:", -- Earthbinder's Regenerating Band
	[35933]="0:4:2:1:Mail::1:0:", -- Ramshorn Greathelm
	[35934]="0:4:2:1:Plate::1:0:", -- Ghoul-Crushing Stompers
	[35935]="0:4:2:1:Trinket::1:0:", -- Infused Coldstone Rune
	[35936]="0:4:2:1:Amulet::1:0:", -- Worg-Fang Talisman
	[35937]="0:4:2:1:Trinket::1:0:", -- Braxley's Backyard Moonshine
	[35938]="0:4:2:1:Cloak::1:0:", -- Drape of Munificence
	[35941]="0:12:1:1:::1:0:", -- Letter from Saurfang
	[35943]="0:12:1:1:::1:0:", -- Jeremiah's Tools
	[35944]="0:12:1:1:::1:0:", -- Lurid's Bones
	[35945]="0:0:3:1:Consumable::1:0:", -- Brilliant Glass
	[35946]="0:0:1:1:Consumable::1:0:", -- Fizzcrank Practice Parachute
	[35947]="16000:0:1:20:FoodDrink::5:0:3329,4554,4571,6741,10367,12096,12097,24149,25278,27032,27069,27137,28685,29121,29205,32419,32420,32631,32638,32642,33018,33644,33865,33866", -- Sparkling Frostcap
	[35948]="16000:0:1:20:FoodDrink:185:5:0:3017,3342,4255,6735,6740,7978,12096,12097,17630,25245,26375,26567,26680,28038,28682,28685,29121,29547,29715,31019,32419,32420,32478,32631,32638,32642,33644,33865,33866", -- Savory Snowplum
	[35949]="8500:0:1:20:FoodDrink:185:5:0:3017,3342,4255,6735,6740,7978,12096,12097,17630,25245,26375,26567,26680,28038,28682,28685,29121,29547,29715,31019,32419,32420,32478,32631,32638,32642,33644,33865,33866", -- Tundra Berries
	[35950]="16000:0:1:20:FoodDrink::5:0:3003,3518,4255,5109,6740,10367,16739,17630,23522,23603,23937,24033,25245,26567,26709,27027,27042,27044,27052,27069,27125,27137,27148,27174,27187,27950,28682,28685,28686,28687,28791,29121,29532,29583,29714,29715,29904,29926,29944,29963,29971,30005,30098,30254,30255,30309,30346,31557,32403,32412,32413,32419,32420,32421,32424,32426,32631,32638,32642,33644,33865,33866", -- Sweet Potato Bread
	[35951]="16000:0:1:20:FoodDrink::5:0:4221,4255,10367,16618,16739,24057,25248,26567,27044,27144,27148,27174,27181,27187,27190,28682,28742,28791,28812,29122,29583,30309,30827,31019,31804,31805,32631,32638,32642,33644,33865,33866", -- Poached Emperor Salmon
	[35952]="16000:0:1:20:FoodDrink::5:0:483,4255,4981,6746,10367,17630,23604,23731,23937,24149,24342,25245,25278,26567,27027,27042,27052,27066,27950,28686,28687,29122,29532,29714,29715,30346,31557,32403,32412,32413,32421,32424,32426,32631,32638,32642,33018,33644,33865,33866", -- Briny Hardcheese
	[35953]="16000:0:1:20:FoodDrink::5:0:3025,3312,3368,4169,4255,5111,5124,6929,10367,12096,12097,16618,16739,17630,23605,23937,25248,26375,26567,26596,26709,26868,27027,27042,27044,27052,27125,27148,27174,27187,27950,28046,28686,28687,28811,29122,29205,29532,29905,29944,30254,30255,30827,31557,32403,32412,32413,32421,32424,32426,32478,32631,32638,32642,33644,33865,33866", -- Mead Basted Caribou
	[35954]="6000:0:1:20:FoodDrink::5:0:4169,4255,4554,4571,4981,5111,6735,6740,6741,6746,6929,10367,12096,12097,16618,16739,17630,23731,23737,24033,24057,24149,24342,25245,25278,26375,26567,26596,26680,26709,27027,27042,27044,27052,27066,27069,27125,27137,27148,27174,27187,27950,28038,28682,28685,28686,28687,28791,28811,29049,29121,29122,29205,29532,29548,29583,29904,29926,29944,29963,29971,30098,30254,30255,30309,30346,30827,31017,31557,32334,32403,32412,32413,32415,32416,32419,32420,32421,32424,32426,32478,32631,32638,32642,33018,33645,33867,33868,33869", -- Sweetened Goat's Milk
	[35955]="0:4:2:1:Cloth::1:0:", -- Farshire Belt
	[35956]="0:4:2:1:Cloth::1:0:", -- Farshire Footpads
	[35957]="0:4:2:1:Cloth::1:0:", -- Farshire Robe
	[35958]="0:4:2:1:Cloth::1:0:", -- Farshire Gloves
	[35959]="0:4:2:1:Cloth::1:0:", -- Farshire Hood
	[35960]="0:4:2:1:Cloth::1:0:", -- Farshire Pants
	[35961]="0:4:2:1:Cloth::1:0:", -- Farshire Shoulderpads
	[35962]="0:4:2:1:Cloth::1:0:", -- Farshire Cuffs
	[35963]="0:4:2:1:Cloth::1:0:", -- Bloodspore Sash
	[35964]="0:4:2:1:Cloth::1:0:", -- Bloodspore Sandals
	[35965]="0:4:2:1:Cloth::1:0:", -- Bloodspore Robe
	[35966]="0:4:2:1:Cloth::1:0:", -- Bloodspore Gloves
	[35967]="0:4:2:1:Cloth::1:0:", -- Bloodspore Hood
	[35968]="0:4:2:1:Cloth::1:0:", -- Bloodspore Leggings
	[35969]="0:4:2:1:Cloth::1:0:", -- Bloodspore Mantle
	[35970]="0:4:2:1:Cloth::1:0:", -- Bloodspore Bracelets
	[35971]="0:4:2:1:Cloth::1:0:", -- Mur'ghoul Girdle
	[35972]="0:4:2:1:Cloth::1:0:", -- Mur'ghoul Boots
	[35973]="0:4:2:1:Cloth::1:0:", -- Mur'ghoul Robe
	[35974]="0:4:2:1:Cloth::1:0:", -- Mur'ghoul Handwraps
	[35975]="0:4:2:1:Cloth::1:0:", -- Mur'ghoul Cap
	[35976]="0:4:2:1:Cloth::1:0:", -- Mur'ghoul Leggings
	[35977]="0:4:2:1:Cloth::1:0:", -- Mur'ghoul Shoulderpads
	[35978]="0:4:2:1:Cloth::1:0:", -- Mur'ghoul Wristwraps
	[35979]="0:4:2:1:Cloth::1:0:", -- Foothold Belt
	[35980]="0:4:2:1:Cloth::1:0:", -- Foothold Boots
	[35981]="0:4:2:1:Cloth::1:0:", -- Foothold Robe
	[35982]="0:4:2:1:Cloth::1:0:", -- Foothold Gloves
	[35983]="0:4:2:1:Cloth::1:0:", -- Foothold Hood
	[35984]="0:4:2:1:Cloth::1:0:", -- Foothold Pants
	[35985]="0:4:2:1:Cloth::1:0:", -- Foothold Shoulderpads
	[35986]="0:4:2:1:Cloth::1:0:", -- Foothold Cuffs
	[35987]="0:4:2:1:Cloth::1:0:", -- Bristlepine Cord
	[35988]="0:4:2:1:Cloth::1:0:", -- Bristlepine Sandals
	[35989]="0:4:2:1:Cloth::1:0:", -- Bristlepine Robe
	[35990]="0:4:2:1:Cloth::1:0:", -- Bristlepine Handwraps
	[35991]="0:4:2:1:Cloth::1:0:", -- Bristlepine Headpiece
	[35992]="0:4:2:1:Cloth::1:0:", -- Bristlepine Leggings
	[35993]="0:4:2:1:Cloth::1:0:", -- Bristlepine Shoulderpads
	[35994]="0:4:2:1:Cloth::1:0:", -- Bristlepine Bracers
	[35995]="0:4:2:1:Cloth::1:0:", -- Voldrune Sash
	[35996]="0:4:2:1:Cloth::1:0:", -- Voldrune Slippers
	[35997]="0:4:2:1:Cloth::1:0:", -- Voldrune Robe
	[35998]="0:4:2:1:Cloth::1:0:", -- Voldrune Gloves
	[35999]="0:4:2:1:Cloth::1:0:", -- Voldrune Crown
	[36000]="0:4:2:1:Cloth::1:0:", -- Voldrune Legs
	[36001]="0:4:2:1:Cloth::1:0:", -- Voldrune Mantle
	[36002]="0:4:2:1:Cloth::1:0:", -- Voldrune Bracelets
	[36003]="0:4:2:1:Cloth::1:0:", -- Icemist Sash
	[36004]="0:4:2:1:Cloth::1:0:", -- Icemist Slippers
	[36005]="0:4:2:1:Cloth::1:0:", -- Icemist Robe
	[36006]="0:4:2:1:Cloth::1:0:", -- Icemist Gloves
	[36007]="0:4:2:1:Cloth::1:0:", -- Icemist Circlet
	[36008]="0:4:2:1:Cloth::1:0:", -- Icemist Pants
	[36009]="0:4:2:1:Cloth::1:0:", -- Icemist Mantle
	[36010]="0:4:2:1:Cloth::1:0:", -- Icemist Bracelets
	[36011]="0:4:2:1:Cloth::1:0:", -- Tethys Sash
	[36012]="0:4:2:1:Cloth::1:0:", -- Tethys Slippers
	[36013]="0:4:2:1:Cloth::1:0:", -- Tethys Robe
	[36014]="0:4:2:1:Cloth::1:0:", -- Tethys Gloves
	[36015]="0:4:2:1:Cloth::1:0:", -- Tethys Hood
	[36016]="0:4:2:1:Cloth::1:0:", -- Tethys Leggings
	[36017]="0:4:2:1:Cloth::1:0:", -- Tethys Mantle
	[36018]="0:4:2:1:Cloth::1:0:", -- Tethys Bracelets
	[36019]="0:4:2:1:Cloth::1:0:", -- Aerie Belt
	[36020]="0:4:2:1:Cloth::1:0:", -- Aerie Boots
	[36021]="0:4:2:1:Cloth::1:0:", -- Aerie Robe
	[36022]="0:4:2:1:Cloth::1:0:", -- Aerie Gloves
	[36023]="0:4:2:1:Cloth::1:0:", -- Aerie Headpiece
	[36024]="0:4:2:1:Cloth::1:0:", -- Aerie Pants
	[36025]="0:4:2:1:Cloth::1:0:", -- Aerie Shoulderpads
	[36026]="0:4:2:1:Cloth::1:0:", -- Aerie Bracers
	[36027]="0:4:2:1:Cloth::1:0:", -- Oracle Belt
	[36028]="0:4:2:1:Cloth::1:0:", -- Oracle Slippers
	[36029]="0:4:2:1:Cloth::1:0:", -- Oracle Robe
	[36030]="0:4:2:1:Cloth::1:0:", -- Oracle Gloves
	[36031]="0:4:2:1:Cloth::1:0:", -- Oracle Circlet
	[36032]="0:4:2:1:Cloth::1:0:", -- Oracle Leggings
	[36033]="0:4:2:1:Cloth::1:0:", -- Oracle Mantle
	[36034]="0:4:2:1:Cloth::1:0:", -- Oracle Bracelets
	[36035]="0:4:2:1:Cloth::1:0:", -- Condor Belt
	[36036]="0:4:2:1:Cloth::1:0:", -- Condor Sandals
	[36037]="0:4:2:1:Cloth::1:0:", -- Condor Robe
	[36038]="0:4:2:1:Cloth::1:0:", -- Condor Gloves
	[36039]="0:4:2:1:Cloth::1:0:", -- Condor Headpiece
	[36040]="0:4:2:1:Cloth::1:0:", -- Condor Pants
	[36041]="0:4:2:1:Cloth::1:0:", -- Condor Shoulderpads
	[36042]="0:4:2:1:Cloth::1:0:", -- Condor Bindings
	[36043]="0:4:2:1:Cloth::1:0:", -- Crystalsong Sash
	[36044]="0:4:2:1:Cloth::1:0:", -- Crystalsong Slippers
	[36045]="0:4:2:1:Cloth::1:0:", -- Crystalsong Robe
	[36046]="0:4:2:1:Cloth::1:0:", -- Crystalsong Gloves
	[36047]="0:4:2:1:Cloth::1:0:", -- Crystalsong Crown
	[36048]="0:4:2:1:Cloth::1:0:", -- Crystalsong Leggings
	[36049]="0:4:2:1:Cloth::1:0:", -- Crystalsong Mantle
	[36050]="0:4:2:1:Cloth::1:0:", -- Crystalsong Bracelets
	[36051]="0:4:2:1:Cloth::1:0:", -- Vizier Sash
	[36052]="0:4:2:1:Cloth::1:0:", -- Vizier Slippers
	[36053]="0:4:2:1:Cloth::1:0:", -- Vizier Robe
	[36054]="0:4:2:1:Cloth::1:0:", -- Vizier Gloves
	[36055]="0:4:2:1:Cloth::1:0:", -- Vizier Hood
	[36056]="0:4:2:1:Cloth::1:0:", -- Vizier Leggings
	[36057]="0:4:2:1:Cloth::1:0:", -- Vizier Mantle
	[36058]="0:4:2:1:Cloth::1:0:", -- Vizier Bracelets
	[36059]="0:4:2:1:Cloth::1:0:", -- Coldwraith Sash
	[36060]="0:4:2:1:Cloth::1:0:", -- Coldwraith Boots
	[36061]="0:4:2:1:Cloth::1:0:", -- Coldwraith Robe
	[36062]="0:4:2:1:Cloth::1:0:", -- Coldwraith Handwraps
	[36063]="0:4:2:1:Cloth::1:0:", -- Coldwraith Cowl
	[36064]="0:4:2:1:Cloth::1:0:", -- Coldwraith Pants
	[36065]="0:4:2:1:Cloth::1:0:", -- Coldwraith Mantle
	[36066]="0:4:2:1:Cloth::1:0:", -- Coldwraith Bindings
	[36067]="0:4:2:1:Leather::1:0:", -- Daggercap Waistband
	[36068]="0:4:2:1:Leather::1:0:", -- Daggercap Boots
	[36069]="0:4:2:1:Leather::1:0:", -- Daggercap Jerkin
	[36070]="0:4:2:1:Leather::1:0:", -- Daggercap Gloves
	[36071]="0:4:2:1:Leather::1:0:", -- Daggercap Cover
	[36072]="0:4:2:1:Leather::1:0:", -- Daggercap Trousers
	[36073]="0:4:2:1:Leather::1:0:", -- Daggercap Spaulders
	[36074]="0:4:2:1:Leather::1:0:", -- Daggercap Bracers
	[36075]="0:4:2:1:Leather::1:0:", -- Winterfin Cord
	[36076]="0:4:2:1:Leather::1:0:", -- Winterfin Boots
	[36077]="0:4:2:1:Leather::1:0:", -- Winterfin Chestpiece
	[36078]="0:4:2:1:Leather::1:0:", -- Winterfin Gloves
	[36079]="0:4:2:1:Leather::1:0:", -- Winterfin Cowl
	[36080]="0:4:2:1:Leather::1:0:", -- Winterfin Legguards
	[36081]="0:4:2:1:Leather::1:0:", -- Winterfin Shoulderguards
	[36082]="0:4:2:1:Leather::1:0:", -- Winterfin Bindings
	[36083]="0:4:2:1:Leather::1:0:", -- Riplash Belt
	[36084]="0:4:2:1:Leather::1:0:", -- Riplash Boots
	[36085]="0:4:2:1:Leather::1:0:", -- Riplash Jerkin
	[36086]="0:4:2:1:Leather::1:0:", -- Riplash Gloves
	[36087]="0:4:2:1:Leather::1:0:", -- Riplash Cover
	[36088]="0:4:2:1:Leather::1:0:", -- Riplash Leggings
	[36089]="0:4:2:1:Leather::1:0:", -- Riplash Pauldrons
	[36090]="0:4:2:1:Leather::1:0:", -- Riplash Wristguards
	[36091]="0:4:2:1:Leather::1:0:", -- Wildevar Belt
	[36092]="0:4:2:1:Leather::1:0:", -- Wildevar Boots
	[36093]="0:4:2:1:Leather::1:0:", -- Wildevar Tunic
	[36094]="0:4:2:1:Leather::1:0:", -- Wildevar Gloves
	[36095]="0:4:2:1:Leather::1:0:", -- Wildevar Cap
	[36096]="0:4:2:1:Leather::1:0:", -- Wildevar Pants
	[36097]="0:4:2:1:Leather::1:0:", -- Wildevar Shoulderguards
	[36098]="0:4:2:1:Leather::1:0:", -- Wildevar Armguards
	[36099]="0:4:2:1:Leather::1:0:", -- Caribou Waistband
	[36100]="0:4:2:1:Leather::1:0:", -- Caribou Boots
	[36101]="0:4:2:1:Leather::1:0:", -- Caribou Vest
	[36102]="0:4:2:1:Leather::1:0:", -- Caribou Gloves
	[36103]="0:4:2:1:Leather::1:0:", -- Caribou Cowl
	[36104]="0:4:2:1:Leather::1:0:", -- Caribou Britches
	[36105]="0:4:2:1:Leather::1:0:", -- Caribou Shoulders
	[36106]="0:4:2:1:Leather::1:0:", -- Caribou Bands
	[36107]="0:4:2:1:Leather::1:0:", -- Vileprey Cord
	[36108]="0:4:2:1:Leather::1:0:", -- Vileprey Boots
	[36109]="0:4:2:1:Leather::1:0:", -- Vileprey Armor
	[36110]="0:4:2:1:Leather::1:0:", -- Vileprey Gloves
	[36111]="0:4:2:1:Leather::1:0:", -- Vileprey Hood
	[36112]="0:4:2:1:Leather::1:0:", -- Vileprey Leggings
	[36113]="0:4:2:1:Leather::1:0:", -- Vileprey Pauldrons
	[36114]="0:4:2:1:Leather::1:0:", -- Vileprey Bracers
	[36115]="0:4:2:1:Leather::1:0:", -- Taunka Belt
	[36116]="0:4:2:1:Leather::1:0:", -- Taunka Boots
	[36117]="0:4:2:1:Leather::1:0:", -- Taunka Tunic
	[36118]="0:4:2:1:Leather::1:0:", -- Taunka Gloves
	[36119]="0:4:2:1:Leather::1:0:", -- Taunka Hat
	[36120]="0:4:2:1:Leather::1:0:", -- Taunka Legguards
	[36121]="0:4:2:1:Leather::1:0:", -- Taunka Spaulders
	[36122]="0:4:2:1:Leather::1:0:", -- Taunka Armguards
	[36123]="0:4:2:1:Leather::1:0:", -- Muradin Belt
	[36124]="0:4:2:1:Leather::1:0:", -- Muradin Boots
	[36125]="0:4:2:1:Leather::1:0:", -- Muradin Chestpiece
	[36126]="0:4:2:1:Leather::1:0:", -- Muradin Gloves
	[36127]="0:4:2:1:Leather::1:0:", -- Muradin Hood
	[36128]="0:4:2:1:Leather::1:0:", -- Muradin Pants
	[36129]="0:4:2:1:Leather::1:0:", -- Muradin Shoulders
	[36130]="0:4:2:1:Leather::1:0:", -- Muradin Bindings
	[36131]="0:4:2:1:Leather::1:0:", -- Wolverine Girdle
	[36132]="0:4:2:1:Leather::1:0:", -- Wolverine Boots
	[36133]="0:4:2:1:Leather::1:0:", -- Wolverine Jerkin
	[36134]="0:4:2:1:Leather::1:0:", -- Wolverine Gloves
	[36135]="0:4:2:1:Leather::1:0:", -- Wolverine Cap
	[36136]="0:4:2:1:Leather::1:0:", -- Wolverine Leggings
	[36137]="0:4:2:1:Leather::1:0:", -- Wolverine Shoulderguards
	[36138]="0:4:2:1:Leather::1:0:", -- Wolverine Armguards
	[36139]="0:4:2:1:Leather::1:0:", -- Ghrino Belt
	[36140]="0:4:2:1:Leather::1:0:", -- Ghrino Boots
	[36141]="0:4:2:1:Leather::1:0:", -- Ghrino Vest
	[36142]="0:4:2:1:Leather::1:0:", -- Ghrino Gloves
	[36143]="0:4:2:1:Leather::1:0:", -- Ghrino Cover
	[36144]="0:4:2:1:Leather::1:0:", -- Ghrino Britches
	[36145]="0:4:2:1:Leather::1:0:", -- Ghrino Pauldrons
	[36146]="0:4:2:1:Leather::1:0:", -- Ghrino Bracers
	[36147]="0:4:2:1:Leather::1:0:", -- Pygmy Belt
	[36148]="0:4:2:1:Leather::1:0:", -- Pygmy Boots
	[36149]="0:4:2:1:Leather::1:0:", -- Pygmy Tunic
	[36150]="0:4:2:1:Leather::1:0:", -- Pygmy Gloves
	[36151]="0:4:2:1:Leather::1:0:", -- Pygmy Helmet
	[36152]="0:4:2:1:Leather::1:0:", -- Pygmy Pants
	[36153]="0:4:2:1:Leather::1:0:", -- Pygmy Shoulders
	[36154]="0:4:2:1:Leather::1:0:", -- Pygmy Bindings
	[36155]="0:4:2:1:Leather::1:0:", -- Wendigo Girdle
	[36156]="0:4:2:1:Leather::1:0:", -- Wendigo Boots
	[36157]="0:4:2:1:Leather::1:0:", -- Wendigo Chestpiece
	[36158]="0:4:2:1:Leather::1:0:", -- Wendigo Gloves
	[36159]="0:4:2:1:Leather::1:0:", -- Wendigo Hood
	[36160]="0:4:2:1:Leather::1:0:", -- Wendigo Legguards
	[36161]="0:4:2:1:Leather::1:0:", -- Wendigo Pauldrons
	[36162]="0:4:2:1:Leather::1:0:", -- Wendigo Bands
	[36163]="0:4:2:1:Leather::1:0:", -- Webspinner Cord
	[36164]="0:4:2:1:Leather::1:0:", -- Webspinner Boots
	[36165]="0:4:2:1:Leather::1:0:", -- Webspinner Vest
	[36166]="0:4:2:1:Leather::1:0:", -- Webspinner Gloves
	[36167]="0:4:2:1:Leather::1:0:", -- Webspinner Hood
	[36168]="0:4:2:1:Leather::1:0:", -- Webspinner Leggings
	[36169]="0:4:2:1:Leather::1:0:", -- Webspinner Shoulderguards
	[36170]="0:4:2:1:Leather::1:0:", -- Webspinner Bindings
	[36171]="0:4:2:1:Leather::1:0:", -- Geist Belt
	[36172]="0:4:2:1:Leather::1:0:", -- Geist Boots
	[36173]="0:4:2:1:Leather::1:0:", -- Geist Tunic
	[36174]="0:4:2:1:Leather::1:0:", -- Geist Gloves
	[36175]="0:4:2:1:Leather::1:0:", -- Geist Hood
	[36176]="0:4:2:1:Leather::1:0:", -- Geist Legguards
	[36177]="0:4:2:1:Leather::1:0:", -- Geist Shoulders
	[36178]="0:4:2:1:Leather::1:0:", -- Geist Wristguards
	[36179]="0:4:2:1:Mail::1:0:", -- Garmaul Waistband
	[36180]="0:4:2:1:Mail::1:0:", -- Garmaul Footwraps
	[36181]="0:4:2:1:Mail::1:0:", -- Garmaul Chestpiece
	[36182]="0:4:2:1:Mail::1:0:", -- Garmaul Fists
	[36183]="0:4:2:1:Mail::1:0:", -- Garmaul Helmet
	[36184]="0:4:2:1:Mail::1:0:", -- Garmaul Legguards
	[36185]="0:4:2:1:Mail::1:0:", -- Garmaul Shoulderguards
	[36186]="0:4:2:1:Mail::1:0:", -- Garmaul Bracers
	[36187]="0:4:2:1:Mail::1:0:", -- Njord Belt
	[36188]="0:4:2:1:Mail::1:0:", -- Njord Boots
	[36189]="0:4:2:1:Mail::1:0:", -- Njord Chain Vest
	[36190]="0:4:2:1:Mail::1:0:", -- Njord Gauntlets
	[36191]="0:4:2:1:Mail::1:0:", -- Njord Helm
	[36192]="0:4:2:1:Mail::1:0:", -- Njord Leggings
	[36193]="0:4:2:1:Mail::1:0:", -- Njord Shoulderguards
	[36194]="0:4:2:1:Mail::1:0:", -- Njord Bracers
	[36195]="0:4:2:1:Mail::1:0:", -- Skom Stitched-Belt
	[36196]="0:4:2:1:Mail::1:0:", -- Skom Greaves
	[36197]="0:4:2:1:Mail::1:0:", -- Skom Chain Vest
	[36198]="0:4:2:1:Mail::1:0:", -- Skom Gloves
	[36199]="0:4:2:1:Mail::1:0:", -- Skom Helm
	[36200]="0:4:2:1:Mail::1:0:", -- Skom Leggings
	[36201]="0:4:2:1:Mail::1:0:", -- Skom Spaulders
	[36202]="0:4:2:1:Mail::1:0:", -- Skom Bracers
	[36203]="0:4:2:1:Mail::1:0:", -- Nifflevar Girdle
	[36204]="0:4:2:1:Mail::1:0:", -- Nifflevar Boots
	[36205]="0:4:2:1:Mail::1:0:", -- Nifflevar Chestpiece
	[36206]="0:4:2:1:Mail::1:0:", -- Nifflevar Gloves
	[36207]="0:4:2:1:Mail::1:0:", -- Nifflevar Helmet
	[36208]="0:4:2:1:Mail::1:0:", -- Nifflevar Legguards
	[36209]="0:4:2:1:Mail::1:0:", -- Nifflevar Shoulderguards
	[36210]="0:4:2:1:Mail::1:0:", -- Nifflevar Bindings
	[36211]="0:4:2:1:Mail::1:0:", -- Orca Belt
	[36212]="0:4:2:1:Mail::1:0:", -- Orca Footwraps
	[36213]="0:4:2:1:Mail::1:0:", -- Orca Armor
	[36214]="0:4:2:1:Mail::1:0:", -- Orca Fists
	[36215]="0:4:2:1:Mail::1:0:", -- Orca Helmet
	[36216]="0:4:2:1:Mail::1:0:", -- Orca Legwraps
	[36217]="0:4:2:1:Mail::1:0:", -- Orca Spaulders
	[36218]="0:4:2:1:Mail::1:0:", -- Orca Bindings
	[36219]="0:4:2:1:Mail::1:0:", -- Amberpine Girdle
	[36220]="0:4:2:1:Mail::1:0:", -- Amberpine Greaves
	[36221]="0:4:2:1:Mail::1:0:", -- Amberpine Chain Vest
	[36222]="0:4:2:1:Mail::1:0:", -- Amberpine Gauntlets
	[36223]="0:4:2:1:Mail::1:0:", -- Amberpine Helmet
	[36224]="0:4:2:1:Mail::1:0:", -- Amberpine Legguards
	[36225]="0:4:2:1:Mail::1:0:", -- Amberpine Spaulders
	[36226]="0:4:2:1:Mail::1:0:", -- Amberpine Bracers
	[36227]="0:4:2:1:Mail::1:0:", -- Trapper Belt
	[36228]="0:4:2:1:Mail::1:0:", -- Trapper Footwraps
	[36229]="0:4:2:1:Mail::1:0:", -- Trapper Chain Vest
	[36230]="0:4:2:1:Mail::1:0:", -- Trapper Gloves
	[36231]="0:4:2:1:Mail::1:0:", -- Trapper Helm
	[36232]="0:4:2:1:Mail::1:0:", -- Trapper Leggings
	[36233]="0:4:2:1:Mail::1:0:", -- Trapper Shoulderguards
	[36234]="0:4:2:1:Mail::1:0:", -- Trapper Bracers
	[36235]="0:4:2:1:Mail::1:0:", -- Shoveltusk Waistband
	[36236]="0:4:2:1:Mail::1:0:", -- Shoveltusk Greaves
	[36237]="0:4:2:1:Mail::1:0:", -- Shoveltusk Breastplate
	[36238]="0:4:2:1:Mail::1:0:", -- Shoveltusk Gauntlets
	[36239]="0:4:2:1:Mail::1:0:", -- Shoveltusk Helmet
	[36240]="0:4:2:1:Mail::1:0:", -- Shoveltusk Legguards
	[36241]="0:4:2:1:Mail::1:0:", -- Shoveltusk Mantle
	[36242]="0:4:2:1:Mail::1:0:", -- Shoveltusk Bindings
	[36243]="0:4:2:1:Mail::1:0:", -- Mammoth Girdle
	[36244]="0:4:2:1:Mail::1:0:", -- Mammoth Boots
	[36245]="0:4:2:1:Mail::1:0:", -- Mammoth Chestpiece
	[36246]="0:4:2:1:Mail::1:0:", -- Mammoth Fists
	[36247]="0:4:2:1:Mail::1:0:", -- Mammoth Helm
	[36248]="0:4:2:1:Mail::1:0:", -- Mammoth Legwraps
	[36249]="0:4:2:1:Mail::1:0:", -- Mammoth Spaulders
	[36250]="0:4:2:1:Mail::1:0:", -- Mammoth Bindings
	[36251]="0:4:2:1:Mail::1:0:", -- Wolvar Belt
	[36252]="0:4:2:1:Mail::1:0:", -- Wolvar Greaves
	[36253]="0:4:2:1:Mail::1:0:", -- Wolvar Armor
	[36254]="0:4:2:1:Mail::1:0:", -- Wolvar Fists
	[36255]="0:4:2:1:Mail::1:0:", -- Wolvar Helmet
	[36256]="0:4:2:1:Mail::1:0:", -- Wolvar Legguards
	[36257]="0:4:2:1:Mail::1:0:", -- Wolvar Shoulderguards
	[36258]="0:4:2:1:Mail::1:0:", -- Wolvar Bindings
	[36259]="0:4:2:1:Mail::1:0:", -- Cormorant Waistband
	[36260]="0:4:2:1:Mail::1:0:", -- Cormorant Footwraps
	[36261]="0:4:2:1:Mail::1:0:", -- Cormorant Chain Vest
	[36262]="0:4:2:1:Mail::1:0:", -- Cormorant Gloves
	[36263]="0:4:2:1:Mail::1:0:", -- Cormorant Helm
	[36264]="0:4:2:1:Mail::1:0:", -- Cormorant Leggings
	[36265]="0:4:2:1:Mail::1:0:", -- Cormorant Mantle
	[36266]="0:4:2:1:Mail::1:0:", -- Cormorant Bracelets
	[36267]="0:4:2:1:Mail::1:0:", -- Ulduar Girdle
	[36268]="0:4:2:1:Mail::1:0:", -- Ulduar Greaves
	[36269]="0:4:2:1:Mail::1:0:", -- Ulduar Breastplate
	[36270]="0:4:2:1:Mail::1:0:", -- Ulduar Gauntlets
	[36271]="0:4:2:1:Mail::1:0:", -- Ulduar Helm
	[36272]="0:4:2:1:Mail::1:0:", -- Ulduar Legguards
	[36273]="0:4:2:1:Mail::1:0:", -- Ulduar Shoulderguards
	[36274]="0:4:2:1:Mail::1:0:", -- Ulduar Bracers
	[36275]="0:4:2:1:Mail::1:0:", -- Spiderlord Belt
	[36276]="0:4:2:1:Mail::1:0:", -- Spiderlord Boots
	[36277]="0:4:2:1:Mail::1:0:", -- Spiderlord Chestpiece
	[36278]="0:4:2:1:Mail::1:0:", -- Spiderlord Gauntlets
	[36279]="0:4:2:1:Mail::1:0:", -- Spiderlord Helm
	[36280]="0:4:2:1:Mail::1:0:", -- Spiderlord Legguards
	[36281]="0:4:2:1:Mail::1:0:", -- Spiderlord Spaulders
	[36282]="0:4:2:1:Mail::1:0:", -- Spiderlord Bracers
	[36283]="0:4:2:1:Mail::1:0:", -- Spectral Waistband
	[36284]="0:4:2:1:Mail::1:0:", -- Spectral Greaves
	[36285]="0:4:2:1:Mail::1:0:", -- Spectral Armor
	[36286]="0:4:2:1:Mail::1:0:", -- Spectral Gauntlets
	[36287]="0:4:2:1:Mail::1:0:", -- Spectral Helmet
	[36288]="0:4:2:1:Mail::1:0:", -- Spectral Legwraps
	[36289]="0:4:2:1:Mail::1:0:", -- Spectral Mantle
	[36290]="0:4:2:1:Mail::1:0:", -- Spectral Bracelets
	[36291]="0:4:2:1:Plate::1:0:", -- Westguard Belt
	[36292]="0:4:2:1:Plate::1:0:", -- Westguard Greaves
	[36293]="0:4:2:1:Plate::1:0:", -- Westguard Armor
	[36294]="0:4:2:1:Plate::1:0:", -- Westguard Gloves
	[36295]="0:4:2:1:Plate::1:0:", -- Westguard Helm
	[36296]="0:4:2:1:Plate::1:0:", -- Westguard Legplates
	[36297]="0:4:2:1:Plate::1:0:", -- Westguard Epaulets
	[36298]="0:4:2:1:Plate::1:0:", -- Westguard Bracers
	[36299]="0:4:2:1:Plate::1:0:", -- Coldrock Girdle
	[36300]="0:4:2:1:Plate::1:0:", -- Coldrock Sabatons
	[36301]="0:4:2:1:Plate::1:0:", -- Coldrock Breastplate
	[36302]="0:4:2:1:Plate::1:0:", -- Coldrock Gauntlets
	[36303]="0:4:2:1:Plate::1:0:", -- Coldrock Helmet
	[36304]="0:4:2:1:Plate::1:0:", -- Coldrock Legplates
	[36305]="0:4:2:1:Plate::1:0:", -- Coldrock Pauldrons
	[36306]="0:4:2:1:Plate::1:0:", -- Coldrock Bracers
	[36307]="0:4:2:1:Plate::1:0:", -- Baleheim Belt
	[36308]="0:4:2:1:Plate::1:0:", -- Baleheim Greaves
	[36309]="0:4:2:1:Plate::1:0:", -- Baleheim Armor
	[36310]="0:4:2:1:Plate::1:0:", -- Baleheim Gloves
	[36311]="0:4:2:1:Plate::1:0:", -- Baleheim Helmet
	[36312]="0:4:2:1:Plate::1:0:", -- Baleheim Legguards
	[36313]="0:4:2:1:Plate::1:0:", -- Baleheim Epaulets
	[36314]="0:4:2:1:Plate::1:0:", -- Baleheim Vambraces
	[36315]="0:4:2:1:Plate::1:0:", -- Wyrmskull Girdle
	[36316]="0:4:2:1:Plate::1:0:", -- Wyrmskull Sabatons
	[36317]="0:4:2:1:Plate::1:0:", -- Wyrmskull Breastplate
	[36318]="0:4:2:1:Plate::1:0:", -- Wyrmskull Gauntlets
	[36319]="0:4:2:1:Plate::1:0:", -- Wyrmskull Helm
	[36320]="0:4:2:1:Plate::1:0:", -- Wyrmskull Legplates
	[36321]="0:4:2:1:Plate::1:0:", -- Wyrmskull Epaulets
	[36322]="0:4:2:1:Plate::1:0:", -- Wyrmskull Bracers
	[36323]="0:4:2:1:Plate::1:0:", -- Halgrind Belt
	[36324]="0:4:2:1:Plate::1:0:", -- Halgrind Greaves
	[36325]="0:4:2:1:Plate::1:0:", -- Halgrind Carapace
	[36326]="0:4:2:1:Plate::1:0:", -- Halgrind Gloves
	[36327]="0:4:2:1:Plate::1:0:", -- Halgrind Helmet
	[36328]="0:4:2:1:Plate::1:0:", -- Halgrind Legplates
	[36329]="0:4:2:1:Plate::1:0:", -- Halgrind Epaulets
	[36330]="0:4:2:1:Plate::1:0:", -- Halgrind Bracers
	[36331]="0:4:2:1:Plate::1:0:", -- Grizzlemaw Belt
	[36332]="0:4:2:1:Plate::1:0:", -- Grizzlemaw Sabatons
	[36333]="0:4:2:1:Plate::1:0:", -- Grizzlemaw Armor
	[36334]="0:4:2:1:Plate::1:0:", -- Grizzlemaw Gauntlets
	[36335]="0:4:2:1:Plate::1:0:", -- Grizzlemaw Helm
	[36336]="0:4:2:1:Plate::1:0:", -- Grizzlemaw Legplates
	[36337]="0:4:2:1:Plate::1:0:", -- Grizzlemaw Epaulets
	[36338]="0:4:2:1:Plate::1:0:", -- Grizzlemaw Vambraces
	[36339]="0:4:2:1:Plate::1:0:", -- Bloodmar Girdle
	[36340]="0:4:2:1:Plate::1:0:", -- Bloodmar Sabatons
	[36341]="0:4:2:1:Plate::1:0:", -- Bloodmar Breastplate
	[36342]="0:4:2:1:Plate::1:0:", -- Bloodmar Gauntlets
	[36343]="0:4:2:1:Plate::1:0:", -- Bloodmar Helm
	[36344]="0:4:2:1:Plate::1:0:", -- Bloodmar Legplates
	[36345]="0:4:2:1:Plate::1:0:", -- Bloodmar Pauldrons
	[36346]="0:4:2:1:Plate::1:0:", -- Bloodmar Vambraces
	[36347]="0:4:2:1:Plate::1:0:", -- Jormungar Girdle
	[36348]="0:4:2:1:Plate::1:0:", -- Jormungar Sabatons
	[36349]="0:4:2:1:Plate::1:0:", -- Jormungar Breastplate
	[36350]="0:4:2:1:Plate::1:0:", -- Jormungar Gauntlets
	[36351]="0:4:2:1:Plate::1:0:", -- Jormungar Helmet
	[36352]="0:4:2:1:Plate::1:0:", -- Jormungar Legplates
	[36353]="0:4:2:1:Plate::1:0:", -- Jormungar Pauldrons
	[36354]="0:4:2:1:Plate::1:0:", -- Jormungar Bracers
	[36355]="0:4:2:1:Plate::1:0:", -- Frostpaw Belt
	[36356]="0:4:2:1:Plate::1:0:", -- Frostpaw Greaves
	[36357]="0:4:2:1:Plate::1:0:", -- Frostpaw Armor
	[36358]="0:4:2:1:Plate::1:0:", -- Frostpaw Gauntlets
	[36359]="0:4:2:1:Plate::1:0:", -- Frostpaw Helmet
	[36360]="0:4:2:1:Plate::1:0:", -- Frostpaw Legguards
	[36361]="0:4:2:1:Plate::1:0:", -- Frostpaw Epaulets
	[36362]="0:4:2:1:Plate::1:0:", -- Frostpaw Vambraces
	[36363]="0:4:2:1:Plate::1:0:", -- Magnataur Girdle
	[36364]="0:4:2:1:Plate::1:0:", -- Magnataur Sabatons
	[36365]="0:4:2:1:Plate::1:0:", -- Magnataur Breastplate
	[36366]="0:4:2:1:Plate::1:0:", -- Magnataur Gauntlets
	[36367]="0:4:2:1:Plate::1:0:", -- Magnataur Helm
	[36368]="0:4:2:1:Plate::1:0:", -- Magnataur Legplates
	[36369]="0:4:2:1:Plate::1:0:", -- Magnataur Pauldrons
	[36370]="0:4:2:1:Plate::1:0:", -- Magnataur Bracers
	[36371]="0:4:2:1:Plate::1:0:", -- Kraken Girdle
	[36372]="0:4:2:1:Plate::1:0:", -- Kraken Greaves
	[36373]="0:4:2:1:Plate::1:0:", -- Kraken Breastplate
	[36374]="0:4:2:1:Plate::1:0:", -- Kraken Gauntlets
	[36375]="0:4:2:1:Plate::1:0:", -- Kraken Helm
	[36376]="0:4:2:1:Plate::1:0:", -- Kraken Legplates
	[36377]="0:4:2:1:Plate::1:0:", -- Kraken Epaulets
	[36378]="0:4:2:1:Plate::1:0:", -- Kraken Vambraces
	[36379]="0:4:2:1:Plate::1:0:", -- Golem Girdle
	[36380]="0:4:2:1:Plate::1:0:", -- Golem Sabatons
	[36381]="0:4:2:1:Plate::1:0:", -- Golem Breastplate
	[36382]="0:4:2:1:Plate::1:0:", -- Golem Gauntlets
	[36383]="0:4:2:1:Plate::1:0:", -- Golem Helmet
	[36384]="0:4:2:1:Plate::1:0:", -- Golem Legplates
	[36385]="0:4:2:1:Plate::1:0:", -- Golem Pauldrons
	[36386]="0:4:2:1:Plate::1:0:", -- Golem Vambraces
	[36387]="0:4:2:1:Plate::1:0:", -- Revenant Belt
	[36388]="0:4:2:1:Plate::1:0:", -- Revenant Greaves
	[36389]="0:4:2:1:Plate::1:0:", -- Revenant Armor
	[36390]="0:4:2:1:Plate::1:0:", -- Revenant Gauntlets
	[36391]="0:4:2:1:Plate::1:0:", -- Revenant Helmet
	[36392]="0:4:2:1:Plate::1:0:", -- Revenant Legguards
	[36393]="0:4:2:1:Plate::1:0:", -- Revenant Epaulets
	[36394]="0:4:2:1:Plate::1:0:", -- Revenant Bracers
	[36395]="0:4:2:1:Plate::1:0:", -- Necropolis Girdle
	[36396]="0:4:2:1:Plate::1:0:", -- Necropolis Sabatons
	[36397]="0:4:2:1:Plate::1:0:", -- Necropolis Breastplate
	[36398]="0:4:2:1:Plate::1:0:", -- Necropolis Gloves
	[36399]="0:4:2:1:Plate::1:0:", -- Necropolis Helm
	[36400]="0:4:2:1:Plate::1:0:", -- Necropolis Legplates
	[36401]="0:4:2:1:Plate::1:0:", -- Necropolis Epaulets
	[36402]="0:4:2:1:Plate::1:0:", -- Necropolis Vambraces
	[36403]="0:4:2:1:Cloak::1:0:", -- Riding Cloak
	[36404]="0:4:2:1:Cloak::1:0:", -- Suede Cloak
	[36405]="0:4:2:1:Cloak::1:0:", -- Double Cape
	[36406]="0:4:2:1:Cloak::1:0:", -- Wayfarer's Cloak
	[36407]="0:4:2:1:Cloak::1:0:", -- Lace-Trimmed Cloak
	[36408]="0:4:2:1:Cloak::1:0:", -- Reversible Wool Cape
	[36409]="0:4:2:1:Cloak::1:0:", -- Crushed Velvet Cloak
	[36410]="0:4:2:1:Cloak::1:0:", -- Caribou Skin Cloak
	[36411]="0:4:2:1:Cloak::1:0:", -- Brawler's Cape
	[36412]="0:4:2:1:Cloak::1:0:", -- Fleece Cloak
	[36413]="0:4:2:1:Cloak::1:0:", -- Dyed Taffeta Cape
	[36414]="0:4:2:1:Cloak::1:0:", -- Mammoth Fur Cloak
	[36415]="0:4:2:1:Cloak::1:0:", -- Vintage Satin Cloak
	[36416]="0:4:2:1:Cloak::1:0:", -- Regal Cloak
	[36417]="0:4:2:1:Ring::1:0:", -- Oval Ring
	[36418]="0:4:2:1:Ring::1:0:", -- Floral Loop
	[36419]="0:4:2:1:Ring::1:0:", -- Glass Ring
	[36420]="0:4:2:1:Ring::1:0:", -- Gemstone Ring
	[36421]="0:4:2:1:Ring::1:0:", -- Devotional Band
	[36422]="0:4:2:1:Ring::1:0:", -- Filigree Ring
	[36423]="0:4:2:1:Ring::1:0:", -- Posy Ring
	[36424]="0:4:2:1:Ring::1:0:", -- Cameo Ring
	[36425]="0:4:2:1:Ring::1:0:", -- Gold Twisted Ring
	[36426]="0:4:2:1:Ring::1:0:", -- Stirrup Ring
	[36427]="0:4:2:1:Ring::1:0:", -- Engraved Ring
	[36428]="0:4:2:1:Ring::1:0:", -- Bouquet Ring
	[36429]="0:4:2:1:Ring::1:0:", -- Spur Ring
	[36430]="0:4:2:1:Ring::1:0:", -- Puzzle Ring
	[36431]="0:4:2:1:Amulet::1:0:", -- Painted Wooden Beads
	[36432]="0:4:2:1:Amulet::1:0:", -- Silver Rope Chain
	[36433]="0:4:2:1:Amulet::1:0:", -- Snake Entwined Necklace
	[36434]="0:4:2:1:Amulet::1:0:", -- Gold Mesh Collar
	[36435]="0:4:2:1:Amulet::1:0:", -- Embroidered Pendant
	[36436]="0:4:2:1:Amulet::1:0:", -- Jasper Bead Necklace
	[36437]="0:4:2:1:Amulet::1:0:", -- Figaro Chain
	[36438]="0:4:2:1:Amulet::1:0:", -- Shark-Toothed Necklace
	[36439]="0:4:2:1:Amulet::1:0:", -- Serpentine Chain
	[36440]="0:4:2:1:Amulet::1:0:", -- Gold Clasped Chain
	[36441]="0:4:2:1:Amulet::1:0:", -- Pearl Woven Choker
	[36442]="0:4:2:1:Amulet::1:0:", -- Silken Cord Amulet
	[36443]="0:4:2:1:Amulet::1:0:", -- Platinum Medallion
	[36444]="0:4:2:1:Amulet::1:0:", -- Ice Encrusted Amulet
	[36445]="0:4:2:1:Shield::1:0:", -- Riveted Shield
	[36446]="0:4:2:1:Shield::1:0:", -- Forged-Iron Shield
	[36447]="0:4:2:1:Shield::1:0:", -- Kaskala Buckler
	[36448]="0:4:2:1:Shield::1:0:", -- Spiked Targe
	[36449]="0:4:2:1:Shield::1:0:", -- Vrykul Shield
	[36450]="0:4:2:1:Shield::1:0:", -- Strapped Heater Shield
	[36451]="0:4:2:1:Shield::1:0:", -- Kamagua Shield
	[36452]="0:4:2:1:Shield::1:0:", -- Spoke Shield
	[36453]="0:4:2:1:Shield::1:0:", -- Embossed Brazen Shield
	[36455]="0:4:2:1:Shield::1:0:", -- Plated Bulwark
	[36456]="0:4:2:1:Shield::1:0:", -- Icy Kite Shield
	[36457]="0:4:2:1:Shield::1:0:", -- Ivory Shield
	[36458]="0:4:2:1:Shield::1:0:", -- Frozen Shield
	[36459]="0:4:2:1:OffHandFrill::1:0:", -- Icy Orb
	[36460]="0:4:2:1:OffHandFrill::1:0:", -- Northern Star
	[36461]="0:4:2:1:OffHandFrill::1:0:", -- Demon-Skull Orb
	[36462]="0:4:2:1:OffHandFrill::1:0:", -- Coldarra Crystal
	[36463]="0:4:2:1:OffHandFrill::1:0:", -- Polished Orb
	[36464]="0:4:2:1:OffHandFrill::1:0:", -- Darkened Scepter
	[36465]="0:4:2:1:OffHandFrill::1:0:", -- Evergreen Branch
	[36466]="0:4:2:1:OffHandFrill::1:0:", -- Facetted Orb
	[36467]="0:4:2:1:OffHandFrill::1:0:", -- Reflecting Sphere
	[36468]="0:4:2:1:OffHandFrill::1:0:", -- Glistening Star
	[36469]="0:4:2:1:OffHandFrill::1:0:", -- Lidless Orb
	[36470]="0:4:2:1:OffHandFrill::1:0:", -- Gilded Scepter
	[36471]="0:4:2:1:OffHandFrill::1:0:", -- Ice Crystal
	[36472]="0:4:2:1:OffHandFrill::1:0:", -- Carved Rod
	[36473]="0:2:2:1:Dagger::1:0:", -- Pioneer's Dagger
	[36474]="0:2:2:1:Dagger::1:0:", -- Engraved Dagger
	[36475]="0:2:2:1:Dagger::1:0:", -- Seal Shortblade
	[36476]="0:2:2:1:Dagger::1:0:", -- Whale Ripper
	[36478]="0:2:2:1:Dagger::1:0:", -- Frosty Talon
	[36479]="0:2:2:1:Dagger::1:0:", -- Snobold Ripper
	[36480]="0:2:2:1:Dagger::1:0:", -- Ebony Dagger
	[36481]="0:2:2:1:Dagger::1:0:", -- Trapper Knife
	[36482]="0:2:2:1:Dagger::1:0:", -- Parrying Dagger
	[36483]="0:2:2:1:Dagger::1:0:", -- Mandible Edge
	[36484]="0:2:2:1:Dagger::1:0:", -- Etched Dagger
	[36485]="0:2:2:1:Dagger::1:0:", -- Sinuous Keris
	[36486]="0:2:2:1:Dagger::1:0:", -- Ornate Pugio
	[36487]="0:2:2:1:OneHandMace::1:0:", -- Stone-Headed Gavel
	[36488]="0:2:2:1:OneHandMace::1:0:", -- Conifer Club
	[36489]="0:2:2:1:OneHandMace::1:0:", -- Iron Flanged Scepter
	[36490]="0:2:2:1:OneHandMace::1:0:", -- Tuskarr Cudgel
	[36492]="0:2:2:1:OneHandMace::1:0:", -- Peaked Club
	[36493]="0:2:2:1:OneHandMace::1:0:", -- Furbolg Truncheon
	[36494]="0:2:2:1:OneHandMace::1:0:", -- Barbed Star
	[36495]="0:2:2:1:OneHandMace::1:0:", -- Ferrous Hammer
	[36496]="0:2:2:1:OneHandMace::1:0:", -- Brass-Bound Cudgel
	[36497]="0:2:2:1:OneHandMace::1:0:", -- Adamant Mallet
	[36498]="0:2:2:1:OneHandMace::1:0:", -- Nerubian Mace
	[36499]="0:2:2:1:OneHandMace::1:0:", -- Frigid War-Mace
	[36500]="0:2:2:1:OneHandMace::1:0:", -- Gargoyle's Mace
	[36501]="0:2:2:1:TwoHandMace::1:0:", -- Granite Maul
	[36502]="0:2:2:1:TwoHandMace::1:0:", -- Ungainly Mace
	[36503]="0:2:2:1:TwoHandMace::1:0:", -- Toothless Bludgeon
	[36504]="0:2:2:1:TwoHandMace::1:0:", -- Cleft-Edged Hammer
	[36506]="0:2:2:1:TwoHandMace::1:0:", -- Vaulted Mace
	[36507]="0:2:2:1:TwoHandMace::1:0:", -- Iron-Molded Fist
	[36508]="0:2:2:1:TwoHandMace::1:0:", -- Cumbersome Sledgehammer
	[36509]="0:2:2:1:TwoHandMace::1:0:", -- Femur-Shafted Mace
	[36510]="0:2:2:1:TwoHandMace::1:0:", -- Lumbering Bludgeon
	[36511]="0:2:2:1:TwoHandMace::1:0:", -- Arctic War Hammer
	[36512]="0:2:2:1:TwoHandMace::1:0:", -- Onerous Mallet
	[36513]="0:2:2:1:TwoHandMace::1:0:", -- Lode-Headed Hammer
	[36514]="0:2:2:1:TwoHandMace::1:0:", -- Kingly Battlehammer
	[36515]="0:2:2:1:OneHandSword::1:0:", -- Raider's Cutlass
	[36516]="0:2:2:1:OneHandSword::1:0:", -- Tribal Blade
	[36517]="0:2:2:1:OneHandSword::1:0:", -- Iron-Grip Shortsword
	[36518]="0:2:2:1:OneHandSword::1:0:", -- Tundra's Edge
	[36520]="0:2:2:1:OneHandSword::1:0:", -- Chopping Wideblade
	[36521]="0:2:2:1:OneHandSword::1:0:", -- Shimmering Sabre
	[36522]="0:2:2:1:OneHandSword::1:0:", -- Scored Blade
	[36523]="0:2:2:1:OneHandSword::1:0:", -- Trollish Slicer
	[36524]="0:2:2:1:OneHandSword::1:0:", -- Primitive Scimitar
	[36525]="0:2:2:1:OneHandSword::1:0:", -- Craggy Machete
	[36526]="0:2:2:1:OneHandSword::1:0:", -- Sleeted Longsword
	[36527]="0:2:2:1:OneHandSword::1:0:", -- Blackened Blade
	[36528]="0:2:2:1:OneHandSword::1:0:", -- Skeleton's Sword
	[36529]="0:2:2:1:TwoHandSword::1:0:", -- Unearthed Broadsword
	[36530]="0:2:2:1:TwoHandSword::1:0:", -- Whetted Ironblade
	[36531]="0:2:2:1:TwoHandSword::1:0:", -- Sawtooth Greatsword
	[36532]="0:2:2:1:TwoHandSword::1:0:", -- Shark Fin Blade
	[36534]="0:2:2:1:TwoHandSword::1:0:", -- Tempered-Steel Blade
	[36535]="0:2:2:1:TwoHandSword::1:0:", -- Dragon's Rib Sword
	[36536]="0:2:2:1:TwoHandSword::1:0:", -- Inlaid Greatsword
	[36537]="0:2:2:1:TwoHandSword::1:0:", -- Fur-Grip Broadsword
	[36538]="0:2:2:1:TwoHandSword::1:0:", -- Trollish Destroyer
	[36539]="0:2:2:1:TwoHandSword::1:0:", -- Chilled Warblade
	[36540]="0:2:2:1:TwoHandSword::1:0:", -- Petrified Sword
	[36541]="0:2:2:1:TwoHandSword::1:0:", -- Wintry Claymore
	[36542]="0:2:2:1:TwoHandSword::1:0:", -- Invasion Blade
	[36543]="0:2:2:1:Stave::1:0:", -- Survival Stick
	[36544]="0:2:2:1:Stave::1:0:", -- Journeyed Staff
	[36545]="0:2:2:1:Stave::1:0:", -- Branched Stick
	[36546]="0:2:2:1:Stave::1:0:", -- Unusual Staff
	[36548]="0:2:2:1:Stave::1:0:", -- Promised Staff
	[36549]="0:2:2:1:Stave::1:0:", -- Pulsing Quarterstaff
	[36550]="0:2:2:1:Stave::1:0:", -- Refulgent Staff
	[36551]="0:2:2:1:Stave::1:0:", -- Ritual Greatstaff
	[36552]="0:2:2:1:Stave::1:0:", -- Spiked Greatstaff
	[36553]="0:2:2:1:Stave::1:0:", -- Desecrated Staff
	[36554]="0:2:2:1:Stave::1:0:", -- Cursed Staff
	[36555]="0:2:2:1:Stave::1:0:", -- Minion Staff
	[36556]="0:2:2:1:Stave::1:0:", -- Apocalyptic Staff
	[36557]="0:2:2:1:FistWeapon::1:0:", -- Meat Ripper
	[36558]="0:2:2:1:FistWeapon::1:0:", -- Curved Scratcher
	[36559]="0:2:2:1:FistWeapon::1:0:", -- Prized Handscythes
	[36560]="0:2:2:1:FistWeapon::1:0:", -- Fighter's Grip
	[36562]="0:2:2:1:FistWeapon::1:0:", -- Blue-Nailed Claws
	[36563]="0:2:2:1:FistWeapon::1:0:", -- Gloved Talons
	[36564]="0:2:2:1:FistWeapon::1:0:", -- Spider Claw
	[36565]="0:2:2:1:FistWeapon::1:0:", -- Hero's Knuckles
	[36566]="0:2:2:1:FistWeapon::1:0:", -- Gilded Fangs
	[36567]="0:2:2:1:FistWeapon::1:0:", -- Six-Fingered Claws
	[36568]="0:2:2:1:FistWeapon::1:0:", -- Hollowed Bone Knuckles
	[36569]="0:2:2:1:FistWeapon::1:0:", -- Savage Talons
	[36570]="0:2:2:1:FistWeapon::1:0:", -- Corrupted Scythes
	[36571]="0:2:2:1:OneHandAxe::1:0:", -- Splicing Axe
	[36572]="0:2:2:1:OneHandAxe::1:0:", -- Dinged Cleaver
	[36573]="0:2:2:1:OneHandAxe::1:0:", -- Primeval Adze
	[36574]="0:2:2:1:OneHandAxe::1:0:", -- Bone Cleaver
	[36576]="0:2:2:1:OneHandAxe::1:0:", -- Beaked Axe
	[36577]="0:2:2:1:OneHandAxe::1:0:", -- Disk Axe
	[36578]="0:2:2:1:OneHandAxe::1:0:", -- Troll Chopper
	[36579]="0:2:2:1:OneHandAxe::1:0:", -- Boreal Woodchopper
	[36580]="0:2:2:1:OneHandAxe::1:0:", -- Dire Axe
	[36581]="0:2:2:1:OneHandAxe::1:0:", -- Wolvar Handaxe
	[36582]="0:2:2:1:OneHandAxe::1:0:", -- Ice Pick
	[36583]="0:2:2:1:OneHandAxe::1:0:", -- Skeletal Hacker
	[36584]="0:2:2:1:OneHandAxe::1:0:", -- Snowy Edge
	[36585]="0:2:2:1:TwoHandAxe::1:0:", -- Finned Battleaxe
	[36586]="0:2:2:1:TwoHandAxe::1:0:", -- Wreaking Battleaxe
	[36587]="0:2:2:1:TwoHandAxe::1:0:", -- Taunka Axe
	[36588]="0:2:2:1:TwoHandAxe::1:0:", -- Burning Battleaxe
	[36590]="0:2:2:1:TwoHandAxe::1:0:", -- Bone Plate Axe
	[36591]="0:2:2:1:TwoHandAxe::1:0:", -- Winged Axe
	[36592]="0:2:2:1:TwoHandAxe::1:0:", -- Deforester Axe
	[36593]="0:2:2:1:TwoHandAxe::1:0:", -- Troll Decollator
	[36594]="0:2:2:1:TwoHandAxe::1:0:", -- Fracturing Battleaxe
	[36595]="0:2:2:1:TwoHandAxe::1:0:", -- Planate Broadaxe
	[36596]="0:2:2:1:TwoHandAxe::1:0:", -- Rupturing Axe
	[36597]="0:2:2:1:TwoHandAxe::1:0:", -- Ice-Splintering Axe
	[36598]="0:2:2:1:TwoHandAxe::1:0:", -- Scarlet Battle Axe
	[36599]="0:2:2:1:Polearm::1:0:", -- Ocean Trident
	[36600]="0:2:2:1:Polearm::1:0:", -- Village Scythe
	[36601]="0:2:2:1:Polearm::1:0:", -- Patient Harpoon
	[36602]="0:2:2:1:Polearm::1:0:", -- Rust-Covered Polearm
	[36604]="0:2:2:1:Polearm::1:0:", -- Grizzly Glaive
	[36605]="0:2:2:1:Polearm::1:0:", -- Wind Scythe
	[36606]="0:2:2:1:Polearm::1:0:", -- Rugged Polearm
	[36607]="0:2:2:1:Polearm::1:0:", -- Dwarven Halberd
	[36608]="0:2:2:1:Polearm::1:0:", -- Piercing Glaive
	[36609]="0:2:2:1:Polearm::1:0:", -- Abandoned Spear
	[36610]="0:2:2:1:Polearm::1:0:", -- Plagued Pike
	[36611]="0:2:2:1:Polearm::1:0:", -- Bleak Scythe
	[36612]="0:2:2:1:Polearm::1:0:", -- Scourge War Spear
	[36613]="0:2:2:1:Bow::1:0:", -- Honorable Longbow
	[36614]="0:2:2:1:Bow::1:0:", -- Yew Bow
	[36615]="0:2:2:1:Bow::1:0:", -- Expert's Longbow
	[36616]="0:2:2:1:Bow::1:0:", -- Dutiful Longbow
	[36618]="0:2:2:1:Bow::1:0:", -- Twisted Longbow
	[36619]="0:2:2:1:Bow::1:0:", -- Astral Light Bow
	[36620]="0:2:2:1:Bow::1:0:", -- Tracking Bow
	[36621]="0:2:2:1:Bow::1:0:", -- Advanced Flatbow
	[36622]="0:2:2:1:Bow::1:0:", -- Acute Shortbow
	[36623]="0:2:2:1:Bow::1:0:", -- Harnessed Longbow
	[36624]="0:2:2:1:Bow::1:0:", -- Shrieking Bow
	[36625]="0:2:2:1:Bow::1:0:", -- Massive Recurved Bow
	[36626]="0:2:2:1:Bow::1:0:", -- Military Compound Bow
	[36627]="0:2:2:1:Crossbow::1:0:", -- Composite Crossbow
	[36628]="0:2:2:1:Crossbow::1:0:", -- Under-Arm Crossbow
	[36629]="0:2:2:1:Crossbow::1:0:", -- Ferocious Crossbow
	[36630]="0:2:2:1:Crossbow::1:0:", -- Sinewed Crossbow
	[36632]="0:2:2:1:Crossbow::1:0:", -- Slingshot Crossbow
	[36633]="0:2:2:1:Crossbow::1:0:", -- Palisade Crossbow
	[36634]="0:2:2:1:Crossbow::1:0:", -- Pain Repeater
	[36635]="0:2:2:1:Crossbow::1:0:", -- Marvelous Crossbow
	[36636]="0:2:2:1:Crossbow::1:0:", -- Arbalest Crossbow
	[36637]="0:2:2:1:Crossbow::1:0:", -- Horrific Crossbow
	[36638]="0:2:2:1:Crossbow::1:0:", -- Bloody Crossbow
	[36639]="0:2:2:1:Crossbow::1:0:", -- Brutal Ballista
	[36640]="0:2:2:1:Crossbow::1:0:", -- Scourge Crossbow
	[36641]="0:2:2:1:Gun::1:0:", -- Bound Musket
	[36642]="0:2:2:1:Gun::1:0:", -- Flintlock Gun
	[36643]="0:2:2:1:Gun::1:0:", -- Tracker's Musket
	[36644]="0:2:2:1:Gun::1:0:", -- Inelegant Musket
	[36646]="0:2:2:1:Gun::1:0:", -- Haggard Gun
	[36647]="0:2:2:1:Gun::1:0:", -- Noisy Blaster
	[36648]="0:2:2:1:Gun::1:0:", -- Trapper's Rifle
	[36649]="0:2:2:1:Gun::1:0:", -- Tundra Rifle
	[36650]="0:2:2:1:Gun::1:0:", -- Mammoth Gun
	[36651]="0:2:2:1:Gun::1:0:", -- Muzzled Musket
	[36652]="0:2:2:1:Gun::1:0:", -- Stocky Shotgun
	[36653]="0:2:2:1:Gun::1:0:", -- Precipice Longrifle
	[36654]="0:2:2:1:Gun::1:0:", -- Harsh-Winter Rifle
	[36655]="0:2:2:1:Wand::1:0:", -- Pearled Wand
	[36656]="0:2:2:1:Wand::1:0:", -- Darkened Wand
	[36657]="0:2:2:1:Wand::1:0:", -- Vicious Wand
	[36658]="0:2:2:1:Wand::1:0:", -- Extinguished Spark
	[36660]="0:2:2:1:Wand::1:0:", -- Melted Wand
	[36661]="0:2:2:1:Wand::1:0:", -- Enigmatic Wand
	[36662]="0:2:2:1:Wand::1:0:", -- Voodoo Wand
	[36663]="0:2:2:1:Wand::1:0:", -- Ancient Wand
	[36664]="0:2:2:1:Wand::1:0:", -- Chilled Wand
	[36665]="0:2:2:1:Wand::1:0:", -- Wasteland Wand
	[36666]="0:2:2:1:Wand::1:0:", -- Polar Wand
	[36667]="0:2:2:1:Wand::1:0:", -- Solid Ice Wand
	[36668]="0:2:2:1:Wand::1:0:", -- Mindless Wand
	[36669]="0:2:2:1:Dagger::1:0:", -- Eccentric Dagger
	[36670]="0:2:2:1:Dagger::1:0:", -- Gypsy Blade
	[36671]="0:2:2:1:Dagger::1:0:", -- Ominous Dagger
	[36672]="0:2:2:1:Dagger::1:0:", -- Strange Dagger
	[36674]="0:2:2:1:Dagger::1:0:", -- Old Tooth
	[36675]="0:2:2:1:Dagger::1:0:", -- Sockeye Dagger
	[36676]="0:2:2:1:Dagger::1:0:", -- Water Blade
	[36677]="0:2:2:1:Dagger::1:0:", -- Levitating Dagger
	[36678]="0:2:2:1:Dagger::1:0:", -- Runed Talon
	[36679]="0:2:2:1:Dagger::1:0:", -- Singing Dagger
	[36680]="0:2:2:1:Dagger::1:0:", -- Mystic Fang
	[36681]="0:2:2:1:Dagger::1:0:", -- Wisdom Carver
	[36682]="0:2:2:1:Dagger::1:0:", -- Seduced Blade
	[36683]="0:2:2:1:OneHandMace::1:0:", -- Enshrined Mace
	[36684]="0:2:2:1:OneHandMace::1:0:", -- Ambrosial Hammer
	[36685]="0:2:2:1:OneHandMace::1:0:", -- Placid Lightmace
	[36686]="0:2:2:1:OneHandMace::1:0:", -- Harmonious Scepter
	[36688]="0:2:2:1:OneHandMace::1:0:", -- Sacrosanct Mace
	[36689]="0:2:2:1:OneHandMace::1:0:", -- Refreshing Hammer
	[36690]="0:2:2:1:OneHandMace::1:0:", -- Unearthly Scepter
	[36691]="0:2:2:1:OneHandMace::1:0:", -- Dignified Hammer
	[36692]="0:2:2:1:OneHandMace::1:0:", -- Remedial Mace
	[36693]="0:2:2:1:OneHandMace::1:0:", -- Serene Hammer
	[36694]="0:2:2:1:OneHandMace::1:0:", -- Beatific Mace
	[36695]="0:2:2:1:OneHandMace::1:0:", -- Dogmatic Scepter
	[36696]="0:2:2:1:OneHandMace::1:0:", -- Graced Scepter
	[36697]="0:2:2:1:Stave::1:0:", -- Aquatic Greatstaff
	[36698]="0:2:2:1:Stave::1:0:", -- Conifer Cone Staff
	[36699]="0:2:2:1:Stave::1:0:", -- Iceberg Staff
	[36700]="0:2:2:1:Stave::1:0:", -- Peat Greatstaff
	[36702]="0:2:2:1:Stave::1:0:", -- Melting Icestaff
	[36703]="0:2:2:1:Stave::1:0:", -- Tusked Greatstaff
	[36704]="0:2:2:1:Stave::1:0:", -- Hive Comb Staff
	[36705]="0:2:2:1:Stave::1:0:", -- Geyser Staff
	[36706]="0:2:2:1:Stave::1:0:", -- Tenacious Vine Staff
	[36707]="0:2:2:1:Stave::1:0:", -- Cascading Water Staff
	[36708]="0:2:2:1:Stave::1:0:", -- Snow Blossom Staff
	[36709]="0:2:2:1:Stave::1:0:", -- Crystal Woodstaff
	[36710]="0:2:2:1:Stave::1:0:", -- Avalanche Staff
	[36711]="0:2:2:1:Thrown::1:0:", -- Forsaken Edge
	[36712]="0:2:2:1:Thrown::1:0:", -- Howling Throwing Knives
	[36713]="0:2:2:1:Thrown::1:0:", -- Reaching Star
	[36714]="0:2:2:1:Thrown::1:0:", -- Tuskarr's Piercers
	[36716]="0:2:2:1:Thrown::1:0:", -- Threatening Darts
	[36717]="0:2:2:1:Thrown::1:0:", -- Venture Co. Throwing Axe
	[36718]="0:2:2:1:Thrown::1:0:", -- Nexus Shrike
	[36719]="0:2:2:1:Thrown::1:0:", -- Hunter's Scout
	[36720]="0:2:2:1:Thrown::1:0:", -- Flying Knives
	[36721]="0:2:2:1:Thrown::1:0:", -- Dragon's Teeth
	[36722]="0:2:2:1:Thrown::1:0:", -- Pyramid Throwing Star
	[36723]="0:2:2:1:Thrown::1:0:", -- Clawed Shuriken
	[36724]="0:2:2:1:Thrown::1:0:", -- Frozen Throwing Blades
	[36725]="0:12:1:10:::1:0:", -- Black Blood of Yogg-Saron Sample
	[36726]="0:12:1:1:::1:0:", -- Ironbender's Mining Pick
	[36727]="0:12:1:8:::1:0:", -- Composite Ore
	[36728]="0:12:1:6:::1:0:", -- Ice Shard Cluster
	[36729]="0:12:1:12:::1:0:", -- Thin Animal Hide
	[36730]="0:12:1:12:::1:0:", -- Splintered Bone Chunk
	[36731]="0:12:1:8:::1:0:", -- Seared Jormungar Meat
	[36732]="0:12:1:1:::1:0:", -- Potent Explosive Charges
	[36733]="0:12:1:50:::1:0:", -- Coldwind Lumber
	[36734]="0:12:1:1:::1:0:", -- Xink's Shredder Control Device
	[36735]="0:12:1:1:::1:0:", -- Kilix's Battle Plan
	[36736]="0:12:1:8:::1:0:", -- Scourge Armament
	[36737]="0:2:4:1:OneHandAxe::1:0:20278,23396", -- Brutal Gladiator's Hatchet
	[36738]="0:12:1:1:::1:0:", -- Warsong Battle Standard
	[36739]="0:12:1:1:::1:0:", -- Heart of the Ancients
	[36740]="0:12:1:10:::1:0:", -- Spiritsbreath
	[36741]="0:12:1:1:::1:0:", -- Head of High Cultist Zangus
	[36742]="0:12:1:1:::1:0:", -- Goramosh's Strange Device
	[36743]="0:12:1:10:::1:0:", -- Desperate Mojo
	[36744]="0:12:1:1:::1:0:", -- Flesh-bound Tome
	[36746]="0:12:1:1:::1:0:", -- Goramosh's Strange Device
	[36747]="0:12:1:1:::1:0:", -- Surge Needle Teleporter
	[36748]="0:0:1:1:Consumable::1:0:", -- Dark Brewmaiden's Brew
	[36751]="0:12:1:1:::1:0:", -- Ley Line Focus Control Ring
	[36752]="0:12:1:1:::1:0:", -- Anok'ra's Key Fragment
	[36753]="0:12:1:1:::1:0:", -- Tivax's Key Fragment
	[36754]="0:12:1:1:::1:0:", -- Sinok's Key Fragment
	[36756]="0:12:1:1:::1:0:", -- Captain Malin's Letter
	[36757]="0:12:1:1:::1:0:", -- Drakkari Tablets
	[36758]="0:12:1:10:::1:0:", -- Sacred Mojo
	[36759]="0:12:1:1:::1:0:", -- Fragment of Anub'et'kan's Husk
	[36760]="0:13:1:1:::1:0:", -- Anub'ar Prison Key
	[36764]="0:12:1:1:::1:0:", -- Shard of the Earth
	[36765]="0:12:1:1:::1:0:", -- Sample of Rockflesh
	[36766]="0:3:4:1:GemRed::1:0:", -- Bright Dragon's Eye
	[36767]="0:3:4:1:GemBlue::1:0:", -- Solid Dragon's Eye
	[36768]="0:12:1:6:::1:0:", -- Vial of Corrosive Spit
	[36769]="0:12:1:1:::1:0:", -- Zort's Protective Elixir
	[36770]="0:0:1:20:Potion::1:0:", -- Zort's Protective Elixir
	[36771]="0:0:1:1:Other::1:0:", -- Sturdy Crates
	[36772]="0:12:1:3:::1:0:", -- Captured Jormungar Spawn
	[36774]="0:12:1:1:::1:0:", -- Valnok's Flare Gun
	[36775]="0:12:1:1:::1:0:", -- Zort's Scraper
	[36776]="0:12:1:10:::1:0:", -- Island Shoveltusk Meat
	[36777]="0:12:1:1:::1:0:", -- Horn of Kamagua
	[36779]="0:12:1:1:::1:0:", -- Ley Line Focus Control Amulet
	[36780]="0:12:1:1:::1:0:", -- Lieutenant Ta'zinni's Letter
	[36781]="0:7:1:20:Other::1:0:", -- Darkwater Clam
	[36782]="0:7:1:20:Meat:185:1:0:", -- Succulent Clam Meat
	[36783]="0:3:2:20:GemSimple:755,197:1:0:25206", -- Northsea Pearl
	[36784]="0:3:3:20:GemSimple:755,197:1:1:25206", -- Siren's Tear
	[36786]="0:12:1:5:::1:0:", -- Bark of the Walkers
	[36787]="0:12:1:1:::1:0:", -- Shard of Gavrock
	[36788]="0:15:0:20:Junk::1:0:", -- Matted Fur
	[36789]="0:15:0:20:Junk::1:0:", -- Cracked Horn
	[36793]="0:12:1:1:::1:0:", -- Sarathstra's Frozen Heart
	[36796]="0:12:1:1:::1:0:", -- Gavrock's Runebreaker
	[36797]="0:15:0:5:Junk::1:0:", -- Massive Scaly Tail
	[36798]="0:15:0:5:Junk::1:0:", -- Scraped Shell Fragment
	[36800]="0:12:1:1:::1:0:", -- Rot Resistant Organ
	[36801]="0:15:0:20:Junk::1:0:", -- Crooked Fang
	[36802]="0:15:0:20:Junk::1:0:", -- Scything Talon
	[36803]="0:12:1:1:::1:0:", -- Ruby Lilac
	[36804]="0:15:0:20:Junk::1:0:", -- Chipped Ivory Tusk
	[36805]="0:15:0:20:Junk::1:0:", -- Misshapen Foot
	[36806]="0:15:0:20:Junk::1:0:", -- Perfectly Rounded Foot
	[36807]="0:12:1:1:::1:0:", -- Sintar's Vaccine
	[36808]="0:15:0:20:Junk::1:0:", -- Bent Ivory Tusk
	[36809]="0:15:0:20:Junk::1:0:", -- Elemental Husk
	[36810]="0:15:0:20:Junk::1:0:", -- Primordial Infusion
	[36811]="0:15:0:20:Junk::1:0:", -- Stripped Sprocket
	[36812]="0:15:0:20:Junk::1:0:", -- Ground Gear
	[36813]="0:15:0:20:Junk::1:0:", -- Sprung Sprocket
	[36814]="0:15:0:20:Junk::1:0:", -- Overgyrated Gear
	[36815]="0:12:1:1:::1:0:", -- Ley Line Focus Control Talisman
	[36816]="0:15:0:10:Junk::1:0:", -- Prismatic Stone Chip
	[36817]="0:15:0:5:Junk::1:0:", -- Banded Stone
	[36818]="0:12:1:1:::1:0:", -- Pack of Vaccine
	[36819]="0:12:1:10:::1:0:", -- Fibrous Worg Meat
	[36820]="0:12:1:1:::1:0:", -- Flesh-bound Tome
	[36821]="0:15:0:10:Junk::1:0:", -- Glimmering Stone Chip
	[36822]="0:15:0:5:Junk::1:0:", -- Translucent Polished Stone
	[36823]="0:15:0:20:Junk::1:0:", -- Silky Plumage
	[36824]="0:15:0:20:Junk::1:0:", -- Articulated Talon
	[36825]="0:12:1:10:::1:0:", -- Drakkari Canopic Jar
	[36826]="0:12:1:10:::1:0:", -- Drakil'jin Mallet
	[36827]="0:12:1:1:::1:0:", -- Blood Gem
	[36828]="0:12:1:1:::1:0:", -- Filled Blood Gem
	[36829]="0:15:0:10:Junk::1:0:", -- Supremely Slimy Ichor
	[36830]="0:15:0:5:Junk::1:0:", -- Gratuitously Gelatinous Goo
	[36832]="0:12:1:1:::1:0:", -- Letter of Introduction to Wyrmrest Temple
	[36833]="0:12:1:1:::1:0:", -- Letter of Introduction to Wyrmrest Temple
	[36834]="0:12:1:1:::1:0:", -- Charged Drakil'jin Mallet
	[36835]="0:12:1:1:::1:0:", -- Unholy Gem
	[36836]="0:12:1:1:::1:0:", -- Filled Unholy Gem
	[36846]="0:12:1:1:::1:0:", -- Filled Frost Gem
	[36847]="0:12:1:1:::1:0:", -- Frost Gem
	[36848]="0:12:1:1:::1:0:", -- War Golem Blueprint
	[36849]="0:12:1:1:::1:0:", -- Golem Blueprint Section 1
	[36850]="0:12:1:1:::1:0:", -- Golem Blueprint Section 2
	[36851]="0:12:1:1:::1:0:", -- Golem Blueprint Section 3
	[36852]="0:12:1:10:::1:0:", -- War Golem Part
	[36853]="0:12:1:1:::1:0:", -- Grom'thar's Head
	[36854]="0:12:1:1:::1:0:", -- Emblazoned Battle Horn
	[36855]="0:12:1:1:::1:0:", -- Emblazoned Battle Horn
	[36856]="0:12:1:1:::1:0:", -- Emblazoned Battle Horn
	[36857]="0:12:1:1:::1:0:", -- Durar's Power Cell
	[36858]="0:12:1:1:::1:0:", -- Kathorn's Power Cell
	[36859]="0:12:1:1:::1:0:", -- Snow of Eternal Slumber
	[36860]="0:7:2:20:Elemental:171,164,333,202,755,165,186,197:1:0:", -- Eternal Fire
	[36861]="0:12:1:1:::1:0:", -- Translated Flesh-bound Tome
	[36862]="0:0:1:1:Consumable::1:0:", -- Worn Troll Dice
	[36863]="0:0:1:1:Consumable::1:0:", -- Decahedral Dwarven Dice
	[36864]="0:12:1:1:::1:0:", -- Emblazoned Battle Horn
	[36865]="0:12:1:1:::1:0:", -- Golem Control Unit
	[36868]="0:12:1:10:::1:0:", -- Drakkari Spirit Particles
	[36870]="0:12:1:10:::1:0:", -- Sacred Drakkari Offering
	[36871]="0:4:3:1:Trinket::1:0:", -- Fury of the Encroaching Storm
	[36872]="0:4:3:1:Trinket::1:0:", -- Mender of the Oncoming Dawn
	[36873]="0:12:1:10:::1:0:", -- Drakkari Spirit Dust
	[36874]="0:4:3:1:Trinket::1:0:", -- Horn of the Herald
	[36875]="0:12:1:10:::1:0:", -- Shovelhorn Steak
	[36876]="0:12:1:1:::1:0:", -- Scorched Holy Symbol
	[36877]="0:0:1:1:Consumable::1:0:", -- Folded Letter
	[36878]="0:2:2:1:Stave::1:0:", -- Writhing Longstaff
	[36879]="0:2:2:1:OneHandMace::1:0:", -- Soldier's Spiked Mace
	[36880]="0:2:2:1:Dagger::1:0:", -- Vicious Spellblade
	[36881]="0:2:2:1:OneHandMace::1:0:", -- Medic's Morning Star
	[36882]="0:2:2:1:Bow::1:0:", -- Warsong Longbow
	[36883]="0:2:2:1:TwoHandSword::1:0:", -- Combatant Greatsword
	[36884]="0:4:2:1:Cloth::1:0:", -- Transborean Cover
	[36885]="0:4:2:1:Leather::1:0:", -- Marshwalker Chestpiece
	[36886]="0:4:2:1:Mail::1:0:", -- Westrift Leggings
	[36887]="0:4:2:1:Plate::1:0:", -- Mightstone Pauldrons
	[36888]="0:4:2:1:Leather::1:0:", -- Marshwalker Legguards
	[36889]="0:0:1:1:Other::1:0:", -- Demonic Healthstone
	[36890]="0:0:1:1:Other::1:0:", -- Demonic Healthstone
	[36891]="0:0:1:1:Other::1:0:", -- Demonic Healthstone
	[36892]="0:0:1:1:Other::1:0:", -- Fel Healthstone
	[36893]="0:0:1:1:Other::1:0:", -- Fel Healthstone
	[36894]="0:0:1:1:Other::1:0:", -- Fel Healthstone
	[36895]="0:0:1:1:Consumable::1:0:", -- Demonic Soulstone
	[36896]="0:4:1:1:Miscellaneous::1:0:", -- Demonic Spellstone
	[36897]="0:4:1:1:Miscellaneous::1:0:", -- Fel Spellstone
	[36899]="0:0:1:1:EnhTemp::1:0:", -- Exceptional Mana Oil
	[36900]="0:0:1:1:EnhTemp::1:0:", -- Exceptional Wizard Oil
	[36901]="3000:7:1:20:Herb:171:1:1:14846", -- Goldclover
	[36902]="0:7:0:20:Herb::1:0:", -- Constrictor Grass
	[36903]="5000:7:1:20:Herb:171:1:1:14846", -- Adder's Tongue
	[36904]="3000:7:1:20:Herb:171:1:1:14846", -- Tiger Lily
	[36905]="8000:7:1:20:Herb:171:1:1:14846", -- Lichbloom
	[36906]="8000:7:1:20:Herb:171:1:1:14846", -- Icethorn
	[36907]="3000:7:1:20:Herb:171:1:1:14846", -- Talandra's Rose
	[36908]="40000:7:2:20:Herb:171,197:1:1:14846", -- Frost Lotus
	[36909]="0:7:1:20:MetalStone:186:1:0:", -- Cobalt Ore
	[36910]="0:7:2:20:MetalStone:186:1:0:", -- Titanium Ore
	[36912]="0:7:1:20:MetalStone:186:1:0:", -- Saronite Ore
	[36913]="0:7:1:20:MetalStone:171,164,202:1:0:", -- Saronite Bar
	[36914]="0:7:1:20:MetalStone::1:0:", -- Azurite Bar
	[36915]="0:7:2:20:MetalStone::1:0:", -- Froststeel Bar
	[36916]="0:7:1:20:MetalStone:164,202:1:0:", -- Cobalt Bar
	[36917]="0:3:2:20:GemRed:171,755:1:0:", -- Bloodstone
	[36918]="0:3:3:20:GemRed:171,333,202,755:1:0:", -- Scarlet Ruby
	[36919]="0:3:4:20:GemRed:755,197:1:0:31580,31582,32172,34039,34040,34043,34079,34080,34081", -- Cardinal Ruby
	[36920]="0:3:2:20:GemYellow:202,755:1:0:", -- Sun Crystal
	[36921]="0:3:3:20:GemYellow:171,202,755:1:0:", -- Autumn's Glow
	[36922]="0:3:4:20:GemYellow:202,755,197:1:0:31580,31582,32172,34039,34040,34043,34079,34080,34081", -- King's Amber
	[36923]="0:3:2:20:GemBlue:171,755:1:0:", -- Chalcedony
	[36924]="0:3:3:20:GemBlue:171,202,755:1:0:", -- Sky Sapphire
	[36925]="0:3:4:20:GemBlue:164,755,197:1:0:31580,31582,32172,34039,34040,34043,34079,34080,34081", -- Majestic Zircon
	[36926]="0:3:2:20:GemPurple:755:1:0:", -- Shadow Crystal
	[36927]="0:3:3:20:GemPurple:171,202,755:1:0:", -- Twilight Opal
	[36928]="0:3:4:20:GemPurple:755:1:0:31580,31582,32172,34039,34040,34043,34079,34080,34081", -- Dreadstone
	[36929]="0:3:2:20:GemOrange:171,755:1:0:", -- Huge Citrine
	[36930]="0:3:3:20:GemOrange:171,202,755,197:1:0:", -- Monarch Topaz
	[36931]="0:3:4:20:GemOrange:755:1:0:31580,31582,32172,34039,34040,34043,34079,34080,34081", -- Ametrine
	[36932]="0:3:2:20:GemGreen:171,755:1:0:", -- Dark Jade
	[36933]="0:3:3:20:GemGreen:171,202,755:1:0:", -- Forest Emerald
	[36934]="0:3:4:20:GemGreen:755,197:1:0:31580,31582,32172,34039,34040,34043,34079,34080,34081", -- Eye of Zul
	[36935]="0:12:1:1:::1:0:", -- Raegar's Explosives
	[36936]="0:12:1:1:::1:0:", -- Golem Control Unit
	[36937]="0:4:2:1:Mail::1:0:", -- Tundrastrider Coif
	[36938]="0:4:2:1:Plate::1:0:", -- Mightstone Breastplate
	[36939]="0:4:2:1:Cloth::1:0:", -- Nymph Stockings
	[36940]="0:12:1:1:::1:0:", -- Mikhail's Journal
	[36941]="0:4:3:1:Tabard::1:0:", -- Competitor's Tabard
	[36943]="0:4:3:1:Amulet::1:0:", -- Timeless Beads of Eternos
	[36944]="0:2:3:1:Dagger::1:0:", -- Lifeblade of Belgaristrasz
	[36945]="0:4:3:1:Cloth::1:0:", -- Verdisa's Cuffs of Dreaming
	[36946]="0:4:3:1:Mail::1:0:", -- Runic Cage Chestpiece
	[36947]="0:4:3:1:Cloak::1:0:", -- Centrifuge Core Cloak
	[36948]="0:4:3:1:Leather::1:0:", -- Horned Helm of Varos
	[36949]="0:4:3:1:Cloth::1:0:", -- Gloves of the Azure-Lord
	[36950]="0:4:3:1:Plate::1:0:", -- Wing Commander's Breastplate
	[36951]="0:4:3:1:Leather::1:0:", -- Sidestepping Handguards
	[36952]="0:4:3:1:Plate::1:0:", -- Girdle of Obscuring
	[36953]="0:4:3:1:Mail::1:0:", -- Spaulders of Skillful Maneuvers
	[36954]="0:4:3:1:Cloth::1:0:", -- The Conjurer's Slippers
	[36955]="100000:9:1:1:Book::1:0:5815,6382", -- Grimoire of Firebolt (Rank 9)
	[36956]="0:12:1:1:::1:0:", -- Liquid Fire of Elune
	[36957]="0:12:1:20:::1:0:", -- Functional Cultist Suit
	[36958]="0:12:1:1:::1:0:", -- The Favor of Zangus
	[36959]="100000:9:1:1:Book::1:0:5815,6382", -- Grimoire of Blood Pact (Rank 7)
	[36960]="100000:9:1:1:Book::1:0:5815,6382", -- Grimoire of Fire Shield (Rank 7)
	[36961]="0:4:3:1:Ring::1:0:", -- Dragonflight Great-Ring
	[36962]="0:2:3:1:TwoHandAxe::1:0:", -- Wyrmclaw Battleaxe
	[36964]="100000:9:1:1:Book::1:0:5815,6382", -- Grimoire of Sacrifice (Rank 8)
	[36965]="100000:9:1:1:Book::1:0:5815,6382", -- Grimoire of Sacrifice (Rank 9)
	[36966]="100000:9:1:1:Book::1:0:5815,6382", -- Grimoire of Consume Shadows (Rank 8)
	[36967]="100000:9:1:1:Book::1:0:5815,6382", -- Grimoire of Consume Shadows (Rank 9)
	[36968]="100000:9:1:1:Book::1:0:5815,6382", -- Grimoire of Suffering (Rank 7)
	[36969]="0:4:3:1:Plate::1:0:", -- Helm of the Ley-Guardian
	[36970]="100000:9:1:1:Book::1:0:5815,6382", -- Grimoire of Suffering (Rank 8)
	[36971]="0:4:3:1:Mail::1:0:", -- Headguard of Westrift
	[36972]="0:4:3:1:Trinket::1:0:", -- Tome of Arcane Phenomena
	[36973]="0:4:3:1:Cloth::1:0:", -- Vestments of the Scholar
	[36974]="0:4:3:1:Plate::1:0:", -- Eregos' Ornamented Chestguard
	[36975]="0:2:3:1:Stave::1:0:", -- Malygos' Favor
	[36976]="0:4:3:1:Cloth::1:0:", -- Ring-Lord's Leggings
	[36977]="0:4:3:1:Plate::1:0:", -- Bindings of the Construct
	[36978]="0:4:3:1:Leather::1:0:", -- Ley-Whelphide Belt
	[36979]="0:4:3:1:Ring::1:0:", -- Bjarngrim Family Signet
	[36980]="0:2:3:1:Stave::1:0:", -- Hewn Sparring Quarterstaff
	[36981]="0:2:3:1:Thrown::1:0:", -- Hardened Vrykul Throwing Axe
	[36982]="0:4:3:1:Cloth::1:0:", -- Mantle of Electrical Charges
	[36983]="0:4:3:1:Cloak::1:0:", -- Cape of Seething Steam
	[36984]="0:2:3:1:OneHandSword::1:0:", -- Eternally Folded Blade
	[36985]="0:4:3:1:Cloth::1:0:", -- Volkhan's Hood
	[36986]="0:4:3:1:Mail::1:0:", -- Kilt of Molten Golems
	[36988]="0:4:3:1:Amulet::1:0:", -- Chaotic Spiral Amulet
	[36989]="0:2:3:1:Wand::1:0:", -- Ancient Measuring Rod
	[36991]="0:4:3:1:Cloth::1:0:", -- Raiments of the Titans
	[36992]="0:4:3:1:Mail::1:0:", -- Leather-Braced Chain Leggings
	[36993]="0:4:3:1:Trinket::1:0:", -- Seal of the Pantheon
	[36994]="0:2:3:1:Gun::1:0:", -- Projectile Activator
	[36995]="0:4:3:1:Plate::1:0:", -- Fists of Loken
	[36996]="0:4:3:1:Leather::1:0:", -- Hood of the Furtive Assassin
	[36997]="0:4:3:1:Cloth::1:0:", -- Sash of the Hardened Watcher
	[36998]="0:4:2:1:Cloak::1:0:", -- Assailant Shroud
	[36999]="0:4:3:1:Mail::1:0:", -- Boots of the Terrestrial Guardian
	[37000]="0:4:3:1:Leather::1:0:", -- Storming Vortex Bracers
	[37002]="0:4:2:1:Mail::1:0:", -- Binder's Links
	[37003]="0:12:1:1:::1:0:", -- Alliance Missive
	[37004]="0:4:2:1:Plate::1:0:", -- Plainwatcher Legplates
	[37005]="0:4:2:1:Cloth::1:0:", -- D.E.H.T.A. Overshirt
	[37006]="0:12:1:1:::1:0:", -- Ley Line Attunement Crystal
	[37007]="0:4:2:1:Leather::1:0:", -- Faux Leather Hood
	[37008]="0:4:2:1:Mail::1:0:", -- Ethical Epaulettes
	[37009]="0:4:2:1:Plate::1:0:", -- Moral Sabatons
	[37010]="0:12:1:20:::1:0:", -- Gray Worg Hide
	[37011]="0:15:3:1:Mount::1:0:", -- Magic Broom
	[37012]="0:15:4:1:Mount::1:0:", -- The Horseman's Reins
	[37013]="0:13:1:10:::1:0:", -- Dun Argol Cage Key
	[37014]="0:2:2:1:OneHandMace::1:0:", -- Rod of Poacher Punishment
	[37015]="0:2:2:1:Wand::1:0:", -- Dowsing Rod
	[37016]="0:2:2:1:Wand::1:0:", -- Wand of the Keeper
	[37017]="0:2:2:1:Dagger::1:0:", -- Nimble Blade
	[37018]="0:2:2:1:Gun::1:0:", -- G.E.H.T.A.
	[37019]="0:4:2:1:Shield::1:0:", -- Borean Ward
	[37020]="0:12:1:20:::1:0:", -- Grizzly Hide
	[37021]="0:2:2:1:FistWeapon::1:0:", -- Claw of the Tuskarr
	[37022]="0:2:2:1:Dagger::1:0:", -- Shark Stabber
	[37023]="0:2:2:1:Crossbow::1:0:", -- Compact Arrow Launcher
	[37024]="0:4:2:1:OffHandFrill::1:0:", -- Medicine Stick
	[37025]="0:2:2:1:TwoHandAxe::1:0:", -- Blubber Carver
	[37026]="0:2:2:1:Stave::1:0:", -- Spirit Channeller's Rod
	[37027]="0:12:1:1:::1:0:", -- Blight Specimen
	[37028]="0:2:2:1:Thrown::1:0:", -- Condor-Bone Star
	[37029]="0:2:2:1:Dagger::1:0:", -- Fin Carver
	[37030]="0:2:2:1:TwoHandMace::1:0:", -- Blubber Grinder
	[37031]="0:2:2:1:Stave::1:0:", -- Zook's Walking Stick
	[37032]="0:2:2:1:OneHandAxe::1:0:", -- Edge of the Tuskarr
	[37033]="0:4:2:1:OffHandFrill::1:0:", -- Manual of the Tides
	[37034]="0:2:2:1:OneHandSword::1:0:", -- Lobstrock Slicer
	[37035]="0:12:1:1:::1:0:", -- Overseer's Uniform
	[37036]="0:2:2:1:Dagger::1:0:", -- Fish-Eye Poker
	[37037]="0:2:3:1:Dagger::1:0:", -- Ritualistic Athame
	[37038]="0:2:3:1:Wand::1:0:", -- Brazier Igniter
	[37039]="0:2:2:1:OneHandSword::1:0:", -- Mrgl Blade
	[37040]="0:4:3:1:Plate::1:0:", -- Svala's Bloodied Shackles
	[37041]="0:2:2:1:OneHandMace::1:0:", -- Scepter of the Winterfin
	[37042]="0:2:2:1:Dagger::1:0:", -- Glimmering Orca Tooth
	[37043]="0:4:3:1:Mail::1:0:", -- Tear-Linked Gauntlets
	[37044]="0:2:2:1:Crossbow::1:0:", -- Amphibious Speargun
	[37045]="0:12:1:1:::1:0:", -- Kilian's Camera
	[37046]="0:2:2:1:TwoHandMace::1:0:", -- Shell Smasher
	[37047]="0:2:2:1:Wand::1:0:", -- Branch of Everlasting Flame
	[37048]="0:4:3:1:Cloak::1:0:", -- Shroud of Resurrection
	[37049]="0:2:2:1:Gun::1:0:", -- Lost Marksman's Rifle
	[37050]="0:2:3:1:Bow::1:0:", -- Trophy Gatherer
	[37051]="0:4:3:1:OffHandFrill::1:0:", -- Seal of Valgarde
	[37052]="0:4:3:1:Plate::1:0:", -- Reanimated Armor
	[37053]="0:4:3:1:Amulet::1:0:", -- Amulet of Deflected Blows
	[37054]="0:2:2:1:TwoHandAxe::1:0:", -- Frostbiter
	[37055]="0:4:3:1:Cloth::1:0:", -- Silken Amice of the Ymirjar
	[37056]="0:4:3:1:Plate::1:0:", -- Harpooner's Striders
	[37057]="0:4:3:1:Leather::1:0:", -- Drake Rider's Tunic
	[37058]="0:4:3:1:Ring::1:0:", -- Signet of Ranulf
	[37060]="0:2:3:1:OneHandSword::1:0:", -- Jeweled Coronation Sword
	[37061]="0:4:3:1:Shield::1:0:", -- Tor's Crest
	[37062]="0:4:3:1:Plate::1:0:", -- Crown of Forgotten Kings
	[37063]="0:12:1:10:::1:0:", -- Infused Drakkari Offering
	[37064]="0:4:3:1:Trinket::1:0:", -- Vestige of Haldor
	[37065]="0:2:3:1:OneHandSword::1:0:", -- Ymiron's Blade
	[37066]="0:4:3:1:Plate::1:0:", -- Ancient Royal Legguards
	[37067]="0:4:3:1:Leather::1:0:", -- Ceremonial Pyre Mantle
	[37068]="0:4:3:1:Plate::1:0:", -- Berserker's Sabatons
	[37069]="0:4:3:1:Mail::1:0:", -- Dragonflayer Seer's Bindings
	[37070]="0:4:3:1:Leather::1:0:", -- Tundra Wolf Boots
	[37071]="0:12:1:1:::1:0:", -- Overseer Disguise Kit
	[37072]="0:2:2:1:FistWeapon::1:0:", -- Jagged Icefist
	[37073]="0:2:2:1:Stave::1:0:", -- Hungering Greatstaff
	[37074]="0:4:2:1:OffHandFrill::1:0:", -- Greatmother's Talisman of Cleansing
	[37075]="0:2:2:1:Dagger::1:0:", -- Serrated Scale Shank
	[37076]="0:2:2:1:OneHandSword::1:0:", -- Fiery Prod
	[37077]="0:2:2:1:FistWeapon::1:0:", -- Smoldering Talon
	[37078]="0:2:2:1:Wand::1:0:", -- Rod of the Crimson Keeper
	[37079]="0:4:3:1:Ring::1:0:", -- Enchanted Wire Stitching
	[37080]="0:2:2:1:TwoHandSword::1:0:", -- Crimson Will
	[37081]="0:2:3:1:OneHandSword::1:0:", -- Meathook's Slicer
	[37082]="0:4:3:1:Plate::1:0:", -- Slaughterhouse Sabatons
	[37083]="0:4:3:1:Leather::1:0:", -- Kilt of Sewn Flesh
	[37084]="0:4:3:1:Cloak::1:0:", -- Flowing Cloak of Command
	[37085]="0:12:1:10:::1:0:", -- Haze Leaf
	[37086]="0:4:3:1:OffHandFrill::1:0:", -- Tome of Salramm
	[37087]="0:12:1:10:::1:0:", -- Sweetroot
	[37088]="0:4:3:1:Plate::1:0:", -- Spiked Metal Cilice
	[37089]="0:12:1:10:::1:0:", -- Honeycone
	[37090]="0:12:1:10:::1:0:", -- Quickpoppy
	[37091]="1080:0:1:20:Scroll::1:1:14847", -- Scroll of Intellect VII
	[37092]="0:0:1:20:Scroll::1:0:", -- Scroll of Intellect VIII
	[37093]="1080:0:1:20:Scroll::1:1:14847", -- Scroll of Stamina VII
	[37094]="0:0:1:20:Scroll::1:0:", -- Scroll of Stamina VIII
	[37095]="0:4:3:1:Mail::1:0:", -- Waistband of the Thuzadin
	[37096]="0:4:3:1:Amulet::1:0:", -- Necklace of the Chrono-Lord
	[37097]="990:0:1:20:Scroll::1:1:14847", -- Scroll of Spirit VII
	[37098]="0:0:1:20:Scroll::1:0:", -- Scroll of Spirit VIII
	[37099]="0:2:3:1:Stave::1:0:", -- Sempiternal Staff
	[37100]="0:7:1:20:Part::1:0:", -- Silver Ink
	[37101]="0:7:1:20:Part:773:1:0:33027", -- Ivory Ink
	[37104]="0:12:1:10:::1:0:", -- Mature Stag Horn
	[37105]="0:4:3:1:Mail::1:0:", -- Treads of Altered History
	[37106]="0:4:3:1:Leather::1:0:", -- Ouroboros Belt
	[37107]="0:4:3:1:Shield::1:0:", -- Leeka's Shield
	[37108]="0:2:3:1:TwoHandSword::1:0:", -- Dreadlord's Blade
	[37109]="0:4:3:1:Plate::1:0:", -- Discarded Silver Hand Spaulders
	[37110]="0:4:3:1:Mail::1:0:", -- Gauntlets of Dark Conversion
	[37111]="0:4:3:1:Trinket::1:0:", -- Soul Preserver
	[37112]="0:2:3:1:OneHandMace::1:0:", -- Beguiling Scepter
	[37113]="0:4:3:1:Cloth::1:0:", -- Demonic Fabric Bands
	[37114]="0:4:3:1:Leather::1:0:", -- Gloves of Northern Lordaeron
	[37115]="0:4:3:1:Plate::1:0:", -- Crusader's Square Pauldrons
	[37116]="0:4:3:1:Mail::1:0:", -- Epaulets of Market Row
	[37117]="0:4:3:1:Leather::1:0:", -- King's Square Bracers
	[37118]="0:0:1:20:Scroll::1:0:", -- Scroll of Recall
	[37121]="0:12:1:10:::1:0:", -- Ectoplasmic Residue
	[37122]="0:2:2:1:Bow::1:0:", -- Taut Driftwood Bow
	[37124]="0:12:1:12:::1:0:", -- Emerald Dragon Tear
	[37125]="0:12:1:1:::1:0:", -- Rokar's Camera
	[37127]="0:4:4:1:Trinket::1:0:", -- Brightbrew Charm
	[37128]="0:4:4:1:Trinket::1:0:", -- Balebrew Charm
	[37129]="0:12:1:1:::1:0:", -- Flask of Blight
	[37134]="0:4:3:1:OffHandFrill::1:0:", -- Telestra's Journal
	[37135]="0:4:3:1:Plate::1:0:", -- Arcane-Shielded Helm
	[37136]="0:12:1:20:::1:0:", -- Scarlet Onslaught Armor
	[37137]="0:12:1:20:::1:0:", -- Scarlet Onslaught Weapon
	[37138]="0:4:3:1:Mail::1:0:", -- Bands of Channeled Energy
	[37139]="0:4:3:1:Leather::1:0:", -- Spaulders of the Careless Thief
	[37140]="0:12:1:20:::1:0:", -- Ace of Rogues
	[37141]="0:4:3:1:Amulet::1:0:", -- Amulet of Dazzling Light
	[37143]="0:12:1:20:::1:0:", -- Two of Rogues
	[37144]="0:4:3:1:Mail::1:0:", -- Hauberk of the Arcane Wraith
	[37145]="0:7:1:20:Other::1:0:", -- Ace of Swords
	[37147]="0:7:1:20:Other::1:0:", -- Two of Swords
	[37148]="0:15:1:1:Junk::1:0:", -- Loose Singed Page
	[37149]="0:4:3:1:Leather::1:0:", -- Helm of Anomalus
	[37150]="0:4:3:1:Plate::1:0:", -- Rift Striders
	[37151]="0:4:3:1:Ring::1:0:", -- Band of Frosted Thorns
	[37152]="0:4:3:1:Plate::1:0:", -- Girdle of Ice
	[37153]="0:4:3:1:Cloth::1:0:", -- Gloves of the Crystal Gardener
	[37155]="0:4:3:1:Mail::1:0:", -- Frozen Forest Kilt
	[37156]="0:12:1:20:::1:0:", -- Three of Rogues
	[37157]="0:12:1:20:::1:0:", -- Four of Rogues
	[37158]="0:12:1:20:::1:0:", -- Five of Rogues
	[37159]="0:7:1:20:Other::1:0:", -- Three of Swords
	[37160]="0:7:1:20:Other::1:0:", -- Four of Swords
	[37161]="0:7:1:20:Other::1:0:", -- Five of Swords
	[37162]="0:4:3:1:Shield::1:0:", -- Bulwark of the Noble Protector
	[37163]="0:12:2:1:::1:0:", -- Rogues Deck
	[37164]="0:12:3:1:::1:0:", -- Swords Deck
	[37165]="0:4:3:1:Leather::1:0:", -- Crystal-Infused Tunic
	[37166]="0:4:3:1:Trinket::1:0:", -- Sphere of Red Dragon's Blood
	[37167]="0:4:3:1:Mail::1:0:", -- Dragon Slayer's Sabatons
	[37168]="0:7:1:1:Other::1:0:", -- Mysterious Tarot
	[37169]="0:2:4:1:OneHandMace::1:0:", -- War Mace of Unrequited Love
	[37170]="0:4:4:1:Mail::1:0:", -- Interwoven Scale Bracers
	[37171]="0:4:4:1:Plate::1:0:", -- Flame-Bathed Steel Girdle
	[37172]="0:4:4:1:Cloth::1:0:", -- Gloves of Glistening Runes
	[37173]="0:0:1:1:Consumable::1:0:", -- Geomancer's Orb
	[37177]="0:2:3:1:Wand::1:0:", -- Wand of the San'layn
	[37178]="0:4:3:1:Plate::1:0:", -- Strategist's Belt
	[37179]="0:2:3:1:OneHandSword::1:0:", -- Infantry Assault Blade
	[37180]="0:4:3:1:Leather::1:0:", -- Battlemap Hide Helm
	[37181]="0:2:3:1:Dagger::1:0:", -- Dagger of Betrayal
	[37182]="0:4:3:1:Plate::1:0:", -- Helmet of the Constructor
	[37183]="0:4:3:1:Leather::1:0:", -- Bindings of the Tunneler
	[37184]="0:4:3:1:Mail::1:0:", -- Dalronn's Jerkin
	[37185]="0:12:1:10:::1:0:", -- Succulent Venison
	[37186]="0:4:3:1:Ring::1:0:", -- Unsmashable Heavy Band
	[37187]="0:12:1:1:::1:0:", -- Container of Rats
	[37188]="0:4:3:1:Mail::1:0:", -- Plunderer's Helmet
	[37189]="0:4:3:1:Cloth::1:0:", -- Breeches of the Caller
	[37190]="0:2:3:1:Stave::1:0:", -- Enraged Feral Staff
	[37191]="0:2:4:1:Crossbow::1:0:", -- Drake-Mounted Crossbow
	[37192]="0:4:4:1:Ring::1:0:", -- Annhylde's Ring
	[37193]="0:4:4:1:Plate::1:0:", -- Staggering Legplates
	[37194]="0:4:4:1:Leather::1:0:", -- Sharp-Barbed Leather Belt
	[37195]="0:4:3:1:Ring::1:0:", -- Band of Enchanted Growth
	[37196]="0:4:3:1:Cloth::1:0:", -- Runecaster's Mantle
	[37197]="0:4:3:1:Cloak::1:0:", -- Tattered Castle Drape
	[37198]="0:0:1:1:Consumable::1:0:", -- Prototype Neural Needler
	[37199]="0:12:1:20:::1:0:", -- Slime Sample
	[37200]="0:12:1:10:::1:0:", -- Grizzly Flank
	[37201]="500:15:1:20:Reagent:-6:1:0:958,983,1257,1275,1307,1308,1351,1463,1673,2805,3323,3335,3351,3490,3500,3542,3562,3700,3970,4083,4220,4562,4575,4878,5110,5139,5151,8361,10364,12096,12097,13476,14739,15175,16015,16588,16611,16612,16706,16757,16829,17518,18006,18017,18019,18243,18802,18998,19004,19013,19014,19235,19535,19678,19679,19718,20081,20092,20915,22479,23112,23145,23157,23373,23560,23734,24313,24349,24357,24780,24843,24935,24995,25010,25019,25039,25051,25082,25736,26382,26474,26569,26598,26900,26908,26950,26968,26984,27030,27039,27054,27088,27133,27138,27149,27176,27186,27935,28714,28760,28809,28827,28870,28943,29015,29037,29203,29288,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33630,33633,33669,33674,33676,33871,35642,37904,37935", -- Corpse Dust
	[37202]="0:12:1:1:::1:0:", -- Onslaught Riding Crop
	[37203]="0:4:2:1:Cloth::1:0:", -- Regenerative Cloth
	[37204]="0:4:2:1:Cloth::1:0:", -- Transborean Leggings
	[37205]="0:4:2:1:Cloth::1:0:", -- Transborean Mantle
	[37206]="0:4:2:1:Cloak::1:0:", -- Weathered Worker Cloak
	[37207]="0:4:2:1:Cloth::1:0:", -- Seafarer Boots
	[37208]="0:4:2:1:Cloth::1:0:", -- Transborean Bracers
	[37209]="0:4:2:1:Cloth::1:0:", -- Wharfmaster's Hat
	[37211]="0:4:2:1:Cloth::1:0:", -- Iceflow Footwraps
	[37212]="0:4:2:1:Cloth::1:0:", -- Transborean Wraps
	[37213]="0:4:2:1:Cloth::1:0:", -- Iceflow Wristwraps
	[37214]="0:4:2:1:Cloth::1:0:", -- Sweltering Leggings
	[37215]="0:4:2:1:Cloth::1:0:", -- Lost Sea Oculus
	[37216]="0:4:3:1:Shield::1:0:", -- Facade Shield of Glyphs
	[37217]="0:4:3:1:Plate::1:0:", -- Golden Limb Bands
	[37218]="0:4:3:1:Cloth::1:0:", -- Stone-Worn Footwraps
	[37219]="0:4:3:1:Leather::1:0:", -- Custodian's Chestpiece
	[37220]="0:4:3:1:Trinket::1:0:", -- Essence of Gossamer
	[37221]="0:4:3:1:Mail::1:0:", -- Hollowed Mandible Legplates
	[37222]="0:4:3:1:Cloth::1:0:", -- Egg Sac Robes
	[37223]="0:4:2:1:Cloth::1:0:", -- Sweltering Handwraps
	[37224]="0:4:2:1:Cloth::1:0:", -- Sweltering Belt
	[37226]="0:4:2:1:Cloth::1:0:", -- Sweltering Robes
	[37227]="0:4:2:1:Cloth::1:0:", -- Seafarer Mantle
	[37228]="0:4:2:1:Cloth::1:0:", -- Sweltering Cuffs
	[37229]="0:12:1:10:::1:0:", -- Flame-Imbued Talisman
	[37230]="0:4:3:1:Leather::1:0:", -- Grotto Mist Gloves
	[37231]="0:4:2:1:Amulet::1:0:", -- Frostspeaker Collar
	[37232]="0:4:3:1:Ring::1:0:", -- Ring of the Traitor King
	[37233]="0:12:1:1:::1:0:", -- The Forsaken Blight
	[37234]="0:4:2:1:Cloth::1:0:", -- Layered Frost Hood
	[37235]="0:2:3:1:OneHandSword::1:0:", -- Crypt Lord's Deft Blade
	[37236]="0:4:3:1:Leather::1:0:", -- Insect Vestments
	[37237]="0:4:3:1:Plate::1:0:", -- Chitin Shell Greathelm
	[37238]="0:2:4:1:Wand::1:0:", -- Rod of the Fallen Monarch
	[37239]="0:4:2:1:Cloth::1:0:", -- Layered Frost Sandals
	[37240]="0:4:4:1:Plate::1:0:", -- Flamebeard's Bracers
	[37241]="0:4:4:1:Plate::1:0:", -- Ancient Aligned Girdle
	[37242]="0:4:4:1:Cloth::1:0:", -- Sash of the Servant
	[37243]="0:4:3:1:Leather::1:0:", -- Treasure Seeker's Belt
	[37246]="0:12:1:10:::1:0:", -- Blackroot Stalk
	[37247]="0:12:1:10:::1:0:", -- Anderhol's Slider Cider
	[37248]="0:12:1:20:::1:0:", -- Siegesmith Bomb
	[37250]="0:12:1:10:::1:0:", -- Partially Processed Amberseeds
	[37251]="0:12:1:20:::1:0:", -- Crazed Furbolg Blood
	[37252]="8500:0:1:20:FoodDrink::5:0:26110", -- Frostberries
	[37253]="6000:0:1:20:FoodDrink::5:0:26110", -- Frostberry Juice
	[37254]="0:4:4:1:Trinket::1:0:", -- Super Simian Sphere
	[37255]="0:2:3:1:OneHandSword::1:0:", -- The Interrogator
	[37256]="0:4:3:1:Mail::1:0:", -- Scaled Armor of Drakos
	[37257]="0:4:3:1:Ring::1:0:", -- Band of Torture
	[37258]="0:4:3:1:Cloth::1:0:", -- Drakewing Raiments
	[37259]="0:12:1:1:::1:0:", -- Siegesmith Bombs
	[37260]="0:2:3:1:OneHandAxe::1:0:", -- Cloudstrider's Waraxe
	[37261]="0:4:3:1:Leather::1:0:", -- Gloves of Radiant Light
	[37262]="0:4:3:1:Mail::1:0:", -- Azure Ringmail Leggings
	[37263]="0:4:3:1:Plate::1:0:", -- Legplates of the Oculus Guardian
	[37264]="0:4:3:1:Trinket::1:0:", -- Pendulum of Telluric Currents
	[37265]="0:0:1:1:Consumable::1:0:", -- Tua'kea's Breathing Bladder
	[37267]="0:12:1:1:::1:0:", -- Scarlet Onslaught Daily Orders: Barracks
	[37268]="0:12:1:1:::1:0:", -- Scarlet Onslaught Daily Orders: Abbey
	[37269]="0:12:1:1:::1:0:", -- Scarlet Onslaught Daily Orders: Beach
	[37270]="0:4:2:1:Cloth::1:0:", -- Layered Frost Robes
	[37271]="0:4:2:1:Cloth::1:0:", -- Dusk Watcher's Belt
	[37272]="0:4:2:1:Cloth::1:0:", -- Wizzlenob Shoulder Covers
	[37274]="0:4:2:1:Cloth::1:0:", -- Mender's Cover
	[37275]="0:4:2:1:Cloth::1:0:", -- Mantle of Congealed Anger
	[37276]="0:4:2:1:Cloth::1:0:", -- Gorge's Loungewear
	[37277]="0:4:2:1:Cloak::1:0:", -- Ermine Ruff Cloak
	[37280]="0:4:2:1:Cloth::1:0:", -- Flame Hardened Waistband
	[37282]="0:4:2:1:Cloth::1:0:", -- Cavernous Gauntlets
	[37283]="0:4:2:1:Cloth::1:0:", -- Wandering Healer's Kilt
	[37287]="0:12:1:1:::1:0:", -- Wintergarde Gryphon Whistle
	[37288]="0:4:3:1:Plate::1:0:", -- Catalytic Bands
	[37289]="0:4:3:1:Cloth::1:0:", -- Sash of Phantasmal Images
	[37290]="0:4:3:1:Amulet::1:0:", -- Dragon Prow Amulet
	[37291]="0:4:3:1:Cloak::1:0:", -- Ancient Dragon Spirit Cape
	[37292]="0:4:3:1:Plate::1:0:", -- Ley-Guardian's Legguards
	[37293]="0:4:3:1:Leather::1:0:", -- Mask of the Watcher
	[37294]="0:4:3:1:Cloth::1:0:", -- Crown of Unbridled Magic
	[37297]="0:15:3:1:Companion::1:0:", -- Gold Medallion
	[37298]="0:15:3:1:Companion::1:0:", -- Competitor's Souvenir
	[37299]="0:12:1:1:::1:0:", -- Scarlet Onslaught Daily Orders
	[37300]="0:12:1:1:::1:0:", -- Levine Family Termites
	[37302]="0:12:1:30:::1:0:", -- Vordrassil's Seed
	[37303]="0:12:1:1:::1:0:", -- Vordrassil's Ashes
	[37304]="0:12:1:1:::1:0:", -- Apothecary's Burning Water
	[37305]="0:12:1:1:::1:0:", -- Captain Shely's Rutters
	[37306]="0:12:1:1:::1:0:", -- Verdant Torch
	[37307]="0:12:1:1:::1:0:", -- Purified Ashes of Vordrassil
	[37311]="0:4:3:1:Miscellaneous::1:0:", -- Skybreaker Whip
	[37312]="0:0:2:1:EnhPerm::1:0:", -- Carrot on a Stick
	[37313]="0:4:3:1:Miscellaneous::1:0:", -- Riding Crop
	[37314]="0:12:1:1:::1:0:", -- High Executor's Branding Iron
	[37319]="0:4:2:1:Leather::1:0:", -- Grips of the Windswept Plains
	[37320]="0:4:2:1:Leather::1:0:", -- Spaulders of Echoing Truth
	[37322]="0:4:2:1:Leather::1:0:", -- Flame Hardened Wristbindings
	[37325]="0:4:2:1:Leather::1:0:", -- Warsong Scout Spaulders
	[37330]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Superior Arcane Resistance
	[37331]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Superior Fire Resistance
	[37332]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Superior Frost Resistance
	[37333]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Superior Nature Resistance
	[37334]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Superior Shadow Resistance
	[37335]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Superior Agility
	[37338]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Greater Savagery
	[37339]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Weapon - Giant Slayer
	[37340]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Chest - Exceptional Resilience
	[37344]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Weapon - Icebreaker
	[37347]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Cloak - Titanweave
	[37348]="0:9:1:1:Enchanting::1:0:", -- Formula: Enchant Cloak - Haste
	[37349]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Cloak - Shadow Armor
	[37350]="0:12:1:1:::1:0:", -- Bishop Street's Prayer Book
	[37351]="0:4:2:1:Leather::1:0:", -- Reinforced Caribou-Hide Leggings
	[37352]="0:4:2:1:Leather::1:0:", -- Regenerative Hide Harness
	[37353]="0:4:2:1:Leather::1:0:", -- Reinforced Caribou-Hide Helm
	[37354]="0:4:2:1:Leather::1:0:", -- Reinforced Caribou-Hide Boots
	[37355]="0:4:2:1:Leather::1:0:", -- Reinforced Caribou-Hide Chestguard
	[37356]="0:4:2:1:Leather::1:0:", -- Rhinohide Wristwraps
	[37357]="0:4:2:1:Cloak::1:0:", -- Shivering Healer's Cloak
	[37358]="0:12:1:1:::1:0:", -- Quarterflash's Mining Pick
	[37359]="0:12:1:10:::1:0:", -- Strange Ore
	[37360]="0:2:4:1:Stave::1:0:", -- Staff of Draconic Combat
	[37361]="0:4:4:1:Cloth::1:0:", -- Cuffs of Winged Levitation
	[37362]="0:4:4:1:Plate::1:0:", -- Leggings of Protective Auras
	[37363]="0:4:4:1:Plate::1:0:", -- Gauntlets of Dragon Wrath
	[37364]="0:4:3:1:OffHandFrill::1:0:", -- Frostbridge Orb
	[37365]="0:4:3:1:Mail::1:0:", -- Bands of the Sky Ring
	[37366]="0:4:3:1:Leather::1:0:", -- Drake-Champion's Bracers
	[37367]="0:4:3:1:Plate::1:0:", -- Echoing Stompers
	[37368]="0:4:3:1:Leather::1:0:", -- Silent Spectator Shoulderpads
	[37369]="0:4:3:1:Cloth::1:0:", -- Sorrowgrave's Breeches
	[37370]="0:4:3:1:Cloth::1:0:", -- Cuffs of the Trussed Hall
	[37371]="0:4:3:1:Ring::1:0:", -- Ring of the Frenzied Wolvar
	[37372]="0:15:1:20:Other::1:0:", -- Harpoon
	[37373]="0:4:3:1:Mail::1:0:", -- Massive Spaulders of the Jormungar
	[37374]="0:4:3:1:Leather::1:0:", -- Ravenous Leggings of the Furbolg
	[37375]="0:4:2:1:Leather::1:0:", -- Rhinohide Gloves
	[37376]="0:4:3:1:Plate::1:0:", -- Ferocious Pauldrons of the Rhino
	[37377]="0:2:3:1:Dagger::1:0:", -- Netherbreath Spellblade
	[37378]="0:4:2:1:Leather::1:0:", -- Sealskin Bindings
	[37379]="0:4:3:1:Plate::1:0:", -- Skadi's Iron Belt
	[37380]="0:4:2:1:Leather::1:0:", -- Whalehunter Leggings
	[37381]="0:12:1:1:::1:0:", -- Banshee's Magic Mirror
	[37382]="0:4:2:1:Leather::1:0:", -- Charred Drakehide Belt
	[37383]="0:4:2:1:Cloak::1:0:", -- Seared Scale Cape
	[37384]="0:2:3:1:Stave::1:0:", -- Staff of Wayward Principles
	[37387]="0:4:2:1:Leather::1:0:", -- Charred Treads
	[37388]="0:4:2:1:Leather::1:0:", -- Reinforced Elastic Band
	[37389]="0:4:3:1:Leather::1:0:", -- Crenelation Leggings
	[37390]="0:4:3:1:Trinket::1:0:", -- Meteorite Whetstone
	[37391]="0:4:2:1:Leather::1:0:", -- Rhinohide Mask
	[37392]="0:4:2:1:Leather::1:0:", -- Soggy Hide Pauldrons
	[37393]="0:4:2:1:Leather::1:0:", -- Shadewrap Gloves
	[37394]="0:4:2:1:Leather::1:0:", -- Marshwalker Waistguard
	[37395]="0:4:3:1:Plate::1:0:", -- Ornamented Plate Regalia
	[37396]="0:4:2:1:Leather::1:0:", -- Whalehunter Gloves
	[37397]="0:4:3:1:Amulet::1:0:", -- Gold Amulet of Kings
	[37398]="0:4:3:1:Mail::1:0:", -- Mantle of Discarded Ways
	[37399]="0:4:2:1:Leather::1:0:", -- Floodplain Shoulderpads
	[37401]="0:2:4:1:OneHandSword::1:0:", -- Red Sword of Courage
	[37402]="0:4:2:1:Leather::1:0:", -- Floodplain Vest
	[37403]="0:4:2:1:Leather::1:0:", -- Marshwalker Boots
	[37404]="0:4:2:1:Leather::1:0:", -- Floodplain Cover
	[37405]="0:4:2:1:Leather::1:0:", -- Marshwalker Pauldrons
	[37406]="0:4:2:1:Leather::1:0:", -- Denwatcher's Leggings
	[37407]="0:4:4:1:Mail::1:0:", -- Sovereign's Belt
	[37408]="0:4:4:1:Cloth::1:0:", -- Girdle of Bane
	[37409]="0:4:4:1:Leather::1:0:", -- Gilt-Edged Leather Gauntlets
	[37410]="0:2:3:1:Thrown::1:0:", -- Tracker's Balanced Knives
	[37411]="0:12:1:10:::1:0:", -- Wintergarde Miner's Card
	[37412]="0:12:1:10:::1:0:", -- Grooved Cog
	[37413]="0:12:1:10:::1:0:", -- Notched Sprocket
	[37414]="0:4:2:1:Mail::1:0:", -- Farseer's Headpiece
	[37415]="0:4:2:1:Mail::1:0:", -- Tundrastrider Ringmail
	[37416]="0:12:1:10:::1:0:", -- High Tension Spring
	[37417]="0:4:2:1:Mail::1:0:", -- Westrift Handcovers
	[37418]="0:4:2:1:Mail::1:0:", -- Seaspeaker Legguards
	[37419]="0:4:2:1:Mail::1:0:", -- Seaspeaker Mantle
	[37421]="0:4:2:1:Mail::1:0:", -- Waverunner Waistband
	[37422]="0:4:2:1:Mail::1:0:", -- Westrift Wristguards
	[37423]="0:4:2:1:Mail::1:0:", -- Sharkproof Coif
	[37424]="0:4:2:1:Mail::1:0:", -- Plainhunter's Epaulettes
	[37425]="0:4:2:1:Mail::1:0:", -- Tundrastrider Boots
	[37426]="0:4:2:1:Mail::1:0:", -- Rusty Mesh Leggings
	[37427]="0:4:2:1:Mail::1:0:", -- Plainhunter's Waistband
	[37428]="0:4:2:1:Mail::1:0:", -- Ring-Ridden Wrist Protectors
	[37429]="0:4:2:1:Mail::1:0:", -- Glimmering Ringmail Gloves
	[37431]="5000:0:2:10:Consumable::5:0:28951", -- Fetch Ball
	[37432]="0:12:1:1:::1:0:", -- Torturer's Rod
	[37434]="0:4:2:1:Mail::1:0:", -- Cauterizing Chain Strand
	[37435]="0:4:2:1:Mail::1:0:", -- Flame Infused Bindings
	[37436]="0:4:2:1:Mail::1:0:", -- Seaspeaker Gloves
	[37437]="0:4:2:1:Mail::1:0:", -- Plainhunter's Chestpiece
	[37438]="0:12:1:1:::1:0:", -- Rod of Compulsion
	[37439]="0:4:2:1:Mail::1:0:", -- Spiked Magmoth Gloves
	[37440]="0:4:2:1:Mail::1:0:", -- Spiked Magmoth Chestpiece
	[37441]="0:4:2:1:Mail::1:0:", -- Spiked Magmoth Mantle
	[37442]="0:4:2:1:Mail::1:0:", -- Chilled Mail Boots
	[37443]="0:4:2:1:Mail::1:0:", -- Spiked Magmoth Helm
	[37445]="0:12:1:1:::1:0:", -- Destructive Wards
	[37446]="0:4:2:1:Mail::1:0:", -- Tank Commander's Treads
	[37447]="0:4:2:1:Mail::1:0:", -- Reinforced Mendicant's Cowl
	[37449]="0:0:1:20:Elixir::1:0:25206", -- Breath of Murloc
	[37452]="0:0:1:20:FoodDrink::1:0:", -- Fatty Bluefin
	[37456]="0:4:2:1:Mail::1:0:", -- Cauterizing Chain Leggings
	[37458]="0:4:2:1:Mail::1:0:", -- Wristguards of Rocky Horror
	[37459]="0:12:1:1:::1:0:", -- Quarterflash's Homing Bot
	[37460]="7500:15:1:1:Companion::1:0:28951", -- Rope Pet Leash
	[37461]="0:2:3:1:Polearm::1:0:25206", -- Tidebreaker Trident
	[37462]="0:4:2:1:Cloth::1:0:25206", -- Sea King's Crown
	[37463]="0:4:2:1:Leather::1:0:25206", -- Winterfin Patch of Honor
	[37464]="0:15:1:20:CombatPet::1:0:25206", -- Winterfin Horn of Distress
	[37465]="0:12:1:1:::1:0:", -- Wintergarde Mine Bomb
	[37467]="0:15:0:5:Junk::1:0:", -- A Steamy Romance Novel: Forbidden Love
	[37471]="0:4:2:1:Plate::1:0:", -- Girdle of Ripped Space
	[37475]="0:4:2:1:Plate::1:0:", -- Benign Crusader's Plate
	[37476]="0:4:2:1:Plate::1:0:", -- Gorge's Breastplate of Bloodrage
	[37478]="0:4:2:1:Plate::1:0:", -- Amberplate Grips
	[37479]="0:4:2:1:Plate::1:0:", -- Amberplate Legguards
	[37480]="0:4:2:1:Plate::1:0:", -- Mightstone Helm
	[37481]="0:4:2:1:Plate::1:0:", -- Chestguard of Salved Wounds
	[37482]="0:4:2:1:Plate::1:0:", -- Mightstone Legplates
	[37483]="0:4:2:1:Plate::1:0:", -- Seabone Heaume
	[37484]="0:4:2:1:Plate::1:0:", -- Mendicant's Treads
	[37486]="0:4:2:1:Plate::1:0:", -- Landlocked Wristguards
	[37487]="0:4:2:1:Plate::1:0:", -- Seabone Legplates
	[37488]="0:0:1:24:Consumable::1:0:", -- Wild Winter Pilsner
	[37489]="0:0:1:24:Consumable::1:0:", -- Izzard's Ever Flavor
	[37490]="0:0:1:24:Consumable::1:0:", -- Aromatic Honey Brew
	[37491]="150:0:1:24:Consumable::6:0:27812", -- Metok's Bubble Bock
	[37492]="150:0:1:24:Consumable::6:0:27813", -- Springtime Stout
	[37493]="150:0:1:24:Consumable::6:0:27814", -- Blackrock Lager
	[37494]="0:0:1:24:Consumable::1:0:", -- Stranglethorn Brew
	[37495]="150:0:1:24:Consumable::6:0:27816", -- Draenic Pale Ale
	[37496]="150:0:1:24:Consumable::6:0:27817", -- Binary Brew
	[37497]="0:0:1:24:Consumable::1:0:", -- Autumnal Acorn Ale
	[37498]="0:0:1:24:Consumable::1:0:", -- Bartlett's Bitter Brew
	[37499]="0:0:1:24:Consumable::1:0:", -- Lord of Frost's Private Label
	[37500]="0:13:1:10:::1:0:", -- Key to Refurbished Shredder
	[37501]="0:12:1:10:::1:0:", -- Northern Salmon
	[37502]="0:12:1:1:::1:0:", -- Quarterflash's Package
	[37503]="0:3:4:1:GemPurple::1:0:", -- Purified Shadowsong Amethyst
	[37504]="500000:9:1:1:Jewelcrafting::1:0:25950,27666", -- Design: Purified Shadowsong Amethyst
	[37505]="0:4:2:1:Plate::1:0:", -- Battle Leader's Breastplate
	[37506]="0:4:2:1:Plate::1:0:", -- Bogstrok Plate Gloves
	[37507]="0:4:2:1:Plate::1:0:", -- Chilled Shoulderplates
	[37508]="0:4:2:1:Plate::1:0:", -- Sinking Pauldrons
	[37509]="0:4:2:1:Plate::1:0:", -- Seething Waistguard
	[37512]="0:4:2:1:Plate::1:0:", -- Gauntlets of the Crimson Guardian
	[37513]="0:4:2:1:Plate::1:0:", -- Helm of the Crimson Drakonid
	[37514]="0:4:2:1:Plate::1:0:", -- Freed Shackles
	[37515]="0:4:2:1:Plate::1:0:", -- Lost Crusader Waistguard
	[37516]="0:4:2:1:Plate::1:0:", -- Chilled Greaves
	[37517]="0:4:2:1:Plate::1:0:", -- Chilled Pauldrons
	[37518]="0:4:2:1:Plate::1:0:", -- Amberplate Waistguard
	[37519]="0:4:2:1:Plate::1:0:", -- Amberplate Headguard
	[37520]="0:4:2:1:Shield::1:0:", -- Plainkeeper Blockade
	[37521]="0:4:2:1:Shield::1:0:", -- Icechill Buckler
	[37522]="0:4:2:1:Plate::1:0:", -- Earthborn Greaves
	[37523]="0:4:2:1:Ring::1:0:", -- Rigid Tuskring
	[37524]="0:4:2:1:Ring::1:0:", -- Scout's Signet Ring
	[37525]="0:4:2:1:Ring::1:0:", -- Deep Sea Tuskring
	[37526]="0:4:2:1:Ring::1:0:", -- Thin Dexterity Enhancing Tube
	[37527]="0:4:2:1:Ring::1:0:", -- Shimmering Band
	[37528]="0:4:2:1:Ring::1:0:", -- Dry Earth Circle
	[37529]="0:4:2:1:Ring::1:0:", -- Shivering Healer's Ring
	[37530]="0:4:2:1:Ring::1:0:", -- Icy Ripper Ring
	[37535]="0:2:2:1:Stave::1:0:", -- Stave of the Windborn
	[37537]="0:2:2:1:Stave::1:0:", -- Stave of the Spiritcaller
	[37538]="0:12:1:1:::1:0:", -- Scrying Orb
	[37539]="0:12:1:1:::1:0:", -- Neltharion's Flame
	[37540]="0:12:1:1:::1:0:", -- The Diary of High General Abbendis
	[37541]="0:4:2:1:Amulet::1:0:", -- Giant Turtle Collar
	[37542]="0:12:1:1:::1:0:", -- Fishing Net
	[37543]="0:4:2:1:Amulet::1:0:", -- Pugnacious Collar
	[37545]="0:4:2:1:Amulet::1:0:", -- Graven Shoveltusk Pendant
	[37546]="0:4:2:1:Amulet::1:0:", -- Choker of the Northern Wind
	[37547]="0:2:2:1:OneHandMace::1:0:", -- Fireborn Warhammer
	[37548]="0:4:2:1:Amulet::1:0:", -- Iceflow Collar
	[37555]="0:4:2:1:Trinket::1:0:", -- Warsong's Wrath
	[37556]="0:4:2:1:Trinket::1:0:", -- Talisman of the Tundra
	[37557]="0:4:2:1:Trinket::1:0:", -- Warsong's Fervor
	[37558]="0:4:2:1:Trinket::1:0:", -- Tidal Boon
	[37559]="0:4:2:1:Trinket::1:0:", -- Serrah's Star
	[37560]="0:4:2:1:Trinket::1:0:", -- Vial of Renewal
	[37562]="0:4:2:1:Trinket::1:0:", -- Fury of the Crimson Drake
	[37564]="0:4:2:1:Cloak::1:0:", -- Scaled Flame Cloak
	[37565]="0:12:1:1:::1:0:", -- The Head of the High General
	[37566]="0:4:2:1:Cloak::1:0:", -- Durable Worghide Cape
	[37567]="0:7:1:20:Device::1:0:", -- Healing Injector Kit
	[37568]="0:12:1:1:::1:0:", -- Renewing Tourniquet
	[37569]="0:12:1:5:::1:0:", -- Murkweed
	[37570]="0:12:1:1:::1:0:", -- Murkweed Elixir
	[37571]="0:12:1:1:::1:0:", -- "Brew of the Month" Club Membership Form
	[37572]="0:12:1:1:::1:0:", -- Cedar Chest
	[37573]="0:4:2:1:Idol::1:0:", -- Idol of the Plainstalker
	[37574]="0:4:2:1:Libram::1:0:", -- Libram of Furious Blows
	[37575]="0:4:2:1:Totem::1:0:", -- Totem of the Tundra
	[37576]="0:12:1:1:::1:0:", -- Renewing Bandage
	[37577]="0:12:1:1:::1:0:", -- Orik's Crystalline Orb
	[37580]="0:12:1:20:::1:0:", -- Forgotten Treasure
	[37581]="0:12:1:1:::1:0:", -- Bloodied Scalping Knife
	[37582]="0:0:1:200:Consumable::1:0:", -- Pyroblast Cinnamon Ball
	[37583]="0:0:1:200:Consumable::1:0:", -- G.N.E.R.D.S.
	[37584]="0:0:1:200:Consumable::1:0:", -- Soothing Spearmint Candy
	[37585]="0:0:1:200:Consumable::1:0:", -- Chewy Fel Taffy
	[37586]="0:15:1:1:Junk::1:0:", -- Handful of Candy
	[37587]="0:4:3:1:Leather::1:0:", -- Ymirjar Physician's Robe
	[37588]="0:7:0:20:Meat::1:0:", -- Mostly Digested Fish
	[37590]="0:4:3:1:Plate::1:0:", -- Bands of Fading Light
	[37591]="0:4:3:1:Ring::1:0:", -- Nerubian Shield Ring
	[37592]="0:4:3:1:Mail::1:0:", -- Brood Plague Helmet
	[37593]="0:4:3:1:Leather::1:0:", -- Sprinting Shoulderpads
	[37594]="0:4:3:1:Cloth::1:0:", -- Elder Headpiece
	[37595]="0:4:3:1:Amulet::1:0:", -- Necklace of Taldaram
	[37597]="0:2:4:1:Dagger::1:0:", -- Direbrew's Shanker
	[37599]="0:12:1:1:::1:0:", -- "Brew of the Month" Club Membership Form
	[37601]="0:12:1:1:::1:0:", -- Flesh-bound Tome
	[37602]="0:7:1:20:EnchArmor::1:0:", -- Armor Vellum II
	[37603]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Dexterity
	[37604]="0:0:1:10:Consumable::1:0:", -- Tooth Pick
	[37606]="0:1:1:1:Bag::1:0:", -- Penny Pouch
	[37607]="0:12:1:1:::1:0:", -- Flesh-bound Tome
	[37612]="0:4:3:1:Plate::1:0:", -- Bonegrinder Breastplate
	[37613]="0:4:3:1:Cloth::1:0:", -- Flame Sphere Bindings
	[37614]="0:4:3:1:Mail::1:0:", -- Gauntlets of the Plundering Geist
	[37615]="0:2:3:1:Bow::1:0:", -- Titanium Compound Bow
	[37616]="0:4:3:1:Leather::1:0:", -- Kilt of the Forgotten One
	[37617]="0:2:3:1:Stave::1:0:", -- Staff of Sinister Claws
	[37618]="0:4:3:1:Plate::1:0:", -- Greaves of Ancient Evil
	[37619]="0:2:4:1:Wand::1:0:", -- Wand of Ahn'kahet
	[37620]="0:4:4:1:Plate::1:0:", -- Bracers of the Herald
	[37621]="0:12:1:1:::1:0:", -- Smoke Bomb
	[37622]="0:4:4:1:Cloth::1:0:", -- Skirt of the Old Kingdom
	[37623]="0:4:4:1:Mail::1:0:", -- Fiery Obelisk Handguards
	[37624]="0:4:3:1:Ring::1:0:", -- Stained-Glass Shard Ring
	[37625]="0:4:3:1:Plate::1:0:", -- Web Winder Gloves
	[37626]="0:2:3:1:Wand::1:0:", -- Wand of Sseratus
	[37627]="0:4:3:1:Plate::1:0:", -- Snake Den Spaulders
	[37628]="0:4:3:1:Mail::1:0:", -- Slad'ran's Coiled Cord
	[37629]="0:4:3:1:Cloth::1:0:", -- Slithering Slippers
	[37630]="0:4:3:1:Cloak::1:0:", -- Shroud of Moorabi
	[37631]="0:2:3:1:FistWeapon::1:0:", -- Fist of the Deity
	[37632]="0:4:3:1:Plate::1:0:", -- Mojo Frenzy Greaves
	[37633]="0:4:3:1:Plate::1:0:", -- Ground Tremor Helm
	[37634]="0:4:3:1:Leather::1:0:", -- Bracers of the Divine Elemental
	[37635]="0:4:3:1:Plate::1:0:", -- Pauldrons of the Colossus
	[37636]="0:4:3:1:Leather::1:0:", -- Helm of Cheated Fate
	[37637]="0:4:3:1:Cloth::1:0:", -- Living Mojo Belt
	[37638]="0:4:3:1:Trinket::1:0:", -- Offering of Sacrifice
	[37639]="0:4:3:1:Mail::1:0:", -- Grips of the Beast God
	[37640]="0:4:3:1:Leather::1:0:", -- Boots of Transformation
	[37641]="0:4:3:1:Cloth::1:0:", -- Arcane Flame Altar-Garb
	[37642]="0:4:4:1:Ring::1:0:", -- Hemorrhaging Circle
	[37643]="0:4:4:1:Leather::1:0:", -- Sash of Blood Removal
	[37644]="0:4:4:1:Leather::1:0:", -- Gored Hide Legguards
	[37645]="0:4:4:1:Plate::1:0:", -- Horn-Tipped Gauntlets
	[37646]="0:4:3:1:Amulet::1:0:", -- Burning Skull Pendant
	[37647]="0:4:3:1:Cloak::1:0:", -- Cloak of Bloodied Waters
	[37648]="0:4:3:1:Mail::1:0:", -- Belt of Tasseled Lanterns
	[37650]="0:4:3:1:Plate::1:0:", -- Shardling Legguards
	[37651]="0:4:3:1:Ring::1:0:", -- The Prospector's Prize
	[37652]="0:4:3:1:Leather::1:0:", -- Spaulders of Krystallus
	[37653]="0:2:3:1:TwoHandSword::1:0:", -- Sword of Justice
	[37654]="0:4:3:1:Mail::1:0:", -- Sabatons of the Ages
	[37655]="0:4:3:1:Cloth::1:0:", -- Mantle of the Tribunal
	[37656]="0:4:3:1:Mail::1:0:", -- Raging Construct Bands
	[37657]="0:4:3:1:Trinket::1:0:", -- Spark of Life
	[37658]="0:4:3:1:Plate::1:0:", -- Sun-Emblazoned Chestplate
	[37659]="0:2:0:1:TwoHandSword::1:0:", -- Enti's Quenched Sword
	[37660]="0:4:3:1:Trinket::1:0:", -- Forge Ember
	[37661]="0:0:1:1:Consumable::1:0:", -- Gossamer Potion
	[37662]="0:12:1:20:::1:0:", -- Gossamer Dust
	[37663]="0:7:2:20:MetalStone:164,333,202:1:0:", -- Titansteel Bar
	[37664]="0:12:2:1:::1:0:", -- Element 115
	[37665]="0:12:1:1:::1:0:", -- Tranquilizer Dart
	[37666]="0:4:3:1:Leather::1:0:", -- Boots of the Whirling Mist
	[37667]="0:2:4:1:Dagger::1:0:", -- The Fleshshaper
	[37668]="0:4:4:1:Plate::1:0:", -- Bands of the Stoneforge
	[37669]="0:4:4:1:Mail::1:0:", -- Leggings of the Stone Halls
	[37670]="0:4:4:1:Plate::1:0:", -- Sjonnir's Girdle
	[37671]="0:4:3:1:Plate::1:0:", -- Refined Ore Gloves
	[37672]="0:4:3:1:Plate::1:0:", -- Patina-Coated Breastplate
	[37673]="0:4:3:1:Cloth::1:0:", -- Dark Runic Mantle
	[37674]="0:15:0:5:Junk::1:0:", -- An Unopened Tome of Advice
	[37675]="0:4:3:1:Plate::1:0:", -- Legplates of Steel Implants
	[37676]="0:15:4:1:FlyingMount::1:0:", -- Vengeful Nether Drake
	[37677]="0:15:0:1:::1:0:", -- Numbered Rod
	[37678]="0:4:3:1:Leather::1:0:", -- Bile-Cured Gloves
	[37679]="0:4:3:1:Mail::1:0:", -- Spaulders of the Abomination
	[37680]="0:4:3:1:Cloth::1:0:", -- Belt of Unified Souls
	[37681]="0:2:3:1:OneHandMace::1:0:", -- Gavel of the Fleshcrafter
	[37682]="0:4:3:1:Plate::1:0:", -- Bindings of Dark Will
	[37683]="0:4:3:1:Amulet::1:0:", -- Necromancer's Amulet
	[37684]="0:4:3:1:Cloth::1:0:", -- Forgotten Shadow Hood
	[37685]="0:4:3:1:Ring::1:0:", -- Mobius Band
	[37686]="0:4:3:1:Mail::1:0:", -- Cracked Epoch Grasps
	[37687]="0:4:3:1:Cloth::1:0:", -- Gloves of Distorted Time
	[37688]="0:4:3:1:Plate::1:0:", -- Legplates of the Infinite Drakonid
	[37689]="0:4:3:1:Amulet::1:0:", -- Pendant of the Nathrezim
	[37690]="0:4:3:1:Plate::1:0:", -- Pauldrons of Destiny
	[37691]="0:4:3:1:Cloth::1:0:", -- Mantle of Deceit
	[37692]="0:2:3:1:Gun::1:0:", -- Pierce's Pistol
	[37693]="0:2:4:1:FistWeapon::1:0:", -- Greed
	[37694]="0:4:4:1:Ring::1:0:", -- Band of Guile
	[37695]="0:4:4:1:Mail::1:0:", -- Legguards of Nature's Power
	[37696]="0:4:4:1:Leather::1:0:", -- Plague-Infected Bracers
	[37700]="2400:7:1:10:Elemental:164,202,165:1:1:14846", -- Crystallized Air
	[37701]="2400:7:1:10:Elemental:171,164,202,755,197:1:1:14846", -- Crystallized Earth
	[37702]="2400:7:1:10:Elemental:171,164,202,197:1:1:14846", -- Crystallized Fire
	[37703]="2400:7:1:10:Elemental:171,164,202,165,197:1:1:14846", -- Crystallized Shadow
	[37704]="2400:7:1:10:Elemental:171,197:1:1:14846", -- Crystallized Life
	[37705]="2400:7:1:10:Elemental:171,164,333,202,165:1:1:14846", -- Crystallized Water
	[37706]="0:7:1:20:MetalStone::1:0:", -- Hardened Saronite Bar
	[37707]="0:12:1:10:::1:0:", -- Wild Carrot
	[37708]="0:2:1:1:Miscellaneous::1:0:", -- Stick
	[37710]="0:15:2:1:CombatPet::1:0:", -- Crashin' Thrashin' Racer Controller
	[37712]="0:4:3:1:Plate::1:0:", -- Terrace Defence Boots
	[37713]="0:15:0:20:Junk::1:0:", -- Needle and Thread
	[37714]="0:4:3:1:Leather::1:0:", -- Batrider's Cord
	[37715]="0:4:3:1:Cloth::1:0:", -- Cowl of the Dire Troll
	[37716]="0:12:1:1:::1:0:", -- Flashbang Grenade
	[37717]="0:4:3:1:Plate::1:0:", -- Legs of Physical Regeneration
	[37718]="0:4:3:1:OffHandFrill::1:0:", -- Temple Crystal Fragment
	[37719]="0:15:4:1:Mount::1:0:", -- Swift Zhevra
	[37721]="0:2:3:1:OneHandSword::1:0:", -- Cursed Lich Blade
	[37722]="0:4:3:1:Plate::1:0:", -- Breastplate of Undeath
	[37723]="0:4:3:1:Trinket::1:0:", -- Incisor Fragment
	[37724]="0:4:3:1:Leather::1:0:", -- Handler's Arm Strap
	[37725]="0:4:3:1:Cloth::1:0:", -- Savage Wound Wrap
	[37726]="0:4:3:1:Mail::1:0:", -- King Dred's Helm
	[37727]="0:12:1:10:::1:0:", -- Ruby Acorn
	[37728]="0:4:3:1:Cloak::1:0:", -- Cloak of the Enemy
	[37729]="0:4:3:1:Plate::1:0:", -- Grips of Sculptured Icicles
	[37730]="0:4:3:1:Cloth::1:0:", -- Cleric's Linen Shoes
	[37731]="0:4:3:1:Cloth::1:0:", -- Opposed Stasis Leggings
	[37732]="0:4:3:1:Ring::1:0:", -- Spectral Seal of the Prophet
	[37733]="0:2:3:1:TwoHandMace::1:0:", -- Mojo Masked Crusher
	[37734]="0:4:3:1:Trinket::1:0:", -- Talisman of Troll Divinity
	[37735]="0:4:3:1:Plate::1:0:", -- Ziggurat Imprinted Chestguard
	[37736]="0:12:1:1:::1:0:23710,27478", -- "Brew of the Month" Club Membership Form
	[37737]="0:12:1:1:::1:0:24495,27489", -- "Brew of the Month" Club Membership Form
	[37739]="0:2:4:1:Dagger::1:0:", -- Brutal Gladiator's Blade of Alacrity
	[37740]="0:2:4:1:OneHandMace::1:0:", -- Brutal Gladiator's Swift Judgement
	[37741]="0:12:1:1:::1:0:", -- Letter of Amnesty
	[37743]="0:4:3:1:Plate::1:0:", -- Legguards of Brutalization
	[37744]="0:4:3:1:Mail::1:0:", -- Horrorblood Treads
	[37745]="0:4:3:1:Leather::1:0:", -- Greenhealer's Garb
	[37746]="0:4:3:1:Cloth::1:0:", -- Helm of the Burning Soul
	[37747]="0:4:3:1:Shield::1:0:", -- Beneficent Bulwark
	[37748]="0:4:3:1:Amulet::1:0:", -- Winterfall's Frozen Necklace
	[37749]="0:2:3:1:FistWeapon::1:0:", -- Shocking Claws
	[37750]="0:0:1:20:Consumable::1:0:23710,24495,27478,27489", -- Fresh Brewfest Hops
	[37751]="0:4:3:1:Ring::1:0:", -- Tooga's Lost Toenail
	[37752]="0:4:3:1:Cloth::1:0:", -- Sandals of Broken Dreams
	[37753]="0:4:3:1:Cloth::1:0:", -- Mendicant's Robe of Mendacity
	[37754]="0:4:3:1:Cloth::1:0:", -- Shimmersteel Hood
	[37755]="0:4:3:1:Cloth::1:0:", -- Leggings of the Icy Heart
	[37756]="0:4:3:1:Cloak::1:0:", -- Zoe's Comforting Cape
	[37757]="0:4:3:1:Cloth::1:0:", -- Charlotte's Chastizing Pauldrons
	[37758]="0:4:3:1:Amulet::1:0:", -- Raine's Choker of Combustion
	[37759]="0:4:3:1:Cloth::1:0:", -- Rhie-ay's Clutching Gauntlets
	[37760]="0:4:3:1:Cloth::1:0:", -- Cracklefire Wristguards
	[37761]="0:4:3:1:Cloth::1:0:", -- Shimmerthread Girdle
	[37762]="0:4:3:1:Leather::1:0:", -- Many-Pocketed Belt
	[37763]="0:4:3:1:Leather::1:0:", -- Treads of the Purifier
	[37764]="0:4:3:1:Leather::1:0:", -- Corehound Fang Shoulderpads
	[37765]="0:4:3:1:Leather::1:0:", -- Leggings of the Water Moccasin
	[37766]="0:4:3:1:Leather::1:0:", -- Bracers of Unmitigated Larceny
	[37767]="0:4:3:1:Leather::1:0:", -- Ryft's Deathgaze
	[37768]="0:4:3:1:Leather::1:0:", -- Leggings of Violent Exsanguination
	[37769]="0:4:3:1:Leather::1:0:", -- Gnarled Shovelhorn Spaulders
	[37770]="0:4:3:1:Leather::1:0:", -- Bulge-Concealing Breastplate
	[37771]="0:4:3:1:Leather::1:0:", -- Wristguards of Verdant Recovery
	[37772]="0:4:3:1:Mail::1:0:", -- Wub's Electrospike Spaulders
	[37773]="0:4:3:1:Mail::1:0:", -- Shock-Inducing Girdle
	[37774]="0:4:3:1:Mail::1:0:", -- Leggings of Aqueous Dissolution
	[37775]="0:4:3:1:Mail::1:0:", -- Helm of the Broken Ram
	[37776]="0:4:3:1:Mail::1:0:", -- Bracers of Accurate Fire
	[37777]="0:4:3:1:Mail::1:0:", -- Bracers of Sizzling Heat
	[37778]="0:4:3:1:Mail::1:0:", -- Girdle of Unerring Flight
	[37779]="0:4:3:1:Mail::1:0:", -- Nixod's Chain-Threshed Spaulders
	[37780]="0:4:3:1:Mail::1:0:", -- Condor-Bone Chestguard
	[37781]="0:4:3:1:Mail::1:0:", -- Grips of the Warming Heart
	[37782]="0:4:3:1:Plate::1:0:", -- Gauntlets of the Cheerful Hearth
	[37783]="0:4:3:1:Plate::1:0:", -- Blood-Tempered Spaulders
	[37784]="0:4:4:1:Ring::1:0:", -- Keystone Great-Ring
	[37785]="0:4:3:1:Plate::1:0:", -- Girdle of the Howling Berserker
	[37786]="0:4:3:1:Plate::1:0:", -- Legguards of the Forlorn Seas
	[37787]="0:4:3:1:Plate::1:0:", -- Greathelm of the Unyielding Bull
	[37788]="0:4:4:1:Mail::1:0:", -- Limb Regeneration Bracers
	[37789]="0:4:3:1:Plate::1:0:", -- Gauntlets of Disembowelment
	[37790]="0:4:3:1:Plate::1:0:", -- Belt of Crystalline Tears
	[37791]="0:4:4:1:Leather::1:0:", -- Leggings of the Winged Serpent
	[37792]="0:4:3:1:Plate::1:0:", -- Agin's Crushing Carapace
	[37793]="0:4:3:1:Plate::1:0:", -- Skullcage of Eternal Terror
	[37794]="0:4:3:1:Amulet::1:0:", -- Torta's Oversized Choker
	[37795]="0:4:3:1:Plate::1:0:", -- Grips of the Valiant Champion
	[37796]="0:4:3:1:Cloak::1:0:", -- Earthbound Cape
	[37797]="0:4:3:1:Cloak::1:0:", -- Cloak of the Agile Mind
	[37798]="0:4:4:1:Cloth::1:0:", -- Overlook Handguards
	[37799]="0:4:3:1:Cloak::1:0:", -- Reanimator's Cloak
	[37800]="0:4:3:1:Mail::1:0:", -- Aviary Guardsman's Hauberk
	[37801]="0:4:3:1:Plate::1:0:", -- Waistguard of the Risen Knight
	[37802]="0:2:3:1:Dagger::1:0:", -- Elanor's Edge
	[37803]="0:2:3:1:Stave::1:0:", -- Lola's Lifegiving Branch
	[37804]="0:2:3:1:Stave::1:0:", -- Bloodwood Greatstaff
	[37805]="0:2:3:1:OneHandMace::1:0:", -- Melia's Magnificent Scepter
	[37806]="0:2:3:1:Stave::1:0:", -- Zabra's Misplaced Staff
	[37807]="0:2:3:1:OneHandSword::1:0:", -- Lydia's Sharpened Swordbreaker
	[37808]="0:2:3:1:OneHandMace::1:0:", -- Dragonjaw Mauler
	[37809]="0:2:3:1:Bow::1:0:", -- Roc-Feather Longbow
	[37810]="0:4:3:1:Shield::1:0:", -- Blade-Binding Bulwark
	[37811]="0:2:3:1:TwoHandAxe::1:0:", -- Captain Carver's Persuader
	[37812]="0:2:3:1:TwoHandMace::1:0:", -- Petrified Ironwood Smasher
	[37813]="0:2:3:1:Polearm::1:0:", -- Banner Slicer
	[37814]="0:4:3:1:Plate::1:0:", -- Iron Dwarf Smith Pauldrons
	[37815]="0:15:1:1:CombatPet::1:0:", -- Emerald Essence
	[37816]="0:15:2:20:Holiday::1:0:23710,24495,27478,27489", -- Preserved Brewfest Hops
	[37817]="0:4:3:1:OffHandFrill::1:0:", -- Branch of Sinful Reprieve
	[37818]="0:4:3:1:Mail::1:0:", -- Patroller's War-Kilt
	[37819]="0:4:3:1:Ring::1:0:", -- Milan's Mastercraft Band
	[37820]="0:4:3:1:Ring::1:0:", -- Worgen's Ring of Revitalization
	[37821]="0:4:3:1:Ring::1:0:", -- Raine's Signet of Blasting
	[37822]="0:4:3:1:Ring::1:0:", -- Twisted Puzzle-Ring
	[37823]="0:4:3:1:Amulet::1:0:", -- Draconic Choker of Ferocity
	[37824]="0:2:3:1:Wand::1:0:", -- Gwyneth's Runed Dragonwand
	[37825]="0:4:3:1:Cloth::1:0:", -- Traditionally Dyed Handguards
	[37826]="0:4:3:1:Plate::1:0:", -- The General's Steel Girdle
	[37828]="0:15:4:1:Mount::1:0:", -- Great Brewfest Kodo
	[37829]="0:12:2:200:::1:0:", -- Brewfest Prize Token
	[37830]="0:12:1:1:::1:0:", -- Mikhail's Journal
	[37831]="0:12:1:1:::1:0:", -- Mikhail's Journal
	[37833]="0:12:1:1:::1:0:", -- Ruby Brooch
	[37835]="0:4:4:1:Trinket::1:0:", -- Je'Tze's Bell
	[37836]="0:10:1::Currency::1:0:", -- Venture Coin
	[37840]="0:4:3:1:Cloak::1:0:", -- Shroud of Reverberation
	[37841]="0:4:3:1:Leather::1:0:", -- Slag Footguards
	[37842]="0:4:3:1:Leather::1:0:", -- Belt of Vivacity
	[37843]="0:4:3:1:Cloth::1:0:", -- Giant-Hair Woven Gloves
	[37844]="0:4:3:1:Trinket::1:0:", -- Winged Talisman
	[37845]="0:4:3:1:Mail::1:0:", -- Cord of Swirling Winds
	[37846]="0:4:3:1:Leather::1:0:", -- Charged-Bolt Grips
	[37847]="0:4:3:1:Plate::1:0:", -- Skywall Striders
	[37848]="0:2:3:1:Stave::1:0:", -- Lightning Giant Staff
	[37849]="0:4:3:1:Plate::1:0:", -- Planetary Helm
	[37850]="0:4:3:1:Cloth::1:0:", -- Flowing Sash of Order
	[37851]="0:4:3:1:Cloth::1:0:", -- Ornate Woolen Stola
	[37852]="0:2:4:1:TwoHandAxe::1:0:", -- Colossal Skull-Clad Cleaver
	[37853]="0:4:4:1:Leather::1:0:", -- Advanced Tooled-Leather Bands
	[37854]="0:4:4:1:Cloth::1:0:", -- Woven Bracae Leggings
	[37855]="0:4:4:1:Mail::1:0:", -- Mail Girdle of the Audient Earth
	[37856]="0:2:3:1:Dagger::1:0:", -- Librarian's Paper Cutter
	[37857]="0:4:3:1:Mail::1:0:", -- Helm of the Lightning Halls
	[37858]="0:4:3:1:Leather::1:0:", -- Awakened Handguards
	[37859]="0:15:1:1:CombatPet::1:0:", -- Amber Essence
	[37860]="0:15:1:1:CombatPet::1:0:", -- Ruby Essence
	[37861]="0:4:3:1:Amulet::1:0:", -- Necklace of Arcane Spheres
	[37862]="0:4:3:1:Plate::1:0:", -- Gauntlets of the Water Revenant
	[37863]="0:0:3:1:Consumable::1:0:", -- Direbrew's Remote
	[37864]="0:4:4:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[37865]="0:4:4:1:Trinket::1:0:12788", -- Medallion of the Horde
	[37867]="0:4:3:1:Cloth::1:0:", -- Footwraps of Teleportation
	[37868]="0:4:3:1:Mail::1:0:", -- Girdle of the Ethereal
	[37869]="0:4:3:1:Ring::1:0:", -- Globule Signet
	[37870]="0:4:3:1:Mail::1:0:", -- Twin-Headed Boots
	[37871]="0:2:3:1:OneHandAxe::1:0:", -- The Key
	[37872]="0:4:3:1:Trinket::1:0:", -- Lavanthor's Talisman
	[37873]="0:4:3:1:Trinket::1:0:", -- Mark of the War Prisoner
	[37874]="0:4:3:1:Plate::1:0:", -- Gauntlets of Capture
	[37875]="0:4:3:1:Mail::1:0:", -- Spaulders of the Violet Hold
	[37876]="0:4:3:1:Cloth::1:0:", -- Cyanigosa's Leggings
	[37877]="0:0:1:1:Consumable::1:0:", -- Silver Feather
	[37878]="0:0:1:1:Consumable::1:0:", -- Worg's Blood Elixir
	[37879]="0:12:1:8:::1:0:", -- Wintergarde Munitions
	[37880]="0:12:1:1:::1:0:", -- The Plume of Alystros
	[37881]="0:12:1:1:::1:0:", -- Skytalon Molts
	[37882]="0:12:1:20:::1:0:", -- Lasher Seed
	[37883]="0:2:4:1:Stave::1:0:", -- Staff of Trickery
	[37884]="0:4:4:1:Cloth::1:0:", -- Azure Cloth Bindings
	[37886]="0:4:4:1:Mail::1:0:", -- Handgrips of the Savage Emissary
	[37887]="0:12:1:1:::1:0:", -- Seeds of Nature's Wrath
	[37888]="0:15:2:1:Junk::1:0:", -- Arcane Disruptor
	[37889]="0:4:3:1:OffHandFrill::1:0:", -- Prison Manifest
	[37890]="0:4:3:1:Leather::1:0:", -- Chain Gang Legguards
	[37891]="0:4:3:1:Plate::1:0:", -- Cast Iron Shackles
	[37892]="0:2:3:1:Miscellaneous::1:0:", -- Green Brewfest Stein
	[37893]="0:2:3:1:Miscellaneous::1:0:", -- Filled Green Brewfest Stein
	[37894]="0:2:3:1:Miscellaneous::1:0:", -- Filled Green Brewfest Stein
	[37895]="0:2:3:1:Miscellaneous::1:0:", -- Filled Green Brewfest Stein
	[37896]="0:2:3:1:Miscellaneous::1:0:", -- Filled Green Brewfest Stein
	[37897]="0:2:3:1:Miscellaneous::1:0:", -- Filled Green Brewfest Stein
	[37898]="150:0:1:24:Consumable::6:0:27806", -- Wild Winter Pilsner
	[37899]="150:0:1:24:Consumable::6:0:27810", -- Izzard's Ever Flavor
	[37900]="150:0:1:24:Consumable::6:0:27811", -- Aromatic Honey Brew
	[37906]="150:0:1:24:Consumable::6:0:27817", -- Binary Brew
	[37907]="150:0:1:24:Consumable::6:0:27818", -- Autumnal Acorn Ale
	[37908]="150:0:1:24:Consumable::6:0:27819", -- Bartlett's Bitter Brew
	[37909]="150:0:1:24:Consumable::6:0:27820", -- Lord of Frost's Private Label
	[37910]="0:12:1:1:::1:0:", -- Page 4 of Plunderbeard's Journal
	[37911]="0:12:1:1:::1:0:", -- Page 5 of Plunderbeard's Journal
	[37912]="0:12:1:1:::1:0:", -- Page 6 of Plunderbeard's Journal
	[37913]="0:12:1:1:::1:0:", -- Page 7 of Plunderbeard's Journal
	[37915]="5000:9:1:1:Tailoring::1:1:15165", -- Pattern: Dress Shoes
	[37920]="0:12:1:1:::1:0:", -- Thel'zan's Phylactery
	[37921]="3000:7:1:20:Herb:171:1:1:14846", -- Deadnettle
	[37922]="0:12:1:1:::1:0:", -- Pack of Nozzlerust Explosives
	[37923]="0:12:1:1:::1:0:", -- Hourglass of Eternity
	[37925]="0:0:1:1:Consumable::1:0:", -- Experimental Mixture
	[37927]="0:4:4:1:Ring::1:0:", -- Guardian's Band of Subjugation
	[37928]="0:4:4:1:Amulet::1:0:", -- Guardian's Pendant of Subjugation
	[37929]="0:4:4:1:Amulet::1:0:", -- Guardian's Pendant of Reprieve
	[37930]="0:12:1:1:::1:0:", -- Onslaught Map
	[37931]="0:12:1:1:::1:0:", -- The Path of Redemption
	[37932]="0:12:1:1:::1:0:", -- Miner's Lantern
	[37933]="0:12:1:1:::1:0:", -- Zelig's Scrying Orb
	[37934]="24000000:4:1:1:Ring::1:1:2849,18756", -- Noble's Elementium Signet
	[37936]="0:4:2:1:Cloth::1:0:", -- Fisherman's Earwarmer
	[37937]="0:4:2:1:Cloth::1:0:", -- Alystros's Plume Cinch
	[37938]="0:4:2:1:Cloth::1:0:", -- Visionary's Robes
	[37939]="0:4:2:1:Amulet::1:0:", -- Baleen Braided Collar
	[37940]="0:4:2:1:Cloth::1:0:", -- Mantle of Itharius
	[37941]="0:4:2:1:Cloth::1:0:", -- Fading Handwraps
	[37942]="0:4:2:1:Cloth::1:0:", -- Kirin Tor Initiate's Sandals
	[37943]="0:4:2:1:Cloth::1:0:", -- Kirin Tor Initiate's Cowl
	[37944]="0:4:2:1:Cloth::1:0:", -- High Priest Forith's Robes
	[37945]="0:4:2:1:Cloth::1:0:", -- Thin Jormungar Legwraps
	[37947]="0:4:2:1:Cloth::1:0:", -- Miraculous Waistwarming Band
	[37948]="0:4:2:1:Cloth::1:0:", -- Refractive Shoulderpads
	[37949]="0:4:2:1:Cloak::1:0:", -- Saboteur's Wrap
	[37950]="0:4:2:1:Cloth::1:0:", -- Highseas Wristwraps
	[37953]="0:4:2:1:Cloth::1:0:", -- Wastewind Garments
	[37954]="0:4:2:1:Cloth::1:0:", -- Wastewind Cinch
	[37956]="0:4:2:1:Cloth::1:0:", -- Frontrunner's Blessed Handwraps
	[37957]="0:4:2:1:Cloth::1:0:", -- Wastewind Bracers
	[37958]="0:4:2:1:Cloth::1:0:", -- Wastewind Headcover
	[37959]="0:4:2:1:Cloth::1:0:", -- Wastewind Pauldrons
	[37960]="0:4:2:1:Ring::1:0:", -- Oath Signet
	[37961]="0:4:2:1:Cloth::1:0:", -- Wastewind Leggings
	[37962]="0:4:2:1:Cloth::1:0:", -- Treads of the Charred Canyon
	[37963]="0:4:2:1:Cloth::1:0:", -- Wastewind Handwraps
	[37964]="0:4:2:1:Cloth::1:0:", -- Spiderwarder Braces
	[37965]="0:4:2:1:Cloth::1:0:", -- Wyrmward Cover
	[37966]="0:4:2:1:Cloth::1:0:", -- Bracers of Nature's Fury
	[37968]="0:4:2:1:Cloth::1:0:", -- Robe of Calcified Tears
	[37969]="0:4:2:1:Cloak::1:0:", -- Chaos Mender Cloak
	[37970]="0:4:2:1:Cloth::1:0:", -- Feathers of the Dragon Wastes
	[37971]="0:4:2:1:Cloth::1:0:", -- Sash of the Nibbling Plague
	[37980]="0:4:2:1:Leather::1:0:", -- Moa'ki Thresherhide Tunic
	[37981]="0:4:2:1:Leather::1:0:", -- Ancient Dreamer's Leggings
	[37982]="0:4:2:1:Ring::1:0:", -- Gleaming Tuskring
	[37983]="0:4:2:1:Leather::1:0:", -- Gloves of the Emerald Stalker
	[37984]="0:4:2:1:Leather::1:0:", -- Deathtouched Boots
	[37985]="0:4:2:1:Leather::1:0:", -- Violet Stalker Shoulderpads
	[37986]="0:4:2:1:Leather::1:0:", -- Hood of the Forgotten Rifleman
	[37987]="0:4:2:1:Leather::1:0:", -- Violet Stalker Bracers
	[37988]="0:4:2:1:Cloak::1:0:", -- Lord Prestor's Drape
	[37989]="0:4:2:1:Leather::1:0:", -- Rattlebore Slayer Leggings
	[37990]="0:4:2:1:Leather::1:0:", -- Narf's Explosiveproof Strand
	[37991]="0:4:2:1:Leather::1:0:", -- Hyper-amplified Natural Leather Vest
	[37992]="0:4:2:1:Amulet::1:0:", -- Ritual Neckguard
	[37993]="0:4:2:1:Leather::1:0:", -- Glade Wanderer Boots
	[37995]="0:4:2:1:Leather::1:0:", -- Snowfall Reaver Hood
	[37996]="0:4:2:1:Leather::1:0:", -- Snowfall Reaver Gloves
	[37998]="0:4:2:1:Leather::1:0:", -- Snowfall Reaver Boots
	[37999]="0:4:2:1:Leather::1:0:", -- Glade Wanderer Bracers
	[38000]="0:4:2:1:Leather::1:0:", -- Snowfall Reaver Breastplate
	[38001]="0:4:2:1:Leather::1:0:", -- Snowfall Reaver Pauldrons
	[38002]="0:4:2:1:Cloak::1:0:", -- Honorborn Cloak
	[38003]="0:4:2:1:Leather::1:0:", -- Snowfall Reaver Leggings
	[38004]="0:4:2:1:Leather::1:0:", -- Scourgeslayer Belt
	[38005]="0:4:2:1:Leather::1:0:", -- Spiritfury Bands
	[38006]="0:4:2:1:Leather::1:0:", -- Glade Wanderer Belt
	[38007]="0:4:2:1:Leather::1:0:", -- Canyon Runner's Vest
	[38008]="0:4:2:1:Leather::1:0:", -- Lothalar Woodwalker Belt
	[38010]="0:4:2:1:Leather::1:0:", -- Scourgeslayer Cover
	[38011]="0:4:2:1:Leather::1:0:", -- Torturer's Fleshwoven Leggings
	[38012]="0:4:2:1:Leather::1:0:", -- Lothalar Woodwalker Bracers
	[38013]="0:4:2:1:Leather::1:0:", -- Lothalar Woodwalker Shoulders
	[38014]="0:4:2:1:Leather::1:0:", -- Vermin-Handler's Gauntlets
	[38023]="0:4:2:1:Mail::1:0:", -- Sharkdiver's Leggings
	[38024]="0:4:2:1:Mail::1:0:", -- Verdant Linked Boots
	[38025]="0:4:2:1:Mail::1:0:", -- Guiding Gloves of the Seer
	[38026]="0:4:2:1:Mail::1:0:", -- Sharkdiver's Bracers
	[38027]="0:4:2:1:Mail::1:0:", -- Verdant Hunter's Guise
	[38028]="0:4:2:1:Ring::1:0:", -- Ring of the Afterlife
	[38029]="0:4:2:1:Mail::1:0:", -- Azurehunter Handguards
	[38030]="0:4:2:1:Mail::1:0:", -- Chestpiece of the Forgotten Captain
	[38031]="0:4:2:1:Mail::1:0:", -- Azurehunter Legguards
	[38032]="0:4:2:1:Amulet::1:0:", -- Wyrm-slave Collar
	[38033]="0:4:2:1:Mail::1:0:", -- Ice Heart Chestguard
	[38034]="0:4:2:1:Mail::1:0:", -- Serrated Chain Links
	[38035]="0:4:2:1:Mail::1:0:", -- Tightened Chainmesh Boots
	[38036]="0:4:2:1:Ring::1:0:", -- Circlet of the Forgotten Mercenary
	[38037]="0:4:2:1:Mail::1:0:", -- Westwind Shoulderguards
	[38039]="0:4:2:1:Mail::1:0:", -- Iceshear Pauldrons
	[38040]="0:4:2:1:Mail::1:0:", -- Iceshear Bindings
	[38041]="0:4:2:1:Mail::1:0:", -- Westwind Waistband
	[38042]="0:4:2:1:Amulet::1:0:", -- Scourge Ghoul Collar
	[38043]="0:4:2:1:Mail::1:0:", -- Anub'ar-Husk Leggings
	[38044]="0:4:2:1:Mail::1:0:", -- Anub'ar-Husk Shoulderguards
	[38045]="0:4:2:1:Mail::1:0:", -- Anub'ar-Husk Helm
	[38046]="0:4:2:1:Mail::1:0:", -- Wyrmfire Gloves
	[38047]="0:4:2:1:Mail::1:0:", -- Belt of Ghostly Essence
	[38048]="0:4:2:1:Mail::1:0:", -- Breastplate of Sizzling Chitin
	[38049]="0:4:2:1:Mail::1:0:", -- Wyrmchaser's Waistguard
	[38050]="0:15:3:1:Companion::1:0:", -- Soul-Trader Beacon
	[38051]="0:4:2:1:Mail::1:0:", -- Star's Rest Treads
	[38053]="0:4:2:1:Mail::1:0:", -- Wyrmfire Links
	[38054]="0:4:2:1:Mail::1:0:", -- Paingiver Wristguards
	[38055]="0:4:2:1:Mail::1:0:", -- Ridgehunter Gauntlets
	[38056]="0:4:2:1:Mail::1:0:", -- Ridgehunter Chestguard
	[38057]="0:4:2:1:Mail::1:0:", -- Rodent-Proof Headguard
	[38068]="0:4:2:1:Ring::1:0:", -- Sinner's Repentance
	[38070]="0:4:2:1:Trinket::1:0:", -- Foresight's Anticipation
	[38071]="0:4:2:1:Trinket::1:0:", -- Valonforth's Remembrance
	[38072]="0:4:2:1:Trinket::1:0:", -- Thunder Capacitor
	[38073]="0:4:2:1:Trinket::1:0:", -- Will of the Red Dragonflight
	[38080]="0:4:2:1:Trinket::1:0:", -- Automated Weapon Coater
	[38081]="0:4:2:1:Trinket::1:0:", -- Scarab of Isanoth
	[38082]="12000000:1:4:1:Bag::1:0:18756", -- "Gigantique" Bag
	[38083]="0:12:1:1:::1:0:", -- Dull Carving Knife
	[38084]="0:4:2:1:Plate::1:0:", -- Crustacean Stompers
	[38085]="0:4:2:1:Plate::1:0:", -- Belt of the Emerald Guardian
	[38086]="0:4:2:1:Plate::1:0:", -- Vigilant Skullcap
	[38087]="0:4:2:1:Plate::1:0:", -- Sea Rusted Gauntlets
	[38088]="0:4:2:1:Plate::1:0:", -- Breastplate of Nature's Ire
	[38089]="0:4:1:1:Cloth::1:0:", -- Ruby Shades
	[38090]="6000000:4:1:1:Ring::1:1:18756", -- Sapphire Pinky Ring
	[38091]="30000000:4:1:1:Ring::1:1:18756", -- Gold Eternium Band
	[38092]="0:4:2:1:Plate::1:0:", -- Crystalplate Pauldrons
	[38093]="0:4:2:1:Plate::1:0:", -- Dalaran Sentry Wristbraces
	[38094]="0:4:2:1:Plate::1:0:", -- Dalaran Sentry Headguard
	[38095]="0:4:2:1:Plate::1:0:", -- Legplates of the Conquered Knight
	[38096]="0:4:2:1:Plate::1:0:", -- Crystalplate Legguards
	[38097]="0:4:2:1:Plate::1:0:", -- Experimental Utility Belt
	[38098]="0:12:1:20:::1:0:", -- Dragonflayer Patriarch's Blood
	[38100]="0:4:2:1:Plate::1:0:", -- Crystalplate Gauntlets
	[38101]="0:4:2:1:Plate::1:0:", -- Stonepath Sabatons
	[38102]="0:4:2:1:Plate::1:0:", -- Stonepath Gauntlets
	[38103]="0:4:2:1:Plate::1:0:", -- Petrified Bone Chestguard
	[38104]="0:4:2:1:Plate::1:0:", -- Stonepath Helm
	[38105]="0:4:2:1:Plate::1:0:", -- Stonepath Pauldrons
	[38106]="0:4:2:1:Plate::1:0:", -- Petrified Bone Footguards
	[38107]="0:4:2:1:Plate::1:0:", -- Stonepath Chestguard
	[38108]="0:4:2:1:Plate::1:0:", -- Conscript's Ruby Waistguard
	[38109]="0:4:2:1:Plate::1:0:", -- Wraithshimmer Legplates
	[38110]="0:4:2:1:Plate::1:0:", -- Legplates of the Agmar Preserver
	[38111]="0:4:2:1:Plate::1:0:", -- Wyrmbane Wristguards
	[38112]="0:4:2:1:Plate::1:0:", -- Bark Covered Pauldrons
	[38114]="0:4:2:1:Plate::1:0:", -- Chestplate of the Ruby Champion
	[38115]="0:4:2:1:Plate::1:0:", -- Sabatons of the Enforcer
	[38116]="0:4:2:1:Plate::1:0:", -- Plated Magnataur Leggings
	[38117]="0:4:2:1:Plate::1:0:", -- Dreadtalon's Clutch
	[38118]="0:4:2:1:Plate::1:0:", -- Bite-Proof Grips
	[38126]="0:2:2:1:Stave::1:0:", -- Frostbite Warstaff
	[38127]="0:2:2:1:OneHandMace::1:0:", -- Carved Dragonbone Mace
	[38128]="0:2:2:1:Stave::1:0:", -- Staff of the Spiked Beast
	[38129]="0:2:2:1:Stave::1:0:", -- Staff of the Ley Mender
	[38130]="0:2:2:1:Dagger::1:0:", -- Emme's Lost Spellblade
	[38131]="0:2:2:1:Stave::1:0:", -- Staff of Ruby Wood
	[38132]="0:2:2:1:Stave::1:0:", -- Moonrest Garden Stave
	[38133]="0:2:2:1:Stave::1:0:", -- Timeshattered Spire
	[38134]="0:2:2:1:Dagger::1:0:", -- Bloodtinged Spellblade
	[38135]="0:2:2:1:OneHandMace::1:0:", -- Mace of the Fallen Raven Priest
	[38137]="0:2:2:1:Stave::1:0:", -- Endurance of the Spell Warder
	[38138]="0:2:2:1:Dagger::1:0:", -- Keldonus's Missing Spellshard
	[38141]="0:2:2:1:Stave::1:0:", -- Coldwind Scratching Pole
	[38142]="0:2:2:1:Dagger::1:0:", -- Infused Dragonbone Splinter
	[38143]="0:2:2:1:Stave::1:0:", -- Composite Harpyspine Staff
	[38144]="0:12:1:10:::1:0:", -- Harkor's Ingredients
	[38145]="0:1:1:1:Bag::1:0:", -- Deathweave Bag
	[38146]="0:2:2:1:OneHandSword::1:0:", -- Gleaming Iceblade
	[38147]="0:4:2:1:Ring::1:0:", -- Corrupted Band
	[38148]="0:2:2:1:TwoHandMace::1:0:", -- Chilled Headsmasher
	[38149]="0:12:1:1:::1:0:", -- Scourged Troll Mummy
	[38150]="0:2:2:1:Crossbow::1:0:", -- Imported Ironshod Crossbow
	[38151]="0:2:2:1:Dagger::1:0:", -- Daschal's Discarded Shiv
	[38152]="0:2:2:1:OneHandMace::1:0:", -- Mace of the Violet Guardian
	[38153]="0:2:2:1:FistWeapon::1:0:", -- Mana Infused Claw
	[38154]="0:2:2:1:OneHandSword::1:0:", -- Taigasha
	[38155]="0:2:2:1:Dagger::1:0:", -- Shortblade of the Ruby Ally
	[38156]="0:2:2:1:TwoHandAxe::1:0:", -- Battered Magnataur Dualblade
	[38157]="0:2:2:1:Bow::1:0:", -- Longbow of the Ruby Rider
	[38160]="0:4:1:1:Miscellaneous::1:0:", -- Soul-Trader's Bindings
	[38161]="0:4:1:1:Miscellaneous::1:0:", -- Soul-Trader's Gloves
	[38162]="0:4:1:1:Miscellaneous::1:0:", -- Soul-Trader's Boots
	[38163]="0:4:1:1:Miscellaneous::1:0:", -- Soul-Trader's Head Wrap
	[38169]="0:2:2:1:Dagger::1:0:", -- Keen Woodland Shank
	[38170]="0:2:2:1:OneHandMace::1:0:", -- Spiked Coldwind Club
	[38171]="0:2:2:1:TwoHandMace::1:0:", -- Battleworn Magnataur Crusher
	[38172]="0:2:2:1:Crossbow::1:0:", -- Crossbow of the Hardened Ranger
	[38173]="0:2:2:1:Dagger::1:0:", -- Dagger of the Returning Past
	[38174]="0:2:2:1:OneHandMace::1:0:", -- Time-Bending Smasher
	[38175]="0:2:4:1:OneHandSword::1:0:", -- The Horseman's Blade
	[38176]="0:2:2:1:OneHandMace::1:0:", -- Stronghold Battlemace
	[38177]="0:2:2:1:Gun::1:0:", -- Siege Captain's Gun
	[38178]="0:2:2:1:TwoHandAxe::1:0:", -- Battlement Enforcer's Axe
	[38181]="0:2:2:1:TwoHandSword::1:0:", -- Warblade of the Forgotten Footman
	[38186]="0:0:1:250:Consumable::1:0:", -- Ethereal Credit
	[38187]="0:2:2:1:OneHandAxe::1:0:", -- Reactive Waraxe
	[38188]="0:2:2:1:FistWeapon::1:0:", -- Claw of the Undead Ravager
	[38189]="0:2:2:1:Dagger::1:0:", -- Backtwister
	[38190]="0:2:2:1:Dagger::1:0:", -- Scourgeslayer's Shank
	[38191]="0:2:2:1:Dagger::1:0:", -- Compact Explosive Delivery Device
	[38194]="0:2:2:1:Gun::1:0:", -- Mageslayer Rifle
	[38195]="0:2:2:1:TwoHandSword::1:0:", -- Magister's Bane
	[38196]="0:2:2:1:OneHandAxe::1:0:", -- Bloodsmeared Brutalizer
	[38197]="0:2:2:1:TwoHandAxe::1:0:", -- Mounted Boneshredder
	[38198]="0:2:2:1:OneHandSword::1:0:", -- Joint-Severing Quickblade
	[38202]="0:2:2:1:Wand::1:0:", -- Twig of Happy Reminders
	[38206]="0:2:2:1:Wand::1:0:", -- Wand of Blinding Light
	[38207]="0:2:2:1:Wand::1:0:", -- Wand of Purifying Fire
	[38208]="0:2:2:1:Bow::1:0:", -- Valiance Longbow
	[38212]="0:4:2:1:Trinket::1:0:", -- Death Knight's Anguish
	[38213]="0:4:2:1:Trinket::1:0:", -- Harbinger's Wrath
	[38214]="0:4:2:1:OffHandFrill::1:0:", -- Hypergizmatic Energy Booster
	[38217]="0:4:2:1:OffHandFrill::1:0:", -- Tome of the Violet Tower
	[38218]="0:4:3:1:Ring::1:0:", -- Executioner's Band
	[38219]="0:4:3:1:Ring::1:0:", -- Ring of Decimation
	[38220]="0:4:3:1:Ring::1:0:", -- Signet of Swift Judgment
	[38221]="0:4:3:1:Cloak::1:0:", -- Shroud of Fluid Strikes
	[38222]="0:4:3:1:Cloak::1:0:", -- Mantle of Keristrasza
	[38223]="0:4:3:1:Cloak::1:0:", -- Cloak of Azure Lights
	[38224]="0:4:2:1:OffHandFrill::1:0:", -- Life Binder Talisman
	[38225]="0:1:3:1:HerbBag::1:0:", -- Mycah's Botanical Bag
	[38226]="0:4:3:1:Amulet::1:0:", -- Chain of the Tolling Bell
	[38227]="0:4:3:1:Amulet::1:0:", -- Indomitable Choker of Light
	[38228]="0:4:3:1:Amulet::1:0:", -- Pendant of Revolutionary Thought
	[38229]="0:9:1:1:Tailoring::1:0:18382", -- Pattern: Mycah's Botanical Bag
	[38230]="0:4:3:1:Amulet::1:0:", -- Clutch of Undying Will
	[38231]="0:4:3:1:Amulet::1:0:", -- Choker of Forceful Redemption
	[38232]="0:4:3:1:Amulet::1:0:", -- Chain of Vigilant Thought
	[38233]="0:0:1:250:Consumable::1:0:", -- Path of Illidan
	[38237]="0:2:3:1:TwoHandAxe::1:0:", -- Axe of Frozen Death
	[38238]="0:2:3:1:FistWeapon::1:0:", -- Borean Smasher
	[38239]="0:2:3:1:Stave::1:0:", -- Tower of the Infinite Mind
	[38240]="0:2:3:1:Stave::1:0:", -- Staff of the Purposeful Mendicant
	[38241]="0:2:3:1:Gun::1:0:", -- Fury of the Raging Dragon
	[38242]="0:2:3:1:Dagger::1:0:", -- Fang of the Desolate Soul
	[38250]="0:4:3:1:Ring::1:0:", -- Activist's Signet of Blasting
	[38251]="0:4:3:1:Ring::1:0:", -- Ring of Indignant Rage
	[38252]="0:4:3:1:Ring::1:0:", -- Band of Wholesome Preservation
	[38257]="0:4:3:1:Trinket::1:0:", -- Strike of the Seas
	[38258]="0:4:3:1:Trinket::1:0:", -- Sailor's Knotted Charm
	[38259]="0:4:3:1:Trinket::1:0:", -- First Mate's Pocketwatch
	[38260]="0:15:0:5:Junk::1:0:", -- Empty Tobacco Pouch
	[38261]="0:15:0:5:Junk::1:0:", -- Bent House Key
	[38262]="0:2:0:1:Stave::1:0:", -- Well-Worn Bat
	[38263]="0:15:0:5:Junk::1:0:", -- Too-Small Armband
	[38264]="0:15:0:5:Junk::1:0:", -- A Very Pretty Rock
	[38266]="0:0:1:4:Other::1:0:", -- Rotund Relic
	[38267]="0:15:0:10:Junk::1:0:", -- Kalieki's Notes
	[38268]="0:2:0:1:Miscellaneous::1:0:", -- Spare Hand
	[38269]="0:15:0:20:Junk::1:0:", -- Soggy Handkerchief
	[38273]="0:15:0:5:Junk::1:0:", -- Brain Coral
	[38274]="0:15:0:5:Junk::1:0:", -- Large Snail Shell
	[38276]="0:4:1:1:Cloth::1:0:", -- Haliscan Brimmed Hat
	[38277]="0:4:1:1:Cloth::1:0:", -- Haliscan Jacket
	[38278]="0:4:1:1:Cloth::1:0:", -- Haliscan Pantaloons
	[38280]="0:12:1:1:::1:0:", -- Direbrew's Dire Brew
	[38281]="0:12:1:1:::1:0:", -- Direbrew's Dire Brew
	[38284]="0:4:2:1:Ring::1:0:", -- Siegemaster's Torch Ring
	[38285]="0:4:1:1:Miscellaneous::1:0:", -- Soul-Trader's Waistband
	[38286]="0:4:1:1:Miscellaneous::1:0:", -- Soul-Trader's Pauldrons
	[38287]="0:4:4:1:Trinket::1:0:", -- Empty Mug of Direbrew
	[38288]="0:4:4:1:Trinket::1:0:", -- Direbrew Hops
	[38289]="0:4:4:1:Trinket::1:0:", -- Coren's Lucky Coin
	[38290]="0:4:4:1:Trinket::1:0:", -- Dark Iron Smoking Pipe
	[38291]="0:0:3:5:Consumable::1:0:", -- Ethereal Mutagen
	[38293]="0:4:2:1:OffHandFrill::1:0:", -- Suntouched Flowers
	[38294]="0:0:1:10:Consumable::1:0:", -- Ethereal Liqueur
	[38295]="0:4:2:1:Idol::1:0:", -- Idol of the Wastes
	[38300]="0:0:3:5:Consumable::1:0:", -- Diluted Ethereum Essence
	[38301]="0:15:3:1:Other::1:0:", -- D.I.S.C.O.
	[38302]="0:12:1:1:::1:0:", -- Ruby Beacon of the Dragon Queen
	[38303]="0:12:1:10:::1:0:", -- Enduring Mojo
	[38305]="0:12:1:1:::1:0:", -- Scythe of Antiok
	[38308]="0:0:1:5:Other::1:0:", -- Ethereal Essence Sphere
	[38309]="0:4:4:1:Tabard::1:0:", -- Tabard of Nature
	[38310]="0:4:4:1:Tabard::1:0:", -- Tabard of the Arcane
	[38311]="0:4:4:1:Tabard::1:0:", -- Tabard of the Void
	[38312]="0:4:4:1:Tabard::1:0:", -- Tabard of Brilliance
	[38313]="0:4:4:1:Tabard::1:0:", -- Tabard of Fury
	[38314]="0:4:4:1:Tabard::1:0:", -- Tabard of the Defender
	[38318]="0:4:2:1:Cloth::1:0:", -- Darkmoon Robe
	[38319]="0:12:1:1:::1:0:", -- New Deployment Orders
	[38320]="0:0:1:1:Consumable::1:0:", -- Dire Brew
	[38321]="0:12:1:1:::1:0:", -- Strange Mojo
	[38322]="0:4:4:1:OffHandFrill::1:0:", -- Iron-bound Tome
	[38323]="0:12:1:3:::1:0:", -- Water Elemental Link
	[38324]="0:12:1:1:::1:0:", -- Tether to the Plane of Water
	[38325]="0:12:1:3:::1:0:", -- Precious Elemental Fluids
	[38326]="0:12:1:10:::1:0:", -- Muddlecap Fungus
	[38327]="5000:9:1:1:Tailoring::1:0:15165", -- Pattern: Haliscan Jacket
	[38328]="4500:9:1:1:Tailoring::1:0:15165", -- Pattern: Haliscan Pantaloons
	[38329]="0:12:1:1:::1:0:", -- Don Carlos' Hat
	[38330]="0:12:1:1:::1:0:", -- Crusader's Bandage
	[38332]="0:12:1:1:::1:0:", -- Modified Mojo
	[38333]="0:12:1:10:::1:0:", -- Drakkari Medallion
	[38334]="0:12:1:1:::1:0:", -- Flying Machine Engine
	[38335]="0:12:1:1:::1:0:", -- Ancient Ectoplasm
	[38336]="0:12:1:1:::1:0:", -- Crystallized Hogsnot
	[38337]="0:12:1:1:::1:0:", -- Speckled Guano
	[38338]="0:12:1:1:::1:0:", -- Knotroot
	[38339]="0:12:1:1:::1:0:", -- Withered Batwing
	[38340]="0:12:1:1:::1:0:", -- Amberseed
	[38341]="0:12:1:1:::1:0:", -- Pickled Eagle Egg
	[38342]="0:12:1:1:::1:0:", -- Trollbane
	[38343]="0:12:1:1:::1:0:", -- Prismatic Mojo
	[38344]="0:12:1:1:::1:0:", -- Shrunken Dragon's Claw
	[38345]="0:12:1:1:::1:0:", -- Frozen Spider Ichor
	[38346]="0:12:1:1:::1:0:", -- Chilled Serpent Mucus
	[38347]="0:1:3:1:MiningBag::1:0:", -- Mammoth Mining Bag
	[38348]="0:15:0:20:Junk::1:0:", -- Damaged Eye
	[38349]="0:12:1:10:::1:0:", -- Venture Co. Spare Parts
	[38350]="0:0:1:10:FoodDrink::1:0:25206", -- Winterfin "Depth Charge"
	[38351]="0:0:1:20:Potion::1:0:25206", -- Murliver Oil
	[38353]="0:4:3:1:Cloak::1:0:27730,27760", -- Venture Bay Buccaneer's Cape
	[38354]="0:4:3:1:Cloak::1:0:27730,27760", -- Oil-Stained Tarp
	[38355]="0:4:3:1:Cloak::1:0:27730,27760", -- Thick Goblin Back Protector 
	[38356]="0:2:3:1:Wand::1:0:27730,27760", -- Venture Battle Wand
	[38357]="0:2:3:1:Thrown::1:0:27730,27760", -- Sharpened Throwing Gizmo
	[38358]="0:4:3:1:Trinket::1:0:27730,27760", -- Arcane Revitalizer
	[38359]="0:4:3:1:Trinket::1:0:27730,27760", -- Goblin Repetition Reducer
	[38360]="0:4:3:1:Idol::1:0:27730,27760", -- Idol of Arcane Terror
	[38361]="0:4:3:1:Totem::1:0:27730,27760", -- Venture Co. Lightning Rod
	[38362]="0:4:3:1:Libram::1:0:27730,27760", -- Venture Co. Libram of Retribution
	[38363]="0:4:3:1:Libram::1:0:27730,27760", -- Venture Co. Libram of Protection
	[38364]="0:4:3:1:Libram::1:0:27730,27760", -- Venture Co. Libram of Mostly Holy Deeds
	[38365]="0:4:3:1:Idol::1:0:27730,27760", -- Idol of Perspicacious Attacks
	[38366]="0:4:3:1:Idol::1:0:27730,27760", -- Idol of Pure Thoughts
	[38367]="0:4:3:1:Totem::1:0:27730,27760", -- Venture Co. Flame Slicer
	[38368]="0:4:3:1:Totem::1:0:27730,27760", -- Totem of the Bay
	[38369]="0:12:1:1:::1:0:", -- Wasp's Wings
	[38370]="0:12:1:1:::1:0:", -- Raptor Claw
	[38371]="0:0:3:20:EnhPerm::1:0:", -- Jormungar Leg Armor
	[38372]="0:0:3:20:EnhPerm::1:0:", -- Nerubian Leg Armor
	[38373]="0:0:4:20:EnhPerm::1:0:", -- Frosthide Leg Armor
	[38374]="0:0:4:20:EnhPerm::1:0:", -- Icescale Leg Armor
	[38375]="0:0:1:10:EnhPerm::1:0:", -- Borean Armor Kit
	[38376]="0:0:2:10:EnhPerm::1:0:", -- Heavy Borean Armor Kit
	[38379]="0:12:1:1:::1:0:", -- Crushed Basilisk Crystals
	[38380]="0:12:1:250:::1:0:", -- Zul'Drak Rat
	[38381]="0:12:1:1:::1:0:", -- Seasoned Slider Cider
	[38382]="0:12:1:20:::1:0:", -- Basilisk Crystals
	[38384]="0:12:1:1:::1:0:", -- Pulverized Gargoyle Teeth
	[38386]="0:12:1:1:::1:0:", -- Muddy Mire Maggot
	[38393]="0:12:1:1:::1:0:", -- Spiky Spider Egg
	[38396]="0:12:1:1:::1:0:", -- Hairy Herring Head
	[38397]="0:12:1:1:::1:0:", -- Putrid Pirate Perspiration
	[38398]="0:12:1:1:::1:0:", -- Icecrown Bottled Water
	[38399]="0:1:3:1:LeatherworkingBag::1:0:", -- Trapper's Traveling Pack
	[38400]="0:4:2:1:Leather::1:0:", -- Arctic Chestpiece
	[38401]="0:4:2:1:Leather::1:0:", -- Arctic Leggings
	[38402]="0:4:2:1:Leather::1:0:", -- Arctic Shoulderpads
	[38403]="0:4:2:1:Leather::1:0:", -- Arctic Gloves
	[38404]="0:4:2:1:Leather::1:0:", -- Arctic Boots
	[38405]="0:4:2:1:Leather::1:0:", -- Arctic Belt
	[38406]="0:4:2:1:Leather::1:0:", -- Iceborne Belt
	[38407]="0:4:2:1:Leather::1:0:", -- Iceborne Boots
	[38408]="0:4:2:1:Leather::1:0:", -- Iceborne Chestguard
	[38409]="0:4:2:1:Leather::1:0:", -- Iceborne Gloves
	[38410]="0:4:2:1:Leather::1:0:", -- Iceborne Leggings
	[38411]="0:4:2:1:Leather::1:0:", -- Iceborne Shoulderpads
	[38412]="0:4:2:1:Mail::1:0:", -- Frostscale Belt
	[38413]="0:4:2:1:Mail::1:0:", -- Frostscale Boots
	[38414]="0:4:2:1:Mail::1:0:", -- Frostscale Chestguard
	[38415]="0:4:2:1:Mail::1:0:", -- Frostscale Gloves
	[38416]="0:4:2:1:Mail::1:0:", -- Frostscale Leggings
	[38417]="0:4:2:1:Mail::1:0:", -- Nerubian Shoulders
	[38418]="0:4:2:1:Mail::1:0:", -- Nerubian Belt
	[38419]="0:4:2:1:Mail::1:0:", -- Nerubian Boots
	[38420]="0:4:2:1:Mail::1:0:", -- Nerubian Chestguard
	[38421]="0:4:2:1:Mail::1:0:", -- Nerubian Gloves
	[38422]="0:4:2:1:Mail::1:0:", -- Nerubian Legguards
	[38424]="0:4:2:1:Mail::1:0:", -- Frostscale Shoulders
	[38425]="0:7:1:20:Leather:202,165,197:1:1:14846", -- Heavy Borean Leather
	[38426]="30000:7:1:20:Cloth:197:1:0:1347,1454,1474,1672,2394,2668,2669,2670,2672,2697,2698,2699,2816,2819,2846,3005,3091,3096,3364,3366,3485,3958,4168,4189,4225,4577,4589,5128,5154,5565,5783,5944,6567,6568,6574,6576,6731,7852,7854,7940,8160,8681,11557,11874,12942,12943,12956,15165,16366,16638,16689,16748,16767,18277,18749,18754,18771,18772,19196,19213,19521,19532,19722,21085,23802,24054,24147,24188,24341,24356,26374,26939,26941,27012,27021,27026,27043,27057,27063,27070,27132,27146,27184,27195,27938,28692,28718,28726,28794,28798,28806,28810,28831,28872,29270,29277,30311,30345,30438,30825,31115,32477,32639,32641,33596,33601,33635,33636,33669,33681,33684,37904,37935", -- Eternium Thread
	[38427]="5600:0:1:20:FoodDrink::5:0:9499", -- Pickled Egg
	[38428]="8000:0:1:20:FoodDrink::5:0:9499", -- Rock-Salted Pretzel
	[38429]="4000:0:1:20:FoodDrink::5:0:9499", -- Blackrock Spring Water
	[38430]="5600:0:1:20:FoodDrink::5:0:9499", -- Blackrock Mineral Water
	[38431]="6400:0:1:20:FoodDrink::5:0:9499", -- Blackrock Fortified Water
	[38432]="1500:0:1:20:FoodDrink::1:0:9499", -- Plugger's Blackrock Ale
	[38433]="0:4:2:1:Leather::1:0:", -- Arctic Wristguards
	[38434]="0:4:2:1:Leather::1:0:", -- Iceborne Wristguards
	[38435]="0:4:2:1:Mail::1:0:", -- Nerubian Bracers
	[38436]="0:4:2:1:Mail::1:0:", -- Frostscale Bracers
	[38437]="0:4:2:1:Leather::1:0:", -- Arctic Helm
	[38438]="0:4:2:1:Leather::1:0:", -- Iceborne Helm
	[38439]="0:4:2:1:Mail::1:0:", -- Nerubian Helm
	[38440]="0:4:2:1:Mail::1:0:", -- Frostscale Helm
	[38441]="0:4:3:1:Cloak::1:0:", -- Cloak of Harsh Winds
	[38452]="390472:4:3:1:Shield::1:0:32565,32774", -- Bulwark of the Warchief
	[38453]="391933:4:3:1:Shield::1:0:32564,32773", -- Shield of the Lion-hearted
	[38454]="614679:2:3:1:OneHandMace::1:0:32565,32774", -- Warsong Punisher
	[38455]="616901:2:3:1:OneHandMace::1:0:32564,32773", -- Hammer of the Alliance Vanguard
	[38456]="464388:2:3:1:Bow::1:0:32565,32774", -- Sin'dorei Recurve Bow
	[38457]="466101:2:3:1:Gun::1:0:32564,32773", -- Sawed-off Hand Cannon
	[38458]="179386:4:3:1:OffHandFrill::1:0:32565,32774", -- Darkspear Orb
	[38459]="179386:4:3:1:OffHandFrill::1:0:32564,32773", -- Orb of the Eastern Kingdoms
	[38460]="471192:2:3:1:Wand::1:0:32565,32774", -- Charged Wand of the Cleft
	[38461]="630540:2:3:1:Dagger::1:0:32565,32774", -- Warsong Shanker
	[38462]="375897:4:3:1:Shield::1:0:32565,32774", -- Warsong Stormshield 
	[38463]="377358:4:3:1:Shield::1:0:32564,32773", -- Lordaeron's Resolve 
	[38464]="443930:2:3:1:Wand::1:0:32564,32773", -- Gnomish Magician's Quill
	[38465]="594190:2:3:1:Dagger::1:0:32564,32773", -- Vanguard Soldier's Dagger
	[38466]="2000:0:1:10:FoodDrink::1:0:9499", -- Sulfuron Slammer
	[38467]="0:12:1:1:::1:0:", -- Softknuckle Poker
	[38473]="0:12:1:1:::1:0:", -- Claw of Serfex
	[38477]="0:12:1:1:::1:0:", -- Stinger of the Sapphire Queen
	[38483]="0:12:1:20:::1:0:", -- Captured Chicken
	[38504]="0:12:1:12:::1:0:", -- Skyreach Crystal Cluster
	[38505]="0:12:1:10:::1:0:", -- Intact Cobra Fang
	[38506]="0:4:3:1:Cloth::1:0:", -- Don Carlos' Famous Hat
	[38510]="0:12:1:1:::1:0:", -- Skyreach Crystal Clusters
	[38512]="0:12:1:1:::1:0:", -- Zepik's Hunting Horn
	[38513]="0:4:2:1:Leather::1:0:", -- Boarhide Leggings
	[38514]="0:12:1:20:::1:0:", -- Intact Skimmer Spinneret
	[38515]="0:12:1:1:::1:0:", -- Tangled Skein Thrower
	[38516]="0:15:0:20:Junk::1:0:", -- Blood-Gorged Thorn
	[38517]="0:15:0:20:Junk::1:0:", -- Mesmerizing Flower
	[38518]="150:0:1:24:Consumable::1:0:19196", -- Cro's Apple
	[38519]="0:12:1:1:::1:0:", -- Soo-rahm's Incense
	[38520]="0:15:0:5:Junk::1:0:", -- Diving Log
	[38521]="0:12:1:1:::1:0:", -- Head of the Corrupter
	[38522]="0:12:1:1:::1:0:", -- Farunn's Horn
	[38523]="0:12:1:1:::1:0:", -- Shango's Pelt
	[38528]="0:4:2:1:Leather::1:0:", -- Legpads of the Inquisitor
	[38529]="0:4:2:1:Cloth::1:0:", -- Robe of the Justicebringer
	[38530]="0:4:3:1:Cloth::1:0:", -- Wrap of Vigorous Destruction
	[38531]="0:4:3:1:Mail::1:0:", -- Links of Righteous Persecution
	[38532]="0:4:3:1:Leather::1:0:", -- Belt of Vengeful Purification
	[38533]="0:4:3:1:Plate::1:0:", -- Girdle of Forceful Annihilation
	[38534]="0:4:3:1:Plate::1:0:", -- Purity-Anointed Warbands
	[38535]="0:4:3:1:Mail::1:0:", -- Wristguards of the Remorseful
	[38536]="0:4:3:1:Cloth::1:0:", -- Bindings of the Forceful Vanquisher
	[38537]="0:4:3:1:Leather::1:0:", -- Cuffs of the Decapitator
	[38540]="0:4:3:1:Cloth::1:0:", -- Sandals of Chaos Resolution
	[38541]="0:4:3:1:Plate::1:0:", -- Implacable Zombie Crushers
	[38542]="0:4:3:1:Mail::1:0:", -- Treads of the Valiant Struggle
	[38543]="0:4:3:1:Leather::1:0:", -- Reinforced Traveler's Boots
	[38544]="0:12:1:1:::1:0:", -- Argent Crusade Banner
	[38545]="0:3:4:1:GemRed::1:0:20278,23396", -- Bold Ornate Ruby
	[38546]="0:3:4:1:GemYellow::1:0:20278,23396", -- Gleaming Ornate Dawnstone
	[38547]="0:3:4:1:GemOrange::1:0:20278,23396", -- Inscribed Ornate Topaz
	[38548]="0:3:4:1:GemOrange::1:0:20278,23396", -- Potent Ornate Topaz
	[38549]="0:3:4:1:GemRed::1:0:20278,23396", -- Runed Ornate Ruby
	[38550]="0:3:4:1:GemYellow::1:0:20278,23396", -- Smooth Ornate Dawnstone
	[38551]="0:12:1:250:::1:0:", -- Drakkari Offerings
	[38552]="0:12:1:5:::1:0:", -- Mature Water-Poppy
	[38553]="0:12:1:10:::1:0:", -- Sandfern
	[38555]="0:13:1:4:::1:0:", -- Ritual Crystal Key
	[38556]="0:12:1:1:::1:0:", -- Incinerating Oil
	[38557]="0:7:1:20:Leather:165:1:0:", -- Icy Dragonscale
	[38558]="0:7:1:20:Leather:165:1:0:", -- Nerubian Chitin
	[38559]="0:12:1:1:::1:0:", -- Bushwhacker's Jaw
	[38560]="0:12:1:20:::1:0:", -- Plague Sprayer Parts
	[38561]="0:7:1:20:Leather:165:1:0:", -- Jormungar Scale
	[38562]="0:12:1:20:::1:0:", -- Chunk of Saronite
	[38563]="0:12:1:20:::1:0:", -- Dead Thornwood
	[38564]="0:12:1:1:::1:0:", -- Sandfern Disguise
	[38566]="0:12:1:1:::1:0:", -- Steel Spade
	[38573]="0:12:1:1:::1:0:", -- RJR Rifle
	[38574]="0:12:1:1:::1:0:", -- High Impact Grenade
	[38575]="0:12:1:8:::1:0:", -- Shiny Treasures
	[38577]="0:0:1:250:Consumable::1:0:", -- Party G.R.E.N.A.D.E.
	[38578]="0:15:3:1:Other::1:0:", -- The Flag of Ownership
	[38579]="4545:4:2:1:OffHandFrill::1:1:28347", -- Venomous Tome
	[38581]="0:15:0:10:Junk::1:0:", -- Adventurer's Skull
	[38583]="0:15:0:20:Junk::1:0:", -- Fetid Ichor
	[38584]="0:15:0:20:Junk::1:0:", -- Masticated Skull
	[38585]="0:15:0:20:Junk::1:0:", -- Scored Carapace
	[38586]="0:15:0:20:Junk::1:0:", -- Spiny Leg
	[38587]="0:0:1:1:Consumable::1:0:", -- Empty Brewfest Stein
	[38588]="0:4:3:1:Trinket::1:0:12788", -- Medallion of the Horde
	[38589]="0:4:3:1:Trinket::1:0:12778", -- Medallion of the Alliance
	[38590]="0:4:3:1:Leather::1:0:", -- Black Chitinguard Boots
	[38591]="0:4:3:1:Leather::1:0:", -- Dark Arctic Leggings
	[38592]="0:4:3:1:Leather::1:0:", -- Dark Arctic Chestpiece
	[38600]="0:12:1:6:::1:0:", -- Primordial Hatchling
	[38601]="0:12:1:1:::1:0:", -- Mistwhisper Treasure
	[38605]="0:15:0:10:Junk::1:0:", -- McCarty's Notes
	[38607]="0:12:1:1:::1:0:", -- Battle-worn Sword
	[38610]="0:12:1:20:::1:0:", -- Fresh Spider Ichor
	[38611]="0:4:3:1:Ring::1:0:", -- Ringlet of Repose
	[38613]="0:4:3:1:Amulet::1:0:", -- Chain of Fiery Orbs
	[38614]="0:4:3:1:Cloak::1:0:", -- Embrace of Sorrow
	[38615]="0:4:3:1:Mail::1:0:", -- Lightning-Charged Gloves
	[38616]="0:4:3:1:Leather::1:0:", -- Maiden's Girdle
	[38617]="0:4:3:1:Ring::1:0:", -- Woeful Band
	[38618]="0:2:3:1:TwoHandMace::1:0:", -- Hammer of Grief
	[38619]="0:12:1:1:::1:0:", -- Goregek's Shackles
	[38620]="0:12:1:20:::1:0:", -- Unblemished Bat Wing
	[38621]="0:12:1:1:::1:0:", -- Dajik's Worn Chalk
	[38622]="0:12:1:1:::1:0:", -- Lafoo's Bug Bag
	[38623]="0:12:1:1:::1:0:", -- Jaloot's Favorite Crystal
	[38624]="0:12:1:1:::1:0:", -- Moodle's Stress Ball
	[38626]="0:0:0:24:Consumable::1:0:", -- Empty Brew Bottle
	[38627]="0:12:1:1:::1:0:", -- Mammoth Harness
	[38628]="400000:15:3:1:Companion::1:0:23367", -- Nether Ray Fry
	[38629]="0:0:1:1:Consumable::1:0:", -- Orders from the Lich King
	[38631]="0:12:1:1:::1:0:", -- Runebladed Sword
	[38632]="0:2:3:1:TwoHandSword::1:0:", -- Greatsword of the Ebon Blade
	[38633]="0:2:3:1:TwoHandAxe::1:0:", -- Greataxe of the Ebon Blade
	[38637]="0:12:1:1:::1:0:", -- Treasure of Kutube'sa
	[38638]="0:12:1:1:::1:0:", -- Treasure of Chulo the Mad
	[38639]="0:12:1:1:::1:0:", -- Treasure of Gawanil
	[38640]="0:0:1:20:Bandage::1:0:", -- Dense Frostweave Bandage
	[38642]="0:12:1:1:::1:0:", -- Golden Engagement Ring
	[38643]="0:0:1:20:Bandage::1:0:", -- Thick Frostweave Bandage
	[38645]="49791:4:1:1:Plate::1:0:28500", -- Bone-Plated Armor
	[38646]="25129:4:1:1:Plate::1:0:28500", -- Bone-Plated Belt
	[38647]="37540:4:1:1:Plate::1:0:28500", -- Bone-Plated Boots
	[38648]="25309:4:1:1:Plate::1:0:28500", -- Bone-Plated Bracers
	[38649]="25400:4:1:1:Plate::1:0:28500", -- Bone-Plated Gloves
	[38650]="37944:4:1:1:Plate::1:0:28500", -- Bone-Plated Helm
	[38651]="50870:4:1:1:Plate::1:0:28500", -- Bone-Plated Leggings
	[38653]="0:12:1:10:::1:0:", -- Banana Bunch
	[38654]="0:12:1:1:::1:0:", -- Corvus' Report
	[38655]="0:12:1:10:::1:0:", -- Papaya
	[38656]="0:12:1:10:::1:0:", -- Orange
	[38657]="0:0:1:1:Consumable::1:0:", -- Freya's Ward
	[38658]="0:15:3:1:Companion::1:0:", -- Vampiric Batling
	[38659]="0:12:1:1:::1:0:", -- Stefan's Steel Toed Boot
	[38660]="0:12:1:1:::1:0:", -- Unliving Choker
	[38661]="0:4:3:1:Plate::1:0:", -- Greathelm of the Scourge Champion
	[38662]="0:4:3:1:Amulet::1:0:", -- Bladed Ebon Amulet
	[38663]="0:4:3:1:Plate::1:0:", -- Blood-soaked Saronite Plated Spaulders
	[38664]="0:4:3:1:Cloak::1:0:", -- Sky Darkener's Shroud of the Unholy
	[38665]="0:4:3:1:Plate::1:0:", -- Saronite War Plate
	[38666]="0:4:3:1:Plate::1:0:", -- Plated Saronite Bracers
	[38667]="0:4:3:1:Plate::1:0:", -- Bloodbane's Gauntlets of Command
	[38668]="0:4:3:1:Plate::1:0:", -- The Plaguebringer's Girdle
	[38669]="0:4:3:1:Plate::1:0:", -- Engraved Saronite Legplates
	[38670]="0:4:3:1:Plate::1:0:", -- Greaves of the Slaughter
	[38671]="0:4:3:1:Ring::1:0:", -- Valanar's Signet Ring
	[38672]="0:4:3:1:Ring::1:0:", -- Keleseth's Signet Ring
	[38673]="0:12:1:1:::1:0:", -- Writhing Choker
	[38674]="0:4:3:1:Trinket::1:0:", -- Soul Harvester's Charm
	[38675]="0:4:3:1:Trinket::1:0:", -- Signet of the Dark Brotherhood
	[38676]="0:12:1:1:::1:0:", -- Whisker of Har'koa
	[38677]="0:12:1:20:::1:0:", -- Har'koan Relic
	[38678]="0:12:1:1:::1:0:", -- Unliving Choker
	[38679]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Minor Health
	[38680]="0:12:1:1:::1:0:", -- Writhing Choker
	[38681]="0:12:1:20:::1:0:", -- Essence of the Frozen Earth
	[38682]="0:7:1:20:EnchArmor::1:0:", -- Armor Vellum
	[38684]="0:12:1:1:::1:0:", -- Freya's Horn
	[38686]="0:12:1:10:::1:0:", -- Putrid Abomination Guts
	[38687]="0:12:1:5:::1:0:", -- Gooey Ghoul Drool
	[38688]="0:12:1:1:::1:0:", -- Thunderbrew's Jungle Punch
	[38689]="0:12:1:1:::1:0:", -- Chicken Net
	[38695]="0:12:1:1:::1:0:", -- Arctic Bear God Mojo
	[38696]="0:12:1:1:::1:0:", -- Tormentor's Incense
	[38697]="0:12:1:1:::1:0:", -- Jungle Punch Sample
	[38698]="8500:0:1:20:FoodDrink::5:0:28589", -- Bitter Plasma
	[38699]="0:12:1:1:::1:0:", -- Ensorcelled Choker
	[38700]="0:12:1:20:::1:0:", -- Rhunokian Artifact
	[38701]="0:12:1:1:::1:0:", -- Bowels and Brains Bowl
	[38703]="0:12:1:1:::1:0:", -- Pitch's Remains
	[38705]="0:12:1:10:::1:0:", -- Roc Egg
	[38706]="16000:0:1:20:FoodDrink::5:0:28589", -- Bowels 'n' Brains
	[38707]="0:2:3:1:TwoHandSword::1:0:", -- Runed Soulblade
	[38708]="0:12:1:1:::1:0:", -- Omega Rune
	[38709]="0:12:1:1:::1:0:", -- Omega Rune
	[38710]="0:4:2:1:Cloth::1:0:", -- Wayfinder's Bracers
	[38711]="0:4:2:1:Cloth::1:0:", -- Grounded Gloves
	[38712]="0:4:2:1:Cloth::1:0:", -- Headbinder's Crown
	[38713]="0:4:2:1:Cloth::1:0:", -- Spaulders of Foresight
	[38714]="0:4:2:1:Cloth::1:0:", -- Path-Cutter's Cord
	[38715]="0:4:2:1:Cloth::1:0:", -- Forge-Scarred Sandals
	[38716]="0:4:2:1:Cloth::1:0:", -- Ethereal Hood
	[38717]="0:4:2:1:Cloth::1:0:", -- Dusty Miner's Leggings
	[38718]="0:4:2:1:Cloth::1:0:", -- Wispy Shoulderpads
	[38719]="0:4:2:1:Cloth::1:0:", -- Robe of Expurgation
	[38726]="0:4:2:1:Cloth::1:0:", -- Instigator's Gloves
	[38727]="0:4:2:1:Cloth::1:0:", -- Foreseer's Girdle
	[38728]="0:4:2:1:Cloth::1:0:", -- Kilt of Peaceful Reclamation
	[38729]="0:4:2:1:Cloth::1:0:", -- Sandals of Quick Escape
	[38730]="0:4:2:1:Cloth::1:0:", -- Bell-Ringer's Shoulderpads
	[38731]="0:12:1:1:::1:0:", -- Ahunae's Knife
	[38732]="0:4:2:1:Cloth::1:0:", -- Bramble-Proof Leggings
	[38733]="0:4:2:1:Cloth::1:0:", -- Raiment of the Caged Beast
	[38734]="0:4:2:1:Cloth::1:0:", -- Abandoned Hood
	[38735]="0:4:2:1:Cloth::1:0:", -- Specially Treated Robes
	[38736]="0:4:2:1:Cloth::1:0:", -- Smuggler's Bracers
	[38737]="0:4:2:1:Cloth::1:0:", -- Shock-Proof Head Protector
	[38739]="0:4:2:1:Cloth::1:0:", -- Fleshwerk Shackles
	[38741]="0:4:2:1:Cloth::1:0:", -- Gloves of Tormented Recollection
	[38743]="0:4:2:1:Ring::1:0:", -- Band of the Tender
	[38744]="0:4:2:1:Ring::1:0:", -- Solstice Signet
	[38745]="0:4:2:1:Ring::1:0:", -- Fetid Loop
	[38746]="0:4:2:1:Ring::1:0:", -- Rancid Signet
	[38747]="0:4:2:1:Ring::1:0:", -- Mildly Tarnished Ring
	[38748]="0:4:2:1:Ring::1:0:", -- Seal of the Slumbering Wolf
	[38749]="0:4:2:1:Ring::1:0:", -- Thane-Reaper's Signet
	[38750]="0:4:2:1:Ring::1:0:", -- Worgslayer's Ring
	[38751]="0:4:2:1:Amulet::1:0:", -- Vengeful Spirit Beads
	[38752]="0:4:2:1:Amulet::1:0:", -- Tatjana's Pendant
	[38753]="0:4:2:1:Amulet::1:0:", -- Hoarder's Necklace
	[38754]="0:4:2:1:Amulet::1:0:", -- Pruning Pendant
	[38755]="0:4:2:1:OffHandFrill::1:0:", -- Scepter of Passionate Reprisal
	[38756]="0:4:2:1:Cloak::1:0:", -- Drape of Horticultural Sanitization
	[38757]="0:4:2:1:Cloak::1:0:", -- Drape of the Possessive Soul
	[38758]="0:4:2:1:Cloak::1:0:", -- Therapeutic Cloak
	[38759]="0:4:2:1:Cloak::1:0:", -- Injured Trapper's Cloak
	[38760]="0:4:2:1:Trinket::1:0:", -- Mendicant's Charm
	[38761]="0:4:2:1:Trinket::1:0:", -- Talon of Hatred
	[38762]="0:4:2:1:Trinket::1:0:", -- Insignia of Bloody Fire
	[38763]="0:4:2:1:Trinket::1:0:", -- Futuresight Rune
	[38764]="0:4:2:1:Trinket::1:0:", -- Rune of Finite Variation
	[38765]="0:4:2:1:Trinket::1:0:", -- Rune of Infinite Power
	[38766]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Minor Health
	[38767]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Minor Absorption
	[38768]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Minor Deflection
	[38769]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Minor Mana
	[38770]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Minor Resistance
	[38771]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Minor Stamina
	[38772]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Minor Impact
	[38773]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Lesser Health
	[38774]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Minor Spirit
	[38775]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Minor Protection
	[38776]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Lesser Mana
	[38777]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Minor Agility
	[38778]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Minor Strength
	[38779]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Minor Beastslayer
	[38780]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Minor Striking
	[38781]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Lesser Intellect
	[38782]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Health
	[38783]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Lesser Spirit
	[38784]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Lesser Fire Resistance
	[38785]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Minor Stamina
	[38786]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Minor Agility
	[38787]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Minor Stamina
	[38788]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Lesser Spirit
	[38789]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Minor Agility
	[38790]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Lesser Protection
	[38791]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Lesser Protection
	[38792]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Lesser Spirit
	[38793]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Lesser Stamina
	[38794]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Lesser Striking
	[38795]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Lesser Shadow Resistance
	[38796]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Lesser Impact
	[38797]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Lesser Strength
	[38798]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Lesser Absorption
	[38799]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Mana
	[38800]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Mining
	[38801]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Herbalism
	[38802]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Fishing
	[38803]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Lesser Intellect
	[38804]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Minor Stats
	[38805]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Lesser Stamina
	[38806]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Defense
	[38807]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Lesser Agility
	[38808]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Greater Health
	[38809]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Spirit
	[38810]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Lesser Stamina
	[38811]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Lesser Deflection
	[38812]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Stamina
	[38813]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Lesser Beastslayer
	[38814]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Lesser Elemental Slayer
	[38815]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Fire Resistance
	[38816]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Spirit
	[38817]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Strength
	[38818]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Greater Mana
	[38819]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Lesser Spirit
	[38820]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Lesser Block
	[38821]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Striking
	[38822]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Impact
	[38823]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Skinning
	[38824]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Lesser Stats
	[38825]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Greater Defense
	[38826]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Resistance
	[38827]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Agility
	[38828]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Stamina
	[38829]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Intellect
	[38830]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Stamina
	[38831]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Advanced Mining
	[38832]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Greater Spirit
	[38833]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Superior Health
	[38834]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Advanced Herbalism
	[38835]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Lesser Agility
	[38836]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Strength
	[38837]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Minor Speed
	[38838]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Fiery Weapon
	[38839]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Greater Spirit
	[38840]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Demonslaying
	[38841]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Superior Mana
	[38842]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Deflection
	[38843]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Frost Resistance
	[38844]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Agility
	[38845]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Greater Impact
	[38846]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Greater Strength
	[38847]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Stats
	[38848]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Greater Striking
	[38849]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Greater Stamina
	[38850]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Riding Skill
	[38851]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Minor Haste
	[38852]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Greater Intellect
	[38853]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Superior Spirit
	[38854]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Superior Strength
	[38855]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Superior Stamina
	[38856]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Greater Agility
	[38857]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Greater Strength
	[38858]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Greater Resistance
	[38859]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Superior Defense
	[38860]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Vitality
	[38861]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Greater Stamina
	[38862]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Greater Stamina
	[38863]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Greater Agility
	[38864]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Spirit
	[38865]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Greater Stats
	[38866]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Major Health
	[38867]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Major Mana
	[38868]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Icy Chill
	[38869]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Superior Impact
	[38870]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Superior Striking
	[38871]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Lifestealing
	[38872]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Unholy Weapon
	[38873]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Crusader
	[38874]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Major Spirit
	[38875]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Major Intellect
	[38876]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Winter's Might
	[38877]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Spellpower
	[38878]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Healing Power
	[38879]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Strength
	[38880]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Agility
	[38881]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Mana Regeneration
	[38882]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Healing Power
	[38883]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Mighty Spirit
	[38884]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Mighty Intellect
	[38885]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Threat
	[38886]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Shadow Power
	[38887]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Frost Power
	[38888]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Fire Power
	[38889]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Healing Power
	[38890]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Superior Agility
	[38891]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Greater Fire Resistance
	[38892]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Greater Nature Resistance
	[38893]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Stealth
	[38894]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Subtlety
	[38895]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Dodge
	[38896]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Agility
	[38897]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Brawn
	[38898]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Stats
	[38899]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Major Defense
	[38900]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Superior Healing
	[38901]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Restore Mana Prime
	[38902]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Fortitude
	[38903]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Spellpower
	[38904]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Tough Shield
	[38905]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Intellect
	[38906]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Shield Block
	[38907]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Resistance
	[38908]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Vitality
	[38909]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Fortitude
	[38910]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Surefooted
	[38911]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Exceptional Health
	[38912]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Exceptional Mana
	[38913]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Exceptional Stats
	[38914]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Major Armor
	[38915]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Major Resistance
	[38917]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Major Striking
	[38918]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Major Intellect
	[38919]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Savagery
	[38920]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Potency
	[38921]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Major Spellpower
	[38922]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Major Agility
	[38923]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Sunfire
	[38924]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Soulfrost
	[38925]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Mongoose
	[38926]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Spellsurge
	[38927]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Battlemaster
	[38928]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Major Spirit
	[38929]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Restore Mana Prime
	[38930]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Major Resilience
	[38931]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Blasting
	[38932]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Precise Strikes
	[38933]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Major Strength
	[38934]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Assault
	[38935]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Major Spellpower
	[38936]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Major Healing
	[38937]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Major Intellect
	[38938]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Assault
	[38939]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Spell Penetration
	[38940]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Greater Agility
	[38941]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Greater Arcane Resistance
	[38942]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Greater Shadow Resistance
	[38943]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Cat's Swiftness
	[38944]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Boar's Speed
	[38945]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Major Stamina
	[38946]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Major Healing
	[38947]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Greater Agility
	[38948]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Executioner
	[38949]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Resilience
	[38950]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Superior Frost Resistance
	[38951]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Expertise
	[38953]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Precision
	[38954]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Defense
	[38955]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Mighty Health
	[38956]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Superior Nature Resistance
	[38957]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Exceptional Striking
	[38958]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Exceptional Intellect
	[38959]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Superior Agility
	[38960]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Gatherer
	[38961]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Greater Spirit
	[38962]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Greater Mana Restoration
	[38963]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Exceptional Spirit
	[38964]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Greater Assault
	[38965]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Icebreaker
	[38966]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Greater Fortitude
	[38967]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Major Agility
	[38968]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracers - Exceptional Intellect
	[38969]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Superior Fire Resistance
	[38970]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Exceptional Healing
	[38971]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracers - Striking
	[38972]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Lifeward
	[38973]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Spell Piercing
	[38974]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Greater Vitality
	[38975]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Exceptional Resilience
	[38976]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Superior Agility
	[38977]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Superior Shadow Resistance
	[38978]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Titanweave
	[38979]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Exceptional Spellpower
	[38980]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracers - Major Spirit
	[38981]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Scourgebane
	[38982]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Superior Arcane Resistance
	[38983]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Exceptional Stamina
	[38984]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Expertise
	[38986]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Icewalker
	[38987]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracers - Greater Stats
	[38988]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Giant Slayer
	[38989]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Super Stats
	[38990]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Armsman
	[38991]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Exceptional Spellpower
	[38992]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Greater Savagery
	[38993]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Shadow Armor
	[38994]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Exceptional Healing
	[38995]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Exceptional Agility
	[38996]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracers - Major Healing
	[38997]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracers - Greater Spellpower
	[38998]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Deathfrost
	[38999]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Defense
	[39000]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Steelweave
	[39001]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Mighty Armor
	[39002]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Greater Defense
	[39003]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Greater Speed
	[39004]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Wisdom
	[39005]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Super Health
	[39006]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Tuskarr's Vitality
	[39010]="0:4:2:1:Shield::1:0:", -- Wolfslayer's Crest
	[39011]="0:4:2:1:Shield::1:0:", -- Bloody Bulwark
	[39013]="0:4:2:1:Leather::1:0:", -- Discoverer's Mitts
	[39015]="0:4:2:1:Leather::1:0:", -- Crackpot Spaulders
	[39016]="0:4:2:1:Leather::1:0:", -- Tunic of the Rectified Thane
	[39017]="0:4:2:1:Leather::1:0:", -- Belt of Keen Hearing
	[39018]="0:4:2:1:Leather::1:0:", -- Boots of Safe Travel
	[39019]="0:4:2:1:Leather::1:0:", -- Iron-Shatter Leggings
	[39020]="0:4:2:1:Leather::1:0:", -- Drakuru's Ghastly Helm
	[39021]="0:4:2:1:Leather::1:0:", -- Ectoplasm Stained Wristguards
	[39022]="0:4:2:1:Leather::1:0:", -- Helm of Rising Smoke
	[39023]="0:4:2:1:Leather::1:0:", -- Wax-Coated Chestguard
	[39025]="0:4:2:1:Leather::1:0:", -- Shackles of Sanity
	[39026]="0:4:2:1:Leather::1:0:", -- Pauldrons of the Prophet
	[39027]="0:4:2:1:Leather::1:0:", -- Leggings of Anger Management
	[39028]="0:4:2:1:Leather::1:0:", -- Coiled Leather Gauntlets
	[39029]="0:4:2:1:Leather::1:0:", -- Waistguard of Expedient Procurement
	[39030]="0:4:2:1:Leather::1:0:", -- Patchhide Pants
	[39031]="0:4:2:1:Leather::1:0:", -- Boots of Internal Strife
	[39033]="0:4:2:1:Leather::1:0:", -- Discarded Miner's Jerkin
	[39034]="0:4:2:1:Leather::1:0:", -- Bearskin Helm
	[39035]="0:4:2:1:Leather::1:0:", -- Glacier-walker's Mukluks
	[39036]="0:4:2:1:Leather::1:0:", -- Hulking Horror Tunic
	[39038]="0:4:2:1:Leather::1:0:", -- Fleshwerk Wristguards
	[39040]="0:4:2:1:Leather::1:0:", -- Gloves of Troubled Memory
	[39041]="0:12:1:1:::1:0:", -- Bat Net
	[39043]="0:4:2:1:Mail::1:0:", -- Trailbreaker's Spaulders
	[39044]="0:4:2:1:Mail::1:0:", -- Short-Circuiting Boots
	[39045]="0:4:2:1:Mail::1:0:", -- Legguards of Refuted Feudalism
	[39046]="0:4:2:1:Mail::1:0:", -- Shoulderpads of Imminent Disaster
	[39047]="0:4:2:1:Mail::1:0:", -- Legguards of Unerring Navigation
	[39048]="0:4:2:1:Mail::1:0:", -- Flame-Tested Chestguard
	[39049]="0:4:2:1:Mail::1:0:", -- Helm of Spirit Links
	[39050]="0:4:2:1:Mail::1:0:", -- Ghostridden Waistguard
	[39051]="0:4:2:1:Mail::1:0:", -- Plane-shifted Boots
	[39052]="0:4:2:1:Mail::1:0:", -- Acid-Resistant Hauberk
	[39053]="0:4:2:1:Mail::1:0:", -- Helm of the Furbolg Purifier
	[39054]="0:4:2:1:Mail::1:0:", -- Gossamer-Stained Grips
	[39055]="0:4:2:1:Mail::1:0:", -- Handguards of Extermination
	[39056]="0:4:2:1:Mail::1:0:", -- Whip-Stitched Wristguards
	[39057]="0:4:2:1:Mail::1:0:", -- Polished Staghorn Helm
	[39058]="0:4:2:1:Mail::1:0:", -- Legguards of Swift Pursuit
	[39059]="0:4:2:1:Mail::1:0:", -- Wristguard of the Tormented Soul
	[39060]="0:4:2:1:Mail::1:0:", -- Patched Trapper Pauldrons
	[39062]="0:4:2:1:Leather::1:0:", -- Herbalist's Pauldrons
	[39063]="0:12:1:20:::1:0:", -- Lifeblood Shard
	[39064]="0:4:2:1:Mail::1:0:", -- Hide-Lined Chestguard
	[39065]="0:4:2:1:Mail::1:0:", -- Skycaptain's Belt
	[39066]="0:4:2:1:Mail::1:0:", -- Leggings of the Turning Point
	[39068]="0:4:2:1:Mail::1:0:", -- Flesh-scaled Bracers
	[39070]="0:4:2:1:Mail::1:0:", -- Gloves of the Mad Bomber
	[39072]="0:4:2:1:Plate::1:0:", -- Blacksoul Protector's Hauberk
	[39073]="0:2:2:1:Wand::1:0:", -- Root of the Everlasting
	[39074]="0:4:2:1:Cloak::1:0:", -- Drape of Distilled Hatred
	[39075]="0:4:2:1:Plate::1:0:", -- Waywalker's Girdle
	[39076]="0:4:2:1:Plate::1:0:", -- Golem-Rider's Greaves
	[39077]="0:4:2:1:Plate::1:0:", -- Skull-Reshaper's Helm 
	[39078]="0:4:2:1:Plate::1:0:", -- Whispering Stompers
	[39079]="0:4:2:1:Plate::1:0:", -- Bracers of the Chaperon
	[39080]="0:4:2:1:Plate::1:0:", -- Grips of Flawed Temper
	[39081]="0:4:2:1:Plate::1:0:", -- Spiritforged Helm
	[39082]="0:4:2:1:Plate::1:0:", -- Shocksteel Shoulderguards
	[39083]="0:4:2:1:Plate::1:0:", -- Cobalt Shoulders
	[39084]="0:4:2:1:Plate::1:0:", -- Cobalt Helm
	[39085]="0:4:2:1:Plate::1:0:", -- Cobalt Chestpiece
	[39086]="0:4:2:1:Plate::1:0:", -- Cobalt Legplates
	[39087]="0:4:2:1:Plate::1:0:", -- Cobalt Belt
	[39088]="0:4:2:1:Plate::1:0:", -- Cobalt Boots
	[39089]="0:4:2:1:Plate::1:0:", -- Spiritforged Legguards
	[39090]="0:4:2:1:Plate::1:0:", -- Chestplate of Untimely Rewards
	[39091]="0:4:2:1:Plate::1:0:", -- Blood-Spattered Spaulders
	[39092]="0:4:2:1:Plate::1:0:", -- Thought-Purifying Protector
	[39093]="0:4:2:1:Plate::1:0:", -- Chestguard of Expressed Fury
	[39094]="0:4:2:1:Plate::1:0:", -- Load-Bearing Girdle
	[39095]="0:4:2:1:Plate::1:0:", -- Hammer-Holder's Gauntlets
	[39096]="0:4:2:1:Plate::1:0:", -- Snaptooth Legplates
	[39097]="0:4:2:1:Plate::1:0:", -- Sabatons of Crushed Humanity
	[39098]="0:4:2:1:Plate::1:0:", -- Rusty Cave Stompers
	[39099]="0:4:2:1:Plate::1:0:", -- Carapace of the Fallen
	[39100]="0:4:2:1:Plate::1:0:", -- Plated Bracelet of the Skies
	[39102]="0:4:2:1:Plate::1:0:", -- Icewalker's Spikes
	[39104]="0:4:2:1:Plate::1:0:", -- Hardened Bone Wrist Protectors
	[39105]="0:4:2:1:Plate::1:0:", -- Girdle of Growing Vines
	[39108]="0:4:2:1:Plate::1:0:", -- Bloodstained Helmet
	[39109]="0:2:2:1:Stave::1:0:", -- Branch of the Roaming Spirit
	[39110]="0:2:2:1:Stave::1:0:", -- Staff of Righteous Vengeance
	[39112]="0:2:2:1:FistWeapon::1:0:", -- Talon of Freedom
	[39113]="0:2:2:1:FistWeapon::1:0:", -- Jagged Troll Render
	[39114]="0:2:2:1:TwoHandAxe::1:0:", -- Axe of the Warlord's Demise
	[39115]="0:2:2:1:TwoHandAxe::1:0:", -- Axe of Bloodstained Ice
	[39116]="0:2:2:1:TwoHandMace::1:0:", -- Grinder of Reverse Emancipation
	[39117]="0:2:2:1:TwoHandSword::1:0:", -- Liberator's Blade
	[39118]="0:4:2:1:OffHandFrill::1:0:", -- Glowing Voodoo Orb
	[39119]="0:2:2:1:Gun::1:0:", -- Bondsniper
	[39120]="0:2:2:1:Stave::1:0:", -- Spire of Soaring Rumination
	[39121]="0:2:2:1:Stave::1:0:", -- Cultist's Cauldron Stirrer
	[39124]="0:4:2:1:OffHandFrill::1:0:", -- Branch of Insightful Dreams
	[39125]="0:2:2:1:Dagger::1:0:", -- Beaked Dagger
	[39127]="0:2:2:1:OneHandSword::1:0:", -- Serrated Cold-Iron Slicer
	[39128]="0:2:2:1:OneHandSword::1:0:", -- Yoke Slasher
	[39129]="0:2:2:1:Dagger::1:0:", -- Spike of Renounced Autonomy
	[39130]="0:2:2:1:Dagger::1:0:", -- Corrupter's Shanker
	[39131]="0:2:2:1:Crossbow::1:0:", -- Warbling Crossbow
	[39132]="0:2:2:1:OneHandSword::1:0:", -- Sword of the Caged Mind
	[39133]="0:2:2:1:Dagger::1:0:", -- Necrolord's Sacrificial Dagger
	[39134]="0:2:2:1:Bow::1:0:", -- Bow of Regression
	[39135]="0:2:2:1:Bow::1:0:", -- Wyrmstalker's Bow
	[39136]="0:2:2:1:OneHandAxe::1:0:", -- Reanimator's Hacker
	[39138]="0:2:2:1:Thrown::1:0:", -- Deadly Razordarts
	[39139]="0:4:4:1:Plate::1:0:", -- Ravaging Sabatons
	[39140]="0:2:4:1:Dagger::1:0:", -- Knife of Incision
	[39141]="0:4:4:1:Ring::1:0:", -- Deflection Band
	[39142]="0:2:2:1:OneHandMace::1:0:", -- Mace of Helotry
	[39143]="0:2:2:1:OneHandMace::1:0:", -- Writhing Mace
	[39144]="0:2:2:1:OneHandMace::1:0:", -- Twisted Hooligan Whacker
	[39146]="0:4:4:1:Amulet::1:0:", -- Collar of Dissolution
	[39150]="0:12:1:20:::1:0:", -- Sacred Adornment
	[39151]="0:7:1:20:Other:773:1:0:", -- Alabaster Pigment
	[39152]="0:9:2:1:FirstAid::1:0:", -- Manual: Heavy Frostweave Bandage
	[39153]="0:9:0:1:FirstAid::1:0:", -- Manual: Dense Frostweave Bandage
	[39154]="0:12:1:1:::1:0:", -- Diluting Additive
	[39156]="0:12:1:20:::1:0:", -- Underworld Power Fragment
	[39157]="0:12:1:1:::1:0:", -- Scepter of Suggestion
	[39158]="0:12:1:1:::1:0:", -- Quetz'lun's Hexxing Stick
	[39159]="0:12:1:10:::1:0:", -- Harvested Blight Crystal
	[39160]="0:12:1:15:::1:0:", -- Saronite Arrow
	[39161]="0:12:1:5:::1:0:", -- Twisted Roc Talon
	[39162]="0:12:1:1:::1:0:", -- Broodmother Slivina's Skull
	[39164]="0:12:1:1:::1:0:", -- Sample Container
	[39165]="0:12:1:1:::1:0:", -- Explosive Charges
	[39166]="0:12:1:1:::1:0:", -- Underworld Power Fragments
	[39167]="0:12:1:20:::1:0:", -- Blood of Mam'toth
	[39168]="0:4:3:1:Plate::1:0:", -- Worg-Rendering Shoulderguards
	[39169]="0:4:3:1:Mail::1:0:", -- Keen Razorfang Spaulders
	[39170]="0:4:3:1:Cloth::1:0:", -- Furred Worgslayer Spaulders
	[39171]="0:4:3:1:Leather::1:0:", -- Fangsever Shoulderguards
	[39172]="0:4:3:1:Plate::1:0:", -- Bone-Polished Iceplate Shoulders
	[39173]="0:4:3:1:Shield::1:0:", -- Bulwark of the Tormented God
	[39174]="0:4:3:1:Plate::1:0:", -- Legguards of Dissolved Hope
	[39175]="0:4:3:1:Plate::1:0:", -- Leggings of Forceful Purification
	[39176]="0:4:3:1:Cloth::1:0:", -- Kilt of Deific Torment
	[39177]="0:4:3:1:Leather::1:0:", -- Pants of Purified Wind
	[39178]="0:4:3:1:Mail::1:0:", -- Greaves of Sanctified Dissolution
	[39179]="0:4:3:1:Plate::1:0:", -- Charged Earthlink Grips
	[39180]="0:4:3:1:Plate::1:0:", -- Handguards of the Sanguine Gladiator
	[39181]="0:4:3:1:Cloth::1:0:", -- Grips of Torrential Power
	[39182]="0:4:3:1:Mail::1:0:", -- Handguards of Deluded Might
	[39183]="0:4:3:1:Leather::1:0:", -- Shining Buckle Gauntlets
	[39187]="0:12:1:1:::1:0:", -- Quetz'lun's Ritual
	[39188]="0:4:4:1:Plate::1:0:", -- Chivalric Chestguard
	[39189]="0:4:4:1:Mail::1:0:", -- Boots of Persistence
	[39190]="0:4:4:1:Cloth::1:0:", -- Agonal Sash
	[39191]="0:4:4:1:Leather::1:0:", -- Splint-Bound Leggings
	[39192]="0:4:4:1:Cloth::1:0:", -- Gloves of Dark Gestures
	[39193]="0:4:4:1:Ring::1:0:", -- Band of Neglected Pleas
	[39194]="0:4:4:1:Mail::1:0:", -- Rusted-Link Spiked Gauntlets
	[39195]="0:4:4:1:Plate::1:0:", -- Bracers of Lost Sentiments
	[39196]="0:4:4:1:Leather::1:0:", -- Boots of the Worshiper
	[39197]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Master
	[39198]="0:4:4:1:Plate::1:0:", -- Frostblight Pauldrons
	[39199]="0:4:4:1:OffHandFrill::1:0:", -- Watchful Eye
	[39200]="0:2:4:1:OneHandSword::1:0:", -- Grieving Spellblade
	[39201]="0:15:0:5:Junk::1:0:", -- Dirt Stained Rags
	[39202]="0:2:0:1:Polearm::1:0:", -- Rusted Pitchfork
	[39203]="0:15:0:5:Junk::1:0:", -- Mangled Diary
	[39204]="0:15:0:5:Junk::1:0:", -- Barely Readable Diary
	[39205]="0:4:0:1:Cloth::1:0:", -- Sole-Less Boots
	[39206]="0:12:1:1:::1:0:", -- Scepter of Empowerment
	[39207]="0:15:0:5:Junk::1:0:", -- Ragweed
	[39208]="0:4:3:1:Sigil::1:0:", -- Sigil of the Dark Rider
	[39209]="0:15:0:10:Junk::1:0:", -- Scintillating Stone Shard
	[39210]="0:15:0:5:Junk::1:0:", -- Shattered Stone
	[39211]="0:15:0:20:Junk::1:0:", -- Serrated Fang
	[39212]="0:15:0:20:Junk::1:0:", -- Indurate Claw
	[39213]="0:0:1:10:Other::1:0:", -- Massive Seaforium Charge
	[39215]="0:4:4:1:Leather::1:0:", -- Boots of the Follower
	[39216]="0:4:4:1:Cloth::1:0:", -- Sash of Mortal Desire
	[39217]="0:4:4:1:Mail::1:0:", -- Avenging Combat Leggings
	[39218]="0:15:0:20:Junk::1:0:", -- Reticulated Fang
	[39219]="0:15:0:20:Junk::1:0:", -- Sawtooth Talon
	[39220]="0:15:0:20:Junk::1:0:", -- Geodesic Fragments
	[39221]="0:2:4:1:Polearm::1:0:", -- Wraith Spear
	[39222]="0:15:0:20:Junk::1:0:", -- Severed Flipper
	[39223]="0:15:0:20:Junk::1:0:", -- Colossal Jaws
	[39224]="0:4:4:1:Leather::1:0:", -- Leggings of Discord
	[39225]="0:4:4:1:Cloak::1:0:", -- Cloak of Armed Strife
	[39226]="0:2:4:1:OneHandMace::1:0:", -- Maexxna's Femur
	[39227]="0:13:1:1:::1:0:", -- Huge Stone Key
	[39228]="0:4:4:1:Plate::1:0:", -- Web Cocoon Grips
	[39229]="0:4:4:1:Trinket::1:0:", -- Embrace of the Spider
	[39230]="0:4:4:1:Leather::1:0:", -- Spaulders of the Monstrosity
	[39231]="0:4:4:1:Ring::1:0:", -- Timeworn Silken Band
	[39232]="0:4:4:1:Amulet::1:0:", -- Pendant of Lost Vocations
	[39233]="0:4:4:1:Shield::1:0:", -- Aegis of Damnation
	[39234]="0:4:4:1:Plate::1:0:", -- Plague-Impervious Boots
	[39235]="0:4:4:1:Plate::1:0:", -- Bone-Framed Bracers
	[39236]="0:4:4:1:Mail::1:0:", -- Trespasser's Boots
	[39237]="0:4:4:1:Leather::1:0:", -- Spaulders of Resumed Battle
	[39238]="0:12:1:1:::1:0:", -- Scepter of Command
	[39239]="0:4:4:1:Plate::1:0:", -- Chestplate of the Risen Soldier
	[39240]="0:4:4:1:Leather::1:0:", -- Noth's Curse
	[39241]="0:4:4:1:Cloak::1:0:", -- Dark Shroud of the Scourge
	[39242]="0:4:4:1:Cloth::1:0:", -- Robes of Hoarse Breaths
	[39243]="0:4:4:1:Mail::1:0:", -- Handgrips of the Foredoomed
	[39244]="0:4:4:1:Ring::1:0:", -- Ring of the Fated
	[39245]="0:2:4:1:TwoHandMace::1:0:", -- Demise
	[39246]="0:4:4:1:Amulet::1:0:", -- Amulet of Autopsy
	[39247]="0:4:4:1:Leather::1:0:", -- Cuffs of Dark Shadows
	[39248]="0:4:4:1:Mail::1:0:", -- Tunic of the Lost Pack
	[39249]="0:4:4:1:Plate::1:0:", -- Shoulderplates of Bloodshed
	[39250]="0:4:4:1:Ring::1:0:", -- Ring of Holy Cleansing
	[39251]="0:4:4:1:Mail::1:0:", -- Necrogenic Belt
	[39252]="0:4:4:1:Cloth::1:0:", -- Preceptor's Bindings
	[39253]="0:12:1:1:::1:0:", -- Gift of the Harvester
	[39254]="0:4:4:1:Cloth::1:0:", -- Saltarello Shoes
	[39255]="0:2:4:1:Stave::1:0:", -- Staff of the Plague Beast
	[39256]="0:2:4:1:Stave::1:0:", -- Sulfur Stave
	[39257]="0:4:4:1:Trinket::1:0:", -- Loatheb's Shadow
	[39258]="0:4:4:1:Plate::1:0:", -- Legplates of Inescapable Death
	[39259]="0:4:4:1:Leather::1:0:", -- Fungi-Stained Coverings
	[39260]="0:4:4:1:Plate::1:0:", -- Helm of the Corrupted Mind
	[39261]="0:4:4:1:Plate::1:0:", -- Tainted Girdle of Mending
	[39262]="0:4:4:1:Plate::1:0:", -- Gauntlets of Combined Strength
	[39264]="0:13:1:1:::1:0:", -- Vic's Keys
	[39265]="0:12:1:1:::1:0:", -- Oracle Blood
	[39266]="0:12:1:1:::1:0:", -- Tainted Crystal
	[39267]="0:4:4:1:Plate::1:0:", -- Abomination Shoulderblades
	[39268]="0:12:1:1:::1:0:", -- Medallion of Mam'toth
	[39269]="0:12:1:1:::1:0:", -- Prince Valanar's Report
	[39270]="0:2:4:1:OneHandSword::1:0:", -- Hatestrike
	[39271]="0:2:4:1:Dagger::1:0:", -- Blade of Dormant Memories
	[39272]="0:4:4:1:Cloak::1:0:", -- Drape of Surgery
	[39273]="0:4:4:1:Cloth::1:0:", -- Sullen Cloth Boots
	[39274]="0:4:4:1:Mail::1:0:", -- Retcher's Shoulderpads
	[39275]="0:4:4:1:Leather::1:0:", -- Contagion Gloves
	[39276]="0:4:4:1:Shield::1:0:", -- The Skull of Ruin
	[39277]="0:4:4:1:Ring::1:0:", -- Sealing Ring of Grobbulus
	[39278]="0:4:4:1:Mail::1:0:", -- Bands of Anxiety
	[39279]="0:4:4:1:Leather::1:0:", -- Blistered Belt of Decay
	[39280]="0:4:4:1:Plate::1:0:", -- Leggings of Innumerable Barbs
	[39281]="0:2:4:1:OneHandMace::1:0:", -- Infection Repulser
	[39282]="0:4:4:1:Amulet::1:0:", -- Bone-Linked Amulet
	[39283]="0:4:4:1:Leather::1:0:", -- Putrescent Bands
	[39284]="0:4:4:1:Cloth::1:0:", -- Miasma Mantle
	[39285]="0:4:4:1:Cloth::1:0:", -- Handgrips of Turmoil
	[39286]="0:15:3:1:Companion::1:0:", -- Frosty's Collar
	[39291]="0:2:4:1:OneHandSword::1:0:", -- Torment of the Banished
	[39292]="0:4:4:1:Trinket::1:0:", -- Repelling Charge
	[39293]="0:4:4:1:Plate::1:0:", -- Blackened Legplates of Feugen
	[39294]="0:4:4:1:Mail::1:0:", -- Arc-Scorched Helmet
	[39295]="0:4:4:1:Cloth::1:0:", -- Cowl of Sheet Lightning
	[39296]="0:2:4:1:Bow::1:0:", -- Accursed Bow of the Elite
	[39297]="0:4:4:1:Cloak::1:0:", -- Cloak of Darkening
	[39298]="0:4:4:1:Plate::1:0:", -- Waistguard of the Tutor
	[39299]="0:4:4:1:Leather::1:0:", -- Rapid Attack Gloves
	[39301]="0:12:1:20:::1:0:", -- Zol'Maz Stronghold Cache
	[39305]="0:12:1:255:::1:0:", -- Tiki Hex Remover
	[39306]="0:4:4:1:Plate::1:0:", -- Plated Gloves of Relief
	[39307]="0:4:4:1:Mail::1:0:", -- Iron Rings of Endurance
	[39308]="0:4:4:1:Leather::1:0:", -- Girdle of Lenience
	[39309]="0:4:4:1:Cloth::1:0:", -- Leggings of the Instructor
	[39310]="0:4:4:1:Cloth::1:0:", -- Mantle of the Extensive Mind
	[39311]="0:4:4:1:OffHandFrill::1:0:", -- Scepter of Murmuring Spirits
	[39313]="0:12:1:1:::1:0:", -- Yara's Sword
	[39314]="0:12:1:1:::1:0:", -- Tiki Dervish Ceremony
	[39315]="0:12:1:1:::1:0:", -- Drek'Maz's Tiki
	[39316]="0:12:1:1:::1:0:", -- Tiri's Magical Incantation
	[39317]="0:15:0:1:Junk::1:0:", -- News From The North
	[39318]="0:13:1:1:::1:0:", -- Key of Warlord Zol'Maz
	[39319]="0:12:1:1:::1:0:", -- Scepter of Domination
	[39320]="0:4:3:1:Cloak::1:0:", -- Sky Darkener's Shroud of Blood
	[39322]="0:4:3:1:Cloak::1:0:", -- Shroud of the North Wind
	[39323]="0:4:2:1:Cloth::1:0:", -- Scrap-Hide Spaulders
	[39324]="0:12:1:1:::1:0:", -- Empty Cauldron
	[39326]="0:12:1:1:::1:0:", -- Iron Chain
	[39327]="0:0:1:20:Potion::1:0:", -- Noth's Special Brew
	[39328]="0:12:1:200:::1:0:", -- Crusader Skull
	[39329]="0:12:1:1:::1:0:", -- Pile of Crusader Skulls
	[39330]="0:4:2:1:Cloth::1:0:", -- Fingers of Dextrous Decimation
	[39331]="0:4:2:1:Cloth::1:0:", -- Tooth-Marked Girdle
	[39332]="0:4:2:1:Cloth::1:0:", -- Ogre-Crushing Wristguards
	[39333]="0:4:2:1:Cloth::1:0:", -- Nimblefoot Moccasins
	[39334]="0:7:1:20:Other:773:1:0:", -- Dusky Pigment
	[39335]="0:4:2:1:Cloth::1:0:", -- Leggings of Mending Fronds
	[39336]="0:4:2:1:Cloth::1:0:", -- Bracers of Prompt Reclamation
	[39337]="0:4:2:1:Cloth::1:0:", -- Stained Coop Warmer
	[39338]="0:7:1:20:Other:773:1:0:", -- Golden Pigment
	[39339]="0:7:1:20:Other:773:1:0:", -- Emerald Pigment
	[39340]="0:7:1:20:Other:773:1:0:", -- Violet Pigment
	[39341]="0:7:1:20:Other:773:1:0:", -- Silvery Pigment
	[39342]="0:7:1:20:Other:773:1:0:", -- Nether Pigment
	[39343]="0:7:1:20:Other:773:1:0:", -- Azure Pigment
	[39344]="0:2:4:1:OneHandSword::1:0:", -- Slayer of the Lifeless
	[39345]="0:4:4:1:Plate::1:0:", -- Girdle of the Ascended Phantom
	[39346]="0:4:2:1:Cloth::1:0:", -- Chitin-Reinforced Hood
	[39347]="0:4:2:1:Cloth::1:0:", -- Gloves of the Crackling Storm
	[39348]="0:4:2:1:Cloth::1:0:", -- Aged Watcher's Legwraps
	[39349]="0:7:1:20:EnchWeapon::1:0:", -- Weapon Vellum
	[39350]="0:7:1:20:EnchWeapon::1:0:", -- Weapon Vellum II
	[39351]="0:15:0:5:Junk::1:0:", -- Richly Appointed Pipe
	[39353]="0:15:0:20:Junk::1:0:", -- Moon-Crescent Necklace
	[39354]="15:7:1:20:Other:773:1:0:66,777,843,960,1250,1456,1465,1692,2118,2225,2381,2393,3081,3168,3187,3482,3499,3556,3614,4194,4877,5100,5135,5817,6301,7947,8145,8934,9636,12022,12028,12043,16224,16261,16262,17490,18426,18427,23802,24054,24147,24188,24341,24356,26374,26916,26939,26941,26959,26977,26995,27012,27021,27026,27043,27057,27063,27070,27132,27143,27146,27184,27195,27938,28692,28723,28794,28806,28831,28872,29270,29277,30311,30345,30438,30723,30724,30727,30729,30730,30731,30732,30733,30734,30735,30825,31115,32477,32639,32641,33598,33638,33669,33679,37904,37935", -- Light Parchment
	[39355]="0:15:1:1:Junk::1:0:", -- Haute Club Membership Card
	[39356]="0:15:0:5:Junk::1:0:", -- Mind-Soothing Bauble
	[39357]="0:15:0:5:Junk::1:0:", -- Priestly Preening: Be Like Your Betters
	[39358]="0:15:0:5:Junk::1:0:", -- Give to the Church and the Light Will Provide
	[39360]="0:15:0:5:Junk::1:0:", -- Musings of the High General
	[39361]="0:15:0:5:Junk::1:0:", -- Turning the Other Cheek
	[39362]="0:12:1:1:::1:0:", -- New Avalon Registry
	[39363]="0:4:2:1:Cloth::1:0:", -- Binding of Purified Corpses
	[39365]="0:4:2:1:Cloth::1:0:", -- Lifewarden's Raiment
	[39366]="0:4:2:1:Cloth::1:0:", -- Spaulders of the Runeseeker
	[39367]="0:4:2:1:Cloth::1:0:", -- Cowl of the Purifier
	[39368]="0:4:2:1:Cloth::1:0:", -- Field Researcher's Boots
	[39369]="0:4:4:1:Plate::1:0:", -- Sabatons of Deathlike Gloom
	[39371]="0:2:1:1:OneHandSword::1:0:", -- Keleseth's Persuader
	[39372]="0:4:2:1:Cloth::1:0:", -- Mantle of the Dark Messenger
	[39373]="0:4:2:1:Leather::1:0:", -- Bracers of Rapid Death
	[39374]="0:4:2:1:Leather::1:0:", -- Crocscale Moccasins
	[39375]="0:4:2:1:Leather::1:0:", -- Dreadsaber Tooth Shoulderpads
	[39376]="0:4:2:1:Leather::1:0:", -- Bracers of the Rejuvenated Forest
	[39377]="0:4:2:1:Leather::1:0:", -- Toenail Belt
	[39378]="0:4:2:1:Leather::1:0:", -- Ragged Leaf Grips
	[39379]="0:4:4:1:Mail::1:0:", -- Spectral Rider's Girdle
	[39380]="0:4:2:1:Leather::1:0:", -- Legguards of the Aggressive Emissary
	[39383]="0:4:2:1:Leather::1:0:", -- Egg-Warming Boots
	[39385]="0:4:2:1:Leather::1:0:", -- Helm of the Ancient Horn
	[39386]="0:4:4:1:Leather::1:0:", -- Tunic of Dislocation
	[39387]="0:4:2:1:Leather::1:0:", -- Stinger-Proof Chestguard
	[39388]="0:4:4:1:Trinket::1:0:", -- Spirit-World Glass
	[39389]="0:4:4:1:Ring::1:0:", -- Signet of the Malevolent
	[39390]="0:4:4:1:Cloth::1:0:", -- Resurgent Phantom Bindings
	[39391]="0:4:4:1:Mail::1:0:", -- Heinous Mail Chestguard
	[39392]="0:4:4:1:Amulet::1:0:", -- Veiled Amulet of Life
	[39393]="0:2:4:1:TwoHandSword::1:0:", -- Claymore of Ancient Power
	[39394]="0:2:4:1:Stave::1:0:", -- Charmed Cierge
	[39395]="0:4:4:1:Plate::1:0:", -- Thane's Tainted Greathelm
	[39396]="0:4:4:1:Cloth::1:0:", -- Gown of Blaumeux
	[39397]="0:4:4:1:Mail::1:0:", -- Pauldrons of Havoc
	[39398]="0:4:4:1:Plate::1:0:", -- Massive Skeletal Ribcage
	[39399]="0:4:4:1:Leather::1:0:", -- Helm of the Vast Legions
	[39400]="0:4:2:1:Leather::1:0:", -- Static-Dispersing Shoulderpads
	[39401]="0:4:4:1:Ring::1:0:", -- Circle of Death
	[39402]="0:4:2:1:Leather::1:0:", -- Binding of the Ancient Keeper
	[39403]="0:4:4:1:Plate::1:0:", -- Helm of the Unsubmissive
	[39404]="0:4:4:1:Cloak::1:0:", -- Cloak of Mastery
	[39405]="0:4:4:1:Mail::1:0:", -- Helmet of the Inner Sanctum
	[39406]="0:4:2:1:Leather::1:0:", -- Splattered Zombie Wristguards
	[39407]="0:4:4:1:Ring::1:0:", -- Circle of Life
	[39408]="0:4:4:1:Cloth::1:0:", -- Leggings of Sapphiron
	[39409]="0:4:4:1:Cloth::1:0:", -- Cowl of Winged Fear
	[39411]="0:4:2:1:Leather::1:0:", -- Legguards of Guided Travel
	[39412]="0:4:2:1:Leather::1:0:", -- Scourgebane Treads
	[39413]="0:4:2:1:Leather::1:0:", -- Hydrafang Breeches
	[39414]="0:4:2:1:Leather::1:0:", -- Gilly's Strangulation Gauntlets
	[39415]="0:4:4:1:Cloak::1:0:", -- Shroud of the Citadel
	[39416]="0:2:4:1:FistWeapon::1:0:", -- Kel'Thuzad's Reach
	[39417]="0:2:4:1:TwoHandAxe::1:0:", -- Death's Bite
	[39418]="0:15:1:1:Junk::1:0:", -- Ornately Jeweled Box
	[39419]="0:2:4:1:Gun::1:0:", -- Nerubian Conquerer
	[39420]="0:2:4:1:Dagger::1:0:", -- Anarchy
	[39421]="0:4:4:1:Amulet::1:0:", -- Gem of Imprisoned Vassals
	[39422]="0:2:4:1:Stave::1:0:", -- Staff of the Plaguehound
	[39423]="0:2:4:1:OneHandMace::1:0:", -- Hammer of the Astral Plane
	[39424]="0:2:4:1:Dagger::1:0:", -- The Soulblade
	[39425]="0:4:4:1:Cloak::1:0:", -- Cloak of the Dying
	[39426]="0:2:4:1:Wand::1:0:", -- Wand of the Archlich
	[39427]="0:2:4:1:Dagger::1:0:", -- Omen of Ruin
	[39428]="0:4:2:1:Mail::1:0:", -- Faceguard of Flawless Aim
	[39429]="0:4:2:1:Mail::1:0:", -- Pauldrons of Swift Replenishment
	[39430]="0:4:2:1:Mail::1:0:", -- Spitelinked Bracers
	[39431]="0:4:2:1:Mail::1:0:", -- Shaved Rhinohorn Chestguard
	[39432]="0:4:2:1:Mail::1:0:", -- Belt of Misconceptions
	[39433]="0:4:2:1:Mail::1:0:", -- Clear Earthen Scalemail
	[39434]="0:13:1:1:::1:0:", -- Key of Warlord Zol'Maz
	[39435]="0:4:2:1:Mail::1:0:", -- Straw-Lined Leggings
	[39436]="0:4:2:1:Mail::1:0:", -- Insect-Filtering Faceguard
	[39437]="0:4:2:1:Mail::1:0:", -- Belt of Trapped Lightning
	[39438]="0:4:2:1:Mail::1:0:", -- Rockhandler's Gloves
	[39439]="0:4:2:1:Mail::1:0:", -- Skeleton Smashers
	[39441]="0:4:2:1:Mail::1:0:", -- Treads of Bound Life
	[39442]="0:4:2:1:Mail::1:0:", -- Seeing-Eye Belt
	[39443]="0:4:2:1:Mail::1:0:", -- Chain Gloves of the Demonic Minion
	[39444]="0:4:2:1:Mail::1:0:", -- Keeper's Touch
	[39445]="0:4:2:1:Mail::1:0:", -- Roc Hunter's Bracer
	[39446]="0:4:2:1:Mail::1:0:", -- Pauldrons of Resolution
	[39448]="0:4:2:1:Plate::1:0:", -- Helm of Brutal Slaughter
	[39449]="0:4:2:1:Plate::1:0:", -- Wristguards of Titanic Vengeance
	[39450]="0:4:2:1:Plate::1:0:", -- Bug-Smashing Pauldrons
	[39451]="0:4:2:1:Plate::1:0:", -- Pauldrons of the Silent Mist
	[39452]="0:4:2:1:Plate::1:0:", -- Roaming Wristguards
	[39453]="0:4:2:1:Plate::1:0:", -- Rhino-Tail Girdle
	[39454]="0:4:2:1:Plate::1:0:", -- Handguards of Transient Friendship
	[39455]="0:4:2:1:Plate::1:0:", -- Cracked Nest Stabilizer
	[39457]="0:4:2:1:Plate::1:0:", -- Zepik's Grounded Legplates
	[39458]="0:4:2:1:Plate::1:0:", -- Cultbreaker's Chestguard
	[39459]="0:4:2:1:Plate::1:0:", -- Preservative-Stained Gauntlets
	[39461]="0:4:2:1:Plate::1:0:", -- Muck-Stained Carapace
	[39462]="0:4:2:1:Plate::1:0:", -- Legplates of the Northern Expedition
	[39463]="0:4:2:1:Plate::1:0:", -- Norrington's Burnished Breastplate
	[39464]="0:4:2:1:Plate::1:0:", -- Lifegiver's Ward
	[39465]="0:4:2:1:Plate::1:0:", -- Pathfinding Treads
	[39466]="0:4:2:1:Plate::1:0:", -- Boots of Dominance
	[39467]="0:4:4:1:Plate::1:0:", -- Minion Bracers
	[39468]="0:2:4:1:FistWeapon::1:0:", -- The Stray
	[39469]="0:7:1:20:Part:773:1:0:33027", -- Moonglow Ink
	[39470]="0:4:4:1:Amulet::1:0:", -- Medallion of the Disgraced
	[39471]="0:4:2:1:Plate::1:0:", -- Gutbuster of Aldur'thar
	[39472]="0:4:4:1:Amulet::1:0:", -- Chain of Latent Energies
	[39473]="0:2:4:1:Wand::1:0:", -- Contortion
	[39474]="0:4:2:1:Ring::1:0:", -- Ring of Devoted Promises
	[39475]="0:4:3:1:Amulet::1:0:", -- Artruis's Focus Stone
	[39476]="0:0:1:20:Consumable::1:0:23710,27478", -- Fresh Goblin Brewfest Hops
	[39477]="0:0:1:20:Consumable::1:0:24495,27489", -- Fresh Dwarven Brewfest Hops
	[39478]="0:4:3:1:Cloak::1:0:", -- Cloak of the Deadliest Game
	[39479]="0:4:2:1:Cloak::1:0:", -- Cloak of Renewed Hope
	[39480]="0:4:2:1:Ring::1:0:", -- Bent Crocolisk Tooth
	[39481]="0:4:2:1:Ring::1:0:", -- Signet of the Avenging Heart
	[39482]="0:4:2:1:Ring::1:0:", -- Ring of Misinterpreted Gestures
	[39483]="0:4:3:1:Amulet::1:0:", -- Choker of Binding
	[39484]="0:4:3:1:Amulet::1:0:", -- Spiked Collar of Servitude
	[39485]="0:4:3:1:Amulet::1:0:", -- Blood-Infused Pendant
	[39486]="0:2:3:1:Gun::1:0:", -- Hemet's Trophy Gun
	[39487]="0:2:3:1:Bow::1:0:", -- Dragon Slayer's Shortbow
	[39488]="0:2:3:1:Wand::1:0:", -- Nesingwary Brush Burner
	[39489]="5000:1:1:1:InscriptionBag::1:1:26916,26959,26977,26995,27143,28723,30723,30724,30727,30729,30730,30731,30732,30733,30734,30735,33598,33638,33679", -- Scribe's Satchel
	[39490]="0:2:3:1:Thrown::1:0:", -- Dorian's Prybar
	[39491]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Frostfire Circlet
	[39492]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Frostfire Robe
	[39493]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Frostfire Leggings
	[39494]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Frostfire Shoulderpads
	[39495]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Frostfire Gloves
	[39496]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Plagueheart Circlet
	[39497]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Plagueheart Robe
	[39498]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Plagueheart Leggings
	[39499]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Plagueheart Shoulderpads
	[39500]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Plagueheart Gloves
	[39501]="1250:7:1:20:Other:773:1:0:23802,24054,24147,24188,24341,24356,26374,26916,26939,26941,26959,26977,26995,27012,27021,27026,27043,27057,27063,27070,27132,27143,27146,27184,27195,27938,28692,28723,28794,28806,28831,28872,29270,29277,30311,30345,30438,30723,30724,30727,30729,30730,30731,30732,30733,30734,30735,30825,31115,32477,32639,32641,33598,33638,33669,33679,37904,37935", -- Heavy Parchment
	[39502]="5000:7:1:20:Other:773:1:0:23802,24054,24147,24188,24341,24356,26374,26916,26939,26941,26959,26977,26995,27012,27021,27026,27043,27057,27063,27070,27132,27143,27146,27184,27195,27938,28692,28723,28794,28806,28831,28872,29270,29277,30311,30345,30438,30723,30724,30727,30729,30730,30731,30732,30733,30734,30735,30825,31115,32477,32639,32641,33598,33638,33669,33679,37904,37935", -- Resilient Parchment
	[39503]="0:4:2:1:Plate::1:0:", -- Bronzed Dome Protector
	[39504]="0:12:1:1:::1:0:", -- New Avalon Patrol Schedule
	[39505]="750:7:1:1:Other::1:0:26916,26959,26977,26995,27143,28723,30723,30724,30727,30729,30730,30731,30732,30733,30734,30735,33598,33638,33679", -- Virtuoso Inking Set
	[39506]="0:12:1:10:::1:0:", -- Depleted Element 115
	[39507]="0:4:2:1:Mail::1:0:", -- Darkmoon Chain Shirt
	[39508]="0:4:2:1:Plate::1:0:", -- Stonebound Chestguard
	[39509]="0:4:2:1:Leather::1:0:", -- Darkmoon Vest
	[39510]="0:12:1:1:::1:0:", -- Valroth's Head
	[39512]="0:15:0:20:Junk::1:0:", -- Hoary Crystals
	[39513]="0:15:0:20:Junk::1:0:", -- Efflorescing Shards
	[39514]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Crown of Faith
	[39515]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Robe of Faith
	[39516]="0:15:0:20:Junk::1:0:", -- Frosty Mushroom
	[39517]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Leggings of Faith
	[39518]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Shoulderpads of Faith
	[39519]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Gloves of Faith
	[39520]="0:0:1:20:FoodDrink::1:0:", -- Kungaloosh
	[39521]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Circlet of Faith
	[39522]="101389:2:1:1:Bow::1:0:29014", -- Wolvar Shortbow
	[39523]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Raiments of Faith
	[39524]="0:15:0:20:Junk::1:0:", -- Sericeous Down
	[39525]="0:15:0:20:Junk::1:0:", -- Mordacious Talon
	[39528]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Pants of Faith
	[39529]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Mantle of Faith
	[39530]="0:4:4:1:Cloth::1:0:28995", -- Heroes' Handwraps of Faith
	[39531]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Headpiece
	[39532]="0:15:0:10:Junk::1:0:", -- Caustic Claw
	[39533]="0:15:0:10:Junk::1:0:", -- Trenchant Fang
	[39534]="0:4:3:1:Plate::1:0:", -- Pauldrons of the Lightning Revenant
	[39535]="0:4:3:1:Plate::1:0:", -- Ionar's Girdle
	[39536]="0:4:3:1:Cloth::1:0:", -- Thundercloud Grasps
	[39538]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Robe
	[39539]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Leggings
	[39540]="0:12:1:1:::1:0:", -- Unblemished Heart of the Guardian
	[39541]="0:12:1:1:::1:0:", -- Gusty Essence of the Warden
	[39542]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Spaulders
	[39543]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Handguards
	[39544]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Gloves
	[39545]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Cover
	[39546]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Trousers
	[39547]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Vestments
	[39548]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Mantle
	[39549]="0:15:0:20:Junk::1:0:", -- Pustulant Moss
	[39550]="0:15:0:20:Junk::1:0:", -- Steaming Fungus
	[39551]="0:15:0:20:Junk::1:0:", -- Stewing Ichor
	[39552]="0:15:0:20:Junk::1:0:", -- Dissolved Skull
	[39553]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Headguard
	[39554]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Raiments
	[39555]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Legguards
	[39556]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Shoulderpads
	[39557]="0:4:4:1:Leather::1:0:28992", -- Heroes' Dreamwalker Handgrips
	[39558]="0:4:4:1:Leather::1:0:28992", -- Heroes' Bonescythe Breastplate
	[39559]="0:15:0:20:Junk::1:0:", -- Flickering Torch
	[39560]="0:4:4:1:Leather::1:0:28992", -- Heroes' Bonescythe Gauntlets
	[39561]="0:4:4:1:Leather::1:0:28992", -- Heroes' Bonescythe Helmet
	[39562]="0:15:0:20:Junk::1:0:", -- Looped Tusk
	[39563]="0:15:0:20:Junk::1:0:", -- Stumpy Foot
	[39564]="0:4:4:1:Leather::1:0:28992", -- Heroes' Bonescythe Legplates
	[39565]="0:4:4:1:Leather::1:0:28992", -- Heroes' Bonescythe Pauldrons
	[39566]="0:12:1:1:::1:0:", -- Prophet of Akali Convocation
	[39567]="0:15:0:20:Junk::1:0:", -- Rubicund Scale
	[39568]="0:15:0:5:Junk::1:0:", -- Hollow Fang
	[39569]="0:15:0:5:Junk::1:0:", -- Bent Basilisk Fang
	[39570]="0:15:0:5:Junk::1:0:", -- Aromatic Basilisk Skin
	[39571]="0:12:1:1:::1:0:", -- Drums of the Tempest
	[39572]="0:12:1:1:::1:0:", -- Chime of Cleansing
	[39573]="0:12:1:1:::1:0:", -- Matriarch's Heartblood
	[39574]="0:12:1:1:::1:0:", -- Rejek's Vial
	[39575]="0:12:1:1:::1:0:", -- Suntouched Heartblood
	[39576]="0:12:1:1:::1:0:", -- Suntouched Water
	[39577]="0:12:1:1:::1:0:", -- Rejek's Blade
	[39578]="0:4:4:1:Mail::1:0:29523", -- Heroes' Cryptstalker Headpiece
	[39579]="0:4:4:1:Mail::1:0:29523", -- Heroes' Cryptstalker Tunic
	[39580]="0:4:4:1:Mail::1:0:29523", -- Heroes' Cryptstalker Legguards
	[39581]="0:4:4:1:Mail::1:0:29523", -- Heroes' Cryptstalker Spaulders
	[39582]="0:4:4:1:Mail::1:0:29523", -- Heroes' Cryptstalker Handguards
	[39583]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Headpiece
	[39588]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Tunic
	[39589]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Legguards
	[39590]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Spaulders
	[39591]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Handguards
	[39592]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Hauberk
	[39593]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Gloves
	[39594]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Helm
	[39595]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Kilt
	[39596]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Shoulderpads
	[39597]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Chestguard
	[39598]="0:12:1:1:::1:0:", -- Didgeridoo of Contemplation
	[39599]="0:12:1:1:::1:0:", -- Horn of Fecundity
	[39601]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Grips
	[39602]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Faceguard
	[39603]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter War-Kilt
	[39604]="0:4:4:1:Mail::1:0:29523", -- Heroes' Earthshatter Shoulderguards
	[39605]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Helmet
	[39606]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Battleplate
	[39607]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Legplates
	[39608]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Shoulderplates
	[39609]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Gauntlets
	[39610]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Greathelm
	[39611]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Breastplate
	[39612]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Legguards
	[39613]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Pauldrons
	[39614]="0:12:1:1:::1:0:", -- True Power of the Tempest
	[39615]="0:12:1:1:::1:0:", -- Crusader Parachute
	[39616]="0:12:1:5:::1:0:", -- Essence of the Monsoon
	[39617]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Battleplate
	[39618]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Gauntlets
	[39619]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Helmet
	[39620]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Legplates
	[39621]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Shoulderplates
	[39622]="0:4:4:1:Plate::1:0:28997", -- Heroes' Dreadnaught Handguards
	[39623]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Chestguard
	[39624]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Handguards
	[39625]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Faceguard
	[39626]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Legguards
	[39627]="0:4:4:1:Plate::1:0:28997", -- Heroes' Scourgeborne Pauldrons
	[39628]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Headpiece
	[39629]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Tunic
	[39630]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Greaves
	[39631]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Spaulders
	[39632]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Gloves
	[39633]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Chestpiece
	[39634]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Gauntlets
	[39635]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Helm
	[39636]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Legplates
	[39637]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Shoulderplates
	[39638]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Breastplate
	[39639]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Handguards
	[39640]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Faceguard
	[39641]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Legguards
	[39642]="0:4:4:1:Plate::1:0:28997", -- Heroes' Redemption Shoulderguards
	[39643]="0:12:1:5:::1:0:", -- Essence of the Storm
	[39644]="0:9:1:1:Cooking::1:0:", -- Recipe: Kungaloosh
	[39645]="0:12:1:1:::1:0:", -- Makeshift Cover
	[39646]="0:12:1:1:::1:0:", -- Scarlet Courier's Belongings
	[39647]="0:12:1:1:::1:0:", -- Scarlet Courier's Message
	[39648]="0:4:3:1:Ring::1:0:", -- Kurzel's Rage
	[39649]="0:4:3:1:Ring::1:0:", -- Kurzel's Angst
	[39650]="0:4:3:1:Ring::1:0:", -- Kurzel's Warband
	[39651]="0:12:1:1:::1:0:", -- Venture Co. Explosives
	[39652]="0:4:3:1:Amulet::1:0:", -- Choker of the Betrayer
	[39653]="0:4:3:1:Amulet::1:0:", -- Choker of Betrayal
	[39654]="0:12:1:1:::1:0:", -- The Path of Redemption
	[39655]="0:4:3:1:Amulet::1:0:", -- Betrayer's Choker
	[39656]="0:15:3:1:Companion::1:0:", -- Tyrael's Hilt
	[39657]="0:4:3:1:Mail::1:0:", -- Tornado Cuffs
	[39664]="0:12:1:1:::1:0:", -- Scepter of Domination
	[39665]="0:12:1:1:::1:0:", -- Bundle of Hides
	[39666]="0:0:1:20:Elixir::1:0:", -- Elixir of Mighty Agility
	[39667]="0:12:1:1:::1:0:", -- Stormwatcher's Head
	[39668]="0:12:1:1:::1:0:", -- Abomination Guts
	[39669]="0:12:1:1:::1:0:", -- Ghoul Drool
	[39670]="0:12:1:1:::1:0:", -- Blight Crystal
	[39671]="0:0:1:20:Potion::1:0:", -- Resurgent Healing Potion
	[39672]="0:4:2:1:Cloak::1:0:", -- Drape of the Offered Branch
	[39673]="0:4:2:1:Cloak::1:0:", -- Lightning Beetle's Cape
	[39674]="0:4:2:1:Cloak::1:0:", -- Cloak of the Buzzing Swarm
	[39675]="0:4:2:1:Cloak::1:0:", -- Cloak of the Hardened Tortoise
	[39676]="0:4:3:1:Cloth::1:0:", -- Wraps of the San'layn
	[39678]="0:4:3:1:Leather::1:0:", -- Vendetta Bindings
	[39679]="0:4:3:1:Mail::1:0:", -- Runecaster's Bracers
	[39680]="0:4:3:1:Plate::1:0:", -- Vambraces of the Vengeance Bringer
	[39681]="0:7:1:20:Part:202:1:0:", -- Handful of Cobalt Bolts
	[39682]="0:7:1:5:Part:202:1:0:", -- Overcharged Capacitor
	[39683]="0:7:1:20:Part:202:1:0:", -- Froststeel Tube
	[39684]="9000:7:1:10:Part:202:1:0:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14337,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Hair Trigger
	[39685]="0:7:1:10:Part::1:0:", -- Indestructible Frame
	[39686]="0:7:1:10:Part::1:0:", -- Neo-Dynamic Gear Assembly
	[39688]="0:2:3:1:Gun::1:0:", -- Mark "S" Boomstick
	[39689]="0:12:1:1:::1:0:", -- Crystal of the Frozen Grip
	[39690]="0:7:1:20:Part:202:1:0:", -- Volatile Blasting Trigger
	[39691]="0:0:1:20:FoodDrink::1:0:", -- Succulent Orca Stew
	[39692]="0:9:1:1:Cooking::1:0:", -- Recipe: Succulent Orca Stew
	[39693]="0:12:1:1:::1:0:", -- Crystal of Unstable Energy
	[39694]="0:12:1:1:::1:0:", -- Crystal of the Violent Storm
	[39695]="0:12:1:1:::1:0:", -- Ensnaring Trap
	[39696]="0:12:1:1:::1:0:", -- Volatile Trap
	[39697]="0:12:1:1:::1:0:", -- Spike Bomb
	[39698]="0:0:1:1:Consumable::1:0:", -- Light-infused Artifact
	[39700]="0:12:1:1:::1:0:", -- Horn of the Frostbrood
	[39701]="0:4:4:1:Leather::1:0:", -- Dawnwalkers
	[39702]="0:4:4:1:Mail::1:0:", -- Arachnoid Gold Band
	[39703]="0:4:4:1:Plate::1:0:", -- Rescinding Grips
	[39704]="0:4:4:1:Plate::1:0:", -- Pauldrons of Unnatural Death
	[39706]="0:4:4:1:Plate::1:0:", -- Sabatons of Sudden Reprisal
	[39707]="0:4:2:1:Leather::1:0:", -- Verdant Tundra Cap
	[39708]="0:4:2:1:Leather::1:0:", -- Verdant Tundra Shoulderpads
	[39709]="0:4:2:1:Leather::1:0:", -- Verdant Tundra Boots
	[39710]="0:4:2:1:Leather::1:0:", -- Verdant Tundra Belt
	[39711]="0:4:2:1:Leather::1:0:", -- Verdant Tundra Bracers
	[39712]="0:2:4:1:Wand::1:0:", -- Gemmed Wand of the Nerubians
	[39713]="0:12:1:1:::1:0:", -- Ebon Hold Gift Voucher
	[39714]="0:2:4:1:Dagger::1:0:", -- Webbed Death
	[39716]="0:4:4:1:Shield::1:0:", -- Shield of Assimilation
	[39717]="0:4:4:1:Plate::1:0:", -- Inexorable Sabatons
	[39718]="0:4:4:1:Mail::1:0:", -- Corpse Scarab Handguards
	[39719]="0:4:4:1:Cloth::1:0:", -- Mantle of the Locusts
	[39720]="0:4:4:1:Cloth::1:0:", -- Leggings of Atrophy
	[39721]="0:4:4:1:Cloth::1:0:", -- Sash of the Parlor
	[39722]="0:4:4:1:Leather::1:0:", -- Swarm Bindings
	[39723]="0:4:4:1:Plate::1:0:", -- Fire-Scorched Greathelm
	[39724]="0:4:4:1:Mail::1:0:", -- Cult's Chestguard
	[39725]="0:4:4:1:Plate::1:0:", -- Epaulets of the Grieving Servant
	[39726]="0:4:4:1:Plate::1:0:", -- Callous-Hearted Gauntlets
	[39727]="0:4:4:1:Leather::1:0:", -- Dislocating Handguards
	[39728]="0:4:4:1:Totem::1:0:29529,31579,31581", -- Totem of Misery
	[39729]="0:4:4:1:Plate::1:0:", -- Bracers of the Tyrant
	[39730]="0:2:4:1:OneHandSword::1:0:", -- Widow's Fury
	[39731]="0:4:4:1:Cloth::1:0:", -- Punctilious Bindings
	[39732]="0:4:4:1:Cloth::1:0:", -- Faerlina's Madness
	[39733]="0:4:4:1:Cloth::1:0:", -- Gloves of Token Respect
	[39734]="0:4:4:1:Mail::1:0:", -- Atonement Greaves
	[39735]="0:4:4:1:Cloth::1:0:", -- Belt of False Dignity
	[39737]="0:12:1:1:::1:0:", -- Secret Strength of the Frenzyheart
	[39738]="0:0:1:20:Consumable::1:0:", -- Thunderbrew's Hard Ale
	[39739]="0:12:1:1:::1:0:", -- Wolvar Berries
	[39740]="0:12:1:1:::1:0:", -- Kirin Tor Signet
	[39747]="0:12:1:1:::1:0:", -- Dormant Polished Crystal
	[39748]="0:12:1:1:::1:0:", -- Energized Polished Crystal
	[39756]="0:4:4:1:Leather::1:0:", -- Tunic of Prejudice
	[39757]="0:4:4:1:Idol::1:0:29529,31579,31581", -- Idol of Worship
	[39758]="0:2:4:1:TwoHandMace::1:0:", -- The Jawbone
	[39759]="0:4:4:1:Plate::1:0:", -- Ablative Chitin Girdle
	[39760]="0:4:4:1:Plate::1:0:", -- Helm of Diminished Pride
	[39761]="0:4:4:1:Leather::1:0:", -- Infectious Skitterer Leggings
	[39762]="0:4:4:1:Mail::1:0:", -- Torn Web Wrapping
	[39763]="0:2:4:1:FistWeapon::1:0:", -- Wraith Strike
	[39764]="0:4:4:1:Plate::1:0:", -- Bindings of the Hapless Prey
	[39765]="0:4:4:1:Leather::1:0:", -- Sinner's Bindings
	[39766]="0:4:4:1:OffHandFrill::1:0:", -- Matriarch's Spawn
	[39767]="0:4:4:1:Plate::1:0:", -- Undiminished Battleplate
	[39768]="0:4:4:1:Leather::1:0:", -- Cowl of the Perished
	[39769]="0:2:4:1:TwoHandAxe::1:0:", -- Arcanite Ripper
	[39770]="0:4:2:1:Cloth::1:0:", -- Soothsayer's Hood
	[39771]="0:4:2:1:Cloth::1:0:", -- Embattled Legwraps
	[39772]="0:4:2:1:Cloth::1:0:", -- Bloodbinder's Wrist Wraps
	[39773]="0:4:2:1:Cloth::1:0:", -- Soothsayer's Shoulderpads
	[39774]="0:7:1:20:Part:773:1:0:33027", -- Midnight Ink
	[39775]="0:4:2:1:Cloth::1:0:", -- Soothsayer's Sandals
	[39776]="0:4:2:1:Mail::1:0:", -- Bloodbinder's Shoulderguards
	[39777]="0:4:2:1:Ring::1:0:", -- Band of Misty Mojo
	[39778]="0:4:2:1:Plate::1:0:", -- Bloodletter's Legplates
	[39779]="0:4:2:1:Cloth::1:0:", -- Crusader's Ripcord
	[39780]="0:4:2:1:Mail::1:0:", -- Valiant Belt of Battle
	[39781]="0:4:2:1:Cloth::1:0:", -- Bloodbinder's Raiment
	[39782]="0:4:2:1:Plate::1:0:", -- Thick Bracers of Battle
	[39783]="0:4:2:1:Mail::1:0:", -- Bloodbinder's Gauntlets
	[39784]="0:2:2:1:Stave::1:0:", -- Staff of the Dutybound
	[39785]="0:4:2:1:Cloth::1:0:", -- Soothsayer's Garb
	[39786]="0:4:2:1:Ring::1:0:", -- Band of the Bloodletter
	[39787]="0:4:2:1:Cloth::1:0:", -- Soothsayer's Handwraps
	[39788]="0:4:2:1:Mail::1:0:", -- Leggings of the Ritual
	[39789]="0:4:2:1:Cloth::1:0:", -- Bloodbinder's Shoulderpads
	[39790]="0:4:2:1:Plate::1:0:", -- Gauntlets of the Altar
	[39791]="0:4:2:1:Cloth::1:0:", -- Soothsayer's Wristwraps
	[39792]="0:4:2:1:Ring::1:0:", -- Ritualistic Band of Light
	[39793]="0:4:2:1:Amulet::1:0:", -- Neckcharm of Mighty Mojo
	[39794]="0:4:2:1:Cloth::1:0:", -- Bloodbinder's Gloves
	[39795]="0:4:2:1:Plate::1:0:", -- Boots of the Altar
	[39796]="0:4:2:1:Mail::1:0:", -- Boots of the Great Sacrifice
	[39797]="0:4:2:1:Cloth::1:0:", -- Bloodbinder's Hood
	[39798]="0:4:2:1:Ring::1:0:", -- Ring of Ancestral Protectors
	[39799]="0:4:2:1:Mail::1:0:", -- Rescuer's Chestguard
	[39800]="0:4:2:1:Cloth::1:0:", -- Pantaloons of the Dutybound
	[39801]="0:4:2:1:Plate::1:0:", -- Boots of the Rescuer
	[39802]="0:2:2:1:TwoHandSword::1:0:", -- Crusader's Greatblade
	[39803]="0:4:2:1:Mail::1:0:", -- Gauntlets of the Great Sacrifice
	[39804]="0:4:2:1:Cloth::1:0:", -- Braided Bat Sinew
	[39805]="0:4:2:1:Plate::1:0:", -- Chestplate of the Altar
	[39806]="0:2:2:1:OneHandSword::1:0:", -- Blade of Diligence
	[39807]="0:4:2:1:Cloak::1:0:", -- Rescuer's Cloak
	[39808]="0:2:2:1:Stave::1:0:", -- Staff of Diligence
	[39809]="0:4:2:1:Cloth::1:0:", -- Sandals of Spying
	[39810]="0:4:2:1:Cloth::1:0:", -- Cords of Duplicity
	[39811]="0:4:2:1:Trinket::1:0:", -- Badge of the Infiltrator
	[39812]="0:4:2:1:Cloth::1:0:", -- Soiled Trousers
	[39814]="0:4:2:1:Cloth::1:0:", -- Slippers of the Broken Front
	[39815]="0:4:2:1:Mail::1:0:", -- Bloodbinder's Links
	[39816]="0:4:2:1:Cloth::1:0:", -- Medic's Hood
	[39817]="0:4:2:1:Plate::1:0:", -- Brazen Offender's Shoulderplates
	[39818]="0:2:2:1:Crossbow::1:0:", -- Frigid Crossbow
	[39820]="0:2:2:1:Dagger::1:0:", -- Blade of Valorous Service
	[39821]="0:4:2:1:Trinket::1:0:", -- Spiritist's Focus
	[39822]="0:2:2:1:Dagger::1:0:", -- Knife of the Dutybound
	[39823]="0:2:2:1:OneHandMace::1:0:", -- Dutybound Mace of Purity
	[39824]="0:2:2:1:TwoHandAxe::1:0:", -- Cleaver of Diligence
	[39825]="0:4:2:1:Mail::1:0:", -- Belt of the Bloodbinder
	[39826]="0:2:2:1:OneHandSword::1:0:", -- Bloodletter's Blade
	[39827]="0:4:2:1:OffHandFrill::1:0:", -- Vile Tome of Tenets
	[39829]="0:2:2:1:Bow::1:0:", -- High-Strung Bow
	[39830]="0:2:2:1:FistWeapon::1:0:", -- Fist of Subtlety
	[39831]="0:4:2:1:Ring::1:0:", -- Petrified Ghoul Finger
	[39833]="0:4:2:1:Leather::1:0:", -- Supple Bloodbinder's Boots
	[39834]="0:4:2:1:Leather::1:0:", -- Embattled Jerkin
	[39835]="0:4:2:1:Leather::1:0:", -- Supple Bloodbinder's Helm
	[39836]="0:4:2:1:Leather::1:0:", -- Supple Mantle of the Bloodletter
	[39837]="0:4:2:1:Leather::1:0:", -- Gloves of Swift Death
	[39838]="0:4:2:1:Leather::1:0:", -- Supple Belt of the Bloodletter
	[39839]="0:4:2:1:Mail::1:0:", -- Ritualistic Shoulderguards
	[39840]="0:4:2:1:Amulet::1:0:", -- Rescuer's Ripcord
	[39841]="0:4:2:1:Plate::1:0:", -- Ancestral Girdle
	[39842]="0:4:2:1:Leather::1:0:", -- Bloodletter's Boots
	[39843]="0:4:2:1:Leather::1:0:", -- Supple Wristguards
	[39844]="0:4:2:1:Shield::1:0:", -- Ritualistic Shield
	[39845]="0:4:2:1:Plate::1:0:", -- Ancestral Gauntlets
	[39846]="0:4:2:1:Mail::1:0:", -- Bloodletter's Headgear
	[39847]="0:4:2:1:Plate::1:0:", -- Ancestral War Boots
	[39848]="0:4:2:1:Amulet::1:0:", -- Neckcharm of the Bloodletter
	[39849]="0:4:2:1:Plate::1:0:", -- Belt of Divine Ancestry
	[39850]="0:4:2:1:Mail::1:0:", -- Wristguards of Service
	[39851]="0:4:2:1:Plate::1:0:", -- Ribbed Helm of Servitude
	[39852]="0:2:2:1:Dagger::1:0:", -- Victorious Spellblade
	[39853]="0:2:2:1:Stave::1:0:", -- Thorny Bough of the Light
	[39854]="0:4:2:1:Mail::1:0:", -- Huntsman's Jerkin
	[39855]="0:4:2:1:Plate::1:0:", -- Gauntlets of the Gatherer
	[39856]="0:4:2:1:Leather::1:0:", -- Bloodletter's Pants
	[39857]="0:4:2:1:Mail::1:0:", -- Rescuer's Binding
	[39858]="0:4:2:1:Cloak::1:0:", -- Drape of the Bloodletter
	[39859]="0:4:2:1:Leather::1:0:", -- Bloodletter's Skullcap
	[39860]="0:4:2:1:Plate::1:0:", -- Vindicator's Bracers of Sacrifice
	[39861]="0:4:2:1:Leather::1:0:", -- Supple Bloodbinder's Leggings
	[39862]="0:4:2:1:Leather::1:0:", -- Supple Vest of the Bloodletter
	[39863]="0:4:2:1:Leather::1:0:", -- Supple Vest of the Bloodbinder
	[39864]="0:4:2:1:Leather::1:0:", -- Belt of Service
	[39865]="0:2:2:1:FistWeapon::1:0:", -- Knuckle of Victory
	[39866]="0:4:2:1:Mail::1:0:", -- Gauntlets of the Secret Agent
	[39867]="0:4:2:1:Leather::1:0:", -- Bat Fur Mitts
	[39868]="0:4:2:1:Leather::1:0:", -- Ravager's Skullcap
	[39869]="0:4:2:1:Leather::1:0:", -- Double-Agent's Wristwraps
	[39870]="0:4:2:1:Cloak::1:0:", -- Drape of Duplicity
	[39871]="0:4:2:1:Leather::1:0:", -- Subtle Boots of the Infiltrator
	[39872]="0:4:2:1:Mail::1:0:", -- Helm of Subtle Whispers
	[39873]="0:4:2:1:Leather::1:0:", -- Skins of Subterfuge
	[39874]="0:4:2:1:Shield::1:0:", -- Infiltrator's Shield
	[39875]="0:4:2:1:Mail::1:0:", -- Shoulderguards of Subterfuge
	[39876]="0:4:2:1:Leather::1:0:", -- Aged Abomination Tripe
	[39877]="0:4:2:1:Plate::1:0:", -- Belt of the Betrayer
	[39878]="30000:0:1:1:Consumable::1:0:31910", -- Mysterious Egg
	[39880]="0:4:2:1:Mail::1:0:", -- Redigested Mail Scraps
	[39881]="0:4:2:1:Leather::1:0:", -- Mantle of Reanimation
	[39882]="0:4:2:1:Plate::1:0:", -- Carved Bone Helm
	[39883]="0:0:1:1:Consumable::1:0:", -- Cracked Egg
	[39886]="0:4:2:1:Leather::1:0:", -- Greenhealer's Gauntlets
	[39887]="0:4:2:1:Mail::1:0:", -- Geist Stalker Leggings
	[39888]="0:4:2:1:Plate::1:0:", -- Scourgebane Pauldrons
	[39889]="0:4:2:1:Trinket::1:0:", -- Horn of Argent Fury
	[39890]="0:4:2:1:Plate::1:0:", -- Purifier's Pantaloons
	[39891]="0:4:2:1:Plate::1:0:", -- Brazen Offender's Helm
	[39893]="0:4:2:1:Plate::1:0:", -- Ancestral Chestplates
	[39894]="0:4:3:1:Cloth::1:0:", -- Darkcloth Shoulders
	[39895]="0:4:3:1:Leather::1:0:", -- Cloaked Shoulderpads
	[39896]="0:15:1:1:Companion::1:0:", -- Tickbird Hatchling
	[39897]="0:4:3:1:Mail::1:0:", -- Azure Shoulderguards
	[39898]="0:15:1:1:Companion::1:0:", -- Cobra Hatchling
	[39899]="0:15:1:1:Companion::1:0:", -- White Tickbird Hatchling
	[39900]="0:3:2:1:GemRed::1:0:", -- Bold Bloodstone
	[39903]="0:15:1:1:Junk::1:0:", -- Argent Crusade Gratuity
	[39904]="0:15:1:1:Junk::1:0:", -- Argent Crusade Gratuity
	[39905]="0:3:2:1:GemRed::1:0:", -- Delicate Bloodstone
	[39906]="0:3:2:1:GemRed::1:0:", -- Bright Bloodstone
	[39907]="0:3:2:1:GemRed::1:0:", -- Subtle Bloodstone
	[39908]="0:3:2:1:GemRed::1:0:", -- Flashing Bloodstone
	[39909]="0:3:2:1:GemRed::1:0:", -- Fractured Bloodstone
	[39910]="0:3:2:1:GemRed::1:0:", -- Precise Bloodstone
	[39911]="0:3:2:1:GemRed::1:0:", -- Runed Bloodstone
	[39912]="0:3:2:1:GemYellow::1:0:", -- Brilliant Sun Crystal
	[39914]="0:3:2:1:GemYellow::1:0:", -- Smooth Sun Crystal
	[39915]="0:3:2:1:GemYellow::1:0:", -- Rigid Sun Crystal
	[39916]="0:3:2:1:GemYellow::1:0:", -- Thick Sun Crystal
	[39917]="0:3:2:1:GemYellow::1:0:", -- Mystic Sun Crystal
	[39918]="0:3:2:1:GemYellow::1:0:", -- Quick Sun Crystal
	[39919]="0:3:2:1:GemBlue::1:0:", -- Solid Chalcedony
	[39920]="0:3:2:1:GemBlue::1:0:", -- Sparkling Chalcedony
	[39927]="0:3:2:1:GemBlue::1:0:", -- Lustrous Chalcedony
	[39932]="0:3:2:1:GemBlue::1:0:", -- Stormy Chalcedony
	[39933]="0:3:2:1:GemPurple::1:0:", -- Puissant Shadow Crystal
	[39934]="0:3:2:1:GemPurple::1:0:", -- Sovereign Shadow Crystal
	[39935]="0:3:2:1:GemPurple::1:0:", -- Shifting Shadow Crystal
	[39936]="0:3:2:1:GemPurple::1:0:", -- Glowing Shadow Crystal
	[39937]="0:3:2:1:GemPurple::1:0:", -- Balanced Shadow Crystal
	[39938]="0:3:2:1:GemPurple::1:0:", -- Regal Shadow Crystal
	[39939]="0:3:2:1:GemPurple::1:0:", -- Defender's Shadow Crystal
	[39940]="0:3:2:1:GemPurple::1:0:", -- Guardian's Shadow Crystal
	[39941]="0:3:2:1:GemPurple::1:0:", -- Purified Shadow Crystal
	[39942]="0:3:2:1:GemPurple::1:0:", -- Tenuous Shadow Crystal
	[39943]="0:3:2:1:GemPurple::1:0:", -- Royal Shadow Crystal
	[39944]="0:3:2:1:GemPurple::1:0:", -- Infused Shadow Crystal
	[39945]="0:3:2:1:GemPurple::1:0:", -- Mysterious Shadow Crystal
	[39946]="0:3:2:1:GemOrange::1:0:", -- Luminous Huge Citrine
	[39947]="0:3:2:1:GemOrange::1:0:", -- Inscribed Huge Citrine
	[39948]="0:3:2:1:GemOrange::1:0:", -- Etched Huge Citrine
	[39949]="0:3:2:1:GemOrange::1:0:", -- Champion's Huge Citrine
	[39950]="0:3:2:1:GemOrange::1:0:", -- Resplendent Huge Citrine
	[39951]="0:3:2:1:GemOrange::1:0:", -- Fierce Huge Citrine
	[39952]="0:3:2:1:GemOrange::1:0:", -- Deadly Huge Citrine
	[39953]="0:3:2:1:GemOrange::1:0:", -- Glinting Huge Citrine
	[39954]="0:3:2:1:GemOrange::1:0:", -- Lucent Huge Citrine
	[39955]="0:3:2:1:GemOrange::1:0:", -- Deft Huge Citrine
	[39956]="0:3:2:1:GemOrange::1:0:", -- Potent Huge Citrine
	[39957]="0:3:2:1:GemOrange::1:0:", -- Veiled Huge Citrine
	[39958]="0:3:2:1:GemOrange::1:0:", -- Durable Huge Citrine
	[39959]="0:3:2:1:GemOrange::1:0:", -- Reckless Huge Citrine
	[39960]="0:3:2:1:GemOrange::1:0:", -- Wicked Huge Citrine
	[39961]="0:3:2:1:GemOrange::1:0:", -- Pristine Huge Citrine
	[39962]="0:3:2:1:GemOrange::1:0:", -- Empowered Huge Citrine
	[39963]="0:3:2:1:GemOrange::1:0:", -- Stark Huge Citrine
	[39964]="0:3:2:1:GemOrange::1:0:", -- Stalwart Huge Citrine
	[39965]="0:3:2:1:GemOrange::1:0:", -- Glimmering Huge Citrine
	[39966]="0:3:2:1:GemOrange::1:0:", -- Accurate Huge Citrine
	[39967]="0:3:2:1:GemOrange::1:0:", -- Resolute Huge Citrine
	[39968]="0:3:2:1:GemGreen::1:0:", -- Timeless Dark Jade
	[39969]="0:0:1:20:Other::1:0:", -- Fire Seed
	[39970]="0:0:1:20:Other:171:1:0:", -- Fire Leaf
	[39973]="400000:15:3:1:Companion::1:0:29537", -- Ghostly Skull
	[39974]="0:3:2:1:GemGreen::1:0:", -- Jagged Dark Jade
	[39975]="0:3:2:1:GemGreen::1:0:", -- Vivid Dark Jade
	[39976]="0:3:2:1:GemGreen::1:0:", -- Enduring Dark Jade
	[39977]="0:3:2:1:GemGreen::1:0:", -- Steady Dark Jade
	[39978]="0:3:2:1:GemGreen::1:0:", -- Forceful Dark Jade
	[39979]="0:3:2:1:GemGreen::1:0:", -- Seer's Dark Jade
	[39980]="0:3:2:1:GemGreen::1:0:", -- Misty Dark Jade
	[39981]="0:3:2:1:GemGreen::1:0:", -- Shining Dark Jade
	[39982]="0:3:2:1:GemGreen::1:0:", -- Turbid Dark Jade
	[39983]="0:3:2:1:GemGreen::1:0:", -- Intricate Dark Jade
	[39984]="0:3:2:1:GemGreen::1:0:", -- Dazzling Dark Jade
	[39985]="0:3:2:1:GemGreen::1:0:", -- Sundered Dark Jade
	[39986]="0:3:2:1:GemGreen::1:0:", -- Lambent Dark Jade
	[39987]="194930:2:1:1:Polearm::1:0:27151,27185,27188", -- Tuskarr Fishing Spear
	[39988]="0:3:2:1:GemGreen::1:0:", -- Opaque Dark Jade
	[39989]="0:3:2:1:GemGreen::1:0:", -- Energized Dark Jade
	[39990]="0:3:2:1:GemGreen::1:0:", -- Radiant Dark Jade
	[39991]="0:3:2:1:GemGreen::1:0:", -- Tense Dark Jade
	[39992]="0:3:2:1:GemGreen::1:0:", -- Shattered Dark Jade
	[39995]="111565:2:1:1:Thrown::1:0:27151,27185,27188", -- Tuskarr Javelin
	[39996]="0:3:3:1:GemRed::1:0:", -- Bold Scarlet Ruby
	[39997]="0:3:3:1:GemRed::1:0:", -- Delicate Scarlet Ruby
	[39998]="0:3:3:1:GemRed::1:0:", -- Runed Scarlet Ruby
	[39999]="0:3:3:1:GemRed::1:0:", -- Bright Scarlet Ruby
	[40000]="0:3:3:1:GemRed::1:0:", -- Subtle Scarlet Ruby
	[40001]="0:3:3:1:GemRed::1:0:", -- Flashing Scarlet Ruby
	[40002]="0:3:3:1:GemRed::1:0:", -- Fractured Scarlet Ruby
	[40003]="0:3:3:1:GemRed::1:0:", -- Precise Scarlet Ruby
	[40004]="179342:2:1:1:TwoHandSword::1:0:24330,30067", -- Forsaken Greatsword
	[40005]="143474:2:1:1:Dagger::1:0:24330,30067", -- Forsaken Blade
	[40006]="143474:2:1:1:OneHandSword::1:0:24330,30067", -- Forsaken Sword
	[40007]="111565:2:1:1:Thrown::1:0:24330,30067", -- Forsaken Throwing Knife
	[40008]="0:3:3:1:GemBlue::1:0:", -- Solid Sky Sapphire
	[40009]="0:3:3:1:GemBlue::1:0:", -- Sparkling Sky Sapphire
	[40010]="0:3:3:1:GemBlue::1:0:", -- Lustrous Sky Sapphire
	[40011]="0:3:3:1:GemBlue::1:0:", -- Stormy Sky Sapphire
	[40012]="0:3:3:1:GemYellow::1:0:", -- Brilliant Autumn's Glow
	[40013]="0:3:3:1:GemYellow::1:0:", -- Smooth Autumn's Glow
	[40014]="0:3:3:1:GemYellow::1:0:", -- Rigid Autumn's Glow
	[40015]="0:3:3:1:GemYellow::1:0:", -- Thick Autumn's Glow
	[40016]="0:3:3:1:GemYellow::1:0:", -- Mystic Autumn's Glow
	[40017]="0:3:3:1:GemYellow::1:0:", -- Quick Autumn's Glow
	[40018]="113201:2:1:1:Wand::1:0:27139,28994", -- Wand of Onyx
	[40019]="113618:2:1:1:Wand::1:0:27139,28994", -- Wand of Amber
	[40020]="114036:2:1:1:Wand::1:0:27139,28994", -- Wand of Jade
	[40021]="107605:2:1:1:Wand::1:0:27139,28994", -- Wand of Crystal
	[40022]="0:3:3:1:GemPurple::1:0:", -- Sovereign Twilight Opal
	[40023]="0:3:3:1:GemPurple::1:0:", -- Shifting Twilight Opal
	[40024]="0:3:3:1:GemPurple::1:0:", -- Tenuous Twilight Opal
	[40025]="0:3:3:1:GemPurple::1:0:", -- Glowing Twilight Opal
	[40026]="0:3:3:1:GemPurple::1:0:", -- Purified Twilight Opal
	[40027]="0:3:3:1:GemPurple::1:0:", -- Royal Twilight Opal
	[40028]="0:3:3:1:GemPurple::1:0:", -- Mysterious Twilight Opal
	[40029]="0:3:3:1:GemPurple::1:0:", -- Balanced Twilight Opal
	[40030]="0:3:3:1:GemPurple::1:0:", -- Infused Twilight Opal
	[40031]="0:3:3:1:GemPurple::1:0:", -- Regal Twilight Opal
	[40032]="0:3:3:1:GemPurple::1:0:", -- Defender's Twilight Opal
	[40033]="0:3:3:1:GemPurple::1:0:", -- Puissant Twilight Opal
	[40034]="0:3:3:1:GemPurple::1:0:", -- Guardian's Twilight Opal
	[40035]="50:0:1:20:FoodDrink::1:0:23737,28682,28685,29049,29715,29963,30005,32403,32416,32421,32424,32426,32631,32638,33019,33026,33645,33867,33868,33869", -- Honey Mead
	[40036]="150:0:1:20:FoodDrink::1:0:23737,28682,28685,29049,29715,29963,32403,32416,32421,32424,32426,32631,32638,33019,33026,33645,33867,33868,33869", -- Snowplum Brandy
	[40037]="0:3:3:1:GemOrange::1:0:", -- Inscribed Monarch Topaz
	[40038]="0:3:3:1:GemOrange::1:0:", -- Etched Monarch Topaz
	[40039]="0:3:3:1:GemOrange::1:0:", -- Champion's Monarch Topaz
	[40040]="0:3:3:1:GemOrange::1:0:", -- Resplendent Monarch Topaz
	[40041]="0:3:3:1:GemOrange::1:0:", -- Fierce Monarch Topaz
	[40042]="1500:0:1:20:FoodDrink::1:0:23737,28682,28685,29049,29715,29963,32403,32416,32421,32424,32426,32631,32638,33019,33026,33645,33867,33868,33869", -- Caraway Burnwine
	[40043]="0:3:3:1:GemOrange::1:0:", -- Deadly Monarch Topaz
	[40044]="0:3:3:1:GemOrange::1:0:", -- Glinting Monarch Topaz
	[40045]="0:3:3:1:GemOrange::1:0:", -- Lucent Monarch Topaz
	[40046]="0:3:3:1:GemOrange::1:0:", -- Deft Monarch Topaz
	[40047]="0:3:3:1:GemOrange::1:0:", -- Luminous Monarch Topaz
	[40048]="0:3:3:1:GemOrange::1:0:", -- Potent Monarch Topaz
	[40049]="0:3:3:1:GemOrange::1:0:", -- Veiled Monarch Topaz
	[40050]="0:3:3:1:GemOrange::1:0:", -- Durable Monarch Topaz
	[40051]="0:3:3:1:GemOrange::1:0:", -- Reckless Monarch Topaz
	[40052]="0:3:3:1:GemOrange::1:0:", -- Wicked Monarch Topaz
	[40053]="0:3:3:1:GemOrange::1:0:", -- Pristine Monarch Topaz
	[40054]="0:3:3:1:GemOrange::1:0:", -- Empowered Monarch Topaz
	[40055]="0:3:3:1:GemOrange::1:0:", -- Stark Monarch Topaz
	[40056]="0:3:3:1:GemOrange::1:0:", -- Stalwart Monarch Topaz
	[40057]="0:3:3:1:GemOrange::1:0:", -- Glimmering Monarch Topaz
	[40058]="0:3:3:1:GemOrange::1:0:", -- Accurate Monarch Topaz
	[40059]="0:3:3:1:GemOrange::1:0:", -- Resolute Monarch Topaz
	[40060]="0:4:4:1:Cloth::1:0:", -- Distorted Limbs
	[40061]="0:4:4:1:Mail::1:0:", -- Quivering Tunic
	[40062]="0:4:4:1:Cloth::1:0:", -- Digested Silken Robes
	[40063]="0:4:4:1:Leather::1:0:", -- Mantle of Shattered Kinship
	[40064]="0:4:4:1:Amulet::1:0:", -- Thunderstorm Amulet
	[40065]="0:4:4:1:Amulet::1:0:", -- Fool's Trial
	[40066]="0:12:1:10:::1:0:", -- Ancient Ectoplasm
	[40067]="0:0:1:20:Potion::1:0:", -- Icy Mana Potion
	[40068]="0:0:1:20:Elixir::1:0:", -- Wrath Elixir
	[40069]="0:4:4:1:Amulet::1:0:", -- Heritage
	[40070]="0:0:1:20:Elixir::1:0:", -- Spellpower Elixir
	[40071]="0:4:4:1:Amulet::1:0:", -- Chains of Adoration
	[40072]="0:0:1:20:Elixir::1:0:", -- Elixir of Spirit
	[40073]="0:0:1:20:Elixir::1:0:", -- Elixir of Mighty Strength
	[40074]="0:4:4:1:Ring::1:0:", -- Strong-Handed Ring
	[40075]="0:4:4:1:Ring::1:0:", -- Ruthlessness
	[40076]="0:0:1:20:Elixir::1:0:", -- Guru's Elixir
	[40077]="0:0:1:20:Potion::1:0:", -- Crazy Alchemist's Potion
	[40078]="0:0:1:20:Elixir::1:0:", -- Elixir of Mighty Fortitude
	[40079]="0:0:1:20:Flask::1:0:", -- Lesser Flask of Toughness
	[40080]="0:4:4:1:Ring::1:0:", -- Lost Jewel
	[40081]="0:0:1:20:Potion::1:0:", -- Potion of Nightmares
	[40082]="0:0:1:5:Flask::1:0:", -- Mixture of the Frost Wyrm
	[40083]="0:0:1:5:Flask::1:0:", -- Mixture of Stoneblood
	[40084]="0:0:1:5:Flask::1:0:", -- Mixture of Endless Rage
	[40085]="0:3:3:1:GemGreen::1:0:", -- Timeless Forest Emerald
	[40086]="0:3:3:1:GemGreen::1:0:", -- Jagged Forest Emerald
	[40087]="0:0:1:20:Potion::1:0:", -- Powerful Rejuvenation Potion
	[40088]="0:3:3:1:GemGreen::1:0:", -- Vivid Forest Emerald
	[40089]="0:3:3:1:GemGreen::1:0:", -- Enduring Forest Emerald
	[40090]="0:3:3:1:GemGreen::1:0:", -- Steady Forest Emerald
	[40091]="0:3:3:1:GemGreen::1:0:", -- Forceful Forest Emerald
	[40092]="0:3:3:1:GemGreen::1:0:", -- Seer's Forest Emerald
	[40093]="0:0:1:20:Potion::1:0:", -- Indestructible Potion
	[40094]="0:3:3:1:GemGreen::1:0:", -- Dazzling Forest Emerald
	[40095]="0:3:3:1:GemGreen::1:0:", -- Misty Forest Emerald
	[40096]="0:3:3:1:GemGreen::1:0:", -- Sundered Forest Emerald
	[40097]="0:0:1:20:Elixir::1:0:", -- Elixir of Protection
	[40098]="0:3:3:1:GemGreen::1:0:", -- Radiant Forest Emerald
	[40099]="0:3:3:1:GemGreen::1:0:", -- Shining Forest Emerald
	[40100]="0:3:3:1:GemGreen::1:0:", -- Lambent Forest Emerald
	[40101]="0:3:3:1:GemGreen::1:0:", -- Tense Forest Emerald
	[40102]="0:3:3:1:GemGreen::1:0:", -- Turbid Forest Emerald
	[40103]="0:3:3:1:GemGreen::1:0:", -- Opaque Forest Emerald
	[40104]="0:3:3:1:GemGreen::1:0:", -- Intricate Forest Emerald
	[40105]="0:3:3:1:GemGreen::1:0:", -- Energized Forest Emerald
	[40106]="0:3:3:1:GemGreen::1:0:", -- Shattered Forest Emerald
	[40107]="0:4:4:1:Ring::1:0:", -- Sand-Worn Band
	[40108]="0:4:4:1:Ring::1:0:", -- Seized Beauty
	[40109]="0:0:1:20:Elixir::1:0:", -- Elixir of Mighty Mageblood
	[40110]="0:15:1:1:CombatPet::1:0:", -- Haunted Memento
	[40111]="0:3:4:1:GemRed::1:0:", -- Bold Cardinal Ruby
	[40112]="0:3:4:1:GemRed::1:0:", -- Delicate Cardinal Ruby
	[40113]="0:3:4:1:GemRed::1:0:", -- Runed Cardinal Ruby
	[40114]="0:3:4:1:GemRed::1:0:", -- Bright Cardinal Ruby
	[40115]="0:3:4:1:GemRed::1:0:", -- Subtle Cardinal Ruby
	[40116]="0:3:4:1:GemRed::1:0:", -- Flashing Cardinal Ruby
	[40117]="0:3:4:1:GemRed::1:0:", -- Fractured Cardinal Ruby
	[40118]="0:3:4:1:GemRed::1:0:", -- Precise Cardinal Ruby
	[40119]="0:3:4:1:GemBlue::1:0:", -- Solid Majestic Zircon
	[40120]="0:3:4:1:GemBlue::1:0:", -- Sparkling Majestic Zircon
	[40121]="0:3:4:1:GemBlue::1:0:", -- Lustrous Majestic Zircon
	[40122]="0:3:4:1:GemBlue::1:0:", -- Stormy Majestic Zircon
	[40123]="0:3:4:1:GemYellow::1:0:", -- Brilliant King's Amber
	[40124]="0:3:4:1:GemYellow::1:0:", -- Smooth King's Amber
	[40125]="0:3:4:1:GemYellow::1:0:", -- Rigid King's Amber
	[40126]="0:3:4:1:GemYellow::1:0:", -- Thick King's Amber
	[40127]="0:3:4:1:GemYellow::1:0:", -- Mystic King's Amber
	[40128]="0:3:4:1:GemYellow::1:0:", -- Quick King's Amber
	[40129]="0:3:4:1:GemPurple::1:0:", -- Sovereign Dreadstone
	[40130]="0:3:4:1:GemPurple::1:0:", -- Shifting Dreadstone
	[40131]="0:3:4:1:GemPurple::1:0:", -- Tenuous Dreadstone
	[40132]="0:3:4:1:GemPurple::1:0:", -- Glowing Dreadstone
	[40133]="0:3:4:1:GemPurple::1:0:", -- Purified Dreadstone
	[40134]="0:3:4:1:GemPurple::1:0:", -- Royal Dreadstone
	[40135]="0:3:4:1:GemPurple::1:0:", -- Mysterious Dreadstone
	[40136]="0:3:4:1:GemPurple::1:0:", -- Balanced Dreadstone
	[40137]="0:3:4:1:GemPurple::1:0:", -- Infused Dreadstone
	[40138]="0:3:4:1:GemPurple::1:0:", -- Regal Dreadstone
	[40139]="0:3:4:1:GemPurple::1:0:", -- Defender's Dreadstone
	[40140]="0:3:4:1:GemPurple::1:0:", -- Puissant Dreadstone
	[40141]="0:3:4:1:GemPurple::1:0:", -- Guardian's Dreadstone
	[40142]="0:3:4:1:GemOrange::1:0:", -- Inscribed Ametrine
	[40143]="0:3:4:1:GemOrange::1:0:", -- Etched Ametrine
	[40144]="0:3:4:1:GemOrange::1:0:", -- Champion's Ametrine
	[40145]="0:3:4:1:GemOrange::1:0:", -- Resplendent Ametrine
	[40146]="0:3:4:1:GemOrange::1:0:", -- Fierce Ametrine
	[40147]="0:3:4:1:GemOrange::1:0:", -- Deadly Ametrine
	[40148]="0:3:4:1:GemOrange::1:0:", -- Glinting Ametrine
	[40149]="0:3:4:1:GemOrange::1:0:", -- Lucent Ametrine
	[40150]="0:3:4:1:GemOrange::1:0:", -- Deft Ametrine
	[40151]="0:3:4:1:GemOrange::1:0:", -- Luminous Ametrine
	[40152]="0:3:4:1:GemOrange::1:0:", -- Potent Ametrine
	[40153]="0:3:4:1:GemOrange::1:0:", -- Veiled Ametrine
	[40154]="0:3:4:1:GemOrange::1:0:", -- Durable Ametrine
	[40155]="0:3:4:1:GemOrange::1:0:", -- Reckless Ametrine
	[40156]="0:3:4:1:GemOrange::1:0:", -- Wicked Ametrine
	[40157]="0:3:4:1:GemOrange::1:0:", -- Pristine Ametrine
	[40158]="0:3:4:1:GemOrange::1:0:", -- Empowered Ametrine
	[40159]="0:3:4:1:GemOrange::1:0:", -- Stark Ametrine
	[40160]="0:3:4:1:GemOrange::1:0:", -- Stalwart Ametrine
	[40161]="0:3:4:1:GemOrange::1:0:", -- Glimmering Ametrine
	[40162]="0:3:4:1:GemOrange::1:0:", -- Accurate Ametrine
	[40163]="0:3:4:1:GemOrange::1:0:", -- Resolute Ametrine
	[40164]="0:3:4:1:GemGreen::1:0:", -- Timeless Eye of Zul
	[40165]="0:3:4:1:GemGreen::1:0:", -- Jagged Eye of Zul
	[40166]="0:3:4:1:GemGreen::1:0:", -- Vivid Eye of Zul
	[40167]="0:3:4:1:GemGreen::1:0:", -- Enduring Eye of Zul
	[40168]="0:3:4:1:GemGreen::1:0:", -- Steady Eye of Zul
	[40169]="0:3:4:1:GemGreen::1:0:", -- Forceful Eye of Zul
	[40170]="0:3:4:1:GemGreen::1:0:", -- Seer's Eye of Zul
	[40171]="0:3:4:1:GemGreen::1:0:", -- Misty Eye of Zul
	[40172]="0:3:4:1:GemGreen::1:0:", -- Shining Eye of Zul
	[40173]="0:3:4:1:GemGreen::1:0:", -- Turbid Eye of Zul
	[40174]="0:3:4:1:GemGreen::1:0:", -- Intricate Eye of Zul
	[40175]="0:3:4:1:GemGreen::1:0:", -- Dazzling Eye of Zul
	[40176]="0:3:4:1:GemGreen::1:0:", -- Sundered Eye of Zul
	[40177]="0:3:4:1:GemGreen::1:0:", -- Lambent Eye of Zul
	[40178]="0:3:4:1:GemGreen::1:0:", -- Opaque Eye of Zul
	[40179]="0:3:4:1:GemGreen::1:0:", -- Energized Eye of Zul
	[40180]="0:3:4:1:GemGreen::1:0:", -- Radiant Eye of Zul
	[40181]="0:3:4:1:GemGreen::1:0:", -- Tense Eye of Zul
	[40182]="0:3:4:1:GemGreen::1:0:", -- Shattered Eye of Zul
	[40184]="0:4:4:1:Mail::1:0:", -- Crippled Treads
	[40185]="0:4:4:1:Plate::1:0:", -- Shoulderguards of Opportunity
	[40186]="0:4:4:1:Leather::1:0:", -- Thrusting Bands
	[40187]="0:4:4:1:Plate::1:0:", -- Poignant Sabatons
	[40188]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Disobedient
	[40189]="0:2:4:1:OneHandMace::1:0:", -- Angry Dread
	[40190]="0:2:4:1:Thrown::1:0:", -- Spinning Fate
	[40191]="0:4:4:1:Libram::1:0:29529,31579,31581", -- Libram of Radiance
	[40192]="0:4:4:1:OffHandFrill::1:0:", -- Accursed Spine
	[40193]="0:4:4:1:Mail::1:0:", -- Tunic of Masked Suffering
	[40194]="0:4:4:1:Cloth::1:0:", -- Blanketing Robes of Snow
	[40195]="0:7:1:20:Other:171:1:0:", -- Pygmy Oil
	[40196]="0:4:4:1:Mail::1:0:", -- Legguards of the Undisturbed
	[40197]="0:4:4:1:Cloth::1:0:", -- Gloves of the Fallen Wizard
	[40198]="0:4:4:1:Cloth::1:0:", -- Bands of Impurity
	[40199]="0:7:1:20:Other:171:1:0:", -- Pygmy Suckerfish
	[40200]="0:4:4:1:Leather::1:0:", -- Belt of Potent Chanting
	[40201]="0:4:4:1:Mail::1:0:", -- Leggings of Colossal Strides
	[40202]="16000:0:1:20:FoodDrink::5:0:29244", -- Sizzling Grizzly Flank
	[40203]="0:4:4:1:Plate::1:0:", -- Breastplate of Tormented Rage
	[40204]="0:4:4:1:Plate::1:0:", -- Legguards of the Apostle
	[40205]="0:4:4:1:Leather::1:0:", -- Stalk-Skin Belt
	[40206]="0:4:4:1:Plate::1:0:", -- Iron-Spring Jumpers
	[40207]="0:4:4:1:Sigil::1:0:29529,31579,31581", -- Sigil of Awareness
	[40208]="0:2:4:1:Polearm::1:0:", -- Cryptfiend's Bite
	[40209]="0:4:4:1:Mail::1:0:", -- Bindings of the Decrepit
	[40210]="0:4:4:1:Plate::1:0:", -- Chestguard of Bitter Charms
	[40211]="0:0:1:20:Potion::1:0:", -- Potion of Speed
	[40212]="0:0:1:20:Potion::1:0:", -- Potion of Wild Magic
	[40213]="0:0:1:20:Potion::1:0:", -- Mighty Arcane Protection Potion
	[40214]="0:0:1:20:Potion::1:0:", -- Mighty Fire Protection Potion
	[40215]="0:0:1:20:Potion::1:0:", -- Mighty Frost Protection Potion
	[40216]="0:0:1:20:Potion::1:0:", -- Mighty Nature Protection Potion
	[40217]="0:0:1:20:Potion::1:0:", -- Mighty Shadow Protection Potion
	[40233]="0:2:4:1:Stave::1:0:", -- The Undeath Carrier
	[40234]="0:4:4:1:Cloth::1:0:", -- Heigan's Putrid Vestments
	[40235]="0:4:4:1:Mail::1:0:", -- Helm of Pilgrimage
	[40236]="0:4:4:1:Cloth::1:0:", -- Serene Echoes
	[40237]="0:4:4:1:Mail::1:0:", -- Eruption-Scarred Boots
	[40238]="0:4:4:1:Leather::1:0:", -- Gloves of the Dancing Bear
	[40239]="0:2:4:1:FistWeapon::1:0:", -- The Hand of Nerub
	[40240]="0:4:4:1:Plate::1:0:", -- Greaves of Turbulence
	[40241]="0:4:4:1:Plate::1:0:", -- Girdle of Unity
	[40242]="0:4:4:1:Mail::1:0:", -- Grotesque Handgrips
	[40243]="0:4:4:1:Leather::1:0:", -- Footwraps of Vile Deceit
	[40244]="0:2:4:1:OneHandMace::1:0:", -- The Impossible Dream
	[40245]="0:2:4:1:Wand::1:0:", -- Fading Glow
	[40246]="0:4:4:1:Cloth::1:0:", -- Boots of Impetuous Ideals
	[40247]="0:4:4:1:Cloth::1:0:", -- Cowl of Innocent Delight
	[40248]="0:7:3:20:Elemental::1:0:", -- Eternal Might
	[40249]="0:4:4:1:Leather::1:0:", -- Vest of Vitality
	[40250]="0:4:4:1:Cloak::1:0:", -- Aged Winter Cloak
	[40251]="0:4:4:1:Cloak::1:0:", -- Shroud of Luminosity
	[40252]="0:4:4:1:Cloak::1:0:", -- Cloak of the Shadowed Sun
	[40253]="0:4:4:1:Cloak::1:0:", -- Shawl of the Old Maid
	[40254]="0:4:4:1:Cloak::1:0:", -- Cloak of Averted Crisis
	[40255]="0:4:4:1:Trinket::1:0:", -- Dying Curse
	[40256]="0:4:4:1:Trinket::1:0:", -- Grim Toll
	[40257]="0:4:4:1:Trinket::1:0:", -- Defender's Code
	[40258]="0:4:4:1:Trinket::1:0:", -- Forethought Talisman
	[40259]="0:4:4:1:Plate::1:0:", -- Waistguard of Divine Grace
	[40260]="0:4:4:1:Leather::1:0:", -- Belt of the Tortured
	[40261]="0:4:4:1:Plate::1:0:", -- Crude Discolored Battlegrips
	[40262]="0:4:4:1:Mail::1:0:", -- Gloves of Calculated Risk
	[40263]="0:4:4:1:Plate::1:0:", -- Fleshless Girdle
	[40264]="0:2:4:1:OneHandMace::1:0:", -- Split Greathammer
	[40265]="0:2:4:1:Bow::1:0:", -- Arrowsong
	[40266]="0:4:4:1:Shield::1:0:", -- Hero's Surrender
	[40267]="0:4:4:1:Totem::1:0:29529,31579,31581", -- Totem of Hex
	[40268]="0:4:4:1:Libram::1:0:29529,31579,31581", -- Libram of Tolerance
	[40269]="0:4:4:1:Cloth::1:0:", -- Boots of Persuasion
	[40270]="0:4:4:1:Leather::1:0:", -- Boots of Septic Wounds
	[40271]="0:4:4:1:Cloth::1:0:", -- Sash of Solitude
	[40272]="0:4:4:1:Mail::1:0:", -- Girdle of the Gambit
	[40273]="0:4:4:1:OffHandFrill::1:0:", -- Surplus Limb
	[40274]="0:4:4:1:Plate::1:0:", -- Bracers of Liberation
	[40275]="0:4:4:1:Mail::1:0:", -- Depraved Linked Belt
	[40277]="0:4:4:1:Leather::1:0:", -- Tunic of Indulgence
	[40278]="0:4:4:1:Plate::1:0:", -- Girdle of Chivalry
	[40279]="0:4:4:1:Plate::1:0:", -- Chestguard of the Exhausted
	[40280]="0:2:4:1:Stave::1:0:", -- Origin of Nightmares
	[40281]="0:2:4:1:Dagger::1:0:", -- Twilight Mist
	[40282]="0:4:4:1:Mail::1:0:", -- Slime Stream Bands
	[40283]="0:4:4:1:Mail::1:0:", -- Fallout Impervious Tunic
	[40284]="0:2:4:1:Wand::1:0:", -- Plague Igniter
	[40285]="0:4:4:1:Leather::1:0:", -- Desecrated Past
	[40286]="0:4:4:1:Cloth::1:0:", -- Mantle of the Corrupted
	[40287]="0:4:4:1:Cloth::1:0:", -- Cowl of Vanity
	[40288]="0:4:4:1:Mail::1:0:", -- Spaulders of Incoherence
	[40289]="0:4:4:1:Cloth::1:0:", -- Sympathetic Amice
	[40290]="0:4:3:1:Cloth::1:0:", -- Gaze of the Punishing Construct
	[40291]="0:4:3:1:Leather::1:0:", -- Helm of the Avenging Protector
	[40292]="0:4:3:1:Mail::1:0:", -- Headguard of Vast Destruction
	[40293]="0:4:3:1:Plate::1:0:", -- Helm of Towering Rage
	[40294]="0:4:4:1:Plate::1:0:", -- Riveted Abomination Leggings
	[40295]="0:4:3:1:Plate::1:0:", -- Greathelm of the Titan Protectorate
	[40296]="0:4:4:1:Leather::1:0:", -- Cover of Silence
	[40297]="0:4:4:1:Plate::1:0:", -- Sabatons of Endurance
	[40298]="0:4:4:1:Plate::1:0:", -- Faceguard of the Succumbed
	[40299]="0:4:4:1:Mail::1:0:", -- Pauldrons of the Abandoned
	[40300]="0:2:4:1:Stave::1:0:", -- Spire of Sunset
	[40301]="0:4:4:1:Cloth::1:0:", -- Cincture of Polarity
	[40302]="0:4:4:1:Mail::1:0:", -- Benefactor's Gauntlets
	[40303]="0:4:4:1:Cloth::1:0:", -- Wraps of the Persecuted
	[40304]="0:4:4:1:Leather::1:0:", -- Headpiece of Fungal Bloom
	[40305]="0:4:4:1:Leather::1:0:", -- Spaulders of Egotism
	[40306]="0:4:4:1:Plate::1:0:", -- Bracers of the Unholy Knight
	[40315]="0:4:4:1:Mail::1:0:", -- Shoulderpads of Secret Arts
	[40316]="0:4:4:1:Plate::1:0:", -- Gauntlets of Guiding Touch
	[40317]="0:4:4:1:Plate::1:0:", -- Girdle of Razuvious
	[40318]="0:4:4:1:Plate::1:0:", -- Legplates of Double Strikes
	[40319]="0:4:4:1:Leather::1:0:", -- Chestpiece of Suspicion
	[40320]="0:4:4:1:Plate::1:0:", -- Faithful Steel Sabatons
	[40321]="0:4:4:1:Idol::1:0:29529,31579,31581", -- Idol of the Shooting Star
	[40322]="0:4:4:1:Totem::1:0:29529,31579,31581", -- Totem of Dueling
	[40323]="0:4:4:1:Leather::1:0:", -- Esteemed Bindings
	[40324]="0:4:4:1:Mail::1:0:", -- Bands of Mutual Respect
	[40325]="0:4:4:1:Cloth::1:0:", -- Bindings of the Expansive Mind
	[40326]="0:4:4:1:Cloth::1:0:", -- Boots of Forlorn Wishes
	[40327]="0:4:4:1:Mail::1:0:", -- Girdle of Recuperation
	[40328]="0:4:4:1:Plate::1:0:", -- Helm of Vital Protection
	[40329]="0:4:4:1:Leather::1:0:", -- Hood of the Exodus
	[40330]="0:4:4:1:Plate::1:0:", -- Bracers of Unrelenting Attack
	[40331]="0:4:4:1:Mail::1:0:", -- Leggings of Failed Escape
	[40332]="0:4:4:1:Plate::1:0:", -- Abetment Bracers
	[40333]="0:4:4:1:Leather::1:0:", -- Leggings of Fleeting Moments
	[40334]="0:4:4:1:Plate::1:0:", -- Burdened Shoulderplates
	[40335]="0:2:4:1:Wand::1:0:", -- Touch of Horror
	[40336]="0:2:4:1:OneHandSword::1:0:", -- Life and Death
	[40337]="0:4:4:1:Libram::1:0:29529,31579,31581", -- Libram of Resurgence
	[40338]="0:4:4:1:Cloth::1:0:", -- Bindings of Yearning
	[40339]="0:4:4:1:Cloth::1:0:", -- Gothik's Cowl
	[40340]="0:4:4:1:Mail::1:0:", -- Helm of Unleashed Energy
	[40341]="0:4:4:1:Leather::1:0:", -- Shackled Cinch
	[40342]="0:4:4:1:Idol::1:0:29529,31579,31581", -- Idol of Awakening
	[40343]="0:2:4:1:TwoHandSword::1:0:", -- Armageddon
	[40344]="0:4:4:1:Mail::1:0:", -- Helm of the Grave
	[40345]="0:2:4:1:OneHandSword::1:0:", -- Broken Promise
	[40346]="0:2:4:1:Crossbow::1:0:", -- Final Voyage
	[40347]="0:4:4:1:Plate::1:0:", -- Zeliek's Gauntlets
	[40348]="0:2:4:1:Stave::1:0:", -- Damnation
	[40349]="0:4:4:1:Leather::1:0:", -- Gloves of Peaceful Death
	[40350]="0:4:4:1:OffHandFrill::1:0:", -- Urn of Lost Memories
	[40351]="0:4:4:1:Cloth::1:0:", -- Mantle of the Fatigued Sage
	[40352]="0:4:4:1:Mail::1:0:", -- Leggings of Voracious Shadows
	[40353]="0:4:3:1:Cloak::1:0:", -- Polished Protodrake Cloak
	[40354]="0:4:3:1:Trinket::1:0:", -- Monster Slayer's Kit
	[40356]="8500:0:1:20:FoodDrink::5:0:29275", -- Grizzleberries
	[40357]="6000:0:1:20:FoodDrink::5:0:29275", -- Grizzleberry Juice
	[40358]="8500:0:1:20:FoodDrink::5:0:29275", -- Raw Tallhorn Chunk
	[40359]="8500:0:1:20:FoodDrink::5:0:29275", -- Fresh Eagle Meat
	[40360]="6940:15:0:20:Junk::1:0:29270", -- Punctured Pelt
	[40361]="6940:15:0:20:Junk::1:0:29270", -- Shredded Cloth
	[40362]="0:4:4:1:Leather::1:0:", -- Gloves of Fast Reactions
	[40363]="0:4:4:1:Plate::1:0:", -- Bone-Inlaid Legguards
	[40364]="0:12:1:1:::1:0:", -- Rainspeaker Peace Offering
	[40365]="0:4:4:1:Plate::1:0:", -- Breastplate of Frozen Pain
	[40366]="0:4:4:1:Plate::1:0:", -- Platehelm of the Great Wyrm
	[40367]="0:4:4:1:Mail::1:0:", -- Boots of the Great Construct
	[40368]="0:2:4:1:Dagger::1:0:", -- Murder
	[40369]="0:4:4:1:Amulet::1:0:", -- Icy Blast Amulet
	[40370]="0:4:4:1:Ring::1:0:", -- Gatekeeper
	[40371]="0:4:4:1:Trinket::1:0:", -- Bandit's Insignia
	[40372]="0:4:4:1:Trinket::1:0:", -- Rune of Repulsion
	[40373]="0:4:4:1:Trinket::1:0:", -- Extract of Necromantic Power
	[40374]="0:4:4:1:Amulet::1:0:", -- Cosmic Lights
	[40375]="0:4:4:1:Ring::1:0:", -- Ring of Decaying Beauty
	[40376]="0:4:4:1:Cloth::1:0:", -- Legwraps of the Defeated Dragon
	[40377]="0:4:4:1:Plate::1:0:", -- Noble Birthright Pauldrons
	[40378]="0:4:4:1:Amulet::1:0:", -- Ceaseless Pity
	[40379]="0:4:4:1:Leather::1:0:", -- Legguards of the Boneyard
	[40380]="0:4:4:1:Cloth::1:0:", -- Gloves of Grandeur
	[40381]="0:4:4:1:Cloth::1:0:", -- Sympathy
	[40382]="0:4:4:1:Trinket::1:0:", -- Soul of the Dead
	[40383]="0:2:4:1:FistWeapon::1:0:", -- Calamity's Grasp
	[40384]="0:2:4:1:TwoHandAxe::1:0:", -- Betrayer of Humanity
	[40385]="0:2:4:1:Gun::1:0:", -- Envoy of Mortality
	[40386]="0:2:4:1:Dagger::1:0:", -- Sinister Revenge
	[40387]="0:4:4:1:Amulet::1:0:", -- Boundless Ambition
	[40388]="0:2:4:1:Stave::1:0:", -- Journey's End
	[40390]="0:0:1:1:Consumable::1:0:", -- Vic's Emergency Air Tank
	[40391]="0:15:0:20:Junk::1:0:", -- Mirror-Like Seashell
	[40392]="0:15:0:20:Junk::1:0:", -- Cracked Diamond
	[40393]="0:15:0:20:Junk::1:0:", -- Green Sparkly
	[40394]="0:12:1:5:::1:0:", -- Longneck Grazer Steak
	[40395]="0:2:4:1:OneHandMace::1:0:", -- Torch of Holy Fire
	[40396]="0:2:4:1:OneHandSword::1:0:", -- The Turning Tide
	[40397]="0:12:1:1:::1:0:", -- Lifeblood Gem
	[40398]="0:4:4:1:Cloth::1:0:", -- Leggings of Mortal Arrogance
	[40399]="0:4:4:1:Ring::1:0:", -- Signet of Manifested Pain
	[40400]="0:4:4:1:Shield::1:0:", -- Wall of Terror
	[40401]="0:4:4:1:Shield::1:0:", -- Voice of Reason
	[40402]="0:2:4:1:OneHandAxe::1:0:", -- Last Laugh
	[40403]="0:4:4:1:Cloak::1:0:", -- Drape of the Deadly Foe
	[40404]="0:0:1:5:Flask::1:0:", -- Mixture of Pure Mojo
	[40405]="0:4:4:1:Cloak::1:0:", -- Cape of the Unworthy Wizard
	[40406]="0:2:4:1:TwoHandMace::1:0:", -- Inevitable Defeat
	[40407]="0:2:4:1:OneHandSword::1:0:", -- Silent Crusader
	[40408]="0:2:4:1:Dagger::1:0:", -- Haunting Call
	[40409]="0:4:4:1:Leather::1:0:", -- Boots of the Escaped Captive
	[40410]="0:4:4:1:Cloak::1:0:", -- Shadow of the Ghoul
	[40411]="50000:7:1:20:Other:171:5:0:844,958,983,1257,1313,1453,2380,2480,2481,2812,2848,3010,3014,3348,3405,3548,3956,4216,4226,4610,4615,4899,5138,5178,5503,5594,8157,8158,8177,8178,8305,11188,16367,16612,16641,16705,16706,16829,18005,19074,19837,20989,23802,24054,24147,24188,24341,24356,24975,26374,26568,26939,26941,27012,27021,27026,27031,27038,27043,27053,27057,27063,27070,27132,27140,27141,27146,27184,27195,27938,28692,28725,28727,28794,28806,28828,28829,28831,28866,28868,28872,29270,29277,29535,29909,30311,30345,30438,30825,31115,32477,32639,32641,33600,33630,33639,33669,33674,33678,37904,37935", -- Enchanted Vial
	[40412]="0:4:4:1:Amulet::1:0:", -- Ousted Bead Necklace
	[40414]="0:4:4:1:Plate::1:0:", -- Shoulderguards of the Undaunted
	[40415]="0:4:4:1:Cloth::1:0:28995", -- Valorous Frostfire Gloves
	[40416]="0:4:4:1:Cloth::1:0:28995", -- Valorous Frostfire Circlet
	[40417]="0:4:4:1:Cloth::1:0:28995", -- Valorous Frostfire Leggings
	[40418]="0:4:4:1:Cloth::1:0:28995", -- Valorous Frostfire Robe
	[40419]="0:4:4:1:Cloth::1:0:28995", -- Valorous Frostfire Shoulderpads
	[40420]="0:4:4:1:Cloth::1:0:28995", -- Valorous Plagueheart Gloves
	[40421]="0:4:4:1:Cloth::1:0:28995", -- Valorous Plagueheart Circlet
	[40422]="0:4:4:1:Cloth::1:0:28995", -- Valorous Plagueheart Leggings
	[40423]="0:4:4:1:Cloth::1:0:28995", -- Valorous Plagueheart Robe
	[40424]="0:4:4:1:Cloth::1:0:28995", -- Valorous Plagueheart Shoulderpads
	[40425]="0:12:1:1:::1:0:", -- Drakuru's Skull
	[40426]="0:4:4:1:Ring::1:0:", -- Signet of the Accord
	[40427]="0:4:4:1:Amulet::1:0:", -- Circle of Arcane Streams
	[40428]="0:4:4:1:Plate::1:0:", -- Titan's Outlook
	[40429]="0:2:4:1:FistWeapon::1:0:", -- Crimson Steel
	[40430]="0:4:4:1:Trinket::1:0:", -- Majestic Dragon Figurine
	[40431]="0:4:4:1:Trinket::1:0:", -- Fury of the Five Flights
	[40432]="0:4:4:1:Trinket::1:0:", -- Illustration of the Dragon Soul
	[40433]="0:4:4:1:Ring::1:0:", -- Wyrmrest Band
	[40437]="0:4:4:1:Leather::1:0:", -- Concealment Shoulderpads
	[40438]="0:4:4:1:Mail::1:0:", -- Council Chamber Epaulets
	[40439]="0:4:4:1:Leather::1:0:", -- Mantle of the Eternal Sentinel
	[40445]="0:4:4:1:Cloth::1:0:28995", -- Valorous Gloves of Faith
	[40446]="0:4:4:1:Plate::1:0:", -- Dragon Brood Legguards
	[40447]="0:4:4:1:Cloth::1:0:28995", -- Valorous Crown of Faith
	[40448]="0:4:4:1:Cloth::1:0:28995", -- Valorous Leggings of Faith
	[40449]="0:4:4:1:Cloth::1:0:28995", -- Valorous Robe of Faith
	[40450]="0:4:4:1:Cloth::1:0:28995", -- Valorous Shoulderpads of Faith
	[40451]="0:4:4:1:Mail::1:0:", -- Hyaline Helm of the Sniper
	[40453]="0:4:4:1:Plate::1:0:", -- Chestplate of the Great Aspects
	[40454]="0:4:4:1:Cloth::1:0:28995", -- Valorous Handwraps of Faith
	[40455]="0:2:4:1:Stave::1:0:", -- Staff of Restraint
	[40456]="0:4:4:1:Cloth::1:0:28995", -- Valorous Circlet of Faith
	[40457]="0:4:4:1:Cloth::1:0:28995", -- Valorous Pants of Faith
	[40458]="0:4:4:1:Cloth::1:0:28995", -- Valorous Raiments of Faith
	[40459]="0:4:4:1:Cloth::1:0:28995", -- Valorous Mantle of Faith
	[40460]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Handguards
	[40461]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Headpiece
	[40462]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Leggings
	[40463]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Robe
	[40465]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Spaulders
	[40466]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Gloves
	[40467]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Cover
	[40468]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Trousers
	[40469]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Vestments
	[40470]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Mantle
	[40471]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Raiments
	[40472]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Handgrips
	[40473]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Headguard
	[40474]="0:4:4:1:Ring::1:0:", -- Surge Needle Ring
	[40475]="0:4:4:1:Shield::1:0:", -- Barricade of Eternity
	[40476]="0:4:3:1:Trinket::1:0:", -- Insignia of the Alliance
	[40477]="0:4:3:1:Trinket::1:0:", -- Insignia of the Horde
	[40482]="0:0:1:1:Consumable::1:0:", -- Dual-plagued Brain
	[40483]="0:4:3:1:Trinket::1:0:", -- Insignia of the Scourge
	[40486]="0:4:4:1:Amulet::1:0:", -- Necklace of the Glittering Chamber
	[40488]="0:2:4:1:OneHandMace::1:0:", -- Ice Spire Scepter
	[40489]="0:2:4:1:Stave::1:0:", -- Greatstaff of the Nexus
	[40490]="0:4:3:1:Mail::1:0:", -- Necromantic Wristguards
	[40491]="0:2:4:1:OneHandSword::1:0:", -- Hailstorm
	[40492]="0:4:3:1:Trinket::1:0:16786", -- Argent War Horn
	[40493]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Legguards
	[40494]="0:4:4:1:Leather::1:0:28992", -- Valorous Dreamwalker Shoulderpads
	[40495]="0:4:4:1:Leather::1:0:28992", -- Valorous Bonescythe Breastplate
	[40496]="0:4:4:1:Leather::1:0:28992", -- Valorous Bonescythe Gauntlets
	[40497]="0:2:4:1:Polearm::1:0:", -- Black Ice
	[40499]="0:4:4:1:Leather::1:0:28992", -- Valorous Bonescythe Helmet
	[40500]="0:4:4:1:Leather::1:0:28992", -- Valorous Bonescythe Legplates
	[40502]="0:4:4:1:Leather::1:0:28992", -- Valorous Bonescythe Pauldrons
	[40503]="0:4:4:1:Mail::1:0:29523", -- Valorous Cryptstalker Tunic
	[40504]="0:4:4:1:Mail::1:0:29523", -- Valorous Cryptstalker Handguards
	[40505]="0:4:4:1:Mail::1:0:29523", -- Valorous Cryptstalker Headpiece
	[40506]="0:4:4:1:Mail::1:0:29523", -- Valorous Cryptstalker Legguards
	[40507]="0:4:4:1:Mail::1:0:29523", -- Valorous Cryptstalker Spaulders
	[40508]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Tunic
	[40509]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Handguards
	[40510]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Headpiece
	[40511]="0:4:4:1:Plate::1:0:", -- Focusing Energy Epaulets
	[40512]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Legguards
	[40513]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Spaulders
	[40514]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Hauberk
	[40515]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Gloves
	[40516]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Helm
	[40517]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Kilt
	[40518]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Shoulderpads
	[40519]="0:4:4:1:Leather::1:0:", -- Footsteps of Malygos
	[40520]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Grips
	[40521]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Faceguard
	[40522]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter War-Kilt
	[40523]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Chestguard
	[40524]="0:4:4:1:Mail::1:0:29523", -- Valorous Earthshatter Shoulderguards
	[40525]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Battleplate
	[40526]="0:4:4:1:Cloth::1:0:", -- Gown of the Spell-Weaver
	[40527]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Gauntlets
	[40528]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Helmet
	[40529]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Legplates
	[40530]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Shoulderplates
	[40531]="0:4:4:1:Trinket::1:0:", -- Mark of Norgannon
	[40532]="0:4:4:1:Trinket::1:0:", -- Living Ice Crystals
	[40533]="50000:7:1:10:Part:202:1:0:1448,1694,2682,2683,2684,2685,2687,2688,3133,3413,3495,4453,4587,5175,5519,6730,6777,8678,8679,9544,9676,11185,14337,14637,16657,16782,17222,17421,18278,18484,18752,18775,19383,20890,26600,26898,27711,28722,28797,29688,29907,30345,30434,30825,31776,31781,33594,33634,33669,33677,37904,37935", -- Walnut Stock
	[40536]="0:15:1:20:CombatPet::1:0:", -- Explosive Decoy
	[40539]="0:4:4:1:Leather::1:0:", -- Chestguard of the Recluse
	[40541]="0:4:4:1:Leather::1:0:", -- Frosted Adroit Handguards
	[40543]="0:4:4:1:Mail::1:0:", -- Blue Aspect Helm
	[40544]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Breastplate
	[40545]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Handguards
	[40546]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Greathelm
	[40547]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Legguards
	[40548]="0:4:4:1:Plate::1:0:28997", -- Valorous Dreadnaught Pauldrons
	[40549]="0:4:4:1:Mail::1:0:", -- Boots of the Renewed Flight
	[40550]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Battleplate
	[40551]="0:12:1:1:::1:0:", -- Gore Bladder
	[40552]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Gauntlets
	[40554]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Helmet
	[40555]="0:4:4:1:Cloth::1:0:", -- Mantle of Dissemination
	[40556]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Legplates
	[40557]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Shoulderplates
	[40558]="0:4:4:1:Cloth::1:0:", -- Arcanic Tramplers
	[40559]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Chestguard
	[40560]="0:4:4:1:Cloth::1:0:", -- Leggings of the Wanton Spellcaster
	[40561]="0:4:4:1:Cloth::1:0:", -- Leash of Heedless Magic
	[40562]="0:4:4:1:Cloth::1:0:", -- Hood of Rationality
	[40563]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Handguards
	[40564]="0:4:4:1:Mail::1:0:", -- Winter Spectacle Gloves
	[40565]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Faceguard
	[40566]="0:4:4:1:Leather::1:0:", -- Unravelling Strands of Sanity
	[40567]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Legguards
	[40568]="0:4:4:1:Plate::1:0:28997", -- Valorous Scourgeborne Pauldrons
	[40569]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Tunic
	[40570]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Gloves
	[40571]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Headpiece
	[40572]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Greaves
	[40573]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Spaulders
	[40574]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Chestpiece
	[40575]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Gauntlets
	[40576]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Helm
	[40577]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Legplates
	[40578]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Shoulderplates
	[40579]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Breastplate
	[40580]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Handguards
	[40581]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Faceguard
	[40582]="0:15:1:1:Junk::1:0:", -- Scourgestone
	[40583]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Legguards
	[40584]="0:4:4:1:Plate::1:0:28997", -- Valorous Redemption Shoulderguards
	[40585]="85000000:4:4:1:Ring::1:0:32172", -- Signet of the Kirin Tor
	[40586]="85000000:4:4:1:Ring::1:0:32172", -- Band of the Kirin Tor
	[40587]="0:12:1:1:::1:0:", -- Darkmender's Tincture
	[40588]="0:4:4:1:Mail::1:0:", -- Tunic of the Artifact Guardian
	[40589]="0:4:4:1:Plate::1:0:", -- Legplates of Sovereignty
	[40590]="0:4:4:1:Plate::1:0:", -- Elevated Lair Pauldrons
	[40591]="0:4:4:1:Plate::1:0:", -- Melancholy Sabatons
	[40592]="0:4:4:1:Plate::1:0:", -- Boots of Healing Energies
	[40593]="0:4:3:1:Trinket::1:0:16786", -- Argent Tome
	[40594]="0:4:4:1:Leather::1:0:", -- Spaulders of Catatonia
	[40600]="0:12:1:1:::1:0:", -- Bone Gryphon
	[40601]="0:4:3:1:Trinket::1:0:16786", -- Argent Dawn Banner
	[40602]="0:4:4:1:Cloth::1:0:", -- Robes of Mutation
	[40603]="0:12:1:12:::1:0:", -- Charred Wreckage
	[40610]="0:15:4:1:ArmorToken::1:0:31580,31582", -- Chestguard of the Lost Conqueror
	[40611]="0:15:4:1:ArmorToken::1:0:31580,31582", -- Chestguard of the Lost Protector
	[40612]="0:15:4:1:ArmorToken::1:0:31580,31582", -- Chestguard of the Lost Vanquisher
	[40613]="0:15:4:1:ArmorToken::1:0:31580,31582", -- Gloves of the Lost Conqueror
	[40614]="0:15:4:1:ArmorToken::1:0:31580,31582", -- Gloves of the Lost Protector
	[40615]="0:15:4:1:ArmorToken::1:0:31580,31582", -- Gloves of the Lost Vanquisher
	[40616]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Lost Conqueror
	[40617]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Lost Protector
	[40618]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Lost Vanquisher
	[40619]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Lost Conqueror
	[40620]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Lost Protector
	[40621]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Lost Vanquisher
	[40622]="0:15:4:1:ArmorToken::1:0:", -- Spaulders of the Lost Conqueror
	[40623]="0:15:4:1:ArmorToken::1:0:", -- Spaulders of the Lost Protector
	[40624]="0:15:4:1:ArmorToken::1:0:", -- Spaulders of the Lost Vanquisher
	[40625]="0:15:4:1:ArmorToken::1:0:", -- Breastplate of the Lost Conqueror
	[40626]="0:15:4:1:ArmorToken::1:0:", -- Breastplate of the Lost Protector
	[40627]="0:15:4:1:ArmorToken::1:0:", -- Breastplate of the Lost Vanquisher
	[40628]="0:15:4:1:ArmorToken::1:0:", -- Gauntlets of the Lost Conqueror
	[40629]="0:15:4:1:ArmorToken::1:0:", -- Gauntlets of the Lost Protector
	[40630]="0:15:4:1:ArmorToken::1:0:", -- Gauntlets of the Lost Vanquisher
	[40631]="0:15:4:1:ArmorToken::1:0:", -- Crown of the Lost Conqueror
	[40632]="0:15:4:1:ArmorToken::1:0:", -- Crown of the Lost Protector
	[40633]="0:15:4:1:ArmorToken::1:0:", -- Crown of the Lost Vanquisher
	[40634]="0:15:4:1:ArmorToken::1:0:31579,31581", -- Legplates of the Lost Conqueror
	[40635]="0:15:4:1:ArmorToken::1:0:31579,31581", -- Legplates of the Lost Protector
	[40636]="0:15:4:1:ArmorToken::1:0:31579,31581", -- Legplates of the Lost Vanquisher
	[40637]="0:15:4:1:ArmorToken::1:0:31579,31581", -- Mantle of the Lost Conqueror
	[40638]="0:15:4:1:ArmorToken::1:0:31579,31581", -- Mantle of the Lost Protector
	[40639]="0:15:4:1:ArmorToken::1:0:31579,31581", -- Mantle of the Lost Vanquisher
	[40640]="0:12:1:20:::1:0:", -- Onslaught Intel Documents
	[40641]="0:13:1:5:::1:0:", -- Cold Iron Key
	[40642]="0:12:1:1:::1:0:", -- Sparksocket's Tools
	[40643]="0:4:4:1:Tabard::1:0:", -- Tabard of the Achiever
	[40645]="0:12:1:20:::1:0:", -- Dried Gnoll Rations
	[40652]="0:13:1:250:::1:0:", -- Scarlet Onslaught Trunk Key
	[40653]="0:15:3:1:Companion::1:0:", -- Reeking Pet Carrier
	[40666]="0:12:1:1:::1:0:", -- Note from the Grand Admiral
	[40668]="0:4:2:1:Shield::1:0:", -- Cobalt Triangle Shield
	[40669]="0:4:3:1:Plate::1:0:", -- Tempered Saronite Belt
	[40670]="0:4:3:1:Shield::1:0:", -- Saronite Defender
	[40671]="0:4:3:1:Plate::1:0:", -- Tempered Saronite Boots
	[40672]="0:4:3:1:Plate::1:0:", -- Tempered Saronite Breastplate
	[40673]="0:4:3:1:Plate::1:0:", -- Tempered Saronite Helm
	[40674]="0:4:3:1:Plate::1:0:", -- Tempered Saronite Legplates
	[40675]="0:4:3:1:Plate::1:0:", -- Tempered Saronite Shoulders
	[40676]="0:12:1:1:::1:0:", -- Improved Land Mines
	[40678]="0:4:4:1:Amulet::1:0:31580,31582,32172", -- Pendant of the Outcast Hero
	[40679]="0:4:4:1:Amulet::1:0:31580,31582,32172", -- Chained Military Gorget
	[40680]="0:4:4:1:Amulet::1:0:31580,31582,32172", -- Encircling Burnished Gold Chains
	[40681]="0:4:4:1:Amulet::1:0:31580,31582,32172", -- Lattice Choker of Light
	[40682]="0:4:4:1:Trinket::1:0:29528,31580,31582", -- Sundial of the Exiled
	[40683]="0:4:4:1:Trinket::1:0:29528,31580,31582", -- Valor Medal of the First War
	[40684]="0:4:4:1:Trinket::1:0:29528,31580,31582", -- Mirror of Truth
	[40685]="0:4:4:1:Trinket::1:0:29528,31580,31582", -- The Egg of Mortal Essence
	[40686]="0:12:1:1:::1:0:", -- U.D.E.D.
	[40687]="0:4:0:1:Ring::1:0:", -- Flores' Lost Seal of Approval
	[40688]="0:4:4:1:Plate::1:0:28997,31580,31582", -- Verdungo's Barbarian Cord
	[40689]="0:4:4:1:Plate::1:0:28997,31580,31582", -- Waistguard of Living Iron
	[40690]="0:12:1:1:::1:0:", -- Runes of the Yrkvinn
	[40691]="0:4:4:1:Plate::1:0:28997,31580,31582", -- Magroth's Meditative Cincture
	[40692]="0:4:4:1:Mail::1:0:29523,31580,31582", -- Vereesa's Silver Chain Belt
	[40693]="0:4:4:1:Mail::1:0:29523,31580,31582", -- Beadwork Belt of Shamanic Vision
	[40694]="0:4:4:1:Leather::1:0:28992,29538,31580,31582", -- Jorach's Crocolisk Skin Belt
	[40695]="0:4:4:1:Leather::1:0:28992,29538,31580,31582", -- Vine Belt of the Woodland Dryad
	[40696]="0:4:4:1:Cloth::1:0:28995,31580,31582", -- Plush Sash of Guzbah
	[40697]="0:4:4:1:Cloth::1:0:28995,31580,31582", -- Elegant Temple Gardens' Girdle
	[40698]="0:4:4:1:OffHandFrill::1:0:29527,31580,31582", -- Ward of the Violet Citadel
	[40699]="0:4:4:1:OffHandFrill::1:0:29527,31580,31582", -- Handbook of Obscure Remedies
	[40700]="0:4:4:1:Shield::1:0:28990,31580,31582", -- Protective Barricade of the Light
	[40701]="0:4:4:1:Shield::1:0:28990,31580,31582", -- Crygil's Discarded Plate Panel
	[40702]="0:2:4:1:Dagger::1:0:29499,29538,31580,31582", -- Rolfsen's Ripper
	[40703]="0:2:4:1:OneHandSword::1:0:28991,31580,31582", -- Grasscutter
	[40704]="0:2:4:1:FistWeapon::1:0:29499,29538,31580,31582", -- Pride
	[40705]="0:4:4:1:Libram::1:0:29529,31580,31582", -- Libram of Renewal
	[40706]="0:4:4:1:Libram::1:0:29529,31580,31582", -- Libram of Reciprocation
	[40707]="0:4:4:1:Libram::1:0:29529,31580,31582", -- Libram of Obstruction
	[40708]="0:4:4:1:Totem::1:0:29529,31580,31582", -- Totem of the Elemental Plane
	[40709]="0:4:4:1:Totem::1:0:29529,31580,31582", -- Totem of Forest Growth
	[40710]="0:4:4:1:Totem::1:0:29529,31580,31582", -- Totem of Splintering
	[40711]="0:4:4:1:Idol::1:0:29529,31580,31582", -- Idol of Lush Moss
	[40712]="0:4:4:1:Idol::1:0:29529,31580,31582", -- Idol of Steadfast Renewal
	[40713]="0:4:4:1:Idol::1:0:29529,31580,31582", -- Idol of the Ravenous Beast
	[40714]="0:4:4:1:Sigil::1:0:29529,31580,31582", -- Sigil of the Unfaltering Knight
	[40715]="0:4:4:1:Sigil::1:0:29529,31580,31582", -- Sigil of Haunted Dreams
	[40716]="0:2:4:1:Thrown::1:0:29493,29499,29538,31580,31582", -- Lillehoff's Winged Blades
	[40717]="0:4:4:1:Ring::1:0:31579,31581,32172", -- Ring of Invincibility
	[40718]="0:4:4:1:Ring::1:0:31579,31581,32172", -- Signet of the Impregnable Fortress
	[40719]="0:4:4:1:Ring::1:0:31579,31581,32172", -- Band of Channeled Magic
	[40720]="0:4:4:1:Ring::1:0:31579,31581,32172", -- Renewal of Life
	[40721]="0:4:4:1:Cloak::1:0:29495,31579,31581", -- Hammerhead Sharkskin Cloak
	[40722]="0:4:4:1:Cloak::1:0:29495,31579,31581", -- Platinum Mesh Cloak
	[40723]="0:4:4:1:Cloak::1:0:29495,31579,31581", -- Disguise of the Kumiho
	[40724]="0:4:4:1:Cloak::1:0:29495,31579,31581", -- Cloak of Kea Feathers
	[40726]="0:12:1:10:::1:0:", -- K3 Equipment
	[40728]="0:12:1:12:::1:0:", -- Hearty Mammoth Meat
	[40730]="0:12:1:1:::1:0:", -- Arete's Gate
	[40731]="0:12:1:1:::1:0:", -- Transporter Power Cell
	[40732]="0:13:1:1:::1:0:", -- Acherus Shackle Key
	[40733]="0:4:4:1:Plate::1:0:28997,31579,31581", -- Wristbands of the Sentinel Huntress
	[40734]="0:4:4:1:Plate::1:0:28997,31579,31581", -- Bracers of Dalaran's Parapets
	[40735]="0:4:4:1:Plate::1:0:28997,31579,31581", -- Zartson's Jungle Vambraces
	[40736]="0:4:4:1:Mail::1:0:29523,31579,31581", -- Armguard of the Tower Archer
	[40737]="0:4:4:1:Mail::1:0:29523,31579,31581", -- Pigmented Clan Bindings
	[40738]="0:4:4:1:Leather::1:0:28992,29538,31579,31581", -- Wristwraps of the Cutthroat
	[40739]="0:4:4:1:Leather::1:0:28992,29538,31579,31581", -- Bands of the Great Tree
	[40740]="0:4:4:1:Cloth::1:0:28995,31579,31581", -- Wraps of the Astral Traveler
	[40741]="0:4:4:1:Cloth::1:0:31579,31581", -- Cuffs of the Shadow Ascendant
	[40742]="0:4:4:1:Plate::1:0:28997,29703,31579,31581", -- Bladed Steelboots
	[40743]="0:4:4:1:Plate::1:0:28997,29703,31579,31581", -- Kyzoc's Ground Stompers
	[40744]="0:12:1:12:::1:0:", -- Impure Saronite Ore
	[40745]="0:4:4:1:Plate::1:0:28997,29703,31579,31581", -- Sabatons of Rapid Recovery
	[40746]="0:4:4:1:Mail::1:0:29523,29703,31579,31581", -- Pack-Ice Striders
	[40747]="0:4:4:1:Mail::1:0:29523,29703,31579,31581", -- Treads of Coastal Wandering
	[40748]="0:4:4:1:Leather::1:0:28992,29538,29703,31579,31581", -- Boots of Captain Ellis
	[40749]="0:4:4:1:Leather::1:0:28992,29538,29703,31579,31581", -- Rainey's Chewed Boots
	[40750]="0:4:4:1:Cloth::1:0:28995,29703,31579,31581", -- Xintor's Expeditionary Boots
	[40751]="0:4:4:1:Cloth::1:0:28995,29703,31579,31581", -- Slippers of the Holy Light
	[40752]="0:10:4::Currency::1:0:31579,31581,35790", -- Emblem of Heroism
	[40753]="0:10:4::Currency::1:0:33963,33964,35790", -- Emblem of Valor
	[40755]="0:4:3:1:Plate::1:0:", -- Enticing Sabatons
	[40756]="0:4:3:1:Mail::1:0:", -- Shoulders of the Seducer
	[40757]="0:4:3:1:Leather::1:0:", -- Shackles of Dark Whispers
	[40758]="0:4:3:1:Cloth::1:0:", -- Shroud of Temptation
	[40767]="0:4:3:1:Trinket::1:0:", -- Sonic Booster
	[40768]="0:7:3:1:Device::1:0:", -- MOLL-E
	[40769]="0:15:1:20:CombatPet:202:1:0:", -- Scrapbot Construction Kit
	[40771]="0:7:1:20:Explosive::1:0:", -- Cobalt Frag Bomb
	[40772]="0:7:1:1:Device::1:0:", -- Gnomish Army Knife
	[40773]="0:0:1:1:EnhTemp::1:0:", -- Master Firestone
	[40775]="10000000:15:4:1:FlyingMount::1:0:29587", -- Winged Steed of the Ebon Blade
	[40778]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Plate Chestpiece
	[40779]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Dreadplate Chestpiece
	[40780]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Scaled Chestpiece
	[40781]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Dreadplate Chestpiece
	[40782]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Scaled Chestpiece
	[40783]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Plate Chestpiece
	[40784]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Dreadplate Chestpiece
	[40785]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Scaled Chestpiece
	[40786]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Plate Chestpiece
	[40787]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dreadplate Chestpiece
	[40788]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Scaled Chestpiece
	[40789]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Plate Chestpiece
	[40790]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Plate Chestpiece
	[40791]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dreadplate Chestpiece
	[40792]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Scaled Chestpiece
	[40797]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Plate Gauntlets
	[40798]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Scaled Gauntlets
	[40799]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Dreadplate Gauntlets
	[40801]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Plate Gauntlets
	[40802]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Scaled Gauntlets
	[40803]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Dreadplate Gauntlets
	[40804]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Plate Gauntlets
	[40805]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Scaled Gauntlets
	[40806]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Dreadplate Gauntlets
	[40807]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Plate Gauntlets
	[40808]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Scaled Gauntlets
	[40809]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dreadplate Gauntlets
	[40810]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Plate Gauntlets
	[40811]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dreadplate Gauntlets
	[40812]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Scaled Gauntlets
	[40816]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Plate Helm
	[40817]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Dreadplate Helm
	[40818]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Scaled Helm
	[40819]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Plate Helm
	[40820]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Dreadplate Helm
	[40821]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Scaled Helm
	[40822]="0:4:3:1:Sigil::1:0:27730,27760", -- Sigil of the Frozen Conscience
	[40823]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Plate Helm
	[40824]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Dreadplate Helm
	[40825]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Scaled Helm
	[40826]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Plate Helm
	[40827]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dreadplate Helm
	[40828]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Scaled Helm
	[40829]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Plate Helm
	[40830]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dreadplate Helm
	[40831]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Scaled Helm
	[40836]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Plate Legguards
	[40837]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Dreadplate Legguards
	[40838]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Scaled Legguards
	[40840]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Plate Legguards
	[40841]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Dreadplate Legguards
	[40842]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Scaled Legguards
	[40844]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Plate Legguards
	[40845]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Dreadplate Legguards
	[40846]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Scaled Legguards
	[40847]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Plate Legguards
	[40848]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dreadplate Legguards
	[40849]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Scaled Legguards
	[40850]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Plate Legguards
	[40851]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dreadplate Legguards
	[40852]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Scaled Legguards
	[40856]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Plate Shoulders
	[40857]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Dreadplate Shoulders
	[40858]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Scaled Shoulders
	[40859]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Plate Shoulders
	[40860]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Dreadplate Shoulders
	[40861]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Scaled Shoulders
	[40862]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Plate Shoulders
	[40863]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Dreadplate Shoulders
	[40864]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Scaled Shoulders
	[40865]="0:4:3:1:Trinket::1:0:", -- Noise Machine
	[40866]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Plate Shoulders
	[40867]="0:4:3:1:Sigil::1:0:27730,27760", -- Sigil of the Wild Buck
	[40868]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dreadplate Shoulders
	[40869]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Scaled Shoulders
	[40870]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Plate Shoulders
	[40871]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dreadplate Shoulders
	[40872]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Scaled Shoulders
	[40875]="0:4:3:1:Sigil::1:0:27730,27760", -- Sigil of Arthritic Binding
	[40877]="0:4:4:1:Plate::1:0:32381", -- Hateful Gladiator's Girdle of Triumph
	[40878]="0:4:4:1:Plate::1:0:32381", -- Hateful Gladiator's Greaves of Triumph
	[40879]="0:4:4:1:Plate::1:0:", -- Deadly Gladiator's Girdle of Triumph
	[40880]="0:4:4:1:Plate::1:0:", -- Deadly Gladiator's Greaves of Triumph
	[40881]="0:4:4:1:Plate::1:0:", -- Furious Gladiator's Girdle of Triumph
	[40882]="0:4:4:1:Plate::1:0:", -- Furious Gladiator's Greaves of Triumph
	[40883]="0:4:4:1:Plate::1:0:34038,34075", -- Relentless Gladiator's Girdle of Triumph
	[40884]="0:4:4:1:Plate::1:0:34038,34075", -- Relentless Gladiator's Greaves of Triumph
	[40887]="0:4:4:1:Plate::1:0:32381", -- Hateful Gladiator's Bracers of Triumph
	[40888]="0:4:4:1:Plate::1:0:", -- Deadly Gladiator's Bracers of Triumph
	[40889]="0:4:4:1:Plate::1:0:", -- Furious Gladiator's Bracers of Triumph
	[40890]="0:4:4:1:Plate::1:0:34038,34075", -- Relentless Gladiator's Bracers of Triumph
	[40892]="0:7:1:1:Device::1:0:", -- Hammer Pick
	[40893]="0:7:1:1:Device::1:0:", -- Bladed Pickaxe
	[40895]="0:4:3:1:Miscellaneous::1:0:", -- Gnomish X-Ray Specs
	[40896]="0:16:1:20:Druid::1:0:", -- Glyph of Frenzied Regeneration
	[40897]="0:16:1:20:Druid::1:0:", -- Glyph of Maul
	[40898]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Ornamented Chestguard
	[40899]="0:16:1:20:Druid::1:0:", -- Glyph of Growl
	[40900]="0:16:1:20:Druid::1:0:", -- Glyph of Mangle
	[40901]="0:16:1:20:Druid::1:0:", -- Glyph of Shred
	[40902]="0:16:1:20:Druid::1:0:", -- Glyph of Rip
	[40903]="0:16:1:20:Druid::1:0:", -- Glyph of Rake
	[40904]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Ornamented Chestguard
	[40905]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Ornamented Chestguard
	[40906]="0:16:1:20:Druid::1:0:", -- Glyph of Swiftmend
	[40907]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ornamented Chestguard
	[40908]="0:16:1:20:Druid::1:0:", -- Glyph of Innervate
	[40909]="0:16:1:20:Druid::1:0:", -- Glyph of Rebirth
	[40910]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ornamented Chestguard
	[40912]="0:16:1:20:Druid::1:0:", -- Glyph of Regrowth
	[40913]="0:16:1:20:Druid::1:0:", -- Glyph of Rejuvenation
	[40914]="0:16:1:20:Druid::1:0:", -- Glyph of Healing Touch
	[40915]="0:16:1:20:Druid::1:0:", -- Glyph of Lifebloom
	[40916]="0:16:1:20:Druid::1:0:", -- Glyph of Starfire
	[40917]="0:12:1:1:::1:0:", -- Lord-Commander's Nullifier
	[40918]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Ornamented Gloves
	[40919]="0:16:1:20:Druid::1:0:", -- Glyph of Insect Swarm
	[40920]="0:16:1:20:Druid::1:0:", -- Glyph of Hurricane
	[40921]="0:16:1:20:Druid::1:0:", -- Glyph of Starfall
	[40922]="0:16:1:20:Druid::1:0:", -- Glyph of Wrath
	[40923]="0:16:1:20:Druid::1:0:", -- Glyph of Moonfire
	[40924]="0:16:1:20:Druid::1:0:", -- Glyph of Entangling Roots
	[40925]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Ornamented Gloves
	[40926]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Ornamented Gloves
	[40927]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ornamented Gloves
	[40928]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ornamented Gloves
	[40930]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Ornamented Headcover
	[40931]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Ornamented Headcover
	[40932]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Ornamented Headcover
	[40933]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ornamented Headcover
	[40934]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ornamented Headcover
	[40936]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Ornamented Legplates
	[40937]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Ornamented Legplates
	[40938]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Ornamented Legplates
	[40939]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ornamented Legplates
	[40940]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ornamented Legplates
	[40942]="0:4:2:1:Plate::1:0:", -- Spiked Cobalt Helm
	[40943]="0:4:2:1:Plate::1:0:", -- Spiked Cobalt Legplates
	[40944]="0:12:1:12:::1:0:", -- Icetip Venom Sac
	[40946]="0:12:1:1:::1:0:", -- Anuniaq's Net
	[40947]="0:12:1:1:::1:0:", -- Burlap-Wrapped Note
	[40949]="0:4:2:1:Plate::1:0:", -- Spiked Cobalt Boots
	[40950]="0:4:2:1:Plate::1:0:", -- Spiked Cobalt Shoulders
	[40951]="0:4:2:1:Plate::1:0:", -- Spiked Cobalt Chestpiece
	[40952]="0:4:2:1:Plate::1:0:", -- Spiked Cobalt Gauntlets
	[40953]="0:4:2:1:Plate::1:0:", -- Spiked Cobalt Belt
	[40954]="0:4:2:1:Plate::1:0:", -- Spiked Cobalt Bracers
	[40955]="0:4:2:1:Plate::1:0:", -- Horned Cobalt Helm
	[40956]="0:4:2:1:Plate::1:0:", -- Reinforced Cobalt Shoulders
	[40957]="0:4:2:1:Plate::1:0:", -- Reinforced Cobalt Helm
	[40958]="0:4:2:1:Plate::1:0:", -- Reinforced Cobalt Legplates
	[40959]="0:4:2:1:Plate::1:0:", -- Reinforced Cobalt Chestpiece
	[40960]="0:4:3:1:Plate::1:0:31580,31582", -- Savage Gladiator's Ornamented Spaulders
	[40961]="0:4:4:1:Plate::1:0:31579,31581", -- Hateful Gladiator's Ornamented Spaulders
	[40962]="0:4:4:1:Plate::1:0:33963,33964", -- Deadly Gladiator's Ornamented Spaulders
	[40963]="0:4:4:1:Plate::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ornamented Spaulders
	[40964]="0:4:4:1:Plate::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ornamented Spaulders
	[40966]="0:4:4:1:Plate::1:0:32381", -- Hateful Gladiator's Girdle of Salvation
	[40969]="0:12:1:1:::1:0:", -- Improved Land Mines
	[40970]="0:12:1:1:::1:0:", -- Onslaught Gryphon Reins
	[40971]="0:12:1:1:::1:0:", -- Brann's Communicator
	[40972]="0:4:4:1:Plate::1:0:32381", -- Hateful Gladiator's Bracers of Salvation
	[40973]="0:4:4:1:Plate::1:0:32381", -- Hateful Gladiator's Greaves of Salvation
	[40974]="0:4:4:1:Plate::1:0:", -- Deadly Gladiator's Girdle of Salvation
	[40975]="0:4:4:1:Plate::1:0:", -- Deadly Gladiator's Greaves of Salvation
	[40976]="0:4:4:1:Plate::1:0:", -- Furious Gladiator's Girdle of Salvation
	[40977]="0:4:4:1:Plate::1:0:", -- Furious Gladiator's Greaves of Salvation
	[40978]="0:4:4:1:Plate::1:0:34038,34075", -- Relentless Gladiator's Girdle of Salvation
	[40979]="0:4:4:1:Plate::1:0:34038,34075", -- Relentless Gladiator's Greaves of Salvation
	[40982]="0:4:4:1:Plate::1:0:", -- Deadly Gladiator's Bracers of Salvation
	[40983]="0:4:4:1:Plate::1:0:", -- Furious Gladiator's Bracers of Salvation
	[40984]="0:4:4:1:Plate::1:0:34038,34075", -- Relentless Gladiator's Bracers of Salvation
	[40986]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Ringmail Armor
	[40987]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Mail Armor
	[40988]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Ringmail Armor
	[40989]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Mail Armor
	[40990]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Ringmail Armor
	[40991]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Mail Armor
	[40992]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ringmail Armor
	[40993]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mail Armor
	[40994]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ringmail Armor
	[40995]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mail Armor
	[40998]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Ringmail Gauntlets
	[40999]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Ringmail Gauntlets
	[41000]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Ringmail Gauntlets
	[41001]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ringmail Gauntlets
	[41002]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ringmail Gauntlets
	[41004]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Mail Gauntlets
	[41005]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Mail Gauntlets
	[41006]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Mail Gauntlets
	[41007]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mail Gauntlets
	[41008]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mail Gauntlets
	[41010]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Ringmail Helm
	[41011]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Ringmail Helm
	[41012]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Ringmail Helm
	[41013]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ringmail Helm
	[41014]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ringmail Helm
	[41016]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Mail Helm
	[41017]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Mail Helm
	[41018]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Mail Helm
	[41019]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mail Helm
	[41020]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mail Helm
	[41023]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Ringmail Leggings
	[41024]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Ringmail Spaulders
	[41025]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Ringmail Leggings
	[41026]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Ringmail Leggings
	[41027]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ringmail Leggings
	[41028]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ringmail Leggings
	[41030]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Mail Leggings
	[41031]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Mail Leggings
	[41032]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Mail Leggings
	[41033]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mail Leggings
	[41034]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mail Leggings
	[41036]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Ringmail Spaulders
	[41037]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Ringmail Spaulders
	[41038]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Ringmail Spaulders
	[41039]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Ringmail Spaulders
	[41041]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Mail Spaulders
	[41042]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Mail Spaulders
	[41043]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Mail Spaulders
	[41044]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mail Spaulders
	[41045]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mail Spaulders
	[41047]="0:4:4:1:Mail::1:0:32381", -- Hateful Gladiator's Wristguards of Salvation
	[41048]="0:4:4:1:Mail::1:0:", -- Deadly Gladiator's Waistguard of Salvation
	[41049]="0:4:4:1:Mail::1:0:32381", -- Hateful Gladiator's Sabatons of Salvation
	[41050]="0:4:4:1:Mail::1:0:32381", -- Hateful Gladiator's Waistguard of Salvation
	[41051]="0:4:4:1:Mail::1:0:", -- Furious Gladiator's Waistguard of Salvation
	[41052]="0:4:4:1:Mail::1:0:34038,34075", -- Relentless Gladiator's Waistguard of Salvation
	[41054]="0:4:4:1:Mail::1:0:", -- Deadly Gladiator's Sabatons of Salvation
	[41055]="0:4:4:1:Mail::1:0:", -- Furious Gladiator's Sabatons of Salvation
	[41056]="0:4:4:1:Mail::1:0:34038,34075", -- Relentless Gladiator's Sabatons of Salvation
	[41058]="0:12:1:1:::1:0:", -- Hyldnir Harpoon
	[41059]="0:4:4:1:Mail::1:0:", -- Deadly Gladiator's Wristguards of Salvation
	[41060]="0:4:4:1:Mail::1:0:", -- Furious Gladiator's Wristguards of Salvation
	[41061]="0:4:4:1:Mail::1:0:34038,34075", -- Relentless Gladiator's Wristguards of Salvation
	[41063]="0:4:4:1:Mail::1:0:32381", -- Hateful Gladiator's Wristguards of Dominance
	[41064]="0:4:4:1:Mail::1:0:", -- Deadly Gladiator's Wristguards of Dominance
	[41065]="0:4:4:1:Mail::1:0:", -- Furious Gladiator's Wristguards of Dominance
	[41066]="0:4:4:1:Mail::1:0:34038,34075", -- Relentless Gladiator's Wristguards of Dominance
	[41068]="0:4:4:1:Mail::1:0:32381", -- Hateful Gladiator's Waistguard of Dominance
	[41069]="0:4:4:1:Mail::1:0:", -- Deadly Gladiator's Waistguard of Dominance
	[41070]="0:4:4:1:Mail::1:0:", -- Furious Gladiator's Waistguard of Dominance
	[41071]="0:4:4:1:Mail::1:0:34038,34075", -- Relentless Gladiator's Waistguard of Dominance
	[41073]="0:4:4:1:Mail::1:0:32381", -- Hateful Gladiator's Sabatons of Dominance
	[41074]="0:4:4:1:Mail::1:0:", -- Deadly Gladiator's Sabatons of Dominance
	[41075]="0:4:4:1:Mail::1:0:", -- Furious Gladiator's Sabatons of Dominance
	[41076]="0:4:4:1:Mail::1:0:34038,34075", -- Relentless Gladiator's Sabatons of Dominance
	[41078]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Linked Armor
	[41079]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Linked Armor
	[41080]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Linked Armor
	[41081]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Linked Armor
	[41082]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Linked Armor
	[41084]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Chain Armor
	[41085]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Chain Armor
	[41086]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Chain Armor
	[41087]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Chain Armor
	[41088]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Chain Armor
	[41092]="0:16:1:20:Paladin::1:0:", -- Glyph of Judgement
	[41094]="0:16:1:20:Paladin::1:0:", -- Glyph of Seal of Command
	[41095]="0:16:1:20:Paladin::1:0:", -- Glyph of Hammer of Justice
	[41096]="0:16:1:20:Paladin::1:0:", -- Glyph of Spiritual Attunement
	[41097]="0:16:1:20:Paladin::1:0:", -- Glyph of Hammer of Wrath
	[41098]="0:16:1:20:Paladin::1:0:", -- Glyph of Crusader Strike
	[41099]="0:16:1:20:Paladin::1:0:", -- Glyph of Consecration
	[41100]="0:16:1:20:Paladin::1:0:", -- Glyph of Righteous Defense
	[41101]="0:16:1:20:Paladin::1:0:", -- Glyph of Avenger's Shield
	[41102]="0:16:1:20:Paladin::1:0:", -- Glyph of Turn Evil
	[41103]="0:16:1:20:Paladin::1:0:", -- Glyph of Exorcism
	[41104]="0:16:1:20:Paladin::1:0:", -- Glyph of Cleansing
	[41105]="0:16:1:20:Paladin::1:0:", -- Glyph of Flash of Light
	[41106]="0:16:1:20:Paladin::1:0:", -- Glyph of Holy Light
	[41107]="0:16:1:20:Paladin::1:0:", -- Glyph of Avenging Wrath
	[41108]="0:16:1:20:Paladin::1:0:", -- Glyph of Divinity
	[41109]="0:16:1:20:Paladin::1:0:", -- Glyph of Seal of Wisdom
	[41110]="0:16:1:20:Paladin::1:0:", -- Glyph of Seal of Light
	[41112]="0:4:3:1:Cloth::1:0:", -- Mechanized Snow Goggles
	[41113]="0:4:3:1:Shield::1:0:", -- Saronite Bulwark
	[41114]="0:4:3:1:Plate::1:0:", -- Tempered Saronite Gauntlets
	[41115]="0:12:1:1:::1:0:", -- Ragemane's Flipper
	[41116]="0:4:3:1:Plate::1:0:", -- Tempered Saronite Bracers
	[41117]="0:4:3:1:Shield::1:0:", -- Saronite Protector
	[41119]="0:7:1:20:Explosive::1:0:", -- Saronite Bomb
	[41120]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Reinforced Cobalt Legplates
	[41121]="0:4:3:1:Trinket::1:0:", -- Gnomish Lightning Generator
	[41122]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Reinforced Cobalt Chestpiece
	[41123]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Reinforced Cobalt Helm
	[41124]="0:9:2:1:Blacksmithing::1:0:", -- Plans: Reinforced Cobalt Shoulders
	[41126]="0:4:3:1:Plate::1:0:", -- Brilliant Saronite Legplates
	[41127]="0:4:3:1:Plate::1:0:", -- Brilliant Saronite Gauntlets
	[41128]="0:4:3:1:Plate::1:0:", -- Brilliant Saronite Boots
	[41129]="0:4:3:1:Plate::1:0:", -- Brilliant Saronite Breastplate
	[41130]="0:12:1:6:::1:0:", -- Inventor's Disk Fragment
	[41131]="0:12:1:1:::1:0:", -- Rageclaw Fire Extinguisher
	[41132]="0:12:1:1:::1:0:", -- The Inventor's Disk
	[41133]="0:15:3:1:Companion::1:0:", -- Unhatched Mr. Chilly
	[41134]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Linked Gauntlets
	[41135]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Linked Gauntlets
	[41136]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Linked Gauntlets
	[41137]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Linked Gauntlets
	[41138]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Linked Gauntlets
	[41140]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Chain Gauntlets
	[41141]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Chain Gauntlets
	[41142]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Chain Gauntlets
	[41143]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Chain Gauntlets
	[41144]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Chain Gauntlets
	[41146]="0:0:3:5:EnhPerm:202:1:0:", -- Sun Scope
	[41148]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Linked Helm
	[41149]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Linked Helm
	[41150]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Linked Helm
	[41151]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Linked Helm
	[41152]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Linked Helm
	[41154]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Chain Helm
	[41155]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Chain Helm
	[41156]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Chain Helm
	[41157]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Chain Helm
	[41158]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Chain Helm
	[41160]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Linked Leggings
	[41161]="0:12:1:10:::1:0:", -- Drakuru "Lock Opener"
	[41162]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Linked Leggings
	[41163]="0:7:2:20:MetalStone:164,333,202,755,186:1:0:", -- Titanium Bar
	[41164]="0:6:3:1000:Bullet::1:0:", -- Mammoth Cutters
	[41165]="0:6:3:1000:Arrow::1:0:", -- Saronite Razorheads
	[41166]="0:0:1:20:Potion::1:0:", -- Runic Healing Injector
	[41167]="0:0:3:5:EnhPerm::1:0:", -- Heartseeker Scope
	[41168]="0:2:4:1:Gun::1:0:", -- Armor Plated Combat Shotgun
	[41169]="0:0:1:1:EnhTemp::1:0:", -- Firestone
	[41170]="0:0:1:1:EnhTemp::1:0:", -- Lesser Firestone
	[41171]="0:0:1:1:EnhTemp::1:0:", -- Greater Firestone
	[41172]="0:0:1:1:EnhTemp::1:0:", -- Major Firestone
	[41173]="0:0:1:1:EnhTemp::1:0:", -- Fel Firestone
	[41174]="0:0:1:1:EnhTemp::1:0:", -- Grand Firestone
	[41179]="0:12:1:1:::1:0:", -- The Inventor's Disk
	[41181]="0:2:3:1:TwoHandAxe::1:0:", -- Honed Cobalt Cleaver
	[41182]="0:2:3:1:OneHandSword::1:0:", -- Savage Cobalt Slicer
	[41183]="0:2:3:1:Dagger::1:0:", -- Saronite Ambusher
	[41184]="0:2:3:1:Dagger::1:0:", -- Saronite Shiv
	[41185]="0:2:3:1:OneHandMace::1:0:", -- Furious Saronite Beatstick
	[41186]="0:2:3:1:OneHandSword::1:0:", -- Corroded Saronite Edge
	[41187]="0:2:3:1:OneHandSword::1:0:", -- Corroded Saronite Woundbringer
	[41188]="0:2:3:1:TwoHandMace::1:0:", -- Saronite Mindcrusher
	[41189]="0:4:3:1:Plate::1:0:", -- Chestplate of Conquest
	[41190]="0:4:3:1:Plate::1:0:", -- Legplates of Conquest
	[41191]="0:0:1:1:EnhTemp::1:0:", -- Spellstone
	[41192]="0:0:1:1:EnhTemp::1:0:", -- Greater Spellstone
	[41193]="0:0:1:1:EnhTemp::1:0:", -- Major Spellstone
	[41194]="0:0:1:1:EnhTemp::1:0:", -- Master Spellstone
	[41195]="0:0:1:1:EnhTemp::1:0:", -- Demonic Spellstone
	[41196]="0:0:1:1:EnhTemp::1:0:", -- Grand Spellstone
	[41197]="0:12:1:1:::1:0:", -- The Inventor's Disk
	[41198]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Linked Leggings
	[41199]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Linked Leggings
	[41200]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Linked Leggings
	[41202]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Chain Leggings
	[41203]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Chain Leggings
	[41204]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Chain Leggings
	[41205]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Chain Leggings
	[41206]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Chain Leggings
	[41208]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Linked Spaulders
	[41209]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Linked Spaulders
	[41210]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Linked Spaulders
	[41211]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Linked Spaulders
	[41212]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Linked Spaulders
	[41214]="0:4:3:1:Mail::1:0:31580,31582", -- Savage Gladiator's Chain Spaulders
	[41215]="0:4:4:1:Mail::1:0:31579,31581", -- Hateful Gladiator's Chain Spaulders
	[41216]="0:4:4:1:Mail::1:0:33963,33964", -- Deadly Gladiator's Chain Spaulders
	[41217]="0:4:4:1:Mail::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Chain Spaulders
	[41218]="0:4:4:1:Mail::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Chain Spaulders
	[41223]="0:4:4:1:Mail::1:0:32381", -- Hateful Gladiator's Wristguards of Triumph
	[41224]="0:4:4:1:Mail::1:0:", -- Deadly Gladiator's Wristguards of Triumph
	[41225]="0:4:4:1:Mail::1:0:", -- Furious Gladiator's Wristguards of Triumph
	[41226]="0:4:4:1:Mail::1:0:34038,34075", -- Relentless Gladiator's Wristguards of Triumph
	[41228]="0:4:4:1:Mail::1:0:32381", -- Hateful Gladiator's Sabatons of Triumph
	[41229]="0:4:4:1:Mail::1:0:", -- Deadly Gladiator's Sabatons of Triumph
	[41230]="0:4:4:1:Mail::1:0:", -- Furious Gladiator's Sabatons of Triumph
	[41231]="0:4:4:1:Mail::1:0:34038,34075", -- Relentless Gladiator's Sabatons of Triumph
	[41233]="0:4:4:1:Mail::1:0:32381", -- Hateful Gladiator's Waistguard of Triumph
	[41234]="0:4:4:1:Mail::1:0:", -- Deadly Gladiator's Waistguard of Triumph
	[41235]="0:4:4:1:Mail::1:0:", -- Furious Gladiator's Waistguard of Triumph
	[41236]="0:4:4:1:Mail::1:0:34038,34075", -- Relentless Gladiator's Waistguard of Triumph
	[41238]="0:4:3:1:Cloak::1:0:", -- Cloak of Tormented Skies
	[41239]="0:2:2:1:OneHandSword::1:0:", -- Sturdy Cobalt Quickblade
	[41240]="0:2:2:1:OneHandMace::1:0:", -- Cobalt Tenderizer
	[41241]="0:2:2:1:Thrown::1:0:", -- Sure-fire Shuriken
	[41242]="0:2:2:1:TwoHandSword::1:0:", -- Forged Cobalt Claymore
	[41243]="0:2:2:1:OneHandAxe::1:0:", -- Notched Cobalt War Axe
	[41245]="0:2:3:1:Thrown:164:1:0:", -- Deadly Saronite Dirk
	[41248]="0:4:1:1:Shirt::1:0:", -- Red Lumberjack Shirt
	[41249]="0:4:1:1:Shirt::1:0:", -- Blue Lumberjack Shirt
	[41250]="0:4:1:1:Shirt::1:0:", -- Green Lumberjack Shirt
	[41251]="0:4:1:1:Shirt::1:0:", -- Yellow Lumberjack Shirt
	[41252]="0:4:1:1:Shirt::1:0:", -- Red Workman's Shirt
	[41253]="0:4:1:1:Shirt::1:0:", -- Blue Workman's Shirt
	[41254]="0:4:1:1:Shirt::1:0:", -- Rustic Workman's Shirt
	[41255]="0:4:1:1:Shirt::1:0:", -- Green Workman's Shirt
	[41257]="0:2:4:1:TwoHandMace::1:0:", -- Titansteel Destroyer
	[41258]="0:12:1:1:::1:0:", -- Norgannon's Shell
	[41260]="0:12:1:1:::1:0:", -- Norgannon's Core
	[41262]="0:12:1:1:::1:0:", -- Orders From Drakuru
	[41264]="0:4:3:1:Leather::1:0:", -- Deflecting Bracers
	[41265]="0:12:1:1:::1:0:", -- Eyesore Blaster
	[41266]="0:3:3:20:GemMeta:755:1:0:", -- Skyflare Diamond
	[41267]="0:12:1:1:::1:0:", -- SCRAP-E Access Card
	[41268]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Kodohide Gloves
	[41269]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Kodohide Helm
	[41270]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Kodohide Legguards
	[41271]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Kodohide Spaulders
	[41272]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Kodohide Robes
	[41273]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Kodohide Spaulders
	[41274]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Kodohide Spaulders
	[41275]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Kodohide Spaulders
	[41276]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Kodohide Spaulders
	[41278]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Wyrmhide Spaulders
	[41279]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Wyrmhide Spaulders
	[41280]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Wyrmhide Spaulders
	[41281]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Wyrmhide Spaulders
	[41282]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Wyrmhide Spaulders
	[41284]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Kodohide Gloves
	[41285]="0:3:3:1:GemMeta::1:0:", -- Chaotic Skyflare Diamond
	[41286]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Kodohide Gloves
	[41287]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Kodohide Gloves
	[41288]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Kodohide Gloves
	[41290]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Wyrmhide Gloves
	[41291]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Wyrmhide Gloves
	[41292]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Wyrmhide Gloves
	[41293]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Wyrmhide Gloves
	[41294]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Wyrmhide Gloves
	[41296]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Kodohide Legguards
	[41297]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Kodohide Legguards
	[41298]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Kodohide Legguards
	[41299]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Kodohide Legguards
	[41301]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Wyrmhide Legguards
	[41302]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Wyrmhide Legguards
	[41303]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Wyrmhide Legguards
	[41304]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Wyrmhide Legguards
	[41305]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Wyrmhide Legguards
	[41307]="0:3:3:1:GemMeta::1:0:", -- Destructive Skyflare Diamond
	[41308]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Kodohide Robes
	[41309]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Kodohide Robes
	[41310]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Kodohide Robes
	[41311]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Kodohide Robes
	[41313]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Wyrmhide Robes
	[41314]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Wyrmhide Robes
	[41315]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Wyrmhide Robes
	[41316]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Wyrmhide Robes
	[41317]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Wyrmhide Robes
	[41319]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Kodohide Helm
	[41320]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Kodohide Helm
	[41321]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Kodohide Helm
	[41322]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Kodohide Helm
	[41324]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Wyrmhide Helm
	[41325]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Wyrmhide Helm
	[41326]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Wyrmhide Helm
	[41327]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Wyrmhide Helm
	[41328]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Wyrmhide Helm
	[41330]="0:4:4:1:Leather::1:0:32381", -- Hateful Gladiator's Belt of Salvation
	[41331]="0:4:4:1:Leather::1:0:32381", -- Hateful Gladiator's Boots of Salvation
	[41332]="0:4:4:1:Leather::1:0:32381", -- Hateful Gladiator's Armwraps of Salvation
	[41333]="0:3:3:1:GemMeta::1:0:", -- Ember Skyflare Diamond
	[41334]="0:3:3:20:GemMeta:755:1:0:", -- Earthsiege Diamond
	[41335]="0:3:3:1:GemMeta::1:0:", -- Enigmatic Skyflare Diamond
	[41336]="0:12:1:12:::1:0:", -- Medical Supply Crate
	[41337]="0:15:0:20:Junk::1:0:", -- Whizzed-Out Gizmo
	[41338]="0:15:0:20:Junk::1:0:", -- Sprung Whirlygig
	[41339]="0:3:3:1:GemMeta::1:0:", -- Swift Skyflare Diamond
	[41340]="0:12:1:12:::1:0:", -- Fresh Ice Rhino Meat
	[41341]="0:12:1:20:::1:0:", -- Stormcrest Eagle Egg
	[41344]="0:4:3:1:Plate::1:0:", -- Helm of Command
	[41345]="0:4:3:1:Plate::1:0:", -- Daunting Legplates
	[41346]="0:4:3:1:Plate::1:0:", -- Righteous Greaves
	[41347]="0:4:3:1:Plate::1:0:", -- Savage Saronite Legplates
	[41348]="0:4:3:1:Plate::1:0:", -- Savage Saronite Walkers
	[41349]="0:4:3:1:Plate::1:0:", -- Savage Saronite Gauntlets
	[41350]="0:4:3:1:Plate::1:0:", -- Savage Saronite Skullshield
	[41351]="0:4:3:1:Plate::1:0:", -- Savage Saronite Pauldrons
	[41352]="0:4:3:1:Plate::1:0:", -- Savage Saronite Waistguard
	[41353]="0:4:3:1:Plate::1:0:", -- Savage Saronite Hauberk
	[41354]="0:4:3:1:Plate::1:0:", -- Savage Saronite Bracers
	[41355]="0:4:3:1:Plate:164:1:0:", -- Vengeance Bindings
	[41356]="0:4:3:1:Plate::1:0:", -- Righteous Gauntlets
	[41357]="0:4:3:1:Plate::1:0:", -- Daunting Handguards
	[41359]="0:12:1:1:::1:0:", -- Cultist Rod
	[41361]="0:12:1:1:::1:0:", -- Abomination Hook
	[41362]="0:12:1:1:::1:0:", -- Geist Rope
	[41363]="0:12:1:5:::1:0:", -- Scourge Essence
	[41366]="0:12:1:1:::1:0:", -- Sovereign Rod
	[41367]="0:0:2:1:Other::1:0:", -- Dark Jade Focusing Lens
	[41368]="0:15:0:20:Junk::1:0:", -- Expired Voodoo Power Core
	[41369]="0:15:0:20:Junk::1:0:", -- Holey Punchcard
	[41372]="0:12:1:1:::1:0:", -- Challenge Flag
	[41373]="0:15:0:5:Junk::1:0:", -- Voo Juice
	[41375]="0:3:3:1:GemMeta::1:0:", -- Tireless Skyflare Diamond
	[41376]="0:3:3:1:GemMeta::1:0:", -- Revitalizing Skyflare Diamond
	[41377]="0:3:3:1:GemMeta::1:0:", -- Effulgent Skyflare Diamond
	[41378]="0:3:3:1:GemMeta::1:0:", -- Forlorn Skyflare Diamond
	[41379]="0:3:3:1:GemMeta::1:0:", -- Impassive Skyflare Diamond
	[41380]="0:3:3:1:GemMeta::1:0:", -- Austere Earthsiege Diamond
	[41381]="0:3:3:1:GemMeta::1:0:", -- Persistent Earthsiege Diamond
	[41382]="0:3:3:1:GemMeta::1:0:", -- Trenchant Earthsiege Diamond
	[41383]="0:2:4:1:OneHandMace::1:0:", -- Titansteel Bonecrusher
	[41384]="0:2:4:1:OneHandMace::1:0:", -- Titansteel Guardian
	[41385]="0:3:3:1:GemMeta::1:0:", -- Invigorating Earthsiege Diamond
	[41386]="0:4:4:1:Plate::1:0:", -- Spiked Titansteel Helm
	[41387]="0:4:4:1:Plate::1:0:", -- Tempered Titansteel Helm
	[41388]="0:4:4:1:Plate::1:0:", -- Brilliant Titansteel Helm
	[41389]="0:3:3:1:GemMeta::1:0:", -- Beaming Earthsiege Diamond
	[41390]="0:12:1:1:::1:0:", -- Stefan's Horn
	[41391]="0:4:4:1:Plate::1:0:", -- Spiked Titansteel Treads
	[41392]="0:4:4:1:Plate::1:0:", -- Tempered Titansteel Treads
	[41393]="0:12:1:12:::1:0:", -- Frostgrip's Signet Ring
	[41394]="0:4:4:1:Plate::1:0:", -- Brilliant Titansteel Treads
	[41395]="0:3:3:1:GemMeta::1:0:", -- Bracing Earthsiege Diamond
	[41396]="0:3:3:1:GemMeta::1:0:", -- Eternal Earthsiege Diamond
	[41397]="0:3:3:1:GemMeta::1:0:", -- Powerful Earthsiege Diamond
	[41398]="0:3:3:1:GemMeta::1:0:", -- Relentless Earthsiege Diamond
	[41399]="0:12:1:10:::1:0:", -- Scourge Scrap Metal
	[41400]="0:3:3:1:GemMeta::1:0:", -- Thundering Skyflare Diamond
	[41401]="0:3:3:1:GemMeta::1:0:", -- Insightful Earthsiege Diamond
	[41424]="0:12:1:20:::1:0:", -- Icemane Yeti Hide
	[41426]="0:0:1:1:Consumable::1:0:", -- Magically Wrapped Gift
	[41427]="0:0:1:5:Other::1:0:", -- Dalaran Firework
	[41428]="0:13:1:1:::1:0:", -- Mildred's Key
	[41429]="0:3:2:1:GemOrange::1:0:", -- Perfect Wicked Huge Citrine
	[41430]="0:12:1:1:::1:0:", -- Frosthound's Collar
	[41431]="0:12:1:1:::1:0:", -- Hardpacked Explosive Bundle
	[41432]="0:3:2:1:GemRed::1:0:", -- Perfect Bold Bloodstone
	[41433]="0:3:2:1:GemRed::1:0:", -- Perfect Bright Bloodstone
	[41434]="0:3:2:1:GemRed::1:0:", -- Perfect Delicate Bloodstone
	[41435]="0:3:2:1:GemRed::1:0:", -- Perfect Flashing Bloodstone
	[41436]="0:3:2:1:GemRed::1:0:", -- Perfect Fractured Bloodstone
	[41437]="0:3:2:1:GemRed::1:0:", -- Perfect Precise Bloodstone
	[41438]="0:3:2:1:GemRed::1:0:", -- Perfect Runed Bloodstone
	[41439]="0:3:2:1:GemRed::1:0:", -- Perfect Subtle Bloodstone
	[41440]="0:3:2:1:GemBlue::1:0:", -- Perfect Lustrous Chalcedony
	[41441]="0:3:2:1:GemBlue::1:0:", -- Perfect Solid Chalcedony
	[41442]="0:3:2:1:GemBlue::1:0:", -- Perfect Sparkling Chalcedony
	[41443]="0:3:2:1:GemBlue::1:0:", -- Perfect Stormy Chalcedony
	[41444]="0:3:2:1:GemYellow::1:0:", -- Perfect Brilliant Sun Crystal
	[41445]="0:3:2:1:GemYellow::1:0:", -- Perfect Mystic Sun Crystal
	[41446]="0:3:2:1:GemYellow::1:0:", -- Perfect Quick Sun Crystal
	[41447]="0:3:2:1:GemYellow::1:0:", -- Perfect Rigid Sun Crystal
	[41448]="0:3:2:1:GemYellow::1:0:", -- Perfect Smooth Sun Crystal
	[41449]="0:3:2:1:GemYellow::1:0:", -- Perfect Thick Sun Crystal
	[41450]="0:3:2:1:GemPurple::1:0:", -- Perfect Balanced Shadow Crystal
	[41451]="0:3:2:1:GemPurple::1:0:", -- Perfect Defender's Shadow Crystal
	[41452]="0:3:2:1:GemPurple::1:0:", -- Perfect Glowing Shadow Crystal
	[41453]="0:3:2:1:GemPurple::1:0:", -- Perfect Guardian's Shadow Crystal
	[41454]="0:3:2:1:GemPurple::1:0:", -- Perfect Infused Shadow Crystal
	[41455]="0:3:2:1:GemPurple::1:0:", -- Perfect Mysterious Shadow Crystal
	[41456]="0:3:2:1:GemPurple::1:0:", -- Perfect Puissant Shadow Crystal
	[41457]="0:3:2:1:GemPurple::1:0:", -- Perfect Purified Shadow Crystal
	[41458]="0:3:2:1:GemPurple::1:0:", -- Perfect Regal Shadow Crystal
	[41459]="0:3:2:1:GemPurple::1:0:", -- Perfect Royal Shadow Crystal
	[41460]="0:3:2:1:GemPurple::1:0:", -- Perfect Shifting Shadow Crystal
	[41461]="0:3:2:1:GemPurple::1:0:", -- Perfect Sovereign Shadow Crystal
	[41462]="0:3:2:1:GemPurple::1:0:", -- Perfect Tenuous Shadow Crystal
	[41463]="0:3:2:1:GemGreen::1:0:", -- Perfect Dazzling Dark Jade
	[41464]="0:3:2:1:GemGreen::1:0:", -- Perfect Enduring Dark Jade
	[41465]="0:3:2:1:GemGreen::1:0:", -- Perfect Energized Dark Jade
	[41466]="0:3:2:1:GemGreen::1:0:", -- Perfect Forceful Dark Jade
	[41467]="0:3:2:1:GemGreen::1:0:", -- Perfect Intricate Dark Jade
	[41468]="0:3:2:1:GemGreen::1:0:", -- Perfect Jagged Dark Jade
	[41469]="0:3:2:1:GemGreen::1:0:", -- Perfect Lambent Dark Jade
	[41470]="0:3:2:1:GemGreen::1:0:", -- Perfect Misty Dark Jade
	[41471]="0:3:2:1:GemGreen::1:0:", -- Perfect Opaque Dark Jade
	[41472]="0:3:2:1:GemGreen::1:0:", -- Perfect Radiant Dark Jade
	[41473]="0:3:2:1:GemGreen::1:0:", -- Perfect Seer's Dark Jade
	[41474]="0:3:2:1:GemGreen::1:0:", -- Perfect Shattered Dark Jade
	[41475]="0:3:2:1:GemGreen::1:0:", -- Perfect Shining Dark Jade
	[41476]="0:3:2:1:GemGreen::1:0:", -- Perfect Steady Dark Jade
	[41477]="0:3:2:1:GemGreen::1:0:", -- Perfect Sundered Dark Jade
	[41478]="0:3:2:1:GemGreen::1:0:", -- Perfect Tense Dark Jade
	[41479]="0:3:2:1:GemGreen::1:0:", -- Perfect Timeless Dark Jade
	[41480]="0:3:2:1:GemGreen::1:0:", -- Perfect Turbid Dark Jade
	[41481]="0:3:2:1:GemGreen::1:0:", -- Perfect Vivid Dark Jade
	[41482]="0:3:2:1:GemOrange::1:0:", -- Perfect Accurate Huge Citrine
	[41483]="0:3:2:1:GemOrange::1:0:", -- Perfect Champion's Huge Citrine
	[41484]="0:3:2:1:GemOrange::1:0:", -- Perfect Deadly Huge Citrine
	[41485]="0:3:2:1:GemOrange::1:0:", -- Perfect Deft Huge Citrine
	[41486]="0:3:2:1:GemOrange::1:0:", -- Perfect Durable Huge Citrine
	[41487]="0:3:2:1:GemOrange::1:0:", -- Perfect Empowered Huge Citrine
	[41488]="0:3:2:1:GemOrange::1:0:", -- Perfect Etched Huge Citrine
	[41489]="0:3:2:1:GemOrange::1:0:", -- Perfect Fierce Huge Citrine
	[41490]="0:3:2:1:GemOrange::1:0:", -- Perfect Glimmering Huge Citrine
	[41491]="0:3:2:1:GemOrange::1:0:", -- Perfect Glinting Huge Citrine
	[41492]="0:3:2:1:GemOrange::1:0:", -- Perfect Inscribed Huge Citrine
	[41493]="0:3:2:1:GemOrange::1:0:", -- Perfect Lucent Huge Citrine
	[41494]="0:3:2:1:GemOrange::1:0:", -- Perfect Luminous Huge Citrine
	[41495]="0:3:2:1:GemOrange::1:0:", -- Perfect Potent Huge Citrine
	[41496]="0:3:2:1:GemOrange::1:0:", -- Perfect Pristine Huge Citrine
	[41497]="0:3:2:1:GemOrange::1:0:", -- Perfect Reckless Huge Citrine
	[41498]="0:3:2:1:GemOrange::1:0:", -- Perfect Resolute Huge Citrine
	[41499]="0:3:2:1:GemOrange::1:0:", -- Perfect Resplendent Huge Citrine
	[41500]="0:3:2:1:GemOrange::1:0:", -- Perfect Stalwart Huge Citrine
	[41501]="0:3:2:1:GemOrange::1:0:", -- Perfect Stark Huge Citrine
	[41502]="0:3:2:1:GemOrange::1:0:", -- Perfect Veiled Huge Citrine
	[41503]="0:12:1:6:::1:0:", -- Diatomaceous Earth
	[41504]="0:12:1:6:::1:0:", -- Banshee Essence
	[41505]="0:12:1:1:::1:0:", -- Thorim's Charm of Earth
	[41506]="0:12:1:1:::1:0:", -- Granite Boulder
	[41507]="0:12:1:1:::1:0:", -- Jumbo Seaforium Charge
	[41508]="0:15:4:1:Mount::1:0:", -- Mechano-hog
	[41509]="0:0:1:20:Other::1:0:", -- Frostweave Net
	[41510]="0:7:1:20:Cloth:197:1:0:", -- Bolt of Frostweave
	[41511]="0:7:2:20:Cloth:197:1:0:", -- Bolt of Imbued Frostweave
	[41512]="0:4:2:1:Cloth::1:0:", -- Frostwoven Wristwraps
	[41513]="0:4:2:1:Cloth::1:0:", -- Frostwoven Shoulders
	[41514]="0:12:1:5:::1:0:", -- Voice of the Wind
	[41515]="0:4:2:1:Cloth::1:0:", -- Frostwoven Robe
	[41516]="0:4:3:1:Cloth::1:0:", -- Frostsavage Gloves
	[41517]="0:16:1:20:Shaman::1:0:", -- Glyph of Chain Heal
	[41518]="0:16:1:20:Shaman::1:0:", -- Glyph of Chain Lightning
	[41519]="0:4:2:1:Cloth::1:0:", -- Frostwoven Leggings
	[41520]="0:4:2:1:Cloth:197:1:0:", -- Frostwoven Boots
	[41521]="0:4:2:1:Cloth::1:0:", -- Frostwoven Cowl
	[41522]="0:4:2:1:Cloth::1:0:", -- Frostwoven Belt
	[41523]="0:4:3:1:Cloth::1:0:", -- Mystic Frostwoven Shoulders
	[41524]="0:16:1:20:Shaman::1:0:", -- Glyph of Lava
	[41525]="0:4:3:1:Cloth::1:0:", -- Mystic Frostwoven Robe
	[41526]="0:16:1:20:Shaman::1:0:", -- Glyph of Shocking
	[41527]="0:16:1:20:Shaman::1:0:", -- Glyph of Earthliving Weapon
	[41528]="0:4:3:1:Cloth::1:0:", -- Mystic Frostwoven Wristwraps
	[41529]="0:16:1:20:Shaman::1:0:", -- Glyph of Fire Elemental Totem
	[41530]="0:16:1:20:Shaman::1:0:", -- Glyph of Fire Nova
	[41531]="0:16:1:20:Shaman::1:0:", -- Glyph of Flame Shock
	[41532]="0:16:1:20:Shaman::1:0:", -- Glyph of Flametongue Weapon
	[41533]="0:16:1:20:Shaman::1:0:", -- Glyph of Healing Stream Totem
	[41534]="0:16:1:20:Shaman::1:0:", -- Glyph of Healing Wave
	[41535]="0:16:1:20:Shaman::1:0:", -- Glyph of Lesser Healing Wave
	[41536]="0:16:1:20:Shaman::1:0:", -- Glyph of Lightning Bolt
	[41537]="0:16:1:20:Shaman::1:0:", -- Glyph of Lightning Shield
	[41538]="0:16:1:20:Shaman::1:0:", -- Glyph of Mana Tide Totem
	[41539]="0:16:1:20:Shaman::1:0:", -- Glyph of Stormstrike
	[41540]="0:16:1:20:Shaman::1:0:", -- Glyph of Lava Lash
	[41541]="0:16:1:20:Shaman::1:0:", -- Glyph of Water Mastery
	[41542]="0:16:1:20:Shaman::1:0:", -- Glyph of Windfury Weapon
	[41543]="0:4:2:1:Cloth::1:0:", -- Duskweave Belt
	[41544]="0:4:2:1:Cloth::1:0:", -- Duskweave Boots
	[41545]="0:4:2:1:Cloth::1:0:", -- Duskweave Gloves
	[41546]="0:4:2:1:Cloth::1:0:", -- Duskweave Cowl
	[41547]="0:16:1:20:Shaman::1:0:", -- Glyph of Frost Shock
	[41548]="0:4:2:1:Cloth::1:0:", -- Duskweave Leggings
	[41549]="0:4:2:1:Cloth::1:0:", -- Duskweave Robe
	[41550]="0:4:2:1:Cloth::1:0:", -- Duskweave Shoulders
	[41551]="0:4:2:1:Cloth::1:0:", -- Duskweave Wristwraps
	[41552]="0:16:1:20:Shaman::1:0:", -- Glyph of Elemental Mastery
	[41553]="0:4:3:1:Cloth::1:0:", -- Black Duskweave Leggings
	[41554]="0:4:3:1:Cloth::1:0:", -- Black Duskweave Robe
	[41555]="0:4:3:1:Cloth::1:0:", -- Black Duskweave Wristwraps
	[41556]="0:12:1:1:::1:0:", -- Slag Covered Metal
	[41557]="0:12:1:20:::1:0:", -- Refined Gleaming Ore
	[41558]="0:12:1:10:::1:0:", -- Furious Spark
	[41559]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Mystic Sun Crystal
	[41560]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Stormy Chalcedony
	[41561]="20000:9:2:1:Jewelcrafting::1:0:31911", -- Design: Reckless Huge Citrine
	[41562]="20000:9:2:1:Jewelcrafting::1:0:32538", -- Design: Deadly Huge Citrine
	[41563]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Durable Huge Citrine
	[41564]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Empowered Huge Citrine
	[41565]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Lucent Huge Citrine
	[41566]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Resplendent Huge Citrine
	[41567]="20000:9:2:1:Jewelcrafting::1:0:31910", -- Design: Vivid Dark Jade
	[41568]="20000:9:2:1:Jewelcrafting::1:0:31916,32763", -- Design: Seer's Dark Jade
	[41569]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Shattered Dark Jade
	[41570]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Tense Dark Jade
	[41571]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Turbid Dark Jade
	[41572]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Steady Dark Jade
	[41573]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Opaque Dark Jade
	[41574]="20000:9:2:1:Jewelcrafting::1:0:31916,32763", -- Design: Defender's Shadow Crystal
	[41575]="0:9:2:1:Jewelcrafting::1:0:34039,34040,34043,34079,34080,34081", -- Design: Mysterious Shadow Crystal
	[41576]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Bold Scarlet Ruby
	[41577]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Delicate Scarlet Ruby
	[41578]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Flashing Scarlet Ruby
	[41579]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Quick Autumn's Glow
	[41580]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Rigid Autumn's Glow
	[41581]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Lustrous Sky Sapphire
	[41582]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Glinting Monarch Topaz
	[41584]="3000:6:1:1000:Bullet::200:0:3625,5134,23802,23862,24028,24053,24141,24188,26388,26901,26934,26936,26938,27011,27022,27025,27041,27051,27055,27058,27071,27145,27182,27193,27940,28040,28691,28792,28800,28807,28813,28830,28867,29014,29035,29493,29561,29908,29925,29944,29962,29970,30011,30070,30256,30257,30310,30437,30572,31022,31025,32477,32638,32642,33872,35642", -- Frostbite Bullets
	[41585]="0:12:1:1:::1:0:", -- Slag Covered Metal
	[41586]="3000:6:1:1000:Arrow::200:0:3625,5134,23802,23862,24028,24053,24141,24188,26388,26901,26934,26936,26938,27011,27022,27025,27041,27051,27055,27058,27071,27145,27182,27193,27940,28040,28691,28792,28800,28807,28813,28830,28867,29014,29035,29493,29561,29908,29925,29944,29962,29970,30011,30070,30256,30257,30310,30437,30572,31022,31025,32477,32638,32642,33872,35642", -- Terrorshaft Arrow
	[41587]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Celerity
	[41588]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Aggression
	[41589]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Resolve
	[41590]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Courage
	[41591]="0:4:4:1:Cloak::1:0:", -- Sergeant's Reinforced Cape
	[41592]="0:4:4:1:Cloak::1:0:", -- The Gladiator's Resolution
	[41593]="0:7:3:20:Cloth:197:1:0:", -- Ebonweave
	[41594]="0:7:3:20:Cloth:197:1:0:", -- Moonshroud
	[41595]="0:7:3:20:Cloth:197:1:0:", -- Spellweave
	[41596]="0:10:2::Currency::1:0:28721", -- Dalaran Jewelcrafter's Token
	[41597]="0:1:3:1:SoulBag::1:0:", -- Abyssal Bag
	[41598]="0:1:3:1:EnchantingBag::1:0:", -- Mysterious Bag
	[41599]="0:1:2:1:Bag::1:0:", -- Frostweave Bag
	[41600]="0:1:3:1:Bag::1:0:", -- Glacial Bag
	[41601]="0:0:3:20:EnhPerm::1:0:", -- Shining Spellthread
	[41602]="0:0:4:20:EnhPerm::1:0:", -- Brilliant Spellthread
	[41603]="0:0:3:20:EnhPerm::1:0:", -- Azure Spellthread
	[41604]="0:0:4:20:EnhPerm::1:0:", -- Sapphire Spellthread
	[41607]="0:4:3:1:Cloak::1:0:", -- Cloak of the Moon
	[41608]="0:4:3:1:Cloak::1:0:", -- Cloak of Frozen Spirits
	[41609]="0:4:4:1:Cloak::1:0:", -- Wispcloak
	[41610]="0:4:4:1:Cloak::1:0:", -- Deathchill Cloak
	[41611]="0:0:3:20:EnhPerm::1:0:", -- Eternal Belt Buckle
	[41612]="0:12:1:20:::1:0:", -- Vial of Frost Oil
	[41614]="0:12:1:10:::1:0:", -- Enchanted Earth
	[41615]="0:12:1:1:::1:0:", -- Earthen Mining Pick
	[41616]="0:4:4:1:Leather::1:0:", -- Deadly Gladiator's Belt of Salvation
	[41617]="0:4:4:1:Leather::1:0:", -- Furious Gladiator's Belt of Salvation
	[41618]="0:4:4:1:Leather::1:0:34038,34075", -- Relentless Gladiator's Belt of Salvation
	[41620]="0:4:4:1:Leather::1:0:", -- Deadly Gladiator's Boots of Salvation
	[41621]="0:4:4:1:Leather::1:0:", -- Furious Gladiator's Boots of Salvation
	[41622]="0:4:4:1:Leather::1:0:34038,34075", -- Relentless Gladiator's Boots of Salvation
	[41624]="0:4:4:1:Leather::1:0:", -- Deadly Gladiator's Armwraps of Salvation
	[41625]="0:4:4:1:Leather::1:0:", -- Furious Gladiator's Armwraps of Salvation
	[41626]="0:4:4:1:Leather::1:0:34038,34075", -- Relentless Gladiator's Armwraps of Salvation
	[41628]="0:4:4:1:Leather::1:0:32381", -- Hateful Gladiator's Belt of Dominance
	[41629]="0:4:4:1:Leather::1:0:", -- Deadly Gladiator's Belt of Dominance
	[41630]="0:4:4:1:Leather::1:0:", -- Furious Gladiator's Belt of Dominance
	[41631]="0:4:4:1:Leather::1:0:34038,34075", -- Relentless Gladiator's Belt of Dominance
	[41633]="0:4:4:1:Leather::1:0:32381", -- Hateful Gladiator's Boots of Dominance
	[41634]="0:4:4:1:Leather::1:0:", -- Deadly Gladiator's Boots of Dominance
	[41635]="0:4:4:1:Leather::1:0:", -- Furious Gladiator's Boots of Dominance
	[41636]="0:4:4:1:Leather::1:0:34038,34075", -- Relentless Gladiator's Boots of Dominance
	[41638]="0:4:4:1:Leather::1:0:32381", -- Hateful Gladiator's Armwraps of Dominance
	[41639]="0:4:4:1:Leather::1:0:", -- Deadly Gladiator's Armwraps of Dominance
	[41640]="0:4:4:1:Leather::1:0:", -- Furious Gladiator's Armwraps of Dominance
	[41641]="0:4:4:1:Leather::1:0:34038,34075", -- Relentless Gladiator's Armwraps of Dominance
	[41643]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Leather Gloves
	[41644]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Leather Helm
	[41645]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Leather Legguards
	[41646]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Leather Spaulders
	[41647]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Leather Tunic
	[41648]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Leather Tunic
	[41649]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Leather Tunic
	[41650]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Leather Tunic
	[41651]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Leather Tunic
	[41653]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Leather Legguards
	[41654]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Leather Legguards
	[41655]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Leather Legguards
	[41656]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Leather Legguards
	[41658]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Dragonhide Robes
	[41659]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Dragonhide Robes
	[41660]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Dragonhide Robes
	[41661]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dragonhide Robes
	[41662]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dragonhide Robes
	[41664]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Dragonhide Legguards
	[41665]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Dragonhide Legguards
	[41666]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Dragonhide Legguards
	[41667]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dragonhide Legguards
	[41668]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dragonhide Legguards
	[41670]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Leather Helm
	[41671]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Leather Helm
	[41672]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Leather Helm
	[41673]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Leather Helm
	[41675]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Dragonhide Helm
	[41676]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Dragonhide Helm
	[41677]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Dragonhide Helm
	[41678]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dragonhide Helm
	[41679]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dragonhide Helm
	[41681]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Leather Spaulders
	[41682]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Leather Spaulders
	[41683]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Leather Spaulders
	[41684]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Leather Spaulders
	[41686]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Potent Monarch Topaz
	[41687]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Stark Monarch Topaz
	[41688]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Veiled Monarch Topaz
	[41689]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Luminous Monarch Topaz
	[41690]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Reckless Monarch Topaz
	[41692]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Energized Forest Emerald
	[41693]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Forceful Forest Emerald
	[41694]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Intricate Forest Emerald
	[41696]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Lambent Forest Emerald
	[41697]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Enduring Forest Emerald
	[41698]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Vivid Forest Emerald
	[41699]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Seer's Forest Emerald
	[41701]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Royal Twilight Opal
	[41702]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Puissant Twilight Opal
	[41703]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Regal Twilight Opal
	[41704]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Chaotic Skyflare Diamond
	[41705]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Effulgent Skyflare Diamond
	[41706]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Ember Skyflare Diamond
	[41707]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Revitalizing Skyflare Diamond
	[41708]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Insightful Earthsiege Diamond
	[41709]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Invigorating Earthsiege Diamond
	[41710]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Relentless Earthsiege Diamond
	[41711]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Trenchant Earthsiege Diamond
	[41712]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Dragonhide Spaulders
	[41713]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Dragonhide Spaulders
	[41714]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Dragonhide Spaulders
	[41715]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dragonhide Spaulders
	[41716]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dragonhide Spaulders
	[41718]="40000:9:3:1:Jewelcrafting::1:0:32287", -- Design: Runed Scarlet Ruby
	[41719]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Subtle Scarlet Ruby
	[41720]="40000:9:3:1:Jewelcrafting::1:0:32540", -- Design: Smooth Autumn's Glow
	[41721]="40000:9:3:1:Jewelcrafting::1:0:32538", -- Design: Wicked Monarch Topaz
	[41722]="40000:9:3:1:Jewelcrafting::1:0:32533", -- Design: Glimmering Monarch Topaz
	[41723]="40000:9:3:1:Jewelcrafting::1:0:31911", -- Design: Jagged Forest Emerald
	[41724]="40000:9:3:1:Jewelcrafting::1:0:31910", -- Design: Sundered Forest Emerald
	[41725]="40000:9:3:1:Jewelcrafting::1:0:32538", -- Design: Glowing Twilight Opal
	[41726]="40000:9:3:1:Jewelcrafting::1:0:30431", -- Design: Guardian's Twilight Opal
	[41727]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Mystic Autumn's Glow
	[41728]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Stormy Sky Sapphire
	[41729]="16000:0:1:20:FoodDrink::5:0:30005", -- Stewed Drakeflesh
	[41730]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Durable Monarch Topaz
	[41731]="11000:0:1:20:FoodDrink::5:0:30005", -- Yeti Milk
	[41732]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Empowered Monarch Topaz
	[41733]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Lucent Monarch Topaz
	[41734]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Resplendent Monarch Topaz
	[41735]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Shattered Forest Emerald
	[41736]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Tense Forest Emerald
	[41737]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Turbid Forest Emerald
	[41738]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Steady Forest Emerald
	[41739]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Opaque Forest Emerald
	[41740]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Mysterious Twilight Opal
	[41741]="0:7:1:1:Enchanting::1:0:", -- Cobalt Rod
	[41742]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Enigmatic Skyflare Diamond
	[41743]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Forlorn Skyflare Diamond
	[41744]="0:9:3:1:Jewelcrafting::1:0:30489,32294,32296", -- Design: Impassive Skyflare Diamond
	[41745]="0:7:1:1:Enchanting:333:1:0:", -- Titanium Rod
	[41746]="126343:2:1:1:Bow::1:0:30006", -- Brunnhildar Bow
	[41747]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Shifting Twilight Opal
	[41750]="0:2:1:1:Polearm::1:0:", -- Brunnhildar Harpoon
	[41751]="0:0:1:20:FoodDrink::1:0:", -- Black Mushroom
	[41752]="172165:2:1:1:OneHandAxe::1:0:30006", -- Brunnhildar Axe
	[41753]="0:2:1:1:TwoHandAxe::1:0:", -- Brunnhildar Great Axe
	[41754]="110970:4:1:1:Shield::1:0:30006", -- Brunnhildar Shield
	[41755]="0:2:3:1:Miscellaneous::1:0:", -- The Fire Extinguisher
	[41760]="0:4:2:1:Cloth::1:0:", -- Emancipator's Robes
	[41761]="0:4:2:1:Leather::1:0:", -- Wristguard of Healing Fingers
	[41762]="0:4:2:1:Mail::1:0:", -- Freedom-Path Treads
	[41763]="0:4:2:1:Plate::1:0:", -- Leggings of the Canny Chief
	[41765]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Leather Gloves
	[41766]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Leather Gloves
	[41767]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Leather Gloves
	[41768]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Leather Gloves
	[41770]="0:4:3:1:Leather::1:0:31580,31582", -- Savage Gladiator's Dragonhide Gloves
	[41771]="0:4:4:1:Leather::1:0:31579,31581", -- Hateful Gladiator's Dragonhide Gloves
	[41772]="0:4:4:1:Leather::1:0:33963,33964", -- Deadly Gladiator's Dragonhide Gloves
	[41773]="0:4:4:1:Leather::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Dragonhide Gloves
	[41774]="0:4:4:1:Leather::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Dragonhide Gloves
	[41776]="0:12:1:1:::1:0:", -- Shadow Vault Decree
	[41777]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Etched Monarch Topaz
	[41778]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Resolute Monarch Topaz
	[41779]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Stalwart Monarch Topaz
	[41780]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Champion's Monarch Topaz
	[41781]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Misty Forest Emerald
	[41782]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Shining Forest Emerald
	[41783]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Purified Twilight Opal
	[41784]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Sovereign Twilight Opal
	[41785]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Tenuous Twilight Opal
	[41786]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Destructive Skyflare Diamond
	[41787]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Thundering Skyflare Diamond
	[41788]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Beaming Earthsiege Diamond
	[41789]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Inscribed Monarch Topaz
	[41790]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Precise Scarlet Ruby
	[41791]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Thick Autumn's Glow
	[41792]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Deft Monarch Topaz
	[41793]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Fierce Monarch Topaz
	[41794]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Deadly Monarch Topaz
	[41795]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Timeless Forest Emerald
	[41796]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Infused Twilight Opal
	[41797]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Austere Earthsiege Diamond
	[41798]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Bracing Earthsiege Diamond
	[41799]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Eternal Earthsiege Diamond
	[41800]="0:7:1:20:Meat:185:1:0:", -- Deep Sea Monsterbelly
	[41801]="0:7:1:20:Meat:185:1:0:", -- Moonglow Cuttlefish
	[41802]="0:7:1:20:Meat:185:1:0:", -- Imperial Manta Ray
	[41803]="0:7:1:20:Meat:185:1:0:", -- Rockfin Grouper
	[41805]="0:7:1:20:Meat:185:1:0:", -- Borean Man O' War
	[41806]="0:7:1:20:Meat:185:1:0:", -- Musselback Sculpin
	[41807]="0:7:1:20:Meat:185:1:0:", -- Dragonfin Angelfish
	[41808]="0:7:1:20:Meat:185:1:0:", -- Bonescale Snapper
	[41809]="0:7:1:20:Meat:185:1:0:", -- Glacial Salmon
	[41810]="0:7:1:20:Meat:185:1:0:", -- Fangtooth Herring
	[41812]="0:7:1:20:Meat:185:1:0:", -- Barrelhead Goby
	[41813]="0:7:1:20:Meat:185:1:0:", -- Nettlefish
	[41814]="0:7:1:20:Meat:171:1:0:", -- Glassfin Minnow
	[41815]="0:2:3:1:Polearm::1:0:", -- Icier Barbed Spear
	[41816]="0:2:3:1:TwoHandAxe::1:0:", -- De-Raged Waraxe
	[41817]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Fractured Scarlet Ruby
	[41818]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Accurate Monarch Topaz
	[41819]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Radiant Forest Emerald
	[41820]="0:9:3:1:Jewelcrafting::1:0:", -- Design: Defender's Twilight Opal
	[41821]="0:2:3:1:Stave::1:0:", -- Chilly Slobberknocker
	[41822]="0:2:3:1:OneHandMace::1:0:", -- Screw-Sprung Fixer-Upper
	[41824]="0:2:3:1:OneHandMace::1:0:", -- Crimson Cranium Crusher
	[41825]="0:2:3:1:Dagger::1:0:", -- Wodin's Second-Best Shanker
	[41826]="0:4:3:1:Cloth::1:0:", -- Grips of the Giant-Rider
	[41827]="0:4:4:1:Leather::1:0:32381", -- Hateful Gladiator's Belt of Triumph
	[41828]="0:4:4:1:Leather::1:0:32381", -- Hateful Gladiator's Boots of Triumph
	[41829]="0:4:3:1:Leather::1:0:", -- Horns of Electrified Terror
	[41830]="0:4:4:1:Leather::1:0:32381", -- Hateful Gladiator's Armwraps of Triumph
	[41831]="0:4:4:1:Leather::1:0:", -- Deadly Gladiator's Belt of Triumph
	[41832]="0:4:4:1:Leather::1:0:", -- Furious Gladiator's Belt of Triumph
	[41833]="0:4:4:1:Leather::1:0:34038,34075", -- Relentless Gladiator's Belt of Triumph
	[41835]="0:4:4:1:Leather::1:0:", -- Deadly Gladiator's Boots of Triumph
	[41836]="0:4:4:1:Leather::1:0:", -- Furious Gladiator's Boots of Triumph
	[41837]="0:4:4:1:Leather::1:0:34038,34075", -- Relentless Gladiator's Boots of Triumph
	[41839]="0:4:4:1:Leather::1:0:", -- Deadly Gladiator's Armwraps of Triumph
	[41840]="0:4:4:1:Leather::1:0:", -- Furious Gladiator's Armwraps of Triumph
	[41841]="0:4:4:1:Leather::1:0:34038,34075", -- Relentless Gladiator's Armwraps of Triumph
	[41843]="0:13:1:1:::1:0:", -- Key to Vaelen's Chains
	[41844]="0:4:3:1:Mail::1:0:", -- Bracers of Vengeful Flight
	[41845]="0:4:3:1:Plate::1:0:", -- Life-Light Pauldrons
	[41846]="0:4:3:1:Plate::1:0:", -- Clutch of the Storm Giant
	[41847]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Mooncloth Gloves
	[41848]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Mooncloth Hood
	[41849]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Mooncloth Leggings
	[41850]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Mooncloth Mantle
	[41851]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Mooncloth Robe
	[41852]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Mooncloth Hood
	[41853]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Mooncloth Hood
	[41854]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mooncloth Hood
	[41855]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mooncloth Hood
	[41857]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Mooncloth Robe
	[41858]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Mooncloth Robe
	[41859]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mooncloth Robe
	[41860]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mooncloth Robe
	[41862]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Mooncloth Leggings
	[41863]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Mooncloth Leggings
	[41864]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mooncloth Leggings
	[41865]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mooncloth Leggings
	[41867]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Mooncloth Mantle
	[41868]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Mooncloth Mantle
	[41869]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mooncloth Mantle
	[41870]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mooncloth Mantle
	[41872]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Mooncloth Gloves
	[41873]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Mooncloth Gloves
	[41874]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Mooncloth Gloves
	[41875]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Mooncloth Gloves
	[41877]="0:4:4:1:Cloth::1:0:32381", -- Hateful Gladiator's Cord of Salvation
	[41878]="0:4:4:1:Cloth::1:0:32381", -- Hateful Gladiator's Cuffs of Salvation
	[41879]="0:4:4:1:Cloth::1:0:32381", -- Hateful Gladiator's Slippers of Salvation
	[41880]="0:4:4:1:Cloth::1:0:", -- Deadly Gladiator's Cord of Salvation
	[41881]="0:4:4:1:Cloth::1:0:", -- Furious Gladiator's Cord of Salvation
	[41882]="0:4:4:1:Cloth::1:0:34038,34075", -- Relentless Gladiator's Cord of Salvation
	[41884]="0:4:4:1:Cloth::1:0:", -- Deadly Gladiator's Treads of Salvation
	[41885]="0:4:4:1:Cloth::1:0:", -- Furious Gladiator's Slippers of Salvation
	[41886]="0:4:4:1:Cloth::1:0:34038,34075", -- Relentless Gladiator's Treads of Salvation
	[41888]="0:15:2:1:Junk::1:0:", -- Small Velvet Bag
	[41890]="0:4:3:1:Cloth::1:0:", -- Robe of the Conquered Prophet
	[41891]="0:4:3:1:Leather::1:0:", -- Intricate Zandalari Tunic
	[41892]="0:4:4:1:Cloth::1:0:", -- Deadly Gladiator's Cuffs of Salvation
	[41893]="0:4:4:1:Cloth::1:0:", -- Furious Gladiator's Cuffs of Salvation
	[41894]="0:4:4:1:Cloth::1:0:34038,34075", -- Relentless Gladiator's Cuffs of Salvation
	[41896]="0:4:4:1:Cloth::1:0:32381", -- Hateful Gladiator's Cord of Dominance
	[41897]="0:4:4:1:Cloth::1:0:", -- Deadly Gladiator's Cord of Dominance
	[41898]="0:4:4:1:Cloth::1:0:", -- Furious Gladiator's Cord of Dominance
	[41899]="0:4:4:1:Cloth::1:0:34038,34075", -- Relentless Gladiator's Cord of Dominance
	[41901]="0:4:4:1:Cloth::1:0:32381", -- Hateful Gladiator's Slippers of Dominance
	[41902]="0:4:4:1:Cloth::1:0:", -- Deadly Gladiator's Treads of Dominance
	[41903]="0:4:4:1:Cloth::1:0:", -- Furious Gladiator's Slippers of Dominance
	[41904]="0:4:4:1:Cloth::1:0:34038,34075", -- Relentless Gladiator's Treads of Dominance
	[41905]="0:4:3:1:Mail::1:0:", -- Chestguard of Rampaging Fury
	[41907]="0:4:4:1:Cloth::1:0:32381", -- Hateful Gladiator's Cuffs of Dominance
	[41908]="0:4:4:1:Cloth::1:0:", -- Deadly Gladiator's Cuffs of Dominance
	[41909]="0:4:4:1:Cloth::1:0:", -- Furious Gladiator's Cuffs of Dominance
	[41910]="0:4:4:1:Cloth::1:0:34038,34075", -- Relentless Gladiator's Cuffs of Dominance
	[41912]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Satin Hood
	[41913]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Satin Hood
	[41914]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Satin Hood
	[41915]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Satin Hood
	[41916]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Satin Hood
	[41918]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Satin Robe
	[41919]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Satin Robe
	[41920]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Satin Robe
	[41921]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Satin Robe
	[41922]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Satin Robe
	[41924]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Satin Leggings
	[41925]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Satin Leggings
	[41926]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Satin Leggings
	[41927]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Satin Leggings
	[41928]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Satin Leggings
	[41930]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Satin Mantle
	[41931]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Satin Mantle
	[41932]="0:4:3:1:Plate::1:0:", -- Links of the Terrified Deity
	[41933]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Satin Mantle
	[41934]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Satin Mantle
	[41935]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Satin Mantle
	[41937]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Satin Gloves
	[41938]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Satin Gloves
	[41939]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Satin Gloves
	[41940]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Satin Gloves
	[41941]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Satin Gloves
	[41943]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Silk Cowl
	[41944]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Silk Cowl
	[41945]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Silk Cowl
	[41946]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Silk Cowl
	[41947]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Silk Cowl
	[41949]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Silk Raiment
	[41950]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Silk Raiment
	[41951]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Silk Raiment
	[41953]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Silk Raiment
	[41954]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Silk Raiment
	[41956]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Silk Trousers
	[41957]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Silk Trousers
	[41958]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Silk Trousers
	[41959]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Silk Trousers
	[41960]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Silk Trousers
	[41962]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Silk Amice
	[41963]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Silk Amice
	[41964]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Silk Amice
	[41965]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Silk Amice
	[41966]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Silk Amice
	[41968]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Silk Handguards
	[41969]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Silk Handguards
	[41970]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Silk Handguards
	[41971]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Silk Handguards
	[41972]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Silk Handguards
	[41974]="0:4:2:1:Plate::1:0:", -- Cobalt Bracers
	[41975]="0:4:2:1:Plate::1:0:", -- Cobalt Gauntlets
	[41976]="0:0:2:5:EnhPerm::1:0:", -- Titanium Weapon Chain
	[41984]="0:4:3:1:Cloth::1:0:", -- Hat of Wintry Doom
	[41985]="0:4:3:1:Cloth::1:0:", -- Silky Iceshard Boots
	[41986]="0:4:3:1:Cloth::1:0:", -- Deep Frozen Cord
	[41987]="0:2:3:1:Stave::1:0:", -- Staff of the Sorrowful Chieftain
	[41988]="0:12:1:1:::1:0:", -- Telluric Poultice
	[41989]="0:12:1:1:::1:0:", -- Vrykul Amulet
	[41990]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Felweave Cowl
	[41991]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Felweave Cowl
	[41992]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Felweave Cowl
	[41993]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Felweave Cowl
	[41994]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Felweave Cowl
	[41996]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Felweave Raiment
	[41997]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Felweave Raiment
	[41998]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Felweave Raiment
	[41999]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Felweave Raiment
	[42001]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Felweave Raiment
	[42002]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Felweave Trousers
	[42003]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Felweave Trousers
	[42004]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Felweave Trousers
	[42005]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Felweave Trousers
	[42006]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Felweave Trousers
	[42008]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Felweave Amice
	[42009]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Felweave Amice
	[42010]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Felweave Amice
	[42011]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Felweave Amice
	[42012]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Felweave Amice
	[42014]="0:4:3:1:Cloth::1:0:31580,31582", -- Savage Gladiator's Felweave Handguards
	[42015]="0:4:4:1:Cloth::1:0:31579,31581", -- Hateful Gladiator's Felweave Handguards
	[42016]="0:4:4:1:Cloth::1:0:33963,33964", -- Deadly Gladiator's Felweave Handguards
	[42017]="0:4:4:1:Cloth::1:0:33934,33938,33941,34063,34084,35494,35495,35573,35574", -- Furious Gladiator's Felweave Handguards
	[42018]="0:4:4:1:Cloth::1:0:33933,33935,33937,37941,37942,38858", -- Relentless Gladiator's Felweave Handguards
	[42020]="0:4:4:1:Amulet::1:0:32381", -- Hateful Gladiator's Pendant of Triumph
	[42021]="0:4:4:1:Amulet::1:0:32381", -- Hateful Gladiator's Pendant of Victory
	[42022]="0:4:4:1:Amulet::1:0:32381", -- Hateful Gladiator's Pendant of Dominance
	[42023]="0:4:4:1:Amulet::1:0:32381", -- Hateful Gladiator's Pendant of Subjugation
	[42024]="0:4:4:1:Amulet::1:0:32381", -- Hateful Gladiator's Pendant of Ascendancy
	[42025]="0:4:4:1:Amulet::1:0:32381", -- Hateful Gladiator's Pendant of Deliverance
	[42026]="0:4:4:1:Amulet::1:0:32381", -- Hateful Gladiator's Pendant of Salvation
	[42027]="0:4:4:1:Amulet::1:0:", -- Deadly Gladiator's Pendant of Triumph
	[42028]="0:4:4:1:Amulet::1:0:", -- Deadly Gladiator's Pendant of Victory
	[42029]="0:4:4:1:Amulet::1:0:", -- Deadly Gladiator's Pendant of Dominance
	[42030]="0:4:4:1:Amulet::1:0:", -- Deadly Gladiator's Pendant of Ascendancy
	[42031]="0:4:4:1:Amulet::1:0:", -- Deadly Gladiator's Pendant of Subjugation
	[42032]="0:4:4:1:Amulet::1:0:", -- Deadly Gladiator's Pendant of Deliverance
	[42033]="0:4:4:1:Amulet::1:0:", -- Deadly Gladiator's Pendant of Salvation
	[42034]="0:4:4:1:Amulet::1:0:", -- Furious Gladiator's Pendant of Triumph
	[42035]="0:4:4:1:Amulet::1:0:", -- Furious Gladiator's Pendant of Victory
	[42036]="0:4:4:1:Amulet::1:0:", -- Furious Gladiator's Pendant of Dominance
	[42037]="0:4:4:1:Amulet::1:0:", -- Furious Gladiator's Pendant of Ascendancy
	[42038]="0:4:4:1:Amulet::1:0:", -- Furious Gladiator's Pendant of Subjugation
	[42039]="0:4:4:1:Amulet::1:0:", -- Furious Gladiator's Pendant of Deliverance
	[42040]="0:4:4:1:Amulet::1:0:", -- Furious Gladiator's Pendant of Salvation
	[42041]="0:4:4:1:Amulet::1:0:34038,34075", -- Relentless Gladiator's Pendant of Triumph
	[42042]="0:4:4:1:Amulet::1:0:34038,34075", -- Relentless Gladiator's Pendant of Victory
	[42043]="0:4:4:1:Amulet::1:0:34038,34075", -- Relentless Gladiator's Pendant of Dominance
	[42044]="0:4:4:1:Amulet::1:0:34038,34075", -- Relentless Gladiator's Pendant of Ascendancy
	[42045]="0:4:4:1:Amulet::1:0:34038,34075", -- Relentless Gladiator's Pendant of Subjugation
	[42046]="0:4:4:1:Amulet::1:0:34038,34075", -- Relentless Gladiator's Pendant of Deliverance
	[42047]="0:4:4:1:Amulet::1:0:34038,34075", -- Relentless Gladiator's Pendant of Salvation
	[42055]="0:4:4:1:Cloak::1:0:32381", -- Hateful Gladiator's Cloak of Dominance
	[42056]="0:4:4:1:Cloak::1:0:32381", -- Hateful Gladiator's Cloak of Subjugation
	[42057]="0:4:4:1:Cloak::1:0:32381", -- Hateful Gladiator's Cloak of Ascendancy
	[42058]="0:4:4:1:Cloak::1:0:32381", -- Hateful Gladiator's Cloak of Salvation
	[42059]="0:4:4:1:Cloak::1:0:32381", -- Hateful Gladiator's Cloak of Deliverance
	[42060]="0:4:4:1:Cloak::1:0:32381", -- Hateful Gladiator's Cloak of Triumph
	[42061]="0:4:4:1:Cloak::1:0:32381", -- Hateful Gladiator's Cloak of Victory
	[42062]="0:4:4:1:Cloak::1:0:", -- Deadly Gladiator's Cloak of Dominance
	[42063]="0:4:4:1:Cloak::1:0:", -- Deadly Gladiator's Cloak of Subjugation
	[42064]="0:4:4:1:Cloak::1:0:", -- Deadly Gladiator's Cloak of Ascendancy
	[42065]="0:4:4:1:Cloak::1:0:", -- Deadly Gladiator's Cloak of Salvation
	[42066]="0:4:4:1:Cloak::1:0:", -- Deadly Gladiator's Cloak of Deliverance
	[42067]="0:4:4:1:Cloak::1:0:", -- Deadly Gladiator's Cloak of Triumph
	[42068]="0:4:4:1:Cloak::1:0:", -- Deadly Gladiator's Cloak of Victory
	[42069]="0:4:4:1:Cloak::1:0:", -- Furious Gladiator's Cloak of Dominance
	[42070]="0:4:4:1:Cloak::1:0:", -- Furious Gladiator's Cloak of Subjugation
	[42071]="0:4:4:1:Cloak::1:0:", -- Furious Gladiator's Cloak of Ascendancy
	[42072]="0:4:4:1:Cloak::1:0:", -- Furious Gladiator's Cloak of Salvation
	[42073]="0:4:4:1:Cloak::1:0:", -- Furious Gladiator's Cloak of Deliverance
	[42074]="0:4:4:1:Cloak::1:0:", -- Furious Gladiator's Cloak of Triumph
	[42075]="0:4:4:1:Cloak::1:0:", -- Furious Gladiator's Cloak of Victory
	[42076]="0:4:4:1:Cloak::1:0:34038,34075", -- Relentless Gladiator's Cloak of Dominance
	[42077]="0:4:4:1:Cloak::1:0:34038,34075", -- Relentless Gladiator's Cloak of Subjugation
	[42078]="0:4:4:1:Cloak::1:0:34038,34075", -- Relentless Gladiator's Cloak of Ascendancy
	[42079]="0:4:4:1:Cloak::1:0:34038,34075", -- Relentless Gladiator's Cloak of Salvation
	[42080]="0:4:4:1:Cloak::1:0:34038,34075", -- Relentless Gladiator's Cloak of Deliverance
	[42081]="0:4:4:1:Cloak::1:0:34038,34075", -- Relentless Gladiator's Cloak of Triumph
	[42082]="0:4:4:1:Cloak::1:0:34038,34075", -- Relentless Gladiator's Cloak of Victory
	[42084]="35440:4:1:1:Leather::1:0:26697", -- Snowhide Belt
	[42088]="53942:4:1:1:Leather::1:0:26697", -- Snowhide Hoof-Warmers
	[42092]="36482:4:1:1:Leather::1:0:26697", -- Snowhide Bracers
	[42093]="0:4:3:1:Cloth::1:0:", -- Frostmoon Pants
	[42094]="55116:4:1:1:Leather::1:0:26697", -- Snowhide Cap
	[42095]="0:4:3:1:Cloth::1:0:", -- Light Blessed Mittens
	[42096]="0:4:3:1:Cloth::1:0:", -- Aurora Slippers
	[42097]="34526:4:1:1:Leather::1:0:26697", -- Snowhide Mitts
	[42098]="69315:4:1:1:Leather::1:0:26697", -- Snowhide Pants
	[42099]="69577:4:1:1:Leather::1:0:26697", -- Snowhide Vest
	[42100]="0:4:4:1:Cloth::1:0:", -- Moonshroud Robe
	[42101]="0:4:4:1:Cloth::1:0:", -- Ebonweave Robe
	[42102]="0:4:4:1:Cloth::1:0:", -- Spellweave Robe
	[42103]="0:4:4:1:Cloth::1:0:", -- Moonshroud Gloves
	[42104]="0:12:1:1:::1:0:", -- Northern Ivory
	[42105]="0:12:1:1:::1:0:", -- Iron Dwarf Brooch
	[42106]="0:12:1:1:::1:0:", -- Proto Dragon Bone
	[42107]="0:12:1:1:::1:0:", -- Elemental Armor Scrap
	[42108]="0:12:1:1:::1:0:", -- Scourge Curio
	[42109]="0:12:1:10:::1:0:", -- Dark Ore Sample
	[42110]="0:4:4:1:Ring::1:0:32381", -- Hateful Gladiator's Band of Dominance
	[42111]="0:4:4:1:Cloth::1:0:", -- Ebonweave Gloves
	[42112]="0:4:4:1:Ring::1:0:32381", -- Hateful Gladiator's Band of Triumph
	[42113]="0:4:4:1:Cloth::1:0:", -- Spellweave Gloves
	[42114]="0:4:4:1:Ring::1:0:", -- Deadly Gladiator's Band of Ascendancy
	[42115]="0:4:4:1:Ring::1:0:", -- Deadly Gladiator's Band of Victory
	[42116]="0:4:4:1:Ring::1:0:", -- Furious Gladiator's Band of Dominance
	[42117]="0:4:4:1:Ring::1:0:", -- Furious Gladiator's Band of Triumph
	[42118]="0:4:4:1:Ring::1:0:34038,34075", -- Relentless Gladiator's Band of Ascendancy
	[42119]="0:4:4:1:Ring::1:0:34038,34075", -- Relentless Gladiator's Band of Victory
	[42122]="0:4:4:1:Trinket::1:0:", -- Medallion of the Horde
	[42123]="0:4:4:1:Trinket::1:0:32381", -- Medallion of the Alliance
	[42124]="0:4:4:1:Trinket::1:0:", -- Medallion of the Alliance
	[42126]="0:4:4:1:Trinket::1:0:", -- Medallion of the Horde
	[42128]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Hostility
	[42129]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Accuracy
	[42130]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Avidity
	[42131]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Conviction
	[42132]="0:4:4:1:Trinket::1:0:", -- Battlemaster's Bravery
	[42133]="0:4:4:1:Trinket::1:0:34038,34075", -- Battlemaster's Fury
	[42134]="0:4:4:1:Trinket::1:0:34038,34075", -- Battlemaster's Precision
	[42135]="0:4:4:1:Trinket::1:0:34038,34075", -- Battlemaster's Vivacity
	[42136]="0:4:4:1:Trinket::1:0:34038,34075", -- Battlemaster's Rage
	[42137]="0:4:4:1:Trinket::1:0:34038,34075", -- Battlemaster's Ruination
	[42138]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Solid Sky Sapphire
	[42142]="0:3:4:1:GemRed::1:0:", -- Bold Dragon's Eye
	[42143]="0:3:4:1:GemRed::1:0:", -- Delicate Dragon's Eye
	[42144]="0:3:4:1:GemRed::1:0:", -- Runed Dragon's Eye
	[42145]="0:3:4:1:GemBlue::1:0:", -- Sparkling Dragon's Eye
	[42146]="0:3:4:1:GemBlue::1:0:", -- Lustrous Dragon's Eye
	[42148]="0:3:4:1:GemYellow::1:0:", -- Brilliant Dragon's Eye
	[42149]="0:3:4:1:GemYellow::1:0:", -- Smooth Dragon's Eye
	[42150]="0:3:4:1:GemYellow::1:0:", -- Quick Dragon's Eye
	[42151]="0:3:4:1:GemRed::1:0:", -- Subtle Dragon's Eye
	[42152]="0:3:4:1:GemRed::1:0:", -- Flashing Dragon's Eye
	[42153]="0:3:4:1:GemRed::1:0:", -- Fractured Dragon's Eye
	[42154]="0:3:4:1:GemRed::1:0:", -- Precise Dragon's Eye
	[42155]="0:3:4:1:GemBlue::1:0:", -- Stormy Dragon's Eye
	[42156]="0:3:4:1:GemYellow::1:0:", -- Rigid Dragon's Eye
	[42157]="0:3:4:1:GemYellow::1:0:", -- Thick Dragon's Eye
	[42158]="0:3:4:1:GemYellow::1:0:", -- Mystic Dragon's Eye
	[42159]="0:12:1:20:::1:0:", -- Storm Hammer
	[42160]="0:12:1:1:::1:0:", -- Incendiary Harpoons
	[42162]="0:12:1:10:::1:0:", -- Horn Fragment
	[42163]="0:12:1:1:::1:0:", -- Horn Fragments
	[42164]="0:12:1:1:::1:0:", -- Hodir's Horn
	[42170]="0:7:1:20:Other::1:0:", -- Silver Brooch
	[42171]="0:7:1:20:Other::1:0:", -- Emerald Brooch
	[42172]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Lumberjack Shirt
	[42173]="0:9:2:1:Tailoring::1:0:", -- Pattern: Blue Lumberjack Shirt
	[42175]="0:9:2:1:Tailoring::1:0:", -- Pattern: Green Lumberjack Shirt
	[42176]="0:9:2:1:Tailoring::1:0:", -- Pattern: Blue Workman's Shirt
	[42177]="0:9:2:1:Tailoring::1:0:", -- Pattern: Red Workman's Shirt
	[42178]="0:9:2:1:Tailoring::1:0:", -- Pattern: Rustic Workman's Shirt
	[42183]="50000:9:1:1:Tailoring::1:0:32538", -- Pattern: Abyssal Bag
	[42184]="50000:9:1:1:Tailoring::1:0:32540", -- Pattern: Glacial Bag
	[42185]="50000:9:1:1:Tailoring::1:0:32533", -- Pattern: Mysterious Bag
	[42187]="50000:9:1:1:Tailoring::1:0:30431", -- Pattern: Brilliant Spellthread
	[42188]="50000:9:1:1:Tailoring::1:0:32287", -- Pattern: Sapphire Spellthread
	[42203]="0:12:1:1:::1:0:", -- Dark Armor Plate
	[42204]="0:12:1:10:::1:0:", -- Dark Armor Sample
	[42206]="0:2:3:1:OneHandAxe::1:0:", -- Savage Gladiator's Cleaver
	[42207]="0:2:4:1:OneHandAxe::1:0:", -- Hateful Gladiator's Cleaver
	[42208]="0:2:4:1:OneHandAxe::1:0:", -- Deadly Gladiator's Cleaver
	[42209]="0:2:4:1:OneHandAxe::1:0:", -- Furious Gladiator's Cleaver
	[42210]="0:2:4:1:OneHandAxe::1:0:", -- Relentless Gladiator's Cleaver
	[42212]="0:2:3:1:OneHandAxe::1:0:", -- Savage Gladiator's Chopper
	[42213]="0:2:3:1:OneHandAxe::1:0:", -- Savage Gladiator's Hacker
	[42214]="0:2:3:1:OneHandAxe::1:0:", -- Savage Gladiator's Waraxe
	[42215]="0:2:3:1:Dagger::1:0:", -- Savage Gladiator's Mutilator
	[42216]="0:2:3:1:Dagger::1:0:", -- Savage Gladiator's Shanker
	[42217]="0:2:3:1:Dagger::1:0:", -- Savage Gladiator's Shiv
	[42218]="0:2:3:1:FistWeapon::1:0:", -- Savage Gladiator's Right Ripper
	[42219]="0:2:3:1:FistWeapon::1:0:", -- Savage Gladiator's Left Render
	[42220]="0:2:3:1:FistWeapon::1:0:", -- Savage Gladiator's Left Ripper
	[42221]="0:2:3:1:OneHandMace::1:0:", -- Savage Gladiator's Bonecracker
	[42222]="0:2:3:1:OneHandMace::1:0:", -- Savage Gladiator's Pummeler
	[42223]="0:2:3:1:OneHandSword::1:0:", -- Savage Gladiator's Quickblade
	[42224]="0:2:3:1:OneHandSword::1:0:", -- Savage Gladiator's Slicer
	[42225]="0:3:3:20:GemPrismatic:755:1:0:28721,33602", -- Dragon's Eye
	[42226]="0:2:4:1:OneHandAxe::1:0:", -- Hateful Gladiator's Hacker
	[42227]="0:2:4:1:OneHandAxe::1:0:", -- Deadly Gladiator's Hacker
	[42228]="0:2:4:1:OneHandAxe::1:0:", -- Furious Gladiator's Hacker
	[42229]="0:2:4:1:OneHandAxe::1:0:", -- Relentless Gladiator's Hacker
	[42231]="0:2:4:1:OneHandAxe::1:0:", -- Hateful Gladiator's Chopper
	[42232]="0:2:4:1:OneHandAxe::1:0:", -- Deadly Gladiator's Chopper
	[42233]="0:2:4:1:OneHandAxe::1:0:", -- Furious Gladiator's Chopper
	[42234]="0:2:4:1:OneHandAxe::1:0:", -- Relentless Gladiator's Chopper
	[42236]="0:2:4:1:OneHandAxe::1:0:", -- Hateful Gladiator's Waraxe
	[42237]="0:2:4:1:OneHandAxe::1:0:", -- Deadly Gladiator's Waraxe
	[42241]="0:2:4:1:Dagger::1:0:", -- Hateful Gladiator's Shanker
	[42242]="0:2:4:1:Dagger::1:0:", -- Deadly Gladiator's Shanker
	[42243]="0:2:4:1:Dagger::1:0:", -- Furious Gladiator's Shanker
	[42244]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Shanker
	[42246]="0:12:1:5:::1:0:", -- Essence of Ice
	[42247]="0:2:4:1:Dagger::1:0:", -- Hateful Gladiator's Shiv
	[42248]="0:2:4:1:Dagger::1:0:", -- Deadly Gladiator's Shiv
	[42249]="0:2:4:1:Dagger::1:0:", -- Furious Gladiator's Shiv
	[42250]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Shiv
	[42252]="0:12:1:10:::1:0:", -- Frozen Iron Scrap
	[42253]="0:7:1:20:Cloth:197:1:0:", -- Iceweb Spider Silk
	[42254]="0:2:4:1:Dagger::1:0:", -- Hateful Gladiator's Mutilator
	[42255]="0:2:4:1:Dagger::1:0:", -- Deadly Gladiator's Mutilator
	[42256]="0:2:4:1:Dagger::1:0:", -- Furious Gladiator's Mutilator
	[42257]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Mutilator
	[42259]="0:2:4:1:FistWeapon::1:0:", -- Hateful Gladiator's Right Ripper
	[42260]="0:2:4:1:FistWeapon::1:0:", -- Deadly Gladiator's Right Ripper
	[42261]="0:2:4:1:FistWeapon::1:0:", -- Furious Gladiator's Right Ripper
	[42262]="0:2:4:1:FistWeapon::1:0:", -- Relentless Gladiator's Right Ripper
	[42264]="0:2:4:1:FistWeapon::1:0:", -- Hateful Gladiator's Left Render
	[42265]="0:2:4:1:FistWeapon::1:0:", -- Deadly Gladiator's Left Render
	[42266]="0:2:4:1:FistWeapon::1:0:", -- Furious Gladiator's Left Render
	[42267]="0:2:4:1:FistWeapon::1:0:", -- Relentless Gladiator's Left Render
	[42269]="0:2:4:1:FistWeapon::1:0:", -- Hateful Gladiator's Left Ripper
	[42270]="0:2:4:1:FistWeapon::1:0:", -- Deadly Gladiator's Left Ripper
	[42271]="0:2:4:1:FistWeapon::1:0:", -- Furious Gladiator's Left Ripper
	[42272]="0:2:4:1:FistWeapon::1:0:", -- Relentless Gladiator's Left Ripper
	[42274]="0:2:4:1:OneHandMace::1:0:", -- Hateful Gladiator's Pummeler
	[42275]="0:2:4:1:OneHandMace::1:0:", -- Deadly Gladiator's Pummeler
	[42276]="0:2:4:1:OneHandMace::1:0:", -- Furious Gladiator's Pummeler
	[42277]="0:2:4:1:OneHandMace::1:0:", -- Relentless Gladiator's Pummeler
	[42279]="0:2:4:1:OneHandMace::1:0:", -- Hateful Gladiator's Bonecracker
	[42280]="0:2:4:1:OneHandMace::1:0:", -- Deadly Gladiator's Bonecracker
	[42281]="0:2:4:1:OneHandMace::1:0:", -- Furious Gladiator's Bonecracker
	[42282]="0:2:4:1:OneHandMace::1:0:", -- Relentless Gladiator's Bonecracker
	[42284]="0:2:4:1:OneHandSword::1:0:", -- Hateful Gladiator's Slicer
	[42285]="0:2:4:1:OneHandSword::1:0:", -- Deadly Gladiator's Slicer
	[42286]="0:2:4:1:OneHandSword::1:0:", -- Furious Gladiator's Slicer
	[42287]="0:2:4:1:OneHandSword::1:0:", -- Relentless Gladiator's Slicer
	[42289]="0:2:4:1:OneHandSword::1:0:", -- Hateful Gladiator's Quickblade
	[42290]="0:2:4:1:OneHandSword::1:0:", -- Deadly Gladiator's Quickblade
	[42291]="0:2:4:1:OneHandSword::1:0:", -- Furious Gladiator's Quickblade
	[42292]="0:2:4:1:OneHandSword::1:0:", -- Relentless Gladiator's Quickblade
	[42294]="0:2:3:1:TwoHandAxe::1:0:", -- Savage Gladiator's Decapitator
	[42295]="0:2:3:1:TwoHandMace::1:0:", -- Savage Gladiator's Bonegrinder
	[42296]="0:2:3:1:Polearm::1:0:", -- Savage Gladiator's Pike
	[42297]="0:2:3:1:TwoHandSword::1:0:", -- Savage Gladiator's Greatsword
	[42298]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Bold Dragon's Eye
	[42299]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Bright Dragon's Eye
	[42300]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Brilliant Dragon's Eye
	[42301]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Delicate Dragon's Eye
	[42302]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Flashing Dragon's Eye
	[42303]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Fractured Dragon's Eye
	[42304]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Lustrous Dragon's Eye
	[42305]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Mystic Dragon's Eye
	[42306]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Precise Dragon's Eye
	[42307]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Quick Dragon's Eye
	[42308]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Rigid Dragon's Eye
	[42309]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Runed Dragon's Eye
	[42310]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Smooth Dragon's Eye
	[42311]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Solid Dragon's Eye
	[42312]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Sparkling Dragon's Eye
	[42313]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Stormy Dragon's Eye
	[42314]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Subtle Dragon's Eye
	[42315]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Thick Dragon's Eye
	[42316]="0:2:4:1:TwoHandAxe::1:0:", -- Hateful Gladiator's Decapitator
	[42317]="0:2:4:1:TwoHandAxe::1:0:", -- Deadly Gladiator's Decapitator
	[42318]="0:2:4:1:TwoHandAxe::1:0:", -- Furious Gladiator's Decapitator
	[42319]="0:2:4:1:TwoHandAxe::1:0:", -- Relentless Gladiator's Decapitator
	[42321]="0:2:4:1:TwoHandMace::1:0:", -- Hateful Gladiator's Bonegrinder
	[42322]="0:2:4:1:TwoHandMace::1:0:", -- Deadly Gladiator's Bonegrinder
	[42323]="0:2:4:1:TwoHandMace::1:0:", -- Furious Gladiator's Bonegrinder
	[42324]="0:2:4:1:TwoHandMace::1:0:", -- Relentless Gladiator's Bonegrinder
	[42326]="0:2:4:1:Polearm::1:0:", -- Hateful Gladiator's Pike
	[42327]="0:2:4:1:Polearm::1:0:", -- Deadly Gladiator's Pike
	[42328]="0:2:4:1:Polearm::1:0:", -- Furious Gladiator's Pike
	[42329]="0:2:4:1:Polearm::1:0:", -- Relentless Gladiator's Pike
	[42331]="0:2:4:1:TwoHandSword::1:0:", -- Hateful Gladiator's Greatsword
	[42332]="0:2:4:1:TwoHandSword::1:0:", -- Deadly Gladiator's Greatsword
	[42333]="0:2:4:1:TwoHandSword::1:0:", -- Furious Gladiator's Greatsword
	[42334]="0:2:4:1:TwoHandSword::1:0:", -- Relentless Gladiator's Greatsword
	[42336]="0:4:2:1:Ring::1:0:", -- Bloodstone Band
	[42337]="0:4:2:1:Ring::1:0:", -- Sun Rock Ring
	[42338]="0:4:3:1:Amulet::1:0:", -- Jade Dagger Pendant
	[42339]="0:4:3:1:Amulet::1:0:", -- Blood Sun Necklace
	[42340]="0:4:3:1:Ring::1:0:", -- Dream Signet
	[42341]="0:4:3:1:Trinket::1:0:", -- Figurine - Ruby Hare
	[42342]="0:0:0:1:Consumable::1:0:", -- Bag of Popcorn
	[42343]="0:2:3:1:Dagger::1:0:", -- Savage Gladiator's Spellblade
	[42344]="0:2:3:1:OneHandMace::1:0:", -- Savage Gladiator's Gavel
	[42345]="0:2:4:1:Dagger::1:0:", -- Hateful Gladiator's Spellblade
	[42346]="0:2:4:1:Dagger::1:0:", -- Deadly Gladiator's Spellblade
	[42347]="0:2:4:1:Dagger::1:0:", -- Furious Gladiator's Spellblade
	[42348]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Spellblade
	[42350]="0:0:0:1:Consumable::1:0:", -- Bag of Peanuts
	[42351]="0:2:4:1:OneHandMace::1:0:", -- Hateful Gladiator's Gavel
	[42352]="0:2:4:1:OneHandMace::1:0:", -- Deadly Gladiator's Gavel
	[42353]="0:2:4:1:OneHandMace::1:0:", -- Furious Gladiator's Gavel
	[42354]="0:2:4:1:OneHandMace::1:0:", -- Relentless Gladiator's Gavel
	[42356]="0:2:3:1:Stave::1:0:", -- Savage Gladiator's Battle Staff
	[42359]="0:2:4:1:Stave::1:0:", -- Hateful Gladiator's Battle Staff
	[42360]="550000:4:1:1:Shirt::1:0:29491", -- Ebon Filigreed Doublet
	[42361]="475000:4:1:1:Shirt::1:0:29491", -- Cerulean Filigreed Doublet
	[42362]="0:2:4:1:Stave::1:0:", -- Deadly Gladiator's Battle Staff
	[42363]="525000:4:1:1:Shirt::1:0:29491", -- Golden Filigreed Doublet
	[42364]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's Battle Staff
	[42365]="450000:4:1:1:Shirt::1:0:29491", -- Amber Filigreed Doublet
	[42366]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's Battle Staff
	[42368]="500000:4:1:1:Shirt::1:0:29491", -- Scarlet Filigreed Doublet
	[42369]="350000:4:1:1:Shirt::1:0:29491", -- Ebon Filigreed Shirt
	[42370]="275000:4:1:1:Shirt::1:0:29491", -- Cerulean Filigreed Shirt
	[42371]="250000:4:1:1:Shirt::1:0:29491", -- Amber Filigreed Shirt
	[42372]="300000:4:1:1:Shirt::1:0:29491", -- Scarlet Filigreed Shirt
	[42373]="325000:4:1:1:Shirt::1:0:29491", -- Golden Filigreed Shirt
	[42374]="375000:4:1:1:Shirt::1:0:29491", -- Blue Martial Shirt
	[42375]="350000:4:1:1:Shirt::1:0:29491", -- Green Martial Shirt
	[42376]="425000:4:1:1:Shirt::1:0:29491", -- Yellow Martial Shirt
	[42377]="450000:4:1:1:Shirt::1:0:29491", -- Purple Martial Shirt
	[42378]="400000:4:1:1:Shirt::1:0:29491", -- Red Martial Shirt
	[42381]="0:0:0:2:Consumable::1:0:", -- Anguish Ale
	[42382]="0:2:3:1:Stave::1:0:", -- Savage Gladiator's Energy Staff
	[42383]="0:2:4:1:Stave::1:0:", -- Hateful Gladiator's Energy Staff
	[42384]="0:2:4:1:Stave::1:0:", -- Deadly Gladiator's Energy Staff
	[42385]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's Energy Staff
	[42386]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's Energy Staff
	[42388]="0:2:3:1:Stave::1:0:", -- Savage Gladiator's Staff
	[42389]="0:2:4:1:Stave::1:0:", -- Hateful Gladiator's Staff
	[42390]="0:2:4:1:Stave::1:0:", -- Deadly Gladiator's Staff
	[42391]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's Staff
	[42392]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's Staff
	[42394]="0:12:1:1:::1:0:", -- Dark Armor Plate
	[42395]="0:4:3:1:Trinket::1:0:", -- Figurine - Twilight Serpent
	[42396]="0:16:1:20:Priest::1:0:", -- Glyph of Circle of Healing
	[42397]="0:16:1:20:Priest::1:0:", -- Glyph of Dispel Magic
	[42398]="0:16:1:20:Priest::1:0:", -- Glyph of Fade
	[42399]="0:16:1:20:Priest::1:0:", -- Glyph of Fear Ward
	[42400]="0:16:1:20:Priest::1:0:", -- Glyph of Flash Heal
	[42401]="0:16:1:20:Priest::1:0:", -- Glyph of Holy Nova
	[42402]="0:16:1:20:Priest::1:0:", -- Glyph of Inner Fire
	[42403]="0:16:1:20:Priest::1:0:", -- Glyph of Lightwell
	[42404]="0:16:1:20:Priest::1:0:", -- Glyph of Mass Dispel
	[42405]="0:16:1:20:Priest::1:0:", -- Glyph of Mind Control
	[42406]="0:16:1:20:Priest::1:0:", -- Glyph of Shadow Word: Pain
	[42407]="0:16:1:20:Priest::1:0:", -- Glyph of Shadow
	[42408]="0:16:1:20:Priest::1:0:", -- Glyph of Power Word: Shield
	[42409]="0:16:1:20:Priest::1:0:", -- Glyph of Prayer of Healing
	[42410]="0:16:1:20:Priest::1:0:", -- Glyph of Psychic Scream
	[42411]="0:16:1:20:Priest::1:0:", -- Glyph of Renew
	[42412]="0:16:1:20:Priest::1:0:", -- Glyph of Scourge Imprisonment
	[42413]="0:4:3:1:Trinket::1:0:", -- Figurine - Sapphire Owl
	[42414]="0:16:1:20:Priest::1:0:", -- Glyph of Shadow Word: Death
	[42415]="0:16:1:20:Priest::1:0:", -- Glyph of Mind Flay
	[42416]="0:16:1:20:Priest::1:0:", -- Glyph of Smite
	[42417]="0:16:1:20:Priest::1:0:", -- Glyph of Spirit of Redemption
	[42418]="0:4:3:1:Trinket::1:0:", -- Figurine - Emerald Boar
	[42419]="0:12:1:1:::1:0:", -- Bouldercrag's War Horn
	[42420]="0:0:2:1:Other::1:0:", -- Shadow Crystal Focusing Lens
	[42421]="0:0:2:1:Other::1:0:", -- Shadow Jade Focusing Lens
	[42422]="0:13:1:10:::1:0:", -- Jotunheim Cage Key
	[42423]="0:12:1:10:::1:0:", -- Stormforged Eye
	[42424]="0:12:1:1:::1:0:", -- Diamond Tipped Pick
	[42425]="0:10:2::Currency::1:0:", -- Strand of the Ancients Mark of Honor
	[42428]="8500:0:1:20:FoodDrink::5:0:29548", -- Carrot Cupcake
	[42429]="16000:0:1:20:FoodDrink::5:0:29548", -- Red Velvet Cupcake
	[42430]="8500:0:1:20:FoodDrink::5:0:29548", -- Dalaran Doughnut
	[42431]="16000:0:1:20:FoodDrink::5:0:29548", -- Dalaran Brownie
	[42432]="0:0:1:20:FoodDrink::1:0:", -- Berry Pie Slice
	[42433]="0:0:1:20:FoodDrink::1:0:", -- Chocolate Cake Slice
	[42434]="0:0:1:20:FoodDrink::1:0:", -- Lovely Cake Slice
	[42435]="0:2:4:1:Dagger::1:0:", -- Titansteel Shanker
	[42436]="90000:0:1:1:Consumable::1:0:29548", -- Chocolate Celebration Cake
	[42438]="180000:0:1:1:Consumable::1:0:29548", -- Lovely Cake
	[42439]="17000:0:1:1:Consumable::1:0:29548", -- Big Berry Pie
	[42440]="0:7:1:1:Other::1:0:", -- Gigaflux Dimensional Transporter
	[42441]="0:12:1:1:::1:0:", -- Bouldercrag's Bomb
	[42442]="0:12:1:1:::1:0:", -- Tablets of Pronouncement
	[42443]="0:2:3:1:OneHandMace::1:0:", -- Cudgel of Saronite Justice
	[42444]="0:2:3:1:Thrown::1:0:", -- Savage Gladiator's War Edge
	[42445]="0:2:3:1:Bow::1:0:", -- Savage Gladiator's Longbow
	[42446]="0:2:3:1:Crossbow::1:0:", -- Savage Gladiator's Heavy Crossbow
	[42447]="0:2:3:1:Gun::1:0:", -- Savage Gladiator's Rifle
	[42448]="0:2:3:1:Wand::1:0:", -- Savage Gladiator's Touch of Defeat
	[42449]="0:2:4:1:Thrown::1:0:", -- Hateful Gladiator's War Edge
	[42450]="0:2:4:1:Thrown::1:0:", -- Deadly Gladiator's War Edge
	[42451]="0:2:4:1:Thrown::1:0:", -- Furious Gladiator's War Edge
	[42453]="0:16:1:20:Warlock::1:0:", -- Glyph of Incinerate
	[42454]="0:16:1:20:Warlock::1:0:", -- Glyph of Conflagrate
	[42455]="0:16:1:20:Warlock::1:0:", -- Glyph of Corruption
	[42456]="0:16:1:20:Warlock::1:0:", -- Glyph of Curse of Agony
	[42457]="0:16:1:20:Warlock::1:0:", -- Glyph of Death Coil
	[42458]="0:16:1:20:Warlock::1:0:", -- Glyph of Fear
	[42459]="0:16:1:20:Warlock::1:0:", -- Glyph of Felguard
	[42460]="0:16:1:20:Warlock::1:0:", -- Glyph of Felhunter
	[42461]="0:16:1:20:Warlock::1:0:", -- Glyph of Health Funnel
	[42462]="0:16:1:20:Warlock::1:0:", -- Glyph of Healthstone
	[42463]="0:16:1:20:Warlock::1:0:", -- Glyph of Howl of Terror
	[42464]="0:16:1:20:Warlock::1:0:", -- Glyph of Immolate
	[42465]="0:16:1:20:Warlock::1:0:", -- Glyph of Imp
	[42466]="0:16:1:20:Warlock::1:0:", -- Glyph of Searing Pain
	[42467]="0:16:1:20:Warlock::1:0:", -- Glyph of Shadow Bolt
	[42468]="0:16:1:20:Warlock::1:0:", -- Glyph of Shadowburn
	[42469]="0:16:1:20:Warlock::1:0:", -- Glyph of Siphon Life
	[42470]="0:16:1:20:Warlock::1:0:", -- Glyph of Soulstone
	[42471]="0:16:1:20:Warlock::1:0:", -- Glyph of Succubus
	[42472]="0:16:1:20:Warlock::1:0:", -- Glyph of Unstable Affliction
	[42473]="0:16:1:20:Warlock::1:0:", -- Glyph of Voidwalker
	[42475]="0:12:1:1:::1:0:", -- Colossus Attack Specs
	[42476]="0:12:1:1:::1:0:", -- Colossus Defense Specs
	[42479]="0:12:1:1:::1:0:", -- Ethereal Worg's Fang
	[42480]="0:12:1:1:::1:0:", -- Ebon Blade Banner
	[42481]="0:12:1:1:::1:0:", -- Reins of the Warbear Matriarch
	[42482]="0:13:1:1:::1:0:", -- The Violet Hold Key
	[42483]="0:2:4:1:Thrown::1:0:", -- Relentless Gladiator's War Edge
	[42484]="0:2:4:1:Gun::1:0:", -- Hateful Gladiator's Rifle
	[42485]="0:2:4:1:Gun::1:0:", -- Deadly Gladiator's Rifle
	[42486]="0:2:4:1:Gun::1:0:", -- Furious Gladiator's Rifle
	[42487]="0:2:4:1:Gun::1:0:", -- Relentless Gladiator's Rifle
	[42489]="0:2:4:1:Bow::1:0:", -- Hateful Gladiator's Longbow
	[42490]="0:2:4:1:Bow::1:0:", -- Deadly Gladiator's Longbow
	[42491]="0:2:4:1:Bow::1:0:", -- Furious Gladiator's Longbow
	[42492]="0:2:4:1:Bow::1:0:", -- Relentless Gladiator's Longbow
	[42494]="0:2:4:1:Crossbow::1:0:", -- Hateful Gladiator's Heavy Crossbow
	[42495]="0:2:4:1:Crossbow::1:0:", -- Deadly Gladiator's Heavy Crossbow
	[42496]="0:2:4:1:Crossbow::1:0:", -- Furious Gladiator's Heavy Crossbow
	[42498]="0:2:4:1:Crossbow::1:0:", -- Relentless Gladiator's Heavy Crossbow
	[42499]="0:12:1:1:::1:0:", -- Reins of the Warbear Matriarch
	[42500]="0:0:2:5:EnhPerm::1:0:", -- Titanium Shield Spike
	[42501]="0:2:4:1:Wand::1:0:", -- Hateful Gladiator's Touch of Defeat
	[42502]="0:2:4:1:Wand::1:0:", -- Deadly Gladiator's Touch of Defeat
	[42503]="0:2:4:1:Wand::1:0:", -- Furious Gladiator's Touch of Defeat
	[42504]="0:2:4:1:Wand::1:0:", -- Relentless Gladiator's Touch of Defeat
	[42508]="0:4:4:1:Shield::1:0:", -- Titansteel Shield Wall
	[42510]="0:12:1:12:::1:0:", -- Worg Fur
	[42511]="0:2:3:1:Wand::1:0:", -- Savage Gladiator's Baton of Light
	[42512]="0:2:4:1:Wand::1:0:", -- Hateful Gladiator's Baton of Light
	[42513]="0:2:4:1:Wand::1:0:", -- Deadly Gladiator's Baton of Light
	[42514]="0:2:4:1:Wand::1:0:", -- Furious Gladiator's Baton of Light
	[42515]="0:2:4:1:Wand::1:0:", -- Relentless Gladiator's Baton of Light
	[42517]="0:2:3:1:Wand::1:0:", -- Savage Gladiator's Piercing Touch
	[42518]="0:2:4:1:Wand::1:0:", -- Hateful Gladiator's Piercing Touch
	[42519]="0:2:4:1:Wand::1:0:", -- Deadly Gladiator's Piercing Touch
	[42520]="0:2:4:1:Wand::1:0:", -- Furious Gladiator's Piercing Touch
	[42521]="0:2:4:1:Wand::1:0:", -- Relentless Gladiator's Piercing Touch
	[42523]="0:4:3:1:OffHandFrill::1:0:", -- Savage Gladiator's Endgame
	[42524]="0:4:4:1:OffHandFrill::1:0:", -- Hateful Gladiator's Endgame
	[42525]="0:4:4:1:OffHandFrill::1:0:", -- Deadly Gladiator's Endgame
	[42526]="0:4:4:1:OffHandFrill::1:0:", -- Furious Gladiator's Endgame
	[42527]="0:4:4:1:OffHandFrill::1:0:", -- Relentless Gladiator's Endgame
	[42529]="0:4:3:1:OffHandFrill::1:0:", -- Savage Gladiator's Reprieve
	[42530]="0:4:4:1:OffHandFrill::1:0:", -- Hateful Gladiator's Reprieve
	[42531]="0:4:4:1:OffHandFrill::1:0:", -- Deadly Gladiator's Reprieve
	[42532]="0:4:4:1:OffHandFrill::1:0:", -- Furious Gladiator's Reprieve
	[42533]="0:4:4:1:OffHandFrill::1:0:", -- Relentless Gladiator's Reprieve
	[42535]="0:4:3:1:OffHandFrill::1:0:", -- Savage Gladiator's Grimoire
	[42536]="0:4:4:1:OffHandFrill::1:0:", -- Hateful Gladiator's Grimoire
	[42537]="0:4:4:1:OffHandFrill::1:0:", -- Deadly Gladiator's Grimoire
	[42538]="0:4:4:1:OffHandFrill::1:0:", -- Furious Gladiator's Grimoire
	[42539]="0:4:4:1:OffHandFrill::1:0:", -- Relentless Gladiator's Grimoire
	[42541]="0:12:1:10:::1:0:", -- Everfrost Shard
	[42542]="0:12:1:10:::1:0:", -- Stoic Mammoth Hide
	[42545]="0:0:1:20:Potion::1:0:", -- Runic Mana Injector
	[42546]="0:7:1:20:Device::1:0:", -- Mana Injector Kit
	[42549]="0:4:4:1:Plate::1:0:", -- Armored Titanium Goggles
	[42550]="0:4:4:1:Leather::1:0:", -- Weakness Spectralizers
	[42551]="0:4:4:1:Mail::1:0:", -- Truesight Ice Blinders
	[42552]="0:4:4:1:Plate::1:0:", -- Charged Titanium Specs
	[42553]="0:4:4:1:Cloth::1:0:", -- Visage Liquification Goggles
	[42554]="0:4:4:1:Leather::1:0:", -- Greensight Gogs
	[42555]="0:4:4:1:Mail::1:0:", -- Electroflux Sight Enhancers
	[42556]="0:4:3:1:Shield::1:0:", -- Savage Gladiator's Shield Wall
	[42557]="0:4:3:1:Shield::1:0:", -- Savage Gladiator's Barrier
	[42558]="0:4:4:1:Shield::1:0:", -- Hateful Gladiator's Shield Wall
	[42559]="0:4:4:1:Shield::1:0:", -- Deadly Gladiator's Shield Wall
	[42560]="0:4:4:1:Shield::1:0:", -- Furious Gladiator's Shield Wall
	[42561]="0:4:4:1:Shield::1:0:", -- Relentless Gladiator's Shield Wall
	[42563]="0:4:4:1:Shield::1:0:", -- Hateful Gladiator's Barrier
	[42564]="0:4:4:1:Shield::1:0:", -- Deadly Gladiator's Barrier
	[42565]="0:4:4:1:Shield::1:0:", -- Furious Gladiator's Barrier
	[42566]="0:4:4:1:Shield::1:0:", -- Relentless Gladiator's Barrier
	[42568]="0:4:3:1:Shield::1:0:", -- Savage Gladiator's Redoubt
	[42569]="0:4:4:1:Shield::1:0:", -- Hateful Gladiator's Redoubt
	[42570]="0:4:4:1:Shield::1:0:", -- Deadly Gladiator's Redoubt
	[42571]="0:4:4:1:Shield::1:0:", -- Furious Gladiator's Redoubt
	[42572]="0:4:4:1:Shield::1:0:", -- Relentless Gladiator's Redoubt
	[42574]="0:4:3:1:Idol::1:0:", -- Savage Gladiator's Idol of Resolve
	[42575]="0:4:3:1:Idol::1:0:", -- Savage Gladiator's Idol of Steadfastness
	[42576]="0:4:3:1:Idol::1:0:", -- Savage Gladiator's Idol of Tenacity
	[42577]="0:4:4:1:Idol::1:0:", -- Hateful Gladiator's Idol of Tenacity
	[42578]="0:4:4:1:Idol::1:0:", -- Deadly Gladiator's Idol of Tenacity
	[42579]="0:4:4:1:Idol::1:0:33934,33938,33941,34063,34084", -- Furious Gladiator's Idol of Tenacity
	[42580]="0:4:4:1:Idol::1:0:33937", -- Relentless Gladiator's Idol of Tenacity
	[42582]="0:4:4:1:Idol::1:0:", -- Hateful Gladiator's Idol of Steadfastness
	[42583]="0:4:4:1:Idol::1:0:", -- Deadly Gladiator's Idol of Steadfastness
	[42584]="0:4:4:1:Idol::1:0:33934,33938,33941,34063,34084", -- Furious Gladiator's Idol of Steadfastness
	[42585]="0:4:4:1:Idol::1:0:33937", -- Relentless Gladiator's Idol of Steadfastness
	[42587]="0:4:4:1:Idol::1:0:", -- Hateful Gladiator's Idol of Resolve
	[42588]="0:4:4:1:Idol::1:0:", -- Deadly Gladiator's Idol of Resolve
	[42589]="0:4:4:1:Idol::1:0:33934,33938,33941,34063,34084", -- Furious Gladiator's Idol of Resolve
	[42591]="0:4:4:1:Idol::1:0:33937", -- Relentless Gladiator's Idol of Resolve
	[42593]="0:4:3:1:Totem::1:0:", -- Savage Gladiator's Totem of Indomitability
	[42594]="0:4:3:1:Totem::1:0:", -- Savage Gladiator's Totem of Survival
	[42595]="0:4:3:1:Totem::1:0:", -- Savage Gladiator's Totem of the Third Wind
	[42596]="0:4:4:1:Totem::1:0:", -- Hateful Gladiator's Totem of the Third Wind
	[42597]="0:4:4:1:Totem::1:0:", -- Deadly Gladiator's Totem of the Third Wind
	[42598]="0:4:4:1:Totem::1:0:33934,33938,33941,34063,34084", -- Furious Gladiator's Totem of the Third Wind
	[42599]="0:4:4:1:Totem::1:0:33937", -- Relentless Gladiator's Totem of the Third Wind
	[42601]="0:4:4:1:Totem::1:0:", -- Hateful Gladiator's Totem of Survival
	[42602]="0:4:4:1:Totem::1:0:", -- Deadly Gladiator's Totem of Survival
	[42603]="0:4:4:1:Totem::1:0:33934,33938,33941,34063,34084", -- Furious Gladiator's Totem of Survival
	[42604]="0:4:4:1:Totem::1:0:33937", -- Relentless Gladiator's Totem of Survival
	[42606]="0:4:4:1:Totem::1:0:", -- Hateful Gladiator's Totem of Indomitability
	[42607]="0:4:4:1:Totem::1:0:", -- Deadly Gladiator's Totem of Indomitability
	[42608]="0:4:4:1:Totem::1:0:33934,33938,33941,34063,34084", -- Furious Gladiator's Totem of Indomitability
	[42609]="0:4:4:1:Totem::1:0:33937", -- Relentless Gladiator's Totem of Indomitability
	[42611]="0:4:3:1:Libram::1:0:", -- Savage Gladiator's Libram of Fortitude
	[42612]="0:4:3:1:Libram::1:0:", -- Savage Gladiator's Libram of Justice
	[42613]="0:4:4:1:Libram::1:0:", -- Hateful Gladiator's Libram of Justice
	[42614]="0:4:4:1:Libram::1:0:", -- Deadly Gladiator's Libram of Justice
	[42615]="0:4:4:1:Libram::1:0:33934,33938,33941,34063,34084", -- Furious Gladiator's Libram of Justice
	[42616]="0:4:4:1:Libram::1:0:33937", -- Relentless Gladiator's Libram of Justice
	[42618]="0:4:3:1:Sigil::1:0:", -- Savage Gladiator's Sigil of Strife
	[42619]="0:4:4:1:Sigil::1:0:", -- Hateful Gladiator's Sigil of Strife
	[42620]="0:4:4:1:Sigil::1:0:", -- Deadly Gladiator's Sigil of Strife
	[42621]="0:4:4:1:Sigil::1:0:33934,33938,33941,34063,34084", -- Furious Gladiator's Sigil of Strife
	[42622]="0:4:4:1:Sigil::1:0:33937", -- Relentless Gladiator's Sigil of Strife
	[42624]="0:12:1:1:::1:0:", -- Battered Storm Hammer
	[42640]="0:12:1:10:::1:0:", -- Viscous Oil
	[42641]="0:7:1:20:Explosive::1:0:", -- Global Thermal Sapper Charge
	[42642]="0:4:4:1:Ring::1:0:", -- Titanium Impact Band
	[42643]="0:4:4:1:Ring::1:0:", -- Titanium Earthguard Ring
	[42644]="0:4:4:1:Ring::1:0:", -- Titanium Spellshock Ring
	[42645]="0:4:4:1:Amulet::1:0:", -- Titanium Impact Choker
	[42646]="0:4:4:1:Amulet::1:0:", -- Titanium Earthguard Chain
	[42647]="0:4:4:1:Amulet::1:0:", -- Titanium Spellshock Necklace
	[42648]="0:9:4:1:Jewelcrafting::1:0:28721,33602", -- Design: Titanium Impact Band
	[42649]="0:9:4:1:Jewelcrafting::1:0:28721,33602", -- Design: Titanium Earthguard Ring
	[42650]="0:9:4:1:Jewelcrafting::1:0:28721,33602", -- Design: Titanium Spellshock Ring
	[42651]="0:9:4:1:Jewelcrafting::1:0:28721,33602", -- Design: Titanium Impact Choker
	[42652]="0:9:4:1:Jewelcrafting::1:0:28721,33602", -- Design: Titanium Earthguard Chain
	[42653]="0:9:4:1:Jewelcrafting::1:0:28721,33602", -- Design: Titanium Spellshock Necklace
	[42679]="0:12:1:1:::1:0:", -- Creteus's Mobile Databank
	[42700]="0:12:1:20:::1:0:", -- Reforged Armor of the Stormlord
	[42701]="0:3:2:1:GemPrismatic::1:0:", -- Enchanted Pearl
	[42702]="0:3:3:1:GemPrismatic::1:0:", -- Enchanted Tear
	[42723]="0:4:3:1:Plate::1:0:", -- Ornate Saronite Bracers
	[42724]="0:4:3:1:Plate::1:0:", -- Ornate Saronite Gauntlets
	[42725]="0:4:3:1:Plate::1:0:", -- Ornate Saronite Hauberk
	[42726]="0:4:3:1:Plate::1:0:", -- Ornate Saronite Legplates
	[42727]="0:4:3:1:Plate::1:0:", -- Ornate Saronite Pauldrons
	[42728]="0:4:3:1:Plate::1:0:", -- Ornate Saronite Skullshield
	[42729]="0:4:3:1:Plate::1:0:", -- Ornate Saronite Waistguard
	[42730]="0:4:3:1:Plate::1:0:", -- Ornate Saronite Walkers
	[42731]="0:4:3:1:Leather::1:0:", -- Leggings of Visceral Strikes
	[42732]="0:12:1:1:::1:0:", -- Everfrost Razor
	[42733]="0:12:1:1:::1:0:", -- Icemaw Bear Flank
	[42734]="0:16:1:20:Mage::1:0:", -- Glyph of Arcane Explosion
	[42735]="0:16:1:20:Mage::1:0:", -- Glyph of Arcane Missiles
	[42736]="0:16:1:20:Mage::1:0:", -- Glyph of Arcane Power
	[42737]="0:16:1:20:Mage::1:0:", -- Glyph of Blink
	[42738]="0:16:1:20:Mage::1:0:", -- Glyph of Evocation
	[42739]="0:16:1:20:Mage::1:0:", -- Glyph of Fireball
	[42740]="0:16:1:20:Mage::1:0:", -- Glyph of Fire Blast
	[42741]="0:16:1:20:Mage::1:0:", -- Glyph of Frost Nova
	[42742]="0:16:1:20:Mage::1:0:", -- Glyph of Frostbolt
	[42743]="0:16:1:20:Mage::1:0:", -- Glyph of Ice Armor
	[42744]="0:16:1:20:Mage::1:0:", -- Glyph of Ice Block
	[42745]="0:16:1:20:Mage::1:0:", -- Glyph of Ice Lance
	[42746]="0:16:1:20:Mage::1:0:", -- Glyph of Icy Veins
	[42747]="0:16:1:20:Mage::1:0:", -- Glyph of Scorch
	[42748]="0:16:1:20:Mage::1:0:", -- Glyph of Invisibility
	[42749]="0:16:1:20:Mage::1:0:", -- Glyph of Mage Armor
	[42750]="0:16:1:20:Mage::1:0:", -- Glyph of Mana Gem
	[42751]="0:16:1:20:Mage::1:0:", -- Glyph of Molten Armor
	[42752]="0:16:1:20:Mage::1:0:", -- Glyph of Polymorph
	[42753]="0:16:1:20:Mage::1:0:", -- Glyph of Remove Curse
	[42754]="0:16:1:20:Mage::1:0:", -- Glyph of Water Elemental
	[42758]="0:4:3:1:Cloth::1:0:", -- Time-Twisted Wraps
	[42760]="0:4:3:1:Cloth::1:0:", -- Sandals of Mystical Evolution
	[42761]="0:4:3:1:Leather::1:0:", -- Time-Stop Gloves
	[42762]="0:4:3:1:Leather::1:0:", -- Treads of Torn Future
	[42763]="0:4:3:1:Mail::1:0:", -- Bindings of Sabotage
	[42765]="0:4:3:1:Plate::1:0:", -- Gauntlets of the Disturbed Giant
	[42766]="0:4:3:1:Mail::1:0:", -- Spiked Treads of Mutation
	[42767]="0:4:3:1:Plate::1:0:", -- Invigorating Sabatons
	[42768]="0:4:3:1:Plate::1:0:", -- Boots of the Unbowed Protector
	[42769]="0:12:1:1:::1:0:", -- Spear of Hodir
	[42770]="0:12:1:10:::1:0:", -- Forgotten Depths Venom Sac
	[42772]="0:12:1:1:::1:0:", -- Dr. Terrible's "Building a Better Flesh Giant"
	[42774]="0:12:1:1:::1:0:", -- Arngrim's Tooth
	[42777]="11000:0:1:20:FoodDrink::5:0:30439,31115", -- Crusader's Waterskin
	[42778]="16000:0:1:20:FoodDrink::5:0:30439,31115", -- Crusader's Rations
	[42779]="16000:0:1:20:FoodDrink::5:1:30439,31115", -- Steaming Chicken Soup
	[42780]="0:12:1:200:::1:0:", -- Relic of Ulduar
	[42781]="0:12:1:1:::1:0:", -- The Chieftain's Totem
	[42782]="0:12:1:1:::1:0:", -- Stormhoof's Spear
	[42783]="0:12:1:1:::1:0:", -- Stormhoof's Mail
	[42784]="0:12:1:10:::1:0:", -- Small Proto-Drake Egg
	[42785]="0:4:2:1:Cloth::1:0:", -- Mammoth Sinew Cinch
	[42786]="0:2:2:1:OneHandSword::1:0:", -- Daschal's Serrated Blade
	[42787]="0:4:2:1:Cloth::1:0:", -- Ironwool Bindings
	[42788]="0:4:2:1:Cloth::1:0:", -- Frosthowl Cinch
	[42789]="0:4:2:1:Cloth::1:0:", -- Boots of the Howling Winds
	[42790]="0:4:2:1:Cloth::1:0:", -- K3 Surgeon's Gloves
	[42791]="0:4:2:1:Ring::1:0:", -- Ring of Order
	[42792]="0:4:2:1:Cloth::1:0:", -- Vestments of Dun Niffelem
	[42793]="0:4:2:1:Amulet::1:0:", -- Locket of Snowcrest
	[42794]="0:2:2:1:Stave::1:0:", -- Hardened Vine of the Mauler
	[42795]="0:4:2:1:Cloth::1:0:", -- Leggings of Renewed Hope
	[42796]="0:4:2:1:OffHandFrill::1:0:", -- Lantern of Enchanted Flame
	[42797]="0:12:1:1:::1:0:", -- Stolen Proto-Dragon Eggs
	[42798]="0:4:2:1:Leather::1:0:", -- Mammoth Hide Galoshes
	[42799]="0:2:2:1:TwoHandSword::1:0:", -- Snowblind Butcher
	[42800]="0:4:2:1:Leather::1:0:", -- Gale-wind Guard
	[42801]="0:4:2:1:Leather::1:0:", -- Nomadic Bracers
	[42802]="0:4:2:1:Leather::1:0:", -- Hardened Whipping Belt
	[42803]="0:4:2:1:Leather::1:0:", -- Buckshot-Proof Battlesurgeon's Protector
	[42804]="0:4:2:1:Leather::1:0:", -- Spiked Iceclimber's Boots
	[42805]="0:4:2:1:Leather::1:0:", -- Njormeld's Pauldrons
	[42806]="0:4:2:1:Leather::1:0:", -- Storm-weathered Cuffs
	[42807]="0:2:2:1:OneHandSword::1:0:", -- Blade of the Inception
	[42808]="0:4:2:1:Amulet::1:0:", -- Bouldercrag's Pendant
	[42809]="0:4:2:1:Leather::1:0:", -- Bloodied Leather Gloves
	[42810]="0:4:2:1:Mail::1:0:", -- Wooly Cowl
	[42811]="0:2:2:1:Dagger::1:0:", -- Twisted Reflection
	[42812]="0:4:2:1:Ring::1:0:", -- The "D" Ring
	[42813]="0:4:2:1:Mail::1:0:", -- Chestplate of the Northern Ranger
	[42814]="0:4:2:1:Mail::1:0:", -- Broken Chastity Belt
	[42815]="0:4:2:1:Mail::1:0:", -- Mammoth Mukluks
	[42816]="0:4:2:1:Mail::1:0:", -- Cuffs of Invention
	[42817]="0:4:2:1:Mail::1:0:", -- Reforged Chain Leggings
	[42818]="0:4:2:1:Mail::1:0:", -- Stormstalker's Clutch
	[42819]="0:2:2:1:OneHandMace::1:0:", -- Maker's Touch
	[42820]="0:4:2:1:Mail::1:0:", -- Mantle of Bouldercrag
	[42821]="0:4:2:1:Mail::1:0:", -- Belt of the Stormforged
	[42822]="0:2:2:1:Gun::1:0:", -- K3 Pachyderm Prevention Device
	[42823]="0:2:2:1:OneHandMace::1:0:", -- Ricket's Beatstick
	[42824]="0:2:2:1:TwoHandAxe::1:0:", -- Maker's Edge
	[42825]="0:4:2:1:Plate::1:0:", -- Polished Tusk Shackles
	[42826]="0:4:2:1:Plate::1:0:", -- Goblin Damage Absorber
	[42827]="0:4:2:1:Plate::1:0:", -- Rockshaper's Resolve
	[42828]="0:2:2:1:Stave::1:0:", -- Garm's Ward
	[42829]="0:4:2:1:Plate::1:0:", -- Plated Skullguard
	[42830]="0:4:2:1:Plate::1:0:", -- Ring of Jokkum
	[42831]="0:2:2:1:Dagger::1:0:", -- Maiden's Dagger
	[42832]="0:4:2:1:Plate::1:0:", -- Coldblooded Legplates
	[42833]="0:4:2:1:Plate::1:0:", -- Jawbreakers
	[42834]="0:4:2:1:Plate::1:0:", -- Mantle of Long Winter
	[42835]="0:4:2:1:Plate::1:0:", -- Backhanded Grips
	[42836]="0:4:2:1:Plate::1:0:", -- Rockshaper Stompers
	[42837]="0:12:1:1:::1:0:", -- Disciplining Rod
	[42838]="0:12:1:1:::1:0:", -- Runed Harness
	[42839]="0:12:1:1:::1:0:", -- The Lorehammer
	[42840]="0:12:1:1:::1:0:", -- Horn of the Peaks
	[42841]="0:4:2:1:Cloth::1:0:", -- Leggings of the Frozen Wastes
	[42842]="0:4:2:1:Cloth::1:0:", -- Fur-Lined Shoulder Warmers
	[42843]="0:4:2:1:Cloth::1:0:", -- Mildred's Cowl
	[42844]="0:4:3:1:Cloth::1:0:", -- Robes of Lightning
	[42845]="0:4:2:1:Ring::1:0:", -- Brunnhildar Runed Ring
	[42846]="0:4:2:1:Cloth::1:0:", -- Jormungar Galoshes
	[42847]="0:4:2:1:Cloth::1:0:", -- Terrace Gazer's Gloves
	[42848]="0:2:2:1:Dagger::1:0:", -- Razor-sharp Icicle
	[42849]="0:4:2:1:Cloth::1:0:", -- Flowing Valkyrion Robes
	[42850]="0:4:2:1:Cloth::1:0:", -- Flamebringer's Crown
	[42851]="0:4:4:1:Libram::1:0:", -- Hateful Gladiator's Libram of Fortitude
	[42852]="0:4:4:1:Libram::1:0:", -- Deadly Gladiator's Libram of Fortitude
	[42853]="0:4:4:1:Libram::1:0:33934,33938,33941,34063,34084", -- Furious Gladiator's Libram of Fortitude
	[42854]="0:4:4:1:Libram::1:0:33937", -- Relentless Gladiator's Libram of Fortitude
	[42857]="0:2:2:1:Stave::1:0:", -- Thorim's Riding Crop
	[42858]="0:2:2:1:Crossbow::1:0:", -- Crossbow of the Storms
	[42859]="0:2:2:1:TwoHandMace::1:0:", -- Thorim's Crusher
	[42860]="0:4:2:1:Shield::1:0:", -- Broodmother's Protector
	[42861]="0:2:2:1:Dagger::1:0:", -- Jormungar Fang
	[42862]="0:2:2:1:FistWeapon::1:0:", -- Hyldnir Painbringer
	[42863]="0:2:2:1:Thrown::1:0:", -- Sharpened Hyldnir Harpoon
	[42864]="0:4:2:1:Ring::1:0:", -- Frozen Mood Ring
	[42865]="0:4:2:1:Leather::1:0:", -- Frost Hardened Bracers
	[42866]="0:4:2:1:Leather::1:0:", -- Fur-Lined Mittens
	[42867]="0:4:2:1:Leather::1:0:", -- Cured Proto-Drake Leggings
	[42868]="0:2:2:1:OneHandMace::1:0:", -- Hyldnir Headcracker
	[42869]="0:4:2:1:Leather::1:0:", -- Yeti Hide Mantle
	[42870]="0:4:2:1:Leather::1:0:", -- Hibernal Chestguard
	[42871]="0:4:2:1:Leather::1:0:", -- Bracer of Tarbash
	[42872]="0:4:2:1:Leather::1:0:", -- Proto-Drake Cover
	[42874]="0:4:2:1:Leather::1:0:", -- Wooly Stompers
	[42876]="0:4:2:1:Plate::1:0:", -- Light-Touched Mantle
	[42877]="0:4:2:1:Plate::1:0:", -- Chestguard of the Frozen Ascent
	[42878]="0:4:2:1:Plate::1:0:", -- Vrykul Training Helm
	[42879]="0:4:2:1:Plate::1:0:", -- Crown of Hyldnir
	[42880]="0:4:2:1:Plate::1:0:", -- Astrid's Riding Gloves
	[42881]="0:4:2:1:Plate::1:0:", -- Bjornrittar's Chilled Legguards
	[42882]="0:4:2:1:Plate::1:0:", -- Thorim's Grasp
	[42883]="0:4:2:1:Plate::1:0:", -- Iva's Boots
	[42884]="0:4:2:1:Plate::1:0:", -- Steel-tipped Snowboots
	[42887]="0:4:2:1:Mail::1:0:", -- Pauldrons of the Ascent
	[42888]="0:4:2:1:Mail::1:0:", -- Summit Bracers
	[42889]="0:4:2:1:Mail::1:0:", -- Mildred's Grasp
	[42890]="0:4:2:1:Mail::1:0:", -- Proto-scale Pants
	[42891]="0:4:2:1:Mail::1:0:", -- Brunnhildar Snowkickers
	[42892]="0:4:2:1:Mail::1:0:", -- Scaled Proto-Wristguard
	[42893]="0:4:2:1:Mail::1:0:", -- Shoulders of Earthen Might
	[42894]="0:12:1:1:::1:0:", -- Horn of Elemental Fury
	[42895]="0:4:2:1:Mail::1:0:", -- Scaled Jormungar Protector
	[42896]="0:4:2:1:Mail::1:0:", -- Valkyrion Tracker's Chestguard
	[42897]="0:16:1:20:Hunter::1:0:", -- Glyph of Aimed Shot
	[42898]="0:16:1:20:Hunter::1:0:", -- Glyph of Arcane Shot
	[42899]="0:16:1:20:Hunter::1:0:", -- Glyph of the Beast
	[42900]="0:16:1:20:Hunter::1:0:", -- Glyph of Mending
	[42901]="0:16:1:20:Hunter::1:0:", -- Glyph of Aspect of the Viper
	[42902]="0:16:1:20:Hunter::1:0:", -- Glyph of Bestial Wrath
	[42903]="0:16:1:20:Hunter::1:0:", -- Glyph of Deterrence
	[42904]="0:16:1:20:Hunter::1:0:", -- Glyph of Disengage
	[42905]="0:16:1:20:Hunter::1:0:", -- Glyph of Freezing Trap
	[42906]="0:16:1:20:Hunter::1:0:", -- Glyph of Frost Trap
	[42907]="0:16:1:20:Hunter::1:0:", -- Glyph of Hunter's Mark
	[42908]="0:16:1:20:Hunter::1:0:", -- Glyph of Immolation Trap
	[42909]="0:16:1:20:Hunter::1:0:", -- Glyph of the Hawk
	[42910]="0:16:1:20:Hunter::1:0:", -- Glyph of Multi-Shot
	[42911]="0:16:1:20:Hunter::1:0:", -- Glyph of Rapid Fire
	[42912]="0:16:1:20:Hunter::1:0:", -- Glyph of Serpent Sting
	[42913]="0:16:1:20:Hunter::1:0:", -- Glyph of Snake Trap
	[42914]="0:16:1:20:Hunter::1:0:", -- Glyph of Steady Shot
	[42915]="0:16:1:20:Hunter::1:0:", -- Glyph of Trueshot Aura
	[42916]="0:16:1:20:Hunter::1:0:", -- Glyph of Volley
	[42917]="0:16:1:20:Hunter::1:0:", -- Glyph of Wyvern Sting
	[42918]="0:12:1:1:::1:0:", -- The Lorehammer
	[42922]="0:12:3:1:::1:0:", -- Swords Deck
	[42926]="0:12:1:20:::1:0:", -- Cave Mushroom
	[42927]="0:12:1:5:::1:0:", -- Toxin Gland
	[42928]="0:12:1:1:::1:0:", -- Bethod's Sword
	[42930]="0:15:0:20:Junk::1:0:", -- Crooked Cog
	[42931]="0:15:0:20:Junk::1:0:", -- Toothless Gear
	[42942]="0:0:1:20:FoodDrink::1:0:", -- Baked Manta Ray
	[42943]="0:2:7:1:TwoHandAxe::1:0:32509,34885,35507,35508", -- Bloodied Arcanite Reaper
	[42944]="0:2:7:1:Dagger::1:0:32509,34885,35507,35508", -- Balanced Heartseeker
	[42945]="0:2:7:1:OneHandSword::1:0:32509,34885,35507,35508", -- Venerable Dal'Rend's Sacred Charge
	[42946]="0:2:7:1:Bow::1:0:32509,34885,35507,35508", -- Charmed Ancient Bone Bow
	[42947]="0:2:7:1:Stave::1:0:32509,34885,35507,35508", -- Dignified Headmaster's Charge
	[42948]="0:2:7:1:OneHandMace::1:0:32509,34885,35507,35508", -- Devout Aurastone Hammer
	[42949]="0:4:7:1:Plate::1:0:32509,34885,35507,35508", -- Polished Spaulders of Valor
	[42950]="0:4:7:1:Mail::1:0:32509,34885,35507,35508", -- Champion Herod's Shoulder
	[42951]="0:4:7:1:Mail::1:0:32509,34885,35507,35508", -- Mystical Pauldrons of Elements
	[42952]="0:4:7:1:Leather::1:0:32509,34885,35507,35508", -- Stained Shadowcraft Spaulders
	[42954]="0:16:1:20:Rogue::1:0:", -- Glyph of Adrenaline Rush
	[42955]="0:16:1:20:Rogue::1:0:", -- Glyph of Ambush
	[42956]="0:16:1:20:Rogue::1:0:", -- Glyph of Backstab
	[42957]="0:16:1:20:Rogue::1:0:", -- Glyph of Blade Flurry
	[42958]="0:16:1:20:Rogue::1:0:", -- Glyph of Crippling Poison
	[42959]="0:16:1:20:Rogue::1:0:", -- Glyph of Deadly Throw
	[42960]="0:16:1:20:Rogue::1:0:", -- Glyph of Evasion
	[42961]="0:16:1:20:Rogue::1:0:", -- Glyph of Eviscerate
	[42962]="0:16:1:20:Rogue::1:0:", -- Glyph of Expose Armor
	[42963]="0:16:1:20:Rogue::1:0:", -- Glyph of Feint
	[42964]="0:16:1:20:Rogue::1:0:", -- Glyph of Garrote
	[42965]="0:16:1:20:Rogue::1:0:", -- Glyph of Ghostly Strike
	[42966]="0:16:1:20:Rogue::1:0:", -- Glyph of Gouge
	[42967]="0:16:1:20:Rogue::1:0:", -- Glyph of Hemorrhage
	[42968]="0:16:1:20:Rogue::1:0:", -- Glyph of Preparation
	[42969]="0:16:1:20:Rogue::1:0:", -- Glyph of Rupture
	[42970]="0:16:1:20:Rogue::1:0:", -- Glyph of Sap
	[42971]="0:16:1:20:Rogue::1:0:", -- Glyph of Vigor
	[42972]="0:16:1:20:Rogue::1:0:", -- Glyph of Sinister Strike
	[42973]="0:16:1:20:Rogue::1:0:", -- Glyph of Slice and Dice
	[42974]="0:16:1:20:Rogue::1:0:", -- Glyph of Sprint
	[42984]="0:4:7:1:Leather::1:0:32509,34885,35507,35508", -- Preened Ironfeather Shoulders
	[42985]="0:4:7:1:Cloth::1:0:32509,34885,35507,35508", -- Tattered Dreadmist Mantle
	[42986]="0:0:1:10:Other::1:0:", -- The RP-GG
	[42987]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Greatness
	[42988]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Illusion
	[42989]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Berserker!
	[42990]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Death
	[42991]="0:4:7:1:Trinket::1:0:32509,34885,35507,35508", -- Swift Hand of Justice
	[42992]="0:4:7:1:Trinket::1:0:32509,34885,35507,35508", -- Discerning Eye of the Beast
	[42993]="0:0:1:20:FoodDrink::1:0:", -- Spicy Fried Herring
	[42994]="0:0:1:20:FoodDrink::1:0:", -- Rhinolicious Wormsteak
	[42995]="0:0:1:20:FoodDrink::1:0:", -- Hearty Rhino
	[42996]="0:0:1:20:FoodDrink::1:0:", -- Snapper Extreme
	[42997]="0:0:1:20:FoodDrink::1:0:", -- Blackened Worg Steak
	[42998]="0:0:1:20:FoodDrink::1:0:", -- Cuttlesteak
	[42999]="0:0:1:20:FoodDrink::1:0:", -- Blackened Dragonfin
	[43000]="0:0:1:20:FoodDrink::1:0:", -- Dragonfin Filet
	[43001]="0:0:1:20:FoodDrink::1:0:", -- Tracker Snacks
	[43002]="0:0:1:10:Other::1:0:", -- Inflatable Land Mines
	[43004]="0:0:1:20:FoodDrink::1:0:", -- Critter Bites
	[43005]="0:0:1:20:FoodDrink::1:0:", -- Spiced Mammoth Treats
	[43006]="0:12:1:3:::1:0:", -- Emerald Acorn
	[43007]="0:7:1:100:Other:185:10:0:31031,31032,33595", -- Northern Spices
	[43009]="0:7:1:20:Meat:185:1:0:", -- Shoveltusk Flank
	[43010]="0:7:1:20:Meat:185:1:0:", -- Worm Meat
	[43011]="0:7:1:20:Meat:185:1:0:", -- Worg Haunch
	[43012]="0:7:1:20:Meat:185:1:0:", -- Rhino Meat
	[43013]="0:7:1:20:Meat:185:1:0:", -- Chilled Meat
	[43015]="0:0:1:20:FoodDrink::1:0:", -- Fish Feast
	[43016]="0:10:2::Currency::1:0:", -- Dalaran Cooking Award
	[43017]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Fish Feast
	[43018]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Mega Mammoth Meal
	[43019]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Tender Shoveltusk Steak
	[43020]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Spiced Worm Burger
	[43021]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Very Burnt Worg
	[43022]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Mighty Rhino Dogs
	[43023]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Poached Northern Sculpin
	[43024]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Firecracker Salmon
	[43025]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Spicy Blue Nettlefish
	[43026]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Imperial Manta Steak
	[43027]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Spicy Fried Herring
	[43028]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Rhinolicious Wormsteak
	[43029]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Critter Bites
	[43030]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Hearty Rhino
	[43031]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Snapper Extreme
	[43032]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Blackened Worg Steak
	[43033]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Cuttlesteak
	[43034]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Spiced Mammoth Treats
	[43035]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Blackened Dragonfin
	[43036]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Dragonfin Filet
	[43037]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Tracker Snacks
	[43039]="0:12:2:1:::1:0:", -- Rogues Deck
	[43059]="0:12:1:1:::1:0:", -- Drakuru's Last Wish
	[43068]="0:4:4:1:Plate::1:0:16786", -- Blessed Spaulders of Undead Slaying
	[43069]="0:4:4:1:Plate::1:0:", -- Blessed Breastplate of Undead Slaying
	[43070]="0:4:4:1:Plate::1:0:16786", -- Blessed Gauntlets of Undead Slaying
	[43071]="0:4:4:1:Plate::1:0:", -- Blessed Legplates of Undead Slaying
	[43072]="0:4:4:1:Cloth::1:0:", -- Blessed Robe of Undead Cleansing
	[43073]="0:4:4:1:Cloth::1:0:16786", -- Blessed Gloves of Undead Cleansing
	[43074]="0:4:4:1:Cloth::1:0:16786", -- Blessed Mantle of Undead Cleansing
	[43075]="0:4:4:1:Cloth::1:0:", -- Blessed Trousers of Undead Cleansing
	[43076]="0:4:4:1:Leather::1:0:", -- Blessed Tunic of Undead Slaying
	[43077]="0:4:4:1:Leather::1:0:16786", -- Blessed Shoulderpads of Undead Slaying
	[43078]="0:4:4:1:Leather::1:0:16786", -- Blessed Grips of Undead Slaying
	[43079]="0:4:4:1:Leather::1:0:", -- Blessed Leggings of Undead Slaying
	[43080]="0:4:4:1:Mail::1:0:", -- Blessed Hauberk of Undead Slaying
	[43081]="0:4:4:1:Mail::1:0:16786", -- Blessed Pauldrons of Undead Slaying
	[43082]="0:4:4:1:Mail::1:0:16786", -- Blessed Handguards of Undead Slaying
	[43083]="0:4:4:1:Mail::1:0:", -- Blessed Greaves of Undead Slaying
	[43084]="0:12:1:1:::1:0:", -- Dahlia's Tears
	[43085]="0:4:4:1:Shield::1:0:", -- Royal Crest of Lordaeron
	[43086]="8500:0:1:20:FoodDrink::5:0:29547", -- Fresh Apple Juice
	[43087]="0:0:1:20:FoodDrink::1:0:", -- Crisp Dalaran Apple
	[43088]="40000:0:1:1:Consumable::1:0:29547", -- Dalaran Apple Bowl
	[43089]="0:12:1:250:::1:0:", -- Vrykul Bones
	[43090]="0:12:1:250:::1:0:", -- Fate Rune of Baneful Intent
	[43094]="0:12:1:250:::1:0:", -- Fate Rune of Nigh Invincibility
	[43095]="0:12:1:1:::1:0:", -- Berinand's Research
	[43096]="0:12:1:1:::1:0:", -- The Breath of Alexstrasza
	[43099]="0:12:1:1:::1:0:", -- Infused Mushroom Meatloaf
	[43100]="0:12:1:20:::1:0:", -- Infused Mushroom
	[43101]="0:12:1:1:::1:0:", -- Meatloaf Pan
	[43102]="0:7:3:20:Other:164,202,755,165,197,773:1:0:31580,31582", -- Frozen Orb
	[43103]="0:7:2:20:Other:773:1:0:", -- Verdant Pigment
	[43104]="0:7:2:20:Other:773:1:0:", -- Burnt Pigment
	[43105]="0:7:2:20:Other:773:1:0:", -- Indigo Pigment
	[43106]="0:7:2:20:Other:773:1:0:", -- Ruby Pigment
	[43107]="0:7:2:20:Other:773:1:0:", -- Sapphire Pigment
	[43108]="0:7:2:20:Other:773:1:0:", -- Ebon Pigment
	[43109]="0:7:2:20:Other:773:1:0:", -- Icy Pigment
	[43115]="0:7:2:20:Part:773:1:0:", -- Hunter's Ink
	[43116]="0:7:1:20:Part:773:1:0:33027", -- Lion's Ink
	[43117]="0:7:2:20:Part:773:1:0:", -- Dawnstar Ink
	[43118]="0:7:1:20:Part:773:1:0:33027", -- Jadefire Ink
	[43119]="0:7:2:20:Part:773:1:0:", -- Royal Ink
	[43120]="0:7:1:20:Part:773:1:0:33027", -- Celestial Ink
	[43121]="0:7:2:20:Part:773:1:0:", -- Fiery Ink
	[43122]="0:7:1:20:Part:773:1:0:33027", -- Shimmering Ink
	[43123]="0:7:2:20:Part:773:1:0:", -- Ink of the Sky
	[43124]="0:7:1:20:Part:773:1:0:33027", -- Ethereal Ink
	[43125]="0:7:2:20:Part:773:1:0:", -- Darkflame Ink
	[43126]="0:7:1:20:Part:773:1:0:", -- Ink of the Sea
	[43127]="0:7:2:20:Part:773:1:0:33027", -- Snowfall Ink
	[43128]="0:12:1:1:::1:0:", -- Jug of Wine
	[43129]="0:4:3:1:Mail::1:0:", -- Razorstrike Breastplate
	[43130]="0:4:3:1:Mail::1:0:", -- Virulent Spaulders
	[43131]="0:4:3:1:Mail::1:0:", -- Eaglebane Bracers
	[43132]="0:4:3:1:Mail::1:0:", -- Nightshock Hood
	[43133]="0:4:3:1:Mail::1:0:", -- Nightshock Girdle
	[43134]="0:12:1:250:::1:0:", -- Fate Rune of Primal Energy
	[43135]="0:0:1:250:Consumable::1:0:", -- Fate Rune of Fleet Feet
	[43136]="0:12:1:1:::1:0:", -- Wine and Cheese Platter
	[43137]="0:12:1:1:::1:0:", -- Aged Dalaran Limburger
	[43138]="0:12:1:20:::1:0:", -- Half Full Dalaran Wine Glass
	[43139]="0:12:1:1:::1:0:", -- Empty Cheese Serving Platter
	[43140]="0:12:1:10:::1:0:", -- Drakkari History Tablet
	[43141]="0:12:1:250:::1:0:", -- Fate Rune of Unsurpassed Vigor
	[43142]="0:12:1:1:::1:0:", -- Empty Picnic Basket
	[43143]="0:12:1:20:::1:0:", -- Wild Mustard
	[43144]="0:12:1:1:::1:0:", -- Mustard Dog Basket!
	[43145]="0:7:1:20:EnchArmor::1:0:", -- Armor Vellum III
	[43146]="0:7:1:20:EnchWeapon::1:0:", -- Weapon Vellum III
	[43147]="0:12:1:1:::1:0:", -- Stew Cookpot
	[43148]="0:12:1:20:::1:0:", -- Crystalsong Carrot
	[43149]="0:12:1:1:::1:0:", -- Vegetable Stew
	[43151]="0:12:1:10:::1:0:", -- Loken's Tongue
	[43153]="0:12:1:1:::1:0:", -- Holy Water
	[43154]="10000:4:1:1:Tabard::1:0:30431", -- Tabard of the Argent Crusade
	[43155]="10000:4:1:1:Tabard::1:0:32538", -- Tabard of the Ebon Blade
	[43156]="10000:4:1:1:Tabard::1:0:32533", -- Tabard of the Wyrmrest Accord
	[43157]="10000:4:1:1:Tabard::1:0:32287", -- Tabard of the Kirin Tor
	[43158]="0:12:1:10:::1:0:", -- Drakkari Colossus Fragment
	[43159]="0:12:1:1:::1:0:", -- Master Summoner's Staff
	[43160]="0:4:3:1:Cloth::1:0:", -- Leggings of Fastidious Decapitation
	[43161]="0:4:3:1:Leather::1:0:", -- Legguards of Solemn Revenge
	[43162]="0:4:3:1:Mail::1:0:", -- Ceremonial Pike Leggings
	[43163]="0:4:3:1:Plate::1:0:", -- Legplates of the Vengeful Mendicant
	[43164]="0:4:3:1:Cloth::1:0:", -- Sly Mojo Sash
	[43165]="0:4:3:1:Leather::1:0:", -- Strange Voodoo Belt
	[43166]="0:12:1:1:::1:0:", -- The Bone Witch's Amulet
	[43167]="0:4:3:1:Mail::1:0:", -- Ranger's Belt of the Fallen Empire
	[43168]="0:4:3:1:Plate::1:0:", -- Clasp of the Fallen Demi-God
	[43169]="0:12:1:15:::1:0:", -- Scourgestone
	[43171]="0:4:3:1:Cloth::1:0:", -- Fur-lined Moccasins
	[43172]="0:4:3:1:Leather::1:0:", -- Rhino Hide Kneeboots
	[43173]="0:4:3:1:Mail::1:0:", -- Scaled Boots of Fallen Hope
	[43174]="0:4:3:1:Plate::1:0:", -- Trollkickers
	[43176]="0:4:3:1:Plate::1:0:", -- Slippers of the Mojo Dojo
	[43177]="0:4:3:1:Ring::1:0:", -- Voodoo Signet
	[43178]="0:4:3:1:Ring::1:0:", -- Ring of Foul Mojo
	[43179]="0:4:3:1:Ring::1:0:", -- Solid Platinum Band
	[43180]="0:4:3:1:Ring::1:0:", -- Lion's Head Ring
	[43181]="0:4:3:1:Cloth::1:0:", -- Shoulders of the Northern Lights
	[43182]="0:4:3:1:Leather::1:0:", -- Cured Mammoth Hide Mantle
	[43183]="0:4:3:1:Mail::1:0:", -- Tundra Tracker's Shoulderguards
	[43184]="0:4:3:1:Plate::1:0:", -- Tundra Pauldrons
	[43185]="0:2:3:1:Wand::1:0:", -- Wand of Chilled Renewal
	[43186]="0:2:3:1:Wand::1:0:", -- Iceshrieker's Touch
	[43187]="0:2:3:1:Thrown::1:0:", -- Weighted Throwing Axe
	[43188]="0:2:3:1:Thrown::1:0:", -- Razor-sharp Ice Shards
	[43189]="0:4:3:1:Ring::1:0:", -- Amberglow Signet
	[43190]="0:4:3:1:Ring::1:0:", -- Iceforged Battle Ring
	[43191]="0:4:3:1:Ring::1:0:", -- Jagged Ice Band
	[43192]="0:4:3:1:Ring::1:0:", -- Ring of the Northern Winds
	[43193]="0:4:3:1:Cloth::1:0:", -- Lightning Infused Mantle
	[43194]="0:4:3:1:Leather::1:0:", -- Charred Leather Shoulderguards
	[43195]="0:4:3:1:Mail::1:0:", -- Stormforged Shoulders
	[43197]="0:4:3:1:Plate::1:0:", -- Pauldrons of Extinguished Hatred
	[43198]="0:4:3:1:Plate::1:0:", -- Mantle of Volkhan
	[43200]="0:4:3:1:Cloth::1:0:", -- Snowdrift Pantaloons
	[43201]="0:4:3:1:Leather::1:0:", -- Leggings of Heightened Renewal
	[43202]="0:4:3:1:Mail::1:0:", -- Jormungar Hide Legguards
	[43203]="0:4:3:1:Plate::1:0:", -- Iron Colossus Legplates
	[43204]="0:4:2:1:Cloth::1:0:", -- Hyldnir Runeweaver's Garb
	[43206]="0:12:1:1:::1:0:", -- War Horn of Acherus
	[43207]="0:4:3:1:Leather::1:0:", -- Hardened Tongue Tunic
	[43208]="0:4:3:1:Mail::1:0:", -- Lightningbringer's Hauberk
	[43209]="0:4:3:1:Plate::1:0:", -- Breastplate of Jagged Stone
	[43210]="0:4:3:1:Cloth::1:0:", -- Gloves of the Servant
	[43211]="0:4:3:1:Leather::1:0:", -- Rough Climber's Grips
	[43212]="0:4:3:1:Mail::1:0:", -- Gauntlets of the Windreacher
	[43213]="0:4:3:1:Plate::1:0:", -- Gauntlets of Vigilance
	[43214]="0:12:1:1:::1:0:", -- Kurzel's Blouse Scrap
	[43215]="0:12:1:1:::1:0:", -- Ichor-Stained Cloth
	[43217]="0:12:1:10:::1:0:", -- Crystalline Heartwood
	[43218]="0:12:1:10:::1:0:", -- Ancient Elven Masonry
	[43225]="0:12:1:8:::1:0:", -- Crystallized Energy
	[43228]="0:10:3::Currency::1:0:", -- Stone Keeper's Shard
	[43229]="0:12:1:1:::1:0:", -- Death's Gaze Orb
	[43230]="4000:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,23732,24148,24313,24349,24357,24780,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,37904,37935", -- Instant Poison VIII
	[43231]="4500:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,12096,12097,15175,16268,16683,18006,20121,23732,24148,24313,24349,24357,24780,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29561,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,35642,37904,37935", -- Instant Poison IX
	[43232]="4500:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,23732,24148,24313,24349,24357,24780,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,37904,37935", -- Deadly Poison VIII
	[43233]="5000:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,12096,12097,15175,16268,16683,18006,20121,23732,24148,24313,24349,24357,24780,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29561,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,35642,37904,37935", -- Deadly Poison IX
	[43234]="3500:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,10364,12096,12097,15175,16268,16683,18006,20121,23732,24148,24313,24349,24357,24780,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,37904,37935", -- Wound Poison VI
	[43235]="4000:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,12096,12097,15175,16268,16683,18006,20121,23732,24148,24313,24349,24357,24780,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29561,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,35642,37904,37935", -- Wound Poison VII
	[43236]="10000:0:1:20:FoodDrink::20:0:32334", -- Star's Sorrow
	[43237]="4000:0:1:20:EnhTemp::1:0:1325,1326,1457,2622,3090,3135,3334,3490,3542,3551,3561,3969,4585,5139,5169,6779,12096,12097,15175,16268,16683,18006,20121,23732,24148,24313,24349,24357,24780,25736,26382,26568,26598,26900,26945,26950,27031,27038,27053,27089,27133,27149,27176,27186,28347,28832,28869,29015,29037,29535,29561,29909,29922,29947,29961,29968,30010,30069,30239,30244,30306,30438,31115,32639,32641,35642,37904,37935", -- Anesthetic Poison II
	[43238]="0:12:1:5:::1:0:", -- Untarnished Silver Bar
	[43239]="0:12:1:5:::1:0:", -- Shiny Bauble
	[43240]="0:12:1:5:::1:0:", -- Golden Goblet
	[43241]="0:12:1:5:::1:0:", -- Jade Statue
	[43242]="0:12:1:1:::1:0:", -- Jagged Shard
	[43243]="0:12:1:1:::1:0:", -- Blessed Banner of the Crusade
	[43244]="0:4:2:1:Amulet::1:0:", -- Crystal Citrine Necklace
	[43245]="0:4:2:1:Amulet::1:0:", -- Crystal Chalcedony Amulet
	[43246]="0:4:3:1:Ring::1:0:", -- Earthshadow Ring
	[43247]="0:4:3:1:Ring::1:0:", -- Jade Ring of Slaying
	[43248]="0:4:2:1:Ring::1:0:", -- Stoneguard Band
	[43249]="0:4:2:1:Ring::1:0:", -- Shadowmight Ring
	[43250]="0:4:3:1:Ring::1:0:", -- Ring of Earthen Might
	[43251]="0:4:3:1:Ring::1:0:", -- Ring of Scarlet Shadows
	[43252]="0:4:3:1:Ring::1:0:", -- Windfire Band
	[43253]="0:4:3:1:Ring::1:0:", -- Ring of Northern Tears
	[43255]="0:4:3:1:Leather::1:0:", -- Seafoam Gauntlets
	[43256]="0:4:3:1:Leather::1:0:", -- Jormscale Footpads
	[43257]="0:4:3:1:Leather::1:0:", -- Wildscale Breastplate
	[43258]="0:4:3:1:Leather::1:0:", -- Purehorn Spaulders
	[43259]="0:12:1:10:::1:0:", -- Jagged Shard
	[43260]="0:4:3:1:Leather::1:0:", -- Eviscerator's Facemask
	[43261]="0:4:3:1:Leather::1:0:", -- Overcast Headguard
	[43262]="0:4:3:1:Leather::1:0:", -- Overcast Spaulders
	[43263]="0:4:3:1:Leather::1:0:", -- Overcast Chestguard
	[43264]="0:4:3:1:Leather::1:0:", -- Overcast Bracers
	[43265]="0:4:3:1:Leather::1:0:", -- Overcast Handwraps
	[43266]="0:4:3:1:Leather::1:0:", -- Overcast Belt
	[43268]="0:0:1:20:FoodDrink::1:0:", -- Dalaran Clam Chowder
	[43269]="0:12:1:1:::1:0:", -- Blood Jade Amulet
	[43270]="0:12:1:1:::1:0:", -- Glowing Ivory Figurine
	[43271]="0:4:3:1:Leather::1:0:", -- Overcast Leggings
	[43272]="0:12:1:1:::1:0:", -- Wicked Sun Brooch
	[43273]="0:4:3:1:Leather::1:0:", -- Overcast Boots
	[43274]="0:12:1:1:::1:0:", -- Intricate Bone Figurine
	[43275]="0:12:1:1:::1:0:", -- Bright Armor Relic
	[43276]="0:12:1:1:::1:0:", -- Shifting Sun Curio
	[43277]="0:4:3:1:Ring::1:0:", -- Jedoga's Greatring
	[43278]="0:4:3:1:Cloak::1:0:", -- Cloak of the Darkcaster
	[43279]="0:4:3:1:Plate::1:0:", -- Battlechest of the Twilight Cult
	[43280]="0:4:3:1:Plate::1:0:", -- Faceguard of the Hammer Clan
	[43281]="0:2:3:1:TwoHandAxe::1:0:", -- Edge of Oblivion
	[43282]="0:4:3:1:Amulet::1:0:", -- Shadowseeker's Pendant
	[43283]="0:4:3:1:Cloak::1:0:", -- Subterranean Waterfall Shroud
	[43284]="0:2:3:1:Crossbow::1:0:", -- Amanitar Skullbow
	[43285]="0:4:3:1:Amulet::1:0:", -- Amulet of the Spell Flinger
	[43286]="0:4:3:1:Leather::1:0:", -- Legguards of Swarming Attacks
	[43287]="0:4:3:1:Cloth::1:0:", -- Silken Bridge Handwraps
	[43288]="0:12:1:1:::1:0:", -- Smelted Metal Bar
	[43289]="0:12:1:1:::1:0:", -- Bag of Jagged Shards
	[43290]="0:12:1:1:::1:0:", -- Father Gustav's Report
	[43291]="0:12:1:10:::1:0:", -- Runed Saronite Plate
	[43297]="0:12:2:1:::1:0:", -- Damaged Necklace
	[43298]="0:12:2:1:::1:0:", -- Beautiful Chalcedony Necklace
	[43299]="0:12:2:1:::1:0:", -- Damaged Necklace
	[43300]="0:4:4:1:Tabard::1:0:", -- Loremaster's Colors
	[43305]="0:4:3:1:Cloak::1:0:", -- Shroud of Akali
	[43306]="0:4:3:1:Ring::1:0:", -- Gal'darah's Signet
	[43307]="0:10:1::Currency::1:0:", -- Arena Points
	[43308]="0:10:1::Currency::1:0:", -- Honor Points
	[43309]="0:4:3:1:Amulet::1:0:", -- Amulet of the Stampede
	[43310]="0:4:3:1:Plate::1:0:", -- Engraved Chestplate of Eck
	[43311]="0:4:3:1:Mail::1:0:", -- Helmet of the Shrine
	[43312]="0:4:3:1:Leather::1:0:", -- Gorloc Muddy Footwraps
	[43313]="0:4:3:1:Cloth::1:0:", -- Leggings of the Ruins Dweller
	[43314]="0:12:1:10:::1:0:", -- Eternal Ember
	[43315]="0:12:1:1:::1:0:", -- Sigil of the Ebon Blade
	[43316]="0:16:1:20:Druid::1:0:", -- Glyph of Aquatic Form
	[43317]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Ring of Earthen Might
	[43318]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Ring of Scarlet Shadows
	[43319]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Windfire Band
	[43320]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Ring of Northern Tears
	[43321]="0:15:0:5:Junk::1:0:", -- Crystallized Tear
	[43322]="0:12:1:10:::1:0:", -- Enchanted Alliance Breastplate
	[43323]="0:12:1:12:::1:0:", -- Quiver of Dragonbone Arrows
	[43324]="0:12:1:12:::1:0:", -- Alliance Herb Pouch
	[43325]="0:15:0:5:Junk::1:0:", -- Frozen Eyelash
	[43326]="0:15:0:5:Junk::1:0:", -- Tusk Warmer
	[43327]="200000:4:1:1:OffHandFrill::1:0:31021", -- Stratholme Lily
	[43328]="0:15:0:5:Junk::1:0:", -- Extinguished Light of Hope
	[43329]="0:15:0:5:Junk::1:0:", -- Pigtail Holder
	[43330]="0:15:0:5:Junk::1:0:", -- Broken U.L.O.S.E Button
	[43331]="0:16:1:20:Druid::1:0:", -- Glyph of Unburdened Rebirth
	[43332]="0:16:1:20:Druid::1:0:", -- Glyph of Thorns
	[43333]="0:15:0:5:Junk::1:0:", -- Empty Hippogryph Harness
	[43334]="0:16:1:20:Druid::1:0:", -- Glyph of Challenging Roar
	[43335]="0:16:1:20:Druid::1:0:", -- Glyph of the Wild
	[43338]="0:16:1:20:Hunter::1:0:", -- Glyph of Revive Pet
	[43339]="0:16:1:20:Mage::1:0:", -- Glyph of Arcane Intellect
	[43340]="0:16:1:20:Paladin::1:0:", -- Glyph of Blessing of Might
	[43341]="0:15:0:5:Junk::1:0:", -- Unwarmed Shoes
	[43342]="0:16:1:20:Priest::1:0:", -- Glyph of Fading
	[43343]="0:16:1:20:Rogue::1:0:", -- Glyph of Pick Pocket
	[43344]="0:16:1:20:Shaman::1:0:", -- Glyph of Water Breathing
	[43345]="0:1:4:1:Bag::1:0:", -- Dragon Hide Bag
	[43346]="0:15:4:1:Junk::1:0:", -- Large Satchel of Spoils
	[43347]="0:15:4:1:Junk::1:0:", -- Satchel of Spoils
	[43348]="0:4:4:1:Tabard::1:0:", -- Tabard of the Explorer
	[43349]="0:4:4:1:Tabard::1:0:", -- Tabard of Brute Force
	[43350]="0:16:1:20:Hunter::1:0:", -- Glyph of Mend Pet
	[43351]="0:16:1:20:Hunter::1:0:", -- Glyph of Feign Death
	[43352]="5000:0:2:10:Consumable::1:0:28951", -- Pet Grooming Kit
	[43353]="0:4:3:1:Plate::1:0:", -- Void Sentry Legplates
	[43354]="0:16:1:20:Hunter::1:0:", -- Glyph of Possessed Strength
	[43355]="0:16:1:20:Hunter::1:0:", -- Glyph of the Pack
	[43356]="0:16:1:20:Hunter::1:0:", -- Glyph of Scare Beast
	[43357]="0:16:1:20:Mage::1:0:", -- Glyph of Fire Ward
	[43358]="0:4:3:1:Amulet::1:0:", -- Pendant of Shadow Beams
	[43359]="0:16:1:20:Mage::1:0:", -- Glyph of Frost Armor
	[43360]="0:16:1:20:Mage::1:0:", -- Glyph of Frost Ward
	[43361]="0:16:1:20:Mage::1:0:", -- Glyph of the Penguin
	[43363]="0:4:3:1:Cloak::1:0:", -- Screeching Cape
	[43364]="0:16:1:20:Mage::1:0:", -- Glyph of Slow Fall
	[43365]="0:16:1:20:Paladin::1:0:", -- Glyph of Blessing of Kings
	[43366]="0:16:1:20:Paladin::1:0:", -- Glyph of Blessing of Wisdom
	[43367]="0:16:1:20:Paladin::1:0:", -- Glyph of Lay on Hands
	[43368]="0:16:1:20:Paladin::1:0:", -- Glyph of Sense Undead
	[43369]="0:16:1:20:Paladin::1:0:", -- Glyph of the Wise
	[43370]="0:16:1:20:Priest::1:0:", -- Glyph of Levitate
	[43371]="0:16:1:20:Priest::1:0:", -- Glyph of Fortitude
	[43372]="0:16:1:20:Priest::1:0:", -- Glyph of Shadow Protection
	[43373]="0:16:1:20:Priest::1:0:", -- Glyph of Shackle Undead
	[43374]="0:16:1:20:Priest::1:0:", -- Glyph of Shadowfiend
	[43375]="0:4:3:1:Cloth::1:0:", -- Trousers of the Arakkoa
	[43376]="0:16:1:20:Rogue::1:0:", -- Glyph of Distract
	[43377]="0:16:1:20:Rogue::1:0:", -- Glyph of Pick Lock
	[43378]="0:16:1:20:Rogue::1:0:", -- Glyph of Safe Fall
	[43379]="0:16:1:20:Rogue::1:0:", -- Glyph of Blurred Speed
	[43380]="0:16:1:20:Rogue::1:0:", -- Glyph of Vanish
	[43381]="0:16:1:20:Shaman::1:0:", -- Glyph of Astral Recall
	[43382]="0:4:3:1:Ring::1:0:", -- Band of Eyes
	[43385]="0:16:1:20:Shaman::1:0:", -- Glyph of Renewed Life
	[43386]="0:16:1:20:Shaman::1:0:", -- Glyph of Water Shield
	[43387]="0:4:3:1:Plate::1:0:", -- Shoulderplates of the Beholder
	[43388]="0:16:1:20:Shaman::1:0:", -- Glyph of Water Walking
	[43389]="0:16:1:20:Warlock::1:0:", -- Glyph of Unending Breath
	[43390]="0:16:1:20:Warlock::1:0:", -- Glyph of Drain Soul
	[43391]="0:16:1:20:Warlock::1:0:", -- Glyph of Kilrogg
	[43392]="0:16:1:20:Warlock::1:0:", -- Glyph of Curse of Exhaustion
	[43393]="0:16:1:20:Warlock::1:0:", -- Glyph of Enslave Demon
	[43394]="0:16:1:20:Warlock::1:0:", -- Glyph of Souls
	[43395]="0:16:1:20:Warrior::1:0:", -- Glyph of Battle
	[43396]="0:16:1:20:Warrior::1:0:", -- Glyph of Bloodrage
	[43397]="0:16:1:20:Warrior::1:0:", -- Glyph of Charge
	[43398]="0:16:1:20:Warrior::1:0:", -- Glyph of Mocking Blow
	[43399]="0:16:1:20:Warrior::1:0:", -- Glyph of Thunder Clap
	[43400]="0:16:1:20:Warrior::1:0:", -- Glyph of Enduring Victory
	[43401]="0:4:3:1:Cloth::1:0:", -- Water-Drenched Robe
	[43402]="0:4:3:1:Plate::1:0:", -- The Obliterator Greaves
	[43403]="0:4:3:1:Leather::1:0:", -- Shroud of Darkness
	[43404]="0:4:3:1:Amulet::1:0:", -- Zuramat's Necklace
	[43405]="0:4:3:1:Plate::1:0:", -- Sabatons of Erekem
	[43406]="0:4:3:1:Cloak::1:0:", -- Cloak of the Gushing Wound
	[43407]="0:2:3:1:OneHandMace::1:0:", -- Stormstrike Mace
	[43408]="0:4:3:1:Ring::1:0:", -- Solitaire of Reflecting Beams
	[43409]="0:2:3:1:Polearm::1:0:", -- Saliva Corroded Pike
	[43410]="0:4:3:1:Mail::1:0:", -- Moragg's Chestguard
	[43411]="0:12:1:1:::1:0:", -- Anub'arak's Broken Husk
	[43412]="0:16:1:20:Warrior::1:0:", -- Glyph of Bloodthirst
	[43413]="0:16:1:20:Warrior::1:0:", -- Glyph of Rapid Charge
	[43414]="0:16:1:20:Warrior::1:0:", -- Glyph of Cleaving
	[43415]="0:16:1:20:Warrior::1:0:", -- Glyph of Devastate
	[43416]="0:16:1:20:Warrior::1:0:", -- Glyph of Execution
	[43417]="0:16:1:20:Warrior::1:0:", -- Glyph of Hamstring
	[43418]="0:16:1:20:Warrior::1:0:", -- Glyph of Heroic Strike
	[43419]="0:16:1:20:Warrior::1:0:", -- Glyph of Intervene
	[43420]="0:16:1:20:Warrior::1:0:", -- Glyph of Barbaric Insults
	[43421]="0:16:1:20:Warrior::1:0:", -- Glyph of Mortal Strike
	[43422]="0:16:1:20:Warrior::1:0:", -- Glyph of Overpower
	[43423]="0:16:1:20:Warrior::1:0:", -- Glyph of Rending
	[43424]="0:16:1:20:Warrior::1:0:", -- Glyph of Revenge
	[43425]="0:16:1:20:Warrior::1:0:", -- Glyph of Blocking
	[43426]="0:16:1:20:Warrior::1:0:", -- Glyph of Last Stand
	[43427]="0:16:1:20:Warrior::1:0:", -- Glyph of Sunder Armor
	[43428]="0:16:1:20:Warrior::1:0:", -- Glyph of Sweeping Strikes
	[43429]="0:16:1:20:Warrior::1:0:", -- Glyph of Taunt
	[43430]="0:16:1:20:Warrior::1:0:", -- Glyph of Resonating Power
	[43431]="0:16:1:20:Warrior::1:0:", -- Glyph of Victory Rush
	[43432]="0:16:1:20:Warrior::1:0:", -- Glyph of Whirlwind
	[43433]="0:4:3:1:Leather::1:0:", -- Eviscerator's Shoulderpads
	[43434]="0:4:3:1:Leather::1:0:", -- Eviscerator's Chestguard
	[43435]="0:4:3:1:Leather::1:0:", -- Eviscerator's Bindings
	[43436]="0:4:3:1:Leather::1:0:", -- Eviscerator's Gauntlets
	[43437]="0:4:3:1:Leather::1:0:", -- Eviscerator's Waistguard
	[43438]="0:4:3:1:Leather::1:0:", -- Eviscerator's Legguards
	[43439]="0:4:3:1:Leather::1:0:", -- Eviscerator's Treads
	[43440]="0:12:1:1:::1:0:", -- To King Varian Wrynn of the Alliance
	[43441]="0:12:1:1:::1:0:", -- To Thrall, Warchief of the Horde
	[43442]="0:4:3:1:Mail::1:0:", -- Swiftarrow Belt
	[43443]="0:4:3:1:Mail::1:0:", -- Swiftarrow Boots
	[43444]="0:4:3:1:Mail::1:0:", -- Swiftarrow Bracers
	[43445]="0:4:3:1:Mail::1:0:", -- Swiftarrow Hauberk
	[43446]="0:4:3:1:Mail::1:0:", -- Swiftarrow Gauntlets
	[43447]="0:4:3:1:Mail::1:0:", -- Swiftarrow Helm
	[43448]="0:4:3:1:Mail::1:0:", -- Swiftarrow Leggings
	[43449]="0:4:3:1:Mail::1:0:", -- Swiftarrow Shoulderguards
	[43450]="0:4:3:1:Mail::1:0:", -- Stormhide Belt
	[43451]="0:4:3:1:Mail::1:0:", -- Stormhide Stompers
	[43452]="0:4:3:1:Mail::1:0:", -- Stormhide Wristguards
	[43453]="0:4:3:1:Mail::1:0:", -- Stormhide Hauberk
	[43454]="0:4:3:1:Mail::1:0:", -- Stormhide Grips
	[43455]="0:4:3:1:Mail::1:0:", -- Stormhide Crown
	[43456]="0:4:3:1:Mail::1:0:", -- Stormhide Legguards
	[43457]="0:4:3:1:Mail::1:0:", -- Stormhide Shoulders
	[43458]="0:4:4:1:Mail::1:0:", -- Giantmaim Legguards
	[43459]="0:4:4:1:Mail::1:0:", -- Giantmaim Bracers
	[43461]="0:4:4:1:Mail::1:0:", -- Revenant's Breastplate
	[43462]="0:0:1:20:Consumable::1:0:29744,30472", -- Airy Pale Ale
	[43463]="900:0:1:20:Scroll::1:1:14847", -- Scroll of Agility VII
	[43464]="0:0:1:20:Scroll::1:0:", -- Scroll of Agility VIII
	[43465]="900:0:1:20:Scroll::1:1:14847", -- Scroll of Strength VII
	[43466]="0:0:1:20:Scroll::1:0:", -- Scroll of Strength VIII
	[43467]="990:0:1:20:Scroll::1:1:14847", -- Scroll of Protection VII
	[43469]="0:4:4:1:Mail::1:0:", -- Revenant's Treads
	[43470]="0:0:1:20:Consumable::1:0:29744,30472", -- Worg Tooth Oatmeal Stout
	[43471]="0:0:1:20:Consumable::1:0:", -- Rork Red Ribbon
	[43472]="0:0:1:20:Consumable::1:0:29744,30472", -- Snowfall Lager
	[43473]="0:0:1:20:Consumable::1:0:29744,30472", -- Drakefire Chile Ale
	[43478]="0:0:1:20:FoodDrink::1:0:", -- Gigantic Feast
	[43480]="0:0:1:20:FoodDrink::1:0:", -- Small Feast
	[43481]="0:4:4:1:Leather::1:0:", -- Trollwoven Spaulders
	[43482]="0:4:3:1:Ring::1:0:", -- Savage Titanium Ring
	[43484]="0:4:4:1:Leather::1:0:", -- Trollwoven Girdle
	[43485]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Savage Titanium Ring
	[43486]="0:4:1:1:Miscellaneous::1:0:", -- Mohawk Mask
	[43488]="0:0:1:20:FoodDrink::1:0:", -- Last Weeks Mammoth
	[43489]="0:0:1:5:Consumable::1:0:", -- Mohawk Grenade
	[43490]="0:0:1:20:FoodDrink::1:0:", -- Tasty Cupcake
	[43491]="0:0:1:20:FoodDrink::1:0:", -- Bad Clams
	[43492]="0:0:1:20:FoodDrink::1:0:", -- Haunted Herring
	[43493]="0:12:1:1:::1:0:", -- Watcher's Corpse Dust
	[43494]="0:12:1:1:::1:0:", -- Ahn'kahar Watcher's Corpse
	[43495]="0:4:4:1:Leather::1:0:", -- Earthgiving Legguards
	[43497]="0:9:3:1:Jewelcrafting::1:0:28721,33602", -- Design: Savage Titanium Band
	[43498]="0:4:3:1:Ring::1:0:", -- Savage Titanium Band
	[43499]="0:4:1:1:Miscellaneous::1:0:29744,30472", -- Iron Boot Flask
	[43500]="0:4:4:1:Plate::1:0:", -- Bolstered Legplates
	[43501]="0:7:1:20:Meat:185:1:0:", -- Northern Egg
	[43502]="0:4:4:1:Leather::1:0:", -- Earthgiving Boots
	[43504]="0:15:1:1:Junk::1:0:", -- Winter Veil Gift
	[43505]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Gigantic Feast
	[43506]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Small Feast
	[43507]="0:9:2:1:Cooking::1:0:", -- Recipe: Tasty Cupcake
	[43508]="0:9:2:1:Cooking::1:0:", -- Recipe: Last Week's Mammoth
	[43509]="0:9:2:1:Cooking::1:0:", -- Recipe: Bad Clams
	[43510]="0:9:2:1:Cooking::1:0:", -- Recipe: Haunted Herring
	[43511]="0:12:1:10:::1:0:", -- Grotesque Fungus
	[43512]="0:12:1:1:::1:0:", -- Ooze-covered Fungus
	[43513]="0:12:1:10:::1:0:", -- Vrykul Weapon
	[43515]="0:4:3:1:OffHandFrill::1:0:", -- Mystic Tome
	[43516]="0:15:4:1:FlyingMount::1:0:", -- Brutal Nether Drake
	[43518]="0:0:1:20:FoodDrink::1:0:", -- Conjured Mana Pie
	[43519]="0:15:0:20:Junk::1:0:", -- Scruffy Toe Lint
	[43520]="0:15:0:20:Junk::1:0:", -- Distinctive Feathers
	[43521]="0:15:0:20:Junk::1:0:", -- Stylish Toe Ring
	[43522]="0:15:0:20:Junk::1:0:", -- Slimming Ankle Bracelet
	[43523]="0:0:1:20:FoodDrink::1:0:", -- Conjured Mana Strudel
	[43524]="0:12:1:1:::1:0:", -- Olakin's Torch
	[43526]="0:12:1:1:::1:0:", -- Olakin's Torso
	[43527]="0:12:1:1:::1:0:", -- Olakin's Legs
	[43528]="0:12:1:1:::1:0:", -- Olakin's Left Arm
	[43529]="0:12:1:1:::1:0:", -- Olakin's Right Arm
	[43530]="0:0:1:20:Potion::1:0:16786", -- Argent Mana Potion
	[43531]="0:0:1:20:Potion::1:0:16786", -- Argent Healing Potion
	[43533]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Anti-Magic Shell
	[43534]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Heart Strike
	[43535]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Blood Tap
	[43536]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Bone Shield
	[43537]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Chains of Ice
	[43538]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Dark Command
	[43539]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Death's Embrace
	[43541]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Death Grip
	[43542]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Death and Decay
	[43543]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Frost Strike
	[43544]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Horn of Winter
	[43545]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Icebound Fortitude
	[43546]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Icy Touch
	[43547]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Obliterate
	[43548]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Plague Strike
	[43549]="0:16:1:20:DeathKnight::1:0:", -- Glyph of the Ghoul
	[43550]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Rune Strike
	[43551]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Scourge Strike
	[43552]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Strangulate
	[43553]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Unbreakable Armor
	[43554]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Vampiric Blood
	[43555]="0:4:4:1:Trinket::1:0:", -- Deputy Pa'trolla Badge
	[43556]="0:15:2:1:Junk::1:0:", -- Patroller's Pack
	[43564]="0:12:1:1:::1:0:", -- Crusader Olakin's Remains
	[43565]="0:4:4:1:Cloak::1:0:", -- Durable Nerubhide Cape
	[43566]="0:4:4:1:Cloak::1:0:", -- Ice Striker's Cloak
	[43567]="0:12:1:1:::1:0:", -- Spool of Thread
	[43568]="0:12:1:1:::1:0:", -- The Doctor's Cleaver
	[43569]="0:0:3:1:Potion::1:0:", -- Endless Healing Potion
	[43570]="0:0:3:1:Potion::1:0:", -- Endless Mana Potion
	[43571]="0:7:1:20:Meat::1:0:", -- Sewer Carp
	[43572]="0:7:1:20:Meat::1:0:", -- Magic Eater
	[43573]="0:4:4:1:Trinket::1:0:", -- Tears of Bitter Anguish
	[43574]="0:15:0:20:Junk::1:0:", -- Dissolved Soul Essence
	[43575]="0:15:1:1:Junk::1:0:", -- Reinforced Junkbox
	[43576]="0:15:0:20:Junk::1:0:", -- Chitin Polish
	[43577]="0:15:0:20:Junk::1:0:", -- Carapace Cleanser
	[43582]="0:4:4:1:Ring::1:0:", -- Titanium Frostguard Ring
	[43583]="0:4:4:1:Cloth::1:0:", -- Glacial Robe
	[43584]="0:4:4:1:Cloth::1:0:", -- Glacial Waistband
	[43585]="0:4:4:1:Cloth::1:0:", -- Glacial Slippers
	[43586]="0:4:4:1:Plate::1:0:", -- Icebane Chestguard
	[43587]="0:4:4:1:Plate::1:0:", -- Icebane Girdle
	[43588]="0:4:4:1:Plate::1:0:", -- Icebane Treads
	[43589]="0:10:2::Currency::1:0:", -- Wintergrasp Mark of Honor
	[43590]="0:4:4:1:Leather::1:0:", -- Polar Vest
	[43591]="0:4:4:1:Leather::1:0:", -- Polar Cord
	[43592]="0:4:4:1:Leather::1:0:", -- Polar Boots
	[43593]="0:4:4:1:Mail::1:0:", -- Icy Scale Chestguard
	[43594]="0:4:4:1:Mail::1:0:", -- Icy Scale Belt
	[43595]="0:4:4:1:Mail::1:0:", -- Icy Scale Boots
	[43597]="0:9:4:1:Jewelcrafting::1:0:28721,33602", -- Design: Titanium Frostguard Ring
	[43599]="0:15:3:1:Mount::1:0:", -- Big Blizzard Bear
	[43600]="200063:2:1:1:Polearm::1:0:30006", -- Brunnhildar Harpoon
	[43601]="200063:2:1:1:TwoHandAxe::1:0:30006", -- Brunnhildar Great Axe
	[43608]="0:12:1:1:::1:0:", -- Copperclaw's Volatile Oil
	[43609]="0:12:1:5:::1:0:", -- Pile of Bones
	[43610]="0:12:1:5:::1:0:", -- Abandoned Helm
	[43611]="0:2:4:1:OneHandSword::1:0:", -- Krol Cleaver
	[43612]="0:2:4:1:Thrown::1:0:", -- Spineslicer
	[43613]="0:2:4:1:Dagger::1:0:", -- The Dusk Blade
	[43615]="0:12:1:1:::1:0:", -- Saurfang's Battle Armor
	[43616]="0:12:1:5:::1:0:", -- Abandoned Armor
	[43622]="0:15:2:1:Junk::1:0:", -- Froststeel Lockbox
	[43624]="0:15:3:1:Junk::1:0:", -- Titanium Lockbox
	[43626]="5000:0:2:20:Consumable::5:0:28951", -- Happy Pet Snack
	[43627]="0:15:1:20:Junk::1:0:", -- Thrall's Gold Coin
	[43628]="0:15:1:20:Junk::1:0:", -- Lady Jaina Proudmoore's Gold Coin
	[43629]="0:15:1:20:Junk::1:0:", -- Uther Lightbringer's Gold Coin
	[43630]="0:15:1:20:Junk::1:0:", -- Tirion Fordring's Gold Coin
	[43631]="0:15:1:20:Junk::1:0:", -- Teron's Gold Coin
	[43632]="0:15:1:20:Junk::1:0:", -- Sylvanas Windrunner's Gold Coin
	[43633]="0:15:1:20:Junk::1:0:", -- Prince Kael'thas Sunstrider's Gold Coin
	[43634]="0:15:1:20:Junk::1:0:", -- Lady Katrana Prestor's Gold Coin
	[43635]="0:15:1:20:Junk::1:0:", -- Kel'Thuzad's Gold Coin
	[43636]="0:15:1:20:Junk::1:0:", -- Chromie's Gold Coin
	[43637]="0:15:1:20:Junk::1:0:", -- Brann Bronzebeard's Gold Coin
	[43638]="0:15:1:20:Junk::1:0:", -- Arugal's Gold Coin
	[43639]="0:15:1:20:Junk::1:0:", -- Arthas' Gold Coin
	[43640]="0:15:1:20:Junk::1:0:", -- Archimonde's Gold Coin
	[43641]="0:15:1:20:Junk::1:0:", -- Anduin Wrynn's Gold Coin
	[43643]="0:15:0:20:Junk::1:0:", -- Prince Magni Bronzebeard's Silver Coin
	[43644]="0:15:0:20:Junk::1:0:", -- A Peasant's Silver Coin
	[43645]="0:15:0:20:Junk::1:0:", -- Bent Fishing Hook
	[43646]="0:7:1:20:Meat::1:0:", -- Fountain Goldfish
	[43647]="0:7:1:20:Meat::1:0:", -- Shimmering Minnow
	[43650]="0:13:1:1:::1:0:", -- Rusty Prison Key
	[43652]="0:7:1:20:Meat::1:0:", -- Slippery Eel
	[43653]="0:15:0:20:Junk::1:0:", -- Partially Eaten Fish
	[43654]="0:4:3:1:OffHandFrill::1:0:", -- Tome of the Dawn
	[43655]="0:4:3:1:OffHandFrill::1:0:", -- Book of Survival
	[43656]="0:4:3:1:OffHandFrill::1:0:", -- Tome of Kings
	[43657]="0:4:3:1:OffHandFrill::1:0:", -- Royal Guide of Escape Routes
	[43658]="0:15:0:1:Junk::1:0:", -- Partially Rusted File
	[43659]="0:2:0:1:Dagger::1:0:", -- Bloodied Prison Shank
	[43660]="0:4:3:1:OffHandFrill::1:0:", -- Fire Eater's Guide
	[43661]="0:4:3:1:OffHandFrill::1:0:", -- Book of Stars
	[43662]="0:12:1:1:::1:0:", -- Axe of the Plunderer
	[43663]="0:4:3:1:OffHandFrill::1:0:", -- Stormbound Tome
	[43664]="0:4:3:1:OffHandFrill::1:0:", -- Manual of Clouds
	[43665]="0:12:1:1:::1:0:", -- Keristrasza's Broken Heart
	[43666]="0:4:3:1:OffHandFrill::1:0:", -- Hellfire Tome
	[43667]="0:4:3:1:OffHandFrill::1:0:", -- Book of Clever Tricks
	[43668]="0:12:1:1:::1:0:", -- Ley Line Tuner
	[43669]="0:12:1:1:::1:0:", -- Locket of the Deceased Queen
	[43670]="0:12:1:1:::1:0:", -- Prophet's Enchanted Tiki
	[43671]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Corpse Explosion
	[43672]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Pestilence
	[43673]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Raise Dead
	[43674]="0:16:1:20:Druid::1:0:", -- Glyph of Dash
	[43675]="0:15:0:20:Junk::1:0:", -- Fandral Staghelm's Silver Coin
	[43676]="0:15:0:20:Junk::1:0:", -- Arcanist Doan's Silver Coin
	[43677]="0:15:0:20:Junk::1:0:", -- High Tinker Mekkatorque's Silver Coin
	[43678]="0:15:0:20:Junk::1:0:", -- Antonidas' Silver Coin
	[43679]="0:15:0:20:Junk::1:0:", -- Muradin Bronzebeard's Silver Coin
	[43680]="0:15:0:20:Junk::1:0:", -- King Varian Wrynn's Silver Coin
	[43681]="0:15:0:20:Junk::1:0:", -- King Terenas Menethil's Silver Coin
	[43682]="0:15:0:20:Junk::1:0:", -- King Anasterian Sunstrider's Silver Coin
	[43683]="0:15:0:20:Junk::1:0:", -- Khadgar's Silver Coin
	[43684]="0:15:0:20:Junk::1:0:", -- Medivh's Silver Coin
	[43685]="0:15:0:20:Junk::1:0:", -- Maiev Shadowsong's Silver Coin
	[43686]="0:15:0:20:Junk::1:0:", -- Alleria's Silver Coin
	[43687]="0:15:0:20:Junk::1:0:", -- Aegwynn's Silver Coin
	[43688]="0:12:1:1:::1:0:", -- Weeping Quarry Document
	[43689]="0:12:1:1:::1:0:", -- Weeping Quarry Ledger
	[43690]="0:12:1:1:::1:0:", -- Weeping Quarry Schedule
	[43691]="0:12:1:1:::1:0:", -- Weeping Quarry Map
	[43693]="0:12:1:1:::1:0:", -- Mojo Remnant of Akali
	[43694]="0:15:0:20:Junk::1:0:", -- Drowned Rat
	[43695]="0:0:1:20:FoodDrink::1:0:", -- Half Full Bottle of Prison Moonshine
	[43696]="0:0:1:20:FoodDrink::1:0:", -- Half Empty Bottle of Prison Moonshine
	[43697]="0:12:1:1:::1:0:", -- Artifact from the Nathrezim Homeworld
	[43698]="0:15:3:1:Companion::1:0:", -- Giant Sewer Rat
	[43699]="0:12:1:1:::1:0:", -- The Curse of Flesh Disc
	[43701]="0:15:0:20:Junk::1:0:", -- A Footman's Copper Coin
	[43702]="0:15:0:20:Junk::1:0:", -- Alonsus Faol's Copper Coin
	[43703]="0:15:0:20:Junk::1:0:", -- Ansirem's Copper Coin
	[43704]="0:15:0:20:Junk::1:0:", -- Attumen's Copper Coin
	[43705]="0:15:0:20:Junk::1:0:", -- Danath's Copper Coin
	[43706]="0:15:0:20:Junk::1:0:", -- Dornaa's Shiny Copper Coin
	[43707]="0:15:0:20:Junk::1:0:", -- Eitrigg's Copper Coin
	[43708]="0:15:0:20:Junk::1:0:", -- Elling Trias' Copper Coin
	[43709]="0:15:0:20:Junk::1:0:", -- Falstad Wildhammer's Copper Coin
	[43710]="0:15:0:20:Junk::1:0:", -- Genn's Copper Coin
	[43711]="0:15:0:20:Junk::1:0:", -- Inigo's Copper Coin
	[43712]="0:15:0:20:Junk::1:0:", -- Krasus' Copper Coin
	[43713]="0:15:0:20:Junk::1:0:", -- Kryll's Copper Coin
	[43714]="0:15:0:20:Junk::1:0:", -- Landro Longshot's Copper Coin
	[43715]="0:15:0:20:Junk::1:0:", -- Molok's Copper Coin
	[43716]="0:15:0:20:Junk::1:0:", -- Murky's Copper Coin
	[43717]="0:15:0:20:Junk::1:0:", -- Princess Calia Menethil's Copper Coin
	[43718]="0:15:0:20:Junk::1:0:", -- Private Marcus Jonathan's Copper Coin
	[43719]="0:15:0:20:Junk::1:0:", -- Salandria's Shiny Copper Coin
	[43720]="0:15:0:20:Junk::1:0:", -- Squire Rowe's Copper Coin
	[43721]="0:15:0:20:Junk::1:0:", -- Stalvan's Copper Coin
	[43722]="0:15:0:20:Junk::1:0:", -- Vareesa's Copper Coin
	[43723]="0:15:0:20:Junk::1:0:", -- Vargoth's Copper Coin
	[43724]="0:12:1:1:::1:0:", -- Celestial Ruby Ring
	[43725]="0:16:1:20:Shaman::1:0:", -- Glyph of Ghost Wolf
	[43726]="0:12:1:1:::1:0:", -- The Idle Crown of Anub'arak
	[43767]="0:4:4:1:Mail::1:0:", -- Earthshatter Hauberk
	[43821]="0:12:1:1:::1:0:", -- Faceless One's Withered Brain
	[43823]="0:12:1:1:::1:0:", -- Head of Cyanigosa
	[43824]="0:15:3:1:Other::1:0:", -- The Schools of Arcane Magic - Mastery
	[43825]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Rune Tap
	[43826]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Blood Strike
	[43827]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Death Strike
	[43828]="0:2:2:1:Wand::1:0:", -- Touch of Light
	[43829]="0:4:2:1:Trinket::1:0:", -- Crusader's Locket
	[43830]="0:4:2:1:Mail::1:0:", -- Cobalt's Shoulderguards
	[43831]="0:4:2:1:Plate::1:0:", -- Enchanted Plate Waistguard
	[43832]="0:2:2:1:TwoHandSword::1:0:", -- The Argent Resolve
	[43833]="0:2:2:1:OneHandSword::1:0:", -- Blade of Echoes
	[43834]="0:2:2:1:Stave::1:0:", -- Staff of Redeemed Souls
	[43835]="0:2:2:1:OneHandMace::1:0:", -- Hand of Gustav
	[43836]="0:4:2:1:Trinket::1:0:", -- Thorny Rose Brooch
	[43837]="0:4:2:1:Trinket::1:0:", -- Softly Glowing Orb
	[43838]="0:4:2:1:Trinket::1:0:", -- Chuchu's Tiny Box of Horrors
	[43839]="0:4:2:1:Cloth::1:0:", -- Leiah's Footpads
	[43840]="0:4:2:1:Leather::1:0:", -- Sixen's Skullcap
	[43841]="0:4:2:1:Mail::1:0:", -- Argent Girdle
	[43842]="0:4:2:1:Plate::1:0:", -- Jayde's Reinforced Handguards
	[43843]="0:4:2:1:Shield::1:0:", -- Iron Coffin Lid
	[43844]="0:4:2:1:Plate::1:0:", -- Ebon Pauldrons
	[43845]="0:4:2:1:Plate::1:0:", -- Legplates of Dominion
	[43846]="0:4:2:1:Plate::1:0:", -- Helmet of the Dedicated
	[43847]="0:4:2:1:Plate::1:0:", -- Demolisher's Grips
	[43849]="0:4:2:1:Amulet::1:0:", -- Chain of the Sovereign
	[43850]="0:0:1:5:Other::1:0:", -- Certificate of Ownership
	[43851]="0:15:0:20:Junk::1:0:", -- Fur Clothing Scraps
	[43852]="0:15:0:20:Junk::1:0:", -- Thick Fur Clothing Scraps
	[43853]="0:13:2:20:::1:0:", -- Titanium Skeleton Key
	[43854]="0:13:2:20:::1:0:", -- Cobalt Skeleton Key
	[43855]="0:4:2:1:Cloth::1:0:", -- Adepts Wristwraps
	[43856]="0:4:2:1:Cloth::1:0:", -- Sigrid's Mittens
	[43857]="0:4:2:1:Cloth::1:0:", -- Duke Lankral's Velvet Slippers
	[43858]="0:2:2:1:Stave::1:0:", -- Vrykul Crusher
	[43859]="0:4:2:1:Cloth::1:0:", -- Shadow Vault Cowl
	[43860]="0:4:3:1:Plate::1:0:", -- Brilliant Saronite Belt
	[43861]="0:4:2:1:Cloak::1:0:", -- Bone Witch's Drape
	[43862]="0:4:2:1:Cloth::1:0:", -- Mantle of the Underhalls
	[43863]="0:4:2:1:Cloth::1:0:", -- Pantaloons of the Water Magi
	[43864]="0:4:3:1:Plate::1:0:", -- Brilliant Saronite Bracers
	[43865]="0:4:3:1:Plate::1:0:", -- Brilliant Saronite Pauldrons
	[43866]="0:4:2:1:Cloth::1:0:", -- Lithe Stalker's Cord
	[43867]="0:16:1:20:Paladin::1:0:", -- Glyph of Holy Wrath
	[43868]="0:16:1:20:Paladin::1:0:", -- Glyph of Seal of Righteousness
	[43869]="0:16:1:20:Paladin::1:0:", -- Glyph of Seal of Vengeance
	[43870]="0:4:3:1:Plate::1:0:", -- Brilliant Saronite Helm
	[43871]="0:2:3:1:OneHandSword::1:0:", -- Saronite Spellblade
	[43872]="0:4:2:1:Cloth::1:0:", -- Weeping Mantle
	[43873]="0:2:2:1:Wand::1:0:", -- Frail Bone Wand
	[43874]="0:4:2:1:Ring::1:0:", -- Lady Nightswood's Engagement Ring
	[43875]="0:2:2:1:OneHandAxe::1:0:", -- Axe of the Cunning
	[43876]="0:9:3:1:Tailoring::1:0:", -- A Guide to Northern Cloth Scavenging
	[43877]="0:4:2:1:Ring::1:0:", -- Blood-forged Circle
	[43879]="0:4:2:1:Cloth::1:0:", -- Gryphon Rider's Bracers
	[43880]="0:2:2:1:Wand::1:0:", -- Fair Touch of the Crusader
	[43881]="0:4:2:1:Cloth::1:0:", -- Demolisher Driver's Dustcoat
	[43882]="0:4:2:1:Cloth::1:0:", -- Cultist's Cowl
	[43883]="0:2:2:1:TwoHandSword::1:0:", -- Arete's Command
	[43884]="0:4:2:1:Amulet::1:0:", -- Amulet of the Malefic Necromancer
	[43885]="0:2:2:1:TwoHandMace::1:0:", -- Scourgehammer
	[43888]="0:2:2:1:OneHandMace::1:0:", -- Blunt Brainwasher
	[43889]="0:4:2:1:Cloak::1:0:", -- Hulking Abomination Hide Cloak
	[43890]="0:2:2:1:FistWeapon::1:0:", -- Interrogator's Flaming Knuckles
	[43891]="0:4:2:1:Leather::1:0:", -- Jhaeqon's Tunic
	[43892]="0:4:2:1:Leather::1:0:", -- Refurbished Demolisher Gear Belt
	[43893]="0:2:2:1:Wand::1:0:", -- Olakin's Enchanted Torch
	[43894]="0:4:2:1:Leather::1:0:", -- Gryphon Hide Moccasins
	[43896]="0:4:2:1:Leather::1:0:", -- Grotesque Butcher's Pants
	[43897]="0:2:2:1:OneHandAxe::1:0:", -- Frost Climber's Hatchet
	[43898]="0:2:2:1:OneHandAxe::1:0:", -- Icy Quick Edge
	[43899]="0:2:2:1:TwoHandAxe::1:0:", -- Sapph's Cleaver
	[43900]="0:2:2:1:Thrown::1:0:", -- Fleshwerk Throwing Glaive
	[43903]="0:4:2:1:Ring::1:0:", -- Ring of the Fallen Shadow Adept
	[43904]="0:4:2:1:Leather::1:0:", -- Discarded Slaughterhouse Gloves
	[43905]="0:4:2:1:Leather::1:0:", -- Fur-lined Helm
	[43906]="0:4:2:1:Leather::1:0:", -- Cunning Leather Tunic
	[43907]="0:4:2:1:Leather::1:0:", -- Spear-Sisters Mantle
	[43908]="0:4:2:1:Leather::1:0:", -- Boots of the Fallen Thane
	[43909]="0:4:2:1:Leather::1:0:", -- Belt of Njorndar
	[43910]="0:4:2:1:Leather::1:0:", -- Gloves of the Flayed
	[43911]="0:2:2:1:Dagger::1:0:", -- Vile's Poker
	[43912]="0:4:2:1:Leather::1:0:", -- Vest of Jotunheim
	[43913]="0:4:2:1:Leather::1:0:", -- Efrem's Bracers
	[43914]="0:4:2:1:Leather::1:0:", -- Girdle of Reprieve
	[43915]="0:2:2:1:Dagger::1:0:", -- Pilot's Knife
	[43916]="0:2:2:1:OneHandMace::1:0:", -- Mace of the Final Command
	[43917]="0:2:2:1:Dagger::1:0:", -- Ritualist's Bloodletter
	[43918]="0:2:2:1:Crossbow::1:0:", -- Shooter's Glory
	[43919]="0:2:2:1:Dagger::1:0:", -- Curved Assassin's Dagger
	[43920]="0:2:2:1:Stave::1:0:", -- Growler's Intimidation
	[43921]="0:2:2:1:Stave::1:0:", -- Staff of Interrogation
	[43923]="0:2:2:1:OneHandSword::1:0:", -- Bloodblade
	[43924]="0:4:2:1:Cloak::1:0:", -- Illskar's Greatcloak
	[43925]="0:4:2:1:Cloak::1:0:", -- Shadow Vault Shawl
	[43926]="0:4:2:1:Ring::1:0:", -- Signet of Baron Sliver
	[43927]="0:2:2:1:Stave::1:0:", -- Wrought-Iron Staff
	[43928]="0:2:2:1:Bow::1:0:", -- Bow of Bone and Sinew
	[43929]="0:2:2:1:TwoHandMace::1:0:", -- Vile's Uglystick
	[43930]="0:4:2:1:Plate::1:0:", -- Accelerator Stompers
	[43931]="0:4:2:1:Mail::1:0:", -- Savryn's Muddy Boots
	[43932]="0:4:2:1:Mail::1:0:", -- Drivetrain Chain Leggings
	[43933]="0:4:2:1:Mail::1:0:", -- Gauntlets of Urgency
	[43934]="0:4:2:1:Mail::1:0:", -- Enchanted Bracelets of the Scout
	[43935]="0:4:2:1:Mail::1:0:", -- Links of the Battlemender
	[43937]="0:4:2:1:Mail::1:0:", -- Blood-stalker's Cover
	[43939]="0:4:2:1:Plate::1:0:", -- Breastplate of Splattered Blood
	[43940]="0:4:2:1:Plate::1:0:", -- Plated Legs of the Unholy
	[43941]="0:4:2:1:Plate::1:0:", -- Grimy Saronite Pauldrons
	[43942]="0:4:2:1:Plate::1:0:", -- Jotunheim Shackles
	[43943]="0:4:2:1:Plate::1:0:", -- Gauntlets of the Holy Gladiator
	[43944]="0:4:2:1:Plate::1:0:", -- Rings of Nergeld
	[43945]="0:4:2:1:Plate::1:0:", -- Blackened Breastplate of the Vault
	[43946]="0:4:2:1:Plate::1:0:", -- Chestplate of the Glacial Crusader
	[43947]="0:4:2:1:Plate::1:0:", -- Stability Girdle
	[43948]="0:4:2:1:Mail::1:0:", -- Blood-encrusted Boots
	[43950]="0:0:2:250:Other::1:0:35494,35495,35573,35574", -- Kirin Tor Commendation Badge
	[43951]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Bronze Drake
	[43952]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Azure Drake
	[43953]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Blue Drake
	[43954]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Twilight Drake
	[43955]="20000000:15:4:1:FlyingMount::1:0:32533", -- Reins of the Red Drake
	[43956]="0:15:4:1:Mount::1:0:32294", -- Reins of the Black War Mammoth
	[43958]="10000000:15:4:1:Mount::1:0:32540", -- Reins of the Ice Mammoth
	[43959]="0:15:4:1:Mount::1:0:", -- Reins of the Grand Black War Mammoth
	[43961]="100000000:15:4:1:Mount::1:0:32540", -- Reins of the Grand Ice Mammoth
	[43962]="0:15:4:1:Mount::1:0:", -- Reins of the White Polar Bear
	[43966]="0:12:1:1:::1:0:", -- Chilled Abomination Guts
	[43968]="0:12:1:1:::1:0:", -- Abomination Reanimation Kit
	[43969]="0:4:3:1:Cloth::1:0:", -- Frostsavage Belt
	[43970]="0:4:3:1:Cloth::1:0:", -- Frostsavage Boots
	[43971]="0:4:3:1:Cloth::1:0:", -- Frostsavage Cowl
	[43972]="0:4:3:1:Cloth::1:0:", -- Frostsavage Robe
	[43973]="0:4:3:1:Cloth::1:0:", -- Frostsavage Shoulders
	[43974]="0:4:3:1:Cloth::1:0:", -- Frostsavage Bracers
	[43975]="0:4:3:1:Cloth::1:0:", -- Frostsavage Leggings
	[43976]="0:4:2:1:Mail::1:0:", -- Chain Gloves of the Quarry
	[43977]="0:4:2:1:Mail::1:0:", -- Links of the Sleep-Watcher
	[43978]="0:4:2:1:Mail::1:0:", -- Circlet of Suffering
	[43979]="0:4:2:1:Mail::1:0:", -- Glaciel Ranger's Leggings
	[43980]="0:4:2:1:Mail::1:0:", -- Thane's Restraints
	[43981]="0:4:2:1:Mail::1:0:", -- Gauntlets of Onu'zun
	[43982]="0:4:2:1:Mail::1:0:", -- Architect's Spaulders
	[43983]="0:12:1:1:::1:0:", -- Prospector Soren's Maps
	[43984]="0:12:1:1:::1:0:", -- Prospector Khrona's Notes
	[43986]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Black Drake
	[43987]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Black Magic
	[43988]="0:4:4:1:Cloak::1:0:", -- Gale-Proof Cloak
	[43989]="0:4:4:1:Plate::1:0:", -- Remembrance Girdle
	[43990]="0:4:4:1:Leather::1:0:", -- Blade-Scarred Tunic
	[43991]="0:4:4:1:Leather::1:0:", -- Legguards of Composure
	[43992]="0:4:4:1:Amulet::1:0:", -- Volitant Amulet
	[43993]="0:4:4:1:Ring::1:0:", -- Greatring of Collision
	[43994]="0:4:4:1:Plate::1:0:", -- Belabored Legplates
	[43995]="0:4:4:1:Cloth::1:0:", -- Enamored Cowl
	[43996]="0:4:4:1:Mail::1:0:", -- Sabatons of Firmament
	[43997]="0:12:1:10:::1:0:", -- Pustulant Spine
	[43998]="0:4:4:1:Mail::1:0:", -- Chestguard of Flagrant Prowess
	[44000]="0:4:4:1:Plate::1:0:", -- Dragonstorm Breastplate
	[44001]="0:12:1:20:::1:0:", -- Faceless One's Blood
	[44002]="0:4:4:1:Cloth::1:0:", -- The Sanctum's Flowing Vestments
	[44003]="0:4:4:1:Mail::1:0:", -- Upstanding Spaulders
	[44004]="0:4:4:1:Mail::1:0:", -- Bountiful Gauntlets
	[44005]="0:4:4:1:Cloak::1:0:", -- Pennant Cloak
	[44006]="0:4:4:1:Plate::1:0:", -- Obsidian Greathelm
	[44007]="0:4:4:1:Leather::1:0:", -- Headpiece of Reconciliation
	[44008]="0:4:4:1:Cloth::1:0:", -- Unsullied Cuffs
	[44009]="0:12:1:1:::1:0:", -- Flesh Giant Spine
	[44010]="0:12:1:1:::1:0:", -- Pustulant Spinal Fluid
	[44011]="0:4:4:1:Leather::1:0:", -- Leggings of the Honored
	[44012]="0:0:1:20:Elixir::1:0:", -- Underbelly Elixir
	[44013]="0:4:3:1:Trinket::1:0:", -- Cannoneer's Fuselighter
	[44014]="0:4:3:1:Trinket::1:0:", -- Fezzik's Pocketwatch
	[44015]="0:4:3:1:Trinket::1:0:", -- Cannoneer's Morale
	[44016]="0:4:3:1:Cloth::1:0:", -- Wristguard of the Bone Witch
	[44017]="0:4:3:1:Amulet::1:0:", -- Emeline's Locket
	[44018]="0:4:3:1:Cloth::1:0:", -- Bridenbrad's Sash
	[44019]="0:4:3:1:Cloth::1:0:", -- The Argent Skullcap
	[44020]="0:4:3:1:Cloak::1:0:", -- Bloodbane's Fall
	[44021]="0:4:3:1:Cloth::1:0:", -- The Darkspeaker's Footpads
	[44022]="0:4:3:1:OffHandFrill::1:0:", -- The Witching Grimoire
	[44023]="0:4:3:1:OffHandFrill::1:0:", -- Bonecaster's Endgame
	[44024]="0:4:3:1:Leather::1:0:", -- The Darkspeaker's Treads
	[44025]="0:4:3:1:Cloak::1:0:", -- Bloodbane Cloak
	[44026]="0:4:3:1:Cloak::1:0:", -- Bloodbane's Resolve
	[44027]="0:4:3:1:Cloak::1:0:", -- Bloodbane Shroud
	[44028]="0:2:3:1:Dagger::1:0:", -- Vengance Shiv
	[44029]="0:2:3:1:OneHandSword::1:0:", -- Quickblade of Cold Return
	[44030]="0:4:3:1:Mail::1:0:", -- The Darkspeaker's Sabatons
	[44031]="0:4:3:1:Plate::1:0:", -- The Darkspeaker's Iron Walkers
	[44032]="0:4:3:1:Shield::1:0:", -- Bulwark of Redemption
	[44033]="0:4:3:1:Amulet::1:0:", -- The Severed Noose of Westwind
	[44034]="0:4:3:1:Amulet::1:0:", -- Amulet of the Crusade
	[44035]="0:4:3:1:Amulet::1:0:", -- Reinforced Titanium Neckguard
	[44036]="0:4:3:1:Leather::1:0:", -- Njorndar Furywraps
	[44037]="0:4:3:1:Mail::1:0:", -- Iskalder's Fate
	[44038]="0:4:3:1:Plate::1:0:", -- Battlescar Spirebands
	[44039]="0:4:3:1:Ring::1:0:", -- Signet of Bridenbrad
	[44040]="0:4:3:1:Plate::1:0:", -- The Crusader's Resolution
	[44041]="0:4:3:1:Leather::1:0:", -- Belt of the Never-Forgotten
	[44042]="0:4:3:1:Mail::1:0:", -- Chained Belt of Remembrance
	[44043]="0:4:3:1:Plate::1:0:", -- Girdle of Eternal Memory
	[44044]="0:4:3:1:Leather::1:0:", -- Tirion's Headwrap
	[44045]="0:4:3:1:Mail::1:0:", -- Crusader's Coif
	[44046]="0:4:3:1:Plate::1:0:", -- The Argent Crown
	[44047]="0:12:1:1:::1:0:", -- Norgannon's Core
	[44048]="0:12:1:1:::1:0:", -- Smuggled Solution
	[44049]="16000:0:1:20:FoodDrink::5:0:31916,32763", -- Freshly-Speared Emperor Salmon
	[44050]="1280448:2:4:1:FishingPole::1:0:31916,32763", -- Mastercraft Kalu'ak Fishing Pole
	[44051]="723612:2:3:1:Dagger::1:0:31916,32763", -- Traditional Flensing Knife
	[44052]="657082:2:3:1:OneHandMace::1:0:31916,32763", -- Totemic Purification Rod
	[44053]="824545:2:3:1:Polearm::1:0:31916,32763", -- Whale-Stick Harpoon
	[44054]="296045:4:3:1:Leather::1:0:31916,32763", -- Whale-Skin Breastplate
	[44055]="297187:4:3:1:Leather::1:0:31916,32763", -- Whale-Skin Vest
	[44057]="430664:4:3:1:Plate::1:0:31916,32763", -- Ivory-Reinforced Chestguard
	[44058]="432262:4:3:1:Plate::1:0:31916,32763", -- Whalebone Carapace
	[44059]="371881:4:3:1:Mail::1:0:31916,32763", -- Cuttlefish Scale Breastplate
	[44060]="373251:4:3:1:Mail::1:0:31916,32763", -- Cuttlefish Tooth Ringmail
	[44061]="249722:4:3:1:Cloth::1:0:31916,32763", -- Pigment-Stained Robes
	[44062]="250636:4:3:1:Cloth::1:0:31916,32763", -- Turtle-Minders Robe
	[44063]="0:4:3:1:Trinket::1:0:", -- Figurine - Monarch Crab
	[44064]="3200:0:1:10:Consumable::1:0:31911", -- Nepeta Leaf
	[44065]="3200:0:1:10:Consumable::1:0:31910", -- Oracle Secret Solution
	[44066]="0:3:4:1:GemYellow::1:0:30489,32294,32296", -- Kharmaa's Grace
	[44067]="0:0:3:1:EnhPerm::1:0:31051,31101,32294,32296", -- Inscription of Triumph
	[44068]="0:0:3:1:EnhPerm::1:0:31051,31101,32294,32296", -- Inscription of Dominance
	[44069]="0:0:3:1:EnhPerm::1:0:31051,31101,32294,32296", -- Arcanum of Triumph
	[44071]="16000:0:1:20:FoodDrink::5:0:31910", -- Slow-Roasted Eel
	[44072]="16000:0:1:20:FoodDrink::5:0:31911", -- Roasted Mystery Beast
	[44073]="429375:4:4:1:Trinket::1:0:31911", -- Frenzyheart Insignia of Fury
	[44074]="429375:4:4:1:Trinket::1:0:31910", -- Oracle Talisman of Ablution
	[44075]="0:0:3:1:EnhPerm::1:0:31051,31101,32294,32296", -- Arcanum of Dominance
	[44076]="0:3:3:1:GemMeta::1:0:30489,32294,32296", -- Swift Starflare Diamond
	[44077]="0:15:4:1:Mount::1:0:32296", -- Reins of the Black War Mammoth
	[44078]="0:3:3:1:GemMeta::1:0:30489,32294,32296", -- Tireless Starflare Diamond
	[44080]="10000000:15:4:1:Mount::1:0:32540", -- Reins of the Ice Mammoth
	[44081]="0:3:3:1:GemMeta::1:0:30489,32294,32296", -- Enigmatic Starflare Diamond
	[44082]="0:3:3:1:GemMeta::1:0:30489,32294,32296", -- Impassive Starflare Diamond
	[44083]="0:15:4:1:Mount::1:0:", -- Reins of the Grand Black War Mammoth
	[44084]="0:3:3:1:GemMeta::1:0:30489,32294,32296", -- Forlorn Starflare Diamond
	[44086]="100000000:15:4:1:Mount::1:0:32540", -- Reins of the Grand Ice Mammoth
	[44087]="0:3:3:1:GemMeta::1:0:30489,32294,32296", -- Persistent Earthshatter Diamond
	[44088]="0:3:3:1:GemMeta::1:0:30489,32294,32296", -- Powerful Earthshatter Diamond
	[44089]="0:3:3:1:GemMeta::1:0:30489,32294,32296", -- Trenchant Earthshatter Diamond
	[44091]="0:2:7:1:Dagger::1:0:32294,32296", -- Sharpened Scarlet Kris
	[44092]="0:2:7:1:TwoHandSword::1:0:32294,32296", -- Reforged Truesilver Champion
	[44093]="0:2:7:1:Gun::1:0:32294,32296", -- Upgraded Dwarven Hand Cannon
	[44094]="0:2:7:1:OneHandMace::1:0:32294,32296", -- The Blessed Hammer of Grace
	[44095]="0:2:7:1:Stave::1:0:32294,32296", -- Grand Staff of Jordan
	[44096]="0:2:7:1:OneHandSword::1:0:32294,32296", -- Battleworn Thrash Blade
	[44097]="0:4:7:1:Trinket::1:0:32296", -- Inherited Insignia of the Horde
	[44098]="0:4:7:1:Trinket::1:0:32294", -- Inherited Insignia of the Alliance
	[44099]="0:4:7:1:Plate::1:0:32294,32296", -- Strengthened Stockade Pauldrons
	[44100]="0:4:7:1:Plate::1:0:32294,32296", -- Pristine Lightforge Spaulders
	[44101]="0:4:7:1:Mail::1:0:32294,32296", -- Prized Beastmaster's Mantle
	[44102]="0:4:7:1:Mail::1:0:32294,32296", -- Aged Pauldrons of The Five Thunders
	[44103]="0:4:7:1:Leather::1:0:32294,32296", -- Exceptional Stormshroud Shoulders
	[44104]="144777:4:3:1:Cloth::1:0:31910", -- Fishy Cinch
	[44105]="0:4:7:1:Leather::1:0:32294,32296", -- Lasting Feralheart Spaulders
	[44106]="164960:4:3:1:Leather::1:0:31910", -- Glitterscale Wrap
	[44107]="0:4:7:1:Cloth::1:0:32294,32296", -- Exquisite Sunderseer Mantle
	[44108]="498712:2:3:1:Wand::1:0:31910", -- Shinygem Rod
	[44109]="300376:4:3:1:Mail::1:0:31910", -- Toothslice Helm
	[44110]="301494:4:3:1:Mail::1:0:31910", -- Sharkjaw Cap
	[44111]="352412:4:3:1:Plate::1:0:31910", -- Gold Star Spaulders
	[44112]="353750:4:3:1:Plate::1:0:31910", -- Glimmershell Shoulder Protectors
	[44113]="0:0:1:1:Consumable::1:0:", -- Small Spice Bag
	[44114]="0:0:1:20:FoodDrink::1:0:", -- Old Spices
	[44115]="0:0:7:250:Other::1:0:32294,32296", -- Wintergrasp Commendation
	[44116]="137048:4:3:1:Cloth::1:0:31911", -- Muddied Crimson Gloves
	[44117]="321380:4:3:1:Leather::1:0:31911", -- Azure Strappy Pants
	[44118]="138516:2:3:1:Thrown::1:0:31911", -- Stolen Vrykul Harpoon
	[44120]="251213:4:3:1:Plate::1:0:31911", -- Giant-Sized Gauntlets
	[44121]="252087:4:3:1:Plate::1:0:31911", -- Sparkly Shiny Gloves
	[44122]="431227:4:3:1:Mail::1:0:31911", -- Scavenged Feathery Leggings
	[44123]="504886:4:3:1:Plate::1:0:31911", -- Discarded Titanium Legplates
	[44127]="0:12:1:1:::1:0:", -- Barricade Construction Kit
	[44128]="120000:7:3:20:Leather:202,165:1:0:14846,32515", -- Arctic Fur
	[44129]="750000:0:3:1:EnhPerm::1:0:32540", -- Lesser Inscription of the Storm 
	[44130]="750000:0:3:1:EnhPerm::1:0:32540", -- Lesser Inscription of the Crag
	[44131]="750000:0:3:1:EnhPerm::1:0:32540", -- Lesser Inscription of the Axe
	[44132]="750000:0:3:1:EnhPerm::1:0:32540", -- Lesser Inscription of the Pinnacle
	[44133]="1000000:0:7:1:EnhPerm::1:0:32540", -- Greater Inscription of the Axe
	[44134]="1000000:0:7:1:EnhPerm::1:0:32540", -- Greater Inscription of the Crag
	[44135]="1000000:0:7:1:EnhPerm::1:0:32540", -- Greater Inscription of the Storm 
	[44136]="1000000:0:7:1:EnhPerm::1:0:32540", -- Greater Inscription of the Pinnacle
	[44137]="1500000:0:3:1:EnhPerm::1:0:32540", -- Arcanum of the Frosty Soul
	[44138]="1500000:0:3:1:EnhPerm::1:0:32538", -- Arcanum of Toxic Warding
	[44139]="1500000:0:3:1:EnhPerm::1:0:30431", -- Arcanum of the Fleeing Shadow
	[44140]="1500000:0:3:1:EnhPerm::1:0:32533", -- Arcanum of the Eclipsed Moon
	[44141]="1500000:0:3:1:EnhPerm::1:0:32287", -- Arcanum of the Flame's Soul
	[44142]="0:7:1:1:Other::1:0:", -- Strange Tarot
	[44143]="0:12:1:20:::1:0:", -- Ace of Demons
	[44144]="0:12:1:20:::1:0:", -- Two of Mages
	[44145]="0:12:1:20:::1:0:", -- Three of Mages
	[44146]="0:12:1:20:::1:0:", -- Four of Mages
	[44147]="0:12:1:20:::1:0:", -- Five of Mages
	[44148]="0:12:3:1:::1:0:", -- Mages Deck
	[44149]="1500000:0:7:1:EnhPerm::1:0:32538", -- Arcanum of Torment
	[44150]="1500000:0:7:1:EnhPerm::1:0:30431", -- Arcanum of the Stalwart Protector
	[44151]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Blue Proto-Drake
	[44152]="1500000:0:7:1:EnhPerm::1:0:32533", -- Arcanum of Blissful Mending
	[44153]="0:13:1:1:::1:0:", -- Foreman's Key
	[44154]="0:12:1:20:::1:0:", -- Two of Demons
	[44155]="0:12:1:20:::1:0:", -- Three of Demons
	[44156]="0:12:1:20:::1:0:", -- Four of Demons
	[44157]="0:12:1:20:::1:0:", -- Five of Demons
	[44158]="0:12:3:1:::1:0:", -- Demons Deck
	[44159]="1500000:0:7:1:EnhPerm::1:0:32287", -- Arcanum of Burning Mysteries
	[44160]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Red Proto-Drake
	[44161]="0:7:1:1:Other::1:0:", -- Arcane Tarot
	[44163]="0:7:1:1:Other::1:0:", -- Shadowy Tarot
	[44164]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Black Proto-Drake
	[44165]="0:12:1:20:::1:0:", -- Ace of Mages
	[44166]="659636:2:3:1:Dagger::1:0:32287", -- Lightblade Rivener
	[44167]="198636:4:3:1:Cloak::1:0:32287", -- Shroud of Dedicated Research
	[44168]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Time-Lost Proto-Drake
	[44170]="258000:4:3:1:Leather::1:0:32287", -- Helm of the Majestic Stag
	[44171]="312130:4:3:1:Mail::1:0:32287", -- Spaulders of Grounded Lightning
	[44173]="741209:2:3:1:Dagger::1:0:32287", -- Flameheart Spell Scalpel
	[44174]="929820:2:3:1:Stave::1:0:32287", -- Stave of Shrouded Mysteries
	[44175]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Plagued Proto-Drake
	[44176]="263752:4:3:1:Plate::1:0:32287", -- Girdle of the Warrior Magi
	[44177]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Violet Proto-Drake
	[44178]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Albino Drake
	[44179]="378693:4:3:1:Leather::1:0:32287", -- Mind-Expanding Leggings
	[44180]="405390:4:4:1:Cloth::1:0:32287", -- Robes of Crackling Flame
	[44181]="254275:4:4:1:Leather::1:0:32287", -- Ghostflicker Waistband
	[44182]="461326:4:4:1:Mail::1:0:32287", -- Boots of Twinkling Stars
	[44183]="360539:4:4:1:Plate::1:0:32287", -- Fireproven Gauntlets
	[44184]="0:12:3:1:::1:0:", -- Mages Deck
	[44185]="0:12:3:1:::1:0:", -- Demons Deck
	[44186]="0:12:1:1:::1:0:", -- Rune of Distortion
	[44187]="680340:2:3:1:OneHandSword::1:0:32533", -- Fang of Truth
	[44188]="204868:4:3:1:Cloak::1:0:32533", -- Cloak of Peaceful Resolutions
	[44189]="205613:4:3:1:Mail::1:0:32540", -- Giant Ring Belt
	[44190]="257974:4:3:1:Leather::1:0:32540", -- Spaulders of Frozen Knives
	[44192]="738414:2:3:1:OneHandAxe::1:0:32540", -- Stalactite Chopper
	[44193]="741061:2:3:1:Dagger::1:0:32540", -- Broken Stalactite
	[44194]="371891:4:3:1:Leather::1:0:32540", -- Giant-Friend Kilt
	[44195]="391167:4:3:1:Plate::1:0:32540", -- Spaulders of the Giant Lords
	[44196]="140636:4:3:1:Cloth::1:0:32533", -- Sash of the Wizened Wyrm
	[44197]="248395:4:3:1:Plate::1:0:32533", -- Bracers of Accorded Courtesy
	[44198]="528214:4:3:1:Plate::1:0:32533", -- Breastplate of the Solemn Council
	[44199]="757312:2:3:1:OneHandMace::1:0:32533", -- Gavel of the Brewing Storm
	[44200]="141182:4:3:1:Cloth::1:0:32533", -- Ancestral Sinew Wristguards
	[44201]="371285:4:3:1:Plate::1:0:32533", -- Sabatons of Draconic Vigor
	[44202]="284512:4:4:1:Cloth::1:0:32533", -- Sandals of Crimson Fury
	[44203]="238000:4:4:1:Leather::1:0:32533", -- Dragonfriend Bracers
	[44204]="286659:4:4:1:Mail::1:0:32533", -- Grips of Fierce Pronouncements
	[44205]="671411:4:4:1:Plate::1:0:32533", -- Legplates of Bloody Reprisal
	[44206]="0:15:0:20:Junk::1:0:", -- Rime-Crusted Herbs
	[44207]="0:15:0:20:Junk::1:0:", -- Flash-Frozen Flower
	[44208]="0:15:0:20:Junk::1:0:", -- Shattered Log
	[44210]="0:4:4:1:OffHandFrill::1:0:", -- Faces of Doom
	[44211]="0:4:2:1:Cloth::1:0:", -- Frostwoven Gloves
	[44212]="0:12:1:1:::1:0:", -- SGM-3
	[44213]="0:4:3:1:Amulet::1:0:", -- Darkmoon Pendant
	[44214]="523506:2:3:1:Wand::1:0:30431", -- Purifying Torch
	[44215]="0:4:3:1:Amulet::1:0:", -- Darkmoon Necklace
	[44216]="210913:4:3:1:Cloak::1:0:30431", -- Cloak of Holy Extermination
	[44217]="0:2:3:1:Dagger::1:0:", -- Darkmoon Dirk
	[44218]="0:2:3:1:TwoHandAxe::1:0:", -- Darkmoon Executioner
	[44219]="0:2:3:1:Stave::1:0:", -- Darkmoon Magestaff
	[44220]="0:12:1:10:::1:0:", -- Orgrim's Hammer Dispatch
	[44221]="0:15:1:1:Mount::1:0:", -- Loaned Gryphon Reins
	[44222]="0:12:1:1:::1:0:", -- Dart Gun
	[44223]="0:15:4:1:Mount::1:0:", -- Reins of the Black War Bear
	[44224]="0:15:4:1:Mount::1:0:", -- Reins of the Black War Bear
	[44225]="7500000:15:4:1:Mount::1:0:32216", -- Reins of the Armored Brown Bear
	[44226]="7500000:15:4:1:Mount::1:0:32216", -- Reins of the Armored Brown Bear
	[44228]="0:0:1:20:FoodDrink::1:0:", -- Baby Spice
	[44229]="0:15:1:1:Mount::1:0:", -- Loaned Wind Rider Reins
	[44230]="0:15:4:1:Mount::1:0:32216", -- Reins of the Wooly Mammoth
	[44231]="0:15:4:1:Mount::1:0:32216", -- Reins of the Wooly Mammoth
	[44234]="200000000:15:4:1:Mount::1:0:32216", -- Reins of the Traveler's Tundra Mammoth
	[44235]="200000000:15:4:1:Mount::1:0:32216", -- Reins of the Traveler's Tundra Mammoth
	[44239]="461842:4:3:1:Plate::1:0:30431", -- Standard Issue Legguards
	[44240]="463629:4:3:1:Plate::1:0:30431", -- Special Issue Legplates
	[44241]="664881:2:3:1:FistWeapon::1:0:32538", -- Unholy Persuader
	[44242]="200209:4:3:1:Cloak::1:0:32538", -- Dark Soldier Cape
	[44243]="351037:4:3:1:Plate::1:0:32538", -- Toxin-Tempered Sabatons
	[44244]="895627:2:3:1:TwoHandMace::1:0:30431", -- Argent Skeleton Crusher
	[44245]="539417:2:3:1:Gun::1:0:30431", -- Zombie Sweeper Shotgun
	[44246]="0:12:1:3:::1:0:", -- Orb of Illusion
	[44247]="379685:4:3:1:Plate::1:0:30431", -- Fang-Deflecting Faceguard
	[44248]="327290:4:3:1:Mail::1:0:30431", -- Battle Mender's Helm
	[44249]="936897:2:3:1:TwoHandSword::1:0:32538", -- Runeblade of Demonstrable Power
	[44250]="752165:2:3:1:OneHandSword::1:0:32538", -- Reaper of Dark Souls
	[44251]="0:12:1:1:::1:0:", -- Partitioned Flask
	[44253]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Greatness
	[44254]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Greatness
	[44255]="0:4:4:1:Trinket::1:0:", -- Darkmoon Card: Greatness
	[44256]="153683:4:3:1:Cloth::1:0:32538", -- Sterile Flesh-Handling Gloves
	[44257]="348520:4:3:1:Mail::1:0:32538", -- Spaulders of the Black Arrow
	[44258]="175044:4:3:1:Leather::1:0:32538", -- Wound-Binder's Wristguards
	[44259]="0:12:4:1:::1:0:", -- Prisms Deck
	[44260]="0:12:3:20:::1:0:", -- Ace of Prisms
	[44261]="0:12:3:20:::1:0:", -- Two of Prisms
	[44262]="0:12:3:20:::1:0:", -- Three of Prisms
	[44263]="0:12:3:20:::1:0:", -- Four of Prisms
	[44264]="0:12:3:20:::1:0:", -- Five of Prisms
	[44265]="0:12:3:20:::1:0:", -- Six of Prisms
	[44266]="0:12:3:20:::1:0:", -- Seven of Prisms
	[44267]="0:12:3:20:::1:0:", -- Eight of Prisms
	[44268]="0:12:3:20:::1:0:", -- Ace of Nobles
	[44269]="0:12:3:20:::1:0:", -- Two of Nobles
	[44270]="0:12:3:20:::1:0:", -- Three of Nobles
	[44271]="0:12:3:20:::1:0:", -- Four of Nobles
	[44272]="0:12:3:20:::1:0:", -- Five of Nobles
	[44273]="0:12:3:20:::1:0:", -- Six of Nobles
	[44274]="0:12:3:20:::1:0:", -- Seven of Nobles
	[44275]="0:12:3:20:::1:0:", -- Eight of Nobles
	[44276]="0:12:4:1:::1:0:", -- Chaos Deck
	[44277]="0:12:3:20:::1:0:", -- Ace of Chaos
	[44278]="0:12:3:20:::1:0:", -- Two of Chaos
	[44279]="0:12:3:20:::1:0:", -- Three of Chaos
	[44280]="0:12:3:20:::1:0:", -- Four of Chaos
	[44281]="0:12:3:20:::1:0:", -- Five of Chaos
	[44282]="0:12:3:20:::1:0:", -- Six of Chaos
	[44283]="284983:4:4:1:Ring::1:0:30431", -- Signet of Hopeful Light
	[44284]="0:12:3:20:::1:0:", -- Seven of Chaos
	[44285]="0:12:3:20:::1:0:", -- Eight of Chaos
	[44286]="0:12:3:20:::1:0:", -- Ace of Undeath
	[44287]="0:12:3:20:::1:0:", -- Two of Undeath
	[44288]="0:12:3:20:::1:0:", -- Three of Undeath
	[44289]="0:12:3:20:::1:0:", -- Four of Undeath
	[44290]="0:12:3:20:::1:0:", -- Five of Undeath
	[44291]="0:12:3:20:::1:0:", -- Six of Undeath
	[44292]="0:12:3:20:::1:0:", -- Seven of Undeath
	[44293]="0:12:3:20:::1:0:", -- Eight of Undeath
	[44294]="0:12:4:1:::1:0:", -- Undeath Deck
	[44295]="612379:4:4:1:Mail::1:0:30431", -- Polished Regimental Hauberk
	[44296]="536712:4:4:1:Plate::1:0:30431", -- Helm of Purified Thoughts
	[44297]="358398:4:4:1:Leather::1:0:30431", -- Boots of the Neverending Path
	[44301]="0:12:1:10:::1:0:", -- Tainted Essence
	[44302]="187027:4:4:1:Cloth::1:0:32538", -- Belt of Dark Mending
	[44303]="488648:4:4:1:Leather::1:0:32538", -- Darkheart Chestguard
	[44304]="0:12:1:1:::1:0:", -- Writhing Mass
	[44305]="590731:4:4:1:Mail::1:0:32538", -- Kilt of Dark Mercy
	[44306]="517755:4:4:1:Plate::1:0:32538", -- Death-Inured Sabatons
	[44307]="0:12:1:1:::1:0:", -- Diluted Cult Tonic
	[44308]="0:4:4:1:Ring::1:0:", -- Signet of Edward the Odd
	[44309]="0:4:4:1:Cloth::1:0:", -- Sash of Jordan
	[44310]="0:2:4:1:Dagger::1:0:", -- Namlak's Supernumerary Sticker
	[44311]="0:2:4:1:OneHandSword::1:0:", -- Avool's Sword of Jin
	[44312]="0:4:4:1:Plate::1:0:", -- Wapach's Spaulders of Solidarity
	[44313]="0:4:4:1:Shield::1:0:", -- Zom's Crackling Bulwark
	[44314]="0:0:1:20:Scroll::1:0:", -- Scroll of Recall II
	[44315]="0:0:1:20:Scroll::1:0:", -- Scroll of Recall III
	[44316]="0:7:3:1:Other::1:0:", -- Darkmoon Card
	[44317]="0:7:3:1:Other::1:0:", -- Greater Darkmoon Card
	[44318]="0:7:3:1:Other::1:0:", -- Darkmoon Card of the North
	[44319]="0:12:1:1:::1:0:", -- Broken Shard of Horror
	[44320]="0:12:1:1:::1:0:", -- Broken Shard of Despair
	[44321]="0:12:1:1:::1:0:", -- Broken Shard of Suffering
	[44322]="0:4:3:1:Trinket::1:0:", -- Mercurial Alchemist Stone
	[44323]="0:4:3:1:Trinket::1:0:", -- Indestructible Alchemist's Stone
	[44324]="0:4:3:1:Trinket::1:0:", -- Mighty Alchemist's Stone
	[44325]="0:0:1:20:Elixir::1:0:", -- Elixir of Accuracy
	[44326]="0:12:4:1:::1:0:", -- Nobles Deck
	[44327]="0:0:1:20:Elixir::1:0:", -- Elixir of Deadly Strikes
	[44328]="0:0:1:20:Elixir::1:0:", -- Elixir of Mighty Defense
	[44329]="0:0:1:20:Elixir::1:0:", -- Elixir of Expertise
	[44330]="0:0:1:20:Elixir::1:0:", -- Elixir of Armor Piercing
	[44331]="0:0:1:20:Elixir::1:0:", -- Elixir of Lightning Speed
	[44332]="0:0:1:20:Elixir::1:0:", -- Elixir of Mighty Thoughts
	[44334]="0:4:3:1:Ring::1:0:", -- Ring of Temerity
	[44335]="0:4:3:1:Ring::1:0:", -- Band of Motivation
	[44336]="0:4:3:1:Ring::1:0:", -- Flourishing Band
	[44337]="0:4:3:1:Ring::1:0:", -- Staunch Signet
	[44338]="0:4:3:1:Cloth::1:0:", -- Cuffs of Gratitude
	[44339]="0:4:3:1:Leather::1:0:", -- Soaring Wristwraps
	[44340]="0:4:3:1:Mail::1:0:", -- Bindings of Raelorasz
	[44341]="0:4:3:1:Plate::1:0:", -- Bracers of Reverence
	[44342]="0:4:3:1:Leather::1:0:", -- Tattooed Deerskin Leggings
	[44343]="0:4:3:1:Cloth::1:0:", -- Conferred Pantaloons
	[44344]="0:4:3:1:Mail::1:0:", -- Labyrinthine Legguards
	[44345]="0:4:3:1:Plate::1:0:", -- Dalaran Warden's Legplates
	[44346]="0:4:3:1:Cloth::1:0:", -- Warchief's Leggings of Wisdom
	[44347]="0:4:3:1:Leather::1:0:", -- Warchief's Legguards of Heroism
	[44348]="0:4:3:1:Mail::1:0:", -- Warchief's Leggings of Valor
	[44349]="0:4:3:1:Plate::1:0:", -- Warchief's Legplates of Carnage
	[44350]="0:4:3:1:Cloth::1:0:", -- Mantle of Thwarted Evil
	[44351]="0:4:3:1:Leather::1:0:", -- Shoulderpads of Abhorrence
	[44352]="0:4:3:1:Plate::1:0:", -- Shoulderplates of the Abolished
	[44353]="0:4:3:1:Mail::1:0:", -- Epaulets of the Faceless Ones
	[44354]="0:4:3:1:Mail::1:0:", -- Assault Hauberk
	[44355]="0:4:3:1:Cloth::1:0:", -- Incursion Vestments
	[44356]="0:4:3:1:Leather::1:0:", -- Vest of the Assailant
	[44357]="0:4:3:1:Plate::1:0:", -- Besieging Breastplate
	[44358]="0:4:3:1:Cloth::1:0:", -- Kilix's Silk Slippers
	[44359]="0:4:3:1:Leather::1:0:", -- Don Soto's Boots
	[44360]="0:4:3:1:Mail::1:0:", -- Husk Shard Sabatons
	[44361]="0:4:3:1:Plate::1:0:", -- Greaves of the Traitor
	[44362]="0:4:3:1:Plate::1:0:", -- Expelling Gauntlets
	[44363]="0:4:3:1:Mail::1:0:", -- Purging Handguards
	[44364]="0:4:3:1:Leather::1:0:", -- Wraps of Quelled Bane
	[44365]="0:4:3:1:Cloth::1:0:", -- Gloves of Banished Infliction
	[44366]="0:4:3:1:Cloth::1:0:", -- Shameful Cuffs
	[44367]="0:4:3:1:Leather::1:0:", -- Scorned Bands
	[44368]="0:4:3:1:Mail::1:0:", -- Accused Wristguards
	[44369]="0:4:3:1:Plate::1:0:", -- Disavowed Bracers
	[44370]="0:4:3:1:Cloth::1:0:", -- Mantle of the Intrepid Explorer
	[44371]="0:4:3:1:Leather::1:0:", -- Shoulderpads of the Adventurer
	[44372]="0:4:3:1:Mail::1:0:", -- Spaulders of Lost Secrets
	[44373]="0:4:3:1:Plate::1:0:", -- Pauldrons of Reconnaissance
	[44374]="0:4:3:1:Amulet::1:0:", -- Amulet of the Tranquil Mind
	[44375]="0:4:3:1:Amulet::1:0:", -- Razor-Blade Pendant
	[44376]="0:4:3:1:Amulet::1:0:", -- Necklace of Fragmented Light
	[44377]="0:4:3:1:Amulet::1:0:", -- Woven Steel Necklace
	[44378]="0:4:3:1:Cloth::1:0:", -- Mantle of the Flesh Giant
	[44379]="0:4:3:1:Leather::1:0:", -- Shoulderpads of Fleshwerks
	[44380]="0:4:3:1:Mail::1:0:", -- Giant Champion's Spaulders
	[44381]="0:4:3:1:Plate::1:0:", -- Pauldrons of Morbidus
	[44382]="0:4:3:1:Cloth::1:0:", -- Robes of Refrained Celebration
	[44383]="0:4:3:1:Plate::1:0:", -- Battleplate of Unheard Ovation
	[44384]="0:4:3:1:Mail::1:0:", -- Chestguard of Unwanted Success
	[44385]="0:4:3:1:Leather::1:0:", -- Tunic of the Unduly Victorious
	[44386]="0:4:3:1:Ring::1:0:", -- Newt-Eye Ring
	[44387]="0:4:3:1:Ring::1:0:", -- Bat-Wool Signet
	[44388]="0:4:3:1:Ring::1:0:", -- Frog-Toe Band
	[44391]="0:4:3:1:Amulet::1:0:", -- Cast Steel Choker
	[44392]="0:4:3:1:Amulet::1:0:", -- Necklace of Permeation
	[44393]="0:2:3:1:Crossbow::1:0:", -- Polished Zombie Exterminator
	[44394]="0:2:3:1:Wand::1:0:", -- Encrusted Zombie Finger
	[44395]="0:2:3:1:Wand::1:0:", -- Touch of Unlife
	[44396]="0:4:3:1:Cloth::1:0:", -- Gloves of the Time Guardian
	[44397]="0:4:3:1:Leather::1:0:", -- Handwraps of Preserved History
	[44398]="0:4:3:1:Mail::1:0:", -- Grips of Chronological Events
	[44399]="0:4:3:1:Plate::1:0:", -- Gauntlets of The Culling
	[44400]="0:4:3:1:Amulet::1:0:", -- Necklace of Calm Skies
	[44401]="0:4:3:1:Amulet::1:0:", -- Hundred Tooth Necklace
	[44402]="0:4:3:1:Amulet::1:0:", -- Tiled-Stone Pendant
	[44403]="0:4:3:1:Amulet::1:0:", -- Amulet of Constrained Power
	[44404]="0:4:3:1:Cloth::1:0:", -- Bauble-Woven Gown
	[44405]="0:4:3:1:Leather::1:0:", -- Exotic Leather Tunic
	[44406]="0:4:3:1:Mail::1:0:", -- Gilded Ringmail Hauberk
	[44407]="0:4:3:1:Plate::1:0:", -- Silver-Plated Battlechest
	[44408]="0:4:3:1:Cloth::1:0:", -- Cowl of the Vindictive Captain
	[44409]="0:4:3:1:Leather::1:0:", -- Headguard of Retaliation
	[44410]="0:4:3:1:Mail::1:0:", -- Helmet of Just Retribution
	[44411]="0:4:3:1:Plate::1:0:", -- Platehelm of Irate Revenge
	[44412]="0:4:3:1:Plate::1:0:", -- Faceguard of Punishment
	[44413]="0:15:4:1:Mount::1:0:", -- Mekgineer's Chopper
	[44415]="0:2:3:1:Stave::1:0:", -- Savage Gladiator's War Staff
	[44416]="0:2:3:1:Stave::1:0:", -- Savage Gladiator's Focus Staff
	[44417]="0:2:4:1:Stave::1:0:", -- Hateful Gladiator's War Staff
	[44418]="0:2:4:1:Stave::1:0:", -- Hateful Gladiator's Focus Staff
	[44419]="0:2:4:1:Stave::1:0:", -- Deadly Gladiator's War Staff
	[44420]="0:2:4:1:Stave::1:0:", -- Deadly Gladiator's Focus Staff
	[44421]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's War Staff
	[44422]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's Focus Staff
	[44423]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's War Staff
	[44424]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's Focus Staff
	[44429]="0:4:4:1:Cloak::1:0:", -- Volanthius Shroud
	[44430]="0:15:3:1:Junk::1:0:", -- Titanium Seal of Dalaran
	[44431]="0:4:4:1:Cloak::1:0:", -- Cloak of Certain Reprieve
	[44433]="0:12:1:1:::1:0:", -- Rod of Siphoning
	[44434]="0:12:1:5:::1:0:", -- Dark Matter
	[44435]="5000:0:2:1:Consumable::1:0:29261", -- Windle's Lighter
	[44436]="0:4:3:1:Mail::1:0:", -- Dark Frostscale Leggings
	[44437]="0:4:3:1:Mail::1:0:", -- Dark Frostscale Breastplate
	[44438]="0:4:3:1:Mail::1:0:", -- Dragonstompers
	[44440]="0:4:3:1:Leather::1:0:", -- Dark Iceborne Leggings
	[44441]="0:4:3:1:Leather::1:0:", -- Dark Iceborne Chestguard
	[44442]="0:4:3:1:Leather::1:0:", -- Bugsquashers
	[44443]="0:4:3:1:Mail::1:0:", -- Dark Nerubian Leggings
	[44444]="0:4:3:1:Mail::1:0:", -- Dark Nerubian Chestpiece
	[44445]="0:4:3:1:Mail::1:0:", -- Scaled Icewalkers
	[44446]="0:1:3:1:InscriptionBag::1:0:", -- Pack of Endless Pockets
	[44447]="0:11:3:1:AmmoPouch::1:0:", -- Dragonscale Ammo Pouch
	[44448]="0:11:3:1:Quiver::1:0:", -- Nerubian Reinforced Quiver
	[44449]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Assault
	[44450]="0:12:1:1:::1:0:", -- Hourglass of Eternity
	[44452]="0:7:3:1:Enchanting::1:0:", -- Runed Titanium Rod
	[44453]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Greater Potency
	[44455]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Shield - Greater Intellect
	[44456]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Speed
	[44457]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Cloak - Major Agility
	[44458]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Crusher
	[44459]="0:12:1:1:::1:0:", -- Cult of the Damned Research - Page 1
	[44460]="0:12:1:1:::1:0:", -- Cult of the Damned Research - Page 2
	[44461]="0:12:1:1:::1:0:", -- Cult of the Damned Research - Page 3
	[44462]="0:12:1:1:::1:0:", -- Cult of the Damned Thesis
	[44463]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant 2H Weapon - Massacre
	[44464]="0:15:0:20:Junk::1:0:", -- Crude Eating Utensils
	[44465]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Chest - Powerful Stats
	[44466]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Superior Potency
	[44467]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Mighty Spellpower
	[44468]="0:15:0:1:Junk::1:0:", -- Water Soaked Letter
	[44469]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Greater Assault
	[44470]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Superior Spellpower
	[44471]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Cloak - Mighty Armor
	[44472]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Cloak - Greater Speed
	[44473]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Weapon - Scourgebane
	[44474]="0:12:1:1:::1:0:", -- Fordragon's Shield
	[44475]="0:7:1:1:Other::1:0:", -- Reinforced Crate
	[44476]="0:12:1:1:::1:0:", -- Alumeth's Skull
	[44477]="0:12:1:1:::1:0:", -- Alumeth's Heart
	[44478]="0:12:1:1:::1:0:", -- Alumeth's Scepter
	[44479]="0:12:1:1:::1:0:", -- Alumeth's Robes
	[44480]="0:12:1:1:::1:0:", -- Alumeth's Remains
	[44481]="4500:0:1:10:Consumable::1:0:29478,29716", -- Grindgear Toy Gorilla
	[44482]="3000:0:2:5:Consumable::1:0:29478,29716", -- Trusty Copper Racer
	[44483]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant 2H Weapon - Massacre
	[44484]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Bracers - Greater Assault
	[44485]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Gloves - Armsman
	[44486]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Weapon - Superior Potency
	[44487]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Weapon - Mighty Spellpower
	[44488]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Cloak - Wisdom
	[44489]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Chest - Powerful Stats
	[44490]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Boots - Greater Assault
	[44491]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Boots - Tuskarr's Vitality
	[44492]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Weapon - Berserking
	[44493]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Berserking
	[44494]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Weapon - Lifeward
	[44495]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Weapon - Black Magic
	[44496]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Weapon - Accuracy
	[44497]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Accuracy
	[44498]="0:9:2:1:Enchanting::1:0:32514", -- Formula: Enchant Bracer - Superior Spellpower
	[44499]="30000000:7:1:1:Part:202:1:0:31247", -- Salvaged Iron Golem Parts
	[44500]="15000000:7:1:1:Part:202:1:1:31247", -- Elementium-plated Exhaust Pipe
	[44501]="10000000:7:1:20:Part:202:1:0:31247", -- Goblin-machined Piston
	[44502]="4000000:9:4:1:Engineering::1:0:32565,32774", -- Schematic: Mechano-hog
	[44503]="4000000:9:4:1:Engineering::1:0:32564,32773", -- Schematic: Mekgineer's Chopper
	[44504]="0:2:4:1:Gun::1:0:", -- Nesingwary 4000
	[44505]="0:2:3:1:Dagger::1:0:", -- Dustbringer
	[44506]="0:0:1:1:Other::1:0:", -- Saronite Arrow Maker
	[44507]="0:0:1:1:Other::1:0:", -- Ultrasafe Bullet Machine
	[44508]="0:9:1:1:Alchemy::1:0:", -- Discovery!
	[44509]="50000:9:3:1:Leatherworking::1:0:31916,32763", -- Pattern: Trapper's Traveling Pack
	[44510]="50000:9:3:1:Leatherworking::1:0:32540", -- Pattern: Mammoth Mining Bag
	[44511]="50000:9:3:1:Leatherworking::1:0:31916,32763", -- Pattern: Dragonscale Ammo Pouch
	[44512]="50000:9:3:1:Leatherworking::1:0:32538", -- Pattern: Nerubian Reinforced Quiver
	[44513]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Eviscerator's Facemask
	[44514]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Eviscerator's Shoulderpads
	[44515]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Eviscerator's Chestguard
	[44516]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Eviscerator's Bindings
	[44517]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Eviscerator's Gauntlets
	[44518]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Eviscerator's Waistguard
	[44519]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Eviscerator's Legguards
	[44520]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Eviscerator's Treads
	[44521]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Overcast Headguard
	[44522]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Overcast Spaulders
	[44523]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Overcast Chestguard
	[44524]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Overcast Bracers
	[44525]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Overcast Handwraps
	[44526]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Overcast Belt
	[44527]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Overcast Leggings
	[44528]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Overcast Boots
	[44529]="0:12:1:5:::1:0:", -- Demolisher Parts
	[44530]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Swiftarrow Helm
	[44531]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Swiftarrow Shoulderguards
	[44532]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Swiftarrow Hauberk
	[44533]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Swiftarrow Bracers
	[44534]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Swiftarrow Gauntlets
	[44535]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Swiftarrow Belt
	[44536]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Swiftarrow Leggings
	[44537]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Swiftarrow Boots
	[44538]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Stormhide Crown
	[44539]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Stormhide Shoulders
	[44540]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Stormhide Hauberk
	[44541]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Stormhide Wristguards
	[44542]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Stormhide Grips
	[44543]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Stormhide Belt
	[44544]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Stormhide Legguards
	[44545]="0:9:3:1:Leatherworking::1:0:32515", -- Pattern: Stormhide Stompers
	[44546]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Giantmaim Legguards
	[44547]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Giantmaim Bracers
	[44548]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Revenant's Breastplate
	[44549]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Revenant's Treads
	[44550]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Trollwoven Spaulders
	[44551]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Trollwoven Girdle
	[44552]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Earthgiving Legguards
	[44553]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Earthgiving Boots
	[44554]="0:15:3:1:FlyingMount::1:0:", -- Flying Carpet
	[44558]="0:15:4:1:FlyingMount::1:0:", -- Magnificent Flying Carpet
	[44559]="0:0:3:1:EnhPerm::1:0:", -- Pattern: Fur Lining - Fire Resist
	[44560]="0:0:3:1:EnhPerm::1:0:", -- Pattern: Fur Lining - Frost Resist
	[44561]="0:0:3:1:EnhPerm::1:0:", -- Pattern: Fur Lining - Shadow Resist
	[44562]="0:0:3:1:EnhPerm::1:0:", -- Pattern: Fur Lining - Nature Resist
	[44563]="0:0:3:1:EnhPerm::1:0:", -- Pattern: Fur Lining - Arcane Resist
	[44564]="0:9:2:1:Alchemy::1:0:", -- Recipe: Mighty Arcane Protection Potion
	[44565]="0:9:2:1:Alchemy::1:0:", -- Recipe: Mighty Fire Protection Potion
	[44566]="0:9:2:1:Alchemy::1:0:", -- Recipe: Mighty Frost Protection Potion
	[44567]="0:9:2:1:Alchemy::1:0:", -- Recipe: Mighty Nature Protection Potion
	[44568]="0:9:2:1:Alchemy::1:0:", -- Recipe: Mighty Shadow Protection Potion
	[44569]="0:12:4:1:::1:0:", -- Key to the Focusing Iris
	[44570]="50:0:1:20:FoodDrink::1:0:32415,32419,32420,32642,33019", -- Glass of Eversong Wine
	[44571]="150:0:1:20:FoodDrink::1:0:32415,32419,32420,32642,33019", -- Bottle of Silvermoon Port
	[44573]="1500:0:1:20:FoodDrink::1:0:32415,32419,32420,32642,33019", -- Cup of Frog Venom Brew
	[44574]="2000:0:1:20:FoodDrink::1:0:32415,32419,32420,32642,33019", -- Skin of Mulgore Firewater
	[44575]="120:0:1:20:FoodDrink::1:0:32415,32419,32420,32642,33019", -- Flask of Bitter Cactus Cider
	[44576]="0:0:1:1:Consumable::1:0:", -- Bright Flare
	[44577]="0:12:4:1:::1:0:", -- Heroic Key to the Focusing Iris
	[44579]="0:4:3:1:Trinket::1:0:", -- Medallion of Heroism
	[44581]="0:13:4:1:::1:0:", -- Heroic Key to the Focusing Iris
	[44582]="0:13:4:1:::1:0:", -- Key to the Focusing Iris
	[44583]="0:4:3:1:Leather::1:0:", -- Warchief's Legguards of Brutality
	[44584]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Polar Vest
	[44585]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Polar Cord
	[44586]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Polar Boots
	[44587]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Icy Scale Chestguard
	[44588]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Icy Scale Belt
	[44589]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Icy Scale Boots
	[44590]="0:4:3:1:Mail::1:0:", -- Warchief's Leggings of Foresight
	[44591]="0:4:3:1:Mail::1:0:", -- Wrynn's Leggings of Foresight
	[44592]="0:4:3:1:Mail::1:0:", -- Wrynn's Leggings of Valor
	[44593]="0:4:3:1:Cloth::1:0:", -- Wrynn's Leggings of Wisdom
	[44594]="0:4:3:1:Leather::1:0:", -- Wrynn's Legguards of Brutality
	[44595]="0:4:3:1:Leather::1:0:", -- Wrynn's Legguards of Heroism
	[44596]="0:4:3:1:Plate::1:0:", -- Wrynn's Legplates of Carnage
	[44597]="0:4:3:1:Trinket::1:0:", -- Medallion of Heroism
	[44599]="3000:0:2:10:Consumable::1:0:29478,29716", -- Zippy Copper Racer
	[44600]="0:9:3:1:Book::1:0:", -- Tome of Polymorph: Serpent
	[44601]="3000:0:2:10:Consumable::1:0:29478,29716", -- Heavy Copper Racer
	[44602]="4750000:9:2:1:Book::1:1:28715", -- Tome of Dalaran Intellect
	[44605]="5000:15:1:20:Reagent:-11:1:0:1257,1275,1308,1351,3323,3335,3351,3562,4220,4562,4575,5110,5151,8361,12096,12097,16611,16612,16706,16757,24313,24349,24357,25736,26382,26569,26908,26950,26968,26984,27030,27039,27054,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33669,33871,35642,37904,37935", -- Wild Spineleaf
	[44606]="2500000:0:3:1:Consumable::1:0:29478,29716", -- Toy Train Set
	[44607]="0:0:1:20:FoodDrink::1:0:", -- Aged Dalaran Sharp
	[44608]="0:0:1:20:FoodDrink::1:0:", -- Dalaran Swiss
	[44609]="0:0:1:20:FoodDrink::1:0:", -- Fresh Dalaran Bread Slice
	[44610]="85000:0:1:1:Consumable::1:0:29714", -- Fresh Dalaran Bread
	[44612]="85000:0:1:1:Consumable::1:0:29714", -- Dalaran Swiss Wheel
	[44613]="160000:0:1:1:Consumable::1:0:29714", -- Aged Dalaran Sharp Wheel
	[44614]="7000:15:1:20:Reagent:-11:1:0:1257,1275,1308,1351,3323,3335,3351,3562,4220,4562,4575,5110,5151,8361,12096,12097,16611,16612,16706,16757,24313,24349,24357,25736,26382,26569,26908,26950,26968,26984,27030,27039,27054,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33669,33871,35642,37904,37935", -- Starleaf Seed
	[44615]="2000:15:1:20:Reagent:-5:1:0:1257,1275,1308,1351,3323,3335,3351,3562,4220,4562,4575,5110,5151,8361,12096,12097,16611,16612,16706,16757,24313,24349,24357,25736,26382,26569,26908,26950,26968,26984,27030,27039,27054,27133,27138,27149,27176,27186,27935,28714,28809,28827,28870,29015,29037,29203,29537,29561,29636,29909,29922,29947,29961,29968,30010,30069,30239,30244,30307,30345,30438,30825,31115,32639,32641,33669,33871,35642,37904,37935", -- Devout Candle
	[44616]="1500:0:1:20:FoodDrink::1:0:29715,32631", -- Glass of Dalaran White
	[44617]="2000:0:1:20:FoodDrink::1:0:29715,32631", -- Glass of Dalaran Red
	[44618]="10000:0:2:20:FoodDrink::1:0:29715,32631", -- Glass of Aged Dalaran Red
	[44619]="0:0:3:20:FoodDrink::1:0:", -- Glass of Peaked Dalaran Red
	[44621]="75000:0:1:1:Consumable::1:0:32337", -- Bottle of Dalaran White
	[44622]="375000:0:1:1:Consumable::1:0:32337", -- Cask of Dalaran White
	[44623]="100000:0:1:1:Consumable::1:0:32337", -- Bottle of Dalaran Red
	[44625]="500000:0:2:1:Consumable::1:0:32337", -- Bottle of Aged Dalaran Red
	[44626]="2500000:0:2:1:Consumable::1:0:32337", -- Cask of Aged Dalaran Red
	[44627]="0:0:3:1:Consumable::1:0:", -- Bottle of Peaked Dalaran Red
	[44629]="0:0:3:1:Consumable::1:0:", -- Cask of Peaked Dalaran Red
	[44631]="0:12:1:20:::1:0:", -- Whelp Bone Dust
	[44632]="500000:0:1:1:Consumable::1:0:32337", -- Cask of Dalaran Red
	[44635]="115886:2:1:1:Gun::1:0:29476", -- Dalaran Rifle
	[44636]="155103:2:1:1:OneHandMace::1:0:29497", -- Dalaran Cudgel
	[44637]="116757:2:1:1:Crossbow::1:0:28989", -- Dalaran Crossbow
	[44638]="156265:2:1:1:OneHandSword::1:0:28991", -- Dalaran Sword
	[44639]="196067:2:1:1:TwoHandSword::1:0:28991", -- Dalaran Greatsword
	[44640]="196803:2:1:1:TwoHandAxe::1:0:29496", -- Dalaran Great Axe
	[44641]="158015:2:1:1:FistWeapon::1:0:29499,29538", -- Dalaran Knuckles
	[44642]="158604:2:1:1:OneHandAxe::1:0:29496", -- Dalaran Axe
	[44643]="119394:2:1:1:Bow::1:0:28989", -- Dalaran Bow
	[44644]="119394:2:1:1:Thrown::1:0:29493,29499,29538", -- Dalaran Dart
	[44645]="200443:2:1:1:TwoHandMace::1:0:29497", -- Dalaran Hammer
	[44647]="550001:4:1:1:Miscellaneous::1:0:29702", -- Violet Hat
	[44648]="999999:4:1:1:Miscellaneous::1:0:29702", -- Purple Turban
	[44649]="0:4:3:1:Plate::1:0:", -- Crystalbark's Toenail
	[44650]="0:12:1:1:::1:0:", -- Heart of Magic
	[44651]="0:12:1:1:::1:0:", -- Heart of Magic
	[44652]="152732:2:1:1:Dagger::1:0:29499,29538", -- Dalaran Dagger
	[44653]="0:12:1:1:::1:0:", -- Volatile Acid
	[44654]="192387:2:1:1:Polearm::1:0:29496", -- Dalaran Spear
	[44655]="193123:2:1:1:Stave::1:0:29494", -- Dalaran Stave
	[44656]="0:12:1:1:::1:0:", -- Cultist Acolyte Robes
	[44657]="0:4:4:1:Amulet::1:0:", -- Torque of the Red Dragonflight
	[44658]="0:4:4:1:Amulet::1:0:", -- Chain of the Ancient Wyrm
	[44659]="0:4:4:1:Amulet::1:0:", -- Pendant of the Dragonsworn
	[44660]="0:4:4:1:Amulet::1:0:", -- Drakescale Collar
	[44661]="0:4:4:1:Amulet::1:0:", -- Wyrmrest Necklace of Power
	[44662]="0:4:4:1:Amulet::1:0:", -- Life-Binder's Locket
	[44663]="0:15:1:1:Junk::1:0:", -- Abandoned Adventurer's Satchel
	[44664]="0:4:4:1:Amulet::1:0:", -- Favor of the Dragon Queen
	[44665]="0:4:4:1:Amulet::1:0:", -- Nexus War Champion Beads
	[44666]="0:4:3:1:Leather::1:0:", -- Flumblub's Seat Cushion
	[44667]="0:4:3:1:Cloth::1:0:", -- Mammoth-Hair Crown
	[44668]="0:4:3:1:Cloth::1:0:", -- Egg-Warming Blanket
	[44669]="0:4:3:1:Mail::1:0:", -- Worgen-Scored Shackles
	[44670]="0:4:3:1:Plate::1:0:", -- Soul-Sealed Belt
	[44671]="0:4:3:1:Mail::1:0:", -- Highlord's Padded Legguards
	[44672]="0:4:3:1:Leather::1:0:", -- Seal-Fur Spaulders
	[44673]="0:4:3:1:Cloth::1:0:", -- Mammoth-Riding Boots
	[44674]="0:4:3:1:Cloth::1:0:", -- Ichor-Stained Wraps
	[44675]="0:4:3:1:Mail::1:0:", -- Rock-Giant's Pinky Cover
	[44676]="0:4:3:1:Leather::1:0:", -- Syreian's Leggings
	[44677]="0:4:3:1:Plate::1:0:", -- Eternal Observer's Legplates
	[44678]="50000:4:1:1:OffHandFrill::1:0:32337", -- Wine Glass
	[44679]="100000:4:1:1:OffHandFrill::1:0:32337", -- Red Wine Glass
	[44680]="0:15:1:1:Other::1:0:", -- Assorted Writings
	[44681]="0:4:3:1:Ring::1:0:", -- Titanium Brain-Gear
	[44682]="0:4:3:1:Amulet::1:0:", -- Time-Forward Talisman
	[44683]="0:4:3:1:Ring::1:0:", -- King's Eyesocket
	[44684]="0:16:1:20:Mage::1:0:", -- Glyph of Frostfire
	[44685]="0:4:3:1:Mail::1:0:", -- Calcified Web Spaulders
	[44686]="0:4:3:1:Leather::1:0:", -- Ethereal Terror Handwraps
	[44687]="0:4:3:1:Cloak::1:0:", -- Loque'Nahak's Pelt
	[44688]="0:4:3:1:Amulet::1:0:", -- Loque'Nahak's Severed Fang
	[44689]="20000000:15:4:1:FlyingMount::1:0:32216", -- Armored Snowy Gryphon
	[44690]="20000000:15:4:1:FlyingMount::1:0:32216", -- Armored Blue Wind Rider
	[44691]="0:4:3:1:Plate::1:0:", -- Aotona's Collar
	[44692]="749998:4:1:1:Miscellaneous::1:0:29628", -- Dalaran Nurse's Gown
	[44693]="200000:4:1:1:Shirt::1:0:29628", -- Wound Dressing
	[44694]="250000:4:1:1:Shirt::1:0:29628", -- Antiseptic-Soaked Dressing
	[44695]="0:4:3:1:Plate::1:0:", -- Corroded Faceguard
	[44696]="0:4:3:1:Leather::1:0:", -- Giant's Toewrap
	[44697]="0:4:3:1:Mail::1:0:", -- Val'kyr Vestments
	[44698]="27000:0:1:1:Consumable::1:0:29628", -- Intravenous Healing Potion
	[44700]="0:7:1:1:Other::1:0:", -- Brooding Darkwater Clam
	[44701]="1500000:0:7:1:EnhPerm::1:0:32564,32773", -- Arcanum of the Savage Gladiator
	[44702]="1500000:0:7:1:EnhPerm::1:0:32565,32774", -- Arcanum of the Savage Gladiator
	[44703]="0:2:2:1:Dagger::1:0:", -- Dark Herring
	[44704]="0:12:1:1:::1:0:", -- Charged Disk
	[44707]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Green Proto-Drake
	[44708]="0:2:3:1:TwoHandMace::1:0:", -- Dirkee's Superstructure
	[44709]="25000000:9:3:1:Book::1:1:28715", -- Tome of Polymorph: Black Cat
	[44710]="0:0:2:250:Other::1:0:35494,35495,35573,35574", -- Wyrmrest Commendation Badge
	[44711]="0:0:2:250:Other::1:0:35494,35495,35573,35574", -- Argent Crusade Commendation Badge
	[44713]="0:0:2:250:Other::1:0:35494,35495,35573,35574", -- Ebon Blade Commendation Badge
	[44714]="5000000:9:2:1:Book::1:1:28715", -- Tome of Dalaran Brilliance
	[44716]="0:0:1:20:Consumable::1:0:", -- Mysterious Fermented Liquid
	[44717]="30000:0:1:1:Consumable::1:0:31911", -- Disgusting Jar
	[44718]="0:0:1:1:Consumable::1:0:", -- Ripe Disgusting Jar
	[44719]="0:4:3:1:Miscellaneous::1:0:", -- Frenzyheart Brew
	[44721]="0:15:1:1:Companion::1:0:", -- Proto-Drake Whelp
	[44722]="0:0:1:20:FoodDrink::1:0:", -- Aged Yolk
	[44723]="120000:15:3:1:Companion::1:0:31916,32763", -- Nurtured Penguin Egg
	[44724]="0:12:1:10:::1:0:", -- Everfrost Chip
	[44725]="0:12:1:1:::1:0:", -- Everfrost Chip
	[44728]="0:0:0:1:Potion::1:0:", -- Endless Rejuvenation Potion
	[44729]="0:12:0:10:::1:0:", -- Everfrost Powder
	[44731]="0:4:2:1:OffHandFrill::1:0:", -- Bouquet of Ebon Roses
	[44732]="0:4:3:1:Leather::1:0:", -- Azure Dragonleather Helm
	[44734]="0:2:3:1:OneHandMace::1:0:", -- Hammer of Quiet Mourning
	[44735]="0:2:3:1:OneHandAxe::1:0:", -- Crescent of Brooding Fury
	[44736]="0:2:3:1:OneHandSword::1:0:", -- Sword of Heartwrenching Slaughter
	[44737]="500005:4:1:1:Miscellaneous::1:0:32638", -- Draenic Silk Robes
	[44738]="0:15:3:1:Companion::1:0:", -- Kirin Tor Familiar
	[44739]="0:0:1:5:EnhPerm::1:0:", -- Diamond-cut Refractor Scope
	[44740]="0:4:3:1:Leather::1:0:", -- Mechanized Snow Goggles
	[44741]="0:4:3:1:Mail::1:0:", -- Mechanized Snow Goggles
	[44742]="0:4:3:1:Plate::1:0:", -- Mechanized Snow Goggles
	[44745]="0:2:3:1:OneHandSword::1:0:", -- Blade of the Empty Void
	[44746]="0:2:3:1:Dagger::1:0:", -- Knife of the Tarnished Soul
	[44747]="0:2:3:1:OneHandMace::1:0:", -- Hammer of Wrenching Change
	[44748]="0:2:3:1:Stave::1:0:", -- Stave of Youthful Sorrow
	[44749]="0:0:1:20:FoodDrink::1:0:", -- Salted Yeti Cheese
	[44750]="0:0:1:20:FoodDrink::1:0:", -- Mountain Water
	[44751]="0:0:1:1:Consumable::1:0:", -- Hyldnir Spoils
	[44752]="0:15:0:20:Junk::1:0:", -- Coarse Bear Tail
	[44753]="0:15:0:20:Junk::1:0:", -- Vicious Incisors
	[44754]="0:15:0:20:Junk::1:0:", -- Severed Boar Tusk
	[44756]="0:15:0:10:Junk::1:0:", -- Coagulated Slime
	[44757]="0:15:0:5:Junk::1:0:", -- Stretched Segments
	[44758]="0:15:0:20:Junk::1:0:", -- Icy Spinneret
	[44759]="0:15:0:20:Junk::1:0:", -- Acid-Drenched Fangs
	[44762]="0:15:0:20:Junk::1:0:", -- Fat-Stained Fur
	[44763]="0:15:0:20:Junk::1:0:", -- Chunky Horn
	[44764]="0:15:0:20:Junk::1:0:", -- Wiry Tail Hair
	[44765]="0:15:0:20:Junk::1:0:", -- Dented Hoof
	[44766]="0:15:0:10:Junk::1:0:", -- Slime-Drenched Scale
	[44767]="0:15:0:5:Junk::1:0:", -- Gelid Nerve Fluid
	[44768]="0:15:0:20:Junk::1:0:", -- Bristly Tail Hair
	[44769]="0:15:0:20:Junk::1:0:", -- Split Hoof
	[44770]="0:15:0:20:Junk::1:0:", -- Rent Carapace
	[44771]="0:15:0:20:Junk::1:0:", -- Spiked Leg
	[44772]="0:15:0:20:Junk::1:0:", -- Stinking Fur
	[44773]="0:15:0:20:Junk::1:0:", -- Pearly Horn
	[44774]="0:15:0:20:Junk::1:0:", -- Ice-Piercing Thorn
	[44775]="0:15:0:20:Junk::1:0:", -- Revolting Flower
	[44776]="0:15:0:20:Junk::1:0:", -- Translucent Scale
	[44777]="0:15:0:5:Junk::1:0:", -- Spiral Fang
	[44778]="0:15:0:1:Junk::1:0:", -- Hefty Barrel
	[44779]="0:15:0:5:Junk::1:0:", -- Swatch of Gorilla Hair
	[44780]="0:15:0:10:Junk::1:0:", -- Sharpened Raptor Talon
	[44781]="0:15:0:10:Junk::1:0:", -- Sparkly Raptor War Feather
	[44782]="0:15:0:10:Junk::1:0:", -- Bent Raptor Talon
	[44783]="0:15:0:10:Junk::1:0:", -- Blood-Soaked Raptor War Feather
	[44784]="0:12:1:1:::1:0:", -- Cultist Acolyte's Hood
	[44785]="0:4:1:1:Miscellaneous::1:0:", -- Pilgrim's Dress
	[44788]="0:4:1:1:Miscellaneous::1:0:", -- Pilgrim's Boots
	[44789]="0:12:1:1:::1:0:", -- Crusader Bridenbrad's Tabard
	[44790]="0:12:1:3:::1:0:", -- Emerald Acorn
	[44791]="0:0:1:20:FoodDrink::1:0:", -- Noblegarden Chocolate
	[44792]="0:0:1:1:Consumable::1:0:32836,32837", -- Blossoming Branch
	[44793]="0:9:3:1:Book::1:0:32836,32837", -- Tome of Polymorph: Rabbit
	[44794]="0:15:3:1:Companion::1:0:32836,32837", -- Spring Rabbit's Foot
	[44800]="0:4:1:1:Miscellaneous::1:0:32836,32837", -- Spring Robes
	[44802]="0:4:1:1:OffHandFrill::1:0:", -- Egg Basket
	[44803]="0:4:1:1:Miscellaneous::1:0:32836,32837", -- Spring Circlet
	[44806]="0:0:1:20:Consumable::1:0:", -- Brightly Colored Shell Fragment
	[44808]="0:12:1:10:::1:0:", -- Imbued Horde Armor
	[44809]="0:12:1:12:::1:0:", -- Horde Herb Pouch
	[44810]="0:15:3:1:Companion::1:0:", -- Turkey Cage
	[44812]="0:0:1:20:Consumable::1:0:", -- Turkey Shooter
	[44815]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracers - Greater Assault
	[44817]="0:0:2:1:Consumable::1:0:", -- The Mischief Maker
	[44818]="0:0:1:20:Consumable::1:0:32836,32837", -- Noblegarden Egg
	[44819]="0:15:1:1:Companion::1:0:", -- Baby Blizzard Bear
	[44820]="15000:15:1:1:Companion::1:0:28951", -- Red Ribbon Pet Leash
	[44822]="500000:15:1:1:Companion::1:0:28951", -- Albino Snake
	[44834]="0:7:1:20:Meat:185:1:0:", -- Wild Turkey
	[44835]="10:7:1:20:Other:185:5:0:34645,34681,34682,34683,34684,34685,34783,34787,35337,35338,35340,35341,35342,35343", -- Autumnal Herbs
	[44836]="0:0:1:20:FoodDrink::1:0:", -- Pumpkin Pie
	[44837]="0:0:1:20:FoodDrink::1:0:", -- Spice Bread Stuffing
	[44838]="0:0:1:20:FoodDrink::1:0:", -- Slow-Roasted Turkey
	[44839]="0:0:1:20:FoodDrink::1:0:", -- Candied Sweet Potato
	[44840]="0:0:1:20:FoodDrink::1:0:", -- Cranberry Chutney
	[44841]="0:15:3:1:Companion::1:0:", -- Little Fawn's Salt Lick
	[44842]="0:15:4:1:FlyingMount::1:0:", -- Red Dragonhawk Mount
	[44843]="0:15:4:1:FlyingMount::1:0:", -- Blue Dragonhawk Mount
	[44844]="0:15:1:1:CombatPet::1:0:", -- Turkey Caller
	[44849]="7500:0:2:1:Consumable::1:0:29478,29716", -- Tiny Green Ragdoll
	[44852]="0:7:1:20:Other::1:0:", -- Cornmeal
	[44853]="25:7:1:20:Other:185:5:0:34645,34681,34682,34683,34684,34685,34783,34787,35337,35338,35340,35341,35342,35343", -- Honey
	[44854]="25:0:1:20:FoodDrink:185:5:0:34645,35340", -- Tangy Wetland Cranberries
	[44855]="25:0:1:20:FoodDrink:185:5:0:34681,35338", -- Teldrassil Sweet Potato
	[44858]="0:9:1:1:Cooking::1:0:", -- Recipe: Cranberry Chutney
	[44859]="0:9:1:1:Cooking::1:0:", -- Recipe: Candied Sweet Potato
	[44860]="0:9:1:1:Cooking::1:0:", -- Recipe: Spice Bread Stuffing
	[44861]="0:9:1:1:Cooking::1:0:", -- Recipe: Slow-Roasted Turkey
	[44862]="0:9:1:1:Cooking::1:0:", -- Recipe: Pumpkin Pie
	[44870]="0:4:4:1:Trinket::1:0:", -- Oracle Talisman of Ablution
	[44890]="0:12:1:1:::1:0:", -- To'kini's Blowgun
	[44891]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Boots of Dominance
	[44892]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Boots of Salvation
	[44893]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Boots of Triumph
	[44894]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Greaves of Salvation
	[44895]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Greaves of Triumph
	[44896]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Sabatons of Dominance
	[44897]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Sabatons of Salvation
	[44898]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Sabatons of Triumph
	[44899]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Slippers of Dominance
	[44900]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Slippers of Salvation
	[44901]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Plate Headcover of Salvation
	[44902]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Plate Helm of Triumph
	[44903]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Chain Helm of Triumph
	[44904]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Mail Helm of Dominance
	[44905]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Ringmail Helm of Salvation
	[44906]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Leather Helm of Salvation
	[44907]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Leather Helm of Dominance
	[44908]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Leather Helm of Triumph
	[44909]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Hood of Salvation
	[44910]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Hood of Dominance
	[44912]="0:4:4:1:Trinket::1:0:32294,32296", -- Flow of Knowledge
	[44914]="0:4:4:1:Trinket::1:0:32294,32296", -- Anvil of Titans
	[44916]="0:9:2:1:Tailoring::1:0:15909", -- Pattern: Festival Dress
	[44917]="0:9:2:1:Tailoring::1:0:15909", -- Pattern: Festival Suit
	[44918]="0:9:2:1:Engineering::1:0:15909", -- Schematic: Cluster Launcher
	[44919]="0:9:2:1:Engineering::1:0:15909", -- Schematic: Firework Launcher
	[44920]="0:16:1:20:Mage::1:0:", -- Glyph of Blast Wave
	[44921]="0:12:1:20:::1:0:", -- Gundrak Raptor Egg
	[44922]="0:16:1:20:Druid::1:0:", -- Glyph of Typhoon
	[44923]="0:16:1:20:Shaman::1:0:", -- Glyph of Thunderstorm
	[44928]="0:16:1:20:Druid::1:0:", -- Glyph of Focus
	[44930]="0:4:4:1:Leather::1:0:", -- Windripper Boots
	[44931]="0:4:4:1:Leather::1:0:", -- Windripper Leggings
	[44932]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Windripper Boots
	[44933]="0:9:4:1:Leatherworking::1:0:32515", -- Pattern: Windripper Leggings
	[44934]="85000000:4:4:1:Ring::1:0:32172", -- Loop of the Kirin Tor
	[44935]="85000000:4:4:1:Ring::1:0:32172", -- Ring of the Kirin Tor
	[44936]="0:0:3:20:EnhPerm::1:0:", -- Titanium Plating
	[44937]="150000:9:3:1:Blacksmithing::1:0:32564,32773", -- Plans: Titanium Plating
	[44938]="150000:9:3:1:Blacksmithing::1:0:32565,32774", -- Plans: Titanium Plating
	[44939]="0:0:1:20:Flask::1:0:", -- Lesser Flask of Resistance
	[44940]="16000:0:1:20:FoodDrink::5:0:14845", -- Corn-Breaded Sausage
	[44941]="8500:0:1:20:FoodDrink::5:0:14844", -- Fresh-Squeezed Limeade
	[44943]="0:0:3:1:Consumable::1:0:", -- Icy Prism
	[44944]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Bracer - Major Stamina
	[44947]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Bracer - Major Stamina
	[44949]="0:4:4:1:Plate::1:0:", -- Unbreakable Healing Amplifiers
	[44950]="0:12:1:1:::1:0:", -- Raelorasz' Spark
	[44951]="0:7:1:1:Explosive::1:0:", -- Box of Bombs
	[44953]="0:0:1:20:FoodDrink::1:0:", -- Worg Tartare
	[44954]="0:9:2:1:Cooking::1:0:31031,31032,33595", -- Recipe: Worg Tartare
	[44955]="0:16:1:20:Mage::1:0:", -- Glyph of Arcane Blast
	[44956]="0:9:3:1:Book::1:0:", -- Goblin's Guide to Elementium
	[44957]="0:0:4:1:EnhPerm::1:0:12781,12793", -- Greater Inscription of the Gladiator
	[44958]="0:7:1:20:Other:171,333:1:0:", -- Ethereal Oil
	[44963]="0:0:4:20:EnhPerm::1:0:", -- Earthen Leg Armor
	[44965]="0:15:3:1:Companion::1:0:33653", -- Teldrassil Sproutling
	[44970]="0:15:3:1:Companion::1:0:33310", -- Dun Morogh Cub
	[44971]="0:15:3:1:Companion::1:0:33555", -- Tirisfal Batling
	[44973]="0:15:3:1:Companion::1:0:33553", -- Durotar Scorpion
	[44974]="0:15:3:1:Companion::1:0:33307", -- Elwynn Lamb
	[44977]="800:9:1:1:Cooking::1:0:3392,3443", -- Recipe: Dig Rat Stew
	[44978]="0:12:1:1:::1:0:", -- Blade of Drak'Mar
	[44980]="0:15:3:1:Companion::1:0:33556", -- Mulgore Hatchling
	[44981]="0:12:1:1:::1:0:", -- Ashwood Brand
	[44982]="0:15:3:1:Companion::1:0:33557", -- Enchanted Broom
	[44983]="0:15:3:1:Companion::1:0:", -- Strand Crawler
	[44984]="0:15:3:1:Companion::1:0:33657", -- Ammen Vale Lashling
	[44986]="0:12:1:1:::1:0:", -- Warts-B-Gone Lip Balm
	[44987]="0:15:1:200:Junk::1:0:", -- Valiant's Seal
	[44990]="0:10:1::Currency::1:0:", -- Champion's Seal
	[44998]="0:15:3:1:Companion::1:0:", -- Argent Squire
	[45000]="0:12:1:5:::1:0:", -- Winter Hyacinth
	[45002]="0:15:3:1:Companion::1:0:33650", -- Mechanopeep
	[45003]="0:12:1:1:::1:0:", -- Winter's Edge
	[45005]="0:12:1:1:::1:0:", -- Everburning Ember
	[45006]="0:0:1:20:Flask::1:0:", -- Jillian's Tonic of Endless Rage
	[45007]="0:0:1:20:Flask::1:0:", -- Jillian's Tonic of Pure Mojo
	[45008]="0:0:1:20:Flask::1:0:", -- Jillian's Tonic of Stoneblood
	[45009]="0:0:1:20:Flask::1:0:", -- Jillian's Tonic of the Frost Wyrm
	[45011]="0:0:1:1:Consumable::1:0:33307", -- Stormwind Banner
	[45013]="0:0:1:1:Consumable::1:0:33556", -- Thunder Bluff Banner
	[45014]="0:0:1:1:Consumable::1:0:33553", -- Orgrimmar Banner
	[45015]="0:0:1:1:Consumable::1:0:33554", -- Sen'jin Banner
	[45016]="0:0:1:1:Consumable::1:0:33555", -- Undercity Banner
	[45017]="0:0:1:1:Consumable::1:0:33557", -- Silvermoon City Banner
	[45018]="0:0:1:1:Consumable::1:0:33310", -- Ironforge Banner
	[45019]="0:0:1:1:Consumable::1:0:33650", -- Gnomeregan Banner
	[45020]="0:0:1:1:Consumable::1:0:33657", -- Exodar Banner
	[45021]="0:0:1:1:Consumable::1:0:33653", -- Darnassus Banner
	[45022]="0:15:3:1:Companion::1:0:", -- Argent Gruntling
	[45037]="0:4:4:1:Shirt::1:0:", -- Epic Purple Shirt
	[45038]="0:0:5:30:Consumable::1:0:", -- Fragment of Val'anyr
	[45039]="0:12:5:1:::1:0:", -- Shattered Fragments of Val'anyr
	[45045]="0:12:1:20:::1:0:", -- Rough Hewn Plank
	[45046]="0:12:1:1:::1:0:", -- Lumberjack's Axe
	[45047]="0:15:3:250:CombatPet::1:0:", -- Sandbox Tiger
	[45050]="0:9:2:1:Enchanting::1:0:", -- Formula: Smoking Heart of the Mountain
	[45052]="0:4:2:1:Leather::1:0:", -- Gruffscale Leggings
	[45054]="0:3:2:20:GemPrismatic::1:0:", -- Prismatic Black Diamond
	[45056]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Staff - Greater Spellpower
	[45057]="2500000:15:3:1:Companion::1:0:29478,29716", -- Wind-Up Train Wrecker
	[45058]="0:12:1:1:::1:0:", -- Dusty Journal
	[45059]="0:9:3:1:Enchanting::1:0:32514", -- Formula: Enchant Staff - Greater Spellpower
	[45060]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Staff - Spellpower
	[45061]="0:2:0:1:Miscellaneous::1:0:", -- Foam Sword
	[45062]="0:12:1:1:::1:0:", -- Dusty Journal
	[45063]="0:0:3:1:Consumable::1:0:", -- Foam Sword Rack
	[45064]="0:12:1:1:::1:0:", -- Seer's Crystal
	[45067]="0:4:1:1:OffHandFrill::1:0:", -- Egg Basket
	[45070]="0:12:1:1:::1:0:", -- Seer's Crystal
	[45072]="0:15:1:1:Junk::1:0:", -- Brightly Colored Egg
	[45073]="0:2:1:1:Miscellaneous::1:0:32836,32837", -- Spring Flowers
	[45074]="0:2:4:1:TwoHandSword::1:0:33307,33310,33650,33653,33657", -- Claymore of the Prophet
	[45075]="0:2:4:1:OneHandMace::1:0:33307,33310,33650,33653,33657", -- Ironforge Smasher
	[45076]="0:2:4:1:OneHandAxe::1:0:33307,33310,33650,33653,33657", -- Teldrassil Protector
	[45077]="0:2:4:1:Dagger::1:0:33307,33310,33650,33653,33657", -- Dagger of the Rising Moon
	[45078]="0:2:4:1:Dagger::1:0:33307,33310,33650,33653,33657", -- Dagger of Lunar Purity
	[45080]="0:12:1:1:::1:0:", -- Large Femur
	[45082]="0:12:1:1:::1:0:", -- Murderer's Toolkit
	[45083]="0:12:1:1:::1:0:", -- Enchanted Bridle
	[45085]="0:2:4:1:Dagger::1:0:", -- Titansteel Spellblade
	[45086]="0:2:4:1:Thrown::1:0:", -- Rising Sun
	[45087]="0:7:3:20:Other:164,165,197:1:0:33963,33964", -- Runed Orb
	[45088]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Belt of the Titans
	[45089]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Battlelord's Plate Boots
	[45090]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Plate Girdle of Righteousness
	[45091]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Treads of Destiny
	[45092]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Indestructible Plate Girdle
	[45093]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Spiked Deathdealers
	[45094]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Belt of Dragons
	[45095]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Boots of Living Scale
	[45096]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Blue Belt of Chaos
	[45097]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Lightning Grounded Boots
	[45098]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Death-warmed Belt
	[45099]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Footpads of Silence
	[45100]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Belt of Arctic Life
	[45101]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Boots of Wintry Endurance
	[45102]="0:9:4:1:Tailoring::1:0:", -- Pattern: Sash of Ancient Power
	[45103]="0:9:4:1:Tailoring::1:0:", -- Pattern: Spellslinger's Slippers
	[45104]="0:9:4:1:Tailoring::1:0:", -- Pattern: Cord of the White Dawn
	[45105]="0:9:4:1:Tailoring::1:0:", -- Pattern: Savior's Slippers
	[45106]="0:4:4:1:Ring::1:0:", -- Strength of the Automaton
	[45107]="0:4:4:1:Plate::1:0:", -- Iron Riveted War Helm
	[45108]="0:4:4:1:Leather::1:0:", -- Mechanist's Bindings
	[45109]="0:4:4:1:Mail::1:0:", -- Gloves of the Fiery Behemoth
	[45110]="0:2:4:1:OneHandSword::1:0:", -- Titanguard
	[45111]="0:4:4:1:Plate::1:0:", -- Mimiron's Inferno Couplings
	[45112]="0:4:4:1:Ring::1:0:", -- The Leviathan's Coil
	[45113]="0:4:4:1:Ring::1:0:", -- Glowing Ring of Reclamation
	[45114]="0:4:4:1:Totem::1:0:33963,33964", -- Steamcaller's Totem
	[45115]="0:4:4:1:OffHandFrill::1:0:", -- Leviathan Fueling Manual
	[45116]="0:4:4:1:Amulet::1:0:", -- Freya's Choker of Warding
	[45117]="0:4:4:1:Cloth::1:0:", -- Constructor's Handwraps
	[45118]="0:4:4:1:Mail::1:0:", -- Steamworker's Goggles
	[45119]="0:4:4:1:Cloth::1:0:", -- Embrace of the Leviathan
	[45121]="0:12:1:1:::1:0:", -- Stolen Tournament Invitation
	[45122]="0:12:1:1:::1:0:", -- Black Knight's Orders
	[45125]="0:15:4:1:Mount::1:0:33307", -- Stormwind Steed
	[45127]="0:12:2:3:::1:0:", -- Mark of the Valiant
	[45128]="0:2:4:1:Stave::1:0:33307,33310,33650,33653,33657", -- Silvery Sylvan Stave
	[45129]="0:2:4:1:OneHandSword::1:0:33307,33310,33650,33653,33657", -- Gnomeregan Bonechopper
	[45130]="0:2:4:1:Gun::1:0:33307,33310,33650,33653,33657", -- Blunderbuss of Khaz Modan
	[45131]="0:4:3:1:Trinket::1:0:33307,33310,33650,33653,33657", -- Jouster's Fury
	[45132]="0:2:4:1:FistWeapon::1:0:", -- Golden Saronite Dragon
	[45133]="0:4:4:1:Amulet::1:0:", -- Pendant of Fiery Havoc
	[45134]="0:4:4:1:Plate::1:0:", -- Plated Leggings of Ruination
	[45135]="0:4:4:1:Cloth::1:0:", -- Boots of Fiery Resolution
	[45136]="0:4:4:1:Leather::1:0:", -- Shoulderpads of Dormant Energies
	[45137]="0:2:4:1:Gun::1:0:", -- Veranus' Bane
	[45138]="0:4:4:1:Cloak::1:0:", -- Drape of the Drakerider
	[45139]="0:4:4:1:Plate::1:0:", -- Dragonslayer's Brace
	[45140]="0:4:4:1:Plate::1:0:", -- Razorscale Shoulderguards
	[45141]="0:4:4:1:Leather::1:0:", -- Proto-hide Leggings
	[45142]="0:2:4:1:OneHandSword::1:0:", -- Remorse
	[45143]="0:4:4:1:Mail::1:0:", -- Saronite Mesh Legguards
	[45144]="0:4:4:1:Sigil::1:0:33963,33964", -- Sigil of Deflection
	[45145]="0:4:4:1:Libram::1:0:33963,33964", -- Libram of the Sacred Shield
	[45146]="0:4:4:1:Cloth::1:0:", -- Shackles of the Odalisque
	[45147]="0:2:4:1:OneHandMace::1:0:", -- Guiding Star
	[45148]="0:4:4:1:Trinket::1:0:", -- Living Flame
	[45149]="0:4:4:1:Leather::1:0:", -- Bracers of the Broodmother
	[45150]="0:4:4:1:Cloth::1:0:", -- Collar of the Wyrmhunter
	[45151]="0:4:4:1:Mail::1:0:", -- Belt of the Fallen Wyrm
	[45152]="0:4:3:1:Amulet::1:0:33307,33310,33650,33653,33657", -- Pendant of Azure Dreams
	[45153]="0:4:3:1:Amulet::1:0:33307,33310,33650,33653,33657", -- Susurrating Shell Necklace
	[45154]="0:4:3:1:Amulet::1:0:33307,33310,33650,33653,33657", -- Necklace of Valiant Blood
	[45155]="0:4:3:1:Amulet::1:0:33307,33310,33650,33653,33657", -- Choker of Spiral Focus
	[45156]="0:4:3:1:Cloth::1:0:33307,33310,33650,33653,33657", -- Sash of Shattering Hearts
	[45157]="0:4:4:1:Ring::1:0:", -- Cindershard Ring
	[45158]="0:4:4:1:Trinket::1:0:", -- Heart of Iron
	[45159]="0:4:3:1:Leather::1:0:33307,33310,33650,33653,33657", -- Treads of Nimble Evasion
	[45160]="0:4:3:1:Plate::1:0:33307,33310,33650,33653,33657", -- Girdle of Valorous Defeat
	[45161]="0:4:4:1:Plate::1:0:", -- Girdle of Embers
	[45162]="0:4:4:1:Leather::1:0:", -- Flamestalker Boots
	[45163]="0:4:3:1:Plate::1:0:33307,33310,33650,33653,33657", -- Stanchions of Unseatable Furor
	[45164]="0:4:4:1:Mail::1:0:", -- Helm of the Furnace Master
	[45165]="0:2:4:1:TwoHandAxe::1:0:", -- Worldcarver
	[45166]="0:4:4:1:Plate::1:0:", -- Charred Saronite Greaves
	[45167]="0:4:4:1:Plate::1:0:", -- Lifeforge Breastplate
	[45168]="0:4:4:1:Ring::1:0:", -- Pyrelight Circle
	[45169]="0:4:4:1:Totem::1:0:33963,33964", -- Totem of the Dancing Flame
	[45170]="0:2:4:1:Wand::1:0:", -- Scepter of Creation
	[45171]="0:2:4:1:Stave::1:0:", -- Intensity
	[45176]="0:2:0:1:Miscellaneous::1:0:", -- Foam Sword
	[45177]="0:2:0:1:Miscellaneous::1:0:", -- Foam Sword
	[45178]="0:2:0:1:Miscellaneous::1:0:", -- Foam Sword
	[45179]="0:2:0:1:Miscellaneous::1:0:", -- Foam Sword
	[45180]="0:15:3:1:Companion::1:0:", -- Murkimus' Little Spear
	[45181]="0:4:3:1:Leather::1:0:33307,33310,33650,33653,33657", -- Wrap of the Everliving Tree
	[45182]="0:4:3:1:Plate::1:0:33307,33310,33650,33653,33657", -- Gauntlets of Shattered Pride
	[45183]="0:4:3:1:Mail::1:0:33307,33310,33650,33653,33657", -- Treads of the Glorious Spirit
	[45184]="0:4:3:1:Mail::1:0:33307,33310,33650,33653,33657", -- Cinch of Bonded Servitude
	[45185]="0:4:4:1:Leather::1:0:", -- Flamewrought Cinch
	[45186]="0:4:4:1:Cloth::1:0:", -- Soot-Covered Mantle
	[45187]="0:4:4:1:Mail::1:0:", -- Wristguards of the Firetender
	[45188]="0:15:0:20:Junk::1:0:", -- Withered Kelp
	[45189]="0:15:0:20:Junk::1:0:", -- Torn Sail
	[45190]="0:15:0:20:Junk::1:0:", -- Driftwood
	[45191]="0:15:0:20:Junk::1:0:", -- Empty Clam
	[45192]="0:12:1:20:::1:0:", -- Aspirant's Seal
	[45193]="0:4:4:1:Amulet::1:0:", -- Insurmountable Fervor
	[45194]="0:15:0:20:Junk::1:0:", -- Tangled Fishing Line
	[45195]="0:15:0:20:Junk::1:0:", -- Empty Rum Bottle
	[45196]="0:15:0:20:Junk::1:0:", -- Tattered Cloth
	[45197]="0:15:0:20:Junk::1:0:", -- Tree Branch
	[45198]="0:15:0:20:Junk::1:0:", -- Weeds
	[45199]="0:15:0:20:Junk::1:0:", -- Old Boot
	[45200]="0:15:0:20:Junk::1:0:", -- Sickly Fish
	[45201]="0:15:0:1:Junk::1:0:", -- Rock
	[45202]="0:15:0:20:Junk::1:0:", -- Water Snail
	[45203]="0:2:4:1:OneHandMace::1:0:33553,33554,33555,33556,33557", -- Grimhorn Crusher
	[45204]="0:2:4:1:OneHandAxe::1:0:33553,33554,33555,33556,33557", -- Axe of the Sen'jin Protector
	[45205]="0:2:4:1:TwoHandSword::1:0:33553,33554,33555,33556,33557", -- Greatsword of the Sin'dorei
	[45206]="0:4:3:1:Amulet::1:0:33553,33554,33555,33556,33557", -- Choker of Feral Fury
	[45207]="0:4:3:1:Amulet::1:0:33553,33554,33555,33556,33557", -- Necklace of Stolen Skulls
	[45208]="0:2:4:1:OneHandSword::1:0:33553,33554,33555,33556,33557", -- Blade of the Keening Banshee
	[45209]="0:4:3:1:Cloth::1:0:33553,33554,33555,33556,33557", -- Sash of Trumpted Pride
	[45210]="0:2:4:1:Gun::1:0:33553,33554,33555,33556,33557", -- Sen'jin Beakblade Longrifle
	[45211]="0:4:3:1:Leather::1:0:33553,33554,33555,33556,33557", -- Waistguard of Equine Fury
	[45212]="0:2:4:1:Stave::1:0:33553,33554,33555,33556,33557", -- Staff of Feral Furies
	[45213]="0:4:3:1:Amulet::1:0:33553,33554,33555,33556,33557", -- Pendant of Emerald Crusader
	[45214]="0:2:4:1:Dagger::1:0:33553,33554,33555,33556,33557", -- Scalpel of the Royal Apothecary
	[45215]="0:4:3:1:Mail::1:0:33553,33554,33555,33556,33557", -- Links of Unquenched Savagery
	[45216]="0:4:3:1:Plate::1:0:33553,33554,33555,33556,33557", -- Gauntlets of Mending Touch
	[45217]="0:4:3:1:Plate::1:0:33553,33554,33555,33556,33557", -- Clinch of Savage Fury
	[45218]="0:4:3:1:Plate::1:0:33553,33554,33555,33556,33557", -- Blood-Caked Stompers
	[45219]="0:4:3:1:Trinket::1:0:33553,33554,33555,33556,33557", -- Jouster's Fury
	[45220]="0:4:3:1:Leather::1:0:33553,33554,33555,33556,33557", -- Treads of the Earnest Squire
	[45221]="0:4:3:1:Mail::1:0:33553,33554,33555,33556,33557", -- Treads of Whispering Dreams
	[45222]="0:2:4:1:Dagger::1:0:33553,33554,33555,33556,33557", -- Spinal Destroyer
	[45223]="0:4:3:1:Amulet::1:0:33553,33554,33555,33556,33557", -- Razor's Edge Pendant
	[45224]="0:4:4:1:Cloak::1:0:", -- Drape of the Lithe
	[45225]="0:4:4:1:Plate::1:0:", -- Steelbreaker's Embrace
	[45226]="0:4:4:1:Plate::1:0:", -- Ancient Iron Heaume
	[45227]="0:4:4:1:Mail::1:0:", -- Iron-studded Mantle
	[45228]="0:4:4:1:Plate::1:0:", -- Handguards of the Enclave
	[45232]="0:4:4:1:Leather::1:0:", -- Runed Ironhide Boots
	[45233]="0:2:4:1:TwoHandSword::1:0:", -- Stormrune Edge
	[45234]="0:2:4:1:Stave::1:0:", -- Rapture
	[45235]="0:4:4:1:Ring::1:0:", -- Radiant Seal
	[45236]="0:4:4:1:Amulet::1:0:", -- Unblinking Eye
	[45237]="0:4:4:1:Leather::1:0:", -- Phaelia's Vestments of the Sprouting Seed
	[45238]="0:4:4:1:Cloth::1:0:", -- Overload Legwraps
	[45239]="0:4:4:1:Mail::1:0:", -- Runeshaper's Gloves
	[45240]="0:4:4:1:Cloth::1:0:", -- Raiments of the Iron Council
	[45241]="0:4:4:1:Plate::1:0:", -- Belt of Colossal Rage
	[45242]="0:4:4:1:Cloak::1:0:", -- Drape of Mortal Downfall
	[45243]="0:4:4:1:Amulet::1:0:", -- Sapphire Amulet of Renewal
	[45244]="0:4:4:1:Mail::1:0:", -- Greaves of Swift Vengeance
	[45245]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Intruder
	[45246]="0:2:4:1:Dagger::1:0:", -- Golem-Shard Sticker
	[45247]="0:4:4:1:Ring::1:0:", -- Signet of the Earthshaker
	[45248]="0:4:4:1:Plate::1:0:", -- Clockwork Legplates
	[45249]="0:4:4:1:Mail::1:0:", -- Brass-lined Boots
	[45250]="0:4:4:1:Ring::1:0:", -- Crazed Construct Ring
	[45251]="0:4:4:1:Plate::1:0:", -- Shoulderplates of the Deconstructor
	[45252]="0:4:4:1:Plate::1:0:", -- Horologist's Wristguards
	[45253]="0:4:4:1:Cloth::1:0:", -- Mantle of Wavering Calm
	[45254]="0:4:4:1:Sigil::1:0:33963,33964", -- Sigil of the Vengeful Heart
	[45255]="0:4:4:1:Totem::1:0:33963,33964", -- Thunderfall Totem
	[45256]="0:2:4:1:Stave::1:0:", -- Twisted Visage
	[45257]="0:2:4:1:Wand::1:0:", -- Quartz Crystal Wand
	[45258]="0:4:4:1:Cloth::1:0:", -- Sandals of Rash Temperament
	[45259]="0:4:4:1:Mail::1:0:", -- Quartz-studded Harness
	[45260]="0:4:4:1:Leather::1:0:", -- Boots of Hasty Revival
	[45261]="0:2:4:1:Gun::1:0:", -- Giant's Bane
	[45262]="0:4:4:1:Amulet::1:0:", -- Necklace of Unerring Mettle
	[45263]="0:4:4:1:Trinket::1:0:", -- Wrathstone
	[45264]="0:4:4:1:Plate::1:0:", -- Decimator's Armguards
	[45265]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Monolith
	[45266]="0:2:4:1:OneHandSword::1:0:", -- Malice
	[45267]="0:4:4:1:Plate::1:0:", -- Saronite Plated Legguards
	[45268]="0:4:4:1:Plate::1:0:", -- Gloves of the Pythonic Guardian
	[45269]="0:4:4:1:Plate::1:0:", -- Unfaltering Armguards
	[45270]="0:4:4:1:Idol::1:0:33963,33964", -- Idol of the Crying Wind
	[45271]="0:4:4:1:OffHandFrill::1:0:", -- Ironmender
	[45272]="0:4:4:1:Cloth::1:0:", -- Robes of the Umbral Brute
	[45273]="0:4:4:1:Cloth::1:0:", -- Handwraps of Plentiful Recovery
	[45274]="0:4:4:1:Mail::1:0:", -- Leggings of the Stoneweaver
	[45275]="0:4:4:1:Cloth::1:0:", -- Bracers of Unleashed Magic
	[45276]="0:0:1:5:Potion::1:0:", -- Jillian's Genius Juice
	[45277]="0:0:1:5:Potion::1:0:", -- Jillian's Savior Sauce
	[45278]="0:12:1:25:::1:0:", -- Small Stone Block
	[45279]="0:0:1:20:FoodDrink::1:0:", -- Jillian's Gourmet Fish Feast
	[45280]="0:4:4:1:Shirt::1:0:", -- Shirt of Uber
	[45281]="0:12:1:1:::1:0:", -- Goblin Chisel
	[45282]="0:2:4:1:TwoHandMace::1:0:", -- Ironsoul
	[45283]="0:4:4:1:Plate::1:0:", -- Flamewatch Armguards
	[45284]="0:2:4:1:FistWeapon::1:0:", -- Kinetic Ripper
	[45285]="0:4:4:1:Amulet::1:0:", -- Might of the Leviathan
	[45286]="0:4:4:1:Trinket::1:0:", -- Pyrite Infuser
	[45287]="0:2:4:1:OneHandSword::1:0:", -- Firesoul
	[45288]="0:4:4:1:Mail::1:0:", -- Firestrider Chestguard
	[45289]="0:4:4:1:Cloth::1:0:", -- Lifespark Visage
	[45291]="0:4:4:1:Cloth::1:0:", -- Combustion Bracers
	[45292]="0:4:4:1:Trinket::1:0:", -- Energy Siphon
	[45293]="0:4:4:1:Leather::1:0:", -- Handguards of Potent Cures
	[45294]="0:2:4:1:Wand::1:0:", -- Petrified Ivy Sprig
	[45295]="0:4:4:1:Plate::1:0:", -- Gilded Steel Legplates
	[45296]="0:2:4:1:Thrown::1:0:", -- Twirling Blades
	[45297]="0:4:4:1:Ring::1:0:", -- Shimmering Seal
	[45298]="0:2:4:1:OneHandSword::1:0:", -- Razorscale Talon
	[45299]="0:4:4:1:Plate::1:0:", -- Dragonsteel Faceplate
	[45300]="0:4:4:1:Mail::1:0:", -- Mantle of Fiery Vengeance
	[45301]="0:4:4:1:Mail::1:0:", -- Bracers of the Smothering Inferno
	[45302]="0:4:4:1:Leather::1:0:", -- Treads of the Invader
	[45303]="0:4:4:1:Ring::1:0:", -- Band of Draconic Guile
	[45304]="0:4:4:1:Plate::1:0:", -- Stormtempered Girdle
	[45305]="0:4:4:1:Plate::1:0:", -- Breastplate of the Afterlife
	[45306]="0:4:4:1:Cloth::1:0:", -- Binding of the Dragon Matriarch
	[45307]="0:4:4:1:Mail::1:0:", -- Ironscale Leggings
	[45308]="0:4:4:1:Trinket::1:0:", -- Eye of the Broodmother
	[45309]="0:2:4:1:Gun::1:0:", -- Rifle of the Platinum Guard
	[45310]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Iron Furnace
	[45311]="0:2:4:1:Polearm::1:0:", -- Relentless Edge
	[45312]="0:4:4:1:Leather::1:0:", -- Gloves of Smoldering Touch
	[45313]="0:4:4:1:Trinket::1:0:", -- Furnace Stone
	[45314]="0:4:4:1:OffHandFrill::1:0:", -- Igniter Rod
	[45315]="0:2:4:1:OneHandMace::1:0:", -- Stonerender
	[45316]="0:4:4:1:Mail::1:0:", -- Armbraces of the Vibrant Flame
	[45317]="0:4:4:1:Cloak::1:0:", -- Shawl of the Caretaker
	[45318]="0:4:4:1:Cloak::1:0:", -- Drape of Fuming Anger
	[45319]="0:4:4:1:Cloak::1:0:", -- Cloak of the Makers
	[45320]="0:4:4:1:Plate::1:0:", -- Shoulderplates of the Eternal
	[45321]="0:4:4:1:Plate::1:0:", -- Pauldrons of Tempered Will
	[45322]="0:4:4:1:Cloak::1:0:", -- Cloak of the Iron Council
	[45323]="0:12:1:1:::1:0:", -- Severed Arm
	[45324]="0:4:4:1:Leather::1:0:", -- Leggings of Swift Reflexes
	[45325]="0:4:4:1:Leather::1:0:", -- Gloves of the Stonereaper
	[45326]="0:4:4:1:Ring::1:0:", -- Platinum Band of the Aesir
	[45327]="0:2:4:1:Bow::1:0:", -- Siren's Cry
	[45328]="0:12:1:1:::1:0:", -- Bloated Monsterbelly
	[45329]="0:4:4:1:Mail::1:0:", -- Circlet of True Sight
	[45330]="0:4:4:1:Plate::1:0:", -- Greaves of Iron Intensity
	[45331]="0:2:4:1:OneHandSword::1:0:", -- Rune-Etched Nightblade
	[45332]="0:2:4:1:Dagger::1:0:", -- Stormtip
	[45333]="0:4:4:1:Mail::1:0:", -- Belt of the Iron Servant
	[45334]="0:4:4:1:Plate::1:0:", -- Unbreakable Chestguard
	[45335]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Chestguard
	[45336]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Faceguard
	[45337]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Handguards
	[45338]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Legguards
	[45339]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Pauldrons
	[45340]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Battleplate
	[45341]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Gauntlets
	[45342]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Helmet
	[45343]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Legplates
	[45344]="0:4:4:1:Plate::1:0:34252", -- Valorous Darkruned Shoulderplates
	[45345]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Handguards
	[45346]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Headpiece
	[45347]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Leggings
	[45348]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Robe
	[45349]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Spaulders
	[45351]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Gloves
	[45352]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Mantle
	[45353]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Trousers
	[45354]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Vestments
	[45355]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Handgrips
	[45356]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Headguard
	[45357]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Legguards
	[45358]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Raiments
	[45359]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Shoulderpads
	[45360]="0:4:4:1:Mail::1:0:29523", -- Valorous Scourgestalker Handguards
	[45361]="0:4:4:1:Mail::1:0:29523", -- Valorous Scourgestalker Headpiece
	[45362]="0:4:4:1:Mail::1:0:29523", -- Valorous Scourgestalker Legguards
	[45363]="0:4:4:1:Mail::1:0:29523", -- Valorous Scourgestalker Spaulders
	[45364]="0:4:4:1:Mail::1:0:29523", -- Valorous Scourgestalker Tunic
	[45365]="0:4:4:1:Cloth::1:0:28995", -- Valorous Kirin Tor Hood
	[45367]="0:4:4:1:Cloth::1:0:28995", -- Valorous Kirin Tor Leggings
	[45368]="0:4:4:1:Cloth::1:0:28995", -- Valorous Kirin Tor Tunic
	[45369]="0:4:4:1:Cloth::1:0:28995", -- Valorous Kirin Tor Shoulderpads
	[45370]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Gloves
	[45371]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Greaves
	[45372]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Headpiece
	[45373]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Spaulders
	[45374]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Tunic
	[45375]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Battleplate
	[45376]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Gauntlets
	[45377]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Helm
	[45378]="0:4:4:1:Leather::1:0:", -- Boots of the Petrified Forest
	[45379]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Legplates
	[45380]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Shoulderplates
	[45381]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Breastplate
	[45382]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Faceguard
	[45383]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Handguards
	[45384]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Legguards
	[45385]="0:4:4:1:Plate::1:0:34252", -- Valorous Aegis Shoulderguards
	[45386]="0:4:4:1:Cloth::1:0:28995", -- Valorous Cowl of Sanctification
	[45387]="0:4:4:1:Cloth::1:0:28995", -- Valorous Gloves of Sanctification
	[45388]="0:4:4:1:Cloth::1:0:28995", -- Valorous Leggings of Sanctification
	[45389]="0:4:4:1:Cloth::1:0:28995", -- Valorous Robe of Sanctification
	[45390]="0:4:4:1:Cloth::1:0:28995", -- Valorous Shoulderpads of Sanctification
	[45391]="0:4:4:1:Cloth::1:0:28995", -- Valorous Circlet of Sanctification
	[45392]="0:4:4:1:Cloth::1:0:28995", -- Valorous Handwraps of Sanctification
	[45393]="0:4:4:1:Cloth::1:0:28995", -- Valorous Mantle of Sanctification
	[45394]="0:4:4:1:Cloth::1:0:28995", -- Valorous Pants of Sanctification
	[45395]="0:4:4:1:Cloth::1:0:28995", -- Valorous Raiments of Sanctification
	[45396]="0:4:4:1:Leather::1:0:28992", -- Valorous Terrorblade Breastplate
	[45397]="0:4:4:1:Leather::1:0:28992", -- Valorous Terrorblade Gauntlets
	[45398]="0:4:4:1:Leather::1:0:28992", -- Valorous Terrorblade Helmet
	[45399]="0:4:4:1:Leather::1:0:28992", -- Valorous Terrorblade Legplates
	[45400]="0:4:4:1:Leather::1:0:28992", -- Valorous Terrorblade Pauldrons
	[45401]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Handguards
	[45402]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Headpiece
	[45403]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Legguards
	[45404]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Spaulders
	[45405]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Tunic
	[45406]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Gloves
	[45408]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Helm
	[45409]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Kilt
	[45410]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Shoulderpads
	[45411]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Hauberk
	[45412]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Faceguard
	[45413]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Chestguard
	[45414]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Grips
	[45415]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker Shoulderguards
	[45416]="0:4:4:1:Mail::1:0:29523", -- Valorous Worldbreaker War-Kilt
	[45417]="0:4:4:1:Cloth::1:0:28995", -- Valorous Deathbringer Hood
	[45418]="0:4:4:1:Ring::1:0:", -- Lady Maye's Sapphire Ring
	[45419]="0:4:4:1:Cloth::1:0:28995", -- Valorous Deathbringer Gloves
	[45420]="0:4:4:1:Cloth::1:0:28995", -- Valorous Deathbringer Leggings
	[45421]="0:4:4:1:Cloth::1:0:28995", -- Valorous Deathbringer Robe
	[45422]="0:4:4:1:Cloth::1:0:28995", -- Valorous Deathbringer Shoulderpads
	[45423]="0:4:4:1:Cloth::1:0:", -- Runetouch Wristwraps
	[45424]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Breastplate
	[45425]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Greathelm
	[45426]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Handguards
	[45427]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Legguards
	[45428]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Pauldrons
	[45429]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Battleplate
	[45430]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Gauntlets
	[45431]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Helmet
	[45432]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Legplates
	[45433]="0:4:4:1:Plate::1:0:34252", -- Valorous Siegebreaker Shoulderplates
	[45434]="0:4:4:1:Plate::1:0:", -- Greaves of the Rockmender
	[45435]="0:4:4:1:Cloth::1:0:", -- Cowl of the Absolute
	[45436]="0:4:4:1:Libram::1:0:33963,33964", -- Libram of the Resolute
	[45437]="0:2:4:1:OneHandSword::1:0:", -- Runescribed Blade
	[45438]="0:4:4:1:Ring::1:0:", -- Ring of the Faithful Servant
	[45439]="0:4:4:1:Leather::1:0:", -- Unwavering Stare
	[45440]="0:4:4:1:Mail::1:0:", -- Amice of the Stoic Watch
	[45441]="0:4:4:1:Cloth::1:0:", -- Sandals of the Ancient Keeper
	[45442]="222087:2:4:1:OneHandMace::1:0:", -- Sorthalis, Hammer of the Watchers
	[45443]="0:4:4:1:Amulet::1:0:", -- Charm of Meticulous Timing
	[45444]="0:4:4:1:Mail::1:0:", -- Gloves of the Steady Hand
	[45445]="0:4:4:1:Plate::1:0:", -- Breastplate of the Devoted
	[45446]="0:4:4:1:Cloth::1:0:", -- Grasps of Reason
	[45447]="0:4:4:1:Amulet::1:0:", -- Watchful Eye of Fate
	[45448]="0:2:4:1:Dagger::1:0:", -- Perilous Bite
	[45449]="0:2:4:1:FistWeapon::1:0:", -- The Masticator
	[45450]="0:4:4:1:Shield::1:0:", -- Northern Barrier
	[45451]="0:4:4:1:Ring::1:0:", -- Frozen Loop
	[45452]="0:4:4:1:Plate::1:0:", -- Frostplate Greaves
	[45453]="0:4:4:1:Leather::1:0:", -- Winter's Icy Embrace
	[45454]="0:4:4:1:Mail::1:0:", -- Frost-bound Chain Bracers
	[45455]="0:4:4:1:Leather::1:0:", -- Belt of the Crystal Tree
	[45456]="0:4:4:1:Ring::1:0:", -- Loop of the Agile
	[45457]="0:2:4:1:Stave::1:0:", -- Staff of Endless Winter
	[45458]="0:2:4:1:TwoHandAxe::1:0:", -- Stormedge
	[45459]="0:4:4:1:Amulet::1:0:", -- Frigid Strength of Hodir
	[45460]="0:4:4:1:Mail::1:0:", -- Bindings of Winter Gale
	[45461]="0:4:4:1:Cloak::1:0:", -- Drape of Icy Intent
	[45462]="0:4:4:1:Leather::1:0:", -- Gloves of the Frozen Glade
	[45463]="216672:2:4:1:OneHandMace::1:0:", -- Vulmir, the Northern Tempest
	[45464]="0:4:4:1:Cloth::1:0:", -- Cowl of Icy Breaths
	[45466]="0:4:4:1:Trinket::1:0:", -- Scale of Fates
	[45467]="0:4:4:1:Mail::1:0:", -- Belt of the Betrayed
	[45468]="0:4:4:1:Cloth::1:0:", -- Leggings of Lost Love
	[45469]="0:4:4:1:Ring::1:0:", -- Sif's Promise
	[45470]="0:4:4:1:Shield::1:0:", -- Wisdom's Hold
	[45471]="0:4:4:1:Ring::1:0:", -- Fate's Clutch
	[45472]="0:4:4:1:Plate::1:0:", -- Warhelm of the Champion
	[45473]="0:4:4:1:Leather::1:0:", -- Embrace of the Gladiator
	[45474]="0:4:4:1:Mail::1:0:", -- Pauldrons of the Combatant
	[45479]="0:2:4:1:Stave::1:0:", -- The Lifebinder
	[45480]="0:4:4:1:Amulet::1:0:", -- Nymph Heart Charm
	[45481]="0:4:4:1:Plate::1:0:", -- Gauntlets of Ruthless Reprisal
	[45482]="0:4:4:1:Leather::1:0:", -- Leggings of the Lifetender
	[45483]="0:4:4:1:Cloth::1:0:", -- Boots of the Servant
	[45484]="0:2:4:1:Dagger::1:0:", -- Bladetwister
	[45485]="0:4:4:1:Amulet::1:0:", -- Bronze Pendant of the Vanir
	[45486]="0:4:4:1:Cloak::1:0:", -- Drape of the Sullen Goddess
	[45487]="0:4:4:1:Plate::1:0:", -- Handguards of Revitalization
	[45488]="0:4:4:1:Cloth::1:0:", -- Leggings of the Enslaved Idol
	[45489]="0:2:4:1:FistWeapon::1:0:", -- Insanity's Grip
	[45490]="0:4:4:1:Trinket::1:0:", -- Pandora's Plea
	[45491]="0:4:4:1:Leather::1:0:", -- Waistguard of the Creator
	[45492]="0:4:4:1:Leather::1:0:", -- Malleable Steelweave Mantle
	[45493]="0:4:4:1:Cloak::1:0:", -- Asimov's Drape
	[45494]="0:2:4:1:FistWeapon::1:0:", -- Delirium's Touch
	[45495]="0:4:4:1:Ring::1:0:", -- Conductive Seal
	[45496]="0:4:4:1:Cloak::1:0:", -- Titanskin Cloak
	[45497]="0:4:4:1:Cloth::1:0:", -- Crown of Luminescence
	[45498]="293838:2:4:1:Polearm::1:0:", -- Lotrafen, Spear of the Damned
	[45500]="0:12:2:4:::1:0:", -- Mark of the Champion
	[45501]="0:4:4:1:Plate::1:0:", -- Boots of the Underdweller
	[45502]="0:4:4:1:Plate::1:0:", -- Helm of the Faceless
	[45503]="0:4:4:1:Ring::1:0:", -- Metallic Loop of the Sufferer
	[45504]="0:4:4:1:Mail::1:0:", -- Darkcore Leggings
	[45505]="0:4:4:1:Plate::1:0:", -- Belt of Clinging Hope
	[45506]="0:12:4:1:::1:0:", -- Archivum Data Disc
	[45507]="0:4:4:1:Trinket::1:0:", -- The General's Heart
	[45508]="0:4:4:1:Cloth::1:0:", -- Belt of the Darkspeaker
	[45509]="0:4:4:1:Idol::1:0:33963,33964", -- Idol of the Corruptor
	[45510]="0:4:4:1:Libram::1:0:33963,33964", -- Libram of Discord
	[45511]="0:2:4:1:Wand::1:0:", -- Scepter of Lost Souls
	[45512]="0:4:4:1:Leather::1:0:", -- Grips of the Unbroken
	[45513]="0:4:4:1:Mail::1:0:", -- Boots of the Forgotten Depths
	[45514]="0:4:4:1:Cloth::1:0:", -- Mantle of the Unknowing
	[45515]="0:4:4:1:Ring::1:0:", -- Ring of the Vacant Eye
	[45516]="300106:2:4:1:TwoHandSword::1:0:", -- Voldrethar, Dark Blade of Oblivion
	[45517]="0:4:4:1:Amulet::1:0:", -- Pendulum of Infinity
	[45518]="0:4:4:1:Trinket::1:0:", -- Flare of the Heavens
	[45519]="0:4:4:1:Leather::1:0:", -- Vestments of the Blind Denizen
	[45520]="0:4:4:1:Cloth::1:0:", -- Handwraps of the Vigilant
	[45521]="0:2:4:1:TwoHandMace::1:0:", -- Earthshaper
	[45522]="0:4:4:1:Trinket::1:0:", -- Blood of the Old God
	[45523]="0:4:4:1:Leather::1:0:", -- Garona's Guise
	[45524]="0:4:4:1:Mail::1:0:", -- Chestguard of Insidious Intent
	[45525]="0:4:4:1:Ring::1:0:", -- Godbane Signet
	[45527]="0:2:4:1:Dagger::1:0:", -- Soulscribe
	[45529]="0:4:4:1:Cloak::1:0:", -- Shawl of Haunted Memories
	[45530]="0:4:4:1:Ring::1:0:", -- Sanity's Bond
	[45531]="0:4:4:1:Mail::1:0:", -- Chestguard of the Fallen God
	[45532]="0:4:4:1:Cloth::1:0:", -- Cowl of Dark Whispers
	[45533]="0:2:4:1:Polearm::1:0:", -- Dark Edge of Depravity
	[45534]="0:4:4:1:Ring::1:0:", -- Seal of the Betrayed King
	[45535]="0:4:4:1:Trinket::1:0:", -- Show of Faith
	[45536]="0:4:4:1:Leather::1:0:", -- Legguards of Cunning Deception
	[45537]="0:4:4:1:Cloth::1:0:", -- Treads of the False Oracle
	[45538]="0:4:4:1:Amulet::1:0:", -- Titanstone Pendant
	[45539]="0:4:4:1:Amulet::1:0:", -- Pendant of Focused Energies
	[45540]="0:4:4:1:Ring::1:0:", -- Bladebearer's Signet
	[45541]="0:4:4:1:Cloak::1:0:", -- Shroud of Alteration
	[45542]="0:4:4:1:Plate::1:0:", -- Greaves of the Stonewarder
	[45543]="0:4:4:1:Mail::1:0:", -- Shoulders of Misfortune
	[45544]="0:4:4:1:Mail::1:0:", -- Leggings of the Tortured Earth
	[45547]="0:4:4:1:Leather::1:0:", -- Relic Hunter's Cord
	[45548]="0:4:4:1:Leather::1:0:", -- Belt of the Sleeper
	[45549]="0:4:4:1:Cloth::1:0:", -- Grips of Chaos
	[45550]="0:4:4:1:Plate::1:0:", -- Belt of the Titans
	[45551]="0:4:4:1:Plate::1:0:", -- Indestructible Plate Girdle
	[45552]="0:4:4:1:Plate::1:0:", -- Plate Girdle of Righteousness
	[45553]="0:4:4:1:Mail::1:0:", -- Belt of Dragons
	[45554]="0:4:4:1:Mail::1:0:", -- Blue Belt of Chaos
	[45555]="0:4:4:1:Leather::1:0:", -- Death-warmed Belt
	[45556]="0:4:4:1:Leather::1:0:", -- Belt of Arctic Life
	[45557]="0:4:4:1:Cloth::1:0:", -- Sash of Ancient Power
	[45558]="0:4:4:1:Cloth::1:0:", -- Cord of the White Dawn
	[45559]="0:4:4:1:Plate::1:0:", -- Battlelord's Plate Boots
	[45560]="0:4:4:1:Plate::1:0:", -- Spiked Deathdealers
	[45561]="0:4:4:1:Plate::1:0:", -- Treads of Destiny
	[45562]="0:4:4:1:Mail::1:0:", -- Boots of Living Scale
	[45563]="0:4:4:1:Mail::1:0:", -- Lightning Grounded Boots
	[45564]="0:4:4:1:Leather::1:0:", -- Footpads of Silence
	[45565]="0:4:4:1:Leather::1:0:", -- Boots of Wintry Endurance
	[45566]="0:4:4:1:Cloth::1:0:", -- Spellslinger's Slippers
	[45567]="0:4:4:1:Cloth::1:0:", -- Savior's Slippers
	[45570]="0:2:4:1:Crossbow::1:0:", -- Skyforge Crossbow
	[45574]="0:4:1:1:Tabard::1:0:33307", -- Stormwind Tabard
	[45577]="0:4:1:1:Tabard::1:0:33310", -- Ironforge Tabard
	[45578]="0:4:1:1:Tabard::1:0:33650", -- Gnomeregan Tabard
	[45579]="0:4:1:1:Tabard::1:0:33653", -- Darnassus Tabard
	[45580]="0:4:1:1:Tabard::1:0:33657", -- Exodar Tabard
	[45581]="0:4:1:1:Tabard::1:0:33553", -- Orgrimmar Tabard
	[45582]="0:4:1:1:Tabard::1:0:33554", -- Sen'jin Tabard
	[45583]="0:4:1:1:Tabard::1:0:33555", -- Undercity Tabard
	[45584]="0:4:1:1:Tabard::1:0:33556", -- Thunder Bluff Tabard
	[45585]="0:4:1:1:Tabard::1:0:33557", -- Silvermoon City Tabard
	[45586]="0:15:4:1:Mount::1:0:33310", -- Ironforge Ram
	[45587]="0:4:4:1:Shield::1:0:", -- Bulwark of Algalon
	[45588]="0:4:4:1:Cloak::1:0:", -- Drape of the Skyborn
	[45589]="0:15:4:1:Mount::1:0:33650", -- Gnomeregan Mechanostrider
	[45590]="0:15:4:1:Mount::1:0:33657", -- Exodar Elekk
	[45591]="0:15:4:1:Mount::1:0:33653", -- Darnassian Nightsaber
	[45592]="0:15:4:1:Mount::1:0:33556", -- Thunder Bluff Kodo
	[45593]="0:15:4:1:Mount::1:0:33554", -- Darkspear Raptor
	[45594]="0:4:4:1:Plate::1:0:", -- Legplates of the Endless Void
	[45595]="0:15:4:1:Mount::1:0:33553", -- Orgrimmar Wolf
	[45596]="0:15:4:1:Mount::1:0:33557", -- Silvermoon Hawkstrider
	[45597]="0:15:4:1:Mount::1:0:33555", -- Forsaken Warhorse
	[45599]="0:4:4:1:Plate::1:0:", -- Sabatons of Lifeless Night
	[45601]="0:16:1:20:Druid::1:0:", -- Glyph of Berserk
	[45602]="0:16:1:20:Druid::1:0:", -- Glyph of Wild Growth
	[45603]="0:16:1:20:Druid::1:0:", -- Glyph of Nourish
	[45604]="0:16:1:20:Druid::1:0:", -- Glyph of Savage Roar
	[45605]="0:2:4:1:Dagger::1:0:", -- Daschal's Bite
	[45606]="0:15:3:1:Companion::1:0:33554", -- Sen'jin Fetish
	[45607]="0:2:4:1:Dagger::1:0:", -- Fang of Oblivion
	[45608]="0:4:4:1:Ring::1:0:", -- Brann's Signet Ring
	[45609]="0:4:4:1:Trinket::1:0:", -- Comet's Trail
	[45610]="0:4:4:1:Mail::1:0:", -- Boundless Gaze
	[45611]="0:4:4:1:Leather::1:0:", -- Solar Bindings
	[45612]="0:2:4:1:OneHandMace::1:0:", -- Constellus
	[45613]="0:2:4:1:Stave::1:0:", -- Dreambinder
	[45614]="0:4:4:1:Ring::1:0:", -- Starshine Circle
	[45615]="0:4:4:1:Mail::1:0:", -- Planewalker Treads
	[45616]="0:4:4:1:Leather::1:0:", -- Star-beaded Clutch
	[45617]="0:4:4:1:OffHandFrill::1:0:", -- Cosmos
	[45618]="0:4:4:1:Cloak::1:0:", -- Sunglimmer Cloak
	[45619]="0:4:4:1:Cloth::1:0:", -- Starwatcher's Binding
	[45620]="0:2:4:1:Dagger::1:0:", -- Starshard Edge
	[45621]="0:0:1:20:Elixir::1:0:", -- Elixir of Minor Accuracy
	[45622]="0:16:1:20:Druid::1:0:", -- Glyph of Monsoon
	[45623]="0:16:1:20:Druid::1:0:", -- Glyph of Barkskin
	[45624]="0:10:4::Currency::1:0:35494,35495,35573,35574,35790", -- Emblem of Conquest
	[45625]="0:16:1:20:Hunter::1:0:", -- Glyph of Chimera Shot
	[45626]="0:4:3:1:Cloak::1:0:", -- Spidersilk Drape
	[45627]="0:4:3:1:Amulet::1:0:", -- Amulet of Truesight
	[45628]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Boots - Lesser Accuracy
	[45631]="0:4:3:1:Trinket::1:0:", -- High-powered Flashlight
	[45632]="0:15:4:1:ArmorToken::1:0:33963,33964", -- Breastplate of the Wayward Conqueror
	[45633]="0:15:4:1:ArmorToken::1:0:33963,33964", -- Breastplate of the Wayward Protector
	[45634]="0:15:4:1:ArmorToken::1:0:33963,33964", -- Breastplate of the Wayward Vanquisher
	[45635]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Wayward Conqueror
	[45636]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Wayward Protector
	[45637]="0:15:4:1:ArmorToken::1:0:", -- Chestguard of the Wayward Vanquisher
	[45638]="0:15:4:1:ArmorToken::1:0:33963,33964", -- Crown of the Wayward Conqueror
	[45639]="0:15:4:1:ArmorToken::1:0:33963,33964", -- Crown of the Wayward Protector
	[45640]="0:15:4:1:ArmorToken::1:0:33963,33964", -- Crown of the Wayward Vanquisher
	[45641]="0:15:4:1:ArmorToken::1:0:", -- Gauntlets of the Wayward Conqueror
	[45642]="0:15:4:1:ArmorToken::1:0:", -- Gauntlets of the Wayward Protector
	[45643]="0:15:4:1:ArmorToken::1:0:", -- Gauntlets of the Wayward Vanquisher
	[45644]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Wayward Conqueror
	[45645]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Wayward Protector
	[45646]="0:15:4:1:ArmorToken::1:0:", -- Gloves of the Wayward Vanquisher
	[45647]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Wayward Conqueror
	[45648]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Wayward Protector
	[45649]="0:15:4:1:ArmorToken::1:0:", -- Helm of the Wayward Vanquisher
	[45650]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Wayward Conqueror
	[45651]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Wayward Protector
	[45652]="0:15:4:1:ArmorToken::1:0:", -- Leggings of the Wayward Vanquisher
	[45653]="0:15:4:1:ArmorToken::1:0:", -- Legplates of the Wayward Conqueror
	[45654]="0:15:4:1:ArmorToken::1:0:", -- Legplates of the Wayward Protector
	[45655]="0:15:4:1:ArmorToken::1:0:", -- Legplates of the Wayward Vanquisher
	[45656]="0:15:4:1:ArmorToken::1:0:", -- Mantle of the Wayward Conqueror
	[45657]="0:15:4:1:ArmorToken::1:0:", -- Mantle of the Wayward Protector
	[45658]="0:15:4:1:ArmorToken::1:0:", -- Mantle of the Wayward Vanquisher
	[45659]="0:15:4:1:ArmorToken::1:0:", -- Spaulders of the Wayward Conqueror
	[45660]="0:15:4:1:ArmorToken::1:0:", -- Spaulders of the Wayward Protector
	[45661]="0:15:4:1:ArmorToken::1:0:", -- Spaulders of the Wayward Vanquisher
	[45663]="0:4:4:1:Plate::1:0:", -- Armbands of Bedlam
	[45664]="250000:4:1:1:Shirt::1:0:33853", -- Silvermoon Doublet
	[45665]="0:4:4:1:Cloth::1:0:", -- Pharos Gloves
	[45666]="250000:4:1:1:Shirt::1:0:33853", -- Ironforge Doublet
	[45667]="250000:4:1:1:Shirt::1:0:33853", -- Stormwind Doublet
	[45668]="250000:4:1:1:Shirt::1:0:33853", -- Exodar Doublet
	[45669]="250000:4:1:1:Shirt::1:0:33853", -- Sen'jin Doublet
	[45670]="250000:4:1:1:Shirt::1:0:33853", -- Darnassus Doublet
	[45671]="250000:4:1:1:Shirt::1:0:33853", -- Gnomeregan Doublet
	[45672]="250000:4:1:1:Shirt::1:0:33853", -- Orgrimmar Doublet
	[45673]="250000:4:1:1:Shirt::1:0:33853", -- Thunder Bluff Doublet
	[45674]="250000:4:1:1:Shirt::1:0:33853", -- Undercity Doublet
	[45675]="0:4:4:1:Ring::1:0:", -- Power Enhancing Loop
	[45676]="0:4:4:1:Plate::1:0:", -- Chestplate of Vicious Potency
	[45677]="0:4:4:1:Leather::1:0:", -- Treacherous Shoulderpads
	[45679]="0:4:4:1:Mail::1:0:", -- Gloves of Taut Grip
	[45680]="0:4:4:1:Plate::1:0:", -- Armbands of the Construct
	[45682]="0:4:4:1:Shield::1:0:", -- Pulsing Spellshield
	[45685]="0:2:4:1:Dagger::1:0:", -- Plasma Foil
	[45686]="0:4:4:1:Leather::1:0:", -- Vest of the Glowing Crescent
	[45687]="0:4:4:1:Mail::1:0:", -- Helm of Veiled Energies
	[45688]="12500000:4:4:1:Ring::1:0:32172", -- Inscribed Band of the Kirin Tor
	[45689]="12500000:4:4:1:Ring::1:0:32172", -- Inscribed Loop of the Kirin Tor
	[45690]="12500000:4:4:1:Ring::1:0:32172", -- Inscribed Ring of the Kirin Tor
	[45691]="12500000:4:4:1:Ring::1:0:32172", -- Inscribed Signet of the Kirin Tor
	[45693]="0:15:4:1:FlyingMount::1:0:", -- Mimiron's Head
	[45694]="0:4:4:1:Cloth::1:0:", -- Conductive Cord
	[45695]="0:2:4:1:Stave::1:0:", -- Spire of Withering Dreams
	[45696]="0:4:4:1:Amulet::1:0:", -- Mark of the Unyielding
	[45697]="0:4:4:1:Plate::1:0:", -- Shoulderguards of the Solemn Watch
	[45698]="0:4:4:1:Plate::1:0:", -- Sabatons of the Iron Watcher
	[45699]="0:4:4:1:Amulet::1:0:", -- Pendant of the Piercing Glare
	[45700]="0:2:4:1:OneHandSword::1:0:", -- Stoneguard
	[45701]="0:4:4:1:Mail::1:0:", -- Greaves of the Earthbinder
	[45702]="0:4:4:1:Ring::1:0:", -- Emerald Signet Ring
	[45703]="0:4:4:1:Trinket::1:0:", -- Spark of Hope
	[45704]="0:4:4:1:Cloak::1:0:", -- Shawl of the Shattered Giant
	[45706]="0:0:4:5:Other::1:0:33933,33934,33935,33937,33938,33941,34063,34084", -- Commendation of Bravery
	[45707]="0:4:4:1:Shield::1:0:", -- Shieldwall of the Breaker
	[45708]="0:4:4:1:Plate::1:0:", -- Archaedas' Lost Legplates
	[45709]="0:4:4:1:Leather::1:0:", -- Nimble Climber's Belt
	[45711]="0:4:4:1:Mail::1:0:", -- Ironaya's Discarded Mantle
	[45712]="0:4:4:1:Plate::1:0:", -- Chestplate of Titanic Fury
	[45713]="0:2:4:1:Wand::1:0:", -- Nurturing Touch
	[45714]="0:0:2:250:Other::1:0:33653", -- Darnassus Commendation Badge
	[45715]="0:0:2:250:Other::1:0:33657", -- Exodar Commendation Badge
	[45716]="0:0:2:250:Other::1:0:33650", -- Gnomeregan Commendation Badge
	[45717]="0:0:2:250:Other::1:0:33310", -- Ironforge Commendation Badge
	[45718]="0:0:2:250:Other::1:0:33307", -- Stormwind Commendation Badge
	[45719]="0:0:2:250:Other::1:0:33553", -- Orgrimmar Commendation Badge
	[45720]="0:0:2:250:Other::1:0:33554", -- Sen'jin Commendation Badge
	[45721]="0:0:2:250:Other::1:0:33557", -- Silvermoon Commendation Badge
	[45722]="0:0:2:250:Other::1:0:33556", -- Thunder Bluff Commendation Badge
	[45723]="0:0:2:250:Other::1:0:33555", -- Undercity Commendation Badge
	[45724]="0:15:1:1:Junk::1:0:", -- Champion's Purse
	[45725]="0:15:4:1:FlyingMount::1:0:33307,33310,33553,33554,33555,33556,33557,33650,33653,33657", -- Argent Hippogryph
	[45731]="0:16:1:20:Hunter::1:0:", -- Glyph of Explosive Shot
	[45732]="0:16:1:20:Hunter::1:0:", -- Glyph of Kill Shot
	[45733]="0:16:1:20:Hunter::1:0:", -- Glyph of Explosive Trap
	[45734]="0:16:1:20:Hunter::1:0:", -- Glyph of Scatter Shot
	[45735]="0:16:1:20:Hunter::1:0:", -- Glyph of Raptor Strike
	[45736]="0:16:1:20:Mage::1:0:", -- Glyph of Deep Freeze
	[45737]="0:16:1:20:Mage::1:0:", -- Glyph of Living Bomb
	[45738]="0:16:1:20:Mage::1:0:", -- Glyph of Arcane Barrage
	[45739]="0:16:1:20:Mage::1:0:", -- Glyph of Mirror Image
	[45740]="0:16:1:20:Mage::1:0:", -- Glyph of Ice Barrier
	[45741]="0:16:1:20:Paladin::1:0:", -- Glyph of Beacon of Light
	[45742]="0:16:1:20:Paladin::1:0:", -- Glyph of Hammer of the Righteous
	[45743]="0:16:1:20:Paladin::1:0:", -- Glyph of Divine Storm
	[45744]="0:16:1:20:Paladin::1:0:", -- Glyph of Shield of Righteousness
	[45745]="0:16:1:20:Paladin::1:0:", -- Glyph of Divine Plea
	[45746]="0:16:1:20:Paladin::1:0:", -- Glyph of Holy Shock
	[45747]="0:16:1:20:Paladin::1:0:", -- Glyph of Salvation
	[45753]="0:16:1:20:Priest::1:0:", -- Glyph of Dispersion
	[45755]="0:16:1:20:Priest::1:0:", -- Glyph of Guardian Spirit
	[45756]="0:16:1:20:Priest::1:0:", -- Glyph of Penance
	[45757]="0:16:1:20:Priest::1:0:", -- Glyph of Mind Sear
	[45758]="0:16:1:20:Priest::1:0:", -- Glyph of Hymn of Hope
	[45760]="0:16:1:20:Priest::1:0:", -- Glyph of Pain Suppression
	[45761]="0:16:1:20:Rogue::1:0:", -- Glyph of Hunger for Blood
	[45762]="0:16:1:20:Rogue::1:0:", -- Glyph of Killing Spree
	[45764]="0:16:1:20:Rogue::1:0:", -- Glyph of Shadow Dance
	[45766]="0:16:1:20:Rogue::1:0:", -- Glyph of Fan of Knives
	[45767]="0:16:1:20:Rogue::1:0:", -- Glyph of Tricks of the Trade
	[45768]="0:16:1:20:Rogue::1:0:", -- Glyph of Mutilate
	[45769]="0:16:1:20:Rogue::1:0:", -- Glyph of Cloak of Shadows
	[45770]="0:16:1:20:Shaman::1:0:", -- Glyph of Thunder
	[45771]="0:16:1:20:Shaman::1:0:", -- Glyph of Feral Spirit
	[45772]="0:16:1:20:Shaman::1:0:", -- Glyph of Riptide
	[45773]="0:1:3:1:HerbBag::1:0:", -- Emerald Bag
	[45774]="50000:9:1:1:Tailoring::1:0:31916,32763", -- Pattern: Emerald Bag
	[45775]="0:16:1:20:Shaman::1:0:", -- Glyph of Earth Shield
	[45776]="0:16:1:20:Shaman::1:0:", -- Glyph of Totem of Wrath
	[45777]="0:16:1:20:Shaman::1:0:", -- Glyph of Hex
	[45778]="0:16:1:20:Shaman::1:0:", -- Glyph of Stoneclaw Totem
	[45779]="0:16:1:20:Warlock::1:0:", -- Glyph of Haunt
	[45780]="0:16:1:20:Warlock::1:0:", -- Glyph of Metamorphosis
	[45781]="0:16:1:20:Warlock::1:0:", -- Glyph of Chaos Bolt
	[45782]="0:16:1:20:Warlock::1:0:", -- Glyph of Demonic Circle
	[45783]="0:16:1:20:Warlock::1:0:", -- Glyph of Shadowflame
	[45784]="0:0:1:1:Consumable::1:0:", -- Thorim's Sigil
	[45785]="0:16:1:20:Warlock::1:0:", -- Glyph of Life Tap
	[45786]="0:0:1:1:Consumable::1:0:", -- Hodir's Sigil
	[45787]="0:0:1:1:Consumable::1:0:", -- Mimiron's Sigil
	[45788]="0:0:1:1:Consumable::1:0:", -- Freya's Sigil
	[45789]="0:16:1:20:Warlock::1:0:", -- Glyph of Soul Link
	[45790]="0:16:1:20:Warrior::1:0:", -- Glyph of Bladestorm
	[45791]="0:0:1:1:Consumable::1:0:", -- Sigils of the Watchers
	[45792]="0:16:1:20:Warrior::1:0:", -- Glyph of Shockwave
	[45793]="0:16:1:20:Warrior::1:0:", -- Glyph of Vigilance
	[45794]="0:16:1:20:Warrior::1:0:", -- Glyph of Enraged Regeneration
	[45795]="0:16:1:20:Warrior::1:0:", -- Glyph of Spell Reflection
	[45796]="0:13:1:1:::1:0:", -- Celestial Planetarium Key
	[45797]="0:16:1:20:Warrior::1:0:", -- Glyph of Shield Wall
	[45798]="0:13:1:1:::1:0:", -- Heroic Celestial Planetarium Key
	[45799]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Dancing Rune Weapon
	[45800]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Hungering Cold
	[45801]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Ironbound Proto-Drake
	[45802]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Rusted Proto-Drake
	[45803]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Unholy Blight
	[45804]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Dark Death
	[45805]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Disease
	[45806]="0:16:1:20:DeathKnight::1:0:", -- Glyph of Howling Blast
	[45808]="0:4:3:1:Ring::1:0:", -- Runed Mana Band
	[45809]="0:4:3:1:Ring::1:0:", -- Scarlet Signet
	[45810]="0:4:3:1:Cloak::1:0:", -- Cloak of Crimson Snow
	[45811]="0:4:3:1:Cloak::1:0:", -- Frostguard Drape
	[45812]="0:4:3:1:Amulet::1:0:", -- Emerald Choker
	[45813]="0:4:3:1:Amulet::1:0:", -- Sky Sapphire Amulet
	[45814]="0:0:1:1:Consumable::1:0:", -- Freya's Sigil
	[45815]="0:0:1:1:Consumable::1:0:", -- Hodir's Sigil
	[45816]="0:0:1:1:Consumable::1:0:", -- Mimiron's Sigil
	[45817]="0:0:1:1:Consumable::1:0:", -- Thorim's Sigil
	[45819]="0:4:4:1:Amulet::1:0:32172,33963,33964", -- Spiked Battleguard Choker
	[45820]="0:4:4:1:Amulet::1:0:32172,33963,33964", -- Broach of the Wailing Night
	[45821]="0:4:4:1:Amulet::1:0:32172,33963,33964", -- Shard of the Crystal Forest
	[45822]="0:4:4:1:Amulet::1:0:32172,33963,33964", -- Evoker's Charm
	[45823]="0:4:4:1:Amulet::1:0:32172,33963,33964", -- Frozen Tear of Elune
	[45824]="0:4:4:1:Plate::1:0:28997,33963,33964", -- Belt of the Singing Blade
	[45825]="0:4:4:1:Plate::1:0:28997,33963,33964", -- Shieldwarder Girdle
	[45826]="0:4:4:1:Plate::1:0:28997,33963,33964", -- Girdle of Unyielding Trust
	[45827]="0:4:4:1:Mail::1:0:29523,33963,33964", -- Belt of the Ardent Marksman
	[45828]="0:4:4:1:Mail::1:0:29523,33963,33964", -- Windchill Binding
	[45829]="0:4:4:1:Leather::1:0:28992,29538,33963,33964", -- Belt of the Twilight Assassin
	[45830]="0:4:4:1:Leather::1:0:28992,29538,33963,33964", -- Belt of the Living Thicket
	[45831]="0:4:4:1:Cloth::1:0:28995,33963,33964", -- Sash of Potent Incantations
	[45832]="0:4:4:1:Cloth::1:0:", -- Mantle of the Preserver
	[45833]="0:4:4:1:Plate::1:0:28997,33963,33964", -- Bladebreaker Gauntlets
	[45834]="0:4:4:1:Plate::1:0:28997,33963,33964", -- Gauntlets of the Royal Watch
	[45835]="0:4:4:1:Plate::1:0:28997,33963,33964", -- Gauntlets of Serene Blessing
	[45836]="0:4:4:1:Mail::1:0:29523,33963,33964", -- Gloves of Unerring Aim
	[45837]="0:4:4:1:Mail::1:0:29523,33963,33964", -- Gloves of Augury
	[45838]="0:4:4:1:Leather::1:0:28992,29538,33963,33964", -- Gloves of the Blind Stalker
	[45839]="0:4:4:1:Leather::1:0:28992,29538,33963,33964", -- Grips of the Secret Grove
	[45840]="0:4:4:1:Cloth::1:0:28995,33963,33964", -- Touch of the Occult
	[45841]="0:4:4:1:Plate::1:0:28997,33963,33964", -- Legplates of the Violet Champion
	[45842]="0:4:4:1:Plate::1:0:28997,33963,33964", -- Wyrmguard Legplates
	[45843]="0:4:4:1:Plate::1:0:28997,33963,33964", -- Legguards of the Peaceful Covenant
	[45844]="0:4:4:1:Mail::1:0:29523,33963,33964", -- Leggings of the Tireless Sentry
	[45845]="0:4:4:1:Mail::1:0:29523,33963,33964", -- Leggings of the Weary Mystic
	[45846]="0:4:4:1:Leather::1:0:28992,29538,33963,33964", -- Leggings of Wavering Shadow
	[45847]="0:4:4:1:Leather::1:0:28992,29538,33963,33964", -- Wildstrider Legguards
	[45848]="0:4:4:1:Cloth::1:0:28995,33963,33964", -- Legwraps of the Master Conjurer
	[45849]="0:4:3:1:OffHandFrill::1:0:", -- Twilight Tome
	[45850]="0:4:3:1:OffHandFrill::1:0:", -- Rituals of the New Moon
	[45851]="0:4:3:1:OffHandFrill::1:0:", -- Rituals of the New Moon
	[45852]="0:4:3:1:OffHandFrill::1:0:", -- Rituals of the New Moon
	[45853]="0:4:3:1:OffHandFrill::1:0:", -- Rituals of the New Moon
	[45854]="0:4:3:1:OffHandFrill::1:0:", -- Rituals of the New Moon
	[45855]="0:0:1:1:Consumable::1:0:", -- Sigils of the Watchers
	[45857]="0:12:4:1:::1:0:", -- Archivum Data Disc
	[45858]="0:2:3:1:FishingPole::1:0:", -- Nat's Lucky Fishing Pole
	[45859]="0:4:4:1:Ring::1:0:", -- The 5 Ring
	[45861]="0:2:1:1:Miscellaneous::1:0:", -- Diamond-tipped Cane
	[45862]="0:3:4:1:GemRed::1:0:", -- Bold Stormjewel
	[45864]="0:4:4:1:Leather::1:0:", -- Cover of the Keepers
	[45865]="0:4:4:1:Cloth::1:0:", -- Raiments of the Corrupted
	[45866]="0:4:4:1:Trinket::1:0:", -- Elemental Focus Stone
	[45867]="0:4:4:1:Mail::1:0:", -- Breastplate of the Stoneshaper
	[45868]="0:2:4:1:TwoHandSword::1:0:", -- Aesir's Edge
	[45869]="0:4:4:1:Leather::1:0:", -- Fluxing Energy Coils
	[45870]="0:2:4:1:Gun::1:0:", -- Magnetized Projectile Emitter
	[45871]="0:4:4:1:Ring::1:0:", -- Seal of Ulduar
	[45872]="0:2:4:1:Bow::1:0:", -- Avalanche
	[45873]="0:4:4:1:Cloak::1:0:", -- Winter's Frigid Embrace
	[45874]="0:4:4:1:Ring::1:0:", -- Signet of Winter
	[45875]="0:15:4:1:Junk::1:0:", -- Sack of Ulduar Spoils
	[45876]="0:2:4:1:OneHandMace::1:0:", -- Shiver
	[45877]="0:4:4:1:Shield::1:0:", -- The Boreal Guard
	[45878]="0:15:4:1:Junk::1:0:", -- Large Sack of Ulduar Spoils
	[45879]="0:3:4:1:GemRed::1:0:", -- Delicate Stormjewel
	[45880]="0:3:4:1:GemBlue::1:0:", -- Solid Stormjewel
	[45881]="0:3:4:1:GemBlue::1:0:", -- Sparkling Stormjewel
	[45882]="0:3:4:1:GemYellow::1:0:", -- Brilliant Stormjewel
	[45883]="0:3:4:1:GemRed::1:0:", -- Runed Stormjewel
	[45886]="0:2:4:1:Stave::1:0:", -- Icecore Staff
	[45887]="0:4:4:1:Shield::1:0:", -- Ice Layered Barrier
	[45888]="0:4:4:1:Plate::1:0:", -- Bitter Cold Armguards
	[45892]="0:2:4:1:OneHandMace::1:0:", -- Legacy of Thunder
	[45893]="0:4:4:1:Leather::1:0:", -- Guise of the Midgard Serpent
	[45894]="0:4:4:1:Cloth::1:0:", -- Leggings of Unstable Discharge
	[45895]="0:4:4:1:Mail::1:0:", -- Belt of the Blood Pit
	[45896]="0:0:5:1:Consumable::1:0:", -- Unbound Fragments of Val'anyr
	[45897]="0:0:5:1:Consumable::1:0:", -- Reforged Hammer of Ancient Kings
	[45902]="0:12:1:20:::1:0:", -- Phantom Ghostfish
	[45903]="0:12:1:20:::1:0:", -- Corroded Jewelry
	[45904]="0:12:1:20:::1:0:", -- Terrorfish
	[45905]="0:12:1:20:::1:0:", -- Bloodtooth Frenzy
	[45907]="0:7:0:20:Meat::1:0:", -- Mostly-eaten Bonescale Snapper
	[45909]="0:7:1:20:Other::1:0:", -- Giant Darkwater Clam
	[45912]="0:9:2:10:Book::1:0:", -- Book of Glyph Mastery
	[45924]="0:15:4:40:Junk::1:0:", -- Certificate of Appreciation
	[45927]="0:4:4:1:Cloth::1:0:", -- Handwraps of Resonance
	[45928]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Thunder God
	[45929]="0:4:4:1:Trinket::1:0:", -- Sif's Remembrance
	[45930]="0:2:4:1:Dagger::1:0:", -- Combatant's Bootblade
	[45931]="0:4:4:1:Trinket::1:0:", -- Mjolnir Runestone
	[45932]="0:0:1:20:FoodDrink::1:0:", -- Black Jelly
	[45933]="0:4:4:1:Amulet::1:0:", -- Pendant of the Shallow Grave
	[45934]="0:2:4:1:Stave::1:0:", -- Unraveling Reach
	[45935]="0:4:4:1:Plate::1:0:", -- Ironbark Faceguard
	[45936]="0:4:4:1:Plate::1:0:", -- Legplates of Flourishing Resolve
	[45937]="0:2:4:1:Gun::1:0:", -- Furious Gladiator's Shotgun
	[45938]="0:2:4:1:Bow::1:0:", -- Furious Gladiator's Recurve
	[45939]="0:2:4:1:Crossbow::1:0:", -- Furious Gladiator's Repeater
	[45940]="0:4:4:1:Leather::1:0:", -- Tunic of the Limber Stalker
	[45941]="0:4:4:1:Mail::1:0:", -- Chestguard of the Lasher
	[45942]="0:15:1:1:Companion::1:0:", -- XS-001 Constructor Bot
	[45943]="0:4:4:1:Mail::1:0:", -- Gloves of Whispering Winds
	[45945]="0:4:4:1:Amulet::1:0:", -- Seed of Budding Carnage
	[45946]="0:4:4:1:Ring::1:0:", -- Fire Orchid Signet
	[45947]="232587:2:4:1:OneHandSword::1:0:", -- Serilas, Blood Blade of Invar One-Arm
	[45948]="0:2:4:1:TwoHandAxe::1:0:", -- Furious Gladiator's Sunderer
	[45949]="0:2:4:1:TwoHandMace::1:0:", -- Furious Gladiator's Crusher
	[45950]="0:2:4:1:TwoHandSword::1:0:", -- Furious Gladiator's Claymore
	[45951]="0:2:4:1:Polearm::1:0:", -- Furious Gladiator's Halberd
	[45952]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's Greatstaff
	[45953]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's Combat Staff
	[45954]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's Acute Staff
	[45955]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's Skirmish Staff
	[45956]="0:2:4:1:Stave::1:0:", -- Furious Gladiator's Light Staff
	[45957]="0:2:4:1:OneHandAxe::1:0:", -- Furious Gladiator's Handaxe
	[45958]="0:2:4:1:Dagger::1:0:", -- Furious Gladiator's Spike
	[45959]="0:2:4:1:OneHandMace::1:0:", -- Furious Gladiator's Truncheon
	[45960]="0:2:4:1:OneHandSword::1:0:", -- Furious Gladiator's Longblade
	[45961]="0:2:4:1:OneHandAxe::1:0:", -- Furious Gladiator's Dicer
	[45962]="0:2:4:1:Dagger::1:0:", -- Furious Gladiator's Dirk
	[45963]="0:2:4:1:FistWeapon::1:0:", -- Furious Gladiator's Left Razor
	[45964]="0:2:4:1:OneHandMace::1:0:", -- Furious Gladiator's Punisher
	[45965]="0:2:4:1:OneHandSword::1:0:", -- Furious Gladiator's Swiftblade
	[45966]="0:2:4:1:OneHandAxe::1:0:", -- Furious Gladiator's Splitter
	[45967]="0:2:4:1:Dagger::1:0:", -- Furious Gladiator's Eviscerator
	[45968]="0:2:4:1:FistWeapon::1:0:", -- Furious Gladiator's Left Claw
	[45969]="0:2:4:1:FistWeapon::1:0:", -- Furious Gladiator's Grasp
	[45970]="0:2:4:1:Dagger::1:0:", -- Furious Gladiator's Mageblade
	[45971]="0:2:4:1:OneHandMace::1:0:", -- Furious Gladiator's Salvation
	[45972]="0:2:4:1:OneHandMace::1:0:", -- Pulse Baton
	[45973]="0:4:4:1:Cloak::1:0:", -- Stylish Power Cape
	[45974]="0:4:4:1:Leather::1:0:", -- Shoulderguards of Assimilation
	[45975]="0:4:4:1:Plate::1:0:", -- Cable of the Metrognome
	[45976]="0:4:4:1:Cloth::1:0:", -- Static Charge Handwraps
	[45977]="0:15:0:20:Junk::1:0:", -- Porcelain Bell
	[45978]="0:15:0:20:Junk::1:0:", -- Solid Gold Coin
	[45979]="0:15:0:20:Junk::1:0:", -- Tower Key
	[45980]="0:15:0:20:Junk::1:0:", -- Whale Statue
	[45981]="0:15:0:20:Junk::1:0:", -- New Age Painting
	[45982]="0:4:4:1:Plate::1:0:", -- Fused Alloy Legplates
	[45983]="0:4:4:1:Tabard::1:0:", -- Furious Gladiator's Tabard
	[45984]="0:15:1:1:Junk::1:0:", -- Unusual Compass
	[45986]="0:15:3:1:Junk::1:0:", -- Tiny Titanium Lockbox
	[45987]="0:3:4:1:GemYellow::1:0:", -- Rigid Stormjewel
	[45988]="0:4:4:1:Plate::1:0:", -- Greaves of the Iron Army
	[45989]="0:4:4:1:Mail::1:0:", -- Tempered Mercury Greaves
	[45990]="0:2:4:1:OneHandSword::1:0:", -- Fusion Blade
	[45991]="0:2:3:1:FishingPole::1:0:", -- Bone Fishing Pole
	[45992]="0:2:3:1:FishingPole::1:0:", -- Jeweled Fishing Pole
	[45993]="0:4:4:1:Leather::1:0:", -- Mimiron's Flight Goggles
	[45994]="0:4:3:1:Ring::1:0:", -- Lost Ring
	[45995]="0:4:3:1:Amulet::1:0:", -- Forgotten Necklace
	[45996]="0:2:4:1:Polearm::1:0:", -- Hoperender
	[45997]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Wretched
	[45998]="0:4:1:1:Miscellaneous::1:0:", -- Battered Jungle Hat
	[45999]="0:15:0:20:Junk::1:0:", -- Worthless Piece of White Glass
	[46000]="0:15:0:20:Junk::1:0:", -- Worthless Piece of Red Glass
	[46001]="0:15:0:20:Junk::1:0:", -- Worthless Piece of Green Glass
	[46002]="0:15:0:20:Junk::1:0:", -- Worthless Piece of Violet Glass
	[46003]="0:15:0:20:Junk::1:0:", -- Worthless Piece of Orange Glass
	[46004]="0:12:1:1:::1:0:", -- Sealed Vial of Poison
	[46005]="0:12:1:1:::1:0:", -- Sealed Vial of Poison
	[46006]="0:0:1:20:EnhTemp::1:0:", -- Glow Worm
	[46007]="0:15:1:1:Junk::1:0:", -- Bag of Fishing Treasures
	[46008]="0:4:4:1:Amulet::1:0:", -- Choker of the Abyss
	[46009]="0:4:4:1:Leather::1:0:", -- Bindings of the Depths
	[46010]="0:4:4:1:Ring::1:0:", -- Darkstone Ring
	[46011]="0:2:4:1:Dagger::1:0:", -- Shadowbite
	[46012]="0:4:4:1:Cloth::1:0:", -- Vestments of the Piercing Light
	[46013]="0:4:4:1:Cloth::1:0:", -- Underworld Mantle
	[46014]="0:4:4:1:Cloak::1:0:", -- Saronite Animus Cloak
	[46015]="0:4:4:1:Amulet::1:0:", -- Pendant of Endless Despair
	[46016]="0:2:4:1:TwoHandSword::1:0:", -- Abaddon
	[46017]="363651:2:5:1:OneHandMace::1:0:", -- Val'anyr, Hammer of Ancient Kings
	[46018]="0:2:4:1:Crossbow::1:0:", -- Deliverance
	[46019]="0:4:4:1:Mail::1:0:", -- Leggings of the Insatiable
	[46021]="0:4:4:1:Trinket::1:0:", -- Royal Seal of King Llane
	[46022]="0:4:4:1:Amulet::1:0:", -- Pendant of a Thousand Maws
	[46023]="0:15:0:5:Junk::1:0:", -- A Steamy Romance Novel: Northern Exposure
	[46024]="0:2:4:1:Dagger::1:0:", -- Kingsbane
	[46025]="0:2:4:1:Stave::1:0:", -- Devotion
	[46026]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Blade Ward
	[46027]="0:9:4:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Blade Ward
	[46028]="0:4:4:1:Plate::1:0:", -- Faceguard of the Eyeless Horror
	[46029]="0:15:1:1:CombatPet::1:0:", -- Magnetic Core
	[46030]="0:4:4:1:Cloth::1:0:", -- Treads of the Dragon Council
	[46031]="0:2:4:1:OneHandAxe::1:0:", -- Touch of Madness
	[46032]="0:4:4:1:Cloak::1:0:", -- Drape of the Faceless General
	[46033]="0:2:4:1:Stave::1:0:", -- Tortured Earth
	[46034]="0:4:4:1:Cloth::1:0:", -- Leggings of Profound Darkness
	[46035]="228456:2:4:1:OneHandMace::1:0:", -- Aesuga, Hand of the Ardent Champion
	[46036]="0:2:4:1:OneHandSword::1:0:", -- Void Sabre
	[46037]="0:4:4:1:Plate::1:0:", -- Shoulderplates of the Celestial Watch
	[46038]="0:4:4:1:Trinket::1:0:", -- Dark Matter
	[46039]="0:4:4:1:Plate::1:0:", -- Breastplate of the Timeless
	[46040]="0:4:4:1:Amulet::1:0:", -- Strength of the Heavens
	[46041]="0:4:4:1:Plate::1:0:", -- Starfall Girdle
	[46042]="0:4:4:1:Cloak::1:0:", -- Drape of the Messenger
	[46043]="0:4:4:1:Leather::1:0:", -- Gloves of the Endless Dark
	[46044]="0:4:4:1:Mail::1:0:", -- Observer's Mantle
	[46045]="0:4:4:1:Cloth::1:0:", -- Pulsar Gloves
	[46046]="0:4:4:1:Ring::1:0:", -- Nebula Band
	[46047]="0:4:4:1:Amulet::1:0:", -- Pendant of the Somber Witness
	[46048]="0:4:4:1:Ring::1:0:", -- Band of Lights
	[46049]="0:4:4:1:Leather::1:0:", -- Zodiac Leggings
	[46050]="0:4:4:1:Cloth::1:0:", -- Starlight Treads
	[46051]="0:4:4:1:Trinket::1:0:", -- Meteorite Crystal
	[46052]="0:12:4:1:::1:0:", -- Reply-Code Alpha
	[46053]="0:12:4:1:::1:0:", -- Reply-Code Alpha
	[46057]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Chestguard of Salvation
	[46058]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Breastplate of Triumph
	[46059]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Chain Armor of Triumph
	[46060]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Ringmail of Salvation
	[46061]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Mail Armor of Domination
	[46062]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Leather Tunic of Triumph
	[46063]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Leather Chestguard of Salvation
	[46064]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Leather Chestguard of Dominance
	[46065]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Raiment of Dominance
	[46066]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Raiment of Salvation
	[46067]="0:2:4:1:TwoHandMace::1:0:", -- Hammer of Crushing Whispers
	[46068]="0:4:4:1:Cloth::1:0:", -- Amice of Inconceivable Horror
	[46069]="0:2:1:1:Miscellaneous::1:0:", -- Alliance Lance
	[46070]="0:2:1:1:Miscellaneous::1:0:", -- Horde Lance
	[46071]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Girdle of Salvation
	[46072]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Girdle of Triumph
	[46073]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Waistguard of Dominance
	[46074]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Waistguard of Salvation
	[46075]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Waistguard of Triumph
	[46076]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Belt of Dominance
	[46077]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Belt of Salvation
	[46078]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Belt of Triumph
	[46079]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Cord of Dominance
	[46080]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Cord of Salvation
	[46081]="0:4:4:1:Trinket::1:0:32294,32296", -- Titan-Forged Rune of Audacity
	[46082]="0:4:4:1:Trinket::1:0:32294,32296", -- Titan-Forged Rune of Determination
	[46083]="0:4:4:1:Trinket::1:0:32294,32296", -- Titan-Forged Rune of Accuracy
	[46084]="0:4:4:1:Trinket::1:0:32294,32296", -- Titan-Forged Rune of Cruelty
	[46085]="0:4:4:1:Trinket::1:0:32294,32296", -- Titan-Forged Rune of Alacrity
	[46086]="0:4:4:1:Trinket::1:0:32294,32296", -- Platinum Disks of Battle
	[46087]="0:4:4:1:Trinket::1:0:32294,32296", -- Platinum Disks of Sorcery
	[46088]="0:4:4:1:Trinket::1:0:32294,32296", -- Platinum Disks of Swiftness
	[46095]="0:4:4:1:Leather::1:0:", -- Soul-Devouring Cinch
	[46096]="0:4:4:1:Ring::1:0:", -- Signet of Soft Lament
	[46097]="0:2:4:1:OneHandMace::1:0:", -- Caress of Insanity
	[46098]="0:0:3:5:EnhPerm::1:0:", -- Scroll of Enchant Weapon - Blood Draining
	[46099]="10000:15:3:1:Mount::1:0:3362", -- Horn of the Black Wolf
	[46100]="10000:15:3:1:Mount::1:0:3685", -- White Kodo
	[46101]="0:15:4:1:Mount::1:0:", -- Blue Skeletal Warhorse
	[46102]="0:15:4:1:Mount::1:0:", -- Whistle of the Venomhide Ravasaur
	[46104]="0:4:4:1:Shirt::1:0:", -- Shirt of the Yogg-Slayer
	[46106]="0:2:1:1:Miscellaneous::1:0:", -- Argent Lance
	[46108]="0:9:2:1:::1:0:", -- Technique: Rituals of the New Moon
	[46109]="0:15:3:1:Mount::1:0:", -- Sea Turtle
	[46110]="0:15:3:1:Junk::1:0:", -- Alchemist's Cache
	[46111]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Battleplate
	[46113]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Gauntlets
	[46114]="0:15:1:250:Junk::1:0:", -- Champion's Writ
	[46115]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Helmet
	[46116]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Legplates
	[46117]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Shoulderplates
	[46118]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Chestguard
	[46119]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Handguards
	[46120]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Faceguard
	[46121]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Legguards
	[46122]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Darkruned Pauldrons
	[46123]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Terrorblade Breastplate
	[46124]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Terrorblade Gauntlets
	[46125]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Terrorblade Helmet
	[46126]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Terrorblade Legplates
	[46127]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Terrorblade Pauldrons
	[46129]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Kirin Tor Hood
	[46130]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Kirin Tor Tunic
	[46131]="0:4:4:1:Cloth::1:0:28995", -- Valorous Kirin Tor Gauntlets
	[46132]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Kirin Tor Gauntlets
	[46133]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Kirin Tor Leggings
	[46134]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Kirin Tor Shoulderpads
	[46135]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Deathbringer Gloves
	[46136]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Deathbringer Shoulderpads
	[46137]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Deathbringer Robe
	[46138]="0:4:4:1:Idol::1:0:33963,33964", -- Idol of the Flourishing Life
	[46139]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Deathbringer Leggings
	[46140]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Deathbringer Hood
	[46141]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Scourgestalker Tunic
	[46142]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Scourgestalker Handguards
	[46143]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Scourgestalker Headpiece
	[46144]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Scourgestalker Legguards
	[46145]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Scourgestalker Spaulders
	[46146]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Battleplate
	[46148]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Gauntlets
	[46149]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Shoulderplates
	[46150]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Legplates
	[46151]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Helmet
	[46152]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Shoulderplates
	[46153]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Legplates
	[46154]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Battleplate
	[46155]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Gauntlets
	[46156]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Helm
	[46157]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Shoulderpads
	[46158]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Handgrips
	[46159]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Raiments
	[46160]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Legguards
	[46161]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Headguard
	[46162]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Breastplate
	[46163]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Handwraps of Sanctification
	[46164]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Handguards
	[46165]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Mantle of Sanctification
	[46166]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Greathelm
	[46167]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Pauldrons
	[46168]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Raiments of Sanctification
	[46169]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Siegebreaker Legguards
	[46170]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Pants of Sanctification
	[46171]="0:15:4:1:FlyingMount::1:0:", -- Furious Gladiator's Frost Wyrm
	[46172]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Circlet of Sanctification
	[46173]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Breastplate
	[46174]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Handguards
	[46175]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Faceguard
	[46176]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Legguards
	[46177]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Shoulderguards
	[46178]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Tunic
	[46179]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Gloves
	[46180]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Headpiece
	[46181]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Greaves
	[46182]="0:4:4:1:Plate::1:0:34252", -- Conqueror's Aegis Spaulders
	[46183]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Handguards
	[46184]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Headpiece
	[46185]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Leggings
	[46186]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Robe
	[46187]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Spaulders
	[46188]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Gloves of Sanctification
	[46189]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Gloves
	[46190]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Shoulderpads of Sanctification
	[46191]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Cover
	[46192]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Trousers
	[46193]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Robe of Sanctification
	[46194]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Vestments
	[46195]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Leggings of Sanctification
	[46196]="0:4:4:1:Leather::1:0:28992", -- Conqueror's Nightsong Mantle
	[46197]="0:4:4:1:Cloth::1:0:28995", -- Conqueror's Cowl of Sanctification
	[46198]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Tunic
	[46199]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Handguards
	[46200]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Grips
	[46201]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Headpiece
	[46202]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Legguards
	[46203]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Shoulderguards
	[46204]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Spaulders
	[46205]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Chestguard
	[46206]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Hauberk
	[46207]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Gloves
	[46208]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker War-Kilt
	[46209]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Helm
	[46210]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Kilt
	[46211]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Shoulderpads
	[46212]="0:4:4:1:Mail::1:0:29523", -- Conqueror's Worldbreaker Faceguard
	[46308]="10000:15:3:1:Mount::1:0:4731", -- Black Skeletal Horse
	[46312]="0:4:4:1:Trinket::1:0:", -- Vanquished Clutches of Yogg-Saron
	[46313]="0:4:4:1:Leather::1:0:28992", -- Valorous Nightsong Cover
	[46319]="0:0:1:1:Consumable::1:0:", -- Tournament Brew
	[46320]="0:4:4:1:Cloak::1:0:", -- Drape of the Skyherald
	[46321]="0:4:4:1:Cloak::1:0:", -- Sunglimmer Drape
	[46322]="0:4:4:1:Ring::1:0:", -- Brann's Sealing Ring
	[46323]="0:4:4:1:Ring::1:0:", -- Starshine Signet
	[46324]="0:4:3:1:Ring::1:0:", -- Gondria's Spectral Claw
	[46339]="0:2:4:1:Gun::1:0:", -- Mimiron's Repeater
	[46340]="0:4:4:1:Plate::1:0:", -- Adamant Handguards
	[46341]="0:4:4:1:Cloak::1:0:", -- Drape of the Spellweaver
	[46342]="0:2:4:1:Bow::1:0:", -- Golemheart Longbow
	[46343]="0:4:4:1:Amulet::1:0:", -- Fervor of the Protectorate
	[46344]="0:4:4:1:Cloth::1:0:", -- Iceshear Mantle
	[46345]="0:4:4:1:Plate::1:0:", -- Bracers of Righteous Reformation
	[46346]="0:4:4:1:Mail::1:0:", -- Boots of Unsettled Prey
	[46347]="0:4:4:1:Cloak::1:0:", -- Cloak of the Dormant Blaze
	[46348]="0:9:4:1:Enchanting::1:0:", -- Formula: Enchant Weapon - Blood Draining
	[46349]="0:4:3:1:Miscellaneous::1:0:31031,31032,33595", -- Chef's Hat
	[46350]="0:2:4:1:Stave::1:0:", -- Pillar of Fortitude
	[46351]="0:2:4:1:OneHandMace::1:0:", -- Bloodcrush Cudgel
	[46359]="0:15:0:1:Junk::1:0:", -- Velociraptor Skull
	[46360]="0:15:0:1:Junk::1:0:", -- Stuffed Shark Head
	[46361]="0:15:0:10:Junk::1:0:", -- Crafted Star
	[46362]="0:12:1:1:::1:0:", -- Venomhide Hatchling
	[46364]="0:12:1:10:::1:0:", -- Venomhide Ravasaur Egg
	[46367]="0:12:1:20:::1:0:", -- Fresh Dinosaur Meat
	[46368]="0:15:0:20:Junk::1:0:", -- Shredded Parchment
	[46369]="0:15:0:20:Junk::1:0:", -- Rotted Sentimental Paintings
	[46372]="0:16:1:20:Druid::1:0:", -- Glyph of Survival Instincts
	[46373]="0:4:4:1:Amulet::1:0:", -- Furious Gladiator's Pendant of Sundering
	[46374]="0:4:4:1:Amulet::1:0:34038,34075", -- Relentless Gladiator's Pendant of Sundering
	[46376]="0:0:1:20:Flask::1:0:", -- Flask of the Frost Wyrm
	[46377]="0:0:1:20:Flask::1:0:", -- Flask of Endless Rage
	[46378]="0:0:1:20:Flask::1:0:", -- Flask of Pure Mojo
	[46379]="0:0:1:20:Flask::1:0:", -- Flask of Stoneblood
	[46380]="0:12:1:15:::1:0:", -- Silithid Meat
	[46381]="0:12:1:10:::1:0:", -- Searing Roc Plumage
	[46382]="0:12:1:12:::1:0:", -- Silithid Egg
	[46396]="0:15:1:1:Companion::1:0:", -- Wolvar Orphan Whistle
	[46397]="0:15:1:1:Companion::1:0:", -- Oracle Orphan Whistle
	[46398]="500000:15:1:1:Companion::1:0:28951", -- Calico Cat
	[46399]="1040:0:1:20:Consumable::1:0:23510,24545", -- Thunder's Plunder
	[46400]="1040:0:1:20:Consumable::1:0:23482", -- Barleybrew Gold
	[46401]="1040:0:1:20:Consumable::1:0:23533", -- Crimson Stripe
	[46402]="1040:0:1:20:Consumable::1:0:24501", -- Promise of the Pandaren
	[46403]="1040:0:1:20:Consumable::1:0:23511", -- Chuganpug's Delight
	[46544]="0:15:3:1:Companion::1:0:", -- Curious Wolvar Pup
	[46545]="0:15:3:1:Companion::1:0:", -- Curious Oracle Hatchling
	[46690]="25:0:1:20:FoodDrink::5:0:34382", -- Candy Skull
	[46691]="0:0:1:20:FoodDrink::1:0:", -- Bread of the Dead
	[46693]="0:12:1:5:::1:0:", -- Small Paper Zeppelin
	[46707]="0:15:3:1:Companion::1:0:23710,24495,27478,27489", -- Pint-Sized Pink Pachyderm
	[46708]="0:15:4:1:FlyingMount::1:0:", -- Deadly Gladiator's Frost Wyrm
	[46710]="2000:9:1:1:Cooking::1:0:34382", -- Recipe: Bread of the Dead
	[46711]="30:0:1:5:Consumable::1:0:34382", -- Spirit Candle
	[46718]="10:0:1:20:Consumable::1:0:34382", -- Orange Marigold
	[46723]="0:4:1:1:Miscellaneous::1:0:", -- Pilgrim's Hat
	[46725]="0:0:2:1:Consumable::1:0:", -- Red Rider Air Rifle
	[46735]="0:4:1:1:Miscellaneous::1:0:", -- Synthebrew Goggles
	[46740]="0:15:1:1:Junk::1:0:", -- Winter Veil Gift
	[46743]="5000000:15:4:1:Mount::1:0:33554", -- Swift Purple Raptor
	[46744]="5000000:15:4:1:Mount::1:0:33653", -- Swift Moonsaber
	[46745]="5000000:15:4:1:Mount::1:0:33657", -- Great Red Elekk
	[46746]="5000000:15:4:1:Mount::1:0:33555", -- White Skeletal Warhorse
	[46747]="5000000:15:4:1:Mount::1:0:33650", -- Turbostrider
	[46748]="5000000:15:4:1:Mount::1:0:33310", -- Swift Violet Ram
	[46749]="5000000:15:4:1:Mount::1:0:33553", -- Swift Burgundy Wolf
	[46750]="5000000:15:4:1:Mount::1:0:33556", -- Great Golden Kodo
	[46751]="5000000:15:4:1:Mount::1:0:33557", -- Swift Red Hawkstrider
	[46752]="5000000:15:4:1:Mount::1:0:33307", -- Swift Gray Steed
	[46765]="0:0:3:20:Consumable::1:0:", -- Blue War Fuel
	[46766]="0:0:3:20:Consumable::1:0:", -- Red War Fuel
	[46767]="0:15:3:1:Companion::1:0:", -- Warbot Ignition Key
	[46775]="0:12:1:1:::1:0:", -- Battered Tribal Shield
	[46779]="0:0:1:250:Consumable::1:0:", -- Path of Cenarius
	[46780]="0:15:3:1:CombatPet::1:0:", -- Ogre Pinata
	[46783]="0:0:1:20:Consumable::1:0:", -- Pink Gumball
	[46784]="25:0:1:20:FoodDrink:185:5:0:34682,35337", -- Ripe Elwynn Pumpkin
	[46793]="25:0:1:20:FoodDrink:185:5:0:34685,35342", -- Tangy Southfury Cranberries
	[46796]="25:0:1:20:FoodDrink:185:5:0:34683,35341", -- Ripe Tirisfal Pumpkin
	[46797]="25:0:1:20:FoodDrink:185:5:0:34684,35343", -- Mulgore Sweet Potato
	[46800]="0:4:1:1:Miscellaneous::1:0:", -- Pilgrim's Attire
	[46802]="0:15:3:1:Companion::1:0:", -- Heavy Murloc Egg
	[46803]="0:9:1:1:Cooking::1:0:", -- Recipe: Spice Bread Stuffing
	[46804]="0:9:1:1:Cooking::1:0:", -- Recipe: Pumpkin Pie
	[46805]="0:9:1:1:Cooking::1:0:", -- Recipe: Cranberry Chutney
	[46806]="0:9:1:1:Cooking::1:0:", -- Recipe: Candied Sweet Potato
	[46807]="0:9:1:1:Cooking::1:0:", -- Recipe: Slow-Roasted Turkey
	[46809]="100:9:2:1:Book::1:0:34645,34681,34682,34783,35337,35338,35340", -- Bountiful Cookbook
	[46810]="100:9:2:1:Book::1:0:34683,34684,34685,34787,35341,35342,35343", -- Bountiful Cookbook
	[46812]="500000:15:1:1:Junk::1:1:14846", -- Northrend Mystery Gem Pouch
	[46813]="0:15:4:1:FlyingMount::1:0:34881", -- Silver Covenant Hippogryph
	[46814]="0:15:4:1:FlyingMount::1:0:34772", -- Sunreaver Dragonhawk
	[46815]="0:15:4:1:Mount::1:0:34881", -- Quel'dorei Steed
	[46816]="0:15:4:1:Mount::1:0:34772", -- Sunreaver Hawkstrider
	[46817]="0:4:1:1:Tabard::1:0:34881", -- Silver Covenant Tabard
	[46818]="0:4:1:1:Tabard::1:0:34772", -- Sunreaver Tabard
	[46820]="0:15:3:1:Companion::1:0:34881", -- Shimmering Wyrmling
	[46821]="0:15:3:1:Companion::1:0:34772", -- Shimmering Wyrmling
	[46824]="0:4:1:1:Miscellaneous::1:0:", -- Pilgrim's Robe
	[46830]="0:15:1:1:Junk::1:0:", -- Save the Orphans Action Alert
	[46831]="0:15:1:1:Companion::1:0:", -- Macabre Marionette
	[46843]="0:0:1:1:Consumable::1:0:34885", -- Argent Crusader's Banner
	[46847]="0:0:1:1:Consumable::1:0:", -- Seaforium Bombs
	[46849]="0:7:2:20:Enchanting::1:0:", -- Titanium Powder
	[46859]="0:12:1:10:::1:0:", -- Stolen Tallstrider Leg
	[46860]="5:4:1:1:Miscellaneous::1:0:34382", -- Whimsical Skull Mask
	[46861]="10000:4:1:1:OffHandFrill::1:0:34382", -- Bouquet of Orange Marigolds
	[46870]="0:12:1:1:::1:0:", -- Confessor's Prayer Book
	[46874]="0:4:3:1:Tabard::1:0:34885", -- Argent Crusader's Tabard
	[46875]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46876]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46877]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46878]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46879]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46880]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46881]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46882]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46883]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46884]="0:12:1:1:::1:0:", -- Riding Training Pamphlet
	[46885]="0:12:1:1:::1:0:", -- Weighted Net
	[46887]="0:0:1:20:FoodDrink::1:0:", -- Bountiful Feast
	[46888]="2000:7:1:20:Other::1:0:34645,34681,34682,34683,34684,34685,34783,34787,35337,35338,35340,35341,35342,35343", -- Bountiful Basket
	[46889]="0:12:1:10:::1:0:", -- Jormungar Egg Sac
	[46893]="0:12:1:1:::1:0:", -- Earthshaker Drum
	[46895]="0:13:1:10:::1:0:", -- Black Cage Key
	[46897]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Enduring Eye of Zul
	[46898]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Steady Eye of Zul
	[46899]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Vivid Eye of Zul
	[46900]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Dazzling Eye of Zul
	[46901]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Jagged Eye of Zul
	[46902]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Timeless Eye of Zul
	[46903]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Seer's Eye of Zul
	[46904]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Forceful Eye of Zul
	[46905]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Misty Eye of Zul
	[46906]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Sundered Eye of Zul
	[46907]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Shining Eye of Zul
	[46908]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Tense Eye of Zul
	[46909]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Lambent Eye of Zul
	[46910]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Intricate Eye of Zul
	[46911]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Radiant Eye of Zul
	[46912]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Energized Eye of Zul
	[46913]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Shattered Eye of Zul
	[46914]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Opaque Eye of Zul
	[46915]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Turbid Eye of Zul
	[46916]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Runed Cardinal Ruby
	[46917]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Bold Cardinal Ruby
	[46918]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Delicate Cardinal Ruby
	[46919]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Bright Cardinal Ruby
	[46920]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Precise Cardinal Ruby
	[46921]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Fractured Cardinal Ruby
	[46922]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Subtle Cardinal Ruby
	[46923]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Flashing Cardinal Ruby
	[46924]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Solid Majestic Zircon
	[46925]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Sparkling Majestic Zircon
	[46926]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Stormy Majestic Zircon
	[46927]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Lustrous Majestic Zircon
	[46928]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Rigid King's Amber
	[46929]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Smooth King's Amber
	[46930]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Brilliant King's Amber
	[46931]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Thick King's Amber
	[46932]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Mystic King's Amber
	[46933]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Quick King's Amber
	[46934]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Balanced Dreadstone
	[46935]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Sovereign Dreadstone
	[46936]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Glowing Dreadstone
	[46937]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Purified Dreadstone
	[46938]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Shifting Dreadstone
	[46939]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Royal Dreadstone
	[46940]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Regal Dreadstone
	[46941]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Defender's Dreadstone
	[46942]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Guardian's Dreadstone
	[46943]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Mysterious Dreadstone
	[46944]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Puissant Dreadstone
	[46945]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Infused Dreadstone
	[46946]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Tenuous Dreadstone
	[46947]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Luminous Ametrine
	[46948]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Inscribed Ametrine
	[46949]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Deadly Ametrine
	[46950]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Potent Ametrine
	[46951]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Veiled Ametrine
	[46952]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Durable Ametrine
	[46953]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Etched Ametrine
	[46954]="0:12:1:1:::1:0:", -- Flaming Spears
	[46955]="0:12:1:10:::1:0:", -- Kraken Tooth
	[46956]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Pristine Ametrine
	[46958]="0:2:4:1:Dagger::1:0:", -- Steel Bladebreaker
	[46959]="0:4:4:1:Ring::1:0:", -- Band of the Violent Temperment
	[46960]="0:4:4:1:Mail::1:0:", -- Breastplate of Cruel Intent
	[46961]="0:4:4:1:Plate::1:0:", -- Boneshatter Armplates
	[46962]="0:4:4:1:Plate::1:0:", -- Chestplate of the Towering Monstrosity
	[46963]="0:4:4:1:Shield::1:0:", -- Crystal Plated Vanguard
	[46964]="0:4:4:1:Shield::1:0:", -- Crystal Plated Vanguard
	[46965]="0:4:4:1:Mail::1:0:", -- Breastplate of Cruel Intent
	[46966]="0:4:4:1:Ring::1:0:", -- Band of the Violent Temperment
	[46967]="0:4:4:1:Plate::1:0:", -- Boneshatter Armplates
	[46968]="0:4:4:1:Plate::1:0:", -- Chestplate of the Towering Monstrosity
	[46969]="0:2:4:1:Dagger::1:0:", -- Steel Bladebreaker
	[46970]="0:4:4:1:Cloak::1:0:", -- Drape of the Untamed Predator
	[46971]="0:4:4:1:Cloak::1:0:", -- Drape of the Untamed Predator
	[46972]="0:4:4:1:Cloth::1:0:", -- Cord of the Tenebrous Mist
	[46973]="0:4:4:1:Cloth::1:0:", -- Cord of the Tenebrous Mist
	[46974]="0:4:4:1:Leather::1:0:", -- Leggings of the Broken Beast
	[46975]="0:4:4:1:Leather::1:0:", -- Leggings of the Broken Beast
	[46976]="0:4:4:1:Cloak::1:0:", -- Shawl of the Refreshing Winds
	[46977]="0:4:4:1:Cloak::1:0:", -- Shawl of the Refreshing Winds
	[46978]="0:4:1:1:Totem::1:0:", -- Totem of the Earthen Ring
	[46979]="0:2:4:1:Dagger::1:0:", -- Blade of Tarasque
	[46980]="0:2:4:1:Dagger::1:0:", -- Blade of Tarasque
	[46985]="0:4:4:1:Plate::1:0:", -- Boots of the Courageous
	[46986]="0:4:4:1:Plate::1:0:", -- Boots of the Courageous
	[46988]="0:4:4:1:Leather::1:0:", -- Boots of the Unrelenting Storm
	[46989]="0:4:4:1:Leather::1:0:", -- Boots of the Unrelenting Storm
	[46990]="0:4:4:1:Mail::1:0:", -- Belt of the Ice Burrower
	[46991]="0:4:4:1:Mail::1:0:", -- Belt of the Ice Burrower
	[46992]="0:4:4:1:Cloth::1:0:", -- Flowing Vestments of Ascent
	[46993]="0:4:4:1:Cloth::1:0:", -- Flowing Vestments of Ascent
	[46994]="0:2:4:1:Crossbow::1:0:", -- Talonstrike
	[46995]="0:2:4:1:Crossbow::1:0:", -- Talonstrike
	[46996]="0:2:4:1:OneHandAxe::1:0:", -- Lionhead Slasher
	[46997]="0:4:4:1:Plate::1:0:", -- Dawnbreaker Greaves
	[46999]="0:4:4:1:Plate::1:0:", -- Bloodbath Belt
	[47000]="0:4:4:1:Leather::1:0:", -- Cuirass of Calamitous Fate
	[47001]="0:2:4:1:OneHandAxe::1:0:", -- Lionhead Slasher
	[47002]="0:4:4:1:Plate::1:0:", -- Bloodbath Belt
	[47003]="0:4:4:1:Plate::1:0:", -- Dawnbreaker Greaves
	[47004]="0:4:4:1:Leather::1:0:", -- Cuirass of Calamitous Fate
	[47006]="0:12:1:1:::1:0:", -- Kvaldir War Horn
	[47007]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Reckless Ametrine
	[47008]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Glinting Ametrine
	[47009]="0:12:1:1:::1:0:", -- Mistcaller's Charm
	[47010]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Accurate Ametrine
	[47011]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Wicked Ametrine
	[47012]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Glimmering Ametrine
	[47015]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Champion's Ametrine
	[47016]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Empowered Ametrine
	[47017]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Stalwart Ametrine
	[47018]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Resplendent Ametrine
	[47019]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Fierce Ametrine
	[47020]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Deft Ametrine
	[47021]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Lucent Ametrine
	[47022]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Resolute Ametrine
	[47023]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Stark Ametrine
	[47029]="0:12:1:1:::1:0:", -- Captured Kvaldir Banner
	[47030]="0:0:1:1:Consumable::1:0:", -- Huge Seaforium Bombs
	[47033]="0:12:1:1:::1:0:", -- Light-Blessed Relic
	[47035]="0:12:1:10:::1:0:", -- Discarded Soul Crystal
	[47036]="0:12:1:5:::1:0:", -- Fresh Chum
	[47037]="0:12:1:5:::1:0:", -- North Sea Shark Meat
	[47041]="0:4:4:1:Trinket::1:0:", -- Solace of the Defeated
	[47042]="0:4:4:1:Cloak::1:0:", -- Pride of the Eredar
	[47043]="0:4:4:1:Amulet::1:0:", -- Charge of the Demon Lord
	[47048]="0:12:1:1:::1:0:", -- Doctor Kohler's Orders
	[47051]="0:4:4:1:Cloth::1:0:", -- Leggings of the Soothing Touch
	[47052]="0:4:4:1:Plate::1:0:", -- Legguards of Feverish Dedication
	[47053]="0:4:4:1:OffHandFrill::1:0:", -- Symbol of Transgression
	[47054]="0:4:4:1:Ring::1:0:", -- Band of Deplorable Violence
	[47055]="0:4:4:1:Leather::1:0:", -- Bracers of the Autumn Willow
	[47056]="0:4:4:1:Mail::1:0:", -- Bracers of Cloudy Omen
	[47057]="0:4:4:1:Plate::1:0:", -- Legplates of Failing Light
	[47059]="0:4:4:1:Trinket::1:0:", -- Solace of the Defeated
	[47060]="0:4:4:1:Amulet::1:0:", -- Charge of the Demon Lord
	[47061]="0:4:4:1:Plate::1:0:", -- Legguards of Feverish Dedication
	[47062]="0:4:4:1:Cloth::1:0:", -- Leggings of the Soothing Touch
	[47063]="0:4:4:1:Cloak::1:0:", -- Pride of the Eredar
	[47064]="0:4:4:1:OffHandFrill::1:0:", -- Symbol of Transgression
	[47066]="0:4:4:1:Leather::1:0:", -- Bracers of the Autumn Willow
	[47067]="0:4:4:1:Plate::1:0:", -- Legplates of Failing Light
	[47068]="0:4:4:1:Mail::1:0:", -- Bracers of Cloudy Omen
	[47069]="0:2:4:1:TwoHandAxe::1:0:", -- Justicebringer
	[47070]="0:4:4:1:Ring::1:0:", -- Ring of Callous Aggression
	[47071]="0:4:4:1:Leather::1:0:", -- Treads of the Icewalker
	[47072]="0:4:4:1:Plate::1:0:", -- Girdle of Bloodied Scars
	[47073]="0:4:4:1:Mail::1:0:", -- Bracers of the Untold Massacre
	[47074]="0:4:4:1:Mail::1:0:", -- Bracers of the Untold Massacre
	[47075]="0:4:4:1:Ring::1:0:", -- Ring of Callous Aggression
	[47076]="0:4:4:1:Plate::1:0:", -- Girdle of Bloodied Scars
	[47077]="0:4:4:1:Leather::1:0:", -- Treads of the Icewalker
	[47078]="0:2:4:1:TwoHandAxe::1:0:", -- Justicebringer
	[47079]="0:4:4:1:Shield::1:0:", -- Bastion of Purity
	[47080]="0:4:4:1:Trinket::1:0:", -- Satrina's Impeding Scarab
	[47081]="0:4:4:1:Cloth::1:0:", -- Cord of Biting Cold
	[47082]="0:4:4:1:Plate::1:0:", -- Chestplate of the Frostborn Hero
	[47083]="0:4:4:1:Mail::1:0:", -- Legguards of Concealed Hatred
	[47084]="0:4:4:1:Cloth::1:0:", -- Cord of Biting Cold
	[47085]="0:4:4:1:Shield::1:0:", -- Bastion of Purity
	[47086]="0:4:4:1:Plate::1:0:", -- Chestplate of the Frostborn Hero
	[47087]="0:4:4:1:Mail::1:0:", -- Legguards of Concealed Hatred
	[47088]="0:4:4:1:Trinket::1:0:", -- Satrina's Impeding Scarab
	[47089]="0:4:4:1:Cloak::1:0:", -- Cloak of Displacement
	[47090]="0:4:4:1:Mail::1:0:", -- Boots of Tremoring Earth
	[47092]="0:4:4:1:Cloth::1:0:", -- Boots of the Mourning Widow
	[47093]="0:4:4:1:Plate::1:0:", -- Vambraces of the Broken Bond
	[47094]="0:4:4:1:Leather::1:0:", -- Vestments of the Shattered Fellowship
	[47095]="0:4:4:1:Cloak::1:0:", -- Cloak of Displacement
	[47096]="0:4:4:1:Leather::1:0:", -- Vestments of the Shattered Fellowship
	[47097]="0:4:4:1:Cloth::1:0:", -- Boots of the Mourning Widow
	[47098]="0:4:4:1:Plate::1:0:", -- Vambraces of the Broken Bond
	[47099]="0:4:4:1:Mail::1:0:", -- Boots of Tremoring Earth
	[47100]="10000:15:3:1:Mount::1:0:4730", -- Reins of the Striped Dawnsaber
	[47101]="100000:15:4:1:Mount::1:0:4731", -- Ochre Skeletal Warhorse
	[47104]="0:2:4:1:Dagger::1:0:", -- Twin Spike
	[47105]="0:4:4:1:Amulet::1:0:", -- The Executioner's Malice
	[47106]="0:4:4:1:Mail::1:0:", -- Sabatons of Ruthless Judgment
	[47107]="0:4:4:1:Leather::1:0:", -- Belt of the Merciless Killer
	[47108]="0:4:4:1:Plate::1:0:", -- Bracers of the Shieldmaiden
	[47109]="0:4:4:1:Mail::1:0:", -- Sabatons of Ruthless Judgment
	[47110]="0:4:4:1:Amulet::1:0:", -- The Executioner's Malice
	[47111]="0:4:4:1:Plate::1:0:", -- Bracers of the Shieldmaiden
	[47112]="0:4:4:1:Leather::1:0:", -- Belt of the Merciless Killer
	[47113]="0:2:4:1:Dagger::1:0:", -- Twin Spike
	[47114]="0:2:4:1:Stave::1:0:", -- Lupine Longstaff
	[47115]="0:4:4:1:Trinket::1:0:", -- Death's Verdict
	[47116]="0:4:4:1:Amulet::1:0:", -- The Arbiter's Muse
	[47121]="0:4:4:1:Plate::1:0:", -- Legguards of Ascension
	[47126]="0:4:4:1:Cloth::1:0:", -- Skyweaver Robes
	[47129]="0:4:4:1:Cloth::1:0:", -- Skyweaver Robes
	[47130]="0:2:4:1:Stave::1:0:", -- Lupine Longstaff
	[47131]="0:4:4:1:Trinket::1:0:", -- Death's Verdict
	[47132]="0:4:4:1:Plate::1:0:", -- Legguards of Ascension
	[47133]="0:4:4:1:Amulet::1:0:", -- The Arbiter's Muse
	[47138]="0:4:4:1:OffHandFrill::1:0:", -- Chalice of Searing Light
	[47139]="0:4:4:1:Amulet::1:0:", -- Wail of the Val'kyr
	[47140]="0:4:4:1:Leather::1:0:", -- Cord of Pale Thorns
	[47141]="0:4:4:1:Cloth::1:0:", -- Bindings of Dark Essence
	[47142]="0:4:4:1:Plate::1:0:", -- Breastplate of the Frozen Lake
	[47143]="0:4:4:1:Cloth::1:0:", -- Bindings of Dark Essence
	[47144]="0:4:4:1:Amulet::1:0:", -- Wail of the Val'kyr
	[47145]="0:4:4:1:Leather::1:0:", -- Cord of Pale Thorns
	[47146]="0:4:4:1:OffHandFrill::1:0:", -- Chalice of Searing Light
	[47147]="0:4:4:1:Plate::1:0:", -- Breastplate of the Frozen Lake
	[47148]="0:2:4:1:OneHandAxe::1:0:", -- Stormpike Cleaver
	[47149]="0:4:4:1:Ring::1:0:", -- Signet of the Traitor King
	[47150]="0:4:4:1:Plate::1:0:", -- Greaves of the 7th Legion
	[47151]="0:4:4:1:Leather::1:0:", -- Bracers of Dark Determination
	[47152]="0:4:4:1:Mail::1:0:", -- Belt of Deathly Dominion
	[47153]="0:4:4:1:Mail::1:0:", -- Belt of Deathly Dominion
	[47154]="0:4:4:1:Plate::1:0:", -- Greaves of the 7th Legion
	[47155]="0:4:4:1:Leather::1:0:", -- Bracers of Dark Determination
	[47156]="0:2:4:1:OneHandAxe::1:0:", -- Stormpike Cleaver
	[47157]="0:4:4:1:Ring::1:0:", -- Signet of the Traitor King
	[47170]="0:4:4:1:Leather::1:0:", -- Belt of Fierce Competition
	[47171]="0:4:4:1:Plate::1:0:", -- Legguards of Abandoned Fealty
	[47172]="0:4:4:1:Plate::1:0:", -- Helm of the Bested Gallant
	[47173]="0:4:4:1:Cloth::1:0:", -- Bindings of the Wicked
	[47174]="0:4:4:1:Leather::1:0:", -- Binding of the Tranquil Glade
	[47175]="0:4:4:1:Mail::1:0:", -- Scale Boots of the Outlander
	[47176]="0:4:4:1:Plate::1:0:", -- Breastplate of the Imperial Joust
	[47177]="0:4:4:1:Leather::1:0:", -- Gloves of the Argent Fanatic
	[47178]="0:4:4:1:Mail::1:0:", -- Carapace of Grim Visions
	[47179]="0:15:4:1:Mount::1:0:34885", -- Argent Charger
	[47180]="0:15:4:1:Mount::1:0:34885", -- Argent Warhorse
	[47181]="0:4:4:1:Cloth::1:0:", -- Belt of the Churning Blaze
	[47182]="0:4:4:1:Trinket::1:0:", -- Reign of the Unliving
	[47183]="0:4:4:1:Cloak::1:0:", -- Strength of the Nerub
	[47184]="0:4:4:1:Mail::1:0:", -- Legguards of the Lurking Threat
	[47185]="0:4:4:1:Cloth::1:0:", -- Leggings of the Haggard Apprentice
	[47186]="0:4:4:1:Leather::1:0:", -- Legwraps of the Awakening
	[47187]="0:4:4:1:Cloth::1:0:", -- Leggings of the Deepening Void
	[47188]="0:4:4:1:Trinket::1:0:", -- Reign of the Unliving
	[47189]="0:4:4:1:Cloth::1:0:", -- Leggings of the Deepening Void
	[47190]="0:4:4:1:Leather::1:0:", -- Legwraps of the Awakening
	[47191]="0:4:4:1:Mail::1:0:", -- Legguards of the Lurking Threat
	[47192]="0:4:4:1:Cloak::1:0:", -- Strength of the Nerub
	[47193]="0:2:4:1:OneHandMace::1:0:", -- Misery's End
	[47194]="0:4:4:1:Cloth::1:0:", -- Footpads of the Icy Floe
	[47195]="0:4:4:1:Plate::1:0:", -- Belt of the Forgotten Martyr
	[47196]="0:12:1:20:::1:0:", -- Venomhide Baby Tooth
	[47197]="0:4:4:1:Plate::1:0:", -- Gauntlets of the Stouthearted Crusader
	[47199]="0:4:4:1:Plate::1:0:", -- Greaves of the Grand Paladin
	[47200]="0:4:4:1:Ring::1:0:", -- Signet of Purity
	[47201]="0:4:4:1:Plate::1:0:", -- Boots of Heartfelt Repentance
	[47202]="0:4:4:1:Leather::1:0:", -- Leggings of Brazen Trespass
	[47203]="0:4:4:1:Cloth::1:0:", -- Armbands of the Ashen Saint
	[47204]="0:4:4:1:Mail::1:0:", -- Chestguard of Flowing Elements
	[47205]="0:4:4:1:Cloth::1:0:", -- Footpads of the Icy Floe
	[47206]="0:2:4:1:OneHandMace::1:0:", -- Misery's End
	[47207]="0:4:4:1:Plate::1:0:", -- Belt of the Forgotten Martyr
	[47208]="0:4:4:1:Cloth::1:0:", -- Armbands of the Ashen Saint
	[47209]="0:4:4:1:Mail::1:0:", -- Chestguard of Flowing Elements
	[47210]="0:4:4:1:Leather::1:0:", -- Mantle of Gnarled Overgrowth
	[47211]="0:4:4:1:Mail::1:0:", -- Wristguards of Ceaseless Regret
	[47212]="0:4:4:1:Plate::1:0:", -- Mercy's Hold
	[47213]="0:4:4:1:Trinket::1:0:", -- Abyssal Rune
	[47214]="0:4:4:1:Trinket::1:0:", -- Banner of Victory
	[47215]="0:4:4:1:Trinket::1:0:", -- Tears of the Vanquished
	[47216]="0:4:4:1:Trinket::1:0:", -- The Black Heart
	[47217]="0:4:4:1:Leather::1:0:", -- Gaze of the Somber Keeper
	[47218]="0:4:4:1:Cloth::1:0:", -- The Confessor's Binding
	[47219]="0:4:4:1:Amulet::1:0:", -- Brilliant Hailstone Amulet
	[47220]="0:4:4:1:Plate::1:0:", -- Helm of the Violent Fray
	[47221]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Infamous Knave
	[47222]="0:4:4:1:Ring::1:0:", -- Uruka's Band of Zeal
	[47223]="0:4:4:1:Ring::1:0:", -- Ring of the Darkmender
	[47224]="0:4:4:1:Ring::1:0:", -- Ring of the Darkmender
	[47225]="0:4:4:1:Cloak::1:0:", -- Maiden's Favor
	[47226]="0:4:4:1:Cloth::1:0:", -- Mantle of Inconsolable Fear
	[47227]="0:4:4:1:Plate::1:0:", -- Girdle of the Pallid Knight
	[47228]="0:4:4:1:Mail::1:0:", -- Leggings of the Bloodless Knight
	[47229]="0:4:4:1:Plate::1:0:", -- Girdle of Arrogant Downfall
	[47230]="0:4:4:1:Cloth::1:0:", -- Handwraps of Surrendered Hope
	[47231]="0:4:4:1:Mail::1:0:", -- Belt of Merciless Cruelty
	[47232]="0:4:4:1:Cloak::1:0:", -- Drape of the Undefeated
	[47233]="0:2:4:1:Polearm::1:0:", -- Archon Glaive
	[47234]="0:4:4:1:Plate::1:0:", -- Gloves of Bitter Reprisal
	[47235]="0:4:4:1:Cloth::1:0:", -- Gloves of the Lifeless Touch
	[47236]="0:4:4:1:Cloth::1:0:", -- Gloves of the Lifeless Touch
	[47237]="0:4:4:1:Ring::1:0:", -- Band of Deplorable Violence
	[47238]="0:4:4:1:Cloak::1:0:", -- Maiden's Favor
	[47239]="0:2:4:1:Polearm::1:0:", -- Archon Glaive
	[47240]="0:4:4:1:Plate::1:0:", -- Gloves of Bitter Reprisal
	[47241]="0:10:4::Currency::1:0:35790,37941,37942,38858", -- Emblem of Triumph
	[47242]="0:15:4:1:ArmorToken::1:0:", -- Trophy of the Crusade
	[47243]="0:4:4:1:Ring::1:0:", -- Mark of the Relentless
	[47244]="0:4:4:1:Mail::1:0:", -- Chestguard of the Ravenous Fiend
	[47245]="0:4:4:1:Mail::1:0:", -- Pauldrons of Concealed Loathing
	[47246]="0:12:3:1:::1:0:", -- Writ of Merit
	[47247]="0:12:3:1:::1:0:", -- Writ of Merit
	[47248]="0:4:4:1:Leather::1:0:", -- Treads of Dismal Fortune
	[47249]="0:4:4:1:Leather::1:0:", -- Leggings of the Snowy Bramble
	[47250]="0:4:4:1:Mail::1:0:", -- Pauldrons of the Deafening Gale
	[47251]="0:4:4:1:Mail::1:0:", -- Cuirass of Cruel Intent
	[47252]="0:4:4:1:Ring::1:0:", -- Ring of the Violent Temperament
	[47253]="0:4:4:1:Plate::1:0:", -- Boneshatter Vambraces
	[47254]="0:4:4:1:Plate::1:0:", -- Hauberk of the Towering Monstrosity
	[47255]="0:2:4:1:Dagger::1:0:", -- Stygian Bladebreaker
	[47256]="0:4:4:1:Cloak::1:0:", -- Drape of the Refreshing Winds
	[47257]="0:4:4:1:Cloak::1:0:", -- Cloak of the Untamed Predator
	[47258]="0:4:4:1:Cloth::1:0:", -- Belt of the Tenebrous Mist
	[47259]="0:4:4:1:Leather::1:0:", -- Legwraps of the Broken Beast
	[47260]="0:4:4:1:Shield::1:0:", -- Forlorn Barrier
	[47261]="0:2:4:1:Dagger::1:0:", -- Barb of Tarasque
	[47262]="0:4:4:1:Leather::1:0:", -- Boots of the Harsh Winter
	[47263]="0:4:4:1:Plate::1:0:", -- Sabatons of the Courageous
	[47264]="0:4:4:1:Cloth::1:0:", -- Flowing Robes of Ascent
	[47265]="0:4:4:1:Mail::1:0:", -- Binding of the Ice Burrower
	[47266]="0:2:4:1:OneHandAxe::1:0:", -- Blood Fury
	[47267]="0:2:4:1:Crossbow::1:0:", -- Death's Head Crossbow
	[47268]="0:4:4:1:Plate::1:0:", -- Bloodbath Girdle
	[47269]="0:4:4:1:Plate::1:0:", -- Dawnbreaker Sabatons
	[47270]="0:4:4:1:Leather::1:0:", -- Vest of Calamitous Fate
	[47271]="0:4:4:1:Trinket::1:0:", -- Solace of the Fallen
	[47272]="0:4:4:1:Amulet::1:0:", -- Charge of the Eredar
	[47273]="0:4:4:1:Plate::1:0:", -- Legplates of Feverish Dedication
	[47274]="0:4:4:1:Cloth::1:0:", -- Pants of the Soothing Touch
	[47275]="0:4:4:1:Cloak::1:0:", -- Pride of the Demon Lord
	[47276]="0:4:4:1:OffHandFrill::1:0:", -- Talisman of Heedless Sins
	[47277]="0:4:4:1:Leather::1:0:", -- Bindings of the Autumn Willow
	[47278]="0:4:4:1:Ring::1:0:", -- Circle of the Darkmender
	[47279]="0:4:4:1:Plate::1:0:", -- Leggings of Failing Light
	[47280]="0:4:4:1:Mail::1:0:", -- Wristwraps of Cloudy Omen
	[47281]="0:4:4:1:Mail::1:0:", -- Bracers of the Silent Massacre
	[47282]="0:4:4:1:Ring::1:0:", -- Band of Callous Aggression
	[47283]="0:4:4:1:Plate::1:0:", -- Belt of Bloodied Scars
	[47284]="0:4:4:1:Leather::1:0:", -- Icewalker Treads
	[47285]="0:2:4:1:TwoHandAxe::1:0:", -- Dual-blade Butcher
	[47286]="0:4:4:1:Cloth::1:0:", -- Belt of Biting Cold
	[47287]="0:4:4:1:Shield::1:0:", -- Bastion of Resolve
	[47288]="0:4:4:1:Plate::1:0:", -- Chestplate of the Frostwolf Hero
	[47289]="0:4:4:1:Mail::1:0:", -- Leggings of Concealed Hatred
	[47290]="0:4:4:1:Trinket::1:0:", -- Juggernaut's Vitality
	[47291]="0:4:4:1:Cloak::1:0:", -- Shroud of Displacement
	[47292]="0:4:4:1:Leather::1:0:", -- Robes of the Shattered Fellowship
	[47293]="0:4:4:1:Cloth::1:0:", -- Sandals of the Mourning Widow
	[47294]="0:4:4:1:Plate::1:0:", -- Bracers of the Broken Bond
	[47295]="0:4:4:1:Mail::1:0:", -- Sabatons of Tremoring Earth
	[47296]="0:4:4:1:Mail::1:0:", -- Greaves of Ruthless Judgment
	[47297]="0:4:4:1:Amulet::1:0:", -- The Executioner's Vice
	[47298]="0:4:4:1:Plate::1:0:", -- Armguards of the Shieldmaiden
	[47299]="0:4:4:1:Leather::1:0:", -- Belt of the Pitiless Killer
	[47300]="0:2:4:1:Dagger::1:0:", -- Gouge of the Frigid Heart
	[47301]="0:4:4:1:Cloth::1:0:", -- Skyweaver Vestments
	[47302]="0:2:4:1:Stave::1:0:", -- Twin's Pact
	[47303]="0:4:4:1:Trinket::1:0:", -- Death's Choice
	[47304]="0:4:4:1:Plate::1:0:", -- Legplates of Ascension
	[47305]="0:4:4:1:Amulet::1:0:", -- Legionnaire's Gorget
	[47306]="0:4:4:1:Cloth::1:0:", -- Dark Essence Bindings
	[47307]="0:4:4:1:Amulet::1:0:", -- Cry of the Val'kyr
	[47308]="0:4:4:1:Leather::1:0:", -- Belt of Pale Thorns
	[47309]="0:4:4:1:OffHandFrill::1:0:", -- Mystifying Charm
	[47310]="0:4:4:1:Plate::1:0:", -- Chestplate of the Frozen Lake
	[47311]="0:4:4:1:Mail::1:0:", -- Waistguard of Deathly Dominion
	[47312]="0:4:4:1:Plate::1:0:", -- Greaves of the Saronite Citadel
	[47313]="0:4:4:1:Leather::1:0:", -- Armbands of Dark Determination
	[47314]="0:2:4:1:OneHandAxe::1:0:", -- Hellscream Slicer
	[47315]="0:4:4:1:Ring::1:0:", -- Band of the Traitor King
	[47316]="0:4:4:1:Trinket::1:0:", -- Reign of the Dead
	[47317]="0:4:4:1:Cloth::1:0:", -- Breeches of the Deepening Void
	[47318]="0:4:4:1:Leather::1:0:", -- Leggings of the Awakening
	[47319]="0:4:4:1:Mail::1:0:", -- Leggings of the Lurking Threat
	[47320]="0:4:4:1:Cloak::1:0:", -- Might of the Nerub
	[47321]="0:4:4:1:Cloth::1:0:", -- Boots of the Icy Floe
	[47322]="0:2:4:1:OneHandMace::1:0:", -- Suffering's End
	[47323]="0:4:4:1:Plate::1:0:", -- Girdle of the Forgotten Martyr
	[47324]="0:4:4:1:Cloth::1:0:", -- Bindings of the Ashen Saint
	[47325]="0:4:4:1:Mail::1:0:", -- Cuirass of Flowing Elements
	[47326]="0:4:4:1:Cloth::1:0:", -- Handwraps of the Lifeless Touch
	[47327]="0:4:4:1:Ring::1:0:", -- Lurid Manifestation
	[47328]="0:4:4:1:Cloak::1:0:", -- Maiden's Adoration
	[47329]="0:2:4:1:Polearm::1:0:", -- Hellion Glaive
	[47330]="0:4:4:1:Plate::1:0:", -- Gauntlets of Bitter Reprisal
	[47395]="0:10:2::Currency::1:0:", -- Isle of Conquest Mark of Honor
	[47412]="0:4:4:1:Mail::1:0:", -- Cuirass of Cruel Intent
	[47413]="0:4:4:1:Ring::1:0:", -- Ring of the Violent Temperament
	[47414]="0:4:4:1:Plate::1:0:", -- Boneshatter Vambraces
	[47415]="0:4:4:1:Plate::1:0:", -- Hauberk of the Towering Monstrosity
	[47416]="0:2:4:1:Dagger::1:0:", -- Stygian Bladebreaker
	[47417]="0:4:4:1:Cloak::1:0:", -- Drape of the Refreshing Winds
	[47418]="0:4:4:1:Cloak::1:0:", -- Cloak of the Untamed Predator
	[47419]="0:4:4:1:Cloth::1:0:", -- Belt of the Tenebrous Mist
	[47420]="0:4:4:1:Leather::1:0:", -- Legwraps of the Broken Beast
	[47421]="0:4:4:1:Shield::1:0:", -- Forlorn Barrier
	[47422]="0:2:4:1:Dagger::1:0:", -- Barb of Tarasque
	[47423]="0:4:4:1:Leather::1:0:", -- Boots of the Harsh Winter
	[47424]="0:4:4:1:Plate::1:0:", -- Sabatons of the Courageous
	[47425]="0:4:4:1:Cloth::1:0:", -- Flowing Robes of Ascent
	[47426]="0:4:4:1:Mail::1:0:", -- Binding of the Ice Burrower
	[47427]="0:2:4:1:OneHandAxe::1:0:", -- Blood Fury
	[47428]="0:2:4:1:Crossbow::1:0:", -- Death's Head Crossbow
	[47429]="0:4:4:1:Plate::1:0:", -- Bloodbath Girdle
	[47430]="0:4:4:1:Plate::1:0:", -- Dawnbreaker Sabatons
	[47431]="0:4:4:1:Leather::1:0:", -- Vest of Calamitous Fate
	[47432]="0:4:4:1:Trinket::1:0:", -- Solace of the Fallen
	[47433]="0:4:4:1:Amulet::1:0:", -- Charge of the Eredar
	[47434]="0:4:4:1:Plate::1:0:", -- Legplates of Feverish Dedication
	[47435]="0:4:4:1:Cloth::1:0:", -- Pants of the Soothing Touch
	[47436]="0:4:4:1:Cloak::1:0:", -- Pride of the Demon Lord
	[47437]="0:4:4:1:OffHandFrill::1:0:", -- Talisman of Heedless Sins
	[47438]="0:4:4:1:Leather::1:0:", -- Bindings of the Autumn Willow
	[47439]="0:4:4:1:Ring::1:0:", -- Circle of the Darkmender
	[47440]="0:4:4:1:Plate::1:0:", -- Leggings of Failing Light
	[47441]="0:4:4:1:Mail::1:0:", -- Wristwraps of Cloudy Omen
	[47442]="0:4:4:1:Mail::1:0:", -- Bracers of the Silent Massacre
	[47443]="0:4:4:1:Ring::1:0:", -- Band of Callous Aggression
	[47444]="0:4:4:1:Plate::1:0:", -- Belt of Bloodied Scars
	[47445]="0:4:4:1:Leather::1:0:", -- Icewalker Treads
	[47446]="0:2:4:1:TwoHandAxe::1:0:", -- Dual-blade Butcher
	[47447]="0:4:4:1:Cloth::1:0:", -- Belt of Biting Cold
	[47448]="0:4:4:1:Shield::1:0:", -- Bastion of Resolve
	[47449]="0:4:4:1:Plate::1:0:", -- Chestplate of the Frostwolf Hero
	[47450]="0:4:4:1:Mail::1:0:", -- Leggings of Concealed Hatred
	[47451]="0:4:4:1:Trinket::1:0:", -- Juggernaut's Vitality
	[47452]="0:4:4:1:Cloak::1:0:", -- Shroud of Displacement
	[47453]="0:4:4:1:Leather::1:0:", -- Robes of the Shattered Fellowship
	[47454]="0:4:4:1:Cloth::1:0:", -- Sandals of the Mourning Widow
	[47455]="0:4:4:1:Plate::1:0:", -- Bracers of the Broken Bond
	[47456]="0:4:4:1:Mail::1:0:", -- Sabatons of Tremoring Earth
	[47457]="0:4:4:1:Mail::1:0:", -- Greaves of Ruthless Judgment
	[47458]="0:4:4:1:Amulet::1:0:", -- The Executioner's Vice
	[47459]="0:4:4:1:Plate::1:0:", -- Armguards of the Shieldmaiden
	[47460]="0:4:4:1:Leather::1:0:", -- Belt of the Pitiless Killer
	[47461]="0:2:4:1:Dagger::1:0:", -- Gouge of the Frigid Heart
	[47462]="0:4:4:1:Cloth::1:0:", -- Skyweaver Vestments
	[47463]="0:2:4:1:Stave::1:0:", -- Twin's Pact
	[47464]="0:4:4:1:Trinket::1:0:", -- Death's Choice
	[47465]="0:4:4:1:Plate::1:0:", -- Legplates of Ascension
	[47466]="0:4:4:1:Amulet::1:0:", -- Legionnaire's Gorget
	[47467]="0:4:4:1:Cloth::1:0:", -- Dark Essence Bindings
	[47468]="0:4:4:1:Amulet::1:0:", -- Cry of the Val'kyr
	[47469]="0:4:4:1:Leather::1:0:", -- Belt of Pale Thorns
	[47470]="0:4:4:1:OffHandFrill::1:0:", -- Mystifying Charm
	[47471]="0:4:4:1:Plate::1:0:", -- Chestplate of the Frozen Lake
	[47472]="0:4:4:1:Mail::1:0:", -- Waistguard of Deathly Dominion
	[47473]="0:4:4:1:Plate::1:0:", -- Greaves of the Saronite Citadel
	[47474]="0:4:4:1:Leather::1:0:", -- Armbands of Dark Determination
	[47475]="0:2:4:1:OneHandAxe::1:0:", -- Hellscream Slicer
	[47476]="0:4:4:1:Ring::1:0:", -- Band of the Traitor King
	[47477]="0:4:4:1:Trinket::1:0:", -- Reign of the Dead
	[47478]="0:4:4:1:Cloth::1:0:", -- Breeches of the Deepening Void
	[47479]="0:4:4:1:Leather::1:0:", -- Leggings of the Awakening
	[47480]="0:4:4:1:Mail::1:0:", -- Leggings of the Lurking Threat
	[47481]="0:4:4:1:Cloak::1:0:", -- Might of the Nerub
	[47482]="0:4:4:1:Cloth::1:0:", -- Boots of the Icy Floe
	[47483]="0:2:4:1:OneHandMace::1:0:", -- Suffering's End
	[47484]="0:4:4:1:Plate::1:0:", -- Girdle of the Forgotten Martyr
	[47485]="0:4:4:1:Cloth::1:0:", -- Bindings of the Ashen Saint
	[47486]="0:4:4:1:Mail::1:0:", -- Cuirass of Flowing Elements
	[47487]="0:4:4:1:Cloth::1:0:", -- Handwraps of the Lifeless Touch
	[47489]="0:4:4:1:Ring::1:0:", -- Lurid Manifestation
	[47490]="0:4:4:1:Cloak::1:0:", -- Maiden's Adoration
	[47491]="0:2:4:1:Polearm::1:0:", -- Hellion Glaive
	[47492]="0:4:4:1:Plate::1:0:", -- Gauntlets of Bitter Reprisal
	[47493]="0:2:4:1:TwoHandAxe::1:0:", -- Edge of Ruin
	[47494]="0:4:4:1:Amulet::1:0:", -- Ancient Pendant of Arathor
	[47495]="0:4:4:1:Plate::1:0:", -- Legplates of Relentless Onslaught
	[47496]="0:4:4:1:Leather::1:0:", -- Armbands of the Wary Lookout
	[47497]="0:4:4:1:Plate::1:0:", -- Helm of the Crestfallen Challenger
	[47498]="0:4:4:1:Leather::1:0:", -- Gloves of Dismal Fortune
	[47499]="0:0:3:1:Flask::1:0:", -- Flask of the North
	[47500]="0:2:4:1:OneHandSword::1:0:", -- Peacekeeper Blade
	[47501]="0:4:4:1:Cloak::1:0:", -- Kurisu's Indecision
	[47502]="0:4:4:1:Plate::1:0:", -- Majestic Silversmith Shoulderplates
	[47503]="0:4:4:1:Plate::1:0:", -- Legplates of the Argent Armistice
	[47504]="0:4:4:1:Leather::1:0:", -- Barkhide Treads
	[47506]="0:2:4:1:OneHandSword::1:0:", -- Silverwing Defender
	[47508]="0:2:4:1:OneHandMace::1:0:", -- Aledar's Battlestar
	[47509]="0:2:4:1:OneHandMace::1:0:", -- Mariel's Sorrow
	[47510]="0:4:4:1:Plate::1:0:", -- Trueheart Girdle
	[47511]="0:4:4:1:Plate::1:0:", -- Plated Greaves of Providence
	[47512]="0:4:4:1:Ring::1:0:", -- Sinner's Confession
	[47513]="0:2:4:1:OneHandSword::1:0:", -- Orgrim's Deflector
	[47514]="0:4:4:1:Plate::1:0:", -- Regal Aurous Shoulderplates
	[47515]="0:2:4:1:TwoHandSword::1:0:", -- Decimation
	[47516]="0:2:4:1:TwoHandSword::1:0:", -- Fleshrender
	[47517]="0:2:4:1:OneHandSword::1:0:", -- Blade of the Unbroken Covenant
	[47518]="0:2:4:1:OneHandSword::1:0:", -- Mortalis
	[47519]="0:2:4:1:TwoHandMace::1:0:", -- Catastrophe
	[47520]="0:2:4:1:TwoHandMace::1:0:", -- Grievance
	[47521]="0:2:4:1:Gun::1:0:", -- BRK-1000
	[47522]="0:2:4:1:Polearm::1:0:", -- Marrowstrike
	[47523]="0:2:4:1:Gun::1:0:", -- Fezzik's Autocannon
	[47524]="0:2:4:1:Stave::1:0:", -- Clemency
	[47525]="0:2:4:1:Stave::1:0:", -- Sufferance
	[47526]="0:2:4:1:OneHandMace::1:0:", -- Remorseless
	[47527]="0:4:4:1:Cloth::1:0:", -- Embrace of Madness
	[47528]="0:2:4:1:OneHandMace::1:0:", -- Cudgel of the Damned
	[47529]="0:4:4:1:Leather::1:0:", -- Mask of Distant Memory
	[47541]="0:0:3:1:Consumable::1:0:34885", -- Argent Pony Bridle
	[47545]="0:4:4:1:Cloak::1:0:", -- Vereesa's Dexterity
	[47546]="0:4:4:1:Cloak::1:0:", -- Sylvanas' Cunning
	[47547]="0:4:4:1:Cloak::1:0:", -- Varian's Furor
	[47548]="0:4:4:1:Cloak::1:0:", -- Garrosh's Rage
	[47549]="0:4:4:1:Cloak::1:0:", -- Magni's Resolution
	[47550]="0:4:4:1:Cloak::1:0:", -- Cairne's Endurance
	[47551]="0:4:4:1:Cloak::1:0:", -- Aethas' Intensity
	[47552]="0:4:4:1:Cloak::1:0:", -- Jaina's Radiance
	[47553]="0:4:4:1:Cloak::1:0:", -- Bolvar's Devotion
	[47554]="0:4:4:1:Cloak::1:0:", -- Lady Liadrin's Conviction
	[47556]="0:7:3:20:Other:164,165,197:1:0:35494,35495,35573,35574", -- Crusader Orb
	[47557]="0:15:4:1:ArmorToken::1:0:", -- Regalia of the Grand Conqueror
	[47558]="0:15:4:1:ArmorToken::1:0:", -- Regalia of the Grand Protector
	[47559]="0:15:4:1:ArmorToken::1:0:", -- Regalia of the Grand Vanquisher
	[47560]="0:4:4:1:Cloth::1:0:", -- Boots of the Crackling Flame
	[47561]="0:4:4:1:Mail::1:0:", -- Gloves of the Dark Exile
	[47562]="0:4:4:1:Amulet::1:0:", -- Symbol of Redemption
	[47563]="0:4:4:1:Mail::1:0:", -- Girdle of the Dauntless Conqueror
	[47564]="0:4:4:1:Cloth::1:0:", -- Gaze of the Unknown
	[47565]="0:4:4:1:Plate::1:0:", -- Vambraces of Unholy Command
	[47566]="0:4:4:1:Amulet::1:0:", -- The Warlord's Depravity
	[47567]="0:4:4:1:Plate::1:0:", -- Gauntlets of Revelation
	[47568]="0:2:4:1:Gun::1:0:", -- True-aim Long Rifle
	[47569]="0:2:4:1:Dagger::1:0:", -- Spectral Kris
	[47570]="0:4:4:1:Plate::1:0:", -- Saronite Swordbreakers
	[47571]="0:4:4:1:Plate::1:0:", -- Saronite Swordbreakers
	[47572]="0:4:4:1:Plate::1:0:", -- Titanium Spikeguards
	[47573]="0:4:4:1:Plate::1:0:", -- Titanium Spikeguards
	[47574]="0:4:4:1:Plate::1:0:", -- Sunforged Bracers
	[47575]="0:4:4:1:Plate::1:0:", -- Sunforged Bracers
	[47576]="0:4:4:1:Mail::1:0:", -- Crusader's Dragonscale Bracers
	[47577]="0:4:4:1:Mail::1:0:", -- Crusader's Dragonscale Bracers
	[47578]="0:4:4:1:Ring::1:0:", -- Carnivorous Band
	[47579]="0:4:4:1:Mail::1:0:", -- Black Chitin Bracers
	[47580]="0:4:4:1:Mail::1:0:", -- Black Chitin Bracers
	[47581]="0:4:4:1:Leather::1:0:", -- Bracers of Swift Death
	[47582]="0:4:4:1:Leather::1:0:", -- Bracers of Swift Death
	[47583]="0:4:4:1:Leather::1:0:", -- Moonshadow Armguards
	[47584]="0:4:4:1:Leather::1:0:", -- Moonshadow Armguards
	[47585]="0:4:4:1:Cloth::1:0:", -- Bejeweled Wizard's Bracers
	[47586]="0:4:4:1:Cloth::1:0:", -- Bejeweled Wizard's Bracers
	[47587]="0:4:4:1:Cloth::1:0:", -- Royal Moonshroud Bracers
	[47588]="0:4:4:1:Cloth::1:0:", -- Royal Moonshroud Bracers
	[47589]="0:4:4:1:Plate::1:0:", -- Titanium Razorplate
	[47590]="0:4:4:1:Plate::1:0:", -- Titanium Razorplate
	[47591]="0:4:4:1:Plate::1:0:", -- Breastplate of the White Knight
	[47592]="0:4:4:1:Plate::1:0:", -- Breastplate of the White Knight
	[47593]="0:4:4:1:Plate::1:0:", -- Sunforged Breastplate
	[47594]="0:4:4:1:Plate::1:0:", -- Sunforged Breastplate
	[47595]="0:4:4:1:Mail::1:0:", -- Crusader's Dragonscale Breastplate
	[47596]="0:4:4:1:Mail::1:0:", -- Crusader's Dragonscale Breastplate
	[47597]="0:4:4:1:Mail::1:0:", -- Ensorcelled Nerubian Breastplate
	[47598]="0:4:4:1:Mail::1:0:", -- Ensorcelled Nerubian Breastplate
	[47599]="0:4:4:1:Leather::1:0:", -- Knightbane Carapace
	[47600]="0:4:4:1:Leather::1:0:", -- Knightbane Carapace
	[47601]="0:4:4:1:Leather::1:0:", -- Lunar Eclipse Robes
	[47602]="0:4:4:1:Leather::1:0:", -- Lunar Eclipse Robes
	[47603]="0:4:4:1:Cloth::1:0:", -- Merlin's Robe
	[47604]="0:4:4:1:Cloth::1:0:", -- Merlin's Robe
	[47605]="0:4:4:1:Cloth::1:0:", -- Royal Moonshroud Robe
	[47606]="0:4:4:1:Cloth::1:0:", -- Royal Moonshroud Robe
	[47607]="0:4:4:1:Amulet::1:0:", -- Collar of Ceaseless Torment
	[47608]="0:4:4:1:Leather::1:0:", -- Acidmaw Boots
	[47609]="0:4:4:1:Plate::1:0:", -- Gauntlets of Rising Anger
	[47610]="0:4:4:1:Mail::1:0:", -- Armbands of the Northern Stalker
	[47611]="0:4:4:1:Plate::1:0:", -- Dreadscale Armguards
	[47612]="0:2:4:1:Wand::1:0:", -- Rod of Imprisoned Souls
	[47613]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Glacial Wilds
	[47614]="0:4:4:1:Plate::1:0:", -- Girdle of the Impaler
	[47615]="0:4:4:1:Plate::1:0:", -- Belt of the Frozen Reach
	[47616]="0:4:4:1:Mail::1:0:", -- Shoulderguards of the Spirit Walker
	[47617]="0:4:4:1:Cloth::1:0:", -- Icehowl Cinch
	[47618]="0:4:4:1:Ring::1:0:", -- Firestorm Ring
	[47619]="0:4:4:1:Amulet::1:0:", -- Amulet of Binding Elements
	[47620]="0:4:4:1:Cloth::1:0:", -- Leggings of the Demonic Messenger
	[47621]="0:4:4:1:Mail::1:0:", -- Girdle of the Farseer
	[47622]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Breastplate of the White Knight
	[47623]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Saronite Swordbreakers
	[47624]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Titanium Razorplate
	[47625]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Titanium Spikeguards
	[47626]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Sunforged Breastplate
	[47627]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Sunforged Bracers
	[47628]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Ensorcelled Nerubian Breastplate
	[47629]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Black Chitin Bracers
	[47630]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Crusader's Dragonscale Breastplate
	[47631]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Crusader's Dragonscale Bracers
	[47632]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Lunar Eclipse Robes
	[47633]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Moonshadow Armguards
	[47634]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Knightbane Carapace
	[47635]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Bracers of Swift Death
	[47636]="0:9:4:1:Tailoring::1:0:", -- Pattern: Royal Moonshroud Robe
	[47637]="0:9:4:1:Tailoring::1:0:", -- Pattern: Royal Moonshroud Bracers
	[47638]="0:9:4:1:Tailoring::1:0:", -- Pattern: Merlin's Robe
	[47639]="0:9:4:1:Tailoring::1:0:", -- Pattern: Bejeweled Wizard's Bracers
	[47640]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Breastplate of the White Knight
	[47641]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Saronite Swordbreakers
	[47642]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Sunforged Bracers
	[47643]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Sunforged Breastplate
	[47644]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Titanium Razorplate
	[47645]="0:9:4:1:Blacksmithing::1:0:", -- Plans: Titanium Spikeguards
	[47646]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Black Chitin Bracers
	[47647]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Bracers of Swift Death
	[47648]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Crusader's Dragonscale Bracers
	[47649]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Crusader's Dragonscale Breastplate
	[47650]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Ensorcelled Nerubian Breastplate
	[47651]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Knightbane Carapace
	[47652]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Lunar Eclipse Robes
	[47653]="0:9:4:1:Leatherworking::1:0:", -- Pattern: Moonshadow Armguards
	[47654]="0:9:4:1:Tailoring::1:0:", -- Pattern: Bejeweled Wizard's Bracers
	[47655]="0:9:4:1:Tailoring::1:0:", -- Pattern: Merlin's Robe
	[47656]="0:9:4:1:Tailoring::1:0:", -- Pattern: Royal Moonshroud Bracers
	[47657]="0:9:4:1:Tailoring::1:0:", -- Pattern: Royal Moonshroud Robe
	[47658]="0:2:4:1:Wand::1:0:28994,35494,35495,35573,35574", -- Brimstone Igniter
	[47659]="0:2:4:1:Thrown::1:0:29493,35494,35495,35573,35574", -- Crimson Star
	[47660]="0:2:4:1:Thrown::1:0:29493,35494,35495,35573,35574", -- Blades of the Sable Cross
	[47661]="0:4:4:1:Libram::1:0:29529,35494,35495,35573,35574", -- Libram of Valiance
	[47662]="0:4:4:1:Libram::1:0:29529,35494,35495,35573,35574", -- Libram of Veracity
	[47663]="0:4:4:1:Cloth::1:0:", -- Felspark Bindings
	[47664]="0:4:4:1:Libram::1:0:29529,35494,35495,35573,35574", -- Libram of Defiance
	[47665]="0:4:4:1:Totem::1:0:29529,35494,35495,35573,35574", -- Totem of Calming Tides
	[47666]="0:4:4:1:Totem::1:0:29529,35494,35495,35573,35574", -- Totem of Electrifying Wind
	[47667]="0:4:4:1:Totem::1:0:29529,35494,35495,35573,35574", -- Totem of Quaking Earth
	[47668]="0:4:4:1:Idol::1:0:29529,35494,35495,35573,35574", -- Idol of Mutilation
	[47669]="0:4:4:1:Leather::1:0:", -- Belt of the Winter Solstice
	[47670]="0:4:4:1:Idol::1:0:29529,35494,35495,35573,35574", -- Idol of Lunar Fury
	[47671]="0:4:4:1:Idol::1:0:29529,35494,35495,35573,35574", -- Idol of Flaring Growth
	[47672]="0:4:4:1:Sigil::1:0:29529,35494,35495,35573,35574", -- Sigil of Insolence
	[47673]="0:4:4:1:Sigil::1:0:29529,35494,35495,35573,35574", -- Sigil of Virulence
	[47674]="0:4:4:1:Plate::1:0:35494,35573", -- Helm of Thunderous Rampage
	[47675]="0:4:4:1:Plate::1:0:35495,35574", -- Faceplate of Thunderous Rampage
	[47676]="0:2:4:1:Dagger::1:0:", -- Dirk of the Night Watch
	[47677]="0:4:4:1:Plate::1:0:35494,35573", -- Faceplate of the Honorbound
	[47678]="0:4:4:1:Plate::1:0:35495,35574", -- Headplate of the Honorbound
	[47679]="0:4:4:1:Amulet::1:0:", -- Endurance of the Infernal
	[47680]="0:4:4:1:Plate::1:0:", -- Armguards of the Nether Lord
	[47681]="0:4:4:1:Plate::1:0:35494,35573", -- Heaume of the Restless Watch
	[47682]="0:4:4:1:Plate::1:0:35495,35574", -- Helm of the Restless Watch
	[47683]="0:4:4:1:Mail::1:0:", -- Sentinel Scouting Greaves
	[47684]="0:4:4:1:Mail::1:0:35495,35574", -- Coif of the Brooding Dragon
	[47685]="0:4:4:1:Mail::1:0:35494,35573", -- Helm of the Brooding Dragon
	[47686]="0:4:4:1:Mail::1:0:35494,35573", -- Helm of Inner Warmth
	[47687]="0:4:4:1:Mail::1:0:35495,35574", -- Headguard of Inner Warmth
	[47688]="0:4:4:1:Leather::1:0:35495,35574", -- Mask of Lethal Intent
	[47689]="0:4:4:1:Leather::1:0:35494,35573", -- Hood of Lethal Intent
	[47690]="0:4:4:1:Leather::1:0:35494,35573", -- Helm of Abundant Growth
	[47691]="0:4:4:1:Leather::1:0:35495,35574", -- Mask of Abundant Growth
	[47692]="0:4:4:1:Cloth::1:0:35495,35574", -- Hood of Smoldering Aftermath
	[47693]="0:4:4:1:Cloth::1:0:35494,35573", -- Hood of Fiery Aftermath
	[47694]="0:4:4:1:Cloth::1:0:35494,35573", -- Helm of Clouded Sight
	[47695]="0:4:4:1:Cloth::1:0:35495,35574", -- Hood of Clouded Sight
	[47696]="0:4:4:1:Plate::1:0:35495,35574", -- Shoulderplates of Trembling Rage
	[47697]="0:4:4:1:Plate::1:0:35494,35573", -- Pauldrons of Trembling Rage
	[47698]="0:4:4:1:Plate::1:0:35494,35573", -- Shoulderplates of Enduring Order
	[47699]="0:4:4:1:Plate::1:0:35495,35574", -- Shoulderguards of Enduring Order
	[47700]="0:4:4:1:Ring::1:0:", -- Loop of the Twin Val'kyr
	[47701]="0:4:4:1:Plate::1:0:35495,35574", -- Shoulderplates of the Cavalier
	[47702]="0:4:4:1:Plate::1:0:35494,35573", -- Pauldrons of the Cavalier
	[47703]="0:4:4:1:Ring::1:0:", -- Planestalker Signet
	[47704]="0:4:4:1:Mail::1:0:35494,35573", -- Epaulets of the Devourer
	[47705]="0:4:4:1:Mail::1:0:35495,35574", -- Pauldrons of the Devourer
	[47706]="0:4:4:1:Mail::1:0:35495,35574", -- Shoulders of the Groundbreaker
	[47707]="0:4:4:1:Mail::1:0:35494,35573", -- Mantle of the Groundbreaker
	[47708]="0:4:4:1:Leather::1:0:35494,35573", -- Duskstalker Shoulderpads
	[47709]="0:4:4:1:Leather::1:0:35495,35574", -- Duskstalker Pauldrons
	[47710]="0:4:4:1:Leather::1:0:35495,35574", -- Epaulets of the Fateful Accord
	[47711]="0:4:4:1:Plate::1:0:", -- Girdle of the Nether Champion
	[47712]="0:4:4:1:Leather::1:0:35494,35573", -- Shoulders of the Fateful Accord
	[47713]="0:4:4:1:Cloth::1:0:35494,35573", -- Mantle of Catastrophic Emanation
	[47714]="0:4:4:1:Cloth::1:0:35495,35574", -- Pauldrons of Catastrophic Emanation
	[47715]="0:4:4:1:Cloth::1:0:35494,35573", -- Pauldrons of Revered Mortality
	[47716]="0:4:4:1:Cloth::1:0:35495,35574", -- Mantle of Revered Mortality
	[47717]="0:4:4:1:Plate::1:0:", -- Faceplate of the Silver Champion
	[47718]="0:4:4:1:Mail::1:0:", -- Helm of the Silver Ranger
	[47719]="0:4:4:1:Leather::1:0:", -- Gloves of the Silver Assassin
	[47720]="0:4:4:1:Plate::1:0:", -- Pauldrons of the Silver Defender
	[47721]="0:4:4:1:Cloth::1:0:", -- Sandals of the Silver Magus
	[47724]="0:2:4:1:Dagger::1:0:", -- Blade of the Silver Disciple
	[47725]="0:4:4:1:Trinket::1:0:", -- Victor's Call
	[47726]="0:4:4:1:Trinket::1:0:", -- Talisman of Volatile Power
	[47727]="0:4:4:1:Trinket::1:0:", -- Fervor of the Frostborn
	[47728]="0:4:4:1:Trinket::1:0:", -- Binding Light
	[47729]="0:4:4:1:Ring::1:0:32172,35494,35495,35573,35574", -- Bloodshed Band
	[47730]="0:4:4:1:Ring::1:0:32172,35494,35495,35573,35574", -- Dexterous Brightstone Ring
	[47731]="0:4:4:1:Ring::1:0:32172,35494,35495,35573,35574", -- Clutch of Fortification
	[47732]="0:4:4:1:Ring::1:0:32172,35494,35495,35573,35574", -- Band of the Invoker
	[47733]="0:4:4:1:Ring::1:0:32172,35494,35495,35573,35574", -- Heartmender Circle
	[47734]="0:4:4:1:Trinket::1:0:29528,35494,35495,35573,35574", -- Mark of Supremacy
	[47735]="0:4:4:1:Trinket::1:0:29528,35494,35495,35573,35574", -- Glyph of Indomitability
	[47736]="0:2:4:1:Dagger::1:0:", -- Icefall Blade
	[47737]="0:2:4:1:TwoHandSword::1:0:", -- Reckoning
	[47738]="0:4:4:1:Plate::1:0:", -- Sabatons of the Lingering Vortex
	[47739]="0:4:4:1:Leather::1:0:", -- Armor of Shifting Shadows
	[47740]="0:2:4:1:Gun::1:0:", -- The Diplomat
	[47741]="0:2:4:1:Crossbow::1:0:", -- Baelgun's Heavy Crossbow
	[47742]="0:4:4:1:OffHandFrill::1:0:", -- Chalice of Benedictus
	[47743]="0:2:4:1:Stave::1:0:", -- Enlightenment
	[47744]="0:4:4:1:Mail::1:0:", -- Gloves of the Azure Prophet
	[47745]="0:4:4:1:Cloth::1:0:", -- Gloves of Looming Shadow
	[47746]="0:4:4:1:Leather::1:0:", -- Helm of the Snowy Grotto
	[47747]="0:4:4:1:Amulet::1:0:", -- Darkbane Pendant
	[47748]="0:4:4:1:Cloth::1:0:35496,35579", -- Khadgar's Hood of Conquest
	[47749]="0:4:4:1:Cloth::1:0:35496,35579", -- Khadgar's Robe of Conquest
	[47750]="0:4:4:1:Cloth::1:0:35496,35579", -- Khadgar's Leggings of Conquest
	[47751]="0:4:4:1:Cloth::1:0:35496,35579", -- Khadgar's Shoulderpads of Conquest
	[47752]="0:4:4:1:Cloth::1:0:35496,35579", -- Khadgar's Gauntlets of Conquest
	[47753]="0:4:4:1:Cloth::1:0:35577", -- Khadgar's Gauntlets of Triumph
	[47754]="0:4:4:1:Cloth::1:0:35577", -- Khadgar's Hood of Triumph
	[47755]="0:4:4:1:Cloth::1:0:35577", -- Khadgar's Leggings of Triumph
	[47756]="0:4:4:1:Cloth::1:0:35577", -- Khadgar's Robe of Triumph
	[47757]="0:4:4:1:Cloth::1:0:35577", -- Khadgar's Shoulderpads of Triumph
	[47758]="0:4:4:1:Cloth::1:0:35575", -- Khadgar's Shoulderpads of Triumph
	[47759]="0:4:4:1:Cloth::1:0:35575", -- Khadgar's Robe of Triumph
	[47760]="0:4:4:1:Cloth::1:0:35575", -- Khadgar's Leggings of Triumph
	[47761]="0:4:4:1:Cloth::1:0:35575", -- Khadgar's Hood of Triumph
	[47762]="0:4:4:1:Cloth::1:0:35575", -- Khadgar's Gauntlets of Triumph
	[47763]="0:4:4:1:Cloth::1:0:35576", -- Sunstrider's Gauntlets of Triumph
	[47764]="0:4:4:1:Cloth::1:0:35576", -- Sunstrider's Hood of Triumph
	[47765]="0:4:4:1:Cloth::1:0:35576", -- Sunstrider's Leggings of Triumph
	[47766]="0:4:4:1:Cloth::1:0:35576", -- Sunstrider's Robe of Triumph
	[47767]="0:4:4:1:Cloth::1:0:35576", -- Sunstrider's Shoulderpads of Triumph
	[47768]="0:4:4:1:Cloth::1:0:35578", -- Sunstrider's Shoulderpads of Triumph
	[47769]="0:4:4:1:Cloth::1:0:35578", -- Sunstrider's Robe of Triumph
	[47770]="0:4:4:1:Cloth::1:0:35578", -- Sunstrider's Leggings of Triumph
	[47771]="0:4:4:1:Cloth::1:0:35578", -- Sunstrider's Hood of Triumph
	[47772]="0:4:4:1:Cloth::1:0:35578", -- Sunstrider's Gauntlets of Triumph
	[47773]="0:4:4:1:Cloth::1:0:35496,35580", -- Sunstrider's Gauntlets of Conquest
	[47774]="0:4:4:1:Cloth::1:0:35496,35580", -- Sunstrider's Hood of Conquest
	[47775]="0:4:4:1:Cloth::1:0:35496,35580", -- Sunstrider's Leggings of Conquest
	[47776]="0:4:4:1:Cloth::1:0:35496,35580", -- Sunstrider's Robe of Conquest
	[47777]="0:4:4:1:Cloth::1:0:35496,35580", -- Sunstrider's Shoulderpads of Conquest
	[47778]="0:4:4:1:Cloth::1:0:35577", -- Kel'Thuzad's Hood of Triumph
	[47779]="0:4:4:1:Cloth::1:0:35577", -- Kel'Thuzad's Robe of Triumph
	[47780]="0:4:4:1:Cloth::1:0:35577", -- Kel'Thuzad's Leggings of Triumph
	[47781]="0:4:4:1:Cloth::1:0:35577", -- Kel'Thuzad's Shoulderpads of Triumph
	[47782]="0:4:4:1:Cloth::1:0:35577", -- Kel'Thuzad's Gloves of Triumph
	[47783]="0:4:4:1:Cloth::1:0:35496,35579", -- Kel'Thuzad's Gloves of Conquest
	[47784]="0:4:4:1:Cloth::1:0:35496,35579", -- Kel'Thuzad's Hood of Conquest
	[47785]="0:4:4:1:Cloth::1:0:35496,35579", -- Kel'Thuzad's Leggings of Conquest
	[47786]="0:4:4:1:Cloth::1:0:35496,35579", -- Kel'Thuzad's Robe of Conquest
	[47787]="0:4:4:1:Cloth::1:0:35496,35579", -- Kel'Thuzad's Shoulderpads of Conquest
	[47788]="0:4:4:1:Cloth::1:0:35575", -- Kel'Thuzad's Gloves of Triumph
	[47789]="0:4:4:1:Cloth::1:0:35575", -- Kel'Thuzad's Hood of Triumph
	[47790]="0:4:4:1:Cloth::1:0:35575", -- Kel'Thuzad's Leggings of Triumph
	[47791]="0:4:4:1:Cloth::1:0:35575", -- Kel'Thuzad's Robe of Triumph
	[47792]="0:4:4:1:Cloth::1:0:35575", -- Kel'Thuzad's Shoulderpads of Triumph
	[47793]="0:4:4:1:Cloth::1:0:35576", -- Gul'dan's Shoulderpads of Triumph
	[47794]="0:4:4:1:Cloth::1:0:35576", -- Gul'dan's Robe of Triumph
	[47795]="0:4:4:1:Cloth::1:0:35576", -- Gul'dan's Leggings of Triumph
	[47796]="0:4:4:1:Cloth::1:0:35576", -- Gul'dan's Hood of Triumph
	[47797]="0:4:4:1:Cloth::1:0:35576", -- Gul'dan's Gloves of Triumph
	[47798]="0:4:4:1:Cloth::1:0:35496,35580", -- Gul'dan's Shoulderpads of Conquest
	[47799]="0:4:4:1:Cloth::1:0:35496,35580", -- Gul'dan's Robe of Conquest
	[47800]="0:4:4:1:Cloth::1:0:35496,35580", -- Gul'dan's Leggings of Conquest
	[47801]="0:4:4:1:Cloth::1:0:35496,35580", -- Gul'dan's Hood of Conquest
	[47802]="0:4:4:1:Cloth::1:0:35496,35580", -- Gul'dan's Gloves of Conquest
	[47803]="0:4:4:1:Cloth::1:0:35578", -- Gul'dan's Gloves of Triumph
	[47804]="0:4:4:1:Cloth::1:0:35578", -- Gul'dan's Hood of Triumph
	[47805]="0:4:4:1:Cloth::1:0:35578", -- Gul'dan's Leggings of Triumph
	[47806]="0:4:4:1:Cloth::1:0:35578", -- Gul'dan's Robe of Triumph
	[47807]="0:4:4:1:Cloth::1:0:35578", -- Gul'dan's Shoulderpads of Triumph
	[47808]="0:2:4:1:OneHandAxe::1:0:", -- The Lion's Maw
	[47809]="0:2:4:1:OneHandMace::1:0:", -- Argent Resolve
	[47810]="0:2:4:1:OneHandSword::1:0:", -- Crusader's Glory
	[47811]="0:4:4:1:Plate::1:0:", -- Chestguard of the Warden
	[47812]="0:4:4:1:Shield::1:0:", -- Vigilant Ward
	[47813]="0:4:4:1:Mail::1:0:", -- Helmet of the Crypt Lord
	[47814]="0:2:4:1:OneHandSword::1:0:", -- Westfall Saber
	[47815]="0:2:4:1:Stave::1:0:", -- Cold Convergence
	[47816]="0:2:4:1:OneHandMace::1:0:", -- The Grinder
	[47828]="0:7:1:1:Device::1:0:", -- Goblin Beam Welder
	[47829]="0:4:4:1:Mail::1:0:", -- Pauldrons of the Timeless Hunter
	[47830]="0:4:4:1:Plate::1:0:", -- Legplates of the Silver Hand
	[47832]="0:4:4:1:Leather::1:0:", -- Spaulders of the Snow Bandit
	[47834]="0:2:4:1:Polearm::1:0:", -- Fordragon Blades
	[47835]="0:4:4:1:Shield::1:0:", -- Bulwark of the Royal Guard
	[47836]="0:4:4:1:Plate::1:0:", -- Legplates of the Immortal Spider
	[47837]="0:4:4:1:Cloth::1:0:", -- Cinch of the Undying
	[47838]="0:4:4:1:Cloth::1:0:", -- Vestments of the Sleepless
	[47849]="0:4:4:1:Amulet::1:0:", -- Collar of Unending Torment
	[47850]="0:4:4:1:Mail::1:0:", -- Bracers of the Northern Stalker
	[47851]="0:4:4:1:Plate::1:0:", -- Gauntlets of Mounting Anger
	[47852]="0:4:4:1:Plate::1:0:", -- Dreadscale Bracers
	[47853]="0:4:4:1:Leather::1:0:", -- Acidmaw Treads
	[47854]="0:4:4:1:Ring::1:0:", -- Gormok's Band
	[47855]="0:4:4:1:Cloth::1:0:", -- Icehowl Binding
	[47856]="0:2:4:1:Wand::1:0:", -- Scepter of Imprisoned Souls
	[47857]="0:4:4:1:Leather::1:0:", -- Pauldrons of the Glacial Wilds
	[47858]="0:4:4:1:Plate::1:0:", -- Girdle of the Frozen Reach
	[47859]="0:4:4:1:Plate::1:0:", -- Belt of the Impaler
	[47860]="0:4:4:1:Mail::1:0:", -- Pauldrons of the Spirit Walker
	[47861]="0:4:4:1:Cloth::1:0:", -- Felspark Bracers
	[47862]="0:4:4:1:Ring::1:0:", -- Firestorm Band
	[47863]="0:4:4:1:Leather::1:0:", -- Belt of the Bloodhoof Emissary
	[47864]="0:4:4:1:Amulet::1:0:", -- Pendant of Binding Elements
	[47865]="0:4:4:1:Cloth::1:0:", -- Legwraps of the Demonic Messenger
	[47866]="0:4:4:1:Mail::1:0:", -- Darkspear Ritual Binding
	[47867]="0:4:4:1:Mail::1:0:", -- Warsong Poacher's Greaves
	[47868]="0:4:4:1:Ring::1:0:", -- Planestalker Band
	[47869]="0:4:4:1:Plate::1:0:", -- Armplates of the Nether Lord
	[47870]="0:4:4:1:Plate::1:0:", -- Belt of the Nether Champion
	[47871]="0:2:4:1:Dagger::1:0:", -- Orcish Deathblade
	[47872]="0:4:4:1:Amulet::1:0:", -- Fortitude of the Infernal
	[47873]="0:4:4:1:Cloth::1:0:", -- Sunreaver Magus' Sandals
	[47874]="0:2:4:1:Dagger::1:0:", -- Sunreaver Disciple's Blade
	[47875]="0:4:4:1:Mail::1:0:", -- Sunreaver Ranger's Helm
	[47876]="0:4:4:1:Plate::1:0:", -- Sunreaver Champion's Faceplate
	[47877]="0:4:4:1:Plate::1:0:", -- Sunreaver Defender's Pauldrons
	[47878]="0:4:4:1:Leather::1:0:", -- Sunreaver Assassin's Gloves
	[47879]="0:4:4:1:Trinket::1:0:", -- Fetish of Volatile Power
	[47880]="0:4:4:1:Trinket::1:0:", -- Binding Stone
	[47881]="0:4:4:1:Trinket::1:0:", -- Vengeance of the Forsaken
	[47882]="0:4:4:1:Trinket::1:0:", -- Eitrigg's Oath
	[47883]="0:2:4:1:Gun::1:0:", -- Widebarrel Flintlock
	[47884]="0:2:4:1:TwoHandSword::1:0:", -- Edge of Agony
	[47885]="0:4:4:1:Plate::1:0:", -- Greaves of the Lingering Vortex
	[47886]="0:2:4:1:Dagger::1:0:", -- Nemesis Blade
	[47887]="0:4:4:1:Leather::1:0:", -- Vest of Shifting Shadows
	[47888]="0:4:4:1:Ring::1:0:", -- Band of the Twin Val'kyr
	[47889]="0:4:4:1:Cloth::1:0:", -- Looming Shadow Wraps
	[47890]="0:4:4:1:Amulet::1:0:", -- Darkbane Amulet
	[47891]="0:4:4:1:Leather::1:0:", -- Helm of the High Mesa
	[47892]="0:2:4:1:Stave::1:0:", -- Illumination
	[47893]="0:4:4:1:Mail::1:0:", -- Sen'jin Ritualist Gloves
	[47894]="0:2:4:1:OneHandMace::1:0:", -- Mace of the Earthborn Chieftain
	[47895]="0:4:4:1:Shield::1:0:", -- Pride of the Kor'kron
	[47896]="0:4:4:1:Plate::1:0:", -- Stoneskin Chestplate
	[47897]="0:4:4:1:Mail::1:0:", -- Helm of the Crypt Lord
	[47898]="0:2:4:1:OneHandAxe::1:0:", -- Frostblade Hatchet
	[47899]="0:2:4:1:OneHandSword::1:0:", -- Ardent Guard
	[47900]="0:2:4:1:Stave::1:0:", -- Perdition
	[47901]="0:4:4:1:Mail::1:0:", -- Pauldrons of the Shadow Hunter
	[47902]="0:4:4:1:Plate::1:0:", -- Legplates of Redeemed Blood
	[47903]="0:2:4:1:OneHandSword::1:0:", -- Forsaken Bonecarver
	[47904]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Snow Bandit
	[47905]="0:2:4:1:OneHandMace::1:0:", -- Blackhorn Bludgeon
	[47906]="0:4:4:1:Cloth::1:0:", -- Robes of the Sleepless
	[47907]="0:2:4:1:Crossbow::1:0:", -- Darkmaw Crossbow
	[47908]="0:4:4:1:Plate::1:0:", -- Sunwalker Legguards
	[47909]="0:4:4:1:Cloth::1:0:", -- Belt of the Eternal
	[47910]="0:4:4:1:Shield::1:0:", -- Aegis of the Coliseum
	[47911]="0:2:4:1:Polearm::1:0:", -- Anguish
	[47913]="0:4:4:1:OffHandFrill::1:0:", -- Lightbane Focus
	[47914]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Cowl of Conquest
	[47915]="0:4:4:1:Amulet::1:0:", -- Collar of Ceaseless Torment
	[47916]="0:4:4:1:Mail::1:0:", -- Armbands of the Northern Stalker
	[47917]="0:4:4:1:Plate::1:0:", -- Gauntlets of Rising Anger
	[47918]="0:4:4:1:Plate::1:0:", -- Dreadscale Armguards
	[47919]="0:4:4:1:Leather::1:0:", -- Acidmaw Boots
	[47920]="0:4:4:1:Ring::1:0:", -- Carnivorous Band
	[47921]="0:4:4:1:Cloth::1:0:", -- Icehowl Cinch
	[47922]="0:2:4:1:Wand::1:0:", -- Rod of Imprisoned Souls
	[47923]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Glacial Wilds
	[47924]="0:4:4:1:Plate::1:0:", -- Belt of the Frozen Reach
	[47925]="0:4:4:1:Plate::1:0:", -- Girdle of the Impaler
	[47926]="0:4:4:1:Mail::1:0:", -- Shoulderguards of the Spirit Walker
	[47927]="0:4:4:1:Cloth::1:0:", -- Felspark Bindings
	[47928]="0:4:4:1:Ring::1:0:", -- Firestorm Ring
	[47929]="0:4:4:1:Leather::1:0:", -- Belt of the Winter Solstice
	[47930]="0:4:4:1:Amulet::1:0:", -- Amulet of Binding Elements
	[47931]="0:4:4:1:Cloth::1:0:", -- Leggings of the Demonic Messenger
	[47932]="0:4:4:1:Mail::1:0:", -- Girdle of the Farseer
	[47933]="0:4:4:1:Mail::1:0:", -- Sentinel Scouting Greaves
	[47934]="0:4:4:1:Ring::1:0:", -- Planestalker Signet
	[47935]="0:4:4:1:Plate::1:0:", -- Armguards of the Nether Lord
	[47936]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Robe of Conquest
	[47937]="0:4:4:1:Plate::1:0:", -- Girdle of the Nether Champion
	[47938]="0:2:4:1:Dagger::1:0:", -- Dirk of the Night Watch
	[47939]="0:4:4:1:Amulet::1:0:", -- Endurance of the Infernal
	[47940]="0:4:4:1:Cloth::1:0:", -- Sandals of the Silver Magus
	[47941]="0:2:4:1:Dagger::1:0:", -- Blade of the Silver Disciple
	[47942]="0:4:4:1:Mail::1:0:", -- Helm of the Silver Ranger
	[47943]="0:4:4:1:Plate::1:0:", -- Faceplate of the Silver Champion
	[47944]="0:4:4:1:Plate::1:0:", -- Pauldrons of the Silver Defender
	[47945]="0:4:4:1:Leather::1:0:", -- Gloves of the Silver Assassin
	[47946]="0:4:4:1:Trinket::1:0:", -- Talisman of Volatile Power
	[47947]="0:4:4:1:Trinket::1:0:", -- Binding Light
	[47948]="0:4:4:1:Trinket::1:0:", -- Victor's Call
	[47949]="0:4:4:1:Trinket::1:0:", -- Fervor of the Frostborn
	[47950]="0:2:4:1:Gun::1:0:", -- The Diplomat
	[47951]="0:2:4:1:TwoHandSword::1:0:", -- Reckoning
	[47952]="0:4:4:1:Plate::1:0:", -- Sabatons of the Lingering Vortex
	[47953]="0:2:4:1:Dagger::1:0:", -- Icefall Blade
	[47954]="0:4:4:1:Leather::1:0:", -- Armor of Shifting Shadows
	[47955]="0:4:4:1:Ring::1:0:", -- Loop of the Twin Val'kyr
	[47956]="0:4:4:1:Cloth::1:0:", -- Gloves of Looming Shadow
	[47957]="0:4:4:1:Amulet::1:0:", -- Darkbane Pendant
	[47958]="0:4:4:1:OffHandFrill::1:0:", -- Chalice of Benedictus
	[47959]="0:4:4:1:Leather::1:0:", -- Helm of the Snowy Grotto
	[47960]="0:2:4:1:Stave::1:0:", -- Enlightenment
	[47961]="0:4:4:1:Mail::1:0:", -- Gloves of the Azure Prophet
	[47962]="0:2:4:1:OneHandMace::1:0:", -- Argent Resolve
	[47963]="0:4:4:1:Shield::1:0:", -- Vigilant Ward
	[47964]="0:4:4:1:Plate::1:0:", -- Chestguard of the Warden
	[47965]="0:4:4:1:Mail::1:0:", -- Helmet of the Crypt Lord
	[47966]="0:2:4:1:OneHandAxe::1:0:", -- The Lion's Maw
	[47967]="0:2:4:1:OneHandSword::1:0:", -- Crusader's Glory
	[47968]="0:2:4:1:Stave::1:0:", -- Cold Convergence
	[47969]="0:4:4:1:Mail::1:0:", -- Pauldrons of the Timeless Hunter
	[47970]="0:4:4:1:Plate::1:0:", -- Legplates of the Silver Hand
	[47971]="0:2:4:1:OneHandSword::1:0:", -- Westfall Saber
	[47972]="0:4:4:1:Leather::1:0:", -- Spaulders of the Snow Bandit
	[47973]="0:2:4:1:OneHandMace::1:0:", -- The Grinder
	[47974]="0:4:4:1:Cloth::1:0:", -- Vestments of the Sleepless
	[47975]="0:2:4:1:Crossbow::1:0:", -- Baelgun's Heavy Crossbow
	[47976]="0:4:4:1:Plate::1:0:", -- Legplates of the Immortal Spider
	[47977]="0:4:4:1:Cloth::1:0:", -- Cinch of the Undying
	[47978]="0:4:4:1:Shield::1:0:", -- Bulwark of the Royal Guard
	[47979]="0:2:4:1:Polearm::1:0:", -- Fordragon Blades
	[47980]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Leggings of Conquest
	[47981]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Shoulderpads of Conquest
	[47982]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Gloves of Conquest
	[47983]="0:4:4:1:Cloth::1:0:35577", -- Velen's Gloves of Triumph
	[47984]="0:4:4:1:Cloth::1:0:35577", -- Velen's Cowl of Triumph
	[47985]="0:4:4:1:Cloth::1:0:35577", -- Velen's Leggings of Triumph
	[47986]="0:4:4:1:Cloth::1:0:35577", -- Velen's Robe of Triumph
	[47987]="0:4:4:1:Cloth::1:0:35577", -- Velen's Shoulderpads of Triumph
	[47988]="0:4:4:1:Amulet::1:0:", -- Collar of Unending Torment
	[47989]="0:4:4:1:Mail::1:0:", -- Bracers of the Northern Stalker
	[47990]="0:4:4:1:Plate::1:0:", -- Gauntlets of Mounting Anger
	[47991]="0:4:4:1:Plate::1:0:", -- Dreadscale Bracers
	[47992]="0:4:4:1:Leather::1:0:", -- Acidmaw Treads
	[47993]="0:4:4:1:Ring::1:0:", -- Gormok's Band
	[47994]="0:4:4:1:Cloth::1:0:", -- Icehowl Binding
	[47995]="0:2:4:1:Wand::1:0:", -- Scepter of Imprisoned Souls
	[47996]="0:4:4:1:Leather::1:0:", -- Pauldrons of the Glacial Wilds
	[47997]="0:4:4:1:Plate::1:0:", -- Girdle of the Frozen Reach
	[47998]="0:4:4:1:Plate::1:0:", -- Belt of the Impaler
	[47999]="0:4:4:1:Mail::1:0:", -- Pauldrons of the Spirit Walker
	[48000]="0:4:4:1:Cloth::1:0:", -- Felspark Bracers
	[48001]="0:4:4:1:Ring::1:0:", -- Firestorm Band
	[48002]="0:4:4:1:Leather::1:0:", -- Belt of the Bloodhoof Emissary
	[48003]="0:4:4:1:Amulet::1:0:", -- Pendant of Binding Elements
	[48004]="0:4:4:1:Cloth::1:0:", -- Legwraps of the Demonic Messenger
	[48005]="0:4:4:1:Mail::1:0:", -- Darkspear Ritual Binding
	[48006]="0:4:4:1:Mail::1:0:", -- Warsong Poacher's Greaves
	[48007]="0:4:4:1:Ring::1:0:", -- Planestalker Band
	[48008]="0:4:4:1:Plate::1:0:", -- Armplates of the Nether Lord
	[48009]="0:4:4:1:Plate::1:0:", -- Belt of the Nether Champion
	[48010]="0:2:4:1:Dagger::1:0:", -- Orcish Deathblade
	[48011]="0:4:4:1:Amulet::1:0:", -- Fortitude of the Infernal
	[48012]="0:4:4:1:Cloth::1:0:", -- Sunreaver Magus' Sandals
	[48013]="0:2:4:1:Dagger::1:0:", -- Sunreaver Disciple's Blade
	[48014]="0:4:4:1:Mail::1:0:", -- Sunreaver Ranger's Helm
	[48015]="0:4:4:1:Plate::1:0:", -- Sunreaver Champion's Faceplate
	[48016]="0:4:4:1:Plate::1:0:", -- Sunreaver Defender's Pauldrons
	[48017]="0:4:4:1:Leather::1:0:", -- Sunreaver Assassin's Gloves
	[48018]="0:4:4:1:Trinket::1:0:", -- Fetish of Volatile Power
	[48019]="0:4:4:1:Trinket::1:0:", -- Binding Stone
	[48020]="0:4:4:1:Trinket::1:0:", -- Vengeance of the Forsaken
	[48021]="0:4:4:1:Trinket::1:0:", -- Eitrigg's Oath
	[48022]="0:2:4:1:Gun::1:0:", -- Widebarrel Flintlock
	[48023]="0:2:4:1:TwoHandSword::1:0:", -- Edge of Agony
	[48024]="0:4:4:1:Plate::1:0:", -- Greaves of the Lingering Vortex
	[48025]="0:2:4:1:Dagger::1:0:", -- Nemesis Blade
	[48026]="0:4:4:1:Leather::1:0:", -- Vest of Shifting Shadows
	[48027]="0:4:4:1:Ring::1:0:", -- Band of the Twin Val'kyr
	[48028]="0:4:4:1:Cloth::1:0:", -- Looming Shadow Wraps
	[48029]="0:4:4:1:Cloth::1:0:35575", -- Velen's Shoulderpads of Triumph
	[48030]="0:4:4:1:Amulet::1:0:", -- Darkbane Amulet
	[48031]="0:4:4:1:Cloth::1:0:35575", -- Velen's Robe of Triumph
	[48032]="0:4:4:1:OffHandFrill::1:0:", -- Lightbane Focus
	[48033]="0:4:4:1:Cloth::1:0:35575", -- Velen's Leggings of Triumph
	[48034]="0:4:4:1:Leather::1:0:", -- Helm of the High Mesa
	[48035]="0:4:4:1:Cloth::1:0:35575", -- Velen's Cowl of Triumph
	[48036]="0:2:4:1:Stave::1:0:", -- Illumination
	[48037]="0:4:4:1:Cloth::1:0:35575", -- Velen's Gloves of Triumph
	[48038]="0:4:4:1:Mail::1:0:", -- Sen'jin Ritualist Gloves
	[48039]="0:2:4:1:OneHandMace::1:0:", -- Mace of the Earthborn Chieftain
	[48040]="0:4:4:1:Shield::1:0:", -- Pride of the Kor'kron
	[48041]="0:4:4:1:Plate::1:0:", -- Stoneskin Chestplate
	[48042]="0:4:4:1:Mail::1:0:", -- Helm of the Crypt Lord
	[48043]="0:2:4:1:OneHandAxe::1:0:", -- Frostblade Hatchet
	[48044]="0:2:4:1:OneHandSword::1:0:", -- Ardent Guard
	[48045]="0:2:4:1:Stave::1:0:", -- Perdition
	[48046]="0:4:4:1:Mail::1:0:", -- Pauldrons of the Shadow Hunter
	[48047]="0:4:4:1:Plate::1:0:", -- Legplates of the Redeemed Blood Knight
	[48048]="0:2:4:1:OneHandSword::1:0:", -- Forsaken Bonecarver
	[48049]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Snow Bandit
	[48050]="0:2:4:1:OneHandMace::1:0:", -- Blackhorn Bludgeon
	[48051]="0:4:4:1:Cloth::1:0:", -- Robes of the Sleepless
	[48052]="0:2:4:1:Crossbow::1:0:", -- Darkmaw Crossbow
	[48053]="0:4:4:1:Plate::1:0:", -- Sunwalker Legguards
	[48054]="0:4:4:1:Cloth::1:0:", -- Belt of the Eternal
	[48055]="0:4:4:1:Shield::1:0:", -- Aegis of the Coliseum
	[48056]="0:2:4:1:Polearm::1:0:", -- Anguish
	[48057]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Gloves of Triumph
	[48058]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Cowl of Triumph
	[48059]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Leggings of Triumph
	[48060]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Robe of Triumph
	[48061]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Shoulderpads of Triumph
	[48062]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Shoulderpads of Triumph
	[48063]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Robe of Triumph
	[48064]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Leggings of Triumph
	[48065]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Cowl of Triumph
	[48066]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Gloves of Triumph
	[48067]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Gloves of Conquest
	[48068]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Cowl of Conquest
	[48069]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Leggings of Conquest
	[48070]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Robe of Conquest
	[48071]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Shoulderpads of Conquest
	[48072]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Handwraps of Conquest
	[48073]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Circlet of Conquest
	[48074]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Pants of Conquest
	[48075]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Raiments of Conquest
	[48076]="0:4:4:1:Cloth::1:0:35496,35579", -- Velen's Mantle of Conquest
	[48077]="0:4:4:1:Cloth::1:0:35577", -- Velen's Handwraps of Triumph
	[48078]="0:4:4:1:Cloth::1:0:35577", -- Velen's Circlet of Triumph
	[48079]="0:4:4:1:Cloth::1:0:35577", -- Velen's Pants of Triumph
	[48080]="0:4:4:1:Cloth::1:0:35577", -- Velen's Raiments of Triumph
	[48081]="0:4:4:1:Cloth::1:0:35577", -- Velen's Mantle of Triumph
	[48082]="0:4:4:1:Cloth::1:0:35575", -- Velen's Mantle of Triumph
	[48083]="0:4:4:1:Cloth::1:0:35575", -- Velen's Raiments of Triumph
	[48084]="0:4:4:1:Cloth::1:0:35575", -- Velen's Pants of Triumph
	[48085]="0:4:4:1:Cloth::1:0:35575", -- Velen's Circlet of Triumph
	[48086]="0:4:4:1:Cloth::1:0:35575", -- Velen's Handwraps of Triumph
	[48087]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Handwraps of Triumph
	[48088]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Circlet of Triumph
	[48089]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Pants of Triumph
	[48090]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Raiments of Triumph
	[48091]="0:4:4:1:Cloth::1:0:35576", -- Zabra's Mantle of Triumph
	[48092]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Mantle of Triumph
	[48093]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Raiments of Triumph
	[48094]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Pants of Triumph
	[48095]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Circlet of Triumph
	[48096]="0:4:4:1:Cloth::1:0:35578", -- Zabra's Handwraps of Triumph
	[48097]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Handwraps of Conquest
	[48098]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Circlet of Conquest
	[48099]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Pants of Conquest
	[48100]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Raiments of Conquest
	[48101]="0:4:4:1:Cloth::1:0:35496,35580", -- Zabra's Mantle of Conquest
	[48102]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Headpiece of Conquest
	[48112]="0:15:1:1:Companion::1:0:", -- Darting Hatchling
	[48114]="0:15:1:1:Companion::1:0:", -- Deviate Hatchling
	[48116]="0:15:1:1:Companion::1:0:", -- Gundrak Hatchling
	[48118]="0:15:1:1:Companion::1:0:", -- Leaping Hatchling
	[48120]="500000:15:1:1:Companion::1:0:28951", -- Obsidian Hatchling
	[48122]="0:15:1:1:Companion::1:0:", -- Ravasaur Hatchling
	[48124]="0:15:1:1:Companion::1:0:", -- Razormaw Hatchling
	[48126]="0:15:1:1:Companion::1:0:", -- Razzashi Hatchling
	[48129]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Robe of Conquest
	[48130]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Leggings of Conquest
	[48131]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Spaulders of Conquest
	[48132]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Handguards of Conquest
	[48133]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Handguards of Triumph
	[48134]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Headpiece of Triumph
	[48135]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Leggings of Triumph
	[48136]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Robe of Triumph
	[48137]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Spaulders of Triumph
	[48138]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Spaulders of Triumph
	[48139]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Robe of Triumph
	[48140]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Leggings of Triumph
	[48141]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Headpiece of Triumph
	[48142]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Handguards of Triumph
	[48143]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Handguards of Triumph
	[48144]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Headpiece of Triumph
	[48145]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Leggings of Triumph
	[48146]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Robe of Triumph
	[48147]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Spaulders of Triumph
	[48148]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Spaulders of Triumph
	[48149]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Robe of Triumph
	[48150]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Leggings of Triumph
	[48151]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Headpiece of Triumph
	[48152]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Handguards of Triumph
	[48153]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Handguards of Conquest
	[48154]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Headpiece of Conquest
	[48155]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Leggings of Conquest
	[48156]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Robe of Conquest
	[48157]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Spaulders of Conquest
	[48158]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Cover of Conquest
	[48159]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Vestments of Conquest
	[48160]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Trousers of Conquest
	[48161]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Mantle of Conquest
	[48162]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Gloves of Conquest
	[48163]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Gloves of Triumph
	[48164]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Cover of Triumph
	[48165]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Trousers of Triumph
	[48166]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Vestments of Triumph
	[48167]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Mantle of Triumph
	[48168]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Mantle of Triumph
	[48169]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Vestments of Triumph
	[48170]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Trousers of Triumph
	[48171]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Cover of Triumph
	[48172]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Gloves of Triumph
	[48173]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Gloves of Triumph
	[48174]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Cover of Triumph
	[48175]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Trousers of Triumph
	[48176]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Vestments of Triumph
	[48177]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Mantle of Triumph
	[48178]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Mantle of Triumph
	[48179]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Vestments of Triumph
	[48180]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Trousers of Triumph
	[48181]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Cover of Triumph
	[48182]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Gloves of Triumph
	[48183]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Gloves of Conquest
	[48184]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Cover of Conquest
	[48185]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Trousers of Conquest
	[48186]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Vestments of Conquest
	[48187]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Mantle of Conquest
	[48188]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Headguard of Conquest
	[48189]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Raiments of Conquest
	[48190]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Legguards of Conquest
	[48191]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Shoulderpads of Conquest
	[48192]="0:4:4:1:Leather::1:0:35497,35580", -- Runetotem's Handgrips of Conquest
	[48193]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Handgrips of Triumph
	[48194]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Headguard of Triumph
	[48195]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Legguards of Triumph
	[48196]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Raiments of Triumph
	[48197]="0:4:4:1:Leather::1:0:35578", -- Runetotem's Shoulderpads of Triumph
	[48198]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Shoulderpads of Triumph
	[48199]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Raiments of Triumph
	[48200]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Legguards of Triumph
	[48201]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Headguard of Triumph
	[48202]="0:4:4:1:Leather::1:0:35576", -- Runetotem's Handgrips of Triumph
	[48203]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Handgrips of Triumph
	[48204]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Headguard of Triumph
	[48205]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Legguards of Triumph
	[48206]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Raiments of Triumph
	[48207]="0:4:4:1:Leather::1:0:35575", -- Malfurion's Shoulderpads of Triumph
	[48208]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Shoulderpads of Triumph
	[48209]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Raiments of Triumph
	[48210]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Legguards of Triumph
	[48211]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Headguard of Triumph
	[48212]="0:4:4:1:Leather::1:0:35577", -- Malfurion's Handgrips of Triumph
	[48213]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Handgrips of Conquest
	[48214]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Headguard of Conquest
	[48215]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Legguards of Conquest
	[48216]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Raiments of Conquest
	[48217]="0:4:4:1:Leather::1:0:35497,35579", -- Malfurion's Shoulderpads of Conquest
	[48218]="0:4:4:1:Leather::1:0:35497,35579", -- VanCleef's Helmet of Conquest
	[48219]="0:4:4:1:Leather::1:0:35497,35579", -- VanCleef's Breastplate of Conquest
	[48220]="0:4:4:1:Leather::1:0:35497,35579", -- VanCleef's Legplates of Conquest
	[48221]="0:4:4:1:Leather::1:0:35497,35579", -- VanCleef's Pauldrons of Conquest
	[48222]="0:4:4:1:Leather::1:0:35497,35579", -- VanCleef's Gauntlets of Conquest
	[48223]="0:4:4:1:Leather::1:0:35577", -- VanCleef's Breastplate of Triumph
	[48224]="0:4:4:1:Leather::1:0:35577", -- VanCleef's Gauntlets of Triumph
	[48225]="0:4:4:1:Leather::1:0:35577", -- VanCleef's Helmet of Triumph
	[48226]="0:4:4:1:Leather::1:0:35577", -- VanCleef's Legplates of Triumph
	[48227]="0:4:4:1:Leather::1:0:35577", -- VanCleef's Pauldrons of Triumph
	[48228]="0:4:4:1:Leather::1:0:35575", -- VanCleef's Pauldrons of Triumph
	[48229]="0:4:4:1:Leather::1:0:35575", -- VanCleef's Legplates of Triumph
	[48230]="0:4:4:1:Leather::1:0:35575", -- VanCleef's Helmet of Triumph
	[48231]="0:4:4:1:Leather::1:0:35575", -- VanCleef's Gauntlets of Triumph
	[48232]="0:4:4:1:Leather::1:0:35575", -- VanCleef's Breastplate of Triumph
	[48233]="0:4:4:1:Leather::1:0:35576", -- Garona's Breastplate of Triumph
	[48234]="0:4:4:1:Leather::1:0:35576", -- Garona's Gauntlets of Triumph
	[48235]="0:4:4:1:Leather::1:0:35576", -- Garona's Helmet of Triumph
	[48236]="0:4:4:1:Leather::1:0:35576", -- Garona's Legplates of Triumph
	[48237]="0:4:4:1:Leather::1:0:35576", -- Garona's Pauldrons of Triumph
	[48238]="0:4:4:1:Leather::1:0:35578", -- Garona's Pauldrons of Triumph
	[48239]="0:4:4:1:Leather::1:0:35578", -- Garona's Legplates of Triumph
	[48240]="0:4:4:1:Leather::1:0:35578", -- Garona's Helmet of Triumph
	[48241]="0:4:4:1:Leather::1:0:35578", -- Garona's Gauntlets of Triumph
	[48242]="0:4:4:1:Leather::1:0:35578", -- Garona's Breastplate of Triumph
	[48243]="0:4:4:1:Leather::1:0:35497,35580", -- Garona's Breastplate of Conquest
	[48244]="0:4:4:1:Leather::1:0:35497,35580", -- Garona's Gauntlets of Conquest
	[48245]="0:4:4:1:Leather::1:0:35497,35580", -- Garona's Helmet of Conquest
	[48246]="0:4:4:1:Leather::1:0:35497,35580", -- Garona's Legplates of Conquest
	[48247]="0:4:4:1:Leather::1:0:35497,35580", -- Garona's Pauldrons of Conquest
	[48250]="0:4:4:1:Mail::1:0:35500,35579", -- Windrunner's Headpiece of Conquest
	[48251]="0:4:4:1:Mail::1:0:35500,35579", -- Windrunner's Tunic of Conquest
	[48252]="0:4:4:1:Mail::1:0:35500,35579", -- Windrunner's Legguards of Conquest
	[48253]="0:4:4:1:Mail::1:0:35500,35579", -- Windrunner's Spaulders of Conquest
	[48254]="0:4:4:1:Mail::1:0:35500,35579", -- Windrunner's Handguards of Conquest
	[48255]="0:4:4:1:Mail::1:0:35577", -- Windrunner's Tunic of Triumph
	[48256]="0:4:4:1:Mail::1:0:35577", -- Windrunner's Handguards of Triumph
	[48257]="0:4:4:1:Mail::1:0:35577", -- Windrunner's Headpiece of Triumph
	[48258]="0:4:4:1:Mail::1:0:35577", -- Windrunner's Legguards of Triumph
	[48259]="0:4:4:1:Mail::1:0:35577", -- Windrunner's Spaulders of Triumph
	[48260]="0:4:4:1:Mail::1:0:35575", -- Windrunner's Spaulders of Triumph
	[48261]="0:4:4:1:Mail::1:0:35575", -- Windrunner's Legguards of Triumph
	[48262]="0:4:4:1:Mail::1:0:35575", -- Windrunner's Headpiece of Triumph
	[48263]="0:4:4:1:Mail::1:0:35575", -- Windrunner's Handguards of Triumph
	[48264]="0:4:4:1:Mail::1:0:35575", -- Windrunner's Tunic of Triumph
	[48265]="0:4:4:1:Mail::1:0:35576", -- Windrunner's Tunic of Triumph
	[48266]="0:4:4:1:Mail::1:0:35576", -- Windrunner's Handguards of Triumph
	[48267]="0:4:4:1:Mail::1:0:35576", -- Windrunner's Headpiece of Triumph
	[48268]="0:4:4:1:Mail::1:0:35576", -- Windrunner's Legguards of Triumph
	[48269]="0:4:4:1:Mail::1:0:35576", -- Windrunner's Spaulders of Triumph
	[48270]="0:4:4:1:Mail::1:0:35578", -- Windrunner's Spaulders of Triumph
	[48271]="0:4:4:1:Mail::1:0:35578", -- Windrunner's Legguards of Triumph
	[48272]="0:4:4:1:Mail::1:0:35578", -- Windrunner's Headpiece of Triumph
	[48273]="0:4:4:1:Mail::1:0:35578", -- Windrunner's Handguards of Triumph
	[48274]="0:4:4:1:Mail::1:0:35578", -- Windrunner's Tunic of Triumph
	[48275]="0:4:4:1:Mail::1:0:35500,35580", -- Windrunner's Tunic of Conquest
	[48276]="0:4:4:1:Mail::1:0:35500,35580", -- Windrunner's Handguards of Conquest
	[48277]="0:4:4:1:Mail::1:0:35500,35580", -- Windrunner's Headpiece of Conquest
	[48278]="0:4:4:1:Mail::1:0:35500,35580", -- Windrunner's Legguards of Conquest
	[48279]="0:4:4:1:Mail::1:0:35500,35580", -- Windrunner's Spaulders of Conquest
	[48280]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Headpiece of Conquest
	[48281]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Tunic of Conquest
	[48282]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Legguards of Conquest
	[48283]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Spaulders of Conquest
	[48284]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Handguards of Conquest
	[48285]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Tunic of Triumph
	[48286]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Handguards of Triumph
	[48287]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Headpiece of Triumph
	[48288]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Legguards of Triumph
	[48289]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Spaulders of Triumph
	[48290]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Spaulders of Triumph
	[48291]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Legguards of Triumph
	[48292]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Headpiece of Triumph
	[48293]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Handguards of Triumph
	[48294]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Tunic of Triumph
	[48295]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Tunic of Conquest
	[48296]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Handguards of Conquest
	[48297]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Headpiece of Conquest
	[48298]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Legguards of Conquest
	[48299]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Spaulders of Conquest
	[48300]="0:4:4:1:Mail::1:0:35578", -- Thrall's Tunic of Triumph
	[48301]="0:4:4:1:Mail::1:0:35578", -- Thrall's Handguards of Triumph
	[48302]="0:4:4:1:Mail::1:0:35578", -- Thrall's Headpiece of Triumph
	[48303]="0:4:4:1:Mail::1:0:35578", -- Thrall's Legguards of Triumph
	[48304]="0:4:4:1:Mail::1:0:35578", -- Thrall's Spaulders of Triumph
	[48305]="0:4:4:1:Mail::1:0:35576", -- Thrall's Tunic of Triumph
	[48306]="0:4:4:1:Mail::1:0:35576", -- Thrall's Handguards of Triumph
	[48307]="0:4:4:1:Mail::1:0:35576", -- Thrall's Headpiece of Triumph
	[48308]="0:4:4:1:Mail::1:0:35576", -- Thrall's Legguards of Triumph
	[48309]="0:4:4:1:Mail::1:0:35576", -- Thrall's Spaulders of Triumph
	[48310]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Hauberk of Conquest
	[48312]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Gloves of Conquest
	[48313]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Helm of Conquest
	[48314]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Kilt of Conquest
	[48315]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Shoulderpads of Conquest
	[48316]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Hauberk of Triumph
	[48317]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Gloves of Triumph
	[48318]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Helm of Triumph
	[48319]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Kilt of Triumph
	[48320]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Shoulderpads of Triumph
	[48321]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Shoulderpads of Triumph
	[48322]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Kilt of Triumph
	[48323]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Helm of Triumph
	[48324]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Gloves of Triumph
	[48325]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Hauberk of Triumph
	[48326]="0:4:4:1:Mail::1:0:35576", -- Thrall's Hauberk of Triumph
	[48327]="0:4:4:1:Mail::1:0:35576", -- Thrall's Gloves of Triumph
	[48328]="0:4:4:1:Mail::1:0:35576", -- Thrall's Helm of Triumph
	[48329]="0:4:4:1:Mail::1:0:35576", -- Thrall's Kilt of Triumph
	[48330]="0:4:4:1:Mail::1:0:35576", -- Thrall's Shoulderpads of Triumph
	[48331]="0:4:4:1:Mail::1:0:35578", -- Thrall's Shoulderpads of Triumph
	[48332]="0:4:4:1:Mail::1:0:35578", -- Thrall's Kilt of Triumph
	[48333]="0:4:4:1:Mail::1:0:35578", -- Thrall's Helm of Triumph
	[48334]="0:4:4:1:Mail::1:0:35578", -- Thrall's Gloves of Triumph
	[48335]="0:4:4:1:Mail::1:0:35578", -- Thrall's Hauberk of Triumph
	[48336]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Hauberk of Conquest
	[48337]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Gloves of Conquest
	[48338]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Helm of Conquest
	[48339]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Kilt of Conquest
	[48340]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Shoulderpads of Conquest
	[48341]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Chestguard of Conquest
	[48342]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Grips of Conquest
	[48343]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Faceguard of Conquest
	[48344]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's War-Kilt of Conquest
	[48345]="0:4:4:1:Mail::1:0:35500,35579", -- Nobundo's Shoulderguards of Conquest
	[48346]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Chestguard of Triumph
	[48347]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Grips of Triumph
	[48348]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Faceguard of Triumph
	[48349]="0:4:4:1:Mail::1:0:35577", -- Nobundo's War-Kilt of Triumph
	[48350]="0:4:4:1:Mail::1:0:35577", -- Nobundo's Shoulderguards of Triumph
	[48351]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Shoulderguards of Triumph
	[48352]="0:4:4:1:Mail::1:0:35575", -- Nobundo's War-Kilt of Triumph
	[48353]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Faceguard of Triumph
	[48354]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Grips of Triumph
	[48355]="0:4:4:1:Mail::1:0:35575", -- Nobundo's Chestguard of Triumph
	[48356]="0:4:4:1:Mail::1:0:35576", -- Thrall's Chestguard of Triumph
	[48357]="0:4:4:1:Mail::1:0:35576", -- Thrall's Grips of Triumph
	[48358]="0:4:4:1:Mail::1:0:35576", -- Thrall's Faceguard of Triumph
	[48359]="0:4:4:1:Mail::1:0:35576", -- Thrall's War-Kilt of Triumph
	[48360]="0:4:4:1:Mail::1:0:35576", -- Thrall's Shoulderguards of Triumph
	[48361]="0:4:4:1:Mail::1:0:35578", -- Thrall's Shoulderguards of Triumph
	[48362]="0:4:4:1:Mail::1:0:35578", -- Thrall's War-Kilt of Triumph
	[48363]="0:4:4:1:Mail::1:0:35578", -- Thrall's Faceguard of Triumph
	[48364]="0:4:4:1:Mail::1:0:35578", -- Thrall's Grips of Triumph
	[48365]="0:4:4:1:Mail::1:0:35578", -- Thrall's Chestguard of Triumph
	[48366]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Chestguard of Conquest
	[48367]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Grips of Conquest
	[48368]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Faceguard of Conquest
	[48369]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's War-Kilt of Conquest
	[48370]="0:4:4:1:Mail::1:0:35500,35580", -- Thrall's Shoulderguards of Conquest
	[48371]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Helmet of Conquest
	[48372]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Battleplate of Conquest
	[48373]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Legplates of Conquest
	[48374]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Shoulderplates of Conquest
	[48375]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Gauntlets of Conquest
	[48376]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Battleplate of Triumph
	[48377]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Gauntlets of Triumph
	[48378]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Helmet of Triumph
	[48379]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Legplates of Triumph
	[48380]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Shoulderplates of Triumph
	[48381]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Shoulderplates of Triumph
	[48382]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Legplates of Triumph
	[48383]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Helmet of Triumph
	[48384]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Gauntlets of Triumph
	[48385]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Battleplate of Triumph
	[48386]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Battleplate of Conquest
	[48387]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Gauntlets of Conquest
	[48388]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Helmet of Conquest
	[48389]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Legplates of Conquest
	[48390]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Shoulderplates of Conquest
	[48391]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Battleplate of Triumph
	[48392]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Gauntlets of Triumph
	[48393]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Helmet of Triumph
	[48394]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Legplates of Triumph
	[48395]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Shoulderplates of Triumph
	[48396]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Battleplate of Triumph
	[48397]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Gauntlets of Triumph
	[48398]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Helmet of Triumph
	[48399]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Legplates of Triumph
	[48400]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Shoulderplates of Triumph
	[48402]="0:2:4:1:TwoHandAxe::1:0:", -- Relentless Gladiator's Sunderer
	[48404]="0:2:4:1:TwoHandMace::1:0:", -- Relentless Gladiator's Crusher
	[48406]="0:2:4:1:TwoHandSword::1:0:", -- Relentless Gladiator's Claymore
	[48408]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Mageblade
	[48410]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's Skirmish Staff
	[48412]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's Acute Staff
	[48414]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's Combat Staff
	[48418]="0:12:1:1:::1:0:", -- Fragment of the Black Knight's Soul
	[48420]="0:2:4:1:Bow::1:0:", -- Relentless Gladiator's Recurve
	[48422]="0:2:4:1:Crossbow::1:0:", -- Relentless Gladiator's Repeater
	[48424]="0:2:4:1:Gun::1:0:", -- Relentless Gladiator's Shotgun
	[48426]="0:2:4:1:OneHandAxe::1:0:", -- Relentless Gladiator's Dicer
	[48428]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Dirk
	[48429]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Greathelm of Conquest
	[48430]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Greathelm of Triumph
	[48432]="0:2:4:1:FistWeapon::1:0:", -- Relentless Gladiator's Left Razor
	[48433]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Greathelm of Triumph
	[48435]="0:2:4:1:OneHandMace::1:0:", -- Relentless Gladiator's Punisher
	[48436]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Breastplate of Conquest
	[48438]="0:2:4:1:OneHandSword::1:0:", -- Relentless Gladiator's Swiftblade
	[48440]="0:2:4:1:OneHandAxe::1:0:", -- Relentless Gladiator's Splitter
	[48442]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Eviscerator
	[48444]="0:2:4:1:FistWeapon::1:0:", -- Relentless Gladiator's Left Claw
	[48445]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Legguards of Conquest
	[48446]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Legguards of Triumph
	[48447]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Legguards of Triumph
	[48448]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Pauldrons of Conquest
	[48449]="0:4:4:1:Plate::1:0:34252,35579", -- Wrynn's Handguards of Conquest
	[48450]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Breastplate of Triumph
	[48451]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Breastplate of Triumph
	[48452]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Handguards of Triumph
	[48453]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Handguards of Triumph
	[48454]="0:4:4:1:Plate::1:0:35577", -- Wrynn's Pauldrons of Triumph
	[48455]="0:4:4:1:Plate::1:0:35575", -- Wrynn's Pauldrons of Triumph
	[48456]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Breastplate of Conquest
	[48457]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Handguards of Conquest
	[48458]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Greathelm of Conquest
	[48459]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Legguards of Conquest
	[48460]="0:4:4:1:Plate::1:0:35498,35580", -- Hellscream's Pauldrons of Conquest
	[48461]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Breastplate of Triumph
	[48462]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Handguards of Triumph
	[48463]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Greathelm of Triumph
	[48464]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Legguards of Triumph
	[48465]="0:4:4:1:Plate::1:0:35578", -- Hellscream's Pauldrons of Triumph
	[48466]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Breastplate of Triumph
	[48467]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Handguards of Triumph
	[48468]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Greathelm of Triumph
	[48469]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Legguards of Triumph
	[48470]="0:4:4:1:Plate::1:0:35576", -- Hellscream's Pauldrons of Triumph
	[48472]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Helmet of Conquest
	[48474]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Battleplate of Conquest
	[48476]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Legplates of Conquest
	[48478]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Shoulderplates of Conquest
	[48480]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Gauntlets of Conquest
	[48481]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Battleplate of Triumph
	[48482]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Gauntlets of Triumph
	[48483]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Helmet of Triumph
	[48484]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Legplates of Triumph
	[48485]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Shoulderplates of Triumph
	[48486]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Shoulderplates of Triumph
	[48487]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Legplates of Triumph
	[48488]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Helmet of Triumph
	[48489]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Gauntlets of Triumph
	[48490]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Battleplate of Triumph
	[48491]="0:4:4:1:Plate::1:0:35576", -- Koltira's Battleplate of Triumph
	[48492]="0:4:4:1:Plate::1:0:35576", -- Koltira's Gauntlets of Triumph
	[48493]="0:4:4:1:Plate::1:0:35576", -- Koltira's Helmet of Triumph
	[48494]="0:4:4:1:Plate::1:0:35576", -- Koltira's Legplates of Triumph
	[48495]="0:4:4:1:Plate::1:0:35576", -- Koltira's Shoulderplates of Triumph
	[48496]="0:4:4:1:Plate::1:0:35578", -- Koltira's Shoulderplates of Triumph
	[48497]="0:4:4:1:Plate::1:0:35578", -- Koltira's Legplates of Triumph
	[48498]="0:4:4:1:Plate::1:0:35578", -- Koltira's Helmet of Triumph
	[48499]="0:4:4:1:Plate::1:0:35578", -- Koltira's Gauntlets of Triumph
	[48500]="0:4:4:1:Plate::1:0:35578", -- Koltira's Battleplate of Triumph
	[48501]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Battleplate of Conquest
	[48502]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Gauntlets of Conquest
	[48503]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Helmet of Conquest
	[48504]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Legplates of Conquest
	[48505]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Shoulderplates of Conquest
	[48507]="0:2:4:1:OneHandAxe::1:0:", -- Relentless Gladiator's Handaxe
	[48509]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Spike
	[48511]="0:2:4:1:OneHandMace::1:0:", -- Relentless Gladiator's Truncheon
	[48513]="0:2:4:1:OneHandSword::1:0:", -- Relentless Gladiator's Longblade
	[48515]="0:2:4:1:FistWeapon::1:0:", -- Relentless Gladiator's Grasp
	[48517]="0:2:4:1:Polearm::1:0:", -- Relentless Gladiator's Halberd
	[48519]="0:2:4:1:OneHandMace::1:0:", -- Relentless Gladiator's Salvation
	[48521]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's Light Staff
	[48523]="0:2:4:1:Stave::1:0:", -- Relentless Gladiator's Greatstaff
	[48529]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Faceguard of Conquest
	[48531]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Chestguard of Conquest
	[48533]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Legguards of Conquest
	[48535]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Pauldrons of Conquest
	[48537]="0:4:4:1:Plate::1:0:34252,35579", -- Thassarian's Handguards of Conquest
	[48538]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Chestguard of Triumph
	[48539]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Handguards of Triumph
	[48540]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Faceguard of Triumph
	[48541]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Legguards of Triumph
	[48542]="0:4:4:1:Plate::1:0:35577", -- Thassarian's Pauldrons of Triumph
	[48543]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Pauldrons of Triumph
	[48544]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Legguards of Triumph
	[48545]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Faceguard of Triumph
	[48546]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Handguards of Triumph
	[48547]="0:4:4:1:Plate::1:0:35575", -- Thassarian's Chestguard of Triumph
	[48548]="0:4:4:1:Plate::1:0:35576", -- Koltira's Chestguard of Triumph
	[48549]="0:4:4:1:Plate::1:0:35576", -- Koltira's Handguards of Triumph
	[48550]="0:4:4:1:Plate::1:0:35576", -- Koltira's Faceguard of Triumph
	[48551]="0:4:4:1:Plate::1:0:35576", -- Koltira's Legguards of Triumph
	[48552]="0:4:4:1:Plate::1:0:35576", -- Koltira's Pauldrons of Triumph
	[48553]="0:4:4:1:Plate::1:0:35578", -- Koltira's Pauldrons of Triumph
	[48554]="0:4:4:1:Plate::1:0:35578", -- Koltira's Legguards of Triumph
	[48555]="0:4:4:1:Plate::1:0:35578", -- Koltira's Faceguard of Triumph
	[48556]="0:4:4:1:Plate::1:0:35578", -- Koltira's Handguards of Triumph
	[48557]="0:4:4:1:Plate::1:0:35578", -- Koltira's Chestguard of Triumph
	[48558]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Chestguard of Conquest
	[48559]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Handguards of Conquest
	[48560]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Faceguard of Conquest
	[48561]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Legguards of Conquest
	[48562]="0:4:4:1:Plate::1:0:35498,35580", -- Koltira's Pauldrons of Conquest
	[48564]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Headpiece of Conquest
	[48566]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Tunic of Conquest
	[48568]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Greaves of Conquest
	[48572]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Spaulders of Conquest
	[48574]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Gloves of Conquest
	[48575]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Tunic of Triumph
	[48576]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Gloves of Triumph
	[48577]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Headpiece of Triumph
	[48578]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Greaves of Triumph
	[48579]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Spaulders of Triumph
	[48580]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Spaulders of Triumph
	[48581]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Greaves of Triumph
	[48582]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Headpiece of Triumph
	[48583]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Gloves of Triumph
	[48584]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Tunic of Triumph
	[48585]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Spaulders of Triumph
	[48586]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Greaves of Triumph
	[48587]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Headpiece of Triumph
	[48588]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Gloves of Triumph
	[48589]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Tunic of Triumph
	[48590]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Spaulders of Triumph
	[48591]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Greaves of Triumph
	[48592]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Headpiece of Triumph
	[48593]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Gloves of Triumph
	[48594]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Tunic of Triumph
	[48595]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Spaulders of Conquest
	[48596]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Greaves of Conquest
	[48597]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Headpiece of Conquest
	[48598]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Gloves of Conquest
	[48599]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Tunic of Conquest
	[48602]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Battleplate of Conquest
	[48603]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Gauntlets of Conquest
	[48604]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Helm of Conquest
	[48605]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Legplates of Conquest
	[48606]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Shoulderplates of Conquest
	[48607]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Battleplate of Triumph
	[48608]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Gauntlets of Triumph
	[48609]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Helm of Triumph
	[48610]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Legplates of Triumph
	[48611]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Shoulderplates of Triumph
	[48612]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Shoulderplates of Triumph
	[48613]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Legplates of Triumph
	[48614]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Helm of Triumph
	[48615]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Gauntlets of Triumph
	[48616]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Battleplate of Triumph
	[48617]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Battleplate of Triumph
	[48618]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Gauntlets of Triumph
	[48619]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Helm of Triumph
	[48620]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Legplates of Triumph
	[48621]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Shoulderplates of Triumph
	[48622]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Shoulderplates of Triumph
	[48623]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Legplates of Triumph
	[48624]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Helm of Triumph
	[48625]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Gauntlets of Triumph
	[48626]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Battleplate of Triumph
	[48627]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Shoulderplates of Conquest
	[48628]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Legplates of Conquest
	[48629]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Helm of Conquest
	[48630]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Gauntlets of Conquest
	[48631]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Battleplate of Conquest
	[48632]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Breastplate of Conquest
	[48633]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Handguards of Conquest
	[48634]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Faceguard of Conquest
	[48635]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Legguards of Conquest
	[48636]="0:4:4:1:Plate::1:0:34252,35579", -- Turalyon's Shoulderguards of Conquest
	[48637]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Shoulderguards of Triumph
	[48638]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Legguards of Triumph
	[48639]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Faceguard of Triumph
	[48640]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Handguards of Triumph
	[48641]="0:4:4:1:Plate::1:0:35577", -- Turalyon's Breastplate of Triumph
	[48642]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Breastplate of Triumph
	[48643]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Handguards of Triumph
	[48644]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Faceguard of Triumph
	[48645]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Legguards of Triumph
	[48646]="0:4:4:1:Plate::1:0:35575", -- Turalyon's Shoulderguards of Triumph
	[48647]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Shoulderguards of Triumph
	[48648]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Legguards of Triumph
	[48649]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Faceguard of Triumph
	[48650]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Handguards of Triumph
	[48651]="0:4:4:1:Plate::1:0:35576", -- Liadrin's Breastplate of Triumph
	[48652]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Breastplate of Conquest
	[48653]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Handguards of Conquest
	[48654]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Faceguard of Conquest
	[48655]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Legguards of Conquest
	[48656]="0:4:4:1:Plate::1:0:35498,35580", -- Liadrin's Shoulderguards of Conquest
	[48657]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Breastplate of Triumph
	[48658]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Handguards of Triumph
	[48659]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Faceguard of Triumph
	[48660]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Legguards of Triumph
	[48661]="0:4:4:1:Plate::1:0:35578", -- Liadrin's Shoulderguards of Triumph
	[48663]="0:2:4:1:OneHandMace::1:0:", -- Tankard O' Terror
	[48666]="0:4:4:1:Cloak::1:0:", -- Drape of the Sunreavers
	[48667]="0:4:4:1:Cloak::1:0:", -- Shawl of the Devout Crusader
	[48668]="0:4:4:1:Cloak::1:0:", -- Cloak of Serrated Blades
	[48669]="0:4:4:1:Cloak::1:0:", -- Cloak of the Triumphant Combatant
	[48670]="0:4:4:1:Cloak::1:0:", -- Cloak of the Unflinching Guardian
	[48671]="0:4:4:1:Cloak::1:0:", -- Drape of Bitter Incantation
	[48672]="0:4:4:1:Cloak::1:0:", -- Shawl of Fervent Crusader
	[48673]="0:4:4:1:Cloak::1:0:", -- Cloak of the Silver Covenant
	[48674]="0:4:4:1:Cloak::1:0:", -- Cloak of the Victorious Combatant
	[48675]="0:4:4:1:Cloak::1:0:", -- Cloak of the Unmoving Guardian
	[48677]="0:4:7:1:Mail::1:0:32509,34885,35507,35508", -- Champion's Deathdealer Breastplate
	[48679]="0:12:1:1:::1:0:", -- Waterlogged Recipe
	[48681]="0:12:1:1:::1:0:", -- Waterlogged Recipe
	[48683]="0:4:7:1:Mail::1:0:32509,34885,35507,35508", -- Mystical Vest of Elements
	[48685]="0:4:7:1:Plate::1:0:32509,34885,35507,35508", -- Polished Breastplate of Valor
	[48687]="0:4:7:1:Leather::1:0:32509,34885,35507,35508", -- Preened Ironfeather Breastplate
	[48689]="0:4:7:1:Leather::1:0:32509,34885,35507,35508", -- Stained Shadowcraft Tunic
	[48691]="0:4:7:1:Cloth::1:0:32509,34885,35507,35508", -- Tattered Dreadmist Robe
	[48693]="0:2:4:1:OneHandMace::1:0:", -- Heartsmasher
	[48695]="309671:2:4:1:TwoHandAxe::1:0:", -- Mor'kosh, the Bloodreaver
	[48697]="0:2:4:1:Bow::1:0:", -- Frenzystrike Longbow
	[48699]="0:2:4:1:OneHandMace::1:0:", -- Blood and Glory
	[48701]="0:2:4:1:OneHandSword::1:0:", -- Spellharvest
	[48703]="0:2:4:1:FistWeapon::1:0:", -- The Facebreaker
	[48705]="0:2:4:1:Stave::1:0:", -- Attrition
	[48708]="0:2:4:1:OneHandSword::1:0:", -- Spellstorm Blade
	[48709]="0:2:4:1:OneHandMace::1:0:", -- Heartcrusher
	[48710]="0:2:4:1:Stave::1:0:", -- Paragon's Breadth
	[48711]="183145:2:4:1:Bow::1:0:", -- Rhok'shalla, the Shadow's Bane
	[48712]="0:2:4:1:FistWeapon::1:0:", -- The Spinebreaker
	[48713]="0:2:4:1:TwoHandAxe::1:0:", -- Lothar's Edge
	[48714]="0:2:4:1:OneHandMace::1:0:", -- Honor of the Fallen
	[48716]="0:2:7:1:OneHandMace::1:0:32509,34885,35507,35508", -- Venerable Mass of McGowan
	[48718]="0:2:7:1:TwoHandMace::1:0:32509,34885,35507,35508", -- Repurposed Lava Dredger
	[48720]="0:16:1:20:Druid::1:0:", -- Glyph of Claw
	[48722]="0:4:4:1:Trinket::1:0:29528,35494,35495,35573,35574", -- Shard of the Crystal Heart
	[48724]="0:4:4:1:Trinket::1:0:29528,35494,35495,35573,35574", -- Talisman of Resurgence
	[48743]="0:4:4:1:Cloth::1:0:", -- Kel'Thuzad's Robe 
	[48774]="0:4:4:1:Leather::1:0:", -- Malfurion's Handguards 
	[48783]="0:4:4:1:Leather::1:0:", -- Runetotem's Mantle 
	[48933]="0:4:3:1:Miscellaneous::1:0:", -- Wormhole Generator: Northrend
	[48954]="12500000:4:4:1:Ring::1:0:32172", -- Etched Band of the Kirin Tor
	[48955]="12500000:4:4:1:Ring::1:0:32172", -- Etched Loop of the Kirin Tor
	[48956]="12500000:4:4:1:Ring::1:0:32172", -- Etched Ring of the Kirin Tor
	[48957]="12500000:4:4:1:Ring::1:0:32172", -- Etched Signet of the Kirin Tor
	[48974]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Armwraps of Dominance
	[48975]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Armwraps of Salvation
	[48976]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Armwraps of Triumph
	[48977]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Bracers of Salvation
	[48978]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Bracers of Triumph
	[48979]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Cuffs of Salvation
	[48980]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Wristguards of Dominance
	[48981]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Wristguards of Salvation
	[48982]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Wristguards of Triumph
	[48983]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Chain Leggings of Triumph
	[48987]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Leather Legguards of Salvation
	[48988]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Leather Legguards of Triumph
	[48990]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Mail Leggings of Dominance
	[48991]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Cloth Leggings of Salvation
	[48992]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Plate Legguards of Salvation
	[48993]="0:4:4:1:Plate::1:0:32294,32296", -- Titan-Forged Plate Legguards of Triumph
	[48994]="0:4:4:1:Mail::1:0:32294,32296", -- Titan-Forged Ringmail Leggings of Salvation
	[48997]="0:4:4:1:Cloth::1:0:32294,32296", -- Titan-Forged Cloth Trousers of Domination
	[48998]="0:4:4:1:Leather::1:0:32294,32296", -- Titan-Forged Leather Legguards of Dominance
	[48999]="0:4:4:1:Ring::1:0:32294,32296", -- Titan-Forged Band of Ascendancy
	[49000]="0:4:4:1:Ring::1:0:32294,32296", -- Titan-Forged Band of Victory
	[49040]="0:15:4:1:CombatPet::1:0:", -- Jeeves
	[49044]="0:15:4:1:Mount::1:0:", -- Swift Alliance Steed
	[49046]="0:15:4:1:Mount::1:0:", -- Swift Horde Wolf
	[49050]="0:9:3:1:Engineering::1:0:", -- Schematic: Jeeves
	[49052]="0:4:3:1:Tabard::1:0:", -- Tabard of Conquest
	[49054]="0:4:3:1:Tabard::1:0:", -- Tabard of Conquest
	[49074]="0:4:4:1:Trinket::1:0:", -- Coren's Chromium Coaster
	[49076]="0:4:4:1:Trinket::1:0:", -- Mithril Pocketwatch
	[49078]="0:4:4:1:Trinket::1:0:", -- Ancient Pickled Egg
	[49080]="0:4:4:1:Trinket::1:0:", -- Brawler's Souvenir
	[49084]="0:16:1:20:Warrior::1:0:", -- Glyph of Command
	[49086]="0:4:4:1:Tabard::1:0:", -- Relentless Gladiator's Tabard
	[49110]="0:3:4:1:GemPrismatic::1:0:", -- Nightmare Tear
	[49112]="0:9:3:1:Jewelcrafting::1:0:19065,28701,33637,33680", -- Design: Nightmare Tear
	[49116]="0:4:4:1:Trinket::1:0:", -- Bitter Balebrew Charm
	[49118]="0:4:4:1:Trinket::1:0:", -- Bubbling Brightbrew Charm
	[49120]="0:2:4:1:Dagger::1:0:", -- Direbrew's Bloody Shanker
	[49121]="0:4:4:1:Ring::1:0:", -- Ring of Ghoulish Glee
	[49123]="0:4:4:1:Ring::1:0:", -- The Horseman's Seal
	[49124]="0:4:4:1:Ring::1:0:", -- Wicked Witch's Band
	[49126]="0:4:4:1:Plate::1:0:", -- The Horseman's Horrific Helm
	[49128]="0:2:4:1:OneHandSword::1:0:", -- The Horseman's Baleful Blade
	[49177]="10000000:15:7:1:FlyingMount::1:0:31238", -- Tome of Cold Weather Flight
	[49179]="0:4:4:1:Cloth::1:0:34038,34075", -- Relentless Gladiator's Cord of Alacrity
	[49181]="0:4:4:1:Cloth::1:0:34038,34075", -- Relentless Gladiator's Cuffs of Alacrity
	[49183]="0:4:4:1:Cloth::1:0:34038,34075", -- Relentless Gladiator's Treads of Alacrity
	[49185]="0:2:4:1:Wand::1:0:", -- Relentless Gladiator's Wand of Alacrity
	[49187]="0:4:4:1:OffHandFrill::1:0:", -- Relentless Gladiator's Compendium
	[49189]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Blade of Alacrity
	[49191]="0:2:4:1:Dagger::1:0:", -- Relentless Gladiator's Blade of Celerity
	[49192]="0:15:0:1:Junk::1:0:", -- Horde Trauma Certification
	[49193]="0:15:0:1:Junk::1:0:", -- Alliance Trauma Certification
	[49205]="0:15:1:1:Junk::1:0:", -- Small Scroll
	[49209]="0:15:0:20:Junk::1:0:", -- Mutated Morrowgrain
	[49227]="0:2:3:1:Dagger::1:0:", -- Skoll's Fang
	[49231]="0:4:4:1:Cloth::1:0:", -- Boots of the Grieving Soul
	[49232]="0:4:4:1:Cloth::1:0:", -- Sandals of the Grieving Soul
	[49233]="0:4:4:1:Cloth::1:0:", -- Sandals of the Grieving Soul
	[49234]="0:4:4:1:Cloth::1:0:", -- Boots of the Grieving Soul
	[49235]="0:4:4:1:Mail::1:0:", -- Boots of Tortured Space
	[49236]="0:4:4:1:Mail::1:0:", -- Sabatons of Tortured Space
	[49237]="0:4:4:1:Mail::1:0:", -- Sabatons of Tortured Space
	[49238]="0:4:4:1:Mail::1:0:", -- Boots of Tortured Space
	[49278]="0:4:1:1:Shirt::1:0:", -- Goblin Rocket Pack
	[49282]="0:15:4:1:Mount::1:0:", -- Big Battle Bear
	[49283]="0:15:3:1:Mount::1:0:", -- Reins of the Spectral Tiger
	[49284]="0:15:4:1:Mount::1:0:", -- Reins of the Swift Spectral Tiger
	[49285]="0:15:3:1:FlyingMount::1:0:", -- X-51 Nether-Rocket
	[49286]="0:15:4:1:FlyingMount::1:0:", -- X-51 Nether-Rocket X-TREME
	[49287]="0:15:4:1:Companion::1:0:", -- Tuskarr Kite
	[49288]="0:15:2:250:Mount::1:0:", -- Little Ivory Raptor Whistle
	[49289]="0:15:2:250:Mount::1:0:", -- Little White Stallion Bridle
	[49290]="0:15:4:1:Mount::1:0:", -- Magic Rooster Egg
	[49294]="0:15:4:1:Junk::1:0:", -- Ashen Sack of Gems
	[49295]="0:1:4:1:Bag::1:0:", -- Enlarged Onyxia Hide Backpack
	[49296]="0:2:4:1:OneHandSword::1:0:", -- Singed Vis'kag the Bloodletter
	[49297]="0:2:4:1:OneHandAxe::1:0:", -- Empowered Deathbringer
	[49298]="0:2:4:1:OneHandSword::1:0:", -- Glinting Azuresong Mageblade
	[49299]="0:2:4:1:TwoHandSword::1:0:", -- Keen Obsidian Edged Blade
	[49301]="0:2:4:1:Polearm::1:0:", -- Reclaimed Thunderstrike
	[49302]="0:2:4:1:Polearm::1:0:", -- Reclaimed Shadowstrike
	[49303]="0:2:4:1:OneHandSword::1:0:", -- Gleaming Quel'Serrar
	[49304]="0:2:4:1:Dagger::1:0:", -- Sharpened Fang of the Mystics
	[49305]="0:2:4:1:Gun::1:0:", -- Snub-Nose Blastershot Launcher
	[49306]="0:4:4:1:Amulet::1:0:", -- Eskhandar's Choker
	[49307]="0:4:4:1:Cloak::1:0:", -- Fluttering Sapphiron Drape
	[49308]="0:4:4:1:OffHandFrill::1:0:", -- Antique Cornerstone Grimoire
	[49309]="0:4:4:1:Ring::1:0:", -- Runed Ring of Binding
	[49310]="0:4:4:1:Trinket::1:0:", -- Purified Shard of the Scale
	[49312]="0:4:4:1:Trinket::1:0:", -- Purified Onyxia Blood Talisman
	[49313]="0:4:4:1:Ring::1:0:", -- Polished Dragonslayer's Signet
	[49315]="0:4:4:1:Cloth::1:0:", -- Nemesis Skullcover
	[49316]="0:4:4:1:Cloth::1:0:", -- Circlet of Transcendence
	[49317]="0:4:4:1:Cloth::1:0:", -- Coronet of Transcendence
	[49318]="0:4:4:1:Cloth::1:0:", -- Netherwind Hood
	[49319]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Helmet
	[49320]="0:4:4:1:Plate::1:0:", -- Faceguard of Wrath
	[49321]="0:4:4:1:Plate::1:0:", -- Greathelm of Wrath
	[49322]="0:4:4:1:Leather::1:0:", -- Bloodfang Mask
	[49323]="0:4:4:1:Plate::1:0:", -- Judgement Cover
	[49324]="0:4:4:1:Plate::1:0:", -- Judgement Helmet
	[49325]="0:4:4:1:Plate::1:0:", -- Judgement Helm
	[49326]="0:4:4:1:Leather::1:0:", -- Stormrage Hood
	[49327]="0:4:4:1:Leather::1:0:", -- Stormrage Antlers
	[49328]="0:4:4:1:Leather::1:0:", -- Stormrage Helm
	[49329]="0:4:4:1:Mail::1:0:", -- Gaze of Ten Storms
	[49330]="0:4:4:1:Mail::1:0:", -- Cowl of Ten Storms
	[49331]="0:4:4:1:Mail::1:0:", -- Coif of Ten Storms
	[49332]="0:4:4:1:Plate::1:0:", -- Frostforged Ringhelm
	[49333]="0:4:4:1:Plate::1:0:", -- Frostforged Helmet
	[49335]="0:12:1:1:::1:0:", -- Daros' Journal
	[49343]="0:15:3:1:Companion::1:0:", -- Spectral Tiger Cub
	[49351]="0:12:1:1:::1:0:", -- Perfume Neutralizer
	[49352]="0:12:1:1:::1:0:", -- Cologne Neutralizer
	[49362]="0:15:1:1:Companion::1:0:", -- Onyxian Whelpling
	[49426]="0:10:4::Currency::1:0:", -- Emblem of Frost
	[49437]="0:2:4:1:Dagger::1:0:", -- Rusted Gutgore Ripper
	[49463]="0:4:4:1:Trinket::1:0:", -- Purified Shard of the Flame
	[49464]="0:4:4:1:Trinket::1:0:", -- Shiny Shard of the Flame
	[49465]="0:2:4:1:Dagger::1:0:", -- Tarnished Gutgore Ripper
	[49466]="0:4:4:1:Plate::1:0:", -- Frostforged Helm
	[49467]="0:4:4:1:Plate::1:0:", -- Frostforged Greathelm
	[49468]="0:4:4:1:Mail::1:0:", -- Helm of Ten Storms
	[49469]="0:4:4:1:Mail::1:0:", -- Crown of Ten Storms
	[49470]="0:4:4:1:Mail::1:0:", -- Helmet of Ten Storms
	[49471]="0:4:4:1:Leather::1:0:", -- Stormrage Coverlet
	[49472]="0:4:4:1:Leather::1:0:", -- Stormrage Crown
	[49473]="0:4:4:1:Leather::1:0:", -- Stormrage Cover
	[49474]="0:4:4:1:Plate::1:0:", -- Judgement Hood
	[49475]="0:4:4:1:Plate::1:0:", -- Judgement Heaume
	[49476]="0:4:4:1:Plate::1:0:", -- Judgement Crown
	[49477]="0:4:4:1:Leather::1:0:", -- Bloodfang Hood
	[49478]="0:4:4:1:Plate::1:0:", -- Helmet of Wrath
	[49479]="0:4:4:1:Plate::1:0:", -- Helm of Wrath
	[49480]="0:4:4:1:Mail::1:0:", -- Dragonstalker's Helm
	[49481]="0:4:4:1:Cloth::1:0:", -- Netherwind Crown
	[49482]="0:4:4:1:Cloth::1:0:", -- Aurora of Transcendence
	[49483]="0:4:4:1:Cloth::1:0:", -- Halo of Transcendence
	[49484]="0:4:4:1:Cloth::1:0:", -- Nemesis Skullcap
	[49485]="0:4:4:1:Amulet::1:0:", -- Sparkling Onyxia Tooth Pendant
	[49486]="0:4:4:1:Ring::1:0:", -- Polished Dragonslayer's Signet
	[49487]="0:4:4:1:Trinket::1:0:", -- Purified Onyxia Blood Talisman
	[49488]="0:4:4:1:Trinket::1:0:", -- Shiny Shard of the Scale
	[49489]="0:4:4:1:Ring::1:0:", -- Signified Ring of Binding
	[49490]="0:4:4:1:OffHandFrill::1:0:", -- Antediluvian Cornerstone Grimoire
	[49491]="0:4:4:1:Cloak::1:0:", -- Flowing Sapphiron Drape
	[49492]="0:4:4:1:Amulet::1:0:", -- Eskhandar's Links
	[49493]="0:2:4:1:Gun::1:0:", -- Rifled Blastershot Launcher
	[49494]="0:2:4:1:Dagger::1:0:", -- Honed Fang of the Mystics
	[49495]="0:2:4:1:OneHandSword::1:0:", -- Burnished Quel'Serrar
	[49496]="0:2:4:1:Polearm::1:0:", -- Reinforced Shadowstrike
	[49497]="0:2:4:1:Polearm::1:0:", -- Reinforced Thunderstrike
	[49498]="0:2:4:1:TwoHandSword::1:0:", -- Sharpened Obsidian Edged Blade
	[49499]="0:2:4:1:OneHandSword::1:0:", -- Polished Azuresong Mageblade
	[49500]="0:2:4:1:OneHandAxe::1:0:", -- Raging Deathbringer
	[49501]="0:2:4:1:OneHandSword::1:0:", -- Tempered Vis'kag the Bloodletter
	[49536]="0:12:1:1:::1:0:", -- Sunreaver Orders
	[49623]="0:2:5:1:TwoHandAxe::1:0:", -- Shadowmourne
	[49631]="0:0:1:1:Consumable::1:0:", -- Standard Apothecary Serving Kit
	[49632]="0:0:1:20:Scroll::1:0:", -- Runescroll of Fortitude
	[49633]="0:0:1:1:Other::1:0:", -- Drums of Forgotten Kings
	[49634]="0:0:1:1:Other::1:0:", -- Drums of the Wild
	[49635]="0:12:1:1:::1:0:", -- Court Subpoena
	[49636]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Onyxian Drake
	[49640]="0:7:2:1:Enchanting::1:0:", -- Essence or Dust
	[49641]="0:12:1:1:::1:0:", -- Faded Lovely Greeting Card
	[49643]="0:12:4:1:::1:0:", -- Head of Onyxia
	[49644]="0:12:4:1:::1:0:", -- Head of Onyxia
	[49646]="0:15:3:1:Companion::1:0:", -- Core Hound Pup
	[49648]="0:12:1:1:::1:0:", -- Borrowed Tabard
	[49655]="0:12:1:40:::1:0:", -- Lovely Charm
	[49661]="0:12:1:1:::1:0:", -- Lovely Charm Collector's Kit
	[49662]="0:15:3:1:Companion::1:0:", -- Gryphon Hatchling
	[49663]="0:15:3:1:Companion::1:0:", -- Wind Rider Cub
	[49665]="0:15:3:1:Companion::1:0:", -- Pandaren Monk
	[49668]="0:12:1:1:::1:0:", -- Crown Perfume Sprayer
	[49669]="0:12:1:1:::1:0:", -- Crown Cologne Sprayer
	[49670]="0:12:1:1:::1:0:", -- Crown Chocolate Sampler
	[49676]="0:12:1:1:::1:0:", -- Kvaldir Attack Plans
	[49678]="0:12:1:1:::1:0:", -- Heart of the Mists
	[49682]="0:2:4:1:Dagger::1:0:", -- Black Knight's Rondel
	[49693]="0:15:3:1:Companion::1:0:", -- Lil' Phylactery
	[49698]="0:12:1:1:::1:0:", -- Ancient Dragonforged Blades
	[49702]="0:0:2:250:Other::1:0:35494,35495,35573,35574", -- Sons of Hodir Commendation Badge
	[49703]="0:15:4:1:Junk::1:0:", -- Perpetual Purple Firework
	[49704]="0:15:4:1:Junk::1:0:", -- Carved Ogre Idol
	[49715]="0:4:3:1:Miscellaneous::1:0:", -- Forever-Lovely Rose
	[49718]="0:12:1:5:::1:0:", -- Infused Saronite Bar
	[49723]="0:12:1:1:::1:0:", -- The Forgemaster's Hammer
	[49739]="0:12:1:1:::1:0:", -- Reforged Quel'Delar
	[49740]="0:12:1:1:::1:0:", -- Remnants of Quel'Delar
	[49750]="0:12:1:1:::1:0:", -- Tempered Quel'Delar
	[49766]="0:12:1:1:::1:0:", -- Tempered Quel'Delar
	[49778]="0:2:1:1:TwoHandSword::1:0:", -- Worn Greatsword
	[49783]="0:2:4:1:OneHandMace::1:0:", -- Lucky Old Sun
	[49784]="0:4:4:1:Plate::1:0:", -- Minister's Number One Legplates
	[49785]="0:4:4:1:Leather::1:0:", -- Bewildering Shoulderpads
	[49786]="0:4:4:1:Leather::1:0:", -- Robes of the Cheating Heart
	[49787]="0:4:4:1:Mail::1:0:", -- Seven Stormy Mornings
	[49788]="0:4:4:1:Cloth::1:0:", -- Cold Sweat Grips
	[49789]="0:2:4:1:Dagger::1:0:", -- Heartshiver
	[49790]="0:2:4:1:Stave::1:0:", -- Blood Boil Lancet
	[49791]="0:4:4:1:Plate::1:0:", -- Lost Reliquary Chestguard
	[49792]="0:4:4:1:Cloak::1:0:", -- Accursed Crawling Cape
	[49793]="0:2:4:1:Stave::1:0:", -- Tower of the Mouldering Corpse
	[49794]="0:4:4:1:Plate::1:0:", -- Legplates of Frozen Granite
	[49795]="0:4:4:1:Plate::1:0:", -- Sollerets of Suffering
	[49796]="0:4:4:1:Cloth::1:0:", -- Essence of Anger
	[49797]="0:4:4:1:Plate::1:0:", -- Brace Guards of the Starless Night
	[49798]="0:4:4:1:Mail::1:0:", -- Soul Screaming Boots
	[49799]="0:4:4:1:Amulet::1:0:", -- Coil of Missing Gems
	[49800]="0:4:4:1:Ring::1:0:", -- Spiteful Signet
	[49801]="0:2:4:1:Stave::1:0:", -- Unspeakable Secret
	[49802]="0:2:4:1:TwoHandMace::1:0:", -- Garfrost's Two-Ton Hammer
	[49803]="0:4:4:1:Ring::1:0:", -- Ring of Carnelian and Bone
	[49804]="0:4:4:1:Mail::1:0:", -- Polished Mirror Helm
	[49805]="0:4:4:1:Cloth::1:0:", -- Ice-Steeped Sandals
	[49806]="0:4:4:1:Leather::1:0:", -- Flayer's Black Belt
	[49807]="0:2:4:1:Dagger::1:0:", -- Krick's Beetle Stabber
	[49808]="0:4:4:1:Plate::1:0:", -- Bent Gold Belt
	[49809]="0:4:4:1:Cloth::1:0:", -- Wristguards of Subterranean Moss
	[49810]="0:4:4:1:Mail::1:0:", -- Scabrous Zombie Leather Belt
	[49811]="0:4:4:1:Mail::1:0:", -- Black Dragonskin Breeches
	[49812]="0:4:4:1:Ring::1:0:", -- Purloined Wedding Ring
	[49813]="0:2:4:1:Gun::1:0:", -- Rimebane Rifle
	[49816]="0:4:4:1:Plate::1:0:", -- Scourgelord's Frigid Chestplate
	[49817]="0:4:4:1:Leather::1:0:", -- Shaggy Wyrmleather Leggings
	[49818]="0:4:4:1:Amulet::1:0:", -- Painfully Sharp Choker
	[49819]="0:4:4:1:Plate::1:0:", -- Skeleton Lord's Cranium
	[49820]="0:4:4:1:Mail::1:0:", -- Gondria's Spectral Bracer
	[49821]="0:4:4:1:Shield::1:0:", -- Protector of Frigid Souls
	[49822]="0:4:4:1:Cloth::1:0:", -- Rimewoven Silks
	[49823]="0:4:4:1:Cloak::1:0:", -- Cloak of the Fallen Cardinal
	[49824]="0:4:4:1:Mail::1:0:", -- Horns of the Spurned Val'kyr
	[49825]="0:4:4:1:Cloth::1:0:", -- Palebone Robes
	[49826]="0:4:4:1:Mail::1:0:", -- Shroud of Rime
	[49827]="0:2:4:1:OneHandSword::1:0:", -- Ghoulslicer
	[49828]="0:4:4:1:Cloth::1:0:", -- Marwyn's Macabre Fingertips
	[49829]="0:4:4:1:Plate::1:0:", -- Valonforth's Tarnished Pauldrons
	[49830]="0:4:4:1:Leather::1:0:", -- Fallen Sentry's Hood
	[49831]="0:4:4:1:Mail::1:0:", -- Muddied Boots of Brill
	[49832]="0:4:4:1:Cloak::1:0:", -- Eerie Runeblade Polisher
	[49833]="0:2:4:1:OneHandSword::1:0:", -- Splintered Icecrown Parapet
	[49834]="0:4:4:1:Cloth::1:0:", -- Frayed Abomination Stitching Shoulders
	[49835]="0:4:4:1:Shield::1:0:", -- Splintered Door of the Citadel
	[49836]="0:4:4:1:Mail::1:0:", -- Frostsworn Bone Leggings
	[49837]="0:4:4:1:Mail::1:0:", -- Mitts of Burning Hail
	[49838]="0:4:4:1:Leather::1:0:", -- Carpal Tunnelers
	[49839]="0:2:4:1:TwoHandSword::1:0:", -- Mourning Malice
	[49840]="0:2:4:1:OneHandAxe::1:0:", -- Hate-Forged Cleaver
	[49841]="0:4:4:1:Leather::1:0:", -- Blackened Geist Ribs
	[49842]="0:4:4:1:Cloak::1:0:", -- Tapestry of the Frozen Throne
	[49843]="0:4:4:1:Plate::1:0:", -- Crystalline Citadel Gauntlets
	[49844]="0:2:4:1:Bow::1:0:", -- Crypt Fiend Slayer
	[49845]="0:2:4:1:OneHandMace::1:0:", -- Bone Golem Scapula
	[49846]="0:2:4:1:Dagger::1:0:", -- Chilled Heart of the Glacier
	[49847]="0:4:4:1:Mail::1:0:", -- Legguards of Untimely Demise
	[49848]="0:4:4:1:Leather::1:0:", -- Grim Lasher Shoulderguards
	[49849]="0:4:4:1:Cloth::1:0:", -- Tattered Glacial-Woven Hood
	[49851]="0:4:4:1:Plate::1:0:", -- Greathelm of the Silver Hand
	[49852]="0:2:4:1:Wand::1:0:", -- Coffin Nail
	[49853]="0:4:4:1:Plate::1:0:", -- Titanium Links of Lore
	[49854]="0:4:4:1:Cloth::1:0:", -- Mantle of Tattered Feathers
	[49855]="0:4:4:1:Plate::1:0:", -- Plated Grips of Korth'azz
	[49856]="0:0:1:20:Consumable::5:0:37674", -- "VICTORY" Perfume
	[49857]="0:0:1:20:Consumable::5:0:37674", -- "Enchantress" Perfume
	[49858]="0:0:1:20:Consumable::5:0:37674", -- "Forever" Perfume
	[49859]="0:0:1:20:Consumable::5:0:37674", -- "Bravado" Cologne
	[49860]="0:0:1:20:Consumable::5:0:37674", -- "Wizardry" Cologne
	[49861]="0:0:1:20:Consumable::5:0:37674", -- "STALWART" Cologne
	[49867]="0:12:1:1:::1:0:", -- Crown Chemical Co. Supplies
	[49869]="0:12:4:10:::1:0:", -- Light's Vengeance
	[49870]="0:12:1:1:::1:0:", -- Tempered Quel'Delar
	[49871]="0:12:1:1:::1:0:", -- Restored Quel'Delar
	[49872]="0:12:1:1:::1:0:", -- Silver Covenant Orders
	[49879]="0:12:1:1:::1:0:", -- Tainted Quel'Delar
	[49888]="0:2:4:1:TwoHandAxe::1:0:", -- Shadow's Edge
	[49889]="0:12:1:1:::1:0:", -- Tainted Quel'Delar
	[49890]="0:4:4:1:Cloth::1:0:", -- Deathfrost Boots
	[49891]="0:4:4:1:Cloth::1:0:", -- Leggings of Woven Death
	[49892]="0:4:4:1:Cloth::1:0:", -- Lightweave Leggings
	[49893]="0:4:4:1:Cloth::1:0:", -- Sandals of Consecration
	[49894]="0:4:4:1:Leather::1:0:", -- Blessed Cenarion Boots
	[49895]="0:4:4:1:Leather::1:0:", -- Footpads of Impending Death
	[49896]="0:4:4:1:Mail::1:0:", -- Earthsoul Boots
	[49897]="0:4:4:1:Mail::1:0:", -- Rock-Steady Treads
	[49898]="0:4:4:1:Leather::1:0:", -- Legwraps of Unleashed Nature
	[49899]="0:4:4:1:Leather::1:0:", -- Bladeborn Leggings
	[49900]="0:4:4:1:Mail::1:0:", -- Lightning-Infused Leggings
	[49901]="0:4:4:1:Mail::1:0:", -- Draconic Bonesplinter Legguards
	[49902]="0:4:4:1:Plate::1:0:", -- Puresteel Legplates
	[49903]="0:4:4:1:Plate::1:0:", -- Legplates of Painful Death
	[49904]="0:4:4:1:Plate::1:0:", -- Pillars of Might
	[49905]="0:4:4:1:Plate::1:0:", -- Protectors of Life
	[49906]="0:4:4:1:Plate::1:0:", -- Hellfrozen Bonegrinders
	[49907]="0:4:4:1:Plate::1:0:", -- Boots of Kingly Upheaval
	[49908]="0:7:3:20:Other:164,165,197:1:0:37941,37942,38858", -- Primordial Saronite
	[49909]="0:15:1:1:Junk::1:0:37674", -- Box of Chocolates
	[49912]="0:15:3:1:Companion::1:0:", -- Perky Pug
	[49915]="0:12:1:10:::1:0:", -- Snivel's Ledger
	[49916]="0:4:1:1:Miscellaneous::1:0:", -- Lovely Charm Bracelet
	[49917]="0:15:2:1:Junk::1:0:", -- Brazie's Gnomish Pleasure Device
	[49918]="0:15:1:1:Junk::1:0:", -- Brazie's Guide to Getting Good with Gnomish Girls
	[49919]="0:2:4:1:TwoHandMace::1:0:", -- Cryptmaker
	[49920]="0:12:1:1:::1:0:", -- Reforged Quel'Delar
	[49922]="0:15:1:1:Junk::1:0:", -- Brazie's Dictionary of Devilish Draenei Damsels
	[49923]="0:15:1:1:Junk::1:0:", -- Brazie's Document on Dwarven Dates in Dun Morogh
	[49924]="0:15:1:1:Junk::1:0:", -- Brazie's Notes on Naughty Night Elves
	[49925]="0:15:1:1:Junk::1:0:", -- Brazie's Handbook to Handling Human Hunnies
	[49926]="0:15:4:1:Junk::1:0:", -- Brazie's Black Book of Secrets
	[49927]="0:15:1:250:Junk::1:0:37674", -- Love Token
	[49936]="0:0:1:20:Consumable::1:0:", -- Lovely Stormwind Card
	[49937]="0:0:1:20:Consumable::1:0:", -- Lovely Undercity Card
	[49938]="0:0:1:20:Consumable::1:0:", -- Lovely Darnassus Card
	[49939]="0:0:1:20:Consumable::1:0:", -- Lovely Orgrimmar Card
	[49940]="0:0:1:20:Consumable::1:0:", -- Lovely Ironforge Card
	[49941]="0:0:1:20:Consumable::1:0:", -- Lovely Thunder Bluff Card
	[49942]="0:0:1:20:Consumable::1:0:", -- Lovely Exodar Card
	[49943]="0:0:1:20:Consumable::1:0:", -- Lovely Silvermoon City Card
	[49949]="0:4:4:1:Ring::1:0:", -- Band of the Bone Colossus
	[49950]="0:4:4:1:Leather::1:0:", -- Frostbitten Fur Boots
	[49951]="0:4:4:1:Plate::1:0:", -- Gendarme's Cuirass
	[49952]="0:4:4:1:Mail::1:0:", -- Snowserpent Mail Helm
	[49953]="0:9:4:1:Tailoring::1:0:37687", -- Pattern: Leggings of Woven Death
	[49954]="0:9:4:1:Tailoring::1:0:37687", -- Pattern: Deathfrost Boots
	[49955]="0:9:4:1:Tailoring::1:0:37687", -- Pattern: Lightweave Leggings
	[49956]="0:9:4:1:Tailoring::1:0:37687", -- Pattern: Sandals of Consecration
	[49957]="0:9:4:1:Leatherworking::1:0:37687", -- Pattern: Legwraps of Unleashed Nature
	[49958]="0:9:4:1:Leatherworking::1:0:37687", -- Pattern: Blessed Cenarion Boots
	[49959]="0:9:4:1:Leatherworking::1:0:37687", -- Pattern: Bladeborn Leggings
	[49960]="0:4:4:1:Plate::1:0:", -- Bracers of Dark Reckoning
	[49961]="0:9:4:1:Leatherworking::1:0:37687", -- Pattern: Footpads of Impending Death
	[49962]="0:9:4:1:Leatherworking::1:0:37687", -- Pattern: Lightning-Infused Leggings
	[49963]="0:9:4:1:Leatherworking::1:0:37687", -- Pattern: Earthsoul Boots
	[49964]="0:4:4:1:Plate::1:0:", -- Legguards of Lost Hope
	[49965]="0:9:4:1:Leatherworking::1:0:37687", -- Pattern: Draconic Bonesplinter Legguards
	[49966]="0:9:4:1:Leatherworking::1:0:37687", -- Pattern: Rock-Steady Treads
	[49967]="0:4:4:1:Ring::1:0:", -- Marrowgar's Frigid Eye
	[49968]="0:2:4:1:Dagger::1:0:", -- Frozen Bonespike
	[49969]="0:9:4:1:Blacksmithing::1:0:37687", -- Plans: Puresteel Legplates
	[49970]="0:9:4:1:Blacksmithing::1:0:37687", -- Plans: Protectors of Life
	[49971]="0:9:4:1:Blacksmithing::1:0:37687", -- Plans: Legplates of Painful Death
	[49972]="0:9:4:1:Blacksmithing::1:0:37687", -- Plans: Hellfrozen Bonegrinders
	[49973]="0:9:4:1:Blacksmithing::1:0:37687", -- Plans: Pillars of Might
	[49974]="0:9:4:1:Blacksmithing::1:0:37687", -- Plans: Boots of Kingly Upheaval
	[49975]="0:4:4:1:Amulet::1:0:", -- Bone Sentinel's Amulet
	[49976]="0:4:4:1:Shield::1:0:", -- Bulwark of Smouldering Steel
	[49977]="0:4:4:1:Ring::1:0:", -- Loop of the Endless Labyrinth
	[49978]="0:4:4:1:Cloth::1:0:", -- Crushing Coldwraith Belt
	[49979]="0:4:4:1:Leather::1:0:", -- Handguards of Winter's Respite
	[49980]="0:4:4:1:Plate::1:0:", -- Rusted Bonespike Pauldrons
	[49981]="192277:2:4:1:Crossbow::1:0:", -- Fal'inrush, Defender of Quel'thalas
	[49982]="0:2:4:1:Dagger::1:0:", -- Heartpierce
	[49983]="0:4:4:1:Plate::1:0:", -- Blood-Soaked Saronite Stompers
	[49985]="0:4:4:1:Ring::1:0:", -- Juggernaut Band
	[49986]="0:4:4:1:Plate::1:0:", -- Broken Ram Skull Helm
	[49987]="0:4:4:1:Leather::1:0:", -- Cultist's Bloodsoaked Spaulders
	[49988]="0:4:4:1:Mail::1:0:", -- Leggings of Northern Lights
	[49989]="0:4:4:1:Amulet::1:0:", -- Ahn'kahar Onyx Neckguard
	[49990]="0:4:4:1:Ring::1:0:", -- Ring of Maddening Whispers
	[49991]="0:4:4:1:Cloth::1:0:", -- Shoulders of Mercy Killing
	[49992]="0:2:4:1:Stave::1:0:", -- Nibelung
	[49993]="0:4:4:1:Mail::1:0:", -- Necrophotic Greaves
	[49994]="0:4:4:1:Cloth::1:0:", -- The Lady's Brittle Bracers
	[49995]="0:4:4:1:Plate::1:0:", -- Fallen Lord's Handguards
	[49996]="0:4:4:1:Leather::1:0:", -- Deathwhisper Chestpiece
	[49997]="252494:2:4:1:OneHandMace::1:0:", -- Mithrios, Bronzebeard's Legacy
	[49998]="0:4:4:1:Cloak::1:0:", -- Shadowvault Slayer's Cloak
	[49999]="0:4:4:1:Ring::1:0:", -- Skeleton Lord's Circle
	[50000]="0:4:4:1:Mail::1:0:", -- Scourge Hunter's Vambraces
	[50001]="0:4:4:1:Leather::1:0:", -- Ikfirus's Sack of Wonder
	[50002]="0:4:4:1:Plate::1:0:", -- Polar Bear Claw Bracers
	[50003]="0:4:4:1:Plate::1:0:", -- Boneguard Commander's Pauldrons
	[50005]="0:4:4:1:Amulet::1:0:", -- Amulet of the Silent Eulogy
	[50006]="0:4:4:1:Cloth::1:0:", -- Corp'rethar Ceremonial Crown
	[50008]="0:4:4:1:Ring::1:0:", -- Ring of Rapid Ascent
	[50009]="0:4:4:1:Leather::1:0:", -- Boots of Unnatural Growth
	[50010]="0:4:4:1:Plate::1:0:", -- Waistband of Righteous Fury
	[50011]="0:4:4:1:Cloth::1:0:", -- Gunship Captain's Mittens
	[50012]="273864:2:4:1:OneHandAxe::1:0:", -- Havoc's Call, Blade of Lordaeron Kings
	[50014]="0:4:4:1:Cloak::1:0:", -- Greatcloak of the Turned Champion
	[50015]="0:4:4:1:Mail::1:0:", -- Belt of the Blood Nova
	[50016]="0:2:4:1:Dagger::1:0:", -- Rib Spreader
	[50019]="0:4:4:1:Cloak::1:0:", -- Winding Sheet
	[50020]="0:4:4:1:Plate::1:0:", -- Raging Behemoth's Shoulderplates
	[50021]="0:4:4:1:Leather::1:0:", -- Aldriana's Gloves of Secrecy
	[50022]="0:4:4:1:Mail::1:0:", -- Dual-Bladed Pauldrons
	[50023]="0:4:4:1:Amulet::1:0:", -- Bile-Encrusted Medallion
	[50024]="0:4:4:1:Plate::1:0:", -- Blightborne Warplate
	[50025]="0:4:4:1:Ring::1:0:", -- Seal of Many Mouths
	[50026]="0:4:4:1:Leather::1:0:", -- Helm of the Elder Moon
	[50027]="0:4:4:1:Plate::1:0:", -- Rot-Resistant Breastplate
	[50028]="0:2:4:1:OneHandMace::1:0:", -- Trauma
	[50030]="0:4:4:1:Mail::1:0:", -- Bloodsunder's Bracers
	[50032]="0:4:4:1:Cloth::1:0:", -- Death Surgeon's Sleeves
	[50033]="0:2:4:1:Wand::1:0:", -- Corpse-Impaling Spike
	[50034]="0:2:4:1:Bow::1:0:", -- Zod's Repeating Longbow
	[50035]="0:2:4:1:FistWeapon::1:0:", -- Black Bruise
	[50036]="0:4:4:1:Plate::1:0:", -- Belt of Broken Bones
	[50037]="0:4:4:1:Plate::1:0:", -- Fleshrending Gauntlets
	[50038]="0:4:4:1:Mail::1:0:", -- Carapace of Forgotten Kings
	[50040]="0:2:4:1:Stave::1:0:", -- Distant Land
	[50041]="0:4:4:1:Leather::1:0:", -- Leather of Stitched Scourge Parts
	[50042]="0:4:4:1:Leather::1:0:", -- Gangrenous Leggings
	[50045]="0:16:1:20:Mage::1:0:", -- Glyph of Eternal Water
	[50046]="249052:2:4:1:OneHandSword::1:0:", -- Quel'Delar, Cunning of the Shadows
	[50047]="249953:2:4:1:OneHandSword::1:0:", -- Quel'Delar, Lens of the Mind
	[50048]="313536:2:4:1:TwoHandSword::1:0:", -- Quel'Delar, Might of the Faithful
	[50049]="314662:2:4:1:TwoHandSword::1:0:", -- Quel'Delar, Ferocity of the Scorned
	[50050]="0:2:4:1:OneHandMace::1:0:", -- Cudgel of Furious Justice
	[50051]="0:2:4:1:OneHandMace::1:0:", -- Hammer of Purified Flame
	[50052]="0:2:4:1:TwoHandMace::1:0:", -- Lightborn Spire
	[50055]="0:2:1:1:Dagger::1:0:", -- Worn Dirk
	[50056]="0:4:4:1:Cloth::1:0:", -- Plaguebringer's Stained Pants
	[50057]="0:2:1:1:Dagger::1:0:", -- Sharp Dirk
	[50059]="0:4:4:1:Mail::1:0:", -- Horrific Flesh Epaulets
	[50060]="0:4:4:1:Plate::1:0:", -- Faceplate of the Forgotten
	[50061]="0:4:4:1:Amulet::1:0:", -- Holiday's Grace
	[50062]="0:4:4:1:Cloth::1:0:", -- Plague Scientist's Boots
	[50063]="0:4:4:1:Cloth::1:0:", -- Lingering Illness
	[50064]="0:4:4:1:Mail::1:0:", -- Unclean Surgical Gloves
	[50065]="0:4:4:1:Shield::1:0:", -- Icecrown Glacial Wall
	[50067]="0:4:4:1:Leather::1:0:", -- Astrylian's Sutured Cinch
	[50068]="0:2:4:1:OneHandSword::1:0:", -- Rigormortis
	[50069]="0:4:4:1:Leather::1:0:", -- Professor's Bloodied Smock
	[50070]="315715:2:4:1:TwoHandSword::1:0:", -- Glorenzelg, High-Blade of the Silver Hand
	[50071]="0:4:4:1:Mail::1:0:", -- Treads of the Wasteland
	[50072]="0:4:4:1:Plate::1:0:", -- Landsoul's Horned Greathelm
	[50073]="0:4:4:1:Leather::1:0:", -- Geistlord's Punishment Sack
	[50074]="0:4:4:1:Cloak::1:0:", -- Royal Crimson Cloak
	[50075]="0:4:4:1:Plate::1:0:", -- Taldaram's Plated Fists
	[50077]="0:16:1:20:Warlock::1:0:", -- Glyph of Quick Decay
	[50078]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Battleplate
	[50079]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Gauntlets
	[50080]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Helmet
	[50081]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Legplates
	[50082]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Shoulderplates
	[50087]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Shadowblade Breastplate
	[50088]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Shadowblade Gauntlets
	[50089]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Shadowblade Helmet
	[50090]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Shadowblade Legplates
	[50094]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Battleplate
	[50095]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Gauntlets
	[50096]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Helmet
	[50097]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Legplates
	[50098]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Shoulderplates
	[50105]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Shadowblade Pauldrons
	[50106]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Robes
	[50107]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Gauntlets
	[50108]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Helmet
	[50109]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Legplates
	[50113]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Pauldrons
	[50114]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Ahn'Kahar Blood Hunter's Handguards
	[50115]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Ahn'Kahar Blood Hunter's Headpiece
	[50116]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Ahn'Kahar Blood Hunter's Legguards
	[50117]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Ahn'Kahar Blood Hunter's Spaulders
	[50118]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Ahn'Kahar Blood Hunter's Tunic
	[50125]="0:16:1:20:Druid::1:0:", -- Glyph of Rapid Rejuvenation
	[50130]="0:12:1:10:::1:0:", -- Snagglebolt's Khorium Bomb
	[50131]="0:12:1:1:::1:0:", -- Snagglebolt's Air Analyzer
	[50160]="0:15:1:1:Junk::1:0:37674", -- Lovely Dress Box
	[50161]="0:15:1:1:Junk::1:0:37674", -- Dinner Suit Box
	[50163]="0:0:1:20:Consumable::5:0:37674", -- Lovely Rose
	[50164]="0:0:1:100:Consumable::1:0:", -- Fras Siabi's Barely Bigger Beer
	[50166]="30000:9:1:1:::1:1:28723,30734,30735", -- Technique: Glyph of Eternal Water
	[50167]="80000:9:1:1:::1:1:28723", -- Technique: Glyph of Rapid Rejuvenation
	[50168]="80000:9:1:1:::1:1:28723", -- Technique: Glyph of Quick Decay
	[50169]="0:2:4:1:Thrown::1:0:", -- Papa's Brand New Knife
	[50170]="0:4:4:1:Ring::1:0:", -- Valanar's Other Signet Ring
	[50171]="0:4:4:1:Leather::1:0:", -- Shoulders of Frost-Tipped Thorns
	[50172]="0:4:4:1:Cloth::1:0:", -- Sanguine Silk Robes
	[50173]="0:4:4:1:OffHandFrill::1:0:", -- Shadow Silk Spindle
	[50174]="0:4:4:1:Ring::1:0:", -- Incarnadine Band of Mending
	[50175]="0:4:4:1:Plate::1:0:", -- Crypt Keeper's Bracers
	[50176]="0:4:4:1:Cloth::1:0:", -- San'layn Ritualist Gloves
	[50177]="0:4:4:1:Mail::1:0:", -- Mail of Crimson Coins
	[50178]="0:2:4:1:Polearm::1:0:", -- Bloodfall
	[50179]="0:2:4:1:OneHandMace::1:0:", -- Last Word
	[50180]="0:4:4:1:Amulet::1:0:", -- Lana'thel's Chain of Flagellation
	[50181]="0:2:4:1:Stave::1:0:", -- Dying Light
	[50182]="0:4:4:1:Amulet::1:0:", -- Blood Queen's Crimson Choker
	[50183]="0:2:4:1:Dagger::1:0:", -- Lungbreaker
	[50184]="0:2:4:1:FistWeapon::1:0:", -- Keleseth's Seducer
	[50185]="0:4:4:1:Ring::1:0:", -- Devium's Eternally Cold Ring
	[50186]="0:4:4:1:Ring::1:0:", -- Frostbrood Sapphire Ring
	[50187]="0:4:4:1:Plate::1:0:", -- Coldwraith Links
	[50188]="0:4:4:1:Mail::1:0:", -- Anub'ar Stalker's Gloves
	[50190]="0:4:4:1:Plate::1:0:", -- Grinning Skull Greatboots
	[50191]="0:2:4:1:OneHandAxe::1:0:", -- Nighttime
	[50192]="0:4:4:1:Plate::1:0:", -- Scourge Reaver's Legplates
	[50193]="0:4:4:1:Cloth::1:0:", -- Very Fashionable Shoulders
	[50194]="0:4:4:1:Plate::1:0:", -- Weeping Gauntlets
	[50195]="0:4:4:1:Amulet::1:0:", -- Noose of Malachite
	[50196]="0:4:4:1:Amulet::1:0:", -- Love's Prisoner
	[50197]="0:4:4:1:Mail::1:0:", -- Eyes of Bewilderment
	[50198]="0:4:4:1:Trinket::1:0:", -- Needle-Encrusted Scorpion
	[50199]="0:4:4:1:Plate::1:0:", -- Leggings of Dying Candles
	[50202]="0:4:4:1:Mail::1:0:", -- Snowstorm Helm
	[50203]="0:2:4:1:Dagger::1:0:", -- Blood Weeper
	[50205]="0:4:4:1:Cloak::1:0:", -- Frostbinder's Shredded Cape
	[50206]="0:4:4:1:Leather::1:0:", -- Frayed Scoundrel's Cap
	[50207]="0:4:4:1:Plate::1:0:", -- Black Spire Sabatons
	[50208]="0:4:4:1:Plate::1:0:", -- Pauldrons of the Souleater
	[50209]="0:4:4:1:Mail::1:0:", -- Essence of Suffering
	[50210]="0:2:4:1:OneHandSword::1:0:", -- Seethe
	[50211]="0:4:4:1:Amulet::1:0:", -- Arcane Loops of Anger
	[50212]="0:4:4:1:Leather::1:0:", -- Essence of Desire
	[50213]="0:4:4:1:Cloth::1:0:", -- Mord'rethar Robes
	[50214]="0:4:4:1:Mail::1:0:", -- Helm of the Spirit Shock
	[50215]="0:4:4:1:Plate::1:0:", -- Recovered Reliquary Boots
	[50226]="0:15:4:10:Junk::1:0:", -- Festergut's Acidic Blood
	[50227]="0:2:4:1:Dagger::1:0:", -- Surgeon's Needle
	[50228]="0:4:4:1:Amulet::1:0:", -- Barbed Ymirheim Choker
	[50229]="0:4:4:1:Plate::1:0:", -- Legguards of the Frosty Depths
	[50230]="0:4:4:1:Plate::1:0:", -- Malykriss Vambraces
	[50231]="0:15:4:10:Junk::1:0:", -- Rotface's Acidic Blood
	[50233]="0:4:4:1:Mail::1:0:", -- Spurned Val'kyr Shoulderguards
	[50234]="0:4:4:1:Plate::1:0:", -- Shoulderplates of Frozen Blood
	[50235]="0:4:4:1:Trinket::1:0:", -- Ick's Rotting Thumb
	[50240]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Dark Coven Gloves
	[50241]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Dark Coven Hood
	[50242]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Dark Coven Leggings
	[50243]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Dark Coven Robe
	[50244]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Dark Coven Shoulderpads
	[50250]="0:15:4:1:Mount::1:0:", -- Big Love Rocket
	[50254]="0:12:1:1:::1:0:", -- Subdued Quel'Delar
	[50255]="0:4:7:1:Ring::1:0:", -- Dread Pirate Ring
	[50259]="0:4:4:1:Trinket::1:0:", -- Nevermelting Ice Crystal
	[50260]="0:4:4:1:Trinket::1:0:", -- Ephemeral Snowflake
	[50262]="0:2:4:1:Crossbow::1:0:", -- Felglacier Bolter
	[50263]="0:4:4:1:Cloth::1:0:", -- Braid of Salt and Fire
	[50264]="0:4:4:1:Leather::1:0:", -- Chewed Leather Wristguards
	[50265]="0:4:4:1:Mail::1:0:", -- Blackened Ghoul Skin Leggings
	[50266]="0:4:4:1:Cloth::1:0:", -- Ancient Polar Bear Hide
	[50267]="0:2:4:1:TwoHandAxe::1:0:", -- Tyrannical Beheader
	[50268]="0:2:4:1:OneHandSword::1:0:", -- Rimefang's Claw
	[50269]="0:4:4:1:Leather::1:0:", -- Fleshwerk Leggings
	[50270]="0:4:4:1:Mail::1:0:", -- Belt of Rotted Fingernails
	[50271]="0:4:4:1:Ring::1:0:", -- Band of Stained Souls
	[50272]="0:4:4:1:Plate::1:0:", -- Frost Wyrm Ribcage
	[50273]="0:2:4:1:Stave::1:0:", -- Engraved Gargoyle Femur
	[50274]="0:15:5:60:Junk::1:0:", -- Shadowfrost Shard
	[50275]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Bloodmage Gloves
	[50276]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Bloodmage Hood
	[50277]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Bloodmage Leggings
	[50278]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Bloodmage Robe
	[50279]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Bloodmage Shoulderpads
	[50283]="0:4:4:1:Mail::1:0:", -- Mudslide Boots
	[50284]="0:4:4:1:Plate::1:0:", -- Rusty Frozen Fingerguards
	[50285]="0:4:4:1:Plate::1:0:", -- Icebound Bronze Cuirass
	[50286]="0:4:4:1:Cloth::1:0:", -- Prelate's Snowshoes
	[50287]="0:4:3:1:Miscellaneous::1:0:", -- Boots of the Bay
	[50289]="0:12:1:1:::1:0:", -- Blacktip Shark
	[50290]="0:2:4:1:OneHandAxe::1:0:", -- Falric's Wrist-Chopper
	[50291]="0:2:4:1:Wand::1:0:", -- Soulsplinter
	[50292]="0:4:4:1:Cloth::1:0:", -- Bracer of Worn Molars
	[50293]="0:4:4:1:Leather::1:0:", -- Spaulders of Black Betrayal
	[50294]="0:4:4:1:Plate::1:0:", -- Chestpiece of High Treason
	[50295]="0:4:4:1:Mail::1:0:", -- Spiked Toestompers
	[50296]="0:2:4:1:Polearm::1:0:", -- Orca-Hunter's Harpoon
	[50297]="0:4:4:1:Mail::1:0:", -- Frostsworn Bone Chestpiece
	[50298]="0:4:4:1:Cloth::1:0:", -- Sightless Crown of Ulmaas
	[50299]="0:4:4:1:Cloth::1:0:", -- Suspiciously Soft Gloves
	[50300]="0:4:4:1:Leather::1:0:", -- Choking Hauberk
	[50301]="0:15:1:1:Junk::1:0:", -- Landro's Pet Box
	[50302]="0:2:4:1:OneHandSword::1:0:", -- Liar's Tongue
	[50303]="0:2:4:1:OneHandMace::1:0:", -- Black Icicle
	[50304]="0:4:4:1:Mail::1:0:", -- Hoarfrost Gauntlets
	[50305]="0:4:4:1:Plate::1:0:", -- Grinning Skull Boots
	[50306]="0:4:4:1:Ring::1:0:", -- The Lady's Promise
	[50307]="0:0:1:5:Consumable::1:0:", -- Infernal Spear
	[50308]="0:4:4:1:Leather::1:0:", -- Blighted Leather Footpads
	[50309]="0:4:4:1:OffHandFrill::1:0:", -- Shriveled Heart
	[50310]="0:4:4:1:Amulet::1:0:", -- Fossilized Ammonite Choker
	[50311]="0:4:4:1:Plate::1:0:", -- Second Helm of the Executioner
	[50312]="0:4:4:1:Leather::1:0:", -- Chestguard of Broken Branches
	[50313]="0:4:4:1:Ring::1:0:", -- Oath of Empress Zoe
	[50314]="0:4:4:1:Cloth::1:0:", -- Strip of Remorse
	[50315]="0:2:4:1:FistWeapon::1:0:", -- Seven-Fingered Claws
	[50316]="0:1:4:1:Bag::1:0:", -- Papa's Brand New Bag
	[50317]="0:1:4:1:Bag::1:0:", -- Papa's New Bag
	[50318]="0:4:4:1:Leather::1:0:", -- Ghostly Wristwraps
	[50319]="0:2:4:1:Dagger::1:0:", -- Unsharpened Ice Razor
	[50320]="0:12:1:1:::1:0:", -- Faded Lovely Greeting Card
	[50324]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Shoulderplates
	[50325]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Legplates
	[50326]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Helmet
	[50327]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Gauntlets
	[50328]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Battleplate
	[50333]="0:4:4:1:Leather::1:0:", -- Toskk's Maximized Wristguards
	[50335]="1000000:0:7:1:EnhPerm::1:0:32540", -- Greater Inscription of the Axe
	[50336]="1000000:0:7:1:EnhPerm::1:0:32540", -- Greater Inscription of the Crag
	[50337]="1000000:0:7:1:EnhPerm::1:0:32540", -- Greater Inscription of the Pinnacle
	[50338]="1000000:0:7:1:EnhPerm::1:0:32540", -- Greater Inscription of the Storm 
	[50339]="0:4:4:1:Trinket::1:0:", -- Sliver of Pure Ice
	[50340]="0:4:4:1:Trinket::1:0:", -- Muradin's Spyglass
	[50341]="0:4:4:1:Trinket::1:0:", -- Unidentifiable Organ
	[50342]="0:4:4:1:Trinket::1:0:", -- Whispering Fanged Skull
	[50343]="0:4:4:1:Trinket::1:0:", -- Whispering Fanged Skull
	[50344]="0:4:4:1:Trinket::1:0:", -- Unidentifiable Organ
	[50345]="0:4:4:1:Trinket::1:0:", -- Muradin's Spyglass
	[50346]="0:4:4:1:Trinket::1:0:", -- Sliver of Pure Ice
	[50348]="0:4:4:1:Trinket::1:0:", -- Dislodged Foreign Object
	[50349]="0:4:4:1:Trinket::1:0:", -- Corpse Tongue Coin
	[50351]="0:4:4:1:Trinket::1:0:", -- Tiny Abomination in a Jar
	[50352]="0:4:4:1:Trinket::1:0:", -- Corpse Tongue Coin
	[50353]="0:4:4:1:Trinket::1:0:", -- Dislodged Foreign Object
	[50354]="0:4:4:1:Trinket::1:0:", -- Bauble of True Blood
	[50355]="0:4:4:1:Trinket::1:0:29528,37941,37942,38858", -- Herkuml War Token
	[50356]="0:4:4:1:Trinket::1:0:29528,37941,37942,38858", -- Corroded Skeleton Key
	[50357]="0:4:4:1:Trinket::1:0:29528,37941,37942,38858", -- Maghia's Misguided Quill
	[50358]="0:4:4:1:Trinket::1:0:29528,37941,37942,38858", -- Purified Lunar Dust
	[50359]="0:4:4:1:Trinket::1:0:", -- Althor's Abacus
	[50360]="0:4:4:1:Trinket::1:0:", -- Phylactery of the Nameless Lich
	[50361]="0:4:4:1:Trinket::1:0:", -- Sindragosa's Flawless Fang
	[50362]="0:4:4:1:Trinket::1:0:", -- Deathbringer's Will
	[50363]="0:4:4:1:Trinket::1:0:", -- Deathbringer's Will
	[50364]="0:4:4:1:Trinket::1:0:", -- Sindragosa's Flawless Fang
	[50365]="0:4:4:1:Trinket::1:0:", -- Phylactery of the Nameless Lich
	[50366]="0:4:4:1:Trinket::1:0:", -- Althor's Abacus
	[50367]="1500000:0:7:1:EnhPerm::1:0:32538", -- Arcanum of Torment
	[50368]="1500000:0:7:1:EnhPerm::1:0:32287", -- Arcanum of Burning Mysteries
	[50369]="1500000:0:7:1:EnhPerm::1:0:30431", -- Arcanum of the Stalwart Protector
	[50370]="1500000:0:7:1:EnhPerm::1:0:32533", -- Arcanum of Blissful Mending
	[50372]="1500000:0:7:1:EnhPerm::1:0:32564,32773", -- Arcanum of the Savage Gladiator
	[50373]="1500000:0:7:1:EnhPerm::1:0:32565,32774", -- Arcanum of the Savage Gladiator
	[50375]="0:4:4:1:Ring::1:0:", -- Ashen Band of Courage
	[50376]="0:4:4:1:Ring::1:0:", -- Ashen Band of Vengeance
	[50377]="0:4:4:1:Ring::1:0:", -- Ashen Band of Destruction
	[50378]="0:4:4:1:Ring::1:0:", -- Ashen Band of Wisdom
	[50379]="0:12:4:1:::1:0:", -- Battered Hilt
	[50380]="0:12:4:1:::1:0:", -- Battered Hilt
	[50384]="0:4:4:1:Ring::1:0:", -- Ashen Band of Greater Destruction
	[50386]="0:4:4:1:Ring::1:0:", -- Ashen Band of Greater Wisdom
	[50387]="0:4:4:1:Ring::1:0:", -- Ashen Band of Greater Vengeance
	[50388]="0:4:4:1:Ring::1:0:", -- Ashen Band of Greater Courage
	[50391]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Handwraps
	[50392]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Cowl
	[50393]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Pants
	[50394]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Raiments
	[50396]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Mantle
	[50397]="0:4:4:1:Ring::1:0:", -- Ashen Band of Unmatched Destruction
	[50398]="0:4:4:1:Ring::1:0:", -- Ashen Band of Endless Destruction
	[50399]="0:4:4:1:Ring::1:0:", -- Ashen Band of Unmatched Wisdom
	[50400]="0:4:4:1:Ring::1:0:", -- Ashen Band of Endless Wisdom
	[50401]="0:4:4:1:Ring::1:0:", -- Ashen Band of Unmatched Vengeance
	[50402]="0:4:4:1:Ring::1:0:", -- Ashen Band of Endless Vengeance
	[50403]="0:4:4:1:Ring::1:0:", -- Ashen Band of Unmatched Courage
	[50404]="0:4:4:1:Ring::1:0:", -- Ashen Band of Endless Courage
	[50406]="0:9:2:1:Enchanting::1:0:", -- Formula: Enchant Gloves - Angler
	[50411]="0:2:4:1:OneHandAxe::1:0:", -- Scourgeborne Waraxe
	[50412]="0:2:4:1:OneHandSword::1:0:", -- Bloodvenom Blade
	[50413]="0:4:4:1:Mail::1:0:", -- Nerub'ar Stalker's Cord
	[50414]="0:4:4:1:Ring::1:0:", -- Might of Blight
	[50415]="314917:2:4:1:TwoHandAxe::1:0:", -- Bryntroll, the Bone Arbiter
	[50416]="0:4:4:1:Plate::1:0:", -- Boots of the Funeral March
	[50417]="0:4:4:1:Leather::1:0:", -- Bracers of Eternal Dreaming
	[50418]="0:4:4:1:Cloth::1:0:", -- Robe of the Waking Nightmare
	[50421]="0:4:4:1:Amulet::1:0:", -- Sindragosa's Cruel Claw
	[50423]="0:4:4:1:OffHandFrill::1:0:", -- Sundial of Eternal Dusk
	[50424]="0:4:4:1:Ring::1:0:", -- Memory of Malygos
	[50425]="343607:2:4:1:Polearm::1:0:", -- Oathbinder, Charge of the Ranger-General
	[50426]="249639:2:4:1:Dagger::1:0:", -- Heaven's Fall, Kryss of a Thousand Lies
	[50427]="250608:2:4:1:OneHandSword::1:0:", -- Bloodsurge, Kel'Thuzad's Blade of Agony
	[50428]="0:2:4:1:OneHandMace::1:0:", -- Royal Scepter of Terenas II
	[50429]="315650:2:4:1:Stave::1:0:", -- Archus, Greatstaff of Antonidas
	[50432]="0:12:1:20:::1:0:", -- Diseased Wolf Pelt
	[50444]="0:2:4:1:Gun::1:0:", -- Rowan's Rifle of Silver Bullets
	[50446]="0:15:3:1:Companion::1:0:", -- Toxic Wasteling
	[50447]="0:4:4:1:Ring::1:0:", -- Harbinger's Bone Band
	[50449]="0:4:4:1:Cloth::1:0:", -- Stiffened Corpse Shoulderpads
	[50450]="0:4:4:1:Mail::1:0:", -- Leggings of Dubious Charms
	[50451]="0:4:4:1:Plate::1:0:", -- Belt of the Lonely Noble
	[50452]="0:4:4:1:Amulet::1:0:", -- Wodin's Lucky Necklace
	[50453]="0:4:4:1:Ring::1:0:", -- Ring of Rotting Sinew
	[50454]="0:4:4:1:Idol::1:0:29529,37941,37942,38858", -- Idol of the Black Willow
	[50455]="0:4:4:1:Libram::1:0:29529,37941,37942,38858", -- Libram of Three Truths
	[50456]="0:4:4:1:Idol::1:0:29529,37941,37942,38858", -- Idol of the Crying Moon
	[50457]="0:4:4:1:Idol::1:0:29529,37941,37942,38858", -- Idol of the Lunar Eclipse
	[50458]="0:4:4:1:Totem::1:0:29529,37941,37942,38858", -- Bizuri's Totem of Shattered Ice
	[50459]="0:4:4:1:Sigil::1:0:29529,37941,37942,38858", -- Sigil of the Hanged Man
	[50460]="0:4:4:1:Libram::1:0:29529,37941,37942,38858", -- Libram of Blinding Light
	[50461]="0:4:4:1:Libram::1:0:29529,37941,37942,38858", -- Libram of the Eternal Tower
	[50462]="0:4:4:1:Sigil::1:0:29529,37941,37942,38858", -- Sigil of the Bone Gryphon
	[50463]="0:4:4:1:Totem::1:0:29529,37941,37942,38858", -- Totem of the Avalanche
	[50464]="0:4:4:1:Totem::1:0:29529,37941,37942,38858", -- Totem of the Surging Sea
	[50466]="0:4:4:1:Cloak::1:0:29495,37941,37942,38858", -- Sentinel's Winter Cloak
	[50467]="0:4:4:1:Cloak::1:0:29495,37941,37942,38858", -- Might of the Ocean Serpent
	[50468]="0:4:4:1:Cloak::1:0:29495,37941,37942,38858", -- Drape of the Violet Tower
	[50469]="0:4:4:1:Cloak::1:0:29495,37941,37942,38858", -- Volde's Cloak of the Night Sky
	[50470]="0:4:4:1:Cloak::1:0:29495,37941,37942,38858", -- Recovered Scarlet Onslaught Cape
	[50471]="0:0:3:1:Consumable::1:0:", -- The Heartbreaker
	[50472]="0:2:4:1:Wand::1:0:", -- Nightmare Ender
	[50474]="0:2:4:1:Thrown::1:0:29493,37941,37942,38858", -- Shrapnel Star
	[50603]="0:2:4:1:TwoHandMace::1:0:", -- Cryptmaker
	[50604]="0:4:4:1:Ring::1:0:", -- Band of the Bone Colossus
	[50605]="0:4:4:1:Mail::1:0:", -- Snowserpent Mail Helm
	[50606]="0:4:4:1:Plate::1:0:", -- Gendarme's Cuirass
	[50607]="0:4:4:1:Leather::1:0:", -- Frostbitten Fur Boots
	[50608]="0:2:4:1:Dagger::1:0:", -- Frozen Bonespike
	[50609]="0:4:4:1:Amulet::1:0:", -- Bone Sentinel's Amulet
	[50610]="0:4:4:1:Ring::1:0:", -- Marrowgar's Frigid Eye
	[50611]="0:4:4:1:Plate::1:0:", -- Bracers of Dark Reckoning
	[50612]="0:4:4:1:Plate::1:0:", -- Legguards of Lost Hope
	[50613]="0:4:4:1:Cloth::1:0:", -- Crushing Coldwraith Belt
	[50614]="0:4:4:1:Ring::1:0:", -- Loop of the Endless Labyrinth
	[50615]="0:4:4:1:Leather::1:0:", -- Handguards of Winter's Respite
	[50616]="0:4:4:1:Shield::1:0:", -- Bulwark of Smouldering Steel
	[50617]="0:4:4:1:Plate::1:0:", -- Rusted Bonespike Pauldrons
	[50618]="0:4:4:1:Ring::1:0:", -- Frostbrood Sapphire Ring
	[50619]="0:4:4:1:Mail::1:0:", -- Anub'ar Stalker's Gloves
	[50620]="0:4:4:1:Plate::1:0:", -- Coldwraith Links
	[50621]="0:2:4:1:Dagger::1:0:", -- Lungbreaker
	[50622]="0:4:4:1:Ring::1:0:", -- Devium's Eternally Cold Ring
	[50623]="0:4:4:1:Plate::1:0:", -- Leggings of Dying Candles
	[50624]="0:4:4:1:Plate::1:0:", -- Scourge Reaver's Legplates
	[50625]="0:4:4:1:Plate::1:0:", -- Grinning Skull Greatboots
	[50626]="0:4:4:1:Mail::1:0:", -- Snowstorm Helm
	[50627]="0:4:4:1:Amulet::1:0:", -- Noose of Malachite
	[50628]="0:4:4:1:Cloak::1:0:", -- Frostbinder's Shredded Cape
	[50629]="0:4:4:1:Cloth::1:0:", -- Robe of the Waking Nightmare
	[50630]="0:4:4:1:Leather::1:0:", -- Bracers of Eternal Dreaming
	[50631]="0:2:4:1:Wand::1:0:", -- Nightmare Ender
	[50632]="0:4:4:1:Plate::1:0:", -- Boots of the Funeral March
	[50633]="0:4:4:1:Amulet::1:0:", -- Sindragosa's Cruel Claw
	[50635]="0:4:4:1:OffHandFrill::1:0:", -- Sundial of Eternal Dusk
	[50636]="0:4:4:1:Ring::1:0:", -- Memory of Malygos
	[50638]="0:2:4:1:Bow::1:0:", -- Zod's Repeating Longbow
	[50639]="0:4:4:1:Plate::1:0:", -- Blood-Soaked Saronite Stompers
	[50640]="0:4:4:1:Plate::1:0:", -- Broken Ram Skull Helm
	[50641]="0:2:4:1:Dagger::1:0:", -- Heartpierce
	[50642]="0:4:4:1:Ring::1:0:", -- Juggernaut Band
	[50643]="0:4:4:1:Cloth::1:0:", -- Shoulders of Mercy Killing
	[50644]="0:4:4:1:Ring::1:0:", -- Ring of Maddening Whispers
	[50645]="0:4:4:1:Mail::1:0:", -- Leggings of Northern Lights
	[50646]="0:4:4:1:Leather::1:0:", -- Cultist's Bloodsoaked Spaulders
	[50647]="0:4:4:1:Amulet::1:0:", -- Ahn'kahar Onyx Neckguard
	[50648]="0:2:4:1:Stave::1:0:", -- Nibelung
	[50649]="0:4:4:1:Leather::1:0:", -- Deathwhisper Chestpiece
	[50650]="0:4:4:1:Plate::1:0:", -- Fallen Lord's Handguards
	[50651]="0:4:4:1:Cloth::1:0:", -- The Lady's Brittle Bracers
	[50652]="0:4:4:1:Mail::1:0:", -- Necrophotic Greaves
	[50653]="0:4:4:1:Cloak::1:0:", -- Shadowvault Slayer's Cloak
	[50654]="0:2:4:1:OneHandAxe::1:0:", -- Scourgeborne Waraxe
	[50655]="0:4:4:1:Mail::1:0:", -- Scourge Hunter's Vambraces
	[50656]="0:4:4:1:Leather::1:0:", -- Ikfirus's Sack of Wonder
	[50657]="0:4:4:1:Ring::1:0:", -- Skeleton Lord's Circle
	[50658]="0:4:4:1:Amulet::1:0:", -- Amulet of the Silent Eulogy
	[50659]="0:4:4:1:Plate::1:0:", -- Polar Bear Claw Bracers
	[50660]="0:4:4:1:Plate::1:0:", -- Boneguard Commander's Pauldrons
	[50661]="0:4:4:1:Cloth::1:0:", -- Corp'rethar Ceremonial Crown
	[50663]="0:4:4:1:Cloth::1:0:", -- Gunship Captain's Mittens
	[50664]="0:4:4:1:Ring::1:0:", -- Ring of Rapid Ascent
	[50665]="0:4:4:1:Leather::1:0:", -- Boots of Unnatural Growth
	[50667]="0:4:4:1:Plate::1:0:", -- Waistband of Righteous Fury
	[50668]="0:4:4:1:Cloak::1:0:", -- Greatcloak of the Turned Champion
	[50670]="0:4:4:1:Leather::1:0:", -- Toskk's Maximized Wristguards
	[50671]="0:4:4:1:Mail::1:0:", -- Belt of the Blood Nova
	[50672]="0:2:4:1:OneHandSword::1:0:", -- Bloodvenom Blade
	[50673]="0:4:4:1:Mail::1:0:", -- Dual-Bladed Pauldrons
	[50674]="0:4:4:1:Plate::1:0:", -- Raging Behemoth's Shoulderplates
	[50675]="0:4:4:1:Leather::1:0:", -- Aldriana's Gloves of Secrecy
	[50676]="0:2:4:1:Dagger::1:0:", -- Rib Spreader
	[50677]="0:4:4:1:Cloak::1:0:", -- Winding Sheet
	[50678]="0:4:4:1:Ring::1:0:", -- Seal of Many Mouths
	[50679]="0:4:4:1:Leather::1:0:", -- Helm of the Elder Moon
	[50680]="0:4:4:1:Plate::1:0:", -- Rot-Resistant Breastplate
	[50681]="0:4:4:1:Plate::1:0:", -- Blightborne Warplate
	[50682]="0:4:4:1:Amulet::1:0:", -- Bile-Encrusted Medallion
	[50684]="0:2:4:1:Wand::1:0:", -- Corpse-Impaling Spike
	[50685]="0:2:4:1:OneHandMace::1:0:", -- Trauma
	[50686]="0:4:4:1:Cloth::1:0:", -- Death Surgeon's Sleeves
	[50687]="0:4:4:1:Mail::1:0:", -- Bloodsunder's Bracers
	[50688]="0:4:4:1:Mail::1:0:", -- Nerub'ar Stalker's Cord
	[50689]="0:4:4:1:Mail::1:0:", -- Carapace of Forgotten Kings
	[50690]="0:4:4:1:Plate::1:0:", -- Fleshrending Gauntlets
	[50691]="0:4:4:1:Plate::1:0:", -- Belt of Broken Bones
	[50692]="0:2:4:1:FistWeapon::1:0:", -- Black Bruise
	[50693]="0:4:4:1:Ring::1:0:", -- Might of Blight
	[50694]="0:4:4:1:Cloth::1:0:", -- Plaguebringer's Stained Pants
	[50695]="0:2:4:1:Stave::1:0:", -- Distant Land
	[50696]="0:4:4:1:Leather::1:0:", -- Leather of Stitched Scourge Parts
	[50697]="0:4:4:1:Leather::1:0:", -- Gangrenous Leggings
	[50698]="0:4:4:1:Mail::1:0:", -- Horrific Flesh Epaulets
	[50699]="0:4:4:1:Cloth::1:0:", -- Plague Scientist's Boots
	[50700]="0:4:4:1:Amulet::1:0:", -- Holiday's Grace
	[50701]="0:4:4:1:Plate::1:0:", -- Faceplate of the Forgotten
	[50702]="0:4:4:1:Cloth::1:0:", -- Lingering Illness
	[50703]="0:4:4:1:Mail::1:0:", -- Unclean Surgical Gloves
	[50704]="0:2:4:1:OneHandSword::1:0:", -- Rigormortis
	[50705]="0:4:4:1:Leather::1:0:", -- Professor's Bloodied Smock
	[50706]="0:4:4:1:Trinket::1:0:", -- Tiny Abomination in a Jar
	[50707]="0:4:4:1:Leather::1:0:", -- Astrylian's Sutured Cinch
	[50708]="0:2:4:1:OneHandMace::1:0:", -- Last Word
	[50709]="348329:2:4:1:TwoHandAxe::1:0:", -- Bryntroll, the Bone Arbiter
	[50710]="0:2:4:1:FistWeapon::1:0:", -- Keleseth's Seducer
	[50711]="0:4:4:1:Mail::1:0:", -- Treads of the Wasteland
	[50712]="0:4:4:1:Plate::1:0:", -- Landsoul's Horned Greathelm
	[50713]="0:4:4:1:Leather::1:0:", -- Geistlord's Punishment Sack
	[50714]="0:4:4:1:Ring::1:0:", -- Valanar's Other Signet Ring
	[50715]="0:4:4:1:Leather::1:0:", -- Shoulders of Frost-Tipped Thorns
	[50716]="0:4:4:1:Plate::1:0:", -- Taldaram's Plated Fists
	[50717]="0:4:4:1:Cloth::1:0:", -- Sanguine Silk Robes
	[50718]="0:4:4:1:Cloak::1:0:", -- Royal Crimson Cloak
	[50719]="0:4:4:1:OffHandFrill::1:0:", -- Shadow Silk Spindle
	[50720]="0:4:4:1:Ring::1:0:", -- Incarnadine Band of Mending
	[50721]="0:4:4:1:Plate::1:0:", -- Crypt Keeper's Bracers
	[50722]="0:4:4:1:Cloth::1:0:", -- San'layn Ritualist Gloves
	[50723]="0:4:4:1:Mail::1:0:", -- Mail of Crimson Coins
	[50724]="0:4:4:1:Amulet::1:0:", -- Blood Queen's Crimson Choker
	[50725]="0:2:4:1:Stave::1:0:", -- Dying Light
	[50726]="0:4:4:1:Trinket::1:0:", -- Bauble of True Blood
	[50727]="0:2:4:1:Polearm::1:0:", -- Bloodfall
	[50728]="0:4:4:1:Amulet::1:0:", -- Lana'thel's Chain of Flagellation
	[50729]="0:4:4:1:Shield::1:0:", -- Icecrown Glacial Wall
	[50730]="0:2:4:1:TwoHandSword::1:0:", -- Glorenzelg, High-Blade of the Silver Hand
	[50731]="0:2:4:1:Stave::1:0:", -- Archus, Greatstaff of Antonidas
	[50732]="0:2:4:1:OneHandSword::1:0:", -- Bloodsurge, Kel'Thuzad's Blade of Agony
	[50733]="0:2:4:1:Crossbow::1:0:", -- Fal'inrush, Defender of Quel'thalas
	[50734]="0:2:4:1:OneHandMace::1:0:", -- Royal Scepter of Terenas II
	[50735]="0:2:4:1:Polearm::1:0:", -- Oathbinder, Charge of the Ranger-General
	[50736]="0:2:4:1:Dagger::1:0:", -- Heaven's Fall, Kryss of a Thousand Lies
	[50737]="0:2:4:1:OneHandAxe::1:0:", -- Havoc's Call, Blade of Lordaeron Kings
	[50738]="0:2:4:1:OneHandMace::1:0:", -- Mithrios, Bronzebeard's Legacy
	[50741]="0:4:3:1:Cloth::1:0:", -- Vile Fumigator's Mask
	[50759]="0:2:4:1:OneHandAxe::1:0:", -- Bone Warden's Splitter
	[50760]="0:2:4:1:OneHandMace::1:0:", -- Bonebreaker Scepter
	[50761]="0:2:4:1:TwoHandSword::1:0:", -- Citadel Enforcer's Claymore
	[50762]="0:4:4:1:Mail::1:0:", -- Linked Scourge Vertebrae
	[50763]="0:4:4:1:Amulet::1:0:", -- Marrowgar's Scratching Choker
	[50764]="0:4:4:1:Cloak::1:0:", -- Shawl of Nerubian Silk
	[50765]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Hood
	[50766]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Gloves
	[50767]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Shoulderpads
	[50768]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Robe
	[50769]="0:4:4:1:Cloth::1:0:35496,38054", -- Crimson Acolyte Leggings
	[50771]="0:2:4:1:OneHandSword::1:0:", -- Frost Needle
	[50772]="0:4:4:1:Plate::1:0:", -- Ancient Skeletal Boots
	[50773]="0:4:4:1:Cloth::1:0:", -- Cord of the Patronizing Practitioner
	[50774]="0:4:4:1:Mail::1:0:", -- Coldwraith Bracers
	[50775]="0:4:4:1:Plate::1:0:", -- Corrupted Silverplate Leggings
	[50776]="0:2:4:1:Bow::1:0:", -- Njordnar Bone Bow
	[50777]="0:4:4:1:Mail::1:0:", -- Handgrips of Frost and Sleet
	[50778]="0:4:4:1:Leather::1:0:", -- Soulthief's Braided Belt
	[50779]="0:4:4:1:Plate::1:0:", -- Deathspeaker Zealot's Helm
	[50780]="0:4:4:1:Leather::1:0:", -- Chestguard of the Frigid Noose
	[50781]="0:4:4:1:OffHandFrill::1:0:", -- Scourgelord's Baton
	[50782]="0:4:4:1:Cloth::1:0:", -- Sister's Handshrouds
	[50783]="0:4:4:1:Leather::1:0:", -- Boots of the Frozen Seed
	[50784]="0:4:4:1:Mail::1:0:", -- Deathspeaker Disciple's Belt
	[50785]="0:4:4:1:Cloth::1:0:", -- Bracers of Dark Blessings
	[50786]="0:4:4:1:Plate::1:0:", -- Ghoul Commander's Cuirass
	[50787]="0:2:4:1:OneHandAxe::1:0:", -- Frost Giant's Cleaver
	[50788]="0:4:4:1:Plate::1:0:", -- Bone Drake's Enameled Boots
	[50789]="0:4:4:1:Mail::1:0:", -- Icecrown Rampart Bracers
	[50790]="0:4:4:1:Ring::1:0:", -- Abomination's Bloody Ring
	[50791]="0:4:4:1:Cloak::1:0:", -- Saronite Gargoyle Cloak
	[50792]="0:4:4:1:Mail::1:0:", -- Pauldrons of Lost Hope
	[50793]="0:2:4:1:Dagger::1:0:", -- Midnight Sun
	[50794]="0:4:4:1:Shield::1:0:", -- Neverending Winter
	[50795]="0:4:4:1:Leather::1:0:", -- Cord of Dark Suffering
	[50796]="0:4:4:1:Plate::1:0:", -- Bracers of Pale Illumination
	[50797]="0:4:4:1:Mail::1:0:", -- Ice-Reinforced Vrykul Helm
	[50798]="0:2:4:1:TwoHandAxe::1:0:", -- Ramaladni's Blade of Culling
	[50799]="0:4:4:1:Leather::1:0:", -- Scourge Stranglers
	[50800]="0:4:4:1:Mail::1:0:", -- Hauberk of a Thousand Cuts
	[50801]="0:4:4:1:Plate::1:0:", -- Blade-Scored Carapace
	[50802]="0:4:4:1:Plate::1:0:", -- Gargoyle Spit Bracers
	[50803]="0:4:4:1:Ring::1:0:", -- Saurfang's Cold-Forged Band
	[50804]="0:4:4:1:Cloth::1:0:", -- Icecrown Spire Sandals
	[50805]="0:2:4:1:Stave::1:0:", -- Mag'hari Chieftain's Staff
	[50806]="0:4:4:1:Leather::1:0:", -- Leggings of Unrelenting Blood
	[50807]="0:4:4:1:Cloth::1:0:", -- Thaumaturge's Crackling Cowl
	[50808]="0:4:4:1:Plate::1:0:", -- Deathforged Legplates
	[50809]="0:4:4:1:Amulet::1:0:", -- Soulcleave Pendant
	[50810]="0:2:4:1:OneHandMace::1:0:", -- Gutbuster
	[50811]="0:4:4:1:Plate::1:0:", -- Festering Fingerguards
	[50812]="0:4:4:1:Mail::1:0:", -- Taldron's Long Neglected Boots
	[50816]="0:0:1:5:EnhPerm::1:0:", -- Scroll of Enchant Gloves - Angler
	[50818]="0:15:4:1:Mount::1:0:", -- Invincible's Reins
	[50819]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Mantle
	[50820]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Trousers
	[50821]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Cover
	[50822]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Gloves
	[50823]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Vestment
	[50824]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Shoulderpads
	[50825]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Legguards
	[50826]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Headguard
	[50827]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Handgrips
	[50828]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Lasherweave Raiment
	[50830]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Chestguard
	[50831]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Grips
	[50832]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Faceguard
	[50833]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's War-Kilt
	[50834]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Shoulderguards
	[50835]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Tunic
	[50836]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Handguards
	[50837]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Headpiece
	[50838]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Legguards
	[50839]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Spaulders
	[50841]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Hauberk
	[50842]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Gloves
	[50843]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Helm
	[50844]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Kilt
	[50845]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Frost Witch's Shoulderpads
	[50846]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Pauldrons
	[50847]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Legguards
	[50848]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Greathelm
	[50849]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Handguards
	[50850]="0:4:4:1:Plate::1:0:35498,37688", -- Ymirjar Lord's Breastplate
	[50851]="0:12:1:1:::1:0:", -- Pulsing Life Crystal
	[50852]="0:4:4:1:Amulet::1:0:", -- Precious's Putrid Collar
	[50853]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Pauldrons
	[50854]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Legguards
	[50855]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Faceguard
	[50856]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Handguards
	[50857]="0:4:4:1:Plate::1:0:35498,38316", -- Scourgelord Chestguard
	[50858]="0:4:4:1:Leather::1:0:", -- Plague-Soaked Leather Leggings
	[50859]="0:4:4:1:Cloak::1:0:", -- Cloak of Many Skins
	[50860]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Shoulderguards
	[50861]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Legguards
	[50862]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Faceguard
	[50863]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Handguards
	[50864]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Chestguard
	[50865]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Spaulders
	[50866]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Greaves
	[50867]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Headpiece
	[50868]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Gloves
	[50869]="0:4:4:1:Plate::1:0:35498,37696", -- Lightsworn Tunic
	[50965]="0:4:4:1:Plate::1:0:28997,37941,37942,38858", -- Castle Breaker's Battleplate
	[50966]="0:2:4:1:Stave::1:0:", -- Abracadaver
	[50967]="0:4:4:1:Plate::1:0:", -- Festergut's Gaseous Gloves
	[50968]="0:4:4:1:Plate::1:0:28997,37941,37942,38858", -- Cataclysmic Chestguard
	[50969]="0:4:4:1:Plate::1:0:28997,37941,37942,38858", -- Chestplate of Unspoken Truths
	[50970]="0:4:4:1:Mail::1:0:29523,37941,37942,38858", -- Longstrider's Vest
	[50971]="0:4:4:1:Mail::1:0:29523,37941,37942,38858", -- Mail of the Geyser
	[50972]="0:4:4:1:Leather::1:0:28992,29538,37941,37942,38858", -- Shadow Seeker's Tunic
	[50973]="0:4:4:1:Leather::1:0:28992,29538,37941,37942,38858", -- Vestments of Spruce and Fir
	[50974]="0:4:4:1:Cloth::1:0:28995,37941,37942,38858", -- Meteor Chaser's Raiment
	[50975]="0:4:4:1:Cloth::1:0:28995,37941,37942,38858", -- Ermine Coronation Robes
	[50976]="0:4:4:1:Plate::1:0:28997,37941,37942,38858", -- Gauntlets of Overexposure
	[50977]="0:4:4:1:Plate::1:0:28997,37941,37942,38858", -- Gatecrasher's Gauntlets
	[50978]="0:4:4:1:Plate::1:0:28997,37941,37942,38858", -- Gauntlets of the Kraken
	[50979]="0:4:4:1:Mail::1:0:29523,37941,37942,38858", -- Logsplitters
	[50980]="0:4:4:1:Mail::1:0:29523,37941,37942,38858", -- Blizzard Keeper's Mitts
	[50981]="0:4:4:1:Leather::1:0:28992,29538,37941,37942,38858", -- Gloves of the Great Horned Owl
	[50982]="0:4:4:1:Leather::1:0:28992,29538,37941,37942,38858", -- Cat Burglar's Grips
	[50983]="0:4:4:1:Cloth::1:0:28995,37941,37942,38858", -- Gloves of False Gestures
	[50984]="0:4:4:1:Cloth::1:0:28995,37941,37942,38858", -- Gloves of Ambivalence
	[50985]="0:4:4:1:Leather::1:0:", -- Wrists of Septic Shock
	[50986]="0:4:4:1:Ring::1:0:", -- Signet of Putrefaction
	[50987]="0:4:4:1:Plate::1:0:28997,37941,37942,38858", -- Malevolent Girdle
	[50988]="0:4:4:1:Cloth::1:0:", -- Bloodstained Surgeon's Shoulderguards
	[50989]="0:4:4:1:Plate::1:0:28997,37941,37942,38858", -- Lich Killer's Lanyard
	[50990]="0:4:4:1:Cloth::1:0:", -- Kilt of Untreated Wounds
	[50991]="0:4:4:1:Plate::1:0:28997,37941,37942,38858", -- Verdigris Chain Belt
	[50992]="0:4:4:1:Mail::1:0:29523,37941,37942,38858", -- Waistband of Despair
	[50993]="0:4:4:1:Mail::1:0:29523,37941,37942,38858", -- Band of the Night Raven
	[50994]="0:4:4:1:Leather::1:0:28992,29538,37941,37942,38858", -- Belt of Petrified Ivy
	[50995]="0:4:4:1:Leather::1:0:28992,29538,37941,37942,38858", -- Vengeful Noose
	[50996]="0:4:4:1:Cloth::1:0:28995,37941,37942,38858", -- Belt of Omission
	[50997]="0:4:4:1:Cloth::1:0:28995,37941,37942,38858", -- Circle of Ossus
	[50998]="0:2:4:1:Stave::1:0:", -- Shaft of Glacial Ice
	[50999]="0:2:4:1:Thrown::1:0:", -- Gluth's Fetching Knife
	[51000]="0:4:4:1:Plate::1:0:", -- Flesh-Shaper's Gurney Strap
	[51001]="0:4:4:1:Ring::1:0:", -- Rotface's Rupturing Ring
	[51002]="0:4:4:1:Mail::1:0:", -- Taldron's Short-Sighted Helm
	[51003]="0:2:4:1:FistWeapon::1:0:", -- Abomination Knuckles
	[51004]="0:2:4:1:OneHandMace::1:0:", -- Lockjaw
	[51005]="0:4:4:1:Cloth::1:0:", -- Gloves of Broken Fingers
	[51006]="0:4:4:1:Mail::1:0:", -- Shuffling Shoes
	[51007]="0:4:4:1:Cloth::1:0:", -- Ether-Soaked Bracers
	[51008]="0:4:4:1:Amulet::1:0:", -- Choker of Filthy Diamonds
	[51009]="0:4:4:1:Leather::1:0:", -- Chestguard of the Failed Experiment
	[51010]="0:2:4:1:OneHandSword::1:0:", -- The Facelifter
	[51011]="0:2:4:1:Dagger::1:0:", -- Flesh-Carving Scalpel
	[51012]="0:4:4:1:Amulet::1:0:", -- Infected Choker
	[51013]="0:4:4:1:Leather::1:0:", -- Discarded Bag of Entrails
	[51014]="0:4:4:1:Plate::1:0:", -- Scalpel-Sharpening Shoulderguards
	[51015]="0:4:4:1:Mail::1:0:", -- Shoulderpads of the Morbid Ritual
	[51016]="0:4:4:1:Amulet::1:0:", -- Pendant of Split Veins
	[51017]="0:4:4:1:Cloth::1:0:", -- Cauterized Cord
	[51018]="0:4:4:1:Plate::1:0:", -- Chestplate of Septic Stitches
	[51019]="0:4:4:1:Mail::1:0:", -- Rippling Flesh Kilt
	[51020]="0:4:4:1:Cloth::1:0:", -- Shoulders of Ruinous Senility
	[51021]="0:2:4:1:OneHandSword::1:0:", -- Soulbreaker
	[51022]="0:2:4:1:Polearm::1:0:", -- Hersir's Greatspear
	[51023]="0:4:4:1:Leather::1:0:", -- Taldaram's Soft Slippers
	[51024]="0:4:4:1:Ring::1:0:", -- Thrice Fanged Signet
	[51025]="0:4:4:1:Plate::1:0:", -- Battle-Maiden's Legguards
	[51026]="0:12:1:20:::1:0:", -- Crystalline Essence of Sindragosa
	[51027]="0:12:1:20:::1:0:", -- Crystalline Essence of Sindragosa
	[51125]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Shoulderplates
	[51126]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Legplates
	[51127]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Helmet
	[51128]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Gauntlets
	[51129]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Battleplate
	[51130]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Pauldrons
	[51131]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Legguards
	[51132]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Handguards
	[51133]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Faceguard
	[51134]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Chestguard
	[51135]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Pauldrons
	[51136]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Legplates
	[51137]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Helmet
	[51138]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Gauntlets
	[51139]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Robes
	[51140]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Shoulderpads
	[51141]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Raiment
	[51142]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Legguards
	[51143]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Headguard
	[51144]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Handgrips
	[51145]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Vestment
	[51146]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Trousers
	[51147]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Mantle
	[51148]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Gloves
	[51149]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Cover
	[51150]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Tunic
	[51151]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Spaulders
	[51152]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Legguards
	[51153]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Headpiece
	[51154]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Handguards
	[51155]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Shoulderpads
	[51156]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Robe
	[51157]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Leggings
	[51158]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Hood
	[51159]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Gloves
	[51160]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Shoulderplates
	[51161]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Legplates
	[51162]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Helmet
	[51163]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Gauntlets
	[51164]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Battleplate
	[51165]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Tunic
	[51166]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Spaulders
	[51167]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Headpiece
	[51168]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Greaves
	[51169]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Gloves
	[51170]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Shoulderguards
	[51171]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Legguards
	[51172]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Handguards
	[51173]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Faceguard
	[51174]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Chestguard
	[51175]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Shoulderpads
	[51176]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Robe
	[51177]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Leggings
	[51178]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Hood
	[51179]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Gloves
	[51180]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Raiments
	[51181]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Pants
	[51182]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Mantle
	[51183]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Handwraps
	[51184]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Cowl
	[51185]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Pauldrons
	[51186]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Legplates
	[51187]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Helmet
	[51188]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Gauntlets
	[51189]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Breastplate
	[51190]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Tunic
	[51191]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Handguards
	[51192]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Headpiece
	[51193]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Legguards
	[51194]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Spaulders
	[51195]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Chestguard
	[51196]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Grips
	[51197]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Faceguard
	[51198]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's War-Kilt
	[51199]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Shoulderguards
	[51200]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Hauberk
	[51201]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Gloves
	[51202]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Helm
	[51203]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Kilt
	[51204]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Shoulderpads
	[51205]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Shoulderpads
	[51206]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Robe
	[51207]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Leggings
	[51208]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Hood
	[51209]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Gloves
	[51210]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Shoulderplates
	[51211]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Legplates
	[51212]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Helmet
	[51213]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Gauntlets
	[51214]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Battleplate
	[51215]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Pauldrons
	[51216]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Legguards
	[51217]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Handguards
	[51218]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Greathelm
	[51219]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Breastplate
	[51220]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Breastplate
	[51221]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Greathelm
	[51222]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Handguards
	[51223]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Legguards
	[51224]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Pauldrons
	[51225]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Battleplate
	[51226]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Gauntlets
	[51227]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Helmet
	[51228]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Legplates
	[51229]="0:4:4:1:Plate::1:0:35498,37688", -- Sanctified Ymirjar Lord's Shoulderplates
	[51230]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Gloves
	[51231]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Hood
	[51232]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Leggings
	[51233]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Robe
	[51234]="0:4:4:1:Cloth::1:0:35496,38181,38182", -- Sanctified Dark Coven Shoulderpads
	[51235]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Shoulderpads
	[51236]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Kilt
	[51237]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Helm
	[51238]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Gloves
	[51239]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Hauberk
	[51240]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Shoulderguards
	[51241]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's War-Kilt
	[51242]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Faceguard
	[51243]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Grips
	[51244]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Chestguard
	[51245]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Spaulders
	[51246]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Legguards
	[51247]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Headpiece
	[51248]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Handguards
	[51249]="0:4:4:1:Mail::1:0:35500,38840,38841", -- Sanctified Frost Witch's Tunic
	[51250]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Breastplate
	[51251]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Gauntlets
	[51252]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Helmet
	[51253]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Legplates
	[51254]="0:4:4:1:Leather::1:0:35497,37991,37997", -- Sanctified Shadowblade Pauldrons
	[51255]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Cowl
	[51256]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Handwraps
	[51257]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Mantle
	[51258]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Pants
	[51259]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Raiments
	[51260]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Gloves
	[51261]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Hood
	[51262]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Leggings
	[51263]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Robe
	[51264]="0:4:4:1:Cloth::1:0:35496,38054", -- Sanctified Crimson Acolyte Shoulderpads
	[51265]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Chestguard
	[51266]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Faceguard
	[51267]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Handguards
	[51268]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Legguards
	[51269]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Shoulderguards
	[51270]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Gloves
	[51271]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Greaves
	[51272]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Headpiece
	[51273]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Spaulders
	[51274]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Tunic
	[51275]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Battleplate
	[51276]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Gauntlets
	[51277]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Helmet
	[51278]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Legplates
	[51279]="0:4:4:1:Plate::1:0:35498,37696", -- Sanctified Lightsworn Shoulderplates
	[51280]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Gloves
	[51281]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Hood
	[51282]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Leggings
	[51283]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Robe
	[51284]="0:4:4:1:Cloth::1:0:35496,38283,38284", -- Sanctified Bloodmage Shoulderpads
	[51285]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Handguards
	[51286]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Headpiece
	[51287]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Legguards
	[51288]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Spaulders
	[51289]="0:4:4:1:Mail::1:0:35500,37993,37998", -- Sanctified Ahn'Kahar Blood Hunter's Tunic
	[51290]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Cover
	[51291]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Gloves
	[51292]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Mantle
	[51293]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Trousers
	[51294]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Vestment
	[51295]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Handgrips
	[51296]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Headguard
	[51297]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Legguards
	[51298]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Raiment
	[51299]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Shoulderpads
	[51300]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Robes
	[51301]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Gauntlets
	[51302]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Helmet
	[51303]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Legplates
	[51304]="0:4:4:1:Leather::1:0:35497,37992,37999", -- Sanctified Lasherweave Pauldrons
	[51305]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Chestguard
	[51306]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Faceguard
	[51307]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Handguards
	[51308]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Legguards
	[51309]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Pauldrons
	[51310]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Battleplate
	[51311]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Gauntlets
	[51312]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Helmet
	[51313]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Legplates
	[51314]="0:4:4:1:Plate::1:0:35498,38316", -- Sanctified Scourgelord Shoulderplates
	[51325]="0:4:4:1:Mail::1:0:", -- Blood-Drinker's Girdle
	[51326]="0:2:4:1:Wand::1:0:", -- Wand of Ruby Claret
	[51327]="0:4:4:1:Cloth::1:0:34060,34078", -- Wrathful Gladiator's Cord of Dominance
	[51328]="0:4:4:1:Cloth::1:0:34060,34078", -- Wrathful Gladiator's Treads of Dominance
	[51329]="0:4:4:1:Cloth::1:0:34060,34078", -- Wrathful Gladiator's Cuffs of Dominance
	[51330]="0:4:4:1:Cloak::1:0:34060,34078", -- Wrathful Gladiator's Cloak of Dominance
	[51331]="0:4:4:1:Amulet::1:0:34060,34078", -- Wrathful Gladiator's Pendant of Dominance
	[51332]="0:4:4:1:Cloak::1:0:34060,34078", -- Wrathful Gladiator's Cloak of Subjugation
	[51333]="0:4:4:1:Amulet::1:0:34060,34078", -- Wrathful Gladiator's Pendant of Subjugation
	[51334]="0:4:4:1:Cloak::1:0:34060,34078", -- Wrathful Gladiator's Cloak of Ascendancy
	[51335]="0:4:4:1:Amulet::1:0:34060,34078", -- Wrathful Gladiator's Pendant of Ascendancy
	[51336]="0:4:4:1:Ring::1:0:34060,34078", -- Wrathful Gladiator's Band of Dominance
	[51337]="0:4:4:1:Cloth::1:0:34060,34078", -- Wrathful Gladiator's Cord of Alacrity
	[51338]="0:4:4:1:Cloth::1:0:34060,34078", -- Wrathful Gladiator's Treads of Alacrity
	[51339]="0:4:4:1:Cloth::1:0:34060,34078", -- Wrathful Gladiator's Cuffs of Alacrity
	[51340]="0:4:4:1:Leather::1:0:34060,34078", -- Wrathful Gladiator's Belt of Salvation
	[51341]="0:4:4:1:Leather::1:0:34060,34078", -- Wrathful Gladiator's Boots of Salvation
	[51342]="0:4:4:1:Leather::1:0:34060,34078", -- Wrathful Gladiator's Armwraps of Salvation
	[51343]="0:4:4:1:Leather::1:0:34060,34078", -- Wrathful Gladiator's Belt of Dominance
	[51344]="0:4:4:1:Leather::1:0:34060,34078", -- Wrathful Gladiator's Boots of Dominance
	[51345]="0:4:4:1:Leather::1:0:34060,34078", -- Wrathful Gladiator's Armwraps of Dominance
	[51346]="0:4:4:1:Cloak::1:0:34060,34078", -- Wrathful Gladiator's Cloak of Salvation
	[51347]="0:4:4:1:Amulet::1:0:34060,34078", -- Wrathful Gladiator's Pendant of Salvation
	[51348]="0:4:4:1:Cloak::1:0:34060,34078", -- Wrathful Gladiator's Cloak of Deliverance
	[51349]="0:4:4:1:Amulet::1:0:34060,34078", -- Wrathful Gladiator's Pendant of Deliverance
	[51350]="0:4:4:1:Mail::1:0:34060,34078", -- Wrathful Gladiator's Waistguard of Triumph
	[51351]="0:4:4:1:Mail::1:0:34060,34078", -- Wrathful Gladiator's Sabatons of Triumph
	[51352]="0:4:4:1:Mail::1:0:34060,34078", -- Wrathful Gladiator's Wristguards of Triumph
	[51353]="0:4:4:1:Amulet::1:0:34060,34078", -- Wrathful Gladiator's Pendant of Sundering
	[51354]="0:4:4:1:Cloak::1:0:34060,34078", -- Wrathful Gladiator's Cloak of Triumph
	[51355]="0:4:4:1:Amulet::1:0:34060,34078", -- Wrathful Gladiator's Pendant of Triumph
	[51356]="0:4:4:1:Cloak::1:0:34060,34078", -- Wrathful Gladiator's Cloak of Victory
	[51357]="0:4:4:1:Amulet::1:0:34060,34078", -- Wrathful Gladiator's Pendant of Victory
	[51358]="0:4:4:1:Ring::1:0:34060,34078", -- Wrathful Gladiator's Band of Triumph
	[51359]="0:4:4:1:Plate::1:0:34060,34078", -- Wrathful Gladiator's Girdle of Salvation
	[51360]="0:4:4:1:Plate::1:0:34060,34078", -- Wrathful Gladiator's Greaves of Salvation
	[51361]="0:4:4:1:Plate::1:0:34060,34078", -- Wrathful Gladiator's Bracers of Salvation
	[51362]="0:4:4:1:Plate::1:0:34060,34078", -- Wrathful Gladiator's Girdle of Triumph
	[51363]="0:4:4:1:Plate::1:0:34060,34078", -- Wrathful Gladiator's Greaves of Triumph
	[51364]="0:4:4:1:Plate::1:0:34060,34078", -- Wrathful Gladiator's Bracers of Triumph
	[51365]="0:4:4:1:Cloth::1:0:34060,34078", -- Wrathful Gladiator's Cord of Salvation
	[51366]="0:4:4:1:Cloth::1:0:34060,34078", -- Wrathful Gladiator's Treads of Salvation
	[51367]="0:4:4:1:Cloth::1:0:34060,34078", -- Wrathful Gladiator's Cuffs of Salvation
	[51368]="0:4:4:1:Leather::1:0:34060,34078", -- Wrathful Gladiator's Belt of Triumph
	[51369]="0:4:4:1:Leather::1:0:34060,34078", -- Wrathful Gladiator's Boots of Triumph
	[51370]="0:4:4:1:Leather::1:0:34060,34078", -- Wrathful Gladiator's Armwraps of Triumph
	[51371]="0:4:4:1:Mail::1:0:34060,34078", -- Wrathful Gladiator's Waistguard of Salvation
	[51372]="0:4:4:1:Mail::1:0:34060,34078", -- Wrathful Gladiator's Sabatons of Salvation
	[51373]="0:4:4:1:Mail::1:0:34060,34078", -- Wrathful Gladiator's Wristguards of Salvation
	[51374]="0:4:4:1:Mail::1:0:34060,34078", -- Wrathful Gladiator's Waistguard of Dominance
	[51375]="0:4:4:1:Mail::1:0:34060,34078", -- Wrathful Gladiator's Sabatons of Dominance
	[51376]="0:4:4:1:Mail::1:0:34060,34078", -- Wrathful Gladiator's Wristguards of Dominance
	[51377]="0:4:4:1:Trinket::1:0:34078", -- Medallion of the Alliance
	[51378]="0:4:4:1:Trinket::1:0:34060", -- Medallion of the Horde
	[51379]="0:4:4:1:Cloth::1:0:", -- Bloodsoul Raiment
	[51380]="0:4:4:1:Cloth::1:0:", -- Pale Corpse Boots
	[51381]="0:4:4:1:Ring::1:0:", -- Cerise Coiled Ring
	[51382]="0:4:4:1:Cloak::1:0:", -- Heartsick Mender's Cape
	[51383]="0:4:4:1:Plate::1:0:", -- Spaulders of the Blood Princes
	[51384]="0:2:4:1:Dagger::1:0:", -- Bloodsipper
	[51385]="0:2:4:1:Gun::1:0:", -- Stakethrower
	[51386]="0:4:4:1:Plate::1:0:", -- Throatrender Handguards
	[51387]="0:4:4:1:Ring::1:0:", -- Seal of the Twilight Queen
	[51388]="0:2:4:1:TwoHandAxe::1:0:33936,33939,33940", -- Wrathful Gladiator's Decapitator
	[51389]="0:2:4:1:TwoHandAxe::1:0:34094,34095", -- Wrathful Gladiator's Sunderer
	[51390]="0:2:4:1:TwoHandMace::1:0:33936,33939,33940", -- Wrathful Gladiator's Bonegrinder
	[51391]="0:2:4:1:TwoHandMace::1:0:34094,34095", -- Wrathful Gladiator's Crusher
	[51392]="0:2:4:1:TwoHandSword::1:0:33936,33939,33940", -- Wrathful Gladiator's Greatsword
	[51393]="0:2:4:1:TwoHandSword::1:0:34094,34095", -- Wrathful Gladiator's Claymore
	[51394]="0:2:4:1:Bow::1:0:33936,33939,33940", -- Wrathful Gladiator's Longbow
	[51395]="0:2:4:1:Bow::1:0:34094,34095", -- Wrathful Gladiator's Recurve
	[51396]="0:4:4:1:OffHandFrill::1:0:33936,33939,33940", -- Wrathful Gladiator's Endgame
	[51397]="0:2:4:1:Dagger::1:0:33936,33939,33940", -- Wrathful Gladiator's Spellblade
	[51398]="0:2:4:1:Dagger::1:0:34094,34095", -- Wrathful Gladiator's Blade of Celerity
	[51399]="0:2:4:1:Dagger::1:0:34094,34095", -- Wrathful Gladiator's Mageblade
	[51400]="0:2:4:1:Stave::1:0:33936,33939,33940", -- Wrathful Gladiator's War Staff
	[51401]="0:2:4:1:Stave::1:0:34094,34095", -- Wrathful Gladiator's Combat Staff
	[51402]="0:2:4:1:Stave::1:0:33936,33939,33940", -- Wrathful Gladiator's Focus Staff
	[51403]="0:2:4:1:Stave::1:0:34094,34095", -- Wrathful Gladiator's Acute Staff
	[51404]="0:2:4:1:Stave::1:0:33936,33939,33940", -- Wrathful Gladiator's Battle Staff
	[51405]="0:2:4:1:Stave::1:0:34094,34095", -- Wrathful Gladiator's Skirmish Staff
	[51406]="0:2:4:1:Dagger::1:0:33936,33939,33940", -- Wrathful Gladiator's Blade of Alacrity
	[51407]="0:4:4:1:OffHandFrill::1:0:33936,33939,33940", -- Wrathful Gladiator's Compendium
	[51408]="0:4:4:1:OffHandFrill::1:0:33936,33939,33940", -- Wrathful Gladiator's Grimoire
	[51409]="0:4:4:1:OffHandFrill::1:0:33936,33939,33940", -- Wrathful Gladiator's Reprieve
	[51410]="0:2:4:1:Wand::1:0:33936,33939,33940", -- Wrathful Gladiator's Touch of Defeat
	[51411]="0:2:4:1:Crossbow::1:0:33936,33939,33940", -- Wrathful Gladiator's Heavy Crossbow
	[51412]="0:2:4:1:Crossbow::1:0:34094,34095", -- Wrathful Gladiator's Repeater
	[51413]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Dreadplate Chestpiece
	[51414]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Dreadplate Gauntlets
	[51415]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Dreadplate Helm
	[51416]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Dreadplate Legguards
	[51417]="0:4:4:1:Sigil::1:0:33936,33939,33940", -- Wrathful Gladiator's Sigil of Strife
	[51418]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Dreadplate Shoulders
	[51419]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Kodohide Robes
	[51420]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Kodohide Gloves
	[51421]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Kodohide Helm
	[51422]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Kodohide Legguards
	[51423]="0:4:4:1:Idol::1:0:33936,33939,33940", -- Wrathful Gladiator's Idol of Tenacity
	[51424]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Kodohide Spaulders
	[51425]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Dragonhide Robes
	[51426]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Dragonhide Gloves
	[51427]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Dragonhide Helm
	[51428]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Dragonhide Legguards
	[51429]="0:4:4:1:Idol::1:0:33936,33939,33940", -- Wrathful Gladiator's Idol of Resolve
	[51430]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Dragonhide Spaulders
	[51431]="0:2:4:1:Stave::1:0:33936,33939,33940", -- Wrathful Gladiator's Staff
	[51432]="0:2:4:1:Stave::1:0:34093,34094,34095", -- Wrathful Gladiator's Greatstaff
	[51433]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Wyrmhide Robes
	[51434]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Wyrmhide Gloves
	[51435]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Wyrmhide Helm
	[51436]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Wyrmhide Legguards
	[51437]="0:4:4:1:Idol::1:0:33936,33939,33940", -- Wrathful Gladiator's Idol of Steadfastness
	[51438]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Wyrmhide Spaulders
	[51439]="0:2:4:1:OneHandAxe::1:0:33936,33939,33940", -- Wrathful Gladiator's Hacker
	[51440]="0:2:4:1:OneHandAxe::1:0:34094,34095", -- Wrathful Gladiator's Dicer
	[51441]="0:2:4:1:Dagger::1:0:33936,33939,33940", -- Wrathful Gladiator's Shiv
	[51442]="0:2:4:1:Dagger::1:0:34094,34095", -- Wrathful Gladiator's Dirk
	[51443]="0:2:4:1:FistWeapon::1:0:33936,33939,33940", -- Wrathful Gladiator's Left Ripper
	[51444]="0:2:4:1:FistWeapon::1:0:34094,34095", -- Wrathful Gladiator's Left Razor
	[51445]="0:2:4:1:OneHandMace::1:0:33936,33939,33940", -- Wrathful Gladiator's Bonecracker
	[51446]="0:2:4:1:OneHandMace::1:0:34094,34095", -- Wrathful Gladiator's Punisher
	[51447]="0:2:4:1:OneHandSword::1:0:33936,33939,33940", -- Wrathful Gladiator's Quickblade
	[51448]="0:2:4:1:OneHandSword::1:0:34094,34095", -- Wrathful Gladiator's Swiftblade
	[51449]="0:2:4:1:Gun::1:0:33936,33939,33940", -- Wrathful Gladiator's Rifle
	[51450]="0:2:4:1:Gun::1:0:34094,34095", -- Wrathful Gladiator's Shotgun
	[51451]="0:2:4:1:Wand::1:0:33936,33939,33940", -- Wrathful Gladiator's Wand of Alacrity
	[51452]="0:4:4:1:Shield::1:0:33936,33939,33940", -- Wrathful Gladiator's Barrier
	[51453]="0:2:4:1:OneHandMace::1:0:33936,33939,33940", -- Wrathful Gladiator's Gavel
	[51454]="0:2:4:1:OneHandMace::1:0:34094,34095", -- Wrathful Gladiator's Salvation
	[51455]="0:4:4:1:Shield::1:0:33936,33939,33940", -- Wrathful Gladiator's Redoubt
	[51456]="0:2:4:1:Stave::1:0:33936,33939,33940", -- Wrathful Gladiator's Energy Staff
	[51457]="0:2:4:1:Stave::1:0:34094,34095", -- Wrathful Gladiator's Light Staff
	[51458]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Chain Armor
	[51459]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Chain Gauntlets
	[51460]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Chain Helm
	[51461]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Chain Leggings
	[51462]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Chain Spaulders
	[51463]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Silk Raiment
	[51464]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Silk Handguards
	[51465]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Silk Cowl
	[51466]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Silk Trousers
	[51467]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Silk Amice
	[51468]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Ornamented Chestguard
	[51469]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Ornamented Gloves
	[51470]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Ornamented Headcover
	[51471]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Ornamented Legplates
	[51472]="0:4:4:1:Libram::1:0:33936,33939,33940", -- Wrathful Gladiator's Libram of Justice
	[51473]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Ornamented Spaulders
	[51474]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Scaled Chestpiece
	[51475]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Scaled Gauntlets
	[51476]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Scaled Helm
	[51477]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Scaled Legguards
	[51478]="0:4:4:1:Libram::1:0:33936,33939,33940", -- Wrathful Gladiator's Libram of Fortitude
	[51479]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Scaled Shoulders
	[51480]="0:2:4:1:Polearm::1:0:33936,33939,33940", -- Wrathful Gladiator's Pike
	[51481]="0:2:4:1:Polearm::1:0:34094,34095", -- Wrathful Gladiator's Halberd
	[51482]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Mooncloth Robe
	[51483]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Mooncloth Gloves
	[51484]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Mooncloth Hood
	[51485]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Mooncloth Leggings
	[51486]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Mooncloth Mantle
	[51487]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Satin Robe
	[51488]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Satin Gloves
	[51489]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Satin Hood
	[51490]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Satin Leggings
	[51491]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Satin Mantle
	[51492]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Leather Tunic
	[51493]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Leather Gloves
	[51494]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Leather Helm
	[51495]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Leather Legguards
	[51496]="0:4:4:1:Leather::1:0:33936,33939,33940", -- Wrathful Gladiator's Leather Spaulders
	[51497]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Ringmail Armor
	[51498]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Ringmail Gauntlets
	[51499]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Ringmail Helm
	[51500]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Ringmail Leggings
	[51501]="0:4:4:1:Totem::1:0:33936,33939,33940", -- Wrathful Gladiator's Totem of the Third Wind
	[51502]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Ringmail Spaulders
	[51503]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Linked Armor
	[51504]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Linked Gauntlets
	[51505]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Linked Helm
	[51506]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Linked Leggings
	[51507]="0:4:4:1:Totem::1:0:33936,33939,33940", -- Wrathful Gladiator's Totem of Indomitability
	[51508]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Linked Spaulders
	[51509]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Mail Armor
	[51510]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Mail Gauntlets
	[51511]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Mail Helm
	[51512]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Mail Leggings
	[51513]="0:4:4:1:Totem::1:0:33936,33939,33940", -- Wrathful Gladiator's Totem of Survival
	[51514]="0:4:4:1:Mail::1:0:33936,33939,33940", -- Wrathful Gladiator's Mail Spaulders
	[51515]="0:2:4:1:OneHandAxe::1:0:33936,33939,33940", -- Wrathful Gladiator's Cleaver
	[51516]="0:2:4:1:OneHandAxe::1:0:34094,34095", -- Wrathful Gladiator's Handaxe
	[51517]="0:2:4:1:Dagger::1:0:33936,33939,33940", -- Wrathful Gladiator's Shanker
	[51518]="0:2:4:1:Dagger::1:0:34094,34095", -- Wrathful Gladiator's Spike
	[51519]="0:2:4:1:OneHandMace::1:0:33936,33939,33940", -- Wrathful Gladiator's Pummeler
	[51520]="0:2:4:1:OneHandMace::1:0:34094,34095", -- Wrathful Gladiator's Truncheon
	[51521]="0:2:4:1:OneHandSword::1:0:33936,33939,33940", -- Wrathful Gladiator's Slicer
	[51522]="0:2:4:1:OneHandSword::1:0:34094,34095", -- Wrathful Gladiator's Longblade
	[51523]="0:2:4:1:FistWeapon::1:0:33936,33939,33940", -- Wrathful Gladiator's Right Ripper
	[51524]="0:2:4:1:FistWeapon::1:0:34094,34095", -- Wrathful Gladiator's Grasp
	[51525]="0:2:4:1:OneHandAxe::1:0:33936,33939,33940", -- Wrathful Gladiator's Chopper
	[51526]="0:2:4:1:OneHandAxe::1:0:34094,34095", -- Wrathful Gladiator's Splitter
	[51527]="0:2:4:1:Dagger::1:0:33936,33939,33940", -- Wrathful Gladiator's Mutilator
	[51528]="0:2:4:1:Dagger::1:0:34094,34095", -- Wrathful Gladiator's Eviscerator
	[51529]="0:2:4:1:FistWeapon::1:0:34094,34095", -- Wrathful Gladiator's Left Claw
	[51530]="0:2:4:1:FistWeapon::1:0:33936,33939,33940", -- Wrathful Gladiator's Left Render
	[51531]="0:2:4:1:Wand::1:0:33936,33939,33940", -- Wrathful Gladiator's Piercing Touch
	[51532]="0:2:4:1:Wand::1:0:33936,33939,33940", -- Wrathful Gladiator's Baton of Light
	[51533]="0:4:4:1:Shield::1:0:33936,33939,33940", -- Wrathful Gladiator's Shield Wall
	[51534]="0:4:4:1:Tabard::1:0:34094,34095", -- Wrathful Gladiator's Tabard
	[51535]="0:2:4:1:Thrown::1:0:33936,33939,33940", -- Wrathful Gladiator's War Edge
	[51536]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Felweave Raiment
	[51537]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Felweave Handguards
	[51538]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Felweave Cowl
	[51539]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Felweave Trousers
	[51540]="0:4:4:1:Cloth::1:0:33936,33939,33940", -- Wrathful Gladiator's Felweave Amice
	[51541]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Plate Chestpiece
	[51542]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Plate Gauntlets
	[51543]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Plate Helm
	[51544]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Plate Legguards
	[51545]="0:4:4:1:Plate::1:0:33936,33939,33940", -- Wrathful Gladiator's Plate Shoulders
	[51548]="0:4:4:1:Amulet::1:0:", -- Collar of Haughty Disdain
	[51550]="0:4:4:1:Leather::1:0:", -- Ivory-Inlaid Leggings
	[51551]="0:4:4:1:Mail::1:0:", -- Chestguard of Siphoned Elements
	[51552]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Searing Kiss
	[51553]="0:2:4:1:Wand::1:0:", -- Lana'thel's Bloody Nail
	[51554]="0:4:4:1:Cloth::1:0:", -- Cowl of Malefic Repose
	[51555]="0:4:4:1:Plate::1:0:", -- Tightening Waistband
	[51556]="0:4:4:1:Plate::1:0:", -- Veincrusher Gauntlets
	[51557]="12500000:4:4:1:Ring::1:0:32172", -- Runed Signet of the Kirin Tor
	[51558]="12500000:4:4:1:Ring::1:0:32172", -- Runed Loop of the Kirin Tor
	[51559]="12500000:4:4:1:Ring::1:0:32172", -- Runed Ring of the Kirin Tor
	[51560]="12500000:4:4:1:Ring::1:0:32172", -- Runed Band of the Kirin Tor
	[51561]="0:2:4:1:Gun::1:0:", -- Dreamhunter's Carbine
	[51562]="0:2:4:1:TwoHandMace::1:0:", -- Oxheart
	[51563]="0:4:4:1:Plate::1:0:", -- Taiga Bindings
	[51564]="0:4:4:1:Plate::1:0:", -- Ironrope Belt of Ymirjar
	[51565]="0:4:4:1:Leather::1:0:", -- Skinned Whelp Shoulders
	[51566]="0:4:4:1:Mail::1:0:", -- Legguards of the Twisted Dream
	[51568]="345602:4:4:1:Amulet::1:0:39172,39173", -- Titan-Forged Pendant of Ascendancy
	[51569]="345602:4:4:1:Amulet::1:0:39172,39173", -- Titan-Forged Pendant of Victory
	[51570]="367788:4:4:1:Cloak::1:0:39172,39173", -- Titan-Forged Cloak of Ascendancy
	[51571]="369108:4:4:1:Cloak::1:0:39172,39173", -- Titan-Forged Cloak of Victory
	[51572]="379091:4:4:1:Cloth::1:0:39172,39173", -- Titan-Forged Shoulderpads of Salvation
	[51573]="380405:4:4:1:Cloth::1:0:39172,39173", -- Titan-Forged Shoulderpads of Domination
	[51574]="477195:4:4:1:Leather::1:0:39172,39173", -- Titan-Forged Spaulders of Dominance
	[51575]="478883:4:4:1:Leather::1:0:39172,39173", -- Titan-Forged Spaulders of Salvation
	[51576]="434896:4:4:1:Leather::1:0:39172,39173", -- Titan-Forged Spaulders of Triumph
	[51577]="526175:4:4:1:Mail::1:0:39172,39173", -- Titan-Forged Shoulders of Triumph
	[51578]="542785:4:4:1:Mail::1:0:39172,39173", -- Titan-Forged Shoulders of Dominance
	[51579]="544819:4:4:1:Mail::1:0:39172,39173", -- Titan-Forged Shoulders of Salvation
	[51580]="633964:4:4:1:Plate::1:0:39172,39173", -- Titan-Forged Shoulderplates of Triumph
	[51581]="636259:4:4:1:Plate::1:0:39172,39173", -- Titan-Forged Shoulderplates of Salvation
	[51582]="0:2:4:1:Stave::1:0:", -- Sister Svalna's Aether Staff
	[51583]="0:4:4:1:Mail::1:0:", -- Stormbringer Gloves
	[51584]="0:4:4:1:Cloak::1:0:", -- Lich Wrappings
	[51585]="0:4:4:1:Leather::1:0:", -- Sister Svalna's Spangenhelm
	[51586]="0:4:4:1:Plate::1:0:", -- Emerald Saint's Spaulders
	[51701]="0:4:4:1:Leather::1:0:", -- Lasherweave Shoulderpads
	[51755]="0:4:4:1:Mail::1:0:", -- Frost Witch's War-Kilt
	[51761]="0:4:4:1:Mail::1:0:", -- Frost Witch's Shoulderpads
	[51776]="0:4:4:1:Plate::1:0:", -- Ymirjar Lord's Pauldrons
	[51777]="0:4:4:1:Cloth::1:0:", -- Leggings of the Refracted Mind
	[51779]="0:4:4:1:Amulet::1:0:", -- Rimetooth Pendant
	[51782]="0:4:4:1:Plate::1:0:", -- Etched Dragonbone Girdle
	[51783]="0:4:4:1:Leather::1:0:", -- Vambraces of the Frost Wyrm Queen
	[51784]="0:2:4:1:FistWeapon::1:0:", -- Splintershard
	[51785]="0:4:4:1:Mail::1:0:", -- Wyrmwing Treads
	[51786]="0:4:4:1:Plate::1:0:", -- Legplates of Aetheric Strife
	[51787]="0:4:4:1:Plate::1:0:", -- Scourge Fanged Stompers
	[51788]="0:2:4:1:Dagger::1:0:", -- Bleak Coldarra Carver
	[51789]="0:4:4:1:Leather::1:0:", -- Icicle Shapers
	[51790]="0:4:4:1:Cloth::1:0:", -- Robes of Azure Downfall
	[51791]="0:4:4:1:Shield::1:0:", -- Lost Pavise of the Blue Flight
	[51792]="0:4:4:1:Mail::1:0:", -- Shoulderguards of Crystalline Bone
	[51795]="256692:2:4:1:OneHandAxe::1:0:", -- Troggbane, Axe of the Frostborne King
	[51796]="0:2:4:1:TwoHandMace::1:0:", -- Warmace of Menethil
	[51797]="0:2:4:1:Stave::1:0:", -- Tainted Twig of Nordrassil
	[51798]="259465:2:4:1:OneHandMace::1:0:", -- Valius, Gavel of the Lightbringer
	[51799]="325456:2:4:1:Stave::1:0:", -- Halion, Staff of Forgotten Love
	[51800]="261289:2:4:1:Dagger::1:0:", -- Stormfury, Black Blade of the Betrayer
	[51801]="262213:2:4:1:FistWeapon::1:0:", -- Pugius, Fist of Defiance
	[51802]="0:2:4:1:Crossbow::1:0:", -- Windrunner's Heartseeker
	[51803]="245649:2:4:1:Dagger::1:0:", -- Tel'thas, Dagger of the Blood King
	[51804]="0:4:4:1:Amulet::1:0:", -- Winking Eye of Love
	[51805]="0:4:4:1:Amulet::1:0:", -- Heartbreak Charm
	[51806]="0:4:4:1:Amulet::1:0:", -- Shard of Pirouetting Happiness
	[51807]="0:4:4:1:Amulet::1:0:", -- Sweet Perfume Broach
	[51808]="0:4:4:1:Amulet::1:0:", -- Choker of the Pure Heart
	[51809]="30000000:1:4:1:Bag::1:0:18756", -- Portable Hole
	[51811]="0:4:4:1:Mail::1:0:", -- Shoulderguards of Crystalline Bone
	[51812]="0:4:4:1:Shield::1:0:", -- Lost Pavise of the Blue Flight
	[51813]="0:4:4:1:Cloth::1:0:", -- Robes of Azure Downfall
	[51814]="0:4:4:1:Leather::1:0:", -- Icicle Shapers
	[51815]="0:2:4:1:Dagger::1:0:", -- Bleak Coldarra Carver
	[51816]="0:4:4:1:Plate::1:0:", -- Scourge Fanged Stompers
	[51817]="0:4:4:1:Plate::1:0:", -- Legplates of Aetheric Strife
	[51818]="0:4:4:1:Mail::1:0:", -- Wyrmwing Treads
	[51819]="0:2:4:1:FistWeapon::1:0:", -- Splintershard
	[51820]="0:4:4:1:Leather::1:0:", -- Vambraces of the Frost Wyrm Queen
	[51821]="0:4:4:1:Plate::1:0:", -- Etched Dragonbone Girdle
	[51822]="0:4:4:1:Amulet::1:0:", -- Rimetooth Pendant
	[51823]="0:4:4:1:Cloth::1:0:", -- Leggings of the Refracted Mind
	[51824]="0:4:4:1:Plate::1:0:", -- Emerald Saint's Spaulders
	[51825]="0:4:4:1:Leather::1:0:", -- Sister Svalna's Spangenhelm
	[51826]="0:4:4:1:Cloak::1:0:", -- Lich Wrappings
	[51827]="0:4:4:1:Mail::1:0:", -- Stormbringer Gloves
	[51828]="0:2:4:1:Stave::1:0:", -- Sister Svalna's Aether Staff
	[51829]="0:4:4:1:Mail::1:0:", -- Legguards of the Twisted Dream
	[51830]="0:4:4:1:Leather::1:0:", -- Skinned Whelp Shoulders
	[51831]="0:4:4:1:Plate::1:0:", -- Ironrope Belt of Ymirjar
	[51832]="0:4:4:1:Plate::1:0:", -- Taiga Bindings
	[51833]="0:2:4:1:TwoHandMace::1:0:", -- Oxheart
	[51834]="0:2:4:1:Gun::1:0:", -- Dreamhunter's Carbine
	[51835]="0:4:4:1:Plate::1:0:", -- Veincrusher Gauntlets
	[51836]="0:4:4:1:Plate::1:0:", -- Tightening Waistband
	[51837]="0:4:4:1:Cloth::1:0:", -- Cowl of Malefic Repose
	[51838]="0:2:4:1:Wand::1:0:", -- Lana'thel's Bloody Nail
	[51839]="0:4:4:1:Leather::1:0:", -- Shoulderpads of the Searing Kiss
	[51840]="0:4:4:1:Mail::1:0:", -- Chestguard of Siphoned Elements
	[51841]="0:4:4:1:Leather::1:0:", -- Ivory-Inlaid Leggings
	[51842]="0:4:4:1:Amulet::1:0:", -- Collar of Haughty Disdain
	[51843]="0:4:4:1:Ring::1:0:", -- Seal of the Twilight Queen
	[51844]="0:4:4:1:Plate::1:0:", -- Throatrender Handguards
	[51845]="0:2:4:1:Gun::1:0:", -- Stakethrower
	[51846]="0:2:4:1:Dagger::1:0:", -- Bloodsipper
	[51847]="0:4:4:1:Plate::1:0:", -- Spaulders of the Blood Princes
	[51848]="0:4:4:1:Cloak::1:0:", -- Heartsick Mender's Cape
	[51849]="0:4:4:1:Ring::1:0:", -- Cerise Coiled Ring
	[51850]="0:4:4:1:Cloth::1:0:", -- Pale Corpse Boots
	[51851]="0:4:4:1:Cloth::1:0:", -- Bloodsoul Raiment
	[51852]="0:2:4:1:Wand::1:0:", -- Wand of Ruby Claret
	[51853]="0:4:4:1:Mail::1:0:", -- Blood-Drinker's Girdle
	[51854]="0:4:4:1:Plate::1:0:", -- Battle-Maiden's Legguards
	[51855]="0:4:4:1:Ring::1:0:", -- Thrice Fanged Signet
	[51856]="0:4:4:1:Leather::1:0:", -- Taldaram's Soft Slippers
	[51857]="0:2:4:1:Polearm::1:0:", -- Hersir's Greatspear
	[51858]="0:2:4:1:OneHandSword::1:0:", -- Soulbreaker
	[51859]="0:4:4:1:Cloth::1:0:", -- Shoulders of Ruinous Senility
	[51860]="0:4:4:1:Mail::1:0:", -- Rippling Flesh Kilt
	[51861]="0:4:4:1:Plate::1:0:", -- Chestplate of Septic Stitches
	[51862]="0:4:4:1:Cloth::1:0:", -- Cauterized Cord
	[51863]="0:4:4:1:Amulet::1:0:", -- Pendant of Split Veins
	[51864]="0:4:4:1:Mail::1:0:", -- Shoulderpads of the Morbid Ritual
	[51865]="0:4:4:1:Plate::1:0:", -- Scalpel-Sharpening Shoulderguards
	[51866]="0:4:4:1:Leather::1:0:", -- Discarded Bag of Entrails
	[51867]="0:4:4:1:Amulet::1:0:", -- Infected Choker
	[51868]="0:2:4:1:Dagger::1:0:", -- Flesh-Carving Scalpel
	[51869]="0:2:4:1:OneHandSword::1:0:", -- The Facelifter
	[51870]="0:4:4:1:Leather::1:0:", -- Chestguard of the Failed Experiment
	[51871]="0:4:4:1:Amulet::1:0:", -- Choker of Filthy Diamonds
	[51872]="0:4:4:1:Cloth::1:0:", -- Ether-Soaked Bracers
	[51873]="0:4:4:1:Mail::1:0:", -- Shuffling Shoes
	[51874]="0:4:4:1:Cloth::1:0:", -- Gloves of Broken Fingers
	[51875]="0:2:4:1:OneHandMace::1:0:", -- Lockjaw
	[51876]="0:2:4:1:FistWeapon::1:0:", -- Abomination Knuckles
	[51877]="0:4:4:1:Mail::1:0:", -- Taldron's Short-Sighted Helm
	[51878]="0:4:4:1:Ring::1:0:", -- Rotface's Rupturing Ring
	[51879]="0:4:4:1:Plate::1:0:", -- Flesh-Shaper's Gurney Strap
	[51880]="0:2:4:1:Thrown::1:0:", -- Gluth's Fetching Knife
	[51881]="0:2:4:1:Stave::1:0:", -- Shaft of Glacial Ice
	[51882]="0:4:4:1:Cloth::1:0:", -- Kilt of Untreated Wounds
	[51883]="0:4:4:1:Cloth::1:0:", -- Bloodstained Surgeon's Shoulderguards
	[51884]="0:4:4:1:Ring::1:0:", -- Signet of Putrefaction
	[51885]="0:4:4:1:Leather::1:0:", -- Wrists of Septic Shock
	[51886]="0:4:4:1:Plate::1:0:", -- Festergut's Gaseous Gloves
	[51887]="0:2:4:1:Stave::1:0:", -- Abracadaver
	[51888]="0:4:4:1:Cloak::1:0:", -- Cloak of Many Skins
	[51889]="0:4:4:1:Leather::1:0:", -- Plague-Soaked Leather Leggings
	[51890]="0:4:4:1:Amulet::1:0:", -- Precious's Putrid Collar
	[51891]="0:4:4:1:Mail::1:0:", -- Taldron's Long Neglected Boots
	[51892]="0:4:4:1:Plate::1:0:", -- Festering Fingerguards
	[51893]="0:2:4:1:OneHandMace::1:0:", -- Gutbuster
	[51894]="0:4:4:1:Amulet::1:0:", -- Soulcleave Pendant
	[51895]="0:4:4:1:Plate::1:0:", -- Deathforged Legplates
	[51896]="0:4:4:1:Cloth::1:0:", -- Thaumaturge's Crackling Cowl
	[51897]="0:4:4:1:Leather::1:0:", -- Leggings of Unrelenting Blood
	[51898]="0:2:4:1:Stave::1:0:", -- Mag'hari Chieftain's Staff
	[51899]="0:4:4:1:Cloth::1:0:", -- Icecrown Spire Sandals
	[51900]="0:4:4:1:Ring::1:0:", -- Saurfang's Cold-Forged Band
	[51901]="0:4:4:1:Plate::1:0:", -- Gargoyle Spit Bracers
	[51902]="0:4:4:1:Plate::1:0:", -- Blade-Scored Carapace
	[51903]="0:4:4:1:Mail::1:0:", -- Hauberk of a Thousand Cuts
	[51904]="0:4:4:1:Leather::1:0:", -- Scourge Stranglers
	[51905]="0:2:4:1:TwoHandAxe::1:0:", -- Ramaladni's Blade of Culling
	[51906]="0:4:4:1:Mail::1:0:", -- Ice-Reinforced Vrykul Helm
	[51907]="0:4:4:1:Plate::1:0:", -- Bracers of Pale Illumination
	[51908]="0:4:4:1:Leather::1:0:", -- Cord of Dark Suffering
	[51909]="0:4:4:1:Shield::1:0:", -- Neverending Winter
	[51910]="0:2:4:1:Dagger::1:0:", -- Midnight Sun
	[51911]="0:4:4:1:Mail::1:0:", -- Pauldrons of Lost Hope
	[51912]="0:4:4:1:Cloak::1:0:", -- Saronite Gargoyle Cloak
	[51913]="0:4:4:1:Ring::1:0:", -- Abomination's Bloody Ring
	[51914]="0:4:4:1:Mail::1:0:", -- Icecrown Rampart Bracers
	[51915]="0:4:4:1:Plate::1:0:", -- Bone Drake's Enameled Boots
	[51916]="0:2:4:1:OneHandAxe::1:0:", -- Frost Giant's Cleaver
	[51917]="0:4:4:1:Plate::1:0:", -- Ghoul Commander's Cuirass
	[51918]="0:4:4:1:Cloth::1:0:", -- Bracers of Dark Blessings
	[51919]="0:4:4:1:Mail::1:0:", -- Deathspeaker Disciple's Belt
	[51920]="0:4:4:1:Leather::1:0:", -- Boots of the Frozen Seed
	[51921]="0:4:4:1:Cloth::1:0:", -- Sister's Handshrouds
	[51922]="0:4:4:1:OffHandFrill::1:0:", -- Scourgelord's Baton
	[51923]="0:4:4:1:Leather::1:0:", -- Chestguard of the Frigid Noose
	[51924]="0:4:4:1:Plate::1:0:", -- Deathspeaker Zealot's Helm
	[51925]="0:4:4:1:Leather::1:0:", -- Soulthief's Braided Belt
	[51926]="0:4:4:1:Mail::1:0:", -- Handgrips of Frost and Sleet
	[51927]="0:2:4:1:Bow::1:0:", -- Njordnar Bone Bow
	[51928]="0:4:4:1:Plate::1:0:", -- Corrupted Silverplate Leggings
	[51929]="0:4:4:1:Mail::1:0:", -- Coldwraith Bracers
	[51930]="0:4:4:1:Cloth::1:0:", -- Cord of the Patronizing Practitioner
	[51931]="0:4:4:1:Plate::1:0:", -- Ancient Skeletal Boots
	[51932]="0:2:4:1:OneHandSword::1:0:", -- Frost Needle
	[51933]="0:4:4:1:Cloak::1:0:", -- Shawl of Nerubian Silk
	[51934]="0:4:4:1:Amulet::1:0:", -- Marrowgar's Scratching Choker
	[51935]="0:4:4:1:Mail::1:0:", -- Linked Scourge Vertebrae
	[51936]="0:2:4:1:TwoHandSword::1:0:", -- Citadel Enforcer's Claymore
	[51937]="0:2:4:1:OneHandMace::1:0:", -- Bonebreaker Scepter
	[51938]="0:2:4:1:OneHandAxe::1:0:", -- Bone Warden's Splitter
	[51939]="260350:2:4:1:Dagger::1:0:", -- Tel'thas, Dagger of the Blood King
	[51940]="0:2:4:1:Crossbow::1:0:", -- Windrunner's Heartseeker
	[51941]="0:2:4:1:FistWeapon::1:0:", -- Pugius, Fist of Defiance
	[51942]="0:2:4:1:Dagger::1:0:", -- Stormfury, Black Blade of the Betrayer
	[51943]="0:2:4:1:Stave::1:0:", -- Halion, Staff of Forgotten Love
	[51944]="0:2:4:1:OneHandMace::1:0:", -- Valius, Gavel of the Lightbringer
	[51945]="0:2:4:1:Stave::1:0:", -- Tainted Twig of Nordrassil
	[51946]="0:2:4:1:TwoHandMace::1:0:", -- Warmace of Menethil
	[51947]="0:2:4:1:OneHandAxe::1:0:", -- Troggbane, Axe of the Frostborne King
	[51954]="0:15:4:1:FlyingMount::1:0:", -- Reins of the Bloodbathed Frostbrood Vanquisher
	[51958]="0:4:3:1:Leather::1:0:", -- Pristine Glowbear Pelt
	[51959]="0:4:3:1:Leather::1:0:", -- Vigorous Belt
	[51960]="0:4:3:1:Leather::1:0:", -- Vigorous Gloves
	[51961]="0:4:3:1:Leather::1:0:", -- Vigorous Shoulderguards
	[51962]="0:4:3:1:Leather::1:0:", -- Vigorous Bracers
	[51963]="0:4:3:1:Leather::1:0:", -- Vigorous Stompers
	[51964]="0:4:3:1:Leather::1:0:", -- Vigorous Belt
	[51965]="0:4:3:1:Leather::1:0:", -- Vigorous Handguards
	[51966]="0:4:3:1:Leather::1:0:", -- Vigorous Spaulders
	[51967]="0:4:3:1:Cloth::1:0:", -- Enumerated Sandals
	[51968]="0:4:3:1:Cloth::1:0:", -- Enumerated Wrap
	[51969]="0:4:3:1:Cloth::1:0:", -- Enumerated Shoulders
	[51970]="0:4:3:1:Cloth::1:0:", -- Enumerated Gloves
	[51971]="0:4:3:1:Cloth::1:0:", -- Enumerated Belt
	[51972]="0:4:3:1:Cloth::1:0:", -- Enumerated Bracers
	[51973]="0:4:3:1:Cloth::1:0:", -- Enumerated Handwraps
	[51974]="0:4:3:1:Cloth::1:0:", -- Enumerated Shoulderpads
	[51975]="0:4:3:1:Mail::1:0:", -- Earthbound Shoulders
	[51976]="0:4:3:1:Mail::1:0:", -- Earthbound Shoulderguards
	[51977]="0:4:3:1:Mail::1:0:", -- Earthbound Girdle
	[51978]="0:4:3:1:Mail::1:0:", -- Earthbound Girdle
	[51979]="0:4:3:1:Mail::1:0:", -- Earthbound Grips
	[51980]="0:4:3:1:Mail::1:0:", -- Earthbound Handgrips
	[51981]="0:4:3:1:Mail::1:0:", -- Earthbound Wristguards
	[51982]="0:4:3:1:Mail::1:0:", -- Earthbound Boots
	[51983]="0:4:3:1:Plate::1:0:", -- Stalwart Shoulderguards
	[51984]="0:4:3:1:Plate::1:0:", -- Stalwart Shoulderpads
	[51985]="0:4:3:1:Plate::1:0:", -- Stalwart Belt
	[51987]="0:4:3:1:Plate::1:0:", -- Stalwart Grips
	[51989]="0:4:3:1:Plate::1:0:", -- Stalwart Bands
	[51990]="0:4:3:1:Plate::1:0:", -- Stalwart Treads
	[51991]="0:4:3:1:Ring::1:0:", -- Turbulent Signet
	[51992]="0:4:3:1:Ring::1:0:", -- Tumultuous Ring
	[51993]="0:4:3:1:Cloak::1:0:", -- Turbulent Cloak
	[51994]="0:4:3:1:Cloak::1:0:", -- Tumultuous Cloak
	[51995]="0:4:3:1:Amulet::1:0:", -- Turbulent Necklace
	[51996]="0:4:3:1:Amulet::1:0:", -- Tumultuous Necklace
	[51999]="0:15:3:1:Junk::1:0:", -- Satchel of Helpful Goods
	[52000]="0:15:3:1:Junk::1:0:", -- Satchel of Helpful Goods
	[52001]="0:15:3:1:Junk::1:0:", -- Satchel of Helpful Goods
	[52002]="0:15:3:1:Junk::1:0:", -- Satchel of Helpful Goods
	[52003]="0:15:3:1:Junk::1:0:", -- Satchel of Helpful Goods
	[52004]="0:15:3:1:Junk::1:0:", -- Satchel of Helpful Goods
	[52005]="0:15:3:1:Junk::1:0:", -- Satchel of Helpful Goods
	[52006]="0:15:4:1:Junk::1:0:", -- Sack of Frosty Treasures
	[52019]="0:4:2:1:Shirt::1:0:", -- Precious's Ribbon
	[52020]="0:6:4:1000:Bullet::1:0:", -- Shatter Rounds
	[52021]="0:6:4:1000:Arrow::1:0:", -- Iceblade Arrow
	[52022]="0:9:4:1:Engineering::1:0:37687", -- Plans: Shatter Rounds
	[52023]="0:9:4:1:Engineering::1:0:37687", -- Plans: Iceblade Arrow
	[52025]="0:15:4:1:ArmorToken::1:0:", -- Vanquisher's Mark of Sanctification
	[52026]="0:15:4:1:ArmorToken::1:0:", -- Protector's Mark of Sanctification
	[52027]="0:15:4:1:ArmorToken::1:0:", -- Conqueror's Mark of Sanctification
	[52028]="0:15:4:1:ArmorToken::1:0:", -- Vanquisher's Mark of Sanctification
	[52029]="0:15:4:1:ArmorToken::1:0:", -- Protector's Mark of Sanctification
	[52030]="0:15:4:1:ArmorToken::1:0:", -- Conqueror's Mark of Sanctification
	[52569]="0:4:4:1:Ring::1:0:", -- Ashen Band of Might
	[52570]="0:4:4:1:Ring::1:0:", -- Ashen Band of Greater Might
	[52571]="0:4:4:1:Ring::1:0:", -- Ashen Band of Unmatched Might
	[52572]="0:4:4:1:Ring::1:0:", -- Ashen Band of Endless Might
	[52676]="0:15:2:1:Junk::1:0:", -- Cache of the Ley-Guardian
	[54343]="0:7:2:1:Device::1:0:", -- Blue Crashin' Thrashin' Racer Controller
	[54436]="0:15:3:1:Companion::1:0:", -- Blue Clockwork Rocket Bot
	[54437]="0:0:2:1:Consumable::1:0:", -- Tiny Green Ragdoll
	[54438]="0:0:2:1:Consumable::1:0:", -- Tiny Blue Ragdoll
	[54537]="0:15:3:1:Junk::1:0:", -- Heart-Shaped Box
})
